-- MySQL dump 10.17  Distrib 10.3.15-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: 
-- ------------------------------------------------------
-- Server version	10.3.15-MariaDB-1:10.3.15+maria~bionic

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `my_wiki`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `my_wiki` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `my_wiki`;

--
-- Table structure for table `actor`
--

DROP TABLE IF EXISTS `actor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actor` (
  `actor_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `actor_user` int(10) unsigned DEFAULT NULL,
  `actor_name` varbinary(255) NOT NULL,
  PRIMARY KEY (`actor_id`),
  UNIQUE KEY `actor_name` (`actor_name`),
  UNIQUE KEY `actor_user` (`actor_user`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actor`
--

LOCK TABLES `actor` WRITE;
/*!40000 ALTER TABLE `actor` DISABLE KEYS */;
/*!40000 ALTER TABLE `actor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `archive`
--

DROP TABLE IF EXISTS `archive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `archive` (
  `ar_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ar_namespace` int(11) NOT NULL DEFAULT 0,
  `ar_title` varbinary(255) NOT NULL DEFAULT '',
  `ar_comment` varbinary(767) NOT NULL DEFAULT '',
  `ar_comment_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `ar_user` int(10) unsigned NOT NULL DEFAULT 0,
  `ar_user_text` varbinary(255) NOT NULL DEFAULT '',
  `ar_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `ar_timestamp` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `ar_minor_edit` tinyint(4) NOT NULL DEFAULT 0,
  `ar_rev_id` int(10) unsigned NOT NULL,
  `ar_text_id` int(10) unsigned NOT NULL DEFAULT 0,
  `ar_deleted` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `ar_len` int(10) unsigned DEFAULT NULL,
  `ar_page_id` int(10) unsigned DEFAULT NULL,
  `ar_parent_id` int(10) unsigned DEFAULT NULL,
  `ar_sha1` varbinary(32) NOT NULL DEFAULT '',
  `ar_content_model` varbinary(32) DEFAULT NULL,
  `ar_content_format` varbinary(64) DEFAULT NULL,
  PRIMARY KEY (`ar_id`),
  UNIQUE KEY `ar_revid_uniq` (`ar_rev_id`),
  KEY `name_title_timestamp` (`ar_namespace`,`ar_title`,`ar_timestamp`),
  KEY `ar_usertext_timestamp` (`ar_user_text`,`ar_timestamp`),
  KEY `ar_actor_timestamp` (`ar_actor`,`ar_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `archive`
--

LOCK TABLES `archive` WRITE;
/*!40000 ALTER TABLE `archive` DISABLE KEYS */;
/*!40000 ALTER TABLE `archive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bot_passwords`
--

DROP TABLE IF EXISTS `bot_passwords`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bot_passwords` (
  `bp_user` int(10) unsigned NOT NULL,
  `bp_app_id` varbinary(32) NOT NULL,
  `bp_password` tinyblob NOT NULL,
  `bp_token` binary(32) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `bp_restrictions` blob NOT NULL,
  `bp_grants` blob NOT NULL,
  PRIMARY KEY (`bp_user`,`bp_app_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bot_passwords`
--

LOCK TABLES `bot_passwords` WRITE;
/*!40000 ALTER TABLE `bot_passwords` DISABLE KEYS */;
/*!40000 ALTER TABLE `bot_passwords` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `category`
--

DROP TABLE IF EXISTS `category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `category` (
  `cat_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `cat_title` varbinary(255) NOT NULL,
  `cat_pages` int(11) NOT NULL DEFAULT 0,
  `cat_subcats` int(11) NOT NULL DEFAULT 0,
  `cat_files` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`cat_id`),
  UNIQUE KEY `cat_title` (`cat_title`),
  KEY `cat_pages` (`cat_pages`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `category`
--

LOCK TABLES `category` WRITE;
/*!40000 ALTER TABLE `category` DISABLE KEYS */;
/*!40000 ALTER TABLE `category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `categorylinks`
--

DROP TABLE IF EXISTS `categorylinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `categorylinks` (
  `cl_from` int(10) unsigned NOT NULL DEFAULT 0,
  `cl_to` varbinary(255) NOT NULL DEFAULT '',
  `cl_sortkey` varbinary(230) NOT NULL DEFAULT '',
  `cl_sortkey_prefix` varbinary(255) NOT NULL DEFAULT '',
  `cl_timestamp` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `cl_collation` varbinary(32) NOT NULL DEFAULT '',
  `cl_type` enum('page','subcat','file') NOT NULL DEFAULT 'page',
  PRIMARY KEY (`cl_from`,`cl_to`),
  KEY `cl_sortkey` (`cl_to`,`cl_type`,`cl_sortkey`,`cl_from`),
  KEY `cl_timestamp` (`cl_to`,`cl_timestamp`),
  KEY `cl_collation_ext` (`cl_collation`,`cl_to`,`cl_type`,`cl_from`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `categorylinks`
--

LOCK TABLES `categorylinks` WRITE;
/*!40000 ALTER TABLE `categorylinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `categorylinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `change_tag`
--

DROP TABLE IF EXISTS `change_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `change_tag` (
  `ct_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ct_rc_id` int(11) DEFAULT NULL,
  `ct_log_id` int(10) unsigned DEFAULT NULL,
  `ct_rev_id` int(10) unsigned DEFAULT NULL,
  `ct_tag` varbinary(255) NOT NULL DEFAULT '',
  `ct_params` blob DEFAULT NULL,
  `ct_tag_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`ct_id`),
  UNIQUE KEY `change_tag_rc_tag_id` (`ct_rc_id`,`ct_tag_id`),
  UNIQUE KEY `change_tag_log_tag_id` (`ct_log_id`,`ct_tag_id`),
  UNIQUE KEY `change_tag_rev_tag_id` (`ct_rev_id`,`ct_tag_id`),
  KEY `change_tag_rc_tag_nonuniq` (`ct_rc_id`,`ct_tag`),
  KEY `change_tag_log_tag_nonuniq` (`ct_log_id`,`ct_tag`),
  KEY `change_tag_rev_tag_nonuniq` (`ct_rev_id`,`ct_tag`),
  KEY `change_tag_tag_id` (`ct_tag`,`ct_rc_id`,`ct_rev_id`,`ct_log_id`),
  KEY `change_tag_tag_id_id` (`ct_tag_id`,`ct_rc_id`,`ct_rev_id`,`ct_log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `change_tag`
--

LOCK TABLES `change_tag` WRITE;
/*!40000 ALTER TABLE `change_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `change_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `change_tag_def`
--

DROP TABLE IF EXISTS `change_tag_def`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `change_tag_def` (
  `ctd_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ctd_name` varbinary(255) NOT NULL,
  `ctd_user_defined` tinyint(1) NOT NULL,
  `ctd_count` bigint(20) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`ctd_id`),
  UNIQUE KEY `ctd_name` (`ctd_name`),
  KEY `ctd_count` (`ctd_count`),
  KEY `ctd_user_defined` (`ctd_user_defined`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `change_tag_def`
--

LOCK TABLES `change_tag_def` WRITE;
/*!40000 ALTER TABLE `change_tag_def` DISABLE KEYS */;
/*!40000 ALTER TABLE `change_tag_def` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `comment_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_hash` int(11) NOT NULL,
  `comment_text` blob NOT NULL,
  `comment_data` blob DEFAULT NULL,
  PRIMARY KEY (`comment_id`),
  KEY `comment_hash` (`comment_hash`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `content`
--

DROP TABLE IF EXISTS `content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `content` (
  `content_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `content_size` int(10) unsigned NOT NULL,
  `content_sha1` varbinary(32) NOT NULL,
  `content_model` smallint(5) unsigned NOT NULL,
  `content_address` varbinary(255) NOT NULL,
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `content`
--

LOCK TABLES `content` WRITE;
/*!40000 ALTER TABLE `content` DISABLE KEYS */;
INSERT INTO `content` VALUES (1,735,'a5wehuldd0go2uniagwvx66n6c80irq',1,'tt:1');
/*!40000 ALTER TABLE `content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `content_models`
--

DROP TABLE IF EXISTS `content_models`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `content_models` (
  `model_id` smallint(6) NOT NULL AUTO_INCREMENT,
  `model_name` varbinary(64) NOT NULL,
  PRIMARY KEY (`model_id`),
  UNIQUE KEY `model_name` (`model_name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `content_models`
--

LOCK TABLES `content_models` WRITE;
/*!40000 ALTER TABLE `content_models` DISABLE KEYS */;
INSERT INTO `content_models` VALUES (1,'wikitext');
/*!40000 ALTER TABLE `content_models` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `externallinks`
--

DROP TABLE IF EXISTS `externallinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `externallinks` (
  `el_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `el_from` int(10) unsigned NOT NULL DEFAULT 0,
  `el_to` blob NOT NULL,
  `el_index` blob NOT NULL,
  `el_index_60` varbinary(60) NOT NULL,
  PRIMARY KEY (`el_id`),
  KEY `el_from` (`el_from`,`el_to`(40)),
  KEY `el_to` (`el_to`(60),`el_from`),
  KEY `el_index` (`el_index`(60)),
  KEY `el_index_60` (`el_index_60`,`el_id`),
  KEY `el_from_index_60` (`el_from`,`el_index_60`,`el_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `externallinks`
--

LOCK TABLES `externallinks` WRITE;
/*!40000 ALTER TABLE `externallinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `externallinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filearchive`
--

DROP TABLE IF EXISTS `filearchive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filearchive` (
  `fa_id` int(11) NOT NULL AUTO_INCREMENT,
  `fa_name` varbinary(255) NOT NULL DEFAULT '',
  `fa_archive_name` varbinary(255) DEFAULT '',
  `fa_storage_group` varbinary(16) DEFAULT NULL,
  `fa_storage_key` varbinary(64) DEFAULT '',
  `fa_deleted_user` int(11) DEFAULT NULL,
  `fa_deleted_timestamp` binary(14) DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `fa_deleted_reason` varbinary(767) DEFAULT '',
  `fa_deleted_reason_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `fa_size` int(10) unsigned DEFAULT 0,
  `fa_width` int(11) DEFAULT 0,
  `fa_height` int(11) DEFAULT 0,
  `fa_metadata` mediumblob DEFAULT NULL,
  `fa_bits` int(11) DEFAULT 0,
  `fa_media_type` enum('UNKNOWN','BITMAP','DRAWING','AUDIO','VIDEO','MULTIMEDIA','OFFICE','TEXT','EXECUTABLE','ARCHIVE','3D') DEFAULT NULL,
  `fa_major_mime` enum('unknown','application','audio','image','text','video','message','model','multipart','chemical') DEFAULT 'unknown',
  `fa_minor_mime` varbinary(100) DEFAULT 'unknown',
  `fa_description` varbinary(767) DEFAULT '',
  `fa_description_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `fa_user` int(10) unsigned DEFAULT 0,
  `fa_user_text` varbinary(255) DEFAULT '',
  `fa_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `fa_timestamp` binary(14) DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `fa_deleted` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `fa_sha1` varbinary(32) NOT NULL DEFAULT '',
  PRIMARY KEY (`fa_id`),
  KEY `fa_name` (`fa_name`,`fa_timestamp`),
  KEY `fa_storage_group` (`fa_storage_group`,`fa_storage_key`),
  KEY `fa_deleted_timestamp` (`fa_deleted_timestamp`),
  KEY `fa_user_timestamp` (`fa_user_text`,`fa_timestamp`),
  KEY `fa_actor_timestamp` (`fa_actor`,`fa_timestamp`),
  KEY `fa_sha1` (`fa_sha1`(10))
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filearchive`
--

LOCK TABLES `filearchive` WRITE;
/*!40000 ALTER TABLE `filearchive` DISABLE KEYS */;
/*!40000 ALTER TABLE `filearchive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `image`
--

DROP TABLE IF EXISTS `image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image` (
  `img_name` varbinary(255) NOT NULL DEFAULT '',
  `img_size` int(10) unsigned NOT NULL DEFAULT 0,
  `img_width` int(11) NOT NULL DEFAULT 0,
  `img_height` int(11) NOT NULL DEFAULT 0,
  `img_metadata` mediumblob NOT NULL,
  `img_bits` int(11) NOT NULL DEFAULT 0,
  `img_media_type` enum('UNKNOWN','BITMAP','DRAWING','AUDIO','VIDEO','MULTIMEDIA','OFFICE','TEXT','EXECUTABLE','ARCHIVE','3D') DEFAULT NULL,
  `img_major_mime` enum('unknown','application','audio','image','text','video','message','model','multipart','chemical') NOT NULL DEFAULT 'unknown',
  `img_minor_mime` varbinary(100) NOT NULL DEFAULT 'unknown',
  `img_description` varbinary(767) NOT NULL DEFAULT '',
  `img_description_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `img_user` int(10) unsigned NOT NULL DEFAULT 0,
  `img_user_text` varbinary(255) NOT NULL DEFAULT '',
  `img_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `img_timestamp` varbinary(14) NOT NULL DEFAULT '',
  `img_sha1` varbinary(32) NOT NULL DEFAULT '',
  PRIMARY KEY (`img_name`),
  KEY `img_user_timestamp` (`img_user`,`img_timestamp`),
  KEY `img_usertext_timestamp` (`img_user_text`,`img_timestamp`),
  KEY `img_actor_timestamp` (`img_actor`,`img_timestamp`),
  KEY `img_size` (`img_size`),
  KEY `img_timestamp` (`img_timestamp`),
  KEY `img_sha1` (`img_sha1`(10)),
  KEY `img_media_mime` (`img_media_type`,`img_major_mime`,`img_minor_mime`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image`
--

LOCK TABLES `image` WRITE;
/*!40000 ALTER TABLE `image` DISABLE KEYS */;
/*!40000 ALTER TABLE `image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `imagelinks`
--

DROP TABLE IF EXISTS `imagelinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `imagelinks` (
  `il_from` int(10) unsigned NOT NULL DEFAULT 0,
  `il_from_namespace` int(11) NOT NULL DEFAULT 0,
  `il_to` varbinary(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`il_from`,`il_to`),
  KEY `il_to` (`il_to`,`il_from`),
  KEY `il_backlinks_namespace` (`il_from_namespace`,`il_to`,`il_from`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `imagelinks`
--

LOCK TABLES `imagelinks` WRITE;
/*!40000 ALTER TABLE `imagelinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `imagelinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `interwiki`
--

DROP TABLE IF EXISTS `interwiki`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `interwiki` (
  `iw_prefix` varbinary(32) NOT NULL,
  `iw_url` blob NOT NULL,
  `iw_api` blob NOT NULL,
  `iw_wikiid` varbinary(64) NOT NULL,
  `iw_local` tinyint(1) NOT NULL,
  `iw_trans` tinyint(4) NOT NULL DEFAULT 0,
  PRIMARY KEY (`iw_prefix`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `interwiki`
--

LOCK TABLES `interwiki` WRITE;
/*!40000 ALTER TABLE `interwiki` DISABLE KEYS */;
INSERT INTO `interwiki` VALUES ('acronym','https://www.acronymfinder.com/~/search/af.aspx?string=exact&Acronym=$1','','',0,0),('advogato','http://www.advogato.org/$1','','',0,0),('arxiv','https://www.arxiv.org/abs/$1','','',0,0),('c2find','http://c2.com/cgi/wiki?FindPage&value=$1','','',0,0),('cache','https://www.google.com/search?q=cache:$1','','',0,0),('commons','https://commons.wikimedia.org/wiki/$1','https://commons.wikimedia.org/w/api.php','',0,0),('dictionary','http://www.dict.org/bin/Dict?Database=*&Form=Dict1&Strategy=*&Query=$1','','',0,0),('doi','https://dx.doi.org/$1','','',0,0),('drumcorpswiki','http://www.drumcorpswiki.com/$1','http://drumcorpswiki.com/api.php','',0,0),('dwjwiki','http://www.suberic.net/cgi-bin/dwj/wiki.cgi?$1','','',0,0),('elibre','http://enciclopedia.us.es/index.php/$1','http://enciclopedia.us.es/api.php','',0,0),('emacswiki','https://www.emacswiki.org/cgi-bin/wiki.pl?$1','','',0,0),('foldoc','https://foldoc.org/?$1','','',0,0),('foxwiki','https://fox.wikis.com/wc.dll?Wiki~$1','','',0,0),('freebsdman','https://www.FreeBSD.org/cgi/man.cgi?apropos=1&query=$1','','',0,0),('gentoo-wiki','http://gentoo-wiki.com/$1','','',0,0),('google','https://www.google.com/search?q=$1','','',0,0),('googlegroups','https://groups.google.com/groups?q=$1','','',0,0),('hammondwiki','http://www.dairiki.org/HammondWiki/$1','','',0,0),('hrwiki','http://www.hrwiki.org/wiki/$1','http://www.hrwiki.org/w/api.php','',0,0),('imdb','http://www.imdb.com/find?q=$1&tt=on','','',0,0),('kmwiki','https://kmwiki.wikispaces.com/$1','','',0,0),('linuxwiki','http://linuxwiki.de/$1','','',0,0),('lojban','https://mw.lojban.org/papri/$1','','',0,0),('lqwiki','http://wiki.linuxquestions.org/wiki/$1','','',0,0),('meatball','http://www.usemod.com/cgi-bin/mb.pl?$1','','',0,0),('mediawikiwiki','https://www.mediawiki.org/wiki/$1','https://www.mediawiki.org/w/api.php','',0,0),('memoryalpha','http://en.memory-alpha.org/wiki/$1','http://en.memory-alpha.org/api.php','',0,0),('metawiki','http://sunir.org/apps/meta.pl?$1','','',0,0),('metawikimedia','https://meta.wikimedia.org/wiki/$1','https://meta.wikimedia.org/w/api.php','',0,0),('mozillawiki','https://wiki.mozilla.org/$1','https://wiki.mozilla.org/api.php','',0,0),('mw','https://www.mediawiki.org/wiki/$1','https://www.mediawiki.org/w/api.php','',0,0),('oeis','https://oeis.org/$1','','',0,0),('openwiki','http://openwiki.com/ow.asp?$1','','',0,0),('pmid','https://www.ncbi.nlm.nih.gov/pubmed/$1?dopt=Abstract','','',0,0),('pythoninfo','https://wiki.python.org/moin/$1','','',0,0),('rfc','https://tools.ietf.org/html/rfc$1','','',0,0),('s23wiki','http://s23.org/wiki/$1','http://s23.org/w/api.php','',0,0),('seattlewireless','http://seattlewireless.net/$1','','',0,0),('senseislibrary','https://senseis.xmp.net/?$1','','',0,0),('shoutwiki','http://www.shoutwiki.com/wiki/$1','http://www.shoutwiki.com/w/api.php','',0,0),('squeak','http://wiki.squeak.org/squeak/$1','','',0,0),('theopedia','https://www.theopedia.com/$1','','',0,0),('tmbw','http://www.tmbw.net/wiki/$1','http://tmbw.net/wiki/api.php','',0,0),('tmnet','http://www.technomanifestos.net/?$1','','',0,0),('twiki','http://twiki.org/cgi-bin/view/$1','','',0,0),('uncyclopedia','https://en.uncyclopedia.co/wiki/$1','https://en.uncyclopedia.co/w/api.php','',0,0),('unreal','https://wiki.beyondunreal.com/$1','https://wiki.beyondunreal.com/w/api.php','',0,0),('usemod','http://www.usemod.com/cgi-bin/wiki.pl?$1','','',0,0),('wiki','http://c2.com/cgi/wiki?$1','','',0,0),('wikia','http://www.wikia.com/wiki/$1','','',0,0),('wikibooks','https://en.wikibooks.org/wiki/$1','https://en.wikibooks.org/w/api.php','',0,0),('wikidata','https://www.wikidata.org/wiki/$1','https://www.wikidata.org/w/api.php','',0,0),('wikif1','http://www.wikif1.org/$1','','',0,0),('wikihow','https://www.wikihow.com/$1','https://www.wikihow.com/api.php','',0,0),('wikimedia','https://foundation.wikimedia.org/wiki/$1','https://foundation.wikimedia.org/w/api.php','',0,0),('wikinews','https://en.wikinews.org/wiki/$1','https://en.wikinews.org/w/api.php','',0,0),('wikinfo','http://wikinfo.co/English/index.php/$1','','',0,0),('wikipedia','https://en.wikipedia.org/wiki/$1','https://en.wikipedia.org/w/api.php','',0,0),('wikiquote','https://en.wikiquote.org/wiki/$1','https://en.wikiquote.org/w/api.php','',0,0),('wikisource','https://wikisource.org/wiki/$1','https://wikisource.org/w/api.php','',0,0),('wikispecies','https://species.wikimedia.org/wiki/$1','https://species.wikimedia.org/w/api.php','',0,0),('wikiversity','https://en.wikiversity.org/wiki/$1','https://en.wikiversity.org/w/api.php','',0,0),('wikivoyage','https://en.wikivoyage.org/wiki/$1','https://en.wikivoyage.org/w/api.php','',0,0),('wikt','https://en.wiktionary.org/wiki/$1','https://en.wiktionary.org/w/api.php','',0,0),('wiktionary','https://en.wiktionary.org/wiki/$1','https://en.wiktionary.org/w/api.php','',0,0);
/*!40000 ALTER TABLE `interwiki` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ip_changes`
--

DROP TABLE IF EXISTS `ip_changes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ip_changes` (
  `ipc_rev_id` int(10) unsigned NOT NULL DEFAULT 0,
  `ipc_rev_timestamp` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `ipc_hex` varbinary(35) NOT NULL DEFAULT '',
  PRIMARY KEY (`ipc_rev_id`),
  KEY `ipc_rev_timestamp` (`ipc_rev_timestamp`),
  KEY `ipc_hex_time` (`ipc_hex`,`ipc_rev_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ip_changes`
--

LOCK TABLES `ip_changes` WRITE;
/*!40000 ALTER TABLE `ip_changes` DISABLE KEYS */;
/*!40000 ALTER TABLE `ip_changes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ipblocks`
--

DROP TABLE IF EXISTS `ipblocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ipblocks` (
  `ipb_id` int(11) NOT NULL AUTO_INCREMENT,
  `ipb_address` tinyblob NOT NULL,
  `ipb_user` int(10) unsigned NOT NULL DEFAULT 0,
  `ipb_by` int(10) unsigned NOT NULL DEFAULT 0,
  `ipb_by_text` varbinary(255) NOT NULL DEFAULT '',
  `ipb_by_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `ipb_reason` varbinary(767) NOT NULL DEFAULT '',
  `ipb_reason_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `ipb_timestamp` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `ipb_auto` tinyint(1) NOT NULL DEFAULT 0,
  `ipb_anon_only` tinyint(1) NOT NULL DEFAULT 0,
  `ipb_create_account` tinyint(1) NOT NULL DEFAULT 1,
  `ipb_enable_autoblock` tinyint(1) NOT NULL DEFAULT 1,
  `ipb_expiry` varbinary(14) NOT NULL DEFAULT '',
  `ipb_range_start` tinyblob NOT NULL,
  `ipb_range_end` tinyblob NOT NULL,
  `ipb_deleted` tinyint(1) NOT NULL DEFAULT 0,
  `ipb_block_email` tinyint(1) NOT NULL DEFAULT 0,
  `ipb_allow_usertalk` tinyint(1) NOT NULL DEFAULT 0,
  `ipb_parent_block_id` int(11) DEFAULT NULL,
  `ipb_sitewide` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`ipb_id`),
  UNIQUE KEY `ipb_address` (`ipb_address`(255),`ipb_user`,`ipb_auto`,`ipb_anon_only`),
  KEY `ipb_user` (`ipb_user`),
  KEY `ipb_range` (`ipb_range_start`(8),`ipb_range_end`(8)),
  KEY `ipb_timestamp` (`ipb_timestamp`),
  KEY `ipb_expiry` (`ipb_expiry`),
  KEY `ipb_parent_block_id` (`ipb_parent_block_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ipblocks`
--

LOCK TABLES `ipblocks` WRITE;
/*!40000 ALTER TABLE `ipblocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `ipblocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ipblocks_restrictions`
--

DROP TABLE IF EXISTS `ipblocks_restrictions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ipblocks_restrictions` (
  `ir_ipb_id` int(11) NOT NULL,
  `ir_type` tinyint(1) NOT NULL,
  `ir_value` int(11) NOT NULL,
  PRIMARY KEY (`ir_ipb_id`,`ir_type`,`ir_value`),
  KEY `ir_type_value` (`ir_type`,`ir_value`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ipblocks_restrictions`
--

LOCK TABLES `ipblocks_restrictions` WRITE;
/*!40000 ALTER TABLE `ipblocks_restrictions` DISABLE KEYS */;
/*!40000 ALTER TABLE `ipblocks_restrictions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iwlinks`
--

DROP TABLE IF EXISTS `iwlinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iwlinks` (
  `iwl_from` int(10) unsigned NOT NULL DEFAULT 0,
  `iwl_prefix` varbinary(20) NOT NULL DEFAULT '',
  `iwl_title` varbinary(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`iwl_from`,`iwl_prefix`,`iwl_title`),
  KEY `iwl_prefix_title_from` (`iwl_prefix`,`iwl_title`,`iwl_from`),
  KEY `iwl_prefix_from_title` (`iwl_prefix`,`iwl_from`,`iwl_title`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iwlinks`
--

LOCK TABLES `iwlinks` WRITE;
/*!40000 ALTER TABLE `iwlinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `iwlinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `job`
--

DROP TABLE IF EXISTS `job`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `job` (
  `job_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `job_cmd` varbinary(60) NOT NULL DEFAULT '',
  `job_namespace` int(11) NOT NULL,
  `job_title` varbinary(255) NOT NULL,
  `job_timestamp` varbinary(14) DEFAULT NULL,
  `job_params` blob NOT NULL,
  `job_random` int(10) unsigned NOT NULL DEFAULT 0,
  `job_attempts` int(10) unsigned NOT NULL DEFAULT 0,
  `job_token` varbinary(32) NOT NULL DEFAULT '',
  `job_token_timestamp` varbinary(14) DEFAULT NULL,
  `job_sha1` varbinary(32) NOT NULL DEFAULT '',
  PRIMARY KEY (`job_id`),
  KEY `job_sha1` (`job_sha1`),
  KEY `job_cmd_token` (`job_cmd`,`job_token`,`job_random`),
  KEY `job_cmd_token_id` (`job_cmd`,`job_token`,`job_id`),
  KEY `job_cmd` (`job_cmd`,`job_namespace`,`job_title`,`job_params`(128)),
  KEY `job_timestamp` (`job_timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `job`
--

LOCK TABLES `job` WRITE;
/*!40000 ALTER TABLE `job` DISABLE KEYS */;
INSERT INTO `job` VALUES (1,'userGroupExpiry',0,'Main_Page','20190520163142','a:1:{s:9:\"requestId\";s:24:\"5654ae52c8809536d762fbb8\";}',345053020,0,'',NULL,'pj06og5ov12ldavegbb06ibixyz4p10');
/*!40000 ALTER TABLE `job` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `l10n_cache`
--

DROP TABLE IF EXISTS `l10n_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `l10n_cache` (
  `lc_lang` varbinary(32) NOT NULL,
  `lc_key` varbinary(255) NOT NULL,
  `lc_value` mediumblob NOT NULL,
  PRIMARY KEY (`lc_lang`,`lc_key`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `l10n_cache`
--

LOCK TABLES `l10n_cache` WRITE;
/*!40000 ALTER TABLE `l10n_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `l10n_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `langlinks`
--

DROP TABLE IF EXISTS `langlinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `langlinks` (
  `ll_from` int(10) unsigned NOT NULL DEFAULT 0,
  `ll_lang` varbinary(20) NOT NULL DEFAULT '',
  `ll_title` varbinary(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ll_from`,`ll_lang`),
  KEY `ll_lang` (`ll_lang`,`ll_title`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `langlinks`
--

LOCK TABLES `langlinks` WRITE;
/*!40000 ALTER TABLE `langlinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `langlinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_search`
--

DROP TABLE IF EXISTS `log_search`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_search` (
  `ls_field` varbinary(32) NOT NULL,
  `ls_value` varbinary(255) NOT NULL,
  `ls_log_id` int(10) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`ls_field`,`ls_value`,`ls_log_id`),
  KEY `ls_log_id` (`ls_log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_search`
--

LOCK TABLES `log_search` WRITE;
/*!40000 ALTER TABLE `log_search` DISABLE KEYS */;
INSERT INTO `log_search` VALUES ('associated_rev_id','1',1);
/*!40000 ALTER TABLE `log_search` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `logging`
--

DROP TABLE IF EXISTS `logging`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `logging` (
  `log_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `log_type` varbinary(32) NOT NULL DEFAULT '',
  `log_action` varbinary(32) NOT NULL DEFAULT '',
  `log_timestamp` binary(14) NOT NULL DEFAULT '19700101000000',
  `log_user` int(10) unsigned NOT NULL DEFAULT 0,
  `log_user_text` varbinary(255) NOT NULL DEFAULT '',
  `log_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `log_namespace` int(11) NOT NULL DEFAULT 0,
  `log_title` varbinary(255) NOT NULL DEFAULT '',
  `log_page` int(10) unsigned DEFAULT NULL,
  `log_comment` varbinary(767) NOT NULL DEFAULT '',
  `log_comment_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `log_params` blob NOT NULL,
  `log_deleted` tinyint(3) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`log_id`),
  KEY `type_time` (`log_type`,`log_timestamp`),
  KEY `user_time` (`log_user`,`log_timestamp`),
  KEY `actor_time` (`log_actor`,`log_timestamp`),
  KEY `page_time` (`log_namespace`,`log_title`,`log_timestamp`),
  KEY `times` (`log_timestamp`),
  KEY `log_user_type_time` (`log_user`,`log_type`,`log_timestamp`),
  KEY `log_actor_type_time` (`log_actor`,`log_type`,`log_timestamp`),
  KEY `log_page_id_time` (`log_page`,`log_timestamp`),
  KEY `log_type_action` (`log_type`,`log_action`,`log_timestamp`),
  KEY `log_user_text_type_time` (`log_user_text`,`log_type`,`log_timestamp`),
  KEY `log_user_text_time` (`log_user_text`,`log_timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `logging`
--

LOCK TABLES `logging` WRITE;
/*!40000 ALTER TABLE `logging` DISABLE KEYS */;
INSERT INTO `logging` VALUES (1,'create','create','20190520163142',0,'MediaWiki default',0,0,'Main_Page',1,'',0,'a:1:{s:17:\"associated_rev_id\";i:1;}',0);
/*!40000 ALTER TABLE `logging` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `module_deps`
--

DROP TABLE IF EXISTS `module_deps`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `module_deps` (
  `md_module` varbinary(255) NOT NULL,
  `md_skin` varbinary(32) NOT NULL,
  `md_deps` mediumblob NOT NULL,
  PRIMARY KEY (`md_module`,`md_skin`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `module_deps`
--

LOCK TABLES `module_deps` WRITE;
/*!40000 ALTER TABLE `module_deps` DISABLE KEYS */;
/*!40000 ALTER TABLE `module_deps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `objectcache`
--

DROP TABLE IF EXISTS `objectcache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `objectcache` (
  `keyname` varbinary(255) NOT NULL DEFAULT '',
  `value` mediumblob DEFAULT NULL,
  `exptime` datetime DEFAULT NULL,
  PRIMARY KEY (`keyname`),
  KEY `exptime` (`exptime`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `objectcache`
--

LOCK TABLES `objectcache` WRITE;
/*!40000 ALTER TABLE `objectcache` DISABLE KEYS */;
/*!40000 ALTER TABLE `objectcache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oldimage`
--

DROP TABLE IF EXISTS `oldimage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oldimage` (
  `oi_name` varbinary(255) NOT NULL DEFAULT '',
  `oi_archive_name` varbinary(255) NOT NULL DEFAULT '',
  `oi_size` int(10) unsigned NOT NULL DEFAULT 0,
  `oi_width` int(11) NOT NULL DEFAULT 0,
  `oi_height` int(11) NOT NULL DEFAULT 0,
  `oi_bits` int(11) NOT NULL DEFAULT 0,
  `oi_description` varbinary(767) NOT NULL DEFAULT '',
  `oi_description_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `oi_user` int(10) unsigned NOT NULL DEFAULT 0,
  `oi_user_text` varbinary(255) NOT NULL DEFAULT '',
  `oi_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `oi_timestamp` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `oi_metadata` mediumblob NOT NULL,
  `oi_media_type` enum('UNKNOWN','BITMAP','DRAWING','AUDIO','VIDEO','MULTIMEDIA','OFFICE','TEXT','EXECUTABLE','ARCHIVE','3D') DEFAULT NULL,
  `oi_major_mime` enum('unknown','application','audio','image','text','video','message','model','multipart','chemical') NOT NULL DEFAULT 'unknown',
  `oi_minor_mime` varbinary(100) NOT NULL DEFAULT 'unknown',
  `oi_deleted` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `oi_sha1` varbinary(32) NOT NULL DEFAULT '',
  KEY `oi_usertext_timestamp` (`oi_user_text`,`oi_timestamp`),
  KEY `oi_actor_timestamp` (`oi_actor`,`oi_timestamp`),
  KEY `oi_name_timestamp` (`oi_name`,`oi_timestamp`),
  KEY `oi_name_archive_name` (`oi_name`,`oi_archive_name`(14)),
  KEY `oi_sha1` (`oi_sha1`(10))
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oldimage`
--

LOCK TABLES `oldimage` WRITE;
/*!40000 ALTER TABLE `oldimage` DISABLE KEYS */;
/*!40000 ALTER TABLE `oldimage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page`
--

DROP TABLE IF EXISTS `page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page` (
  `page_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `page_namespace` int(11) NOT NULL,
  `page_title` varbinary(255) NOT NULL,
  `page_restrictions` tinyblob NOT NULL,
  `page_is_redirect` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `page_is_new` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `page_random` double unsigned NOT NULL,
  `page_touched` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `page_links_updated` varbinary(14) DEFAULT NULL,
  `page_latest` int(10) unsigned NOT NULL,
  `page_len` int(10) unsigned NOT NULL,
  `page_content_model` varbinary(32) DEFAULT NULL,
  `page_lang` varbinary(35) DEFAULT NULL,
  PRIMARY KEY (`page_id`),
  UNIQUE KEY `name_title` (`page_namespace`,`page_title`),
  KEY `page_random` (`page_random`),
  KEY `page_len` (`page_len`),
  KEY `page_redirect_namespace_len` (`page_is_redirect`,`page_namespace`,`page_len`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page`
--

LOCK TABLES `page` WRITE;
/*!40000 ALTER TABLE `page` DISABLE KEYS */;
INSERT INTO `page` VALUES (1,0,'Main_Page','',0,1,0.819444925507,'20190520163142',NULL,1,735,'wikitext',NULL);
/*!40000 ALTER TABLE `page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_props`
--

DROP TABLE IF EXISTS `page_props`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_props` (
  `pp_page` int(11) NOT NULL,
  `pp_propname` varbinary(60) NOT NULL,
  `pp_value` blob NOT NULL,
  `pp_sortkey` float DEFAULT NULL,
  PRIMARY KEY (`pp_page`,`pp_propname`),
  UNIQUE KEY `pp_propname_page` (`pp_propname`,`pp_page`),
  UNIQUE KEY `pp_propname_sortkey_page` (`pp_propname`,`pp_sortkey`,`pp_page`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_props`
--

LOCK TABLES `page_props` WRITE;
/*!40000 ALTER TABLE `page_props` DISABLE KEYS */;
/*!40000 ALTER TABLE `page_props` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_restrictions`
--

DROP TABLE IF EXISTS `page_restrictions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_restrictions` (
  `pr_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `pr_page` int(11) NOT NULL,
  `pr_type` varbinary(60) NOT NULL,
  `pr_level` varbinary(60) NOT NULL,
  `pr_cascade` tinyint(4) NOT NULL,
  `pr_user` int(10) unsigned DEFAULT NULL,
  `pr_expiry` varbinary(14) DEFAULT NULL,
  PRIMARY KEY (`pr_id`),
  UNIQUE KEY `pr_pagetype` (`pr_page`,`pr_type`),
  KEY `pr_typelevel` (`pr_type`,`pr_level`),
  KEY `pr_level` (`pr_level`),
  KEY `pr_cascade` (`pr_cascade`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_restrictions`
--

LOCK TABLES `page_restrictions` WRITE;
/*!40000 ALTER TABLE `page_restrictions` DISABLE KEYS */;
/*!40000 ALTER TABLE `page_restrictions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pagelinks`
--

DROP TABLE IF EXISTS `pagelinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pagelinks` (
  `pl_from` int(10) unsigned NOT NULL DEFAULT 0,
  `pl_from_namespace` int(11) NOT NULL DEFAULT 0,
  `pl_namespace` int(11) NOT NULL DEFAULT 0,
  `pl_title` varbinary(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`pl_from`,`pl_namespace`,`pl_title`),
  KEY `pl_namespace` (`pl_namespace`,`pl_title`,`pl_from`),
  KEY `pl_backlinks_namespace` (`pl_from_namespace`,`pl_namespace`,`pl_title`,`pl_from`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pagelinks`
--

LOCK TABLES `pagelinks` WRITE;
/*!40000 ALTER TABLE `pagelinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `pagelinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `protected_titles`
--

DROP TABLE IF EXISTS `protected_titles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `protected_titles` (
  `pt_namespace` int(11) NOT NULL,
  `pt_title` varbinary(255) NOT NULL,
  `pt_user` int(10) unsigned NOT NULL,
  `pt_reason` varbinary(767) DEFAULT '',
  `pt_reason_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `pt_timestamp` binary(14) NOT NULL,
  `pt_expiry` varbinary(14) NOT NULL DEFAULT '',
  `pt_create_perm` varbinary(60) NOT NULL,
  PRIMARY KEY (`pt_namespace`,`pt_title`),
  KEY `pt_timestamp` (`pt_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `protected_titles`
--

LOCK TABLES `protected_titles` WRITE;
/*!40000 ALTER TABLE `protected_titles` DISABLE KEYS */;
/*!40000 ALTER TABLE `protected_titles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `querycache`
--

DROP TABLE IF EXISTS `querycache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `querycache` (
  `qc_type` varbinary(32) NOT NULL,
  `qc_value` int(10) unsigned NOT NULL DEFAULT 0,
  `qc_namespace` int(11) NOT NULL DEFAULT 0,
  `qc_title` varbinary(255) NOT NULL DEFAULT '',
  KEY `qc_type` (`qc_type`,`qc_value`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `querycache`
--

LOCK TABLES `querycache` WRITE;
/*!40000 ALTER TABLE `querycache` DISABLE KEYS */;
/*!40000 ALTER TABLE `querycache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `querycache_info`
--

DROP TABLE IF EXISTS `querycache_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `querycache_info` (
  `qci_type` varbinary(32) NOT NULL DEFAULT '',
  `qci_timestamp` binary(14) NOT NULL DEFAULT '19700101000000',
  PRIMARY KEY (`qci_type`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `querycache_info`
--

LOCK TABLES `querycache_info` WRITE;
/*!40000 ALTER TABLE `querycache_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `querycache_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `querycachetwo`
--

DROP TABLE IF EXISTS `querycachetwo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `querycachetwo` (
  `qcc_type` varbinary(32) NOT NULL,
  `qcc_value` int(10) unsigned NOT NULL DEFAULT 0,
  `qcc_namespace` int(11) NOT NULL DEFAULT 0,
  `qcc_title` varbinary(255) NOT NULL DEFAULT '',
  `qcc_namespacetwo` int(11) NOT NULL DEFAULT 0,
  `qcc_titletwo` varbinary(255) NOT NULL DEFAULT '',
  KEY `qcc_type` (`qcc_type`,`qcc_value`),
  KEY `qcc_title` (`qcc_type`,`qcc_namespace`,`qcc_title`),
  KEY `qcc_titletwo` (`qcc_type`,`qcc_namespacetwo`,`qcc_titletwo`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `querycachetwo`
--

LOCK TABLES `querycachetwo` WRITE;
/*!40000 ALTER TABLE `querycachetwo` DISABLE KEYS */;
/*!40000 ALTER TABLE `querycachetwo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recentchanges`
--

DROP TABLE IF EXISTS `recentchanges`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recentchanges` (
  `rc_id` int(11) NOT NULL AUTO_INCREMENT,
  `rc_timestamp` varbinary(14) NOT NULL DEFAULT '',
  `rc_user` int(10) unsigned NOT NULL DEFAULT 0,
  `rc_user_text` varbinary(255) NOT NULL DEFAULT '',
  `rc_actor` bigint(20) unsigned NOT NULL DEFAULT 0,
  `rc_namespace` int(11) NOT NULL DEFAULT 0,
  `rc_title` varbinary(255) NOT NULL DEFAULT '',
  `rc_comment` varbinary(767) NOT NULL DEFAULT '',
  `rc_comment_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `rc_minor` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rc_bot` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rc_new` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rc_cur_id` int(10) unsigned NOT NULL DEFAULT 0,
  `rc_this_oldid` int(10) unsigned NOT NULL DEFAULT 0,
  `rc_last_oldid` int(10) unsigned NOT NULL DEFAULT 0,
  `rc_type` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rc_source` varbinary(16) NOT NULL DEFAULT '',
  `rc_patrolled` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rc_ip` varbinary(40) NOT NULL DEFAULT '',
  `rc_old_len` int(11) DEFAULT NULL,
  `rc_new_len` int(11) DEFAULT NULL,
  `rc_deleted` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rc_logid` int(10) unsigned NOT NULL DEFAULT 0,
  `rc_log_type` varbinary(255) DEFAULT NULL,
  `rc_log_action` varbinary(255) DEFAULT NULL,
  `rc_params` blob DEFAULT NULL,
  PRIMARY KEY (`rc_id`),
  KEY `rc_timestamp` (`rc_timestamp`),
  KEY `rc_namespace_title_timestamp` (`rc_namespace`,`rc_title`,`rc_timestamp`),
  KEY `rc_cur_id` (`rc_cur_id`),
  KEY `new_name_timestamp` (`rc_new`,`rc_namespace`,`rc_timestamp`),
  KEY `rc_ip` (`rc_ip`),
  KEY `rc_ns_usertext` (`rc_namespace`,`rc_user_text`),
  KEY `rc_ns_actor` (`rc_namespace`,`rc_actor`),
  KEY `rc_user_text` (`rc_user_text`,`rc_timestamp`),
  KEY `rc_actor` (`rc_actor`,`rc_timestamp`),
  KEY `rc_name_type_patrolled_timestamp` (`rc_namespace`,`rc_type`,`rc_patrolled`,`rc_timestamp`),
  KEY `rc_this_oldid` (`rc_this_oldid`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recentchanges`
--

LOCK TABLES `recentchanges` WRITE;
/*!40000 ALTER TABLE `recentchanges` DISABLE KEYS */;
/*!40000 ALTER TABLE `recentchanges` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `redirect`
--

DROP TABLE IF EXISTS `redirect`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `redirect` (
  `rd_from` int(10) unsigned NOT NULL DEFAULT 0,
  `rd_namespace` int(11) NOT NULL DEFAULT 0,
  `rd_title` varbinary(255) NOT NULL DEFAULT '',
  `rd_interwiki` varbinary(32) DEFAULT NULL,
  `rd_fragment` varbinary(255) DEFAULT NULL,
  PRIMARY KEY (`rd_from`),
  KEY `rd_ns_title` (`rd_namespace`,`rd_title`,`rd_from`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `redirect`
--

LOCK TABLES `redirect` WRITE;
/*!40000 ALTER TABLE `redirect` DISABLE KEYS */;
/*!40000 ALTER TABLE `redirect` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `revision`
--

DROP TABLE IF EXISTS `revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `revision` (
  `rev_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `rev_page` int(10) unsigned NOT NULL,
  `rev_text_id` int(10) unsigned NOT NULL DEFAULT 0,
  `rev_comment` varbinary(767) NOT NULL DEFAULT '',
  `rev_user` int(10) unsigned NOT NULL DEFAULT 0,
  `rev_user_text` varbinary(255) NOT NULL DEFAULT '',
  `rev_timestamp` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `rev_minor_edit` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rev_deleted` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `rev_len` int(10) unsigned DEFAULT NULL,
  `rev_parent_id` int(10) unsigned DEFAULT NULL,
  `rev_sha1` varbinary(32) NOT NULL DEFAULT '',
  `rev_content_model` varbinary(32) DEFAULT NULL,
  `rev_content_format` varbinary(64) DEFAULT NULL,
  PRIMARY KEY (`rev_id`),
  KEY `rev_page_id` (`rev_page`,`rev_id`),
  KEY `rev_timestamp` (`rev_timestamp`),
  KEY `page_timestamp` (`rev_page`,`rev_timestamp`),
  KEY `user_timestamp` (`rev_user`,`rev_timestamp`),
  KEY `usertext_timestamp` (`rev_user_text`,`rev_timestamp`),
  KEY `page_user_timestamp` (`rev_page`,`rev_user`,`rev_timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary MAX_ROWS=10000000 AVG_ROW_LENGTH=1024;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `revision`
--

LOCK TABLES `revision` WRITE;
/*!40000 ALTER TABLE `revision` DISABLE KEYS */;
INSERT INTO `revision` VALUES (1,1,1,'',0,'MediaWiki default','20190520163142',0,0,735,0,'a5wehuldd0go2uniagwvx66n6c80irq',NULL,NULL);
/*!40000 ALTER TABLE `revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `revision_actor_temp`
--

DROP TABLE IF EXISTS `revision_actor_temp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `revision_actor_temp` (
  `revactor_rev` int(10) unsigned NOT NULL,
  `revactor_actor` bigint(20) unsigned NOT NULL,
  `revactor_timestamp` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `revactor_page` int(10) unsigned NOT NULL,
  PRIMARY KEY (`revactor_rev`,`revactor_actor`),
  UNIQUE KEY `revactor_rev` (`revactor_rev`),
  KEY `actor_timestamp` (`revactor_actor`,`revactor_timestamp`),
  KEY `page_actor_timestamp` (`revactor_page`,`revactor_actor`,`revactor_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `revision_actor_temp`
--

LOCK TABLES `revision_actor_temp` WRITE;
/*!40000 ALTER TABLE `revision_actor_temp` DISABLE KEYS */;
/*!40000 ALTER TABLE `revision_actor_temp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `revision_comment_temp`
--

DROP TABLE IF EXISTS `revision_comment_temp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `revision_comment_temp` (
  `revcomment_rev` int(10) unsigned NOT NULL,
  `revcomment_comment_id` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`revcomment_rev`,`revcomment_comment_id`),
  UNIQUE KEY `revcomment_rev` (`revcomment_rev`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `revision_comment_temp`
--

LOCK TABLES `revision_comment_temp` WRITE;
/*!40000 ALTER TABLE `revision_comment_temp` DISABLE KEYS */;
/*!40000 ALTER TABLE `revision_comment_temp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `searchindex`
--

DROP TABLE IF EXISTS `searchindex`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `searchindex` (
  `si_page` int(10) unsigned NOT NULL,
  `si_title` varchar(255) NOT NULL DEFAULT '',
  `si_text` mediumtext NOT NULL,
  UNIQUE KEY `si_page` (`si_page`),
  FULLTEXT KEY `si_title` (`si_title`),
  FULLTEXT KEY `si_text` (`si_text`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `searchindex`
--

LOCK TABLES `searchindex` WRITE;
/*!40000 ALTER TABLE `searchindex` DISABLE KEYS */;
/*!40000 ALTER TABLE `searchindex` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `site_identifiers`
--

DROP TABLE IF EXISTS `site_identifiers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `site_identifiers` (
  `si_site` int(10) unsigned NOT NULL,
  `si_type` varbinary(32) NOT NULL,
  `si_key` varbinary(32) NOT NULL,
  PRIMARY KEY (`si_type`,`si_key`),
  KEY `site_ids_site` (`si_site`),
  KEY `site_ids_key` (`si_key`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `site_identifiers`
--

LOCK TABLES `site_identifiers` WRITE;
/*!40000 ALTER TABLE `site_identifiers` DISABLE KEYS */;
/*!40000 ALTER TABLE `site_identifiers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `site_stats`
--

DROP TABLE IF EXISTS `site_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `site_stats` (
  `ss_row_id` int(10) unsigned NOT NULL,
  `ss_total_edits` bigint(20) unsigned DEFAULT NULL,
  `ss_good_articles` bigint(20) unsigned DEFAULT NULL,
  `ss_total_pages` bigint(20) unsigned DEFAULT NULL,
  `ss_users` bigint(20) unsigned DEFAULT NULL,
  `ss_active_users` bigint(20) unsigned DEFAULT NULL,
  `ss_images` bigint(20) unsigned DEFAULT NULL,
  PRIMARY KEY (`ss_row_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `site_stats`
--

LOCK TABLES `site_stats` WRITE;
/*!40000 ALTER TABLE `site_stats` DISABLE KEYS */;
INSERT INTO `site_stats` VALUES (1,0,0,0,0,0,0);
/*!40000 ALTER TABLE `site_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sites`
--

DROP TABLE IF EXISTS `sites`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sites` (
  `site_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `site_global_key` varbinary(32) NOT NULL,
  `site_type` varbinary(32) NOT NULL,
  `site_group` varbinary(32) NOT NULL,
  `site_source` varbinary(32) NOT NULL,
  `site_language` varbinary(32) NOT NULL,
  `site_protocol` varbinary(32) NOT NULL,
  `site_domain` varbinary(255) NOT NULL,
  `site_data` blob NOT NULL,
  `site_forward` tinyint(1) NOT NULL,
  `site_config` blob NOT NULL,
  PRIMARY KEY (`site_id`),
  UNIQUE KEY `sites_global_key` (`site_global_key`),
  KEY `sites_type` (`site_type`),
  KEY `sites_group` (`site_group`),
  KEY `sites_source` (`site_source`),
  KEY `sites_language` (`site_language`),
  KEY `sites_protocol` (`site_protocol`),
  KEY `sites_domain` (`site_domain`),
  KEY `sites_forward` (`site_forward`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sites`
--

LOCK TABLES `sites` WRITE;
/*!40000 ALTER TABLE `sites` DISABLE KEYS */;
/*!40000 ALTER TABLE `sites` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slot_roles`
--

DROP TABLE IF EXISTS `slot_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slot_roles` (
  `role_id` smallint(6) NOT NULL AUTO_INCREMENT,
  `role_name` varbinary(64) NOT NULL,
  PRIMARY KEY (`role_id`),
  UNIQUE KEY `role_name` (`role_name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slot_roles`
--

LOCK TABLES `slot_roles` WRITE;
/*!40000 ALTER TABLE `slot_roles` DISABLE KEYS */;
INSERT INTO `slot_roles` VALUES (1,'main');
/*!40000 ALTER TABLE `slot_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slots`
--

DROP TABLE IF EXISTS `slots`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slots` (
  `slot_revision_id` bigint(20) unsigned NOT NULL,
  `slot_role_id` smallint(5) unsigned NOT NULL,
  `slot_content_id` bigint(20) unsigned NOT NULL,
  `slot_origin` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`slot_revision_id`,`slot_role_id`),
  KEY `slot_revision_origin_role` (`slot_revision_id`,`slot_origin`,`slot_role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slots`
--

LOCK TABLES `slots` WRITE;
/*!40000 ALTER TABLE `slots` DISABLE KEYS */;
INSERT INTO `slots` VALUES (1,1,1,1);
/*!40000 ALTER TABLE `slots` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tag_summary`
--

DROP TABLE IF EXISTS `tag_summary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tag_summary` (
  `ts_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ts_rc_id` int(11) DEFAULT NULL,
  `ts_log_id` int(10) unsigned DEFAULT NULL,
  `ts_rev_id` int(10) unsigned DEFAULT NULL,
  `ts_tags` blob NOT NULL,
  PRIMARY KEY (`ts_id`),
  UNIQUE KEY `tag_summary_rc_id` (`ts_rc_id`),
  UNIQUE KEY `tag_summary_log_id` (`ts_log_id`),
  UNIQUE KEY `tag_summary_rev_id` (`ts_rev_id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tag_summary`
--

LOCK TABLES `tag_summary` WRITE;
/*!40000 ALTER TABLE `tag_summary` DISABLE KEYS */;
/*!40000 ALTER TABLE `tag_summary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `templatelinks`
--

DROP TABLE IF EXISTS `templatelinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `templatelinks` (
  `tl_from` int(10) unsigned NOT NULL DEFAULT 0,
  `tl_from_namespace` int(11) NOT NULL DEFAULT 0,
  `tl_namespace` int(11) NOT NULL DEFAULT 0,
  `tl_title` varbinary(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`tl_from`,`tl_namespace`,`tl_title`),
  KEY `tl_namespace` (`tl_namespace`,`tl_title`,`tl_from`),
  KEY `tl_backlinks_namespace` (`tl_from_namespace`,`tl_namespace`,`tl_title`,`tl_from`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `templatelinks`
--

LOCK TABLES `templatelinks` WRITE;
/*!40000 ALTER TABLE `templatelinks` DISABLE KEYS */;
/*!40000 ALTER TABLE `templatelinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `text`
--

DROP TABLE IF EXISTS `text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `text` (
  `old_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_text` mediumblob NOT NULL,
  `old_flags` tinyblob NOT NULL,
  PRIMARY KEY (`old_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary MAX_ROWS=10000000 AVG_ROW_LENGTH=10240;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `text`
--

LOCK TABLES `text` WRITE;
/*!40000 ALTER TABLE `text` DISABLE KEYS */;
INSERT INTO `text` VALUES (1,'<strong>MediaWiki has been installed.</strong>\n\nConsult the [https://www.mediawiki.org/wiki/Special:MyLanguage/Help:Contents User\'s Guide] for information on using the wiki software.\n\n== Getting started ==\n* [https://www.mediawiki.org/wiki/Special:MyLanguage/Manual:Configuration_settings Configuration settings list]\n* [https://www.mediawiki.org/wiki/Special:MyLanguage/Manual:FAQ MediaWiki FAQ]\n* [https://lists.wikimedia.org/mailman/listinfo/mediawiki-announce MediaWiki release mailing list]\n* [https://www.mediawiki.org/wiki/Special:MyLanguage/Localisation#Translation_resources Localise MediaWiki for your language]\n* [https://www.mediawiki.org/wiki/Special:MyLanguage/Manual:Combating_spam Learn how to combat spam on your wiki]','utf-8');
/*!40000 ALTER TABLE `text` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `updatelog`
--

DROP TABLE IF EXISTS `updatelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `updatelog` (
  `ul_key` varbinary(255) NOT NULL,
  `ul_value` blob DEFAULT NULL,
  PRIMARY KEY (`ul_key`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `updatelog`
--

LOCK TABLES `updatelog` WRITE;
/*!40000 ALTER TABLE `updatelog` DISABLE KEYS */;
INSERT INTO `updatelog` VALUES ('filearchive-fa_major_mime-patch-fa_major_mime-chemical.sql',NULL),('image-img_major_mime-patch-img_major_mime-chemical.sql',NULL),('oldimage-oi_major_mime-patch-oi_major_mime-chemical.sql',NULL),('user_former_groups-ufg_group-patch-ufg_group-length-increase-255.sql',NULL),('user_groups-ug_group-patch-ug_group-length-increase-255.sql',NULL),('user_properties-up_property-patch-up_property.sql',NULL);
/*!40000 ALTER TABLE `updatelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `uploadstash`
--

DROP TABLE IF EXISTS `uploadstash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `uploadstash` (
  `us_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `us_user` int(10) unsigned NOT NULL,
  `us_key` varbinary(255) NOT NULL,
  `us_orig_path` varbinary(255) NOT NULL,
  `us_path` varbinary(255) NOT NULL,
  `us_source_type` varbinary(50) DEFAULT NULL,
  `us_timestamp` varbinary(14) NOT NULL,
  `us_status` varbinary(50) NOT NULL,
  `us_chunk_inx` int(10) unsigned DEFAULT NULL,
  `us_props` blob DEFAULT NULL,
  `us_size` int(10) unsigned NOT NULL,
  `us_sha1` varbinary(31) NOT NULL,
  `us_mime` varbinary(255) DEFAULT NULL,
  `us_media_type` enum('UNKNOWN','BITMAP','DRAWING','AUDIO','VIDEO','MULTIMEDIA','OFFICE','TEXT','EXECUTABLE','ARCHIVE','3D') DEFAULT NULL,
  `us_image_width` int(10) unsigned DEFAULT NULL,
  `us_image_height` int(10) unsigned DEFAULT NULL,
  `us_image_bits` smallint(5) unsigned DEFAULT NULL,
  PRIMARY KEY (`us_id`),
  UNIQUE KEY `us_key` (`us_key`),
  KEY `us_user` (`us_user`),
  KEY `us_timestamp` (`us_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `uploadstash`
--

LOCK TABLES `uploadstash` WRITE;
/*!40000 ALTER TABLE `uploadstash` DISABLE KEYS */;
/*!40000 ALTER TABLE `uploadstash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_name` varbinary(255) NOT NULL DEFAULT '',
  `user_real_name` varbinary(255) NOT NULL DEFAULT '',
  `user_password` tinyblob NOT NULL,
  `user_newpassword` tinyblob NOT NULL,
  `user_newpass_time` binary(14) DEFAULT NULL,
  `user_email` tinyblob NOT NULL,
  `user_touched` binary(14) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `user_token` binary(32) NOT NULL DEFAULT '\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  `user_email_authenticated` binary(14) DEFAULT NULL,
  `user_email_token` binary(32) DEFAULT NULL,
  `user_email_token_expires` binary(14) DEFAULT NULL,
  `user_registration` binary(14) DEFAULT NULL,
  `user_editcount` int(11) DEFAULT NULL,
  `user_password_expires` varbinary(14) DEFAULT NULL,
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `user_name` (`user_name`),
  KEY `user_email_token` (`user_email_token`),
  KEY `user_email` (`user_email`(50))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES (1,'Admin','',':pbkdf2:sha512:30000:64:0xFNtPqsGEumczWb4FpjMw==:myEXUdEvselONFx71gICXBVjrR91lzqC/gAH3VDpqDZ0r77TB8blc+nJHYcCsgF80uBDEYIcwqUYCbyMBADg9g==','',NULL,'','20190520163149','403cfb49cda6f1206e9d96cb0c8cc2e1',NULL,'\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',NULL,'20190520163142',0,NULL);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_former_groups`
--

DROP TABLE IF EXISTS `user_former_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user_former_groups` (
  `ufg_user` int(10) unsigned NOT NULL DEFAULT 0,
  `ufg_group` varbinary(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ufg_user`,`ufg_group`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_former_groups`
--

LOCK TABLES `user_former_groups` WRITE;
/*!40000 ALTER TABLE `user_former_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `user_former_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_groups`
--

DROP TABLE IF EXISTS `user_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user_groups` (
  `ug_user` int(10) unsigned NOT NULL DEFAULT 0,
  `ug_group` varbinary(255) NOT NULL DEFAULT '',
  `ug_expiry` varbinary(14) DEFAULT NULL,
  PRIMARY KEY (`ug_user`,`ug_group`),
  KEY `ug_group` (`ug_group`),
  KEY `ug_expiry` (`ug_expiry`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_groups`
--

LOCK TABLES `user_groups` WRITE;
/*!40000 ALTER TABLE `user_groups` DISABLE KEYS */;
INSERT INTO `user_groups` VALUES (1,'bureaucrat',NULL),(1,'interface-admin',NULL),(1,'sysop',NULL);
/*!40000 ALTER TABLE `user_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_newtalk`
--

DROP TABLE IF EXISTS `user_newtalk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user_newtalk` (
  `user_id` int(10) unsigned NOT NULL DEFAULT 0,
  `user_ip` varbinary(40) NOT NULL DEFAULT '',
  `user_last_timestamp` varbinary(14) DEFAULT NULL,
  KEY `un_user_id` (`user_id`),
  KEY `un_user_ip` (`user_ip`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_newtalk`
--

LOCK TABLES `user_newtalk` WRITE;
/*!40000 ALTER TABLE `user_newtalk` DISABLE KEYS */;
/*!40000 ALTER TABLE `user_newtalk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_properties`
--

DROP TABLE IF EXISTS `user_properties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user_properties` (
  `up_user` int(10) unsigned NOT NULL,
  `up_property` varbinary(255) NOT NULL,
  `up_value` blob DEFAULT NULL,
  PRIMARY KEY (`up_user`,`up_property`),
  KEY `user_properties_property` (`up_property`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_properties`
--

LOCK TABLES `user_properties` WRITE;
/*!40000 ALTER TABLE `user_properties` DISABLE KEYS */;
/*!40000 ALTER TABLE `user_properties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `valid_tag`
--

DROP TABLE IF EXISTS `valid_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `valid_tag` (
  `vt_tag` varbinary(255) NOT NULL,
  PRIMARY KEY (`vt_tag`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `valid_tag`
--

LOCK TABLES `valid_tag` WRITE;
/*!40000 ALTER TABLE `valid_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `valid_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `watchlist`
--

DROP TABLE IF EXISTS `watchlist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `watchlist` (
  `wl_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `wl_user` int(10) unsigned NOT NULL,
  `wl_namespace` int(11) NOT NULL DEFAULT 0,
  `wl_title` varbinary(255) NOT NULL DEFAULT '',
  `wl_notificationtimestamp` varbinary(14) DEFAULT NULL,
  PRIMARY KEY (`wl_id`),
  UNIQUE KEY `wl_user` (`wl_user`,`wl_namespace`,`wl_title`),
  KEY `namespace_title` (`wl_namespace`,`wl_title`),
  KEY `wl_user_notificationtimestamp` (`wl_user`,`wl_notificationtimestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=binary;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `watchlist`
--

LOCK TABLES `watchlist` WRITE;
/*!40000 ALTER TABLE `watchlist` DISABLE KEYS */;
/*!40000 ALTER TABLE `watchlist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Current Database: `mysql`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `mysql` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `mysql`;

--
-- Table structure for table `column_stats`
--

DROP TABLE IF EXISTS `column_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `column_stats` (
  `db_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `column_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `min_value` varbinary(255) DEFAULT NULL,
  `max_value` varbinary(255) DEFAULT NULL,
  `nulls_ratio` decimal(12,4) DEFAULT NULL,
  `avg_length` decimal(12,4) DEFAULT NULL,
  `avg_frequency` decimal(12,4) DEFAULT NULL,
  `hist_size` tinyint(3) unsigned DEFAULT NULL,
  `hist_type` enum('SINGLE_PREC_HB','DOUBLE_PREC_HB') COLLATE utf8_bin DEFAULT NULL,
  `histogram` varbinary(255) DEFAULT NULL,
  PRIMARY KEY (`db_name`,`table_name`,`column_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Statistics on Columns';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `column_stats`
--

LOCK TABLES `column_stats` WRITE;
/*!40000 ALTER TABLE `column_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `column_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `columns_priv`
--

DROP TABLE IF EXISTS `columns_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `columns_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Column_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`Db`,`User`,`Table_name`,`Column_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Column privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `columns_priv`
--

LOCK TABLES `columns_priv` WRITE;
/*!40000 ALTER TABLE `columns_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `columns_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `db`
--

DROP TABLE IF EXISTS `db`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `db` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_history_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`Db`,`User`),
  KEY `User` (`User`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `db`
--

LOCK TABLES `db` WRITE;
/*!40000 ALTER TABLE `db` DISABLE KEYS */;
INSERT INTO `db` VALUES ('%','test','','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','N','N','Y','Y','Y'),('%','test\\_%','','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','N','N','Y','Y','Y'),('%','my_wiki','wikiuser','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y');
/*!40000 ALTER TABLE `db` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event`
--

DROP TABLE IF EXISTS `event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event` (
  `db` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `name` char(64) NOT NULL DEFAULT '',
  `body` longblob NOT NULL,
  `definer` char(141) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `execute_at` datetime DEFAULT NULL,
  `interval_value` int(11) DEFAULT NULL,
  `interval_field` enum('YEAR','QUARTER','MONTH','DAY','HOUR','MINUTE','WEEK','SECOND','MICROSECOND','YEAR_MONTH','DAY_HOUR','DAY_MINUTE','DAY_SECOND','HOUR_MINUTE','HOUR_SECOND','MINUTE_SECOND','DAY_MICROSECOND','HOUR_MICROSECOND','MINUTE_MICROSECOND','SECOND_MICROSECOND') DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_executed` datetime DEFAULT NULL,
  `starts` datetime DEFAULT NULL,
  `ends` datetime DEFAULT NULL,
  `status` enum('ENABLED','DISABLED','SLAVESIDE_DISABLED') NOT NULL DEFAULT 'ENABLED',
  `on_completion` enum('DROP','PRESERVE') NOT NULL DEFAULT 'DROP',
  `sql_mode` set('REAL_AS_FLOAT','PIPES_AS_CONCAT','ANSI_QUOTES','IGNORE_SPACE','IGNORE_BAD_TABLE_OPTIONS','ONLY_FULL_GROUP_BY','NO_UNSIGNED_SUBTRACTION','NO_DIR_IN_CREATE','POSTGRESQL','ORACLE','MSSQL','DB2','MAXDB','NO_KEY_OPTIONS','NO_TABLE_OPTIONS','NO_FIELD_OPTIONS','MYSQL323','MYSQL40','ANSI','NO_AUTO_VALUE_ON_ZERO','NO_BACKSLASH_ESCAPES','STRICT_TRANS_TABLES','STRICT_ALL_TABLES','NO_ZERO_IN_DATE','NO_ZERO_DATE','INVALID_DATES','ERROR_FOR_DIVISION_BY_ZERO','TRADITIONAL','NO_AUTO_CREATE_USER','HIGH_NOT_PRECEDENCE','NO_ENGINE_SUBSTITUTION','PAD_CHAR_TO_FULL_LENGTH','EMPTY_STRING_IS_NULL','SIMULTANEOUS_ASSIGNMENT') NOT NULL DEFAULT '',
  `comment` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `originator` int(10) unsigned NOT NULL,
  `time_zone` char(64) CHARACTER SET latin1 NOT NULL DEFAULT 'SYSTEM',
  `character_set_client` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `collation_connection` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `db_collation` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `body_utf8` longblob DEFAULT NULL,
  PRIMARY KEY (`db`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Events';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `func`
--

DROP TABLE IF EXISTS `func`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `func` (
  `name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ret` tinyint(1) NOT NULL DEFAULT 0,
  `dl` char(128) COLLATE utf8_bin NOT NULL DEFAULT '',
  `type` enum('function','aggregate') CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='User defined functions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `func`
--

LOCK TABLES `func` WRITE;
/*!40000 ALTER TABLE `func` DISABLE KEYS */;
/*!40000 ALTER TABLE `func` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gtid_slave_pos`
--

DROP TABLE IF EXISTS `gtid_slave_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gtid_slave_pos` (
  `domain_id` int(10) unsigned NOT NULL,
  `sub_id` bigint(20) unsigned NOT NULL,
  `server_id` int(10) unsigned NOT NULL,
  `seq_no` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`domain_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Replication slave GTID position';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gtid_slave_pos`
--

LOCK TABLES `gtid_slave_pos` WRITE;
/*!40000 ALTER TABLE `gtid_slave_pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `gtid_slave_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_category`
--

DROP TABLE IF EXISTS `help_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_category` (
  `help_category_id` smallint(5) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `parent_category_id` smallint(5) unsigned DEFAULT NULL,
  `url` text NOT NULL,
  PRIMARY KEY (`help_category_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help categories';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_category`
--

LOCK TABLES `help_category` WRITE;
/*!40000 ALTER TABLE `help_category` DISABLE KEYS */;
INSERT INTO `help_category` VALUES (1,'Geographic',0,''),(2,'Polygon properties',34,''),(3,'WKT',34,''),(4,'Numeric Functions',38,''),(5,'Plugins',35,''),(6,'MBR',34,''),(7,'Control flow functions',38,''),(8,'Transactions',35,''),(9,'Help Metadata',35,''),(10,'Account Management',35,''),(11,'Point properties',34,''),(12,'Encryption Functions',38,''),(13,'LineString properties',34,''),(14,'Miscellaneous Functions',38,''),(15,'Logical operators',38,''),(16,'Functions and Modifiers for Use with GROUP BY',35,''),(17,'Information Functions',38,''),(18,'Comparison operators',38,''),(19,'Bit Functions',38,''),(20,'Table Maintenance',35,''),(21,'User-Defined Functions',35,''),(22,'Data Types',35,''),(23,'Compound Statements',35,''),(24,'Geometry constructors',34,''),(25,'GeometryCollection properties',1,''),(26,'Administration',35,''),(27,'Data Manipulation',35,''),(28,'Utility',35,''),(29,'Language Structure',35,''),(30,'Geometry relations',34,''),(31,'Date and Time Functions',38,''),(32,'WKB',34,''),(33,'Procedures',35,''),(34,'Geographic Features',35,''),(35,'Contents',0,''),(36,'Geometry properties',34,''),(37,'String Functions',38,''),(38,'Functions',35,''),(39,'Data Definition',35,'');
/*!40000 ALTER TABLE `help_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_keyword`
--

DROP TABLE IF EXISTS `help_keyword`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_keyword` (
  `help_keyword_id` int(10) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  PRIMARY KEY (`help_keyword_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help keywords';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_keyword`
--

LOCK TABLES `help_keyword` WRITE;
/*!40000 ALTER TABLE `help_keyword` DISABLE KEYS */;
INSERT INTO `help_keyword` VALUES (0,'JOIN'),(1,'HOST'),(2,'REPEAT'),(3,'SERIALIZABLE'),(4,'REPLACE'),(5,'AT'),(6,'SCHEDULE'),(7,'RETURNS'),(8,'STARTS'),(9,'MASTER_SSL_CA'),(10,'NCHAR'),(11,'COLUMNS'),(12,'COMPLETION'),(13,'WORK'),(14,'DATETIME'),(15,'MODE'),(16,'OPEN'),(17,'INTEGER'),(18,'ESCAPE'),(19,'VALUE'),(20,'MASTER_SSL_VERIFY_SERVER_CERT'),(21,'SQL_BIG_RESULT'),(22,'DROP'),(23,'GEOMETRYCOLLECTIONFROMWKB'),(24,'EVENTS'),(25,'MONTH'),(26,'PROFILES'),(27,'DUPLICATE'),(28,'REPLICATION'),(29,'UNLOCK'),(30,'INNODB'),(31,'YEAR_MONTH'),(32,'SUBJECT'),(33,'PREPARE'),(34,'LOCK'),(35,'NDB'),(36,'CHECK'),(37,'FULL'),(38,'INT4'),(39,'BY'),(40,'NO'),(41,'MINUTE'),(42,'PARTITION'),(43,'DATA'),(44,'DAY'),(45,'SHARE'),(46,'REAL'),(47,'SEPARATOR'),(48,'MESSAGE_TEXT'),(49,'MASTER_HEARTBEAT_PERIOD'),(50,'DELETE'),(51,'ON'),(52,'COLUMN_NAME'),(53,'CONNECTION'),(54,'CLOSE'),(55,'X509'),(56,'USE'),(57,'SUBCLASS_ORIGIN'),(58,'WHERE'),(59,'PRIVILEGES'),(60,'SPATIAL'),(61,'EVENT'),(62,'SUPER'),(63,'SQL_BUFFER_RESULT'),(64,'IGNORE'),(65,'SHA2'),(66,'QUICK'),(67,'SIGNED'),(68,'OFFLINE'),(69,'SECURITY'),(70,'AUTOEXTEND_SIZE'),(71,'NDBCLUSTER'),(72,'POLYGONFROMWKB'),(73,'FALSE'),(74,'LEVEL'),(75,'FORCE'),(76,'BINARY'),(77,'TO'),(78,'CHANGE'),(79,'CURRENT_USER'),(80,'HOUR_MINUTE'),(81,'UPDATE'),(82,'PRESERVE'),(83,'TABLE_NAME'),(84,'INTO'),(85,'FEDERATED'),(86,'VARYING'),(87,'MAX_SIZE'),(88,'HOUR_SECOND'),(89,'VARIABLE'),(90,'ROLLBACK'),(91,'PROCEDURE'),(92,'TIMESTAMP'),(93,'IMPORT'),(94,'AGAINST'),(95,'CHECKSUM'),(96,'COUNT'),(97,'LONGBINARY'),(98,'THEN'),(99,'INSERT'),(100,'ENGINES'),(101,'HANDLER'),(102,'PORT'),(103,'DAY_SECOND'),(104,'EXISTS'),(105,'MUTEX'),(106,'HELP_DATE'),(107,'RELEASE'),(108,'BOOLEAN'),(109,'MOD'),(110,'DEFAULT'),(111,'TYPE'),(112,'NO_WRITE_TO_BINLOG'),(113,'OPTIMIZE'),(114,'SQLSTATE'),(115,'RESET'),(116,'CLASS_ORIGIN'),(117,'INSTALL'),(118,'ITERATE'),(119,'DO'),(120,'BIGINT'),(121,'SET'),(122,'ISSUER'),(123,'DATE'),(124,'STATUS'),(125,'FULLTEXT'),(126,'COMMENT'),(127,'MASTER_CONNECT_RETRY'),(128,'INNER'),(129,'RELAYLOG'),(130,'STOP'),(131,'MASTER_LOG_FILE'),(132,'MRG_MYISAM'),(133,'PRECISION'),(134,'REQUIRE'),(135,'TRAILING'),(136,'PARTITIONS'),(137,'LONG'),(138,'OPTION'),(139,'REORGANIZE'),(140,'ELSE'),(141,'DEALLOCATE'),(142,'IO_THREAD'),(143,'CASE'),(144,'CIPHER'),(145,'CONTINUE'),(146,'FROM'),(147,'READ'),(148,'LEFT'),(149,'ELSEIF'),(150,'MINUTE_SECOND'),(151,'COMPACT'),(152,'DEC'),(153,'FOR'),(154,'WARNINGS'),(155,'MIN_ROWS'),(156,'STRING'),(157,'CONDITION'),(158,'ENCLOSED'),(159,'FUNCTION'),(160,'AGGREGATE'),(161,'FIELDS'),(162,'INT3'),(163,'ARCHIVE'),(164,'AVG_ROW_LENGTH'),(165,'ADD'),(166,'KILL'),(167,'FLOAT4'),(168,'TABLESPACE'),(169,'VIEW'),(170,'REPEATABLE'),(171,'INFILE'),(172,'HELP_VERSION'),(173,'ORDER'),(174,'USING'),(175,'CONSTRAINT_CATALOG'),(176,'MIDDLEINT'),(177,'GRANT'),(178,'UNSIGNED'),(179,'DECIMAL'),(180,'GEOMETRYFROMTEXT'),(181,'INDEXES'),(182,'FOREIGN'),(183,'CACHE'),(184,'HOSTS'),(185,'MYSQL_ERRNO'),(186,'COMMIT'),(187,'SCHEMAS'),(188,'LEADING'),(189,'SNAPSHOT'),(190,'CONSTRAINT_NAME'),(191,'DECLARE'),(192,'LOAD'),(193,'SQL_CACHE'),(194,'CONVERT'),(195,'DYNAMIC'),(196,'COLLATE'),(197,'POLYGONFROMTEXT'),(198,'BYTE'),(199,'GLOBAL'),(200,'LINESTRINGFROMWKB'),(201,'WHEN'),(202,'HAVING'),(203,'AS'),(204,'STARTING'),(205,'RELOAD'),(206,'AUTOCOMMIT'),(207,'REVOKE'),(208,'GRANTS'),(209,'OUTER'),(210,'CURSOR_NAME'),(211,'FLOOR'),(212,'EXPLAIN'),(213,'WITH'),(214,'AFTER'),(215,'STD'),(216,'CSV'),(217,'DISABLE'),(218,'UNINSTALL'),(219,'OUTFILE'),(220,'LOW_PRIORITY'),(221,'FILE'),(222,'NODEGROUP'),(223,'SCHEMA'),(224,'SONAME'),(225,'POW'),(226,'DUAL'),(227,'MULTIPOINTFROMWKB'),(228,'INDEX'),(229,'MULTIPOINTFROMTEXT'),(230,'DEFINER'),(231,'MASTER_BIND'),(232,'REMOVE'),(233,'EXTENDED'),(234,'MULTILINESTRINGFROMWKB'),(235,'CROSS'),(236,'CONTRIBUTORS'),(237,'NATIONAL'),(238,'GROUP'),(239,'SHA'),(240,'ONLINE'),(241,'UNDO'),(242,'IGNORE_SERVER_IDS'),(243,'ZEROFILL'),(244,'CLIENT'),(245,'MASTER_PASSWORD'),(246,'OWNER'),(247,'RELAY_LOG_FILE'),(248,'TRUE'),(249,'CHARACTER'),(250,'MASTER_USER'),(251,'SCHEMA_NAME'),(252,'TABLE'),(253,'ENGINE'),(254,'INSERT_METHOD'),(255,'CASCADE'),(256,'RELAY_LOG_POS'),(257,'SQL_CALC_FOUND_ROWS'),(258,'UNION'),(259,'MYISAM'),(260,'LEAVE'),(261,'MODIFY'),(262,'MATCH'),(263,'MASTER_LOG_POS'),(264,'DISTINCTROW'),(265,'DESC'),(266,'TIME'),(267,'NUMERIC'),(268,'EXPANSION'),(269,'CODE'),(270,'CURSOR'),(271,'GEOMETRYCOLLECTIONFROMTEXT'),(272,'CHAIN'),(273,'LOGFILE'),(274,'FLUSH'),(275,'CREATE'),(276,'DESCRIBE'),(277,'EXTENT_SIZE'),(278,'MAX_UPDATES_PER_HOUR'),(279,'INT2'),(280,'PROCESSLIST'),(281,'ENDS'),(282,'LOGS'),(283,'DISCARD'),(284,'HEAP'),(285,'SOUNDS'),(286,'BETWEEN'),(287,'MULTILINESTRINGFROMTEXT'),(288,'REPAIR'),(289,'PACK_KEYS'),(290,'FAST'),(291,'VALUES'),(292,'CALL'),(293,'LOOP'),(294,'VARCHARACTER'),(295,'BEFORE'),(296,'TRUNCATE'),(297,'SHOW'),(298,'ALL'),(299,'REDUNDANT'),(300,'USER_RESOURCES'),(301,'PARTIAL'),(302,'BINLOG'),(303,'END'),(304,'SECOND'),(305,'AND'),(306,'FLOAT8'),(307,'PREV'),(308,'HOUR'),(309,'SELECT'),(310,'DATABASES'),(311,'OR'),(312,'IDENTIFIED'),(313,'WRAPPER'),(314,'MASTER_SSL_CIPHER'),(315,'SQL_SLAVE_SKIP_COUNTER'),(316,'BOTH'),(317,'BOOL'),(318,'YEAR'),(319,'MASTER_PORT'),(320,'CONCURRENT'),(321,'HELP'),(322,'UNIQUE'),(323,'TRIGGERS'),(324,'PROCESS'),(325,'OPTIONS'),(326,'RESIGNAL'),(327,'CONSISTENT'),(328,'MASTER_SSL'),(329,'DATE_ADD'),(330,'MAX_CONNECTIONS_PER_HOUR'),(331,'LIKE'),(332,'PLUGIN'),(333,'FETCH'),(334,'IN'),(335,'COLUMN'),(336,'DUMPFILE'),(337,'USAGE'),(338,'EXECUTE'),(339,'MEMORY'),(340,'CEIL'),(341,'QUERY'),(342,'MASTER_HOST'),(343,'LINES'),(344,'SQL_THREAD'),(345,'SERVER'),(346,'MAX_QUERIES_PER_HOUR'),(347,'MASTER_SSL_CERT'),(348,'MULTIPOLYGONFROMWKB'),(349,'TRANSACTION'),(350,'DAY_MINUTE'),(351,'STDDEV'),(352,'DATE_SUB'),(353,'REBUILD'),(354,'GEOMETRYFROMWKB'),(355,'INT1'),(356,'RENAME'),(357,'PARSER'),(358,'RIGHT'),(359,'ALTER'),(360,'MAX_ROWS'),(361,'SOCKET'),(362,'STRAIGHT_JOIN'),(363,'NATURAL'),(364,'VARIABLES'),(365,'ESCAPED'),(366,'SHA1'),(367,'KEY_BLOCK_SIZE'),(368,'PASSWORD'),(369,'OFFSET'),(370,'CHAR'),(371,'NEXT'),(372,'ERRORS'),(373,'SQL_LOG_BIN'),(374,'TEMPORARY'),(375,'COMMITTED'),(376,'SQL_SMALL_RESULT'),(377,'UPGRADE'),(378,'BEGIN'),(379,'DELAY_KEY_WRITE'),(380,'PROFILE'),(381,'MEDIUM'),(382,'INTERVAL'),(383,'SSL'),(384,'DAY_HOUR'),(385,'NAME'),(386,'REFERENCES'),(387,'AES_ENCRYPT'),(388,'STORAGE'),(389,'ISOLATION'),(390,'CEILING'),(391,'EVERY'),(392,'INT8'),(393,'AUTHORS'),(394,'RESTRICT'),(395,'UNCOMMITTED'),(396,'LINESTRINGFROMTEXT'),(397,'IS'),(398,'NOT'),(399,'ANALYSE'),(400,'DATAFILE'),(401,'DES_KEY_FILE'),(402,'SIGNAL'),(403,'COMPRESSED'),(404,'START'),(405,'PLUGINS'),(406,'SAVEPOINT'),(407,'IF'),(408,'ROWS'),(409,'PRIMARY'),(410,'PURGE'),(411,'LAST'),(412,'USER'),(413,'EXIT'),(414,'KEYS'),(415,'LIMIT'),(416,'KEY'),(417,'MERGE'),(418,'UNTIL'),(419,'SQL_NO_CACHE'),(420,'DELAYED'),(421,'CONSTRAINT_SCHEMA'),(422,'ANALYZE'),(423,'CONSTRAINT'),(424,'SERIAL'),(425,'ACTION'),(426,'WRITE'),(427,'INITIAL_SIZE'),(428,'SESSION'),(429,'DATABASE'),(430,'NULL'),(431,'POWER'),(432,'USE_FRM'),(433,'TERMINATED'),(434,'SLAVE'),(435,'NVARCHAR'),(436,'ASC'),(437,'RETURN'),(438,'OPTIONALLY'),(439,'ENABLE'),(440,'DIRECTORY'),(441,'MAX_USER_CONNECTIONS'),(442,'WHILE'),(443,'LOCAL'),(444,'DISTINCT'),(445,'AES_DECRYPT'),(446,'MASTER_SSL_KEY'),(447,'NONE'),(448,'TABLES'),(449,'<>'),(450,'RLIKE'),(451,'TRIGGER'),(452,'COLLATION'),(453,'SHUTDOWN'),(454,'HIGH_PRIORITY'),(455,'BTREE'),(456,'FIRST'),(457,'COALESCE'),(458,'WAIT'),(459,'CATALOG_NAME'),(460,'MASTER'),(461,'FIXED'),(462,'MULTIPOLYGONFROMTEXT'),(463,'ROW_FORMAT');
/*!40000 ALTER TABLE `help_keyword` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_relation`
--

DROP TABLE IF EXISTS `help_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_relation` (
  `help_topic_id` int(10) unsigned NOT NULL,
  `help_keyword_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`help_keyword_id`,`help_topic_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='keyword-topic relation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_relation`
--

LOCK TABLES `help_relation` WRITE;
/*!40000 ALTER TABLE `help_relation` DISABLE KEYS */;
INSERT INTO `help_relation` VALUES (1,0),(356,0),(473,1),(232,2),(447,3),(3,4),(130,4),(421,4),(89,5),(89,6),(406,6),(97,7),(89,8),(185,9),(430,10),(21,11),(347,11),(421,11),(463,11),(468,11),(89,12),(406,12),(146,13),(230,14),(88,15),(356,15),(18,16),(106,16),(134,16),(347,16),(97,17),(500,17),(380,18),(3,19),(104,19),(243,19),(374,19),(459,19),(185,20),(356,21),(9,22),(30,22),(34,22),(87,22),(186,22),(237,22),(263,22),(276,22),(300,22),(331,22),(405,22),(415,22),(416,22),(463,22),(478,22),(108,23),(122,24),(170,24),(424,24),(376,25),(82,26),(104,27),(199,28),(36,29),(347,30),(468,30),(376,31),(199,32),(35,33),(237,33),(36,34),(356,34),(468,35),(417,36),(463,36),(468,36),(21,37),(294,37),(347,37),(451,37),(468,37),(500,38),(48,39),(77,39),(83,39),(130,39),(199,39),(356,39),(361,39),(421,39),(463,39),(468,39),(468,40),(472,40),(376,41),(463,42),(468,42),(212,43),(421,43),(468,43),(473,43),(376,44),(356,45),(97,46),(314,46),(361,47),(374,48),(459,48),(185,49),(48,50),(468,50),(472,50),(1,51),(89,51),(406,51),(472,51),(374,52),(459,52),(176,53),(468,53),(51,54),(106,54),(199,55),(1,56),(55,56),(194,56),(374,57),(459,57),(48,58),(83,58),(106,58),(193,59),(199,59),(249,59),(210,60),(463,60),(89,61),(300,61),(358,61),(406,61),(199,62),(356,63),(1,64),(83,64),(104,64),(130,64),(356,64),(421,64),(463,64),(66,65),(48,66),(417,66),(466,66),(230,67),(87,68),(210,68),(463,68),(199,69),(194,70),(468,71),(91,72),(482,72),(385,73),(447,74),(1,75),(39,76),(230,76),(269,76),(185,77),(269,77),(460,77),(185,78),(463,78),(89,79),(406,79),(376,80),(83,81),(104,81),(356,81),(472,81),(89,82),(406,82),(374,83),(459,83),(3,84),(104,84),(304,84),(356,84),(468,85),(257,86),(194,87),(376,88),(129,89),(146,90),(460,90),(17,91),(189,91),(302,91),(328,91),(347,91),(356,91),(416,91),(439,91),(488,91),(99,92),(188,92),(421,93),(463,93),(88,94),(401,95),(468,95),(69,96),(330,96),(433,96),(285,97),(28,98),(57,98),(85,98),(104,99),(195,99),(301,99),(486,99),(282,100),(347,100),(106,101),(313,101),(473,102),(376,103),(9,104),(30,104),(89,104),(155,104),(186,104),(276,104),(300,104),(347,105),(365,105),(109,106),(146,107),(460,107),(24,108),(88,108),(113,109),(174,109),(3,110),(104,110),(155,110),(200,110),(212,110),(243,110),(463,110),(468,110),(463,111),(115,112),(326,112),(466,112),(470,112),(115,113),(463,113),(374,114),(459,114),(38,115),(119,115),(151,115),(264,115),(374,116),(459,116),(419,117),(124,118),(89,119),(125,119),(406,119),(496,119),(221,120),(3,121),(83,121),(104,121),(129,121),(130,121),(146,121),(155,121),(182,121),(212,121),(333,121),(347,121),(356,121),(374,121),(421,121),(459,121),(463,121),(468,121),(472,121),(477,121),(494,121),(199,122),(132,123),(230,123),(262,123),(376,123),(58,124),(137,124),(215,124),(223,124),(328,124),(336,124),(347,124),(365,124),(210,125),(463,125),(468,125),(89,126),(194,126),(210,126),(406,126),(468,126),(185,127),(1,128),(424,129),(52,130),(185,131),(468,132),(314,133),(199,134),(455,135),(255,136),(285,137),(199,138),(249,138),(463,139),(57,140),(85,140),(237,141),(52,142),(324,142),(57,143),(85,143),(199,144),(313,145),(48,146),(122,146),(347,146),(356,146),(424,146),(455,146),(36,147),(106,147),(447,147),(1,148),(28,149),(376,150),(468,151),(209,152),(180,153),(313,153),(347,153),(356,153),(420,153),(330,154),(347,154),(468,155),(97,156),(180,157),(421,158),(34,159),(68,159),(97,159),(211,159),(233,159),(302,159),(336,159),(347,159),(393,159),(405,159),(416,159),(97,160),(347,161),(421,161),(252,162),(468,163),(463,164),(468,164),(60,165),(194,165),(463,165),(478,165),(176,166),(168,167),(194,168),(415,168),(463,168),(478,168),(30,169),(159,169),(454,169),(447,170),(130,171),(421,171),(190,172),(48,173),(83,173),(356,173),(361,173),(463,173),(1,174),(48,174),(86,174),(374,175),(459,175),(252,176),(199,177),(249,177),(24,178),(128,178),(168,178),(209,178),(230,178),(314,178),(500,178),(97,179),(156,179),(230,179),(411,180),(347,181),(463,182),(468,182),(472,182),(473,182),(101,183),(151,183),(304,183),(145,184),(347,184),(374,185),(459,185),(146,186),(160,187),(347,187),(455,188),(146,189),(374,190),(459,190),(180,191),(200,191),(313,191),(420,191),(304,192),(421,192),(356,193),(230,194),(377,194),(468,195),(155,196),(212,196),(468,196),(395,197),(465,198),(129,199),(137,199),(182,199),(349,199),(447,199),(452,200),(57,201),(85,201),(356,202),(1,203),(36,203),(356,203),(421,204),(199,205),(146,206),(249,207),(192,208),(347,208),(1,209),(374,210),(459,210),(221,211),(255,212),(88,213),(199,213),(210,213),(463,213),(468,213),(463,214),(260,215),(421,216),(468,216),(89,217),(406,217),(463,217),(291,218),(356,219),(3,220),(36,220),(48,220),(83,220),(104,220),(130,220),(421,220),(199,221),(194,222),(155,223),(186,223),(212,223),(309,223),(347,223),(97,224),(277,225),(279,226),(464,227),(1,228),(60,228),(87,228),(101,228),(210,228),(304,228),(308,228),(347,228),(463,228),(468,228),(425,229),(89,230),(406,230),(185,231),(463,232),(255,233),(466,233),(272,234),(1,235),(7,236),(347,236),(257,237),(430,237),(194,238),(226,238),(356,238),(427,239),(87,240),(210,240),(463,240),(313,241),(185,242),(24,243),(128,243),(168,243),(209,243),(314,243),(500,243),(199,244),(185,245),(473,246),(185,247),(385,248),(130,249),(155,249),(212,249),(257,249),(333,249),(347,249),(356,249),(421,249),(430,249),(468,249),(185,250),(374,251),(459,251),(60,252),(110,252),(115,252),(215,252),(276,252),(278,252),(321,252),(347,252),(401,252),(417,252),(463,252),(466,252),(468,252),(470,252),(194,253),(347,253),(365,253),(415,253),(463,253),(468,253),(478,253),(468,254),(30,255),(276,255),(468,255),(472,255),(185,256),(356,257),(305,258),(468,259),(310,260),(463,261),(88,262),(185,263),(356,264),(329,265),(356,265),(361,265),(230,266),(315,266),(375,266),(209,267),(88,268),(68,269),(488,269),(420,270),(246,271),(146,272),(194,273),(226,273),(151,274),(326,274),(17,275),(22,275),(60,275),(77,275),(89,275),(97,275),(155,275),(194,275),(210,275),(211,275),(278,275),(302,275),(309,275),(347,275),(358,275),(393,275),(454,275),(468,275),(473,275),(329,276),(194,277),(199,278),(234,279),(347,280),(451,280),(89,281),(39,282),(269,282),(347,282),(463,283),(468,284),(378,285),(147,286),(107,287),(463,288),(466,288),(468,289),(417,290),(3,291),(104,291),(339,292),(344,293),(257,294),(269,295),(321,296),(463,296),(7,297),(10,297),(17,297),(21,297),(25,297),(33,297),(39,297),(58,297),(68,297),(69,297),(82,297),(122,297),(134,297),(137,297),(145,297),(160,297),(170,297),(192,297),(193,297),(215,297),(223,297),(278,297),(282,297),(294,297),(308,297),(309,297),(328,297),(330,297),(333,297),(336,297),(347,297),(349,297),(358,297),(365,297),(393,297),(424,297),(451,297),(487,297),(488,297),(492,297),(38,298),(199,298),(249,298),(305,298),(356,298),(468,299),(326,300),(468,301),(122,302),(350,302),(28,303),(57,303),(85,303),(232,303),(327,303),(344,303),(496,303),(376,304),(147,305),(316,305),(314,306),(106,307),(376,308),(3,309),(104,309),(255,309),(301,309),(356,309),(160,310),(347,310),(141,311),(77,312),(130,312),(199,312),(473,313),(185,314),(182,315),(455,316),(24,317),(111,317),(376,318),(185,319),(130,320),(421,320),(118,321),(390,321),(463,322),(25,323),(347,323),(199,324),(373,325),(473,325),(374,326),(146,327),(185,328),(376,329),(199,330),(347,331),(378,331),(291,332),(347,332),(419,332),(383,333),(88,334),(122,334),(356,334),(424,334),(463,335),(356,336),(199,337),(86,338),(199,338),(356,339),(397,340),(88,341),(151,341),(176,341),(185,342),(130,343),(421,343),(52,344),(324,344),(9,345),(373,345),(473,345),(199,346),(185,347),(123,348),(146,349),(447,349),(376,350),(407,351),(376,352),(463,353),(144,354),(24,355),(110,356),(222,356),(406,356),(463,356),(210,357),(463,357),(468,357),(1,358),(60,359),(159,359),(199,359),(212,359),(226,359),(233,359),(373,359),(406,359),(439,359),(463,359),(478,359),(463,360),(468,360),(473,361),(1,362),(356,362),(1,363),(347,364),(349,364),(421,365),(427,366),(468,367),(77,368),(199,368),(473,368),(477,368),(356,369),(230,370),(465,370),(106,371),(69,372),(347,372),(494,373),(276,374),(447,375),(356,376),(212,377),(417,377),(146,378),(327,378),(468,379),(487,380),(417,381),(89,382),(376,382),(199,383),(376,384),(212,385),(199,386),(468,386),(472,386),(443,387),(282,388),(447,389),(448,390),(89,391),(128,392),(10,393),(347,393),(30,394),(276,394),(472,394),(447,395),(56,396),(84,397),(206,397),(368,397),(456,397),(84,398),(89,398),(155,398),(206,398),(312,398),(189,399),(194,400),(478,400),(326,401),(459,402),(468,403),(146,404),(324,404),(33,405),(460,406),(9,407),(28,407),(30,407),(89,407),(155,407),(186,407),(276,407),(300,407),(479,407),(130,408),(463,409),(269,410),(106,411),(77,412),(222,412),(331,412),(473,412),(313,413),(308,414),(347,414),(463,414),(48,415),(83,415),(106,415),(122,415),(356,415),(424,415),(60,416),(104,416),(463,416),(468,416),(472,416),(468,417),(232,418),(356,419),(3,420),(104,420),(486,420),(374,421),(459,421),(463,422),(470,422),(463,423),(468,423),(243,424),(468,424),(468,425),(472,425),(36,426),(194,427),(478,427),(129,428),(137,428),(349,428),(447,428),(155,429),(186,429),(212,429),(309,429),(347,429),(473,429),(84,430),(368,430),(472,430),(483,431),(466,432),(421,433),(38,434),(52,434),(89,434),(145,434),(223,434),(324,434),(406,434),(257,435),(356,436),(361,436),(491,437),(421,438),(89,439),(406,439),(463,439),(212,440),(468,440),(199,441),(496,442),(36,443),(115,443),(130,443),(326,443),(421,443),(466,443),(470,443),(0,444),(96,444),(288,444),(305,444),(356,444),(361,444),(384,444),(433,444),(497,445),(185,446),(199,447),(36,448),(134,448),(294,448),(347,448),(495,449),(27,450),(22,451),(263,451),(347,451),(347,452),(492,452),(199,453),(104,454),(356,454),(210,455),(106,456),(463,456),(468,456),(463,457),(194,458),(478,458),(374,459),(459,459),(39,460),(58,460),(185,460),(264,460),(269,460),(209,461),(468,461),(201,462),(468,463);
/*!40000 ALTER TABLE `help_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_topic`
--

DROP TABLE IF EXISTS `help_topic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_topic` (
  `help_topic_id` int(10) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `help_category_id` smallint(5) unsigned NOT NULL,
  `description` text NOT NULL,
  `example` text NOT NULL,
  `url` text NOT NULL,
  PRIMARY KEY (`help_topic_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help topics';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_topic`
--

LOCK TABLES `help_topic` WRITE;
/*!40000 ALTER TABLE `help_topic` DISABLE KEYS */;
INSERT INTO `help_topic` VALUES (0,'MIN',16,'Syntax:\nMIN([DISTINCT] expr)\n\nReturns the minimum value of expr. MIN() may take a string argument; in\nsuch cases, it returns the minimum string value.\nThe DISTINCT keyword can be used to find the minimum of the distinct values\nof expr, however, this produces the same result as omitting DISTINCT.\n\nMIN() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/min/\n\n','MariaDB> SELECT student_name, MIN(test_score), MAX(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','https://mariadb.com/kb/en/min/'),(1,'JOIN',27,'MySQL supports the following JOIN syntaxes for the table_references\npart of SELECT statements and multiple-table DELETE and UPDATE\nstatements:\n\ntable_references:\n    table_reference [, table_reference] ...\n\ntable_reference:\n    table_factor\n  | join_table\n\ntable_factor:\n    tbl_name [[AS] alias] [index_hint_list]\n  | table_subquery [AS] alias\n  | ( table_references )\n  | { OJ table_reference LEFT OUTER JOIN table_reference\n        ON conditional_expr }\n\njoin_table:\n    table_reference [INNER | CROSS] JOIN table_factor [join_condition]\n  | table_reference STRAIGHT_JOIN table_factor\n  | table_reference STRAIGHT_JOIN table_factor ON conditional_expr\n  | table_reference {LEFT|RIGHT} [OUTER] JOIN table_reference join_condition\n  | table_reference NATURAL [{LEFT|RIGHT} [OUTER]] JOIN table_factor\n\njoin_condition:\n    ON conditional_expr\n  | USING (column_list)\n\nindex_hint_list:\n    index_hint [, index_hint] ...\n\nindex_hint:\n    USE {INDEX|KEY}\n      [FOR {JOIN|ORDER BY|GROUP BY}] ([index_list])\n  | IGNORE {INDEX|KEY}\n      [FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n  | FORCE {INDEX|KEY}\n      [FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n\nindex_list:\n    index_name [, index_name] ...\n\nA table reference is also known as a join expression.\n\nThe syntax of table_factor is extended in comparison with the SQL\nStandard. The latter accepts only table_reference, not a list of them\ninside a pair of parentheses.\n\nThis is a conservative extension if we consider each comma in a list of\ntable_reference items as equivalent to an inner join. For example:\n\nSELECT * FROM t1 LEFT JOIN (t2, t3, t4)\n                 ON (t2.a=t1.a AND t3.b=t1.b AND t4.c=t1.c)\n\nis equivalent to:\n\nSELECT * FROM t1 LEFT JOIN (t2 CROSS JOIN t3 CROSS JOIN t4)\n                 ON (t2.a=t1.a AND t3.b=t1.b AND t4.c=t1.c)\n\nIn MySQL, JOIN, CROSS JOIN, and INNER JOIN are syntactic equivalents\n(they can replace each other). In standard SQL, they are not\nequivalent. INNER JOIN is used with an ON clause, CROSS JOIN is used\notherwise.\n\nIn general, parentheses can be ignored in join expressions containing\nonly inner join operations.\n\nIndex hints can be specified to affect how the MySQL optimizer makes\nuse of indexes. For more information, see\nhttps://mariadb.com/kb/en/how-to-force-query-plans/.\n\nURL: https://mariadb.com/kb/en/join-syntax/\n\n','SELECT left_tbl.*\n  FROM left_tbl LEFT JOIN right_tbl ON left_tbl.id = right_tbl.id\n  WHERE right_tbl.id IS NULL;\n','https://mariadb.com/kb/en/join-syntax/'),(2,'HEX',37,'Syntax:\nHEX(str), HEX(N)\n\nFor a string argument str, HEX() returns a hexadecimal string\nrepresentation of str where each character in str is converted to two\nhexadecimal digits. The inverse of this operation is performed by the\nUNHEX() function.\n\nFor a numeric argument N, HEX() returns a hexadecimal string\nrepresentation of the value of N treated as a longlong (BIGINT) number.\nThis is equivalent to CONV(N,10,16). The inverse of this operation is\nperformed by CONV(HEX(N),16,10).\n\nURL: https://mariadb.com/kb/en/hex/\n\n','MariaDB> SELECT 0x616263, HEX(\'abc\'), UNHEX(HEX(\'abc\'));\n        -> \'abc\', 616263, \'abc\'\nMariaDB> SELECT HEX(255), CONV(HEX(255),16,10);\n        -> \'FF\', 255\n','https://mariadb.com/kb/en/hex/'),(3,'REPLACE',27,'Syntax:\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name [(col_name,...)]\n    {VALUES | VALUE} ({expr | DEFAULT},...),(...),...\n\nOr:\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name\n    SET col_name={expr | DEFAULT}, ...\n\nOr:\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n\nREPLACE works exactly like INSERT, except that if an old row in the\ntable has the same value as a new row for a PRIMARY KEY or a UNIQUE\nindex, the old row is deleted before the new row is inserted. See [HELP\nINSERT].\n\nREPLACE is a MySQL extension to the SQL standard. It either inserts, or\ndeletes and inserts. For another MySQL extension to standard SQL---that\neither inserts or updates---see\nhttps://mariadb.com/kb/en/insert-on-duplicate-key-update/.\n\nNote that unless the table has a PRIMARY KEY or UNIQUE index, using a\nREPLACE statement makes no sense. It becomes equivalent to INSERT,\nbecause there is no index to be used to determine whether a new row\nduplicates another.\n\nValues for all columns are taken from the values specified in the\nREPLACE statement. Any missing columns are set to their default values,\njust as happens for INSERT. You cannot refer to values from the current\nrow and use them in the new row. If you use an assignment such as SET\ncol_name = col_name + 1, the reference to the column name on the right\nhand side is treated as DEFAULT(col_name), so the assignment is\nequivalent to SET col_name = DEFAULT(col_name) + 1.\n\nTo use REPLACE, you must have both the INSERT and DELETE privileges for\nthe table.\n\nURL: https://mariadb.com/kb/en/replace/\n\n','','https://mariadb.com/kb/en/replace/'),(4,'CONTAINS',30,'Contains(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 completely contains g2. This\ntests the opposite relationship as Within().\n\nURL: https://mariadb.com/kb/en/contains/\n\n','','https://mariadb.com/kb/en/contains/'),(5,'SRID',36,'SRID(g)\n\nReturns an integer indicating the Spatial Reference System ID for the\ngeometry value g.\n\nIn MySQL, the SRID value is just an integer associated with the\ngeometry value. All calculations are done assuming Euclidean (planar)\ngeometry.\n\nURL: https://mariadb.com/kb/en/srid/\n\n','MariaDB> SELECT SRID(GeomFromText(\'LineString(1 1,2 2)\',101));\n+-----------------------------------------------+\n| SRID(GeomFromText(\'LineString(1 1,2 2)\',101)) |\n+-----------------------------------------------+\n|                                           101 |\n+-----------------------------------------------+\n','https://mariadb.com/kb/en/srid/'),(6,'CURRENT_TIMESTAMP',31,'Syntax:\nCURRENT_TIMESTAMP, CURRENT_TIMESTAMP()\n\nCURRENT_TIMESTAMP and CURRENT_TIMESTAMP() are synonyms for NOW().\n\nURL: https://mariadb.com/kb/en/current_timestamp/\n\n','','https://mariadb.com/kb/en/current_timestamp/'),(7,'SHOW CONTRIBUTORS',26,'Syntax:\nSHOW CONTRIBUTORS\n\nThe SHOW CONTRIBUTORS statement displays information about the people\nwho contribute to MySQL source or to causes that we support. For each\ncontributor, it displays Name, Location, and Comment values.\n\nURL: https://mariadb.com/kb/en/show-contributors/\n\n','','https://mariadb.com/kb/en/show-contributors/'),(8,'VARIANCE',16,'Syntax:\nVARIANCE(expr)\n\nReturns the population standard variance of expr. This is an extension\nto standard SQL. The standard SQL function VAR_POP() can be used\ninstead.\n\nVARIANCE() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/variance/\n\n','','https://mariadb.com/kb/en/variance/'),(9,'DROP SERVER',39,'Syntax:\nDROP SERVER [ IF EXISTS ] server_name\n\nDrops the server definition for the server named server_name. The\ncorresponding row within the mysql.servers table will be deleted. This\nstatement requires the SUPER privilege.\n\nDropping a server for a table does not affect any FEDERATED tables that\nused this connection information when they were created. See [HELP\nCREATE SERVER].\n\nURL: https://mariadb.com/kb/en/drop-server/\n\n','','https://mariadb.com/kb/en/drop-server/'),(10,'SHOW AUTHORS',26,'Syntax:\nSHOW AUTHORS\n\nThe SHOW AUTHORS statement displays information about the people who\nwork on MySQL. For each author, it displays Name, Location, and Comment\nvalues.\n\nURL: https://mariadb.com/kb/en/show-authors/\n\n','','https://mariadb.com/kb/en/show-authors/'),(11,'VAR_SAMP',16,'Syntax:\nVAR_SAMP(expr)\n\nReturns the sample variance of expr. That is, the denominator is the\nnumber of rows minus one.\n\nVAR_SAMP() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/var_samp/\n\n','','https://mariadb.com/kb/en/var_samp/'),(12,'CONCAT',37,'Syntax:\nCONCAT(str1,str2,...)\n\nReturns the string that results from concatenating the arguments. May\nhave one or more arguments. If all arguments are nonbinary strings, the\nresult is a nonbinary string. If the arguments include any binary\nstrings, the result is a binary string. A numeric argument is converted\nto its equivalent string form. This is a nonbinary string as of MySQL\n5.5.3. Before 5.5.3, it is a binary string; to to avoid that and\nproduce a nonbinary string, you can use an explicit type cast, as in\nthis example:\n\nSELECT CONCAT(CAST(int_col AS CHAR), char_col);\n\nCONCAT() returns NULL if any argument is NULL.\n\nURL: https://mariadb.com/kb/en/concat/\n\n','MariaDB> SELECT CONCAT(\'My\', \'S\', \'QL\');\n        -> \'MySQL\'\nMariaDB> SELECT CONCAT(\'My\', NULL, \'QL\');\n        -> NULL\nMariaDB> SELECT CONCAT(14.3);\n        -> \'14.3\'\n','https://mariadb.com/kb/en/concat/'),(13,'GEOMETRY HIERARCHY',34,'Geometry is the base class. It is an abstract class. The instantiable\nsubclasses of Geometry are restricted to zero-, one-, and\ntwo-dimensional geometric objects that exist in two-dimensional\ncoordinate space. All instantiable geometry classes are defined so that\nvalid instances of a geometry class are topologically closed (that is,\nall defined geometries include their boundary).\n\nThe base Geometry class has subclasses for Point, Curve, Surface, and\nGeometryCollection:\n\no Point represents zero-dimensional objects.\n\no Curve represents one-dimensional objects, and has subclass\n  LineString, with sub-subclasses Line and LinearRing.\n\no Surface is designed for two-dimensional objects and has subclass\n  Polygon.\n\no GeometryCollection has specialized zero-, one-, and two-dimensional\n  collection classes named MultiPoint, MultiLineString, and\n  MultiPolygon for modeling geometries corresponding to collections of\n  Points, LineStrings, and Polygons, respectively. MultiCurve and\n  MultiSurface are introduced as abstract superclasses that generalize\n  the collection interfaces to handle Curves and Surfaces.\n\nGeometry, Curve, Surface, MultiCurve, and MultiSurface are defined as\nnoninstantiable classes. They define a common set of methods for their\nsubclasses and are included for extensibility.\n\nPoint, LineString, Polygon, GeometryCollection, MultiPoint,\nMultiLineString, and MultiPolygon are instantiable classes.\n\nURL: https://mariadb.com/kb/en/geometry-hierarchy/\n\n','','https://mariadb.com/kb/en/geometry-hierarchy/'),(14,'CHAR FUNCTION',37,'Syntax:\nCHAR(N,... [USING charset_name])\n\nCHAR() interprets each argument N as an integer and returns a string\nconsisting of the characters given by the code values of those\nintegers. NULL values are skipped.\nBy default, CHAR() returns a binary string. To produce a string in a\ngiven character set, use the optional USING clause:\n\nMariaDB> SELECT CHARSET(CHAR(0x65)), CHARSET(CHAR(0x65 USING utf8));\n+---------------------+--------------------------------+\n| CHARSET(CHAR(0x65)) | CHARSET(CHAR(0x65 USING utf8)) |\n+---------------------+--------------------------------+\n| binary              | utf8                           |\n+---------------------+--------------------------------+\n\nIf USING is given and the result string is illegal for the given\ncharacter set, a warning is issued. Also, if strict SQL mode is\nenabled, the result from CHAR() becomes NULL.\n\nURL: https://mariadb.com/kb/en/char-function/\n\n','MariaDB> SELECT CHAR(77,121,83,81,\'76\');\n        -> \'MySQL\'\nMariaDB> SELECT CHAR(77,77.3,\'77.3\');\n        -> \'MMM\'\n','https://mariadb.com/kb/en/char-function/'),(15,'DATETIME',22,'DATETIME\n\nA date and time combination. The supported range is \'1000-01-01\n00:00:00\' to \'9999-12-31 23:59:59\'. MySQL displays DATETIME values in\n\'YYYY-MM-DD HH:MM:SS\' format, but permits assignment of values to\nDATETIME columns using either strings or numbers.\n\nURL: https://mariadb.com/kb/en/datetime/\n\n','','https://mariadb.com/kb/en/datetime/'),(16,'SHOW CREATE TRIGGER',26,'Syntax:\nSHOW CREATE TRIGGER trigger_name\n\nThis statement shows a CREATE TRIGGER statement that creates the given\ntrigger.\n\nURL: https://mariadb.com/kb/en/show-create-trigger/\n\n','','https://mariadb.com/kb/en/show-create-trigger/'),(17,'SHOW CREATE PROCEDURE',26,'Syntax:\nSHOW CREATE PROCEDURE proc_name\n\nThis statement is a MySQL extension. It returns the exact string that\ncan be used to re-create the named stored procedure. A similar\nstatement, SHOW CREATE FUNCTION, displays information about stored\nfunctions (see [HELP SHOW CREATE FUNCTION]).\n\nBoth statements require that you be the owner of the routine or have\nSELECT access to the mysql.proc table. If you do not have privileges\nfor the routine itself, the value displayed for the Create Procedure or\nCreate Function field will be NULL.\n\nURL: https://mariadb.com/kb/en/show-create-procedure/\n\n','MariaDB> SHOW CREATE PROCEDURE test.simpleproc\\G\n*************************** 1. row ***************************\n           Procedure: simpleproc\n            sql_mode:\n    Create Procedure: CREATE PROCEDURE `simpleproc`(OUT param1 INT)\n                      BEGIN\n                      SELECT COUNT(*) INTO param1 FROM t;\n                      END\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\nMariaDB> SHOW CREATE FUNCTION test.hello\\G\n*************************** 1. row ***************************\n            Function: hello\n            sql_mode:\n     Create Function: CREATE FUNCTION `hello`(s CHAR(20))\n                      RETURNS CHAR(50)\n                      RETURN CONCAT(\'Hello, \',s,\'!\')\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','https://mariadb.com/kb/en/show-create-procedure/'),(18,'OPEN',23,'Syntax:\nOPEN cursor_name\n\nThis statement opens a previously declared cursor. For an example, see\nhttps://mariadb.com/kb/en/cursor-overview/.\n\nURL: https://mariadb.com/kb/en/open/\n\n','','https://mariadb.com/kb/en/open/'),(19,'INTEGER',22,'INTEGER[(M)] [UNSIGNED] [ZEROFILL]\n\nThis type is a synonym for INT.\n\nURL: https://mariadb.com/kb/en/sql_language-data_types-int\n\n','','https://mariadb.com/kb/en/sql_language-data_types-int'),(20,'LOWER',37,'Syntax:\nLOWER(str)\n\nReturns the string str with all characters changed to lowercase\naccording to the current character set mapping. The default is latin1\n(cp1252 West European).\n\nMariaDB> SELECT LOWER(\'QUADRATICALLY\');\n        -> \'quadratically\'\n\nLOWER() (and UPPER()) are ineffective when applied to binary strings\n(BINARY, VARBINARY, BLOB). To perform lettercase conversion, convert\nthe string to a nonbinary string:\n\nMariaDB> SET @str = BINARY \'New York\';\nMariaDB> SELECT LOWER(@str), LOWER(CONVERT(@str USING latin1));\n+-------------+-----------------------------------+\n| LOWER(@str) | LOWER(CONVERT(@str USING latin1)) |\n+-------------+-----------------------------------+\n| New York    | new york                          |\n+-------------+-----------------------------------+\n\nURL: https://mariadb.com/kb/en/lower/\n\n','','https://mariadb.com/kb/en/lower/'),(21,'SHOW COLUMNS',26,'Syntax:\nSHOW [FULL] COLUMNS {FROM | IN} tbl_name [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW COLUMNS displays information about the columns in a given table.\nIt also works for views. The LIKE clause, if present, indicates which\ncolumn names to match. The WHERE clause can be given to select rows\nusing more general conditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nSHOW COLUMNS displays information only for those columns for which you\nhave some privilege.\n\nMariaDB> SHOW COLUMNS FROM City;\n+------------+----------+------+-----+---------+----------------+\n| Field      | Type     | Null | Key | Default | Extra          |\n+------------+----------+------+-----+---------+----------------+\n| Id         | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name       | char(35) | NO   |     |         |                |\n| Country    | char(3)  | NO   | UNI |         |                |\n| District   | char(20) | YES  | MUL |         |                |\n| Population | int(11)  | NO   |     | 0       |                |\n+------------+----------+------+-----+---------+----------------+\n5 rows in set (0.00 sec)\n\nIf the data types differ from what you expect them to be based on a\nCREATE TABLE statement, note that MySQL sometimes changes data types\nwhen you create or alter a table. The conditions under which this\noccurs are described in\nhttps://mariadb.com/kb/en/silent-column-changes/.\n\nThe FULL keyword causes the output to include the column collation and\ncomments, as well as the privileges you have for each column.\n\nYou can use db_name.tbl_name as an alternative to the tbl_name FROM\ndb_name syntax. In other words, these two statements are equivalent:\n\nMariaDB> SHOW COLUMNS FROM mytable FROM mydb;\nMariaDB> SHOW COLUMNS FROM mydb.mytable;\n\nSHOW COLUMNS displays the following values for each table column:\n\nField indicates the column name.\n\nType indicates the column data type.\n\nCollation indicates the collation for nonbinary string columns, or NULL\nfor other columns. This value is displayed only if you use the FULL\nkeyword.\n\nThe Null field contains YES if NULL values can be stored in the column,\nNO if not.\n\nThe Key field indicates whether the column is indexed:\n\no If Key is empty, the column either is not indexed or is indexed only\n  as a secondary column in a multiple-column, nonunique index.\n\no If Key is PRI, the column is a PRIMARY KEY or is one of the columns\n  in a multiple-column PRIMARY KEY.\n\no If Key is UNI, the column is the first column of a UNIQUE index. (A\n  UNIQUE index permits multiple NULL values, but you can tell whether\n  the column permits NULL by checking the Null field.)\n\no If Key is MUL, the column is the first column of a nonunique index in\n  which multiple occurrences of a given value are permitted within the\n  column.\n\nIf more than one of the Key values applies to a given column of a\ntable, Key displays the one with the highest priority, in the order\nPRI, UNI, MUL.\n\nA UNIQUE index may be displayed as PRI if it cannot contain NULL values\nand there is no PRIMARY KEY in the table. A UNIQUE index may display as\nMUL if several columns form a composite UNIQUE index; although the\ncombination of the columns is unique, each column can still hold\nmultiple occurrences of a given value.\n\nThe Default field indicates the default value that is assigned to the\ncolumn. This is NULL if the column has an explicit default of NULL, or\nif the column definition has no DEFAULT clause.\n\nThe Extra field contains any additional information that is available\nabout a given column. The value is nonempty in these cases:\nauto_increment for columns that have the AUTO_INCREMENT attribute; on\nupdate CURRENT_TIMESTAMP for TIMESTAMP columns that have the ON UPDATE\nCURRENT_TIMESTAMP attribute.\n\nPrivileges indicates the privileges you have for the column. This value\nis displayed only if you use the FULL keyword.\n\nComment indicates any comment the column has. This value is displayed\nonly if you use the FULL keyword.\n\nSHOW FIELDS is a synonym for SHOW COLUMNS. You can also list a table\'s\ncolumns with the mysqlshow db_name tbl_name command.\n\nThe DESCRIBE statement provides information similar to SHOW COLUMNS.\nSee [HELP DESCRIBE].\n\nThe SHOW CREATE TABLE, SHOW TABLE STATUS, and SHOW INDEX statements\nalso provide information about tables. See [HELP SHOW].\n\nURL: https://mariadb.com/kb/en/show-columns/\n\n','','https://mariadb.com/kb/en/show-columns/'),(22,'CREATE TRIGGER',39,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    TRIGGER trigger_name trigger_time trigger_event\n    ON tbl_name FOR EACH ROW trigger_body\n\nThis statement creates a new trigger. A trigger is a named database\nobject that is associated with a table, and that activates when a\nparticular event occurs for the table. The trigger becomes associated\nwith the table named tbl_name, which must refer to a permanent table.\nYou cannot associate a trigger with a TEMPORARY table or a view.\n\nCREATE TRIGGER requires the TRIGGER privilege for the table associated\nwith the trigger. The statement might also require the SUPER privilege,\ndepending on the DEFINER value, as described later in this section. If\nbinary logging is enabled, CREATE TRIGGER might require the SUPER\nprivilege, as described in\nhttps://mariadb.com/kb/en/binary-logging-of-stored-routines/.\n\nThe DEFINER clause determines the security context to be used when\nchecking access privileges at trigger activation time. See later in\nthis section for more information.\n\ntrigger_time is the trigger action time. It can be BEFORE or AFTER to\nindicate that the trigger activates before or after each row to be\nmodified.\n\ntrigger_event indicates the kind of statement that activates the\ntrigger. The trigger_event can be one of the following:\n\no INSERT: The trigger is activated whenever a new row is inserted into\n  the table; for example, through INSERT, LOAD DATA, and REPLACE\n  statements.\n\no UPDATE: The trigger is activated whenever a row is modified; for\n  example, through UPDATE statements.\n\no DELETE: The trigger is activated whenever a row is deleted from the\n  table; for example, through DELETE and REPLACE statements. However,\n  DROP TABLE and TRUNCATE TABLE statements on the table do not activate\n  this trigger, because they do not use DELETE. Dropping a partition\n  does not activate DELETE triggers, either. See [HELP TRUNCATE TABLE].\n\nURL: https://mariadb.com/kb/en/create-trigger/\n\n','','https://mariadb.com/kb/en/create-trigger/'),(23,'MONTH',31,'Syntax:\nMONTH(date)\n\nReturns the month for date, in the range 1 to 12 for January to\nDecember, or 0 for dates such as \'0000-00-00\' or \'2008-00-00\' that have\na zero month part.\n\nURL: https://mariadb.com/kb/en/month/\n\n','MariaDB> SELECT MONTH(\'2008-02-03\');\n        -> 2\n','https://mariadb.com/kb/en/month/'),(24,'TINYINT',22,'TINYINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA very small integer. The signed range is -128 to 127. The unsigned\nrange is 0 to 255.\n\nURL: https://mariadb.com/kb/en/tinyint/\n\n','','https://mariadb.com/kb/en/tinyint/'),(25,'SHOW TRIGGERS',26,'Syntax:\nSHOW TRIGGERS [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TRIGGERS lists the triggers currently defined for tables in a\ndatabase (the default database unless a FROM clause is given). This\nstatement returns results only for databases and tables for which you\nhave the TRIGGER privilege. The LIKE clause, if present, indicates\nwhich table names to match and causes the statement to display triggers\nfor those tables. The WHERE clause can be given to select rows using\nmore general conditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nFor the trigger ins_sum as defined in\nhttps://mariadb.com/kb/en/triggers/, the output of\nthis statement is as shown here:\n\nMariaDB> SHOW TRIGGERS LIKE \'acc%\'\\G\n*************************** 1. row ***************************\n             Trigger: ins_sum\n               Event: INSERT\n               Table: account\n           Statement: SET @sum = @sum + NEW.amount\n              Timing: BEFORE\n             Created: NULL\n            sql_mode:\n             Definer: myname@localhost\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\ncharacter_set_client is the session value of the character_set_client\nsystem variable when the trigger was created. collation_connection is\nthe session value of the collation_connection system variable when the\ntrigger was created. Database Collation is the collation of the\ndatabase with which the trigger is associated.\n\nURL: https://mariadb.com/kb/en/show-triggers/\n\n','','https://mariadb.com/kb/en/show-triggers/'),(26,'MASTER_POS_WAIT',14,'Syntax:\nMASTER_POS_WAIT(log_name,log_pos[,timeout])\n\nThis function is useful for control of master/slave synchronization. It\nblocks until the slave has read and applied all updates up to the\nspecified position in the master log. The return value is the number of\nlog events the slave had to wait for to advance to the specified\nposition. The function returns NULL if the slave SQL thread is not\nstarted, the slave\'s master information is not initialized, the\narguments are incorrect, or an error occurs. It returns -1 if the\ntimeout has been exceeded. If the slave SQL thread stops while\nMASTER_POS_WAIT() is waiting, the function returns NULL. If the slave\nis past the specified position, the function returns immediately.\n\nIf a timeout value is specified, MASTER_POS_WAIT() stops waiting when\ntimeout seconds have elapsed. timeout must be greater than 0; a zero or\nnegative timeout means no timeout.\n\nURL: https://mariadb.com/kb/en/master_pos_wait/\n\n','','https://mariadb.com/kb/en/master_pos_wait/'),(27,'REGEXP',37,'Syntax:\nexpr REGEXP pat, expr RLIKE pat\n\nPerforms a pattern match of a string expression expr against a pattern\npat. The pattern can be an extended regular expression. The syntax for\nregular expressions is discussed in\nhttps://mariadb.com/kb/en/regexp/. Returns 1 if expr\nmatches pat; otherwise it returns 0. If either expr or pat is NULL, the\nresult is NULL. RLIKE is a synonym for REGEXP, provided for mSQL\ncompatibility.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column.\n\n*Note*: Because MySQL uses the C escape syntax in strings (for example,\n\"\\n\" to represent the newline character), you must double any \"\\\" that\nyou use in your REGEXP strings.\n\nREGEXP is not case sensitive, except when used with binary strings.\n\nURL: https://mariadb.com/kb/en/regexp/\n\n','MariaDB> SELECT \'Monty!\' REGEXP \'.*\';\n        -> 1\nMariaDB> SELECT \'new*\\n*line\' REGEXP \'new\\\\*.\\\\*line\';\n        -> 1\nMariaDB> SELECT \'a\' REGEXP \'A\', \'a\' REGEXP BINARY \'A\';\n        -> 1  0\nMariaDB> SELECT \'a\' REGEXP \'^[a-d]\';\n        -> 1\n','https://mariadb.com/kb/en/regexp/'),(28,'IF STATEMENT',23,'Syntax:\nIF search_condition THEN statement_list\n    [ELSEIF search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND IF\n\nThe IF statement for stored programs implements a basic conditional\nconstruct.\n\n*Note*: There is also an IF() function, which differs from the IF\nstatement described here. See\nhttps://mariadb.com/kb/en/if-function/. The\nIF statement can have THEN, ELSE, and ELSEIF clauses, and it is\nterminated with END IF.\n\nIf the search_condition evaluates to true, the corresponding THEN or\nELSEIF clause statement_list executes. If no search_condition matches,\nthe ELSE clause statement_list executes.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nURL: https://mariadb.com/kb/en/if-statement/\n\n','','https://mariadb.com/kb/en/if-statement/'),(29,'^',19,'Syntax:\n^\n\nBitwise XOR:\n\nURL: https://mariadb.com/kb/en/bitwise-xor/\n\n','MariaDB> SELECT 1 ^ 1;\n        -> 0\nMariaDB> SELECT 1 ^ 0;\n        -> 1\nMariaDB> SELECT 11 ^ 3;\n        -> 8\n','https://mariadb.com/kb/en/bitwise-xor/'),(30,'DROP VIEW',39,'Syntax:\nDROP VIEW [IF EXISTS]\n    view_name [, view_name] ...\n    [RESTRICT | CASCADE]\n\nDROP VIEW removes one or more views. You must have the DROP privilege\nfor each view. If any of the views named in the argument list do not\nexist, MySQL returns an error indicating by name which nonexisting\nviews it was unable to drop, but it also drops all of the views in the\nlist that do exist.\n\nThe IF EXISTS clause prevents an error from occurring for views that\ndon\'t exist. When this clause is given, a NOTE is generated for each\nnonexistent view. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE, if given, are parsed and ignored.\n\nURL: https://mariadb.com/kb/en/drop-view/\n\n','','https://mariadb.com/kb/en/drop-view/'),(31,'WITHIN',30,'Within(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially within g2. This\ntests the opposite relationship as Contains().\n\nURL: https://mariadb.com/kb/en/within/\n\n','','https://mariadb.com/kb/en/within/'),(32,'WEEK',31,'Syntax:\nWEEK(date[,mode])\n\nThis function returns the week number for date. The two-argument form\nof WEEK() enables you to specify whether the week starts on Sunday or\nMonday and whether the return value should be in the range from 0 to 53\nor from 1 to 53. If the mode argument is omitted, the value of the\ndefault_week_format system variable is used. See\nhttps://mariadb.com/kb/en/server-system-variables/.\n\nURL: https://mariadb.com/kb/en/week/\n\n','MariaDB> SELECT WEEK(\'2008-02-20\');\n        -> 7\nMariaDB> SELECT WEEK(\'2008-02-20\',0);\n        -> 7\nMariaDB> SELECT WEEK(\'2008-02-20\',1);\n        -> 8\nMariaDB> SELECT WEEK(\'2008-12-31\',1);\n        -> 53\n','https://mariadb.com/kb/en/week/'),(33,'SHOW PLUGINS',26,'Syntax:\nSHOW PLUGINS\n\nSHOW PLUGINS displays information about server plugins. Plugin\ninformation is also available in the INFORMATION_SCHEMA.PLUGINS table.\nSee https://mariadb.com/kb/en/information_schemaplugins-table/.\n\nExample of SHOW PLUGINS output:\n\nMariaDB> SHOW PLUGINS\\G\n*************************** 1. row ***************************\n   Name: binlog\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 2. row ***************************\n   Name: CSV\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 3. row ***************************\n   Name: MEMORY\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 4. row ***************************\n   Name: MyISAM\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n...\n\nURL: https://mariadb.com/kb/en/show-plugins/\n\n','','https://mariadb.com/kb/en/show-plugins/'),(34,'DROP FUNCTION UDF',21,'Syntax:\nDROP FUNCTION function_name\n\nThis statement drops the user-defined function (UDF) named\nfunction_name.\n\nTo drop a function, you must have the DELETE privilege for the mysql\ndatabase. This is because DROP FUNCTION removes a row from the\nmysql.func system table that records the function\'s name, type, and\nshared library name.\n\nURL: https://mariadb.com/kb/en/drop-function-udf/\n\n','','https://mariadb.com/kb/en/drop-function-udf/'),(35,'PREPARE',8,'Syntax:\nPREPARE stmt_name FROM preparable_stmt\n\nThe PREPARE statement prepares a statement and assigns it a name,\nstmt_name, by which to refer to the statement later. Statement names\nare not case sensitive. preparable_stmt is either a string literal or a\nuser variable that contains the text of the statement. The text must\nrepresent a single SQL statement, not multiple statements. Within the\nstatement, \"?\" characters can be used as parameter markers to indicate\nwhere data values are to be bound to the query later when you execute\nit. The \"?\" characters should not be enclosed within quotation marks,\neven if you intend to bind them to string values. Parameter markers can\nbe used only where data values should appear, not for SQL keywords,\nidentifiers, and so forth.\n\nIf a prepared statement with the given name already exists, it is\ndeallocated implicitly before the new statement is prepared. This means\nthat if the new statement contains an error and cannot be prepared, an\nerror is returned and no statement with the given name exists.\n\nA prepared statement is executed with EXECUTE and released with\nDEALLOCATE PREPARE.\n\nThe scope of a prepared statement is the session within which it is\ncreated. Other sessions cannot see it.\n\nURL: https://mariadb.com/kb/en/prepare-statement/\n\n','','https://mariadb.com/kb/en/prepare-statement/'),(36,'LOCK',8,'Syntax:\nLOCK TABLES\n    tbl_name [[AS] alias] lock_type\n    [, tbl_name [[AS] alias] lock_type] ...\n\nlock_type:\n    READ [LOCAL]\n  | [LOW_PRIORITY] WRITE\n\nUNLOCK TABLES\n\nMySQL enables client sessions to acquire table locks explicitly for the\npurpose of cooperating with other sessions for access to tables, or to\nprevent other sessions from modifying tables during periods when a\nsession requires exclusive access to them. A session can acquire or\nrelease locks only for itself. One session cannot acquire locks for\nanother session or release locks held by another session.\n\nLocks may be used to emulate transactions or to get more speed when\nupdating tables. This is explained in more detail later in this\nsection.\n\nLOCK TABLES explicitly acquires table locks for the current client\nsession. Table locks can be acquired for base tables or views. You must\nhave the LOCK TABLES privilege, and the SELECT privilege for each\nobject to be locked.\n\nFor view locking, LOCK TABLES adds all base tables used in the view to\nthe set of tables to be locked and locks them automatically. If you\nlock a table explicitly with LOCK TABLES, any tables used in triggers\nare also locked implicitly, as described in\nhttps://mariadb.com/kb/en/triggers-and-implicit-locks/.\n\nUNLOCK TABLES explicitly releases any table locks held by the current\nsession. LOCK TABLES implicitly releases any table locks held by the\ncurrent session before acquiring new locks.\n\nAnother use for UNLOCK TABLES is to release the global read lock\nacquired with the FLUSH TABLES WITH READ LOCK statement, which enables\nyou to lock all tables in all databases. See [HELP FLUSH]. (This is a\nvery convenient way to get backups if you have a file system such as\nVeritas that can take snapshots in time.)\n\nURL: https://mariadb.com/kb/en/transactions-lock/\n\n','','https://mariadb.com/kb/en/transactions-lock/'),(37,'UPDATEXML',37,'Syntax:\nUpdateXML(xml_target, xpath_expr, new_xml)\n\nThis function replaces a single portion of a given fragment of XML\nmarkup xml_target with a new XML fragment new_xml, and then returns the\nchanged XML. The portion of xml_target that is replaced matches an\nXPath expression xpath_expr supplied by the user. In MySQL 5.5, the\nXPath expression can contain at most 127 characters. (This limitation\nis lifted in MySQL 5.6.)\n\nIf no expression matching xpath_expr is found, or if multiple matches\nare found, the function returns the original xml_target XML fragment.\nAll three arguments should be strings.\n\nURL: https://mariadb.com/kb/en/updatexml/\n\n','MariaDB> SELECT\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a\', \'<e>fff</e>\') AS val1,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/b\', \'<e>fff</e>\') AS val2,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'//b\', \'<e>fff</e>\') AS val3,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val4,\n    ->   UpdateXML(\'<a><d></d><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val5\n    -> \\G\n\n*************************** 1. row ***************************\nval1: <e>fff</e>\nval2: <a><b>ccc</b><d></d></a>\nval3: <a><e>fff</e><d></d></a>\nval4: <a><b>ccc</b><e>fff</e></a>\nval5: <a><d></d><b>ccc</b><d></d></a>\n','https://mariadb.com/kb/en/updatexml/'),(38,'RESET SLAVE',8,'Syntax:\nRESET SLAVE [ALL]\n\nRESET SLAVE makes the slave forget its replication position in the\nmaster\'s binary log. This statement is meant to be used for a clean\nstart: It deletes the master.info and relay-log.info files, all the\nrelay log files, and starts a new relay log file. To use RESET SLAVE,\nthe slave replication threads must be stopped (use STOP SLAVE if\nnecessary).\n\n*Note*: All relay log files are deleted, even if they have not been\ncompletely executed by the slave SQL thread. (This is a condition\nlikely to exist on a replication slave if you have issued a STOP SLAVE\nstatement or if the slave is highly loaded.)\n\nIn MySQL 5.5 (unlike the case in MySQL 5.1 and earlier), RESET SLAVE\ndoes not change any replication connection parameters such as master\nhost, master port, master user, or master password, which are retained\nin memory. This means that START SLAVE can be issued without requiring\na CHANGE MASTER TO statement following RESET SLAVE.\n\nIn MySQL 5.5.16 and later, you can use RESET SLAVE ALL to reset these\nconnection parameters (Bug #11809016). Connection parameters are also\nreset if the slave mysqld is shut down.\n\nIf the slave SQL thread was in the middle of replicating temporary\ntables when it was stopped, and RESET SLAVE is issued, these replicated\ntemporary tables are deleted on the slave.\n\nURL: https://mariadb.com/kb/en/reset-slave-connection_name/\n\n','','https://mariadb.com/kb/en/reset-slave-connection_name/'),(39,'SHOW BINARY LOGS',26,'Syntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [HELP PURGE BINARY LOGS], that shows\nhow to determine which logs can be purged.\n\nMariaDB> SHOW BINARY LOGS;\n+---------------+-----------+\n| Log_name      | File_size |\n+---------------+-----------+\n| binlog.000015 |    724935 |\n| binlog.000016 |    733481 |\n+---------------+-----------+\n\nURL: https://mariadb.com/kb/en/show-binary-logs/\n\n','','https://mariadb.com/kb/en/show-binary-logs/'),(40,'POLYGON',24,'Polygon(ls1,ls2,...)\n\nConstructs a Polygon value from a number of LineString or WKB\nLineString arguments. If any argument does not represent a LinearRing\n(that is, not a closed and simple LineString), the return value is\nNULL.\n\nURL: https://mariadb.com/kb/en/polygon/\n\n','','https://mariadb.com/kb/en/polygon/'),(41,'MINUTE',31,'Syntax:\nMINUTE(time)\n\nReturns the minute for time, in the range 0 to 59.\n\nURL: https://mariadb.com/kb/en/minute/\n\n','MariaDB> SELECT MINUTE(\'2008-02-03 10:05:03\');\n        -> 5\n','https://mariadb.com/kb/en/minute/'),(42,'DAY',31,'Syntax:\nDAY(date)\n\nDAY() is a synonym for DAYOFMONTH().\n\nURL: https://mariadb.com/kb/en/day/\n\n','','https://mariadb.com/kb/en/day/'),(43,'MID',37,'Syntax:\nMID(str,pos,len)\n\nMID(str,pos,len) is a synonym for SUBSTRING(str,pos,len).\n\nURL: https://mariadb.com/kb/en/mid/\n\n','','https://mariadb.com/kb/en/mid/'),(44,'UUID',14,'Syntax:\nUUID()\n\nReturns a Universal Unique Identifier (UUID) generated according to\n\"DCE 1.1: Remote Procedure Call\" (Appendix A) CAE (Common Applications\nEnvironment) Specifications published by The Open Group in October 1997\n(Document Number C706,\nhttp://www.opengroup.org/public/pubs/catalog/c706.htm).\n\nA UUID is designed as a number that is globally unique in space and\ntime. Two calls to UUID() are expected to generate two different\nvalues, even if these calls are performed on two separate computers\nthat are not connected to each other.\n\nA UUID is a 128-bit number represented by a utf8 string of five\nhexadecimal numbers in aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee format:\n\no The first three numbers are generated from a timestamp.\n\no The fourth number preserves temporal uniqueness in case the timestamp\n  value loses monotonicity (for example, due to daylight saving time).\n\no The fifth number is an IEEE 802 node number that provides spatial\n  uniqueness. A random number is substituted if the latter is not\n  available (for example, because the host computer has no Ethernet\n  card, or we do not know how to find the hardware address of an\n  interface on your operating system). In this case, spatial uniqueness\n  cannot be guaranteed. Nevertheless, a collision should have very low\n  probability.\n\n  Currently, the MAC address of an interface is taken into account only\n  on FreeBSD and Linux. On other operating systems, MySQL uses a\n  randomly generated 48-bit number.\n\nURL: https://mariadb.com/kb/en/uuid/\n\n','MariaDB> SELECT UUID();\n        -> \'6ccd780c-baba-1026-9564-0040f4311e29\'\n','https://mariadb.com/kb/en/uuid/'),(45,'LINESTRING',24,'LineString(pt1,pt2,...)\n\nConstructs a LineString value from a number of Point or WKB Point\narguments. If the number of arguments is less than two, the return\nvalue is NULL.\n\nURL: https://mariadb.com/kb/en/linestring/\n\n','','https://mariadb.com/kb/en/linestring/'),(46,'SLEEP',14,'Syntax:\nSLEEP(duration)\n\nSleeps (pauses) for the number of seconds given by the duration\nargument, then returns 0. If SLEEP() is interrupted, it returns 1. The\nduration may have a fractional part given in microseconds.\n\nURL: https://mariadb.com/kb/en/sleep/\n\n','','https://mariadb.com/kb/en/sleep/'),(47,'CONNECTION_ID',17,'Syntax:\nCONNECTION_ID()\n\nReturns the connection ID (thread ID) for the connection. Every\nconnection has an ID that is unique among the set of currently\nconnected clients.\n\nURL: https://mariadb.com/kb/en/connection_id/\n\n','MariaDB> SELECT CONNECTION_ID();\n        -> 23786\n','https://mariadb.com/kb/en/connection_id/'),(48,'DELETE',27,'Syntax:\nSingle-table syntax:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE] FROM tbl_name\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nMultiple-table syntax:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    tbl_name[.*] [, tbl_name[.*]] ...\n    FROM table_references\n    [WHERE where_condition]\n\nOr:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    FROM tbl_name[.*] [, tbl_name[.*]] ...\n    USING table_references\n    [WHERE where_condition]\n\nFor the single-table syntax, the DELETE statement deletes rows from\ntbl_name and returns a count of the number of deleted rows. This count\ncan be obtained by calling the ROW_COUNT() function (see\nhttps://mariadb.com/kb/en/information-functions-row_count/). The\nWHERE clause, if given, specifies the conditions that identify which\nrows to delete. With no WHERE clause, all rows are deleted. If the\nORDER BY clause is specified, the rows are deleted in the order that is\nspecified. The LIMIT clause places a limit on the number of rows that\ncan be deleted.\n\nFor the multiple-table syntax, DELETE deletes from each tbl_name the\nrows that satisfy the conditions. In this case, ORDER BY and LIMIT\ncannot be used.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe deleted. It is specified as described in\nhttps://mariadb.com/kb/en/select/.\n\nCurrently, you cannot delete from a table and select from the same\ntable in a subquery.\n\nYou need the DELETE privilege on a table to delete rows from it. You\nneed only the SELECT privilege for any columns that are only read, such\nas those named in the WHERE clause.\n\nAs stated, a DELETE statement with no WHERE clause deletes all rows. A\nfaster way to do this, when you do not need to know the number of\ndeleted rows, is to use TRUNCATE TABLE. However, within a transaction\nor if you have a lock on the table, TRUNCATE TABLE cannot be used\nwhereas DELETE can. See [HELP TRUNCATE TABLE], and [HELP LOCK].\n\nURL: https://mariadb.com/kb/en/delete/\n\n','','https://mariadb.com/kb/en/delete/'),(49,'ROUND',4,'Syntax:\nROUND(X), ROUND(X,D)\n\nRounds the argument X to D decimal places. The rounding algorithm\ndepends on the data type of X. D defaults to 0 if not specified. D can\nbe negative to cause D digits left of the decimal point of the value X\nto become zero.\n\nURL: https://mariadb.com/kb/en/round/\n\n','MariaDB> SELECT ROUND(-1.23);\n        -> -1\nMariaDB> SELECT ROUND(-1.58);\n        -> -2\nMariaDB> SELECT ROUND(1.58);\n        -> 2\nMariaDB> SELECT ROUND(1.298, 1);\n        -> 1.3\nMariaDB> SELECT ROUND(1.298, 0);\n        -> 1\nMariaDB> SELECT ROUND(23.298, -1);\n        -> 20\n','https://mariadb.com/kb/en/round/'),(50,'NULLIF',7,'Syntax:\nNULLIF(expr1,expr2)\n\nReturns NULL if expr1 = expr2 is true, otherwise returns expr1. This is\nthe same as CASE WHEN expr1 = expr2 THEN NULL ELSE expr1 END.\n\nURL: https://mariadb.com/kb/en/nullif/\n\n','MariaDB> SELECT NULLIF(1,1);\n        -> NULL\nMariaDB> SELECT NULLIF(1,2);\n        -> 1\n','https://mariadb.com/kb/en/nullif/'),(51,'CLOSE',23,'Syntax:\nCLOSE cursor_name\n\nThis statement closes a previously opened cursor. For an example, see\nhttps://mariadb.com/kb/en/cursor-overview/.\n\nAn error occurs if the cursor is not open.\n\nIf not closed explicitly, a cursor is closed at the end of the BEGIN\n... END block in which it was declared.\n\nURL: https://mariadb.com/kb/en/close/\n\n','','https://mariadb.com/kb/en/close/'),(52,'STOP SLAVE',8,'Syntax:\nSTOP SLAVE [thread_types]\n\nthread_types:\n    [thread_type [, thread_type] ... ]\n\nthread_type: IO_THREAD | SQL_THREAD\n\nStops the slave threads. STOP SLAVE requires the SUPER privilege.\nRecommended best practice is to execute STOP SLAVE on the slave before\nstopping the slave server (see\nhttp://dev.mysql.com/doc/refman/5.5/en/server-shutdown.html, for more\ninformation).\n\nWhen using the row-based logging format: You should execute STOP SLAVE\non the slave prior to shutting down the slave server if you are\nreplicating any tables that use a nontransactional storage engine (see\nthe Note later in this section). In MySQL 5.5.9 and later, you can also\nuse STOP SLAVE SQL_THREAD for this purpose.\n\nLike START SLAVE, this statement may be used with the IO_THREAD and\nSQL_THREAD options to name the thread or threads to be stopped.\n\n*Note*: In MySQL 5.5, STOP SLAVE waits until the current replication\nevent group affecting one or more non-transactional tables has finished\nexecuting (if there is any such replication group), or until the user\nissues a KILL QUERY or KILL CONNECTION statement. (Bug #319, Bug\n#38205)\n\nURL: https://mariadb.com/kb/en/stop-slave/\n\n','','https://mariadb.com/kb/en/stop-slave/'),(53,'TIMEDIFF',31,'Syntax:\nTIMEDIFF(expr1,expr2)\n\nTIMEDIFF() returns expr1 - expr2 expressed as a time value. expr1 and\nexpr2 are time or date-and-time expressions, but both must be of the\nsame type.\n\nThe result returned by TIMEDIFF() is limited to the range allowed for\nTIME values. Alternatively, you can use either of the functions\nTIMESTAMPDIFF() and UNIX_TIMESTAMP(), both of which return integers.\n\nURL: https://mariadb.com/kb/en/timediff/\n\n','MariaDB> SELECT TIMEDIFF(\'2000:01:01 00:00:00\',\n    ->                 \'2000:01:01 00:00:00.000001\');\n        -> \'-00:00:00.000001\'\nMariaDB> SELECT TIMEDIFF(\'2008-12-31 23:59:59.000001\',\n    ->                 \'2008-12-30 01:01:01.000002\');\n        -> \'46:58:57.999999\'\n','https://mariadb.com/kb/en/timediff/'),(54,'REPLACE FUNCTION',37,'Syntax:\nREPLACE(str,from_str,to_str)\n\nReturns the string str with all occurrences of the string from_str\nreplaced by the string to_str. REPLACE() performs a case-sensitive\nmatch when searching for from_str.\n\nURL: https://mariadb.com/kb/en/replace-function/\n\n','MariaDB> SELECT REPLACE(\'www.mariadb.org\', \'w\', \'Ww\');\n        -> \'WwWwWw.mariadb.org\'\n','https://mariadb.com/kb/en/replace-function/'),(55,'USE',28,'Syntax:\nUSE db_name\n\nThe USE db_name statement tells MySQL to use the db_name database as\nthe default (current) database for subsequent statements. The database\nremains the default until the end of the session or another USE\nstatement is issued:\n\nUSE db1;\nSELECT COUNT(*) FROM mytable;   # selects from db1.mytable\nUSE db2;\nSELECT COUNT(*) FROM mytable;   # selects from db2.mytable\n\nURL: https://mariadb.com/kb/en/use/\n\n','','https://mariadb.com/kb/en/use/'),(56,'LINEFROMTEXT',3,'LineFromText(wkt[,srid]), LineStringFromText(wkt[,srid])\n\nConstructs a LINESTRING value using its WKT representation and SRID.\n\nURL: https://mariadb.com/kb/en/linefromtext/\n\n','','https://mariadb.com/kb/en/linefromtext/'),(57,'CASE OPERATOR',7,'Syntax:\nCASE value WHEN [compare_value] THEN result [WHEN [compare_value] THEN\nresult ...] [ELSE result] END\n\nCASE WHEN [condition] THEN result [WHEN [condition] THEN result ...]\n[ELSE result] END\n\nThe first version returns the result where value=compare_value. The\nsecond version returns the result for the first condition that is true.\nIf there was no matching result value, the result after ELSE is\nreturned, or NULL if there is no ELSE part.\n\nURL: https://mariadb.com/kb/en/case-operator/\n\n','MariaDB> SELECT CASE 1 WHEN 1 THEN \'one\'\n    ->     WHEN 2 THEN \'two\' ELSE \'more\' END;\n        -> \'one\'\nMariaDB> SELECT CASE WHEN 1>0 THEN \'true\' ELSE \'false\' END;\n        -> \'true\'\nMariaDB> SELECT CASE BINARY \'B\'\n    ->     WHEN \'a\' THEN 1 WHEN \'b\' THEN 2 END;\n        -> NULL\n','https://mariadb.com/kb/en/case-operator/'),(58,'SHOW MASTER STATUS',26,'Syntax:\nSHOW MASTER STATUS\n\nThis statement provides status information about the binary log files\nof the master. It requires either the SUPER or REPLICATION CLIENT\nprivilege.\n\nExample:\n\nMariaDB> SHOW MASTER STATUS;\n+---------------+----------+--------------+------------------+\n| File          | Position | Binlog_Do_DB | Binlog_Ignore_DB |\n+---------------+----------+--------------+------------------+\n| mysql-bin.003 | 73       | test         | manual,mysql     |\n+---------------+----------+--------------+------------------+\n\nURL: https://mariadb.com/kb/en/show-master-status/\n\n','','https://mariadb.com/kb/en/show-master-status/'),(59,'ADDTIME',31,'Syntax:\nADDTIME(expr1,expr2)\n\nADDTIME() adds expr2 to expr1 and returns the result. expr1 is a time\nor datetime expression, and expr2 is a time expression.\n\nURL: https://mariadb.com/kb/en/addtime/\n\n','MariaDB> SELECT ADDTIME(\'2007-12-31 23:59:59.999999\', \'1 1:1:1.000002\');\n        -> \'2008-01-02 01:01:01.000001\'\nMariaDB> SELECT ADDTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'03:00:01.999997\'\n','https://mariadb.com/kb/en/addtime/'),(60,'SPATIAL',34,'For MyISAM tables, MySQL can create spatial indexes using syntax\nsimilar to that for creating regular indexes, but extended with the\nSPATIAL keyword. Currently, columns in spatial indexes must be declared\nNOT NULL. The following examples demonstrate how to create spatial\nindexes:\n\no With CREATE TABLE:\n\nCREATE TABLE geom (g GEOMETRY NOT NULL, SPATIAL INDEX(g)) ENGINE=MyISAM;\n\no With ALTER TABLE:\n\nALTER TABLE geom ADD SPATIAL INDEX(g);\n\no With CREATE INDEX:\n\nCREATE SPATIAL INDEX sp_index ON geom (g);\n\nFor MyISAM tables, SPATIAL INDEX creates an R-tree index. For storage\nengines that support nonspatial indexing of spatial columns, the engine\ncreates a B-tree index. A B-tree index on spatial values will be useful\nfor exact-value lookups, but not for range scans.\n\nFor more information on indexing spatial columns, see [HELP CREATE\nINDEX].\n\nTo drop spatial indexes, use ALTER TABLE or DROP INDEX:\n\no With ALTER TABLE:\n\nALTER TABLE geom DROP INDEX g;\n\no With DROP INDEX:\n\nDROP INDEX sp_index ON geom;\n\nExample: Suppose that a table geom contains more than 32,000\ngeometries, which are stored in the column g of type GEOMETRY. The\ntable also has an AUTO_INCREMENT column fid for storing object ID\nvalues.\n\nURL: https://mariadb.com/kb/en/spatial/\n\n','','https://mariadb.com/kb/en/spatial/'),(61,'TO_SECONDS',31,'Syntax:\nTO_SECONDS(expr)\n\nGiven a date or datetime expr, returns a the number of seconds since\nthe year 0. If expr is not a valid date or datetime value, returns\nNULL.\n\nURL: https://mariadb.com/kb/en/to_seconds/\n\n','MariaDB> SELECT TO_SECONDS(950501);\n        -> 62966505600\nMariaDB> SELECT TO_SECONDS(\'2009-11-29\');\n        -> 63426672000\nMariaDB> SELECT TO_SECONDS(\'2009-11-29 13:43:32\');\n        -> 63426721412\nMariaDB> SELECT TO_SECONDS( NOW() );\n        -> 63426721458\n','https://mariadb.com/kb/en/to_seconds/'),(62,'TIMESTAMPDIFF',31,'Syntax:\nTIMESTAMPDIFF(unit,datetime_expr1,datetime_expr2)\n\nReturns datetime_expr2 - datetime_expr1, where datetime_expr1 and\ndatetime_expr2 are date or datetime expressions. One expression may be\na date and the other a datetime; a date value is treated as a datetime\nhaving the time part \'00:00:00\' where necessary. The unit for the\nresult (an integer) is given by the unit argument. The legal values for\nunit are the same as those listed in the description of the\nTIMESTAMPADD() function.\n\nURL: https://mariadb.com/kb/en/timestampdiff/\n\n','MariaDB> SELECT TIMESTAMPDIFF(MONTH,\'2003-02-01\',\'2003-05-01\');\n        -> 3\nMariaDB> SELECT TIMESTAMPDIFF(YEAR,\'2002-05-01\',\'2001-01-01\');\n        -> -1\nMariaDB> SELECT TIMESTAMPDIFF(MINUTE,\'2003-02-01\',\'2003-05-01 12:05:55\');\n        -> 128885\n','https://mariadb.com/kb/en/timestampdiff/'),(63,'UPPER',37,'Syntax:\nUPPER(str)\n\nReturns the string str with all characters changed to uppercase\naccording to the current character set mapping. The default is latin1\n(cp1252 West European).\n\nMariaDB> SELECT UPPER(\'Hej\');\n        -> \'HEJ\'\n\nSee the description of LOWER() for information that also applies to\nUPPER(), such as information about how to perform lettercase conversion\nof binary strings (BINARY, VARBINARY, BLOB) for which these functions\nare ineffective.\n\nURL: https://mariadb.com/kb/en/upper/\n\n','','https://mariadb.com/kb/en/upper/'),(64,'FROM_UNIXTIME',31,'Syntax:\nFROM_UNIXTIME(unix_timestamp), FROM_UNIXTIME(unix_timestamp,format)\n\nReturns a representation of the unix_timestamp argument as a value in\n\'YYYY-MM-DD HH:MM:SS\' or YYYYMMDDHHMMSS.uuuuuu format, depending on\nwhether the function is used in a string or numeric context. The value\nis expressed in the current time zone. unix_timestamp is an internal\ntimestamp value such as is produced by the UNIX_TIMESTAMP() function.\n\nIf format is given, the result is formatted according to the format\nstring, which is used the same way as listed in the entry for the\nDATE_FORMAT() function.\n\nURL: https://mariadb.com/kb/en/from_unixtime/\n\n','MariaDB> SELECT FROM_UNIXTIME(1196440219);\n        -> \'2007-11-30 10:30:19\'\nMariaDB> SELECT FROM_UNIXTIME(1196440219) + 0;\n        -> 20071130103019.000000\nMariaDB> SELECT FROM_UNIXTIME(UNIX_TIMESTAMP(),\n    ->                      \'%Y %D %M %h:%i:%s %x\');\n        -> \'2007 30th November 10:30:59 2007\'\n','https://mariadb.com/kb/en/from_unixtime/'),(65,'MEDIUMBLOB',22,'MEDIUMBLOB\n\nA BLOB column with a maximum length of 16,777,215 (224 - 1) bytes. Each\nMEDIUMBLOB value is stored using a 3-byte length prefix that indicates\nthe number of bytes in the value.\n\nURL: https://mariadb.com/kb/en/mediumblob/\n\n','','https://mariadb.com/kb/en/mediumblob/'),(66,'SHA2',12,'Syntax:\nSHA2(str, hash_length)\n\nCalculates the SHA-2 family of hash functions (SHA-224, SHA-256,\nSHA-384, and SHA-512). The first argument is the cleartext string to be\nhashed. The second argument indicates the desired bit length of the\nresult, which must have a value of 224, 256, 384, 512, or 0 (which is\nequivalent to 256). If either argument is NULL or the hash length is\nnot one of the permitted values, the return value is NULL. Otherwise,\nthe function result is a hash value containing the desired number of\nbits. See the notes at the beginning of this section about storing hash\nvalues efficiently.\n\nAs of MySQL 5.5.6, the return value is a nonbinary string in the\nconnection character set. Before 5.5.6, the return value is a binary\nstring; see the notes at the beginning of this section about using the\nvalue as a nonbinary string.\n\nURL: https://mariadb.com/kb/en/sha2/\n\n','MariaDB> SELECT SHA2(\'abc\', 224);\n        -> \'23097d223405d8228642a477bda255b32aadbce4bda0b3f7e36c9da7\'\n','https://mariadb.com/kb/en/sha2/'),(67,'IFNULL',7,'Syntax:\nIFNULL(expr1,expr2)\n\nIf expr1 is not NULL, IFNULL() returns expr1; otherwise it returns\nexpr2. IFNULL() returns a numeric or string value, depending on the\ncontext in which it is used.\n\nURL: https://mariadb.com/kb/en/ifnull/\n\n','MariaDB> SELECT IFNULL(1,0);\n        -> 1\nMariaDB> SELECT IFNULL(NULL,10);\n        -> 10\nMariaDB> SELECT IFNULL(1/0,10);\n        -> 10\nMariaDB> SELECT IFNULL(1/0,\'yes\');\n        -> \'yes\'\n','https://mariadb.com/kb/en/ifnull/'),(68,'SHOW FUNCTION CODE',26,'Syntax:\nSHOW FUNCTION CODE func_name\n\nThis statement is similar to SHOW PROCEDURE CODE but for stored\nfunctions. See [HELP SHOW PROCEDURE CODE].\n\nURL: https://mariadb.com/kb/en/show-function-code/\n\n','','https://mariadb.com/kb/en/show-function-code/'),(69,'SHOW ERRORS',26,'Syntax:\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW COUNT(*) ERRORS\n\nThis statement is similar to SHOW WARNINGS, except that it displays\ninformation only for errors, rather than for errors, warnings, and\nnotes.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttps://mariadb.com/kb/en/select/.\n\nThe SHOW COUNT(*) ERRORS statement displays the number of errors. You\ncan also retrieve this number from the error_count variable:\n\nSHOW COUNT(*) ERRORS;\nSELECT @@error_count;\n\nSHOW ERRORS and error_count apply only to errors, not warnings or\nnotes. In other respects, they are similar to SHOW WARNINGS and\nwarning_count. In particular, SHOW ERRORS cannot display information\nfor more than max_error_count messages, and error_count can exceed the\nvalue of max_error_count if the number of errors exceeds\nmax_error_count.\n\nURL: https://mariadb.com/kb/en/show-errors/\n\n','','https://mariadb.com/kb/en/show-errors/'),(70,'LEAST',18,'Syntax:\nLEAST(value1,value2,...)\n\nWith two or more arguments, returns the smallest (minimum-valued)\nargument. The arguments are compared using the following rules:\n\no If any argument is NULL, the result is NULL. No comparison is needed.\n\no If the return value is used in an INTEGER context or all arguments\n  are integer-valued, they are compared as integers.\n\no If the return value is used in a REAL context or all arguments are\n  real-valued, they are compared as reals.\n\no If the arguments comprise a mix of numbers and strings, they are\n  compared as numbers.\n\no If any argument is a nonbinary (character) string, the arguments are\n  compared as nonbinary strings.\n\no In all other cases, the arguments are compared as binary strings.\n\nURL: https://mariadb.com/kb/en/least/\n\n','MariaDB> SELECT LEAST(2,0);\n        -> 0\nMariaDB> SELECT LEAST(34.0,3.0,5.0,767.0);\n        -> 3.0\nMariaDB> SELECT LEAST(\'B\',\'A\',\'C\');\n        -> \'A\'\n','https://mariadb.com/kb/en/least/'),(71,'=',18,'=\n\nEqual:\n\nURL: https://mariadb.com/kb/en/equal/\n\n','MariaDB> SELECT 1 = 0;\n        -> 0\nMariaDB> SELECT \'0\' = 0;\n        -> 1\nMariaDB> SELECT \'0.0\' = 0;\n        -> 1\nMariaDB> SELECT \'0.01\' = 0;\n        -> 0\nMariaDB> SELECT \'.01\' = 0.01;\n        -> 1\n','https://mariadb.com/kb/en/equal/'),(72,'REVERSE',37,'Syntax:\nREVERSE(str)\n\nReturns the string str with the order of the characters reversed.\n\nURL: https://mariadb.com/kb/en/reverse/\n\n','MariaDB> SELECT REVERSE(\'abc\');\n        -> \'cba\'\n','https://mariadb.com/kb/en/reverse/'),(73,'ISNULL',18,'Syntax:\nISNULL(expr)\n\nIf expr is NULL, ISNULL() returns 1, otherwise it returns 0.\n\nURL: https://mariadb.com/kb/en/isnull/\n\n','MariaDB> SELECT ISNULL(1+1);\n        -> 0\nMariaDB> SELECT ISNULL(1/0);\n        -> 1\n','https://mariadb.com/kb/en/isnull/'),(74,'BINARY',22,'BINARY(M)\n\nThe BINARY type is similar to the CHAR type, but stores binary byte\nstrings rather than nonbinary character strings. M represents the\ncolumn length in bytes.\n\nURL: https://mariadb.com/kb/en/binary/\n\n','','https://mariadb.com/kb/en/binary/'),(75,'BLOB DATA TYPE',22,'A BLOB is a binary large object that can hold a variable amount of\ndata. The four BLOB types are TINYBLOB, BLOB, MEDIUMBLOB, and LONGBLOB.\nThese differ only in the maximum length of the values they can hold.\nThe four TEXT types are TINYTEXT, TEXT, MEDIUMTEXT, and LONGTEXT. These\ncorrespond to the four BLOB types and have the same maximum lengths and\nstorage requirements. See\nhttps://mariadb.com/kb/en/data-type-storage-requirements/.\n\nURL: https://mariadb.com/kb/en/sql_language-data_types-blob/\n\n','','https://mariadb.com/kb/en/sql_language-data_types-blob/'),(76,'BOUNDARY',36,'Boundary(g)\n\nReturns a geometry that is the closure of the combinatorial boundary of\nthe geometry value g.\n\nURL: https://mariadb.com/kb/en/boundary/\n\n','','https://mariadb.com/kb/en/boundary/'),(77,'CREATE USER',10,'Syntax:\nCREATE USER user_specification\n    [, user_specification] ...\n\nuser_specification:\n    user\n    [\n        IDENTIFIED BY [PASSWORD] \'password\'\n      | IDENTIFIED WITH auth_plugin [AS \'auth_string\']\n    ]\n\nThe CREATE USER statement creates new MySQL accounts. To use it, you\nmust have the global CREATE USER privilege or the INSERT privilege for\nthe mysql database. For each account, CREATE USER creates a new row in\nthe mysql.user table and assigns the account no privileges. An error\noccurs if the account already exists.\n\nEach account name uses the format described in\nhttps://mariadb.com/kb/en/create-user#account-names. For example:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nThe user specification may indicate how the user should authenticate\nwhen connecting to the server:\n\no To enable the user to connect with no password (which is insecure),\n  include no IDENTIFIED BY clause:\n\nCREATE USER \'jeffrey\'@\'localhost\';\n\n  In this case, the account uses built-in authentication and clients\n  must provide no password.\n\no To assign a password, use IDENTIFIED BY with the literal plaintext\n  password value:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\n\n  The account uses built-in authentication and clients must match the\n  given password.\n\no To avoid specifying the plaintext password if you know its hash value\n  (the value that PASSWORD() would return for the password), specify\n  the hash value preceded by the keyword PASSWORD:\n\nCREATE USER \'jeffrey\'@\'localhost\'\nIDENTIFIED BY PASSWORD \'*90E462C37378CED12064BB3388827D2BA3A9B689\';\n\n  The account uses built-in authentication and clients must match the\n  given password.\n\no To authenticate the account using a specific authentication plugin,\n  use IDENTIFIED WITH, where auth_plugin is the plugin name. It can be\n  an unquoted name or a quoted string literal. \'auth_string\' is an\n  optional quoted string literal to pass to the plugin. The plugin\n  interprets the meaning of the string, so its format is plugin\n  specific. Consult the documentation for a given plugin for\n  information about the authentication string values it accepts.\n\nCREATE USER \'jeffrey\'@\'localhost\'\nIDENTIFIED WITH my_auth_plugin;\n\n  For connections that use this account, the server invokes the named\n  plugin and clients must provide credentials as required for the\n  authentication method that the plugin implements. If the server\n  cannot find the plugin, either at account-creation time or connect\n  time, an error occurs. IDENTIFIED WITH can be used as of MySQL 5.5.7.\n\nThe IDENTIFIED BY and IDENTIFIED WITH clauses are mutually exclusive,\nso at most one of them can be specified for a given user.\n\nFor additional information about setting passwords, see\nhttps://mariadb.com/kb/en/create-user/.\n\nURL: https://mariadb.com/kb/en/create-user/\n\n','','https://mariadb.com/kb/en/create-user/'),(78,'POINT',24,'Point(x,y)\n\nConstructs a Point using its coordinates.\n\nURL: https://mariadb.com/kb/en/point/\n\n','','https://mariadb.com/kb/en/point/'),(79,'CURRENT_USER',17,'Syntax:\nCURRENT_USER, CURRENT_USER()\n\nReturns the user name and host name combination for the MySQL account\nthat the server used to authenticate the current client. This account\ndetermines your access privileges. The return value is a string in the\nutf8 character set.\n\nThe value of CURRENT_USER() can differ from the value of USER().\n\nURL: https://mariadb.com/kb/en/current_user/\n\n','MariaDB> SELECT USER();\n        -> \'davida@localhost\'\nMariaDB> SELECT * FROM mysql.user;\nERROR 1044: Access denied for user \'\'@\'localhost\' to\ndatabase \'mysql\'\nMariaDB> SELECT CURRENT_USER();\n        -> \'@localhost\'\n','https://mariadb.com/kb/en/current_user/'),(80,'LCASE',37,'Syntax:\nLCASE(str)\n\nLCASE() is a synonym for LOWER().\n\nURL: https://mariadb.com/kb/en/lcase/\n\n','','https://mariadb.com/kb/en/lcase/'),(81,'<=',18,'Syntax:\n<=\n\nLess than or equal:\n\nURL: https://mariadb.com/kb/en/less-than-or-equal/\n\n','MariaDB> SELECT 0.1 <= 2;\n        -> 1\n','https://mariadb.com/kb/en/less-than-or-equal/'),(82,'SHOW PROFILES',26,'Syntax:\nSHOW PROFILES\n\nThe SHOW PROFILES statement, together with SHOW PROFILE, displays\nprofiling information that indicates resource usage for statements\nexecuted during the course of the current session. For more\ninformation, see [HELP SHOW PROFILE].\n\nURL: https://mariadb.com/kb/en/show-profiles/\n\n','','https://mariadb.com/kb/en/show-profiles/'),(83,'UPDATE',27,'Syntax:\nSingle-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_reference\n    SET col_name1={expr1|DEFAULT} [, col_name2={expr2|DEFAULT}] ...\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nMultiple-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_references\n    SET col_name1={expr1|DEFAULT} [, col_name2={expr2|DEFAULT}] ...\n    [WHERE where_condition]\n\nFor the single-table syntax, the UPDATE statement updates columns of\nexisting rows in the named table with new values. The SET clause\nindicates which columns to modify and the values they should be given.\nEach value can be given as an expression, or the keyword DEFAULT to set\na column explicitly to its default value. The WHERE clause, if given,\nspecifies the conditions that identify which rows to update. With no\nWHERE clause, all rows are updated. If the ORDER BY clause is\nspecified, the rows are updated in the order that is specified. The\nLIMIT clause places a limit on the number of rows that can be updated.\n\nFor the multiple-table syntax, UPDATE updates rows in each table named\nin table_references that satisfy the conditions. In this case, ORDER BY\nand LIMIT cannot be used.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe updated. For expression syntax, see\nhttp://dev.mysql.com/doc/refman/5.5/en/expressions.html.\n\ntable_references and where_condition are is specified as described in\nhttps://mariadb.com/kb/en/select/.\n\nYou need the UPDATE privilege only for columns referenced in an UPDATE\nthat are actually updated. You need only the SELECT privilege for any\ncolumns that are read but not modified.\n\nThe UPDATE statement supports the following modifiers:\n\no With the LOW_PRIORITY keyword, execution of the UPDATE is delayed\n  until no other clients are reading from the table. This affects only\n  storage engines that use only table-level locking (such as MyISAM,\n  MEMORY, and MERGE).\n\no With the IGNORE keyword, the update statement does not abort even if\n  errors occur during the update. Rows for which duplicate-key\n  conflicts occur are not updated. Rows for which columns are updated\n  to values that would cause data conversion errors are updated to the\n  closest valid values instead.\n\nURL: https://mariadb.com/kb/en/update/\n\n','','https://mariadb.com/kb/en/update/'),(84,'IS NOT NULL',18,'Syntax:\nIS NOT NULL\n\nTests whether a value is not NULL.\n\nURL: https://mariadb.com/kb/en/is-not-null/\n\n','MariaDB> SELECT 1 IS NOT NULL, 0 IS NOT NULL, NULL IS NOT NULL;\n        -> 1, 1, 0\n','https://mariadb.com/kb/en/is-not-null/'),(85,'CASE STATEMENT',23,'Syntax:\nCASE case_value\n    WHEN when_value THEN statement_list\n    [WHEN when_value THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nOr:\n\nCASE\n    WHEN search_condition THEN statement_list\n    [WHEN search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nThe CASE statement for stored programs implements a complex conditional\nconstruct.\n\n*Note*: There is also a CASE expression, which differs from the CASE\nstatement described here. See\nhttps://mariadb.com/kb/en/case-operator/. The\nCASE statement cannot have an ELSE NULL clause, and it is terminated\nwith END CASE instead of END.\n\nFor the first syntax, case_value is an expression. This value is\ncompared to the when_value expression in each WHEN clause until one of\nthem is equal. When an equal when_value is found, the corresponding\nTHEN clause statement_list executes. If no when_value is equal, the\nELSE clause statement_list executes, if there is one.\n\nThis syntax cannot be used to test for equality with NULL because NULL\n= NULL is false. See\nhttps://mariadb.com/kb/en/null-values/.\n\nFor the second syntax, each WHEN clause search_condition expression is\nevaluated until one is true, at which point its corresponding THEN\nclause statement_list executes. If no search_condition is equal, the\nELSE clause statement_list executes, if there is one.\n\nIf no when_value or search_condition matches the value tested and the\nCASE statement contains no ELSE clause, a Case not found for CASE\nstatement error results.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nTo handle situations where no value is matched by any WHEN clause, use\nan ELSE containing an empty BEGIN ... END block, as shown in this\nexample. (The indentation used here in the ELSE clause is for purposes\nof clarity only, and is not otherwise significant.)\n\nDELIMITER |\n\nCREATE PROCEDURE p()\n  BEGIN\n    DECLARE v INT DEFAULT 1;\n\n    CASE v\n      WHEN 2 THEN SELECT v;\n      WHEN 3 THEN SELECT 0;\n      ELSE\n        BEGIN\n        END;\n    END CASE;\n  END;\n  |\n\nURL: https://mariadb.com/kb/en/case-statement/\n\n','','https://mariadb.com/kb/en/case-statement/'),(86,'EXECUTE STATEMENT',8,'Syntax:\nEXECUTE stmt_name\n    [USING @var_name [, @var_name] ...]\n\nAfter preparing a statement with PREPARE, you execute it with an\nEXECUTE statement that refers to the prepared statement name. If the\nprepared statement contains any parameter markers, you must supply a\nUSING clause that lists user variables containing the values to be\nbound to the parameters. Parameter values can be supplied only by user\nvariables, and the USING clause must name exactly as many variables as\nthe number of parameter markers in the statement.\n\nYou can execute a given prepared statement multiple times, passing\ndifferent variables to it or setting the variables to different values\nbefore each execution.\n\nURL: https://mariadb.com/kb/en/execute-statement/\n\n','','https://mariadb.com/kb/en/execute-statement/'),(87,'DROP INDEX',39,'Syntax:\nDROP [ONLINE|OFFLINE] INDEX index_name ON tbl_name\n\nDROP INDEX drops the index named index_name from the table tbl_name.\nThis statement is mapped to an ALTER TABLE statement to drop the index.\nSee [HELP ALTER TABLE].\n\nTo drop a primary key, the index name is always PRIMARY, which must be\nspecified as a quoted identifier because PRIMARY is a reserved word:\n\nDROP INDEX `PRIMARY` ON t;\n\nURL: https://mariadb.com/kb/en/drop-index/\n\n','','https://mariadb.com/kb/en/drop-index/'),(88,'MATCH AGAINST',37,'Syntax:\nMATCH (col1,col2,...) AGAINST (expr [search_modifier])\n\nMySQL has support for full-text indexing and searching:\n\no A full-text index in MySQL is an index of type FULLTEXT.\n\no Full-text indexes can be used only with MyISAM tables, and can be\n  created only for CHAR, VARCHAR, or TEXT columns.\n\no A FULLTEXT index definition can be given in the CREATE TABLE\n  statement when a table is created, or added later using ALTER TABLE\n  or CREATE INDEX.\n\no For large data sets, it is much faster to load your data into a table\n  that has no FULLTEXT index and then create the index after that, than\n  to load data into a table that has an existing FULLTEXT index.\n\nFull-text searching is performed using MATCH() ... AGAINST syntax.\nMATCH() takes a comma-separated list that names the columns to be\nsearched. AGAINST takes a string to search for, and an optional\nmodifier that indicates what type of search to perform. The search\nstring must be a literal string, not a variable or a column name. There\nare three types of full-text searches:\n\no A natural language search interprets the search string as a phrase in\n  natural human language (a phrase in free text). There are no special\n  operators. The stopword list applies. In addition, words that are\n  present in 50% or more of the rows are considered common and do not\n  match.\n\n  Full-text searches are natural language searches if the IN NATURAL\n  LANGUAGE MODE modifier is given or if no modifier is given. For more\n  information, see\n  https://mariadb.com/kb/en/fulltext-index-overview#in-natural-language-mode\n  .\n\no A boolean search interprets the search string using the rules of a\n  special query language. The string contains the words to search for.\n  It can also contain operators that specify requirements such that a\n  word must be present or absent in matching rows, or that it should be\n  weighted higher or lower than usual. Common words such as \"some\" or\n  \"then\" are stopwords and do not match if present in the search\n  string. The IN BOOLEAN MODE modifier specifies a boolean search. For\n  more information, see\n  https://mariadb.com/kb/en/fulltext-index-overview#in-boolean-mode.\n\no A query expansion search is a modification of a natural language\n  search. The search string is used to perform a natural language\n  search. Then words from the most relevant rows returned by the search\n  are added to the search string and the search is done again. The\n  query returns the rows from the second search. The IN NATURAL\n  LANGUAGE MODE WITH QUERY EXPANSION or WITH QUERY EXPANSION modifier\n  specifies a query expansion search. For more information, see\n  https://mariadb.com/kb/en/fulltext-index-overview#with-query-expansion.\n\nURL: https://mariadb.com/kb/en/match-against/\n\n','MariaDB> SELECT id, body, MATCH (title,body) AGAINST\n    -> (\'Security implications of running MySQL as root\'\n    -> IN NATURAL LANGUAGE MODE) AS score\n    -> FROM articles WHERE MATCH (title,body) AGAINST\n    -> (\'Security implications of running MySQL as root\'\n    -> IN NATURAL LANGUAGE MODE);\n+----+-------------------------------------+-----------------+\n| id | body                                | score           |\n+----+-------------------------------------+-----------------+\n|  4 | 1. Never run mysqld as root. 2. ... | 1.5219271183014 |\n|  6 | When configured properly, MySQL ... | 1.3114095926285 |\n+----+-------------------------------------+-----------------+\n2 rows in set (0.00 sec)\n','https://mariadb.com/kb/en/match-against/'),(89,'CREATE EVENT',39,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    EVENT\n    [IF NOT EXISTS]\n    event_name\n    ON SCHEDULE schedule\n    [ON COMPLETION [NOT] PRESERVE]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'comment\']\n    DO event_body;\n\nschedule:\n    AT timestamp [+ INTERVAL interval] ...\n  | EVERY interval\n    [STARTS timestamp [+ INTERVAL interval] ...]\n    [ENDS timestamp [+ INTERVAL interval] ...]\n\ninterval:\n    quantity {YEAR | QUARTER | MONTH | DAY | HOUR | MINUTE |\n              WEEK | SECOND | YEAR_MONTH | DAY_HOUR | DAY_MINUTE |\n              DAY_SECOND | HOUR_MINUTE | HOUR_SECOND | MINUTE_SECOND}\n\nThis statement creates and schedules a new event. The event will not\nrun unless the Event Scheduler is enabled. For information about\nchecking Event Scheduler status and enabling it if necessary, see\nhttps://mariadb.com/kb/en/events/.\n\nCREATE EVENT requires the EVENT privilege for the schema in which the\nevent is to be created. It might also require the SUPER privilege,\ndepending on the DEFINER value, as described later in this section.\n\nThe minimum requirements for a valid CREATE EVENT statement are as\nfollows:\n\no The keywords CREATE EVENT plus an event name, which uniquely\n  identifies the event in a database schema.\n\no An ON SCHEDULE clause, which determines when and how often the event\n  executes.\n\no A DO clause, which contains the SQL statement to be executed by an\n  event.\n\nThis is an example of a minimal CREATE EVENT statement:\n\nCREATE EVENT myevent\n    ON SCHEDULE AT CURRENT_TIMESTAMP + INTERVAL 1 HOUR\n    DO\n      UPDATE myschema.mytable SET mycol = mycol + 1;\n\nThe previous statement creates an event named myevent. This event\nexecutes once---one hour following its creation---by running an SQL\nstatement that increments the value of the myschema.mytable table\'s\nmycol column by 1.\n\nThe event_name must be a valid MySQL identifier with a maximum length\nof 64 characters. Event names are not case sensitive, so you cannot\nhave two events named myevent and MyEvent in the same schema. In\ngeneral, the rules governing event names are the same as those for\nnames of stored routines. See\nhttps://mariadb.com/kb/en/identifier-names/.\n\nAn event is associated with a schema. If no schema is indicated as part\nof event_name, the default (current) schema is assumed. To create an\nevent in a specific schema, qualify the event name with a schema using\nschema_name.event_name syntax.\n\nURL: https://mariadb.com/kb/en/create-event/\n\n','','https://mariadb.com/kb/en/create-event/'),(90,'ABS',4,'Syntax:\nABS(X)\n\nReturns the absolute value of X.\n\nURL: https://mariadb.com/kb/en/abs/\n\n','MariaDB> SELECT ABS(2);\n        -> 2\nMariaDB> SELECT ABS(-32);\n        -> 32\n','https://mariadb.com/kb/en/abs/'),(91,'POLYFROMWKB',32,'PolyFromWKB(wkb[,srid]), PolygonFromWKB(wkb[,srid])\n\nConstructs a POLYGON value using its WKB representation and SRID.\n\nURL: https://mariadb.com/kb/en/polyfromwkb/\n\n','','https://mariadb.com/kb/en/polyfromwkb/'),(92,'NOT LIKE',37,'Syntax:\nexpr NOT LIKE pat [ESCAPE \'escape_char\']\n\nThis is the same as NOT (expr LIKE pat [ESCAPE \'escape_char\']).\n\nURL: https://mariadb.com/kb/en/not-like/\n\n','','https://mariadb.com/kb/en/not-like/'),(93,'SPACE',37,'Syntax:\nSPACE(N)\n\nReturns a string consisting of N space characters.\n\nURL: https://mariadb.com/kb/en/space/\n\n','MariaDB> SELECT SPACE(6);\n        -> \'      \'\n','https://mariadb.com/kb/en/space/'),(94,'MBR DEFINITION',6,'Its MBR (Minimum Bounding Rectangle), or Envelope. This is the bounding\ngeometry, formed by the minimum and maximum (X,Y) coordinates:\n\nURL: https://mariadb.com/kb/en/mbr-definition/\n\n','((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n','https://mariadb.com/kb/en/mbr-definition/'),(95,'GEOMETRYCOLLECTION',24,'GeometryCollection(g1,g2,...)\n\nConstructs a GeometryCollection.\n\nURL: https://mariadb.com/kb/en/geometrycollection/\n\n','','https://mariadb.com/kb/en/geometrycollection/'),(96,'MAX',16,'Syntax:\nMAX([DISTINCT] expr)\n\nReturns the maximum value of expr. MAX() may take a string argument; in\nsuch cases, it returns the maximum string value. See\nhttps://mariadb.com/kb/en/max/. The DISTINCT\nkeyword can be used to find the maximum of the distinct values of expr,\nhowever, this produces the same result as omitting DISTINCT.\n\nMAX() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/max/\n\n','MariaDB> SELECT student_name, MIN(test_score), MAX(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','https://mariadb.com/kb/en/max/'),(97,'CREATE FUNCTION UDF',21,'Syntax:\nCREATE [AGGREGATE] FUNCTION function_name RETURNS {STRING|INTEGER|REAL|DECIMAL}\n    SONAME shared_library_name\n\nA user-defined function (UDF) is a way to extend MySQL with a new\nfunction that works like a native (built-in) MySQL function such as\nABS() or CONCAT().\n\nfunction_name is the name that should be used in SQL statements to\ninvoke the function. The RETURNS clause indicates the type of the\nfunction\'s return value. DECIMAL is a legal value after RETURNS, but\ncurrently DECIMAL functions return string values and should be written\nlike STRING functions.\n\nshared_library_name is the basename of the shared object file that\ncontains the code that implements the function. The file must be\nlocated in the plugin directory. This directory is given by the value\nof the plugin_dir system variable. For more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/udf-compiling.html.\n\nTo create a function, you must have the INSERT privilege for the mysql\ndatabase. This is necessary because CREATE FUNCTION adds a row to the\nmysql.func system table that records the function\'s name, type, and\nshared library name. If you do not have this table, you should run the\nmysql_upgrade command to create it. See\nhttps://mariadb.com/kb/en/mysql_upgrade/.\n\nURL: https://mariadb.com/kb/en/create-function-udf/\n\n','','https://mariadb.com/kb/en/create-function-udf/'),(98,'*',4,'Syntax:\n*\n\nMultiplication:\n\nURL: https://mariadb.com/kb/en/multiplication-operator/\n\n','MariaDB> SELECT 3*5;\n        -> 15\nMariaDB> SELECT 18014398509481984*18014398509481984.0;\n        -> 324518553658426726783156020576256.0\nMariaDB> SELECT 18014398509481984*18014398509481984;\n        -> 0\n','https://mariadb.com/kb/en/multiplication-operator/'),(99,'TIMESTAMP',22,'TIMESTAMP\n\nA timestamp. The range is \'1970-01-01 00:00:01\' UTC to \'2038-01-19\n03:14:07\' UTC. TIMESTAMP values are stored as the number of seconds\nsince the epoch (\'1970-01-01 00:00:00\' UTC). A TIMESTAMP cannot\nrepresent the value \'1970-01-01 00:00:00\' because that is equivalent to\n0 seconds from the epoch and the value 0 is reserved for representing\n\'0000-00-00 00:00:00\', the \"zero\" TIMESTAMP value.\n\nUnless specified otherwise, the first TIMESTAMP column in a table is\ndefined to be automatically set to the date and time of the most recent\nmodification if not explicitly assigned a value. This makes TIMESTAMP\nuseful for recording the timestamp of an INSERT or UPDATE operation.\nYou can also set any TIMESTAMP column to the current date and time by\nassigning it a NULL value, unless it has been defined with the NULL\nattribute to permit NULL values. The automatic initialization and\nupdating to the current date and time can be specified using DEFAULT\nCURRENT_TIMESTAMP and ON UPDATE CURRENT_TIMESTAMP clauses, as described\nin\nhttps://mariadb.com/kb/en/timestamp/.\n\n*Note*: The TIMESTAMP format that was used prior to MySQL 4.1 is not\nsupported in MySQL 5.5; see MySQL 3.23, 4.0, 4.1 Reference Manual for\ninformation regarding the old format.\n\nURL: https://mariadb.com/kb/en/timestamp/\n\n','','https://mariadb.com/kb/en/timestamp/'),(100,'DES_DECRYPT',12,'Syntax:\nDES_DECRYPT(crypt_str[,key_str])\n\nDecrypts a string encrypted with DES_ENCRYPT(). If an error occurs,\nthis function returns NULL.\n\nThis function works only if MySQL has been configured with SSL support.\nSee https://mariadb.com/kb/en/ssl-connections/.\n\nIf no key_str argument is given, DES_DECRYPT() examines the first byte\nof the encrypted string to determine the DES key number that was used\nto encrypt the original string, and then reads the key from the DES key\nfile to decrypt the message. For this to work, the user must have the\nSUPER privilege. The key file can be specified with the --des-key-file\nserver option.\n\nIf you pass this function a key_str argument, that string is used as\nthe key for decrypting the message.\n\nIf the crypt_str argument does not appear to be an encrypted string,\nMySQL returns the given crypt_str.\n\nURL: https://mariadb.com/kb/en/des_decrypt/\n\n','','https://mariadb.com/kb/en/des_decrypt/'),(101,'CACHE INDEX',26,'Syntax:\nCACHE INDEX\n  tbl_index_list [, tbl_index_list] ...\n  [PARTITION (partition_list | ALL)]\n  IN key_cache_name\n\ntbl_index_list:\n  tbl_name [[INDEX|KEY] (index_name[, index_name] ...)]\n\npartition_list:\n  partition_name[, partition_name][, ...]\n\nThe CACHE INDEX statement assigns table indexes to a specific key\ncache. It is used only for MyISAM tables. After the indexes have been\nassigned, they can be preloaded into the cache if desired with LOAD\nINDEX INTO CACHE.\n\nThe following statement assigns indexes from the tables t1, t2, and t3\nto the key cache named hot_cache:\n\nMariaDB> CACHE INDEX t1, t2, t3 IN hot_cache;\n+---------+--------------------+----------+----------+\n| Table   | Op                 | Msg_type | Msg_text |\n+---------+--------------------+----------+----------+\n| test.t1 | assign_to_keycache | status   | OK       |\n| test.t2 | assign_to_keycache | status   | OK       |\n| test.t3 | assign_to_keycache | status   | OK       |\n+---------+--------------------+----------+----------+\n\nURL: https://mariadb.com/kb/en/cache-index/\n\n','','https://mariadb.com/kb/en/cache-index/'),(102,'ENDPOINT',13,'EndPoint(ls)\n\nReturns the Point that is the endpoint of the LineString value ls.\n\nURL: https://mariadb.com/kb/en/endpoint/\n\n','MariaDB> SET @ls = \'LineString(1 1,2 2,3 3)\';\nMariaDB> SELECT AsText(EndPoint(GeomFromText(@ls)));\n+-------------------------------------+\n| AsText(EndPoint(GeomFromText(@ls))) |\n+-------------------------------------+\n| POINT(3 3)                          |\n+-------------------------------------+\n','https://mariadb.com/kb/en/endpoint/'),(103,'COMPRESS',12,'Syntax:\nCOMPRESS(string_to_compress)\n\nCompresses a string and returns the result as a binary string. This\nfunction requires MySQL to have been compiled with a compression\nlibrary such as zlib. Otherwise, the return value is always NULL. The\ncompressed string can be uncompressed with UNCOMPRESS().\n\nURL: https://mariadb.com/kb/en/compress/\n\n','MariaDB> SELECT LENGTH(COMPRESS(REPEAT(\'a\',1000)));\n        -> 21\nMariaDB> SELECT LENGTH(COMPRESS(\'\'));\n        -> 0\nMariaDB> SELECT LENGTH(COMPRESS(\'a\'));\n        -> 13\nMariaDB> SELECT LENGTH(COMPRESS(REPEAT(\'a\',16)));\n        -> 15\n','https://mariadb.com/kb/en/compress/'),(104,'INSERT',27,'Syntax:\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    {VALUES | VALUE} ({expr | DEFAULT},...),(...),...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nOr:\n\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    SET col_name={expr | DEFAULT}, ...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nOr:\n\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nINSERT inserts new rows into an existing table. The INSERT ... VALUES\nand INSERT ... SET forms of the statement insert rows based on\nexplicitly specified values. The INSERT ... SELECT form inserts rows\nselected from another table or tables. INSERT ... SELECT is discussed\nfurther in [HELP INSERT SELECT].\n\nURL: https://mariadb.com/kb/en/insert/\n\n','','https://mariadb.com/kb/en/insert/'),(105,'COUNT',16,'Syntax:\nCOUNT(expr)\n\nReturns a count of the number of non-NULL values of expr in the rows\nretrieved by a SELECT statement. The result is a BIGINT value.\n\nCOUNT() returns 0 if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/count/\n\n','MariaDB> SELECT student.student_name,COUNT(*)\n    ->        FROM student,course\n    ->        WHERE student.student_id=course.student_id\n    ->        GROUP BY student_name;\n','https://mariadb.com/kb/en/count/'),(106,'HANDLER',27,'Syntax:\nHANDLER tbl_name OPEN [ [AS] alias]\n\nHANDLER tbl_name READ index_name { = | <= | >= | < | > } (value1,value2,...)\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ index_name { FIRST | NEXT | PREV | LAST }\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ { FIRST | NEXT }\n    [ WHERE where_condition ] [LIMIT ... ]\n\nHANDLER tbl_name CLOSE\n\nThe HANDLER statement provides direct access to table storage engine\ninterfaces. It is available for MyISAM and InnoDB tables.\n\nURL: https://mariadb.com/kb/en/handler-commands/\n\n','','https://mariadb.com/kb/en/handler-commands/'),(107,'MLINEFROMTEXT',3,'MLineFromText(wkt[,srid]), MultiLineStringFromText(wkt[,srid])\n\nConstructs a MULTILINESTRING value using its WKT representation and\nSRID.\n\nURL: https://mariadb.com/kb/en/mlinefromtext/\n\n','','https://mariadb.com/kb/en/mlinefromtext/'),(108,'GEOMCOLLFROMWKB',32,'GeomCollFromWKB(wkb[,srid]), GeometryCollectionFromWKB(wkb[,srid])\n\nConstructs a GEOMETRYCOLLECTION value using its WKB representation and\nSRID.\n\nURL: https://mariadb.com/kb/en/geomcollfromwkb/\n\n','','https://mariadb.com/kb/en/geomcollfromwkb/'),(109,'HELP_DATE',9,'This help information was generated from the MySQL 5.5 Reference Manual\non: 2012-08-25\n','',''),(110,'RENAME TABLE',39,'Syntax:\nRENAME TABLE tbl_name TO new_tbl_name\n    [, tbl_name2 TO new_tbl_name2] ...\n\nThis statement renames one or more tables.\n\nThe rename operation is done atomically, which means that no other\nsession can access any of the tables while the rename is running. For\nexample, if you have an existing table old_table, you can create\nanother table new_table that has the same structure but is empty, and\nthen replace the existing table with the empty one as follows (assuming\nthat backup_table does not already exist):\n\nURL: https://mariadb.com/kb/en/rename-table/\n\n','CREATE TABLE new_table (...);\nRENAME TABLE old_table TO backup_table, new_table TO old_table;\n','https://mariadb.com/kb/en/rename-table/'),(111,'BOOLEAN',22,'BOOL, BOOLEAN\n\nThese types are synonyms for TINYINT(1). A value of zero is considered\nfalse. Nonzero values are considered true:\n\nMariaDB> SELECT IF(0, \'true\', \'false\');\n+------------------------+\n| IF(0, \'true\', \'false\') |\n+------------------------+\n| false                  |\n+------------------------+\n\nMariaDB> SELECT IF(1, \'true\', \'false\');\n+------------------------+\n| IF(1, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nMariaDB> SELECT IF(2, \'true\', \'false\');\n+------------------------+\n| IF(2, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nHowever, the values TRUE and FALSE are merely aliases for 1 and 0,\nrespectively, as shown here:\n\nMariaDB> SELECT IF(0 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(0 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| true                           |\n+--------------------------------+\n\nMariaDB> SELECT IF(1 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(1 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| true                          |\n+-------------------------------+\n\nMariaDB> SELECT IF(2 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(2 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| false                         |\n+-------------------------------+\n\nMariaDB> SELECT IF(2 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(2 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| false                          |\n+--------------------------------+\n\nThe last two statements display the results shown because 2 is equal to\nneither 1 nor 0.\n\nURL: https://mariadb.com/kb/en/boolean/\n\n','','https://mariadb.com/kb/en/boolean/'),(112,'DEFAULT',14,'Syntax:\nDEFAULT(col_name)\n\nReturns the default value for a table column. An error results if the\ncolumn has no default value.\n\nURL: https://mariadb.com/kb/en/default/\n\n','MariaDB> UPDATE t SET i = DEFAULT(i)+1 WHERE id < 100;\n','https://mariadb.com/kb/en/default/'),(113,'MOD',4,'Syntax:\nMOD(N,M), N % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M.\n\nURL: https://mariadb.com/kb/en/mod/\n\n','MariaDB> SELECT MOD(234, 10);\n        -> 4\nMariaDB> SELECT 253 % 7;\n        -> 1\nMariaDB> SELECT MOD(29,9);\n        -> 2\nMariaDB> SELECT 29 MOD 9;\n        -> 2\n','https://mariadb.com/kb/en/mod/'),(114,'TINYTEXT',22,'TINYTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 255 (28 - 1) characters. The\neffective maximum length is less if the value contains multi-byte\ncharacters. Each TINYTEXT value is stored using a 1-byte length prefix\nthat indicates the number of bytes in the value.\n\nURL: https://mariadb.com/kb/en/tinytext/\n\n','','https://mariadb.com/kb/en/tinytext/'),(115,'OPTIMIZE TABLE',20,'Syntax:\nOPTIMIZE [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n\nOPTIMIZE TABLE should be used if you have deleted a large part of a\ntable or if you have made many changes to a table with variable-length\nrows (tables that have VARCHAR, VARBINARY, BLOB, or TEXT columns).\nDeleted rows are maintained in a linked list and subsequent INSERT\noperations reuse old row positions. You can use OPTIMIZE TABLE to\nreclaim the unused space and to defragment the data file. After\nextensive changes to a table, this statement may also improve\nperformance of statements that use the table, sometimes significantly.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nOPTIMIZE TABLE is supported for partitioned tables, and you can use\nALTER TABLE ... OPTIMIZE PARTITION to optimize one or more partitions;\nfor more information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: https://mariadb.com/kb/en/optimize-table/\n\n','','https://mariadb.com/kb/en/optimize-table/'),(116,'DECODE',12,'Syntax:\nDECODE(crypt_str,pass_str)\n\nDecrypts the encrypted string crypt_str using pass_str as the password.\ncrypt_str should be a string returned from ENCODE().\n\nURL: https://mariadb.com/kb/en/decode/\n\n','','https://mariadb.com/kb/en/decode/'),(117,'<=>',18,'Syntax:\n<=>\n\nNULL-safe equal. This operator performs an equality comparison like the\n= operator, but returns 1 rather than NULL if both operands are NULL,\nand 0 rather than NULL if one operand is NULL.\n\nURL: https://mariadb.com/kb/en/null-safe-equal/\n\n','MariaDB> SELECT 1 <=> 1, NULL <=> NULL, 1 <=> NULL;\n        -> 1, 1, 0\nMariaDB> SELECT 1 = 1, NULL = NULL, 1 = NULL;\n        -> 1, NULL, NULL\n','https://mariadb.com/kb/en/null-safe-equal/'),(118,'HELP STATEMENT',28,'Syntax:\nHELP \'search_string\'\n\nThe HELP statement returns online information from the MySQL Reference\nmanual. Its proper operation requires that the help tables in the mysql\ndatabase be initialized with help topic information.\n\nThe HELP statement searches the help tables for the given search string\nand displays the result of the search. The search string is not case\nsensitive.\n\nURL: https://mariadb.com/kb/en/help-command/\n\n','','https://mariadb.com/kb/en/help-command/'),(119,'RESET',26,'Syntax:\nRESET reset_option [, reset_option] ...\n\nThe RESET statement is used to clear the state of various server\noperations. You must have the RELOAD privilege to execute RESET.\n\nRESET acts as a stronger version of the FLUSH statement. See [HELP\nFLUSH].\n\nThe RESET statement causes an implicit commit. See\nhttps://mariadb.com/kb/en/sql-statements-that-cause-an-implicit-commit/.\n\nURL: https://mariadb.com/kb/en/reset/\n\n','','https://mariadb.com/kb/en/reset/'),(120,'GET_LOCK',14,'Syntax:\nGET_LOCK(str,timeout)\n\nTries to obtain a lock with a name given by the string str, using a\ntimeout of timeout seconds. Returns 1 if the lock was obtained\nsuccessfully, 0 if the attempt timed out (for example, because another\nclient has previously locked the name), or NULL if an error occurred\n(such as running out of memory or the thread was killed with mysqladmin\nkill). If you have a lock obtained with GET_LOCK(), it is released when\nyou execute RELEASE_LOCK(), execute a new GET_LOCK(), or your\nconnection terminates (either normally or abnormally). Locks obtained\nwith GET_LOCK() do not interact with transactions. That is, committing\na transaction does not release any such locks obtained during the\ntransaction.\n\nThis function can be used to implement application locks or to simulate\nrecord locks. Names are locked on a server-wide basis. If a name has\nbeen locked by one client, GET_LOCK() blocks any request by another\nclient for a lock with the same name. This enables clients that agree\non a given lock name to use the name to perform cooperative advisory\nlocking. But be aware that it also enables a client that is not among\nthe set of cooperating clients to lock a name, either inadvertently or\ndeliberately, and thus prevent any of the cooperating clients from\nlocking that name. One way to reduce the likelihood of this is to use\nlock names that are database-specific or application-specific. For\nexample, use lock names of the form db_name.str or app_name.str.\n\nURL: https://mariadb.com/kb/en/get_lock/\n\n','MariaDB> SELECT GET_LOCK(\'lock1\',10);\n        -> 1\nMariaDB> SELECT IS_FREE_LOCK(\'lock2\');\n        -> 1\nMariaDB> SELECT GET_LOCK(\'lock2\',10);\n        -> 1\nMariaDB> SELECT RELEASE_LOCK(\'lock2\');\n        -> 1\nMariaDB> SELECT RELEASE_LOCK(\'lock1\');\n        -> NULL\n','https://mariadb.com/kb/en/get_lock/'),(121,'UCASE',37,'Syntax:\nUCASE(str)\n\nUCASE() is a synonym for UPPER().\n\nURL: https://mariadb.com/kb/en/ucase/\n\n','','https://mariadb.com/kb/en/ucase/'),(122,'SHOW BINLOG EVENTS',26,'Syntax:\nSHOW BINLOG EVENTS\n   [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\n\nShows the events in the binary log. If you do not specify \'log_name\',\nthe first binary log is displayed.\n\nURL: https://mariadb.com/kb/en/show-binlog-events/\n\n','','https://mariadb.com/kb/en/show-binlog-events/'),(123,'MPOLYFROMWKB',32,'MPolyFromWKB(wkb[,srid]), MultiPolygonFromWKB(wkb[,srid])\n\nConstructs a MULTIPOLYGON value using its WKB representation and SRID.\n\nURL: https://mariadb.com/kb/en/mpolyfromwkb/\n\n','','https://mariadb.com/kb/en/mpolyfromwkb/'),(124,'ITERATE',23,'Syntax:\nITERATE label\n\nITERATE can appear only within LOOP, REPEAT, and WHILE statements.\nITERATE means \"start the loop again.\"\n\nURL: https://mariadb.com/kb/en/iterate/\n\n','','https://mariadb.com/kb/en/iterate/'),(125,'DO',27,'Syntax:\nDO expr [, expr] ...\n\nDO executes the expressions but does not return any results. In most\nrespects, DO is shorthand for SELECT expr, ..., but has the advantage\nthat it is slightly faster when you do not care about the result.\n\nDO is useful primarily with functions that have side effects, such as\nRELEASE_LOCK().\n\nURL: https://mariadb.com/kb/en/do/\n\n','','https://mariadb.com/kb/en/do/'),(126,'CURTIME',31,'Syntax:\nCURTIME()\n\nReturns the current time as a value in \'HH:MM:SS\' or HHMMSS.uuuuuu\nformat, depending on whether the function is used in a string or\nnumeric context. The value is expressed in the current time zone.\n\nURL: https://mariadb.com/kb/en/curtime/\n\n','MariaDB> SELECT CURTIME();\n        -> \'23:50:26\'\nMariaDB> SELECT CURTIME() + 0;\n        -> 235026.000000\n','https://mariadb.com/kb/en/curtime/'),(127,'CHAR_LENGTH',37,'Syntax:\nCHAR_LENGTH(str)\n\nReturns the length of the string str, measured in characters. A\nmulti-byte character counts as a single character. This means that for\na string containing five 2-byte characters, LENGTH() returns 10,\nwhereas CHAR_LENGTH() returns 5.\n\nURL: https://mariadb.com/kb/en/char_length/\n\n','','https://mariadb.com/kb/en/char_length/'),(128,'BIGINT',22,'BIGINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA large integer. The signed range is -9223372036854775808 to\n9223372036854775807. The unsigned range is 0 to 18446744073709551615.\n\nSERIAL is an alias for BIGINT UNSIGNED NOT NULL AUTO_INCREMENT UNIQUE.\n\nURL: https://mariadb.com/kb/en/bigint/\n\n','','https://mariadb.com/kb/en/bigint/'),(129,'SET',26,'Syntax:\nSET variable_assignment [, variable_assignment] ...\n\nvariable_assignment:\n      user_var_name = expr\n    | [GLOBAL | SESSION] system_var_name = expr\n    | [@@global. | @@session. | @@]system_var_name = expr\n\nThe SET statement assigns values to different types of variables that\naffect the operation of the server or your client. Older versions of\nMySQL employed SET OPTION, but this syntax is deprecated in favor of\nSET without OPTION.\n\nURL: https://mariadb.com/kb/en/set/\n\n','','https://mariadb.com/kb/en/set/'),(130,'LOAD XML',27,'Syntax:\nLOAD XML [LOW_PRIORITY | CONCURRENT] [LOCAL] INFILE \'file_name\'\n    [REPLACE | IGNORE]\n    INTO TABLE [db_name.]tbl_name\n    [CHARACTER SET charset_name]\n    [ROWS IDENTIFIED BY \'<tagname>\']\n    [IGNORE number {LINES | ROWS}]\n    [(column_or_user_var,...)]\n    [SET col_name = expr,...]\n\nThe LOAD XML statement reads data from an XML file into a table. The\nfile_name must be given as a literal string. The tagname in the\noptional ROWS IDENTIFIED BY clause must also be given as a literal\nstring, and must be surrounded by angle brackets (< and >).\n\nLOAD XML acts as the complement of running the mysql client in XML\noutput mode (that is, starting the client with the --xml option). To\nwrite data from a table to an XML file, use a command such as the\nfollowing one from the system shell:\n\nshell> mysql --xml -e \'SELECT * FROM mytable\' > file.xml\n\nTo read the file back into a table, use LOAD XML INFILE. By default,\nthe <row> element is considered to be the equivalent of a database\ntable row; this can be changed using the ROWS IDENTIFIED BY clause.\n\nThis statement supports three different XML formats:\n\no Column names as attributes and column values as attribute values:\n\n<row column1=\"value1\" column2=\"value2\" .../>\n\no Column names as tags and column values as the content of these tags:\n\n<row>\n  <column1>value1</column1>\n  <column2>value2</column2>\n</row>\n\no Column names are the name attributes of <field> tags, and values are\n  the contents of these tags:\n\n<row>\n  <field name=\'column1\'>value1</field>\n  <field name=\'column2\'>value2</field>\n</row>\n\n  This is the format used by other MySQL tools, such as mysqldump.\n\nAll 3 formats can be used in the same XML file; the import routine\nautomatically detects the format for each row and interprets it\ncorrectly. Tags are matched based on the tag or attribute name and the\ncolumn name.\n\nThe following clauses work essentially the same way for LOAD XML as\nthey do for LOAD DATA:\n\no LOW_PRIORITY or CONCURRENT\n\no LOCAL\n\no REPLACE or IGNORE\n\no CHARACTER SET\n\no (column_or_user_var,...)\n\no SET\n\nSee [HELP LOAD DATA], for more information about these clauses.\n\nThe IGNORE number LINES or IGNORE number ROWS clause causes the first\nnumber rows in the XML file to be skipped. It is analogous to the LOAD\nDATA statement\'s IGNORE ... LINES clause.\n\nURL: https://mariadb.com/kb/en/load-xml/\n\n','','https://mariadb.com/kb/en/load-xml/'),(131,'CONV',4,'Syntax:\nCONV(N,from_base,to_base)\n\nConverts numbers between different number bases. Returns a string\nrepresentation of the number N, converted from base from_base to base\nto_base. Returns NULL if any argument is NULL. The argument N is\ninterpreted as an integer, but may be specified as an integer or a\nstring. The minimum base is 2 and the maximum base is 36. If to_base is\na negative number, N is regarded as a signed number. Otherwise, N is\ntreated as unsigned. CONV() works with 64-bit precision.\n\nURL: https://mariadb.com/kb/en/conv/\n\n','MariaDB> SELECT CONV(\'a\',16,2);\n        -> \'1010\'\nMariaDB> SELECT CONV(\'6E\',18,8);\n        -> \'172\'\nMariaDB> SELECT CONV(-17,10,-18);\n        -> \'-H\'\nMariaDB> SELECT CONV(10+\'10\'+\'10\'+0xa,10,10);\n        -> \'40\'\n','https://mariadb.com/kb/en/conv/'),(132,'DATE',22,'DATE\n\nA date. The supported range is \'1000-01-01\' to \'9999-12-31\'. MySQL\ndisplays DATE values in \'YYYY-MM-DD\' format, but permits assignment of\nvalues to DATE columns using either strings or numbers.\n\nURL: https://mariadb.com/kb/en/date/\n\n','','https://mariadb.com/kb/en/date/'),(133,'ASSIGN-VALUE',15,'Syntax:\n:=\n\nAssignment operator. Causes the user variable on the left hand side of\nthe operator to take on the value to its right. The value on the right\nhand side may be a literal value, another variable storing a value, or\nany legal expression that yields a scalar value, including the result\nof a query (provided that this value is a scalar value). You can\nperform multiple assignments in the same SET statement. You can perform\nmultiple assignments in the same statement-\n\nUnlike =, the := operator is never interpreted as a comparison\noperator. This means you can use := in any valid SQL statement (not\njust in SET statements) to assign a value to a variable.\n\nURL: https://mariadb.com/kb/en/assignment-operator/\n\n','MariaDB> SELECT @var1, @var2;\n        -> NULL, NULL\nMariaDB> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nMariaDB> SELECT @var1, @var2;\n        -> 1, NULL\nMariaDB> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nMariaDB> SELECT @var1, @var2;\n        -> 1, 1\n\nMariaDB> SELECT @var1:=COUNT(*) FROM t1;\n        -> 4\nMariaDB> SELECT @var1;\n        -> 4\n','https://mariadb.com/kb/en/assignment-operator/'),(134,'SHOW OPEN TABLES',26,'Syntax:\nSHOW OPEN TABLES [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW OPEN TABLES lists the non-TEMPORARY tables that are currently open\nin the table cache. See\nhttp://dev.mysql.com/doc/refman/5.5/en/table-cache.html. The FROM\nclause, if present, restricts the tables shown to those present in the\ndb_name database. The LIKE clause, if present, indicates which table\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nURL: https://mariadb.com/kb/en/show-open-tables/\n\n','','https://mariadb.com/kb/en/show-open-tables/'),(135,'EXTRACT',31,'Syntax:\nEXTRACT(unit FROM date)\n\nThe EXTRACT() function uses the same kinds of unit specifiers as\nDATE_ADD() or DATE_SUB(), but extracts parts from the date rather than\nperforming date arithmetic.\n\nURL: https://mariadb.com/kb/en/extract/\n\n','MariaDB> SELECT EXTRACT(YEAR FROM \'2009-07-02\');\n       -> 2009\nMariaDB> SELECT EXTRACT(YEAR_MONTH FROM \'2009-07-02 01:02:03\');\n       -> 200907\nMariaDB> SELECT EXTRACT(DAY_MINUTE FROM \'2009-07-02 01:02:03\');\n       -> 20102\nMariaDB> SELECT EXTRACT(MICROSECOND\n    ->                FROM \'2003-01-02 10:30:00.000123\');\n        -> 123\n','https://mariadb.com/kb/en/extract/'),(136,'ENCRYPT',12,'Syntax:\nENCRYPT(str[,salt])\n\nEncrypts str using the Unix crypt() system call and returns a binary\nstring. The salt argument must be a string with at least two characters\nor the result will be NULL. If no salt argument is given, a random\nvalue is used.\n\nURL: https://mariadb.com/kb/en/encrypt/\n\n','MariaDB> SELECT ENCRYPT(\'hello\');\n        -> \'VxuFAJXVARROc\'\n','https://mariadb.com/kb/en/encrypt/'),(137,'SHOW STATUS',26,'Syntax:\nSHOW [GLOBAL | SESSION] STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW STATUS provides server status information. This information also\ncan be obtained using the mysqladmin extended-status command. The LIKE\nclause, if present, indicates which variable names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in https://mariadb.com/kb/en/extended-show/.\nThis statement does not require any privilege. It requires only the\nability to connect to the server.\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern:\n\nMariaDB> SHOW STATUS LIKE \'Key%\';\n+--------------------+----------+\n| Variable_name      | Value    |\n+--------------------+----------+\n| Key_blocks_used    | 14955    |\n| Key_read_requests  | 96854827 |\n| Key_reads          | 162040   |\n| Key_write_requests | 7589728  |\n| Key_writes         | 3813196  |\n+--------------------+----------+\n\nWith the GLOBAL modifier, SHOW STATUS displays the status values for\nall connections to MySQL. With SESSION, it displays the status values\nfor the current connection. If no modifier is present, the default is\nSESSION. LOCAL is a synonym for SESSION.\n\nSome status variables have only a global value. For these, you get the\nsame value for both GLOBAL and SESSION. The scope for each status\nvariable is listed at\nhttps://mariadb.com/kb/en/server-status-variables/.\n\nEach invocation of the SHOW STATUS statement uses an internal temporary\ntable and increments the global Created_tmp_tables value.\n\nURL: https://mariadb.com/kb/en/show-status/\n\n','','https://mariadb.com/kb/en/show-status/'),(138,'EXTRACTVALUE',37,'Syntax:\nExtractValue(xml_frag, xpath_expr)\n\nExtractValue() takes two string arguments, a fragment of XML markup\nxml_frag and an XPath expression xpath_expr (also known as a locator);\nit returns the text (CDATA) of the first text node which is a child of\nthe elements or elements matched by the XPath expression. In MySQL 5.5,\nthe XPath expression can contain at most 127 characters. (This\nlimitation is lifted in MySQL 5.6.)\n\nUsing this function is the equivalent of performing a match using the\nxpath_expr after appending /text(). In other words,\nExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b\') and\nExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b/text()\') produce the same\nresult.\n\nIf multiple matches are found, the content of the first child text node\nof each matching element is returned (in the order matched) as a\nsingle, space-delimited string.\n\nIf no matching text node is found for the expression (including the\nimplicit /text())---for whatever reason, as long as xpath_expr is\nvalid, and xml_frag consists of elements which are properly nested and\nclosed---an empty string is returned. No distinction is made between a\nmatch on an empty element and no match at all. This is by design.\n\nIf you need to determine whether no matching element was found in\nxml_frag or such an element was found but contained no child text\nnodes, you should test the result of an expression that uses the XPath\ncount() function. For example, both of these statements return an empty\nstring, as shown here:\n\nMariaDB> SELECT ExtractValue(\'<a><b/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nMariaDB> SELECT ExtractValue(\'<a><c/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nHowever, you can determine whether there was actually a matching\nelement using the following:\n\nMariaDB> SELECT ExtractValue(\'<a><b/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 1                                   |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nMariaDB> SELECT ExtractValue(\'<a><c/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 0                                   |\n+-------------------------------------+\n1 row in set (0.01 sec)\n\n*Important*: ExtractValue() returns only CDATA, and does not return any\ntags that might be contained within a matching tag, nor any of their\ncontent (see the result returned as val1 in the following example).\n\nURL: https://mariadb.com/kb/en/extractvalue/\n\n','MariaDB> SELECT\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a\') AS val1,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a/b\') AS val2,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'//b\') AS val3,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/b\') AS val4,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b><b>eee</b></a>\', \'//b\') AS val5;\n\n+------+------+------+------+---------+\n| val1 | val2 | val3 | val4 | val5    |\n+------+------+------+------+---------+\n| ccc  | ddd  | ddd  |      | ddd eee |\n+------+------+------+------+---------+\n','https://mariadb.com/kb/en/extractvalue/'),(139,'OLD_PASSWORD',12,'Syntax:\nOLD_PASSWORD(str)\n\nOLD_PASSWORD() was added when the implementation of PASSWORD() was\nchanged in MySQL 4.1 to improve security. OLD_PASSWORD() returns the\nvalue of the pre-4.1 implementation of PASSWORD() as a string, and is\nintended to permit you to reset passwords for any pre-4.1 clients that\nneed to connect to your version 5.5 MySQL server without locking them\nout. See http://dev.mysql.com/doc/refman/5.1/en/password-hashing.html.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring.\n\nURL: https://mariadb.com/kb/en/old_password/\n\n','','https://mariadb.com/kb/en/old_password/'),(140,'FORMAT',37,'Syntax:\nFORMAT(X,D[,locale])\n\nFormats the number X to a format like \'#,###,###.##\', rounded to D\ndecimal places, and returns the result as a string. If D is 0, the\nresult has no decimal point or fractional part.\n\nThe optional third parameter enables a locale to be specified to be\nused for the result number\'s decimal point, thousands separator, and\ngrouping between separators. Permissible locale values are the same as\nthe legal values for the lc_time_names system variable (see\nhttps://mariadb.com/kb/en/server-locale/). If no\nlocale is specified, the default is \'en_US\'.\n\nURL: https://mariadb.com/kb/en/format/\n\n','MariaDB> SELECT FORMAT(12332.123456, 4);\n        -> \'12,332.1235\'\nMariaDB> SELECT FORMAT(12332.1,4);\n        -> \'12,332.1000\'\nMariaDB> SELECT FORMAT(12332.2,0);\n        -> \'12,332\'\nMariaDB> SELECT FORMAT(12332.2,2,\'de_DE\');\n        -> \'12.332,20\'\n','https://mariadb.com/kb/en/format/'),(141,'||',15,'Syntax:\nOR, ||\n\nLogical OR. When both operands are non-NULL, the result is 1 if any\noperand is nonzero, and 0 otherwise. With a NULL operand, the result is\n1 if the other operand is nonzero, and NULL otherwise. If both operands\nare NULL, the result is NULL.\n\nURL: https://mariadb.com/kb/en/or/\n\n','MariaDB> SELECT 1 || 1;\n        -> 1\nMariaDB> SELECT 1 || 0;\n        -> 1\nMariaDB> SELECT 0 || 0;\n        -> 0\nMariaDB> SELECT 0 || NULL;\n        -> NULL\nMariaDB> SELECT 1 || NULL;\n        -> 1\n','https://mariadb.com/kb/en/or/'),(142,'BIT_LENGTH',37,'Syntax:\nBIT_LENGTH(str)\n\nReturns the length of the string str in bits.\n\nURL: https://mariadb.com/kb/en/bit_length/\n\n','MariaDB> SELECT BIT_LENGTH(\'text\');\n        -> 32\n','https://mariadb.com/kb/en/bit_length/'),(143,'EXTERIORRING',2,'ExteriorRing(poly)\n\nReturns the exterior ring of the Polygon value poly as a LineString.\n\nURL: https://mariadb.com/kb/en/exteriorring/\n\n','MariaDB> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nMariaDB> SELECT AsText(ExteriorRing(GeomFromText(@poly)));\n+-------------------------------------------+\n| AsText(ExteriorRing(GeomFromText(@poly))) |\n+-------------------------------------------+\n| LINESTRING(0 0,0 3,3 3,3 0,0 0)           |\n+-------------------------------------------+\n','https://mariadb.com/kb/en/exteriorring/'),(144,'GEOMFROMWKB',32,'GeomFromWKB(wkb[,srid]), GeometryFromWKB(wkb[,srid])\n\nConstructs a geometry value of any type using its WKB representation\nand SRID.\n\nURL: https://mariadb.com/kb/en/geomfromwkb/\n\n','','https://mariadb.com/kb/en/geomfromwkb/'),(145,'SHOW SLAVE HOSTS',26,'Syntax:\nSHOW SLAVE HOSTS\n\nDisplays a list of replication slaves currently registered with the\nmaster. (Before MySQL 5.5.3, only slaves started with the\n--report-host=host_name option are visible in this list.)\n\nThe list is displayed on any server (not just the master server). The\noutput looks like this:\n\nMariaDB> SHOW SLAVE HOSTS;\n+------------+-----------+------+-----------+\n| Server_id  | Host      | Port | Master_id |\n+------------+-----------+------+-----------+\n|  192168010 | iconnect2 | 3306 | 192168011 |\n| 1921680101 | athena    | 3306 | 192168011 |\n+------------+-----------+------+-----------+\n\no Server_id: The unique server ID of the slave server, as configured in\n  the server\'s option file, or on the command line with\n  --server-id=value.\n\no Host: The host name of the slave server, as configured in the\n  server\'s option file, or on the command line with\n  --report-host=host_name. Note that this can differ from the machine\n  name as configured in the operating system.\n\no Port: The port the slave server is listening on.\n\n  In MySQL 5.5.23 and later, a zero in this column means that the slave\n  port (--report-port) was not set. Prior to MySQL 5.5.23, 3306 was\n  used as the default in such cases (Bug #13333431).\n\no Master_id: The unique server ID of the master server that the slave\n  server is replicating from.\n\nSome MySQL versions report another variable, Rpl_recovery_rank. This\nvariable was never used, and was removed in MySQL 5.5.3. (Bug #13963)\n\nURL: https://mariadb.com/kb/en/show-slave-hosts/\n\n','','https://mariadb.com/kb/en/show-slave-hosts/'),(146,'START TRANSACTION',8,'Syntax:\nSTART TRANSACTION [WITH CONSISTENT SNAPSHOT]\nBEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThese statements provide control over use of transactions:\n\no START TRANSACTION or BEGIN start a new transaction.\n\no COMMIT commits the current transaction, making its changes permanent.\n\no ROLLBACK rolls back the current transaction, canceling its changes.\n\no SET autocommit disables or enables the default autocommit mode for\n  the current session.\n\nBy default, MySQL runs with autocommit mode enabled. This means that as\nsoon as you execute a statement that updates (modifies) a table, MySQL\nstores the update on disk to make it permanent. The change cannot be\nrolled back.\n\nTo disable autocommit mode implicitly for a single series of\nstatements, use the START TRANSACTION statement:\n\nSTART TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n\nWith START TRANSACTION, autocommit remains disabled until you end the\ntransaction with COMMIT or ROLLBACK. The autocommit mode then reverts\nto its previous state.\n\nYou can also begin a transaction like this:\n\nSTART TRANSACTION WITH CONSISTENT SNAPSHOT;\n\nThe WITH CONSISTENT SNAPSHOT option starts a consistent read for\nstorage engines that are capable of it. This applies only to InnoDB.\nThe effect is the same as issuing a START TRANSACTION followed by a\nSELECT from any InnoDB table. See\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-consistent-read.html. The\nWITH CONSISTENT SNAPSHOT option does not change the current transaction\nisolation level, so it provides a consistent snapshot only if the\ncurrent isolation level is one that permits consistent read (REPEATABLE\nREAD or SERIALIZABLE).\n\n*Important*: Many APIs used for writing MySQL client applications (such\nas JDBC) provide their own methods for starting transactions that can\n(and sometimes should) be used instead of sending a START TRANSACTION\nstatement from the client. See\nhttp://dev.mysql.com/doc/refman/5.5/en/connectors-apis.html, or the\ndocumentation for your API, for more information.\n\nTo disable autocommit mode explicitly, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB) are not made permanent immediately. You must use COMMIT to\nstore your changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. To\ndisable autocommit mode for each new connection, see the description of\nthe autocommit system variable at\nhttps://mariadb.com/kb/en/server-system-variables/.\n\nBEGIN and BEGIN WORK are supported as aliases of START TRANSACTION for\ninitiating a transaction. START TRANSACTION is standard SQL syntax and\nis the recommended way to start an ad-hoc transaction.\n\nThe BEGIN statement differs from the use of the BEGIN keyword that\nstarts a BEGIN ... END compound statement. The latter does not begin a\ntransaction. See [HELP BEGIN END].\n\n*Note*: Within all stored programs (stored procedures and functions,\ntriggers, and events), the parser treats BEGIN [WORK] as the beginning\nof a BEGIN ... END block. Begin a transaction in this context with\nSTART TRANSACTION instead.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttps://mariadb.com/kb/en/server-system-variables/.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The RELEASE clause causes the\nserver to disconnect the current client session after terminating the\ncurrent transaction. Including the NO keyword suppresses CHAIN or\nRELEASE completion, which can be useful if the completion_type system\nvariable is set to cause chaining or release completion by default.\n\nURL: https://mariadb.com/kb/en/start-transaction/\n\n','','https://mariadb.com/kb/en/start-transaction/'),(147,'BETWEEN AND',18,'Syntax:\nexpr BETWEEN min AND max\n\nIf expr is greater than or equal to min and expr is less than or equal\nto max, BETWEEN returns 1, otherwise it returns 0. This is equivalent\nto the expression (min <= expr AND expr <= max) if all the arguments\nare of the same type. Otherwise type conversion takes place according\nto the rules described in\nhttps://mariadb.com/kb/en/type-conversion/, but\napplied to all the three arguments.\n\nURL: https://mariadb.com/kb/en/between-and/\n\n','MariaDB> SELECT 2 BETWEEN 1 AND 3, 2 BETWEEN 3 and 1;\n        -> 1, 0\nMariaDB> SELECT 1 BETWEEN 2 AND 3;\n        -> 0\nMariaDB> SELECT \'b\' BETWEEN \'a\' AND \'c\';\n        -> 1\nMariaDB> SELECT 2 BETWEEN 2 AND \'3\';\n        -> 1\nMariaDB> SELECT 2 BETWEEN 2 AND \'x-3\';\n        -> 0\n','https://mariadb.com/kb/en/between-and/'),(148,'MULTIPOLYGON',24,'MultiPolygon(poly1,poly2,...)\n\nConstructs a MultiPolygon value from a set of Polygon or WKB Polygon\narguments.\n\nURL: https://mariadb.com/kb/en/multipolygon/\n\n','','https://mariadb.com/kb/en/multipolygon/'),(149,'TIME_FORMAT',31,'Syntax:\nTIME_FORMAT(time,format)\n\nThis is used like the DATE_FORMAT() function, but the format string may\ncontain format specifiers only for hours, minutes, seconds, and\nmicroseconds. Other specifiers produce a NULL value or 0.\n\nURL: https://mariadb.com/kb/en/time_format/\n\n','MariaDB> SELECT TIME_FORMAT(\'100:00:00\', \'%H %k %h %I %l\');\n        -> \'100 100 04 04 4\'\n','https://mariadb.com/kb/en/time_format/'),(150,'LEFT',37,'Syntax:\nLEFT(str,len)\n\nReturns the leftmost len characters from the string str, or NULL if any\nargument is NULL.\n\nURL: https://mariadb.com/kb/en/left/\n\n','MariaDB> SELECT LEFT(\'foobarbar\', 5);\n        -> \'fooba\'\n','https://mariadb.com/kb/en/left/'),(151,'FLUSH QUERY CACHE',26,'You can defragment the query cache to better utilize its memory with\nthe FLUSH QUERY CACHE statement. The statement does not remove any\nqueries from the cache.\n\nThe RESET QUERY CACHE statement removes all query results from the\nquery cache. The FLUSH TABLES statement also does this.\n\nURL: https://mariadb.com/kb/en/flush-query-cache/\n\n','','https://mariadb.com/kb/en/flush-query-cache/'),(152,'SET DATA TYPE',22,'SET(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA set. A string object that can have zero or more values, each of which\nmust be chosen from the list of values \'value1\', \'value2\', ... A SET\ncolumn can have a maximum of 64 members. SET values are represented\ninternally as integers.\n\nURL: https://mariadb.com/kb/en/set-data-type/\n\n','','https://mariadb.com/kb/en/set-data-type/'),(153,'RAND',4,'Syntax:\nRAND(), RAND(N)\n\nReturns a random floating-point value v in the range 0 <= v < 1.0. If a\nconstant integer argument N is specified, it is used as the seed value,\nwhich produces a repeatable sequence of column values. In the following\nexample, note that the sequences of values produced by RAND(3) is the\nsame both places where it occurs.\n\nURL: https://mariadb.com/kb/en/rand/\n\n','MariaDB> CREATE TABLE t (i INT);\nQuery OK, 0 rows affected (0.42 sec)\n\nMariaDB> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nMariaDB> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.61914388706828 |\n|    2 | 0.93845168309142 |\n|    3 | 0.83482678498591 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nMariaDB> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nMariaDB> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.35877890638893 |\n|    2 | 0.28941420772058 |\n|    3 | 0.37073435016976 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nMariaDB> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.01 sec)\n','https://mariadb.com/kb/en/rand/'),(154,'RPAD',37,'Syntax:\nRPAD(str,len,padstr)\n\nReturns the string str, right-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\nURL: https://mariadb.com/kb/en/rpad/\n\n','MariaDB> SELECT RPAD(\'hi\',5,\'?\');\n        -> \'hi???\'\nMariaDB> SELECT RPAD(\'hi\',1,\'?\');\n        -> \'h\'\n','https://mariadb.com/kb/en/rpad/'),(155,'CREATE DATABASE',39,'Syntax:\nCREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n    [create_specification] ...\n\ncreate_specification:\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n\nCREATE DATABASE creates a database with the given name. To use this\nstatement, you need the CREATE privilege for the database. CREATE\nSCHEMA is a synonym for CREATE DATABASE.\n\nURL: https://mariadb.com/kb/en/create-database/\n\n','','https://mariadb.com/kb/en/create-database/'),(156,'DEC',22,'DEC[(M[,D])] [UNSIGNED] [ZEROFILL], NUMERIC[(M[,D])] [UNSIGNED]\n[ZEROFILL], FIXED[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nThese types are synonyms for DECIMAL. The FIXED synonym is available\nfor compatibility with other database systems.\n\nURL: https://mariadb.com/kb/en/dec-numeric-fixed/\n\n','','https://mariadb.com/kb/en/dec-numeric-fixed/'),(157,'VAR_POP',16,'Syntax:\nVAR_POP(expr)\n\nReturns the population standard variance of expr. It considers rows as\nthe whole population, not as a sample, so it has the number of rows as\nthe denominator. You can also use VARIANCE(), which is equivalent but\nis not standard SQL.\n\nVAR_POP() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/var_pop/\n\n','','https://mariadb.com/kb/en/var_pop/'),(158,'ELT',37,'Syntax:\nELT(N,str1,str2,str3,...)\n\nReturns str1 if N = 1, str2 if N = 2, and so on. Returns NULL if N is\nless than 1 or greater than the number of arguments. ELT() is the\ncomplement of FIELD().\n\nURL: https://mariadb.com/kb/en/elt/.html\n\n','MariaDB> SELECT ELT(1, \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> \'ej\'\nMariaDB> SELECT ELT(4, \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> \'foo\'\n','https://mariadb.com/kb/en/elt/.html'),(159,'ALTER VIEW',39,'Syntax:\nALTER\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = { user | CURRENT_USER }]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThis statement changes the definition of a view, which must exist. The\nsyntax is similar to that for CREATE VIEW and the effect is the same as\nfor CREATE OR REPLACE VIEW. See [HELP CREATE VIEW]. This statement\nrequires the CREATE VIEW and DROP privileges for the view, and some\nprivilege for each column referred to in the SELECT statement. ALTER\nVIEW is permitted only to the definer or users with the SUPER\nprivilege.\n\nURL: https://mariadb.com/kb/en/alter-view/\n\n','','https://mariadb.com/kb/en/alter-view/'),(160,'SHOW DATABASES',26,'Syntax:\nSHOW {DATABASES | SCHEMAS}\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW DATABASES lists the databases on the MySQL server host. SHOW\nSCHEMAS is a synonym for SHOW DATABASES. The LIKE clause, if present,\nindicates which database names to match. The WHERE clause can be given\nto select rows using more general conditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nYou see only those databases for which you have some kind of privilege,\nunless you have the global SHOW DATABASES privilege. You can also get\nthis list using the mysqlshow command.\n\nIf the server was started with the --skip-show-database option, you\ncannot use this statement at all unless you have the SHOW DATABASES\nprivilege.\n\nURL: https://mariadb.com/kb/en/show-databases/\n\n','','https://mariadb.com/kb/en/show-databases/'),(161,'~',19,'Syntax:\n~\n\nInvert all bits.\n\nURL: https://mariadb.com/kb/en/3489/\n\n','MariaDB> SELECT 5 & ~1;\n        -> 4\n','https://mariadb.com/kb/en/3489/'),(162,'TEXT',22,'TEXT[(M)] [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 65,535 (216 - 1) characters. The\neffective maximum length is less if the value contains multi-byte\ncharacters. Each TEXT value is stored using a 2-byte length prefix that\nindicates the number of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest TEXT type large enough to hold\nvalues M characters long.\n\nURL: https://mariadb.com/kb/en/text/\n\n','','https://mariadb.com/kb/en/text/'),(163,'CONCAT_WS',37,'Syntax:\nCONCAT_WS(separator,str1,str2,...)\n\nCONCAT_WS() stands for Concatenate With Separator and is a special form\nof CONCAT(). The first argument is the separator for the rest of the\narguments. The separator is added between the strings to be\nconcatenated. The separator can be a string, as can the rest of the\narguments. If the separator is NULL, the result is NULL.\n\nURL: https://mariadb.com/kb/en/concat_ws/\n\n','MariaDB> SELECT CONCAT_WS(\',\',\'First name\',\'Second name\',\'Last Name\');\n        -> \'First name,Second name,Last Name\'\nMariaDB> SELECT CONCAT_WS(\',\',\'First name\',NULL,\'Last Name\');\n        -> \'First name,Last Name\'\n','https://mariadb.com/kb/en/concat_ws/'),(164,'ROW_COUNT',17,'Syntax:\nROW_COUNT()\n\nBefore MySQL 5.5.5, ROW_COUNT() returns the number of rows changed,\ndeleted, or inserted by the last statement if it was an UPDATE, DELETE,\nor INSERT. For other statements, the value may not be meaningful.\n\nAs of MySQL 5.5.5, ROW_COUNT() returns a value as follows:\n\no DDL statements: 0. This applies to statements such as CREATE TABLE or\n  DROP TABLE.\n\no DML statements other than SELECT: The number of affected rows. This\n  applies to statements such as UPDATE, INSERT, or DELETE (as before),\n  but now also to statements such as ALTER TABLE and LOAD DATA INFILE.\n\no SELECT: -1 if the statement returns a result set, or the number of\n  rows \"affected\" if it does not. For example, for SELECT * FROM t1,\n  ROW_COUNT() returns -1. For SELECT * FROM t1 INTO OUTFILE\n  \'file_name\', ROW_COUNT() returns the number of rows written to the\n  file.\n\no SIGNAL statements: 0.\n\nFor UPDATE statements, the affected-rows value by default is the number\nof rows actually changed. If you specify the CLIENT_FOUND_ROWS flag to\nmysql_real_connect() when connecting to mysqld, the affected-rows value\nis the number of rows \"found\"; that is, matched by the WHERE clause.\n\nFor REPLACE statements, the affected-rows value is 2 if the new row\nreplaced an old row, because in this case, one row was inserted after\nthe duplicate was deleted.\n\nFor INSERT ... ON DUPLICATE KEY UPDATE statements, the affected-rows\nvalue is 1 if the row is inserted as a new row and 2 if an existing row\nis updated.\n\nThe ROW_COUNT() value is similar to the value from the\nmysql_affected_rows() C API function and the row count that the mysql\nclient displays following statement execution.\n\nURL: https://mariadb.com/kb/en/information-functions-row_count/\n\n','MariaDB> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nMariaDB> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           3 |\n+-------------+\n1 row in set (0.00 sec)\n\nMariaDB> DELETE FROM t WHERE i IN(1,2);\nQuery OK, 2 rows affected (0.00 sec)\n\nMariaDB> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           2 |\n+-------------+\n1 row in set (0.00 sec)\n','https://mariadb.com/kb/en/information-functions-row_count/'),(165,'ASIN',4,'Syntax:\nASIN(X)\n\nReturns the arc sine of X, that is, the value whose sine is X. Returns\nNULL if X is not in the range -1 to 1.\n\nURL: https://mariadb.com/kb/en/asin/\n\n','MariaDB> SELECT ASIN(0.2);\n        -> 0.20135792079033\nMariaDB> SELECT ASIN(\'foo\');\n\n+-------------+\n| ASIN(\'foo\') |\n+-------------+\n|           0 |\n+-------------+\n1 row in set, 1 warning (0.00 sec)\n\nMariaDB> SHOW WARNINGS;\n+---------+------+-----------------------------------------+\n| Level   | Code | Message                                 |\n+---------+------+-----------------------------------------+\n| Warning | 1292 | Truncated incorrect DOUBLE value: \'foo\' |\n+---------+------+-----------------------------------------+\n','https://mariadb.com/kb/en/asin/'),(166,'SIGN',4,'Syntax:\nSIGN(X)\n\nReturns the sign of the argument as -1, 0, or 1, depending on whether X\nis negative, zero, or positive.\n\nURL: https://mariadb.com/kb/en/sign/\n\n','MariaDB> SELECT SIGN(-32);\n        -> -1\nMariaDB> SELECT SIGN(0);\n        -> 0\nMariaDB> SELECT SIGN(234);\n        -> 1\n','https://mariadb.com/kb/en/sign/'),(167,'SEC_TO_TIME',31,'Syntax:\nSEC_TO_TIME(seconds)\n\nReturns the seconds argument, converted to hours, minutes, and seconds,\nas a TIME value. The range of the result is constrained to that of the\nTIME data type. A warning occurs if the argument corresponds to a value\noutside that range.\n\nURL: https://mariadb.com/kb/en/sec_to_time/\n\n','MariaDB> SELECT SEC_TO_TIME(2378);\n        -> \'00:39:38\'\nMariaDB> SELECT SEC_TO_TIME(2378) + 0;\n        -> 3938\n','https://mariadb.com/kb/en/sec_to_time/'),(168,'FLOAT',22,'FLOAT[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA small (single-precision) floating-point number. Permissible values\nare -3.402823466E+38 to -1.175494351E-38, 0, and 1.175494351E-38 to\n3.402823466E+38. These are the theoretical limits, based on the IEEE\nstandard. The actual range might be slightly smaller depending on your\nhardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A single-precision floating-point\nnumber is accurate to approximately 7 decimal places.\n\nUNSIGNED, if specified, disallows negative values.\n\nUsing FLOAT might give you some unexpected problems because all\ncalculations in MySQL are done with double precision. See\nhttps://mariadb.com/kb/en/floating-point-accuracy/.\n\nURL: https://mariadb.com/kb/en/float/\n\n','','https://mariadb.com/kb/en/float/'),(169,'LOCATE',37,'Syntax:\nLOCATE(substr,str), LOCATE(substr,str,pos)\n\nThe first syntax returns the position of the first occurrence of\nsubstring substr in string str. The second syntax returns the position\nof the first occurrence of substring substr in string str, starting at\nposition pos. Returns 0 if substr is not in str.\n\nURL: https://mariadb.com/kb/en/locate/\n\n','MariaDB> SELECT LOCATE(\'bar\', \'foobarbar\');\n        -> 4\nMariaDB> SELECT LOCATE(\'xbar\', \'foobar\');\n        -> 0\nMariaDB> SELECT LOCATE(\'bar\', \'foobarbar\', 5);\n        -> 7\n','https://mariadb.com/kb/en/locate/'),(170,'SHOW EVENTS',26,'Syntax:\nSHOW EVENTS [{FROM | IN} schema_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement displays information about Event Manager events. It\nrequires the EVENT privilege for the database from which the events are\nto be shown.\n\nIn its simplest form, SHOW EVENTS lists all of the events in the\ncurrent schema:\n\nMariaDB> SELECT CURRENT_USER(), SCHEMA();\n+----------------+----------+\n| CURRENT_USER() | SCHEMA() |\n+----------------+----------+\n| jon@ghidora    | myschema |\n+----------------+----------+\n1 row in set (0.00 sec)\n\nMariaDB> SHOW EVENTS\\G\n*************************** 1. row ***************************\n                  Db: myschema\n                Name: e_daily\n             Definer: jon@ghidora\n           Time zone: SYSTEM\n                Type: RECURRING\n          Execute at: NULL\n      Interval value: 10\n      Interval field: SECOND\n              Starts: 2006-02-09 10:41:23\n                Ends: NULL\n              Status: ENABLED\n          Originator: 0\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\nTo see events for a specific schema, use the FROM clause. For example,\nto see events for the test schema, use the following statement:\n\nSHOW EVENTS FROM test;\n\nThe LIKE clause, if present, indicates which event names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nURL: https://mariadb.com/kb/en/show-events/\n\n','','https://mariadb.com/kb/en/show-events/'),(171,'CHARSET',17,'Syntax:\nCHARSET(str)\n\nReturns the character set of the string argument.\n\nURL: https://mariadb.com/kb/en/charset/\n\n','MariaDB> SELECT CHARSET(\'abc\');\n        -> \'latin1\'\nMariaDB> SELECT CHARSET(CONVERT(\'abc\' USING utf8));\n        -> \'utf8\'\nMariaDB> SELECT CHARSET(USER());\n        -> \'utf8\'\n','https://mariadb.com/kb/en/charset/'),(172,'SUBDATE',31,'Syntax:\nSUBDATE(date,INTERVAL expr unit), SUBDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, SUBDATE()\nis a synonym for DATE_SUB(). For information on the INTERVAL unit\nargument, see the discussion for DATE_ADD().\n\nMariaDB> SELECT DATE_SUB(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\nMariaDB> SELECT SUBDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\n\nThe second form enables the use of an integer value for days. In such\ncases, it is interpreted as the number of days to be subtracted from\nthe date or datetime expression expr.\n\nMariaDB> SELECT SUBDATE(\'2008-01-02 12:00:00\', 31);\n        -> \'2007-12-02 12:00:00\'\n\nURL: https://mariadb.com/kb/en/subdate/\n\n','','https://mariadb.com/kb/en/subdate/'),(173,'DAYOFYEAR',31,'Syntax:\nDAYOFYEAR(date)\n\nReturns the day of the year for date, in the range 1 to 366.\n\nURL: https://mariadb.com/kb/en/dayofyear/\n\n','MariaDB> SELECT DAYOFYEAR(\'2007-02-03\');\n        -> 34\n','https://mariadb.com/kb/en/dayofyear/'),(174,'%',4,'Syntax:\nN % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M. For more\ninformation, see the description for the MOD() function in\nhttps://mariadb.com/kb/en/mod/.\n\nURL: https://mariadb.com/kb/en/modulo-operator/\n\n','','https://mariadb.com/kb/en/modulo-operator/'),(175,'LONGTEXT',22,'LONGTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 4,294,967,295 or 4GB (232 - 1)\ncharacters. The effective maximum length is less if the value contains\nmulti-byte characters. The effective maximum length of LONGTEXT columns\nalso depends on the configured maximum packet size in the client/server\nprotocol and available memory. Each LONGTEXT value is stored using a\n4-byte length prefix that indicates the number of bytes in the value.\n\nURL: https://mariadb.com/kb/en/longtext/\n\n','','https://mariadb.com/kb/en/longtext/'),(176,'KILL',26,'Syntax:\nKILL [CONNECTION | QUERY] thread_id\n\nEach connection to mysqld runs in a separate thread. You can see which\nthreads are running with the SHOW PROCESSLIST statement and kill a\nthread with the KILL thread_id statement.\n\nKILL permits an optional CONNECTION or QUERY modifier:\n\no KILL CONNECTION is the same as KILL with no modifier: It terminates\n  the connection associated with the given thread_id.\n\no KILL QUERY terminates the statement that the connection is currently\n  executing, but leaves the connection itself intact.\n\nIf you have the PROCESS privilege, you can see all threads. If you have\nthe SUPER privilege, you can kill all threads and statements.\nOtherwise, you can see and kill only your own threads and statements.\n\nYou can also use the mysqladmin processlist and mysqladmin kill\ncommands to examine and kill threads.\n\n*Note*: You cannot use KILL with the Embedded MySQL Server library\nbecause the embedded server merely runs inside the threads of the host\napplication. It does not create any connection threads of its own.\n\nURL: https://mariadb.com/kb/en/data-manipulation-kill-connection-query/\n\n','','https://mariadb.com/kb/en/data-manipulation-kill-connection-query/'),(177,'DISJOINT',30,'Disjoint(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially disjoint from (does\nnot intersect) g2.\n\nURL: https://mariadb.com/kb/en/disjoint/\n\n','','https://mariadb.com/kb/en/disjoint/'),(178,'ASTEXT',3,'AsText(g), AsWKT(g)\n\nConverts a value in internal geometry format to its WKT representation\nand returns the string result.\n\nURL: https://mariadb.com/kb/en/astext/\n\n','MariaDB> SET @g = \'LineString(1 1,2 2,3 3)\';\nMariaDB> SELECT AsText(GeomFromText(@g));\n+--------------------------+\n| AsText(GeomFromText(@g)) |\n+--------------------------+\n| LINESTRING(1 1,2 2,3 3)  |\n+--------------------------+\n','https://mariadb.com/kb/en/astext/'),(179,'LPAD',37,'Syntax:\nLPAD(str,len,padstr)\n\nReturns the string str, left-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\n\nURL: https://mariadb.com/kb/en/lpad/\n\n','MariaDB> SELECT LPAD(\'hi\',4,\'??\');\n        -> \'??hi\'\nMariaDB> SELECT LPAD(\'hi\',1,\'??\');\n        -> \'h\'\n','https://mariadb.com/kb/en/lpad/'),(180,'DECLARE CONDITION',23,'Syntax:\nDECLARE condition_name CONDITION FOR condition_value\n\ncondition_value:\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n\nThe DECLARE ... CONDITION statement declares a named error condition,\nassociating a name with a condition that needs specific handling. The\nname can be referred to in a subsequent DECLARE ... HANDLER statement\n(see [HELP DECLARE HANDLER]).\n\nCondition declarations must appear before cursor or handler\ndeclarations.\n\nThe condition_value for DECLARE ... CONDITION can be a MySQL error code\n(a number) or an SQLSTATE value (a 5-character string literal). You\nshould not use MySQL error code 0 or SQLSTATE values that begin with\n\'00\', because those indicate success rather than an error condition.\nFor a list of MySQL error codes and SQLSTATE values, see\nhttps://mariadb.com/kb/en/mariadb-error-codes/.\n\nURL: https://mariadb.com/kb/en/declare-condition/\n\n','','https://mariadb.com/kb/en/declare-condition/'),(181,'OVERLAPS',30,'Overlaps(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially overlaps g2. The term\nspatially overlaps is used if two geometries intersect and their\nintersection results in a geometry of the same dimension but not equal\nto either of the given geometries.\n\nURL: https://mariadb.com/kb/en/overlaps/\n\n','','https://mariadb.com/kb/en/overlaps/'),(182,'SET GLOBAL SQL_SLAVE_SKIP_COUNTER',8,'Syntax:\nSET GLOBAL sql_slave_skip_counter = N\n\nThis statement skips the next N events from the master. This is useful\nfor recovering from replication stops caused by a statement.\n\nThis statement is valid only when the slave threads are not running.\nOtherwise, it produces an error.\n\nURL: https://mariadb.com/kb/en/set-global-sql_slave_skip_counter/\n\n','','https://mariadb.com/kb/en/set-global-sql_slave_skip_counter/'),(183,'NUMGEOMETRIES',25,'NumGeometries(gc)\n\nReturns the number of geometries in the GeometryCollection value gc.\n\nURL: https://mariadb.com/kb/en/numgeometries/\n\n','MariaDB> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nMariaDB> SELECT NumGeometries(GeomFromText(@gc));\n+----------------------------------+\n| NumGeometries(GeomFromText(@gc)) |\n+----------------------------------+\n|                                2 |\n+----------------------------------+\n','https://mariadb.com/kb/en/numgeometries/'),(184,'MONTHNAME',31,'Syntax:\nMONTHNAME(date)\n\nReturns the full name of the month for date. The language used for the\nname is controlled by the value of the lc_time_names system variable\n(https://mariadb.com/kb/en/server-locale/).\n\nURL: https://mariadb.com/kb/en/monthname/\n\n','MariaDB> SELECT MONTHNAME(\'2008-02-03\');\n        -> \'February\'\n','https://mariadb.com/kb/en/monthname/'),(185,'CHANGE MASTER TO',8,'Syntax:\nCHANGE MASTER TO option [, option] ...\n\noption:\n    MASTER_BIND = \'interface_name\'\n  | MASTER_HOST = \'host_name\'\n  | MASTER_USER = \'user_name\'\n  | MASTER_PASSWORD = \'password\'\n  | MASTER_PORT = port_num\n  | MASTER_CONNECT_RETRY = interval\n  | MASTER_HEARTBEAT_PERIOD = interval\n  | MASTER_LOG_FILE = \'master_log_name\'\n  | MASTER_LOG_POS = master_log_pos\n  | RELAY_LOG_FILE = \'relay_log_name\'\n  | RELAY_LOG_POS = relay_log_pos\n  | MASTER_SSL = {0|1}\n  | MASTER_SSL_CA = \'ca_file_name\'\n  | MASTER_SSL_CAPATH = \'ca_directory_name\'\n  | MASTER_SSL_CERT = \'cert_file_name\'\n  | MASTER_SSL_KEY = \'key_file_name\'\n  | MASTER_SSL_CIPHER = \'cipher_list\'\n  | MASTER_SSL_VERIFY_SERVER_CERT = {0|1}\n  | IGNORE_SERVER_IDS = (server_id_list)\n\nserver_id_list:\n    [server_id [, server_id] ... ]\n\nCHANGE MASTER TO changes the parameters that the slave server uses for\nconnecting to the master server, for reading the master binary log, and\nreading the slave relay log. It also updates the contents of the\nmaster.info and relay-log.info files. To use CHANGE MASTER TO, the\nslave replication threads must be stopped (use STOP SLAVE if\nnecessary).\n\nOptions not specified retain their value, except as indicated in the\nfollowing discussion. Thus, in most cases, there is no need to specify\noptions that do not change. For example, if the password to connect to\nyour MySQL master has changed, you just need to issue these statements\nto tell the slave about the new password:\n\nSTOP SLAVE; -- if replication was running\nCHANGE MASTER TO MASTER_PASSWORD=\'new3cret\';\nSTART SLAVE; -- if you want to restart replication\n\nMASTER_HOST, MASTER_USER, MASTER_PASSWORD, and MASTER_PORT provide\ninformation to the slave about how to connect to its master:\n\no MASTER_HOST and MASTER_PORT are the host name (or IP address) of the\n  master host and its TCP/IP port.\n\n  *Note*: Replication cannot use Unix socket files. You must be able to\n  connect to the master MySQL server using TCP/IP.\n\n  If you specify the MASTER_HOST or MASTER_PORT option, the slave\n  assumes that the master server is different from before (even if the\n  option value is the same as its current value.) In this case, the old\n  values for the master binary log file name and position are\n  considered no longer applicable, so if you do not specify\n  MASTER_LOG_FILE and MASTER_LOG_POS in the statement,\n  MASTER_LOG_FILE=\'\' and MASTER_LOG_POS=4 are silently appended to it.\n\n  Setting MASTER_HOST=\'\' (that is, setting its value explicitly to an\n  empty string) is not the same as not setting MASTER_HOST at all.\n  Beginning with MySQL 5.5, trying to set MASTER_HOST to an empty\n  string fails with an error. Previously, setting MASTER_HOST to an\n  empty string caused START SLAVE subsequently to fail. (Bug #28796)\n\no MASTER_USER and MASTER_PASSWORD are the user name and password of the\n  account to use for connecting to the master.\n\n  In MySQL 5.5.20 and later, MASTER_USER cannot be made empty; setting\n  MASTER_USER = \'\' or leaving it unset when setting a value for for\n  MASTER_PASSWORD causes an error (Bug #13427949).\n\n  Currently, a password used for a replication slave account is\n  effectively limited to 32 characters in length; the password can be\n  longer, but any excess characters are truncated. This is not due to\n  any limit imposed by the MySQL Server generally, but rather is an\n  issue specific to MySQL Replication. (For more information, see Bug\n  #43439.)\n\n  The text of a running CHANGE MASTER TO statement, including values\n  for MASTER_USER and MASTER_PASSWORD, can be seen in the output of a\n  concurrent SHOW PROCESSLIST statement.\n\nThe MASTER_SSL_xxx options provide information about using SSL for the\nconnection. They correspond to the --ssl-xxx options described in\nhttps://mariadb.com/kb/en/ssl-server-system-variables/, and\nhttp://dev.mysql.com/doc/refman/5.5/en/replication-solutions-ssl.html.\nThese options can be changed even on slaves that are compiled without\nSSL support. They are saved to the master.info file, but are ignored if\nthe slave does not have SSL support enabled.\n\nMASTER_CONNECT_RETRY specifies how many seconds to wait between connect\nretries. The default is 60. The number of reconnection attempts is\nlimited by the --master-retry-count server option; for more\ninformation, see\nhttps://mariadb.com/kb/en/replication-and-binary-log-server-system-variables/.\n\nMASTER_HEARTBEAT_PERIOD sets the interval in seconds between\nreplication heartbeats. Whenever the master\'s binary log is updated\nwith an event, the waiting period for the next heartbeat is reset.\ninterval is a decimal value having the range 0 to 4294967 seconds and a\nresolution in milliseconds; the smallest nonzero value is 0.001.\nHeartbeats are sent by the master only if there are no unsent events in\nthe binary log file for a period longer than interval.\n\nSetting interval to 0 disables heartbeats altogether. The default value\nfor interval is equal to the value of slave_net_timeout divided by 2.\n\nSetting @@global.slave_net_timeout to a value less than that of the\ncurrent heartbeat interval results in a warning being issued. The\neffect of issuing RESET SLAVE on the heartbeat interval is to reset it\nto the default value.\n\nMASTER_LOG_FILE and MASTER_LOG_POS are the coordinates at which the\nslave I/O thread should begin reading from the master the next time the\nthread starts. RELAY_LOG_FILE and RELAY_LOG_POS are the coordinates at\nwhich the slave SQL thread should begin reading from the relay log the\nnext time the thread starts. If you specify either of MASTER_LOG_FILE\nor MASTER_LOG_POS, you cannot specify RELAY_LOG_FILE or RELAY_LOG_POS.\nIf neither of MASTER_LOG_FILE or MASTER_LOG_POS is specified, the slave\nuses the last coordinates of the slave SQL thread before CHANGE MASTER\nTO was issued. This ensures that there is no discontinuity in\nreplication, even if the slave SQL thread was late compared to the\nslave I/O thread, when you merely want to change, say, the password to\nuse.\n\nCHANGE MASTER TO deletes all relay log files and starts a new one,\nunless you specify RELAY_LOG_FILE or RELAY_LOG_POS. In that case, relay\nlog files are kept; the relay_log_purge global variable is set silently\nto 0.\n\nPrior to MySQL 5.5, RELAY_LOG_FILE required an absolute path. In MySQL\n5.5, the path can be relative, in which case the path is assumed to be\nrelative to the slave\'s data directory. (Bug #12190)\n\nIGNORE_SERVER_IDS was added in MySQL 5.5. This option takes a\ncomma-separated list of 0 or more server IDs. Events originating from\nthe corresponding servers are ignored, with the exception of log\nrotation and deletion events, which are still recorded in the relay\nlog.\n\nIn circular replication, the originating server normally acts as the\nterminator of its own events, so that they are not applied more than\nonce. Thus, this option is useful in circular replication when one of\nthe servers in the circle is removed. Suppose that you have a circular\nreplication setup with 4 servers, having server IDs 1, 2, 3, and 4, and\nserver 3 fails. When bridging the gap by starting replication from\nserver 2 to server 4, you can include IGNORE_SERVER_IDS = (3) in the\nCHANGE MASTER TO statement that you issue on server 4 to tell it to use\nserver 2 as its master instead of server 3. Doing so causes it to\nignore and not to propagate any statements that originated with the\nserver that is no longer in use.\n\nIf a CHANGE MASTER TO statement is issued without any IGNORE_SERVER_IDS\noption, any existing list is preserved; RESET SLAVE also has no effect\non the server ID list. To clear the list of ignored servers, it is\nnecessary to use the option with an empty list:\n\nCHANGE MASTER TO IGNORE_SERVER_IDS = ();\n\nIf IGNORE_SERVER_IDS contains the server\'s own ID and the server was\nstarted with the --replicate-same-server-id option enabled, an error\nresults.\n\nAlso beginning with MySQL 5.5, the master.info file and the output of\nSHOW SLAVE STATUS are extended to provide the list of servers that are\ncurrently ignored. For more information, see\nhttps://mariadb.com/kb/en/show-slave-status/, and\n[HELP SHOW SLAVE STATUS].\n\nBeginning with MySQL 5.5.5, invoking CHANGE MASTER TO causes the\nprevious values for MASTER_HOST, MASTER_PORT, MASTER_LOG_FILE, and\nMASTER_LOG_POS to be written to the error log, along with other\ninformation about the slave\'s state prior to execution.\n\nCHANGE MASTER TO is useful for setting up a slave when you have the\nsnapshot of the master and have recorded the master binary log\ncoordinates corresponding to the time of the snapshot. After loading\nthe snapshot into the slave to synchronize it to the slave, you can run\nCHANGE MASTER TO MASTER_LOG_FILE=\'log_name\', MASTER_LOG_POS=log_pos on\nthe slave to specify the coordinates at which the slave should begin\nreading the master binary log.\n\nThe following example changes the master server the slave uses and\nestablishes the master binary log coordinates from which the slave\nbegins reading. This is used when you want to set up the slave to\nreplicate the master:\n\nCHANGE MASTER TO\n  MASTER_HOST=\'master2.mycompany.com\',\n  MASTER_USER=\'replication\',\n  MASTER_PASSWORD=\'bigs3cret\',\n  MASTER_PORT=3306,\n  MASTER_LOG_FILE=\'master2-bin.001\',\n  MASTER_LOG_POS=4,\n  MASTER_CONNECT_RETRY=10;\n\nThe next example shows an operation that is less frequently employed.\nIt is used when the slave has relay log files that you want it to\nexecute again for some reason. To do this, the master need not be\nreachable. You need only use CHANGE MASTER TO and start the SQL thread\n(START SLAVE SQL_THREAD):\n\nCHANGE MASTER TO\n  RELAY_LOG_FILE=\'slave-relay-bin.006\',\n  RELAY_LOG_POS=4025;\n\nURL: https://mariadb.com/kb/en/change-master-to/\n\n','','https://mariadb.com/kb/en/change-master-to/'),(186,'DROP DATABASE',39,'Syntax:\nDROP {DATABASE | SCHEMA} [IF EXISTS] db_name\n\nDROP DATABASE drops all tables in the database and deletes the\ndatabase. Be very careful with this statement! To use DROP DATABASE,\nyou need the DROP privilege on the database. DROP SCHEMA is a synonym\nfor DROP DATABASE.\n\n*Important*: When a database is dropped, user privileges on the\ndatabase are not automatically dropped. See [HELP GRANT].\n\nIF EXISTS is used to prevent an error from occurring if the database\ndoes not exist.\n\nURL: https://mariadb.com/kb/en/drop-database/\n\n','','https://mariadb.com/kb/en/drop-database/'),(187,'MBREQUAL',6,'MBREqual(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 are the same.\n\nURL: https://mariadb.com/kb/en/mbrequal/\n\n','','https://mariadb.com/kb/en/mbrequal/'),(188,'TIMESTAMP FUNCTION',31,'Syntax:\nTIMESTAMP(expr), TIMESTAMP(expr1,expr2)\n\nWith a single argument, this function returns the date or datetime\nexpression expr as a datetime value. With two arguments, it adds the\ntime expression expr2 to the date or datetime expression expr1 and\nreturns the result as a datetime value.\n\nURL: https://mariadb.com/kb/en/timestamp-function/\n\n','MariaDB> SELECT TIMESTAMP(\'2003-12-31\');\n        -> \'2003-12-31 00:00:00\'\nMariaDB> SELECT TIMESTAMP(\'2003-12-31 12:00:00\',\'12:00:00\');\n        -> \'2004-01-01 00:00:00\'\n','https://mariadb.com/kb/en/timestamp-function/'),(189,'PROCEDURE ANALYSE',33,'Syntax:\nANALYSE([max_elements[,max_memory]])\n\nANALYSE() examines the result from a query and returns an analysis of\nthe results that suggests optimal data types for each column that may\nhelp reduce table sizes. To obtain this analysis, append PROCEDURE\nANALYSE to the end of a SELECT statement:\n\nSELECT ... FROM ... WHERE ... PROCEDURE ANALYSE([max_elements,[max_memory]])\n\nFor example:\n\nSELECT col1, col2 FROM table1 PROCEDURE ANALYSE(10, 2000);\n\nThe results show some statistics for the values returned by the query,\nand propose an optimal data type for the columns. This can be helpful\nfor checking your existing tables, or after importing new data. You may\nneed to try different settings for the arguments so that PROCEDURE\nANALYSE() does not suggest the ENUM data type when it is not\nappropriate.\n\nThe arguments are optional and are used as follows:\n\no max_elements (default 256) is the maximum number of distinct values\n  that ANALYSE() notices per column. This is used by ANALYSE() to check\n  whether the optimal data type should be of type ENUM; if there are\n  more than max_elements distinct values, then ENUM is not a suggested\n  type.\n\no max_memory (default 8192) is the maximum amount of memory that\n  ANALYSE() should allocate per column while trying to find all\n  distinct values.\n\nURL: https://mariadb.com/kb/en/procedure-analyse/\n\n','','https://mariadb.com/kb/en/procedure-analyse/'),(190,'HELP_VERSION',9,'This help information was generated from the MySQL 5.5 Reference Manual\non: 2012-08-25 (revision: 31914)\n\nThis information applies to MySQL 5.5 through 5.5.29.\n','',''),(191,'CHARACTER_LENGTH',37,'Syntax:\nCHARACTER_LENGTH(str)\n\nCHARACTER_LENGTH() is a synonym for CHAR_LENGTH().\n\nURL: https://mariadb.com/kb/en/character_length/\n\n','','https://mariadb.com/kb/en/character_length/'),(192,'SHOW GRANTS',26,'Syntax:\nSHOW GRANTS [FOR user]\n\nThis statement lists the GRANT statement or statements that must be\nissued to duplicate the privileges that are granted to a MySQL user\naccount. The account is named using the same format as for the GRANT\nstatement; for example, \'jeffrey\'@\'localhost\'. If you specify only the\nuser name part of the account name, a host name part of \'%\' is used.\nFor additional information about specifying account names, see [HELP\nGRANT].\n\nMariaDB> SHOW GRANTS FOR \'root\'@\'localhost\';\n+---------------------------------------------------------------------+\n| Grants for root@localhost                                           |\n+---------------------------------------------------------------------+\n| GRANT ALL PRIVILEGES ON *.* TO \'root\'@\'localhost\' WITH GRANT OPTION |\n+---------------------------------------------------------------------+\n\nTo list the privileges granted to the account that you are using to\nconnect to the server, you can use any of the following statements:\n\nSHOW GRANTS;\nSHOW GRANTS FOR CURRENT_USER;\nSHOW GRANTS FOR CURRENT_USER();\n\nIf SHOW GRANTS FOR CURRENT_USER (or any of the equivalent syntaxes) is\nused in DEFINER context, such as within a stored procedure that is\ndefined with SQL SECURITY DEFINER), the grants displayed are those of\nthe definer and not the invoker.\n\nURL: https://mariadb.com/kb/en/show-grants/\n\n','','https://mariadb.com/kb/en/show-grants/'),(193,'SHOW PRIVILEGES',26,'Syntax:\nSHOW PRIVILEGES\n\nSHOW PRIVILEGES shows the list of system privileges that the MySQL\nserver supports. The exact list of privileges depends on the version of\nyour server.\n\nURL: https://mariadb.com/kb/en/show-privileges/\n\n','','https://mariadb.com/kb/en/show-privileges/'),(194,'CREATE TABLESPACE',39,'Syntax:\nCREATE TABLESPACE tablespace_name\n    ADD DATAFILE \'file_name\'\n    USE LOGFILE GROUP logfile_group\n    [EXTENT_SIZE [=] extent_size]\n    [INITIAL_SIZE [=] initial_size]\n    [AUTOEXTEND_SIZE [=] autoextend_size]\n    [MAX_SIZE [=] max_size]\n    [NODEGROUP [=] nodegroup_id]\n    [WAIT]\n    [COMMENT [=] comment_text]\n    ENGINE [=] engine_name\n\nThis statement is used with NDB cluster, which is not supported by MariaDB.','','https://mariadb.com/kb/en/create-tablespace/'),(195,'INSERT FUNCTION',37,'Syntax:\nINSERT(str,pos,len,newstr)\n\nReturns the string str, with the substring beginning at position pos\nand len characters long replaced by the string newstr. Returns the\noriginal string if pos is not within the length of the string. Replaces\nthe rest of the string from position pos if len is not within the\nlength of the rest of the string. Returns NULL if any argument is NULL.\n\nURL: https://mariadb.com/kb/en/insert-function/\n\n','MariaDB> SELECT INSERT(\'Quadratic\', 3, 4, \'What\');\n        -> \'QuWhattic\'\nMariaDB> SELECT INSERT(\'Quadratic\', -1, 4, \'What\');\n        -> \'Quadratic\'\nMariaDB> SELECT INSERT(\'Quadratic\', 3, 100, \'What\');\n        -> \'QuWhat\'\n','https://mariadb.com/kb/en/insert-function/'),(196,'CRC32',4,'Syntax:\nCRC32(expr)\n\nComputes a cyclic redundancy check value and returns a 32-bit unsigned\nvalue. The result is NULL if the argument is NULL. The argument is\nexpected to be a string and (if possible) is treated as one if it is\nnot.\n\nURL: https://mariadb.com/kb/en/crc32/\n\n','MariaDB> SELECT CRC32(\'MySQL\');\n        -> 3259397556\nMariaDB> SELECT CRC32(\'mysql\');\n        -> 2501908538\n','https://mariadb.com/kb/en/crc32/'),(197,'XOR',15,'Syntax:\nXOR\n\nLogical XOR. Returns NULL if either operand is NULL. For non-NULL\noperands, evaluates to 1 if an odd number of operands is nonzero,\notherwise 0 is returned.\n\nURL: https://mariadb.com/kb/en/xor/\n\n','MariaDB> SELECT 1 XOR 1;\n        -> 0\nMariaDB> SELECT 1 XOR 0;\n        -> 1\nMariaDB> SELECT 1 XOR NULL;\n        -> NULL\nMariaDB> SELECT 1 XOR 1 XOR 1;\n        -> 1\n','https://mariadb.com/kb/en/xor/'),(198,'STARTPOINT',13,'StartPoint(ls)\n\nReturns the Point that is the start point of the LineString value ls.\n\nURL: https://mariadb.com/kb/en/startpoint/\n\n','MariaDB> SET @ls = \'LineString(1 1,2 2,3 3)\';\nMariaDB> SELECT AsText(StartPoint(GeomFromText(@ls)));\n+---------------------------------------+\n| AsText(StartPoint(GeomFromText(@ls))) |\n+---------------------------------------+\n| POINT(1 1)                            |\n+---------------------------------------+\n','https://mariadb.com/kb/en/startpoint/'),(199,'GRANT',10,'Syntax:\nGRANT\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    TO user_specification [, user_specification] ...\n    [REQUIRE {NONE | ssl_option [[AND] ssl_option] ...}]\n    [WITH with_option ...]\n\nGRANT PROXY ON user_specification\n    TO user_specification [, user_specification] ...\n    [WITH GRANT OPTION]\n\nobject_type:\n    TABLE\n  | FUNCTION\n  | PROCEDURE\n\npriv_level:\n    *\n  | *.*\n  | db_name.*\n  | db_name.tbl_name\n  | tbl_name\n  | db_name.routine_name\n\nuser_specification:\n    user\n    [\n        IDENTIFIED BY [PASSWORD] \'password\'\n      | IDENTIFIED WITH auth_plugin [AS \'auth_string\']\n    ]\n\nssl_option:\n    SSL\n  | X509\n  | CIPHER \'cipher\'\n  | ISSUER \'issuer\'\n  | SUBJECT \'subject\'\n\nwith_option:\n    GRANT OPTION\n  | MAX_QUERIES_PER_HOUR count\n  | MAX_UPDATES_PER_HOUR count\n  | MAX_CONNECTIONS_PER_HOUR count\n  | MAX_USER_CONNECTIONS count\n\nThe GRANT statement grants privileges to MySQL user accounts. GRANT\nalso serves to specify other account characteristics such as use of\nsecure connections and limits on access to server resources. To use\nGRANT, you must have the GRANT OPTION privilege, and you must have the\nprivileges that you are granting.\n\nNormally, a database administrator first uses CREATE USER to create an\naccount, then GRANT to define its privileges and characteristics. For\nexample:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\nGRANT ALL ON db1.* TO \'jeffrey\'@\'localhost\';\nGRANT SELECT ON db2.invoice TO \'jeffrey\'@\'localhost\';\nGRANT USAGE ON *.* TO \'jeffrey\'@\'localhost\' WITH MAX_QUERIES_PER_HOUR 90;\n\nHowever, if an account named in a GRANT statement does not already\nexist, GRANT may create it under the conditions described later in the\ndiscussion of the NO_AUTO_CREATE_USER SQL mode.\n\nThe REVOKE statement is related to GRANT and enables administrators to\nremove account privileges. See [HELP REVOKE].\n\nWhen successfully executed from the mysql program, GRANT responds with\nQuery OK, 0 rows affected. To determine what privileges result from the\noperation, use SHOW GRANTS. See [HELP SHOW GRANTS].\n\nURL: https://mariadb.com/kb/en/grant/\n\n','','https://mariadb.com/kb/en/grant/'),(200,'DECLARE VARIABLE',23,'Syntax:\nDECLARE var_name [, var_name] ... type [DEFAULT value]\n\nThis statement declares local variables within stored programs. To\nprovide a default value for a variable, include a DEFAULT clause. The\nvalue can be specified as an expression; it need not be a constant. If\nthe DEFAULT clause is missing, the initial value is NULL.\n\nLocal variables are treated like stored routine parameters with respect\nto data type and overflow checking. See [HELP CREATE PROCEDURE].\n\nVariable declarations must appear before cursor or handler\ndeclarations.\n\nLocal variable names are not case sensitive. Permissible characters and\nquoting rules are the same as for other identifiers, as described in\nhttps://mariadb.com/kb/en/identifier-names/.\n\nThe scope of a local variable is the BEGIN ... END block within which\nit is declared. The variable can be referred to in blocks nested within\nthe declaring block, except those blocks that declare a variable with\nthe same name.\n\nURL: https://mariadb.com/kb/en/declare-variable/\n\n','','https://mariadb.com/kb/en/declare-variable/'),(201,'MPOLYFROMTEXT',3,'MPolyFromText(wkt[,srid]), MultiPolygonFromText(wkt[,srid])\n\nConstructs a MULTIPOLYGON value using its WKT representation and SRID.\n\nURL: https://mariadb.com/kb/en/mpolyfromtext/\n\n','','https://mariadb.com/kb/en/mpolyfromtext/'),(202,'MBRINTERSECTS',6,'MBRIntersects(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 intersect.\n\nURL: https://mariadb.com/kb/en/mbrintersects/\n\n','','https://mariadb.com/kb/en/mbrintersects/'),(203,'BIT_OR',16,'Syntax:\nBIT_OR(expr)\n\nReturns the bitwise OR of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: https://mariadb.com/kb/en/bit_or/\n\n','','https://mariadb.com/kb/en/bit_or/'),(204,'YEARWEEK',31,'Syntax:\nYEARWEEK(date), YEARWEEK(date,mode)\n\nReturns year and week for a date. The mode argument works exactly like\nthe mode argument to WEEK(). The year in the result may be different\nfrom the year in the date argument for the first and the last week of\nthe year.\n\nURL: https://mariadb.com/kb/en/yearweek/\n\n','MariaDB> SELECT YEARWEEK(\'1987-01-01\');\n        -> 198653\n','https://mariadb.com/kb/en/yearweek/'),(205,'NOT BETWEEN',18,'Syntax:\nexpr NOT BETWEEN min AND max\n\nThis is the same as NOT (expr BETWEEN min AND max).\n\nURL: https://mariadb.com/kb/en/not-between/\n\n','','https://mariadb.com/kb/en/not-between/'),(206,'IS NOT',18,'Syntax:\nIS NOT boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: https://mariadb.com/kb/en/is-not/\n\n','MariaDB> SELECT 1 IS NOT UNKNOWN, 0 IS NOT UNKNOWN, NULL IS NOT UNKNOWN;\n        -> 1, 1, 0\n','https://mariadb.com/kb/en/is-not/'),(207,'LOG10',4,'Syntax:\nLOG10(X)\n\nReturns the base-10 logarithm of X.\n\nURL: https://mariadb.com/kb/en/log10/\n\n','MariaDB> SELECT LOG10(2);\n        -> 0.30102999566398\nMariaDB> SELECT LOG10(100);\n        -> 2\nMariaDB> SELECT LOG10(-100);\n        -> NULL\n','https://mariadb.com/kb/en/log10/'),(208,'SQRT',4,'Syntax:\nSQRT(X)\n\nReturns the square root of a nonnegative number X.\n\nURL: https://mariadb.com/kb/en/sqrt/\n\n','MariaDB> SELECT SQRT(4);\n        -> 2\nMariaDB> SELECT SQRT(20);\n        -> 4.4721359549996\nMariaDB> SELECT SQRT(-16);\n        -> NULL\n','https://mariadb.com/kb/en/sqrt/'),(209,'DECIMAL',22,'DECIMAL[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nA packed \"exact\" fixed-point number. M is the total number of digits\n(the precision) and D is the number of digits after the decimal point\n(the scale). The decimal point and (for negative numbers) the \"-\" sign\nare not counted in M. If D is 0, values have no decimal point or\nfractional part. The maximum number of digits (M) for DECIMAL is 65.\nThe maximum number of supported decimals (D) is 30. If D is omitted,\nthe default is 0. If M is omitted, the default is 10.\n\nUNSIGNED, if specified, disallows negative values.\n\nAll basic calculations (+, -, *, /) with DECIMAL columns are done with\na precision of 65 digits.\n\nURL: https://mariadb.com/kb/en/decimal/\n\n','','https://mariadb.com/kb/en/decimal/'),(210,'CREATE INDEX',39,'Syntax:\nCREATE [ONLINE|OFFLINE] [UNIQUE|FULLTEXT|SPATIAL] INDEX index_name\n    [index_type]\n    ON tbl_name (index_col_name,...)\n    [index_option] ...\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n\nCREATE INDEX is mapped to an ALTER TABLE statement to create indexes.\nSee [HELP ALTER TABLE]. CREATE INDEX cannot be used to create a PRIMARY\nKEY; use ALTER TABLE instead. For more information about indexes, see\nhttps://mariadb.com/kb/en/optimization-and-indexes/.\n\nURL: https://mariadb.com/kb/en/create-index/\n\n','','https://mariadb.com/kb/en/create-index/'),(211,'CREATE FUNCTION',39,'The CREATE FUNCTION statement is used to create stored functions and\nuser-defined functions (UDFs):\n\no For information about creating stored functions, see [HELP CREATE\n  PROCEDURE].\n\no For information about creating user-defined functions, see [HELP\n  CREATE FUNCTION UDF].\n\nURL: https://mariadb.com/kb/en/create-function/\n\n','','https://mariadb.com/kb/en/create-function/'),(212,'ALTER DATABASE',39,'Syntax:\nALTER {DATABASE | SCHEMA} [db_name]\n    alter_specification ...\nALTER {DATABASE | SCHEMA} db_name\n    UPGRADE DATA DIRECTORY NAME\n\nalter_specification:\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n\nALTER DATABASE enables you to change the overall characteristics of a\ndatabase. These characteristics are stored in the db.opt file in the\ndatabase directory. To use ALTER DATABASE, you need the ALTER privilege\non the database. ALTER SCHEMA is a synonym for ALTER DATABASE.\n\nThe database name can be omitted from the first syntax, in which case\nthe statement applies to the default database.\n\nNational Language Characteristics\n\nThe CHARACTER SET clause changes the default database character set.\nThe COLLATE clause changes the default database collation.\nhttps://mariadb.com/kb/en/data-types-character-sets-and-collations/, discusses\ncharacter set and collation names.\n\nYou can see what character sets and collations are available using,\nrespectively, the SHOW CHARACTER SET and SHOW COLLATION statements. See\n[HELP SHOW CHARACTER SET], and [HELP SHOW COLLATION], for more\ninformation.\n\nIf you change the default character set or collation for a database,\nstored routines that use the database defaults must be dropped and\nrecreated so that they use the new defaults. (In a stored routine,\nvariables with character data types use the database defaults if the\ncharacter set or collation are not specified explicitly. See [HELP\nCREATE PROCEDURE].)\n\nUpgrading from Versions Older than MySQL 5.1\n\nThe syntax that includes the UPGRADE DATA DIRECTORY NAME clause updates\nthe name of the directory associated with the database to use the\nencoding implemented in MySQL 5.1 for mapping database names to\ndatabase directory names (see\nhttps://mariadb.com/kb/en/identifier-to-file-name-mapping/). This\nclause is for use under these conditions:\n\no It is intended when upgrading MySQL to 5.1 or later from older\n  versions.\n\no It is intended to update a database directory name to the current\n  encoding format if the name contains special characters that need\n  encoding.\n\no The statement is used by mysqlcheck (as invoked by mysql_upgrade).\n\nFor example, if a database in MySQL 5.0 has the name a-b-c, the name\ncontains instances of the - (dash) character. In MySQL 5.0, the\ndatabase directory is also named a-b-c, which is not necessarily safe\nfor all file systems. In MySQL 5.1 and later, the same database name is\nencoded as a@002db@002dc to produce a file system-neutral directory\nname.\n\nWhen a MySQL installation is upgraded to MySQL 5.1 or later from an\nolder version,the server displays a name such as a-b-c (which is in the\nold format) as #mysql50#a-b-c, and you must refer to the name using the\n#mysql50# prefix. Use UPGRADE DATA DIRECTORY NAME in this case to\nexplicitly tell the server to re-encode the database directory name to\nthe current encoding format:\n\nALTER DATABASE `#mysql50#a-b-c` UPGRADE DATA DIRECTORY NAME;\n\nAfter executing this statement, you can refer to the database as a-b-c\nwithout the special #mysql50# prefix.\n\nURL: https://mariadb.com/kb/en/alter-database/\n\n','','https://mariadb.com/kb/en/alter-database/'),(213,'GEOMETRYN',25,'GeometryN(gc,N)\n\nReturns the N-th geometry in the GeometryCollection value gc.\nGeometries are numbered beginning with 1.\n\nURL: https://mariadb.com/kb/en/geometryn/\n\n','MariaDB> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nMariaDB> SELECT AsText(GeometryN(GeomFromText(@gc),1));\n+----------------------------------------+\n| AsText(GeometryN(GeomFromText(@gc),1)) |\n+----------------------------------------+\n| POINT(1 1)                             |\n+----------------------------------------+\n','https://mariadb.com/kb/en/geometryn/'),(214,'<<',19,'Syntax:\n<<\n\nShifts a longlong (BIGINT) number to the left.\n\nURL: https://mariadb.com/kb/en/shift-left/\n\n','MariaDB> SELECT 1 << 2;\n        -> 4\n','https://mariadb.com/kb/en/shift-left/'),(215,'SHOW TABLE STATUS',26,'Syntax:\nSHOW TABLE STATUS [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLE STATUS works likes SHOW TABLES, but provides a lot of\ninformation about each non-TEMPORARY table. You can also get this list\nusing the mysqlshow --status db_name command. The LIKE clause, if\npresent, indicates which table names to match. The WHERE clause can be\ngiven to select rows using more general conditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nURL: https://mariadb.com/kb/en/show-table-status/\n\n','','https://mariadb.com/kb/en/show-table-status/'),(216,'MD5',12,'Syntax:\nMD5(str)\n\nCalculates an MD5 128-bit checksum for the string. The value is\nreturned as a string of 32 hex digits, or NULL if the argument was\nNULL. The return value can, for example, be used as a hash key. See the\nnotes at the beginning of this section about storing hash values\nefficiently.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring; see the notes at the beginning of this section about using the\nvalue as a nonbinary string.\n\nURL: https://mariadb.com/kb/en/md5/\n\n','MariaDB> SELECT MD5(\'testing\');\n        -> \'ae2b1fca515949e5d54fb22b8ed95575\'\n','https://mariadb.com/kb/en/md5/'),(217,'<',18,'Syntax:\n<\n\nLess than:\n\nURL: https://mariadb.com/kb/en/less-than/\n\n','MariaDB> SELECT 2 < 2;\n        -> 0\n','https://mariadb.com/kb/en/less-than/'),(218,'UNIX_TIMESTAMP',31,'Syntax:\nUNIX_TIMESTAMP(), UNIX_TIMESTAMP(date)\n\nIf called with no argument, returns a Unix timestamp (seconds since\n\'1970-01-01 00:00:00\' UTC) as an unsigned integer. If UNIX_TIMESTAMP()\nis called with a date argument, it returns the value of the argument as\nseconds since \'1970-01-01 00:00:00\' UTC. date may be a DATE string, a\nDATETIME string, a TIMESTAMP, or a number in the format YYMMDD or\nYYYYMMDD. The server interprets date as a value in the current time\nzone and converts it to an internal value in UTC. Clients can set their\ntime zone as described in\nhttps://mariadb.com/kb/en/time-zones/.\n\nURL: https://mariadb.com/kb/en/unix_timestamp/\n\n','MariaDB> SELECT UNIX_TIMESTAMP();\n        -> 1196440210\nMariaDB> SELECT UNIX_TIMESTAMP(\'2007-11-30 10:30:19\');\n        -> 1196440219\n','https://mariadb.com/kb/en/unix_timestamp/'),(219,'DAYOFMONTH',31,'Syntax:\nDAYOFMONTH(date)\n\nReturns the day of the month for date, in the range 1 to 31, or 0 for\ndates such as \'0000-00-00\' or \'2008-00-00\' that have a zero day part.\n\nURL: https://mariadb.com/kb/en/dayofmonth/\n\n','MariaDB> SELECT DAYOFMONTH(\'2007-02-03\');\n        -> 3\n','https://mariadb.com/kb/en/dayofmonth/'),(220,'ASCII',37,'Syntax:\nASCII(str)\n\nReturns the numeric value of the leftmost character of the string str.\nReturns 0 if str is the empty string. Returns NULL if str is NULL.\nASCII() works for 8-bit characters.\n\nURL: https://mariadb.com/kb/en/ascii/\n\n','MariaDB> SELECT ASCII(\'2\');\n        -> 50\nMariaDB> SELECT ASCII(2);\n        -> 50\nMariaDB> SELECT ASCII(\'dx\');\n        -> 100\n','https://mariadb.com/kb/en/ascii/'),(221,'DIV',4,'Syntax:\nDIV\n\nInteger division. Similar to FLOOR(), but is safe with BIGINT values.\n\nAs of MySQL 5.5.3, if either operand has a noninteger type, the\noperands are converted to DECIMAL and divided using DECIMAL arithmetic\nbefore converting the result to BIGINT. If the result exceeds BIGINT\nrange, an error occurs. Before MySQL 5.5.3, incorrect results may occur\nfor noninteger operands that exceed BIGINT range.\n\nURL: https://mariadb.com/kb/en/div/\n\n','MariaDB> SELECT 5 DIV 2;\n        -> 2\n','https://mariadb.com/kb/en/div/'),(222,'RENAME USER',10,'Syntax:\nRENAME USER old_user TO new_user\n    [, old_user TO new_user] ...\n\nThe RENAME USER statement renames existing MySQL accounts. To use it,\nyou must have the global CREATE USER privilege or the UPDATE privilege\nfor the mysql database. An error occurs if any old account does not\nexist or any new account exists. Each account name uses the format\ndescribed in https://mariadb.com/kb/en/create-user/#account-names.\nFor example:\n\nRENAME USER \'jeffrey\'@\'localhost\' TO \'jeff\'@\'127.0.0.1\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nRENAME USER causes the privileges held by the old user to be those held\nby the new user. However, RENAME USER does not automatically drop or\ninvalidate databases or objects within them that the old user created.\nThis includes stored programs or views for which the DEFINER attribute\nnames the old user. Attempts to access such objects may produce an\nerror if they execute in definer security context. (For information\nabout security context, see\nhttps://mariadb.com/kb/en/stored-routine-privileges/.)\n\nThe privilege changes take effect as indicated in\nhttp://dev.mysql.com/doc/refman/5.5/en/privilege-changes.html.\n\nURL: https://mariadb.com/kb/en/rename-user/\n\n','','https://mariadb.com/kb/en/rename-user/'),(223,'SHOW SLAVE STATUS',26,'Syntax:\nSHOW SLAVE STATUS\n\nThis statement provides status information on essential parameters of\nthe slave threads. It requires either the SUPER or REPLICATION CLIENT\nprivilege.\n\nIf you issue this statement using the mysql client, you can use a \\G\nstatement terminator rather than a semicolon to obtain a more readable\nvertical layout:\n\nMariaDB> SHOW SLAVE STATUS\\G\n*************************** 1. row ***************************\n               Slave_IO_State: Waiting for master to send event\n                  Master_Host: localhost\n                  Master_User: root\n                  Master_Port: 3306\n                Connect_Retry: 3\n              Master_Log_File: gbichot-bin.005\n          Read_Master_Log_Pos: 79\n               Relay_Log_File: gbichot-relay-bin.005\n                Relay_Log_Pos: 548\n        Relay_Master_Log_File: gbichot-bin.005\n             Slave_IO_Running: Yes\n            Slave_SQL_Running: Yes\n              Replicate_Do_DB:\n          Replicate_Ignore_DB:\n           Replicate_Do_Table:\n       Replicate_Ignore_Table:\n      Replicate_Wild_Do_Table:\n  Replicate_Wild_Ignore_Table:\n                   Last_Errno: 0\n                   Last_Error:\n                 Skip_Counter: 0\n          Exec_Master_Log_Pos: 79\n              Relay_Log_Space: 552\n              Until_Condition: None\n               Until_Log_File:\n                Until_Log_Pos: 0\n           Master_SSL_Allowed: No\n           Master_SSL_CA_File:\n           Master_SSL_CA_Path:\n              Master_SSL_Cert:\n            Master_SSL_Cipher:\n               Master_SSL_Key:\n        Seconds_Behind_Master: 8\nMaster_SSL_Verify_Server_Cert: No\n                Last_IO_Errno: 0\n                Last_IO_Error:\n               Last_SQL_Errno: 0\n               Last_SQL_Error:\n  Replicate_Ignore_Server_Ids: 0\n             Master_Server_Id: 1\n\nURL: https://mariadb.com/kb/en/show-slave-status/\n\n','','https://mariadb.com/kb/en/show-slave-status/'),(224,'GEOMETRY',34,'MySQL provides a standard way of creating spatial columns for geometry\ntypes, for example, with CREATE TABLE or ALTER TABLE. Currently,\nspatial columns are supported for MyISAM, Aria, InnoDB and ARCHIVE\ntables. See also the annotations about spatial indexes under [HELP\nSPATIAL].\n\nURL: https://mariadb.com/kb/en/gis-functionality/\n\n','CREATE TABLE geom (g GEOMETRY);\n','https://mariadb.com/kb/en/gis-functionality/'),(225,'NUMPOINTS',13,'NumPoints(ls)\n\nReturns the number of Point objects in the LineString value ls.\n\nURL: https://mariadb.com/kb/en/numpoints/\n\n','MariaDB> SET @ls = \'LineString(1 1,2 2,3 3)\';\nMariaDB> SELECT NumPoints(GeomFromText(@ls));\n+------------------------------+\n| NumPoints(GeomFromText(@ls)) |\n+------------------------------+\n|                            3 |\n+------------------------------+\n','https://mariadb.com/kb/en/numpoints/'),(226,'ALTER LOGFILE GROUP',39,'Syntax:\nALTER LOGFILE GROUP logfile_group\n    ADD UNDOFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement is used with NDB cluster, which is not supported by MariaDB.\n','','https://mariadb.com/kb/en/alter-logfile-group/'),(227,'&',19,'Syntax:\n&\n\nBitwise AND:\n\nURL: https://mariadb.com/kb/en/bitwise_and/\n\n','MariaDB> SELECT 29 & 15;\n        -> 13\n','https://mariadb.com/kb/en/bitwise_and/'),(228,'LOCALTIMESTAMP',31,'Syntax:\nLOCALTIMESTAMP, LOCALTIMESTAMP()\n\nLOCALTIMESTAMP and LOCALTIMESTAMP() are synonyms for NOW().\n\nURL: https://mariadb.com/kb/en/localtimestamp/\n\n','','https://mariadb.com/kb/en/localtimestamp/'),(229,'ASSIGN-EQUAL',15,'Syntax:\n=\n\nThis operator is used to perform value assignments in two cases,\ndescribed in the next two paragraphs.\n\nWithin a SET statement, = is treated as an assignment operator that\ncauses the user variable on the left hand side of the operator to take\non the value to its right. (In other words, when used in a SET\nstatement, = is treated identically to :=.) The value on the right hand\nside may be a literal value, another variable storing a value, or any\nlegal expression that yields a scalar value, including the result of a\nquery (provided that this value is a scalar value). You can perform\nmultiple assignments in the same SET statement.\n\nIn the SET clause of an UPDATE statement, = also acts as an assignment\noperator; in this case, however, it causes the column named on the left\nhand side of the operator to assume the value given to the right,\nprovided any WHERE conditions that are part of the UPDATE are met. You\ncan make multiple assignments in the same SET clause of an UPDATE\nstatement.\n\nIn any other context, = is treated as a comparison operator.\n\nURL: https://mariadb.com/kb/en/assignment-operators-assignment-operator/\n\n','MariaDB> SELECT @var1, @var2;\n        -> NULL, NULL\nMariaDB> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nMariaDB> SELECT @var1, @var2;\n        -> 1, NULL\nMariaDB> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nMariaDB> SELECT @var1, @var2;\n        -> 1, 1\n','https://mariadb.com/kb/en/assignment-operators-assignment-operator/'),(230,'CONVERT',37,'Syntax:\nCONVERT(expr,type), CONVERT(expr USING transcoding_name)\n\nThe CONVERT() and CAST() functions take an expression of any type and\nproduce a result value of a specified type.\n\nThe type for the result can be one of the following values:\n\no BINARY[(N)]\n\no CHAR[(N)]\n\no DATE\n\no DATETIME\n\no DECIMAL[(M[,D])]\n\no SIGNED [INTEGER]\n\no TIME\n\no UNSIGNED [INTEGER]\n\nBINARY produces a string with the BINARY data type. See\nhttps://mariadb.com/kb/en/binary/ for a\ndescription of how this affects comparisons. If the optional length N\nis given, BINARY(N) causes the cast to use no more than N bytes of the\nargument. Values shorter than N bytes are padded with 0x00 bytes to a\nlength of N.\n\nCHAR(N) causes the cast to use no more than N characters of the\nargument.\n\nCAST() and CONVERT(... USING ...) are standard SQL syntax. The\nnon-USING form of CONVERT() is ODBC syntax.\n\nCONVERT() with USING is used to convert data between different\ncharacter sets. In MySQL, transcoding names are the same as the\ncorresponding character set names. For example, this statement converts\nthe string \'abc\' in the default character set to the corresponding\nstring in the utf8 character set:\n\nSELECT CONVERT(\'abc\' USING utf8);\n\nURL: https://mariadb.com/kb/en/convert/\n\n','SELECT enum_col FROM tbl_name ORDER BY CAST(enum_col AS CHAR);\n','https://mariadb.com/kb/en/convert/'),(231,'ADDDATE',31,'Syntax:\nADDDATE(date,INTERVAL expr unit), ADDDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, ADDDATE()\nis a synonym for DATE_ADD(). The related function SUBDATE() is a\nsynonym for DATE_SUB(). For information on the INTERVAL unit argument,\nsee the discussion for DATE_ADD().\n\nMariaDB> SELECT DATE_ADD(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\nMariaDB> SELECT ADDDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\n\nWhen invoked with the days form of the second argument, MySQL treats it\nas an integer number of days to be added to expr.\n\nURL: https://mariadb.com/kb/en/adddate/\n\n','MariaDB> SELECT ADDDATE(\'2008-01-02\', 31);\n        -> \'2008-02-02\'\n','https://mariadb.com/kb/en/adddate/'),(232,'REPEAT LOOP',23,'Syntax:\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\nThe statement list within a REPEAT statement is repeated until the\nsearch_condition expression is true. Thus, a REPEAT always enters the\nloop at least once. statement_list consists of one or more statements,\neach terminated by a semicolon (;) statement delimiter.\n\nA REPEAT statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: https://mariadb.com/kb/en/repeat-loop/\n\n','MariaDB> delimiter //\n\nMariaDB> CREATE PROCEDURE dorepeat(p1 INT)\n    -> BEGIN\n    ->   SET @x = 0;\n    ->   REPEAT\n    ->     SET @x = @x + 1;\n    ->   UNTIL @x > p1 END REPEAT;\n    -> END\n    -> //\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> CALL dorepeat(1000)//\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SELECT @x//\n+------+\n| @x   |\n+------+\n| 1001 |\n+------+\n1 row in set (0.00 sec)\n','https://mariadb.com/kb/en/repeat-loop/'),(233,'ALTER FUNCTION',39,'Syntax:\nALTER FUNCTION func_name [characteristic ...]\n\ncharacteristic:\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nThis statement can be used to change the characteristics of a stored\nfunction. More than one change may be specified in an ALTER FUNCTION\nstatement. However, you cannot change the parameters or body of a\nstored function using this statement; to make such changes, you must\ndrop and re-create the function using DROP FUNCTION and CREATE\nFUNCTION.\n\nYou must have the ALTER ROUTINE privilege for the function. (That\nprivilege is granted automatically to the function creator.) If binary\nlogging is enabled, the ALTER FUNCTION statement might also require the\nSUPER privilege, as described in\nhttps://mariadb.com/kb/en/binary-logging-of-stored-routines/.\n\nURL: https://mariadb.com/kb/en/alter-function/\n\n','','https://mariadb.com/kb/en/alter-function/'),(234,'SMALLINT',22,'SMALLINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA small integer. The signed range is -32768 to 32767. The unsigned\nrange is 0 to 65535.\n\nURL: https://mariadb.com/kb/en/smallint/\n\n','','https://mariadb.com/kb/en/smallint/'),(235,'DOUBLE PRECISION',22,'DOUBLE PRECISION[(M,D)] [UNSIGNED] [ZEROFILL], REAL[(M,D)] [UNSIGNED]\n[ZEROFILL]\n\nThese types are synonyms for DOUBLE. Exception: If the REAL_AS_FLOAT\nSQL mode is enabled, REAL is a synonym for FLOAT rather than DOUBLE.\n\nURL: https://mariadb.com/kb/en/double-precision/\n\n','','https://mariadb.com/kb/en/double-precision/'),(236,'ORD',37,'Syntax:\nORD(str)\n\nIf the leftmost character of the string str is a multi-byte character,\nreturns the code for that character, calculated from the numeric values\nof its constituent bytes using this formula:\n\n  (1st byte code)\n+ (2nd byte code * 256)\n+ (3rd byte code * 2562) ...\n\nIf the leftmost character is not a multi-byte character, ORD() returns\nthe same value as the ASCII() function.\n\nURL: https://mariadb.com/kb/en/ord/\n\n','MariaDB> SELECT ORD(\'2\');\n        -> 50\n','https://mariadb.com/kb/en/ord/'),(237,'DEALLOCATE PREPARE',8,'Syntax:\n{DEALLOCATE | DROP} PREPARE stmt_name\n\nTo deallocate a prepared statement produced with PREPARE, use a\nDEALLOCATE PREPARE statement that refers to the prepared statement\nname. Attempting to execute a prepared statement after deallocating it\nresults in an error.\n\nURL: https://mariadb.com/kb/en/deallocate-drop-prepared-statement/\n\n','','https://mariadb.com/kb/en/deallocate-drop-prepared-statement/'),(238,'ENVELOPE',36,'Envelope(g)\n\nReturns the Minimum Bounding Rectangle (MBR) for the geometry value g.\nThe result is returned as a Polygon value.\n\nThe polygon is defined by the corner points of the bounding box:\n\nPOLYGON((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n\nURL: https://mariadb.com/kb/en/envelope/\n\n','MariaDB> SELECT AsText(Envelope(GeomFromText(\'LineString(1 1,2 2)\')));\n+-------------------------------------------------------+\n| AsText(Envelope(GeomFromText(\'LineString(1 1,2 2)\'))) |\n+-------------------------------------------------------+\n| POLYGON((1 1,2 1,2 2,1 2,1 1))                        |\n+-------------------------------------------------------+\n','https://mariadb.com/kb/en/envelope/'),(239,'IS_FREE_LOCK',14,'Syntax:\nIS_FREE_LOCK(str)\n\nChecks whether the lock named str is free to use (that is, not locked).\nReturns 1 if the lock is free (no one is using the lock), 0 if the lock\nis in use, and NULL if an error occurs (such as an incorrect argument).\n\nURL: https://mariadb.com/kb/en/is_free_lock/\n\n','','https://mariadb.com/kb/en/is_free_lock/'),(240,'TOUCHES',30,'Touches(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially touches g2. Two\ngeometries spatially touch if the interiors of the geometries do not\nintersect, but the boundary of one of the geometries intersects either\nthe boundary or the interior of the other.\n\nURL: https://mariadb.com/kb/en/touches/\n\n','','https://mariadb.com/kb/en/touches/'),(241,'INET_ATON',14,'Syntax:\nINET_ATON(expr)\n\nGiven the dotted-quad representation of an IPv4 network address as a\nstring, returns an integer that represents the numeric value of the\naddress in network byte order (big endian). INET_ATON() returns NULL if\nit does not understand its argument.\n\nURL: https://mariadb.com/kb/en/inet_aton/\n\n','MariaDB> SELECT INET_ATON(\'10.0.5.9\');\n        -> 167773449\n','https://mariadb.com/kb/en/inet_aton/'),(242,'UNCOMPRESS',12,'Syntax:\nUNCOMPRESS(string_to_uncompress)\n\nUncompresses a string compressed by the COMPRESS() function. If the\nargument is not a compressed value, the result is NULL. This function\nrequires MySQL to have been compiled with a compression library such as\nzlib. Otherwise, the return value is always NULL.\n\nURL: https://mariadb.com/kb/en/uncompress/\n\n','MariaDB> SELECT UNCOMPRESS(COMPRESS(\'any string\'));\n        -> \'any string\'\nMariaDB> SELECT UNCOMPRESS(\'any string\');\n        -> NULL\n','https://mariadb.com/kb/en/uncompress/'),(243,'AUTO_INCREMENT',22,'The AUTO_INCREMENT attribute can be used to generate a unique identity\nfor new rows:\n\nURL: https://mariadb.com/kb/en/auto_increment/\n\n','CREATE TABLE animals (\n     id MEDIUMINT NOT NULL AUTO_INCREMENT,\n     name CHAR(30) NOT NULL,\n     PRIMARY KEY (id)\n);\n\nINSERT INTO animals (name) VALUES\n    (\'dog\'),(\'cat\'),(\'penguin\'),\n    (\'lax\'),(\'whale\'),(\'ostrich\');\n\nSELECT * FROM animals;\n','https://mariadb.com/kb/en/auto_increment/'),(244,'ISSIMPLE',36,'IsSimple(g)\n\nCurrently, this function is a placeholder and should not be used. If\nimplemented, its behavior will be as described in the next paragraph.\n\nReturns 1 if the geometry value g has no anomalous geometric points,\nsuch as self-intersection or self-tangency. IsSimple() returns 0 if the\nargument is not simple, and -1 if it is NULL.\n\nThe description of each instantiable geometric class given earlier in\nthe chapter includes the specific conditions that cause an instance of\nthat class to be classified as not simple. (See [HELP Geometry\nhierarchy].)\n\nURL: https://mariadb.com/kb/en/issimple/\n\n','','https://mariadb.com/kb/en/issimple/'),(245,'- BINARY',4,'Syntax:\n-\n\nSubtraction:\n\nURL: https://mariadb.com/kb/en/subtraction-operator-/\n\n','MariaDB> SELECT 3-5;\n        -> -2\n','https://mariadb.com/kb/en/subtraction-operator-/'),(246,'GEOMCOLLFROMTEXT',3,'GeomCollFromText(wkt[,srid]), GeometryCollectionFromText(wkt[,srid])\n\nConstructs a GEOMETRYCOLLECTION value using its WKT representation and\nSRID.\n\nURL: https://mariadb.com/kb/en/geomcollfromtext/\n\n','','https://mariadb.com/kb/en/geomcollfromtext/'),(247,'WKT DEFINITION',3,'The Well-Known Text (WKT) representation of Geometry is designed to\nexchange geometry data in ASCII form. For a Backus-Naur grammar that\nspecifies the formal production rules for writing WKT values, see the\nOpenGIS specification document referenced in\nhttps://mariadb.com/kb/en/gis-resources/.\n\nURL: https://mariadb.com/kb/en/wkt-definition/\n\n','','https://mariadb.com/kb/en/wkt-definition/'),(248,'CURRENT_TIME',31,'Syntax:\nCURRENT_TIME, CURRENT_TIME()\n\nCURRENT_TIME and CURRENT_TIME() are synonyms for CURTIME().\n\nURL: https://mariadb.com/kb/en/current_time/\n\n','','https://mariadb.com/kb/en/current_time/'),(249,'REVOKE',10,'Syntax:\nREVOKE\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    FROM user [, user] ...\n\nREVOKE ALL PRIVILEGES, GRANT OPTION\n    FROM user [, user] ...\n\nREVOKE PROXY ON user\n    FROM user [, user] ...\n\nThe REVOKE statement enables system administrators to revoke privileges\nfrom MySQL accounts. Each account name uses the format described in\nhttps://mariadb.com/kb/en/create-user#account-names. For example:\n\nREVOKE INSERT ON *.* FROM \'jeffrey\'@\'localhost\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nFor details on the levels at which privileges exist, the permissible\npriv_type and priv_level values, and the syntax for specifying users\nand passwords, see [HELP GRANT]\n\nTo use the first REVOKE syntax, you must have the GRANT OPTION\nprivilege, and you must have the privileges that you are revoking.\n\nTo revoke all privileges, use the second syntax, which drops all\nglobal, database, table, column, and routine privileges for the named\nuser or users:\n\nREVOKE ALL PRIVILEGES, GRANT OPTION FROM user [, user] ...\n\nTo use this REVOKE syntax, you must have the global CREATE USER\nprivilege or the UPDATE privilege for the mysql database.\n\nURL: https://mariadb.com/kb/en/revoke/\n\n','','https://mariadb.com/kb/en/revoke/'),(250,'LAST_INSERT_ID',17,'Syntax:\nLAST_INSERT_ID(), LAST_INSERT_ID(expr)\n\nLAST_INSERT_ID() (with no argument) returns a BIGINT (64-bit) value\nrepresenting the first automatically generated value successfully\ninserted for an AUTO_INCREMENT column as a result of the most recently\nexecuted INSERT statement. The value of LAST_INSERT_ID() remains\nunchanged if no rows are successfully inserted.\n\nFor example, after inserting a row that generates an AUTO_INCREMENT\nvalue, you can get the value like this:\n\nMariaDB> SELECT LAST_INSERT_ID();\n        -> 195\n\nThe currently executing statement does not affect the value of\nLAST_INSERT_ID(). Suppose that you generate an AUTO_INCREMENT value\nwith one statement, and then refer to LAST_INSERT_ID() in a\nmultiple-row INSERT statement that inserts rows into a table with its\nown AUTO_INCREMENT column. The value of LAST_INSERT_ID() will remain\nstable in the second statement; its value for the second and later rows\nis not affected by the earlier row insertions. (However, if you mix\nreferences to LAST_INSERT_ID() and LAST_INSERT_ID(expr), the effect is\nundefined.)\n\nIf the previous statement returned an error, the value of\nLAST_INSERT_ID() is undefined. For transactional tables, if the\nstatement is rolled back due to an error, the value of LAST_INSERT_ID()\nis left undefined. For manual ROLLBACK, the value of LAST_INSERT_ID()\nis not restored to that before the transaction; it remains as it was at\nthe point of the ROLLBACK.\n\nWithin the body of a stored routine (procedure or function) or a\ntrigger, the value of LAST_INSERT_ID() changes the same way as for\nstatements executed outside the body of these kinds of objects. The\neffect of a stored routine or trigger upon the value of\nLAST_INSERT_ID() that is seen by following statements depends on the\nkind of routine:\n\no If a stored procedure executes statements that change the value of\n  LAST_INSERT_ID(), the changed value is seen by statements that follow\n  the procedure call.\n\no For stored functions and triggers that change the value, the value is\n  restored when the function or trigger ends, so following statements\n  will not see a changed value.\n\nURL: https://mariadb.com/kb/en/last_insert_id/\n\n','','https://mariadb.com/kb/en/last_insert_id/'),(251,'LAST_DAY',31,'Syntax:\nLAST_DAY(date)\n\nTakes a date or datetime value and returns the corresponding value for\nthe last day of the month. Returns NULL if the argument is invalid.\n\nURL: https://mariadb.com/kb/en/last_day/\n\n','MariaDB> SELECT LAST_DAY(\'2003-02-05\');\n        -> \'2003-02-28\'\nMariaDB> SELECT LAST_DAY(\'2004-02-05\');\n        -> \'2004-02-29\'\nMariaDB> SELECT LAST_DAY(\'2004-01-01 01:01:01\');\n        -> \'2004-01-31\'\nMariaDB> SELECT LAST_DAY(\'2003-03-32\');\n        -> NULL\n','https://mariadb.com/kb/en/last_day/'),(252,'MEDIUMINT',22,'MEDIUMINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA medium-sized integer. The signed range is -8388608 to 8388607. The\nunsigned range is 0 to 16777215.\n\nURL: https://mariadb.com/kb/en/mediumint/\n\n','','https://mariadb.com/kb/en/mediumint/'),(253,'FLOOR',4,'Syntax:\nFLOOR(X)\n\nReturns the largest integer value not greater than X.\n\nURL: https://mariadb.com/kb/en/floor/\n\n','MariaDB> SELECT FLOOR(1.23);\n        -> 1\nMariaDB> SELECT FLOOR(-1.23);\n        -> -2\n','https://mariadb.com/kb/en/floor/'),(254,'RTRIM',37,'Syntax:\nRTRIM(str)\n\nReturns the string str with trailing space characters removed.\n\nURL: https://mariadb.com/kb/en/rtrim/\n\n','MariaDB> SELECT RTRIM(\'barbar   \');\n        -> \'barbar\'\n','https://mariadb.com/kb/en/rtrim/'),(255,'EXPLAIN',28,'Syntax:\nEXPLAIN [explain_type] SELECT select_options\n\nexplain_type:\n    EXTENDED\n  | PARTITIONS\n\nOr:\n\nEXPLAIN tbl_name\n\nThe EXPLAIN statement can be used either as a way to obtain information\nabout how MySQL executes a statement, or as a synonym for DESCRIBE:\n\no When you precede a SELECT statement with the keyword EXPLAIN, MySQL\n  displays information from the optimizer about the query execution\n  plan. That is, MySQL explains how it would process the statement,\n  including information about how tables are joined and in which order.\n  EXPLAIN EXTENDED can be used to obtain additional information.\n\n  For information about using EXPLAIN and EXPLAIN EXTENDED to obtain\n  query execution plan information, see\n  https://mariadb.com/kb/en/explain/.\n\no EXPLAIN PARTITIONS is useful only when examining queries involving\n  partitioned tables. For details, see\n  http://dev.mysql.com/doc/refman/5.5/en/partitioning-info.html.\n\no EXPLAIN tbl_name is synonymous with DESCRIBE tbl_name or SHOW COLUMNS\n  FROM tbl_name. For information about DESCRIBE and SHOW COLUMNS, see\n  [HELP DESCRIBE], and [HELP SHOW COLUMNS].\n\nURL: https://mariadb.com/kb/en/explain/\n\n','','https://mariadb.com/kb/en/explain/'),(256,'DEGREES',4,'Syntax:\nDEGREES(X)\n\nReturns the argument X, converted from radians to degrees.\n\nURL: https://mariadb.com/kb/en/degrees/\n\n','MariaDB> SELECT DEGREES(PI());\n        -> 180\nMariaDB> SELECT DEGREES(PI() / 2);\n        -> 90\n','https://mariadb.com/kb/en/degrees/'),(257,'VARCHAR',22,'[NATIONAL] VARCHAR(M) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA variable-length string. M represents the maximum column length in\ncharacters. The range of M is 0 to 65,535. The effective maximum length\nof a VARCHAR is subject to the maximum row size (65,535 bytes, which is\nshared among all columns) and the character set used. For example, utf8\ncharacters can require up to three bytes per character, so a VARCHAR\ncolumn that uses the utf8 character set can be declared to be a maximum\nof 21,844 characters. See\nhttp://dev.mysql.com/doc/refman/5.5/en/column-count-limit.html.\n\nMySQL stores VARCHAR values as a 1-byte or 2-byte length prefix plus\ndata. The length prefix indicates the number of bytes in the value. A\nVARCHAR column uses one length byte if values require no more than 255\nbytes, two length bytes if values may require more than 255 bytes.\n\n*Note*: MySQL 5.5 follows the standard SQL specification, and does not\nremove trailing spaces from VARCHAR values.\n\nVARCHAR is shorthand for CHARACTER VARYING. NATIONAL VARCHAR is the\nstandard SQL way to define that a VARCHAR column should use some\npredefined character set. MySQL 4.1 and up uses utf8 as this predefined\ncharacter set.\nhttps://mariadb.com/kb/en/varchar/. NVARCHAR\nis shorthand for NATIONAL VARCHAR.\n\nURL: https://mariadb.com/kb/en/varchar/\n\n','','https://mariadb.com/kb/en/varchar/'),(258,'UNHEX',37,'Syntax:\n\nUNHEX(str)\n\nFor a string argument str, UNHEX(str) performs the inverse operation of\nHEX(str). That is, it interprets each pair of characters in the\nargument as a hexadecimal number and converts it to the character\nrepresented by the number. The return value is a binary string.\n\nURL: https://mariadb.com/kb/en/unhex/\n\n','MariaDB> SELECT UNHEX(\'4D7953514C\');\n        -> \'MySQL\'\nMariaDB> SELECT 0x4D7953514C;\n        -> \'MySQL\'\nMariaDB> SELECT UNHEX(HEX(\'string\'));\n        -> \'string\'\nMariaDB> SELECT HEX(UNHEX(\'1267\'));\n        -> \'1267\'\n','https://mariadb.com/kb/en/unhex/'),(259,'- UNARY',4,'Syntax:\n-\n\nUnary minus. This operator changes the sign of the operand.\n\nURL: https://mariadb.com/kb/en/subtraction-operator-/\n\n','MariaDB> SELECT - 2;\n        -> -2\n','https://mariadb.com/kb/en/subtraction-operator-/'),(260,'STD',16,'Syntax:\nSTD(expr)\n\nReturns the population standard deviation of expr. This is an extension\nto standard SQL. The standard SQL function STDDEV_POP() can be used\ninstead.\n\nThis function returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/std/\n\n','','https://mariadb.com/kb/en/std/'),(261,'COS',4,'Syntax:\nCOS(X)\n\nReturns the cosine of X, where X is given in radians.\n\nURL: https://mariadb.com/kb/en/cos/\n\n','MariaDB> SELECT COS(PI());\n        -> -1\n','https://mariadb.com/kb/en/cos/'),(262,'DATE FUNCTION',31,'Syntax:\nDATE(expr)\n\nExtracts the date part of the date or datetime expression expr.\n\nURL: https://mariadb.com/kb/en/date-function/\n\n','MariaDB> SELECT DATE(\'2003-12-31 01:02:03\');\n        -> \'2003-12-31\'\n','https://mariadb.com/kb/en/date-function/'),(263,'DROP TRIGGER',39,'Syntax:\nDROP TRIGGER [IF EXISTS] [schema_name.]trigger_name\n\nThis statement drops a trigger. The schema (database) name is optional.\nIf the schema is omitted, the trigger is dropped from the default\nschema. DROP TRIGGER requires the TRIGGER privilege for the table\nassociated with the trigger.\n\nUse IF EXISTS to prevent an error from occurring for a trigger that\ndoes not exist. A NOTE is generated for a nonexistent trigger when\nusing IF EXISTS. See [HELP SHOW WARNINGS].\n\nTriggers for a table are also dropped if you drop the table.\n\nURL: https://mariadb.com/kb/en/drop-trigger/\n\n','','https://mariadb.com/kb/en/drop-trigger/'),(264,'RESET MASTER',8,'Syntax:\nRESET MASTER\n\nDeletes all binary log files listed in the index file, resets the\nbinary log index file to be empty, and creates a new binary log file.\nThis statement is intended to be used only when the master is started\nfor the first time.\n\nURL: https://mariadb.com/kb/en/reset-master/\n\n','','https://mariadb.com/kb/en/reset-master/'),(265,'TAN',4,'Syntax:\nTAN(X)\n\nReturns the tangent of X, where X is given in radians.\n\nURL: https://mariadb.com/kb/en/tan/\n\n','MariaDB> SELECT TAN(PI());\n        -> -1.2246063538224e-16\nMariaDB> SELECT TAN(PI()+1);\n        -> 1.5574077246549\n','https://mariadb.com/kb/en/tan/'),(266,'PI',4,'Syntax:\nPI()\n\nReturns the value of π (pi). The default number of decimal places\ndisplayed is seven, but MySQL uses the full double-precision value\ninternally.\n\nURL: https://mariadb.com/kb/en/pi/\n\n','MariaDB> SELECT PI();\n        -> 3.141593\nMariaDB> SELECT PI()+0.000000000000000000;\n        -> 3.141592653589793116\n','https://mariadb.com/kb/en/pi/'),(267,'WEEKOFYEAR',31,'Syntax:\nWEEKOFYEAR(date)\n\nReturns the calendar week of the date as a number in the range from 1\nto 53. WEEKOFYEAR() is a compatibility function that is equivalent to\nWEEK(date,3).\n\nURL: https://mariadb.com/kb/en/weekofyear/\n\n','MariaDB> SELECT WEEKOFYEAR(\'2008-02-20\');\n        -> 8\n','https://mariadb.com/kb/en/weekofyear/'),(268,'/',4,'Syntax:\n/\n\nDivision:\n\nURL: https://mariadb.com/kb/en/division-operator/\n\n','MariaDB> SELECT 3/5;\n        -> 0.60\n','https://mariadb.com/kb/en/division-operator/'),(269,'PURGE BINARY LOGS',8,'Syntax:\nPURGE { BINARY | MASTER } LOGS\n    { TO \'log_name\' | BEFORE datetime_expr }\n\nThe binary log is a set of files that contain information about data\nmodifications made by the MySQL server. The log consists of a set of\nbinary log files, plus an index file (see\nhttps://mariadb.com/kb/en/overview-of-the-binary-log/).\n\nThe PURGE BINARY LOGS statement deletes all the binary log files listed\nin the log index file prior to the specified log file name or date.\nBINARY and MASTER are synonyms. Deleted log files also are removed from\nthe list recorded in the index file, so that the given log file becomes\nthe first in the list.\n\nThis statement has no effect if the server was not started with the\n--log-bin option to enable binary logging.\n\nURL: https://mariadb.com/kb/en/sql-commands-purge-logs/\n\n','PURGE BINARY LOGS TO \'mysql-bin.010\';\nPURGE BINARY LOGS BEFORE \'2008-04-02 22:46:26\';\n','https://mariadb.com/kb/en/sql-commands-purge-logs/'),(270,'STDDEV_SAMP',16,'Syntax:\nSTDDEV_SAMP(expr)\n\nReturns the sample standard deviation of expr (the square root of\nVAR_SAMP().\n\nSTDDEV_SAMP() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/stddev_samp/\n\n','','https://mariadb.com/kb/en/stddev_samp/'),(271,'SCHEMA',17,'Syntax:\nSCHEMA()\n\nThis function is a synonym for DATABASE().\n\nURL: https://mariadb.com/kb/en/schema/\n\n','','https://mariadb.com/kb/en/schema/'),(272,'MLINEFROMWKB',32,'MLineFromWKB(wkb[,srid]), MultiLineStringFromWKB(wkb[,srid])\n\nConstructs a MULTILINESTRING value using its WKB representation and\nSRID.\n\nURL: https://mariadb.com/kb/en/mlinefromwkb/\n\n','','https://mariadb.com/kb/en/mlinefromwkb/'),(273,'LOG2',4,'Syntax:\nLOG2(X)\n\nReturns the base-2 logarithm of X.\n\nURL: https://mariadb.com/kb/en/log2/\n\n','MariaDB> SELECT LOG2(65536);\n        -> 16\nMariaDB> SELECT LOG2(-100);\n        -> NULL\n','https://mariadb.com/kb/en/log2/'),(274,'SUBTIME',31,'Syntax:\nSUBTIME(expr1,expr2)\n\nSUBTIME() returns expr1 - expr2 expressed as a value in the same format\nas expr1. expr1 is a time or datetime expression, and expr2 is a time\nexpression.\n\nURL: https://mariadb.com/kb/en/subtime/\n\n','MariaDB> SELECT SUBTIME(\'2007-12-31 23:59:59.999999\',\'1 1:1:1.000002\');\n        -> \'2007-12-30 22:58:58.999997\'\nMariaDB> SELECT SUBTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'-00:59:59.999999\'\n','https://mariadb.com/kb/en/subtime/'),(275,'UNCOMPRESSED_LENGTH',12,'Syntax:\nUNCOMPRESSED_LENGTH(compressed_string)\n\nReturns the length that the compressed string had before being\ncompressed.\n\nURL: https://mariadb.com/kb/en/uncompressed_length/\n\n','MariaDB> SELECT UNCOMPRESSED_LENGTH(COMPRESS(REPEAT(\'a\',30)));\n        -> 30\n','https://mariadb.com/kb/en/uncompressed_length/'),(276,'DROP TABLE',39,'Syntax:\nDROP [TEMPORARY] TABLE [IF EXISTS]\n    tbl_name [, tbl_name] ...\n    [RESTRICT | CASCADE]\n\nDROP TABLE removes one or more tables. You must have the DROP privilege\nfor each table. All table data and the table definition are removed, so\nbe careful with this statement! If any of the tables named in the\nargument list do not exist, MySQL returns an error indicating by name\nwhich nonexisting tables it was unable to drop, but it also drops all\nof the tables in the list that do exist.\n\n*Important*: When a table is dropped, user privileges on the table are\nnot automatically dropped. See [HELP GRANT].\n\nNote that for a partitioned table, DROP TABLE permanently removes the\ntable definition, all of its partitions, and all of the data which was\nstored in those partitions. It also removes the partitioning definition\n(.par) file associated with the dropped table.\n\nUse IF EXISTS to prevent an error from occurring for tables that do not\nexist. A NOTE is generated for each nonexistent table when using IF\nEXISTS. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE are permitted to make porting easier. In MySQL\n5.5, they do nothing.\n\n*Note*: DROP TABLE automatically commits the current active\ntransaction, unless you use the TEMPORARY keyword.\n\nURL: https://mariadb.com/kb/en/drop-table/\n\n','','https://mariadb.com/kb/en/drop-table/'),(277,'POW',4,'Syntax:\nPOW(X,Y)\n\nReturns the value of X raised to the power of Y.\n\nURL: https://mariadb.com/kb/en/pow/\n\n','MariaDB> SELECT POW(2,2);\n        -> 4\nMariaDB> SELECT POW(2,-2);\n        -> 0.25\n','https://mariadb.com/kb/en/pow/'),(278,'SHOW CREATE TABLE',26,'Syntax:\nSHOW CREATE TABLE tbl_name\n\nShows the CREATE TABLE statement that creates the given table. To use\nthis statement, you must have some privilege for the table. This\nstatement also works with views.\nSHOW CREATE TABLE quotes table and column names according to the value\nof the sql_quote_show_create option. See\nhttps://mariadb.com/kb/en/server-system-variables/.\n\nURL: https://mariadb.com/kb/en/show-create-table/\n\n','MariaDB> SHOW CREATE TABLE t\\G\n*************************** 1. row ***************************\n       Table: t\nCreate Table: CREATE TABLE t (\n  id INT(11) default NULL auto_increment,\n  s char(60) default NULL,\n  PRIMARY KEY (id)\n) ENGINE=MyISAM\n','https://mariadb.com/kb/en/show-create-table/'),(279,'DUAL',27,'You are permitted to specify DUAL as a dummy table name in situations\nwhere no tables are referenced:\n\nMariaDB> SELECT 1 + 1 FROM DUAL;\n        -> 2\n\nDUAL is purely for the convenience of people who require that all\nSELECT statements should have FROM and possibly other clauses. MySQL\nmay ignore the clauses. MySQL does not require FROM DUAL if no tables\nare referenced.\n\nURL: https://mariadb.com/kb/en/dual/\n\n','','https://mariadb.com/kb/en/dual/'),(280,'INSTR',37,'Syntax:\nINSTR(str,substr)\n\nReturns the position of the first occurrence of substring substr in\nstring str. This is the same as the two-argument form of LOCATE(),\nexcept that the order of the arguments is reversed.\n\nURL: https://mariadb.com/kb/en/instr/\n\n','MariaDB> SELECT INSTR(\'foobarbar\', \'bar\');\n        -> 4\nMariaDB> SELECT INSTR(\'xbar\', \'foobar\');\n        -> 0\n','https://mariadb.com/kb/en/instr/'),(281,'NOW',31,'Syntax:\nNOW()\n\nReturns the current date and time as a value in \'YYYY-MM-DD HH:MM:SS\'\nor YYYYMMDDHHMMSS.uuuuuu format, depending on whether the function is\nused in a string or numeric context. The value is expressed in the\ncurrent time zone.\n\nURL: https://mariadb.com/kb/en/now/\n\n','MariaDB> SELECT NOW();\n        -> \'2007-12-15 23:50:26\'\nMariaDB> SELECT NOW() + 0;\n        -> 20071215235026.000000\n','https://mariadb.com/kb/en/now/'),(282,'SHOW ENGINES',26,'Syntax:\nSHOW [STORAGE] ENGINES\n\nSHOW ENGINES displays status information about the server\'s storage\nengines. This is particularly useful for checking whether a storage\nengine is supported, or to see what the default engine is.\n\nURL: https://mariadb.com/kb/en/show-engines/\n\n','','https://mariadb.com/kb/en/show-engines/'),(283,'>=',18,'Syntax:\n>=\n\nGreater than or equal:\n\nURL: https://mariadb.com/kb/en/greater-than-or-equal/\n\n','MariaDB> SELECT 2 >= 2;\n        -> 1\n','https://mariadb.com/kb/en/greater-than-or-equal/'),(284,'EXP',4,'Syntax:\nEXP(X)\n\nReturns the value of e (the base of natural logarithms) raised to the\npower of X. The inverse of this function is LOG() (using a single\nargument only) or LN().\n\nURL: https://mariadb.com/kb/en/exp/\n\n','MariaDB> SELECT EXP(2);\n        -> 7.3890560989307\nMariaDB> SELECT EXP(-2);\n        -> 0.13533528323661\nMariaDB> SELECT EXP(0);\n        -> 1\n','https://mariadb.com/kb/en/exp/'),(285,'LONGBLOB',22,'LONGBLOB\n\nA BLOB column with a maximum length of 4,294,967,295 or 4GB (232 - 1)\nbytes. The effective maximum length of LONGBLOB columns depends on the\nconfigured maximum packet size in the client/server protocol and\navailable memory. Each LONGBLOB value is stored using a 4-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: https://mariadb.com/kb/en/longblob/\n\n','','https://mariadb.com/kb/en/longblob/'),(286,'POINTN',13,'PointN(ls,N)\n\nReturns the N-th Point in the Linestring value ls. Points are numbered\nbeginning with 1.\n\nURL: https://mariadb.com/kb/en/pointn/\n\n','MariaDB> SET @ls = \'LineString(1 1,2 2,3 3)\';\nMariaDB> SELECT AsText(PointN(GeomFromText(@ls),2));\n+-------------------------------------+\n| AsText(PointN(GeomFromText(@ls),2)) |\n+-------------------------------------+\n| POINT(2 2)                          |\n+-------------------------------------+\n','https://mariadb.com/kb/en/pointn/'),(287,'YEAR DATA TYPE',22,'YEAR[(2|4)]\n\nA year in two-digit or four-digit format. The default is four-digit\nformat. YEAR(2) or YEAR(4) differ in display format, but have the same\nrange of values. In four-digit format, values display as 1901 to 2155,\nand 0000. In two-digit format, values display as 70 to 69, representing\nyears from 1970 to 2069. MySQL displays YEAR values in YYYY or\nYYformat, but permits assignment of values to YEAR columns using either\nstrings or numbers.\n\n*Note*: The YEAR(2) data type has certain issues that you should\nconsider before choosing to use it. As of MySQL 5.5.27, YEAR(2) is\ndeprecated. For more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/migrating-to-year4.html.\n\nFor additional information about YEAR display format and inerpretation\nof input values, see https://mariadb.com/kb/en/year-data-type/.\n\nURL: https://mariadb.com/kb/en/year-data-type/\n\n','','https://mariadb.com/kb/en/year-data-type/'),(288,'SUM',16,'Syntax:\nSUM([DISTINCT] expr)\n\nReturns the sum of expr. If the return set has no rows, SUM() returns\nNULL. The DISTINCT keyword can be used to sum only the distinct values\nof expr.\n\nSUM() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/sum/\n\n','','https://mariadb.com/kb/en/sum/'),(289,'OCT',37,'Syntax:\nOCT(N)\n\nReturns a string representation of the octal value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,8). Returns\nNULL if N is NULL.\n\nURL: https://mariadb.com/kb/en/oct/\n\n','MariaDB> SELECT OCT(12);\n        -> \'14\'\n','https://mariadb.com/kb/en/oct/'),(290,'SYSDATE',31,'Syntax:\nSYSDATE()\n\nReturns the current date and time as a value in \'YYYY-MM-DD HH:MM:SS\'\nor YYYYMMDDHHMMSS.uuuuuu format, depending on whether the function is\nused in a string or numeric context.\n\nSYSDATE() returns the time at which it executes. This differs from the\nbehavior for NOW(), which returns a constant time that indicates the\ntime at which the statement began to execute. (Within a stored function\nor trigger, NOW() returns the time at which the function or triggering\nstatement began to execute.)\n\nMariaDB> SELECT NOW(), SLEEP(2), NOW();\n+---------------------+----------+---------------------+\n| NOW()               | SLEEP(2) | NOW()               |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:36 |        0 | 2006-04-12 13:47:36 |\n+---------------------+----------+---------------------+\n\nMariaDB> SELECT SYSDATE(), SLEEP(2), SYSDATE();\n+---------------------+----------+---------------------+\n| SYSDATE()           | SLEEP(2) | SYSDATE()           |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:44 |        0 | 2006-04-12 13:47:46 |\n+---------------------+----------+---------------------+\n\nIn addition, the SET TIMESTAMP statement affects the value returned by\nNOW() but not by SYSDATE(). This means that timestamp settings in the\nbinary log have no effect on invocations of SYSDATE().\n\nBecause SYSDATE() can return different values even within the same\nstatement, and is not affected by SET TIMESTAMP, it is nondeterministic\nand therefore unsafe for replication if statement-based binary logging\nis used. If that is a problem, you can use row-based logging.\n\nAlternatively, you can use the --sysdate-is-now option to cause\nSYSDATE() to be an alias for NOW(). This works if the option is used on\nboth the master and the slave.\n\nThe nondeterministic nature of SYSDATE() also means that indexes cannot\nbe used for evaluating expressions that refer to it.\n\nURL: https://mariadb.com/kb/en/sysdate/\n\n','','https://mariadb.com/kb/en/sysdate/'),(291,'UNINSTALL PLUGIN',5,'Syntax:\nUNINSTALL PLUGIN plugin_name\n\nThis statement removes an installed server plugin. It requires the\nDELETE privilege for the mysql.plugin table.\n\nplugin_name must be the name of some plugin that is listed in the\nmysql.plugin table. The server executes the plugin\'s deinitialization\nfunction and removes the row for the plugin from the mysql.plugin\ntable, so that subsequent server restarts will not load and initialize\nthe plugin. UNINSTALL PLUGIN does not remove the plugin\'s shared\nlibrary file.\n\nURL: https://mariadb.com/kb/en/uninstall-plugin/\n\n','','https://mariadb.com/kb/en/uninstall-plugin/'),(292,'ASBINARY',32,'AsBinary(g), AsWKB(g)\n\nConverts a value in internal geometry format to its WKB representation\nand returns the binary result.\n\nURL: https://mariadb.com/kb/en/asbinary/\n\n','SELECT AsBinary(g) FROM geom;\n','https://mariadb.com/kb/en/asbinary/'),(293,'REPEAT FUNCTION',37,'Syntax:\nREPEAT(str,count)\n\nReturns a string consisting of the string str repeated count times. If\ncount is less than 1, returns an empty string. Returns NULL if str or\ncount are NULL.\n\nURL: https://mariadb.com/kb/en/repeat-function/\n\n','MariaDB> SELECT REPEAT(\'MySQL\', 3);\n        -> \'MySQLMySQLMySQL\'\n','https://mariadb.com/kb/en/repeat-function/'),(294,'SHOW TABLES',26,'Syntax:\nSHOW [FULL] TABLES [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLES lists the non-TEMPORARY tables in a given database. You can\nalso get this list using the mysqlshow db_name command. The LIKE\nclause, if present, indicates which table names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in https://mariadb.com/kb/en/extended-show/.\n\nThis statement also lists any views in the database. The FULL modifier\nis supported such that SHOW FULL TABLES displays a second output\ncolumn. Values for the second column are BASE TABLE for a table and\nVIEW for a view.\n\nIf you have no privileges for a base table or view, it does not show up\nin the output from SHOW TABLES or mysqlshow db_name.\n\nURL: https://mariadb.com/kb/en/show-tables/\n\n','','https://mariadb.com/kb/en/show-tables/'),(295,'MAKEDATE',31,'Syntax:\nMAKEDATE(year,dayofyear)\n\nReturns a date, given year and day-of-year values. dayofyear must be\ngreater than 0 or the result is NULL.\n\nURL: https://mariadb.com/kb/en/makedate/\n\n','MariaDB> SELECT MAKEDATE(2011,31), MAKEDATE(2011,32);\n        -> \'2011-01-31\', \'2011-02-01\'\nMariaDB> SELECT MAKEDATE(2011,365), MAKEDATE(2014,365);\n        -> \'2011-12-31\', \'2014-12-31\'\nMariaDB> SELECT MAKEDATE(2011,0);\n        -> NULL\n','https://mariadb.com/kb/en/makedate/'),(296,'BINARY OPERATOR',37,'Syntax:\nBINARY\n\nThe BINARY operator casts the string following it to a binary string.\nThis is an easy way to force a column comparison to be done byte by\nbyte rather than character by character. This causes the comparison to\nbe case sensitive even if the column is not defined as BINARY or BLOB.\nBINARY also causes trailing spaces to be significant.\n\nURL: https://mariadb.com/kb/en/binary-operator/\n\n','MariaDB> SELECT \'a\' = \'A\';\n        -> 1\nMariaDB> SELECT BINARY \'a\' = \'A\';\n        -> 0\nMariaDB> SELECT \'a\' = \'a \';\n        -> 1\nMariaDB> SELECT BINARY \'a\' = \'a \';\n        -> 0\n','https://mariadb.com/kb/en/binary-operator/'),(297,'MBROVERLAPS',6,'MBROverlaps(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 overlap. The term spatially overlaps is\nused if two geometries intersect and their intersection results in a\ngeometry of the same dimension but not equal to either of the given\ngeometries.\n\nURL: https://mariadb.com/kb/en/mbroverlaps/\n\n','','https://mariadb.com/kb/en/mbroverlaps/'),(298,'SOUNDEX',37,'Syntax:\nSOUNDEX(str)\n\nReturns a soundex string from str. Two strings that sound almost the\nsame should have identical soundex strings. A standard soundex string\nis four characters long, but the SOUNDEX() function returns an\narbitrarily long string. You can use SUBSTRING() on the result to get a\nstandard soundex string. All nonalphabetic characters in str are\nignored. All international alphabetic characters outside the A-Z range\nare treated as vowels.\n\n*Important*: When using SOUNDEX(), you should be aware of the following\nlimitations:\n\no This function, as currently implemented, is intended to work well\n  with strings that are in the English language only. Strings in other\n  languages may not produce reliable results.\n\no This function is not guaranteed to provide consistent results with\n  strings that use multi-byte character sets, including utf-8.\n\n  We hope to remove these limitations in a future release. See Bug\n  #22638 for more information.\n\nURL: https://mariadb.com/kb/en/soundex/\n\n','MariaDB> SELECT SOUNDEX(\'Hello\');\n        -> \'H400\'\nMariaDB> SELECT SOUNDEX(\'Quadratically\');\n        -> \'Q36324\'\n','https://mariadb.com/kb/en/soundex/'),(299,'MBRTOUCHES',6,'MBRTouches(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 touch. Two geometries spatially touch if\nthe interiors of the geometries do not intersect, but the boundary of\none of the geometries intersects either the boundary or the interior of\nthe other.\n\nURL: https://mariadb.com/kb/en/mbrtouches/\n\n','','https://mariadb.com/kb/en/mbrtouches/'),(300,'DROP EVENT',39,'Syntax:\nDROP EVENT [IF EXISTS] event_name\n\nThis statement drops the event named event_name. The event immediately\nceases being active, and is deleted completely from the server.\n\nIf the event does not exist, the error ERROR 1517 (HY000): Unknown\nevent \'event_name\' results. You can override this and cause the\nstatement to generate a warning for nonexistent events instead using IF\nEXISTS.\n\nThis statement requires the EVENT privilege for the schema to which the\nevent to be dropped belongs.\n\nURL: https://mariadb.com/kb/en/drop-event/\n\n','','https://mariadb.com/kb/en/drop-event/'),(301,'INSERT SELECT',27,'Syntax:\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n    [ ON DUPLICATE KEY UPDATE col_name=expr, ... ]\n\nWith INSERT ... SELECT, you can quickly insert many rows into a table\nfrom one or many tables. For example:\n\nINSERT INTO tbl_temp2 (fld_id)\n  SELECT tbl_temp1.fld_order_id\n  FROM tbl_temp1 WHERE tbl_temp1.fld_order_id > 100;\n\nURL: https://mariadb.com/kb/en/insert-select/\n\n','','https://mariadb.com/kb/en/insert-select/'),(302,'CREATE PROCEDURE',39,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    PROCEDURE sp_name ([proc_parameter[,...]])\n    [characteristic ...] routine_body\n\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    FUNCTION sp_name ([func_parameter[,...]])\n    RETURNS type\n    [characteristic ...] routine_body\n\nproc_parameter:\n    [ IN | OUT | INOUT ] param_name type\n\nfunc_parameter:\n    param_name type\n\ntype:\n    Any valid MySQL data type\n\ncharacteristic:\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | [NOT] DETERMINISTIC\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nroutine_body:\n    Valid SQL routine statement\n\nThese statements create stored routines. By default, a routine is\nassociated with the default database. To associate the routine\nexplicitly with a given database, specify the name as db_name.sp_name\nwhen you create it.\n\nThe CREATE FUNCTION statement is also used in MySQL to support UDFs\n(user-defined functions). See\nhttps://mariadb.com/kb/en/create-function-udf/. A UDF can\nbe regarded as an external stored function. Stored functions share\ntheir namespace with UDFs. See\nhttp://dev.mysql.com/doc/refman/5.5/en/function-resolution.html, for\nthe rules describing how the server interprets references to different\nkinds of functions.\n\nTo invoke a stored procedure, use the CALL statement (see [HELP CALL]).\nTo invoke a stored function, refer to it in an expression. The function\nreturns a value during expression evaluation.\n\nCREATE PROCEDURE and CREATE FUNCTION require the CREATE ROUTINE\nprivilege. They might also require the SUPER privilege, depending on\nthe DEFINER value, as described later in this section. If binary\nlogging is enabled, CREATE FUNCTION might require the SUPER privilege,\nas described in\nhttps://mariadb.com/kb/en/binary-logging-of-stored-routines/.\n\nBy default, MySQL automatically grants the ALTER ROUTINE and EXECUTE\nprivileges to the routine creator. This behavior can be changed by\ndisabling the automatic_sp_privileges system variable. See\nhttps://mariadb.com/kb/en/stored-routine-privileges/.\n\nThe DEFINER and SQL SECURITY clauses specify the security context to be\nused when checking access privileges at routine execution time, as\ndescribed later in this section.\n\nIf the routine name is the same as the name of a built-in SQL function,\na syntax error occurs unless you use a space between the name and the\nfollowing parenthesis when defining the routine or invoking it later.\nFor this reason, avoid using the names of existing SQL functions for\nyour own stored routines.\n\nThe IGNORE_SPACE SQL mode applies to built-in functions, not to stored\nroutines. It is always permissible to have spaces after a stored\nroutine name, regardless of whether IGNORE_SPACE is enabled.\n\nThe parameter list enclosed within parentheses must always be present.\nIf there are no parameters, an empty parameter list of () should be\nused. Parameter names are not case sensitive.\n\nEach parameter is an IN parameter by default. To specify otherwise for\na parameter, use the keyword OUT or INOUT before the parameter name.\n\n*Note*: Specifying a parameter as IN, OUT, or INOUT is valid only for a\nPROCEDURE. For a FUNCTION, parameters are always regarded as IN\nparameters.\n\nAn IN parameter passes a value into a procedure. The procedure might\nmodify the value, but the modification is not visible to the caller\nwhen the procedure returns. An OUT parameter passes a value from the\nprocedure back to the caller. Its initial value is NULL within the\nprocedure, and its value is visible to the caller when the procedure\nreturns. An INOUT parameter is initialized by the caller, can be\nmodified by the procedure, and any change made by the procedure is\nvisible to the caller when the procedure returns.\n\nFor each OUT or INOUT parameter, pass a user-defined variable in the\nCALL statement that invokes the procedure so that you can obtain its\nvalue when the procedure returns. If you are calling the procedure from\nwithin another stored procedure or function, you can also pass a\nroutine parameter or local routine variable as an IN or INOUT\nparameter.\n\nThe following example shows a simple stored procedure that uses an OUT\nparameter:\n\nMariaDB> delimiter //\n\nMariaDB> CREATE PROCEDURE simpleproc (OUT param1 INT)\n    -> BEGIN\n    ->   SELECT COUNT(*) INTO param1 FROM t;\n    -> END//\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> delimiter ;\n\nMariaDB> CALL simpleproc(@a);\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SELECT @a;\n+------+\n| @a   |\n+------+\n| 3    |\n+------+\n1 row in set (0.00 sec)\n\nThe example uses the mysql client delimiter command to change the\nstatement delimiter from ; to // while the procedure is being defined.\nThis enables the ; delimiter used in the procedure body to be passed\nthrough to the server rather than being interpreted by mysql itself.\nSee\nhttps://mariadb.com/kb/en/stored-procedure-overview/.\n\nThe RETURNS clause may be specified only for a FUNCTION, for which it\nis mandatory. It indicates the return type of the function, and the\nfunction body must contain a RETURN value statement. If the RETURN\nstatement returns a value of a different type, the value is coerced to\nthe proper type. For example, if a function specifies an ENUM or SET\nvalue in the RETURNS clause, but the RETURN statement returns an\ninteger, the value returned from the function is the string for the\ncorresponding ENUM member of set of SET members.\n\nThe following example function takes a parameter, performs an operation\nusing an SQL function, and returns the result. In this case, it is\nunnecessary to use delimiter because the function definition contains\nno internal ; statement delimiters:\n\nMariaDB> CREATE FUNCTION hello (s CHAR(20))\nMariaDB> RETURNS CHAR(50) DETERMINISTIC\n    -> RETURN CONCAT(\'Hello, \',s,\'!\');\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SELECT hello(\'world\');\n+----------------+\n| hello(\'world\') |\n+----------------+\n| Hello, world!  |\n+----------------+\n1 row in set (0.00 sec)\n\nParameter types and function return types can be declared to use any\nvalid data type, except that the COLLATE attribute cannot be used prior\nto MySQL 5.5.3. As of 5.5.3, COLLATE can be used if preceded by the\nCHARACTER SET attribute.\n\nThe routine_body consists of a valid SQL routine statement. This can be\na simple statement such as SELECT or INSERT, or a compound statement\nwritten using BEGIN and END. Compound statements can contain\ndeclarations, loops, and other control structure statements. The syntax\nfor these statements is described in\nhttps://mariadb.com/kb/programmatic-and-compound-statements.\n\nMySQL permits routines to contain DDL statements, such as CREATE and\nDROP. MySQL also permits stored procedures (but not stored functions)\nto contain SQL transaction statements such as COMMIT. Stored functions\nmay not contain statements that perform explicit or implicit commit or\nrollback. Support for these statements is not required by the SQL\nstandard, which states that each DBMS vendor may decide whether to\npermit them.\n\nStatements that return a result set can be used within a stored\nprocedure but not within a stored function. This prohibition includes\nSELECT statements that do not have an INTO var_list clause and other\nstatements such as SHOW, EXPLAIN, and CHECK TABLE. For statements that\ncan be determined at function definition time to return a result set, a\nNot allowed to return a result set from a function error occurs\n(ER_SP_NO_RETSET). For statements that can be determined only at\nruntime to return a result set, a PROCEDURE %s can\'t return a result\nset in the given context error occurs (ER_SP_BADSELECT).\n\nUSE statements within stored routines are not permitted. When a routine\nis invoked, an implicit USE db_name is performed (and undone when the\nroutine terminates). The causes the routine to have the given default\ndatabase while it executes. References to objects in databases other\nthan the routine default database should be qualified with the\nappropriate database name.\n\nFor additional information about statements that are not permitted in\nstored routines, see\nhttps://mariadb.com/kb/en/stored-routine-privileges/\n.\n\nFor information about invoking stored procedures from within programs\nwritten in a language that has a MySQL interface, see [HELP CALL].\n\nMySQL stores the sql_mode system variable setting that is in effect at\nthe time a routine is created, and always executes the routine with\nthis setting in force, regardless of the server SQL mode in effect when\nthe routine is invoked.\n\nThe switch from the SQL mode of the invoker to that of the routine\noccurs after evaluation of arguments and assignment of the resulting\nvalues to routine parameters. If you define a routine in strict SQL\nmode but invoke it in nonstrict mode, assignment of arguments to\nroutine parameters does not take place in strict mode. If you require\nthat expressions passed to a routine be assigned in strict SQL mode,\nyou should invoke the routine with strict mode in effect.\n\nURL: https://mariadb.com/kb/en/create-procedure/\n\n','','https://mariadb.com/kb/en/create-procedure/'),(303,'VARBINARY',22,'VARBINARY(M)\n\nThe VARBINARY type is similar to the VARCHAR type, but stores binary\nbyte strings rather than nonbinary character strings. M represents the\nmaximum column length in bytes.\n\nURL: https://mariadb.com/kb/en/varbinary/\n\n','','https://mariadb.com/kb/en/varbinary/'),(304,'LOAD INDEX',26,'Syntax:\nLOAD INDEX INTO CACHE\n  tbl_index_list [, tbl_index_list] ...\n\ntbl_index_list:\n  tbl_name\n    [PARTITION (partition_list | ALL)]\n    [[INDEX|KEY] (index_name[, index_name] ...)]\n    [IGNORE LEAVES]\n\npartition_list:\n    partition_name[, partition_name][, ...]\n\nThe LOAD INDEX INTO CACHE statement preloads a table index into the key\ncache to which it has been assigned by an explicit CACHE INDEX\nstatement, or into the default key cache otherwise.\n\nLOAD INDEX INTO CACHE is used only for MyISAM tables. In MySQL 5.5, it\nis also supported for partitioned MyISAM tables; in addition, indexes\non partitioned tables can be preloaded for one, several, or all\npartitions.\n\nThe IGNORE LEAVES modifier causes only blocks for the nonleaf nodes of\nthe index to be preloaded.\n\nIGNORE LEAVES is also supported for partitioned MyISAM tables.\n\nURL: https://mariadb.com/kb/en/load-index/\n\n','','https://mariadb.com/kb/en/load-index/'),(305,'UNION',27,'Syntax:\nSELECT ...\nUNION [ALL | DISTINCT] SELECT ...\n[UNION [ALL | DISTINCT] SELECT ...]\n\nUNION is used to combine the result from multiple SELECT statements\ninto a single result set.\n\nThe column names from the first SELECT statement are used as the column\nnames for the results returned. Selected columns listed in\ncorresponding positions of each SELECT statement should have the same\ndata type. (For example, the first column selected by the first\nstatement should have the same type as the first column selected by the\nother statements.)\n\nURL: https://mariadb.com/kb/en/union/\n\n','','https://mariadb.com/kb/en/union/'),(306,'TO_DAYS',31,'Syntax:\nTO_DAYS(date)\n\nGiven a date date, returns a day number (the number of days since year\n0).\n\nURL: https://mariadb.com/kb/en/to_days/\n\n','MariaDB> SELECT TO_DAYS(950501);\n        -> 728779\nMariaDB> SELECT TO_DAYS(\'2007-10-07\');\n        -> 733321\n','https://mariadb.com/kb/en/to_days/'),(307,'NOT REGEXP',37,'Syntax:\nexpr NOT REGEXP pat, expr NOT RLIKE pat\n\nThis is the same as NOT (expr REGEXP pat).\n\nURL: https://mariadb.com/kb/en/not-regexp/\n\n','','https://mariadb.com/kb/en/not-regexp/'),(308,'SHOW INDEX',26,'Syntax:\nSHOW {INDEX | INDEXES | KEYS}\n    {FROM | IN} tbl_name\n    [{FROM | IN} db_name]\n    [WHERE expr]\n\nSHOW INDEX returns table index information. The format resembles that\nof the SQLStatistics call in ODBC. This statement requires some\nprivilege for any column in the table.\nYou can use db_name.tbl_name as an alternative to the tbl_name FROM\ndb_name syntax. These two statements are equivalent:\n\nSHOW INDEX FROM mytable FROM mydb;\nSHOW INDEX FROM mydb.mytable;\n\nThe WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nYou can also list a table\'s indexes with the mysqlshow -k db_name\ntbl_name command.\n\nURL: https://mariadb.com/kb/en/show-index/\n\n','','https://mariadb.com/kb/en/show-index/'),(309,'SHOW CREATE DATABASE',26,'Syntax:\nSHOW CREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n\nShows the CREATE DATABASE statement that creates the given database. If\nthe SHOW statement includes an IF NOT EXISTS clause, the output too\nincludes such a clause. SHOW CREATE SCHEMA is a synonym for SHOW CREATE\nDATABASE.\n\nURL: https://mariadb.com/kb/en/show-create-database/\n\n','MariaDB> SHOW CREATE DATABASE test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test`\n                 /*!40100 DEFAULT CHARACTER SET latin1 */\n\nMariaDB> SHOW CREATE SCHEMA test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test`\n                 /*!40100 DEFAULT CHARACTER SET latin1 */\n','https://mariadb.com/kb/en/show-create-database/'),(310,'LEAVE',23,'Syntax:\nLEAVE label\n\nThis statement is used to exit the flow control construct that has the\ngiven label. If the label is for the outermost stored program block,\nLEAVE exits the program.\n\nLEAVE can be used within BEGIN ... END or loop constructs (LOOP,\nREPEAT, WHILE).\n\nURL: https://mariadb.com/kb/en/leave/\n\n','','https://mariadb.com/kb/en/leave/'),(311,'NOT IN',18,'Syntax:\nexpr NOT IN (value,...)\n\nThis is the same as NOT (expr IN (value,...)).\n\nURL: https://mariadb.com/kb/en/not-in/\n\n','','https://mariadb.com/kb/en/not-in/'),(312,'!',15,'Syntax:\nNOT, !\n\nLogical NOT. Evaluates to 1 if the operand is 0, to 0 if the operand is\nnonzero, and NOT NULL returns NULL.\n\nURL: https://mariadb.com/kb/en/not/\n\n','MariaDB> SELECT NOT 10;\n        -> 0\nMariaDB> SELECT NOT 0;\n        -> 1\nMariaDB> SELECT NOT NULL;\n        -> NULL\nMariaDB> SELECT ! (1+1);\n        -> 0\nMariaDB> SELECT ! 1+1;\n        -> 1\n','https://mariadb.com/kb/en/not/'),(313,'DECLARE HANDLER',23,'Syntax:\nDECLARE handler_action HANDLER\n    FOR condition_value [, condition_value] ...\n    statement\n\nhandler_action:\n    CONTINUE\n  | EXIT\n  | UNDO\n\ncondition_value:\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n  | SQLWARNING\n  | NOT FOUND\n  | SQLEXCEPTION\n\nThe DECLARE ... HANDLER statement specifies a handler that deals with\none or more conditions. If one of these conditions occurs, the\nspecified statement executes. statement can be a simple statement such\nas SET var_name = value, or a compound statement written using BEGIN\nand END (see [HELP BEGIN END]).\n\nHandler declarations must appear after variable or condition\ndeclarations.\n\nThe handler_action value indicates what action the handler takes after\nexecution of the handler statement:\n\no CONTINUE: Execution of the current program continues.\n\no EXIT: Execution terminates for the BEGIN ... END compound statement\n  in which the handler is declared. This is true even if the condition\n  occurs in an inner block.\n\no UNDO: Not supported.\n\nThe condition_value for DECLARE ... HANDLER indicates the specific\ncondition or class of conditions that activates the handler:\n\no A MySQL error code (a number) or an SQLSTATE value (a 5-character\n  string literal). You should not use MySQL error code 0 or SQLSTATE\n  values that begin with \'00\', because those indicate success rather\n  than an error condition. For a list of MySQL error codes and SQLSTATE\n  values, see\n  https://mariadb.com/kb/en/mariadb-error-codes/.\n\no A condition name previously specified with DECLARE ... CONDITION. A\n  condition name can be associated with a MySQL error code or SQLSTATE\n  value. See [HELP DECLARE CONDITION].\n\no SQLWARNING is shorthand for the class of SQLSTATE values that begin\n  with \'01\'.\n\no NOT FOUND is shorthand for the class of SQLSTATE values that begin\n  with \'02\'. This is relevant within the context of cursors and is used\n  to control what happens when a cursor reaches the end of a data set.\n  If no more rows are available, a No Data condition occurs with\n  SQLSTATE value \'02000\'. To detect this condition, you can set up a\n  handler for it (or for a NOT FOUND condition). For an example, see\n  https://mariadb.com/kb/en/cursor-overview/. This condition\n  also occurs for SELECT ... INTO var_list statements that retrieve no\n  rows.\n\no SQLEXCEPTION is shorthand for the class of SQLSTATE values that do\n  not begin with \'00\', \'01\', or \'02\'.\n\nIf a condition occurs for which no handler has been declared, the\naction taken depends on the condition class:\n\no For SQLEXCEPTION conditions, the stored program terminates at the\n  statement that raised the condition, as if there were an EXIT\n  handler. If the program was called by another stored program, the\n  calling program handles the condition using the handler selection\n  rules applied to its own handlers.\n\no For SQLWARNING conditions, the program continues executing, as if\n  there were a CONTINUE handler.\n\no For NOT FOUND conditions, if the condition was raised normally, the\n  action is CONTINUE. If it was raised by SIGNAL or RESIGNAL, the\n  action is EXIT.\n\nURL: https://mariadb.com/kb/en/declare-handler/\n\n','MariaDB> CREATE TABLE test.t (s1 INT, PRIMARY KEY (s1));\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> delimiter //\n\nMariaDB> CREATE PROCEDURE handlerdemo ()\n    -> BEGIN\n    ->   DECLARE CONTINUE HANDLER FOR SQLSTATE \'23000\' SET @x2 = 1;\n    ->   SET @x = 1;\n    ->   INSERT INTO test.t VALUES (1);\n    ->   SET @x = 2;\n    ->   INSERT INTO test.t VALUES (1);\n    ->   SET @x = 3;\n    -> END;\n    -> //\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> CALL handlerdemo()//\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SELECT @x//\n    +------+\n    | @x   |\n    +------+\n    | 3    |\n    +------+\n    1 row in set (0.00 sec)\n','https://mariadb.com/kb/en/declare-handler/'),(314,'DOUBLE',22,'DOUBLE[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA normal-size (double-precision) floating-point number. Permissible\nvalues are -1.7976931348623157E+308 to -2.2250738585072014E-308, 0, and\n2.2250738585072014E-308 to 1.7976931348623157E+308. These are the\ntheoretical limits, based on the IEEE standard. The actual range might\nbe slightly smaller depending on your hardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A double-precision floating-point\nnumber is accurate to approximately 15 decimal places.\n\nUNSIGNED, if specified, disallows negative values.\n\nURL: https://mariadb.com/kb/en/double/\n\n','','https://mariadb.com/kb/en/double/'),(315,'TIME',22,'TIME\n\nA time. The range is \'-838:59:59\' to \'838:59:59\'. MySQL displays TIME\nvalues in \'HH:MM:SS\' format, but permits assignment of values to TIME\ncolumns using either strings or numbers.\n\nURL: https://mariadb.com/kb/en/time/\n\n','','https://mariadb.com/kb/en/time/'),(316,'&&',15,'Syntax:\nAND, &&\n\nLogical AND. Evaluates to 1 if all operands are nonzero and not NULL,\nto 0 if one or more operands are 0, otherwise NULL is returned.\n\nURL: https://mariadb.com/kb/en/and/\n\n','MariaDB> SELECT 1 && 1;\n        -> 1\nMariaDB> SELECT 1 && 0;\n        -> 0\nMariaDB> SELECT 1 && NULL;\n        -> NULL\nMariaDB> SELECT 0 && NULL;\n        -> 0\nMariaDB> SELECT NULL && 0;\n        -> 0\n','https://mariadb.com/kb/en/and/'),(317,'X',11,'X(p)\n\nReturns the X-coordinate value for the Point object p as a\ndouble-precision number.\n\nURL: https://mariadb.com/kb/en/x/\n\n','MariaDB> SELECT X(POINT(56.7, 53.34));\n+-----------------------+\n| X(POINT(56.7, 53.34)) |\n+-----------------------+\n|                  56.7 |\n+-----------------------+\n','https://mariadb.com/kb/en/x/'),(318,'SYSTEM_USER',17,'Syntax:\nSYSTEM_USER()\n\nSYSTEM_USER() is a synonym for USER().\n\nURL: https://mariadb.com/kb/en/system_user/\n\n','','https://mariadb.com/kb/en/system_user/'),(319,'FOUND_ROWS',17,'Syntax:\nFOUND_ROWS()\n\nA SELECT statement may include a LIMIT clause to restrict the number of\nrows the server returns to the client. In some cases, it is desirable\nto know how many rows the statement would have returned without the\nLIMIT, but without running the statement again. To obtain this row\ncount, include a SQL_CALC_FOUND_ROWS option in the SELECT statement,\nand then invoke FOUND_ROWS() afterward:\n\nURL: https://mariadb.com/kb/en/found_rows/\n\n','MariaDB> SELECT SQL_CALC_FOUND_ROWS * FROM tbl_name\n    -> WHERE id > 100 LIMIT 10;\nMariaDB> SELECT FOUND_ROWS();\n','https://mariadb.com/kb/en/found_rows/'),(320,'CROSSES',30,'Crosses(g1,g2)\n\nReturns 1 if g1 spatially crosses g2. Returns NULL if g1 is a Polygon\nor a MultiPolygon, or if g2 is a Point or a MultiPoint. Otherwise,\nreturns 0.\n\nThe term spatially crosses denotes a spatial relation between two given\ngeometries that has the following properties:\n\no The two geometries intersect\n\no Their intersection results in a geometry that has a dimension that is\n  one less than the maximum dimension of the two given geometries\n\no Their intersection is not equal to either of the two given geometries\n\nURL: https://mariadb.com/kb/en/crosses/\n\n','','https://mariadb.com/kb/en/crosses/'),(321,'TRUNCATE TABLE',39,'Syntax:\nTRUNCATE [TABLE] tbl_name\n\nTRUNCATE TABLE empties a table completely. It requires the DROP\nprivilege.\n\nLogically, TRUNCATE TABLE is similar to a DELETE statement that deletes\nall rows, or a sequence of DROP TABLE and CREATE TABLE statements. To\nachieve high performance, it bypasses the DML method of deleting data.\nThus, it cannot be rolled back, it does not cause ON DELETE triggers to\nfire, and it cannot be performed for InnoDB tables with parent-child\nforeign key relationships.\n\nAlthough TRUNCATE TABLE is similar to DELETE, it is classified as a DDL\nstatement rather than a DML statement. It differs from DELETE in the\nfollowing ways in MySQL 5.5:\n\no Truncate operations drop and re-create the table, which is much\n  faster than deleting rows one by one, particularly for large tables.\n\no Truncate operations cause an implicit commit, and so cannot be rolled\n  back.\n\no Truncation operations cannot be performed if the session holds an\n  active table lock.\n\no TRUNCATE TABLE fails for an InnoDB table if there are any FOREIGN KEY\n  constraints from other tables that reference the table. Foreign key\n  constraints between columns of the same table are permitted.\n\no Truncation operations do not return a meaningful value for the number\n  of deleted rows. The usual result is \"0 rows affected,\" which should\n  be interpreted as \"no information.\"\n\no As long as the table format file tbl_name.frm is valid, the table can\n  be re-created as an empty table with TRUNCATE TABLE, even if the data\n  or index files have become corrupted.\n\no Any AUTO_INCREMENT value is reset to its start value. This is true\n  even for MyISAM and InnoDB, which normally do not reuse sequence\n  values.\n\no When used with partitioned tables, TRUNCATE TABLE preserves the\n  partitioning; that is, the data and index files are dropped and\n  re-created, while the partition definitions (.par) file is\n  unaffected.\n\no The TRUNCATE TABLE statement does not invoke ON DELETE triggers.\n\nURL: https://mariadb.com/kb/en/truncate-table/\n\n','','https://mariadb.com/kb/en/truncate-table/'),(322,'BIT_XOR',16,'Syntax:\nBIT_XOR(expr)\n\nReturns the bitwise XOR of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: https://mariadb.com/kb/en/bit_xor/\n\n','','https://mariadb.com/kb/en/bit_xor/'),(323,'CURRENT_DATE',31,'Syntax:\nCURRENT_DATE, CURRENT_DATE()\n\nCURRENT_DATE and CURRENT_DATE() are synonyms for CURDATE().\n\nURL: https://mariadb.com/kb/en/current_date/\n\n','','https://mariadb.com/kb/en/current_date/'),(324,'START SLAVE',8,'Syntax:\nSTART SLAVE [thread_types]\n\nSTART SLAVE [SQL_THREAD] UNTIL\n    MASTER_LOG_FILE = \'log_name\', MASTER_LOG_POS = log_pos\n\nSTART SLAVE [SQL_THREAD] UNTIL\n    RELAY_LOG_FILE = \'log_name\', RELAY_LOG_POS = log_pos\n\nthread_types:\n    [thread_type [, thread_type] ... ]\n\nthread_type: IO_THREAD | SQL_THREAD\n\nSTART SLAVE with no thread_type options starts both of the slave\nthreads. The I/O thread reads events from the master server and stores\nthem in the relay log. The SQL thread reads events from the relay log\nand executes them. START SLAVE requires the SUPER privilege.\n\nIf START SLAVE succeeds in starting the slave threads, it returns\nwithout any error. However, even in that case, it might be that the\nslave threads start and then later stop (for example, because they do\nnot manage to connect to the master or read its binary log, or some\nother problem). START SLAVE does not warn you about this. You must\ncheck the slave\'s error log for error messages generated by the slave\nthreads, or check that they are running satisfactorily with SHOW SLAVE\nSTATUS.\n\nURL: https://mariadb.com/kb/en/start-slave/\n\n','','https://mariadb.com/kb/en/start-slave/'),(325,'AREA',2,'Area(poly)\n\nReturns as a double-precision number the area of the Polygon value\npoly, as measured in its spatial reference system.\n\nURL: https://mariadb.com/kb/en/area/\n\n','MariaDB> SET @poly = \'Polygon((0 0,0 3,3 0,0 0),(1 1,1 2,2 1,1 1))\';\nMariaDB> SELECT Area(GeomFromText(@poly));\n+---------------------------+\n| Area(GeomFromText(@poly)) |\n+---------------------------+\n|                         4 |\n+---------------------------+\n','https://mariadb.com/kb/en/area/'),(326,'FLUSH',26,'Syntax:\nFLUSH [NO_WRITE_TO_BINLOG | LOCAL]\n    flush_option [, flush_option] ...\n\nThe FLUSH statement has several variant forms that clear or reload\nvarious internal caches, flush tables, or acquire locks. To execute\nFLUSH, you must have the RELOAD privilege. Specific flush options might\nrequire additional privileges, as described later.\n\nBy default, the server writes FLUSH statements to the binary log so\nthat they replicate to replication slaves. To suppress logging, use the\noptional NO_WRITE_TO_BINLOG keyword or its alias LOCAL.\n\n*Note*: FLUSH LOGS, FLUSH MASTER, FLUSH SLAVE, and FLUSH TABLES WITH\nREAD LOCK (with or without a table list) are not written to the binary\nlog in any case because they would cause problems if replicated to a\nslave.\n\nThe FLUSH statement causes an implicit commit. See\nhttp://dev.mysql.com/doc/refman/5.5/en/implicit-commit.html.\n\nThe RESET statement is similar to FLUSH. See [HELP RESET], for\ninformation about using the RESET statement with replication.\n\nURL: https://mariadb.com/kb/en/flush/\n\n','','https://mariadb.com/kb/en/flush/'),(327,'BEGIN END',23,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\nBEGIN ... END syntax is used for writing compound statements, which can\nappear within stored programs (stored procedures and functions,\ntriggers, and events). A compound statement can contain multiple\nstatements, enclosed by the BEGIN and END keywords. statement_list\nrepresents a list of one or more statements, each terminated by a\nsemicolon (;) statement delimiter. The statement_list itself is\noptional, so the empty compound statement (BEGIN END) is legal.\n\nBEGIN ... END blocks can be nested.\n\nUse of multiple statements requires that a client is able to send\nstatement strings containing the ; statement delimiter. In the mysql\ncommand-line client, this is handled with the delimiter command.\nChanging the ; end-of-statement delimiter (for example, to //) permit ;\nto be used in a program body. For an example, see\nhttps://mariadb.com/kb/en/stored-procedure-overview/.\n\nA BEGIN ... END block can be labeled. See [HELP labels].\n\nURL: https://mariadb.com/kb/en/begin-end/\n\n','','https://mariadb.com/kb/en/begin-end/'),(328,'SHOW PROCEDURE STATUS',26,'Syntax:\nSHOW PROCEDURE STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is a MySQL extension. It returns characteristics of a\nstored procedure, such as the database, name, type, creator, creation\nand modification dates, and character set information. A similar\nstatement, SHOW FUNCTION STATUS, displays information about stored\nfunctions (see [HELP SHOW FUNCTION STATUS]).\n\nThe LIKE clause, if present, indicates which procedure or function\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/.\n\nURL: https://mariadb.com/kb/en/show-procedure-status/\n\n','MariaDB> SHOW PROCEDURE STATUS LIKE \'sp1\'\\G\n*************************** 1. row ***************************\n                  Db: test\n                Name: sp1\n                Type: PROCEDURE\n             Definer: testuser@localhost\n            Modified: 2004-08-03 15:29:37\n             Created: 2004-08-03 15:29:37\n       Security_type: DEFINER\n             Comment:\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','https://mariadb.com/kb/en/show-procedure-status/'),(329,'DESCRIBE',28,'Syntax:\n{DESCRIBE | DESC} tbl_name [col_name | wild]\n\nDESCRIBE provides information about the columns in a table. It is a\nshortcut for SHOW COLUMNS FROM. These statements also display\ninformation for views. (See [HELP SHOW COLUMNS].)\n\ncol_name can be a column name, or a string containing the SQL \"%\" and\n\"_\" wildcard characters to obtain output only for the columns with\nnames matching the string. There is no need to enclose the string\nwithin quotation marks unless it contains spaces or other special\ncharacters.\n\nMariaDB> DESCRIBE City;\n+------------+----------+------+-----+---------+----------------+\n| Field      | Type     | Null | Key | Default | Extra          |\n+------------+----------+------+-----+---------+----------------+\n| Id         | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name       | char(35) | NO   |     |         |                |\n| Country    | char(3)  | NO   | UNI |         |                |\n| District   | char(20) | YES  | MUL |         |                |\n| Population | int(11)  | NO   |     | 0       |                |\n+------------+----------+------+-----+---------+----------------+\n5 rows in set (0.00 sec)\n\nThe description for SHOW COLUMNS provides more information about the\noutput columns (see [HELP SHOW COLUMNS]).\n\nURL: https://mariadb.com/kb/en/describe/\n\n','','https://mariadb.com/kb/en/describe/'),(330,'SHOW WARNINGS',26,'Syntax:\nSHOW WARNINGS [LIMIT [offset,] row_count]\nSHOW COUNT(*) WARNINGS\n\nSHOW WARNINGS shows information about the conditions (errors, warnings,\nand notes) that resulted from the last statement in the current session\nthat generated messages. It shows nothing if the last statement used a\ntable and generated no messages. (That is, a statement that uses a\ntable but generates no messages clears the message list.) Statements\nthat do not use tables and do not generate messages have no effect on\nthe message list.\n\nWarnings are generated for DML statements such as INSERT, UPDATE, and\nLOAD DATA INFILE as well as DDL statements such as CREATE TABLE and\nALTER TABLE.\n\nSHOW WARNINGS is also used following EXPLAIN EXTENDED, to display the\nextra information generated by EXPLAIN when the EXTENDED keyword is\nused. See https://mariadb.com/kb/en/explain#explain-extended.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttps://mariadb.com/kb/en/select/.\n\nA related statement, SHOW ERRORS, shows only the error conditions (it\nexcludes warnings and notes). See [HELP SHOW ERRORS].\n\nThe SHOW COUNT(*) WARNINGS statement displays the total number of\nerrors, warnings, and notes. You can also retrieve this number from the\nwarning_count system variable:\n\nSHOW COUNT(*) WARNINGS;\nSELECT @@warning_count;\n\nURL: https://mariadb.com/kb/en/show-warnings/\n\n','','https://mariadb.com/kb/en/show-warnings/'),(331,'DROP USER',10,'Syntax:\nDROP USER user [, user] ...\n\nThe DROP USER statement removes one or more MySQL accounts and their\nprivileges. It removes privilege rows for the account from all grant\ntables. To use this statement, you must have the global CREATE USER\nprivilege or the DELETE privilege for the mysql database. Each account\nname uses the format described in\nhttps://mariadb.com/kb/en/create-user#account-names. For example:\n\nDROP USER \'jeffrey\'@\'localhost\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nURL: https://mariadb.com/kb/en/drop-user/\n\n','','https://mariadb.com/kb/en/drop-user/'),(332,'STDDEV_POP',16,'Syntax:\nSTDDEV_POP(expr)\n\nReturns the population standard deviation of expr (the square root of\nVAR_POP()). You can also use STD() or STDDEV(), which are equivalent\nbut not standard SQL.\n\nSTDDEV_POP() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/stddev_pop/\n\n','','https://mariadb.com/kb/en/stddev_pop/'),(333,'SHOW CHARACTER SET',26,'Syntax:\nSHOW CHARACTER SET\n    [LIKE \'pattern\' | WHERE expr]\n\nThe SHOW CHARACTER SET statement shows all available character sets.\nThe LIKE clause, if present, indicates which character set names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/. For example:\n\nMariaDB> SHOW CHARACTER SET LIKE \'latin%\';\n+---------+-----------------------------+-------------------+--------+\n| Charset | Description                 | Default collation | Maxlen |\n+---------+-----------------------------+-------------------+--------+\n| latin1  | cp1252 West European        | latin1_swedish_ci |      1 |\n| latin2  | ISO 8859-2 Central European | latin2_general_ci |      1 |\n| latin5  | ISO 8859-9 Turkish          | latin5_turkish_ci |      1 |\n| latin7  | ISO 8859-13 Baltic          | latin7_general_ci |      1 |\n+---------+-----------------------------+-------------------+--------+\n\nURL: https://mariadb.com/kb/en/show-character-set/\n\n','','https://mariadb.com/kb/en/show-character-set/'),(334,'SUBSTRING',37,'Syntax:\nSUBSTRING(str,pos), SUBSTRING(str FROM pos), SUBSTRING(str,pos,len),\nSUBSTRING(str FROM pos FOR len)\n\nThe forms without a len argument return a substring from string str\nstarting at position pos. The forms with a len argument return a\nsubstring len characters long from string str, starting at position\npos. The forms that use FROM are standard SQL syntax. It is also\npossible to use a negative value for pos. In this case, the beginning\nof the substring is pos characters from the end of the string, rather\nthan the beginning. A negative value may be used for pos in any of the\nforms of this function.\n\nFor all forms of SUBSTRING(), the position of the first character in\nthe string from which the substring is to be extracted is reckoned as\n1.\n\nURL: https://mariadb.com/kb/en/substring/\n\n','MariaDB> SELECT SUBSTRING(\'Quadratically\',5);\n        -> \'ratically\'\nMariaDB> SELECT SUBSTRING(\'foobarbar\' FROM 4);\n        -> \'barbar\'\nMariaDB> SELECT SUBSTRING(\'Quadratically\',5,6);\n        -> \'ratica\'\nMariaDB> SELECT SUBSTRING(\'Sakila\', -3);\n        -> \'ila\'\nMariaDB> SELECT SUBSTRING(\'Sakila\', -5, 3);\n        -> \'aki\'\nMariaDB> SELECT SUBSTRING(\'Sakila\' FROM -4 FOR 2);\n        -> \'ki\'\n','https://mariadb.com/kb/en/substring/'),(335,'ISEMPTY',36,'IsEmpty(g)\n\nReturns 1 if the geometry value g is the empty geometry, 0 if it is not\nempty, and -1 if the argument is NULL. If the geometry is empty, it\nrepresents the empty point set.\n\nURL: https://mariadb.com/kb/en/isempty/\n\n','','https://mariadb.com/kb/en/isempty/'),(336,'SHOW FUNCTION STATUS',26,'Syntax:\nSHOW FUNCTION STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is similar to SHOW PROCEDURE STATUS but for stored\nfunctions. See [HELP SHOW PROCEDURE STATUS].\n\nURL: https://mariadb.com/kb/en/show-function-status/\n\n','','https://mariadb.com/kb/en/show-function-status/'),(337,'LTRIM',37,'Syntax:\nLTRIM(str)\n\nReturns the string str with leading space characters removed.\n\nURL: https://mariadb.com/kb/en/ltrim/\n\n','MariaDB> SELECT LTRIM(\'  barbar\');\n        -> \'barbar\'\n','https://mariadb.com/kb/en/ltrim/'),(338,'INTERSECTS',30,'Intersects(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially intersects g2.\n\nURL: https://mariadb.com/kb/en/intersects/\n\n','','https://mariadb.com/kb/en/intersects/'),(339,'CALL',27,'Syntax:\nCALL sp_name([parameter[,...]])\nCALL sp_name[()]\n\nThe CALL statement invokes a stored procedure that was defined\npreviously with CREATE PROCEDURE.\n\nStored procedures that take no arguments can be invoked without\nparentheses. That is, CALL p() and CALL p are equivalent.\n\nCALL can pass back values to its caller using parameters that are\ndeclared as OUT or INOUT parameters. When the procedure returns, a\nclient program can also obtain the number of rows affected for the\nfinal statement executed within the routine: At the SQL level, call the\nROW_COUNT() function; from the C API, call the mysql_affected_rows()\nfunction.\n\nURL: https://mariadb.com/kb/en/call/\n\n','','https://mariadb.com/kb/en/call/'),(340,'MBRDISJOINT',6,'MBRDisjoint(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 are disjoint (do not intersect).\n\nURL: https://mariadb.com/kb/en/mbrdisjoint/\n\n','','https://mariadb.com/kb/en/mbrdisjoint/'),(341,'VALUES',14,'Syntax:\nVALUES(col_name)\n\nIn an INSERT ... ON DUPLICATE KEY UPDATE statement, you can use the\nVALUES(col_name) function in the UPDATE clause to refer to column\nvalues from the INSERT portion of the statement. In other words,\nVALUES(col_name) in the UPDATE clause refers to the value of col_name\nthat would be inserted, had no duplicate-key conflict occurred. This\nfunction is especially useful in multiple-row inserts. The VALUES()\nfunction is meaningful only in the ON DUPLICATE KEY UPDATE clause of\nINSERT statements and returns NULL otherwise. See\nhttps://mariadb.com/kb/en/insert-on-duplicate-key-update/.\n\nURL: https://mariadb.com/kb/en/values/\n\n','MariaDB> INSERT INTO table (a,b,c) VALUES (1,2,3),(4,5,6)\n    -> ON DUPLICATE KEY UPDATE c=VALUES(a)+VALUES(b);\n','https://mariadb.com/kb/en/values/'),(342,'SUBSTRING_INDEX',37,'Syntax:\nSUBSTRING_INDEX(str,delim,count)\n\nReturns the substring from string str before count occurrences of the\ndelimiter delim. If count is positive, everything to the left of the\nfinal delimiter (counting from the left) is returned. If count is\nnegative, everything to the right of the final delimiter (counting from\nthe right) is returned. SUBSTRING_INDEX() performs a case-sensitive\nmatch when searching for delim.\n\nURL: https://mariadb.com/kb/en/substring_index/\n\n','MariaDB> SELECT SUBSTRING_INDEX(\'www.mariadb.org\', \'.\', 2);\n        -> \'www.mariadb\'\nMariaDB> SELECT SUBSTRING_INDEX(\'www.mariadb.org\', \'.\', -2);\n        -> \'mariadb.org\'\n','https://mariadb.com/kb/en/substring_index/'),(343,'ENCODE',12,'Syntax:\nENCODE(str,pass_str)\n\nEncrypt str using pass_str as the password. To decrypt the result, use\nDECODE().\n\nThe result is a binary string of the same length as str.\n\nThe strength of the encryption is based on how good the random\ngenerator is. It should suffice for short strings.\n\nURL: https://mariadb.com/kb/en/encode/\n\n','','https://mariadb.com/kb/en/encode/'),(344,'LOOP',23,'Syntax:\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\nLOOP implements a simple loop construct, enabling repeated execution of\nthe statement list, which consists of one or more statements, each\nterminated by a semicolon (;) statement delimiter. The statements\nwithin the loop are repeated until the loop is terminated. Usually,\nthis is accomplished with a LEAVE statement. Within a stored function,\nRETURN can also be used, which exits the function entirely.\n\nNeglecting to include a loop-termination statement results in an\ninfinite loop.\n\nA LOOP statement can be labeled. For the rules regarding label use, see\n[HELP labels].\n\nURL: https://mariadb.com/kb/en/loop/\n\n','CREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN\n      ITERATE label1;\n    END IF;\n    LEAVE label1;\n  END LOOP label1;\n  SET @x = p1;\nEND;\n','https://mariadb.com/kb/en/loop/'),(345,'TRUNCATE',4,'Syntax:\nTRUNCATE(X,D)\n\nReturns the number X, truncated to D decimal places. If D is 0, the\nresult has no decimal point or fractional part. D can be negative to\ncause D digits left of the decimal point of the value X to become zero.\n\nURL: https://mariadb.com/kb/en/truncate/\n\n','MariaDB> SELECT TRUNCATE(1.223,1);\n        -> 1.2\nMariaDB> SELECT TRUNCATE(1.999,1);\n        -> 1.9\nMariaDB> SELECT TRUNCATE(1.999,0);\n        -> 1\nMariaDB> SELECT TRUNCATE(-1.999,1);\n        -> -1.9\nMariaDB> SELECT TRUNCATE(122,-2);\n       -> 100\nMariaDB> SELECT TRUNCATE(10.28*100,0);\n       -> 1028\n','https://mariadb.com/kb/en/truncate/'),(346,'TIMESTAMPADD',31,'Syntax:\nTIMESTAMPADD(unit,interval,datetime_expr)\n\nAdds the integer expression interval to the date or datetime expression\ndatetime_expr. The unit for interval is given by the unit argument,\nwhich should be one of the following values: MICROSECOND\n(microseconds), SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or\nYEAR.\n\nIt is possible to use FRAC_SECOND in place of MICROSECOND, but\nFRAC_SECOND is deprecated. FRAC_SECOND was removed in MySQL 5.5.3.\n\nThe unit value may be specified using one of keywords as shown, or with\na prefix of SQL_TSI_. For example, DAY and SQL_TSI_DAY both are legal.\n\nURL: https://mariadb.com/kb/en/timestampadd/\n\n','MariaDB> SELECT TIMESTAMPADD(MINUTE,1,\'2003-01-02\');\n        -> \'2003-01-02 00:01:00\'\nMariaDB> SELECT TIMESTAMPADD(WEEK,1,\'2003-01-02\');\n        -> \'2003-01-09\'\n','https://mariadb.com/kb/en/timestampadd/'),(347,'SHOW',26,'SHOW has many forms that provide information about databases, tables,\ncolumns, or status information about the server. This section describes\nthose following:\n\nSHOW AUTHORS\nSHOW {BINARY | MASTER} LOGS\nSHOW BINLOG EVENTS [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\nSHOW CHARACTER SET [like_or_where]\nSHOW COLLATION [like_or_where]\nSHOW [FULL] COLUMNS FROM tbl_name [FROM db_name] [like_or_where]\nSHOW CONTRIBUTORS\nSHOW CREATE DATABASE db_name\nSHOW CREATE EVENT event_name\nSHOW CREATE FUNCTION func_name\nSHOW CREATE PROCEDURE proc_name\nSHOW CREATE TABLE tbl_name\nSHOW CREATE TRIGGER trigger_name\nSHOW CREATE VIEW view_name\nSHOW DATABASES [like_or_where]\nSHOW ENGINE engine_name {STATUS | MUTEX}\nSHOW [STORAGE] ENGINES\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW EVENTS\nSHOW FUNCTION CODE func_name\nSHOW FUNCTION STATUS [like_or_where]\nSHOW GRANTS FOR user\nSHOW INDEX FROM tbl_name [FROM db_name]\nSHOW MASTER STATUS\nSHOW OPEN TABLES [FROM db_name] [like_or_where]\nSHOW PLUGINS\nSHOW PROCEDURE CODE proc_name\nSHOW PROCEDURE STATUS [like_or_where]\nSHOW PRIVILEGES\nSHOW [FULL] PROCESSLIST\nSHOW PROFILE [types] [FOR QUERY n] [OFFSET n] [LIMIT n]\nSHOW PROFILES\nSHOW SLAVE HOSTS\nSHOW SLAVE STATUS\nSHOW [GLOBAL | SESSION] STATUS [like_or_where]\nSHOW TABLE STATUS [FROM db_name] [like_or_where]\nSHOW [FULL] TABLES [FROM db_name] [like_or_where]\nSHOW TRIGGERS [FROM db_name] [like_or_where]\nSHOW [GLOBAL | SESSION] VARIABLES [like_or_where]\nSHOW WARNINGS [LIMIT [offset,] row_count]\n\nlike_or_where:\n    LIKE \'pattern\'\n  | WHERE expr\n\nIf the syntax for a given SHOW statement includes a LIKE \'pattern\'\npart, \'pattern\' is a string that can contain the SQL \"%\" and \"_\"\nwildcard characters. The pattern is useful for restricting statement\noutput to matching values.\n\nSeveral SHOW statements also accept a WHERE clause that provides more\nflexibility in specifying which rows to display. See\nhttps://mariadb.com/kb/en/extended-show/.\n\nURL: https://mariadb.com/kb/en/show/\n\n','','https://mariadb.com/kb/en/show/'),(348,'GREATEST',18,'Syntax:\nGREATEST(value1,value2,...)\n\nWith two or more arguments, returns the largest (maximum-valued)\nargument. The arguments are compared using the same rules as for\nLEAST().\n\nURL: https://mariadb.com/kb/en/greatest/\n\n','MariaDB> SELECT GREATEST(2,0);\n        -> 2\nMariaDB> SELECT GREATEST(34.0,3.0,5.0,767.0);\n        -> 767.0\nMariaDB> SELECT GREATEST(\'B\',\'A\',\'C\');\n        -> \'C\'\n','https://mariadb.com/kb/en/greatest/'),(349,'SHOW VARIABLES',26,'Syntax:\nSHOW [GLOBAL | SESSION] VARIABLES\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW VARIABLES shows the values of MySQL system variables. This\ninformation also can be obtained using the mysqladmin variables\ncommand. The LIKE clause, if present, indicates which variable names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttps://mariadb.com/kb/en/extended-show/. This\nstatement does not require any privilege. It requires only the ability\nto connect to the server.\n\nWith the GLOBAL modifier, SHOW VARIABLES displays the values that are\nused for new connections to MySQL. As of MySQL 5.5.3, if a variable has\nno global value, no value is displayed. Before 5.5.3, the session value\nis displayed. With SESSION, SHOW VARIABLES displays the values that are\nin effect for the current connection. If no modifier is present, the\ndefault is SESSION. LOCAL is a synonym for SESSION.\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern. To obtain the row for a\nspecific variable, use a LIKE clause as shown:\n\nSHOW VARIABLES LIKE \'max_join_size\';\nSHOW SESSION VARIABLES LIKE \'max_join_size\';\n\nTo get a list of variables whose name match a pattern, use the \"%\"\nwildcard character in a LIKE clause:\n\nSHOW VARIABLES LIKE \'%size%\';\nSHOW GLOBAL VARIABLES LIKE \'%size%\';\n\nWildcard characters can be used in any position within the pattern to\nbe matched. Strictly speaking, because \"_\" is a wildcard that matches\nany single character, you should escape it as \"\\_\" to match it\nliterally. In practice, this is rarely necessary.\n\nURL: https://mariadb.com/kb/en/show-variables/\n\n','','https://mariadb.com/kb/en/show-variables/'),(350,'BINLOG',26,'Syntax:\nBINLOG \'str\'\n\nBINLOG is an internal-use statement. It is generated by the mysqlbinlog\nprogram as the printable representation of certain events in binary log\nfiles. (See https://mariadb.com/kb/en/mysqlbinlog/.)\nThe \'str\' value is a base 64-encoded string the that server decodes to\ndetermine the data change indicated by the corresponding event. This\nstatement requires the SUPER privilege.\n\nURL: https://mariadb.com/kb/en/binlog/\n\n','','https://mariadb.com/kb/en/binlog/'),(351,'BIT_AND',16,'Syntax:\nBIT_AND(expr)\n\nReturns the bitwise AND of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: https://mariadb.com/kb/en/bit_and/\n\n','','https://mariadb.com/kb/en/bit_and/'),(352,'SECOND',31,'Syntax:\nSECOND(time)\n\nReturns the second for time, in the range 0 to 59.\n\nURL: https://mariadb.com/kb/en/second/\n\n','MariaDB> SELECT SECOND(\'10:05:03\');\n        -> 3\n','https://mariadb.com/kb/en/second/'),(353,'ATAN2',4,'Syntax:\nATAN(Y,X), ATAN2(Y,X)\n\nReturns the arc tangent of the two variables X and Y. It is similar to\ncalculating the arc tangent of Y / X, except that the signs of both\narguments are used to determine the quadrant of the result.\n\nURL: https://mariadb.com/kb/en/atan2/\n\n','MariaDB> SELECT ATAN(-2,2);\n        -> -0.78539816339745\nMariaDB> SELECT ATAN2(PI(),0);\n        -> 1.5707963267949\n','https://mariadb.com/kb/en/atan2/'),(354,'MBRCONTAINS',6,'MBRContains(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangle of g1\ncontains the Minimum Bounding Rectangle of g2. This tests the opposite\nrelationship as MBRWithin().\n\nURL: https://mariadb.com/kb/en/mbrcontains/\n\n','MariaDB> SET @g1 = GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nMariaDB> SET @g2 = GeomFromText(\'Point(1 1)\');\nMariaDB> SELECT MBRContains(@g1,@g2), MBRContains(@g2,@g1);\n----------------------+----------------------+\n| MBRContains(@g1,@g2) | MBRContains(@g2,@g1) |\n+----------------------+----------------------+\n|                    1 |                    0 |\n+----------------------+----------------------+\n','https://mariadb.com/kb/en/mbrcontains/'),(355,'HOUR',31,'Syntax:\nHOUR(time)\n\nReturns the hour for time. The range of the return value is 0 to 23 for\ntime-of-day values. However, the range of TIME values actually is much\nlarger, so HOUR can return values greater than 23.\n\nURL: https://mariadb.com/kb/en/hour/\n\n','MariaDB> SELECT HOUR(\'10:05:03\');\n        -> 10\nMariaDB> SELECT HOUR(\'272:59:59\');\n        -> 272\n','https://mariadb.com/kb/en/hour/'),(356,'SELECT',27,'Syntax:\nSELECT\n    [ALL | DISTINCT | DISTINCTROW ]\n      [HIGH_PRIORITY]\n      [STRAIGHT_JOIN]\n      [SQL_SMALL_RESULT] [SQL_BIG_RESULT] [SQL_BUFFER_RESULT]\n      [SQL_CACHE | SQL_NO_CACHE] [SQL_CALC_FOUND_ROWS]\n    select_expr [, select_expr ...]\n    [FROM table_references\n    [WHERE where_condition]\n    [GROUP BY {col_name | expr | position}\n      [ASC | DESC], ... [WITH ROLLUP]]\n    [HAVING where_condition]\n    [ORDER BY {col_name | expr | position}\n      [ASC | DESC], ...]\n    [LIMIT {[offset,] row_count | row_count OFFSET offset}]\n    [PROCEDURE procedure_name(argument_list)]\n    [INTO OUTFILE \'file_name\'\n        [CHARACTER SET charset_name]\n        export_options\n      | INTO DUMPFILE \'file_name\'\n      | INTO var_name [, var_name]]\n    [FOR UPDATE | LOCK IN SHARE MODE]]\n\nSELECT is used to retrieve rows selected from one or more tables, and\ncan include UNION statements and subqueries. See [HELP UNION], and\nhttps://mariadb.com/kb/en/subqueries/.\n\nThe most commonly used clauses of SELECT statements are these:\n\no Each select_expr indicates a column that you want to retrieve. There\n  must be at least one select_expr.\n\no table_references indicates the table or tables from which to retrieve\n  rows. Its syntax is described in [HELP JOIN].\n\no The WHERE clause, if given, indicates the condition or conditions\n  that rows must satisfy to be selected. where_condition is an\n  expression that evaluates to true for each row to be selected. The\n  statement selects all rows if there is no WHERE clause.\n\n  In the WHERE expression, you can use any of the functions and\n  operators that MySQL supports, except for aggregate (summary)\n  functions. See\n  https://mariadb.com/kb/en/select#select-expressions, and\n  https://mariadb.com/kb/en/functions-and-operators/.\n\nSELECT can also be used to retrieve rows computed without reference to\nany table.\n\nURL: https://mariadb.com/kb/en/select/\n\n','','https://mariadb.com/kb/en/select/'),(357,'COT',4,'Syntax:\nCOT(X)\n\nReturns the cotangent of X.\n\nURL: https://mariadb.com/kb/en/cot/\n\n','MariaDB> SELECT COT(12);\n        -> -1.5726734063977\nMariaDB> SELECT COT(0);\n        -> NULL\n','https://mariadb.com/kb/en/cot/'),(358,'SHOW CREATE EVENT',26,'Syntax:\nSHOW CREATE EVENT event_name\n\nThis statement displays the CREATE EVENT statement needed to re-create\na given event. It requires the EVENT privilege for the database from\nwhich the event is to be shown. For example (using the same event\ne_daily defined and then altered in [HELP SHOW EVENTS]):\n\nURL: https://mariadb.com/kb/en/show-create-event/\n\n','MariaDB> SHOW CREATE EVENT test.e_daily\\G\n*************************** 1. row ***************************\n               Event: e_daily\n            sql_mode:\n           time_zone: SYSTEM\n        Create Event: CREATE EVENT `e_daily`\n                        ON SCHEDULE EVERY 1 DAY\n                        STARTS CURRENT_TIMESTAMP + INTERVAL 6 HOUR\n                        ON COMPLETION NOT PRESERVE\n                        ENABLE\n                        COMMENT \'Saves total number of sessions then\n                                clears the table each day\'\n                        DO BEGIN\n                          INSERT INTO site_activity.totals (time, total)\n                            SELECT CURRENT_TIMESTAMP, COUNT(*)\n                            FROM site_activity.sessions;\n                          DELETE FROM site_activity.sessions;\n                        END\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','https://mariadb.com/kb/en/show-create-event/'),(359,'LOAD_FILE',37,'Syntax:\nLOAD_FILE(file_name)\n\nReads the file and returns the file contents as a string. To use this\nfunction, the file must be located on the server host, you must specify\nthe full path name to the file, and you must have the FILE privilege.\nThe file must be readable by all and its size less than\nmax_allowed_packet bytes. If the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory.\n\nIf the file does not exist or cannot be read because one of the\npreceding conditions is not satisfied, the function returns NULL.\n\nThe character_set_filesystem system variable controls interpretation of\nfile names that are given as literal strings.\n\nURL: https://mariadb.com/kb/en/load_file/\n\n','MariaDB> UPDATE t\n            SET blob_col=LOAD_FILE(\'/tmp/picture\')\n            WHERE id=1;\n','https://mariadb.com/kb/en/load_file/'),(360,'POINTFROMTEXT',3,'PointFromText(wkt[,srid])\n\nConstructs a POINT value using its WKT representation and SRID.\n\nURL: https://mariadb.com/kb/en/pointfromtext/\n\n','','https://mariadb.com/kb/en/pointfromtext/'),(361,'GROUP_CONCAT',16,'Syntax:\nGROUP_CONCAT(expr)\n\nThis function returns a string result with the concatenated non-NULL\nvalues from a group. It returns NULL if there are no non-NULL values.\nThe full syntax is as follows:\n\nGROUP_CONCAT([DISTINCT] expr [,expr ...]\n             [ORDER BY {unsigned_integer | col_name | expr}\n                 [ASC | DESC] [,col_name ...]]\n             [SEPARATOR str_val])\n\nURL: https://mariadb.com/kb/en/group_concat/\n\n','MariaDB> SELECT student_name,\n    ->     GROUP_CONCAT(test_score)\n    ->     FROM student\n    ->     GROUP BY student_name;\n','https://mariadb.com/kb/en/group_concat/'),(362,'DATE_FORMAT',31,'Syntax:\nDATE_FORMAT(date,format)\n\nFormats the date value according to the format string.\n\nURL: https://mariadb.com/kb/en/date_format/\n\n','MariaDB> SELECT DATE_FORMAT(\'2009-10-04 22:23:00\', \'%W %M %Y\');\n        -> \'Sunday October 2009\'\nMariaDB> SELECT DATE_FORMAT(\'2007-10-04 22:23:00\', \'%H:%i:%s\');\n        -> \'22:23:00\'\nMariaDB> SELECT DATE_FORMAT(\'1900-10-04 22:23:00\',\n    ->                 \'%D %y %a %d %m %b %j\');\n        -> \'4th 00 Thu 04 10 Oct 277\'\nMariaDB> SELECT DATE_FORMAT(\'1997-10-04 22:23:00\',\n    ->                 \'%H %k %I %r %T %S %w\');\n        -> \'22 22 10 10:23:00 PM 22:23:00 00 6\'\nMariaDB> SELECT DATE_FORMAT(\'1999-01-01\', \'%X %V\');\n        -> \'1998 52\'\nMariaDB> SELECT DATE_FORMAT(\'2006-06-00\', \'%d\');\n        -> \'00\'\n','https://mariadb.com/kb/en/date_format/'),(363,'BENCHMARK',17,'Syntax:\nBENCHMARK(count,expr)\n\nThe BENCHMARK() function executes the expression expr repeatedly count\ntimes. It may be used to time how quickly MySQL processes the\nexpression. The result value is always 0. The intended use is from\nwithin the mysql client, which reports query execution times:\n\nURL: https://mariadb.com/kb/en/benchmark/\n\n','MariaDB> SELECT BENCHMARK(1000000,ENCODE(\'hello\',\'goodbye\'));\n+----------------------------------------------+\n| BENCHMARK(1000000,ENCODE(\'hello\',\'goodbye\')) |\n+----------------------------------------------+\n|                                            0 |\n+----------------------------------------------+\n1 row in set (4.74 sec)\n','https://mariadb.com/kb/en/benchmark/'),(364,'YEAR',31,'Syntax:\nYEAR(date)\n\nReturns the year for date, in the range 1000 to 9999, or 0 for the\n\"zero\" date.\n\nURL: https://mariadb.com/kb/en/year/\n\n','MariaDB> SELECT YEAR(\'1987-01-01\');\n        -> 1987\n','https://mariadb.com/kb/en/year/'),(365,'SHOW ENGINE',26,'Syntax:\nSHOW ENGINE engine_name {STATUS | MUTEX}\n\nSHOW ENGINE displays operational information about a storage engine.\nThe following statements currently are supported:\n\nSHOW ENGINE INNODB STATUS\nSHOW ENGINE INNODB MUTEX\nSHOW ENGINE PERFORMANCE_SCHEMA STATUS\n\nSHOW ENGINE INNODB STATUS displays extensive information from the\nstandard InnoDB Monitor about the state of the InnoDB storage engine.\nFor information about the standard monitor and other InnoDB Monitors\nthat provide information about InnoDB processing, see\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-monitors.html.\n\nSHOW ENGINE INNODB MUTEX displays InnoDB mutex statistics. The\nstatement displays the following fields:\n\no Type\n\n  Always InnoDB.\n\no Name\n\n  The source file where the mutex is implemented, and the line number\n  in the file where the mutex is created. The line number may change\n  depending on your version of MySQL.\n\no Status\n\n  The mutex status. This field displays several values if UNIV_DEBUG\n  was defined at MySQL compilation time (for example, in include/univ.i\n  in the InnoDB part of the MySQL source tree). If UNIV_DEBUG was not\n  defined, the statement displays only the os_waits value. In the\n  latter case (without UNIV_DEBUG), the information on which the output\n  is based is insufficient to distinguish regular mutexes and mutexes\n  that protect rw-locks (which permit multiple readers or a single\n  writer). Consequently, the output may appear to contain multiple rows\n  for the same mutex.\n\n  o count indicates how many times the mutex was requested.\n\n  o spin_waits indicates how many times the spinlock had to run.\n\n  o spin_rounds indicates the number of spinlock rounds. (spin_rounds\n    divided by spin_waits provides the average round count.)\n\n  o os_waits indicates the number of operating system waits. This\n    occurs when the spinlock did not work (the mutex was not locked\n    during the spinlock and it was necessary to yield to the operating\n    system and wait).\n\n  o os_yields indicates the number of times a the thread trying to lock\n    a mutex gave up its timeslice and yielded to the operating system\n    (on the presumption that permitting other threads to run will free\n    the mutex so that it can be locked).\n\n  o os_wait_times indicates the amount of time (in ms) spent in\n    operating system waits, if the timed_mutexes system variable is 1\n    (ON). If timed_mutexes is 0 (OFF), timing is disabled, so\n    os_wait_times is 0. timed_mutexes is off by default.\n\nInformation from this statement can be used to diagnose system\nproblems. For example, large values of spin_waits and spin_rounds may\nindicate scalability problems.\n\nUse SHOW ENGINE PERFORMANCE_SCHEMA STATUS to inspect the internal\noperation of the Performance Schema code:\n\nMariaDB> SHOW ENGINE PERFORMANCE_SCHEMA STATUS\\G\n...\n*************************** 3. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.row_size\nStatus: 76\n*************************** 4. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.row_count\nStatus: 10000\n*************************** 5. row ***************************\n  Type: performance_schema\n  Name: events_waits_history.memory\nStatus: 760000\n...\n*************************** 57. row ***************************\n  Type: performance_schema\n  Name: performance_schema.memory\nStatus: 26459600\n...\n\nThe intent of this statement is to help the DBA to understand the\neffects that different options have on memory requirements.\n\nName values consist of two parts, which name an internal buffer and an\nattribute of the buffer, respectively:\n\no Internal buffers that are exposed as a table in the\n  performance_schema database are named after the table. Examples:\n  events_waits_history.row_size, mutex_instances.row_count.\n\no Internal buffers that are not exposed as a table are named within\n  parentheses. Examples: (pfs_cond_class).row_size,\n  (pfs_mutex_class).memory.\n\no Values that apply to the Performance Schema as a whole begin with\n  performance_schema. Example: performance_schema.memory.\n\nAttributes have these meanings:\n\no row_size cannot be changed. It is the size of the internal record\n  used by the implementation.\n\no row_count can be changed depending on the configuration options.\n\no For a table, tbl_name.memory is the product of row_size multiplied by\n  row_count. For the Performance Schema as a whole,\n  performance_schema.memory is the sum of all the memory used (the sum\n  of all other memory values).\n\nIn some cases, there is a direct relationship between a configuration\nparameter and a SHOW ENGINE value. For example,\nevents_waits_history_long.row_count corresponds to\nperformance_schema_events_waits_history_long_size. In other cases, the\nrelationship is more complex. For example,\nevents_waits_history.row_count corresponds to\nperformance_schema_events_waits_history_size (the number of rows per\nthread) multiplied by performance_schema_max_thread_instances ( the\nnumber of threads).\n\nURL: https://mariadb.com/kb/en/show-engine/\n\n','','https://mariadb.com/kb/en/show-engine/'),(366,'NAME_CONST',14,'Syntax:\nNAME_CONST(name,value)\n\nReturns the given value. When used to produce a result set column,\nNAME_CONST() causes the column to have the given name. The arguments\nshould be constants.\n\nMariaDB> SELECT NAME_CONST(\'myname\', 14);\n+--------+\n| myname |\n+--------+\n|     14 |\n+--------+\n\nURL: https://mariadb.com/kb/en/name_const/\n\n','','https://mariadb.com/kb/en/name_const/'),(367,'RELEASE_LOCK',14,'Syntax:\nRELEASE_LOCK(str)\n\nReleases the lock named by the string str that was obtained with\nGET_LOCK(). Returns 1 if the lock was released, 0 if the lock was not\nestablished by this thread (in which case the lock is not released),\nand NULL if the named lock did not exist. The lock does not exist if it\nwas never obtained by a call to GET_LOCK() or if it has previously been\nreleased.\n\nThe DO statement is convenient to use with RELEASE_LOCK(). See [HELP\nDO].\n\nURL: https://mariadb.com/kb/en/release_lock/\n\n','','https://mariadb.com/kb/en/release_lock/'),(368,'IS NULL',18,'Syntax:\nIS NULL\n\nTests whether a value is NULL.\n\nURL: https://mariadb.com/kb/en/is-null/\n\n','MariaDB> SELECT 1 IS NULL, 0 IS NULL, NULL IS NULL;\n        -> 0, 0, 1\n','https://mariadb.com/kb/en/is-null/'),(369,'CONVERT_TZ',31,'Syntax:\nCONVERT_TZ(dt,from_tz,to_tz)\n\nCONVERT_TZ() converts a datetime value dt from the time zone given by\nfrom_tz to the time zone given by to_tz and returns the resulting\nvalue. Time zones are specified as described in\nhttps://mariadb.com/kb/en/time-zones/. This\nfunction returns NULL if the arguments are invalid.\n\nURL: https://mariadb.com/kb/en/convert_tz/\n\n','MariaDB> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'GMT\',\'MET\');\n        -> \'2004-01-01 13:00:00\'\nMariaDB> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'+00:00\',\'+10:00\');\n        -> \'2004-01-01 22:00:00\'\n','https://mariadb.com/kb/en/convert_tz/'),(370,'TIME_TO_SEC',31,'Syntax:\nTIME_TO_SEC(time)\n\nReturns the time argument, converted to seconds.\n\nURL: https://mariadb.com/kb/en/time_to_sec/\n\n','MariaDB> SELECT TIME_TO_SEC(\'22:23:00\');\n        -> 80580\nMariaDB> SELECT TIME_TO_SEC(\'00:39:38\');\n        -> 2378\n','https://mariadb.com/kb/en/time_to_sec/'),(371,'WEEKDAY',31,'Syntax:\nWEEKDAY(date)\n\nReturns the weekday index for date (0 = Monday, 1 = Tuesday, ... 6 =\nSunday).\n\nURL: https://mariadb.com/kb/en/weekday/\n\n','MariaDB> SELECT WEEKDAY(\'2008-02-03 22:23:00\');\n        -> 6\nMariaDB> SELECT WEEKDAY(\'2007-11-06\');\n        -> 1\n','https://mariadb.com/kb/en/weekday/'),(372,'EXPORT_SET',37,'Syntax:\nEXPORT_SET(bits,on,off[,separator[,number_of_bits]])\n\nReturns a string such that for every bit set in the value bits, you get\nan on string and for every bit not set in the value, you get an off\nstring. Bits in bits are examined from right to left (from low-order to\nhigh-order bits). Strings are added to the result from left to right,\nseparated by the separator string (the default being the comma\ncharacter \",\"). The number of bits examined is given by number_of_bits,\nwhich has a default of 64 if not specified. number_of_bits is silently\nclipped to 64 if larger than 64. It is treated as an unsigned integer,\nso a value of -1 is effectively the same as 64.\n\nURL: https://mariadb.com/kb/en/export_set/\n\n','MariaDB> SELECT EXPORT_SET(5,\'Y\',\'N\',\',\',4);\n        -> \'Y,N,Y,N\'\nMariaDB> SELECT EXPORT_SET(6,\'1\',\'0\',\',\',10);\n        -> \'0,1,1,0,0,0,0,0,0,0\'\n','https://mariadb.com/kb/en/export_set/'),(373,'ALTER SERVER',39,'Syntax:\nALTER SERVER  server_name\n    OPTIONS (option [, option] ...)\n\nAlters the server information for server_name, adjusting any of the\noptions permitted in the CREATE SERVER statement. See [HELP CREATE\nSERVER]. The corresponding fields in the mysql.servers table are\nupdated accordingly. This statement requires the SUPER privilege.\n\nURL: https://mariadb.com/kb/en/alter-server/\n\n','ALTER SERVER s OPTIONS (USER \'sally\');\n','https://mariadb.com/kb/en/alter-server/'),(374,'RESIGNAL',23,'Syntax:\nRESIGNAL [condition_value]\n    [SET signal_information_item\n    [, signal_information_item] ...]\n\ncondition_value:\n    SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n\nsignal_information_item:\n    condition_information_item_name = simple_value_specification\n\ncondition_information_item_name:\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n\ncondition_name, simple_value_specification:\n    (see following discussion)\n\nRESIGNAL passes on the error condition information that is available\nduring execution of a condition handler within a compound statement\ninside a stored procedure or function, trigger, or event. RESIGNAL may\nchange some or all information before passing it on. RESIGNAL is\nrelated to SIGNAL, but instead of originating a condition as SIGNAL\ndoes, RESIGNAL relays existing condition information, possibly after\nmodifying it.\n\nRESIGNAL makes it possible to both handle an error and return the error\ninformation. Otherwise, by executing an SQL statement within the\nhandler, information that caused the handler\'s activation is destroyed.\nRESIGNAL also can make some procedures shorter if a given handler can\nhandle part of a situation, then pass the condition \"up the line\" to\nanother handler.\n\nNo special privileges are required to execute the RESIGNAL statement.\n\nFor condition_value and signal_information_item, the definitions and\nrules are the same for RESIGNAL as for SIGNAL (see [HELP SIGNAL]).\n\nThe RESIGNAL statement takes condition_value and SET clauses, both of\nwhich are optional. This leads to several possible uses:\n\no RESIGNAL alone:\n\nRESIGNAL;\n\no RESIGNAL with new signal information:\n\nRESIGNAL SET signal_information_item [, signal_information_item] ...;\n\no RESIGNAL with a condition value and possibly new signal information:\n\nRESIGNAL condition_value\n    [SET signal_information_item [, signal_information_item] ...];\n\nURL: https://mariadb.com/kb/en/resignal/\n\n','','https://mariadb.com/kb/en/resignal/'),(375,'TIME FUNCTION',31,'Syntax:\nTIME(expr)\n\nExtracts the time part of the time or datetime expression expr and\nreturns it as a string.\n\nURL: https://mariadb.com/kb/en/time-function/\n\n','MariaDB> SELECT TIME(\'2003-12-31 01:02:03\');\n        -> \'01:02:03\'\nMariaDB> SELECT TIME(\'2003-12-31 01:02:03.000123\');\n        -> \'01:02:03.000123\'\n','https://mariadb.com/kb/en/time-function/'),(376,'DATE_ADD',31,'Syntax:\nDATE_ADD(date,INTERVAL expr unit), DATE_SUB(date,INTERVAL expr unit)\n\nThese functions perform date arithmetic. The date argument specifies\nthe starting date or datetime value. expr is an expression specifying\nthe interval value to be added or subtracted from the starting date.\nexpr is a string; it may start with a \"-\" for negative intervals. unit\nis a keyword indicating the units in which the expression should be\ninterpreted.\n\nURL: https://mariadb.com/kb/en/date_add/\n\n','MariaDB> SELECT \'2008-12-31 23:59:59\' + INTERVAL 1 SECOND;\n        -> \'2009-01-01 00:00:00\'\nMariaDB> SELECT INTERVAL 1 DAY + \'2008-12-31\';\n        -> \'2009-01-01\'\nMariaDB> SELECT \'2005-01-01\' - INTERVAL 1 SECOND;\n        -> \'2004-12-31 23:59:59\'\nMariaDB> SELECT DATE_ADD(\'2000-12-31 23:59:59\',\n    ->                 INTERVAL 1 SECOND);\n        -> \'2001-01-01 00:00:00\'\nMariaDB> SELECT DATE_ADD(\'2010-12-31 23:59:59\',\n    ->                 INTERVAL 1 DAY);\n        -> \'2011-01-01 23:59:59\'\nMariaDB> SELECT DATE_ADD(\'2100-12-31 23:59:59\',\n    ->                 INTERVAL \'1:1\' MINUTE_SECOND);\n        -> \'2101-01-01 00:01:00\'\nMariaDB> SELECT DATE_SUB(\'2005-01-01 00:00:00\',\n    ->                 INTERVAL \'1 1:1:1\' DAY_SECOND);\n        -> \'2004-12-30 22:58:59\'\nMariaDB> SELECT DATE_ADD(\'1900-01-01 00:00:00\',\n    ->                 INTERVAL \'-1 10\' DAY_HOUR);\n        -> \'1899-12-30 14:00:00\'\nMariaDB> SELECT DATE_SUB(\'1998-01-02\', INTERVAL 31 DAY);\n        -> \'1997-12-02\'\nMariaDB> SELECT DATE_ADD(\'1992-12-31 23:59:59.000002\',\n    ->            INTERVAL \'1.999999\' SECOND_MICROSECOND);\n        -> \'1993-01-01 00:00:01.000001\'\n','https://mariadb.com/kb/en/date_add/'),(377,'CAST',37,'Syntax:\nCAST(expr AS type)\n\nThe CAST() function takes an expression of any type and produces a\nresult value of a specified type, similar to CONVERT(). See the\ndescription of CONVERT() for more information.\n\nURL: https://mariadb.com/kb/en/cast/\n\n','','https://mariadb.com/kb/en/cast/'),(378,'SOUNDS LIKE',37,'Syntax:\nexpr1 SOUNDS LIKE expr2\n\nThis is the same as SOUNDEX(expr1) = SOUNDEX(expr2).\n\nURL: https://mariadb.com/kb/en/sounds-like/\n\n','','https://mariadb.com/kb/en/sounds-like/'),(379,'PERIOD_DIFF',31,'Syntax:\nPERIOD_DIFF(P1,P2)\n\nReturns the number of months between periods P1 and P2. P1 and P2\nshould be in the format YYMM or YYYYMM. Note that the period arguments\nP1 and P2 are not date values.\n\nURL: https://mariadb.com/kb/en/period_diff/\n\n','MariaDB> SELECT PERIOD_DIFF(200802,200703);\n        -> 11\n','https://mariadb.com/kb/en/period_diff/'),(380,'LIKE',37,'Syntax:\nexpr LIKE pat [ESCAPE \'escape_char\']\n\nPattern matching using SQL simple regular expression comparison.\nReturns 1 (TRUE) or 0 (FALSE). If either expr or pat is NULL, the\nresult is NULL.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column.\n\nURL: https://mariadb.com/kb/en/like/\n\n','MariaDB> SELECT \'David!\' LIKE \'David_\';\n        -> 1\nMariaDB> SELECT \'David!\' LIKE \'%D%v%\';\n        -> 1\n','https://mariadb.com/kb/en/like/'),(381,'MULTIPOINT',24,'MultiPoint(pt1,pt2,...)\n\nConstructs a MultiPoint value using Point or WKB Point arguments.\n\nURL: https://mariadb.com/kb/en/multipoint/\n\n','','https://mariadb.com/kb/en/multipoint/'),(382,'>>',19,'Syntax:\n>>\n\nShifts a longlong (BIGINT) number to the right.\n\nURL: https://mariadb.com/kb/en/shift-right/\n\n','MariaDB> SELECT 4 >> 2;\n        -> 1\n','https://mariadb.com/kb/en/shift-right/'),(383,'FETCH',23,'Syntax:\nFETCH [[NEXT] FROM] cursor_name INTO var_name [, var_name] ...\n\nThis statement fetches the next row for the SELECT statement associated\nwith the specified cursor (which must be open), and advances the cursor\npointer. If a row exists, the fetched columns are stored in the named\nvariables. The number of columns retrieved by the SELECT statement must\nmatch the number of output variables specified in the FETCH statement.\n\nIf no more rows are available, a No Data condition occurs with SQLSTATE\nvalue \'02000\'. To detect this condition, you can set up a handler for\nit (or for a NOT FOUND condition). For an example, see\nhttps://mariadb.com/kb/en/cursor-overview/.\n\nURL: https://mariadb.com/kb/en/fetch/\n\n','','https://mariadb.com/kb/en/fetch/'),(384,'AVG',16,'Syntax:\nAVG([DISTINCT] expr)\n\nReturns the average value of expr. The DISTINCT option can be used to\nreturn the average of the distinct values of expr.\n\nAVG() returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/avg/\n\n','MariaDB> SELECT student_name, AVG(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','https://mariadb.com/kb/en/avg/'),(385,'TRUE FALSE',29,'The constants TRUE and FALSE evaluate to 1 and 0, respectively. The\nconstant names can be written in any lettercase.\n\nMariaDB> SELECT TRUE, true, FALSE, false;\n        -> 1, 1, 0, 0\n\nURL: https://mariadb.com/kb/en/true-false/\n\n','','https://mariadb.com/kb/en/true-false/'),(386,'MBRWITHIN',6,'MBRWithin(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangle of g1\nis within the Minimum Bounding Rectangle of g2. This tests the opposite\nrelationship as MBRContains().\n\nURL: https://mariadb.com/kb/en/mbrwithin/\n\n','MariaDB> SET @g1 = GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nMariaDB> SET @g2 = GeomFromText(\'Polygon((0 0,0 5,5 5,5 0,0 0))\');\nMariaDB> SELECT MBRWithin(@g1,@g2), MBRWithin(@g2,@g1);\n+--------------------+--------------------+\n| MBRWithin(@g1,@g2) | MBRWithin(@g2,@g1) |\n+--------------------+--------------------+\n|                  1 |                  0 |\n+--------------------+--------------------+\n','https://mariadb.com/kb/en/mbrwithin/'),(387,'SESSION_USER',17,'Syntax:\nSESSION_USER()\n\nSESSION_USER() is a synonym for USER().\n\nURL: https://mariadb.com/kb/en/session_user/\n\n','','https://mariadb.com/kb/en/session_user/'),(388,'IN',18,'Syntax:\nexpr IN (value,...)\n\nReturns 1 if expr is equal to any of the values in the IN list, else\nreturns 0. If all values are constants, they are evaluated according to\nthe type of expr and sorted. The search for the item then is done using\na binary search. This means IN is very quick if the IN value list\nconsists entirely of constants. Otherwise, type conversion takes place\naccording to the rules described in\nhttps://mariadb.com/kb/en/type-conversion/, but\napplied to all the arguments.\n\nURL: https://mariadb.com/kb/en/in/\n\n','MariaDB> SELECT 2 IN (0,3,5,7);\n        -> 0\nMariaDB> SELECT \'wefwf\' IN (\'wee\',\'wefwf\',\'weg\');\n        -> 1\n','https://mariadb.com/kb/en/in/'),(389,'QUOTE',37,'Syntax:\nQUOTE(str)\n\nQuotes a string to produce a result that can be used as a properly\nescaped data value in an SQL statement. The string is returned enclosed\nby single quotation marks and with each instance of backslash (\"\\\"),\nsingle quote (\"\'\"), ASCII NUL, and Control+Z preceded by a backslash.\nIf the argument is NULL, the return value is the word \"NULL\" without\nenclosing single quotation marks.\n\nURL: https://mariadb.com/kb/en/quote/\n\n','MariaDB> SELECT QUOTE(\'Don\\\'t!\');\n        -> \'Don\\\'t!\'\nMariaDB> SELECT QUOTE(NULL);\n        -> NULL\n','https://mariadb.com/kb/en/quote/'),(390,'HELP COMMAND',26,'Syntax:\nMariaDB> help search_string\n\nIf you provide an argument to the help command, mysql uses it as a\nsearch string to access server-side help from the contents of the MySQL\nReference Manual. The proper operation of this command requires that\nthe help tables in the mysql database be initialized with help topic\ninformation .\n\nIf there is no match for the search string, the search fails:\n\nMariaDB> help me\n\nNothing found\nPlease try to run \'help contents\' for a list of all accessible topics\n\nUse help contents to see a list of the help categories:\n\nMariaDB> help contents\nYou asked for help about help category: \"Contents\"\nFor more information, type \'help <item>\', where <item> is one of the\nfollowing categories:\n   Account Management\n   Administration\n   Data Definition\n   Data Manipulation\n   Data Types\n   Functions\n   Functions and Modifiers for Use with GROUP BY\n   Geographic Features\n   Language Structure\n   Plugins\n   Storage Engines\n   Stored Routines\n   Table Maintenance\n   Transactions\n   Triggers\n\nIf the search string matches multiple items, mysql shows a list of\nmatching topics:\n\nMariaDB> help logs\nMany help items for your request exist.\nTo make a more specific request, please type \'help <item>\',\nwhere <item> is one of the following topics:\n   SHOW\n   SHOW BINARY LOGS\n   SHOW ENGINE\n   SHOW LOGS\n\nUse a topic as the search string to see the help entry for that topic:\n\nMariaDB> help show binary logs\nName: \'SHOW BINARY LOGS\'\nDescription:\nSyntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [purge-binary-logs], that shows how\nto determine which logs can be purged.\n\nMariaDB> SHOW BINARY LOGS;\n+---------------+-----------+\n| Log_name      | File_size |\n+---------------+-----------+\n| binlog.000015 |    724935 |\n| binlog.000016 |    733481 |\n+---------------+-----------+\n\nURL: https://mariadb.com/kb/en/help-command/\n\n','','https://mariadb.com/kb/en/help-command/'),(391,'QUARTER',31,'Syntax:\nQUARTER(date)\n\nReturns the quarter of the year for date, in the range 1 to 4.\n\nURL: https://mariadb.com/kb/en/quarter/\n\n','MariaDB> SELECT QUARTER(\'2008-04-01\');\n        -> 2\n','https://mariadb.com/kb/en/quarter/'),(392,'POSITION',37,'Syntax:\nPOSITION(substr IN str)\n\nPOSITION(substr IN str) is a synonym for LOCATE(substr,str).\n\nURL: https://mariadb.com/kb/en/position/\n\n','','https://mariadb.com/kb/en/position/'),(393,'SHOW CREATE FUNCTION',26,'Syntax:\nSHOW CREATE FUNCTION func_name\n\nThis statement is similar to SHOW CREATE PROCEDURE but for stored\nfunctions. See [HELP SHOW CREATE PROCEDURE].\n\nURL: https://mariadb.com/kb/en/show-create-function/\n\n','','https://mariadb.com/kb/en/show-create-function/'),(394,'IS_USED_LOCK',14,'Syntax:\nIS_USED_LOCK(str)\n\nChecks whether the lock named str is in use (that is, locked). If so,\nit returns the connection identifier of the client that holds the lock.\nOtherwise, it returns NULL.\n\nURL: https://mariadb.com/kb/en/is_used_lock/\n\n','','https://mariadb.com/kb/en/is_used_lock/'),(395,'POLYFROMTEXT',3,'PolyFromText(wkt[,srid]), PolygonFromText(wkt[,srid])\n\nConstructs a POLYGON value using its WKT representation and SRID.\n\nURL: https://mariadb.com/kb/en/polyfromtext/\n\n','','https://mariadb.com/kb/en/polyfromtext/'),(396,'DES_ENCRYPT',12,'Syntax:\nDES_ENCRYPT(str[,{key_num|key_str}])\n\nEncrypts the string with the given key using the Triple-DES algorithm.\n\nThis function works only if MySQL has been configured with SSL support.\nSee https://mariadb.com/kb/en/ssl-connections/.\n\nThe encryption key to use is chosen based on the second argument to\nDES_ENCRYPT(), if one was given. With no argument, the first key from\nthe DES key file is used. With a key_num argument, the given key number\n(0 to 9) from the DES key file is used. With a key_str argument, the\ngiven key string is used to encrypt str.\n\nThe key file can be specified with the --des-key-file server option.\n\nThe return string is a binary string where the first character is\nCHAR(128 | key_num). If an error occurs, DES_ENCRYPT() returns NULL.\n\nThe 128 is added to make it easier to recognize an encrypted key. If\nyou use a string key, key_num is 127.\n\nThe string length for the result is given by this formula:\n\nnew_len = orig_len + (8 - (orig_len % 8)) + 1\n\nEach line in the DES key file has the following format:\n\nkey_num des_key_str\n\nEach key_num value must be a number in the range from 0 to 9. Lines in\nthe file may be in any order. des_key_str is the string that is used to\nencrypt the message. There should be at least one space between the\nnumber and the key. The first key is the default key that is used if\nyou do not specify any key argument to DES_ENCRYPT().\n\nYou can tell MySQL to read new key values from the key file with the\nFLUSH DES_KEY_FILE statement. This requires the RELOAD privilege.\n\nOne benefit of having a set of default keys is that it gives\napplications a way to check for the existence of encrypted column\nvalues, without giving the end user the right to decrypt those values.\n\nURL: https://mariadb.com/kb/en/des_encrypt/\n\n','MariaDB> SELECT customer_address FROM customer_table \n     > WHERE crypted_credit_card = DES_ENCRYPT(\'credit_card_number\');\n','https://mariadb.com/kb/en/des_encrypt/'),(397,'CEIL',4,'Syntax:\nCEIL(X)\n\nCEIL() is a synonym for CEILING().\n\nURL: https://mariadb.com/kb/en/ceil/\n\n','','https://mariadb.com/kb/en/ceil/'),(398,'LENGTH',37,'Syntax:\nLENGTH(str)\n\nReturns the length of the string str, measured in bytes. A multi-byte\ncharacter counts as multiple bytes. This means that for a string\ncontaining five 2-byte characters, LENGTH() returns 10, whereas\nCHAR_LENGTH() returns 5.\n\nURL: https://mariadb.com/kb/en/length/\n\n','MariaDB> SELECT LENGTH(\'text\');\n        -> 4\n','https://mariadb.com/kb/en/length/'),(399,'STR_TO_DATE',31,'Syntax:\nSTR_TO_DATE(str,format)\n\nThis is the inverse of the DATE_FORMAT() function. It takes a string\nstr and a format string format. STR_TO_DATE() returns a DATETIME value\nif the format string contains both date and time parts, or a DATE or\nTIME value if the string contains only date or time parts. If the date,\ntime, or datetime value extracted from str is illegal, STR_TO_DATE()\nreturns NULL and produces a warning.\n\nThe server scans str attempting to match format to it. The format\nstring can contain literal characters and format specifiers beginning\nwith %. Literal characters in format must match literally in str.\nFormat specifiers in format must match a date or time part in str. For\nthe specifiers that can be used in format, see the DATE_FORMAT()\nfunction description.\n\nMariaDB> SELECT STR_TO_DATE(\'01,5,2013\',\'%d,%m,%Y\');\n        -> \'2013-05-01\'\nMariaDB> SELECT STR_TO_DATE(\'May 1, 2013\',\'%M %d,%Y\');\n        -> \'2013-05-01\'\n\nScanning starts at the beginning of str and fails if format is found\nnot to match. Extra characters at the end of str are ignored.\n\nMariaDB> SELECT STR_TO_DATE(\'a09:30:17\',\'a%h:%i:%s\');\n        -> \'09:30:17\'\nMariaDB> SELECT STR_TO_DATE(\'a09:30:17\',\'%h:%i:%s\');\n        -> NULL\nMariaDB> SELECT STR_TO_DATE(\'09:30:17a\',\'%h:%i:%s\');\n        -> \'09:30:17\'\n\nUnspecified date or time parts have a value of 0, so incompletely\nspecified values in str produce a result with some or all parts set to\n0:\n\nMariaDB> SELECT STR_TO_DATE(\'abc\',\'abc\');\n        -> \'0000-00-00\'\nMariaDB> SELECT STR_TO_DATE(\'9\',\'%m\');\n        -> \'0000-09-00\'\nMariaDB> SELECT STR_TO_DATE(\'9\',\'%s\');\n        -> \'00:00:09\'\n\nURL: https://mariadb.com/kb/en/str_to_date/\n\n','','https://mariadb.com/kb/en/str_to_date/'),(400,'Y',11,'Y(p)\n\nReturns the Y-coordinate value for the Point object p as a\ndouble-precision number.\n\nURL: https://mariadb.com/kb/en/y/\n\n','MariaDB> SELECT Y(POINT(56.7, 53.34));\n+-----------------------+\n| Y(POINT(56.7, 53.34)) |\n+-----------------------+\n|                 53.34 |\n+-----------------------+\n','https://mariadb.com/kb/en/y/'),(401,'CHECKSUM TABLE',20,'Syntax:\nCHECKSUM TABLE tbl_name [, tbl_name] ... [ QUICK | EXTENDED ]\n\nCHECKSUM TABLE reports a table checksum. This statement requires the\nSELECT privilege for the table.\n\nWith QUICK, the live table checksum is reported if it is available, or\nNULL otherwise. This is very fast. A live checksum is enabled by\nspecifying the CHECKSUM=1 table option when you create the table;\ncurrently, this is supported only for MyISAM tables. See [HELP CREATE\nTABLE].\n\nWith EXTENDED, the entire table is read row by row and the checksum is\ncalculated. This can be very slow for large tables.\n\nIf neither QUICK nor EXTENDED is specified, MySQL returns a live\nchecksum if the table storage engine supports it and scans the table\notherwise.\n\nFor a nonexistent table, CHECKSUM TABLE returns NULL and generates a\nwarning.\n\nIn MySQL 5.5, CHECKSUM TABLE returns 0 for partitioned tables unless\nyou include the EXTENDED option. This issue is resolved in MySQL 5.6.\n(Bug #11933226, Bug #60681)\n\nThe checksum value depends on the table row format. If the row format\nchanges, the checksum also changes. For example, the storage format for\nVARCHAR changed between MySQL 4.1 and 5.0, so if a 4.1 table is\nupgraded to MySQL 5.0, the checksum value may change.\n\nURL: https://mariadb.com/kb/en/checksum-table/\n\n','','https://mariadb.com/kb/en/checksum-table/'),(402,'NUMINTERIORRINGS',2,'NumInteriorRings(poly)\n\nReturns the number of interior rings in the Polygon value poly.\n\nURL: https://mariadb.com/kb/en/numinteriorrings/\n\n','MariaDB> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nMariaDB> SELECT NumInteriorRings(GeomFromText(@poly));\n+---------------------------------------+\n| NumInteriorRings(GeomFromText(@poly)) |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n','https://mariadb.com/kb/en/numinteriorrings/'),(403,'INTERIORRINGN',2,'InteriorRingN(poly,N)\n\nReturns the N-th interior ring for the Polygon value poly as a\nLineString. Rings are numbered beginning with 1.\n\nURL: https://mariadb.com/kb/en/interiorringn/\n\n','MariaDB> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nMariaDB> SELECT AsText(InteriorRingN(GeomFromText(@poly),1));\n+----------------------------------------------+\n| AsText(InteriorRingN(GeomFromText(@poly),1)) |\n+----------------------------------------------+\n| LINESTRING(1 1,1 2,2 2,2 1,1 1)              |\n+----------------------------------------------+\n','https://mariadb.com/kb/en/interiorringn/'),(404,'UTC_TIME',31,'Syntax:\nUTC_TIME, UTC_TIME()\n\nReturns the current UTC time as a value in \'HH:MM:SS\' or HHMMSS.uuuuuu\nformat, depending on whether the function is used in a string or\nnumeric context.\n\nURL: https://mariadb.com/kb/en/utc_time/\n\n','MariaDB> SELECT UTC_TIME(), UTC_TIME() + 0;\n        -> \'18:07:53\', 180753.000000\n','https://mariadb.com/kb/en/utc_time/'),(405,'DROP FUNCTION',39,'The DROP FUNCTION statement is used to drop stored functions and\nuser-defined functions (UDFs):\n\no For information about dropping stored functions, see [HELP DROP\n  PROCEDURE].\n\no For information about dropping user-defined functions, see [HELP DROP\n  FUNCTION UDF].\n\nURL: https://mariadb.com/kb/en/drop-function/\n\n','','https://mariadb.com/kb/en/drop-function/'),(406,'ALTER EVENT',39,'Syntax:\nALTER\n    [DEFINER = { user | CURRENT_USER }]\n    EVENT event_name\n    [ON SCHEDULE schedule]\n    [ON COMPLETION [NOT] PRESERVE]\n    [RENAME TO new_event_name]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'comment\']\n    [DO event_body]\n\nThe ALTER EVENT statement changes one or more of the characteristics of\nan existing event without the need to drop and recreate it. The syntax\nfor each of the DEFINER, ON SCHEDULE, ON COMPLETION, COMMENT, ENABLE /\nDISABLE, and DO clauses is exactly the same as when used with CREATE\nEVENT. (See [HELP CREATE EVENT].)\n\nAny user can alter an event defined on a database for which that user\nhas the EVENT privilege. When a user executes a successful ALTER EVENT\nstatement, that user becomes the definer for the affected event.\n\nALTER EVENT works only with an existing event:\n\nMariaDB> ALTER EVENT no_such_event \n     >     ON SCHEDULE \n     >       EVERY \'2:3\' DAY_HOUR;\nERROR 1517 (HY000): Unknown event \'no_such_event\'\n\nURL: https://mariadb.com/kb/en/alter-event/\n\n','','https://mariadb.com/kb/en/alter-event/'),(407,'STDDEV',16,'Syntax:\nSTDDEV(expr)\n\nReturns the population standard deviation of expr. This function is\nprovided for compatibility with Oracle. The standard SQL function\nSTDDEV_POP() can be used instead.\n\nThis function returns NULL if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/stddev/\n\n','','https://mariadb.com/kb/en/stddev/'),(408,'DATE_SUB',31,'Syntax:\nDATE_SUB(date,INTERVAL expr unit)\n\nSee the description for DATE_ADD().\n\nURL: https://mariadb.com/kb/en/date_sub/\n\n','','https://mariadb.com/kb/en/date_sub/'),(409,'PERIOD_ADD',31,'Syntax:\nPERIOD_ADD(P,N)\n\nAdds N months to period P (in the format YYMM or YYYYMM). Returns a\nvalue in the format YYYYMM. Note that the period argument P is not a\ndate value.\n\nURL: https://mariadb.com/kb/en/period_add/\n\n','MariaDB> SELECT PERIOD_ADD(200801,2);\n        -> 200803\n','https://mariadb.com/kb/en/period_add/'),(410,'|',19,'Syntax:\n|\n\nBitwise OR:\n\nURL: https://mariadb.com/kb/en/bitwise-or/\n\n','MariaDB> SELECT 29 | 15;\n        -> 31\n','https://mariadb.com/kb/en/bitwise-or/'),(411,'GEOMFROMTEXT',3,'GeomFromText(wkt[,srid]), GeometryFromText(wkt[,srid])\n\nConstructs a geometry value of any type using its WKT representation\nand SRID.\n\nURL: https://mariadb.com/kb/en/geomfromtext/\n\n','','https://mariadb.com/kb/en/geomfromtext/'),(412,'UUID_SHORT',14,'Syntax:\nUUID_SHORT()\n\nReturns a \"short\" universal identifier as a 64-bit unsigned integer\n(rather than a string-form 128-bit identifier as returned by the UUID()\nfunction).\n\nThe value of UUID_SHORT() is guaranteed to be unique if the following\nconditions hold:\n\no The server_id of the current host is unique among your set of master\n  and slave servers\n\no server_id is between 0 and 255\n\no You do not set back your system time for your server between mysqld\n  restarts\n\no You do not invoke UUID_SHORT() on average more than 16 million times\n  per second between mysqld restarts\n\nThe UUID_SHORT() return value is constructed this way:\n\n  (server_id & 255) << 56\n+ (server_startup_time_in_seconds << 24)\n+ incremented_variable++;\n\nURL: https://mariadb.com/kb/en/uuid_short/\n\n','MariaDB> SELECT UUID_SHORT();\n        -> 92395783831158784\n','https://mariadb.com/kb/en/uuid_short/'),(413,'RIGHT',37,'Syntax:\nRIGHT(str,len)\n\nReturns the rightmost len characters from the string str, or NULL if\nany argument is NULL.\n\nURL: https://mariadb.com/kb/en/right/\n\n','MariaDB> SELECT RIGHT(\'foobarbar\', 4);\n        -> \'rbar\'\n','https://mariadb.com/kb/en/right/'),(414,'DATEDIFF',31,'Syntax:\nDATEDIFF(expr1,expr2)\n\nDATEDIFF() returns expr1 - expr2 expressed as a value in days from one\ndate to the other. expr1 and expr2 are date or date-and-time\nexpressions. Only the date parts of the values are used in the\ncalculation.\n\nURL: https://mariadb.com/kb/en/datediff/\n\n','MariaDB> SELECT DATEDIFF(\'2007-12-31 23:59:59\',\'2007-12-30\');\n        -> 1\nMariaDB> SELECT DATEDIFF(\'2010-11-30 23:59:59\',\'2010-12-31\');\n        -> -31\n','https://mariadb.com/kb/en/datediff/'),(415,'DROP TABLESPACE',39,'Syntax:\nDROP TABLESPACE tablespace_name\n    ENGINE [=] engine_name\n\nThis statement is used with NDB cluster, which is not supported by MariaDB.\n\nURL: https://mariadb.com/kb/en/drop-tablespace/\n\n','','https://mariadb.com/kb/en/drop-tablespace/'),(416,'DROP PROCEDURE',39,'Syntax:\nDROP {PROCEDURE | FUNCTION} [IF EXISTS] sp_name\n\nThis statement is used to drop a stored procedure or function. That is,\nthe specified routine is removed from the server. You must have the\nALTER ROUTINE privilege for the routine. (If the\nautomatic_sp_privileges system variable is enabled, that privilege and\nEXECUTE are granted automatically to the routine creator when the\nroutine is created and dropped from the creator when the routine is\ndropped. See\nhttps://mariadb.com/kb/en/stored-routine-privileges/.\n)\n\nThe IF EXISTS clause is a MySQL extension. It prevents an error from\noccurring if the procedure or function does not exist. A warning is\nproduced that can be viewed with SHOW WARNINGS.\n\nURL: https://mariadb.com/kb/en/drop-procedure/\n\n','','https://mariadb.com/kb/en/drop-procedure/'),(417,'CHECK TABLE',20,'Syntax:\nCHECK TABLE tbl_name [, tbl_name] ... [option] ...\n\noption = {FOR UPGRADE | QUICK | FAST | MEDIUM | EXTENDED | CHANGED}\n\nCHECK TABLE checks a table or tables for errors. CHECK TABLE works for\nInnoDB, MyISAM, ARCHIVE, and CSV tables. For MyISAM tables, the key\nstatistics are updated as well.\n\nTo check a table, you must have some privilege for it.\n\nCHECK TABLE can also check views for problems, such as tables that are\nreferenced in the view definition that no longer exist.\n\nCHECK TABLE is supported for partitioned tables, and you can use ALTER\nTABLE ... CHECK PARTITION to check one or more partitions; for more\ninformation, see [HELP ALTER TABLE].\n\nURL: https://mariadb.com/kb/en/sql-commands-check-table/\n\n','','https://mariadb.com/kb/en/sql-commands-check-table/'),(418,'BIN',37,'Syntax:\nBIN(N)\n\nReturns a string representation of the binary value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,2). Returns\nNULL if N is NULL.\n\nURL: https://mariadb.com/kb/en/bin/\n\n','MariaDB> SELECT BIN(12);\n        -> \'1100\'\n','https://mariadb.com/kb/en/bin/'),(419,'INSTALL PLUGIN',5,'Syntax:\nINSTALL PLUGIN plugin_name SONAME \'shared_library_name\'\n\nThis statement installs a server plugin. It requires the INSERT\nprivilege for the mysql.plugin table.\n\nplugin_name is the name of the plugin as defined in the plugin\ndescriptor structure contained in the library file (see\nhttp://dev.mysql.com/doc/refman/5.5/en/plugin-data-structures.html).\nPlugin names are not case sensitive. For maximal compatibility, plugin\nnames should be limited to ASCII letters, digits, and underscore\nbecause they are used in C source files, shell command lines, M4 and\nBourne shell scripts, and SQL environments.\n\nshared_library_name is the name of the shared library that contains the\nplugin code. The name includes the file name extension (for example,\nlibmyplugin.so, libmyplugin.dll, or libmyplugin.dylib).\n\nThe shared library must be located in the plugin directory (the\ndirectory named by the plugin_dir system variable). The library must be\nin the plugin directory itself, not in a subdirectory. By default,\nplugin_dir is the plugin directory under the directory named by the\npkglibdir configuration variable, but it can be changed by setting the\nvalue of plugin_dir at server startup. For example, set its value in a\nmy.cnf file:\n\n[mysqld]\nplugin_dir=/path/to/plugin/directory\n\nIf the value of plugin_dir is a relative path name, it is taken to be\nrelative to the MySQL base directory (the value of the basedir system\nvariable).\n\nINSTALL PLUGIN loads and initializes the plugin code to make the plugin\navailable for use. A plugin is initialized by executing its\ninitialization function, which handles any setup that the plugin must\nperform before it can be used. When the server shuts down, it executes\nthe deinitialization function for each plugin that is loaded so that\nthe plugin has a change to perform any final cleanup.\n\nINSTALL PLUGIN also registers the plugin by adding a line that\nindicates the plugin name and library file name to the mysql.plugin\ntable. At server startup, the server loads and initializes any plugin\nthat is listed in the mysql.plugin table. This means that a plugin is\ninstalled with INSTALL PLUGIN only once, not every time the server\nstarts. Plugin loading at startup does not occur if the server is\nstarted with the --skip-grant-tables option.\n\nA plugin library can contain multiple plugins. For each of them to be\ninstalled, use a separate INSTALL PLUGIN statement. Each statement\nnames a different plugin, but all of them specify the same library\nname.\n\nURL: https://mariadb.com/kb/en/install-plugin/\n\n','','https://mariadb.com/kb/en/install-plugin/'),(420,'DECLARE CURSOR',23,'Syntax:\nDECLARE cursor_name CURSOR FOR select_statement\n\nThis statement declares a cursor and associates it with a SELECT\nstatement that retrieves the rows to be traversed by the cursor. To\nfetch the rows later, use a FETCH statement. The number of columns\nretrieved by the SELECT statement must match the number of output\nvariables specified in the FETCH statement.\n\nThe SELECT statement cannot have an INTO clause.\n\nCursor declarations must appear before handler declarations and after\nvariable and condition declarations.\n\nA stored program may contain multiple cursor declarations, but each\ncursor declared in a given block must have a unique name. For an\nexample, see https://mariadb.com/kb/en/programmatic-and-compound-statements-cursors/.\n\nFor information available through SHOW statements, it is possible in\nmany cases to obtain equivalent information by using a cursor with an\nINFORMATION_SCHEMA table.\n\nURL: https://mariadb.com/kb/en/declare-cursor/\n\n','','https://mariadb.com/kb/en/declare-cursor/'),(421,'LOAD DATA',27,'Syntax:\nLOAD DATA [LOW_PRIORITY | CONCURRENT] [LOCAL] INFILE \'file_name\'\n    [REPLACE | IGNORE]\n    INTO TABLE tbl_name\n    [CHARACTER SET charset_name]\n    [{FIELDS | COLUMNS}\n        [TERMINATED BY \'string\']\n        [[OPTIONALLY] ENCLOSED BY \'char\']\n        [ESCAPED BY \'char\']\n    ]\n    [LINES\n        [STARTING BY \'string\']\n        [TERMINATED BY \'string\']\n    ]\n    [IGNORE number {LINES | ROWS}]\n    [(col_name_or_user_var,...)]\n    [SET col_name = expr,...]\n\nThe LOAD DATA INFILE statement reads rows from a text file into a table\nat a very high speed. The file name must be given as a literal string.\n\nLOAD DATA INFILE is the complement of SELECT ... INTO OUTFILE. (See\nhttps://mariadb.com/kb/en/select-into/.) To write data\nfrom a table to a file, use SELECT ... INTO OUTFILE. To read the file\nback into a table, use LOAD DATA INFILE. The syntax of the FIELDS and\nLINES clauses is the same for both statements. Both clauses are\noptional, but FIELDS must precede LINES if both are specified.\n\nFor more information about the efficiency of INSERT versus LOAD DATA\nINFILE and speeding up LOAD DATA INFILE, see\nhttp://dev.mysql.com/doc/refman/5.5/en/insert-speed.html.\n\nThe character set indicated by the character_set_database system\nvariable is used to interpret the information in the file. SET NAMES\nand the setting of character_set_client do not affect interpretation of\ninput. If the contents of the input file use a character set that\ndiffers from the default, it is usually preferable to specify the\ncharacter set of the file by using the CHARACTER SET clause. A\ncharacter set of binary specifies \"no conversion.\"\n\nLOAD DATA INFILE interprets all fields in the file as having the same\ncharacter set, regardless of the data types of the columns into which\nfield values are loaded. For proper interpretation of file contents,\nyou must ensure that it was written with the correct character set. For\nexample, if you write a data file with mysqldump -T or by issuing a\nSELECT ... INTO OUTFILE statement in mysql, be sure to use a\n--default-character-set option with mysqldump or mysql so that output\nis written in the character set to be used when the file is loaded with\nLOAD DATA INFILE.\n\n*Note*: It is not possible to load data files that use the ucs2, utf16,\nor utf32 character set.\n\nThe character_set_filesystem system variable controls the\ninterpretation of the file name.\n\nYou can also load data files by using the mysqlimport utility; it\noperates by sending a LOAD DATA INFILE statement to the server. The\n--local option causes mysqlimport to read data files from the client\nhost. You can specify the --compress option to get better performance\nover slow networks if the client and server support the compressed\nprotocol. See https://mariadb.com/kb/en/mysqlimport/.\n\nIf you use LOW_PRIORITY, execution of the LOAD DATA statement is\ndelayed until no other clients are reading from the table. This affects\nonly storage engines that use only table-level locking (such as MyISAM,\nMEMORY, and MERGE).\n\nIf you specify CONCURRENT with a MyISAM table that satisfies the\ncondition for concurrent inserts (that is, it contains no free blocks\nin the middle), other threads can retrieve data from the table while\nLOAD DATA is executing. Using this option affects the performance of\nLOAD DATA a bit, even if no other thread is using the table at the same\ntime.\n\nPrior to MySQL 5.5.1, CONCURRENT was not replicated when using\nstatement-based replication (see Bug #34628). However, it is replicated\nwhen using row-based replication, regardless of the version. See\nhttp://dev.mysql.com/doc/refman/5.5/en/replication-features-load-data.h\ntml, for more information.\n\nThe LOCAL keyword, if specified, is interpreted with respect to the\nclient end of the connection:\n\no If LOCAL is specified, the file is read by the client program on the\n  client host and sent to the server. The file can be given as a full\n  path name to specify its exact location. If given as a relative path\n  name, the name is interpreted relative to the directory in which the\n  client program was started.\n\n  When using LOCAL with LOAD DATA, a copy of the file is created in the\n  server\'s temporary directory. This is not the directory determined by\n  the value of tmpdir or slave_load_tmpdir, but rather the operating\n  system\'s temporary directory, and is not configurable in the MySQL\n  Server. (Typically the system temporary directory is /tmp on Linux\n  systems and C:\\WINDOWS\\TEMP on Windows.) Lack of sufficient space for\n  the copy in this directory can cause the LOAD DATA LOCAL statement to\n  fail.\n\no If LOCAL is not specified, the file must be located on the server\n  host and is read directly by the server. The server uses the\n  following rules to locate the file:\n\n  o If the file name is an absolute path name, the server uses it as\n    given.\n\n  o If the file name is a relative path name with one or more leading\n    components, the server searches for the file relative to the\n    server\'s data directory.\n\n  o If a file name with no leading components is given, the server\n    looks for the file in the database directory of the default\n    database.\n\nNote that, in the non-LOCAL case, these rules mean that a file named as\n./myfile.txt is read from the server\'s data directory, whereas the file\nnamed as myfile.txt is read from the database directory of the default\ndatabase. For example, if db1 is the default database, the following\nLOAD DATA statement reads the file data.txt from the database directory\nfor db1, even though the statement explicitly loads the file into a\ntable in the db2 database:\n\nLOAD DATA INFILE \'data.txt\' INTO TABLE db2.my_table;\n\nWindows path names are specified using forward slashes rather than\nbackslashes. If you do use backslashes, you must double them.\n\nFor security reasons, when reading text files located on the server,\nthe files must either reside in the database directory or be readable\nby all. Also, to use LOAD DATA INFILE on server files, you must have\nthe FILE privilege. See\nhttps://mariadb.com/kb/en/grant/. For\nnon-LOCAL load operations, if the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory.\n\nURL: https://mariadb.com/kb/en/load-data-infile/\n\n','','https://mariadb.com/kb/en/load-data-infile/'),(422,'MULTILINESTRING',24,'MultiLineString(ls1,ls2,...)\n\nConstructs a MultiLineString value using LineString or WKB LineString\narguments.\n\nURL: https://mariadb.com/kb/en/multilinestring/\n\n','','https://mariadb.com/kb/en/multilinestring/'),(423,'LOCALTIME',31,'Syntax:\nLOCALTIME, LOCALTIME()\n\nLOCALTIME and LOCALTIME() are synonyms for NOW().\n\nURL: https://mariadb.com/kb/en/localtime/\n\n','','https://mariadb.com/kb/en/localtime/'),(424,'SHOW RELAYLOG EVENTS',26,'Syntax:\nSHOW RELAYLOG EVENTS\n   [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\n\nShows the events in the relay log of a replication slave. If you do not\nspecify \'log_name\', the first relay log is displayed. This statement\nhas no effect on the master.\n\nURL: https://mariadb.com/kb/en/show-relaylog-events/\n\n','','https://mariadb.com/kb/en/show-relaylog-events/'),(425,'MPOINTFROMTEXT',3,'MPointFromText(wkt[,srid]), MultiPointFromText(wkt[,srid])\n\nConstructs a MULTIPOINT value using its WKT representation and SRID.\n\nURL: https://mariadb.com/kb/en/mpointfromtext/\n\n','','https://mariadb.com/kb/en/mpointfromtext/'),(426,'BLOB',22,'BLOB[(M)]\n\nA BLOB column with a maximum length of 65,535 (216 - 1) bytes. Each\nBLOB value is stored using a 2-byte length prefix that indicates the\nnumber of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest BLOB type large enough to hold\nvalues M bytes long.\n\nURL: https://mariadb.com/kb/en/blob/\n\n','','https://mariadb.com/kb/en/blob/'),(427,'SHA1',12,'Syntax:\nSHA1(str), SHA(str)\n\nCalculates an SHA-1 160-bit checksum for the string, as described in\nRFC 3174 (Secure Hash Algorithm). The value is returned as a string of\n40 hex digits, or NULL if the argument was NULL. One of the possible\nuses for this function is as a hash key. See the notes at the beginning\nof this section about storing hash values efficiently. You can also use\nSHA1() as a cryptographic function for storing passwords. SHA() is\nsynonymous with SHA1().\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring; see the notes at the beginning of this section about using the\nvalue as a nonbinary string.\n\nURL: https://mariadb.com/kb/en/sha1/\n\n','MariaDB> SELECT SHA1(\'abc\');\n        -> \'a9993e364706816aba3e25717850c26c9cd0d89d\'\n','https://mariadb.com/kb/en/sha1/'),(428,'SUBSTR',37,'Syntax:\nSUBSTR(str,pos), SUBSTR(str FROM pos), SUBSTR(str,pos,len), SUBSTR(str\nFROM pos FOR len)\n\nSUBSTR() is a synonym for SUBSTRING().\n\nURL: https://mariadb.com/kb/en/substr/\n\n','','https://mariadb.com/kb/en/substr/'),(429,'PASSWORD',12,'Syntax:\nPASSWORD(str)\n\nCalculates and returns a hashed password string from the plaintext\npassword str and returns a nonbinary string in the connection character\nset (a binary string before MySQL 5.5.3), or NULL if the argument is\nNULL. This function is the SQL interface to the algorithm used by the\nserver to encrypt MySQL passwords for storage in the mysql.user grant\ntable.\n\nThe password hashing method used by PASSWORD() depends on the value of\nthe old_passwords system variable:\n\nURL: https://mariadb.com/kb/en/password/\n\n','MariaDB> SET old_passwords = 0;\nMariaDB> SELECT PASSWORD(\'mypass\');\n+-------------------------------------------+\n| PASSWORD(\'mypass\')                        |\n+-------------------------------------------+\n| *6C8989366EAF75BB670AD8EA7A7FC1176A95CEF4 |\n+-------------------------------------------+\n\nMariaDB> SET old_passwords = 1;\nMariaDB> SELECT PASSWORD(\'mypass\');\n+--------------------+\n| PASSWORD(\'mypass\') |\n+--------------------+\n| 6f8c114b58f2ce9e   |\n+--------------------+\n','https://mariadb.com/kb/en/password/'),(430,'CHAR',22,'[NATIONAL] CHAR[(M)] [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA fixed-length string that is always right-padded with spaces to the\nspecified length when stored. M represents the column length in\ncharacters. The range of M is 0 to 255. If M is omitted, the length is\n1.\n\n*Note*: Trailing spaces are removed when CHAR values are retrieved\nunless the PAD_CHAR_TO_FULL_LENGTH SQL mode is enabled.\n\nURL: https://mariadb.com/kb/en/char/\n\n','','https://mariadb.com/kb/en/char/'),(431,'UTC_DATE',31,'Syntax:\nUTC_DATE, UTC_DATE()\n\nReturns the current UTC date as a value in \'YYYY-MM-DD\' or YYYYMMDD\nformat, depending on whether the function is used in a string or\nnumeric context.\n\nURL: https://mariadb.com/kb/en/utc_date/\n\n','MariaDB> SELECT UTC_DATE(), UTC_DATE() + 0;\n        -> \'2003-08-14\', 20030814\n','https://mariadb.com/kb/en/utc_date/'),(432,'DIMENSION',36,'Dimension(g)\n\nReturns the inherent dimension of the geometry value g. The result can\nbe -1, 0, 1, or 2. The meaning of these values is given in\nhttps://mariadb.com/kb/en/dimension/.\n\nURL: https://mariadb.com/kb/en/dimension/\n\n','MariaDB> SELECT Dimension(GeomFromText(\'LineString(1 1,2 2)\'));\n+------------------------------------------------+\n| Dimension(GeomFromText(\'LineString(1 1,2 2)\')) |\n+------------------------------------------------+\n|                                              1 |\n+------------------------------------------------+\n','https://mariadb.com/kb/en/dimension/'),(433,'COUNT DISTINCT',16,'Syntax:\nCOUNT(DISTINCT expr,[expr...])\n\nReturns a count of the number of rows with different non-NULL expr\nvalues.\n\nCOUNT(DISTINCT) returns 0 if there were no matching rows.\n\nURL: https://mariadb.com/kb/en/count-distinct/\n\n','MariaDB> SELECT COUNT(DISTINCT results) FROM student;\n','https://mariadb.com/kb/en/count-distinct/'),(434,'BIT',22,'BIT[(M)]\n\nA bit-field type. M indicates the number of bits per value, from 1 to\n64. The default is 1 if M is omitted.\n\nURL: https://mariadb.com/kb/en/bit/\n\n','','https://mariadb.com/kb/en/bit/'),(435,'EQUALS',30,'Equals(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially equal to g2.\n\nURL: https://mariadb.com/kb/en/equals/\n\n','','https://mariadb.com/kb/en/equals/'),(436,'SHOW CREATE VIEW',26,'Syntax:\nSHOW CREATE VIEW view_name\n\nThis statement shows a CREATE VIEW statement that creates the given\nview.\n\nURL: https://mariadb.com/kb/en/show-create-view/\n\n','','https://mariadb.com/kb/en/show-create-view/'),(437,'INTERVAL',18,'Syntax:\nINTERVAL(N,N1,N2,N3,...)\n\nReturns 0 if N < N1, 1 if N < N2 and so on or -1 if N is NULL. All\narguments are treated as integers. It is required that N1 < N2 < N3 <\n... < Nn for this function to work correctly. This is because a binary\nsearch is used (very fast).\n\nURL: https://mariadb.com/kb/en/interval/\n\n','MariaDB> SELECT INTERVAL(23, 1, 15, 17, 30, 44, 200);\n        -> 3\nMariaDB> SELECT INTERVAL(10, 1, 10, 100, 1000);\n        -> 2\nMariaDB> SELECT INTERVAL(22, 23, 30, 44, 200);\n        -> 0\n','https://mariadb.com/kb/en/interval/'),(438,'FROM_DAYS',31,'Syntax:\nFROM_DAYS(N)\n\nGiven a day number N, returns a DATE value.\n\nURL: https://mariadb.com/kb/en/from_days/\n\n','MariaDB> SELECT FROM_DAYS(730669);\n        -> \'2007-07-03\'\n','https://mariadb.com/kb/en/from_days/'),(439,'ALTER PROCEDURE',39,'Syntax:\nALTER PROCEDURE proc_name [characteristic ...]\n\ncharacteristic:\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nThis statement can be used to change the characteristics of a stored\nprocedure. More than one change may be specified in an ALTER PROCEDURE\nstatement. However, you cannot change the parameters or body of a\nstored procedure using this statement; to make such changes, you must\ndrop and re-create the procedure using DROP PROCEDURE and CREATE\nPROCEDURE.\n\nYou must have the ALTER ROUTINE privilege for the procedure. By\ndefault, that privilege is granted automatically to the procedure\ncreator. This behavior can be changed by disabling the\nautomatic_sp_privileges system variable. See\nhttps://mariadb.com/kb/en/stored-routine-privileges/.\n\nURL: https://mariadb.com/kb/en/alter-procedure/\n\n','','https://mariadb.com/kb/en/alter-procedure/'),(440,'BIT_COUNT',19,'Syntax:\nBIT_COUNT(N)\n\nReturns the number of bits that are set in the argument N.\n\nURL: https://mariadb.com/kb/en/bit_count/\n\n','MariaDB> SELECT BIT_COUNT(29), BIT_COUNT(b\'101010\');\n        -> 4, 3\n','https://mariadb.com/kb/en/bit_count/'),(441,'OCTET_LENGTH',37,'Syntax:\nOCTET_LENGTH(str)\n\nOCTET_LENGTH() is a synonym for LENGTH().\n\nURL: https://mariadb.com/kb/en/octet_length/\n\n','','https://mariadb.com/kb/en/octet_length/'),(442,'UTC_TIMESTAMP',31,'Syntax:\nUTC_TIMESTAMP, UTC_TIMESTAMP()\n\nReturns the current UTC date and time as a value in \'YYYY-MM-DD\nHH:MM:SS\' or YYYYMMDDHHMMSS.uuuuuu format, depending on whether the\nfunction is used in a string or numeric context.\n\nURL: https://mariadb.com/kb/en/utc_timestamp/\n\n','MariaDB> SELECT UTC_TIMESTAMP(), UTC_TIMESTAMP() + 0;\n        -> \'2003-08-14 18:08:04\', 20030814180804.000000\n','https://mariadb.com/kb/en/utc_timestamp/'),(443,'AES_ENCRYPT',12,'Syntax:\nAES_ENCRYPT(str,key_str)\n\nAES_ENCRYPT() and AES_DECRYPT() enable encryption and decryption of\ndata using the official AES (Advanced Encryption Standard) algorithm,\npreviously known as \"Rijndael.\" Encoding with a 128-bit key length is\nused, but you can extend it up to 256 bits by modifying the source. We\nchose 128 bits because it is much faster and it is secure enough for\nmost purposes.\n\nAES_ENCRYPT() encrypts a string and returns a binary string.\nAES_DECRYPT() decrypts the encrypted string and returns the original\nstring. The input arguments may be any length. If either argument is\nNULL, the result of this function is also NULL.\n\nBecause AES is a block-level algorithm, padding is used to encode\nuneven length strings and so the result string length may be calculated\nusing this formula:\n\n16 * (trunc(string_length / 16) + 1)\n\nIf AES_DECRYPT() detects invalid data or incorrect padding, it returns\nNULL. However, it is possible for AES_DECRYPT() to return a non-NULL\nvalue (possibly garbage) if the input data or the key is invalid.\n\nYou can use the AES functions to store data in an encrypted form by\nmodifying your queries:\n\nURL: https://mariadb.com/kb/en/aes_encrypt/\n\n','INSERT INTO t VALUES (1,AES_ENCRYPT(\'text\',\'password\'));\n','https://mariadb.com/kb/en/aes_encrypt/'),(444,'+',4,'Syntax:\n+\n\nAddition:\n\nURL: https://mariadb.com/kb/en/addition-operator/\n\n','MariaDB> SELECT 3+5;\n        -> 8\n','https://mariadb.com/kb/en/addition-operator/'),(445,'INET_NTOA',14,'Syntax:\nINET_NTOA(expr)\n\nGiven a numeric IPv4 network address in network byte order, returns the\ndotted-quad representation of the address as a string. INET_NTOA()\nreturns NULL if it does not understand its argument.\n\nAs of MySQL 5.5.3, the return value is a nonbinary string in the\nconnection character set. Before 5.5.3, the return value is a binary\nstring.\n\nURL: https://mariadb.com/kb/en/inet_ntoa/\n\n','MariaDB> SELECT INET_NTOA(167773449);\n        -> \'10.0.5.9\'\n','https://mariadb.com/kb/en/inet_ntoa/'),(446,'ACOS',4,'Syntax:\nACOS(X)\n\nReturns the arc cosine of X, that is, the value whose cosine is X.\nReturns NULL if X is not in the range -1 to 1.\n\nURL: https://mariadb.com/kb/en/acos/\n\n','MariaDB> SELECT ACOS(1);\n        -> 0\nMariaDB> SELECT ACOS(1.0001);\n        -> NULL\nMariaDB> SELECT ACOS(0);\n        -> 1.5707963267949\n','https://mariadb.com/kb/en/acos/'),(447,'ISOLATION',8,'Syntax:\nSET [GLOBAL | SESSION] TRANSACTION ISOLATION LEVEL\n  {\n       REPEATABLE READ\n     | READ COMMITTED\n     | READ UNCOMMITTED\n     | SERIALIZABLE\n   }\n\nThis statement sets the transaction isolation level, used for\noperations on InnoDB tables.\n\nScope of the Isolation Level\n\nYou can set the isolation level globally, for the current session, or\nfor the next transaction:\n\no With the GLOBAL keyword, the statement sets the default transaction\n  level globally for all subsequent sessions. Existing sessions are\n  unaffected.\n\no With the SESSION keyword, the statement sets the default transaction\n  level for all subsequent transactions performed within the current\n  session.\n\no Without any SESSION or GLOBAL keyword, the statement sets the\n  isolation level for the next (not started) transaction performed\n  within the current session.\n\nA change to the global default isolation level requires the SUPER\nprivilege. Any session is free to change its session isolation level\n(even in the middle of a transaction), or the isolation level for its\nnext transaction.\n\nSET TRANSACTION ISOLATION LEVEL without GLOBAL or SESSION is not\npermitted while there is an active transaction:\n\nMariaDB> START TRANSACTION;\nQuery OK, 0 rows affected (0.02 sec)\n\nMariaDB> SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;\nERROR 1568 (25001): Transaction isolation level can\'t be changed\nwhile a transaction is in progress\n\nTo set the global default isolation level at server startup, use the\n--transaction-isolation=level option to mysqld on the command line or\nin an option file. Values of level for this option use dashes rather\nthan spaces, so the permissible values are READ-UNCOMMITTED,\nREAD-COMMITTED, REPEATABLE-READ, or SERIALIZABLE. For example, to set\nthe default isolation level to REPEATABLE READ, use these lines in the\n[mysqld] section of an option file:\n\n[mysqld]\ntransaction-isolation = REPEATABLE-READ\n\nIt is possible to check or set the global and session transaction\nisolation levels at runtime by using the tx_isolation system variable:\n\nSELECT @@GLOBAL.tx_isolation, @@tx_isolation;\nSET GLOBAL tx_isolation=\'REPEATABLE-READ\';\nSET SESSION tx_isolation=\'SERIALIZABLE\';\n\nDetails and Usage of Isolation Levels\n\nInnoDB supports each of the transaction isolation levels described here\nusing different locking strategies. You can enforce a high degree of\nconsistency with the default REPEATABLE READ level, for operations on\ncrucial data where ACID compliance is important. Or you can relax the\nconsistency rules with READ COMMITTED or even READ UNCOMMITTED, in\nsituations such as bulk reporting where precise consistency and\nrepeatable results are less important than minimizing the amount of\noverhead for locking. SERIALIZABLE enforces even stricter rules than\nREPEATABLE READ, and is used mainly in specialized situations, such as\nwith XA transactions and for troubleshooting issues with concurrency\nand deadlocks.\n\nFor full information about how these isolation levels work with InnoDB\ntransactions, see\nhttp://dev.mysql.com/doc/refman/5.1/en/innodb-transaction-model.html.\nIn particular, for additional information about InnoDB record-level\nlocks and how it uses them to execute various types of statements, see\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-record-level-locks.html\nand http://dev.mysql.com/doc/refman/5.5/en/innodb-locks-set.html.\n\nThe following list describes how MySQL supports the different\ntransaction levels. The list goes from the most commonly used level to\nthe least used.\n\no REPEATABLE READ\n\n  This is the default isolation level for InnoDB. For consistent reads,\n  there is an important difference from the READ COMMITTED isolation\n  level: All consistent reads within the same transaction read the\n  snapshot established by the first read. This convention means that if\n  you issue several plain (nonlocking) SELECT statements within the\n  same transaction, these SELECT statements are consistent also with\n  respect to each other. See\n  http://dev.mysql.com/doc/refman/5.5/en/innodb-consistent-read.html.\n\n  For locking reads (SELECT with FOR UPDATE or LOCK IN SHARE MODE),\n  UPDATE, and DELETE statements, locking depends on whether the\n  statement uses a unique index with a unique search condition, or a\n  range-type search condition. For a unique index with a unique search\n  condition, InnoDB locks only the index record found, not the gap\n  before it. For other search conditions, InnoDB locks the index range\n  scanned, using gap locks or next-key (gap plus index-record) locks to\n  block insertions by other sessions into the gaps covered by the\n  range.\n\no READ COMMITTED\n\n  A somewhat Oracle-like isolation level with respect to consistent\n  (nonlocking) reads: Each consistent read, even within the same\n  transaction, sets and reads its own fresh snapshot. See\n  http://dev.mysql.com/doc/refman/5.5/en/innodb-consistent-read.html.\n\n  For locking reads (SELECT with FOR UPDATE or LOCK IN SHARE MODE),\n  InnoDB locks only index records, not the gaps before them, and thus\n  permits the free insertion of new records next to locked records. For\n  UPDATE and DELETE statements, locking depends on whether the\n  statement uses a unique index with a unique search condition (such as\n  WHERE id = 100), or a range-type search condition (such as WHERE id >\n  100). For a unique index with a unique search condition, InnoDB locks\n  only the index record found, not the gap before it. For range-type\n  searches, InnoDB locks the index range scanned, using gap locks or\n  next-key (gap plus index-record) locks to block insertions by other\n  sessions into the gaps covered by the range. This is necessary\n  because \"phantom rows\" must be blocked for MySQL replication and\n  recovery to work.\n\n  *Note*: In MySQL 5.5, if the READ COMMITTED isolation level is used\n  or the innodb_locks_unsafe_for_binlog system variable is enabled,\n  there is no InnoDB gap locking except for foreign-key constraint\n  checking and duplicate-key checking. Also, record locks for\n  nonmatching rows are released after MySQL has evaluated the WHERE\n  condition. If you use READ COMMITTED or enable\n  innodb_locks_unsafe_for_binlog, you must use row-based binary\n  logging.\n\no READ UNCOMMITTED\n\n  SELECT statements are performed in a nonlocking fashion, but a\n  possible earlier version of a row might be used. Thus, using this\n  isolation level, such reads are not consistent. This is also called a\n  \"dirty read.\" Otherwise, this isolation level works like READ\n  COMMITTED.\n\no SERIALIZABLE\n\n  This level is like REPEATABLE READ, but InnoDB implicitly converts\n  all plain SELECT statements to SELECT ... LOCK IN SHARE MODE if\n  autocommit is disabled. If autocommit is enabled, the SELECT is its\n  own transaction. It therefore is known to be read only and can be\n  serialized if performed as a consistent (nonlocking) read and need\n  not block for other transactions. (To force a plain SELECT to block\n  if other transactions have modified the selected rows, disable\n  autocommit.)\n\nURL: https://mariadb.com/kb/en/set-transaction-isolation-level/\n\n','','https://mariadb.com/kb/en/set-transaction-isolation-level/'),(448,'CEILING',4,'Syntax:\nCEILING(X)\n\nReturns the smallest integer value not less than X.\n\nURL: https://mariadb.com/kb/en/ceiling/\n\n','MariaDB> SELECT CEILING(1.23);\n        -> 2\nMariaDB> SELECT CEILING(-1.23);\n        -> -1\n','https://mariadb.com/kb/en/ceiling/'),(449,'SIN',4,'Syntax:\nSIN(X)\n\nReturns the sine of X, where X is given in radians.\n\nURL: https://mariadb.com/kb/en/sin/\n\n','MariaDB> SELECT SIN(PI());\n        -> 1.2246063538224e-16\nMariaDB> SELECT ROUND(SIN(PI()));\n        -> 0\n','https://mariadb.com/kb/en/sin/'),(450,'DAYOFWEEK',31,'Syntax:\nDAYOFWEEK(date)\n\nReturns the weekday index for date (1 = Sunday, 2 = Monday, ..., 7 =\nSaturday). These index values correspond to the ODBC standard.\n\nURL: https://mariadb.com/kb/en/dayofweek/\n\n','MariaDB> SELECT DAYOFWEEK(\'2007-02-03\');\n        -> 7\n','https://mariadb.com/kb/en/dayofweek/'),(451,'SHOW PROCESSLIST',26,'Syntax:\nSHOW [FULL] PROCESSLIST\n\nSHOW PROCESSLIST shows you which threads are running. You can also get\nthis information from the INFORMATION_SCHEMA PROCESSLIST table or the\nmysqladmin processlist command. If you have the PROCESS privilege, you\ncan see all threads. Otherwise, you can see only your own threads (that\nis, threads associated with the MySQL account that you are using). If\nyou do not use the FULL keyword, only the first 100 characters of each\nstatement are shown in the Info field.\n\nURL: https://mariadb.com/kb/en/show-processlist/\n\n','','https://mariadb.com/kb/en/show-processlist/'),(452,'LINEFROMWKB',32,'LineFromWKB(wkb[,srid]), LineStringFromWKB(wkb[,srid])\n\nConstructs a LINESTRING value using its WKB representation and SRID.\n\nURL: https://mariadb.com/kb/en/linefromwkb/\n\n','','https://mariadb.com/kb/en/linefromwkb/'),(453,'GEOMETRYTYPE',36,'GeometryType(g)\n\nReturns as a binary string the name of the geometry type of which the\ngeometry instance g is a member. The name corresponds to one of the\ninstantiable Geometry subclasses.\n\nURL: https://mariadb.com/kb/en/geometrytype/\n\n','MariaDB> SELECT GeometryType(GeomFromText(\'POINT(1 1)\'));\n+------------------------------------------+\n| GeometryType(GeomFromText(\'POINT(1 1)\')) |\n+------------------------------------------+\n| POINT                                    |\n+------------------------------------------+\n','https://mariadb.com/kb/en/geometrytype/'),(454,'CREATE VIEW',39,'Syntax:\nCREATE\n    [OR REPLACE]\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = { user | CURRENT_USER }]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThe CREATE VIEW statement creates a new view, or replaces an existing\none if the OR REPLACE clause is given. If the view does not exist,\nCREATE OR REPLACE VIEW is the same as CREATE VIEW. If the view does\nexist, CREATE OR REPLACE VIEW is the same as ALTER VIEW.\n\nThe select_statement is a SELECT statement that provides the definition\nof the view. (When you select from the view, you select in effect using\nthe SELECT statement.) select_statement can select from base tables or\nother views.\n\nThe view definition is \"frozen\" at creation time, so changes to the\nunderlying tables afterward do not affect the view definition. For\nexample, if a view is defined as SELECT * on a table, new columns added\nto the table later do not become part of the view.\n\nThe ALGORITHM clause affects how MySQL processes the view. The DEFINER\nand SQL SECURITY clauses specify the security context to be used when\nchecking access privileges at view invocation time. The WITH CHECK\nOPTION clause can be given to constrain inserts or updates to rows in\ntables referenced by the view. These clauses are described later in\nthis section.\n\nThe CREATE VIEW statement requires the CREATE VIEW privilege for the\nview, and some privilege for each column selected by the SELECT\nstatement. For columns used elsewhere in the SELECT statement you must\nhave the SELECT privilege. If the OR REPLACE clause is present, you\nmust also have the DROP privilege for the view. CREATE VIEW might also\nrequire the SUPER privilege, depending on the DEFINER value, as\ndescribed later in this section.\n\nWhen a view is referenced, privilege checking occurs as described later\nin this section.\n\nA view belongs to a database. By default, a new view is created in the\ndefault database. To create the view explicitly in a given database,\nspecify the name as db_name.view_name when you create it:\n\nMariaDB> CREATE VIEW test.v AS SELECT * FROM t;\n\nWithin a database, base tables and views share the same namespace, so a\nbase table and a view cannot have the same name.\n\nColumns retrieved by the SELECT statement can be simple references to\ntable columns. They can also be expressions that use functions,\nconstant values, operators, and so forth.\n\nViews must have unique column names with no duplicates, just like base\ntables. By default, the names of the columns retrieved by the SELECT\nstatement are used for the view column names. To define explicit names\nfor the view columns, the optional column_list clause can be given as a\nlist of comma-separated identifiers. The number of names in column_list\nmust be the same as the number of columns retrieved by the SELECT\nstatement.\n\nUnqualified table or view names in the SELECT statement are interpreted\nwith respect to the default database. A view can refer to tables or\nviews in other databases by qualifying the table or view name with the\nproper database name.\n\nA view can be created from many kinds of SELECT statements. It can\nrefer to base tables or other views. It can use joins, UNION, and\nsubqueries. The SELECT need not even refer to any tables. The following\nexample defines a view that selects two columns from another table, as\nwell as an expression calculated from those columns:\n\nMariaDB> CREATE TABLE t (qty INT, price INT);\nMariaDB> INSERT INTO t VALUES(3, 50);\nMariaDB> CREATE VIEW v AS SELECT qty, price, qty*price AS value FROM t;\nMariaDB> SELECT * FROM v;\n+------+-------+-------+\n| qty  | price | value |\n+------+-------+-------+\n|    3 |    50 |   150 |\n+------+-------+-------+\n\nA view definition is subject to the following restrictions:\n\no The SELECT statement cannot contain a subquery in the FROM clause.\n\no The SELECT statement cannot refer to system or user variables.\n\no Within a stored program, the definition cannot refer to program\n  parameters or local variables.\n\no The SELECT statement cannot refer to prepared statement parameters.\n\no Any table or view referred to in the definition must exist. However,\n  after a view has been created, it is possible to drop a table or view\n  that the definition refers to. In this case, use of the view results\n  in an error. To check a view definition for problems of this kind,\n  use the CHECK TABLE statement.\n\no The definition cannot refer to a TEMPORARY table, and you cannot\n  create a TEMPORARY view.\n\no Any tables named in the view definition must exist at definition\n  time.\n\no You cannot associate a trigger with a view.\n\no Aliases for column names in the SELECT statement are checked against\n  the maximum column length of 64 characters (not the maximum alias\n  length of 256 characters).\n\nORDER BY is permitted in a view definition, but it is ignored if you\nselect from a view using a statement that has its own ORDER BY.\n\nFor other options or clauses in the definition, they are added to the\noptions or clauses of the statement that references the view, but the\neffect is undefined. For example, if a view definition includes a LIMIT\nclause, and you select from the view using a statement that has its own\nLIMIT clause, it is undefined which limit applies. This same principle\napplies to options such as ALL, DISTINCT, or SQL_SMALL_RESULT that\nfollow the SELECT keyword, and to clauses such as INTO, FOR UPDATE,\nLOCK IN SHARE MODE, and PROCEDURE.\n\nIf you create a view and then change the query processing environment\nby changing system variables, that may affect the results that you get\nfrom the view:\n\nMariaDB> CREATE VIEW v (mycol) AS SELECT \'abc\';\nQuery OK, 0 rows affected (0.01 sec)\n\nMariaDB> SET sql_mode = \'\';\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| mycol |\n+-------+\n1 row in set (0.01 sec)\n\nMariaDB> SET sql_mode = \'ANSI_QUOTES\';\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| abc   |\n+-------+\n1 row in set (0.00 sec)\n\nThe DEFINER and SQL SECURITY clauses determine which MySQL account to\nuse when checking access privileges for the view when a statement is\nexecuted that references the view. The valid SQL SECURITY\ncharacteristic values are DEFINER and INVOKER. These indicate that the\nrequired privileges must be held by the user who defined or invoked the\nview, respectively. The default SQL SECURITY value is DEFINER.\n\nIf a user value is given for the DEFINER clause, it should be a MySQL\naccount specified as \'user_name\'@\'host_name\' (the same format used in\nthe GRANT statement), CURRENT_USER, or CURRENT_USER(). The default\nDEFINER value is the user who executes the CREATE VIEW statement. This\nis the same as specifying DEFINER = CURRENT_USER explicitly.\n\nIf you specify the DEFINER clause, these rules determine the valid\nDEFINER user values:\n\no If you do not have the SUPER privilege, the only valid user value is\n  your own account, either specified literally or by using\n  CURRENT_USER. You cannot set the definer to some other account.\n\no If you have the SUPER privilege, you can specify any syntactically\n  valid account name. If the account does not actually exist, a warning\n  is generated.\n\no Although it is possible to create a view with a nonexistent DEFINER\n  account, an error occurs when the view is referenced if the SQL\n  SECURITY value is DEFINER but the definer account does not exist.\n\nFor more information about view security, see\nhttps://mariadb.com/kb/en/stored-routine-privileges/.\n\nWithin a view definition, CURRENT_USER returns the view\'s DEFINER value\nby default. For views defined with the SQL SECURITY INVOKER\ncharacteristic, CURRENT_USER returns the account for the view\'s\ninvoker. For information about user auditing within views, see\nhttp://dev.mysql.com/doc/refman/5.5/en/account-activity-auditing.html.\n\nWithin a stored routine that is defined with the SQL SECURITY DEFINER\ncharacteristic, CURRENT_USER returns the routine\'s DEFINER value. This\nalso affects a view defined within such a routine, if the view\ndefinition contains a DEFINER value of CURRENT_USER.\n\nView privileges are checked like this:\n\no At view definition time, the view creator must have the privileges\n  needed to use the top-level objects accessed by the view. For\n  example, if the view definition refers to table columns, the creator\n  must have some privilege for each column in the select list of the\n  definition, and the SELECT privilege for each column used elsewhere\n  in the definition. If the definition refers to a stored function,\n  only the privileges needed to invoke the function can be checked. The\n  privileges required at function invocation time can be checked only\n  as it executes: For different invocations, different execution paths\n  within the function might be taken.\n\no The user who references a view must have appropriate privileges to\n  access it (SELECT to select from it, INSERT to insert into it, and so\n  forth.)\n\no When a view has been referenced, privileges for objects accessed by\n  the view are checked against the privileges held by the view DEFINER\n  account or invoker, depending on whether the SQL SECURITY\n  characteristic is DEFINER or INVOKER, respectively.\n\no If reference to a view causes execution of a stored function,\n  privilege checking for statements executed within the function depend\n  on whether the function SQL SECURITY characteristic is DEFINER or\n  INVOKER. If the security characteristic is DEFINER, the function runs\n  with the privileges of the DEFINER account. If the characteristic is\n  INVOKER, the function runs with the privileges determined by the\n  view\'s SQL SECURITY characteristic.\n\nExample: A view might depend on a stored function, and that function\nmight invoke other stored routines. For example, the following view\ninvokes a stored function f():\n\nCREATE VIEW v AS SELECT * FROM t WHERE t.id = f(t.name);\n\nSuppose that f() contains a statement such as this:\n\nIF name IS NULL then\n  CALL p1();\nELSE\n  CALL p2();\nEND IF;\n\nThe privileges required for executing statements within f() need to be\nchecked when f() executes. This might mean that privileges are needed\nfor p1() or p2(), depending on the execution path within f(). Those\nprivileges must be checked at runtime, and the user who must possess\nthe privileges is determined by the SQL SECURITY values of the view v\nand the function f().\n\nThe DEFINER and SQL SECURITY clauses for views are extensions to\nstandard SQL. In standard SQL, views are handled using the rules for\nSQL SECURITY DEFINER. The standard says that the definer of the view,\nwhich is the same as the owner of the view\'s schema, gets applicable\nprivileges on the view (for example, SELECT) and may grant them. MySQL\nhas no concept of a schema \"owner\", so MySQL adds a clause to identify\nthe definer. The DEFINER clause is an extension where the intent is to\nhave what the standard has; that is, a permanent record of who defined\nthe view. This is why the default DEFINER value is the account of the\nview creator.\n\nThe optional ALGORITHM clause is a MySQL extension to standard SQL. It\naffects how MySQL processes the view. ALGORITHM takes three values:\nMERGE, TEMPTABLE, or UNDEFINED. The default algorithm is UNDEFINED if\nno ALGORITHM clause is present. For more information, see\nhttps://mariadb.com/kb/en/view-algorithms/.\n\nSome views are updatable. That is, you can use them in statements such\nas UPDATE, DELETE, or INSERT to update the contents of the underlying\ntable. For a view to be updatable, there must be a one-to-one\nrelationship between the rows in the view and the rows in the\nunderlying table. There are also certain other constructs that make a\nview nonupdatable.\n\nThe WITH CHECK OPTION clause can be given for an updatable view to\nprevent inserts or updates to rows except those for which the WHERE\nclause in the select_statement is true.\n\nIn a WITH CHECK OPTION clause for an updatable view, the LOCAL and\nCASCADED keywords determine the scope of check testing when the view is\ndefined in terms of another view. The LOCAL keyword restricts the CHECK\nOPTION only to the view being defined. CASCADED causes the checks for\nunderlying views to be evaluated as well. When neither keyword is\ngiven, the default is CASCADED.\n\nFor more information about updatable views and the WITH CHECK OPTION\nclause, see\nhttps://mariadb.com/kb/en/inserting-and-updating-with-views/.\n\nURL: https://mariadb.com/kb/en/create-view/\n\n','','https://mariadb.com/kb/en/create-view/'),(455,'TRIM',37,'Syntax:\nTRIM([{BOTH | LEADING | TRAILING} [remstr] FROM] str), TRIM([remstr\nFROM] str)\n\nReturns the string str with all remstr prefixes or suffixes removed. If\nnone of the specifiers BOTH, LEADING, or TRAILING is given, BOTH is\nassumed. remstr is optional and, if not specified, spaces are removed.\n\nURL: https://mariadb.com/kb/en/trim/\n\n','MariaDB> SELECT TRIM(\'  bar   \');\n        -> \'bar\'\nMariaDB> SELECT TRIM(LEADING \'x\' FROM \'xxxbarxxx\');\n        -> \'barxxx\'\nMariaDB> SELECT TRIM(BOTH \'x\' FROM \'xxxbarxxx\');\n        -> \'bar\'\nMariaDB> SELECT TRIM(TRAILING \'xyz\' FROM \'barxxyz\');\n        -> \'barx\'\n','https://mariadb.com/kb/en/trim/'),(456,'IS',18,'Syntax:\nIS boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: https://mariadb.com/kb/en/is/\n\n','MariaDB> SELECT 1 IS TRUE, 0 IS FALSE, NULL IS UNKNOWN;\n        -> 1, 1, 1\n','https://mariadb.com/kb/en/is/'),(457,'GET_FORMAT',31,'Syntax:\nGET_FORMAT({DATE|TIME|DATETIME}, {\'EUR\'|\'USA\'|\'JIS\'|\'ISO\'|\'INTERNAL\'})\n\nReturns a format string. This function is useful in combination with\nthe DATE_FORMAT() and the STR_TO_DATE() functions.\n\nURL: https://mariadb.com/kb/en/get_format/\n\n','MariaDB> SELECT DATE_FORMAT(\'2003-10-03\',GET_FORMAT(DATE,\'EUR\'));\n        -> \'03.10.2003\'\nMariaDB> SELECT STR_TO_DATE(\'10.31.2003\',GET_FORMAT(DATE,\'USA\'));\n        -> \'2003-10-31\'\n','https://mariadb.com/kb/en/get_format/'),(458,'TINYBLOB',22,'TINYBLOB\n\nA BLOB column with a maximum length of 255 (28 - 1) bytes. Each\nTINYBLOB value is stored using a 1-byte length prefix that indicates\nthe number of bytes in the value.\n\nURL: https://mariadb.com/kb/en/tinyblob/\n\n','','https://mariadb.com/kb/en/tinyblob/'),(459,'SIGNAL',23,'Syntax:\nSIGNAL condition_value\n    [SET signal_information_item\n    [, signal_information_item] ...]\n\ncondition_value:\n    SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n\nsignal_information_item:\n    condition_information_item_name = simple_value_specification\n\ncondition_information_item_name:\n    CLASS_ORIGIN\n  | SUBCLASS_ORIGIN\n  | MESSAGE_TEXT\n  | MYSQL_ERRNO\n  | CONSTRAINT_CATALOG\n  | CONSTRAINT_SCHEMA\n  | CONSTRAINT_NAME\n  | CATALOG_NAME\n  | SCHEMA_NAME\n  | TABLE_NAME\n  | COLUMN_NAME\n  | CURSOR_NAME\n\ncondition_name, simple_value_specification:\n    (see following discussion)\n\nSIGNAL is the way to \"return\" an error. SIGNAL provides error\ninformation to a handler, to an outer portion of the application, or to\nthe client. Also, it provides control over the error\'s characteristics\n(error number, SQLSTATE value, message). Without SIGNAL, it is\nnecessary to resort to workarounds such as deliberately referring to a\nnonexistent table to cause a routine to return an error.\n\nNo special privileges are required to execute the SIGNAL statement.\n\nThe condition_value in a SIGNAL statement indicates the error value to\nbe returned. It can be an SQLSTATE value (a 5-character string literal)\nor a condition_name that refers to a named condition previously defined\nwith DECLARE ... CONDITION (see [HELP DECLARE CONDITION]).\n\nAn SQLSTATE value can indicate errors, warnings, or \"not found.\" The\nfirst two characters of the value indicate its error class, as\ndiscussed in\nhttps://mariadb.com/kb/en/signal/#signal-condition-inf\normation-items. Some signal values cause statement termination; see\nhttps://mariadb.com/kb/en/signal/#signal-effects.\n\nThe SQLSTATE value for a SIGNAL statement should not start with \'00\'\nbecause such values indicate success and are not valid for signaling an\nerror. This is true whether the SQLSTATE value is specified directly in\nthe SIGNAL statement or in a named condition referred to in the\nstatement. If the value is invalid, a Bad SQLSTATE error occurs.\n\nTo signal a generic SQLSTATE value, use \'45000\', which means \"unhandled\nuser-defined exception.\"\n\nThe SIGNAL statement optionally includes a SET clause that contains\nmultiple signal items, in a comma-separated list of\ncondition_information_item_name = simple_value_specification\nassignments.\n\nEach condition_information_item_name may be specified only once in the\nSET clause. Otherwise, a Duplicate condition information item error\noccurs.\n\nValid simple_value_specification designators can be specified using\nstored procedure or function parameters, stored program local variables\ndeclared with DECLARE, user-defined variables, system variables, or\nliterals. A character literal may include a _charset introducer.\n\nFor information about permissible condition_information_item_name\nvalues, see\nhttps://mariadb.com/kb/en/signal/#signal-condition-inf\normation-items.\n\nURL: https://mariadb.com/kb/en/signal/\n\n','CREATE PROCEDURE p (pval INT)\nBEGIN\n  DECLARE specialty CONDITION FOR SQLSTATE \'45000\';\n  IF pval = 0 THEN\n    SIGNAL SQLSTATE \'01000\';\n  ELSEIF pval = 1 THEN\n    SIGNAL SQLSTATE \'45000\'\n      SET MESSAGE_TEXT = \'An error occurred\';\n  ELSEIF pval = 2 THEN\n    SIGNAL specialty\n      SET MESSAGE_TEXT = \'An error occurred\';\n  ELSE\n    SIGNAL SQLSTATE \'01000\'\n      SET MESSAGE_TEXT = \'A warning occurred\', MYSQL_ERRNO = 1000;\n    SIGNAL SQLSTATE \'45000\'\n      SET MESSAGE_TEXT = \'An error occurred\', MYSQL_ERRNO = 1001;\n  END IF;\nEND;\n','https://mariadb.com/kb/en/signal/'),(460,'SAVEPOINT',8,'Syntax:\nSAVEPOINT identifier\nROLLBACK [WORK] TO [SAVEPOINT] identifier\nRELEASE SAVEPOINT identifier\n\nInnoDB supports the SQL statements SAVEPOINT, ROLLBACK TO SAVEPOINT,\nRELEASE SAVEPOINT and the optional WORK keyword for ROLLBACK.\n\nURL: https://mariadb.com/kb/en/savepoint/\n\n','','https://mariadb.com/kb/en/savepoint/'),(461,'USER',17,'Syntax:\nUSER()\n\nReturns the current MySQL user name and host name as a string in the\nutf8 character set.\n\nURL: https://mariadb.com/kb/en/user/\n\n','MariaDB> SELECT USER();\n        -> \'davida@localhost\'\n','https://mariadb.com/kb/en/user/'),(462,'LABELS',23,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nLabels are permitted for BEGIN ... END blocks and for the LOOP, REPEAT,\nand WHILE statements. Label use for those statements follows these\nrules:\n\no begin_label must be followed by a colon.\n\no begin_label can be given without end_label. If end_label is present,\n  it must be the same as begin_label.\n\no end_label cannot be given without begin_label.\n\no Labels at the same nesting level must be distinct.\n\no Labels can be up to 16 characters long.\n\nTo refer to a label within the labeled construct, use an ITERATE or\nLEAVE statement. The following example uses those statements to\ncontinue iterating or terminate the loop:\n\nCREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN ITERATE label1; END IF;\n    LEAVE label1;\n  END LOOP label1;\nEND;\n\nThe scope of a block label does not include the code for handlers\ndeclared within the block. For details, see [HELP DECLARE HANDLER].\n\nURL: https://mariadb.com/kb/en/labels/\n\n','','https://mariadb.com/kb/en/labels/'),(463,'ALTER TABLE',39,'Syntax:\nALTER [ONLINE | OFFLINE] [IGNORE] TABLE tbl_name\n    [alter_specification [, alter_specification] ...]\n    [partition_options]\n\nalter_specification:\n    table_options\n  | ADD [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name ]\n  | ADD [COLUMN] (col_name column_definition,...)\n  | ADD {INDEX|KEY} [index_name]\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]] PRIMARY KEY\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]]\n        UNIQUE [INDEX|KEY] [index_name]\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD FULLTEXT [INDEX|KEY] [index_name]\n        (index_col_name,...) [index_option] ...\n  | ADD SPATIAL [INDEX|KEY] [index_name]\n        (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]]\n        FOREIGN KEY [index_name] (index_col_name,...)\n        reference_definition\n  | ALTER [COLUMN] col_name {SET DEFAULT literal | DROP DEFAULT}\n  | CHANGE [COLUMN] old_col_name new_col_name column_definition\n        [FIRST|AFTER col_name]\n  | MODIFY [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name]\n  | DROP [COLUMN] col_name\n  | DROP PRIMARY KEY\n  | DROP {INDEX|KEY} index_name\n  | DROP FOREIGN KEY fk_symbol\n  | MAX_ROWS = rows\n  | DISABLE KEYS\n  | ENABLE KEYS\n  | RENAME [TO|AS] new_tbl_name\n  | ORDER BY col_name [, col_name] ...\n  | CONVERT TO CHARACTER SET charset_name [COLLATE collation_name]\n  | [DEFAULT] CHARACTER SET [=] charset_name [COLLATE [=] collation_name]\n  | DISCARD TABLESPACE\n  | IMPORT TABLESPACE\n  | FORCE\n  | ADD PARTITION (partition_definition)\n  | DROP PARTITION partition_names\n  | TRUNCATE PARTITION {partition_names | ALL}\n  | COALESCE PARTITION number\n  | REORGANIZE PARTITION [partition_names INTO (partition_definitions)]\n  | ANALYZE PARTITION {partition_names | ALL}\n  | CHECK PARTITION {partition_names | ALL}\n  | OPTIMIZE PARTITION {partition_names | ALL}\n  | REBUILD PARTITION {partition_names | ALL}\n  | REPAIR PARTITION {partition_names | ALL}\n  | PARTITION BY partitioning_expression\n  | REMOVE PARTITIONING\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n\ntable_options:\n    table_option [[,] table_option] ...  (see CREATE TABLE options)\n\npartition_options:\n    (see CREATE TABLE options)\n\nALTER TABLE changes the structure of a table. For example, you can add\nor delete columns, create or destroy indexes, change the type of\nexisting columns, or rename columns or the table itself. You can also\nchange characteristics such as the storage engine used for the table or\nthe table comment.\n\nPartitioning-related clauses for ALTER TABLE can be used with\npartitioned tables for repartitioning, for adding, dropping, merging,\nand splitting partitions, and for performing partitioning maintenance.\nFor more information, see\nhttp://dev.mysql.com/doc/refman/5.5/en/alter-table-partition-operations\n.html.\n\nFollowing the table name, specify the alterations to be made. If none\nare given, ALTER TABLE does nothing.\n\nURL: https://mariadb.com/kb/en/alter-table/\n\n','','https://mariadb.com/kb/en/alter-table/'),(464,'MPOINTFROMWKB',32,'MPointFromWKB(wkb[,srid]), MultiPointFromWKB(wkb[,srid])\n\nConstructs a MULTIPOINT value using its WKB representation and SRID.\n\nURL: https://mariadb.com/kb/en/mpointfromwkb/\n\n','','https://mariadb.com/kb/en/mpointfromwkb/'),(465,'CHAR BYTE',22,'The CHAR BYTE data type is an alias for the BINARY data type. This is a\ncompatibility feature.\n\nURL: https://mariadb.com/kb/en/char-byte/\n\n','','https://mariadb.com/kb/en/char-byte/'),(466,'REPAIR TABLE',20,'Syntax:\nREPAIR [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n    [QUICK] [EXTENDED] [USE_FRM]\n\nREPAIR TABLE repairs a possibly corrupted table. By default, it has the\nsame effect as myisamchk --recover tbl_name. REPAIR TABLE works for\nMyISAM, ARCHIVE, and CSV tables. See\nhttps://mariadb.com/kb/en/myisam-storage-engine/, and\nhttps://mariadb.com/kb/en/archive/, and\nhttps://mariadb.com/kb/en/csv/\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nREPAIR TABLE is supported for partitioned tables. However, the USE_FRM\noption cannot be used with this statement on a partitioned table.\n\nYou can use ALTER TABLE ... REPAIR PARTITION to repair one or more\npartitions; for more information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: https://mariadb.com/kb/en/repair-table/\n\n','','https://mariadb.com/kb/en/repair-table/'),(467,'MERGE',39,'The MERGE storage engine, also known as the MRG_MyISAM engine, is a\ncollection of identical MyISAM tables that can be used as one.\n\"Identical\" means that all tables have identical column and index\ninformation. You cannot merge MyISAM tables in which the columns are\nlisted in a different order, do not have exactly the same columns, or\nhave the indexes in different order. However, any or all of the MyISAM\ntables can be compressed with myisampack. See\nhttps://mariadb.com/kb/en/myisampack/. Differences in\ntable options such as AVG_ROW_LENGTH, MAX_ROWS, or PACK_KEYS do not\nmatter.\n\nURL: https://mariadb.com/kb/en/merge/\n\n','MariaDB> CREATE TABLE t1 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nMariaDB> CREATE TABLE t2 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nMariaDB> INSERT INTO t1 (message) VALUES (\'Testing\'),(\'table\'),(\'t1\');\nMariaDB> INSERT INTO t2 (message) VALUES (\'Testing\'),(\'table\'),(\'t2\');\nMariaDB> CREATE TABLE total (\n    ->    a INT NOT NULL AUTO_INCREMENT,\n    ->    message CHAR(20), INDEX(a))\n    ->    ENGINE=MERGE UNION=(t1,t2) INSERT_METHOD=LAST;\n','https://mariadb.com/kb/en/merge/'),(468,'CREATE TABLE',39,'Syntax:\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    (create_definition,...)\n    [table_options]\n    [partition_options]\n\nOr:\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    [(create_definition,...)]\n    [table_options]\n    [partition_options]\n    select_statement\n\nOr:\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    { LIKE old_tbl_name | (LIKE old_tbl_name) }\n\ncreate_definition:\n    col_name column_definition\n  | [CONSTRAINT [symbol]] PRIMARY KEY [index_type] (index_col_name,...)\n      [index_option] ...\n  | {INDEX|KEY} [index_name] [index_type] (index_col_name,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] UNIQUE [INDEX|KEY]\n      [index_name] [index_type] (index_col_name,...)\n      [index_option] ...\n  | {FULLTEXT|SPATIAL} [INDEX|KEY] [index_name] (index_col_name,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] FOREIGN KEY\n      [index_name] (index_col_name,...) reference_definition\n  | CHECK (expr)\n\ncolumn_definition:\n    data_type [NOT NULL | NULL] [DEFAULT default_value]\n      [AUTO_INCREMENT] [UNIQUE [KEY] | [PRIMARY] KEY]\n      [COMMENT \'string\']\n      [COLUMN_FORMAT {FIXED|DYNAMIC|DEFAULT}]\n      [STORAGE {DISK|MEMORY|DEFAULT}]\n      [reference_definition]\n\ndata_type:\n    BIT[(length)]\n  | TINYINT[(length)] [UNSIGNED] [ZEROFILL]\n  | SMALLINT[(length)] [UNSIGNED] [ZEROFILL]\n  | MEDIUMINT[(length)] [UNSIGNED] [ZEROFILL]\n  | INT[(length)] [UNSIGNED] [ZEROFILL]\n  | INTEGER[(length)] [UNSIGNED] [ZEROFILL]\n  | BIGINT[(length)] [UNSIGNED] [ZEROFILL]\n  | REAL[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | DOUBLE[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | FLOAT[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | DECIMAL[(length[,decimals])] [UNSIGNED] [ZEROFILL]\n  | NUMERIC[(length[,decimals])] [UNSIGNED] [ZEROFILL]\n  | DATE\n  | TIME\n  | TIMESTAMP\n  | DATETIME\n  | YEAR\n  | CHAR[(length)]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | VARCHAR(length)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | BINARY[(length)]\n  | VARBINARY(length)\n  | TINYBLOB\n  | BLOB\n  | MEDIUMBLOB\n  | LONGBLOB\n  | TINYTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | TEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | MEDIUMTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | LONGTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | ENUM(value1,value2,value3,...)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | SET(value1,value2,value3,...)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | spatial_type\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n  | COMMENT \'string\'\n\nreference_definition:\n    REFERENCES tbl_name (index_col_name,...)\n      [MATCH FULL | MATCH PARTIAL | MATCH SIMPLE]\n      [ON DELETE reference_option]\n      [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION\n\ntable_options:\n    table_option [[,] table_option] ...\n\ntable_option:\n    ENGINE [=] engine_name\n  | AUTO_INCREMENT [=] value\n  | AVG_ROW_LENGTH [=] value\n  | [DEFAULT] CHARACTER SET [=] charset_name\n  | CHECKSUM [=] {0 | 1}\n  | [DEFAULT] COLLATE [=] collation_name\n  | COMMENT [=] \'string\'\n  | CONNECTION [=] \'connect_string\'\n  | DATA DIRECTORY [=] \'absolute path to directory\'\n  | DELAY_KEY_WRITE [=] {0 | 1}\n  | INDEX DIRECTORY [=] \'absolute path to directory\'\n  | INSERT_METHOD [=] { NO | FIRST | LAST }\n  | KEY_BLOCK_SIZE [=] value\n  | MAX_ROWS [=] value\n  | MIN_ROWS [=] value\n  | PACK_KEYS [=] {0 | 1 | DEFAULT}\n  | PASSWORD [=] \'string\'\n  | ROW_FORMAT [=] {DEFAULT|DYNAMIC|FIXED|COMPRESSED|REDUNDANT|COMPACT}\n  | TABLESPACE tablespace_name [STORAGE {DISK|MEMORY|DEFAULT}]\n  | UNION [=] (tbl_name[,tbl_name]...)\n\npartition_options:\n    PARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY(column_list)\n        | RANGE{(expr) | COLUMNS(column_list)}\n        | LIST{(expr) | COLUMNS(column_list)} }\n    [PARTITIONS num]\n    [SUBPARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY(column_list) }\n      [SUBPARTITIONS num]\n    ]\n    [(partition_definition [, partition_definition] ...)]\n\npartition_definition:\n    PARTITION partition_name\n        [VALUES \n            {LESS THAN {(expr | value_list) | MAXVALUE} \n            | \n            IN (value_list)}]\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'comment_text\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [NODEGROUP [=] node_group_id]\n        [(subpartition_definition [, subpartition_definition] ...)]\n\nsubpartition_definition:\n    SUBPARTITION logical_name\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'comment_text\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [NODEGROUP [=] node_group_id]\n\nselect_statement:\n    [IGNORE | REPLACE] [AS] SELECT ...   (Some valid select statement)\n\nCREATE TABLE creates a table with the given name. You must have the\nCREATE privilege for the table.\n\nRules for permissible table names are given in\nhttps://mariadb.com/kb/en/identifier-names/. By default,\nthe table is created in the default database, using the InnoDB storage\nengine. An error occurs if the table exists, if there is no default\ndatabase, or if the database does not exist.\n\nURL: https://mariadb.com/kb/en/create-table/\n\n','','https://mariadb.com/kb/en/create-table/'),(469,'>',18,'Syntax:\n>\n\nGreater than:\n\nURL: https://mariadb.com/kb/en/greater-than/\n\n','MariaDB> SELECT 2 > 2;\n        -> 0\n','https://mariadb.com/kb/en/greater-than/'),(470,'ANALYZE TABLE',20,'Syntax:\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n\nANALYZE TABLE analyzes and stores the key distribution for a table.\nDuring the analysis, the table is locked with a read lock for InnoDB\nand MyISAM. This statement works with InnoDB, Aria and MyISAM tables.\nFor MyISAM tables, this statement is equivalent to using myisamchk\n--analyze.\n\nFor more information on how the analysis works within InnoDB, see\nhttp://dev.mysql.com/doc/refman/5.5/en/innodb-restrictions.html.\n\nMySQL uses the stored key distribution to decide the order in which\ntables should be joined when you perform a join on something other than\na constant. In addition, key distributions can be used when deciding\nwhich indexes to use for a specific table within a query.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nANALYZE TABLE is supported for partitioned tables, and you can use\nALTER TABLE ... ANALYZE PARTITION to analyze one or more partitions;\nfor more information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.5/en/partitioning-maintenance.html.\n\nURL: https://mariadb.com/kb/en/analyze-table/\n\n','','https://mariadb.com/kb/en/analyze-table/'),(471,'MICROSECOND',31,'Syntax:\nMICROSECOND(expr)\n\nReturns the microseconds from the time or datetime expression expr as a\nnumber in the range from 0 to 999999.\n\nURL: https://mariadb.com/kb/en/microsecond/\n\n','MariaDB> SELECT MICROSECOND(\'12:00:00.123456\');\n        -> 123456\nMariaDB> SELECT MICROSECOND(\'2009-12-31 23:59:59.000010\');\n        -> 10\n','https://mariadb.com/kb/en/microsecond/'),(472,'CONSTRAINT',39,'InnoDB supports foreign keys, which let you cross-reference related\ndata across tables, and foreign key constraints, which help keep this\nspread-out data consistent. The syntax for an InnoDB foreign key\nconstraint definition in the CREATE TABLE or ALTER TABLE statement\nlooks like this:\n\n[CONSTRAINT [symbol]] FOREIGN KEY\n    [index_name] (index_col_name, ...)\n    REFERENCES tbl_name (index_col_name,...)\n    [ON DELETE reference_option]\n    [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION\n\nURL: https://mariadb.com/kb/en/constraint/\n\n','CREATE TABLE product (category INT NOT NULL, id INT NOT NULL,\n                      price DECIMAL,\n                      PRIMARY KEY(category, id)) ENGINE=INNODB;\nCREATE TABLE customer (id INT NOT NULL,\n                       PRIMARY KEY (id)) ENGINE=INNODB;\nCREATE TABLE product_order (no INT NOT NULL AUTO_INCREMENT,\n                            product_category INT NOT NULL,\n                            product_id INT NOT NULL,\n                            customer_id INT NOT NULL,\n                            PRIMARY KEY(no),\n                            INDEX (product_category, product_id),\n                            FOREIGN KEY (product_category, product_id)\n                              REFERENCES product(category, id)\n                              ON UPDATE CASCADE ON DELETE RESTRICT,\n                            INDEX (customer_id),\n                            FOREIGN KEY (customer_id)\n                              REFERENCES customer(id)) ENGINE=INNODB;\n','https://mariadb.com/kb/en/constraint/'),(473,'CREATE SERVER',39,'Syntax:\nCREATE SERVER server_name\n    FOREIGN DATA WRAPPER wrapper_name\n    OPTIONS (option [, option] ...)\n\noption:\n  { HOST character-literal\n  | DATABASE character-literal\n  | USER character-literal\n  | PASSWORD character-literal\n  | SOCKET character-literal\n  | OWNER character-literal\n  | PORT numeric-literal }\n\nThis statement creates the definition of a server for use with the\nFEDERATED storage engine. The CREATE SERVER statement creates a new row\nwithin the servers table within the mysql database. This statement\nrequires the SUPER privilege.\n\nThe server_name should be a unique reference to the server. Server\ndefinitions are global within the scope of the server, it is not\npossible to qualify the server definition to a specific database.\nserver_name has a maximum length of 64 characters (names longer than 64\ncharacters are silently truncated), and is case insensitive. You may\nspecify the name as a quoted string.\n\nThe wrapper_name should be mysql, and may be quoted with single\nquotation marks. Other values for wrapper_name are not currently\nsupported.\n\nFor each option you must specify either a character literal or numeric\nliteral. Character literals are UTF-8, support a maximum length of 64\ncharacters and default to a blank (empty) string. String literals are\nsilently truncated to 64 characters. Numeric literals must be a number\nbetween 0 and 9999, default value is 0.\n\n*Note*: Note that the OWNER option is currently not applied, and has no\neffect on the ownership or operation of the server connection that is\ncreated.\n\nThe CREATE SERVER statement creates an entry in the mysql.servers table\nthat can later be used with the CREATE TABLE statement when creating a\nFEDERATED table. The options that you specify will be used to populate\nthe columns in the mysql.servers table. The table columns are\nServer_name, Host, Db, Username, Password, Port and Socket.\n\nURL: https://mariadb.com/kb/en/create-server/\n\n','CREATE SERVER s\nFOREIGN DATA WRAPPER mysql\nOPTIONS (USER \'Remote\', HOST \'192.168.1.106\', DATABASE \'test\');\n','https://mariadb.com/kb/en/create-server/'),(474,'FIELD',37,'Syntax:\nFIELD(str,str1,str2,str3,...)\n\nReturns the index (position) of str in the str1, str2, str3, ... list.\nReturns 0 if str is not found.\n\nIf all arguments to FIELD() are strings, all arguments are compared as\nstrings. If all arguments are numbers, they are compared as numbers.\nOtherwise, the arguments are compared as double.\n\nIf str is NULL, the return value is 0 because NULL fails equality\ncomparison with any value. FIELD() is the complement of ELT().\n\nURL: https://mariadb.com/kb/en/field/\n\n','MariaDB> SELECT FIELD(\'ej\', \'Hej\', \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> 2\nMariaDB> SELECT FIELD(\'fo\', \'Hej\', \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> 0\n','https://mariadb.com/kb/en/field/'),(475,'MAKETIME',31,'Syntax:\nMAKETIME(hour,minute,second)\n\nReturns a time value calculated from the hour, minute, and second\narguments.\n\nURL: https://mariadb.com/kb/en/maketime/\n\n','MariaDB> SELECT MAKETIME(12,15,30);\n        -> \'12:15:30\'\n','https://mariadb.com/kb/en/maketime/'),(476,'CURDATE',31,'Syntax:\nCURDATE()\n\nReturns the current date as a value in \'YYYY-MM-DD\' or YYYYMMDD format,\ndepending on whether the function is used in a string or numeric\ncontext.\n\nURL: https://mariadb.com/kb/en/curdate/\n\n','MariaDB> SELECT CURDATE();\n        -> \'2008-06-13\'\nMariaDB> SELECT CURDATE() + 0;\n        -> 20080613\n','https://mariadb.com/kb/en/curdate/'),(477,'SET PASSWORD',10,'Syntax:\nSET PASSWORD [FOR user] =\n    {\n        PASSWORD(\'cleartext password\')\n      | OLD_PASSWORD(\'cleartext password\')\n      | \'encrypted password\'\n    }\n\nThe SET PASSWORD statement assigns a password to an existing MySQL user\naccount. When the read_only system variable is enabled, the SUPER\nprivilege is required to use SET PASSWORD, in addition to whatever\nother privileges might be required.\n\nIf the password is specified using the PASSWORD() or OLD_PASSWORD()\nfunction, the cleartext (unencrypted) password should be given as the\nargument to the function, which hashes the password and returns the\nencrypted password string. If the password is specified without using\neither function, it should be the already encrypted password value as a\nliteral string. In all cases, the encrypted password string must be in\nthe format required by the authentication method used for the account.\n\nThe old_passwords system variable value determines the hashing method\nused by PASSWORD(). If you specify the password using that function and\nSET PASSWORD rejects the password as not being in the correct format,\nit may be necessary to set old_passwords to change the hashing method.\nFor descriptions of the permitted values, see\nhttps://mariadb.com/kb/en/server-system-variables#old_passwords.\n\nWith no FOR user clause, this statement sets the password for the\ncurrent user. (To see which account the server authenticated you as,\ninvoke the CURRENT_USER() function.) Any client who successfully\nconnects to the server using a nonanonymous account can change the\npassword for that account.\n\nWith a FOR user clause, this statement sets the password for the named\nuser. You must have the UPDATE privilege for the mysql database to do\nthis. The user account name uses the format described in\nhttps://mariadb.com/kb/en/create-user#account-names. The user\nvalue should be given as \'user_name\'@\'host_name\', where \'user_name\' and\n\'host_name\' are exactly as listed in the User and Host columns of the\nmysql.user table row. (If you specify only a user name, a host name of\n\'%\' is used.) For example, to set the password for an account with User\nand Host column values of \'bob\' and \'%.example.org\', write the\nstatement like this:\n\nSET PASSWORD FOR \'bob\'@\'%.example.org\' = PASSWORD(\'cleartext password\');\n\nURL: https://mariadb.com/kb/en/set-password/\n\n','','https://mariadb.com/kb/en/set-password/'),(478,'ALTER TABLESPACE',39,'Syntax:\nALTER TABLESPACE tablespace_name\n    {ADD|DROP} DATAFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement is used with NDB cluster, which is not supported by MariaDB.\n\nURL: https://mariadb.com/kb/en/alter-tablespace/\n\n','','https://mariadb.com/kb/en/alter-tablespace/'),(479,'IF FUNCTION',7,'Syntax:\nIF(expr1,expr2,expr3)\n\nIf expr1 is TRUE (expr1 <> 0 and expr1 <> NULL) then IF() returns\nexpr2; otherwise it returns expr3. IF() returns a numeric or string\nvalue, depending on the context in which it is used.\n\nURL: https://mariadb.com/kb/en/if-function/\n\n','MariaDB> SELECT IF(1>2,2,3);\n        -> 3\nMariaDB> SELECT IF(1<2,\'yes\',\'no\');\n        -> \'yes\'\nMariaDB> SELECT IF(STRCMP(\'test\',\'test1\'),\'no\',\'yes\');\n        -> \'no\'\n','https://mariadb.com/kb/en/if-function/'),(480,'ENUM',22,'ENUM(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nAn enumeration. A string object that can have only one value, chosen\nfrom the list of values \'value1\', \'value2\', ..., NULL or the special \'\'\nerror value. An ENUM column can have a maximum of 65,535 distinct\nvalues. ENUM values are represented internally as integers.\n\nURL: https://mariadb.com/kb/en/enum/\n\n','','https://mariadb.com/kb/en/enum/'),(481,'DATABASE',17,'Syntax:\nDATABASE()\n\nReturns the default (current) database name as a string in the utf8\ncharacter set. If there is no default database, DATABASE() returns\nNULL. Within a stored routine, the default database is the database\nthat the routine is associated with, which is not necessarily the same\nas the database that is the default in the calling context.\n\nURL: https://mariadb.com/kb/en/database/\n\n','MariaDB> SELECT DATABASE();\n        -> \'test\'\n','https://mariadb.com/kb/en/database/'),(482,'POINTFROMWKB',32,'PointFromWKB(wkb[,srid])\n\nConstructs a POINT value using its WKB representation and SRID.\n\nURL: https://mariadb.com/kb/en/pointfromwkb/\n\n','','https://mariadb.com/kb/en/pointfromwkb/'),(483,'POWER',4,'Syntax:\nPOWER(X,Y)\n\nThis is a synonym for POW().\n\nURL: https://mariadb.com/kb/en/power/\n\n','','https://mariadb.com/kb/en/power/'),(484,'ATAN',4,'Syntax:\nATAN(X)\n\nReturns the arc tangent of X, that is, the value whose tangent is X.\n\nURL: https://mariadb.com/kb/en/atan/\n\n','MariaDB> SELECT ATAN(2);\n        -> 1.1071487177941\nMariaDB> SELECT ATAN(-2);\n        -> -1.1071487177941\n','https://mariadb.com/kb/en/atan/'),(485,'STRCMP',37,'Syntax:\nSTRCMP(expr1,expr2)\n\nSTRCMP() returns 0 if the strings are the same, -1 if the first\nargument is smaller than the second according to the current sort\norder, and 1 otherwise.\n\nURL: https://mariadb.com/kb/en/strcmp/\n\n','MariaDB> SELECT STRCMP(\'text\', \'text2\');\n        -> -1\nMariaDB> SELECT STRCMP(\'text2\', \'text\');\n        -> 1\nMariaDB> SELECT STRCMP(\'text\', \'text\');\n        -> 0\n','https://mariadb.com/kb/en/strcmp/'),(486,'INSERT DELAYED',27,'Syntax:\nINSERT DELAYED ...\n\nThe DELAYED option for the INSERT statement is a MySQL extension to\nstandard SQL that is very useful if you have clients that cannot or\nneed not wait for the INSERT to complete. This is a common situation\nwhen you use MySQL for logging and you also periodically run SELECT and\nUPDATE statements that take a long time to complete.\n\nWhen a client uses INSERT DELAYED, it gets an okay from the server at\nonce, and the row is queued to be inserted when the table is not in use\nby any other thread.\n\nAnother major benefit of using INSERT DELAYED is that inserts from many\nclients are bundled together and written in one block. This is much\nfaster than performing many separate inserts.\n\nNote that INSERT DELAYED is slower than a normal INSERT if the table is\nnot otherwise in use. There is also the additional overhead for the\nserver to handle a separate thread for each table for which there are\ndelayed rows. This means that you should use INSERT DELAYED only when\nyou are really sure that you need it.\n\nThe queued rows are held only in memory until they are inserted into\nthe table. This means that if you terminate mysqld forcibly (for\nexample, with kill -9) or if mysqld dies unexpectedly, any queued rows\nthat have not been written to disk are lost.\n\nThere are some constraints on the use of DELAYED:\n\no INSERT DELAYED works only with MyISAM, MEMORY, ARCHIVE, and BLACKHOLE\n  tables. For engines that do not support DELAYED, an error occurs.\n\no An error occurs for INSERT DELAYED if used with a table that has been\n  locked with LOCK TABLES because the insert must be handled by a\n  separate thread, not by the session that holds the lock.\n\no For MyISAM tables, if there are no free blocks in the middle of the\n  data file, concurrent SELECT and INSERT statements are supported.\n  Under these circumstances, you very seldom need to use INSERT DELAYED\n  with MyISAM.\n\no INSERT DELAYED should be used only for INSERT statements that specify\n  value lists. The server ignores DELAYED for INSERT ... SELECT or\n  INSERT ... ON DUPLICATE KEY UPDATE statements.\n\no Because the INSERT DELAYED statement returns immediately, before the\n  rows are inserted, you cannot use LAST_INSERT_ID() to get the\n  AUTO_INCREMENT value that the statement might generate.\n\no DELAYED rows are not visible to SELECT statements until they actually\n  have been inserted.\n\no Prior to MySQL 5.5.7, INSERT DELAYED was treated as a normal INSERT\n  if the statement inserted multiple rows, binary logging was enabled,\n  and the global logging format was statement-based (that is, whenever\n  binlog_format was set to STATEMENT). Beginning with MySQL 5.5.7,\n  INSERT DELAYED is always handled as a simple INSERT (that is, without\n  the DELAYED option) whenever the value of binlog_format is STATEMENT\n  or MIXED. (In the latter case, the statement no longer triggers a\n  switch to row-based logging, and so is logged using the\n  statement-based format.)\n\n  This does not apply when using row-based binary logging mode\n  (binlog_format set to ROW), in which INSERT DELAYED statements are\n  always executed using the DELAYED option as specified, and logged as\n  row-update events.\n\no DELAYED is ignored on slave replication servers, so that INSERT\n  DELAYED is treated as a normal INSERT on slaves. This is because\n  DELAYED could cause the slave to have different data than the master.\n\no Pending INSERT DELAYED statements are lost if a table is write locked\n  and ALTER TABLE is used to modify the table structure.\n\no INSERT DELAYED is not supported for views.\n\no INSERT DELAYED is not supported for partitioned tables.\n\nURL: https://mariadb.com/kb/en/insert-delayed/\n\n','','https://mariadb.com/kb/en/insert-delayed/'),(487,'SHOW PROFILE',26,'Syntax:\nSHOW PROFILE [type [, type] ... ]\n    [FOR QUERY n]\n    [LIMIT row_count [OFFSET offset]]\n\ntype:\n    ALL\n  | BLOCK IO\n  | CONTEXT SWITCHES\n  | CPU\n  | IPC\n  | MEMORY\n  | PAGE FAULTS\n  | SOURCE\n  | SWAPS\n\nThe SHOW PROFILE and SHOW PROFILES statements display profiling\ninformation that indicates resource usage for statements executed\nduring the course of the current session.\n\nProfiling is controlled by the profiling session variable, which has a\ndefault value of 0 (OFF). Profiling is enabled by setting profiling to\n1 or ON:\n\nMariaDB> SET profiling = 1;\n\nSHOW PROFILES displays a list of the most recent statements sent to the\nserver. The size of the list is controlled by the\nprofiling_history_size session variable, which has a default value of\n15. The maximum value is 100. Setting the value to 0 has the practical\neffect of disabling profiling.\n\nAll statements are profiled except SHOW PROFILE and SHOW PROFILES, so\nyou will find neither of those statements in the profile list.\nMalformed statements are profiled. For example, SHOW PROFILING is an\nillegal statement, and a syntax error occurs if you try to execute it,\nbut it will show up in the profiling list.\n\nSHOW PROFILE displays detailed information about a single statement.\nWithout the FOR QUERY n clause, the output pertains to the most\nrecently executed statement. If FOR QUERY n is included, SHOW PROFILE\ndisplays information for statement n. The values of n correspond to the\nQuery_ID values displayed by SHOW PROFILES.\n\nThe LIMIT row_count clause may be given to limit the output to\nrow_count rows. If LIMIT is given, OFFSET offset may be added to begin\nthe output offset rows into the full set of rows.\n\nBy default, SHOW PROFILE displays Status and Duration columns. The\nStatus values are like the State values displayed by SHOW PROCESSLIST,\nalthough there might be some minor differences in interpretion for the\ntwo statements for some status values (see\nhttp://dev.mysql.com/doc/refman/5.5/en/thread-information.html).\n\nOptional type values may be specified to display specific additional\ntypes of information:\n\no ALL displays all information\n\no BLOCK IO displays counts for block input and output operations\n\no CONTEXT SWITCHES displays counts for voluntary and involuntary\n  context switches\n\no CPU displays user and system CPU usage times\n\no IPC displays counts for messages sent and received\n\no MEMORY is not currently implemented\n\no PAGE FAULTS displays counts for major and minor page faults\n\no SOURCE displays the names of functions from the source code, together\n  with the name and line number of the file in which the function\n  occurs\n\no SWAPS displays swap counts\n\nProfiling is enabled per session. When a session ends, its profiling\ninformation is lost.\n\nURL: https://mariadb.com/kb/en/show-profile/\n\n','MariaDB> SELECT @@profiling;\n+-------------+\n| @@profiling |\n+-------------+\n|           0 |\n+-------------+\n1 row in set (0.00 sec)\n\nMariaDB> SET profiling = 1;\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> DROP TABLE IF EXISTS t1;\nQuery OK, 0 rows affected, 1 warning (0.00 sec)\n\nMariaDB> CREATE TABLE T1 (id INT);\nQuery OK, 0 rows affected (0.01 sec)\n\nMariaDB> SHOW PROFILES;\n+----------+----------+--------------------------+\n| Query_ID | Duration | Query                    |\n+----------+----------+--------------------------+\n|        0 | 0.000088 | SET PROFILING = 1        |\n|        1 | 0.000136 | DROP TABLE IF EXISTS t1  |\n|        2 | 0.011947 | CREATE TABLE t1 (id INT) |\n+----------+----------+--------------------------+\n3 rows in set (0.00 sec)\n\nMariaDB> SHOW PROFILE;\n+----------------------+----------+\n| Status               | Duration |\n+----------------------+----------+\n| checking permissions | 0.000040 |\n| creating table       | 0.000056 |\n| After create         | 0.011363 |\n| query end            | 0.000375 |\n| freeing items        | 0.000089 |\n| logging slow query   | 0.000019 |\n| cleaning up          | 0.000005 |\n+----------------------+----------+\n7 rows in set (0.00 sec)\n\nMariaDB> SHOW PROFILE FOR QUERY 1;\n+--------------------+----------+\n| Status             | Duration |\n+--------------------+----------+\n| query end          | 0.000107 |\n| freeing items      | 0.000008 |\n| logging slow query | 0.000015 |\n| cleaning up        | 0.000006 |\n+--------------------+----------+\n4 rows in set (0.00 sec)\n\nMariaDB> SHOW PROFILE CPU FOR QUERY 2;\n+----------------------+----------+----------+------------+\n| Status               | Duration | CPU_user | CPU_system |\n+----------------------+----------+----------+------------+\n| checking permissions | 0.000040 | 0.000038 |   0.000002 |\n| creating table       | 0.000056 | 0.000028 |   0.000028 |\n| After create         | 0.011363 | 0.000217 |   0.001571 |\n| query end            | 0.000375 | 0.000013 |   0.000028 |\n| freeing items        | 0.000089 | 0.000010 |   0.000014 |\n| logging slow query   | 0.000019 | 0.000009 |   0.000010 |\n| cleaning up          | 0.000005 | 0.000003 |   0.000002 |\n+----------------------+----------+----------+------------+\n7 rows in set (0.00 sec)\n','https://mariadb.com/kb/en/show-profile/'),(488,'SHOW PROCEDURE CODE',26,'Syntax:\nSHOW PROCEDURE CODE proc_name\n\nThis statement is a MySQL extension that is available only for servers\nthat have been built with debugging support. It displays a\nrepresentation of the internal implementation of the named stored\nprocedure. A similar statement, SHOW FUNCTION CODE, displays\ninformation about stored functions (see [HELP SHOW FUNCTION CODE]).\n\nBoth statements require that you be the owner of the routine or have\nSELECT access to the mysql.proc table.\n\nIf the named routine is available, each statement produces a result\nset. Each row in the result set corresponds to one \"instruction\" in the\nroutine. The first column is Pos, which is an ordinal number beginning\nwith 0. The second column is Instruction, which contains an SQL\nstatement (usually changed from the original source), or a directive\nwhich has meaning only to the stored-routine handler.\n\nURL: https://mariadb.com/kb/en/show-procedure-code/\n\n','MariaDB> DELIMITER //\nMariaDB> CREATE PROCEDURE p1 ()\n    -> BEGIN\n    ->   DECLARE fanta INT DEFAULT 55;\n    ->   DROP TABLE t2;\n    ->   LOOP\n    ->     INSERT INTO t3 VALUES (fanta);\n    ->     END LOOP;\n    ->   END//\nQuery OK, 0 rows affected (0.00 sec)\n\nMariaDB> SHOW PROCEDURE CODE p1//\n+-----+----------------------------------------+\n| Pos | Instruction                            |\n+-----+----------------------------------------+\n|   0 | set fanta@0 55                         |\n|   1 | stmt 9 \"DROP TABLE t2\"                 |\n|   2 | stmt 5 \"INSERT INTO t3 VALUES (fanta)\" |\n|   3 | jump 2                                 |\n+-----+----------------------------------------+\n4 rows in set (0.00 sec)\n','https://mariadb.com/kb/en/show-procedure-code/'),(489,'MEDIUMTEXT',22,'MEDIUMTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 16,777,215 (224 - 1) characters.\nThe effective maximum length is less if the value contains multi-byte\ncharacters. Each MEDIUMTEXT value is stored using a 3-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: https://mariadb.com/kb/en/mediumtext/\n\n','','https://mariadb.com/kb/en/mediumtext/'),(490,'LN',4,'Syntax:\nLN(X)\n\nReturns the natural logarithm of X; that is, the base-e logarithm of X.\nIf X is less than or equal to 0, then NULL is returned.\n\nURL: https://mariadb.com/kb/en/ln/\n\n','MariaDB> SELECT LN(2);\n        -> 0.69314718055995\nMariaDB> SELECT LN(-2);\n        -> NULL\n','https://mariadb.com/kb/en/ln/'),(491,'RETURN',23,'Syntax:\nRETURN expr\n\nThe RETURN statement terminates execution of a stored function and\nreturns the value expr to the function caller. There must be at least\none RETURN statement in a stored function. There may be more than one\nif the function has multiple exit points.\n\nThis statement is not used in stored procedures, triggers, or events.\nThe LEAVE statement can be used to exit a stored program of those\ntypes.\n\nURL: https://mariadb.com/kb/en/return/\n\n','','https://mariadb.com/kb/en/return/'),(492,'SHOW COLLATION',26,'Syntax:\nSHOW COLLATION\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement lists collations supported by the server. By default,\nthe output from SHOW COLLATION includes all available collations. The\nLIKE clause, if present, indicates which collation names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttps://mariadb.com/kb/en/extended-show/. For example:\n\nMariaDB> SHOW COLLATION LIKE \'latin1%\';\n+-------------------+---------+----+---------+----------+---------+\n| Collation         | Charset | Id | Default | Compiled | Sortlen |\n+-------------------+---------+----+---------+----------+---------+\n| latin1_german1_ci | latin1  |  5 |         |          |       0 |\n| latin1_swedish_ci | latin1  |  8 | Yes     | Yes      |       0 |\n| latin1_danish_ci  | latin1  | 15 |         |          |       0 |\n| latin1_german2_ci | latin1  | 31 |         | Yes      |       2 |\n| latin1_bin        | latin1  | 47 |         | Yes      |       0 |\n| latin1_general_ci | latin1  | 48 |         |          |       0 |\n| latin1_general_cs | latin1  | 49 |         |          |       0 |\n| latin1_spanish_ci | latin1  | 94 |         |          |       0 |\n+-------------------+---------+----+---------+----------+---------+\n\nURL: https://mariadb.com/kb/en/show-collation/\n\n','','https://mariadb.com/kb/en/show-collation/'),(493,'LOG',4,'Syntax:\nLOG(X), LOG(B,X)\n\nIf called with one parameter, this function returns the natural\nlogarithm of X. If X is less than or equal to 0, then NULL is returned.\n\nThe inverse of this function (when called with a single argument) is\nthe EXP() function.\n\nURL: https://mariadb.com/kb/en/log/\n\n','MariaDB> SELECT LOG(2);\n        -> 0.69314718055995\nMariaDB> SELECT LOG(-2);\n        -> NULL\n','https://mariadb.com/kb/en/log/'),(494,'SET SQL_LOG_BIN',8,'Syntax:\nSET sql_log_bin = {0|1}\n\nThe sql_log_bin variable controls whether logging to the binary log is\ndone. The default value is 1 (do logging). To change logging for the\ncurrent session, change the session value of this variable. The session\nuser must have the SUPER privilege to set this variable.\n\nBeginning with MySQL 5.5.5, it is no longer possible to set\n@@session.sql_log_bin within a transaction or subquery. (Bug #53437)\n\nURL: https://mariadb.com/kb/en/set-sql_log_bin/\n\n','','https://mariadb.com/kb/en/set-sql_log_bin/'),(495,'!=',18,'Syntax:\n<>, !=\n\nNot equal:\n\nURL: https://mariadb.com/kb/en/not-equal/\n\n','MariaDB> SELECT \'.01\' <> \'0.01\';\n        -> 1\nMariaDB> SELECT .01 <> \'0.01\';\n        -> 0\nMariaDB> SELECT \'zapp\' <> \'zappp\';\n        -> 1\n','https://mariadb.com/kb/en/not-equal/'),(496,'WHILE',23,'Syntax:\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nThe statement list within a WHILE statement is repeated as long as the\nsearch_condition expression is true. statement_list consists of one or\nmore SQL statements, each terminated by a semicolon (;) statement\ndelimiter.\n\nA WHILE statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: https://mariadb.com/kb/en/while/\n\n','CREATE PROCEDURE dowhile()\nBEGIN\n  DECLARE v1 INT DEFAULT 5;\n\n  WHILE v1 > 0 DO\n    ...\n    SET v1 = v1 - 1;\n  END WHILE;\nEND;\n','https://mariadb.com/kb/en/while/'),(497,'AES_DECRYPT',12,'Syntax:\nAES_DECRYPT(crypt_str,key_str)\n\nThis function decrypts data using the official AES (Advanced Encryption\nStandard) algorithm. For more information, see the description of\nAES_ENCRYPT().\n\nURL: https://mariadb.com/kb/en/aes_decrypt/\n\n','','https://mariadb.com/kb/en/aes_decrypt/'),(498,'DAYNAME',31,'Syntax:\nDAYNAME(date)\n\nReturns the name of the weekday for date. The language used for the\nname is controlled by the value of the lc_time_names system variable\n(https://mariadb.com/kb/en/server-system-variables#lc_time_names).\n\nURL: https://mariadb.com/kb/en/dayname/\n\n','MariaDB> SELECT DAYNAME(\'2007-02-03\');\n        -> \'Saturday\'\n','https://mariadb.com/kb/en/dayname/'),(499,'COERCIBILITY',17,'Syntax:\nCOERCIBILITY(str)\n\nReturns the collation coercibility value of the string argument.\n\nURL: https://mariadb.com/kb/en/coercibility/\n\n','MariaDB> SELECT COERCIBILITY(\'abc\' COLLATE latin1_swedish_ci);\n        -> 0\nMariaDB> SELECT COERCIBILITY(USER());\n        -> 3\nMariaDB> SELECT COERCIBILITY(\'abc\');\n        -> 4\n','https://mariadb.com/kb/en/coercibility/'),(500,'INT',22,'INT[(M)] [UNSIGNED] [ZEROFILL]\n\nA normal-size integer. The signed range is -2147483648 to 2147483647.\nThe unsigned range is 0 to 4294967295.\n\nURL: https://mariadb.com/kb/en/int/\n\n','','https://mariadb.com/kb/en/int/'),(501,'GLENGTH',13,'GLength(ls)\n\nReturns as a double-precision number the length of the LineString value\nls in its associated spatial reference.\n\nURL: https://mariadb.com/kb/en/glength/\n\n','MariaDB> SET @ls = \'LineString(1 1,2 2,3 3)\';\nMariaDB> SELECT GLength(GeomFromText(@ls));\n+----------------------------+\n| GLength(GeomFromText(@ls)) |\n+----------------------------+\n|            2.8284271247462 |\n+----------------------------+\n','https://mariadb.com/kb/en/glength/'),(502,'RADIANS',4,'Syntax:\nRADIANS(X)\n\nReturns the argument X, converted from degrees to radians. (Note that\nπ radians equals 180 degrees.)\n\nURL: https://mariadb.com/kb/en/radians/\n\n','MariaDB> SELECT RADIANS(90);\n        -> 1.5707963267949\n','https://mariadb.com/kb/en/radians/'),(503,'COLLATION',17,'Syntax:\nCOLLATION(str)\n\nReturns the collation of the string argument.\n\nURL: https://mariadb.com/kb/en/collation/\n\n','MariaDB> SELECT COLLATION(\'abc\');\n        -> \'latin1_swedish_ci\'\nMariaDB> SELECT COLLATION(_utf8\'abc\');\n        -> \'utf8_general_ci\'\n','https://mariadb.com/kb/en/collation/'),(504,'COALESCE',18,'Syntax:\nCOALESCE(value,...)\n\nReturns the first non-NULL value in the list, or NULL if there are no\nnon-NULL values.\n\nURL: https://mariadb.com/kb/en/coalesce/\n\n','MariaDB> SELECT COALESCE(NULL,1);\n        -> 1\nMariaDB> SELECT COALESCE(NULL,NULL,NULL);\n        -> NULL\n','https://mariadb.com/kb/en/coalesce/'),(505,'VERSION',17,'Syntax:\nVERSION()\n\nReturns a string that indicates the MySQL server version. The string\nuses the utf8 character set. The value might have a suffix in addition\nto the version number. See the description of the version system\nvariable in\nhttps://mariadb.com/kb/en/server-system-variables#version.\n\nURL: https://mariadb.com/kb/en/version/\n\n','MariaDB> SELECT VERSION();\n        -> \'5.5.29-standard\'\n','https://mariadb.com/kb/en/version/'),(506,'MAKE_SET',37,'Syntax:\nMAKE_SET(bits,str1,str2,...)\n\nReturns a set value (a string containing substrings separated by \",\"\ncharacters) consisting of the strings that have the corresponding bit\nin bits set. str1 corresponds to bit 0, str2 to bit 1, and so on. NULL\nvalues in str1, str2, ... are not appended to the result.\n\nURL: https://mariadb.com/kb/en/make_set/\n\n','MariaDB> SELECT MAKE_SET(1,\'a\',\'b\',\'c\');\n        -> \'a\'\nMariaDB> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',\'world\');\n        -> \'hello,world\'\nMariaDB> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',NULL,\'world\');\n        -> \'hello\'\nMariaDB> SELECT MAKE_SET(0,\'a\',\'b\',\'c\');\n        -> \'\'\n','https://mariadb.com/kb/en/make_set/'),(507,'FIND_IN_SET',37,'Syntax:\nFIND_IN_SET(str,strlist)\n\nReturns a value in the range of 1 to N if the string str is in the\nstring list strlist consisting of N substrings. A string list is a\nstring composed of substrings separated by \",\" characters. If the first\nargument is a constant string and the second is a column of type SET,\nthe FIND_IN_SET() function is optimized to use bit arithmetic. Returns\n0 if str is not in strlist or if strlist is the empty string. Returns\nNULL if either argument is NULL. This function does not work properly\nif the first argument contains a comma (\",\") character.\n\nURL: https://mariadb.com/kb/en/find_in_set/\n\n','MariaDB> SELECT FIND_IN_SET(\'b\',\'a,b,c,d\');\n        -> 2\n','https://mariadb.com/kb/en/find_in_set/');
/*!40000 ALTER TABLE `help_topic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `host`
--

DROP TABLE IF EXISTS `host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `host` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`Db`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Host privileges;  Merged with database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `host`
--

LOCK TABLES `host` WRITE;
/*!40000 ALTER TABLE `host` DISABLE KEYS */;
/*!40000 ALTER TABLE `host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `index_stats`
--

DROP TABLE IF EXISTS `index_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `index_stats` (
  `db_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `index_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `prefix_arity` int(11) unsigned NOT NULL,
  `avg_frequency` decimal(12,4) DEFAULT NULL,
  PRIMARY KEY (`db_name`,`table_name`,`index_name`,`prefix_arity`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Statistics on Indexes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `index_stats`
--

LOCK TABLES `index_stats` WRITE;
/*!40000 ALTER TABLE `index_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `index_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `innodb_index_stats`
--

DROP TABLE IF EXISTS `innodb_index_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `innodb_index_stats` (
  `database_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(199) COLLATE utf8_bin NOT NULL,
  `index_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `last_update` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `stat_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `stat_value` bigint(20) unsigned NOT NULL,
  `sample_size` bigint(20) unsigned DEFAULT NULL,
  `stat_description` varchar(1024) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`database_name`,`table_name`,`index_name`,`stat_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin STATS_PERSISTENT=0;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `innodb_index_stats`
--

LOCK TABLES `innodb_index_stats` WRITE;
/*!40000 ALTER TABLE `innodb_index_stats` DISABLE KEYS */;
INSERT INTO `innodb_index_stats` VALUES ('my_wiki','actor','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'actor_id'),('my_wiki','actor','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','actor','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','actor','actor_name','2019-05-20 16:31:40','n_diff_pfx01',0,1,'actor_name'),('my_wiki','actor','actor_name','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','actor','actor_name','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','actor','actor_user','2019-05-20 16:31:40','n_diff_pfx01',0,1,'actor_user'),('my_wiki','actor','actor_user','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','actor','actor_user','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','archive','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ar_id'),('my_wiki','archive','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','archive','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','archive','ar_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ar_actor'),('my_wiki','archive','ar_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'ar_actor,ar_timestamp'),('my_wiki','archive','ar_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'ar_actor,ar_timestamp,ar_id'),('my_wiki','archive','ar_actor_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','archive','ar_actor_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','archive','ar_revid_uniq','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ar_rev_id'),('my_wiki','archive','ar_revid_uniq','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','archive','ar_revid_uniq','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','archive','ar_usertext_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ar_user_text'),('my_wiki','archive','ar_usertext_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'ar_user_text,ar_timestamp'),('my_wiki','archive','ar_usertext_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'ar_user_text,ar_timestamp,ar_id'),('my_wiki','archive','ar_usertext_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','archive','ar_usertext_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','archive','name_title_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ar_namespace'),('my_wiki','archive','name_title_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'ar_namespace,ar_title'),('my_wiki','archive','name_title_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'ar_namespace,ar_title,ar_timestamp'),('my_wiki','archive','name_title_timestamp','2019-05-20 16:31:40','n_diff_pfx04',0,1,'ar_namespace,ar_title,ar_timestamp,ar_id'),('my_wiki','archive','name_title_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','archive','name_title_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','bot_passwords','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'bp_user'),('my_wiki','bot_passwords','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'bp_user,bp_app_id'),('my_wiki','bot_passwords','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','bot_passwords','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','category','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cat_id'),('my_wiki','category','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','category','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','category','cat_pages','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cat_pages'),('my_wiki','category','cat_pages','2019-05-20 16:31:41','n_diff_pfx02',0,1,'cat_pages,cat_id'),('my_wiki','category','cat_pages','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','category','cat_pages','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','category','cat_title','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cat_title'),('my_wiki','category','cat_title','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','category','cat_title','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','categorylinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cl_from'),('my_wiki','categorylinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'cl_from,cl_to'),('my_wiki','categorylinks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','categorylinks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','categorylinks','cl_collation_ext','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cl_collation'),('my_wiki','categorylinks','cl_collation_ext','2019-05-20 16:31:41','n_diff_pfx02',0,1,'cl_collation,cl_to'),('my_wiki','categorylinks','cl_collation_ext','2019-05-20 16:31:41','n_diff_pfx03',0,1,'cl_collation,cl_to,cl_type'),('my_wiki','categorylinks','cl_collation_ext','2019-05-20 16:31:41','n_diff_pfx04',0,1,'cl_collation,cl_to,cl_type,cl_from'),('my_wiki','categorylinks','cl_collation_ext','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','categorylinks','cl_collation_ext','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','categorylinks','cl_sortkey','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cl_to'),('my_wiki','categorylinks','cl_sortkey','2019-05-20 16:31:41','n_diff_pfx02',0,1,'cl_to,cl_type'),('my_wiki','categorylinks','cl_sortkey','2019-05-20 16:31:41','n_diff_pfx03',0,1,'cl_to,cl_type,cl_sortkey'),('my_wiki','categorylinks','cl_sortkey','2019-05-20 16:31:41','n_diff_pfx04',0,1,'cl_to,cl_type,cl_sortkey,cl_from'),('my_wiki','categorylinks','cl_sortkey','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','categorylinks','cl_sortkey','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','categorylinks','cl_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'cl_to'),('my_wiki','categorylinks','cl_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'cl_to,cl_timestamp'),('my_wiki','categorylinks','cl_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'cl_to,cl_timestamp,cl_from'),('my_wiki','categorylinks','cl_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','categorylinks','cl_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_id'),('my_wiki','change_tag','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_log_tag_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_log_id'),('my_wiki','change_tag','change_tag_log_tag_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_log_id,ct_tag_id'),('my_wiki','change_tag','change_tag_log_tag_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_log_tag_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_log_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_log_id'),('my_wiki','change_tag','change_tag_log_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_log_id,ct_tag'),('my_wiki','change_tag','change_tag_log_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ct_log_id,ct_tag,ct_id'),('my_wiki','change_tag','change_tag_log_tag_nonuniq','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_log_tag_nonuniq','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_rc_tag_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_rc_id'),('my_wiki','change_tag','change_tag_rc_tag_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_rc_id,ct_tag_id'),('my_wiki','change_tag','change_tag_rc_tag_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_rc_tag_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_rc_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_rc_id'),('my_wiki','change_tag','change_tag_rc_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_rc_id,ct_tag'),('my_wiki','change_tag','change_tag_rc_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ct_rc_id,ct_tag,ct_id'),('my_wiki','change_tag','change_tag_rc_tag_nonuniq','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_rc_tag_nonuniq','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_rev_tag_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_rev_id'),('my_wiki','change_tag','change_tag_rev_tag_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_rev_id,ct_tag_id'),('my_wiki','change_tag','change_tag_rev_tag_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_rev_tag_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_rev_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_rev_id'),('my_wiki','change_tag','change_tag_rev_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_rev_id,ct_tag'),('my_wiki','change_tag','change_tag_rev_tag_nonuniq','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ct_rev_id,ct_tag,ct_id'),('my_wiki','change_tag','change_tag_rev_tag_nonuniq','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_rev_tag_nonuniq','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_tag'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_tag,ct_rc_id'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ct_tag,ct_rc_id,ct_rev_id'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','n_diff_pfx04',0,1,'ct_tag,ct_rc_id,ct_rev_id,ct_log_id'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','n_diff_pfx05',0,1,'ct_tag,ct_rc_id,ct_rev_id,ct_log_id,ct_id'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_tag_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ct_tag_id'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ct_tag_id,ct_rc_id'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ct_tag_id,ct_rc_id,ct_rev_id'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','n_diff_pfx04',0,1,'ct_tag_id,ct_rc_id,ct_rev_id,ct_log_id'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','n_diff_pfx05',0,1,'ct_tag_id,ct_rc_id,ct_rev_id,ct_log_id,ct_id'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag','change_tag_tag_id_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag_def','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ctd_id'),('my_wiki','change_tag_def','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag_def','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag_def','ctd_count','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ctd_count'),('my_wiki','change_tag_def','ctd_count','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ctd_count,ctd_id'),('my_wiki','change_tag_def','ctd_count','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag_def','ctd_count','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag_def','ctd_name','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ctd_name'),('my_wiki','change_tag_def','ctd_name','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag_def','ctd_name','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','change_tag_def','ctd_user_defined','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ctd_user_defined'),('my_wiki','change_tag_def','ctd_user_defined','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ctd_user_defined,ctd_id'),('my_wiki','change_tag_def','ctd_user_defined','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','change_tag_def','ctd_user_defined','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','comment','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'comment_id'),('my_wiki','comment','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','comment','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','comment','comment_hash','2019-05-20 16:31:40','n_diff_pfx01',0,1,'comment_hash'),('my_wiki','comment','comment_hash','2019-05-20 16:31:40','n_diff_pfx02',0,1,'comment_hash,comment_id'),('my_wiki','comment','comment_hash','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','comment','comment_hash','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','content','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'content_id'),('my_wiki','content','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','content','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','content_models','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'model_id'),('my_wiki','content_models','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','content_models','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','content_models','model_name','2019-05-20 16:31:40','n_diff_pfx01',0,1,'model_name'),('my_wiki','content_models','model_name','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','content_models','model_name','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','externallinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'el_id'),('my_wiki','externallinks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','externallinks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','externallinks','el_from','2019-05-20 16:31:41','n_diff_pfx01',0,1,'el_from'),('my_wiki','externallinks','el_from','2019-05-20 16:31:41','n_diff_pfx02',0,1,'el_from,el_to'),('my_wiki','externallinks','el_from','2019-05-20 16:31:41','n_diff_pfx03',0,1,'el_from,el_to,el_id'),('my_wiki','externallinks','el_from','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','externallinks','el_from','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','externallinks','el_from_index_60','2019-05-20 16:31:41','n_diff_pfx01',0,1,'el_from'),('my_wiki','externallinks','el_from_index_60','2019-05-20 16:31:41','n_diff_pfx02',0,1,'el_from,el_index_60'),('my_wiki','externallinks','el_from_index_60','2019-05-20 16:31:41','n_diff_pfx03',0,1,'el_from,el_index_60,el_id'),('my_wiki','externallinks','el_from_index_60','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','externallinks','el_from_index_60','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','externallinks','el_index','2019-05-20 16:31:41','n_diff_pfx01',0,1,'el_index'),('my_wiki','externallinks','el_index','2019-05-20 16:31:41','n_diff_pfx02',0,1,'el_index,el_id'),('my_wiki','externallinks','el_index','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','externallinks','el_index','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','externallinks','el_index_60','2019-05-20 16:31:41','n_diff_pfx01',0,1,'el_index_60'),('my_wiki','externallinks','el_index_60','2019-05-20 16:31:41','n_diff_pfx02',0,1,'el_index_60,el_id'),('my_wiki','externallinks','el_index_60','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','externallinks','el_index_60','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','externallinks','el_to','2019-05-20 16:31:41','n_diff_pfx01',0,1,'el_to'),('my_wiki','externallinks','el_to','2019-05-20 16:31:41','n_diff_pfx02',0,1,'el_to,el_from'),('my_wiki','externallinks','el_to','2019-05-20 16:31:41','n_diff_pfx03',0,1,'el_to,el_from,el_id'),('my_wiki','externallinks','el_to','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','externallinks','el_to','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_id'),('my_wiki','filearchive','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','fa_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_actor'),('my_wiki','filearchive','fa_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'fa_actor,fa_timestamp'),('my_wiki','filearchive','fa_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'fa_actor,fa_timestamp,fa_id'),('my_wiki','filearchive','fa_actor_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','fa_actor_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','fa_deleted_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_deleted_timestamp'),('my_wiki','filearchive','fa_deleted_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'fa_deleted_timestamp,fa_id'),('my_wiki','filearchive','fa_deleted_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','fa_deleted_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','fa_name','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_name'),('my_wiki','filearchive','fa_name','2019-05-20 16:31:41','n_diff_pfx02',0,1,'fa_name,fa_timestamp'),('my_wiki','filearchive','fa_name','2019-05-20 16:31:41','n_diff_pfx03',0,1,'fa_name,fa_timestamp,fa_id'),('my_wiki','filearchive','fa_name','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','fa_name','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','fa_sha1','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_sha1'),('my_wiki','filearchive','fa_sha1','2019-05-20 16:31:41','n_diff_pfx02',0,1,'fa_sha1,fa_id'),('my_wiki','filearchive','fa_sha1','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','fa_sha1','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','fa_storage_group','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_storage_group'),('my_wiki','filearchive','fa_storage_group','2019-05-20 16:31:41','n_diff_pfx02',0,1,'fa_storage_group,fa_storage_key'),('my_wiki','filearchive','fa_storage_group','2019-05-20 16:31:41','n_diff_pfx03',0,1,'fa_storage_group,fa_storage_key,fa_id'),('my_wiki','filearchive','fa_storage_group','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','fa_storage_group','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','filearchive','fa_user_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'fa_user_text'),('my_wiki','filearchive','fa_user_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'fa_user_text,fa_timestamp'),('my_wiki','filearchive','fa_user_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'fa_user_text,fa_timestamp,fa_id'),('my_wiki','filearchive','fa_user_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','filearchive','fa_user_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_name'),('my_wiki','image','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_actor'),('my_wiki','image','img_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_actor,img_timestamp'),('my_wiki','image','img_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'img_actor,img_timestamp,img_name'),('my_wiki','image','img_actor_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_actor_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_media_mime','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_media_type'),('my_wiki','image','img_media_mime','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_media_type,img_major_mime'),('my_wiki','image','img_media_mime','2019-05-20 16:31:41','n_diff_pfx03',0,1,'img_media_type,img_major_mime,img_minor_mime'),('my_wiki','image','img_media_mime','2019-05-20 16:31:41','n_diff_pfx04',0,1,'img_media_type,img_major_mime,img_minor_mime,img_name'),('my_wiki','image','img_media_mime','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_media_mime','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_sha1','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_sha1'),('my_wiki','image','img_sha1','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_sha1,img_name'),('my_wiki','image','img_sha1','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_sha1','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_size','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_size'),('my_wiki','image','img_size','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_size,img_name'),('my_wiki','image','img_size','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_size','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_timestamp'),('my_wiki','image','img_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_timestamp,img_name'),('my_wiki','image','img_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_user_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_user'),('my_wiki','image','img_user_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_user,img_timestamp'),('my_wiki','image','img_user_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'img_user,img_timestamp,img_name'),('my_wiki','image','img_user_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_user_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','image','img_usertext_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'img_user_text'),('my_wiki','image','img_usertext_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'img_user_text,img_timestamp'),('my_wiki','image','img_usertext_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'img_user_text,img_timestamp,img_name'),('my_wiki','image','img_usertext_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','image','img_usertext_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','imagelinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'il_from'),('my_wiki','imagelinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'il_from,il_to'),('my_wiki','imagelinks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','imagelinks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','imagelinks','il_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx01',0,1,'il_from_namespace'),('my_wiki','imagelinks','il_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx02',0,1,'il_from_namespace,il_to'),('my_wiki','imagelinks','il_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx03',0,1,'il_from_namespace,il_to,il_from'),('my_wiki','imagelinks','il_backlinks_namespace','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','imagelinks','il_backlinks_namespace','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','imagelinks','il_to','2019-05-20 16:31:41','n_diff_pfx01',0,1,'il_to'),('my_wiki','imagelinks','il_to','2019-05-20 16:31:41','n_diff_pfx02',0,1,'il_to,il_from'),('my_wiki','imagelinks','il_to','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','imagelinks','il_to','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','interwiki','PRIMARY','2019-05-20 16:32:02','n_diff_pfx01',66,1,'iw_prefix'),('my_wiki','interwiki','PRIMARY','2019-05-20 16:32:02','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','interwiki','PRIMARY','2019-05-20 16:32:02','size',1,NULL,'Number of pages in the index'),('my_wiki','ip_changes','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ipc_rev_id'),('my_wiki','ip_changes','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ip_changes','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','ip_changes','ipc_hex_time','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ipc_hex'),('my_wiki','ip_changes','ipc_hex_time','2019-05-20 16:31:40','n_diff_pfx02',0,1,'ipc_hex,ipc_rev_timestamp'),('my_wiki','ip_changes','ipc_hex_time','2019-05-20 16:31:40','n_diff_pfx03',0,1,'ipc_hex,ipc_rev_timestamp,ipc_rev_id'),('my_wiki','ip_changes','ipc_hex_time','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ip_changes','ipc_hex_time','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','ip_changes','ipc_rev_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ipc_rev_timestamp'),('my_wiki','ip_changes','ipc_rev_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'ipc_rev_timestamp,ipc_rev_id'),('my_wiki','ip_changes','ipc_rev_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ip_changes','ipc_rev_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_id'),('my_wiki','ipblocks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','ipb_address','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_address'),('my_wiki','ipblocks','ipb_address','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ipb_address,ipb_user'),('my_wiki','ipblocks','ipb_address','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ipb_address,ipb_user,ipb_auto'),('my_wiki','ipblocks','ipb_address','2019-05-20 16:31:41','n_diff_pfx04',0,1,'ipb_address,ipb_user,ipb_auto,ipb_anon_only'),('my_wiki','ipblocks','ipb_address','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','ipb_address','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','ipb_expiry','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_expiry'),('my_wiki','ipblocks','ipb_expiry','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ipb_expiry,ipb_id'),('my_wiki','ipblocks','ipb_expiry','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','ipb_expiry','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','ipb_parent_block_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_parent_block_id'),('my_wiki','ipblocks','ipb_parent_block_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ipb_parent_block_id,ipb_id'),('my_wiki','ipblocks','ipb_parent_block_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','ipb_parent_block_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','ipb_range','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_range_start'),('my_wiki','ipblocks','ipb_range','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ipb_range_start,ipb_range_end'),('my_wiki','ipblocks','ipb_range','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ipb_range_start,ipb_range_end,ipb_id'),('my_wiki','ipblocks','ipb_range','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','ipb_range','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','ipb_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_timestamp'),('my_wiki','ipblocks','ipb_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ipb_timestamp,ipb_id'),('my_wiki','ipblocks','ipb_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','ipb_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks','ipb_user','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ipb_user'),('my_wiki','ipblocks','ipb_user','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ipb_user,ipb_id'),('my_wiki','ipblocks','ipb_user','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks','ipb_user','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks_restrictions','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ir_ipb_id'),('my_wiki','ipblocks_restrictions','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ir_ipb_id,ir_type'),('my_wiki','ipblocks_restrictions','PRIMARY','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ir_ipb_id,ir_type,ir_value'),('my_wiki','ipblocks_restrictions','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks_restrictions','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','ipblocks_restrictions','ir_type_value','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ir_type'),('my_wiki','ipblocks_restrictions','ir_type_value','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ir_type,ir_value'),('my_wiki','ipblocks_restrictions','ir_type_value','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ir_type,ir_value,ir_ipb_id'),('my_wiki','ipblocks_restrictions','ir_type_value','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','ipblocks_restrictions','ir_type_value','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','iwlinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'iwl_from'),('my_wiki','iwlinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'iwl_from,iwl_prefix'),('my_wiki','iwlinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx03',0,1,'iwl_from,iwl_prefix,iwl_title'),('my_wiki','iwlinks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','iwlinks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','iwlinks','iwl_prefix_from_title','2019-05-20 16:31:41','n_diff_pfx01',0,1,'iwl_prefix'),('my_wiki','iwlinks','iwl_prefix_from_title','2019-05-20 16:31:41','n_diff_pfx02',0,1,'iwl_prefix,iwl_from'),('my_wiki','iwlinks','iwl_prefix_from_title','2019-05-20 16:31:41','n_diff_pfx03',0,1,'iwl_prefix,iwl_from,iwl_title'),('my_wiki','iwlinks','iwl_prefix_from_title','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','iwlinks','iwl_prefix_from_title','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','iwlinks','iwl_prefix_title_from','2019-05-20 16:31:41','n_diff_pfx01',0,1,'iwl_prefix'),('my_wiki','iwlinks','iwl_prefix_title_from','2019-05-20 16:31:41','n_diff_pfx02',0,1,'iwl_prefix,iwl_title'),('my_wiki','iwlinks','iwl_prefix_title_from','2019-05-20 16:31:41','n_diff_pfx03',0,1,'iwl_prefix,iwl_title,iwl_from'),('my_wiki','iwlinks','iwl_prefix_title_from','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','iwlinks','iwl_prefix_title_from','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','job','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'job_id'),('my_wiki','job','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','job','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','n_diff_pfx01',0,1,'job_cmd'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','n_diff_pfx02',0,1,'job_cmd,job_namespace'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','n_diff_pfx03',0,1,'job_cmd,job_namespace,job_title'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','n_diff_pfx04',0,1,'job_cmd,job_namespace,job_title,job_params'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','n_diff_pfx05',0,1,'job_cmd,job_namespace,job_title,job_params,job_id'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','job','job_cmd','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','job','job_cmd_token','2019-05-20 16:31:41','n_diff_pfx01',0,1,'job_cmd'),('my_wiki','job','job_cmd_token','2019-05-20 16:31:41','n_diff_pfx02',0,1,'job_cmd,job_token'),('my_wiki','job','job_cmd_token','2019-05-20 16:31:41','n_diff_pfx03',0,1,'job_cmd,job_token,job_random'),('my_wiki','job','job_cmd_token','2019-05-20 16:31:41','n_diff_pfx04',0,1,'job_cmd,job_token,job_random,job_id'),('my_wiki','job','job_cmd_token','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','job','job_cmd_token','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','job','job_cmd_token_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'job_cmd'),('my_wiki','job','job_cmd_token_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'job_cmd,job_token'),('my_wiki','job','job_cmd_token_id','2019-05-20 16:31:41','n_diff_pfx03',0,1,'job_cmd,job_token,job_id'),('my_wiki','job','job_cmd_token_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','job','job_cmd_token_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','job','job_sha1','2019-05-20 16:31:41','n_diff_pfx01',0,1,'job_sha1'),('my_wiki','job','job_sha1','2019-05-20 16:31:41','n_diff_pfx02',0,1,'job_sha1,job_id'),('my_wiki','job','job_sha1','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','job','job_sha1','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','job','job_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'job_timestamp'),('my_wiki','job','job_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'job_timestamp,job_id'),('my_wiki','job','job_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','job','job_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','l10n_cache','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'lc_lang'),('my_wiki','l10n_cache','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'lc_lang,lc_key'),('my_wiki','l10n_cache','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','l10n_cache','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','langlinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ll_from'),('my_wiki','langlinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ll_from,ll_lang'),('my_wiki','langlinks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','langlinks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','langlinks','ll_lang','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ll_lang'),('my_wiki','langlinks','ll_lang','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ll_lang,ll_title'),('my_wiki','langlinks','ll_lang','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ll_lang,ll_title,ll_from'),('my_wiki','langlinks','ll_lang','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','langlinks','ll_lang','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','log_search','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ls_field'),('my_wiki','log_search','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ls_field,ls_value'),('my_wiki','log_search','PRIMARY','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ls_field,ls_value,ls_log_id'),('my_wiki','log_search','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','log_search','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','log_search','ls_log_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ls_log_id'),('my_wiki','log_search','ls_log_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'ls_log_id,ls_field'),('my_wiki','log_search','ls_log_id','2019-05-20 16:31:41','n_diff_pfx03',0,1,'ls_log_id,ls_field,ls_value'),('my_wiki','log_search','ls_log_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','log_search','ls_log_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_id'),('my_wiki','logging','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','actor_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_actor'),('my_wiki','logging','actor_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_actor,log_timestamp'),('my_wiki','logging','actor_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_actor,log_timestamp,log_id'),('my_wiki','logging','actor_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','actor_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','log_actor_type_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_actor'),('my_wiki','logging','log_actor_type_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_actor,log_type'),('my_wiki','logging','log_actor_type_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_actor,log_type,log_timestamp'),('my_wiki','logging','log_actor_type_time','2019-05-20 16:31:41','n_diff_pfx04',0,1,'log_actor,log_type,log_timestamp,log_id'),('my_wiki','logging','log_actor_type_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','log_actor_type_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','log_page_id_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_page'),('my_wiki','logging','log_page_id_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_page,log_timestamp'),('my_wiki','logging','log_page_id_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_page,log_timestamp,log_id'),('my_wiki','logging','log_page_id_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','log_page_id_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','log_type_action','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_type'),('my_wiki','logging','log_type_action','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_type,log_action'),('my_wiki','logging','log_type_action','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_type,log_action,log_timestamp'),('my_wiki','logging','log_type_action','2019-05-20 16:31:41','n_diff_pfx04',0,1,'log_type,log_action,log_timestamp,log_id'),('my_wiki','logging','log_type_action','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','log_type_action','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','log_user_text_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_user_text'),('my_wiki','logging','log_user_text_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_user_text,log_timestamp'),('my_wiki','logging','log_user_text_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_user_text,log_timestamp,log_id'),('my_wiki','logging','log_user_text_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','log_user_text_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','log_user_text_type_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_user_text'),('my_wiki','logging','log_user_text_type_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_user_text,log_type'),('my_wiki','logging','log_user_text_type_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_user_text,log_type,log_timestamp'),('my_wiki','logging','log_user_text_type_time','2019-05-20 16:31:41','n_diff_pfx04',0,1,'log_user_text,log_type,log_timestamp,log_id'),('my_wiki','logging','log_user_text_type_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','log_user_text_type_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','log_user_type_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_user'),('my_wiki','logging','log_user_type_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_user,log_type'),('my_wiki','logging','log_user_type_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_user,log_type,log_timestamp'),('my_wiki','logging','log_user_type_time','2019-05-20 16:31:41','n_diff_pfx04',0,1,'log_user,log_type,log_timestamp,log_id'),('my_wiki','logging','log_user_type_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','log_user_type_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','page_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_namespace'),('my_wiki','logging','page_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_namespace,log_title'),('my_wiki','logging','page_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_namespace,log_title,log_timestamp'),('my_wiki','logging','page_time','2019-05-20 16:31:41','n_diff_pfx04',0,1,'log_namespace,log_title,log_timestamp,log_id'),('my_wiki','logging','page_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','page_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','times','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_timestamp'),('my_wiki','logging','times','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_timestamp,log_id'),('my_wiki','logging','times','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','times','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','type_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_type'),('my_wiki','logging','type_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_type,log_timestamp'),('my_wiki','logging','type_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_type,log_timestamp,log_id'),('my_wiki','logging','type_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','type_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','logging','user_time','2019-05-20 16:31:41','n_diff_pfx01',0,1,'log_user'),('my_wiki','logging','user_time','2019-05-20 16:31:41','n_diff_pfx02',0,1,'log_user,log_timestamp'),('my_wiki','logging','user_time','2019-05-20 16:31:41','n_diff_pfx03',0,1,'log_user,log_timestamp,log_id'),('my_wiki','logging','user_time','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','logging','user_time','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','module_deps','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'md_module'),('my_wiki','module_deps','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'md_module,md_skin'),('my_wiki','module_deps','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','module_deps','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','objectcache','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'keyname'),('my_wiki','objectcache','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','objectcache','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','objectcache','exptime','2019-05-20 16:31:41','n_diff_pfx01',0,1,'exptime'),('my_wiki','objectcache','exptime','2019-05-20 16:31:41','n_diff_pfx02',0,1,'exptime,keyname'),('my_wiki','objectcache','exptime','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','objectcache','exptime','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','oldimage','GEN_CLUST_INDEX','2019-05-20 16:31:41','n_diff_pfx01',0,1,'DB_ROW_ID'),('my_wiki','oldimage','GEN_CLUST_INDEX','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','oldimage','GEN_CLUST_INDEX','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','oldimage','oi_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'oi_actor'),('my_wiki','oldimage','oi_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'oi_actor,oi_timestamp'),('my_wiki','oldimage','oi_actor_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'oi_actor,oi_timestamp,DB_ROW_ID'),('my_wiki','oldimage','oi_actor_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','oldimage','oi_actor_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','oldimage','oi_name_archive_name','2019-05-20 16:31:41','n_diff_pfx01',0,1,'oi_name'),('my_wiki','oldimage','oi_name_archive_name','2019-05-20 16:31:41','n_diff_pfx02',0,1,'oi_name,oi_archive_name'),('my_wiki','oldimage','oi_name_archive_name','2019-05-20 16:31:41','n_diff_pfx03',0,1,'oi_name,oi_archive_name,DB_ROW_ID'),('my_wiki','oldimage','oi_name_archive_name','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','oldimage','oi_name_archive_name','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','oldimage','oi_name_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'oi_name'),('my_wiki','oldimage','oi_name_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'oi_name,oi_timestamp'),('my_wiki','oldimage','oi_name_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'oi_name,oi_timestamp,DB_ROW_ID'),('my_wiki','oldimage','oi_name_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','oldimage','oi_name_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','oldimage','oi_sha1','2019-05-20 16:31:41','n_diff_pfx01',0,1,'oi_sha1'),('my_wiki','oldimage','oi_sha1','2019-05-20 16:31:41','n_diff_pfx02',0,1,'oi_sha1,DB_ROW_ID'),('my_wiki','oldimage','oi_sha1','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','oldimage','oi_sha1','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','oldimage','oi_usertext_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'oi_user_text'),('my_wiki','oldimage','oi_usertext_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'oi_user_text,oi_timestamp'),('my_wiki','oldimage','oi_usertext_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'oi_user_text,oi_timestamp,DB_ROW_ID'),('my_wiki','oldimage','oi_usertext_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','oldimage','oi_usertext_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page','PRIMARY','2019-05-20 16:32:12','n_diff_pfx01',1,1,'page_id'),('my_wiki','page','PRIMARY','2019-05-20 16:32:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page','PRIMARY','2019-05-20 16:32:12','size',1,NULL,'Number of pages in the index'),('my_wiki','page','name_title','2019-05-20 16:32:12','n_diff_pfx01',1,1,'page_namespace'),('my_wiki','page','name_title','2019-05-20 16:32:12','n_diff_pfx02',1,1,'page_namespace,page_title'),('my_wiki','page','name_title','2019-05-20 16:32:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page','name_title','2019-05-20 16:32:12','size',1,NULL,'Number of pages in the index'),('my_wiki','page','page_len','2019-05-20 16:32:12','n_diff_pfx01',1,1,'page_len'),('my_wiki','page','page_len','2019-05-20 16:32:12','n_diff_pfx02',1,1,'page_len,page_id'),('my_wiki','page','page_len','2019-05-20 16:32:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page','page_len','2019-05-20 16:32:12','size',1,NULL,'Number of pages in the index'),('my_wiki','page','page_random','2019-05-20 16:32:12','n_diff_pfx01',1,1,'page_random'),('my_wiki','page','page_random','2019-05-20 16:32:12','n_diff_pfx02',1,1,'page_random,page_id'),('my_wiki','page','page_random','2019-05-20 16:32:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page','page_random','2019-05-20 16:32:12','size',1,NULL,'Number of pages in the index'),('my_wiki','page','page_redirect_namespace_len','2019-05-20 16:32:12','n_diff_pfx01',1,1,'page_is_redirect'),('my_wiki','page','page_redirect_namespace_len','2019-05-20 16:32:12','n_diff_pfx02',1,1,'page_is_redirect,page_namespace'),('my_wiki','page','page_redirect_namespace_len','2019-05-20 16:32:12','n_diff_pfx03',1,1,'page_is_redirect,page_namespace,page_len'),('my_wiki','page','page_redirect_namespace_len','2019-05-20 16:32:12','n_diff_pfx04',1,1,'page_is_redirect,page_namespace,page_len,page_id'),('my_wiki','page','page_redirect_namespace_len','2019-05-20 16:32:12','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page','page_redirect_namespace_len','2019-05-20 16:32:12','size',1,NULL,'Number of pages in the index'),('my_wiki','page_props','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pp_page'),('my_wiki','page_props','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pp_page,pp_propname'),('my_wiki','page_props','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_props','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_props','pp_propname_page','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pp_propname'),('my_wiki','page_props','pp_propname_page','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pp_propname,pp_page'),('my_wiki','page_props','pp_propname_page','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_props','pp_propname_page','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_props','pp_propname_sortkey_page','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pp_propname'),('my_wiki','page_props','pp_propname_sortkey_page','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pp_propname,pp_sortkey'),('my_wiki','page_props','pp_propname_sortkey_page','2019-05-20 16:31:41','n_diff_pfx03',0,1,'pp_propname,pp_sortkey,pp_page'),('my_wiki','page_props','pp_propname_sortkey_page','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_props','pp_propname_sortkey_page','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_restrictions','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pr_id'),('my_wiki','page_restrictions','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_restrictions','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_restrictions','pr_cascade','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pr_cascade'),('my_wiki','page_restrictions','pr_cascade','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pr_cascade,pr_id'),('my_wiki','page_restrictions','pr_cascade','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_restrictions','pr_cascade','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_restrictions','pr_level','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pr_level'),('my_wiki','page_restrictions','pr_level','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pr_level,pr_id'),('my_wiki','page_restrictions','pr_level','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_restrictions','pr_level','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_restrictions','pr_pagetype','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pr_page'),('my_wiki','page_restrictions','pr_pagetype','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pr_page,pr_type'),('my_wiki','page_restrictions','pr_pagetype','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_restrictions','pr_pagetype','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','page_restrictions','pr_typelevel','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pr_type'),('my_wiki','page_restrictions','pr_typelevel','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pr_type,pr_level'),('my_wiki','page_restrictions','pr_typelevel','2019-05-20 16:31:41','n_diff_pfx03',0,1,'pr_type,pr_level,pr_id'),('my_wiki','page_restrictions','pr_typelevel','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','page_restrictions','pr_typelevel','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','pagelinks','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'pl_from'),('my_wiki','pagelinks','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'pl_from,pl_namespace'),('my_wiki','pagelinks','PRIMARY','2019-05-20 16:31:40','n_diff_pfx03',0,1,'pl_from,pl_namespace,pl_title'),('my_wiki','pagelinks','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','pagelinks','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','pagelinks','pl_backlinks_namespace','2019-05-20 16:31:40','n_diff_pfx01',0,1,'pl_from_namespace'),('my_wiki','pagelinks','pl_backlinks_namespace','2019-05-20 16:31:40','n_diff_pfx02',0,1,'pl_from_namespace,pl_namespace'),('my_wiki','pagelinks','pl_backlinks_namespace','2019-05-20 16:31:40','n_diff_pfx03',0,1,'pl_from_namespace,pl_namespace,pl_title'),('my_wiki','pagelinks','pl_backlinks_namespace','2019-05-20 16:31:40','n_diff_pfx04',0,1,'pl_from_namespace,pl_namespace,pl_title,pl_from'),('my_wiki','pagelinks','pl_backlinks_namespace','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','pagelinks','pl_backlinks_namespace','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','pagelinks','pl_namespace','2019-05-20 16:31:40','n_diff_pfx01',0,1,'pl_namespace'),('my_wiki','pagelinks','pl_namespace','2019-05-20 16:31:40','n_diff_pfx02',0,1,'pl_namespace,pl_title'),('my_wiki','pagelinks','pl_namespace','2019-05-20 16:31:40','n_diff_pfx03',0,1,'pl_namespace,pl_title,pl_from'),('my_wiki','pagelinks','pl_namespace','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','pagelinks','pl_namespace','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','protected_titles','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pt_namespace'),('my_wiki','protected_titles','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pt_namespace,pt_title'),('my_wiki','protected_titles','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','protected_titles','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','protected_titles','pt_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'pt_timestamp'),('my_wiki','protected_titles','pt_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'pt_timestamp,pt_namespace'),('my_wiki','protected_titles','pt_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'pt_timestamp,pt_namespace,pt_title'),('my_wiki','protected_titles','pt_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','protected_titles','pt_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycache','GEN_CLUST_INDEX','2019-05-20 16:31:41','n_diff_pfx01',0,1,'DB_ROW_ID'),('my_wiki','querycache','GEN_CLUST_INDEX','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycache','GEN_CLUST_INDEX','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycache','qc_type','2019-05-20 16:31:41','n_diff_pfx01',0,1,'qc_type'),('my_wiki','querycache','qc_type','2019-05-20 16:31:41','n_diff_pfx02',0,1,'qc_type,qc_value'),('my_wiki','querycache','qc_type','2019-05-20 16:31:41','n_diff_pfx03',0,1,'qc_type,qc_value,DB_ROW_ID'),('my_wiki','querycache','qc_type','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycache','qc_type','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycache_info','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'qci_type'),('my_wiki','querycache_info','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycache_info','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycachetwo','GEN_CLUST_INDEX','2019-05-20 16:31:41','n_diff_pfx01',0,1,'DB_ROW_ID'),('my_wiki','querycachetwo','GEN_CLUST_INDEX','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycachetwo','GEN_CLUST_INDEX','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycachetwo','qcc_title','2019-05-20 16:31:41','n_diff_pfx01',0,1,'qcc_type'),('my_wiki','querycachetwo','qcc_title','2019-05-20 16:31:41','n_diff_pfx02',0,1,'qcc_type,qcc_namespace'),('my_wiki','querycachetwo','qcc_title','2019-05-20 16:31:41','n_diff_pfx03',0,1,'qcc_type,qcc_namespace,qcc_title'),('my_wiki','querycachetwo','qcc_title','2019-05-20 16:31:41','n_diff_pfx04',0,1,'qcc_type,qcc_namespace,qcc_title,DB_ROW_ID'),('my_wiki','querycachetwo','qcc_title','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycachetwo','qcc_title','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycachetwo','qcc_titletwo','2019-05-20 16:31:41','n_diff_pfx01',0,1,'qcc_type'),('my_wiki','querycachetwo','qcc_titletwo','2019-05-20 16:31:41','n_diff_pfx02',0,1,'qcc_type,qcc_namespacetwo'),('my_wiki','querycachetwo','qcc_titletwo','2019-05-20 16:31:41','n_diff_pfx03',0,1,'qcc_type,qcc_namespacetwo,qcc_titletwo'),('my_wiki','querycachetwo','qcc_titletwo','2019-05-20 16:31:41','n_diff_pfx04',0,1,'qcc_type,qcc_namespacetwo,qcc_titletwo,DB_ROW_ID'),('my_wiki','querycachetwo','qcc_titletwo','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycachetwo','qcc_titletwo','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','querycachetwo','qcc_type','2019-05-20 16:31:41','n_diff_pfx01',0,1,'qcc_type'),('my_wiki','querycachetwo','qcc_type','2019-05-20 16:31:41','n_diff_pfx02',0,1,'qcc_type,qcc_value'),('my_wiki','querycachetwo','qcc_type','2019-05-20 16:31:41','n_diff_pfx03',0,1,'qcc_type,qcc_value,DB_ROW_ID'),('my_wiki','querycachetwo','qcc_type','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','querycachetwo','qcc_type','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_id'),('my_wiki','recentchanges','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','new_name_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_new'),('my_wiki','recentchanges','new_name_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_new,rc_namespace'),('my_wiki','recentchanges','new_name_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_new,rc_namespace,rc_timestamp'),('my_wiki','recentchanges','new_name_timestamp','2019-05-20 16:31:41','n_diff_pfx04',0,1,'rc_new,rc_namespace,rc_timestamp,rc_id'),('my_wiki','recentchanges','new_name_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','new_name_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_actor','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_actor'),('my_wiki','recentchanges','rc_actor','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_actor,rc_timestamp'),('my_wiki','recentchanges','rc_actor','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_actor,rc_timestamp,rc_id'),('my_wiki','recentchanges','rc_actor','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_actor','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_cur_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_cur_id'),('my_wiki','recentchanges','rc_cur_id','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_cur_id,rc_id'),('my_wiki','recentchanges','rc_cur_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_cur_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_ip','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_ip'),('my_wiki','recentchanges','rc_ip','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_ip,rc_id'),('my_wiki','recentchanges','rc_ip','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_ip','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_namespace'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_namespace,rc_type'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_namespace,rc_type,rc_patrolled'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','n_diff_pfx04',0,1,'rc_namespace,rc_type,rc_patrolled,rc_timestamp'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','n_diff_pfx05',0,1,'rc_namespace,rc_type,rc_patrolled,rc_timestamp,rc_id'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_name_type_patrolled_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_namespace_title_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_namespace'),('my_wiki','recentchanges','rc_namespace_title_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_namespace,rc_title'),('my_wiki','recentchanges','rc_namespace_title_timestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_namespace,rc_title,rc_timestamp'),('my_wiki','recentchanges','rc_namespace_title_timestamp','2019-05-20 16:31:41','n_diff_pfx04',0,1,'rc_namespace,rc_title,rc_timestamp,rc_id'),('my_wiki','recentchanges','rc_namespace_title_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_namespace_title_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_ns_actor','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_namespace'),('my_wiki','recentchanges','rc_ns_actor','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_namespace,rc_actor'),('my_wiki','recentchanges','rc_ns_actor','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_namespace,rc_actor,rc_id'),('my_wiki','recentchanges','rc_ns_actor','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_ns_actor','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_ns_usertext','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_namespace'),('my_wiki','recentchanges','rc_ns_usertext','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_namespace,rc_user_text'),('my_wiki','recentchanges','rc_ns_usertext','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_namespace,rc_user_text,rc_id'),('my_wiki','recentchanges','rc_ns_usertext','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_ns_usertext','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_this_oldid','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_this_oldid'),('my_wiki','recentchanges','rc_this_oldid','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_this_oldid,rc_id'),('my_wiki','recentchanges','rc_this_oldid','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_this_oldid','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_timestamp'),('my_wiki','recentchanges','rc_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_timestamp,rc_id'),('my_wiki','recentchanges','rc_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','recentchanges','rc_user_text','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rc_user_text'),('my_wiki','recentchanges','rc_user_text','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rc_user_text,rc_timestamp'),('my_wiki','recentchanges','rc_user_text','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rc_user_text,rc_timestamp,rc_id'),('my_wiki','recentchanges','rc_user_text','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','recentchanges','rc_user_text','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','redirect','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rd_from'),('my_wiki','redirect','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','redirect','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','redirect','rd_ns_title','2019-05-20 16:31:41','n_diff_pfx01',0,1,'rd_namespace'),('my_wiki','redirect','rd_ns_title','2019-05-20 16:31:41','n_diff_pfx02',0,1,'rd_namespace,rd_title'),('my_wiki','redirect','rd_ns_title','2019-05-20 16:31:41','n_diff_pfx03',0,1,'rd_namespace,rd_title,rd_from'),('my_wiki','redirect','rd_ns_title','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','redirect','rd_ns_title','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_id'),('my_wiki','revision','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','page_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_page'),('my_wiki','revision','page_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'rev_page,rev_timestamp'),('my_wiki','revision','page_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'rev_page,rev_timestamp,rev_id'),('my_wiki','revision','page_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','page_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','page_user_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_page'),('my_wiki','revision','page_user_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'rev_page,rev_user'),('my_wiki','revision','page_user_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'rev_page,rev_user,rev_timestamp'),('my_wiki','revision','page_user_timestamp','2019-05-20 16:31:40','n_diff_pfx04',0,1,'rev_page,rev_user,rev_timestamp,rev_id'),('my_wiki','revision','page_user_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','page_user_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','rev_page_id','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_page'),('my_wiki','revision','rev_page_id','2019-05-20 16:31:40','n_diff_pfx02',0,1,'rev_page,rev_id'),('my_wiki','revision','rev_page_id','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','rev_page_id','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','rev_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_timestamp'),('my_wiki','revision','rev_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'rev_timestamp,rev_id'),('my_wiki','revision','rev_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','rev_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','user_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_user'),('my_wiki','revision','user_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'rev_user,rev_timestamp'),('my_wiki','revision','user_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'rev_user,rev_timestamp,rev_id'),('my_wiki','revision','user_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','user_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision','usertext_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'rev_user_text'),('my_wiki','revision','usertext_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'rev_user_text,rev_timestamp'),('my_wiki','revision','usertext_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'rev_user_text,rev_timestamp,rev_id'),('my_wiki','revision','usertext_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision','usertext_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision_actor_temp','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'revactor_rev'),('my_wiki','revision_actor_temp','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'revactor_rev,revactor_actor'),('my_wiki','revision_actor_temp','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision_actor_temp','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision_actor_temp','actor_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'revactor_actor'),('my_wiki','revision_actor_temp','actor_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'revactor_actor,revactor_timestamp'),('my_wiki','revision_actor_temp','actor_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'revactor_actor,revactor_timestamp,revactor_rev'),('my_wiki','revision_actor_temp','actor_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision_actor_temp','actor_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision_actor_temp','page_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx01',0,1,'revactor_page'),('my_wiki','revision_actor_temp','page_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx02',0,1,'revactor_page,revactor_actor'),('my_wiki','revision_actor_temp','page_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx03',0,1,'revactor_page,revactor_actor,revactor_timestamp'),('my_wiki','revision_actor_temp','page_actor_timestamp','2019-05-20 16:31:40','n_diff_pfx04',0,1,'revactor_page,revactor_actor,revactor_timestamp,revactor_rev'),('my_wiki','revision_actor_temp','page_actor_timestamp','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision_actor_temp','page_actor_timestamp','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision_actor_temp','revactor_rev','2019-05-20 16:31:40','n_diff_pfx01',0,1,'revactor_rev'),('my_wiki','revision_actor_temp','revactor_rev','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision_actor_temp','revactor_rev','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision_comment_temp','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'revcomment_rev'),('my_wiki','revision_comment_temp','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'revcomment_rev,revcomment_comment_id'),('my_wiki','revision_comment_temp','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision_comment_temp','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','revision_comment_temp','revcomment_rev','2019-05-20 16:31:40','n_diff_pfx01',0,1,'revcomment_rev'),('my_wiki','revision_comment_temp','revcomment_rev','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','revision_comment_temp','revcomment_rev','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','site_identifiers','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'si_type'),('my_wiki','site_identifiers','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'si_type,si_key'),('my_wiki','site_identifiers','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','site_identifiers','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','site_identifiers','site_ids_key','2019-05-20 16:31:41','n_diff_pfx01',0,1,'si_key'),('my_wiki','site_identifiers','site_ids_key','2019-05-20 16:31:41','n_diff_pfx02',0,1,'si_key,si_type'),('my_wiki','site_identifiers','site_ids_key','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','site_identifiers','site_ids_key','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','site_identifiers','site_ids_site','2019-05-20 16:31:41','n_diff_pfx01',0,1,'si_site'),('my_wiki','site_identifiers','site_ids_site','2019-05-20 16:31:41','n_diff_pfx02',0,1,'si_site,si_type'),('my_wiki','site_identifiers','site_ids_site','2019-05-20 16:31:41','n_diff_pfx03',0,1,'si_site,si_type,si_key'),('my_wiki','site_identifiers','site_ids_site','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','site_identifiers','site_ids_site','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','site_stats','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ss_row_id'),('my_wiki','site_stats','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','site_stats','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_id'),('my_wiki','sites','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_domain','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_domain'),('my_wiki','sites','sites_domain','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_domain,site_id'),('my_wiki','sites','sites_domain','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_domain','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_forward','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_forward'),('my_wiki','sites','sites_forward','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_forward,site_id'),('my_wiki','sites','sites_forward','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_forward','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_global_key','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_global_key'),('my_wiki','sites','sites_global_key','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_global_key','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_group','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_group'),('my_wiki','sites','sites_group','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_group,site_id'),('my_wiki','sites','sites_group','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_group','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_language','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_language'),('my_wiki','sites','sites_language','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_language,site_id'),('my_wiki','sites','sites_language','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_language','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_protocol','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_protocol'),('my_wiki','sites','sites_protocol','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_protocol,site_id'),('my_wiki','sites','sites_protocol','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_protocol','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_source','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_source'),('my_wiki','sites','sites_source','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_source,site_id'),('my_wiki','sites','sites_source','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_source','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','sites','sites_type','2019-05-20 16:31:41','n_diff_pfx01',0,1,'site_type'),('my_wiki','sites','sites_type','2019-05-20 16:31:41','n_diff_pfx02',0,1,'site_type,site_id'),('my_wiki','sites','sites_type','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','sites','sites_type','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','slot_roles','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'role_id'),('my_wiki','slot_roles','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','slot_roles','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','slot_roles','role_name','2019-05-20 16:31:40','n_diff_pfx01',0,1,'role_name'),('my_wiki','slot_roles','role_name','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','slot_roles','role_name','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','slots','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'slot_revision_id'),('my_wiki','slots','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'slot_revision_id,slot_role_id'),('my_wiki','slots','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','slots','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','slots','slot_revision_origin_role','2019-05-20 16:31:40','n_diff_pfx01',0,1,'slot_revision_id'),('my_wiki','slots','slot_revision_origin_role','2019-05-20 16:31:40','n_diff_pfx02',0,1,'slot_revision_id,slot_origin'),('my_wiki','slots','slot_revision_origin_role','2019-05-20 16:31:40','n_diff_pfx03',0,1,'slot_revision_id,slot_origin,slot_role_id'),('my_wiki','slots','slot_revision_origin_role','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','slots','slot_revision_origin_role','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','tag_summary','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ts_id'),('my_wiki','tag_summary','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','tag_summary','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','tag_summary','tag_summary_log_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ts_log_id'),('my_wiki','tag_summary','tag_summary_log_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','tag_summary','tag_summary_log_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','tag_summary','tag_summary_rc_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ts_rc_id'),('my_wiki','tag_summary','tag_summary_rc_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','tag_summary','tag_summary_rc_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','tag_summary','tag_summary_rev_id','2019-05-20 16:31:41','n_diff_pfx01',0,1,'ts_rev_id'),('my_wiki','tag_summary','tag_summary_rev_id','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','tag_summary','tag_summary_rev_id','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','templatelinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'tl_from'),('my_wiki','templatelinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx02',0,1,'tl_from,tl_namespace'),('my_wiki','templatelinks','PRIMARY','2019-05-20 16:31:41','n_diff_pfx03',0,1,'tl_from,tl_namespace,tl_title'),('my_wiki','templatelinks','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','templatelinks','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','templatelinks','tl_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx01',0,1,'tl_from_namespace'),('my_wiki','templatelinks','tl_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx02',0,1,'tl_from_namespace,tl_namespace'),('my_wiki','templatelinks','tl_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx03',0,1,'tl_from_namespace,tl_namespace,tl_title'),('my_wiki','templatelinks','tl_backlinks_namespace','2019-05-20 16:31:41','n_diff_pfx04',0,1,'tl_from_namespace,tl_namespace,tl_title,tl_from'),('my_wiki','templatelinks','tl_backlinks_namespace','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','templatelinks','tl_backlinks_namespace','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','templatelinks','tl_namespace','2019-05-20 16:31:41','n_diff_pfx01',0,1,'tl_namespace'),('my_wiki','templatelinks','tl_namespace','2019-05-20 16:31:41','n_diff_pfx02',0,1,'tl_namespace,tl_title'),('my_wiki','templatelinks','tl_namespace','2019-05-20 16:31:41','n_diff_pfx03',0,1,'tl_namespace,tl_title,tl_from'),('my_wiki','templatelinks','tl_namespace','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','templatelinks','tl_namespace','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','text','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'old_id'),('my_wiki','text','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','text','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','updatelog','PRIMARY','2019-05-20 16:31:42','n_diff_pfx01',6,1,'ul_key'),('my_wiki','updatelog','PRIMARY','2019-05-20 16:31:42','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','updatelog','PRIMARY','2019-05-20 16:31:42','size',1,NULL,'Number of pages in the index'),('my_wiki','uploadstash','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'us_id'),('my_wiki','uploadstash','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','uploadstash','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','uploadstash','us_key','2019-05-20 16:31:41','n_diff_pfx01',0,1,'us_key'),('my_wiki','uploadstash','us_key','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','uploadstash','us_key','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','uploadstash','us_timestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'us_timestamp'),('my_wiki','uploadstash','us_timestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'us_timestamp,us_id'),('my_wiki','uploadstash','us_timestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','uploadstash','us_timestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','uploadstash','us_user','2019-05-20 16:31:41','n_diff_pfx01',0,1,'us_user'),('my_wiki','uploadstash','us_user','2019-05-20 16:31:41','n_diff_pfx02',0,1,'us_user,us_id'),('my_wiki','uploadstash','us_user','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','uploadstash','us_user','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','user','PRIMARY','2019-05-20 16:31:42','n_diff_pfx01',1,1,'user_id'),('my_wiki','user','PRIMARY','2019-05-20 16:31:42','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user','PRIMARY','2019-05-20 16:31:42','size',1,NULL,'Number of pages in the index'),('my_wiki','user','user_email','2019-05-20 16:31:42','n_diff_pfx01',1,1,'user_email'),('my_wiki','user','user_email','2019-05-20 16:31:42','n_diff_pfx02',1,1,'user_email,user_id'),('my_wiki','user','user_email','2019-05-20 16:31:42','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user','user_email','2019-05-20 16:31:42','size',1,NULL,'Number of pages in the index'),('my_wiki','user','user_email_token','2019-05-20 16:31:42','n_diff_pfx01',1,1,'user_email_token'),('my_wiki','user','user_email_token','2019-05-20 16:31:42','n_diff_pfx02',1,1,'user_email_token,user_id'),('my_wiki','user','user_email_token','2019-05-20 16:31:42','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user','user_email_token','2019-05-20 16:31:42','size',1,NULL,'Number of pages in the index'),('my_wiki','user','user_name','2019-05-20 16:31:42','n_diff_pfx01',1,1,'user_name'),('my_wiki','user','user_name','2019-05-20 16:31:42','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user','user_name','2019-05-20 16:31:42','size',1,NULL,'Number of pages in the index'),('my_wiki','user_former_groups','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'ufg_user'),('my_wiki','user_former_groups','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'ufg_user,ufg_group'),('my_wiki','user_former_groups','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_former_groups','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','user_groups','PRIMARY','2019-05-20 16:31:52','n_diff_pfx01',1,1,'ug_user'),('my_wiki','user_groups','PRIMARY','2019-05-20 16:31:52','n_diff_pfx02',3,1,'ug_user,ug_group'),('my_wiki','user_groups','PRIMARY','2019-05-20 16:31:52','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_groups','PRIMARY','2019-05-20 16:31:52','size',1,NULL,'Number of pages in the index'),('my_wiki','user_groups','ug_expiry','2019-05-20 16:31:52','n_diff_pfx01',1,1,'ug_expiry'),('my_wiki','user_groups','ug_expiry','2019-05-20 16:31:52','n_diff_pfx02',1,1,'ug_expiry,ug_user'),('my_wiki','user_groups','ug_expiry','2019-05-20 16:31:52','n_diff_pfx03',3,1,'ug_expiry,ug_user,ug_group'),('my_wiki','user_groups','ug_expiry','2019-05-20 16:31:52','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_groups','ug_expiry','2019-05-20 16:31:52','size',1,NULL,'Number of pages in the index'),('my_wiki','user_groups','ug_group','2019-05-20 16:31:52','n_diff_pfx01',3,1,'ug_group'),('my_wiki','user_groups','ug_group','2019-05-20 16:31:52','n_diff_pfx02',3,1,'ug_group,ug_user'),('my_wiki','user_groups','ug_group','2019-05-20 16:31:52','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_groups','ug_group','2019-05-20 16:31:52','size',1,NULL,'Number of pages in the index'),('my_wiki','user_newtalk','GEN_CLUST_INDEX','2019-05-20 16:31:40','n_diff_pfx01',0,1,'DB_ROW_ID'),('my_wiki','user_newtalk','GEN_CLUST_INDEX','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_newtalk','GEN_CLUST_INDEX','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','user_newtalk','un_user_id','2019-05-20 16:31:40','n_diff_pfx01',0,1,'user_id'),('my_wiki','user_newtalk','un_user_id','2019-05-20 16:31:40','n_diff_pfx02',0,1,'user_id,DB_ROW_ID'),('my_wiki','user_newtalk','un_user_id','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_newtalk','un_user_id','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','user_newtalk','un_user_ip','2019-05-20 16:31:40','n_diff_pfx01',0,1,'user_ip'),('my_wiki','user_newtalk','un_user_ip','2019-05-20 16:31:40','n_diff_pfx02',0,1,'user_ip,DB_ROW_ID'),('my_wiki','user_newtalk','un_user_ip','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_newtalk','un_user_ip','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','user_properties','PRIMARY','2019-05-20 16:31:40','n_diff_pfx01',0,1,'up_user'),('my_wiki','user_properties','PRIMARY','2019-05-20 16:31:40','n_diff_pfx02',0,1,'up_user,up_property'),('my_wiki','user_properties','PRIMARY','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_properties','PRIMARY','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','user_properties','user_properties_property','2019-05-20 16:31:40','n_diff_pfx01',0,1,'up_property'),('my_wiki','user_properties','user_properties_property','2019-05-20 16:31:40','n_diff_pfx02',0,1,'up_property,up_user'),('my_wiki','user_properties','user_properties_property','2019-05-20 16:31:40','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','user_properties','user_properties_property','2019-05-20 16:31:40','size',1,NULL,'Number of pages in the index'),('my_wiki','valid_tag','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'vt_tag'),('my_wiki','valid_tag','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','valid_tag','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','watchlist','PRIMARY','2019-05-20 16:31:41','n_diff_pfx01',0,1,'wl_id'),('my_wiki','watchlist','PRIMARY','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','watchlist','PRIMARY','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','watchlist','namespace_title','2019-05-20 16:31:41','n_diff_pfx01',0,1,'wl_namespace'),('my_wiki','watchlist','namespace_title','2019-05-20 16:31:41','n_diff_pfx02',0,1,'wl_namespace,wl_title'),('my_wiki','watchlist','namespace_title','2019-05-20 16:31:41','n_diff_pfx03',0,1,'wl_namespace,wl_title,wl_id'),('my_wiki','watchlist','namespace_title','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','watchlist','namespace_title','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','watchlist','wl_user','2019-05-20 16:31:41','n_diff_pfx01',0,1,'wl_user'),('my_wiki','watchlist','wl_user','2019-05-20 16:31:41','n_diff_pfx02',0,1,'wl_user,wl_namespace'),('my_wiki','watchlist','wl_user','2019-05-20 16:31:41','n_diff_pfx03',0,1,'wl_user,wl_namespace,wl_title'),('my_wiki','watchlist','wl_user','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','watchlist','wl_user','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('my_wiki','watchlist','wl_user_notificationtimestamp','2019-05-20 16:31:41','n_diff_pfx01',0,1,'wl_user'),('my_wiki','watchlist','wl_user_notificationtimestamp','2019-05-20 16:31:41','n_diff_pfx02',0,1,'wl_user,wl_notificationtimestamp'),('my_wiki','watchlist','wl_user_notificationtimestamp','2019-05-20 16:31:41','n_diff_pfx03',0,1,'wl_user,wl_notificationtimestamp,wl_id'),('my_wiki','watchlist','wl_user_notificationtimestamp','2019-05-20 16:31:41','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('my_wiki','watchlist','wl_user_notificationtimestamp','2019-05-20 16:31:41','size',1,NULL,'Number of pages in the index'),('mysql','gtid_slave_pos','PRIMARY','2019-05-20 16:27:20','n_diff_pfx01',0,1,'domain_id'),('mysql','gtid_slave_pos','PRIMARY','2019-05-20 16:27:20','n_diff_pfx02',0,1,'domain_id,sub_id'),('mysql','gtid_slave_pos','PRIMARY','2019-05-20 16:27:20','n_leaf_pages',1,NULL,'Number of leaf pages in the index'),('mysql','gtid_slave_pos','PRIMARY','2019-05-20 16:27:20','size',1,NULL,'Number of pages in the index');
/*!40000 ALTER TABLE `innodb_index_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `innodb_table_stats`
--

DROP TABLE IF EXISTS `innodb_table_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `innodb_table_stats` (
  `database_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(199) COLLATE utf8_bin NOT NULL,
  `last_update` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `n_rows` bigint(20) unsigned NOT NULL,
  `clustered_index_size` bigint(20) unsigned NOT NULL,
  `sum_of_other_index_sizes` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`database_name`,`table_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin STATS_PERSISTENT=0;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `innodb_table_stats`
--

LOCK TABLES `innodb_table_stats` WRITE;
/*!40000 ALTER TABLE `innodb_table_stats` DISABLE KEYS */;
INSERT INTO `innodb_table_stats` VALUES ('my_wiki','actor','2019-05-20 16:31:40',0,1,2),('my_wiki','archive','2019-05-20 16:31:40',0,1,4),('my_wiki','bot_passwords','2019-05-20 16:31:40',0,1,0),('my_wiki','category','2019-05-20 16:31:41',0,1,2),('my_wiki','categorylinks','2019-05-20 16:31:41',0,1,3),('my_wiki','change_tag','2019-05-20 16:31:41',0,1,8),('my_wiki','change_tag_def','2019-05-20 16:31:41',0,1,3),('my_wiki','comment','2019-05-20 16:31:40',0,1,1),('my_wiki','content','2019-05-20 16:31:40',0,1,0),('my_wiki','content_models','2019-05-20 16:31:40',0,1,1),('my_wiki','externallinks','2019-05-20 16:31:41',0,1,5),('my_wiki','filearchive','2019-05-20 16:31:41',0,1,6),('my_wiki','image','2019-05-20 16:31:41',0,1,7),('my_wiki','imagelinks','2019-05-20 16:31:41',0,1,2),('my_wiki','interwiki','2019-05-20 16:32:02',66,1,0),('my_wiki','ip_changes','2019-05-20 16:31:40',0,1,2),('my_wiki','ipblocks','2019-05-20 16:31:41',0,1,6),('my_wiki','ipblocks_restrictions','2019-05-20 16:31:41',0,1,1),('my_wiki','iwlinks','2019-05-20 16:31:41',0,1,2),('my_wiki','job','2019-05-20 16:31:41',0,1,5),('my_wiki','l10n_cache','2019-05-20 16:31:41',0,1,0),('my_wiki','langlinks','2019-05-20 16:31:41',0,1,1),('my_wiki','log_search','2019-05-20 16:31:41',0,1,1),('my_wiki','logging','2019-05-20 16:31:41',0,1,11),('my_wiki','module_deps','2019-05-20 16:31:41',0,1,0),('my_wiki','objectcache','2019-05-20 16:31:41',0,1,1),('my_wiki','oldimage','2019-05-20 16:31:41',0,1,5),('my_wiki','page','2019-05-20 16:32:12',1,1,4),('my_wiki','page_props','2019-05-20 16:31:41',0,1,2),('my_wiki','page_restrictions','2019-05-20 16:31:41',0,1,4),('my_wiki','pagelinks','2019-05-20 16:31:40',0,1,2),('my_wiki','protected_titles','2019-05-20 16:31:41',0,1,1),('my_wiki','querycache','2019-05-20 16:31:41',0,1,1),('my_wiki','querycache_info','2019-05-20 16:31:41',0,1,0),('my_wiki','querycachetwo','2019-05-20 16:31:41',0,1,3),('my_wiki','recentchanges','2019-05-20 16:31:41',0,1,11),('my_wiki','redirect','2019-05-20 16:31:41',0,1,1),('my_wiki','revision','2019-05-20 16:31:40',0,1,6),('my_wiki','revision_actor_temp','2019-05-20 16:31:40',0,1,3),('my_wiki','revision_comment_temp','2019-05-20 16:31:40',0,1,1),('my_wiki','site_identifiers','2019-05-20 16:31:41',0,1,2),('my_wiki','site_stats','2019-05-20 16:31:41',0,1,0),('my_wiki','sites','2019-05-20 16:31:41',0,1,8),('my_wiki','slot_roles','2019-05-20 16:31:40',0,1,1),('my_wiki','slots','2019-05-20 16:31:40',0,1,1),('my_wiki','tag_summary','2019-05-20 16:31:41',0,1,3),('my_wiki','templatelinks','2019-05-20 16:31:41',0,1,2),('my_wiki','text','2019-05-20 16:31:40',0,1,0),('my_wiki','updatelog','2019-05-20 16:31:42',6,1,0),('my_wiki','uploadstash','2019-05-20 16:31:41',0,1,3),('my_wiki','user','2019-05-20 16:31:42',1,1,3),('my_wiki','user_former_groups','2019-05-20 16:31:40',0,1,0),('my_wiki','user_groups','2019-05-20 16:31:52',3,1,2),('my_wiki','user_newtalk','2019-05-20 16:31:40',0,1,2),('my_wiki','user_properties','2019-05-20 16:31:40',0,1,1),('my_wiki','valid_tag','2019-05-20 16:31:41',0,1,0),('my_wiki','watchlist','2019-05-20 16:31:41',0,1,3),('mysql','gtid_slave_pos','2019-05-20 16:27:20',0,1,0);
/*!40000 ALTER TABLE `innodb_table_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plugin`
--

DROP TABLE IF EXISTS `plugin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plugin` (
  `name` varchar(64) NOT NULL DEFAULT '',
  `dl` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='MySQL plugins';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plugin`
--

LOCK TABLES `plugin` WRITE;
/*!40000 ALTER TABLE `plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `plugin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proc`
--

DROP TABLE IF EXISTS `proc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proc` (
  `db` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `name` char(64) NOT NULL DEFAULT '',
  `type` enum('FUNCTION','PROCEDURE','PACKAGE','PACKAGE BODY') NOT NULL,
  `specific_name` char(64) NOT NULL DEFAULT '',
  `language` enum('SQL') NOT NULL DEFAULT 'SQL',
  `sql_data_access` enum('CONTAINS_SQL','NO_SQL','READS_SQL_DATA','MODIFIES_SQL_DATA') NOT NULL DEFAULT 'CONTAINS_SQL',
  `is_deterministic` enum('YES','NO') NOT NULL DEFAULT 'NO',
  `security_type` enum('INVOKER','DEFINER') NOT NULL DEFAULT 'DEFINER',
  `param_list` blob NOT NULL,
  `returns` longblob NOT NULL,
  `body` longblob NOT NULL,
  `definer` char(141) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `created` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `sql_mode` set('REAL_AS_FLOAT','PIPES_AS_CONCAT','ANSI_QUOTES','IGNORE_SPACE','IGNORE_BAD_TABLE_OPTIONS','ONLY_FULL_GROUP_BY','NO_UNSIGNED_SUBTRACTION','NO_DIR_IN_CREATE','POSTGRESQL','ORACLE','MSSQL','DB2','MAXDB','NO_KEY_OPTIONS','NO_TABLE_OPTIONS','NO_FIELD_OPTIONS','MYSQL323','MYSQL40','ANSI','NO_AUTO_VALUE_ON_ZERO','NO_BACKSLASH_ESCAPES','STRICT_TRANS_TABLES','STRICT_ALL_TABLES','NO_ZERO_IN_DATE','NO_ZERO_DATE','INVALID_DATES','ERROR_FOR_DIVISION_BY_ZERO','TRADITIONAL','NO_AUTO_CREATE_USER','HIGH_NOT_PRECEDENCE','NO_ENGINE_SUBSTITUTION','PAD_CHAR_TO_FULL_LENGTH','EMPTY_STRING_IS_NULL','SIMULTANEOUS_ASSIGNMENT') NOT NULL DEFAULT '',
  `comment` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `character_set_client` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `collation_connection` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `db_collation` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `body_utf8` longblob DEFAULT NULL,
  `aggregate` enum('NONE','GROUP') NOT NULL DEFAULT 'NONE',
  PRIMARY KEY (`db`,`name`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stored Procedures';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proc`
--

LOCK TABLES `proc` WRITE;
/*!40000 ALTER TABLE `proc` DISABLE KEYS */;
INSERT INTO `proc` VALUES ('mysql','AddGeometryColumn','PROCEDURE','AddGeometryColumn','SQL','CONTAINS_SQL','NO','INVOKER','catalog varchar(64), t_schema varchar(64),\n   t_name varchar(64), geometry_column varchar(64), t_srid int','','begin\n  set @qwe= concat(\'ALTER TABLE \', t_schema, \'.\', t_name, \' ADD \', geometry_column,\' GEOMETRY REF_SYSTEM_ID=\', t_srid); PREPARE ls from @qwe; execute ls; deallocate prepare ls; end','root@localhost','2019-05-20 16:27:20','2019-05-20 16:27:20','','','utf8','utf8_general_ci','latin1_swedish_ci','begin\n  set @qwe= concat(\'ALTER TABLE \', t_schema, \'.\', t_name, \' ADD \', geometry_column,\' GEOMETRY REF_SYSTEM_ID=\', t_srid); PREPARE ls from @qwe; execute ls; deallocate prepare ls; end','NONE'),('mysql','DropGeometryColumn','PROCEDURE','DropGeometryColumn','SQL','CONTAINS_SQL','NO','INVOKER','catalog varchar(64), t_schema varchar(64),\n   t_name varchar(64), geometry_column varchar(64)','','begin\n  set @qwe= concat(\'ALTER TABLE \', t_schema, \'.\', t_name, \' DROP \', geometry_column); PREPARE ls from @qwe; execute ls; deallocate prepare ls; end','root@localhost','2019-05-20 16:27:20','2019-05-20 16:27:20','','','utf8','utf8_general_ci','latin1_swedish_ci','begin\n  set @qwe= concat(\'ALTER TABLE \', t_schema, \'.\', t_name, \' DROP \', geometry_column); PREPARE ls from @qwe; execute ls; deallocate prepare ls; end','NONE');
/*!40000 ALTER TABLE `proc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `procs_priv`
--

DROP TABLE IF EXISTS `procs_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `procs_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Routine_name` char(64) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Routine_type` enum('FUNCTION','PROCEDURE','PACKAGE','PACKAGE BODY') COLLATE utf8_bin NOT NULL,
  `Grantor` char(141) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proc_priv` set('Execute','Alter Routine','Grant') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`Host`,`Db`,`User`,`Routine_name`,`Routine_type`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Procedure privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `procs_priv`
--

LOCK TABLES `procs_priv` WRITE;
/*!40000 ALTER TABLE `procs_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `procs_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proxies_priv`
--

DROP TABLE IF EXISTS `proxies_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proxies_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proxied_host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proxied_user` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `With_grant` tinyint(1) NOT NULL DEFAULT 0,
  `Grantor` char(141) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`Host`,`User`,`Proxied_host`,`Proxied_user`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='User proxy privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proxies_priv`
--

LOCK TABLES `proxies_priv` WRITE;
/*!40000 ALTER TABLE `proxies_priv` DISABLE KEYS */;
INSERT INTO `proxies_priv` VALUES ('localhost','root','','',1,'','2019-05-20 16:27:20'),('94d06c619cb5','root','','',1,'','2019-05-20 16:27:20');
/*!40000 ALTER TABLE `proxies_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `roles_mapping`
--

DROP TABLE IF EXISTS `roles_mapping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `roles_mapping` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Role` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Admin_option` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  UNIQUE KEY `Host` (`Host`,`User`,`Role`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Granted roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `roles_mapping`
--

LOCK TABLES `roles_mapping` WRITE;
/*!40000 ALTER TABLE `roles_mapping` DISABLE KEYS */;
/*!40000 ALTER TABLE `roles_mapping` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `servers`
--

DROP TABLE IF EXISTS `servers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `servers` (
  `Server_name` char(64) NOT NULL DEFAULT '',
  `Host` char(64) NOT NULL DEFAULT '',
  `Db` char(64) NOT NULL DEFAULT '',
  `Username` char(80) NOT NULL DEFAULT '',
  `Password` char(64) NOT NULL DEFAULT '',
  `Port` int(4) NOT NULL DEFAULT 0,
  `Socket` char(64) NOT NULL DEFAULT '',
  `Wrapper` char(64) NOT NULL DEFAULT '',
  `Owner` char(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`Server_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='MySQL Foreign Servers table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `servers`
--

LOCK TABLES `servers` WRITE;
/*!40000 ALTER TABLE `servers` DISABLE KEYS */;
/*!40000 ALTER TABLE `servers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `table_stats`
--

DROP TABLE IF EXISTS `table_stats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `table_stats` (
  `db_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `table_name` varchar(64) COLLATE utf8_bin NOT NULL,
  `cardinality` bigint(21) unsigned DEFAULT NULL,
  PRIMARY KEY (`db_name`,`table_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Statistics on Tables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `table_stats`
--

LOCK TABLES `table_stats` WRITE;
/*!40000 ALTER TABLE `table_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `table_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tables_priv`
--

DROP TABLE IF EXISTS `tables_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tables_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Grantor` char(141) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `Table_priv` set('Select','Insert','Update','Delete','Create','Drop','Grant','References','Index','Alter','Create View','Show view','Trigger','Delete versioning rows') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`Db`,`User`,`Table_name`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Table privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tables_priv`
--

LOCK TABLES `tables_priv` WRITE;
/*!40000 ALTER TABLE `tables_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `tables_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone`
--

DROP TABLE IF EXISTS `time_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone` (
  `Time_zone_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `Use_leap_seconds` enum('Y','N') NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Time_zone_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1821 DEFAULT CHARSET=utf8 COMMENT='Time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone`
--

LOCK TABLES `time_zone` WRITE;
/*!40000 ALTER TABLE `time_zone` DISABLE KEYS */;
INSERT INTO `time_zone` VALUES (1,'N'),(2,'N'),(3,'N'),(4,'N'),(5,'N'),(6,'N'),(7,'N'),(8,'N'),(9,'N'),(10,'N'),(11,'N'),(12,'N'),(13,'N'),(14,'N'),(15,'N'),(16,'N'),(17,'N'),(18,'N'),(19,'N'),(20,'N'),(21,'N'),(22,'N'),(23,'N'),(24,'N'),(25,'N'),(26,'N'),(27,'N'),(28,'N'),(29,'N'),(30,'N'),(31,'N'),(32,'N'),(33,'N'),(34,'N'),(35,'N'),(36,'N'),(37,'N'),(38,'N'),(39,'N'),(40,'N'),(41,'N'),(42,'N'),(43,'N'),(44,'N'),(45,'N'),(46,'N'),(47,'N'),(48,'N'),(49,'N'),(50,'N'),(51,'N'),(52,'N'),(53,'N'),(54,'N'),(55,'N'),(56,'N'),(57,'N'),(58,'N'),(59,'N'),(60,'N'),(61,'N'),(62,'N'),(63,'N'),(64,'N'),(65,'N'),(66,'N'),(67,'N'),(68,'N'),(69,'N'),(70,'N'),(71,'N'),(72,'N'),(73,'N'),(74,'N'),(75,'N'),(76,'N'),(77,'N'),(78,'N'),(79,'N'),(80,'N'),(81,'N'),(82,'N'),(83,'N'),(84,'N'),(85,'N'),(86,'N'),(87,'N'),(88,'N'),(89,'N'),(90,'N'),(91,'N'),(92,'N'),(93,'N'),(94,'N'),(95,'N'),(96,'N'),(97,'N'),(98,'N'),(99,'N'),(100,'N'),(101,'N'),(102,'N'),(103,'N'),(104,'N'),(105,'N'),(106,'N'),(107,'N'),(108,'N'),(109,'N'),(110,'N'),(111,'N'),(112,'N'),(113,'N'),(114,'N'),(115,'N'),(116,'N'),(117,'N'),(118,'N'),(119,'N'),(120,'N'),(121,'N'),(122,'N'),(123,'N'),(124,'N'),(125,'N'),(126,'N'),(127,'N'),(128,'N'),(129,'N'),(130,'N'),(131,'N'),(132,'N'),(133,'N'),(134,'N'),(135,'N'),(136,'N'),(137,'N'),(138,'N'),(139,'N'),(140,'N'),(141,'N'),(142,'N'),(143,'N'),(144,'N'),(145,'N'),(146,'N'),(147,'N'),(148,'N'),(149,'N'),(150,'N'),(151,'N'),(152,'N'),(153,'N'),(154,'N'),(155,'N'),(156,'N'),(157,'N'),(158,'N'),(159,'N'),(160,'N'),(161,'N'),(162,'N'),(163,'N'),(164,'N'),(165,'N'),(166,'N'),(167,'N'),(168,'N'),(169,'N'),(170,'N'),(171,'N'),(172,'N'),(173,'N'),(174,'N'),(175,'N'),(176,'N'),(177,'N'),(178,'N'),(179,'N'),(180,'N'),(181,'N'),(182,'N'),(183,'N'),(184,'N'),(185,'N'),(186,'N'),(187,'N'),(188,'N'),(189,'N'),(190,'N'),(191,'N'),(192,'N'),(193,'N'),(194,'N'),(195,'N'),(196,'N'),(197,'N'),(198,'N'),(199,'N'),(200,'N'),(201,'N'),(202,'N'),(203,'N'),(204,'N'),(205,'N'),(206,'N'),(207,'N'),(208,'N'),(209,'N'),(210,'N'),(211,'N'),(212,'N'),(213,'N'),(214,'N'),(215,'N'),(216,'N'),(217,'N'),(218,'N'),(219,'N'),(220,'N'),(221,'N'),(222,'N'),(223,'N'),(224,'N'),(225,'N'),(226,'N'),(227,'N'),(228,'N'),(229,'N'),(230,'N'),(231,'N'),(232,'N'),(233,'N'),(234,'N'),(235,'N'),(236,'N'),(237,'N'),(238,'N'),(239,'N'),(240,'N'),(241,'N'),(242,'N'),(243,'N'),(244,'N'),(245,'N'),(246,'N'),(247,'N'),(248,'N'),(249,'N'),(250,'N'),(251,'N'),(252,'N'),(253,'N'),(254,'N'),(255,'N'),(256,'N'),(257,'N'),(258,'N'),(259,'N'),(260,'N'),(261,'N'),(262,'N'),(263,'N'),(264,'N'),(265,'N'),(266,'N'),(267,'N'),(268,'N'),(269,'N'),(270,'N'),(271,'N'),(272,'N'),(273,'N'),(274,'N'),(275,'N'),(276,'N'),(277,'N'),(278,'N'),(279,'N'),(280,'N'),(281,'N'),(282,'N'),(283,'N'),(284,'N'),(285,'N'),(286,'N'),(287,'N'),(288,'N'),(289,'N'),(290,'N'),(291,'N'),(292,'N'),(293,'N'),(294,'N'),(295,'N'),(296,'N'),(297,'N'),(298,'N'),(299,'N'),(300,'N'),(301,'N'),(302,'N'),(303,'N'),(304,'N'),(305,'N'),(306,'N'),(307,'N'),(308,'N'),(309,'N'),(310,'N'),(311,'N'),(312,'N'),(313,'N'),(314,'N'),(315,'N'),(316,'N'),(317,'N'),(318,'N'),(319,'N'),(320,'N'),(321,'N'),(322,'N'),(323,'N'),(324,'N'),(325,'N'),(326,'N'),(327,'N'),(328,'N'),(329,'N'),(330,'N'),(331,'N'),(332,'N'),(333,'N'),(334,'N'),(335,'N'),(336,'N'),(337,'N'),(338,'N'),(339,'N'),(340,'N'),(341,'N'),(342,'N'),(343,'N'),(344,'N'),(345,'N'),(346,'N'),(347,'N'),(348,'N'),(349,'N'),(350,'N'),(351,'N'),(352,'N'),(353,'N'),(354,'N'),(355,'N'),(356,'N'),(357,'N'),(358,'N'),(359,'N'),(360,'N'),(361,'N'),(362,'N'),(363,'N'),(364,'N'),(365,'N'),(366,'N'),(367,'N'),(368,'N'),(369,'N'),(370,'N'),(371,'N'),(372,'N'),(373,'N'),(374,'N'),(375,'N'),(376,'N'),(377,'N'),(378,'N'),(379,'N'),(380,'N'),(381,'N'),(382,'N'),(383,'N'),(384,'N'),(385,'N'),(386,'N'),(387,'N'),(388,'N'),(389,'N'),(390,'N'),(391,'N'),(392,'N'),(393,'N'),(394,'N'),(395,'N'),(396,'N'),(397,'N'),(398,'N'),(399,'N'),(400,'N'),(401,'N'),(402,'N'),(403,'N'),(404,'N'),(405,'N'),(406,'N'),(407,'N'),(408,'N'),(409,'N'),(410,'N'),(411,'N'),(412,'N'),(413,'N'),(414,'N'),(415,'N'),(416,'N'),(417,'N'),(418,'N'),(419,'N'),(420,'N'),(421,'N'),(422,'N'),(423,'N'),(424,'N'),(425,'N'),(426,'N'),(427,'N'),(428,'N'),(429,'N'),(430,'N'),(431,'N'),(432,'N'),(433,'N'),(434,'N'),(435,'N'),(436,'N'),(437,'N'),(438,'N'),(439,'N'),(440,'N'),(441,'N'),(442,'N'),(443,'N'),(444,'N'),(445,'N'),(446,'N'),(447,'N'),(448,'N'),(449,'N'),(450,'N'),(451,'N'),(452,'N'),(453,'N'),(454,'N'),(455,'N'),(456,'N'),(457,'N'),(458,'N'),(459,'N'),(460,'N'),(461,'N'),(462,'N'),(463,'N'),(464,'N'),(465,'N'),(466,'N'),(467,'N'),(468,'N'),(469,'N'),(470,'N'),(471,'N'),(472,'N'),(473,'N'),(474,'N'),(475,'N'),(476,'N'),(477,'N'),(478,'N'),(479,'N'),(480,'N'),(481,'N'),(482,'N'),(483,'N'),(484,'N'),(485,'N'),(486,'N'),(487,'N'),(488,'N'),(489,'N'),(490,'N'),(491,'N'),(492,'N'),(493,'N'),(494,'N'),(495,'N'),(496,'N'),(497,'N'),(498,'N'),(499,'N'),(500,'N'),(501,'N'),(502,'N'),(503,'N'),(504,'N'),(505,'N'),(506,'N'),(507,'N'),(508,'N'),(509,'N'),(510,'N'),(511,'N'),(512,'N'),(513,'N'),(514,'N'),(515,'N'),(516,'N'),(517,'N'),(518,'N'),(519,'N'),(520,'N'),(521,'N'),(522,'N'),(523,'N'),(524,'N'),(525,'N'),(526,'N'),(527,'N'),(528,'N'),(529,'N'),(530,'N'),(531,'N'),(532,'N'),(533,'N'),(534,'N'),(535,'N'),(536,'N'),(537,'N'),(538,'N'),(539,'N'),(540,'N'),(541,'N'),(542,'N'),(543,'N'),(544,'N'),(545,'N'),(546,'N'),(547,'N'),(548,'N'),(549,'N'),(550,'N'),(551,'N'),(552,'N'),(553,'N'),(554,'N'),(555,'N'),(556,'N'),(557,'N'),(558,'N'),(559,'N'),(560,'N'),(561,'N'),(562,'N'),(563,'N'),(564,'N'),(565,'N'),(566,'N'),(567,'N'),(568,'N'),(569,'N'),(570,'N'),(571,'N'),(572,'N'),(573,'N'),(574,'N'),(575,'N'),(576,'N'),(577,'N'),(578,'N'),(579,'N'),(580,'N'),(581,'N'),(582,'N'),(583,'N'),(584,'N'),(585,'N'),(586,'N'),(587,'N'),(588,'N'),(589,'N'),(590,'N'),(591,'N'),(592,'N'),(593,'N'),(594,'N'),(595,'N'),(596,'N'),(597,'N'),(598,'N'),(599,'N'),(600,'N'),(601,'N'),(602,'N'),(603,'N'),(604,'N'),(605,'N'),(606,'N'),(607,'N'),(608,'N'),(609,'N'),(610,'N'),(611,'N'),(612,'N'),(613,'N'),(614,'N'),(615,'N'),(616,'N'),(617,'N'),(618,'N'),(619,'N'),(620,'N'),(621,'N'),(622,'N'),(623,'N'),(624,'N'),(625,'N'),(626,'N'),(627,'N'),(628,'N'),(629,'N'),(630,'N'),(631,'N'),(632,'N'),(633,'N'),(634,'N'),(635,'N'),(636,'N'),(637,'N'),(638,'N'),(639,'N'),(640,'N'),(641,'N'),(642,'N'),(643,'N'),(644,'N'),(645,'N'),(646,'N'),(647,'N'),(648,'N'),(649,'N'),(650,'N'),(651,'N'),(652,'N'),(653,'N'),(654,'N'),(655,'N'),(656,'N'),(657,'N'),(658,'N'),(659,'N'),(660,'N'),(661,'N'),(662,'N'),(663,'N'),(664,'N'),(665,'N'),(666,'N'),(667,'N'),(668,'N'),(669,'N'),(670,'N'),(671,'N'),(672,'N'),(673,'N'),(674,'N'),(675,'N'),(676,'N'),(677,'N'),(678,'N'),(679,'N'),(680,'N'),(681,'N'),(682,'N'),(683,'N'),(684,'N'),(685,'N'),(686,'N'),(687,'N'),(688,'N'),(689,'N'),(690,'N'),(691,'N'),(692,'N'),(693,'N'),(694,'N'),(695,'N'),(696,'N'),(697,'N'),(698,'N'),(699,'N'),(700,'N'),(701,'N'),(702,'N'),(703,'N'),(704,'N'),(705,'N'),(706,'N'),(707,'N'),(708,'N'),(709,'N'),(710,'N'),(711,'N'),(712,'N'),(713,'N'),(714,'N'),(715,'N'),(716,'N'),(717,'N'),(718,'N'),(719,'N'),(720,'N'),(721,'N'),(722,'N'),(723,'N'),(724,'N'),(725,'N'),(726,'N'),(727,'N'),(728,'N'),(729,'N'),(730,'N'),(731,'N'),(732,'N'),(733,'N'),(734,'N'),(735,'N'),(736,'N'),(737,'N'),(738,'N'),(739,'N'),(740,'N'),(741,'N'),(742,'N'),(743,'N'),(744,'N'),(745,'N'),(746,'N'),(747,'N'),(748,'N'),(749,'N'),(750,'N'),(751,'N'),(752,'N'),(753,'N'),(754,'N'),(755,'N'),(756,'N'),(757,'N'),(758,'N'),(759,'N'),(760,'N'),(761,'N'),(762,'N'),(763,'N'),(764,'N'),(765,'N'),(766,'N'),(767,'N'),(768,'N'),(769,'N'),(770,'N'),(771,'N'),(772,'N'),(773,'N'),(774,'N'),(775,'N'),(776,'N'),(777,'N'),(778,'N'),(779,'N'),(780,'N'),(781,'N'),(782,'N'),(783,'N'),(784,'N'),(785,'N'),(786,'N'),(787,'N'),(788,'N'),(789,'N'),(790,'N'),(791,'N'),(792,'N'),(793,'N'),(794,'N'),(795,'N'),(796,'N'),(797,'N'),(798,'N'),(799,'N'),(800,'N'),(801,'N'),(802,'N'),(803,'N'),(804,'N'),(805,'N'),(806,'N'),(807,'N'),(808,'N'),(809,'N'),(810,'N'),(811,'N'),(812,'N'),(813,'N'),(814,'N'),(815,'N'),(816,'N'),(817,'N'),(818,'N'),(819,'N'),(820,'N'),(821,'N'),(822,'N'),(823,'N'),(824,'N'),(825,'N'),(826,'N'),(827,'N'),(828,'N'),(829,'N'),(830,'N'),(831,'N'),(832,'N'),(833,'N'),(834,'N'),(835,'N'),(836,'N'),(837,'N'),(838,'N'),(839,'N'),(840,'N'),(841,'N'),(842,'N'),(843,'N'),(844,'N'),(845,'N'),(846,'N'),(847,'N'),(848,'N'),(849,'N'),(850,'N'),(851,'N'),(852,'N'),(853,'N'),(854,'N'),(855,'N'),(856,'N'),(857,'N'),(858,'N'),(859,'N'),(860,'N'),(861,'N'),(862,'N'),(863,'N'),(864,'N'),(865,'N'),(866,'N'),(867,'N'),(868,'N'),(869,'N'),(870,'N'),(871,'N'),(872,'N'),(873,'N'),(874,'N'),(875,'N'),(876,'N'),(877,'N'),(878,'N'),(879,'N'),(880,'N'),(881,'N'),(882,'N'),(883,'N'),(884,'N'),(885,'N'),(886,'N'),(887,'N'),(888,'N'),(889,'N'),(890,'N'),(891,'N'),(892,'N'),(893,'N'),(894,'N'),(895,'N'),(896,'N'),(897,'N'),(898,'N'),(899,'N'),(900,'N'),(901,'N'),(902,'N'),(903,'N'),(904,'N'),(905,'N'),(906,'N'),(907,'N'),(908,'N'),(909,'N'),(910,'N'),(911,'N'),(912,'N'),(913,'N'),(914,'N'),(915,'N'),(916,'N'),(917,'N'),(918,'N'),(919,'N'),(920,'N'),(921,'N'),(922,'N'),(923,'N'),(924,'N'),(925,'N'),(926,'N'),(927,'N'),(928,'N'),(929,'N'),(930,'N'),(931,'N'),(932,'N'),(933,'N'),(934,'N'),(935,'N'),(936,'N'),(937,'N'),(938,'N'),(939,'N'),(940,'N'),(941,'N'),(942,'N'),(943,'N'),(944,'N'),(945,'N'),(946,'N'),(947,'N'),(948,'N'),(949,'N'),(950,'N'),(951,'N'),(952,'N'),(953,'N'),(954,'N'),(955,'N'),(956,'N'),(957,'N'),(958,'N'),(959,'N'),(960,'N'),(961,'N'),(962,'N'),(963,'N'),(964,'N'),(965,'N'),(966,'N'),(967,'N'),(968,'N'),(969,'N'),(970,'N'),(971,'N'),(972,'N'),(973,'N'),(974,'N'),(975,'N'),(976,'N'),(977,'N'),(978,'N'),(979,'N'),(980,'N'),(981,'N'),(982,'N'),(983,'N'),(984,'N'),(985,'N'),(986,'N'),(987,'N'),(988,'N'),(989,'N'),(990,'N'),(991,'N'),(992,'N'),(993,'N'),(994,'N'),(995,'N'),(996,'N'),(997,'N'),(998,'N'),(999,'N'),(1000,'N'),(1001,'N'),(1002,'N'),(1003,'N'),(1004,'N'),(1005,'N'),(1006,'N'),(1007,'N'),(1008,'N'),(1009,'N'),(1010,'N'),(1011,'N'),(1012,'N'),(1013,'N'),(1014,'N'),(1015,'N'),(1016,'N'),(1017,'N'),(1018,'N'),(1019,'N'),(1020,'N'),(1021,'N'),(1022,'N'),(1023,'N'),(1024,'N'),(1025,'N'),(1026,'N'),(1027,'N'),(1028,'N'),(1029,'N'),(1030,'N'),(1031,'N'),(1032,'N'),(1033,'N'),(1034,'N'),(1035,'N'),(1036,'N'),(1037,'N'),(1038,'N'),(1039,'N'),(1040,'N'),(1041,'N'),(1042,'N'),(1043,'N'),(1044,'N'),(1045,'N'),(1046,'N'),(1047,'N'),(1048,'N'),(1049,'N'),(1050,'N'),(1051,'N'),(1052,'N'),(1053,'N'),(1054,'N'),(1055,'N'),(1056,'N'),(1057,'N'),(1058,'N'),(1059,'N'),(1060,'N'),(1061,'N'),(1062,'N'),(1063,'N'),(1064,'N'),(1065,'N'),(1066,'N'),(1067,'N'),(1068,'N'),(1069,'N'),(1070,'N'),(1071,'N'),(1072,'N'),(1073,'N'),(1074,'N'),(1075,'N'),(1076,'N'),(1077,'N'),(1078,'N'),(1079,'N'),(1080,'N'),(1081,'N'),(1082,'N'),(1083,'N'),(1084,'N'),(1085,'N'),(1086,'N'),(1087,'N'),(1088,'N'),(1089,'N'),(1090,'N'),(1091,'N'),(1092,'N'),(1093,'N'),(1094,'N'),(1095,'N'),(1096,'N'),(1097,'N'),(1098,'N'),(1099,'N'),(1100,'N'),(1101,'N'),(1102,'N'),(1103,'N'),(1104,'N'),(1105,'N'),(1106,'N'),(1107,'N'),(1108,'N'),(1109,'N'),(1110,'N'),(1111,'N'),(1112,'N'),(1113,'N'),(1114,'N'),(1115,'N'),(1116,'N'),(1117,'N'),(1118,'N'),(1119,'N'),(1120,'N'),(1121,'N'),(1122,'N'),(1123,'N'),(1124,'N'),(1125,'N'),(1126,'N'),(1127,'N'),(1128,'N'),(1129,'N'),(1130,'N'),(1131,'N'),(1132,'N'),(1133,'N'),(1134,'N'),(1135,'N'),(1136,'N'),(1137,'N'),(1138,'N'),(1139,'N'),(1140,'N'),(1141,'N'),(1142,'N'),(1143,'N'),(1144,'N'),(1145,'N'),(1146,'N'),(1147,'N'),(1148,'N'),(1149,'N'),(1150,'N'),(1151,'N'),(1152,'N'),(1153,'N'),(1154,'N'),(1155,'N'),(1156,'N'),(1157,'N'),(1158,'N'),(1159,'N'),(1160,'N'),(1161,'N'),(1162,'N'),(1163,'N'),(1164,'N'),(1165,'N'),(1166,'N'),(1167,'N'),(1168,'N'),(1169,'N'),(1170,'N'),(1171,'N'),(1172,'N'),(1173,'N'),(1174,'N'),(1175,'N'),(1176,'N'),(1177,'N'),(1178,'N'),(1179,'N'),(1180,'N'),(1181,'N'),(1182,'N'),(1183,'N'),(1184,'N'),(1185,'N'),(1186,'N'),(1187,'N'),(1188,'N'),(1189,'N'),(1190,'N'),(1191,'N'),(1192,'N'),(1193,'N'),(1194,'N'),(1195,'N'),(1196,'N'),(1197,'N'),(1198,'N'),(1199,'N'),(1200,'N'),(1201,'N'),(1202,'N'),(1203,'N'),(1204,'N'),(1205,'N'),(1206,'N'),(1207,'N'),(1208,'N'),(1209,'N'),(1210,'N'),(1211,'N'),(1212,'N'),(1213,'N'),(1214,'N'),(1215,'Y'),(1216,'Y'),(1217,'Y'),(1218,'Y'),(1219,'Y'),(1220,'Y'),(1221,'Y'),(1222,'Y'),(1223,'Y'),(1224,'Y'),(1225,'Y'),(1226,'Y'),(1227,'Y'),(1228,'Y'),(1229,'Y'),(1230,'Y'),(1231,'Y'),(1232,'Y'),(1233,'Y'),(1234,'Y'),(1235,'Y'),(1236,'Y'),(1237,'Y'),(1238,'Y'),(1239,'Y'),(1240,'Y'),(1241,'Y'),(1242,'Y'),(1243,'Y'),(1244,'Y'),(1245,'Y'),(1246,'Y'),(1247,'Y'),(1248,'Y'),(1249,'Y'),(1250,'Y'),(1251,'Y'),(1252,'Y'),(1253,'Y'),(1254,'Y'),(1255,'Y'),(1256,'Y'),(1257,'Y'),(1258,'Y'),(1259,'Y'),(1260,'Y'),(1261,'Y'),(1262,'Y'),(1263,'Y'),(1264,'Y'),(1265,'Y'),(1266,'Y'),(1267,'Y'),(1268,'Y'),(1269,'Y'),(1270,'Y'),(1271,'Y'),(1272,'Y'),(1273,'Y'),(1274,'Y'),(1275,'Y'),(1276,'Y'),(1277,'Y'),(1278,'Y'),(1279,'Y'),(1280,'Y'),(1281,'Y'),(1282,'Y'),(1283,'Y'),(1284,'Y'),(1285,'Y'),(1286,'Y'),(1287,'Y'),(1288,'Y'),(1289,'Y'),(1290,'Y'),(1291,'Y'),(1292,'Y'),(1293,'Y'),(1294,'Y'),(1295,'Y'),(1296,'Y'),(1297,'Y'),(1298,'Y'),(1299,'Y'),(1300,'Y'),(1301,'Y'),(1302,'Y'),(1303,'Y'),(1304,'Y'),(1305,'Y'),(1306,'Y'),(1307,'Y'),(1308,'Y'),(1309,'Y'),(1310,'Y'),(1311,'Y'),(1312,'Y'),(1313,'Y'),(1314,'Y'),(1315,'Y'),(1316,'Y'),(1317,'Y'),(1318,'Y'),(1319,'Y'),(1320,'Y'),(1321,'Y'),(1322,'Y'),(1323,'Y'),(1324,'Y'),(1325,'Y'),(1326,'Y'),(1327,'Y'),(1328,'Y'),(1329,'Y'),(1330,'Y'),(1331,'Y'),(1332,'Y'),(1333,'Y'),(1334,'Y'),(1335,'Y'),(1336,'Y'),(1337,'Y'),(1338,'Y'),(1339,'Y'),(1340,'Y'),(1341,'Y'),(1342,'Y'),(1343,'Y'),(1344,'Y'),(1345,'Y'),(1346,'Y'),(1347,'Y'),(1348,'Y'),(1349,'Y'),(1350,'Y'),(1351,'Y'),(1352,'Y'),(1353,'Y'),(1354,'Y'),(1355,'Y'),(1356,'Y'),(1357,'Y'),(1358,'Y'),(1359,'Y'),(1360,'Y'),(1361,'Y'),(1362,'Y'),(1363,'Y'),(1364,'Y'),(1365,'Y'),(1366,'Y'),(1367,'Y'),(1368,'Y'),(1369,'Y'),(1370,'Y'),(1371,'Y'),(1372,'Y'),(1373,'Y'),(1374,'Y'),(1375,'Y'),(1376,'Y'),(1377,'Y'),(1378,'Y'),(1379,'Y'),(1380,'Y'),(1381,'Y'),(1382,'Y'),(1383,'Y'),(1384,'Y'),(1385,'Y'),(1386,'Y'),(1387,'Y'),(1388,'Y'),(1389,'Y'),(1390,'Y'),(1391,'Y'),(1392,'Y'),(1393,'Y'),(1394,'Y'),(1395,'Y'),(1396,'Y'),(1397,'Y'),(1398,'Y'),(1399,'Y'),(1400,'Y'),(1401,'Y'),(1402,'Y'),(1403,'Y'),(1404,'Y'),(1405,'Y'),(1406,'Y'),(1407,'Y'),(1408,'Y'),(1409,'Y'),(1410,'Y'),(1411,'Y'),(1412,'Y'),(1413,'Y'),(1414,'Y'),(1415,'Y'),(1416,'Y'),(1417,'Y'),(1418,'Y'),(1419,'Y'),(1420,'Y'),(1421,'Y'),(1422,'Y'),(1423,'Y'),(1424,'Y'),(1425,'Y'),(1426,'Y'),(1427,'Y'),(1428,'Y'),(1429,'Y'),(1430,'Y'),(1431,'Y'),(1432,'Y'),(1433,'Y'),(1434,'Y'),(1435,'Y'),(1436,'Y'),(1437,'Y'),(1438,'Y'),(1439,'Y'),(1440,'Y'),(1441,'Y'),(1442,'Y'),(1443,'Y'),(1444,'Y'),(1445,'Y'),(1446,'Y'),(1447,'Y'),(1448,'Y'),(1449,'Y'),(1450,'Y'),(1451,'Y'),(1452,'Y'),(1453,'Y'),(1454,'Y'),(1455,'Y'),(1456,'Y'),(1457,'Y'),(1458,'Y'),(1459,'Y'),(1460,'Y'),(1461,'Y'),(1462,'Y'),(1463,'Y'),(1464,'Y'),(1465,'Y'),(1466,'Y'),(1467,'Y'),(1468,'Y'),(1469,'Y'),(1470,'Y'),(1471,'Y'),(1472,'Y'),(1473,'Y'),(1474,'Y'),(1475,'Y'),(1476,'Y'),(1477,'Y'),(1478,'Y'),(1479,'Y'),(1480,'Y'),(1481,'Y'),(1482,'Y'),(1483,'Y'),(1484,'Y'),(1485,'Y'),(1486,'Y'),(1487,'Y'),(1488,'Y'),(1489,'Y'),(1490,'Y'),(1491,'Y'),(1492,'Y'),(1493,'Y'),(1494,'Y'),(1495,'Y'),(1496,'Y'),(1497,'Y'),(1498,'Y'),(1499,'Y'),(1500,'Y'),(1501,'Y'),(1502,'Y'),(1503,'Y'),(1504,'Y'),(1505,'Y'),(1506,'Y'),(1507,'Y'),(1508,'Y'),(1509,'Y'),(1510,'Y'),(1511,'Y'),(1512,'Y'),(1513,'Y'),(1514,'Y'),(1515,'Y'),(1516,'Y'),(1517,'Y'),(1518,'Y'),(1519,'Y'),(1520,'Y'),(1521,'Y'),(1522,'Y'),(1523,'Y'),(1524,'Y'),(1525,'Y'),(1526,'Y'),(1527,'Y'),(1528,'Y'),(1529,'Y'),(1530,'Y'),(1531,'Y'),(1532,'Y'),(1533,'Y'),(1534,'Y'),(1535,'Y'),(1536,'Y'),(1537,'Y'),(1538,'Y'),(1539,'Y'),(1540,'Y'),(1541,'Y'),(1542,'Y'),(1543,'Y'),(1544,'Y'),(1545,'Y'),(1546,'Y'),(1547,'Y'),(1548,'Y'),(1549,'Y'),(1550,'Y'),(1551,'Y'),(1552,'Y'),(1553,'Y'),(1554,'Y'),(1555,'Y'),(1556,'Y'),(1557,'Y'),(1558,'Y'),(1559,'Y'),(1560,'Y'),(1561,'Y'),(1562,'Y'),(1563,'Y'),(1564,'Y'),(1565,'Y'),(1566,'Y'),(1567,'Y'),(1568,'Y'),(1569,'Y'),(1570,'Y'),(1571,'Y'),(1572,'Y'),(1573,'Y'),(1574,'Y'),(1575,'Y'),(1576,'Y'),(1577,'Y'),(1578,'Y'),(1579,'Y'),(1580,'Y'),(1581,'Y'),(1582,'Y'),(1583,'Y'),(1584,'Y'),(1585,'Y'),(1586,'Y'),(1587,'Y'),(1588,'Y'),(1589,'Y'),(1590,'Y'),(1591,'Y'),(1592,'Y'),(1593,'Y'),(1594,'Y'),(1595,'Y'),(1596,'Y'),(1597,'Y'),(1598,'Y'),(1599,'Y'),(1600,'Y'),(1601,'Y'),(1602,'Y'),(1603,'Y'),(1604,'Y'),(1605,'Y'),(1606,'Y'),(1607,'Y'),(1608,'Y'),(1609,'Y'),(1610,'Y'),(1611,'Y'),(1612,'Y'),(1613,'Y'),(1614,'Y'),(1615,'Y'),(1616,'Y'),(1617,'Y'),(1618,'Y'),(1619,'Y'),(1620,'Y'),(1621,'Y'),(1622,'Y'),(1623,'Y'),(1624,'Y'),(1625,'Y'),(1626,'Y'),(1627,'Y'),(1628,'Y'),(1629,'Y'),(1630,'Y'),(1631,'Y'),(1632,'Y'),(1633,'Y'),(1634,'Y'),(1635,'Y'),(1636,'Y'),(1637,'Y'),(1638,'Y'),(1639,'Y'),(1640,'Y'),(1641,'Y'),(1642,'Y'),(1643,'Y'),(1644,'Y'),(1645,'Y'),(1646,'Y'),(1647,'Y'),(1648,'Y'),(1649,'Y'),(1650,'Y'),(1651,'Y'),(1652,'Y'),(1653,'Y'),(1654,'Y'),(1655,'Y'),(1656,'Y'),(1657,'Y'),(1658,'Y'),(1659,'Y'),(1660,'Y'),(1661,'Y'),(1662,'Y'),(1663,'Y'),(1664,'Y'),(1665,'Y'),(1666,'Y'),(1667,'Y'),(1668,'Y'),(1669,'Y'),(1670,'Y'),(1671,'Y'),(1672,'Y'),(1673,'Y'),(1674,'Y'),(1675,'Y'),(1676,'Y'),(1677,'Y'),(1678,'Y'),(1679,'Y'),(1680,'Y'),(1681,'Y'),(1682,'Y'),(1683,'Y'),(1684,'Y'),(1685,'Y'),(1686,'Y'),(1687,'Y'),(1688,'Y'),(1689,'Y'),(1690,'Y'),(1691,'Y'),(1692,'Y'),(1693,'Y'),(1694,'Y'),(1695,'Y'),(1696,'Y'),(1697,'Y'),(1698,'Y'),(1699,'Y'),(1700,'Y'),(1701,'Y'),(1702,'Y'),(1703,'Y'),(1704,'Y'),(1705,'Y'),(1706,'Y'),(1707,'Y'),(1708,'Y'),(1709,'Y'),(1710,'Y'),(1711,'Y'),(1712,'Y'),(1713,'Y'),(1714,'Y'),(1715,'Y'),(1716,'Y'),(1717,'Y'),(1718,'Y'),(1719,'Y'),(1720,'Y'),(1721,'Y'),(1722,'Y'),(1723,'Y'),(1724,'Y'),(1725,'Y'),(1726,'Y'),(1727,'Y'),(1728,'Y'),(1729,'Y'),(1730,'Y'),(1731,'Y'),(1732,'Y'),(1733,'Y'),(1734,'Y'),(1735,'Y'),(1736,'Y'),(1737,'Y'),(1738,'Y'),(1739,'Y'),(1740,'Y'),(1741,'Y'),(1742,'Y'),(1743,'Y'),(1744,'Y'),(1745,'Y'),(1746,'Y'),(1747,'Y'),(1748,'Y'),(1749,'Y'),(1750,'Y'),(1751,'Y'),(1752,'Y'),(1753,'Y'),(1754,'Y'),(1755,'Y'),(1756,'Y'),(1757,'Y'),(1758,'Y'),(1759,'Y'),(1760,'Y'),(1761,'Y'),(1762,'Y'),(1763,'Y'),(1764,'Y'),(1765,'Y'),(1766,'Y'),(1767,'Y'),(1768,'Y'),(1769,'Y'),(1770,'Y'),(1771,'Y'),(1772,'Y'),(1773,'Y'),(1774,'Y'),(1775,'Y'),(1776,'Y'),(1777,'Y'),(1778,'Y'),(1779,'Y'),(1780,'Y'),(1781,'Y'),(1782,'Y'),(1783,'Y'),(1784,'Y'),(1785,'Y'),(1786,'Y'),(1787,'Y'),(1788,'Y'),(1789,'Y'),(1790,'Y'),(1791,'Y'),(1792,'Y'),(1793,'Y'),(1794,'Y'),(1795,'Y'),(1796,'Y'),(1797,'Y'),(1798,'Y'),(1799,'Y'),(1800,'Y'),(1801,'Y'),(1802,'Y'),(1803,'Y'),(1804,'Y'),(1805,'Y'),(1806,'Y'),(1807,'Y'),(1808,'Y'),(1809,'Y'),(1810,'Y'),(1811,'Y'),(1812,'Y'),(1813,'Y'),(1814,'Y'),(1815,'Y'),(1816,'Y'),(1817,'Y'),(1818,'Y'),(1819,'Y'),(1820,'Y');
/*!40000 ALTER TABLE `time_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_leap_second`
--

DROP TABLE IF EXISTS `time_zone_leap_second`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_leap_second` (
  `Transition_time` bigint(20) NOT NULL,
  `Correction` int(11) NOT NULL,
  PRIMARY KEY (`Transition_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Leap seconds information for time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_leap_second`
--

LOCK TABLES `time_zone_leap_second` WRITE;
/*!40000 ALTER TABLE `time_zone_leap_second` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_leap_second` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_name`
--

DROP TABLE IF EXISTS `time_zone_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_name` (
  `Name` char(64) NOT NULL,
  `Time_zone_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone names';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_name`
--

LOCK TABLES `time_zone_name` WRITE;
/*!40000 ALTER TABLE `time_zone_name` DISABLE KEYS */;
INSERT INTO `time_zone_name` VALUES ('Africa/Abidjan',1),('Africa/Accra',2),('Africa/Addis_Ababa',3),('Africa/Algiers',4),('Africa/Asmara',5),('Africa/Asmera',6),('Africa/Bamako',7),('Africa/Bangui',8),('Africa/Banjul',9),('Africa/Bissau',10),('Africa/Blantyre',11),('Africa/Brazzaville',12),('Africa/Bujumbura',13),('Africa/Cairo',14),('Africa/Casablanca',15),('Africa/Ceuta',16),('Africa/Conakry',17),('Africa/Dakar',18),('Africa/Dar_es_Salaam',19),('Africa/Djibouti',20),('Africa/Douala',21),('Africa/El_Aaiun',22),('Africa/Freetown',23),('Africa/Gaborone',24),('Africa/Harare',25),('Africa/Johannesburg',26),('Africa/Juba',27),('Africa/Kampala',28),('Africa/Khartoum',29),('Africa/Kigali',30),('Africa/Kinshasa',31),('Africa/Lagos',32),('Africa/Libreville',33),('Africa/Lome',34),('Africa/Luanda',35),('Africa/Lubumbashi',36),('Africa/Lusaka',37),('Africa/Malabo',38),('Africa/Maputo',39),('Africa/Maseru',40),('Africa/Mbabane',41),('Africa/Mogadishu',42),('Africa/Monrovia',43),('Africa/Nairobi',44),('Africa/Ndjamena',45),('Africa/Niamey',46),('Africa/Nouakchott',47),('Africa/Ouagadougou',48),('Africa/Porto-Novo',49),('Africa/Sao_Tome',50),('Africa/Timbuktu',51),('Africa/Tripoli',52),('Africa/Tunis',53),('Africa/Windhoek',54),('America/Adak',55),('America/Anchorage',56),('America/Anguilla',57),('America/Antigua',58),('America/Araguaina',59),('America/Argentina/Buenos_Aires',60),('America/Argentina/Catamarca',61),('America/Argentina/ComodRivadavia',62),('America/Argentina/Cordoba',63),('America/Argentina/Jujuy',64),('America/Argentina/La_Rioja',65),('America/Argentina/Mendoza',66),('America/Argentina/Rio_Gallegos',67),('America/Argentina/Salta',68),('America/Argentina/San_Juan',69),('America/Argentina/San_Luis',70),('America/Argentina/Tucuman',71),('America/Argentina/Ushuaia',72),('America/Aruba',73),('America/Asuncion',74),('America/Atikokan',75),('America/Atka',76),('America/Bahia',77),('America/Bahia_Banderas',78),('America/Barbados',79),('America/Belem',80),('America/Belize',81),('America/Blanc-Sablon',82),('America/Boa_Vista',83),('America/Bogota',84),('America/Boise',85),('America/Buenos_Aires',86),('America/Cambridge_Bay',87),('America/Campo_Grande',88),('America/Cancun',89),('America/Caracas',90),('America/Catamarca',91),('America/Cayenne',92),('America/Cayman',93),('America/Chicago',94),('America/Chihuahua',95),('America/Coral_Harbour',96),('America/Cordoba',97),('America/Costa_Rica',98),('America/Creston',99),('America/Cuiaba',100),('America/Curacao',101),('America/Danmarkshavn',102),('America/Dawson',103),('America/Dawson_Creek',104),('America/Denver',105),('America/Detroit',106),('America/Dominica',107),('America/Edmonton',108),('America/Eirunepe',109),('America/El_Salvador',110),('America/Ensenada',111),('America/Fort_Nelson',112),('America/Fort_Wayne',113),('America/Fortaleza',114),('America/Glace_Bay',115),('America/Godthab',116),('America/Goose_Bay',117),('America/Grand_Turk',118),('America/Grenada',119),('America/Guadeloupe',120),('America/Guatemala',121),('America/Guayaquil',122),('America/Guyana',123),('America/Halifax',124),('America/Havana',125),('America/Hermosillo',126),('America/Indiana/Indianapolis',127),('America/Indiana/Knox',128),('America/Indiana/Marengo',129),('America/Indiana/Petersburg',130),('America/Indiana/Tell_City',131),('America/Indiana/Vevay',132),('America/Indiana/Vincennes',133),('America/Indiana/Winamac',134),('America/Indianapolis',135),('America/Inuvik',136),('America/Iqaluit',137),('America/Jamaica',138),('America/Jujuy',139),('America/Juneau',140),('America/Kentucky/Louisville',141),('America/Kentucky/Monticello',142),('America/Knox_IN',143),('America/Kralendijk',144),('America/La_Paz',145),('America/Lima',146),('America/Los_Angeles',147),('America/Louisville',148),('America/Lower_Princes',149),('America/Maceio',150),('America/Managua',151),('America/Manaus',152),('America/Marigot',153),('America/Martinique',154),('America/Matamoros',155),('America/Mazatlan',156),('America/Mendoza',157),('America/Menominee',158),('America/Merida',159),('America/Metlakatla',160),('America/Mexico_City',161),('America/Miquelon',162),('America/Moncton',163),('America/Monterrey',164),('America/Montevideo',165),('America/Montreal',166),('America/Montserrat',167),('America/Nassau',168),('America/New_York',169),('America/Nipigon',170),('America/Nome',171),('America/Noronha',172),('America/North_Dakota/Beulah',173),('America/North_Dakota/Center',174),('America/North_Dakota/New_Salem',175),('America/Ojinaga',176),('America/Panama',177),('America/Pangnirtung',178),('America/Paramaribo',179),('America/Phoenix',180),('America/Port-au-Prince',181),('America/Port_of_Spain',182),('America/Porto_Acre',183),('America/Porto_Velho',184),('America/Puerto_Rico',185),('America/Punta_Arenas',186),('America/Rainy_River',187),('America/Rankin_Inlet',188),('America/Recife',189),('America/Regina',190),('America/Resolute',191),('America/Rio_Branco',192),('America/Rosario',193),('America/Santa_Isabel',194),('America/Santarem',195),('America/Santiago',196),('America/Santo_Domingo',197),('America/Sao_Paulo',198),('America/Scoresbysund',199),('America/Shiprock',200),('America/Sitka',201),('America/St_Barthelemy',202),('America/St_Johns',203),('America/St_Kitts',204),('America/St_Lucia',205),('America/St_Thomas',206),('America/St_Vincent',207),('America/Swift_Current',208),('America/Tegucigalpa',209),('America/Thule',210),('America/Thunder_Bay',211),('America/Tijuana',212),('America/Toronto',213),('America/Tortola',214),('America/Vancouver',215),('America/Virgin',216),('America/Whitehorse',217),('America/Winnipeg',218),('America/Yakutat',219),('America/Yellowknife',220),('Antarctica/Casey',221),('Antarctica/Davis',222),('Antarctica/DumontDUrville',223),('Antarctica/Macquarie',224),('Antarctica/Mawson',225),('Antarctica/McMurdo',226),('Antarctica/Palmer',227),('Antarctica/Rothera',228),('Antarctica/South_Pole',229),('Antarctica/Syowa',230),('Antarctica/Troll',231),('Antarctica/Vostok',232),('Arctic/Longyearbyen',233),('Asia/Aden',234),('Asia/Almaty',235),('Asia/Amman',236),('Asia/Anadyr',237),('Asia/Aqtau',238),('Asia/Aqtobe',239),('Asia/Ashgabat',240),('Asia/Ashkhabad',241),('Asia/Atyrau',242),('Asia/Baghdad',243),('Asia/Bahrain',244),('Asia/Baku',245),('Asia/Bangkok',246),('Asia/Barnaul',247),('Asia/Beirut',248),('Asia/Bishkek',249),('Asia/Brunei',250),('Asia/Calcutta',251),('Asia/Chita',252),('Asia/Choibalsan',253),('Asia/Chongqing',254),('Asia/Chungking',255),('Asia/Colombo',256),('Asia/Dacca',257),('Asia/Damascus',258),('Asia/Dhaka',259),('Asia/Dili',260),('Asia/Dubai',261),('Asia/Dushanbe',262),('Asia/Famagusta',263),('Asia/Gaza',264),('Asia/Harbin',265),('Asia/Hebron',266),('Asia/Ho_Chi_Minh',267),('Asia/Hong_Kong',268),('Asia/Hovd',269),('Asia/Irkutsk',270),('Asia/Istanbul',271),('Asia/Jakarta',272),('Asia/Jayapura',273),('Asia/Jerusalem',274),('Asia/Kabul',275),('Asia/Kamchatka',276),('Asia/Karachi',277),('Asia/Kashgar',278),('Asia/Kathmandu',279),('Asia/Katmandu',280),('Asia/Khandyga',281),('Asia/Kolkata',282),('Asia/Krasnoyarsk',283),('Asia/Kuala_Lumpur',284),('Asia/Kuching',285),('Asia/Kuwait',286),('Asia/Macao',287),('Asia/Macau',288),('Asia/Magadan',289),('Asia/Makassar',290),('Asia/Manila',291),('Asia/Muscat',292),('Asia/Nicosia',293),('Asia/Novokuznetsk',294),('Asia/Novosibirsk',295),('Asia/Omsk',296),('Asia/Oral',297),('Asia/Phnom_Penh',298),('Asia/Pontianak',299),('Asia/Pyongyang',300),('Asia/Qatar',301),('Asia/Qostanay',302),('Asia/Qyzylorda',303),('Asia/Rangoon',304),('Asia/Riyadh',305),('Asia/Saigon',306),('Asia/Sakhalin',307),('Asia/Samarkand',308),('Asia/Seoul',309),('Asia/Shanghai',310),('Asia/Singapore',311),('Asia/Srednekolymsk',312),('Asia/Taipei',313),('Asia/Tashkent',314),('Asia/Tbilisi',315),('Asia/Tehran',316),('Asia/Tel_Aviv',317),('Asia/Thimbu',318),('Asia/Thimphu',319),('Asia/Tokyo',320),('Asia/Tomsk',321),('Asia/Ujung_Pandang',322),('Asia/Ulaanbaatar',323),('Asia/Ulan_Bator',324),('Asia/Urumqi',325),('Asia/Ust-Nera',326),('Asia/Vientiane',327),('Asia/Vladivostok',328),('Asia/Yakutsk',329),('Asia/Yangon',330),('Asia/Yekaterinburg',331),('Asia/Yerevan',332),('Atlantic/Azores',333),('Atlantic/Bermuda',334),('Atlantic/Canary',335),('Atlantic/Cape_Verde',336),('Atlantic/Faeroe',337),('Atlantic/Faroe',338),('Atlantic/Jan_Mayen',339),('Atlantic/Madeira',340),('Atlantic/Reykjavik',341),('Atlantic/South_Georgia',342),('Atlantic/St_Helena',343),('Atlantic/Stanley',344),('Australia/ACT',345),('Australia/Adelaide',346),('Australia/Brisbane',347),('Australia/Broken_Hill',348),('Australia/Canberra',349),('Australia/Currie',350),('Australia/Darwin',351),('Australia/Eucla',352),('Australia/Hobart',353),('Australia/LHI',354),('Australia/Lindeman',355),('Australia/Lord_Howe',356),('Australia/Melbourne',357),('Australia/NSW',358),('Australia/North',359),('Australia/Perth',360),('Australia/Queensland',361),('Australia/South',362),('Australia/Sydney',363),('Australia/Tasmania',364),('Australia/Victoria',365),('Australia/West',366),('Australia/Yancowinna',367),('Brazil/Acre',368),('Brazil/DeNoronha',369),('Brazil/East',370),('Brazil/West',371),('CET',372),('CST6CDT',373),('Canada/Atlantic',374),('Canada/Central',375),('Canada/Eastern',376),('Canada/Mountain',377),('Canada/Newfoundland',378),('Canada/Pacific',379),('Canada/Saskatchewan',380),('Canada/Yukon',381),('Chile/Continental',382),('Chile/EasterIsland',383),('Cuba',384),('EET',385),('EST',386),('EST5EDT',387),('Egypt',388),('Eire',389),('Etc/GMT',390),('Etc/GMT+0',391),('Etc/GMT+1',392),('Etc/GMT+10',393),('Etc/GMT+11',394),('Etc/GMT+12',395),('Etc/GMT+2',396),('Etc/GMT+3',397),('Etc/GMT+4',398),('Etc/GMT+5',399),('Etc/GMT+6',400),('Etc/GMT+7',401),('Etc/GMT+8',402),('Etc/GMT+9',403),('Etc/GMT-0',404),('Etc/GMT-1',405),('Etc/GMT-10',406),('Etc/GMT-11',407),('Etc/GMT-12',408),('Etc/GMT-13',409),('Etc/GMT-14',410),('Etc/GMT-2',411),('Etc/GMT-3',412),('Etc/GMT-4',413),('Etc/GMT-5',414),('Etc/GMT-6',415),('Etc/GMT-7',416),('Etc/GMT-8',417),('Etc/GMT-9',418),('Etc/GMT0',419),('Etc/Greenwich',420),('Etc/UCT',421),('Etc/UTC',422),('Etc/Universal',423),('Etc/Zulu',424),('Europe/Amsterdam',425),('Europe/Andorra',426),('Europe/Astrakhan',427),('Europe/Athens',428),('Europe/Belfast',429),('Europe/Belgrade',430),('Europe/Berlin',431),('Europe/Bratislava',432),('Europe/Brussels',433),('Europe/Bucharest',434),('Europe/Budapest',435),('Europe/Busingen',436),('Europe/Chisinau',437),('Europe/Copenhagen',438),('Europe/Dublin',439),('Europe/Gibraltar',440),('Europe/Guernsey',441),('Europe/Helsinki',442),('Europe/Isle_of_Man',443),('Europe/Istanbul',444),('Europe/Jersey',445),('Europe/Kaliningrad',446),('Europe/Kiev',447),('Europe/Kirov',448),('Europe/Lisbon',449),('Europe/Ljubljana',450),('Europe/London',451),('Europe/Luxembourg',452),('Europe/Madrid',453),('Europe/Malta',454),('Europe/Mariehamn',455),('Europe/Minsk',456),('Europe/Monaco',457),('Europe/Moscow',458),('Europe/Nicosia',459),('Europe/Oslo',460),('Europe/Paris',461),('Europe/Podgorica',462),('Europe/Prague',463),('Europe/Riga',464),('Europe/Rome',465),('Europe/Samara',466),('Europe/San_Marino',467),('Europe/Sarajevo',468),('Europe/Saratov',469),('Europe/Simferopol',470),('Europe/Skopje',471),('Europe/Sofia',472),('Europe/Stockholm',473),('Europe/Tallinn',474),('Europe/Tirane',475),('Europe/Tiraspol',476),('Europe/Ulyanovsk',477),('Europe/Uzhgorod',478),('Europe/Vaduz',479),('Europe/Vatican',480),('Europe/Vienna',481),('Europe/Vilnius',482),('Europe/Volgograd',483),('Europe/Warsaw',484),('Europe/Zagreb',485),('Europe/Zaporozhye',486),('Europe/Zurich',487),('GB',488),('GB-Eire',489),('GMT',490),('GMT+0',491),('GMT-0',492),('GMT0',493),('Greenwich',494),('HST',495),('Hongkong',496),('Iceland',497),('Indian/Antananarivo',498),('Indian/Chagos',499),('Indian/Christmas',500),('Indian/Cocos',501),('Indian/Comoro',502),('Indian/Kerguelen',503),('Indian/Mahe',504),('Indian/Maldives',505),('Indian/Mauritius',506),('Indian/Mayotte',507),('Indian/Reunion',508),('Iran',509),('Israel',510),('Jamaica',511),('Japan',512),('Kwajalein',513),('Libya',514),('MET',515),('MST',516),('MST7MDT',517),('Mexico/BajaNorte',518),('Mexico/BajaSur',519),('Mexico/General',520),('NZ',521),('NZ-CHAT',522),('Navajo',523),('PRC',524),('PST8PDT',525),('Pacific/Apia',526),('Pacific/Auckland',527),('Pacific/Bougainville',528),('Pacific/Chatham',529),('Pacific/Chuuk',530),('Pacific/Easter',531),('Pacific/Efate',532),('Pacific/Enderbury',533),('Pacific/Fakaofo',534),('Pacific/Fiji',535),('Pacific/Funafuti',536),('Pacific/Galapagos',537),('Pacific/Gambier',538),('Pacific/Guadalcanal',539),('Pacific/Guam',540),('Pacific/Honolulu',541),('Pacific/Johnston',542),('Pacific/Kiritimati',543),('Pacific/Kosrae',544),('Pacific/Kwajalein',545),('Pacific/Majuro',546),('Pacific/Marquesas',547),('Pacific/Midway',548),('Pacific/Nauru',549),('Pacific/Niue',550),('Pacific/Norfolk',551),('Pacific/Noumea',552),('Pacific/Pago_Pago',553),('Pacific/Palau',554),('Pacific/Pitcairn',555),('Pacific/Pohnpei',556),('Pacific/Ponape',557),('Pacific/Port_Moresby',558),('Pacific/Rarotonga',559),('Pacific/Saipan',560),('Pacific/Samoa',561),('Pacific/Tahiti',562),('Pacific/Tarawa',563),('Pacific/Tongatapu',564),('Pacific/Truk',565),('Pacific/Wake',566),('Pacific/Wallis',567),('Pacific/Yap',568),('Poland',569),('Portugal',570),('ROC',571),('ROK',572),('Singapore',573),('SystemV/AST4',574),('SystemV/AST4ADT',575),('SystemV/CST6',576),('SystemV/CST6CDT',577),('SystemV/EST5',578),('SystemV/EST5EDT',579),('SystemV/HST10',580),('SystemV/MST7',581),('SystemV/MST7MDT',582),('SystemV/PST8',583),('SystemV/PST8PDT',584),('SystemV/YST9',585),('SystemV/YST9YDT',586),('Turkey',587),('UCT',588),('US/Alaska',589),('US/Aleutian',590),('US/Arizona',591),('US/Central',592),('US/East-Indiana',593),('US/Eastern',594),('US/Hawaii',595),('US/Indiana-Starke',596),('US/Michigan',597),('US/Mountain',598),('US/Pacific',599),('US/Pacific-New',600),('US/Samoa',601),('UTC',602),('Universal',603),('W-SU',604),('WET',605),('Zulu',606),('localtime',607),('posix/Africa/Abidjan',608),('posix/Africa/Accra',609),('posix/Africa/Addis_Ababa',610),('posix/Africa/Algiers',611),('posix/Africa/Asmara',612),('posix/Africa/Asmera',613),('posix/Africa/Bamako',614),('posix/Africa/Bangui',615),('posix/Africa/Banjul',616),('posix/Africa/Bissau',617),('posix/Africa/Blantyre',618),('posix/Africa/Brazzaville',619),('posix/Africa/Bujumbura',620),('posix/Africa/Cairo',621),('posix/Africa/Casablanca',622),('posix/Africa/Ceuta',623),('posix/Africa/Conakry',624),('posix/Africa/Dakar',625),('posix/Africa/Dar_es_Salaam',626),('posix/Africa/Djibouti',627),('posix/Africa/Douala',628),('posix/Africa/El_Aaiun',629),('posix/Africa/Freetown',630),('posix/Africa/Gaborone',631),('posix/Africa/Harare',632),('posix/Africa/Johannesburg',633),('posix/Africa/Juba',634),('posix/Africa/Kampala',635),('posix/Africa/Khartoum',636),('posix/Africa/Kigali',637),('posix/Africa/Kinshasa',638),('posix/Africa/Lagos',639),('posix/Africa/Libreville',640),('posix/Africa/Lome',641),('posix/Africa/Luanda',642),('posix/Africa/Lubumbashi',643),('posix/Africa/Lusaka',644),('posix/Africa/Malabo',645),('posix/Africa/Maputo',646),('posix/Africa/Maseru',647),('posix/Africa/Mbabane',648),('posix/Africa/Mogadishu',649),('posix/Africa/Monrovia',650),('posix/Africa/Nairobi',651),('posix/Africa/Ndjamena',652),('posix/Africa/Niamey',653),('posix/Africa/Nouakchott',654),('posix/Africa/Ouagadougou',655),('posix/Africa/Porto-Novo',656),('posix/Africa/Sao_Tome',657),('posix/Africa/Timbuktu',658),('posix/Africa/Tripoli',659),('posix/Africa/Tunis',660),('posix/Africa/Windhoek',661),('posix/America/Adak',662),('posix/America/Anchorage',663),('posix/America/Anguilla',664),('posix/America/Antigua',665),('posix/America/Araguaina',666),('posix/America/Argentina/Buenos_Aires',667),('posix/America/Argentina/Catamarca',668),('posix/America/Argentina/ComodRivadavia',669),('posix/America/Argentina/Cordoba',670),('posix/America/Argentina/Jujuy',671),('posix/America/Argentina/La_Rioja',672),('posix/America/Argentina/Mendoza',673),('posix/America/Argentina/Rio_Gallegos',674),('posix/America/Argentina/Salta',675),('posix/America/Argentina/San_Juan',676),('posix/America/Argentina/San_Luis',677),('posix/America/Argentina/Tucuman',678),('posix/America/Argentina/Ushuaia',679),('posix/America/Aruba',680),('posix/America/Asuncion',681),('posix/America/Atikokan',682),('posix/America/Atka',683),('posix/America/Bahia',684),('posix/America/Bahia_Banderas',685),('posix/America/Barbados',686),('posix/America/Belem',687),('posix/America/Belize',688),('posix/America/Blanc-Sablon',689),('posix/America/Boa_Vista',690),('posix/America/Bogota',691),('posix/America/Boise',692),('posix/America/Buenos_Aires',693),('posix/America/Cambridge_Bay',694),('posix/America/Campo_Grande',695),('posix/America/Cancun',696),('posix/America/Caracas',697),('posix/America/Catamarca',698),('posix/America/Cayenne',699),('posix/America/Cayman',700),('posix/America/Chicago',701),('posix/America/Chihuahua',702),('posix/America/Coral_Harbour',703),('posix/America/Cordoba',704),('posix/America/Costa_Rica',705),('posix/America/Creston',706),('posix/America/Cuiaba',707),('posix/America/Curacao',708),('posix/America/Danmarkshavn',709),('posix/America/Dawson',710),('posix/America/Dawson_Creek',711),('posix/America/Denver',712),('posix/America/Detroit',713),('posix/America/Dominica',714),('posix/America/Edmonton',715),('posix/America/Eirunepe',716),('posix/America/El_Salvador',717),('posix/America/Ensenada',718),('posix/America/Fort_Nelson',719),('posix/America/Fort_Wayne',720),('posix/America/Fortaleza',721),('posix/America/Glace_Bay',722),('posix/America/Godthab',723),('posix/America/Goose_Bay',724),('posix/America/Grand_Turk',725),('posix/America/Grenada',726),('posix/America/Guadeloupe',727),('posix/America/Guatemala',728),('posix/America/Guayaquil',729),('posix/America/Guyana',730),('posix/America/Halifax',731),('posix/America/Havana',732),('posix/America/Hermosillo',733),('posix/America/Indiana/Indianapolis',734),('posix/America/Indiana/Knox',735),('posix/America/Indiana/Marengo',736),('posix/America/Indiana/Petersburg',737),('posix/America/Indiana/Tell_City',738),('posix/America/Indiana/Vevay',739),('posix/America/Indiana/Vincennes',740),('posix/America/Indiana/Winamac',741),('posix/America/Indianapolis',742),('posix/America/Inuvik',743),('posix/America/Iqaluit',744),('posix/America/Jamaica',745),('posix/America/Jujuy',746),('posix/America/Juneau',747),('posix/America/Kentucky/Louisville',748),('posix/America/Kentucky/Monticello',749),('posix/America/Knox_IN',750),('posix/America/Kralendijk',751),('posix/America/La_Paz',752),('posix/America/Lima',753),('posix/America/Los_Angeles',754),('posix/America/Louisville',755),('posix/America/Lower_Princes',756),('posix/America/Maceio',757),('posix/America/Managua',758),('posix/America/Manaus',759),('posix/America/Marigot',760),('posix/America/Martinique',761),('posix/America/Matamoros',762),('posix/America/Mazatlan',763),('posix/America/Mendoza',764),('posix/America/Menominee',765),('posix/America/Merida',766),('posix/America/Metlakatla',767),('posix/America/Mexico_City',768),('posix/America/Miquelon',769),('posix/America/Moncton',770),('posix/America/Monterrey',771),('posix/America/Montevideo',772),('posix/America/Montreal',773),('posix/America/Montserrat',774),('posix/America/Nassau',775),('posix/America/New_York',776),('posix/America/Nipigon',777),('posix/America/Nome',778),('posix/America/Noronha',779),('posix/America/North_Dakota/Beulah',780),('posix/America/North_Dakota/Center',781),('posix/America/North_Dakota/New_Salem',782),('posix/America/Ojinaga',783),('posix/America/Panama',784),('posix/America/Pangnirtung',785),('posix/America/Paramaribo',786),('posix/America/Phoenix',787),('posix/America/Port-au-Prince',788),('posix/America/Port_of_Spain',789),('posix/America/Porto_Acre',790),('posix/America/Porto_Velho',791),('posix/America/Puerto_Rico',792),('posix/America/Punta_Arenas',793),('posix/America/Rainy_River',794),('posix/America/Rankin_Inlet',795),('posix/America/Recife',796),('posix/America/Regina',797),('posix/America/Resolute',798),('posix/America/Rio_Branco',799),('posix/America/Rosario',800),('posix/America/Santa_Isabel',801),('posix/America/Santarem',802),('posix/America/Santiago',803),('posix/America/Santo_Domingo',804),('posix/America/Sao_Paulo',805),('posix/America/Scoresbysund',806),('posix/America/Shiprock',807),('posix/America/Sitka',808),('posix/America/St_Barthelemy',809),('posix/America/St_Johns',810),('posix/America/St_Kitts',811),('posix/America/St_Lucia',812),('posix/America/St_Thomas',813),('posix/America/St_Vincent',814),('posix/America/Swift_Current',815),('posix/America/Tegucigalpa',816),('posix/America/Thule',817),('posix/America/Thunder_Bay',818),('posix/America/Tijuana',819),('posix/America/Toronto',820),('posix/America/Tortola',821),('posix/America/Vancouver',822),('posix/America/Virgin',823),('posix/America/Whitehorse',824),('posix/America/Winnipeg',825),('posix/America/Yakutat',826),('posix/America/Yellowknife',827),('posix/Antarctica/Casey',828),('posix/Antarctica/Davis',829),('posix/Antarctica/DumontDUrville',830),('posix/Antarctica/Macquarie',831),('posix/Antarctica/Mawson',832),('posix/Antarctica/McMurdo',833),('posix/Antarctica/Palmer',834),('posix/Antarctica/Rothera',835),('posix/Antarctica/South_Pole',836),('posix/Antarctica/Syowa',837),('posix/Antarctica/Troll',838),('posix/Antarctica/Vostok',839),('posix/Arctic/Longyearbyen',840),('posix/Asia/Aden',841),('posix/Asia/Almaty',842),('posix/Asia/Amman',843),('posix/Asia/Anadyr',844),('posix/Asia/Aqtau',845),('posix/Asia/Aqtobe',846),('posix/Asia/Ashgabat',847),('posix/Asia/Ashkhabad',848),('posix/Asia/Atyrau',849),('posix/Asia/Baghdad',850),('posix/Asia/Bahrain',851),('posix/Asia/Baku',852),('posix/Asia/Bangkok',853),('posix/Asia/Barnaul',854),('posix/Asia/Beirut',855),('posix/Asia/Bishkek',856),('posix/Asia/Brunei',857),('posix/Asia/Calcutta',858),('posix/Asia/Chita',859),('posix/Asia/Choibalsan',860),('posix/Asia/Chongqing',861),('posix/Asia/Chungking',862),('posix/Asia/Colombo',863),('posix/Asia/Dacca',864),('posix/Asia/Damascus',865),('posix/Asia/Dhaka',866),('posix/Asia/Dili',867),('posix/Asia/Dubai',868),('posix/Asia/Dushanbe',869),('posix/Asia/Famagusta',870),('posix/Asia/Gaza',871),('posix/Asia/Harbin',872),('posix/Asia/Hebron',873),('posix/Asia/Ho_Chi_Minh',874),('posix/Asia/Hong_Kong',875),('posix/Asia/Hovd',876),('posix/Asia/Irkutsk',877),('posix/Asia/Istanbul',878),('posix/Asia/Jakarta',879),('posix/Asia/Jayapura',880),('posix/Asia/Jerusalem',881),('posix/Asia/Kabul',882),('posix/Asia/Kamchatka',883),('posix/Asia/Karachi',884),('posix/Asia/Kashgar',885),('posix/Asia/Kathmandu',886),('posix/Asia/Katmandu',887),('posix/Asia/Khandyga',888),('posix/Asia/Kolkata',889),('posix/Asia/Krasnoyarsk',890),('posix/Asia/Kuala_Lumpur',891),('posix/Asia/Kuching',892),('posix/Asia/Kuwait',893),('posix/Asia/Macao',894),('posix/Asia/Macau',895),('posix/Asia/Magadan',896),('posix/Asia/Makassar',897),('posix/Asia/Manila',898),('posix/Asia/Muscat',899),('posix/Asia/Nicosia',900),('posix/Asia/Novokuznetsk',901),('posix/Asia/Novosibirsk',902),('posix/Asia/Omsk',903),('posix/Asia/Oral',904),('posix/Asia/Phnom_Penh',905),('posix/Asia/Pontianak',906),('posix/Asia/Pyongyang',907),('posix/Asia/Qatar',908),('posix/Asia/Qostanay',909),('posix/Asia/Qyzylorda',910),('posix/Asia/Rangoon',911),('posix/Asia/Riyadh',912),('posix/Asia/Saigon',913),('posix/Asia/Sakhalin',914),('posix/Asia/Samarkand',915),('posix/Asia/Seoul',916),('posix/Asia/Shanghai',917),('posix/Asia/Singapore',918),('posix/Asia/Srednekolymsk',919),('posix/Asia/Taipei',920),('posix/Asia/Tashkent',921),('posix/Asia/Tbilisi',922),('posix/Asia/Tehran',923),('posix/Asia/Tel_Aviv',924),('posix/Asia/Thimbu',925),('posix/Asia/Thimphu',926),('posix/Asia/Tokyo',927),('posix/Asia/Tomsk',928),('posix/Asia/Ujung_Pandang',929),('posix/Asia/Ulaanbaatar',930),('posix/Asia/Ulan_Bator',931),('posix/Asia/Urumqi',932),('posix/Asia/Ust-Nera',933),('posix/Asia/Vientiane',934),('posix/Asia/Vladivostok',935),('posix/Asia/Yakutsk',936),('posix/Asia/Yangon',937),('posix/Asia/Yekaterinburg',938),('posix/Asia/Yerevan',939),('posix/Atlantic/Azores',940),('posix/Atlantic/Bermuda',941),('posix/Atlantic/Canary',942),('posix/Atlantic/Cape_Verde',943),('posix/Atlantic/Faeroe',944),('posix/Atlantic/Faroe',945),('posix/Atlantic/Jan_Mayen',946),('posix/Atlantic/Madeira',947),('posix/Atlantic/Reykjavik',948),('posix/Atlantic/South_Georgia',949),('posix/Atlantic/St_Helena',950),('posix/Atlantic/Stanley',951),('posix/Australia/ACT',952),('posix/Australia/Adelaide',953),('posix/Australia/Brisbane',954),('posix/Australia/Broken_Hill',955),('posix/Australia/Canberra',956),('posix/Australia/Currie',957),('posix/Australia/Darwin',958),('posix/Australia/Eucla',959),('posix/Australia/Hobart',960),('posix/Australia/LHI',961),('posix/Australia/Lindeman',962),('posix/Australia/Lord_Howe',963),('posix/Australia/Melbourne',964),('posix/Australia/NSW',965),('posix/Australia/North',966),('posix/Australia/Perth',967),('posix/Australia/Queensland',968),('posix/Australia/South',969),('posix/Australia/Sydney',970),('posix/Australia/Tasmania',971),('posix/Australia/Victoria',972),('posix/Australia/West',973),('posix/Australia/Yancowinna',974),('posix/Brazil/Acre',975),('posix/Brazil/DeNoronha',976),('posix/Brazil/East',977),('posix/Brazil/West',978),('posix/CET',979),('posix/CST6CDT',980),('posix/Canada/Atlantic',981),('posix/Canada/Central',982),('posix/Canada/Eastern',983),('posix/Canada/Mountain',984),('posix/Canada/Newfoundland',985),('posix/Canada/Pacific',986),('posix/Canada/Saskatchewan',987),('posix/Canada/Yukon',988),('posix/Chile/Continental',989),('posix/Chile/EasterIsland',990),('posix/Cuba',991),('posix/EET',992),('posix/EST',993),('posix/EST5EDT',994),('posix/Egypt',995),('posix/Eire',996),('posix/Etc/GMT',997),('posix/Etc/GMT+0',998),('posix/Etc/GMT+1',999),('posix/Etc/GMT+10',1000),('posix/Etc/GMT+11',1001),('posix/Etc/GMT+12',1002),('posix/Etc/GMT+2',1003),('posix/Etc/GMT+3',1004),('posix/Etc/GMT+4',1005),('posix/Etc/GMT+5',1006),('posix/Etc/GMT+6',1007),('posix/Etc/GMT+7',1008),('posix/Etc/GMT+8',1009),('posix/Etc/GMT+9',1010),('posix/Etc/GMT-0',1011),('posix/Etc/GMT-1',1012),('posix/Etc/GMT-10',1013),('posix/Etc/GMT-11',1014),('posix/Etc/GMT-12',1015),('posix/Etc/GMT-13',1016),('posix/Etc/GMT-14',1017),('posix/Etc/GMT-2',1018),('posix/Etc/GMT-3',1019),('posix/Etc/GMT-4',1020),('posix/Etc/GMT-5',1021),('posix/Etc/GMT-6',1022),('posix/Etc/GMT-7',1023),('posix/Etc/GMT-8',1024),('posix/Etc/GMT-9',1025),('posix/Etc/GMT0',1026),('posix/Etc/Greenwich',1027),('posix/Etc/UCT',1028),('posix/Etc/UTC',1029),('posix/Etc/Universal',1030),('posix/Etc/Zulu',1031),('posix/Europe/Amsterdam',1032),('posix/Europe/Andorra',1033),('posix/Europe/Astrakhan',1034),('posix/Europe/Athens',1035),('posix/Europe/Belfast',1036),('posix/Europe/Belgrade',1037),('posix/Europe/Berlin',1038),('posix/Europe/Bratislava',1039),('posix/Europe/Brussels',1040),('posix/Europe/Bucharest',1041),('posix/Europe/Budapest',1042),('posix/Europe/Busingen',1043),('posix/Europe/Chisinau',1044),('posix/Europe/Copenhagen',1045),('posix/Europe/Dublin',1046),('posix/Europe/Gibraltar',1047),('posix/Europe/Guernsey',1048),('posix/Europe/Helsinki',1049),('posix/Europe/Isle_of_Man',1050),('posix/Europe/Istanbul',1051),('posix/Europe/Jersey',1052),('posix/Europe/Kaliningrad',1053),('posix/Europe/Kiev',1054),('posix/Europe/Kirov',1055),('posix/Europe/Lisbon',1056),('posix/Europe/Ljubljana',1057),('posix/Europe/London',1058),('posix/Europe/Luxembourg',1059),('posix/Europe/Madrid',1060),('posix/Europe/Malta',1061),('posix/Europe/Mariehamn',1062),('posix/Europe/Minsk',1063),('posix/Europe/Monaco',1064),('posix/Europe/Moscow',1065),('posix/Europe/Nicosia',1066),('posix/Europe/Oslo',1067),('posix/Europe/Paris',1068),('posix/Europe/Podgorica',1069),('posix/Europe/Prague',1070),('posix/Europe/Riga',1071),('posix/Europe/Rome',1072),('posix/Europe/Samara',1073),('posix/Europe/San_Marino',1074),('posix/Europe/Sarajevo',1075),('posix/Europe/Saratov',1076),('posix/Europe/Simferopol',1077),('posix/Europe/Skopje',1078),('posix/Europe/Sofia',1079),('posix/Europe/Stockholm',1080),('posix/Europe/Tallinn',1081),('posix/Europe/Tirane',1082),('posix/Europe/Tiraspol',1083),('posix/Europe/Ulyanovsk',1084),('posix/Europe/Uzhgorod',1085),('posix/Europe/Vaduz',1086),('posix/Europe/Vatican',1087),('posix/Europe/Vienna',1088),('posix/Europe/Vilnius',1089),('posix/Europe/Volgograd',1090),('posix/Europe/Warsaw',1091),('posix/Europe/Zagreb',1092),('posix/Europe/Zaporozhye',1093),('posix/Europe/Zurich',1094),('posix/GB',1095),('posix/GB-Eire',1096),('posix/GMT',1097),('posix/GMT+0',1098),('posix/GMT-0',1099),('posix/GMT0',1100),('posix/Greenwich',1101),('posix/HST',1102),('posix/Hongkong',1103),('posix/Iceland',1104),('posix/Indian/Antananarivo',1105),('posix/Indian/Chagos',1106),('posix/Indian/Christmas',1107),('posix/Indian/Cocos',1108),('posix/Indian/Comoro',1109),('posix/Indian/Kerguelen',1110),('posix/Indian/Mahe',1111),('posix/Indian/Maldives',1112),('posix/Indian/Mauritius',1113),('posix/Indian/Mayotte',1114),('posix/Indian/Reunion',1115),('posix/Iran',1116),('posix/Israel',1117),('posix/Jamaica',1118),('posix/Japan',1119),('posix/Kwajalein',1120),('posix/Libya',1121),('posix/MET',1122),('posix/MST',1123),('posix/MST7MDT',1124),('posix/Mexico/BajaNorte',1125),('posix/Mexico/BajaSur',1126),('posix/Mexico/General',1127),('posix/NZ',1128),('posix/NZ-CHAT',1129),('posix/Navajo',1130),('posix/PRC',1131),('posix/PST8PDT',1132),('posix/Pacific/Apia',1133),('posix/Pacific/Auckland',1134),('posix/Pacific/Bougainville',1135),('posix/Pacific/Chatham',1136),('posix/Pacific/Chuuk',1137),('posix/Pacific/Easter',1138),('posix/Pacific/Efate',1139),('posix/Pacific/Enderbury',1140),('posix/Pacific/Fakaofo',1141),('posix/Pacific/Fiji',1142),('posix/Pacific/Funafuti',1143),('posix/Pacific/Galapagos',1144),('posix/Pacific/Gambier',1145),('posix/Pacific/Guadalcanal',1146),('posix/Pacific/Guam',1147),('posix/Pacific/Honolulu',1148),('posix/Pacific/Johnston',1149),('posix/Pacific/Kiritimati',1150),('posix/Pacific/Kosrae',1151),('posix/Pacific/Kwajalein',1152),('posix/Pacific/Majuro',1153),('posix/Pacific/Marquesas',1154),('posix/Pacific/Midway',1155),('posix/Pacific/Nauru',1156),('posix/Pacific/Niue',1157),('posix/Pacific/Norfolk',1158),('posix/Pacific/Noumea',1159),('posix/Pacific/Pago_Pago',1160),('posix/Pacific/Palau',1161),('posix/Pacific/Pitcairn',1162),('posix/Pacific/Pohnpei',1163),('posix/Pacific/Ponape',1164),('posix/Pacific/Port_Moresby',1165),('posix/Pacific/Rarotonga',1166),('posix/Pacific/Saipan',1167),('posix/Pacific/Samoa',1168),('posix/Pacific/Tahiti',1169),('posix/Pacific/Tarawa',1170),('posix/Pacific/Tongatapu',1171),('posix/Pacific/Truk',1172),('posix/Pacific/Wake',1173),('posix/Pacific/Wallis',1174),('posix/Pacific/Yap',1175),('posix/Poland',1176),('posix/Portugal',1177),('posix/ROC',1178),('posix/ROK',1179),('posix/Singapore',1180),('posix/SystemV/AST4',1181),('posix/SystemV/AST4ADT',1182),('posix/SystemV/CST6',1183),('posix/SystemV/CST6CDT',1184),('posix/SystemV/EST5',1185),('posix/SystemV/EST5EDT',1186),('posix/SystemV/HST10',1187),('posix/SystemV/MST7',1188),('posix/SystemV/MST7MDT',1189),('posix/SystemV/PST8',1190),('posix/SystemV/PST8PDT',1191),('posix/SystemV/YST9',1192),('posix/SystemV/YST9YDT',1193),('posix/Turkey',1194),('posix/UCT',1195),('posix/US/Alaska',1196),('posix/US/Aleutian',1197),('posix/US/Arizona',1198),('posix/US/Central',1199),('posix/US/East-Indiana',1200),('posix/US/Eastern',1201),('posix/US/Hawaii',1202),('posix/US/Indiana-Starke',1203),('posix/US/Michigan',1204),('posix/US/Mountain',1205),('posix/US/Pacific',1206),('posix/US/Pacific-New',1207),('posix/US/Samoa',1208),('posix/UTC',1209),('posix/Universal',1210),('posix/W-SU',1211),('posix/WET',1212),('posix/Zulu',1213),('posixrules',1214),('right/Africa/Abidjan',1215),('right/Africa/Accra',1216),('right/Africa/Addis_Ababa',1217),('right/Africa/Algiers',1218),('right/Africa/Asmara',1219),('right/Africa/Asmera',1220),('right/Africa/Bamako',1221),('right/Africa/Bangui',1222),('right/Africa/Banjul',1223),('right/Africa/Bissau',1224),('right/Africa/Blantyre',1225),('right/Africa/Brazzaville',1226),('right/Africa/Bujumbura',1227),('right/Africa/Cairo',1228),('right/Africa/Casablanca',1229),('right/Africa/Ceuta',1230),('right/Africa/Conakry',1231),('right/Africa/Dakar',1232),('right/Africa/Dar_es_Salaam',1233),('right/Africa/Djibouti',1234),('right/Africa/Douala',1235),('right/Africa/El_Aaiun',1236),('right/Africa/Freetown',1237),('right/Africa/Gaborone',1238),('right/Africa/Harare',1239),('right/Africa/Johannesburg',1240),('right/Africa/Juba',1241),('right/Africa/Kampala',1242),('right/Africa/Khartoum',1243),('right/Africa/Kigali',1244),('right/Africa/Kinshasa',1245),('right/Africa/Lagos',1246),('right/Africa/Libreville',1247),('right/Africa/Lome',1248),('right/Africa/Luanda',1249),('right/Africa/Lubumbashi',1250),('right/Africa/Lusaka',1251),('right/Africa/Malabo',1252),('right/Africa/Maputo',1253),('right/Africa/Maseru',1254),('right/Africa/Mbabane',1255),('right/Africa/Mogadishu',1256),('right/Africa/Monrovia',1257),('right/Africa/Nairobi',1258),('right/Africa/Ndjamena',1259),('right/Africa/Niamey',1260),('right/Africa/Nouakchott',1261),('right/Africa/Ouagadougou',1262),('right/Africa/Porto-Novo',1263),('right/Africa/Sao_Tome',1264),('right/Africa/Timbuktu',1265),('right/Africa/Tripoli',1266),('right/Africa/Tunis',1267),('right/Africa/Windhoek',1268),('right/America/Adak',1269),('right/America/Anchorage',1270),('right/America/Anguilla',1271),('right/America/Antigua',1272),('right/America/Araguaina',1273),('right/America/Argentina/Buenos_Aires',1274),('right/America/Argentina/Catamarca',1275),('right/America/Argentina/ComodRivadavia',1276),('right/America/Argentina/Cordoba',1277),('right/America/Argentina/Jujuy',1278),('right/America/Argentina/La_Rioja',1279),('right/America/Argentina/Mendoza',1280),('right/America/Argentina/Rio_Gallegos',1281),('right/America/Argentina/Salta',1282),('right/America/Argentina/San_Juan',1283),('right/America/Argentina/San_Luis',1284),('right/America/Argentina/Tucuman',1285),('right/America/Argentina/Ushuaia',1286),('right/America/Aruba',1287),('right/America/Asuncion',1288),('right/America/Atikokan',1289),('right/America/Atka',1290),('right/America/Bahia',1291),('right/America/Bahia_Banderas',1292),('right/America/Barbados',1293),('right/America/Belem',1294),('right/America/Belize',1295),('right/America/Blanc-Sablon',1296),('right/America/Boa_Vista',1297),('right/America/Bogota',1298),('right/America/Boise',1299),('right/America/Buenos_Aires',1300),('right/America/Cambridge_Bay',1301),('right/America/Campo_Grande',1302),('right/America/Cancun',1303),('right/America/Caracas',1304),('right/America/Catamarca',1305),('right/America/Cayenne',1306),('right/America/Cayman',1307),('right/America/Chicago',1308),('right/America/Chihuahua',1309),('right/America/Coral_Harbour',1310),('right/America/Cordoba',1311),('right/America/Costa_Rica',1312),('right/America/Creston',1313),('right/America/Cuiaba',1314),('right/America/Curacao',1315),('right/America/Danmarkshavn',1316),('right/America/Dawson',1317),('right/America/Dawson_Creek',1318),('right/America/Denver',1319),('right/America/Detroit',1320),('right/America/Dominica',1321),('right/America/Edmonton',1322),('right/America/Eirunepe',1323),('right/America/El_Salvador',1324),('right/America/Ensenada',1325),('right/America/Fort_Nelson',1326),('right/America/Fort_Wayne',1327),('right/America/Fortaleza',1328),('right/America/Glace_Bay',1329),('right/America/Godthab',1330),('right/America/Goose_Bay',1331),('right/America/Grand_Turk',1332),('right/America/Grenada',1333),('right/America/Guadeloupe',1334),('right/America/Guatemala',1335),('right/America/Guayaquil',1336),('right/America/Guyana',1337),('right/America/Halifax',1338),('right/America/Havana',1339),('right/America/Hermosillo',1340),('right/America/Indiana/Indianapolis',1341),('right/America/Indiana/Knox',1342),('right/America/Indiana/Marengo',1343),('right/America/Indiana/Petersburg',1344),('right/America/Indiana/Tell_City',1345),('right/America/Indiana/Vevay',1346),('right/America/Indiana/Vincennes',1347),('right/America/Indiana/Winamac',1348),('right/America/Indianapolis',1349),('right/America/Inuvik',1350),('right/America/Iqaluit',1351),('right/America/Jamaica',1352),('right/America/Jujuy',1353),('right/America/Juneau',1354),('right/America/Kentucky/Louisville',1355),('right/America/Kentucky/Monticello',1356),('right/America/Knox_IN',1357),('right/America/Kralendijk',1358),('right/America/La_Paz',1359),('right/America/Lima',1360),('right/America/Los_Angeles',1361),('right/America/Louisville',1362),('right/America/Lower_Princes',1363),('right/America/Maceio',1364),('right/America/Managua',1365),('right/America/Manaus',1366),('right/America/Marigot',1367),('right/America/Martinique',1368),('right/America/Matamoros',1369),('right/America/Mazatlan',1370),('right/America/Mendoza',1371),('right/America/Menominee',1372),('right/America/Merida',1373),('right/America/Metlakatla',1374),('right/America/Mexico_City',1375),('right/America/Miquelon',1376),('right/America/Moncton',1377),('right/America/Monterrey',1378),('right/America/Montevideo',1379),('right/America/Montreal',1380),('right/America/Montserrat',1381),('right/America/Nassau',1382),('right/America/New_York',1383),('right/America/Nipigon',1384),('right/America/Nome',1385),('right/America/Noronha',1386),('right/America/North_Dakota/Beulah',1387),('right/America/North_Dakota/Center',1388),('right/America/North_Dakota/New_Salem',1389),('right/America/Ojinaga',1390),('right/America/Panama',1391),('right/America/Pangnirtung',1392),('right/America/Paramaribo',1393),('right/America/Phoenix',1394),('right/America/Port-au-Prince',1395),('right/America/Port_of_Spain',1396),('right/America/Porto_Acre',1397),('right/America/Porto_Velho',1398),('right/America/Puerto_Rico',1399),('right/America/Punta_Arenas',1400),('right/America/Rainy_River',1401),('right/America/Rankin_Inlet',1402),('right/America/Recife',1403),('right/America/Regina',1404),('right/America/Resolute',1405),('right/America/Rio_Branco',1406),('right/America/Rosario',1407),('right/America/Santa_Isabel',1408),('right/America/Santarem',1409),('right/America/Santiago',1410),('right/America/Santo_Domingo',1411),('right/America/Sao_Paulo',1412),('right/America/Scoresbysund',1413),('right/America/Shiprock',1414),('right/America/Sitka',1415),('right/America/St_Barthelemy',1416),('right/America/St_Johns',1417),('right/America/St_Kitts',1418),('right/America/St_Lucia',1419),('right/America/St_Thomas',1420),('right/America/St_Vincent',1421),('right/America/Swift_Current',1422),('right/America/Tegucigalpa',1423),('right/America/Thule',1424),('right/America/Thunder_Bay',1425),('right/America/Tijuana',1426),('right/America/Toronto',1427),('right/America/Tortola',1428),('right/America/Vancouver',1429),('right/America/Virgin',1430),('right/America/Whitehorse',1431),('right/America/Winnipeg',1432),('right/America/Yakutat',1433),('right/America/Yellowknife',1434),('right/Antarctica/Casey',1435),('right/Antarctica/Davis',1436),('right/Antarctica/DumontDUrville',1437),('right/Antarctica/Macquarie',1438),('right/Antarctica/Mawson',1439),('right/Antarctica/McMurdo',1440),('right/Antarctica/Palmer',1441),('right/Antarctica/Rothera',1442),('right/Antarctica/South_Pole',1443),('right/Antarctica/Syowa',1444),('right/Antarctica/Troll',1445),('right/Antarctica/Vostok',1446),('right/Arctic/Longyearbyen',1447),('right/Asia/Aden',1448),('right/Asia/Almaty',1449),('right/Asia/Amman',1450),('right/Asia/Anadyr',1451),('right/Asia/Aqtau',1452),('right/Asia/Aqtobe',1453),('right/Asia/Ashgabat',1454),('right/Asia/Ashkhabad',1455),('right/Asia/Atyrau',1456),('right/Asia/Baghdad',1457),('right/Asia/Bahrain',1458),('right/Asia/Baku',1459),('right/Asia/Bangkok',1460),('right/Asia/Barnaul',1461),('right/Asia/Beirut',1462),('right/Asia/Bishkek',1463),('right/Asia/Brunei',1464),('right/Asia/Calcutta',1465),('right/Asia/Chita',1466),('right/Asia/Choibalsan',1467),('right/Asia/Chongqing',1468),('right/Asia/Chungking',1469),('right/Asia/Colombo',1470),('right/Asia/Dacca',1471),('right/Asia/Damascus',1472),('right/Asia/Dhaka',1473),('right/Asia/Dili',1474),('right/Asia/Dubai',1475),('right/Asia/Dushanbe',1476),('right/Asia/Famagusta',1477),('right/Asia/Gaza',1478),('right/Asia/Harbin',1479),('right/Asia/Hebron',1480),('right/Asia/Ho_Chi_Minh',1481),('right/Asia/Hong_Kong',1482),('right/Asia/Hovd',1483),('right/Asia/Irkutsk',1484),('right/Asia/Istanbul',1485),('right/Asia/Jakarta',1486),('right/Asia/Jayapura',1487),('right/Asia/Jerusalem',1488),('right/Asia/Kabul',1489),('right/Asia/Kamchatka',1490),('right/Asia/Karachi',1491),('right/Asia/Kashgar',1492),('right/Asia/Kathmandu',1493),('right/Asia/Katmandu',1494),('right/Asia/Khandyga',1495),('right/Asia/Kolkata',1496),('right/Asia/Krasnoyarsk',1497),('right/Asia/Kuala_Lumpur',1498),('right/Asia/Kuching',1499),('right/Asia/Kuwait',1500),('right/Asia/Macao',1501),('right/Asia/Macau',1502),('right/Asia/Magadan',1503),('right/Asia/Makassar',1504),('right/Asia/Manila',1505),('right/Asia/Muscat',1506),('right/Asia/Nicosia',1507),('right/Asia/Novokuznetsk',1508),('right/Asia/Novosibirsk',1509),('right/Asia/Omsk',1510),('right/Asia/Oral',1511),('right/Asia/Phnom_Penh',1512),('right/Asia/Pontianak',1513),('right/Asia/Pyongyang',1514),('right/Asia/Qatar',1515),('right/Asia/Qostanay',1516),('right/Asia/Qyzylorda',1517),('right/Asia/Rangoon',1518),('right/Asia/Riyadh',1519),('right/Asia/Saigon',1520),('right/Asia/Sakhalin',1521),('right/Asia/Samarkand',1522),('right/Asia/Seoul',1523),('right/Asia/Shanghai',1524),('right/Asia/Singapore',1525),('right/Asia/Srednekolymsk',1526),('right/Asia/Taipei',1527),('right/Asia/Tashkent',1528),('right/Asia/Tbilisi',1529),('right/Asia/Tehran',1530),('right/Asia/Tel_Aviv',1531),('right/Asia/Thimbu',1532),('right/Asia/Thimphu',1533),('right/Asia/Tokyo',1534),('right/Asia/Tomsk',1535),('right/Asia/Ujung_Pandang',1536),('right/Asia/Ulaanbaatar',1537),('right/Asia/Ulan_Bator',1538),('right/Asia/Urumqi',1539),('right/Asia/Ust-Nera',1540),('right/Asia/Vientiane',1541),('right/Asia/Vladivostok',1542),('right/Asia/Yakutsk',1543),('right/Asia/Yangon',1544),('right/Asia/Yekaterinburg',1545),('right/Asia/Yerevan',1546),('right/Atlantic/Azores',1547),('right/Atlantic/Bermuda',1548),('right/Atlantic/Canary',1549),('right/Atlantic/Cape_Verde',1550),('right/Atlantic/Faeroe',1551),('right/Atlantic/Faroe',1552),('right/Atlantic/Jan_Mayen',1553),('right/Atlantic/Madeira',1554),('right/Atlantic/Reykjavik',1555),('right/Atlantic/South_Georgia',1556),('right/Atlantic/St_Helena',1557),('right/Atlantic/Stanley',1558),('right/Australia/ACT',1559),('right/Australia/Adelaide',1560),('right/Australia/Brisbane',1561),('right/Australia/Broken_Hill',1562),('right/Australia/Canberra',1563),('right/Australia/Currie',1564),('right/Australia/Darwin',1565),('right/Australia/Eucla',1566),('right/Australia/Hobart',1567),('right/Australia/LHI',1568),('right/Australia/Lindeman',1569),('right/Australia/Lord_Howe',1570),('right/Australia/Melbourne',1571),('right/Australia/NSW',1572),('right/Australia/North',1573),('right/Australia/Perth',1574),('right/Australia/Queensland',1575),('right/Australia/South',1576),('right/Australia/Sydney',1577),('right/Australia/Tasmania',1578),('right/Australia/Victoria',1579),('right/Australia/West',1580),('right/Australia/Yancowinna',1581),('right/Brazil/Acre',1582),('right/Brazil/DeNoronha',1583),('right/Brazil/East',1584),('right/Brazil/West',1585),('right/CET',1586),('right/CST6CDT',1587),('right/Canada/Atlantic',1588),('right/Canada/Central',1589),('right/Canada/Eastern',1590),('right/Canada/Mountain',1591),('right/Canada/Newfoundland',1592),('right/Canada/Pacific',1593),('right/Canada/Saskatchewan',1594),('right/Canada/Yukon',1595),('right/Chile/Continental',1596),('right/Chile/EasterIsland',1597),('right/Cuba',1598),('right/EET',1599),('right/EST',1600),('right/EST5EDT',1601),('right/Egypt',1602),('right/Eire',1603),('right/Etc/GMT',1604),('right/Etc/GMT+0',1605),('right/Etc/GMT+1',1606),('right/Etc/GMT+10',1607),('right/Etc/GMT+11',1608),('right/Etc/GMT+12',1609),('right/Etc/GMT+2',1610),('right/Etc/GMT+3',1611),('right/Etc/GMT+4',1612),('right/Etc/GMT+5',1613),('right/Etc/GMT+6',1614),('right/Etc/GMT+7',1615),('right/Etc/GMT+8',1616),('right/Etc/GMT+9',1617),('right/Etc/GMT-0',1618),('right/Etc/GMT-1',1619),('right/Etc/GMT-10',1620),('right/Etc/GMT-11',1621),('right/Etc/GMT-12',1622),('right/Etc/GMT-13',1623),('right/Etc/GMT-14',1624),('right/Etc/GMT-2',1625),('right/Etc/GMT-3',1626),('right/Etc/GMT-4',1627),('right/Etc/GMT-5',1628),('right/Etc/GMT-6',1629),('right/Etc/GMT-7',1630),('right/Etc/GMT-8',1631),('right/Etc/GMT-9',1632),('right/Etc/GMT0',1633),('right/Etc/Greenwich',1634),('right/Etc/UCT',1635),('right/Etc/UTC',1636),('right/Etc/Universal',1637),('right/Etc/Zulu',1638),('right/Europe/Amsterdam',1639),('right/Europe/Andorra',1640),('right/Europe/Astrakhan',1641),('right/Europe/Athens',1642),('right/Europe/Belfast',1643),('right/Europe/Belgrade',1644),('right/Europe/Berlin',1645),('right/Europe/Bratislava',1646),('right/Europe/Brussels',1647),('right/Europe/Bucharest',1648),('right/Europe/Budapest',1649),('right/Europe/Busingen',1650),('right/Europe/Chisinau',1651),('right/Europe/Copenhagen',1652),('right/Europe/Dublin',1653),('right/Europe/Gibraltar',1654),('right/Europe/Guernsey',1655),('right/Europe/Helsinki',1656),('right/Europe/Isle_of_Man',1657),('right/Europe/Istanbul',1658),('right/Europe/Jersey',1659),('right/Europe/Kaliningrad',1660),('right/Europe/Kiev',1661),('right/Europe/Kirov',1662),('right/Europe/Lisbon',1663),('right/Europe/Ljubljana',1664),('right/Europe/London',1665),('right/Europe/Luxembourg',1666),('right/Europe/Madrid',1667),('right/Europe/Malta',1668),('right/Europe/Mariehamn',1669),('right/Europe/Minsk',1670),('right/Europe/Monaco',1671),('right/Europe/Moscow',1672),('right/Europe/Nicosia',1673),('right/Europe/Oslo',1674),('right/Europe/Paris',1675),('right/Europe/Podgorica',1676),('right/Europe/Prague',1677),('right/Europe/Riga',1678),('right/Europe/Rome',1679),('right/Europe/Samara',1680),('right/Europe/San_Marino',1681),('right/Europe/Sarajevo',1682),('right/Europe/Saratov',1683),('right/Europe/Simferopol',1684),('right/Europe/Skopje',1685),('right/Europe/Sofia',1686),('right/Europe/Stockholm',1687),('right/Europe/Tallinn',1688),('right/Europe/Tirane',1689),('right/Europe/Tiraspol',1690),('right/Europe/Ulyanovsk',1691),('right/Europe/Uzhgorod',1692),('right/Europe/Vaduz',1693),('right/Europe/Vatican',1694),('right/Europe/Vienna',1695),('right/Europe/Vilnius',1696),('right/Europe/Volgograd',1697),('right/Europe/Warsaw',1698),('right/Europe/Zagreb',1699),('right/Europe/Zaporozhye',1700),('right/Europe/Zurich',1701),('right/GB',1702),('right/GB-Eire',1703),('right/GMT',1704),('right/GMT+0',1705),('right/GMT-0',1706),('right/GMT0',1707),('right/Greenwich',1708),('right/HST',1709),('right/Hongkong',1710),('right/Iceland',1711),('right/Indian/Antananarivo',1712),('right/Indian/Chagos',1713),('right/Indian/Christmas',1714),('right/Indian/Cocos',1715),('right/Indian/Comoro',1716),('right/Indian/Kerguelen',1717),('right/Indian/Mahe',1718),('right/Indian/Maldives',1719),('right/Indian/Mauritius',1720),('right/Indian/Mayotte',1721),('right/Indian/Reunion',1722),('right/Iran',1723),('right/Israel',1724),('right/Jamaica',1725),('right/Japan',1726),('right/Kwajalein',1727),('right/Libya',1728),('right/MET',1729),('right/MST',1730),('right/MST7MDT',1731),('right/Mexico/BajaNorte',1732),('right/Mexico/BajaSur',1733),('right/Mexico/General',1734),('right/NZ',1735),('right/NZ-CHAT',1736),('right/Navajo',1737),('right/PRC',1738),('right/PST8PDT',1739),('right/Pacific/Apia',1740),('right/Pacific/Auckland',1741),('right/Pacific/Bougainville',1742),('right/Pacific/Chatham',1743),('right/Pacific/Chuuk',1744),('right/Pacific/Easter',1745),('right/Pacific/Efate',1746),('right/Pacific/Enderbury',1747),('right/Pacific/Fakaofo',1748),('right/Pacific/Fiji',1749),('right/Pacific/Funafuti',1750),('right/Pacific/Galapagos',1751),('right/Pacific/Gambier',1752),('right/Pacific/Guadalcanal',1753),('right/Pacific/Guam',1754),('right/Pacific/Honolulu',1755),('right/Pacific/Johnston',1756),('right/Pacific/Kiritimati',1757),('right/Pacific/Kosrae',1758),('right/Pacific/Kwajalein',1759),('right/Pacific/Majuro',1760),('right/Pacific/Marquesas',1761),('right/Pacific/Midway',1762),('right/Pacific/Nauru',1763),('right/Pacific/Niue',1764),('right/Pacific/Norfolk',1765),('right/Pacific/Noumea',1766),('right/Pacific/Pago_Pago',1767),('right/Pacific/Palau',1768),('right/Pacific/Pitcairn',1769),('right/Pacific/Pohnpei',1770),('right/Pacific/Ponape',1771),('right/Pacific/Port_Moresby',1772),('right/Pacific/Rarotonga',1773),('right/Pacific/Saipan',1774),('right/Pacific/Samoa',1775),('right/Pacific/Tahiti',1776),('right/Pacific/Tarawa',1777),('right/Pacific/Tongatapu',1778),('right/Pacific/Truk',1779),('right/Pacific/Wake',1780),('right/Pacific/Wallis',1781),('right/Pacific/Yap',1782),('right/Poland',1783),('right/Portugal',1784),('right/ROC',1785),('right/ROK',1786),('right/Singapore',1787),('right/SystemV/AST4',1788),('right/SystemV/AST4ADT',1789),('right/SystemV/CST6',1790),('right/SystemV/CST6CDT',1791),('right/SystemV/EST5',1792),('right/SystemV/EST5EDT',1793),('right/SystemV/HST10',1794),('right/SystemV/MST7',1795),('right/SystemV/MST7MDT',1796),('right/SystemV/PST8',1797),('right/SystemV/PST8PDT',1798),('right/SystemV/YST9',1799),('right/SystemV/YST9YDT',1800),('right/Turkey',1801),('right/UCT',1802),('right/US/Alaska',1803),('right/US/Aleutian',1804),('right/US/Arizona',1805),('right/US/Central',1806),('right/US/East-Indiana',1807),('right/US/Eastern',1808),('right/US/Hawaii',1809),('right/US/Indiana-Starke',1810),('right/US/Michigan',1811),('right/US/Mountain',1812),('right/US/Pacific',1813),('right/US/Pacific-New',1814),('right/US/Samoa',1815),('right/UTC',1816),('right/Universal',1817),('right/W-SU',1818),('right/WET',1819),('right/Zulu',1820);
/*!40000 ALTER TABLE `time_zone_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition`
--

DROP TABLE IF EXISTS `time_zone_transition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_transition` (
  `Time_zone_id` int(10) unsigned NOT NULL,
  `Transition_time` bigint(20) NOT NULL,
  `Transition_type_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`Time_zone_id`,`Transition_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone transitions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition`
--

LOCK TABLES `time_zone_transition` WRITE;
/*!40000 ALTER TABLE `time_zone_transition` DISABLE KEYS */;
INSERT INTO `time_zone_transition` VALUES (1,-2147483648,0),(1,-1830383032,1),(2,-2147483648,0),(2,-1640995148,2),(2,-1556841600,1),(2,-1546388400,2),(2,-1525305600,1),(2,-1514852400,2),(2,-1493769600,1),(2,-1483316400,2),(2,-1462233600,1),(2,-1451780400,2),(2,-1430611200,1),(2,-1420158000,2),(2,-1399075200,1),(2,-1388622000,2),(2,-1367539200,1),(2,-1357086000,2),(2,-1336003200,1),(2,-1325550000,2),(2,-1304380800,1),(2,-1293927600,2),(2,-1272844800,1),(2,-1262391600,2),(2,-1241308800,1),(2,-1230855600,2),(2,-1209772800,1),(2,-1199319600,2),(2,-1178150400,1),(2,-1167697200,2),(2,-1146614400,1),(2,-1136161200,2),(2,-1115078400,1),(2,-1104625200,2),(2,-1083542400,1),(2,-1073089200,2),(2,-1051920000,1),(2,-1041466800,2),(2,-1020384000,1),(2,-1009930800,2),(2,-988848000,1),(2,-978394800,2),(2,-957312000,1),(2,-946858800,2),(2,-925689600,1),(2,-915236400,2),(2,-894153600,1),(2,-883700400,2),(2,-862617600,1),(2,-852164400,2),(3,-2147483648,0),(3,-1309746436,1),(3,-1262314800,2),(3,-946780200,3),(3,-315629100,1),(4,-2147483648,1),(4,-1855958961,4),(4,-1689814800,2),(4,-1680397200,3),(4,-1665363600,2),(4,-1648342800,3),(4,-1635123600,2),(4,-1616893200,3),(4,-1604278800,2),(4,-1585443600,3),(4,-1574038800,2),(4,-1552266000,3),(4,-1539997200,2),(4,-1531443600,3),(4,-956365200,2),(4,-950486400,4),(4,-942012000,6),(4,-812502000,5),(4,-796262400,6),(4,-781052400,5),(4,-766630800,6),(4,-733280400,4),(4,-439430400,6),(4,-212029200,4),(4,41468400,2),(4,54774000,3),(4,231724800,7),(4,246236400,6),(4,259545600,5),(4,275274000,6),(4,309740400,4),(4,325468800,7),(4,341802000,4),(4,357523200,6),(5,-2147483648,0),(5,-1309746436,1),(5,-1262314800,2),(5,-946780200,3),(5,-315629100,1),(6,-2147483648,0),(6,-1309746436,1),(6,-1262314800,2),(6,-946780200,3),(6,-315629100,1),(7,-2147483648,0),(7,-1830383032,1),(8,-2147483648,0),(8,-1588464816,1),(9,-2147483648,0),(9,-1830383032,1),(10,-2147483648,0),(10,-1830380400,1),(10,157770000,2),(11,-2147483648,0),(11,-2109291020,1),(12,-2147483648,0),(12,-1588464816,1),(13,-2147483648,0),(13,-2109291020,1),(14,-2147483648,2),(14,-929844000,1),(14,-923108400,2),(14,-906170400,1),(14,-892868400,2),(14,-875844000,1),(14,-857790000,2),(14,-844308000,1),(14,-825822000,2),(14,-812685600,1),(14,-794199600,2),(14,-779853600,1),(14,-762663600,2),(14,-399088800,1),(14,-386650800,2),(14,-368330400,1),(14,-355114800,2),(14,-336790800,1),(14,-323654400,2),(14,-305168400,1),(14,-292032000,2),(14,-273632400,1),(14,-260496000,2),(14,-242096400,1),(14,-228960000,2),(14,-210560400,1),(14,-197424000,2),(14,-178938000,1),(14,-165801600,2),(14,-147402000,1),(14,-134265600,2),(14,-115866000,1),(14,-102643200,2),(14,-84330000,1),(14,-71107200,2),(14,-52707600,1),(14,-39484800,2),(14,-21171600,1),(14,-7948800,2),(14,10364400,1),(14,23587200,2),(14,41900400,1),(14,55123200,2),(14,73522800,1),(14,86745600,2),(14,105058800,1),(14,118281600,2),(14,136594800,1),(14,149817600,2),(14,168130800,1),(14,181353600,2),(14,199753200,1),(14,212976000,2),(14,231289200,1),(14,244512000,2),(14,262825200,1),(14,276048000,2),(14,294361200,1),(14,307584000,2),(14,325983600,1),(14,339206400,2),(14,357519600,1),(14,370742400,2),(14,396399600,1),(14,402278400,2),(14,426812400,1),(14,433814400,2),(14,452214000,1),(14,465436800,2),(14,483750000,1),(14,496972800,2),(14,515286000,1),(14,528508800,2),(14,546822000,1),(14,560044800,2),(14,578444400,1),(14,591667200,2),(14,610412400,1),(14,623203200,2),(14,641516400,1),(14,654739200,2),(14,673052400,1),(14,686275200,2),(14,704674800,1),(14,717897600,2),(14,736210800,1),(14,749433600,2),(14,767746800,1),(14,780969600,2),(14,799020000,3),(14,812322000,2),(14,830469600,3),(14,843771600,2),(14,861919200,3),(14,875221200,2),(14,893368800,3),(14,906670800,2),(14,925423200,3),(14,938725200,2),(14,956872800,3),(14,970174800,2),(14,988322400,3),(14,1001624400,2),(14,1019772000,3),(14,1033074000,2),(14,1051221600,3),(14,1064523600,2),(14,1083276000,3),(14,1096578000,2),(14,1114725600,3),(14,1128027600,2),(14,1146175200,3),(14,1158872400,2),(14,1177624800,3),(14,1189112400,2),(14,1209074400,3),(14,1219957200,2),(14,1240524000,3),(14,1250802000,2),(14,1272578400,3),(14,1281474000,2),(14,1284069600,1),(14,1285880400,2),(14,1400191200,1),(14,1403816400,2),(14,1406844000,1),(14,1411678800,2),(15,-2147483648,0),(15,-1773012580,2),(15,-956361600,1),(15,-950490000,2),(15,-942019200,1),(15,-761187600,2),(15,-617241600,1),(15,-605149200,2),(15,-81432000,1),(15,-71110800,2),(15,141264000,1),(15,147222000,2),(15,199756800,1),(15,207702000,2),(15,231292800,1),(15,244249200,2),(15,265507200,1),(15,271033200,2),(15,448243200,3),(15,504918000,2),(15,1212278400,1),(15,1220223600,2),(15,1243814400,1),(15,1250809200,2),(15,1272758400,1),(15,1281222000,2),(15,1301788800,1),(15,1312066800,2),(15,1335664800,1),(15,1342749600,2),(15,1345428000,1),(15,1348970400,2),(15,1367114400,1),(15,1373162400,2),(15,1376100000,1),(15,1382839200,2),(15,1396144800,1),(15,1403920800,2),(15,1406944800,1),(15,1414288800,2),(15,1427594400,1),(15,1434247200,2),(15,1437271200,1),(15,1445738400,2),(15,1459044000,1),(15,1465092000,2),(15,1468116000,1),(15,1477792800,2),(15,1490493600,1),(15,1495332000,2),(15,1498960800,1),(15,1509242400,2),(15,1521943200,1),(15,1526176800,2),(15,1529200800,1),(15,1540692000,3),(15,1557021600,4),(15,1560045600,3),(15,1587261600,4),(15,1590285600,3),(15,1618106400,4),(15,1621130400,3),(15,1648346400,4),(15,1651975200,3),(15,1679191200,4),(15,1682215200,3),(15,1710036000,4),(15,1713060000,3),(15,1740276000,4),(15,1743904800,3),(15,1771120800,4),(15,1774144800,3),(15,1801965600,4),(15,1804989600,3),(15,1832205600,4),(15,1835229600,3),(15,1863050400,4),(15,1866074400,3),(15,1893290400,4),(15,1896919200,3),(15,1924135200,4),(15,1927159200,3),(15,1954980000,4),(15,1958004000,3),(15,1985220000,4),(15,1988848800,3),(15,2016064800,4),(15,2019088800,3),(15,2046304800,4),(15,2049933600,3),(15,2077149600,4),(15,2080173600,3),(15,2107994400,4),(15,2111018400,3),(15,2138234400,4),(15,2141863200,3),(16,-2147483648,1),(16,-1630112400,2),(16,-1616810400,1),(16,-1442451600,2),(16,-1427673600,3),(16,-1379293200,2),(16,-1364774400,3),(16,-1348448400,2),(16,-1333324800,3),(16,-1316390400,2),(16,-1301270400,3),(16,-1293840000,1),(16,-81432000,2),(16,-71110800,1),(16,141264000,2),(16,147222000,1),(16,199756800,2),(16,207702000,1),(16,231292800,2),(16,244249200,1),(16,265507200,2),(16,271033200,1),(16,448243200,4),(16,512528400,5),(16,528253200,6),(16,543978000,5),(16,559702800,6),(16,575427600,5),(16,591152400,6),(16,606877200,5),(16,622602000,6),(16,638326800,5),(16,654656400,6),(16,670381200,5),(16,686106000,6),(16,701830800,5),(16,717555600,6),(16,733280400,5),(16,749005200,6),(16,764730000,5),(16,780454800,6),(16,796179600,5),(16,811904400,6),(16,828234000,5),(16,846378000,6),(16,859683600,5),(16,877827600,6),(16,891133200,5),(16,909277200,6),(16,922582800,5),(16,941331600,6),(16,954032400,5),(16,972781200,6),(16,985482000,5),(16,1004230800,6),(16,1017536400,5),(16,1035680400,6),(16,1048986000,5),(16,1067130000,6),(16,1080435600,5),(16,1099184400,6),(16,1111885200,5),(16,1130634000,6),(16,1143334800,5),(16,1162083600,6),(16,1174784400,5),(16,1193533200,6),(16,1206838800,5),(16,1224982800,6),(16,1238288400,5),(16,1256432400,6),(16,1269738000,5),(16,1288486800,6),(16,1301187600,5),(16,1319936400,6),(16,1332637200,5),(16,1351386000,6),(16,1364691600,5),(16,1382835600,6),(16,1396141200,5),(16,1414285200,6),(16,1427590800,5),(16,1445734800,6),(16,1459040400,5),(16,1477789200,6),(16,1490490000,5),(16,1509238800,6),(16,1521939600,5),(16,1540688400,6),(16,1553994000,5),(16,1572138000,6),(16,1585443600,5),(16,1603587600,6),(16,1616893200,5),(16,1635642000,6),(16,1648342800,5),(16,1667091600,6),(16,1679792400,5),(16,1698541200,6),(16,1711846800,5),(16,1729990800,6),(16,1743296400,5),(16,1761440400,6),(16,1774746000,5),(16,1792890000,6),(16,1806195600,5),(16,1824944400,6),(16,1837645200,5),(16,1856394000,6),(16,1869094800,5),(16,1887843600,6),(16,1901149200,5),(16,1919293200,6),(16,1932598800,5),(16,1950742800,6),(16,1964048400,5),(16,1982797200,6),(16,1995498000,5),(16,2014246800,6),(16,2026947600,5),(16,2045696400,6),(16,2058397200,5),(16,2077146000,6),(16,2090451600,5),(16,2108595600,6),(16,2121901200,5),(16,2140045200,6),(17,-2147483648,0),(17,-1830383032,1),(18,-2147483648,0),(18,-1830383032,1),(19,-2147483648,0),(19,-1309746436,1),(19,-1262314800,2),(19,-946780200,3),(19,-315629100,1),(20,-2147483648,0),(20,-1309746436,1),(20,-1262314800,2),(20,-946780200,3),(20,-315629100,1),(21,-2147483648,0),(21,-1588464816,1),(22,-2147483648,0),(22,-1136070432,1),(22,198291600,3),(22,199756800,2),(22,207702000,3),(22,231292800,2),(22,244249200,3),(22,265507200,2),(22,271033200,3),(22,1212278400,2),(22,1220223600,3),(22,1243814400,2),(22,1250809200,3),(22,1272758400,2),(22,1281222000,3),(22,1301788800,2),(22,1312066800,3),(22,1335664800,2),(22,1342749600,3),(22,1345428000,2),(22,1348970400,3),(22,1367114400,2),(22,1373162400,3),(22,1376100000,2),(22,1382839200,3),(22,1396144800,2),(22,1403920800,3),(22,1406944800,2),(22,1414288800,3),(22,1427594400,2),(22,1434247200,3),(22,1437271200,2),(22,1445738400,3),(22,1459044000,2),(22,1465092000,3),(22,1468116000,2),(22,1477792800,3),(22,1490493600,2),(22,1495332000,3),(22,1498960800,2),(22,1509242400,3),(22,1521943200,2),(22,1526176800,3),(22,1529200800,2),(22,1540692000,5),(22,1557021600,4),(22,1560045600,5),(22,1587261600,4),(22,1590285600,5),(22,1618106400,4),(22,1621130400,5),(22,1648346400,4),(22,1651975200,5),(22,1679191200,4),(22,1682215200,5),(22,1710036000,4),(22,1713060000,5),(22,1740276000,4),(22,1743904800,5),(22,1771120800,4),(22,1774144800,5),(22,1801965600,4),(22,1804989600,5),(22,1832205600,4),(22,1835229600,5),(22,1863050400,4),(22,1866074400,5),(22,1893290400,4),(22,1896919200,5),(22,1924135200,4),(22,1927159200,5),(22,1954980000,4),(22,1958004000,5),(22,1985220000,4),(22,1988848800,5),(22,2016064800,4),(22,2019088800,5),(22,2046304800,4),(22,2049933600,5),(22,2077149600,4),(22,2080173600,5),(22,2107994400,4),(22,2111018400,5),(22,2138234400,4),(22,2141863200,5),(23,-2147483648,0),(23,-1830383032,1),(24,-2147483648,0),(24,-2109291020,1),(25,-2147483648,0),(25,-2109291020,1),(26,-2147483648,1),(26,-2109288600,3),(26,-860976000,2),(26,-845254800,3),(26,-829526400,2),(26,-813805200,3),(27,-2147483648,0),(27,-1230775588,2),(27,10360800,1),(27,24786000,2),(27,41810400,1),(27,56322000,2),(27,73432800,1),(27,87944400,2),(27,104882400,1),(27,119480400,2),(27,136332000,1),(27,151016400,2),(27,167781600,1),(27,182552400,2),(27,199231200,1),(27,214174800,2),(27,230680800,1),(27,245710800,2),(27,262735200,1),(27,277246800,2),(27,294184800,1),(27,308782800,2),(27,325634400,1),(27,340405200,2),(27,357084000,1),(27,371941200,2),(27,388533600,1),(27,403477200,2),(27,419983200,1),(27,435013200,2),(27,452037600,1),(27,466635600,2),(27,483487200,1),(27,498171600,2),(27,947930400,3),(28,-2147483648,0),(28,-1309746436,1),(28,-1262314800,2),(28,-946780200,3),(28,-315629100,1),(29,-2147483648,0),(29,-1230775808,2),(29,10360800,1),(29,24786000,2),(29,41810400,1),(29,56322000,2),(29,73432800,1),(29,87944400,2),(29,104882400,1),(29,119480400,2),(29,136332000,1),(29,151016400,2),(29,167781600,1),(29,182552400,2),(29,199231200,1),(29,214174800,2),(29,230680800,1),(29,245710800,2),(29,262735200,1),(29,277246800,2),(29,294184800,1),(29,308782800,2),(29,325634400,1),(29,340405200,2),(29,357084000,1),(29,371941200,2),(29,388533600,1),(29,403477200,2),(29,419983200,1),(29,435013200,2),(29,452037600,1),(29,466635600,2),(29,483487200,1),(29,498171600,2),(29,947930400,3),(29,1509483600,2),(30,-2147483648,0),(30,-2109291020,1),(31,-2147483648,0),(31,-1588464816,1),(32,-2147483648,0),(32,-1588464816,1),(33,-2147483648,0),(33,-1588464816,1),(34,-2147483648,0),(34,-1830383032,1),(35,-2147483648,0),(35,-1588464816,1),(36,-2147483648,0),(36,-2109291020,1),(37,-2147483648,0),(37,-2109291020,1),(38,-2147483648,0),(38,-1588464816,1),(39,-2147483648,0),(39,-2109291020,1),(40,-2147483648,1),(40,-2109288600,3),(40,-860976000,2),(40,-845254800,3),(40,-829526400,2),(40,-813805200,3),(41,-2147483648,1),(41,-2109288600,3),(41,-860976000,2),(41,-845254800,3),(41,-829526400,2),(41,-813805200,3),(42,-2147483648,0),(42,-1309746436,1),(42,-1262314800,2),(42,-946780200,3),(42,-315629100,1),(43,-2147483648,1),(43,-1604359012,2),(43,63593070,3),(44,-2147483648,0),(44,-1309746436,1),(44,-1262314800,2),(44,-946780200,3),(44,-315629100,1),(45,-2147483648,0),(45,-1830387612,1),(45,308703600,2),(45,321314400,1),(46,-2147483648,0),(46,-1588464816,1),(47,-2147483648,0),(47,-1830383032,1),(48,-2147483648,0),(48,-1830383032,1),(49,-2147483648,0),(49,-1588464816,1),(50,-2147483648,1),(50,-1830384000,2),(50,1514768400,3),(50,1546304400,4),(51,-2147483648,0),(51,-1830383032,1),(52,-2147483648,0),(52,-1577926364,2),(52,-574902000,1),(52,-568087200,2),(52,-512175600,1),(52,-504928800,2),(52,-449888400,1),(52,-441856800,2),(52,-347158800,3),(52,378684000,2),(52,386463600,1),(52,402271200,2),(52,417999600,1),(52,433807200,2),(52,449622000,1),(52,465429600,2),(52,481590000,1),(52,496965600,2),(52,512953200,1),(52,528674400,2),(52,544230000,1),(52,560037600,2),(52,575852400,1),(52,591660000,2),(52,607388400,1),(52,623196000,2),(52,641775600,3),(52,844034400,2),(52,860108400,1),(52,875916000,3),(52,1352505600,2),(52,1364515200,1),(52,1382659200,3),(53,-2147483648,1),(53,-1855958961,4),(53,-969242400,2),(53,-950493600,3),(53,-941940000,2),(53,-891136800,4),(53,-877827600,5),(53,-857257200,4),(53,-844556400,5),(53,-842918400,4),(53,-842223600,5),(53,-828230400,4),(53,-812502000,5),(53,-796269600,4),(53,-781052400,5),(53,-766634400,4),(53,231202800,2),(53,243903600,3),(53,262825200,2),(53,276044400,3),(53,581122800,2),(53,591145200,3),(53,606870000,2),(53,622594800,3),(53,641516400,2),(53,654649200,3),(53,1114902000,2),(53,1128038400,3),(53,1143334800,2),(53,1162083600,3),(53,1174784400,2),(53,1193533200,3),(53,1206838800,2),(53,1224982800,3),(54,-2147483648,1),(54,-2109288600,2),(54,-860976000,3),(54,-845254800,2),(54,637970400,5),(54,764200800,4),(54,778640400,5),(54,796780800,4),(54,810090000,5),(54,828835200,4),(54,841539600,5),(54,860284800,4),(54,873594000,5),(54,891734400,4),(54,905043600,5),(54,923184000,4),(54,936493200,5),(54,954633600,4),(54,967942800,5),(54,986083200,4),(54,999392400,5),(54,1018137600,4),(54,1030842000,5),(54,1049587200,4),(54,1062896400,5),(54,1081036800,4),(54,1094346000,5),(54,1112486400,4),(54,1125795600,5),(54,1143936000,4),(54,1157245200,5),(54,1175385600,4),(54,1188694800,5),(54,1207440000,4),(54,1220749200,5),(54,1238889600,4),(54,1252198800,5),(54,1270339200,4),(54,1283648400,5),(54,1301788800,4),(54,1315098000,5),(54,1333238400,4),(54,1346547600,5),(54,1365292800,4),(54,1377997200,5),(54,1396742400,4),(54,1410051600,5),(54,1428192000,4),(54,1441501200,5),(54,1459641600,4),(54,1472950800,5),(54,1491091200,4),(54,1504400400,5),(55,-2147483648,1),(55,-880196400,2),(55,-769395600,3),(55,-765374400,1),(55,-86878800,4),(55,-21466800,5),(55,-5745600,4),(55,9982800,5),(55,25704000,4),(55,41432400,5),(55,57758400,4),(55,73486800,5),(55,89208000,4),(55,104936400,5),(55,120657600,4),(55,126709200,5),(55,152107200,4),(55,162392400,5),(55,183556800,4),(55,199285200,5),(55,215611200,4),(55,230734800,5),(55,247060800,4),(55,262789200,5),(55,278510400,4),(55,294238800,5),(55,309960000,4),(55,325688400,5),(55,341409600,4),(55,357138000,5),(55,372859200,4),(55,388587600,5),(55,404913600,4),(55,420037200,5),(55,436363200,6),(55,439034400,8),(55,452088000,7),(55,467809200,8),(55,483537600,7),(55,499258800,8),(55,514987200,7),(55,530708400,8),(55,544622400,7),(55,562158000,8),(55,576072000,7),(55,594212400,8),(55,607521600,7),(55,625662000,8),(55,638971200,7),(55,657111600,8),(55,671025600,7),(55,688561200,8),(55,702475200,7),(55,720010800,8),(55,733924800,7),(55,752065200,8),(55,765374400,7),(55,783514800,8),(55,796824000,7),(55,814964400,8),(55,828878400,7),(55,846414000,8),(55,860328000,7),(55,877863600,8),(55,891777600,7),(55,909313200,8),(55,923227200,7),(55,941367600,8),(55,954676800,7),(55,972817200,8),(55,986126400,7),(55,1004266800,8),(55,1018180800,7),(55,1035716400,8),(55,1049630400,7),(55,1067166000,8),(55,1081080000,7),(55,1099220400,8),(55,1112529600,7),(55,1130670000,8),(55,1143979200,7),(55,1162119600,8),(55,1173614400,7),(55,1194174000,8),(55,1205064000,7),(55,1225623600,8),(55,1236513600,7),(55,1257073200,8),(55,1268568000,7),(55,1289127600,8),(55,1300017600,7),(55,1320577200,8),(55,1331467200,7),(55,1352026800,8),(55,1362916800,7),(55,1383476400,8),(55,1394366400,7),(55,1414926000,8),(55,1425816000,7),(55,1446375600,8),(55,1457870400,7),(55,1478430000,8),(55,1489320000,7),(55,1509879600,8),(55,1520769600,7),(55,1541329200,8),(55,1552219200,7),(55,1572778800,8),(55,1583668800,7),(55,1604228400,8),(55,1615723200,7),(55,1636282800,8),(55,1647172800,7),(55,1667732400,8),(55,1678622400,7),(55,1699182000,8),(55,1710072000,7),(55,1730631600,8),(55,1741521600,7),(55,1762081200,8),(55,1772971200,7),(55,1793530800,8),(55,1805025600,7),(55,1825585200,8),(55,1836475200,7),(55,1857034800,8),(55,1867924800,7),(55,1888484400,8),(55,1899374400,7),(55,1919934000,8),(55,1930824000,7),(55,1951383600,8),(55,1962878400,7),(55,1983438000,8),(55,1994328000,7),(55,2014887600,8),(55,2025777600,7),(55,2046337200,8),(55,2057227200,7),(55,2077786800,8),(55,2088676800,7),(55,2109236400,8),(55,2120126400,7),(55,2140686000,8),(56,-2147483648,1),(56,-880200000,2),(56,-769395600,3),(56,-765378000,1),(56,-86882400,4),(56,-21470400,5),(56,-5749200,4),(56,9979200,5),(56,25700400,4),(56,41428800,5),(56,57754800,4),(56,73483200,5),(56,89204400,4),(56,104932800,5),(56,120654000,4),(56,126705600,5),(56,152103600,4),(56,162388800,5),(56,183553200,4),(56,199281600,5),(56,215607600,4),(56,230731200,5),(56,247057200,4),(56,262785600,5),(56,278506800,4),(56,294235200,5),(56,309956400,4),(56,325684800,5),(56,341406000,4),(56,357134400,5),(56,372855600,4),(56,388584000,5),(56,404910000,4),(56,420033600,5),(56,436359600,6),(56,439030800,8),(56,452084400,7),(56,467805600,8),(56,483534000,7),(56,499255200,8),(56,514983600,7),(56,530704800,8),(56,544618800,7),(56,562154400,8),(56,576068400,7),(56,594208800,8),(56,607518000,7),(56,625658400,8),(56,638967600,7),(56,657108000,8),(56,671022000,7),(56,688557600,8),(56,702471600,7),(56,720007200,8),(56,733921200,7),(56,752061600,8),(56,765370800,7),(56,783511200,8),(56,796820400,7),(56,814960800,8),(56,828874800,7),(56,846410400,8),(56,860324400,7),(56,877860000,8),(56,891774000,7),(56,909309600,8),(56,923223600,7),(56,941364000,8),(56,954673200,7),(56,972813600,8),(56,986122800,7),(56,1004263200,8),(56,1018177200,7),(56,1035712800,8),(56,1049626800,7),(56,1067162400,8),(56,1081076400,7),(56,1099216800,8),(56,1112526000,7),(56,1130666400,8),(56,1143975600,7),(56,1162116000,8),(56,1173610800,7),(56,1194170400,8),(56,1205060400,7),(56,1225620000,8),(56,1236510000,7),(56,1257069600,8),(56,1268564400,7),(56,1289124000,8),(56,1300014000,7),(56,1320573600,8),(56,1331463600,7),(56,1352023200,8),(56,1362913200,7),(56,1383472800,8),(56,1394362800,7),(56,1414922400,8),(56,1425812400,7),(56,1446372000,8),(56,1457866800,7),(56,1478426400,8),(56,1489316400,7),(56,1509876000,8),(56,1520766000,7),(56,1541325600,8),(56,1552215600,7),(56,1572775200,8),(56,1583665200,7),(56,1604224800,8),(56,1615719600,7),(56,1636279200,8),(56,1647169200,7),(56,1667728800,8),(56,1678618800,7),(56,1699178400,8),(56,1710068400,7),(56,1730628000,8),(56,1741518000,7),(56,1762077600,8),(56,1772967600,7),(56,1793527200,8),(56,1805022000,7),(56,1825581600,8),(56,1836471600,7),(56,1857031200,8),(56,1867921200,7),(56,1888480800,8),(56,1899370800,7),(56,1919930400,8),(56,1930820400,7),(56,1951380000,8),(56,1962874800,7),(56,1983434400,8),(56,1994324400,7),(56,2014884000,8),(56,2025774000,7),(56,2046333600,8),(56,2057223600,7),(56,2077783200,8),(56,2088673200,7),(56,2109232800,8),(56,2120122800,7),(56,2140682400,8),(57,-2147483648,0),(57,-1825098836,1),(58,-2147483648,0),(58,-1825098836,1),(59,-2147483648,0),(59,-1767214032,2),(59,-1206957600,1),(59,-1191362400,2),(59,-1175374800,1),(59,-1159826400,2),(59,-633819600,1),(59,-622069200,2),(59,-602283600,1),(59,-591832800,2),(59,-570747600,1),(59,-560210400,2),(59,-539125200,1),(59,-531352800,2),(59,-191365200,1),(59,-184197600,2),(59,-155163600,1),(59,-150069600,2),(59,-128898000,1),(59,-121125600,2),(59,-99954000,1),(59,-89589600,2),(59,-68418000,1),(59,-57967200,2),(59,499748400,1),(59,511236000,2),(59,530593200,1),(59,540266400,2),(59,562129200,1),(59,571197600,2),(59,592974000,1),(59,602042400,2),(59,624423600,1),(59,634701600,2),(59,813726000,1),(59,824004000,2),(59,844570800,1),(59,856058400,2),(59,876106800,1),(59,888717600,2),(59,908074800,1),(59,919562400,2),(59,938919600,1),(59,951616800,2),(59,970974000,1),(59,982461600,2),(59,1003028400,1),(59,1013911200,2),(59,1036292400,1),(59,1045360800,2),(59,1350788400,1),(59,1361066400,2),(59,2147483647,2),(60,-2147483648,1),(60,-1567453392,2),(60,-1233432000,3),(60,-1222981200,2),(60,-1205956800,3),(60,-1194037200,2),(60,-1172865600,3),(60,-1162501200,2),(60,-1141329600,3),(60,-1130965200,2),(60,-1109793600,3),(60,-1099429200,2),(60,-1078257600,3),(60,-1067806800,2),(60,-1046635200,3),(60,-1036270800,2),(60,-1015099200,3),(60,-1004734800,2),(60,-983563200,3),(60,-973198800,2),(60,-952027200,3),(60,-941576400,2),(60,-931032000,3),(60,-900882000,2),(60,-890337600,3),(60,-833749200,2),(60,-827265600,3),(60,-752274000,2),(60,-733780800,3),(60,-197326800,2),(60,-190843200,3),(60,-184194000,2),(60,-164491200,3),(60,-152658000,2),(60,-132955200,3),(60,-121122000,2),(60,-101419200,3),(60,-86821200,2),(60,-71092800,3),(60,-54766800,2),(60,-39038400,3),(60,-23317200,2),(60,-7588800,5),(60,128142000,4),(60,136605600,5),(60,596948400,4),(60,605066400,5),(60,624423600,4),(60,636516000,5),(60,656478000,4),(60,667965600,5),(60,687927600,4),(60,699415200,5),(60,719377200,4),(60,731469600,5),(60,938919600,3),(60,952052400,5),(60,1198983600,4),(60,1205632800,5),(60,1224385200,4),(60,1237082400,5),(60,2147483647,5),(61,-2147483648,1),(61,-1567453392,2),(61,-1233432000,3),(61,-1222981200,2),(61,-1205956800,3),(61,-1194037200,2),(61,-1172865600,3),(61,-1162501200,2),(61,-1141329600,3),(61,-1130965200,2),(61,-1109793600,3),(61,-1099429200,2),(61,-1078257600,3),(61,-1067806800,2),(61,-1046635200,3),(61,-1036270800,2),(61,-1015099200,3),(61,-1004734800,2),(61,-983563200,3),(61,-973198800,2),(61,-952027200,3),(61,-941576400,2),(61,-931032000,3),(61,-900882000,2),(61,-890337600,3),(61,-833749200,2),(61,-827265600,3),(61,-752274000,2),(61,-733780800,3),(61,-197326800,2),(61,-190843200,3),(61,-184194000,2),(61,-164491200,3),(61,-152658000,2),(61,-132955200,3),(61,-121122000,2),(61,-101419200,3),(61,-86821200,2),(61,-71092800,3),(61,-54766800,2),(61,-39038400,3),(61,-23317200,2),(61,-7588800,5),(61,128142000,4),(61,136605600,5),(61,596948400,4),(61,605066400,5),(61,624423600,4),(61,636516000,5),(61,656478000,4),(61,667965600,2),(61,687931200,4),(61,699415200,5),(61,719377200,4),(61,731469600,5),(61,938919600,3),(61,952052400,5),(61,1086058800,2),(61,1087704000,5),(61,1198983600,4),(61,1205632800,5),(61,2147483647,5),(62,-2147483648,1),(62,-1567453392,2),(62,-1233432000,3),(62,-1222981200,2),(62,-1205956800,3),(62,-1194037200,2),(62,-1172865600,3),(62,-1162501200,2),(62,-1141329600,3),(62,-1130965200,2),(62,-1109793600,3),(62,-1099429200,2),(62,-1078257600,3),(62,-1067806800,2),(62,-1046635200,3),(62,-1036270800,2),(62,-1015099200,3),(62,-1004734800,2),(62,-983563200,3),(62,-973198800,2),(62,-952027200,3),(62,-941576400,2),(62,-931032000,3),(62,-900882000,2),(62,-890337600,3),(62,-833749200,2),(62,-827265600,3),(62,-752274000,2),(62,-733780800,3),(62,-197326800,2),(62,-190843200,3),(62,-184194000,2),(62,-164491200,3),(62,-152658000,2),(62,-132955200,3),(62,-121122000,2),(62,-101419200,3),(62,-86821200,2),(62,-71092800,3),(62,-54766800,2),(62,-39038400,3),(62,-23317200,2),(62,-7588800,5),(62,128142000,4),(62,136605600,5),(62,596948400,4),(62,605066400,5),(62,624423600,4),(62,636516000,5),(62,656478000,4),(62,667965600,2),(62,687931200,4),(62,699415200,5),(62,719377200,4),(62,731469600,5),(62,938919600,3),(62,952052400,5),(62,1086058800,2),(62,1087704000,5),(62,1198983600,4),(62,1205632800,5),(62,2147483647,5),(63,-2147483648,1),(63,-1567453392,2),(63,-1233432000,3),(63,-1222981200,2),(63,-1205956800,3),(63,-1194037200,2),(63,-1172865600,3),(63,-1162501200,2),(63,-1141329600,3),(63,-1130965200,2),(63,-1109793600,3),(63,-1099429200,2),(63,-1078257600,3),(63,-1067806800,2),(63,-1046635200,3),(63,-1036270800,2),(63,-1015099200,3),(63,-1004734800,2),(63,-983563200,3),(63,-973198800,2),(63,-952027200,3),(63,-941576400,2),(63,-931032000,3),(63,-900882000,2),(63,-890337600,3),(63,-833749200,2),(63,-827265600,3),(63,-752274000,2),(63,-733780800,3),(63,-197326800,2),(63,-190843200,3),(63,-184194000,2),(63,-164491200,3),(63,-152658000,2),(63,-132955200,3),(63,-121122000,2),(63,-101419200,3),(63,-86821200,2),(63,-71092800,3),(63,-54766800,2),(63,-39038400,3),(63,-23317200,2),(63,-7588800,5),(63,128142000,4),(63,136605600,5),(63,596948400,4),(63,605066400,5),(63,624423600,4),(63,636516000,5),(63,656478000,4),(63,667965600,2),(63,687931200,4),(63,699415200,5),(63,719377200,4),(63,731469600,5),(63,938919600,3),(63,952052400,5),(63,1198983600,4),(63,1205632800,5),(63,1224385200,4),(63,1237082400,5),(63,2147483647,5),(64,-2147483648,1),(64,-1567453392,2),(64,-1233432000,3),(64,-1222981200,2),(64,-1205956800,3),(64,-1194037200,2),(64,-1172865600,3),(64,-1162501200,2),(64,-1141329600,3),(64,-1130965200,2),(64,-1109793600,3),(64,-1099429200,2),(64,-1078257600,3),(64,-1067806800,2),(64,-1046635200,3),(64,-1036270800,2),(64,-1015099200,3),(64,-1004734800,2),(64,-983563200,3),(64,-973198800,2),(64,-952027200,3),(64,-941576400,2),(64,-931032000,3),(64,-900882000,2),(64,-890337600,3),(64,-833749200,2),(64,-827265600,3),(64,-752274000,2),(64,-733780800,3),(64,-197326800,2),(64,-190843200,3),(64,-184194000,2),(64,-164491200,3),(64,-152658000,2),(64,-132955200,3),(64,-121122000,2),(64,-101419200,3),(64,-86821200,2),(64,-71092800,3),(64,-54766800,2),(64,-39038400,3),(64,-23317200,2),(64,-7588800,5),(64,128142000,4),(64,136605600,5),(64,596948400,4),(64,605066400,5),(64,624423600,4),(64,636516000,2),(64,657086400,3),(64,669178800,2),(64,686721600,4),(64,699415200,5),(64,719377200,4),(64,731469600,5),(64,938919600,3),(64,952052400,5),(64,1198983600,4),(64,1205632800,5),(64,2147483647,5),(65,-2147483648,1),(65,-1567453392,2),(65,-1233432000,3),(65,-1222981200,2),(65,-1205956800,3),(65,-1194037200,2),(65,-1172865600,3),(65,-1162501200,2),(65,-1141329600,3),(65,-1130965200,2),(65,-1109793600,3),(65,-1099429200,2),(65,-1078257600,3),(65,-1067806800,2),(65,-1046635200,3),(65,-1036270800,2),(65,-1015099200,3),(65,-1004734800,2),(65,-983563200,3),(65,-973198800,2),(65,-952027200,3),(65,-941576400,2),(65,-931032000,3),(65,-900882000,2),(65,-890337600,3),(65,-833749200,2),(65,-827265600,3),(65,-752274000,2),(65,-733780800,3),(65,-197326800,2),(65,-190843200,3),(65,-184194000,2),(65,-164491200,3),(65,-152658000,2),(65,-132955200,3),(65,-121122000,2),(65,-101419200,3),(65,-86821200,2),(65,-71092800,3),(65,-54766800,2),(65,-39038400,3),(65,-23317200,2),(65,-7588800,5),(65,128142000,4),(65,136605600,5),(65,596948400,4),(65,605066400,5),(65,624423600,4),(65,636516000,5),(65,656478000,4),(65,667792800,2),(65,673588800,5),(65,687927600,4),(65,699415200,5),(65,719377200,4),(65,731469600,5),(65,938919600,3),(65,952052400,5),(65,1086058800,2),(65,1087704000,5),(65,1198983600,4),(65,1205632800,5),(65,2147483647,5),(66,-2147483648,1),(66,-1567453392,2),(66,-1233432000,3),(66,-1222981200,2),(66,-1205956800,3),(66,-1194037200,2),(66,-1172865600,3),(66,-1162501200,2),(66,-1141329600,3),(66,-1130965200,2),(66,-1109793600,3),(66,-1099429200,2),(66,-1078257600,3),(66,-1067806800,2),(66,-1046635200,3),(66,-1036270800,2),(66,-1015099200,3),(66,-1004734800,2),(66,-983563200,3),(66,-973198800,2),(66,-952027200,3),(66,-941576400,2),(66,-931032000,3),(66,-900882000,2),(66,-890337600,3),(66,-833749200,2),(66,-827265600,3),(66,-752274000,2),(66,-733780800,3),(66,-197326800,2),(66,-190843200,3),(66,-184194000,2),(66,-164491200,3),(66,-152658000,2),(66,-132955200,3),(66,-121122000,2),(66,-101419200,3),(66,-86821200,2),(66,-71092800,3),(66,-54766800,2),(66,-39038400,3),(66,-23317200,2),(66,-7588800,5),(66,128142000,4),(66,136605600,5),(66,596948400,4),(66,605066400,5),(66,624423600,4),(66,636516000,2),(66,655963200,3),(66,667796400,2),(66,687499200,3),(66,699418800,2),(66,719380800,4),(66,731469600,5),(66,938919600,3),(66,952052400,5),(66,1085281200,2),(66,1096171200,5),(66,1198983600,4),(66,1205632800,5),(66,2147483647,5),(67,-2147483648,1),(67,-1567453392,2),(67,-1233432000,3),(67,-1222981200,2),(67,-1205956800,3),(67,-1194037200,2),(67,-1172865600,3),(67,-1162501200,2),(67,-1141329600,3),(67,-1130965200,2),(67,-1109793600,3),(67,-1099429200,2),(67,-1078257600,3),(67,-1067806800,2),(67,-1046635200,3),(67,-1036270800,2),(67,-1015099200,3),(67,-1004734800,2),(67,-983563200,3),(67,-973198800,2),(67,-952027200,3),(67,-941576400,2),(67,-931032000,3),(67,-900882000,2),(67,-890337600,3),(67,-833749200,2),(67,-827265600,3),(67,-752274000,2),(67,-733780800,3),(67,-197326800,2),(67,-190843200,3),(67,-184194000,2),(67,-164491200,3),(67,-152658000,2),(67,-132955200,3),(67,-121122000,2),(67,-101419200,3),(67,-86821200,2),(67,-71092800,3),(67,-54766800,2),(67,-39038400,3),(67,-23317200,2),(67,-7588800,5),(67,128142000,4),(67,136605600,5),(67,596948400,4),(67,605066400,5),(67,624423600,4),(67,636516000,5),(67,656478000,4),(67,667965600,5),(67,687927600,4),(67,699415200,5),(67,719377200,4),(67,731469600,5),(67,938919600,3),(67,952052400,5),(67,1086058800,2),(67,1087704000,5),(67,1198983600,4),(67,1205632800,5),(67,2147483647,5),(68,-2147483648,1),(68,-1567453392,2),(68,-1233432000,3),(68,-1222981200,2),(68,-1205956800,3),(68,-1194037200,2),(68,-1172865600,3),(68,-1162501200,2),(68,-1141329600,3),(68,-1130965200,2),(68,-1109793600,3),(68,-1099429200,2),(68,-1078257600,3),(68,-1067806800,2),(68,-1046635200,3),(68,-1036270800,2),(68,-1015099200,3),(68,-1004734800,2),(68,-983563200,3),(68,-973198800,2),(68,-952027200,3),(68,-941576400,2),(68,-931032000,3),(68,-900882000,2),(68,-890337600,3),(68,-833749200,2),(68,-827265600,3),(68,-752274000,2),(68,-733780800,3),(68,-197326800,2),(68,-190843200,3),(68,-184194000,2),(68,-164491200,3),(68,-152658000,2),(68,-132955200,3),(68,-121122000,2),(68,-101419200,3),(68,-86821200,2),(68,-71092800,3),(68,-54766800,2),(68,-39038400,3),(68,-23317200,2),(68,-7588800,5),(68,128142000,4),(68,136605600,5),(68,596948400,4),(68,605066400,5),(68,624423600,4),(68,636516000,5),(68,656478000,4),(68,667965600,2),(68,687931200,4),(68,699415200,5),(68,719377200,4),(68,731469600,5),(68,938919600,3),(68,952052400,5),(68,1198983600,4),(68,1205632800,5),(68,2147483647,5),(69,-2147483648,1),(69,-1567453392,2),(69,-1233432000,3),(69,-1222981200,2),(69,-1205956800,3),(69,-1194037200,2),(69,-1172865600,3),(69,-1162501200,2),(69,-1141329600,3),(69,-1130965200,2),(69,-1109793600,3),(69,-1099429200,2),(69,-1078257600,3),(69,-1067806800,2),(69,-1046635200,3),(69,-1036270800,2),(69,-1015099200,3),(69,-1004734800,2),(69,-983563200,3),(69,-973198800,2),(69,-952027200,3),(69,-941576400,2),(69,-931032000,3),(69,-900882000,2),(69,-890337600,3),(69,-833749200,2),(69,-827265600,3),(69,-752274000,2),(69,-733780800,3),(69,-197326800,2),(69,-190843200,3),(69,-184194000,2),(69,-164491200,3),(69,-152658000,2),(69,-132955200,3),(69,-121122000,2),(69,-101419200,3),(69,-86821200,2),(69,-71092800,3),(69,-54766800,2),(69,-39038400,3),(69,-23317200,2),(69,-7588800,5),(69,128142000,4),(69,136605600,5),(69,596948400,4),(69,605066400,5),(69,624423600,4),(69,636516000,5),(69,656478000,4),(69,667792800,2),(69,673588800,5),(69,687927600,4),(69,699415200,5),(69,719377200,4),(69,731469600,5),(69,938919600,3),(69,952052400,5),(69,1085972400,2),(69,1090728000,5),(69,1198983600,4),(69,1205632800,5),(69,2147483647,5),(70,-2147483648,1),(70,-1567453392,2),(70,-1233432000,3),(70,-1222981200,2),(70,-1205956800,3),(70,-1194037200,2),(70,-1172865600,3),(70,-1162501200,2),(70,-1141329600,3),(70,-1130965200,2),(70,-1109793600,3),(70,-1099429200,2),(70,-1078257600,3),(70,-1067806800,2),(70,-1046635200,3),(70,-1036270800,2),(70,-1015099200,3),(70,-1004734800,2),(70,-983563200,3),(70,-973198800,2),(70,-952027200,3),(70,-941576400,2),(70,-931032000,3),(70,-900882000,2),(70,-890337600,3),(70,-833749200,2),(70,-827265600,3),(70,-752274000,2),(70,-733780800,3),(70,-197326800,2),(70,-190843200,3),(70,-184194000,2),(70,-164491200,3),(70,-152658000,2),(70,-132955200,3),(70,-121122000,2),(70,-101419200,3),(70,-86821200,2),(70,-71092800,3),(70,-54766800,2),(70,-39038400,3),(70,-23317200,2),(70,-7588800,5),(70,128142000,4),(70,136605600,5),(70,596948400,4),(70,605066400,5),(70,624423600,4),(70,637380000,2),(70,655963200,3),(70,667796400,2),(70,675748800,5),(70,938919600,3),(70,952052400,5),(70,1085972400,2),(70,1090728000,5),(70,1198983600,4),(70,1200880800,3),(70,1205031600,2),(70,1223784000,3),(70,1236481200,2),(70,1255233600,5),(70,2147483647,5),(71,-2147483648,1),(71,-1567453392,2),(71,-1233432000,3),(71,-1222981200,2),(71,-1205956800,3),(71,-1194037200,2),(71,-1172865600,3),(71,-1162501200,2),(71,-1141329600,3),(71,-1130965200,2),(71,-1109793600,3),(71,-1099429200,2),(71,-1078257600,3),(71,-1067806800,2),(71,-1046635200,3),(71,-1036270800,2),(71,-1015099200,3),(71,-1004734800,2),(71,-983563200,3),(71,-973198800,2),(71,-952027200,3),(71,-941576400,2),(71,-931032000,3),(71,-900882000,2),(71,-890337600,3),(71,-833749200,2),(71,-827265600,3),(71,-752274000,2),(71,-733780800,3),(71,-197326800,2),(71,-190843200,3),(71,-184194000,2),(71,-164491200,3),(71,-152658000,2),(71,-132955200,3),(71,-121122000,2),(71,-101419200,3),(71,-86821200,2),(71,-71092800,3),(71,-54766800,2),(71,-39038400,3),(71,-23317200,2),(71,-7588800,5),(71,128142000,4),(71,136605600,5),(71,596948400,4),(71,605066400,5),(71,624423600,4),(71,636516000,5),(71,656478000,4),(71,667965600,2),(71,687931200,4),(71,699415200,5),(71,719377200,4),(71,731469600,5),(71,938919600,3),(71,952052400,5),(71,1086058800,2),(71,1087099200,5),(71,1198983600,4),(71,1205632800,5),(71,1224385200,4),(71,1237082400,5),(71,2147483647,5),(72,-2147483648,1),(72,-1567453392,2),(72,-1233432000,3),(72,-1222981200,2),(72,-1205956800,3),(72,-1194037200,2),(72,-1172865600,3),(72,-1162501200,2),(72,-1141329600,3),(72,-1130965200,2),(72,-1109793600,3),(72,-1099429200,2),(72,-1078257600,3),(72,-1067806800,2),(72,-1046635200,3),(72,-1036270800,2),(72,-1015099200,3),(72,-1004734800,2),(72,-983563200,3),(72,-973198800,2),(72,-952027200,3),(72,-941576400,2),(72,-931032000,3),(72,-900882000,2),(72,-890337600,3),(72,-833749200,2),(72,-827265600,3),(72,-752274000,2),(72,-733780800,3),(72,-197326800,2),(72,-190843200,3),(72,-184194000,2),(72,-164491200,3),(72,-152658000,2),(72,-132955200,3),(72,-121122000,2),(72,-101419200,3),(72,-86821200,2),(72,-71092800,3),(72,-54766800,2),(72,-39038400,3),(72,-23317200,2),(72,-7588800,5),(72,128142000,4),(72,136605600,5),(72,596948400,4),(72,605066400,5),(72,624423600,4),(72,636516000,5),(72,656478000,4),(72,667965600,5),(72,687927600,4),(72,699415200,5),(72,719377200,4),(72,731469600,5),(72,938919600,3),(72,952052400,5),(72,1085886000,2),(72,1087704000,5),(72,1198983600,4),(72,1205632800,5),(72,2147483647,5),(73,-2147483648,0),(73,-1826738653,1),(73,-157750200,2),(74,-2147483648,1),(74,-1206389360,2),(74,86760000,3),(74,134017200,2),(74,181368000,4),(74,194497200,2),(74,212990400,4),(74,226033200,2),(74,244526400,4),(74,257569200,2),(74,276062400,4),(74,291783600,2),(74,307598400,4),(74,323406000,2),(74,339220800,4),(74,354942000,2),(74,370756800,4),(74,386478000,2),(74,402292800,4),(74,418014000,2),(74,433828800,4),(74,449636400,2),(74,465451200,4),(74,481172400,2),(74,496987200,4),(74,512708400,2),(74,528523200,4),(74,544244400,2),(74,560059200,4),(74,575866800,2),(74,591681600,4),(74,607402800,2),(74,625032000,4),(74,638938800,2),(74,654753600,4),(74,670474800,2),(74,686721600,4),(74,699418800,2),(74,718257600,4),(74,733546800,2),(74,749448000,4),(74,762318000,2),(74,780984000,4),(74,793767600,2),(74,812520000,4),(74,825649200,2),(74,844574400,4),(74,856666800,2),(74,876024000,4),(74,888721200,2),(74,907473600,4),(74,920775600,2),(74,938923200,4),(74,952225200,2),(74,970372800,4),(74,983674800,2),(74,1002427200,4),(74,1018148400,2),(74,1030852800,4),(74,1049598000,2),(74,1062907200,4),(74,1081047600,2),(74,1097985600,4),(74,1110682800,2),(74,1129435200,4),(74,1142132400,2),(74,1160884800,4),(74,1173582000,2),(74,1192939200,4),(74,1205031600,2),(74,1224388800,4),(74,1236481200,2),(74,1255838400,4),(74,1270954800,2),(74,1286078400,4),(74,1302404400,2),(74,1317528000,4),(74,1333854000,2),(74,1349582400,4),(74,1364094000,2),(74,1381032000,4),(74,1395543600,2),(74,1412481600,4),(74,1426993200,2),(74,1443931200,4),(74,1459047600,2),(74,1475380800,4),(74,1490497200,2),(74,1506830400,4),(74,1521946800,2),(74,1538884800,4),(74,1553396400,2),(74,1570334400,4),(74,1584846000,2),(74,1601784000,4),(74,1616900400,2),(74,1633233600,4),(74,1648350000,2),(74,1664683200,4),(74,1679799600,2),(74,1696132800,4),(74,1711249200,2),(74,1728187200,4),(74,1742698800,2),(74,1759636800,4),(74,1774148400,2),(74,1791086400,4),(74,1806202800,2),(74,1822536000,4),(74,1837652400,2),(74,1853985600,4),(74,1869102000,2),(74,1886040000,4),(74,1900551600,2),(74,1917489600,4),(74,1932001200,2),(74,1948939200,4),(74,1964055600,2),(74,1980388800,4),(74,1995505200,2),(74,2011838400,4),(74,2026954800,2),(74,2043288000,4),(74,2058404400,2),(74,2075342400,4),(74,2089854000,2),(74,2106792000,4),(74,2121303600,2),(74,2138241600,4),(74,2147483647,4),(75,-2147483648,2),(75,-1632067200,1),(75,-1615136400,2),(75,-923248800,1),(75,-880214400,3),(75,-769395600,4),(75,-765392400,5),(76,-2147483648,1),(76,-880196400,2),(76,-769395600,3),(76,-765374400,1),(76,-86878800,4),(76,-21466800,5),(76,-5745600,4),(76,9982800,5),(76,25704000,4),(76,41432400,5),(76,57758400,4),(76,73486800,5),(76,89208000,4),(76,104936400,5),(76,120657600,4),(76,126709200,5),(76,152107200,4),(76,162392400,5),(76,183556800,4),(76,199285200,5),(76,215611200,4),(76,230734800,5),(76,247060800,4),(76,262789200,5),(76,278510400,4),(76,294238800,5),(76,309960000,4),(76,325688400,5),(76,341409600,4),(76,357138000,5),(76,372859200,4),(76,388587600,5),(76,404913600,4),(76,420037200,5),(76,436363200,6),(76,439034400,8),(76,452088000,7),(76,467809200,8),(76,483537600,7),(76,499258800,8),(76,514987200,7),(76,530708400,8),(76,544622400,7),(76,562158000,8),(76,576072000,7),(76,594212400,8),(76,607521600,7),(76,625662000,8),(76,638971200,7),(76,657111600,8),(76,671025600,7),(76,688561200,8),(76,702475200,7),(76,720010800,8),(76,733924800,7),(76,752065200,8),(76,765374400,7),(76,783514800,8),(76,796824000,7),(76,814964400,8),(76,828878400,7),(76,846414000,8),(76,860328000,7),(76,877863600,8),(76,891777600,7),(76,909313200,8),(76,923227200,7),(76,941367600,8),(76,954676800,7),(76,972817200,8),(76,986126400,7),(76,1004266800,8),(76,1018180800,7),(76,1035716400,8),(76,1049630400,7),(76,1067166000,8),(76,1081080000,7),(76,1099220400,8),(76,1112529600,7),(76,1130670000,8),(76,1143979200,7),(76,1162119600,8),(76,1173614400,7),(76,1194174000,8),(76,1205064000,7),(76,1225623600,8),(76,1236513600,7),(76,1257073200,8),(76,1268568000,7),(76,1289127600,8),(76,1300017600,7),(76,1320577200,8),(76,1331467200,7),(76,1352026800,8),(76,1362916800,7),(76,1383476400,8),(76,1394366400,7),(76,1414926000,8),(76,1425816000,7),(76,1446375600,8),(76,1457870400,7),(76,1478430000,8),(76,1489320000,7),(76,1509879600,8),(76,1520769600,7),(76,1541329200,8),(76,1552219200,7),(76,1572778800,8),(76,1583668800,7),(76,1604228400,8),(76,1615723200,7),(76,1636282800,8),(76,1647172800,7),(76,1667732400,8),(76,1678622400,7),(76,1699182000,8),(76,1710072000,7),(76,1730631600,8),(76,1741521600,7),(76,1762081200,8),(76,1772971200,7),(76,1793530800,8),(76,1805025600,7),(76,1825585200,8),(76,1836475200,7),(76,1857034800,8),(76,1867924800,7),(76,1888484400,8),(76,1899374400,7),(76,1919934000,8),(76,1930824000,7),(76,1951383600,8),(76,1962878400,7),(76,1983438000,8),(76,1994328000,7),(76,2014887600,8),(76,2025777600,7),(76,2046337200,8),(76,2057227200,7),(76,2077786800,8),(76,2088676800,7),(76,2109236400,8),(76,2120126400,7),(76,2140686000,8),(77,-2147483648,0),(77,-1767216356,2),(77,-1206957600,1),(77,-1191362400,2),(77,-1175374800,1),(77,-1159826400,2),(77,-633819600,1),(77,-622069200,2),(77,-602283600,1),(77,-591832800,2),(77,-570747600,1),(77,-560210400,2),(77,-539125200,1),(77,-531352800,2),(77,-191365200,1),(77,-184197600,2),(77,-155163600,1),(77,-150069600,2),(77,-128898000,1),(77,-121125600,2),(77,-99954000,1),(77,-89589600,2),(77,-68418000,1),(77,-57967200,2),(77,499748400,1),(77,511236000,2),(77,530593200,1),(77,540266400,2),(77,562129200,1),(77,571197600,2),(77,592974000,1),(77,602042400,2),(77,624423600,1),(77,634701600,2),(77,656478000,1),(77,666756000,2),(77,687927600,1),(77,697600800,2),(77,719982000,1),(77,728445600,2),(77,750826800,1),(77,761709600,2),(77,782276400,1),(77,793159200,2),(77,813726000,1),(77,824004000,2),(77,844570800,1),(77,856058400,2),(77,876106800,1),(77,888717600,2),(77,908074800,1),(77,919562400,2),(77,938919600,1),(77,951616800,2),(77,970974000,1),(77,982461600,2),(77,1003028400,1),(77,1013911200,2),(77,1036292400,1),(77,1045360800,2),(77,1318734000,1),(77,1330221600,2),(77,2147483647,2),(78,-2147483648,0),(78,-1514739600,1),(78,-1343066400,2),(78,-1234807200,1),(78,-1220292000,2),(78,-1207159200,1),(78,-1191344400,2),(78,-873828000,1),(78,-661539600,3),(78,28800,1),(78,828867600,4),(78,846403200,1),(78,860317200,4),(78,877852800,1),(78,891766800,4),(78,909302400,1),(78,923216400,4),(78,941356800,1),(78,954666000,4),(78,972806400,1),(78,989139600,4),(78,1001836800,1),(78,1018170000,4),(78,1035705600,1),(78,1049619600,4),(78,1067155200,1),(78,1081069200,4),(78,1099209600,1),(78,1112518800,4),(78,1130659200,1),(78,1143968400,4),(78,1162108800,1),(78,1175418000,4),(78,1193558400,1),(78,1207472400,4),(78,1225008000,1),(78,1238922000,4),(78,1256457600,1),(78,1270371600,5),(78,1288508400,2),(78,1301817600,5),(78,1319958000,2),(78,1333267200,5),(78,1351407600,2),(78,1365321600,5),(78,1382857200,2),(78,1396771200,5),(78,1414306800,2),(78,1428220800,5),(78,1445756400,2),(78,1459670400,5),(78,1477810800,2),(78,1491120000,5),(78,1509260400,2),(78,1522569600,5),(78,1540710000,2),(78,1554624000,5),(78,1572159600,2),(78,1586073600,5),(78,1603609200,2),(78,1617523200,5),(78,1635663600,2),(78,1648972800,5),(78,1667113200,2),(78,1680422400,5),(78,1698562800,2),(78,1712476800,5),(78,1730012400,2),(78,1743926400,5),(78,1761462000,2),(78,1775376000,5),(78,1792911600,2),(78,1806825600,5),(78,1824966000,2),(78,1838275200,5),(78,1856415600,2),(78,1869724800,5),(78,1887865200,2),(78,1901779200,5),(78,1919314800,2),(78,1933228800,5),(78,1950764400,2),(78,1964678400,5),(78,1982818800,2),(78,1996128000,5),(78,2014268400,2),(78,2027577600,5),(78,2045718000,2),(78,2059027200,5),(78,2077167600,2),(78,2091081600,5),(78,2108617200,2),(78,2122531200,5),(78,2140066800,2),(79,-2147483648,0),(79,-1451678491,1),(79,-1199217691,3),(79,234943200,2),(79,244616400,3),(79,261554400,2),(79,276066000,3),(79,293004000,2),(79,307515600,3),(79,325058400,2),(79,338706000,3),(80,-2147483648,0),(80,-1767213964,2),(80,-1206957600,1),(80,-1191362400,2),(80,-1175374800,1),(80,-1159826400,2),(80,-633819600,1),(80,-622069200,2),(80,-602283600,1),(80,-591832800,2),(80,-570747600,1),(80,-560210400,2),(80,-539125200,1),(80,-531352800,2),(80,-191365200,1),(80,-184197600,2),(80,-155163600,1),(80,-150069600,2),(80,-128898000,1),(80,-121125600,2),(80,-99954000,1),(80,-89589600,2),(80,-68418000,1),(80,-57967200,2),(80,499748400,1),(80,511236000,2),(80,530593200,1),(80,540266400,2),(80,562129200,1),(80,571197600,2),(80,2147483647,2),(81,-2147483648,0),(81,-1822500432,2),(81,-1616954400,1),(81,-1606069800,2),(81,-1585504800,1),(81,-1574015400,2),(81,-1554055200,1),(81,-1542565800,2),(81,-1522605600,1),(81,-1511116200,2),(81,-1490551200,1),(81,-1479666600,2),(81,-1459101600,1),(81,-1448217000,2),(81,-1427652000,1),(81,-1416162600,2),(81,-1396202400,1),(81,-1384713000,2),(81,-1364752800,1),(81,-1353263400,2),(81,-1333303200,1),(81,-1321813800,2),(81,-1301248800,1),(81,-1290364200,2),(81,-1269799200,1),(81,-1258914600,2),(81,-1238349600,1),(81,-1226860200,2),(81,-1206900000,1),(81,-1195410600,2),(81,-1175450400,1),(81,-1163961000,2),(81,-1143396000,1),(81,-1132511400,2),(81,-1111946400,1),(81,-1101061800,2),(81,-1080496800,1),(81,-1069612200,2),(81,-1049047200,1),(81,-1037557800,2),(81,-1017597600,1),(81,-1006108200,2),(81,-986148000,1),(81,-974658600,2),(81,-954093600,1),(81,-943209000,2),(81,-922644000,1),(81,-911759400,2),(81,-891194400,1),(81,-879705000,2),(81,-859744800,1),(81,-848255400,2),(81,123919200,3),(81,129618000,2),(81,409039200,3),(81,413874000,2),(82,-2147483648,2),(82,-1632074400,1),(82,-1615143600,2),(82,-880221600,3),(82,-769395600,4),(82,-765399600,2),(83,-2147483648,0),(83,-1767211040,2),(83,-1206954000,1),(83,-1191358800,2),(83,-1175371200,1),(83,-1159822800,2),(83,-633816000,1),(83,-622065600,2),(83,-602280000,1),(83,-591829200,2),(83,-570744000,1),(83,-560206800,2),(83,-539121600,1),(83,-531349200,2),(83,-191361600,1),(83,-184194000,2),(83,-155160000,1),(83,-150066000,2),(83,-128894400,1),(83,-121122000,2),(83,-99950400,1),(83,-89586000,2),(83,-68414400,1),(83,-57963600,2),(83,499752000,1),(83,511239600,2),(83,530596800,1),(83,540270000,2),(83,562132800,1),(83,571201200,2),(83,938923200,1),(83,951620400,2),(83,970977600,1),(83,971578800,2),(83,2147483647,2),(84,-2147483648,1),(84,-1739041424,3),(84,704869200,2),(84,733896000,3),(84,2147483647,3),(85,-2147483648,2),(85,-1633269600,1),(85,-1615129200,2),(85,-1601820000,1),(85,-1583679600,2),(85,-1471788000,5),(85,-880210800,3),(85,-769395600,4),(85,-765388800,5),(85,-84380400,6),(85,-68659200,5),(85,-52930800,6),(85,-37209600,5),(85,-21481200,6),(85,-5760000,5),(85,9968400,6),(85,25689600,5),(85,41418000,6),(85,57744000,5),(85,73472400,6),(85,89193600,5),(85,104922000,6),(85,120643200,5),(85,129114000,6),(85,152092800,5),(85,162378000,6),(85,183542400,5),(85,199270800,6),(85,215596800,5),(85,230720400,6),(85,247046400,5),(85,262774800,6),(85,278496000,5),(85,294224400,6),(85,309945600,5),(85,325674000,6),(85,341395200,5),(85,357123600,6),(85,372844800,5),(85,388573200,6),(85,404899200,5),(85,420022800,6),(85,436348800,5),(85,452077200,6),(85,467798400,5),(85,483526800,6),(85,499248000,5),(85,514976400,6),(85,530697600,5),(85,544611600,6),(85,562147200,5),(85,576061200,6),(85,594201600,5),(85,607510800,6),(85,625651200,5),(85,638960400,6),(85,657100800,5),(85,671014800,6),(85,688550400,5),(85,702464400,6),(85,720000000,5),(85,733914000,6),(85,752054400,5),(85,765363600,6),(85,783504000,5),(85,796813200,6),(85,814953600,5),(85,828867600,6),(85,846403200,5),(85,860317200,6),(85,877852800,5),(85,891766800,6),(85,909302400,5),(85,923216400,6),(85,941356800,5),(85,954666000,6),(85,972806400,5),(85,986115600,6),(85,1004256000,5),(85,1018170000,6),(85,1035705600,5),(85,1049619600,6),(85,1067155200,5),(85,1081069200,6),(85,1099209600,5),(85,1112518800,6),(85,1130659200,5),(85,1143968400,6),(85,1162108800,5),(85,1173603600,6),(85,1194163200,5),(85,1205053200,6),(85,1225612800,5),(85,1236502800,6),(85,1257062400,5),(85,1268557200,6),(85,1289116800,5),(85,1300006800,6),(85,1320566400,5),(85,1331456400,6),(85,1352016000,5),(85,1362906000,6),(85,1383465600,5),(85,1394355600,6),(85,1414915200,5),(85,1425805200,6),(85,1446364800,5),(85,1457859600,6),(85,1478419200,5),(85,1489309200,6),(85,1509868800,5),(85,1520758800,6),(85,1541318400,5),(85,1552208400,6),(85,1572768000,5),(85,1583658000,6),(85,1604217600,5),(85,1615712400,6),(85,1636272000,5),(85,1647162000,6),(85,1667721600,5),(85,1678611600,6),(85,1699171200,5),(85,1710061200,6),(85,1730620800,5),(85,1741510800,6),(85,1762070400,5),(85,1772960400,6),(85,1793520000,5),(85,1805014800,6),(85,1825574400,5),(85,1836464400,6),(85,1857024000,5),(85,1867914000,6),(85,1888473600,5),(85,1899363600,6),(85,1919923200,5),(85,1930813200,6),(85,1951372800,5),(85,1962867600,6),(85,1983427200,5),(85,1994317200,6),(85,2014876800,5),(85,2025766800,6),(85,2046326400,5),(85,2057216400,6),(85,2077776000,5),(85,2088666000,6),(85,2109225600,5),(85,2120115600,6),(85,2140675200,5),(86,-2147483648,1),(86,-1567453392,2),(86,-1233432000,3),(86,-1222981200,2),(86,-1205956800,3),(86,-1194037200,2),(86,-1172865600,3),(86,-1162501200,2),(86,-1141329600,3),(86,-1130965200,2),(86,-1109793600,3),(86,-1099429200,2),(86,-1078257600,3),(86,-1067806800,2),(86,-1046635200,3),(86,-1036270800,2),(86,-1015099200,3),(86,-1004734800,2),(86,-983563200,3),(86,-973198800,2),(86,-952027200,3),(86,-941576400,2),(86,-931032000,3),(86,-900882000,2),(86,-890337600,3),(86,-833749200,2),(86,-827265600,3),(86,-752274000,2),(86,-733780800,3),(86,-197326800,2),(86,-190843200,3),(86,-184194000,2),(86,-164491200,3),(86,-152658000,2),(86,-132955200,3),(86,-121122000,2),(86,-101419200,3),(86,-86821200,2),(86,-71092800,3),(86,-54766800,2),(86,-39038400,3),(86,-23317200,2),(86,-7588800,5),(86,128142000,4),(86,136605600,5),(86,596948400,4),(86,605066400,5),(86,624423600,4),(86,636516000,5),(86,656478000,4),(86,667965600,5),(86,687927600,4),(86,699415200,5),(86,719377200,4),(86,731469600,5),(86,938919600,3),(86,952052400,5),(86,1198983600,4),(86,1205632800,5),(86,1224385200,4),(86,1237082400,5),(86,2147483647,5),(87,-2147483648,0),(87,-1577923200,3),(87,-880210800,1),(87,-769395600,2),(87,-765388800,3),(87,-147891600,4),(87,-131562000,3),(87,325674000,5),(87,341395200,3),(87,357123600,5),(87,372844800,3),(87,388573200,5),(87,404899200,3),(87,420022800,5),(87,436348800,3),(87,452077200,5),(87,467798400,3),(87,483526800,5),(87,499248000,3),(87,514976400,5),(87,530697600,3),(87,544611600,5),(87,562147200,3),(87,576061200,5),(87,594201600,3),(87,607510800,5),(87,625651200,3),(87,638960400,5),(87,657100800,3),(87,671014800,5),(87,688550400,3),(87,702464400,5),(87,720000000,3),(87,733914000,5),(87,752054400,3),(87,765363600,5),(87,783504000,3),(87,796813200,5),(87,814953600,3),(87,828867600,5),(87,846403200,3),(87,860317200,5),(87,877852800,3),(87,891766800,5),(87,909302400,3),(87,923216400,5),(87,941356800,7),(87,954662400,6),(87,972802800,8),(87,973400400,7),(87,986115600,5),(87,1004256000,3),(87,1018170000,5),(87,1035705600,3),(87,1049619600,5),(87,1067155200,3),(87,1081069200,5),(87,1099209600,3),(87,1112518800,5),(87,1130659200,3),(87,1143968400,5),(87,1162108800,3),(87,1173603600,5),(87,1194163200,3),(87,1205053200,5),(87,1225612800,3),(87,1236502800,5),(87,1257062400,3),(87,1268557200,5),(87,1289116800,3),(87,1300006800,5),(87,1320566400,3),(87,1331456400,5),(87,1352016000,3),(87,1362906000,5),(87,1383465600,3),(87,1394355600,5),(87,1414915200,3),(87,1425805200,5),(87,1446364800,3),(87,1457859600,5),(87,1478419200,3),(87,1489309200,5),(87,1509868800,3),(87,1520758800,5),(87,1541318400,3),(87,1552208400,5),(87,1572768000,3),(87,1583658000,5),(87,1604217600,3),(87,1615712400,5),(87,1636272000,3),(87,1647162000,5),(87,1667721600,3),(87,1678611600,5),(87,1699171200,3),(87,1710061200,5),(87,1730620800,3),(87,1741510800,5),(87,1762070400,3),(87,1772960400,5),(87,1793520000,3),(87,1805014800,5),(87,1825574400,3),(87,1836464400,5),(87,1857024000,3),(87,1867914000,5),(87,1888473600,3),(87,1899363600,5),(87,1919923200,3),(87,1930813200,5),(87,1951372800,3),(87,1962867600,5),(87,1983427200,3),(87,1994317200,5),(87,2014876800,3),(87,2025766800,5),(87,2046326400,3),(87,2057216400,5),(87,2077776000,3),(87,2088666000,5),(87,2109225600,3),(87,2120115600,5),(87,2140675200,3),(88,-2147483648,0),(88,-1767212492,2),(88,-1206954000,1),(88,-1191358800,2),(88,-1175371200,1),(88,-1159822800,2),(88,-633816000,1),(88,-622065600,2),(88,-602280000,1),(88,-591829200,2),(88,-570744000,1),(88,-560206800,2),(88,-539121600,1),(88,-531349200,2),(88,-191361600,1),(88,-184194000,2),(88,-155160000,1),(88,-150066000,2),(88,-128894400,1),(88,-121122000,2),(88,-99950400,1),(88,-89586000,2),(88,-68414400,1),(88,-57963600,2),(88,499752000,1),(88,511239600,2),(88,530596800,1),(88,540270000,2),(88,562132800,1),(88,571201200,2),(88,592977600,1),(88,602046000,2),(88,624427200,1),(88,634705200,2),(88,656481600,1),(88,666759600,2),(88,687931200,1),(88,697604400,2),(88,719985600,1),(88,728449200,2),(88,750830400,1),(88,761713200,2),(88,782280000,1),(88,793162800,2),(88,813729600,1),(88,824007600,2),(88,844574400,1),(88,856062000,2),(88,876110400,1),(88,888721200,2),(88,908078400,1),(88,919566000,2),(88,938923200,1),(88,951620400,2),(88,970977600,1),(88,982465200,2),(88,1003032000,1),(88,1013914800,2),(88,1036296000,1),(88,1045364400,2),(88,1066536000,1),(88,1076814000,2),(88,1099368000,1),(88,1108868400,2),(88,1129435200,1),(88,1140318000,2),(88,1162699200,1),(88,1172372400,2),(88,1192334400,1),(88,1203217200,2),(88,1224388800,1),(88,1234666800,2),(88,1255838400,1),(88,1266721200,2),(88,1287288000,1),(88,1298170800,2),(88,1318737600,1),(88,1330225200,2),(88,1350792000,1),(88,1361070000,2),(88,1382241600,1),(88,1392519600,2),(88,1413691200,1),(88,1424574000,2),(88,1445140800,1),(88,1456023600,2),(88,1476590400,1),(88,1487473200,2),(88,1508040000,1),(88,1518922800,2),(88,1541304000,1),(88,1550372400,2),(88,1572753600,1),(88,1581822000,2),(88,1604203200,1),(88,1613876400,2),(88,1636257600,1),(88,1645326000,2),(88,1667707200,1),(88,1677380400,2),(88,1699156800,1),(88,1708225200,2),(88,1730606400,1),(88,1739674800,2),(88,1762056000,1),(88,1771729200,2),(88,1793505600,1),(88,1803178800,2),(88,1825560000,1),(88,1834628400,2),(88,1857009600,1),(88,1866078000,2),(88,1888459200,1),(88,1897527600,2),(88,1919908800,1),(88,1928977200,2),(88,1951358400,1),(88,1960426800,2),(88,1983412800,1),(88,1992481200,2),(88,2014862400,1),(88,2024535600,2),(88,2046312000,1),(88,2055380400,2),(88,2077761600,1),(88,2086830000,2),(88,2109211200,1),(88,2118884400,2),(88,2140660800,1),(89,-2147483648,0),(89,-1514743200,1),(89,377935200,3),(89,828860400,2),(89,846396000,3),(89,860310000,2),(89,877845600,3),(89,891759600,2),(89,902037600,4),(89,909298800,1),(89,923212800,4),(89,941353200,1),(89,954662400,4),(89,972802800,1),(89,989136000,4),(89,1001833200,1),(89,1018166400,4),(89,1035702000,1),(89,1049616000,4),(89,1067151600,1),(89,1081065600,4),(89,1099206000,1),(89,1112515200,4),(89,1130655600,1),(89,1143964800,4),(89,1162105200,1),(89,1175414400,4),(89,1193554800,1),(89,1207468800,4),(89,1225004400,1),(89,1238918400,4),(89,1256454000,1),(89,1270368000,4),(89,1288508400,1),(89,1301817600,4),(89,1319958000,1),(89,1333267200,4),(89,1351407600,1),(89,1365321600,4),(89,1382857200,1),(89,1396771200,4),(89,1414306800,1),(89,1422777600,3),(90,-2147483648,1),(90,-1826739140,2),(90,-157750200,3),(90,1197183600,2),(90,1462086000,3),(90,2147483647,3),(91,-2147483648,1),(91,-1567453392,2),(91,-1233432000,3),(91,-1222981200,2),(91,-1205956800,3),(91,-1194037200,2),(91,-1172865600,3),(91,-1162501200,2),(91,-1141329600,3),(91,-1130965200,2),(91,-1109793600,3),(91,-1099429200,2),(91,-1078257600,3),(91,-1067806800,2),(91,-1046635200,3),(91,-1036270800,2),(91,-1015099200,3),(91,-1004734800,2),(91,-983563200,3),(91,-973198800,2),(91,-952027200,3),(91,-941576400,2),(91,-931032000,3),(91,-900882000,2),(91,-890337600,3),(91,-833749200,2),(91,-827265600,3),(91,-752274000,2),(91,-733780800,3),(91,-197326800,2),(91,-190843200,3),(91,-184194000,2),(91,-164491200,3),(91,-152658000,2),(91,-132955200,3),(91,-121122000,2),(91,-101419200,3),(91,-86821200,2),(91,-71092800,3),(91,-54766800,2),(91,-39038400,3),(91,-23317200,2),(91,-7588800,5),(91,128142000,4),(91,136605600,5),(91,596948400,4),(91,605066400,5),(91,624423600,4),(91,636516000,5),(91,656478000,4),(91,667965600,2),(91,687931200,4),(91,699415200,5),(91,719377200,4),(91,731469600,5),(91,938919600,3),(91,952052400,5),(91,1086058800,2),(91,1087704000,5),(91,1198983600,4),(91,1205632800,5),(91,2147483647,5),(92,-2147483648,0),(92,-1846269040,1),(92,-71092800,2),(92,2147483647,2),(93,-2147483648,1),(93,-1946918424,2),(94,-2147483648,2),(94,-1633276800,1),(94,-1615136400,2),(94,-1601827200,1),(94,-1583686800,2),(94,-1563724800,1),(94,-1551632400,2),(94,-1538928000,1),(94,-1520182800,2),(94,-1504454400,1),(94,-1491757200,2),(94,-1473004800,1),(94,-1459702800,2),(94,-1441555200,1),(94,-1428253200,2),(94,-1410105600,1),(94,-1396803600,2),(94,-1378656000,1),(94,-1365354000,2),(94,-1347206400,1),(94,-1333904400,2),(94,-1315152000,1),(94,-1301850000,2),(94,-1283702400,1),(94,-1270400400,2),(94,-1252252800,1),(94,-1238950800,2),(94,-1220803200,1),(94,-1207501200,2),(94,-1189353600,1),(94,-1176051600,2),(94,-1157299200,1),(94,-1144602000,2),(94,-1125849600,1),(94,-1112547600,2),(94,-1094400000,1),(94,-1081098000,2),(94,-1067788800,3),(94,-1045414800,2),(94,-1031500800,1),(94,-1018198800,2),(94,-1000051200,1),(94,-986749200,2),(94,-967996800,1),(94,-955299600,2),(94,-936547200,1),(94,-923245200,2),(94,-905097600,1),(94,-891795600,2),(94,-880214400,4),(94,-769395600,5),(94,-765392400,2),(94,-747244800,1),(94,-733942800,2),(94,-715795200,1),(94,-702493200,2),(94,-684345600,1),(94,-671043600,2),(94,-652896000,1),(94,-639594000,2),(94,-620841600,1),(94,-608144400,2),(94,-589392000,1),(94,-576090000,2),(94,-557942400,1),(94,-544640400,2),(94,-526492800,1),(94,-513190800,2),(94,-495043200,1),(94,-481741200,2),(94,-463593600,1),(94,-447267600,2),(94,-431539200,1),(94,-415818000,2),(94,-400089600,1),(94,-384368400,2),(94,-368640000,1),(94,-352918800,2),(94,-337190400,1),(94,-321469200,2),(94,-305740800,1),(94,-289414800,2),(94,-273686400,1),(94,-257965200,2),(94,-242236800,1),(94,-226515600,2),(94,-210787200,1),(94,-195066000,2),(94,-179337600,1),(94,-163616400,2),(94,-147888000,1),(94,-131562000,2),(94,-116438400,1),(94,-100112400,2),(94,-84384000,1),(94,-68662800,2),(94,-52934400,1),(94,-37213200,2),(94,-21484800,1),(94,-5763600,2),(94,9964800,1),(94,25686000,2),(94,41414400,1),(94,57740400,2),(94,73468800,1),(94,89190000,2),(94,104918400,1),(94,120639600,2),(94,126691200,1),(94,152089200,2),(94,162374400,1),(94,183538800,2),(94,199267200,1),(94,215593200,2),(94,230716800,1),(94,247042800,2),(94,262771200,1),(94,278492400,2),(94,294220800,1),(94,309942000,2),(94,325670400,1),(94,341391600,2),(94,357120000,1),(94,372841200,2),(94,388569600,1),(94,404895600,2),(94,420019200,1),(94,436345200,2),(94,452073600,1),(94,467794800,2),(94,483523200,1),(94,499244400,2),(94,514972800,1),(94,530694000,2),(94,544608000,1),(94,562143600,2),(94,576057600,1),(94,594198000,2),(94,607507200,1),(94,625647600,2),(94,638956800,1),(94,657097200,2),(94,671011200,1),(94,688546800,2),(94,702460800,1),(94,719996400,2),(94,733910400,1),(94,752050800,2),(94,765360000,1),(94,783500400,2),(94,796809600,1),(94,814950000,2),(94,828864000,1),(94,846399600,2),(94,860313600,1),(94,877849200,2),(94,891763200,1),(94,909298800,2),(94,923212800,1),(94,941353200,2),(94,954662400,1),(94,972802800,2),(94,986112000,1),(94,1004252400,2),(94,1018166400,1),(94,1035702000,2),(94,1049616000,1),(94,1067151600,2),(94,1081065600,1),(94,1099206000,2),(94,1112515200,1),(94,1130655600,2),(94,1143964800,1),(94,1162105200,2),(94,1173600000,1),(94,1194159600,2),(94,1205049600,1),(94,1225609200,2),(94,1236499200,1),(94,1257058800,2),(94,1268553600,1),(94,1289113200,2),(94,1300003200,1),(94,1320562800,2),(94,1331452800,1),(94,1352012400,2),(94,1362902400,1),(94,1383462000,2),(94,1394352000,1),(94,1414911600,2),(94,1425801600,1),(94,1446361200,2),(94,1457856000,1),(94,1478415600,2),(94,1489305600,1),(94,1509865200,2),(94,1520755200,1),(94,1541314800,2),(94,1552204800,1),(94,1572764400,2),(94,1583654400,1),(94,1604214000,2),(94,1615708800,1),(94,1636268400,2),(94,1647158400,1),(94,1667718000,2),(94,1678608000,1),(94,1699167600,2),(94,1710057600,1),(94,1730617200,2),(94,1741507200,1),(94,1762066800,2),(94,1772956800,1),(94,1793516400,2),(94,1805011200,1),(94,1825570800,2),(94,1836460800,1),(94,1857020400,2),(94,1867910400,1),(94,1888470000,2),(94,1899360000,1),(94,1919919600,2),(94,1930809600,1),(94,1951369200,2),(94,1962864000,1),(94,1983423600,2),(94,1994313600,1),(94,2014873200,2),(94,2025763200,1),(94,2046322800,2),(94,2057212800,1),(94,2077772400,2),(94,2088662400,1),(94,2109222000,2),(94,2120112000,1),(94,2140671600,2),(95,-2147483648,0),(95,-1514739600,1),(95,-1343066400,2),(95,-1234807200,1),(95,-1220292000,2),(95,-1207159200,1),(95,-1191344400,2),(95,828864000,3),(95,846399600,2),(95,860313600,3),(95,877849200,2),(95,891766800,4),(95,909302400,1),(95,923216400,4),(95,941356800,1),(95,954666000,4),(95,972806400,1),(95,989139600,4),(95,1001836800,1),(95,1018170000,4),(95,1035705600,1),(95,1049619600,4),(95,1067155200,1),(95,1081069200,4),(95,1099209600,1),(95,1112518800,4),(95,1130659200,1),(95,1143968400,4),(95,1162108800,1),(95,1175418000,4),(95,1193558400,1),(95,1207472400,4),(95,1225008000,1),(95,1238922000,4),(95,1256457600,1),(95,1270371600,4),(95,1288512000,1),(95,1301821200,4),(95,1319961600,1),(95,1333270800,4),(95,1351411200,1),(95,1365325200,4),(95,1382860800,1),(95,1396774800,4),(95,1414310400,1),(95,1428224400,4),(95,1445760000,1),(95,1459674000,4),(95,1477814400,1),(95,1491123600,4),(95,1509264000,1),(95,1522573200,4),(95,1540713600,1),(95,1554627600,4),(95,1572163200,1),(95,1586077200,4),(95,1603612800,1),(95,1617526800,4),(95,1635667200,1),(95,1648976400,4),(95,1667116800,1),(95,1680426000,4),(95,1698566400,1),(95,1712480400,4),(95,1730016000,1),(95,1743930000,4),(95,1761465600,1),(95,1775379600,4),(95,1792915200,1),(95,1806829200,4),(95,1824969600,1),(95,1838278800,4),(95,1856419200,1),(95,1869728400,4),(95,1887868800,1),(95,1901782800,4),(95,1919318400,1),(95,1933232400,4),(95,1950768000,1),(95,1964682000,4),(95,1982822400,1),(95,1996131600,4),(95,2014272000,1),(95,2027581200,4),(95,2045721600,1),(95,2059030800,4),(95,2077171200,1),(95,2091085200,4),(95,2108620800,1),(95,2122534800,4),(95,2140070400,1),(96,-2147483648,2),(96,-1632067200,1),(96,-1615136400,2),(96,-923248800,1),(96,-880214400,3),(96,-769395600,4),(96,-765392400,5),(97,-2147483648,1),(97,-1567453392,2),(97,-1233432000,3),(97,-1222981200,2),(97,-1205956800,3),(97,-1194037200,2),(97,-1172865600,3),(97,-1162501200,2),(97,-1141329600,3),(97,-1130965200,2),(97,-1109793600,3),(97,-1099429200,2),(97,-1078257600,3),(97,-1067806800,2),(97,-1046635200,3),(97,-1036270800,2),(97,-1015099200,3),(97,-1004734800,2),(97,-983563200,3),(97,-973198800,2),(97,-952027200,3),(97,-941576400,2),(97,-931032000,3),(97,-900882000,2),(97,-890337600,3),(97,-833749200,2),(97,-827265600,3),(97,-752274000,2),(97,-733780800,3),(97,-197326800,2),(97,-190843200,3),(97,-184194000,2),(97,-164491200,3),(97,-152658000,2),(97,-132955200,3),(97,-121122000,2),(97,-101419200,3),(97,-86821200,2),(97,-71092800,3),(97,-54766800,2),(97,-39038400,3),(97,-23317200,2),(97,-7588800,5),(97,128142000,4),(97,136605600,5),(97,596948400,4),(97,605066400,5),(97,624423600,4),(97,636516000,5),(97,656478000,4),(97,667965600,2),(97,687931200,4),(97,699415200,5),(97,719377200,4),(97,731469600,5),(97,938919600,3),(97,952052400,5),(97,1198983600,4),(97,1205632800,5),(97,1224385200,4),(97,1237082400,5),(97,2147483647,5),(98,-2147483648,1),(98,-1545071027,3),(98,288770400,2),(98,297234000,3),(98,320220000,2),(98,328683600,3),(98,664264800,2),(98,678344400,3),(98,695714400,2),(98,700635600,3),(99,-2147483648,1),(99,-1680454800,2),(99,-1627833600,1),(100,-2147483648,0),(100,-1767212140,2),(100,-1206954000,1),(100,-1191358800,2),(100,-1175371200,1),(100,-1159822800,2),(100,-633816000,1),(100,-622065600,2),(100,-602280000,1),(100,-591829200,2),(100,-570744000,1),(100,-560206800,2),(100,-539121600,1),(100,-531349200,2),(100,-191361600,1),(100,-184194000,2),(100,-155160000,1),(100,-150066000,2),(100,-128894400,1),(100,-121122000,2),(100,-99950400,1),(100,-89586000,2),(100,-68414400,1),(100,-57963600,2),(100,499752000,1),(100,511239600,2),(100,530596800,1),(100,540270000,2),(100,562132800,1),(100,571201200,2),(100,592977600,1),(100,602046000,2),(100,624427200,1),(100,634705200,2),(100,656481600,1),(100,666759600,2),(100,687931200,1),(100,697604400,2),(100,719985600,1),(100,728449200,2),(100,750830400,1),(100,761713200,2),(100,782280000,1),(100,793162800,2),(100,813729600,1),(100,824007600,2),(100,844574400,1),(100,856062000,2),(100,876110400,1),(100,888721200,2),(100,908078400,1),(100,919566000,2),(100,938923200,1),(100,951620400,2),(100,970977600,1),(100,982465200,2),(100,1003032000,1),(100,1013914800,2),(100,1036296000,1),(100,1045364400,2),(100,1099368000,1),(100,1108868400,2),(100,1129435200,1),(100,1140318000,2),(100,1162699200,1),(100,1172372400,2),(100,1192334400,1),(100,1203217200,2),(100,1224388800,1),(100,1234666800,2),(100,1255838400,1),(100,1266721200,2),(100,1287288000,1),(100,1298170800,2),(100,1318737600,1),(100,1330225200,2),(100,1350792000,1),(100,1361070000,2),(100,1382241600,1),(100,1392519600,2),(100,1413691200,1),(100,1424574000,2),(100,1445140800,1),(100,1456023600,2),(100,1476590400,1),(100,1487473200,2),(100,1508040000,1),(100,1518922800,2),(100,1541304000,1),(100,1550372400,2),(100,1572753600,1),(100,1581822000,2),(100,1604203200,1),(100,1613876400,2),(100,1636257600,1),(100,1645326000,2),(100,1667707200,1),(100,1677380400,2),(100,1699156800,1),(100,1708225200,2),(100,1730606400,1),(100,1739674800,2),(100,1762056000,1),(100,1771729200,2),(100,1793505600,1),(100,1803178800,2),(100,1825560000,1),(100,1834628400,2),(100,1857009600,1),(100,1866078000,2),(100,1888459200,1),(100,1897527600,2),(100,1919908800,1),(100,1928977200,2),(100,1951358400,1),(100,1960426800,2),(100,1983412800,1),(100,1992481200,2),(100,2014862400,1),(100,2024535600,2),(100,2046312000,1),(100,2055380400,2),(100,2077761600,1),(100,2086830000,2),(100,2109211200,1),(100,2118884400,2),(100,2140660800,1),(101,-2147483648,0),(101,-1826738653,1),(101,-157750200,2),(102,-2147483648,0),(102,-1686091520,1),(102,323845200,4),(102,338950800,2),(102,354675600,3),(102,370400400,2),(102,386125200,3),(102,401850000,2),(102,417574800,3),(102,433299600,2),(102,449024400,3),(102,465354000,2),(102,481078800,3),(102,496803600,2),(102,512528400,3),(102,528253200,2),(102,543978000,3),(102,559702800,2),(102,575427600,3),(102,591152400,2),(102,606877200,3),(102,622602000,2),(102,638326800,3),(102,654656400,2),(102,670381200,3),(102,686106000,2),(102,701830800,3),(102,717555600,2),(102,733280400,3),(102,749005200,2),(102,764730000,3),(102,780454800,2),(102,796179600,3),(102,811904400,2),(102,820465200,5),(103,-2147483648,2),(103,-1632056400,1),(103,-1615125600,2),(103,-1596978000,1),(103,-1583164800,2),(103,-880203600,3),(103,-769395600,4),(103,-765381600,2),(103,-147884400,5),(103,-131554800,2),(103,120646800,6),(103,325677600,7),(103,341398800,6),(103,357127200,7),(103,372848400,6),(103,388576800,7),(103,404902800,6),(103,420026400,7),(103,436352400,6),(103,452080800,7),(103,467802000,6),(103,483530400,7),(103,499251600,6),(103,514980000,7),(103,530701200,6),(103,544615200,7),(103,562150800,6),(103,576064800,7),(103,594205200,6),(103,607514400,7),(103,625654800,6),(103,638964000,7),(103,657104400,6),(103,671018400,7),(103,688554000,6),(103,702468000,7),(103,720003600,6),(103,733917600,7),(103,752058000,6),(103,765367200,7),(103,783507600,6),(103,796816800,7),(103,814957200,6),(103,828871200,7),(103,846406800,6),(103,860320800,7),(103,877856400,6),(103,891770400,7),(103,909306000,6),(103,923220000,7),(103,941360400,6),(103,954669600,7),(103,972810000,6),(103,986119200,7),(103,1004259600,6),(103,1018173600,7),(103,1035709200,6),(103,1049623200,7),(103,1067158800,6),(103,1081072800,7),(103,1099213200,6),(103,1112522400,7),(103,1130662800,6),(103,1143972000,7),(103,1162112400,6),(103,1173607200,7),(103,1194166800,6),(103,1205056800,7),(103,1225616400,6),(103,1236506400,7),(103,1257066000,6),(103,1268560800,7),(103,1289120400,6),(103,1300010400,7),(103,1320570000,6),(103,1331460000,7),(103,1352019600,6),(103,1362909600,7),(103,1383469200,6),(103,1394359200,7),(103,1414918800,6),(103,1425808800,7),(103,1446368400,6),(103,1457863200,7),(103,1478422800,6),(103,1489312800,7),(103,1509872400,6),(103,1520762400,7),(103,1541322000,6),(103,1552212000,7),(103,1572771600,6),(103,1583661600,7),(103,1604221200,6),(103,1615716000,7),(103,1636275600,6),(103,1647165600,7),(103,1667725200,6),(103,1678615200,7),(103,1699174800,6),(103,1710064800,7),(103,1730624400,6),(103,1741514400,7),(103,1762074000,6),(103,1772964000,7),(103,1793523600,6),(103,1805018400,7),(103,1825578000,6),(103,1836468000,7),(103,1857027600,6),(103,1867917600,7),(103,1888477200,6),(103,1899367200,7),(103,1919926800,6),(103,1930816800,7),(103,1951376400,6),(103,1962871200,7),(103,1983430800,6),(103,1994320800,7),(103,2014880400,6),(103,2025770400,7),(103,2046330000,6),(103,2057220000,7),(103,2077779600,6),(103,2088669600,7),(103,2109229200,6),(103,2120119200,7),(103,2140678800,6),(104,-2147483648,2),(104,-1632060000,1),(104,-1615129200,2),(104,-880207200,3),(104,-769395600,4),(104,-765385200,2),(104,-715788000,1),(104,-702486000,2),(104,-684338400,1),(104,-671036400,2),(104,-652888800,1),(104,-639586800,2),(104,-620834400,1),(104,-608137200,2),(104,-589384800,1),(104,-576082800,2),(104,-557935200,1),(104,-544633200,2),(104,-526485600,1),(104,-513183600,2),(104,-495036000,1),(104,-481734000,2),(104,-463586400,1),(104,-450284400,2),(104,-431532000,1),(104,-418230000,2),(104,-400082400,1),(104,-386780400,2),(104,-368632800,1),(104,-355330800,2),(104,-337183200,1),(104,-323881200,2),(104,-305733600,1),(104,-292431600,2),(104,-273679200,1),(104,-260982000,2),(104,-242229600,1),(104,-226508400,2),(104,-210780000,1),(104,-195058800,2),(104,-179330400,1),(104,-163609200,2),(104,-147880800,1),(104,-131554800,2),(104,-116431200,1),(104,-100105200,2),(104,-84376800,1),(104,-68655600,2),(104,-52927200,1),(104,-37206000,2),(104,-21477600,1),(104,-5756400,2),(104,9972000,1),(104,25693200,2),(104,41421600,1),(104,57747600,2),(104,73476000,1),(104,84013200,5),(105,-2147483648,2),(105,-1633273200,1),(105,-1615132800,2),(105,-1601823600,1),(105,-1583683200,2),(105,-1570374000,1),(105,-1551628800,2),(105,-1538924400,1),(105,-1534089600,2),(105,-880210800,3),(105,-769395600,4),(105,-765388800,2),(105,-147884400,1),(105,-131558400,2),(105,-116434800,1),(105,-100108800,2),(105,-84380400,1),(105,-68659200,2),(105,-52930800,1),(105,-37209600,2),(105,-21481200,1),(105,-5760000,2),(105,9968400,1),(105,25689600,2),(105,41418000,1),(105,57744000,2),(105,73472400,1),(105,89193600,2),(105,104922000,1),(105,120643200,2),(105,126694800,1),(105,152092800,2),(105,162378000,1),(105,183542400,2),(105,199270800,1),(105,215596800,2),(105,230720400,1),(105,247046400,2),(105,262774800,1),(105,278496000,2),(105,294224400,1),(105,309945600,2),(105,325674000,1),(105,341395200,2),(105,357123600,1),(105,372844800,2),(105,388573200,1),(105,404899200,2),(105,420022800,1),(105,436348800,2),(105,452077200,1),(105,467798400,2),(105,483526800,1),(105,499248000,2),(105,514976400,1),(105,530697600,2),(105,544611600,1),(105,562147200,2),(105,576061200,1),(105,594201600,2),(105,607510800,1),(105,625651200,2),(105,638960400,1),(105,657100800,2),(105,671014800,1),(105,688550400,2),(105,702464400,1),(105,720000000,2),(105,733914000,1),(105,752054400,2),(105,765363600,1),(105,783504000,2),(105,796813200,1),(105,814953600,2),(105,828867600,1),(105,846403200,2),(105,860317200,1),(105,877852800,2),(105,891766800,1),(105,909302400,2),(105,923216400,1),(105,941356800,2),(105,954666000,1),(105,972806400,2),(105,986115600,1),(105,1004256000,2),(105,1018170000,1),(105,1035705600,2),(105,1049619600,1),(105,1067155200,2),(105,1081069200,1),(105,1099209600,2),(105,1112518800,1),(105,1130659200,2),(105,1143968400,1),(105,1162108800,2),(105,1173603600,1),(105,1194163200,2),(105,1205053200,1),(105,1225612800,2),(105,1236502800,1),(105,1257062400,2),(105,1268557200,1),(105,1289116800,2),(105,1300006800,1),(105,1320566400,2),(105,1331456400,1),(105,1352016000,2),(105,1362906000,1),(105,1383465600,2),(105,1394355600,1),(105,1414915200,2),(105,1425805200,1),(105,1446364800,2),(105,1457859600,1),(105,1478419200,2),(105,1489309200,1),(105,1509868800,2),(105,1520758800,1),(105,1541318400,2),(105,1552208400,1),(105,1572768000,2),(105,1583658000,1),(105,1604217600,2),(105,1615712400,1),(105,1636272000,2),(105,1647162000,1),(105,1667721600,2),(105,1678611600,1),(105,1699171200,2),(105,1710061200,1),(105,1730620800,2),(105,1741510800,1),(105,1762070400,2),(105,1772960400,1),(105,1793520000,2),(105,1805014800,1),(105,1825574400,2),(105,1836464400,1),(105,1857024000,2),(105,1867914000,1),(105,1888473600,2),(105,1899363600,1),(105,1919923200,2),(105,1930813200,1),(105,1951372800,2),(105,1962867600,1),(105,1983427200,2),(105,1994317200,1),(105,2014876800,2),(105,2025766800,1),(105,2046326400,2),(105,2057216400,1),(105,2077776000,2),(105,2088666000,1),(105,2109225600,2),(105,2120115600,1),(105,2140675200,2),(106,-2147483648,0),(106,-2051202469,1),(106,-1724083200,2),(106,-880218000,3),(106,-769395600,4),(106,-765396000,2),(106,-684349200,5),(106,-671047200,2),(106,104914800,5),(106,120636000,2),(106,126687600,5),(106,152085600,2),(106,167814000,5),(106,183535200,2),(106,199263600,5),(106,215589600,2),(106,230713200,5),(106,247039200,2),(106,262767600,5),(106,278488800,2),(106,294217200,5),(106,309938400,2),(106,325666800,5),(106,341388000,2),(106,357116400,5),(106,372837600,2),(106,388566000,5),(106,404892000,2),(106,420015600,5),(106,436341600,2),(106,452070000,5),(106,467791200,2),(106,483519600,5),(106,499240800,2),(106,514969200,5),(106,530690400,2),(106,544604400,5),(106,562140000,2),(106,576054000,5),(106,594194400,2),(106,607503600,5),(106,625644000,2),(106,638953200,5),(106,657093600,2),(106,671007600,5),(106,688543200,2),(106,702457200,5),(106,719992800,2),(106,733906800,5),(106,752047200,2),(106,765356400,5),(106,783496800,2),(106,796806000,5),(106,814946400,2),(106,828860400,5),(106,846396000,2),(106,860310000,5),(106,877845600,2),(106,891759600,5),(106,909295200,2),(106,923209200,5),(106,941349600,2),(106,954658800,5),(106,972799200,2),(106,986108400,5),(106,1004248800,2),(106,1018162800,5),(106,1035698400,2),(106,1049612400,5),(106,1067148000,2),(106,1081062000,5),(106,1099202400,2),(106,1112511600,5),(106,1130652000,2),(106,1143961200,5),(106,1162101600,2),(106,1173596400,5),(106,1194156000,2),(106,1205046000,5),(106,1225605600,2),(106,1236495600,5),(106,1257055200,2),(106,1268550000,5),(106,1289109600,2),(106,1299999600,5),(106,1320559200,2),(106,1331449200,5),(106,1352008800,2),(106,1362898800,5),(106,1383458400,2),(106,1394348400,5),(106,1414908000,2),(106,1425798000,5),(106,1446357600,2),(106,1457852400,5),(106,1478412000,2),(106,1489302000,5),(106,1509861600,2),(106,1520751600,5),(106,1541311200,2),(106,1552201200,5),(106,1572760800,2),(106,1583650800,5),(106,1604210400,2),(106,1615705200,5),(106,1636264800,2),(106,1647154800,5),(106,1667714400,2),(106,1678604400,5),(106,1699164000,2),(106,1710054000,5),(106,1730613600,2),(106,1741503600,5),(106,1762063200,2),(106,1772953200,5),(106,1793512800,2),(106,1805007600,5),(106,1825567200,2),(106,1836457200,5),(106,1857016800,2),(106,1867906800,5),(106,1888466400,2),(106,1899356400,5),(106,1919916000,2),(106,1930806000,5),(106,1951365600,2),(106,1962860400,5),(106,1983420000,2),(106,1994310000,5),(106,2014869600,2),(106,2025759600,5),(106,2046319200,2),(106,2057209200,5),(106,2077768800,2),(106,2088658800,5),(106,2109218400,2),(106,2120108400,5),(106,2140668000,2),(107,-2147483648,0),(107,-1825098836,1),(108,-2147483648,0),(108,-1998663968,2),(108,-1632063600,1),(108,-1615132800,2),(108,-1600614000,1),(108,-1596816000,2),(108,-1567954800,1),(108,-1551628800,2),(108,-1536505200,1),(108,-1523203200,2),(108,-1504450800,1),(108,-1491753600,2),(108,-1473001200,1),(108,-1459699200,2),(108,-880210800,3),(108,-769395600,4),(108,-765388800,2),(108,-715791600,1),(108,-702489600,2),(108,-84380400,1),(108,-68659200,2),(108,-21481200,1),(108,-5760000,2),(108,73472400,1),(108,89193600,2),(108,104922000,1),(108,120643200,2),(108,136371600,1),(108,152092800,2),(108,167821200,1),(108,183542400,2),(108,199270800,1),(108,215596800,2),(108,230720400,1),(108,247046400,2),(108,262774800,1),(108,278496000,2),(108,294224400,1),(108,309945600,2),(108,325674000,1),(108,341395200,2),(108,357123600,1),(108,372844800,2),(108,388573200,1),(108,404899200,2),(108,420022800,1),(108,436348800,2),(108,452077200,1),(108,467798400,2),(108,483526800,1),(108,499248000,2),(108,514976400,1),(108,530697600,2),(108,544611600,1),(108,562147200,2),(108,576061200,1),(108,594201600,2),(108,607510800,1),(108,625651200,2),(108,638960400,1),(108,657100800,2),(108,671014800,1),(108,688550400,2),(108,702464400,1),(108,720000000,2),(108,733914000,1),(108,752054400,2),(108,765363600,1),(108,783504000,2),(108,796813200,1),(108,814953600,2),(108,828867600,1),(108,846403200,2),(108,860317200,1),(108,877852800,2),(108,891766800,1),(108,909302400,2),(108,923216400,1),(108,941356800,2),(108,954666000,1),(108,972806400,2),(108,986115600,1),(108,1004256000,2),(108,1018170000,1),(108,1035705600,2),(108,1049619600,1),(108,1067155200,2),(108,1081069200,1),(108,1099209600,2),(108,1112518800,1),(108,1130659200,2),(108,1143968400,1),(108,1162108800,2),(108,1173603600,1),(108,1194163200,2),(108,1205053200,1),(108,1225612800,2),(108,1236502800,1),(108,1257062400,2),(108,1268557200,1),(108,1289116800,2),(108,1300006800,1),(108,1320566400,2),(108,1331456400,1),(108,1352016000,2),(108,1362906000,1),(108,1383465600,2),(108,1394355600,1),(108,1414915200,2),(108,1425805200,1),(108,1446364800,2),(108,1457859600,1),(108,1478419200,2),(108,1489309200,1),(108,1509868800,2),(108,1520758800,1),(108,1541318400,2),(108,1552208400,1),(108,1572768000,2),(108,1583658000,1),(108,1604217600,2),(108,1615712400,1),(108,1636272000,2),(108,1647162000,1),(108,1667721600,2),(108,1678611600,1),(108,1699171200,2),(108,1710061200,1),(108,1730620800,2),(108,1741510800,1),(108,1762070400,2),(108,1772960400,1),(108,1793520000,2),(108,1805014800,1),(108,1825574400,2),(108,1836464400,1),(108,1857024000,2),(108,1867914000,1),(108,1888473600,2),(108,1899363600,1),(108,1919923200,2),(108,1930813200,1),(108,1951372800,2),(108,1962867600,1),(108,1983427200,2),(108,1994317200,1),(108,2014876800,2),(108,2025766800,1),(108,2046326400,2),(108,2057216400,1),(108,2077776000,2),(108,2088666000,1),(108,2109225600,2),(108,2120115600,1),(108,2140675200,2),(109,-2147483648,0),(109,-1767208832,2),(109,-1206950400,1),(109,-1191355200,2),(109,-1175367600,1),(109,-1159819200,2),(109,-633812400,1),(109,-622062000,2),(109,-602276400,1),(109,-591825600,2),(109,-570740400,1),(109,-560203200,2),(109,-539118000,1),(109,-531345600,2),(109,-191358000,1),(109,-184190400,2),(109,-155156400,1),(109,-150062400,2),(109,-128890800,1),(109,-121118400,2),(109,-99946800,1),(109,-89582400,2),(109,-68410800,1),(109,-57960000,2),(109,499755600,1),(109,511243200,2),(109,530600400,1),(109,540273600,2),(109,562136400,1),(109,571204800,2),(109,750834000,1),(109,761716800,2),(109,1214283600,3),(109,1384056000,2),(109,2147483647,2),(110,-2147483648,0),(110,-1546279392,2),(110,547020000,1),(110,559717200,2),(110,578469600,1),(110,591166800,2),(111,-2147483648,0),(111,-1514736000,1),(111,-1451667600,2),(111,-1343062800,1),(111,-1234803600,2),(111,-1222963200,3),(111,-1207242000,2),(111,-873820800,4),(111,-769395600,5),(111,-761677200,2),(111,-686073600,3),(111,-661539600,2),(111,-495039600,3),(111,-481734000,2),(111,-463590000,3),(111,-450284400,2),(111,-431535600,3),(111,-418230000,2),(111,-400086000,3),(111,-386780400,2),(111,-368636400,3),(111,-355330800,2),(111,-337186800,3),(111,-323881200,2),(111,-305737200,3),(111,-292431600,2),(111,199274400,3),(111,215600400,2),(111,230724000,3),(111,247050000,2),(111,262778400,3),(111,278499600,2),(111,294228000,3),(111,309949200,2),(111,325677600,3),(111,341398800,2),(111,357127200,3),(111,372848400,2),(111,388576800,3),(111,404902800,2),(111,420026400,3),(111,436352400,2),(111,452080800,3),(111,467802000,2),(111,483530400,3),(111,499251600,2),(111,514980000,3),(111,530701200,2),(111,544615200,3),(111,562150800,2),(111,576064800,3),(111,594205200,2),(111,607514400,3),(111,625654800,2),(111,638964000,3),(111,657104400,2),(111,671018400,3),(111,688554000,2),(111,702468000,3),(111,720003600,2),(111,733917600,3),(111,752058000,2),(111,765367200,3),(111,783507600,2),(111,796816800,3),(111,814957200,2),(111,828871200,3),(111,846406800,2),(111,860320800,3),(111,877856400,2),(111,891770400,3),(111,909306000,2),(111,923220000,3),(111,941360400,2),(111,954669600,3),(111,972810000,2),(111,986119200,3),(111,1004259600,2),(111,1018173600,3),(111,1035709200,2),(111,1049623200,3),(111,1067158800,2),(111,1081072800,3),(111,1099213200,2),(111,1112522400,3),(111,1130662800,2),(111,1143972000,3),(111,1162112400,2),(111,1175421600,3),(111,1193562000,2),(111,1207476000,3),(111,1225011600,2),(111,1238925600,3),(111,1256461200,2),(111,1268560800,3),(111,1289120400,2),(111,1300010400,3),(111,1320570000,2),(111,1331460000,3),(111,1352019600,2),(111,1362909600,3),(111,1383469200,2),(111,1394359200,3),(111,1414918800,2),(111,1425808800,3),(111,1446368400,2),(111,1457863200,3),(111,1478422800,2),(111,1489312800,3),(111,1509872400,2),(111,1520762400,3),(111,1541322000,2),(111,1552212000,3),(111,1572771600,2),(111,1583661600,3),(111,1604221200,2),(111,1615716000,3),(111,1636275600,2),(111,1647165600,3),(111,1667725200,2),(111,1678615200,3),(111,1699174800,2),(111,1710064800,3),(111,1730624400,2),(111,1741514400,3),(111,1762074000,2),(111,1772964000,3),(111,1793523600,2),(111,1805018400,3),(111,1825578000,2),(111,1836468000,3),(111,1857027600,2),(111,1867917600,3),(111,1888477200,2),(111,1899367200,3),(111,1919926800,2),(111,1930816800,3),(111,1951376400,2),(111,1962871200,3),(111,1983430800,2),(111,1994320800,3),(111,2014880400,2),(111,2025770400,3),(111,2046330000,2),(111,2057220000,3),(111,2077779600,2),(111,2088669600,3),(111,2109229200,2),(111,2120119200,3),(111,2140678800,2),(112,-2147483648,2),(112,-1632060000,1),(112,-1615129200,2),(112,-880207200,3),(112,-769395600,4),(112,-765385200,2),(112,-715788000,1),(112,-702486000,2),(112,-684338400,1),(112,-671036400,2),(112,-652888800,1),(112,-639586800,2),(112,-620834400,1),(112,-608137200,2),(112,-589384800,1),(112,-576082800,2),(112,-557935200,1),(112,-544633200,2),(112,-526485600,1),(112,-513183600,2),(112,-495036000,1),(112,-481734000,2),(112,-463586400,1),(112,-450284400,2),(112,-431532000,1),(112,-418230000,2),(112,-400082400,1),(112,-386780400,2),(112,-368632800,1),(112,-355330800,2),(112,-337183200,1),(112,-323881200,2),(112,-305733600,1),(112,-292431600,2),(112,-273679200,1),(112,-260982000,2),(112,-242229600,1),(112,-226508400,2),(112,-210780000,1),(112,-195058800,2),(112,-179330400,1),(112,-163609200,2),(112,-147880800,1),(112,-131554800,2),(112,-116431200,1),(112,-100105200,2),(112,-84376800,1),(112,-68655600,2),(112,-52927200,1),(112,-37206000,2),(112,-21477600,1),(112,-5756400,2),(112,9972000,1),(112,25693200,2),(112,41421600,1),(112,57747600,2),(112,73476000,1),(112,89197200,2),(112,104925600,1),(112,120646800,2),(112,136375200,1),(112,152096400,2),(112,167824800,1),(112,183546000,2),(112,199274400,1),(112,215600400,2),(112,230724000,1),(112,247050000,2),(112,262778400,1),(112,278499600,2),(112,294228000,1),(112,309949200,2),(112,325677600,1),(112,341398800,2),(112,357127200,1),(112,372848400,2),(112,388576800,1),(112,404902800,2),(112,420026400,1),(112,436352400,2),(112,452080800,1),(112,467802000,2),(112,483530400,1),(112,499251600,2),(112,514980000,1),(112,530701200,2),(112,544615200,1),(112,562150800,2),(112,576064800,1),(112,594205200,2),(112,607514400,1),(112,625654800,2),(112,638964000,1),(112,657104400,2),(112,671018400,1),(112,688554000,2),(112,702468000,1),(112,720003600,2),(112,733917600,1),(112,752058000,2),(112,765367200,1),(112,783507600,2),(112,796816800,1),(112,814957200,2),(112,828871200,1),(112,846406800,2),(112,860320800,1),(112,877856400,2),(112,891770400,1),(112,909306000,2),(112,923220000,1),(112,941360400,2),(112,954669600,1),(112,972810000,2),(112,986119200,1),(112,1004259600,2),(112,1018173600,1),(112,1035709200,2),(112,1049623200,1),(112,1067158800,2),(112,1081072800,1),(112,1099213200,2),(112,1112522400,1),(112,1130662800,2),(112,1143972000,1),(112,1162112400,2),(112,1173607200,1),(112,1194166800,2),(112,1205056800,1),(112,1225616400,2),(112,1236506400,1),(112,1257066000,2),(112,1268560800,1),(112,1289120400,2),(112,1300010400,1),(112,1320570000,2),(112,1331460000,1),(112,1352019600,2),(112,1362909600,1),(112,1383469200,2),(112,1394359200,1),(112,1414918800,2),(112,1425808800,5),(113,-2147483648,2),(113,-1633276800,1),(113,-1615136400,2),(113,-1601827200,1),(113,-1583686800,2),(113,-900259200,1),(113,-891795600,2),(113,-880214400,3),(113,-769395600,4),(113,-765392400,2),(113,-747244800,1),(113,-733942800,2),(113,-715795200,1),(113,-702493200,2),(113,-684345600,1),(113,-671043600,2),(113,-652896000,1),(113,-639594000,2),(113,-620841600,1),(113,-608144400,2),(113,-589392000,1),(113,-576090000,2),(113,-557942400,1),(113,-544640400,2),(113,-526492800,1),(113,-513190800,2),(113,-495043200,1),(113,-481741200,2),(113,-463593600,5),(113,-386787600,2),(113,-368640000,5),(113,-21488400,6),(113,-5767200,5),(113,9961200,6),(113,25682400,5),(113,1143961200,6),(113,1162101600,5),(113,1173596400,6),(113,1194156000,5),(113,1205046000,6),(113,1225605600,5),(113,1236495600,6),(113,1257055200,5),(113,1268550000,6),(113,1289109600,5),(113,1299999600,6),(113,1320559200,5),(113,1331449200,6),(113,1352008800,5),(113,1362898800,6),(113,1383458400,5),(113,1394348400,6),(113,1414908000,5),(113,1425798000,6),(113,1446357600,5),(113,1457852400,6),(113,1478412000,5),(113,1489302000,6),(113,1509861600,5),(113,1520751600,6),(113,1541311200,5),(113,1552201200,6),(113,1572760800,5),(113,1583650800,6),(113,1604210400,5),(113,1615705200,6),(113,1636264800,5),(113,1647154800,6),(113,1667714400,5),(113,1678604400,6),(113,1699164000,5),(113,1710054000,6),(113,1730613600,5),(113,1741503600,6),(113,1762063200,5),(113,1772953200,6),(113,1793512800,5),(113,1805007600,6),(113,1825567200,5),(113,1836457200,6),(113,1857016800,5),(113,1867906800,6),(113,1888466400,5),(113,1899356400,6),(113,1919916000,5),(113,1930806000,6),(113,1951365600,5),(113,1962860400,6),(113,1983420000,5),(113,1994310000,6),(113,2014869600,5),(113,2025759600,6),(113,2046319200,5),(113,2057209200,6),(113,2077768800,5),(113,2088658800,6),(113,2109218400,5),(113,2120108400,6),(113,2140668000,5),(114,-2147483648,0),(114,-1767216360,2),(114,-1206957600,1),(114,-1191362400,2),(114,-1175374800,1),(114,-1159826400,2),(114,-633819600,1),(114,-622069200,2),(114,-602283600,1),(114,-591832800,2),(114,-570747600,1),(114,-560210400,2),(114,-539125200,1),(114,-531352800,2),(114,-191365200,1),(114,-184197600,2),(114,-155163600,1),(114,-150069600,2),(114,-128898000,1),(114,-121125600,2),(114,-99954000,1),(114,-89589600,2),(114,-68418000,1),(114,-57967200,2),(114,499748400,1),(114,511236000,2),(114,530593200,1),(114,540266400,2),(114,562129200,1),(114,571197600,2),(114,592974000,1),(114,602042400,2),(114,624423600,1),(114,634701600,2),(114,938919600,1),(114,951616800,2),(114,970974000,1),(114,972180000,2),(114,1003028400,1),(114,1013911200,2),(114,2147483647,2),(115,-2147483648,0),(115,-2131646412,2),(115,-1632074400,1),(115,-1615143600,2),(115,-880221600,3),(115,-769395600,4),(115,-765399600,2),(115,-526500000,1),(115,-513198000,2),(115,73461600,1),(115,89182800,2),(115,104911200,1),(115,120632400,2),(115,136360800,1),(115,152082000,2),(115,167810400,1),(115,183531600,2),(115,199260000,1),(115,215586000,2),(115,230709600,1),(115,247035600,2),(115,262764000,1),(115,278485200,2),(115,294213600,1),(115,309934800,2),(115,325663200,1),(115,341384400,2),(115,357112800,1),(115,372834000,2),(115,388562400,1),(115,404888400,2),(115,420012000,1),(115,436338000,2),(115,452066400,1),(115,467787600,2),(115,483516000,1),(115,499237200,2),(115,514965600,1),(115,530686800,2),(115,544600800,1),(115,562136400,2),(115,576050400,1),(115,594190800,2),(115,607500000,1),(115,625640400,2),(115,638949600,1),(115,657090000,2),(115,671004000,1),(115,688539600,2),(115,702453600,1),(115,719989200,2),(115,733903200,1),(115,752043600,2),(115,765352800,1),(115,783493200,2),(115,796802400,1),(115,814942800,2),(115,828856800,1),(115,846392400,2),(115,860306400,1),(115,877842000,2),(115,891756000,1),(115,909291600,2),(115,923205600,1),(115,941346000,2),(115,954655200,1),(115,972795600,2),(115,986104800,1),(115,1004245200,2),(115,1018159200,1),(115,1035694800,2),(115,1049608800,1),(115,1067144400,2),(115,1081058400,1),(115,1099198800,2),(115,1112508000,1),(115,1130648400,2),(115,1143957600,1),(115,1162098000,2),(115,1173592800,1),(115,1194152400,2),(115,1205042400,1),(115,1225602000,2),(115,1236492000,1),(115,1257051600,2),(115,1268546400,1),(115,1289106000,2),(115,1299996000,1),(115,1320555600,2),(115,1331445600,1),(115,1352005200,2),(115,1362895200,1),(115,1383454800,2),(115,1394344800,1),(115,1414904400,2),(115,1425794400,1),(115,1446354000,2),(115,1457848800,1),(115,1478408400,2),(115,1489298400,1),(115,1509858000,2),(115,1520748000,1),(115,1541307600,2),(115,1552197600,1),(115,1572757200,2),(115,1583647200,1),(115,1604206800,2),(115,1615701600,1),(115,1636261200,2),(115,1647151200,1),(115,1667710800,2),(115,1678600800,1),(115,1699160400,2),(115,1710050400,1),(115,1730610000,2),(115,1741500000,1),(115,1762059600,2),(115,1772949600,1),(115,1793509200,2),(115,1805004000,1),(115,1825563600,2),(115,1836453600,1),(115,1857013200,2),(115,1867903200,1),(115,1888462800,2),(115,1899352800,1),(115,1919912400,2),(115,1930802400,1),(115,1951362000,2),(115,1962856800,1),(115,1983416400,2),(115,1994306400,1),(115,2014866000,2),(115,2025756000,1),(115,2046315600,2),(115,2057205600,1),(115,2077765200,2),(115,2088655200,1),(115,2109214800,2),(115,2120104800,1),(115,2140664400,2),(116,-2147483648,0),(116,-1686083584,1),(116,323845200,4),(116,338950800,2),(116,354675600,3),(116,370400400,2),(116,386125200,3),(116,401850000,2),(116,417574800,3),(116,433299600,2),(116,449024400,3),(116,465354000,2),(116,481078800,3),(116,496803600,2),(116,512528400,3),(116,528253200,2),(116,543978000,3),(116,559702800,2),(116,575427600,3),(116,591152400,2),(116,606877200,3),(116,622602000,2),(116,638326800,3),(116,654656400,2),(116,670381200,3),(116,686106000,2),(116,701830800,3),(116,717555600,2),(116,733280400,3),(116,749005200,2),(116,764730000,3),(116,780454800,2),(116,796179600,3),(116,811904400,2),(116,828234000,3),(116,846378000,2),(116,859683600,3),(116,877827600,2),(116,891133200,3),(116,909277200,2),(116,922582800,3),(116,941331600,2),(116,954032400,3),(116,972781200,2),(116,985482000,3),(116,1004230800,2),(116,1017536400,3),(116,1035680400,2),(116,1048986000,3),(116,1067130000,2),(116,1080435600,3),(116,1099184400,2),(116,1111885200,3),(116,1130634000,2),(116,1143334800,3),(116,1162083600,2),(116,1174784400,3),(116,1193533200,2),(116,1206838800,3),(116,1224982800,2),(116,1238288400,3),(116,1256432400,2),(116,1269738000,3),(116,1288486800,2),(116,1301187600,3),(116,1319936400,2),(116,1332637200,3),(116,1351386000,2),(116,1364691600,3),(116,1382835600,2),(116,1396141200,3),(116,1414285200,2),(116,1427590800,3),(116,1445734800,2),(116,1459040400,3),(116,1477789200,2),(116,1490490000,3),(116,1509238800,2),(116,1521939600,3),(116,1540688400,2),(116,1553994000,3),(116,1572138000,2),(116,1585443600,3),(116,1603587600,2),(116,1616893200,3),(116,1635642000,2),(116,1648342800,3),(116,1667091600,2),(116,1679792400,3),(116,1698541200,2),(116,1711846800,3),(116,1729990800,2),(116,1743296400,3),(116,1761440400,2),(116,1774746000,3),(116,1792890000,2),(116,1806195600,3),(116,1824944400,2),(116,1837645200,3),(116,1856394000,2),(116,1869094800,3),(116,1887843600,2),(116,1901149200,3),(116,1919293200,2),(116,1932598800,3),(116,1950742800,2),(116,1964048400,3),(116,1982797200,2),(116,1995498000,3),(116,2014246800,2),(116,2026947600,3),(116,2045696400,2),(116,2058397200,3),(116,2077146000,2),(116,2090451600,3),(116,2108595600,2),(116,2121901200,3),(116,2140045200,2),(116,2147483647,2),(117,-2147483648,1),(117,-1632076148,2),(117,-1615145348,1),(117,-1096921748,3),(117,-1061670600,4),(117,-1048973400,3),(117,-1030221000,4),(117,-1017523800,3),(117,-998771400,4),(117,-986074200,3),(117,-966717000,4),(117,-954624600,3),(117,-935267400,4),(117,-922570200,3),(117,-903817800,4),(117,-891120600,3),(117,-872368200,6),(117,-769395600,5),(117,-765401400,3),(117,-746044200,4),(117,-733347000,3),(117,-714594600,4),(117,-701897400,3),(117,-683145000,4),(117,-670447800,3),(117,-651695400,4),(117,-638998200,3),(117,-619641000,4),(117,-606943800,3),(117,-589401000,4),(117,-576099000,3),(117,-557951400,4),(117,-544649400,3),(117,-526501800,4),(117,-513199800,3),(117,-495052200,4),(117,-481750200,3),(117,-463602600,4),(117,-450300600,3),(117,-431548200,4),(117,-418246200,3),(117,-400098600,4),(117,-386796600,3),(117,-368649000,4),(117,-355347000,3),(117,-337199400,4),(117,-323897400,3),(117,-305749800,4),(117,-289423800,3),(117,-273695400,4),(117,-257974200,3),(117,-242245800,4),(117,-226524600,3),(117,-210796200,4),(117,-195075000,3),(117,-179346600,4),(117,-163625400,3),(117,-147897000,4),(117,-131571000,3),(117,-119903400,8),(117,-116445600,7),(117,-100119600,8),(117,-84391200,7),(117,-68670000,8),(117,-52941600,7),(117,-37220400,8),(117,-21492000,7),(117,-5770800,8),(117,9957600,7),(117,25678800,8),(117,41407200,7),(117,57733200,8),(117,73461600,7),(117,89182800,8),(117,104911200,7),(117,120632400,8),(117,136360800,7),(117,152082000,8),(117,167810400,7),(117,183531600,8),(117,199260000,7),(117,215586000,8),(117,230709600,7),(117,247035600,8),(117,262764000,7),(117,278485200,8),(117,294213600,7),(117,309934800,8),(117,325663200,7),(117,341384400,8),(117,357112800,7),(117,372834000,8),(117,388562400,7),(117,404888400,8),(117,420012000,7),(117,436338000,8),(117,452066400,7),(117,467787600,8),(117,483516000,7),(117,499237200,8),(117,514965600,7),(117,530686800,8),(117,544593660,7),(117,562129260,8),(117,576043260,9),(117,594180060,8),(117,607492860,7),(117,625633260,8),(117,638942460,7),(117,657082860,8),(117,670996860,7),(117,688532460,8),(117,702446460,7),(117,719982060,8),(117,733896060,7),(117,752036460,8),(117,765345660,7),(117,783486060,8),(117,796795260,7),(117,814935660,8),(117,828849660,7),(117,846385260,8),(117,860299260,7),(117,877834860,8),(117,891748860,7),(117,909284460,8),(117,923198460,7),(117,941338860,8),(117,954648060,7),(117,972788460,8),(117,986097660,7),(117,1004238060,8),(117,1018152060,7),(117,1035687660,8),(117,1049601660,7),(117,1067137260,8),(117,1081051260,7),(117,1099191660,8),(117,1112500860,7),(117,1130641260,8),(117,1143950460,7),(117,1162090860,8),(117,1173585660,7),(117,1194145260,8),(117,1205035260,7),(117,1225594860,8),(117,1236484860,7),(117,1257044460,8),(117,1268539260,7),(117,1289098860,8),(117,1299988860,7),(117,1320555600,8),(117,1331445600,7),(117,1352005200,8),(117,1362895200,7),(117,1383454800,8),(117,1394344800,7),(117,1414904400,8),(117,1425794400,7),(117,1446354000,8),(117,1457848800,7),(117,1478408400,8),(117,1489298400,7),(117,1509858000,8),(117,1520748000,7),(117,1541307600,8),(117,1552197600,7),(117,1572757200,8),(117,1583647200,7),(117,1604206800,8),(117,1615701600,7),(117,1636261200,8),(117,1647151200,7),(117,1667710800,8),(117,1678600800,7),(117,1699160400,8),(117,1710050400,7),(117,1730610000,8),(117,1741500000,7),(117,1762059600,8),(117,1772949600,7),(117,1793509200,8),(117,1805004000,7),(117,1825563600,8),(117,1836453600,7),(117,1857013200,8),(117,1867903200,7),(117,1888462800,8),(117,1899352800,7),(117,1919912400,8),(117,1930802400,7),(117,1951362000,8),(117,1962856800,7),(117,1983416400,8),(117,1994306400,7),(117,2014866000,8),(117,2025756000,7),(117,2046315600,8),(117,2057205600,7),(117,2077765200,8),(117,2088655200,7),(117,2109214800,8),(117,2120104800,7),(117,2140664400,8),(118,-2147483648,1),(118,-1827687170,2),(118,294217200,3),(118,309938400,2),(118,325666800,3),(118,341388000,2),(118,357116400,3),(118,372837600,2),(118,388566000,3),(118,404892000,2),(118,420015600,3),(118,436341600,2),(118,452070000,3),(118,467791200,2),(118,483519600,3),(118,499240800,2),(118,514969200,3),(118,530690400,2),(118,544604400,3),(118,562140000,2),(118,576054000,3),(118,594194400,2),(118,607503600,3),(118,625644000,2),(118,638953200,3),(118,657093600,2),(118,671007600,3),(118,688543200,2),(118,702457200,3),(118,719992800,2),(118,733906800,3),(118,752047200,2),(118,765356400,3),(118,783496800,2),(118,796806000,3),(118,814946400,2),(118,828860400,3),(118,846396000,2),(118,860310000,3),(118,877845600,2),(118,891759600,3),(118,909295200,2),(118,923209200,3),(118,941349600,2),(118,954658800,3),(118,972799200,2),(118,986108400,3),(118,1004248800,2),(118,1018162800,3),(118,1035698400,2),(118,1049612400,3),(118,1067148000,2),(118,1081062000,3),(118,1099202400,2),(118,1112511600,3),(118,1130652000,2),(118,1143961200,3),(118,1162101600,2),(118,1173596400,3),(118,1194156000,2),(118,1205046000,3),(118,1225605600,2),(118,1236495600,3),(118,1257055200,2),(118,1268550000,3),(118,1289109600,2),(118,1299999600,3),(118,1320559200,2),(118,1331449200,3),(118,1352008800,2),(118,1362898800,3),(118,1383458400,2),(118,1394348400,3),(118,1414908000,2),(118,1425798000,3),(118,1446357600,4),(118,1520751600,3),(118,1541311200,2),(118,1552201200,3),(118,1572760800,2),(118,1583650800,3),(118,1604210400,2),(118,1615705200,3),(118,1636264800,2),(118,1647154800,3),(118,1667714400,2),(118,1678604400,3),(118,1699164000,2),(118,1710054000,3),(118,1730613600,2),(118,1741503600,3),(118,1762063200,2),(118,1772953200,3),(118,1793512800,2),(118,1805007600,3),(118,1825567200,2),(118,1836457200,3),(118,1857016800,2),(118,1867906800,3),(118,1888466400,2),(118,1899356400,3),(118,1919916000,2),(118,1930806000,3),(118,1951365600,2),(118,1962860400,3),(118,1983420000,2),(118,1994310000,3),(118,2014869600,2),(118,2025759600,3),(118,2046319200,2),(118,2057209200,3),(118,2077768800,2),(118,2088658800,3),(118,2109218400,2),(118,2120108400,3),(118,2140668000,2),(119,-2147483648,0),(119,-1825098836,1),(120,-2147483648,0),(120,-1825098836,1),(121,-2147483648,0),(121,-1617040676,2),(121,123055200,1),(121,130914000,2),(121,422344800,1),(121,433054800,2),(121,669708000,1),(121,684219600,2),(121,1146376800,1),(121,1159678800,2),(122,-2147483648,1),(122,-1230749160,3),(122,722926800,2),(122,728884800,3),(122,2147483647,3),(123,-2147483648,0),(123,-1730578040,1),(123,176010300,2),(123,662698800,3),(123,2147483647,3),(124,-2147483648,0),(124,-2131645536,2),(124,-1696276800,1),(124,-1680469200,2),(124,-1632074400,1),(124,-1615143600,2),(124,-1566763200,1),(124,-1557090000,2),(124,-1535486400,1),(124,-1524949200,2),(124,-1504468800,1),(124,-1493413200,2),(124,-1472414400,1),(124,-1461963600,2),(124,-1440964800,1),(124,-1429390800,2),(124,-1409515200,1),(124,-1396731600,2),(124,-1376856000,1),(124,-1366491600,2),(124,-1346616000,1),(124,-1333832400,2),(124,-1313956800,1),(124,-1303678800,2),(124,-1282507200,1),(124,-1272661200,2),(124,-1251057600,1),(124,-1240088400,2),(124,-1219608000,1),(124,-1207429200,2),(124,-1188763200,1),(124,-1175979600,2),(124,-1157313600,1),(124,-1143925200,2),(124,-1124049600,1),(124,-1113771600,2),(124,-1091390400,1),(124,-1081026000,2),(124,-1059854400,1),(124,-1050786000,2),(124,-1030910400,1),(124,-1018126800,2),(124,-999460800,1),(124,-986677200,2),(124,-965592000,1),(124,-955227600,2),(124,-935956800,1),(124,-923173200,2),(124,-904507200,1),(124,-891723600,2),(124,-880221600,3),(124,-769395600,4),(124,-765399600,2),(124,-747252000,1),(124,-733950000,2),(124,-715802400,1),(124,-702500400,2),(124,-684352800,1),(124,-671050800,2),(124,-652903200,1),(124,-639601200,2),(124,-589399200,1),(124,-576097200,2),(124,-557949600,1),(124,-544647600,2),(124,-526500000,1),(124,-513198000,2),(124,-495050400,1),(124,-481748400,2),(124,-431546400,1),(124,-418244400,2),(124,-400096800,1),(124,-386794800,2),(124,-368647200,1),(124,-355345200,2),(124,-337197600,1),(124,-323895600,2),(124,-242244000,1),(124,-226522800,2),(124,-210794400,1),(124,-195073200,2),(124,-179344800,1),(124,-163623600,2),(124,-147895200,1),(124,-131569200,2),(124,-116445600,1),(124,-100119600,2),(124,-84391200,1),(124,-68670000,2),(124,-52941600,1),(124,-37220400,2),(124,-21492000,1),(124,-5770800,2),(124,9957600,1),(124,25678800,2),(124,41407200,1),(124,57733200,2),(124,73461600,1),(124,89182800,2),(124,104911200,1),(124,120632400,2),(124,136360800,1),(124,152082000,2),(124,167810400,1),(124,183531600,2),(124,199260000,1),(124,215586000,2),(124,230709600,1),(124,247035600,2),(124,262764000,1),(124,278485200,2),(124,294213600,1),(124,309934800,2),(124,325663200,1),(124,341384400,2),(124,357112800,1),(124,372834000,2),(124,388562400,1),(124,404888400,2),(124,420012000,1),(124,436338000,2),(124,452066400,1),(124,467787600,2),(124,483516000,1),(124,499237200,2),(124,514965600,1),(124,530686800,2),(124,544600800,1),(124,562136400,2),(124,576050400,1),(124,594190800,2),(124,607500000,1),(124,625640400,2),(124,638949600,1),(124,657090000,2),(124,671004000,1),(124,688539600,2),(124,702453600,1),(124,719989200,2),(124,733903200,1),(124,752043600,2),(124,765352800,1),(124,783493200,2),(124,796802400,1),(124,814942800,2),(124,828856800,1),(124,846392400,2),(124,860306400,1),(124,877842000,2),(124,891756000,1),(124,909291600,2),(124,923205600,1),(124,941346000,2),(124,954655200,1),(124,972795600,2),(124,986104800,1),(124,1004245200,2),(124,1018159200,1),(124,1035694800,2),(124,1049608800,1),(124,1067144400,2),(124,1081058400,1),(124,1099198800,2),(124,1112508000,1),(124,1130648400,2),(124,1143957600,1),(124,1162098000,2),(124,1173592800,1),(124,1194152400,2),(124,1205042400,1),(124,1225602000,2),(124,1236492000,1),(124,1257051600,2),(124,1268546400,1),(124,1289106000,2),(124,1299996000,1),(124,1320555600,2),(124,1331445600,1),(124,1352005200,2),(124,1362895200,1),(124,1383454800,2),(124,1394344800,1),(124,1414904400,2),(124,1425794400,1),(124,1446354000,2),(124,1457848800,1),(124,1478408400,2),(124,1489298400,1),(124,1509858000,2),(124,1520748000,1),(124,1541307600,2),(124,1552197600,1),(124,1572757200,2),(124,1583647200,1),(124,1604206800,2),(124,1615701600,1),(124,1636261200,2),(124,1647151200,1),(124,1667710800,2),(124,1678600800,1),(124,1699160400,2),(124,1710050400,1),(124,1730610000,2),(124,1741500000,1),(124,1762059600,2),(124,1772949600,1),(124,1793509200,2),(124,1805004000,1),(124,1825563600,2),(124,1836453600,1),(124,1857013200,2),(124,1867903200,1),(124,1888462800,2),(124,1899352800,1),(124,1919912400,2),(124,1930802400,1),(124,1951362000,2),(124,1962856800,1),(124,1983416400,2),(124,1994306400,1),(124,2014866000,2),(124,2025756000,1),(124,2046315600,2),(124,2057205600,1),(124,2077765200,2),(124,2088655200,1),(124,2109214800,2),(124,2120104800,1),(124,2140664400,2),(125,-2147483648,1),(125,-1402813824,3),(125,-1311534000,2),(125,-1300996800,3),(125,-933534000,2),(125,-925675200,3),(125,-902084400,2),(125,-893620800,3),(125,-870030000,2),(125,-862171200,3),(125,-775681200,2),(125,-767822400,3),(125,-744231600,2),(125,-736372800,3),(125,-144702000,2),(125,-134251200,3),(125,-113425200,2),(125,-102542400,3),(125,-86295600,2),(125,-72907200,3),(125,-54154800,2),(125,-41457600,3),(125,-21495600,2),(125,-5774400,3),(125,9954000,2),(125,25675200,3),(125,41403600,2),(125,57729600,3),(125,73458000,2),(125,87364800,3),(125,104907600,2),(125,118900800,3),(125,136357200,2),(125,150436800,3),(125,167806800,2),(125,183528000,3),(125,199256400,2),(125,215582400,3),(125,230706000,2),(125,247032000,3),(125,263365200,2),(125,276667200,3),(125,290581200,2),(125,308721600,3),(125,322030800,2),(125,340171200,3),(125,358318800,2),(125,371620800,3),(125,389768400,2),(125,403070400,3),(125,421218000,2),(125,434520000,3),(125,452667600,2),(125,466574400,3),(125,484117200,2),(125,498024000,3),(125,511333200,2),(125,529473600,3),(125,542782800,2),(125,560923200,3),(125,574837200,2),(125,592372800,3),(125,606286800,2),(125,623822400,3),(125,638946000,2),(125,655876800,3),(125,671000400,2),(125,687330000,4),(125,702450000,2),(125,718779600,4),(125,733899600,2),(125,750229200,4),(125,765349200,2),(125,781678800,4),(125,796798800,2),(125,813128400,4),(125,828853200,2),(125,844578000,4),(125,860302800,2),(125,876632400,4),(125,891147600,5),(125,909291600,4),(125,922597200,5),(125,941346000,4),(125,954651600,5),(125,972795600,4),(125,986101200,5),(125,1004245200,4),(125,1018155600,5),(125,1035694800,4),(125,1049605200,5),(125,1067144400,4),(125,1080450000,5),(125,1162098000,4),(125,1173589200,5),(125,1193547600,4),(125,1205643600,5),(125,1224997200,4),(125,1236488400,5),(125,1256446800,4),(125,1268542800,5),(125,1288501200,4),(125,1300597200,5),(125,1321160400,4),(125,1333256400,5),(125,1352005200,4),(125,1362891600,5),(125,1383454800,4),(125,1394341200,5),(125,1414904400,4),(125,1425790800,5),(125,1446354000,4),(125,1457845200,5),(125,1478408400,4),(125,1489294800,5),(125,1509858000,4),(125,1520744400,5),(125,1541307600,4),(125,1552194000,5),(125,1572757200,4),(125,1583643600,5),(125,1604206800,4),(125,1615698000,5),(125,1636261200,4),(125,1647147600,5),(125,1667710800,4),(125,1678597200,5),(125,1699160400,4),(125,1710046800,5),(125,1730610000,4),(125,1741496400,5),(125,1762059600,4),(125,1772946000,5),(125,1793509200,4),(125,1805000400,5),(125,1825563600,4),(125,1836450000,5),(125,1857013200,4),(125,1867899600,5),(125,1888462800,4),(125,1899349200,5),(125,1919912400,4),(125,1930798800,5),(125,1951362000,4),(125,1962853200,5),(125,1983416400,4),(125,1994302800,5),(125,2014866000,4),(125,2025752400,5),(125,2046315600,4),(125,2057202000,5),(125,2077765200,4),(125,2088651600,5),(125,2109214800,4),(125,2120101200,5),(125,2140664400,4),(126,-2147483648,0),(126,-1514739600,1),(126,-1343066400,2),(126,-1234807200,1),(126,-1220292000,2),(126,-1207159200,1),(126,-1191344400,2),(126,-873828000,1),(126,-661539600,3),(126,28800,1),(126,828867600,4),(126,846403200,1),(126,860317200,4),(126,877852800,1),(126,891766800,4),(126,909302400,1),(127,-2147483648,2),(127,-1633276800,1),(127,-1615136400,2),(127,-1601827200,1),(127,-1583686800,2),(127,-900259200,1),(127,-891795600,2),(127,-880214400,3),(127,-769395600,4),(127,-765392400,2),(127,-747244800,1),(127,-733942800,2),(127,-715795200,1),(127,-702493200,2),(127,-684345600,1),(127,-671043600,2),(127,-652896000,1),(127,-639594000,2),(127,-620841600,1),(127,-608144400,2),(127,-589392000,1),(127,-576090000,2),(127,-557942400,1),(127,-544640400,2),(127,-526492800,1),(127,-513190800,2),(127,-495043200,1),(127,-481741200,2),(127,-463593600,5),(127,-386787600,2),(127,-368640000,5),(127,-21488400,6),(127,-5767200,5),(127,9961200,6),(127,25682400,5),(127,1143961200,6),(127,1162101600,5),(127,1173596400,6),(127,1194156000,5),(127,1205046000,6),(127,1225605600,5),(127,1236495600,6),(127,1257055200,5),(127,1268550000,6),(127,1289109600,5),(127,1299999600,6),(127,1320559200,5),(127,1331449200,6),(127,1352008800,5),(127,1362898800,6),(127,1383458400,5),(127,1394348400,6),(127,1414908000,5),(127,1425798000,6),(127,1446357600,5),(127,1457852400,6),(127,1478412000,5),(127,1489302000,6),(127,1509861600,5),(127,1520751600,6),(127,1541311200,5),(127,1552201200,6),(127,1572760800,5),(127,1583650800,6),(127,1604210400,5),(127,1615705200,6),(127,1636264800,5),(127,1647154800,6),(127,1667714400,5),(127,1678604400,6),(127,1699164000,5),(127,1710054000,6),(127,1730613600,5),(127,1741503600,6),(127,1762063200,5),(127,1772953200,6),(127,1793512800,5),(127,1805007600,6),(127,1825567200,5),(127,1836457200,6),(127,1857016800,5),(127,1867906800,6),(127,1888466400,5),(127,1899356400,6),(127,1919916000,5),(127,1930806000,6),(127,1951365600,5),(127,1962860400,6),(127,1983420000,5),(127,1994310000,6),(127,2014869600,5),(127,2025759600,6),(127,2046319200,5),(127,2057209200,6),(127,2077768800,5),(127,2088658800,6),(127,2109218400,5),(127,2120108400,6),(127,2140668000,5),(128,-2147483648,2),(128,-1633276800,1),(128,-1615136400,2),(128,-1601827200,1),(128,-1583686800,2),(128,-880214400,3),(128,-769395600,4),(128,-765392400,2),(128,-715795200,1),(128,-702493200,2),(128,-684345600,1),(128,-671043600,2),(128,-652896000,1),(128,-639594000,2),(128,-620841600,1),(128,-608144400,2),(128,-589392000,1),(128,-576090000,2),(128,-557942400,1),(128,-544640400,2),(128,-526492800,1),(128,-513190800,2),(128,-495043200,1),(128,-481741200,2),(128,-463593600,1),(128,-447267600,2),(128,-431539200,1),(128,-415818000,2),(128,-400089600,1),(128,-386787600,2),(128,-368640000,1),(128,-355338000,2),(128,-337190400,1),(128,-321469200,2),(128,-305740800,1),(128,-289414800,2),(128,-273686400,1),(128,-257965200,2),(128,-242236800,5),(128,-195066000,2),(128,-84384000,1),(128,-68662800,2),(128,-52934400,1),(128,-37213200,2),(128,-21484800,1),(128,-5763600,2),(128,9964800,1),(128,25686000,2),(128,41414400,1),(128,57740400,2),(128,73468800,1),(128,89190000,2),(128,104918400,1),(128,120639600,2),(128,126691200,1),(128,152089200,2),(128,162374400,1),(128,183538800,2),(128,199267200,1),(128,215593200,2),(128,230716800,1),(128,247042800,2),(128,262771200,1),(128,278492400,2),(128,294220800,1),(128,309942000,2),(128,325670400,1),(128,341391600,2),(128,357120000,1),(128,372841200,2),(128,388569600,1),(128,404895600,2),(128,420019200,1),(128,436345200,2),(128,452073600,1),(128,467794800,2),(128,483523200,1),(128,499244400,2),(128,514972800,1),(128,530694000,2),(128,544608000,1),(128,562143600,2),(128,576057600,1),(128,594198000,2),(128,607507200,1),(128,625647600,2),(128,638956800,1),(128,657097200,2),(128,671011200,1),(128,688546800,5),(128,1143961200,1),(128,1162105200,2),(128,1173600000,1),(128,1194159600,2),(128,1205049600,1),(128,1225609200,2),(128,1236499200,1),(128,1257058800,2),(128,1268553600,1),(128,1289113200,2),(128,1300003200,1),(128,1320562800,2),(128,1331452800,1),(128,1352012400,2),(128,1362902400,1),(128,1383462000,2),(128,1394352000,1),(128,1414911600,2),(128,1425801600,1),(128,1446361200,2),(128,1457856000,1),(128,1478415600,2),(128,1489305600,1),(128,1509865200,2),(128,1520755200,1),(128,1541314800,2),(128,1552204800,1),(128,1572764400,2),(128,1583654400,1),(128,1604214000,2),(128,1615708800,1),(128,1636268400,2),(128,1647158400,1),(128,1667718000,2),(128,1678608000,1),(128,1699167600,2),(128,1710057600,1),(128,1730617200,2),(128,1741507200,1),(128,1762066800,2),(128,1772956800,1),(128,1793516400,2),(128,1805011200,1),(128,1825570800,2),(128,1836460800,1),(128,1857020400,2),(128,1867910400,1),(128,1888470000,2),(128,1899360000,1),(128,1919919600,2),(128,1930809600,1),(128,1951369200,2),(128,1962864000,1),(128,1983423600,2),(128,1994313600,1),(128,2014873200,2),(128,2025763200,1),(128,2046322800,2),(128,2057212800,1),(128,2077772400,2),(128,2088662400,1),(128,2109222000,2),(128,2120112000,1),(128,2140671600,2),(129,-2147483648,2),(129,-1633276800,1),(129,-1615136400,2),(129,-1601827200,1),(129,-1583686800,2),(129,-880214400,3),(129,-769395600,4),(129,-765392400,2),(129,-589392000,1),(129,-576090000,2),(129,-495043200,1),(129,-481741200,2),(129,-463593600,1),(129,-450291600,2),(129,-431539200,1),(129,-418237200,2),(129,-400089600,1),(129,-386787600,2),(129,-368640000,1),(129,-355338000,2),(129,-337190400,1),(129,-323888400,2),(129,-305740800,1),(129,-292438800,2),(129,-273686400,5),(129,-21488400,6),(129,-5767200,5),(129,9961200,6),(129,25682400,5),(129,41410800,6),(129,57736800,5),(129,73465200,6),(129,89186400,5),(129,104914800,6),(129,120636000,5),(129,126687600,1),(129,152089200,5),(129,162370800,6),(129,183535200,5),(129,1143961200,6),(129,1162101600,5),(129,1173596400,6),(129,1194156000,5),(129,1205046000,6),(129,1225605600,5),(129,1236495600,6),(129,1257055200,5),(129,1268550000,6),(129,1289109600,5),(129,1299999600,6),(129,1320559200,5),(129,1331449200,6),(129,1352008800,5),(129,1362898800,6),(129,1383458400,5),(129,1394348400,6),(129,1414908000,5),(129,1425798000,6),(129,1446357600,5),(129,1457852400,6),(129,1478412000,5),(129,1489302000,6),(129,1509861600,5),(129,1520751600,6),(129,1541311200,5),(129,1552201200,6),(129,1572760800,5),(129,1583650800,6),(129,1604210400,5),(129,1615705200,6),(129,1636264800,5),(129,1647154800,6),(129,1667714400,5),(129,1678604400,6),(129,1699164000,5),(129,1710054000,6),(129,1730613600,5),(129,1741503600,6),(129,1762063200,5),(129,1772953200,6),(129,1793512800,5),(129,1805007600,6),(129,1825567200,5),(129,1836457200,6),(129,1857016800,5),(129,1867906800,6),(129,1888466400,5),(129,1899356400,6),(129,1919916000,5),(129,1930806000,6),(129,1951365600,5),(129,1962860400,6),(129,1983420000,5),(129,1994310000,6),(129,2014869600,5),(129,2025759600,6),(129,2046319200,5),(129,2057209200,6),(129,2077768800,5),(129,2088658800,6),(129,2109218400,5),(129,2120108400,6),(129,2140668000,5),(130,-2147483648,2),(130,-1633276800,1),(130,-1615136400,2),(130,-1601827200,1),(130,-1583686800,2),(130,-880214400,3),(130,-769395600,4),(130,-765392400,2),(130,-462996000,1),(130,-450291600,2),(130,-431539200,1),(130,-418237200,2),(130,-400089600,1),(130,-386787600,2),(130,-368640000,1),(130,-355338000,2),(130,-337190400,1),(130,-323888400,2),(130,-305740800,1),(130,-292438800,2),(130,-273686400,1),(130,-257965200,2),(130,-242236800,1),(130,-226515600,2),(130,-210787200,1),(130,-195066000,2),(130,-179337600,1),(130,-163616400,2),(130,-147888000,5),(130,-100112400,2),(130,-84384000,1),(130,-68662800,2),(130,-52934400,1),(130,-37213200,2),(130,-21484800,1),(130,-5763600,2),(130,9964800,1),(130,25686000,2),(130,41414400,1),(130,57740400,2),(130,73468800,1),(130,89190000,2),(130,104918400,1),(130,120639600,2),(130,126691200,1),(130,152089200,2),(130,162374400,1),(130,183538800,2),(130,199267200,1),(130,215593200,2),(130,230716800,1),(130,247042800,5),(130,1143961200,1),(130,1162105200,2),(130,1173600000,1),(130,1194159600,5),(130,1205046000,6),(130,1225605600,5),(130,1236495600,6),(130,1257055200,5),(130,1268550000,6),(130,1289109600,5),(130,1299999600,6),(130,1320559200,5),(130,1331449200,6),(130,1352008800,5),(130,1362898800,6),(130,1383458400,5),(130,1394348400,6),(130,1414908000,5),(130,1425798000,6),(130,1446357600,5),(130,1457852400,6),(130,1478412000,5),(130,1489302000,6),(130,1509861600,5),(130,1520751600,6),(130,1541311200,5),(130,1552201200,6),(130,1572760800,5),(130,1583650800,6),(130,1604210400,5),(130,1615705200,6),(130,1636264800,5),(130,1647154800,6),(130,1667714400,5),(130,1678604400,6),(130,1699164000,5),(130,1710054000,6),(130,1730613600,5),(130,1741503600,6),(130,1762063200,5),(130,1772953200,6),(130,1793512800,5),(130,1805007600,6),(130,1825567200,5),(130,1836457200,6),(130,1857016800,5),(130,1867906800,6),(130,1888466400,5),(130,1899356400,6),(130,1919916000,5),(130,1930806000,6),(130,1951365600,5),(130,1962860400,6),(130,1983420000,5),(130,1994310000,6),(130,2014869600,5),(130,2025759600,6),(130,2046319200,5),(130,2057209200,6),(130,2077768800,5),(130,2088658800,6),(130,2109218400,5),(130,2120108400,6),(130,2140668000,5),(131,-2147483648,2),(131,-1633276800,1),(131,-1615136400,2),(131,-1601827200,1),(131,-1583686800,2),(131,-880214400,3),(131,-769395600,4),(131,-765392400,2),(131,-747244800,1),(131,-733942800,2),(131,-526492800,1),(131,-513190800,2),(131,-495043200,1),(131,-481741200,2),(131,-462996000,1),(131,-450291600,2),(131,-431539200,1),(131,-418237200,2),(131,-400089600,1),(131,-386787600,2),(131,-368640000,1),(131,-355338000,2),(131,-337190400,1),(131,-323888400,2),(131,-305740800,1),(131,-289414800,2),(131,-273686400,1),(131,-260989200,2),(131,-242236800,1),(131,-226515600,2),(131,-210787200,1),(131,-195066000,2),(131,-179337600,5),(131,-21488400,6),(131,-5767200,5),(131,9961200,6),(131,25682400,5),(131,1143961200,1),(131,1162105200,2),(131,1173600000,1),(131,1194159600,2),(131,1205049600,1),(131,1225609200,2),(131,1236499200,1),(131,1257058800,2),(131,1268553600,1),(131,1289113200,2),(131,1300003200,1),(131,1320562800,2),(131,1331452800,1),(131,1352012400,2),(131,1362902400,1),(131,1383462000,2),(131,1394352000,1),(131,1414911600,2),(131,1425801600,1),(131,1446361200,2),(131,1457856000,1),(131,1478415600,2),(131,1489305600,1),(131,1509865200,2),(131,1520755200,1),(131,1541314800,2),(131,1552204800,1),(131,1572764400,2),(131,1583654400,1),(131,1604214000,2),(131,1615708800,1),(131,1636268400,2),(131,1647158400,1),(131,1667718000,2),(131,1678608000,1),(131,1699167600,2),(131,1710057600,1),(131,1730617200,2),(131,1741507200,1),(131,1762066800,2),(131,1772956800,1),(131,1793516400,2),(131,1805011200,1),(131,1825570800,2),(131,1836460800,1),(131,1857020400,2),(131,1867910400,1),(131,1888470000,2),(131,1899360000,1),(131,1919919600,2),(131,1930809600,1),(131,1951369200,2),(131,1962864000,1),(131,1983423600,2),(131,1994313600,1),(131,2014873200,2),(131,2025763200,1),(131,2046322800,2),(131,2057212800,1),(131,2077772400,2),(131,2088662400,1),(131,2109222000,2),(131,2120112000,1),(131,2140671600,2),(132,-2147483648,2),(132,-1633276800,1),(132,-1615136400,2),(132,-1601827200,1),(132,-1583686800,2),(132,-880214400,3),(132,-769395600,4),(132,-765392400,2),(132,-495043200,5),(132,-21488400,6),(132,-5767200,5),(132,9961200,6),(132,25682400,5),(132,41410800,6),(132,57736800,5),(132,73465200,6),(132,89186400,5),(132,1143961200,6),(132,1162101600,5),(132,1173596400,6),(132,1194156000,5),(132,1205046000,6),(132,1225605600,5),(132,1236495600,6),(132,1257055200,5),(132,1268550000,6),(132,1289109600,5),(132,1299999600,6),(132,1320559200,5),(132,1331449200,6),(132,1352008800,5),(132,1362898800,6),(132,1383458400,5),(132,1394348400,6),(132,1414908000,5),(132,1425798000,6),(132,1446357600,5),(132,1457852400,6),(132,1478412000,5),(132,1489302000,6),(132,1509861600,5),(132,1520751600,6),(132,1541311200,5),(132,1552201200,6),(132,1572760800,5),(132,1583650800,6),(132,1604210400,5),(132,1615705200,6),(132,1636264800,5),(132,1647154800,6),(132,1667714400,5),(132,1678604400,6),(132,1699164000,5),(132,1710054000,6),(132,1730613600,5),(132,1741503600,6),(132,1762063200,5),(132,1772953200,6),(132,1793512800,5),(132,1805007600,6),(132,1825567200,5),(132,1836457200,6),(132,1857016800,5),(132,1867906800,6),(132,1888466400,5),(132,1899356400,6),(132,1919916000,5),(132,1930806000,6),(132,1951365600,5),(132,1962860400,6),(132,1983420000,5),(132,1994310000,6),(132,2014869600,5),(132,2025759600,6),(132,2046319200,5),(132,2057209200,6),(132,2077768800,5),(132,2088658800,6),(132,2109218400,5),(132,2120108400,6),(132,2140668000,5),(133,-2147483648,2),(133,-1633276800,1),(133,-1615136400,2),(133,-1601827200,1),(133,-1583686800,2),(133,-880214400,3),(133,-769395600,4),(133,-765392400,2),(133,-747244800,1),(133,-733942800,2),(133,-526492800,1),(133,-513190800,2),(133,-495043200,1),(133,-481741200,2),(133,-462996000,1),(133,-450291600,2),(133,-431539200,1),(133,-418237200,2),(133,-400089600,1),(133,-386787600,2),(133,-368640000,1),(133,-355338000,2),(133,-337190400,1),(133,-323888400,2),(133,-305740800,1),(133,-289414800,2),(133,-273686400,1),(133,-260989200,2),(133,-242236800,1),(133,-226515600,2),(133,-210787200,1),(133,-195066000,2),(133,-179337600,5),(133,-21488400,6),(133,-5767200,5),(133,9961200,6),(133,25682400,5),(133,1143961200,1),(133,1162105200,2),(133,1173600000,1),(133,1194159600,5),(133,1205046000,6),(133,1225605600,5),(133,1236495600,6),(133,1257055200,5),(133,1268550000,6),(133,1289109600,5),(133,1299999600,6),(133,1320559200,5),(133,1331449200,6),(133,1352008800,5),(133,1362898800,6),(133,1383458400,5),(133,1394348400,6),(133,1414908000,5),(133,1425798000,6),(133,1446357600,5),(133,1457852400,6),(133,1478412000,5),(133,1489302000,6),(133,1509861600,5),(133,1520751600,6),(133,1541311200,5),(133,1552201200,6),(133,1572760800,5),(133,1583650800,6),(133,1604210400,5),(133,1615705200,6),(133,1636264800,5),(133,1647154800,6),(133,1667714400,5),(133,1678604400,6),(133,1699164000,5),(133,1710054000,6),(133,1730613600,5),(133,1741503600,6),(133,1762063200,5),(133,1772953200,6),(133,1793512800,5),(133,1805007600,6),(133,1825567200,5),(133,1836457200,6),(133,1857016800,5),(133,1867906800,6),(133,1888466400,5),(133,1899356400,6),(133,1919916000,5),(133,1930806000,6),(133,1951365600,5),(133,1962860400,6),(133,1983420000,5),(133,1994310000,6),(133,2014869600,5),(133,2025759600,6),(133,2046319200,5),(133,2057209200,6),(133,2077768800,5),(133,2088658800,6),(133,2109218400,5),(133,2120108400,6),(133,2140668000,5),(134,-2147483648,2),(134,-1633276800,1),(134,-1615136400,2),(134,-1601827200,1),(134,-1583686800,2),(134,-880214400,3),(134,-769395600,4),(134,-765392400,2),(134,-747244800,1),(134,-733942800,2),(134,-715795200,1),(134,-702493200,2),(134,-684345600,1),(134,-671043600,2),(134,-652896000,1),(134,-639594000,2),(134,-620841600,1),(134,-608144400,2),(134,-589392000,1),(134,-576090000,2),(134,-557942400,1),(134,-544640400,2),(134,-526492800,1),(134,-513190800,2),(134,-495043200,1),(134,-481741200,2),(134,-463593600,1),(134,-447267600,2),(134,-431539200,1),(134,-415818000,2),(134,-400089600,1),(134,-386787600,2),(134,-368640000,1),(134,-355338000,2),(134,-337190400,1),(134,-323888400,2),(134,-305740800,1),(134,-292438800,2),(134,-273686400,5),(134,-21488400,6),(134,-5767200,5),(134,9961200,6),(134,25682400,5),(134,1143961200,1),(134,1162105200,2),(134,1173600000,6),(134,1194156000,5),(134,1205046000,6),(134,1225605600,5),(134,1236495600,6),(134,1257055200,5),(134,1268550000,6),(134,1289109600,5),(134,1299999600,6),(134,1320559200,5),(134,1331449200,6),(134,1352008800,5),(134,1362898800,6),(134,1383458400,5),(134,1394348400,6),(134,1414908000,5),(134,1425798000,6),(134,1446357600,5),(134,1457852400,6),(134,1478412000,5),(134,1489302000,6),(134,1509861600,5),(134,1520751600,6),(134,1541311200,5),(134,1552201200,6),(134,1572760800,5),(134,1583650800,6),(134,1604210400,5),(134,1615705200,6),(134,1636264800,5),(134,1647154800,6),(134,1667714400,5),(134,1678604400,6),(134,1699164000,5),(134,1710054000,6),(134,1730613600,5),(134,1741503600,6),(134,1762063200,5),(134,1772953200,6),(134,1793512800,5),(134,1805007600,6),(134,1825567200,5),(134,1836457200,6),(134,1857016800,5),(134,1867906800,6),(134,1888466400,5),(134,1899356400,6),(134,1919916000,5),(134,1930806000,6),(134,1951365600,5),(134,1962860400,6),(134,1983420000,5),(134,1994310000,6),(134,2014869600,5),(134,2025759600,6),(134,2046319200,5),(134,2057209200,6),(134,2077768800,5),(134,2088658800,6),(134,2109218400,5),(134,2120108400,6),(134,2140668000,5),(135,-2147483648,2),(135,-1633276800,1),(135,-1615136400,2),(135,-1601827200,1),(135,-1583686800,2),(135,-900259200,1),(135,-891795600,2),(135,-880214400,3),(135,-769395600,4),(135,-765392400,2),(135,-747244800,1),(135,-733942800,2),(135,-715795200,1),(135,-702493200,2),(135,-684345600,1),(135,-671043600,2),(135,-652896000,1),(135,-639594000,2),(135,-620841600,1),(135,-608144400,2),(135,-589392000,1),(135,-576090000,2),(135,-557942400,1),(135,-544640400,2),(135,-526492800,1),(135,-513190800,2),(135,-495043200,1),(135,-481741200,2),(135,-463593600,5),(135,-386787600,2),(135,-368640000,5),(135,-21488400,6),(135,-5767200,5),(135,9961200,6),(135,25682400,5),(135,1143961200,6),(135,1162101600,5),(135,1173596400,6),(135,1194156000,5),(135,1205046000,6),(135,1225605600,5),(135,1236495600,6),(135,1257055200,5),(135,1268550000,6),(135,1289109600,5),(135,1299999600,6),(135,1320559200,5),(135,1331449200,6),(135,1352008800,5),(135,1362898800,6),(135,1383458400,5),(135,1394348400,6),(135,1414908000,5),(135,1425798000,6),(135,1446357600,5),(135,1457852400,6),(135,1478412000,5),(135,1489302000,6),(135,1509861600,5),(135,1520751600,6),(135,1541311200,5),(135,1552201200,6),(135,1572760800,5),(135,1583650800,6),(135,1604210400,5),(135,1615705200,6),(135,1636264800,5),(135,1647154800,6),(135,1667714400,5),(135,1678604400,6),(135,1699164000,5),(135,1710054000,6),(135,1730613600,5),(135,1741503600,6),(135,1762063200,5),(135,1772953200,6),(135,1793512800,5),(135,1805007600,6),(135,1825567200,5),(135,1836457200,6),(135,1857016800,5),(135,1867906800,6),(135,1888466400,5),(135,1899356400,6),(135,1919916000,5),(135,1930806000,6),(135,1951365600,5),(135,1962860400,6),(135,1983420000,5),(135,1994310000,6),(135,2014869600,5),(135,2025759600,6),(135,2046319200,5),(135,2057209200,6),(135,2077768800,5),(135,2088658800,6),(135,2109218400,5),(135,2120108400,6),(135,2140668000,5),(136,-2147483648,0),(136,-536457600,2),(136,-147888000,1),(136,-131558400,2),(136,294228000,3),(136,325674000,4),(136,341395200,3),(136,357123600,4),(136,372844800,3),(136,388573200,4),(136,404899200,3),(136,420022800,4),(136,436348800,3),(136,452077200,4),(136,467798400,3),(136,483526800,4),(136,499248000,3),(136,514976400,4),(136,530697600,3),(136,544611600,4),(136,562147200,3),(136,576061200,4),(136,594201600,3),(136,607510800,4),(136,625651200,3),(136,638960400,4),(136,657100800,3),(136,671014800,4),(136,688550400,3),(136,702464400,4),(136,720000000,3),(136,733914000,4),(136,752054400,3),(136,765363600,4),(136,783504000,3),(136,796813200,4),(136,814953600,3),(136,828867600,4),(136,846403200,3),(136,860317200,4),(136,877852800,3),(136,891766800,4),(136,909302400,3),(136,923216400,4),(136,941356800,3),(136,954666000,4),(136,972806400,3),(136,986115600,4),(136,1004256000,3),(136,1018170000,4),(136,1035705600,3),(136,1049619600,4),(136,1067155200,3),(136,1081069200,4),(136,1099209600,3),(136,1112518800,4),(136,1130659200,3),(136,1143968400,4),(136,1162108800,3),(136,1173603600,4),(136,1194163200,3),(136,1205053200,4),(136,1225612800,3),(136,1236502800,4),(136,1257062400,3),(136,1268557200,4),(136,1289116800,3),(136,1300006800,4),(136,1320566400,3),(136,1331456400,4),(136,1352016000,3),(136,1362906000,4),(136,1383465600,3),(136,1394355600,4),(136,1414915200,3),(136,1425805200,4),(136,1446364800,3),(136,1457859600,4),(136,1478419200,3),(136,1489309200,4),(136,1509868800,3),(136,1520758800,4),(136,1541318400,3),(136,1552208400,4),(136,1572768000,3),(136,1583658000,4),(136,1604217600,3),(136,1615712400,4),(136,1636272000,3),(136,1647162000,4),(136,1667721600,3),(136,1678611600,4),(136,1699171200,3),(136,1710061200,4),(136,1730620800,3),(136,1741510800,4),(136,1762070400,3),(136,1772960400,4),(136,1793520000,3),(136,1805014800,4),(136,1825574400,3),(136,1836464400,4),(136,1857024000,3),(136,1867914000,4),(136,1888473600,3),(136,1899363600,4),(136,1919923200,3),(136,1930813200,4),(136,1951372800,3),(136,1962867600,4),(136,1983427200,3),(136,1994317200,4),(136,2014876800,3),(136,2025766800,4),(136,2046326400,3),(136,2057216400,4),(136,2077776000,3),(136,2088666000,4),(136,2109225600,3),(136,2120115600,4),(136,2140675200,3),(137,-2147483648,0),(137,-865296000,5),(137,-769395600,1),(137,-765396000,2),(137,-147898800,3),(137,-131569200,2),(137,325666800,4),(137,341388000,2),(137,357116400,4),(137,372837600,2),(137,388566000,4),(137,404892000,2),(137,420015600,4),(137,436341600,2),(137,452070000,4),(137,467791200,2),(137,483519600,4),(137,499240800,2),(137,514969200,4),(137,530690400,2),(137,544604400,4),(137,562140000,2),(137,576054000,4),(137,594194400,2),(137,607503600,4),(137,625644000,2),(137,638953200,4),(137,657093600,2),(137,671007600,4),(137,688543200,2),(137,702457200,4),(137,719992800,2),(137,733906800,4),(137,752047200,2),(137,765356400,4),(137,783496800,2),(137,796806000,4),(137,814946400,2),(137,828860400,4),(137,846396000,2),(137,860310000,4),(137,877845600,2),(137,891759600,4),(137,909295200,2),(137,923209200,4),(137,941349600,6),(137,954662400,7),(137,972802800,2),(137,986108400,4),(137,1004248800,2),(137,1018162800,4),(137,1035698400,2),(137,1049612400,4),(137,1067148000,2),(137,1081062000,4),(137,1099202400,2),(137,1112511600,4),(137,1130652000,2),(137,1143961200,4),(137,1162101600,2),(137,1173596400,4),(137,1194156000,2),(137,1205046000,4),(137,1225605600,2),(137,1236495600,4),(137,1257055200,2),(137,1268550000,4),(137,1289109600,2),(137,1299999600,4),(137,1320559200,2),(137,1331449200,4),(137,1352008800,2),(137,1362898800,4),(137,1383458400,2),(137,1394348400,4),(137,1414908000,2),(137,1425798000,4),(137,1446357600,2),(137,1457852400,4),(137,1478412000,2),(137,1489302000,4),(137,1509861600,2),(137,1520751600,4),(137,1541311200,2),(137,1552201200,4),(137,1572760800,2),(137,1583650800,4),(137,1604210400,2),(137,1615705200,4),(137,1636264800,2),(137,1647154800,4),(137,1667714400,2),(137,1678604400,4),(137,1699164000,2),(137,1710054000,4),(137,1730613600,2),(137,1741503600,4),(137,1762063200,2),(137,1772953200,4),(137,1793512800,2),(137,1805007600,4),(137,1825567200,2),(137,1836457200,4),(137,1857016800,2),(137,1867906800,4),(137,1888466400,2),(137,1899356400,4),(137,1919916000,2),(137,1930806000,4),(137,1951365600,2),(137,1962860400,4),(137,1983420000,2),(137,1994310000,4),(137,2014869600,2),(137,2025759600,4),(137,2046319200,2),(137,2057209200,4),(137,2077768800,2),(137,2088658800,4),(137,2109218400,2),(137,2120108400,4),(137,2140668000,2),(138,-2147483648,1),(138,-1827687170,2),(138,126687600,3),(138,152085600,2),(138,162370800,3),(138,183535200,2),(138,199263600,3),(138,215589600,2),(138,230713200,3),(138,247039200,2),(138,262767600,3),(138,278488800,2),(138,294217200,3),(138,309938400,2),(138,325666800,3),(138,341388000,2),(138,357116400,3),(138,372837600,2),(138,388566000,3),(138,404892000,2),(138,420015600,3),(138,436341600,2),(139,-2147483648,1),(139,-1567453392,2),(139,-1233432000,3),(139,-1222981200,2),(139,-1205956800,3),(139,-1194037200,2),(139,-1172865600,3),(139,-1162501200,2),(139,-1141329600,3),(139,-1130965200,2),(139,-1109793600,3),(139,-1099429200,2),(139,-1078257600,3),(139,-1067806800,2),(139,-1046635200,3),(139,-1036270800,2),(139,-1015099200,3),(139,-1004734800,2),(139,-983563200,3),(139,-973198800,2),(139,-952027200,3),(139,-941576400,2),(139,-931032000,3),(139,-900882000,2),(139,-890337600,3),(139,-833749200,2),(139,-827265600,3),(139,-752274000,2),(139,-733780800,3),(139,-197326800,2),(139,-190843200,3),(139,-184194000,2),(139,-164491200,3),(139,-152658000,2),(139,-132955200,3),(139,-121122000,2),(139,-101419200,3),(139,-86821200,2),(139,-71092800,3),(139,-54766800,2),(139,-39038400,3),(139,-23317200,2),(139,-7588800,5),(139,128142000,4),(139,136605600,5),(139,596948400,4),(139,605066400,5),(139,624423600,4),(139,636516000,2),(139,657086400,3),(139,669178800,2),(139,686721600,4),(139,699415200,5),(139,719377200,4),(139,731469600,5),(139,938919600,3),(139,952052400,5),(139,1198983600,4),(139,1205632800,5),(139,2147483647,5),(140,-2147483648,1),(140,-880207200,2),(140,-769395600,3),(140,-765385200,1),(140,-21477600,4),(140,-5756400,1),(140,9972000,4),(140,25693200,1),(140,41421600,4),(140,57747600,1),(140,73476000,4),(140,89197200,1),(140,104925600,4),(140,120646800,1),(140,126698400,4),(140,152096400,1),(140,162381600,4),(140,183546000,1),(140,199274400,4),(140,215600400,1),(140,230724000,4),(140,247050000,1),(140,262778400,4),(140,278499600,1),(140,294228000,4),(140,309949200,1),(140,325677600,5),(140,341402400,1),(140,357127200,4),(140,372848400,1),(140,388576800,4),(140,404902800,1),(140,420026400,4),(140,436352400,6),(140,439030800,8),(140,452084400,7),(140,467805600,8),(140,483534000,7),(140,499255200,8),(140,514983600,7),(140,530704800,8),(140,544618800,7),(140,562154400,8),(140,576068400,7),(140,594208800,8),(140,607518000,7),(140,625658400,8),(140,638967600,7),(140,657108000,8),(140,671022000,7),(140,688557600,8),(140,702471600,7),(140,720007200,8),(140,733921200,7),(140,752061600,8),(140,765370800,7),(140,783511200,8),(140,796820400,7),(140,814960800,8),(140,828874800,7),(140,846410400,8),(140,860324400,7),(140,877860000,8),(140,891774000,7),(140,909309600,8),(140,923223600,7),(140,941364000,8),(140,954673200,7),(140,972813600,8),(140,986122800,7),(140,1004263200,8),(140,1018177200,7),(140,1035712800,8),(140,1049626800,7),(140,1067162400,8),(140,1081076400,7),(140,1099216800,8),(140,1112526000,7),(140,1130666400,8),(140,1143975600,7),(140,1162116000,8),(140,1173610800,7),(140,1194170400,8),(140,1205060400,7),(140,1225620000,8),(140,1236510000,7),(140,1257069600,8),(140,1268564400,7),(140,1289124000,8),(140,1300014000,7),(140,1320573600,8),(140,1331463600,7),(140,1352023200,8),(140,1362913200,7),(140,1383472800,8),(140,1394362800,7),(140,1414922400,8),(140,1425812400,7),(140,1446372000,8),(140,1457866800,7),(140,1478426400,8),(140,1489316400,7),(140,1509876000,8),(140,1520766000,7),(140,1541325600,8),(140,1552215600,7),(140,1572775200,8),(140,1583665200,7),(140,1604224800,8),(140,1615719600,7),(140,1636279200,8),(140,1647169200,7),(140,1667728800,8),(140,1678618800,7),(140,1699178400,8),(140,1710068400,7),(140,1730628000,8),(140,1741518000,7),(140,1762077600,8),(140,1772967600,7),(140,1793527200,8),(140,1805022000,7),(140,1825581600,8),(140,1836471600,7),(140,1857031200,8),(140,1867921200,7),(140,1888480800,8),(140,1899370800,7),(140,1919930400,8),(140,1930820400,7),(140,1951380000,8),(140,1962874800,7),(140,1983434400,8),(140,1994324400,7),(140,2014884000,8),(140,2025774000,7),(140,2046333600,8),(140,2057223600,7),(140,2077783200,8),(140,2088673200,7),(140,2109232800,8),(140,2120122800,7),(140,2140682400,8),(141,-2147483648,2),(141,-1633276800,1),(141,-1615136400,2),(141,-1601827200,1),(141,-1583686800,2),(141,-1535904000,1),(141,-1525280400,2),(141,-905097600,1),(141,-891795600,2),(141,-880214400,3),(141,-769395600,4),(141,-765392400,2),(141,-757360800,1),(141,-744224400,2),(141,-715795200,1),(141,-608144400,2),(141,-589392000,1),(141,-576090000,2),(141,-557942400,1),(141,-544640400,2),(141,-526492800,1),(141,-513190800,2),(141,-495043200,1),(141,-481741200,2),(141,-463593600,1),(141,-450291600,2),(141,-431539200,1),(141,-415818000,2),(141,-400089600,1),(141,-384368400,2),(141,-368640000,1),(141,-352918800,2),(141,-337190400,1),(141,-321469200,2),(141,-305740800,1),(141,-289414800,2),(141,-273686400,1),(141,-266432400,5),(141,-52938000,6),(141,-37216800,5),(141,-21488400,6),(141,-5767200,5),(141,9961200,6),(141,25682400,5),(141,41410800,6),(141,57736800,5),(141,73465200,6),(141,89186400,5),(141,104914800,6),(141,120636000,5),(141,126687600,1),(141,152089200,5),(141,162370800,6),(141,183535200,5),(141,199263600,6),(141,215589600,5),(141,230713200,6),(141,247039200,5),(141,262767600,6),(141,278488800,5),(141,294217200,6),(141,309938400,5),(141,325666800,6),(141,341388000,5),(141,357116400,6),(141,372837600,5),(141,388566000,6),(141,404892000,5),(141,420015600,6),(141,436341600,5),(141,452070000,6),(141,467791200,5),(141,483519600,6),(141,499240800,5),(141,514969200,6),(141,530690400,5),(141,544604400,6),(141,562140000,5),(141,576054000,6),(141,594194400,5),(141,607503600,6),(141,625644000,5),(141,638953200,6),(141,657093600,5),(141,671007600,6),(141,688543200,5),(141,702457200,6),(141,719992800,5),(141,733906800,6),(141,752047200,5),(141,765356400,6),(141,783496800,5),(141,796806000,6),(141,814946400,5),(141,828860400,6),(141,846396000,5),(141,860310000,6),(141,877845600,5),(141,891759600,6),(141,909295200,5),(141,923209200,6),(141,941349600,5),(141,954658800,6),(141,972799200,5),(141,986108400,6),(141,1004248800,5),(141,1018162800,6),(141,1035698400,5),(141,1049612400,6),(141,1067148000,5),(141,1081062000,6),(141,1099202400,5),(141,1112511600,6),(141,1130652000,5),(141,1143961200,6),(141,1162101600,5),(141,1173596400,6),(141,1194156000,5),(141,1205046000,6),(141,1225605600,5),(141,1236495600,6),(141,1257055200,5),(141,1268550000,6),(141,1289109600,5),(141,1299999600,6),(141,1320559200,5),(141,1331449200,6),(141,1352008800,5),(141,1362898800,6),(141,1383458400,5),(141,1394348400,6),(141,1414908000,5),(141,1425798000,6),(141,1446357600,5),(141,1457852400,6),(141,1478412000,5),(141,1489302000,6),(141,1509861600,5),(141,1520751600,6),(141,1541311200,5),(141,1552201200,6),(141,1572760800,5),(141,1583650800,6),(141,1604210400,5),(141,1615705200,6),(141,1636264800,5),(141,1647154800,6),(141,1667714400,5),(141,1678604400,6),(141,1699164000,5),(141,1710054000,6),(141,1730613600,5),(141,1741503600,6),(141,1762063200,5),(141,1772953200,6),(141,1793512800,5),(141,1805007600,6),(141,1825567200,5),(141,1836457200,6),(141,1857016800,5),(141,1867906800,6),(141,1888466400,5),(141,1899356400,6),(141,1919916000,5),(141,1930806000,6),(141,1951365600,5),(141,1962860400,6),(141,1983420000,5),(141,1994310000,6),(141,2014869600,5),(141,2025759600,6),(141,2046319200,5),(141,2057209200,6),(141,2077768800,5),(141,2088658800,6),(141,2109218400,5),(141,2120108400,6),(141,2140668000,5),(142,-2147483648,2),(142,-1633276800,1),(142,-1615136400,2),(142,-1601827200,1),(142,-1583686800,2),(142,-880214400,3),(142,-769395600,4),(142,-765392400,2),(142,-52934400,1),(142,-37213200,2),(142,-21484800,1),(142,-5763600,2),(142,9964800,1),(142,25686000,2),(142,41414400,1),(142,57740400,2),(142,73468800,1),(142,89190000,2),(142,104918400,1),(142,120639600,2),(142,126691200,1),(142,152089200,2),(142,162374400,1),(142,183538800,2),(142,199267200,1),(142,215593200,2),(142,230716800,1),(142,247042800,2),(142,262771200,1),(142,278492400,2),(142,294220800,1),(142,309942000,2),(142,325670400,1),(142,341391600,2),(142,357120000,1),(142,372841200,2),(142,388569600,1),(142,404895600,2),(142,420019200,1),(142,436345200,2),(142,452073600,1),(142,467794800,2),(142,483523200,1),(142,499244400,2),(142,514972800,1),(142,530694000,2),(142,544608000,1),(142,562143600,2),(142,576057600,1),(142,594198000,2),(142,607507200,1),(142,625647600,2),(142,638956800,1),(142,657097200,2),(142,671011200,1),(142,688546800,2),(142,702460800,1),(142,719996400,2),(142,733910400,1),(142,752050800,2),(142,765360000,1),(142,783500400,2),(142,796809600,1),(142,814950000,2),(142,828864000,1),(142,846399600,2),(142,860313600,1),(142,877849200,2),(142,891763200,1),(142,909298800,2),(142,923212800,1),(142,941353200,2),(142,954662400,1),(142,972802800,6),(142,986108400,5),(142,1004248800,6),(142,1018162800,5),(142,1035698400,6),(142,1049612400,5),(142,1067148000,6),(142,1081062000,5),(142,1099202400,6),(142,1112511600,5),(142,1130652000,6),(142,1143961200,5),(142,1162101600,6),(142,1173596400,5),(142,1194156000,6),(142,1205046000,5),(142,1225605600,6),(142,1236495600,5),(142,1257055200,6),(142,1268550000,5),(142,1289109600,6),(142,1299999600,5),(142,1320559200,6),(142,1331449200,5),(142,1352008800,6),(142,1362898800,5),(142,1383458400,6),(142,1394348400,5),(142,1414908000,6),(142,1425798000,5),(142,1446357600,6),(142,1457852400,5),(142,1478412000,6),(142,1489302000,5),(142,1509861600,6),(142,1520751600,5),(142,1541311200,6),(142,1552201200,5),(142,1572760800,6),(142,1583650800,5),(142,1604210400,6),(142,1615705200,5),(142,1636264800,6),(142,1647154800,5),(142,1667714400,6),(142,1678604400,5),(142,1699164000,6),(142,1710054000,5),(142,1730613600,6),(142,1741503600,5),(142,1762063200,6),(142,1772953200,5),(142,1793512800,6),(142,1805007600,5),(142,1825567200,6),(142,1836457200,5),(142,1857016800,6),(142,1867906800,5),(142,1888466400,6),(142,1899356400,5),(142,1919916000,6),(142,1930806000,5),(142,1951365600,6),(142,1962860400,5),(142,1983420000,6),(142,1994310000,5),(142,2014869600,6),(142,2025759600,5),(142,2046319200,6),(142,2057209200,5),(142,2077768800,6),(142,2088658800,5),(142,2109218400,6),(142,2120108400,5),(142,2140668000,6),(143,-2147483648,2),(143,-1633276800,1),(143,-1615136400,2),(143,-1601827200,1),(143,-1583686800,2),(143,-880214400,3),(143,-769395600,4),(143,-765392400,2),(143,-715795200,1),(143,-702493200,2),(143,-684345600,1),(143,-671043600,2),(143,-652896000,1),(143,-639594000,2),(143,-620841600,1),(143,-608144400,2),(143,-589392000,1),(143,-576090000,2),(143,-557942400,1),(143,-544640400,2),(143,-526492800,1),(143,-513190800,2),(143,-495043200,1),(143,-481741200,2),(143,-463593600,1),(143,-447267600,2),(143,-431539200,1),(143,-415818000,2),(143,-400089600,1),(143,-386787600,2),(143,-368640000,1),(143,-355338000,2),(143,-337190400,1),(143,-321469200,2),(143,-305740800,1),(143,-289414800,2),(143,-273686400,1),(143,-257965200,2),(143,-242236800,5),(143,-195066000,2),(143,-84384000,1),(143,-68662800,2),(143,-52934400,1),(143,-37213200,2),(143,-21484800,1),(143,-5763600,2),(143,9964800,1),(143,25686000,2),(143,41414400,1),(143,57740400,2),(143,73468800,1),(143,89190000,2),(143,104918400,1),(143,120639600,2),(143,126691200,1),(143,152089200,2),(143,162374400,1),(143,183538800,2),(143,199267200,1),(143,215593200,2),(143,230716800,1),(143,247042800,2),(143,262771200,1),(143,278492400,2),(143,294220800,1),(143,309942000,2),(143,325670400,1),(143,341391600,2),(143,357120000,1),(143,372841200,2),(143,388569600,1),(143,404895600,2),(143,420019200,1),(143,436345200,2),(143,452073600,1),(143,467794800,2),(143,483523200,1),(143,499244400,2),(143,514972800,1),(143,530694000,2),(143,544608000,1),(143,562143600,2),(143,576057600,1),(143,594198000,2),(143,607507200,1),(143,625647600,2),(143,638956800,1),(143,657097200,2),(143,671011200,1),(143,688546800,5),(143,1143961200,1),(143,1162105200,2),(143,1173600000,1),(143,1194159600,2),(143,1205049600,1),(143,1225609200,2),(143,1236499200,1),(143,1257058800,2),(143,1268553600,1),(143,1289113200,2),(143,1300003200,1),(143,1320562800,2),(143,1331452800,1),(143,1352012400,2),(143,1362902400,1),(143,1383462000,2),(143,1394352000,1),(143,1414911600,2),(143,1425801600,1),(143,1446361200,2),(143,1457856000,1),(143,1478415600,2),(143,1489305600,1),(143,1509865200,2),(143,1520755200,1),(143,1541314800,2),(143,1552204800,1),(143,1572764400,2),(143,1583654400,1),(143,1604214000,2),(143,1615708800,1),(143,1636268400,2),(143,1647158400,1),(143,1667718000,2),(143,1678608000,1),(143,1699167600,2),(143,1710057600,1),(143,1730617200,2),(143,1741507200,1),(143,1762066800,2),(143,1772956800,1),(143,1793516400,2),(143,1805011200,1),(143,1825570800,2),(143,1836460800,1),(143,1857020400,2),(143,1867910400,1),(143,1888470000,2),(143,1899360000,1),(143,1919919600,2),(143,1930809600,1),(143,1951369200,2),(143,1962864000,1),(143,1983423600,2),(143,1994313600,1),(143,2014873200,2),(143,2025763200,1),(143,2046322800,2),(143,2057212800,1),(143,2077772400,2),(143,2088662400,1),(143,2109222000,2),(143,2120112000,1),(143,2140671600,2),(144,-2147483648,0),(144,-1826738653,1),(144,-157750200,2),(145,-2147483648,1),(145,-1205954844,2),(145,-1192307244,3),(145,2147483647,3),(146,-2147483648,1),(146,-1938538284,3),(146,-1009825200,2),(146,-1002052800,3),(146,-986756400,2),(146,-971035200,3),(146,-955306800,2),(146,-939585600,3),(146,504939600,2),(146,512712000,3),(146,536475600,2),(146,544248000,3),(146,631170000,2),(146,638942400,3),(146,757400400,2),(146,765172800,3),(146,2147483647,3),(147,-2147483648,2),(147,-1633269600,1),(147,-1615129200,2),(147,-1601820000,1),(147,-1583679600,2),(147,-880207200,3),(147,-769395600,4),(147,-765385200,2),(147,-687967140,1),(147,-662655600,2),(147,-620838000,1),(147,-608137200,2),(147,-589388400,1),(147,-576082800,2),(147,-557938800,1),(147,-544633200,2),(147,-526489200,1),(147,-513183600,2),(147,-495039600,1),(147,-481734000,2),(147,-463590000,1),(147,-450284400,2),(147,-431535600,1),(147,-418230000,2),(147,-400086000,1),(147,-386780400,2),(147,-368636400,1),(147,-355330800,2),(147,-337186800,1),(147,-323881200,2),(147,-305737200,1),(147,-292431600,2),(147,-273682800,1),(147,-260982000,2),(147,-242233200,1),(147,-226508400,2),(147,-210783600,1),(147,-195058800,2),(147,-179334000,1),(147,-163609200,2),(147,-147884400,1),(147,-131554800,2),(147,-116434800,1),(147,-100105200,2),(147,-84376800,1),(147,-68655600,2),(147,-52927200,1),(147,-37206000,2),(147,-21477600,1),(147,-5756400,2),(147,9972000,1),(147,25693200,2),(147,41421600,1),(147,57747600,2),(147,73476000,1),(147,89197200,2),(147,104925600,1),(147,120646800,2),(147,126698400,1),(147,152096400,2),(147,162381600,1),(147,183546000,2),(147,199274400,1),(147,215600400,2),(147,230724000,1),(147,247050000,2),(147,262778400,1),(147,278499600,2),(147,294228000,1),(147,309949200,2),(147,325677600,1),(147,341398800,2),(147,357127200,1),(147,372848400,2),(147,388576800,1),(147,404902800,2),(147,420026400,1),(147,436352400,2),(147,452080800,1),(147,467802000,2),(147,483530400,1),(147,499251600,2),(147,514980000,1),(147,530701200,2),(147,544615200,1),(147,562150800,2),(147,576064800,1),(147,594205200,2),(147,607514400,1),(147,625654800,2),(147,638964000,1),(147,657104400,2),(147,671018400,1),(147,688554000,2),(147,702468000,1),(147,720003600,2),(147,733917600,1),(147,752058000,2),(147,765367200,1),(147,783507600,2),(147,796816800,1),(147,814957200,2),(147,828871200,1),(147,846406800,2),(147,860320800,1),(147,877856400,2),(147,891770400,1),(147,909306000,2),(147,923220000,1),(147,941360400,2),(147,954669600,1),(147,972810000,2),(147,986119200,1),(147,1004259600,2),(147,1018173600,1),(147,1035709200,2),(147,1049623200,1),(147,1067158800,2),(147,1081072800,1),(147,1099213200,2),(147,1112522400,1),(147,1130662800,2),(147,1143972000,1),(147,1162112400,2),(147,1173607200,1),(147,1194166800,2),(147,1205056800,1),(147,1225616400,2),(147,1236506400,1),(147,1257066000,2),(147,1268560800,1),(147,1289120400,2),(147,1300010400,1),(147,1320570000,2),(147,1331460000,1),(147,1352019600,2),(147,1362909600,1),(147,1383469200,2),(147,1394359200,1),(147,1414918800,2),(147,1425808800,1),(147,1446368400,2),(147,1457863200,1),(147,1478422800,2),(147,1489312800,1),(147,1509872400,2),(147,1520762400,1),(147,1541322000,2),(147,1552212000,1),(147,1572771600,2),(147,1583661600,1),(147,1604221200,2),(147,1615716000,1),(147,1636275600,2),(147,1647165600,1),(147,1667725200,2),(147,1678615200,1),(147,1699174800,2),(147,1710064800,1),(147,1730624400,2),(147,1741514400,1),(147,1762074000,2),(147,1772964000,1),(147,1793523600,2),(147,1805018400,1),(147,1825578000,2),(147,1836468000,1),(147,1857027600,2),(147,1867917600,1),(147,1888477200,2),(147,1899367200,1),(147,1919926800,2),(147,1930816800,1),(147,1951376400,2),(147,1962871200,1),(147,1983430800,2),(147,1994320800,1),(147,2014880400,2),(147,2025770400,1),(147,2046330000,2),(147,2057220000,1),(147,2077779600,2),(147,2088669600,1),(147,2109229200,2),(147,2120119200,1),(147,2140678800,2),(148,-2147483648,2),(148,-1633276800,1),(148,-1615136400,2),(148,-1601827200,1),(148,-1583686800,2),(148,-1535904000,1),(148,-1525280400,2),(148,-905097600,1),(148,-891795600,2),(148,-880214400,3),(148,-769395600,4),(148,-765392400,2),(148,-757360800,1),(148,-744224400,2),(148,-715795200,1),(148,-608144400,2),(148,-589392000,1),(148,-576090000,2),(148,-557942400,1),(148,-544640400,2),(148,-526492800,1),(148,-513190800,2),(148,-495043200,1),(148,-481741200,2),(148,-463593600,1),(148,-450291600,2),(148,-431539200,1),(148,-415818000,2),(148,-400089600,1),(148,-384368400,2),(148,-368640000,1),(148,-352918800,2),(148,-337190400,1),(148,-321469200,2),(148,-305740800,1),(148,-289414800,2),(148,-273686400,1),(148,-266432400,5),(148,-52938000,6),(148,-37216800,5),(148,-21488400,6),(148,-5767200,5),(148,9961200,6),(148,25682400,5),(148,41410800,6),(148,57736800,5),(148,73465200,6),(148,89186400,5),(148,104914800,6),(148,120636000,5),(148,126687600,1),(148,152089200,5),(148,162370800,6),(148,183535200,5),(148,199263600,6),(148,215589600,5),(148,230713200,6),(148,247039200,5),(148,262767600,6),(148,278488800,5),(148,294217200,6),(148,309938400,5),(148,325666800,6),(148,341388000,5),(148,357116400,6),(148,372837600,5),(148,388566000,6),(148,404892000,5),(148,420015600,6),(148,436341600,5),(148,452070000,6),(148,467791200,5),(148,483519600,6),(148,499240800,5),(148,514969200,6),(148,530690400,5),(148,544604400,6),(148,562140000,5),(148,576054000,6),(148,594194400,5),(148,607503600,6),(148,625644000,5),(148,638953200,6),(148,657093600,5),(148,671007600,6),(148,688543200,5),(148,702457200,6),(148,719992800,5),(148,733906800,6),(148,752047200,5),(148,765356400,6),(148,783496800,5),(148,796806000,6),(148,814946400,5),(148,828860400,6),(148,846396000,5),(148,860310000,6),(148,877845600,5),(148,891759600,6),(148,909295200,5),(148,923209200,6),(148,941349600,5),(148,954658800,6),(148,972799200,5),(148,986108400,6),(148,1004248800,5),(148,1018162800,6),(148,1035698400,5),(148,1049612400,6),(148,1067148000,5),(148,1081062000,6),(148,1099202400,5),(148,1112511600,6),(148,1130652000,5),(148,1143961200,6),(148,1162101600,5),(148,1173596400,6),(148,1194156000,5),(148,1205046000,6),(148,1225605600,5),(148,1236495600,6),(148,1257055200,5),(148,1268550000,6),(148,1289109600,5),(148,1299999600,6),(148,1320559200,5),(148,1331449200,6),(148,1352008800,5),(148,1362898800,6),(148,1383458400,5),(148,1394348400,6),(148,1414908000,5),(148,1425798000,6),(148,1446357600,5),(148,1457852400,6),(148,1478412000,5),(148,1489302000,6),(148,1509861600,5),(148,1520751600,6),(148,1541311200,5),(148,1552201200,6),(148,1572760800,5),(148,1583650800,6),(148,1604210400,5),(148,1615705200,6),(148,1636264800,5),(148,1647154800,6),(148,1667714400,5),(148,1678604400,6),(148,1699164000,5),(148,1710054000,6),(148,1730613600,5),(148,1741503600,6),(148,1762063200,5),(148,1772953200,6),(148,1793512800,5),(148,1805007600,6),(148,1825567200,5),(148,1836457200,6),(148,1857016800,5),(148,1867906800,6),(148,1888466400,5),(148,1899356400,6),(148,1919916000,5),(148,1930806000,6),(148,1951365600,5),(148,1962860400,6),(148,1983420000,5),(148,1994310000,6),(148,2014869600,5),(148,2025759600,6),(148,2046319200,5),(148,2057209200,6),(148,2077768800,5),(148,2088658800,6),(148,2109218400,5),(148,2120108400,6),(148,2140668000,5),(149,-2147483648,0),(149,-1826738653,1),(149,-157750200,2),(150,-2147483648,0),(150,-1767217028,2),(150,-1206957600,1),(150,-1191362400,2),(150,-1175374800,1),(150,-1159826400,2),(150,-633819600,1),(150,-622069200,2),(150,-602283600,1),(150,-591832800,2),(150,-570747600,1),(150,-560210400,2),(150,-539125200,1),(150,-531352800,2),(150,-191365200,1),(150,-184197600,2),(150,-155163600,1),(150,-150069600,2),(150,-128898000,1),(150,-121125600,2),(150,-99954000,1),(150,-89589600,2),(150,-68418000,1),(150,-57967200,2),(150,499748400,1),(150,511236000,2),(150,530593200,1),(150,540266400,2),(150,562129200,1),(150,571197600,2),(150,592974000,1),(150,602042400,2),(150,624423600,1),(150,634701600,2),(150,813726000,1),(150,824004000,2),(150,938919600,1),(150,951616800,2),(150,970974000,1),(150,972180000,2),(150,1003028400,1),(150,1013911200,2),(150,2147483647,2),(151,-2147483648,1),(151,-1121105688,2),(151,105084000,3),(151,161758800,2),(151,290584800,4),(151,299134800,2),(151,322034400,4),(151,330584400,2),(151,694260000,3),(151,717310800,2),(151,725868000,3),(151,852094800,2),(151,1113112800,4),(151,1128229200,2),(151,1146384000,4),(151,1159682400,2),(152,-2147483648,0),(152,-1767211196,2),(152,-1206954000,1),(152,-1191358800,2),(152,-1175371200,1),(152,-1159822800,2),(152,-633816000,1),(152,-622065600,2),(152,-602280000,1),(152,-591829200,2),(152,-570744000,1),(152,-560206800,2),(152,-539121600,1),(152,-531349200,2),(152,-191361600,1),(152,-184194000,2),(152,-155160000,1),(152,-150066000,2),(152,-128894400,1),(152,-121122000,2),(152,-99950400,1),(152,-89586000,2),(152,-68414400,1),(152,-57963600,2),(152,499752000,1),(152,511239600,2),(152,530596800,1),(152,540270000,2),(152,562132800,1),(152,571201200,2),(152,750830400,1),(152,761713200,2),(152,2147483647,2),(153,-2147483648,0),(153,-1825098836,1),(154,-2147483648,1),(154,-1851537340,2),(154,323841600,3),(154,338958000,2),(155,-2147483648,0),(155,-1514743200,1),(155,576057600,2),(155,594198000,1),(155,828864000,2),(155,846399600,1),(155,860313600,2),(155,877849200,1),(155,891763200,2),(155,909298800,1),(155,923212800,2),(155,941353200,1),(155,954662400,2),(155,972802800,1),(155,989136000,2),(155,1001833200,1),(155,1018166400,2),(155,1035702000,1),(155,1049616000,2),(155,1067151600,1),(155,1081065600,2),(155,1099206000,1),(155,1112515200,2),(155,1130655600,1),(155,1143964800,2),(155,1162105200,1),(155,1175414400,2),(155,1193554800,1),(155,1207468800,2),(155,1225004400,1),(155,1238918400,2),(155,1256454000,1),(155,1268553600,2),(155,1289113200,1),(155,1300003200,2),(155,1320562800,1),(155,1331452800,2),(155,1352012400,1),(155,1362902400,2),(155,1383462000,1),(155,1394352000,2),(155,1414911600,1),(155,1425801600,2),(155,1446361200,1),(155,1457856000,2),(155,1478415600,1),(155,1489305600,2),(155,1509865200,1),(155,1520755200,2),(155,1541314800,1),(155,1552204800,2),(155,1572764400,1),(155,1583654400,2),(155,1604214000,1),(155,1615708800,2),(155,1636268400,1),(155,1647158400,2),(155,1667718000,1),(155,1678608000,2),(155,1699167600,1),(155,1710057600,2),(155,1730617200,1),(155,1741507200,2),(155,1762066800,1),(155,1772956800,2),(155,1793516400,1),(155,1805011200,2),(155,1825570800,1),(155,1836460800,2),(155,1857020400,1),(155,1867910400,2),(155,1888470000,1),(155,1899360000,2),(155,1919919600,1),(155,1930809600,2),(155,1951369200,1),(155,1962864000,2),(155,1983423600,1),(155,1994313600,2),(155,2014873200,1),(155,2025763200,2),(155,2046322800,1),(155,2057212800,2),(155,2077772400,1),(155,2088662400,2),(155,2109222000,1),(155,2120112000,2),(155,2140671600,1),(156,-2147483648,0),(156,-1514739600,1),(156,-1343066400,2),(156,-1234807200,1),(156,-1220292000,2),(156,-1207159200,1),(156,-1191344400,2),(156,-873828000,1),(156,-661539600,3),(156,28800,1),(156,828867600,4),(156,846403200,1),(156,860317200,4),(156,877852800,1),(156,891766800,4),(156,909302400,1),(156,923216400,4),(156,941356800,1),(156,954666000,4),(156,972806400,1),(156,989139600,4),(156,1001836800,1),(156,1018170000,4),(156,1035705600,1),(156,1049619600,4),(156,1067155200,1),(156,1081069200,4),(156,1099209600,1),(156,1112518800,4),(156,1130659200,1),(156,1143968400,4),(156,1162108800,1),(156,1175418000,4),(156,1193558400,1),(156,1207472400,4),(156,1225008000,1),(156,1238922000,4),(156,1256457600,1),(156,1270371600,4),(156,1288512000,1),(156,1301821200,4),(156,1319961600,1),(156,1333270800,4),(156,1351411200,1),(156,1365325200,4),(156,1382860800,1),(156,1396774800,4),(156,1414310400,1),(156,1428224400,4),(156,1445760000,1),(156,1459674000,4),(156,1477814400,1),(156,1491123600,4),(156,1509264000,1),(156,1522573200,4),(156,1540713600,1),(156,1554627600,4),(156,1572163200,1),(156,1586077200,4),(156,1603612800,1),(156,1617526800,4),(156,1635667200,1),(156,1648976400,4),(156,1667116800,1),(156,1680426000,4),(156,1698566400,1),(156,1712480400,4),(156,1730016000,1),(156,1743930000,4),(156,1761465600,1),(156,1775379600,4),(156,1792915200,1),(156,1806829200,4),(156,1824969600,1),(156,1838278800,4),(156,1856419200,1),(156,1869728400,4),(156,1887868800,1),(156,1901782800,4),(156,1919318400,1),(156,1933232400,4),(156,1950768000,1),(156,1964682000,4),(156,1982822400,1),(156,1996131600,4),(156,2014272000,1),(156,2027581200,4),(156,2045721600,1),(156,2059030800,4),(156,2077171200,1),(156,2091085200,4),(156,2108620800,1),(156,2122534800,4),(156,2140070400,1),(157,-2147483648,1),(157,-1567453392,2),(157,-1233432000,3),(157,-1222981200,2),(157,-1205956800,3),(157,-1194037200,2),(157,-1172865600,3),(157,-1162501200,2),(157,-1141329600,3),(157,-1130965200,2),(157,-1109793600,3),(157,-1099429200,2),(157,-1078257600,3),(157,-1067806800,2),(157,-1046635200,3),(157,-1036270800,2),(157,-1015099200,3),(157,-1004734800,2),(157,-983563200,3),(157,-973198800,2),(157,-952027200,3),(157,-941576400,2),(157,-931032000,3),(157,-900882000,2),(157,-890337600,3),(157,-833749200,2),(157,-827265600,3),(157,-752274000,2),(157,-733780800,3),(157,-197326800,2),(157,-190843200,3),(157,-184194000,2),(157,-164491200,3),(157,-152658000,2),(157,-132955200,3),(157,-121122000,2),(157,-101419200,3),(157,-86821200,2),(157,-71092800,3),(157,-54766800,2),(157,-39038400,3),(157,-23317200,2),(157,-7588800,5),(157,128142000,4),(157,136605600,5),(157,596948400,4),(157,605066400,5),(157,624423600,4),(157,636516000,2),(157,655963200,3),(157,667796400,2),(157,687499200,3),(157,699418800,2),(157,719380800,4),(157,731469600,5),(157,938919600,3),(157,952052400,5),(157,1085281200,2),(157,1096171200,5),(157,1198983600,4),(157,1205632800,5),(157,2147483647,5),(158,-2147483648,2),(158,-1633276800,1),(158,-1615136400,2),(158,-1601827200,1),(158,-1583686800,2),(158,-880214400,3),(158,-769395600,4),(158,-765392400,2),(158,-747244800,1),(158,-733942800,2),(158,-116438400,1),(158,-100112400,2),(158,-21484800,5),(158,104914800,1),(158,120639600,2),(158,126691200,1),(158,152089200,2),(158,162374400,1),(158,183538800,2),(158,199267200,1),(158,215593200,2),(158,230716800,1),(158,247042800,2),(158,262771200,1),(158,278492400,2),(158,294220800,1),(158,309942000,2),(158,325670400,1),(158,341391600,2),(158,357120000,1),(158,372841200,2),(158,388569600,1),(158,404895600,2),(158,420019200,1),(158,436345200,2),(158,452073600,1),(158,467794800,2),(158,483523200,1),(158,499244400,2),(158,514972800,1),(158,530694000,2),(158,544608000,1),(158,562143600,2),(158,576057600,1),(158,594198000,2),(158,607507200,1),(158,625647600,2),(158,638956800,1),(158,657097200,2),(158,671011200,1),(158,688546800,2),(158,702460800,1),(158,719996400,2),(158,733910400,1),(158,752050800,2),(158,765360000,1),(158,783500400,2),(158,796809600,1),(158,814950000,2),(158,828864000,1),(158,846399600,2),(158,860313600,1),(158,877849200,2),(158,891763200,1),(158,909298800,2),(158,923212800,1),(158,941353200,2),(158,954662400,1),(158,972802800,2),(158,986112000,1),(158,1004252400,2),(158,1018166400,1),(158,1035702000,2),(158,1049616000,1),(158,1067151600,2),(158,1081065600,1),(158,1099206000,2),(158,1112515200,1),(158,1130655600,2),(158,1143964800,1),(158,1162105200,2),(158,1173600000,1),(158,1194159600,2),(158,1205049600,1),(158,1225609200,2),(158,1236499200,1),(158,1257058800,2),(158,1268553600,1),(158,1289113200,2),(158,1300003200,1),(158,1320562800,2),(158,1331452800,1),(158,1352012400,2),(158,1362902400,1),(158,1383462000,2),(158,1394352000,1),(158,1414911600,2),(158,1425801600,1),(158,1446361200,2),(158,1457856000,1),(158,1478415600,2),(158,1489305600,1),(158,1509865200,2),(158,1520755200,1),(158,1541314800,2),(158,1552204800,1),(158,1572764400,2),(158,1583654400,1),(158,1604214000,2),(158,1615708800,1),(158,1636268400,2),(158,1647158400,1),(158,1667718000,2),(158,1678608000,1),(158,1699167600,2),(158,1710057600,1),(158,1730617200,2),(158,1741507200,1),(158,1762066800,2),(158,1772956800,1),(158,1793516400,2),(158,1805011200,1),(158,1825570800,2),(158,1836460800,1),(158,1857020400,2),(158,1867910400,1),(158,1888470000,2),(158,1899360000,1),(158,1919919600,2),(158,1930809600,1),(158,1951369200,2),(158,1962864000,1),(158,1983423600,2),(158,1994313600,1),(158,2014873200,2),(158,2025763200,1),(158,2046322800,2),(158,2057212800,1),(158,2077772400,2),(158,2088662400,1),(158,2109222000,2),(158,2120112000,1),(158,2140671600,2),(159,-2147483648,0),(159,-1514743200,1),(159,377935200,2),(159,407653200,1),(159,828864000,3),(159,846399600,1),(159,860313600,3),(159,877849200,1),(159,891763200,3),(159,909298800,1),(159,923212800,3),(159,941353200,1),(159,954662400,3),(159,972802800,1),(159,989136000,3),(159,1001833200,1),(159,1018166400,3),(159,1035702000,1),(159,1049616000,3),(159,1067151600,1),(159,1081065600,3),(159,1099206000,1),(159,1112515200,3),(159,1130655600,1),(159,1143964800,3),(159,1162105200,1),(159,1175414400,3),(159,1193554800,1),(159,1207468800,3),(159,1225004400,1),(159,1238918400,3),(159,1256454000,1),(159,1270368000,3),(159,1288508400,1),(159,1301817600,3),(159,1319958000,1),(159,1333267200,3),(159,1351407600,1),(159,1365321600,3),(159,1382857200,1),(159,1396771200,3),(159,1414306800,1),(159,1428220800,3),(159,1445756400,1),(159,1459670400,3),(159,1477810800,1),(159,1491120000,3),(159,1509260400,1),(159,1522569600,3),(159,1540710000,1),(159,1554624000,3),(159,1572159600,1),(159,1586073600,3),(159,1603609200,1),(159,1617523200,3),(159,1635663600,1),(159,1648972800,3),(159,1667113200,1),(159,1680422400,3),(159,1698562800,1),(159,1712476800,3),(159,1730012400,1),(159,1743926400,3),(159,1761462000,1),(159,1775376000,3),(159,1792911600,1),(159,1806825600,3),(159,1824966000,1),(159,1838275200,3),(159,1856415600,1),(159,1869724800,3),(159,1887865200,1),(159,1901779200,3),(159,1919314800,1),(159,1933228800,3),(159,1950764400,1),(159,1964678400,3),(159,1982818800,1),(159,1996128000,3),(159,2014268400,1),(159,2027577600,3),(159,2045718000,1),(159,2059027200,3),(159,2077167600,1),(159,2091081600,3),(159,2108617200,1),(159,2122531200,3),(159,2140066800,1),(160,-2147483648,1),(160,-880207200,2),(160,-769395600,3),(160,-765385200,1),(160,-21477600,4),(160,-5756400,1),(160,9972000,4),(160,25693200,1),(160,41421600,4),(160,57747600,1),(160,73476000,4),(160,89197200,1),(160,104925600,4),(160,120646800,1),(160,126698400,4),(160,152096400,1),(160,162381600,4),(160,183546000,1),(160,199274400,4),(160,215600400,1),(160,230724000,4),(160,247050000,1),(160,262778400,4),(160,278499600,1),(160,294228000,4),(160,309949200,1),(160,325677600,4),(160,341398800,1),(160,357127200,4),(160,372848400,1),(160,388576800,4),(160,404902800,1),(160,420026400,4),(160,436352400,1),(160,1446372000,5),(160,1457866800,6),(160,1478426400,5),(160,1489316400,6),(160,1509876000,5),(160,1520766000,6),(160,1541325600,1),(160,1547978400,5),(160,1552215600,6),(160,1572775200,5),(160,1583665200,6),(160,1604224800,5),(160,1615719600,6),(160,1636279200,5),(160,1647169200,6),(160,1667728800,5),(160,1678618800,6),(160,1699178400,5),(160,1710068400,6),(160,1730628000,5),(160,1741518000,6),(160,1762077600,5),(160,1772967600,6),(160,1793527200,5),(160,1805022000,6),(160,1825581600,5),(160,1836471600,6),(160,1857031200,5),(160,1867921200,6),(160,1888480800,5),(160,1899370800,6),(160,1919930400,5),(160,1930820400,6),(160,1951380000,5),(160,1962874800,6),(160,1983434400,5),(160,1994324400,6),(160,2014884000,5),(160,2025774000,6),(160,2046333600,5),(160,2057223600,6),(160,2077783200,5),(160,2088673200,6),(160,2109232800,5),(160,2120122800,6),(160,2140682400,5),(161,-2147483648,0),(161,-1514739600,1),(161,-1343066400,2),(161,-1234807200,1),(161,-1220292000,2),(161,-1207159200,1),(161,-1191344400,2),(161,-975261600,3),(161,-963169200,2),(161,-917114400,3),(161,-907354800,2),(161,-821901600,4),(161,-810068400,2),(161,-627501600,3),(161,-612990000,2),(161,828864000,3),(161,846399600,2),(161,860313600,3),(161,877849200,2),(161,891763200,3),(161,909298800,2),(161,923212800,3),(161,941353200,2),(161,954662400,3),(161,972802800,2),(161,989136000,3),(161,1001833200,2),(161,1018166400,3),(161,1035702000,2),(161,1049616000,3),(161,1067151600,2),(161,1081065600,3),(161,1099206000,2),(161,1112515200,3),(161,1130655600,2),(161,1143964800,3),(161,1162105200,2),(161,1175414400,3),(161,1193554800,2),(161,1207468800,3),(161,1225004400,2),(161,1238918400,3),(161,1256454000,2),(161,1270368000,3),(161,1288508400,2),(161,1301817600,3),(161,1319958000,2),(161,1333267200,3),(161,1351407600,2),(161,1365321600,3),(161,1382857200,2),(161,1396771200,3),(161,1414306800,2),(161,1428220800,3),(161,1445756400,2),(161,1459670400,3),(161,1477810800,2),(161,1491120000,3),(161,1509260400,2),(161,1522569600,3),(161,1540710000,2),(161,1554624000,3),(161,1572159600,2),(161,1586073600,3),(161,1603609200,2),(161,1617523200,3),(161,1635663600,2),(161,1648972800,3),(161,1667113200,2),(161,1680422400,3),(161,1698562800,2),(161,1712476800,3),(161,1730012400,2),(161,1743926400,3),(161,1761462000,2),(161,1775376000,3),(161,1792911600,2),(161,1806825600,3),(161,1824966000,2),(161,1838275200,3),(161,1856415600,2),(161,1869724800,3),(161,1887865200,2),(161,1901779200,3),(161,1919314800,2),(161,1933228800,3),(161,1950764400,2),(161,1964678400,3),(161,1982818800,2),(161,1996128000,3),(161,2014268400,2),(161,2027577600,3),(161,2045718000,2),(161,2059027200,3),(161,2077167600,2),(161,2091081600,3),(161,2108617200,2),(161,2122531200,3),(161,2140066800,2),(162,-2147483648,0),(162,-1850328920,1),(162,326001600,2),(162,544597200,3),(162,562132800,2),(162,576046800,3),(162,594187200,2),(162,607496400,3),(162,625636800,2),(162,638946000,3),(162,657086400,2),(162,671000400,3),(162,688536000,2),(162,702450000,3),(162,719985600,2),(162,733899600,3),(162,752040000,2),(162,765349200,3),(162,783489600,2),(162,796798800,3),(162,814939200,2),(162,828853200,3),(162,846388800,2),(162,860302800,3),(162,877838400,2),(162,891752400,3),(162,909288000,2),(162,923202000,3),(162,941342400,2),(162,954651600,3),(162,972792000,2),(162,986101200,3),(162,1004241600,2),(162,1018155600,3),(162,1035691200,2),(162,1049605200,3),(162,1067140800,2),(162,1081054800,3),(162,1099195200,2),(162,1112504400,3),(162,1130644800,2),(162,1143954000,3),(162,1162094400,2),(162,1173589200,3),(162,1194148800,2),(162,1205038800,3),(162,1225598400,2),(162,1236488400,3),(162,1257048000,2),(162,1268542800,3),(162,1289102400,2),(162,1299992400,3),(162,1320552000,2),(162,1331442000,3),(162,1352001600,2),(162,1362891600,3),(162,1383451200,2),(162,1394341200,3),(162,1414900800,2),(162,1425790800,3),(162,1446350400,2),(162,1457845200,3),(162,1478404800,2),(162,1489294800,3),(162,1509854400,2),(162,1520744400,3),(162,1541304000,2),(162,1552194000,3),(162,1572753600,2),(162,1583643600,3),(162,1604203200,2),(162,1615698000,3),(162,1636257600,2),(162,1647147600,3),(162,1667707200,2),(162,1678597200,3),(162,1699156800,2),(162,1710046800,3),(162,1730606400,2),(162,1741496400,3),(162,1762056000,2),(162,1772946000,3),(162,1793505600,2),(162,1805000400,3),(162,1825560000,2),(162,1836450000,3),(162,1857009600,2),(162,1867899600,3),(162,1888459200,2),(162,1899349200,3),(162,1919908800,2),(162,1930798800,3),(162,1951358400,2),(162,1962853200,3),(162,1983412800,2),(162,1994302800,3),(162,2014862400,2),(162,2025752400,3),(162,2046312000,2),(162,2057202000,3),(162,2077761600,2),(162,2088651600,3),(162,2109211200,2),(162,2120101200,3),(162,2140660800,2),(162,2147483647,2),(163,-2147483648,1),(163,-2131642800,3),(163,-1632074400,2),(163,-1615143600,3),(163,-1153681200,2),(163,-1145822400,3),(163,-1122231600,2),(163,-1114372800,3),(163,-1090782000,2),(163,-1082923200,3),(163,-1059332400,2),(163,-1051473600,3),(163,-1027882800,2),(163,-1020024000,3),(163,-996433200,2),(163,-988574400,3),(163,-965674800,2),(163,-955396800,3),(163,-934743600,2),(163,-923947200,3),(163,-904503600,2),(163,-891892800,3),(163,-880221600,4),(163,-769395600,5),(163,-765399600,3),(163,-747252000,2),(163,-733950000,3),(163,-715802400,2),(163,-702500400,3),(163,-684352800,2),(163,-671050800,3),(163,-652903200,2),(163,-639601200,3),(163,-620848800,2),(163,-608151600,3),(163,-589399200,2),(163,-576097200,3),(163,-557949600,2),(163,-544647600,3),(163,-526500000,2),(163,-513198000,3),(163,-495050400,2),(163,-481748400,3),(163,-463600800,2),(163,-450298800,3),(163,-431546400,2),(163,-418244400,3),(163,-400096800,2),(163,-384375600,3),(163,-368647200,2),(163,-352926000,3),(163,-337197600,2),(163,-321476400,3),(163,-305748000,2),(163,-289422000,3),(163,-273693600,2),(163,-257972400,3),(163,-242244000,2),(163,-226522800,3),(163,-210794400,2),(163,-195073200,3),(163,-179344800,2),(163,-163623600,3),(163,-147895200,2),(163,-131569200,3),(163,-116445600,2),(163,-100119600,3),(163,-84391200,2),(163,-68670000,3),(163,-52941600,2),(163,-37220400,3),(163,-21492000,2),(163,-5770800,3),(163,9957600,2),(163,25678800,3),(163,41407200,2),(163,57733200,3),(163,73461600,2),(163,89182800,3),(163,136360800,2),(163,152082000,3),(163,167810400,2),(163,183531600,3),(163,199260000,2),(163,215586000,3),(163,230709600,2),(163,247035600,3),(163,262764000,2),(163,278485200,3),(163,294213600,2),(163,309934800,3),(163,325663200,2),(163,341384400,3),(163,357112800,2),(163,372834000,3),(163,388562400,2),(163,404888400,3),(163,420012000,2),(163,436338000,3),(163,452066400,2),(163,467787600,3),(163,483516000,2),(163,499237200,3),(163,514965600,2),(163,530686800,3),(163,544600800,2),(163,562136400,3),(163,576050400,2),(163,594190800,3),(163,607500000,2),(163,625640400,3),(163,638949600,2),(163,657090000,3),(163,671004000,2),(163,688539600,3),(163,702453600,2),(163,719989200,3),(163,733896060,2),(163,752036460,3),(163,765345660,2),(163,783486060,3),(163,796795260,2),(163,814935660,3),(163,828849660,2),(163,846385260,3),(163,860299260,2),(163,877834860,3),(163,891748860,2),(163,909284460,3),(163,923198460,2),(163,941338860,3),(163,954648060,2),(163,972788460,3),(163,986097660,2),(163,1004238060,3),(163,1018152060,2),(163,1035687660,3),(163,1049601660,2),(163,1067137260,3),(163,1081051260,2),(163,1099191660,3),(163,1112500860,2),(163,1130641260,3),(163,1143950460,2),(163,1162090860,3),(163,1173592800,2),(163,1194152400,3),(163,1205042400,2),(163,1225602000,3),(163,1236492000,2),(163,1257051600,3),(163,1268546400,2),(163,1289106000,3),(163,1299996000,2),(163,1320555600,3),(163,1331445600,2),(163,1352005200,3),(163,1362895200,2),(163,1383454800,3),(163,1394344800,2),(163,1414904400,3),(163,1425794400,2),(163,1446354000,3),(163,1457848800,2),(163,1478408400,3),(163,1489298400,2),(163,1509858000,3),(163,1520748000,2),(163,1541307600,3),(163,1552197600,2),(163,1572757200,3),(163,1583647200,2),(163,1604206800,3),(163,1615701600,2),(163,1636261200,3),(163,1647151200,2),(163,1667710800,3),(163,1678600800,2),(163,1699160400,3),(163,1710050400,2),(163,1730610000,3),(163,1741500000,2),(163,1762059600,3),(163,1772949600,2),(163,1793509200,3),(163,1805004000,2),(163,1825563600,3),(163,1836453600,2),(163,1857013200,3),(163,1867903200,2),(163,1888462800,3),(163,1899352800,2),(163,1919912400,3),(163,1930802400,2),(163,1951362000,3),(163,1962856800,2),(163,1983416400,3),(163,1994306400,2),(163,2014866000,3),(163,2025756000,2),(163,2046315600,3),(163,2057205600,2),(163,2077765200,3),(163,2088655200,2),(163,2109214800,3),(163,2120104800,2),(163,2140664400,3),(164,-2147483648,0),(164,-1514743200,1),(164,576057600,2),(164,594198000,1),(164,828864000,2),(164,846399600,1),(164,860313600,2),(164,877849200,1),(164,891763200,2),(164,909298800,1),(164,923212800,2),(164,941353200,1),(164,954662400,2),(164,972802800,1),(164,989136000,2),(164,1001833200,1),(164,1018166400,2),(164,1035702000,1),(164,1049616000,2),(164,1067151600,1),(164,1081065600,2),(164,1099206000,1),(164,1112515200,2),(164,1130655600,1),(164,1143964800,2),(164,1162105200,1),(164,1175414400,2),(164,1193554800,1),(164,1207468800,2),(164,1225004400,1),(164,1238918400,2),(164,1256454000,1),(164,1270368000,2),(164,1288508400,1),(164,1301817600,2),(164,1319958000,1),(164,1333267200,2),(164,1351407600,1),(164,1365321600,2),(164,1382857200,1),(164,1396771200,2),(164,1414306800,1),(164,1428220800,2),(164,1445756400,1),(164,1459670400,2),(164,1477810800,1),(164,1491120000,2),(164,1509260400,1),(164,1522569600,2),(164,1540710000,1),(164,1554624000,2),(164,1572159600,1),(164,1586073600,2),(164,1603609200,1),(164,1617523200,2),(164,1635663600,1),(164,1648972800,2),(164,1667113200,1),(164,1680422400,2),(164,1698562800,1),(164,1712476800,2),(164,1730012400,1),(164,1743926400,2),(164,1761462000,1),(164,1775376000,2),(164,1792911600,1),(164,1806825600,2),(164,1824966000,1),(164,1838275200,2),(164,1856415600,1),(164,1869724800,2),(164,1887865200,1),(164,1901779200,2),(164,1919314800,1),(164,1933228800,2),(164,1950764400,1),(164,1964678400,2),(164,1982818800,1),(164,1996128000,2),(164,2014268400,1),(164,2027577600,2),(164,2045718000,1),(164,2059027200,2),(164,2077167600,1),(164,2091081600,2),(164,2108617200,1),(164,2122531200,2),(164,2140066800,1),(165,-2147483648,0),(165,-1942690509,1),(165,-1567455309,2),(165,-1459627200,4),(165,-1443819600,3),(165,-1428006600,4),(165,-1412283600,3),(165,-1396470600,4),(165,-1380747600,3),(165,-1141590600,4),(165,-1128286800,3),(165,-1110141000,4),(165,-1096837200,3),(165,-1078691400,4),(165,-1065387600,3),(165,-1047241800,4),(165,-1033938000,3),(165,-1015187400,4),(165,-1002488400,3),(165,-983737800,4),(165,-971038800,3),(165,-954707400,4),(165,-938984400,3),(165,-920838600,4),(165,-907534800,3),(165,-896819400,4),(165,-853621200,6),(165,-845847000,5),(165,-334789200,6),(165,-319671000,5),(165,-314226000,7),(165,-309996000,5),(165,-149720400,7),(165,-134604000,5),(165,-50446800,6),(165,-34205400,5),(165,9860400,7),(165,14176800,5),(165,72846000,7),(165,80100000,5),(165,127278000,8),(165,132111000,6),(165,147234600,5),(165,156913200,7),(165,165376800,5),(165,219812400,7),(165,226461600,5),(165,250052400,7),(165,257911200,5),(165,282711600,7),(165,289360800,5),(165,294202800,7),(165,322020000,5),(165,566449200,7),(165,573012000,5),(165,597812400,7),(165,605066400,5),(165,625633200,7),(165,635911200,5),(165,656478000,7),(165,667965600,5),(165,688532400,7),(165,699415200,5),(165,719377200,7),(165,730864800,5),(165,1095562800,7),(165,1111896000,5),(165,1128834000,7),(165,1142136000,5),(165,1159678800,7),(165,1173585600,5),(165,1191733200,7),(165,1205035200,5),(165,1223182800,7),(165,1236484800,5),(165,1254632400,7),(165,1268539200,5),(165,1286082000,7),(165,1299988800,5),(165,1317531600,7),(165,1331438400,5),(165,1349586000,7),(165,1362888000,5),(165,1381035600,7),(165,1394337600,5),(165,1412485200,7),(165,1425787200,5),(165,2147483647,5),(166,-2147483648,2),(166,-1632070800,1),(166,-1615140000,2),(166,-1601753400,1),(166,-1583697600,2),(166,-1567357200,1),(166,-1554667200,2),(166,-1534698000,1),(166,-1524074400,2),(166,-1503248400,1),(166,-1492365600,2),(166,-1471798800,1),(166,-1460916000,2),(166,-1440954000,1),(166,-1428861600,2),(166,-1409504400,1),(166,-1397412000,2),(166,-1378054800,1),(166,-1365962400,2),(166,-1346605200,1),(166,-1333908000,2),(166,-1315155600,1),(166,-1301853600,2),(166,-1283706000,1),(166,-1270404000,2),(166,-1252256400,1),(166,-1238954400,2),(166,-1220806800,1),(166,-1207504800,2),(166,-1188752400,1),(166,-1176055200,2),(166,-1157302800,1),(166,-1144000800,2),(166,-1125853200,1),(166,-1112551200,2),(166,-1094403600,1),(166,-1081101600,2),(166,-1062954000,1),(166,-1049652000,2),(166,-1031504400,1),(166,-1018202400,2),(166,-1000054800,1),(166,-986752800,2),(166,-968000400,1),(166,-955303200,2),(166,-936550800,1),(166,-880218000,3),(166,-769395600,4),(166,-765396000,2),(166,-747248400,1),(166,-733946400,2),(166,-715806000,1),(166,-702504000,2),(166,-684356400,1),(166,-671054400,2),(166,-652906800,1),(166,-634161600,2),(166,-620845200,1),(166,-602704800,2),(166,-589395600,1),(166,-576093600,2),(166,-557946000,1),(166,-544644000,2),(166,-526496400,1),(166,-513194400,2),(166,-495046800,1),(166,-481744800,2),(166,-463597200,1),(166,-450295200,2),(166,-431542800,1),(166,-418240800,2),(166,-400093200,1),(166,-384372000,2),(166,-368643600,1),(166,-352922400,2),(166,-337194000,1),(166,-321472800,2),(166,-305744400,1),(166,-289418400,2),(166,-273690000,1),(166,-257968800,2),(166,-242240400,1),(166,-226519200,2),(166,-210790800,1),(166,-195069600,2),(166,-179341200,1),(166,-163620000,2),(166,-147891600,1),(166,-131565600,2),(166,-116442000,1),(166,-100116000,2),(166,-84387600,1),(166,-68666400,2),(166,-52938000,1),(166,-37216800,2),(166,-21488400,1),(166,-5767200,2),(166,9961200,1),(166,25682400,2),(166,41410800,1),(166,57736800,2),(166,73465200,1),(166,89186400,2),(166,104914800,1),(166,120636000,2),(166,136364400,1),(166,152085600,2),(166,167814000,1),(166,183535200,2),(166,199263600,1),(166,215589600,2),(166,230713200,1),(166,247039200,2),(166,262767600,1),(166,278488800,2),(166,294217200,1),(166,309938400,2),(166,325666800,1),(166,341388000,2),(166,357116400,1),(166,372837600,2),(166,388566000,1),(166,404892000,2),(166,420015600,1),(166,436341600,2),(166,452070000,1),(166,467791200,2),(166,483519600,1),(166,499240800,2),(166,514969200,1),(166,530690400,2),(166,544604400,1),(166,562140000,2),(166,576054000,1),(166,594194400,2),(166,607503600,1),(166,625644000,2),(166,638953200,1),(166,657093600,2),(166,671007600,1),(166,688543200,2),(166,702457200,1),(166,719992800,2),(166,733906800,1),(166,752047200,2),(166,765356400,1),(166,783496800,2),(166,796806000,1),(166,814946400,2),(166,828860400,1),(166,846396000,2),(166,860310000,1),(166,877845600,2),(166,891759600,1),(166,909295200,2),(166,923209200,1),(166,941349600,2),(166,954658800,1),(166,972799200,2),(166,986108400,1),(166,1004248800,2),(166,1018162800,1),(166,1035698400,2),(166,1049612400,1),(166,1067148000,2),(166,1081062000,1),(166,1099202400,2),(166,1112511600,1),(166,1130652000,2),(166,1143961200,1),(166,1162101600,2),(166,1173596400,1),(166,1194156000,2),(166,1205046000,1),(166,1225605600,2),(166,1236495600,1),(166,1257055200,2),(166,1268550000,1),(166,1289109600,2),(166,1299999600,1),(166,1320559200,2),(166,1331449200,1),(166,1352008800,2),(166,1362898800,1),(166,1383458400,2),(166,1394348400,1),(166,1414908000,2),(166,1425798000,1),(166,1446357600,2),(166,1457852400,1),(166,1478412000,2),(166,1489302000,1),(166,1509861600,2),(166,1520751600,1),(166,1541311200,2),(166,1552201200,1),(166,1572760800,2),(166,1583650800,1),(166,1604210400,2),(166,1615705200,1),(166,1636264800,2),(166,1647154800,1),(166,1667714400,2),(166,1678604400,1),(166,1699164000,2),(166,1710054000,1),(166,1730613600,2),(166,1741503600,1),(166,1762063200,2),(166,1772953200,1),(166,1793512800,2),(166,1805007600,1),(166,1825567200,2),(166,1836457200,1),(166,1857016800,2),(166,1867906800,1),(166,1888466400,2),(166,1899356400,1),(166,1919916000,2),(166,1930806000,1),(166,1951365600,2),(166,1962860400,1),(166,1983420000,2),(166,1994310000,1),(166,2014869600,2),(166,2025759600,1),(166,2046319200,2),(166,2057209200,1),(166,2077768800,2),(166,2088658800,1),(166,2109218400,2),(166,2120108400,1),(166,2140668000,2),(167,-2147483648,0),(167,-1825098836,1),(168,-2147483648,0),(168,-1825095030,2),(168,-179341200,1),(168,-163620000,2),(168,-147891600,1),(168,-131565600,2),(168,-116442000,1),(168,-100116000,2),(168,-84387600,1),(168,-68666400,2),(168,-52938000,1),(168,-37216800,2),(168,-21488400,1),(168,-5767200,2),(168,9961200,1),(168,25682400,2),(168,41410800,1),(168,57736800,2),(168,73465200,1),(168,89186400,2),(168,104914800,1),(168,120636000,2),(168,136364400,1),(168,152085600,2),(168,167814000,1),(168,183535200,2),(168,199263600,1),(168,215589600,2),(168,230713200,1),(168,247039200,2),(168,262767600,1),(168,278488800,2),(168,294217200,1),(168,309938400,2),(168,325666800,1),(168,341388000,2),(168,357116400,1),(168,372837600,2),(168,388566000,1),(168,404892000,2),(168,420015600,1),(168,436341600,2),(168,452070000,1),(168,467791200,2),(168,483519600,1),(168,499240800,2),(168,514969200,1),(168,530690400,2),(168,544604400,1),(168,562140000,2),(168,576054000,1),(168,594194400,2),(168,607503600,1),(168,625644000,2),(168,638953200,1),(168,657093600,2),(168,671007600,1),(168,688543200,2),(168,702457200,1),(168,719992800,2),(168,733906800,1),(168,752047200,2),(168,765356400,1),(168,783496800,2),(168,796806000,1),(168,814946400,2),(168,828860400,1),(168,846396000,2),(168,860310000,1),(168,877845600,2),(168,891759600,1),(168,909295200,2),(168,923209200,1),(168,941349600,2),(168,954658800,1),(168,972799200,2),(168,986108400,1),(168,1004248800,2),(168,1018162800,1),(168,1035698400,2),(168,1049612400,1),(168,1067148000,2),(168,1081062000,1),(168,1099202400,2),(168,1112511600,1),(168,1130652000,2),(168,1143961200,1),(168,1162101600,2),(168,1173596400,1),(168,1194156000,2),(168,1205046000,1),(168,1225605600,2),(168,1236495600,1),(168,1257055200,2),(168,1268550000,1),(168,1289109600,2),(168,1299999600,1),(168,1320559200,2),(168,1331449200,1),(168,1352008800,2),(168,1362898800,1),(168,1383458400,2),(168,1394348400,1),(168,1414908000,2),(168,1425798000,1),(168,1446357600,2),(168,1457852400,1),(168,1478412000,2),(168,1489302000,1),(168,1509861600,2),(168,1520751600,1),(168,1541311200,2),(168,1552201200,1),(168,1572760800,2),(168,1583650800,1),(168,1604210400,2),(168,1615705200,1),(168,1636264800,2),(168,1647154800,1),(168,1667714400,2),(168,1678604400,1),(168,1699164000,2),(168,1710054000,1),(168,1730613600,2),(168,1741503600,1),(168,1762063200,2),(168,1772953200,1),(168,1793512800,2),(168,1805007600,1),(168,1825567200,2),(168,1836457200,1),(168,1857016800,2),(168,1867906800,1),(168,1888466400,2),(168,1899356400,1),(168,1919916000,2),(168,1930806000,1),(168,1951365600,2),(168,1962860400,1),(168,1983420000,2),(168,1994310000,1),(168,2014869600,2),(168,2025759600,1),(168,2046319200,2),(168,2057209200,1),(168,2077768800,2),(168,2088658800,1),(168,2109218400,2),(168,2120108400,1),(168,2140668000,2),(169,-2147483648,2),(169,-1633280400,1),(169,-1615140000,2),(169,-1601830800,1),(169,-1583690400,2),(169,-1570381200,1),(169,-1551636000,2),(169,-1536512400,1),(169,-1523210400,2),(169,-1504458000,1),(169,-1491760800,2),(169,-1473008400,1),(169,-1459706400,2),(169,-1441558800,1),(169,-1428256800,2),(169,-1410109200,1),(169,-1396807200,2),(169,-1378659600,1),(169,-1365357600,2),(169,-1347210000,1),(169,-1333908000,2),(169,-1315155600,1),(169,-1301853600,2),(169,-1283706000,1),(169,-1270404000,2),(169,-1252256400,1),(169,-1238954400,2),(169,-1220806800,1),(169,-1207504800,2),(169,-1189357200,1),(169,-1176055200,2),(169,-1157302800,1),(169,-1144605600,2),(169,-1125853200,1),(169,-1112551200,2),(169,-1094403600,1),(169,-1081101600,2),(169,-1062954000,1),(169,-1049652000,2),(169,-1031504400,1),(169,-1018202400,2),(169,-1000054800,1),(169,-986752800,2),(169,-968000400,1),(169,-955303200,2),(169,-936550800,1),(169,-923248800,2),(169,-905101200,1),(169,-891799200,2),(169,-880218000,3),(169,-769395600,4),(169,-765396000,2),(169,-747248400,1),(169,-733946400,2),(169,-715798800,1),(169,-702496800,2),(169,-684349200,1),(169,-671047200,2),(169,-652899600,1),(169,-639597600,2),(169,-620845200,1),(169,-608148000,2),(169,-589395600,1),(169,-576093600,2),(169,-557946000,1),(169,-544644000,2),(169,-526496400,1),(169,-513194400,2),(169,-495046800,1),(169,-481744800,2),(169,-463597200,1),(169,-447271200,2),(169,-431542800,1),(169,-415821600,2),(169,-400093200,1),(169,-384372000,2),(169,-368643600,1),(169,-352922400,2),(169,-337194000,1),(169,-321472800,2),(169,-305744400,1),(169,-289418400,2),(169,-273690000,1),(169,-257968800,2),(169,-242240400,1),(169,-226519200,2),(169,-210790800,1),(169,-195069600,2),(169,-179341200,1),(169,-163620000,2),(169,-147891600,1),(169,-131565600,2),(169,-116442000,1),(169,-100116000,2),(169,-84387600,1),(169,-68666400,2),(169,-52938000,1),(169,-37216800,2),(169,-21488400,1),(169,-5767200,2),(169,9961200,1),(169,25682400,2),(169,41410800,1),(169,57736800,2),(169,73465200,1),(169,89186400,2),(169,104914800,1),(169,120636000,2),(169,126687600,1),(169,152085600,2),(169,162370800,1),(169,183535200,2),(169,199263600,1),(169,215589600,2),(169,230713200,1),(169,247039200,2),(169,262767600,1),(169,278488800,2),(169,294217200,1),(169,309938400,2),(169,325666800,1),(169,341388000,2),(169,357116400,1),(169,372837600,2),(169,388566000,1),(169,404892000,2),(169,420015600,1),(169,436341600,2),(169,452070000,1),(169,467791200,2),(169,483519600,1),(169,499240800,2),(169,514969200,1),(169,530690400,2),(169,544604400,1),(169,562140000,2),(169,576054000,1),(169,594194400,2),(169,607503600,1),(169,625644000,2),(169,638953200,1),(169,657093600,2),(169,671007600,1),(169,688543200,2),(169,702457200,1),(169,719992800,2),(169,733906800,1),(169,752047200,2),(169,765356400,1),(169,783496800,2),(169,796806000,1),(169,814946400,2),(169,828860400,1),(169,846396000,2),(169,860310000,1),(169,877845600,2),(169,891759600,1),(169,909295200,2),(169,923209200,1),(169,941349600,2),(169,954658800,1),(169,972799200,2),(169,986108400,1),(169,1004248800,2),(169,1018162800,1),(169,1035698400,2),(169,1049612400,1),(169,1067148000,2),(169,1081062000,1),(169,1099202400,2),(169,1112511600,1),(169,1130652000,2),(169,1143961200,1),(169,1162101600,2),(169,1173596400,1),(169,1194156000,2),(169,1205046000,1),(169,1225605600,2),(169,1236495600,1),(169,1257055200,2),(169,1268550000,1),(169,1289109600,2),(169,1299999600,1),(169,1320559200,2),(169,1331449200,1),(169,1352008800,2),(169,1362898800,1),(169,1383458400,2),(169,1394348400,1),(169,1414908000,2),(169,1425798000,1),(169,1446357600,2),(169,1457852400,1),(169,1478412000,2),(169,1489302000,1),(169,1509861600,2),(169,1520751600,1),(169,1541311200,2),(169,1552201200,1),(169,1572760800,2),(169,1583650800,1),(169,1604210400,2),(169,1615705200,1),(169,1636264800,2),(169,1647154800,1),(169,1667714400,2),(169,1678604400,1),(169,1699164000,2),(169,1710054000,1),(169,1730613600,2),(169,1741503600,1),(169,1762063200,2),(169,1772953200,1),(169,1793512800,2),(169,1805007600,1),(169,1825567200,2),(169,1836457200,1),(169,1857016800,2),(169,1867906800,1),(169,1888466400,2),(169,1899356400,1),(169,1919916000,2),(169,1930806000,1),(169,1951365600,2),(169,1962860400,1),(169,1983420000,2),(169,1994310000,1),(169,2014869600,2),(169,2025759600,1),(169,2046319200,2),(169,2057209200,1),(169,2077768800,2),(169,2088658800,1),(169,2109218400,2),(169,2120108400,1),(169,2140668000,2),(170,-2147483648,2),(170,-1632070800,1),(170,-1615140000,2),(170,-923252400,1),(170,-880218000,3),(170,-769395600,4),(170,-765396000,2),(170,136364400,1),(170,152085600,2),(170,167814000,1),(170,183535200,2),(170,199263600,1),(170,215589600,2),(170,230713200,1),(170,247039200,2),(170,262767600,1),(170,278488800,2),(170,294217200,1),(170,309938400,2),(170,325666800,1),(170,341388000,2),(170,357116400,1),(170,372837600,2),(170,388566000,1),(170,404892000,2),(170,420015600,1),(170,436341600,2),(170,452070000,1),(170,467791200,2),(170,483519600,1),(170,499240800,2),(170,514969200,1),(170,530690400,2),(170,544604400,1),(170,562140000,2),(170,576054000,1),(170,594194400,2),(170,607503600,1),(170,625644000,2),(170,638953200,1),(170,657093600,2),(170,671007600,1),(170,688543200,2),(170,702457200,1),(170,719992800,2),(170,733906800,1),(170,752047200,2),(170,765356400,1),(170,783496800,2),(170,796806000,1),(170,814946400,2),(170,828860400,1),(170,846396000,2),(170,860310000,1),(170,877845600,2),(170,891759600,1),(170,909295200,2),(170,923209200,1),(170,941349600,2),(170,954658800,1),(170,972799200,2),(170,986108400,1),(170,1004248800,2),(170,1018162800,1),(170,1035698400,2),(170,1049612400,1),(170,1067148000,2),(170,1081062000,1),(170,1099202400,2),(170,1112511600,1),(170,1130652000,2),(170,1143961200,1),(170,1162101600,2),(170,1173596400,1),(170,1194156000,2),(170,1205046000,1),(170,1225605600,2),(170,1236495600,1),(170,1257055200,2),(170,1268550000,1),(170,1289109600,2),(170,1299999600,1),(170,1320559200,2),(170,1331449200,1),(170,1352008800,2),(170,1362898800,1),(170,1383458400,2),(170,1394348400,1),(170,1414908000,2),(170,1425798000,1),(170,1446357600,2),(170,1457852400,1),(170,1478412000,2),(170,1489302000,1),(170,1509861600,2),(170,1520751600,1),(170,1541311200,2),(170,1552201200,1),(170,1572760800,2),(170,1583650800,1),(170,1604210400,2),(170,1615705200,1),(170,1636264800,2),(170,1647154800,1),(170,1667714400,2),(170,1678604400,1),(170,1699164000,2),(170,1710054000,1),(170,1730613600,2),(170,1741503600,1),(170,1762063200,2),(170,1772953200,1),(170,1793512800,2),(170,1805007600,1),(170,1825567200,2),(170,1836457200,1),(170,1857016800,2),(170,1867906800,1),(170,1888466400,2),(170,1899356400,1),(170,1919916000,2),(170,1930806000,1),(170,1951365600,2),(170,1962860400,1),(170,1983420000,2),(170,1994310000,1),(170,2014869600,2),(170,2025759600,1),(170,2046319200,2),(170,2057209200,1),(170,2077768800,2),(170,2088658800,1),(170,2109218400,2),(170,2120108400,1),(170,2140668000,2),(171,-2147483648,1),(171,-880196400,2),(171,-769395600,3),(171,-765374400,1),(171,-86878800,4),(171,-21466800,5),(171,-5745600,4),(171,9982800,5),(171,25704000,4),(171,41432400,5),(171,57758400,4),(171,73486800,5),(171,89208000,4),(171,104936400,5),(171,120657600,4),(171,126709200,5),(171,152107200,4),(171,162392400,5),(171,183556800,4),(171,199285200,5),(171,215611200,4),(171,230734800,5),(171,247060800,4),(171,262789200,5),(171,278510400,4),(171,294238800,5),(171,309960000,4),(171,325688400,5),(171,341409600,4),(171,357138000,5),(171,372859200,4),(171,388587600,5),(171,404913600,4),(171,420037200,5),(171,436363200,6),(171,439030800,8),(171,452084400,7),(171,467805600,8),(171,483534000,7),(171,499255200,8),(171,514983600,7),(171,530704800,8),(171,544618800,7),(171,562154400,8),(171,576068400,7),(171,594208800,8),(171,607518000,7),(171,625658400,8),(171,638967600,7),(171,657108000,8),(171,671022000,7),(171,688557600,8),(171,702471600,7),(171,720007200,8),(171,733921200,7),(171,752061600,8),(171,765370800,7),(171,783511200,8),(171,796820400,7),(171,814960800,8),(171,828874800,7),(171,846410400,8),(171,860324400,7),(171,877860000,8),(171,891774000,7),(171,909309600,8),(171,923223600,7),(171,941364000,8),(171,954673200,7),(171,972813600,8),(171,986122800,7),(171,1004263200,8),(171,1018177200,7),(171,1035712800,8),(171,1049626800,7),(171,1067162400,8),(171,1081076400,7),(171,1099216800,8),(171,1112526000,7),(171,1130666400,8),(171,1143975600,7),(171,1162116000,8),(171,1173610800,7),(171,1194170400,8),(171,1205060400,7),(171,1225620000,8),(171,1236510000,7),(171,1257069600,8),(171,1268564400,7),(171,1289124000,8),(171,1300014000,7),(171,1320573600,8),(171,1331463600,7),(171,1352023200,8),(171,1362913200,7),(171,1383472800,8),(171,1394362800,7),(171,1414922400,8),(171,1425812400,7),(171,1446372000,8),(171,1457866800,7),(171,1478426400,8),(171,1489316400,7),(171,1509876000,8),(171,1520766000,7),(171,1541325600,8),(171,1552215600,7),(171,1572775200,8),(171,1583665200,7),(171,1604224800,8),(171,1615719600,7),(171,1636279200,8),(171,1647169200,7),(171,1667728800,8),(171,1678618800,7),(171,1699178400,8),(171,1710068400,7),(171,1730628000,8),(171,1741518000,7),(171,1762077600,8),(171,1772967600,7),(171,1793527200,8),(171,1805022000,7),(171,1825581600,8),(171,1836471600,7),(171,1857031200,8),(171,1867921200,7),(171,1888480800,8),(171,1899370800,7),(171,1919930400,8),(171,1930820400,7),(171,1951380000,8),(171,1962874800,7),(171,1983434400,8),(171,1994324400,7),(171,2014884000,8),(171,2025774000,7),(171,2046333600,8),(171,2057223600,7),(171,2077783200,8),(171,2088673200,7),(171,2109232800,8),(171,2120122800,7),(171,2140682400,8),(172,-2147483648,0),(172,-1767217820,2),(172,-1206961200,1),(172,-1191366000,2),(172,-1175378400,1),(172,-1159830000,2),(172,-633823200,1),(172,-622072800,2),(172,-602287200,1),(172,-591836400,2),(172,-570751200,1),(172,-560214000,2),(172,-539128800,1),(172,-531356400,2),(172,-191368800,1),(172,-184201200,2),(172,-155167200,1),(172,-150073200,2),(172,-128901600,1),(172,-121129200,2),(172,-99957600,1),(172,-89593200,2),(172,-68421600,1),(172,-57970800,2),(172,499744800,1),(172,511232400,2),(172,530589600,1),(172,540262800,2),(172,562125600,1),(172,571194000,2),(172,592970400,1),(172,602038800,2),(172,624420000,1),(172,634698000,2),(172,938916000,1),(172,951613200,2),(172,970970400,1),(172,971571600,2),(172,1003024800,1),(172,1013907600,2),(172,2147483647,2),(173,-2147483648,2),(173,-1633273200,1),(173,-1615132800,2),(173,-1601823600,1),(173,-1583683200,2),(173,-880210800,3),(173,-769395600,4),(173,-765388800,2),(173,-84380400,1),(173,-68659200,2),(173,-52930800,1),(173,-37209600,2),(173,-21481200,1),(173,-5760000,2),(173,9968400,1),(173,25689600,2),(173,41418000,1),(173,57744000,2),(173,73472400,1),(173,89193600,2),(173,104922000,1),(173,120643200,2),(173,126694800,1),(173,152092800,2),(173,162378000,1),(173,183542400,2),(173,199270800,1),(173,215596800,2),(173,230720400,1),(173,247046400,2),(173,262774800,1),(173,278496000,2),(173,294224400,1),(173,309945600,2),(173,325674000,1),(173,341395200,2),(173,357123600,1),(173,372844800,2),(173,388573200,1),(173,404899200,2),(173,420022800,1),(173,436348800,2),(173,452077200,1),(173,467798400,2),(173,483526800,1),(173,499248000,2),(173,514976400,1),(173,530697600,2),(173,544611600,1),(173,562147200,2),(173,576061200,1),(173,594201600,2),(173,607510800,1),(173,625651200,2),(173,638960400,1),(173,657100800,2),(173,671014800,1),(173,688550400,2),(173,702464400,1),(173,720000000,2),(173,733914000,1),(173,752054400,2),(173,765363600,1),(173,783504000,2),(173,796813200,1),(173,814953600,2),(173,828867600,1),(173,846403200,2),(173,860317200,1),(173,877852800,2),(173,891766800,1),(173,909302400,2),(173,923216400,1),(173,941356800,2),(173,954666000,1),(173,972806400,2),(173,986115600,1),(173,1004256000,2),(173,1018170000,1),(173,1035705600,2),(173,1049619600,1),(173,1067155200,2),(173,1081069200,1),(173,1099209600,2),(173,1112518800,1),(173,1130659200,2),(173,1143968400,1),(173,1162108800,2),(173,1173603600,1),(173,1194163200,2),(173,1205053200,1),(173,1225612800,2),(173,1236502800,1),(173,1257062400,2),(173,1268557200,1),(173,1289116800,6),(173,1300003200,5),(173,1320562800,6),(173,1331452800,5),(173,1352012400,6),(173,1362902400,5),(173,1383462000,6),(173,1394352000,5),(173,1414911600,6),(173,1425801600,5),(173,1446361200,6),(173,1457856000,5),(173,1478415600,6),(173,1489305600,5),(173,1509865200,6),(173,1520755200,5),(173,1541314800,6),(173,1552204800,5),(173,1572764400,6),(173,1583654400,5),(173,1604214000,6),(173,1615708800,5),(173,1636268400,6),(173,1647158400,5),(173,1667718000,6),(173,1678608000,5),(173,1699167600,6),(173,1710057600,5),(173,1730617200,6),(173,1741507200,5),(173,1762066800,6),(173,1772956800,5),(173,1793516400,6),(173,1805011200,5),(173,1825570800,6),(173,1836460800,5),(173,1857020400,6),(173,1867910400,5),(173,1888470000,6),(173,1899360000,5),(173,1919919600,6),(173,1930809600,5),(173,1951369200,6),(173,1962864000,5),(173,1983423600,6),(173,1994313600,5),(173,2014873200,6),(173,2025763200,5),(173,2046322800,6),(173,2057212800,5),(173,2077772400,6),(173,2088662400,5),(173,2109222000,6),(173,2120112000,5),(173,2140671600,6),(174,-2147483648,2),(174,-1633273200,1),(174,-1615132800,2),(174,-1601823600,1),(174,-1583683200,2),(174,-880210800,3),(174,-769395600,4),(174,-765388800,2),(174,-84380400,1),(174,-68659200,2),(174,-52930800,1),(174,-37209600,2),(174,-21481200,1),(174,-5760000,2),(174,9968400,1),(174,25689600,2),(174,41418000,1),(174,57744000,2),(174,73472400,1),(174,89193600,2),(174,104922000,1),(174,120643200,2),(174,126694800,1),(174,152092800,2),(174,162378000,1),(174,183542400,2),(174,199270800,1),(174,215596800,2),(174,230720400,1),(174,247046400,2),(174,262774800,1),(174,278496000,2),(174,294224400,1),(174,309945600,2),(174,325674000,1),(174,341395200,2),(174,357123600,1),(174,372844800,2),(174,388573200,1),(174,404899200,2),(174,420022800,1),(174,436348800,2),(174,452077200,1),(174,467798400,2),(174,483526800,1),(174,499248000,2),(174,514976400,1),(174,530697600,2),(174,544611600,1),(174,562147200,2),(174,576061200,1),(174,594201600,2),(174,607510800,1),(174,625651200,2),(174,638960400,1),(174,657100800,2),(174,671014800,1),(174,688550400,2),(174,702464400,1),(174,720000000,6),(174,733910400,5),(174,752050800,6),(174,765360000,5),(174,783500400,6),(174,796809600,5),(174,814950000,6),(174,828864000,5),(174,846399600,6),(174,860313600,5),(174,877849200,6),(174,891763200,5),(174,909298800,6),(174,923212800,5),(174,941353200,6),(174,954662400,5),(174,972802800,6),(174,986112000,5),(174,1004252400,6),(174,1018166400,5),(174,1035702000,6),(174,1049616000,5),(174,1067151600,6),(174,1081065600,5),(174,1099206000,6),(174,1112515200,5),(174,1130655600,6),(174,1143964800,5),(174,1162105200,6),(174,1173600000,5),(174,1194159600,6),(174,1205049600,5),(174,1225609200,6),(174,1236499200,5),(174,1257058800,6),(174,1268553600,5),(174,1289113200,6),(174,1300003200,5),(174,1320562800,6),(174,1331452800,5),(174,1352012400,6),(174,1362902400,5),(174,1383462000,6),(174,1394352000,5),(174,1414911600,6),(174,1425801600,5),(174,1446361200,6),(174,1457856000,5),(174,1478415600,6),(174,1489305600,5),(174,1509865200,6),(174,1520755200,5),(174,1541314800,6),(174,1552204800,5),(174,1572764400,6),(174,1583654400,5),(174,1604214000,6),(174,1615708800,5),(174,1636268400,6),(174,1647158400,5),(174,1667718000,6),(174,1678608000,5),(174,1699167600,6),(174,1710057600,5),(174,1730617200,6),(174,1741507200,5),(174,1762066800,6),(174,1772956800,5),(174,1793516400,6),(174,1805011200,5),(174,1825570800,6),(174,1836460800,5),(174,1857020400,6),(174,1867910400,5),(174,1888470000,6),(174,1899360000,5),(174,1919919600,6),(174,1930809600,5),(174,1951369200,6),(174,1962864000,5),(174,1983423600,6),(174,1994313600,5),(174,2014873200,6),(174,2025763200,5),(174,2046322800,6),(174,2057212800,5),(174,2077772400,6),(174,2088662400,5),(174,2109222000,6),(174,2120112000,5),(174,2140671600,6),(175,-2147483648,2),(175,-1633273200,1),(175,-1615132800,2),(175,-1601823600,1),(175,-1583683200,2),(175,-880210800,3),(175,-769395600,4),(175,-765388800,2),(175,-84380400,1),(175,-68659200,2),(175,-52930800,1),(175,-37209600,2),(175,-21481200,1),(175,-5760000,2),(175,9968400,1),(175,25689600,2),(175,41418000,1),(175,57744000,2),(175,73472400,1),(175,89193600,2),(175,104922000,1),(175,120643200,2),(175,126694800,1),(175,152092800,2),(175,162378000,1),(175,183542400,2),(175,199270800,1),(175,215596800,2),(175,230720400,1),(175,247046400,2),(175,262774800,1),(175,278496000,2),(175,294224400,1),(175,309945600,2),(175,325674000,1),(175,341395200,2),(175,357123600,1),(175,372844800,2),(175,388573200,1),(175,404899200,2),(175,420022800,1),(175,436348800,2),(175,452077200,1),(175,467798400,2),(175,483526800,1),(175,499248000,2),(175,514976400,1),(175,530697600,2),(175,544611600,1),(175,562147200,2),(175,576061200,1),(175,594201600,2),(175,607510800,1),(175,625651200,2),(175,638960400,1),(175,657100800,2),(175,671014800,1),(175,688550400,2),(175,702464400,1),(175,720000000,2),(175,733914000,1),(175,752054400,2),(175,765363600,1),(175,783504000,2),(175,796813200,1),(175,814953600,2),(175,828867600,1),(175,846403200,2),(175,860317200,1),(175,877852800,2),(175,891766800,1),(175,909302400,2),(175,923216400,1),(175,941356800,2),(175,954666000,1),(175,972806400,2),(175,986115600,1),(175,1004256000,2),(175,1018170000,1),(175,1035705600,2),(175,1049619600,1),(175,1067155200,6),(175,1081065600,5),(175,1099206000,6),(175,1112515200,5),(175,1130655600,6),(175,1143964800,5),(175,1162105200,6),(175,1173600000,5),(175,1194159600,6),(175,1205049600,5),(175,1225609200,6),(175,1236499200,5),(175,1257058800,6),(175,1268553600,5),(175,1289113200,6),(175,1300003200,5),(175,1320562800,6),(175,1331452800,5),(175,1352012400,6),(175,1362902400,5),(175,1383462000,6),(175,1394352000,5),(175,1414911600,6),(175,1425801600,5),(175,1446361200,6),(175,1457856000,5),(175,1478415600,6),(175,1489305600,5),(175,1509865200,6),(175,1520755200,5),(175,1541314800,6),(175,1552204800,5),(175,1572764400,6),(175,1583654400,5),(175,1604214000,6),(175,1615708800,5),(175,1636268400,6),(175,1647158400,5),(175,1667718000,6),(175,1678608000,5),(175,1699167600,6),(175,1710057600,5),(175,1730617200,6),(175,1741507200,5),(175,1762066800,6),(175,1772956800,5),(175,1793516400,6),(175,1805011200,5),(175,1825570800,6),(175,1836460800,5),(175,1857020400,6),(175,1867910400,5),(175,1888470000,6),(175,1899360000,5),(175,1919919600,6),(175,1930809600,5),(175,1951369200,6),(175,1962864000,5),(175,1983423600,6),(175,1994313600,5),(175,2014873200,6),(175,2025763200,5),(175,2046322800,6),(175,2057212800,5),(175,2077772400,6),(175,2088662400,5),(175,2109222000,6),(175,2120112000,5),(175,2140671600,6),(176,-2147483648,0),(176,-1514739600,1),(176,-1343066400,2),(176,-1234807200,1),(176,-1220292000,2),(176,-1207159200,1),(176,-1191344400,2),(176,828864000,3),(176,846399600,2),(176,860313600,3),(176,877849200,2),(176,891766800,4),(176,909302400,1),(176,923216400,4),(176,941356800,1),(176,954666000,4),(176,972806400,1),(176,989139600,4),(176,1001836800,1),(176,1018170000,4),(176,1035705600,1),(176,1049619600,4),(176,1067155200,1),(176,1081069200,4),(176,1099209600,1),(176,1112518800,4),(176,1130659200,1),(176,1143968400,4),(176,1162108800,1),(176,1175418000,4),(176,1193558400,1),(176,1207472400,4),(176,1225008000,1),(176,1238922000,4),(176,1256457600,1),(176,1268557200,4),(176,1289116800,1),(176,1300006800,4),(176,1320566400,1),(176,1331456400,4),(176,1352016000,1),(176,1362906000,4),(176,1383465600,1),(176,1394355600,4),(176,1414915200,1),(176,1425805200,4),(176,1446364800,1),(176,1457859600,4),(176,1478419200,1),(176,1489309200,4),(176,1509868800,1),(176,1520758800,4),(176,1541318400,1),(176,1552208400,4),(176,1572768000,1),(176,1583658000,4),(176,1604217600,1),(176,1615712400,4),(176,1636272000,1),(176,1647162000,4),(176,1667721600,1),(176,1678611600,4),(176,1699171200,1),(176,1710061200,4),(176,1730620800,1),(176,1741510800,4),(176,1762070400,1),(176,1772960400,4),(176,1793520000,1),(176,1805014800,4),(176,1825574400,1),(176,1836464400,4),(176,1857024000,1),(176,1867914000,4),(176,1888473600,1),(176,1899363600,4),(176,1919923200,1),(176,1930813200,4),(176,1951372800,1),(176,1962867600,4),(176,1983427200,1),(176,1994317200,4),(176,2014876800,1),(176,2025766800,4),(176,2046326400,1),(176,2057216400,4),(176,2077776000,1),(176,2088666000,4),(176,2109225600,1),(176,2120115600,4),(176,2140675200,1),(177,-2147483648,1),(177,-1946918424,2),(178,-2147483648,0),(178,-1546300800,3),(178,-880221600,1),(178,-769395600,2),(178,-765399600,3),(178,-147902400,4),(178,-131572800,3),(178,325663200,5),(178,341384400,3),(178,357112800,5),(178,372834000,3),(178,388562400,5),(178,404888400,3),(178,420012000,5),(178,436338000,3),(178,452066400,5),(178,467787600,3),(178,483516000,5),(178,499237200,3),(178,514965600,5),(178,530686800,3),(178,544600800,5),(178,562136400,3),(178,576050400,5),(178,594190800,3),(178,607500000,5),(178,625640400,3),(178,638949600,5),(178,657090000,3),(178,671004000,5),(178,688539600,3),(178,702453600,5),(178,719989200,3),(178,733903200,5),(178,752043600,3),(178,765352800,5),(178,783493200,3),(178,796802400,6),(178,814946400,7),(178,828860400,6),(178,846396000,7),(178,860310000,6),(178,877845600,7),(178,891759600,6),(178,909295200,7),(178,923209200,6),(178,941349600,8),(178,954662400,9),(178,972802800,7),(178,986108400,6),(178,1004248800,7),(178,1018162800,6),(178,1035698400,7),(178,1049612400,6),(178,1067148000,7),(178,1081062000,6),(178,1099202400,7),(178,1112511600,6),(178,1130652000,7),(178,1143961200,6),(178,1162101600,7),(178,1173596400,6),(178,1194156000,7),(178,1205046000,6),(178,1225605600,7),(178,1236495600,6),(178,1257055200,7),(178,1268550000,6),(178,1289109600,7),(178,1299999600,6),(178,1320559200,7),(178,1331449200,6),(178,1352008800,7),(178,1362898800,6),(178,1383458400,7),(178,1394348400,6),(178,1414908000,7),(178,1425798000,6),(178,1446357600,7),(178,1457852400,6),(178,1478412000,7),(178,1489302000,6),(178,1509861600,7),(178,1520751600,6),(178,1541311200,7),(178,1552201200,6),(178,1572760800,7),(178,1583650800,6),(178,1604210400,7),(178,1615705200,6),(178,1636264800,7),(178,1647154800,6),(178,1667714400,7),(178,1678604400,6),(178,1699164000,7),(178,1710054000,6),(178,1730613600,7),(178,1741503600,6),(178,1762063200,7),(178,1772953200,6),(178,1793512800,7),(178,1805007600,6),(178,1825567200,7),(178,1836457200,6),(178,1857016800,7),(178,1867906800,6),(178,1888466400,7),(178,1899356400,6),(178,1919916000,7),(178,1930806000,6),(178,1951365600,7),(178,1962860400,6),(178,1983420000,7),(178,1994310000,6),(178,2014869600,7),(178,2025759600,6),(178,2046319200,7),(178,2057209200,6),(178,2077768800,7),(178,2088658800,6),(178,2109218400,7),(178,2120108400,6),(178,2140668000,7),(179,-2147483648,0),(179,-1861906760,1),(179,-1104524348,2),(179,-765317964,3),(179,465449400,4),(179,2147483647,4),(180,-2147483648,2),(180,-1633273200,1),(180,-1615132800,2),(180,-1601823600,1),(180,-1583683200,2),(180,-880210800,3),(180,-820519140,2),(180,-812653140,3),(180,-796845540,2),(180,-84380400,1),(180,-68659200,2),(181,-2147483648,1),(181,-1670483460,3),(181,421218000,2),(181,436334400,3),(181,452062800,2),(181,467784000,3),(181,483512400,2),(181,499233600,3),(181,514962000,2),(181,530683200,3),(181,546411600,2),(181,562132800,3),(181,576050400,4),(181,594194400,5),(181,607500000,4),(181,625644000,5),(181,638949600,4),(181,657093600,5),(181,671004000,4),(181,688543200,5),(181,702453600,4),(181,719992800,5),(181,733903200,4),(181,752047200,5),(181,765352800,4),(181,783496800,5),(181,796802400,4),(181,814946400,5),(181,828856800,4),(181,846396000,5),(181,860306400,4),(181,877845600,5),(181,1112504400,2),(181,1130644800,3),(181,1143954000,2),(181,1162094400,3),(181,1331449200,2),(181,1352008800,3),(181,1362898800,2),(181,1383458400,3),(181,1394348400,2),(181,1414908000,3),(181,1425798000,2),(181,1446357600,3),(181,1489302000,2),(181,1509861600,3),(181,1520751600,2),(181,1541311200,3),(181,1552201200,2),(181,1572760800,3),(181,1583650800,2),(181,1604210400,3),(181,1615705200,2),(181,1636264800,3),(181,1647154800,2),(181,1667714400,3),(181,1678604400,2),(181,1699164000,3),(181,1710054000,2),(181,1730613600,3),(181,1741503600,2),(181,1762063200,3),(181,1772953200,2),(181,1793512800,3),(181,1805007600,2),(181,1825567200,3),(181,1836457200,2),(181,1857016800,3),(181,1867906800,2),(181,1888466400,3),(181,1899356400,2),(181,1919916000,3),(181,1930806000,2),(181,1951365600,3),(181,1962860400,2),(181,1983420000,3),(181,1994310000,2),(181,2014869600,3),(181,2025759600,2),(181,2046319200,3),(181,2057209200,2),(181,2077768800,3),(181,2088658800,2),(181,2109218400,3),(181,2120108400,2),(181,2140668000,3),(182,-2147483648,0),(182,-1825098836,1),(183,-2147483648,0),(183,-1767209328,2),(183,-1206950400,1),(183,-1191355200,2),(183,-1175367600,1),(183,-1159819200,2),(183,-633812400,1),(183,-622062000,2),(183,-602276400,1),(183,-591825600,2),(183,-570740400,1),(183,-560203200,2),(183,-539118000,1),(183,-531345600,2),(183,-191358000,1),(183,-184190400,2),(183,-155156400,1),(183,-150062400,2),(183,-128890800,1),(183,-121118400,2),(183,-99946800,1),(183,-89582400,2),(183,-68410800,1),(183,-57960000,2),(183,499755600,1),(183,511243200,2),(183,530600400,1),(183,540273600,2),(183,562136400,1),(183,571204800,2),(183,1214283600,3),(183,1384056000,2),(183,2147483647,2),(184,-2147483648,0),(184,-1767210264,2),(184,-1206954000,1),(184,-1191358800,2),(184,-1175371200,1),(184,-1159822800,2),(184,-633816000,1),(184,-622065600,2),(184,-602280000,1),(184,-591829200,2),(184,-570744000,1),(184,-560206800,2),(184,-539121600,1),(184,-531349200,2),(184,-191361600,1),(184,-184194000,2),(184,-155160000,1),(184,-150066000,2),(184,-128894400,1),(184,-121122000,2),(184,-99950400,1),(184,-89586000,2),(184,-68414400,1),(184,-57963600,2),(184,499752000,1),(184,511239600,2),(184,530596800,1),(184,540270000,2),(184,562132800,1),(184,571201200,2),(184,2147483647,2),(185,-2147483648,1),(185,-873057600,3),(185,-769395600,2),(185,-765399600,1),(186,-2147483648,1),(186,-1892661434,2),(186,-1688410800,1),(186,-1619205434,3),(186,-1593806400,1),(186,-1335986234,4),(186,-1317585600,2),(186,-1304362800,4),(186,-1286049600,2),(186,-1272826800,4),(186,-1254513600,2),(186,-1241290800,4),(186,-1222977600,2),(186,-1209754800,4),(186,-1191355200,2),(186,-1178132400,3),(186,-870552000,2),(186,-865278000,3),(186,-718056000,2),(186,-713649600,3),(186,-36619200,5),(186,-23922000,6),(186,-3355200,5),(186,7527600,6),(186,24465600,5),(186,37767600,6),(186,55915200,5),(186,69217200,6),(186,87969600,5),(186,100666800,6),(186,118209600,5),(186,132116400,6),(186,150868800,5),(186,163566000,6),(186,182318400,5),(186,195620400,6),(186,213768000,5),(186,227070000,6),(186,245217600,5),(186,258519600,6),(186,277272000,5),(186,289969200,6),(186,308721600,5),(186,321418800,6),(186,340171200,5),(186,353473200,6),(186,371620800,5),(186,384922800,6),(186,403070400,5),(186,416372400,6),(186,434520000,5),(186,447822000,6),(186,466574400,5),(186,479271600,6),(186,498024000,5),(186,510721200,6),(186,529473600,5),(186,545194800,6),(186,560923200,5),(186,574225200,6),(186,592372800,5),(186,605674800,6),(186,624427200,5),(186,637124400,6),(186,653457600,5),(186,668574000,6),(186,687326400,5),(186,700628400,6),(186,718776000,5),(186,732078000,6),(186,750225600,5),(186,763527600,6),(186,781675200,5),(186,794977200,6),(186,813729600,5),(186,826426800,6),(186,845179200,5),(186,859690800,6),(186,876628800,5),(186,889930800,6),(186,906868800,5),(186,923194800,6),(186,939528000,5),(186,952830000,6),(186,971582400,5),(186,984279600,6),(186,1003032000,5),(186,1015729200,6),(186,1034481600,5),(186,1047178800,6),(186,1065931200,5),(186,1079233200,6),(186,1097380800,5),(186,1110682800,6),(186,1128830400,5),(186,1142132400,6),(186,1160884800,5),(186,1173582000,6),(186,1192334400,5),(186,1206846000,6),(186,1223784000,5),(186,1237086000,6),(186,1255233600,5),(186,1270350000,6),(186,1286683200,5),(186,1304823600,6),(186,1313899200,5),(186,1335668400,6),(186,1346558400,5),(186,1367118000,6),(186,1378612800,5),(186,1398567600,6),(186,1410062400,5),(186,1463281200,6),(186,1471147200,5),(186,1480820400,7),(186,2147483647,7),(187,-2147483648,2),(187,-1632067200,1),(187,-1615136400,2),(187,-923248800,1),(187,-880214400,3),(187,-769395600,4),(187,-765392400,2),(187,136368000,1),(187,152089200,2),(187,167817600,1),(187,183538800,2),(187,199267200,1),(187,215593200,2),(187,230716800,1),(187,247042800,2),(187,262771200,1),(187,278492400,2),(187,294220800,1),(187,309942000,2),(187,325670400,1),(187,341391600,2),(187,357120000,1),(187,372841200,2),(187,388569600,1),(187,404895600,2),(187,420019200,1),(187,436345200,2),(187,452073600,1),(187,467794800,2),(187,483523200,1),(187,499244400,2),(187,514972800,1),(187,530694000,2),(187,544608000,1),(187,562143600,2),(187,576057600,1),(187,594198000,2),(187,607507200,1),(187,625647600,2),(187,638956800,1),(187,657097200,2),(187,671011200,1),(187,688546800,2),(187,702460800,1),(187,719996400,2),(187,733910400,1),(187,752050800,2),(187,765360000,1),(187,783500400,2),(187,796809600,1),(187,814950000,2),(187,828864000,1),(187,846399600,2),(187,860313600,1),(187,877849200,2),(187,891763200,1),(187,909298800,2),(187,923212800,1),(187,941353200,2),(187,954662400,1),(187,972802800,2),(187,986112000,1),(187,1004252400,2),(187,1018166400,1),(187,1035702000,2),(187,1049616000,1),(187,1067151600,2),(187,1081065600,1),(187,1099206000,2),(187,1112515200,1),(187,1130655600,2),(187,1143964800,1),(187,1162105200,2),(187,1173600000,1),(187,1194159600,2),(187,1205049600,1),(187,1225609200,2),(187,1236499200,1),(187,1257058800,2),(187,1268553600,1),(187,1289113200,2),(187,1300003200,1),(187,1320562800,2),(187,1331452800,1),(187,1352012400,2),(187,1362902400,1),(187,1383462000,2),(187,1394352000,1),(187,1414911600,2),(187,1425801600,1),(187,1446361200,2),(187,1457856000,1),(187,1478415600,2),(187,1489305600,1),(187,1509865200,2),(187,1520755200,1),(187,1541314800,2),(187,1552204800,1),(187,1572764400,2),(187,1583654400,1),(187,1604214000,2),(187,1615708800,1),(187,1636268400,2),(187,1647158400,1),(187,1667718000,2),(187,1678608000,1),(187,1699167600,2),(187,1710057600,1),(187,1730617200,2),(187,1741507200,1),(187,1762066800,2),(187,1772956800,1),(187,1793516400,2),(187,1805011200,1),(187,1825570800,2),(187,1836460800,1),(187,1857020400,2),(187,1867910400,1),(187,1888470000,2),(187,1899360000,1),(187,1919919600,2),(187,1930809600,1),(187,1951369200,2),(187,1962864000,1),(187,1983423600,2),(187,1994313600,1),(187,2014873200,2),(187,2025763200,1),(187,2046322800,2),(187,2057212800,1),(187,2077772400,2),(187,2088662400,1),(187,2109222000,2),(187,2120112000,1),(187,2140671600,2),(188,-2147483648,0),(188,-410227200,2),(188,-147895200,1),(188,-131565600,2),(188,325670400,3),(188,341391600,2),(188,357120000,3),(188,372841200,2),(188,388569600,3),(188,404895600,2),(188,420019200,3),(188,436345200,2),(188,452073600,3),(188,467794800,2),(188,483523200,3),(188,499244400,2),(188,514972800,3),(188,530694000,2),(188,544608000,3),(188,562143600,2),(188,576057600,3),(188,594198000,2),(188,607507200,3),(188,625647600,2),(188,638956800,3),(188,657097200,2),(188,671011200,3),(188,688546800,2),(188,702460800,3),(188,719996400,2),(188,733910400,3),(188,752050800,2),(188,765360000,3),(188,783500400,2),(188,796809600,3),(188,814950000,2),(188,828864000,3),(188,846399600,2),(188,860313600,3),(188,877849200,2),(188,891763200,3),(188,909298800,2),(188,923212800,3),(188,941353200,2),(188,954662400,3),(188,972802800,4),(188,986112000,3),(188,1004252400,2),(188,1018166400,3),(188,1035702000,2),(188,1049616000,3),(188,1067151600,2),(188,1081065600,3),(188,1099206000,2),(188,1112515200,3),(188,1130655600,2),(188,1143964800,3),(188,1162105200,2),(188,1173600000,3),(188,1194159600,2),(188,1205049600,3),(188,1225609200,2),(188,1236499200,3),(188,1257058800,2),(188,1268553600,3),(188,1289113200,2),(188,1300003200,3),(188,1320562800,2),(188,1331452800,3),(188,1352012400,2),(188,1362902400,3),(188,1383462000,2),(188,1394352000,3),(188,1414911600,2),(188,1425801600,3),(188,1446361200,2),(188,1457856000,3),(188,1478415600,2),(188,1489305600,3),(188,1509865200,2),(188,1520755200,3),(188,1541314800,2),(188,1552204800,3),(188,1572764400,2),(188,1583654400,3),(188,1604214000,2),(188,1615708800,3),(188,1636268400,2),(188,1647158400,3),(188,1667718000,2),(188,1678608000,3),(188,1699167600,2),(188,1710057600,3),(188,1730617200,2),(188,1741507200,3),(188,1762066800,2),(188,1772956800,3),(188,1793516400,2),(188,1805011200,3),(188,1825570800,2),(188,1836460800,3),(188,1857020400,2),(188,1867910400,3),(188,1888470000,2),(188,1899360000,3),(188,1919919600,2),(188,1930809600,3),(188,1951369200,2),(188,1962864000,3),(188,1983423600,2),(188,1994313600,3),(188,2014873200,2),(188,2025763200,3),(188,2046322800,2),(188,2057212800,3),(188,2077772400,2),(188,2088662400,3),(188,2109222000,2),(188,2120112000,3),(188,2140671600,2),(189,-2147483648,0),(189,-1767217224,2),(189,-1206957600,1),(189,-1191362400,2),(189,-1175374800,1),(189,-1159826400,2),(189,-633819600,1),(189,-622069200,2),(189,-602283600,1),(189,-591832800,2),(189,-570747600,1),(189,-560210400,2),(189,-539125200,1),(189,-531352800,2),(189,-191365200,1),(189,-184197600,2),(189,-155163600,1),(189,-150069600,2),(189,-128898000,1),(189,-121125600,2),(189,-99954000,1),(189,-89589600,2),(189,-68418000,1),(189,-57967200,2),(189,499748400,1),(189,511236000,2),(189,530593200,1),(189,540266400,2),(189,562129200,1),(189,571197600,2),(189,592974000,1),(189,602042400,2),(189,624423600,1),(189,634701600,2),(189,938919600,1),(189,951616800,2),(189,970974000,1),(189,971575200,2),(189,1003028400,1),(189,1013911200,2),(189,2147483647,2),(190,-2147483648,0),(190,-2030202084,2),(190,-1632063600,1),(190,-1615132800,2),(190,-1251651600,1),(190,-1238349600,2),(190,-1220202000,1),(190,-1206900000,2),(190,-1188752400,1),(190,-1175450400,2),(190,-1156698000,1),(190,-1144000800,2),(190,-1125248400,1),(190,-1111946400,2),(190,-1032714000,1),(190,-1016992800,2),(190,-1001264400,1),(190,-986148000,2),(190,-969814800,1),(190,-954093600,2),(190,-937760400,1),(190,-922039200,2),(190,-906310800,1),(190,-890589600,2),(190,-880210800,3),(190,-769395600,4),(190,-765388800,2),(190,-748450800,1),(190,-732729600,2),(190,-715791600,1),(190,-702489600,2),(190,-684342000,1),(190,-671040000,2),(190,-652892400,1),(190,-639590400,2),(190,-620838000,1),(190,-608140800,2),(190,-589388400,1),(190,-576086400,2),(190,-557938800,1),(190,-544636800,2),(190,-526489200,1),(190,-513187200,2),(190,-495039600,1),(190,-481737600,2),(190,-463590000,1),(190,-450288000,2),(190,-431535600,1),(190,-418233600,2),(190,-400086000,1),(190,-386784000,2),(190,-337186800,1),(190,-321465600,2),(190,-305737200,5),(191,-2147483648,0),(191,-704937600,2),(191,-147895200,1),(191,-131565600,2),(191,325670400,3),(191,341391600,2),(191,357120000,3),(191,372841200,2),(191,388569600,3),(191,404895600,2),(191,420019200,3),(191,436345200,2),(191,452073600,3),(191,467794800,2),(191,483523200,3),(191,499244400,2),(191,514972800,3),(191,530694000,2),(191,544608000,3),(191,562143600,2),(191,576057600,3),(191,594198000,2),(191,607507200,3),(191,625647600,2),(191,638956800,3),(191,657097200,2),(191,671011200,3),(191,688546800,2),(191,702460800,3),(191,719996400,2),(191,733910400,3),(191,752050800,2),(191,765360000,3),(191,783500400,2),(191,796809600,3),(191,814950000,2),(191,828864000,3),(191,846399600,2),(191,860313600,3),(191,877849200,2),(191,891763200,3),(191,909298800,2),(191,923212800,3),(191,941353200,2),(191,954662400,3),(191,972802800,4),(191,986112000,3),(191,1004252400,2),(191,1018166400,3),(191,1035702000,2),(191,1049616000,3),(191,1067151600,2),(191,1081065600,3),(191,1099206000,2),(191,1112515200,3),(191,1130655600,2),(191,1143964800,3),(191,1162105200,4),(191,1173600000,3),(191,1194159600,2),(191,1205049600,3),(191,1225609200,2),(191,1236499200,3),(191,1257058800,2),(191,1268553600,3),(191,1289113200,2),(191,1300003200,3),(191,1320562800,2),(191,1331452800,3),(191,1352012400,2),(191,1362902400,3),(191,1383462000,2),(191,1394352000,3),(191,1414911600,2),(191,1425801600,3),(191,1446361200,2),(191,1457856000,3),(191,1478415600,2),(191,1489305600,3),(191,1509865200,2),(191,1520755200,3),(191,1541314800,2),(191,1552204800,3),(191,1572764400,2),(191,1583654400,3),(191,1604214000,2),(191,1615708800,3),(191,1636268400,2),(191,1647158400,3),(191,1667718000,2),(191,1678608000,3),(191,1699167600,2),(191,1710057600,3),(191,1730617200,2),(191,1741507200,3),(191,1762066800,2),(191,1772956800,3),(191,1793516400,2),(191,1805011200,3),(191,1825570800,2),(191,1836460800,3),(191,1857020400,2),(191,1867910400,3),(191,1888470000,2),(191,1899360000,3),(191,1919919600,2),(191,1930809600,3),(191,1951369200,2),(191,1962864000,3),(191,1983423600,2),(191,1994313600,3),(191,2014873200,2),(191,2025763200,3),(191,2046322800,2),(191,2057212800,3),(191,2077772400,2),(191,2088662400,3),(191,2109222000,2),(191,2120112000,3),(191,2140671600,2),(192,-2147483648,0),(192,-1767209328,2),(192,-1206950400,1),(192,-1191355200,2),(192,-1175367600,1),(192,-1159819200,2),(192,-633812400,1),(192,-622062000,2),(192,-602276400,1),(192,-591825600,2),(192,-570740400,1),(192,-560203200,2),(192,-539118000,1),(192,-531345600,2),(192,-191358000,1),(192,-184190400,2),(192,-155156400,1),(192,-150062400,2),(192,-128890800,1),(192,-121118400,2),(192,-99946800,1),(192,-89582400,2),(192,-68410800,1),(192,-57960000,2),(192,499755600,1),(192,511243200,2),(192,530600400,1),(192,540273600,2),(192,562136400,1),(192,571204800,2),(192,1214283600,3),(192,1384056000,2),(192,2147483647,2),(193,-2147483648,1),(193,-1567453392,2),(193,-1233432000,3),(193,-1222981200,2),(193,-1205956800,3),(193,-1194037200,2),(193,-1172865600,3),(193,-1162501200,2),(193,-1141329600,3),(193,-1130965200,2),(193,-1109793600,3),(193,-1099429200,2),(193,-1078257600,3),(193,-1067806800,2),(193,-1046635200,3),(193,-1036270800,2),(193,-1015099200,3),(193,-1004734800,2),(193,-983563200,3),(193,-973198800,2),(193,-952027200,3),(193,-941576400,2),(193,-931032000,3),(193,-900882000,2),(193,-890337600,3),(193,-833749200,2),(193,-827265600,3),(193,-752274000,2),(193,-733780800,3),(193,-197326800,2),(193,-190843200,3),(193,-184194000,2),(193,-164491200,3),(193,-152658000,2),(193,-132955200,3),(193,-121122000,2),(193,-101419200,3),(193,-86821200,2),(193,-71092800,3),(193,-54766800,2),(193,-39038400,3),(193,-23317200,2),(193,-7588800,5),(193,128142000,4),(193,136605600,5),(193,596948400,4),(193,605066400,5),(193,624423600,4),(193,636516000,5),(193,656478000,4),(193,667965600,2),(193,687931200,4),(193,699415200,5),(193,719377200,4),(193,731469600,5),(193,938919600,3),(193,952052400,5),(193,1198983600,4),(193,1205632800,5),(193,1224385200,4),(193,1237082400,5),(193,2147483647,5),(194,-2147483648,0),(194,-1514736000,1),(194,-1451667600,2),(194,-1343062800,1),(194,-1234803600,2),(194,-1222963200,3),(194,-1207242000,2),(194,-873820800,4),(194,-769395600,5),(194,-761677200,2),(194,-686073600,3),(194,-661539600,2),(194,-495039600,3),(194,-481734000,2),(194,-463590000,3),(194,-450284400,2),(194,-431535600,3),(194,-418230000,2),(194,-400086000,3),(194,-386780400,2),(194,-368636400,3),(194,-355330800,2),(194,-337186800,3),(194,-323881200,2),(194,-305737200,3),(194,-292431600,2),(194,199274400,3),(194,215600400,2),(194,230724000,3),(194,247050000,2),(194,262778400,3),(194,278499600,2),(194,294228000,3),(194,309949200,2),(194,325677600,3),(194,341398800,2),(194,357127200,3),(194,372848400,2),(194,388576800,3),(194,404902800,2),(194,420026400,3),(194,436352400,2),(194,452080800,3),(194,467802000,2),(194,483530400,3),(194,499251600,2),(194,514980000,3),(194,530701200,2),(194,544615200,3),(194,562150800,2),(194,576064800,3),(194,594205200,2),(194,607514400,3),(194,625654800,2),(194,638964000,3),(194,657104400,2),(194,671018400,3),(194,688554000,2),(194,702468000,3),(194,720003600,2),(194,733917600,3),(194,752058000,2),(194,765367200,3),(194,783507600,2),(194,796816800,3),(194,814957200,2),(194,828871200,3),(194,846406800,2),(194,860320800,3),(194,877856400,2),(194,891770400,3),(194,909306000,2),(194,923220000,3),(194,941360400,2),(194,954669600,3),(194,972810000,2),(194,986119200,3),(194,1004259600,2),(194,1018173600,3),(194,1035709200,2),(194,1049623200,3),(194,1067158800,2),(194,1081072800,3),(194,1099213200,2),(194,1112522400,3),(194,1130662800,2),(194,1143972000,3),(194,1162112400,2),(194,1175421600,3),(194,1193562000,2),(194,1207476000,3),(194,1225011600,2),(194,1238925600,3),(194,1256461200,2),(194,1268560800,3),(194,1289120400,2),(194,1300010400,3),(194,1320570000,2),(194,1331460000,3),(194,1352019600,2),(194,1362909600,3),(194,1383469200,2),(194,1394359200,3),(194,1414918800,2),(194,1425808800,3),(194,1446368400,2),(194,1457863200,3),(194,1478422800,2),(194,1489312800,3),(194,1509872400,2),(194,1520762400,3),(194,1541322000,2),(194,1552212000,3),(194,1572771600,2),(194,1583661600,3),(194,1604221200,2),(194,1615716000,3),(194,1636275600,2),(194,1647165600,3),(194,1667725200,2),(194,1678615200,3),(194,1699174800,2),(194,1710064800,3),(194,1730624400,2),(194,1741514400,3),(194,1762074000,2),(194,1772964000,3),(194,1793523600,2),(194,1805018400,3),(194,1825578000,2),(194,1836468000,3),(194,1857027600,2),(194,1867917600,3),(194,1888477200,2),(194,1899367200,3),(194,1919926800,2),(194,1930816800,3),(194,1951376400,2),(194,1962871200,3),(194,1983430800,2),(194,1994320800,3),(194,2014880400,2),(194,2025770400,3),(194,2046330000,2),(194,2057220000,3),(194,2077779600,2),(194,2088669600,3),(194,2109229200,2),(194,2120119200,3),(194,2140678800,2),(195,-2147483648,0),(195,-1767212472,2),(195,-1206954000,1),(195,-1191358800,2),(195,-1175371200,1),(195,-1159822800,2),(195,-633816000,1),(195,-622065600,2),(195,-602280000,1),(195,-591829200,2),(195,-570744000,1),(195,-560206800,2),(195,-539121600,1),(195,-531349200,2),(195,-191361600,1),(195,-184194000,2),(195,-155160000,1),(195,-150066000,2),(195,-128894400,1),(195,-121122000,2),(195,-99950400,1),(195,-89586000,2),(195,-68414400,1),(195,-57963600,2),(195,499752000,1),(195,511239600,2),(195,530596800,1),(195,540270000,2),(195,562132800,1),(195,571201200,2),(195,1214280000,3),(195,2147483647,3),(196,-2147483648,1),(196,-1892661434,2),(196,-1688410800,1),(196,-1619205434,3),(196,-1593806400,1),(196,-1335986234,4),(196,-1317585600,2),(196,-1304362800,4),(196,-1286049600,2),(196,-1272826800,4),(196,-1254513600,2),(196,-1241290800,4),(196,-1222977600,2),(196,-1209754800,4),(196,-1191355200,2),(196,-1178132400,3),(196,-870552000,2),(196,-865278000,3),(196,-740520000,5),(196,-736376400,3),(196,-718056000,2),(196,-713649600,3),(196,-36619200,6),(196,-23922000,7),(196,-3355200,6),(196,7527600,7),(196,24465600,6),(196,37767600,7),(196,55915200,6),(196,69217200,7),(196,87969600,6),(196,100666800,7),(196,118209600,6),(196,132116400,7),(196,150868800,6),(196,163566000,7),(196,182318400,6),(196,195620400,7),(196,213768000,6),(196,227070000,7),(196,245217600,6),(196,258519600,7),(196,277272000,6),(196,289969200,7),(196,308721600,6),(196,321418800,7),(196,340171200,6),(196,353473200,7),(196,371620800,6),(196,384922800,7),(196,403070400,6),(196,416372400,7),(196,434520000,6),(196,447822000,7),(196,466574400,6),(196,479271600,7),(196,498024000,6),(196,510721200,7),(196,529473600,6),(196,545194800,7),(196,560923200,6),(196,574225200,7),(196,592372800,6),(196,605674800,7),(196,624427200,6),(196,637124400,7),(196,653457600,6),(196,668574000,7),(196,687326400,6),(196,700628400,7),(196,718776000,6),(196,732078000,7),(196,750225600,6),(196,763527600,7),(196,781675200,6),(196,794977200,7),(196,813729600,6),(196,826426800,7),(196,845179200,6),(196,859690800,7),(196,876628800,6),(196,889930800,7),(196,906868800,6),(196,923194800,7),(196,939528000,6),(196,952830000,7),(196,971582400,6),(196,984279600,7),(196,1003032000,6),(196,1015729200,7),(196,1034481600,6),(196,1047178800,7),(196,1065931200,6),(196,1079233200,7),(196,1097380800,6),(196,1110682800,7),(196,1128830400,6),(196,1142132400,7),(196,1160884800,6),(196,1173582000,7),(196,1192334400,6),(196,1206846000,7),(196,1223784000,6),(196,1237086000,7),(196,1255233600,6),(196,1270350000,7),(196,1286683200,6),(196,1304823600,7),(196,1313899200,6),(196,1335668400,7),(196,1346558400,6),(196,1367118000,7),(196,1378612800,6),(196,1398567600,7),(196,1410062400,6),(196,1463281200,7),(196,1471147200,6),(196,1494730800,7),(196,1502596800,6),(196,1526180400,7),(196,1534046400,6),(196,1554606000,7),(196,1567915200,6),(196,1586055600,7),(196,1599364800,6),(196,1617505200,7),(196,1630814400,6),(196,1648954800,7),(196,1662264000,6),(196,1680404400,7),(196,1693713600,6),(196,1712458800,7),(196,1725768000,6),(196,1743908400,7),(196,1757217600,6),(196,1775358000,7),(196,1788667200,6),(196,1806807600,7),(196,1820116800,6),(196,1838257200,7),(196,1851566400,6),(196,1870311600,7),(196,1883016000,6),(196,1901761200,7),(196,1915070400,6),(196,1933210800,7),(196,1946520000,6),(196,1964660400,7),(196,1977969600,6),(196,1996110000,7),(196,2009419200,6),(196,2027559600,7),(196,2040868800,6),(196,2059614000,7),(196,2072318400,6),(196,2091063600,7),(196,2104372800,6),(196,2122513200,7),(196,2135822400,6),(196,2147483647,6),(197,-2147483648,1),(197,-1159773600,3),(197,-100119600,2),(197,-89668800,3),(197,-5770800,4),(197,4422600,3),(197,25678800,4),(197,33193800,3),(197,57733200,4),(197,64816200,3),(197,89182800,4),(197,96438600,3),(197,120632400,4),(197,127974600,3),(197,152082000,5),(197,972799200,3),(197,975823200,5),(198,-2147483648,0),(198,-1767214412,2),(198,-1206957600,1),(198,-1191362400,2),(198,-1175374800,1),(198,-1159826400,2),(198,-633819600,1),(198,-622069200,2),(198,-602283600,1),(198,-591832800,2),(198,-570747600,1),(198,-560210400,2),(198,-539125200,1),(198,-531352800,2),(198,-195426000,1),(198,-184197600,2),(198,-155163600,1),(198,-150069600,2),(198,-128898000,1),(198,-121125600,2),(198,-99954000,1),(198,-89589600,2),(198,-68418000,1),(198,-57967200,2),(198,499748400,1),(198,511236000,2),(198,530593200,1),(198,540266400,2),(198,562129200,1),(198,571197600,2),(198,592974000,1),(198,602042400,2),(198,624423600,1),(198,634701600,2),(198,656478000,1),(198,666756000,2),(198,687927600,1),(198,697600800,2),(198,719982000,1),(198,728445600,2),(198,750826800,1),(198,761709600,2),(198,782276400,1),(198,793159200,2),(198,813726000,1),(198,824004000,2),(198,844570800,1),(198,856058400,2),(198,876106800,1),(198,888717600,2),(198,908074800,1),(198,919562400,2),(198,938919600,1),(198,951616800,2),(198,970974000,1),(198,982461600,2),(198,1003028400,1),(198,1013911200,2),(198,1036292400,1),(198,1045360800,2),(198,1066532400,1),(198,1076810400,2),(198,1099364400,1),(198,1108864800,2),(198,1129431600,1),(198,1140314400,2),(198,1162695600,1),(198,1172368800,2),(198,1192330800,1),(198,1203213600,2),(198,1224385200,1),(198,1234663200,2),(198,1255834800,1),(198,1266717600,2),(198,1287284400,1),(198,1298167200,2),(198,1318734000,1),(198,1330221600,2),(198,1350788400,1),(198,1361066400,2),(198,1382238000,1),(198,1392516000,2),(198,1413687600,1),(198,1424570400,2),(198,1445137200,1),(198,1456020000,2),(198,1476586800,1),(198,1487469600,2),(198,1508036400,1),(198,1518919200,2),(198,1541300400,1),(198,1550368800,2),(198,1572750000,1),(198,1581818400,2),(198,1604199600,1),(198,1613872800,2),(198,1636254000,1),(198,1645322400,2),(198,1667703600,1),(198,1677376800,2),(198,1699153200,1),(198,1708221600,2),(198,1730602800,1),(198,1739671200,2),(198,1762052400,1),(198,1771725600,2),(198,1793502000,1),(198,1803175200,2),(198,1825556400,1),(198,1834624800,2),(198,1857006000,1),(198,1866074400,2),(198,1888455600,1),(198,1897524000,2),(198,1919905200,1),(198,1928973600,2),(198,1951354800,1),(198,1960423200,2),(198,1983409200,1),(198,1992477600,2),(198,2014858800,1),(198,2024532000,2),(198,2046308400,1),(198,2055376800,2),(198,2077758000,1),(198,2086826400,2),(198,2109207600,1),(198,2118880800,2),(198,2140657200,1),(199,-2147483648,0),(199,-1686090728,1),(199,323841600,2),(199,338961600,3),(199,354679200,6),(199,370400400,4),(199,386125200,5),(199,401850000,4),(199,417574800,5),(199,433299600,4),(199,449024400,5),(199,465354000,4),(199,481078800,5),(199,496803600,4),(199,512528400,5),(199,528253200,4),(199,543978000,5),(199,559702800,4),(199,575427600,5),(199,591152400,4),(199,606877200,5),(199,622602000,4),(199,638326800,5),(199,654656400,4),(199,670381200,5),(199,686106000,4),(199,701830800,5),(199,717555600,4),(199,733280400,5),(199,749005200,4),(199,764730000,5),(199,780454800,4),(199,796179600,5),(199,811904400,4),(199,828234000,5),(199,846378000,4),(199,859683600,5),(199,877827600,4),(199,891133200,5),(199,909277200,4),(199,922582800,5),(199,941331600,4),(199,954032400,5),(199,972781200,4),(199,985482000,5),(199,1004230800,4),(199,1017536400,5),(199,1035680400,4),(199,1048986000,5),(199,1067130000,4),(199,1080435600,5),(199,1099184400,4),(199,1111885200,5),(199,1130634000,4),(199,1143334800,5),(199,1162083600,4),(199,1174784400,5),(199,1193533200,4),(199,1206838800,5),(199,1224982800,4),(199,1238288400,5),(199,1256432400,4),(199,1269738000,5),(199,1288486800,4),(199,1301187600,5),(199,1319936400,4),(199,1332637200,5),(199,1351386000,4),(199,1364691600,5),(199,1382835600,4),(199,1396141200,5),(199,1414285200,4),(199,1427590800,5),(199,1445734800,4),(199,1459040400,5),(199,1477789200,4),(199,1490490000,5),(199,1509238800,4),(199,1521939600,5),(199,1540688400,4),(199,1553994000,5),(199,1572138000,4),(199,1585443600,5),(199,1603587600,4),(199,1616893200,5),(199,1635642000,4),(199,1648342800,5),(199,1667091600,4),(199,1679792400,5),(199,1698541200,4),(199,1711846800,5),(199,1729990800,4),(199,1743296400,5),(199,1761440400,4),(199,1774746000,5),(199,1792890000,4),(199,1806195600,5),(199,1824944400,4),(199,1837645200,5),(199,1856394000,4),(199,1869094800,5),(199,1887843600,4),(199,1901149200,5),(199,1919293200,4),(199,1932598800,5),(199,1950742800,4),(199,1964048400,5),(199,1982797200,4),(199,1995498000,5),(199,2014246800,4),(199,2026947600,5),(199,2045696400,4),(199,2058397200,5),(199,2077146000,4),(199,2090451600,5),(199,2108595600,4),(199,2121901200,5),(199,2140045200,4),(199,2147483647,4),(200,-2147483648,2),(200,-1633273200,1),(200,-1615132800,2),(200,-1601823600,1),(200,-1583683200,2),(200,-1570374000,1),(200,-1551628800,2),(200,-1538924400,1),(200,-1534089600,2),(200,-880210800,3),(200,-769395600,4),(200,-765388800,2),(200,-147884400,1),(200,-131558400,2),(200,-116434800,1),(200,-100108800,2),(200,-84380400,1),(200,-68659200,2),(200,-52930800,1),(200,-37209600,2),(200,-21481200,1),(200,-5760000,2),(200,9968400,1),(200,25689600,2),(200,41418000,1),(200,57744000,2),(200,73472400,1),(200,89193600,2),(200,104922000,1),(200,120643200,2),(200,126694800,1),(200,152092800,2),(200,162378000,1),(200,183542400,2),(200,199270800,1),(200,215596800,2),(200,230720400,1),(200,247046400,2),(200,262774800,1),(200,278496000,2),(200,294224400,1),(200,309945600,2),(200,325674000,1),(200,341395200,2),(200,357123600,1),(200,372844800,2),(200,388573200,1),(200,404899200,2),(200,420022800,1),(200,436348800,2),(200,452077200,1),(200,467798400,2),(200,483526800,1),(200,499248000,2),(200,514976400,1),(200,530697600,2),(200,544611600,1),(200,562147200,2),(200,576061200,1),(200,594201600,2),(200,607510800,1),(200,625651200,2),(200,638960400,1),(200,657100800,2),(200,671014800,1),(200,688550400,2),(200,702464400,1),(200,720000000,2),(200,733914000,1),(200,752054400,2),(200,765363600,1),(200,783504000,2),(200,796813200,1),(200,814953600,2),(200,828867600,1),(200,846403200,2),(200,860317200,1),(200,877852800,2),(200,891766800,1),(200,909302400,2),(200,923216400,1),(200,941356800,2),(200,954666000,1),(200,972806400,2),(200,986115600,1),(200,1004256000,2),(200,1018170000,1),(200,1035705600,2),(200,1049619600,1),(200,1067155200,2),(200,1081069200,1),(200,1099209600,2),(200,1112518800,1),(200,1130659200,2),(200,1143968400,1),(200,1162108800,2),(200,1173603600,1),(200,1194163200,2),(200,1205053200,1),(200,1225612800,2),(200,1236502800,1),(200,1257062400,2),(200,1268557200,1),(200,1289116800,2),(200,1300006800,1),(200,1320566400,2),(200,1331456400,1),(200,1352016000,2),(200,1362906000,1),(200,1383465600,2),(200,1394355600,1),(200,1414915200,2),(200,1425805200,1),(200,1446364800,2),(200,1457859600,1),(200,1478419200,2),(200,1489309200,1),(200,1509868800,2),(200,1520758800,1),(200,1541318400,2),(200,1552208400,1),(200,1572768000,2),(200,1583658000,1),(200,1604217600,2),(200,1615712400,1),(200,1636272000,2),(200,1647162000,1),(200,1667721600,2),(200,1678611600,1),(200,1699171200,2),(200,1710061200,1),(200,1730620800,2),(200,1741510800,1),(200,1762070400,2),(200,1772960400,1),(200,1793520000,2),(200,1805014800,1),(200,1825574400,2),(200,1836464400,1),(200,1857024000,2),(200,1867914000,1),(200,1888473600,2),(200,1899363600,1),(200,1919923200,2),(200,1930813200,1),(200,1951372800,2),(200,1962867600,1),(200,1983427200,2),(200,1994317200,1),(200,2014876800,2),(200,2025766800,1),(200,2046326400,2),(200,2057216400,1),(200,2077776000,2),(200,2088666000,1),(200,2109225600,2),(200,2120115600,1),(200,2140675200,2),(201,-2147483648,1),(201,-880207200,2),(201,-769395600,3),(201,-765385200,1),(201,-21477600,4),(201,-5756400,1),(201,9972000,4),(201,25693200,1),(201,41421600,4),(201,57747600,1),(201,73476000,4),(201,89197200,1),(201,104925600,4),(201,120646800,1),(201,126698400,4),(201,152096400,1),(201,162381600,4),(201,183546000,1),(201,199274400,4),(201,215600400,1),(201,230724000,4),(201,247050000,1),(201,262778400,4),(201,278499600,1),(201,294228000,4),(201,309949200,1),(201,325677600,4),(201,341398800,1),(201,357127200,4),(201,372848400,1),(201,388576800,4),(201,404902800,1),(201,420026400,4),(201,436352400,5),(201,439030800,7),(201,452084400,6),(201,467805600,7),(201,483534000,6),(201,499255200,7),(201,514983600,6),(201,530704800,7),(201,544618800,6),(201,562154400,7),(201,576068400,6),(201,594208800,7),(201,607518000,6),(201,625658400,7),(201,638967600,6),(201,657108000,7),(201,671022000,6),(201,688557600,7),(201,702471600,6),(201,720007200,7),(201,733921200,6),(201,752061600,7),(201,765370800,6),(201,783511200,7),(201,796820400,6),(201,814960800,7),(201,828874800,6),(201,846410400,7),(201,860324400,6),(201,877860000,7),(201,891774000,6),(201,909309600,7),(201,923223600,6),(201,941364000,7),(201,954673200,6),(201,972813600,7),(201,986122800,6),(201,1004263200,7),(201,1018177200,6),(201,1035712800,7),(201,1049626800,6),(201,1067162400,7),(201,1081076400,6),(201,1099216800,7),(201,1112526000,6),(201,1130666400,7),(201,1143975600,6),(201,1162116000,7),(201,1173610800,6),(201,1194170400,7),(201,1205060400,6),(201,1225620000,7),(201,1236510000,6),(201,1257069600,7),(201,1268564400,6),(201,1289124000,7),(201,1300014000,6),(201,1320573600,7),(201,1331463600,6),(201,1352023200,7),(201,1362913200,6),(201,1383472800,7),(201,1394362800,6),(201,1414922400,7),(201,1425812400,6),(201,1446372000,7),(201,1457866800,6),(201,1478426400,7),(201,1489316400,6),(201,1509876000,7),(201,1520766000,6),(201,1541325600,7),(201,1552215600,6),(201,1572775200,7),(201,1583665200,6),(201,1604224800,7),(201,1615719600,6),(201,1636279200,7),(201,1647169200,6),(201,1667728800,7),(201,1678618800,6),(201,1699178400,7),(201,1710068400,6),(201,1730628000,7),(201,1741518000,6),(201,1762077600,7),(201,1772967600,6),(201,1793527200,7),(201,1805022000,6),(201,1825581600,7),(201,1836471600,6),(201,1857031200,7),(201,1867921200,6),(201,1888480800,7),(201,1899370800,6),(201,1919930400,7),(201,1930820400,6),(201,1951380000,7),(201,1962874800,6),(201,1983434400,7),(201,1994324400,6),(201,2014884000,7),(201,2025774000,6),(201,2046333600,7),(201,2057223600,6),(201,2077783200,7),(201,2088673200,6),(201,2109232800,7),(201,2120122800,6),(201,2140682400,7),(202,-2147483648,0),(202,-1825098836,1),(203,-2147483648,2),(203,-1664130548,1),(203,-1650137348,2),(203,-1632076148,1),(203,-1615145348,2),(203,-1598650148,1),(203,-1590100148,2),(203,-1567286948,1),(203,-1551565748,2),(203,-1535837348,1),(203,-1520116148,2),(203,-1503782948,1),(203,-1488666548,2),(203,-1472333348,1),(203,-1457216948,2),(203,-1440883748,1),(203,-1425767348,2),(203,-1409434148,1),(203,-1394317748,2),(203,-1377984548,1),(203,-1362263348,2),(203,-1346534948,1),(203,-1330813748,2),(203,-1314480548,1),(203,-1299364148,2),(203,-1283030948,1),(203,-1267914548,2),(203,-1251581348,1),(203,-1236464948,2),(203,-1220131748,1),(203,-1205015348,2),(203,-1188682148,1),(203,-1172960948,2),(203,-1156627748,1),(203,-1141511348,2),(203,-1125178148,1),(203,-1110061748,2),(203,-1096921748,4),(203,-1093728600,3),(203,-1078612200,4),(203,-1061670600,3),(203,-1048973400,4),(203,-1030221000,3),(203,-1017523800,4),(203,-998771400,3),(203,-986074200,4),(203,-966717000,3),(203,-954624600,4),(203,-935267400,3),(203,-922570200,4),(203,-903817800,3),(203,-891120600,4),(203,-872368200,6),(203,-769395600,5),(203,-765401400,4),(203,-746044200,3),(203,-733347000,4),(203,-714594600,3),(203,-701897400,4),(203,-683145000,3),(203,-670447800,4),(203,-651695400,3),(203,-638998200,4),(203,-619641000,3),(203,-606943800,4),(203,-589401000,3),(203,-576099000,4),(203,-557951400,3),(203,-544649400,4),(203,-526501800,3),(203,-513199800,4),(203,-495052200,3),(203,-481750200,4),(203,-463602600,3),(203,-450300600,4),(203,-431548200,3),(203,-418246200,4),(203,-400098600,3),(203,-386796600,4),(203,-368649000,3),(203,-355347000,4),(203,-337199400,3),(203,-323897400,4),(203,-305749800,3),(203,-289423800,4),(203,-273695400,3),(203,-257974200,4),(203,-242245800,3),(203,-226524600,4),(203,-210796200,3),(203,-195075000,4),(203,-179346600,3),(203,-163625400,4),(203,-147897000,3),(203,-131571000,4),(203,-116447400,3),(203,-100121400,4),(203,-84393000,3),(203,-68671800,4),(203,-52943400,3),(203,-37222200,4),(203,-21493800,3),(203,-5772600,4),(203,9955800,3),(203,25677000,4),(203,41405400,3),(203,57731400,4),(203,73459800,3),(203,89181000,4),(203,104909400,3),(203,120630600,4),(203,136359000,3),(203,152080200,4),(203,167808600,3),(203,183529800,4),(203,199258200,3),(203,215584200,4),(203,230707800,3),(203,247033800,4),(203,262762200,3),(203,278483400,4),(203,294211800,3),(203,309933000,4),(203,325661400,3),(203,341382600,4),(203,357111000,3),(203,372832200,4),(203,388560600,3),(203,404886600,4),(203,420010200,3),(203,436336200,4),(203,452064600,3),(203,467785800,4),(203,483514200,3),(203,499235400,4),(203,514963800,3),(203,530685000,4),(203,544591860,3),(203,562127460,4),(203,576041460,7),(203,594178260,4),(203,607491060,3),(203,625631460,4),(203,638940660,3),(203,657081060,4),(203,670995060,3),(203,688530660,4),(203,702444660,3),(203,719980260,4),(203,733894260,3),(203,752034660,4),(203,765343860,3),(203,783484260,4),(203,796793460,3),(203,814933860,4),(203,828847860,3),(203,846383460,4),(203,860297460,3),(203,877833060,4),(203,891747060,3),(203,909282660,4),(203,923196660,3),(203,941337060,4),(203,954646260,3),(203,972786660,4),(203,986095860,3),(203,1004236260,4),(203,1018150260,3),(203,1035685860,4),(203,1049599860,3),(203,1067135460,4),(203,1081049460,3),(203,1099189860,4),(203,1112499060,3),(203,1130639460,4),(203,1143948660,3),(203,1162089060,4),(203,1173583860,3),(203,1194143460,4),(203,1205033460,3),(203,1225593060,4),(203,1236483060,3),(203,1257042660,4),(203,1268537460,3),(203,1289097060,4),(203,1299987060,3),(203,1320553800,4),(203,1331443800,3),(203,1352003400,4),(203,1362893400,3),(203,1383453000,4),(203,1394343000,3),(203,1414902600,4),(203,1425792600,3),(203,1446352200,4),(203,1457847000,3),(203,1478406600,4),(203,1489296600,3),(203,1509856200,4),(203,1520746200,3),(203,1541305800,4),(203,1552195800,3),(203,1572755400,4),(203,1583645400,3),(203,1604205000,4),(203,1615699800,3),(203,1636259400,4),(203,1647149400,3),(203,1667709000,4),(203,1678599000,3),(203,1699158600,4),(203,1710048600,3),(203,1730608200,4),(203,1741498200,3),(203,1762057800,4),(203,1772947800,3),(203,1793507400,4),(203,1805002200,3),(203,1825561800,4),(203,1836451800,3),(203,1857011400,4),(203,1867901400,3),(203,1888461000,4),(203,1899351000,3),(203,1919910600,4),(203,1930800600,3),(203,1951360200,4),(203,1962855000,3),(203,1983414600,4),(203,1994304600,3),(203,2014864200,4),(203,2025754200,3),(203,2046313800,4),(203,2057203800,3),(203,2077763400,4),(203,2088653400,3),(203,2109213000,4),(203,2120103000,3),(203,2140662600,4),(204,-2147483648,0),(204,-1825098836,1),(205,-2147483648,0),(205,-1825098836,1),(206,-2147483648,0),(206,-1825098836,1),(207,-2147483648,0),(207,-1825098836,1),(208,-2147483648,0),(208,-2030201320,2),(208,-1632063600,1),(208,-1615132800,2),(208,-880210800,3),(208,-769395600,4),(208,-765388800,2),(208,-747241200,1),(208,-732729600,2),(208,-715791600,1),(208,-702489600,2),(208,-684342000,1),(208,-671040000,2),(208,-652892400,1),(208,-639590400,2),(208,-400086000,1),(208,-384364800,2),(208,-337186800,1),(208,-321465600,2),(208,-305737200,1),(208,-292435200,2),(208,-273682800,1),(208,-260985600,2),(208,73472400,5),(209,-2147483648,0),(209,-1538503868,2),(209,547020000,1),(209,559717200,2),(209,578469600,1),(209,591166800,2),(209,1146981600,1),(209,1154926800,2),(210,-2147483648,0),(210,-1686079492,2),(210,670399200,1),(210,686120400,2),(210,701848800,1),(210,717570000,2),(210,733903200,1),(210,752043600,2),(210,765352800,1),(210,783493200,2),(210,796802400,1),(210,814942800,2),(210,828856800,1),(210,846392400,2),(210,860306400,1),(210,877842000,2),(210,891756000,1),(210,909291600,2),(210,923205600,1),(210,941346000,2),(210,954655200,1),(210,972795600,2),(210,986104800,1),(210,1004245200,2),(210,1018159200,1),(210,1035694800,2),(210,1049608800,1),(210,1067144400,2),(210,1081058400,1),(210,1099198800,2),(210,1112508000,1),(210,1130648400,2),(210,1143957600,1),(210,1162098000,2),(210,1173592800,1),(210,1194152400,2),(210,1205042400,1),(210,1225602000,2),(210,1236492000,1),(210,1257051600,2),(210,1268546400,1),(210,1289106000,2),(210,1299996000,1),(210,1320555600,2),(210,1331445600,1),(210,1352005200,2),(210,1362895200,1),(210,1383454800,2),(210,1394344800,1),(210,1414904400,2),(210,1425794400,1),(210,1446354000,2),(210,1457848800,1),(210,1478408400,2),(210,1489298400,1),(210,1509858000,2),(210,1520748000,1),(210,1541307600,2),(210,1552197600,1),(210,1572757200,2),(210,1583647200,1),(210,1604206800,2),(210,1615701600,1),(210,1636261200,2),(210,1647151200,1),(210,1667710800,2),(210,1678600800,1),(210,1699160400,2),(210,1710050400,1),(210,1730610000,2),(210,1741500000,1),(210,1762059600,2),(210,1772949600,1),(210,1793509200,2),(210,1805004000,1),(210,1825563600,2),(210,1836453600,1),(210,1857013200,2),(210,1867903200,1),(210,1888462800,2),(210,1899352800,1),(210,1919912400,2),(210,1930802400,1),(210,1951362000,2),(210,1962856800,1),(210,1983416400,2),(210,1994306400,1),(210,2014866000,2),(210,2025756000,1),(210,2046315600,2),(210,2057205600,1),(210,2077765200,2),(210,2088655200,1),(210,2109214800,2),(210,2120104800,1),(210,2140664400,2),(211,-2147483648,1),(211,-1893434400,2),(211,-880218000,3),(211,-769395600,4),(211,-765396000,2),(211,9961200,5),(211,25682400,2),(211,41410800,5),(211,57736800,2),(211,73465200,5),(211,89186400,2),(211,136364400,5),(211,152085600,2),(211,167814000,5),(211,183535200,2),(211,199263600,5),(211,215589600,2),(211,230713200,5),(211,247039200,2),(211,262767600,5),(211,278488800,2),(211,294217200,5),(211,309938400,2),(211,325666800,5),(211,341388000,2),(211,357116400,5),(211,372837600,2),(211,388566000,5),(211,404892000,2),(211,420015600,5),(211,436341600,2),(211,452070000,5),(211,467791200,2),(211,483519600,5),(211,499240800,2),(211,514969200,5),(211,530690400,2),(211,544604400,5),(211,562140000,2),(211,576054000,5),(211,594194400,2),(211,607503600,5),(211,625644000,2),(211,638953200,5),(211,657093600,2),(211,671007600,5),(211,688543200,2),(211,702457200,5),(211,719992800,2),(211,733906800,5),(211,752047200,2),(211,765356400,5),(211,783496800,2),(211,796806000,5),(211,814946400,2),(211,828860400,5),(211,846396000,2),(211,860310000,5),(211,877845600,2),(211,891759600,5),(211,909295200,2),(211,923209200,5),(211,941349600,2),(211,954658800,5),(211,972799200,2),(211,986108400,5),(211,1004248800,2),(211,1018162800,5),(211,1035698400,2),(211,1049612400,5),(211,1067148000,2),(211,1081062000,5),(211,1099202400,2),(211,1112511600,5),(211,1130652000,2),(211,1143961200,5),(211,1162101600,2),(211,1173596400,5),(211,1194156000,2),(211,1205046000,5),(211,1225605600,2),(211,1236495600,5),(211,1257055200,2),(211,1268550000,5),(211,1289109600,2),(211,1299999600,5),(211,1320559200,2),(211,1331449200,5),(211,1352008800,2),(211,1362898800,5),(211,1383458400,2),(211,1394348400,5),(211,1414908000,2),(211,1425798000,5),(211,1446357600,2),(211,1457852400,5),(211,1478412000,2),(211,1489302000,5),(211,1509861600,2),(211,1520751600,5),(211,1541311200,2),(211,1552201200,5),(211,1572760800,2),(211,1583650800,5),(211,1604210400,2),(211,1615705200,5),(211,1636264800,2),(211,1647154800,5),(211,1667714400,2),(211,1678604400,5),(211,1699164000,2),(211,1710054000,5),(211,1730613600,2),(211,1741503600,5),(211,1762063200,2),(211,1772953200,5),(211,1793512800,2),(211,1805007600,5),(211,1825567200,2),(211,1836457200,5),(211,1857016800,2),(211,1867906800,5),(211,1888466400,2),(211,1899356400,5),(211,1919916000,2),(211,1930806000,5),(211,1951365600,2),(211,1962860400,5),(211,1983420000,2),(211,1994310000,5),(211,2014869600,2),(211,2025759600,5),(211,2046319200,2),(211,2057209200,5),(211,2077768800,2),(211,2088658800,5),(211,2109218400,2),(211,2120108400,5),(211,2140668000,2),(212,-2147483648,0),(212,-1514736000,1),(212,-1451667600,2),(212,-1343062800,1),(212,-1234803600,2),(212,-1222963200,3),(212,-1207242000,2),(212,-873820800,4),(212,-769395600,5),(212,-761677200,2),(212,-686073600,3),(212,-661539600,2),(212,-495039600,3),(212,-481734000,2),(212,-463590000,3),(212,-450284400,2),(212,-431535600,3),(212,-418230000,2),(212,-400086000,3),(212,-386780400,2),(212,-368636400,3),(212,-355330800,2),(212,-337186800,3),(212,-323881200,2),(212,-305737200,3),(212,-292431600,2),(212,199274400,3),(212,215600400,2),(212,230724000,3),(212,247050000,2),(212,262778400,3),(212,278499600,2),(212,294228000,3),(212,309949200,2),(212,325677600,3),(212,341398800,2),(212,357127200,3),(212,372848400,2),(212,388576800,3),(212,404902800,2),(212,420026400,3),(212,436352400,2),(212,452080800,3),(212,467802000,2),(212,483530400,3),(212,499251600,2),(212,514980000,3),(212,530701200,2),(212,544615200,3),(212,562150800,2),(212,576064800,3),(212,594205200,2),(212,607514400,3),(212,625654800,2),(212,638964000,3),(212,657104400,2),(212,671018400,3),(212,688554000,2),(212,702468000,3),(212,720003600,2),(212,733917600,3),(212,752058000,2),(212,765367200,3),(212,783507600,2),(212,796816800,3),(212,814957200,2),(212,828871200,3),(212,846406800,2),(212,860320800,3),(212,877856400,2),(212,891770400,3),(212,909306000,2),(212,923220000,3),(212,941360400,2),(212,954669600,3),(212,972810000,2),(212,986119200,3),(212,1004259600,2),(212,1018173600,3),(212,1035709200,2),(212,1049623200,3),(212,1067158800,2),(212,1081072800,3),(212,1099213200,2),(212,1112522400,3),(212,1130662800,2),(212,1143972000,3),(212,1162112400,2),(212,1175421600,3),(212,1193562000,2),(212,1207476000,3),(212,1225011600,2),(212,1238925600,3),(212,1256461200,2),(212,1268560800,3),(212,1289120400,2),(212,1300010400,3),(212,1320570000,2),(212,1331460000,3),(212,1352019600,2),(212,1362909600,3),(212,1383469200,2),(212,1394359200,3),(212,1414918800,2),(212,1425808800,3),(212,1446368400,2),(212,1457863200,3),(212,1478422800,2),(212,1489312800,3),(212,1509872400,2),(212,1520762400,3),(212,1541322000,2),(212,1552212000,3),(212,1572771600,2),(212,1583661600,3),(212,1604221200,2),(212,1615716000,3),(212,1636275600,2),(212,1647165600,3),(212,1667725200,2),(212,1678615200,3),(212,1699174800,2),(212,1710064800,3),(212,1730624400,2),(212,1741514400,3),(212,1762074000,2),(212,1772964000,3),(212,1793523600,2),(212,1805018400,3),(212,1825578000,2),(212,1836468000,3),(212,1857027600,2),(212,1867917600,3),(212,1888477200,2),(212,1899367200,3),(212,1919926800,2),(212,1930816800,3),(212,1951376400,2),(212,1962871200,3),(212,1983430800,2),(212,1994320800,3),(212,2014880400,2),(212,2025770400,3),(212,2046330000,2),(212,2057220000,3),(212,2077779600,2),(212,2088669600,3),(212,2109229200,2),(212,2120119200,3),(212,2140678800,2),(213,-2147483648,2),(213,-1632070800,1),(213,-1615140000,2),(213,-1601753400,1),(213,-1583697600,2),(213,-1567357200,1),(213,-1554667200,2),(213,-1534698000,1),(213,-1524074400,2),(213,-1503248400,1),(213,-1492365600,2),(213,-1471798800,1),(213,-1460916000,2),(213,-1440954000,1),(213,-1428861600,2),(213,-1409504400,1),(213,-1397412000,2),(213,-1378054800,1),(213,-1365962400,2),(213,-1346605200,1),(213,-1333908000,2),(213,-1315155600,1),(213,-1301853600,2),(213,-1283706000,1),(213,-1270404000,2),(213,-1252256400,1),(213,-1238954400,2),(213,-1220806800,1),(213,-1207504800,2),(213,-1188752400,1),(213,-1176055200,2),(213,-1157302800,1),(213,-1144000800,2),(213,-1125853200,1),(213,-1112551200,2),(213,-1094403600,1),(213,-1081101600,2),(213,-1062954000,1),(213,-1049652000,2),(213,-1031504400,1),(213,-1018202400,2),(213,-1000054800,1),(213,-986752800,2),(213,-968000400,1),(213,-955303200,2),(213,-936550800,1),(213,-880218000,3),(213,-769395600,4),(213,-765396000,2),(213,-747248400,1),(213,-733946400,2),(213,-715806000,1),(213,-702504000,2),(213,-684356400,1),(213,-671054400,2),(213,-652906800,1),(213,-634161600,2),(213,-620845200,1),(213,-602704800,2),(213,-589395600,1),(213,-576093600,2),(213,-557946000,1),(213,-544644000,2),(213,-526496400,1),(213,-513194400,2),(213,-495046800,1),(213,-481744800,2),(213,-463597200,1),(213,-450295200,2),(213,-431542800,1),(213,-418240800,2),(213,-400093200,1),(213,-384372000,2),(213,-368643600,1),(213,-352922400,2),(213,-337194000,1),(213,-321472800,2),(213,-305744400,1),(213,-289418400,2),(213,-273690000,1),(213,-257968800,2),(213,-242240400,1),(213,-226519200,2),(213,-210790800,1),(213,-195069600,2),(213,-179341200,1),(213,-163620000,2),(213,-147891600,1),(213,-131565600,2),(213,-116442000,1),(213,-100116000,2),(213,-84387600,1),(213,-68666400,2),(213,-52938000,1),(213,-37216800,2),(213,-21488400,1),(213,-5767200,2),(213,9961200,1),(213,25682400,2),(213,41410800,1),(213,57736800,2),(213,73465200,1),(213,89186400,2),(213,104914800,1),(213,120636000,2),(213,136364400,1),(213,152085600,2),(213,167814000,1),(213,183535200,2),(213,199263600,1),(213,215589600,2),(213,230713200,1),(213,247039200,2),(213,262767600,1),(213,278488800,2),(213,294217200,1),(213,309938400,2),(213,325666800,1),(213,341388000,2),(213,357116400,1),(213,372837600,2),(213,388566000,1),(213,404892000,2),(213,420015600,1),(213,436341600,2),(213,452070000,1),(213,467791200,2),(213,483519600,1),(213,499240800,2),(213,514969200,1),(213,530690400,2),(213,544604400,1),(213,562140000,2),(213,576054000,1),(213,594194400,2),(213,607503600,1),(213,625644000,2),(213,638953200,1),(213,657093600,2),(213,671007600,1),(213,688543200,2),(213,702457200,1),(213,719992800,2),(213,733906800,1),(213,752047200,2),(213,765356400,1),(213,783496800,2),(213,796806000,1),(213,814946400,2),(213,828860400,1),(213,846396000,2),(213,860310000,1),(213,877845600,2),(213,891759600,1),(213,909295200,2),(213,923209200,1),(213,941349600,2),(213,954658800,1),(213,972799200,2),(213,986108400,1),(213,1004248800,2),(213,1018162800,1),(213,1035698400,2),(213,1049612400,1),(213,1067148000,2),(213,1081062000,1),(213,1099202400,2),(213,1112511600,1),(213,1130652000,2),(213,1143961200,1),(213,1162101600,2),(213,1173596400,1),(213,1194156000,2),(213,1205046000,1),(213,1225605600,2),(213,1236495600,1),(213,1257055200,2),(213,1268550000,1),(213,1289109600,2),(213,1299999600,1),(213,1320559200,2),(213,1331449200,1),(213,1352008800,2),(213,1362898800,1),(213,1383458400,2),(213,1394348400,1),(213,1414908000,2),(213,1425798000,1),(213,1446357600,2),(213,1457852400,1),(213,1478412000,2),(213,1489302000,1),(213,1509861600,2),(213,1520751600,1),(213,1541311200,2),(213,1552201200,1),(213,1572760800,2),(213,1583650800,1),(213,1604210400,2),(213,1615705200,1),(213,1636264800,2),(213,1647154800,1),(213,1667714400,2),(213,1678604400,1),(213,1699164000,2),(213,1710054000,1),(213,1730613600,2),(213,1741503600,1),(213,1762063200,2),(213,1772953200,1),(213,1793512800,2),(213,1805007600,1),(213,1825567200,2),(213,1836457200,1),(213,1857016800,2),(213,1867906800,1),(213,1888466400,2),(213,1899356400,1),(213,1919916000,2),(213,1930806000,1),(213,1951365600,2),(213,1962860400,1),(213,1983420000,2),(213,1994310000,1),(213,2014869600,2),(213,2025759600,1),(213,2046319200,2),(213,2057209200,1),(213,2077768800,2),(213,2088658800,1),(213,2109218400,2),(213,2120108400,1),(213,2140668000,2),(214,-2147483648,0),(214,-1825098836,1),(215,-2147483648,2),(215,-1632060000,1),(215,-1615129200,2),(215,-880207200,3),(215,-769395600,4),(215,-765385200,2),(215,-747237600,1),(215,-732726000,2),(215,-715788000,1),(215,-702486000,2),(215,-684338400,1),(215,-671036400,2),(215,-652888800,1),(215,-639586800,2),(215,-620834400,1),(215,-608137200,2),(215,-589384800,1),(215,-576082800,2),(215,-557935200,1),(215,-544633200,2),(215,-526485600,1),(215,-513183600,2),(215,-495036000,1),(215,-481734000,2),(215,-463586400,1),(215,-450284400,2),(215,-431532000,1),(215,-418230000,2),(215,-400082400,1),(215,-386780400,2),(215,-368632800,1),(215,-355330800,2),(215,-337183200,1),(215,-323881200,2),(215,-305733600,1),(215,-292431600,2),(215,-273679200,1),(215,-260982000,2),(215,-242229600,1),(215,-226508400,2),(215,-210780000,1),(215,-195058800,2),(215,-179330400,1),(215,-163609200,2),(215,-147880800,1),(215,-131554800,2),(215,-116431200,1),(215,-100105200,2),(215,-84376800,1),(215,-68655600,2),(215,-52927200,1),(215,-37206000,2),(215,-21477600,1),(215,-5756400,2),(215,9972000,1),(215,25693200,2),(215,41421600,1),(215,57747600,2),(215,73476000,1),(215,89197200,2),(215,104925600,1),(215,120646800,2),(215,136375200,1),(215,152096400,2),(215,167824800,1),(215,183546000,2),(215,199274400,1),(215,215600400,2),(215,230724000,1),(215,247050000,2),(215,262778400,1),(215,278499600,2),(215,294228000,1),(215,309949200,2),(215,325677600,1),(215,341398800,2),(215,357127200,1),(215,372848400,2),(215,388576800,1),(215,404902800,2),(215,420026400,1),(215,436352400,2),(215,452080800,1),(215,467802000,2),(215,483530400,1),(215,499251600,2),(215,514980000,1),(215,530701200,2),(215,544615200,1),(215,562150800,2),(215,576064800,1),(215,594205200,2),(215,607514400,1),(215,625654800,2),(215,638964000,1),(215,657104400,2),(215,671018400,1),(215,688554000,2),(215,702468000,1),(215,720003600,2),(215,733917600,1),(215,752058000,2),(215,765367200,1),(215,783507600,2),(215,796816800,1),(215,814957200,2),(215,828871200,1),(215,846406800,2),(215,860320800,1),(215,877856400,2),(215,891770400,1),(215,909306000,2),(215,923220000,1),(215,941360400,2),(215,954669600,1),(215,972810000,2),(215,986119200,1),(215,1004259600,2),(215,1018173600,1),(215,1035709200,2),(215,1049623200,1),(215,1067158800,2),(215,1081072800,1),(215,1099213200,2),(215,1112522400,1),(215,1130662800,2),(215,1143972000,1),(215,1162112400,2),(215,1173607200,1),(215,1194166800,2),(215,1205056800,1),(215,1225616400,2),(215,1236506400,1),(215,1257066000,2),(215,1268560800,1),(215,1289120400,2),(215,1300010400,1),(215,1320570000,2),(215,1331460000,1),(215,1352019600,2),(215,1362909600,1),(215,1383469200,2),(215,1394359200,1),(215,1414918800,2),(215,1425808800,1),(215,1446368400,2),(215,1457863200,1),(215,1478422800,2),(215,1489312800,1),(215,1509872400,2),(215,1520762400,1),(215,1541322000,2),(215,1552212000,1),(215,1572771600,2),(215,1583661600,1),(215,1604221200,2),(215,1615716000,1),(215,1636275600,2),(215,1647165600,1),(215,1667725200,2),(215,1678615200,1),(215,1699174800,2),(215,1710064800,1),(215,1730624400,2),(215,1741514400,1),(215,1762074000,2),(215,1772964000,1),(215,1793523600,2),(215,1805018400,1),(215,1825578000,2),(215,1836468000,1),(215,1857027600,2),(215,1867917600,1),(215,1888477200,2),(215,1899367200,1),(215,1919926800,2),(215,1930816800,1),(215,1951376400,2),(215,1962871200,1),(215,1983430800,2),(215,1994320800,1),(215,2014880400,2),(215,2025770400,1),(215,2046330000,2),(215,2057220000,1),(215,2077779600,2),(215,2088669600,1),(215,2109229200,2),(215,2120119200,1),(215,2140678800,2),(216,-2147483648,0),(216,-1825098836,1),(217,-2147483648,2),(217,-1632056400,1),(217,-1615125600,2),(217,-1596978000,1),(217,-1583164800,2),(217,-880203600,3),(217,-769395600,4),(217,-765381600,2),(217,-147884400,5),(217,-131554800,2),(217,-81961200,6),(217,325677600,7),(217,341398800,6),(217,357127200,7),(217,372848400,6),(217,388576800,7),(217,404902800,6),(217,420026400,7),(217,436352400,6),(217,452080800,7),(217,467802000,6),(217,483530400,7),(217,499251600,6),(217,514980000,7),(217,530701200,6),(217,544615200,7),(217,562150800,6),(217,576064800,7),(217,594205200,6),(217,607514400,7),(217,625654800,6),(217,638964000,7),(217,657104400,6),(217,671018400,7),(217,688554000,6),(217,702468000,7),(217,720003600,6),(217,733917600,7),(217,752058000,6),(217,765367200,7),(217,783507600,6),(217,796816800,7),(217,814957200,6),(217,828871200,7),(217,846406800,6),(217,860320800,7),(217,877856400,6),(217,891770400,7),(217,909306000,6),(217,923220000,7),(217,941360400,6),(217,954669600,7),(217,972810000,6),(217,986119200,7),(217,1004259600,6),(217,1018173600,7),(217,1035709200,6),(217,1049623200,7),(217,1067158800,6),(217,1081072800,7),(217,1099213200,6),(217,1112522400,7),(217,1130662800,6),(217,1143972000,7),(217,1162112400,6),(217,1173607200,7),(217,1194166800,6),(217,1205056800,7),(217,1225616400,6),(217,1236506400,7),(217,1257066000,6),(217,1268560800,7),(217,1289120400,6),(217,1300010400,7),(217,1320570000,6),(217,1331460000,7),(217,1352019600,6),(217,1362909600,7),(217,1383469200,6),(217,1394359200,7),(217,1414918800,6),(217,1425808800,7),(217,1446368400,6),(217,1457863200,7),(217,1478422800,6),(217,1489312800,7),(217,1509872400,6),(217,1520762400,7),(217,1541322000,6),(217,1552212000,7),(217,1572771600,6),(217,1583661600,7),(217,1604221200,6),(217,1615716000,7),(217,1636275600,6),(217,1647165600,7),(217,1667725200,6),(217,1678615200,7),(217,1699174800,6),(217,1710064800,7),(217,1730624400,6),(217,1741514400,7),(217,1762074000,6),(217,1772964000,7),(217,1793523600,6),(217,1805018400,7),(217,1825578000,6),(217,1836468000,7),(217,1857027600,6),(217,1867917600,7),(217,1888477200,6),(217,1899367200,7),(217,1919926800,6),(217,1930816800,7),(217,1951376400,6),(217,1962871200,7),(217,1983430800,6),(217,1994320800,7),(217,2014880400,6),(217,2025770400,7),(217,2046330000,6),(217,2057220000,7),(217,2077779600,6),(217,2088669600,7),(217,2109229200,6),(217,2120119200,7),(217,2140678800,6),(218,-2147483648,2),(218,-1694368800,1),(218,-1681671600,2),(218,-1632067200,1),(218,-1615136400,2),(218,-1029686400,1),(218,-1018198800,2),(218,-880214400,3),(218,-769395600,4),(218,-765392400,2),(218,-746035200,1),(218,-732733200,2),(218,-715795200,1),(218,-702493200,2),(218,-684345600,1),(218,-671043600,2),(218,-652896000,1),(218,-639594000,2),(218,-620755200,1),(218,-607626000,2),(218,-589392000,1),(218,-576090000,2),(218,-557942400,1),(218,-544640400,2),(218,-526492800,1),(218,-513190800,2),(218,-495043200,1),(218,-481741200,2),(218,-463593600,1),(218,-450291600,2),(218,-431539200,1),(218,-418237200,2),(218,-400089600,1),(218,-386787600,2),(218,-368640000,1),(218,-355338000,2),(218,-337190400,1),(218,-321469200,2),(218,-305740800,1),(218,-292438800,2),(218,-210787200,1),(218,-198090000,2),(218,-116438400,5),(218,-100108800,6),(218,-84384000,5),(218,-68659200,6),(218,-52934400,5),(218,-37209600,6),(218,-21484800,5),(218,-5760000,6),(218,9964800,5),(218,25689600,6),(218,41414400,5),(218,57744000,6),(218,73468800,5),(218,89193600,6),(218,104918400,5),(218,120643200,6),(218,136368000,5),(218,152092800,6),(218,167817600,5),(218,183542400,6),(218,199267200,5),(218,215596800,6),(218,230716800,5),(218,247046400,6),(218,262771200,5),(218,278496000,6),(218,294220800,5),(218,309945600,6),(218,325670400,5),(218,341395200,6),(218,357120000,5),(218,372844800,6),(218,388569600,5),(218,404899200,6),(218,420019200,5),(218,436348800,6),(218,452073600,5),(218,467798400,6),(218,483523200,5),(218,499248000,6),(218,514972800,5),(218,530697600,6),(218,544608000,5),(218,562147200,6),(218,576057600,5),(218,594201600,6),(218,607507200,5),(218,625651200,6),(218,638956800,5),(218,657100800,6),(218,671011200,5),(218,688550400,6),(218,702460800,5),(218,720000000,6),(218,733910400,5),(218,752054400,6),(218,765360000,5),(218,783504000,6),(218,796809600,5),(218,814953600,6),(218,828864000,5),(218,846403200,6),(218,860313600,5),(218,877852800,6),(218,891763200,5),(218,909302400,6),(218,923212800,5),(218,941356800,6),(218,954662400,5),(218,972806400,6),(218,986112000,5),(218,1004256000,6),(218,1018166400,5),(218,1035705600,6),(218,1049616000,5),(218,1067155200,6),(218,1081065600,5),(218,1099209600,6),(218,1112515200,5),(218,1130659200,6),(218,1136095200,2),(218,1143964800,1),(218,1162105200,2),(218,1173600000,1),(218,1194159600,2),(218,1205049600,1),(218,1225609200,2),(218,1236499200,1),(218,1257058800,2),(218,1268553600,1),(218,1289113200,2),(218,1300003200,1),(218,1320562800,2),(218,1331452800,1),(218,1352012400,2),(218,1362902400,1),(218,1383462000,2),(218,1394352000,1),(218,1414911600,2),(218,1425801600,1),(218,1446361200,2),(218,1457856000,1),(218,1478415600,2),(218,1489305600,1),(218,1509865200,2),(218,1520755200,1),(218,1541314800,2),(218,1552204800,1),(218,1572764400,2),(218,1583654400,1),(218,1604214000,2),(218,1615708800,1),(218,1636268400,2),(218,1647158400,1),(218,1667718000,2),(218,1678608000,1),(218,1699167600,2),(218,1710057600,1),(218,1730617200,2),(218,1741507200,1),(218,1762066800,2),(218,1772956800,1),(218,1793516400,2),(218,1805011200,1),(218,1825570800,2),(218,1836460800,1),(218,1857020400,2),(218,1867910400,1),(218,1888470000,2),(218,1899360000,1),(218,1919919600,2),(218,1930809600,1),(218,1951369200,2),(218,1962864000,1),(218,1983423600,2),(218,1994313600,1),(218,2014873200,2),(218,2025763200,1),(218,2046322800,2),(218,2057212800,1),(218,2077772400,2),(218,2088662400,1),(218,2109222000,2),(218,2120112000,1),(218,2140671600,2),(219,-2147483648,1),(219,-880203600,2),(219,-769395600,3),(219,-765381600,1),(219,-21474000,4),(219,-5752800,1),(219,9975600,4),(219,25696800,1),(219,41425200,4),(219,57751200,1),(219,73479600,4),(219,89200800,1),(219,104929200,4),(219,120650400,1),(219,126702000,4),(219,152100000,1),(219,162385200,4),(219,183549600,1),(219,199278000,4),(219,215604000,1),(219,230727600,4),(219,247053600,1),(219,262782000,4),(219,278503200,1),(219,294231600,4),(219,309952800,1),(219,325681200,4),(219,341402400,1),(219,357130800,4),(219,372852000,1),(219,388580400,4),(219,404906400,1),(219,420030000,4),(219,436356000,1),(219,439030800,6),(219,452084400,5),(219,467805600,6),(219,483534000,5),(219,499255200,6),(219,514983600,5),(219,530704800,6),(219,544618800,5),(219,562154400,6),(219,576068400,5),(219,594208800,6),(219,607518000,5),(219,625658400,6),(219,638967600,5),(219,657108000,6),(219,671022000,5),(219,688557600,6),(219,702471600,5),(219,720007200,6),(219,733921200,5),(219,752061600,6),(219,765370800,5),(219,783511200,6),(219,796820400,5),(219,814960800,6),(219,828874800,5),(219,846410400,6),(219,860324400,5),(219,877860000,6),(219,891774000,5),(219,909309600,6),(219,923223600,5),(219,941364000,6),(219,954673200,5),(219,972813600,6),(219,986122800,5),(219,1004263200,6),(219,1018177200,5),(219,1035712800,6),(219,1049626800,5),(219,1067162400,6),(219,1081076400,5),(219,1099216800,6),(219,1112526000,5),(219,1130666400,6),(219,1143975600,5),(219,1162116000,6),(219,1173610800,5),(219,1194170400,6),(219,1205060400,5),(219,1225620000,6),(219,1236510000,5),(219,1257069600,6),(219,1268564400,5),(219,1289124000,6),(219,1300014000,5),(219,1320573600,6),(219,1331463600,5),(219,1352023200,6),(219,1362913200,5),(219,1383472800,6),(219,1394362800,5),(219,1414922400,6),(219,1425812400,5),(219,1446372000,6),(219,1457866800,5),(219,1478426400,6),(219,1489316400,5),(219,1509876000,6),(219,1520766000,5),(219,1541325600,6),(219,1552215600,5),(219,1572775200,6),(219,1583665200,5),(219,1604224800,6),(219,1615719600,5),(219,1636279200,6),(219,1647169200,5),(219,1667728800,6),(219,1678618800,5),(219,1699178400,6),(219,1710068400,5),(219,1730628000,6),(219,1741518000,5),(219,1762077600,6),(219,1772967600,5),(219,1793527200,6),(219,1805022000,5),(219,1825581600,6),(219,1836471600,5),(219,1857031200,6),(219,1867921200,5),(219,1888480800,6),(219,1899370800,5),(219,1919930400,6),(219,1930820400,5),(219,1951380000,6),(219,1962874800,5),(219,1983434400,6),(219,1994324400,5),(219,2014884000,6),(219,2025774000,5),(219,2046333600,6),(219,2057223600,5),(219,2077783200,6),(219,2088673200,5),(219,2109232800,6),(219,2120122800,5),(219,2140682400,6),(220,-2147483648,0),(220,-1104537600,3),(220,-880210800,1),(220,-769395600,2),(220,-765388800,3),(220,-147891600,4),(220,-131562000,3),(220,325674000,5),(220,341395200,3),(220,357123600,5),(220,372844800,3),(220,388573200,5),(220,404899200,3),(220,420022800,5),(220,436348800,3),(220,452077200,5),(220,467798400,3),(220,483526800,5),(220,499248000,3),(220,514976400,5),(220,530697600,3),(220,544611600,5),(220,562147200,3),(220,576061200,5),(220,594201600,3),(220,607510800,5),(220,625651200,3),(220,638960400,5),(220,657100800,3),(220,671014800,5),(220,688550400,3),(220,702464400,5),(220,720000000,3),(220,733914000,5),(220,752054400,3),(220,765363600,5),(220,783504000,3),(220,796813200,5),(220,814953600,3),(220,828867600,5),(220,846403200,3),(220,860317200,5),(220,877852800,3),(220,891766800,5),(220,909302400,3),(220,923216400,5),(220,941356800,3),(220,954666000,5),(220,972806400,3),(220,986115600,5),(220,1004256000,3),(220,1018170000,5),(220,1035705600,3),(220,1049619600,5),(220,1067155200,3),(220,1081069200,5),(220,1099209600,3),(220,1112518800,5),(220,1130659200,3),(220,1143968400,5),(220,1162108800,3),(220,1173603600,5),(220,1194163200,3),(220,1205053200,5),(220,1225612800,3),(220,1236502800,5),(220,1257062400,3),(220,1268557200,5),(220,1289116800,3),(220,1300006800,5),(220,1320566400,3),(220,1331456400,5),(220,1352016000,3),(220,1362906000,5),(220,1383465600,3),(220,1394355600,5),(220,1414915200,3),(220,1425805200,5),(220,1446364800,3),(220,1457859600,5),(220,1478419200,3),(220,1489309200,5),(220,1509868800,3),(220,1520758800,5),(220,1541318400,3),(220,1552208400,5),(220,1572768000,3),(220,1583658000,5),(220,1604217600,3),(220,1615712400,5),(220,1636272000,3),(220,1647162000,5),(220,1667721600,3),(220,1678611600,5),(220,1699171200,3),(220,1710061200,5),(220,1730620800,3),(220,1741510800,5),(220,1762070400,3),(220,1772960400,5),(220,1793520000,3),(220,1805014800,5),(220,1825574400,3),(220,1836464400,5),(220,1857024000,3),(220,1867914000,5),(220,1888473600,3),(220,1899363600,5),(220,1919923200,3),(220,1930813200,5),(220,1951372800,3),(220,1962867600,5),(220,1983427200,3),(220,1994317200,5),(220,2014876800,3),(220,2025766800,5),(220,2046326400,3),(220,2057216400,5),(220,2077776000,3),(220,2088666000,5),(220,2109225600,3),(220,2120115600,5),(220,2140675200,3),(221,-2147483648,0),(221,-31536000,1),(221,1255802400,2),(221,1267714800,1),(221,1319738400,2),(221,1329843600,3),(221,1477065600,2),(221,1520701200,1),(221,2147483647,1),(222,-2147483648,0),(222,-409190400,1),(222,-163062000,0),(222,-28857600,1),(222,1255806000,2),(222,1268251200,3),(222,1319742000,2),(222,1329854400,3),(222,2147483647,3),(223,-2147483648,0),(223,-725846400,1),(223,-566992800,0),(223,-415497600,1),(223,2147483647,1),(224,-2147483648,1),(224,-1680508800,2),(224,-1665392400,1),(224,-1601719200,3),(224,-687052800,1),(224,-71136000,4),(224,-55411200,5),(224,-37267200,4),(224,-25776000,5),(224,-5817600,4),(224,5673600,5),(224,25632000,4),(224,37728000,5),(224,57686400,4),(224,67968000,5),(224,89136000,4),(224,100022400,5),(224,120585600,4),(224,131472000,5),(224,152035200,4),(224,162921600,5),(224,183484800,4),(224,194976000,5),(224,215539200,4),(224,226425600,5),(224,246988800,4),(224,257875200,5),(224,278438400,4),(224,289324800,5),(224,309888000,4),(224,320774400,5),(224,341337600,4),(224,352224000,5),(224,372787200,4),(224,386092800,5),(224,404841600,4),(224,417542400,5),(224,436291200,4),(224,447177600,5),(224,467740800,4),(224,478627200,5),(224,499190400,4),(224,510076800,5),(224,530035200,4),(224,542736000,5),(224,562089600,4),(224,574790400,5),(224,594144000,4),(224,606240000,5),(224,625593600,4),(224,637689600,5),(224,657043200,4),(224,670348800,5),(224,686678400,4),(224,701798400,5),(224,718128000,4),(224,733248000,5),(224,749577600,4),(224,764697600,5),(224,781027200,4),(224,796147200,5),(224,812476800,4),(224,828201600,5),(224,844531200,4),(224,859651200,5),(224,875980800,4),(224,891100800,5),(224,907430400,4),(224,922550400,5),(224,938880000,4),(224,954000000,5),(224,967305600,4),(224,985449600,5),(224,1002384000,4),(224,1017504000,5),(224,1033833600,4),(224,1048953600,5),(224,1065283200,4),(224,1080403200,5),(224,1096732800,4),(224,1111852800,5),(224,1128182400,4),(224,1143907200,5),(224,1159632000,4),(224,1174752000,5),(224,1191686400,4),(224,1207411200,5),(224,1223136000,4),(224,1238860800,5),(224,1254585600,4),(224,1270310400,6),(224,2147483647,6),(225,-2147483648,0),(225,-501206400,1),(225,1255809600,2),(225,2147483647,2),(226,-2147483648,2),(226,-1330335000,1),(226,-1320057000,2),(226,-1300699800,3),(226,-1287396000,2),(226,-1269250200,3),(226,-1255946400,2),(226,-1237800600,3),(226,-1224496800,2),(226,-1206351000,3),(226,-1192442400,2),(226,-1174901400,3),(226,-1160992800,2),(226,-1143451800,3),(226,-1125914400,2),(226,-1112607000,3),(226,-1094464800,2),(226,-1081157400,3),(226,-1063015200,2),(226,-1049707800,3),(226,-1031565600,2),(226,-1018258200,3),(226,-1000116000,2),(226,-986808600,3),(226,-968061600,2),(226,-955359000,3),(226,-936612000,2),(226,-923304600,3),(226,-757425600,6),(226,152632800,4),(226,162309600,5),(226,183477600,4),(226,194968800,5),(226,215532000,4),(226,226418400,5),(226,246981600,4),(226,257868000,5),(226,278431200,4),(226,289317600,5),(226,309880800,4),(226,320767200,5),(226,341330400,4),(226,352216800,5),(226,372780000,4),(226,384271200,5),(226,404834400,4),(226,415720800,5),(226,436284000,4),(226,447170400,5),(226,467733600,4),(226,478620000,5),(226,499183200,4),(226,510069600,5),(226,530632800,4),(226,541519200,5),(226,562082400,4),(226,573573600,5),(226,594136800,4),(226,605023200,5),(226,623772000,4),(226,637682400,5),(226,655221600,4),(226,669132000,5),(226,686671200,4),(226,700581600,5),(226,718120800,4),(226,732636000,5),(226,749570400,4),(226,764085600,5),(226,781020000,4),(226,795535200,5),(226,812469600,4),(226,826984800,5),(226,844524000,4),(226,858434400,5),(226,875973600,4),(226,889884000,5),(226,907423200,4),(226,921938400,5),(226,938872800,4),(226,953388000,5),(226,970322400,4),(226,984837600,5),(226,1002376800,4),(226,1016287200,5),(226,1033826400,4),(226,1047736800,5),(226,1065276000,4),(226,1079791200,5),(226,1096725600,4),(226,1111240800,5),(226,1128175200,4),(226,1142690400,5),(226,1159624800,4),(226,1174140000,5),(226,1191074400,4),(226,1207404000,5),(226,1222524000,4),(226,1238853600,5),(226,1253973600,4),(226,1270303200,5),(226,1285423200,4),(226,1301752800,5),(226,1316872800,4),(226,1333202400,5),(226,1348927200,4),(226,1365256800,5),(226,1380376800,4),(226,1396706400,5),(226,1411826400,4),(226,1428156000,5),(226,1443276000,4),(226,1459605600,5),(226,1474725600,4),(226,1491055200,5),(226,1506175200,4),(226,1522504800,5),(226,1538229600,4),(226,1554559200,5),(226,1569679200,4),(226,1586008800,5),(226,1601128800,4),(226,1617458400,5),(226,1632578400,4),(226,1648908000,5),(226,1664028000,4),(226,1680357600,5),(226,1695477600,4),(226,1712412000,5),(226,1727532000,4),(226,1743861600,5),(226,1758981600,4),(226,1775311200,5),(226,1790431200,4),(226,1806760800,5),(226,1821880800,4),(226,1838210400,5),(226,1853330400,4),(226,1869660000,5),(226,1885384800,4),(226,1901714400,5),(226,1916834400,4),(226,1933164000,5),(226,1948284000,4),(226,1964613600,5),(226,1979733600,4),(226,1996063200,5),(226,2011183200,4),(226,2027512800,5),(226,2042632800,4),(226,2058962400,5),(226,2074687200,4),(226,2091016800,5),(226,2106136800,4),(226,2122466400,5),(226,2137586400,4),(227,-2147483648,0),(227,-157766400,2),(227,-152658000,1),(227,-132955200,2),(227,-121122000,1),(227,-101419200,2),(227,-86821200,1),(227,-71092800,2),(227,-54766800,1),(227,-39038400,2),(227,-23317200,1),(227,-7588800,4),(227,128142000,3),(227,136605600,4),(227,389070000,1),(227,403070400,5),(227,416372400,6),(227,434520000,5),(227,447822000,6),(227,466574400,5),(227,479271600,6),(227,498024000,5),(227,510721200,6),(227,529473600,5),(227,545194800,6),(227,560923200,5),(227,574225200,6),(227,592372800,5),(227,605674800,6),(227,624427200,5),(227,637124400,6),(227,653457600,5),(227,668574000,6),(227,687326400,5),(227,700628400,6),(227,718776000,5),(227,732078000,6),(227,750225600,5),(227,763527600,6),(227,781675200,5),(227,794977200,6),(227,813729600,5),(227,826426800,6),(227,845179200,5),(227,859690800,6),(227,876628800,5),(227,889930800,6),(227,906868800,5),(227,923194800,6),(227,939528000,5),(227,952830000,6),(227,971582400,5),(227,984279600,6),(227,1003032000,5),(227,1015729200,6),(227,1034481600,5),(227,1047178800,6),(227,1065931200,5),(227,1079233200,6),(227,1097380800,5),(227,1110682800,6),(227,1128830400,5),(227,1142132400,6),(227,1160884800,5),(227,1173582000,6),(227,1192334400,5),(227,1206846000,6),(227,1223784000,5),(227,1237086000,6),(227,1255233600,5),(227,1270350000,6),(227,1286683200,5),(227,1304823600,6),(227,1313899200,5),(227,1335668400,6),(227,1346558400,5),(227,1367118000,6),(227,1378612800,5),(227,1398567600,6),(227,1410062400,5),(227,1463281200,6),(227,1471147200,5),(227,1480820400,4),(227,2147483647,4),(228,-2147483648,0),(228,218246400,1),(228,2147483647,1),(229,-2147483648,2),(229,-1330335000,1),(229,-1320057000,2),(229,-1300699800,3),(229,-1287396000,2),(229,-1269250200,3),(229,-1255946400,2),(229,-1237800600,3),(229,-1224496800,2),(229,-1206351000,3),(229,-1192442400,2),(229,-1174901400,3),(229,-1160992800,2),(229,-1143451800,3),(229,-1125914400,2),(229,-1112607000,3),(229,-1094464800,2),(229,-1081157400,3),(229,-1063015200,2),(229,-1049707800,3),(229,-1031565600,2),(229,-1018258200,3),(229,-1000116000,2),(229,-986808600,3),(229,-968061600,2),(229,-955359000,3),(229,-936612000,2),(229,-923304600,3),(229,-757425600,6),(229,152632800,4),(229,162309600,5),(229,183477600,4),(229,194968800,5),(229,215532000,4),(229,226418400,5),(229,246981600,4),(229,257868000,5),(229,278431200,4),(229,289317600,5),(229,309880800,4),(229,320767200,5),(229,341330400,4),(229,352216800,5),(229,372780000,4),(229,384271200,5),(229,404834400,4),(229,415720800,5),(229,436284000,4),(229,447170400,5),(229,467733600,4),(229,478620000,5),(229,499183200,4),(229,510069600,5),(229,530632800,4),(229,541519200,5),(229,562082400,4),(229,573573600,5),(229,594136800,4),(229,605023200,5),(229,623772000,4),(229,637682400,5),(229,655221600,4),(229,669132000,5),(229,686671200,4),(229,700581600,5),(229,718120800,4),(229,732636000,5),(229,749570400,4),(229,764085600,5),(229,781020000,4),(229,795535200,5),(229,812469600,4),(229,826984800,5),(229,844524000,4),(229,858434400,5),(229,875973600,4),(229,889884000,5),(229,907423200,4),(229,921938400,5),(229,938872800,4),(229,953388000,5),(229,970322400,4),(229,984837600,5),(229,1002376800,4),(229,1016287200,5),(229,1033826400,4),(229,1047736800,5),(229,1065276000,4),(229,1079791200,5),(229,1096725600,4),(229,1111240800,5),(229,1128175200,4),(229,1142690400,5),(229,1159624800,4),(229,1174140000,5),(229,1191074400,4),(229,1207404000,5),(229,1222524000,4),(229,1238853600,5),(229,1253973600,4),(229,1270303200,5),(229,1285423200,4),(229,1301752800,5),(229,1316872800,4),(229,1333202400,5),(229,1348927200,4),(229,1365256800,5),(229,1380376800,4),(229,1396706400,5),(229,1411826400,4),(229,1428156000,5),(229,1443276000,4),(229,1459605600,5),(229,1474725600,4),(229,1491055200,5),(229,1506175200,4),(229,1522504800,5),(229,1538229600,4),(229,1554559200,5),(229,1569679200,4),(229,1586008800,5),(229,1601128800,4),(229,1617458400,5),(229,1632578400,4),(229,1648908000,5),(229,1664028000,4),(229,1680357600,5),(229,1695477600,4),(229,1712412000,5),(229,1727532000,4),(229,1743861600,5),(229,1758981600,4),(229,1775311200,5),(229,1790431200,4),(229,1806760800,5),(229,1821880800,4),(229,1838210400,5),(229,1853330400,4),(229,1869660000,5),(229,1885384800,4),(229,1901714400,5),(229,1916834400,4),(229,1933164000,5),(229,1948284000,4),(229,1964613600,5),(229,1979733600,4),(229,1996063200,5),(229,2011183200,4),(229,2027512800,5),(229,2042632800,4),(229,2058962400,5),(229,2074687200,4),(229,2091016800,5),(229,2106136800,4),(229,2122466400,5),(229,2137586400,4),(230,-2147483648,0),(230,-407808000,1),(230,2147483647,1),(231,-2147483648,0),(231,1108166400,3),(231,1111885200,1),(231,1130634000,2),(231,1143334800,1),(231,1162083600,2),(231,1174784400,1),(231,1193533200,2),(231,1206838800,1),(231,1224982800,2),(231,1238288400,1),(231,1256432400,2),(231,1269738000,1),(231,1288486800,2),(231,1301187600,1),(231,1319936400,2),(231,1332637200,1),(231,1351386000,2),(231,1364691600,1),(231,1382835600,2),(231,1396141200,1),(231,1414285200,2),(231,1427590800,1),(231,1445734800,2),(231,1459040400,1),(231,1477789200,2),(231,1490490000,1),(231,1509238800,2),(231,1521939600,1),(231,1540688400,2),(231,1553994000,1),(231,1572138000,2),(231,1585443600,1),(231,1603587600,2),(231,1616893200,1),(231,1635642000,2),(231,1648342800,1),(231,1667091600,2),(231,1679792400,1),(231,1698541200,2),(231,1711846800,1),(231,1729990800,2),(231,1743296400,1),(231,1761440400,2),(231,1774746000,1),(231,1792890000,2),(231,1806195600,1),(231,1824944400,2),(231,1837645200,1),(231,1856394000,2),(231,1869094800,1),(231,1887843600,2),(231,1901149200,1),(231,1919293200,2),(231,1932598800,1),(231,1950742800,2),(231,1964048400,1),(231,1982797200,2),(231,1995498000,1),(231,2014246800,2),(231,2026947600,1),(231,2045696400,2),(231,2058397200,1),(231,2077146000,2),(231,2090451600,1),(231,2108595600,2),(231,2121901200,1),(231,2140045200,2),(231,2147483647,2),(232,-2147483648,0),(232,-380073600,1),(232,2147483647,1),(233,-2147483648,2),(233,-1691884800,1),(233,-1680573600,2),(233,-927511200,1),(233,-857257200,3),(233,-844556400,4),(233,-828226800,3),(233,-812502000,4),(233,-796777200,3),(233,-781052400,4),(233,-765327600,3),(233,-340844400,4),(233,-324514800,3),(233,-308790000,4),(233,-293065200,3),(233,-277340400,4),(233,-261615600,3),(233,-245890800,4),(233,-230166000,3),(233,-214441200,4),(233,-198716400,3),(233,-182991600,4),(233,-166662000,3),(233,-147913200,4),(233,-135212400,3),(233,315529200,2),(233,323830800,5),(233,338950800,6),(233,354675600,5),(233,370400400,6),(233,386125200,5),(233,401850000,6),(233,417574800,5),(233,433299600,6),(233,449024400,5),(233,465354000,6),(233,481078800,5),(233,496803600,6),(233,512528400,5),(233,528253200,6),(233,543978000,5),(233,559702800,6),(233,575427600,5),(233,591152400,6),(233,606877200,5),(233,622602000,6),(233,638326800,5),(233,654656400,6),(233,670381200,5),(233,686106000,6),(233,701830800,5),(233,717555600,6),(233,733280400,5),(233,749005200,6),(233,764730000,5),(233,780454800,6),(233,796179600,5),(233,811904400,6),(233,828234000,5),(233,846378000,6),(233,859683600,5),(233,877827600,6),(233,891133200,5),(233,909277200,6),(233,922582800,5),(233,941331600,6),(233,954032400,5),(233,972781200,6),(233,985482000,5),(233,1004230800,6),(233,1017536400,5),(233,1035680400,6),(233,1048986000,5),(233,1067130000,6),(233,1080435600,5),(233,1099184400,6),(233,1111885200,5),(233,1130634000,6),(233,1143334800,5),(233,1162083600,6),(233,1174784400,5),(233,1193533200,6),(233,1206838800,5),(233,1224982800,6),(233,1238288400,5),(233,1256432400,6),(233,1269738000,5),(233,1288486800,6),(233,1301187600,5),(233,1319936400,6),(233,1332637200,5),(233,1351386000,6),(233,1364691600,5),(233,1382835600,6),(233,1396141200,5),(233,1414285200,6),(233,1427590800,5),(233,1445734800,6),(233,1459040400,5),(233,1477789200,6),(233,1490490000,5),(233,1509238800,6),(233,1521939600,5),(233,1540688400,6),(233,1553994000,5),(233,1572138000,6),(233,1585443600,5),(233,1603587600,6),(233,1616893200,5),(233,1635642000,6),(233,1648342800,5),(233,1667091600,6),(233,1679792400,5),(233,1698541200,6),(233,1711846800,5),(233,1729990800,6),(233,1743296400,5),(233,1761440400,6),(233,1774746000,5),(233,1792890000,6),(233,1806195600,5),(233,1824944400,6),(233,1837645200,5),(233,1856394000,6),(233,1869094800,5),(233,1887843600,6),(233,1901149200,5),(233,1919293200,6),(233,1932598800,5),(233,1950742800,6),(233,1964048400,5),(233,1982797200,6),(233,1995498000,5),(233,2014246800,6),(233,2026947600,5),(233,2045696400,6),(233,2058397200,5),(233,2077146000,6),(233,2090451600,5),(233,2108595600,6),(233,2121901200,5),(233,2140045200,6),(234,-2147483648,0),(234,-719636812,1),(234,2147483647,1),(235,-2147483648,0),(235,-1441170468,1),(235,-1247547600,3),(235,354909600,2),(235,370717200,3),(235,386445600,2),(235,402253200,3),(235,417981600,2),(235,433789200,3),(235,449604000,2),(235,465336000,4),(235,481060800,5),(235,496785600,4),(235,512510400,5),(235,528235200,4),(235,543960000,5),(235,559684800,4),(235,575409600,5),(235,591134400,4),(235,606859200,5),(235,622584000,4),(235,638308800,5),(235,654638400,4),(235,670363200,6),(235,686091600,7),(235,695768400,4),(235,701812800,5),(235,717537600,4),(235,733262400,5),(235,748987200,4),(235,764712000,5),(235,780436800,4),(235,796161600,5),(235,811886400,4),(235,828216000,5),(235,846360000,4),(235,859665600,5),(235,877809600,4),(235,891115200,5),(235,909259200,4),(235,922564800,5),(235,941313600,4),(235,954014400,5),(235,972763200,4),(235,985464000,5),(235,1004212800,4),(235,1017518400,5),(235,1035662400,4),(235,1048968000,5),(235,1067112000,4),(235,1080417600,5),(235,1099166400,4),(235,2147483647,4),(236,-2147483648,0),(236,-1230776624,2),(236,108165600,1),(236,118270800,2),(236,136591200,1),(236,149806800,2),(236,168127200,1),(236,181342800,2),(236,199749600,1),(236,215643600,2),(236,231285600,1),(236,244501200,2),(236,262735200,1),(236,275950800,2),(236,481154400,1),(236,496962000,2),(236,512949600,1),(236,528670800,2),(236,544399200,1),(236,560120400,2),(236,575848800,1),(236,592174800,2),(236,610581600,1),(236,623624400,2),(236,641167200,1),(236,655074000,2),(236,671839200,1),(236,685918800,2),(236,702856800,1),(236,717973200,2),(236,733701600,1),(236,749422800,2),(236,765151200,1),(236,779662800,2),(236,797205600,1),(236,811116000,3),(236,828655200,1),(236,843170400,3),(236,860104800,1),(236,874620000,3),(236,891554400,1),(236,906069600,3),(236,930780000,4),(236,938124000,3),(236,954367200,4),(236,970178400,3),(236,985816800,4),(236,1001628000,3),(236,1017352800,1),(236,1033077600,3),(236,1048802400,1),(236,1066946400,3),(236,1080252000,1),(236,1097791200,3),(236,1112306400,1),(236,1128031200,3),(236,1143756000,1),(236,1161900000,3),(236,1175205600,1),(236,1193349600,3),(236,1206655200,1),(236,1225404000,3),(236,1238104800,1),(236,1256853600,3),(236,1269554400,1),(236,1288303200,3),(236,1301608800,1),(236,1319752800,3),(236,1333058400,1),(236,1387486800,2),(236,1395957600,1),(236,1414706400,3),(236,1427407200,1),(236,1446156000,3),(236,1459461600,1),(236,1477605600,3),(236,1490911200,1),(236,1509055200,3),(236,1522360800,1),(236,1540504800,3),(236,1553810400,1),(236,1571954400,3),(236,1585260000,1),(236,1604008800,3),(236,1616709600,1),(236,1635458400,3),(236,1648764000,1),(236,1666908000,3),(236,1680213600,1),(236,1698357600,3),(236,1711663200,1),(236,1729807200,3),(236,1743112800,1),(236,1761861600,3),(236,1774562400,1),(236,1793311200,3),(236,1806012000,1),(236,1824760800,3),(236,1838066400,1),(236,1856210400,3),(236,1869516000,1),(236,1887660000,3),(236,1900965600,1),(236,1919109600,3),(236,1932415200,1),(236,1951164000,3),(236,1963864800,1),(236,1982613600,3),(236,1995919200,1),(236,2014063200,3),(236,2027368800,1),(236,2045512800,3),(236,2058818400,1),(236,2076962400,3),(236,2090268000,1),(236,2109016800,3),(236,2121717600,1),(236,2140466400,3),(237,-2147483648,0),(237,-1441194596,1),(237,-1247572800,3),(237,354884400,2),(237,370692000,3),(237,386420400,4),(237,402231600,1),(237,417960000,4),(237,433767600,1),(237,449582400,4),(237,465314400,5),(237,481039200,6),(237,496764000,5),(237,512488800,6),(237,528213600,5),(237,543938400,6),(237,559663200,5),(237,575388000,6),(237,591112800,5),(237,606837600,6),(237,622562400,5),(237,638287200,6),(237,654616800,5),(237,670341600,7),(237,686070000,8),(237,695746800,5),(237,701791200,6),(237,717516000,5),(237,733240800,6),(237,748965600,5),(237,764690400,6),(237,780415200,5),(237,796140000,6),(237,811864800,5),(237,828194400,6),(237,846338400,5),(237,859644000,6),(237,877788000,5),(237,891093600,6),(237,909237600,5),(237,922543200,6),(237,941292000,5),(237,953992800,6),(237,972741600,5),(237,985442400,6),(237,1004191200,5),(237,1017496800,6),(237,1035640800,5),(237,1048946400,6),(237,1067090400,5),(237,1080396000,6),(237,1099144800,5),(237,1111845600,6),(237,1130594400,5),(237,1143295200,6),(237,1162044000,5),(237,1174744800,6),(237,1193493600,5),(237,1206799200,6),(237,1224943200,5),(237,1238248800,6),(237,1256392800,5),(237,1269698400,7),(237,1288450800,8),(237,1301151600,5),(237,2147483647,5),(238,-2147483648,0),(238,-1441164064,1),(238,-1247544000,2),(238,370724400,3),(238,386445600,4),(238,402256800,2),(238,417985200,4),(238,433792800,2),(238,449607600,4),(238,465339600,5),(238,481064400,6),(238,496789200,5),(238,512514000,6),(238,528238800,5),(238,543963600,6),(238,559688400,5),(238,575413200,6),(238,591138000,5),(238,606862800,6),(238,622587600,5),(238,638312400,6),(238,654642000,5),(238,670366800,7),(238,686095200,8),(238,695772000,5),(238,701816400,6),(238,717541200,5),(238,733266000,6),(238,748990800,5),(238,764715600,6),(238,780440400,8),(238,796168800,7),(238,811893600,8),(238,828223200,7),(238,846367200,8),(238,859672800,7),(238,877816800,8),(238,891122400,7),(238,909266400,8),(238,922572000,7),(238,941320800,8),(238,954021600,7),(238,972770400,8),(238,985471200,7),(238,1004220000,8),(238,1017525600,7),(238,1035669600,8),(238,1048975200,7),(238,1067119200,8),(238,1080424800,7),(238,1099173600,5),(238,2147483647,5),(239,-2147483648,0),(239,-1441165720,1),(239,-1247544000,2),(239,354913200,3),(239,370720800,4),(239,386445600,3),(239,402256800,2),(239,417985200,3),(239,433792800,2),(239,449607600,3),(239,465339600,5),(239,481064400,6),(239,496789200,5),(239,512514000,6),(239,528238800,5),(239,543963600,6),(239,559688400,5),(239,575413200,6),(239,591138000,5),(239,606862800,6),(239,622587600,5),(239,638312400,6),(239,654642000,5),(239,670366800,7),(239,686095200,8),(239,695772000,5),(239,701816400,6),(239,717541200,5),(239,733266000,6),(239,748990800,5),(239,764715600,6),(239,780440400,5),(239,796165200,6),(239,811890000,5),(239,828219600,6),(239,846363600,5),(239,859669200,6),(239,877813200,5),(239,891118800,6),(239,909262800,5),(239,922568400,6),(239,941317200,5),(239,954018000,6),(239,972766800,5),(239,985467600,6),(239,1004216400,5),(239,1017522000,6),(239,1035666000,5),(239,1048971600,6),(239,1067115600,5),(239,1080421200,6),(239,1099170000,5),(239,2147483647,5),(240,-2147483648,0),(240,-1441166012,1),(240,-1247544000,3),(240,354913200,2),(240,370720800,3),(240,386449200,2),(240,402256800,3),(240,417985200,2),(240,433792800,3),(240,449607600,2),(240,465339600,4),(240,481064400,5),(240,496789200,4),(240,512514000,5),(240,528238800,4),(240,543963600,5),(240,559688400,4),(240,575413200,5),(240,591138000,4),(240,606862800,5),(240,622587600,4),(240,638312400,5),(240,654642000,4),(240,670366800,6),(240,686095200,7),(240,695772000,3),(240,2147483647,3),(241,-2147483648,0),(241,-1441166012,1),(241,-1247544000,3),(241,354913200,2),(241,370720800,3),(241,386449200,2),(241,402256800,3),(241,417985200,2),(241,433792800,3),(241,449607600,2),(241,465339600,4),(241,481064400,5),(241,496789200,4),(241,512514000,5),(241,528238800,4),(241,543963600,5),(241,559688400,4),(241,575413200,5),(241,591138000,4),(241,606862800,5),(241,622587600,4),(241,638312400,5),(241,654642000,4),(241,670366800,6),(241,686095200,7),(241,695772000,3),(241,2147483647,3),(242,-2147483648,0),(242,-1441164464,1),(242,-1247540400,2),(242,370724400,3),(242,386445600,4),(242,402256800,2),(242,417985200,4),(242,433792800,2),(242,449607600,4),(242,465339600,5),(242,481064400,6),(242,496789200,5),(242,512514000,6),(242,528238800,5),(242,543963600,6),(242,559688400,5),(242,575413200,6),(242,591138000,5),(242,606862800,6),(242,622587600,5),(242,638312400,6),(242,654642000,5),(242,670366800,7),(242,686095200,8),(242,695772000,5),(242,701816400,6),(242,717541200,5),(242,733266000,6),(242,748990800,5),(242,764715600,6),(242,780440400,5),(242,796165200,6),(242,811890000,5),(242,828219600,6),(242,846363600,5),(242,859669200,6),(242,877813200,5),(242,891118800,6),(242,909262800,5),(242,922568400,7),(242,941320800,8),(242,954021600,7),(242,972770400,8),(242,985471200,7),(242,1004220000,8),(242,1017525600,7),(242,1035669600,8),(242,1048975200,7),(242,1067119200,8),(242,1080424800,7),(242,1099173600,5),(242,2147483647,5),(243,-2147483648,1),(243,-1641005856,2),(243,389048400,3),(243,402264000,2),(243,417906000,3),(243,433800000,2),(243,449614800,3),(243,465422400,2),(243,481150800,3),(243,496792800,4),(243,512517600,5),(243,528242400,4),(243,543967200,5),(243,559692000,4),(243,575416800,5),(243,591141600,4),(243,606866400,5),(243,622591200,4),(243,638316000,5),(243,654645600,4),(243,670464000,5),(243,686275200,4),(243,702086400,5),(243,717897600,4),(243,733622400,5),(243,749433600,4),(243,765158400,5),(243,780969600,4),(243,796694400,5),(243,812505600,4),(243,828316800,5),(243,844128000,4),(243,859852800,5),(243,875664000,4),(243,891388800,5),(243,907200000,4),(243,922924800,5),(243,938736000,4),(243,954547200,5),(243,970358400,4),(243,986083200,5),(243,1001894400,4),(243,1017619200,5),(243,1033430400,4),(243,1049155200,5),(243,1064966400,4),(243,1080777600,5),(243,1096588800,4),(243,1112313600,5),(243,1128124800,4),(243,1143849600,5),(243,1159660800,4),(243,1175385600,5),(243,1191196800,4),(243,2147483647,4),(244,-2147483648,0),(244,-1577935568,1),(244,76190400,2),(244,2147483647,2),(245,-2147483648,0),(245,-1441163964,1),(245,-405140400,3),(245,354916800,2),(245,370724400,3),(245,386452800,2),(245,402260400,3),(245,417988800,2),(245,433796400,3),(245,449611200,2),(245,465343200,4),(245,481068000,5),(245,496792800,4),(245,512517600,5),(245,528242400,4),(245,543967200,5),(245,559692000,4),(245,575416800,5),(245,591141600,4),(245,606866400,5),(245,622591200,4),(245,638316000,5),(245,654645600,4),(245,670370400,6),(245,686098800,7),(245,701823600,6),(245,717548400,4),(245,820440000,3),(245,828234000,8),(245,846378000,9),(245,852062400,3),(245,859680000,2),(245,877824000,3),(245,891129600,2),(245,909273600,3),(245,922579200,2),(245,941328000,3),(245,954028800,2),(245,972777600,3),(245,985478400,2),(245,1004227200,3),(245,1017532800,2),(245,1035676800,3),(245,1048982400,2),(245,1067126400,3),(245,1080432000,2),(245,1099180800,3),(245,1111881600,2),(245,1130630400,3),(245,1143331200,2),(245,1162080000,3),(245,1174780800,2),(245,1193529600,3),(245,1206835200,2),(245,1224979200,3),(245,1238284800,2),(245,1256428800,3),(245,1269734400,2),(245,1288483200,3),(245,1301184000,2),(245,1319932800,3),(245,1332633600,2),(245,1351382400,3),(245,1364688000,2),(245,1382832000,3),(245,1396137600,2),(245,1414281600,3),(245,1427587200,2),(245,1445731200,3),(245,2147483647,3),(246,-2147483648,1),(246,-1570084924,2),(246,2147483647,2),(247,-2147483648,0),(247,-1579844100,1),(247,-1247551200,3),(247,354906000,2),(247,370713600,3),(247,386442000,2),(247,402249600,3),(247,417978000,2),(247,433785600,3),(247,449600400,2),(247,465332400,4),(247,481057200,5),(247,496782000,4),(247,512506800,5),(247,528231600,4),(247,543956400,5),(247,559681200,4),(247,575406000,5),(247,591130800,4),(247,606855600,5),(247,622580400,4),(247,638305200,5),(247,654634800,4),(247,670359600,6),(247,686088000,7),(247,695764800,4),(247,701809200,5),(247,717534000,4),(247,733258800,5),(247,748983600,4),(247,764708400,5),(247,780433200,4),(247,796158000,5),(247,801590400,8),(247,811886400,7),(247,828216000,6),(247,846360000,7),(247,859665600,6),(247,877809600,7),(247,891115200,6),(247,909259200,7),(247,922564800,6),(247,941313600,7),(247,954014400,6),(247,972763200,7),(247,985464000,6),(247,1004212800,7),(247,1017518400,6),(247,1035662400,7),(247,1048968000,6),(247,1067112000,7),(247,1080417600,6),(247,1099166400,7),(247,1111867200,6),(247,1130616000,7),(247,1143316800,6),(247,1162065600,7),(247,1174766400,6),(247,1193515200,7),(247,1206820800,6),(247,1224964800,7),(247,1238270400,6),(247,1256414400,7),(247,1269720000,6),(247,1288468800,7),(247,1301169600,4),(247,1414263600,7),(247,1459022400,4),(247,2147483647,4),(248,-2147483648,2),(248,-1570413600,1),(248,-1552186800,2),(248,-1538359200,1),(248,-1522551600,2),(248,-1507514400,1),(248,-1490583600,2),(248,-1473645600,1),(248,-1460948400,2),(248,-399866400,1),(248,-386650800,2),(248,-368330400,1),(248,-355114800,2),(248,-336794400,1),(248,-323578800,2),(248,-305172000,1),(248,-291956400,2),(248,-273636000,1),(248,-260420400,2),(248,78012000,1),(248,86734800,2),(248,105055200,1),(248,118270800,2),(248,136591200,1),(248,149806800,2),(248,168127200,1),(248,181342800,2),(248,199749600,1),(248,212965200,2),(248,231285600,1),(248,244501200,2),(248,262735200,1),(248,275950800,2),(248,452210400,1),(248,466722000,2),(248,483746400,1),(248,498258000,2),(248,515282400,1),(248,529794000,2),(248,546818400,1),(248,561330000,2),(248,581119200,1),(248,592952400,2),(248,610754400,1),(248,624488400,2),(248,641512800,1),(248,656024400,2),(248,673048800,1),(248,687560400,2),(248,704671200,1),(248,718146000,2),(248,733269600,1),(248,748990800,2),(248,764719200,1),(248,780440400,2),(248,796168800,1),(248,811890000,2),(248,828223200,1),(248,843944400,2),(248,859672800,1),(248,875394000,2),(248,891122400,1),(248,906843600,2),(248,922572000,1),(248,941317200,2),(248,954021600,1),(248,972766800,2),(248,985471200,1),(248,1004216400,2),(248,1017525600,1),(248,1035666000,2),(248,1048975200,1),(248,1067115600,2),(248,1080424800,1),(248,1099170000,2),(248,1111874400,1),(248,1130619600,2),(248,1143324000,1),(248,1162069200,2),(248,1174773600,1),(248,1193518800,2),(248,1206828000,1),(248,1224968400,2),(248,1238277600,1),(248,1256418000,2),(248,1269727200,1),(248,1288472400,2),(248,1301176800,1),(248,1319922000,2),(248,1332626400,1),(248,1351371600,2),(248,1364680800,1),(248,1382821200,2),(248,1396130400,1),(248,1414270800,2),(248,1427580000,1),(248,1445720400,2),(248,1459029600,1),(248,1477774800,2),(248,1490479200,1),(248,1509224400,2),(248,1521928800,1),(248,1540674000,2),(248,1553983200,1),(248,1572123600,2),(248,1585432800,1),(248,1603573200,2),(248,1616882400,1),(248,1635627600,2),(248,1648332000,1),(248,1667077200,2),(248,1679781600,1),(248,1698526800,2),(248,1711836000,1),(248,1729976400,2),(248,1743285600,1),(248,1761426000,2),(248,1774735200,1),(248,1792875600,2),(248,1806184800,1),(248,1824930000,2),(248,1837634400,1),(248,1856379600,2),(248,1869084000,1),(248,1887829200,2),(248,1901138400,1),(248,1919278800,2),(248,1932588000,1),(248,1950728400,2),(248,1964037600,1),(248,1982782800,2),(248,1995487200,1),(248,2014232400,2),(248,2026936800,1),(248,2045682000,2),(248,2058386400,1),(248,2077131600,2),(248,2090440800,1),(248,2108581200,2),(248,2121890400,1),(248,2140030800,2),(249,-2147483648,0),(249,-1441169904,1),(249,-1247547600,3),(249,354909600,2),(249,370717200,3),(249,386445600,2),(249,402253200,3),(249,417981600,2),(249,433789200,3),(249,449604000,2),(249,465336000,4),(249,481060800,5),(249,496785600,4),(249,512510400,5),(249,528235200,4),(249,543960000,5),(249,559684800,4),(249,575409600,5),(249,591134400,4),(249,606859200,5),(249,622584000,4),(249,638308800,5),(249,654638400,4),(249,670363200,6),(249,683582400,1),(249,703018800,6),(249,717530400,1),(249,734468400,6),(249,748980000,1),(249,765918000,6),(249,780429600,1),(249,797367600,6),(249,811879200,1),(249,828817200,6),(249,843933600,1),(249,859671000,8),(249,877811400,1),(249,891120600,8),(249,909261000,1),(249,922570200,8),(249,941315400,1),(249,954019800,8),(249,972765000,1),(249,985469400,8),(249,1004214600,1),(249,1017523800,8),(249,1035664200,1),(249,1048973400,8),(249,1067113800,1),(249,1080423000,8),(249,1099168200,1),(249,1111872600,8),(249,1123783200,3),(249,2147483647,3),(250,-2147483648,0),(250,-1383464380,1),(250,-1167636600,2),(250,2147483647,2),(251,-2147483648,1),(251,-2019705670,2),(251,-891581400,3),(251,-872058600,2),(251,-862637400,3),(251,-764145000,2),(252,-2147483648,0),(252,-1579419232,1),(252,-1247558400,3),(252,354898800,2),(252,370706400,3),(252,386434800,2),(252,402242400,3),(252,417970800,2),(252,433778400,3),(252,449593200,2),(252,465325200,4),(252,481050000,5),(252,496774800,4),(252,512499600,5),(252,528224400,4),(252,543949200,5),(252,559674000,4),(252,575398800,5),(252,591123600,4),(252,606848400,5),(252,622573200,4),(252,638298000,5),(252,654627600,4),(252,670352400,6),(252,686080800,7),(252,695757600,4),(252,701802000,5),(252,717526800,4),(252,733251600,5),(252,748976400,4),(252,764701200,5),(252,780426000,4),(252,796150800,5),(252,811875600,4),(252,828205200,5),(252,846349200,4),(252,859654800,5),(252,877798800,4),(252,891104400,5),(252,909248400,4),(252,922554000,5),(252,941302800,4),(252,954003600,5),(252,972752400,4),(252,985453200,5),(252,1004202000,4),(252,1017507600,5),(252,1035651600,4),(252,1048957200,5),(252,1067101200,4),(252,1080406800,5),(252,1099155600,4),(252,1111856400,5),(252,1130605200,4),(252,1143306000,5),(252,1162054800,4),(252,1174755600,5),(252,1193504400,4),(252,1206810000,5),(252,1224954000,4),(252,1238259600,5),(252,1256403600,4),(252,1269709200,5),(252,1288458000,4),(252,1301158800,8),(252,1414252800,7),(252,1459015200,3),(252,2147483647,3),(253,-2147483648,0),(253,-2032933080,1),(253,252435600,2),(253,417974400,4),(253,433778400,3),(253,449593200,4),(253,465314400,3),(253,481042800,4),(253,496764000,3),(253,512492400,4),(253,528213600,3),(253,543942000,4),(253,559663200,3),(253,575391600,4),(253,591112800,3),(253,606841200,4),(253,622562400,3),(253,638290800,4),(253,654616800,3),(253,670345200,4),(253,686066400,3),(253,701794800,4),(253,717516000,3),(253,733244400,4),(253,748965600,3),(253,764694000,4),(253,780415200,3),(253,796143600,4),(253,811864800,3),(253,828198000,4),(253,843919200,3),(253,859647600,4),(253,875368800,3),(253,891097200,4),(253,906818400,3),(253,988390800,4),(253,1001692800,3),(253,1017421200,4),(253,1033142400,3),(253,1048870800,4),(253,1064592000,3),(253,1080320400,4),(253,1096041600,3),(253,1111770000,4),(253,1127491200,3),(253,1143219600,4),(253,1159545600,3),(253,1206889200,2),(253,1427479200,5),(253,1443193200,2),(253,1458928800,5),(253,1474642800,2),(253,2147483647,2),(254,-2147483648,2),(254,-933667200,1),(254,-922093200,2),(254,-908870400,1),(254,-888829200,2),(254,-881049600,1),(254,-767869200,2),(254,-745833600,1),(254,-733827600,2),(254,-716889600,1),(254,-699613200,2),(254,-683884800,1),(254,-670669200,2),(254,-652348800,1),(254,-650019600,2),(254,515527200,1),(254,527014800,2),(254,545162400,1),(254,558464400,2),(254,577216800,1),(254,589914000,2),(254,608666400,1),(254,621968400,2),(254,640116000,1),(254,653418000,2),(254,671565600,1),(254,684867600,2),(255,-2147483648,2),(255,-933667200,1),(255,-922093200,2),(255,-908870400,1),(255,-888829200,2),(255,-881049600,1),(255,-767869200,2),(255,-745833600,1),(255,-733827600,2),(255,-716889600,1),(255,-699613200,2),(255,-683884800,1),(255,-670669200,2),(255,-652348800,1),(255,-650019600,2),(255,515527200,1),(255,527014800,2),(255,545162400,1),(255,558464400,2),(255,577216800,1),(255,589914000,2),(255,608666400,1),(255,621968400,2),(255,640116000,1),(255,653418000,2),(255,671565600,1),(255,684867600,2),(256,-2147483648,1),(256,-2019705572,2),(256,-883287000,3),(256,-862639200,4),(256,-764051400,2),(256,832962600,5),(256,846266400,6),(256,1145039400,2),(256,2147483647,2),(257,-2147483648,1),(257,-891582800,2),(257,-872058600,3),(257,-862637400,2),(257,-576138600,4),(257,1245430800,5),(257,1262278800,4),(257,2147483647,4),(258,-2147483648,0),(258,-1577931912,2),(258,-1568592000,1),(258,-1554080400,2),(258,-1537142400,1),(258,-1522630800,2),(258,-1505692800,1),(258,-1491181200,2),(258,-1474243200,1),(258,-1459126800,2),(258,-242265600,1),(258,-228877200,2),(258,-210556800,1),(258,-197427600,2),(258,-178934400,1),(258,-165718800,2),(258,-147398400,1),(258,-134269200,2),(258,-116467200,1),(258,-102646800,2),(258,-84326400,1),(258,-71110800,2),(258,-52704000,1),(258,-39488400,2),(258,-21168000,1),(258,-7952400,2),(258,10368000,1),(258,23583600,2),(258,41904000,1),(258,55119600,2),(258,73526400,1),(258,86742000,2),(258,105062400,1),(258,118278000,2),(258,136598400,1),(258,149814000,2),(258,168134400,1),(258,181350000,2),(258,199756800,1),(258,212972400,2),(258,231292800,1),(258,241916400,2),(258,262828800,1),(258,273452400,2),(258,418694400,1),(258,433810800,2),(258,450316800,1),(258,465433200,2),(258,508896000,1),(258,529196400,2),(258,541555200,1),(258,562633200,2),(258,574387200,1),(258,594255600,2),(258,607305600,1),(258,623199600,2),(258,638928000,1),(258,654649200,2),(258,670456800,1),(258,686264400,2),(258,702684000,1),(258,717886800,2),(258,733096800,1),(258,748904400,2),(258,765151200,1),(258,780958800,2),(258,796687200,1),(258,812494800,2),(258,828309600,1),(258,844117200,2),(258,859759200,1),(258,875653200,2),(258,891208800,1),(258,907189200,2),(258,922917600,1),(258,938725200,2),(258,954540000,1),(258,970347600,2),(258,986076000,1),(258,1001883600,2),(258,1017612000,1),(258,1033419600,2),(258,1049148000,1),(258,1064955600,2),(258,1080770400,1),(258,1096578000,2),(258,1112306400,1),(258,1128114000,2),(258,1143842400,1),(258,1158872400,2),(258,1175205600,1),(258,1193950800,2),(258,1207260000,1),(258,1225486800,2),(258,1238104800,1),(258,1256850000,2),(258,1270159200,1),(258,1288299600,2),(258,1301608800,1),(258,1319749200,2),(258,1333058400,1),(258,1351198800,2),(258,1364508000,1),(258,1382648400,2),(258,1395957600,1),(258,1414702800,2),(258,1427407200,1),(258,1446152400,2),(258,1458856800,1),(258,1477602000,2),(258,1490911200,1),(258,1509051600,2),(258,1522360800,1),(258,1540501200,2),(258,1553810400,1),(258,1571950800,2),(258,1585260000,1),(258,1604005200,2),(258,1616709600,1),(258,1635454800,2),(258,1648159200,1),(258,1666904400,2),(258,1680213600,1),(258,1698354000,2),(258,1711663200,1),(258,1729803600,2),(258,1743112800,1),(258,1761858000,2),(258,1774562400,1),(258,1793307600,2),(258,1806012000,1),(258,1824757200,2),(258,1838066400,1),(258,1856206800,2),(258,1869516000,1),(258,1887656400,2),(258,1900965600,1),(258,1919106000,2),(258,1932415200,1),(258,1951160400,2),(258,1963864800,1),(258,1982610000,2),(258,1995314400,1),(258,2014059600,2),(258,2027368800,1),(258,2045509200,2),(258,2058818400,1),(258,2076958800,2),(258,2090268000,1),(258,2109013200,2),(258,2121717600,1),(258,2140462800,2),(259,-2147483648,1),(259,-891582800,2),(259,-872058600,3),(259,-862637400,2),(259,-576138600,4),(259,1245430800,5),(259,1262278800,4),(259,2147483647,4),(260,-2147483648,0),(260,-1830414140,1),(260,-879152400,2),(260,199897200,1),(260,969120000,2),(260,2147483647,2),(261,-2147483648,0),(261,-1577936472,1),(261,2147483647,1),(262,-2147483648,0),(262,-1441168512,1),(262,-1247547600,3),(262,354909600,2),(262,370717200,3),(262,386445600,2),(262,402253200,3),(262,417981600,2),(262,433789200,3),(262,449604000,2),(262,465336000,4),(262,481060800,5),(262,496785600,4),(262,512510400,5),(262,528235200,4),(262,543960000,5),(262,559684800,4),(262,575409600,5),(262,591134400,4),(262,606859200,5),(262,622584000,4),(262,638308800,5),(262,654638400,4),(262,670363200,6),(262,684363600,7),(262,2147483647,7),(263,-2147483648,0),(263,-1518920148,2),(263,166572000,1),(263,182293200,2),(263,200959200,1),(263,213829200,2),(263,228866400,1),(263,243982800,2),(263,260316000,1),(263,276123600,2),(263,291765600,1),(263,307486800,2),(263,323820000,1),(263,338936400,2),(263,354664800,1),(263,370386000,2),(263,386114400,1),(263,401835600,2),(263,417564000,1),(263,433285200,2),(263,449013600,1),(263,465339600,2),(263,481068000,1),(263,496789200,2),(263,512517600,1),(263,528238800,2),(263,543967200,1),(263,559688400,2),(263,575416800,1),(263,591138000,2),(263,606866400,1),(263,622587600,2),(263,638316000,1),(263,654642000,2),(263,670370400,1),(263,686091600,2),(263,701820000,1),(263,717541200,2),(263,733269600,1),(263,748990800,2),(263,764719200,1),(263,780440400,2),(263,796168800,1),(263,811890000,2),(263,828223200,1),(263,843944400,2),(263,859672800,1),(263,875394000,2),(263,891122400,1),(263,909277200,3),(263,922582800,4),(263,941331600,3),(263,954032400,4),(263,972781200,3),(263,985482000,4),(263,1004230800,3),(263,1017536400,4),(263,1035680400,3),(263,1048986000,4),(263,1067130000,3),(263,1080435600,4),(263,1099184400,3),(263,1111885200,4),(263,1130634000,3),(263,1143334800,4),(263,1162083600,3),(263,1174784400,4),(263,1193533200,3),(263,1206838800,4),(263,1224982800,3),(263,1238288400,4),(263,1256432400,3),(263,1269738000,4),(263,1288486800,3),(263,1301187600,4),(263,1319936400,3),(263,1332637200,4),(263,1351386000,3),(263,1364691600,4),(263,1382835600,3),(263,1396141200,4),(263,1414285200,3),(263,1427590800,4),(263,1445734800,3),(263,1459040400,4),(263,1473282000,5),(263,1509238800,3),(263,1521939600,4),(263,1540688400,3),(263,1553994000,4),(263,1572138000,3),(263,1585443600,4),(263,1603587600,3),(263,1616893200,4),(263,1635642000,3),(263,1648342800,4),(263,1667091600,3),(263,1679792400,4),(263,1698541200,3),(263,1711846800,4),(263,1729990800,3),(263,1743296400,4),(263,1761440400,3),(263,1774746000,4),(263,1792890000,3),(263,1806195600,4),(263,1824944400,3),(263,1837645200,4),(263,1856394000,3),(263,1869094800,4),(263,1887843600,3),(263,1901149200,4),(263,1919293200,3),(263,1932598800,4),(263,1950742800,3),(263,1964048400,4),(263,1982797200,3),(263,1995498000,4),(263,2014246800,3),(263,2026947600,4),(263,2045696400,3),(263,2058397200,4),(263,2077146000,3),(263,2090451600,4),(263,2108595600,3),(263,2121901200,4),(263,2140045200,3),(264,-2147483648,2),(264,-933645600,1),(264,-857358000,2),(264,-844300800,1),(264,-825822000,2),(264,-812685600,1),(264,-794199600,2),(264,-779853600,1),(264,-762656400,2),(264,-748310400,1),(264,-731127600,2),(264,-399088800,1),(264,-386650800,2),(264,-368330400,1),(264,-355114800,2),(264,-336790800,1),(264,-323654400,2),(264,-305168400,1),(264,-292032000,2),(264,-273632400,1),(264,-260496000,2),(264,-242096400,1),(264,-228960000,2),(264,-210560400,1),(264,-197424000,2),(264,-178938000,1),(264,-165801600,2),(264,-147402000,1),(264,-134265600,2),(264,-115866000,1),(264,-102643200,2),(264,-84330000,1),(264,-81313200,4),(264,142380000,3),(264,150843600,4),(264,167176800,3),(264,178664400,4),(264,334015200,3),(264,337644000,4),(264,452556000,3),(264,462232800,4),(264,482277600,3),(264,495579600,4),(264,516751200,3),(264,526424400,4),(264,545436000,3),(264,558478800,4),(264,576626400,3),(264,589323600,4),(264,609890400,3),(264,620773200,4),(264,638316000,3),(264,651618000,4),(264,669765600,3),(264,683672400,4),(264,701820000,3),(264,715726800,4),(264,733701600,3),(264,747176400,4),(264,765151200,3),(264,778021200,4),(264,796600800,3),(264,810075600,4),(264,820447200,2),(264,828655200,1),(264,843170400,5),(264,860104800,1),(264,874620000,5),(264,891554400,1),(264,906069600,5),(264,915141600,2),(264,924213600,1),(264,939934800,2),(264,956268000,1),(264,971989200,2),(264,987717600,1),(264,1003438800,2),(264,1019167200,1),(264,1034888400,2),(264,1050616800,1),(264,1066338000,2),(264,1082066400,1),(264,1096581600,2),(264,1113516000,1),(264,1128380400,2),(264,1143842400,1),(264,1158872400,2),(264,1175378400,1),(264,1189638000,2),(264,1206655200,1),(264,1219957200,2),(264,1238104800,1),(264,1252015200,2),(264,1269640860,1),(264,1281474000,2),(264,1301608860,1),(264,1312146000,2),(264,1333058400,1),(264,1348178400,2),(264,1364508000,1),(264,1380229200,2),(264,1395957600,1),(264,1414098000,2),(264,1427493600,1),(264,1445547600,2),(264,1458946800,1),(264,1477692000,2),(264,1490396400,1),(264,1509141600,2),(264,1521846000,1),(264,1540591200,2),(264,1553900400,1),(264,1572040800,2),(264,1585350000,1),(264,1604095200,2),(264,1616799600,1),(264,1635544800,2),(264,1648249200,1),(264,1666994400,2),(264,1679698800,1),(264,1698444000,2),(264,1711753200,1),(264,1729893600,2),(264,1743202800,1),(264,1761343200,2),(264,1774652400,1),(264,1793397600,2),(264,1806102000,1),(264,1824847200,2),(264,1837551600,1),(264,1856296800,2),(264,1869001200,1),(264,1887746400,2),(264,1901055600,1),(264,1919196000,2),(264,1932505200,1),(264,1950645600,2),(264,1963954800,1),(264,1982700000,2),(264,1995404400,1),(264,2014149600,2),(264,2026854000,1),(264,2045599200,2),(264,2058303600,1),(264,2077048800,2),(264,2090358000,1),(264,2108498400,2),(264,2121807600,1),(264,2140552800,2),(265,-2147483648,2),(265,-933667200,1),(265,-922093200,2),(265,-908870400,1),(265,-888829200,2),(265,-881049600,1),(265,-767869200,2),(265,-745833600,1),(265,-733827600,2),(265,-716889600,1),(265,-699613200,2),(265,-683884800,1),(265,-670669200,2),(265,-652348800,1),(265,-650019600,2),(265,515527200,1),(265,527014800,2),(265,545162400,1),(265,558464400,2),(265,577216800,1),(265,589914000,2),(265,608666400,1),(265,621968400,2),(265,640116000,1),(265,653418000,2),(265,671565600,1),(265,684867600,2),(266,-2147483648,2),(266,-933645600,1),(266,-857358000,2),(266,-844300800,1),(266,-825822000,2),(266,-812685600,1),(266,-794199600,2),(266,-779853600,1),(266,-762656400,2),(266,-748310400,1),(266,-731127600,2),(266,-399088800,1),(266,-386650800,2),(266,-368330400,1),(266,-355114800,2),(266,-336790800,1),(266,-323654400,2),(266,-305168400,1),(266,-292032000,2),(266,-273632400,1),(266,-260496000,2),(266,-242096400,1),(266,-228960000,2),(266,-210560400,1),(266,-197424000,2),(266,-178938000,1),(266,-165801600,2),(266,-147402000,1),(266,-134265600,2),(266,-115866000,1),(266,-102643200,2),(266,-84330000,1),(266,-81313200,4),(266,142380000,3),(266,150843600,4),(266,167176800,3),(266,178664400,4),(266,334015200,3),(266,337644000,4),(266,452556000,3),(266,462232800,4),(266,482277600,3),(266,495579600,4),(266,516751200,3),(266,526424400,4),(266,545436000,3),(266,558478800,4),(266,576626400,3),(266,589323600,4),(266,609890400,3),(266,620773200,4),(266,638316000,3),(266,651618000,4),(266,669765600,3),(266,683672400,4),(266,701820000,3),(266,715726800,4),(266,733701600,3),(266,747176400,4),(266,765151200,3),(266,778021200,4),(266,796600800,3),(266,810075600,4),(266,820447200,2),(266,828655200,1),(266,843170400,5),(266,860104800,1),(266,874620000,5),(266,891554400,1),(266,906069600,5),(266,915141600,2),(266,924213600,1),(266,939934800,2),(266,956268000,1),(266,971989200,2),(266,987717600,1),(266,1003438800,2),(266,1019167200,1),(266,1034888400,2),(266,1050616800,1),(266,1066338000,2),(266,1082066400,1),(266,1096581600,2),(266,1113516000,1),(266,1128380400,2),(266,1143842400,1),(266,1158872400,2),(266,1175378400,1),(266,1189638000,2),(266,1206655200,1),(266,1220216400,2),(266,1238104800,1),(266,1252015200,2),(266,1269554400,1),(266,1281474000,2),(266,1301608860,1),(266,1312146000,2),(266,1314655200,1),(266,1317330000,2),(266,1333058400,1),(266,1348178400,2),(266,1364508000,1),(266,1380229200,2),(266,1395957600,1),(266,1414098000,2),(266,1427493600,1),(266,1445547600,2),(266,1458946800,1),(266,1477692000,2),(266,1490396400,1),(266,1509141600,2),(266,1521846000,1),(266,1540591200,2),(266,1553900400,1),(266,1572040800,2),(266,1585350000,1),(266,1604095200,2),(266,1616799600,1),(266,1635544800,2),(266,1648249200,1),(266,1666994400,2),(266,1679698800,1),(266,1698444000,2),(266,1711753200,1),(266,1729893600,2),(266,1743202800,1),(266,1761343200,2),(266,1774652400,1),(266,1793397600,2),(266,1806102000,1),(266,1824847200,2),(266,1837551600,1),(266,1856296800,2),(266,1869001200,1),(266,1887746400,2),(266,1901055600,1),(266,1919196000,2),(266,1932505200,1),(266,1950645600,2),(266,1963954800,1),(266,1982700000,2),(266,1995404400,1),(266,2014149600,2),(266,2026854000,1),(266,2045599200,2),(266,2058303600,1),(266,2077048800,2),(266,2090358000,1),(266,2108498400,2),(266,2121807600,1),(266,2140552800,2),(267,-2147483648,0),(267,-2004073600,1),(267,-1851577590,2),(267,-852105600,3),(267,-782643600,4),(267,-767869200,2),(267,-718095600,3),(267,-457776000,2),(267,-315648000,3),(267,171820800,2),(267,2147483647,2),(268,-2147483648,0),(268,-2056690800,1),(268,-900909000,2),(268,-891579600,3),(268,-884248200,4),(268,-766659600,1),(268,-747981000,2),(268,-728544600,1),(268,-717049800,2),(268,-694503000,1),(268,-683785800,2),(268,-668064600,1),(268,-654755400,2),(268,-636615000,1),(268,-623305800,2),(268,-605165400,1),(268,-591856200,2),(268,-573715800,1),(268,-559801800,2),(268,-541661400,1),(268,-528352200,2),(268,-510211800,1),(268,-498112200,2),(268,-478762200,1),(268,-466662600,2),(268,-446707800,1),(268,-435213000,2),(268,-415258200,1),(268,-403158600,2),(268,-383808600,1),(268,-371709000,2),(268,-352359000,1),(268,-340259400,2),(268,-320909400,1),(268,-308809800,2),(268,-288855000,1),(268,-277360200,2),(268,-257405400,1),(268,-245910600,2),(268,-225955800,1),(268,-213856200,2),(268,-194506200,1),(268,-182406600,2),(268,-163056600,1),(268,-148537800,2),(268,-132816600,1),(268,-117088200,2),(268,-101367000,1),(268,-85638600,2),(268,-69312600,1),(268,-53584200,2),(268,-37863000,1),(268,-22134600,2),(268,-6413400,1),(268,9315000,2),(268,25036200,1),(268,40764600,2),(268,56485800,1),(268,72214200,2),(268,88540200,1),(268,104268600,2),(268,119989800,1),(268,126041400,2),(268,151439400,1),(268,167167800,2),(268,182889000,1),(268,198617400,2),(268,214338600,1),(268,295385400,2),(268,309292200,1),(269,-2147483648,0),(269,-2032927596,1),(269,252439200,3),(269,417978000,2),(269,433785600,3),(269,449600400,2),(269,465321600,3),(269,481050000,2),(269,496771200,3),(269,512499600,2),(269,528220800,3),(269,543949200,2),(269,559670400,3),(269,575398800,2),(269,591120000,3),(269,606848400,2),(269,622569600,3),(269,638298000,2),(269,654624000,3),(269,670352400,2),(269,686073600,3),(269,701802000,2),(269,717523200,3),(269,733251600,2),(269,748972800,3),(269,764701200,2),(269,780422400,3),(269,796150800,2),(269,811872000,3),(269,828205200,2),(269,843926400,3),(269,859654800,2),(269,875376000,3),(269,891104400,2),(269,906825600,3),(269,988398000,2),(269,1001700000,3),(269,1017428400,2),(269,1033149600,3),(269,1048878000,2),(269,1064599200,3),(269,1080327600,2),(269,1096048800,3),(269,1111777200,2),(269,1127498400,3),(269,1143226800,2),(269,1159552800,3),(269,1427482800,2),(269,1443196800,3),(269,1458932400,2),(269,1474646400,3),(269,2147483647,3),(270,-2147483648,1),(270,-1575874625,2),(270,-1247554800,4),(270,354902400,3),(270,370710000,4),(270,386438400,3),(270,402246000,4),(270,417974400,3),(270,433782000,4),(270,449596800,3),(270,465328800,5),(270,481053600,6),(270,496778400,5),(270,512503200,6),(270,528228000,5),(270,543952800,6),(270,559677600,5),(270,575402400,6),(270,591127200,5),(270,606852000,6),(270,622576800,5),(270,638301600,6),(270,654631200,5),(270,670356000,7),(270,686084400,8),(270,695761200,5),(270,701805600,6),(270,717530400,5),(270,733255200,6),(270,748980000,5),(270,764704800,6),(270,780429600,5),(270,796154400,6),(270,811879200,5),(270,828208800,6),(270,846352800,5),(270,859658400,6),(270,877802400,5),(270,891108000,6),(270,909252000,5),(270,922557600,6),(270,941306400,5),(270,954007200,6),(270,972756000,5),(270,985456800,6),(270,1004205600,5),(270,1017511200,6),(270,1035655200,5),(270,1048960800,6),(270,1067104800,5),(270,1080410400,6),(270,1099159200,5),(270,1111860000,6),(270,1130608800,5),(270,1143309600,6),(270,1162058400,5),(270,1174759200,6),(270,1193508000,5),(270,1206813600,6),(270,1224957600,5),(270,1238263200,6),(270,1256407200,5),(270,1269712800,6),(270,1288461600,5),(270,1301162400,9),(270,1414256400,5),(270,2147483647,5),(271,-2147483648,1),(271,-1869875816,3),(271,-1693706400,2),(271,-1680490800,3),(271,-1570413600,2),(271,-1552186800,3),(271,-1538359200,2),(271,-1522551600,3),(271,-1507514400,2),(271,-1490583600,3),(271,-1440208800,2),(271,-1428030000,3),(271,-1409709600,2),(271,-1396494000,3),(271,-931140000,2),(271,-922762800,3),(271,-917834400,2),(271,-892436400,3),(271,-875844000,2),(271,-857358000,3),(271,-781063200,2),(271,-764737200,3),(271,-744343200,2),(271,-733806000,3),(271,-716436000,2),(271,-701924400,3),(271,-684986400,2),(271,-670474800,3),(271,-654141600,2),(271,-639025200,3),(271,-621828000,2),(271,-606970800,3),(271,-590032800,2),(271,-575434800,3),(271,-235620000,2),(271,-228279600,3),(271,-177732000,2),(271,-165726000,3),(271,10533600,2),(271,23835600,3),(271,41983200,2),(271,55285200,3),(271,74037600,2),(271,87339600,3),(271,107910000,2),(271,121219200,3),(271,133920000,2),(271,152676000,3),(271,165362400,2),(271,183502800,3),(271,202428000,2),(271,215557200,3),(271,228866400,2),(271,245797200,3),(271,260316000,2),(271,277246800,4),(271,308779200,5),(271,323827200,4),(271,340228800,5),(271,354672000,4),(271,371678400,5),(271,386121600,4),(271,403128000,5),(271,428446800,4),(271,433886400,5),(271,482792400,2),(271,496702800,3),(271,512521200,6),(271,528246000,7),(271,543970800,6),(271,559695600,7),(271,575420400,6),(271,591145200,7),(271,606870000,6),(271,622594800,7),(271,638319600,6),(271,654649200,7),(271,670374000,6),(271,686098800,7),(271,701823600,6),(271,717548400,7),(271,733273200,6),(271,748998000,7),(271,764118000,6),(271,780447600,7),(271,796172400,6),(271,811897200,7),(271,828226800,6),(271,846370800,7),(271,859676400,6),(271,877820400,7),(271,891126000,6),(271,909270000,7),(271,922575600,6),(271,941324400,7),(271,954025200,6),(271,972774000,7),(271,985474800,6),(271,1004223600,7),(271,1017529200,6),(271,1035673200,7),(271,1048978800,6),(271,1067122800,7),(271,1080428400,6),(271,1099177200,7),(271,1111878000,6),(271,1130626800,7),(271,1143327600,6),(271,1162076400,7),(271,1167602400,3),(271,1174784400,8),(271,1193533200,9),(271,1206838800,8),(271,1224982800,9),(271,1238288400,8),(271,1256432400,9),(271,1269738000,8),(271,1288486800,9),(271,1301274000,8),(271,1319936400,9),(271,1332637200,8),(271,1351386000,9),(271,1364691600,8),(271,1382835600,9),(271,1396227600,8),(271,1414285200,9),(271,1427590800,8),(271,1446944400,9),(271,1459040400,8),(271,1473195600,5),(271,2147483647,5),(272,-2147483648,1),(272,-1451719200,2),(272,-1172906400,3),(272,-876641400,4),(272,-766054800,3),(272,-683883000,5),(272,-620812800,3),(272,-189415800,6),(273,-2147483648,0),(273,-1172913768,1),(273,-799491600,2),(273,-189423000,3),(274,-2147483648,1),(274,-1641003640,3),(274,-933645600,2),(274,-857358000,3),(274,-844300800,2),(274,-825822000,3),(274,-812685600,2),(274,-794199600,3),(274,-779853600,2),(274,-762656400,3),(274,-748310400,2),(274,-731127600,3),(274,-681962400,4),(274,-673243200,2),(274,-667962000,3),(274,-652327200,2),(274,-636426000,3),(274,-622087200,2),(274,-608947200,3),(274,-591847200,2),(274,-572486400,3),(274,-558576000,2),(274,-542851200,3),(274,-527731200,2),(274,-514425600,3),(274,-490845600,2),(274,-482986800,3),(274,-459475200,2),(274,-451537200,3),(274,-428551200,2),(274,-418262400,3),(274,-400032000,2),(274,-387428400,3),(274,142380000,2),(274,150843600,3),(274,167176800,2),(274,178664400,3),(274,334015200,2),(274,337644000,3),(274,452556000,2),(274,462232800,3),(274,482277600,2),(274,495579600,3),(274,516751200,2),(274,526424400,3),(274,545436000,2),(274,558478800,3),(274,576626400,2),(274,589323600,3),(274,609890400,2),(274,620773200,3),(274,638316000,2),(274,651618000,3),(274,669765600,2),(274,683672400,3),(274,701820000,2),(274,715726800,3),(274,733701600,2),(274,747176400,3),(274,765151200,2),(274,778021200,3),(274,796600800,2),(274,810075600,3),(274,826840800,2),(274,842821200,3),(274,858895200,2),(274,874184400,3),(274,890344800,2),(274,905029200,3),(274,923011200,2),(274,936313200,3),(274,955670400,2),(274,970783200,3),(274,986770800,2),(274,1001282400,3),(274,1017356400,2),(274,1033941600,3),(274,1048806000,2),(274,1065132000,3),(274,1081292400,2),(274,1095804000,3),(274,1112313600,2),(274,1128812400,3),(274,1143763200,2),(274,1159657200,3),(274,1175212800,2),(274,1189897200,3),(274,1206662400,2),(274,1223161200,3),(274,1238112000,2),(274,1254006000,3),(274,1269561600,2),(274,1284246000,3),(274,1301616000,2),(274,1317510000,3),(274,1333065600,2),(274,1348354800,3),(274,1364515200,2),(274,1382828400,3),(274,1395964800,2),(274,1414278000,3),(274,1427414400,2),(274,1445727600,3),(274,1458864000,2),(274,1477782000,3),(274,1490313600,2),(274,1509231600,3),(274,1521763200,2),(274,1540681200,3),(274,1553817600,2),(274,1572130800,3),(274,1585267200,2),(274,1603580400,3),(274,1616716800,2),(274,1635634800,3),(274,1648166400,2),(274,1667084400,3),(274,1679616000,2),(274,1698534000,3),(274,1711670400,2),(274,1729983600,3),(274,1743120000,2),(274,1761433200,3),(274,1774569600,2),(274,1792882800,3),(274,1806019200,2),(274,1824937200,3),(274,1837468800,2),(274,1856386800,3),(274,1868918400,2),(274,1887836400,3),(274,1900972800,2),(274,1919286000,3),(274,1932422400,2),(274,1950735600,3),(274,1963872000,2),(274,1982790000,3),(274,1995321600,2),(274,2014239600,3),(274,2026771200,2),(274,2045689200,3),(274,2058220800,2),(274,2077138800,3),(274,2090275200,2),(274,2108588400,3),(274,2121724800,2),(274,2140038000,3),(275,-2147483648,1),(275,-788932800,2),(275,2147483647,2),(276,-2147483648,0),(276,-1487759676,1),(276,-1247569200,3),(276,354888000,2),(276,370695600,3),(276,386424000,2),(276,402231600,3),(276,417960000,2),(276,433767600,3),(276,449582400,2),(276,465314400,4),(276,481039200,5),(276,496764000,4),(276,512488800,5),(276,528213600,4),(276,543938400,5),(276,559663200,4),(276,575388000,5),(276,591112800,4),(276,606837600,5),(276,622562400,4),(276,638287200,5),(276,654616800,4),(276,670341600,6),(276,686070000,7),(276,695746800,4),(276,701791200,5),(276,717516000,4),(276,733240800,5),(276,748965600,4),(276,764690400,5),(276,780415200,4),(276,796140000,5),(276,811864800,4),(276,828194400,5),(276,846338400,4),(276,859644000,5),(276,877788000,4),(276,891093600,5),(276,909237600,4),(276,922543200,5),(276,941292000,4),(276,953992800,5),(276,972741600,4),(276,985442400,5),(276,1004191200,4),(276,1017496800,5),(276,1035640800,4),(276,1048946400,5),(276,1067090400,4),(276,1080396000,5),(276,1099144800,4),(276,1111845600,5),(276,1130594400,4),(276,1143295200,5),(276,1162044000,4),(276,1174744800,5),(276,1193493600,4),(276,1206799200,5),(276,1224943200,4),(276,1238248800,5),(276,1256392800,4),(276,1269698400,6),(276,1288450800,7),(276,1301151600,4),(276,2147483647,4),(277,-2147483648,0),(277,-1988166492,1),(277,-862637400,2),(277,-764145000,1),(277,-576135000,3),(277,38775600,5),(277,1018119600,4),(277,1033840800,5),(277,1212260400,4),(277,1225476000,5),(277,1239735600,4),(277,1257012000,5),(278,-2147483648,0),(278,-1325483420,1),(278,2147483647,1),(279,-2147483648,0),(279,-1577943676,1),(279,504901800,2),(279,2147483647,2),(280,-2147483648,0),(280,-1577943676,1),(280,504901800,2),(280,2147483647,2),(281,-2147483648,0),(281,-1579424533,1),(281,-1247558400,3),(281,354898800,2),(281,370706400,3),(281,386434800,2),(281,402242400,3),(281,417970800,2),(281,433778400,3),(281,449593200,2),(281,465325200,4),(281,481050000,5),(281,496774800,4),(281,512499600,5),(281,528224400,4),(281,543949200,5),(281,559674000,4),(281,575398800,5),(281,591123600,4),(281,606848400,5),(281,622573200,4),(281,638298000,5),(281,654627600,4),(281,670352400,6),(281,686080800,7),(281,695757600,4),(281,701802000,5),(281,717526800,4),(281,733251600,5),(281,748976400,4),(281,764701200,5),(281,780426000,4),(281,796150800,5),(281,811875600,4),(281,828205200,5),(281,846349200,4),(281,859654800,5),(281,877798800,4),(281,891104400,5),(281,909248400,4),(281,922554000,5),(281,941302800,4),(281,954003600,5),(281,972752400,4),(281,985453200,5),(281,1004202000,4),(281,1017507600,5),(281,1035651600,4),(281,1048957200,5),(281,1067101200,4),(281,1072882800,10),(281,1080403200,8),(281,1099152000,9),(281,1111852800,8),(281,1130601600,9),(281,1143302400,8),(281,1162051200,9),(281,1174752000,8),(281,1193500800,9),(281,1206806400,8),(281,1224950400,9),(281,1238256000,8),(281,1256400000,9),(281,1269705600,8),(281,1288454400,9),(281,1301155200,11),(281,1315832400,9),(281,1414252800,4),(281,2147483647,4),(282,-2147483648,1),(282,-2019705670,2),(282,-891581400,3),(282,-872058600,2),(282,-862637400,3),(282,-764145000,2),(283,-2147483648,0),(283,-1577513486,1),(283,-1247551200,3),(283,354906000,2),(283,370713600,3),(283,386442000,2),(283,402249600,3),(283,417978000,2),(283,433785600,3),(283,449600400,2),(283,465332400,4),(283,481057200,5),(283,496782000,4),(283,512506800,5),(283,528231600,4),(283,543956400,5),(283,559681200,4),(283,575406000,5),(283,591130800,4),(283,606855600,5),(283,622580400,4),(283,638305200,5),(283,654634800,4),(283,670359600,6),(283,686088000,7),(283,695764800,4),(283,701809200,5),(283,717534000,4),(283,733258800,5),(283,748983600,4),(283,764708400,5),(283,780433200,4),(283,796158000,5),(283,811882800,4),(283,828212400,5),(283,846356400,4),(283,859662000,5),(283,877806000,4),(283,891111600,5),(283,909255600,4),(283,922561200,5),(283,941310000,4),(283,954010800,5),(283,972759600,4),(283,985460400,5),(283,1004209200,4),(283,1017514800,5),(283,1035658800,4),(283,1048964400,5),(283,1067108400,4),(283,1080414000,5),(283,1099162800,4),(283,1111863600,5),(283,1130612400,4),(283,1143313200,5),(283,1162062000,4),(283,1174762800,5),(283,1193511600,4),(283,1206817200,5),(283,1224961200,4),(283,1238266800,5),(283,1256410800,4),(283,1269716400,5),(283,1288465200,4),(283,1301166000,8),(283,1414260000,4),(283,2147483647,4),(284,-2147483648,1),(284,-2038200925,2),(284,-1167634800,3),(284,-1073028000,4),(284,-894180000,5),(284,-879665400,6),(284,-767005200,5),(284,378664200,7),(284,2147483647,7),(285,-2147483648,0),(285,-1383463280,1),(285,-1167636600,3),(285,-1082448000,2),(285,-1074586800,3),(285,-1050825600,2),(285,-1042964400,3),(285,-1019289600,2),(285,-1011428400,3),(285,-987753600,2),(285,-979892400,3),(285,-956217600,2),(285,-948356400,3),(285,-924595200,2),(285,-916734000,3),(285,-893059200,2),(285,-885198000,3),(285,-879667200,4),(285,-767005200,3),(285,2147483647,3),(286,-2147483648,0),(286,-719636812,1),(286,2147483647,1),(287,-2147483648,0),(287,-2056692850,1),(287,-884509200,3),(287,-873280800,2),(287,-855918000,3),(287,-841744800,2),(287,-828529200,3),(287,-765363600,1),(287,-747046800,4),(287,-733827600,5),(287,-716461200,4),(287,-697021200,5),(287,-683715600,4),(287,-667990800,5),(287,-654771600,4),(287,-636627600,5),(287,-623322000,4),(287,-605178000,5),(287,-591872400,4),(287,-573642000,5),(287,-559818000,4),(287,-541674000,5),(287,-528368400,4),(287,-510224400,5),(287,-498128400,4),(287,-478774800,5),(287,-466678800,4),(287,-446720400,5),(287,-435229200,4),(287,-415258200,1),(287,-403158600,6),(287,-383808600,1),(287,-371709000,6),(287,-352359000,1),(287,-340259400,6),(287,-320909400,1),(287,-308809800,6),(287,-288855000,1),(287,-277360200,6),(287,-257405400,1),(287,-245910600,6),(287,-225955800,1),(287,-213856200,6),(287,-194506200,1),(287,-182406600,6),(287,-163056600,1),(287,-148537800,6),(287,-132820200,1),(287,-117088200,6),(287,-101370600,1),(287,-85638600,6),(287,-69312600,1),(287,-53584200,6),(287,-37863000,1),(287,-22134600,6),(287,-6413400,1),(287,9315000,6),(287,25036200,1),(287,40764600,6),(287,56485800,1),(287,72214200,6),(287,88540200,1),(287,104268600,6),(287,119989800,1),(287,126041400,6),(287,151439400,1),(287,167167800,6),(287,182889000,1),(287,198617400,6),(287,214338600,1),(287,295385400,6),(287,309292200,1),(288,-2147483648,0),(288,-2056692850,1),(288,-884509200,3),(288,-873280800,2),(288,-855918000,3),(288,-841744800,2),(288,-828529200,3),(288,-765363600,1),(288,-747046800,4),(288,-733827600,5),(288,-716461200,4),(288,-697021200,5),(288,-683715600,4),(288,-667990800,5),(288,-654771600,4),(288,-636627600,5),(288,-623322000,4),(288,-605178000,5),(288,-591872400,4),(288,-573642000,5),(288,-559818000,4),(288,-541674000,5),(288,-528368400,4),(288,-510224400,5),(288,-498128400,4),(288,-478774800,5),(288,-466678800,4),(288,-446720400,5),(288,-435229200,4),(288,-415258200,1),(288,-403158600,6),(288,-383808600,1),(288,-371709000,6),(288,-352359000,1),(288,-340259400,6),(288,-320909400,1),(288,-308809800,6),(288,-288855000,1),(288,-277360200,6),(288,-257405400,1),(288,-245910600,6),(288,-225955800,1),(288,-213856200,6),(288,-194506200,1),(288,-182406600,6),(288,-163056600,1),(288,-148537800,6),(288,-132820200,1),(288,-117088200,6),(288,-101370600,1),(288,-85638600,6),(288,-69312600,1),(288,-53584200,6),(288,-37863000,1),(288,-22134600,6),(288,-6413400,1),(288,9315000,6),(288,25036200,1),(288,40764600,6),(288,56485800,1),(288,72214200,6),(288,88540200,1),(288,104268600,6),(288,119989800,1),(288,126041400,6),(288,151439400,1),(288,167167800,6),(288,182889000,1),(288,198617400,6),(288,214338600,1),(288,295385400,6),(288,309292200,1),(289,-2147483648,0),(289,-1441188192,1),(289,-1247565600,3),(289,354891600,2),(289,370699200,3),(289,386427600,2),(289,402235200,3),(289,417963600,2),(289,433771200,3),(289,449586000,2),(289,465318000,4),(289,481042800,5),(289,496767600,4),(289,512492400,5),(289,528217200,4),(289,543942000,5),(289,559666800,4),(289,575391600,5),(289,591116400,4),(289,606841200,5),(289,622566000,4),(289,638290800,5),(289,654620400,4),(289,670345200,6),(289,686073600,7),(289,695750400,4),(289,701794800,5),(289,717519600,4),(289,733244400,5),(289,748969200,4),(289,764694000,5),(289,780418800,4),(289,796143600,5),(289,811868400,4),(289,828198000,5),(289,846342000,4),(289,859647600,5),(289,877791600,4),(289,891097200,5),(289,909241200,4),(289,922546800,5),(289,941295600,4),(289,953996400,5),(289,972745200,4),(289,985446000,5),(289,1004194800,4),(289,1017500400,5),(289,1035644400,4),(289,1048950000,5),(289,1067094000,4),(289,1080399600,5),(289,1099148400,4),(289,1111849200,5),(289,1130598000,4),(289,1143298800,5),(289,1162047600,4),(289,1174748400,5),(289,1193497200,4),(289,1206802800,5),(289,1224946800,4),(289,1238252400,5),(289,1256396400,4),(289,1269702000,5),(289,1288450800,4),(289,1301151600,8),(289,1414245600,7),(289,1461427200,4),(289,2147483647,4),(290,-2147483648,0),(290,-1577951856,1),(290,-1172908656,2),(290,-880272000,3),(290,-766054800,4),(291,-2147483648,2),(291,-1046678400,1),(291,-1038733200,2),(291,-873273600,3),(291,-794221200,2),(291,-496224000,1),(291,-489315600,2),(291,259344000,1),(291,275151600,2),(292,-2147483648,0),(292,-1577936472,1),(292,2147483647,1),(293,-2147483648,0),(293,-1518920008,2),(293,166572000,1),(293,182293200,2),(293,200959200,1),(293,213829200,2),(293,228866400,1),(293,243982800,2),(293,260316000,1),(293,276123600,2),(293,291765600,1),(293,307486800,2),(293,323820000,1),(293,338936400,2),(293,354664800,1),(293,370386000,2),(293,386114400,1),(293,401835600,2),(293,417564000,1),(293,433285200,2),(293,449013600,1),(293,465339600,2),(293,481068000,1),(293,496789200,2),(293,512517600,1),(293,528238800,2),(293,543967200,1),(293,559688400,2),(293,575416800,1),(293,591138000,2),(293,606866400,1),(293,622587600,2),(293,638316000,1),(293,654642000,2),(293,670370400,1),(293,686091600,2),(293,701820000,1),(293,717541200,2),(293,733269600,1),(293,748990800,2),(293,764719200,1),(293,780440400,2),(293,796168800,1),(293,811890000,2),(293,828223200,1),(293,843944400,2),(293,859672800,1),(293,875394000,2),(293,891122400,1),(293,909277200,3),(293,922582800,4),(293,941331600,3),(293,954032400,4),(293,972781200,3),(293,985482000,4),(293,1004230800,3),(293,1017536400,4),(293,1035680400,3),(293,1048986000,4),(293,1067130000,3),(293,1080435600,4),(293,1099184400,3),(293,1111885200,4),(293,1130634000,3),(293,1143334800,4),(293,1162083600,3),(293,1174784400,4),(293,1193533200,3),(293,1206838800,4),(293,1224982800,3),(293,1238288400,4),(293,1256432400,3),(293,1269738000,4),(293,1288486800,3),(293,1301187600,4),(293,1319936400,3),(293,1332637200,4),(293,1351386000,3),(293,1364691600,4),(293,1382835600,3),(293,1396141200,4),(293,1414285200,3),(293,1427590800,4),(293,1445734800,3),(293,1459040400,4),(293,1477789200,3),(293,1490490000,4),(293,1509238800,3),(293,1521939600,4),(293,1540688400,3),(293,1553994000,4),(293,1572138000,3),(293,1585443600,4),(293,1603587600,3),(293,1616893200,4),(293,1635642000,3),(293,1648342800,4),(293,1667091600,3),(293,1679792400,4),(293,1698541200,3),(293,1711846800,4),(293,1729990800,3),(293,1743296400,4),(293,1761440400,3),(293,1774746000,4),(293,1792890000,3),(293,1806195600,4),(293,1824944400,3),(293,1837645200,4),(293,1856394000,3),(293,1869094800,4),(293,1887843600,3),(293,1901149200,4),(293,1919293200,3),(293,1932598800,4),(293,1950742800,3),(293,1964048400,4),(293,1982797200,3),(293,1995498000,4),(293,2014246800,3),(293,2026947600,4),(293,2045696400,3),(293,2058397200,4),(293,2077146000,3),(293,2090451600,4),(293,2108595600,3),(293,2121901200,4),(293,2140045200,3),(294,-2147483648,0),(294,-1441259328,1),(294,-1247551200,3),(294,354906000,2),(294,370713600,3),(294,386442000,2),(294,402249600,3),(294,417978000,2),(294,433785600,3),(294,449600400,2),(294,465332400,4),(294,481057200,5),(294,496782000,4),(294,512506800,5),(294,528231600,4),(294,543956400,5),(294,559681200,4),(294,575406000,5),(294,591130800,4),(294,606855600,5),(294,622580400,4),(294,638305200,5),(294,654634800,4),(294,670359600,6),(294,686088000,7),(294,695764800,4),(294,701809200,5),(294,717534000,4),(294,733258800,5),(294,748983600,4),(294,764708400,5),(294,780433200,4),(294,796158000,5),(294,811882800,4),(294,828212400,5),(294,846356400,4),(294,859662000,5),(294,877806000,4),(294,891111600,5),(294,909255600,4),(294,922561200,5),(294,941310000,4),(294,954010800,5),(294,972759600,4),(294,985460400,5),(294,1004209200,4),(294,1017514800,5),(294,1035658800,4),(294,1048964400,5),(294,1067108400,4),(294,1080414000,5),(294,1099162800,4),(294,1111863600,5),(294,1130612400,4),(294,1143313200,5),(294,1162062000,4),(294,1174762800,5),(294,1193511600,4),(294,1206817200,5),(294,1224961200,4),(294,1238266800,5),(294,1256410800,4),(294,1269716400,6),(294,1288468800,7),(294,1301169600,4),(294,2147483647,4),(295,-2147483648,0),(295,-1579476700,1),(295,-1247551200,3),(295,354906000,2),(295,370713600,3),(295,386442000,2),(295,402249600,3),(295,417978000,2),(295,433785600,3),(295,449600400,2),(295,465332400,4),(295,481057200,5),(295,496782000,4),(295,512506800,5),(295,528231600,4),(295,543956400,5),(295,559681200,4),(295,575406000,5),(295,591130800,4),(295,606855600,5),(295,622580400,4),(295,638305200,5),(295,654634800,4),(295,670359600,6),(295,686088000,7),(295,695764800,4),(295,701809200,5),(295,717534000,4),(295,733258800,5),(295,738086400,8),(295,748987200,7),(295,764712000,6),(295,780436800,7),(295,796161600,6),(295,811886400,7),(295,828216000,6),(295,846360000,7),(295,859665600,6),(295,877809600,7),(295,891115200,6),(295,909259200,7),(295,922564800,6),(295,941313600,7),(295,954014400,6),(295,972763200,7),(295,985464000,6),(295,1004212800,7),(295,1017518400,6),(295,1035662400,7),(295,1048968000,6),(295,1067112000,7),(295,1080417600,6),(295,1099166400,7),(295,1111867200,6),(295,1130616000,7),(295,1143316800,6),(295,1162065600,7),(295,1174766400,6),(295,1193515200,7),(295,1206820800,6),(295,1224964800,7),(295,1238270400,6),(295,1256414400,7),(295,1269720000,6),(295,1288468800,7),(295,1301169600,4),(295,1414263600,7),(295,1469304000,4),(295,2147483647,4),(296,-2147483648,0),(296,-1582088010,1),(296,-1247547600,3),(296,354909600,2),(296,370717200,3),(296,386445600,2),(296,402253200,3),(296,417981600,2),(296,433789200,3),(296,449604000,2),(296,465336000,4),(296,481060800,5),(296,496785600,4),(296,512510400,5),(296,528235200,4),(296,543960000,5),(296,559684800,4),(296,575409600,5),(296,591134400,4),(296,606859200,5),(296,622584000,4),(296,638308800,5),(296,654638400,4),(296,670363200,6),(296,686091600,7),(296,695768400,4),(296,701812800,5),(296,717537600,4),(296,733262400,5),(296,748987200,4),(296,764712000,5),(296,780436800,4),(296,796161600,5),(296,811886400,4),(296,828216000,5),(296,846360000,4),(296,859665600,5),(296,877809600,4),(296,891115200,5),(296,909259200,4),(296,922564800,5),(296,941313600,4),(296,954014400,5),(296,972763200,4),(296,985464000,5),(296,1004212800,4),(296,1017518400,5),(296,1035662400,4),(296,1048968000,5),(296,1067112000,4),(296,1080417600,5),(296,1099166400,4),(296,1111867200,5),(296,1130616000,4),(296,1143316800,5),(296,1162065600,4),(296,1174766400,5),(296,1193515200,4),(296,1206820800,5),(296,1224964800,4),(296,1238270400,5),(296,1256414400,4),(296,1269720000,5),(296,1288468800,4),(296,1301169600,8),(296,1414263600,4),(296,2147483647,4),(297,-2147483648,0),(297,-1441164324,1),(297,-1247540400,2),(297,354913200,3),(297,370720800,4),(297,386445600,3),(297,402256800,2),(297,417985200,3),(297,433792800,2),(297,449607600,3),(297,465339600,5),(297,481064400,6),(297,496789200,5),(297,512514000,6),(297,528238800,5),(297,543963600,6),(297,559688400,5),(297,575413200,6),(297,591138000,5),(297,606862800,7),(297,622591200,8),(297,638316000,7),(297,654645600,8),(297,670370400,7),(297,686095200,8),(297,695772000,5),(297,701816400,7),(297,717544800,8),(297,733269600,7),(297,748994400,8),(297,764719200,7),(297,780444000,8),(297,796168800,7),(297,811893600,8),(297,828223200,7),(297,846367200,8),(297,859672800,7),(297,877816800,8),(297,891122400,7),(297,909266400,8),(297,922572000,7),(297,941320800,8),(297,954021600,7),(297,972770400,8),(297,985471200,7),(297,1004220000,8),(297,1017525600,7),(297,1035669600,8),(297,1048975200,7),(297,1067119200,8),(297,1080424800,7),(297,1099173600,5),(297,2147483647,5),(298,-2147483648,1),(298,-1570084924,2),(298,2147483647,2),(299,-2147483648,0),(299,-1946186240,1),(299,-1172906240,2),(299,-881220600,3),(299,-766054800,2),(299,-683883000,4),(299,-620812800,2),(299,-189415800,5),(299,567964800,6),(300,-2147483648,0),(300,-1948782180,1),(300,-1830414600,2),(300,-768646800,3),(300,1439564400,1),(300,1525446000,3),(301,-2147483648,0),(301,-1577935568,1),(301,76190400,2),(301,2147483647,2),(302,-2147483648,0),(302,-1441167268,1),(302,-1247544000,2),(302,354913200,3),(302,370720800,4),(302,386445600,3),(302,402256800,2),(302,417985200,3),(302,433792800,2),(302,449607600,3),(302,465339600,5),(302,481064400,6),(302,496789200,5),(302,512514000,6),(302,528238800,5),(302,543963600,6),(302,559688400,5),(302,575413200,6),(302,591138000,5),(302,606862800,6),(302,622587600,5),(302,638312400,6),(302,654642000,5),(302,670366800,7),(302,686095200,8),(302,695772000,5),(302,701816400,6),(302,717541200,5),(302,733266000,6),(302,748990800,5),(302,764715600,6),(302,780440400,5),(302,796165200,6),(302,811890000,5),(302,828219600,6),(302,846363600,5),(302,859669200,6),(302,877813200,5),(302,891118800,6),(302,909262800,5),(302,922568400,6),(302,941317200,5),(302,954018000,6),(302,972766800,5),(302,985467600,6),(302,1004216400,5),(302,1017522000,6),(302,1035666000,5),(302,1048971600,6),(302,1067115600,5),(302,1080421200,6),(302,1099170000,9),(302,2147483647,9),(303,-2147483648,0),(303,-1441167712,1),(303,-1247544000,2),(303,354913200,3),(303,370720800,4),(303,386445600,3),(303,402256800,2),(303,417985200,3),(303,433792800,2),(303,449607600,3),(303,465339600,5),(303,481064400,6),(303,496789200,5),(303,512514000,6),(303,528238800,5),(303,543963600,6),(303,559688400,5),(303,575413200,6),(303,591138000,5),(303,606862800,6),(303,622587600,5),(303,638312400,6),(303,654642000,5),(303,670366800,7),(303,686095200,5),(303,695768400,9),(303,701812800,6),(303,717541200,5),(303,733266000,6),(303,748990800,5),(303,764715600,6),(303,780440400,5),(303,796165200,6),(303,811890000,5),(303,828219600,6),(303,846363600,5),(303,859669200,6),(303,877813200,5),(303,891118800,6),(303,909262800,5),(303,922568400,6),(303,941317200,5),(303,954018000,6),(303,972766800,5),(303,985467600,6),(303,1004216400,5),(303,1017522000,6),(303,1035666000,5),(303,1048971600,6),(303,1067115600,5),(303,1080421200,6),(303,1099170000,9),(303,1545328800,2),(303,2147483647,2),(304,-2147483648,1),(304,-1577946287,2),(304,-873268200,3),(304,-778410000,2),(304,2147483647,2),(305,-2147483648,0),(305,-719636812,1),(305,2147483647,1),(306,-2147483648,0),(306,-2004073600,1),(306,-1851577590,2),(306,-852105600,3),(306,-782643600,4),(306,-767869200,2),(306,-718095600,3),(306,-457776000,2),(306,-315648000,3),(306,171820800,2),(306,2147483647,2),(307,-2147483648,0),(307,-2031039048,1),(307,-768560400,3),(307,354891600,2),(307,370699200,3),(307,386427600,2),(307,402235200,3),(307,417963600,2),(307,433771200,3),(307,449586000,2),(307,465318000,4),(307,481042800,5),(307,496767600,4),(307,512492400,5),(307,528217200,4),(307,543942000,5),(307,559666800,4),(307,575391600,5),(307,591116400,4),(307,606841200,5),(307,622566000,4),(307,638290800,5),(307,654620400,4),(307,670345200,6),(307,686073600,7),(307,695750400,4),(307,701794800,5),(307,717519600,4),(307,733244400,5),(307,748969200,4),(307,764694000,5),(307,780418800,4),(307,796143600,5),(307,811868400,4),(307,828198000,5),(307,846342000,4),(307,859647600,6),(307,877795200,7),(307,891100800,6),(307,909244800,7),(307,922550400,6),(307,941299200,7),(307,954000000,6),(307,972748800,7),(307,985449600,6),(307,1004198400,7),(307,1017504000,6),(307,1035648000,7),(307,1048953600,6),(307,1067097600,7),(307,1080403200,6),(307,1099152000,7),(307,1111852800,6),(307,1130601600,7),(307,1143302400,6),(307,1162051200,7),(307,1174752000,6),(307,1193500800,7),(307,1206806400,6),(307,1224950400,7),(307,1238256000,6),(307,1256400000,7),(307,1269705600,6),(307,1288454400,7),(307,1301155200,4),(307,1414249200,7),(307,1459008000,4),(307,2147483647,4),(308,-2147483648,0),(308,-1441168073,1),(308,-1247544000,2),(308,354913200,3),(308,370720800,4),(308,386445600,3),(308,402256800,2),(308,417985200,3),(308,433792800,2),(308,449607600,3),(308,465339600,5),(308,481064400,6),(308,496789200,5),(308,512514000,6),(308,528238800,5),(308,543963600,6),(308,559688400,5),(308,575413200,6),(308,591138000,5),(308,606862800,6),(308,622587600,5),(308,638312400,6),(308,654642000,5),(308,670366800,6),(308,686091600,5),(308,694206000,2),(308,2147483647,2),(309,-2147483648,0),(309,-1948782472,1),(309,-1830414600,2),(309,-767350800,3),(309,-498128400,1),(309,-462702600,4),(309,-451733400,1),(309,-429784200,4),(309,-418296600,1),(309,-399544200,4),(309,-387451800,1),(309,-368094600,4),(309,-356002200,1),(309,-336645000,4),(309,-324552600,1),(309,-305195400,4),(309,-293103000,1),(309,-264933000,3),(309,547578000,5),(309,560883600,3),(309,579027600,5),(309,592333200,3),(310,-2147483648,2),(310,-933667200,1),(310,-922093200,2),(310,-908870400,1),(310,-888829200,2),(310,-881049600,1),(310,-767869200,2),(310,-745833600,1),(310,-733827600,2),(310,-716889600,1),(310,-699613200,2),(310,-683884800,1),(310,-670669200,2),(310,-652348800,1),(310,-650019600,2),(310,515527200,1),(310,527014800,2),(310,545162400,1),(310,558464400,2),(310,577216800,1),(310,589914000,2),(310,608666400,1),(310,621968400,2),(310,640116000,1),(310,653418000,2),(310,671565600,1),(310,684867600,2),(311,-2147483648,1),(311,-2038200925,2),(311,-1167634800,3),(311,-1073028000,4),(311,-894180000,5),(311,-879665400,6),(311,-767005200,5),(311,378664200,7),(311,2147483647,7),(312,-2147483648,0),(312,-1441188892,1),(312,-1247565600,3),(312,354891600,2),(312,370699200,3),(312,386427600,2),(312,402235200,3),(312,417963600,2),(312,433771200,3),(312,449586000,2),(312,465318000,4),(312,481042800,5),(312,496767600,4),(312,512492400,5),(312,528217200,4),(312,543942000,5),(312,559666800,4),(312,575391600,5),(312,591116400,4),(312,606841200,5),(312,622566000,4),(312,638290800,5),(312,654620400,4),(312,670345200,6),(312,686073600,7),(312,695750400,4),(312,701794800,5),(312,717519600,4),(312,733244400,5),(312,748969200,4),(312,764694000,5),(312,780418800,4),(312,796143600,5),(312,811868400,4),(312,828198000,5),(312,846342000,4),(312,859647600,5),(312,877791600,4),(312,891097200,5),(312,909241200,4),(312,922546800,5),(312,941295600,4),(312,953996400,5),(312,972745200,4),(312,985446000,5),(312,1004194800,4),(312,1017500400,5),(312,1035644400,4),(312,1048950000,5),(312,1067094000,4),(312,1080399600,5),(312,1099148400,4),(312,1111849200,5),(312,1130598000,4),(312,1143298800,5),(312,1162047600,4),(312,1174748400,5),(312,1193497200,4),(312,1206802800,5),(312,1224946800,4),(312,1238252400,5),(312,1256396400,4),(312,1269702000,5),(312,1288450800,4),(312,1301151600,8),(312,1414245600,4),(312,2147483647,4),(313,-2147483648,1),(313,-1017820800,2),(313,-766224000,1),(313,-745833600,3),(313,-733827600,1),(313,-716889600,3),(313,-699613200,1),(313,-683884800,3),(313,-670669200,1),(313,-652348800,3),(313,-639133200,1),(313,-620812800,3),(313,-607597200,1),(313,-589276800,3),(313,-576061200,1),(313,-562924800,3),(313,-541760400,1),(313,-528710400,3),(313,-510224400,1),(313,-497174400,3),(313,-478688400,1),(313,-465638400,3),(313,-449830800,1),(313,-434016000,3),(313,-418208400,1),(313,-402480000,3),(313,-386672400,1),(313,-370944000,3),(313,-355136400,1),(313,-339408000,3),(313,-323600400,1),(313,-302515200,3),(313,-291978000,1),(313,-270979200,3),(313,-260442000,1),(313,133977600,3),(313,149785200,1),(313,165513600,3),(313,181321200,1),(313,299606400,3),(313,307551600,1),(314,-2147483648,0),(314,-1441168631,1),(314,-1247547600,3),(314,354909600,2),(314,370717200,3),(314,386445600,2),(314,402253200,3),(314,417981600,2),(314,433789200,3),(314,449604000,2),(314,465336000,4),(314,481060800,5),(314,496785600,4),(314,512510400,5),(314,528235200,4),(314,543960000,5),(314,559684800,4),(314,575409600,5),(314,591134400,4),(314,606859200,5),(314,622584000,4),(314,638308800,5),(314,654638400,4),(314,670363200,6),(314,686091600,7),(314,694206000,1),(314,2147483647,1),(315,-2147483648,1),(315,-1441162751,2),(315,-405140400,4),(315,354916800,3),(315,370724400,4),(315,386452800,3),(315,402260400,4),(315,417988800,3),(315,433796400,4),(315,449611200,3),(315,465343200,5),(315,481068000,6),(315,496792800,5),(315,512517600,6),(315,528242400,5),(315,543967200,6),(315,559692000,5),(315,575416800,6),(315,591141600,5),(315,606866400,6),(315,622591200,5),(315,638316000,6),(315,654645600,5),(315,670370400,7),(315,686098800,8),(315,694213200,2),(315,701816400,9),(315,717537600,2),(315,733266000,9),(315,748987200,2),(315,764715600,9),(315,780436800,4),(315,796161600,3),(315,811882800,4),(315,828216000,3),(315,859662000,3),(315,877806000,4),(315,891115200,3),(315,909255600,4),(315,922564800,3),(315,941310000,4),(315,954014400,3),(315,972759600,4),(315,985464000,3),(315,1004209200,4),(315,1017518400,3),(315,1035658800,4),(315,1048968000,3),(315,1067108400,4),(315,1080417600,3),(315,1088276400,9),(315,1099177200,8),(315,1111878000,4),(315,2147483647,4),(316,-2147483648,0),(316,-1704165944,1),(316,-757394744,2),(316,247177800,4),(316,259272000,3),(316,277758000,4),(316,283982400,2),(316,290809800,5),(316,306531000,2),(316,322432200,5),(316,338499000,2),(316,673216200,5),(316,685481400,2),(316,701209800,5),(316,717103800,2),(316,732745800,5),(316,748639800,2),(316,764281800,5),(316,780175800,2),(316,795817800,5),(316,811711800,2),(316,827353800,5),(316,843247800,2),(316,858976200,5),(316,874870200,2),(316,890512200,5),(316,906406200,2),(316,922048200,5),(316,937942200,2),(316,953584200,5),(316,969478200,2),(316,985206600,5),(316,1001100600,2),(316,1016742600,5),(316,1032636600,2),(316,1048278600,5),(316,1064172600,2),(316,1079814600,5),(316,1095708600,2),(316,1111437000,5),(316,1127331000,2),(316,1206045000,5),(316,1221939000,2),(316,1237667400,5),(316,1253561400,2),(316,1269203400,5),(316,1285097400,2),(316,1300739400,5),(316,1316633400,2),(316,1332275400,5),(316,1348169400,2),(316,1363897800,5),(316,1379791800,2),(316,1395433800,5),(316,1411327800,2),(316,1426969800,5),(316,1442863800,2),(316,1458505800,5),(316,1474399800,2),(316,1490128200,5),(316,1506022200,2),(316,1521664200,5),(316,1537558200,2),(316,1553200200,5),(316,1569094200,2),(316,1584736200,5),(316,1600630200,2),(316,1616358600,5),(316,1632252600,2),(316,1647894600,5),(316,1663788600,2),(316,1679430600,5),(316,1695324600,2),(316,1710966600,5),(316,1726860600,2),(316,1742589000,5),(316,1758483000,2),(316,1774125000,5),(316,1790019000,2),(316,1805661000,5),(316,1821555000,2),(316,1837197000,5),(316,1853091000,2),(316,1868733000,5),(316,1884627000,2),(316,1900355400,5),(316,1916249400,2),(316,1931891400,5),(316,1947785400,2),(316,1963427400,5),(316,1979321400,2),(316,1994963400,5),(316,2010857400,2),(316,2026585800,5),(316,2042479800,2),(316,2058121800,5),(316,2074015800,2),(316,2089657800,5),(316,2105551800,2),(316,2121193800,5),(316,2137087800,2),(317,-2147483648,1),(317,-1641003640,3),(317,-933645600,2),(317,-857358000,3),(317,-844300800,2),(317,-825822000,3),(317,-812685600,2),(317,-794199600,3),(317,-779853600,2),(317,-762656400,3),(317,-748310400,2),(317,-731127600,3),(317,-681962400,4),(317,-673243200,2),(317,-667962000,3),(317,-652327200,2),(317,-636426000,3),(317,-622087200,2),(317,-608947200,3),(317,-591847200,2),(317,-572486400,3),(317,-558576000,2),(317,-542851200,3),(317,-527731200,2),(317,-514425600,3),(317,-490845600,2),(317,-482986800,3),(317,-459475200,2),(317,-451537200,3),(317,-428551200,2),(317,-418262400,3),(317,-400032000,2),(317,-387428400,3),(317,142380000,2),(317,150843600,3),(317,167176800,2),(317,178664400,3),(317,334015200,2),(317,337644000,3),(317,452556000,2),(317,462232800,3),(317,482277600,2),(317,495579600,3),(317,516751200,2),(317,526424400,3),(317,545436000,2),(317,558478800,3),(317,576626400,2),(317,589323600,3),(317,609890400,2),(317,620773200,3),(317,638316000,2),(317,651618000,3),(317,669765600,2),(317,683672400,3),(317,701820000,2),(317,715726800,3),(317,733701600,2),(317,747176400,3),(317,765151200,2),(317,778021200,3),(317,796600800,2),(317,810075600,3),(317,826840800,2),(317,842821200,3),(317,858895200,2),(317,874184400,3),(317,890344800,2),(317,905029200,3),(317,923011200,2),(317,936313200,3),(317,955670400,2),(317,970783200,3),(317,986770800,2),(317,1001282400,3),(317,1017356400,2),(317,1033941600,3),(317,1048806000,2),(317,1065132000,3),(317,1081292400,2),(317,1095804000,3),(317,1112313600,2),(317,1128812400,3),(317,1143763200,2),(317,1159657200,3),(317,1175212800,2),(317,1189897200,3),(317,1206662400,2),(317,1223161200,3),(317,1238112000,2),(317,1254006000,3),(317,1269561600,2),(317,1284246000,3),(317,1301616000,2),(317,1317510000,3),(317,1333065600,2),(317,1348354800,3),(317,1364515200,2),(317,1382828400,3),(317,1395964800,2),(317,1414278000,3),(317,1427414400,2),(317,1445727600,3),(317,1458864000,2),(317,1477782000,3),(317,1490313600,2),(317,1509231600,3),(317,1521763200,2),(317,1540681200,3),(317,1553817600,2),(317,1572130800,3),(317,1585267200,2),(317,1603580400,3),(317,1616716800,2),(317,1635634800,3),(317,1648166400,2),(317,1667084400,3),(317,1679616000,2),(317,1698534000,3),(317,1711670400,2),(317,1729983600,3),(317,1743120000,2),(317,1761433200,3),(317,1774569600,2),(317,1792882800,3),(317,1806019200,2),(317,1824937200,3),(317,1837468800,2),(317,1856386800,3),(317,1868918400,2),(317,1887836400,3),(317,1900972800,2),(317,1919286000,3),(317,1932422400,2),(317,1950735600,3),(317,1963872000,2),(317,1982790000,3),(317,1995321600,2),(317,2014239600,3),(317,2026771200,2),(317,2045689200,3),(317,2058220800,2),(317,2077138800,3),(317,2090275200,2),(317,2108588400,3),(317,2121724800,2),(317,2140038000,3),(318,-2147483648,0),(318,-706341516,1),(318,560025000,2),(318,2147483647,2),(319,-2147483648,0),(319,-706341516,1),(319,560025000,2),(319,2147483647,2),(320,-2147483648,3),(320,-683802000,1),(320,-672310800,2),(320,-654771600,1),(320,-640861200,2),(320,-620298000,1),(320,-609411600,2),(320,-588848400,1),(320,-577962000,2),(321,-2147483648,0),(321,-1578807591,1),(321,-1247551200,3),(321,354906000,2),(321,370713600,3),(321,386442000,2),(321,402249600,3),(321,417978000,2),(321,433785600,3),(321,449600400,2),(321,465332400,4),(321,481057200,5),(321,496782000,4),(321,512506800,5),(321,528231600,4),(321,543956400,5),(321,559681200,4),(321,575406000,5),(321,591130800,4),(321,606855600,5),(321,622580400,4),(321,638305200,5),(321,654634800,4),(321,670359600,6),(321,686088000,7),(321,695764800,4),(321,701809200,5),(321,717534000,4),(321,733258800,5),(321,748983600,4),(321,764708400,5),(321,780433200,4),(321,796158000,5),(321,811882800,4),(321,828212400,5),(321,846356400,4),(321,859662000,5),(321,877806000,4),(321,891111600,5),(321,909255600,4),(321,922561200,5),(321,941310000,4),(321,954010800,5),(321,972759600,4),(321,985460400,5),(321,1004209200,4),(321,1017514800,5),(321,1020193200,8),(321,1035662400,7),(321,1048968000,6),(321,1067112000,7),(321,1080417600,6),(321,1099166400,7),(321,1111867200,6),(321,1130616000,7),(321,1143316800,6),(321,1162065600,7),(321,1174766400,6),(321,1193515200,7),(321,1206820800,6),(321,1224964800,7),(321,1238270400,6),(321,1256414400,7),(321,1269720000,6),(321,1288468800,7),(321,1301169600,4),(321,1414263600,7),(321,1464465600,4),(321,2147483647,4),(322,-2147483648,0),(322,-1577951856,1),(322,-1172908656,2),(322,-880272000,3),(322,-766054800,4),(323,-2147483648,0),(323,-2032931252,1),(323,252435600,3),(323,417974400,2),(323,433782000,3),(323,449596800,2),(323,465318000,3),(323,481046400,2),(323,496767600,3),(323,512496000,2),(323,528217200,3),(323,543945600,2),(323,559666800,3),(323,575395200,2),(323,591116400,3),(323,606844800,2),(323,622566000,3),(323,638294400,2),(323,654620400,3),(323,670348800,2),(323,686070000,3),(323,701798400,2),(323,717519600,3),(323,733248000,2),(323,748969200,3),(323,764697600,2),(323,780418800,3),(323,796147200,2),(323,811868400,3),(323,828201600,2),(323,843922800,3),(323,859651200,2),(323,875372400,3),(323,891100800,2),(323,906822000,3),(323,988394400,2),(323,1001696400,3),(323,1017424800,2),(323,1033146000,3),(323,1048874400,2),(323,1064595600,3),(323,1080324000,2),(323,1096045200,3),(323,1111773600,2),(323,1127494800,3),(323,1143223200,2),(323,1159549200,3),(323,1427479200,2),(323,1443193200,3),(323,1458928800,2),(323,1474642800,3),(323,2147483647,3),(324,-2147483648,0),(324,-2032931252,1),(324,252435600,3),(324,417974400,2),(324,433782000,3),(324,449596800,2),(324,465318000,3),(324,481046400,2),(324,496767600,3),(324,512496000,2),(324,528217200,3),(324,543945600,2),(324,559666800,3),(324,575395200,2),(324,591116400,3),(324,606844800,2),(324,622566000,3),(324,638294400,2),(324,654620400,3),(324,670348800,2),(324,686070000,3),(324,701798400,2),(324,717519600,3),(324,733248000,2),(324,748969200,3),(324,764697600,2),(324,780418800,3),(324,796147200,2),(324,811868400,3),(324,828201600,2),(324,843922800,3),(324,859651200,2),(324,875372400,3),(324,891100800,2),(324,906822000,3),(324,988394400,2),(324,1001696400,3),(324,1017424800,2),(324,1033146000,3),(324,1048874400,2),(324,1064595600,3),(324,1080324000,2),(324,1096045200,3),(324,1111773600,2),(324,1127494800,3),(324,1143223200,2),(324,1159549200,3),(324,1427479200,2),(324,1443193200,3),(324,1458928800,2),(324,1474642800,3),(324,2147483647,3),(325,-2147483648,0),(325,-1325483420,1),(325,2147483647,1),(326,-2147483648,0),(326,-1579426374,1),(326,-1247558400,2),(326,354898800,4),(326,370699200,3),(326,386427600,4),(326,402235200,3),(326,417963600,4),(326,433771200,3),(326,449586000,4),(326,465318000,5),(326,481042800,6),(326,496767600,5),(326,512492400,6),(326,528217200,5),(326,543942000,6),(326,559666800,5),(326,575391600,6),(326,591116400,5),(326,606841200,6),(326,622566000,5),(326,638290800,6),(326,654620400,5),(326,670345200,7),(326,686073600,8),(326,695750400,5),(326,701794800,6),(326,717519600,5),(326,733244400,6),(326,748969200,5),(326,764694000,6),(326,780418800,5),(326,796143600,6),(326,811868400,5),(326,828198000,6),(326,846342000,5),(326,859647600,6),(326,877791600,5),(326,891097200,6),(326,909241200,5),(326,922546800,6),(326,941295600,5),(326,953996400,6),(326,972745200,5),(326,985446000,6),(326,1004194800,5),(326,1017500400,6),(326,1035644400,5),(326,1048950000,6),(326,1067094000,5),(326,1080399600,6),(326,1099148400,5),(326,1111849200,6),(326,1130598000,5),(326,1143298800,6),(326,1162047600,5),(326,1174748400,6),(326,1193497200,5),(326,1206802800,6),(326,1224946800,5),(326,1238252400,6),(326,1256396400,5),(326,1269702000,6),(326,1288450800,5),(326,1301151600,9),(326,1315828800,5),(326,1414249200,8),(326,2147483647,8),(327,-2147483648,1),(327,-1570084924,2),(327,2147483647,2),(328,-2147483648,0),(328,-1487321251,1),(328,-1247562000,3),(328,354895200,2),(328,370702800,3),(328,386431200,2),(328,402238800,3),(328,417967200,2),(328,433774800,3),(328,449589600,2),(328,465321600,4),(328,481046400,5),(328,496771200,4),(328,512496000,5),(328,528220800,4),(328,543945600,5),(328,559670400,4),(328,575395200,5),(328,591120000,4),(328,606844800,5),(328,622569600,4),(328,638294400,5),(328,654624000,4),(328,670348800,6),(328,686077200,7),(328,695754000,4),(328,701798400,5),(328,717523200,4),(328,733248000,5),(328,748972800,4),(328,764697600,5),(328,780422400,4),(328,796147200,5),(328,811872000,4),(328,828201600,5),(328,846345600,4),(328,859651200,5),(328,877795200,4),(328,891100800,5),(328,909244800,4),(328,922550400,5),(328,941299200,4),(328,954000000,5),(328,972748800,4),(328,985449600,5),(328,1004198400,4),(328,1017504000,5),(328,1035648000,4),(328,1048953600,5),(328,1067097600,4),(328,1080403200,5),(328,1099152000,4),(328,1111852800,5),(328,1130601600,4),(328,1143302400,5),(328,1162051200,4),(328,1174752000,5),(328,1193500800,4),(328,1206806400,5),(328,1224950400,4),(328,1238256000,5),(328,1256400000,4),(328,1269705600,5),(328,1288454400,4),(328,1301155200,8),(328,1414249200,4),(328,2147483647,4),(329,-2147483648,0),(329,-1579423138,1),(329,-1247558400,3),(329,354898800,2),(329,370706400,3),(329,386434800,2),(329,402242400,3),(329,417970800,2),(329,433778400,3),(329,449593200,2),(329,465325200,4),(329,481050000,5),(329,496774800,4),(329,512499600,5),(329,528224400,4),(329,543949200,5),(329,559674000,4),(329,575398800,5),(329,591123600,4),(329,606848400,5),(329,622573200,4),(329,638298000,5),(329,654627600,4),(329,670352400,6),(329,686080800,7),(329,695757600,4),(329,701802000,5),(329,717526800,4),(329,733251600,5),(329,748976400,4),(329,764701200,5),(329,780426000,4),(329,796150800,5),(329,811875600,4),(329,828205200,5),(329,846349200,4),(329,859654800,5),(329,877798800,4),(329,891104400,5),(329,909248400,4),(329,922554000,5),(329,941302800,4),(329,954003600,5),(329,972752400,4),(329,985453200,5),(329,1004202000,4),(329,1017507600,5),(329,1035651600,4),(329,1048957200,5),(329,1067101200,4),(329,1080406800,5),(329,1099155600,4),(329,1111856400,5),(329,1130605200,4),(329,1143306000,5),(329,1162054800,4),(329,1174755600,5),(329,1193504400,4),(329,1206810000,5),(329,1224954000,4),(329,1238259600,5),(329,1256403600,4),(329,1269709200,5),(329,1288458000,4),(329,1301158800,8),(329,1414252800,4),(329,2147483647,4),(330,-2147483648,1),(330,-1577946287,2),(330,-873268200,3),(330,-778410000,2),(330,2147483647,2),(331,-2147483648,0),(331,-1688270553,1),(331,-1592610305,2),(331,-1247544000,4),(331,354913200,3),(331,370720800,4),(331,386449200,3),(331,402256800,4),(331,417985200,3),(331,433792800,4),(331,449607600,3),(331,465339600,5),(331,481064400,6),(331,496789200,5),(331,512514000,6),(331,528238800,5),(331,543963600,6),(331,559688400,5),(331,575413200,6),(331,591138000,5),(331,606862800,6),(331,622587600,5),(331,638312400,6),(331,654642000,5),(331,670366800,7),(331,686095200,8),(331,695772000,5),(331,701816400,6),(331,717541200,5),(331,733266000,6),(331,748990800,5),(331,764715600,6),(331,780440400,5),(331,796165200,6),(331,811890000,5),(331,828219600,6),(331,846363600,5),(331,859669200,6),(331,877813200,5),(331,891118800,6),(331,909262800,5),(331,922568400,6),(331,941317200,5),(331,954018000,6),(331,972766800,5),(331,985467600,6),(331,1004216400,5),(331,1017522000,6),(331,1035666000,5),(331,1048971600,6),(331,1067115600,5),(331,1080421200,6),(331,1099170000,5),(331,1111870800,6),(331,1130619600,5),(331,1143320400,6),(331,1162069200,5),(331,1174770000,6),(331,1193518800,5),(331,1206824400,6),(331,1224968400,5),(331,1238274000,6),(331,1256418000,5),(331,1269723600,6),(331,1288472400,5),(331,1301173200,9),(331,1414267200,5),(331,2147483647,5),(332,-2147483648,0),(332,-1441162680,1),(332,-405140400,3),(332,354916800,2),(332,370724400,3),(332,386452800,2),(332,402260400,3),(332,417988800,2),(332,433796400,3),(332,449611200,2),(332,465343200,4),(332,481068000,5),(332,496792800,4),(332,512517600,5),(332,528242400,4),(332,543967200,5),(332,559692000,4),(332,575416800,5),(332,591141600,4),(332,606866400,5),(332,622591200,4),(332,638316000,5),(332,654645600,4),(332,670370400,6),(332,686098800,7),(332,701823600,6),(332,717548400,7),(332,733273200,6),(332,748998000,7),(332,764722800,6),(332,780447600,7),(332,796172400,6),(332,811897200,4),(332,852062400,3),(332,859672800,5),(332,877816800,4),(332,891122400,5),(332,909266400,4),(332,922572000,5),(332,941320800,4),(332,954021600,5),(332,972770400,4),(332,985471200,5),(332,1004220000,4),(332,1017525600,5),(332,1035669600,4),(332,1048975200,5),(332,1067119200,4),(332,1080424800,5),(332,1099173600,4),(332,1111874400,5),(332,1130623200,4),(332,1143324000,5),(332,1162072800,4),(332,1174773600,5),(332,1193522400,4),(332,1206828000,5),(332,1224972000,4),(332,1238277600,5),(332,1256421600,4),(332,1269727200,5),(332,1288476000,4),(332,1293825600,3),(332,1301176800,5),(332,1319925600,4),(332,2147483647,4),(333,-2147483648,1),(333,-1830376800,6),(333,-1689548400,2),(333,-1677794400,3),(333,-1667430000,4),(333,-1647730800,5),(333,-1635807600,4),(333,-1616194800,5),(333,-1604358000,4),(333,-1584658800,5),(333,-1572735600,4),(333,-1553036400,5),(333,-1541199600,4),(333,-1521500400,5),(333,-1442444400,4),(333,-1426806000,5),(333,-1379286000,4),(333,-1364770800,5),(333,-1348441200,4),(333,-1333321200,5),(333,-1316386800,4),(333,-1301266800,5),(333,-1284332400,4),(333,-1269817200,5),(333,-1221433200,4),(333,-1206918000,5),(333,-1191193200,4),(333,-1175468400,5),(333,-1127689200,4),(333,-1111964400,5),(333,-1096844400,4),(333,-1080514800,5),(333,-1063580400,4),(333,-1049065200,5),(333,-1033340400,4),(333,-1017615600,5),(333,-1002495600,4),(333,-986166000,5),(333,-969231600,4),(333,-950482800,5),(333,-942015600,4),(333,-922662000,5),(333,-906937200,4),(333,-891126000,5),(333,-877302000,4),(333,-873676800,7),(333,-864000000,4),(333,-857948400,5),(333,-845852400,4),(333,-842832000,7),(333,-831340800,4),(333,-825894000,5),(333,-814402800,4),(333,-810777600,7),(333,-799891200,4),(333,-794444400,5),(333,-782953200,4),(333,-779328000,7),(333,-768441600,4),(333,-762994800,5),(333,-749084400,4),(333,-733359600,5),(333,-717624000,4),(333,-701899200,5),(333,-686174400,4),(333,-670449600,5),(333,-654724800,4),(333,-639000000,5),(333,-591825600,4),(333,-575496000,5),(333,-559771200,4),(333,-544046400,5),(333,-528321600,4),(333,-512596800,5),(333,-496872000,4),(333,-481147200,5),(333,-465422400,4),(333,-449697600,5),(333,-433972800,4),(333,-417643200,5),(333,-401918400,4),(333,-386193600,5),(333,-370468800,4),(333,-354744000,5),(333,-339019200,4),(333,-323294400,5),(333,-307569600,4),(333,-291844800,5),(333,-276120000,4),(333,-260395200,5),(333,-244670400,4),(333,-228340800,5),(333,-212616000,4),(333,-196891200,5),(333,-181166400,4),(333,-165441600,5),(333,-149716800,4),(333,-133992000,5),(333,-118267200,9),(333,228272400,7),(333,243997200,8),(333,260326800,7),(333,276051600,8),(333,291776400,7),(333,307504800,8),(333,323226000,7),(333,338954400,8),(333,354679200,7),(333,370404000,8),(333,386128800,7),(333,401853600,8),(333,417582000,7),(333,433303200,8),(333,449028000,7),(333,465357600,8),(333,481082400,7),(333,496807200,8),(333,512532000,7),(333,528256800,8),(333,543981600,7),(333,559706400,8),(333,575431200,7),(333,591156000,8),(333,606880800,7),(333,622605600,8),(333,638330400,7),(333,654660000,8),(333,670384800,7),(333,686109600,8),(333,701834400,7),(333,717559200,10),(333,733280400,11),(333,749005200,12),(333,764730000,11),(333,780454800,12),(333,796179600,11),(333,811904400,12),(333,828234000,11),(333,846378000,12),(333,859683600,11),(333,877827600,12),(333,891133200,11),(333,909277200,12),(333,922582800,11),(333,941331600,12),(333,954032400,11),(333,972781200,12),(333,985482000,11),(333,1004230800,12),(333,1017536400,11),(333,1035680400,12),(333,1048986000,11),(333,1067130000,12),(333,1080435600,11),(333,1099184400,12),(333,1111885200,11),(333,1130634000,12),(333,1143334800,11),(333,1162083600,12),(333,1174784400,11),(333,1193533200,12),(333,1206838800,11),(333,1224982800,12),(333,1238288400,11),(333,1256432400,12),(333,1269738000,11),(333,1288486800,12),(333,1301187600,11),(333,1319936400,12),(333,1332637200,11),(333,1351386000,12),(333,1364691600,11),(333,1382835600,12),(333,1396141200,11),(333,1414285200,12),(333,1427590800,11),(333,1445734800,12),(333,1459040400,11),(333,1477789200,12),(333,1490490000,11),(333,1509238800,12),(333,1521939600,11),(333,1540688400,12),(333,1553994000,11),(333,1572138000,12),(333,1585443600,11),(333,1603587600,12),(333,1616893200,11),(333,1635642000,12),(333,1648342800,11),(333,1667091600,12),(333,1679792400,11),(333,1698541200,12),(333,1711846800,11),(333,1729990800,12),(333,1743296400,11),(333,1761440400,12),(333,1774746000,11),(333,1792890000,12),(333,1806195600,11),(333,1824944400,12),(333,1837645200,11),(333,1856394000,12),(333,1869094800,11),(333,1887843600,12),(333,1901149200,11),(333,1919293200,12),(333,1932598800,11),(333,1950742800,12),(333,1964048400,11),(333,1982797200,12),(333,1995498000,11),(333,2014246800,12),(333,2026947600,11),(333,2045696400,12),(333,2058397200,11),(333,2077146000,12),(333,2090451600,11),(333,2108595600,12),(333,2121901200,11),(333,2140045200,12),(333,2147483647,12),(334,-2147483648,0),(334,-1262281242,1),(334,136360800,2),(334,152082000,1),(334,167810400,2),(334,183531600,1),(334,199260000,2),(334,215586000,1),(334,230709600,2),(334,247035600,1),(334,262764000,2),(334,278485200,1),(334,294213600,2),(334,309934800,1),(334,325663200,2),(334,341384400,1),(334,357112800,2),(334,372834000,1),(334,388562400,2),(334,404888400,1),(334,420012000,2),(334,436338000,1),(334,452066400,2),(334,467787600,1),(334,483516000,2),(334,499237200,1),(334,514965600,2),(334,530686800,1),(334,544600800,2),(334,562136400,1),(334,576050400,2),(334,594190800,1),(334,607500000,2),(334,625640400,1),(334,638949600,2),(334,657090000,1),(334,671004000,2),(334,688539600,1),(334,702453600,2),(334,719989200,1),(334,733903200,2),(334,752043600,1),(334,765352800,2),(334,783493200,1),(334,796802400,2),(334,814942800,1),(334,828856800,2),(334,846392400,1),(334,860306400,2),(334,877842000,1),(334,891756000,2),(334,909291600,1),(334,923205600,2),(334,941346000,1),(334,954655200,2),(334,972795600,1),(334,986104800,2),(334,1004245200,1),(334,1018159200,2),(334,1035694800,1),(334,1049608800,2),(334,1067144400,1),(334,1081058400,2),(334,1099198800,1),(334,1112508000,2),(334,1130648400,1),(334,1143957600,2),(334,1162098000,1),(334,1173592800,2),(334,1194152400,1),(334,1205042400,2),(334,1225602000,1),(334,1236492000,2),(334,1257051600,1),(334,1268546400,2),(334,1289106000,1),(334,1299996000,2),(334,1320555600,1),(334,1331445600,2),(334,1352005200,1),(334,1362895200,2),(334,1383454800,1),(334,1394344800,2),(334,1414904400,1),(334,1425794400,2),(334,1446354000,1),(334,1457848800,2),(334,1478408400,1),(334,1489298400,2),(334,1509858000,1),(334,1520748000,2),(334,1541307600,1),(334,1552197600,2),(334,1572757200,1),(334,1583647200,2),(334,1604206800,1),(334,1615701600,2),(334,1636261200,1),(334,1647151200,2),(334,1667710800,1),(334,1678600800,2),(334,1699160400,1),(334,1710050400,2),(334,1730610000,1),(334,1741500000,2),(334,1762059600,1),(334,1772949600,2),(334,1793509200,1),(334,1805004000,2),(334,1825563600,1),(334,1836453600,2),(334,1857013200,1),(334,1867903200,2),(334,1888462800,1),(334,1899352800,2),(334,1919912400,1),(334,1930802400,2),(334,1951362000,1),(334,1962856800,2),(334,1983416400,1),(334,1994306400,2),(334,2014866000,1),(334,2025756000,2),(334,2046315600,1),(334,2057205600,2),(334,2077765200,1),(334,2088655200,2),(334,2109214800,1),(334,2120104800,2),(334,2140664400,1),(335,-2147483648,0),(335,-1509663504,1),(335,-733874400,2),(335,323827200,3),(335,338950800,4),(335,354675600,5),(335,370400400,4),(335,386125200,5),(335,401850000,4),(335,417574800,5),(335,433299600,4),(335,449024400,5),(335,465354000,4),(335,481078800,5),(335,496803600,4),(335,512528400,5),(335,528253200,4),(335,543978000,5),(335,559702800,4),(335,575427600,5),(335,591152400,4),(335,606877200,5),(335,622602000,4),(335,638326800,5),(335,654656400,4),(335,670381200,5),(335,686106000,4),(335,701830800,5),(335,717555600,4),(335,733280400,5),(335,749005200,4),(335,764730000,5),(335,780454800,4),(335,796179600,5),(335,811904400,4),(335,828234000,5),(335,846378000,4),(335,859683600,5),(335,877827600,4),(335,891133200,5),(335,909277200,4),(335,922582800,5),(335,941331600,4),(335,954032400,5),(335,972781200,4),(335,985482000,5),(335,1004230800,4),(335,1017536400,5),(335,1035680400,4),(335,1048986000,5),(335,1067130000,4),(335,1080435600,5),(335,1099184400,4),(335,1111885200,5),(335,1130634000,4),(335,1143334800,5),(335,1162083600,4),(335,1174784400,5),(335,1193533200,4),(335,1206838800,5),(335,1224982800,4),(335,1238288400,5),(335,1256432400,4),(335,1269738000,5),(335,1288486800,4),(335,1301187600,5),(335,1319936400,4),(335,1332637200,5),(335,1351386000,4),(335,1364691600,5),(335,1382835600,4),(335,1396141200,5),(335,1414285200,4),(335,1427590800,5),(335,1445734800,4),(335,1459040400,5),(335,1477789200,4),(335,1490490000,5),(335,1509238800,4),(335,1521939600,5),(335,1540688400,4),(335,1553994000,5),(335,1572138000,4),(335,1585443600,5),(335,1603587600,4),(335,1616893200,5),(335,1635642000,4),(335,1648342800,5),(335,1667091600,4),(335,1679792400,5),(335,1698541200,4),(335,1711846800,5),(335,1729990800,4),(335,1743296400,5),(335,1761440400,4),(335,1774746000,5),(335,1792890000,4),(335,1806195600,5),(335,1824944400,4),(335,1837645200,5),(335,1856394000,4),(335,1869094800,5),(335,1887843600,4),(335,1901149200,5),(335,1919293200,4),(335,1932598800,5),(335,1950742800,4),(335,1964048400,5),(335,1982797200,4),(335,1995498000,5),(335,2014246800,4),(335,2026947600,5),(335,2045696400,4),(335,2058397200,5),(335,2077146000,4),(335,2090451600,5),(335,2108595600,4),(335,2121901200,5),(335,2140045200,4),(336,-2147483648,0),(336,-1830376800,1),(336,-862610400,2),(336,-764118000,3),(336,186120000,4),(336,2147483647,4),(337,-2147483648,0),(337,-1955748776,1),(337,354675600,2),(337,370400400,3),(337,386125200,2),(337,401850000,3),(337,417574800,2),(337,433299600,3),(337,449024400,2),(337,465354000,3),(337,481078800,2),(337,496803600,3),(337,512528400,2),(337,528253200,3),(337,543978000,2),(337,559702800,3),(337,575427600,2),(337,591152400,3),(337,606877200,2),(337,622602000,3),(337,638326800,2),(337,654656400,3),(337,670381200,2),(337,686106000,3),(337,701830800,2),(337,717555600,3),(337,733280400,2),(337,749005200,3),(337,764730000,2),(337,780454800,3),(337,796179600,2),(337,811904400,3),(337,828234000,2),(337,846378000,3),(337,859683600,2),(337,877827600,3),(337,891133200,2),(337,909277200,3),(337,922582800,2),(337,941331600,3),(337,954032400,2),(337,972781200,3),(337,985482000,2),(337,1004230800,3),(337,1017536400,2),(337,1035680400,3),(337,1048986000,2),(337,1067130000,3),(337,1080435600,2),(337,1099184400,3),(337,1111885200,2),(337,1130634000,3),(337,1143334800,2),(337,1162083600,3),(337,1174784400,2),(337,1193533200,3),(337,1206838800,2),(337,1224982800,3),(337,1238288400,2),(337,1256432400,3),(337,1269738000,2),(337,1288486800,3),(337,1301187600,2),(337,1319936400,3),(337,1332637200,2),(337,1351386000,3),(337,1364691600,2),(337,1382835600,3),(337,1396141200,2),(337,1414285200,3),(337,1427590800,2),(337,1445734800,3),(337,1459040400,2),(337,1477789200,3),(337,1490490000,2),(337,1509238800,3),(337,1521939600,2),(337,1540688400,3),(337,1553994000,2),(337,1572138000,3),(337,1585443600,2),(337,1603587600,3),(337,1616893200,2),(337,1635642000,3),(337,1648342800,2),(337,1667091600,3),(337,1679792400,2),(337,1698541200,3),(337,1711846800,2),(337,1729990800,3),(337,1743296400,2),(337,1761440400,3),(337,1774746000,2),(337,1792890000,3),(337,1806195600,2),(337,1824944400,3),(337,1837645200,2),(337,1856394000,3),(337,1869094800,2),(337,1887843600,3),(337,1901149200,2),(337,1919293200,3),(337,1932598800,2),(337,1950742800,3),(337,1964048400,2),(337,1982797200,3),(337,1995498000,2),(337,2014246800,3),(337,2026947600,2),(337,2045696400,3),(337,2058397200,2),(337,2077146000,3),(337,2090451600,2),(337,2108595600,3),(337,2121901200,2),(337,2140045200,3),(338,-2147483648,0),(338,-1955748776,1),(338,354675600,2),(338,370400400,3),(338,386125200,2),(338,401850000,3),(338,417574800,2),(338,433299600,3),(338,449024400,2),(338,465354000,3),(338,481078800,2),(338,496803600,3),(338,512528400,2),(338,528253200,3),(338,543978000,2),(338,559702800,3),(338,575427600,2),(338,591152400,3),(338,606877200,2),(338,622602000,3),(338,638326800,2),(338,654656400,3),(338,670381200,2),(338,686106000,3),(338,701830800,2),(338,717555600,3),(338,733280400,2),(338,749005200,3),(338,764730000,2),(338,780454800,3),(338,796179600,2),(338,811904400,3),(338,828234000,2),(338,846378000,3),(338,859683600,2),(338,877827600,3),(338,891133200,2),(338,909277200,3),(338,922582800,2),(338,941331600,3),(338,954032400,2),(338,972781200,3),(338,985482000,2),(338,1004230800,3),(338,1017536400,2),(338,1035680400,3),(338,1048986000,2),(338,1067130000,3),(338,1080435600,2),(338,1099184400,3),(338,1111885200,2),(338,1130634000,3),(338,1143334800,2),(338,1162083600,3),(338,1174784400,2),(338,1193533200,3),(338,1206838800,2),(338,1224982800,3),(338,1238288400,2),(338,1256432400,3),(338,1269738000,2),(338,1288486800,3),(338,1301187600,2),(338,1319936400,3),(338,1332637200,2),(338,1351386000,3),(338,1364691600,2),(338,1382835600,3),(338,1396141200,2),(338,1414285200,3),(338,1427590800,2),(338,1445734800,3),(338,1459040400,2),(338,1477789200,3),(338,1490490000,2),(338,1509238800,3),(338,1521939600,2),(338,1540688400,3),(338,1553994000,2),(338,1572138000,3),(338,1585443600,2),(338,1603587600,3),(338,1616893200,2),(338,1635642000,3),(338,1648342800,2),(338,1667091600,3),(338,1679792400,2),(338,1698541200,3),(338,1711846800,2),(338,1729990800,3),(338,1743296400,2),(338,1761440400,3),(338,1774746000,2),(338,1792890000,3),(338,1806195600,2),(338,1824944400,3),(338,1837645200,2),(338,1856394000,3),(338,1869094800,2),(338,1887843600,3),(338,1901149200,2),(338,1919293200,3),(338,1932598800,2),(338,1950742800,3),(338,1964048400,2),(338,1982797200,3),(338,1995498000,2),(338,2014246800,3),(338,2026947600,2),(338,2045696400,3),(338,2058397200,2),(338,2077146000,3),(338,2090451600,2),(338,2108595600,3),(338,2121901200,2),(338,2140045200,3),(339,-2147483648,2),(339,-1691884800,1),(339,-1680573600,2),(339,-927511200,1),(339,-857257200,3),(339,-844556400,4),(339,-828226800,3),(339,-812502000,4),(339,-796777200,3),(339,-781052400,4),(339,-765327600,3),(339,-340844400,4),(339,-324514800,3),(339,-308790000,4),(339,-293065200,3),(339,-277340400,4),(339,-261615600,3),(339,-245890800,4),(339,-230166000,3),(339,-214441200,4),(339,-198716400,3),(339,-182991600,4),(339,-166662000,3),(339,-147913200,4),(339,-135212400,3),(339,315529200,2),(339,323830800,5),(339,338950800,6),(339,354675600,5),(339,370400400,6),(339,386125200,5),(339,401850000,6),(339,417574800,5),(339,433299600,6),(339,449024400,5),(339,465354000,6),(339,481078800,5),(339,496803600,6),(339,512528400,5),(339,528253200,6),(339,543978000,5),(339,559702800,6),(339,575427600,5),(339,591152400,6),(339,606877200,5),(339,622602000,6),(339,638326800,5),(339,654656400,6),(339,670381200,5),(339,686106000,6),(339,701830800,5),(339,717555600,6),(339,733280400,5),(339,749005200,6),(339,764730000,5),(339,780454800,6),(339,796179600,5),(339,811904400,6),(339,828234000,5),(339,846378000,6),(339,859683600,5),(339,877827600,6),(339,891133200,5),(339,909277200,6),(339,922582800,5),(339,941331600,6),(339,954032400,5),(339,972781200,6),(339,985482000,5),(339,1004230800,6),(339,1017536400,5),(339,1035680400,6),(339,1048986000,5),(339,1067130000,6),(339,1080435600,5),(339,1099184400,6),(339,1111885200,5),(339,1130634000,6),(339,1143334800,5),(339,1162083600,6),(339,1174784400,5),(339,1193533200,6),(339,1206838800,5),(339,1224982800,6),(339,1238288400,5),(339,1256432400,6),(339,1269738000,5),(339,1288486800,6),(339,1301187600,5),(339,1319936400,6),(339,1332637200,5),(339,1351386000,6),(339,1364691600,5),(339,1382835600,6),(339,1396141200,5),(339,1414285200,6),(339,1427590800,5),(339,1445734800,6),(339,1459040400,5),(339,1477789200,6),(339,1490490000,5),(339,1509238800,6),(339,1521939600,5),(339,1540688400,6),(339,1553994000,5),(339,1572138000,6),(339,1585443600,5),(339,1603587600,6),(339,1616893200,5),(339,1635642000,6),(339,1648342800,5),(339,1667091600,6),(339,1679792400,5),(339,1698541200,6),(339,1711846800,5),(339,1729990800,6),(339,1743296400,5),(339,1761440400,6),(339,1774746000,5),(339,1792890000,6),(339,1806195600,5),(339,1824944400,6),(339,1837645200,5),(339,1856394000,6),(339,1869094800,5),(339,1887843600,6),(339,1901149200,5),(339,1919293200,6),(339,1932598800,5),(339,1950742800,6),(339,1964048400,5),(339,1982797200,6),(339,1995498000,5),(339,2014246800,6),(339,2026947600,5),(339,2045696400,6),(339,2058397200,5),(339,2077146000,6),(339,2090451600,5),(339,2108595600,6),(339,2121901200,5),(339,2140045200,6),(340,-2147483648,1),(340,-1830380400,6),(340,-1689552000,2),(340,-1677798000,3),(340,-1667433600,4),(340,-1647734400,5),(340,-1635811200,4),(340,-1616198400,5),(340,-1604361600,4),(340,-1584662400,5),(340,-1572739200,4),(340,-1553040000,5),(340,-1541203200,4),(340,-1521504000,5),(340,-1442448000,4),(340,-1426809600,5),(340,-1379289600,4),(340,-1364774400,5),(340,-1348444800,4),(340,-1333324800,5),(340,-1316390400,4),(340,-1301270400,5),(340,-1284336000,4),(340,-1269820800,5),(340,-1221436800,4),(340,-1206921600,5),(340,-1191196800,4),(340,-1175472000,5),(340,-1127692800,4),(340,-1111968000,5),(340,-1096848000,4),(340,-1080518400,5),(340,-1063584000,4),(340,-1049068800,5),(340,-1033344000,4),(340,-1017619200,5),(340,-1002499200,4),(340,-986169600,5),(340,-969235200,4),(340,-950486400,5),(340,-942019200,4),(340,-922665600,5),(340,-906940800,4),(340,-891129600,5),(340,-877305600,4),(340,-873680400,7),(340,-864003600,4),(340,-857952000,5),(340,-845856000,4),(340,-842835600,7),(340,-831344400,4),(340,-825897600,5),(340,-814406400,4),(340,-810781200,7),(340,-799894800,4),(340,-794448000,5),(340,-782956800,4),(340,-779331600,7),(340,-768445200,4),(340,-762998400,5),(340,-749088000,4),(340,-733363200,5),(340,-717627600,4),(340,-701902800,5),(340,-686178000,4),(340,-670453200,5),(340,-654728400,4),(340,-639003600,5),(340,-591829200,4),(340,-575499600,5),(340,-559774800,4),(340,-544050000,5),(340,-528325200,4),(340,-512600400,5),(340,-496875600,4),(340,-481150800,5),(340,-465426000,4),(340,-449701200,5),(340,-433976400,4),(340,-417646800,5),(340,-401922000,4),(340,-386197200,5),(340,-370472400,4),(340,-354747600,5),(340,-339022800,4),(340,-323298000,5),(340,-307573200,4),(340,-291848400,5),(340,-276123600,4),(340,-260398800,5),(340,-244674000,4),(340,-228344400,5),(340,-212619600,4),(340,-196894800,5),(340,-181170000,4),(340,-165445200,5),(340,-149720400,4),(340,-133995600,5),(340,-118270800,10),(340,228268800,8),(340,243993600,9),(340,260323200,8),(340,276048000,9),(340,291772800,8),(340,307501200,9),(340,323222400,8),(340,338950800,9),(340,354675600,8),(340,370400400,9),(340,386125200,8),(340,401850000,9),(340,417578400,8),(340,433299600,11),(340,449024400,12),(340,465354000,11),(340,481078800,12),(340,496803600,11),(340,512528400,12),(340,528253200,11),(340,543978000,12),(340,559702800,11),(340,575427600,12),(340,591152400,11),(340,606877200,12),(340,622602000,11),(340,638326800,12),(340,654656400,11),(340,670381200,12),(340,686106000,11),(340,701830800,12),(340,717555600,11),(340,733280400,12),(340,749005200,11),(340,764730000,12),(340,780454800,11),(340,796179600,12),(340,811904400,11),(340,828234000,12),(340,846378000,11),(340,859683600,12),(340,877827600,11),(340,891133200,12),(340,909277200,11),(340,922582800,12),(340,941331600,11),(340,954032400,12),(340,972781200,11),(340,985482000,12),(340,1004230800,11),(340,1017536400,12),(340,1035680400,11),(340,1048986000,12),(340,1067130000,11),(340,1080435600,12),(340,1099184400,11),(340,1111885200,12),(340,1130634000,11),(340,1143334800,12),(340,1162083600,11),(340,1174784400,12),(340,1193533200,11),(340,1206838800,12),(340,1224982800,11),(340,1238288400,12),(340,1256432400,11),(340,1269738000,12),(340,1288486800,11),(340,1301187600,12),(340,1319936400,11),(340,1332637200,12),(340,1351386000,11),(340,1364691600,12),(340,1382835600,11),(340,1396141200,12),(340,1414285200,11),(340,1427590800,12),(340,1445734800,11),(340,1459040400,12),(340,1477789200,11),(340,1490490000,12),(340,1509238800,11),(340,1521939600,12),(340,1540688400,11),(340,1553994000,12),(340,1572138000,11),(340,1585443600,12),(340,1603587600,11),(340,1616893200,12),(340,1635642000,11),(340,1648342800,12),(340,1667091600,11),(340,1679792400,12),(340,1698541200,11),(340,1711846800,12),(340,1729990800,11),(340,1743296400,12),(340,1761440400,11),(340,1774746000,12),(340,1792890000,11),(340,1806195600,12),(340,1824944400,11),(340,1837645200,12),(340,1856394000,11),(340,1869094800,12),(340,1887843600,11),(340,1901149200,12),(340,1919293200,11),(340,1932598800,12),(340,1950742800,11),(340,1964048400,12),(340,1982797200,11),(340,1995498000,12),(340,2014246800,11),(340,2026947600,12),(340,2045696400,11),(340,2058397200,12),(340,2077146000,11),(340,2090451600,12),(340,2108595600,11),(340,2121901200,12),(340,2140045200,11),(341,-2147483648,0),(341,-1956609120,2),(341,-1668211200,1),(341,-1647212400,2),(341,-1636675200,1),(341,-1613430000,2),(341,-1605139200,1),(341,-1581894000,2),(341,-1539561600,1),(341,-1531350000,2),(341,-968025600,1),(341,-952293600,2),(341,-942008400,1),(341,-920239200,3),(341,-909957600,4),(341,-888789600,3),(341,-877903200,4),(341,-857944800,3),(341,-846453600,4),(341,-826495200,3),(341,-815004000,4),(341,-795045600,3),(341,-783554400,4),(341,-762991200,3),(341,-752104800,4),(341,-731541600,3),(341,-717631200,4),(341,-700092000,3),(341,-686181600,4),(341,-668642400,3),(341,-654732000,4),(341,-636588000,3),(341,-623282400,4),(341,-605743200,3),(341,-591832800,4),(341,-573688800,3),(341,-559778400,4),(341,-542239200,3),(341,-528328800,4),(341,-510789600,3),(341,-496879200,4),(341,-479340000,3),(341,-465429600,4),(341,-447890400,3),(341,-433980000,4),(341,-415836000,3),(341,-401925600,4),(341,-384386400,3),(341,-370476000,4),(341,-352936800,3),(341,-339026400,4),(341,-321487200,3),(341,-307576800,4),(341,-290037600,3),(341,-276127200,4),(341,-258588000,3),(341,-244677600,4),(341,-226533600,3),(341,-212623200,4),(341,-195084000,3),(341,-181173600,4),(341,-163634400,3),(341,-149724000,4),(341,-132184800,3),(341,-118274400,4),(341,-100735200,3),(341,-86824800,4),(341,-68680800,3),(341,-54770400,5),(342,-2147483648,1),(342,2147483647,1),(343,-2147483648,0),(343,-1830383032,1),(344,-2147483648,1),(344,-1824235716,3),(344,-1018209600,2),(344,-1003093200,3),(344,-986760000,2),(344,-971643600,3),(344,-954705600,2),(344,-939589200,3),(344,-923256000,2),(344,-908139600,3),(344,-891806400,2),(344,-876690000,3),(344,-860356800,2),(344,-852066000,3),(344,420609600,5),(344,433306800,4),(344,452052000,5),(344,464151600,4),(344,483501600,5),(344,495601200,2),(344,514350000,3),(344,527054400,2),(344,545799600,3),(344,558504000,2),(344,577249200,3),(344,589953600,2),(344,608698800,3),(344,621403200,2),(344,640753200,3),(344,652852800,2),(344,672202800,3),(344,684907200,2),(344,703652400,3),(344,716356800,2),(344,735102000,3),(344,747806400,2),(344,766551600,3),(344,779256000,2),(344,798001200,3),(344,810705600,2),(344,830055600,3),(344,842760000,2),(344,861505200,3),(344,874209600,2),(344,892954800,3),(344,905659200,2),(344,924404400,3),(344,937108800,2),(344,955854000,3),(344,968558400,2),(344,987310800,3),(344,999410400,2),(344,1019365200,3),(344,1030860000,2),(344,1050814800,3),(344,1062914400,2),(344,1082264400,3),(344,1094364000,2),(344,1113714000,3),(344,1125813600,2),(344,1145163600,3),(344,1157263200,2),(344,1176613200,3),(344,1188712800,2),(344,1208667600,3),(344,1220767200,2),(344,1240117200,3),(344,1252216800,2),(344,1271566800,3),(344,1283666400,5),(344,2147483647,5),(345,-2147483648,2),(345,-1672567140,1),(345,-1665392400,2),(345,-883641600,1),(345,-876128400,2),(345,-860400000,1),(345,-844678800,2),(345,-828345600,1),(345,-813229200,2),(345,57686400,3),(345,67968000,4),(345,89136000,3),(345,100022400,4),(345,120585600,3),(345,131472000,4),(345,152035200,3),(345,162921600,4),(345,183484800,3),(345,194976000,4),(345,215539200,3),(345,226425600,4),(345,246988800,3),(345,257875200,4),(345,278438400,3),(345,289324800,4),(345,309888000,3),(345,320774400,4),(345,341337600,3),(345,352224000,4),(345,372787200,3),(345,386697600,4),(345,404841600,3),(345,415728000,4),(345,436291200,3),(345,447177600,4),(345,467740800,3),(345,478627200,4),(345,499190400,3),(345,511286400,4),(345,530035200,3),(345,542736000,4),(345,562089600,3),(345,574790400,4),(345,594144000,3),(345,606240000,4),(345,625593600,3),(345,636480000,4),(345,657043200,3),(345,667929600,4),(345,688492800,3),(345,699379200,4),(345,719942400,3),(345,731433600,4),(345,751996800,3),(345,762883200,4),(345,783446400,3),(345,794332800,4),(345,814896000,3),(345,828201600,4),(345,846345600,3),(345,859651200,4),(345,877795200,3),(345,891100800,4),(345,909244800,3),(345,922550400,4),(345,941299200,3),(345,954000000,4),(345,967305600,3),(345,985449600,4),(345,1004198400,3),(345,1017504000,4),(345,1035648000,3),(345,1048953600,4),(345,1067097600,3),(345,1080403200,4),(345,1099152000,3),(345,1111852800,4),(345,1130601600,3),(345,1143907200,4),(345,1162051200,3),(345,1174752000,4),(345,1193500800,3),(345,1207411200,4),(345,1223136000,3),(345,1238860800,4),(345,1254585600,3),(345,1270310400,4),(345,1286035200,3),(345,1301760000,4),(345,1317484800,3),(345,1333209600,4),(345,1349539200,3),(345,1365264000,4),(345,1380988800,3),(345,1396713600,4),(345,1412438400,3),(345,1428163200,4),(345,1443888000,3),(345,1459612800,4),(345,1475337600,3),(345,1491062400,4),(345,1506787200,3),(345,1522512000,4),(345,1538841600,3),(345,1554566400,4),(345,1570291200,3),(345,1586016000,4),(345,1601740800,3),(345,1617465600,4),(345,1633190400,3),(345,1648915200,4),(345,1664640000,3),(345,1680364800,4),(345,1696089600,3),(345,1712419200,4),(345,1728144000,3),(345,1743868800,4),(345,1759593600,3),(345,1775318400,4),(345,1791043200,3),(345,1806768000,4),(345,1822492800,3),(345,1838217600,4),(345,1853942400,3),(345,1869667200,4),(345,1885996800,3),(345,1901721600,4),(345,1917446400,3),(345,1933171200,4),(345,1948896000,3),(345,1964620800,4),(345,1980345600,3),(345,1996070400,4),(345,2011795200,3),(345,2027520000,4),(345,2043244800,3),(345,2058969600,4),(345,2075299200,3),(345,2091024000,4),(345,2106748800,3),(345,2122473600,4),(345,2138198400,3),(346,-2147483648,2),(346,-1672565340,1),(346,-1665390600,2),(346,-883639800,1),(346,-876126600,2),(346,-860398200,1),(346,-844677000,2),(346,-828343800,1),(346,-813227400,2),(346,57688200,3),(346,67969800,4),(346,89137800,3),(346,100024200,4),(346,120587400,3),(346,131473800,4),(346,152037000,3),(346,162923400,4),(346,183486600,3),(346,194977800,4),(346,215541000,3),(346,226427400,4),(346,246990600,3),(346,257877000,4),(346,278440200,3),(346,289326600,4),(346,309889800,3),(346,320776200,4),(346,341339400,3),(346,352225800,4),(346,372789000,3),(346,384280200,4),(346,404843400,3),(346,415729800,4),(346,436293000,3),(346,447179400,4),(346,467742600,3),(346,478629000,4),(346,499192200,3),(346,511288200,4),(346,530037000,3),(346,542737800,4),(346,562091400,3),(346,574792200,4),(346,594145800,3),(346,606241800,4),(346,625595400,3),(346,637691400,4),(346,657045000,3),(346,667931400,4),(346,688494600,3),(346,701195400,4),(346,719944200,3),(346,731435400,4),(346,751998600,3),(346,764094600,4),(346,783448200,3),(346,796149000,4),(346,814897800,3),(346,828203400,4),(346,846347400,3),(346,859653000,4),(346,877797000,3),(346,891102600,4),(346,909246600,3),(346,922552200,4),(346,941301000,3),(346,954001800,4),(346,972750600,3),(346,985451400,4),(346,1004200200,3),(346,1017505800,4),(346,1035649800,3),(346,1048955400,4),(346,1067099400,3),(346,1080405000,4),(346,1099153800,3),(346,1111854600,4),(346,1130603400,3),(346,1143909000,4),(346,1162053000,3),(346,1174753800,4),(346,1193502600,3),(346,1207413000,4),(346,1223137800,3),(346,1238862600,4),(346,1254587400,3),(346,1270312200,4),(346,1286037000,3),(346,1301761800,4),(346,1317486600,3),(346,1333211400,4),(346,1349541000,3),(346,1365265800,4),(346,1380990600,3),(346,1396715400,4),(346,1412440200,3),(346,1428165000,4),(346,1443889800,3),(346,1459614600,4),(346,1475339400,3),(346,1491064200,4),(346,1506789000,3),(346,1522513800,4),(346,1538843400,3),(346,1554568200,4),(346,1570293000,3),(346,1586017800,4),(346,1601742600,3),(346,1617467400,4),(346,1633192200,3),(346,1648917000,4),(346,1664641800,3),(346,1680366600,4),(346,1696091400,3),(346,1712421000,4),(346,1728145800,3),(346,1743870600,4),(346,1759595400,3),(346,1775320200,4),(346,1791045000,3),(346,1806769800,4),(346,1822494600,3),(346,1838219400,4),(346,1853944200,3),(346,1869669000,4),(346,1885998600,3),(346,1901723400,4),(346,1917448200,3),(346,1933173000,4),(346,1948897800,3),(346,1964622600,4),(346,1980347400,3),(346,1996072200,4),(346,2011797000,3),(346,2027521800,4),(346,2043246600,3),(346,2058971400,4),(346,2075301000,3),(346,2091025800,4),(346,2106750600,3),(346,2122475400,4),(346,2138200200,3),(347,-2147483648,2),(347,-1672567140,1),(347,-1665392400,2),(347,-883641600,1),(347,-876128400,2),(347,-860400000,1),(347,-844678800,2),(347,-828345600,1),(347,-813229200,2),(347,57686400,3),(347,67968000,4),(347,625593600,3),(347,636480000,4),(347,657043200,3),(347,667929600,4),(347,688492800,3),(347,699379200,4),(348,-2147483648,2),(348,-1672565340,1),(348,-1665390600,2),(348,-883639800,1),(348,-876126600,2),(348,-860398200,1),(348,-844677000,2),(348,-828343800,1),(348,-813227400,2),(348,57688200,3),(348,67969800,4),(348,89137800,3),(348,100024200,4),(348,120587400,3),(348,131473800,4),(348,152037000,3),(348,162923400,4),(348,183486600,3),(348,194977800,4),(348,215541000,3),(348,226427400,4),(348,246990600,3),(348,257877000,4),(348,278440200,3),(348,289326600,4),(348,309889800,3),(348,320776200,4),(348,341339400,3),(348,352225800,4),(348,372789000,3),(348,386699400,4),(348,404843400,3),(348,415729800,4),(348,436293000,3),(348,447179400,4),(348,467742600,3),(348,478629000,4),(348,499192200,3),(348,511288200,4),(348,530037000,3),(348,542737800,4),(348,562091400,3),(348,574792200,4),(348,594145800,3),(348,606241800,4),(348,625595400,3),(348,636481800,4),(348,657045000,3),(348,667931400,4),(348,688494600,3),(348,699381000,4),(348,719944200,3),(348,731435400,4),(348,751998600,3),(348,762885000,4),(348,783448200,3),(348,794334600,4),(348,814897800,3),(348,828203400,4),(348,846347400,3),(348,859653000,4),(348,877797000,3),(348,891102600,4),(348,909246600,3),(348,922552200,4),(348,941301000,3),(348,946647000,1),(348,954001800,4),(348,972750600,3),(348,985451400,4),(348,1004200200,3),(348,1017505800,4),(348,1035649800,3),(348,1048955400,4),(348,1067099400,3),(348,1080405000,4),(348,1099153800,3),(348,1111854600,4),(348,1130603400,3),(348,1143909000,4),(348,1162053000,3),(348,1174753800,4),(348,1193502600,3),(348,1207413000,4),(348,1223137800,3),(348,1238862600,4),(348,1254587400,3),(348,1270312200,4),(348,1286037000,3),(348,1301761800,4),(348,1317486600,3),(348,1333211400,4),(348,1349541000,3),(348,1365265800,4),(348,1380990600,3),(348,1396715400,4),(348,1412440200,3),(348,1428165000,4),(348,1443889800,3),(348,1459614600,4),(348,1475339400,3),(348,1491064200,4),(348,1506789000,3),(348,1522513800,4),(348,1538843400,3),(348,1554568200,4),(348,1570293000,3),(348,1586017800,4),(348,1601742600,3),(348,1617467400,4),(348,1633192200,3),(348,1648917000,4),(348,1664641800,3),(348,1680366600,4),(348,1696091400,3),(348,1712421000,4),(348,1728145800,3),(348,1743870600,4),(348,1759595400,3),(348,1775320200,4),(348,1791045000,3),(348,1806769800,4),(348,1822494600,3),(348,1838219400,4),(348,1853944200,3),(348,1869669000,4),(348,1885998600,3),(348,1901723400,4),(348,1917448200,3),(348,1933173000,4),(348,1948897800,3),(348,1964622600,4),(348,1980347400,3),(348,1996072200,4),(348,2011797000,3),(348,2027521800,4),(348,2043246600,3),(348,2058971400,4),(348,2075301000,3),(348,2091025800,4),(348,2106750600,3),(348,2122475400,4),(348,2138200200,3),(349,-2147483648,2),(349,-1672567140,1),(349,-1665392400,2),(349,-883641600,1),(349,-876128400,2),(349,-860400000,1),(349,-844678800,2),(349,-828345600,1),(349,-813229200,2),(349,57686400,3),(349,67968000,4),(349,89136000,3),(349,100022400,4),(349,120585600,3),(349,131472000,4),(349,152035200,3),(349,162921600,4),(349,183484800,3),(349,194976000,4),(349,215539200,3),(349,226425600,4),(349,246988800,3),(349,257875200,4),(349,278438400,3),(349,289324800,4),(349,309888000,3),(349,320774400,4),(349,341337600,3),(349,352224000,4),(349,372787200,3),(349,386697600,4),(349,404841600,3),(349,415728000,4),(349,436291200,3),(349,447177600,4),(349,467740800,3),(349,478627200,4),(349,499190400,3),(349,511286400,4),(349,530035200,3),(349,542736000,4),(349,562089600,3),(349,574790400,4),(349,594144000,3),(349,606240000,4),(349,625593600,3),(349,636480000,4),(349,657043200,3),(349,667929600,4),(349,688492800,3),(349,699379200,4),(349,719942400,3),(349,731433600,4),(349,751996800,3),(349,762883200,4),(349,783446400,3),(349,794332800,4),(349,814896000,3),(349,828201600,4),(349,846345600,3),(349,859651200,4),(349,877795200,3),(349,891100800,4),(349,909244800,3),(349,922550400,4),(349,941299200,3),(349,954000000,4),(349,967305600,3),(349,985449600,4),(349,1004198400,3),(349,1017504000,4),(349,1035648000,3),(349,1048953600,4),(349,1067097600,3),(349,1080403200,4),(349,1099152000,3),(349,1111852800,4),(349,1130601600,3),(349,1143907200,4),(349,1162051200,3),(349,1174752000,4),(349,1193500800,3),(349,1207411200,4),(349,1223136000,3),(349,1238860800,4),(349,1254585600,3),(349,1270310400,4),(349,1286035200,3),(349,1301760000,4),(349,1317484800,3),(349,1333209600,4),(349,1349539200,3),(349,1365264000,4),(349,1380988800,3),(349,1396713600,4),(349,1412438400,3),(349,1428163200,4),(349,1443888000,3),(349,1459612800,4),(349,1475337600,3),(349,1491062400,4),(349,1506787200,3),(349,1522512000,4),(349,1538841600,3),(349,1554566400,4),(349,1570291200,3),(349,1586016000,4),(349,1601740800,3),(349,1617465600,4),(349,1633190400,3),(349,1648915200,4),(349,1664640000,3),(349,1680364800,4),(349,1696089600,3),(349,1712419200,4),(349,1728144000,3),(349,1743868800,4),(349,1759593600,3),(349,1775318400,4),(349,1791043200,3),(349,1806768000,4),(349,1822492800,3),(349,1838217600,4),(349,1853942400,3),(349,1869667200,4),(349,1885996800,3),(349,1901721600,4),(349,1917446400,3),(349,1933171200,4),(349,1948896000,3),(349,1964620800,4),(349,1980345600,3),(349,1996070400,4),(349,2011795200,3),(349,2027520000,4),(349,2043244800,3),(349,2058969600,4),(349,2075299200,3),(349,2091024000,4),(349,2106748800,3),(349,2122473600,4),(349,2138198400,3),(350,-2147483648,1),(350,-1680508800,2),(350,-1665392400,1),(350,-883641600,2),(350,-876128400,1),(350,-860400000,2),(350,-844678800,1),(350,-828345600,2),(350,-813229200,1),(350,57686400,3),(350,67968000,4),(350,89136000,3),(350,100022400,4),(350,120585600,3),(350,131472000,4),(350,152035200,3),(350,162921600,4),(350,183484800,3),(350,194976000,4),(350,215539200,3),(350,226425600,4),(350,246988800,3),(350,257875200,4),(350,278438400,3),(350,289324800,4),(350,309888000,3),(350,320774400,4),(350,341337600,3),(350,352224000,4),(350,372787200,3),(350,386092800,4),(350,404841600,3),(350,417542400,4),(350,436291200,3),(350,447177600,4),(350,467740800,3),(350,478627200,4),(350,499190400,3),(350,510076800,4),(350,530035200,3),(350,542736000,4),(350,562089600,3),(350,574790400,4),(350,594144000,3),(350,606240000,4),(350,625593600,3),(350,637689600,4),(350,657043200,3),(350,670348800,4),(350,686678400,3),(350,701798400,4),(350,718128000,3),(350,733248000,4),(350,749577600,3),(350,764697600,4),(350,781027200,3),(350,796147200,4),(350,812476800,3),(350,828201600,4),(350,844531200,3),(350,859651200,4),(350,875980800,3),(350,891100800,4),(350,907430400,3),(350,922550400,4),(350,938880000,3),(350,954000000,4),(350,967305600,3),(350,985449600,4),(350,1002384000,3),(350,1017504000,4),(350,1033833600,3),(350,1048953600,4),(350,1065283200,3),(350,1080403200,4),(350,1096732800,3),(350,1111852800,4),(350,1128182400,3),(350,1143907200,4),(350,1159632000,3),(350,1174752000,4),(350,1191686400,3),(350,1207411200,4),(350,1223136000,3),(350,1238860800,4),(350,1254585600,3),(350,1270310400,4),(350,1286035200,3),(350,1301760000,4),(350,1317484800,3),(350,1333209600,4),(350,1349539200,3),(350,1365264000,4),(350,1380988800,3),(350,1396713600,4),(350,1412438400,3),(350,1428163200,4),(350,1443888000,3),(350,1459612800,4),(350,1475337600,3),(350,1491062400,4),(350,1506787200,3),(350,1522512000,4),(350,1538841600,3),(350,1554566400,4),(350,1570291200,3),(350,1586016000,4),(350,1601740800,3),(350,1617465600,4),(350,1633190400,3),(350,1648915200,4),(350,1664640000,3),(350,1680364800,4),(350,1696089600,3),(350,1712419200,4),(350,1728144000,3),(350,1743868800,4),(350,1759593600,3),(350,1775318400,4),(350,1791043200,3),(350,1806768000,4),(350,1822492800,3),(350,1838217600,4),(350,1853942400,3),(350,1869667200,4),(350,1885996800,3),(350,1901721600,4),(350,1917446400,3),(350,1933171200,4),(350,1948896000,3),(350,1964620800,4),(350,1980345600,3),(350,1996070400,4),(350,2011795200,3),(350,2027520000,4),(350,2043244800,3),(350,2058969600,4),(350,2075299200,3),(350,2091024000,4),(350,2106748800,3),(350,2122473600,4),(350,2138198400,3),(351,-2147483648,2),(351,-1672565340,1),(351,-1665390600,2),(351,-883639800,1),(351,-876126600,2),(351,-860398200,1),(351,-844677000,2),(351,-828343800,1),(351,-813227400,2),(352,-2147483648,2),(352,-1672562640,1),(352,-1665387900,2),(352,-883637100,1),(352,-876123900,2),(352,-860395500,1),(352,-844674300,2),(352,152039700,3),(352,162926100,4),(352,436295700,3),(352,447182100,4),(352,690311700,3),(352,699383700,4),(352,1165079700,3),(352,1174756500,4),(352,1193505300,3),(352,1206810900,4),(352,1224954900,3),(352,1238260500,4),(352,2147483647,4),(353,-2147483648,1),(353,-1680508800,2),(353,-1665392400,1),(353,-883641600,2),(353,-876128400,1),(353,-860400000,2),(353,-844678800,1),(353,-828345600,2),(353,-813229200,1),(353,-71136000,3),(353,-55411200,4),(353,-37267200,3),(353,-25776000,4),(353,-5817600,3),(353,5673600,4),(353,25632000,3),(353,37728000,4),(353,57686400,3),(353,67968000,4),(353,89136000,3),(353,100022400,4),(353,120585600,3),(353,131472000,4),(353,152035200,3),(353,162921600,4),(353,183484800,3),(353,194976000,4),(353,215539200,3),(353,226425600,4),(353,246988800,3),(353,257875200,4),(353,278438400,3),(353,289324800,4),(353,309888000,3),(353,320774400,4),(353,341337600,3),(353,352224000,4),(353,372787200,3),(353,386092800,4),(353,404841600,3),(353,417542400,4),(353,436291200,3),(353,447177600,4),(353,467740800,3),(353,478627200,4),(353,499190400,3),(353,510076800,4),(353,530035200,3),(353,542736000,4),(353,562089600,3),(353,574790400,4),(353,594144000,3),(353,606240000,4),(353,625593600,3),(353,637689600,4),(353,657043200,3),(353,670348800,4),(353,686678400,3),(353,701798400,4),(353,718128000,3),(353,733248000,4),(353,749577600,3),(353,764697600,4),(353,781027200,3),(353,796147200,4),(353,812476800,3),(353,828201600,4),(353,844531200,3),(353,859651200,4),(353,875980800,3),(353,891100800,4),(353,907430400,3),(353,922550400,4),(353,938880000,3),(353,954000000,4),(353,967305600,3),(353,985449600,4),(353,1002384000,3),(353,1017504000,4),(353,1033833600,3),(353,1048953600,4),(353,1065283200,3),(353,1080403200,4),(353,1096732800,3),(353,1111852800,4),(353,1128182400,3),(353,1143907200,4),(353,1159632000,3),(353,1174752000,4),(353,1191686400,3),(353,1207411200,4),(353,1223136000,3),(353,1238860800,4),(353,1254585600,3),(353,1270310400,4),(353,1286035200,3),(353,1301760000,4),(353,1317484800,3),(353,1333209600,4),(353,1349539200,3),(353,1365264000,4),(353,1380988800,3),(353,1396713600,4),(353,1412438400,3),(353,1428163200,4),(353,1443888000,3),(353,1459612800,4),(353,1475337600,3),(353,1491062400,4),(353,1506787200,3),(353,1522512000,4),(353,1538841600,3),(353,1554566400,4),(353,1570291200,3),(353,1586016000,4),(353,1601740800,3),(353,1617465600,4),(353,1633190400,3),(353,1648915200,4),(353,1664640000,3),(353,1680364800,4),(353,1696089600,3),(353,1712419200,4),(353,1728144000,3),(353,1743868800,4),(353,1759593600,3),(353,1775318400,4),(353,1791043200,3),(353,1806768000,4),(353,1822492800,3),(353,1838217600,4),(353,1853942400,3),(353,1869667200,4),(353,1885996800,3),(353,1901721600,4),(353,1917446400,3),(353,1933171200,4),(353,1948896000,3),(353,1964620800,4),(353,1980345600,3),(353,1996070400,4),(353,2011795200,3),(353,2027520000,4),(353,2043244800,3),(353,2058969600,4),(353,2075299200,3),(353,2091024000,4),(353,2106748800,3),(353,2122473600,4),(353,2138198400,3),(354,-2147483648,1),(354,352216800,3),(354,372785400,2),(354,384273000,3),(354,404839800,2),(354,415722600,3),(354,436289400,2),(354,447172200,3),(354,467739000,2),(354,478621800,3),(354,499188600,4),(354,511282800,3),(354,530033400,4),(354,542732400,3),(354,562087800,4),(354,574786800,3),(354,594142200,4),(354,606236400,3),(354,625591800,4),(354,636476400,3),(354,657041400,4),(354,667926000,3),(354,688491000,4),(354,699375600,3),(354,719940600,4),(354,731430000,3),(354,751995000,4),(354,762879600,3),(354,783444600,4),(354,794329200,3),(354,814894200,4),(354,828198000,3),(354,846343800,4),(354,859647600,3),(354,877793400,4),(354,891097200,3),(354,909243000,4),(354,922546800,3),(354,941297400,4),(354,953996400,3),(354,967303800,4),(354,985446000,3),(354,1004196600,4),(354,1017500400,3),(354,1035646200,4),(354,1048950000,3),(354,1067095800,4),(354,1080399600,3),(354,1099150200,4),(354,1111849200,3),(354,1130599800,4),(354,1143903600,3),(354,1162049400,4),(354,1174748400,3),(354,1193499000,4),(354,1207407600,3),(354,1223134200,4),(354,1238857200,3),(354,1254583800,4),(354,1270306800,3),(354,1286033400,4),(354,1301756400,3),(354,1317483000,4),(354,1333206000,3),(354,1349537400,4),(354,1365260400,3),(354,1380987000,4),(354,1396710000,3),(354,1412436600,4),(354,1428159600,3),(354,1443886200,4),(354,1459609200,3),(354,1475335800,4),(354,1491058800,3),(354,1506785400,4),(354,1522508400,3),(354,1538839800,4),(354,1554562800,3),(354,1570289400,4),(354,1586012400,3),(354,1601739000,4),(354,1617462000,3),(354,1633188600,4),(354,1648911600,3),(354,1664638200,4),(354,1680361200,3),(354,1696087800,4),(354,1712415600,3),(354,1728142200,4),(354,1743865200,3),(354,1759591800,4),(354,1775314800,3),(354,1791041400,4),(354,1806764400,3),(354,1822491000,4),(354,1838214000,3),(354,1853940600,4),(354,1869663600,3),(354,1885995000,4),(354,1901718000,3),(354,1917444600,4),(354,1933167600,3),(354,1948894200,4),(354,1964617200,3),(354,1980343800,4),(354,1996066800,3),(354,2011793400,4),(354,2027516400,3),(354,2043243000,4),(354,2058966000,3),(354,2075297400,4),(354,2091020400,3),(354,2106747000,4),(354,2122470000,3),(354,2138196600,4),(354,2147483647,4),(355,-2147483648,2),(355,-1672567140,1),(355,-1665392400,2),(355,-883641600,1),(355,-876128400,2),(355,-860400000,1),(355,-844678800,2),(355,-828345600,1),(355,-813229200,2),(355,57686400,3),(355,67968000,4),(355,625593600,3),(355,636480000,4),(355,657043200,3),(355,667929600,4),(355,688492800,3),(355,699379200,4),(355,709912800,2),(355,719942400,3),(355,731433600,4),(355,751996800,3),(355,762883200,4),(356,-2147483648,1),(356,352216800,3),(356,372785400,2),(356,384273000,3),(356,404839800,2),(356,415722600,3),(356,436289400,2),(356,447172200,3),(356,467739000,2),(356,478621800,3),(356,499188600,4),(356,511282800,3),(356,530033400,4),(356,542732400,3),(356,562087800,4),(356,574786800,3),(356,594142200,4),(356,606236400,3),(356,625591800,4),(356,636476400,3),(356,657041400,4),(356,667926000,3),(356,688491000,4),(356,699375600,3),(356,719940600,4),(356,731430000,3),(356,751995000,4),(356,762879600,3),(356,783444600,4),(356,794329200,3),(356,814894200,4),(356,828198000,3),(356,846343800,4),(356,859647600,3),(356,877793400,4),(356,891097200,3),(356,909243000,4),(356,922546800,3),(356,941297400,4),(356,953996400,3),(356,967303800,4),(356,985446000,3),(356,1004196600,4),(356,1017500400,3),(356,1035646200,4),(356,1048950000,3),(356,1067095800,4),(356,1080399600,3),(356,1099150200,4),(356,1111849200,3),(356,1130599800,4),(356,1143903600,3),(356,1162049400,4),(356,1174748400,3),(356,1193499000,4),(356,1207407600,3),(356,1223134200,4),(356,1238857200,3),(356,1254583800,4),(356,1270306800,3),(356,1286033400,4),(356,1301756400,3),(356,1317483000,4),(356,1333206000,3),(356,1349537400,4),(356,1365260400,3),(356,1380987000,4),(356,1396710000,3),(356,1412436600,4),(356,1428159600,3),(356,1443886200,4),(356,1459609200,3),(356,1475335800,4),(356,1491058800,3),(356,1506785400,4),(356,1522508400,3),(356,1538839800,4),(356,1554562800,3),(356,1570289400,4),(356,1586012400,3),(356,1601739000,4),(356,1617462000,3),(356,1633188600,4),(356,1648911600,3),(356,1664638200,4),(356,1680361200,3),(356,1696087800,4),(356,1712415600,3),(356,1728142200,4),(356,1743865200,3),(356,1759591800,4),(356,1775314800,3),(356,1791041400,4),(356,1806764400,3),(356,1822491000,4),(356,1838214000,3),(356,1853940600,4),(356,1869663600,3),(356,1885995000,4),(356,1901718000,3),(356,1917444600,4),(356,1933167600,3),(356,1948894200,4),(356,1964617200,3),(356,1980343800,4),(356,1996066800,3),(356,2011793400,4),(356,2027516400,3),(356,2043243000,4),(356,2058966000,3),(356,2075297400,4),(356,2091020400,3),(356,2106747000,4),(356,2122470000,3),(356,2138196600,4),(356,2147483647,4),(357,-2147483648,2),(357,-1672567140,1),(357,-1665392400,2),(357,-883641600,1),(357,-876128400,2),(357,-860400000,1),(357,-844678800,2),(357,-828345600,1),(357,-813229200,2),(357,57686400,3),(357,67968000,4),(357,89136000,3),(357,100022400,4),(357,120585600,3),(357,131472000,4),(357,152035200,3),(357,162921600,4),(357,183484800,3),(357,194976000,4),(357,215539200,3),(357,226425600,4),(357,246988800,3),(357,257875200,4),(357,278438400,3),(357,289324800,4),(357,309888000,3),(357,320774400,4),(357,341337600,3),(357,352224000,4),(357,372787200,3),(357,384278400,4),(357,404841600,3),(357,415728000,4),(357,436291200,3),(357,447177600,4),(357,467740800,3),(357,478627200,4),(357,499190400,3),(357,511286400,4),(357,530035200,3),(357,542736000,4),(357,561484800,3),(357,574790400,4),(357,594144000,3),(357,606240000,4),(357,625593600,3),(357,637689600,4),(357,657043200,3),(357,667929600,4),(357,688492800,3),(357,699379200,4),(357,719942400,3),(357,731433600,4),(357,751996800,3),(357,762883200,4),(357,783446400,3),(357,796147200,4),(357,814896000,3),(357,828201600,4),(357,846345600,3),(357,859651200,4),(357,877795200,3),(357,891100800,4),(357,909244800,3),(357,922550400,4),(357,941299200,3),(357,954000000,4),(357,967305600,3),(357,985449600,4),(357,1004198400,3),(357,1017504000,4),(357,1035648000,3),(357,1048953600,4),(357,1067097600,3),(357,1080403200,4),(357,1099152000,3),(357,1111852800,4),(357,1130601600,3),(357,1143907200,4),(357,1162051200,3),(357,1174752000,4),(357,1193500800,3),(357,1207411200,4),(357,1223136000,3),(357,1238860800,4),(357,1254585600,3),(357,1270310400,4),(357,1286035200,3),(357,1301760000,4),(357,1317484800,3),(357,1333209600,4),(357,1349539200,3),(357,1365264000,4),(357,1380988800,3),(357,1396713600,4),(357,1412438400,3),(357,1428163200,4),(357,1443888000,3),(357,1459612800,4),(357,1475337600,3),(357,1491062400,4),(357,1506787200,3),(357,1522512000,4),(357,1538841600,3),(357,1554566400,4),(357,1570291200,3),(357,1586016000,4),(357,1601740800,3),(357,1617465600,4),(357,1633190400,3),(357,1648915200,4),(357,1664640000,3),(357,1680364800,4),(357,1696089600,3),(357,1712419200,4),(357,1728144000,3),(357,1743868800,4),(357,1759593600,3),(357,1775318400,4),(357,1791043200,3),(357,1806768000,4),(357,1822492800,3),(357,1838217600,4),(357,1853942400,3),(357,1869667200,4),(357,1885996800,3),(357,1901721600,4),(357,1917446400,3),(357,1933171200,4),(357,1948896000,3),(357,1964620800,4),(357,1980345600,3),(357,1996070400,4),(357,2011795200,3),(357,2027520000,4),(357,2043244800,3),(357,2058969600,4),(357,2075299200,3),(357,2091024000,4),(357,2106748800,3),(357,2122473600,4),(357,2138198400,3),(358,-2147483648,2),(358,-1672567140,1),(358,-1665392400,2),(358,-883641600,1),(358,-876128400,2),(358,-860400000,1),(358,-844678800,2),(358,-828345600,1),(358,-813229200,2),(358,57686400,3),(358,67968000,4),(358,89136000,3),(358,100022400,4),(358,120585600,3),(358,131472000,4),(358,152035200,3),(358,162921600,4),(358,183484800,3),(358,194976000,4),(358,215539200,3),(358,226425600,4),(358,246988800,3),(358,257875200,4),(358,278438400,3),(358,289324800,4),(358,309888000,3),(358,320774400,4),(358,341337600,3),(358,352224000,4),(358,372787200,3),(358,386697600,4),(358,404841600,3),(358,415728000,4),(358,436291200,3),(358,447177600,4),(358,467740800,3),(358,478627200,4),(358,499190400,3),(358,511286400,4),(358,530035200,3),(358,542736000,4),(358,562089600,3),(358,574790400,4),(358,594144000,3),(358,606240000,4),(358,625593600,3),(358,636480000,4),(358,657043200,3),(358,667929600,4),(358,688492800,3),(358,699379200,4),(358,719942400,3),(358,731433600,4),(358,751996800,3),(358,762883200,4),(358,783446400,3),(358,794332800,4),(358,814896000,3),(358,828201600,4),(358,846345600,3),(358,859651200,4),(358,877795200,3),(358,891100800,4),(358,909244800,3),(358,922550400,4),(358,941299200,3),(358,954000000,4),(358,967305600,3),(358,985449600,4),(358,1004198400,3),(358,1017504000,4),(358,1035648000,3),(358,1048953600,4),(358,1067097600,3),(358,1080403200,4),(358,1099152000,3),(358,1111852800,4),(358,1130601600,3),(358,1143907200,4),(358,1162051200,3),(358,1174752000,4),(358,1193500800,3),(358,1207411200,4),(358,1223136000,3),(358,1238860800,4),(358,1254585600,3),(358,1270310400,4),(358,1286035200,3),(358,1301760000,4),(358,1317484800,3),(358,1333209600,4),(358,1349539200,3),(358,1365264000,4),(358,1380988800,3),(358,1396713600,4),(358,1412438400,3),(358,1428163200,4),(358,1443888000,3),(358,1459612800,4),(358,1475337600,3),(358,1491062400,4),(358,1506787200,3),(358,1522512000,4),(358,1538841600,3),(358,1554566400,4),(358,1570291200,3),(358,1586016000,4),(358,1601740800,3),(358,1617465600,4),(358,1633190400,3),(358,1648915200,4),(358,1664640000,3),(358,1680364800,4),(358,1696089600,3),(358,1712419200,4),(358,1728144000,3),(358,1743868800,4),(358,1759593600,3),(358,1775318400,4),(358,1791043200,3),(358,1806768000,4),(358,1822492800,3),(358,1838217600,4),(358,1853942400,3),(358,1869667200,4),(358,1885996800,3),(358,1901721600,4),(358,1917446400,3),(358,1933171200,4),(358,1948896000,3),(358,1964620800,4),(358,1980345600,3),(358,1996070400,4),(358,2011795200,3),(358,2027520000,4),(358,2043244800,3),(358,2058969600,4),(358,2075299200,3),(358,2091024000,4),(358,2106748800,3),(358,2122473600,4),(358,2138198400,3),(359,-2147483648,2),(359,-1672565340,1),(359,-1665390600,2),(359,-883639800,1),(359,-876126600,2),(359,-860398200,1),(359,-844677000,2),(359,-828343800,1),(359,-813227400,2),(360,-2147483648,2),(360,-1672559940,1),(360,-1665385200,2),(360,-883634400,1),(360,-876121200,2),(360,-860392800,1),(360,-844671600,2),(360,152042400,3),(360,162928800,4),(360,436298400,3),(360,447184800,4),(360,690314400,3),(360,699386400,4),(360,1165082400,3),(360,1174759200,4),(360,1193508000,3),(360,1206813600,4),(360,1224957600,3),(360,1238263200,4),(361,-2147483648,2),(361,-1672567140,1),(361,-1665392400,2),(361,-883641600,1),(361,-876128400,2),(361,-860400000,1),(361,-844678800,2),(361,-828345600,1),(361,-813229200,2),(361,57686400,3),(361,67968000,4),(361,625593600,3),(361,636480000,4),(361,657043200,3),(361,667929600,4),(361,688492800,3),(361,699379200,4),(362,-2147483648,2),(362,-1672565340,1),(362,-1665390600,2),(362,-883639800,1),(362,-876126600,2),(362,-860398200,1),(362,-844677000,2),(362,-828343800,1),(362,-813227400,2),(362,57688200,3),(362,67969800,4),(362,89137800,3),(362,100024200,4),(362,120587400,3),(362,131473800,4),(362,152037000,3),(362,162923400,4),(362,183486600,3),(362,194977800,4),(362,215541000,3),(362,226427400,4),(362,246990600,3),(362,257877000,4),(362,278440200,3),(362,289326600,4),(362,309889800,3),(362,320776200,4),(362,341339400,3),(362,352225800,4),(362,372789000,3),(362,384280200,4),(362,404843400,3),(362,415729800,4),(362,436293000,3),(362,447179400,4),(362,467742600,3),(362,478629000,4),(362,499192200,3),(362,511288200,4),(362,530037000,3),(362,542737800,4),(362,562091400,3),(362,574792200,4),(362,594145800,3),(362,606241800,4),(362,625595400,3),(362,637691400,4),(362,657045000,3),(362,667931400,4),(362,688494600,3),(362,701195400,4),(362,719944200,3),(362,731435400,4),(362,751998600,3),(362,764094600,4),(362,783448200,3),(362,796149000,4),(362,814897800,3),(362,828203400,4),(362,846347400,3),(362,859653000,4),(362,877797000,3),(362,891102600,4),(362,909246600,3),(362,922552200,4),(362,941301000,3),(362,954001800,4),(362,972750600,3),(362,985451400,4),(362,1004200200,3),(362,1017505800,4),(362,1035649800,3),(362,1048955400,4),(362,1067099400,3),(362,1080405000,4),(362,1099153800,3),(362,1111854600,4),(362,1130603400,3),(362,1143909000,4),(362,1162053000,3),(362,1174753800,4),(362,1193502600,3),(362,1207413000,4),(362,1223137800,3),(362,1238862600,4),(362,1254587400,3),(362,1270312200,4),(362,1286037000,3),(362,1301761800,4),(362,1317486600,3),(362,1333211400,4),(362,1349541000,3),(362,1365265800,4),(362,1380990600,3),(362,1396715400,4),(362,1412440200,3),(362,1428165000,4),(362,1443889800,3),(362,1459614600,4),(362,1475339400,3),(362,1491064200,4),(362,1506789000,3),(362,1522513800,4),(362,1538843400,3),(362,1554568200,4),(362,1570293000,3),(362,1586017800,4),(362,1601742600,3),(362,1617467400,4),(362,1633192200,3),(362,1648917000,4),(362,1664641800,3),(362,1680366600,4),(362,1696091400,3),(362,1712421000,4),(362,1728145800,3),(362,1743870600,4),(362,1759595400,3),(362,1775320200,4),(362,1791045000,3),(362,1806769800,4),(362,1822494600,3),(362,1838219400,4),(362,1853944200,3),(362,1869669000,4),(362,1885998600,3),(362,1901723400,4),(362,1917448200,3),(362,1933173000,4),(362,1948897800,3),(362,1964622600,4),(362,1980347400,3),(362,1996072200,4),(362,2011797000,3),(362,2027521800,4),(362,2043246600,3),(362,2058971400,4),(362,2075301000,3),(362,2091025800,4),(362,2106750600,3),(362,2122475400,4),(362,2138200200,3),(363,-2147483648,2),(363,-1672567140,1),(363,-1665392400,2),(363,-883641600,1),(363,-876128400,2),(363,-860400000,1),(363,-844678800,2),(363,-828345600,1),(363,-813229200,2),(363,57686400,3),(363,67968000,4),(363,89136000,3),(363,100022400,4),(363,120585600,3),(363,131472000,4),(363,152035200,3),(363,162921600,4),(363,183484800,3),(363,194976000,4),(363,215539200,3),(363,226425600,4),(363,246988800,3),(363,257875200,4),(363,278438400,3),(363,289324800,4),(363,309888000,3),(363,320774400,4),(363,341337600,3),(363,352224000,4),(363,372787200,3),(363,386697600,4),(363,404841600,3),(363,415728000,4),(363,436291200,3),(363,447177600,4),(363,467740800,3),(363,478627200,4),(363,499190400,3),(363,511286400,4),(363,530035200,3),(363,542736000,4),(363,562089600,3),(363,574790400,4),(363,594144000,3),(363,606240000,4),(363,625593600,3),(363,636480000,4),(363,657043200,3),(363,667929600,4),(363,688492800,3),(363,699379200,4),(363,719942400,3),(363,731433600,4),(363,751996800,3),(363,762883200,4),(363,783446400,3),(363,794332800,4),(363,814896000,3),(363,828201600,4),(363,846345600,3),(363,859651200,4),(363,877795200,3),(363,891100800,4),(363,909244800,3),(363,922550400,4),(363,941299200,3),(363,954000000,4),(363,967305600,3),(363,985449600,4),(363,1004198400,3),(363,1017504000,4),(363,1035648000,3),(363,1048953600,4),(363,1067097600,3),(363,1080403200,4),(363,1099152000,3),(363,1111852800,4),(363,1130601600,3),(363,1143907200,4),(363,1162051200,3),(363,1174752000,4),(363,1193500800,3),(363,1207411200,4),(363,1223136000,3),(363,1238860800,4),(363,1254585600,3),(363,1270310400,4),(363,1286035200,3),(363,1301760000,4),(363,1317484800,3),(363,1333209600,4),(363,1349539200,3),(363,1365264000,4),(363,1380988800,3),(363,1396713600,4),(363,1412438400,3),(363,1428163200,4),(363,1443888000,3),(363,1459612800,4),(363,1475337600,3),(363,1491062400,4),(363,1506787200,3),(363,1522512000,4),(363,1538841600,3),(363,1554566400,4),(363,1570291200,3),(363,1586016000,4),(363,1601740800,3),(363,1617465600,4),(363,1633190400,3),(363,1648915200,4),(363,1664640000,3),(363,1680364800,4),(363,1696089600,3),(363,1712419200,4),(363,1728144000,3),(363,1743868800,4),(363,1759593600,3),(363,1775318400,4),(363,1791043200,3),(363,1806768000,4),(363,1822492800,3),(363,1838217600,4),(363,1853942400,3),(363,1869667200,4),(363,1885996800,3),(363,1901721600,4),(363,1917446400,3),(363,1933171200,4),(363,1948896000,3),(363,1964620800,4),(363,1980345600,3),(363,1996070400,4),(363,2011795200,3),(363,2027520000,4),(363,2043244800,3),(363,2058969600,4),(363,2075299200,3),(363,2091024000,4),(363,2106748800,3),(363,2122473600,4),(363,2138198400,3),(364,-2147483648,1),(364,-1680508800,2),(364,-1665392400,1),(364,-883641600,2),(364,-876128400,1),(364,-860400000,2),(364,-844678800,1),(364,-828345600,2),(364,-813229200,1),(364,-71136000,3),(364,-55411200,4),(364,-37267200,3),(364,-25776000,4),(364,-5817600,3),(364,5673600,4),(364,25632000,3),(364,37728000,4),(364,57686400,3),(364,67968000,4),(364,89136000,3),(364,100022400,4),(364,120585600,3),(364,131472000,4),(364,152035200,3),(364,162921600,4),(364,183484800,3),(364,194976000,4),(364,215539200,3),(364,226425600,4),(364,246988800,3),(364,257875200,4),(364,278438400,3),(364,289324800,4),(364,309888000,3),(364,320774400,4),(364,341337600,3),(364,352224000,4),(364,372787200,3),(364,386092800,4),(364,404841600,3),(364,417542400,4),(364,436291200,3),(364,447177600,4),(364,467740800,3),(364,478627200,4),(364,499190400,3),(364,510076800,4),(364,530035200,3),(364,542736000,4),(364,562089600,3),(364,574790400,4),(364,594144000,3),(364,606240000,4),(364,625593600,3),(364,637689600,4),(364,657043200,3),(364,670348800,4),(364,686678400,3),(364,701798400,4),(364,718128000,3),(364,733248000,4),(364,749577600,3),(364,764697600,4),(364,781027200,3),(364,796147200,4),(364,812476800,3),(364,828201600,4),(364,844531200,3),(364,859651200,4),(364,875980800,3),(364,891100800,4),(364,907430400,3),(364,922550400,4),(364,938880000,3),(364,954000000,4),(364,967305600,3),(364,985449600,4),(364,1002384000,3),(364,1017504000,4),(364,1033833600,3),(364,1048953600,4),(364,1065283200,3),(364,1080403200,4),(364,1096732800,3),(364,1111852800,4),(364,1128182400,3),(364,1143907200,4),(364,1159632000,3),(364,1174752000,4),(364,1191686400,3),(364,1207411200,4),(364,1223136000,3),(364,1238860800,4),(364,1254585600,3),(364,1270310400,4),(364,1286035200,3),(364,1301760000,4),(364,1317484800,3),(364,1333209600,4),(364,1349539200,3),(364,1365264000,4),(364,1380988800,3),(364,1396713600,4),(364,1412438400,3),(364,1428163200,4),(364,1443888000,3),(364,1459612800,4),(364,1475337600,3),(364,1491062400,4),(364,1506787200,3),(364,1522512000,4),(364,1538841600,3),(364,1554566400,4),(364,1570291200,3),(364,1586016000,4),(364,1601740800,3),(364,1617465600,4),(364,1633190400,3),(364,1648915200,4),(364,1664640000,3),(364,1680364800,4),(364,1696089600,3),(364,1712419200,4),(364,1728144000,3),(364,1743868800,4),(364,1759593600,3),(364,1775318400,4),(364,1791043200,3),(364,1806768000,4),(364,1822492800,3),(364,1838217600,4),(364,1853942400,3),(364,1869667200,4),(364,1885996800,3),(364,1901721600,4),(364,1917446400,3),(364,1933171200,4),(364,1948896000,3),(364,1964620800,4),(364,1980345600,3),(364,1996070400,4),(364,2011795200,3),(364,2027520000,4),(364,2043244800,3),(364,2058969600,4),(364,2075299200,3),(364,2091024000,4),(364,2106748800,3),(364,2122473600,4),(364,2138198400,3),(365,-2147483648,2),(365,-1672567140,1),(365,-1665392400,2),(365,-883641600,1),(365,-876128400,2),(365,-860400000,1),(365,-844678800,2),(365,-828345600,1),(365,-813229200,2),(365,57686400,3),(365,67968000,4),(365,89136000,3),(365,100022400,4),(365,120585600,3),(365,131472000,4),(365,152035200,3),(365,162921600,4),(365,183484800,3),(365,194976000,4),(365,215539200,3),(365,226425600,4),(365,246988800,3),(365,257875200,4),(365,278438400,3),(365,289324800,4),(365,309888000,3),(365,320774400,4),(365,341337600,3),(365,352224000,4),(365,372787200,3),(365,384278400,4),(365,404841600,3),(365,415728000,4),(365,436291200,3),(365,447177600,4),(365,467740800,3),(365,478627200,4),(365,499190400,3),(365,511286400,4),(365,530035200,3),(365,542736000,4),(365,561484800,3),(365,574790400,4),(365,594144000,3),(365,606240000,4),(365,625593600,3),(365,637689600,4),(365,657043200,3),(365,667929600,4),(365,688492800,3),(365,699379200,4),(365,719942400,3),(365,731433600,4),(365,751996800,3),(365,762883200,4),(365,783446400,3),(365,796147200,4),(365,814896000,3),(365,828201600,4),(365,846345600,3),(365,859651200,4),(365,877795200,3),(365,891100800,4),(365,909244800,3),(365,922550400,4),(365,941299200,3),(365,954000000,4),(365,967305600,3),(365,985449600,4),(365,1004198400,3),(365,1017504000,4),(365,1035648000,3),(365,1048953600,4),(365,1067097600,3),(365,1080403200,4),(365,1099152000,3),(365,1111852800,4),(365,1130601600,3),(365,1143907200,4),(365,1162051200,3),(365,1174752000,4),(365,1193500800,3),(365,1207411200,4),(365,1223136000,3),(365,1238860800,4),(365,1254585600,3),(365,1270310400,4),(365,1286035200,3),(365,1301760000,4),(365,1317484800,3),(365,1333209600,4),(365,1349539200,3),(365,1365264000,4),(365,1380988800,3),(365,1396713600,4),(365,1412438400,3),(365,1428163200,4),(365,1443888000,3),(365,1459612800,4),(365,1475337600,3),(365,1491062400,4),(365,1506787200,3),(365,1522512000,4),(365,1538841600,3),(365,1554566400,4),(365,1570291200,3),(365,1586016000,4),(365,1601740800,3),(365,1617465600,4),(365,1633190400,3),(365,1648915200,4),(365,1664640000,3),(365,1680364800,4),(365,1696089600,3),(365,1712419200,4),(365,1728144000,3),(365,1743868800,4),(365,1759593600,3),(365,1775318400,4),(365,1791043200,3),(365,1806768000,4),(365,1822492800,3),(365,1838217600,4),(365,1853942400,3),(365,1869667200,4),(365,1885996800,3),(365,1901721600,4),(365,1917446400,3),(365,1933171200,4),(365,1948896000,3),(365,1964620800,4),(365,1980345600,3),(365,1996070400,4),(365,2011795200,3),(365,2027520000,4),(365,2043244800,3),(365,2058969600,4),(365,2075299200,3),(365,2091024000,4),(365,2106748800,3),(365,2122473600,4),(365,2138198400,3),(366,-2147483648,2),(366,-1672559940,1),(366,-1665385200,2),(366,-883634400,1),(366,-876121200,2),(366,-860392800,1),(366,-844671600,2),(366,152042400,3),(366,162928800,4),(366,436298400,3),(366,447184800,4),(366,690314400,3),(366,699386400,4),(366,1165082400,3),(366,1174759200,4),(366,1193508000,3),(366,1206813600,4),(366,1224957600,3),(366,1238263200,4),(367,-2147483648,2),(367,-1672565340,1),(367,-1665390600,2),(367,-883639800,1),(367,-876126600,2),(367,-860398200,1),(367,-844677000,2),(367,-828343800,1),(367,-813227400,2),(367,57688200,3),(367,67969800,4),(367,89137800,3),(367,100024200,4),(367,120587400,3),(367,131473800,4),(367,152037000,3),(367,162923400,4),(367,183486600,3),(367,194977800,4),(367,215541000,3),(367,226427400,4),(367,246990600,3),(367,257877000,4),(367,278440200,3),(367,289326600,4),(367,309889800,3),(367,320776200,4),(367,341339400,3),(367,352225800,4),(367,372789000,3),(367,386699400,4),(367,404843400,3),(367,415729800,4),(367,436293000,3),(367,447179400,4),(367,467742600,3),(367,478629000,4),(367,499192200,3),(367,511288200,4),(367,530037000,3),(367,542737800,4),(367,562091400,3),(367,574792200,4),(367,594145800,3),(367,606241800,4),(367,625595400,3),(367,636481800,4),(367,657045000,3),(367,667931400,4),(367,688494600,3),(367,699381000,4),(367,719944200,3),(367,731435400,4),(367,751998600,3),(367,762885000,4),(367,783448200,3),(367,794334600,4),(367,814897800,3),(367,828203400,4),(367,846347400,3),(367,859653000,4),(367,877797000,3),(367,891102600,4),(367,909246600,3),(367,922552200,4),(367,941301000,3),(367,946647000,1),(367,954001800,4),(367,972750600,3),(367,985451400,4),(367,1004200200,3),(367,1017505800,4),(367,1035649800,3),(367,1048955400,4),(367,1067099400,3),(367,1080405000,4),(367,1099153800,3),(367,1111854600,4),(367,1130603400,3),(367,1143909000,4),(367,1162053000,3),(367,1174753800,4),(367,1193502600,3),(367,1207413000,4),(367,1223137800,3),(367,1238862600,4),(367,1254587400,3),(367,1270312200,4),(367,1286037000,3),(367,1301761800,4),(367,1317486600,3),(367,1333211400,4),(367,1349541000,3),(367,1365265800,4),(367,1380990600,3),(367,1396715400,4),(367,1412440200,3),(367,1428165000,4),(367,1443889800,3),(367,1459614600,4),(367,1475339400,3),(367,1491064200,4),(367,1506789000,3),(367,1522513800,4),(367,1538843400,3),(367,1554568200,4),(367,1570293000,3),(367,1586017800,4),(367,1601742600,3),(367,1617467400,4),(367,1633192200,3),(367,1648917000,4),(367,1664641800,3),(367,1680366600,4),(367,1696091400,3),(367,1712421000,4),(367,1728145800,3),(367,1743870600,4),(367,1759595400,3),(367,1775320200,4),(367,1791045000,3),(367,1806769800,4),(367,1822494600,3),(367,1838219400,4),(367,1853944200,3),(367,1869669000,4),(367,1885998600,3),(367,1901723400,4),(367,1917448200,3),(367,1933173000,4),(367,1948897800,3),(367,1964622600,4),(367,1980347400,3),(367,1996072200,4),(367,2011797000,3),(367,2027521800,4),(367,2043246600,3),(367,2058971400,4),(367,2075301000,3),(367,2091025800,4),(367,2106750600,3),(367,2122475400,4),(367,2138200200,3),(368,-2147483648,0),(368,-1767209328,2),(368,-1206950400,1),(368,-1191355200,2),(368,-1175367600,1),(368,-1159819200,2),(368,-633812400,1),(368,-622062000,2),(368,-602276400,1),(368,-591825600,2),(368,-570740400,1),(368,-560203200,2),(368,-539118000,1),(368,-531345600,2),(368,-191358000,1),(368,-184190400,2),(368,-155156400,1),(368,-150062400,2),(368,-128890800,1),(368,-121118400,2),(368,-99946800,1),(368,-89582400,2),(368,-68410800,1),(368,-57960000,2),(368,499755600,1),(368,511243200,2),(368,530600400,1),(368,540273600,2),(368,562136400,1),(368,571204800,2),(368,1214283600,3),(368,1384056000,2),(368,2147483647,2),(369,-2147483648,0),(369,-1767217820,2),(369,-1206961200,1),(369,-1191366000,2),(369,-1175378400,1),(369,-1159830000,2),(369,-633823200,1),(369,-622072800,2),(369,-602287200,1),(369,-591836400,2),(369,-570751200,1),(369,-560214000,2),(369,-539128800,1),(369,-531356400,2),(369,-191368800,1),(369,-184201200,2),(369,-155167200,1),(369,-150073200,2),(369,-128901600,1),(369,-121129200,2),(369,-99957600,1),(369,-89593200,2),(369,-68421600,1),(369,-57970800,2),(369,499744800,1),(369,511232400,2),(369,530589600,1),(369,540262800,2),(369,562125600,1),(369,571194000,2),(369,592970400,1),(369,602038800,2),(369,624420000,1),(369,634698000,2),(369,938916000,1),(369,951613200,2),(369,970970400,1),(369,971571600,2),(369,1003024800,1),(369,1013907600,2),(369,2147483647,2),(370,-2147483648,0),(370,-1767214412,2),(370,-1206957600,1),(370,-1191362400,2),(370,-1175374800,1),(370,-1159826400,2),(370,-633819600,1),(370,-622069200,2),(370,-602283600,1),(370,-591832800,2),(370,-570747600,1),(370,-560210400,2),(370,-539125200,1),(370,-531352800,2),(370,-195426000,1),(370,-184197600,2),(370,-155163600,1),(370,-150069600,2),(370,-128898000,1),(370,-121125600,2),(370,-99954000,1),(370,-89589600,2),(370,-68418000,1),(370,-57967200,2),(370,499748400,1),(370,511236000,2),(370,530593200,1),(370,540266400,2),(370,562129200,1),(370,571197600,2),(370,592974000,1),(370,602042400,2),(370,624423600,1),(370,634701600,2),(370,656478000,1),(370,666756000,2),(370,687927600,1),(370,697600800,2),(370,719982000,1),(370,728445600,2),(370,750826800,1),(370,761709600,2),(370,782276400,1),(370,793159200,2),(370,813726000,1),(370,824004000,2),(370,844570800,1),(370,856058400,2),(370,876106800,1),(370,888717600,2),(370,908074800,1),(370,919562400,2),(370,938919600,1),(370,951616800,2),(370,970974000,1),(370,982461600,2),(370,1003028400,1),(370,1013911200,2),(370,1036292400,1),(370,1045360800,2),(370,1066532400,1),(370,1076810400,2),(370,1099364400,1),(370,1108864800,2),(370,1129431600,1),(370,1140314400,2),(370,1162695600,1),(370,1172368800,2),(370,1192330800,1),(370,1203213600,2),(370,1224385200,1),(370,1234663200,2),(370,1255834800,1),(370,1266717600,2),(370,1287284400,1),(370,1298167200,2),(370,1318734000,1),(370,1330221600,2),(370,1350788400,1),(370,1361066400,2),(370,1382238000,1),(370,1392516000,2),(370,1413687600,1),(370,1424570400,2),(370,1445137200,1),(370,1456020000,2),(370,1476586800,1),(370,1487469600,2),(370,1508036400,1),(370,1518919200,2),(370,1541300400,1),(370,1550368800,2),(370,1572750000,1),(370,1581818400,2),(370,1604199600,1),(370,1613872800,2),(370,1636254000,1),(370,1645322400,2),(370,1667703600,1),(370,1677376800,2),(370,1699153200,1),(370,1708221600,2),(370,1730602800,1),(370,1739671200,2),(370,1762052400,1),(370,1771725600,2),(370,1793502000,1),(370,1803175200,2),(370,1825556400,1),(370,1834624800,2),(370,1857006000,1),(370,1866074400,2),(370,1888455600,1),(370,1897524000,2),(370,1919905200,1),(370,1928973600,2),(370,1951354800,1),(370,1960423200,2),(370,1983409200,1),(370,1992477600,2),(370,2014858800,1),(370,2024532000,2),(370,2046308400,1),(370,2055376800,2),(370,2077758000,1),(370,2086826400,2),(370,2109207600,1),(370,2118880800,2),(370,2140657200,1),(371,-2147483648,0),(371,-1767211196,2),(371,-1206954000,1),(371,-1191358800,2),(371,-1175371200,1),(371,-1159822800,2),(371,-633816000,1),(371,-622065600,2),(371,-602280000,1),(371,-591829200,2),(371,-570744000,1),(371,-560206800,2),(371,-539121600,1),(371,-531349200,2),(371,-191361600,1),(371,-184194000,2),(371,-155160000,1),(371,-150066000,2),(371,-128894400,1),(371,-121122000,2),(371,-99950400,1),(371,-89586000,2),(371,-68414400,1),(371,-57963600,2),(371,499752000,1),(371,511239600,2),(371,530596800,1),(371,540270000,2),(371,562132800,1),(371,571201200,2),(371,750830400,1),(371,761713200,2),(371,2147483647,2),(372,-1693706400,0),(372,-1680483600,1),(372,-1663455600,2),(372,-1650150000,3),(372,-1632006000,2),(372,-1618700400,3),(372,-938905200,2),(372,-857257200,3),(372,-844556400,2),(372,-828226800,3),(372,-812502000,2),(372,-796777200,3),(372,-781052400,2),(372,-766623600,3),(372,228877200,2),(372,243997200,3),(372,260326800,2),(372,276051600,3),(372,291776400,2),(372,307501200,3),(372,323830800,2),(372,338950800,3),(372,354675600,2),(372,370400400,3),(372,386125200,2),(372,401850000,3),(372,417574800,2),(372,433299600,3),(372,449024400,2),(372,465354000,3),(372,481078800,2),(372,496803600,3),(372,512528400,2),(372,528253200,3),(372,543978000,2),(372,559702800,3),(372,575427600,2),(372,591152400,3),(372,606877200,2),(372,622602000,3),(372,638326800,2),(372,654656400,3),(372,670381200,2),(372,686106000,3),(372,701830800,2),(372,717555600,3),(372,733280400,2),(372,749005200,3),(372,764730000,2),(372,780454800,3),(372,796179600,2),(372,811904400,3),(372,828234000,2),(372,846378000,3),(372,859683600,2),(372,877827600,3),(372,891133200,2),(372,909277200,3),(372,922582800,2),(372,941331600,3),(372,954032400,2),(372,972781200,3),(372,985482000,2),(372,1004230800,3),(372,1017536400,2),(372,1035680400,3),(372,1048986000,2),(372,1067130000,3),(372,1080435600,2),(372,1099184400,3),(372,1111885200,2),(372,1130634000,3),(372,1143334800,2),(372,1162083600,3),(372,1174784400,2),(372,1193533200,3),(372,1206838800,2),(372,1224982800,3),(372,1238288400,2),(372,1256432400,3),(372,1269738000,2),(372,1288486800,3),(372,1301187600,2),(372,1319936400,3),(372,1332637200,2),(372,1351386000,3),(372,1364691600,2),(372,1382835600,3),(372,1396141200,2),(372,1414285200,3),(372,1427590800,2),(372,1445734800,3),(372,1459040400,2),(372,1477789200,3),(372,1490490000,2),(372,1509238800,3),(372,1521939600,2),(372,1540688400,3),(372,1553994000,2),(372,1572138000,3),(372,1585443600,2),(372,1603587600,3),(372,1616893200,2),(372,1635642000,3),(372,1648342800,2),(372,1667091600,3),(372,1679792400,2),(372,1698541200,3),(372,1711846800,2),(372,1729990800,3),(372,1743296400,2),(372,1761440400,3),(372,1774746000,2),(372,1792890000,3),(372,1806195600,2),(372,1824944400,3),(372,1837645200,2),(372,1856394000,3),(372,1869094800,2),(372,1887843600,3),(372,1901149200,2),(372,1919293200,3),(372,1932598800,2),(372,1950742800,3),(372,1964048400,2),(372,1982797200,3),(372,1995498000,2),(372,2014246800,3),(372,2026947600,2),(372,2045696400,3),(372,2058397200,2),(372,2077146000,3),(372,2090451600,2),(372,2108595600,3),(372,2121901200,2),(372,2140045200,3),(373,-1633276800,0),(373,-1615136400,1),(373,-1601827200,0),(373,-1583686800,1),(373,-880214400,2),(373,-769395600,3),(373,-765392400,1),(373,-84384000,0),(373,-68662800,1),(373,-52934400,0),(373,-37213200,1),(373,-21484800,0),(373,-5763600,1),(373,9964800,0),(373,25686000,1),(373,41414400,0),(373,57740400,1),(373,73468800,0),(373,89190000,1),(373,104918400,0),(373,120639600,1),(373,126691200,0),(373,152089200,1),(373,162374400,0),(373,183538800,1),(373,199267200,0),(373,215593200,1),(373,230716800,0),(373,247042800,1),(373,262771200,0),(373,278492400,1),(373,294220800,0),(373,309942000,1),(373,325670400,0),(373,341391600,1),(373,357120000,0),(373,372841200,1),(373,388569600,0),(373,404895600,1),(373,420019200,0),(373,436345200,1),(373,452073600,0),(373,467794800,1),(373,483523200,0),(373,499244400,1),(373,514972800,0),(373,530694000,1),(373,544608000,0),(373,562143600,1),(373,576057600,0),(373,594198000,1),(373,607507200,0),(373,625647600,1),(373,638956800,0),(373,657097200,1),(373,671011200,0),(373,688546800,1),(373,702460800,0),(373,719996400,1),(373,733910400,0),(373,752050800,1),(373,765360000,0),(373,783500400,1),(373,796809600,0),(373,814950000,1),(373,828864000,0),(373,846399600,1),(373,860313600,0),(373,877849200,1),(373,891763200,0),(373,909298800,1),(373,923212800,0),(373,941353200,1),(373,954662400,0),(373,972802800,1),(373,986112000,0),(373,1004252400,1),(373,1018166400,0),(373,1035702000,1),(373,1049616000,0),(373,1067151600,1),(373,1081065600,0),(373,1099206000,1),(373,1112515200,0),(373,1130655600,1),(373,1143964800,0),(373,1162105200,1),(373,1173600000,0),(373,1194159600,1),(373,1205049600,0),(373,1225609200,1),(373,1236499200,0),(373,1257058800,1),(373,1268553600,0),(373,1289113200,1),(373,1300003200,0),(373,1320562800,1),(373,1331452800,0),(373,1352012400,1),(373,1362902400,0),(373,1383462000,1),(373,1394352000,0),(373,1414911600,1),(373,1425801600,0),(373,1446361200,1),(373,1457856000,0),(373,1478415600,1),(373,1489305600,0),(373,1509865200,1),(373,1520755200,0),(373,1541314800,1),(373,1552204800,0),(373,1572764400,1),(373,1583654400,0),(373,1604214000,1),(373,1615708800,0),(373,1636268400,1),(373,1647158400,0),(373,1667718000,1),(373,1678608000,0),(373,1699167600,1),(373,1710057600,0),(373,1730617200,1),(373,1741507200,0),(373,1762066800,1),(373,1772956800,0),(373,1793516400,1),(373,1805011200,0),(373,1825570800,1),(373,1836460800,0),(373,1857020400,1),(373,1867910400,0),(373,1888470000,1),(373,1899360000,0),(373,1919919600,1),(373,1930809600,0),(373,1951369200,1),(373,1962864000,0),(373,1983423600,1),(373,1994313600,0),(373,2014873200,1),(373,2025763200,0),(373,2046322800,1),(373,2057212800,0),(373,2077772400,1),(373,2088662400,0),(373,2109222000,1),(373,2120112000,0),(373,2140671600,1),(374,-2147483648,0),(374,-2131645536,2),(374,-1696276800,1),(374,-1680469200,2),(374,-1632074400,1),(374,-1615143600,2),(374,-1566763200,1),(374,-1557090000,2),(374,-1535486400,1),(374,-1524949200,2),(374,-1504468800,1),(374,-1493413200,2),(374,-1472414400,1),(374,-1461963600,2),(374,-1440964800,1),(374,-1429390800,2),(374,-1409515200,1),(374,-1396731600,2),(374,-1376856000,1),(374,-1366491600,2),(374,-1346616000,1),(374,-1333832400,2),(374,-1313956800,1),(374,-1303678800,2),(374,-1282507200,1),(374,-1272661200,2),(374,-1251057600,1),(374,-1240088400,2),(374,-1219608000,1),(374,-1207429200,2),(374,-1188763200,1),(374,-1175979600,2),(374,-1157313600,1),(374,-1143925200,2),(374,-1124049600,1),(374,-1113771600,2),(374,-1091390400,1),(374,-1081026000,2),(374,-1059854400,1),(374,-1050786000,2),(374,-1030910400,1),(374,-1018126800,2),(374,-999460800,1),(374,-986677200,2),(374,-965592000,1),(374,-955227600,2),(374,-935956800,1),(374,-923173200,2),(374,-904507200,1),(374,-891723600,2),(374,-880221600,3),(374,-769395600,4),(374,-765399600,2),(374,-747252000,1),(374,-733950000,2),(374,-715802400,1),(374,-702500400,2),(374,-684352800,1),(374,-671050800,2),(374,-652903200,1),(374,-639601200,2),(374,-589399200,1),(374,-576097200,2),(374,-557949600,1),(374,-544647600,2),(374,-526500000,1),(374,-513198000,2),(374,-495050400,1),(374,-481748400,2),(374,-431546400,1),(374,-418244400,2),(374,-400096800,1),(374,-386794800,2),(374,-368647200,1),(374,-355345200,2),(374,-337197600,1),(374,-323895600,2),(374,-242244000,1),(374,-226522800,2),(374,-210794400,1),(374,-195073200,2),(374,-179344800,1),(374,-163623600,2),(374,-147895200,1),(374,-131569200,2),(374,-116445600,1),(374,-100119600,2),(374,-84391200,1),(374,-68670000,2),(374,-52941600,1),(374,-37220400,2),(374,-21492000,1),(374,-5770800,2),(374,9957600,1),(374,25678800,2),(374,41407200,1),(374,57733200,2),(374,73461600,1),(374,89182800,2),(374,104911200,1),(374,120632400,2),(374,136360800,1),(374,152082000,2),(374,167810400,1),(374,183531600,2),(374,199260000,1),(374,215586000,2),(374,230709600,1),(374,247035600,2),(374,262764000,1),(374,278485200,2),(374,294213600,1),(374,309934800,2),(374,325663200,1),(374,341384400,2),(374,357112800,1),(374,372834000,2),(374,388562400,1),(374,404888400,2),(374,420012000,1),(374,436338000,2),(374,452066400,1),(374,467787600,2),(374,483516000,1),(374,499237200,2),(374,514965600,1),(374,530686800,2),(374,544600800,1),(374,562136400,2),(374,576050400,1),(374,594190800,2),(374,607500000,1),(374,625640400,2),(374,638949600,1),(374,657090000,2),(374,671004000,1),(374,688539600,2),(374,702453600,1),(374,719989200,2),(374,733903200,1),(374,752043600,2),(374,765352800,1),(374,783493200,2),(374,796802400,1),(374,814942800,2),(374,828856800,1),(374,846392400,2),(374,860306400,1),(374,877842000,2),(374,891756000,1),(374,909291600,2),(374,923205600,1),(374,941346000,2),(374,954655200,1),(374,972795600,2),(374,986104800,1),(374,1004245200,2),(374,1018159200,1),(374,1035694800,2),(374,1049608800,1),(374,1067144400,2),(374,1081058400,1),(374,1099198800,2),(374,1112508000,1),(374,1130648400,2),(374,1143957600,1),(374,1162098000,2),(374,1173592800,1),(374,1194152400,2),(374,1205042400,1),(374,1225602000,2),(374,1236492000,1),(374,1257051600,2),(374,1268546400,1),(374,1289106000,2),(374,1299996000,1),(374,1320555600,2),(374,1331445600,1),(374,1352005200,2),(374,1362895200,1),(374,1383454800,2),(374,1394344800,1),(374,1414904400,2),(374,1425794400,1),(374,1446354000,2),(374,1457848800,1),(374,1478408400,2),(374,1489298400,1),(374,1509858000,2),(374,1520748000,1),(374,1541307600,2),(374,1552197600,1),(374,1572757200,2),(374,1583647200,1),(374,1604206800,2),(374,1615701600,1),(374,1636261200,2),(374,1647151200,1),(374,1667710800,2),(374,1678600800,1),(374,1699160400,2),(374,1710050400,1),(374,1730610000,2),(374,1741500000,1),(374,1762059600,2),(374,1772949600,1),(374,1793509200,2),(374,1805004000,1),(374,1825563600,2),(374,1836453600,1),(374,1857013200,2),(374,1867903200,1),(374,1888462800,2),(374,1899352800,1),(374,1919912400,2),(374,1930802400,1),(374,1951362000,2),(374,1962856800,1),(374,1983416400,2),(374,1994306400,1),(374,2014866000,2),(374,2025756000,1),(374,2046315600,2),(374,2057205600,1),(374,2077765200,2),(374,2088655200,1),(374,2109214800,2),(374,2120104800,1),(374,2140664400,2),(375,-2147483648,2),(375,-1694368800,1),(375,-1681671600,2),(375,-1632067200,1),(375,-1615136400,2),(375,-1029686400,1),(375,-1018198800,2),(375,-880214400,3),(375,-769395600,4),(375,-765392400,2),(375,-746035200,1),(375,-732733200,2),(375,-715795200,1),(375,-702493200,2),(375,-684345600,1),(375,-671043600,2),(375,-652896000,1),(375,-639594000,2),(375,-620755200,1),(375,-607626000,2),(375,-589392000,1),(375,-576090000,2),(375,-557942400,1),(375,-544640400,2),(375,-526492800,1),(375,-513190800,2),(375,-495043200,1),(375,-481741200,2),(375,-463593600,1),(375,-450291600,2),(375,-431539200,1),(375,-418237200,2),(375,-400089600,1),(375,-386787600,2),(375,-368640000,1),(375,-355338000,2),(375,-337190400,1),(375,-321469200,2),(375,-305740800,1),(375,-292438800,2),(375,-210787200,1),(375,-198090000,2),(375,-116438400,5),(375,-100108800,6),(375,-84384000,5),(375,-68659200,6),(375,-52934400,5),(375,-37209600,6),(375,-21484800,5),(375,-5760000,6),(375,9964800,5),(375,25689600,6),(375,41414400,5),(375,57744000,6),(375,73468800,5),(375,89193600,6),(375,104918400,5),(375,120643200,6),(375,136368000,5),(375,152092800,6),(375,167817600,5),(375,183542400,6),(375,199267200,5),(375,215596800,6),(375,230716800,5),(375,247046400,6),(375,262771200,5),(375,278496000,6),(375,294220800,5),(375,309945600,6),(375,325670400,5),(375,341395200,6),(375,357120000,5),(375,372844800,6),(375,388569600,5),(375,404899200,6),(375,420019200,5),(375,436348800,6),(375,452073600,5),(375,467798400,6),(375,483523200,5),(375,499248000,6),(375,514972800,5),(375,530697600,6),(375,544608000,5),(375,562147200,6),(375,576057600,5),(375,594201600,6),(375,607507200,5),(375,625651200,6),(375,638956800,5),(375,657100800,6),(375,671011200,5),(375,688550400,6),(375,702460800,5),(375,720000000,6),(375,733910400,5),(375,752054400,6),(375,765360000,5),(375,783504000,6),(375,796809600,5),(375,814953600,6),(375,828864000,5),(375,846403200,6),(375,860313600,5),(375,877852800,6),(375,891763200,5),(375,909302400,6),(375,923212800,5),(375,941356800,6),(375,954662400,5),(375,972806400,6),(375,986112000,5),(375,1004256000,6),(375,1018166400,5),(375,1035705600,6),(375,1049616000,5),(375,1067155200,6),(375,1081065600,5),(375,1099209600,6),(375,1112515200,5),(375,1130659200,6),(375,1136095200,2),(375,1143964800,1),(375,1162105200,2),(375,1173600000,1),(375,1194159600,2),(375,1205049600,1),(375,1225609200,2),(375,1236499200,1),(375,1257058800,2),(375,1268553600,1),(375,1289113200,2),(375,1300003200,1),(375,1320562800,2),(375,1331452800,1),(375,1352012400,2),(375,1362902400,1),(375,1383462000,2),(375,1394352000,1),(375,1414911600,2),(375,1425801600,1),(375,1446361200,2),(375,1457856000,1),(375,1478415600,2),(375,1489305600,1),(375,1509865200,2),(375,1520755200,1),(375,1541314800,2),(375,1552204800,1),(375,1572764400,2),(375,1583654400,1),(375,1604214000,2),(375,1615708800,1),(375,1636268400,2),(375,1647158400,1),(375,1667718000,2),(375,1678608000,1),(375,1699167600,2),(375,1710057600,1),(375,1730617200,2),(375,1741507200,1),(375,1762066800,2),(375,1772956800,1),(375,1793516400,2),(375,1805011200,1),(375,1825570800,2),(375,1836460800,1),(375,1857020400,2),(375,1867910400,1),(375,1888470000,2),(375,1899360000,1),(375,1919919600,2),(375,1930809600,1),(375,1951369200,2),(375,1962864000,1),(375,1983423600,2),(375,1994313600,1),(375,2014873200,2),(375,2025763200,1),(375,2046322800,2),(375,2057212800,1),(375,2077772400,2),(375,2088662400,1),(375,2109222000,2),(375,2120112000,1),(375,2140671600,2),(376,-2147483648,2),(376,-1632070800,1),(376,-1615140000,2),(376,-1601753400,1),(376,-1583697600,2),(376,-1567357200,1),(376,-1554667200,2),(376,-1534698000,1),(376,-1524074400,2),(376,-1503248400,1),(376,-1492365600,2),(376,-1471798800,1),(376,-1460916000,2),(376,-1440954000,1),(376,-1428861600,2),(376,-1409504400,1),(376,-1397412000,2),(376,-1378054800,1),(376,-1365962400,2),(376,-1346605200,1),(376,-1333908000,2),(376,-1315155600,1),(376,-1301853600,2),(376,-1283706000,1),(376,-1270404000,2),(376,-1252256400,1),(376,-1238954400,2),(376,-1220806800,1),(376,-1207504800,2),(376,-1188752400,1),(376,-1176055200,2),(376,-1157302800,1),(376,-1144000800,2),(376,-1125853200,1),(376,-1112551200,2),(376,-1094403600,1),(376,-1081101600,2),(376,-1062954000,1),(376,-1049652000,2),(376,-1031504400,1),(376,-1018202400,2),(376,-1000054800,1),(376,-986752800,2),(376,-968000400,1),(376,-955303200,2),(376,-936550800,1),(376,-880218000,3),(376,-769395600,4),(376,-765396000,2),(376,-747248400,1),(376,-733946400,2),(376,-715806000,1),(376,-702504000,2),(376,-684356400,1),(376,-671054400,2),(376,-652906800,1),(376,-634161600,2),(376,-620845200,1),(376,-602704800,2),(376,-589395600,1),(376,-576093600,2),(376,-557946000,1),(376,-544644000,2),(376,-526496400,1),(376,-513194400,2),(376,-495046800,1),(376,-481744800,2),(376,-463597200,1),(376,-450295200,2),(376,-431542800,1),(376,-418240800,2),(376,-400093200,1),(376,-384372000,2),(376,-368643600,1),(376,-352922400,2),(376,-337194000,1),(376,-321472800,2),(376,-305744400,1),(376,-289418400,2),(376,-273690000,1),(376,-257968800,2),(376,-242240400,1),(376,-226519200,2),(376,-210790800,1),(376,-195069600,2),(376,-179341200,1),(376,-163620000,2),(376,-147891600,1),(376,-131565600,2),(376,-116442000,1),(376,-100116000,2),(376,-84387600,1),(376,-68666400,2),(376,-52938000,1),(376,-37216800,2),(376,-21488400,1),(376,-5767200,2),(376,9961200,1),(376,25682400,2),(376,41410800,1),(376,57736800,2),(376,73465200,1),(376,89186400,2),(376,104914800,1),(376,120636000,2),(376,136364400,1),(376,152085600,2),(376,167814000,1),(376,183535200,2),(376,199263600,1),(376,215589600,2),(376,230713200,1),(376,247039200,2),(376,262767600,1),(376,278488800,2),(376,294217200,1),(376,309938400,2),(376,325666800,1),(376,341388000,2),(376,357116400,1),(376,372837600,2),(376,388566000,1),(376,404892000,2),(376,420015600,1),(376,436341600,2),(376,452070000,1),(376,467791200,2),(376,483519600,1),(376,499240800,2),(376,514969200,1),(376,530690400,2),(376,544604400,1),(376,562140000,2),(376,576054000,1),(376,594194400,2),(376,607503600,1),(376,625644000,2),(376,638953200,1),(376,657093600,2),(376,671007600,1),(376,688543200,2),(376,702457200,1),(376,719992800,2),(376,733906800,1),(376,752047200,2),(376,765356400,1),(376,783496800,2),(376,796806000,1),(376,814946400,2),(376,828860400,1),(376,846396000,2),(376,860310000,1),(376,877845600,2),(376,891759600,1),(376,909295200,2),(376,923209200,1),(376,941349600,2),(376,954658800,1),(376,972799200,2),(376,986108400,1),(376,1004248800,2),(376,1018162800,1),(376,1035698400,2),(376,1049612400,1),(376,1067148000,2),(376,1081062000,1),(376,1099202400,2),(376,1112511600,1),(376,1130652000,2),(376,1143961200,1),(376,1162101600,2),(376,1173596400,1),(376,1194156000,2),(376,1205046000,1),(376,1225605600,2),(376,1236495600,1),(376,1257055200,2),(376,1268550000,1),(376,1289109600,2),(376,1299999600,1),(376,1320559200,2),(376,1331449200,1),(376,1352008800,2),(376,1362898800,1),(376,1383458400,2),(376,1394348400,1),(376,1414908000,2),(376,1425798000,1),(376,1446357600,2),(376,1457852400,1),(376,1478412000,2),(376,1489302000,1),(376,1509861600,2),(376,1520751600,1),(376,1541311200,2),(376,1552201200,1),(376,1572760800,2),(376,1583650800,1),(376,1604210400,2),(376,1615705200,1),(376,1636264800,2),(376,1647154800,1),(376,1667714400,2),(376,1678604400,1),(376,1699164000,2),(376,1710054000,1),(376,1730613600,2),(376,1741503600,1),(376,1762063200,2),(376,1772953200,1),(376,1793512800,2),(376,1805007600,1),(376,1825567200,2),(376,1836457200,1),(376,1857016800,2),(376,1867906800,1),(376,1888466400,2),(376,1899356400,1),(376,1919916000,2),(376,1930806000,1),(376,1951365600,2),(376,1962860400,1),(376,1983420000,2),(376,1994310000,1),(376,2014869600,2),(376,2025759600,1),(376,2046319200,2),(376,2057209200,1),(376,2077768800,2),(376,2088658800,1),(376,2109218400,2),(376,2120108400,1),(376,2140668000,2),(377,-2147483648,0),(377,-1998663968,2),(377,-1632063600,1),(377,-1615132800,2),(377,-1600614000,1),(377,-1596816000,2),(377,-1567954800,1),(377,-1551628800,2),(377,-1536505200,1),(377,-1523203200,2),(377,-1504450800,1),(377,-1491753600,2),(377,-1473001200,1),(377,-1459699200,2),(377,-880210800,3),(377,-769395600,4),(377,-765388800,2),(377,-715791600,1),(377,-702489600,2),(377,-84380400,1),(377,-68659200,2),(377,-21481200,1),(377,-5760000,2),(377,73472400,1),(377,89193600,2),(377,104922000,1),(377,120643200,2),(377,136371600,1),(377,152092800,2),(377,167821200,1),(377,183542400,2),(377,199270800,1),(377,215596800,2),(377,230720400,1),(377,247046400,2),(377,262774800,1),(377,278496000,2),(377,294224400,1),(377,309945600,2),(377,325674000,1),(377,341395200,2),(377,357123600,1),(377,372844800,2),(377,388573200,1),(377,404899200,2),(377,420022800,1),(377,436348800,2),(377,452077200,1),(377,467798400,2),(377,483526800,1),(377,499248000,2),(377,514976400,1),(377,530697600,2),(377,544611600,1),(377,562147200,2),(377,576061200,1),(377,594201600,2),(377,607510800,1),(377,625651200,2),(377,638960400,1),(377,657100800,2),(377,671014800,1),(377,688550400,2),(377,702464400,1),(377,720000000,2),(377,733914000,1),(377,752054400,2),(377,765363600,1),(377,783504000,2),(377,796813200,1),(377,814953600,2),(377,828867600,1),(377,846403200,2),(377,860317200,1),(377,877852800,2),(377,891766800,1),(377,909302400,2),(377,923216400,1),(377,941356800,2),(377,954666000,1),(377,972806400,2),(377,986115600,1),(377,1004256000,2),(377,1018170000,1),(377,1035705600,2),(377,1049619600,1),(377,1067155200,2),(377,1081069200,1),(377,1099209600,2),(377,1112518800,1),(377,1130659200,2),(377,1143968400,1),(377,1162108800,2),(377,1173603600,1),(377,1194163200,2),(377,1205053200,1),(377,1225612800,2),(377,1236502800,1),(377,1257062400,2),(377,1268557200,1),(377,1289116800,2),(377,1300006800,1),(377,1320566400,2),(377,1331456400,1),(377,1352016000,2),(377,1362906000,1),(377,1383465600,2),(377,1394355600,1),(377,1414915200,2),(377,1425805200,1),(377,1446364800,2),(377,1457859600,1),(377,1478419200,2),(377,1489309200,1),(377,1509868800,2),(377,1520758800,1),(377,1541318400,2),(377,1552208400,1),(377,1572768000,2),(377,1583658000,1),(377,1604217600,2),(377,1615712400,1),(377,1636272000,2),(377,1647162000,1),(377,1667721600,2),(377,1678611600,1),(377,1699171200,2),(377,1710061200,1),(377,1730620800,2),(377,1741510800,1),(377,1762070400,2),(377,1772960400,1),(377,1793520000,2),(377,1805014800,1),(377,1825574400,2),(377,1836464400,1),(377,1857024000,2),(377,1867914000,1),(377,1888473600,2),(377,1899363600,1),(377,1919923200,2),(377,1930813200,1),(377,1951372800,2),(377,1962867600,1),(377,1983427200,2),(377,1994317200,1),(377,2014876800,2),(377,2025766800,1),(377,2046326400,2),(377,2057216400,1),(377,2077776000,2),(377,2088666000,1),(377,2109225600,2),(377,2120115600,1),(377,2140675200,2),(378,-2147483648,2),(378,-1664130548,1),(378,-1650137348,2),(378,-1632076148,1),(378,-1615145348,2),(378,-1598650148,1),(378,-1590100148,2),(378,-1567286948,1),(378,-1551565748,2),(378,-1535837348,1),(378,-1520116148,2),(378,-1503782948,1),(378,-1488666548,2),(378,-1472333348,1),(378,-1457216948,2),(378,-1440883748,1),(378,-1425767348,2),(378,-1409434148,1),(378,-1394317748,2),(378,-1377984548,1),(378,-1362263348,2),(378,-1346534948,1),(378,-1330813748,2),(378,-1314480548,1),(378,-1299364148,2),(378,-1283030948,1),(378,-1267914548,2),(378,-1251581348,1),(378,-1236464948,2),(378,-1220131748,1),(378,-1205015348,2),(378,-1188682148,1),(378,-1172960948,2),(378,-1156627748,1),(378,-1141511348,2),(378,-1125178148,1),(378,-1110061748,2),(378,-1096921748,4),(378,-1093728600,3),(378,-1078612200,4),(378,-1061670600,3),(378,-1048973400,4),(378,-1030221000,3),(378,-1017523800,4),(378,-998771400,3),(378,-986074200,4),(378,-966717000,3),(378,-954624600,4),(378,-935267400,3),(378,-922570200,4),(378,-903817800,3),(378,-891120600,4),(378,-872368200,6),(378,-769395600,5),(378,-765401400,4),(378,-746044200,3),(378,-733347000,4),(378,-714594600,3),(378,-701897400,4),(378,-683145000,3),(378,-670447800,4),(378,-651695400,3),(378,-638998200,4),(378,-619641000,3),(378,-606943800,4),(378,-589401000,3),(378,-576099000,4),(378,-557951400,3),(378,-544649400,4),(378,-526501800,3),(378,-513199800,4),(378,-495052200,3),(378,-481750200,4),(378,-463602600,3),(378,-450300600,4),(378,-431548200,3),(378,-418246200,4),(378,-400098600,3),(378,-386796600,4),(378,-368649000,3),(378,-355347000,4),(378,-337199400,3),(378,-323897400,4),(378,-305749800,3),(378,-289423800,4),(378,-273695400,3),(378,-257974200,4),(378,-242245800,3),(378,-226524600,4),(378,-210796200,3),(378,-195075000,4),(378,-179346600,3),(378,-163625400,4),(378,-147897000,3),(378,-131571000,4),(378,-116447400,3),(378,-100121400,4),(378,-84393000,3),(378,-68671800,4),(378,-52943400,3),(378,-37222200,4),(378,-21493800,3),(378,-5772600,4),(378,9955800,3),(378,25677000,4),(378,41405400,3),(378,57731400,4),(378,73459800,3),(378,89181000,4),(378,104909400,3),(378,120630600,4),(378,136359000,3),(378,152080200,4),(378,167808600,3),(378,183529800,4),(378,199258200,3),(378,215584200,4),(378,230707800,3),(378,247033800,4),(378,262762200,3),(378,278483400,4),(378,294211800,3),(378,309933000,4),(378,325661400,3),(378,341382600,4),(378,357111000,3),(378,372832200,4),(378,388560600,3),(378,404886600,4),(378,420010200,3),(378,436336200,4),(378,452064600,3),(378,467785800,4),(378,483514200,3),(378,499235400,4),(378,514963800,3),(378,530685000,4),(378,544591860,3),(378,562127460,4),(378,576041460,7),(378,594178260,4),(378,607491060,3),(378,625631460,4),(378,638940660,3),(378,657081060,4),(378,670995060,3),(378,688530660,4),(378,702444660,3),(378,719980260,4),(378,733894260,3),(378,752034660,4),(378,765343860,3),(378,783484260,4),(378,796793460,3),(378,814933860,4),(378,828847860,3),(378,846383460,4),(378,860297460,3),(378,877833060,4),(378,891747060,3),(378,909282660,4),(378,923196660,3),(378,941337060,4),(378,954646260,3),(378,972786660,4),(378,986095860,3),(378,1004236260,4),(378,1018150260,3),(378,1035685860,4),(378,1049599860,3),(378,1067135460,4),(378,1081049460,3),(378,1099189860,4),(378,1112499060,3),(378,1130639460,4),(378,1143948660,3),(378,1162089060,4),(378,1173583860,3),(378,1194143460,4),(378,1205033460,3),(378,1225593060,4),(378,1236483060,3),(378,1257042660,4),(378,1268537460,3),(378,1289097060,4),(378,1299987060,3),(378,1320553800,4),(378,1331443800,3),(378,1352003400,4),(378,1362893400,3),(378,1383453000,4),(378,1394343000,3),(378,1414902600,4),(378,1425792600,3),(378,1446352200,4),(378,1457847000,3),(378,1478406600,4),(378,1489296600,3),(378,1509856200,4),(378,1520746200,3),(378,1541305800,4),(378,1552195800,3),(378,1572755400,4),(378,1583645400,3),(378,1604205000,4),(378,1615699800,3),(378,1636259400,4),(378,1647149400,3),(378,1667709000,4),(378,1678599000,3),(378,1699158600,4),(378,1710048600,3),(378,1730608200,4),(378,1741498200,3),(378,1762057800,4),(378,1772947800,3),(378,1793507400,4),(378,1805002200,3),(378,1825561800,4),(378,1836451800,3),(378,1857011400,4),(378,1867901400,3),(378,1888461000,4),(378,1899351000,3),(378,1919910600,4),(378,1930800600,3),(378,1951360200,4),(378,1962855000,3),(378,1983414600,4),(378,1994304600,3),(378,2014864200,4),(378,2025754200,3),(378,2046313800,4),(378,2057203800,3),(378,2077763400,4),(378,2088653400,3),(378,2109213000,4),(378,2120103000,3),(378,2140662600,4),(379,-2147483648,2),(379,-1632060000,1),(379,-1615129200,2),(379,-880207200,3),(379,-769395600,4),(379,-765385200,2),(379,-747237600,1),(379,-732726000,2),(379,-715788000,1),(379,-702486000,2),(379,-684338400,1),(379,-671036400,2),(379,-652888800,1),(379,-639586800,2),(379,-620834400,1),(379,-608137200,2),(379,-589384800,1),(379,-576082800,2),(379,-557935200,1),(379,-544633200,2),(379,-526485600,1),(379,-513183600,2),(379,-495036000,1),(379,-481734000,2),(379,-463586400,1),(379,-450284400,2),(379,-431532000,1),(379,-418230000,2),(379,-400082400,1),(379,-386780400,2),(379,-368632800,1),(379,-355330800,2),(379,-337183200,1),(379,-323881200,2),(379,-305733600,1),(379,-292431600,2),(379,-273679200,1),(379,-260982000,2),(379,-242229600,1),(379,-226508400,2),(379,-210780000,1),(379,-195058800,2),(379,-179330400,1),(379,-163609200,2),(379,-147880800,1),(379,-131554800,2),(379,-116431200,1),(379,-100105200,2),(379,-84376800,1),(379,-68655600,2),(379,-52927200,1),(379,-37206000,2),(379,-21477600,1),(379,-5756400,2),(379,9972000,1),(379,25693200,2),(379,41421600,1),(379,57747600,2),(379,73476000,1),(379,89197200,2),(379,104925600,1),(379,120646800,2),(379,136375200,1),(379,152096400,2),(379,167824800,1),(379,183546000,2),(379,199274400,1),(379,215600400,2),(379,230724000,1),(379,247050000,2),(379,262778400,1),(379,278499600,2),(379,294228000,1),(379,309949200,2),(379,325677600,1),(379,341398800,2),(379,357127200,1),(379,372848400,2),(379,388576800,1),(379,404902800,2),(379,420026400,1),(379,436352400,2),(379,452080800,1),(379,467802000,2),(379,483530400,1),(379,499251600,2),(379,514980000,1),(379,530701200,2),(379,544615200,1),(379,562150800,2),(379,576064800,1),(379,594205200,2),(379,607514400,1),(379,625654800,2),(379,638964000,1),(379,657104400,2),(379,671018400,1),(379,688554000,2),(379,702468000,1),(379,720003600,2),(379,733917600,1),(379,752058000,2),(379,765367200,1),(379,783507600,2),(379,796816800,1),(379,814957200,2),(379,828871200,1),(379,846406800,2),(379,860320800,1),(379,877856400,2),(379,891770400,1),(379,909306000,2),(379,923220000,1),(379,941360400,2),(379,954669600,1),(379,972810000,2),(379,986119200,1),(379,1004259600,2),(379,1018173600,1),(379,1035709200,2),(379,1049623200,1),(379,1067158800,2),(379,1081072800,1),(379,1099213200,2),(379,1112522400,1),(379,1130662800,2),(379,1143972000,1),(379,1162112400,2),(379,1173607200,1),(379,1194166800,2),(379,1205056800,1),(379,1225616400,2),(379,1236506400,1),(379,1257066000,2),(379,1268560800,1),(379,1289120400,2),(379,1300010400,1),(379,1320570000,2),(379,1331460000,1),(379,1352019600,2),(379,1362909600,1),(379,1383469200,2),(379,1394359200,1),(379,1414918800,2),(379,1425808800,1),(379,1446368400,2),(379,1457863200,1),(379,1478422800,2),(379,1489312800,1),(379,1509872400,2),(379,1520762400,1),(379,1541322000,2),(379,1552212000,1),(379,1572771600,2),(379,1583661600,1),(379,1604221200,2),(379,1615716000,1),(379,1636275600,2),(379,1647165600,1),(379,1667725200,2),(379,1678615200,1),(379,1699174800,2),(379,1710064800,1),(379,1730624400,2),(379,1741514400,1),(379,1762074000,2),(379,1772964000,1),(379,1793523600,2),(379,1805018400,1),(379,1825578000,2),(379,1836468000,1),(379,1857027600,2),(379,1867917600,1),(379,1888477200,2),(379,1899367200,1),(379,1919926800,2),(379,1930816800,1),(379,1951376400,2),(379,1962871200,1),(379,1983430800,2),(379,1994320800,1),(379,2014880400,2),(379,2025770400,1),(379,2046330000,2),(379,2057220000,1),(379,2077779600,2),(379,2088669600,1),(379,2109229200,2),(379,2120119200,1),(379,2140678800,2),(380,-2147483648,0),(380,-2030202084,2),(380,-1632063600,1),(380,-1615132800,2),(380,-1251651600,1),(380,-1238349600,2),(380,-1220202000,1),(380,-1206900000,2),(380,-1188752400,1),(380,-1175450400,2),(380,-1156698000,1),(380,-1144000800,2),(380,-1125248400,1),(380,-1111946400,2),(380,-1032714000,1),(380,-1016992800,2),(380,-1001264400,1),(380,-986148000,2),(380,-969814800,1),(380,-954093600,2),(380,-937760400,1),(380,-922039200,2),(380,-906310800,1),(380,-890589600,2),(380,-880210800,3),(380,-769395600,4),(380,-765388800,2),(380,-748450800,1),(380,-732729600,2),(380,-715791600,1),(380,-702489600,2),(380,-684342000,1),(380,-671040000,2),(380,-652892400,1),(380,-639590400,2),(380,-620838000,1),(380,-608140800,2),(380,-589388400,1),(380,-576086400,2),(380,-557938800,1),(380,-544636800,2),(380,-526489200,1),(380,-513187200,2),(380,-495039600,1),(380,-481737600,2),(380,-463590000,1),(380,-450288000,2),(380,-431535600,1),(380,-418233600,2),(380,-400086000,1),(380,-386784000,2),(380,-337186800,1),(380,-321465600,2),(380,-305737200,5),(381,-2147483648,2),(381,-1632056400,1),(381,-1615125600,2),(381,-1596978000,1),(381,-1583164800,2),(381,-880203600,3),(381,-769395600,4),(381,-765381600,2),(381,-147884400,5),(381,-131554800,2),(381,-81961200,6),(381,325677600,7),(381,341398800,6),(381,357127200,7),(381,372848400,6),(381,388576800,7),(381,404902800,6),(381,420026400,7),(381,436352400,6),(381,452080800,7),(381,467802000,6),(381,483530400,7),(381,499251600,6),(381,514980000,7),(381,530701200,6),(381,544615200,7),(381,562150800,6),(381,576064800,7),(381,594205200,6),(381,607514400,7),(381,625654800,6),(381,638964000,7),(381,657104400,6),(381,671018400,7),(381,688554000,6),(381,702468000,7),(381,720003600,6),(381,733917600,7),(381,752058000,6),(381,765367200,7),(381,783507600,6),(381,796816800,7),(381,814957200,6),(381,828871200,7),(381,846406800,6),(381,860320800,7),(381,877856400,6),(381,891770400,7),(381,909306000,6),(381,923220000,7),(381,941360400,6),(381,954669600,7),(381,972810000,6),(381,986119200,7),(381,1004259600,6),(381,1018173600,7),(381,1035709200,6),(381,1049623200,7),(381,1067158800,6),(381,1081072800,7),(381,1099213200,6),(381,1112522400,7),(381,1130662800,6),(381,1143972000,7),(381,1162112400,6),(381,1173607200,7),(381,1194166800,6),(381,1205056800,7),(381,1225616400,6),(381,1236506400,7),(381,1257066000,6),(381,1268560800,7),(381,1289120400,6),(381,1300010400,7),(381,1320570000,6),(381,1331460000,7),(381,1352019600,6),(381,1362909600,7),(381,1383469200,6),(381,1394359200,7),(381,1414918800,6),(381,1425808800,7),(381,1446368400,6),(381,1457863200,7),(381,1478422800,6),(381,1489312800,7),(381,1509872400,6),(381,1520762400,7),(381,1541322000,6),(381,1552212000,7),(381,1572771600,6),(381,1583661600,7),(381,1604221200,6),(381,1615716000,7),(381,1636275600,6),(381,1647165600,7),(381,1667725200,6),(381,1678615200,7),(381,1699174800,6),(381,1710064800,7),(381,1730624400,6),(381,1741514400,7),(381,1762074000,6),(381,1772964000,7),(381,1793523600,6),(381,1805018400,7),(381,1825578000,6),(381,1836468000,7),(381,1857027600,6),(381,1867917600,7),(381,1888477200,6),(381,1899367200,7),(381,1919926800,6),(381,1930816800,7),(381,1951376400,6),(381,1962871200,7),(381,1983430800,6),(381,1994320800,7),(381,2014880400,6),(381,2025770400,7),(381,2046330000,6),(381,2057220000,7),(381,2077779600,6),(381,2088669600,7),(381,2109229200,6),(381,2120119200,7),(381,2140678800,6),(382,-2147483648,1),(382,-1892661434,2),(382,-1688410800,1),(382,-1619205434,3),(382,-1593806400,1),(382,-1335986234,4),(382,-1317585600,2),(382,-1304362800,4),(382,-1286049600,2),(382,-1272826800,4),(382,-1254513600,2),(382,-1241290800,4),(382,-1222977600,2),(382,-1209754800,4),(382,-1191355200,2),(382,-1178132400,3),(382,-870552000,2),(382,-865278000,3),(382,-740520000,5),(382,-736376400,3),(382,-718056000,2),(382,-713649600,3),(382,-36619200,6),(382,-23922000,7),(382,-3355200,6),(382,7527600,7),(382,24465600,6),(382,37767600,7),(382,55915200,6),(382,69217200,7),(382,87969600,6),(382,100666800,7),(382,118209600,6),(382,132116400,7),(382,150868800,6),(382,163566000,7),(382,182318400,6),(382,195620400,7),(382,213768000,6),(382,227070000,7),(382,245217600,6),(382,258519600,7),(382,277272000,6),(382,289969200,7),(382,308721600,6),(382,321418800,7),(382,340171200,6),(382,353473200,7),(382,371620800,6),(382,384922800,7),(382,403070400,6),(382,416372400,7),(382,434520000,6),(382,447822000,7),(382,466574400,6),(382,479271600,7),(382,498024000,6),(382,510721200,7),(382,529473600,6),(382,545194800,7),(382,560923200,6),(382,574225200,7),(382,592372800,6),(382,605674800,7),(382,624427200,6),(382,637124400,7),(382,653457600,6),(382,668574000,7),(382,687326400,6),(382,700628400,7),(382,718776000,6),(382,732078000,7),(382,750225600,6),(382,763527600,7),(382,781675200,6),(382,794977200,7),(382,813729600,6),(382,826426800,7),(382,845179200,6),(382,859690800,7),(382,876628800,6),(382,889930800,7),(382,906868800,6),(382,923194800,7),(382,939528000,6),(382,952830000,7),(382,971582400,6),(382,984279600,7),(382,1003032000,6),(382,1015729200,7),(382,1034481600,6),(382,1047178800,7),(382,1065931200,6),(382,1079233200,7),(382,1097380800,6),(382,1110682800,7),(382,1128830400,6),(382,1142132400,7),(382,1160884800,6),(382,1173582000,7),(382,1192334400,6),(382,1206846000,7),(382,1223784000,6),(382,1237086000,7),(382,1255233600,6),(382,1270350000,7),(382,1286683200,6),(382,1304823600,7),(382,1313899200,6),(382,1335668400,7),(382,1346558400,6),(382,1367118000,7),(382,1378612800,6),(382,1398567600,7),(382,1410062400,6),(382,1463281200,7),(382,1471147200,6),(382,1494730800,7),(382,1502596800,6),(382,1526180400,7),(382,1534046400,6),(382,1554606000,7),(382,1567915200,6),(382,1586055600,7),(382,1599364800,6),(382,1617505200,7),(382,1630814400,6),(382,1648954800,7),(382,1662264000,6),(382,1680404400,7),(382,1693713600,6),(382,1712458800,7),(382,1725768000,6),(382,1743908400,7),(382,1757217600,6),(382,1775358000,7),(382,1788667200,6),(382,1806807600,7),(382,1820116800,6),(382,1838257200,7),(382,1851566400,6),(382,1870311600,7),(382,1883016000,6),(382,1901761200,7),(382,1915070400,6),(382,1933210800,7),(382,1946520000,6),(382,1964660400,7),(382,1977969600,6),(382,1996110000,7),(382,2009419200,6),(382,2027559600,7),(382,2040868800,6),(382,2059614000,7),(382,2072318400,6),(382,2091063600,7),(382,2104372800,6),(382,2122513200,7),(382,2135822400,6),(382,2147483647,6),(383,-2147483648,1),(383,-1178124152,4),(383,-36619200,2),(383,-23922000,3),(383,-3355200,2),(383,7527600,3),(383,24465600,2),(383,37767600,3),(383,55915200,2),(383,69217200,3),(383,87969600,2),(383,100666800,3),(383,118209600,2),(383,132116400,3),(383,150868800,2),(383,163566000,3),(383,182318400,2),(383,195620400,3),(383,213768000,2),(383,227070000,3),(383,245217600,2),(383,258519600,3),(383,277272000,2),(383,289969200,3),(383,308721600,2),(383,321418800,3),(383,340171200,2),(383,353473200,3),(383,371620800,2),(383,384922800,5),(383,403070400,6),(383,416372400,5),(383,434520000,6),(383,447822000,5),(383,466574400,6),(383,479271600,5),(383,498024000,6),(383,510721200,5),(383,529473600,6),(383,545194800,5),(383,560923200,6),(383,574225200,5),(383,592372800,6),(383,605674800,5),(383,624427200,6),(383,637124400,5),(383,653457600,6),(383,668574000,5),(383,687326400,6),(383,700628400,5),(383,718776000,6),(383,732078000,5),(383,750225600,6),(383,763527600,5),(383,781675200,6),(383,794977200,5),(383,813729600,6),(383,826426800,5),(383,845179200,6),(383,859690800,5),(383,876628800,6),(383,889930800,5),(383,906868800,6),(383,923194800,5),(383,939528000,6),(383,952830000,5),(383,971582400,6),(383,984279600,5),(383,1003032000,6),(383,1015729200,5),(383,1034481600,6),(383,1047178800,5),(383,1065931200,6),(383,1079233200,5),(383,1097380800,6),(383,1110682800,5),(383,1128830400,6),(383,1142132400,5),(383,1160884800,6),(383,1173582000,5),(383,1192334400,6),(383,1206846000,5),(383,1223784000,6),(383,1237086000,5),(383,1255233600,6),(383,1270350000,5),(383,1286683200,6),(383,1304823600,5),(383,1313899200,6),(383,1335668400,5),(383,1346558400,6),(383,1367118000,5),(383,1378612800,6),(383,1398567600,5),(383,1410062400,6),(383,1463281200,5),(383,1471147200,6),(383,1494730800,5),(383,1502596800,6),(383,1526180400,5),(383,1534046400,6),(383,1554606000,5),(383,1567915200,6),(383,1586055600,5),(383,1599364800,6),(383,1617505200,5),(383,1630814400,6),(383,1648954800,5),(383,1662264000,6),(383,1680404400,5),(383,1693713600,6),(383,1712458800,5),(383,1725768000,6),(383,1743908400,5),(383,1757217600,6),(383,1775358000,5),(383,1788667200,6),(383,1806807600,5),(383,1820116800,6),(383,1838257200,5),(383,1851566400,6),(383,1870311600,5),(383,1883016000,6),(383,1901761200,5),(383,1915070400,6),(383,1933210800,5),(383,1946520000,6),(383,1964660400,5),(383,1977969600,6),(383,1996110000,5),(383,2009419200,6),(383,2027559600,5),(383,2040868800,6),(383,2059614000,5),(383,2072318400,6),(383,2091063600,5),(383,2104372800,6),(383,2122513200,5),(383,2135822400,6),(383,2147483647,6),(384,-2147483648,1),(384,-1402813824,3),(384,-1311534000,2),(384,-1300996800,3),(384,-933534000,2),(384,-925675200,3),(384,-902084400,2),(384,-893620800,3),(384,-870030000,2),(384,-862171200,3),(384,-775681200,2),(384,-767822400,3),(384,-744231600,2),(384,-736372800,3),(384,-144702000,2),(384,-134251200,3),(384,-113425200,2),(384,-102542400,3),(384,-86295600,2),(384,-72907200,3),(384,-54154800,2),(384,-41457600,3),(384,-21495600,2),(384,-5774400,3),(384,9954000,2),(384,25675200,3),(384,41403600,2),(384,57729600,3),(384,73458000,2),(384,87364800,3),(384,104907600,2),(384,118900800,3),(384,136357200,2),(384,150436800,3),(384,167806800,2),(384,183528000,3),(384,199256400,2),(384,215582400,3),(384,230706000,2),(384,247032000,3),(384,263365200,2),(384,276667200,3),(384,290581200,2),(384,308721600,3),(384,322030800,2),(384,340171200,3),(384,358318800,2),(384,371620800,3),(384,389768400,2),(384,403070400,3),(384,421218000,2),(384,434520000,3),(384,452667600,2),(384,466574400,3),(384,484117200,2),(384,498024000,3),(384,511333200,2),(384,529473600,3),(384,542782800,2),(384,560923200,3),(384,574837200,2),(384,592372800,3),(384,606286800,2),(384,623822400,3),(384,638946000,2),(384,655876800,3),(384,671000400,2),(384,687330000,4),(384,702450000,2),(384,718779600,4),(384,733899600,2),(384,750229200,4),(384,765349200,2),(384,781678800,4),(384,796798800,2),(384,813128400,4),(384,828853200,2),(384,844578000,4),(384,860302800,2),(384,876632400,4),(384,891147600,5),(384,909291600,4),(384,922597200,5),(384,941346000,4),(384,954651600,5),(384,972795600,4),(384,986101200,5),(384,1004245200,4),(384,1018155600,5),(384,1035694800,4),(384,1049605200,5),(384,1067144400,4),(384,1080450000,5),(384,1162098000,4),(384,1173589200,5),(384,1193547600,4),(384,1205643600,5),(384,1224997200,4),(384,1236488400,5),(384,1256446800,4),(384,1268542800,5),(384,1288501200,4),(384,1300597200,5),(384,1321160400,4),(384,1333256400,5),(384,1352005200,4),(384,1362891600,5),(384,1383454800,4),(384,1394341200,5),(384,1414904400,4),(384,1425790800,5),(384,1446354000,4),(384,1457845200,5),(384,1478408400,4),(384,1489294800,5),(384,1509858000,4),(384,1520744400,5),(384,1541307600,4),(384,1552194000,5),(384,1572757200,4),(384,1583643600,5),(384,1604206800,4),(384,1615698000,5),(384,1636261200,4),(384,1647147600,5),(384,1667710800,4),(384,1678597200,5),(384,1699160400,4),(384,1710046800,5),(384,1730610000,4),(384,1741496400,5),(384,1762059600,4),(384,1772946000,5),(384,1793509200,4),(384,1805000400,5),(384,1825563600,4),(384,1836450000,5),(384,1857013200,4),(384,1867899600,5),(384,1888462800,4),(384,1899349200,5),(384,1919912400,4),(384,1930798800,5),(384,1951362000,4),(384,1962853200,5),(384,1983416400,4),(384,1994302800,5),(384,2014866000,4),(384,2025752400,5),(384,2046315600,4),(384,2057202000,5),(384,2077765200,4),(384,2088651600,5),(384,2109214800,4),(384,2120101200,5),(384,2140664400,4),(385,228877200,0),(385,243997200,1),(385,260326800,0),(385,276051600,1),(385,291776400,0),(385,307501200,1),(385,323830800,0),(385,338950800,1),(385,354675600,0),(385,370400400,1),(385,386125200,0),(385,401850000,1),(385,417574800,0),(385,433299600,1),(385,449024400,0),(385,465354000,1),(385,481078800,0),(385,496803600,1),(385,512528400,0),(385,528253200,1),(385,543978000,0),(385,559702800,1),(385,575427600,0),(385,591152400,1),(385,606877200,0),(385,622602000,1),(385,638326800,0),(385,654656400,1),(385,670381200,0),(385,686106000,1),(385,701830800,0),(385,717555600,1),(385,733280400,0),(385,749005200,1),(385,764730000,0),(385,780454800,1),(385,796179600,0),(385,811904400,1),(385,828234000,0),(385,846378000,1),(385,859683600,0),(385,877827600,1),(385,891133200,0),(385,909277200,1),(385,922582800,0),(385,941331600,1),(385,954032400,0),(385,972781200,1),(385,985482000,0),(385,1004230800,1),(385,1017536400,0),(385,1035680400,1),(385,1048986000,0),(385,1067130000,1),(385,1080435600,0),(385,1099184400,1),(385,1111885200,0),(385,1130634000,1),(385,1143334800,0),(385,1162083600,1),(385,1174784400,0),(385,1193533200,1),(385,1206838800,0),(385,1224982800,1),(385,1238288400,0),(385,1256432400,1),(385,1269738000,0),(385,1288486800,1),(385,1301187600,0),(385,1319936400,1),(385,1332637200,0),(385,1351386000,1),(385,1364691600,0),(385,1382835600,1),(385,1396141200,0),(385,1414285200,1),(385,1427590800,0),(385,1445734800,1),(385,1459040400,0),(385,1477789200,1),(385,1490490000,0),(385,1509238800,1),(385,1521939600,0),(385,1540688400,1),(385,1553994000,0),(385,1572138000,1),(385,1585443600,0),(385,1603587600,1),(385,1616893200,0),(385,1635642000,1),(385,1648342800,0),(385,1667091600,1),(385,1679792400,0),(385,1698541200,1),(385,1711846800,0),(385,1729990800,1),(385,1743296400,0),(385,1761440400,1),(385,1774746000,0),(385,1792890000,1),(385,1806195600,0),(385,1824944400,1),(385,1837645200,0),(385,1856394000,1),(385,1869094800,0),(385,1887843600,1),(385,1901149200,0),(385,1919293200,1),(385,1932598800,0),(385,1950742800,1),(385,1964048400,0),(385,1982797200,1),(385,1995498000,0),(385,2014246800,1),(385,2026947600,0),(385,2045696400,1),(385,2058397200,0),(385,2077146000,1),(385,2090451600,0),(385,2108595600,1),(385,2121901200,0),(385,2140045200,1),(387,-1633280400,0),(387,-1615140000,1),(387,-1601830800,0),(387,-1583690400,1),(387,-880218000,2),(387,-769395600,3),(387,-765396000,1),(387,-84387600,0),(387,-68666400,1),(387,-52938000,0),(387,-37216800,1),(387,-21488400,0),(387,-5767200,1),(387,9961200,0),(387,25682400,1),(387,41410800,0),(387,57736800,1),(387,73465200,0),(387,89186400,1),(387,104914800,0),(387,120636000,1),(387,126687600,0),(387,152085600,1),(387,162370800,0),(387,183535200,1),(387,199263600,0),(387,215589600,1),(387,230713200,0),(387,247039200,1),(387,262767600,0),(387,278488800,1),(387,294217200,0),(387,309938400,1),(387,325666800,0),(387,341388000,1),(387,357116400,0),(387,372837600,1),(387,388566000,0),(387,404892000,1),(387,420015600,0),(387,436341600,1),(387,452070000,0),(387,467791200,1),(387,483519600,0),(387,499240800,1),(387,514969200,0),(387,530690400,1),(387,544604400,0),(387,562140000,1),(387,576054000,0),(387,594194400,1),(387,607503600,0),(387,625644000,1),(387,638953200,0),(387,657093600,1),(387,671007600,0),(387,688543200,1),(387,702457200,0),(387,719992800,1),(387,733906800,0),(387,752047200,1),(387,765356400,0),(387,783496800,1),(387,796806000,0),(387,814946400,1),(387,828860400,0),(387,846396000,1),(387,860310000,0),(387,877845600,1),(387,891759600,0),(387,909295200,1),(387,923209200,0),(387,941349600,1),(387,954658800,0),(387,972799200,1),(387,986108400,0),(387,1004248800,1),(387,1018162800,0),(387,1035698400,1),(387,1049612400,0),(387,1067148000,1),(387,1081062000,0),(387,1099202400,1),(387,1112511600,0),(387,1130652000,1),(387,1143961200,0),(387,1162101600,1),(387,1173596400,0),(387,1194156000,1),(387,1205046000,0),(387,1225605600,1),(387,1236495600,0),(387,1257055200,1),(387,1268550000,0),(387,1289109600,1),(387,1299999600,0),(387,1320559200,1),(387,1331449200,0),(387,1352008800,1),(387,1362898800,0),(387,1383458400,1),(387,1394348400,0),(387,1414908000,1),(387,1425798000,0),(387,1446357600,1),(387,1457852400,0),(387,1478412000,1),(387,1489302000,0),(387,1509861600,1),(387,1520751600,0),(387,1541311200,1),(387,1552201200,0),(387,1572760800,1),(387,1583650800,0),(387,1604210400,1),(387,1615705200,0),(387,1636264800,1),(387,1647154800,0),(387,1667714400,1),(387,1678604400,0),(387,1699164000,1),(387,1710054000,0),(387,1730613600,1),(387,1741503600,0),(387,1762063200,1),(387,1772953200,0),(387,1793512800,1),(387,1805007600,0),(387,1825567200,1),(387,1836457200,0),(387,1857016800,1),(387,1867906800,0),(387,1888466400,1),(387,1899356400,0),(387,1919916000,1),(387,1930806000,0),(387,1951365600,1),(387,1962860400,0),(387,1983420000,1),(387,1994310000,0),(387,2014869600,1),(387,2025759600,0),(387,2046319200,1),(387,2057209200,0),(387,2077768800,1),(387,2088658800,0),(387,2109218400,1),(387,2120108400,0),(387,2140668000,1),(388,-2147483648,2),(388,-929844000,1),(388,-923108400,2),(388,-906170400,1),(388,-892868400,2),(388,-875844000,1),(388,-857790000,2),(388,-844308000,1),(388,-825822000,2),(388,-812685600,1),(388,-794199600,2),(388,-779853600,1),(388,-762663600,2),(388,-399088800,1),(388,-386650800,2),(388,-368330400,1),(388,-355114800,2),(388,-336790800,1),(388,-323654400,2),(388,-305168400,1),(388,-292032000,2),(388,-273632400,1),(388,-260496000,2),(388,-242096400,1),(388,-228960000,2),(388,-210560400,1),(388,-197424000,2),(388,-178938000,1),(388,-165801600,2),(388,-147402000,1),(388,-134265600,2),(388,-115866000,1),(388,-102643200,2),(388,-84330000,1),(388,-71107200,2),(388,-52707600,1),(388,-39484800,2),(388,-21171600,1),(388,-7948800,2),(388,10364400,1),(388,23587200,2),(388,41900400,1),(388,55123200,2),(388,73522800,1),(388,86745600,2),(388,105058800,1),(388,118281600,2),(388,136594800,1),(388,149817600,2),(388,168130800,1),(388,181353600,2),(388,199753200,1),(388,212976000,2),(388,231289200,1),(388,244512000,2),(388,262825200,1),(388,276048000,2),(388,294361200,1),(388,307584000,2),(388,325983600,1),(388,339206400,2),(388,357519600,1),(388,370742400,2),(388,396399600,1),(388,402278400,2),(388,426812400,1),(388,433814400,2),(388,452214000,1),(388,465436800,2),(388,483750000,1),(388,496972800,2),(388,515286000,1),(388,528508800,2),(388,546822000,1),(388,560044800,2),(388,578444400,1),(388,591667200,2),(388,610412400,1),(388,623203200,2),(388,641516400,1),(388,654739200,2),(388,673052400,1),(388,686275200,2),(388,704674800,1),(388,717897600,2),(388,736210800,1),(388,749433600,2),(388,767746800,1),(388,780969600,2),(388,799020000,3),(388,812322000,2),(388,830469600,3),(388,843771600,2),(388,861919200,3),(388,875221200,2),(388,893368800,3),(388,906670800,2),(388,925423200,3),(388,938725200,2),(388,956872800,3),(388,970174800,2),(388,988322400,3),(388,1001624400,2),(388,1019772000,3),(388,1033074000,2),(388,1051221600,3),(388,1064523600,2),(388,1083276000,3),(388,1096578000,2),(388,1114725600,3),(388,1128027600,2),(388,1146175200,3),(388,1158872400,2),(388,1177624800,3),(388,1189112400,2),(388,1209074400,3),(388,1219957200,2),(388,1240524000,3),(388,1250802000,2),(388,1272578400,3),(388,1281474000,2),(388,1284069600,1),(388,1285880400,2),(388,1400191200,1),(388,1403816400,2),(388,1406844000,1),(388,1411678800,2),(389,-2147483648,1),(389,-1691962479,2),(389,-1680471279,4),(389,-1664143200,3),(389,-1650146400,4),(389,-1633903200,3),(389,-1617487200,4),(389,-1601848800,3),(389,-1586037600,4),(389,-1570399200,3),(389,-1552168800,4),(389,-1538344800,3),(389,-1522533600,4),(389,-1517011200,6),(389,-1507500000,5),(389,-1490565600,4),(389,-1473631200,5),(389,-1460930400,4),(389,-1442786400,5),(389,-1428876000,4),(389,-1410732000,5),(389,-1396216800,4),(389,-1379282400,5),(389,-1364767200,4),(389,-1348437600,5),(389,-1333317600,4),(389,-1315778400,5),(389,-1301263200,4),(389,-1284328800,5),(389,-1269813600,4),(389,-1253484000,5),(389,-1238364000,4),(389,-1221429600,5),(389,-1206914400,4),(389,-1189980000,5),(389,-1175464800,4),(389,-1159135200,5),(389,-1143410400,4),(389,-1126476000,5),(389,-1111960800,4),(389,-1095631200,5),(389,-1080511200,4),(389,-1063576800,5),(389,-1049061600,4),(389,-1032127200,5),(389,-1017612000,4),(389,-1001282400,5),(389,-986162400,4),(389,-969228000,5),(389,-950479200,4),(389,-942012000,5),(389,-733356000,4),(389,-719445600,5),(389,-699487200,4),(389,-684972000,5),(389,-668037600,4),(389,-654732000,5),(389,-636588000,4),(389,-622072800,5),(389,-605743200,4),(389,-590623200,5),(389,-574293600,4),(389,-558568800,5),(389,-542239200,4),(389,-527119200,5),(389,-512604000,4),(389,-496274400,5),(389,-481154400,4),(389,-464220000,5),(389,-449704800,4),(389,-432165600,5),(389,-417650400,4),(389,-401320800,5),(389,-386200800,4),(389,-369266400,5),(389,-354751200,4),(389,-337816800,5),(389,-323301600,4),(389,-306972000,5),(389,-291852000,4),(389,-276732000,5),(389,-257983200,4),(389,-245282400,5),(389,-226533600,4),(389,-213228000,5),(389,-195084000,4),(389,-182383200,5),(389,-163634400,4),(389,-150933600,5),(389,-132184800,4),(389,-119484000,5),(389,-100735200,4),(389,-88034400,5),(389,-68680800,4),(389,-59004000,5),(389,-37242000,9),(389,57722400,7),(389,69818400,8),(389,89172000,7),(389,101268000,8),(389,120621600,7),(389,132717600,8),(389,152071200,7),(389,164167200,8),(389,183520800,7),(389,196221600,8),(389,214970400,7),(389,227671200,8),(389,246420000,7),(389,259120800,8),(389,278474400,7),(389,290570400,8),(389,309924000,7),(389,322020000,8),(389,341373600,7),(389,354675600,8),(389,372819600,7),(389,386125200,8),(389,404269200,7),(389,417574800,8),(389,435718800,7),(389,449024400,8),(389,467773200,7),(389,481078800,8),(389,499222800,7),(389,512528400,8),(389,530672400,7),(389,543978000,8),(389,562122000,7),(389,575427600,8),(389,593571600,7),(389,606877200,8),(389,625626000,7),(389,638326800,8),(389,657075600,7),(389,670381200,8),(389,688525200,7),(389,701830800,8),(389,719974800,7),(389,733280400,8),(389,751424400,7),(389,764730000,8),(389,782874000,7),(389,796179600,8),(389,814323600,7),(389,828234000,8),(389,846378000,7),(389,859683600,8),(389,877827600,7),(389,891133200,8),(389,909277200,7),(389,922582800,8),(389,941331600,7),(389,954032400,8),(389,972781200,7),(389,985482000,8),(389,1004230800,7),(389,1017536400,8),(389,1035680400,7),(389,1048986000,8),(389,1067130000,7),(389,1080435600,8),(389,1099184400,7),(389,1111885200,8),(389,1130634000,7),(389,1143334800,8),(389,1162083600,7),(389,1174784400,8),(389,1193533200,7),(389,1206838800,8),(389,1224982800,7),(389,1238288400,8),(389,1256432400,7),(389,1269738000,8),(389,1288486800,7),(389,1301187600,8),(389,1319936400,7),(389,1332637200,8),(389,1351386000,7),(389,1364691600,8),(389,1382835600,7),(389,1396141200,8),(389,1414285200,7),(389,1427590800,8),(389,1445734800,7),(389,1459040400,8),(389,1477789200,7),(389,1490490000,8),(389,1509238800,7),(389,1521939600,8),(389,1540688400,7),(389,1553994000,8),(389,1572138000,7),(389,1585443600,8),(389,1603587600,7),(389,1616893200,8),(389,1635642000,7),(389,1648342800,8),(389,1667091600,7),(389,1679792400,8),(389,1698541200,7),(389,1711846800,8),(389,1729990800,7),(389,1743296400,8),(389,1761440400,7),(389,1774746000,8),(389,1792890000,7),(389,1806195600,8),(389,1824944400,7),(389,1837645200,8),(389,1856394000,7),(389,1869094800,8),(389,1887843600,7),(389,1901149200,8),(389,1919293200,7),(389,1932598800,8),(389,1950742800,7),(389,1964048400,8),(389,1982797200,7),(389,1995498000,8),(389,2014246800,7),(389,2026947600,8),(389,2045696400,7),(389,2058397200,8),(389,2077146000,7),(389,2090451600,8),(389,2108595600,7),(389,2121901200,8),(389,2140045200,7),(392,-2147483648,0),(392,2147483647,0),(393,-2147483648,0),(393,2147483647,0),(394,-2147483648,0),(394,2147483647,0),(395,-2147483648,0),(395,2147483647,0),(396,-2147483648,0),(396,2147483647,0),(397,-2147483648,0),(397,2147483647,0),(398,-2147483648,0),(398,2147483647,0),(399,-2147483648,0),(399,2147483647,0),(400,-2147483648,0),(400,2147483647,0),(401,-2147483648,0),(401,2147483647,0),(402,-2147483648,0),(402,2147483647,0),(403,-2147483648,0),(403,2147483647,0),(405,-2147483648,0),(405,2147483647,0),(406,-2147483648,0),(406,2147483647,0),(407,-2147483648,0),(407,2147483647,0),(408,-2147483648,0),(408,2147483647,0),(409,-2147483648,0),(409,2147483647,0),(410,-2147483648,0),(410,2147483647,0),(411,-2147483648,0),(411,2147483647,0),(412,-2147483648,0),(412,2147483647,0),(413,-2147483648,0),(413,2147483647,0),(414,-2147483648,0),(414,2147483647,0),(415,-2147483648,0),(415,2147483647,0),(416,-2147483648,0),(416,2147483647,0),(417,-2147483648,0),(417,2147483647,0),(418,-2147483648,0),(418,2147483647,0),(425,-2147483648,2),(425,-1693700372,1),(425,-1680484772,2),(425,-1663453172,3),(425,-1650147572,4),(425,-1633213172,3),(425,-1617488372,4),(425,-1601158772,3),(425,-1586038772,4),(425,-1569709172,3),(425,-1554589172,4),(425,-1538259572,3),(425,-1523139572,4),(425,-1507501172,3),(425,-1490566772,4),(425,-1470176372,3),(425,-1459117172,4),(425,-1443997172,3),(425,-1427667572,4),(425,-1406672372,3),(425,-1396217972,4),(425,-1376950772,3),(425,-1364768372,4),(425,-1345414772,3),(425,-1333318772,4),(425,-1313792372,3),(425,-1301264372,4),(425,-1282256372,3),(425,-1269814772,4),(425,-1250720372,3),(425,-1238365172,4),(425,-1219184372,3),(425,-1206915572,4),(425,-1186957172,3),(425,-1175465972,4),(425,-1156025972,3),(425,-1143411572,4),(425,-1124489972,3),(425,-1111961972,4),(425,-1092953972,3),(425,-1080512372,4),(425,-1061331572,3),(425,-1049062772,4),(425,-1029190772,3),(425,-1025745572,7),(425,-1017613200,5),(425,-998259600,6),(425,-986163600,5),(425,-966723600,6),(425,-954109200,5),(425,-935022000,10),(425,-857257200,8),(425,-844556400,9),(425,-828226800,8),(425,-812502000,9),(425,-796777200,8),(425,-781052400,9),(425,-766623600,8),(425,220921200,13),(425,228877200,11),(425,243997200,12),(425,260326800,11),(425,276051600,12),(425,291776400,11),(425,307501200,12),(425,323830800,11),(425,338950800,12),(425,354675600,11),(425,370400400,12),(425,386125200,11),(425,401850000,12),(425,417574800,11),(425,433299600,12),(425,449024400,11),(425,465354000,12),(425,481078800,11),(425,496803600,12),(425,512528400,11),(425,528253200,12),(425,543978000,11),(425,559702800,12),(425,575427600,11),(425,591152400,12),(425,606877200,11),(425,622602000,12),(425,638326800,11),(425,654656400,12),(425,670381200,11),(425,686106000,12),(425,701830800,11),(425,717555600,12),(425,733280400,11),(425,749005200,12),(425,764730000,11),(425,780454800,12),(425,796179600,11),(425,811904400,12),(425,828234000,11),(425,846378000,12),(425,859683600,11),(425,877827600,12),(425,891133200,11),(425,909277200,12),(425,922582800,11),(425,941331600,12),(425,954032400,11),(425,972781200,12),(425,985482000,11),(425,1004230800,12),(425,1017536400,11),(425,1035680400,12),(425,1048986000,11),(425,1067130000,12),(425,1080435600,11),(425,1099184400,12),(425,1111885200,11),(425,1130634000,12),(425,1143334800,11),(425,1162083600,12),(425,1174784400,11),(425,1193533200,12),(425,1206838800,11),(425,1224982800,12),(425,1238288400,11),(425,1256432400,12),(425,1269738000,11),(425,1288486800,12),(425,1301187600,11),(425,1319936400,12),(425,1332637200,11),(425,1351386000,12),(425,1364691600,11),(425,1382835600,12),(425,1396141200,11),(425,1414285200,12),(425,1427590800,11),(425,1445734800,12),(425,1459040400,11),(425,1477789200,12),(425,1490490000,11),(425,1509238800,12),(425,1521939600,11),(425,1540688400,12),(425,1553994000,11),(425,1572138000,12),(425,1585443600,11),(425,1603587600,12),(425,1616893200,11),(425,1635642000,12),(425,1648342800,11),(425,1667091600,12),(425,1679792400,11),(425,1698541200,12),(425,1711846800,11),(425,1729990800,12),(425,1743296400,11),(425,1761440400,12),(425,1774746000,11),(425,1792890000,12),(425,1806195600,11),(425,1824944400,12),(425,1837645200,11),(425,1856394000,12),(425,1869094800,11),(425,1887843600,12),(425,1901149200,11),(425,1919293200,12),(425,1932598800,11),(425,1950742800,12),(425,1964048400,11),(425,1982797200,12),(425,1995498000,11),(425,2014246800,12),(425,2026947600,11),(425,2045696400,12),(425,2058397200,11),(425,2077146000,12),(425,2090451600,11),(425,2108595600,12),(425,2121901200,11),(425,2140045200,12),(426,-2147483648,1),(426,-733881600,2),(426,481078800,3),(426,496803600,4),(426,512528400,3),(426,528253200,4),(426,543978000,3),(426,559702800,4),(426,575427600,3),(426,591152400,4),(426,606877200,3),(426,622602000,4),(426,638326800,3),(426,654656400,4),(426,670381200,3),(426,686106000,4),(426,701830800,3),(426,717555600,4),(426,733280400,3),(426,749005200,4),(426,764730000,3),(426,780454800,4),(426,796179600,3),(426,811904400,4),(426,828234000,3),(426,846378000,4),(426,859683600,3),(426,877827600,4),(426,891133200,3),(426,909277200,4),(426,922582800,3),(426,941331600,4),(426,954032400,3),(426,972781200,4),(426,985482000,3),(426,1004230800,4),(426,1017536400,3),(426,1035680400,4),(426,1048986000,3),(426,1067130000,4),(426,1080435600,3),(426,1099184400,4),(426,1111885200,3),(426,1130634000,4),(426,1143334800,3),(426,1162083600,4),(426,1174784400,3),(426,1193533200,4),(426,1206838800,3),(426,1224982800,4),(426,1238288400,3),(426,1256432400,4),(426,1269738000,3),(426,1288486800,4),(426,1301187600,3),(426,1319936400,4),(426,1332637200,3),(426,1351386000,4),(426,1364691600,3),(426,1382835600,4),(426,1396141200,3),(426,1414285200,4),(426,1427590800,3),(426,1445734800,4),(426,1459040400,3),(426,1477789200,4),(426,1490490000,3),(426,1509238800,4),(426,1521939600,3),(426,1540688400,4),(426,1553994000,3),(426,1572138000,4),(426,1585443600,3),(426,1603587600,4),(426,1616893200,3),(426,1635642000,4),(426,1648342800,3),(426,1667091600,4),(426,1679792400,3),(426,1698541200,4),(426,1711846800,3),(426,1729990800,4),(426,1743296400,3),(426,1761440400,4),(426,1774746000,3),(426,1792890000,4),(426,1806195600,3),(426,1824944400,4),(426,1837645200,3),(426,1856394000,4),(426,1869094800,3),(426,1887843600,4),(426,1901149200,3),(426,1919293200,4),(426,1932598800,3),(426,1950742800,4),(426,1964048400,3),(426,1982797200,4),(426,1995498000,3),(426,2014246800,4),(426,2026947600,3),(426,2045696400,4),(426,2058397200,3),(426,2077146000,4),(426,2090451600,3),(426,2108595600,4),(426,2121901200,3),(426,2140045200,4),(427,-2147483648,0),(427,-1441249932,1),(427,-1247540400,3),(427,354916800,2),(427,370724400,3),(427,386452800,2),(427,402260400,3),(427,417988800,2),(427,433796400,3),(427,449611200,2),(427,465343200,4),(427,481068000,5),(427,496792800,4),(427,512517600,5),(427,528242400,4),(427,543967200,5),(427,559692000,4),(427,575416800,5),(427,591141600,4),(427,606866400,6),(427,622594800,7),(427,638319600,6),(427,654649200,7),(427,670374000,4),(427,701820000,6),(427,717548400,7),(427,733273200,6),(427,748998000,7),(427,764722800,6),(427,780447600,7),(427,796172400,6),(427,811897200,7),(427,828226800,6),(427,846370800,7),(427,859676400,6),(427,877820400,7),(427,891126000,6),(427,909270000,7),(427,922575600,6),(427,941324400,7),(427,954025200,6),(427,972774000,7),(427,985474800,6),(427,1004223600,7),(427,1017529200,6),(427,1035673200,7),(427,1048978800,6),(427,1067122800,7),(427,1080428400,6),(427,1099177200,7),(427,1111878000,6),(427,1130626800,7),(427,1143327600,6),(427,1162076400,7),(427,1174777200,6),(427,1193526000,7),(427,1206831600,6),(427,1224975600,7),(427,1238281200,6),(427,1256425200,7),(427,1269730800,6),(427,1288479600,7),(427,1301180400,4),(427,1414274400,7),(427,1459033200,4),(427,2147483647,4),(428,-2147483648,1),(428,-1686101632,3),(428,-1182996000,2),(428,-1178161200,3),(428,-906861600,2),(428,-904878000,5),(428,-857257200,4),(428,-844477200,5),(428,-828237600,4),(428,-812422800,3),(428,-552362400,2),(428,-541652400,3),(428,166485600,6),(428,186184800,7),(428,198028800,6),(428,213753600,7),(428,228873600,6),(428,244080000,7),(428,260323200,6),(428,275446800,3),(428,291798000,2),(428,307407600,3),(428,323388000,2),(428,338936400,3),(428,354675600,8),(428,370400400,9),(428,386125200,8),(428,401850000,9),(428,417574800,8),(428,433299600,9),(428,449024400,8),(428,465354000,9),(428,481078800,8),(428,496803600,9),(428,512528400,8),(428,528253200,9),(428,543978000,8),(428,559702800,9),(428,575427600,8),(428,591152400,9),(428,606877200,8),(428,622602000,9),(428,638326800,8),(428,654656400,9),(428,670381200,8),(428,686106000,9),(428,701830800,8),(428,717555600,9),(428,733280400,8),(428,749005200,9),(428,764730000,8),(428,780454800,9),(428,796179600,8),(428,811904400,9),(428,828234000,8),(428,846378000,9),(428,859683600,8),(428,877827600,9),(428,891133200,8),(428,909277200,9),(428,922582800,8),(428,941331600,9),(428,954032400,8),(428,972781200,9),(428,985482000,8),(428,1004230800,9),(428,1017536400,8),(428,1035680400,9),(428,1048986000,8),(428,1067130000,9),(428,1080435600,8),(428,1099184400,9),(428,1111885200,8),(428,1130634000,9),(428,1143334800,8),(428,1162083600,9),(428,1174784400,8),(428,1193533200,9),(428,1206838800,8),(428,1224982800,9),(428,1238288400,8),(428,1256432400,9),(428,1269738000,8),(428,1288486800,9),(428,1301187600,8),(428,1319936400,9),(428,1332637200,8),(428,1351386000,9),(428,1364691600,8),(428,1382835600,9),(428,1396141200,8),(428,1414285200,9),(428,1427590800,8),(428,1445734800,9),(428,1459040400,8),(428,1477789200,9),(428,1490490000,8),(428,1509238800,9),(428,1521939600,8),(428,1540688400,9),(428,1553994000,8),(428,1572138000,9),(428,1585443600,8),(428,1603587600,9),(428,1616893200,8),(428,1635642000,9),(428,1648342800,8),(428,1667091600,9),(428,1679792400,8),(428,1698541200,9),(428,1711846800,8),(428,1729990800,9),(428,1743296400,8),(428,1761440400,9),(428,1774746000,8),(428,1792890000,9),(428,1806195600,8),(428,1824944400,9),(428,1837645200,8),(428,1856394000,9),(428,1869094800,8),(428,1887843600,9),(428,1901149200,8),(428,1919293200,9),(428,1932598800,8),(428,1950742800,9),(428,1964048400,8),(428,1982797200,9),(428,1995498000,8),(428,2014246800,9),(428,2026947600,8),(428,2045696400,9),(428,2058397200,8),(428,2077146000,9),(428,2090451600,8),(428,2108595600,9),(428,2121901200,8),(428,2140045200,9),(429,-2147483648,2),(429,-1691964000,1),(429,-1680472800,2),(429,-1664143200,1),(429,-1650146400,2),(429,-1633903200,1),(429,-1617487200,2),(429,-1601848800,1),(429,-1586037600,2),(429,-1570399200,1),(429,-1552168800,2),(429,-1538344800,1),(429,-1522533600,2),(429,-1507500000,1),(429,-1490565600,2),(429,-1473631200,1),(429,-1460930400,2),(429,-1442786400,1),(429,-1428876000,2),(429,-1410732000,1),(429,-1396216800,2),(429,-1379282400,1),(429,-1364767200,2),(429,-1348437600,1),(429,-1333317600,2),(429,-1315778400,1),(429,-1301263200,2),(429,-1284328800,1),(429,-1269813600,2),(429,-1253484000,1),(429,-1238364000,2),(429,-1221429600,1),(429,-1206914400,2),(429,-1189980000,1),(429,-1175464800,2),(429,-1159135200,1),(429,-1143410400,2),(429,-1126476000,1),(429,-1111960800,2),(429,-1095631200,1),(429,-1080511200,2),(429,-1063576800,1),(429,-1049061600,2),(429,-1032127200,1),(429,-1017612000,2),(429,-1001282400,1),(429,-986162400,2),(429,-969228000,1),(429,-950479200,2),(429,-942012000,1),(429,-904518000,3),(429,-896050800,1),(429,-875487600,3),(429,-864601200,1),(429,-844038000,3),(429,-832546800,1),(429,-812588400,3),(429,-798073200,1),(429,-781052400,3),(429,-772066800,1),(429,-764805600,2),(429,-748476000,1),(429,-733356000,2),(429,-719445600,1),(429,-717030000,3),(429,-706748400,1),(429,-699487200,2),(429,-687996000,1),(429,-668037600,2),(429,-654732000,1),(429,-636588000,2),(429,-622072800,1),(429,-605743200,2),(429,-590623200,1),(429,-574293600,2),(429,-558568800,1),(429,-542239200,2),(429,-527119200,1),(429,-512604000,2),(429,-496274400,1),(429,-481154400,2),(429,-464220000,1),(429,-449704800,2),(429,-432165600,1),(429,-417650400,2),(429,-401320800,1),(429,-386200800,2),(429,-369266400,1),(429,-354751200,2),(429,-337816800,1),(429,-323301600,2),(429,-306972000,1),(429,-291852000,2),(429,-276732000,1),(429,-257983200,2),(429,-245282400,1),(429,-226533600,2),(429,-213228000,1),(429,-195084000,2),(429,-182383200,1),(429,-163634400,2),(429,-150933600,1),(429,-132184800,2),(429,-119484000,1),(429,-100735200,2),(429,-88034400,1),(429,-68680800,2),(429,-59004000,1),(429,-37242000,4),(429,57722400,6),(429,69818400,1),(429,89172000,2),(429,101268000,1),(429,120621600,2),(429,132717600,1),(429,152071200,2),(429,164167200,1),(429,183520800,2),(429,196221600,1),(429,214970400,2),(429,227671200,1),(429,246420000,2),(429,259120800,1),(429,278474400,2),(429,290570400,1),(429,309924000,2),(429,322020000,1),(429,341373600,2),(429,354675600,5),(429,372819600,6),(429,386125200,5),(429,404269200,6),(429,417574800,5),(429,435718800,6),(429,449024400,5),(429,467773200,6),(429,481078800,5),(429,499222800,6),(429,512528400,5),(429,530672400,6),(429,543978000,5),(429,562122000,6),(429,575427600,5),(429,593571600,6),(429,606877200,5),(429,625626000,6),(429,638326800,5),(429,657075600,6),(429,670381200,5),(429,688525200,6),(429,701830800,5),(429,719974800,6),(429,733280400,5),(429,751424400,6),(429,764730000,5),(429,782874000,6),(429,796179600,5),(429,814323600,6),(429,820454400,7),(429,828234000,5),(429,846378000,6),(429,859683600,5),(429,877827600,6),(429,891133200,5),(429,909277200,6),(429,922582800,5),(429,941331600,6),(429,954032400,5),(429,972781200,6),(429,985482000,5),(429,1004230800,6),(429,1017536400,5),(429,1035680400,6),(429,1048986000,5),(429,1067130000,6),(429,1080435600,5),(429,1099184400,6),(429,1111885200,5),(429,1130634000,6),(429,1143334800,5),(429,1162083600,6),(429,1174784400,5),(429,1193533200,6),(429,1206838800,5),(429,1224982800,6),(429,1238288400,5),(429,1256432400,6),(429,1269738000,5),(429,1288486800,6),(429,1301187600,5),(429,1319936400,6),(429,1332637200,5),(429,1351386000,6),(429,1364691600,5),(429,1382835600,6),(429,1396141200,5),(429,1414285200,6),(429,1427590800,5),(429,1445734800,6),(429,1459040400,5),(429,1477789200,6),(429,1490490000,5),(429,1509238800,6),(429,1521939600,5),(429,1540688400,6),(429,1553994000,5),(429,1572138000,6),(429,1585443600,5),(429,1603587600,6),(429,1616893200,5),(429,1635642000,6),(429,1648342800,5),(429,1667091600,6),(429,1679792400,5),(429,1698541200,6),(429,1711846800,5),(429,1729990800,6),(429,1743296400,5),(429,1761440400,6),(429,1774746000,5),(429,1792890000,6),(429,1806195600,5),(429,1824944400,6),(429,1837645200,5),(429,1856394000,6),(429,1869094800,5),(429,1887843600,6),(429,1901149200,5),(429,1919293200,6),(429,1932598800,5),(429,1950742800,6),(429,1964048400,5),(429,1982797200,6),(429,1995498000,5),(429,2014246800,6),(429,2026947600,5),(429,2045696400,6),(429,2058397200,5),(429,2077146000,6),(429,2090451600,5),(429,2108595600,6),(429,2121901200,5),(429,2140045200,6),(430,-2147483648,1),(430,-905824800,4),(430,-857257200,2),(430,-844556400,3),(430,-828226800,2),(430,-812502000,3),(430,-796777200,2),(430,-788922000,1),(430,-777942000,3),(430,-766623600,2),(430,407199600,1),(430,417574800,5),(430,433299600,6),(430,449024400,5),(430,465354000,6),(430,481078800,5),(430,496803600,6),(430,512528400,5),(430,528253200,6),(430,543978000,5),(430,559702800,6),(430,575427600,5),(430,591152400,6),(430,606877200,5),(430,622602000,6),(430,638326800,5),(430,654656400,6),(430,670381200,5),(430,686106000,6),(430,701830800,5),(430,717555600,6),(430,733280400,5),(430,749005200,6),(430,764730000,5),(430,780454800,6),(430,796179600,5),(430,811904400,6),(430,828234000,5),(430,846378000,6),(430,859683600,5),(430,877827600,6),(430,891133200,5),(430,909277200,6),(430,922582800,5),(430,941331600,6),(430,954032400,5),(430,972781200,6),(430,985482000,5),(430,1004230800,6),(430,1017536400,5),(430,1035680400,6),(430,1048986000,5),(430,1067130000,6),(430,1080435600,5),(430,1099184400,6),(430,1111885200,5),(430,1130634000,6),(430,1143334800,5),(430,1162083600,6),(430,1174784400,5),(430,1193533200,6),(430,1206838800,5),(430,1224982800,6),(430,1238288400,5),(430,1256432400,6),(430,1269738000,5),(430,1288486800,6),(430,1301187600,5),(430,1319936400,6),(430,1332637200,5),(430,1351386000,6),(430,1364691600,5),(430,1382835600,6),(430,1396141200,5),(430,1414285200,6),(430,1427590800,5),(430,1445734800,6),(430,1459040400,5),(430,1477789200,6),(430,1490490000,5),(430,1509238800,6),(430,1521939600,5),(430,1540688400,6),(430,1553994000,5),(430,1572138000,6),(430,1585443600,5),(430,1603587600,6),(430,1616893200,5),(430,1635642000,6),(430,1648342800,5),(430,1667091600,6),(430,1679792400,5),(430,1698541200,6),(430,1711846800,5),(430,1729990800,6),(430,1743296400,5),(430,1761440400,6),(430,1774746000,5),(430,1792890000,6),(430,1806195600,5),(430,1824944400,6),(430,1837645200,5),(430,1856394000,6),(430,1869094800,5),(430,1887843600,6),(430,1901149200,5),(430,1919293200,6),(430,1932598800,5),(430,1950742800,6),(430,1964048400,5),(430,1982797200,6),(430,1995498000,5),(430,2014246800,6),(430,2026947600,5),(430,2045696400,6),(430,2058397200,5),(430,2077146000,6),(430,2090451600,5),(430,2108595600,6),(430,2121901200,5),(430,2140045200,6),(431,-2147483648,2),(431,-1693706400,1),(431,-1680483600,2),(431,-1663455600,3),(431,-1650150000,4),(431,-1632006000,3),(431,-1618700400,4),(431,-938905200,3),(431,-857257200,4),(431,-844556400,3),(431,-828226800,4),(431,-812502000,3),(431,-796777200,4),(431,-781052400,3),(431,-776563200,5),(431,-765936000,1),(431,-761180400,4),(431,-757386000,2),(431,-748479600,3),(431,-733273200,4),(431,-717631200,3),(431,-714610800,6),(431,-710380800,1),(431,-701910000,4),(431,-684975600,3),(431,-670460400,4),(431,-654130800,3),(431,-639010800,4),(431,315529200,2),(431,323830800,7),(431,338950800,8),(431,354675600,7),(431,370400400,8),(431,386125200,7),(431,401850000,8),(431,417574800,7),(431,433299600,8),(431,449024400,7),(431,465354000,8),(431,481078800,7),(431,496803600,8),(431,512528400,7),(431,528253200,8),(431,543978000,7),(431,559702800,8),(431,575427600,7),(431,591152400,8),(431,606877200,7),(431,622602000,8),(431,638326800,7),(431,654656400,8),(431,670381200,7),(431,686106000,8),(431,701830800,7),(431,717555600,8),(431,733280400,7),(431,749005200,8),(431,764730000,7),(431,780454800,8),(431,796179600,7),(431,811904400,8),(431,828234000,7),(431,846378000,8),(431,859683600,7),(431,877827600,8),(431,891133200,7),(431,909277200,8),(431,922582800,7),(431,941331600,8),(431,954032400,7),(431,972781200,8),(431,985482000,7),(431,1004230800,8),(431,1017536400,7),(431,1035680400,8),(431,1048986000,7),(431,1067130000,8),(431,1080435600,7),(431,1099184400,8),(431,1111885200,7),(431,1130634000,8),(431,1143334800,7),(431,1162083600,8),(431,1174784400,7),(431,1193533200,8),(431,1206838800,7),(431,1224982800,8),(431,1238288400,7),(431,1256432400,8),(431,1269738000,7),(431,1288486800,8),(431,1301187600,7),(431,1319936400,8),(431,1332637200,7),(431,1351386000,8),(431,1364691600,7),(431,1382835600,8),(431,1396141200,7),(431,1414285200,8),(431,1427590800,7),(431,1445734800,8),(431,1459040400,7),(431,1477789200,8),(431,1490490000,7),(431,1509238800,8),(431,1521939600,7),(431,1540688400,8),(431,1553994000,7),(431,1572138000,8),(431,1585443600,7),(431,1603587600,8),(431,1616893200,7),(431,1635642000,8),(431,1648342800,7),(431,1667091600,8),(431,1679792400,7),(431,1698541200,8),(431,1711846800,7),(431,1729990800,8),(431,1743296400,7),(431,1761440400,8),(431,1774746000,7),(431,1792890000,8),(431,1806195600,7),(431,1824944400,8),(431,1837645200,7),(431,1856394000,8),(431,1869094800,7),(431,1887843600,8),(431,1901149200,7),(431,1919293200,8),(431,1932598800,7),(431,1950742800,8),(431,1964048400,7),(431,1982797200,8),(431,1995498000,7),(431,2014246800,8),(431,2026947600,7),(431,2045696400,8),(431,2058397200,7),(431,2077146000,8),(431,2090451600,7),(431,2108595600,8),(431,2121901200,7),(431,2140045200,8),(432,-2147483648,2),(432,-1693706400,1),(432,-1680483600,2),(432,-1663455600,3),(432,-1650150000,4),(432,-1632006000,3),(432,-1618700400,4),(432,-938905200,3),(432,-857257200,4),(432,-844556400,3),(432,-828226800,4),(432,-812502000,3),(432,-796777200,4),(432,-781052400,3),(432,-777866400,1),(432,-765327600,4),(432,-746578800,3),(432,-733359600,4),(432,-728517600,5),(432,-721260000,2),(432,-716425200,3),(432,-701910000,4),(432,-684975600,3),(432,-670460400,4),(432,-654217200,3),(432,-639010800,4),(432,283993200,2),(432,291776400,6),(432,307501200,7),(432,323830800,6),(432,338950800,7),(432,354675600,6),(432,370400400,7),(432,386125200,6),(432,401850000,7),(432,417574800,6),(432,433299600,7),(432,449024400,6),(432,465354000,7),(432,481078800,6),(432,496803600,7),(432,512528400,6),(432,528253200,7),(432,543978000,6),(432,559702800,7),(432,575427600,6),(432,591152400,7),(432,606877200,6),(432,622602000,7),(432,638326800,6),(432,654656400,7),(432,670381200,6),(432,686106000,7),(432,701830800,6),(432,717555600,7),(432,733280400,6),(432,749005200,7),(432,764730000,6),(432,780454800,7),(432,796179600,6),(432,811904400,7),(432,828234000,6),(432,846378000,7),(432,859683600,6),(432,877827600,7),(432,891133200,6),(432,909277200,7),(432,922582800,6),(432,941331600,7),(432,954032400,6),(432,972781200,7),(432,985482000,6),(432,1004230800,7),(432,1017536400,6),(432,1035680400,7),(432,1048986000,6),(432,1067130000,7),(432,1080435600,6),(432,1099184400,7),(432,1111885200,6),(432,1130634000,7),(432,1143334800,6),(432,1162083600,7),(432,1174784400,6),(432,1193533200,7),(432,1206838800,6),(432,1224982800,7),(432,1238288400,6),(432,1256432400,7),(432,1269738000,6),(432,1288486800,7),(432,1301187600,6),(432,1319936400,7),(432,1332637200,6),(432,1351386000,7),(432,1364691600,6),(432,1382835600,7),(432,1396141200,6),(432,1414285200,7),(432,1427590800,6),(432,1445734800,7),(432,1459040400,6),(432,1477789200,7),(432,1490490000,6),(432,1509238800,7),(432,1521939600,6),(432,1540688400,7),(432,1553994000,6),(432,1572138000,7),(432,1585443600,6),(432,1603587600,7),(432,1616893200,6),(432,1635642000,7),(432,1648342800,6),(432,1667091600,7),(432,1679792400,6),(432,1698541200,7),(432,1711846800,6),(432,1729990800,7),(432,1743296400,6),(432,1761440400,7),(432,1774746000,6),(432,1792890000,7),(432,1806195600,6),(432,1824944400,7),(432,1837645200,6),(432,1856394000,7),(432,1869094800,6),(432,1887843600,7),(432,1901149200,6),(432,1919293200,7),(432,1932598800,6),(432,1950742800,7),(432,1964048400,6),(432,1982797200,7),(432,1995498000,6),(432,2014246800,7),(432,2026947600,6),(432,2045696400,7),(432,2058397200,6),(432,2077146000,7),(432,2090451600,6),(432,2108595600,7),(432,2121901200,6),(432,2140045200,7),(433,-2147483648,1),(433,-1740355200,2),(433,-1693702800,5),(433,-1680483600,2),(433,-1663455600,3),(433,-1650150000,4),(433,-1632006000,3),(433,-1618700400,4),(433,-1613826000,8),(433,-1604278800,6),(433,-1585530000,7),(433,-1574038800,6),(433,-1552266000,7),(433,-1539997200,6),(433,-1520557200,7),(433,-1507510800,6),(433,-1490576400,7),(433,-1473642000,6),(433,-1459126800,7),(433,-1444006800,6),(433,-1427677200,7),(433,-1411952400,6),(433,-1396227600,7),(433,-1379293200,6),(433,-1364778000,7),(433,-1348448400,6),(433,-1333328400,7),(433,-1316394000,6),(433,-1301263200,7),(433,-1284328800,6),(433,-1269813600,7),(433,-1253484000,6),(433,-1238364000,7),(433,-1221429600,6),(433,-1206914400,7),(433,-1191189600,6),(433,-1175464800,7),(433,-1160344800,6),(433,-1143410400,7),(433,-1127685600,6),(433,-1111960800,7),(433,-1096840800,6),(433,-1080511200,7),(433,-1063576800,6),(433,-1049061600,7),(433,-1033336800,6),(433,-1017612000,7),(433,-1002492000,6),(433,-986162400,7),(433,-969228000,6),(433,-950479200,7),(433,-942012000,6),(433,-934668000,3),(433,-857257200,4),(433,-844556400,3),(433,-828226800,4),(433,-812502000,3),(433,-799293600,5),(433,-798073200,4),(433,-781052400,3),(433,-766623600,4),(433,-745455600,3),(433,-733273200,4),(433,220921200,2),(433,228877200,9),(433,243997200,10),(433,260326800,9),(433,276051600,10),(433,291776400,9),(433,307501200,10),(433,323830800,9),(433,338950800,10),(433,354675600,9),(433,370400400,10),(433,386125200,9),(433,401850000,10),(433,417574800,9),(433,433299600,10),(433,449024400,9),(433,465354000,10),(433,481078800,9),(433,496803600,10),(433,512528400,9),(433,528253200,10),(433,543978000,9),(433,559702800,10),(433,575427600,9),(433,591152400,10),(433,606877200,9),(433,622602000,10),(433,638326800,9),(433,654656400,10),(433,670381200,9),(433,686106000,10),(433,701830800,9),(433,717555600,10),(433,733280400,9),(433,749005200,10),(433,764730000,9),(433,780454800,10),(433,796179600,9),(433,811904400,10),(433,828234000,9),(433,846378000,10),(433,859683600,9),(433,877827600,10),(433,891133200,9),(433,909277200,10),(433,922582800,9),(433,941331600,10),(433,954032400,9),(433,972781200,10),(433,985482000,9),(433,1004230800,10),(433,1017536400,9),(433,1035680400,10),(433,1048986000,9),(433,1067130000,10),(433,1080435600,9),(433,1099184400,10),(433,1111885200,9),(433,1130634000,10),(433,1143334800,9),(433,1162083600,10),(433,1174784400,9),(433,1193533200,10),(433,1206838800,9),(433,1224982800,10),(433,1238288400,9),(433,1256432400,10),(433,1269738000,9),(433,1288486800,10),(433,1301187600,9),(433,1319936400,10),(433,1332637200,9),(433,1351386000,10),(433,1364691600,9),(433,1382835600,10),(433,1396141200,9),(433,1414285200,10),(433,1427590800,9),(433,1445734800,10),(433,1459040400,9),(433,1477789200,10),(433,1490490000,9),(433,1509238800,10),(433,1521939600,9),(433,1540688400,10),(433,1553994000,9),(433,1572138000,10),(433,1585443600,9),(433,1603587600,10),(433,1616893200,9),(433,1635642000,10),(433,1648342800,9),(433,1667091600,10),(433,1679792400,9),(433,1698541200,10),(433,1711846800,9),(433,1729990800,10),(433,1743296400,9),(433,1761440400,10),(433,1774746000,9),(433,1792890000,10),(433,1806195600,9),(433,1824944400,10),(433,1837645200,9),(433,1856394000,10),(433,1869094800,9),(433,1887843600,10),(433,1901149200,9),(433,1919293200,10),(433,1932598800,9),(433,1950742800,10),(433,1964048400,9),(433,1982797200,10),(433,1995498000,9),(433,2014246800,10),(433,2026947600,9),(433,2045696400,10),(433,2058397200,9),(433,2077146000,10),(433,2090451600,9),(433,2108595600,10),(433,2121901200,9),(433,2140045200,10),(434,-2147483648,1),(434,-1213148664,5),(434,-1187056800,2),(434,-1175479200,3),(434,-1159754400,2),(434,-1144029600,3),(434,-1127700000,2),(434,-1111975200,3),(434,-1096250400,2),(434,-1080525600,3),(434,-1064800800,2),(434,-1049076000,3),(434,-1033351200,2),(434,-1017626400,3),(434,-1001901600,2),(434,-986176800,3),(434,-970452000,2),(434,-954727200,3),(434,296604000,4),(434,307486800,5),(434,323816400,4),(434,338940000,5),(434,354672000,2),(434,370396800,3),(434,386121600,2),(434,401846400,3),(434,417571200,2),(434,433296000,3),(434,449020800,2),(434,465350400,3),(434,481075200,2),(434,496800000,3),(434,512524800,2),(434,528249600,3),(434,543974400,2),(434,559699200,3),(434,575424000,2),(434,591148800,3),(434,606873600,2),(434,622598400,3),(434,638323200,2),(434,654652800,3),(434,662680800,5),(434,670370400,2),(434,686095200,3),(434,701820000,2),(434,717544800,3),(434,733269600,2),(434,748994400,3),(434,757375200,5),(434,764719200,4),(434,780440400,5),(434,796168800,4),(434,811890000,5),(434,828223200,4),(434,846363600,5),(434,859683600,6),(434,877827600,7),(434,891133200,6),(434,909277200,7),(434,922582800,6),(434,941331600,7),(434,954032400,6),(434,972781200,7),(434,985482000,6),(434,1004230800,7),(434,1017536400,6),(434,1035680400,7),(434,1048986000,6),(434,1067130000,7),(434,1080435600,6),(434,1099184400,7),(434,1111885200,6),(434,1130634000,7),(434,1143334800,6),(434,1162083600,7),(434,1174784400,6),(434,1193533200,7),(434,1206838800,6),(434,1224982800,7),(434,1238288400,6),(434,1256432400,7),(434,1269738000,6),(434,1288486800,7),(434,1301187600,6),(434,1319936400,7),(434,1332637200,6),(434,1351386000,7),(434,1364691600,6),(434,1382835600,7),(434,1396141200,6),(434,1414285200,7),(434,1427590800,6),(434,1445734800,7),(434,1459040400,6),(434,1477789200,7),(434,1490490000,6),(434,1509238800,7),(434,1521939600,6),(434,1540688400,7),(434,1553994000,6),(434,1572138000,7),(434,1585443600,6),(434,1603587600,7),(434,1616893200,6),(434,1635642000,7),(434,1648342800,6),(434,1667091600,7),(434,1679792400,6),(434,1698541200,7),(434,1711846800,6),(434,1729990800,7),(434,1743296400,6),(434,1761440400,7),(434,1774746000,6),(434,1792890000,7),(434,1806195600,6),(434,1824944400,7),(434,1837645200,6),(434,1856394000,7),(434,1869094800,6),(434,1887843600,7),(434,1901149200,6),(434,1919293200,7),(434,1932598800,6),(434,1950742800,7),(434,1964048400,6),(434,1982797200,7),(434,1995498000,6),(434,2014246800,7),(434,2026947600,6),(434,2045696400,7),(434,2058397200,6),(434,2077146000,7),(434,2090451600,6),(434,2108595600,7),(434,2121901200,6),(434,2140045200,7),(435,-2147483648,2),(435,-1693706400,1),(435,-1680483600,2),(435,-1663455600,3),(435,-1650150000,4),(435,-1640998800,2),(435,-1633212000,1),(435,-1618700400,2),(435,-1600466400,1),(435,-1581202800,2),(435,-906771600,1),(435,-857257200,4),(435,-844556400,3),(435,-828226800,4),(435,-812502000,3),(435,-796777200,4),(435,-788922000,2),(435,-778471200,1),(435,-762660000,2),(435,-749689200,3),(435,-733359600,4),(435,-717634800,3),(435,-701910000,4),(435,-686185200,3),(435,-670460400,4),(435,-654130800,3),(435,-639010800,4),(435,-621990000,3),(435,-605660400,4),(435,-492656400,1),(435,-481168800,2),(435,-461120400,1),(435,-449632800,2),(435,-428547600,1),(435,-418269600,2),(435,-397094400,1),(435,-386809200,2),(435,323827200,1),(435,338950800,5),(435,354675600,6),(435,370400400,5),(435,386125200,6),(435,401850000,5),(435,417574800,6),(435,433299600,5),(435,449024400,6),(435,465354000,5),(435,481078800,6),(435,496803600,5),(435,512528400,6),(435,528253200,5),(435,543978000,6),(435,559702800,5),(435,575427600,6),(435,591152400,5),(435,606877200,6),(435,622602000,5),(435,638326800,6),(435,654656400,5),(435,670381200,6),(435,686106000,5),(435,701830800,6),(435,717555600,5),(435,733280400,6),(435,749005200,5),(435,764730000,6),(435,780454800,5),(435,796179600,6),(435,811904400,5),(435,828234000,6),(435,846378000,5),(435,859683600,6),(435,877827600,5),(435,891133200,6),(435,909277200,5),(435,922582800,6),(435,941331600,5),(435,954032400,6),(435,972781200,5),(435,985482000,6),(435,1004230800,5),(435,1017536400,6),(435,1035680400,5),(435,1048986000,6),(435,1067130000,5),(435,1080435600,6),(435,1099184400,5),(435,1111885200,6),(435,1130634000,5),(435,1143334800,6),(435,1162083600,5),(435,1174784400,6),(435,1193533200,5),(435,1206838800,6),(435,1224982800,5),(435,1238288400,6),(435,1256432400,5),(435,1269738000,6),(435,1288486800,5),(435,1301187600,6),(435,1319936400,5),(435,1332637200,6),(435,1351386000,5),(435,1364691600,6),(435,1382835600,5),(435,1396141200,6),(435,1414285200,5),(435,1427590800,6),(435,1445734800,5),(435,1459040400,6),(435,1477789200,5),(435,1490490000,6),(435,1509238800,5),(435,1521939600,6),(435,1540688400,5),(435,1553994000,6),(435,1572138000,5),(435,1585443600,6),(435,1603587600,5),(435,1616893200,6),(435,1635642000,5),(435,1648342800,6),(435,1667091600,5),(435,1679792400,6),(435,1698541200,5),(435,1711846800,6),(435,1729990800,5),(435,1743296400,6),(435,1761440400,5),(435,1774746000,6),(435,1792890000,5),(435,1806195600,6),(435,1824944400,5),(435,1837645200,6),(435,1856394000,5),(435,1869094800,6),(435,1887843600,5),(435,1901149200,6),(435,1919293200,5),(435,1932598800,6),(435,1950742800,5),(435,1964048400,6),(435,1982797200,5),(435,1995498000,6),(435,2014246800,5),(435,2026947600,6),(435,2045696400,5),(435,2058397200,6),(435,2077146000,5),(435,2090451600,6),(435,2108595600,5),(435,2121901200,6),(435,2140045200,5),(436,-2147483648,2),(436,-904435200,1),(436,-891129600,2),(436,-872985600,1),(436,-859680000,2),(436,354675600,3),(436,370400400,4),(436,386125200,3),(436,401850000,4),(436,417574800,3),(436,433299600,4),(436,449024400,3),(436,465354000,4),(436,481078800,3),(436,496803600,4),(436,512528400,3),(436,528253200,4),(436,543978000,3),(436,559702800,4),(436,575427600,3),(436,591152400,4),(436,606877200,3),(436,622602000,4),(436,638326800,3),(436,654656400,4),(436,670381200,3),(436,686106000,4),(436,701830800,3),(436,717555600,4),(436,733280400,3),(436,749005200,4),(436,764730000,3),(436,780454800,4),(436,796179600,3),(436,811904400,4),(436,828234000,3),(436,846378000,4),(436,859683600,3),(436,877827600,4),(436,891133200,3),(436,909277200,4),(436,922582800,3),(436,941331600,4),(436,954032400,3),(436,972781200,4),(436,985482000,3),(436,1004230800,4),(436,1017536400,3),(436,1035680400,4),(436,1048986000,3),(436,1067130000,4),(436,1080435600,3),(436,1099184400,4),(436,1111885200,3),(436,1130634000,4),(436,1143334800,3),(436,1162083600,4),(436,1174784400,3),(436,1193533200,4),(436,1206838800,3),(436,1224982800,4),(436,1238288400,3),(436,1256432400,4),(436,1269738000,3),(436,1288486800,4),(436,1301187600,3),(436,1319936400,4),(436,1332637200,3),(436,1351386000,4),(436,1364691600,3),(436,1382835600,4),(436,1396141200,3),(436,1414285200,4),(436,1427590800,3),(436,1445734800,4),(436,1459040400,3),(436,1477789200,4),(436,1490490000,3),(436,1509238800,4),(436,1521939600,3),(436,1540688400,4),(436,1553994000,3),(436,1572138000,4),(436,1585443600,3),(436,1603587600,4),(436,1616893200,3),(436,1635642000,4),(436,1648342800,3),(436,1667091600,4),(436,1679792400,3),(436,1698541200,4),(436,1711846800,3),(436,1729990800,4),(436,1743296400,3),(436,1761440400,4),(436,1774746000,3),(436,1792890000,4),(436,1806195600,3),(436,1824944400,4),(436,1837645200,3),(436,1856394000,4),(436,1869094800,3),(436,1887843600,4),(436,1901149200,3),(436,1919293200,4),(436,1932598800,3),(436,1950742800,4),(436,1964048400,3),(436,1982797200,4),(436,1995498000,3),(436,2014246800,4),(436,2026947600,3),(436,2045696400,4),(436,2058397200,3),(436,2077146000,4),(436,2090451600,3),(436,2108595600,4),(436,2121901200,3),(436,2140045200,4),(437,-2147483648,1),(437,-1637114100,2),(437,-1213148664,5),(437,-1187056800,3),(437,-1175479200,4),(437,-1159754400,3),(437,-1144029600,4),(437,-1127700000,3),(437,-1111975200,4),(437,-1096250400,3),(437,-1080525600,4),(437,-1064800800,3),(437,-1049076000,4),(437,-1033351200,3),(437,-1017626400,4),(437,-1001901600,3),(437,-986176800,4),(437,-970452000,3),(437,-954727200,4),(437,-927165600,6),(437,-898138800,9),(437,-857257200,7),(437,-844556400,8),(437,-828226800,7),(437,-812502000,8),(437,-800157600,11),(437,354920400,10),(437,370728000,11),(437,386456400,10),(437,402264000,11),(437,417992400,10),(437,433800000,11),(437,449614800,10),(437,465346800,12),(437,481071600,13),(437,496796400,12),(437,512521200,13),(437,528246000,12),(437,543970800,13),(437,559695600,12),(437,575420400,13),(437,591145200,12),(437,606870000,13),(437,622594800,12),(437,638319600,13),(437,641944800,6),(437,654652800,4),(437,670377600,3),(437,686102400,4),(437,694216800,5),(437,701820000,6),(437,717541200,5),(437,733269600,6),(437,748990800,5),(437,764719200,6),(437,780440400,5),(437,796168800,6),(437,811890000,5),(437,828223200,6),(437,846363600,5),(437,859680000,6),(437,877824000,5),(437,891129600,6),(437,909273600,5),(437,922579200,6),(437,941328000,5),(437,954028800,6),(437,972777600,5),(437,985478400,6),(437,1004227200,5),(437,1017532800,6),(437,1035676800,5),(437,1048982400,6),(437,1067126400,5),(437,1080432000,6),(437,1099180800,5),(437,1111881600,6),(437,1130630400,5),(437,1143331200,6),(437,1162080000,5),(437,1174780800,6),(437,1193529600,5),(437,1206835200,6),(437,1224979200,5),(437,1238284800,6),(437,1256428800,5),(437,1269734400,6),(437,1288483200,5),(437,1301184000,6),(437,1319932800,5),(437,1332633600,6),(437,1351382400,5),(437,1364688000,6),(437,1382832000,5),(437,1396137600,6),(437,1414281600,5),(437,1427587200,6),(437,1445731200,5),(437,1459036800,6),(437,1477785600,5),(437,1490486400,6),(437,1509235200,5),(437,1521936000,6),(437,1540684800,5),(437,1553990400,6),(437,1572134400,5),(437,1585440000,6),(437,1603584000,5),(437,1616889600,6),(437,1635638400,5),(437,1648339200,6),(437,1667088000,5),(437,1679788800,6),(437,1698537600,5),(437,1711843200,6),(437,1729987200,5),(437,1743292800,6),(437,1761436800,5),(437,1774742400,6),(437,1792886400,5),(437,1806192000,6),(437,1824940800,5),(437,1837641600,6),(437,1856390400,5),(437,1869091200,6),(437,1887840000,5),(437,1901145600,6),(437,1919289600,5),(437,1932595200,6),(437,1950739200,5),(437,1964044800,6),(437,1982793600,5),(437,1995494400,6),(437,2014243200,5),(437,2026944000,6),(437,2045692800,5),(437,2058393600,6),(437,2077142400,5),(437,2090448000,6),(437,2108592000,5),(437,2121897600,6),(437,2140041600,5),(438,-2147483648,2),(438,-1692496800,1),(438,-1680490800,2),(438,-935110800,1),(438,-857257200,3),(438,-844556400,4),(438,-828226800,3),(438,-812502000,4),(438,-796777200,3),(438,-781052400,4),(438,-769388400,3),(438,-747010800,4),(438,-736383600,3),(438,-715215600,4),(438,-706748400,3),(438,-683161200,4),(438,-675298800,3),(438,315529200,2),(438,323830800,5),(438,338950800,6),(438,354675600,5),(438,370400400,6),(438,386125200,5),(438,401850000,6),(438,417574800,5),(438,433299600,6),(438,449024400,5),(438,465354000,6),(438,481078800,5),(438,496803600,6),(438,512528400,5),(438,528253200,6),(438,543978000,5),(438,559702800,6),(438,575427600,5),(438,591152400,6),(438,606877200,5),(438,622602000,6),(438,638326800,5),(438,654656400,6),(438,670381200,5),(438,686106000,6),(438,701830800,5),(438,717555600,6),(438,733280400,5),(438,749005200,6),(438,764730000,5),(438,780454800,6),(438,796179600,5),(438,811904400,6),(438,828234000,5),(438,846378000,6),(438,859683600,5),(438,877827600,6),(438,891133200,5),(438,909277200,6),(438,922582800,5),(438,941331600,6),(438,954032400,5),(438,972781200,6),(438,985482000,5),(438,1004230800,6),(438,1017536400,5),(438,1035680400,6),(438,1048986000,5),(438,1067130000,6),(438,1080435600,5),(438,1099184400,6),(438,1111885200,5),(438,1130634000,6),(438,1143334800,5),(438,1162083600,6),(438,1174784400,5),(438,1193533200,6),(438,1206838800,5),(438,1224982800,6),(438,1238288400,5),(438,1256432400,6),(438,1269738000,5),(438,1288486800,6),(438,1301187600,5),(438,1319936400,6),(438,1332637200,5),(438,1351386000,6),(438,1364691600,5),(438,1382835600,6),(438,1396141200,5),(438,1414285200,6),(438,1427590800,5),(438,1445734800,6),(438,1459040400,5),(438,1477789200,6),(438,1490490000,5),(438,1509238800,6),(438,1521939600,5),(438,1540688400,6),(438,1553994000,5),(438,1572138000,6),(438,1585443600,5),(438,1603587600,6),(438,1616893200,5),(438,1635642000,6),(438,1648342800,5),(438,1667091600,6),(438,1679792400,5),(438,1698541200,6),(438,1711846800,5),(438,1729990800,6),(438,1743296400,5),(438,1761440400,6),(438,1774746000,5),(438,1792890000,6),(438,1806195600,5),(438,1824944400,6),(438,1837645200,5),(438,1856394000,6),(438,1869094800,5),(438,1887843600,6),(438,1901149200,5),(438,1919293200,6),(438,1932598800,5),(438,1950742800,6),(438,1964048400,5),(438,1982797200,6),(438,1995498000,5),(438,2014246800,6),(438,2026947600,5),(438,2045696400,6),(438,2058397200,5),(438,2077146000,6),(438,2090451600,5),(438,2108595600,6),(438,2121901200,5),(438,2140045200,6),(439,-2147483648,1),(439,-1691962479,2),(439,-1680471279,4),(439,-1664143200,3),(439,-1650146400,4),(439,-1633903200,3),(439,-1617487200,4),(439,-1601848800,3),(439,-1586037600,4),(439,-1570399200,3),(439,-1552168800,4),(439,-1538344800,3),(439,-1522533600,4),(439,-1517011200,6),(439,-1507500000,5),(439,-1490565600,4),(439,-1473631200,5),(439,-1460930400,4),(439,-1442786400,5),(439,-1428876000,4),(439,-1410732000,5),(439,-1396216800,4),(439,-1379282400,5),(439,-1364767200,4),(439,-1348437600,5),(439,-1333317600,4),(439,-1315778400,5),(439,-1301263200,4),(439,-1284328800,5),(439,-1269813600,4),(439,-1253484000,5),(439,-1238364000,4),(439,-1221429600,5),(439,-1206914400,4),(439,-1189980000,5),(439,-1175464800,4),(439,-1159135200,5),(439,-1143410400,4),(439,-1126476000,5),(439,-1111960800,4),(439,-1095631200,5),(439,-1080511200,4),(439,-1063576800,5),(439,-1049061600,4),(439,-1032127200,5),(439,-1017612000,4),(439,-1001282400,5),(439,-986162400,4),(439,-969228000,5),(439,-950479200,4),(439,-942012000,5),(439,-733356000,4),(439,-719445600,5),(439,-699487200,4),(439,-684972000,5),(439,-668037600,4),(439,-654732000,5),(439,-636588000,4),(439,-622072800,5),(439,-605743200,4),(439,-590623200,5),(439,-574293600,4),(439,-558568800,5),(439,-542239200,4),(439,-527119200,5),(439,-512604000,4),(439,-496274400,5),(439,-481154400,4),(439,-464220000,5),(439,-449704800,4),(439,-432165600,5),(439,-417650400,4),(439,-401320800,5),(439,-386200800,4),(439,-369266400,5),(439,-354751200,4),(439,-337816800,5),(439,-323301600,4),(439,-306972000,5),(439,-291852000,4),(439,-276732000,5),(439,-257983200,4),(439,-245282400,5),(439,-226533600,4),(439,-213228000,5),(439,-195084000,4),(439,-182383200,5),(439,-163634400,4),(439,-150933600,5),(439,-132184800,4),(439,-119484000,5),(439,-100735200,4),(439,-88034400,5),(439,-68680800,4),(439,-59004000,5),(439,-37242000,9),(439,57722400,7),(439,69818400,8),(439,89172000,7),(439,101268000,8),(439,120621600,7),(439,132717600,8),(439,152071200,7),(439,164167200,8),(439,183520800,7),(439,196221600,8),(439,214970400,7),(439,227671200,8),(439,246420000,7),(439,259120800,8),(439,278474400,7),(439,290570400,8),(439,309924000,7),(439,322020000,8),(439,341373600,7),(439,354675600,8),(439,372819600,7),(439,386125200,8),(439,404269200,7),(439,417574800,8),(439,435718800,7),(439,449024400,8),(439,467773200,7),(439,481078800,8),(439,499222800,7),(439,512528400,8),(439,530672400,7),(439,543978000,8),(439,562122000,7),(439,575427600,8),(439,593571600,7),(439,606877200,8),(439,625626000,7),(439,638326800,8),(439,657075600,7),(439,670381200,8),(439,688525200,7),(439,701830800,8),(439,719974800,7),(439,733280400,8),(439,751424400,7),(439,764730000,8),(439,782874000,7),(439,796179600,8),(439,814323600,7),(439,828234000,8),(439,846378000,7),(439,859683600,8),(439,877827600,7),(439,891133200,8),(439,909277200,7),(439,922582800,8),(439,941331600,7),(439,954032400,8),(439,972781200,7),(439,985482000,8),(439,1004230800,7),(439,1017536400,8),(439,1035680400,7),(439,1048986000,8),(439,1067130000,7),(439,1080435600,8),(439,1099184400,7),(439,1111885200,8),(439,1130634000,7),(439,1143334800,8),(439,1162083600,7),(439,1174784400,8),(439,1193533200,7),(439,1206838800,8),(439,1224982800,7),(439,1238288400,8),(439,1256432400,7),(439,1269738000,8),(439,1288486800,7),(439,1301187600,8),(439,1319936400,7),(439,1332637200,8),(439,1351386000,7),(439,1364691600,8),(439,1382835600,7),(439,1396141200,8),(439,1414285200,7),(439,1427590800,8),(439,1445734800,7),(439,1459040400,8),(439,1477789200,7),(439,1490490000,8),(439,1509238800,7),(439,1521939600,8),(439,1540688400,7),(439,1553994000,8),(439,1572138000,7),(439,1585443600,8),(439,1603587600,7),(439,1616893200,8),(439,1635642000,7),(439,1648342800,8),(439,1667091600,7),(439,1679792400,8),(439,1698541200,7),(439,1711846800,8),(439,1729990800,7),(439,1743296400,8),(439,1761440400,7),(439,1774746000,8),(439,1792890000,7),(439,1806195600,8),(439,1824944400,7),(439,1837645200,8),(439,1856394000,7),(439,1869094800,8),(439,1887843600,7),(439,1901149200,8),(439,1919293200,7),(439,1932598800,8),(439,1950742800,7),(439,1964048400,8),(439,1982797200,7),(439,1995498000,8),(439,2014246800,7),(439,2026947600,8),(439,2045696400,7),(439,2058397200,8),(439,2077146000,7),(439,2090451600,8),(439,2108595600,7),(439,2121901200,8),(439,2140045200,7),(440,-2147483648,2),(440,-1691964000,1),(440,-1680472800,2),(440,-1664143200,1),(440,-1650146400,2),(440,-1633903200,1),(440,-1617487200,2),(440,-1601848800,1),(440,-1586037600,2),(440,-1570399200,1),(440,-1552168800,2),(440,-1538344800,1),(440,-1522533600,2),(440,-1507500000,1),(440,-1490565600,2),(440,-1473631200,1),(440,-1460930400,2),(440,-1442786400,1),(440,-1428876000,2),(440,-1410732000,1),(440,-1396216800,2),(440,-1379282400,1),(440,-1364767200,2),(440,-1348437600,1),(440,-1333317600,2),(440,-1315778400,1),(440,-1301263200,2),(440,-1284328800,1),(440,-1269813600,2),(440,-1253484000,1),(440,-1238364000,2),(440,-1221429600,1),(440,-1206914400,2),(440,-1189980000,1),(440,-1175464800,2),(440,-1159135200,1),(440,-1143410400,2),(440,-1126476000,1),(440,-1111960800,2),(440,-1095631200,1),(440,-1080511200,2),(440,-1063576800,1),(440,-1049061600,2),(440,-1032127200,1),(440,-1017612000,2),(440,-1001282400,1),(440,-986162400,2),(440,-969228000,1),(440,-950479200,2),(440,-942012000,1),(440,-904518000,3),(440,-896050800,1),(440,-875487600,3),(440,-864601200,1),(440,-844038000,3),(440,-832546800,1),(440,-812588400,3),(440,-798073200,1),(440,-781052400,3),(440,-772066800,1),(440,-764805600,2),(440,-748476000,1),(440,-733356000,2),(440,-719445600,1),(440,-717030000,3),(440,-706748400,1),(440,-699487200,2),(440,-687996000,1),(440,-668037600,2),(440,-654732000,1),(440,-636588000,2),(440,-622072800,1),(440,-605743200,2),(440,-590623200,1),(440,-574293600,2),(440,-558568800,1),(440,-542239200,2),(440,-527119200,1),(440,-512604000,2),(440,-496274400,1),(440,-481154400,2),(440,-464220000,1),(440,-449704800,2),(440,-432165600,1),(440,-417650400,2),(440,-401320800,4),(440,386125200,5),(440,401850000,6),(440,417574800,5),(440,433299600,6),(440,449024400,5),(440,465354000,6),(440,481078800,5),(440,496803600,6),(440,512528400,5),(440,528253200,6),(440,543978000,5),(440,559702800,6),(440,575427600,5),(440,591152400,6),(440,606877200,5),(440,622602000,6),(440,638326800,5),(440,654656400,6),(440,670381200,5),(440,686106000,6),(440,701830800,5),(440,717555600,6),(440,733280400,5),(440,749005200,6),(440,764730000,5),(440,780454800,6),(440,796179600,5),(440,811904400,6),(440,828234000,5),(440,846378000,6),(440,859683600,5),(440,877827600,6),(440,891133200,5),(440,909277200,6),(440,922582800,5),(440,941331600,6),(440,954032400,5),(440,972781200,6),(440,985482000,5),(440,1004230800,6),(440,1017536400,5),(440,1035680400,6),(440,1048986000,5),(440,1067130000,6),(440,1080435600,5),(440,1099184400,6),(440,1111885200,5),(440,1130634000,6),(440,1143334800,5),(440,1162083600,6),(440,1174784400,5),(440,1193533200,6),(440,1206838800,5),(440,1224982800,6),(440,1238288400,5),(440,1256432400,6),(440,1269738000,5),(440,1288486800,6),(440,1301187600,5),(440,1319936400,6),(440,1332637200,5),(440,1351386000,6),(440,1364691600,5),(440,1382835600,6),(440,1396141200,5),(440,1414285200,6),(440,1427590800,5),(440,1445734800,6),(440,1459040400,5),(440,1477789200,6),(440,1490490000,5),(440,1509238800,6),(440,1521939600,5),(440,1540688400,6),(440,1553994000,5),(440,1572138000,6),(440,1585443600,5),(440,1603587600,6),(440,1616893200,5),(440,1635642000,6),(440,1648342800,5),(440,1667091600,6),(440,1679792400,5),(440,1698541200,6),(440,1711846800,5),(440,1729990800,6),(440,1743296400,5),(440,1761440400,6),(440,1774746000,5),(440,1792890000,6),(440,1806195600,5),(440,1824944400,6),(440,1837645200,5),(440,1856394000,6),(440,1869094800,5),(440,1887843600,6),(440,1901149200,5),(440,1919293200,6),(440,1932598800,5),(440,1950742800,6),(440,1964048400,5),(440,1982797200,6),(440,1995498000,5),(440,2014246800,6),(440,2026947600,5),(440,2045696400,6),(440,2058397200,5),(440,2077146000,6),(440,2090451600,5),(440,2108595600,6),(440,2121901200,5),(440,2140045200,6),(441,-2147483648,2),(441,-1691964000,1),(441,-1680472800,2),(441,-1664143200,1),(441,-1650146400,2),(441,-1633903200,1),(441,-1617487200,2),(441,-1601848800,1),(441,-1586037600,2),(441,-1570399200,1),(441,-1552168800,2),(441,-1538344800,1),(441,-1522533600,2),(441,-1507500000,1),(441,-1490565600,2),(441,-1473631200,1),(441,-1460930400,2),(441,-1442786400,1),(441,-1428876000,2),(441,-1410732000,1),(441,-1396216800,2),(441,-1379282400,1),(441,-1364767200,2),(441,-1348437600,1),(441,-1333317600,2),(441,-1315778400,1),(441,-1301263200,2),(441,-1284328800,1),(441,-1269813600,2),(441,-1253484000,1),(441,-1238364000,2),(441,-1221429600,1),(441,-1206914400,2),(441,-1189980000,1),(441,-1175464800,2),(441,-1159135200,1),(441,-1143410400,2),(441,-1126476000,1),(441,-1111960800,2),(441,-1095631200,1),(441,-1080511200,2),(441,-1063576800,1),(441,-1049061600,2),(441,-1032127200,1),(441,-1017612000,2),(441,-1001282400,1),(441,-986162400,2),(441,-969228000,1),(441,-950479200,2),(441,-942012000,1),(441,-904518000,3),(441,-896050800,1),(441,-875487600,3),(441,-864601200,1),(441,-844038000,3),(441,-832546800,1),(441,-812588400,3),(441,-798073200,1),(441,-781052400,3),(441,-772066800,1),(441,-764805600,2),(441,-748476000,1),(441,-733356000,2),(441,-719445600,1),(441,-717030000,3),(441,-706748400,1),(441,-699487200,2),(441,-687996000,1),(441,-668037600,2),(441,-654732000,1),(441,-636588000,2),(441,-622072800,1),(441,-605743200,2),(441,-590623200,1),(441,-574293600,2),(441,-558568800,1),(441,-542239200,2),(441,-527119200,1),(441,-512604000,2),(441,-496274400,1),(441,-481154400,2),(441,-464220000,1),(441,-449704800,2),(441,-432165600,1),(441,-417650400,2),(441,-401320800,1),(441,-386200800,2),(441,-369266400,1),(441,-354751200,2),(441,-337816800,1),(441,-323301600,2),(441,-306972000,1),(441,-291852000,2),(441,-276732000,1),(441,-257983200,2),(441,-245282400,1),(441,-226533600,2),(441,-213228000,1),(441,-195084000,2),(441,-182383200,1),(441,-163634400,2),(441,-150933600,1),(441,-132184800,2),(441,-119484000,1),(441,-100735200,2),(441,-88034400,1),(441,-68680800,2),(441,-59004000,1),(441,-37242000,4),(441,57722400,6),(441,69818400,1),(441,89172000,2),(441,101268000,1),(441,120621600,2),(441,132717600,1),(441,152071200,2),(441,164167200,1),(441,183520800,2),(441,196221600,1),(441,214970400,2),(441,227671200,1),(441,246420000,2),(441,259120800,1),(441,278474400,2),(441,290570400,1),(441,309924000,2),(441,322020000,1),(441,341373600,2),(441,354675600,5),(441,372819600,6),(441,386125200,5),(441,404269200,6),(441,417574800,5),(441,435718800,6),(441,449024400,5),(441,467773200,6),(441,481078800,5),(441,499222800,6),(441,512528400,5),(441,530672400,6),(441,543978000,5),(441,562122000,6),(441,575427600,5),(441,593571600,6),(441,606877200,5),(441,625626000,6),(441,638326800,5),(441,657075600,6),(441,670381200,5),(441,688525200,6),(441,701830800,5),(441,719974800,6),(441,733280400,5),(441,751424400,6),(441,764730000,5),(441,782874000,6),(441,796179600,5),(441,814323600,6),(441,820454400,7),(441,828234000,5),(441,846378000,6),(441,859683600,5),(441,877827600,6),(441,891133200,5),(441,909277200,6),(441,922582800,5),(441,941331600,6),(441,954032400,5),(441,972781200,6),(441,985482000,5),(441,1004230800,6),(441,1017536400,5),(441,1035680400,6),(441,1048986000,5),(441,1067130000,6),(441,1080435600,5),(441,1099184400,6),(441,1111885200,5),(441,1130634000,6),(441,1143334800,5),(441,1162083600,6),(441,1174784400,5),(441,1193533200,6),(441,1206838800,5),(441,1224982800,6),(441,1238288400,5),(441,1256432400,6),(441,1269738000,5),(441,1288486800,6),(441,1301187600,5),(441,1319936400,6),(441,1332637200,5),(441,1351386000,6),(441,1364691600,5),(441,1382835600,6),(441,1396141200,5),(441,1414285200,6),(441,1427590800,5),(441,1445734800,6),(441,1459040400,5),(441,1477789200,6),(441,1490490000,5),(441,1509238800,6),(441,1521939600,5),(441,1540688400,6),(441,1553994000,5),(441,1572138000,6),(441,1585443600,5),(441,1603587600,6),(441,1616893200,5),(441,1635642000,6),(441,1648342800,5),(441,1667091600,6),(441,1679792400,5),(441,1698541200,6),(441,1711846800,5),(441,1729990800,6),(441,1743296400,5),(441,1761440400,6),(441,1774746000,5),(441,1792890000,6),(441,1806195600,5),(441,1824944400,6),(441,1837645200,5),(441,1856394000,6),(441,1869094800,5),(441,1887843600,6),(441,1901149200,5),(441,1919293200,6),(441,1932598800,5),(441,1950742800,6),(441,1964048400,5),(441,1982797200,6),(441,1995498000,5),(441,2014246800,6),(441,2026947600,5),(441,2045696400,6),(441,2058397200,5),(441,2077146000,6),(441,2090451600,5),(441,2108595600,6),(441,2121901200,5),(441,2140045200,6),(442,-2147483648,1),(442,-1535938789,3),(442,-875671200,2),(442,-859773600,3),(442,354672000,2),(442,370396800,3),(442,386121600,2),(442,401846400,3),(442,417574800,4),(442,433299600,5),(442,449024400,4),(442,465354000,5),(442,481078800,4),(442,496803600,5),(442,512528400,4),(442,528253200,5),(442,543978000,4),(442,559702800,5),(442,575427600,4),(442,591152400,5),(442,606877200,4),(442,622602000,5),(442,638326800,4),(442,654656400,5),(442,670381200,4),(442,686106000,5),(442,701830800,4),(442,717555600,5),(442,733280400,4),(442,749005200,5),(442,764730000,4),(442,780454800,5),(442,796179600,4),(442,811904400,5),(442,828234000,4),(442,846378000,5),(442,859683600,4),(442,877827600,5),(442,891133200,4),(442,909277200,5),(442,922582800,4),(442,941331600,5),(442,954032400,4),(442,972781200,5),(442,985482000,4),(442,1004230800,5),(442,1017536400,4),(442,1035680400,5),(442,1048986000,4),(442,1067130000,5),(442,1080435600,4),(442,1099184400,5),(442,1111885200,4),(442,1130634000,5),(442,1143334800,4),(442,1162083600,5),(442,1174784400,4),(442,1193533200,5),(442,1206838800,4),(442,1224982800,5),(442,1238288400,4),(442,1256432400,5),(442,1269738000,4),(442,1288486800,5),(442,1301187600,4),(442,1319936400,5),(442,1332637200,4),(442,1351386000,5),(442,1364691600,4),(442,1382835600,5),(442,1396141200,4),(442,1414285200,5),(442,1427590800,4),(442,1445734800,5),(442,1459040400,4),(442,1477789200,5),(442,1490490000,4),(442,1509238800,5),(442,1521939600,4),(442,1540688400,5),(442,1553994000,4),(442,1572138000,5),(442,1585443600,4),(442,1603587600,5),(442,1616893200,4),(442,1635642000,5),(442,1648342800,4),(442,1667091600,5),(442,1679792400,4),(442,1698541200,5),(442,1711846800,4),(442,1729990800,5),(442,1743296400,4),(442,1761440400,5),(442,1774746000,4),(442,1792890000,5),(442,1806195600,4),(442,1824944400,5),(442,1837645200,4),(442,1856394000,5),(442,1869094800,4),(442,1887843600,5),(442,1901149200,4),(442,1919293200,5),(442,1932598800,4),(442,1950742800,5),(442,1964048400,4),(442,1982797200,5),(442,1995498000,4),(442,2014246800,5),(442,2026947600,4),(442,2045696400,5),(442,2058397200,4),(442,2077146000,5),(442,2090451600,4),(442,2108595600,5),(442,2121901200,4),(442,2140045200,5),(443,-2147483648,2),(443,-1691964000,1),(443,-1680472800,2),(443,-1664143200,1),(443,-1650146400,2),(443,-1633903200,1),(443,-1617487200,2),(443,-1601848800,1),(443,-1586037600,2),(443,-1570399200,1),(443,-1552168800,2),(443,-1538344800,1),(443,-1522533600,2),(443,-1507500000,1),(443,-1490565600,2),(443,-1473631200,1),(443,-1460930400,2),(443,-1442786400,1),(443,-1428876000,2),(443,-1410732000,1),(443,-1396216800,2),(443,-1379282400,1),(443,-1364767200,2),(443,-1348437600,1),(443,-1333317600,2),(443,-1315778400,1),(443,-1301263200,2),(443,-1284328800,1),(443,-1269813600,2),(443,-1253484000,1),(443,-1238364000,2),(443,-1221429600,1),(443,-1206914400,2),(443,-1189980000,1),(443,-1175464800,2),(443,-1159135200,1),(443,-1143410400,2),(443,-1126476000,1),(443,-1111960800,2),(443,-1095631200,1),(443,-1080511200,2),(443,-1063576800,1),(443,-1049061600,2),(443,-1032127200,1),(443,-1017612000,2),(443,-1001282400,1),(443,-986162400,2),(443,-969228000,1),(443,-950479200,2),(443,-942012000,1),(443,-904518000,3),(443,-896050800,1),(443,-875487600,3),(443,-864601200,1),(443,-844038000,3),(443,-832546800,1),(443,-812588400,3),(443,-798073200,1),(443,-781052400,3),(443,-772066800,1),(443,-764805600,2),(443,-748476000,1),(443,-733356000,2),(443,-719445600,1),(443,-717030000,3),(443,-706748400,1),(443,-699487200,2),(443,-687996000,1),(443,-668037600,2),(443,-654732000,1),(443,-636588000,2),(443,-622072800,1),(443,-605743200,2),(443,-590623200,1),(443,-574293600,2),(443,-558568800,1),(443,-542239200,2),(443,-527119200,1),(443,-512604000,2),(443,-496274400,1),(443,-481154400,2),(443,-464220000,1),(443,-449704800,2),(443,-432165600,1),(443,-417650400,2),(443,-401320800,1),(443,-386200800,2),(443,-369266400,1),(443,-354751200,2),(443,-337816800,1),(443,-323301600,2),(443,-306972000,1),(443,-291852000,2),(443,-276732000,1),(443,-257983200,2),(443,-245282400,1),(443,-226533600,2),(443,-213228000,1),(443,-195084000,2),(443,-182383200,1),(443,-163634400,2),(443,-150933600,1),(443,-132184800,2),(443,-119484000,1),(443,-100735200,2),(443,-88034400,1),(443,-68680800,2),(443,-59004000,1),(443,-37242000,4),(443,57722400,6),(443,69818400,1),(443,89172000,2),(443,101268000,1),(443,120621600,2),(443,132717600,1),(443,152071200,2),(443,164167200,1),(443,183520800,2),(443,196221600,1),(443,214970400,2),(443,227671200,1),(443,246420000,2),(443,259120800,1),(443,278474400,2),(443,290570400,1),(443,309924000,2),(443,322020000,1),(443,341373600,2),(443,354675600,5),(443,372819600,6),(443,386125200,5),(443,404269200,6),(443,417574800,5),(443,435718800,6),(443,449024400,5),(443,467773200,6),(443,481078800,5),(443,499222800,6),(443,512528400,5),(443,530672400,6),(443,543978000,5),(443,562122000,6),(443,575427600,5),(443,593571600,6),(443,606877200,5),(443,625626000,6),(443,638326800,5),(443,657075600,6),(443,670381200,5),(443,688525200,6),(443,701830800,5),(443,719974800,6),(443,733280400,5),(443,751424400,6),(443,764730000,5),(443,782874000,6),(443,796179600,5),(443,814323600,6),(443,820454400,7),(443,828234000,5),(443,846378000,6),(443,859683600,5),(443,877827600,6),(443,891133200,5),(443,909277200,6),(443,922582800,5),(443,941331600,6),(443,954032400,5),(443,972781200,6),(443,985482000,5),(443,1004230800,6),(443,1017536400,5),(443,1035680400,6),(443,1048986000,5),(443,1067130000,6),(443,1080435600,5),(443,1099184400,6),(443,1111885200,5),(443,1130634000,6),(443,1143334800,5),(443,1162083600,6),(443,1174784400,5),(443,1193533200,6),(443,1206838800,5),(443,1224982800,6),(443,1238288400,5),(443,1256432400,6),(443,1269738000,5),(443,1288486800,6),(443,1301187600,5),(443,1319936400,6),(443,1332637200,5),(443,1351386000,6),(443,1364691600,5),(443,1382835600,6),(443,1396141200,5),(443,1414285200,6),(443,1427590800,5),(443,1445734800,6),(443,1459040400,5),(443,1477789200,6),(443,1490490000,5),(443,1509238800,6),(443,1521939600,5),(443,1540688400,6),(443,1553994000,5),(443,1572138000,6),(443,1585443600,5),(443,1603587600,6),(443,1616893200,5),(443,1635642000,6),(443,1648342800,5),(443,1667091600,6),(443,1679792400,5),(443,1698541200,6),(443,1711846800,5),(443,1729990800,6),(443,1743296400,5),(443,1761440400,6),(443,1774746000,5),(443,1792890000,6),(443,1806195600,5),(443,1824944400,6),(443,1837645200,5),(443,1856394000,6),(443,1869094800,5),(443,1887843600,6),(443,1901149200,5),(443,1919293200,6),(443,1932598800,5),(443,1950742800,6),(443,1964048400,5),(443,1982797200,6),(443,1995498000,5),(443,2014246800,6),(443,2026947600,5),(443,2045696400,6),(443,2058397200,5),(443,2077146000,6),(443,2090451600,5),(443,2108595600,6),(443,2121901200,5),(443,2140045200,6),(444,-2147483648,1),(444,-1869875816,3),(444,-1693706400,2),(444,-1680490800,3),(444,-1570413600,2),(444,-1552186800,3),(444,-1538359200,2),(444,-1522551600,3),(444,-1507514400,2),(444,-1490583600,3),(444,-1440208800,2),(444,-1428030000,3),(444,-1409709600,2),(444,-1396494000,3),(444,-931140000,2),(444,-922762800,3),(444,-917834400,2),(444,-892436400,3),(444,-875844000,2),(444,-857358000,3),(444,-781063200,2),(444,-764737200,3),(444,-744343200,2),(444,-733806000,3),(444,-716436000,2),(444,-701924400,3),(444,-684986400,2),(444,-670474800,3),(444,-654141600,2),(444,-639025200,3),(444,-621828000,2),(444,-606970800,3),(444,-590032800,2),(444,-575434800,3),(444,-235620000,2),(444,-228279600,3),(444,-177732000,2),(444,-165726000,3),(444,10533600,2),(444,23835600,3),(444,41983200,2),(444,55285200,3),(444,74037600,2),(444,87339600,3),(444,107910000,2),(444,121219200,3),(444,133920000,2),(444,152676000,3),(444,165362400,2),(444,183502800,3),(444,202428000,2),(444,215557200,3),(444,228866400,2),(444,245797200,3),(444,260316000,2),(444,277246800,4),(444,308779200,5),(444,323827200,4),(444,340228800,5),(444,354672000,4),(444,371678400,5),(444,386121600,4),(444,403128000,5),(444,428446800,4),(444,433886400,5),(444,482792400,2),(444,496702800,3),(444,512521200,6),(444,528246000,7),(444,543970800,6),(444,559695600,7),(444,575420400,6),(444,591145200,7),(444,606870000,6),(444,622594800,7),(444,638319600,6),(444,654649200,7),(444,670374000,6),(444,686098800,7),(444,701823600,6),(444,717548400,7),(444,733273200,6),(444,748998000,7),(444,764118000,6),(444,780447600,7),(444,796172400,6),(444,811897200,7),(444,828226800,6),(444,846370800,7),(444,859676400,6),(444,877820400,7),(444,891126000,6),(444,909270000,7),(444,922575600,6),(444,941324400,7),(444,954025200,6),(444,972774000,7),(444,985474800,6),(444,1004223600,7),(444,1017529200,6),(444,1035673200,7),(444,1048978800,6),(444,1067122800,7),(444,1080428400,6),(444,1099177200,7),(444,1111878000,6),(444,1130626800,7),(444,1143327600,6),(444,1162076400,7),(444,1167602400,3),(444,1174784400,8),(444,1193533200,9),(444,1206838800,8),(444,1224982800,9),(444,1238288400,8),(444,1256432400,9),(444,1269738000,8),(444,1288486800,9),(444,1301274000,8),(444,1319936400,9),(444,1332637200,8),(444,1351386000,9),(444,1364691600,8),(444,1382835600,9),(444,1396227600,8),(444,1414285200,9),(444,1427590800,8),(444,1446944400,9),(444,1459040400,8),(444,1473195600,5),(444,2147483647,5),(445,-2147483648,2),(445,-1691964000,1),(445,-1680472800,2),(445,-1664143200,1),(445,-1650146400,2),(445,-1633903200,1),(445,-1617487200,2),(445,-1601848800,1),(445,-1586037600,2),(445,-1570399200,1),(445,-1552168800,2),(445,-1538344800,1),(445,-1522533600,2),(445,-1507500000,1),(445,-1490565600,2),(445,-1473631200,1),(445,-1460930400,2),(445,-1442786400,1),(445,-1428876000,2),(445,-1410732000,1),(445,-1396216800,2),(445,-1379282400,1),(445,-1364767200,2),(445,-1348437600,1),(445,-1333317600,2),(445,-1315778400,1),(445,-1301263200,2),(445,-1284328800,1),(445,-1269813600,2),(445,-1253484000,1),(445,-1238364000,2),(445,-1221429600,1),(445,-1206914400,2),(445,-1189980000,1),(445,-1175464800,2),(445,-1159135200,1),(445,-1143410400,2),(445,-1126476000,1),(445,-1111960800,2),(445,-1095631200,1),(445,-1080511200,2),(445,-1063576800,1),(445,-1049061600,2),(445,-1032127200,1),(445,-1017612000,2),(445,-1001282400,1),(445,-986162400,2),(445,-969228000,1),(445,-950479200,2),(445,-942012000,1),(445,-904518000,3),(445,-896050800,1),(445,-875487600,3),(445,-864601200,1),(445,-844038000,3),(445,-832546800,1),(445,-812588400,3),(445,-798073200,1),(445,-781052400,3),(445,-772066800,1),(445,-764805600,2),(445,-748476000,1),(445,-733356000,2),(445,-719445600,1),(445,-717030000,3),(445,-706748400,1),(445,-699487200,2),(445,-687996000,1),(445,-668037600,2),(445,-654732000,1),(445,-636588000,2),(445,-622072800,1),(445,-605743200,2),(445,-590623200,1),(445,-574293600,2),(445,-558568800,1),(445,-542239200,2),(445,-527119200,1),(445,-512604000,2),(445,-496274400,1),(445,-481154400,2),(445,-464220000,1),(445,-449704800,2),(445,-432165600,1),(445,-417650400,2),(445,-401320800,1),(445,-386200800,2),(445,-369266400,1),(445,-354751200,2),(445,-337816800,1),(445,-323301600,2),(445,-306972000,1),(445,-291852000,2),(445,-276732000,1),(445,-257983200,2),(445,-245282400,1),(445,-226533600,2),(445,-213228000,1),(445,-195084000,2),(445,-182383200,1),(445,-163634400,2),(445,-150933600,1),(445,-132184800,2),(445,-119484000,1),(445,-100735200,2),(445,-88034400,1),(445,-68680800,2),(445,-59004000,1),(445,-37242000,4),(445,57722400,6),(445,69818400,1),(445,89172000,2),(445,101268000,1),(445,120621600,2),(445,132717600,1),(445,152071200,2),(445,164167200,1),(445,183520800,2),(445,196221600,1),(445,214970400,2),(445,227671200,1),(445,246420000,2),(445,259120800,1),(445,278474400,2),(445,290570400,1),(445,309924000,2),(445,322020000,1),(445,341373600,2),(445,354675600,5),(445,372819600,6),(445,386125200,5),(445,404269200,6),(445,417574800,5),(445,435718800,6),(445,449024400,5),(445,467773200,6),(445,481078800,5),(445,499222800,6),(445,512528400,5),(445,530672400,6),(445,543978000,5),(445,562122000,6),(445,575427600,5),(445,593571600,6),(445,606877200,5),(445,625626000,6),(445,638326800,5),(445,657075600,6),(445,670381200,5),(445,688525200,6),(445,701830800,5),(445,719974800,6),(445,733280400,5),(445,751424400,6),(445,764730000,5),(445,782874000,6),(445,796179600,5),(445,814323600,6),(445,820454400,7),(445,828234000,5),(445,846378000,6),(445,859683600,5),(445,877827600,6),(445,891133200,5),(445,909277200,6),(445,922582800,5),(445,941331600,6),(445,954032400,5),(445,972781200,6),(445,985482000,5),(445,1004230800,6),(445,1017536400,5),(445,1035680400,6),(445,1048986000,5),(445,1067130000,6),(445,1080435600,5),(445,1099184400,6),(445,1111885200,5),(445,1130634000,6),(445,1143334800,5),(445,1162083600,6),(445,1174784400,5),(445,1193533200,6),(445,1206838800,5),(445,1224982800,6),(445,1238288400,5),(445,1256432400,6),(445,1269738000,5),(445,1288486800,6),(445,1301187600,5),(445,1319936400,6),(445,1332637200,5),(445,1351386000,6),(445,1364691600,5),(445,1382835600,6),(445,1396141200,5),(445,1414285200,6),(445,1427590800,5),(445,1445734800,6),(445,1459040400,5),(445,1477789200,6),(445,1490490000,5),(445,1509238800,6),(445,1521939600,5),(445,1540688400,6),(445,1553994000,5),(445,1572138000,6),(445,1585443600,5),(445,1603587600,6),(445,1616893200,5),(445,1635642000,6),(445,1648342800,5),(445,1667091600,6),(445,1679792400,5),(445,1698541200,6),(445,1711846800,5),(445,1729990800,6),(445,1743296400,5),(445,1761440400,6),(445,1774746000,5),(445,1792890000,6),(445,1806195600,5),(445,1824944400,6),(445,1837645200,5),(445,1856394000,6),(445,1869094800,5),(445,1887843600,6),(445,1901149200,5),(445,1919293200,6),(445,1932598800,5),(445,1950742800,6),(445,1964048400,5),(445,1982797200,6),(445,1995498000,5),(445,2014246800,6),(445,2026947600,5),(445,2045696400,6),(445,2058397200,5),(445,2077146000,6),(445,2090451600,5),(445,2108595600,6),(445,2121901200,5),(445,2140045200,6),(446,-2147483648,2),(446,-1693706400,1),(446,-1680483600,2),(446,-1663455600,3),(446,-1650150000,4),(446,-1632006000,3),(446,-1618700400,4),(446,-938905200,3),(446,-857257200,4),(446,-844556400,3),(446,-828226800,4),(446,-812502000,3),(446,-796777200,4),(446,-788922000,6),(446,-778730400,5),(446,-762663600,6),(446,-757389600,8),(446,354920400,7),(446,370728000,8),(446,386456400,7),(446,402264000,8),(446,417992400,7),(446,433800000,8),(446,449614800,7),(446,465346800,9),(446,481071600,10),(446,496796400,9),(446,512521200,10),(446,528246000,9),(446,543970800,10),(446,559695600,9),(446,575420400,10),(446,591145200,9),(446,606870000,11),(446,622598400,12),(446,638323200,11),(446,654652800,12),(446,670377600,11),(446,686102400,12),(446,701827200,11),(446,717552000,12),(446,733276800,11),(446,749001600,12),(446,764726400,11),(446,780451200,12),(446,796176000,11),(446,811900800,12),(446,828230400,11),(446,846374400,12),(446,859680000,11),(446,877824000,12),(446,891129600,11),(446,909273600,12),(446,922579200,11),(446,941328000,12),(446,954028800,11),(446,972777600,12),(446,985478400,11),(446,1004227200,12),(446,1017532800,11),(446,1035676800,12),(446,1048982400,11),(446,1067126400,12),(446,1080432000,11),(446,1099180800,12),(446,1111881600,11),(446,1130630400,12),(446,1143331200,11),(446,1162080000,12),(446,1174780800,11),(446,1193529600,12),(446,1206835200,11),(446,1224979200,12),(446,1238284800,11),(446,1256428800,12),(446,1269734400,11),(446,1288483200,12),(446,1301184000,13),(446,1414278000,12),(447,-2147483648,1),(447,-1441159324,2),(447,-1247536800,3),(447,-892522800,6),(447,-857257200,4),(447,-844556400,5),(447,-828226800,4),(447,-825382800,3),(447,354920400,7),(447,370728000,3),(447,386456400,7),(447,402264000,3),(447,417992400,7),(447,433800000,3),(447,449614800,7),(447,465346800,8),(447,481071600,9),(447,496796400,8),(447,512521200,9),(447,528246000,8),(447,543970800,9),(447,559695600,8),(447,575420400,9),(447,591145200,8),(447,606870000,9),(447,622594800,8),(447,638319600,9),(447,646783200,10),(447,686102400,2),(447,701820000,10),(447,717541200,2),(447,733269600,10),(447,748990800,2),(447,764719200,10),(447,780440400,2),(447,796179600,11),(447,811904400,12),(447,828234000,11),(447,846378000,12),(447,859683600,11),(447,877827600,12),(447,891133200,11),(447,909277200,12),(447,922582800,11),(447,941331600,12),(447,954032400,11),(447,972781200,12),(447,985482000,11),(447,1004230800,12),(447,1017536400,11),(447,1035680400,12),(447,1048986000,11),(447,1067130000,12),(447,1080435600,11),(447,1099184400,12),(447,1111885200,11),(447,1130634000,12),(447,1143334800,11),(447,1162083600,12),(447,1174784400,11),(447,1193533200,12),(447,1206838800,11),(447,1224982800,12),(447,1238288400,11),(447,1256432400,12),(447,1269738000,11),(447,1288486800,12),(447,1301187600,11),(447,1319936400,12),(447,1332637200,11),(447,1351386000,12),(447,1364691600,11),(447,1382835600,12),(447,1396141200,11),(447,1414285200,12),(447,1427590800,11),(447,1445734800,12),(447,1459040400,11),(447,1477789200,12),(447,1490490000,11),(447,1509238800,12),(447,1521939600,11),(447,1540688400,12),(447,1553994000,11),(447,1572138000,12),(447,1585443600,11),(447,1603587600,12),(447,1616893200,11),(447,1635642000,12),(447,1648342800,11),(447,1667091600,12),(447,1679792400,11),(447,1698541200,12),(447,1711846800,11),(447,1729990800,12),(447,1743296400,11),(447,1761440400,12),(447,1774746000,11),(447,1792890000,12),(447,1806195600,11),(447,1824944400,12),(447,1837645200,11),(447,1856394000,12),(447,1869094800,11),(447,1887843600,12),(447,1901149200,11),(447,1919293200,12),(447,1932598800,11),(447,1950742800,12),(447,1964048400,11),(447,1982797200,12),(447,1995498000,11),(447,2014246800,12),(447,2026947600,11),(447,2045696400,12),(447,2058397200,11),(447,2077146000,12),(447,2090451600,11),(447,2108595600,12),(447,2121901200,11),(447,2140045200,12),(448,-2147483648,0),(448,-1593820800,1),(448,-1247540400,3),(448,354916800,2),(448,370724400,3),(448,386452800,2),(448,402260400,3),(448,417988800,2),(448,433796400,3),(448,449611200,2),(448,465343200,4),(448,481068000,5),(448,496792800,4),(448,512517600,5),(448,528242400,4),(448,543967200,5),(448,559692000,4),(448,575416800,5),(448,591141600,4),(448,606866400,6),(448,622594800,7),(448,638319600,6),(448,654649200,7),(448,670374000,4),(448,701820000,6),(448,717548400,7),(448,733273200,6),(448,748998000,7),(448,764722800,6),(448,780447600,7),(448,796172400,6),(448,811897200,7),(448,828226800,6),(448,846370800,7),(448,859676400,6),(448,877820400,7),(448,891126000,6),(448,909270000,7),(448,922575600,6),(448,941324400,7),(448,954025200,6),(448,972774000,7),(448,985474800,6),(448,1004223600,7),(448,1017529200,6),(448,1035673200,7),(448,1048978800,6),(448,1067122800,7),(448,1080428400,6),(448,1099177200,7),(448,1111878000,6),(448,1130626800,7),(448,1143327600,6),(448,1162076400,7),(448,1174777200,6),(448,1193526000,7),(448,1206831600,6),(448,1224975600,7),(448,1238281200,6),(448,1256425200,7),(448,1269730800,6),(448,1288479600,7),(448,1301180400,4),(448,1414274400,7),(448,2147483647,7),(449,-2147483648,0),(449,-1830384000,6),(449,-1689555600,1),(449,-1677801600,2),(449,-1667437200,3),(449,-1647738000,4),(449,-1635814800,3),(449,-1616202000,4),(449,-1604365200,3),(449,-1584666000,4),(449,-1572742800,3),(449,-1553043600,4),(449,-1541206800,3),(449,-1521507600,4),(449,-1442451600,3),(449,-1426813200,4),(449,-1379293200,3),(449,-1364778000,4),(449,-1348448400,3),(449,-1333328400,4),(449,-1316394000,3),(449,-1301274000,4),(449,-1284339600,3),(449,-1269824400,4),(449,-1221440400,3),(449,-1206925200,4),(449,-1191200400,3),(449,-1175475600,4),(449,-1127696400,3),(449,-1111971600,4),(449,-1096851600,3),(449,-1080522000,4),(449,-1063587600,3),(449,-1049072400,4),(449,-1033347600,3),(449,-1017622800,4),(449,-1002502800,3),(449,-986173200,4),(449,-969238800,3),(449,-950490000,4),(449,-942022800,3),(449,-922669200,4),(449,-906944400,3),(449,-891133200,4),(449,-877309200,3),(449,-873684000,5),(449,-864007200,3),(449,-857955600,4),(449,-845859600,3),(449,-842839200,5),(449,-831348000,3),(449,-825901200,4),(449,-814410000,3),(449,-810784800,5),(449,-799898400,3),(449,-794451600,4),(449,-782960400,3),(449,-779335200,5),(449,-768448800,3),(449,-763002000,4),(449,-749091600,3),(449,-733366800,4),(449,-717631200,3),(449,-701906400,4),(449,-686181600,3),(449,-670456800,4),(449,-654732000,3),(449,-639007200,4),(449,-591832800,3),(449,-575503200,4),(449,-559778400,3),(449,-544053600,4),(449,-528328800,3),(449,-512604000,4),(449,-496879200,3),(449,-481154400,4),(449,-465429600,3),(449,-449704800,4),(449,-433980000,3),(449,-417650400,4),(449,-401925600,3),(449,-386200800,4),(449,-370476000,3),(449,-354751200,4),(449,-339026400,3),(449,-323301600,4),(449,-307576800,3),(449,-291852000,4),(449,-276127200,3),(449,-260402400,4),(449,-244677600,3),(449,-228348000,4),(449,-212623200,3),(449,-196898400,4),(449,-181173600,3),(449,-165448800,4),(449,-149724000,3),(449,-133999200,4),(449,-118274400,7),(449,212544000,2),(449,228268800,3),(449,243993600,4),(449,260323200,3),(449,276048000,4),(449,291772800,3),(449,307501200,4),(449,323222400,3),(449,338950800,4),(449,354675600,3),(449,370400400,4),(449,386125200,3),(449,401850000,4),(449,417578400,3),(449,433299600,4),(449,449024400,3),(449,465354000,4),(449,481078800,3),(449,496803600,4),(449,512528400,3),(449,528253200,4),(449,543978000,3),(449,559702800,4),(449,575427600,3),(449,591152400,4),(449,606877200,3),(449,622602000,4),(449,638326800,3),(449,654656400,4),(449,670381200,3),(449,686106000,4),(449,701830800,3),(449,717555600,8),(449,733280400,9),(449,749005200,8),(449,764730000,9),(449,780454800,8),(449,796179600,9),(449,811904400,8),(449,828234000,10),(449,846378000,6),(449,859683600,10),(449,877827600,6),(449,891133200,10),(449,909277200,6),(449,922582800,10),(449,941331600,6),(449,954032400,10),(449,972781200,6),(449,985482000,10),(449,1004230800,6),(449,1017536400,10),(449,1035680400,6),(449,1048986000,10),(449,1067130000,6),(449,1080435600,10),(449,1099184400,6),(449,1111885200,10),(449,1130634000,6),(449,1143334800,10),(449,1162083600,6),(449,1174784400,10),(449,1193533200,6),(449,1206838800,10),(449,1224982800,6),(449,1238288400,10),(449,1256432400,6),(449,1269738000,10),(449,1288486800,6),(449,1301187600,10),(449,1319936400,6),(449,1332637200,10),(449,1351386000,6),(449,1364691600,10),(449,1382835600,6),(449,1396141200,10),(449,1414285200,6),(449,1427590800,10),(449,1445734800,6),(449,1459040400,10),(449,1477789200,6),(449,1490490000,10),(449,1509238800,6),(449,1521939600,10),(449,1540688400,6),(449,1553994000,10),(449,1572138000,6),(449,1585443600,10),(449,1603587600,6),(449,1616893200,10),(449,1635642000,6),(449,1648342800,10),(449,1667091600,6),(449,1679792400,10),(449,1698541200,6),(449,1711846800,10),(449,1729990800,6),(449,1743296400,10),(449,1761440400,6),(449,1774746000,10),(449,1792890000,6),(449,1806195600,10),(449,1824944400,6),(449,1837645200,10),(449,1856394000,6),(449,1869094800,10),(449,1887843600,6),(449,1901149200,10),(449,1919293200,6),(449,1932598800,10),(449,1950742800,6),(449,1964048400,10),(449,1982797200,6),(449,1995498000,10),(449,2014246800,6),(449,2026947600,10),(449,2045696400,6),(449,2058397200,10),(449,2077146000,6),(449,2090451600,10),(449,2108595600,6),(449,2121901200,10),(449,2140045200,6),(450,-2147483648,1),(450,-905824800,4),(450,-857257200,2),(450,-844556400,3),(450,-828226800,2),(450,-812502000,3),(450,-796777200,2),(450,-788922000,1),(450,-777942000,3),(450,-766623600,2),(450,407199600,1),(450,417574800,5),(450,433299600,6),(450,449024400,5),(450,465354000,6),(450,481078800,5),(450,496803600,6),(450,512528400,5),(450,528253200,6),(450,543978000,5),(450,559702800,6),(450,575427600,5),(450,591152400,6),(450,606877200,5),(450,622602000,6),(450,638326800,5),(450,654656400,6),(450,670381200,5),(450,686106000,6),(450,701830800,5),(450,717555600,6),(450,733280400,5),(450,749005200,6),(450,764730000,5),(450,780454800,6),(450,796179600,5),(450,811904400,6),(450,828234000,5),(450,846378000,6),(450,859683600,5),(450,877827600,6),(450,891133200,5),(450,909277200,6),(450,922582800,5),(450,941331600,6),(450,954032400,5),(450,972781200,6),(450,985482000,5),(450,1004230800,6),(450,1017536400,5),(450,1035680400,6),(450,1048986000,5),(450,1067130000,6),(450,1080435600,5),(450,1099184400,6),(450,1111885200,5),(450,1130634000,6),(450,1143334800,5),(450,1162083600,6),(450,1174784400,5),(450,1193533200,6),(450,1206838800,5),(450,1224982800,6),(450,1238288400,5),(450,1256432400,6),(450,1269738000,5),(450,1288486800,6),(450,1301187600,5),(450,1319936400,6),(450,1332637200,5),(450,1351386000,6),(450,1364691600,5),(450,1382835600,6),(450,1396141200,5),(450,1414285200,6),(450,1427590800,5),(450,1445734800,6),(450,1459040400,5),(450,1477789200,6),(450,1490490000,5),(450,1509238800,6),(450,1521939600,5),(450,1540688400,6),(450,1553994000,5),(450,1572138000,6),(450,1585443600,5),(450,1603587600,6),(450,1616893200,5),(450,1635642000,6),(450,1648342800,5),(450,1667091600,6),(450,1679792400,5),(450,1698541200,6),(450,1711846800,5),(450,1729990800,6),(450,1743296400,5),(450,1761440400,6),(450,1774746000,5),(450,1792890000,6),(450,1806195600,5),(450,1824944400,6),(450,1837645200,5),(450,1856394000,6),(450,1869094800,5),(450,1887843600,6),(450,1901149200,5),(450,1919293200,6),(450,1932598800,5),(450,1950742800,6),(450,1964048400,5),(450,1982797200,6),(450,1995498000,5),(450,2014246800,6),(450,2026947600,5),(450,2045696400,6),(450,2058397200,5),(450,2077146000,6),(450,2090451600,5),(450,2108595600,6),(450,2121901200,5),(450,2140045200,6),(451,-2147483648,2),(451,-1691964000,1),(451,-1680472800,2),(451,-1664143200,1),(451,-1650146400,2),(451,-1633903200,1),(451,-1617487200,2),(451,-1601848800,1),(451,-1586037600,2),(451,-1570399200,1),(451,-1552168800,2),(451,-1538344800,1),(451,-1522533600,2),(451,-1507500000,1),(451,-1490565600,2),(451,-1473631200,1),(451,-1460930400,2),(451,-1442786400,1),(451,-1428876000,2),(451,-1410732000,1),(451,-1396216800,2),(451,-1379282400,1),(451,-1364767200,2),(451,-1348437600,1),(451,-1333317600,2),(451,-1315778400,1),(451,-1301263200,2),(451,-1284328800,1),(451,-1269813600,2),(451,-1253484000,1),(451,-1238364000,2),(451,-1221429600,1),(451,-1206914400,2),(451,-1189980000,1),(451,-1175464800,2),(451,-1159135200,1),(451,-1143410400,2),(451,-1126476000,1),(451,-1111960800,2),(451,-1095631200,1),(451,-1080511200,2),(451,-1063576800,1),(451,-1049061600,2),(451,-1032127200,1),(451,-1017612000,2),(451,-1001282400,1),(451,-986162400,2),(451,-969228000,1),(451,-950479200,2),(451,-942012000,1),(451,-904518000,3),(451,-896050800,1),(451,-875487600,3),(451,-864601200,1),(451,-844038000,3),(451,-832546800,1),(451,-812588400,3),(451,-798073200,1),(451,-781052400,3),(451,-772066800,1),(451,-764805600,2),(451,-748476000,1),(451,-733356000,2),(451,-719445600,1),(451,-717030000,3),(451,-706748400,1),(451,-699487200,2),(451,-687996000,1),(451,-668037600,2),(451,-654732000,1),(451,-636588000,2),(451,-622072800,1),(451,-605743200,2),(451,-590623200,1),(451,-574293600,2),(451,-558568800,1),(451,-542239200,2),(451,-527119200,1),(451,-512604000,2),(451,-496274400,1),(451,-481154400,2),(451,-464220000,1),(451,-449704800,2),(451,-432165600,1),(451,-417650400,2),(451,-401320800,1),(451,-386200800,2),(451,-369266400,1),(451,-354751200,2),(451,-337816800,1),(451,-323301600,2),(451,-306972000,1),(451,-291852000,2),(451,-276732000,1),(451,-257983200,2),(451,-245282400,1),(451,-226533600,2),(451,-213228000,1),(451,-195084000,2),(451,-182383200,1),(451,-163634400,2),(451,-150933600,1),(451,-132184800,2),(451,-119484000,1),(451,-100735200,2),(451,-88034400,1),(451,-68680800,2),(451,-59004000,1),(451,-37242000,4),(451,57722400,6),(451,69818400,1),(451,89172000,2),(451,101268000,1),(451,120621600,2),(451,132717600,1),(451,152071200,2),(451,164167200,1),(451,183520800,2),(451,196221600,1),(451,214970400,2),(451,227671200,1),(451,246420000,2),(451,259120800,1),(451,278474400,2),(451,290570400,1),(451,309924000,2),(451,322020000,1),(451,341373600,2),(451,354675600,5),(451,372819600,6),(451,386125200,5),(451,404269200,6),(451,417574800,5),(451,435718800,6),(451,449024400,5),(451,467773200,6),(451,481078800,5),(451,499222800,6),(451,512528400,5),(451,530672400,6),(451,543978000,5),(451,562122000,6),(451,575427600,5),(451,593571600,6),(451,606877200,5),(451,625626000,6),(451,638326800,5),(451,657075600,6),(451,670381200,5),(451,688525200,6),(451,701830800,5),(451,719974800,6),(451,733280400,5),(451,751424400,6),(451,764730000,5),(451,782874000,6),(451,796179600,5),(451,814323600,6),(451,820454400,7),(451,828234000,5),(451,846378000,6),(451,859683600,5),(451,877827600,6),(451,891133200,5),(451,909277200,6),(451,922582800,5),(451,941331600,6),(451,954032400,5),(451,972781200,6),(451,985482000,5),(451,1004230800,6),(451,1017536400,5),(451,1035680400,6),(451,1048986000,5),(451,1067130000,6),(451,1080435600,5),(451,1099184400,6),(451,1111885200,5),(451,1130634000,6),(451,1143334800,5),(451,1162083600,6),(451,1174784400,5),(451,1193533200,6),(451,1206838800,5),(451,1224982800,6),(451,1238288400,5),(451,1256432400,6),(451,1269738000,5),(451,1288486800,6),(451,1301187600,5),(451,1319936400,6),(451,1332637200,5),(451,1351386000,6),(451,1364691600,5),(451,1382835600,6),(451,1396141200,5),(451,1414285200,6),(451,1427590800,5),(451,1445734800,6),(451,1459040400,5),(451,1477789200,6),(451,1490490000,5),(451,1509238800,6),(451,1521939600,5),(451,1540688400,6),(451,1553994000,5),(451,1572138000,6),(451,1585443600,5),(451,1603587600,6),(451,1616893200,5),(451,1635642000,6),(451,1648342800,5),(451,1667091600,6),(451,1679792400,5),(451,1698541200,6),(451,1711846800,5),(451,1729990800,6),(451,1743296400,5),(451,1761440400,6),(451,1774746000,5),(451,1792890000,6),(451,1806195600,5),(451,1824944400,6),(451,1837645200,5),(451,1856394000,6),(451,1869094800,5),(451,1887843600,6),(451,1901149200,5),(451,1919293200,6),(451,1932598800,5),(451,1950742800,6),(451,1964048400,5),(451,1982797200,6),(451,1995498000,5),(451,2014246800,6),(451,2026947600,5),(451,2045696400,6),(451,2058397200,5),(451,2077146000,6),(451,2090451600,5),(451,2108595600,6),(451,2121901200,5),(451,2140045200,6),(452,-2147483648,0),(452,-2069713476,2),(452,-1692496800,1),(452,-1680483600,2),(452,-1662343200,1),(452,-1650157200,2),(452,-1632006000,3),(452,-1618700400,4),(452,-1612659600,6),(452,-1604278800,5),(452,-1585519200,6),(452,-1574038800,5),(452,-1552258800,6),(452,-1539997200,5),(452,-1520550000,6),(452,-1507510800,5),(452,-1490572800,6),(452,-1473642000,5),(452,-1459119600,6),(452,-1444006800,5),(452,-1427673600,6),(452,-1411866000,5),(452,-1396224000,6),(452,-1379293200,5),(452,-1364774400,6),(452,-1348448400,5),(452,-1333324800,6),(452,-1316394000,5),(452,-1301270400,6),(452,-1284339600,5),(452,-1269813600,7),(452,-1253484000,8),(452,-1238364000,7),(452,-1221429600,8),(452,-1206914400,7),(452,-1191189600,8),(452,-1175464800,7),(452,-1160344800,8),(452,-1143410400,7),(452,-1127685600,8),(452,-1111960800,7),(452,-1096840800,8),(452,-1080511200,7),(452,-1063576800,8),(452,-1049061600,7),(452,-1033336800,8),(452,-1017612000,7),(452,-1002492000,8),(452,-986162400,7),(452,-969228000,8),(452,-950479200,7),(452,-942012000,8),(452,-935186400,11),(452,-857257200,9),(452,-844556400,10),(452,-828226800,9),(452,-812502000,10),(452,-797986800,2),(452,-781052400,3),(452,-766623600,4),(452,-745455600,3),(452,-733273200,4),(452,220921200,2),(452,228877200,12),(452,243997200,13),(452,260326800,12),(452,276051600,13),(452,291776400,12),(452,307501200,13),(452,323830800,12),(452,338950800,13),(452,354675600,12),(452,370400400,13),(452,386125200,12),(452,401850000,13),(452,417574800,12),(452,433299600,13),(452,449024400,12),(452,465354000,13),(452,481078800,12),(452,496803600,13),(452,512528400,12),(452,528253200,13),(452,543978000,12),(452,559702800,13),(452,575427600,12),(452,591152400,13),(452,606877200,12),(452,622602000,13),(452,638326800,12),(452,654656400,13),(452,670381200,12),(452,686106000,13),(452,701830800,12),(452,717555600,13),(452,733280400,12),(452,749005200,13),(452,764730000,12),(452,780454800,13),(452,796179600,12),(452,811904400,13),(452,828234000,12),(452,846378000,13),(452,859683600,12),(452,877827600,13),(452,891133200,12),(452,909277200,13),(452,922582800,12),(452,941331600,13),(452,954032400,12),(452,972781200,13),(452,985482000,12),(452,1004230800,13),(452,1017536400,12),(452,1035680400,13),(452,1048986000,12),(452,1067130000,13),(452,1080435600,12),(452,1099184400,13),(452,1111885200,12),(452,1130634000,13),(452,1143334800,12),(452,1162083600,13),(452,1174784400,12),(452,1193533200,13),(452,1206838800,12),(452,1224982800,13),(452,1238288400,12),(452,1256432400,13),(452,1269738000,12),(452,1288486800,13),(452,1301187600,12),(452,1319936400,13),(452,1332637200,12),(452,1351386000,13),(452,1364691600,12),(452,1382835600,13),(452,1396141200,12),(452,1414285200,13),(452,1427590800,12),(452,1445734800,13),(452,1459040400,12),(452,1477789200,13),(452,1490490000,12),(452,1509238800,13),(452,1521939600,12),(452,1540688400,13),(452,1553994000,12),(452,1572138000,13),(452,1585443600,12),(452,1603587600,13),(452,1616893200,12),(452,1635642000,13),(452,1648342800,12),(452,1667091600,13),(452,1679792400,12),(452,1698541200,13),(452,1711846800,12),(452,1729990800,13),(452,1743296400,12),(452,1761440400,13),(452,1774746000,12),(452,1792890000,13),(452,1806195600,12),(452,1824944400,13),(452,1837645200,12),(452,1856394000,13),(452,1869094800,12),(452,1887843600,13),(452,1901149200,12),(452,1919293200,13),(452,1932598800,12),(452,1950742800,13),(452,1964048400,12),(452,1982797200,13),(452,1995498000,12),(452,2014246800,13),(452,2026947600,12),(452,2045696400,13),(452,2058397200,12),(452,2077146000,13),(452,2090451600,12),(452,2108595600,13),(452,2121901200,12),(452,2140045200,13),(453,-2147483648,4),(453,-1631926800,1),(453,-1616889600,2),(453,-1601168400,1),(453,-1585353600,2),(453,-1442451600,1),(453,-1427673600,2),(453,-1379293200,1),(453,-1364774400,2),(453,-1348448400,1),(453,-1333324800,2),(453,-1316390400,1),(453,-1301270400,2),(453,-1284339600,1),(453,-1269820800,2),(453,-1026954000,1),(453,-1017619200,2),(453,-1001898000,1),(453,-999482400,3),(453,-986090400,1),(453,-954115200,2),(453,-940208400,6),(453,-873079200,5),(453,-862621200,6),(453,-842839200,5),(453,-828320400,6),(453,-811389600,5),(453,-796870800,6),(453,-779940000,5),(453,-765421200,6),(453,-748490400,5),(453,-733971600,6),(453,-652327200,5),(453,-639018000,6),(453,135122400,5),(453,150246000,6),(453,166572000,5),(453,181695600,6),(453,196812000,5),(453,212540400,6),(453,228866400,5),(453,243990000,6),(453,260326800,7),(453,276051600,8),(453,283993200,6),(453,291776400,9),(453,307501200,10),(453,323830800,9),(453,338950800,10),(453,354675600,9),(453,370400400,10),(453,386125200,9),(453,401850000,10),(453,417574800,9),(453,433299600,10),(453,449024400,9),(453,465354000,10),(453,481078800,9),(453,496803600,10),(453,512528400,9),(453,528253200,10),(453,543978000,9),(453,559702800,10),(453,575427600,9),(453,591152400,10),(453,606877200,9),(453,622602000,10),(453,638326800,9),(453,654656400,10),(453,670381200,9),(453,686106000,10),(453,701830800,9),(453,717555600,10),(453,733280400,9),(453,749005200,10),(453,764730000,9),(453,780454800,10),(453,796179600,9),(453,811904400,10),(453,828234000,9),(453,846378000,10),(453,859683600,9),(453,877827600,10),(453,891133200,9),(453,909277200,10),(453,922582800,9),(453,941331600,10),(453,954032400,9),(453,972781200,10),(453,985482000,9),(453,1004230800,10),(453,1017536400,9),(453,1035680400,10),(453,1048986000,9),(453,1067130000,10),(453,1080435600,9),(453,1099184400,10),(453,1111885200,9),(453,1130634000,10),(453,1143334800,9),(453,1162083600,10),(453,1174784400,9),(453,1193533200,10),(453,1206838800,9),(453,1224982800,10),(453,1238288400,9),(453,1256432400,10),(453,1269738000,9),(453,1288486800,10),(453,1301187600,9),(453,1319936400,10),(453,1332637200,9),(453,1351386000,10),(453,1364691600,9),(453,1382835600,10),(453,1396141200,9),(453,1414285200,10),(453,1427590800,9),(453,1445734800,10),(453,1459040400,9),(453,1477789200,10),(453,1490490000,9),(453,1509238800,10),(453,1521939600,9),(453,1540688400,10),(453,1553994000,9),(453,1572138000,10),(453,1585443600,9),(453,1603587600,10),(453,1616893200,9),(453,1635642000,10),(453,1648342800,9),(453,1667091600,10),(453,1679792400,9),(453,1698541200,10),(453,1711846800,9),(453,1729990800,10),(453,1743296400,9),(453,1761440400,10),(453,1774746000,9),(453,1792890000,10),(453,1806195600,9),(453,1824944400,10),(453,1837645200,9),(453,1856394000,10),(453,1869094800,9),(453,1887843600,10),(453,1901149200,9),(453,1919293200,10),(453,1932598800,9),(453,1950742800,10),(453,1964048400,9),(453,1982797200,10),(453,1995498000,9),(453,2014246800,10),(453,2026947600,9),(453,2045696400,10),(453,2058397200,9),(453,2077146000,10),(453,2090451600,9),(453,2108595600,10),(453,2121901200,9),(453,2140045200,10),(454,-2147483648,3),(454,-1690765200,1),(454,-1680487200,2),(454,-1664758800,1),(454,-1648951200,2),(454,-1635123600,1),(454,-1616896800,2),(454,-1604278800,1),(454,-1585533600,2),(454,-1571014800,1),(454,-1555293600,2),(454,-932432400,1),(454,-857257200,3),(454,-844556400,4),(454,-828226800,3),(454,-812588400,4),(454,-798073200,3),(454,-781052400,1),(454,-766717200,2),(454,-750898800,4),(454,-733359600,3),(454,-719456400,4),(454,-701917200,3),(454,-689209200,4),(454,-670460400,3),(454,-114051600,4),(454,-103168800,2),(454,-81997200,4),(454,-71715600,3),(454,-50547600,4),(454,-40266000,3),(454,-18493200,4),(454,-8211600,3),(454,12956400,4),(454,23238000,3),(454,43801200,4),(454,54687600,3),(454,75855600,4),(454,86742000,3),(454,102380400,4),(454,118105200,3),(454,135730800,4),(454,148518000,3),(454,167187600,1),(454,180489600,2),(454,198637200,1),(454,211939200,2),(454,230086800,1),(454,243388800,2),(454,261536400,1),(454,274838400,2),(454,292986000,1),(454,306288000,2),(454,323312400,1),(454,338342400,2),(454,354675600,5),(454,370400400,6),(454,386125200,5),(454,401850000,6),(454,417574800,5),(454,433299600,6),(454,449024400,5),(454,465354000,6),(454,481078800,5),(454,496803600,6),(454,512528400,5),(454,528253200,6),(454,543978000,5),(454,559702800,6),(454,575427600,5),(454,591152400,6),(454,606877200,5),(454,622602000,6),(454,638326800,5),(454,654656400,6),(454,670381200,5),(454,686106000,6),(454,701830800,5),(454,717555600,6),(454,733280400,5),(454,749005200,6),(454,764730000,5),(454,780454800,6),(454,796179600,5),(454,811904400,6),(454,828234000,5),(454,846378000,6),(454,859683600,5),(454,877827600,6),(454,891133200,5),(454,909277200,6),(454,922582800,5),(454,941331600,6),(454,954032400,5),(454,972781200,6),(454,985482000,5),(454,1004230800,6),(454,1017536400,5),(454,1035680400,6),(454,1048986000,5),(454,1067130000,6),(454,1080435600,5),(454,1099184400,6),(454,1111885200,5),(454,1130634000,6),(454,1143334800,5),(454,1162083600,6),(454,1174784400,5),(454,1193533200,6),(454,1206838800,5),(454,1224982800,6),(454,1238288400,5),(454,1256432400,6),(454,1269738000,5),(454,1288486800,6),(454,1301187600,5),(454,1319936400,6),(454,1332637200,5),(454,1351386000,6),(454,1364691600,5),(454,1382835600,6),(454,1396141200,5),(454,1414285200,6),(454,1427590800,5),(454,1445734800,6),(454,1459040400,5),(454,1477789200,6),(454,1490490000,5),(454,1509238800,6),(454,1521939600,5),(454,1540688400,6),(454,1553994000,5),(454,1572138000,6),(454,1585443600,5),(454,1603587600,6),(454,1616893200,5),(454,1635642000,6),(454,1648342800,5),(454,1667091600,6),(454,1679792400,5),(454,1698541200,6),(454,1711846800,5),(454,1729990800,6),(454,1743296400,5),(454,1761440400,6),(454,1774746000,5),(454,1792890000,6),(454,1806195600,5),(454,1824944400,6),(454,1837645200,5),(454,1856394000,6),(454,1869094800,5),(454,1887843600,6),(454,1901149200,5),(454,1919293200,6),(454,1932598800,5),(454,1950742800,6),(454,1964048400,5),(454,1982797200,6),(454,1995498000,5),(454,2014246800,6),(454,2026947600,5),(454,2045696400,6),(454,2058397200,5),(454,2077146000,6),(454,2090451600,5),(454,2108595600,6),(454,2121901200,5),(454,2140045200,6),(455,-2147483648,1),(455,-1535938789,3),(455,-875671200,2),(455,-859773600,3),(455,354672000,2),(455,370396800,3),(455,386121600,2),(455,401846400,3),(455,417574800,4),(455,433299600,5),(455,449024400,4),(455,465354000,5),(455,481078800,4),(455,496803600,5),(455,512528400,4),(455,528253200,5),(455,543978000,4),(455,559702800,5),(455,575427600,4),(455,591152400,5),(455,606877200,4),(455,622602000,5),(455,638326800,4),(455,654656400,5),(455,670381200,4),(455,686106000,5),(455,701830800,4),(455,717555600,5),(455,733280400,4),(455,749005200,5),(455,764730000,4),(455,780454800,5),(455,796179600,4),(455,811904400,5),(455,828234000,4),(455,846378000,5),(455,859683600,4),(455,877827600,5),(455,891133200,4),(455,909277200,5),(455,922582800,4),(455,941331600,5),(455,954032400,4),(455,972781200,5),(455,985482000,4),(455,1004230800,5),(455,1017536400,4),(455,1035680400,5),(455,1048986000,4),(455,1067130000,5),(455,1080435600,4),(455,1099184400,5),(455,1111885200,4),(455,1130634000,5),(455,1143334800,4),(455,1162083600,5),(455,1174784400,4),(455,1193533200,5),(455,1206838800,4),(455,1224982800,5),(455,1238288400,4),(455,1256432400,5),(455,1269738000,4),(455,1288486800,5),(455,1301187600,4),(455,1319936400,5),(455,1332637200,4),(455,1351386000,5),(455,1364691600,4),(455,1382835600,5),(455,1396141200,4),(455,1414285200,5),(455,1427590800,4),(455,1445734800,5),(455,1459040400,4),(455,1477789200,5),(455,1490490000,4),(455,1509238800,5),(455,1521939600,4),(455,1540688400,5),(455,1553994000,4),(455,1572138000,5),(455,1585443600,4),(455,1603587600,5),(455,1616893200,4),(455,1635642000,5),(455,1648342800,4),(455,1667091600,5),(455,1679792400,4),(455,1698541200,5),(455,1711846800,4),(455,1729990800,5),(455,1743296400,4),(455,1761440400,5),(455,1774746000,4),(455,1792890000,5),(455,1806195600,4),(455,1824944400,5),(455,1837645200,4),(455,1856394000,5),(455,1869094800,4),(455,1887843600,5),(455,1901149200,4),(455,1919293200,5),(455,1932598800,4),(455,1950742800,5),(455,1964048400,4),(455,1982797200,5),(455,1995498000,4),(455,2014246800,5),(455,2026947600,4),(455,2045696400,5),(455,2058397200,4),(455,2077146000,5),(455,2090451600,4),(455,2108595600,5),(455,2121901200,4),(455,2140045200,5),(456,-2147483648,1),(456,-1441158600,2),(456,-1247536800,3),(456,-899780400,6),(456,-857257200,4),(456,-844556400,5),(456,-828226800,4),(456,-812502000,5),(456,-804650400,3),(456,354920400,7),(456,370728000,3),(456,386456400,7),(456,402264000,3),(456,417992400,7),(456,433800000,3),(456,449614800,7),(456,465346800,8),(456,481071600,9),(456,496796400,8),(456,512521200,9),(456,528246000,8),(456,543970800,9),(456,559695600,8),(456,575420400,9),(456,591145200,8),(456,606870000,9),(456,622594800,8),(456,631141200,3),(456,670374000,10),(456,686102400,11),(456,701827200,10),(456,717552000,11),(456,733276800,10),(456,749001600,11),(456,764726400,10),(456,780451200,11),(456,796176000,10),(456,811900800,11),(456,828230400,10),(456,846374400,11),(456,859680000,10),(456,877824000,11),(456,891129600,10),(456,909273600,11),(456,922579200,10),(456,941328000,11),(456,954028800,10),(456,972777600,11),(456,985478400,10),(456,1004227200,11),(456,1017532800,10),(456,1035676800,11),(456,1048982400,10),(456,1067126400,11),(456,1080432000,10),(456,1099180800,11),(456,1111881600,10),(456,1130630400,11),(456,1143331200,10),(456,1162080000,11),(456,1174780800,10),(456,1193529600,11),(456,1206835200,10),(456,1224979200,11),(456,1238284800,10),(456,1256428800,11),(456,1269734400,10),(456,1288483200,11),(456,1301184000,12),(456,2147483647,12),(457,-2147483648,1),(457,-1855958961,6),(457,-1689814800,2),(457,-1680397200,3),(457,-1665363600,2),(457,-1648342800,3),(457,-1635123600,2),(457,-1616893200,3),(457,-1604278800,2),(457,-1585443600,3),(457,-1574038800,2),(457,-1552266000,3),(457,-1539997200,2),(457,-1520557200,3),(457,-1507510800,2),(457,-1490576400,3),(457,-1470618000,2),(457,-1459126800,3),(457,-1444006800,2),(457,-1427677200,3),(457,-1411952400,2),(457,-1396227600,3),(457,-1379293200,2),(457,-1364778000,3),(457,-1348448400,2),(457,-1333328400,3),(457,-1316394000,2),(457,-1301274000,3),(457,-1284339600,2),(457,-1269824400,3),(457,-1253494800,2),(457,-1238374800,3),(457,-1221440400,2),(457,-1206925200,3),(457,-1191200400,2),(457,-1175475600,3),(457,-1160355600,2),(457,-1143421200,3),(457,-1127696400,2),(457,-1111971600,3),(457,-1096851600,2),(457,-1080522000,3),(457,-1063587600,2),(457,-1049072400,3),(457,-1033347600,2),(457,-1017622800,3),(457,-1002502800,2),(457,-986173200,3),(457,-969238800,2),(457,-950490000,3),(457,-942012000,4),(457,-904438800,5),(457,-891136800,4),(457,-877827600,5),(457,-857257200,4),(457,-844556400,5),(457,-828226800,4),(457,-812502000,5),(457,-796266000,4),(457,-781052400,5),(457,-766623600,8),(457,196819200,7),(457,212540400,8),(457,228877200,9),(457,243997200,10),(457,260326800,9),(457,276051600,10),(457,291776400,9),(457,307501200,10),(457,323830800,9),(457,338950800,10),(457,354675600,9),(457,370400400,10),(457,386125200,9),(457,401850000,10),(457,417574800,9),(457,433299600,10),(457,449024400,9),(457,465354000,10),(457,481078800,9),(457,496803600,10),(457,512528400,9),(457,528253200,10),(457,543978000,9),(457,559702800,10),(457,575427600,9),(457,591152400,10),(457,606877200,9),(457,622602000,10),(457,638326800,9),(457,654656400,10),(457,670381200,9),(457,686106000,10),(457,701830800,9),(457,717555600,10),(457,733280400,9),(457,749005200,10),(457,764730000,9),(457,780454800,10),(457,796179600,9),(457,811904400,10),(457,828234000,9),(457,846378000,10),(457,859683600,9),(457,877827600,10),(457,891133200,9),(457,909277200,10),(457,922582800,9),(457,941331600,10),(457,954032400,9),(457,972781200,10),(457,985482000,9),(457,1004230800,10),(457,1017536400,9),(457,1035680400,10),(457,1048986000,9),(457,1067130000,10),(457,1080435600,9),(457,1099184400,10),(457,1111885200,9),(457,1130634000,10),(457,1143334800,9),(457,1162083600,10),(457,1174784400,9),(457,1193533200,10),(457,1206838800,9),(457,1224982800,10),(457,1238288400,9),(457,1256432400,10),(457,1269738000,9),(457,1288486800,10),(457,1301187600,9),(457,1319936400,10),(457,1332637200,9),(457,1351386000,10),(457,1364691600,9),(457,1382835600,10),(457,1396141200,9),(457,1414285200,10),(457,1427590800,9),(457,1445734800,10),(457,1459040400,9),(457,1477789200,10),(457,1490490000,9),(457,1509238800,10),(457,1521939600,9),(457,1540688400,10),(457,1553994000,9),(457,1572138000,10),(457,1585443600,9),(457,1603587600,10),(457,1616893200,9),(457,1635642000,10),(457,1648342800,9),(457,1667091600,10),(457,1679792400,9),(457,1698541200,10),(457,1711846800,9),(457,1729990800,10),(457,1743296400,9),(457,1761440400,10),(457,1774746000,9),(457,1792890000,10),(457,1806195600,9),(457,1824944400,10),(457,1837645200,9),(457,1856394000,10),(457,1869094800,9),(457,1887843600,10),(457,1901149200,9),(457,1919293200,10),(457,1932598800,9),(457,1950742800,10),(457,1964048400,9),(457,1982797200,10),(457,1995498000,9),(457,2014246800,10),(457,2026947600,9),(457,2045696400,10),(457,2058397200,9),(457,2077146000,10),(457,2090451600,9),(457,2108595600,10),(457,2121901200,9),(457,2140045200,10),(458,-2147483648,1),(458,-1688265017,3),(458,-1656819079,2),(458,-1641353479,3),(458,-1627965079,4),(458,-1618716679,2),(458,-1596429079,4),(458,-1593820800,5),(458,-1589860800,6),(458,-1542427200,7),(458,-1539493200,8),(458,-1525323600,7),(458,-1522728000,6),(458,-1491188400,9),(458,-1247536800,6),(458,354920400,7),(458,370728000,6),(458,386456400,7),(458,402264000,6),(458,417992400,7),(458,433800000,6),(458,449614800,7),(458,465346800,10),(458,481071600,11),(458,496796400,10),(458,512521200,11),(458,528246000,10),(458,543970800,11),(458,559695600,10),(458,575420400,11),(458,591145200,10),(458,606870000,11),(458,622594800,10),(458,638319600,11),(458,654649200,10),(458,670374000,12),(458,686102400,13),(458,695779200,10),(458,701823600,11),(458,717548400,10),(458,733273200,11),(458,748998000,10),(458,764722800,11),(458,780447600,10),(458,796172400,11),(458,811897200,10),(458,828226800,11),(458,846370800,10),(458,859676400,11),(458,877820400,10),(458,891126000,11),(458,909270000,10),(458,922575600,11),(458,941324400,10),(458,954025200,11),(458,972774000,10),(458,985474800,11),(458,1004223600,10),(458,1017529200,11),(458,1035673200,10),(458,1048978800,11),(458,1067122800,10),(458,1080428400,11),(458,1099177200,10),(458,1111878000,11),(458,1130626800,10),(458,1143327600,11),(458,1162076400,10),(458,1174777200,11),(458,1193526000,10),(458,1206831600,11),(458,1224975600,10),(458,1238281200,11),(458,1256425200,10),(458,1269730800,11),(458,1288479600,10),(458,1301180400,14),(458,1414274400,10),(459,-2147483648,0),(459,-1518920008,2),(459,166572000,1),(459,182293200,2),(459,200959200,1),(459,213829200,2),(459,228866400,1),(459,243982800,2),(459,260316000,1),(459,276123600,2),(459,291765600,1),(459,307486800,2),(459,323820000,1),(459,338936400,2),(459,354664800,1),(459,370386000,2),(459,386114400,1),(459,401835600,2),(459,417564000,1),(459,433285200,2),(459,449013600,1),(459,465339600,2),(459,481068000,1),(459,496789200,2),(459,512517600,1),(459,528238800,2),(459,543967200,1),(459,559688400,2),(459,575416800,1),(459,591138000,2),(459,606866400,1),(459,622587600,2),(459,638316000,1),(459,654642000,2),(459,670370400,1),(459,686091600,2),(459,701820000,1),(459,717541200,2),(459,733269600,1),(459,748990800,2),(459,764719200,1),(459,780440400,2),(459,796168800,1),(459,811890000,2),(459,828223200,1),(459,843944400,2),(459,859672800,1),(459,875394000,2),(459,891122400,1),(459,909277200,3),(459,922582800,4),(459,941331600,3),(459,954032400,4),(459,972781200,3),(459,985482000,4),(459,1004230800,3),(459,1017536400,4),(459,1035680400,3),(459,1048986000,4),(459,1067130000,3),(459,1080435600,4),(459,1099184400,3),(459,1111885200,4),(459,1130634000,3),(459,1143334800,4),(459,1162083600,3),(459,1174784400,4),(459,1193533200,3),(459,1206838800,4),(459,1224982800,3),(459,1238288400,4),(459,1256432400,3),(459,1269738000,4),(459,1288486800,3),(459,1301187600,4),(459,1319936400,3),(459,1332637200,4),(459,1351386000,3),(459,1364691600,4),(459,1382835600,3),(459,1396141200,4),(459,1414285200,3),(459,1427590800,4),(459,1445734800,3),(459,1459040400,4),(459,1477789200,3),(459,1490490000,4),(459,1509238800,3),(459,1521939600,4),(459,1540688400,3),(459,1553994000,4),(459,1572138000,3),(459,1585443600,4),(459,1603587600,3),(459,1616893200,4),(459,1635642000,3),(459,1648342800,4),(459,1667091600,3),(459,1679792400,4),(459,1698541200,3),(459,1711846800,4),(459,1729990800,3),(459,1743296400,4),(459,1761440400,3),(459,1774746000,4),(459,1792890000,3),(459,1806195600,4),(459,1824944400,3),(459,1837645200,4),(459,1856394000,3),(459,1869094800,4),(459,1887843600,3),(459,1901149200,4),(459,1919293200,3),(459,1932598800,4),(459,1950742800,3),(459,1964048400,4),(459,1982797200,3),(459,1995498000,4),(459,2014246800,3),(459,2026947600,4),(459,2045696400,3),(459,2058397200,4),(459,2077146000,3),(459,2090451600,4),(459,2108595600,3),(459,2121901200,4),(459,2140045200,3),(460,-2147483648,2),(460,-1691884800,1),(460,-1680573600,2),(460,-927511200,1),(460,-857257200,3),(460,-844556400,4),(460,-828226800,3),(460,-812502000,4),(460,-796777200,3),(460,-781052400,4),(460,-765327600,3),(460,-340844400,4),(460,-324514800,3),(460,-308790000,4),(460,-293065200,3),(460,-277340400,4),(460,-261615600,3),(460,-245890800,4),(460,-230166000,3),(460,-214441200,4),(460,-198716400,3),(460,-182991600,4),(460,-166662000,3),(460,-147913200,4),(460,-135212400,3),(460,315529200,2),(460,323830800,5),(460,338950800,6),(460,354675600,5),(460,370400400,6),(460,386125200,5),(460,401850000,6),(460,417574800,5),(460,433299600,6),(460,449024400,5),(460,465354000,6),(460,481078800,5),(460,496803600,6),(460,512528400,5),(460,528253200,6),(460,543978000,5),(460,559702800,6),(460,575427600,5),(460,591152400,6),(460,606877200,5),(460,622602000,6),(460,638326800,5),(460,654656400,6),(460,670381200,5),(460,686106000,6),(460,701830800,5),(460,717555600,6),(460,733280400,5),(460,749005200,6),(460,764730000,5),(460,780454800,6),(460,796179600,5),(460,811904400,6),(460,828234000,5),(460,846378000,6),(460,859683600,5),(460,877827600,6),(460,891133200,5),(460,909277200,6),(460,922582800,5),(460,941331600,6),(460,954032400,5),(460,972781200,6),(460,985482000,5),(460,1004230800,6),(460,1017536400,5),(460,1035680400,6),(460,1048986000,5),(460,1067130000,6),(460,1080435600,5),(460,1099184400,6),(460,1111885200,5),(460,1130634000,6),(460,1143334800,5),(460,1162083600,6),(460,1174784400,5),(460,1193533200,6),(460,1206838800,5),(460,1224982800,6),(460,1238288400,5),(460,1256432400,6),(460,1269738000,5),(460,1288486800,6),(460,1301187600,5),(460,1319936400,6),(460,1332637200,5),(460,1351386000,6),(460,1364691600,5),(460,1382835600,6),(460,1396141200,5),(460,1414285200,6),(460,1427590800,5),(460,1445734800,6),(460,1459040400,5),(460,1477789200,6),(460,1490490000,5),(460,1509238800,6),(460,1521939600,5),(460,1540688400,6),(460,1553994000,5),(460,1572138000,6),(460,1585443600,5),(460,1603587600,6),(460,1616893200,5),(460,1635642000,6),(460,1648342800,5),(460,1667091600,6),(460,1679792400,5),(460,1698541200,6),(460,1711846800,5),(460,1729990800,6),(460,1743296400,5),(460,1761440400,6),(460,1774746000,5),(460,1792890000,6),(460,1806195600,5),(460,1824944400,6),(460,1837645200,5),(460,1856394000,6),(460,1869094800,5),(460,1887843600,6),(460,1901149200,5),(460,1919293200,6),(460,1932598800,5),(460,1950742800,6),(460,1964048400,5),(460,1982797200,6),(460,1995498000,5),(460,2014246800,6),(460,2026947600,5),(460,2045696400,6),(460,2058397200,5),(460,2077146000,6),(460,2090451600,5),(460,2108595600,6),(460,2121901200,5),(460,2140045200,6),(461,-2147483648,1),(461,-1855958901,5),(461,-1689814800,2),(461,-1680397200,3),(461,-1665363600,2),(461,-1648342800,3),(461,-1635123600,2),(461,-1616893200,3),(461,-1604278800,2),(461,-1585443600,3),(461,-1574038800,2),(461,-1552266000,3),(461,-1539997200,2),(461,-1520557200,3),(461,-1507510800,2),(461,-1490576400,3),(461,-1470618000,2),(461,-1459126800,3),(461,-1444006800,2),(461,-1427677200,3),(461,-1411952400,2),(461,-1396227600,3),(461,-1379293200,2),(461,-1364778000,3),(461,-1348448400,2),(461,-1333328400,3),(461,-1316394000,2),(461,-1301274000,3),(461,-1284339600,2),(461,-1269824400,3),(461,-1253494800,2),(461,-1238374800,3),(461,-1221440400,2),(461,-1206925200,3),(461,-1191200400,2),(461,-1175475600,3),(461,-1160355600,2),(461,-1143421200,3),(461,-1127696400,2),(461,-1111971600,3),(461,-1096851600,2),(461,-1080522000,3),(461,-1063587600,2),(461,-1049072400,3),(461,-1033347600,2),(461,-1017622800,3),(461,-1002502800,2),(461,-986173200,3),(461,-969238800,2),(461,-950490000,3),(461,-942012000,4),(461,-932436000,8),(461,-857257200,6),(461,-844556400,7),(461,-828226800,6),(461,-812502000,7),(461,-800071200,9),(461,-796266000,4),(461,-781052400,9),(461,-766623600,10),(461,196819200,8),(461,212540400,10),(461,228877200,11),(461,243997200,12),(461,260326800,11),(461,276051600,12),(461,291776400,11),(461,307501200,12),(461,323830800,11),(461,338950800,12),(461,354675600,11),(461,370400400,12),(461,386125200,11),(461,401850000,12),(461,417574800,11),(461,433299600,12),(461,449024400,11),(461,465354000,12),(461,481078800,11),(461,496803600,12),(461,512528400,11),(461,528253200,12),(461,543978000,11),(461,559702800,12),(461,575427600,11),(461,591152400,12),(461,606877200,11),(461,622602000,12),(461,638326800,11),(461,654656400,12),(461,670381200,11),(461,686106000,12),(461,701830800,11),(461,717555600,12),(461,733280400,11),(461,749005200,12),(461,764730000,11),(461,780454800,12),(461,796179600,11),(461,811904400,12),(461,828234000,11),(461,846378000,12),(461,859683600,11),(461,877827600,12),(461,891133200,11),(461,909277200,12),(461,922582800,11),(461,941331600,12),(461,954032400,11),(461,972781200,12),(461,985482000,11),(461,1004230800,12),(461,1017536400,11),(461,1035680400,12),(461,1048986000,11),(461,1067130000,12),(461,1080435600,11),(461,1099184400,12),(461,1111885200,11),(461,1130634000,12),(461,1143334800,11),(461,1162083600,12),(461,1174784400,11),(461,1193533200,12),(461,1206838800,11),(461,1224982800,12),(461,1238288400,11),(461,1256432400,12),(461,1269738000,11),(461,1288486800,12),(461,1301187600,11),(461,1319936400,12),(461,1332637200,11),(461,1351386000,12),(461,1364691600,11),(461,1382835600,12),(461,1396141200,11),(461,1414285200,12),(461,1427590800,11),(461,1445734800,12),(461,1459040400,11),(461,1477789200,12),(461,1490490000,11),(461,1509238800,12),(461,1521939600,11),(461,1540688400,12),(461,1553994000,11),(461,1572138000,12),(461,1585443600,11),(461,1603587600,12),(461,1616893200,11),(461,1635642000,12),(461,1648342800,11),(461,1667091600,12),(461,1679792400,11),(461,1698541200,12),(461,1711846800,11),(461,1729990800,12),(461,1743296400,11),(461,1761440400,12),(461,1774746000,11),(461,1792890000,12),(461,1806195600,11),(461,1824944400,12),(461,1837645200,11),(461,1856394000,12),(461,1869094800,11),(461,1887843600,12),(461,1901149200,11),(461,1919293200,12),(461,1932598800,11),(461,1950742800,12),(461,1964048400,11),(461,1982797200,12),(461,1995498000,11),(461,2014246800,12),(461,2026947600,11),(461,2045696400,12),(461,2058397200,11),(461,2077146000,12),(461,2090451600,11),(461,2108595600,12),(461,2121901200,11),(461,2140045200,12),(462,-2147483648,1),(462,-905824800,4),(462,-857257200,2),(462,-844556400,3),(462,-828226800,2),(462,-812502000,3),(462,-796777200,2),(462,-788922000,1),(462,-777942000,3),(462,-766623600,2),(462,407199600,1),(462,417574800,5),(462,433299600,6),(462,449024400,5),(462,465354000,6),(462,481078800,5),(462,496803600,6),(462,512528400,5),(462,528253200,6),(462,543978000,5),(462,559702800,6),(462,575427600,5),(462,591152400,6),(462,606877200,5),(462,622602000,6),(462,638326800,5),(462,654656400,6),(462,670381200,5),(462,686106000,6),(462,701830800,5),(462,717555600,6),(462,733280400,5),(462,749005200,6),(462,764730000,5),(462,780454800,6),(462,796179600,5),(462,811904400,6),(462,828234000,5),(462,846378000,6),(462,859683600,5),(462,877827600,6),(462,891133200,5),(462,909277200,6),(462,922582800,5),(462,941331600,6),(462,954032400,5),(462,972781200,6),(462,985482000,5),(462,1004230800,6),(462,1017536400,5),(462,1035680400,6),(462,1048986000,5),(462,1067130000,6),(462,1080435600,5),(462,1099184400,6),(462,1111885200,5),(462,1130634000,6),(462,1143334800,5),(462,1162083600,6),(462,1174784400,5),(462,1193533200,6),(462,1206838800,5),(462,1224982800,6),(462,1238288400,5),(462,1256432400,6),(462,1269738000,5),(462,1288486800,6),(462,1301187600,5),(462,1319936400,6),(462,1332637200,5),(462,1351386000,6),(462,1364691600,5),(462,1382835600,6),(462,1396141200,5),(462,1414285200,6),(462,1427590800,5),(462,1445734800,6),(462,1459040400,5),(462,1477789200,6),(462,1490490000,5),(462,1509238800,6),(462,1521939600,5),(462,1540688400,6),(462,1553994000,5),(462,1572138000,6),(462,1585443600,5),(462,1603587600,6),(462,1616893200,5),(462,1635642000,6),(462,1648342800,5),(462,1667091600,6),(462,1679792400,5),(462,1698541200,6),(462,1711846800,5),(462,1729990800,6),(462,1743296400,5),(462,1761440400,6),(462,1774746000,5),(462,1792890000,6),(462,1806195600,5),(462,1824944400,6),(462,1837645200,5),(462,1856394000,6),(462,1869094800,5),(462,1887843600,6),(462,1901149200,5),(462,1919293200,6),(462,1932598800,5),(462,1950742800,6),(462,1964048400,5),(462,1982797200,6),(462,1995498000,5),(462,2014246800,6),(462,2026947600,5),(462,2045696400,6),(462,2058397200,5),(462,2077146000,6),(462,2090451600,5),(462,2108595600,6),(462,2121901200,5),(462,2140045200,6),(463,-2147483648,2),(463,-1693706400,1),(463,-1680483600,2),(463,-1663455600,3),(463,-1650150000,4),(463,-1632006000,3),(463,-1618700400,4),(463,-938905200,3),(463,-857257200,4),(463,-844556400,3),(463,-828226800,4),(463,-812502000,3),(463,-796777200,4),(463,-781052400,3),(463,-777866400,1),(463,-765327600,4),(463,-746578800,3),(463,-733359600,4),(463,-728517600,5),(463,-721260000,2),(463,-716425200,3),(463,-701910000,4),(463,-684975600,3),(463,-670460400,4),(463,-654217200,3),(463,-639010800,4),(463,283993200,2),(463,291776400,6),(463,307501200,7),(463,323830800,6),(463,338950800,7),(463,354675600,6),(463,370400400,7),(463,386125200,6),(463,401850000,7),(463,417574800,6),(463,433299600,7),(463,449024400,6),(463,465354000,7),(463,481078800,6),(463,496803600,7),(463,512528400,6),(463,528253200,7),(463,543978000,6),(463,559702800,7),(463,575427600,6),(463,591152400,7),(463,606877200,6),(463,622602000,7),(463,638326800,6),(463,654656400,7),(463,670381200,6),(463,686106000,7),(463,701830800,6),(463,717555600,7),(463,733280400,6),(463,749005200,7),(463,764730000,6),(463,780454800,7),(463,796179600,6),(463,811904400,7),(463,828234000,6),(463,846378000,7),(463,859683600,6),(463,877827600,7),(463,891133200,6),(463,909277200,7),(463,922582800,6),(463,941331600,7),(463,954032400,6),(463,972781200,7),(463,985482000,6),(463,1004230800,7),(463,1017536400,6),(463,1035680400,7),(463,1048986000,6),(463,1067130000,7),(463,1080435600,6),(463,1099184400,7),(463,1111885200,6),(463,1130634000,7),(463,1143334800,6),(463,1162083600,7),(463,1174784400,6),(463,1193533200,7),(463,1206838800,6),(463,1224982800,7),(463,1238288400,6),(463,1256432400,7),(463,1269738000,6),(463,1288486800,7),(463,1301187600,6),(463,1319936400,7),(463,1332637200,6),(463,1351386000,7),(463,1364691600,6),(463,1382835600,7),(463,1396141200,6),(463,1414285200,7),(463,1427590800,6),(463,1445734800,7),(463,1459040400,6),(463,1477789200,7),(463,1490490000,6),(463,1509238800,7),(463,1521939600,6),(463,1540688400,7),(463,1553994000,6),(463,1572138000,7),(463,1585443600,6),(463,1603587600,7),(463,1616893200,6),(463,1635642000,7),(463,1648342800,6),(463,1667091600,7),(463,1679792400,6),(463,1698541200,7),(463,1711846800,6),(463,1729990800,7),(463,1743296400,6),(463,1761440400,7),(463,1774746000,6),(463,1792890000,7),(463,1806195600,6),(463,1824944400,7),(463,1837645200,6),(463,1856394000,7),(463,1869094800,6),(463,1887843600,7),(463,1901149200,6),(463,1919293200,7),(463,1932598800,6),(463,1950742800,7),(463,1964048400,6),(463,1982797200,7),(463,1995498000,6),(463,2014246800,7),(463,2026947600,6),(463,2045696400,7),(463,2058397200,6),(463,2077146000,7),(463,2090451600,6),(463,2108595600,7),(463,2121901200,6),(463,2140045200,7),(464,-2147483648,1),(464,-1632008194,2),(464,-1618702594,1),(464,-1601681794,2),(464,-1597275394,1),(464,-1377308194,3),(464,-928029600,4),(464,-899521200,7),(464,-857257200,5),(464,-844556400,6),(464,-828226800,5),(464,-812502000,6),(464,-796777200,5),(464,-795834000,4),(464,354920400,8),(464,370728000,4),(464,386456400,8),(464,402264000,4),(464,417992400,8),(464,433800000,4),(464,449614800,8),(464,465346800,9),(464,481071600,10),(464,496796400,9),(464,512521200,10),(464,528246000,9),(464,543970800,10),(464,559695600,9),(464,575420400,10),(464,591145200,9),(464,606870000,11),(464,622598400,12),(464,638323200,11),(464,654652800,12),(464,670377600,11),(464,686102400,12),(464,701827200,11),(464,717552000,12),(464,733276800,11),(464,749001600,12),(464,764726400,11),(464,780451200,12),(464,796176000,11),(464,811900800,12),(464,828230400,11),(464,843955200,12),(464,853797600,3),(464,859683600,13),(464,877827600,14),(464,891133200,13),(464,909277200,14),(464,922582800,13),(464,941331600,14),(464,951775200,3),(464,985482000,13),(464,1004230800,14),(464,1017536400,13),(464,1035680400,14),(464,1048986000,13),(464,1067130000,14),(464,1080435600,13),(464,1099184400,14),(464,1111885200,13),(464,1130634000,14),(464,1143334800,13),(464,1162083600,14),(464,1174784400,13),(464,1193533200,14),(464,1206838800,13),(464,1224982800,14),(464,1238288400,13),(464,1256432400,14),(464,1269738000,13),(464,1288486800,14),(464,1301187600,13),(464,1319936400,14),(464,1332637200,13),(464,1351386000,14),(464,1364691600,13),(464,1382835600,14),(464,1396141200,13),(464,1414285200,14),(464,1427590800,13),(464,1445734800,14),(464,1459040400,13),(464,1477789200,14),(464,1490490000,13),(464,1509238800,14),(464,1521939600,13),(464,1540688400,14),(464,1553994000,13),(464,1572138000,14),(464,1585443600,13),(464,1603587600,14),(464,1616893200,13),(464,1635642000,14),(464,1648342800,13),(464,1667091600,14),(464,1679792400,13),(464,1698541200,14),(464,1711846800,13),(464,1729990800,14),(464,1743296400,13),(464,1761440400,14),(464,1774746000,13),(464,1792890000,14),(464,1806195600,13),(464,1824944400,14),(464,1837645200,13),(464,1856394000,14),(464,1869094800,13),(464,1887843600,14),(464,1901149200,13),(464,1919293200,14),(464,1932598800,13),(464,1950742800,14),(464,1964048400,13),(464,1982797200,14),(464,1995498000,13),(464,2014246800,14),(464,2026947600,13),(464,2045696400,14),(464,2058397200,13),(464,2077146000,14),(464,2090451600,13),(464,2108595600,14),(464,2121901200,13),(464,2140045200,14),(465,-2147483648,2),(465,-1690765200,1),(465,-1680487200,2),(465,-1664758800,1),(465,-1648951200,2),(465,-1635123600,1),(465,-1616896800,2),(465,-1604278800,1),(465,-1585533600,2),(465,-1571014800,1),(465,-1555293600,2),(465,-932432400,1),(465,-857257200,3),(465,-844556400,4),(465,-830311200,1),(465,-828226800,3),(465,-812502000,4),(465,-807156000,1),(465,-798073200,3),(465,-781052400,1),(465,-766717200,2),(465,-750898800,4),(465,-733359600,3),(465,-719456400,4),(465,-701917200,3),(465,-689209200,4),(465,-670460400,3),(465,-114051600,4),(465,-103168800,2),(465,-81997200,4),(465,-71715600,3),(465,-50547600,4),(465,-40266000,3),(465,-18493200,4),(465,-8211600,3),(465,12956400,4),(465,23238000,3),(465,43801200,4),(465,54687600,3),(465,75855600,4),(465,86742000,3),(465,107910000,4),(465,118191600,3),(465,138754800,4),(465,149641200,3),(465,170809200,4),(465,181090800,3),(465,202258800,4),(465,212540400,3),(465,233103600,4),(465,243990000,3),(465,265158000,4),(465,276044400,3),(465,296607600,4),(465,307494000,3),(465,315529200,2),(465,323830800,5),(465,338950800,6),(465,354675600,5),(465,370400400,6),(465,386125200,5),(465,401850000,6),(465,417574800,5),(465,433299600,6),(465,449024400,5),(465,465354000,6),(465,481078800,5),(465,496803600,6),(465,512528400,5),(465,528253200,6),(465,543978000,5),(465,559702800,6),(465,575427600,5),(465,591152400,6),(465,606877200,5),(465,622602000,6),(465,638326800,5),(465,654656400,6),(465,670381200,5),(465,686106000,6),(465,701830800,5),(465,717555600,6),(465,733280400,5),(465,749005200,6),(465,764730000,5),(465,780454800,6),(465,796179600,5),(465,811904400,6),(465,828234000,5),(465,846378000,6),(465,859683600,5),(465,877827600,6),(465,891133200,5),(465,909277200,6),(465,922582800,5),(465,941331600,6),(465,954032400,5),(465,972781200,6),(465,985482000,5),(465,1004230800,6),(465,1017536400,5),(465,1035680400,6),(465,1048986000,5),(465,1067130000,6),(465,1080435600,5),(465,1099184400,6),(465,1111885200,5),(465,1130634000,6),(465,1143334800,5),(465,1162083600,6),(465,1174784400,5),(465,1193533200,6),(465,1206838800,5),(465,1224982800,6),(465,1238288400,5),(465,1256432400,6),(465,1269738000,5),(465,1288486800,6),(465,1301187600,5),(465,1319936400,6),(465,1332637200,5),(465,1351386000,6),(465,1364691600,5),(465,1382835600,6),(465,1396141200,5),(465,1414285200,6),(465,1427590800,5),(465,1445734800,6),(465,1459040400,5),(465,1477789200,6),(465,1490490000,5),(465,1509238800,6),(465,1521939600,5),(465,1540688400,6),(465,1553994000,5),(465,1572138000,6),(465,1585443600,5),(465,1603587600,6),(465,1616893200,5),(465,1635642000,6),(465,1648342800,5),(465,1667091600,6),(465,1679792400,5),(465,1698541200,6),(465,1711846800,5),(465,1729990800,6),(465,1743296400,5),(465,1761440400,6),(465,1774746000,5),(465,1792890000,6),(465,1806195600,5),(465,1824944400,6),(465,1837645200,5),(465,1856394000,6),(465,1869094800,5),(465,1887843600,6),(465,1901149200,5),(465,1919293200,6),(465,1932598800,5),(465,1950742800,6),(465,1964048400,5),(465,1982797200,6),(465,1995498000,5),(465,2014246800,6),(465,2026947600,5),(465,2045696400,6),(465,2058397200,5),(465,2077146000,6),(465,2090451600,5),(465,2108595600,6),(465,2121901200,5),(465,2140045200,6),(466,-2147483648,0),(466,-1593820800,1),(466,-1247540400,2),(466,354916800,3),(466,370724400,2),(466,386452800,3),(466,402260400,2),(466,417988800,3),(466,433796400,2),(466,449611200,3),(466,465343200,4),(466,481068000,5),(466,496792800,4),(466,512517600,5),(466,528242400,4),(466,543967200,5),(466,559692000,4),(466,575416800,5),(466,591141600,4),(466,606866400,6),(466,622594800,7),(466,638319600,6),(466,654649200,7),(466,670374000,8),(466,686102400,7),(466,687916800,2),(466,701820000,5),(466,717544800,4),(466,733269600,5),(466,748994400,4),(466,764719200,5),(466,780444000,4),(466,796168800,5),(466,811893600,4),(466,828223200,5),(466,846367200,4),(466,859672800,5),(466,877816800,4),(466,891122400,5),(466,909266400,4),(466,922572000,5),(466,941320800,4),(466,954021600,5),(466,972770400,4),(466,985471200,5),(466,1004220000,4),(466,1017525600,5),(466,1035669600,4),(466,1048975200,5),(466,1067119200,4),(466,1080424800,5),(466,1099173600,4),(466,1111874400,5),(466,1130623200,4),(466,1143324000,5),(466,1162072800,4),(466,1174773600,5),(466,1193522400,4),(466,1206828000,5),(466,1224972000,4),(466,1238277600,5),(466,1256421600,4),(466,1269727200,6),(466,1288479600,7),(466,1301180400,4),(466,2147483647,4),(467,-2147483648,2),(467,-1690765200,1),(467,-1680487200,2),(467,-1664758800,1),(467,-1648951200,2),(467,-1635123600,1),(467,-1616896800,2),(467,-1604278800,1),(467,-1585533600,2),(467,-1571014800,1),(467,-1555293600,2),(467,-932432400,1),(467,-857257200,3),(467,-844556400,4),(467,-830311200,1),(467,-828226800,3),(467,-812502000,4),(467,-807156000,1),(467,-798073200,3),(467,-781052400,1),(467,-766717200,2),(467,-750898800,4),(467,-733359600,3),(467,-719456400,4),(467,-701917200,3),(467,-689209200,4),(467,-670460400,3),(467,-114051600,4),(467,-103168800,2),(467,-81997200,4),(467,-71715600,3),(467,-50547600,4),(467,-40266000,3),(467,-18493200,4),(467,-8211600,3),(467,12956400,4),(467,23238000,3),(467,43801200,4),(467,54687600,3),(467,75855600,4),(467,86742000,3),(467,107910000,4),(467,118191600,3),(467,138754800,4),(467,149641200,3),(467,170809200,4),(467,181090800,3),(467,202258800,4),(467,212540400,3),(467,233103600,4),(467,243990000,3),(467,265158000,4),(467,276044400,3),(467,296607600,4),(467,307494000,3),(467,315529200,2),(467,323830800,5),(467,338950800,6),(467,354675600,5),(467,370400400,6),(467,386125200,5),(467,401850000,6),(467,417574800,5),(467,433299600,6),(467,449024400,5),(467,465354000,6),(467,481078800,5),(467,496803600,6),(467,512528400,5),(467,528253200,6),(467,543978000,5),(467,559702800,6),(467,575427600,5),(467,591152400,6),(467,606877200,5),(467,622602000,6),(467,638326800,5),(467,654656400,6),(467,670381200,5),(467,686106000,6),(467,701830800,5),(467,717555600,6),(467,733280400,5),(467,749005200,6),(467,764730000,5),(467,780454800,6),(467,796179600,5),(467,811904400,6),(467,828234000,5),(467,846378000,6),(467,859683600,5),(467,877827600,6),(467,891133200,5),(467,909277200,6),(467,922582800,5),(467,941331600,6),(467,954032400,5),(467,972781200,6),(467,985482000,5),(467,1004230800,6),(467,1017536400,5),(467,1035680400,6),(467,1048986000,5),(467,1067130000,6),(467,1080435600,5),(467,1099184400,6),(467,1111885200,5),(467,1130634000,6),(467,1143334800,5),(467,1162083600,6),(467,1174784400,5),(467,1193533200,6),(467,1206838800,5),(467,1224982800,6),(467,1238288400,5),(467,1256432400,6),(467,1269738000,5),(467,1288486800,6),(467,1301187600,5),(467,1319936400,6),(467,1332637200,5),(467,1351386000,6),(467,1364691600,5),(467,1382835600,6),(467,1396141200,5),(467,1414285200,6),(467,1427590800,5),(467,1445734800,6),(467,1459040400,5),(467,1477789200,6),(467,1490490000,5),(467,1509238800,6),(467,1521939600,5),(467,1540688400,6),(467,1553994000,5),(467,1572138000,6),(467,1585443600,5),(467,1603587600,6),(467,1616893200,5),(467,1635642000,6),(467,1648342800,5),(467,1667091600,6),(467,1679792400,5),(467,1698541200,6),(467,1711846800,5),(467,1729990800,6),(467,1743296400,5),(467,1761440400,6),(467,1774746000,5),(467,1792890000,6),(467,1806195600,5),(467,1824944400,6),(467,1837645200,5),(467,1856394000,6),(467,1869094800,5),(467,1887843600,6),(467,1901149200,5),(467,1919293200,6),(467,1932598800,5),(467,1950742800,6),(467,1964048400,5),(467,1982797200,6),(467,1995498000,5),(467,2014246800,6),(467,2026947600,5),(467,2045696400,6),(467,2058397200,5),(467,2077146000,6),(467,2090451600,5),(467,2108595600,6),(467,2121901200,5),(467,2140045200,6),(468,-2147483648,1),(468,-905824800,4),(468,-857257200,2),(468,-844556400,3),(468,-828226800,2),(468,-812502000,3),(468,-796777200,2),(468,-788922000,1),(468,-777942000,3),(468,-766623600,2),(468,407199600,1),(468,417574800,5),(468,433299600,6),(468,449024400,5),(468,465354000,6),(468,481078800,5),(468,496803600,6),(468,512528400,5),(468,528253200,6),(468,543978000,5),(468,559702800,6),(468,575427600,5),(468,591152400,6),(468,606877200,5),(468,622602000,6),(468,638326800,5),(468,654656400,6),(468,670381200,5),(468,686106000,6),(468,701830800,5),(468,717555600,6),(468,733280400,5),(468,749005200,6),(468,764730000,5),(468,780454800,6),(468,796179600,5),(468,811904400,6),(468,828234000,5),(468,846378000,6),(468,859683600,5),(468,877827600,6),(468,891133200,5),(468,909277200,6),(468,922582800,5),(468,941331600,6),(468,954032400,5),(468,972781200,6),(468,985482000,5),(468,1004230800,6),(468,1017536400,5),(468,1035680400,6),(468,1048986000,5),(468,1067130000,6),(468,1080435600,5),(468,1099184400,6),(468,1111885200,5),(468,1130634000,6),(468,1143334800,5),(468,1162083600,6),(468,1174784400,5),(468,1193533200,6),(468,1206838800,5),(468,1224982800,6),(468,1238288400,5),(468,1256432400,6),(468,1269738000,5),(468,1288486800,6),(468,1301187600,5),(468,1319936400,6),(468,1332637200,5),(468,1351386000,6),(468,1364691600,5),(468,1382835600,6),(468,1396141200,5),(468,1414285200,6),(468,1427590800,5),(468,1445734800,6),(468,1459040400,5),(468,1477789200,6),(468,1490490000,5),(468,1509238800,6),(468,1521939600,5),(468,1540688400,6),(468,1553994000,5),(468,1572138000,6),(468,1585443600,5),(468,1603587600,6),(468,1616893200,5),(468,1635642000,6),(468,1648342800,5),(468,1667091600,6),(468,1679792400,5),(468,1698541200,6),(468,1711846800,5),(468,1729990800,6),(468,1743296400,5),(468,1761440400,6),(468,1774746000,5),(468,1792890000,6),(468,1806195600,5),(468,1824944400,6),(468,1837645200,5),(468,1856394000,6),(468,1869094800,5),(468,1887843600,6),(468,1901149200,5),(468,1919293200,6),(468,1932598800,5),(468,1950742800,6),(468,1964048400,5),(468,1982797200,6),(468,1995498000,5),(468,2014246800,6),(468,2026947600,5),(468,2045696400,6),(468,2058397200,5),(468,2077146000,6),(468,2090451600,5),(468,2108595600,6),(468,2121901200,5),(468,2140045200,6),(469,-2147483648,0),(469,-1593820800,1),(469,-1247540400,3),(469,354916800,2),(469,370724400,3),(469,386452800,2),(469,402260400,3),(469,417988800,2),(469,433796400,3),(469,449611200,2),(469,465343200,4),(469,481068000,5),(469,496792800,4),(469,512517600,5),(469,528242400,4),(469,543967200,5),(469,559692000,4),(469,575416800,6),(469,591145200,7),(469,606870000,6),(469,622594800,7),(469,638319600,6),(469,654649200,7),(469,670374000,4),(469,701820000,6),(469,717548400,7),(469,733273200,6),(469,748998000,7),(469,764722800,6),(469,780447600,7),(469,796172400,6),(469,811897200,7),(469,828226800,6),(469,846370800,7),(469,859676400,6),(469,877820400,7),(469,891126000,6),(469,909270000,7),(469,922575600,6),(469,941324400,7),(469,954025200,6),(469,972774000,7),(469,985474800,6),(469,1004223600,7),(469,1017529200,6),(469,1035673200,7),(469,1048978800,6),(469,1067122800,7),(469,1080428400,6),(469,1099177200,7),(469,1111878000,6),(469,1130626800,7),(469,1143327600,6),(469,1162076400,7),(469,1174777200,6),(469,1193526000,7),(469,1206831600,6),(469,1224975600,7),(469,1238281200,6),(469,1256425200,7),(469,1269730800,6),(469,1288479600,7),(469,1301180400,4),(469,1414274400,7),(469,1480806000,4),(469,2147483647,4),(470,-2147483648,1),(470,-1441160160,2),(470,-1247536800,3),(470,-888894000,6),(470,-857257200,4),(470,-844556400,5),(470,-828226800,4),(470,-812502000,5),(470,-811648800,3),(470,354920400,7),(470,370728000,3),(470,386456400,7),(470,402264000,3),(470,417992400,7),(470,433800000,3),(470,449614800,7),(470,465346800,8),(470,481071600,9),(470,496796400,8),(470,512521200,9),(470,528246000,8),(470,543970800,9),(470,559695600,8),(470,575420400,9),(470,591145200,8),(470,606870000,9),(470,622594800,8),(470,631141200,3),(470,646786800,2),(470,701820000,10),(470,717541200,2),(470,733269600,10),(470,748990800,2),(470,764719200,10),(470,767739600,7),(470,780436800,3),(470,796165200,7),(470,811886400,3),(470,828219600,9),(470,846374400,8),(470,852066000,3),(470,859683600,11),(470,877827600,12),(470,891133200,11),(470,909277200,12),(470,922582800,11),(470,941331600,12),(470,954032400,11),(470,972781200,12),(470,985482000,11),(470,1004230800,12),(470,1017536400,11),(470,1035680400,12),(470,1048986000,11),(470,1067130000,12),(470,1080435600,11),(470,1099184400,12),(470,1111885200,11),(470,1130634000,12),(470,1143334800,11),(470,1162083600,12),(470,1174784400,11),(470,1193533200,12),(470,1206838800,11),(470,1224982800,12),(470,1238288400,11),(470,1256432400,12),(470,1269738000,11),(470,1288486800,12),(470,1301187600,11),(470,1319936400,12),(470,1332637200,11),(470,1351386000,12),(470,1364691600,11),(470,1382835600,12),(470,1396137600,13),(470,1414274400,8),(471,-2147483648,1),(471,-905824800,4),(471,-857257200,2),(471,-844556400,3),(471,-828226800,2),(471,-812502000,3),(471,-796777200,2),(471,-788922000,1),(471,-777942000,3),(471,-766623600,2),(471,407199600,1),(471,417574800,5),(471,433299600,6),(471,449024400,5),(471,465354000,6),(471,481078800,5),(471,496803600,6),(471,512528400,5),(471,528253200,6),(471,543978000,5),(471,559702800,6),(471,575427600,5),(471,591152400,6),(471,606877200,5),(471,622602000,6),(471,638326800,5),(471,654656400,6),(471,670381200,5),(471,686106000,6),(471,701830800,5),(471,717555600,6),(471,733280400,5),(471,749005200,6),(471,764730000,5),(471,780454800,6),(471,796179600,5),(471,811904400,6),(471,828234000,5),(471,846378000,6),(471,859683600,5),(471,877827600,6),(471,891133200,5),(471,909277200,6),(471,922582800,5),(471,941331600,6),(471,954032400,5),(471,972781200,6),(471,985482000,5),(471,1004230800,6),(471,1017536400,5),(471,1035680400,6),(471,1048986000,5),(471,1067130000,6),(471,1080435600,5),(471,1099184400,6),(471,1111885200,5),(471,1130634000,6),(471,1143334800,5),(471,1162083600,6),(471,1174784400,5),(471,1193533200,6),(471,1206838800,5),(471,1224982800,6),(471,1238288400,5),(471,1256432400,6),(471,1269738000,5),(471,1288486800,6),(471,1301187600,5),(471,1319936400,6),(471,1332637200,5),(471,1351386000,6),(471,1364691600,5),(471,1382835600,6),(471,1396141200,5),(471,1414285200,6),(471,1427590800,5),(471,1445734800,6),(471,1459040400,5),(471,1477789200,6),(471,1490490000,5),(471,1509238800,6),(471,1521939600,5),(471,1540688400,6),(471,1553994000,5),(471,1572138000,6),(471,1585443600,5),(471,1603587600,6),(471,1616893200,5),(471,1635642000,6),(471,1648342800,5),(471,1667091600,6),(471,1679792400,5),(471,1698541200,6),(471,1711846800,5),(471,1729990800,6),(471,1743296400,5),(471,1761440400,6),(471,1774746000,5),(471,1792890000,6),(471,1806195600,5),(471,1824944400,6),(471,1837645200,5),(471,1856394000,6),(471,1869094800,5),(471,1887843600,6),(471,1901149200,5),(471,1919293200,6),(471,1932598800,5),(471,1950742800,6),(471,1964048400,5),(471,1982797200,6),(471,1995498000,5),(471,2014246800,6),(471,2026947600,5),(471,2045696400,6),(471,2058397200,5),(471,2077146000,6),(471,2090451600,5),(471,2108595600,6),(471,2121901200,5),(471,2140045200,6),(472,-2147483648,1),(472,-857257200,2),(472,-844556400,3),(472,-828226800,2),(472,-812502000,3),(472,-796777200,2),(472,-788922000,4),(472,-781048800,1),(472,291762000,5),(472,307576800,1),(472,323816400,5),(472,339026400,1),(472,355266000,5),(472,370393200,1),(472,386715600,5),(472,401846400,6),(472,417571200,7),(472,433296000,6),(472,449020800,7),(472,465350400,6),(472,481075200,7),(472,496800000,6),(472,512524800,7),(472,528249600,6),(472,543974400,7),(472,559699200,6),(472,575424000,7),(472,591148800,6),(472,606873600,7),(472,622598400,6),(472,638323200,7),(472,654652800,6),(472,662680800,1),(472,670370400,5),(472,686091600,1),(472,701820000,5),(472,717541200,1),(472,733269600,5),(472,748990800,1),(472,764719200,5),(472,780440400,1),(472,796168800,5),(472,811890000,1),(472,828223200,5),(472,846363600,1),(472,859683600,8),(472,877827600,9),(472,891133200,8),(472,909277200,9),(472,922582800,8),(472,941331600,9),(472,954032400,8),(472,972781200,9),(472,985482000,8),(472,1004230800,9),(472,1017536400,8),(472,1035680400,9),(472,1048986000,8),(472,1067130000,9),(472,1080435600,8),(472,1099184400,9),(472,1111885200,8),(472,1130634000,9),(472,1143334800,8),(472,1162083600,9),(472,1174784400,8),(472,1193533200,9),(472,1206838800,8),(472,1224982800,9),(472,1238288400,8),(472,1256432400,9),(472,1269738000,8),(472,1288486800,9),(472,1301187600,8),(472,1319936400,9),(472,1332637200,8),(472,1351386000,9),(472,1364691600,8),(472,1382835600,9),(472,1396141200,8),(472,1414285200,9),(472,1427590800,8),(472,1445734800,9),(472,1459040400,8),(472,1477789200,9),(472,1490490000,8),(472,1509238800,9),(472,1521939600,8),(472,1540688400,9),(472,1553994000,8),(472,1572138000,9),(472,1585443600,8),(472,1603587600,9),(472,1616893200,8),(472,1635642000,9),(472,1648342800,8),(472,1667091600,9),(472,1679792400,8),(472,1698541200,9),(472,1711846800,8),(472,1729990800,9),(472,1743296400,8),(472,1761440400,9),(472,1774746000,8),(472,1792890000,9),(472,1806195600,8),(472,1824944400,9),(472,1837645200,8),(472,1856394000,9),(472,1869094800,8),(472,1887843600,9),(472,1901149200,8),(472,1919293200,9),(472,1932598800,8),(472,1950742800,9),(472,1964048400,8),(472,1982797200,9),(472,1995498000,8),(472,2014246800,9),(472,2026947600,8),(472,2045696400,9),(472,2058397200,8),(472,2077146000,9),(472,2090451600,8),(472,2108595600,9),(472,2121901200,8),(472,2140045200,9),(473,-2147483648,1),(473,-1692496800,2),(473,-1680483600,1),(473,323830800,3),(473,338950800,4),(473,354675600,3),(473,370400400,4),(473,386125200,3),(473,401850000,4),(473,417574800,3),(473,433299600,4),(473,449024400,3),(473,465354000,4),(473,481078800,3),(473,496803600,4),(473,512528400,3),(473,528253200,4),(473,543978000,3),(473,559702800,4),(473,575427600,3),(473,591152400,4),(473,606877200,3),(473,622602000,4),(473,638326800,3),(473,654656400,4),(473,670381200,3),(473,686106000,4),(473,701830800,3),(473,717555600,4),(473,733280400,3),(473,749005200,4),(473,764730000,3),(473,780454800,4),(473,796179600,3),(473,811904400,4),(473,828234000,3),(473,846378000,4),(473,859683600,3),(473,877827600,4),(473,891133200,3),(473,909277200,4),(473,922582800,3),(473,941331600,4),(473,954032400,3),(473,972781200,4),(473,985482000,3),(473,1004230800,4),(473,1017536400,3),(473,1035680400,4),(473,1048986000,3),(473,1067130000,4),(473,1080435600,3),(473,1099184400,4),(473,1111885200,3),(473,1130634000,4),(473,1143334800,3),(473,1162083600,4),(473,1174784400,3),(473,1193533200,4),(473,1206838800,3),(473,1224982800,4),(473,1238288400,3),(473,1256432400,4),(473,1269738000,3),(473,1288486800,4),(473,1301187600,3),(473,1319936400,4),(473,1332637200,3),(473,1351386000,4),(473,1364691600,3),(473,1382835600,4),(473,1396141200,3),(473,1414285200,4),(473,1427590800,3),(473,1445734800,4),(473,1459040400,3),(473,1477789200,4),(473,1490490000,3),(473,1509238800,4),(473,1521939600,3),(473,1540688400,4),(473,1553994000,3),(473,1572138000,4),(473,1585443600,3),(473,1603587600,4),(473,1616893200,3),(473,1635642000,4),(473,1648342800,3),(473,1667091600,4),(473,1679792400,3),(473,1698541200,4),(473,1711846800,3),(473,1729990800,4),(473,1743296400,3),(473,1761440400,4),(473,1774746000,3),(473,1792890000,4),(473,1806195600,3),(473,1824944400,4),(473,1837645200,3),(473,1856394000,4),(473,1869094800,3),(473,1887843600,4),(473,1901149200,3),(473,1919293200,4),(473,1932598800,3),(473,1950742800,4),(473,1964048400,3),(473,1982797200,4),(473,1995498000,3),(473,2014246800,4),(473,2026947600,3),(473,2045696400,4),(473,2058397200,3),(473,2077146000,4),(473,2090451600,3),(473,2108595600,4),(473,2121901200,3),(473,2140045200,4),(474,-2147483648,1),(474,-1638322740,4),(474,-1632006000,2),(474,-1618700400,3),(474,-1593824400,1),(474,-1535938740,5),(474,-927943200,6),(474,-892954800,7),(474,-857257200,3),(474,-844556400,2),(474,-828226800,3),(474,-812502000,2),(474,-797652000,6),(474,354920400,8),(474,370728000,6),(474,386456400,8),(474,402264000,6),(474,417992400,8),(474,433800000,6),(474,449614800,8),(474,465346800,9),(474,481071600,10),(474,496796400,9),(474,512521200,10),(474,528246000,9),(474,543970800,10),(474,559695600,9),(474,575420400,10),(474,591145200,9),(474,606870000,11),(474,622598400,12),(474,638323200,11),(474,654652800,12),(474,670377600,11),(474,686102400,12),(474,701827200,11),(474,717552000,12),(474,733276800,11),(474,749001600,12),(474,764726400,11),(474,780451200,12),(474,796176000,11),(474,811900800,12),(474,828230400,11),(474,846374400,12),(474,859680000,11),(474,877824000,12),(474,891129600,11),(474,906411600,15),(474,909277200,13),(474,922582800,14),(474,941331600,5),(474,1017536400,14),(474,1035680400,13),(474,1048986000,14),(474,1067130000,13),(474,1080435600,14),(474,1099184400,13),(474,1111885200,14),(474,1130634000,13),(474,1143334800,14),(474,1162083600,13),(474,1174784400,14),(474,1193533200,13),(474,1206838800,14),(474,1224982800,13),(474,1238288400,14),(474,1256432400,13),(474,1269738000,14),(474,1288486800,13),(474,1301187600,14),(474,1319936400,13),(474,1332637200,14),(474,1351386000,13),(474,1364691600,14),(474,1382835600,13),(474,1396141200,14),(474,1414285200,13),(474,1427590800,14),(474,1445734800,13),(474,1459040400,14),(474,1477789200,13),(474,1490490000,14),(474,1509238800,13),(474,1521939600,14),(474,1540688400,13),(474,1553994000,14),(474,1572138000,13),(474,1585443600,14),(474,1603587600,13),(474,1616893200,14),(474,1635642000,13),(474,1648342800,14),(474,1667091600,13),(474,1679792400,14),(474,1698541200,13),(474,1711846800,14),(474,1729990800,13),(474,1743296400,14),(474,1761440400,13),(474,1774746000,14),(474,1792890000,13),(474,1806195600,14),(474,1824944400,13),(474,1837645200,14),(474,1856394000,13),(474,1869094800,14),(474,1887843600,13),(474,1901149200,14),(474,1919293200,13),(474,1932598800,14),(474,1950742800,13),(474,1964048400,14),(474,1982797200,13),(474,1995498000,14),(474,2014246800,13),(474,2026947600,14),(474,2045696400,13),(474,2058397200,14),(474,2077146000,13),(474,2090451600,14),(474,2108595600,13),(474,2121901200,14),(474,2140045200,13),(475,-2147483648,0),(475,-1767230360,1),(475,-932346000,2),(475,-857257200,1),(475,-844556400,2),(475,-843519600,1),(475,136854000,2),(475,149896800,1),(475,168130800,2),(475,181432800,1),(475,199839600,2),(475,213141600,1),(475,231894000,2),(475,244591200,1),(475,263257200,2),(475,276040800,1),(475,294706800,2),(475,307490400,1),(475,326156400,2),(475,339458400,1),(475,357087600,2),(475,370389600,1),(475,389142000,2),(475,402444000,1),(475,419468400,2),(475,433807200,1),(475,449622000,2),(475,465354000,3),(475,481078800,4),(475,496803600,3),(475,512528400,4),(475,528253200,3),(475,543978000,4),(475,559702800,3),(475,575427600,4),(475,591152400,3),(475,606877200,4),(475,622602000,3),(475,638326800,4),(475,654656400,3),(475,670381200,4),(475,686106000,3),(475,701830800,4),(475,717555600,3),(475,733280400,4),(475,749005200,3),(475,764730000,4),(475,780454800,3),(475,796179600,4),(475,811904400,3),(475,828234000,4),(475,846378000,3),(475,859683600,4),(475,877827600,3),(475,891133200,4),(475,909277200,3),(475,922582800,4),(475,941331600,3),(475,954032400,4),(475,972781200,3),(475,985482000,4),(475,1004230800,3),(475,1017536400,4),(475,1035680400,3),(475,1048986000,4),(475,1067130000,3),(475,1080435600,4),(475,1099184400,3),(475,1111885200,4),(475,1130634000,3),(475,1143334800,4),(475,1162083600,3),(475,1174784400,4),(475,1193533200,3),(475,1206838800,4),(475,1224982800,3),(475,1238288400,4),(475,1256432400,3),(475,1269738000,4),(475,1288486800,3),(475,1301187600,4),(475,1319936400,3),(475,1332637200,4),(475,1351386000,3),(475,1364691600,4),(475,1382835600,3),(475,1396141200,4),(475,1414285200,3),(475,1427590800,4),(475,1445734800,3),(475,1459040400,4),(475,1477789200,3),(475,1490490000,4),(475,1509238800,3),(475,1521939600,4),(475,1540688400,3),(475,1553994000,4),(475,1572138000,3),(475,1585443600,4),(475,1603587600,3),(475,1616893200,4),(475,1635642000,3),(475,1648342800,4),(475,1667091600,3),(475,1679792400,4),(475,1698541200,3),(475,1711846800,4),(475,1729990800,3),(475,1743296400,4),(475,1761440400,3),(475,1774746000,4),(475,1792890000,3),(475,1806195600,4),(475,1824944400,3),(475,1837645200,4),(475,1856394000,3),(475,1869094800,4),(475,1887843600,3),(475,1901149200,4),(475,1919293200,3),(475,1932598800,4),(475,1950742800,3),(475,1964048400,4),(475,1982797200,3),(475,1995498000,4),(475,2014246800,3),(475,2026947600,4),(475,2045696400,3),(475,2058397200,4),(475,2077146000,3),(475,2090451600,4),(475,2108595600,3),(475,2121901200,4),(475,2140045200,3),(476,-2147483648,1),(476,-1637114100,2),(476,-1213148664,5),(476,-1187056800,3),(476,-1175479200,4),(476,-1159754400,3),(476,-1144029600,4),(476,-1127700000,3),(476,-1111975200,4),(476,-1096250400,3),(476,-1080525600,4),(476,-1064800800,3),(476,-1049076000,4),(476,-1033351200,3),(476,-1017626400,4),(476,-1001901600,3),(476,-986176800,4),(476,-970452000,3),(476,-954727200,4),(476,-927165600,6),(476,-898138800,9),(476,-857257200,7),(476,-844556400,8),(476,-828226800,7),(476,-812502000,8),(476,-800157600,11),(476,354920400,10),(476,370728000,11),(476,386456400,10),(476,402264000,11),(476,417992400,10),(476,433800000,11),(476,449614800,10),(476,465346800,12),(476,481071600,13),(476,496796400,12),(476,512521200,13),(476,528246000,12),(476,543970800,13),(476,559695600,12),(476,575420400,13),(476,591145200,12),(476,606870000,13),(476,622594800,12),(476,638319600,13),(476,641944800,6),(476,654652800,4),(476,670377600,3),(476,686102400,4),(476,694216800,5),(476,701820000,6),(476,717541200,5),(476,733269600,6),(476,748990800,5),(476,764719200,6),(476,780440400,5),(476,796168800,6),(476,811890000,5),(476,828223200,6),(476,846363600,5),(476,859680000,6),(476,877824000,5),(476,891129600,6),(476,909273600,5),(476,922579200,6),(476,941328000,5),(476,954028800,6),(476,972777600,5),(476,985478400,6),(476,1004227200,5),(476,1017532800,6),(476,1035676800,5),(476,1048982400,6),(476,1067126400,5),(476,1080432000,6),(476,1099180800,5),(476,1111881600,6),(476,1130630400,5),(476,1143331200,6),(476,1162080000,5),(476,1174780800,6),(476,1193529600,5),(476,1206835200,6),(476,1224979200,5),(476,1238284800,6),(476,1256428800,5),(476,1269734400,6),(476,1288483200,5),(476,1301184000,6),(476,1319932800,5),(476,1332633600,6),(476,1351382400,5),(476,1364688000,6),(476,1382832000,5),(476,1396137600,6),(476,1414281600,5),(476,1427587200,6),(476,1445731200,5),(476,1459036800,6),(476,1477785600,5),(476,1490486400,6),(476,1509235200,5),(476,1521936000,6),(476,1540684800,5),(476,1553990400,6),(476,1572134400,5),(476,1585440000,6),(476,1603584000,5),(476,1616889600,6),(476,1635638400,5),(476,1648339200,6),(476,1667088000,5),(476,1679788800,6),(476,1698537600,5),(476,1711843200,6),(476,1729987200,5),(476,1743292800,6),(476,1761436800,5),(476,1774742400,6),(476,1792886400,5),(476,1806192000,6),(476,1824940800,5),(476,1837641600,6),(476,1856390400,5),(476,1869091200,6),(476,1887840000,5),(476,1901145600,6),(476,1919289600,5),(476,1932595200,6),(476,1950739200,5),(476,1964044800,6),(476,1982793600,5),(476,1995494400,6),(476,2014243200,5),(476,2026944000,6),(476,2045692800,5),(476,2058393600,6),(476,2077142400,5),(476,2090448000,6),(476,2108592000,5),(476,2121897600,6),(476,2140041600,5),(477,-2147483648,0),(477,-1593820800,1),(477,-1247540400,3),(477,354916800,2),(477,370724400,3),(477,386452800,2),(477,402260400,3),(477,417988800,2),(477,433796400,3),(477,449611200,2),(477,465343200,4),(477,481068000,5),(477,496792800,4),(477,512517600,5),(477,528242400,4),(477,543967200,5),(477,559692000,4),(477,575416800,5),(477,591141600,4),(477,606866400,6),(477,622594800,7),(477,638319600,6),(477,654649200,7),(477,670374000,8),(477,686102400,9),(477,695779200,7),(477,701823600,6),(477,717548400,7),(477,733273200,6),(477,748998000,7),(477,764722800,6),(477,780447600,7),(477,796172400,6),(477,811897200,7),(477,828226800,6),(477,846370800,7),(477,859676400,6),(477,877820400,7),(477,891126000,6),(477,909270000,7),(477,922575600,6),(477,941324400,7),(477,954025200,6),(477,972774000,7),(477,985474800,6),(477,1004223600,7),(477,1017529200,6),(477,1035673200,7),(477,1048978800,6),(477,1067122800,7),(477,1080428400,6),(477,1099177200,7),(477,1111878000,6),(477,1130626800,7),(477,1143327600,6),(477,1162076400,7),(477,1174777200,6),(477,1193526000,7),(477,1206831600,6),(477,1224975600,7),(477,1238281200,6),(477,1256425200,7),(477,1269730800,6),(477,1288479600,7),(477,1301180400,4),(477,1414274400,7),(477,1459033200,4),(477,2147483647,4),(478,-2147483648,1),(478,-938905200,2),(478,-857257200,3),(478,-844556400,2),(478,-828226800,3),(478,-812502000,2),(478,-796874400,4),(478,-794714400,1),(478,-773456400,6),(478,354920400,5),(478,370728000,6),(478,386456400,5),(478,402264000,6),(478,417992400,5),(478,433800000,6),(478,449614800,5),(478,465346800,7),(478,481071600,8),(478,496796400,7),(478,512521200,8),(478,528246000,7),(478,543970800,8),(478,559695600,7),(478,575420400,8),(478,591145200,7),(478,606870000,8),(478,622594800,7),(478,631141200,6),(478,646786800,1),(478,670384800,9),(478,701820000,10),(478,717541200,9),(478,733269600,10),(478,748990800,9),(478,764719200,10),(478,780440400,9),(478,796179600,11),(478,811904400,12),(478,828234000,11),(478,846378000,12),(478,859683600,11),(478,877827600,12),(478,891133200,11),(478,909277200,12),(478,922582800,11),(478,941331600,12),(478,954032400,11),(478,972781200,12),(478,985482000,11),(478,1004230800,12),(478,1017536400,11),(478,1035680400,12),(478,1048986000,11),(478,1067130000,12),(478,1080435600,11),(478,1099184400,12),(478,1111885200,11),(478,1130634000,12),(478,1143334800,11),(478,1162083600,12),(478,1174784400,11),(478,1193533200,12),(478,1206838800,11),(478,1224982800,12),(478,1238288400,11),(478,1256432400,12),(478,1269738000,11),(478,1288486800,12),(478,1301187600,11),(478,1319936400,12),(478,1332637200,11),(478,1351386000,12),(478,1364691600,11),(478,1382835600,12),(478,1396141200,11),(478,1414285200,12),(478,1427590800,11),(478,1445734800,12),(478,1459040400,11),(478,1477789200,12),(478,1490490000,11),(478,1509238800,12),(478,1521939600,11),(478,1540688400,12),(478,1553994000,11),(478,1572138000,12),(478,1585443600,11),(478,1603587600,12),(478,1616893200,11),(478,1635642000,12),(478,1648342800,11),(478,1667091600,12),(478,1679792400,11),(478,1698541200,12),(478,1711846800,11),(478,1729990800,12),(478,1743296400,11),(478,1761440400,12),(478,1774746000,11),(478,1792890000,12),(478,1806195600,11),(478,1824944400,12),(478,1837645200,11),(478,1856394000,12),(478,1869094800,11),(478,1887843600,12),(478,1901149200,11),(478,1919293200,12),(478,1932598800,11),(478,1950742800,12),(478,1964048400,11),(478,1982797200,12),(478,1995498000,11),(478,2014246800,12),(478,2026947600,11),(478,2045696400,12),(478,2058397200,11),(478,2077146000,12),(478,2090451600,11),(478,2108595600,12),(478,2121901200,11),(478,2140045200,12),(479,-2147483648,2),(479,-904435200,1),(479,-891129600,2),(479,-872985600,1),(479,-859680000,2),(479,354675600,3),(479,370400400,4),(479,386125200,3),(479,401850000,4),(479,417574800,3),(479,433299600,4),(479,449024400,3),(479,465354000,4),(479,481078800,3),(479,496803600,4),(479,512528400,3),(479,528253200,4),(479,543978000,3),(479,559702800,4),(479,575427600,3),(479,591152400,4),(479,606877200,3),(479,622602000,4),(479,638326800,3),(479,654656400,4),(479,670381200,3),(479,686106000,4),(479,701830800,3),(479,717555600,4),(479,733280400,3),(479,749005200,4),(479,764730000,3),(479,780454800,4),(479,796179600,3),(479,811904400,4),(479,828234000,3),(479,846378000,4),(479,859683600,3),(479,877827600,4),(479,891133200,3),(479,909277200,4),(479,922582800,3),(479,941331600,4),(479,954032400,3),(479,972781200,4),(479,985482000,3),(479,1004230800,4),(479,1017536400,3),(479,1035680400,4),(479,1048986000,3),(479,1067130000,4),(479,1080435600,3),(479,1099184400,4),(479,1111885200,3),(479,1130634000,4),(479,1143334800,3),(479,1162083600,4),(479,1174784400,3),(479,1193533200,4),(479,1206838800,3),(479,1224982800,4),(479,1238288400,3),(479,1256432400,4),(479,1269738000,3),(479,1288486800,4),(479,1301187600,3),(479,1319936400,4),(479,1332637200,3),(479,1351386000,4),(479,1364691600,3),(479,1382835600,4),(479,1396141200,3),(479,1414285200,4),(479,1427590800,3),(479,1445734800,4),(479,1459040400,3),(479,1477789200,4),(479,1490490000,3),(479,1509238800,4),(479,1521939600,3),(479,1540688400,4),(479,1553994000,3),(479,1572138000,4),(479,1585443600,3),(479,1603587600,4),(479,1616893200,3),(479,1635642000,4),(479,1648342800,3),(479,1667091600,4),(479,1679792400,3),(479,1698541200,4),(479,1711846800,3),(479,1729990800,4),(479,1743296400,3),(479,1761440400,4),(479,1774746000,3),(479,1792890000,4),(479,1806195600,3),(479,1824944400,4),(479,1837645200,3),(479,1856394000,4),(479,1869094800,3),(479,1887843600,4),(479,1901149200,3),(479,1919293200,4),(479,1932598800,3),(479,1950742800,4),(479,1964048400,3),(479,1982797200,4),(479,1995498000,3),(479,2014246800,4),(479,2026947600,3),(479,2045696400,4),(479,2058397200,3),(479,2077146000,4),(479,2090451600,3),(479,2108595600,4),(479,2121901200,3),(479,2140045200,4),(480,-2147483648,2),(480,-1690765200,1),(480,-1680487200,2),(480,-1664758800,1),(480,-1648951200,2),(480,-1635123600,1),(480,-1616896800,2),(480,-1604278800,1),(480,-1585533600,2),(480,-1571014800,1),(480,-1555293600,2),(480,-932432400,1),(480,-857257200,3),(480,-844556400,4),(480,-830311200,1),(480,-828226800,3),(480,-812502000,4),(480,-807156000,1),(480,-798073200,3),(480,-781052400,1),(480,-766717200,2),(480,-750898800,4),(480,-733359600,3),(480,-719456400,4),(480,-701917200,3),(480,-689209200,4),(480,-670460400,3),(480,-114051600,4),(480,-103168800,2),(480,-81997200,4),(480,-71715600,3),(480,-50547600,4),(480,-40266000,3),(480,-18493200,4),(480,-8211600,3),(480,12956400,4),(480,23238000,3),(480,43801200,4),(480,54687600,3),(480,75855600,4),(480,86742000,3),(480,107910000,4),(480,118191600,3),(480,138754800,4),(480,149641200,3),(480,170809200,4),(480,181090800,3),(480,202258800,4),(480,212540400,3),(480,233103600,4),(480,243990000,3),(480,265158000,4),(480,276044400,3),(480,296607600,4),(480,307494000,3),(480,315529200,2),(480,323830800,5),(480,338950800,6),(480,354675600,5),(480,370400400,6),(480,386125200,5),(480,401850000,6),(480,417574800,5),(480,433299600,6),(480,449024400,5),(480,465354000,6),(480,481078800,5),(480,496803600,6),(480,512528400,5),(480,528253200,6),(480,543978000,5),(480,559702800,6),(480,575427600,5),(480,591152400,6),(480,606877200,5),(480,622602000,6),(480,638326800,5),(480,654656400,6),(480,670381200,5),(480,686106000,6),(480,701830800,5),(480,717555600,6),(480,733280400,5),(480,749005200,6),(480,764730000,5),(480,780454800,6),(480,796179600,5),(480,811904400,6),(480,828234000,5),(480,846378000,6),(480,859683600,5),(480,877827600,6),(480,891133200,5),(480,909277200,6),(480,922582800,5),(480,941331600,6),(480,954032400,5),(480,972781200,6),(480,985482000,5),(480,1004230800,6),(480,1017536400,5),(480,1035680400,6),(480,1048986000,5),(480,1067130000,6),(480,1080435600,5),(480,1099184400,6),(480,1111885200,5),(480,1130634000,6),(480,1143334800,5),(480,1162083600,6),(480,1174784400,5),(480,1193533200,6),(480,1206838800,5),(480,1224982800,6),(480,1238288400,5),(480,1256432400,6),(480,1269738000,5),(480,1288486800,6),(480,1301187600,5),(480,1319936400,6),(480,1332637200,5),(480,1351386000,6),(480,1364691600,5),(480,1382835600,6),(480,1396141200,5),(480,1414285200,6),(480,1427590800,5),(480,1445734800,6),(480,1459040400,5),(480,1477789200,6),(480,1490490000,5),(480,1509238800,6),(480,1521939600,5),(480,1540688400,6),(480,1553994000,5),(480,1572138000,6),(480,1585443600,5),(480,1603587600,6),(480,1616893200,5),(480,1635642000,6),(480,1648342800,5),(480,1667091600,6),(480,1679792400,5),(480,1698541200,6),(480,1711846800,5),(480,1729990800,6),(480,1743296400,5),(480,1761440400,6),(480,1774746000,5),(480,1792890000,6),(480,1806195600,5),(480,1824944400,6),(480,1837645200,5),(480,1856394000,6),(480,1869094800,5),(480,1887843600,6),(480,1901149200,5),(480,1919293200,6),(480,1932598800,5),(480,1950742800,6),(480,1964048400,5),(480,1982797200,6),(480,1995498000,5),(480,2014246800,6),(480,2026947600,5),(480,2045696400,6),(480,2058397200,5),(480,2077146000,6),(480,2090451600,5),(480,2108595600,6),(480,2121901200,5),(480,2140045200,6),(481,-2147483648,2),(481,-1693706400,1),(481,-1680483600,2),(481,-1663455600,3),(481,-1650150000,4),(481,-1632006000,3),(481,-1618700400,4),(481,-1577926800,2),(481,-1569711600,3),(481,-1555801200,4),(481,-938905200,3),(481,-857257200,4),(481,-844556400,3),(481,-828226800,4),(481,-812502000,3),(481,-796777200,4),(481,-781052400,3),(481,-780188400,4),(481,-757386000,2),(481,-748479600,3),(481,-733359600,4),(481,-717634800,3),(481,-701910000,4),(481,-684975600,3),(481,-670460400,4),(481,323823600,1),(481,338940000,2),(481,354675600,5),(481,370400400,6),(481,386125200,5),(481,401850000,6),(481,417574800,5),(481,433299600,6),(481,449024400,5),(481,465354000,6),(481,481078800,5),(481,496803600,6),(481,512528400,5),(481,528253200,6),(481,543978000,5),(481,559702800,6),(481,575427600,5),(481,591152400,6),(481,606877200,5),(481,622602000,6),(481,638326800,5),(481,654656400,6),(481,670381200,5),(481,686106000,6),(481,701830800,5),(481,717555600,6),(481,733280400,5),(481,749005200,6),(481,764730000,5),(481,780454800,6),(481,796179600,5),(481,811904400,6),(481,828234000,5),(481,846378000,6),(481,859683600,5),(481,877827600,6),(481,891133200,5),(481,909277200,6),(481,922582800,5),(481,941331600,6),(481,954032400,5),(481,972781200,6),(481,985482000,5),(481,1004230800,6),(481,1017536400,5),(481,1035680400,6),(481,1048986000,5),(481,1067130000,6),(481,1080435600,5),(481,1099184400,6),(481,1111885200,5),(481,1130634000,6),(481,1143334800,5),(481,1162083600,6),(481,1174784400,5),(481,1193533200,6),(481,1206838800,5),(481,1224982800,6),(481,1238288400,5),(481,1256432400,6),(481,1269738000,5),(481,1288486800,6),(481,1301187600,5),(481,1319936400,6),(481,1332637200,5),(481,1351386000,6),(481,1364691600,5),(481,1382835600,6),(481,1396141200,5),(481,1414285200,6),(481,1427590800,5),(481,1445734800,6),(481,1459040400,5),(481,1477789200,6),(481,1490490000,5),(481,1509238800,6),(481,1521939600,5),(481,1540688400,6),(481,1553994000,5),(481,1572138000,6),(481,1585443600,5),(481,1603587600,6),(481,1616893200,5),(481,1635642000,6),(481,1648342800,5),(481,1667091600,6),(481,1679792400,5),(481,1698541200,6),(481,1711846800,5),(481,1729990800,6),(481,1743296400,5),(481,1761440400,6),(481,1774746000,5),(481,1792890000,6),(481,1806195600,5),(481,1824944400,6),(481,1837645200,5),(481,1856394000,6),(481,1869094800,5),(481,1887843600,6),(481,1901149200,5),(481,1919293200,6),(481,1932598800,5),(481,1950742800,6),(481,1964048400,5),(481,1982797200,6),(481,1995498000,5),(481,2014246800,6),(481,2026947600,5),(481,2045696400,6),(481,2058397200,5),(481,2077146000,6),(481,2090451600,5),(481,2108595600,6),(481,2121901200,5),(481,2140045200,6),(482,-2147483648,1),(482,-1672536240,2),(482,-1585100136,3),(482,-1561251600,4),(482,-1553565600,3),(482,-928198800,5),(482,-900126000,8),(482,-857257200,6),(482,-844556400,7),(482,-828226800,6),(482,-812502000,7),(482,-802144800,5),(482,354920400,9),(482,370728000,5),(482,386456400,9),(482,402264000,5),(482,417992400,9),(482,433800000,5),(482,449614800,9),(482,465346800,10),(482,481071600,11),(482,496796400,10),(482,512521200,11),(482,528246000,10),(482,543970800,11),(482,559695600,10),(482,575420400,11),(482,591145200,10),(482,606870000,12),(482,622598400,13),(482,638323200,12),(482,654652800,13),(482,670377600,12),(482,686102400,13),(482,701827200,12),(482,717552000,13),(482,733276800,12),(482,749001600,13),(482,764726400,12),(482,780451200,13),(482,796176000,12),(482,811900800,13),(482,828230400,12),(482,846374400,13),(482,859680000,12),(482,877824000,13),(482,883605600,4),(482,891133200,14),(482,909277200,15),(482,922582800,14),(482,941331600,16),(482,1041372000,4),(482,1048986000,17),(482,1067130000,16),(482,1080435600,17),(482,1099184400,16),(482,1111885200,17),(482,1130634000,16),(482,1143334800,17),(482,1162083600,16),(482,1174784400,17),(482,1193533200,16),(482,1206838800,17),(482,1224982800,16),(482,1238288400,17),(482,1256432400,16),(482,1269738000,17),(482,1288486800,16),(482,1301187600,17),(482,1319936400,16),(482,1332637200,17),(482,1351386000,16),(482,1364691600,17),(482,1382835600,16),(482,1396141200,17),(482,1414285200,16),(482,1427590800,17),(482,1445734800,16),(482,1459040400,17),(482,1477789200,16),(482,1490490000,17),(482,1509238800,16),(482,1521939600,17),(482,1540688400,16),(482,1553994000,17),(482,1572138000,16),(482,1585443600,17),(482,1603587600,16),(482,1616893200,17),(482,1635642000,16),(482,1648342800,17),(482,1667091600,16),(482,1679792400,17),(482,1698541200,16),(482,1711846800,17),(482,1729990800,16),(482,1743296400,17),(482,1761440400,16),(482,1774746000,17),(482,1792890000,16),(482,1806195600,17),(482,1824944400,16),(482,1837645200,17),(482,1856394000,16),(482,1869094800,17),(482,1887843600,16),(482,1901149200,17),(482,1919293200,16),(482,1932598800,17),(482,1950742800,16),(482,1964048400,17),(482,1982797200,16),(482,1995498000,17),(482,2014246800,16),(482,2026947600,17),(482,2045696400,16),(482,2058397200,17),(482,2077146000,16),(482,2090451600,17),(482,2108595600,16),(482,2121901200,17),(482,2140045200,16),(483,-2147483648,0),(483,-1577761060,1),(483,-1247540400,2),(483,354916800,3),(483,370724400,2),(483,386452800,3),(483,402260400,2),(483,417988800,3),(483,433796400,2),(483,449611200,3),(483,465343200,4),(483,481068000,5),(483,496792800,4),(483,512517600,5),(483,528242400,4),(483,543967200,5),(483,559692000,4),(483,575416800,6),(483,591145200,7),(483,606870000,6),(483,622594800,7),(483,638319600,6),(483,654649200,7),(483,670374000,4),(483,701820000,6),(483,717548400,7),(483,733273200,6),(483,748998000,7),(483,764722800,6),(483,780447600,7),(483,796172400,6),(483,811897200,7),(483,828226800,6),(483,846370800,7),(483,859676400,6),(483,877820400,7),(483,891126000,6),(483,909270000,7),(483,922575600,6),(483,941324400,7),(483,954025200,6),(483,972774000,7),(483,985474800,6),(483,1004223600,7),(483,1017529200,6),(483,1035673200,7),(483,1048978800,6),(483,1067122800,7),(483,1080428400,6),(483,1099177200,7),(483,1111878000,6),(483,1130626800,7),(483,1143327600,6),(483,1162076400,7),(483,1174777200,6),(483,1193526000,7),(483,1206831600,6),(483,1224975600,7),(483,1238281200,6),(483,1256425200,7),(483,1269730800,6),(483,1288479600,7),(483,1301180400,4),(483,1414274400,7),(483,1540681200,4),(483,2147483647,4),(484,-2147483648,1),(484,-1717032240,3),(484,-1693706400,2),(484,-1680483600,3),(484,-1663455600,4),(484,-1650150000,5),(484,-1632006000,4),(484,-1618700400,8),(484,-1600473600,6),(484,-1587168000,7),(484,-1501725600,3),(484,-931734000,2),(484,-857257200,5),(484,-844556400,4),(484,-828226800,5),(484,-812502000,4),(484,-796874400,2),(484,-796608000,3),(484,-778726800,2),(484,-762660000,3),(484,-748486800,4),(484,-733273200,5),(484,-715215600,4),(484,-701910000,5),(484,-684975600,4),(484,-670460400,5),(484,-654130800,4),(484,-639010800,5),(484,-397094400,4),(484,-386812800,5),(484,-371088000,4),(484,-355363200,5),(484,-334195200,4),(484,-323308800,5),(484,-307584000,4),(484,-291859200,5),(484,-271296000,4),(484,-260409600,5),(484,-239846400,4),(484,-228960000,5),(484,-208396800,4),(484,-197510400,5),(484,-176342400,4),(484,-166060800,5),(484,220921200,3),(484,228873600,4),(484,243993600,5),(484,260323200,4),(484,276048000,5),(484,291772800,4),(484,307497600,5),(484,323827200,4),(484,338947200,5),(484,354672000,4),(484,370396800,5),(484,386121600,4),(484,401846400,5),(484,417571200,4),(484,433296000,5),(484,449020800,4),(484,465350400,5),(484,481075200,4),(484,496800000,5),(484,512524800,4),(484,528249600,5),(484,543974400,4),(484,559699200,5),(484,567990000,3),(484,575427600,9),(484,591152400,10),(484,606877200,9),(484,622602000,10),(484,638326800,9),(484,654656400,10),(484,670381200,9),(484,686106000,10),(484,701830800,9),(484,717555600,10),(484,733280400,9),(484,749005200,10),(484,764730000,9),(484,780454800,10),(484,796179600,9),(484,811904400,10),(484,828234000,9),(484,846378000,10),(484,859683600,9),(484,877827600,10),(484,891133200,9),(484,909277200,10),(484,922582800,9),(484,941331600,10),(484,954032400,9),(484,972781200,10),(484,985482000,9),(484,1004230800,10),(484,1017536400,9),(484,1035680400,10),(484,1048986000,9),(484,1067130000,10),(484,1080435600,9),(484,1099184400,10),(484,1111885200,9),(484,1130634000,10),(484,1143334800,9),(484,1162083600,10),(484,1174784400,9),(484,1193533200,10),(484,1206838800,9),(484,1224982800,10),(484,1238288400,9),(484,1256432400,10),(484,1269738000,9),(484,1288486800,10),(484,1301187600,9),(484,1319936400,10),(484,1332637200,9),(484,1351386000,10),(484,1364691600,9),(484,1382835600,10),(484,1396141200,9),(484,1414285200,10),(484,1427590800,9),(484,1445734800,10),(484,1459040400,9),(484,1477789200,10),(484,1490490000,9),(484,1509238800,10),(484,1521939600,9),(484,1540688400,10),(484,1553994000,9),(484,1572138000,10),(484,1585443600,9),(484,1603587600,10),(484,1616893200,9),(484,1635642000,10),(484,1648342800,9),(484,1667091600,10),(484,1679792400,9),(484,1698541200,10),(484,1711846800,9),(484,1729990800,10),(484,1743296400,9),(484,1761440400,10),(484,1774746000,9),(484,1792890000,10),(484,1806195600,9),(484,1824944400,10),(484,1837645200,9),(484,1856394000,10),(484,1869094800,9),(484,1887843600,10),(484,1901149200,9),(484,1919293200,10),(484,1932598800,9),(484,1950742800,10),(484,1964048400,9),(484,1982797200,10),(484,1995498000,9),(484,2014246800,10),(484,2026947600,9),(484,2045696400,10),(484,2058397200,9),(484,2077146000,10),(484,2090451600,9),(484,2108595600,10),(484,2121901200,9),(484,2140045200,10),(485,-2147483648,1),(485,-905824800,4),(485,-857257200,2),(485,-844556400,3),(485,-828226800,2),(485,-812502000,3),(485,-796777200,2),(485,-788922000,1),(485,-777942000,3),(485,-766623600,2),(485,407199600,1),(485,417574800,5),(485,433299600,6),(485,449024400,5),(485,465354000,6),(485,481078800,5),(485,496803600,6),(485,512528400,5),(485,528253200,6),(485,543978000,5),(485,559702800,6),(485,575427600,5),(485,591152400,6),(485,606877200,5),(485,622602000,6),(485,638326800,5),(485,654656400,6),(485,670381200,5),(485,686106000,6),(485,701830800,5),(485,717555600,6),(485,733280400,5),(485,749005200,6),(485,764730000,5),(485,780454800,6),(485,796179600,5),(485,811904400,6),(485,828234000,5),(485,846378000,6),(485,859683600,5),(485,877827600,6),(485,891133200,5),(485,909277200,6),(485,922582800,5),(485,941331600,6),(485,954032400,5),(485,972781200,6),(485,985482000,5),(485,1004230800,6),(485,1017536400,5),(485,1035680400,6),(485,1048986000,5),(485,1067130000,6),(485,1080435600,5),(485,1099184400,6),(485,1111885200,5),(485,1130634000,6),(485,1143334800,5),(485,1162083600,6),(485,1174784400,5),(485,1193533200,6),(485,1206838800,5),(485,1224982800,6),(485,1238288400,5),(485,1256432400,6),(485,1269738000,5),(485,1288486800,6),(485,1301187600,5),(485,1319936400,6),(485,1332637200,5),(485,1351386000,6),(485,1364691600,5),(485,1382835600,6),(485,1396141200,5),(485,1414285200,6),(485,1427590800,5),(485,1445734800,6),(485,1459040400,5),(485,1477789200,6),(485,1490490000,5),(485,1509238800,6),(485,1521939600,5),(485,1540688400,6),(485,1553994000,5),(485,1572138000,6),(485,1585443600,5),(485,1603587600,6),(485,1616893200,5),(485,1635642000,6),(485,1648342800,5),(485,1667091600,6),(485,1679792400,5),(485,1698541200,6),(485,1711846800,5),(485,1729990800,6),(485,1743296400,5),(485,1761440400,6),(485,1774746000,5),(485,1792890000,6),(485,1806195600,5),(485,1824944400,6),(485,1837645200,5),(485,1856394000,6),(485,1869094800,5),(485,1887843600,6),(485,1901149200,5),(485,1919293200,6),(485,1932598800,5),(485,1950742800,6),(485,1964048400,5),(485,1982797200,6),(485,1995498000,5),(485,2014246800,6),(485,2026947600,5),(485,2045696400,6),(485,2058397200,5),(485,2077146000,6),(485,2090451600,5),(485,2108595600,6),(485,2121901200,5),(485,2140045200,6),(486,-2147483648,1),(486,-1441160400,2),(486,-1247536800,3),(486,-894769200,6),(486,-857257200,4),(486,-844556400,5),(486,-828226800,4),(486,-826419600,3),(486,354920400,7),(486,370728000,3),(486,386456400,7),(486,402264000,3),(486,417992400,7),(486,433800000,3),(486,449614800,7),(486,465346800,8),(486,481071600,9),(486,496796400,8),(486,512521200,9),(486,528246000,8),(486,543970800,9),(486,559695600,8),(486,575420400,9),(486,591145200,8),(486,606870000,9),(486,622594800,8),(486,638319600,9),(486,654649200,8),(486,670374000,10),(486,686091600,2),(486,701820000,10),(486,717541200,2),(486,733269600,10),(486,748990800,2),(486,764719200,10),(486,780440400,2),(486,796179600,11),(486,811904400,12),(486,828234000,11),(486,846378000,12),(486,859683600,11),(486,877827600,12),(486,891133200,11),(486,909277200,12),(486,922582800,11),(486,941331600,12),(486,954032400,11),(486,972781200,12),(486,985482000,11),(486,1004230800,12),(486,1017536400,11),(486,1035680400,12),(486,1048986000,11),(486,1067130000,12),(486,1080435600,11),(486,1099184400,12),(486,1111885200,11),(486,1130634000,12),(486,1143334800,11),(486,1162083600,12),(486,1174784400,11),(486,1193533200,12),(486,1206838800,11),(486,1224982800,12),(486,1238288400,11),(486,1256432400,12),(486,1269738000,11),(486,1288486800,12),(486,1301187600,11),(486,1319936400,12),(486,1332637200,11),(486,1351386000,12),(486,1364691600,11),(486,1382835600,12),(486,1396141200,11),(486,1414285200,12),(486,1427590800,11),(486,1445734800,12),(486,1459040400,11),(486,1477789200,12),(486,1490490000,11),(486,1509238800,12),(486,1521939600,11),(486,1540688400,12),(486,1553994000,11),(486,1572138000,12),(486,1585443600,11),(486,1603587600,12),(486,1616893200,11),(486,1635642000,12),(486,1648342800,11),(486,1667091600,12),(486,1679792400,11),(486,1698541200,12),(486,1711846800,11),(486,1729990800,12),(486,1743296400,11),(486,1761440400,12),(486,1774746000,11),(486,1792890000,12),(486,1806195600,11),(486,1824944400,12),(486,1837645200,11),(486,1856394000,12),(486,1869094800,11),(486,1887843600,12),(486,1901149200,11),(486,1919293200,12),(486,1932598800,11),(486,1950742800,12),(486,1964048400,11),(486,1982797200,12),(486,1995498000,11),(486,2014246800,12),(486,2026947600,11),(486,2045696400,12),(486,2058397200,11),(486,2077146000,12),(486,2090451600,11),(486,2108595600,12),(486,2121901200,11),(486,2140045200,12),(487,-2147483648,2),(487,-904435200,1),(487,-891129600,2),(487,-872985600,1),(487,-859680000,2),(487,354675600,3),(487,370400400,4),(487,386125200,3),(487,401850000,4),(487,417574800,3),(487,433299600,4),(487,449024400,3),(487,465354000,4),(487,481078800,3),(487,496803600,4),(487,512528400,3),(487,528253200,4),(487,543978000,3),(487,559702800,4),(487,575427600,3),(487,591152400,4),(487,606877200,3),(487,622602000,4),(487,638326800,3),(487,654656400,4),(487,670381200,3),(487,686106000,4),(487,701830800,3),(487,717555600,4),(487,733280400,3),(487,749005200,4),(487,764730000,3),(487,780454800,4),(487,796179600,3),(487,811904400,4),(487,828234000,3),(487,846378000,4),(487,859683600,3),(487,877827600,4),(487,891133200,3),(487,909277200,4),(487,922582800,3),(487,941331600,4),(487,954032400,3),(487,972781200,4),(487,985482000,3),(487,1004230800,4),(487,1017536400,3),(487,1035680400,4),(487,1048986000,3),(487,1067130000,4),(487,1080435600,3),(487,1099184400,4),(487,1111885200,3),(487,1130634000,4),(487,1143334800,3),(487,1162083600,4),(487,1174784400,3),(487,1193533200,4),(487,1206838800,3),(487,1224982800,4),(487,1238288400,3),(487,1256432400,4),(487,1269738000,3),(487,1288486800,4),(487,1301187600,3),(487,1319936400,4),(487,1332637200,3),(487,1351386000,4),(487,1364691600,3),(487,1382835600,4),(487,1396141200,3),(487,1414285200,4),(487,1427590800,3),(487,1445734800,4),(487,1459040400,3),(487,1477789200,4),(487,1490490000,3),(487,1509238800,4),(487,1521939600,3),(487,1540688400,4),(487,1553994000,3),(487,1572138000,4),(487,1585443600,3),(487,1603587600,4),(487,1616893200,3),(487,1635642000,4),(487,1648342800,3),(487,1667091600,4),(487,1679792400,3),(487,1698541200,4),(487,1711846800,3),(487,1729990800,4),(487,1743296400,3),(487,1761440400,4),(487,1774746000,3),(487,1792890000,4),(487,1806195600,3),(487,1824944400,4),(487,1837645200,3),(487,1856394000,4),(487,1869094800,3),(487,1887843600,4),(487,1901149200,3),(487,1919293200,4),(487,1932598800,3),(487,1950742800,4),(487,1964048400,3),(487,1982797200,4),(487,1995498000,3),(487,2014246800,4),(487,2026947600,3),(487,2045696400,4),(487,2058397200,3),(487,2077146000,4),(487,2090451600,3),(487,2108595600,4),(487,2121901200,3),(487,2140045200,4),(488,-2147483648,2),(488,-1691964000,1),(488,-1680472800,2),(488,-1664143200,1),(488,-1650146400,2),(488,-1633903200,1),(488,-1617487200,2),(488,-1601848800,1),(488,-1586037600,2),(488,-1570399200,1),(488,-1552168800,2),(488,-1538344800,1),(488,-1522533600,2),(488,-1507500000,1),(488,-1490565600,2),(488,-1473631200,1),(488,-1460930400,2),(488,-1442786400,1),(488,-1428876000,2),(488,-1410732000,1),(488,-1396216800,2),(488,-1379282400,1),(488,-1364767200,2),(488,-1348437600,1),(488,-1333317600,2),(488,-1315778400,1),(488,-1301263200,2),(488,-1284328800,1),(488,-1269813600,2),(488,-1253484000,1),(488,-1238364000,2),(488,-1221429600,1),(488,-1206914400,2),(488,-1189980000,1),(488,-1175464800,2),(488,-1159135200,1),(488,-1143410400,2),(488,-1126476000,1),(488,-1111960800,2),(488,-1095631200,1),(488,-1080511200,2),(488,-1063576800,1),(488,-1049061600,2),(488,-1032127200,1),(488,-1017612000,2),(488,-1001282400,1),(488,-986162400,2),(488,-969228000,1),(488,-950479200,2),(488,-942012000,1),(488,-904518000,3),(488,-896050800,1),(488,-875487600,3),(488,-864601200,1),(488,-844038000,3),(488,-832546800,1),(488,-812588400,3),(488,-798073200,1),(488,-781052400,3),(488,-772066800,1),(488,-764805600,2),(488,-748476000,1),(488,-733356000,2),(488,-719445600,1),(488,-717030000,3),(488,-706748400,1),(488,-699487200,2),(488,-687996000,1),(488,-668037600,2),(488,-654732000,1),(488,-636588000,2),(488,-622072800,1),(488,-605743200,2),(488,-590623200,1),(488,-574293600,2),(488,-558568800,1),(488,-542239200,2),(488,-527119200,1),(488,-512604000,2),(488,-496274400,1),(488,-481154400,2),(488,-464220000,1),(488,-449704800,2),(488,-432165600,1),(488,-417650400,2),(488,-401320800,1),(488,-386200800,2),(488,-369266400,1),(488,-354751200,2),(488,-337816800,1),(488,-323301600,2),(488,-306972000,1),(488,-291852000,2),(488,-276732000,1),(488,-257983200,2),(488,-245282400,1),(488,-226533600,2),(488,-213228000,1),(488,-195084000,2),(488,-182383200,1),(488,-163634400,2),(488,-150933600,1),(488,-132184800,2),(488,-119484000,1),(488,-100735200,2),(488,-88034400,1),(488,-68680800,2),(488,-59004000,1),(488,-37242000,4),(488,57722400,6),(488,69818400,1),(488,89172000,2),(488,101268000,1),(488,120621600,2),(488,132717600,1),(488,152071200,2),(488,164167200,1),(488,183520800,2),(488,196221600,1),(488,214970400,2),(488,227671200,1),(488,246420000,2),(488,259120800,1),(488,278474400,2),(488,290570400,1),(488,309924000,2),(488,322020000,1),(488,341373600,2),(488,354675600,5),(488,372819600,6),(488,386125200,5),(488,404269200,6),(488,417574800,5),(488,435718800,6),(488,449024400,5),(488,467773200,6),(488,481078800,5),(488,499222800,6),(488,512528400,5),(488,530672400,6),(488,543978000,5),(488,562122000,6),(488,575427600,5),(488,593571600,6),(488,606877200,5),(488,625626000,6),(488,638326800,5),(488,657075600,6),(488,670381200,5),(488,688525200,6),(488,701830800,5),(488,719974800,6),(488,733280400,5),(488,751424400,6),(488,764730000,5),(488,782874000,6),(488,796179600,5),(488,814323600,6),(488,820454400,7),(488,828234000,5),(488,846378000,6),(488,859683600,5),(488,877827600,6),(488,891133200,5),(488,909277200,6),(488,922582800,5),(488,941331600,6),(488,954032400,5),(488,972781200,6),(488,985482000,5),(488,1004230800,6),(488,1017536400,5),(488,1035680400,6),(488,1048986000,5),(488,1067130000,6),(488,1080435600,5),(488,1099184400,6),(488,1111885200,5),(488,1130634000,6),(488,1143334800,5),(488,1162083600,6),(488,1174784400,5),(488,1193533200,6),(488,1206838800,5),(488,1224982800,6),(488,1238288400,5),(488,1256432400,6),(488,1269738000,5),(488,1288486800,6),(488,1301187600,5),(488,1319936400,6),(488,1332637200,5),(488,1351386000,6),(488,1364691600,5),(488,1382835600,6),(488,1396141200,5),(488,1414285200,6),(488,1427590800,5),(488,1445734800,6),(488,1459040400,5),(488,1477789200,6),(488,1490490000,5),(488,1509238800,6),(488,1521939600,5),(488,1540688400,6),(488,1553994000,5),(488,1572138000,6),(488,1585443600,5),(488,1603587600,6),(488,1616893200,5),(488,1635642000,6),(488,1648342800,5),(488,1667091600,6),(488,1679792400,5),(488,1698541200,6),(488,1711846800,5),(488,1729990800,6),(488,1743296400,5),(488,1761440400,6),(488,1774746000,5),(488,1792890000,6),(488,1806195600,5),(488,1824944400,6),(488,1837645200,5),(488,1856394000,6),(488,1869094800,5),(488,1887843600,6),(488,1901149200,5),(488,1919293200,6),(488,1932598800,5),(488,1950742800,6),(488,1964048400,5),(488,1982797200,6),(488,1995498000,5),(488,2014246800,6),(488,2026947600,5),(488,2045696400,6),(488,2058397200,5),(488,2077146000,6),(488,2090451600,5),(488,2108595600,6),(488,2121901200,5),(488,2140045200,6),(489,-2147483648,2),(489,-1691964000,1),(489,-1680472800,2),(489,-1664143200,1),(489,-1650146400,2),(489,-1633903200,1),(489,-1617487200,2),(489,-1601848800,1),(489,-1586037600,2),(489,-1570399200,1),(489,-1552168800,2),(489,-1538344800,1),(489,-1522533600,2),(489,-1507500000,1),(489,-1490565600,2),(489,-1473631200,1),(489,-1460930400,2),(489,-1442786400,1),(489,-1428876000,2),(489,-1410732000,1),(489,-1396216800,2),(489,-1379282400,1),(489,-1364767200,2),(489,-1348437600,1),(489,-1333317600,2),(489,-1315778400,1),(489,-1301263200,2),(489,-1284328800,1),(489,-1269813600,2),(489,-1253484000,1),(489,-1238364000,2),(489,-1221429600,1),(489,-1206914400,2),(489,-1189980000,1),(489,-1175464800,2),(489,-1159135200,1),(489,-1143410400,2),(489,-1126476000,1),(489,-1111960800,2),(489,-1095631200,1),(489,-1080511200,2),(489,-1063576800,1),(489,-1049061600,2),(489,-1032127200,1),(489,-1017612000,2),(489,-1001282400,1),(489,-986162400,2),(489,-969228000,1),(489,-950479200,2),(489,-942012000,1),(489,-904518000,3),(489,-896050800,1),(489,-875487600,3),(489,-864601200,1),(489,-844038000,3),(489,-832546800,1),(489,-812588400,3),(489,-798073200,1),(489,-781052400,3),(489,-772066800,1),(489,-764805600,2),(489,-748476000,1),(489,-733356000,2),(489,-719445600,1),(489,-717030000,3),(489,-706748400,1),(489,-699487200,2),(489,-687996000,1),(489,-668037600,2),(489,-654732000,1),(489,-636588000,2),(489,-622072800,1),(489,-605743200,2),(489,-590623200,1),(489,-574293600,2),(489,-558568800,1),(489,-542239200,2),(489,-527119200,1),(489,-512604000,2),(489,-496274400,1),(489,-481154400,2),(489,-464220000,1),(489,-449704800,2),(489,-432165600,1),(489,-417650400,2),(489,-401320800,1),(489,-386200800,2),(489,-369266400,1),(489,-354751200,2),(489,-337816800,1),(489,-323301600,2),(489,-306972000,1),(489,-291852000,2),(489,-276732000,1),(489,-257983200,2),(489,-245282400,1),(489,-226533600,2),(489,-213228000,1),(489,-195084000,2),(489,-182383200,1),(489,-163634400,2),(489,-150933600,1),(489,-132184800,2),(489,-119484000,1),(489,-100735200,2),(489,-88034400,1),(489,-68680800,2),(489,-59004000,1),(489,-37242000,4),(489,57722400,6),(489,69818400,1),(489,89172000,2),(489,101268000,1),(489,120621600,2),(489,132717600,1),(489,152071200,2),(489,164167200,1),(489,183520800,2),(489,196221600,1),(489,214970400,2),(489,227671200,1),(489,246420000,2),(489,259120800,1),(489,278474400,2),(489,290570400,1),(489,309924000,2),(489,322020000,1),(489,341373600,2),(489,354675600,5),(489,372819600,6),(489,386125200,5),(489,404269200,6),(489,417574800,5),(489,435718800,6),(489,449024400,5),(489,467773200,6),(489,481078800,5),(489,499222800,6),(489,512528400,5),(489,530672400,6),(489,543978000,5),(489,562122000,6),(489,575427600,5),(489,593571600,6),(489,606877200,5),(489,625626000,6),(489,638326800,5),(489,657075600,6),(489,670381200,5),(489,688525200,6),(489,701830800,5),(489,719974800,6),(489,733280400,5),(489,751424400,6),(489,764730000,5),(489,782874000,6),(489,796179600,5),(489,814323600,6),(489,820454400,7),(489,828234000,5),(489,846378000,6),(489,859683600,5),(489,877827600,6),(489,891133200,5),(489,909277200,6),(489,922582800,5),(489,941331600,6),(489,954032400,5),(489,972781200,6),(489,985482000,5),(489,1004230800,6),(489,1017536400,5),(489,1035680400,6),(489,1048986000,5),(489,1067130000,6),(489,1080435600,5),(489,1099184400,6),(489,1111885200,5),(489,1130634000,6),(489,1143334800,5),(489,1162083600,6),(489,1174784400,5),(489,1193533200,6),(489,1206838800,5),(489,1224982800,6),(489,1238288400,5),(489,1256432400,6),(489,1269738000,5),(489,1288486800,6),(489,1301187600,5),(489,1319936400,6),(489,1332637200,5),(489,1351386000,6),(489,1364691600,5),(489,1382835600,6),(489,1396141200,5),(489,1414285200,6),(489,1427590800,5),(489,1445734800,6),(489,1459040400,5),(489,1477789200,6),(489,1490490000,5),(489,1509238800,6),(489,1521939600,5),(489,1540688400,6),(489,1553994000,5),(489,1572138000,6),(489,1585443600,5),(489,1603587600,6),(489,1616893200,5),(489,1635642000,6),(489,1648342800,5),(489,1667091600,6),(489,1679792400,5),(489,1698541200,6),(489,1711846800,5),(489,1729990800,6),(489,1743296400,5),(489,1761440400,6),(489,1774746000,5),(489,1792890000,6),(489,1806195600,5),(489,1824944400,6),(489,1837645200,5),(489,1856394000,6),(489,1869094800,5),(489,1887843600,6),(489,1901149200,5),(489,1919293200,6),(489,1932598800,5),(489,1950742800,6),(489,1964048400,5),(489,1982797200,6),(489,1995498000,5),(489,2014246800,6),(489,2026947600,5),(489,2045696400,6),(489,2058397200,5),(489,2077146000,6),(489,2090451600,5),(489,2108595600,6),(489,2121901200,5),(489,2140045200,6),(496,-2147483648,0),(496,-2056690800,1),(496,-900909000,2),(496,-891579600,3),(496,-884248200,4),(496,-766659600,1),(496,-747981000,2),(496,-728544600,1),(496,-717049800,2),(496,-694503000,1),(496,-683785800,2),(496,-668064600,1),(496,-654755400,2),(496,-636615000,1),(496,-623305800,2),(496,-605165400,1),(496,-591856200,2),(496,-573715800,1),(496,-559801800,2),(496,-541661400,1),(496,-528352200,2),(496,-510211800,1),(496,-498112200,2),(496,-478762200,1),(496,-466662600,2),(496,-446707800,1),(496,-435213000,2),(496,-415258200,1),(496,-403158600,2),(496,-383808600,1),(496,-371709000,2),(496,-352359000,1),(496,-340259400,2),(496,-320909400,1),(496,-308809800,2),(496,-288855000,1),(496,-277360200,2),(496,-257405400,1),(496,-245910600,2),(496,-225955800,1),(496,-213856200,2),(496,-194506200,1),(496,-182406600,2),(496,-163056600,1),(496,-148537800,2),(496,-132816600,1),(496,-117088200,2),(496,-101367000,1),(496,-85638600,2),(496,-69312600,1),(496,-53584200,2),(496,-37863000,1),(496,-22134600,2),(496,-6413400,1),(496,9315000,2),(496,25036200,1),(496,40764600,2),(496,56485800,1),(496,72214200,2),(496,88540200,1),(496,104268600,2),(496,119989800,1),(496,126041400,2),(496,151439400,1),(496,167167800,2),(496,182889000,1),(496,198617400,2),(496,214338600,1),(496,295385400,2),(496,309292200,1),(497,-2147483648,0),(497,-1956609120,2),(497,-1668211200,1),(497,-1647212400,2),(497,-1636675200,1),(497,-1613430000,2),(497,-1605139200,1),(497,-1581894000,2),(497,-1539561600,1),(497,-1531350000,2),(497,-968025600,1),(497,-952293600,2),(497,-942008400,1),(497,-920239200,3),(497,-909957600,4),(497,-888789600,3),(497,-877903200,4),(497,-857944800,3),(497,-846453600,4),(497,-826495200,3),(497,-815004000,4),(497,-795045600,3),(497,-783554400,4),(497,-762991200,3),(497,-752104800,4),(497,-731541600,3),(497,-717631200,4),(497,-700092000,3),(497,-686181600,4),(497,-668642400,3),(497,-654732000,4),(497,-636588000,3),(497,-623282400,4),(497,-605743200,3),(497,-591832800,4),(497,-573688800,3),(497,-559778400,4),(497,-542239200,3),(497,-528328800,4),(497,-510789600,3),(497,-496879200,4),(497,-479340000,3),(497,-465429600,4),(497,-447890400,3),(497,-433980000,4),(497,-415836000,3),(497,-401925600,4),(497,-384386400,3),(497,-370476000,4),(497,-352936800,3),(497,-339026400,4),(497,-321487200,3),(497,-307576800,4),(497,-290037600,3),(497,-276127200,4),(497,-258588000,3),(497,-244677600,4),(497,-226533600,3),(497,-212623200,4),(497,-195084000,3),(497,-181173600,4),(497,-163634400,3),(497,-149724000,4),(497,-132184800,3),(497,-118274400,4),(497,-100735200,3),(497,-86824800,4),(497,-68680800,3),(497,-54770400,5),(498,-2147483648,0),(498,-1309746436,1),(498,-1262314800,2),(498,-946780200,3),(498,-315629100,1),(499,-2147483648,0),(499,-1988167780,1),(499,820436400,2),(499,2147483647,2),(500,-2147483648,1),(500,2147483647,1),(501,-2147483648,1),(501,2147483647,1),(502,-2147483648,0),(502,-1309746436,1),(502,-1262314800,2),(502,-946780200,3),(502,-315629100,1),(503,-2147483648,0),(503,-631152000,1),(503,2147483647,1),(504,-2147483648,0),(504,-2006653308,1),(504,2147483647,1),(505,-2147483648,1),(505,-315636840,2),(505,2147483647,2),(506,-2147483648,0),(506,-1988164200,2),(506,403041600,1),(506,417034800,2),(506,1224972000,1),(506,1238274000,2),(506,2147483647,2),(507,-2147483648,0),(507,-1309746436,1),(507,-1262314800,2),(507,-946780200,3),(507,-315629100,1),(508,-2147483648,0),(508,-1848886912,1),(508,2147483647,1),(509,-2147483648,0),(509,-1704165944,1),(509,-757394744,2),(509,247177800,4),(509,259272000,3),(509,277758000,4),(509,283982400,2),(509,290809800,5),(509,306531000,2),(509,322432200,5),(509,338499000,2),(509,673216200,5),(509,685481400,2),(509,701209800,5),(509,717103800,2),(509,732745800,5),(509,748639800,2),(509,764281800,5),(509,780175800,2),(509,795817800,5),(509,811711800,2),(509,827353800,5),(509,843247800,2),(509,858976200,5),(509,874870200,2),(509,890512200,5),(509,906406200,2),(509,922048200,5),(509,937942200,2),(509,953584200,5),(509,969478200,2),(509,985206600,5),(509,1001100600,2),(509,1016742600,5),(509,1032636600,2),(509,1048278600,5),(509,1064172600,2),(509,1079814600,5),(509,1095708600,2),(509,1111437000,5),(509,1127331000,2),(509,1206045000,5),(509,1221939000,2),(509,1237667400,5),(509,1253561400,2),(509,1269203400,5),(509,1285097400,2),(509,1300739400,5),(509,1316633400,2),(509,1332275400,5),(509,1348169400,2),(509,1363897800,5),(509,1379791800,2),(509,1395433800,5),(509,1411327800,2),(509,1426969800,5),(509,1442863800,2),(509,1458505800,5),(509,1474399800,2),(509,1490128200,5),(509,1506022200,2),(509,1521664200,5),(509,1537558200,2),(509,1553200200,5),(509,1569094200,2),(509,1584736200,5),(509,1600630200,2),(509,1616358600,5),(509,1632252600,2),(509,1647894600,5),(509,1663788600,2),(509,1679430600,5),(509,1695324600,2),(509,1710966600,5),(509,1726860600,2),(509,1742589000,5),(509,1758483000,2),(509,1774125000,5),(509,1790019000,2),(509,1805661000,5),(509,1821555000,2),(509,1837197000,5),(509,1853091000,2),(509,1868733000,5),(509,1884627000,2),(509,1900355400,5),(509,1916249400,2),(509,1931891400,5),(509,1947785400,2),(509,1963427400,5),(509,1979321400,2),(509,1994963400,5),(509,2010857400,2),(509,2026585800,5),(509,2042479800,2),(509,2058121800,5),(509,2074015800,2),(509,2089657800,5),(509,2105551800,2),(509,2121193800,5),(509,2137087800,2),(510,-2147483648,1),(510,-1641003640,3),(510,-933645600,2),(510,-857358000,3),(510,-844300800,2),(510,-825822000,3),(510,-812685600,2),(510,-794199600,3),(510,-779853600,2),(510,-762656400,3),(510,-748310400,2),(510,-731127600,3),(510,-681962400,4),(510,-673243200,2),(510,-667962000,3),(510,-652327200,2),(510,-636426000,3),(510,-622087200,2),(510,-608947200,3),(510,-591847200,2),(510,-572486400,3),(510,-558576000,2),(510,-542851200,3),(510,-527731200,2),(510,-514425600,3),(510,-490845600,2),(510,-482986800,3),(510,-459475200,2),(510,-451537200,3),(510,-428551200,2),(510,-418262400,3),(510,-400032000,2),(510,-387428400,3),(510,142380000,2),(510,150843600,3),(510,167176800,2),(510,178664400,3),(510,334015200,2),(510,337644000,3),(510,452556000,2),(510,462232800,3),(510,482277600,2),(510,495579600,3),(510,516751200,2),(510,526424400,3),(510,545436000,2),(510,558478800,3),(510,576626400,2),(510,589323600,3),(510,609890400,2),(510,620773200,3),(510,638316000,2),(510,651618000,3),(510,669765600,2),(510,683672400,3),(510,701820000,2),(510,715726800,3),(510,733701600,2),(510,747176400,3),(510,765151200,2),(510,778021200,3),(510,796600800,2),(510,810075600,3),(510,826840800,2),(510,842821200,3),(510,858895200,2),(510,874184400,3),(510,890344800,2),(510,905029200,3),(510,923011200,2),(510,936313200,3),(510,955670400,2),(510,970783200,3),(510,986770800,2),(510,1001282400,3),(510,1017356400,2),(510,1033941600,3),(510,1048806000,2),(510,1065132000,3),(510,1081292400,2),(510,1095804000,3),(510,1112313600,2),(510,1128812400,3),(510,1143763200,2),(510,1159657200,3),(510,1175212800,2),(510,1189897200,3),(510,1206662400,2),(510,1223161200,3),(510,1238112000,2),(510,1254006000,3),(510,1269561600,2),(510,1284246000,3),(510,1301616000,2),(510,1317510000,3),(510,1333065600,2),(510,1348354800,3),(510,1364515200,2),(510,1382828400,3),(510,1395964800,2),(510,1414278000,3),(510,1427414400,2),(510,1445727600,3),(510,1458864000,2),(510,1477782000,3),(510,1490313600,2),(510,1509231600,3),(510,1521763200,2),(510,1540681200,3),(510,1553817600,2),(510,1572130800,3),(510,1585267200,2),(510,1603580400,3),(510,1616716800,2),(510,1635634800,3),(510,1648166400,2),(510,1667084400,3),(510,1679616000,2),(510,1698534000,3),(510,1711670400,2),(510,1729983600,3),(510,1743120000,2),(510,1761433200,3),(510,1774569600,2),(510,1792882800,3),(510,1806019200,2),(510,1824937200,3),(510,1837468800,2),(510,1856386800,3),(510,1868918400,2),(510,1887836400,3),(510,1900972800,2),(510,1919286000,3),(510,1932422400,2),(510,1950735600,3),(510,1963872000,2),(510,1982790000,3),(510,1995321600,2),(510,2014239600,3),(510,2026771200,2),(510,2045689200,3),(510,2058220800,2),(510,2077138800,3),(510,2090275200,2),(510,2108588400,3),(510,2121724800,2),(510,2140038000,3),(511,-2147483648,1),(511,-1827687170,2),(511,126687600,3),(511,152085600,2),(511,162370800,3),(511,183535200,2),(511,199263600,3),(511,215589600,2),(511,230713200,3),(511,247039200,2),(511,262767600,3),(511,278488800,2),(511,294217200,3),(511,309938400,2),(511,325666800,3),(511,341388000,2),(511,357116400,3),(511,372837600,2),(511,388566000,3),(511,404892000,2),(511,420015600,3),(511,436341600,2),(512,-2147483648,3),(512,-683802000,1),(512,-672310800,2),(512,-654771600,1),(512,-640861200,2),(512,-620298000,1),(512,-609411600,2),(512,-588848400,1),(512,-577962000,2),(513,-2147483648,1),(513,-1041418800,2),(513,-907408800,3),(513,-817462800,1),(513,-7988400,4),(513,745934400,5),(513,2147483647,5),(514,-2147483648,0),(514,-1577926364,2),(514,-574902000,1),(514,-568087200,2),(514,-512175600,1),(514,-504928800,2),(514,-449888400,1),(514,-441856800,2),(514,-347158800,3),(514,378684000,2),(514,386463600,1),(514,402271200,2),(514,417999600,1),(514,433807200,2),(514,449622000,1),(514,465429600,2),(514,481590000,1),(514,496965600,2),(514,512953200,1),(514,528674400,2),(514,544230000,1),(514,560037600,2),(514,575852400,1),(514,591660000,2),(514,607388400,1),(514,623196000,2),(514,641775600,3),(514,844034400,2),(514,860108400,1),(514,875916000,3),(514,1352505600,2),(514,1364515200,1),(514,1382659200,3),(515,-1693706400,0),(515,-1680483600,1),(515,-1663455600,2),(515,-1650150000,3),(515,-1632006000,2),(515,-1618700400,3),(515,-938905200,2),(515,-857257200,3),(515,-844556400,2),(515,-828226800,3),(515,-812502000,2),(515,-796777200,3),(515,-781052400,2),(515,-766623600,3),(515,228877200,2),(515,243997200,3),(515,260326800,2),(515,276051600,3),(515,291776400,2),(515,307501200,3),(515,323830800,2),(515,338950800,3),(515,354675600,2),(515,370400400,3),(515,386125200,2),(515,401850000,3),(515,417574800,2),(515,433299600,3),(515,449024400,2),(515,465354000,3),(515,481078800,2),(515,496803600,3),(515,512528400,2),(515,528253200,3),(515,543978000,2),(515,559702800,3),(515,575427600,2),(515,591152400,3),(515,606877200,2),(515,622602000,3),(515,638326800,2),(515,654656400,3),(515,670381200,2),(515,686106000,3),(515,701830800,2),(515,717555600,3),(515,733280400,2),(515,749005200,3),(515,764730000,2),(515,780454800,3),(515,796179600,2),(515,811904400,3),(515,828234000,2),(515,846378000,3),(515,859683600,2),(515,877827600,3),(515,891133200,2),(515,909277200,3),(515,922582800,2),(515,941331600,3),(515,954032400,2),(515,972781200,3),(515,985482000,2),(515,1004230800,3),(515,1017536400,2),(515,1035680400,3),(515,1048986000,2),(515,1067130000,3),(515,1080435600,2),(515,1099184400,3),(515,1111885200,2),(515,1130634000,3),(515,1143334800,2),(515,1162083600,3),(515,1174784400,2),(515,1193533200,3),(515,1206838800,2),(515,1224982800,3),(515,1238288400,2),(515,1256432400,3),(515,1269738000,2),(515,1288486800,3),(515,1301187600,2),(515,1319936400,3),(515,1332637200,2),(515,1351386000,3),(515,1364691600,2),(515,1382835600,3),(515,1396141200,2),(515,1414285200,3),(515,1427590800,2),(515,1445734800,3),(515,1459040400,2),(515,1477789200,3),(515,1490490000,2),(515,1509238800,3),(515,1521939600,2),(515,1540688400,3),(515,1553994000,2),(515,1572138000,3),(515,1585443600,2),(515,1603587600,3),(515,1616893200,2),(515,1635642000,3),(515,1648342800,2),(515,1667091600,3),(515,1679792400,2),(515,1698541200,3),(515,1711846800,2),(515,1729990800,3),(515,1743296400,2),(515,1761440400,3),(515,1774746000,2),(515,1792890000,3),(515,1806195600,2),(515,1824944400,3),(515,1837645200,2),(515,1856394000,3),(515,1869094800,2),(515,1887843600,3),(515,1901149200,2),(515,1919293200,3),(515,1932598800,2),(515,1950742800,3),(515,1964048400,2),(515,1982797200,3),(515,1995498000,2),(515,2014246800,3),(515,2026947600,2),(515,2045696400,3),(515,2058397200,2),(515,2077146000,3),(515,2090451600,2),(515,2108595600,3),(515,2121901200,2),(515,2140045200,3),(517,-1633273200,0),(517,-1615132800,1),(517,-1601823600,0),(517,-1583683200,1),(517,-880210800,2),(517,-769395600,3),(517,-765388800,1),(517,-84380400,0),(517,-68659200,1),(517,-52930800,0),(517,-37209600,1),(517,-21481200,0),(517,-5760000,1),(517,9968400,0),(517,25689600,1),(517,41418000,0),(517,57744000,1),(517,73472400,0),(517,89193600,1),(517,104922000,0),(517,120643200,1),(517,126694800,0),(517,152092800,1),(517,162378000,0),(517,183542400,1),(517,199270800,0),(517,215596800,1),(517,230720400,0),(517,247046400,1),(517,262774800,0),(517,278496000,1),(517,294224400,0),(517,309945600,1),(517,325674000,0),(517,341395200,1),(517,357123600,0),(517,372844800,1),(517,388573200,0),(517,404899200,1),(517,420022800,0),(517,436348800,1),(517,452077200,0),(517,467798400,1),(517,483526800,0),(517,499248000,1),(517,514976400,0),(517,530697600,1),(517,544611600,0),(517,562147200,1),(517,576061200,0),(517,594201600,1),(517,607510800,0),(517,625651200,1),(517,638960400,0),(517,657100800,1),(517,671014800,0),(517,688550400,1),(517,702464400,0),(517,720000000,1),(517,733914000,0),(517,752054400,1),(517,765363600,0),(517,783504000,1),(517,796813200,0),(517,814953600,1),(517,828867600,0),(517,846403200,1),(517,860317200,0),(517,877852800,1),(517,891766800,0),(517,909302400,1),(517,923216400,0),(517,941356800,1),(517,954666000,0),(517,972806400,1),(517,986115600,0),(517,1004256000,1),(517,1018170000,0),(517,1035705600,1),(517,1049619600,0),(517,1067155200,1),(517,1081069200,0),(517,1099209600,1),(517,1112518800,0),(517,1130659200,1),(517,1143968400,0),(517,1162108800,1),(517,1173603600,0),(517,1194163200,1),(517,1205053200,0),(517,1225612800,1),(517,1236502800,0),(517,1257062400,1),(517,1268557200,0),(517,1289116800,1),(517,1300006800,0),(517,1320566400,1),(517,1331456400,0),(517,1352016000,1),(517,1362906000,0),(517,1383465600,1),(517,1394355600,0),(517,1414915200,1),(517,1425805200,0),(517,1446364800,1),(517,1457859600,0),(517,1478419200,1),(517,1489309200,0),(517,1509868800,1),(517,1520758800,0),(517,1541318400,1),(517,1552208400,0),(517,1572768000,1),(517,1583658000,0),(517,1604217600,1),(517,1615712400,0),(517,1636272000,1),(517,1647162000,0),(517,1667721600,1),(517,1678611600,0),(517,1699171200,1),(517,1710061200,0),(517,1730620800,1),(517,1741510800,0),(517,1762070400,1),(517,1772960400,0),(517,1793520000,1),(517,1805014800,0),(517,1825574400,1),(517,1836464400,0),(517,1857024000,1),(517,1867914000,0),(517,1888473600,1),(517,1899363600,0),(517,1919923200,1),(517,1930813200,0),(517,1951372800,1),(517,1962867600,0),(517,1983427200,1),(517,1994317200,0),(517,2014876800,1),(517,2025766800,0),(517,2046326400,1),(517,2057216400,0),(517,2077776000,1),(517,2088666000,0),(517,2109225600,1),(517,2120115600,0),(517,2140675200,1),(518,-2147483648,0),(518,-1514736000,1),(518,-1451667600,2),(518,-1343062800,1),(518,-1234803600,2),(518,-1222963200,3),(518,-1207242000,2),(518,-873820800,4),(518,-769395600,5),(518,-761677200,2),(518,-686073600,3),(518,-661539600,2),(518,-495039600,3),(518,-481734000,2),(518,-463590000,3),(518,-450284400,2),(518,-431535600,3),(518,-418230000,2),(518,-400086000,3),(518,-386780400,2),(518,-368636400,3),(518,-355330800,2),(518,-337186800,3),(518,-323881200,2),(518,-305737200,3),(518,-292431600,2),(518,199274400,3),(518,215600400,2),(518,230724000,3),(518,247050000,2),(518,262778400,3),(518,278499600,2),(518,294228000,3),(518,309949200,2),(518,325677600,3),(518,341398800,2),(518,357127200,3),(518,372848400,2),(518,388576800,3),(518,404902800,2),(518,420026400,3),(518,436352400,2),(518,452080800,3),(518,467802000,2),(518,483530400,3),(518,499251600,2),(518,514980000,3),(518,530701200,2),(518,544615200,3),(518,562150800,2),(518,576064800,3),(518,594205200,2),(518,607514400,3),(518,625654800,2),(518,638964000,3),(518,657104400,2),(518,671018400,3),(518,688554000,2),(518,702468000,3),(518,720003600,2),(518,733917600,3),(518,752058000,2),(518,765367200,3),(518,783507600,2),(518,796816800,3),(518,814957200,2),(518,828871200,3),(518,846406800,2),(518,860320800,3),(518,877856400,2),(518,891770400,3),(518,909306000,2),(518,923220000,3),(518,941360400,2),(518,954669600,3),(518,972810000,2),(518,986119200,3),(518,1004259600,2),(518,1018173600,3),(518,1035709200,2),(518,1049623200,3),(518,1067158800,2),(518,1081072800,3),(518,1099213200,2),(518,1112522400,3),(518,1130662800,2),(518,1143972000,3),(518,1162112400,2),(518,1175421600,3),(518,1193562000,2),(518,1207476000,3),(518,1225011600,2),(518,1238925600,3),(518,1256461200,2),(518,1268560800,3),(518,1289120400,2),(518,1300010400,3),(518,1320570000,2),(518,1331460000,3),(518,1352019600,2),(518,1362909600,3),(518,1383469200,2),(518,1394359200,3),(518,1414918800,2),(518,1425808800,3),(518,1446368400,2),(518,1457863200,3),(518,1478422800,2),(518,1489312800,3),(518,1509872400,2),(518,1520762400,3),(518,1541322000,2),(518,1552212000,3),(518,1572771600,2),(518,1583661600,3),(518,1604221200,2),(518,1615716000,3),(518,1636275600,2),(518,1647165600,3),(518,1667725200,2),(518,1678615200,3),(518,1699174800,2),(518,1710064800,3),(518,1730624400,2),(518,1741514400,3),(518,1762074000,2),(518,1772964000,3),(518,1793523600,2),(518,1805018400,3),(518,1825578000,2),(518,1836468000,3),(518,1857027600,2),(518,1867917600,3),(518,1888477200,2),(518,1899367200,3),(518,1919926800,2),(518,1930816800,3),(518,1951376400,2),(518,1962871200,3),(518,1983430800,2),(518,1994320800,3),(518,2014880400,2),(518,2025770400,3),(518,2046330000,2),(518,2057220000,3),(518,2077779600,2),(518,2088669600,3),(518,2109229200,2),(518,2120119200,3),(518,2140678800,2),(519,-2147483648,0),(519,-1514739600,1),(519,-1343066400,2),(519,-1234807200,1),(519,-1220292000,2),(519,-1207159200,1),(519,-1191344400,2),(519,-873828000,1),(519,-661539600,3),(519,28800,1),(519,828867600,4),(519,846403200,1),(519,860317200,4),(519,877852800,1),(519,891766800,4),(519,909302400,1),(519,923216400,4),(519,941356800,1),(519,954666000,4),(519,972806400,1),(519,989139600,4),(519,1001836800,1),(519,1018170000,4),(519,1035705600,1),(519,1049619600,4),(519,1067155200,1),(519,1081069200,4),(519,1099209600,1),(519,1112518800,4),(519,1130659200,1),(519,1143968400,4),(519,1162108800,1),(519,1175418000,4),(519,1193558400,1),(519,1207472400,4),(519,1225008000,1),(519,1238922000,4),(519,1256457600,1),(519,1270371600,4),(519,1288512000,1),(519,1301821200,4),(519,1319961600,1),(519,1333270800,4),(519,1351411200,1),(519,1365325200,4),(519,1382860800,1),(519,1396774800,4),(519,1414310400,1),(519,1428224400,4),(519,1445760000,1),(519,1459674000,4),(519,1477814400,1),(519,1491123600,4),(519,1509264000,1),(519,1522573200,4),(519,1540713600,1),(519,1554627600,4),(519,1572163200,1),(519,1586077200,4),(519,1603612800,1),(519,1617526800,4),(519,1635667200,1),(519,1648976400,4),(519,1667116800,1),(519,1680426000,4),(519,1698566400,1),(519,1712480400,4),(519,1730016000,1),(519,1743930000,4),(519,1761465600,1),(519,1775379600,4),(519,1792915200,1),(519,1806829200,4),(519,1824969600,1),(519,1838278800,4),(519,1856419200,1),(519,1869728400,4),(519,1887868800,1),(519,1901782800,4),(519,1919318400,1),(519,1933232400,4),(519,1950768000,1),(519,1964682000,4),(519,1982822400,1),(519,1996131600,4),(519,2014272000,1),(519,2027581200,4),(519,2045721600,1),(519,2059030800,4),(519,2077171200,1),(519,2091085200,4),(519,2108620800,1),(519,2122534800,4),(519,2140070400,1),(520,-2147483648,0),(520,-1514739600,1),(520,-1343066400,2),(520,-1234807200,1),(520,-1220292000,2),(520,-1207159200,1),(520,-1191344400,2),(520,-975261600,3),(520,-963169200,2),(520,-917114400,3),(520,-907354800,2),(520,-821901600,4),(520,-810068400,2),(520,-627501600,3),(520,-612990000,2),(520,828864000,3),(520,846399600,2),(520,860313600,3),(520,877849200,2),(520,891763200,3),(520,909298800,2),(520,923212800,3),(520,941353200,2),(520,954662400,3),(520,972802800,2),(520,989136000,3),(520,1001833200,2),(520,1018166400,3),(520,1035702000,2),(520,1049616000,3),(520,1067151600,2),(520,1081065600,3),(520,1099206000,2),(520,1112515200,3),(520,1130655600,2),(520,1143964800,3),(520,1162105200,2),(520,1175414400,3),(520,1193554800,2),(520,1207468800,3),(520,1225004400,2),(520,1238918400,3),(520,1256454000,2),(520,1270368000,3),(520,1288508400,2),(520,1301817600,3),(520,1319958000,2),(520,1333267200,3),(520,1351407600,2),(520,1365321600,3),(520,1382857200,2),(520,1396771200,3),(520,1414306800,2),(520,1428220800,3),(520,1445756400,2),(520,1459670400,3),(520,1477810800,2),(520,1491120000,3),(520,1509260400,2),(520,1522569600,3),(520,1540710000,2),(520,1554624000,3),(520,1572159600,2),(520,1586073600,3),(520,1603609200,2),(520,1617523200,3),(520,1635663600,2),(520,1648972800,3),(520,1667113200,2),(520,1680422400,3),(520,1698562800,2),(520,1712476800,3),(520,1730012400,2),(520,1743926400,3),(520,1761462000,2),(520,1775376000,3),(520,1792911600,2),(520,1806825600,3),(520,1824966000,2),(520,1838275200,3),(520,1856415600,2),(520,1869724800,3),(520,1887865200,2),(520,1901779200,3),(520,1919314800,2),(520,1933228800,3),(520,1950764400,2),(520,1964678400,3),(520,1982818800,2),(520,1996128000,3),(520,2014268400,2),(520,2027577600,3),(520,2045718000,2),(520,2059027200,3),(520,2077167600,2),(520,2091081600,3),(520,2108617200,2),(520,2122531200,3),(520,2140066800,2),(521,-2147483648,2),(521,-1330335000,1),(521,-1320057000,2),(521,-1300699800,3),(521,-1287396000,2),(521,-1269250200,3),(521,-1255946400,2),(521,-1237800600,3),(521,-1224496800,2),(521,-1206351000,3),(521,-1192442400,2),(521,-1174901400,3),(521,-1160992800,2),(521,-1143451800,3),(521,-1125914400,2),(521,-1112607000,3),(521,-1094464800,2),(521,-1081157400,3),(521,-1063015200,2),(521,-1049707800,3),(521,-1031565600,2),(521,-1018258200,3),(521,-1000116000,2),(521,-986808600,3),(521,-968061600,2),(521,-955359000,3),(521,-936612000,2),(521,-923304600,3),(521,-757425600,6),(521,152632800,4),(521,162309600,5),(521,183477600,4),(521,194968800,5),(521,215532000,4),(521,226418400,5),(521,246981600,4),(521,257868000,5),(521,278431200,4),(521,289317600,5),(521,309880800,4),(521,320767200,5),(521,341330400,4),(521,352216800,5),(521,372780000,4),(521,384271200,5),(521,404834400,4),(521,415720800,5),(521,436284000,4),(521,447170400,5),(521,467733600,4),(521,478620000,5),(521,499183200,4),(521,510069600,5),(521,530632800,4),(521,541519200,5),(521,562082400,4),(521,573573600,5),(521,594136800,4),(521,605023200,5),(521,623772000,4),(521,637682400,5),(521,655221600,4),(521,669132000,5),(521,686671200,4),(521,700581600,5),(521,718120800,4),(521,732636000,5),(521,749570400,4),(521,764085600,5),(521,781020000,4),(521,795535200,5),(521,812469600,4),(521,826984800,5),(521,844524000,4),(521,858434400,5),(521,875973600,4),(521,889884000,5),(521,907423200,4),(521,921938400,5),(521,938872800,4),(521,953388000,5),(521,970322400,4),(521,984837600,5),(521,1002376800,4),(521,1016287200,5),(521,1033826400,4),(521,1047736800,5),(521,1065276000,4),(521,1079791200,5),(521,1096725600,4),(521,1111240800,5),(521,1128175200,4),(521,1142690400,5),(521,1159624800,4),(521,1174140000,5),(521,1191074400,4),(521,1207404000,5),(521,1222524000,4),(521,1238853600,5),(521,1253973600,4),(521,1270303200,5),(521,1285423200,4),(521,1301752800,5),(521,1316872800,4),(521,1333202400,5),(521,1348927200,4),(521,1365256800,5),(521,1380376800,4),(521,1396706400,5),(521,1411826400,4),(521,1428156000,5),(521,1443276000,4),(521,1459605600,5),(521,1474725600,4),(521,1491055200,5),(521,1506175200,4),(521,1522504800,5),(521,1538229600,4),(521,1554559200,5),(521,1569679200,4),(521,1586008800,5),(521,1601128800,4),(521,1617458400,5),(521,1632578400,4),(521,1648908000,5),(521,1664028000,4),(521,1680357600,5),(521,1695477600,4),(521,1712412000,5),(521,1727532000,4),(521,1743861600,5),(521,1758981600,4),(521,1775311200,5),(521,1790431200,4),(521,1806760800,5),(521,1821880800,4),(521,1838210400,5),(521,1853330400,4),(521,1869660000,5),(521,1885384800,4),(521,1901714400,5),(521,1916834400,4),(521,1933164000,5),(521,1948284000,4),(521,1964613600,5),(521,1979733600,4),(521,1996063200,5),(521,2011183200,4),(521,2027512800,5),(521,2042632800,4),(521,2058962400,5),(521,2074687200,4),(521,2091016800,5),(521,2106136800,4),(521,2122466400,5),(521,2137586400,4),(522,-2147483648,1),(522,-757426500,4),(522,152632800,2),(522,162309600,3),(522,183477600,2),(522,194968800,3),(522,215532000,2),(522,226418400,3),(522,246981600,2),(522,257868000,3),(522,278431200,2),(522,289317600,3),(522,309880800,2),(522,320767200,3),(522,341330400,2),(522,352216800,3),(522,372780000,2),(522,384271200,3),(522,404834400,2),(522,415720800,3),(522,436284000,2),(522,447170400,3),(522,467733600,2),(522,478620000,3),(522,499183200,2),(522,510069600,3),(522,530632800,2),(522,541519200,3),(522,562082400,2),(522,573573600,3),(522,594136800,2),(522,605023200,3),(522,623772000,2),(522,637682400,3),(522,655221600,2),(522,669132000,3),(522,686671200,2),(522,700581600,3),(522,718120800,2),(522,732636000,3),(522,749570400,2),(522,764085600,3),(522,781020000,2),(522,795535200,3),(522,812469600,2),(522,826984800,3),(522,844524000,2),(522,858434400,3),(522,875973600,2),(522,889884000,3),(522,907423200,2),(522,921938400,3),(522,938872800,2),(522,953388000,3),(522,970322400,2),(522,984837600,3),(522,1002376800,2),(522,1016287200,3),(522,1033826400,2),(522,1047736800,3),(522,1065276000,2),(522,1079791200,3),(522,1096725600,2),(522,1111240800,3),(522,1128175200,2),(522,1142690400,3),(522,1159624800,2),(522,1174140000,3),(522,1191074400,2),(522,1207404000,3),(522,1222524000,2),(522,1238853600,3),(522,1253973600,2),(522,1270303200,3),(522,1285423200,2),(522,1301752800,3),(522,1316872800,2),(522,1333202400,3),(522,1348927200,2),(522,1365256800,3),(522,1380376800,2),(522,1396706400,3),(522,1411826400,2),(522,1428156000,3),(522,1443276000,2),(522,1459605600,3),(522,1474725600,2),(522,1491055200,3),(522,1506175200,2),(522,1522504800,3),(522,1538229600,2),(522,1554559200,3),(522,1569679200,2),(522,1586008800,3),(522,1601128800,2),(522,1617458400,3),(522,1632578400,2),(522,1648908000,3),(522,1664028000,2),(522,1680357600,3),(522,1695477600,2),(522,1712412000,3),(522,1727532000,2),(522,1743861600,3),(522,1758981600,2),(522,1775311200,3),(522,1790431200,2),(522,1806760800,3),(522,1821880800,2),(522,1838210400,3),(522,1853330400,2),(522,1869660000,3),(522,1885384800,2),(522,1901714400,3),(522,1916834400,2),(522,1933164000,3),(522,1948284000,2),(522,1964613600,3),(522,1979733600,2),(522,1996063200,3),(522,2011183200,2),(522,2027512800,3),(522,2042632800,2),(522,2058962400,3),(522,2074687200,2),(522,2091016800,3),(522,2106136800,2),(522,2122466400,3),(522,2137586400,2),(522,2147483647,2),(523,-2147483648,2),(523,-1633273200,1),(523,-1615132800,2),(523,-1601823600,1),(523,-1583683200,2),(523,-1570374000,1),(523,-1551628800,2),(523,-1538924400,1),(523,-1534089600,2),(523,-880210800,3),(523,-769395600,4),(523,-765388800,2),(523,-147884400,1),(523,-131558400,2),(523,-116434800,1),(523,-100108800,2),(523,-84380400,1),(523,-68659200,2),(523,-52930800,1),(523,-37209600,2),(523,-21481200,1),(523,-5760000,2),(523,9968400,1),(523,25689600,2),(523,41418000,1),(523,57744000,2),(523,73472400,1),(523,89193600,2),(523,104922000,1),(523,120643200,2),(523,126694800,1),(523,152092800,2),(523,162378000,1),(523,183542400,2),(523,199270800,1),(523,215596800,2),(523,230720400,1),(523,247046400,2),(523,262774800,1),(523,278496000,2),(523,294224400,1),(523,309945600,2),(523,325674000,1),(523,341395200,2),(523,357123600,1),(523,372844800,2),(523,388573200,1),(523,404899200,2),(523,420022800,1),(523,436348800,2),(523,452077200,1),(523,467798400,2),(523,483526800,1),(523,499248000,2),(523,514976400,1),(523,530697600,2),(523,544611600,1),(523,562147200,2),(523,576061200,1),(523,594201600,2),(523,607510800,1),(523,625651200,2),(523,638960400,1),(523,657100800,2),(523,671014800,1),(523,688550400,2),(523,702464400,1),(523,720000000,2),(523,733914000,1),(523,752054400,2),(523,765363600,1),(523,783504000,2),(523,796813200,1),(523,814953600,2),(523,828867600,1),(523,846403200,2),(523,860317200,1),(523,877852800,2),(523,891766800,1),(523,909302400,2),(523,923216400,1),(523,941356800,2),(523,954666000,1),(523,972806400,2),(523,986115600,1),(523,1004256000,2),(523,1018170000,1),(523,1035705600,2),(523,1049619600,1),(523,1067155200,2),(523,1081069200,1),(523,1099209600,2),(523,1112518800,1),(523,1130659200,2),(523,1143968400,1),(523,1162108800,2),(523,1173603600,1),(523,1194163200,2),(523,1205053200,1),(523,1225612800,2),(523,1236502800,1),(523,1257062400,2),(523,1268557200,1),(523,1289116800,2),(523,1300006800,1),(523,1320566400,2),(523,1331456400,1),(523,1352016000,2),(523,1362906000,1),(523,1383465600,2),(523,1394355600,1),(523,1414915200,2),(523,1425805200,1),(523,1446364800,2),(523,1457859600,1),(523,1478419200,2),(523,1489309200,1),(523,1509868800,2),(523,1520758800,1),(523,1541318400,2),(523,1552208400,1),(523,1572768000,2),(523,1583658000,1),(523,1604217600,2),(523,1615712400,1),(523,1636272000,2),(523,1647162000,1),(523,1667721600,2),(523,1678611600,1),(523,1699171200,2),(523,1710061200,1),(523,1730620800,2),(523,1741510800,1),(523,1762070400,2),(523,1772960400,1),(523,1793520000,2),(523,1805014800,1),(523,1825574400,2),(523,1836464400,1),(523,1857024000,2),(523,1867914000,1),(523,1888473600,2),(523,1899363600,1),(523,1919923200,2),(523,1930813200,1),(523,1951372800,2),(523,1962867600,1),(523,1983427200,2),(523,1994317200,1),(523,2014876800,2),(523,2025766800,1),(523,2046326400,2),(523,2057216400,1),(523,2077776000,2),(523,2088666000,1),(523,2109225600,2),(523,2120115600,1),(523,2140675200,2),(524,-2147483648,2),(524,-933667200,1),(524,-922093200,2),(524,-908870400,1),(524,-888829200,2),(524,-881049600,1),(524,-767869200,2),(524,-745833600,1),(524,-733827600,2),(524,-716889600,1),(524,-699613200,2),(524,-683884800,1),(524,-670669200,2),(524,-652348800,1),(524,-650019600,2),(524,515527200,1),(524,527014800,2),(524,545162400,1),(524,558464400,2),(524,577216800,1),(524,589914000,2),(524,608666400,1),(524,621968400,2),(524,640116000,1),(524,653418000,2),(524,671565600,1),(524,684867600,2),(525,-1633269600,0),(525,-1615129200,1),(525,-1601820000,0),(525,-1583679600,1),(525,-880207200,2),(525,-769395600,3),(525,-765385200,1),(525,-84376800,0),(525,-68655600,1),(525,-52927200,0),(525,-37206000,1),(525,-21477600,0),(525,-5756400,1),(525,9972000,0),(525,25693200,1),(525,41421600,0),(525,57747600,1),(525,73476000,0),(525,89197200,1),(525,104925600,0),(525,120646800,1),(525,126698400,0),(525,152096400,1),(525,162381600,0),(525,183546000,1),(525,199274400,0),(525,215600400,1),(525,230724000,0),(525,247050000,1),(525,262778400,0),(525,278499600,1),(525,294228000,0),(525,309949200,1),(525,325677600,0),(525,341398800,1),(525,357127200,0),(525,372848400,1),(525,388576800,0),(525,404902800,1),(525,420026400,0),(525,436352400,1),(525,452080800,0),(525,467802000,1),(525,483530400,0),(525,499251600,1),(525,514980000,0),(525,530701200,1),(525,544615200,0),(525,562150800,1),(525,576064800,0),(525,594205200,1),(525,607514400,0),(525,625654800,1),(525,638964000,0),(525,657104400,1),(525,671018400,0),(525,688554000,1),(525,702468000,0),(525,720003600,1),(525,733917600,0),(525,752058000,1),(525,765367200,0),(525,783507600,1),(525,796816800,0),(525,814957200,1),(525,828871200,0),(525,846406800,1),(525,860320800,0),(525,877856400,1),(525,891770400,0),(525,909306000,1),(525,923220000,0),(525,941360400,1),(525,954669600,0),(525,972810000,1),(525,986119200,0),(525,1004259600,1),(525,1018173600,0),(525,1035709200,1),(525,1049623200,0),(525,1067158800,1),(525,1081072800,0),(525,1099213200,1),(525,1112522400,0),(525,1130662800,1),(525,1143972000,0),(525,1162112400,1),(525,1173607200,0),(525,1194166800,1),(525,1205056800,0),(525,1225616400,1),(525,1236506400,0),(525,1257066000,1),(525,1268560800,0),(525,1289120400,1),(525,1300010400,0),(525,1320570000,1),(525,1331460000,0),(525,1352019600,1),(525,1362909600,0),(525,1383469200,1),(525,1394359200,0),(525,1414918800,1),(525,1425808800,0),(525,1446368400,1),(525,1457863200,0),(525,1478422800,1),(525,1489312800,0),(525,1509872400,1),(525,1520762400,0),(525,1541322000,1),(525,1552212000,0),(525,1572771600,1),(525,1583661600,0),(525,1604221200,1),(525,1615716000,0),(525,1636275600,1),(525,1647165600,0),(525,1667725200,1),(525,1678615200,0),(525,1699174800,1),(525,1710064800,0),(525,1730624400,1),(525,1741514400,0),(525,1762074000,1),(525,1772964000,0),(525,1793523600,1),(525,1805018400,0),(525,1825578000,1),(525,1836468000,0),(525,1857027600,1),(525,1867917600,0),(525,1888477200,1),(525,1899367200,0),(525,1919926800,1),(525,1930816800,0),(525,1951376400,1),(525,1962871200,0),(525,1983430800,1),(525,1994320800,0),(525,2014880400,1),(525,2025770400,0),(525,2046330000,1),(525,2057220000,0),(525,2077779600,1),(525,2088669600,0),(525,2109229200,1),(525,2120119200,0),(525,2140678800,1),(526,-2147483648,1),(526,-1861878784,2),(526,-631110600,4),(526,1285498800,3),(526,1301752800,4),(526,1316872800,3),(526,1325239200,6),(526,1333202400,5),(526,1348927200,6),(526,1365256800,5),(526,1380376800,6),(526,1396706400,5),(526,1411826400,6),(526,1428156000,5),(526,1443276000,6),(526,1459605600,5),(526,1474725600,6),(526,1491055200,5),(526,1506175200,6),(526,1522504800,5),(526,1538229600,6),(526,1554559200,5),(526,1569679200,6),(526,1586008800,5),(526,1601128800,6),(526,1617458400,5),(526,1632578400,6),(526,1648908000,5),(526,1664028000,6),(526,1680357600,5),(526,1695477600,6),(526,1712412000,5),(526,1727532000,6),(526,1743861600,5),(526,1758981600,6),(526,1775311200,5),(526,1790431200,6),(526,1806760800,5),(526,1821880800,6),(526,1838210400,5),(526,1853330400,6),(526,1869660000,5),(526,1885384800,6),(526,1901714400,5),(526,1916834400,6),(526,1933164000,5),(526,1948284000,6),(526,1964613600,5),(526,1979733600,6),(526,1996063200,5),(526,2011183200,6),(526,2027512800,5),(526,2042632800,6),(526,2058962400,5),(526,2074687200,6),(526,2091016800,5),(526,2106136800,6),(526,2122466400,5),(526,2137586400,6),(526,2147483647,6),(527,-2147483648,2),(527,-1330335000,1),(527,-1320057000,2),(527,-1300699800,3),(527,-1287396000,2),(527,-1269250200,3),(527,-1255946400,2),(527,-1237800600,3),(527,-1224496800,2),(527,-1206351000,3),(527,-1192442400,2),(527,-1174901400,3),(527,-1160992800,2),(527,-1143451800,3),(527,-1125914400,2),(527,-1112607000,3),(527,-1094464800,2),(527,-1081157400,3),(527,-1063015200,2),(527,-1049707800,3),(527,-1031565600,2),(527,-1018258200,3),(527,-1000116000,2),(527,-986808600,3),(527,-968061600,2),(527,-955359000,3),(527,-936612000,2),(527,-923304600,3),(527,-757425600,6),(527,152632800,4),(527,162309600,5),(527,183477600,4),(527,194968800,5),(527,215532000,4),(527,226418400,5),(527,246981600,4),(527,257868000,5),(527,278431200,4),(527,289317600,5),(527,309880800,4),(527,320767200,5),(527,341330400,4),(527,352216800,5),(527,372780000,4),(527,384271200,5),(527,404834400,4),(527,415720800,5),(527,436284000,4),(527,447170400,5),(527,467733600,4),(527,478620000,5),(527,499183200,4),(527,510069600,5),(527,530632800,4),(527,541519200,5),(527,562082400,4),(527,573573600,5),(527,594136800,4),(527,605023200,5),(527,623772000,4),(527,637682400,5),(527,655221600,4),(527,669132000,5),(527,686671200,4),(527,700581600,5),(527,718120800,4),(527,732636000,5),(527,749570400,4),(527,764085600,5),(527,781020000,4),(527,795535200,5),(527,812469600,4),(527,826984800,5),(527,844524000,4),(527,858434400,5),(527,875973600,4),(527,889884000,5),(527,907423200,4),(527,921938400,5),(527,938872800,4),(527,953388000,5),(527,970322400,4),(527,984837600,5),(527,1002376800,4),(527,1016287200,5),(527,1033826400,4),(527,1047736800,5),(527,1065276000,4),(527,1079791200,5),(527,1096725600,4),(527,1111240800,5),(527,1128175200,4),(527,1142690400,5),(527,1159624800,4),(527,1174140000,5),(527,1191074400,4),(527,1207404000,5),(527,1222524000,4),(527,1238853600,5),(527,1253973600,4),(527,1270303200,5),(527,1285423200,4),(527,1301752800,5),(527,1316872800,4),(527,1333202400,5),(527,1348927200,4),(527,1365256800,5),(527,1380376800,4),(527,1396706400,5),(527,1411826400,4),(527,1428156000,5),(527,1443276000,4),(527,1459605600,5),(527,1474725600,4),(527,1491055200,5),(527,1506175200,4),(527,1522504800,5),(527,1538229600,4),(527,1554559200,5),(527,1569679200,4),(527,1586008800,5),(527,1601128800,4),(527,1617458400,5),(527,1632578400,4),(527,1648908000,5),(527,1664028000,4),(527,1680357600,5),(527,1695477600,4),(527,1712412000,5),(527,1727532000,4),(527,1743861600,5),(527,1758981600,4),(527,1775311200,5),(527,1790431200,4),(527,1806760800,5),(527,1821880800,4),(527,1838210400,5),(527,1853330400,4),(527,1869660000,5),(527,1885384800,4),(527,1901714400,5),(527,1916834400,4),(527,1933164000,5),(527,1948284000,4),(527,1964613600,5),(527,1979733600,4),(527,1996063200,5),(527,2011183200,4),(527,2027512800,5),(527,2042632800,4),(527,2058962400,5),(527,2074687200,4),(527,2091016800,5),(527,2106136800,4),(527,2122466400,5),(527,2137586400,4),(528,-2147483648,1),(528,-868010400,2),(528,-768906000,1),(528,1419696000,3),(528,2147483647,3),(529,-2147483648,1),(529,-757426500,4),(529,152632800,2),(529,162309600,3),(529,183477600,2),(529,194968800,3),(529,215532000,2),(529,226418400,3),(529,246981600,2),(529,257868000,3),(529,278431200,2),(529,289317600,3),(529,309880800,2),(529,320767200,3),(529,341330400,2),(529,352216800,3),(529,372780000,2),(529,384271200,3),(529,404834400,2),(529,415720800,3),(529,436284000,2),(529,447170400,3),(529,467733600,2),(529,478620000,3),(529,499183200,2),(529,510069600,3),(529,530632800,2),(529,541519200,3),(529,562082400,2),(529,573573600,3),(529,594136800,2),(529,605023200,3),(529,623772000,2),(529,637682400,3),(529,655221600,2),(529,669132000,3),(529,686671200,2),(529,700581600,3),(529,718120800,2),(529,732636000,3),(529,749570400,2),(529,764085600,3),(529,781020000,2),(529,795535200,3),(529,812469600,2),(529,826984800,3),(529,844524000,2),(529,858434400,3),(529,875973600,2),(529,889884000,3),(529,907423200,2),(529,921938400,3),(529,938872800,2),(529,953388000,3),(529,970322400,2),(529,984837600,3),(529,1002376800,2),(529,1016287200,3),(529,1033826400,2),(529,1047736800,3),(529,1065276000,2),(529,1079791200,3),(529,1096725600,2),(529,1111240800,3),(529,1128175200,2),(529,1142690400,3),(529,1159624800,2),(529,1174140000,3),(529,1191074400,2),(529,1207404000,3),(529,1222524000,2),(529,1238853600,3),(529,1253973600,2),(529,1270303200,3),(529,1285423200,2),(529,1301752800,3),(529,1316872800,2),(529,1333202400,3),(529,1348927200,2),(529,1365256800,3),(529,1380376800,2),(529,1396706400,3),(529,1411826400,2),(529,1428156000,3),(529,1443276000,2),(529,1459605600,3),(529,1474725600,2),(529,1491055200,3),(529,1506175200,2),(529,1522504800,3),(529,1538229600,2),(529,1554559200,3),(529,1569679200,2),(529,1586008800,3),(529,1601128800,2),(529,1617458400,3),(529,1632578400,2),(529,1648908000,3),(529,1664028000,2),(529,1680357600,3),(529,1695477600,2),(529,1712412000,3),(529,1727532000,2),(529,1743861600,3),(529,1758981600,2),(529,1775311200,3),(529,1790431200,2),(529,1806760800,3),(529,1821880800,2),(529,1838210400,3),(529,1853330400,2),(529,1869660000,3),(529,1885384800,2),(529,1901714400,3),(529,1916834400,2),(529,1933164000,3),(529,1948284000,2),(529,1964613600,3),(529,1979733600,2),(529,1996063200,3),(529,2011183200,2),(529,2027512800,3),(529,2042632800,2),(529,2058962400,3),(529,2074687200,2),(529,2091016800,3),(529,2106136800,2),(529,2122466400,3),(529,2137586400,2),(529,2147483647,2),(530,-2147483648,1),(530,-1743674400,2),(530,-1606813200,1),(530,-907408800,2),(530,-770634000,1),(530,2147483647,1),(531,-2147483648,1),(531,-1178124152,4),(531,-36619200,2),(531,-23922000,3),(531,-3355200,2),(531,7527600,3),(531,24465600,2),(531,37767600,3),(531,55915200,2),(531,69217200,3),(531,87969600,2),(531,100666800,3),(531,118209600,2),(531,132116400,3),(531,150868800,2),(531,163566000,3),(531,182318400,2),(531,195620400,3),(531,213768000,2),(531,227070000,3),(531,245217600,2),(531,258519600,3),(531,277272000,2),(531,289969200,3),(531,308721600,2),(531,321418800,3),(531,340171200,2),(531,353473200,3),(531,371620800,2),(531,384922800,5),(531,403070400,6),(531,416372400,5),(531,434520000,6),(531,447822000,5),(531,466574400,6),(531,479271600,5),(531,498024000,6),(531,510721200,5),(531,529473600,6),(531,545194800,5),(531,560923200,6),(531,574225200,5),(531,592372800,6),(531,605674800,5),(531,624427200,6),(531,637124400,5),(531,653457600,6),(531,668574000,5),(531,687326400,6),(531,700628400,5),(531,718776000,6),(531,732078000,5),(531,750225600,6),(531,763527600,5),(531,781675200,6),(531,794977200,5),(531,813729600,6),(531,826426800,5),(531,845179200,6),(531,859690800,5),(531,876628800,6),(531,889930800,5),(531,906868800,6),(531,923194800,5),(531,939528000,6),(531,952830000,5),(531,971582400,6),(531,984279600,5),(531,1003032000,6),(531,1015729200,5),(531,1034481600,6),(531,1047178800,5),(531,1065931200,6),(531,1079233200,5),(531,1097380800,6),(531,1110682800,5),(531,1128830400,6),(531,1142132400,5),(531,1160884800,6),(531,1173582000,5),(531,1192334400,6),(531,1206846000,5),(531,1223784000,6),(531,1237086000,5),(531,1255233600,6),(531,1270350000,5),(531,1286683200,6),(531,1304823600,5),(531,1313899200,6),(531,1335668400,5),(531,1346558400,6),(531,1367118000,5),(531,1378612800,6),(531,1398567600,5),(531,1410062400,6),(531,1463281200,5),(531,1471147200,6),(531,1494730800,5),(531,1502596800,6),(531,1526180400,5),(531,1534046400,6),(531,1554606000,5),(531,1567915200,6),(531,1586055600,5),(531,1599364800,6),(531,1617505200,5),(531,1630814400,6),(531,1648954800,5),(531,1662264000,6),(531,1680404400,5),(531,1693713600,6),(531,1712458800,5),(531,1725768000,6),(531,1743908400,5),(531,1757217600,6),(531,1775358000,5),(531,1788667200,6),(531,1806807600,5),(531,1820116800,6),(531,1838257200,5),(531,1851566400,6),(531,1870311600,5),(531,1883016000,6),(531,1901761200,5),(531,1915070400,6),(531,1933210800,5),(531,1946520000,6),(531,1964660400,5),(531,1977969600,6),(531,1996110000,5),(531,2009419200,6),(531,2027559600,5),(531,2040868800,6),(531,2059614000,5),(531,2072318400,6),(531,2091063600,5),(531,2104372800,6),(531,2122513200,5),(531,2135822400,6),(531,2147483647,6),(532,-2147483648,0),(532,-1829387596,2),(532,433256400,1),(532,448977600,2),(532,467298000,1),(532,480427200,2),(532,496760400,1),(532,511876800,2),(532,528210000,1),(532,543931200,2),(532,559659600,1),(532,575380800,2),(532,591109200,1),(532,606830400,2),(532,622558800,1),(532,638280000,2),(532,654008400,1),(532,669729600,2),(532,686062800,1),(532,696340800,2),(532,719931600,1),(532,727790400,2),(532,2147483647,2),(533,-2147483648,1),(533,307627200,2),(533,788871600,3),(533,2147483647,3),(534,-2147483648,1),(534,1325242800,2),(534,2147483647,2),(535,-2147483648,0),(535,-1709985344,2),(535,909842400,1),(535,920124000,2),(535,941896800,1),(535,951573600,2),(535,1259416800,1),(535,1269698400,2),(535,1287842400,1),(535,1299333600,2),(535,1319292000,1),(535,1327154400,2),(535,1350741600,1),(535,1358604000,2),(535,1382796000,1),(535,1390050000,2),(535,1414850400,1),(535,1421503200,2),(535,1446300000,1),(535,1452952800,2),(535,1478354400,1),(535,1484402400,2),(535,1509804000,1),(535,1515852000,2),(535,1541253600,1),(535,1547301600,2),(535,1572703200,1),(535,1579356000,2),(535,1604152800,1),(535,1610805600,2),(535,1636207200,1),(535,1642255200,2),(535,1667656800,1),(535,1673704800,2),(535,1699106400,1),(535,1705154400,2),(535,1730556000,1),(535,1737208800,2),(535,1762005600,1),(535,1768658400,2),(535,1793455200,1),(535,1800108000,2),(535,1825509600,1),(535,1831557600,2),(535,1856959200,1),(535,1863007200,2),(535,1888408800,1),(535,1894456800,2),(535,1919858400,1),(535,1926511200,2),(535,1951308000,1),(535,1957960800,2),(535,1983362400,1),(535,1989410400,2),(535,2014812000,1),(535,2020860000,2),(535,2046261600,1),(535,2052309600,2),(535,2077711200,1),(535,2083759200,2),(535,2109160800,1),(535,2115813600,2),(535,2140610400,1),(535,2147263200,2),(535,2147483647,2),(536,-2147483648,1),(536,2147483647,1),(537,-2147483648,0),(537,-1230746496,1),(537,504939600,3),(537,722930400,2),(537,728888400,3),(537,2147483647,3),(538,-2147483648,0),(538,-1806678012,1),(538,2147483647,1),(539,-2147483648,0),(539,-1806748788,1),(539,2147483647,1),(540,-2147483648,1),(540,-885549600,2),(540,-802256400,1),(540,-331891200,3),(540,-281610000,1),(540,-73728000,3),(540,-29415540,1),(540,-16704000,3),(540,-10659600,1),(540,9907200,3),(540,21394800,1),(540,41356800,3),(540,52844400,1),(540,124819200,3),(540,130863600,1),(540,201888000,3),(540,209487660,1),(540,230659200,3),(540,241542000,1),(540,977493600,4),(541,-2147483648,1),(541,-1157283000,2),(541,-1155436200,1),(541,-880198200,3),(541,-769395600,4),(541,-765376200,1),(541,-712150200,5),(542,-2147483648,1),(542,-1157283000,2),(542,-1155436200,1),(542,-880198200,3),(542,-769395600,4),(542,-765376200,1),(542,-712150200,5),(543,-2147483648,1),(543,307622400,2),(543,788868000,3),(543,2147483647,3),(544,-2147483648,1),(544,-1743678000,2),(544,-1606813200,1),(544,-1041418800,3),(544,-907408800,2),(544,-770634000,1),(544,-7988400,4),(544,915105600,1),(544,2147483647,1),(545,-2147483648,1),(545,-1041418800,2),(545,-907408800,3),(545,-817462800,1),(545,-7988400,4),(545,745934400,5),(545,2147483647,5),(546,-2147483648,1),(546,-1743678000,2),(546,-1606813200,1),(546,-1041418800,3),(546,-907408800,2),(546,-818067600,1),(546,-7988400,4),(546,2147483647,4),(547,-2147483648,0),(547,-1806676920,1),(547,2147483647,1),(548,-2147483648,1),(548,-1861879032,2),(549,-2147483648,0),(549,-1545131260,1),(549,-862918200,2),(549,-767350800,1),(549,287418600,3),(549,2147483647,3),(550,-2147483648,1),(550,-599575200,2),(550,276089400,3),(550,2147483647,3),(551,-2147483648,1),(551,-599656320,2),(551,152029800,3),(551,162912600,2),(551,1443882600,4),(551,2147483647,4),(552,-2147483648,0),(552,-1829387148,2),(552,250002000,1),(552,257342400,2),(552,281451600,1),(552,288878400,2),(552,849366000,3),(552,857228400,4),(552,2147483647,4),(553,-2147483648,1),(553,-1861879032,2),(554,-2147483648,1),(554,2147483647,1),(555,-2147483648,1),(555,893665800,2),(555,2147483647,2),(556,-2147483648,1),(556,-1743678000,2),(556,-1606813200,1),(556,-1041418800,3),(556,-907408800,2),(556,-770634000,1),(556,2147483647,1),(557,-2147483648,1),(557,-1743678000,2),(557,-1606813200,1),(557,-1041418800,3),(557,-907408800,2),(557,-770634000,1),(557,2147483647,1),(558,-2147483648,1),(558,2147483647,1),(559,-2147483648,1),(559,279714600,3),(559,289387800,2),(559,309952800,3),(559,320837400,2),(559,341402400,3),(559,352287000,2),(559,372852000,3),(559,384341400,2),(559,404906400,3),(559,415791000,2),(559,436356000,3),(559,447240600,2),(559,467805600,3),(559,478690200,2),(559,499255200,3),(559,510139800,2),(559,530704800,3),(559,541589400,2),(559,562154400,3),(559,573643800,2),(559,594208800,3),(559,605093400,2),(559,625658400,3),(559,636543000,2),(559,657108000,3),(559,667992600,2),(559,2147483647,2),(560,-2147483648,1),(560,-885549600,2),(560,-802256400,1),(560,-331891200,3),(560,-281610000,1),(560,-73728000,3),(560,-29415540,1),(560,-16704000,3),(560,-10659600,1),(560,9907200,3),(560,21394800,1),(560,41356800,3),(560,52844400,1),(560,124819200,3),(560,130863600,1),(560,201888000,3),(560,209487660,1),(560,230659200,3),(560,241542000,1),(560,977493600,4),(561,-2147483648,1),(561,-1861879032,2),(562,-2147483648,0),(562,-1806674504,1),(562,2147483647,1),(563,-2147483648,1),(563,2147483647,1),(564,-2147483648,1),(564,-915193200,2),(564,939214800,3),(564,953384400,4),(564,973342800,5),(564,980596800,2),(564,1004792400,5),(564,1012046400,2),(564,1478350800,5),(564,1484398800,2),(564,2147483647,2),(565,-2147483648,1),(565,-1743674400,2),(565,-1606813200,1),(565,-907408800,2),(565,-770634000,1),(565,2147483647,1),(566,-2147483648,1),(566,2147483647,1),(567,-2147483648,1),(567,2147483647,1),(568,-2147483648,1),(568,-1743674400,2),(568,-1606813200,1),(568,-907408800,2),(568,-770634000,1),(568,2147483647,1),(569,-2147483648,1),(569,-1717032240,3),(569,-1693706400,2),(569,-1680483600,3),(569,-1663455600,4),(569,-1650150000,5),(569,-1632006000,4),(569,-1618700400,8),(569,-1600473600,6),(569,-1587168000,7),(569,-1501725600,3),(569,-931734000,2),(569,-857257200,5),(569,-844556400,4),(569,-828226800,5),(569,-812502000,4),(569,-796874400,2),(569,-796608000,3),(569,-778726800,2),(569,-762660000,3),(569,-748486800,4),(569,-733273200,5),(569,-715215600,4),(569,-701910000,5),(569,-684975600,4),(569,-670460400,5),(569,-654130800,4),(569,-639010800,5),(569,-397094400,4),(569,-386812800,5),(569,-371088000,4),(569,-355363200,5),(569,-334195200,4),(569,-323308800,5),(569,-307584000,4),(569,-291859200,5),(569,-271296000,4),(569,-260409600,5),(569,-239846400,4),(569,-228960000,5),(569,-208396800,4),(569,-197510400,5),(569,-176342400,4),(569,-166060800,5),(569,220921200,3),(569,228873600,4),(569,243993600,5),(569,260323200,4),(569,276048000,5),(569,291772800,4),(569,307497600,5),(569,323827200,4),(569,338947200,5),(569,354672000,4),(569,370396800,5),(569,386121600,4),(569,401846400,5),(569,417571200,4),(569,433296000,5),(569,449020800,4),(569,465350400,5),(569,481075200,4),(569,496800000,5),(569,512524800,4),(569,528249600,5),(569,543974400,4),(569,559699200,5),(569,567990000,3),(569,575427600,9),(569,591152400,10),(569,606877200,9),(569,622602000,10),(569,638326800,9),(569,654656400,10),(569,670381200,9),(569,686106000,10),(569,701830800,9),(569,717555600,10),(569,733280400,9),(569,749005200,10),(569,764730000,9),(569,780454800,10),(569,796179600,9),(569,811904400,10),(569,828234000,9),(569,846378000,10),(569,859683600,9),(569,877827600,10),(569,891133200,9),(569,909277200,10),(569,922582800,9),(569,941331600,10),(569,954032400,9),(569,972781200,10),(569,985482000,9),(569,1004230800,10),(569,1017536400,9),(569,1035680400,10),(569,1048986000,9),(569,1067130000,10),(569,1080435600,9),(569,1099184400,10),(569,1111885200,9),(569,1130634000,10),(569,1143334800,9),(569,1162083600,10),(569,1174784400,9),(569,1193533200,10),(569,1206838800,9),(569,1224982800,10),(569,1238288400,9),(569,1256432400,10),(569,1269738000,9),(569,1288486800,10),(569,1301187600,9),(569,1319936400,10),(569,1332637200,9),(569,1351386000,10),(569,1364691600,9),(569,1382835600,10),(569,1396141200,9),(569,1414285200,10),(569,1427590800,9),(569,1445734800,10),(569,1459040400,9),(569,1477789200,10),(569,1490490000,9),(569,1509238800,10),(569,1521939600,9),(569,1540688400,10),(569,1553994000,9),(569,1572138000,10),(569,1585443600,9),(569,1603587600,10),(569,1616893200,9),(569,1635642000,10),(569,1648342800,9),(569,1667091600,10),(569,1679792400,9),(569,1698541200,10),(569,1711846800,9),(569,1729990800,10),(569,1743296400,9),(569,1761440400,10),(569,1774746000,9),(569,1792890000,10),(569,1806195600,9),(569,1824944400,10),(569,1837645200,9),(569,1856394000,10),(569,1869094800,9),(569,1887843600,10),(569,1901149200,9),(569,1919293200,10),(569,1932598800,9),(569,1950742800,10),(569,1964048400,9),(569,1982797200,10),(569,1995498000,9),(569,2014246800,10),(569,2026947600,9),(569,2045696400,10),(569,2058397200,9),(569,2077146000,10),(569,2090451600,9),(569,2108595600,10),(569,2121901200,9),(569,2140045200,10),(570,-2147483648,0),(570,-1830384000,6),(570,-1689555600,1),(570,-1677801600,2),(570,-1667437200,3),(570,-1647738000,4),(570,-1635814800,3),(570,-1616202000,4),(570,-1604365200,3),(570,-1584666000,4),(570,-1572742800,3),(570,-1553043600,4),(570,-1541206800,3),(570,-1521507600,4),(570,-1442451600,3),(570,-1426813200,4),(570,-1379293200,3),(570,-1364778000,4),(570,-1348448400,3),(570,-1333328400,4),(570,-1316394000,3),(570,-1301274000,4),(570,-1284339600,3),(570,-1269824400,4),(570,-1221440400,3),(570,-1206925200,4),(570,-1191200400,3),(570,-1175475600,4),(570,-1127696400,3),(570,-1111971600,4),(570,-1096851600,3),(570,-1080522000,4),(570,-1063587600,3),(570,-1049072400,4),(570,-1033347600,3),(570,-1017622800,4),(570,-1002502800,3),(570,-986173200,4),(570,-969238800,3),(570,-950490000,4),(570,-942022800,3),(570,-922669200,4),(570,-906944400,3),(570,-891133200,4),(570,-877309200,3),(570,-873684000,5),(570,-864007200,3),(570,-857955600,4),(570,-845859600,3),(570,-842839200,5),(570,-831348000,3),(570,-825901200,4),(570,-814410000,3),(570,-810784800,5),(570,-799898400,3),(570,-794451600,4),(570,-782960400,3),(570,-779335200,5),(570,-768448800,3),(570,-763002000,4),(570,-749091600,3),(570,-733366800,4),(570,-717631200,3),(570,-701906400,4),(570,-686181600,3),(570,-670456800,4),(570,-654732000,3),(570,-639007200,4),(570,-591832800,3),(570,-575503200,4),(570,-559778400,3),(570,-544053600,4),(570,-528328800,3),(570,-512604000,4),(570,-496879200,3),(570,-481154400,4),(570,-465429600,3),(570,-449704800,4),(570,-433980000,3),(570,-417650400,4),(570,-401925600,3),(570,-386200800,4),(570,-370476000,3),(570,-354751200,4),(570,-339026400,3),(570,-323301600,4),(570,-307576800,3),(570,-291852000,4),(570,-276127200,3),(570,-260402400,4),(570,-244677600,3),(570,-228348000,4),(570,-212623200,3),(570,-196898400,4),(570,-181173600,3),(570,-165448800,4),(570,-149724000,3),(570,-133999200,4),(570,-118274400,7),(570,212544000,2),(570,228268800,3),(570,243993600,4),(570,260323200,3),(570,276048000,4),(570,291772800,3),(570,307501200,4),(570,323222400,3),(570,338950800,4),(570,354675600,3),(570,370400400,4),(570,386125200,3),(570,401850000,4),(570,417578400,3),(570,433299600,4),(570,449024400,3),(570,465354000,4),(570,481078800,3),(570,496803600,4),(570,512528400,3),(570,528253200,4),(570,543978000,3),(570,559702800,4),(570,575427600,3),(570,591152400,4),(570,606877200,3),(570,622602000,4),(570,638326800,3),(570,654656400,4),(570,670381200,3),(570,686106000,4),(570,701830800,3),(570,717555600,8),(570,733280400,9),(570,749005200,8),(570,764730000,9),(570,780454800,8),(570,796179600,9),(570,811904400,8),(570,828234000,10),(570,846378000,6),(570,859683600,10),(570,877827600,6),(570,891133200,10),(570,909277200,6),(570,922582800,10),(570,941331600,6),(570,954032400,10),(570,972781200,6),(570,985482000,10),(570,1004230800,6),(570,1017536400,10),(570,1035680400,6),(570,1048986000,10),(570,1067130000,6),(570,1080435600,10),(570,1099184400,6),(570,1111885200,10),(570,1130634000,6),(570,1143334800,10),(570,1162083600,6),(570,1174784400,10),(570,1193533200,6),(570,1206838800,10),(570,1224982800,6),(570,1238288400,10),(570,1256432400,6),(570,1269738000,10),(570,1288486800,6),(570,1301187600,10),(570,1319936400,6),(570,1332637200,10),(570,1351386000,6),(570,1364691600,10),(570,1382835600,6),(570,1396141200,10),(570,1414285200,6),(570,1427590800,10),(570,1445734800,6),(570,1459040400,10),(570,1477789200,6),(570,1490490000,10),(570,1509238800,6),(570,1521939600,10),(570,1540688400,6),(570,1553994000,10),(570,1572138000,6),(570,1585443600,10),(570,1603587600,6),(570,1616893200,10),(570,1635642000,6),(570,1648342800,10),(570,1667091600,6),(570,1679792400,10),(570,1698541200,6),(570,1711846800,10),(570,1729990800,6),(570,1743296400,10),(570,1761440400,6),(570,1774746000,10),(570,1792890000,6),(570,1806195600,10),(570,1824944400,6),(570,1837645200,10),(570,1856394000,6),(570,1869094800,10),(570,1887843600,6),(570,1901149200,10),(570,1919293200,6),(570,1932598800,10),(570,1950742800,6),(570,1964048400,10),(570,1982797200,6),(570,1995498000,10),(570,2014246800,6),(570,2026947600,10),(570,2045696400,6),(570,2058397200,10),(570,2077146000,6),(570,2090451600,10),(570,2108595600,6),(570,2121901200,10),(570,2140045200,6),(571,-2147483648,1),(571,-1017820800,2),(571,-766224000,1),(571,-745833600,3),(571,-733827600,1),(571,-716889600,3),(571,-699613200,1),(571,-683884800,3),(571,-670669200,1),(571,-652348800,3),(571,-639133200,1),(571,-620812800,3),(571,-607597200,1),(571,-589276800,3),(571,-576061200,1),(571,-562924800,3),(571,-541760400,1),(571,-528710400,3),(571,-510224400,1),(571,-497174400,3),(571,-478688400,1),(571,-465638400,3),(571,-449830800,1),(571,-434016000,3),(571,-418208400,1),(571,-402480000,3),(571,-386672400,1),(571,-370944000,3),(571,-355136400,1),(571,-339408000,3),(571,-323600400,1),(571,-302515200,3),(571,-291978000,1),(571,-270979200,3),(571,-260442000,1),(571,133977600,3),(571,149785200,1),(571,165513600,3),(571,181321200,1),(571,299606400,3),(571,307551600,1),(572,-2147483648,0),(572,-1948782472,1),(572,-1830414600,2),(572,-767350800,3),(572,-498128400,1),(572,-462702600,4),(572,-451733400,1),(572,-429784200,4),(572,-418296600,1),(572,-399544200,4),(572,-387451800,1),(572,-368094600,4),(572,-356002200,1),(572,-336645000,4),(572,-324552600,1),(572,-305195400,4),(572,-293103000,1),(572,-264933000,3),(572,547578000,5),(572,560883600,3),(572,579027600,5),(572,592333200,3),(573,-2147483648,1),(573,-2038200925,2),(573,-1167634800,3),(573,-1073028000,4),(573,-894180000,5),(573,-879665400,6),(573,-767005200,5),(573,378664200,7),(573,2147483647,7),(574,-2147483648,1),(574,-873057600,3),(574,-769395600,2),(574,-765399600,1),(575,-2147483648,0),(575,-2131645536,2),(575,-1696276800,1),(575,-1680469200,2),(575,-1632074400,1),(575,-1615143600,2),(575,-1566763200,1),(575,-1557090000,2),(575,-1535486400,1),(575,-1524949200,2),(575,-1504468800,1),(575,-1493413200,2),(575,-1472414400,1),(575,-1461963600,2),(575,-1440964800,1),(575,-1429390800,2),(575,-1409515200,1),(575,-1396731600,2),(575,-1376856000,1),(575,-1366491600,2),(575,-1346616000,1),(575,-1333832400,2),(575,-1313956800,1),(575,-1303678800,2),(575,-1282507200,1),(575,-1272661200,2),(575,-1251057600,1),(575,-1240088400,2),(575,-1219608000,1),(575,-1207429200,2),(575,-1188763200,1),(575,-1175979600,2),(575,-1157313600,1),(575,-1143925200,2),(575,-1124049600,1),(575,-1113771600,2),(575,-1091390400,1),(575,-1081026000,2),(575,-1059854400,1),(575,-1050786000,2),(575,-1030910400,1),(575,-1018126800,2),(575,-999460800,1),(575,-986677200,2),(575,-965592000,1),(575,-955227600,2),(575,-935956800,1),(575,-923173200,2),(575,-904507200,1),(575,-891723600,2),(575,-880221600,3),(575,-769395600,4),(575,-765399600,2),(575,-747252000,1),(575,-733950000,2),(575,-715802400,1),(575,-702500400,2),(575,-684352800,1),(575,-671050800,2),(575,-652903200,1),(575,-639601200,2),(575,-589399200,1),(575,-576097200,2),(575,-557949600,1),(575,-544647600,2),(575,-526500000,1),(575,-513198000,2),(575,-495050400,1),(575,-481748400,2),(575,-431546400,1),(575,-418244400,2),(575,-400096800,1),(575,-386794800,2),(575,-368647200,1),(575,-355345200,2),(575,-337197600,1),(575,-323895600,2),(575,-242244000,1),(575,-226522800,2),(575,-210794400,1),(575,-195073200,2),(575,-179344800,1),(575,-163623600,2),(575,-147895200,1),(575,-131569200,2),(575,-116445600,1),(575,-100119600,2),(575,-84391200,1),(575,-68670000,2),(575,-52941600,1),(575,-37220400,2),(575,-21492000,1),(575,-5770800,2),(575,9957600,1),(575,25678800,2),(575,41407200,1),(575,57733200,2),(575,73461600,1),(575,89182800,2),(575,104911200,1),(575,120632400,2),(575,136360800,1),(575,152082000,2),(575,167810400,1),(575,183531600,2),(575,199260000,1),(575,215586000,2),(575,230709600,1),(575,247035600,2),(575,262764000,1),(575,278485200,2),(575,294213600,1),(575,309934800,2),(575,325663200,1),(575,341384400,2),(575,357112800,1),(575,372834000,2),(575,388562400,1),(575,404888400,2),(575,420012000,1),(575,436338000,2),(575,452066400,1),(575,467787600,2),(575,483516000,1),(575,499237200,2),(575,514965600,1),(575,530686800,2),(575,544600800,1),(575,562136400,2),(575,576050400,1),(575,594190800,2),(575,607500000,1),(575,625640400,2),(575,638949600,1),(575,657090000,2),(575,671004000,1),(575,688539600,2),(575,702453600,1),(575,719989200,2),(575,733903200,1),(575,752043600,2),(575,765352800,1),(575,783493200,2),(575,796802400,1),(575,814942800,2),(575,828856800,1),(575,846392400,2),(575,860306400,1),(575,877842000,2),(575,891756000,1),(575,909291600,2),(575,923205600,1),(575,941346000,2),(575,954655200,1),(575,972795600,2),(575,986104800,1),(575,1004245200,2),(575,1018159200,1),(575,1035694800,2),(575,1049608800,1),(575,1067144400,2),(575,1081058400,1),(575,1099198800,2),(575,1112508000,1),(575,1130648400,2),(575,1143957600,1),(575,1162098000,2),(575,1173592800,1),(575,1194152400,2),(575,1205042400,1),(575,1225602000,2),(575,1236492000,1),(575,1257051600,2),(575,1268546400,1),(575,1289106000,2),(575,1299996000,1),(575,1320555600,2),(575,1331445600,1),(575,1352005200,2),(575,1362895200,1),(575,1383454800,2),(575,1394344800,1),(575,1414904400,2),(575,1425794400,1),(575,1446354000,2),(575,1457848800,1),(575,1478408400,2),(575,1489298400,1),(575,1509858000,2),(575,1520748000,1),(575,1541307600,2),(575,1552197600,1),(575,1572757200,2),(575,1583647200,1),(575,1604206800,2),(575,1615701600,1),(575,1636261200,2),(575,1647151200,1),(575,1667710800,2),(575,1678600800,1),(575,1699160400,2),(575,1710050400,1),(575,1730610000,2),(575,1741500000,1),(575,1762059600,2),(575,1772949600,1),(575,1793509200,2),(575,1805004000,1),(575,1825563600,2),(575,1836453600,1),(575,1857013200,2),(575,1867903200,1),(575,1888462800,2),(575,1899352800,1),(575,1919912400,2),(575,1930802400,1),(575,1951362000,2),(575,1962856800,1),(575,1983416400,2),(575,1994306400,1),(575,2014866000,2),(575,2025756000,1),(575,2046315600,2),(575,2057205600,1),(575,2077765200,2),(575,2088655200,1),(575,2109214800,2),(575,2120104800,1),(575,2140664400,2),(576,-2147483648,0),(576,-2030202084,2),(576,-1632063600,1),(576,-1615132800,2),(576,-1251651600,1),(576,-1238349600,2),(576,-1220202000,1),(576,-1206900000,2),(576,-1188752400,1),(576,-1175450400,2),(576,-1156698000,1),(576,-1144000800,2),(576,-1125248400,1),(576,-1111946400,2),(576,-1032714000,1),(576,-1016992800,2),(576,-1001264400,1),(576,-986148000,2),(576,-969814800,1),(576,-954093600,2),(576,-937760400,1),(576,-922039200,2),(576,-906310800,1),(576,-890589600,2),(576,-880210800,3),(576,-769395600,4),(576,-765388800,2),(576,-748450800,1),(576,-732729600,2),(576,-715791600,1),(576,-702489600,2),(576,-684342000,1),(576,-671040000,2),(576,-652892400,1),(576,-639590400,2),(576,-620838000,1),(576,-608140800,2),(576,-589388400,1),(576,-576086400,2),(576,-557938800,1),(576,-544636800,2),(576,-526489200,1),(576,-513187200,2),(576,-495039600,1),(576,-481737600,2),(576,-463590000,1),(576,-450288000,2),(576,-431535600,1),(576,-418233600,2),(576,-400086000,1),(576,-386784000,2),(576,-337186800,1),(576,-321465600,2),(576,-305737200,5),(577,-2147483648,2),(577,-1633276800,1),(577,-1615136400,2),(577,-1601827200,1),(577,-1583686800,2),(577,-1563724800,1),(577,-1551632400,2),(577,-1538928000,1),(577,-1520182800,2),(577,-1504454400,1),(577,-1491757200,2),(577,-1473004800,1),(577,-1459702800,2),(577,-1441555200,1),(577,-1428253200,2),(577,-1410105600,1),(577,-1396803600,2),(577,-1378656000,1),(577,-1365354000,2),(577,-1347206400,1),(577,-1333904400,2),(577,-1315152000,1),(577,-1301850000,2),(577,-1283702400,1),(577,-1270400400,2),(577,-1252252800,1),(577,-1238950800,2),(577,-1220803200,1),(577,-1207501200,2),(577,-1189353600,1),(577,-1176051600,2),(577,-1157299200,1),(577,-1144602000,2),(577,-1125849600,1),(577,-1112547600,2),(577,-1094400000,1),(577,-1081098000,2),(577,-1067788800,3),(577,-1045414800,2),(577,-1031500800,1),(577,-1018198800,2),(577,-1000051200,1),(577,-986749200,2),(577,-967996800,1),(577,-955299600,2),(577,-936547200,1),(577,-923245200,2),(577,-905097600,1),(577,-891795600,2),(577,-880214400,4),(577,-769395600,5),(577,-765392400,2),(577,-747244800,1),(577,-733942800,2),(577,-715795200,1),(577,-702493200,2),(577,-684345600,1),(577,-671043600,2),(577,-652896000,1),(577,-639594000,2),(577,-620841600,1),(577,-608144400,2),(577,-589392000,1),(577,-576090000,2),(577,-557942400,1),(577,-544640400,2),(577,-526492800,1),(577,-513190800,2),(577,-495043200,1),(577,-481741200,2),(577,-463593600,1),(577,-447267600,2),(577,-431539200,1),(577,-415818000,2),(577,-400089600,1),(577,-384368400,2),(577,-368640000,1),(577,-352918800,2),(577,-337190400,1),(577,-321469200,2),(577,-305740800,1),(577,-289414800,2),(577,-273686400,1),(577,-257965200,2),(577,-242236800,1),(577,-226515600,2),(577,-210787200,1),(577,-195066000,2),(577,-179337600,1),(577,-163616400,2),(577,-147888000,1),(577,-131562000,2),(577,-116438400,1),(577,-100112400,2),(577,-84384000,1),(577,-68662800,2),(577,-52934400,1),(577,-37213200,2),(577,-21484800,1),(577,-5763600,2),(577,9964800,1),(577,25686000,2),(577,41414400,1),(577,57740400,2),(577,73468800,1),(577,89190000,2),(577,104918400,1),(577,120639600,2),(577,126691200,1),(577,152089200,2),(577,162374400,1),(577,183538800,2),(577,199267200,1),(577,215593200,2),(577,230716800,1),(577,247042800,2),(577,262771200,1),(577,278492400,2),(577,294220800,1),(577,309942000,2),(577,325670400,1),(577,341391600,2),(577,357120000,1),(577,372841200,2),(577,388569600,1),(577,404895600,2),(577,420019200,1),(577,436345200,2),(577,452073600,1),(577,467794800,2),(577,483523200,1),(577,499244400,2),(577,514972800,1),(577,530694000,2),(577,544608000,1),(577,562143600,2),(577,576057600,1),(577,594198000,2),(577,607507200,1),(577,625647600,2),(577,638956800,1),(577,657097200,2),(577,671011200,1),(577,688546800,2),(577,702460800,1),(577,719996400,2),(577,733910400,1),(577,752050800,2),(577,765360000,1),(577,783500400,2),(577,796809600,1),(577,814950000,2),(577,828864000,1),(577,846399600,2),(577,860313600,1),(577,877849200,2),(577,891763200,1),(577,909298800,2),(577,923212800,1),(577,941353200,2),(577,954662400,1),(577,972802800,2),(577,986112000,1),(577,1004252400,2),(577,1018166400,1),(577,1035702000,2),(577,1049616000,1),(577,1067151600,2),(577,1081065600,1),(577,1099206000,2),(577,1112515200,1),(577,1130655600,2),(577,1143964800,1),(577,1162105200,2),(577,1173600000,1),(577,1194159600,2),(577,1205049600,1),(577,1225609200,2),(577,1236499200,1),(577,1257058800,2),(577,1268553600,1),(577,1289113200,2),(577,1300003200,1),(577,1320562800,2),(577,1331452800,1),(577,1352012400,2),(577,1362902400,1),(577,1383462000,2),(577,1394352000,1),(577,1414911600,2),(577,1425801600,1),(577,1446361200,2),(577,1457856000,1),(577,1478415600,2),(577,1489305600,1),(577,1509865200,2),(577,1520755200,1),(577,1541314800,2),(577,1552204800,1),(577,1572764400,2),(577,1583654400,1),(577,1604214000,2),(577,1615708800,1),(577,1636268400,2),(577,1647158400,1),(577,1667718000,2),(577,1678608000,1),(577,1699167600,2),(577,1710057600,1),(577,1730617200,2),(577,1741507200,1),(577,1762066800,2),(577,1772956800,1),(577,1793516400,2),(577,1805011200,1),(577,1825570800,2),(577,1836460800,1),(577,1857020400,2),(577,1867910400,1),(577,1888470000,2),(577,1899360000,1),(577,1919919600,2),(577,1930809600,1),(577,1951369200,2),(577,1962864000,1),(577,1983423600,2),(577,1994313600,1),(577,2014873200,2),(577,2025763200,1),(577,2046322800,2),(577,2057212800,1),(577,2077772400,2),(577,2088662400,1),(577,2109222000,2),(577,2120112000,1),(577,2140671600,2),(578,-2147483648,1),(578,-1946918424,2),(579,-2147483648,2),(579,-1633280400,1),(579,-1615140000,2),(579,-1601830800,1),(579,-1583690400,2),(579,-1570381200,1),(579,-1551636000,2),(579,-1536512400,1),(579,-1523210400,2),(579,-1504458000,1),(579,-1491760800,2),(579,-1473008400,1),(579,-1459706400,2),(579,-1441558800,1),(579,-1428256800,2),(579,-1410109200,1),(579,-1396807200,2),(579,-1378659600,1),(579,-1365357600,2),(579,-1347210000,1),(579,-1333908000,2),(579,-1315155600,1),(579,-1301853600,2),(579,-1283706000,1),(579,-1270404000,2),(579,-1252256400,1),(579,-1238954400,2),(579,-1220806800,1),(579,-1207504800,2),(579,-1189357200,1),(579,-1176055200,2),(579,-1157302800,1),(579,-1144605600,2),(579,-1125853200,1),(579,-1112551200,2),(579,-1094403600,1),(579,-1081101600,2),(579,-1062954000,1),(579,-1049652000,2),(579,-1031504400,1),(579,-1018202400,2),(579,-1000054800,1),(579,-986752800,2),(579,-968000400,1),(579,-955303200,2),(579,-936550800,1),(579,-923248800,2),(579,-905101200,1),(579,-891799200,2),(579,-880218000,3),(579,-769395600,4),(579,-765396000,2),(579,-747248400,1),(579,-733946400,2),(579,-715798800,1),(579,-702496800,2),(579,-684349200,1),(579,-671047200,2),(579,-652899600,1),(579,-639597600,2),(579,-620845200,1),(579,-608148000,2),(579,-589395600,1),(579,-576093600,2),(579,-557946000,1),(579,-544644000,2),(579,-526496400,1),(579,-513194400,2),(579,-495046800,1),(579,-481744800,2),(579,-463597200,1),(579,-447271200,2),(579,-431542800,1),(579,-415821600,2),(579,-400093200,1),(579,-384372000,2),(579,-368643600,1),(579,-352922400,2),(579,-337194000,1),(579,-321472800,2),(579,-305744400,1),(579,-289418400,2),(579,-273690000,1),(579,-257968800,2),(579,-242240400,1),(579,-226519200,2),(579,-210790800,1),(579,-195069600,2),(579,-179341200,1),(579,-163620000,2),(579,-147891600,1),(579,-131565600,2),(579,-116442000,1),(579,-100116000,2),(579,-84387600,1),(579,-68666400,2),(579,-52938000,1),(579,-37216800,2),(579,-21488400,1),(579,-5767200,2),(579,9961200,1),(579,25682400,2),(579,41410800,1),(579,57736800,2),(579,73465200,1),(579,89186400,2),(579,104914800,1),(579,120636000,2),(579,126687600,1),(579,152085600,2),(579,162370800,1),(579,183535200,2),(579,199263600,1),(579,215589600,2),(579,230713200,1),(579,247039200,2),(579,262767600,1),(579,278488800,2),(579,294217200,1),(579,309938400,2),(579,325666800,1),(579,341388000,2),(579,357116400,1),(579,372837600,2),(579,388566000,1),(579,404892000,2),(579,420015600,1),(579,436341600,2),(579,452070000,1),(579,467791200,2),(579,483519600,1),(579,499240800,2),(579,514969200,1),(579,530690400,2),(579,544604400,1),(579,562140000,2),(579,576054000,1),(579,594194400,2),(579,607503600,1),(579,625644000,2),(579,638953200,1),(579,657093600,2),(579,671007600,1),(579,688543200,2),(579,702457200,1),(579,719992800,2),(579,733906800,1),(579,752047200,2),(579,765356400,1),(579,783496800,2),(579,796806000,1),(579,814946400,2),(579,828860400,1),(579,846396000,2),(579,860310000,1),(579,877845600,2),(579,891759600,1),(579,909295200,2),(579,923209200,1),(579,941349600,2),(579,954658800,1),(579,972799200,2),(579,986108400,1),(579,1004248800,2),(579,1018162800,1),(579,1035698400,2),(579,1049612400,1),(579,1067148000,2),(579,1081062000,1),(579,1099202400,2),(579,1112511600,1),(579,1130652000,2),(579,1143961200,1),(579,1162101600,2),(579,1173596400,1),(579,1194156000,2),(579,1205046000,1),(579,1225605600,2),(579,1236495600,1),(579,1257055200,2),(579,1268550000,1),(579,1289109600,2),(579,1299999600,1),(579,1320559200,2),(579,1331449200,1),(579,1352008800,2),(579,1362898800,1),(579,1383458400,2),(579,1394348400,1),(579,1414908000,2),(579,1425798000,1),(579,1446357600,2),(579,1457852400,1),(579,1478412000,2),(579,1489302000,1),(579,1509861600,2),(579,1520751600,1),(579,1541311200,2),(579,1552201200,1),(579,1572760800,2),(579,1583650800,1),(579,1604210400,2),(579,1615705200,1),(579,1636264800,2),(579,1647154800,1),(579,1667714400,2),(579,1678604400,1),(579,1699164000,2),(579,1710054000,1),(579,1730613600,2),(579,1741503600,1),(579,1762063200,2),(579,1772953200,1),(579,1793512800,2),(579,1805007600,1),(579,1825567200,2),(579,1836457200,1),(579,1857016800,2),(579,1867906800,1),(579,1888466400,2),(579,1899356400,1),(579,1919916000,2),(579,1930806000,1),(579,1951365600,2),(579,1962860400,1),(579,1983420000,2),(579,1994310000,1),(579,2014869600,2),(579,2025759600,1),(579,2046319200,2),(579,2057209200,1),(579,2077768800,2),(579,2088658800,1),(579,2109218400,2),(579,2120108400,1),(579,2140668000,2),(580,-2147483648,1),(580,-1157283000,2),(580,-1155436200,1),(580,-880198200,3),(580,-769395600,4),(580,-765376200,1),(580,-712150200,5),(581,-2147483648,2),(581,-1633273200,1),(581,-1615132800,2),(581,-1601823600,1),(581,-1583683200,2),(581,-880210800,3),(581,-820519140,2),(581,-812653140,3),(581,-796845540,2),(581,-84380400,1),(581,-68659200,2),(582,-2147483648,2),(582,-1633273200,1),(582,-1615132800,2),(582,-1601823600,1),(582,-1583683200,2),(582,-1570374000,1),(582,-1551628800,2),(582,-1538924400,1),(582,-1534089600,2),(582,-880210800,3),(582,-769395600,4),(582,-765388800,2),(582,-147884400,1),(582,-131558400,2),(582,-116434800,1),(582,-100108800,2),(582,-84380400,1),(582,-68659200,2),(582,-52930800,1),(582,-37209600,2),(582,-21481200,1),(582,-5760000,2),(582,9968400,1),(582,25689600,2),(582,41418000,1),(582,57744000,2),(582,73472400,1),(582,89193600,2),(582,104922000,1),(582,120643200,2),(582,126694800,1),(582,152092800,2),(582,162378000,1),(582,183542400,2),(582,199270800,1),(582,215596800,2),(582,230720400,1),(582,247046400,2),(582,262774800,1),(582,278496000,2),(582,294224400,1),(582,309945600,2),(582,325674000,1),(582,341395200,2),(582,357123600,1),(582,372844800,2),(582,388573200,1),(582,404899200,2),(582,420022800,1),(582,436348800,2),(582,452077200,1),(582,467798400,2),(582,483526800,1),(582,499248000,2),(582,514976400,1),(582,530697600,2),(582,544611600,1),(582,562147200,2),(582,576061200,1),(582,594201600,2),(582,607510800,1),(582,625651200,2),(582,638960400,1),(582,657100800,2),(582,671014800,1),(582,688550400,2),(582,702464400,1),(582,720000000,2),(582,733914000,1),(582,752054400,2),(582,765363600,1),(582,783504000,2),(582,796813200,1),(582,814953600,2),(582,828867600,1),(582,846403200,2),(582,860317200,1),(582,877852800,2),(582,891766800,1),(582,909302400,2),(582,923216400,1),(582,941356800,2),(582,954666000,1),(582,972806400,2),(582,986115600,1),(582,1004256000,2),(582,1018170000,1),(582,1035705600,2),(582,1049619600,1),(582,1067155200,2),(582,1081069200,1),(582,1099209600,2),(582,1112518800,1),(582,1130659200,2),(582,1143968400,1),(582,1162108800,2),(582,1173603600,1),(582,1194163200,2),(582,1205053200,1),(582,1225612800,2),(582,1236502800,1),(582,1257062400,2),(582,1268557200,1),(582,1289116800,2),(582,1300006800,1),(582,1320566400,2),(582,1331456400,1),(582,1352016000,2),(582,1362906000,1),(582,1383465600,2),(582,1394355600,1),(582,1414915200,2),(582,1425805200,1),(582,1446364800,2),(582,1457859600,1),(582,1478419200,2),(582,1489309200,1),(582,1509868800,2),(582,1520758800,1),(582,1541318400,2),(582,1552208400,1),(582,1572768000,2),(582,1583658000,1),(582,1604217600,2),(582,1615712400,1),(582,1636272000,2),(582,1647162000,1),(582,1667721600,2),(582,1678611600,1),(582,1699171200,2),(582,1710061200,1),(582,1730620800,2),(582,1741510800,1),(582,1762070400,2),(582,1772960400,1),(582,1793520000,2),(582,1805014800,1),(582,1825574400,2),(582,1836464400,1),(582,1857024000,2),(582,1867914000,1),(582,1888473600,2),(582,1899363600,1),(582,1919923200,2),(582,1930813200,1),(582,1951372800,2),(582,1962867600,1),(582,1983427200,2),(582,1994317200,1),(582,2014876800,2),(582,2025766800,1),(582,2046326400,2),(582,2057216400,1),(582,2077776000,2),(582,2088666000,1),(582,2109225600,2),(582,2120115600,1),(582,2140675200,2),(583,-2147483648,1),(583,893665800,2),(583,2147483647,2),(584,-2147483648,2),(584,-1633269600,1),(584,-1615129200,2),(584,-1601820000,1),(584,-1583679600,2),(584,-880207200,3),(584,-769395600,4),(584,-765385200,2),(584,-687967140,1),(584,-662655600,2),(584,-620838000,1),(584,-608137200,2),(584,-589388400,1),(584,-576082800,2),(584,-557938800,1),(584,-544633200,2),(584,-526489200,1),(584,-513183600,2),(584,-495039600,1),(584,-481734000,2),(584,-463590000,1),(584,-450284400,2),(584,-431535600,1),(584,-418230000,2),(584,-400086000,1),(584,-386780400,2),(584,-368636400,1),(584,-355330800,2),(584,-337186800,1),(584,-323881200,2),(584,-305737200,1),(584,-292431600,2),(584,-273682800,1),(584,-260982000,2),(584,-242233200,1),(584,-226508400,2),(584,-210783600,1),(584,-195058800,2),(584,-179334000,1),(584,-163609200,2),(584,-147884400,1),(584,-131554800,2),(584,-116434800,1),(584,-100105200,2),(584,-84376800,1),(584,-68655600,2),(584,-52927200,1),(584,-37206000,2),(584,-21477600,1),(584,-5756400,2),(584,9972000,1),(584,25693200,2),(584,41421600,1),(584,57747600,2),(584,73476000,1),(584,89197200,2),(584,104925600,1),(584,120646800,2),(584,126698400,1),(584,152096400,2),(584,162381600,1),(584,183546000,2),(584,199274400,1),(584,215600400,2),(584,230724000,1),(584,247050000,2),(584,262778400,1),(584,278499600,2),(584,294228000,1),(584,309949200,2),(584,325677600,1),(584,341398800,2),(584,357127200,1),(584,372848400,2),(584,388576800,1),(584,404902800,2),(584,420026400,1),(584,436352400,2),(584,452080800,1),(584,467802000,2),(584,483530400,1),(584,499251600,2),(584,514980000,1),(584,530701200,2),(584,544615200,1),(584,562150800,2),(584,576064800,1),(584,594205200,2),(584,607514400,1),(584,625654800,2),(584,638964000,1),(584,657104400,2),(584,671018400,1),(584,688554000,2),(584,702468000,1),(584,720003600,2),(584,733917600,1),(584,752058000,2),(584,765367200,1),(584,783507600,2),(584,796816800,1),(584,814957200,2),(584,828871200,1),(584,846406800,2),(584,860320800,1),(584,877856400,2),(584,891770400,1),(584,909306000,2),(584,923220000,1),(584,941360400,2),(584,954669600,1),(584,972810000,2),(584,986119200,1),(584,1004259600,2),(584,1018173600,1),(584,1035709200,2),(584,1049623200,1),(584,1067158800,2),(584,1081072800,1),(584,1099213200,2),(584,1112522400,1),(584,1130662800,2),(584,1143972000,1),(584,1162112400,2),(584,1173607200,1),(584,1194166800,2),(584,1205056800,1),(584,1225616400,2),(584,1236506400,1),(584,1257066000,2),(584,1268560800,1),(584,1289120400,2),(584,1300010400,1),(584,1320570000,2),(584,1331460000,1),(584,1352019600,2),(584,1362909600,1),(584,1383469200,2),(584,1394359200,1),(584,1414918800,2),(584,1425808800,1),(584,1446368400,2),(584,1457863200,1),(584,1478422800,2),(584,1489312800,1),(584,1509872400,2),(584,1520762400,1),(584,1541322000,2),(584,1552212000,1),(584,1572771600,2),(584,1583661600,1),(584,1604221200,2),(584,1615716000,1),(584,1636275600,2),(584,1647165600,1),(584,1667725200,2),(584,1678615200,1),(584,1699174800,2),(584,1710064800,1),(584,1730624400,2),(584,1741514400,1),(584,1762074000,2),(584,1772964000,1),(584,1793523600,2),(584,1805018400,1),(584,1825578000,2),(584,1836468000,1),(584,1857027600,2),(584,1867917600,1),(584,1888477200,2),(584,1899367200,1),(584,1919926800,2),(584,1930816800,1),(584,1951376400,2),(584,1962871200,1),(584,1983430800,2),(584,1994320800,1),(584,2014880400,2),(584,2025770400,1),(584,2046330000,2),(584,2057220000,1),(584,2077779600,2),(584,2088669600,1),(584,2109229200,2),(584,2120119200,1),(584,2140678800,2),(585,-2147483648,0),(585,-1806678012,1),(585,2147483647,1),(586,-2147483648,1),(586,-880200000,2),(586,-769395600,3),(586,-765378000,1),(586,-86882400,4),(586,-21470400,5),(586,-5749200,4),(586,9979200,5),(586,25700400,4),(586,41428800,5),(586,57754800,4),(586,73483200,5),(586,89204400,4),(586,104932800,5),(586,120654000,4),(586,126705600,5),(586,152103600,4),(586,162388800,5),(586,183553200,4),(586,199281600,5),(586,215607600,4),(586,230731200,5),(586,247057200,4),(586,262785600,5),(586,278506800,4),(586,294235200,5),(586,309956400,4),(586,325684800,5),(586,341406000,4),(586,357134400,5),(586,372855600,4),(586,388584000,5),(586,404910000,4),(586,420033600,5),(586,436359600,6),(586,439030800,8),(586,452084400,7),(586,467805600,8),(586,483534000,7),(586,499255200,8),(586,514983600,7),(586,530704800,8),(586,544618800,7),(586,562154400,8),(586,576068400,7),(586,594208800,8),(586,607518000,7),(586,625658400,8),(586,638967600,7),(586,657108000,8),(586,671022000,7),(586,688557600,8),(586,702471600,7),(586,720007200,8),(586,733921200,7),(586,752061600,8),(586,765370800,7),(586,783511200,8),(586,796820400,7),(586,814960800,8),(586,828874800,7),(586,846410400,8),(586,860324400,7),(586,877860000,8),(586,891774000,7),(586,909309600,8),(586,923223600,7),(586,941364000,8),(586,954673200,7),(586,972813600,8),(586,986122800,7),(586,1004263200,8),(586,1018177200,7),(586,1035712800,8),(586,1049626800,7),(586,1067162400,8),(586,1081076400,7),(586,1099216800,8),(586,1112526000,7),(586,1130666400,8),(586,1143975600,7),(586,1162116000,8),(586,1173610800,7),(586,1194170400,8),(586,1205060400,7),(586,1225620000,8),(586,1236510000,7),(586,1257069600,8),(586,1268564400,7),(586,1289124000,8),(586,1300014000,7),(586,1320573600,8),(586,1331463600,7),(586,1352023200,8),(586,1362913200,7),(586,1383472800,8),(586,1394362800,7),(586,1414922400,8),(586,1425812400,7),(586,1446372000,8),(586,1457866800,7),(586,1478426400,8),(586,1489316400,7),(586,1509876000,8),(586,1520766000,7),(586,1541325600,8),(586,1552215600,7),(586,1572775200,8),(586,1583665200,7),(586,1604224800,8),(586,1615719600,7),(586,1636279200,8),(586,1647169200,7),(586,1667728800,8),(586,1678618800,7),(586,1699178400,8),(586,1710068400,7),(586,1730628000,8),(586,1741518000,7),(586,1762077600,8),(586,1772967600,7),(586,1793527200,8),(586,1805022000,7),(586,1825581600,8),(586,1836471600,7),(586,1857031200,8),(586,1867921200,7),(586,1888480800,8),(586,1899370800,7),(586,1919930400,8),(586,1930820400,7),(586,1951380000,8),(586,1962874800,7),(586,1983434400,8),(586,1994324400,7),(586,2014884000,8),(586,2025774000,7),(586,2046333600,8),(586,2057223600,7),(586,2077783200,8),(586,2088673200,7),(586,2109232800,8),(586,2120122800,7),(586,2140682400,8),(587,-2147483648,1),(587,-1869875816,3),(587,-1693706400,2),(587,-1680490800,3),(587,-1570413600,2),(587,-1552186800,3),(587,-1538359200,2),(587,-1522551600,3),(587,-1507514400,2),(587,-1490583600,3),(587,-1440208800,2),(587,-1428030000,3),(587,-1409709600,2),(587,-1396494000,3),(587,-931140000,2),(587,-922762800,3),(587,-917834400,2),(587,-892436400,3),(587,-875844000,2),(587,-857358000,3),(587,-781063200,2),(587,-764737200,3),(587,-744343200,2),(587,-733806000,3),(587,-716436000,2),(587,-701924400,3),(587,-684986400,2),(587,-670474800,3),(587,-654141600,2),(587,-639025200,3),(587,-621828000,2),(587,-606970800,3),(587,-590032800,2),(587,-575434800,3),(587,-235620000,2),(587,-228279600,3),(587,-177732000,2),(587,-165726000,3),(587,10533600,2),(587,23835600,3),(587,41983200,2),(587,55285200,3),(587,74037600,2),(587,87339600,3),(587,107910000,2),(587,121219200,3),(587,133920000,2),(587,152676000,3),(587,165362400,2),(587,183502800,3),(587,202428000,2),(587,215557200,3),(587,228866400,2),(587,245797200,3),(587,260316000,2),(587,277246800,4),(587,308779200,5),(587,323827200,4),(587,340228800,5),(587,354672000,4),(587,371678400,5),(587,386121600,4),(587,403128000,5),(587,428446800,4),(587,433886400,5),(587,482792400,2),(587,496702800,3),(587,512521200,6),(587,528246000,7),(587,543970800,6),(587,559695600,7),(587,575420400,6),(587,591145200,7),(587,606870000,6),(587,622594800,7),(587,638319600,6),(587,654649200,7),(587,670374000,6),(587,686098800,7),(587,701823600,6),(587,717548400,7),(587,733273200,6),(587,748998000,7),(587,764118000,6),(587,780447600,7),(587,796172400,6),(587,811897200,7),(587,828226800,6),(587,846370800,7),(587,859676400,6),(587,877820400,7),(587,891126000,6),(587,909270000,7),(587,922575600,6),(587,941324400,7),(587,954025200,6),(587,972774000,7),(587,985474800,6),(587,1004223600,7),(587,1017529200,6),(587,1035673200,7),(587,1048978800,6),(587,1067122800,7),(587,1080428400,6),(587,1099177200,7),(587,1111878000,6),(587,1130626800,7),(587,1143327600,6),(587,1162076400,7),(587,1167602400,3),(587,1174784400,8),(587,1193533200,9),(587,1206838800,8),(587,1224982800,9),(587,1238288400,8),(587,1256432400,9),(587,1269738000,8),(587,1288486800,9),(587,1301274000,8),(587,1319936400,9),(587,1332637200,8),(587,1351386000,9),(587,1364691600,8),(587,1382835600,9),(587,1396227600,8),(587,1414285200,9),(587,1427590800,8),(587,1446944400,9),(587,1459040400,8),(587,1473195600,5),(587,2147483647,5),(589,-2147483648,1),(589,-880200000,2),(589,-769395600,3),(589,-765378000,1),(589,-86882400,4),(589,-21470400,5),(589,-5749200,4),(589,9979200,5),(589,25700400,4),(589,41428800,5),(589,57754800,4),(589,73483200,5),(589,89204400,4),(589,104932800,5),(589,120654000,4),(589,126705600,5),(589,152103600,4),(589,162388800,5),(589,183553200,4),(589,199281600,5),(589,215607600,4),(589,230731200,5),(589,247057200,4),(589,262785600,5),(589,278506800,4),(589,294235200,5),(589,309956400,4),(589,325684800,5),(589,341406000,4),(589,357134400,5),(589,372855600,4),(589,388584000,5),(589,404910000,4),(589,420033600,5),(589,436359600,6),(589,439030800,8),(589,452084400,7),(589,467805600,8),(589,483534000,7),(589,499255200,8),(589,514983600,7),(589,530704800,8),(589,544618800,7),(589,562154400,8),(589,576068400,7),(589,594208800,8),(589,607518000,7),(589,625658400,8),(589,638967600,7),(589,657108000,8),(589,671022000,7),(589,688557600,8),(589,702471600,7),(589,720007200,8),(589,733921200,7),(589,752061600,8),(589,765370800,7),(589,783511200,8),(589,796820400,7),(589,814960800,8),(589,828874800,7),(589,846410400,8),(589,860324400,7),(589,877860000,8),(589,891774000,7),(589,909309600,8),(589,923223600,7),(589,941364000,8),(589,954673200,7),(589,972813600,8),(589,986122800,7),(589,1004263200,8),(589,1018177200,7),(589,1035712800,8),(589,1049626800,7),(589,1067162400,8),(589,1081076400,7),(589,1099216800,8),(589,1112526000,7),(589,1130666400,8),(589,1143975600,7),(589,1162116000,8),(589,1173610800,7),(589,1194170400,8),(589,1205060400,7),(589,1225620000,8),(589,1236510000,7),(589,1257069600,8),(589,1268564400,7),(589,1289124000,8),(589,1300014000,7),(589,1320573600,8),(589,1331463600,7),(589,1352023200,8),(589,1362913200,7),(589,1383472800,8),(589,1394362800,7),(589,1414922400,8),(589,1425812400,7),(589,1446372000,8),(589,1457866800,7),(589,1478426400,8),(589,1489316400,7),(589,1509876000,8),(589,1520766000,7),(589,1541325600,8),(589,1552215600,7),(589,1572775200,8),(589,1583665200,7),(589,1604224800,8),(589,1615719600,7),(589,1636279200,8),(589,1647169200,7),(589,1667728800,8),(589,1678618800,7),(589,1699178400,8),(589,1710068400,7),(589,1730628000,8),(589,1741518000,7),(589,1762077600,8),(589,1772967600,7),(589,1793527200,8),(589,1805022000,7),(589,1825581600,8),(589,1836471600,7),(589,1857031200,8),(589,1867921200,7),(589,1888480800,8),(589,1899370800,7),(589,1919930400,8),(589,1930820400,7),(589,1951380000,8),(589,1962874800,7),(589,1983434400,8),(589,1994324400,7),(589,2014884000,8),(589,2025774000,7),(589,2046333600,8),(589,2057223600,7),(589,2077783200,8),(589,2088673200,7),(589,2109232800,8),(589,2120122800,7),(589,2140682400,8),(590,-2147483648,1),(590,-880196400,2),(590,-769395600,3),(590,-765374400,1),(590,-86878800,4),(590,-21466800,5),(590,-5745600,4),(590,9982800,5),(590,25704000,4),(590,41432400,5),(590,57758400,4),(590,73486800,5),(590,89208000,4),(590,104936400,5),(590,120657600,4),(590,126709200,5),(590,152107200,4),(590,162392400,5),(590,183556800,4),(590,199285200,5),(590,215611200,4),(590,230734800,5),(590,247060800,4),(590,262789200,5),(590,278510400,4),(590,294238800,5),(590,309960000,4),(590,325688400,5),(590,341409600,4),(590,357138000,5),(590,372859200,4),(590,388587600,5),(590,404913600,4),(590,420037200,5),(590,436363200,6),(590,439034400,8),(590,452088000,7),(590,467809200,8),(590,483537600,7),(590,499258800,8),(590,514987200,7),(590,530708400,8),(590,544622400,7),(590,562158000,8),(590,576072000,7),(590,594212400,8),(590,607521600,7),(590,625662000,8),(590,638971200,7),(590,657111600,8),(590,671025600,7),(590,688561200,8),(590,702475200,7),(590,720010800,8),(590,733924800,7),(590,752065200,8),(590,765374400,7),(590,783514800,8),(590,796824000,7),(590,814964400,8),(590,828878400,7),(590,846414000,8),(590,860328000,7),(590,877863600,8),(590,891777600,7),(590,909313200,8),(590,923227200,7),(590,941367600,8),(590,954676800,7),(590,972817200,8),(590,986126400,7),(590,1004266800,8),(590,1018180800,7),(590,1035716400,8),(590,1049630400,7),(590,1067166000,8),(590,1081080000,7),(590,1099220400,8),(590,1112529600,7),(590,1130670000,8),(590,1143979200,7),(590,1162119600,8),(590,1173614400,7),(590,1194174000,8),(590,1205064000,7),(590,1225623600,8),(590,1236513600,7),(590,1257073200,8),(590,1268568000,7),(590,1289127600,8),(590,1300017600,7),(590,1320577200,8),(590,1331467200,7),(590,1352026800,8),(590,1362916800,7),(590,1383476400,8),(590,1394366400,7),(590,1414926000,8),(590,1425816000,7),(590,1446375600,8),(590,1457870400,7),(590,1478430000,8),(590,1489320000,7),(590,1509879600,8),(590,1520769600,7),(590,1541329200,8),(590,1552219200,7),(590,1572778800,8),(590,1583668800,7),(590,1604228400,8),(590,1615723200,7),(590,1636282800,8),(590,1647172800,7),(590,1667732400,8),(590,1678622400,7),(590,1699182000,8),(590,1710072000,7),(590,1730631600,8),(590,1741521600,7),(590,1762081200,8),(590,1772971200,7),(590,1793530800,8),(590,1805025600,7),(590,1825585200,8),(590,1836475200,7),(590,1857034800,8),(590,1867924800,7),(590,1888484400,8),(590,1899374400,7),(590,1919934000,8),(590,1930824000,7),(590,1951383600,8),(590,1962878400,7),(590,1983438000,8),(590,1994328000,7),(590,2014887600,8),(590,2025777600,7),(590,2046337200,8),(590,2057227200,7),(590,2077786800,8),(590,2088676800,7),(590,2109236400,8),(590,2120126400,7),(590,2140686000,8),(591,-2147483648,2),(591,-1633273200,1),(591,-1615132800,2),(591,-1601823600,1),(591,-1583683200,2),(591,-880210800,3),(591,-820519140,2),(591,-812653140,3),(591,-796845540,2),(591,-84380400,1),(591,-68659200,2),(592,-2147483648,2),(592,-1633276800,1),(592,-1615136400,2),(592,-1601827200,1),(592,-1583686800,2),(592,-1563724800,1),(592,-1551632400,2),(592,-1538928000,1),(592,-1520182800,2),(592,-1504454400,1),(592,-1491757200,2),(592,-1473004800,1),(592,-1459702800,2),(592,-1441555200,1),(592,-1428253200,2),(592,-1410105600,1),(592,-1396803600,2),(592,-1378656000,1),(592,-1365354000,2),(592,-1347206400,1),(592,-1333904400,2),(592,-1315152000,1),(592,-1301850000,2),(592,-1283702400,1),(592,-1270400400,2),(592,-1252252800,1),(592,-1238950800,2),(592,-1220803200,1),(592,-1207501200,2),(592,-1189353600,1),(592,-1176051600,2),(592,-1157299200,1),(592,-1144602000,2),(592,-1125849600,1),(592,-1112547600,2),(592,-1094400000,1),(592,-1081098000,2),(592,-1067788800,3),(592,-1045414800,2),(592,-1031500800,1),(592,-1018198800,2),(592,-1000051200,1),(592,-986749200,2),(592,-967996800,1),(592,-955299600,2),(592,-936547200,1),(592,-923245200,2),(592,-905097600,1),(592,-891795600,2),(592,-880214400,4),(592,-769395600,5),(592,-765392400,2),(592,-747244800,1),(592,-733942800,2),(592,-715795200,1),(592,-702493200,2),(592,-684345600,1),(592,-671043600,2),(592,-652896000,1),(592,-639594000,2),(592,-620841600,1),(592,-608144400,2),(592,-589392000,1),(592,-576090000,2),(592,-557942400,1),(592,-544640400,2),(592,-526492800,1),(592,-513190800,2),(592,-495043200,1),(592,-481741200,2),(592,-463593600,1),(592,-447267600,2),(592,-431539200,1),(592,-415818000,2),(592,-400089600,1),(592,-384368400,2),(592,-368640000,1),(592,-352918800,2),(592,-337190400,1),(592,-321469200,2),(592,-305740800,1),(592,-289414800,2),(592,-273686400,1),(592,-257965200,2),(592,-242236800,1),(592,-226515600,2),(592,-210787200,1),(592,-195066000,2),(592,-179337600,1),(592,-163616400,2),(592,-147888000,1),(592,-131562000,2),(592,-116438400,1),(592,-100112400,2),(592,-84384000,1),(592,-68662800,2),(592,-52934400,1),(592,-37213200,2),(592,-21484800,1),(592,-5763600,2),(592,9964800,1),(592,25686000,2),(592,41414400,1),(592,57740400,2),(592,73468800,1),(592,89190000,2),(592,104918400,1),(592,120639600,2),(592,126691200,1),(592,152089200,2),(592,162374400,1),(592,183538800,2),(592,199267200,1),(592,215593200,2),(592,230716800,1),(592,247042800,2),(592,262771200,1),(592,278492400,2),(592,294220800,1),(592,309942000,2),(592,325670400,1),(592,341391600,2),(592,357120000,1),(592,372841200,2),(592,388569600,1),(592,404895600,2),(592,420019200,1),(592,436345200,2),(592,452073600,1),(592,467794800,2),(592,483523200,1),(592,499244400,2),(592,514972800,1),(592,530694000,2),(592,544608000,1),(592,562143600,2),(592,576057600,1),(592,594198000,2),(592,607507200,1),(592,625647600,2),(592,638956800,1),(592,657097200,2),(592,671011200,1),(592,688546800,2),(592,702460800,1),(592,719996400,2),(592,733910400,1),(592,752050800,2),(592,765360000,1),(592,783500400,2),(592,796809600,1),(592,814950000,2),(592,828864000,1),(592,846399600,2),(592,860313600,1),(592,877849200,2),(592,891763200,1),(592,909298800,2),(592,923212800,1),(592,941353200,2),(592,954662400,1),(592,972802800,2),(592,986112000,1),(592,1004252400,2),(592,1018166400,1),(592,1035702000,2),(592,1049616000,1),(592,1067151600,2),(592,1081065600,1),(592,1099206000,2),(592,1112515200,1),(592,1130655600,2),(592,1143964800,1),(592,1162105200,2),(592,1173600000,1),(592,1194159600,2),(592,1205049600,1),(592,1225609200,2),(592,1236499200,1),(592,1257058800,2),(592,1268553600,1),(592,1289113200,2),(592,1300003200,1),(592,1320562800,2),(592,1331452800,1),(592,1352012400,2),(592,1362902400,1),(592,1383462000,2),(592,1394352000,1),(592,1414911600,2),(592,1425801600,1),(592,1446361200,2),(592,1457856000,1),(592,1478415600,2),(592,1489305600,1),(592,1509865200,2),(592,1520755200,1),(592,1541314800,2),(592,1552204800,1),(592,1572764400,2),(592,1583654400,1),(592,1604214000,2),(592,1615708800,1),(592,1636268400,2),(592,1647158400,1),(592,1667718000,2),(592,1678608000,1),(592,1699167600,2),(592,1710057600,1),(592,1730617200,2),(592,1741507200,1),(592,1762066800,2),(592,1772956800,1),(592,1793516400,2),(592,1805011200,1),(592,1825570800,2),(592,1836460800,1),(592,1857020400,2),(592,1867910400,1),(592,1888470000,2),(592,1899360000,1),(592,1919919600,2),(592,1930809600,1),(592,1951369200,2),(592,1962864000,1),(592,1983423600,2),(592,1994313600,1),(592,2014873200,2),(592,2025763200,1),(592,2046322800,2),(592,2057212800,1),(592,2077772400,2),(592,2088662400,1),(592,2109222000,2),(592,2120112000,1),(592,2140671600,2),(593,-2147483648,2),(593,-1633276800,1),(593,-1615136400,2),(593,-1601827200,1),(593,-1583686800,2),(593,-900259200,1),(593,-891795600,2),(593,-880214400,3),(593,-769395600,4),(593,-765392400,2),(593,-747244800,1),(593,-733942800,2),(593,-715795200,1),(593,-702493200,2),(593,-684345600,1),(593,-671043600,2),(593,-652896000,1),(593,-639594000,2),(593,-620841600,1),(593,-608144400,2),(593,-589392000,1),(593,-576090000,2),(593,-557942400,1),(593,-544640400,2),(593,-526492800,1),(593,-513190800,2),(593,-495043200,1),(593,-481741200,2),(593,-463593600,5),(593,-386787600,2),(593,-368640000,5),(593,-21488400,6),(593,-5767200,5),(593,9961200,6),(593,25682400,5),(593,1143961200,6),(593,1162101600,5),(593,1173596400,6),(593,1194156000,5),(593,1205046000,6),(593,1225605600,5),(593,1236495600,6),(593,1257055200,5),(593,1268550000,6),(593,1289109600,5),(593,1299999600,6),(593,1320559200,5),(593,1331449200,6),(593,1352008800,5),(593,1362898800,6),(593,1383458400,5),(593,1394348400,6),(593,1414908000,5),(593,1425798000,6),(593,1446357600,5),(593,1457852400,6),(593,1478412000,5),(593,1489302000,6),(593,1509861600,5),(593,1520751600,6),(593,1541311200,5),(593,1552201200,6),(593,1572760800,5),(593,1583650800,6),(593,1604210400,5),(593,1615705200,6),(593,1636264800,5),(593,1647154800,6),(593,1667714400,5),(593,1678604400,6),(593,1699164000,5),(593,1710054000,6),(593,1730613600,5),(593,1741503600,6),(593,1762063200,5),(593,1772953200,6),(593,1793512800,5),(593,1805007600,6),(593,1825567200,5),(593,1836457200,6),(593,1857016800,5),(593,1867906800,6),(593,1888466400,5),(593,1899356400,6),(593,1919916000,5),(593,1930806000,6),(593,1951365600,5),(593,1962860400,6),(593,1983420000,5),(593,1994310000,6),(593,2014869600,5),(593,2025759600,6),(593,2046319200,5),(593,2057209200,6),(593,2077768800,5),(593,2088658800,6),(593,2109218400,5),(593,2120108400,6),(593,2140668000,5),(594,-2147483648,2),(594,-1633280400,1),(594,-1615140000,2),(594,-1601830800,1),(594,-1583690400,2),(594,-1570381200,1),(594,-1551636000,2),(594,-1536512400,1),(594,-1523210400,2),(594,-1504458000,1),(594,-1491760800,2),(594,-1473008400,1),(594,-1459706400,2),(594,-1441558800,1),(594,-1428256800,2),(594,-1410109200,1),(594,-1396807200,2),(594,-1378659600,1),(594,-1365357600,2),(594,-1347210000,1),(594,-1333908000,2),(594,-1315155600,1),(594,-1301853600,2),(594,-1283706000,1),(594,-1270404000,2),(594,-1252256400,1),(594,-1238954400,2),(594,-1220806800,1),(594,-1207504800,2),(594,-1189357200,1),(594,-1176055200,2),(594,-1157302800,1),(594,-1144605600,2),(594,-1125853200,1),(594,-1112551200,2),(594,-1094403600,1),(594,-1081101600,2),(594,-1062954000,1),(594,-1049652000,2),(594,-1031504400,1),(594,-1018202400,2),(594,-1000054800,1),(594,-986752800,2),(594,-968000400,1),(594,-955303200,2),(594,-936550800,1),(594,-923248800,2),(594,-905101200,1),(594,-891799200,2),(594,-880218000,3),(594,-769395600,4),(594,-765396000,2),(594,-747248400,1),(594,-733946400,2),(594,-715798800,1),(594,-702496800,2),(594,-684349200,1),(594,-671047200,2),(594,-652899600,1),(594,-639597600,2),(594,-620845200,1),(594,-608148000,2),(594,-589395600,1),(594,-576093600,2),(594,-557946000,1),(594,-544644000,2),(594,-526496400,1),(594,-513194400,2),(594,-495046800,1),(594,-481744800,2),(594,-463597200,1),(594,-447271200,2),(594,-431542800,1),(594,-415821600,2),(594,-400093200,1),(594,-384372000,2),(594,-368643600,1),(594,-352922400,2),(594,-337194000,1),(594,-321472800,2),(594,-305744400,1),(594,-289418400,2),(594,-273690000,1),(594,-257968800,2),(594,-242240400,1),(594,-226519200,2),(594,-210790800,1),(594,-195069600,2),(594,-179341200,1),(594,-163620000,2),(594,-147891600,1),(594,-131565600,2),(594,-116442000,1),(594,-100116000,2),(594,-84387600,1),(594,-68666400,2),(594,-52938000,1),(594,-37216800,2),(594,-21488400,1),(594,-5767200,2),(594,9961200,1),(594,25682400,2),(594,41410800,1),(594,57736800,2),(594,73465200,1),(594,89186400,2),(594,104914800,1),(594,120636000,2),(594,126687600,1),(594,152085600,2),(594,162370800,1),(594,183535200,2),(594,199263600,1),(594,215589600,2),(594,230713200,1),(594,247039200,2),(594,262767600,1),(594,278488800,2),(594,294217200,1),(594,309938400,2),(594,325666800,1),(594,341388000,2),(594,357116400,1),(594,372837600,2),(594,388566000,1),(594,404892000,2),(594,420015600,1),(594,436341600,2),(594,452070000,1),(594,467791200,2),(594,483519600,1),(594,499240800,2),(594,514969200,1),(594,530690400,2),(594,544604400,1),(594,562140000,2),(594,576054000,1),(594,594194400,2),(594,607503600,1),(594,625644000,2),(594,638953200,1),(594,657093600,2),(594,671007600,1),(594,688543200,2),(594,702457200,1),(594,719992800,2),(594,733906800,1),(594,752047200,2),(594,765356400,1),(594,783496800,2),(594,796806000,1),(594,814946400,2),(594,828860400,1),(594,846396000,2),(594,860310000,1),(594,877845600,2),(594,891759600,1),(594,909295200,2),(594,923209200,1),(594,941349600,2),(594,954658800,1),(594,972799200,2),(594,986108400,1),(594,1004248800,2),(594,1018162800,1),(594,1035698400,2),(594,1049612400,1),(594,1067148000,2),(594,1081062000,1),(594,1099202400,2),(594,1112511600,1),(594,1130652000,2),(594,1143961200,1),(594,1162101600,2),(594,1173596400,1),(594,1194156000,2),(594,1205046000,1),(594,1225605600,2),(594,1236495600,1),(594,1257055200,2),(594,1268550000,1),(594,1289109600,2),(594,1299999600,1),(594,1320559200,2),(594,1331449200,1),(594,1352008800,2),(594,1362898800,1),(594,1383458400,2),(594,1394348400,1),(594,1414908000,2),(594,1425798000,1),(594,1446357600,2),(594,1457852400,1),(594,1478412000,2),(594,1489302000,1),(594,1509861600,2),(594,1520751600,1),(594,1541311200,2),(594,1552201200,1),(594,1572760800,2),(594,1583650800,1),(594,1604210400,2),(594,1615705200,1),(594,1636264800,2),(594,1647154800,1),(594,1667714400,2),(594,1678604400,1),(594,1699164000,2),(594,1710054000,1),(594,1730613600,2),(594,1741503600,1),(594,1762063200,2),(594,1772953200,1),(594,1793512800,2),(594,1805007600,1),(594,1825567200,2),(594,1836457200,1),(594,1857016800,2),(594,1867906800,1),(594,1888466400,2),(594,1899356400,1),(594,1919916000,2),(594,1930806000,1),(594,1951365600,2),(594,1962860400,1),(594,1983420000,2),(594,1994310000,1),(594,2014869600,2),(594,2025759600,1),(594,2046319200,2),(594,2057209200,1),(594,2077768800,2),(594,2088658800,1),(594,2109218400,2),(594,2120108400,1),(594,2140668000,2),(595,-2147483648,1),(595,-1157283000,2),(595,-1155436200,1),(595,-880198200,3),(595,-769395600,4),(595,-765376200,1),(595,-712150200,5),(596,-2147483648,2),(596,-1633276800,1),(596,-1615136400,2),(596,-1601827200,1),(596,-1583686800,2),(596,-880214400,3),(596,-769395600,4),(596,-765392400,2),(596,-715795200,1),(596,-702493200,2),(596,-684345600,1),(596,-671043600,2),(596,-652896000,1),(596,-639594000,2),(596,-620841600,1),(596,-608144400,2),(596,-589392000,1),(596,-576090000,2),(596,-557942400,1),(596,-544640400,2),(596,-526492800,1),(596,-513190800,2),(596,-495043200,1),(596,-481741200,2),(596,-463593600,1),(596,-447267600,2),(596,-431539200,1),(596,-415818000,2),(596,-400089600,1),(596,-386787600,2),(596,-368640000,1),(596,-355338000,2),(596,-337190400,1),(596,-321469200,2),(596,-305740800,1),(596,-289414800,2),(596,-273686400,1),(596,-257965200,2),(596,-242236800,5),(596,-195066000,2),(596,-84384000,1),(596,-68662800,2),(596,-52934400,1),(596,-37213200,2),(596,-21484800,1),(596,-5763600,2),(596,9964800,1),(596,25686000,2),(596,41414400,1),(596,57740400,2),(596,73468800,1),(596,89190000,2),(596,104918400,1),(596,120639600,2),(596,126691200,1),(596,152089200,2),(596,162374400,1),(596,183538800,2),(596,199267200,1),(596,215593200,2),(596,230716800,1),(596,247042800,2),(596,262771200,1),(596,278492400,2),(596,294220800,1),(596,309942000,2),(596,325670400,1),(596,341391600,2),(596,357120000,1),(596,372841200,2),(596,388569600,1),(596,404895600,2),(596,420019200,1),(596,436345200,2),(596,452073600,1),(596,467794800,2),(596,483523200,1),(596,499244400,2),(596,514972800,1),(596,530694000,2),(596,544608000,1),(596,562143600,2),(596,576057600,1),(596,594198000,2),(596,607507200,1),(596,625647600,2),(596,638956800,1),(596,657097200,2),(596,671011200,1),(596,688546800,5),(596,1143961200,1),(596,1162105200,2),(596,1173600000,1),(596,1194159600,2),(596,1205049600,1),(596,1225609200,2),(596,1236499200,1),(596,1257058800,2),(596,1268553600,1),(596,1289113200,2),(596,1300003200,1),(596,1320562800,2),(596,1331452800,1),(596,1352012400,2),(596,1362902400,1),(596,1383462000,2),(596,1394352000,1),(596,1414911600,2),(596,1425801600,1),(596,1446361200,2),(596,1457856000,1),(596,1478415600,2),(596,1489305600,1),(596,1509865200,2),(596,1520755200,1),(596,1541314800,2),(596,1552204800,1),(596,1572764400,2),(596,1583654400,1),(596,1604214000,2),(596,1615708800,1),(596,1636268400,2),(596,1647158400,1),(596,1667718000,2),(596,1678608000,1),(596,1699167600,2),(596,1710057600,1),(596,1730617200,2),(596,1741507200,1),(596,1762066800,2),(596,1772956800,1),(596,1793516400,2),(596,1805011200,1),(596,1825570800,2),(596,1836460800,1),(596,1857020400,2),(596,1867910400,1),(596,1888470000,2),(596,1899360000,1),(596,1919919600,2),(596,1930809600,1),(596,1951369200,2),(596,1962864000,1),(596,1983423600,2),(596,1994313600,1),(596,2014873200,2),(596,2025763200,1),(596,2046322800,2),(596,2057212800,1),(596,2077772400,2),(596,2088662400,1),(596,2109222000,2),(596,2120112000,1),(596,2140671600,2),(597,-2147483648,0),(597,-2051202469,1),(597,-1724083200,2),(597,-880218000,3),(597,-769395600,4),(597,-765396000,2),(597,-684349200,5),(597,-671047200,2),(597,104914800,5),(597,120636000,2),(597,126687600,5),(597,152085600,2),(597,167814000,5),(597,183535200,2),(597,199263600,5),(597,215589600,2),(597,230713200,5),(597,247039200,2),(597,262767600,5),(597,278488800,2),(597,294217200,5),(597,309938400,2),(597,325666800,5),(597,341388000,2),(597,357116400,5),(597,372837600,2),(597,388566000,5),(597,404892000,2),(597,420015600,5),(597,436341600,2),(597,452070000,5),(597,467791200,2),(597,483519600,5),(597,499240800,2),(597,514969200,5),(597,530690400,2),(597,544604400,5),(597,562140000,2),(597,576054000,5),(597,594194400,2),(597,607503600,5),(597,625644000,2),(597,638953200,5),(597,657093600,2),(597,671007600,5),(597,688543200,2),(597,702457200,5),(597,719992800,2),(597,733906800,5),(597,752047200,2),(597,765356400,5),(597,783496800,2),(597,796806000,5),(597,814946400,2),(597,828860400,5),(597,846396000,2),(597,860310000,5),(597,877845600,2),(597,891759600,5),(597,909295200,2),(597,923209200,5),(597,941349600,2),(597,954658800,5),(597,972799200,2),(597,986108400,5),(597,1004248800,2),(597,1018162800,5),(597,1035698400,2),(597,1049612400,5),(597,1067148000,2),(597,1081062000,5),(597,1099202400,2),(597,1112511600,5),(597,1130652000,2),(597,1143961200,5),(597,1162101600,2),(597,1173596400,5),(597,1194156000,2),(597,1205046000,5),(597,1225605600,2),(597,1236495600,5),(597,1257055200,2),(597,1268550000,5),(597,1289109600,2),(597,1299999600,5),(597,1320559200,2),(597,1331449200,5),(597,1352008800,2),(597,1362898800,5),(597,1383458400,2),(597,1394348400,5),(597,1414908000,2),(597,1425798000,5),(597,1446357600,2),(597,1457852400,5),(597,1478412000,2),(597,1489302000,5),(597,1509861600,2),(597,1520751600,5),(597,1541311200,2),(597,1552201200,5),(597,1572760800,2),(597,1583650800,5),(597,1604210400,2),(597,1615705200,5),(597,1636264800,2),(597,1647154800,5),(597,1667714400,2),(597,1678604400,5),(597,1699164000,2),(597,1710054000,5),(597,1730613600,2),(597,1741503600,5),(597,1762063200,2),(597,1772953200,5),(597,1793512800,2),(597,1805007600,5),(597,1825567200,2),(597,1836457200,5),(597,1857016800,2),(597,1867906800,5),(597,1888466400,2),(597,1899356400,5),(597,1919916000,2),(597,1930806000,5),(597,1951365600,2),(597,1962860400,5),(597,1983420000,2),(597,1994310000,5),(597,2014869600,2),(597,2025759600,5),(597,2046319200,2),(597,2057209200,5),(597,2077768800,2),(597,2088658800,5),(597,2109218400,2),(597,2120108400,5),(597,2140668000,2),(598,-2147483648,2),(598,-1633273200,1),(598,-1615132800,2),(598,-1601823600,1),(598,-1583683200,2),(598,-1570374000,1),(598,-1551628800,2),(598,-1538924400,1),(598,-1534089600,2),(598,-880210800,3),(598,-769395600,4),(598,-765388800,2),(598,-147884400,1),(598,-131558400,2),(598,-116434800,1),(598,-100108800,2),(598,-84380400,1),(598,-68659200,2),(598,-52930800,1),(598,-37209600,2),(598,-21481200,1),(598,-5760000,2),(598,9968400,1),(598,25689600,2),(598,41418000,1),(598,57744000,2),(598,73472400,1),(598,89193600,2),(598,104922000,1),(598,120643200,2),(598,126694800,1),(598,152092800,2),(598,162378000,1),(598,183542400,2),(598,199270800,1),(598,215596800,2),(598,230720400,1),(598,247046400,2),(598,262774800,1),(598,278496000,2),(598,294224400,1),(598,309945600,2),(598,325674000,1),(598,341395200,2),(598,357123600,1),(598,372844800,2),(598,388573200,1),(598,404899200,2),(598,420022800,1),(598,436348800,2),(598,452077200,1),(598,467798400,2),(598,483526800,1),(598,499248000,2),(598,514976400,1),(598,530697600,2),(598,544611600,1),(598,562147200,2),(598,576061200,1),(598,594201600,2),(598,607510800,1),(598,625651200,2),(598,638960400,1),(598,657100800,2),(598,671014800,1),(598,688550400,2),(598,702464400,1),(598,720000000,2),(598,733914000,1),(598,752054400,2),(598,765363600,1),(598,783504000,2),(598,796813200,1),(598,814953600,2),(598,828867600,1),(598,846403200,2),(598,860317200,1),(598,877852800,2),(598,891766800,1),(598,909302400,2),(598,923216400,1),(598,941356800,2),(598,954666000,1),(598,972806400,2),(598,986115600,1),(598,1004256000,2),(598,1018170000,1),(598,1035705600,2),(598,1049619600,1),(598,1067155200,2),(598,1081069200,1),(598,1099209600,2),(598,1112518800,1),(598,1130659200,2),(598,1143968400,1),(598,1162108800,2),(598,1173603600,1),(598,1194163200,2),(598,1205053200,1),(598,1225612800,2),(598,1236502800,1),(598,1257062400,2),(598,1268557200,1),(598,1289116800,2),(598,1300006800,1),(598,1320566400,2),(598,1331456400,1),(598,1352016000,2),(598,1362906000,1),(598,1383465600,2),(598,1394355600,1),(598,1414915200,2),(598,1425805200,1),(598,1446364800,2),(598,1457859600,1),(598,1478419200,2),(598,1489309200,1),(598,1509868800,2),(598,1520758800,1),(598,1541318400,2),(598,1552208400,1),(598,1572768000,2),(598,1583658000,1),(598,1604217600,2),(598,1615712400,1),(598,1636272000,2),(598,1647162000,1),(598,1667721600,2),(598,1678611600,1),(598,1699171200,2),(598,1710061200,1),(598,1730620800,2),(598,1741510800,1),(598,1762070400,2),(598,1772960400,1),(598,1793520000,2),(598,1805014800,1),(598,1825574400,2),(598,1836464400,1),(598,1857024000,2),(598,1867914000,1),(598,1888473600,2),(598,1899363600,1),(598,1919923200,2),(598,1930813200,1),(598,1951372800,2),(598,1962867600,1),(598,1983427200,2),(598,1994317200,1),(598,2014876800,2),(598,2025766800,1),(598,2046326400,2),(598,2057216400,1),(598,2077776000,2),(598,2088666000,1),(598,2109225600,2),(598,2120115600,1),(598,2140675200,2),(599,-2147483648,2),(599,-1633269600,1),(599,-1615129200,2),(599,-1601820000,1),(599,-1583679600,2),(599,-880207200,3),(599,-769395600,4),(599,-765385200,2),(599,-687967140,1),(599,-662655600,2),(599,-620838000,1),(599,-608137200,2),(599,-589388400,1),(599,-576082800,2),(599,-557938800,1),(599,-544633200,2),(599,-526489200,1),(599,-513183600,2),(599,-495039600,1),(599,-481734000,2),(599,-463590000,1),(599,-450284400,2),(599,-431535600,1),(599,-418230000,2),(599,-400086000,1),(599,-386780400,2),(599,-368636400,1),(599,-355330800,2),(599,-337186800,1),(599,-323881200,2),(599,-305737200,1),(599,-292431600,2),(599,-273682800,1),(599,-260982000,2),(599,-242233200,1),(599,-226508400,2),(599,-210783600,1),(599,-195058800,2),(599,-179334000,1),(599,-163609200,2),(599,-147884400,1),(599,-131554800,2),(599,-116434800,1),(599,-100105200,2),(599,-84376800,1),(599,-68655600,2),(599,-52927200,1),(599,-37206000,2),(599,-21477600,1),(599,-5756400,2),(599,9972000,1),(599,25693200,2),(599,41421600,1),(599,57747600,2),(599,73476000,1),(599,89197200,2),(599,104925600,1),(599,120646800,2),(599,126698400,1),(599,152096400,2),(599,162381600,1),(599,183546000,2),(599,199274400,1),(599,215600400,2),(599,230724000,1),(599,247050000,2),(599,262778400,1),(599,278499600,2),(599,294228000,1),(599,309949200,2),(599,325677600,1),(599,341398800,2),(599,357127200,1),(599,372848400,2),(599,388576800,1),(599,404902800,2),(599,420026400,1),(599,436352400,2),(599,452080800,1),(599,467802000,2),(599,483530400,1),(599,499251600,2),(599,514980000,1),(599,530701200,2),(599,544615200,1),(599,562150800,2),(599,576064800,1),(599,594205200,2),(599,607514400,1),(599,625654800,2),(599,638964000,1),(599,657104400,2),(599,671018400,1),(599,688554000,2),(599,702468000,1),(599,720003600,2),(599,733917600,1),(599,752058000,2),(599,765367200,1),(599,783507600,2),(599,796816800,1),(599,814957200,2),(599,828871200,1),(599,846406800,2),(599,860320800,1),(599,877856400,2),(599,891770400,1),(599,909306000,2),(599,923220000,1),(599,941360400,2),(599,954669600,1),(599,972810000,2),(599,986119200,1),(599,1004259600,2),(599,1018173600,1),(599,1035709200,2),(599,1049623200,1),(599,1067158800,2),(599,1081072800,1),(599,1099213200,2),(599,1112522400,1),(599,1130662800,2),(599,1143972000,1),(599,1162112400,2),(599,1173607200,1),(599,1194166800,2),(599,1205056800,1),(599,1225616400,2),(599,1236506400,1),(599,1257066000,2),(599,1268560800,1),(599,1289120400,2),(599,1300010400,1),(599,1320570000,2),(599,1331460000,1),(599,1352019600,2),(599,1362909600,1),(599,1383469200,2),(599,1394359200,1),(599,1414918800,2),(599,1425808800,1),(599,1446368400,2),(599,1457863200,1),(599,1478422800,2),(599,1489312800,1),(599,1509872400,2),(599,1520762400,1),(599,1541322000,2),(599,1552212000,1),(599,1572771600,2),(599,1583661600,1),(599,1604221200,2),(599,1615716000,1),(599,1636275600,2),(599,1647165600,1),(599,1667725200,2),(599,1678615200,1),(599,1699174800,2),(599,1710064800,1),(599,1730624400,2),(599,1741514400,1),(599,1762074000,2),(599,1772964000,1),(599,1793523600,2),(599,1805018400,1),(599,1825578000,2),(599,1836468000,1),(599,1857027600,2),(599,1867917600,1),(599,1888477200,2),(599,1899367200,1),(599,1919926800,2),(599,1930816800,1),(599,1951376400,2),(599,1962871200,1),(599,1983430800,2),(599,1994320800,1),(599,2014880400,2),(599,2025770400,1),(599,2046330000,2),(599,2057220000,1),(599,2077779600,2),(599,2088669600,1),(599,2109229200,2),(599,2120119200,1),(599,2140678800,2),(600,-2147483648,2),(600,-1633269600,1),(600,-1615129200,2),(600,-1601820000,1),(600,-1583679600,2),(600,-880207200,3),(600,-769395600,4),(600,-765385200,2),(600,-687967140,1),(600,-662655600,2),(600,-620838000,1),(600,-608137200,2),(600,-589388400,1),(600,-576082800,2),(600,-557938800,1),(600,-544633200,2),(600,-526489200,1),(600,-513183600,2),(600,-495039600,1),(600,-481734000,2),(600,-463590000,1),(600,-450284400,2),(600,-431535600,1),(600,-418230000,2),(600,-400086000,1),(600,-386780400,2),(600,-368636400,1),(600,-355330800,2),(600,-337186800,1),(600,-323881200,2),(600,-305737200,1),(600,-292431600,2),(600,-273682800,1),(600,-260982000,2),(600,-242233200,1),(600,-226508400,2),(600,-210783600,1),(600,-195058800,2),(600,-179334000,1),(600,-163609200,2),(600,-147884400,1),(600,-131554800,2),(600,-116434800,1),(600,-100105200,2),(600,-84376800,1),(600,-68655600,2),(600,-52927200,1),(600,-37206000,2),(600,-21477600,1),(600,-5756400,2),(600,9972000,1),(600,25693200,2),(600,41421600,1),(600,57747600,2),(600,73476000,1),(600,89197200,2),(600,104925600,1),(600,120646800,2),(600,126698400,1),(600,152096400,2),(600,162381600,1),(600,183546000,2),(600,199274400,1),(600,215600400,2),(600,230724000,1),(600,247050000,2),(600,262778400,1),(600,278499600,2),(600,294228000,1),(600,309949200,2),(600,325677600,1),(600,341398800,2),(600,357127200,1),(600,372848400,2),(600,388576800,1),(600,404902800,2),(600,420026400,1),(600,436352400,2),(600,452080800,1),(600,467802000,2),(600,483530400,1),(600,499251600,2),(600,514980000,1),(600,530701200,2),(600,544615200,1),(600,562150800,2),(600,576064800,1),(600,594205200,2),(600,607514400,1),(600,625654800,2),(600,638964000,1),(600,657104400,2),(600,671018400,1),(600,688554000,2),(600,702468000,1),(600,720003600,2),(600,733917600,1),(600,752058000,2),(600,765367200,1),(600,783507600,2),(600,796816800,1),(600,814957200,2),(600,828871200,1),(600,846406800,2),(600,860320800,1),(600,877856400,2),(600,891770400,1),(600,909306000,2),(600,923220000,1),(600,941360400,2),(600,954669600,1),(600,972810000,2),(600,986119200,1),(600,1004259600,2),(600,1018173600,1),(600,1035709200,2),(600,1049623200,1),(600,1067158800,2),(600,1081072800,1),(600,1099213200,2),(600,1112522400,1),(600,1130662800,2),(600,1143972000,1),(600,1162112400,2),(600,1173607200,1),(600,1194166800,2),(600,1205056800,1),(600,1225616400,2),(600,1236506400,1),(600,1257066000,2),(600,1268560800,1),(600,1289120400,2),(600,1300010400,1),(600,1320570000,2),(600,1331460000,1),(600,1352019600,2),(600,1362909600,1),(600,1383469200,2),(600,1394359200,1),(600,1414918800,2),(600,1425808800,1),(600,1446368400,2),(600,1457863200,1),(600,1478422800,2),(600,1489312800,1),(600,1509872400,2),(600,1520762400,1),(600,1541322000,2),(600,1552212000,1),(600,1572771600,2),(600,1583661600,1),(600,1604221200,2),(600,1615716000,1),(600,1636275600,2),(600,1647165600,1),(600,1667725200,2),(600,1678615200,1),(600,1699174800,2),(600,1710064800,1),(600,1730624400,2),(600,1741514400,1),(600,1762074000,2),(600,1772964000,1),(600,1793523600,2),(600,1805018400,1),(600,1825578000,2),(600,1836468000,1),(600,1857027600,2),(600,1867917600,1),(600,1888477200,2),(600,1899367200,1),(600,1919926800,2),(600,1930816800,1),(600,1951376400,2),(600,1962871200,1),(600,1983430800,2),(600,1994320800,1),(600,2014880400,2),(600,2025770400,1),(600,2046330000,2),(600,2057220000,1),(600,2077779600,2),(600,2088669600,1),(600,2109229200,2),(600,2120119200,1),(600,2140678800,2),(601,-2147483648,1),(601,-1861879032,2),(604,-2147483648,1),(604,-1688265017,3),(604,-1656819079,2),(604,-1641353479,3),(604,-1627965079,4),(604,-1618716679,2),(604,-1596429079,4),(604,-1593820800,5),(604,-1589860800,6),(604,-1542427200,7),(604,-1539493200,8),(604,-1525323600,7),(604,-1522728000,6),(604,-1491188400,9),(604,-1247536800,6),(604,354920400,7),(604,370728000,6),(604,386456400,7),(604,402264000,6),(604,417992400,7),(604,433800000,6),(604,449614800,7),(604,465346800,10),(604,481071600,11),(604,496796400,10),(604,512521200,11),(604,528246000,10),(604,543970800,11),(604,559695600,10),(604,575420400,11),(604,591145200,10),(604,606870000,11),(604,622594800,10),(604,638319600,11),(604,654649200,10),(604,670374000,12),(604,686102400,13),(604,695779200,10),(604,701823600,11),(604,717548400,10),(604,733273200,11),(604,748998000,10),(604,764722800,11),(604,780447600,10),(604,796172400,11),(604,811897200,10),(604,828226800,11),(604,846370800,10),(604,859676400,11),(604,877820400,10),(604,891126000,11),(604,909270000,10),(604,922575600,11),(604,941324400,10),(604,954025200,11),(604,972774000,10),(604,985474800,11),(604,1004223600,10),(604,1017529200,11),(604,1035673200,10),(604,1048978800,11),(604,1067122800,10),(604,1080428400,11),(604,1099177200,10),(604,1111878000,11),(604,1130626800,10),(604,1143327600,11),(604,1162076400,10),(604,1174777200,11),(604,1193526000,10),(604,1206831600,11),(604,1224975600,10),(604,1238281200,11),(604,1256425200,10),(604,1269730800,11),(604,1288479600,10),(604,1301180400,14),(604,1414274400,10),(605,228877200,0),(605,243997200,1),(605,260326800,0),(605,276051600,1),(605,291776400,0),(605,307501200,1),(605,323830800,0),(605,338950800,1),(605,354675600,0),(605,370400400,1),(605,386125200,0),(605,401850000,1),(605,417574800,0),(605,433299600,1),(605,449024400,0),(605,465354000,1),(605,481078800,0),(605,496803600,1),(605,512528400,0),(605,528253200,1),(605,543978000,0),(605,559702800,1),(605,575427600,0),(605,591152400,1),(605,606877200,0),(605,622602000,1),(605,638326800,0),(605,654656400,1),(605,670381200,0),(605,686106000,1),(605,701830800,0),(605,717555600,1),(605,733280400,0),(605,749005200,1),(605,764730000,0),(605,780454800,1),(605,796179600,0),(605,811904400,1),(605,828234000,0),(605,846378000,1),(605,859683600,0),(605,877827600,1),(605,891133200,0),(605,909277200,1),(605,922582800,0),(605,941331600,1),(605,954032400,0),(605,972781200,1),(605,985482000,0),(605,1004230800,1),(605,1017536400,0),(605,1035680400,1),(605,1048986000,0),(605,1067130000,1),(605,1080435600,0),(605,1099184400,1),(605,1111885200,0),(605,1130634000,1),(605,1143334800,0),(605,1162083600,1),(605,1174784400,0),(605,1193533200,1),(605,1206838800,0),(605,1224982800,1),(605,1238288400,0),(605,1256432400,1),(605,1269738000,0),(605,1288486800,1),(605,1301187600,0),(605,1319936400,1),(605,1332637200,0),(605,1351386000,1),(605,1364691600,0),(605,1382835600,1),(605,1396141200,0),(605,1414285200,1),(605,1427590800,0),(605,1445734800,1),(605,1459040400,0),(605,1477789200,1),(605,1490490000,0),(605,1509238800,1),(605,1521939600,0),(605,1540688400,1),(605,1553994000,0),(605,1572138000,1),(605,1585443600,0),(605,1603587600,1),(605,1616893200,0),(605,1635642000,1),(605,1648342800,0),(605,1667091600,1),(605,1679792400,0),(605,1698541200,1),(605,1711846800,0),(605,1729990800,1),(605,1743296400,0),(605,1761440400,1),(605,1774746000,0),(605,1792890000,1),(605,1806195600,0),(605,1824944400,1),(605,1837645200,0),(605,1856394000,1),(605,1869094800,0),(605,1887843600,1),(605,1901149200,0),(605,1919293200,1),(605,1932598800,0),(605,1950742800,1),(605,1964048400,0),(605,1982797200,1),(605,1995498000,0),(605,2014246800,1),(605,2026947600,0),(605,2045696400,1),(605,2058397200,0),(605,2077146000,1),(605,2090451600,0),(605,2108595600,1),(605,2121901200,0),(605,2140045200,1),(608,-2147483648,0),(608,-1830383032,1),(609,-2147483648,0),(609,-1640995148,2),(609,-1556841600,1),(609,-1546388400,2),(609,-1525305600,1),(609,-1514852400,2),(609,-1493769600,1),(609,-1483316400,2),(609,-1462233600,1),(609,-1451780400,2),(609,-1430611200,1),(609,-1420158000,2),(609,-1399075200,1),(609,-1388622000,2),(609,-1367539200,1),(609,-1357086000,2),(609,-1336003200,1),(609,-1325550000,2),(609,-1304380800,1),(609,-1293927600,2),(609,-1272844800,1),(609,-1262391600,2),(609,-1241308800,1),(609,-1230855600,2),(609,-1209772800,1),(609,-1199319600,2),(609,-1178150400,1),(609,-1167697200,2),(609,-1146614400,1),(609,-1136161200,2),(609,-1115078400,1),(609,-1104625200,2),(609,-1083542400,1),(609,-1073089200,2),(609,-1051920000,1),(609,-1041466800,2),(609,-1020384000,1),(609,-1009930800,2),(609,-988848000,1),(609,-978394800,2),(609,-957312000,1),(609,-946858800,2),(609,-925689600,1),(609,-915236400,2),(609,-894153600,1),(609,-883700400,2),(609,-862617600,1),(609,-852164400,2),(610,-2147483648,0),(610,-1309746436,1),(610,-1262314800,2),(610,-946780200,3),(610,-315629100,1),(611,-2147483648,1),(611,-1855958961,4),(611,-1689814800,2),(611,-1680397200,3),(611,-1665363600,2),(611,-1648342800,3),(611,-1635123600,2),(611,-1616893200,3),(611,-1604278800,2),(611,-1585443600,3),(611,-1574038800,2),(611,-1552266000,3),(611,-1539997200,2),(611,-1531443600,3),(611,-956365200,2),(611,-950486400,4),(611,-942012000,6),(611,-812502000,5),(611,-796262400,6),(611,-781052400,5),(611,-766630800,6),(611,-733280400,4),(611,-439430400,6),(611,-212029200,4),(611,41468400,2),(611,54774000,3),(611,231724800,7),(611,246236400,6),(611,259545600,5),(611,275274000,6),(611,309740400,4),(611,325468800,7),(611,341802000,4),(611,357523200,6),(612,-2147483648,0),(612,-1309746436,1),(612,-1262314800,2),(612,-946780200,3),(612,-315629100,1),(613,-2147483648,0),(613,-1309746436,1),(613,-1262314800,2),(613,-946780200,3),(613,-315629100,1),(614,-2147483648,0),(614,-1830383032,1),(615,-2147483648,0),(615,-1588464816,1),(616,-2147483648,0),(616,-1830383032,1),(617,-2147483648,0),(617,-1830380400,1),(617,157770000,2),(618,-2147483648,0),(618,-2109291020,1),(619,-2147483648,0),(619,-1588464816,1),(620,-2147483648,0),(620,-2109291020,1),(621,-2147483648,2),(621,-929844000,1),(621,-923108400,2),(621,-906170400,1),(621,-892868400,2),(621,-875844000,1),(621,-857790000,2),(621,-844308000,1),(621,-825822000,2),(621,-812685600,1),(621,-794199600,2),(621,-779853600,1),(621,-762663600,2),(621,-399088800,1),(621,-386650800,2),(621,-368330400,1),(621,-355114800,2),(621,-336790800,1),(621,-323654400,2),(621,-305168400,1),(621,-292032000,2),(621,-273632400,1),(621,-260496000,2),(621,-242096400,1),(621,-228960000,2),(621,-210560400,1),(621,-197424000,2),(621,-178938000,1),(621,-165801600,2),(621,-147402000,1),(621,-134265600,2),(621,-115866000,1),(621,-102643200,2),(621,-84330000,1),(621,-71107200,2),(621,-52707600,1),(621,-39484800,2),(621,-21171600,1),(621,-7948800,2),(621,10364400,1),(621,23587200,2),(621,41900400,1),(621,55123200,2),(621,73522800,1),(621,86745600,2),(621,105058800,1),(621,118281600,2),(621,136594800,1),(621,149817600,2),(621,168130800,1),(621,181353600,2),(621,199753200,1),(621,212976000,2),(621,231289200,1),(621,244512000,2),(621,262825200,1),(621,276048000,2),(621,294361200,1),(621,307584000,2),(621,325983600,1),(621,339206400,2),(621,357519600,1),(621,370742400,2),(621,396399600,1),(621,402278400,2),(621,426812400,1),(621,433814400,2),(621,452214000,1),(621,465436800,2),(621,483750000,1),(621,496972800,2),(621,515286000,1),(621,528508800,2),(621,546822000,1),(621,560044800,2),(621,578444400,1),(621,591667200,2),(621,610412400,1),(621,623203200,2),(621,641516400,1),(621,654739200,2),(621,673052400,1),(621,686275200,2),(621,704674800,1),(621,717897600,2),(621,736210800,1),(621,749433600,2),(621,767746800,1),(621,780969600,2),(621,799020000,3),(621,812322000,2),(621,830469600,3),(621,843771600,2),(621,861919200,3),(621,875221200,2),(621,893368800,3),(621,906670800,2),(621,925423200,3),(621,938725200,2),(621,956872800,3),(621,970174800,2),(621,988322400,3),(621,1001624400,2),(621,1019772000,3),(621,1033074000,2),(621,1051221600,3),(621,1064523600,2),(621,1083276000,3),(621,1096578000,2),(621,1114725600,3),(621,1128027600,2),(621,1146175200,3),(621,1158872400,2),(621,1177624800,3),(621,1189112400,2),(621,1209074400,3),(621,1219957200,2),(621,1240524000,3),(621,1250802000,2),(621,1272578400,3),(621,1281474000,2),(621,1284069600,1),(621,1285880400,2),(621,1400191200,1),(621,1403816400,2),(621,1406844000,1),(621,1411678800,2),(622,-2147483648,0),(622,-1773012580,2),(622,-956361600,1),(622,-950490000,2),(622,-942019200,1),(622,-761187600,2),(622,-617241600,1),(622,-605149200,2),(622,-81432000,1),(622,-71110800,2),(622,141264000,1),(622,147222000,2),(622,199756800,1),(622,207702000,2),(622,231292800,1),(622,244249200,2),(622,265507200,1),(622,271033200,2),(622,448243200,3),(622,504918000,2),(622,1212278400,1),(622,1220223600,2),(622,1243814400,1),(622,1250809200,2),(622,1272758400,1),(622,1281222000,2),(622,1301788800,1),(622,1312066800,2),(622,1335664800,1),(622,1342749600,2),(622,1345428000,1),(622,1348970400,2),(622,1367114400,1),(622,1373162400,2),(622,1376100000,1),(622,1382839200,2),(622,1396144800,1),(622,1403920800,2),(622,1406944800,1),(622,1414288800,2),(622,1427594400,1),(622,1434247200,2),(622,1437271200,1),(622,1445738400,2),(622,1459044000,1),(622,1465092000,2),(622,1468116000,1),(622,1477792800,2),(622,1490493600,1),(622,1495332000,2),(622,1498960800,1),(622,1509242400,2),(622,1521943200,1),(622,1526176800,2),(622,1529200800,1),(622,1540692000,3),(622,1557021600,4),(622,1560045600,3),(622,1587261600,4),(622,1590285600,3),(622,1618106400,4),(622,1621130400,3),(622,1648346400,4),(622,1651975200,3),(622,1679191200,4),(622,1682215200,3),(622,1710036000,4),(622,1713060000,3),(622,1740276000,4),(622,1743904800,3),(622,1771120800,4),(622,1774144800,3),(622,1801965600,4),(622,1804989600,3),(622,1832205600,4),(622,1835229600,3),(622,1863050400,4),(622,1866074400,3),(622,1893290400,4),(622,1896919200,3),(622,1924135200,4),(622,1927159200,3),(622,1954980000,4),(622,1958004000,3),(622,1985220000,4),(622,1988848800,3),(622,2016064800,4),(622,2019088800,3),(622,2046304800,4),(622,2049933600,3),(622,2077149600,4),(622,2080173600,3),(622,2107994400,4),(622,2111018400,3),(622,2138234400,4),(622,2141863200,3),(623,-2147483648,1),(623,-1630112400,2),(623,-1616810400,1),(623,-1442451600,2),(623,-1427673600,3),(623,-1379293200,2),(623,-1364774400,3),(623,-1348448400,2),(623,-1333324800,3),(623,-1316390400,2),(623,-1301270400,3),(623,-1293840000,1),(623,-81432000,2),(623,-71110800,1),(623,141264000,2),(623,147222000,1),(623,199756800,2),(623,207702000,1),(623,231292800,2),(623,244249200,1),(623,265507200,2),(623,271033200,1),(623,448243200,4),(623,512528400,5),(623,528253200,6),(623,543978000,5),(623,559702800,6),(623,575427600,5),(623,591152400,6),(623,606877200,5),(623,622602000,6),(623,638326800,5),(623,654656400,6),(623,670381200,5),(623,686106000,6),(623,701830800,5),(623,717555600,6),(623,733280400,5),(623,749005200,6),(623,764730000,5),(623,780454800,6),(623,796179600,5),(623,811904400,6),(623,828234000,5),(623,846378000,6),(623,859683600,5),(623,877827600,6),(623,891133200,5),(623,909277200,6),(623,922582800,5),(623,941331600,6),(623,954032400,5),(623,972781200,6),(623,985482000,5),(623,1004230800,6),(623,1017536400,5),(623,1035680400,6),(623,1048986000,5),(623,1067130000,6),(623,1080435600,5),(623,1099184400,6),(623,1111885200,5),(623,1130634000,6),(623,1143334800,5),(623,1162083600,6),(623,1174784400,5),(623,1193533200,6),(623,1206838800,5),(623,1224982800,6),(623,1238288400,5),(623,1256432400,6),(623,1269738000,5),(623,1288486800,6),(623,1301187600,5),(623,1319936400,6),(623,1332637200,5),(623,1351386000,6),(623,1364691600,5),(623,1382835600,6),(623,1396141200,5),(623,1414285200,6),(623,1427590800,5),(623,1445734800,6),(623,1459040400,5),(623,1477789200,6),(623,1490490000,5),(623,1509238800,6),(623,1521939600,5),(623,1540688400,6),(623,1553994000,5),(623,1572138000,6),(623,1585443600,5),(623,1603587600,6),(623,1616893200,5),(623,1635642000,6),(623,1648342800,5),(623,1667091600,6),(623,1679792400,5),(623,1698541200,6),(623,1711846800,5),(623,1729990800,6),(623,1743296400,5),(623,1761440400,6),(623,1774746000,5),(623,1792890000,6),(623,1806195600,5),(623,1824944400,6),(623,1837645200,5),(623,1856394000,6),(623,1869094800,5),(623,1887843600,6),(623,1901149200,5),(623,1919293200,6),(623,1932598800,5),(623,1950742800,6),(623,1964048400,5),(623,1982797200,6),(623,1995498000,5),(623,2014246800,6),(623,2026947600,5),(623,2045696400,6),(623,2058397200,5),(623,2077146000,6),(623,2090451600,5),(623,2108595600,6),(623,2121901200,5),(623,2140045200,6),(624,-2147483648,0),(624,-1830383032,1),(625,-2147483648,0),(625,-1830383032,1),(626,-2147483648,0),(626,-1309746436,1),(626,-1262314800,2),(626,-946780200,3),(626,-315629100,1),(627,-2147483648,0),(627,-1309746436,1),(627,-1262314800,2),(627,-946780200,3),(627,-315629100,1),(628,-2147483648,0),(628,-1588464816,1),(629,-2147483648,0),(629,-1136070432,1),(629,198291600,3),(629,199756800,2),(629,207702000,3),(629,231292800,2),(629,244249200,3),(629,265507200,2),(629,271033200,3),(629,1212278400,2),(629,1220223600,3),(629,1243814400,2),(629,1250809200,3),(629,1272758400,2),(629,1281222000,3),(629,1301788800,2),(629,1312066800,3),(629,1335664800,2),(629,1342749600,3),(629,1345428000,2),(629,1348970400,3),(629,1367114400,2),(629,1373162400,3),(629,1376100000,2),(629,1382839200,3),(629,1396144800,2),(629,1403920800,3),(629,1406944800,2),(629,1414288800,3),(629,1427594400,2),(629,1434247200,3),(629,1437271200,2),(629,1445738400,3),(629,1459044000,2),(629,1465092000,3),(629,1468116000,2),(629,1477792800,3),(629,1490493600,2),(629,1495332000,3),(629,1498960800,2),(629,1509242400,3),(629,1521943200,2),(629,1526176800,3),(629,1529200800,2),(629,1540692000,5),(629,1557021600,4),(629,1560045600,5),(629,1587261600,4),(629,1590285600,5),(629,1618106400,4),(629,1621130400,5),(629,1648346400,4),(629,1651975200,5),(629,1679191200,4),(629,1682215200,5),(629,1710036000,4),(629,1713060000,5),(629,1740276000,4),(629,1743904800,5),(629,1771120800,4),(629,1774144800,5),(629,1801965600,4),(629,1804989600,5),(629,1832205600,4),(629,1835229600,5),(629,1863050400,4),(629,1866074400,5),(629,1893290400,4),(629,1896919200,5),(629,1924135200,4),(629,1927159200,5),(629,1954980000,4),(629,1958004000,5),(629,1985220000,4),(629,1988848800,5),(629,2016064800,4),(629,2019088800,5),(629,2046304800,4),(629,2049933600,5),(629,2077149600,4),(629,2080173600,5),(629,2107994400,4),(629,2111018400,5),(629,2138234400,4),(629,2141863200,5),(630,-2147483648,0),(630,-1830383032,1),(631,-2147483648,0),(631,-2109291020,1),(632,-2147483648,0),(632,-2109291020,1),(633,-2147483648,1),(633,-2109288600,3),(633,-860976000,2),(633,-845254800,3),(633,-829526400,2),(633,-813805200,3),(634,-2147483648,0),(634,-1230775588,2),(634,10360800,1),(634,24786000,2),(634,41810400,1),(634,56322000,2),(634,73432800,1),(634,87944400,2),(634,104882400,1),(634,119480400,2),(634,136332000,1),(634,151016400,2),(634,167781600,1),(634,182552400,2),(634,199231200,1),(634,214174800,2),(634,230680800,1),(634,245710800,2),(634,262735200,1),(634,277246800,2),(634,294184800,1),(634,308782800,2),(634,325634400,1),(634,340405200,2),(634,357084000,1),(634,371941200,2),(634,388533600,1),(634,403477200,2),(634,419983200,1),(634,435013200,2),(634,452037600,1),(634,466635600,2),(634,483487200,1),(634,498171600,2),(634,947930400,3),(635,-2147483648,0),(635,-1309746436,1),(635,-1262314800,2),(635,-946780200,3),(635,-315629100,1),(636,-2147483648,0),(636,-1230775808,2),(636,10360800,1),(636,24786000,2),(636,41810400,1),(636,56322000,2),(636,73432800,1),(636,87944400,2),(636,104882400,1),(636,119480400,2),(636,136332000,1),(636,151016400,2),(636,167781600,1),(636,182552400,2),(636,199231200,1),(636,214174800,2),(636,230680800,1),(636,245710800,2),(636,262735200,1),(636,277246800,2),(636,294184800,1),(636,308782800,2),(636,325634400,1),(636,340405200,2),(636,357084000,1),(636,371941200,2),(636,388533600,1),(636,403477200,2),(636,419983200,1),(636,435013200,2),(636,452037600,1),(636,466635600,2),(636,483487200,1),(636,498171600,2),(636,947930400,3),(636,1509483600,2),(637,-2147483648,0),(637,-2109291020,1),(638,-2147483648,0),(638,-1588464816,1),(639,-2147483648,0),(639,-1588464816,1),(640,-2147483648,0),(640,-1588464816,1),(641,-2147483648,0),(641,-1830383032,1),(642,-2147483648,0),(642,-1588464816,1),(643,-2147483648,0),(643,-2109291020,1),(644,-2147483648,0),(644,-2109291020,1),(645,-2147483648,0),(645,-1588464816,1),(646,-2147483648,0),(646,-2109291020,1),(647,-2147483648,1),(647,-2109288600,3),(647,-860976000,2),(647,-845254800,3),(647,-829526400,2),(647,-813805200,3),(648,-2147483648,1),(648,-2109288600,3),(648,-860976000,2),(648,-845254800,3),(648,-829526400,2),(648,-813805200,3),(649,-2147483648,0),(649,-1309746436,1),(649,-1262314800,2),(649,-946780200,3),(649,-315629100,1),(650,-2147483648,1),(650,-1604359012,2),(650,63593070,3),(651,-2147483648,0),(651,-1309746436,1),(651,-1262314800,2),(651,-946780200,3),(651,-315629100,1),(652,-2147483648,0),(652,-1830387612,1),(652,308703600,2),(652,321314400,1),(653,-2147483648,0),(653,-1588464816,1),(654,-2147483648,0),(654,-1830383032,1),(655,-2147483648,0),(655,-1830383032,1),(656,-2147483648,0),(656,-1588464816,1),(657,-2147483648,1),(657,-1830384000,2),(657,1514768400,3),(657,1546304400,4),(658,-2147483648,0),(658,-1830383032,1),(659,-2147483648,0),(659,-1577926364,2),(659,-574902000,1),(659,-568087200,2),(659,-512175600,1),(659,-504928800,2),(659,-449888400,1),(659,-441856800,2),(659,-347158800,3),(659,378684000,2),(659,386463600,1),(659,402271200,2),(659,417999600,1),(659,433807200,2),(659,449622000,1),(659,465429600,2),(659,481590000,1),(659,496965600,2),(659,512953200,1),(659,528674400,2),(659,544230000,1),(659,560037600,2),(659,575852400,1),(659,591660000,2),(659,607388400,1),(659,623196000,2),(659,641775600,3),(659,844034400,2),(659,860108400,1),(659,875916000,3),(659,1352505600,2),(659,1364515200,1),(659,1382659200,3),(660,-2147483648,1),(660,-1855958961,4),(660,-969242400,2),(660,-950493600,3),(660,-941940000,2),(660,-891136800,4),(660,-877827600,5),(660,-857257200,4),(660,-844556400,5),(660,-842918400,4),(660,-842223600,5),(660,-828230400,4),(660,-812502000,5),(660,-796269600,4),(660,-781052400,5),(660,-766634400,4),(660,231202800,2),(660,243903600,3),(660,262825200,2),(660,276044400,3),(660,581122800,2),(660,591145200,3),(660,606870000,2),(660,622594800,3),(660,641516400,2),(660,654649200,3),(660,1114902000,2),(660,1128038400,3),(660,1143334800,2),(660,1162083600,3),(660,1174784400,2),(660,1193533200,3),(660,1206838800,2),(660,1224982800,3),(661,-2147483648,1),(661,-2109288600,2),(661,-860976000,3),(661,-845254800,2),(661,637970400,5),(661,764200800,4),(661,778640400,5),(661,796780800,4),(661,810090000,5),(661,828835200,4),(661,841539600,5),(661,860284800,4),(661,873594000,5),(661,891734400,4),(661,905043600,5),(661,923184000,4),(661,936493200,5),(661,954633600,4),(661,967942800,5),(661,986083200,4),(661,999392400,5),(661,1018137600,4),(661,1030842000,5),(661,1049587200,4),(661,1062896400,5),(661,1081036800,4),(661,1094346000,5),(661,1112486400,4),(661,1125795600,5),(661,1143936000,4),(661,1157245200,5),(661,1175385600,4),(661,1188694800,5),(661,1207440000,4),(661,1220749200,5),(661,1238889600,4),(661,1252198800,5),(661,1270339200,4),(661,1283648400,5),(661,1301788800,4),(661,1315098000,5),(661,1333238400,4),(661,1346547600,5),(661,1365292800,4),(661,1377997200,5),(661,1396742400,4),(661,1410051600,5),(661,1428192000,4),(661,1441501200,5),(661,1459641600,4),(661,1472950800,5),(661,1491091200,4),(661,1504400400,5),(662,-2147483648,1),(662,-880196400,2),(662,-769395600,3),(662,-765374400,1),(662,-86878800,4),(662,-21466800,5),(662,-5745600,4),(662,9982800,5),(662,25704000,4),(662,41432400,5),(662,57758400,4),(662,73486800,5),(662,89208000,4),(662,104936400,5),(662,120657600,4),(662,126709200,5),(662,152107200,4),(662,162392400,5),(662,183556800,4),(662,199285200,5),(662,215611200,4),(662,230734800,5),(662,247060800,4),(662,262789200,5),(662,278510400,4),(662,294238800,5),(662,309960000,4),(662,325688400,5),(662,341409600,4),(662,357138000,5),(662,372859200,4),(662,388587600,5),(662,404913600,4),(662,420037200,5),(662,436363200,6),(662,439034400,8),(662,452088000,7),(662,467809200,8),(662,483537600,7),(662,499258800,8),(662,514987200,7),(662,530708400,8),(662,544622400,7),(662,562158000,8),(662,576072000,7),(662,594212400,8),(662,607521600,7),(662,625662000,8),(662,638971200,7),(662,657111600,8),(662,671025600,7),(662,688561200,8),(662,702475200,7),(662,720010800,8),(662,733924800,7),(662,752065200,8),(662,765374400,7),(662,783514800,8),(662,796824000,7),(662,814964400,8),(662,828878400,7),(662,846414000,8),(662,860328000,7),(662,877863600,8),(662,891777600,7),(662,909313200,8),(662,923227200,7),(662,941367600,8),(662,954676800,7),(662,972817200,8),(662,986126400,7),(662,1004266800,8),(662,1018180800,7),(662,1035716400,8),(662,1049630400,7),(662,1067166000,8),(662,1081080000,7),(662,1099220400,8),(662,1112529600,7),(662,1130670000,8),(662,1143979200,7),(662,1162119600,8),(662,1173614400,7),(662,1194174000,8),(662,1205064000,7),(662,1225623600,8),(662,1236513600,7),(662,1257073200,8),(662,1268568000,7),(662,1289127600,8),(662,1300017600,7),(662,1320577200,8),(662,1331467200,7),(662,1352026800,8),(662,1362916800,7),(662,1383476400,8),(662,1394366400,7),(662,1414926000,8),(662,1425816000,7),(662,1446375600,8),(662,1457870400,7),(662,1478430000,8),(662,1489320000,7),(662,1509879600,8),(662,1520769600,7),(662,1541329200,8),(662,1552219200,7),(662,1572778800,8),(662,1583668800,7),(662,1604228400,8),(662,1615723200,7),(662,1636282800,8),(662,1647172800,7),(662,1667732400,8),(662,1678622400,7),(662,1699182000,8),(662,1710072000,7),(662,1730631600,8),(662,1741521600,7),(662,1762081200,8),(662,1772971200,7),(662,1793530800,8),(662,1805025600,7),(662,1825585200,8),(662,1836475200,7),(662,1857034800,8),(662,1867924800,7),(662,1888484400,8),(662,1899374400,7),(662,1919934000,8),(662,1930824000,7),(662,1951383600,8),(662,1962878400,7),(662,1983438000,8),(662,1994328000,7),(662,2014887600,8),(662,2025777600,7),(662,2046337200,8),(662,2057227200,7),(662,2077786800,8),(662,2088676800,7),(662,2109236400,8),(662,2120126400,7),(662,2140686000,8),(663,-2147483648,1),(663,-880200000,2),(663,-769395600,3),(663,-765378000,1),(663,-86882400,4),(663,-21470400,5),(663,-5749200,4),(663,9979200,5),(663,25700400,4),(663,41428800,5),(663,57754800,4),(663,73483200,5),(663,89204400,4),(663,104932800,5),(663,120654000,4),(663,126705600,5),(663,152103600,4),(663,162388800,5),(663,183553200,4),(663,199281600,5),(663,215607600,4),(663,230731200,5),(663,247057200,4),(663,262785600,5),(663,278506800,4),(663,294235200,5),(663,309956400,4),(663,325684800,5),(663,341406000,4),(663,357134400,5),(663,372855600,4),(663,388584000,5),(663,404910000,4),(663,420033600,5),(663,436359600,6),(663,439030800,8),(663,452084400,7),(663,467805600,8),(663,483534000,7),(663,499255200,8),(663,514983600,7),(663,530704800,8),(663,544618800,7),(663,562154400,8),(663,576068400,7),(663,594208800,8),(663,607518000,7),(663,625658400,8),(663,638967600,7),(663,657108000,8),(663,671022000,7),(663,688557600,8),(663,702471600,7),(663,720007200,8),(663,733921200,7),(663,752061600,8),(663,765370800,7),(663,783511200,8),(663,796820400,7),(663,814960800,8),(663,828874800,7),(663,846410400,8),(663,860324400,7),(663,877860000,8),(663,891774000,7),(663,909309600,8),(663,923223600,7),(663,941364000,8),(663,954673200,7),(663,972813600,8),(663,986122800,7),(663,1004263200,8),(663,1018177200,7),(663,1035712800,8),(663,1049626800,7),(663,1067162400,8),(663,1081076400,7),(663,1099216800,8),(663,1112526000,7),(663,1130666400,8),(663,1143975600,7),(663,1162116000,8),(663,1173610800,7),(663,1194170400,8),(663,1205060400,7),(663,1225620000,8),(663,1236510000,7),(663,1257069600,8),(663,1268564400,7),(663,1289124000,8),(663,1300014000,7),(663,1320573600,8),(663,1331463600,7),(663,1352023200,8),(663,1362913200,7),(663,1383472800,8),(663,1394362800,7),(663,1414922400,8),(663,1425812400,7),(663,1446372000,8),(663,1457866800,7),(663,1478426400,8),(663,1489316400,7),(663,1509876000,8),(663,1520766000,7),(663,1541325600,8),(663,1552215600,7),(663,1572775200,8),(663,1583665200,7),(663,1604224800,8),(663,1615719600,7),(663,1636279200,8),(663,1647169200,7),(663,1667728800,8),(663,1678618800,7),(663,1699178400,8),(663,1710068400,7),(663,1730628000,8),(663,1741518000,7),(663,1762077600,8),(663,1772967600,7),(663,1793527200,8),(663,1805022000,7),(663,1825581600,8),(663,1836471600,7),(663,1857031200,8),(663,1867921200,7),(663,1888480800,8),(663,1899370800,7),(663,1919930400,8),(663,1930820400,7),(663,1951380000,8),(663,1962874800,7),(663,1983434400,8),(663,1994324400,7),(663,2014884000,8),(663,2025774000,7),(663,2046333600,8),(663,2057223600,7),(663,2077783200,8),(663,2088673200,7),(663,2109232800,8),(663,2120122800,7),(663,2140682400,8),(664,-2147483648,0),(664,-1825098836,1),(665,-2147483648,0),(665,-1825098836,1),(666,-2147483648,0),(666,-1767214032,2),(666,-1206957600,1),(666,-1191362400,2),(666,-1175374800,1),(666,-1159826400,2),(666,-633819600,1),(666,-622069200,2),(666,-602283600,1),(666,-591832800,2),(666,-570747600,1),(666,-560210400,2),(666,-539125200,1),(666,-531352800,2),(666,-191365200,1),(666,-184197600,2),(666,-155163600,1),(666,-150069600,2),(666,-128898000,1),(666,-121125600,2),(666,-99954000,1),(666,-89589600,2),(666,-68418000,1),(666,-57967200,2),(666,499748400,1),(666,511236000,2),(666,530593200,1),(666,540266400,2),(666,562129200,1),(666,571197600,2),(666,592974000,1),(666,602042400,2),(666,624423600,1),(666,634701600,2),(666,813726000,1),(666,824004000,2),(666,844570800,1),(666,856058400,2),(666,876106800,1),(666,888717600,2),(666,908074800,1),(666,919562400,2),(666,938919600,1),(666,951616800,2),(666,970974000,1),(666,982461600,2),(666,1003028400,1),(666,1013911200,2),(666,1036292400,1),(666,1045360800,2),(666,1350788400,1),(666,1361066400,2),(666,2147483647,2),(667,-2147483648,1),(667,-1567453392,2),(667,-1233432000,3),(667,-1222981200,2),(667,-1205956800,3),(667,-1194037200,2),(667,-1172865600,3),(667,-1162501200,2),(667,-1141329600,3),(667,-1130965200,2),(667,-1109793600,3),(667,-1099429200,2),(667,-1078257600,3),(667,-1067806800,2),(667,-1046635200,3),(667,-1036270800,2),(667,-1015099200,3),(667,-1004734800,2),(667,-983563200,3),(667,-973198800,2),(667,-952027200,3),(667,-941576400,2),(667,-931032000,3),(667,-900882000,2),(667,-890337600,3),(667,-833749200,2),(667,-827265600,3),(667,-752274000,2),(667,-733780800,3),(667,-197326800,2),(667,-190843200,3),(667,-184194000,2),(667,-164491200,3),(667,-152658000,2),(667,-132955200,3),(667,-121122000,2),(667,-101419200,3),(667,-86821200,2),(667,-71092800,3),(667,-54766800,2),(667,-39038400,3),(667,-23317200,2),(667,-7588800,5),(667,128142000,4),(667,136605600,5),(667,596948400,4),(667,605066400,5),(667,624423600,4),(667,636516000,5),(667,656478000,4),(667,667965600,5),(667,687927600,4),(667,699415200,5),(667,719377200,4),(667,731469600,5),(667,938919600,3),(667,952052400,5),(667,1198983600,4),(667,1205632800,5),(667,1224385200,4),(667,1237082400,5),(667,2147483647,5),(668,-2147483648,1),(668,-1567453392,2),(668,-1233432000,3),(668,-1222981200,2),(668,-1205956800,3),(668,-1194037200,2),(668,-1172865600,3),(668,-1162501200,2),(668,-1141329600,3),(668,-1130965200,2),(668,-1109793600,3),(668,-1099429200,2),(668,-1078257600,3),(668,-1067806800,2),(668,-1046635200,3),(668,-1036270800,2),(668,-1015099200,3),(668,-1004734800,2),(668,-983563200,3),(668,-973198800,2),(668,-952027200,3),(668,-941576400,2),(668,-931032000,3),(668,-900882000,2),(668,-890337600,3),(668,-833749200,2),(668,-827265600,3),(668,-752274000,2),(668,-733780800,3),(668,-197326800,2),(668,-190843200,3),(668,-184194000,2),(668,-164491200,3),(668,-152658000,2),(668,-132955200,3),(668,-121122000,2),(668,-101419200,3),(668,-86821200,2),(668,-71092800,3),(668,-54766800,2),(668,-39038400,3),(668,-23317200,2),(668,-7588800,5),(668,128142000,4),(668,136605600,5),(668,596948400,4),(668,605066400,5),(668,624423600,4),(668,636516000,5),(668,656478000,4),(668,667965600,2),(668,687931200,4),(668,699415200,5),(668,719377200,4),(668,731469600,5),(668,938919600,3),(668,952052400,5),(668,1086058800,2),(668,1087704000,5),(668,1198983600,4),(668,1205632800,5),(668,2147483647,5),(669,-2147483648,1),(669,-1567453392,2),(669,-1233432000,3),(669,-1222981200,2),(669,-1205956800,3),(669,-1194037200,2),(669,-1172865600,3),(669,-1162501200,2),(669,-1141329600,3),(669,-1130965200,2),(669,-1109793600,3),(669,-1099429200,2),(669,-1078257600,3),(669,-1067806800,2),(669,-1046635200,3),(669,-1036270800,2),(669,-1015099200,3),(669,-1004734800,2),(669,-983563200,3),(669,-973198800,2),(669,-952027200,3),(669,-941576400,2),(669,-931032000,3),(669,-900882000,2),(669,-890337600,3),(669,-833749200,2),(669,-827265600,3),(669,-752274000,2),(669,-733780800,3),(669,-197326800,2),(669,-190843200,3),(669,-184194000,2),(669,-164491200,3),(669,-152658000,2),(669,-132955200,3),(669,-121122000,2),(669,-101419200,3),(669,-86821200,2),(669,-71092800,3),(669,-54766800,2),(669,-39038400,3),(669,-23317200,2),(669,-7588800,5),(669,128142000,4),(669,136605600,5),(669,596948400,4),(669,605066400,5),(669,624423600,4),(669,636516000,5),(669,656478000,4),(669,667965600,2),(669,687931200,4),(669,699415200,5),(669,719377200,4),(669,731469600,5),(669,938919600,3),(669,952052400,5),(669,1086058800,2),(669,1087704000,5),(669,1198983600,4),(669,1205632800,5),(669,2147483647,5),(670,-2147483648,1),(670,-1567453392,2),(670,-1233432000,3),(670,-1222981200,2),(670,-1205956800,3),(670,-1194037200,2),(670,-1172865600,3),(670,-1162501200,2),(670,-1141329600,3),(670,-1130965200,2),(670,-1109793600,3),(670,-1099429200,2),(670,-1078257600,3),(670,-1067806800,2),(670,-1046635200,3),(670,-1036270800,2),(670,-1015099200,3),(670,-1004734800,2),(670,-983563200,3),(670,-973198800,2),(670,-952027200,3),(670,-941576400,2),(670,-931032000,3),(670,-900882000,2),(670,-890337600,3),(670,-833749200,2),(670,-827265600,3),(670,-752274000,2),(670,-733780800,3),(670,-197326800,2),(670,-190843200,3),(670,-184194000,2),(670,-164491200,3),(670,-152658000,2),(670,-132955200,3),(670,-121122000,2),(670,-101419200,3),(670,-86821200,2),(670,-71092800,3),(670,-54766800,2),(670,-39038400,3),(670,-23317200,2),(670,-7588800,5),(670,128142000,4),(670,136605600,5),(670,596948400,4),(670,605066400,5),(670,624423600,4),(670,636516000,5),(670,656478000,4),(670,667965600,2),(670,687931200,4),(670,699415200,5),(670,719377200,4),(670,731469600,5),(670,938919600,3),(670,952052400,5),(670,1198983600,4),(670,1205632800,5),(670,1224385200,4),(670,1237082400,5),(670,2147483647,5),(671,-2147483648,1),(671,-1567453392,2),(671,-1233432000,3),(671,-1222981200,2),(671,-1205956800,3),(671,-1194037200,2),(671,-1172865600,3),(671,-1162501200,2),(671,-1141329600,3),(671,-1130965200,2),(671,-1109793600,3),(671,-1099429200,2),(671,-1078257600,3),(671,-1067806800,2),(671,-1046635200,3),(671,-1036270800,2),(671,-1015099200,3),(671,-1004734800,2),(671,-983563200,3),(671,-973198800,2),(671,-952027200,3),(671,-941576400,2),(671,-931032000,3),(671,-900882000,2),(671,-890337600,3),(671,-833749200,2),(671,-827265600,3),(671,-752274000,2),(671,-733780800,3),(671,-197326800,2),(671,-190843200,3),(671,-184194000,2),(671,-164491200,3),(671,-152658000,2),(671,-132955200,3),(671,-121122000,2),(671,-101419200,3),(671,-86821200,2),(671,-71092800,3),(671,-54766800,2),(671,-39038400,3),(671,-23317200,2),(671,-7588800,5),(671,128142000,4),(671,136605600,5),(671,596948400,4),(671,605066400,5),(671,624423600,4),(671,636516000,2),(671,657086400,3),(671,669178800,2),(671,686721600,4),(671,699415200,5),(671,719377200,4),(671,731469600,5),(671,938919600,3),(671,952052400,5),(671,1198983600,4),(671,1205632800,5),(671,2147483647,5),(672,-2147483648,1),(672,-1567453392,2),(672,-1233432000,3),(672,-1222981200,2),(672,-1205956800,3),(672,-1194037200,2),(672,-1172865600,3),(672,-1162501200,2),(672,-1141329600,3),(672,-1130965200,2),(672,-1109793600,3),(672,-1099429200,2),(672,-1078257600,3),(672,-1067806800,2),(672,-1046635200,3),(672,-1036270800,2),(672,-1015099200,3),(672,-1004734800,2),(672,-983563200,3),(672,-973198800,2),(672,-952027200,3),(672,-941576400,2),(672,-931032000,3),(672,-900882000,2),(672,-890337600,3),(672,-833749200,2),(672,-827265600,3),(672,-752274000,2),(672,-733780800,3),(672,-197326800,2),(672,-190843200,3),(672,-184194000,2),(672,-164491200,3),(672,-152658000,2),(672,-132955200,3),(672,-121122000,2),(672,-101419200,3),(672,-86821200,2),(672,-71092800,3),(672,-54766800,2),(672,-39038400,3),(672,-23317200,2),(672,-7588800,5),(672,128142000,4),(672,136605600,5),(672,596948400,4),(672,605066400,5),(672,624423600,4),(672,636516000,5),(672,656478000,4),(672,667792800,2),(672,673588800,5),(672,687927600,4),(672,699415200,5),(672,719377200,4),(672,731469600,5),(672,938919600,3),(672,952052400,5),(672,1086058800,2),(672,1087704000,5),(672,1198983600,4),(672,1205632800,5),(672,2147483647,5),(673,-2147483648,1),(673,-1567453392,2),(673,-1233432000,3),(673,-1222981200,2),(673,-1205956800,3),(673,-1194037200,2),(673,-1172865600,3),(673,-1162501200,2),(673,-1141329600,3),(673,-1130965200,2),(673,-1109793600,3),(673,-1099429200,2),(673,-1078257600,3),(673,-1067806800,2),(673,-1046635200,3),(673,-1036270800,2),(673,-1015099200,3),(673,-1004734800,2),(673,-983563200,3),(673,-973198800,2),(673,-952027200,3),(673,-941576400,2),(673,-931032000,3),(673,-900882000,2),(673,-890337600,3),(673,-833749200,2),(673,-827265600,3),(673,-752274000,2),(673,-733780800,3),(673,-197326800,2),(673,-190843200,3),(673,-184194000,2),(673,-164491200,3),(673,-152658000,2),(673,-132955200,3),(673,-121122000,2),(673,-101419200,3),(673,-86821200,2),(673,-71092800,3),(673,-54766800,2),(673,-39038400,3),(673,-23317200,2),(673,-7588800,5),(673,128142000,4),(673,136605600,5),(673,596948400,4),(673,605066400,5),(673,624423600,4),(673,636516000,2),(673,655963200,3),(673,667796400,2),(673,687499200,3),(673,699418800,2),(673,719380800,4),(673,731469600,5),(673,938919600,3),(673,952052400,5),(673,1085281200,2),(673,1096171200,5),(673,1198983600,4),(673,1205632800,5),(673,2147483647,5),(674,-2147483648,1),(674,-1567453392,2),(674,-1233432000,3),(674,-1222981200,2),(674,-1205956800,3),(674,-1194037200,2),(674,-1172865600,3),(674,-1162501200,2),(674,-1141329600,3),(674,-1130965200,2),(674,-1109793600,3),(674,-1099429200,2),(674,-1078257600,3),(674,-1067806800,2),(674,-1046635200,3),(674,-1036270800,2),(674,-1015099200,3),(674,-1004734800,2),(674,-983563200,3),(674,-973198800,2),(674,-952027200,3),(674,-941576400,2),(674,-931032000,3),(674,-900882000,2),(674,-890337600,3),(674,-833749200,2),(674,-827265600,3),(674,-752274000,2),(674,-733780800,3),(674,-197326800,2),(674,-190843200,3),(674,-184194000,2),(674,-164491200,3),(674,-152658000,2),(674,-132955200,3),(674,-121122000,2),(674,-101419200,3),(674,-86821200,2),(674,-71092800,3),(674,-54766800,2),(674,-39038400,3),(674,-23317200,2),(674,-7588800,5),(674,128142000,4),(674,136605600,5),(674,596948400,4),(674,605066400,5),(674,624423600,4),(674,636516000,5),(674,656478000,4),(674,667965600,5),(674,687927600,4),(674,699415200,5),(674,719377200,4),(674,731469600,5),(674,938919600,3),(674,952052400,5),(674,1086058800,2),(674,1087704000,5),(674,1198983600,4),(674,1205632800,5),(674,2147483647,5),(675,-2147483648,1),(675,-1567453392,2),(675,-1233432000,3),(675,-1222981200,2),(675,-1205956800,3),(675,-1194037200,2),(675,-1172865600,3),(675,-1162501200,2),(675,-1141329600,3),(675,-1130965200,2),(675,-1109793600,3),(675,-1099429200,2),(675,-1078257600,3),(675,-1067806800,2),(675,-1046635200,3),(675,-1036270800,2),(675,-1015099200,3),(675,-1004734800,2),(675,-983563200,3),(675,-973198800,2),(675,-952027200,3),(675,-941576400,2),(675,-931032000,3),(675,-900882000,2),(675,-890337600,3),(675,-833749200,2),(675,-827265600,3),(675,-752274000,2),(675,-733780800,3),(675,-197326800,2),(675,-190843200,3),(675,-184194000,2),(675,-164491200,3),(675,-152658000,2),(675,-132955200,3),(675,-121122000,2),(675,-101419200,3),(675,-86821200,2),(675,-71092800,3),(675,-54766800,2),(675,-39038400,3),(675,-23317200,2),(675,-7588800,5),(675,128142000,4),(675,136605600,5),(675,596948400,4),(675,605066400,5),(675,624423600,4),(675,636516000,5),(675,656478000,4),(675,667965600,2),(675,687931200,4),(675,699415200,5),(675,719377200,4),(675,731469600,5),(675,938919600,3),(675,952052400,5),(675,1198983600,4),(675,1205632800,5),(675,2147483647,5),(676,-2147483648,1),(676,-1567453392,2),(676,-1233432000,3),(676,-1222981200,2),(676,-1205956800,3),(676,-1194037200,2),(676,-1172865600,3),(676,-1162501200,2),(676,-1141329600,3),(676,-1130965200,2),(676,-1109793600,3),(676,-1099429200,2),(676,-1078257600,3),(676,-1067806800,2),(676,-1046635200,3),(676,-1036270800,2),(676,-1015099200,3),(676,-1004734800,2),(676,-983563200,3),(676,-973198800,2),(676,-952027200,3),(676,-941576400,2),(676,-931032000,3),(676,-900882000,2),(676,-890337600,3),(676,-833749200,2),(676,-827265600,3),(676,-752274000,2),(676,-733780800,3),(676,-197326800,2),(676,-190843200,3),(676,-184194000,2),(676,-164491200,3),(676,-152658000,2),(676,-132955200,3),(676,-121122000,2),(676,-101419200,3),(676,-86821200,2),(676,-71092800,3),(676,-54766800,2),(676,-39038400,3),(676,-23317200,2),(676,-7588800,5),(676,128142000,4),(676,136605600,5),(676,596948400,4),(676,605066400,5),(676,624423600,4),(676,636516000,5),(676,656478000,4),(676,667792800,2),(676,673588800,5),(676,687927600,4),(676,699415200,5),(676,719377200,4),(676,731469600,5),(676,938919600,3),(676,952052400,5),(676,1085972400,2),(676,1090728000,5),(676,1198983600,4),(676,1205632800,5),(676,2147483647,5),(677,-2147483648,1),(677,-1567453392,2),(677,-1233432000,3),(677,-1222981200,2),(677,-1205956800,3),(677,-1194037200,2),(677,-1172865600,3),(677,-1162501200,2),(677,-1141329600,3),(677,-1130965200,2),(677,-1109793600,3),(677,-1099429200,2),(677,-1078257600,3),(677,-1067806800,2),(677,-1046635200,3),(677,-1036270800,2),(677,-1015099200,3),(677,-1004734800,2),(677,-983563200,3),(677,-973198800,2),(677,-952027200,3),(677,-941576400,2),(677,-931032000,3),(677,-900882000,2),(677,-890337600,3),(677,-833749200,2),(677,-827265600,3),(677,-752274000,2),(677,-733780800,3),(677,-197326800,2),(677,-190843200,3),(677,-184194000,2),(677,-164491200,3),(677,-152658000,2),(677,-132955200,3),(677,-121122000,2),(677,-101419200,3),(677,-86821200,2),(677,-71092800,3),(677,-54766800,2),(677,-39038400,3),(677,-23317200,2),(677,-7588800,5),(677,128142000,4),(677,136605600,5),(677,596948400,4),(677,605066400,5),(677,624423600,4),(677,637380000,2),(677,655963200,3),(677,667796400,2),(677,675748800,5),(677,938919600,3),(677,952052400,5),(677,1085972400,2),(677,1090728000,5),(677,1198983600,4),(677,1200880800,3),(677,1205031600,2),(677,1223784000,3),(677,1236481200,2),(677,1255233600,5),(677,2147483647,5),(678,-2147483648,1),(678,-1567453392,2),(678,-1233432000,3),(678,-1222981200,2),(678,-1205956800,3),(678,-1194037200,2),(678,-1172865600,3),(678,-1162501200,2),(678,-1141329600,3),(678,-1130965200,2),(678,-1109793600,3),(678,-1099429200,2),(678,-1078257600,3),(678,-1067806800,2),(678,-1046635200,3),(678,-1036270800,2),(678,-1015099200,3),(678,-1004734800,2),(678,-983563200,3),(678,-973198800,2),(678,-952027200,3),(678,-941576400,2),(678,-931032000,3),(678,-900882000,2),(678,-890337600,3),(678,-833749200,2),(678,-827265600,3),(678,-752274000,2),(678,-733780800,3),(678,-197326800,2),(678,-190843200,3),(678,-184194000,2),(678,-164491200,3),(678,-152658000,2),(678,-132955200,3),(678,-121122000,2),(678,-101419200,3),(678,-86821200,2),(678,-71092800,3),(678,-54766800,2),(678,-39038400,3),(678,-23317200,2),(678,-7588800,5),(678,128142000,4),(678,136605600,5),(678,596948400,4),(678,605066400,5),(678,624423600,4),(678,636516000,5),(678,656478000,4),(678,667965600,2),(678,687931200,4),(678,699415200,5),(678,719377200,4),(678,731469600,5),(678,938919600,3),(678,952052400,5),(678,1086058800,2),(678,1087099200,5),(678,1198983600,4),(678,1205632800,5),(678,1224385200,4),(678,1237082400,5),(678,2147483647,5),(679,-2147483648,1),(679,-1567453392,2),(679,-1233432000,3),(679,-1222981200,2),(679,-1205956800,3),(679,-1194037200,2),(679,-1172865600,3),(679,-1162501200,2),(679,-1141329600,3),(679,-1130965200,2),(679,-1109793600,3),(679,-1099429200,2),(679,-1078257600,3),(679,-1067806800,2),(679,-1046635200,3),(679,-1036270800,2),(679,-1015099200,3),(679,-1004734800,2),(679,-983563200,3),(679,-973198800,2),(679,-952027200,3),(679,-941576400,2),(679,-931032000,3),(679,-900882000,2),(679,-890337600,3),(679,-833749200,2),(679,-827265600,3),(679,-752274000,2),(679,-733780800,3),(679,-197326800,2),(679,-190843200,3),(679,-184194000,2),(679,-164491200,3),(679,-152658000,2),(679,-132955200,3),(679,-121122000,2),(679,-101419200,3),(679,-86821200,2),(679,-71092800,3),(679,-54766800,2),(679,-39038400,3),(679,-23317200,2),(679,-7588800,5),(679,128142000,4),(679,136605600,5),(679,596948400,4),(679,605066400,5),(679,624423600,4),(679,636516000,5),(679,656478000,4),(679,667965600,5),(679,687927600,4),(679,699415200,5),(679,719377200,4),(679,731469600,5),(679,938919600,3),(679,952052400,5),(679,1085886000,2),(679,1087704000,5),(679,1198983600,4),(679,1205632800,5),(679,2147483647,5),(680,-2147483648,0),(680,-1826738653,1),(680,-157750200,2),(681,-2147483648,1),(681,-1206389360,2),(681,86760000,3),(681,134017200,2),(681,181368000,4),(681,194497200,2),(681,212990400,4),(681,226033200,2),(681,244526400,4),(681,257569200,2),(681,276062400,4),(681,291783600,2),(681,307598400,4),(681,323406000,2),(681,339220800,4),(681,354942000,2),(681,370756800,4),(681,386478000,2),(681,402292800,4),(681,418014000,2),(681,433828800,4),(681,449636400,2),(681,465451200,4),(681,481172400,2),(681,496987200,4),(681,512708400,2),(681,528523200,4),(681,544244400,2),(681,560059200,4),(681,575866800,2),(681,591681600,4),(681,607402800,2),(681,625032000,4),(681,638938800,2),(681,654753600,4),(681,670474800,2),(681,686721600,4),(681,699418800,2),(681,718257600,4),(681,733546800,2),(681,749448000,4),(681,762318000,2),(681,780984000,4),(681,793767600,2),(681,812520000,4),(681,825649200,2),(681,844574400,4),(681,856666800,2),(681,876024000,4),(681,888721200,2),(681,907473600,4),(681,920775600,2),(681,938923200,4),(681,952225200,2),(681,970372800,4),(681,983674800,2),(681,1002427200,4),(681,1018148400,2),(681,1030852800,4),(681,1049598000,2),(681,1062907200,4),(681,1081047600,2),(681,1097985600,4),(681,1110682800,2),(681,1129435200,4),(681,1142132400,2),(681,1160884800,4),(681,1173582000,2),(681,1192939200,4),(681,1205031600,2),(681,1224388800,4),(681,1236481200,2),(681,1255838400,4),(681,1270954800,2),(681,1286078400,4),(681,1302404400,2),(681,1317528000,4),(681,1333854000,2),(681,1349582400,4),(681,1364094000,2),(681,1381032000,4),(681,1395543600,2),(681,1412481600,4),(681,1426993200,2),(681,1443931200,4),(681,1459047600,2),(681,1475380800,4),(681,1490497200,2),(681,1506830400,4),(681,1521946800,2),(681,1538884800,4),(681,1553396400,2),(681,1570334400,4),(681,1584846000,2),(681,1601784000,4),(681,1616900400,2),(681,1633233600,4),(681,1648350000,2),(681,1664683200,4),(681,1679799600,2),(681,1696132800,4),(681,1711249200,2),(681,1728187200,4),(681,1742698800,2),(681,1759636800,4),(681,1774148400,2),(681,1791086400,4),(681,1806202800,2),(681,1822536000,4),(681,1837652400,2),(681,1853985600,4),(681,1869102000,2),(681,1886040000,4),(681,1900551600,2),(681,1917489600,4),(681,1932001200,2),(681,1948939200,4),(681,1964055600,2),(681,1980388800,4),(681,1995505200,2),(681,2011838400,4),(681,2026954800,2),(681,2043288000,4),(681,2058404400,2),(681,2075342400,4),(681,2089854000,2),(681,2106792000,4),(681,2121303600,2),(681,2138241600,4),(681,2147483647,4),(682,-2147483648,2),(682,-1632067200,1),(682,-1615136400,2),(682,-923248800,1),(682,-880214400,3),(682,-769395600,4),(682,-765392400,5),(683,-2147483648,1),(683,-880196400,2),(683,-769395600,3),(683,-765374400,1),(683,-86878800,4),(683,-21466800,5),(683,-5745600,4),(683,9982800,5),(683,25704000,4),(683,41432400,5),(683,57758400,4),(683,73486800,5),(683,89208000,4),(683,104936400,5),(683,120657600,4),(683,126709200,5),(683,152107200,4),(683,162392400,5),(683,183556800,4),(683,199285200,5),(683,215611200,4),(683,230734800,5),(683,247060800,4),(683,262789200,5),(683,278510400,4),(683,294238800,5),(683,309960000,4),(683,325688400,5),(683,341409600,4),(683,357138000,5),(683,372859200,4),(683,388587600,5),(683,404913600,4),(683,420037200,5),(683,436363200,6),(683,439034400,8),(683,452088000,7),(683,467809200,8),(683,483537600,7),(683,499258800,8),(683,514987200,7),(683,530708400,8),(683,544622400,7),(683,562158000,8),(683,576072000,7),(683,594212400,8),(683,607521600,7),(683,625662000,8),(683,638971200,7),(683,657111600,8),(683,671025600,7),(683,688561200,8),(683,702475200,7),(683,720010800,8),(683,733924800,7),(683,752065200,8),(683,765374400,7),(683,783514800,8),(683,796824000,7),(683,814964400,8),(683,828878400,7),(683,846414000,8),(683,860328000,7),(683,877863600,8),(683,891777600,7),(683,909313200,8),(683,923227200,7),(683,941367600,8),(683,954676800,7),(683,972817200,8),(683,986126400,7),(683,1004266800,8),(683,1018180800,7),(683,1035716400,8),(683,1049630400,7),(683,1067166000,8),(683,1081080000,7),(683,1099220400,8),(683,1112529600,7),(683,1130670000,8),(683,1143979200,7),(683,1162119600,8),(683,1173614400,7),(683,1194174000,8),(683,1205064000,7),(683,1225623600,8),(683,1236513600,7),(683,1257073200,8),(683,1268568000,7),(683,1289127600,8),(683,1300017600,7),(683,1320577200,8),(683,1331467200,7),(683,1352026800,8),(683,1362916800,7),(683,1383476400,8),(683,1394366400,7),(683,1414926000,8),(683,1425816000,7),(683,1446375600,8),(683,1457870400,7),(683,1478430000,8),(683,1489320000,7),(683,1509879600,8),(683,1520769600,7),(683,1541329200,8),(683,1552219200,7),(683,1572778800,8),(683,1583668800,7),(683,1604228400,8),(683,1615723200,7),(683,1636282800,8),(683,1647172800,7),(683,1667732400,8),(683,1678622400,7),(683,1699182000,8),(683,1710072000,7),(683,1730631600,8),(683,1741521600,7),(683,1762081200,8),(683,1772971200,7),(683,1793530800,8),(683,1805025600,7),(683,1825585200,8),(683,1836475200,7),(683,1857034800,8),(683,1867924800,7),(683,1888484400,8),(683,1899374400,7),(683,1919934000,8),(683,1930824000,7),(683,1951383600,8),(683,1962878400,7),(683,1983438000,8),(683,1994328000,7),(683,2014887600,8),(683,2025777600,7),(683,2046337200,8),(683,2057227200,7),(683,2077786800,8),(683,2088676800,7),(683,2109236400,8),(683,2120126400,7),(683,2140686000,8),(684,-2147483648,0),(684,-1767216356,2),(684,-1206957600,1),(684,-1191362400,2),(684,-1175374800,1),(684,-1159826400,2),(684,-633819600,1),(684,-622069200,2),(684,-602283600,1),(684,-591832800,2),(684,-570747600,1),(684,-560210400,2),(684,-539125200,1),(684,-531352800,2),(684,-191365200,1),(684,-184197600,2),(684,-155163600,1),(684,-150069600,2),(684,-128898000,1),(684,-121125600,2),(684,-99954000,1),(684,-89589600,2),(684,-68418000,1),(684,-57967200,2),(684,499748400,1),(684,511236000,2),(684,530593200,1),(684,540266400,2),(684,562129200,1),(684,571197600,2),(684,592974000,1),(684,602042400,2),(684,624423600,1),(684,634701600,2),(684,656478000,1),(684,666756000,2),(684,687927600,1),(684,697600800,2),(684,719982000,1),(684,728445600,2),(684,750826800,1),(684,761709600,2),(684,782276400,1),(684,793159200,2),(684,813726000,1),(684,824004000,2),(684,844570800,1),(684,856058400,2),(684,876106800,1),(684,888717600,2),(684,908074800,1),(684,919562400,2),(684,938919600,1),(684,951616800,2),(684,970974000,1),(684,982461600,2),(684,1003028400,1),(684,1013911200,2),(684,1036292400,1),(684,1045360800,2),(684,1318734000,1),(684,1330221600,2),(684,2147483647,2),(685,-2147483648,0),(685,-1514739600,1),(685,-1343066400,2),(685,-1234807200,1),(685,-1220292000,2),(685,-1207159200,1),(685,-1191344400,2),(685,-873828000,1),(685,-661539600,3),(685,28800,1),(685,828867600,4),(685,846403200,1),(685,860317200,4),(685,877852800,1),(685,891766800,4),(685,909302400,1),(685,923216400,4),(685,941356800,1),(685,954666000,4),(685,972806400,1),(685,989139600,4),(685,1001836800,1),(685,1018170000,4),(685,1035705600,1),(685,1049619600,4),(685,1067155200,1),(685,1081069200,4),(685,1099209600,1),(685,1112518800,4),(685,1130659200,1),(685,1143968400,4),(685,1162108800,1),(685,1175418000,4),(685,1193558400,1),(685,1207472400,4),(685,1225008000,1),(685,1238922000,4),(685,1256457600,1),(685,1270371600,5),(685,1288508400,2),(685,1301817600,5),(685,1319958000,2),(685,1333267200,5),(685,1351407600,2),(685,1365321600,5),(685,1382857200,2),(685,1396771200,5),(685,1414306800,2),(685,1428220800,5),(685,1445756400,2),(685,1459670400,5),(685,1477810800,2),(685,1491120000,5),(685,1509260400,2),(685,1522569600,5),(685,1540710000,2),(685,1554624000,5),(685,1572159600,2),(685,1586073600,5),(685,1603609200,2),(685,1617523200,5),(685,1635663600,2),(685,1648972800,5),(685,1667113200,2),(685,1680422400,5),(685,1698562800,2),(685,1712476800,5),(685,1730012400,2),(685,1743926400,5),(685,1761462000,2),(685,1775376000,5),(685,1792911600,2),(685,1806825600,5),(685,1824966000,2),(685,1838275200,5),(685,1856415600,2),(685,1869724800,5),(685,1887865200,2),(685,1901779200,5),(685,1919314800,2),(685,1933228800,5),(685,1950764400,2),(685,1964678400,5),(685,1982818800,2),(685,1996128000,5),(685,2014268400,2),(685,2027577600,5),(685,2045718000,2),(685,2059027200,5),(685,2077167600,2),(685,2091081600,5),(685,2108617200,2),(685,2122531200,5),(685,2140066800,2),(686,-2147483648,0),(686,-1451678491,1),(686,-1199217691,3),(686,234943200,2),(686,244616400,3),(686,261554400,2),(686,276066000,3),(686,293004000,2),(686,307515600,3),(686,325058400,2),(686,338706000,3),(687,-2147483648,0),(687,-1767213964,2),(687,-1206957600,1),(687,-1191362400,2),(687,-1175374800,1),(687,-1159826400,2),(687,-633819600,1),(687,-622069200,2),(687,-602283600,1),(687,-591832800,2),(687,-570747600,1),(687,-560210400,2),(687,-539125200,1),(687,-531352800,2),(687,-191365200,1),(687,-184197600,2),(687,-155163600,1),(687,-150069600,2),(687,-128898000,1),(687,-121125600,2),(687,-99954000,1),(687,-89589600,2),(687,-68418000,1),(687,-57967200,2),(687,499748400,1),(687,511236000,2),(687,530593200,1),(687,540266400,2),(687,562129200,1),(687,571197600,2),(687,2147483647,2),(688,-2147483648,0),(688,-1822500432,2),(688,-1616954400,1),(688,-1606069800,2),(688,-1585504800,1),(688,-1574015400,2),(688,-1554055200,1),(688,-1542565800,2),(688,-1522605600,1),(688,-1511116200,2),(688,-1490551200,1),(688,-1479666600,2),(688,-1459101600,1),(688,-1448217000,2),(688,-1427652000,1),(688,-1416162600,2),(688,-1396202400,1),(688,-1384713000,2),(688,-1364752800,1),(688,-1353263400,2),(688,-1333303200,1),(688,-1321813800,2),(688,-1301248800,1),(688,-1290364200,2),(688,-1269799200,1),(688,-1258914600,2),(688,-1238349600,1),(688,-1226860200,2),(688,-1206900000,1),(688,-1195410600,2),(688,-1175450400,1),(688,-1163961000,2),(688,-1143396000,1),(688,-1132511400,2),(688,-1111946400,1),(688,-1101061800,2),(688,-1080496800,1),(688,-1069612200,2),(688,-1049047200,1),(688,-1037557800,2),(688,-1017597600,1),(688,-1006108200,2),(688,-986148000,1),(688,-974658600,2),(688,-954093600,1),(688,-943209000,2),(688,-922644000,1),(688,-911759400,2),(688,-891194400,1),(688,-879705000,2),(688,-859744800,1),(688,-848255400,2),(688,123919200,3),(688,129618000,2),(688,409039200,3),(688,413874000,2),(689,-2147483648,2),(689,-1632074400,1),(689,-1615143600,2),(689,-880221600,3),(689,-769395600,4),(689,-765399600,2),(690,-2147483648,0),(690,-1767211040,2),(690,-1206954000,1),(690,-1191358800,2),(690,-1175371200,1),(690,-1159822800,2),(690,-633816000,1),(690,-622065600,2),(690,-602280000,1),(690,-591829200,2),(690,-570744000,1),(690,-560206800,2),(690,-539121600,1),(690,-531349200,2),(690,-191361600,1),(690,-184194000,2),(690,-155160000,1),(690,-150066000,2),(690,-128894400,1),(690,-121122000,2),(690,-99950400,1),(690,-89586000,2),(690,-68414400,1),(690,-57963600,2),(690,499752000,1),(690,511239600,2),(690,530596800,1),(690,540270000,2),(690,562132800,1),(690,571201200,2),(690,938923200,1),(690,951620400,2),(690,970977600,1),(690,971578800,2),(690,2147483647,2),(691,-2147483648,1),(691,-1739041424,3),(691,704869200,2),(691,733896000,3),(691,2147483647,3),(692,-2147483648,2),(692,-1633269600,1),(692,-1615129200,2),(692,-1601820000,1),(692,-1583679600,2),(692,-1471788000,5),(692,-880210800,3),(692,-769395600,4),(692,-765388800,5),(692,-84380400,6),(692,-68659200,5),(692,-52930800,6),(692,-37209600,5),(692,-21481200,6),(692,-5760000,5),(692,9968400,6),(692,25689600,5),(692,41418000,6),(692,57744000,5),(692,73472400,6),(692,89193600,5),(692,104922000,6),(692,120643200,5),(692,129114000,6),(692,152092800,5),(692,162378000,6),(692,183542400,5),(692,199270800,6),(692,215596800,5),(692,230720400,6),(692,247046400,5),(692,262774800,6),(692,278496000,5),(692,294224400,6),(692,309945600,5),(692,325674000,6),(692,341395200,5),(692,357123600,6),(692,372844800,5),(692,388573200,6),(692,404899200,5),(692,420022800,6),(692,436348800,5),(692,452077200,6),(692,467798400,5),(692,483526800,6),(692,499248000,5),(692,514976400,6),(692,530697600,5),(692,544611600,6),(692,562147200,5),(692,576061200,6),(692,594201600,5),(692,607510800,6),(692,625651200,5),(692,638960400,6),(692,657100800,5),(692,671014800,6),(692,688550400,5),(692,702464400,6),(692,720000000,5),(692,733914000,6),(692,752054400,5),(692,765363600,6),(692,783504000,5),(692,796813200,6),(692,814953600,5),(692,828867600,6),(692,846403200,5),(692,860317200,6),(692,877852800,5),(692,891766800,6),(692,909302400,5),(692,923216400,6),(692,941356800,5),(692,954666000,6),(692,972806400,5),(692,986115600,6),(692,1004256000,5),(692,1018170000,6),(692,1035705600,5),(692,1049619600,6),(692,1067155200,5),(692,1081069200,6),(692,1099209600,5),(692,1112518800,6),(692,1130659200,5),(692,1143968400,6),(692,1162108800,5),(692,1173603600,6),(692,1194163200,5),(692,1205053200,6),(692,1225612800,5),(692,1236502800,6),(692,1257062400,5),(692,1268557200,6),(692,1289116800,5),(692,1300006800,6),(692,1320566400,5),(692,1331456400,6),(692,1352016000,5),(692,1362906000,6),(692,1383465600,5),(692,1394355600,6),(692,1414915200,5),(692,1425805200,6),(692,1446364800,5),(692,1457859600,6),(692,1478419200,5),(692,1489309200,6),(692,1509868800,5),(692,1520758800,6),(692,1541318400,5),(692,1552208400,6),(692,1572768000,5),(692,1583658000,6),(692,1604217600,5),(692,1615712400,6),(692,1636272000,5),(692,1647162000,6),(692,1667721600,5),(692,1678611600,6),(692,1699171200,5),(692,1710061200,6),(692,1730620800,5),(692,1741510800,6),(692,1762070400,5),(692,1772960400,6),(692,1793520000,5),(692,1805014800,6),(692,1825574400,5),(692,1836464400,6),(692,1857024000,5),(692,1867914000,6),(692,1888473600,5),(692,1899363600,6),(692,1919923200,5),(692,1930813200,6),(692,1951372800,5),(692,1962867600,6),(692,1983427200,5),(692,1994317200,6),(692,2014876800,5),(692,2025766800,6),(692,2046326400,5),(692,2057216400,6),(692,2077776000,5),(692,2088666000,6),(692,2109225600,5),(692,2120115600,6),(692,2140675200,5),(693,-2147483648,1),(693,-1567453392,2),(693,-1233432000,3),(693,-1222981200,2),(693,-1205956800,3),(693,-1194037200,2),(693,-1172865600,3),(693,-1162501200,2),(693,-1141329600,3),(693,-1130965200,2),(693,-1109793600,3),(693,-1099429200,2),(693,-1078257600,3),(693,-1067806800,2),(693,-1046635200,3),(693,-1036270800,2),(693,-1015099200,3),(693,-1004734800,2),(693,-983563200,3),(693,-973198800,2),(693,-952027200,3),(693,-941576400,2),(693,-931032000,3),(693,-900882000,2),(693,-890337600,3),(693,-833749200,2),(693,-827265600,3),(693,-752274000,2),(693,-733780800,3),(693,-197326800,2),(693,-190843200,3),(693,-184194000,2),(693,-164491200,3),(693,-152658000,2),(693,-132955200,3),(693,-121122000,2),(693,-101419200,3),(693,-86821200,2),(693,-71092800,3),(693,-54766800,2),(693,-39038400,3),(693,-23317200,2),(693,-7588800,5),(693,128142000,4),(693,136605600,5),(693,596948400,4),(693,605066400,5),(693,624423600,4),(693,636516000,5),(693,656478000,4),(693,667965600,5),(693,687927600,4),(693,699415200,5),(693,719377200,4),(693,731469600,5),(693,938919600,3),(693,952052400,5),(693,1198983600,4),(693,1205632800,5),(693,1224385200,4),(693,1237082400,5),(693,2147483647,5),(694,-2147483648,0),(694,-1577923200,3),(694,-880210800,1),(694,-769395600,2),(694,-765388800,3),(694,-147891600,4),(694,-131562000,3),(694,325674000,5),(694,341395200,3),(694,357123600,5),(694,372844800,3),(694,388573200,5),(694,404899200,3),(694,420022800,5),(694,436348800,3),(694,452077200,5),(694,467798400,3),(694,483526800,5),(694,499248000,3),(694,514976400,5),(694,530697600,3),(694,544611600,5),(694,562147200,3),(694,576061200,5),(694,594201600,3),(694,607510800,5),(694,625651200,3),(694,638960400,5),(694,657100800,3),(694,671014800,5),(694,688550400,3),(694,702464400,5),(694,720000000,3),(694,733914000,5),(694,752054400,3),(694,765363600,5),(694,783504000,3),(694,796813200,5),(694,814953600,3),(694,828867600,5),(694,846403200,3),(694,860317200,5),(694,877852800,3),(694,891766800,5),(694,909302400,3),(694,923216400,5),(694,941356800,7),(694,954662400,6),(694,972802800,8),(694,973400400,7),(694,986115600,5),(694,1004256000,3),(694,1018170000,5),(694,1035705600,3),(694,1049619600,5),(694,1067155200,3),(694,1081069200,5),(694,1099209600,3),(694,1112518800,5),(694,1130659200,3),(694,1143968400,5),(694,1162108800,3),(694,1173603600,5),(694,1194163200,3),(694,1205053200,5),(694,1225612800,3),(694,1236502800,5),(694,1257062400,3),(694,1268557200,5),(694,1289116800,3),(694,1300006800,5),(694,1320566400,3),(694,1331456400,5),(694,1352016000,3),(694,1362906000,5),(694,1383465600,3),(694,1394355600,5),(694,1414915200,3),(694,1425805200,5),(694,1446364800,3),(694,1457859600,5),(694,1478419200,3),(694,1489309200,5),(694,1509868800,3),(694,1520758800,5),(694,1541318400,3),(694,1552208400,5),(694,1572768000,3),(694,1583658000,5),(694,1604217600,3),(694,1615712400,5),(694,1636272000,3),(694,1647162000,5),(694,1667721600,3),(694,1678611600,5),(694,1699171200,3),(694,1710061200,5),(694,1730620800,3),(694,1741510800,5),(694,1762070400,3),(694,1772960400,5),(694,1793520000,3),(694,1805014800,5),(694,1825574400,3),(694,1836464400,5),(694,1857024000,3),(694,1867914000,5),(694,1888473600,3),(694,1899363600,5),(694,1919923200,3),(694,1930813200,5),(694,1951372800,3),(694,1962867600,5),(694,1983427200,3),(694,1994317200,5),(694,2014876800,3),(694,2025766800,5),(694,2046326400,3),(694,2057216400,5),(694,2077776000,3),(694,2088666000,5),(694,2109225600,3),(694,2120115600,5),(694,2140675200,3),(695,-2147483648,0),(695,-1767212492,2),(695,-1206954000,1),(695,-1191358800,2),(695,-1175371200,1),(695,-1159822800,2),(695,-633816000,1),(695,-622065600,2),(695,-602280000,1),(695,-591829200,2),(695,-570744000,1),(695,-560206800,2),(695,-539121600,1),(695,-531349200,2),(695,-191361600,1),(695,-184194000,2),(695,-155160000,1),(695,-150066000,2),(695,-128894400,1),(695,-121122000,2),(695,-99950400,1),(695,-89586000,2),(695,-68414400,1),(695,-57963600,2),(695,499752000,1),(695,511239600,2),(695,530596800,1),(695,540270000,2),(695,562132800,1),(695,571201200,2),(695,592977600,1),(695,602046000,2),(695,624427200,1),(695,634705200,2),(695,656481600,1),(695,666759600,2),(695,687931200,1),(695,697604400,2),(695,719985600,1),(695,728449200,2),(695,750830400,1),(695,761713200,2),(695,782280000,1),(695,793162800,2),(695,813729600,1),(695,824007600,2),(695,844574400,1),(695,856062000,2),(695,876110400,1),(695,888721200,2),(695,908078400,1),(695,919566000,2),(695,938923200,1),(695,951620400,2),(695,970977600,1),(695,982465200,2),(695,1003032000,1),(695,1013914800,2),(695,1036296000,1),(695,1045364400,2),(695,1066536000,1),(695,1076814000,2),(695,1099368000,1),(695,1108868400,2),(695,1129435200,1),(695,1140318000,2),(695,1162699200,1),(695,1172372400,2),(695,1192334400,1),(695,1203217200,2),(695,1224388800,1),(695,1234666800,2),(695,1255838400,1),(695,1266721200,2),(695,1287288000,1),(695,1298170800,2),(695,1318737600,1),(695,1330225200,2),(695,1350792000,1),(695,1361070000,2),(695,1382241600,1),(695,1392519600,2),(695,1413691200,1),(695,1424574000,2),(695,1445140800,1),(695,1456023600,2),(695,1476590400,1),(695,1487473200,2),(695,1508040000,1),(695,1518922800,2),(695,1541304000,1),(695,1550372400,2),(695,1572753600,1),(695,1581822000,2),(695,1604203200,1),(695,1613876400,2),(695,1636257600,1),(695,1645326000,2),(695,1667707200,1),(695,1677380400,2),(695,1699156800,1),(695,1708225200,2),(695,1730606400,1),(695,1739674800,2),(695,1762056000,1),(695,1771729200,2),(695,1793505600,1),(695,1803178800,2),(695,1825560000,1),(695,1834628400,2),(695,1857009600,1),(695,1866078000,2),(695,1888459200,1),(695,1897527600,2),(695,1919908800,1),(695,1928977200,2),(695,1951358400,1),(695,1960426800,2),(695,1983412800,1),(695,1992481200,2),(695,2014862400,1),(695,2024535600,2),(695,2046312000,1),(695,2055380400,2),(695,2077761600,1),(695,2086830000,2),(695,2109211200,1),(695,2118884400,2),(695,2140660800,1),(696,-2147483648,0),(696,-1514743200,1),(696,377935200,3),(696,828860400,2),(696,846396000,3),(696,860310000,2),(696,877845600,3),(696,891759600,2),(696,902037600,4),(696,909298800,1),(696,923212800,4),(696,941353200,1),(696,954662400,4),(696,972802800,1),(696,989136000,4),(696,1001833200,1),(696,1018166400,4),(696,1035702000,1),(696,1049616000,4),(696,1067151600,1),(696,1081065600,4),(696,1099206000,1),(696,1112515200,4),(696,1130655600,1),(696,1143964800,4),(696,1162105200,1),(696,1175414400,4),(696,1193554800,1),(696,1207468800,4),(696,1225004400,1),(696,1238918400,4),(696,1256454000,1),(696,1270368000,4),(696,1288508400,1),(696,1301817600,4),(696,1319958000,1),(696,1333267200,4),(696,1351407600,1),(696,1365321600,4),(696,1382857200,1),(696,1396771200,4),(696,1414306800,1),(696,1422777600,3),(697,-2147483648,1),(697,-1826739140,2),(697,-157750200,3),(697,1197183600,2),(697,1462086000,3),(697,2147483647,3),(698,-2147483648,1),(698,-1567453392,2),(698,-1233432000,3),(698,-1222981200,2),(698,-1205956800,3),(698,-1194037200,2),(698,-1172865600,3),(698,-1162501200,2),(698,-1141329600,3),(698,-1130965200,2),(698,-1109793600,3),(698,-1099429200,2),(698,-1078257600,3),(698,-1067806800,2),(698,-1046635200,3),(698,-1036270800,2),(698,-1015099200,3),(698,-1004734800,2),(698,-983563200,3),(698,-973198800,2),(698,-952027200,3),(698,-941576400,2),(698,-931032000,3),(698,-900882000,2),(698,-890337600,3),(698,-833749200,2),(698,-827265600,3),(698,-752274000,2),(698,-733780800,3),(698,-197326800,2),(698,-190843200,3),(698,-184194000,2),(698,-164491200,3),(698,-152658000,2),(698,-132955200,3),(698,-121122000,2),(698,-101419200,3),(698,-86821200,2),(698,-71092800,3),(698,-54766800,2),(698,-39038400,3),(698,-23317200,2),(698,-7588800,5),(698,128142000,4),(698,136605600,5),(698,596948400,4),(698,605066400,5),(698,624423600,4),(698,636516000,5),(698,656478000,4),(698,667965600,2),(698,687931200,4),(698,699415200,5),(698,719377200,4),(698,731469600,5),(698,938919600,3),(698,952052400,5),(698,1086058800,2),(698,1087704000,5),(698,1198983600,4),(698,1205632800,5),(698,2147483647,5),(699,-2147483648,0),(699,-1846269040,1),(699,-71092800,2),(699,2147483647,2),(700,-2147483648,1),(700,-1946918424,2),(701,-2147483648,2),(701,-1633276800,1),(701,-1615136400,2),(701,-1601827200,1),(701,-1583686800,2),(701,-1563724800,1),(701,-1551632400,2),(701,-1538928000,1),(701,-1520182800,2),(701,-1504454400,1),(701,-1491757200,2),(701,-1473004800,1),(701,-1459702800,2),(701,-1441555200,1),(701,-1428253200,2),(701,-1410105600,1),(701,-1396803600,2),(701,-1378656000,1),(701,-1365354000,2),(701,-1347206400,1),(701,-1333904400,2),(701,-1315152000,1),(701,-1301850000,2),(701,-1283702400,1),(701,-1270400400,2),(701,-1252252800,1),(701,-1238950800,2),(701,-1220803200,1),(701,-1207501200,2),(701,-1189353600,1),(701,-1176051600,2),(701,-1157299200,1),(701,-1144602000,2),(701,-1125849600,1),(701,-1112547600,2),(701,-1094400000,1),(701,-1081098000,2),(701,-1067788800,3),(701,-1045414800,2),(701,-1031500800,1),(701,-1018198800,2),(701,-1000051200,1),(701,-986749200,2),(701,-967996800,1),(701,-955299600,2),(701,-936547200,1),(701,-923245200,2),(701,-905097600,1),(701,-891795600,2),(701,-880214400,4),(701,-769395600,5),(701,-765392400,2),(701,-747244800,1),(701,-733942800,2),(701,-715795200,1),(701,-702493200,2),(701,-684345600,1),(701,-671043600,2),(701,-652896000,1),(701,-639594000,2),(701,-620841600,1),(701,-608144400,2),(701,-589392000,1),(701,-576090000,2),(701,-557942400,1),(701,-544640400,2),(701,-526492800,1),(701,-513190800,2),(701,-495043200,1),(701,-481741200,2),(701,-463593600,1),(701,-447267600,2),(701,-431539200,1),(701,-415818000,2),(701,-400089600,1),(701,-384368400,2),(701,-368640000,1),(701,-352918800,2),(701,-337190400,1),(701,-321469200,2),(701,-305740800,1),(701,-289414800,2),(701,-273686400,1),(701,-257965200,2),(701,-242236800,1),(701,-226515600,2),(701,-210787200,1),(701,-195066000,2),(701,-179337600,1),(701,-163616400,2),(701,-147888000,1),(701,-131562000,2),(701,-116438400,1),(701,-100112400,2),(701,-84384000,1),(701,-68662800,2),(701,-52934400,1),(701,-37213200,2),(701,-21484800,1),(701,-5763600,2),(701,9964800,1),(701,25686000,2),(701,41414400,1),(701,57740400,2),(701,73468800,1),(701,89190000,2),(701,104918400,1),(701,120639600,2),(701,126691200,1),(701,152089200,2),(701,162374400,1),(701,183538800,2),(701,199267200,1),(701,215593200,2),(701,230716800,1),(701,247042800,2),(701,262771200,1),(701,278492400,2),(701,294220800,1),(701,309942000,2),(701,325670400,1),(701,341391600,2),(701,357120000,1),(701,372841200,2),(701,388569600,1),(701,404895600,2),(701,420019200,1),(701,436345200,2),(701,452073600,1),(701,467794800,2),(701,483523200,1),(701,499244400,2),(701,514972800,1),(701,530694000,2),(701,544608000,1),(701,562143600,2),(701,576057600,1),(701,594198000,2),(701,607507200,1),(701,625647600,2),(701,638956800,1),(701,657097200,2),(701,671011200,1),(701,688546800,2),(701,702460800,1),(701,719996400,2),(701,733910400,1),(701,752050800,2),(701,765360000,1),(701,783500400,2),(701,796809600,1),(701,814950000,2),(701,828864000,1),(701,846399600,2),(701,860313600,1),(701,877849200,2),(701,891763200,1),(701,909298800,2),(701,923212800,1),(701,941353200,2),(701,954662400,1),(701,972802800,2),(701,986112000,1),(701,1004252400,2),(701,1018166400,1),(701,1035702000,2),(701,1049616000,1),(701,1067151600,2),(701,1081065600,1),(701,1099206000,2),(701,1112515200,1),(701,1130655600,2),(701,1143964800,1),(701,1162105200,2),(701,1173600000,1),(701,1194159600,2),(701,1205049600,1),(701,1225609200,2),(701,1236499200,1),(701,1257058800,2),(701,1268553600,1),(701,1289113200,2),(701,1300003200,1),(701,1320562800,2),(701,1331452800,1),(701,1352012400,2),(701,1362902400,1),(701,1383462000,2),(701,1394352000,1),(701,1414911600,2),(701,1425801600,1),(701,1446361200,2),(701,1457856000,1),(701,1478415600,2),(701,1489305600,1),(701,1509865200,2),(701,1520755200,1),(701,1541314800,2),(701,1552204800,1),(701,1572764400,2),(701,1583654400,1),(701,1604214000,2),(701,1615708800,1),(701,1636268400,2),(701,1647158400,1),(701,1667718000,2),(701,1678608000,1),(701,1699167600,2),(701,1710057600,1),(701,1730617200,2),(701,1741507200,1),(701,1762066800,2),(701,1772956800,1),(701,1793516400,2),(701,1805011200,1),(701,1825570800,2),(701,1836460800,1),(701,1857020400,2),(701,1867910400,1),(701,1888470000,2),(701,1899360000,1),(701,1919919600,2),(701,1930809600,1),(701,1951369200,2),(701,1962864000,1),(701,1983423600,2),(701,1994313600,1),(701,2014873200,2),(701,2025763200,1),(701,2046322800,2),(701,2057212800,1),(701,2077772400,2),(701,2088662400,1),(701,2109222000,2),(701,2120112000,1),(701,2140671600,2),(702,-2147483648,0),(702,-1514739600,1),(702,-1343066400,2),(702,-1234807200,1),(702,-1220292000,2),(702,-1207159200,1),(702,-1191344400,2),(702,828864000,3),(702,846399600,2),(702,860313600,3),(702,877849200,2),(702,891766800,4),(702,909302400,1),(702,923216400,4),(702,941356800,1),(702,954666000,4),(702,972806400,1),(702,989139600,4),(702,1001836800,1),(702,1018170000,4),(702,1035705600,1),(702,1049619600,4),(702,1067155200,1),(702,1081069200,4),(702,1099209600,1),(702,1112518800,4),(702,1130659200,1),(702,1143968400,4),(702,1162108800,1),(702,1175418000,4),(702,1193558400,1),(702,1207472400,4),(702,1225008000,1),(702,1238922000,4),(702,1256457600,1),(702,1270371600,4),(702,1288512000,1),(702,1301821200,4),(702,1319961600,1),(702,1333270800,4),(702,1351411200,1),(702,1365325200,4),(702,1382860800,1),(702,1396774800,4),(702,1414310400,1),(702,1428224400,4),(702,1445760000,1),(702,1459674000,4),(702,1477814400,1),(702,1491123600,4),(702,1509264000,1),(702,1522573200,4),(702,1540713600,1),(702,1554627600,4),(702,1572163200,1),(702,1586077200,4),(702,1603612800,1),(702,1617526800,4),(702,1635667200,1),(702,1648976400,4),(702,1667116800,1),(702,1680426000,4),(702,1698566400,1),(702,1712480400,4),(702,1730016000,1),(702,1743930000,4),(702,1761465600,1),(702,1775379600,4),(702,1792915200,1),(702,1806829200,4),(702,1824969600,1),(702,1838278800,4),(702,1856419200,1),(702,1869728400,4),(702,1887868800,1),(702,1901782800,4),(702,1919318400,1),(702,1933232400,4),(702,1950768000,1),(702,1964682000,4),(702,1982822400,1),(702,1996131600,4),(702,2014272000,1),(702,2027581200,4),(702,2045721600,1),(702,2059030800,4),(702,2077171200,1),(702,2091085200,4),(702,2108620800,1),(702,2122534800,4),(702,2140070400,1),(703,-2147483648,2),(703,-1632067200,1),(703,-1615136400,2),(703,-923248800,1),(703,-880214400,3),(703,-769395600,4),(703,-765392400,5),(704,-2147483648,1),(704,-1567453392,2),(704,-1233432000,3),(704,-1222981200,2),(704,-1205956800,3),(704,-1194037200,2),(704,-1172865600,3),(704,-1162501200,2),(704,-1141329600,3),(704,-1130965200,2),(704,-1109793600,3),(704,-1099429200,2),(704,-1078257600,3),(704,-1067806800,2),(704,-1046635200,3),(704,-1036270800,2),(704,-1015099200,3),(704,-1004734800,2),(704,-983563200,3),(704,-973198800,2),(704,-952027200,3),(704,-941576400,2),(704,-931032000,3),(704,-900882000,2),(704,-890337600,3),(704,-833749200,2),(704,-827265600,3),(704,-752274000,2),(704,-733780800,3),(704,-197326800,2),(704,-190843200,3),(704,-184194000,2),(704,-164491200,3),(704,-152658000,2),(704,-132955200,3),(704,-121122000,2),(704,-101419200,3),(704,-86821200,2),(704,-71092800,3),(704,-54766800,2),(704,-39038400,3),(704,-23317200,2),(704,-7588800,5),(704,128142000,4),(704,136605600,5),(704,596948400,4),(704,605066400,5),(704,624423600,4),(704,636516000,5),(704,656478000,4),(704,667965600,2),(704,687931200,4),(704,699415200,5),(704,719377200,4),(704,731469600,5),(704,938919600,3),(704,952052400,5),(704,1198983600,4),(704,1205632800,5),(704,1224385200,4),(704,1237082400,5),(704,2147483647,5),(705,-2147483648,1),(705,-1545071027,3),(705,288770400,2),(705,297234000,3),(705,320220000,2),(705,328683600,3),(705,664264800,2),(705,678344400,3),(705,695714400,2),(705,700635600,3),(706,-2147483648,1),(706,-1680454800,2),(706,-1627833600,1),(707,-2147483648,0),(707,-1767212140,2),(707,-1206954000,1),(707,-1191358800,2),(707,-1175371200,1),(707,-1159822800,2),(707,-633816000,1),(707,-622065600,2),(707,-602280000,1),(707,-591829200,2),(707,-570744000,1),(707,-560206800,2),(707,-539121600,1),(707,-531349200,2),(707,-191361600,1),(707,-184194000,2),(707,-155160000,1),(707,-150066000,2),(707,-128894400,1),(707,-121122000,2),(707,-99950400,1),(707,-89586000,2),(707,-68414400,1),(707,-57963600,2),(707,499752000,1),(707,511239600,2),(707,530596800,1),(707,540270000,2),(707,562132800,1),(707,571201200,2),(707,592977600,1),(707,602046000,2),(707,624427200,1),(707,634705200,2),(707,656481600,1),(707,666759600,2),(707,687931200,1),(707,697604400,2),(707,719985600,1),(707,728449200,2),(707,750830400,1),(707,761713200,2),(707,782280000,1),(707,793162800,2),(707,813729600,1),(707,824007600,2),(707,844574400,1),(707,856062000,2),(707,876110400,1),(707,888721200,2),(707,908078400,1),(707,919566000,2),(707,938923200,1),(707,951620400,2),(707,970977600,1),(707,982465200,2),(707,1003032000,1),(707,1013914800,2),(707,1036296000,1),(707,1045364400,2),(707,1099368000,1),(707,1108868400,2),(707,1129435200,1),(707,1140318000,2),(707,1162699200,1),(707,1172372400,2),(707,1192334400,1),(707,1203217200,2),(707,1224388800,1),(707,1234666800,2),(707,1255838400,1),(707,1266721200,2),(707,1287288000,1),(707,1298170800,2),(707,1318737600,1),(707,1330225200,2),(707,1350792000,1),(707,1361070000,2),(707,1382241600,1),(707,1392519600,2),(707,1413691200,1),(707,1424574000,2),(707,1445140800,1),(707,1456023600,2),(707,1476590400,1),(707,1487473200,2),(707,1508040000,1),(707,1518922800,2),(707,1541304000,1),(707,1550372400,2),(707,1572753600,1),(707,1581822000,2),(707,1604203200,1),(707,1613876400,2),(707,1636257600,1),(707,1645326000,2),(707,1667707200,1),(707,1677380400,2),(707,1699156800,1),(707,1708225200,2),(707,1730606400,1),(707,1739674800,2),(707,1762056000,1),(707,1771729200,2),(707,1793505600,1),(707,1803178800,2),(707,1825560000,1),(707,1834628400,2),(707,1857009600,1),(707,1866078000,2),(707,1888459200,1),(707,1897527600,2),(707,1919908800,1),(707,1928977200,2),(707,1951358400,1),(707,1960426800,2),(707,1983412800,1),(707,1992481200,2),(707,2014862400,1),(707,2024535600,2),(707,2046312000,1),(707,2055380400,2),(707,2077761600,1),(707,2086830000,2),(707,2109211200,1),(707,2118884400,2),(707,2140660800,1),(708,-2147483648,0),(708,-1826738653,1),(708,-157750200,2),(709,-2147483648,0),(709,-1686091520,1),(709,323845200,4),(709,338950800,2),(709,354675600,3),(709,370400400,2),(709,386125200,3),(709,401850000,2),(709,417574800,3),(709,433299600,2),(709,449024400,3),(709,465354000,2),(709,481078800,3),(709,496803600,2),(709,512528400,3),(709,528253200,2),(709,543978000,3),(709,559702800,2),(709,575427600,3),(709,591152400,2),(709,606877200,3),(709,622602000,2),(709,638326800,3),(709,654656400,2),(709,670381200,3),(709,686106000,2),(709,701830800,3),(709,717555600,2),(709,733280400,3),(709,749005200,2),(709,764730000,3),(709,780454800,2),(709,796179600,3),(709,811904400,2),(709,820465200,5),(710,-2147483648,2),(710,-1632056400,1),(710,-1615125600,2),(710,-1596978000,1),(710,-1583164800,2),(710,-880203600,3),(710,-769395600,4),(710,-765381600,2),(710,-147884400,5),(710,-131554800,2),(710,120646800,6),(710,325677600,7),(710,341398800,6),(710,357127200,7),(710,372848400,6),(710,388576800,7),(710,404902800,6),(710,420026400,7),(710,436352400,6),(710,452080800,7),(710,467802000,6),(710,483530400,7),(710,499251600,6),(710,514980000,7),(710,530701200,6),(710,544615200,7),(710,562150800,6),(710,576064800,7),(710,594205200,6),(710,607514400,7),(710,625654800,6),(710,638964000,7),(710,657104400,6),(710,671018400,7),(710,688554000,6),(710,702468000,7),(710,720003600,6),(710,733917600,7),(710,752058000,6),(710,765367200,7),(710,783507600,6),(710,796816800,7),(710,814957200,6),(710,828871200,7),(710,846406800,6),(710,860320800,7),(710,877856400,6),(710,891770400,7),(710,909306000,6),(710,923220000,7),(710,941360400,6),(710,954669600,7),(710,972810000,6),(710,986119200,7),(710,1004259600,6),(710,1018173600,7),(710,1035709200,6),(710,1049623200,7),(710,1067158800,6),(710,1081072800,7),(710,1099213200,6),(710,1112522400,7),(710,1130662800,6),(710,1143972000,7),(710,1162112400,6),(710,1173607200,7),(710,1194166800,6),(710,1205056800,7),(710,1225616400,6),(710,1236506400,7),(710,1257066000,6),(710,1268560800,7),(710,1289120400,6),(710,1300010400,7),(710,1320570000,6),(710,1331460000,7),(710,1352019600,6),(710,1362909600,7),(710,1383469200,6),(710,1394359200,7),(710,1414918800,6),(710,1425808800,7),(710,1446368400,6),(710,1457863200,7),(710,1478422800,6),(710,1489312800,7),(710,1509872400,6),(710,1520762400,7),(710,1541322000,6),(710,1552212000,7),(710,1572771600,6),(710,1583661600,7),(710,1604221200,6),(710,1615716000,7),(710,1636275600,6),(710,1647165600,7),(710,1667725200,6),(710,1678615200,7),(710,1699174800,6),(710,1710064800,7),(710,1730624400,6),(710,1741514400,7),(710,1762074000,6),(710,1772964000,7),(710,1793523600,6),(710,1805018400,7),(710,1825578000,6),(710,1836468000,7),(710,1857027600,6),(710,1867917600,7),(710,1888477200,6),(710,1899367200,7),(710,1919926800,6),(710,1930816800,7),(710,1951376400,6),(710,1962871200,7),(710,1983430800,6),(710,1994320800,7),(710,2014880400,6),(710,2025770400,7),(710,2046330000,6),(710,2057220000,7),(710,2077779600,6),(710,2088669600,7),(710,2109229200,6),(710,2120119200,7),(710,2140678800,6),(711,-2147483648,2),(711,-1632060000,1),(711,-1615129200,2),(711,-880207200,3),(711,-769395600,4),(711,-765385200,2),(711,-715788000,1),(711,-702486000,2),(711,-684338400,1),(711,-671036400,2),(711,-652888800,1),(711,-639586800,2),(711,-620834400,1),(711,-608137200,2),(711,-589384800,1),(711,-576082800,2),(711,-557935200,1),(711,-544633200,2),(711,-526485600,1),(711,-513183600,2),(711,-495036000,1),(711,-481734000,2),(711,-463586400,1),(711,-450284400,2),(711,-431532000,1),(711,-418230000,2),(711,-400082400,1),(711,-386780400,2),(711,-368632800,1),(711,-355330800,2),(711,-337183200,1),(711,-323881200,2),(711,-305733600,1),(711,-292431600,2),(711,-273679200,1),(711,-260982000,2),(711,-242229600,1),(711,-226508400,2),(711,-210780000,1),(711,-195058800,2),(711,-179330400,1),(711,-163609200,2),(711,-147880800,1),(711,-131554800,2),(711,-116431200,1),(711,-100105200,2),(711,-84376800,1),(711,-68655600,2),(711,-52927200,1),(711,-37206000,2),(711,-21477600,1),(711,-5756400,2),(711,9972000,1),(711,25693200,2),(711,41421600,1),(711,57747600,2),(711,73476000,1),(711,84013200,5),(712,-2147483648,2),(712,-1633273200,1),(712,-1615132800,2),(712,-1601823600,1),(712,-1583683200,2),(712,-1570374000,1),(712,-1551628800,2),(712,-1538924400,1),(712,-1534089600,2),(712,-880210800,3),(712,-769395600,4),(712,-765388800,2),(712,-147884400,1),(712,-131558400,2),(712,-116434800,1),(712,-100108800,2),(712,-84380400,1),(712,-68659200,2),(712,-52930800,1),(712,-37209600,2),(712,-21481200,1),(712,-5760000,2),(712,9968400,1),(712,25689600,2),(712,41418000,1),(712,57744000,2),(712,73472400,1),(712,89193600,2),(712,104922000,1),(712,120643200,2),(712,126694800,1),(712,152092800,2),(712,162378000,1),(712,183542400,2),(712,199270800,1),(712,215596800,2),(712,230720400,1),(712,247046400,2),(712,262774800,1),(712,278496000,2),(712,294224400,1),(712,309945600,2),(712,325674000,1),(712,341395200,2),(712,357123600,1),(712,372844800,2),(712,388573200,1),(712,404899200,2),(712,420022800,1),(712,436348800,2),(712,452077200,1),(712,467798400,2),(712,483526800,1),(712,499248000,2),(712,514976400,1),(712,530697600,2),(712,544611600,1),(712,562147200,2),(712,576061200,1),(712,594201600,2),(712,607510800,1),(712,625651200,2),(712,638960400,1),(712,657100800,2),(712,671014800,1),(712,688550400,2),(712,702464400,1),(712,720000000,2),(712,733914000,1),(712,752054400,2),(712,765363600,1),(712,783504000,2),(712,796813200,1),(712,814953600,2),(712,828867600,1),(712,846403200,2),(712,860317200,1),(712,877852800,2),(712,891766800,1),(712,909302400,2),(712,923216400,1),(712,941356800,2),(712,954666000,1),(712,972806400,2),(712,986115600,1),(712,1004256000,2),(712,1018170000,1),(712,1035705600,2),(712,1049619600,1),(712,1067155200,2),(712,1081069200,1),(712,1099209600,2),(712,1112518800,1),(712,1130659200,2),(712,1143968400,1),(712,1162108800,2),(712,1173603600,1),(712,1194163200,2),(712,1205053200,1),(712,1225612800,2),(712,1236502800,1),(712,1257062400,2),(712,1268557200,1),(712,1289116800,2),(712,1300006800,1),(712,1320566400,2),(712,1331456400,1),(712,1352016000,2),(712,1362906000,1),(712,1383465600,2),(712,1394355600,1),(712,1414915200,2),(712,1425805200,1),(712,1446364800,2),(712,1457859600,1),(712,1478419200,2),(712,1489309200,1),(712,1509868800,2),(712,1520758800,1),(712,1541318400,2),(712,1552208400,1),(712,1572768000,2),(712,1583658000,1),(712,1604217600,2),(712,1615712400,1),(712,1636272000,2),(712,1647162000,1),(712,1667721600,2),(712,1678611600,1),(712,1699171200,2),(712,1710061200,1),(712,1730620800,2),(712,1741510800,1),(712,1762070400,2),(712,1772960400,1),(712,1793520000,2),(712,1805014800,1),(712,1825574400,2),(712,1836464400,1),(712,1857024000,2),(712,1867914000,1),(712,1888473600,2),(712,1899363600,1),(712,1919923200,2),(712,1930813200,1),(712,1951372800,2),(712,1962867600,1),(712,1983427200,2),(712,1994317200,1),(712,2014876800,2),(712,2025766800,1),(712,2046326400,2),(712,2057216400,1),(712,2077776000,2),(712,2088666000,1),(712,2109225600,2),(712,2120115600,1),(712,2140675200,2),(713,-2147483648,0),(713,-2051202469,1),(713,-1724083200,2),(713,-880218000,3),(713,-769395600,4),(713,-765396000,2),(713,-684349200,5),(713,-671047200,2),(713,104914800,5),(713,120636000,2),(713,126687600,5),(713,152085600,2),(713,167814000,5),(713,183535200,2),(713,199263600,5),(713,215589600,2),(713,230713200,5),(713,247039200,2),(713,262767600,5),(713,278488800,2),(713,294217200,5),(713,309938400,2),(713,325666800,5),(713,341388000,2),(713,357116400,5),(713,372837600,2),(713,388566000,5),(713,404892000,2),(713,420015600,5),(713,436341600,2),(713,452070000,5),(713,467791200,2),(713,483519600,5),(713,499240800,2),(713,514969200,5),(713,530690400,2),(713,544604400,5),(713,562140000,2),(713,576054000,5),(713,594194400,2),(713,607503600,5),(713,625644000,2),(713,638953200,5),(713,657093600,2),(713,671007600,5),(713,688543200,2),(713,702457200,5),(713,719992800,2),(713,733906800,5),(713,752047200,2),(713,765356400,5),(713,783496800,2),(713,796806000,5),(713,814946400,2),(713,828860400,5),(713,846396000,2),(713,860310000,5),(713,877845600,2),(713,891759600,5),(713,909295200,2),(713,923209200,5),(713,941349600,2),(713,954658800,5),(713,972799200,2),(713,986108400,5),(713,1004248800,2),(713,1018162800,5),(713,1035698400,2),(713,1049612400,5),(713,1067148000,2),(713,1081062000,5),(713,1099202400,2),(713,1112511600,5),(713,1130652000,2),(713,1143961200,5),(713,1162101600,2),(713,1173596400,5),(713,1194156000,2),(713,1205046000,5),(713,1225605600,2),(713,1236495600,5),(713,1257055200,2),(713,1268550000,5),(713,1289109600,2),(713,1299999600,5),(713,1320559200,2),(713,1331449200,5),(713,1352008800,2),(713,1362898800,5),(713,1383458400,2),(713,1394348400,5),(713,1414908000,2),(713,1425798000,5),(713,1446357600,2),(713,1457852400,5),(713,1478412000,2),(713,1489302000,5),(713,1509861600,2),(713,1520751600,5),(713,1541311200,2),(713,1552201200,5),(713,1572760800,2),(713,1583650800,5),(713,1604210400,2),(713,1615705200,5),(713,1636264800,2),(713,1647154800,5),(713,1667714400,2),(713,1678604400,5),(713,1699164000,2),(713,1710054000,5),(713,1730613600,2),(713,1741503600,5),(713,1762063200,2),(713,1772953200,5),(713,1793512800,2),(713,1805007600,5),(713,1825567200,2),(713,1836457200,5),(713,1857016800,2),(713,1867906800,5),(713,1888466400,2),(713,1899356400,5),(713,1919916000,2),(713,1930806000,5),(713,1951365600,2),(713,1962860400,5),(713,1983420000,2),(713,1994310000,5),(713,2014869600,2),(713,2025759600,5),(713,2046319200,2),(713,2057209200,5),(713,2077768800,2),(713,2088658800,5),(713,2109218400,2),(713,2120108400,5),(713,2140668000,2),(714,-2147483648,0),(714,-1825098836,1),(715,-2147483648,0),(715,-1998663968,2),(715,-1632063600,1),(715,-1615132800,2),(715,-1600614000,1),(715,-1596816000,2),(715,-1567954800,1),(715,-1551628800,2),(715,-1536505200,1),(715,-1523203200,2),(715,-1504450800,1),(715,-1491753600,2),(715,-1473001200,1),(715,-1459699200,2),(715,-880210800,3),(715,-769395600,4),(715,-765388800,2),(715,-715791600,1),(715,-702489600,2),(715,-84380400,1),(715,-68659200,2),(715,-21481200,1),(715,-5760000,2),(715,73472400,1),(715,89193600,2),(715,104922000,1),(715,120643200,2),(715,136371600,1),(715,152092800,2),(715,167821200,1),(715,183542400,2),(715,199270800,1),(715,215596800,2),(715,230720400,1),(715,247046400,2),(715,262774800,1),(715,278496000,2),(715,294224400,1),(715,309945600,2),(715,325674000,1),(715,341395200,2),(715,357123600,1),(715,372844800,2),(715,388573200,1),(715,404899200,2),(715,420022800,1),(715,436348800,2),(715,452077200,1),(715,467798400,2),(715,483526800,1),(715,499248000,2),(715,514976400,1),(715,530697600,2),(715,544611600,1),(715,562147200,2),(715,576061200,1),(715,594201600,2),(715,607510800,1),(715,625651200,2),(715,638960400,1),(715,657100800,2),(715,671014800,1),(715,688550400,2),(715,702464400,1),(715,720000000,2),(715,733914000,1),(715,752054400,2),(715,765363600,1),(715,783504000,2),(715,796813200,1),(715,814953600,2),(715,828867600,1),(715,846403200,2),(715,860317200,1),(715,877852800,2),(715,891766800,1),(715,909302400,2),(715,923216400,1),(715,941356800,2),(715,954666000,1),(715,972806400,2),(715,986115600,1),(715,1004256000,2),(715,1018170000,1),(715,1035705600,2),(715,1049619600,1),(715,1067155200,2),(715,1081069200,1),(715,1099209600,2),(715,1112518800,1),(715,1130659200,2),(715,1143968400,1),(715,1162108800,2),(715,1173603600,1),(715,1194163200,2),(715,1205053200,1),(715,1225612800,2),(715,1236502800,1),(715,1257062400,2),(715,1268557200,1),(715,1289116800,2),(715,1300006800,1),(715,1320566400,2),(715,1331456400,1),(715,1352016000,2),(715,1362906000,1),(715,1383465600,2),(715,1394355600,1),(715,1414915200,2),(715,1425805200,1),(715,1446364800,2),(715,1457859600,1),(715,1478419200,2),(715,1489309200,1),(715,1509868800,2),(715,1520758800,1),(715,1541318400,2),(715,1552208400,1),(715,1572768000,2),(715,1583658000,1),(715,1604217600,2),(715,1615712400,1),(715,1636272000,2),(715,1647162000,1),(715,1667721600,2),(715,1678611600,1),(715,1699171200,2),(715,1710061200,1),(715,1730620800,2),(715,1741510800,1),(715,1762070400,2),(715,1772960400,1),(715,1793520000,2),(715,1805014800,1),(715,1825574400,2),(715,1836464400,1),(715,1857024000,2),(715,1867914000,1),(715,1888473600,2),(715,1899363600,1),(715,1919923200,2),(715,1930813200,1),(715,1951372800,2),(715,1962867600,1),(715,1983427200,2),(715,1994317200,1),(715,2014876800,2),(715,2025766800,1),(715,2046326400,2),(715,2057216400,1),(715,2077776000,2),(715,2088666000,1),(715,2109225600,2),(715,2120115600,1),(715,2140675200,2),(716,-2147483648,0),(716,-1767208832,2),(716,-1206950400,1),(716,-1191355200,2),(716,-1175367600,1),(716,-1159819200,2),(716,-633812400,1),(716,-622062000,2),(716,-602276400,1),(716,-591825600,2),(716,-570740400,1),(716,-560203200,2),(716,-539118000,1),(716,-531345600,2),(716,-191358000,1),(716,-184190400,2),(716,-155156400,1),(716,-150062400,2),(716,-128890800,1),(716,-121118400,2),(716,-99946800,1),(716,-89582400,2),(716,-68410800,1),(716,-57960000,2),(716,499755600,1),(716,511243200,2),(716,530600400,1),(716,540273600,2),(716,562136400,1),(716,571204800,2),(716,750834000,1),(716,761716800,2),(716,1214283600,3),(716,1384056000,2),(716,2147483647,2),(717,-2147483648,0),(717,-1546279392,2),(717,547020000,1),(717,559717200,2),(717,578469600,1),(717,591166800,2),(718,-2147483648,0),(718,-1514736000,1),(718,-1451667600,2),(718,-1343062800,1),(718,-1234803600,2),(718,-1222963200,3),(718,-1207242000,2),(718,-873820800,4),(718,-769395600,5),(718,-761677200,2),(718,-686073600,3),(718,-661539600,2),(718,-495039600,3),(718,-481734000,2),(718,-463590000,3),(718,-450284400,2),(718,-431535600,3),(718,-418230000,2),(718,-400086000,3),(718,-386780400,2),(718,-368636400,3),(718,-355330800,2),(718,-337186800,3),(718,-323881200,2),(718,-305737200,3),(718,-292431600,2),(718,199274400,3),(718,215600400,2),(718,230724000,3),(718,247050000,2),(718,262778400,3),(718,278499600,2),(718,294228000,3),(718,309949200,2),(718,325677600,3),(718,341398800,2),(718,357127200,3),(718,372848400,2),(718,388576800,3),(718,404902800,2),(718,420026400,3),(718,436352400,2),(718,452080800,3),(718,467802000,2),(718,483530400,3),(718,499251600,2),(718,514980000,3),(718,530701200,2),(718,544615200,3),(718,562150800,2),(718,576064800,3),(718,594205200,2),(718,607514400,3),(718,625654800,2),(718,638964000,3),(718,657104400,2),(718,671018400,3),(718,688554000,2),(718,702468000,3),(718,720003600,2),(718,733917600,3),(718,752058000,2),(718,765367200,3),(718,783507600,2),(718,796816800,3),(718,814957200,2),(718,828871200,3),(718,846406800,2),(718,860320800,3),(718,877856400,2),(718,891770400,3),(718,909306000,2),(718,923220000,3),(718,941360400,2),(718,954669600,3),(718,972810000,2),(718,986119200,3),(718,1004259600,2),(718,1018173600,3),(718,1035709200,2),(718,1049623200,3),(718,1067158800,2),(718,1081072800,3),(718,1099213200,2),(718,1112522400,3),(718,1130662800,2),(718,1143972000,3),(718,1162112400,2),(718,1175421600,3),(718,1193562000,2),(718,1207476000,3),(718,1225011600,2),(718,1238925600,3),(718,1256461200,2),(718,1268560800,3),(718,1289120400,2),(718,1300010400,3),(718,1320570000,2),(718,1331460000,3),(718,1352019600,2),(718,1362909600,3),(718,1383469200,2),(718,1394359200,3),(718,1414918800,2),(718,1425808800,3),(718,1446368400,2),(718,1457863200,3),(718,1478422800,2),(718,1489312800,3),(718,1509872400,2),(718,1520762400,3),(718,1541322000,2),(718,1552212000,3),(718,1572771600,2),(718,1583661600,3),(718,1604221200,2),(718,1615716000,3),(718,1636275600,2),(718,1647165600,3),(718,1667725200,2),(718,1678615200,3),(718,1699174800,2),(718,1710064800,3),(718,1730624400,2),(718,1741514400,3),(718,1762074000,2),(718,1772964000,3),(718,1793523600,2),(718,1805018400,3),(718,1825578000,2),(718,1836468000,3),(718,1857027600,2),(718,1867917600,3),(718,1888477200,2),(718,1899367200,3),(718,1919926800,2),(718,1930816800,3),(718,1951376400,2),(718,1962871200,3),(718,1983430800,2),(718,1994320800,3),(718,2014880400,2),(718,2025770400,3),(718,2046330000,2),(718,2057220000,3),(718,2077779600,2),(718,2088669600,3),(718,2109229200,2),(718,2120119200,3),(718,2140678800,2),(719,-2147483648,2),(719,-1632060000,1),(719,-1615129200,2),(719,-880207200,3),(719,-769395600,4),(719,-765385200,2),(719,-715788000,1),(719,-702486000,2),(719,-684338400,1),(719,-671036400,2),(719,-652888800,1),(719,-639586800,2),(719,-620834400,1),(719,-608137200,2),(719,-589384800,1),(719,-576082800,2),(719,-557935200,1),(719,-544633200,2),(719,-526485600,1),(719,-513183600,2),(719,-495036000,1),(719,-481734000,2),(719,-463586400,1),(719,-450284400,2),(719,-431532000,1),(719,-418230000,2),(719,-400082400,1),(719,-386780400,2),(719,-368632800,1),(719,-355330800,2),(719,-337183200,1),(719,-323881200,2),(719,-305733600,1),(719,-292431600,2),(719,-273679200,1),(719,-260982000,2),(719,-242229600,1),(719,-226508400,2),(719,-210780000,1),(719,-195058800,2),(719,-179330400,1),(719,-163609200,2),(719,-147880800,1),(719,-131554800,2),(719,-116431200,1),(719,-100105200,2),(719,-84376800,1),(719,-68655600,2),(719,-52927200,1),(719,-37206000,2),(719,-21477600,1),(719,-5756400,2),(719,9972000,1),(719,25693200,2),(719,41421600,1),(719,57747600,2),(719,73476000,1),(719,89197200,2),(719,104925600,1),(719,120646800,2),(719,136375200,1),(719,152096400,2),(719,167824800,1),(719,183546000,2),(719,199274400,1),(719,215600400,2),(719,230724000,1),(719,247050000,2),(719,262778400,1),(719,278499600,2),(719,294228000,1),(719,309949200,2),(719,325677600,1),(719,341398800,2),(719,357127200,1),(719,372848400,2),(719,388576800,1),(719,404902800,2),(719,420026400,1),(719,436352400,2),(719,452080800,1),(719,467802000,2),(719,483530400,1),(719,499251600,2),(719,514980000,1),(719,530701200,2),(719,544615200,1),(719,562150800,2),(719,576064800,1),(719,594205200,2),(719,607514400,1),(719,625654800,2),(719,638964000,1),(719,657104400,2),(719,671018400,1),(719,688554000,2),(719,702468000,1),(719,720003600,2),(719,733917600,1),(719,752058000,2),(719,765367200,1),(719,783507600,2),(719,796816800,1),(719,814957200,2),(719,828871200,1),(719,846406800,2),(719,860320800,1),(719,877856400,2),(719,891770400,1),(719,909306000,2),(719,923220000,1),(719,941360400,2),(719,954669600,1),(719,972810000,2),(719,986119200,1),(719,1004259600,2),(719,1018173600,1),(719,1035709200,2),(719,1049623200,1),(719,1067158800,2),(719,1081072800,1),(719,1099213200,2),(719,1112522400,1),(719,1130662800,2),(719,1143972000,1),(719,1162112400,2),(719,1173607200,1),(719,1194166800,2),(719,1205056800,1),(719,1225616400,2),(719,1236506400,1),(719,1257066000,2),(719,1268560800,1),(719,1289120400,2),(719,1300010400,1),(719,1320570000,2),(719,1331460000,1),(719,1352019600,2),(719,1362909600,1),(719,1383469200,2),(719,1394359200,1),(719,1414918800,2),(719,1425808800,5),(720,-2147483648,2),(720,-1633276800,1),(720,-1615136400,2),(720,-1601827200,1),(720,-1583686800,2),(720,-900259200,1),(720,-891795600,2),(720,-880214400,3),(720,-769395600,4),(720,-765392400,2),(720,-747244800,1),(720,-733942800,2),(720,-715795200,1),(720,-702493200,2),(720,-684345600,1),(720,-671043600,2),(720,-652896000,1),(720,-639594000,2),(720,-620841600,1),(720,-608144400,2),(720,-589392000,1),(720,-576090000,2),(720,-557942400,1),(720,-544640400,2),(720,-526492800,1),(720,-513190800,2),(720,-495043200,1),(720,-481741200,2),(720,-463593600,5),(720,-386787600,2),(720,-368640000,5),(720,-21488400,6),(720,-5767200,5),(720,9961200,6),(720,25682400,5),(720,1143961200,6),(720,1162101600,5),(720,1173596400,6),(720,1194156000,5),(720,1205046000,6),(720,1225605600,5),(720,1236495600,6),(720,1257055200,5),(720,1268550000,6),(720,1289109600,5),(720,1299999600,6),(720,1320559200,5),(720,1331449200,6),(720,1352008800,5),(720,1362898800,6),(720,1383458400,5),(720,1394348400,6),(720,1414908000,5),(720,1425798000,6),(720,1446357600,5),(720,1457852400,6),(720,1478412000,5),(720,1489302000,6),(720,1509861600,5),(720,1520751600,6),(720,1541311200,5),(720,1552201200,6),(720,1572760800,5),(720,1583650800,6),(720,1604210400,5),(720,1615705200,6),(720,1636264800,5),(720,1647154800,6),(720,1667714400,5),(720,1678604400,6),(720,1699164000,5),(720,1710054000,6),(720,1730613600,5),(720,1741503600,6),(720,1762063200,5),(720,1772953200,6),(720,1793512800,5),(720,1805007600,6),(720,1825567200,5),(720,1836457200,6),(720,1857016800,5),(720,1867906800,6),(720,1888466400,5),(720,1899356400,6),(720,1919916000,5),(720,1930806000,6),(720,1951365600,5),(720,1962860400,6),(720,1983420000,5),(720,1994310000,6),(720,2014869600,5),(720,2025759600,6),(720,2046319200,5),(720,2057209200,6),(720,2077768800,5),(720,2088658800,6),(720,2109218400,5),(720,2120108400,6),(720,2140668000,5),(721,-2147483648,0),(721,-1767216360,2),(721,-1206957600,1),(721,-1191362400,2),(721,-1175374800,1),(721,-1159826400,2),(721,-633819600,1),(721,-622069200,2),(721,-602283600,1),(721,-591832800,2),(721,-570747600,1),(721,-560210400,2),(721,-539125200,1),(721,-531352800,2),(721,-191365200,1),(721,-184197600,2),(721,-155163600,1),(721,-150069600,2),(721,-128898000,1),(721,-121125600,2),(721,-99954000,1),(721,-89589600,2),(721,-68418000,1),(721,-57967200,2),(721,499748400,1),(721,511236000,2),(721,530593200,1),(721,540266400,2),(721,562129200,1),(721,571197600,2),(721,592974000,1),(721,602042400,2),(721,624423600,1),(721,634701600,2),(721,938919600,1),(721,951616800,2),(721,970974000,1),(721,972180000,2),(721,1003028400,1),(721,1013911200,2),(721,2147483647,2),(722,-2147483648,0),(722,-2131646412,2),(722,-1632074400,1),(722,-1615143600,2),(722,-880221600,3),(722,-769395600,4),(722,-765399600,2),(722,-526500000,1),(722,-513198000,2),(722,73461600,1),(722,89182800,2),(722,104911200,1),(722,120632400,2),(722,136360800,1),(722,152082000,2),(722,167810400,1),(722,183531600,2),(722,199260000,1),(722,215586000,2),(722,230709600,1),(722,247035600,2),(722,262764000,1),(722,278485200,2),(722,294213600,1),(722,309934800,2),(722,325663200,1),(722,341384400,2),(722,357112800,1),(722,372834000,2),(722,388562400,1),(722,404888400,2),(722,420012000,1),(722,436338000,2),(722,452066400,1),(722,467787600,2),(722,483516000,1),(722,499237200,2),(722,514965600,1),(722,530686800,2),(722,544600800,1),(722,562136400,2),(722,576050400,1),(722,594190800,2),(722,607500000,1),(722,625640400,2),(722,638949600,1),(722,657090000,2),(722,671004000,1),(722,688539600,2),(722,702453600,1),(722,719989200,2),(722,733903200,1),(722,752043600,2),(722,765352800,1),(722,783493200,2),(722,796802400,1),(722,814942800,2),(722,828856800,1),(722,846392400,2),(722,860306400,1),(722,877842000,2),(722,891756000,1),(722,909291600,2),(722,923205600,1),(722,941346000,2),(722,954655200,1),(722,972795600,2),(722,986104800,1),(722,1004245200,2),(722,1018159200,1),(722,1035694800,2),(722,1049608800,1),(722,1067144400,2),(722,1081058400,1),(722,1099198800,2),(722,1112508000,1),(722,1130648400,2),(722,1143957600,1),(722,1162098000,2),(722,1173592800,1),(722,1194152400,2),(722,1205042400,1),(722,1225602000,2),(722,1236492000,1),(722,1257051600,2),(722,1268546400,1),(722,1289106000,2),(722,1299996000,1),(722,1320555600,2),(722,1331445600,1),(722,1352005200,2),(722,1362895200,1),(722,1383454800,2),(722,1394344800,1),(722,1414904400,2),(722,1425794400,1),(722,1446354000,2),(722,1457848800,1),(722,1478408400,2),(722,1489298400,1),(722,1509858000,2),(722,1520748000,1),(722,1541307600,2),(722,1552197600,1),(722,1572757200,2),(722,1583647200,1),(722,1604206800,2),(722,1615701600,1),(722,1636261200,2),(722,1647151200,1),(722,1667710800,2),(722,1678600800,1),(722,1699160400,2),(722,1710050400,1),(722,1730610000,2),(722,1741500000,1),(722,1762059600,2),(722,1772949600,1),(722,1793509200,2),(722,1805004000,1),(722,1825563600,2),(722,1836453600,1),(722,1857013200,2),(722,1867903200,1),(722,1888462800,2),(722,1899352800,1),(722,1919912400,2),(722,1930802400,1),(722,1951362000,2),(722,1962856800,1),(722,1983416400,2),(722,1994306400,1),(722,2014866000,2),(722,2025756000,1),(722,2046315600,2),(722,2057205600,1),(722,2077765200,2),(722,2088655200,1),(722,2109214800,2),(722,2120104800,1),(722,2140664400,2),(723,-2147483648,0),(723,-1686083584,1),(723,323845200,4),(723,338950800,2),(723,354675600,3),(723,370400400,2),(723,386125200,3),(723,401850000,2),(723,417574800,3),(723,433299600,2),(723,449024400,3),(723,465354000,2),(723,481078800,3),(723,496803600,2),(723,512528400,3),(723,528253200,2),(723,543978000,3),(723,559702800,2),(723,575427600,3),(723,591152400,2),(723,606877200,3),(723,622602000,2),(723,638326800,3),(723,654656400,2),(723,670381200,3),(723,686106000,2),(723,701830800,3),(723,717555600,2),(723,733280400,3),(723,749005200,2),(723,764730000,3),(723,780454800,2),(723,796179600,3),(723,811904400,2),(723,828234000,3),(723,846378000,2),(723,859683600,3),(723,877827600,2),(723,891133200,3),(723,909277200,2),(723,922582800,3),(723,941331600,2),(723,954032400,3),(723,972781200,2),(723,985482000,3),(723,1004230800,2),(723,1017536400,3),(723,1035680400,2),(723,1048986000,3),(723,1067130000,2),(723,1080435600,3),(723,1099184400,2),(723,1111885200,3),(723,1130634000,2),(723,1143334800,3),(723,1162083600,2),(723,1174784400,3),(723,1193533200,2),(723,1206838800,3),(723,1224982800,2),(723,1238288400,3),(723,1256432400,2),(723,1269738000,3),(723,1288486800,2),(723,1301187600,3),(723,1319936400,2),(723,1332637200,3),(723,1351386000,2),(723,1364691600,3),(723,1382835600,2),(723,1396141200,3),(723,1414285200,2),(723,1427590800,3),(723,1445734800,2),(723,1459040400,3),(723,1477789200,2),(723,1490490000,3),(723,1509238800,2),(723,1521939600,3),(723,1540688400,2),(723,1553994000,3),(723,1572138000,2),(723,1585443600,3),(723,1603587600,2),(723,1616893200,3),(723,1635642000,2),(723,1648342800,3),(723,1667091600,2),(723,1679792400,3),(723,1698541200,2),(723,1711846800,3),(723,1729990800,2),(723,1743296400,3),(723,1761440400,2),(723,1774746000,3),(723,1792890000,2),(723,1806195600,3),(723,1824944400,2),(723,1837645200,3),(723,1856394000,2),(723,1869094800,3),(723,1887843600,2),(723,1901149200,3),(723,1919293200,2),(723,1932598800,3),(723,1950742800,2),(723,1964048400,3),(723,1982797200,2),(723,1995498000,3),(723,2014246800,2),(723,2026947600,3),(723,2045696400,2),(723,2058397200,3),(723,2077146000,2),(723,2090451600,3),(723,2108595600,2),(723,2121901200,3),(723,2140045200,2),(723,2147483647,2),(724,-2147483648,1),(724,-1632076148,2),(724,-1615145348,1),(724,-1096921748,3),(724,-1061670600,4),(724,-1048973400,3),(724,-1030221000,4),(724,-1017523800,3),(724,-998771400,4),(724,-986074200,3),(724,-966717000,4),(724,-954624600,3),(724,-935267400,4),(724,-922570200,3),(724,-903817800,4),(724,-891120600,3),(724,-872368200,6),(724,-769395600,5),(724,-765401400,3),(724,-746044200,4),(724,-733347000,3),(724,-714594600,4),(724,-701897400,3),(724,-683145000,4),(724,-670447800,3),(724,-651695400,4),(724,-638998200,3),(724,-619641000,4),(724,-606943800,3),(724,-589401000,4),(724,-576099000,3),(724,-557951400,4),(724,-544649400,3),(724,-526501800,4),(724,-513199800,3),(724,-495052200,4),(724,-481750200,3),(724,-463602600,4),(724,-450300600,3),(724,-431548200,4),(724,-418246200,3),(724,-400098600,4),(724,-386796600,3),(724,-368649000,4),(724,-355347000,3),(724,-337199400,4),(724,-323897400,3),(724,-305749800,4),(724,-289423800,3),(724,-273695400,4),(724,-257974200,3),(724,-242245800,4),(724,-226524600,3),(724,-210796200,4),(724,-195075000,3),(724,-179346600,4),(724,-163625400,3),(724,-147897000,4),(724,-131571000,3),(724,-119903400,8),(724,-116445600,7),(724,-100119600,8),(724,-84391200,7),(724,-68670000,8),(724,-52941600,7),(724,-37220400,8),(724,-21492000,7),(724,-5770800,8),(724,9957600,7),(724,25678800,8),(724,41407200,7),(724,57733200,8),(724,73461600,7),(724,89182800,8),(724,104911200,7),(724,120632400,8),(724,136360800,7),(724,152082000,8),(724,167810400,7),(724,183531600,8),(724,199260000,7),(724,215586000,8),(724,230709600,7),(724,247035600,8),(724,262764000,7),(724,278485200,8),(724,294213600,7),(724,309934800,8),(724,325663200,7),(724,341384400,8),(724,357112800,7),(724,372834000,8),(724,388562400,7),(724,404888400,8),(724,420012000,7),(724,436338000,8),(724,452066400,7),(724,467787600,8),(724,483516000,7),(724,499237200,8),(724,514965600,7),(724,530686800,8),(724,544593660,7),(724,562129260,8),(724,576043260,9),(724,594180060,8),(724,607492860,7),(724,625633260,8),(724,638942460,7),(724,657082860,8),(724,670996860,7),(724,688532460,8),(724,702446460,7),(724,719982060,8),(724,733896060,7),(724,752036460,8),(724,765345660,7),(724,783486060,8),(724,796795260,7),(724,814935660,8),(724,828849660,7),(724,846385260,8),(724,860299260,7),(724,877834860,8),(724,891748860,7),(724,909284460,8),(724,923198460,7),(724,941338860,8),(724,954648060,7),(724,972788460,8),(724,986097660,7),(724,1004238060,8),(724,1018152060,7),(724,1035687660,8),(724,1049601660,7),(724,1067137260,8),(724,1081051260,7),(724,1099191660,8),(724,1112500860,7),(724,1130641260,8),(724,1143950460,7),(724,1162090860,8),(724,1173585660,7),(724,1194145260,8),(724,1205035260,7),(724,1225594860,8),(724,1236484860,7),(724,1257044460,8),(724,1268539260,7),(724,1289098860,8),(724,1299988860,7),(724,1320555600,8),(724,1331445600,7),(724,1352005200,8),(724,1362895200,7),(724,1383454800,8),(724,1394344800,7),(724,1414904400,8),(724,1425794400,7),(724,1446354000,8),(724,1457848800,7),(724,1478408400,8),(724,1489298400,7),(724,1509858000,8),(724,1520748000,7),(724,1541307600,8),(724,1552197600,7),(724,1572757200,8),(724,1583647200,7),(724,1604206800,8),(724,1615701600,7),(724,1636261200,8),(724,1647151200,7),(724,1667710800,8),(724,1678600800,7),(724,1699160400,8),(724,1710050400,7),(724,1730610000,8),(724,1741500000,7),(724,1762059600,8),(724,1772949600,7),(724,1793509200,8),(724,1805004000,7),(724,1825563600,8),(724,1836453600,7),(724,1857013200,8),(724,1867903200,7),(724,1888462800,8),(724,1899352800,7),(724,1919912400,8),(724,1930802400,7),(724,1951362000,8),(724,1962856800,7),(724,1983416400,8),(724,1994306400,7),(724,2014866000,8),(724,2025756000,7),(724,2046315600,8),(724,2057205600,7),(724,2077765200,8),(724,2088655200,7),(724,2109214800,8),(724,2120104800,7),(724,2140664400,8),(725,-2147483648,1),(725,-1827687170,2),(725,294217200,3),(725,309938400,2),(725,325666800,3),(725,341388000,2),(725,357116400,3),(725,372837600,2),(725,388566000,3),(725,404892000,2),(725,420015600,3),(725,436341600,2),(725,452070000,3),(725,467791200,2),(725,483519600,3),(725,499240800,2),(725,514969200,3),(725,530690400,2),(725,544604400,3),(725,562140000,2),(725,576054000,3),(725,594194400,2),(725,607503600,3),(725,625644000,2),(725,638953200,3),(725,657093600,2),(725,671007600,3),(725,688543200,2),(725,702457200,3),(725,719992800,2),(725,733906800,3),(725,752047200,2),(725,765356400,3),(725,783496800,2),(725,796806000,3),(725,814946400,2),(725,828860400,3),(725,846396000,2),(725,860310000,3),(725,877845600,2),(725,891759600,3),(725,909295200,2),(725,923209200,3),(725,941349600,2),(725,954658800,3),(725,972799200,2),(725,986108400,3),(725,1004248800,2),(725,1018162800,3),(725,1035698400,2),(725,1049612400,3),(725,1067148000,2),(725,1081062000,3),(725,1099202400,2),(725,1112511600,3),(725,1130652000,2),(725,1143961200,3),(725,1162101600,2),(725,1173596400,3),(725,1194156000,2),(725,1205046000,3),(725,1225605600,2),(725,1236495600,3),(725,1257055200,2),(725,1268550000,3),(725,1289109600,2),(725,1299999600,3),(725,1320559200,2),(725,1331449200,3),(725,1352008800,2),(725,1362898800,3),(725,1383458400,2),(725,1394348400,3),(725,1414908000,2),(725,1425798000,3),(725,1446357600,4),(725,1520751600,3),(725,1541311200,2),(725,1552201200,3),(725,1572760800,2),(725,1583650800,3),(725,1604210400,2),(725,1615705200,3),(725,1636264800,2),(725,1647154800,3),(725,1667714400,2),(725,1678604400,3),(725,1699164000,2),(725,1710054000,3),(725,1730613600,2),(725,1741503600,3),(725,1762063200,2),(725,1772953200,3),(725,1793512800,2),(725,1805007600,3),(725,1825567200,2),(725,1836457200,3),(725,1857016800,2),(725,1867906800,3),(725,1888466400,2),(725,1899356400,3),(725,1919916000,2),(725,1930806000,3),(725,1951365600,2),(725,1962860400,3),(725,1983420000,2),(725,1994310000,3),(725,2014869600,2),(725,2025759600,3),(725,2046319200,2),(725,2057209200,3),(725,2077768800,2),(725,2088658800,3),(725,2109218400,2),(725,2120108400,3),(725,2140668000,2),(726,-2147483648,0),(726,-1825098836,1),(727,-2147483648,0),(727,-1825098836,1),(728,-2147483648,0),(728,-1617040676,2),(728,123055200,1),(728,130914000,2),(728,422344800,1),(728,433054800,2),(728,669708000,1),(728,684219600,2),(728,1146376800,1),(728,1159678800,2),(729,-2147483648,1),(729,-1230749160,3),(729,722926800,2),(729,728884800,3),(729,2147483647,3),(730,-2147483648,0),(730,-1730578040,1),(730,176010300,2),(730,662698800,3),(730,2147483647,3),(731,-2147483648,0),(731,-2131645536,2),(731,-1696276800,1),(731,-1680469200,2),(731,-1632074400,1),(731,-1615143600,2),(731,-1566763200,1),(731,-1557090000,2),(731,-1535486400,1),(731,-1524949200,2),(731,-1504468800,1),(731,-1493413200,2),(731,-1472414400,1),(731,-1461963600,2),(731,-1440964800,1),(731,-1429390800,2),(731,-1409515200,1),(731,-1396731600,2),(731,-1376856000,1),(731,-1366491600,2),(731,-1346616000,1),(731,-1333832400,2),(731,-1313956800,1),(731,-1303678800,2),(731,-1282507200,1),(731,-1272661200,2),(731,-1251057600,1),(731,-1240088400,2),(731,-1219608000,1),(731,-1207429200,2),(731,-1188763200,1),(731,-1175979600,2),(731,-1157313600,1),(731,-1143925200,2),(731,-1124049600,1),(731,-1113771600,2),(731,-1091390400,1),(731,-1081026000,2),(731,-1059854400,1),(731,-1050786000,2),(731,-1030910400,1),(731,-1018126800,2),(731,-999460800,1),(731,-986677200,2),(731,-965592000,1),(731,-955227600,2),(731,-935956800,1),(731,-923173200,2),(731,-904507200,1),(731,-891723600,2),(731,-880221600,3),(731,-769395600,4),(731,-765399600,2),(731,-747252000,1),(731,-733950000,2),(731,-715802400,1),(731,-702500400,2),(731,-684352800,1),(731,-671050800,2),(731,-652903200,1),(731,-639601200,2),(731,-589399200,1),(731,-576097200,2),(731,-557949600,1),(731,-544647600,2),(731,-526500000,1),(731,-513198000,2),(731,-495050400,1),(731,-481748400,2),(731,-431546400,1),(731,-418244400,2),(731,-400096800,1),(731,-386794800,2),(731,-368647200,1),(731,-355345200,2),(731,-337197600,1),(731,-323895600,2),(731,-242244000,1),(731,-226522800,2),(731,-210794400,1),(731,-195073200,2),(731,-179344800,1),(731,-163623600,2),(731,-147895200,1),(731,-131569200,2),(731,-116445600,1),(731,-100119600,2),(731,-84391200,1),(731,-68670000,2),(731,-52941600,1),(731,-37220400,2),(731,-21492000,1),(731,-5770800,2),(731,9957600,1),(731,25678800,2),(731,41407200,1),(731,57733200,2),(731,73461600,1),(731,89182800,2),(731,104911200,1),(731,120632400,2),(731,136360800,1),(731,152082000,2),(731,167810400,1),(731,183531600,2),(731,199260000,1),(731,215586000,2),(731,230709600,1),(731,247035600,2),(731,262764000,1),(731,278485200,2),(731,294213600,1),(731,309934800,2),(731,325663200,1),(731,341384400,2),(731,357112800,1),(731,372834000,2),(731,388562400,1),(731,404888400,2),(731,420012000,1),(731,436338000,2),(731,452066400,1),(731,467787600,2),(731,483516000,1),(731,499237200,2),(731,514965600,1),(731,530686800,2),(731,544600800,1),(731,562136400,2),(731,576050400,1),(731,594190800,2),(731,607500000,1),(731,625640400,2),(731,638949600,1),(731,657090000,2),(731,671004000,1),(731,688539600,2),(731,702453600,1),(731,719989200,2),(731,733903200,1),(731,752043600,2),(731,765352800,1),(731,783493200,2),(731,796802400,1),(731,814942800,2),(731,828856800,1),(731,846392400,2),(731,860306400,1),(731,877842000,2),(731,891756000,1),(731,909291600,2),(731,923205600,1),(731,941346000,2),(731,954655200,1),(731,972795600,2),(731,986104800,1),(731,1004245200,2),(731,1018159200,1),(731,1035694800,2),(731,1049608800,1),(731,1067144400,2),(731,1081058400,1),(731,1099198800,2),(731,1112508000,1),(731,1130648400,2),(731,1143957600,1),(731,1162098000,2),(731,1173592800,1),(731,1194152400,2),(731,1205042400,1),(731,1225602000,2),(731,1236492000,1),(731,1257051600,2),(731,1268546400,1),(731,1289106000,2),(731,1299996000,1),(731,1320555600,2),(731,1331445600,1),(731,1352005200,2),(731,1362895200,1),(731,1383454800,2),(731,1394344800,1),(731,1414904400,2),(731,1425794400,1),(731,1446354000,2),(731,1457848800,1),(731,1478408400,2),(731,1489298400,1),(731,1509858000,2),(731,1520748000,1),(731,1541307600,2),(731,1552197600,1),(731,1572757200,2),(731,1583647200,1),(731,1604206800,2),(731,1615701600,1),(731,1636261200,2),(731,1647151200,1),(731,1667710800,2),(731,1678600800,1),(731,1699160400,2),(731,1710050400,1),(731,1730610000,2),(731,1741500000,1),(731,1762059600,2),(731,1772949600,1),(731,1793509200,2),(731,1805004000,1),(731,1825563600,2),(731,1836453600,1),(731,1857013200,2),(731,1867903200,1),(731,1888462800,2),(731,1899352800,1),(731,1919912400,2),(731,1930802400,1),(731,1951362000,2),(731,1962856800,1),(731,1983416400,2),(731,1994306400,1),(731,2014866000,2),(731,2025756000,1),(731,2046315600,2),(731,2057205600,1),(731,2077765200,2),(731,2088655200,1),(731,2109214800,2),(731,2120104800,1),(731,2140664400,2),(732,-2147483648,1),(732,-1402813824,3),(732,-1311534000,2),(732,-1300996800,3),(732,-933534000,2),(732,-925675200,3),(732,-902084400,2),(732,-893620800,3),(732,-870030000,2),(732,-862171200,3),(732,-775681200,2),(732,-767822400,3),(732,-744231600,2),(732,-736372800,3),(732,-144702000,2),(732,-134251200,3),(732,-113425200,2),(732,-102542400,3),(732,-86295600,2),(732,-72907200,3),(732,-54154800,2),(732,-41457600,3),(732,-21495600,2),(732,-5774400,3),(732,9954000,2),(732,25675200,3),(732,41403600,2),(732,57729600,3),(732,73458000,2),(732,87364800,3),(732,104907600,2),(732,118900800,3),(732,136357200,2),(732,150436800,3),(732,167806800,2),(732,183528000,3),(732,199256400,2),(732,215582400,3),(732,230706000,2),(732,247032000,3),(732,263365200,2),(732,276667200,3),(732,290581200,2),(732,308721600,3),(732,322030800,2),(732,340171200,3),(732,358318800,2),(732,371620800,3),(732,389768400,2),(732,403070400,3),(732,421218000,2),(732,434520000,3),(732,452667600,2),(732,466574400,3),(732,484117200,2),(732,498024000,3),(732,511333200,2),(732,529473600,3),(732,542782800,2),(732,560923200,3),(732,574837200,2),(732,592372800,3),(732,606286800,2),(732,623822400,3),(732,638946000,2),(732,655876800,3),(732,671000400,2),(732,687330000,4),(732,702450000,2),(732,718779600,4),(732,733899600,2),(732,750229200,4),(732,765349200,2),(732,781678800,4),(732,796798800,2),(732,813128400,4),(732,828853200,2),(732,844578000,4),(732,860302800,2),(732,876632400,4),(732,891147600,5),(732,909291600,4),(732,922597200,5),(732,941346000,4),(732,954651600,5),(732,972795600,4),(732,986101200,5),(732,1004245200,4),(732,1018155600,5),(732,1035694800,4),(732,1049605200,5),(732,1067144400,4),(732,1080450000,5),(732,1162098000,4),(732,1173589200,5),(732,1193547600,4),(732,1205643600,5),(732,1224997200,4),(732,1236488400,5),(732,1256446800,4),(732,1268542800,5),(732,1288501200,4),(732,1300597200,5),(732,1321160400,4),(732,1333256400,5),(732,1352005200,4),(732,1362891600,5),(732,1383454800,4),(732,1394341200,5),(732,1414904400,4),(732,1425790800,5),(732,1446354000,4),(732,1457845200,5),(732,1478408400,4),(732,1489294800,5),(732,1509858000,4),(732,1520744400,5),(732,1541307600,4),(732,1552194000,5),(732,1572757200,4),(732,1583643600,5),(732,1604206800,4),(732,1615698000,5),(732,1636261200,4),(732,1647147600,5),(732,1667710800,4),(732,1678597200,5),(732,1699160400,4),(732,1710046800,5),(732,1730610000,4),(732,1741496400,5),(732,1762059600,4),(732,1772946000,5),(732,1793509200,4),(732,1805000400,5),(732,1825563600,4),(732,1836450000,5),(732,1857013200,4),(732,1867899600,5),(732,1888462800,4),(732,1899349200,5),(732,1919912400,4),(732,1930798800,5),(732,1951362000,4),(732,1962853200,5),(732,1983416400,4),(732,1994302800,5),(732,2014866000,4),(732,2025752400,5),(732,2046315600,4),(732,2057202000,5),(732,2077765200,4),(732,2088651600,5),(732,2109214800,4),(732,2120101200,5),(732,2140664400,4),(733,-2147483648,0),(733,-1514739600,1),(733,-1343066400,2),(733,-1234807200,1),(733,-1220292000,2),(733,-1207159200,1),(733,-1191344400,2),(733,-873828000,1),(733,-661539600,3),(733,28800,1),(733,828867600,4),(733,846403200,1),(733,860317200,4),(733,877852800,1),(733,891766800,4),(733,909302400,1),(734,-2147483648,2),(734,-1633276800,1),(734,-1615136400,2),(734,-1601827200,1),(734,-1583686800,2),(734,-900259200,1),(734,-891795600,2),(734,-880214400,3),(734,-769395600,4),(734,-765392400,2),(734,-747244800,1),(734,-733942800,2),(734,-715795200,1),(734,-702493200,2),(734,-684345600,1),(734,-671043600,2),(734,-652896000,1),(734,-639594000,2),(734,-620841600,1),(734,-608144400,2),(734,-589392000,1),(734,-576090000,2),(734,-557942400,1),(734,-544640400,2),(734,-526492800,1),(734,-513190800,2),(734,-495043200,1),(734,-481741200,2),(734,-463593600,5),(734,-386787600,2),(734,-368640000,5),(734,-21488400,6),(734,-5767200,5),(734,9961200,6),(734,25682400,5),(734,1143961200,6),(734,1162101600,5),(734,1173596400,6),(734,1194156000,5),(734,1205046000,6),(734,1225605600,5),(734,1236495600,6),(734,1257055200,5),(734,1268550000,6),(734,1289109600,5),(734,1299999600,6),(734,1320559200,5),(734,1331449200,6),(734,1352008800,5),(734,1362898800,6),(734,1383458400,5),(734,1394348400,6),(734,1414908000,5),(734,1425798000,6),(734,1446357600,5),(734,1457852400,6),(734,1478412000,5),(734,1489302000,6),(734,1509861600,5),(734,1520751600,6),(734,1541311200,5),(734,1552201200,6),(734,1572760800,5),(734,1583650800,6),(734,1604210400,5),(734,1615705200,6),(734,1636264800,5),(734,1647154800,6),(734,1667714400,5),(734,1678604400,6),(734,1699164000,5),(734,1710054000,6),(734,1730613600,5),(734,1741503600,6),(734,1762063200,5),(734,1772953200,6),(734,1793512800,5),(734,1805007600,6),(734,1825567200,5),(734,1836457200,6),(734,1857016800,5),(734,1867906800,6),(734,1888466400,5),(734,1899356400,6),(734,1919916000,5),(734,1930806000,6),(734,1951365600,5),(734,1962860400,6),(734,1983420000,5),(734,1994310000,6),(734,2014869600,5),(734,2025759600,6),(734,2046319200,5),(734,2057209200,6),(734,2077768800,5),(734,2088658800,6),(734,2109218400,5),(734,2120108400,6),(734,2140668000,5),(735,-2147483648,2),(735,-1633276800,1),(735,-1615136400,2),(735,-1601827200,1),(735,-1583686800,2),(735,-880214400,3),(735,-769395600,4),(735,-765392400,2),(735,-715795200,1),(735,-702493200,2),(735,-684345600,1),(735,-671043600,2),(735,-652896000,1),(735,-639594000,2),(735,-620841600,1),(735,-608144400,2),(735,-589392000,1),(735,-576090000,2),(735,-557942400,1),(735,-544640400,2),(735,-526492800,1),(735,-513190800,2),(735,-495043200,1),(735,-481741200,2),(735,-463593600,1),(735,-447267600,2),(735,-431539200,1),(735,-415818000,2),(735,-400089600,1),(735,-386787600,2),(735,-368640000,1),(735,-355338000,2),(735,-337190400,1),(735,-321469200,2),(735,-305740800,1),(735,-289414800,2),(735,-273686400,1),(735,-257965200,2),(735,-242236800,5),(735,-195066000,2),(735,-84384000,1),(735,-68662800,2),(735,-52934400,1),(735,-37213200,2),(735,-21484800,1),(735,-5763600,2),(735,9964800,1),(735,25686000,2),(735,41414400,1),(735,57740400,2),(735,73468800,1),(735,89190000,2),(735,104918400,1),(735,120639600,2),(735,126691200,1),(735,152089200,2),(735,162374400,1),(735,183538800,2),(735,199267200,1),(735,215593200,2),(735,230716800,1),(735,247042800,2),(735,262771200,1),(735,278492400,2),(735,294220800,1),(735,309942000,2),(735,325670400,1),(735,341391600,2),(735,357120000,1),(735,372841200,2),(735,388569600,1),(735,404895600,2),(735,420019200,1),(735,436345200,2),(735,452073600,1),(735,467794800,2),(735,483523200,1),(735,499244400,2),(735,514972800,1),(735,530694000,2),(735,544608000,1),(735,562143600,2),(735,576057600,1),(735,594198000,2),(735,607507200,1),(735,625647600,2),(735,638956800,1),(735,657097200,2),(735,671011200,1),(735,688546800,5),(735,1143961200,1),(735,1162105200,2),(735,1173600000,1),(735,1194159600,2),(735,1205049600,1),(735,1225609200,2),(735,1236499200,1),(735,1257058800,2),(735,1268553600,1),(735,1289113200,2),(735,1300003200,1),(735,1320562800,2),(735,1331452800,1),(735,1352012400,2),(735,1362902400,1),(735,1383462000,2),(735,1394352000,1),(735,1414911600,2),(735,1425801600,1),(735,1446361200,2),(735,1457856000,1),(735,1478415600,2),(735,1489305600,1),(735,1509865200,2),(735,1520755200,1),(735,1541314800,2),(735,1552204800,1),(735,1572764400,2),(735,1583654400,1),(735,1604214000,2),(735,1615708800,1),(735,1636268400,2),(735,1647158400,1),(735,1667718000,2),(735,1678608000,1),(735,1699167600,2),(735,1710057600,1),(735,1730617200,2),(735,1741507200,1),(735,1762066800,2),(735,1772956800,1),(735,1793516400,2),(735,1805011200,1),(735,1825570800,2),(735,1836460800,1),(735,1857020400,2),(735,1867910400,1),(735,1888470000,2),(735,1899360000,1),(735,1919919600,2),(735,1930809600,1),(735,1951369200,2),(735,1962864000,1),(735,1983423600,2),(735,1994313600,1),(735,2014873200,2),(735,2025763200,1),(735,2046322800,2),(735,2057212800,1),(735,2077772400,2),(735,2088662400,1),(735,2109222000,2),(735,2120112000,1),(735,2140671600,2),(736,-2147483648,2),(736,-1633276800,1),(736,-1615136400,2),(736,-1601827200,1),(736,-1583686800,2),(736,-880214400,3),(736,-769395600,4),(736,-765392400,2),(736,-589392000,1),(736,-576090000,2),(736,-495043200,1),(736,-481741200,2),(736,-463593600,1),(736,-450291600,2),(736,-431539200,1),(736,-418237200,2),(736,-400089600,1),(736,-386787600,2),(736,-368640000,1),(736,-355338000,2),(736,-337190400,1),(736,-323888400,2),(736,-305740800,1),(736,-292438800,2),(736,-273686400,5),(736,-21488400,6),(736,-5767200,5),(736,9961200,6),(736,25682400,5),(736,41410800,6),(736,57736800,5),(736,73465200,6),(736,89186400,5),(736,104914800,6),(736,120636000,5),(736,126687600,1),(736,152089200,5),(736,162370800,6),(736,183535200,5),(736,1143961200,6),(736,1162101600,5),(736,1173596400,6),(736,1194156000,5),(736,1205046000,6),(736,1225605600,5),(736,1236495600,6),(736,1257055200,5),(736,1268550000,6),(736,1289109600,5),(736,1299999600,6),(736,1320559200,5),(736,1331449200,6),(736,1352008800,5),(736,1362898800,6),(736,1383458400,5),(736,1394348400,6),(736,1414908000,5),(736,1425798000,6),(736,1446357600,5),(736,1457852400,6),(736,1478412000,5),(736,1489302000,6),(736,1509861600,5),(736,1520751600,6),(736,1541311200,5),(736,1552201200,6),(736,1572760800,5),(736,1583650800,6),(736,1604210400,5),(736,1615705200,6),(736,1636264800,5),(736,1647154800,6),(736,1667714400,5),(736,1678604400,6),(736,1699164000,5),(736,1710054000,6),(736,1730613600,5),(736,1741503600,6),(736,1762063200,5),(736,1772953200,6),(736,1793512800,5),(736,1805007600,6),(736,1825567200,5),(736,1836457200,6),(736,1857016800,5),(736,1867906800,6),(736,1888466400,5),(736,1899356400,6),(736,1919916000,5),(736,1930806000,6),(736,1951365600,5),(736,1962860400,6),(736,1983420000,5),(736,1994310000,6),(736,2014869600,5),(736,2025759600,6),(736,2046319200,5),(736,2057209200,6),(736,2077768800,5),(736,2088658800,6),(736,2109218400,5),(736,2120108400,6),(736,2140668000,5),(737,-2147483648,2),(737,-1633276800,1),(737,-1615136400,2),(737,-1601827200,1),(737,-1583686800,2),(737,-880214400,3),(737,-769395600,4),(737,-765392400,2),(737,-462996000,1),(737,-450291600,2),(737,-431539200,1),(737,-418237200,2),(737,-400089600,1),(737,-386787600,2),(737,-368640000,1),(737,-355338000,2),(737,-337190400,1),(737,-323888400,2),(737,-305740800,1),(737,-292438800,2),(737,-273686400,1),(737,-257965200,2),(737,-242236800,1),(737,-226515600,2),(737,-210787200,1),(737,-195066000,2),(737,-179337600,1),(737,-163616400,2),(737,-147888000,5),(737,-100112400,2),(737,-84384000,1),(737,-68662800,2),(737,-52934400,1),(737,-37213200,2),(737,-21484800,1),(737,-5763600,2),(737,9964800,1),(737,25686000,2),(737,41414400,1),(737,57740400,2),(737,73468800,1),(737,89190000,2),(737,104918400,1),(737,120639600,2),(737,126691200,1),(737,152089200,2),(737,162374400,1),(737,183538800,2),(737,199267200,1),(737,215593200,2),(737,230716800,1),(737,247042800,5),(737,1143961200,1),(737,1162105200,2),(737,1173600000,1),(737,1194159600,5),(737,1205046000,6),(737,1225605600,5),(737,1236495600,6),(737,1257055200,5),(737,1268550000,6),(737,1289109600,5),(737,1299999600,6),(737,1320559200,5),(737,1331449200,6),(737,1352008800,5),(737,1362898800,6),(737,1383458400,5),(737,1394348400,6),(737,1414908000,5),(737,1425798000,6),(737,1446357600,5),(737,1457852400,6),(737,1478412000,5),(737,1489302000,6),(737,1509861600,5),(737,1520751600,6),(737,1541311200,5),(737,1552201200,6),(737,1572760800,5),(737,1583650800,6),(737,1604210400,5),(737,1615705200,6),(737,1636264800,5),(737,1647154800,6),(737,1667714400,5),(737,1678604400,6),(737,1699164000,5),(737,1710054000,6),(737,1730613600,5),(737,1741503600,6),(737,1762063200,5),(737,1772953200,6),(737,1793512800,5),(737,1805007600,6),(737,1825567200,5),(737,1836457200,6),(737,1857016800,5),(737,1867906800,6),(737,1888466400,5),(737,1899356400,6),(737,1919916000,5),(737,1930806000,6),(737,1951365600,5),(737,1962860400,6),(737,1983420000,5),(737,1994310000,6),(737,2014869600,5),(737,2025759600,6),(737,2046319200,5),(737,2057209200,6),(737,2077768800,5),(737,2088658800,6),(737,2109218400,5),(737,2120108400,6),(737,2140668000,5),(738,-2147483648,2),(738,-1633276800,1),(738,-1615136400,2),(738,-1601827200,1),(738,-1583686800,2),(738,-880214400,3),(738,-769395600,4),(738,-765392400,2),(738,-747244800,1),(738,-733942800,2),(738,-526492800,1),(738,-513190800,2),(738,-495043200,1),(738,-481741200,2),(738,-462996000,1),(738,-450291600,2),(738,-431539200,1),(738,-418237200,2),(738,-400089600,1),(738,-386787600,2),(738,-368640000,1),(738,-355338000,2),(738,-337190400,1),(738,-323888400,2),(738,-305740800,1),(738,-289414800,2),(738,-273686400,1),(738,-260989200,2),(738,-242236800,1),(738,-226515600,2),(738,-210787200,1),(738,-195066000,2),(738,-179337600,5),(738,-21488400,6),(738,-5767200,5),(738,9961200,6),(738,25682400,5),(738,1143961200,1),(738,1162105200,2),(738,1173600000,1),(738,1194159600,2),(738,1205049600,1),(738,1225609200,2),(738,1236499200,1),(738,1257058800,2),(738,1268553600,1),(738,1289113200,2),(738,1300003200,1),(738,1320562800,2),(738,1331452800,1),(738,1352012400,2),(738,1362902400,1),(738,1383462000,2),(738,1394352000,1),(738,1414911600,2),(738,1425801600,1),(738,1446361200,2),(738,1457856000,1),(738,1478415600,2),(738,1489305600,1),(738,1509865200,2),(738,1520755200,1),(738,1541314800,2),(738,1552204800,1),(738,1572764400,2),(738,1583654400,1),(738,1604214000,2),(738,1615708800,1),(738,1636268400,2),(738,1647158400,1),(738,1667718000,2),(738,1678608000,1),(738,1699167600,2),(738,1710057600,1),(738,1730617200,2),(738,1741507200,1),(738,1762066800,2),(738,1772956800,1),(738,1793516400,2),(738,1805011200,1),(738,1825570800,2),(738,1836460800,1),(738,1857020400,2),(738,1867910400,1),(738,1888470000,2),(738,1899360000,1),(738,1919919600,2),(738,1930809600,1),(738,1951369200,2),(738,1962864000,1),(738,1983423600,2),(738,1994313600,1),(738,2014873200,2),(738,2025763200,1),(738,2046322800,2),(738,2057212800,1),(738,2077772400,2),(738,2088662400,1),(738,2109222000,2),(738,2120112000,1),(738,2140671600,2),(739,-2147483648,2),(739,-1633276800,1),(739,-1615136400,2),(739,-1601827200,1),(739,-1583686800,2),(739,-880214400,3),(739,-769395600,4),(739,-765392400,2),(739,-495043200,5),(739,-21488400,6),(739,-5767200,5),(739,9961200,6),(739,25682400,5),(739,41410800,6),(739,57736800,5),(739,73465200,6),(739,89186400,5),(739,1143961200,6),(739,1162101600,5),(739,1173596400,6),(739,1194156000,5),(739,1205046000,6),(739,1225605600,5),(739,1236495600,6),(739,1257055200,5),(739,1268550000,6),(739,1289109600,5),(739,1299999600,6),(739,1320559200,5),(739,1331449200,6),(739,1352008800,5),(739,1362898800,6),(739,1383458400,5),(739,1394348400,6),(739,1414908000,5),(739,1425798000,6),(739,1446357600,5),(739,1457852400,6),(739,1478412000,5),(739,1489302000,6),(739,1509861600,5),(739,1520751600,6),(739,1541311200,5),(739,1552201200,6),(739,1572760800,5),(739,1583650800,6),(739,1604210400,5),(739,1615705200,6),(739,1636264800,5),(739,1647154800,6),(739,1667714400,5),(739,1678604400,6),(739,1699164000,5),(739,1710054000,6),(739,1730613600,5),(739,1741503600,6),(739,1762063200,5),(739,1772953200,6),(739,1793512800,5),(739,1805007600,6),(739,1825567200,5),(739,1836457200,6),(739,1857016800,5),(739,1867906800,6),(739,1888466400,5),(739,1899356400,6),(739,1919916000,5),(739,1930806000,6),(739,1951365600,5),(739,1962860400,6),(739,1983420000,5),(739,1994310000,6),(739,2014869600,5),(739,2025759600,6),(739,2046319200,5),(739,2057209200,6),(739,2077768800,5),(739,2088658800,6),(739,2109218400,5),(739,2120108400,6),(739,2140668000,5),(740,-2147483648,2),(740,-1633276800,1),(740,-1615136400,2),(740,-1601827200,1),(740,-1583686800,2),(740,-880214400,3),(740,-769395600,4),(740,-765392400,2),(740,-747244800,1),(740,-733942800,2),(740,-526492800,1),(740,-513190800,2),(740,-495043200,1),(740,-481741200,2),(740,-462996000,1),(740,-450291600,2),(740,-431539200,1),(740,-418237200,2),(740,-400089600,1),(740,-386787600,2),(740,-368640000,1),(740,-355338000,2),(740,-337190400,1),(740,-323888400,2),(740,-305740800,1),(740,-289414800,2),(740,-273686400,1),(740,-260989200,2),(740,-242236800,1),(740,-226515600,2),(740,-210787200,1),(740,-195066000,2),(740,-179337600,5),(740,-21488400,6),(740,-5767200,5),(740,9961200,6),(740,25682400,5),(740,1143961200,1),(740,1162105200,2),(740,1173600000,1),(740,1194159600,5),(740,1205046000,6),(740,1225605600,5),(740,1236495600,6),(740,1257055200,5),(740,1268550000,6),(740,1289109600,5),(740,1299999600,6),(740,1320559200,5),(740,1331449200,6),(740,1352008800,5),(740,1362898800,6),(740,1383458400,5),(740,1394348400,6),(740,1414908000,5),(740,1425798000,6),(740,1446357600,5),(740,1457852400,6),(740,1478412000,5),(740,1489302000,6),(740,1509861600,5),(740,1520751600,6),(740,1541311200,5),(740,1552201200,6),(740,1572760800,5),(740,1583650800,6),(740,1604210400,5),(740,1615705200,6),(740,1636264800,5),(740,1647154800,6),(740,1667714400,5),(740,1678604400,6),(740,1699164000,5),(740,1710054000,6),(740,1730613600,5),(740,1741503600,6),(740,1762063200,5),(740,1772953200,6),(740,1793512800,5),(740,1805007600,6),(740,1825567200,5),(740,1836457200,6),(740,1857016800,5),(740,1867906800,6),(740,1888466400,5),(740,1899356400,6),(740,1919916000,5),(740,1930806000,6),(740,1951365600,5),(740,1962860400,6),(740,1983420000,5),(740,1994310000,6),(740,2014869600,5),(740,2025759600,6),(740,2046319200,5),(740,2057209200,6),(740,2077768800,5),(740,2088658800,6),(740,2109218400,5),(740,2120108400,6),(740,2140668000,5),(741,-2147483648,2),(741,-1633276800,1),(741,-1615136400,2),(741,-1601827200,1),(741,-1583686800,2),(741,-880214400,3),(741,-769395600,4),(741,-765392400,2),(741,-747244800,1),(741,-733942800,2),(741,-715795200,1),(741,-702493200,2),(741,-684345600,1),(741,-671043600,2),(741,-652896000,1),(741,-639594000,2),(741,-620841600,1),(741,-608144400,2),(741,-589392000,1),(741,-576090000,2),(741,-557942400,1),(741,-544640400,2),(741,-526492800,1),(741,-513190800,2),(741,-495043200,1),(741,-481741200,2),(741,-463593600,1),(741,-447267600,2),(741,-431539200,1),(741,-415818000,2),(741,-400089600,1),(741,-386787600,2),(741,-368640000,1),(741,-355338000,2),(741,-337190400,1),(741,-323888400,2),(741,-305740800,1),(741,-292438800,2),(741,-273686400,5),(741,-21488400,6),(741,-5767200,5),(741,9961200,6),(741,25682400,5),(741,1143961200,1),(741,1162105200,2),(741,1173600000,6),(741,1194156000,5),(741,1205046000,6),(741,1225605600,5),(741,1236495600,6),(741,1257055200,5),(741,1268550000,6),(741,1289109600,5),(741,1299999600,6),(741,1320559200,5),(741,1331449200,6),(741,1352008800,5),(741,1362898800,6),(741,1383458400,5),(741,1394348400,6),(741,1414908000,5),(741,1425798000,6),(741,1446357600,5),(741,1457852400,6),(741,1478412000,5),(741,1489302000,6),(741,1509861600,5),(741,1520751600,6),(741,1541311200,5),(741,1552201200,6),(741,1572760800,5),(741,1583650800,6),(741,1604210400,5),(741,1615705200,6),(741,1636264800,5),(741,1647154800,6),(741,1667714400,5),(741,1678604400,6),(741,1699164000,5),(741,1710054000,6),(741,1730613600,5),(741,1741503600,6),(741,1762063200,5),(741,1772953200,6),(741,1793512800,5),(741,1805007600,6),(741,1825567200,5),(741,1836457200,6),(741,1857016800,5),(741,1867906800,6),(741,1888466400,5),(741,1899356400,6),(741,1919916000,5),(741,1930806000,6),(741,1951365600,5),(741,1962860400,6),(741,1983420000,5),(741,1994310000,6),(741,2014869600,5),(741,2025759600,6),(741,2046319200,5),(741,2057209200,6),(741,2077768800,5),(741,2088658800,6),(741,2109218400,5),(741,2120108400,6),(741,2140668000,5),(742,-2147483648,2),(742,-1633276800,1),(742,-1615136400,2),(742,-1601827200,1),(742,-1583686800,2),(742,-900259200,1),(742,-891795600,2),(742,-880214400,3),(742,-769395600,4),(742,-765392400,2),(742,-747244800,1),(742,-733942800,2),(742,-715795200,1),(742,-702493200,2),(742,-684345600,1),(742,-671043600,2),(742,-652896000,1),(742,-639594000,2),(742,-620841600,1),(742,-608144400,2),(742,-589392000,1),(742,-576090000,2),(742,-557942400,1),(742,-544640400,2),(742,-526492800,1),(742,-513190800,2),(742,-495043200,1),(742,-481741200,2),(742,-463593600,5),(742,-386787600,2),(742,-368640000,5),(742,-21488400,6),(742,-5767200,5),(742,9961200,6),(742,25682400,5),(742,1143961200,6),(742,1162101600,5),(742,1173596400,6),(742,1194156000,5),(742,1205046000,6),(742,1225605600,5),(742,1236495600,6),(742,1257055200,5),(742,1268550000,6),(742,1289109600,5),(742,1299999600,6),(742,1320559200,5),(742,1331449200,6),(742,1352008800,5),(742,1362898800,6),(742,1383458400,5),(742,1394348400,6),(742,1414908000,5),(742,1425798000,6),(742,1446357600,5),(742,1457852400,6),(742,1478412000,5),(742,1489302000,6),(742,1509861600,5),(742,1520751600,6),(742,1541311200,5),(742,1552201200,6),(742,1572760800,5),(742,1583650800,6),(742,1604210400,5),(742,1615705200,6),(742,1636264800,5),(742,1647154800,6),(742,1667714400,5),(742,1678604400,6),(742,1699164000,5),(742,1710054000,6),(742,1730613600,5),(742,1741503600,6),(742,1762063200,5),(742,1772953200,6),(742,1793512800,5),(742,1805007600,6),(742,1825567200,5),(742,1836457200,6),(742,1857016800,5),(742,1867906800,6),(742,1888466400,5),(742,1899356400,6),(742,1919916000,5),(742,1930806000,6),(742,1951365600,5),(742,1962860400,6),(742,1983420000,5),(742,1994310000,6),(742,2014869600,5),(742,2025759600,6),(742,2046319200,5),(742,2057209200,6),(742,2077768800,5),(742,2088658800,6),(742,2109218400,5),(742,2120108400,6),(742,2140668000,5),(743,-2147483648,0),(743,-536457600,2),(743,-147888000,1),(743,-131558400,2),(743,294228000,3),(743,325674000,4),(743,341395200,3),(743,357123600,4),(743,372844800,3),(743,388573200,4),(743,404899200,3),(743,420022800,4),(743,436348800,3),(743,452077200,4),(743,467798400,3),(743,483526800,4),(743,499248000,3),(743,514976400,4),(743,530697600,3),(743,544611600,4),(743,562147200,3),(743,576061200,4),(743,594201600,3),(743,607510800,4),(743,625651200,3),(743,638960400,4),(743,657100800,3),(743,671014800,4),(743,688550400,3),(743,702464400,4),(743,720000000,3),(743,733914000,4),(743,752054400,3),(743,765363600,4),(743,783504000,3),(743,796813200,4),(743,814953600,3),(743,828867600,4),(743,846403200,3),(743,860317200,4),(743,877852800,3),(743,891766800,4),(743,909302400,3),(743,923216400,4),(743,941356800,3),(743,954666000,4),(743,972806400,3),(743,986115600,4),(743,1004256000,3),(743,1018170000,4),(743,1035705600,3),(743,1049619600,4),(743,1067155200,3),(743,1081069200,4),(743,1099209600,3),(743,1112518800,4),(743,1130659200,3),(743,1143968400,4),(743,1162108800,3),(743,1173603600,4),(743,1194163200,3),(743,1205053200,4),(743,1225612800,3),(743,1236502800,4),(743,1257062400,3),(743,1268557200,4),(743,1289116800,3),(743,1300006800,4),(743,1320566400,3),(743,1331456400,4),(743,1352016000,3),(743,1362906000,4),(743,1383465600,3),(743,1394355600,4),(743,1414915200,3),(743,1425805200,4),(743,1446364800,3),(743,1457859600,4),(743,1478419200,3),(743,1489309200,4),(743,1509868800,3),(743,1520758800,4),(743,1541318400,3),(743,1552208400,4),(743,1572768000,3),(743,1583658000,4),(743,1604217600,3),(743,1615712400,4),(743,1636272000,3),(743,1647162000,4),(743,1667721600,3),(743,1678611600,4),(743,1699171200,3),(743,1710061200,4),(743,1730620800,3),(743,1741510800,4),(743,1762070400,3),(743,1772960400,4),(743,1793520000,3),(743,1805014800,4),(743,1825574400,3),(743,1836464400,4),(743,1857024000,3),(743,1867914000,4),(743,1888473600,3),(743,1899363600,4),(743,1919923200,3),(743,1930813200,4),(743,1951372800,3),(743,1962867600,4),(743,1983427200,3),(743,1994317200,4),(743,2014876800,3),(743,2025766800,4),(743,2046326400,3),(743,2057216400,4),(743,2077776000,3),(743,2088666000,4),(743,2109225600,3),(743,2120115600,4),(743,2140675200,3),(744,-2147483648,0),(744,-865296000,5),(744,-769395600,1),(744,-765396000,2),(744,-147898800,3),(744,-131569200,2),(744,325666800,4),(744,341388000,2),(744,357116400,4),(744,372837600,2),(744,388566000,4),(744,404892000,2),(744,420015600,4),(744,436341600,2),(744,452070000,4),(744,467791200,2),(744,483519600,4),(744,499240800,2),(744,514969200,4),(744,530690400,2),(744,544604400,4),(744,562140000,2),(744,576054000,4),(744,594194400,2),(744,607503600,4),(744,625644000,2),(744,638953200,4),(744,657093600,2),(744,671007600,4),(744,688543200,2),(744,702457200,4),(744,719992800,2),(744,733906800,4),(744,752047200,2),(744,765356400,4),(744,783496800,2),(744,796806000,4),(744,814946400,2),(744,828860400,4),(744,846396000,2),(744,860310000,4),(744,877845600,2),(744,891759600,4),(744,909295200,2),(744,923209200,4),(744,941349600,6),(744,954662400,7),(744,972802800,2),(744,986108400,4),(744,1004248800,2),(744,1018162800,4),(744,1035698400,2),(744,1049612400,4),(744,1067148000,2),(744,1081062000,4),(744,1099202400,2),(744,1112511600,4),(744,1130652000,2),(744,1143961200,4),(744,1162101600,2),(744,1173596400,4),(744,1194156000,2),(744,1205046000,4),(744,1225605600,2),(744,1236495600,4),(744,1257055200,2),(744,1268550000,4),(744,1289109600,2),(744,1299999600,4),(744,1320559200,2),(744,1331449200,4),(744,1352008800,2),(744,1362898800,4),(744,1383458400,2),(744,1394348400,4),(744,1414908000,2),(744,1425798000,4),(744,1446357600,2),(744,1457852400,4),(744,1478412000,2),(744,1489302000,4),(744,1509861600,2),(744,1520751600,4),(744,1541311200,2),(744,1552201200,4),(744,1572760800,2),(744,1583650800,4),(744,1604210400,2),(744,1615705200,4),(744,1636264800,2),(744,1647154800,4),(744,1667714400,2),(744,1678604400,4),(744,1699164000,2),(744,1710054000,4),(744,1730613600,2),(744,1741503600,4),(744,1762063200,2),(744,1772953200,4),(744,1793512800,2),(744,1805007600,4),(744,1825567200,2),(744,1836457200,4),(744,1857016800,2),(744,1867906800,4),(744,1888466400,2),(744,1899356400,4),(744,1919916000,2),(744,1930806000,4),(744,1951365600,2),(744,1962860400,4),(744,1983420000,2),(744,1994310000,4),(744,2014869600,2),(744,2025759600,4),(744,2046319200,2),(744,2057209200,4),(744,2077768800,2),(744,2088658800,4),(744,2109218400,2),(744,2120108400,4),(744,2140668000,2),(745,-2147483648,1),(745,-1827687170,2),(745,126687600,3),(745,152085600,2),(745,162370800,3),(745,183535200,2),(745,199263600,3),(745,215589600,2),(745,230713200,3),(745,247039200,2),(745,262767600,3),(745,278488800,2),(745,294217200,3),(745,309938400,2),(745,325666800,3),(745,341388000,2),(745,357116400,3),(745,372837600,2),(745,388566000,3),(745,404892000,2),(745,420015600,3),(745,436341600,2),(746,-2147483648,1),(746,-1567453392,2),(746,-1233432000,3),(746,-1222981200,2),(746,-1205956800,3),(746,-1194037200,2),(746,-1172865600,3),(746,-1162501200,2),(746,-1141329600,3),(746,-1130965200,2),(746,-1109793600,3),(746,-1099429200,2),(746,-1078257600,3),(746,-1067806800,2),(746,-1046635200,3),(746,-1036270800,2),(746,-1015099200,3),(746,-1004734800,2),(746,-983563200,3),(746,-973198800,2),(746,-952027200,3),(746,-941576400,2),(746,-931032000,3),(746,-900882000,2),(746,-890337600,3),(746,-833749200,2),(746,-827265600,3),(746,-752274000,2),(746,-733780800,3),(746,-197326800,2),(746,-190843200,3),(746,-184194000,2),(746,-164491200,3),(746,-152658000,2),(746,-132955200,3),(746,-121122000,2),(746,-101419200,3),(746,-86821200,2),(746,-71092800,3),(746,-54766800,2),(746,-39038400,3),(746,-23317200,2),(746,-7588800,5),(746,128142000,4),(746,136605600,5),(746,596948400,4),(746,605066400,5),(746,624423600,4),(746,636516000,2),(746,657086400,3),(746,669178800,2),(746,686721600,4),(746,699415200,5),(746,719377200,4),(746,731469600,5),(746,938919600,3),(746,952052400,5),(746,1198983600,4),(746,1205632800,5),(746,2147483647,5),(747,-2147483648,1),(747,-880207200,2),(747,-769395600,3),(747,-765385200,1),(747,-21477600,4),(747,-5756400,1),(747,9972000,4),(747,25693200,1),(747,41421600,4),(747,57747600,1),(747,73476000,4),(747,89197200,1),(747,104925600,4),(747,120646800,1),(747,126698400,4),(747,152096400,1),(747,162381600,4),(747,183546000,1),(747,199274400,4),(747,215600400,1),(747,230724000,4),(747,247050000,1),(747,262778400,4),(747,278499600,1),(747,294228000,4),(747,309949200,1),(747,325677600,5),(747,341402400,1),(747,357127200,4),(747,372848400,1),(747,388576800,4),(747,404902800,1),(747,420026400,4),(747,436352400,6),(747,439030800,8),(747,452084400,7),(747,467805600,8),(747,483534000,7),(747,499255200,8),(747,514983600,7),(747,530704800,8),(747,544618800,7),(747,562154400,8),(747,576068400,7),(747,594208800,8),(747,607518000,7),(747,625658400,8),(747,638967600,7),(747,657108000,8),(747,671022000,7),(747,688557600,8),(747,702471600,7),(747,720007200,8),(747,733921200,7),(747,752061600,8),(747,765370800,7),(747,783511200,8),(747,796820400,7),(747,814960800,8),(747,828874800,7),(747,846410400,8),(747,860324400,7),(747,877860000,8),(747,891774000,7),(747,909309600,8),(747,923223600,7),(747,941364000,8),(747,954673200,7),(747,972813600,8),(747,986122800,7),(747,1004263200,8),(747,1018177200,7),(747,1035712800,8),(747,1049626800,7),(747,1067162400,8),(747,1081076400,7),(747,1099216800,8),(747,1112526000,7),(747,1130666400,8),(747,1143975600,7),(747,1162116000,8),(747,1173610800,7),(747,1194170400,8),(747,1205060400,7),(747,1225620000,8),(747,1236510000,7),(747,1257069600,8),(747,1268564400,7),(747,1289124000,8),(747,1300014000,7),(747,1320573600,8),(747,1331463600,7),(747,1352023200,8),(747,1362913200,7),(747,1383472800,8),(747,1394362800,7),(747,1414922400,8),(747,1425812400,7),(747,1446372000,8),(747,1457866800,7),(747,1478426400,8),(747,1489316400,7),(747,1509876000,8),(747,1520766000,7),(747,1541325600,8),(747,1552215600,7),(747,1572775200,8),(747,1583665200,7),(747,1604224800,8),(747,1615719600,7),(747,1636279200,8),(747,1647169200,7),(747,1667728800,8),(747,1678618800,7),(747,1699178400,8),(747,1710068400,7),(747,1730628000,8),(747,1741518000,7),(747,1762077600,8),(747,1772967600,7),(747,1793527200,8),(747,1805022000,7),(747,1825581600,8),(747,1836471600,7),(747,1857031200,8),(747,1867921200,7),(747,1888480800,8),(747,1899370800,7),(747,1919930400,8),(747,1930820400,7),(747,1951380000,8),(747,1962874800,7),(747,1983434400,8),(747,1994324400,7),(747,2014884000,8),(747,2025774000,7),(747,2046333600,8),(747,2057223600,7),(747,2077783200,8),(747,2088673200,7),(747,2109232800,8),(747,2120122800,7),(747,2140682400,8),(748,-2147483648,2),(748,-1633276800,1),(748,-1615136400,2),(748,-1601827200,1),(748,-1583686800,2),(748,-1535904000,1),(748,-1525280400,2),(748,-905097600,1),(748,-891795600,2),(748,-880214400,3),(748,-769395600,4),(748,-765392400,2),(748,-757360800,1),(748,-744224400,2),(748,-715795200,1),(748,-608144400,2),(748,-589392000,1),(748,-576090000,2),(748,-557942400,1),(748,-544640400,2),(748,-526492800,1),(748,-513190800,2),(748,-495043200,1),(748,-481741200,2),(748,-463593600,1),(748,-450291600,2),(748,-431539200,1),(748,-415818000,2),(748,-400089600,1),(748,-384368400,2),(748,-368640000,1),(748,-352918800,2),(748,-337190400,1),(748,-321469200,2),(748,-305740800,1),(748,-289414800,2),(748,-273686400,1),(748,-266432400,5),(748,-52938000,6),(748,-37216800,5),(748,-21488400,6),(748,-5767200,5),(748,9961200,6),(748,25682400,5),(748,41410800,6),(748,57736800,5),(748,73465200,6),(748,89186400,5),(748,104914800,6),(748,120636000,5),(748,126687600,1),(748,152089200,5),(748,162370800,6),(748,183535200,5),(748,199263600,6),(748,215589600,5),(748,230713200,6),(748,247039200,5),(748,262767600,6),(748,278488800,5),(748,294217200,6),(748,309938400,5),(748,325666800,6),(748,341388000,5),(748,357116400,6),(748,372837600,5),(748,388566000,6),(748,404892000,5),(748,420015600,6),(748,436341600,5),(748,452070000,6),(748,467791200,5),(748,483519600,6),(748,499240800,5),(748,514969200,6),(748,530690400,5),(748,544604400,6),(748,562140000,5),(748,576054000,6),(748,594194400,5),(748,607503600,6),(748,625644000,5),(748,638953200,6),(748,657093600,5),(748,671007600,6),(748,688543200,5),(748,702457200,6),(748,719992800,5),(748,733906800,6),(748,752047200,5),(748,765356400,6),(748,783496800,5),(748,796806000,6),(748,814946400,5),(748,828860400,6),(748,846396000,5),(748,860310000,6),(748,877845600,5),(748,891759600,6),(748,909295200,5),(748,923209200,6),(748,941349600,5),(748,954658800,6),(748,972799200,5),(748,986108400,6),(748,1004248800,5),(748,1018162800,6),(748,1035698400,5),(748,1049612400,6),(748,1067148000,5),(748,1081062000,6),(748,1099202400,5),(748,1112511600,6),(748,1130652000,5),(748,1143961200,6),(748,1162101600,5),(748,1173596400,6),(748,1194156000,5),(748,1205046000,6),(748,1225605600,5),(748,1236495600,6),(748,1257055200,5),(748,1268550000,6),(748,1289109600,5),(748,1299999600,6),(748,1320559200,5),(748,1331449200,6),(748,1352008800,5),(748,1362898800,6),(748,1383458400,5),(748,1394348400,6),(748,1414908000,5),(748,1425798000,6),(748,1446357600,5),(748,1457852400,6),(748,1478412000,5),(748,1489302000,6),(748,1509861600,5),(748,1520751600,6),(748,1541311200,5),(748,1552201200,6),(748,1572760800,5),(748,1583650800,6),(748,1604210400,5),(748,1615705200,6),(748,1636264800,5),(748,1647154800,6),(748,1667714400,5),(748,1678604400,6),(748,1699164000,5),(748,1710054000,6),(748,1730613600,5),(748,1741503600,6),(748,1762063200,5),(748,1772953200,6),(748,1793512800,5),(748,1805007600,6),(748,1825567200,5),(748,1836457200,6),(748,1857016800,5),(748,1867906800,6),(748,1888466400,5),(748,1899356400,6),(748,1919916000,5),(748,1930806000,6),(748,1951365600,5),(748,1962860400,6),(748,1983420000,5),(748,1994310000,6),(748,2014869600,5),(748,2025759600,6),(748,2046319200,5),(748,2057209200,6),(748,2077768800,5),(748,2088658800,6),(748,2109218400,5),(748,2120108400,6),(748,2140668000,5),(749,-2147483648,2),(749,-1633276800,1),(749,-1615136400,2),(749,-1601827200,1),(749,-1583686800,2),(749,-880214400,3),(749,-769395600,4),(749,-765392400,2),(749,-52934400,1),(749,-37213200,2),(749,-21484800,1),(749,-5763600,2),(749,9964800,1),(749,25686000,2),(749,41414400,1),(749,57740400,2),(749,73468800,1),(749,89190000,2),(749,104918400,1),(749,120639600,2),(749,126691200,1),(749,152089200,2),(749,162374400,1),(749,183538800,2),(749,199267200,1),(749,215593200,2),(749,230716800,1),(749,247042800,2),(749,262771200,1),(749,278492400,2),(749,294220800,1),(749,309942000,2),(749,325670400,1),(749,341391600,2),(749,357120000,1),(749,372841200,2),(749,388569600,1),(749,404895600,2),(749,420019200,1),(749,436345200,2),(749,452073600,1),(749,467794800,2),(749,483523200,1),(749,499244400,2),(749,514972800,1),(749,530694000,2),(749,544608000,1),(749,562143600,2),(749,576057600,1),(749,594198000,2),(749,607507200,1),(749,625647600,2),(749,638956800,1),(749,657097200,2),(749,671011200,1),(749,688546800,2),(749,702460800,1),(749,719996400,2),(749,733910400,1),(749,752050800,2),(749,765360000,1),(749,783500400,2),(749,796809600,1),(749,814950000,2),(749,828864000,1),(749,846399600,2),(749,860313600,1),(749,877849200,2),(749,891763200,1),(749,909298800,2),(749,923212800,1),(749,941353200,2),(749,954662400,1),(749,972802800,6),(749,986108400,5),(749,1004248800,6),(749,1018162800,5),(749,1035698400,6),(749,1049612400,5),(749,1067148000,6),(749,1081062000,5),(749,1099202400,6),(749,1112511600,5),(749,1130652000,6),(749,1143961200,5),(749,1162101600,6),(749,1173596400,5),(749,1194156000,6),(749,1205046000,5),(749,1225605600,6),(749,1236495600,5),(749,1257055200,6),(749,1268550000,5),(749,1289109600,6),(749,1299999600,5),(749,1320559200,6),(749,1331449200,5),(749,1352008800,6),(749,1362898800,5),(749,1383458400,6),(749,1394348400,5),(749,1414908000,6),(749,1425798000,5),(749,1446357600,6),(749,1457852400,5),(749,1478412000,6),(749,1489302000,5),(749,1509861600,6),(749,1520751600,5),(749,1541311200,6),(749,1552201200,5),(749,1572760800,6),(749,1583650800,5),(749,1604210400,6),(749,1615705200,5),(749,1636264800,6),(749,1647154800,5),(749,1667714400,6),(749,1678604400,5),(749,1699164000,6),(749,1710054000,5),(749,1730613600,6),(749,1741503600,5),(749,1762063200,6),(749,1772953200,5),(749,1793512800,6),(749,1805007600,5),(749,1825567200,6),(749,1836457200,5),(749,1857016800,6),(749,1867906800,5),(749,1888466400,6),(749,1899356400,5),(749,1919916000,6),(749,1930806000,5),(749,1951365600,6),(749,1962860400,5),(749,1983420000,6),(749,1994310000,5),(749,2014869600,6),(749,2025759600,5),(749,2046319200,6),(749,2057209200,5),(749,2077768800,6),(749,2088658800,5),(749,2109218400,6),(749,2120108400,5),(749,2140668000,6),(750,-2147483648,2),(750,-1633276800,1),(750,-1615136400,2),(750,-1601827200,1),(750,-1583686800,2),(750,-880214400,3),(750,-769395600,4),(750,-765392400,2),(750,-715795200,1),(750,-702493200,2),(750,-684345600,1),(750,-671043600,2),(750,-652896000,1),(750,-639594000,2),(750,-620841600,1),(750,-608144400,2),(750,-589392000,1),(750,-576090000,2),(750,-557942400,1),(750,-544640400,2),(750,-526492800,1),(750,-513190800,2),(750,-495043200,1),(750,-481741200,2),(750,-463593600,1),(750,-447267600,2),(750,-431539200,1),(750,-415818000,2),(750,-400089600,1),(750,-386787600,2),(750,-368640000,1),(750,-355338000,2),(750,-337190400,1),(750,-321469200,2),(750,-305740800,1),(750,-289414800,2),(750,-273686400,1),(750,-257965200,2),(750,-242236800,5),(750,-195066000,2),(750,-84384000,1),(750,-68662800,2),(750,-52934400,1),(750,-37213200,2),(750,-21484800,1),(750,-5763600,2),(750,9964800,1),(750,25686000,2),(750,41414400,1),(750,57740400,2),(750,73468800,1),(750,89190000,2),(750,104918400,1),(750,120639600,2),(750,126691200,1),(750,152089200,2),(750,162374400,1),(750,183538800,2),(750,199267200,1),(750,215593200,2),(750,230716800,1),(750,247042800,2),(750,262771200,1),(750,278492400,2),(750,294220800,1),(750,309942000,2),(750,325670400,1),(750,341391600,2),(750,357120000,1),(750,372841200,2),(750,388569600,1),(750,404895600,2),(750,420019200,1),(750,436345200,2),(750,452073600,1),(750,467794800,2),(750,483523200,1),(750,499244400,2),(750,514972800,1),(750,530694000,2),(750,544608000,1),(750,562143600,2),(750,576057600,1),(750,594198000,2),(750,607507200,1),(750,625647600,2),(750,638956800,1),(750,657097200,2),(750,671011200,1),(750,688546800,5),(750,1143961200,1),(750,1162105200,2),(750,1173600000,1),(750,1194159600,2),(750,1205049600,1),(750,1225609200,2),(750,1236499200,1),(750,1257058800,2),(750,1268553600,1),(750,1289113200,2),(750,1300003200,1),(750,1320562800,2),(750,1331452800,1),(750,1352012400,2),(750,1362902400,1),(750,1383462000,2),(750,1394352000,1),(750,1414911600,2),(750,1425801600,1),(750,1446361200,2),(750,1457856000,1),(750,1478415600,2),(750,1489305600,1),(750,1509865200,2),(750,1520755200,1),(750,1541314800,2),(750,1552204800,1),(750,1572764400,2),(750,1583654400,1),(750,1604214000,2),(750,1615708800,1),(750,1636268400,2),(750,1647158400,1),(750,1667718000,2),(750,1678608000,1),(750,1699167600,2),(750,1710057600,1),(750,1730617200,2),(750,1741507200,1),(750,1762066800,2),(750,1772956800,1),(750,1793516400,2),(750,1805011200,1),(750,1825570800,2),(750,1836460800,1),(750,1857020400,2),(750,1867910400,1),(750,1888470000,2),(750,1899360000,1),(750,1919919600,2),(750,1930809600,1),(750,1951369200,2),(750,1962864000,1),(750,1983423600,2),(750,1994313600,1),(750,2014873200,2),(750,2025763200,1),(750,2046322800,2),(750,2057212800,1),(750,2077772400,2),(750,2088662400,1),(750,2109222000,2),(750,2120112000,1),(750,2140671600,2),(751,-2147483648,0),(751,-1826738653,1),(751,-157750200,2),(752,-2147483648,1),(752,-1205954844,2),(752,-1192307244,3),(752,2147483647,3),(753,-2147483648,1),(753,-1938538284,3),(753,-1009825200,2),(753,-1002052800,3),(753,-986756400,2),(753,-971035200,3),(753,-955306800,2),(753,-939585600,3),(753,504939600,2),(753,512712000,3),(753,536475600,2),(753,544248000,3),(753,631170000,2),(753,638942400,3),(753,757400400,2),(753,765172800,3),(753,2147483647,3),(754,-2147483648,2),(754,-1633269600,1),(754,-1615129200,2),(754,-1601820000,1),(754,-1583679600,2),(754,-880207200,3),(754,-769395600,4),(754,-765385200,2),(754,-687967140,1),(754,-662655600,2),(754,-620838000,1),(754,-608137200,2),(754,-589388400,1),(754,-576082800,2),(754,-557938800,1),(754,-544633200,2),(754,-526489200,1),(754,-513183600,2),(754,-495039600,1),(754,-481734000,2),(754,-463590000,1),(754,-450284400,2),(754,-431535600,1),(754,-418230000,2),(754,-400086000,1),(754,-386780400,2),(754,-368636400,1),(754,-355330800,2),(754,-337186800,1),(754,-323881200,2),(754,-305737200,1),(754,-292431600,2),(754,-273682800,1),(754,-260982000,2),(754,-242233200,1),(754,-226508400,2),(754,-210783600,1),(754,-195058800,2),(754,-179334000,1),(754,-163609200,2),(754,-147884400,1),(754,-131554800,2),(754,-116434800,1),(754,-100105200,2),(754,-84376800,1),(754,-68655600,2),(754,-52927200,1),(754,-37206000,2),(754,-21477600,1),(754,-5756400,2),(754,9972000,1),(754,25693200,2),(754,41421600,1),(754,57747600,2),(754,73476000,1),(754,89197200,2),(754,104925600,1),(754,120646800,2),(754,126698400,1),(754,152096400,2),(754,162381600,1),(754,183546000,2),(754,199274400,1),(754,215600400,2),(754,230724000,1),(754,247050000,2),(754,262778400,1),(754,278499600,2),(754,294228000,1),(754,309949200,2),(754,325677600,1),(754,341398800,2),(754,357127200,1),(754,372848400,2),(754,388576800,1),(754,404902800,2),(754,420026400,1),(754,436352400,2),(754,452080800,1),(754,467802000,2),(754,483530400,1),(754,499251600,2),(754,514980000,1),(754,530701200,2),(754,544615200,1),(754,562150800,2),(754,576064800,1),(754,594205200,2),(754,607514400,1),(754,625654800,2),(754,638964000,1),(754,657104400,2),(754,671018400,1),(754,688554000,2),(754,702468000,1),(754,720003600,2),(754,733917600,1),(754,752058000,2),(754,765367200,1),(754,783507600,2),(754,796816800,1),(754,814957200,2),(754,828871200,1),(754,846406800,2),(754,860320800,1),(754,877856400,2),(754,891770400,1),(754,909306000,2),(754,923220000,1),(754,941360400,2),(754,954669600,1),(754,972810000,2),(754,986119200,1),(754,1004259600,2),(754,1018173600,1),(754,1035709200,2),(754,1049623200,1),(754,1067158800,2),(754,1081072800,1),(754,1099213200,2),(754,1112522400,1),(754,1130662800,2),(754,1143972000,1),(754,1162112400,2),(754,1173607200,1),(754,1194166800,2),(754,1205056800,1),(754,1225616400,2),(754,1236506400,1),(754,1257066000,2),(754,1268560800,1),(754,1289120400,2),(754,1300010400,1),(754,1320570000,2),(754,1331460000,1),(754,1352019600,2),(754,1362909600,1),(754,1383469200,2),(754,1394359200,1),(754,1414918800,2),(754,1425808800,1),(754,1446368400,2),(754,1457863200,1),(754,1478422800,2),(754,1489312800,1),(754,1509872400,2),(754,1520762400,1),(754,1541322000,2),(754,1552212000,1),(754,1572771600,2),(754,1583661600,1),(754,1604221200,2),(754,1615716000,1),(754,1636275600,2),(754,1647165600,1),(754,1667725200,2),(754,1678615200,1),(754,1699174800,2),(754,1710064800,1),(754,1730624400,2),(754,1741514400,1),(754,1762074000,2),(754,1772964000,1),(754,1793523600,2),(754,1805018400,1),(754,1825578000,2),(754,1836468000,1),(754,1857027600,2),(754,1867917600,1),(754,1888477200,2),(754,1899367200,1),(754,1919926800,2),(754,1930816800,1),(754,1951376400,2),(754,1962871200,1),(754,1983430800,2),(754,1994320800,1),(754,2014880400,2),(754,2025770400,1),(754,2046330000,2),(754,2057220000,1),(754,2077779600,2),(754,2088669600,1),(754,2109229200,2),(754,2120119200,1),(754,2140678800,2),(755,-2147483648,2),(755,-1633276800,1),(755,-1615136400,2),(755,-1601827200,1),(755,-1583686800,2),(755,-1535904000,1),(755,-1525280400,2),(755,-905097600,1),(755,-891795600,2),(755,-880214400,3),(755,-769395600,4),(755,-765392400,2),(755,-757360800,1),(755,-744224400,2),(755,-715795200,1),(755,-608144400,2),(755,-589392000,1),(755,-576090000,2),(755,-557942400,1),(755,-544640400,2),(755,-526492800,1),(755,-513190800,2),(755,-495043200,1),(755,-481741200,2),(755,-463593600,1),(755,-450291600,2),(755,-431539200,1),(755,-415818000,2),(755,-400089600,1),(755,-384368400,2),(755,-368640000,1),(755,-352918800,2),(755,-337190400,1),(755,-321469200,2),(755,-305740800,1),(755,-289414800,2),(755,-273686400,1),(755,-266432400,5),(755,-52938000,6),(755,-37216800,5),(755,-21488400,6),(755,-5767200,5),(755,9961200,6),(755,25682400,5),(755,41410800,6),(755,57736800,5),(755,73465200,6),(755,89186400,5),(755,104914800,6),(755,120636000,5),(755,126687600,1),(755,152089200,5),(755,162370800,6),(755,183535200,5),(755,199263600,6),(755,215589600,5),(755,230713200,6),(755,247039200,5),(755,262767600,6),(755,278488800,5),(755,294217200,6),(755,309938400,5),(755,325666800,6),(755,341388000,5),(755,357116400,6),(755,372837600,5),(755,388566000,6),(755,404892000,5),(755,420015600,6),(755,436341600,5),(755,452070000,6),(755,467791200,5),(755,483519600,6),(755,499240800,5),(755,514969200,6),(755,530690400,5),(755,544604400,6),(755,562140000,5),(755,576054000,6),(755,594194400,5),(755,607503600,6),(755,625644000,5),(755,638953200,6),(755,657093600,5),(755,671007600,6),(755,688543200,5),(755,702457200,6),(755,719992800,5),(755,733906800,6),(755,752047200,5),(755,765356400,6),(755,783496800,5),(755,796806000,6),(755,814946400,5),(755,828860400,6),(755,846396000,5),(755,860310000,6),(755,877845600,5),(755,891759600,6),(755,909295200,5),(755,923209200,6),(755,941349600,5),(755,954658800,6),(755,972799200,5),(755,986108400,6),(755,1004248800,5),(755,1018162800,6),(755,1035698400,5),(755,1049612400,6),(755,1067148000,5),(755,1081062000,6),(755,1099202400,5),(755,1112511600,6),(755,1130652000,5),(755,1143961200,6),(755,1162101600,5),(755,1173596400,6),(755,1194156000,5),(755,1205046000,6),(755,1225605600,5),(755,1236495600,6),(755,1257055200,5),(755,1268550000,6),(755,1289109600,5),(755,1299999600,6),(755,1320559200,5),(755,1331449200,6),(755,1352008800,5),(755,1362898800,6),(755,1383458400,5),(755,1394348400,6),(755,1414908000,5),(755,1425798000,6),(755,1446357600,5),(755,1457852400,6),(755,1478412000,5),(755,1489302000,6),(755,1509861600,5),(755,1520751600,6),(755,1541311200,5),(755,1552201200,6),(755,1572760800,5),(755,1583650800,6),(755,1604210400,5),(755,1615705200,6),(755,1636264800,5),(755,1647154800,6),(755,1667714400,5),(755,1678604400,6),(755,1699164000,5),(755,1710054000,6),(755,1730613600,5),(755,1741503600,6),(755,1762063200,5),(755,1772953200,6),(755,1793512800,5),(755,1805007600,6),(755,1825567200,5),(755,1836457200,6),(755,1857016800,5),(755,1867906800,6),(755,1888466400,5),(755,1899356400,6),(755,1919916000,5),(755,1930806000,6),(755,1951365600,5),(755,1962860400,6),(755,1983420000,5),(755,1994310000,6),(755,2014869600,5),(755,2025759600,6),(755,2046319200,5),(755,2057209200,6),(755,2077768800,5),(755,2088658800,6),(755,2109218400,5),(755,2120108400,6),(755,2140668000,5),(756,-2147483648,0),(756,-1826738653,1),(756,-157750200,2),(757,-2147483648,0),(757,-1767217028,2),(757,-1206957600,1),(757,-1191362400,2),(757,-1175374800,1),(757,-1159826400,2),(757,-633819600,1),(757,-622069200,2),(757,-602283600,1),(757,-591832800,2),(757,-570747600,1),(757,-560210400,2),(757,-539125200,1),(757,-531352800,2),(757,-191365200,1),(757,-184197600,2),(757,-155163600,1),(757,-150069600,2),(757,-128898000,1),(757,-121125600,2),(757,-99954000,1),(757,-89589600,2),(757,-68418000,1),(757,-57967200,2),(757,499748400,1),(757,511236000,2),(757,530593200,1),(757,540266400,2),(757,562129200,1),(757,571197600,2),(757,592974000,1),(757,602042400,2),(757,624423600,1),(757,634701600,2),(757,813726000,1),(757,824004000,2),(757,938919600,1),(757,951616800,2),(757,970974000,1),(757,972180000,2),(757,1003028400,1),(757,1013911200,2),(757,2147483647,2),(758,-2147483648,1),(758,-1121105688,2),(758,105084000,3),(758,161758800,2),(758,290584800,4),(758,299134800,2),(758,322034400,4),(758,330584400,2),(758,694260000,3),(758,717310800,2),(758,725868000,3),(758,852094800,2),(758,1113112800,4),(758,1128229200,2),(758,1146384000,4),(758,1159682400,2),(759,-2147483648,0),(759,-1767211196,2),(759,-1206954000,1),(759,-1191358800,2),(759,-1175371200,1),(759,-1159822800,2),(759,-633816000,1),(759,-622065600,2),(759,-602280000,1),(759,-591829200,2),(759,-570744000,1),(759,-560206800,2),(759,-539121600,1),(759,-531349200,2),(759,-191361600,1),(759,-184194000,2),(759,-155160000,1),(759,-150066000,2),(759,-128894400,1),(759,-121122000,2),(759,-99950400,1),(759,-89586000,2),(759,-68414400,1),(759,-57963600,2),(759,499752000,1),(759,511239600,2),(759,530596800,1),(759,540270000,2),(759,562132800,1),(759,571201200,2),(759,750830400,1),(759,761713200,2),(759,2147483647,2),(760,-2147483648,0),(760,-1825098836,1),(761,-2147483648,1),(761,-1851537340,2),(761,323841600,3),(761,338958000,2),(762,-2147483648,0),(762,-1514743200,1),(762,576057600,2),(762,594198000,1),(762,828864000,2),(762,846399600,1),(762,860313600,2),(762,877849200,1),(762,891763200,2),(762,909298800,1),(762,923212800,2),(762,941353200,1),(762,954662400,2),(762,972802800,1),(762,989136000,2),(762,1001833200,1),(762,1018166400,2),(762,1035702000,1),(762,1049616000,2),(762,1067151600,1),(762,1081065600,2),(762,1099206000,1),(762,1112515200,2),(762,1130655600,1),(762,1143964800,2),(762,1162105200,1),(762,1175414400,2),(762,1193554800,1),(762,1207468800,2),(762,1225004400,1),(762,1238918400,2),(762,1256454000,1),(762,1268553600,2),(762,1289113200,1),(762,1300003200,2),(762,1320562800,1),(762,1331452800,2),(762,1352012400,1),(762,1362902400,2),(762,1383462000,1),(762,1394352000,2),(762,1414911600,1),(762,1425801600,2),(762,1446361200,1),(762,1457856000,2),(762,1478415600,1),(762,1489305600,2),(762,1509865200,1),(762,1520755200,2),(762,1541314800,1),(762,1552204800,2),(762,1572764400,1),(762,1583654400,2),(762,1604214000,1),(762,1615708800,2),(762,1636268400,1),(762,1647158400,2),(762,1667718000,1),(762,1678608000,2),(762,1699167600,1),(762,1710057600,2),(762,1730617200,1),(762,1741507200,2),(762,1762066800,1),(762,1772956800,2),(762,1793516400,1),(762,1805011200,2),(762,1825570800,1),(762,1836460800,2),(762,1857020400,1),(762,1867910400,2),(762,1888470000,1),(762,1899360000,2),(762,1919919600,1),(762,1930809600,2),(762,1951369200,1),(762,1962864000,2),(762,1983423600,1),(762,1994313600,2),(762,2014873200,1),(762,2025763200,2),(762,2046322800,1),(762,2057212800,2),(762,2077772400,1),(762,2088662400,2),(762,2109222000,1),(762,2120112000,2),(762,2140671600,1),(763,-2147483648,0),(763,-1514739600,1),(763,-1343066400,2),(763,-1234807200,1),(763,-1220292000,2),(763,-1207159200,1),(763,-1191344400,2),(763,-873828000,1),(763,-661539600,3),(763,28800,1),(763,828867600,4),(763,846403200,1),(763,860317200,4),(763,877852800,1),(763,891766800,4),(763,909302400,1),(763,923216400,4),(763,941356800,1),(763,954666000,4),(763,972806400,1),(763,989139600,4),(763,1001836800,1),(763,1018170000,4),(763,1035705600,1),(763,1049619600,4),(763,1067155200,1),(763,1081069200,4),(763,1099209600,1),(763,1112518800,4),(763,1130659200,1),(763,1143968400,4),(763,1162108800,1),(763,1175418000,4),(763,1193558400,1),(763,1207472400,4),(763,1225008000,1),(763,1238922000,4),(763,1256457600,1),(763,1270371600,4),(763,1288512000,1),(763,1301821200,4),(763,1319961600,1),(763,1333270800,4),(763,1351411200,1),(763,1365325200,4),(763,1382860800,1),(763,1396774800,4),(763,1414310400,1),(763,1428224400,4),(763,1445760000,1),(763,1459674000,4),(763,1477814400,1),(763,1491123600,4),(763,1509264000,1),(763,1522573200,4),(763,1540713600,1),(763,1554627600,4),(763,1572163200,1),(763,1586077200,4),(763,1603612800,1),(763,1617526800,4),(763,1635667200,1),(763,1648976400,4),(763,1667116800,1),(763,1680426000,4),(763,1698566400,1),(763,1712480400,4),(763,1730016000,1),(763,1743930000,4),(763,1761465600,1),(763,1775379600,4),(763,1792915200,1),(763,1806829200,4),(763,1824969600,1),(763,1838278800,4),(763,1856419200,1),(763,1869728400,4),(763,1887868800,1),(763,1901782800,4),(763,1919318400,1),(763,1933232400,4),(763,1950768000,1),(763,1964682000,4),(763,1982822400,1),(763,1996131600,4),(763,2014272000,1),(763,2027581200,4),(763,2045721600,1),(763,2059030800,4),(763,2077171200,1),(763,2091085200,4),(763,2108620800,1),(763,2122534800,4),(763,2140070400,1),(764,-2147483648,1),(764,-1567453392,2),(764,-1233432000,3),(764,-1222981200,2),(764,-1205956800,3),(764,-1194037200,2),(764,-1172865600,3),(764,-1162501200,2),(764,-1141329600,3),(764,-1130965200,2),(764,-1109793600,3),(764,-1099429200,2),(764,-1078257600,3),(764,-1067806800,2),(764,-1046635200,3),(764,-1036270800,2),(764,-1015099200,3),(764,-1004734800,2),(764,-983563200,3),(764,-973198800,2),(764,-952027200,3),(764,-941576400,2),(764,-931032000,3),(764,-900882000,2),(764,-890337600,3),(764,-833749200,2),(764,-827265600,3),(764,-752274000,2),(764,-733780800,3),(764,-197326800,2),(764,-190843200,3),(764,-184194000,2),(764,-164491200,3),(764,-152658000,2),(764,-132955200,3),(764,-121122000,2),(764,-101419200,3),(764,-86821200,2),(764,-71092800,3),(764,-54766800,2),(764,-39038400,3),(764,-23317200,2),(764,-7588800,5),(764,128142000,4),(764,136605600,5),(764,596948400,4),(764,605066400,5),(764,624423600,4),(764,636516000,2),(764,655963200,3),(764,667796400,2),(764,687499200,3),(764,699418800,2),(764,719380800,4),(764,731469600,5),(764,938919600,3),(764,952052400,5),(764,1085281200,2),(764,1096171200,5),(764,1198983600,4),(764,1205632800,5),(764,2147483647,5),(765,-2147483648,2),(765,-1633276800,1),(765,-1615136400,2),(765,-1601827200,1),(765,-1583686800,2),(765,-880214400,3),(765,-769395600,4),(765,-765392400,2),(765,-747244800,1),(765,-733942800,2),(765,-116438400,1),(765,-100112400,2),(765,-21484800,5),(765,104914800,1),(765,120639600,2),(765,126691200,1),(765,152089200,2),(765,162374400,1),(765,183538800,2),(765,199267200,1),(765,215593200,2),(765,230716800,1),(765,247042800,2),(765,262771200,1),(765,278492400,2),(765,294220800,1),(765,309942000,2),(765,325670400,1),(765,341391600,2),(765,357120000,1),(765,372841200,2),(765,388569600,1),(765,404895600,2),(765,420019200,1),(765,436345200,2),(765,452073600,1),(765,467794800,2),(765,483523200,1),(765,499244400,2),(765,514972800,1),(765,530694000,2),(765,544608000,1),(765,562143600,2),(765,576057600,1),(765,594198000,2),(765,607507200,1),(765,625647600,2),(765,638956800,1),(765,657097200,2),(765,671011200,1),(765,688546800,2),(765,702460800,1),(765,719996400,2),(765,733910400,1),(765,752050800,2),(765,765360000,1),(765,783500400,2),(765,796809600,1),(765,814950000,2),(765,828864000,1),(765,846399600,2),(765,860313600,1),(765,877849200,2),(765,891763200,1),(765,909298800,2),(765,923212800,1),(765,941353200,2),(765,954662400,1),(765,972802800,2),(765,986112000,1),(765,1004252400,2),(765,1018166400,1),(765,1035702000,2),(765,1049616000,1),(765,1067151600,2),(765,1081065600,1),(765,1099206000,2),(765,1112515200,1),(765,1130655600,2),(765,1143964800,1),(765,1162105200,2),(765,1173600000,1),(765,1194159600,2),(765,1205049600,1),(765,1225609200,2),(765,1236499200,1),(765,1257058800,2),(765,1268553600,1),(765,1289113200,2),(765,1300003200,1),(765,1320562800,2),(765,1331452800,1),(765,1352012400,2),(765,1362902400,1),(765,1383462000,2),(765,1394352000,1),(765,1414911600,2),(765,1425801600,1),(765,1446361200,2),(765,1457856000,1),(765,1478415600,2),(765,1489305600,1),(765,1509865200,2),(765,1520755200,1),(765,1541314800,2),(765,1552204800,1),(765,1572764400,2),(765,1583654400,1),(765,1604214000,2),(765,1615708800,1),(765,1636268400,2),(765,1647158400,1),(765,1667718000,2),(765,1678608000,1),(765,1699167600,2),(765,1710057600,1),(765,1730617200,2),(765,1741507200,1),(765,1762066800,2),(765,1772956800,1),(765,1793516400,2),(765,1805011200,1),(765,1825570800,2),(765,1836460800,1),(765,1857020400,2),(765,1867910400,1),(765,1888470000,2),(765,1899360000,1),(765,1919919600,2),(765,1930809600,1),(765,1951369200,2),(765,1962864000,1),(765,1983423600,2),(765,1994313600,1),(765,2014873200,2),(765,2025763200,1),(765,2046322800,2),(765,2057212800,1),(765,2077772400,2),(765,2088662400,1),(765,2109222000,2),(765,2120112000,1),(765,2140671600,2),(766,-2147483648,0),(766,-1514743200,1),(766,377935200,2),(766,407653200,1),(766,828864000,3),(766,846399600,1),(766,860313600,3),(766,877849200,1),(766,891763200,3),(766,909298800,1),(766,923212800,3),(766,941353200,1),(766,954662400,3),(766,972802800,1),(766,989136000,3),(766,1001833200,1),(766,1018166400,3),(766,1035702000,1),(766,1049616000,3),(766,1067151600,1),(766,1081065600,3),(766,1099206000,1),(766,1112515200,3),(766,1130655600,1),(766,1143964800,3),(766,1162105200,1),(766,1175414400,3),(766,1193554800,1),(766,1207468800,3),(766,1225004400,1),(766,1238918400,3),(766,1256454000,1),(766,1270368000,3),(766,1288508400,1),(766,1301817600,3),(766,1319958000,1),(766,1333267200,3),(766,1351407600,1),(766,1365321600,3),(766,1382857200,1),(766,1396771200,3),(766,1414306800,1),(766,1428220800,3),(766,1445756400,1),(766,1459670400,3),(766,1477810800,1),(766,1491120000,3),(766,1509260400,1),(766,1522569600,3),(766,1540710000,1),(766,1554624000,3),(766,1572159600,1),(766,1586073600,3),(766,1603609200,1),(766,1617523200,3),(766,1635663600,1),(766,1648972800,3),(766,1667113200,1),(766,1680422400,3),(766,1698562800,1),(766,1712476800,3),(766,1730012400,1),(766,1743926400,3),(766,1761462000,1),(766,1775376000,3),(766,1792911600,1),(766,1806825600,3),(766,1824966000,1),(766,1838275200,3),(766,1856415600,1),(766,1869724800,3),(766,1887865200,1),(766,1901779200,3),(766,1919314800,1),(766,1933228800,3),(766,1950764400,1),(766,1964678400,3),(766,1982818800,1),(766,1996128000,3),(766,2014268400,1),(766,2027577600,3),(766,2045718000,1),(766,2059027200,3),(766,2077167600,1),(766,2091081600,3),(766,2108617200,1),(766,2122531200,3),(766,2140066800,1),(767,-2147483648,1),(767,-880207200,2),(767,-769395600,3),(767,-765385200,1),(767,-21477600,4),(767,-5756400,1),(767,9972000,4),(767,25693200,1),(767,41421600,4),(767,57747600,1),(767,73476000,4),(767,89197200,1),(767,104925600,4),(767,120646800,1),(767,126698400,4),(767,152096400,1),(767,162381600,4),(767,183546000,1),(767,199274400,4),(767,215600400,1),(767,230724000,4),(767,247050000,1),(767,262778400,4),(767,278499600,1),(767,294228000,4),(767,309949200,1),(767,325677600,4),(767,341398800,1),(767,357127200,4),(767,372848400,1),(767,388576800,4),(767,404902800,1),(767,420026400,4),(767,436352400,1),(767,1446372000,5),(767,1457866800,6),(767,1478426400,5),(767,1489316400,6),(767,1509876000,5),(767,1520766000,6),(767,1541325600,1),(767,1547978400,5),(767,1552215600,6),(767,1572775200,5),(767,1583665200,6),(767,1604224800,5),(767,1615719600,6),(767,1636279200,5),(767,1647169200,6),(767,1667728800,5),(767,1678618800,6),(767,1699178400,5),(767,1710068400,6),(767,1730628000,5),(767,1741518000,6),(767,1762077600,5),(767,1772967600,6),(767,1793527200,5),(767,1805022000,6),(767,1825581600,5),(767,1836471600,6),(767,1857031200,5),(767,1867921200,6),(767,1888480800,5),(767,1899370800,6),(767,1919930400,5),(767,1930820400,6),(767,1951380000,5),(767,1962874800,6),(767,1983434400,5),(767,1994324400,6),(767,2014884000,5),(767,2025774000,6),(767,2046333600,5),(767,2057223600,6),(767,2077783200,5),(767,2088673200,6),(767,2109232800,5),(767,2120122800,6),(767,2140682400,5),(768,-2147483648,0),(768,-1514739600,1),(768,-1343066400,2),(768,-1234807200,1),(768,-1220292000,2),(768,-1207159200,1),(768,-1191344400,2),(768,-975261600,3),(768,-963169200,2),(768,-917114400,3),(768,-907354800,2),(768,-821901600,4),(768,-810068400,2),(768,-627501600,3),(768,-612990000,2),(768,828864000,3),(768,846399600,2),(768,860313600,3),(768,877849200,2),(768,891763200,3),(768,909298800,2),(768,923212800,3),(768,941353200,2),(768,954662400,3),(768,972802800,2),(768,989136000,3),(768,1001833200,2),(768,1018166400,3),(768,1035702000,2),(768,1049616000,3),(768,1067151600,2),(768,1081065600,3),(768,1099206000,2),(768,1112515200,3),(768,1130655600,2),(768,1143964800,3),(768,1162105200,2),(768,1175414400,3),(768,1193554800,2),(768,1207468800,3),(768,1225004400,2),(768,1238918400,3),(768,1256454000,2),(768,1270368000,3),(768,1288508400,2),(768,1301817600,3),(768,1319958000,2),(768,1333267200,3),(768,1351407600,2),(768,1365321600,3),(768,1382857200,2),(768,1396771200,3),(768,1414306800,2),(768,1428220800,3),(768,1445756400,2),(768,1459670400,3),(768,1477810800,2),(768,1491120000,3),(768,1509260400,2),(768,1522569600,3),(768,1540710000,2),(768,1554624000,3),(768,1572159600,2),(768,1586073600,3),(768,1603609200,2),(768,1617523200,3),(768,1635663600,2),(768,1648972800,3),(768,1667113200,2),(768,1680422400,3),(768,1698562800,2),(768,1712476800,3),(768,1730012400,2),(768,1743926400,3),(768,1761462000,2),(768,1775376000,3),(768,1792911600,2),(768,1806825600,3),(768,1824966000,2),(768,1838275200,3),(768,1856415600,2),(768,1869724800,3),(768,1887865200,2),(768,1901779200,3),(768,1919314800,2),(768,1933228800,3),(768,1950764400,2),(768,1964678400,3),(768,1982818800,2),(768,1996128000,3),(768,2014268400,2),(768,2027577600,3),(768,2045718000,2),(768,2059027200,3),(768,2077167600,2),(768,2091081600,3),(768,2108617200,2),(768,2122531200,3),(768,2140066800,2),(769,-2147483648,0),(769,-1850328920,1),(769,326001600,2),(769,544597200,3),(769,562132800,2),(769,576046800,3),(769,594187200,2),(769,607496400,3),(769,625636800,2),(769,638946000,3),(769,657086400,2),(769,671000400,3),(769,688536000,2),(769,702450000,3),(769,719985600,2),(769,733899600,3),(769,752040000,2),(769,765349200,3),(769,783489600,2),(769,796798800,3),(769,814939200,2),(769,828853200,3),(769,846388800,2),(769,860302800,3),(769,877838400,2),(769,891752400,3),(769,909288000,2),(769,923202000,3),(769,941342400,2),(769,954651600,3),(769,972792000,2),(769,986101200,3),(769,1004241600,2),(769,1018155600,3),(769,1035691200,2),(769,1049605200,3),(769,1067140800,2),(769,1081054800,3),(769,1099195200,2),(769,1112504400,3),(769,1130644800,2),(769,1143954000,3),(769,1162094400,2),(769,1173589200,3),(769,1194148800,2),(769,1205038800,3),(769,1225598400,2),(769,1236488400,3),(769,1257048000,2),(769,1268542800,3),(769,1289102400,2),(769,1299992400,3),(769,1320552000,2),(769,1331442000,3),(769,1352001600,2),(769,1362891600,3),(769,1383451200,2),(769,1394341200,3),(769,1414900800,2),(769,1425790800,3),(769,1446350400,2),(769,1457845200,3),(769,1478404800,2),(769,1489294800,3),(769,1509854400,2),(769,1520744400,3),(769,1541304000,2),(769,1552194000,3),(769,1572753600,2),(769,1583643600,3),(769,1604203200,2),(769,1615698000,3),(769,1636257600,2),(769,1647147600,3),(769,1667707200,2),(769,1678597200,3),(769,1699156800,2),(769,1710046800,3),(769,1730606400,2),(769,1741496400,3),(769,1762056000,2),(769,1772946000,3),(769,1793505600,2),(769,1805000400,3),(769,1825560000,2),(769,1836450000,3),(769,1857009600,2),(769,1867899600,3),(769,1888459200,2),(769,1899349200,3),(769,1919908800,2),(769,1930798800,3),(769,1951358400,2),(769,1962853200,3),(769,1983412800,2),(769,1994302800,3),(769,2014862400,2),(769,2025752400,3),(769,2046312000,2),(769,2057202000,3),(769,2077761600,2),(769,2088651600,3),(769,2109211200,2),(769,2120101200,3),(769,2140660800,2),(769,2147483647,2),(770,-2147483648,1),(770,-2131642800,3),(770,-1632074400,2),(770,-1615143600,3),(770,-1153681200,2),(770,-1145822400,3),(770,-1122231600,2),(770,-1114372800,3),(770,-1090782000,2),(770,-1082923200,3),(770,-1059332400,2),(770,-1051473600,3),(770,-1027882800,2),(770,-1020024000,3),(770,-996433200,2),(770,-988574400,3),(770,-965674800,2),(770,-955396800,3),(770,-934743600,2),(770,-923947200,3),(770,-904503600,2),(770,-891892800,3),(770,-880221600,4),(770,-769395600,5),(770,-765399600,3),(770,-747252000,2),(770,-733950000,3),(770,-715802400,2),(770,-702500400,3),(770,-684352800,2),(770,-671050800,3),(770,-652903200,2),(770,-639601200,3),(770,-620848800,2),(770,-608151600,3),(770,-589399200,2),(770,-576097200,3),(770,-557949600,2),(770,-544647600,3),(770,-526500000,2),(770,-513198000,3),(770,-495050400,2),(770,-481748400,3),(770,-463600800,2),(770,-450298800,3),(770,-431546400,2),(770,-418244400,3),(770,-400096800,2),(770,-384375600,3),(770,-368647200,2),(770,-352926000,3),(770,-337197600,2),(770,-321476400,3),(770,-305748000,2),(770,-289422000,3),(770,-273693600,2),(770,-257972400,3),(770,-242244000,2),(770,-226522800,3),(770,-210794400,2),(770,-195073200,3),(770,-179344800,2),(770,-163623600,3),(770,-147895200,2),(770,-131569200,3),(770,-116445600,2),(770,-100119600,3),(770,-84391200,2),(770,-68670000,3),(770,-52941600,2),(770,-37220400,3),(770,-21492000,2),(770,-5770800,3),(770,9957600,2),(770,25678800,3),(770,41407200,2),(770,57733200,3),(770,73461600,2),(770,89182800,3),(770,136360800,2),(770,152082000,3),(770,167810400,2),(770,183531600,3),(770,199260000,2),(770,215586000,3),(770,230709600,2),(770,247035600,3),(770,262764000,2),(770,278485200,3),(770,294213600,2),(770,309934800,3),(770,325663200,2),(770,341384400,3),(770,357112800,2),(770,372834000,3),(770,388562400,2),(770,404888400,3),(770,420012000,2),(770,436338000,3),(770,452066400,2),(770,467787600,3),(770,483516000,2),(770,499237200,3),(770,514965600,2),(770,530686800,3),(770,544600800,2),(770,562136400,3),(770,576050400,2),(770,594190800,3),(770,607500000,2),(770,625640400,3),(770,638949600,2),(770,657090000,3),(770,671004000,2),(770,688539600,3),(770,702453600,2),(770,719989200,3),(770,733896060,2),(770,752036460,3),(770,765345660,2),(770,783486060,3),(770,796795260,2),(770,814935660,3),(770,828849660,2),(770,846385260,3),(770,860299260,2),(770,877834860,3),(770,891748860,2),(770,909284460,3),(770,923198460,2),(770,941338860,3),(770,954648060,2),(770,972788460,3),(770,986097660,2),(770,1004238060,3),(770,1018152060,2),(770,1035687660,3),(770,1049601660,2),(770,1067137260,3),(770,1081051260,2),(770,1099191660,3),(770,1112500860,2),(770,1130641260,3),(770,1143950460,2),(770,1162090860,3),(770,1173592800,2),(770,1194152400,3),(770,1205042400,2),(770,1225602000,3),(770,1236492000,2),(770,1257051600,3),(770,1268546400,2),(770,1289106000,3),(770,1299996000,2),(770,1320555600,3),(770,1331445600,2),(770,1352005200,3),(770,1362895200,2),(770,1383454800,3),(770,1394344800,2),(770,1414904400,3),(770,1425794400,2),(770,1446354000,3),(770,1457848800,2),(770,1478408400,3),(770,1489298400,2),(770,1509858000,3),(770,1520748000,2),(770,1541307600,3),(770,1552197600,2),(770,1572757200,3),(770,1583647200,2),(770,1604206800,3),(770,1615701600,2),(770,1636261200,3),(770,1647151200,2),(770,1667710800,3),(770,1678600800,2),(770,1699160400,3),(770,1710050400,2),(770,1730610000,3),(770,1741500000,2),(770,1762059600,3),(770,1772949600,2),(770,1793509200,3),(770,1805004000,2),(770,1825563600,3),(770,1836453600,2),(770,1857013200,3),(770,1867903200,2),(770,1888462800,3),(770,1899352800,2),(770,1919912400,3),(770,1930802400,2),(770,1951362000,3),(770,1962856800,2),(770,1983416400,3),(770,1994306400,2),(770,2014866000,3),(770,2025756000,2),(770,2046315600,3),(770,2057205600,2),(770,2077765200,3),(770,2088655200,2),(770,2109214800,3),(770,2120104800,2),(770,2140664400,3),(771,-2147483648,0),(771,-1514743200,1),(771,576057600,2),(771,594198000,1),(771,828864000,2),(771,846399600,1),(771,860313600,2),(771,877849200,1),(771,891763200,2),(771,909298800,1),(771,923212800,2),(771,941353200,1),(771,954662400,2),(771,972802800,1),(771,989136000,2),(771,1001833200,1),(771,1018166400,2),(771,1035702000,1),(771,1049616000,2),(771,1067151600,1),(771,1081065600,2),(771,1099206000,1),(771,1112515200,2),(771,1130655600,1),(771,1143964800,2),(771,1162105200,1),(771,1175414400,2),(771,1193554800,1),(771,1207468800,2),(771,1225004400,1),(771,1238918400,2),(771,1256454000,1),(771,1270368000,2),(771,1288508400,1),(771,1301817600,2),(771,1319958000,1),(771,1333267200,2),(771,1351407600,1),(771,1365321600,2),(771,1382857200,1),(771,1396771200,2),(771,1414306800,1),(771,1428220800,2),(771,1445756400,1),(771,1459670400,2),(771,1477810800,1),(771,1491120000,2),(771,1509260400,1),(771,1522569600,2),(771,1540710000,1),(771,1554624000,2),(771,1572159600,1),(771,1586073600,2),(771,1603609200,1),(771,1617523200,2),(771,1635663600,1),(771,1648972800,2),(771,1667113200,1),(771,1680422400,2),(771,1698562800,1),(771,1712476800,2),(771,1730012400,1),(771,1743926400,2),(771,1761462000,1),(771,1775376000,2),(771,1792911600,1),(771,1806825600,2),(771,1824966000,1),(771,1838275200,2),(771,1856415600,1),(771,1869724800,2),(771,1887865200,1),(771,1901779200,2),(771,1919314800,1),(771,1933228800,2),(771,1950764400,1),(771,1964678400,2),(771,1982818800,1),(771,1996128000,2),(771,2014268400,1),(771,2027577600,2),(771,2045718000,1),(771,2059027200,2),(771,2077167600,1),(771,2091081600,2),(771,2108617200,1),(771,2122531200,2),(771,2140066800,1),(772,-2147483648,0),(772,-1942690509,1),(772,-1567455309,2),(772,-1459627200,4),(772,-1443819600,3),(772,-1428006600,4),(772,-1412283600,3),(772,-1396470600,4),(772,-1380747600,3),(772,-1141590600,4),(772,-1128286800,3),(772,-1110141000,4),(772,-1096837200,3),(772,-1078691400,4),(772,-1065387600,3),(772,-1047241800,4),(772,-1033938000,3),(772,-1015187400,4),(772,-1002488400,3),(772,-983737800,4),(772,-971038800,3),(772,-954707400,4),(772,-938984400,3),(772,-920838600,4),(772,-907534800,3),(772,-896819400,4),(772,-853621200,6),(772,-845847000,5),(772,-334789200,6),(772,-319671000,5),(772,-314226000,7),(772,-309996000,5),(772,-149720400,7),(772,-134604000,5),(772,-50446800,6),(772,-34205400,5),(772,9860400,7),(772,14176800,5),(772,72846000,7),(772,80100000,5),(772,127278000,8),(772,132111000,6),(772,147234600,5),(772,156913200,7),(772,165376800,5),(772,219812400,7),(772,226461600,5),(772,250052400,7),(772,257911200,5),(772,282711600,7),(772,289360800,5),(772,294202800,7),(772,322020000,5),(772,566449200,7),(772,573012000,5),(772,597812400,7),(772,605066400,5),(772,625633200,7),(772,635911200,5),(772,656478000,7),(772,667965600,5),(772,688532400,7),(772,699415200,5),(772,719377200,7),(772,730864800,5),(772,1095562800,7),(772,1111896000,5),(772,1128834000,7),(772,1142136000,5),(772,1159678800,7),(772,1173585600,5),(772,1191733200,7),(772,1205035200,5),(772,1223182800,7),(772,1236484800,5),(772,1254632400,7),(772,1268539200,5),(772,1286082000,7),(772,1299988800,5),(772,1317531600,7),(772,1331438400,5),(772,1349586000,7),(772,1362888000,5),(772,1381035600,7),(772,1394337600,5),(772,1412485200,7),(772,1425787200,5),(772,2147483647,5),(773,-2147483648,2),(773,-1632070800,1),(773,-1615140000,2),(773,-1601753400,1),(773,-1583697600,2),(773,-1567357200,1),(773,-1554667200,2),(773,-1534698000,1),(773,-1524074400,2),(773,-1503248400,1),(773,-1492365600,2),(773,-1471798800,1),(773,-1460916000,2),(773,-1440954000,1),(773,-1428861600,2),(773,-1409504400,1),(773,-1397412000,2),(773,-1378054800,1),(773,-1365962400,2),(773,-1346605200,1),(773,-1333908000,2),(773,-1315155600,1),(773,-1301853600,2),(773,-1283706000,1),(773,-1270404000,2),(773,-1252256400,1),(773,-1238954400,2),(773,-1220806800,1),(773,-1207504800,2),(773,-1188752400,1),(773,-1176055200,2),(773,-1157302800,1),(773,-1144000800,2),(773,-1125853200,1),(773,-1112551200,2),(773,-1094403600,1),(773,-1081101600,2),(773,-1062954000,1),(773,-1049652000,2),(773,-1031504400,1),(773,-1018202400,2),(773,-1000054800,1),(773,-986752800,2),(773,-968000400,1),(773,-955303200,2),(773,-936550800,1),(773,-880218000,3),(773,-769395600,4),(773,-765396000,2),(773,-747248400,1),(773,-733946400,2),(773,-715806000,1),(773,-702504000,2),(773,-684356400,1),(773,-671054400,2),(773,-652906800,1),(773,-634161600,2),(773,-620845200,1),(773,-602704800,2),(773,-589395600,1),(773,-576093600,2),(773,-557946000,1),(773,-544644000,2),(773,-526496400,1),(773,-513194400,2),(773,-495046800,1),(773,-481744800,2),(773,-463597200,1),(773,-450295200,2),(773,-431542800,1),(773,-418240800,2),(773,-400093200,1),(773,-384372000,2),(773,-368643600,1),(773,-352922400,2),(773,-337194000,1),(773,-321472800,2),(773,-305744400,1),(773,-289418400,2),(773,-273690000,1),(773,-257968800,2),(773,-242240400,1),(773,-226519200,2),(773,-210790800,1),(773,-195069600,2),(773,-179341200,1),(773,-163620000,2),(773,-147891600,1),(773,-131565600,2),(773,-116442000,1),(773,-100116000,2),(773,-84387600,1),(773,-68666400,2),(773,-52938000,1),(773,-37216800,2),(773,-21488400,1),(773,-5767200,2),(773,9961200,1),(773,25682400,2),(773,41410800,1),(773,57736800,2),(773,73465200,1),(773,89186400,2),(773,104914800,1),(773,120636000,2),(773,136364400,1),(773,152085600,2),(773,167814000,1),(773,183535200,2),(773,199263600,1),(773,215589600,2),(773,230713200,1),(773,247039200,2),(773,262767600,1),(773,278488800,2),(773,294217200,1),(773,309938400,2),(773,325666800,1),(773,341388000,2),(773,357116400,1),(773,372837600,2),(773,388566000,1),(773,404892000,2),(773,420015600,1),(773,436341600,2),(773,452070000,1),(773,467791200,2),(773,483519600,1),(773,499240800,2),(773,514969200,1),(773,530690400,2),(773,544604400,1),(773,562140000,2),(773,576054000,1),(773,594194400,2),(773,607503600,1),(773,625644000,2),(773,638953200,1),(773,657093600,2),(773,671007600,1),(773,688543200,2),(773,702457200,1),(773,719992800,2),(773,733906800,1),(773,752047200,2),(773,765356400,1),(773,783496800,2),(773,796806000,1),(773,814946400,2),(773,828860400,1),(773,846396000,2),(773,860310000,1),(773,877845600,2),(773,891759600,1),(773,909295200,2),(773,923209200,1),(773,941349600,2),(773,954658800,1),(773,972799200,2),(773,986108400,1),(773,1004248800,2),(773,1018162800,1),(773,1035698400,2),(773,1049612400,1),(773,1067148000,2),(773,1081062000,1),(773,1099202400,2),(773,1112511600,1),(773,1130652000,2),(773,1143961200,1),(773,1162101600,2),(773,1173596400,1),(773,1194156000,2),(773,1205046000,1),(773,1225605600,2),(773,1236495600,1),(773,1257055200,2),(773,1268550000,1),(773,1289109600,2),(773,1299999600,1),(773,1320559200,2),(773,1331449200,1),(773,1352008800,2),(773,1362898800,1),(773,1383458400,2),(773,1394348400,1),(773,1414908000,2),(773,1425798000,1),(773,1446357600,2),(773,1457852400,1),(773,1478412000,2),(773,1489302000,1),(773,1509861600,2),(773,1520751600,1),(773,1541311200,2),(773,1552201200,1),(773,1572760800,2),(773,1583650800,1),(773,1604210400,2),(773,1615705200,1),(773,1636264800,2),(773,1647154800,1),(773,1667714400,2),(773,1678604400,1),(773,1699164000,2),(773,1710054000,1),(773,1730613600,2),(773,1741503600,1),(773,1762063200,2),(773,1772953200,1),(773,1793512800,2),(773,1805007600,1),(773,1825567200,2),(773,1836457200,1),(773,1857016800,2),(773,1867906800,1),(773,1888466400,2),(773,1899356400,1),(773,1919916000,2),(773,1930806000,1),(773,1951365600,2),(773,1962860400,1),(773,1983420000,2),(773,1994310000,1),(773,2014869600,2),(773,2025759600,1),(773,2046319200,2),(773,2057209200,1),(773,2077768800,2),(773,2088658800,1),(773,2109218400,2),(773,2120108400,1),(773,2140668000,2),(774,-2147483648,0),(774,-1825098836,1),(775,-2147483648,0),(775,-1825095030,2),(775,-179341200,1),(775,-163620000,2),(775,-147891600,1),(775,-131565600,2),(775,-116442000,1),(775,-100116000,2),(775,-84387600,1),(775,-68666400,2),(775,-52938000,1),(775,-37216800,2),(775,-21488400,1),(775,-5767200,2),(775,9961200,1),(775,25682400,2),(775,41410800,1),(775,57736800,2),(775,73465200,1),(775,89186400,2),(775,104914800,1),(775,120636000,2),(775,136364400,1),(775,152085600,2),(775,167814000,1),(775,183535200,2),(775,199263600,1),(775,215589600,2),(775,230713200,1),(775,247039200,2),(775,262767600,1),(775,278488800,2),(775,294217200,1),(775,309938400,2),(775,325666800,1),(775,341388000,2),(775,357116400,1),(775,372837600,2),(775,388566000,1),(775,404892000,2),(775,420015600,1),(775,436341600,2),(775,452070000,1),(775,467791200,2),(775,483519600,1),(775,499240800,2),(775,514969200,1),(775,530690400,2),(775,544604400,1),(775,562140000,2),(775,576054000,1),(775,594194400,2),(775,607503600,1),(775,625644000,2),(775,638953200,1),(775,657093600,2),(775,671007600,1),(775,688543200,2),(775,702457200,1),(775,719992800,2),(775,733906800,1),(775,752047200,2),(775,765356400,1),(775,783496800,2),(775,796806000,1),(775,814946400,2),(775,828860400,1),(775,846396000,2),(775,860310000,1),(775,877845600,2),(775,891759600,1),(775,909295200,2),(775,923209200,1),(775,941349600,2),(775,954658800,1),(775,972799200,2),(775,986108400,1),(775,1004248800,2),(775,1018162800,1),(775,1035698400,2),(775,1049612400,1),(775,1067148000,2),(775,1081062000,1),(775,1099202400,2),(775,1112511600,1),(775,1130652000,2),(775,1143961200,1),(775,1162101600,2),(775,1173596400,1),(775,1194156000,2),(775,1205046000,1),(775,1225605600,2),(775,1236495600,1),(775,1257055200,2),(775,1268550000,1),(775,1289109600,2),(775,1299999600,1),(775,1320559200,2),(775,1331449200,1),(775,1352008800,2),(775,1362898800,1),(775,1383458400,2),(775,1394348400,1),(775,1414908000,2),(775,1425798000,1),(775,1446357600,2),(775,1457852400,1),(775,1478412000,2),(775,1489302000,1),(775,1509861600,2),(775,1520751600,1),(775,1541311200,2),(775,1552201200,1),(775,1572760800,2),(775,1583650800,1),(775,1604210400,2),(775,1615705200,1),(775,1636264800,2),(775,1647154800,1),(775,1667714400,2),(775,1678604400,1),(775,1699164000,2),(775,1710054000,1),(775,1730613600,2),(775,1741503600,1),(775,1762063200,2),(775,1772953200,1),(775,1793512800,2),(775,1805007600,1),(775,1825567200,2),(775,1836457200,1),(775,1857016800,2),(775,1867906800,1),(775,1888466400,2),(775,1899356400,1),(775,1919916000,2),(775,1930806000,1),(775,1951365600,2),(775,1962860400,1),(775,1983420000,2),(775,1994310000,1),(775,2014869600,2),(775,2025759600,1),(775,2046319200,2),(775,2057209200,1),(775,2077768800,2),(775,2088658800,1),(775,2109218400,2),(775,2120108400,1),(775,2140668000,2),(776,-2147483648,2),(776,-1633280400,1),(776,-1615140000,2),(776,-1601830800,1),(776,-1583690400,2),(776,-1570381200,1),(776,-1551636000,2),(776,-1536512400,1),(776,-1523210400,2),(776,-1504458000,1),(776,-1491760800,2),(776,-1473008400,1),(776,-1459706400,2),(776,-1441558800,1),(776,-1428256800,2),(776,-1410109200,1),(776,-1396807200,2),(776,-1378659600,1),(776,-1365357600,2),(776,-1347210000,1),(776,-1333908000,2),(776,-1315155600,1),(776,-1301853600,2),(776,-1283706000,1),(776,-1270404000,2),(776,-1252256400,1),(776,-1238954400,2),(776,-1220806800,1),(776,-1207504800,2),(776,-1189357200,1),(776,-1176055200,2),(776,-1157302800,1),(776,-1144605600,2),(776,-1125853200,1),(776,-1112551200,2),(776,-1094403600,1),(776,-1081101600,2),(776,-1062954000,1),(776,-1049652000,2),(776,-1031504400,1),(776,-1018202400,2),(776,-1000054800,1),(776,-986752800,2),(776,-968000400,1),(776,-955303200,2),(776,-936550800,1),(776,-923248800,2),(776,-905101200,1),(776,-891799200,2),(776,-880218000,3),(776,-769395600,4),(776,-765396000,2),(776,-747248400,1),(776,-733946400,2),(776,-715798800,1),(776,-702496800,2),(776,-684349200,1),(776,-671047200,2),(776,-652899600,1),(776,-639597600,2),(776,-620845200,1),(776,-608148000,2),(776,-589395600,1),(776,-576093600,2),(776,-557946000,1),(776,-544644000,2),(776,-526496400,1),(776,-513194400,2),(776,-495046800,1),(776,-481744800,2),(776,-463597200,1),(776,-447271200,2),(776,-431542800,1),(776,-415821600,2),(776,-400093200,1),(776,-384372000,2),(776,-368643600,1),(776,-352922400,2),(776,-337194000,1),(776,-321472800,2),(776,-305744400,1),(776,-289418400,2),(776,-273690000,1),(776,-257968800,2),(776,-242240400,1),(776,-226519200,2),(776,-210790800,1),(776,-195069600,2),(776,-179341200,1),(776,-163620000,2),(776,-147891600,1),(776,-131565600,2),(776,-116442000,1),(776,-100116000,2),(776,-84387600,1),(776,-68666400,2),(776,-52938000,1),(776,-37216800,2),(776,-21488400,1),(776,-5767200,2),(776,9961200,1),(776,25682400,2),(776,41410800,1),(776,57736800,2),(776,73465200,1),(776,89186400,2),(776,104914800,1),(776,120636000,2),(776,126687600,1),(776,152085600,2),(776,162370800,1),(776,183535200,2),(776,199263600,1),(776,215589600,2),(776,230713200,1),(776,247039200,2),(776,262767600,1),(776,278488800,2),(776,294217200,1),(776,309938400,2),(776,325666800,1),(776,341388000,2),(776,357116400,1),(776,372837600,2),(776,388566000,1),(776,404892000,2),(776,420015600,1),(776,436341600,2),(776,452070000,1),(776,467791200,2),(776,483519600,1),(776,499240800,2),(776,514969200,1),(776,530690400,2),(776,544604400,1),(776,562140000,2),(776,576054000,1),(776,594194400,2),(776,607503600,1),(776,625644000,2),(776,638953200,1),(776,657093600,2),(776,671007600,1),(776,688543200,2),(776,702457200,1),(776,719992800,2),(776,733906800,1),(776,752047200,2),(776,765356400,1),(776,783496800,2),(776,796806000,1),(776,814946400,2),(776,828860400,1),(776,846396000,2),(776,860310000,1),(776,877845600,2),(776,891759600,1),(776,909295200,2),(776,923209200,1),(776,941349600,2),(776,954658800,1),(776,972799200,2),(776,986108400,1),(776,1004248800,2),(776,1018162800,1),(776,1035698400,2),(776,1049612400,1),(776,1067148000,2),(776,1081062000,1),(776,1099202400,2),(776,1112511600,1),(776,1130652000,2),(776,1143961200,1),(776,1162101600,2),(776,1173596400,1),(776,1194156000,2),(776,1205046000,1),(776,1225605600,2),(776,1236495600,1),(776,1257055200,2),(776,1268550000,1),(776,1289109600,2),(776,1299999600,1),(776,1320559200,2),(776,1331449200,1),(776,1352008800,2),(776,1362898800,1),(776,1383458400,2),(776,1394348400,1),(776,1414908000,2),(776,1425798000,1),(776,1446357600,2),(776,1457852400,1),(776,1478412000,2),(776,1489302000,1),(776,1509861600,2),(776,1520751600,1),(776,1541311200,2),(776,1552201200,1),(776,1572760800,2),(776,1583650800,1),(776,1604210400,2),(776,1615705200,1),(776,1636264800,2),(776,1647154800,1),(776,1667714400,2),(776,1678604400,1),(776,1699164000,2),(776,1710054000,1),(776,1730613600,2),(776,1741503600,1),(776,1762063200,2),(776,1772953200,1),(776,1793512800,2),(776,1805007600,1),(776,1825567200,2),(776,1836457200,1),(776,1857016800,2),(776,1867906800,1),(776,1888466400,2),(776,1899356400,1),(776,1919916000,2),(776,1930806000,1),(776,1951365600,2),(776,1962860400,1),(776,1983420000,2),(776,1994310000,1),(776,2014869600,2),(776,2025759600,1),(776,2046319200,2),(776,2057209200,1),(776,2077768800,2),(776,2088658800,1),(776,2109218400,2),(776,2120108400,1),(776,2140668000,2),(777,-2147483648,2),(777,-1632070800,1),(777,-1615140000,2),(777,-923252400,1),(777,-880218000,3),(777,-769395600,4),(777,-765396000,2),(777,136364400,1),(777,152085600,2),(777,167814000,1),(777,183535200,2),(777,199263600,1),(777,215589600,2),(777,230713200,1),(777,247039200,2),(777,262767600,1),(777,278488800,2),(777,294217200,1),(777,309938400,2),(777,325666800,1),(777,341388000,2),(777,357116400,1),(777,372837600,2),(777,388566000,1),(777,404892000,2),(777,420015600,1),(777,436341600,2),(777,452070000,1),(777,467791200,2),(777,483519600,1),(777,499240800,2),(777,514969200,1),(777,530690400,2),(777,544604400,1),(777,562140000,2),(777,576054000,1),(777,594194400,2),(777,607503600,1),(777,625644000,2),(777,638953200,1),(777,657093600,2),(777,671007600,1),(777,688543200,2),(777,702457200,1),(777,719992800,2),(777,733906800,1),(777,752047200,2),(777,765356400,1),(777,783496800,2),(777,796806000,1),(777,814946400,2),(777,828860400,1),(777,846396000,2),(777,860310000,1),(777,877845600,2),(777,891759600,1),(777,909295200,2),(777,923209200,1),(777,941349600,2),(777,954658800,1),(777,972799200,2),(777,986108400,1),(777,1004248800,2),(777,1018162800,1),(777,1035698400,2),(777,1049612400,1),(777,1067148000,2),(777,1081062000,1),(777,1099202400,2),(777,1112511600,1),(777,1130652000,2),(777,1143961200,1),(777,1162101600,2),(777,1173596400,1),(777,1194156000,2),(777,1205046000,1),(777,1225605600,2),(777,1236495600,1),(777,1257055200,2),(777,1268550000,1),(777,1289109600,2),(777,1299999600,1),(777,1320559200,2),(777,1331449200,1),(777,1352008800,2),(777,1362898800,1),(777,1383458400,2),(777,1394348400,1),(777,1414908000,2),(777,1425798000,1),(777,1446357600,2),(777,1457852400,1),(777,1478412000,2),(777,1489302000,1),(777,1509861600,2),(777,1520751600,1),(777,1541311200,2),(777,1552201200,1),(777,1572760800,2),(777,1583650800,1),(777,1604210400,2),(777,1615705200,1),(777,1636264800,2),(777,1647154800,1),(777,1667714400,2),(777,1678604400,1),(777,1699164000,2),(777,1710054000,1),(777,1730613600,2),(777,1741503600,1),(777,1762063200,2),(777,1772953200,1),(777,1793512800,2),(777,1805007600,1),(777,1825567200,2),(777,1836457200,1),(777,1857016800,2),(777,1867906800,1),(777,1888466400,2),(777,1899356400,1),(777,1919916000,2),(777,1930806000,1),(777,1951365600,2),(777,1962860400,1),(777,1983420000,2),(777,1994310000,1),(777,2014869600,2),(777,2025759600,1),(777,2046319200,2),(777,2057209200,1),(777,2077768800,2),(777,2088658800,1),(777,2109218400,2),(777,2120108400,1),(777,2140668000,2),(778,-2147483648,1),(778,-880196400,2),(778,-769395600,3),(778,-765374400,1),(778,-86878800,4),(778,-21466800,5),(778,-5745600,4),(778,9982800,5),(778,25704000,4),(778,41432400,5),(778,57758400,4),(778,73486800,5),(778,89208000,4),(778,104936400,5),(778,120657600,4),(778,126709200,5),(778,152107200,4),(778,162392400,5),(778,183556800,4),(778,199285200,5),(778,215611200,4),(778,230734800,5),(778,247060800,4),(778,262789200,5),(778,278510400,4),(778,294238800,5),(778,309960000,4),(778,325688400,5),(778,341409600,4),(778,357138000,5),(778,372859200,4),(778,388587600,5),(778,404913600,4),(778,420037200,5),(778,436363200,6),(778,439030800,8),(778,452084400,7),(778,467805600,8),(778,483534000,7),(778,499255200,8),(778,514983600,7),(778,530704800,8),(778,544618800,7),(778,562154400,8),(778,576068400,7),(778,594208800,8),(778,607518000,7),(778,625658400,8),(778,638967600,7),(778,657108000,8),(778,671022000,7),(778,688557600,8),(778,702471600,7),(778,720007200,8),(778,733921200,7),(778,752061600,8),(778,765370800,7),(778,783511200,8),(778,796820400,7),(778,814960800,8),(778,828874800,7),(778,846410400,8),(778,860324400,7),(778,877860000,8),(778,891774000,7),(778,909309600,8),(778,923223600,7),(778,941364000,8),(778,954673200,7),(778,972813600,8),(778,986122800,7),(778,1004263200,8),(778,1018177200,7),(778,1035712800,8),(778,1049626800,7),(778,1067162400,8),(778,1081076400,7),(778,1099216800,8),(778,1112526000,7),(778,1130666400,8),(778,1143975600,7),(778,1162116000,8),(778,1173610800,7),(778,1194170400,8),(778,1205060400,7),(778,1225620000,8),(778,1236510000,7),(778,1257069600,8),(778,1268564400,7),(778,1289124000,8),(778,1300014000,7),(778,1320573600,8),(778,1331463600,7),(778,1352023200,8),(778,1362913200,7),(778,1383472800,8),(778,1394362800,7),(778,1414922400,8),(778,1425812400,7),(778,1446372000,8),(778,1457866800,7),(778,1478426400,8),(778,1489316400,7),(778,1509876000,8),(778,1520766000,7),(778,1541325600,8),(778,1552215600,7),(778,1572775200,8),(778,1583665200,7),(778,1604224800,8),(778,1615719600,7),(778,1636279200,8),(778,1647169200,7),(778,1667728800,8),(778,1678618800,7),(778,1699178400,8),(778,1710068400,7),(778,1730628000,8),(778,1741518000,7),(778,1762077600,8),(778,1772967600,7),(778,1793527200,8),(778,1805022000,7),(778,1825581600,8),(778,1836471600,7),(778,1857031200,8),(778,1867921200,7),(778,1888480800,8),(778,1899370800,7),(778,1919930400,8),(778,1930820400,7),(778,1951380000,8),(778,1962874800,7),(778,1983434400,8),(778,1994324400,7),(778,2014884000,8),(778,2025774000,7),(778,2046333600,8),(778,2057223600,7),(778,2077783200,8),(778,2088673200,7),(778,2109232800,8),(778,2120122800,7),(778,2140682400,8),(779,-2147483648,0),(779,-1767217820,2),(779,-1206961200,1),(779,-1191366000,2),(779,-1175378400,1),(779,-1159830000,2),(779,-633823200,1),(779,-622072800,2),(779,-602287200,1),(779,-591836400,2),(779,-570751200,1),(779,-560214000,2),(779,-539128800,1),(779,-531356400,2),(779,-191368800,1),(779,-184201200,2),(779,-155167200,1),(779,-150073200,2),(779,-128901600,1),(779,-121129200,2),(779,-99957600,1),(779,-89593200,2),(779,-68421600,1),(779,-57970800,2),(779,499744800,1),(779,511232400,2),(779,530589600,1),(779,540262800,2),(779,562125600,1),(779,571194000,2),(779,592970400,1),(779,602038800,2),(779,624420000,1),(779,634698000,2),(779,938916000,1),(779,951613200,2),(779,970970400,1),(779,971571600,2),(779,1003024800,1),(779,1013907600,2),(779,2147483647,2),(780,-2147483648,2),(780,-1633273200,1),(780,-1615132800,2),(780,-1601823600,1),(780,-1583683200,2),(780,-880210800,3),(780,-769395600,4),(780,-765388800,2),(780,-84380400,1),(780,-68659200,2),(780,-52930800,1),(780,-37209600,2),(780,-21481200,1),(780,-5760000,2),(780,9968400,1),(780,25689600,2),(780,41418000,1),(780,57744000,2),(780,73472400,1),(780,89193600,2),(780,104922000,1),(780,120643200,2),(780,126694800,1),(780,152092800,2),(780,162378000,1),(780,183542400,2),(780,199270800,1),(780,215596800,2),(780,230720400,1),(780,247046400,2),(780,262774800,1),(780,278496000,2),(780,294224400,1),(780,309945600,2),(780,325674000,1),(780,341395200,2),(780,357123600,1),(780,372844800,2),(780,388573200,1),(780,404899200,2),(780,420022800,1),(780,436348800,2),(780,452077200,1),(780,467798400,2),(780,483526800,1),(780,499248000,2),(780,514976400,1),(780,530697600,2),(780,544611600,1),(780,562147200,2),(780,576061200,1),(780,594201600,2),(780,607510800,1),(780,625651200,2),(780,638960400,1),(780,657100800,2),(780,671014800,1),(780,688550400,2),(780,702464400,1),(780,720000000,2),(780,733914000,1),(780,752054400,2),(780,765363600,1),(780,783504000,2),(780,796813200,1),(780,814953600,2),(780,828867600,1),(780,846403200,2),(780,860317200,1),(780,877852800,2),(780,891766800,1),(780,909302400,2),(780,923216400,1),(780,941356800,2),(780,954666000,1),(780,972806400,2),(780,986115600,1),(780,1004256000,2),(780,1018170000,1),(780,1035705600,2),(780,1049619600,1),(780,1067155200,2),(780,1081069200,1),(780,1099209600,2),(780,1112518800,1),(780,1130659200,2),(780,1143968400,1),(780,1162108800,2),(780,1173603600,1),(780,1194163200,2),(780,1205053200,1),(780,1225612800,2),(780,1236502800,1),(780,1257062400,2),(780,1268557200,1),(780,1289116800,6),(780,1300003200,5),(780,1320562800,6),(780,1331452800,5),(780,1352012400,6),(780,1362902400,5),(780,1383462000,6),(780,1394352000,5),(780,1414911600,6),(780,1425801600,5),(780,1446361200,6),(780,1457856000,5),(780,1478415600,6),(780,1489305600,5),(780,1509865200,6),(780,1520755200,5),(780,1541314800,6),(780,1552204800,5),(780,1572764400,6),(780,1583654400,5),(780,1604214000,6),(780,1615708800,5),(780,1636268400,6),(780,1647158400,5),(780,1667718000,6),(780,1678608000,5),(780,1699167600,6),(780,1710057600,5),(780,1730617200,6),(780,1741507200,5),(780,1762066800,6),(780,1772956800,5),(780,1793516400,6),(780,1805011200,5),(780,1825570800,6),(780,1836460800,5),(780,1857020400,6),(780,1867910400,5),(780,1888470000,6),(780,1899360000,5),(780,1919919600,6),(780,1930809600,5),(780,1951369200,6),(780,1962864000,5),(780,1983423600,6),(780,1994313600,5),(780,2014873200,6),(780,2025763200,5),(780,2046322800,6),(780,2057212800,5),(780,2077772400,6),(780,2088662400,5),(780,2109222000,6),(780,2120112000,5),(780,2140671600,6),(781,-2147483648,2),(781,-1633273200,1),(781,-1615132800,2),(781,-1601823600,1),(781,-1583683200,2),(781,-880210800,3),(781,-769395600,4),(781,-765388800,2),(781,-84380400,1),(781,-68659200,2),(781,-52930800,1),(781,-37209600,2),(781,-21481200,1),(781,-5760000,2),(781,9968400,1),(781,25689600,2),(781,41418000,1),(781,57744000,2),(781,73472400,1),(781,89193600,2),(781,104922000,1),(781,120643200,2),(781,126694800,1),(781,152092800,2),(781,162378000,1),(781,183542400,2),(781,199270800,1),(781,215596800,2),(781,230720400,1),(781,247046400,2),(781,262774800,1),(781,278496000,2),(781,294224400,1),(781,309945600,2),(781,325674000,1),(781,341395200,2),(781,357123600,1),(781,372844800,2),(781,388573200,1),(781,404899200,2),(781,420022800,1),(781,436348800,2),(781,452077200,1),(781,467798400,2),(781,483526800,1),(781,499248000,2),(781,514976400,1),(781,530697600,2),(781,544611600,1),(781,562147200,2),(781,576061200,1),(781,594201600,2),(781,607510800,1),(781,625651200,2),(781,638960400,1),(781,657100800,2),(781,671014800,1),(781,688550400,2),(781,702464400,1),(781,720000000,6),(781,733910400,5),(781,752050800,6),(781,765360000,5),(781,783500400,6),(781,796809600,5),(781,814950000,6),(781,828864000,5),(781,846399600,6),(781,860313600,5),(781,877849200,6),(781,891763200,5),(781,909298800,6),(781,923212800,5),(781,941353200,6),(781,954662400,5),(781,972802800,6),(781,986112000,5),(781,1004252400,6),(781,1018166400,5),(781,1035702000,6),(781,1049616000,5),(781,1067151600,6),(781,1081065600,5),(781,1099206000,6),(781,1112515200,5),(781,1130655600,6),(781,1143964800,5),(781,1162105200,6),(781,1173600000,5),(781,1194159600,6),(781,1205049600,5),(781,1225609200,6),(781,1236499200,5),(781,1257058800,6),(781,1268553600,5),(781,1289113200,6),(781,1300003200,5),(781,1320562800,6),(781,1331452800,5),(781,1352012400,6),(781,1362902400,5),(781,1383462000,6),(781,1394352000,5),(781,1414911600,6),(781,1425801600,5),(781,1446361200,6),(781,1457856000,5),(781,1478415600,6),(781,1489305600,5),(781,1509865200,6),(781,1520755200,5),(781,1541314800,6),(781,1552204800,5),(781,1572764400,6),(781,1583654400,5),(781,1604214000,6),(781,1615708800,5),(781,1636268400,6),(781,1647158400,5),(781,1667718000,6),(781,1678608000,5),(781,1699167600,6),(781,1710057600,5),(781,1730617200,6),(781,1741507200,5),(781,1762066800,6),(781,1772956800,5),(781,1793516400,6),(781,1805011200,5),(781,1825570800,6),(781,1836460800,5),(781,1857020400,6),(781,1867910400,5),(781,1888470000,6),(781,1899360000,5),(781,1919919600,6),(781,1930809600,5),(781,1951369200,6),(781,1962864000,5),(781,1983423600,6),(781,1994313600,5),(781,2014873200,6),(781,2025763200,5),(781,2046322800,6),(781,2057212800,5),(781,2077772400,6),(781,2088662400,5),(781,2109222000,6),(781,2120112000,5),(781,2140671600,6),(782,-2147483648,2),(782,-1633273200,1),(782,-1615132800,2),(782,-1601823600,1),(782,-1583683200,2),(782,-880210800,3),(782,-769395600,4),(782,-765388800,2),(782,-84380400,1),(782,-68659200,2),(782,-52930800,1),(782,-37209600,2),(782,-21481200,1),(782,-5760000,2),(782,9968400,1),(782,25689600,2),(782,41418000,1),(782,57744000,2),(782,73472400,1),(782,89193600,2),(782,104922000,1),(782,120643200,2),(782,126694800,1),(782,152092800,2),(782,162378000,1),(782,183542400,2),(782,199270800,1),(782,215596800,2),(782,230720400,1),(782,247046400,2),(782,262774800,1),(782,278496000,2),(782,294224400,1),(782,309945600,2),(782,325674000,1),(782,341395200,2),(782,357123600,1),(782,372844800,2),(782,388573200,1),(782,404899200,2),(782,420022800,1),(782,436348800,2),(782,452077200,1),(782,467798400,2),(782,483526800,1),(782,499248000,2),(782,514976400,1),(782,530697600,2),(782,544611600,1),(782,562147200,2),(782,576061200,1),(782,594201600,2),(782,607510800,1),(782,625651200,2),(782,638960400,1),(782,657100800,2),(782,671014800,1),(782,688550400,2),(782,702464400,1),(782,720000000,2),(782,733914000,1),(782,752054400,2),(782,765363600,1),(782,783504000,2),(782,796813200,1),(782,814953600,2),(782,828867600,1),(782,846403200,2),(782,860317200,1),(782,877852800,2),(782,891766800,1),(782,909302400,2),(782,923216400,1),(782,941356800,2),(782,954666000,1),(782,972806400,2),(782,986115600,1),(782,1004256000,2),(782,1018170000,1),(782,1035705600,2),(782,1049619600,1),(782,1067155200,6),(782,1081065600,5),(782,1099206000,6),(782,1112515200,5),(782,1130655600,6),(782,1143964800,5),(782,1162105200,6),(782,1173600000,5),(782,1194159600,6),(782,1205049600,5),(782,1225609200,6),(782,1236499200,5),(782,1257058800,6),(782,1268553600,5),(782,1289113200,6),(782,1300003200,5),(782,1320562800,6),(782,1331452800,5),(782,1352012400,6),(782,1362902400,5),(782,1383462000,6),(782,1394352000,5),(782,1414911600,6),(782,1425801600,5),(782,1446361200,6),(782,1457856000,5),(782,1478415600,6),(782,1489305600,5),(782,1509865200,6),(782,1520755200,5),(782,1541314800,6),(782,1552204800,5),(782,1572764400,6),(782,1583654400,5),(782,1604214000,6),(782,1615708800,5),(782,1636268400,6),(782,1647158400,5),(782,1667718000,6),(782,1678608000,5),(782,1699167600,6),(782,1710057600,5),(782,1730617200,6),(782,1741507200,5),(782,1762066800,6),(782,1772956800,5),(782,1793516400,6),(782,1805011200,5),(782,1825570800,6),(782,1836460800,5),(782,1857020400,6),(782,1867910400,5),(782,1888470000,6),(782,1899360000,5),(782,1919919600,6),(782,1930809600,5),(782,1951369200,6),(782,1962864000,5),(782,1983423600,6),(782,1994313600,5),(782,2014873200,6),(782,2025763200,5),(782,2046322800,6),(782,2057212800,5),(782,2077772400,6),(782,2088662400,5),(782,2109222000,6),(782,2120112000,5),(782,2140671600,6),(783,-2147483648,0),(783,-1514739600,1),(783,-1343066400,2),(783,-1234807200,1),(783,-1220292000,2),(783,-1207159200,1),(783,-1191344400,2),(783,828864000,3),(783,846399600,2),(783,860313600,3),(783,877849200,2),(783,891766800,4),(783,909302400,1),(783,923216400,4),(783,941356800,1),(783,954666000,4),(783,972806400,1),(783,989139600,4),(783,1001836800,1),(783,1018170000,4),(783,1035705600,1),(783,1049619600,4),(783,1067155200,1),(783,1081069200,4),(783,1099209600,1),(783,1112518800,4),(783,1130659200,1),(783,1143968400,4),(783,1162108800,1),(783,1175418000,4),(783,1193558400,1),(783,1207472400,4),(783,1225008000,1),(783,1238922000,4),(783,1256457600,1),(783,1268557200,4),(783,1289116800,1),(783,1300006800,4),(783,1320566400,1),(783,1331456400,4),(783,1352016000,1),(783,1362906000,4),(783,1383465600,1),(783,1394355600,4),(783,1414915200,1),(783,1425805200,4),(783,1446364800,1),(783,1457859600,4),(783,1478419200,1),(783,1489309200,4),(783,1509868800,1),(783,1520758800,4),(783,1541318400,1),(783,1552208400,4),(783,1572768000,1),(783,1583658000,4),(783,1604217600,1),(783,1615712400,4),(783,1636272000,1),(783,1647162000,4),(783,1667721600,1),(783,1678611600,4),(783,1699171200,1),(783,1710061200,4),(783,1730620800,1),(783,1741510800,4),(783,1762070400,1),(783,1772960400,4),(783,1793520000,1),(783,1805014800,4),(783,1825574400,1),(783,1836464400,4),(783,1857024000,1),(783,1867914000,4),(783,1888473600,1),(783,1899363600,4),(783,1919923200,1),(783,1930813200,4),(783,1951372800,1),(783,1962867600,4),(783,1983427200,1),(783,1994317200,4),(783,2014876800,1),(783,2025766800,4),(783,2046326400,1),(783,2057216400,4),(783,2077776000,1),(783,2088666000,4),(783,2109225600,1),(783,2120115600,4),(783,2140675200,1),(784,-2147483648,1),(784,-1946918424,2),(785,-2147483648,0),(785,-1546300800,3),(785,-880221600,1),(785,-769395600,2),(785,-765399600,3),(785,-147902400,4),(785,-131572800,3),(785,325663200,5),(785,341384400,3),(785,357112800,5),(785,372834000,3),(785,388562400,5),(785,404888400,3),(785,420012000,5),(785,436338000,3),(785,452066400,5),(785,467787600,3),(785,483516000,5),(785,499237200,3),(785,514965600,5),(785,530686800,3),(785,544600800,5),(785,562136400,3),(785,576050400,5),(785,594190800,3),(785,607500000,5),(785,625640400,3),(785,638949600,5),(785,657090000,3),(785,671004000,5),(785,688539600,3),(785,702453600,5),(785,719989200,3),(785,733903200,5),(785,752043600,3),(785,765352800,5),(785,783493200,3),(785,796802400,6),(785,814946400,7),(785,828860400,6),(785,846396000,7),(785,860310000,6),(785,877845600,7),(785,891759600,6),(785,909295200,7),(785,923209200,6),(785,941349600,8),(785,954662400,9),(785,972802800,7),(785,986108400,6),(785,1004248800,7),(785,1018162800,6),(785,1035698400,7),(785,1049612400,6),(785,1067148000,7),(785,1081062000,6),(785,1099202400,7),(785,1112511600,6),(785,1130652000,7),(785,1143961200,6),(785,1162101600,7),(785,1173596400,6),(785,1194156000,7),(785,1205046000,6),(785,1225605600,7),(785,1236495600,6),(785,1257055200,7),(785,1268550000,6),(785,1289109600,7),(785,1299999600,6),(785,1320559200,7),(785,1331449200,6),(785,1352008800,7),(785,1362898800,6),(785,1383458400,7),(785,1394348400,6),(785,1414908000,7),(785,1425798000,6),(785,1446357600,7),(785,1457852400,6),(785,1478412000,7),(785,1489302000,6),(785,1509861600,7),(785,1520751600,6),(785,1541311200,7),(785,1552201200,6),(785,1572760800,7),(785,1583650800,6),(785,1604210400,7),(785,1615705200,6),(785,1636264800,7),(785,1647154800,6),(785,1667714400,7),(785,1678604400,6),(785,1699164000,7),(785,1710054000,6),(785,1730613600,7),(785,1741503600,6),(785,1762063200,7),(785,1772953200,6),(785,1793512800,7),(785,1805007600,6),(785,1825567200,7),(785,1836457200,6),(785,1857016800,7),(785,1867906800,6),(785,1888466400,7),(785,1899356400,6),(785,1919916000,7),(785,1930806000,6),(785,1951365600,7),(785,1962860400,6),(785,1983420000,7),(785,1994310000,6),(785,2014869600,7),(785,2025759600,6),(785,2046319200,7),(785,2057209200,6),(785,2077768800,7),(785,2088658800,6),(785,2109218400,7),(785,2120108400,6),(785,2140668000,7),(786,-2147483648,0),(786,-1861906760,1),(786,-1104524348,2),(786,-765317964,3),(786,465449400,4),(786,2147483647,4),(787,-2147483648,2),(787,-1633273200,1),(787,-1615132800,2),(787,-1601823600,1),(787,-1583683200,2),(787,-880210800,3),(787,-820519140,2),(787,-812653140,3),(787,-796845540,2),(787,-84380400,1),(787,-68659200,2),(788,-2147483648,1),(788,-1670483460,3),(788,421218000,2),(788,436334400,3),(788,452062800,2),(788,467784000,3),(788,483512400,2),(788,499233600,3),(788,514962000,2),(788,530683200,3),(788,546411600,2),(788,562132800,3),(788,576050400,4),(788,594194400,5),(788,607500000,4),(788,625644000,5),(788,638949600,4),(788,657093600,5),(788,671004000,4),(788,688543200,5),(788,702453600,4),(788,719992800,5),(788,733903200,4),(788,752047200,5),(788,765352800,4),(788,783496800,5),(788,796802400,4),(788,814946400,5),(788,828856800,4),(788,846396000,5),(788,860306400,4),(788,877845600,5),(788,1112504400,2),(788,1130644800,3),(788,1143954000,2),(788,1162094400,3),(788,1331449200,2),(788,1352008800,3),(788,1362898800,2),(788,1383458400,3),(788,1394348400,2),(788,1414908000,3),(788,1425798000,2),(788,1446357600,3),(788,1489302000,2),(788,1509861600,3),(788,1520751600,2),(788,1541311200,3),(788,1552201200,2),(788,1572760800,3),(788,1583650800,2),(788,1604210400,3),(788,1615705200,2),(788,1636264800,3),(788,1647154800,2),(788,1667714400,3),(788,1678604400,2),(788,1699164000,3),(788,1710054000,2),(788,1730613600,3),(788,1741503600,2),(788,1762063200,3),(788,1772953200,2),(788,1793512800,3),(788,1805007600,2),(788,1825567200,3),(788,1836457200,2),(788,1857016800,3),(788,1867906800,2),(788,1888466400,3),(788,1899356400,2),(788,1919916000,3),(788,1930806000,2),(788,1951365600,3),(788,1962860400,2),(788,1983420000,3),(788,1994310000,2),(788,2014869600,3),(788,2025759600,2),(788,2046319200,3),(788,2057209200,2),(788,2077768800,3),(788,2088658800,2),(788,2109218400,3),(788,2120108400,2),(788,2140668000,3),(789,-2147483648,0),(789,-1825098836,1),(790,-2147483648,0),(790,-1767209328,2),(790,-1206950400,1),(790,-1191355200,2),(790,-1175367600,1),(790,-1159819200,2),(790,-633812400,1),(790,-622062000,2),(790,-602276400,1),(790,-591825600,2),(790,-570740400,1),(790,-560203200,2),(790,-539118000,1),(790,-531345600,2),(790,-191358000,1),(790,-184190400,2),(790,-155156400,1),(790,-150062400,2),(790,-128890800,1),(790,-121118400,2),(790,-99946800,1),(790,-89582400,2),(790,-68410800,1),(790,-57960000,2),(790,499755600,1),(790,511243200,2),(790,530600400,1),(790,540273600,2),(790,562136400,1),(790,571204800,2),(790,1214283600,3),(790,1384056000,2),(790,2147483647,2),(791,-2147483648,0),(791,-1767210264,2),(791,-1206954000,1),(791,-1191358800,2),(791,-1175371200,1),(791,-1159822800,2),(791,-633816000,1),(791,-622065600,2),(791,-602280000,1),(791,-591829200,2),(791,-570744000,1),(791,-560206800,2),(791,-539121600,1),(791,-531349200,2),(791,-191361600,1),(791,-184194000,2),(791,-155160000,1),(791,-150066000,2),(791,-128894400,1),(791,-121122000,2),(791,-99950400,1),(791,-89586000,2),(791,-68414400,1),(791,-57963600,2),(791,499752000,1),(791,511239600,2),(791,530596800,1),(791,540270000,2),(791,562132800,1),(791,571201200,2),(791,2147483647,2),(792,-2147483648,1),(792,-873057600,3),(792,-769395600,2),(792,-765399600,1),(793,-2147483648,1),(793,-1892661434,2),(793,-1688410800,1),(793,-1619205434,3),(793,-1593806400,1),(793,-1335986234,4),(793,-1317585600,2),(793,-1304362800,4),(793,-1286049600,2),(793,-1272826800,4),(793,-1254513600,2),(793,-1241290800,4),(793,-1222977600,2),(793,-1209754800,4),(793,-1191355200,2),(793,-1178132400,3),(793,-870552000,2),(793,-865278000,3),(793,-718056000,2),(793,-713649600,3),(793,-36619200,5),(793,-23922000,6),(793,-3355200,5),(793,7527600,6),(793,24465600,5),(793,37767600,6),(793,55915200,5),(793,69217200,6),(793,87969600,5),(793,100666800,6),(793,118209600,5),(793,132116400,6),(793,150868800,5),(793,163566000,6),(793,182318400,5),(793,195620400,6),(793,213768000,5),(793,227070000,6),(793,245217600,5),(793,258519600,6),(793,277272000,5),(793,289969200,6),(793,308721600,5),(793,321418800,6),(793,340171200,5),(793,353473200,6),(793,371620800,5),(793,384922800,6),(793,403070400,5),(793,416372400,6),(793,434520000,5),(793,447822000,6),(793,466574400,5),(793,479271600,6),(793,498024000,5),(793,510721200,6),(793,529473600,5),(793,545194800,6),(793,560923200,5),(793,574225200,6),(793,592372800,5),(793,605674800,6),(793,624427200,5),(793,637124400,6),(793,653457600,5),(793,668574000,6),(793,687326400,5),(793,700628400,6),(793,718776000,5),(793,732078000,6),(793,750225600,5),(793,763527600,6),(793,781675200,5),(793,794977200,6),(793,813729600,5),(793,826426800,6),(793,845179200,5),(793,859690800,6),(793,876628800,5),(793,889930800,6),(793,906868800,5),(793,923194800,6),(793,939528000,5),(793,952830000,6),(793,971582400,5),(793,984279600,6),(793,1003032000,5),(793,1015729200,6),(793,1034481600,5),(793,1047178800,6),(793,1065931200,5),(793,1079233200,6),(793,1097380800,5),(793,1110682800,6),(793,1128830400,5),(793,1142132400,6),(793,1160884800,5),(793,1173582000,6),(793,1192334400,5),(793,1206846000,6),(793,1223784000,5),(793,1237086000,6),(793,1255233600,5),(793,1270350000,6),(793,1286683200,5),(793,1304823600,6),(793,1313899200,5),(793,1335668400,6),(793,1346558400,5),(793,1367118000,6),(793,1378612800,5),(793,1398567600,6),(793,1410062400,5),(793,1463281200,6),(793,1471147200,5),(793,1480820400,7),(793,2147483647,7),(794,-2147483648,2),(794,-1632067200,1),(794,-1615136400,2),(794,-923248800,1),(794,-880214400,3),(794,-769395600,4),(794,-765392400,2),(794,136368000,1),(794,152089200,2),(794,167817600,1),(794,183538800,2),(794,199267200,1),(794,215593200,2),(794,230716800,1),(794,247042800,2),(794,262771200,1),(794,278492400,2),(794,294220800,1),(794,309942000,2),(794,325670400,1),(794,341391600,2),(794,357120000,1),(794,372841200,2),(794,388569600,1),(794,404895600,2),(794,420019200,1),(794,436345200,2),(794,452073600,1),(794,467794800,2),(794,483523200,1),(794,499244400,2),(794,514972800,1),(794,530694000,2),(794,544608000,1),(794,562143600,2),(794,576057600,1),(794,594198000,2),(794,607507200,1),(794,625647600,2),(794,638956800,1),(794,657097200,2),(794,671011200,1),(794,688546800,2),(794,702460800,1),(794,719996400,2),(794,733910400,1),(794,752050800,2),(794,765360000,1),(794,783500400,2),(794,796809600,1),(794,814950000,2),(794,828864000,1),(794,846399600,2),(794,860313600,1),(794,877849200,2),(794,891763200,1),(794,909298800,2),(794,923212800,1),(794,941353200,2),(794,954662400,1),(794,972802800,2),(794,986112000,1),(794,1004252400,2),(794,1018166400,1),(794,1035702000,2),(794,1049616000,1),(794,1067151600,2),(794,1081065600,1),(794,1099206000,2),(794,1112515200,1),(794,1130655600,2),(794,1143964800,1),(794,1162105200,2),(794,1173600000,1),(794,1194159600,2),(794,1205049600,1),(794,1225609200,2),(794,1236499200,1),(794,1257058800,2),(794,1268553600,1),(794,1289113200,2),(794,1300003200,1),(794,1320562800,2),(794,1331452800,1),(794,1352012400,2),(794,1362902400,1),(794,1383462000,2),(794,1394352000,1),(794,1414911600,2),(794,1425801600,1),(794,1446361200,2),(794,1457856000,1),(794,1478415600,2),(794,1489305600,1),(794,1509865200,2),(794,1520755200,1),(794,1541314800,2),(794,1552204800,1),(794,1572764400,2),(794,1583654400,1),(794,1604214000,2),(794,1615708800,1),(794,1636268400,2),(794,1647158400,1),(794,1667718000,2),(794,1678608000,1),(794,1699167600,2),(794,1710057600,1),(794,1730617200,2),(794,1741507200,1),(794,1762066800,2),(794,1772956800,1),(794,1793516400,2),(794,1805011200,1),(794,1825570800,2),(794,1836460800,1),(794,1857020400,2),(794,1867910400,1),(794,1888470000,2),(794,1899360000,1),(794,1919919600,2),(794,1930809600,1),(794,1951369200,2),(794,1962864000,1),(794,1983423600,2),(794,1994313600,1),(794,2014873200,2),(794,2025763200,1),(794,2046322800,2),(794,2057212800,1),(794,2077772400,2),(794,2088662400,1),(794,2109222000,2),(794,2120112000,1),(794,2140671600,2),(795,-2147483648,0),(795,-410227200,2),(795,-147895200,1),(795,-131565600,2),(795,325670400,3),(795,341391600,2),(795,357120000,3),(795,372841200,2),(795,388569600,3),(795,404895600,2),(795,420019200,3),(795,436345200,2),(795,452073600,3),(795,467794800,2),(795,483523200,3),(795,499244400,2),(795,514972800,3),(795,530694000,2),(795,544608000,3),(795,562143600,2),(795,576057600,3),(795,594198000,2),(795,607507200,3),(795,625647600,2),(795,638956800,3),(795,657097200,2),(795,671011200,3),(795,688546800,2),(795,702460800,3),(795,719996400,2),(795,733910400,3),(795,752050800,2),(795,765360000,3),(795,783500400,2),(795,796809600,3),(795,814950000,2),(795,828864000,3),(795,846399600,2),(795,860313600,3),(795,877849200,2),(795,891763200,3),(795,909298800,2),(795,923212800,3),(795,941353200,2),(795,954662400,3),(795,972802800,4),(795,986112000,3);
INSERT INTO `time_zone_transition` VALUES (795,1004252400,2),(795,1018166400,3),(795,1035702000,2),(795,1049616000,3),(795,1067151600,2),(795,1081065600,3),(795,1099206000,2),(795,1112515200,3),(795,1130655600,2),(795,1143964800,3),(795,1162105200,2),(795,1173600000,3),(795,1194159600,2),(795,1205049600,3),(795,1225609200,2),(795,1236499200,3),(795,1257058800,2),(795,1268553600,3),(795,1289113200,2),(795,1300003200,3),(795,1320562800,2),(795,1331452800,3),(795,1352012400,2),(795,1362902400,3),(795,1383462000,2),(795,1394352000,3),(795,1414911600,2),(795,1425801600,3),(795,1446361200,2),(795,1457856000,3),(795,1478415600,2),(795,1489305600,3),(795,1509865200,2),(795,1520755200,3),(795,1541314800,2),(795,1552204800,3),(795,1572764400,2),(795,1583654400,3),(795,1604214000,2),(795,1615708800,3),(795,1636268400,2),(795,1647158400,3),(795,1667718000,2),(795,1678608000,3),(795,1699167600,2),(795,1710057600,3),(795,1730617200,2),(795,1741507200,3),(795,1762066800,2),(795,1772956800,3),(795,1793516400,2),(795,1805011200,3),(795,1825570800,2),(795,1836460800,3),(795,1857020400,2),(795,1867910400,3),(795,1888470000,2),(795,1899360000,3),(795,1919919600,2),(795,1930809600,3),(795,1951369200,2),(795,1962864000,3),(795,1983423600,2),(795,1994313600,3),(795,2014873200,2),(795,2025763200,3),(795,2046322800,2),(795,2057212800,3),(795,2077772400,2),(795,2088662400,3),(795,2109222000,2),(795,2120112000,3),(795,2140671600,2),(796,-2147483648,0),(796,-1767217224,2),(796,-1206957600,1),(796,-1191362400,2),(796,-1175374800,1),(796,-1159826400,2),(796,-633819600,1),(796,-622069200,2),(796,-602283600,1),(796,-591832800,2),(796,-570747600,1),(796,-560210400,2),(796,-539125200,1),(796,-531352800,2),(796,-191365200,1),(796,-184197600,2),(796,-155163600,1),(796,-150069600,2),(796,-128898000,1),(796,-121125600,2),(796,-99954000,1),(796,-89589600,2),(796,-68418000,1),(796,-57967200,2),(796,499748400,1),(796,511236000,2),(796,530593200,1),(796,540266400,2),(796,562129200,1),(796,571197600,2),(796,592974000,1),(796,602042400,2),(796,624423600,1),(796,634701600,2),(796,938919600,1),(796,951616800,2),(796,970974000,1),(796,971575200,2),(796,1003028400,1),(796,1013911200,2),(796,2147483647,2),(797,-2147483648,0),(797,-2030202084,2),(797,-1632063600,1),(797,-1615132800,2),(797,-1251651600,1),(797,-1238349600,2),(797,-1220202000,1),(797,-1206900000,2),(797,-1188752400,1),(797,-1175450400,2),(797,-1156698000,1),(797,-1144000800,2),(797,-1125248400,1),(797,-1111946400,2),(797,-1032714000,1),(797,-1016992800,2),(797,-1001264400,1),(797,-986148000,2),(797,-969814800,1),(797,-954093600,2),(797,-937760400,1),(797,-922039200,2),(797,-906310800,1),(797,-890589600,2),(797,-880210800,3),(797,-769395600,4),(797,-765388800,2),(797,-748450800,1),(797,-732729600,2),(797,-715791600,1),(797,-702489600,2),(797,-684342000,1),(797,-671040000,2),(797,-652892400,1),(797,-639590400,2),(797,-620838000,1),(797,-608140800,2),(797,-589388400,1),(797,-576086400,2),(797,-557938800,1),(797,-544636800,2),(797,-526489200,1),(797,-513187200,2),(797,-495039600,1),(797,-481737600,2),(797,-463590000,1),(797,-450288000,2),(797,-431535600,1),(797,-418233600,2),(797,-400086000,1),(797,-386784000,2),(797,-337186800,1),(797,-321465600,2),(797,-305737200,5),(798,-2147483648,0),(798,-704937600,2),(798,-147895200,1),(798,-131565600,2),(798,325670400,3),(798,341391600,2),(798,357120000,3),(798,372841200,2),(798,388569600,3),(798,404895600,2),(798,420019200,3),(798,436345200,2),(798,452073600,3),(798,467794800,2),(798,483523200,3),(798,499244400,2),(798,514972800,3),(798,530694000,2),(798,544608000,3),(798,562143600,2),(798,576057600,3),(798,594198000,2),(798,607507200,3),(798,625647600,2),(798,638956800,3),(798,657097200,2),(798,671011200,3),(798,688546800,2),(798,702460800,3),(798,719996400,2),(798,733910400,3),(798,752050800,2),(798,765360000,3),(798,783500400,2),(798,796809600,3),(798,814950000,2),(798,828864000,3),(798,846399600,2),(798,860313600,3),(798,877849200,2),(798,891763200,3),(798,909298800,2),(798,923212800,3),(798,941353200,2),(798,954662400,3),(798,972802800,4),(798,986112000,3),(798,1004252400,2),(798,1018166400,3),(798,1035702000,2),(798,1049616000,3),(798,1067151600,2),(798,1081065600,3),(798,1099206000,2),(798,1112515200,3),(798,1130655600,2),(798,1143964800,3),(798,1162105200,4),(798,1173600000,3),(798,1194159600,2),(798,1205049600,3),(798,1225609200,2),(798,1236499200,3),(798,1257058800,2),(798,1268553600,3),(798,1289113200,2),(798,1300003200,3),(798,1320562800,2),(798,1331452800,3),(798,1352012400,2),(798,1362902400,3),(798,1383462000,2),(798,1394352000,3),(798,1414911600,2),(798,1425801600,3),(798,1446361200,2),(798,1457856000,3),(798,1478415600,2),(798,1489305600,3),(798,1509865200,2),(798,1520755200,3),(798,1541314800,2),(798,1552204800,3),(798,1572764400,2),(798,1583654400,3),(798,1604214000,2),(798,1615708800,3),(798,1636268400,2),(798,1647158400,3),(798,1667718000,2),(798,1678608000,3),(798,1699167600,2),(798,1710057600,3),(798,1730617200,2),(798,1741507200,3),(798,1762066800,2),(798,1772956800,3),(798,1793516400,2),(798,1805011200,3),(798,1825570800,2),(798,1836460800,3),(798,1857020400,2),(798,1867910400,3),(798,1888470000,2),(798,1899360000,3),(798,1919919600,2),(798,1930809600,3),(798,1951369200,2),(798,1962864000,3),(798,1983423600,2),(798,1994313600,3),(798,2014873200,2),(798,2025763200,3),(798,2046322800,2),(798,2057212800,3),(798,2077772400,2),(798,2088662400,3),(798,2109222000,2),(798,2120112000,3),(798,2140671600,2),(799,-2147483648,0),(799,-1767209328,2),(799,-1206950400,1),(799,-1191355200,2),(799,-1175367600,1),(799,-1159819200,2),(799,-633812400,1),(799,-622062000,2),(799,-602276400,1),(799,-591825600,2),(799,-570740400,1),(799,-560203200,2),(799,-539118000,1),(799,-531345600,2),(799,-191358000,1),(799,-184190400,2),(799,-155156400,1),(799,-150062400,2),(799,-128890800,1),(799,-121118400,2),(799,-99946800,1),(799,-89582400,2),(799,-68410800,1),(799,-57960000,2),(799,499755600,1),(799,511243200,2),(799,530600400,1),(799,540273600,2),(799,562136400,1),(799,571204800,2),(799,1214283600,3),(799,1384056000,2),(799,2147483647,2),(800,-2147483648,1),(800,-1567453392,2),(800,-1233432000,3),(800,-1222981200,2),(800,-1205956800,3),(800,-1194037200,2),(800,-1172865600,3),(800,-1162501200,2),(800,-1141329600,3),(800,-1130965200,2),(800,-1109793600,3),(800,-1099429200,2),(800,-1078257600,3),(800,-1067806800,2),(800,-1046635200,3),(800,-1036270800,2),(800,-1015099200,3),(800,-1004734800,2),(800,-983563200,3),(800,-973198800,2),(800,-952027200,3),(800,-941576400,2),(800,-931032000,3),(800,-900882000,2),(800,-890337600,3),(800,-833749200,2),(800,-827265600,3),(800,-752274000,2),(800,-733780800,3),(800,-197326800,2),(800,-190843200,3),(800,-184194000,2),(800,-164491200,3),(800,-152658000,2),(800,-132955200,3),(800,-121122000,2),(800,-101419200,3),(800,-86821200,2),(800,-71092800,3),(800,-54766800,2),(800,-39038400,3),(800,-23317200,2),(800,-7588800,5),(800,128142000,4),(800,136605600,5),(800,596948400,4),(800,605066400,5),(800,624423600,4),(800,636516000,5),(800,656478000,4),(800,667965600,2),(800,687931200,4),(800,699415200,5),(800,719377200,4),(800,731469600,5),(800,938919600,3),(800,952052400,5),(800,1198983600,4),(800,1205632800,5),(800,1224385200,4),(800,1237082400,5),(800,2147483647,5),(801,-2147483648,0),(801,-1514736000,1),(801,-1451667600,2),(801,-1343062800,1),(801,-1234803600,2),(801,-1222963200,3),(801,-1207242000,2),(801,-873820800,4),(801,-769395600,5),(801,-761677200,2),(801,-686073600,3),(801,-661539600,2),(801,-495039600,3),(801,-481734000,2),(801,-463590000,3),(801,-450284400,2),(801,-431535600,3),(801,-418230000,2),(801,-400086000,3),(801,-386780400,2),(801,-368636400,3),(801,-355330800,2),(801,-337186800,3),(801,-323881200,2),(801,-305737200,3),(801,-292431600,2),(801,199274400,3),(801,215600400,2),(801,230724000,3),(801,247050000,2),(801,262778400,3),(801,278499600,2),(801,294228000,3),(801,309949200,2),(801,325677600,3),(801,341398800,2),(801,357127200,3),(801,372848400,2),(801,388576800,3),(801,404902800,2),(801,420026400,3),(801,436352400,2),(801,452080800,3),(801,467802000,2),(801,483530400,3),(801,499251600,2),(801,514980000,3),(801,530701200,2),(801,544615200,3),(801,562150800,2),(801,576064800,3),(801,594205200,2),(801,607514400,3),(801,625654800,2),(801,638964000,3),(801,657104400,2),(801,671018400,3),(801,688554000,2),(801,702468000,3),(801,720003600,2),(801,733917600,3),(801,752058000,2),(801,765367200,3),(801,783507600,2),(801,796816800,3),(801,814957200,2),(801,828871200,3),(801,846406800,2),(801,860320800,3),(801,877856400,2),(801,891770400,3),(801,909306000,2),(801,923220000,3),(801,941360400,2),(801,954669600,3),(801,972810000,2),(801,986119200,3),(801,1004259600,2),(801,1018173600,3),(801,1035709200,2),(801,1049623200,3),(801,1067158800,2),(801,1081072800,3),(801,1099213200,2),(801,1112522400,3),(801,1130662800,2),(801,1143972000,3),(801,1162112400,2),(801,1175421600,3),(801,1193562000,2),(801,1207476000,3),(801,1225011600,2),(801,1238925600,3),(801,1256461200,2),(801,1268560800,3),(801,1289120400,2),(801,1300010400,3),(801,1320570000,2),(801,1331460000,3),(801,1352019600,2),(801,1362909600,3),(801,1383469200,2),(801,1394359200,3),(801,1414918800,2),(801,1425808800,3),(801,1446368400,2),(801,1457863200,3),(801,1478422800,2),(801,1489312800,3),(801,1509872400,2),(801,1520762400,3),(801,1541322000,2),(801,1552212000,3),(801,1572771600,2),(801,1583661600,3),(801,1604221200,2),(801,1615716000,3),(801,1636275600,2),(801,1647165600,3),(801,1667725200,2),(801,1678615200,3),(801,1699174800,2),(801,1710064800,3),(801,1730624400,2),(801,1741514400,3),(801,1762074000,2),(801,1772964000,3),(801,1793523600,2),(801,1805018400,3),(801,1825578000,2),(801,1836468000,3),(801,1857027600,2),(801,1867917600,3),(801,1888477200,2),(801,1899367200,3),(801,1919926800,2),(801,1930816800,3),(801,1951376400,2),(801,1962871200,3),(801,1983430800,2),(801,1994320800,3),(801,2014880400,2),(801,2025770400,3),(801,2046330000,2),(801,2057220000,3),(801,2077779600,2),(801,2088669600,3),(801,2109229200,2),(801,2120119200,3),(801,2140678800,2),(802,-2147483648,0),(802,-1767212472,2),(802,-1206954000,1),(802,-1191358800,2),(802,-1175371200,1),(802,-1159822800,2),(802,-633816000,1),(802,-622065600,2),(802,-602280000,1),(802,-591829200,2),(802,-570744000,1),(802,-560206800,2),(802,-539121600,1),(802,-531349200,2),(802,-191361600,1),(802,-184194000,2),(802,-155160000,1),(802,-150066000,2),(802,-128894400,1),(802,-121122000,2),(802,-99950400,1),(802,-89586000,2),(802,-68414400,1),(802,-57963600,2),(802,499752000,1),(802,511239600,2),(802,530596800,1),(802,540270000,2),(802,562132800,1),(802,571201200,2),(802,1214280000,3),(802,2147483647,3),(803,-2147483648,1),(803,-1892661434,2),(803,-1688410800,1),(803,-1619205434,3),(803,-1593806400,1),(803,-1335986234,4),(803,-1317585600,2),(803,-1304362800,4),(803,-1286049600,2),(803,-1272826800,4),(803,-1254513600,2),(803,-1241290800,4),(803,-1222977600,2),(803,-1209754800,4),(803,-1191355200,2),(803,-1178132400,3),(803,-870552000,2),(803,-865278000,3),(803,-740520000,5),(803,-736376400,3),(803,-718056000,2),(803,-713649600,3),(803,-36619200,6),(803,-23922000,7),(803,-3355200,6),(803,7527600,7),(803,24465600,6),(803,37767600,7),(803,55915200,6),(803,69217200,7),(803,87969600,6),(803,100666800,7),(803,118209600,6),(803,132116400,7),(803,150868800,6),(803,163566000,7),(803,182318400,6),(803,195620400,7),(803,213768000,6),(803,227070000,7),(803,245217600,6),(803,258519600,7),(803,277272000,6),(803,289969200,7),(803,308721600,6),(803,321418800,7),(803,340171200,6),(803,353473200,7),(803,371620800,6),(803,384922800,7),(803,403070400,6),(803,416372400,7),(803,434520000,6),(803,447822000,7),(803,466574400,6),(803,479271600,7),(803,498024000,6),(803,510721200,7),(803,529473600,6),(803,545194800,7),(803,560923200,6),(803,574225200,7),(803,592372800,6),(803,605674800,7),(803,624427200,6),(803,637124400,7),(803,653457600,6),(803,668574000,7),(803,687326400,6),(803,700628400,7),(803,718776000,6),(803,732078000,7),(803,750225600,6),(803,763527600,7),(803,781675200,6),(803,794977200,7),(803,813729600,6),(803,826426800,7),(803,845179200,6),(803,859690800,7),(803,876628800,6),(803,889930800,7),(803,906868800,6),(803,923194800,7),(803,939528000,6),(803,952830000,7),(803,971582400,6),(803,984279600,7),(803,1003032000,6),(803,1015729200,7),(803,1034481600,6),(803,1047178800,7),(803,1065931200,6),(803,1079233200,7),(803,1097380800,6),(803,1110682800,7),(803,1128830400,6),(803,1142132400,7),(803,1160884800,6),(803,1173582000,7),(803,1192334400,6),(803,1206846000,7),(803,1223784000,6),(803,1237086000,7),(803,1255233600,6),(803,1270350000,7),(803,1286683200,6),(803,1304823600,7),(803,1313899200,6),(803,1335668400,7),(803,1346558400,6),(803,1367118000,7),(803,1378612800,6),(803,1398567600,7),(803,1410062400,6),(803,1463281200,7),(803,1471147200,6),(803,1494730800,7),(803,1502596800,6),(803,1526180400,7),(803,1534046400,6),(803,1554606000,7),(803,1567915200,6),(803,1586055600,7),(803,1599364800,6),(803,1617505200,7),(803,1630814400,6),(803,1648954800,7),(803,1662264000,6),(803,1680404400,7),(803,1693713600,6),(803,1712458800,7),(803,1725768000,6),(803,1743908400,7),(803,1757217600,6),(803,1775358000,7),(803,1788667200,6),(803,1806807600,7),(803,1820116800,6),(803,1838257200,7),(803,1851566400,6),(803,1870311600,7),(803,1883016000,6),(803,1901761200,7),(803,1915070400,6),(803,1933210800,7),(803,1946520000,6),(803,1964660400,7),(803,1977969600,6),(803,1996110000,7),(803,2009419200,6),(803,2027559600,7),(803,2040868800,6),(803,2059614000,7),(803,2072318400,6),(803,2091063600,7),(803,2104372800,6),(803,2122513200,7),(803,2135822400,6),(803,2147483647,6),(804,-2147483648,1),(804,-1159773600,3),(804,-100119600,2),(804,-89668800,3),(804,-5770800,4),(804,4422600,3),(804,25678800,4),(804,33193800,3),(804,57733200,4),(804,64816200,3),(804,89182800,4),(804,96438600,3),(804,120632400,4),(804,127974600,3),(804,152082000,5),(804,972799200,3),(804,975823200,5),(805,-2147483648,0),(805,-1767214412,2),(805,-1206957600,1),(805,-1191362400,2),(805,-1175374800,1),(805,-1159826400,2),(805,-633819600,1),(805,-622069200,2),(805,-602283600,1),(805,-591832800,2),(805,-570747600,1),(805,-560210400,2),(805,-539125200,1),(805,-531352800,2),(805,-195426000,1),(805,-184197600,2),(805,-155163600,1),(805,-150069600,2),(805,-128898000,1),(805,-121125600,2),(805,-99954000,1),(805,-89589600,2),(805,-68418000,1),(805,-57967200,2),(805,499748400,1),(805,511236000,2),(805,530593200,1),(805,540266400,2),(805,562129200,1),(805,571197600,2),(805,592974000,1),(805,602042400,2),(805,624423600,1),(805,634701600,2),(805,656478000,1),(805,666756000,2),(805,687927600,1),(805,697600800,2),(805,719982000,1),(805,728445600,2),(805,750826800,1),(805,761709600,2),(805,782276400,1),(805,793159200,2),(805,813726000,1),(805,824004000,2),(805,844570800,1),(805,856058400,2),(805,876106800,1),(805,888717600,2),(805,908074800,1),(805,919562400,2),(805,938919600,1),(805,951616800,2),(805,970974000,1),(805,982461600,2),(805,1003028400,1),(805,1013911200,2),(805,1036292400,1),(805,1045360800,2),(805,1066532400,1),(805,1076810400,2),(805,1099364400,1),(805,1108864800,2),(805,1129431600,1),(805,1140314400,2),(805,1162695600,1),(805,1172368800,2),(805,1192330800,1),(805,1203213600,2),(805,1224385200,1),(805,1234663200,2),(805,1255834800,1),(805,1266717600,2),(805,1287284400,1),(805,1298167200,2),(805,1318734000,1),(805,1330221600,2),(805,1350788400,1),(805,1361066400,2),(805,1382238000,1),(805,1392516000,2),(805,1413687600,1),(805,1424570400,2),(805,1445137200,1),(805,1456020000,2),(805,1476586800,1),(805,1487469600,2),(805,1508036400,1),(805,1518919200,2),(805,1541300400,1),(805,1550368800,2),(805,1572750000,1),(805,1581818400,2),(805,1604199600,1),(805,1613872800,2),(805,1636254000,1),(805,1645322400,2),(805,1667703600,1),(805,1677376800,2),(805,1699153200,1),(805,1708221600,2),(805,1730602800,1),(805,1739671200,2),(805,1762052400,1),(805,1771725600,2),(805,1793502000,1),(805,1803175200,2),(805,1825556400,1),(805,1834624800,2),(805,1857006000,1),(805,1866074400,2),(805,1888455600,1),(805,1897524000,2),(805,1919905200,1),(805,1928973600,2),(805,1951354800,1),(805,1960423200,2),(805,1983409200,1),(805,1992477600,2),(805,2014858800,1),(805,2024532000,2),(805,2046308400,1),(805,2055376800,2),(805,2077758000,1),(805,2086826400,2),(805,2109207600,1),(805,2118880800,2),(805,2140657200,1),(806,-2147483648,0),(806,-1686090728,1),(806,323841600,2),(806,338961600,3),(806,354679200,6),(806,370400400,4),(806,386125200,5),(806,401850000,4),(806,417574800,5),(806,433299600,4),(806,449024400,5),(806,465354000,4),(806,481078800,5),(806,496803600,4),(806,512528400,5),(806,528253200,4),(806,543978000,5),(806,559702800,4),(806,575427600,5),(806,591152400,4),(806,606877200,5),(806,622602000,4),(806,638326800,5),(806,654656400,4),(806,670381200,5),(806,686106000,4),(806,701830800,5),(806,717555600,4),(806,733280400,5),(806,749005200,4),(806,764730000,5),(806,780454800,4),(806,796179600,5),(806,811904400,4),(806,828234000,5),(806,846378000,4),(806,859683600,5),(806,877827600,4),(806,891133200,5),(806,909277200,4),(806,922582800,5),(806,941331600,4),(806,954032400,5),(806,972781200,4),(806,985482000,5),(806,1004230800,4),(806,1017536400,5),(806,1035680400,4),(806,1048986000,5),(806,1067130000,4),(806,1080435600,5),(806,1099184400,4),(806,1111885200,5),(806,1130634000,4),(806,1143334800,5),(806,1162083600,4),(806,1174784400,5),(806,1193533200,4),(806,1206838800,5),(806,1224982800,4),(806,1238288400,5),(806,1256432400,4),(806,1269738000,5),(806,1288486800,4),(806,1301187600,5),(806,1319936400,4),(806,1332637200,5),(806,1351386000,4),(806,1364691600,5),(806,1382835600,4),(806,1396141200,5),(806,1414285200,4),(806,1427590800,5),(806,1445734800,4),(806,1459040400,5),(806,1477789200,4),(806,1490490000,5),(806,1509238800,4),(806,1521939600,5),(806,1540688400,4),(806,1553994000,5),(806,1572138000,4),(806,1585443600,5),(806,1603587600,4),(806,1616893200,5),(806,1635642000,4),(806,1648342800,5),(806,1667091600,4),(806,1679792400,5),(806,1698541200,4),(806,1711846800,5),(806,1729990800,4),(806,1743296400,5),(806,1761440400,4),(806,1774746000,5),(806,1792890000,4),(806,1806195600,5),(806,1824944400,4),(806,1837645200,5),(806,1856394000,4),(806,1869094800,5),(806,1887843600,4),(806,1901149200,5),(806,1919293200,4),(806,1932598800,5),(806,1950742800,4),(806,1964048400,5),(806,1982797200,4),(806,1995498000,5),(806,2014246800,4),(806,2026947600,5),(806,2045696400,4),(806,2058397200,5),(806,2077146000,4),(806,2090451600,5),(806,2108595600,4),(806,2121901200,5),(806,2140045200,4),(806,2147483647,4),(807,-2147483648,2),(807,-1633273200,1),(807,-1615132800,2),(807,-1601823600,1),(807,-1583683200,2),(807,-1570374000,1),(807,-1551628800,2),(807,-1538924400,1),(807,-1534089600,2),(807,-880210800,3),(807,-769395600,4),(807,-765388800,2),(807,-147884400,1),(807,-131558400,2),(807,-116434800,1),(807,-100108800,2),(807,-84380400,1),(807,-68659200,2),(807,-52930800,1),(807,-37209600,2),(807,-21481200,1),(807,-5760000,2),(807,9968400,1),(807,25689600,2),(807,41418000,1),(807,57744000,2),(807,73472400,1),(807,89193600,2),(807,104922000,1),(807,120643200,2),(807,126694800,1),(807,152092800,2),(807,162378000,1),(807,183542400,2),(807,199270800,1),(807,215596800,2),(807,230720400,1),(807,247046400,2),(807,262774800,1),(807,278496000,2),(807,294224400,1),(807,309945600,2),(807,325674000,1),(807,341395200,2),(807,357123600,1),(807,372844800,2),(807,388573200,1),(807,404899200,2),(807,420022800,1),(807,436348800,2),(807,452077200,1),(807,467798400,2),(807,483526800,1),(807,499248000,2),(807,514976400,1),(807,530697600,2),(807,544611600,1),(807,562147200,2),(807,576061200,1),(807,594201600,2),(807,607510800,1),(807,625651200,2),(807,638960400,1),(807,657100800,2),(807,671014800,1),(807,688550400,2),(807,702464400,1),(807,720000000,2),(807,733914000,1),(807,752054400,2),(807,765363600,1),(807,783504000,2),(807,796813200,1),(807,814953600,2),(807,828867600,1),(807,846403200,2),(807,860317200,1),(807,877852800,2),(807,891766800,1),(807,909302400,2),(807,923216400,1),(807,941356800,2),(807,954666000,1),(807,972806400,2),(807,986115600,1),(807,1004256000,2),(807,1018170000,1),(807,1035705600,2),(807,1049619600,1),(807,1067155200,2),(807,1081069200,1),(807,1099209600,2),(807,1112518800,1),(807,1130659200,2),(807,1143968400,1),(807,1162108800,2),(807,1173603600,1),(807,1194163200,2),(807,1205053200,1),(807,1225612800,2),(807,1236502800,1),(807,1257062400,2),(807,1268557200,1),(807,1289116800,2),(807,1300006800,1),(807,1320566400,2),(807,1331456400,1),(807,1352016000,2),(807,1362906000,1),(807,1383465600,2),(807,1394355600,1),(807,1414915200,2),(807,1425805200,1),(807,1446364800,2),(807,1457859600,1),(807,1478419200,2),(807,1489309200,1),(807,1509868800,2),(807,1520758800,1),(807,1541318400,2),(807,1552208400,1),(807,1572768000,2),(807,1583658000,1),(807,1604217600,2),(807,1615712400,1),(807,1636272000,2),(807,1647162000,1),(807,1667721600,2),(807,1678611600,1),(807,1699171200,2),(807,1710061200,1),(807,1730620800,2),(807,1741510800,1),(807,1762070400,2),(807,1772960400,1),(807,1793520000,2),(807,1805014800,1),(807,1825574400,2),(807,1836464400,1),(807,1857024000,2),(807,1867914000,1),(807,1888473600,2),(807,1899363600,1),(807,1919923200,2),(807,1930813200,1),(807,1951372800,2),(807,1962867600,1),(807,1983427200,2),(807,1994317200,1),(807,2014876800,2),(807,2025766800,1),(807,2046326400,2),(807,2057216400,1),(807,2077776000,2),(807,2088666000,1),(807,2109225600,2),(807,2120115600,1),(807,2140675200,2),(808,-2147483648,1),(808,-880207200,2),(808,-769395600,3),(808,-765385200,1),(808,-21477600,4),(808,-5756400,1),(808,9972000,4),(808,25693200,1),(808,41421600,4),(808,57747600,1),(808,73476000,4),(808,89197200,1),(808,104925600,4),(808,120646800,1),(808,126698400,4),(808,152096400,1),(808,162381600,4),(808,183546000,1),(808,199274400,4),(808,215600400,1),(808,230724000,4),(808,247050000,1),(808,262778400,4),(808,278499600,1),(808,294228000,4),(808,309949200,1),(808,325677600,4),(808,341398800,1),(808,357127200,4),(808,372848400,1),(808,388576800,4),(808,404902800,1),(808,420026400,4),(808,436352400,5),(808,439030800,7),(808,452084400,6),(808,467805600,7),(808,483534000,6),(808,499255200,7),(808,514983600,6),(808,530704800,7),(808,544618800,6),(808,562154400,7),(808,576068400,6),(808,594208800,7),(808,607518000,6),(808,625658400,7),(808,638967600,6),(808,657108000,7),(808,671022000,6),(808,688557600,7),(808,702471600,6),(808,720007200,7),(808,733921200,6),(808,752061600,7),(808,765370800,6),(808,783511200,7),(808,796820400,6),(808,814960800,7),(808,828874800,6),(808,846410400,7),(808,860324400,6),(808,877860000,7),(808,891774000,6),(808,909309600,7),(808,923223600,6),(808,941364000,7),(808,954673200,6),(808,972813600,7),(808,986122800,6),(808,1004263200,7),(808,1018177200,6),(808,1035712800,7),(808,1049626800,6),(808,1067162400,7),(808,1081076400,6),(808,1099216800,7),(808,1112526000,6),(808,1130666400,7),(808,1143975600,6),(808,1162116000,7),(808,1173610800,6),(808,1194170400,7),(808,1205060400,6),(808,1225620000,7),(808,1236510000,6),(808,1257069600,7),(808,1268564400,6),(808,1289124000,7),(808,1300014000,6),(808,1320573600,7),(808,1331463600,6),(808,1352023200,7),(808,1362913200,6),(808,1383472800,7),(808,1394362800,6),(808,1414922400,7),(808,1425812400,6),(808,1446372000,7),(808,1457866800,6),(808,1478426400,7),(808,1489316400,6),(808,1509876000,7),(808,1520766000,6),(808,1541325600,7),(808,1552215600,6),(808,1572775200,7),(808,1583665200,6),(808,1604224800,7),(808,1615719600,6),(808,1636279200,7),(808,1647169200,6),(808,1667728800,7),(808,1678618800,6),(808,1699178400,7),(808,1710068400,6),(808,1730628000,7),(808,1741518000,6),(808,1762077600,7),(808,1772967600,6),(808,1793527200,7),(808,1805022000,6),(808,1825581600,7),(808,1836471600,6),(808,1857031200,7),(808,1867921200,6),(808,1888480800,7),(808,1899370800,6),(808,1919930400,7),(808,1930820400,6),(808,1951380000,7),(808,1962874800,6),(808,1983434400,7),(808,1994324400,6),(808,2014884000,7),(808,2025774000,6),(808,2046333600,7),(808,2057223600,6),(808,2077783200,7),(808,2088673200,6),(808,2109232800,7),(808,2120122800,6),(808,2140682400,7),(809,-2147483648,0),(809,-1825098836,1),(810,-2147483648,2),(810,-1664130548,1),(810,-1650137348,2),(810,-1632076148,1),(810,-1615145348,2),(810,-1598650148,1),(810,-1590100148,2),(810,-1567286948,1),(810,-1551565748,2),(810,-1535837348,1),(810,-1520116148,2),(810,-1503782948,1),(810,-1488666548,2),(810,-1472333348,1),(810,-1457216948,2),(810,-1440883748,1),(810,-1425767348,2),(810,-1409434148,1),(810,-1394317748,2),(810,-1377984548,1),(810,-1362263348,2),(810,-1346534948,1),(810,-1330813748,2),(810,-1314480548,1),(810,-1299364148,2),(810,-1283030948,1),(810,-1267914548,2),(810,-1251581348,1),(810,-1236464948,2),(810,-1220131748,1),(810,-1205015348,2),(810,-1188682148,1),(810,-1172960948,2),(810,-1156627748,1),(810,-1141511348,2),(810,-1125178148,1),(810,-1110061748,2),(810,-1096921748,4),(810,-1093728600,3),(810,-1078612200,4),(810,-1061670600,3),(810,-1048973400,4),(810,-1030221000,3),(810,-1017523800,4),(810,-998771400,3),(810,-986074200,4),(810,-966717000,3),(810,-954624600,4),(810,-935267400,3),(810,-922570200,4),(810,-903817800,3),(810,-891120600,4),(810,-872368200,6),(810,-769395600,5),(810,-765401400,4),(810,-746044200,3),(810,-733347000,4),(810,-714594600,3),(810,-701897400,4),(810,-683145000,3),(810,-670447800,4),(810,-651695400,3),(810,-638998200,4),(810,-619641000,3),(810,-606943800,4),(810,-589401000,3),(810,-576099000,4),(810,-557951400,3),(810,-544649400,4),(810,-526501800,3),(810,-513199800,4),(810,-495052200,3),(810,-481750200,4),(810,-463602600,3),(810,-450300600,4),(810,-431548200,3),(810,-418246200,4),(810,-400098600,3),(810,-386796600,4),(810,-368649000,3),(810,-355347000,4),(810,-337199400,3),(810,-323897400,4),(810,-305749800,3),(810,-289423800,4),(810,-273695400,3),(810,-257974200,4),(810,-242245800,3),(810,-226524600,4),(810,-210796200,3),(810,-195075000,4),(810,-179346600,3),(810,-163625400,4),(810,-147897000,3),(810,-131571000,4),(810,-116447400,3),(810,-100121400,4),(810,-84393000,3),(810,-68671800,4),(810,-52943400,3),(810,-37222200,4),(810,-21493800,3),(810,-5772600,4),(810,9955800,3),(810,25677000,4),(810,41405400,3),(810,57731400,4),(810,73459800,3),(810,89181000,4),(810,104909400,3),(810,120630600,4),(810,136359000,3),(810,152080200,4),(810,167808600,3),(810,183529800,4),(810,199258200,3),(810,215584200,4),(810,230707800,3),(810,247033800,4),(810,262762200,3),(810,278483400,4),(810,294211800,3),(810,309933000,4),(810,325661400,3),(810,341382600,4),(810,357111000,3),(810,372832200,4),(810,388560600,3),(810,404886600,4),(810,420010200,3),(810,436336200,4),(810,452064600,3),(810,467785800,4),(810,483514200,3),(810,499235400,4),(810,514963800,3),(810,530685000,4),(810,544591860,3),(810,562127460,4),(810,576041460,7),(810,594178260,4),(810,607491060,3),(810,625631460,4),(810,638940660,3),(810,657081060,4),(810,670995060,3),(810,688530660,4),(810,702444660,3),(810,719980260,4),(810,733894260,3),(810,752034660,4),(810,765343860,3),(810,783484260,4),(810,796793460,3),(810,814933860,4),(810,828847860,3),(810,846383460,4),(810,860297460,3),(810,877833060,4),(810,891747060,3),(810,909282660,4),(810,923196660,3),(810,941337060,4),(810,954646260,3),(810,972786660,4),(810,986095860,3),(810,1004236260,4),(810,1018150260,3),(810,1035685860,4),(810,1049599860,3),(810,1067135460,4),(810,1081049460,3),(810,1099189860,4),(810,1112499060,3),(810,1130639460,4),(810,1143948660,3),(810,1162089060,4),(810,1173583860,3),(810,1194143460,4),(810,1205033460,3),(810,1225593060,4),(810,1236483060,3),(810,1257042660,4),(810,1268537460,3),(810,1289097060,4),(810,1299987060,3),(810,1320553800,4),(810,1331443800,3),(810,1352003400,4),(810,1362893400,3),(810,1383453000,4),(810,1394343000,3),(810,1414902600,4),(810,1425792600,3),(810,1446352200,4),(810,1457847000,3),(810,1478406600,4),(810,1489296600,3),(810,1509856200,4),(810,1520746200,3),(810,1541305800,4),(810,1552195800,3),(810,1572755400,4),(810,1583645400,3),(810,1604205000,4),(810,1615699800,3),(810,1636259400,4),(810,1647149400,3),(810,1667709000,4),(810,1678599000,3),(810,1699158600,4),(810,1710048600,3),(810,1730608200,4),(810,1741498200,3),(810,1762057800,4),(810,1772947800,3),(810,1793507400,4),(810,1805002200,3),(810,1825561800,4),(810,1836451800,3),(810,1857011400,4),(810,1867901400,3),(810,1888461000,4),(810,1899351000,3),(810,1919910600,4),(810,1930800600,3),(810,1951360200,4),(810,1962855000,3),(810,1983414600,4),(810,1994304600,3),(810,2014864200,4),(810,2025754200,3),(810,2046313800,4),(810,2057203800,3),(810,2077763400,4),(810,2088653400,3),(810,2109213000,4),(810,2120103000,3),(810,2140662600,4),(811,-2147483648,0),(811,-1825098836,1),(812,-2147483648,0),(812,-1825098836,1),(813,-2147483648,0),(813,-1825098836,1),(814,-2147483648,0),(814,-1825098836,1),(815,-2147483648,0),(815,-2030201320,2),(815,-1632063600,1),(815,-1615132800,2),(815,-880210800,3),(815,-769395600,4),(815,-765388800,2),(815,-747241200,1),(815,-732729600,2),(815,-715791600,1),(815,-702489600,2),(815,-684342000,1),(815,-671040000,2),(815,-652892400,1),(815,-639590400,2),(815,-400086000,1),(815,-384364800,2),(815,-337186800,1),(815,-321465600,2),(815,-305737200,1),(815,-292435200,2),(815,-273682800,1),(815,-260985600,2),(815,73472400,5),(816,-2147483648,0),(816,-1538503868,2),(816,547020000,1),(816,559717200,2),(816,578469600,1),(816,591166800,2),(816,1146981600,1),(816,1154926800,2),(817,-2147483648,0),(817,-1686079492,2),(817,670399200,1),(817,686120400,2),(817,701848800,1),(817,717570000,2),(817,733903200,1),(817,752043600,2),(817,765352800,1),(817,783493200,2),(817,796802400,1),(817,814942800,2),(817,828856800,1),(817,846392400,2),(817,860306400,1),(817,877842000,2),(817,891756000,1),(817,909291600,2),(817,923205600,1),(817,941346000,2),(817,954655200,1),(817,972795600,2),(817,986104800,1),(817,1004245200,2),(817,1018159200,1),(817,1035694800,2),(817,1049608800,1),(817,1067144400,2),(817,1081058400,1),(817,1099198800,2),(817,1112508000,1),(817,1130648400,2),(817,1143957600,1),(817,1162098000,2),(817,1173592800,1),(817,1194152400,2),(817,1205042400,1),(817,1225602000,2),(817,1236492000,1),(817,1257051600,2),(817,1268546400,1),(817,1289106000,2),(817,1299996000,1),(817,1320555600,2),(817,1331445600,1),(817,1352005200,2),(817,1362895200,1),(817,1383454800,2),(817,1394344800,1),(817,1414904400,2),(817,1425794400,1),(817,1446354000,2),(817,1457848800,1),(817,1478408400,2),(817,1489298400,1),(817,1509858000,2),(817,1520748000,1),(817,1541307600,2),(817,1552197600,1),(817,1572757200,2),(817,1583647200,1),(817,1604206800,2),(817,1615701600,1),(817,1636261200,2),(817,1647151200,1),(817,1667710800,2),(817,1678600800,1),(817,1699160400,2),(817,1710050400,1),(817,1730610000,2),(817,1741500000,1),(817,1762059600,2),(817,1772949600,1),(817,1793509200,2),(817,1805004000,1),(817,1825563600,2),(817,1836453600,1),(817,1857013200,2),(817,1867903200,1),(817,1888462800,2),(817,1899352800,1),(817,1919912400,2),(817,1930802400,1),(817,1951362000,2),(817,1962856800,1),(817,1983416400,2),(817,1994306400,1),(817,2014866000,2),(817,2025756000,1),(817,2046315600,2),(817,2057205600,1),(817,2077765200,2),(817,2088655200,1),(817,2109214800,2),(817,2120104800,1),(817,2140664400,2),(818,-2147483648,1),(818,-1893434400,2),(818,-880218000,3),(818,-769395600,4),(818,-765396000,2),(818,9961200,5),(818,25682400,2),(818,41410800,5),(818,57736800,2),(818,73465200,5),(818,89186400,2),(818,136364400,5),(818,152085600,2),(818,167814000,5),(818,183535200,2),(818,199263600,5),(818,215589600,2),(818,230713200,5),(818,247039200,2),(818,262767600,5),(818,278488800,2),(818,294217200,5),(818,309938400,2),(818,325666800,5),(818,341388000,2),(818,357116400,5),(818,372837600,2),(818,388566000,5),(818,404892000,2),(818,420015600,5),(818,436341600,2),(818,452070000,5),(818,467791200,2),(818,483519600,5),(818,499240800,2),(818,514969200,5),(818,530690400,2),(818,544604400,5),(818,562140000,2),(818,576054000,5),(818,594194400,2),(818,607503600,5),(818,625644000,2),(818,638953200,5),(818,657093600,2),(818,671007600,5),(818,688543200,2),(818,702457200,5),(818,719992800,2),(818,733906800,5),(818,752047200,2),(818,765356400,5),(818,783496800,2),(818,796806000,5),(818,814946400,2),(818,828860400,5),(818,846396000,2),(818,860310000,5),(818,877845600,2),(818,891759600,5),(818,909295200,2),(818,923209200,5),(818,941349600,2),(818,954658800,5),(818,972799200,2),(818,986108400,5),(818,1004248800,2),(818,1018162800,5),(818,1035698400,2),(818,1049612400,5),(818,1067148000,2),(818,1081062000,5),(818,1099202400,2),(818,1112511600,5),(818,1130652000,2),(818,1143961200,5),(818,1162101600,2),(818,1173596400,5),(818,1194156000,2),(818,1205046000,5),(818,1225605600,2),(818,1236495600,5),(818,1257055200,2),(818,1268550000,5),(818,1289109600,2),(818,1299999600,5),(818,1320559200,2),(818,1331449200,5),(818,1352008800,2),(818,1362898800,5),(818,1383458400,2),(818,1394348400,5),(818,1414908000,2),(818,1425798000,5),(818,1446357600,2),(818,1457852400,5),(818,1478412000,2),(818,1489302000,5),(818,1509861600,2),(818,1520751600,5),(818,1541311200,2),(818,1552201200,5),(818,1572760800,2),(818,1583650800,5),(818,1604210400,2),(818,1615705200,5),(818,1636264800,2),(818,1647154800,5),(818,1667714400,2),(818,1678604400,5),(818,1699164000,2),(818,1710054000,5),(818,1730613600,2),(818,1741503600,5),(818,1762063200,2),(818,1772953200,5),(818,1793512800,2),(818,1805007600,5),(818,1825567200,2),(818,1836457200,5),(818,1857016800,2),(818,1867906800,5),(818,1888466400,2),(818,1899356400,5),(818,1919916000,2),(818,1930806000,5),(818,1951365600,2),(818,1962860400,5),(818,1983420000,2),(818,1994310000,5),(818,2014869600,2),(818,2025759600,5),(818,2046319200,2),(818,2057209200,5),(818,2077768800,2),(818,2088658800,5),(818,2109218400,2),(818,2120108400,5),(818,2140668000,2),(819,-2147483648,0),(819,-1514736000,1),(819,-1451667600,2),(819,-1343062800,1),(819,-1234803600,2),(819,-1222963200,3),(819,-1207242000,2),(819,-873820800,4),(819,-769395600,5),(819,-761677200,2),(819,-686073600,3),(819,-661539600,2),(819,-495039600,3),(819,-481734000,2),(819,-463590000,3),(819,-450284400,2),(819,-431535600,3),(819,-418230000,2),(819,-400086000,3),(819,-386780400,2),(819,-368636400,3),(819,-355330800,2),(819,-337186800,3),(819,-323881200,2),(819,-305737200,3),(819,-292431600,2),(819,199274400,3),(819,215600400,2),(819,230724000,3),(819,247050000,2),(819,262778400,3),(819,278499600,2),(819,294228000,3),(819,309949200,2),(819,325677600,3),(819,341398800,2),(819,357127200,3),(819,372848400,2),(819,388576800,3),(819,404902800,2),(819,420026400,3),(819,436352400,2),(819,452080800,3),(819,467802000,2),(819,483530400,3),(819,499251600,2),(819,514980000,3),(819,530701200,2),(819,544615200,3),(819,562150800,2),(819,576064800,3),(819,594205200,2),(819,607514400,3),(819,625654800,2),(819,638964000,3),(819,657104400,2),(819,671018400,3),(819,688554000,2),(819,702468000,3),(819,720003600,2),(819,733917600,3),(819,752058000,2),(819,765367200,3),(819,783507600,2),(819,796816800,3),(819,814957200,2),(819,828871200,3),(819,846406800,2),(819,860320800,3),(819,877856400,2),(819,891770400,3),(819,909306000,2),(819,923220000,3),(819,941360400,2),(819,954669600,3),(819,972810000,2),(819,986119200,3),(819,1004259600,2),(819,1018173600,3),(819,1035709200,2),(819,1049623200,3),(819,1067158800,2),(819,1081072800,3),(819,1099213200,2),(819,1112522400,3),(819,1130662800,2),(819,1143972000,3),(819,1162112400,2),(819,1175421600,3),(819,1193562000,2),(819,1207476000,3),(819,1225011600,2),(819,1238925600,3),(819,1256461200,2),(819,1268560800,3),(819,1289120400,2),(819,1300010400,3),(819,1320570000,2),(819,1331460000,3),(819,1352019600,2),(819,1362909600,3),(819,1383469200,2),(819,1394359200,3),(819,1414918800,2),(819,1425808800,3),(819,1446368400,2),(819,1457863200,3),(819,1478422800,2),(819,1489312800,3),(819,1509872400,2),(819,1520762400,3),(819,1541322000,2),(819,1552212000,3),(819,1572771600,2),(819,1583661600,3),(819,1604221200,2),(819,1615716000,3),(819,1636275600,2),(819,1647165600,3),(819,1667725200,2),(819,1678615200,3),(819,1699174800,2),(819,1710064800,3),(819,1730624400,2),(819,1741514400,3),(819,1762074000,2),(819,1772964000,3),(819,1793523600,2),(819,1805018400,3),(819,1825578000,2),(819,1836468000,3),(819,1857027600,2),(819,1867917600,3),(819,1888477200,2),(819,1899367200,3),(819,1919926800,2),(819,1930816800,3),(819,1951376400,2),(819,1962871200,3),(819,1983430800,2),(819,1994320800,3),(819,2014880400,2),(819,2025770400,3),(819,2046330000,2),(819,2057220000,3),(819,2077779600,2),(819,2088669600,3),(819,2109229200,2),(819,2120119200,3),(819,2140678800,2),(820,-2147483648,2),(820,-1632070800,1),(820,-1615140000,2),(820,-1601753400,1),(820,-1583697600,2),(820,-1567357200,1),(820,-1554667200,2),(820,-1534698000,1),(820,-1524074400,2),(820,-1503248400,1),(820,-1492365600,2),(820,-1471798800,1),(820,-1460916000,2),(820,-1440954000,1),(820,-1428861600,2),(820,-1409504400,1),(820,-1397412000,2),(820,-1378054800,1),(820,-1365962400,2),(820,-1346605200,1),(820,-1333908000,2),(820,-1315155600,1),(820,-1301853600,2),(820,-1283706000,1),(820,-1270404000,2),(820,-1252256400,1),(820,-1238954400,2),(820,-1220806800,1),(820,-1207504800,2),(820,-1188752400,1),(820,-1176055200,2),(820,-1157302800,1),(820,-1144000800,2),(820,-1125853200,1),(820,-1112551200,2),(820,-1094403600,1),(820,-1081101600,2),(820,-1062954000,1),(820,-1049652000,2),(820,-1031504400,1),(820,-1018202400,2),(820,-1000054800,1),(820,-986752800,2),(820,-968000400,1),(820,-955303200,2),(820,-936550800,1),(820,-880218000,3),(820,-769395600,4),(820,-765396000,2),(820,-747248400,1),(820,-733946400,2),(820,-715806000,1),(820,-702504000,2),(820,-684356400,1),(820,-671054400,2),(820,-652906800,1),(820,-634161600,2),(820,-620845200,1),(820,-602704800,2),(820,-589395600,1),(820,-576093600,2),(820,-557946000,1),(820,-544644000,2),(820,-526496400,1),(820,-513194400,2),(820,-495046800,1),(820,-481744800,2),(820,-463597200,1),(820,-450295200,2),(820,-431542800,1),(820,-418240800,2),(820,-400093200,1),(820,-384372000,2),(820,-368643600,1),(820,-352922400,2),(820,-337194000,1),(820,-321472800,2),(820,-305744400,1),(820,-289418400,2),(820,-273690000,1),(820,-257968800,2),(820,-242240400,1),(820,-226519200,2),(820,-210790800,1),(820,-195069600,2),(820,-179341200,1),(820,-163620000,2),(820,-147891600,1),(820,-131565600,2),(820,-116442000,1),(820,-100116000,2),(820,-84387600,1),(820,-68666400,2),(820,-52938000,1),(820,-37216800,2),(820,-21488400,1),(820,-5767200,2),(820,9961200,1),(820,25682400,2),(820,41410800,1),(820,57736800,2),(820,73465200,1),(820,89186400,2),(820,104914800,1),(820,120636000,2),(820,136364400,1),(820,152085600,2),(820,167814000,1),(820,183535200,2),(820,199263600,1),(820,215589600,2),(820,230713200,1),(820,247039200,2),(820,262767600,1),(820,278488800,2),(820,294217200,1),(820,309938400,2),(820,325666800,1),(820,341388000,2),(820,357116400,1),(820,372837600,2),(820,388566000,1),(820,404892000,2),(820,420015600,1),(820,436341600,2),(820,452070000,1),(820,467791200,2),(820,483519600,1),(820,499240800,2),(820,514969200,1),(820,530690400,2),(820,544604400,1),(820,562140000,2),(820,576054000,1),(820,594194400,2),(820,607503600,1),(820,625644000,2),(820,638953200,1),(820,657093600,2),(820,671007600,1),(820,688543200,2),(820,702457200,1),(820,719992800,2),(820,733906800,1),(820,752047200,2),(820,765356400,1),(820,783496800,2),(820,796806000,1),(820,814946400,2),(820,828860400,1),(820,846396000,2),(820,860310000,1),(820,877845600,2),(820,891759600,1),(820,909295200,2),(820,923209200,1),(820,941349600,2),(820,954658800,1),(820,972799200,2),(820,986108400,1),(820,1004248800,2),(820,1018162800,1),(820,1035698400,2),(820,1049612400,1),(820,1067148000,2),(820,1081062000,1),(820,1099202400,2),(820,1112511600,1),(820,1130652000,2),(820,1143961200,1),(820,1162101600,2),(820,1173596400,1),(820,1194156000,2),(820,1205046000,1),(820,1225605600,2),(820,1236495600,1),(820,1257055200,2),(820,1268550000,1),(820,1289109600,2),(820,1299999600,1),(820,1320559200,2),(820,1331449200,1),(820,1352008800,2),(820,1362898800,1),(820,1383458400,2),(820,1394348400,1),(820,1414908000,2),(820,1425798000,1),(820,1446357600,2),(820,1457852400,1),(820,1478412000,2),(820,1489302000,1),(820,1509861600,2),(820,1520751600,1),(820,1541311200,2),(820,1552201200,1),(820,1572760800,2),(820,1583650800,1),(820,1604210400,2),(820,1615705200,1),(820,1636264800,2),(820,1647154800,1),(820,1667714400,2),(820,1678604400,1),(820,1699164000,2),(820,1710054000,1),(820,1730613600,2),(820,1741503600,1),(820,1762063200,2),(820,1772953200,1),(820,1793512800,2),(820,1805007600,1),(820,1825567200,2),(820,1836457200,1),(820,1857016800,2),(820,1867906800,1),(820,1888466400,2),(820,1899356400,1),(820,1919916000,2),(820,1930806000,1),(820,1951365600,2),(820,1962860400,1),(820,1983420000,2),(820,1994310000,1),(820,2014869600,2),(820,2025759600,1),(820,2046319200,2),(820,2057209200,1),(820,2077768800,2),(820,2088658800,1),(820,2109218400,2),(820,2120108400,1),(820,2140668000,2),(821,-2147483648,0),(821,-1825098836,1),(822,-2147483648,2),(822,-1632060000,1),(822,-1615129200,2),(822,-880207200,3),(822,-769395600,4),(822,-765385200,2),(822,-747237600,1),(822,-732726000,2),(822,-715788000,1),(822,-702486000,2),(822,-684338400,1),(822,-671036400,2),(822,-652888800,1),(822,-639586800,2),(822,-620834400,1),(822,-608137200,2),(822,-589384800,1),(822,-576082800,2),(822,-557935200,1),(822,-544633200,2),(822,-526485600,1),(822,-513183600,2),(822,-495036000,1),(822,-481734000,2),(822,-463586400,1),(822,-450284400,2),(822,-431532000,1),(822,-418230000,2),(822,-400082400,1),(822,-386780400,2),(822,-368632800,1),(822,-355330800,2),(822,-337183200,1),(822,-323881200,2),(822,-305733600,1),(822,-292431600,2),(822,-273679200,1),(822,-260982000,2),(822,-242229600,1),(822,-226508400,2),(822,-210780000,1),(822,-195058800,2),(822,-179330400,1),(822,-163609200,2),(822,-147880800,1),(822,-131554800,2),(822,-116431200,1),(822,-100105200,2),(822,-84376800,1),(822,-68655600,2),(822,-52927200,1),(822,-37206000,2),(822,-21477600,1),(822,-5756400,2),(822,9972000,1),(822,25693200,2),(822,41421600,1),(822,57747600,2),(822,73476000,1),(822,89197200,2),(822,104925600,1),(822,120646800,2),(822,136375200,1),(822,152096400,2),(822,167824800,1),(822,183546000,2),(822,199274400,1),(822,215600400,2),(822,230724000,1),(822,247050000,2),(822,262778400,1),(822,278499600,2),(822,294228000,1),(822,309949200,2),(822,325677600,1),(822,341398800,2),(822,357127200,1),(822,372848400,2),(822,388576800,1),(822,404902800,2),(822,420026400,1),(822,436352400,2),(822,452080800,1),(822,467802000,2),(822,483530400,1),(822,499251600,2),(822,514980000,1),(822,530701200,2),(822,544615200,1),(822,562150800,2),(822,576064800,1),(822,594205200,2),(822,607514400,1),(822,625654800,2),(822,638964000,1),(822,657104400,2),(822,671018400,1),(822,688554000,2),(822,702468000,1),(822,720003600,2),(822,733917600,1),(822,752058000,2),(822,765367200,1),(822,783507600,2),(822,796816800,1),(822,814957200,2),(822,828871200,1),(822,846406800,2),(822,860320800,1),(822,877856400,2),(822,891770400,1),(822,909306000,2),(822,923220000,1),(822,941360400,2),(822,954669600,1),(822,972810000,2),(822,986119200,1),(822,1004259600,2),(822,1018173600,1),(822,1035709200,2),(822,1049623200,1),(822,1067158800,2),(822,1081072800,1),(822,1099213200,2),(822,1112522400,1),(822,1130662800,2),(822,1143972000,1),(822,1162112400,2),(822,1173607200,1),(822,1194166800,2),(822,1205056800,1),(822,1225616400,2),(822,1236506400,1),(822,1257066000,2),(822,1268560800,1),(822,1289120400,2),(822,1300010400,1),(822,1320570000,2),(822,1331460000,1),(822,1352019600,2),(822,1362909600,1),(822,1383469200,2),(822,1394359200,1),(822,1414918800,2),(822,1425808800,1),(822,1446368400,2),(822,1457863200,1),(822,1478422800,2),(822,1489312800,1),(822,1509872400,2),(822,1520762400,1),(822,1541322000,2),(822,1552212000,1),(822,1572771600,2),(822,1583661600,1),(822,1604221200,2),(822,1615716000,1),(822,1636275600,2),(822,1647165600,1),(822,1667725200,2),(822,1678615200,1),(822,1699174800,2),(822,1710064800,1),(822,1730624400,2),(822,1741514400,1),(822,1762074000,2),(822,1772964000,1),(822,1793523600,2),(822,1805018400,1),(822,1825578000,2),(822,1836468000,1),(822,1857027600,2),(822,1867917600,1),(822,1888477200,2),(822,1899367200,1),(822,1919926800,2),(822,1930816800,1),(822,1951376400,2),(822,1962871200,1),(822,1983430800,2),(822,1994320800,1),(822,2014880400,2),(822,2025770400,1),(822,2046330000,2),(822,2057220000,1),(822,2077779600,2),(822,2088669600,1),(822,2109229200,2),(822,2120119200,1),(822,2140678800,2),(823,-2147483648,0),(823,-1825098836,1),(824,-2147483648,2),(824,-1632056400,1),(824,-1615125600,2),(824,-1596978000,1),(824,-1583164800,2),(824,-880203600,3),(824,-769395600,4),(824,-765381600,2),(824,-147884400,5),(824,-131554800,2),(824,-81961200,6),(824,325677600,7),(824,341398800,6),(824,357127200,7),(824,372848400,6),(824,388576800,7),(824,404902800,6),(824,420026400,7),(824,436352400,6),(824,452080800,7),(824,467802000,6),(824,483530400,7),(824,499251600,6),(824,514980000,7),(824,530701200,6),(824,544615200,7),(824,562150800,6),(824,576064800,7),(824,594205200,6),(824,607514400,7),(824,625654800,6),(824,638964000,7),(824,657104400,6),(824,671018400,7),(824,688554000,6),(824,702468000,7),(824,720003600,6),(824,733917600,7),(824,752058000,6),(824,765367200,7),(824,783507600,6),(824,796816800,7),(824,814957200,6),(824,828871200,7),(824,846406800,6),(824,860320800,7),(824,877856400,6),(824,891770400,7),(824,909306000,6),(824,923220000,7),(824,941360400,6),(824,954669600,7),(824,972810000,6),(824,986119200,7),(824,1004259600,6),(824,1018173600,7),(824,1035709200,6),(824,1049623200,7),(824,1067158800,6),(824,1081072800,7),(824,1099213200,6),(824,1112522400,7),(824,1130662800,6),(824,1143972000,7),(824,1162112400,6),(824,1173607200,7),(824,1194166800,6),(824,1205056800,7),(824,1225616400,6),(824,1236506400,7),(824,1257066000,6),(824,1268560800,7),(824,1289120400,6),(824,1300010400,7),(824,1320570000,6),(824,1331460000,7),(824,1352019600,6),(824,1362909600,7),(824,1383469200,6),(824,1394359200,7),(824,1414918800,6),(824,1425808800,7),(824,1446368400,6),(824,1457863200,7),(824,1478422800,6),(824,1489312800,7),(824,1509872400,6),(824,1520762400,7),(824,1541322000,6),(824,1552212000,7),(824,1572771600,6),(824,1583661600,7),(824,1604221200,6),(824,1615716000,7),(824,1636275600,6),(824,1647165600,7),(824,1667725200,6),(824,1678615200,7),(824,1699174800,6),(824,1710064800,7),(824,1730624400,6),(824,1741514400,7),(824,1762074000,6),(824,1772964000,7),(824,1793523600,6),(824,1805018400,7),(824,1825578000,6),(824,1836468000,7),(824,1857027600,6),(824,1867917600,7),(824,1888477200,6),(824,1899367200,7),(824,1919926800,6),(824,1930816800,7),(824,1951376400,6),(824,1962871200,7),(824,1983430800,6),(824,1994320800,7),(824,2014880400,6),(824,2025770400,7),(824,2046330000,6),(824,2057220000,7),(824,2077779600,6),(824,2088669600,7),(824,2109229200,6),(824,2120119200,7),(824,2140678800,6),(825,-2147483648,2),(825,-1694368800,1),(825,-1681671600,2),(825,-1632067200,1),(825,-1615136400,2),(825,-1029686400,1),(825,-1018198800,2),(825,-880214400,3),(825,-769395600,4),(825,-765392400,2),(825,-746035200,1),(825,-732733200,2),(825,-715795200,1),(825,-702493200,2),(825,-684345600,1),(825,-671043600,2),(825,-652896000,1),(825,-639594000,2),(825,-620755200,1),(825,-607626000,2),(825,-589392000,1),(825,-576090000,2),(825,-557942400,1),(825,-544640400,2),(825,-526492800,1),(825,-513190800,2),(825,-495043200,1),(825,-481741200,2),(825,-463593600,1),(825,-450291600,2),(825,-431539200,1),(825,-418237200,2),(825,-400089600,1),(825,-386787600,2),(825,-368640000,1),(825,-355338000,2),(825,-337190400,1),(825,-321469200,2),(825,-305740800,1),(825,-292438800,2),(825,-210787200,1),(825,-198090000,2),(825,-116438400,5),(825,-100108800,6),(825,-84384000,5),(825,-68659200,6),(825,-52934400,5),(825,-37209600,6),(825,-21484800,5),(825,-5760000,6),(825,9964800,5),(825,25689600,6),(825,41414400,5),(825,57744000,6),(825,73468800,5),(825,89193600,6),(825,104918400,5),(825,120643200,6),(825,136368000,5),(825,152092800,6),(825,167817600,5),(825,183542400,6),(825,199267200,5),(825,215596800,6),(825,230716800,5),(825,247046400,6),(825,262771200,5),(825,278496000,6),(825,294220800,5),(825,309945600,6),(825,325670400,5),(825,341395200,6),(825,357120000,5),(825,372844800,6),(825,388569600,5),(825,404899200,6),(825,420019200,5),(825,436348800,6),(825,452073600,5),(825,467798400,6),(825,483523200,5),(825,499248000,6),(825,514972800,5),(825,530697600,6),(825,544608000,5),(825,562147200,6),(825,576057600,5),(825,594201600,6),(825,607507200,5),(825,625651200,6),(825,638956800,5),(825,657100800,6),(825,671011200,5),(825,688550400,6),(825,702460800,5),(825,720000000,6),(825,733910400,5),(825,752054400,6),(825,765360000,5),(825,783504000,6),(825,796809600,5),(825,814953600,6),(825,828864000,5),(825,846403200,6),(825,860313600,5),(825,877852800,6),(825,891763200,5),(825,909302400,6),(825,923212800,5),(825,941356800,6),(825,954662400,5),(825,972806400,6),(825,986112000,5),(825,1004256000,6),(825,1018166400,5),(825,1035705600,6),(825,1049616000,5),(825,1067155200,6),(825,1081065600,5),(825,1099209600,6),(825,1112515200,5),(825,1130659200,6),(825,1136095200,2),(825,1143964800,1),(825,1162105200,2),(825,1173600000,1),(825,1194159600,2),(825,1205049600,1),(825,1225609200,2),(825,1236499200,1),(825,1257058800,2),(825,1268553600,1),(825,1289113200,2),(825,1300003200,1),(825,1320562800,2),(825,1331452800,1),(825,1352012400,2),(825,1362902400,1),(825,1383462000,2),(825,1394352000,1),(825,1414911600,2),(825,1425801600,1),(825,1446361200,2),(825,1457856000,1),(825,1478415600,2),(825,1489305600,1),(825,1509865200,2),(825,1520755200,1),(825,1541314800,2),(825,1552204800,1),(825,1572764400,2),(825,1583654400,1),(825,1604214000,2),(825,1615708800,1),(825,1636268400,2),(825,1647158400,1),(825,1667718000,2),(825,1678608000,1),(825,1699167600,2),(825,1710057600,1),(825,1730617200,2),(825,1741507200,1),(825,1762066800,2),(825,1772956800,1),(825,1793516400,2),(825,1805011200,1),(825,1825570800,2),(825,1836460800,1),(825,1857020400,2),(825,1867910400,1),(825,1888470000,2),(825,1899360000,1),(825,1919919600,2),(825,1930809600,1),(825,1951369200,2),(825,1962864000,1),(825,1983423600,2),(825,1994313600,1),(825,2014873200,2),(825,2025763200,1),(825,2046322800,2),(825,2057212800,1),(825,2077772400,2),(825,2088662400,1),(825,2109222000,2),(825,2120112000,1),(825,2140671600,2),(826,-2147483648,1),(826,-880203600,2),(826,-769395600,3),(826,-765381600,1),(826,-21474000,4),(826,-5752800,1),(826,9975600,4),(826,25696800,1),(826,41425200,4),(826,57751200,1),(826,73479600,4),(826,89200800,1),(826,104929200,4),(826,120650400,1),(826,126702000,4),(826,152100000,1),(826,162385200,4),(826,183549600,1),(826,199278000,4),(826,215604000,1),(826,230727600,4),(826,247053600,1),(826,262782000,4),(826,278503200,1),(826,294231600,4),(826,309952800,1),(826,325681200,4),(826,341402400,1),(826,357130800,4),(826,372852000,1),(826,388580400,4),(826,404906400,1),(826,420030000,4),(826,436356000,1),(826,439030800,6),(826,452084400,5),(826,467805600,6),(826,483534000,5),(826,499255200,6),(826,514983600,5),(826,530704800,6),(826,544618800,5),(826,562154400,6),(826,576068400,5),(826,594208800,6),(826,607518000,5),(826,625658400,6),(826,638967600,5),(826,657108000,6),(826,671022000,5),(826,688557600,6),(826,702471600,5),(826,720007200,6),(826,733921200,5),(826,752061600,6),(826,765370800,5),(826,783511200,6),(826,796820400,5),(826,814960800,6),(826,828874800,5),(826,846410400,6),(826,860324400,5),(826,877860000,6),(826,891774000,5),(826,909309600,6),(826,923223600,5),(826,941364000,6),(826,954673200,5),(826,972813600,6),(826,986122800,5),(826,1004263200,6),(826,1018177200,5),(826,1035712800,6),(826,1049626800,5),(826,1067162400,6),(826,1081076400,5),(826,1099216800,6),(826,1112526000,5),(826,1130666400,6),(826,1143975600,5),(826,1162116000,6),(826,1173610800,5),(826,1194170400,6),(826,1205060400,5),(826,1225620000,6),(826,1236510000,5),(826,1257069600,6),(826,1268564400,5),(826,1289124000,6),(826,1300014000,5),(826,1320573600,6),(826,1331463600,5),(826,1352023200,6),(826,1362913200,5),(826,1383472800,6),(826,1394362800,5),(826,1414922400,6),(826,1425812400,5),(826,1446372000,6),(826,1457866800,5),(826,1478426400,6),(826,1489316400,5),(826,1509876000,6),(826,1520766000,5),(826,1541325600,6),(826,1552215600,5),(826,1572775200,6),(826,1583665200,5),(826,1604224800,6),(826,1615719600,5),(826,1636279200,6),(826,1647169200,5),(826,1667728800,6),(826,1678618800,5),(826,1699178400,6),(826,1710068400,5),(826,1730628000,6),(826,1741518000,5),(826,1762077600,6),(826,1772967600,5),(826,1793527200,6),(826,1805022000,5),(826,1825581600,6),(826,1836471600,5),(826,1857031200,6),(826,1867921200,5),(826,1888480800,6),(826,1899370800,5),(826,1919930400,6),(826,1930820400,5),(826,1951380000,6),(826,1962874800,5),(826,1983434400,6),(826,1994324400,5),(826,2014884000,6),(826,2025774000,5),(826,2046333600,6),(826,2057223600,5),(826,2077783200,6),(826,2088673200,5),(826,2109232800,6),(826,2120122800,5),(826,2140682400,6),(827,-2147483648,0),(827,-1104537600,3),(827,-880210800,1),(827,-769395600,2),(827,-765388800,3),(827,-147891600,4),(827,-131562000,3),(827,325674000,5),(827,341395200,3),(827,357123600,5),(827,372844800,3),(827,388573200,5),(827,404899200,3),(827,420022800,5),(827,436348800,3),(827,452077200,5),(827,467798400,3),(827,483526800,5),(827,499248000,3),(827,514976400,5),(827,530697600,3),(827,544611600,5),(827,562147200,3),(827,576061200,5),(827,594201600,3),(827,607510800,5),(827,625651200,3),(827,638960400,5),(827,657100800,3),(827,671014800,5),(827,688550400,3),(827,702464400,5),(827,720000000,3),(827,733914000,5),(827,752054400,3),(827,765363600,5),(827,783504000,3),(827,796813200,5),(827,814953600,3),(827,828867600,5),(827,846403200,3),(827,860317200,5),(827,877852800,3),(827,891766800,5),(827,909302400,3),(827,923216400,5),(827,941356800,3),(827,954666000,5),(827,972806400,3),(827,986115600,5),(827,1004256000,3),(827,1018170000,5),(827,1035705600,3),(827,1049619600,5),(827,1067155200,3),(827,1081069200,5),(827,1099209600,3),(827,1112518800,5),(827,1130659200,3),(827,1143968400,5),(827,1162108800,3),(827,1173603600,5),(827,1194163200,3),(827,1205053200,5),(827,1225612800,3),(827,1236502800,5),(827,1257062400,3),(827,1268557200,5),(827,1289116800,3),(827,1300006800,5),(827,1320566400,3),(827,1331456400,5),(827,1352016000,3),(827,1362906000,5),(827,1383465600,3),(827,1394355600,5),(827,1414915200,3),(827,1425805200,5),(827,1446364800,3),(827,1457859600,5),(827,1478419200,3),(827,1489309200,5),(827,1509868800,3),(827,1520758800,5),(827,1541318400,3),(827,1552208400,5),(827,1572768000,3),(827,1583658000,5),(827,1604217600,3),(827,1615712400,5),(827,1636272000,3),(827,1647162000,5),(827,1667721600,3),(827,1678611600,5),(827,1699171200,3),(827,1710061200,5),(827,1730620800,3),(827,1741510800,5),(827,1762070400,3),(827,1772960400,5),(827,1793520000,3),(827,1805014800,5),(827,1825574400,3),(827,1836464400,5),(827,1857024000,3),(827,1867914000,5),(827,1888473600,3),(827,1899363600,5),(827,1919923200,3),(827,1930813200,5),(827,1951372800,3),(827,1962867600,5),(827,1983427200,3),(827,1994317200,5),(827,2014876800,3),(827,2025766800,5),(827,2046326400,3),(827,2057216400,5),(827,2077776000,3),(827,2088666000,5),(827,2109225600,3),(827,2120115600,5),(827,2140675200,3),(828,-2147483648,0),(828,-31536000,1),(828,1255802400,2),(828,1267714800,1),(828,1319738400,2),(828,1329843600,3),(828,1477065600,2),(828,1520701200,1),(828,2147483647,1),(829,-2147483648,0),(829,-409190400,1),(829,-163062000,0),(829,-28857600,1),(829,1255806000,2),(829,1268251200,3),(829,1319742000,2),(829,1329854400,3),(829,2147483647,3),(830,-2147483648,0),(830,-725846400,1),(830,-566992800,0),(830,-415497600,1),(830,2147483647,1),(831,-2147483648,1),(831,-1680508800,2),(831,-1665392400,1),(831,-1601719200,3),(831,-687052800,1),(831,-71136000,4),(831,-55411200,5),(831,-37267200,4),(831,-25776000,5),(831,-5817600,4),(831,5673600,5),(831,25632000,4),(831,37728000,5),(831,57686400,4),(831,67968000,5),(831,89136000,4),(831,100022400,5),(831,120585600,4),(831,131472000,5),(831,152035200,4),(831,162921600,5),(831,183484800,4),(831,194976000,5),(831,215539200,4),(831,226425600,5),(831,246988800,4),(831,257875200,5),(831,278438400,4),(831,289324800,5),(831,309888000,4),(831,320774400,5),(831,341337600,4),(831,352224000,5),(831,372787200,4),(831,386092800,5),(831,404841600,4),(831,417542400,5),(831,436291200,4),(831,447177600,5),(831,467740800,4),(831,478627200,5),(831,499190400,4),(831,510076800,5),(831,530035200,4),(831,542736000,5),(831,562089600,4),(831,574790400,5),(831,594144000,4),(831,606240000,5),(831,625593600,4),(831,637689600,5),(831,657043200,4),(831,670348800,5),(831,686678400,4),(831,701798400,5),(831,718128000,4),(831,733248000,5),(831,749577600,4),(831,764697600,5),(831,781027200,4),(831,796147200,5),(831,812476800,4),(831,828201600,5),(831,844531200,4),(831,859651200,5),(831,875980800,4),(831,891100800,5),(831,907430400,4),(831,922550400,5),(831,938880000,4),(831,954000000,5),(831,967305600,4),(831,985449600,5),(831,1002384000,4),(831,1017504000,5),(831,1033833600,4),(831,1048953600,5),(831,1065283200,4),(831,1080403200,5),(831,1096732800,4),(831,1111852800,5),(831,1128182400,4),(831,1143907200,5),(831,1159632000,4),(831,1174752000,5),(831,1191686400,4),(831,1207411200,5),(831,1223136000,4),(831,1238860800,5),(831,1254585600,4),(831,1270310400,6),(831,2147483647,6),(832,-2147483648,0),(832,-501206400,1),(832,1255809600,2),(832,2147483647,2),(833,-2147483648,2),(833,-1330335000,1),(833,-1320057000,2),(833,-1300699800,3),(833,-1287396000,2),(833,-1269250200,3),(833,-1255946400,2),(833,-1237800600,3),(833,-1224496800,2),(833,-1206351000,3),(833,-1192442400,2),(833,-1174901400,3),(833,-1160992800,2),(833,-1143451800,3),(833,-1125914400,2),(833,-1112607000,3),(833,-1094464800,2),(833,-1081157400,3),(833,-1063015200,2),(833,-1049707800,3),(833,-1031565600,2),(833,-1018258200,3),(833,-1000116000,2),(833,-986808600,3),(833,-968061600,2),(833,-955359000,3),(833,-936612000,2),(833,-923304600,3),(833,-757425600,6),(833,152632800,4),(833,162309600,5),(833,183477600,4),(833,194968800,5),(833,215532000,4),(833,226418400,5),(833,246981600,4),(833,257868000,5),(833,278431200,4),(833,289317600,5),(833,309880800,4),(833,320767200,5),(833,341330400,4),(833,352216800,5),(833,372780000,4),(833,384271200,5),(833,404834400,4),(833,415720800,5),(833,436284000,4),(833,447170400,5),(833,467733600,4),(833,478620000,5),(833,499183200,4),(833,510069600,5),(833,530632800,4),(833,541519200,5),(833,562082400,4),(833,573573600,5),(833,594136800,4),(833,605023200,5),(833,623772000,4),(833,637682400,5),(833,655221600,4),(833,669132000,5),(833,686671200,4),(833,700581600,5),(833,718120800,4),(833,732636000,5),(833,749570400,4),(833,764085600,5),(833,781020000,4),(833,795535200,5),(833,812469600,4),(833,826984800,5),(833,844524000,4),(833,858434400,5),(833,875973600,4),(833,889884000,5),(833,907423200,4),(833,921938400,5),(833,938872800,4),(833,953388000,5),(833,970322400,4),(833,984837600,5),(833,1002376800,4),(833,1016287200,5),(833,1033826400,4),(833,1047736800,5),(833,1065276000,4),(833,1079791200,5),(833,1096725600,4),(833,1111240800,5),(833,1128175200,4),(833,1142690400,5),(833,1159624800,4),(833,1174140000,5),(833,1191074400,4),(833,1207404000,5),(833,1222524000,4),(833,1238853600,5),(833,1253973600,4),(833,1270303200,5),(833,1285423200,4),(833,1301752800,5),(833,1316872800,4),(833,1333202400,5),(833,1348927200,4),(833,1365256800,5),(833,1380376800,4),(833,1396706400,5),(833,1411826400,4),(833,1428156000,5),(833,1443276000,4),(833,1459605600,5),(833,1474725600,4),(833,1491055200,5),(833,1506175200,4),(833,1522504800,5),(833,1538229600,4),(833,1554559200,5),(833,1569679200,4),(833,1586008800,5),(833,1601128800,4),(833,1617458400,5),(833,1632578400,4),(833,1648908000,5),(833,1664028000,4),(833,1680357600,5),(833,1695477600,4),(833,1712412000,5),(833,1727532000,4),(833,1743861600,5),(833,1758981600,4),(833,1775311200,5),(833,1790431200,4),(833,1806760800,5),(833,1821880800,4),(833,1838210400,5),(833,1853330400,4),(833,1869660000,5),(833,1885384800,4),(833,1901714400,5),(833,1916834400,4),(833,1933164000,5),(833,1948284000,4),(833,1964613600,5),(833,1979733600,4),(833,1996063200,5),(833,2011183200,4),(833,2027512800,5),(833,2042632800,4),(833,2058962400,5),(833,2074687200,4),(833,2091016800,5),(833,2106136800,4),(833,2122466400,5),(833,2137586400,4),(834,-2147483648,0),(834,-157766400,2),(834,-152658000,1),(834,-132955200,2),(834,-121122000,1),(834,-101419200,2),(834,-86821200,1),(834,-71092800,2),(834,-54766800,1),(834,-39038400,2),(834,-23317200,1),(834,-7588800,4),(834,128142000,3),(834,136605600,4),(834,389070000,1),(834,403070400,5),(834,416372400,6),(834,434520000,5),(834,447822000,6),(834,466574400,5),(834,479271600,6),(834,498024000,5),(834,510721200,6),(834,529473600,5),(834,545194800,6),(834,560923200,5),(834,574225200,6),(834,592372800,5),(834,605674800,6),(834,624427200,5),(834,637124400,6),(834,653457600,5),(834,668574000,6),(834,687326400,5),(834,700628400,6),(834,718776000,5),(834,732078000,6),(834,750225600,5),(834,763527600,6),(834,781675200,5),(834,794977200,6),(834,813729600,5),(834,826426800,6),(834,845179200,5),(834,859690800,6),(834,876628800,5),(834,889930800,6),(834,906868800,5),(834,923194800,6),(834,939528000,5),(834,952830000,6),(834,971582400,5),(834,984279600,6),(834,1003032000,5),(834,1015729200,6),(834,1034481600,5),(834,1047178800,6),(834,1065931200,5),(834,1079233200,6),(834,1097380800,5),(834,1110682800,6),(834,1128830400,5),(834,1142132400,6),(834,1160884800,5),(834,1173582000,6),(834,1192334400,5),(834,1206846000,6),(834,1223784000,5),(834,1237086000,6),(834,1255233600,5),(834,1270350000,6),(834,1286683200,5),(834,1304823600,6),(834,1313899200,5),(834,1335668400,6),(834,1346558400,5),(834,1367118000,6),(834,1378612800,5),(834,1398567600,6),(834,1410062400,5),(834,1463281200,6),(834,1471147200,5),(834,1480820400,4),(834,2147483647,4),(835,-2147483648,0),(835,218246400,1),(835,2147483647,1),(836,-2147483648,2),(836,-1330335000,1),(836,-1320057000,2),(836,-1300699800,3),(836,-1287396000,2),(836,-1269250200,3),(836,-1255946400,2),(836,-1237800600,3),(836,-1224496800,2),(836,-1206351000,3),(836,-1192442400,2),(836,-1174901400,3),(836,-1160992800,2),(836,-1143451800,3),(836,-1125914400,2),(836,-1112607000,3),(836,-1094464800,2),(836,-1081157400,3),(836,-1063015200,2),(836,-1049707800,3),(836,-1031565600,2),(836,-1018258200,3),(836,-1000116000,2),(836,-986808600,3),(836,-968061600,2),(836,-955359000,3),(836,-936612000,2),(836,-923304600,3),(836,-757425600,6),(836,152632800,4),(836,162309600,5),(836,183477600,4),(836,194968800,5),(836,215532000,4),(836,226418400,5),(836,246981600,4),(836,257868000,5),(836,278431200,4),(836,289317600,5),(836,309880800,4),(836,320767200,5),(836,341330400,4),(836,352216800,5),(836,372780000,4),(836,384271200,5),(836,404834400,4),(836,415720800,5),(836,436284000,4),(836,447170400,5),(836,467733600,4),(836,478620000,5),(836,499183200,4),(836,510069600,5),(836,530632800,4),(836,541519200,5),(836,562082400,4),(836,573573600,5),(836,594136800,4),(836,605023200,5),(836,623772000,4),(836,637682400,5),(836,655221600,4),(836,669132000,5),(836,686671200,4),(836,700581600,5),(836,718120800,4),(836,732636000,5),(836,749570400,4),(836,764085600,5),(836,781020000,4),(836,795535200,5),(836,812469600,4),(836,826984800,5),(836,844524000,4),(836,858434400,5),(836,875973600,4),(836,889884000,5),(836,907423200,4),(836,921938400,5),(836,938872800,4),(836,953388000,5),(836,970322400,4),(836,984837600,5),(836,1002376800,4),(836,1016287200,5),(836,1033826400,4),(836,1047736800,5),(836,1065276000,4),(836,1079791200,5),(836,1096725600,4),(836,1111240800,5),(836,1128175200,4),(836,1142690400,5),(836,1159624800,4),(836,1174140000,5),(836,1191074400,4),(836,1207404000,5),(836,1222524000,4),(836,1238853600,5),(836,1253973600,4),(836,1270303200,5),(836,1285423200,4),(836,1301752800,5),(836,1316872800,4),(836,1333202400,5),(836,1348927200,4),(836,1365256800,5),(836,1380376800,4),(836,1396706400,5),(836,1411826400,4),(836,1428156000,5),(836,1443276000,4),(836,1459605600,5),(836,1474725600,4),(836,1491055200,5),(836,1506175200,4),(836,1522504800,5),(836,1538229600,4),(836,1554559200,5),(836,1569679200,4),(836,1586008800,5),(836,1601128800,4),(836,1617458400,5),(836,1632578400,4),(836,1648908000,5),(836,1664028000,4),(836,1680357600,5),(836,1695477600,4),(836,1712412000,5),(836,1727532000,4),(836,1743861600,5),(836,1758981600,4),(836,1775311200,5),(836,1790431200,4),(836,1806760800,5),(836,1821880800,4),(836,1838210400,5),(836,1853330400,4),(836,1869660000,5),(836,1885384800,4),(836,1901714400,5),(836,1916834400,4),(836,1933164000,5),(836,1948284000,4),(836,1964613600,5),(836,1979733600,4),(836,1996063200,5),(836,2011183200,4),(836,2027512800,5),(836,2042632800,4),(836,2058962400,5),(836,2074687200,4),(836,2091016800,5),(836,2106136800,4),(836,2122466400,5),(836,2137586400,4),(837,-2147483648,0),(837,-407808000,1),(837,2147483647,1),(838,-2147483648,0),(838,1108166400,3),(838,1111885200,1),(838,1130634000,2),(838,1143334800,1),(838,1162083600,2),(838,1174784400,1),(838,1193533200,2),(838,1206838800,1),(838,1224982800,2),(838,1238288400,1),(838,1256432400,2),(838,1269738000,1),(838,1288486800,2),(838,1301187600,1),(838,1319936400,2),(838,1332637200,1),(838,1351386000,2),(838,1364691600,1),(838,1382835600,2),(838,1396141200,1),(838,1414285200,2),(838,1427590800,1),(838,1445734800,2),(838,1459040400,1),(838,1477789200,2),(838,1490490000,1),(838,1509238800,2),(838,1521939600,1),(838,1540688400,2),(838,1553994000,1),(838,1572138000,2),(838,1585443600,1),(838,1603587600,2),(838,1616893200,1),(838,1635642000,2),(838,1648342800,1),(838,1667091600,2),(838,1679792400,1),(838,1698541200,2),(838,1711846800,1),(838,1729990800,2),(838,1743296400,1),(838,1761440400,2),(838,1774746000,1),(838,1792890000,2),(838,1806195600,1),(838,1824944400,2),(838,1837645200,1),(838,1856394000,2),(838,1869094800,1),(838,1887843600,2),(838,1901149200,1),(838,1919293200,2),(838,1932598800,1),(838,1950742800,2),(838,1964048400,1),(838,1982797200,2),(838,1995498000,1),(838,2014246800,2),(838,2026947600,1),(838,2045696400,2),(838,2058397200,1),(838,2077146000,2),(838,2090451600,1),(838,2108595600,2),(838,2121901200,1),(838,2140045200,2),(838,2147483647,2),(839,-2147483648,0),(839,-380073600,1),(839,2147483647,1),(840,-2147483648,2),(840,-1691884800,1),(840,-1680573600,2),(840,-927511200,1),(840,-857257200,3),(840,-844556400,4),(840,-828226800,3),(840,-812502000,4),(840,-796777200,3),(840,-781052400,4),(840,-765327600,3),(840,-340844400,4),(840,-324514800,3),(840,-308790000,4),(840,-293065200,3),(840,-277340400,4),(840,-261615600,3),(840,-245890800,4),(840,-230166000,3),(840,-214441200,4),(840,-198716400,3),(840,-182991600,4),(840,-166662000,3),(840,-147913200,4),(840,-135212400,3),(840,315529200,2),(840,323830800,5),(840,338950800,6),(840,354675600,5),(840,370400400,6),(840,386125200,5),(840,401850000,6),(840,417574800,5),(840,433299600,6),(840,449024400,5),(840,465354000,6),(840,481078800,5),(840,496803600,6),(840,512528400,5),(840,528253200,6),(840,543978000,5),(840,559702800,6),(840,575427600,5),(840,591152400,6),(840,606877200,5),(840,622602000,6),(840,638326800,5),(840,654656400,6),(840,670381200,5),(840,686106000,6),(840,701830800,5),(840,717555600,6),(840,733280400,5),(840,749005200,6),(840,764730000,5),(840,780454800,6),(840,796179600,5),(840,811904400,6),(840,828234000,5),(840,846378000,6),(840,859683600,5),(840,877827600,6),(840,891133200,5),(840,909277200,6),(840,922582800,5),(840,941331600,6),(840,954032400,5),(840,972781200,6),(840,985482000,5),(840,1004230800,6),(840,1017536400,5),(840,1035680400,6),(840,1048986000,5),(840,1067130000,6),(840,1080435600,5),(840,1099184400,6),(840,1111885200,5),(840,1130634000,6),(840,1143334800,5),(840,1162083600,6),(840,1174784400,5),(840,1193533200,6),(840,1206838800,5),(840,1224982800,6),(840,1238288400,5),(840,1256432400,6),(840,1269738000,5),(840,1288486800,6),(840,1301187600,5),(840,1319936400,6),(840,1332637200,5),(840,1351386000,6),(840,1364691600,5),(840,1382835600,6),(840,1396141200,5),(840,1414285200,6),(840,1427590800,5),(840,1445734800,6),(840,1459040400,5),(840,1477789200,6),(840,1490490000,5),(840,1509238800,6),(840,1521939600,5),(840,1540688400,6),(840,1553994000,5),(840,1572138000,6),(840,1585443600,5),(840,1603587600,6),(840,1616893200,5),(840,1635642000,6),(840,1648342800,5),(840,1667091600,6),(840,1679792400,5),(840,1698541200,6),(840,1711846800,5),(840,1729990800,6),(840,1743296400,5),(840,1761440400,6),(840,1774746000,5),(840,1792890000,6),(840,1806195600,5),(840,1824944400,6),(840,1837645200,5),(840,1856394000,6),(840,1869094800,5),(840,1887843600,6),(840,1901149200,5),(840,1919293200,6),(840,1932598800,5),(840,1950742800,6),(840,1964048400,5),(840,1982797200,6),(840,1995498000,5),(840,2014246800,6),(840,2026947600,5),(840,2045696400,6),(840,2058397200,5),(840,2077146000,6),(840,2090451600,5),(840,2108595600,6),(840,2121901200,5),(840,2140045200,6),(841,-2147483648,0),(841,-719636812,1),(841,2147483647,1),(842,-2147483648,0),(842,-1441170468,1),(842,-1247547600,3),(842,354909600,2),(842,370717200,3),(842,386445600,2),(842,402253200,3),(842,417981600,2),(842,433789200,3),(842,449604000,2),(842,465336000,4),(842,481060800,5),(842,496785600,4),(842,512510400,5),(842,528235200,4),(842,543960000,5),(842,559684800,4),(842,575409600,5),(842,591134400,4),(842,606859200,5),(842,622584000,4),(842,638308800,5),(842,654638400,4),(842,670363200,6),(842,686091600,7),(842,695768400,4),(842,701812800,5),(842,717537600,4),(842,733262400,5),(842,748987200,4),(842,764712000,5),(842,780436800,4),(842,796161600,5),(842,811886400,4),(842,828216000,5),(842,846360000,4),(842,859665600,5),(842,877809600,4),(842,891115200,5),(842,909259200,4),(842,922564800,5),(842,941313600,4),(842,954014400,5),(842,972763200,4),(842,985464000,5),(842,1004212800,4),(842,1017518400,5),(842,1035662400,4),(842,1048968000,5),(842,1067112000,4),(842,1080417600,5),(842,1099166400,4),(842,2147483647,4),(843,-2147483648,0),(843,-1230776624,2),(843,108165600,1),(843,118270800,2),(843,136591200,1),(843,149806800,2),(843,168127200,1),(843,181342800,2),(843,199749600,1),(843,215643600,2),(843,231285600,1),(843,244501200,2),(843,262735200,1),(843,275950800,2),(843,481154400,1),(843,496962000,2),(843,512949600,1),(843,528670800,2),(843,544399200,1),(843,560120400,2),(843,575848800,1),(843,592174800,2),(843,610581600,1),(843,623624400,2),(843,641167200,1),(843,655074000,2),(843,671839200,1),(843,685918800,2),(843,702856800,1),(843,717973200,2),(843,733701600,1),(843,749422800,2),(843,765151200,1),(843,779662800,2),(843,797205600,1),(843,811116000,3),(843,828655200,1),(843,843170400,3),(843,860104800,1),(843,874620000,3),(843,891554400,1),(843,906069600,3),(843,930780000,4),(843,938124000,3),(843,954367200,4),(843,970178400,3),(843,985816800,4),(843,1001628000,3),(843,1017352800,1),(843,1033077600,3),(843,1048802400,1),(843,1066946400,3),(843,1080252000,1),(843,1097791200,3),(843,1112306400,1),(843,1128031200,3),(843,1143756000,1),(843,1161900000,3),(843,1175205600,1),(843,1193349600,3),(843,1206655200,1),(843,1225404000,3),(843,1238104800,1),(843,1256853600,3),(843,1269554400,1),(843,1288303200,3),(843,1301608800,1),(843,1319752800,3),(843,1333058400,1),(843,1387486800,2),(843,1395957600,1),(843,1414706400,3),(843,1427407200,1),(843,1446156000,3),(843,1459461600,1),(843,1477605600,3),(843,1490911200,1),(843,1509055200,3),(843,1522360800,1),(843,1540504800,3),(843,1553810400,1),(843,1571954400,3),(843,1585260000,1),(843,1604008800,3),(843,1616709600,1),(843,1635458400,3),(843,1648764000,1),(843,1666908000,3),(843,1680213600,1),(843,1698357600,3),(843,1711663200,1),(843,1729807200,3),(843,1743112800,1),(843,1761861600,3),(843,1774562400,1),(843,1793311200,3),(843,1806012000,1),(843,1824760800,3),(843,1838066400,1),(843,1856210400,3),(843,1869516000,1),(843,1887660000,3),(843,1900965600,1),(843,1919109600,3),(843,1932415200,1),(843,1951164000,3),(843,1963864800,1),(843,1982613600,3),(843,1995919200,1),(843,2014063200,3),(843,2027368800,1),(843,2045512800,3),(843,2058818400,1),(843,2076962400,3),(843,2090268000,1),(843,2109016800,3),(843,2121717600,1),(843,2140466400,3),(844,-2147483648,0),(844,-1441194596,1),(844,-1247572800,3),(844,354884400,2),(844,370692000,3),(844,386420400,4),(844,402231600,1),(844,417960000,4),(844,433767600,1),(844,449582400,4),(844,465314400,5),(844,481039200,6),(844,496764000,5),(844,512488800,6),(844,528213600,5),(844,543938400,6),(844,559663200,5),(844,575388000,6),(844,591112800,5),(844,606837600,6),(844,622562400,5),(844,638287200,6),(844,654616800,5),(844,670341600,7),(844,686070000,8),(844,695746800,5),(844,701791200,6),(844,717516000,5),(844,733240800,6),(844,748965600,5),(844,764690400,6),(844,780415200,5),(844,796140000,6),(844,811864800,5),(844,828194400,6),(844,846338400,5),(844,859644000,6),(844,877788000,5),(844,891093600,6),(844,909237600,5),(844,922543200,6),(844,941292000,5),(844,953992800,6),(844,972741600,5),(844,985442400,6),(844,1004191200,5),(844,1017496800,6),(844,1035640800,5),(844,1048946400,6),(844,1067090400,5),(844,1080396000,6),(844,1099144800,5),(844,1111845600,6),(844,1130594400,5),(844,1143295200,6),(844,1162044000,5),(844,1174744800,6),(844,1193493600,5),(844,1206799200,6),(844,1224943200,5),(844,1238248800,6),(844,1256392800,5),(844,1269698400,7),(844,1288450800,8),(844,1301151600,5),(844,2147483647,5),(845,-2147483648,0),(845,-1441164064,1),(845,-1247544000,2),(845,370724400,3),(845,386445600,4),(845,402256800,2),(845,417985200,4),(845,433792800,2),(845,449607600,4),(845,465339600,5),(845,481064400,6),(845,496789200,5),(845,512514000,6),(845,528238800,5),(845,543963600,6),(845,559688400,5),(845,575413200,6),(845,591138000,5),(845,606862800,6),(845,622587600,5),(845,638312400,6),(845,654642000,5),(845,670366800,7),(845,686095200,8),(845,695772000,5),(845,701816400,6),(845,717541200,5),(845,733266000,6),(845,748990800,5),(845,764715600,6),(845,780440400,8),(845,796168800,7),(845,811893600,8),(845,828223200,7),(845,846367200,8),(845,859672800,7),(845,877816800,8),(845,891122400,7),(845,909266400,8),(845,922572000,7),(845,941320800,8),(845,954021600,7),(845,972770400,8),(845,985471200,7),(845,1004220000,8),(845,1017525600,7),(845,1035669600,8),(845,1048975200,7),(845,1067119200,8),(845,1080424800,7),(845,1099173600,5),(845,2147483647,5),(846,-2147483648,0),(846,-1441165720,1),(846,-1247544000,2),(846,354913200,3),(846,370720800,4),(846,386445600,3),(846,402256800,2),(846,417985200,3),(846,433792800,2),(846,449607600,3),(846,465339600,5),(846,481064400,6),(846,496789200,5),(846,512514000,6),(846,528238800,5),(846,543963600,6),(846,559688400,5),(846,575413200,6),(846,591138000,5),(846,606862800,6),(846,622587600,5),(846,638312400,6),(846,654642000,5),(846,670366800,7),(846,686095200,8),(846,695772000,5),(846,701816400,6),(846,717541200,5),(846,733266000,6),(846,748990800,5),(846,764715600,6),(846,780440400,5),(846,796165200,6),(846,811890000,5),(846,828219600,6),(846,846363600,5),(846,859669200,6),(846,877813200,5),(846,891118800,6),(846,909262800,5),(846,922568400,6),(846,941317200,5),(846,954018000,6),(846,972766800,5),(846,985467600,6),(846,1004216400,5),(846,1017522000,6),(846,1035666000,5),(846,1048971600,6),(846,1067115600,5),(846,1080421200,6),(846,1099170000,5),(846,2147483647,5),(847,-2147483648,0),(847,-1441166012,1),(847,-1247544000,3),(847,354913200,2),(847,370720800,3),(847,386449200,2),(847,402256800,3),(847,417985200,2),(847,433792800,3),(847,449607600,2),(847,465339600,4),(847,481064400,5),(847,496789200,4),(847,512514000,5),(847,528238800,4),(847,543963600,5),(847,559688400,4),(847,575413200,5),(847,591138000,4),(847,606862800,5),(847,622587600,4),(847,638312400,5),(847,654642000,4),(847,670366800,6),(847,686095200,7),(847,695772000,3),(847,2147483647,3),(848,-2147483648,0),(848,-1441166012,1),(848,-1247544000,3),(848,354913200,2),(848,370720800,3),(848,386449200,2),(848,402256800,3),(848,417985200,2),(848,433792800,3),(848,449607600,2),(848,465339600,4),(848,481064400,5),(848,496789200,4),(848,512514000,5),(848,528238800,4),(848,543963600,5),(848,559688400,4),(848,575413200,5),(848,591138000,4),(848,606862800,5),(848,622587600,4),(848,638312400,5),(848,654642000,4),(848,670366800,6),(848,686095200,7),(848,695772000,3),(848,2147483647,3),(849,-2147483648,0),(849,-1441164464,1),(849,-1247540400,2),(849,370724400,3),(849,386445600,4),(849,402256800,2),(849,417985200,4),(849,433792800,2),(849,449607600,4),(849,465339600,5),(849,481064400,6),(849,496789200,5),(849,512514000,6),(849,528238800,5),(849,543963600,6),(849,559688400,5),(849,575413200,6),(849,591138000,5),(849,606862800,6),(849,622587600,5),(849,638312400,6),(849,654642000,5),(849,670366800,7),(849,686095200,8),(849,695772000,5),(849,701816400,6),(849,717541200,5),(849,733266000,6),(849,748990800,5),(849,764715600,6),(849,780440400,5),(849,796165200,6),(849,811890000,5),(849,828219600,6),(849,846363600,5),(849,859669200,6),(849,877813200,5),(849,891118800,6),(849,909262800,5),(849,922568400,7),(849,941320800,8),(849,954021600,7),(849,972770400,8),(849,985471200,7),(849,1004220000,8),(849,1017525600,7),(849,1035669600,8),(849,1048975200,7),(849,1067119200,8),(849,1080424800,7),(849,1099173600,5),(849,2147483647,5),(850,-2147483648,1),(850,-1641005856,2),(850,389048400,3),(850,402264000,2),(850,417906000,3),(850,433800000,2),(850,449614800,3),(850,465422400,2),(850,481150800,3),(850,496792800,4),(850,512517600,5),(850,528242400,4),(850,543967200,5),(850,559692000,4),(850,575416800,5),(850,591141600,4),(850,606866400,5),(850,622591200,4),(850,638316000,5),(850,654645600,4),(850,670464000,5),(850,686275200,4),(850,702086400,5),(850,717897600,4),(850,733622400,5),(850,749433600,4),(850,765158400,5),(850,780969600,4),(850,796694400,5),(850,812505600,4),(850,828316800,5),(850,844128000,4),(850,859852800,5),(850,875664000,4),(850,891388800,5),(850,907200000,4),(850,922924800,5),(850,938736000,4),(850,954547200,5),(850,970358400,4),(850,986083200,5),(850,1001894400,4),(850,1017619200,5),(850,1033430400,4),(850,1049155200,5),(850,1064966400,4),(850,1080777600,5),(850,1096588800,4),(850,1112313600,5),(850,1128124800,4),(850,1143849600,5),(850,1159660800,4),(850,1175385600,5),(850,1191196800,4),(850,2147483647,4),(851,-2147483648,0),(851,-1577935568,1),(851,76190400,2),(851,2147483647,2),(852,-2147483648,0),(852,-1441163964,1),(852,-405140400,3),(852,354916800,2),(852,370724400,3),(852,386452800,2),(852,402260400,3),(852,417988800,2),(852,433796400,3),(852,449611200,2),(852,465343200,4),(852,481068000,5),(852,496792800,4),(852,512517600,5),(852,528242400,4),(852,543967200,5),(852,559692000,4),(852,575416800,5),(852,591141600,4),(852,606866400,5),(852,622591200,4),(852,638316000,5),(852,654645600,4),(852,670370400,6),(852,686098800,7),(852,701823600,6),(852,717548400,4),(852,820440000,3),(852,828234000,8),(852,846378000,9),(852,852062400,3),(852,859680000,2),(852,877824000,3),(852,891129600,2),(852,909273600,3),(852,922579200,2),(852,941328000,3),(852,954028800,2),(852,972777600,3),(852,985478400,2),(852,1004227200,3),(852,1017532800,2),(852,1035676800,3),(852,1048982400,2),(852,1067126400,3),(852,1080432000,2),(852,1099180800,3),(852,1111881600,2),(852,1130630400,3),(852,1143331200,2),(852,1162080000,3),(852,1174780800,2),(852,1193529600,3),(852,1206835200,2),(852,1224979200,3),(852,1238284800,2),(852,1256428800,3),(852,1269734400,2),(852,1288483200,3),(852,1301184000,2),(852,1319932800,3),(852,1332633600,2),(852,1351382400,3),(852,1364688000,2),(852,1382832000,3),(852,1396137600,2),(852,1414281600,3),(852,1427587200,2),(852,1445731200,3),(852,2147483647,3),(853,-2147483648,1),(853,-1570084924,2),(853,2147483647,2),(854,-2147483648,0),(854,-1579844100,1),(854,-1247551200,3),(854,354906000,2),(854,370713600,3),(854,386442000,2),(854,402249600,3),(854,417978000,2),(854,433785600,3),(854,449600400,2),(854,465332400,4),(854,481057200,5),(854,496782000,4),(854,512506800,5),(854,528231600,4),(854,543956400,5),(854,559681200,4),(854,575406000,5),(854,591130800,4),(854,606855600,5),(854,622580400,4),(854,638305200,5),(854,654634800,4),(854,670359600,6),(854,686088000,7),(854,695764800,4),(854,701809200,5),(854,717534000,4),(854,733258800,5),(854,748983600,4),(854,764708400,5),(854,780433200,4),(854,796158000,5),(854,801590400,8),(854,811886400,7),(854,828216000,6),(854,846360000,7),(854,859665600,6),(854,877809600,7),(854,891115200,6),(854,909259200,7),(854,922564800,6),(854,941313600,7),(854,954014400,6),(854,972763200,7),(854,985464000,6),(854,1004212800,7),(854,1017518400,6),(854,1035662400,7),(854,1048968000,6),(854,1067112000,7),(854,1080417600,6),(854,1099166400,7),(854,1111867200,6),(854,1130616000,7),(854,1143316800,6),(854,1162065600,7),(854,1174766400,6),(854,1193515200,7),(854,1206820800,6),(854,1224964800,7),(854,1238270400,6),(854,1256414400,7),(854,1269720000,6),(854,1288468800,7),(854,1301169600,4),(854,1414263600,7),(854,1459022400,4),(854,2147483647,4),(855,-2147483648,2),(855,-1570413600,1),(855,-1552186800,2),(855,-1538359200,1),(855,-1522551600,2),(855,-1507514400,1),(855,-1490583600,2),(855,-1473645600,1),(855,-1460948400,2),(855,-399866400,1),(855,-386650800,2),(855,-368330400,1),(855,-355114800,2),(855,-336794400,1),(855,-323578800,2),(855,-305172000,1),(855,-291956400,2),(855,-273636000,1),(855,-260420400,2),(855,78012000,1),(855,86734800,2),(855,105055200,1),(855,118270800,2),(855,136591200,1),(855,149806800,2),(855,168127200,1),(855,181342800,2),(855,199749600,1),(855,212965200,2),(855,231285600,1),(855,244501200,2),(855,262735200,1),(855,275950800,2),(855,452210400,1),(855,466722000,2),(855,483746400,1),(855,498258000,2),(855,515282400,1),(855,529794000,2),(855,546818400,1),(855,561330000,2),(855,581119200,1),(855,592952400,2),(855,610754400,1),(855,624488400,2),(855,641512800,1),(855,656024400,2),(855,673048800,1),(855,687560400,2),(855,704671200,1),(855,718146000,2),(855,733269600,1),(855,748990800,2),(855,764719200,1),(855,780440400,2),(855,796168800,1),(855,811890000,2),(855,828223200,1),(855,843944400,2),(855,859672800,1),(855,875394000,2),(855,891122400,1),(855,906843600,2),(855,922572000,1),(855,941317200,2),(855,954021600,1),(855,972766800,2),(855,985471200,1),(855,1004216400,2),(855,1017525600,1),(855,1035666000,2),(855,1048975200,1),(855,1067115600,2),(855,1080424800,1),(855,1099170000,2),(855,1111874400,1),(855,1130619600,2),(855,1143324000,1),(855,1162069200,2),(855,1174773600,1),(855,1193518800,2),(855,1206828000,1),(855,1224968400,2),(855,1238277600,1),(855,1256418000,2),(855,1269727200,1),(855,1288472400,2),(855,1301176800,1),(855,1319922000,2),(855,1332626400,1),(855,1351371600,2),(855,1364680800,1),(855,1382821200,2),(855,1396130400,1),(855,1414270800,2),(855,1427580000,1),(855,1445720400,2),(855,1459029600,1),(855,1477774800,2),(855,1490479200,1),(855,1509224400,2),(855,1521928800,1),(855,1540674000,2),(855,1553983200,1),(855,1572123600,2),(855,1585432800,1),(855,1603573200,2),(855,1616882400,1),(855,1635627600,2),(855,1648332000,1),(855,1667077200,2),(855,1679781600,1),(855,1698526800,2),(855,1711836000,1),(855,1729976400,2),(855,1743285600,1),(855,1761426000,2),(855,1774735200,1),(855,1792875600,2),(855,1806184800,1),(855,1824930000,2),(855,1837634400,1),(855,1856379600,2),(855,1869084000,1),(855,1887829200,2),(855,1901138400,1),(855,1919278800,2),(855,1932588000,1),(855,1950728400,2),(855,1964037600,1),(855,1982782800,2),(855,1995487200,1),(855,2014232400,2),(855,2026936800,1),(855,2045682000,2),(855,2058386400,1),(855,2077131600,2),(855,2090440800,1),(855,2108581200,2),(855,2121890400,1),(855,2140030800,2),(856,-2147483648,0),(856,-1441169904,1),(856,-1247547600,3),(856,354909600,2),(856,370717200,3),(856,386445600,2),(856,402253200,3),(856,417981600,2),(856,433789200,3),(856,449604000,2),(856,465336000,4),(856,481060800,5),(856,496785600,4),(856,512510400,5),(856,528235200,4),(856,543960000,5),(856,559684800,4),(856,575409600,5),(856,591134400,4),(856,606859200,5),(856,622584000,4),(856,638308800,5),(856,654638400,4),(856,670363200,6),(856,683582400,1),(856,703018800,6),(856,717530400,1),(856,734468400,6),(856,748980000,1),(856,765918000,6),(856,780429600,1),(856,797367600,6),(856,811879200,1),(856,828817200,6),(856,843933600,1),(856,859671000,8),(856,877811400,1),(856,891120600,8),(856,909261000,1),(856,922570200,8),(856,941315400,1),(856,954019800,8),(856,972765000,1),(856,985469400,8),(856,1004214600,1),(856,1017523800,8),(856,1035664200,1),(856,1048973400,8),(856,1067113800,1),(856,1080423000,8),(856,1099168200,1),(856,1111872600,8),(856,1123783200,3),(856,2147483647,3),(857,-2147483648,0),(857,-1383464380,1),(857,-1167636600,2),(857,2147483647,2),(858,-2147483648,1),(858,-2019705670,2),(858,-891581400,3),(858,-872058600,2),(858,-862637400,3),(858,-764145000,2),(859,-2147483648,0),(859,-1579419232,1),(859,-1247558400,3),(859,354898800,2),(859,370706400,3),(859,386434800,2),(859,402242400,3),(859,417970800,2),(859,433778400,3),(859,449593200,2),(859,465325200,4),(859,481050000,5),(859,496774800,4),(859,512499600,5),(859,528224400,4),(859,543949200,5),(859,559674000,4),(859,575398800,5),(859,591123600,4),(859,606848400,5),(859,622573200,4),(859,638298000,5),(859,654627600,4),(859,670352400,6),(859,686080800,7),(859,695757600,4),(859,701802000,5),(859,717526800,4),(859,733251600,5),(859,748976400,4),(859,764701200,5),(859,780426000,4),(859,796150800,5),(859,811875600,4),(859,828205200,5),(859,846349200,4),(859,859654800,5),(859,877798800,4),(859,891104400,5),(859,909248400,4),(859,922554000,5),(859,941302800,4),(859,954003600,5),(859,972752400,4),(859,985453200,5),(859,1004202000,4),(859,1017507600,5),(859,1035651600,4),(859,1048957200,5),(859,1067101200,4),(859,1080406800,5),(859,1099155600,4),(859,1111856400,5),(859,1130605200,4),(859,1143306000,5),(859,1162054800,4),(859,1174755600,5),(859,1193504400,4),(859,1206810000,5),(859,1224954000,4),(859,1238259600,5),(859,1256403600,4),(859,1269709200,5),(859,1288458000,4),(859,1301158800,8),(859,1414252800,7),(859,1459015200,3),(859,2147483647,3),(860,-2147483648,0),(860,-2032933080,1),(860,252435600,2),(860,417974400,4),(860,433778400,3),(860,449593200,4),(860,465314400,3),(860,481042800,4),(860,496764000,3),(860,512492400,4),(860,528213600,3),(860,543942000,4),(860,559663200,3),(860,575391600,4),(860,591112800,3),(860,606841200,4),(860,622562400,3),(860,638290800,4),(860,654616800,3),(860,670345200,4),(860,686066400,3),(860,701794800,4),(860,717516000,3),(860,733244400,4),(860,748965600,3),(860,764694000,4),(860,780415200,3),(860,796143600,4),(860,811864800,3),(860,828198000,4),(860,843919200,3),(860,859647600,4),(860,875368800,3),(860,891097200,4),(860,906818400,3),(860,988390800,4),(860,1001692800,3),(860,1017421200,4),(860,1033142400,3),(860,1048870800,4),(860,1064592000,3),(860,1080320400,4),(860,1096041600,3),(860,1111770000,4),(860,1127491200,3),(860,1143219600,4),(860,1159545600,3),(860,1206889200,2),(860,1427479200,5),(860,1443193200,2),(860,1458928800,5),(860,1474642800,2),(860,2147483647,2),(861,-2147483648,2),(861,-933667200,1),(861,-922093200,2),(861,-908870400,1),(861,-888829200,2),(861,-881049600,1),(861,-767869200,2),(861,-745833600,1),(861,-733827600,2),(861,-716889600,1),(861,-699613200,2),(861,-683884800,1),(861,-670669200,2),(861,-652348800,1),(861,-650019600,2),(861,515527200,1),(861,527014800,2),(861,545162400,1),(861,558464400,2),(861,577216800,1),(861,589914000,2),(861,608666400,1),(861,621968400,2),(861,640116000,1),(861,653418000,2),(861,671565600,1),(861,684867600,2),(862,-2147483648,2),(862,-933667200,1),(862,-922093200,2),(862,-908870400,1),(862,-888829200,2),(862,-881049600,1),(862,-767869200,2),(862,-745833600,1),(862,-733827600,2),(862,-716889600,1),(862,-699613200,2),(862,-683884800,1),(862,-670669200,2),(862,-652348800,1),(862,-650019600,2),(862,515527200,1),(862,527014800,2),(862,545162400,1),(862,558464400,2),(862,577216800,1),(862,589914000,2),(862,608666400,1),(862,621968400,2),(862,640116000,1),(862,653418000,2),(862,671565600,1),(862,684867600,2),(863,-2147483648,1),(863,-2019705572,2),(863,-883287000,3),(863,-862639200,4),(863,-764051400,2),(863,832962600,5),(863,846266400,6),(863,1145039400,2),(863,2147483647,2),(864,-2147483648,1),(864,-891582800,2),(864,-872058600,3),(864,-862637400,2),(864,-576138600,4),(864,1245430800,5),(864,1262278800,4),(864,2147483647,4),(865,-2147483648,0),(865,-1577931912,2),(865,-1568592000,1),(865,-1554080400,2),(865,-1537142400,1),(865,-1522630800,2),(865,-1505692800,1),(865,-1491181200,2),(865,-1474243200,1),(865,-1459126800,2),(865,-242265600,1),(865,-228877200,2),(865,-210556800,1),(865,-197427600,2),(865,-178934400,1),(865,-165718800,2),(865,-147398400,1),(865,-134269200,2),(865,-116467200,1),(865,-102646800,2),(865,-84326400,1),(865,-71110800,2),(865,-52704000,1),(865,-39488400,2),(865,-21168000,1),(865,-7952400,2),(865,10368000,1),(865,23583600,2),(865,41904000,1),(865,55119600,2),(865,73526400,1),(865,86742000,2),(865,105062400,1),(865,118278000,2),(865,136598400,1),(865,149814000,2),(865,168134400,1),(865,181350000,2),(865,199756800,1),(865,212972400,2),(865,231292800,1),(865,241916400,2),(865,262828800,1),(865,273452400,2),(865,418694400,1),(865,433810800,2),(865,450316800,1),(865,465433200,2),(865,508896000,1),(865,529196400,2),(865,541555200,1),(865,562633200,2),(865,574387200,1),(865,594255600,2),(865,607305600,1),(865,623199600,2),(865,638928000,1),(865,654649200,2),(865,670456800,1),(865,686264400,2),(865,702684000,1),(865,717886800,2),(865,733096800,1),(865,748904400,2),(865,765151200,1),(865,780958800,2),(865,796687200,1),(865,812494800,2),(865,828309600,1),(865,844117200,2),(865,859759200,1),(865,875653200,2),(865,891208800,1),(865,907189200,2),(865,922917600,1),(865,938725200,2),(865,954540000,1),(865,970347600,2),(865,986076000,1),(865,1001883600,2),(865,1017612000,1),(865,1033419600,2),(865,1049148000,1),(865,1064955600,2),(865,1080770400,1),(865,1096578000,2),(865,1112306400,1),(865,1128114000,2),(865,1143842400,1),(865,1158872400,2),(865,1175205600,1),(865,1193950800,2),(865,1207260000,1),(865,1225486800,2),(865,1238104800,1),(865,1256850000,2),(865,1270159200,1),(865,1288299600,2),(865,1301608800,1),(865,1319749200,2),(865,1333058400,1),(865,1351198800,2),(865,1364508000,1),(865,1382648400,2),(865,1395957600,1),(865,1414702800,2),(865,1427407200,1),(865,1446152400,2),(865,1458856800,1),(865,1477602000,2),(865,1490911200,1),(865,1509051600,2),(865,1522360800,1),(865,1540501200,2),(865,1553810400,1),(865,1571950800,2),(865,1585260000,1),(865,1604005200,2),(865,1616709600,1),(865,1635454800,2),(865,1648159200,1),(865,1666904400,2),(865,1680213600,1),(865,1698354000,2),(865,1711663200,1),(865,1729803600,2),(865,1743112800,1),(865,1761858000,2),(865,1774562400,1),(865,1793307600,2),(865,1806012000,1),(865,1824757200,2),(865,1838066400,1),(865,1856206800,2),(865,1869516000,1),(865,1887656400,2),(865,1900965600,1),(865,1919106000,2),(865,1932415200,1),(865,1951160400,2),(865,1963864800,1),(865,1982610000,2),(865,1995314400,1),(865,2014059600,2),(865,2027368800,1),(865,2045509200,2),(865,2058818400,1),(865,2076958800,2),(865,2090268000,1),(865,2109013200,2),(865,2121717600,1),(865,2140462800,2),(866,-2147483648,1),(866,-891582800,2),(866,-872058600,3),(866,-862637400,2),(866,-576138600,4),(866,1245430800,5),(866,1262278800,4),(866,2147483647,4),(867,-2147483648,0),(867,-1830414140,1),(867,-879152400,2),(867,199897200,1),(867,969120000,2),(867,2147483647,2),(868,-2147483648,0),(868,-1577936472,1),(868,2147483647,1),(869,-2147483648,0),(869,-1441168512,1),(869,-1247547600,3),(869,354909600,2),(869,370717200,3),(869,386445600,2),(869,402253200,3),(869,417981600,2),(869,433789200,3),(869,449604000,2),(869,465336000,4),(869,481060800,5),(869,496785600,4),(869,512510400,5),(869,528235200,4),(869,543960000,5),(869,559684800,4),(869,575409600,5),(869,591134400,4),(869,606859200,5),(869,622584000,4),(869,638308800,5),(869,654638400,4),(869,670363200,6),(869,684363600,7),(869,2147483647,7),(870,-2147483648,0),(870,-1518920148,2),(870,166572000,1),(870,182293200,2),(870,200959200,1),(870,213829200,2),(870,228866400,1),(870,243982800,2),(870,260316000,1),(870,276123600,2),(870,291765600,1),(870,307486800,2),(870,323820000,1),(870,338936400,2),(870,354664800,1),(870,370386000,2),(870,386114400,1),(870,401835600,2),(870,417564000,1),(870,433285200,2),(870,449013600,1),(870,465339600,2),(870,481068000,1),(870,496789200,2),(870,512517600,1),(870,528238800,2),(870,543967200,1),(870,559688400,2),(870,575416800,1),(870,591138000,2),(870,606866400,1),(870,622587600,2),(870,638316000,1),(870,654642000,2),(870,670370400,1),(870,686091600,2),(870,701820000,1),(870,717541200,2),(870,733269600,1),(870,748990800,2),(870,764719200,1),(870,780440400,2),(870,796168800,1),(870,811890000,2),(870,828223200,1),(870,843944400,2),(870,859672800,1),(870,875394000,2),(870,891122400,1),(870,909277200,3),(870,922582800,4),(870,941331600,3),(870,954032400,4),(870,972781200,3),(870,985482000,4),(870,1004230800,3),(870,1017536400,4),(870,1035680400,3),(870,1048986000,4),(870,1067130000,3),(870,1080435600,4),(870,1099184400,3),(870,1111885200,4),(870,1130634000,3),(870,1143334800,4),(870,1162083600,3),(870,1174784400,4),(870,1193533200,3),(870,1206838800,4),(870,1224982800,3),(870,1238288400,4),(870,1256432400,3),(870,1269738000,4),(870,1288486800,3),(870,1301187600,4),(870,1319936400,3),(870,1332637200,4),(870,1351386000,3),(870,1364691600,4),(870,1382835600,3),(870,1396141200,4),(870,1414285200,3),(870,1427590800,4),(870,1445734800,3),(870,1459040400,4),(870,1473282000,5),(870,1509238800,3),(870,1521939600,4),(870,1540688400,3),(870,1553994000,4),(870,1572138000,3),(870,1585443600,4),(870,1603587600,3),(870,1616893200,4),(870,1635642000,3),(870,1648342800,4),(870,1667091600,3),(870,1679792400,4),(870,1698541200,3),(870,1711846800,4),(870,1729990800,3),(870,1743296400,4),(870,1761440400,3),(870,1774746000,4),(870,1792890000,3),(870,1806195600,4),(870,1824944400,3),(870,1837645200,4),(870,1856394000,3),(870,1869094800,4),(870,1887843600,3),(870,1901149200,4),(870,1919293200,3),(870,1932598800,4),(870,1950742800,3),(870,1964048400,4),(870,1982797200,3),(870,1995498000,4),(870,2014246800,3),(870,2026947600,4),(870,2045696400,3),(870,2058397200,4),(870,2077146000,3),(870,2090451600,4),(870,2108595600,3),(870,2121901200,4),(870,2140045200,3),(871,-2147483648,2),(871,-933645600,1),(871,-857358000,2),(871,-844300800,1),(871,-825822000,2),(871,-812685600,1),(871,-794199600,2),(871,-779853600,1),(871,-762656400,2),(871,-748310400,1),(871,-731127600,2),(871,-399088800,1),(871,-386650800,2),(871,-368330400,1),(871,-355114800,2),(871,-336790800,1),(871,-323654400,2),(871,-305168400,1),(871,-292032000,2),(871,-273632400,1),(871,-260496000,2),(871,-242096400,1),(871,-228960000,2),(871,-210560400,1),(871,-197424000,2),(871,-178938000,1),(871,-165801600,2),(871,-147402000,1),(871,-134265600,2),(871,-115866000,1),(871,-102643200,2),(871,-84330000,1),(871,-81313200,4),(871,142380000,3),(871,150843600,4),(871,167176800,3),(871,178664400,4),(871,334015200,3),(871,337644000,4),(871,452556000,3),(871,462232800,4),(871,482277600,3),(871,495579600,4),(871,516751200,3),(871,526424400,4),(871,545436000,3),(871,558478800,4),(871,576626400,3),(871,589323600,4),(871,609890400,3),(871,620773200,4),(871,638316000,3),(871,651618000,4),(871,669765600,3),(871,683672400,4),(871,701820000,3),(871,715726800,4),(871,733701600,3),(871,747176400,4),(871,765151200,3),(871,778021200,4),(871,796600800,3),(871,810075600,4),(871,820447200,2),(871,828655200,1),(871,843170400,5),(871,860104800,1),(871,874620000,5),(871,891554400,1),(871,906069600,5),(871,915141600,2),(871,924213600,1),(871,939934800,2),(871,956268000,1),(871,971989200,2),(871,987717600,1),(871,1003438800,2),(871,1019167200,1),(871,1034888400,2),(871,1050616800,1),(871,1066338000,2),(871,1082066400,1),(871,1096581600,2),(871,1113516000,1),(871,1128380400,2),(871,1143842400,1),(871,1158872400,2),(871,1175378400,1),(871,1189638000,2),(871,1206655200,1),(871,1219957200,2),(871,1238104800,1),(871,1252015200,2),(871,1269640860,1),(871,1281474000,2),(871,1301608860,1),(871,1312146000,2),(871,1333058400,1),(871,1348178400,2),(871,1364508000,1),(871,1380229200,2),(871,1395957600,1),(871,1414098000,2),(871,1427493600,1),(871,1445547600,2),(871,1458946800,1),(871,1477692000,2),(871,1490396400,1),(871,1509141600,2),(871,1521846000,1),(871,1540591200,2),(871,1553900400,1),(871,1572040800,2),(871,1585350000,1),(871,1604095200,2),(871,1616799600,1),(871,1635544800,2),(871,1648249200,1),(871,1666994400,2),(871,1679698800,1),(871,1698444000,2),(871,1711753200,1),(871,1729893600,2),(871,1743202800,1),(871,1761343200,2),(871,1774652400,1),(871,1793397600,2),(871,1806102000,1),(871,1824847200,2),(871,1837551600,1),(871,1856296800,2),(871,1869001200,1),(871,1887746400,2),(871,1901055600,1),(871,1919196000,2),(871,1932505200,1),(871,1950645600,2),(871,1963954800,1),(871,1982700000,2),(871,1995404400,1),(871,2014149600,2),(871,2026854000,1),(871,2045599200,2),(871,2058303600,1),(871,2077048800,2),(871,2090358000,1),(871,2108498400,2),(871,2121807600,1),(871,2140552800,2),(872,-2147483648,2),(872,-933667200,1),(872,-922093200,2),(872,-908870400,1),(872,-888829200,2),(872,-881049600,1),(872,-767869200,2),(872,-745833600,1),(872,-733827600,2),(872,-716889600,1),(872,-699613200,2),(872,-683884800,1),(872,-670669200,2),(872,-652348800,1),(872,-650019600,2),(872,515527200,1),(872,527014800,2),(872,545162400,1),(872,558464400,2),(872,577216800,1),(872,589914000,2),(872,608666400,1),(872,621968400,2),(872,640116000,1),(872,653418000,2),(872,671565600,1),(872,684867600,2),(873,-2147483648,2),(873,-933645600,1),(873,-857358000,2),(873,-844300800,1),(873,-825822000,2),(873,-812685600,1),(873,-794199600,2),(873,-779853600,1),(873,-762656400,2),(873,-748310400,1),(873,-731127600,2),(873,-399088800,1),(873,-386650800,2),(873,-368330400,1),(873,-355114800,2),(873,-336790800,1),(873,-323654400,2),(873,-305168400,1),(873,-292032000,2),(873,-273632400,1),(873,-260496000,2),(873,-242096400,1),(873,-228960000,2),(873,-210560400,1),(873,-197424000,2),(873,-178938000,1),(873,-165801600,2),(873,-147402000,1),(873,-134265600,2),(873,-115866000,1),(873,-102643200,2),(873,-84330000,1),(873,-81313200,4),(873,142380000,3),(873,150843600,4),(873,167176800,3),(873,178664400,4),(873,334015200,3),(873,337644000,4),(873,452556000,3),(873,462232800,4),(873,482277600,3),(873,495579600,4),(873,516751200,3),(873,526424400,4),(873,545436000,3),(873,558478800,4),(873,576626400,3),(873,589323600,4),(873,609890400,3),(873,620773200,4),(873,638316000,3),(873,651618000,4),(873,669765600,3),(873,683672400,4),(873,701820000,3),(873,715726800,4),(873,733701600,3),(873,747176400,4),(873,765151200,3),(873,778021200,4),(873,796600800,3),(873,810075600,4),(873,820447200,2),(873,828655200,1),(873,843170400,5),(873,860104800,1),(873,874620000,5),(873,891554400,1),(873,906069600,5),(873,915141600,2),(873,924213600,1),(873,939934800,2),(873,956268000,1),(873,971989200,2),(873,987717600,1),(873,1003438800,2),(873,1019167200,1),(873,1034888400,2),(873,1050616800,1),(873,1066338000,2),(873,1082066400,1),(873,1096581600,2),(873,1113516000,1),(873,1128380400,2),(873,1143842400,1),(873,1158872400,2),(873,1175378400,1),(873,1189638000,2),(873,1206655200,1),(873,1220216400,2),(873,1238104800,1),(873,1252015200,2),(873,1269554400,1),(873,1281474000,2),(873,1301608860,1),(873,1312146000,2),(873,1314655200,1),(873,1317330000,2),(873,1333058400,1),(873,1348178400,2),(873,1364508000,1),(873,1380229200,2),(873,1395957600,1),(873,1414098000,2),(873,1427493600,1),(873,1445547600,2),(873,1458946800,1),(873,1477692000,2),(873,1490396400,1),(873,1509141600,2),(873,1521846000,1),(873,1540591200,2),(873,1553900400,1),(873,1572040800,2),(873,1585350000,1),(873,1604095200,2),(873,1616799600,1),(873,1635544800,2),(873,1648249200,1),(873,1666994400,2),(873,1679698800,1),(873,1698444000,2),(873,1711753200,1),(873,1729893600,2),(873,1743202800,1),(873,1761343200,2),(873,1774652400,1),(873,1793397600,2),(873,1806102000,1),(873,1824847200,2),(873,1837551600,1),(873,1856296800,2),(873,1869001200,1),(873,1887746400,2),(873,1901055600,1),(873,1919196000,2),(873,1932505200,1),(873,1950645600,2),(873,1963954800,1),(873,1982700000,2),(873,1995404400,1),(873,2014149600,2),(873,2026854000,1),(873,2045599200,2),(873,2058303600,1),(873,2077048800,2),(873,2090358000,1),(873,2108498400,2),(873,2121807600,1),(873,2140552800,2),(874,-2147483648,0),(874,-2004073600,1),(874,-1851577590,2),(874,-852105600,3),(874,-782643600,4),(874,-767869200,2),(874,-718095600,3),(874,-457776000,2),(874,-315648000,3),(874,171820800,2),(874,2147483647,2),(875,-2147483648,0),(875,-2056690800,1),(875,-900909000,2),(875,-891579600,3),(875,-884248200,4),(875,-766659600,1),(875,-747981000,2),(875,-728544600,1),(875,-717049800,2),(875,-694503000,1),(875,-683785800,2),(875,-668064600,1),(875,-654755400,2),(875,-636615000,1),(875,-623305800,2),(875,-605165400,1),(875,-591856200,2),(875,-573715800,1),(875,-559801800,2),(875,-541661400,1),(875,-528352200,2),(875,-510211800,1),(875,-498112200,2),(875,-478762200,1),(875,-466662600,2),(875,-446707800,1),(875,-435213000,2),(875,-415258200,1),(875,-403158600,2),(875,-383808600,1),(875,-371709000,2),(875,-352359000,1),(875,-340259400,2),(875,-320909400,1),(875,-308809800,2),(875,-288855000,1),(875,-277360200,2),(875,-257405400,1),(875,-245910600,2),(875,-225955800,1),(875,-213856200,2),(875,-194506200,1),(875,-182406600,2),(875,-163056600,1),(875,-148537800,2),(875,-132816600,1),(875,-117088200,2),(875,-101367000,1),(875,-85638600,2),(875,-69312600,1),(875,-53584200,2),(875,-37863000,1),(875,-22134600,2),(875,-6413400,1),(875,9315000,2),(875,25036200,1),(875,40764600,2),(875,56485800,1),(875,72214200,2),(875,88540200,1),(875,104268600,2),(875,119989800,1),(875,126041400,2),(875,151439400,1),(875,167167800,2),(875,182889000,1),(875,198617400,2),(875,214338600,1),(875,295385400,2),(875,309292200,1),(876,-2147483648,0),(876,-2032927596,1),(876,252439200,3),(876,417978000,2),(876,433785600,3),(876,449600400,2),(876,465321600,3),(876,481050000,2),(876,496771200,3),(876,512499600,2),(876,528220800,3),(876,543949200,2),(876,559670400,3),(876,575398800,2),(876,591120000,3),(876,606848400,2),(876,622569600,3),(876,638298000,2),(876,654624000,3),(876,670352400,2),(876,686073600,3),(876,701802000,2),(876,717523200,3),(876,733251600,2),(876,748972800,3),(876,764701200,2),(876,780422400,3),(876,796150800,2),(876,811872000,3),(876,828205200,2),(876,843926400,3),(876,859654800,2),(876,875376000,3),(876,891104400,2),(876,906825600,3),(876,988398000,2),(876,1001700000,3),(876,1017428400,2),(876,1033149600,3),(876,1048878000,2),(876,1064599200,3),(876,1080327600,2),(876,1096048800,3),(876,1111777200,2),(876,1127498400,3),(876,1143226800,2),(876,1159552800,3),(876,1427482800,2),(876,1443196800,3),(876,1458932400,2),(876,1474646400,3),(876,2147483647,3),(877,-2147483648,1),(877,-1575874625,2),(877,-1247554800,4),(877,354902400,3),(877,370710000,4),(877,386438400,3),(877,402246000,4),(877,417974400,3),(877,433782000,4),(877,449596800,3),(877,465328800,5),(877,481053600,6),(877,496778400,5),(877,512503200,6),(877,528228000,5),(877,543952800,6),(877,559677600,5),(877,575402400,6),(877,591127200,5),(877,606852000,6),(877,622576800,5),(877,638301600,6),(877,654631200,5),(877,670356000,7),(877,686084400,8),(877,695761200,5),(877,701805600,6),(877,717530400,5),(877,733255200,6),(877,748980000,5),(877,764704800,6),(877,780429600,5),(877,796154400,6),(877,811879200,5),(877,828208800,6),(877,846352800,5),(877,859658400,6),(877,877802400,5),(877,891108000,6),(877,909252000,5),(877,922557600,6),(877,941306400,5),(877,954007200,6),(877,972756000,5),(877,985456800,6),(877,1004205600,5),(877,1017511200,6),(877,1035655200,5),(877,1048960800,6),(877,1067104800,5),(877,1080410400,6),(877,1099159200,5),(877,1111860000,6),(877,1130608800,5),(877,1143309600,6),(877,1162058400,5),(877,1174759200,6),(877,1193508000,5),(877,1206813600,6),(877,1224957600,5),(877,1238263200,6),(877,1256407200,5),(877,1269712800,6),(877,1288461600,5),(877,1301162400,9),(877,1414256400,5),(877,2147483647,5),(878,-2147483648,1),(878,-1869875816,3),(878,-1693706400,2),(878,-1680490800,3),(878,-1570413600,2),(878,-1552186800,3),(878,-1538359200,2),(878,-1522551600,3),(878,-1507514400,2),(878,-1490583600,3),(878,-1440208800,2),(878,-1428030000,3),(878,-1409709600,2),(878,-1396494000,3),(878,-931140000,2),(878,-922762800,3),(878,-917834400,2),(878,-892436400,3),(878,-875844000,2),(878,-857358000,3),(878,-781063200,2),(878,-764737200,3),(878,-744343200,2),(878,-733806000,3),(878,-716436000,2),(878,-701924400,3),(878,-684986400,2),(878,-670474800,3),(878,-654141600,2),(878,-639025200,3),(878,-621828000,2),(878,-606970800,3),(878,-590032800,2),(878,-575434800,3),(878,-235620000,2),(878,-228279600,3),(878,-177732000,2),(878,-165726000,3),(878,10533600,2),(878,23835600,3),(878,41983200,2),(878,55285200,3),(878,74037600,2),(878,87339600,3),(878,107910000,2),(878,121219200,3),(878,133920000,2),(878,152676000,3),(878,165362400,2),(878,183502800,3),(878,202428000,2),(878,215557200,3),(878,228866400,2),(878,245797200,3),(878,260316000,2),(878,277246800,4),(878,308779200,5),(878,323827200,4),(878,340228800,5),(878,354672000,4),(878,371678400,5),(878,386121600,4),(878,403128000,5),(878,428446800,4),(878,433886400,5),(878,482792400,2),(878,496702800,3),(878,512521200,6),(878,528246000,7),(878,543970800,6),(878,559695600,7),(878,575420400,6),(878,591145200,7),(878,606870000,6),(878,622594800,7),(878,638319600,6),(878,654649200,7),(878,670374000,6),(878,686098800,7),(878,701823600,6),(878,717548400,7),(878,733273200,6),(878,748998000,7),(878,764118000,6),(878,780447600,7),(878,796172400,6),(878,811897200,7),(878,828226800,6),(878,846370800,7),(878,859676400,6),(878,877820400,7),(878,891126000,6),(878,909270000,7),(878,922575600,6),(878,941324400,7),(878,954025200,6),(878,972774000,7),(878,985474800,6),(878,1004223600,7),(878,1017529200,6),(878,1035673200,7),(878,1048978800,6),(878,1067122800,7),(878,1080428400,6),(878,1099177200,7),(878,1111878000,6),(878,1130626800,7),(878,1143327600,6),(878,1162076400,7),(878,1167602400,3),(878,1174784400,8),(878,1193533200,9),(878,1206838800,8),(878,1224982800,9),(878,1238288400,8),(878,1256432400,9),(878,1269738000,8),(878,1288486800,9),(878,1301274000,8),(878,1319936400,9),(878,1332637200,8),(878,1351386000,9),(878,1364691600,8),(878,1382835600,9),(878,1396227600,8),(878,1414285200,9),(878,1427590800,8),(878,1446944400,9),(878,1459040400,8),(878,1473195600,5),(878,2147483647,5),(879,-2147483648,1),(879,-1451719200,2),(879,-1172906400,3),(879,-876641400,4),(879,-766054800,3),(879,-683883000,5),(879,-620812800,3),(879,-189415800,6),(880,-2147483648,0),(880,-1172913768,1),(880,-799491600,2),(880,-189423000,3),(881,-2147483648,1),(881,-1641003640,3),(881,-933645600,2),(881,-857358000,3),(881,-844300800,2),(881,-825822000,3),(881,-812685600,2),(881,-794199600,3),(881,-779853600,2),(881,-762656400,3),(881,-748310400,2),(881,-731127600,3),(881,-681962400,4),(881,-673243200,2),(881,-667962000,3),(881,-652327200,2),(881,-636426000,3),(881,-622087200,2),(881,-608947200,3),(881,-591847200,2),(881,-572486400,3),(881,-558576000,2),(881,-542851200,3),(881,-527731200,2),(881,-514425600,3),(881,-490845600,2),(881,-482986800,3),(881,-459475200,2),(881,-451537200,3),(881,-428551200,2),(881,-418262400,3),(881,-400032000,2),(881,-387428400,3),(881,142380000,2),(881,150843600,3),(881,167176800,2),(881,178664400,3),(881,334015200,2),(881,337644000,3),(881,452556000,2),(881,462232800,3),(881,482277600,2),(881,495579600,3),(881,516751200,2),(881,526424400,3),(881,545436000,2),(881,558478800,3),(881,576626400,2),(881,589323600,3),(881,609890400,2),(881,620773200,3),(881,638316000,2),(881,651618000,3),(881,669765600,2),(881,683672400,3),(881,701820000,2),(881,715726800,3),(881,733701600,2),(881,747176400,3),(881,765151200,2),(881,778021200,3),(881,796600800,2),(881,810075600,3),(881,826840800,2),(881,842821200,3),(881,858895200,2),(881,874184400,3),(881,890344800,2),(881,905029200,3),(881,923011200,2),(881,936313200,3),(881,955670400,2),(881,970783200,3),(881,986770800,2),(881,1001282400,3),(881,1017356400,2),(881,1033941600,3),(881,1048806000,2),(881,1065132000,3),(881,1081292400,2),(881,1095804000,3),(881,1112313600,2),(881,1128812400,3),(881,1143763200,2),(881,1159657200,3),(881,1175212800,2),(881,1189897200,3),(881,1206662400,2),(881,1223161200,3),(881,1238112000,2),(881,1254006000,3),(881,1269561600,2),(881,1284246000,3),(881,1301616000,2),(881,1317510000,3),(881,1333065600,2),(881,1348354800,3),(881,1364515200,2),(881,1382828400,3),(881,1395964800,2),(881,1414278000,3),(881,1427414400,2),(881,1445727600,3),(881,1458864000,2),(881,1477782000,3),(881,1490313600,2),(881,1509231600,3),(881,1521763200,2),(881,1540681200,3),(881,1553817600,2),(881,1572130800,3),(881,1585267200,2),(881,1603580400,3),(881,1616716800,2),(881,1635634800,3),(881,1648166400,2),(881,1667084400,3),(881,1679616000,2),(881,1698534000,3),(881,1711670400,2),(881,1729983600,3),(881,1743120000,2),(881,1761433200,3),(881,1774569600,2),(881,1792882800,3),(881,1806019200,2),(881,1824937200,3),(881,1837468800,2),(881,1856386800,3),(881,1868918400,2),(881,1887836400,3),(881,1900972800,2),(881,1919286000,3),(881,1932422400,2),(881,1950735600,3),(881,1963872000,2),(881,1982790000,3),(881,1995321600,2),(881,2014239600,3),(881,2026771200,2),(881,2045689200,3),(881,2058220800,2),(881,2077138800,3),(881,2090275200,2),(881,2108588400,3),(881,2121724800,2),(881,2140038000,3),(882,-2147483648,1),(882,-788932800,2),(882,2147483647,2),(883,-2147483648,0),(883,-1487759676,1),(883,-1247569200,3),(883,354888000,2),(883,370695600,3),(883,386424000,2),(883,402231600,3),(883,417960000,2),(883,433767600,3),(883,449582400,2),(883,465314400,4),(883,481039200,5),(883,496764000,4),(883,512488800,5),(883,528213600,4),(883,543938400,5),(883,559663200,4),(883,575388000,5),(883,591112800,4),(883,606837600,5),(883,622562400,4),(883,638287200,5),(883,654616800,4),(883,670341600,6),(883,686070000,7),(883,695746800,4),(883,701791200,5),(883,717516000,4),(883,733240800,5),(883,748965600,4),(883,764690400,5),(883,780415200,4),(883,796140000,5),(883,811864800,4),(883,828194400,5),(883,846338400,4),(883,859644000,5),(883,877788000,4),(883,891093600,5),(883,909237600,4),(883,922543200,5),(883,941292000,4),(883,953992800,5),(883,972741600,4),(883,985442400,5),(883,1004191200,4),(883,1017496800,5),(883,1035640800,4),(883,1048946400,5),(883,1067090400,4),(883,1080396000,5),(883,1099144800,4),(883,1111845600,5),(883,1130594400,4),(883,1143295200,5),(883,1162044000,4),(883,1174744800,5),(883,1193493600,4),(883,1206799200,5),(883,1224943200,4),(883,1238248800,5),(883,1256392800,4),(883,1269698400,6),(883,1288450800,7),(883,1301151600,4),(883,2147483647,4),(884,-2147483648,0),(884,-1988166492,1),(884,-862637400,2),(884,-764145000,1),(884,-576135000,3),(884,38775600,5),(884,1018119600,4),(884,1033840800,5),(884,1212260400,4),(884,1225476000,5),(884,1239735600,4),(884,1257012000,5),(885,-2147483648,0),(885,-1325483420,1),(885,2147483647,1),(886,-2147483648,0),(886,-1577943676,1),(886,504901800,2),(886,2147483647,2),(887,-2147483648,0),(887,-1577943676,1),(887,504901800,2),(887,2147483647,2),(888,-2147483648,0),(888,-1579424533,1),(888,-1247558400,3),(888,354898800,2),(888,370706400,3),(888,386434800,2),(888,402242400,3),(888,417970800,2),(888,433778400,3),(888,449593200,2),(888,465325200,4),(888,481050000,5),(888,496774800,4),(888,512499600,5),(888,528224400,4),(888,543949200,5),(888,559674000,4),(888,575398800,5),(888,591123600,4),(888,606848400,5),(888,622573200,4),(888,638298000,5),(888,654627600,4),(888,670352400,6),(888,686080800,7),(888,695757600,4),(888,701802000,5),(888,717526800,4),(888,733251600,5),(888,748976400,4),(888,764701200,5),(888,780426000,4),(888,796150800,5),(888,811875600,4),(888,828205200,5),(888,846349200,4),(888,859654800,5),(888,877798800,4),(888,891104400,5),(888,909248400,4),(888,922554000,5),(888,941302800,4),(888,954003600,5),(888,972752400,4),(888,985453200,5),(888,1004202000,4),(888,1017507600,5),(888,1035651600,4),(888,1048957200,5),(888,1067101200,4),(888,1072882800,10),(888,1080403200,8),(888,1099152000,9),(888,1111852800,8),(888,1130601600,9),(888,1143302400,8),(888,1162051200,9),(888,1174752000,8),(888,1193500800,9),(888,1206806400,8),(888,1224950400,9),(888,1238256000,8),(888,1256400000,9),(888,1269705600,8),(888,1288454400,9),(888,1301155200,11),(888,1315832400,9),(888,1414252800,4),(888,2147483647,4),(889,-2147483648,1),(889,-2019705670,2),(889,-891581400,3),(889,-872058600,2),(889,-862637400,3),(889,-764145000,2),(890,-2147483648,0),(890,-1577513486,1),(890,-1247551200,3),(890,354906000,2),(890,370713600,3),(890,386442000,2),(890,402249600,3),(890,417978000,2),(890,433785600,3),(890,449600400,2),(890,465332400,4),(890,481057200,5),(890,496782000,4),(890,512506800,5),(890,528231600,4),(890,543956400,5),(890,559681200,4),(890,575406000,5),(890,591130800,4),(890,606855600,5),(890,622580400,4),(890,638305200,5),(890,654634800,4),(890,670359600,6),(890,686088000,7),(890,695764800,4),(890,701809200,5),(890,717534000,4),(890,733258800,5),(890,748983600,4),(890,764708400,5),(890,780433200,4),(890,796158000,5),(890,811882800,4),(890,828212400,5),(890,846356400,4),(890,859662000,5),(890,877806000,4),(890,891111600,5),(890,909255600,4),(890,922561200,5),(890,941310000,4),(890,954010800,5),(890,972759600,4),(890,985460400,5),(890,1004209200,4),(890,1017514800,5),(890,1035658800,4),(890,1048964400,5),(890,1067108400,4),(890,1080414000,5),(890,1099162800,4),(890,1111863600,5),(890,1130612400,4),(890,1143313200,5),(890,1162062000,4),(890,1174762800,5),(890,1193511600,4),(890,1206817200,5),(890,1224961200,4),(890,1238266800,5),(890,1256410800,4),(890,1269716400,5),(890,1288465200,4),(890,1301166000,8),(890,1414260000,4),(890,2147483647,4),(891,-2147483648,1),(891,-2038200925,2),(891,-1167634800,3),(891,-1073028000,4),(891,-894180000,5),(891,-879665400,6),(891,-767005200,5),(891,378664200,7),(891,2147483647,7),(892,-2147483648,0),(892,-1383463280,1),(892,-1167636600,3),(892,-1082448000,2),(892,-1074586800,3),(892,-1050825600,2),(892,-1042964400,3),(892,-1019289600,2),(892,-1011428400,3),(892,-987753600,2),(892,-979892400,3),(892,-956217600,2),(892,-948356400,3),(892,-924595200,2),(892,-916734000,3),(892,-893059200,2),(892,-885198000,3),(892,-879667200,4),(892,-767005200,3),(892,2147483647,3),(893,-2147483648,0),(893,-719636812,1),(893,2147483647,1),(894,-2147483648,0),(894,-2056692850,1),(894,-884509200,3),(894,-873280800,2),(894,-855918000,3),(894,-841744800,2),(894,-828529200,3),(894,-765363600,1),(894,-747046800,4),(894,-733827600,5),(894,-716461200,4),(894,-697021200,5),(894,-683715600,4),(894,-667990800,5),(894,-654771600,4),(894,-636627600,5),(894,-623322000,4),(894,-605178000,5),(894,-591872400,4),(894,-573642000,5),(894,-559818000,4),(894,-541674000,5),(894,-528368400,4),(894,-510224400,5),(894,-498128400,4),(894,-478774800,5),(894,-466678800,4),(894,-446720400,5),(894,-435229200,4),(894,-415258200,1),(894,-403158600,6),(894,-383808600,1),(894,-371709000,6),(894,-352359000,1),(894,-340259400,6),(894,-320909400,1),(894,-308809800,6),(894,-288855000,1),(894,-277360200,6),(894,-257405400,1),(894,-245910600,6),(894,-225955800,1),(894,-213856200,6),(894,-194506200,1),(894,-182406600,6),(894,-163056600,1),(894,-148537800,6),(894,-132820200,1),(894,-117088200,6),(894,-101370600,1),(894,-85638600,6),(894,-69312600,1),(894,-53584200,6),(894,-37863000,1),(894,-22134600,6),(894,-6413400,1),(894,9315000,6),(894,25036200,1),(894,40764600,6),(894,56485800,1),(894,72214200,6),(894,88540200,1),(894,104268600,6),(894,119989800,1),(894,126041400,6),(894,151439400,1),(894,167167800,6),(894,182889000,1),(894,198617400,6),(894,214338600,1),(894,295385400,6),(894,309292200,1),(895,-2147483648,0),(895,-2056692850,1),(895,-884509200,3),(895,-873280800,2),(895,-855918000,3),(895,-841744800,2),(895,-828529200,3),(895,-765363600,1),(895,-747046800,4),(895,-733827600,5),(895,-716461200,4),(895,-697021200,5),(895,-683715600,4),(895,-667990800,5),(895,-654771600,4),(895,-636627600,5),(895,-623322000,4),(895,-605178000,5),(895,-591872400,4),(895,-573642000,5),(895,-559818000,4),(895,-541674000,5),(895,-528368400,4),(895,-510224400,5),(895,-498128400,4),(895,-478774800,5),(895,-466678800,4),(895,-446720400,5),(895,-435229200,4),(895,-415258200,1),(895,-403158600,6),(895,-383808600,1),(895,-371709000,6),(895,-352359000,1),(895,-340259400,6),(895,-320909400,1),(895,-308809800,6),(895,-288855000,1),(895,-277360200,6),(895,-257405400,1),(895,-245910600,6),(895,-225955800,1),(895,-213856200,6),(895,-194506200,1),(895,-182406600,6),(895,-163056600,1),(895,-148537800,6),(895,-132820200,1),(895,-117088200,6),(895,-101370600,1),(895,-85638600,6),(895,-69312600,1),(895,-53584200,6),(895,-37863000,1),(895,-22134600,6),(895,-6413400,1),(895,9315000,6),(895,25036200,1),(895,40764600,6),(895,56485800,1),(895,72214200,6),(895,88540200,1),(895,104268600,6),(895,119989800,1),(895,126041400,6),(895,151439400,1),(895,167167800,6),(895,182889000,1),(895,198617400,6),(895,214338600,1),(895,295385400,6),(895,309292200,1),(896,-2147483648,0),(896,-1441188192,1),(896,-1247565600,3),(896,354891600,2),(896,370699200,3),(896,386427600,2),(896,402235200,3),(896,417963600,2),(896,433771200,3),(896,449586000,2),(896,465318000,4),(896,481042800,5),(896,496767600,4),(896,512492400,5),(896,528217200,4),(896,543942000,5),(896,559666800,4),(896,575391600,5),(896,591116400,4),(896,606841200,5),(896,622566000,4),(896,638290800,5),(896,654620400,4),(896,670345200,6),(896,686073600,7),(896,695750400,4),(896,701794800,5),(896,717519600,4),(896,733244400,5),(896,748969200,4),(896,764694000,5),(896,780418800,4),(896,796143600,5),(896,811868400,4),(896,828198000,5),(896,846342000,4),(896,859647600,5),(896,877791600,4),(896,891097200,5),(896,909241200,4),(896,922546800,5),(896,941295600,4),(896,953996400,5),(896,972745200,4),(896,985446000,5),(896,1004194800,4),(896,1017500400,5),(896,1035644400,4),(896,1048950000,5),(896,1067094000,4),(896,1080399600,5),(896,1099148400,4),(896,1111849200,5),(896,1130598000,4),(896,1143298800,5),(896,1162047600,4),(896,1174748400,5),(896,1193497200,4),(896,1206802800,5),(896,1224946800,4),(896,1238252400,5),(896,1256396400,4),(896,1269702000,5),(896,1288450800,4),(896,1301151600,8),(896,1414245600,7),(896,1461427200,4),(896,2147483647,4),(897,-2147483648,0),(897,-1577951856,1),(897,-1172908656,2),(897,-880272000,3),(897,-766054800,4),(898,-2147483648,2),(898,-1046678400,1),(898,-1038733200,2),(898,-873273600,3),(898,-794221200,2),(898,-496224000,1),(898,-489315600,2),(898,259344000,1),(898,275151600,2),(899,-2147483648,0),(899,-1577936472,1),(899,2147483647,1),(900,-2147483648,0),(900,-1518920008,2),(900,166572000,1),(900,182293200,2),(900,200959200,1),(900,213829200,2),(900,228866400,1),(900,243982800,2),(900,260316000,1),(900,276123600,2),(900,291765600,1),(900,307486800,2),(900,323820000,1),(900,338936400,2),(900,354664800,1),(900,370386000,2),(900,386114400,1),(900,401835600,2),(900,417564000,1),(900,433285200,2),(900,449013600,1),(900,465339600,2),(900,481068000,1),(900,496789200,2),(900,512517600,1),(900,528238800,2),(900,543967200,1),(900,559688400,2),(900,575416800,1),(900,591138000,2),(900,606866400,1),(900,622587600,2),(900,638316000,1),(900,654642000,2),(900,670370400,1),(900,686091600,2),(900,701820000,1),(900,717541200,2),(900,733269600,1),(900,748990800,2),(900,764719200,1),(900,780440400,2),(900,796168800,1),(900,811890000,2),(900,828223200,1),(900,843944400,2),(900,859672800,1),(900,875394000,2),(900,891122400,1),(900,909277200,3),(900,922582800,4),(900,941331600,3),(900,954032400,4),(900,972781200,3),(900,985482000,4),(900,1004230800,3),(900,1017536400,4),(900,1035680400,3),(900,1048986000,4),(900,1067130000,3),(900,1080435600,4),(900,1099184400,3),(900,1111885200,4),(900,1130634000,3),(900,1143334800,4),(900,1162083600,3),(900,1174784400,4),(900,1193533200,3),(900,1206838800,4),(900,1224982800,3),(900,1238288400,4),(900,1256432400,3),(900,1269738000,4),(900,1288486800,3),(900,1301187600,4),(900,1319936400,3),(900,1332637200,4),(900,1351386000,3),(900,1364691600,4),(900,1382835600,3),(900,1396141200,4),(900,1414285200,3),(900,1427590800,4),(900,1445734800,3),(900,1459040400,4),(900,1477789200,3),(900,1490490000,4),(900,1509238800,3),(900,1521939600,4),(900,1540688400,3),(900,1553994000,4),(900,1572138000,3),(900,1585443600,4),(900,1603587600,3),(900,1616893200,4),(900,1635642000,3),(900,1648342800,4),(900,1667091600,3),(900,1679792400,4),(900,1698541200,3),(900,1711846800,4),(900,1729990800,3),(900,1743296400,4),(900,1761440400,3),(900,1774746000,4),(900,1792890000,3),(900,1806195600,4),(900,1824944400,3),(900,1837645200,4),(900,1856394000,3),(900,1869094800,4),(900,1887843600,3),(900,1901149200,4),(900,1919293200,3),(900,1932598800,4),(900,1950742800,3),(900,1964048400,4),(900,1982797200,3),(900,1995498000,4),(900,2014246800,3),(900,2026947600,4),(900,2045696400,3),(900,2058397200,4),(900,2077146000,3),(900,2090451600,4),(900,2108595600,3),(900,2121901200,4),(900,2140045200,3),(901,-2147483648,0),(901,-1441259328,1),(901,-1247551200,3),(901,354906000,2),(901,370713600,3),(901,386442000,2),(901,402249600,3),(901,417978000,2),(901,433785600,3),(901,449600400,2),(901,465332400,4),(901,481057200,5),(901,496782000,4),(901,512506800,5),(901,528231600,4),(901,543956400,5),(901,559681200,4),(901,575406000,5),(901,591130800,4),(901,606855600,5),(901,622580400,4),(901,638305200,5),(901,654634800,4),(901,670359600,6),(901,686088000,7),(901,695764800,4),(901,701809200,5),(901,717534000,4),(901,733258800,5),(901,748983600,4),(901,764708400,5),(901,780433200,4),(901,796158000,5),(901,811882800,4),(901,828212400,5),(901,846356400,4),(901,859662000,5),(901,877806000,4),(901,891111600,5),(901,909255600,4),(901,922561200,5),(901,941310000,4),(901,954010800,5),(901,972759600,4),(901,985460400,5),(901,1004209200,4),(901,1017514800,5),(901,1035658800,4),(901,1048964400,5),(901,1067108400,4),(901,1080414000,5),(901,1099162800,4),(901,1111863600,5),(901,1130612400,4),(901,1143313200,5),(901,1162062000,4),(901,1174762800,5),(901,1193511600,4),(901,1206817200,5),(901,1224961200,4),(901,1238266800,5),(901,1256410800,4),(901,1269716400,6),(901,1288468800,7),(901,1301169600,4),(901,2147483647,4),(902,-2147483648,0),(902,-1579476700,1),(902,-1247551200,3),(902,354906000,2),(902,370713600,3),(902,386442000,2),(902,402249600,3),(902,417978000,2),(902,433785600,3),(902,449600400,2),(902,465332400,4),(902,481057200,5),(902,496782000,4),(902,512506800,5),(902,528231600,4),(902,543956400,5),(902,559681200,4),(902,575406000,5),(902,591130800,4),(902,606855600,5),(902,622580400,4),(902,638305200,5),(902,654634800,4),(902,670359600,6),(902,686088000,7),(902,695764800,4),(902,701809200,5),(902,717534000,4),(902,733258800,5),(902,738086400,8),(902,748987200,7),(902,764712000,6),(902,780436800,7),(902,796161600,6),(902,811886400,7),(902,828216000,6),(902,846360000,7),(902,859665600,6),(902,877809600,7),(902,891115200,6),(902,909259200,7),(902,922564800,6),(902,941313600,7),(902,954014400,6),(902,972763200,7),(902,985464000,6),(902,1004212800,7),(902,1017518400,6),(902,1035662400,7),(902,1048968000,6),(902,1067112000,7),(902,1080417600,6),(902,1099166400,7),(902,1111867200,6),(902,1130616000,7),(902,1143316800,6),(902,1162065600,7),(902,1174766400,6),(902,1193515200,7),(902,1206820800,6),(902,1224964800,7),(902,1238270400,6),(902,1256414400,7),(902,1269720000,6),(902,1288468800,7),(902,1301169600,4),(902,1414263600,7),(902,1469304000,4),(902,2147483647,4),(903,-2147483648,0),(903,-1582088010,1),(903,-1247547600,3),(903,354909600,2),(903,370717200,3),(903,386445600,2),(903,402253200,3),(903,417981600,2),(903,433789200,3),(903,449604000,2),(903,465336000,4),(903,481060800,5),(903,496785600,4),(903,512510400,5),(903,528235200,4),(903,543960000,5),(903,559684800,4),(903,575409600,5),(903,591134400,4),(903,606859200,5),(903,622584000,4),(903,638308800,5),(903,654638400,4),(903,670363200,6),(903,686091600,7),(903,695768400,4),(903,701812800,5),(903,717537600,4),(903,733262400,5),(903,748987200,4),(903,764712000,5),(903,780436800,4),(903,796161600,5),(903,811886400,4),(903,828216000,5),(903,846360000,4),(903,859665600,5),(903,877809600,4),(903,891115200,5),(903,909259200,4),(903,922564800,5),(903,941313600,4),(903,954014400,5),(903,972763200,4),(903,985464000,5),(903,1004212800,4),(903,1017518400,5),(903,1035662400,4),(903,1048968000,5),(903,1067112000,4),(903,1080417600,5),(903,1099166400,4),(903,1111867200,5),(903,1130616000,4),(903,1143316800,5),(903,1162065600,4),(903,1174766400,5),(903,1193515200,4),(903,1206820800,5),(903,1224964800,4),(903,1238270400,5),(903,1256414400,4),(903,1269720000,5),(903,1288468800,4),(903,1301169600,8),(903,1414263600,4),(903,2147483647,4),(904,-2147483648,0),(904,-1441164324,1),(904,-1247540400,2),(904,354913200,3),(904,370720800,4),(904,386445600,3),(904,402256800,2),(904,417985200,3),(904,433792800,2),(904,449607600,3),(904,465339600,5),(904,481064400,6),(904,496789200,5),(904,512514000,6),(904,528238800,5),(904,543963600,6),(904,559688400,5),(904,575413200,6),(904,591138000,5),(904,606862800,7),(904,622591200,8),(904,638316000,7),(904,654645600,8),(904,670370400,7),(904,686095200,8),(904,695772000,5),(904,701816400,7),(904,717544800,8),(904,733269600,7),(904,748994400,8),(904,764719200,7),(904,780444000,8),(904,796168800,7),(904,811893600,8),(904,828223200,7),(904,846367200,8),(904,859672800,7),(904,877816800,8),(904,891122400,7),(904,909266400,8),(904,922572000,7),(904,941320800,8),(904,954021600,7),(904,972770400,8),(904,985471200,7),(904,1004220000,8),(904,1017525600,7),(904,1035669600,8),(904,1048975200,7),(904,1067119200,8),(904,1080424800,7),(904,1099173600,5),(904,2147483647,5),(905,-2147483648,1),(905,-1570084924,2),(905,2147483647,2),(906,-2147483648,0),(906,-1946186240,1),(906,-1172906240,2),(906,-881220600,3),(906,-766054800,2),(906,-683883000,4),(906,-620812800,2),(906,-189415800,5),(906,567964800,6),(907,-2147483648,0),(907,-1948782180,1),(907,-1830414600,2),(907,-768646800,3),(907,1439564400,1),(907,1525446000,3),(908,-2147483648,0),(908,-1577935568,1),(908,76190400,2),(908,2147483647,2),(909,-2147483648,0),(909,-1441167268,1),(909,-1247544000,2),(909,354913200,3),(909,370720800,4),(909,386445600,3),(909,402256800,2),(909,417985200,3),(909,433792800,2),(909,449607600,3),(909,465339600,5),(909,481064400,6),(909,496789200,5),(909,512514000,6),(909,528238800,5),(909,543963600,6),(909,559688400,5),(909,575413200,6),(909,591138000,5),(909,606862800,6),(909,622587600,5),(909,638312400,6),(909,654642000,5),(909,670366800,7),(909,686095200,8),(909,695772000,5),(909,701816400,6),(909,717541200,5),(909,733266000,6),(909,748990800,5),(909,764715600,6),(909,780440400,5),(909,796165200,6),(909,811890000,5),(909,828219600,6),(909,846363600,5),(909,859669200,6),(909,877813200,5),(909,891118800,6),(909,909262800,5),(909,922568400,6),(909,941317200,5),(909,954018000,6),(909,972766800,5),(909,985467600,6),(909,1004216400,5),(909,1017522000,6),(909,1035666000,5),(909,1048971600,6),(909,1067115600,5),(909,1080421200,6),(909,1099170000,9),(909,2147483647,9),(910,-2147483648,0),(910,-1441167712,1),(910,-1247544000,2),(910,354913200,3),(910,370720800,4),(910,386445600,3),(910,402256800,2),(910,417985200,3),(910,433792800,2),(910,449607600,3),(910,465339600,5),(910,481064400,6),(910,496789200,5),(910,512514000,6),(910,528238800,5),(910,543963600,6),(910,559688400,5),(910,575413200,6),(910,591138000,5),(910,606862800,6),(910,622587600,5),(910,638312400,6),(910,654642000,5),(910,670366800,7),(910,686095200,5),(910,695768400,9),(910,701812800,6),(910,717541200,5),(910,733266000,6),(910,748990800,5),(910,764715600,6),(910,780440400,5),(910,796165200,6),(910,811890000,5),(910,828219600,6),(910,846363600,5),(910,859669200,6),(910,877813200,5),(910,891118800,6),(910,909262800,5),(910,922568400,6),(910,941317200,5),(910,954018000,6),(910,972766800,5),(910,985467600,6),(910,1004216400,5),(910,1017522000,6),(910,1035666000,5),(910,1048971600,6),(910,1067115600,5),(910,1080421200,6),(910,1099170000,9),(910,1545328800,2),(910,2147483647,2),(911,-2147483648,1),(911,-1577946287,2),(911,-873268200,3),(911,-778410000,2),(911,2147483647,2),(912,-2147483648,0),(912,-719636812,1),(912,2147483647,1),(913,-2147483648,0),(913,-2004073600,1),(913,-1851577590,2),(913,-852105600,3),(913,-782643600,4),(913,-767869200,2),(913,-718095600,3),(913,-457776000,2),(913,-315648000,3),(913,171820800,2),(913,2147483647,2),(914,-2147483648,0),(914,-2031039048,1),(914,-768560400,3),(914,354891600,2),(914,370699200,3),(914,386427600,2),(914,402235200,3),(914,417963600,2),(914,433771200,3),(914,449586000,2),(914,465318000,4),(914,481042800,5),(914,496767600,4),(914,512492400,5),(914,528217200,4),(914,543942000,5),(914,559666800,4),(914,575391600,5),(914,591116400,4),(914,606841200,5),(914,622566000,4),(914,638290800,5),(914,654620400,4),(914,670345200,6),(914,686073600,7),(914,695750400,4),(914,701794800,5),(914,717519600,4),(914,733244400,5),(914,748969200,4),(914,764694000,5),(914,780418800,4),(914,796143600,5),(914,811868400,4),(914,828198000,5),(914,846342000,4),(914,859647600,6),(914,877795200,7),(914,891100800,6),(914,909244800,7),(914,922550400,6),(914,941299200,7),(914,954000000,6),(914,972748800,7),(914,985449600,6),(914,1004198400,7),(914,1017504000,6),(914,1035648000,7),(914,1048953600,6),(914,1067097600,7),(914,1080403200,6),(914,1099152000,7),(914,1111852800,6),(914,1130601600,7),(914,1143302400,6),(914,1162051200,7),(914,1174752000,6),(914,1193500800,7),(914,1206806400,6),(914,1224950400,7),(914,1238256000,6),(914,1256400000,7),(914,1269705600,6),(914,1288454400,7),(914,1301155200,4),(914,1414249200,7),(914,1459008000,4),(914,2147483647,4),(915,-2147483648,0),(915,-1441168073,1),(915,-1247544000,2),(915,354913200,3),(915,370720800,4),(915,386445600,3),(915,402256800,2),(915,417985200,3),(915,433792800,2),(915,449607600,3),(915,465339600,5),(915,481064400,6),(915,496789200,5),(915,512514000,6),(915,528238800,5),(915,543963600,6),(915,559688400,5),(915,575413200,6),(915,591138000,5),(915,606862800,6),(915,622587600,5),(915,638312400,6),(915,654642000,5),(915,670366800,6),(915,686091600,5),(915,694206000,2),(915,2147483647,2),(916,-2147483648,0),(916,-1948782472,1),(916,-1830414600,2),(916,-767350800,3),(916,-498128400,1),(916,-462702600,4),(916,-451733400,1),(916,-429784200,4),(916,-418296600,1),(916,-399544200,4),(916,-387451800,1),(916,-368094600,4),(916,-356002200,1),(916,-336645000,4),(916,-324552600,1),(916,-305195400,4),(916,-293103000,1),(916,-264933000,3),(916,547578000,5),(916,560883600,3),(916,579027600,5),(916,592333200,3),(917,-2147483648,2),(917,-933667200,1),(917,-922093200,2),(917,-908870400,1),(917,-888829200,2),(917,-881049600,1),(917,-767869200,2),(917,-745833600,1),(917,-733827600,2),(917,-716889600,1),(917,-699613200,2),(917,-683884800,1),(917,-670669200,2),(917,-652348800,1),(917,-650019600,2),(917,515527200,1),(917,527014800,2),(917,545162400,1),(917,558464400,2),(917,577216800,1),(917,589914000,2),(917,608666400,1),(917,621968400,2),(917,640116000,1),(917,653418000,2),(917,671565600,1),(917,684867600,2),(918,-2147483648,1),(918,-2038200925,2),(918,-1167634800,3),(918,-1073028000,4),(918,-894180000,5),(918,-879665400,6),(918,-767005200,5),(918,378664200,7),(918,2147483647,7),(919,-2147483648,0),(919,-1441188892,1),(919,-1247565600,3),(919,354891600,2),(919,370699200,3),(919,386427600,2),(919,402235200,3),(919,417963600,2),(919,433771200,3),(919,449586000,2),(919,465318000,4),(919,481042800,5),(919,496767600,4),(919,512492400,5),(919,528217200,4),(919,543942000,5),(919,559666800,4),(919,575391600,5),(919,591116400,4),(919,606841200,5),(919,622566000,4),(919,638290800,5),(919,654620400,4),(919,670345200,6),(919,686073600,7),(919,695750400,4),(919,701794800,5),(919,717519600,4),(919,733244400,5),(919,748969200,4),(919,764694000,5),(919,780418800,4),(919,796143600,5),(919,811868400,4),(919,828198000,5),(919,846342000,4),(919,859647600,5),(919,877791600,4),(919,891097200,5),(919,909241200,4),(919,922546800,5),(919,941295600,4),(919,953996400,5),(919,972745200,4),(919,985446000,5),(919,1004194800,4),(919,1017500400,5),(919,1035644400,4),(919,1048950000,5),(919,1067094000,4),(919,1080399600,5),(919,1099148400,4),(919,1111849200,5),(919,1130598000,4),(919,1143298800,5),(919,1162047600,4),(919,1174748400,5),(919,1193497200,4),(919,1206802800,5),(919,1224946800,4),(919,1238252400,5),(919,1256396400,4),(919,1269702000,5),(919,1288450800,4),(919,1301151600,8),(919,1414245600,4),(919,2147483647,4),(920,-2147483648,1),(920,-1017820800,2),(920,-766224000,1),(920,-745833600,3),(920,-733827600,1),(920,-716889600,3),(920,-699613200,1),(920,-683884800,3),(920,-670669200,1),(920,-652348800,3),(920,-639133200,1),(920,-620812800,3),(920,-607597200,1),(920,-589276800,3),(920,-576061200,1),(920,-562924800,3),(920,-541760400,1),(920,-528710400,3),(920,-510224400,1),(920,-497174400,3),(920,-478688400,1),(920,-465638400,3),(920,-449830800,1),(920,-434016000,3),(920,-418208400,1),(920,-402480000,3),(920,-386672400,1),(920,-370944000,3),(920,-355136400,1),(920,-339408000,3),(920,-323600400,1),(920,-302515200,3),(920,-291978000,1),(920,-270979200,3),(920,-260442000,1),(920,133977600,3),(920,149785200,1),(920,165513600,3),(920,181321200,1),(920,299606400,3),(920,307551600,1),(921,-2147483648,0),(921,-1441168631,1),(921,-1247547600,3),(921,354909600,2),(921,370717200,3),(921,386445600,2),(921,402253200,3),(921,417981600,2),(921,433789200,3),(921,449604000,2),(921,465336000,4),(921,481060800,5),(921,496785600,4),(921,512510400,5),(921,528235200,4),(921,543960000,5),(921,559684800,4),(921,575409600,5),(921,591134400,4),(921,606859200,5),(921,622584000,4),(921,638308800,5),(921,654638400,4),(921,670363200,6),(921,686091600,7),(921,694206000,1),(921,2147483647,1),(922,-2147483648,1),(922,-1441162751,2),(922,-405140400,4),(922,354916800,3),(922,370724400,4),(922,386452800,3),(922,402260400,4),(922,417988800,3),(922,433796400,4),(922,449611200,3),(922,465343200,5),(922,481068000,6),(922,496792800,5),(922,512517600,6),(922,528242400,5),(922,543967200,6),(922,559692000,5),(922,575416800,6),(922,591141600,5),(922,606866400,6),(922,622591200,5),(922,638316000,6),(922,654645600,5),(922,670370400,7),(922,686098800,8),(922,694213200,2),(922,701816400,9),(922,717537600,2),(922,733266000,9),(922,748987200,2),(922,764715600,9),(922,780436800,4),(922,796161600,3),(922,811882800,4),(922,828216000,3),(922,859662000,3),(922,877806000,4),(922,891115200,3),(922,909255600,4),(922,922564800,3),(922,941310000,4),(922,954014400,3),(922,972759600,4),(922,985464000,3),(922,1004209200,4),(922,1017518400,3),(922,1035658800,4),(922,1048968000,3),(922,1067108400,4),(922,1080417600,3),(922,1088276400,9),(922,1099177200,8),(922,1111878000,4),(922,2147483647,4),(923,-2147483648,0),(923,-1704165944,1),(923,-757394744,2),(923,247177800,4),(923,259272000,3),(923,277758000,4),(923,283982400,2),(923,290809800,5),(923,306531000,2),(923,322432200,5),(923,338499000,2),(923,673216200,5),(923,685481400,2),(923,701209800,5),(923,717103800,2),(923,732745800,5),(923,748639800,2),(923,764281800,5),(923,780175800,2),(923,795817800,5),(923,811711800,2),(923,827353800,5),(923,843247800,2),(923,858976200,5),(923,874870200,2),(923,890512200,5),(923,906406200,2),(923,922048200,5),(923,937942200,2),(923,953584200,5),(923,969478200,2),(923,985206600,5),(923,1001100600,2),(923,1016742600,5),(923,1032636600,2),(923,1048278600,5),(923,1064172600,2),(923,1079814600,5),(923,1095708600,2),(923,1111437000,5),(923,1127331000,2),(923,1206045000,5),(923,1221939000,2),(923,1237667400,5),(923,1253561400,2),(923,1269203400,5),(923,1285097400,2),(923,1300739400,5),(923,1316633400,2),(923,1332275400,5),(923,1348169400,2),(923,1363897800,5),(923,1379791800,2),(923,1395433800,5),(923,1411327800,2),(923,1426969800,5),(923,1442863800,2),(923,1458505800,5),(923,1474399800,2),(923,1490128200,5),(923,1506022200,2),(923,1521664200,5),(923,1537558200,2),(923,1553200200,5),(923,1569094200,2),(923,1584736200,5),(923,1600630200,2),(923,1616358600,5),(923,1632252600,2),(923,1647894600,5),(923,1663788600,2),(923,1679430600,5),(923,1695324600,2),(923,1710966600,5),(923,1726860600,2),(923,1742589000,5),(923,1758483000,2),(923,1774125000,5),(923,1790019000,2),(923,1805661000,5),(923,1821555000,2),(923,1837197000,5),(923,1853091000,2),(923,1868733000,5),(923,1884627000,2),(923,1900355400,5),(923,1916249400,2),(923,1931891400,5),(923,1947785400,2),(923,1963427400,5),(923,1979321400,2),(923,1994963400,5),(923,2010857400,2),(923,2026585800,5),(923,2042479800,2),(923,2058121800,5),(923,2074015800,2),(923,2089657800,5),(923,2105551800,2),(923,2121193800,5),(923,2137087800,2),(924,-2147483648,1),(924,-1641003640,3),(924,-933645600,2),(924,-857358000,3),(924,-844300800,2),(924,-825822000,3),(924,-812685600,2),(924,-794199600,3),(924,-779853600,2),(924,-762656400,3),(924,-748310400,2),(924,-731127600,3),(924,-681962400,4),(924,-673243200,2),(924,-667962000,3),(924,-652327200,2),(924,-636426000,3),(924,-622087200,2),(924,-608947200,3),(924,-591847200,2),(924,-572486400,3),(924,-558576000,2),(924,-542851200,3),(924,-527731200,2),(924,-514425600,3),(924,-490845600,2),(924,-482986800,3),(924,-459475200,2),(924,-451537200,3),(924,-428551200,2),(924,-418262400,3),(924,-400032000,2),(924,-387428400,3),(924,142380000,2),(924,150843600,3),(924,167176800,2),(924,178664400,3),(924,334015200,2),(924,337644000,3),(924,452556000,2),(924,462232800,3),(924,482277600,2),(924,495579600,3),(924,516751200,2),(924,526424400,3),(924,545436000,2),(924,558478800,3),(924,576626400,2),(924,589323600,3),(924,609890400,2),(924,620773200,3),(924,638316000,2),(924,651618000,3),(924,669765600,2),(924,683672400,3),(924,701820000,2),(924,715726800,3),(924,733701600,2),(924,747176400,3),(924,765151200,2),(924,778021200,3),(924,796600800,2),(924,810075600,3),(924,826840800,2),(924,842821200,3),(924,858895200,2),(924,874184400,3),(924,890344800,2),(924,905029200,3),(924,923011200,2),(924,936313200,3),(924,955670400,2),(924,970783200,3),(924,986770800,2),(924,1001282400,3),(924,1017356400,2),(924,1033941600,3),(924,1048806000,2),(924,1065132000,3),(924,1081292400,2),(924,1095804000,3),(924,1112313600,2),(924,1128812400,3),(924,1143763200,2),(924,1159657200,3),(924,1175212800,2),(924,1189897200,3),(924,1206662400,2),(924,1223161200,3),(924,1238112000,2),(924,1254006000,3),(924,1269561600,2),(924,1284246000,3),(924,1301616000,2),(924,1317510000,3),(924,1333065600,2),(924,1348354800,3),(924,1364515200,2),(924,1382828400,3),(924,1395964800,2),(924,1414278000,3),(924,1427414400,2),(924,1445727600,3),(924,1458864000,2),(924,1477782000,3),(924,1490313600,2),(924,1509231600,3),(924,1521763200,2),(924,1540681200,3),(924,1553817600,2),(924,1572130800,3),(924,1585267200,2),(924,1603580400,3),(924,1616716800,2),(924,1635634800,3),(924,1648166400,2),(924,1667084400,3),(924,1679616000,2),(924,1698534000,3),(924,1711670400,2),(924,1729983600,3),(924,1743120000,2),(924,1761433200,3),(924,1774569600,2),(924,1792882800,3),(924,1806019200,2),(924,1824937200,3),(924,1837468800,2),(924,1856386800,3),(924,1868918400,2),(924,1887836400,3),(924,1900972800,2),(924,1919286000,3),(924,1932422400,2),(924,1950735600,3),(924,1963872000,2),(924,1982790000,3),(924,1995321600,2),(924,2014239600,3),(924,2026771200,2),(924,2045689200,3),(924,2058220800,2),(924,2077138800,3),(924,2090275200,2),(924,2108588400,3),(924,2121724800,2),(924,2140038000,3),(925,-2147483648,0),(925,-706341516,1),(925,560025000,2),(925,2147483647,2),(926,-2147483648,0),(926,-706341516,1),(926,560025000,2),(926,2147483647,2),(927,-2147483648,3),(927,-683802000,1),(927,-672310800,2),(927,-654771600,1),(927,-640861200,2),(927,-620298000,1),(927,-609411600,2),(927,-588848400,1),(927,-577962000,2),(928,-2147483648,0),(928,-1578807591,1),(928,-1247551200,3),(928,354906000,2),(928,370713600,3),(928,386442000,2),(928,402249600,3),(928,417978000,2),(928,433785600,3),(928,449600400,2),(928,465332400,4),(928,481057200,5),(928,496782000,4),(928,512506800,5),(928,528231600,4),(928,543956400,5),(928,559681200,4),(928,575406000,5),(928,591130800,4),(928,606855600,5),(928,622580400,4),(928,638305200,5),(928,654634800,4),(928,670359600,6),(928,686088000,7),(928,695764800,4),(928,701809200,5),(928,717534000,4),(928,733258800,5),(928,748983600,4),(928,764708400,5),(928,780433200,4),(928,796158000,5),(928,811882800,4),(928,828212400,5),(928,846356400,4),(928,859662000,5),(928,877806000,4),(928,891111600,5),(928,909255600,4),(928,922561200,5),(928,941310000,4),(928,954010800,5),(928,972759600,4),(928,985460400,5),(928,1004209200,4),(928,1017514800,5),(928,1020193200,8),(928,1035662400,7),(928,1048968000,6),(928,1067112000,7),(928,1080417600,6),(928,1099166400,7),(928,1111867200,6),(928,1130616000,7),(928,1143316800,6),(928,1162065600,7),(928,1174766400,6),(928,1193515200,7),(928,1206820800,6),(928,1224964800,7),(928,1238270400,6),(928,1256414400,7),(928,1269720000,6),(928,1288468800,7),(928,1301169600,4),(928,1414263600,7),(928,1464465600,4),(928,2147483647,4),(929,-2147483648,0),(929,-1577951856,1),(929,-1172908656,2),(929,-880272000,3),(929,-766054800,4),(930,-2147483648,0),(930,-2032931252,1),(930,252435600,3),(930,417974400,2),(930,433782000,3),(930,449596800,2),(930,465318000,3),(930,481046400,2),(930,496767600,3),(930,512496000,2),(930,528217200,3),(930,543945600,2),(930,559666800,3),(930,575395200,2),(930,591116400,3),(930,606844800,2),(930,622566000,3),(930,638294400,2),(930,654620400,3),(930,670348800,2),(930,686070000,3),(930,701798400,2),(930,717519600,3),(930,733248000,2),(930,748969200,3),(930,764697600,2),(930,780418800,3),(930,796147200,2),(930,811868400,3),(930,828201600,2),(930,843922800,3),(930,859651200,2),(930,875372400,3),(930,891100800,2),(930,906822000,3),(930,988394400,2),(930,1001696400,3),(930,1017424800,2),(930,1033146000,3),(930,1048874400,2),(930,1064595600,3),(930,1080324000,2),(930,1096045200,3),(930,1111773600,2),(930,1127494800,3),(930,1143223200,2),(930,1159549200,3),(930,1427479200,2),(930,1443193200,3),(930,1458928800,2),(930,1474642800,3),(930,2147483647,3),(931,-2147483648,0),(931,-2032931252,1),(931,252435600,3),(931,417974400,2),(931,433782000,3),(931,449596800,2),(931,465318000,3),(931,481046400,2),(931,496767600,3),(931,512496000,2),(931,528217200,3),(931,543945600,2),(931,559666800,3),(931,575395200,2),(931,591116400,3),(931,606844800,2),(931,622566000,3),(931,638294400,2),(931,654620400,3),(931,670348800,2),(931,686070000,3),(931,701798400,2),(931,717519600,3),(931,733248000,2),(931,748969200,3),(931,764697600,2),(931,780418800,3),(931,796147200,2),(931,811868400,3),(931,828201600,2),(931,843922800,3),(931,859651200,2),(931,875372400,3),(931,891100800,2),(931,906822000,3),(931,988394400,2),(931,1001696400,3),(931,1017424800,2),(931,1033146000,3),(931,1048874400,2),(931,1064595600,3),(931,1080324000,2),(931,1096045200,3),(931,1111773600,2),(931,1127494800,3),(931,1143223200,2),(931,1159549200,3),(931,1427479200,2),(931,1443193200,3),(931,1458928800,2),(931,1474642800,3),(931,2147483647,3),(932,-2147483648,0),(932,-1325483420,1),(932,2147483647,1),(933,-2147483648,0),(933,-1579426374,1),(933,-1247558400,2),(933,354898800,4),(933,370699200,3),(933,386427600,4),(933,402235200,3),(933,417963600,4),(933,433771200,3),(933,449586000,4),(933,465318000,5),(933,481042800,6),(933,496767600,5),(933,512492400,6),(933,528217200,5),(933,543942000,6),(933,559666800,5),(933,575391600,6),(933,591116400,5),(933,606841200,6),(933,622566000,5),(933,638290800,6),(933,654620400,5),(933,670345200,7),(933,686073600,8),(933,695750400,5),(933,701794800,6),(933,717519600,5),(933,733244400,6),(933,748969200,5),(933,764694000,6),(933,780418800,5),(933,796143600,6),(933,811868400,5),(933,828198000,6),(933,846342000,5),(933,859647600,6),(933,877791600,5),(933,891097200,6),(933,909241200,5),(933,922546800,6),(933,941295600,5),(933,953996400,6),(933,972745200,5),(933,985446000,6),(933,1004194800,5),(933,1017500400,6),(933,1035644400,5),(933,1048950000,6),(933,1067094000,5),(933,1080399600,6),(933,1099148400,5),(933,1111849200,6),(933,1130598000,5),(933,1143298800,6),(933,1162047600,5),(933,1174748400,6),(933,1193497200,5),(933,1206802800,6),(933,1224946800,5),(933,1238252400,6),(933,1256396400,5),(933,1269702000,6),(933,1288450800,5),(933,1301151600,9),(933,1315828800,5),(933,1414249200,8),(933,2147483647,8),(934,-2147483648,1),(934,-1570084924,2),(934,2147483647,2),(935,-2147483648,0),(935,-1487321251,1),(935,-1247562000,3),(935,354895200,2),(935,370702800,3),(935,386431200,2),(935,402238800,3),(935,417967200,2),(935,433774800,3),(935,449589600,2),(935,465321600,4),(935,481046400,5),(935,496771200,4),(935,512496000,5),(935,528220800,4),(935,543945600,5),(935,559670400,4),(935,575395200,5),(935,591120000,4),(935,606844800,5),(935,622569600,4),(935,638294400,5),(935,654624000,4),(935,670348800,6),(935,686077200,7),(935,695754000,4),(935,701798400,5),(935,717523200,4),(935,733248000,5),(935,748972800,4),(935,764697600,5),(935,780422400,4),(935,796147200,5),(935,811872000,4),(935,828201600,5),(935,846345600,4),(935,859651200,5),(935,877795200,4),(935,891100800,5),(935,909244800,4),(935,922550400,5),(935,941299200,4),(935,954000000,5),(935,972748800,4),(935,985449600,5),(935,1004198400,4),(935,1017504000,5),(935,1035648000,4),(935,1048953600,5),(935,1067097600,4),(935,1080403200,5),(935,1099152000,4),(935,1111852800,5),(935,1130601600,4),(935,1143302400,5),(935,1162051200,4),(935,1174752000,5),(935,1193500800,4),(935,1206806400,5),(935,1224950400,4),(935,1238256000,5),(935,1256400000,4),(935,1269705600,5),(935,1288454400,4),(935,1301155200,8),(935,1414249200,4),(935,2147483647,4),(936,-2147483648,0),(936,-1579423138,1),(936,-1247558400,3),(936,354898800,2),(936,370706400,3),(936,386434800,2),(936,402242400,3),(936,417970800,2),(936,433778400,3),(936,449593200,2),(936,465325200,4),(936,481050000,5),(936,496774800,4),(936,512499600,5),(936,528224400,4),(936,543949200,5),(936,559674000,4),(936,575398800,5),(936,591123600,4),(936,606848400,5),(936,622573200,4),(936,638298000,5),(936,654627600,4),(936,670352400,6),(936,686080800,7),(936,695757600,4),(936,701802000,5),(936,717526800,4),(936,733251600,5),(936,748976400,4),(936,764701200,5),(936,780426000,4),(936,796150800,5),(936,811875600,4),(936,828205200,5),(936,846349200,4),(936,859654800,5),(936,877798800,4),(936,891104400,5),(936,909248400,4),(936,922554000,5),(936,941302800,4),(936,954003600,5),(936,972752400,4),(936,985453200,5),(936,1004202000,4),(936,1017507600,5),(936,1035651600,4),(936,1048957200,5),(936,1067101200,4),(936,1080406800,5),(936,1099155600,4),(936,1111856400,5),(936,1130605200,4),(936,1143306000,5),(936,1162054800,4),(936,1174755600,5),(936,1193504400,4),(936,1206810000,5),(936,1224954000,4),(936,1238259600,5),(936,1256403600,4),(936,1269709200,5),(936,1288458000,4),(936,1301158800,8),(936,1414252800,4),(936,2147483647,4),(937,-2147483648,1),(937,-1577946287,2),(937,-873268200,3),(937,-778410000,2),(937,2147483647,2),(938,-2147483648,0),(938,-1688270553,1),(938,-1592610305,2),(938,-1247544000,4),(938,354913200,3),(938,370720800,4),(938,386449200,3),(938,402256800,4),(938,417985200,3),(938,433792800,4),(938,449607600,3),(938,465339600,5),(938,481064400,6),(938,496789200,5),(938,512514000,6),(938,528238800,5),(938,543963600,6),(938,559688400,5),(938,575413200,6),(938,591138000,5),(938,606862800,6),(938,622587600,5),(938,638312400,6),(938,654642000,5),(938,670366800,7),(938,686095200,8),(938,695772000,5),(938,701816400,6),(938,717541200,5),(938,733266000,6),(938,748990800,5),(938,764715600,6),(938,780440400,5),(938,796165200,6),(938,811890000,5),(938,828219600,6),(938,846363600,5),(938,859669200,6),(938,877813200,5),(938,891118800,6),(938,909262800,5),(938,922568400,6),(938,941317200,5),(938,954018000,6),(938,972766800,5),(938,985467600,6),(938,1004216400,5),(938,1017522000,6),(938,1035666000,5),(938,1048971600,6),(938,1067115600,5),(938,1080421200,6),(938,1099170000,5),(938,1111870800,6),(938,1130619600,5),(938,1143320400,6),(938,1162069200,5),(938,1174770000,6),(938,1193518800,5),(938,1206824400,6),(938,1224968400,5),(938,1238274000,6),(938,1256418000,5),(938,1269723600,6),(938,1288472400,5),(938,1301173200,9),(938,1414267200,5),(938,2147483647,5),(939,-2147483648,0),(939,-1441162680,1),(939,-405140400,3),(939,354916800,2),(939,370724400,3),(939,386452800,2),(939,402260400,3),(939,417988800,2),(939,433796400,3),(939,449611200,2),(939,465343200,4),(939,481068000,5),(939,496792800,4),(939,512517600,5),(939,528242400,4),(939,543967200,5),(939,559692000,4),(939,575416800,5),(939,591141600,4),(939,606866400,5),(939,622591200,4),(939,638316000,5),(939,654645600,4),(939,670370400,6),(939,686098800,7),(939,701823600,6),(939,717548400,7),(939,733273200,6),(939,748998000,7),(939,764722800,6),(939,780447600,7),(939,796172400,6),(939,811897200,4),(939,852062400,3),(939,859672800,5),(939,877816800,4),(939,891122400,5),(939,909266400,4),(939,922572000,5),(939,941320800,4),(939,954021600,5),(939,972770400,4),(939,985471200,5),(939,1004220000,4),(939,1017525600,5),(939,1035669600,4),(939,1048975200,5),(939,1067119200,4),(939,1080424800,5),(939,1099173600,4),(939,1111874400,5),(939,1130623200,4),(939,1143324000,5),(939,1162072800,4),(939,1174773600,5),(939,1193522400,4),(939,1206828000,5),(939,1224972000,4),(939,1238277600,5),(939,1256421600,4),(939,1269727200,5),(939,1288476000,4),(939,1293825600,3),(939,1301176800,5),(939,1319925600,4),(939,2147483647,4),(940,-2147483648,1),(940,-1830376800,6),(940,-1689548400,2),(940,-1677794400,3),(940,-1667430000,4),(940,-1647730800,5),(940,-1635807600,4),(940,-1616194800,5),(940,-1604358000,4),(940,-1584658800,5),(940,-1572735600,4),(940,-1553036400,5),(940,-1541199600,4),(940,-1521500400,5),(940,-1442444400,4),(940,-1426806000,5),(940,-1379286000,4),(940,-1364770800,5),(940,-1348441200,4),(940,-1333321200,5),(940,-1316386800,4),(940,-1301266800,5),(940,-1284332400,4),(940,-1269817200,5),(940,-1221433200,4),(940,-1206918000,5),(940,-1191193200,4),(940,-1175468400,5),(940,-1127689200,4),(940,-1111964400,5),(940,-1096844400,4),(940,-1080514800,5),(940,-1063580400,4),(940,-1049065200,5),(940,-1033340400,4),(940,-1017615600,5),(940,-1002495600,4),(940,-986166000,5),(940,-969231600,4),(940,-950482800,5),(940,-942015600,4),(940,-922662000,5),(940,-906937200,4),(940,-891126000,5),(940,-877302000,4),(940,-873676800,7),(940,-864000000,4),(940,-857948400,5),(940,-845852400,4),(940,-842832000,7),(940,-831340800,4),(940,-825894000,5),(940,-814402800,4),(940,-810777600,7),(940,-799891200,4),(940,-794444400,5),(940,-782953200,4),(940,-779328000,7),(940,-768441600,4),(940,-762994800,5),(940,-749084400,4),(940,-733359600,5),(940,-717624000,4),(940,-701899200,5),(940,-686174400,4),(940,-670449600,5),(940,-654724800,4),(940,-639000000,5),(940,-591825600,4),(940,-575496000,5),(940,-559771200,4),(940,-544046400,5),(940,-528321600,4),(940,-512596800,5),(940,-496872000,4),(940,-481147200,5),(940,-465422400,4),(940,-449697600,5),(940,-433972800,4),(940,-417643200,5),(940,-401918400,4),(940,-386193600,5),(940,-370468800,4),(940,-354744000,5),(940,-339019200,4),(940,-323294400,5),(940,-307569600,4),(940,-291844800,5),(940,-276120000,4),(940,-260395200,5),(940,-244670400,4),(940,-228340800,5),(940,-212616000,4),(940,-196891200,5),(940,-181166400,4),(940,-165441600,5),(940,-149716800,4),(940,-133992000,5),(940,-118267200,9),(940,228272400,7),(940,243997200,8),(940,260326800,7),(940,276051600,8),(940,291776400,7),(940,307504800,8),(940,323226000,7),(940,338954400,8),(940,354679200,7),(940,370404000,8),(940,386128800,7),(940,401853600,8),(940,417582000,7),(940,433303200,8),(940,449028000,7),(940,465357600,8),(940,481082400,7),(940,496807200,8),(940,512532000,7),(940,528256800,8),(940,543981600,7),(940,559706400,8),(940,575431200,7),(940,591156000,8),(940,606880800,7),(940,622605600,8),(940,638330400,7),(940,654660000,8),(940,670384800,7),(940,686109600,8),(940,701834400,7),(940,717559200,10),(940,733280400,11),(940,749005200,12),(940,764730000,11),(940,780454800,12),(940,796179600,11),(940,811904400,12),(940,828234000,11),(940,846378000,12),(940,859683600,11),(940,877827600,12),(940,891133200,11),(940,909277200,12),(940,922582800,11),(940,941331600,12),(940,954032400,11),(940,972781200,12),(940,985482000,11),(940,1004230800,12),(940,1017536400,11),(940,1035680400,12),(940,1048986000,11),(940,1067130000,12),(940,1080435600,11),(940,1099184400,12),(940,1111885200,11),(940,1130634000,12),(940,1143334800,11),(940,1162083600,12),(940,1174784400,11),(940,1193533200,12),(940,1206838800,11),(940,1224982800,12),(940,1238288400,11),(940,1256432400,12),(940,1269738000,11),(940,1288486800,12),(940,1301187600,11),(940,1319936400,12),(940,1332637200,11),(940,1351386000,12),(940,1364691600,11),(940,1382835600,12),(940,1396141200,11),(940,1414285200,12),(940,1427590800,11),(940,1445734800,12),(940,1459040400,11),(940,1477789200,12),(940,1490490000,11),(940,1509238800,12),(940,1521939600,11),(940,1540688400,12),(940,1553994000,11),(940,1572138000,12),(940,1585443600,11),(940,1603587600,12),(940,1616893200,11),(940,1635642000,12),(940,1648342800,11),(940,1667091600,12),(940,1679792400,11),(940,1698541200,12),(940,1711846800,11),(940,1729990800,12),(940,1743296400,11),(940,1761440400,12),(940,1774746000,11),(940,1792890000,12),(940,1806195600,11),(940,1824944400,12),(940,1837645200,11),(940,1856394000,12),(940,1869094800,11),(940,1887843600,12),(940,1901149200,11),(940,1919293200,12),(940,1932598800,11),(940,1950742800,12),(940,1964048400,11),(940,1982797200,12),(940,1995498000,11),(940,2014246800,12),(940,2026947600,11),(940,2045696400,12),(940,2058397200,11),(940,2077146000,12),(940,2090451600,11),(940,2108595600,12),(940,2121901200,11),(940,2140045200,12),(940,2147483647,12),(941,-2147483648,0),(941,-1262281242,1),(941,136360800,2),(941,152082000,1),(941,167810400,2),(941,183531600,1),(941,199260000,2),(941,215586000,1),(941,230709600,2),(941,247035600,1),(941,262764000,2),(941,278485200,1),(941,294213600,2),(941,309934800,1),(941,325663200,2),(941,341384400,1),(941,357112800,2),(941,372834000,1),(941,388562400,2),(941,404888400,1),(941,420012000,2),(941,436338000,1),(941,452066400,2),(941,467787600,1),(941,483516000,2),(941,499237200,1),(941,514965600,2),(941,530686800,1),(941,544600800,2),(941,562136400,1),(941,576050400,2),(941,594190800,1),(941,607500000,2),(941,625640400,1),(941,638949600,2),(941,657090000,1),(941,671004000,2),(941,688539600,1),(941,702453600,2),(941,719989200,1),(941,733903200,2),(941,752043600,1),(941,765352800,2),(941,783493200,1),(941,796802400,2),(941,814942800,1),(941,828856800,2),(941,846392400,1),(941,860306400,2),(941,877842000,1),(941,891756000,2),(941,909291600,1),(941,923205600,2),(941,941346000,1),(941,954655200,2),(941,972795600,1),(941,986104800,2),(941,1004245200,1),(941,1018159200,2),(941,1035694800,1),(941,1049608800,2),(941,1067144400,1),(941,1081058400,2),(941,1099198800,1),(941,1112508000,2),(941,1130648400,1),(941,1143957600,2),(941,1162098000,1),(941,1173592800,2),(941,1194152400,1),(941,1205042400,2),(941,1225602000,1),(941,1236492000,2),(941,1257051600,1),(941,1268546400,2),(941,1289106000,1),(941,1299996000,2),(941,1320555600,1),(941,1331445600,2),(941,1352005200,1),(941,1362895200,2),(941,1383454800,1),(941,1394344800,2),(941,1414904400,1),(941,1425794400,2),(941,1446354000,1),(941,1457848800,2),(941,1478408400,1),(941,1489298400,2),(941,1509858000,1),(941,1520748000,2),(941,1541307600,1),(941,1552197600,2),(941,1572757200,1),(941,1583647200,2),(941,1604206800,1),(941,1615701600,2),(941,1636261200,1),(941,1647151200,2),(941,1667710800,1),(941,1678600800,2),(941,1699160400,1),(941,1710050400,2),(941,1730610000,1),(941,1741500000,2),(941,1762059600,1),(941,1772949600,2),(941,1793509200,1),(941,1805004000,2),(941,1825563600,1),(941,1836453600,2),(941,1857013200,1),(941,1867903200,2),(941,1888462800,1),(941,1899352800,2),(941,1919912400,1),(941,1930802400,2),(941,1951362000,1),(941,1962856800,2),(941,1983416400,1),(941,1994306400,2),(941,2014866000,1),(941,2025756000,2),(941,2046315600,1),(941,2057205600,2),(941,2077765200,1),(941,2088655200,2),(941,2109214800,1),(941,2120104800,2),(941,2140664400,1),(942,-2147483648,0),(942,-1509663504,1),(942,-733874400,2),(942,323827200,3),(942,338950800,4),(942,354675600,5),(942,370400400,4),(942,386125200,5),(942,401850000,4),(942,417574800,5),(942,433299600,4),(942,449024400,5),(942,465354000,4),(942,481078800,5),(942,496803600,4),(942,512528400,5),(942,528253200,4),(942,543978000,5),(942,559702800,4),(942,575427600,5),(942,591152400,4),(942,606877200,5),(942,622602000,4),(942,638326800,5),(942,654656400,4),(942,670381200,5),(942,686106000,4),(942,701830800,5),(942,717555600,4),(942,733280400,5),(942,749005200,4),(942,764730000,5),(942,780454800,4),(942,796179600,5),(942,811904400,4),(942,828234000,5),(942,846378000,4),(942,859683600,5),(942,877827600,4),(942,891133200,5),(942,909277200,4),(942,922582800,5),(942,941331600,4),(942,954032400,5),(942,972781200,4),(942,985482000,5),(942,1004230800,4),(942,1017536400,5),(942,1035680400,4),(942,1048986000,5),(942,1067130000,4),(942,1080435600,5),(942,1099184400,4),(942,1111885200,5),(942,1130634000,4),(942,1143334800,5),(942,1162083600,4),(942,1174784400,5),(942,1193533200,4),(942,1206838800,5),(942,1224982800,4),(942,1238288400,5),(942,1256432400,4),(942,1269738000,5),(942,1288486800,4),(942,1301187600,5),(942,1319936400,4),(942,1332637200,5),(942,1351386000,4),(942,1364691600,5),(942,1382835600,4),(942,1396141200,5),(942,1414285200,4),(942,1427590800,5),(942,1445734800,4),(942,1459040400,5),(942,1477789200,4),(942,1490490000,5),(942,1509238800,4),(942,1521939600,5),(942,1540688400,4),(942,1553994000,5),(942,1572138000,4),(942,1585443600,5),(942,1603587600,4),(942,1616893200,5),(942,1635642000,4),(942,1648342800,5),(942,1667091600,4),(942,1679792400,5),(942,1698541200,4),(942,1711846800,5),(942,1729990800,4),(942,1743296400,5),(942,1761440400,4),(942,1774746000,5),(942,1792890000,4),(942,1806195600,5),(942,1824944400,4),(942,1837645200,5),(942,1856394000,4),(942,1869094800,5),(942,1887843600,4),(942,1901149200,5),(942,1919293200,4),(942,1932598800,5),(942,1950742800,4),(942,1964048400,5),(942,1982797200,4),(942,1995498000,5),(942,2014246800,4),(942,2026947600,5),(942,2045696400,4),(942,2058397200,5),(942,2077146000,4),(942,2090451600,5),(942,2108595600,4),(942,2121901200,5),(942,2140045200,4),(943,-2147483648,0),(943,-1830376800,1),(943,-862610400,2),(943,-764118000,3),(943,186120000,4),(943,2147483647,4),(944,-2147483648,0),(944,-1955748776,1),(944,354675600,2),(944,370400400,3),(944,386125200,2),(944,401850000,3),(944,417574800,2),(944,433299600,3),(944,449024400,2),(944,465354000,3),(944,481078800,2),(944,496803600,3),(944,512528400,2),(944,528253200,3),(944,543978000,2),(944,559702800,3),(944,575427600,2),(944,591152400,3),(944,606877200,2),(944,622602000,3),(944,638326800,2),(944,654656400,3),(944,670381200,2),(944,686106000,3),(944,701830800,2),(944,717555600,3),(944,733280400,2),(944,749005200,3),(944,764730000,2),(944,780454800,3),(944,796179600,2),(944,811904400,3),(944,828234000,2),(944,846378000,3),(944,859683600,2),(944,877827600,3),(944,891133200,2),(944,909277200,3),(944,922582800,2),(944,941331600,3),(944,954032400,2),(944,972781200,3),(944,985482000,2),(944,1004230800,3),(944,1017536400,2),(944,1035680400,3),(944,1048986000,2),(944,1067130000,3),(944,1080435600,2),(944,1099184400,3),(944,1111885200,2),(944,1130634000,3),(944,1143334800,2),(944,1162083600,3),(944,1174784400,2),(944,1193533200,3),(944,1206838800,2),(944,1224982800,3),(944,1238288400,2),(944,1256432400,3),(944,1269738000,2),(944,1288486800,3),(944,1301187600,2),(944,1319936400,3),(944,1332637200,2),(944,1351386000,3),(944,1364691600,2),(944,1382835600,3),(944,1396141200,2),(944,1414285200,3),(944,1427590800,2),(944,1445734800,3),(944,1459040400,2),(944,1477789200,3),(944,1490490000,2),(944,1509238800,3),(944,1521939600,2),(944,1540688400,3),(944,1553994000,2),(944,1572138000,3),(944,1585443600,2),(944,1603587600,3),(944,1616893200,2),(944,1635642000,3),(944,1648342800,2),(944,1667091600,3),(944,1679792400,2),(944,1698541200,3),(944,1711846800,2),(944,1729990800,3),(944,1743296400,2),(944,1761440400,3),(944,1774746000,2),(944,1792890000,3),(944,1806195600,2),(944,1824944400,3),(944,1837645200,2),(944,1856394000,3),(944,1869094800,2),(944,1887843600,3),(944,1901149200,2),(944,1919293200,3),(944,1932598800,2),(944,1950742800,3),(944,1964048400,2),(944,1982797200,3),(944,1995498000,2),(944,2014246800,3),(944,2026947600,2),(944,2045696400,3),(944,2058397200,2),(944,2077146000,3),(944,2090451600,2),(944,2108595600,3),(944,2121901200,2),(944,2140045200,3),(945,-2147483648,0),(945,-1955748776,1),(945,354675600,2),(945,370400400,3),(945,386125200,2),(945,401850000,3),(945,417574800,2),(945,433299600,3),(945,449024400,2),(945,465354000,3),(945,481078800,2),(945,496803600,3),(945,512528400,2),(945,528253200,3),(945,543978000,2),(945,559702800,3),(945,575427600,2),(945,591152400,3),(945,606877200,2),(945,622602000,3),(945,638326800,2),(945,654656400,3),(945,670381200,2),(945,686106000,3),(945,701830800,2),(945,717555600,3),(945,733280400,2),(945,749005200,3),(945,764730000,2),(945,780454800,3),(945,796179600,2),(945,811904400,3),(945,828234000,2),(945,846378000,3),(945,859683600,2),(945,877827600,3),(945,891133200,2),(945,909277200,3),(945,922582800,2),(945,941331600,3),(945,954032400,2),(945,972781200,3),(945,985482000,2),(945,1004230800,3),(945,1017536400,2),(945,1035680400,3),(945,1048986000,2),(945,1067130000,3),(945,1080435600,2),(945,1099184400,3),(945,1111885200,2),(945,1130634000,3),(945,1143334800,2),(945,1162083600,3),(945,1174784400,2),(945,1193533200,3),(945,1206838800,2),(945,1224982800,3),(945,1238288400,2),(945,1256432400,3),(945,1269738000,2),(945,1288486800,3),(945,1301187600,2),(945,1319936400,3),(945,1332637200,2),(945,1351386000,3),(945,1364691600,2),(945,1382835600,3),(945,1396141200,2),(945,1414285200,3),(945,1427590800,2),(945,1445734800,3),(945,1459040400,2),(945,1477789200,3),(945,1490490000,2),(945,1509238800,3),(945,1521939600,2),(945,1540688400,3),(945,1553994000,2),(945,1572138000,3),(945,1585443600,2),(945,1603587600,3),(945,1616893200,2),(945,1635642000,3),(945,1648342800,2),(945,1667091600,3),(945,1679792400,2),(945,1698541200,3),(945,1711846800,2),(945,1729990800,3),(945,1743296400,2),(945,1761440400,3),(945,1774746000,2),(945,1792890000,3),(945,1806195600,2),(945,1824944400,3),(945,1837645200,2),(945,1856394000,3),(945,1869094800,2),(945,1887843600,3),(945,1901149200,2),(945,1919293200,3),(945,1932598800,2),(945,1950742800,3),(945,1964048400,2),(945,1982797200,3),(945,1995498000,2),(945,2014246800,3),(945,2026947600,2),(945,2045696400,3),(945,2058397200,2),(945,2077146000,3),(945,2090451600,2),(945,2108595600,3),(945,2121901200,2),(945,2140045200,3),(946,-2147483648,2),(946,-1691884800,1),(946,-1680573600,2),(946,-927511200,1),(946,-857257200,3),(946,-844556400,4),(946,-828226800,3),(946,-812502000,4),(946,-796777200,3),(946,-781052400,4),(946,-765327600,3),(946,-340844400,4),(946,-324514800,3),(946,-308790000,4),(946,-293065200,3),(946,-277340400,4),(946,-261615600,3),(946,-245890800,4),(946,-230166000,3),(946,-214441200,4),(946,-198716400,3),(946,-182991600,4),(946,-166662000,3),(946,-147913200,4),(946,-135212400,3),(946,315529200,2),(946,323830800,5),(946,338950800,6),(946,354675600,5),(946,370400400,6),(946,386125200,5),(946,401850000,6),(946,417574800,5),(946,433299600,6),(946,449024400,5),(946,465354000,6),(946,481078800,5),(946,496803600,6),(946,512528400,5),(946,528253200,6),(946,543978000,5),(946,559702800,6),(946,575427600,5),(946,591152400,6),(946,606877200,5),(946,622602000,6),(946,638326800,5),(946,654656400,6),(946,670381200,5),(946,686106000,6),(946,701830800,5),(946,717555600,6),(946,733280400,5),(946,749005200,6),(946,764730000,5),(946,780454800,6),(946,796179600,5),(946,811904400,6),(946,828234000,5),(946,846378000,6),(946,859683600,5),(946,877827600,6),(946,891133200,5),(946,909277200,6),(946,922582800,5),(946,941331600,6),(946,954032400,5),(946,972781200,6),(946,985482000,5),(946,1004230800,6),(946,1017536400,5),(946,1035680400,6),(946,1048986000,5),(946,1067130000,6),(946,1080435600,5),(946,1099184400,6),(946,1111885200,5),(946,1130634000,6),(946,1143334800,5),(946,1162083600,6),(946,1174784400,5),(946,1193533200,6),(946,1206838800,5),(946,1224982800,6),(946,1238288400,5),(946,1256432400,6),(946,1269738000,5),(946,1288486800,6),(946,1301187600,5),(946,1319936400,6),(946,1332637200,5),(946,1351386000,6),(946,1364691600,5),(946,1382835600,6),(946,1396141200,5),(946,1414285200,6),(946,1427590800,5),(946,1445734800,6),(946,1459040400,5),(946,1477789200,6),(946,1490490000,5),(946,1509238800,6),(946,1521939600,5),(946,1540688400,6),(946,1553994000,5),(946,1572138000,6),(946,1585443600,5),(946,1603587600,6),(946,1616893200,5),(946,1635642000,6),(946,1648342800,5),(946,1667091600,6),(946,1679792400,5),(946,1698541200,6),(946,1711846800,5),(946,1729990800,6),(946,1743296400,5),(946,1761440400,6),(946,1774746000,5),(946,1792890000,6),(946,1806195600,5),(946,1824944400,6),(946,1837645200,5),(946,1856394000,6),(946,1869094800,5),(946,1887843600,6),(946,1901149200,5),(946,1919293200,6),(946,1932598800,5),(946,1950742800,6),(946,1964048400,5),(946,1982797200,6),(946,1995498000,5),(946,2014246800,6),(946,2026947600,5),(946,2045696400,6),(946,2058397200,5),(946,2077146000,6),(946,2090451600,5),(946,2108595600,6),(946,2121901200,5),(946,2140045200,6),(947,-2147483648,1),(947,-1830380400,6),(947,-1689552000,2),(947,-1677798000,3),(947,-1667433600,4),(947,-1647734400,5),(947,-1635811200,4),(947,-1616198400,5),(947,-1604361600,4),(947,-1584662400,5),(947,-1572739200,4),(947,-1553040000,5),(947,-1541203200,4),(947,-1521504000,5),(947,-1442448000,4),(947,-1426809600,5),(947,-1379289600,4),(947,-1364774400,5),(947,-1348444800,4),(947,-1333324800,5),(947,-1316390400,4),(947,-1301270400,5),(947,-1284336000,4),(947,-1269820800,5),(947,-1221436800,4),(947,-1206921600,5),(947,-1191196800,4),(947,-1175472000,5),(947,-1127692800,4),(947,-1111968000,5),(947,-1096848000,4),(947,-1080518400,5),(947,-1063584000,4),(947,-1049068800,5),(947,-1033344000,4),(947,-1017619200,5),(947,-1002499200,4),(947,-986169600,5),(947,-969235200,4),(947,-950486400,5),(947,-942019200,4),(947,-922665600,5),(947,-906940800,4),(947,-891129600,5),(947,-877305600,4),(947,-873680400,7),(947,-864003600,4),(947,-857952000,5),(947,-845856000,4),(947,-842835600,7),(947,-831344400,4),(947,-825897600,5),(947,-814406400,4),(947,-810781200,7),(947,-799894800,4),(947,-794448000,5),(947,-782956800,4),(947,-779331600,7),(947,-768445200,4),(947,-762998400,5),(947,-749088000,4),(947,-733363200,5),(947,-717627600,4),(947,-701902800,5),(947,-686178000,4),(947,-670453200,5),(947,-654728400,4),(947,-639003600,5),(947,-591829200,4),(947,-575499600,5),(947,-559774800,4),(947,-544050000,5),(947,-528325200,4),(947,-512600400,5),(947,-496875600,4),(947,-481150800,5),(947,-465426000,4),(947,-449701200,5),(947,-433976400,4),(947,-417646800,5),(947,-401922000,4),(947,-386197200,5),(947,-370472400,4),(947,-354747600,5),(947,-339022800,4),(947,-323298000,5),(947,-307573200,4),(947,-291848400,5),(947,-276123600,4),(947,-260398800,5),(947,-244674000,4),(947,-228344400,5),(947,-212619600,4),(947,-196894800,5),(947,-181170000,4),(947,-165445200,5),(947,-149720400,4),(947,-133995600,5),(947,-118270800,10),(947,228268800,8),(947,243993600,9),(947,260323200,8),(947,276048000,9),(947,291772800,8),(947,307501200,9),(947,323222400,8),(947,338950800,9),(947,354675600,8),(947,370400400,9),(947,386125200,8),(947,401850000,9),(947,417578400,8),(947,433299600,11),(947,449024400,12),(947,465354000,11),(947,481078800,12),(947,496803600,11),(947,512528400,12),(947,528253200,11),(947,543978000,12),(947,559702800,11),(947,575427600,12),(947,591152400,11),(947,606877200,12),(947,622602000,11),(947,638326800,12),(947,654656400,11),(947,670381200,12),(947,686106000,11),(947,701830800,12),(947,717555600,11),(947,733280400,12),(947,749005200,11),(947,764730000,12),(947,780454800,11),(947,796179600,12),(947,811904400,11),(947,828234000,12),(947,846378000,11),(947,859683600,12),(947,877827600,11),(947,891133200,12),(947,909277200,11),(947,922582800,12),(947,941331600,11),(947,954032400,12),(947,972781200,11),(947,985482000,12),(947,1004230800,11),(947,1017536400,12),(947,1035680400,11),(947,1048986000,12),(947,1067130000,11),(947,1080435600,12),(947,1099184400,11),(947,1111885200,12),(947,1130634000,11),(947,1143334800,12),(947,1162083600,11),(947,1174784400,12),(947,1193533200,11),(947,1206838800,12),(947,1224982800,11),(947,1238288400,12),(947,1256432400,11),(947,1269738000,12),(947,1288486800,11),(947,1301187600,12),(947,1319936400,11),(947,1332637200,12),(947,1351386000,11),(947,1364691600,12),(947,1382835600,11),(947,1396141200,12),(947,1414285200,11),(947,1427590800,12),(947,1445734800,11),(947,1459040400,12),(947,1477789200,11),(947,1490490000,12),(947,1509238800,11),(947,1521939600,12),(947,1540688400,11),(947,1553994000,12),(947,1572138000,11),(947,1585443600,12),(947,1603587600,11),(947,1616893200,12),(947,1635642000,11),(947,1648342800,12),(947,1667091600,11),(947,1679792400,12),(947,1698541200,11),(947,1711846800,12),(947,1729990800,11),(947,1743296400,12),(947,1761440400,11),(947,1774746000,12),(947,1792890000,11),(947,1806195600,12),(947,1824944400,11),(947,1837645200,12),(947,1856394000,11),(947,1869094800,12),(947,1887843600,11),(947,1901149200,12),(947,1919293200,11),(947,1932598800,12),(947,1950742800,11),(947,1964048400,12),(947,1982797200,11),(947,1995498000,12),(947,2014246800,11),(947,2026947600,12),(947,2045696400,11),(947,2058397200,12),(947,2077146000,11),(947,2090451600,12),(947,2108595600,11),(947,2121901200,12),(947,2140045200,11),(948,-2147483648,0),(948,-1956609120,2),(948,-1668211200,1),(948,-1647212400,2),(948,-1636675200,1),(948,-1613430000,2),(948,-1605139200,1),(948,-1581894000,2),(948,-1539561600,1),(948,-1531350000,2),(948,-968025600,1),(948,-952293600,2),(948,-942008400,1),(948,-920239200,3),(948,-909957600,4),(948,-888789600,3),(948,-877903200,4),(948,-857944800,3),(948,-846453600,4),(948,-826495200,3),(948,-815004000,4),(948,-795045600,3),(948,-783554400,4),(948,-762991200,3),(948,-752104800,4),(948,-731541600,3),(948,-717631200,4),(948,-700092000,3),(948,-686181600,4),(948,-668642400,3),(948,-654732000,4),(948,-636588000,3),(948,-623282400,4),(948,-605743200,3),(948,-591832800,4),(948,-573688800,3),(948,-559778400,4),(948,-542239200,3),(948,-528328800,4),(948,-510789600,3),(948,-496879200,4),(948,-479340000,3),(948,-465429600,4),(948,-447890400,3),(948,-433980000,4),(948,-415836000,3),(948,-401925600,4),(948,-384386400,3),(948,-370476000,4),(948,-352936800,3),(948,-339026400,4),(948,-321487200,3),(948,-307576800,4),(948,-290037600,3),(948,-276127200,4),(948,-258588000,3),(948,-244677600,4),(948,-226533600,3),(948,-212623200,4),(948,-195084000,3),(948,-181173600,4),(948,-163634400,3),(948,-149724000,4),(948,-132184800,3),(948,-118274400,4),(948,-100735200,3),(948,-86824800,4),(948,-68680800,3),(948,-54770400,5),(949,-2147483648,1),(949,2147483647,1),(950,-2147483648,0),(950,-1830383032,1),(951,-2147483648,1),(951,-1824235716,3),(951,-1018209600,2),(951,-1003093200,3),(951,-986760000,2),(951,-971643600,3),(951,-954705600,2),(951,-939589200,3),(951,-923256000,2),(951,-908139600,3),(951,-891806400,2),(951,-876690000,3),(951,-860356800,2),(951,-852066000,3),(951,420609600,5),(951,433306800,4),(951,452052000,5),(951,464151600,4),(951,483501600,5),(951,495601200,2),(951,514350000,3),(951,527054400,2),(951,545799600,3),(951,558504000,2),(951,577249200,3),(951,589953600,2),(951,608698800,3),(951,621403200,2),(951,640753200,3),(951,652852800,2),(951,672202800,3),(951,684907200,2),(951,703652400,3),(951,716356800,2),(951,735102000,3),(951,747806400,2),(951,766551600,3),(951,779256000,2),(951,798001200,3),(951,810705600,2),(951,830055600,3),(951,842760000,2),(951,861505200,3),(951,874209600,2),(951,892954800,3),(951,905659200,2),(951,924404400,3),(951,937108800,2),(951,955854000,3),(951,968558400,2),(951,987310800,3),(951,999410400,2),(951,1019365200,3),(951,1030860000,2),(951,1050814800,3),(951,1062914400,2),(951,1082264400,3),(951,1094364000,2),(951,1113714000,3),(951,1125813600,2),(951,1145163600,3),(951,1157263200,2),(951,1176613200,3),(951,1188712800,2),(951,1208667600,3),(951,1220767200,2),(951,1240117200,3),(951,1252216800,2),(951,1271566800,3),(951,1283666400,5),(951,2147483647,5),(952,-2147483648,2),(952,-1672567140,1),(952,-1665392400,2),(952,-883641600,1),(952,-876128400,2),(952,-860400000,1),(952,-844678800,2),(952,-828345600,1),(952,-813229200,2),(952,57686400,3),(952,67968000,4),(952,89136000,3),(952,100022400,4),(952,120585600,3),(952,131472000,4),(952,152035200,3),(952,162921600,4),(952,183484800,3),(952,194976000,4),(952,215539200,3),(952,226425600,4),(952,246988800,3),(952,257875200,4),(952,278438400,3),(952,289324800,4),(952,309888000,3),(952,320774400,4),(952,341337600,3),(952,352224000,4),(952,372787200,3),(952,386697600,4),(952,404841600,3),(952,415728000,4),(952,436291200,3),(952,447177600,4),(952,467740800,3),(952,478627200,4),(952,499190400,3),(952,511286400,4),(952,530035200,3),(952,542736000,4),(952,562089600,3),(952,574790400,4),(952,594144000,3),(952,606240000,4),(952,625593600,3),(952,636480000,4),(952,657043200,3),(952,667929600,4),(952,688492800,3),(952,699379200,4),(952,719942400,3),(952,731433600,4),(952,751996800,3),(952,762883200,4),(952,783446400,3),(952,794332800,4),(952,814896000,3),(952,828201600,4),(952,846345600,3),(952,859651200,4),(952,877795200,3),(952,891100800,4),(952,909244800,3),(952,922550400,4),(952,941299200,3),(952,954000000,4),(952,967305600,3),(952,985449600,4),(952,1004198400,3),(952,1017504000,4),(952,1035648000,3),(952,1048953600,4),(952,1067097600,3),(952,1080403200,4),(952,1099152000,3),(952,1111852800,4),(952,1130601600,3),(952,1143907200,4),(952,1162051200,3),(952,1174752000,4),(952,1193500800,3),(952,1207411200,4),(952,1223136000,3),(952,1238860800,4),(952,1254585600,3),(952,1270310400,4),(952,1286035200,3),(952,1301760000,4),(952,1317484800,3),(952,1333209600,4),(952,1349539200,3),(952,1365264000,4),(952,1380988800,3),(952,1396713600,4),(952,1412438400,3),(952,1428163200,4),(952,1443888000,3),(952,1459612800,4),(952,1475337600,3),(952,1491062400,4),(952,1506787200,3),(952,1522512000,4),(952,1538841600,3),(952,1554566400,4),(952,1570291200,3),(952,1586016000,4),(952,1601740800,3),(952,1617465600,4),(952,1633190400,3),(952,1648915200,4),(952,1664640000,3),(952,1680364800,4),(952,1696089600,3),(952,1712419200,4),(952,1728144000,3),(952,1743868800,4),(952,1759593600,3),(952,1775318400,4),(952,1791043200,3),(952,1806768000,4),(952,1822492800,3),(952,1838217600,4),(952,1853942400,3),(952,1869667200,4),(952,1885996800,3),(952,1901721600,4),(952,1917446400,3),(952,1933171200,4),(952,1948896000,3),(952,1964620800,4),(952,1980345600,3),(952,1996070400,4),(952,2011795200,3),(952,2027520000,4),(952,2043244800,3),(952,2058969600,4),(952,2075299200,3),(952,2091024000,4),(952,2106748800,3),(952,2122473600,4),(952,2138198400,3),(953,-2147483648,2),(953,-1672565340,1),(953,-1665390600,2),(953,-883639800,1),(953,-876126600,2),(953,-860398200,1),(953,-844677000,2),(953,-828343800,1),(953,-813227400,2),(953,57688200,3),(953,67969800,4),(953,89137800,3),(953,100024200,4),(953,120587400,3),(953,131473800,4),(953,152037000,3),(953,162923400,4),(953,183486600,3),(953,194977800,4),(953,215541000,3),(953,226427400,4),(953,246990600,3),(953,257877000,4),(953,278440200,3),(953,289326600,4),(953,309889800,3),(953,320776200,4),(953,341339400,3),(953,352225800,4),(953,372789000,3),(953,384280200,4),(953,404843400,3),(953,415729800,4),(953,436293000,3),(953,447179400,4),(953,467742600,3),(953,478629000,4),(953,499192200,3),(953,511288200,4),(953,530037000,3),(953,542737800,4),(953,562091400,3),(953,574792200,4),(953,594145800,3),(953,606241800,4),(953,625595400,3),(953,637691400,4),(953,657045000,3),(953,667931400,4),(953,688494600,3),(953,701195400,4),(953,719944200,3),(953,731435400,4),(953,751998600,3),(953,764094600,4),(953,783448200,3),(953,796149000,4),(953,814897800,3),(953,828203400,4),(953,846347400,3),(953,859653000,4),(953,877797000,3),(953,891102600,4),(953,909246600,3),(953,922552200,4),(953,941301000,3),(953,954001800,4),(953,972750600,3),(953,985451400,4),(953,1004200200,3),(953,1017505800,4),(953,1035649800,3),(953,1048955400,4),(953,1067099400,3),(953,1080405000,4),(953,1099153800,3),(953,1111854600,4),(953,1130603400,3),(953,1143909000,4),(953,1162053000,3),(953,1174753800,4),(953,1193502600,3),(953,1207413000,4),(953,1223137800,3),(953,1238862600,4),(953,1254587400,3),(953,1270312200,4),(953,1286037000,3),(953,1301761800,4),(953,1317486600,3),(953,1333211400,4),(953,1349541000,3),(953,1365265800,4),(953,1380990600,3),(953,1396715400,4),(953,1412440200,3),(953,1428165000,4),(953,1443889800,3),(953,1459614600,4),(953,1475339400,3),(953,1491064200,4),(953,1506789000,3),(953,1522513800,4),(953,1538843400,3),(953,1554568200,4),(953,1570293000,3),(953,1586017800,4),(953,1601742600,3),(953,1617467400,4),(953,1633192200,3),(953,1648917000,4),(953,1664641800,3),(953,1680366600,4),(953,1696091400,3),(953,1712421000,4),(953,1728145800,3),(953,1743870600,4),(953,1759595400,3),(953,1775320200,4),(953,1791045000,3),(953,1806769800,4),(953,1822494600,3),(953,1838219400,4),(953,1853944200,3),(953,1869669000,4),(953,1885998600,3),(953,1901723400,4),(953,1917448200,3),(953,1933173000,4),(953,1948897800,3),(953,1964622600,4),(953,1980347400,3),(953,1996072200,4),(953,2011797000,3),(953,2027521800,4),(953,2043246600,3),(953,2058971400,4),(953,2075301000,3),(953,2091025800,4),(953,2106750600,3),(953,2122475400,4),(953,2138200200,3),(954,-2147483648,2),(954,-1672567140,1),(954,-1665392400,2),(954,-883641600,1),(954,-876128400,2),(954,-860400000,1),(954,-844678800,2),(954,-828345600,1),(954,-813229200,2),(954,57686400,3),(954,67968000,4),(954,625593600,3),(954,636480000,4),(954,657043200,3),(954,667929600,4),(954,688492800,3),(954,699379200,4),(955,-2147483648,2),(955,-1672565340,1),(955,-1665390600,2),(955,-883639800,1),(955,-876126600,2),(955,-860398200,1),(955,-844677000,2),(955,-828343800,1),(955,-813227400,2),(955,57688200,3),(955,67969800,4),(955,89137800,3),(955,100024200,4),(955,120587400,3),(955,131473800,4),(955,152037000,3),(955,162923400,4),(955,183486600,3),(955,194977800,4),(955,215541000,3),(955,226427400,4),(955,246990600,3),(955,257877000,4),(955,278440200,3),(955,289326600,4),(955,309889800,3),(955,320776200,4),(955,341339400,3),(955,352225800,4),(955,372789000,3),(955,386699400,4),(955,404843400,3),(955,415729800,4),(955,436293000,3),(955,447179400,4),(955,467742600,3),(955,478629000,4),(955,499192200,3),(955,511288200,4),(955,530037000,3),(955,542737800,4),(955,562091400,3),(955,574792200,4),(955,594145800,3),(955,606241800,4),(955,625595400,3),(955,636481800,4),(955,657045000,3),(955,667931400,4),(955,688494600,3),(955,699381000,4),(955,719944200,3),(955,731435400,4),(955,751998600,3),(955,762885000,4),(955,783448200,3),(955,794334600,4),(955,814897800,3),(955,828203400,4),(955,846347400,3),(955,859653000,4),(955,877797000,3),(955,891102600,4),(955,909246600,3),(955,922552200,4),(955,941301000,3),(955,946647000,1),(955,954001800,4),(955,972750600,3),(955,985451400,4),(955,1004200200,3),(955,1017505800,4),(955,1035649800,3),(955,1048955400,4),(955,1067099400,3),(955,1080405000,4),(955,1099153800,3),(955,1111854600,4),(955,1130603400,3),(955,1143909000,4),(955,1162053000,3),(955,1174753800,4),(955,1193502600,3),(955,1207413000,4),(955,1223137800,3),(955,1238862600,4),(955,1254587400,3),(955,1270312200,4),(955,1286037000,3),(955,1301761800,4),(955,1317486600,3),(955,1333211400,4),(955,1349541000,3),(955,1365265800,4),(955,1380990600,3),(955,1396715400,4),(955,1412440200,3),(955,1428165000,4),(955,1443889800,3),(955,1459614600,4),(955,1475339400,3),(955,1491064200,4),(955,1506789000,3),(955,1522513800,4),(955,1538843400,3),(955,1554568200,4),(955,1570293000,3),(955,1586017800,4),(955,1601742600,3),(955,1617467400,4),(955,1633192200,3),(955,1648917000,4),(955,1664641800,3),(955,1680366600,4),(955,1696091400,3),(955,1712421000,4),(955,1728145800,3),(955,1743870600,4),(955,1759595400,3),(955,1775320200,4),(955,1791045000,3),(955,1806769800,4),(955,1822494600,3),(955,1838219400,4),(955,1853944200,3),(955,1869669000,4),(955,1885998600,3),(955,1901723400,4),(955,1917448200,3),(955,1933173000,4),(955,1948897800,3),(955,1964622600,4),(955,1980347400,3),(955,1996072200,4),(955,2011797000,3),(955,2027521800,4),(955,2043246600,3),(955,2058971400,4),(955,2075301000,3),(955,2091025800,4),(955,2106750600,3),(955,2122475400,4),(955,2138200200,3),(956,-2147483648,2),(956,-1672567140,1),(956,-1665392400,2),(956,-883641600,1),(956,-876128400,2),(956,-860400000,1),(956,-844678800,2),(956,-828345600,1),(956,-813229200,2),(956,57686400,3),(956,67968000,4),(956,89136000,3),(956,100022400,4),(956,120585600,3),(956,131472000,4),(956,152035200,3),(956,162921600,4),(956,183484800,3),(956,194976000,4),(956,215539200,3),(956,226425600,4),(956,246988800,3),(956,257875200,4),(956,278438400,3),(956,289324800,4),(956,309888000,3),(956,320774400,4),(956,341337600,3),(956,352224000,4),(956,372787200,3),(956,386697600,4),(956,404841600,3),(956,415728000,4),(956,436291200,3),(956,447177600,4),(956,467740800,3),(956,478627200,4),(956,499190400,3),(956,511286400,4),(956,530035200,3),(956,542736000,4),(956,562089600,3),(956,574790400,4),(956,594144000,3),(956,606240000,4),(956,625593600,3),(956,636480000,4),(956,657043200,3),(956,667929600,4),(956,688492800,3),(956,699379200,4),(956,719942400,3),(956,731433600,4),(956,751996800,3),(956,762883200,4),(956,783446400,3),(956,794332800,4),(956,814896000,3),(956,828201600,4),(956,846345600,3),(956,859651200,4),(956,877795200,3),(956,891100800,4),(956,909244800,3),(956,922550400,4),(956,941299200,3),(956,954000000,4),(956,967305600,3),(956,985449600,4),(956,1004198400,3),(956,1017504000,4),(956,1035648000,3),(956,1048953600,4),(956,1067097600,3),(956,1080403200,4),(956,1099152000,3),(956,1111852800,4),(956,1130601600,3),(956,1143907200,4),(956,1162051200,3),(956,1174752000,4),(956,1193500800,3),(956,1207411200,4),(956,1223136000,3),(956,1238860800,4),(956,1254585600,3),(956,1270310400,4),(956,1286035200,3),(956,1301760000,4),(956,1317484800,3),(956,1333209600,4),(956,1349539200,3),(956,1365264000,4),(956,1380988800,3),(956,1396713600,4),(956,1412438400,3),(956,1428163200,4),(956,1443888000,3),(956,1459612800,4),(956,1475337600,3),(956,1491062400,4),(956,1506787200,3),(956,1522512000,4),(956,1538841600,3),(956,1554566400,4),(956,1570291200,3),(956,1586016000,4),(956,1601740800,3),(956,1617465600,4),(956,1633190400,3),(956,1648915200,4),(956,1664640000,3),(956,1680364800,4),(956,1696089600,3),(956,1712419200,4),(956,1728144000,3),(956,1743868800,4),(956,1759593600,3),(956,1775318400,4),(956,1791043200,3),(956,1806768000,4),(956,1822492800,3),(956,1838217600,4),(956,1853942400,3),(956,1869667200,4),(956,1885996800,3),(956,1901721600,4),(956,1917446400,3),(956,1933171200,4),(956,1948896000,3),(956,1964620800,4),(956,1980345600,3),(956,1996070400,4),(956,2011795200,3),(956,2027520000,4),(956,2043244800,3),(956,2058969600,4),(956,2075299200,3),(956,2091024000,4),(956,2106748800,3),(956,2122473600,4),(956,2138198400,3),(957,-2147483648,1),(957,-1680508800,2),(957,-1665392400,1),(957,-883641600,2),(957,-876128400,1),(957,-860400000,2),(957,-844678800,1),(957,-828345600,2),(957,-813229200,1),(957,57686400,3),(957,67968000,4),(957,89136000,3),(957,100022400,4),(957,120585600,3),(957,131472000,4),(957,152035200,3),(957,162921600,4),(957,183484800,3),(957,194976000,4),(957,215539200,3),(957,226425600,4),(957,246988800,3),(957,257875200,4),(957,278438400,3),(957,289324800,4),(957,309888000,3),(957,320774400,4),(957,341337600,3),(957,352224000,4),(957,372787200,3),(957,386092800,4),(957,404841600,3),(957,417542400,4),(957,436291200,3),(957,447177600,4),(957,467740800,3),(957,478627200,4),(957,499190400,3),(957,510076800,4),(957,530035200,3),(957,542736000,4),(957,562089600,3),(957,574790400,4),(957,594144000,3),(957,606240000,4),(957,625593600,3),(957,637689600,4),(957,657043200,3),(957,670348800,4),(957,686678400,3),(957,701798400,4),(957,718128000,3),(957,733248000,4),(957,749577600,3),(957,764697600,4),(957,781027200,3),(957,796147200,4),(957,812476800,3),(957,828201600,4),(957,844531200,3),(957,859651200,4),(957,875980800,3),(957,891100800,4),(957,907430400,3),(957,922550400,4),(957,938880000,3),(957,954000000,4),(957,967305600,3),(957,985449600,4),(957,1002384000,3),(957,1017504000,4),(957,1033833600,3),(957,1048953600,4),(957,1065283200,3),(957,1080403200,4),(957,1096732800,3),(957,1111852800,4),(957,1128182400,3),(957,1143907200,4),(957,1159632000,3),(957,1174752000,4),(957,1191686400,3),(957,1207411200,4),(957,1223136000,3),(957,1238860800,4),(957,1254585600,3),(957,1270310400,4),(957,1286035200,3),(957,1301760000,4),(957,1317484800,3),(957,1333209600,4),(957,1349539200,3),(957,1365264000,4),(957,1380988800,3),(957,1396713600,4),(957,1412438400,3),(957,1428163200,4),(957,1443888000,3),(957,1459612800,4),(957,1475337600,3),(957,1491062400,4),(957,1506787200,3),(957,1522512000,4),(957,1538841600,3),(957,1554566400,4),(957,1570291200,3),(957,1586016000,4),(957,1601740800,3),(957,1617465600,4),(957,1633190400,3),(957,1648915200,4),(957,1664640000,3),(957,1680364800,4),(957,1696089600,3),(957,1712419200,4),(957,1728144000,3),(957,1743868800,4),(957,1759593600,3),(957,1775318400,4),(957,1791043200,3),(957,1806768000,4),(957,1822492800,3),(957,1838217600,4),(957,1853942400,3),(957,1869667200,4),(957,1885996800,3),(957,1901721600,4),(957,1917446400,3),(957,1933171200,4),(957,1948896000,3),(957,1964620800,4),(957,1980345600,3),(957,1996070400,4),(957,2011795200,3),(957,2027520000,4),(957,2043244800,3),(957,2058969600,4),(957,2075299200,3),(957,2091024000,4),(957,2106748800,3),(957,2122473600,4),(957,2138198400,3),(958,-2147483648,2),(958,-1672565340,1),(958,-1665390600,2),(958,-883639800,1),(958,-876126600,2),(958,-860398200,1),(958,-844677000,2),(958,-828343800,1),(958,-813227400,2),(959,-2147483648,2),(959,-1672562640,1),(959,-1665387900,2),(959,-883637100,1),(959,-876123900,2),(959,-860395500,1),(959,-844674300,2),(959,152039700,3),(959,162926100,4),(959,436295700,3),(959,447182100,4),(959,690311700,3),(959,699383700,4),(959,1165079700,3),(959,1174756500,4),(959,1193505300,3),(959,1206810900,4),(959,1224954900,3),(959,1238260500,4),(959,2147483647,4),(960,-2147483648,1),(960,-1680508800,2),(960,-1665392400,1),(960,-883641600,2),(960,-876128400,1),(960,-860400000,2),(960,-844678800,1),(960,-828345600,2),(960,-813229200,1),(960,-71136000,3),(960,-55411200,4),(960,-37267200,3),(960,-25776000,4),(960,-5817600,3),(960,5673600,4),(960,25632000,3),(960,37728000,4),(960,57686400,3),(960,67968000,4),(960,89136000,3),(960,100022400,4),(960,120585600,3),(960,131472000,4),(960,152035200,3),(960,162921600,4),(960,183484800,3),(960,194976000,4),(960,215539200,3),(960,226425600,4),(960,246988800,3),(960,257875200,4),(960,278438400,3),(960,289324800,4),(960,309888000,3),(960,320774400,4),(960,341337600,3),(960,352224000,4),(960,372787200,3),(960,386092800,4),(960,404841600,3),(960,417542400,4),(960,436291200,3),(960,447177600,4),(960,467740800,3),(960,478627200,4),(960,499190400,3),(960,510076800,4),(960,530035200,3),(960,542736000,4),(960,562089600,3),(960,574790400,4),(960,594144000,3),(960,606240000,4),(960,625593600,3),(960,637689600,4),(960,657043200,3),(960,670348800,4),(960,686678400,3),(960,701798400,4),(960,718128000,3),(960,733248000,4),(960,749577600,3),(960,764697600,4),(960,781027200,3),(960,796147200,4),(960,812476800,3),(960,828201600,4),(960,844531200,3),(960,859651200,4),(960,875980800,3),(960,891100800,4),(960,907430400,3),(960,922550400,4),(960,938880000,3),(960,954000000,4),(960,967305600,3),(960,985449600,4),(960,1002384000,3),(960,1017504000,4),(960,1033833600,3),(960,1048953600,4),(960,1065283200,3),(960,1080403200,4),(960,1096732800,3),(960,1111852800,4),(960,1128182400,3),(960,1143907200,4),(960,1159632000,3),(960,1174752000,4),(960,1191686400,3),(960,1207411200,4),(960,1223136000,3),(960,1238860800,4),(960,1254585600,3),(960,1270310400,4),(960,1286035200,3),(960,1301760000,4),(960,1317484800,3),(960,1333209600,4),(960,1349539200,3),(960,1365264000,4),(960,1380988800,3),(960,1396713600,4),(960,1412438400,3),(960,1428163200,4),(960,1443888000,3),(960,1459612800,4),(960,1475337600,3),(960,1491062400,4),(960,1506787200,3),(960,1522512000,4),(960,1538841600,3),(960,1554566400,4),(960,1570291200,3),(960,1586016000,4),(960,1601740800,3),(960,1617465600,4),(960,1633190400,3),(960,1648915200,4),(960,1664640000,3),(960,1680364800,4),(960,1696089600,3),(960,1712419200,4),(960,1728144000,3),(960,1743868800,4),(960,1759593600,3),(960,1775318400,4),(960,1791043200,3),(960,1806768000,4),(960,1822492800,3),(960,1838217600,4),(960,1853942400,3),(960,1869667200,4),(960,1885996800,3),(960,1901721600,4),(960,1917446400,3),(960,1933171200,4),(960,1948896000,3),(960,1964620800,4),(960,1980345600,3),(960,1996070400,4),(960,2011795200,3),(960,2027520000,4),(960,2043244800,3),(960,2058969600,4),(960,2075299200,3),(960,2091024000,4),(960,2106748800,3),(960,2122473600,4),(960,2138198400,3),(961,-2147483648,1),(961,352216800,3),(961,372785400,2),(961,384273000,3),(961,404839800,2),(961,415722600,3),(961,436289400,2),(961,447172200,3),(961,467739000,2),(961,478621800,3),(961,499188600,4),(961,511282800,3),(961,530033400,4),(961,542732400,3),(961,562087800,4),(961,574786800,3),(961,594142200,4),(961,606236400,3),(961,625591800,4),(961,636476400,3),(961,657041400,4),(961,667926000,3),(961,688491000,4),(961,699375600,3),(961,719940600,4),(961,731430000,3),(961,751995000,4),(961,762879600,3),(961,783444600,4),(961,794329200,3),(961,814894200,4),(961,828198000,3),(961,846343800,4),(961,859647600,3),(961,877793400,4),(961,891097200,3),(961,909243000,4),(961,922546800,3),(961,941297400,4),(961,953996400,3),(961,967303800,4),(961,985446000,3),(961,1004196600,4),(961,1017500400,3),(961,1035646200,4),(961,1048950000,3),(961,1067095800,4),(961,1080399600,3),(961,1099150200,4),(961,1111849200,3),(961,1130599800,4),(961,1143903600,3),(961,1162049400,4),(961,1174748400,3),(961,1193499000,4),(961,1207407600,3),(961,1223134200,4),(961,1238857200,3),(961,1254583800,4),(961,1270306800,3),(961,1286033400,4),(961,1301756400,3),(961,1317483000,4),(961,1333206000,3),(961,1349537400,4),(961,1365260400,3),(961,1380987000,4),(961,1396710000,3),(961,1412436600,4),(961,1428159600,3),(961,1443886200,4),(961,1459609200,3),(961,1475335800,4),(961,1491058800,3),(961,1506785400,4),(961,1522508400,3),(961,1538839800,4),(961,1554562800,3),(961,1570289400,4),(961,1586012400,3),(961,1601739000,4),(961,1617462000,3),(961,1633188600,4),(961,1648911600,3),(961,1664638200,4),(961,1680361200,3),(961,1696087800,4),(961,1712415600,3),(961,1728142200,4),(961,1743865200,3),(961,1759591800,4),(961,1775314800,3),(961,1791041400,4),(961,1806764400,3),(961,1822491000,4),(961,1838214000,3),(961,1853940600,4),(961,1869663600,3),(961,1885995000,4),(961,1901718000,3),(961,1917444600,4),(961,1933167600,3),(961,1948894200,4),(961,1964617200,3),(961,1980343800,4),(961,1996066800,3),(961,2011793400,4),(961,2027516400,3),(961,2043243000,4),(961,2058966000,3),(961,2075297400,4),(961,2091020400,3),(961,2106747000,4),(961,2122470000,3),(961,2138196600,4),(961,2147483647,4),(962,-2147483648,2),(962,-1672567140,1),(962,-1665392400,2),(962,-883641600,1),(962,-876128400,2),(962,-860400000,1),(962,-844678800,2),(962,-828345600,1),(962,-813229200,2),(962,57686400,3),(962,67968000,4),(962,625593600,3),(962,636480000,4),(962,657043200,3),(962,667929600,4),(962,688492800,3),(962,699379200,4),(962,709912800,2),(962,719942400,3),(962,731433600,4),(962,751996800,3),(962,762883200,4),(963,-2147483648,1),(963,352216800,3),(963,372785400,2),(963,384273000,3),(963,404839800,2),(963,415722600,3),(963,436289400,2),(963,447172200,3),(963,467739000,2),(963,478621800,3),(963,499188600,4),(963,511282800,3),(963,530033400,4),(963,542732400,3),(963,562087800,4),(963,574786800,3),(963,594142200,4),(963,606236400,3),(963,625591800,4),(963,636476400,3),(963,657041400,4),(963,667926000,3),(963,688491000,4),(963,699375600,3),(963,719940600,4),(963,731430000,3),(963,751995000,4),(963,762879600,3),(963,783444600,4),(963,794329200,3),(963,814894200,4),(963,828198000,3),(963,846343800,4),(963,859647600,3),(963,877793400,4),(963,891097200,3),(963,909243000,4),(963,922546800,3),(963,941297400,4),(963,953996400,3),(963,967303800,4),(963,985446000,3),(963,1004196600,4),(963,1017500400,3),(963,1035646200,4),(963,1048950000,3),(963,1067095800,4),(963,1080399600,3),(963,1099150200,4),(963,1111849200,3),(963,1130599800,4),(963,1143903600,3),(963,1162049400,4),(963,1174748400,3),(963,1193499000,4),(963,1207407600,3),(963,1223134200,4),(963,1238857200,3),(963,1254583800,4),(963,1270306800,3),(963,1286033400,4),(963,1301756400,3),(963,1317483000,4),(963,1333206000,3),(963,1349537400,4),(963,1365260400,3),(963,1380987000,4),(963,1396710000,3),(963,1412436600,4),(963,1428159600,3),(963,1443886200,4),(963,1459609200,3),(963,1475335800,4),(963,1491058800,3),(963,1506785400,4),(963,1522508400,3),(963,1538839800,4),(963,1554562800,3),(963,1570289400,4),(963,1586012400,3),(963,1601739000,4),(963,1617462000,3),(963,1633188600,4),(963,1648911600,3),(963,1664638200,4),(963,1680361200,3),(963,1696087800,4),(963,1712415600,3),(963,1728142200,4),(963,1743865200,3),(963,1759591800,4),(963,1775314800,3),(963,1791041400,4),(963,1806764400,3),(963,1822491000,4),(963,1838214000,3),(963,1853940600,4),(963,1869663600,3),(963,1885995000,4),(963,1901718000,3),(963,1917444600,4),(963,1933167600,3),(963,1948894200,4),(963,1964617200,3),(963,1980343800,4),(963,1996066800,3),(963,2011793400,4),(963,2027516400,3),(963,2043243000,4),(963,2058966000,3),(963,2075297400,4),(963,2091020400,3),(963,2106747000,4),(963,2122470000,3),(963,2138196600,4),(963,2147483647,4),(964,-2147483648,2),(964,-1672567140,1),(964,-1665392400,2),(964,-883641600,1),(964,-876128400,2),(964,-860400000,1),(964,-844678800,2),(964,-828345600,1),(964,-813229200,2),(964,57686400,3),(964,67968000,4),(964,89136000,3),(964,100022400,4),(964,120585600,3),(964,131472000,4),(964,152035200,3),(964,162921600,4),(964,183484800,3),(964,194976000,4),(964,215539200,3),(964,226425600,4),(964,246988800,3),(964,257875200,4),(964,278438400,3),(964,289324800,4),(964,309888000,3),(964,320774400,4),(964,341337600,3),(964,352224000,4),(964,372787200,3),(964,384278400,4),(964,404841600,3),(964,415728000,4),(964,436291200,3),(964,447177600,4),(964,467740800,3),(964,478627200,4),(964,499190400,3),(964,511286400,4),(964,530035200,3),(964,542736000,4),(964,561484800,3),(964,574790400,4),(964,594144000,3),(964,606240000,4),(964,625593600,3),(964,637689600,4),(964,657043200,3),(964,667929600,4),(964,688492800,3),(964,699379200,4),(964,719942400,3),(964,731433600,4),(964,751996800,3),(964,762883200,4),(964,783446400,3),(964,796147200,4),(964,814896000,3),(964,828201600,4),(964,846345600,3),(964,859651200,4),(964,877795200,3),(964,891100800,4),(964,909244800,3),(964,922550400,4),(964,941299200,3),(964,954000000,4),(964,967305600,3),(964,985449600,4),(964,1004198400,3),(964,1017504000,4),(964,1035648000,3),(964,1048953600,4),(964,1067097600,3),(964,1080403200,4),(964,1099152000,3),(964,1111852800,4),(964,1130601600,3),(964,1143907200,4),(964,1162051200,3),(964,1174752000,4),(964,1193500800,3),(964,1207411200,4),(964,1223136000,3),(964,1238860800,4),(964,1254585600,3),(964,1270310400,4),(964,1286035200,3),(964,1301760000,4),(964,1317484800,3),(964,1333209600,4),(964,1349539200,3),(964,1365264000,4),(964,1380988800,3),(964,1396713600,4),(964,1412438400,3),(964,1428163200,4),(964,1443888000,3),(964,1459612800,4),(964,1475337600,3),(964,1491062400,4),(964,1506787200,3),(964,1522512000,4),(964,1538841600,3),(964,1554566400,4),(964,1570291200,3),(964,1586016000,4),(964,1601740800,3),(964,1617465600,4),(964,1633190400,3),(964,1648915200,4),(964,1664640000,3),(964,1680364800,4),(964,1696089600,3),(964,1712419200,4),(964,1728144000,3),(964,1743868800,4),(964,1759593600,3),(964,1775318400,4),(964,1791043200,3),(964,1806768000,4),(964,1822492800,3),(964,1838217600,4),(964,1853942400,3),(964,1869667200,4),(964,1885996800,3),(964,1901721600,4),(964,1917446400,3),(964,1933171200,4),(964,1948896000,3),(964,1964620800,4),(964,1980345600,3),(964,1996070400,4),(964,2011795200,3),(964,2027520000,4),(964,2043244800,3),(964,2058969600,4),(964,2075299200,3),(964,2091024000,4),(964,2106748800,3),(964,2122473600,4),(964,2138198400,3),(965,-2147483648,2),(965,-1672567140,1),(965,-1665392400,2),(965,-883641600,1),(965,-876128400,2),(965,-860400000,1),(965,-844678800,2),(965,-828345600,1),(965,-813229200,2),(965,57686400,3),(965,67968000,4),(965,89136000,3),(965,100022400,4),(965,120585600,3),(965,131472000,4),(965,152035200,3),(965,162921600,4),(965,183484800,3),(965,194976000,4),(965,215539200,3),(965,226425600,4),(965,246988800,3),(965,257875200,4),(965,278438400,3),(965,289324800,4),(965,309888000,3),(965,320774400,4),(965,341337600,3),(965,352224000,4),(965,372787200,3),(965,386697600,4),(965,404841600,3),(965,415728000,4),(965,436291200,3),(965,447177600,4),(965,467740800,3),(965,478627200,4),(965,499190400,3),(965,511286400,4),(965,530035200,3),(965,542736000,4),(965,562089600,3),(965,574790400,4),(965,594144000,3),(965,606240000,4),(965,625593600,3),(965,636480000,4),(965,657043200,3),(965,667929600,4),(965,688492800,3),(965,699379200,4),(965,719942400,3),(965,731433600,4),(965,751996800,3),(965,762883200,4),(965,783446400,3),(965,794332800,4),(965,814896000,3),(965,828201600,4),(965,846345600,3),(965,859651200,4),(965,877795200,3),(965,891100800,4),(965,909244800,3),(965,922550400,4),(965,941299200,3),(965,954000000,4),(965,967305600,3),(965,985449600,4),(965,1004198400,3),(965,1017504000,4),(965,1035648000,3),(965,1048953600,4),(965,1067097600,3),(965,1080403200,4),(965,1099152000,3),(965,1111852800,4),(965,1130601600,3),(965,1143907200,4),(965,1162051200,3),(965,1174752000,4),(965,1193500800,3),(965,1207411200,4),(965,1223136000,3),(965,1238860800,4),(965,1254585600,3),(965,1270310400,4),(965,1286035200,3),(965,1301760000,4),(965,1317484800,3),(965,1333209600,4),(965,1349539200,3),(965,1365264000,4),(965,1380988800,3),(965,1396713600,4),(965,1412438400,3),(965,1428163200,4),(965,1443888000,3),(965,1459612800,4),(965,1475337600,3),(965,1491062400,4),(965,1506787200,3),(965,1522512000,4),(965,1538841600,3),(965,1554566400,4),(965,1570291200,3),(965,1586016000,4),(965,1601740800,3),(965,1617465600,4),(965,1633190400,3),(965,1648915200,4),(965,1664640000,3),(965,1680364800,4),(965,1696089600,3),(965,1712419200,4),(965,1728144000,3),(965,1743868800,4),(965,1759593600,3),(965,1775318400,4),(965,1791043200,3),(965,1806768000,4),(965,1822492800,3),(965,1838217600,4),(965,1853942400,3),(965,1869667200,4),(965,1885996800,3),(965,1901721600,4),(965,1917446400,3),(965,1933171200,4),(965,1948896000,3),(965,1964620800,4),(965,1980345600,3),(965,1996070400,4),(965,2011795200,3),(965,2027520000,4),(965,2043244800,3),(965,2058969600,4),(965,2075299200,3),(965,2091024000,4),(965,2106748800,3),(965,2122473600,4),(965,2138198400,3),(966,-2147483648,2),(966,-1672565340,1),(966,-1665390600,2),(966,-883639800,1),(966,-876126600,2),(966,-860398200,1),(966,-844677000,2),(966,-828343800,1),(966,-813227400,2),(967,-2147483648,2),(967,-1672559940,1),(967,-1665385200,2),(967,-883634400,1),(967,-876121200,2),(967,-860392800,1),(967,-844671600,2),(967,152042400,3),(967,162928800,4),(967,436298400,3),(967,447184800,4),(967,690314400,3),(967,699386400,4),(967,1165082400,3),(967,1174759200,4),(967,1193508000,3),(967,1206813600,4),(967,1224957600,3),(967,1238263200,4),(968,-2147483648,2),(968,-1672567140,1),(968,-1665392400,2),(968,-883641600,1),(968,-876128400,2),(968,-860400000,1),(968,-844678800,2),(968,-828345600,1),(968,-813229200,2),(968,57686400,3),(968,67968000,4),(968,625593600,3),(968,636480000,4),(968,657043200,3),(968,667929600,4),(968,688492800,3),(968,699379200,4),(969,-2147483648,2),(969,-1672565340,1),(969,-1665390600,2),(969,-883639800,1),(969,-876126600,2),(969,-860398200,1),(969,-844677000,2),(969,-828343800,1),(969,-813227400,2),(969,57688200,3),(969,67969800,4),(969,89137800,3),(969,100024200,4),(969,120587400,3),(969,131473800,4),(969,152037000,3),(969,162923400,4),(969,183486600,3),(969,194977800,4),(969,215541000,3),(969,226427400,4),(969,246990600,3),(969,257877000,4),(969,278440200,3),(969,289326600,4),(969,309889800,3),(969,320776200,4),(969,341339400,3),(969,352225800,4),(969,372789000,3),(969,384280200,4),(969,404843400,3),(969,415729800,4),(969,436293000,3),(969,447179400,4),(969,467742600,3),(969,478629000,4),(969,499192200,3),(969,511288200,4),(969,530037000,3),(969,542737800,4),(969,562091400,3),(969,574792200,4),(969,594145800,3),(969,606241800,4),(969,625595400,3),(969,637691400,4),(969,657045000,3),(969,667931400,4),(969,688494600,3),(969,701195400,4),(969,719944200,3),(969,731435400,4),(969,751998600,3),(969,764094600,4),(969,783448200,3),(969,796149000,4),(969,814897800,3),(969,828203400,4),(969,846347400,3),(969,859653000,4),(969,877797000,3),(969,891102600,4),(969,909246600,3),(969,922552200,4),(969,941301000,3),(969,954001800,4),(969,972750600,3),(969,985451400,4),(969,1004200200,3),(969,1017505800,4),(969,1035649800,3),(969,1048955400,4),(969,1067099400,3),(969,1080405000,4),(969,1099153800,3),(969,1111854600,4),(969,1130603400,3),(969,1143909000,4),(969,1162053000,3),(969,1174753800,4),(969,1193502600,3),(969,1207413000,4),(969,1223137800,3),(969,1238862600,4),(969,1254587400,3),(969,1270312200,4),(969,1286037000,3),(969,1301761800,4),(969,1317486600,3),(969,1333211400,4),(969,1349541000,3),(969,1365265800,4),(969,1380990600,3),(969,1396715400,4),(969,1412440200,3),(969,1428165000,4),(969,1443889800,3),(969,1459614600,4),(969,1475339400,3),(969,1491064200,4),(969,1506789000,3),(969,1522513800,4),(969,1538843400,3),(969,1554568200,4),(969,1570293000,3),(969,1586017800,4),(969,1601742600,3),(969,1617467400,4),(969,1633192200,3),(969,1648917000,4),(969,1664641800,3),(969,1680366600,4),(969,1696091400,3),(969,1712421000,4),(969,1728145800,3),(969,1743870600,4),(969,1759595400,3),(969,1775320200,4),(969,1791045000,3),(969,1806769800,4),(969,1822494600,3),(969,1838219400,4),(969,1853944200,3),(969,1869669000,4),(969,1885998600,3),(969,1901723400,4),(969,1917448200,3),(969,1933173000,4),(969,1948897800,3),(969,1964622600,4),(969,1980347400,3),(969,1996072200,4),(969,2011797000,3),(969,2027521800,4),(969,2043246600,3),(969,2058971400,4),(969,2075301000,3),(969,2091025800,4),(969,2106750600,3),(969,2122475400,4),(969,2138200200,3),(970,-2147483648,2),(970,-1672567140,1),(970,-1665392400,2),(970,-883641600,1),(970,-876128400,2),(970,-860400000,1),(970,-844678800,2),(970,-828345600,1),(970,-813229200,2),(970,57686400,3),(970,67968000,4),(970,89136000,3),(970,100022400,4),(970,120585600,3),(970,131472000,4),(970,152035200,3),(970,162921600,4),(970,183484800,3),(970,194976000,4),(970,215539200,3),(970,226425600,4),(970,246988800,3),(970,257875200,4),(970,278438400,3),(970,289324800,4),(970,309888000,3),(970,320774400,4),(970,341337600,3),(970,352224000,4),(970,372787200,3),(970,386697600,4),(970,404841600,3),(970,415728000,4),(970,436291200,3),(970,447177600,4),(970,467740800,3),(970,478627200,4),(970,499190400,3),(970,511286400,4),(970,530035200,3),(970,542736000,4),(970,562089600,3),(970,574790400,4),(970,594144000,3),(970,606240000,4),(970,625593600,3),(970,636480000,4),(970,657043200,3),(970,667929600,4),(970,688492800,3),(970,699379200,4),(970,719942400,3),(970,731433600,4),(970,751996800,3),(970,762883200,4),(970,783446400,3),(970,794332800,4),(970,814896000,3),(970,828201600,4),(970,846345600,3),(970,859651200,4),(970,877795200,3),(970,891100800,4),(970,909244800,3),(970,922550400,4),(970,941299200,3),(970,954000000,4),(970,967305600,3),(970,985449600,4),(970,1004198400,3),(970,1017504000,4),(970,1035648000,3),(970,1048953600,4),(970,1067097600,3),(970,1080403200,4),(970,1099152000,3),(970,1111852800,4),(970,1130601600,3),(970,1143907200,4),(970,1162051200,3),(970,1174752000,4),(970,1193500800,3),(970,1207411200,4),(970,1223136000,3),(970,1238860800,4),(970,1254585600,3),(970,1270310400,4),(970,1286035200,3),(970,1301760000,4),(970,1317484800,3),(970,1333209600,4),(970,1349539200,3),(970,1365264000,4),(970,1380988800,3),(970,1396713600,4),(970,1412438400,3),(970,1428163200,4),(970,1443888000,3),(970,1459612800,4),(970,1475337600,3),(970,1491062400,4),(970,1506787200,3),(970,1522512000,4),(970,1538841600,3),(970,1554566400,4),(970,1570291200,3),(970,1586016000,4),(970,1601740800,3),(970,1617465600,4),(970,1633190400,3),(970,1648915200,4),(970,1664640000,3),(970,1680364800,4),(970,1696089600,3),(970,1712419200,4),(970,1728144000,3),(970,1743868800,4),(970,1759593600,3),(970,1775318400,4),(970,1791043200,3),(970,1806768000,4),(970,1822492800,3),(970,1838217600,4),(970,1853942400,3),(970,1869667200,4),(970,1885996800,3),(970,1901721600,4),(970,1917446400,3),(970,1933171200,4),(970,1948896000,3),(970,1964620800,4),(970,1980345600,3),(970,1996070400,4),(970,2011795200,3),(970,2027520000,4),(970,2043244800,3),(970,2058969600,4),(970,2075299200,3),(970,2091024000,4),(970,2106748800,3),(970,2122473600,4),(970,2138198400,3),(971,-2147483648,1),(971,-1680508800,2),(971,-1665392400,1),(971,-883641600,2),(971,-876128400,1),(971,-860400000,2),(971,-844678800,1),(971,-828345600,2),(971,-813229200,1),(971,-71136000,3),(971,-55411200,4),(971,-37267200,3),(971,-25776000,4),(971,-5817600,3),(971,5673600,4),(971,25632000,3),(971,37728000,4),(971,57686400,3),(971,67968000,4),(971,89136000,3),(971,100022400,4),(971,120585600,3),(971,131472000,4),(971,152035200,3),(971,162921600,4),(971,183484800,3),(971,194976000,4),(971,215539200,3),(971,226425600,4),(971,246988800,3),(971,257875200,4),(971,278438400,3),(971,289324800,4),(971,309888000,3),(971,320774400,4),(971,341337600,3),(971,352224000,4),(971,372787200,3),(971,386092800,4),(971,404841600,3),(971,417542400,4),(971,436291200,3),(971,447177600,4),(971,467740800,3),(971,478627200,4),(971,499190400,3),(971,510076800,4),(971,530035200,3),(971,542736000,4),(971,562089600,3),(971,574790400,4),(971,594144000,3),(971,606240000,4),(971,625593600,3),(971,637689600,4),(971,657043200,3),(971,670348800,4),(971,686678400,3),(971,701798400,4),(971,718128000,3),(971,733248000,4),(971,749577600,3),(971,764697600,4),(971,781027200,3),(971,796147200,4),(971,812476800,3),(971,828201600,4),(971,844531200,3),(971,859651200,4),(971,875980800,3),(971,891100800,4),(971,907430400,3),(971,922550400,4),(971,938880000,3),(971,954000000,4),(971,967305600,3),(971,985449600,4),(971,1002384000,3),(971,1017504000,4),(971,1033833600,3),(971,1048953600,4),(971,1065283200,3),(971,1080403200,4),(971,1096732800,3),(971,1111852800,4),(971,1128182400,3),(971,1143907200,4),(971,1159632000,3),(971,1174752000,4),(971,1191686400,3),(971,1207411200,4),(971,1223136000,3),(971,1238860800,4),(971,1254585600,3),(971,1270310400,4),(971,1286035200,3),(971,1301760000,4),(971,1317484800,3),(971,1333209600,4),(971,1349539200,3),(971,1365264000,4),(971,1380988800,3),(971,1396713600,4),(971,1412438400,3),(971,1428163200,4),(971,1443888000,3),(971,1459612800,4),(971,1475337600,3),(971,1491062400,4),(971,1506787200,3),(971,1522512000,4),(971,1538841600,3),(971,1554566400,4),(971,1570291200,3),(971,1586016000,4),(971,1601740800,3),(971,1617465600,4),(971,1633190400,3),(971,1648915200,4),(971,1664640000,3),(971,1680364800,4),(971,1696089600,3),(971,1712419200,4),(971,1728144000,3),(971,1743868800,4),(971,1759593600,3),(971,1775318400,4),(971,1791043200,3),(971,1806768000,4),(971,1822492800,3),(971,1838217600,4),(971,1853942400,3),(971,1869667200,4),(971,1885996800,3),(971,1901721600,4),(971,1917446400,3),(971,1933171200,4),(971,1948896000,3),(971,1964620800,4),(971,1980345600,3),(971,1996070400,4),(971,2011795200,3),(971,2027520000,4),(971,2043244800,3),(971,2058969600,4),(971,2075299200,3),(971,2091024000,4),(971,2106748800,3),(971,2122473600,4),(971,2138198400,3),(972,-2147483648,2),(972,-1672567140,1),(972,-1665392400,2),(972,-883641600,1),(972,-876128400,2),(972,-860400000,1),(972,-844678800,2),(972,-828345600,1),(972,-813229200,2),(972,57686400,3),(972,67968000,4),(972,89136000,3),(972,100022400,4),(972,120585600,3),(972,131472000,4),(972,152035200,3),(972,162921600,4),(972,183484800,3),(972,194976000,4),(972,215539200,3),(972,226425600,4),(972,246988800,3),(972,257875200,4),(972,278438400,3),(972,289324800,4),(972,309888000,3),(972,320774400,4),(972,341337600,3),(972,352224000,4),(972,372787200,3),(972,384278400,4),(972,404841600,3),(972,415728000,4),(972,436291200,3),(972,447177600,4),(972,467740800,3),(972,478627200,4),(972,499190400,3),(972,511286400,4),(972,530035200,3),(972,542736000,4),(972,561484800,3),(972,574790400,4),(972,594144000,3),(972,606240000,4),(972,625593600,3),(972,637689600,4),(972,657043200,3),(972,667929600,4),(972,688492800,3),(972,699379200,4),(972,719942400,3),(972,731433600,4),(972,751996800,3),(972,762883200,4),(972,783446400,3),(972,796147200,4),(972,814896000,3),(972,828201600,4),(972,846345600,3),(972,859651200,4),(972,877795200,3),(972,891100800,4),(972,909244800,3),(972,922550400,4),(972,941299200,3),(972,954000000,4),(972,967305600,3),(972,985449600,4),(972,1004198400,3),(972,1017504000,4),(972,1035648000,3),(972,1048953600,4),(972,1067097600,3),(972,1080403200,4),(972,1099152000,3),(972,1111852800,4),(972,1130601600,3),(972,1143907200,4),(972,1162051200,3),(972,1174752000,4),(972,1193500800,3),(972,1207411200,4),(972,1223136000,3),(972,1238860800,4),(972,1254585600,3),(972,1270310400,4),(972,1286035200,3),(972,1301760000,4),(972,1317484800,3),(972,1333209600,4),(972,1349539200,3),(972,1365264000,4),(972,1380988800,3),(972,1396713600,4),(972,1412438400,3),(972,1428163200,4),(972,1443888000,3),(972,1459612800,4),(972,1475337600,3),(972,1491062400,4),(972,1506787200,3),(972,1522512000,4),(972,1538841600,3),(972,1554566400,4),(972,1570291200,3),(972,1586016000,4),(972,1601740800,3),(972,1617465600,4),(972,1633190400,3),(972,1648915200,4),(972,1664640000,3),(972,1680364800,4),(972,1696089600,3),(972,1712419200,4),(972,1728144000,3),(972,1743868800,4),(972,1759593600,3),(972,1775318400,4),(972,1791043200,3),(972,1806768000,4),(972,1822492800,3),(972,1838217600,4),(972,1853942400,3),(972,1869667200,4),(972,1885996800,3),(972,1901721600,4),(972,1917446400,3),(972,1933171200,4),(972,1948896000,3),(972,1964620800,4),(972,1980345600,3),(972,1996070400,4),(972,2011795200,3),(972,2027520000,4),(972,2043244800,3),(972,2058969600,4),(972,2075299200,3),(972,2091024000,4),(972,2106748800,3),(972,2122473600,4),(972,2138198400,3),(973,-2147483648,2),(973,-1672559940,1),(973,-1665385200,2),(973,-883634400,1),(973,-876121200,2),(973,-860392800,1),(973,-844671600,2),(973,152042400,3),(973,162928800,4),(973,436298400,3),(973,447184800,4),(973,690314400,3),(973,699386400,4),(973,1165082400,3),(973,1174759200,4),(973,1193508000,3),(973,1206813600,4),(973,1224957600,3),(973,1238263200,4),(974,-2147483648,2),(974,-1672565340,1),(974,-1665390600,2),(974,-883639800,1),(974,-876126600,2),(974,-860398200,1),(974,-844677000,2),(974,-828343800,1),(974,-813227400,2),(974,57688200,3),(974,67969800,4),(974,89137800,3),(974,100024200,4),(974,120587400,3),(974,131473800,4),(974,152037000,3),(974,162923400,4),(974,183486600,3),(974,194977800,4),(974,215541000,3),(974,226427400,4),(974,246990600,3),(974,257877000,4),(974,278440200,3),(974,289326600,4),(974,309889800,3),(974,320776200,4),(974,341339400,3),(974,352225800,4),(974,372789000,3),(974,386699400,4),(974,404843400,3),(974,415729800,4),(974,436293000,3),(974,447179400,4),(974,467742600,3),(974,478629000,4),(974,499192200,3),(974,511288200,4),(974,530037000,3),(974,542737800,4),(974,562091400,3),(974,574792200,4),(974,594145800,3),(974,606241800,4),(974,625595400,3),(974,636481800,4),(974,657045000,3),(974,667931400,4),(974,688494600,3),(974,699381000,4),(974,719944200,3),(974,731435400,4),(974,751998600,3),(974,762885000,4),(974,783448200,3),(974,794334600,4),(974,814897800,3),(974,828203400,4),(974,846347400,3),(974,859653000,4),(974,877797000,3),(974,891102600,4),(974,909246600,3),(974,922552200,4),(974,941301000,3),(974,946647000,1),(974,954001800,4),(974,972750600,3),(974,985451400,4),(974,1004200200,3),(974,1017505800,4),(974,1035649800,3),(974,1048955400,4),(974,1067099400,3),(974,1080405000,4),(974,1099153800,3),(974,1111854600,4),(974,1130603400,3),(974,1143909000,4),(974,1162053000,3),(974,1174753800,4),(974,1193502600,3),(974,1207413000,4),(974,1223137800,3),(974,1238862600,4),(974,1254587400,3),(974,1270312200,4),(974,1286037000,3),(974,1301761800,4),(974,1317486600,3),(974,1333211400,4),(974,1349541000,3),(974,1365265800,4),(974,1380990600,3),(974,1396715400,4),(974,1412440200,3),(974,1428165000,4),(974,1443889800,3),(974,1459614600,4),(974,1475339400,3),(974,1491064200,4),(974,1506789000,3),(974,1522513800,4),(974,1538843400,3),(974,1554568200,4),(974,1570293000,3),(974,1586017800,4),(974,1601742600,3),(974,1617467400,4),(974,1633192200,3),(974,1648917000,4),(974,1664641800,3),(974,1680366600,4),(974,1696091400,3),(974,1712421000,4),(974,1728145800,3),(974,1743870600,4),(974,1759595400,3),(974,1775320200,4),(974,1791045000,3),(974,1806769800,4),(974,1822494600,3),(974,1838219400,4),(974,1853944200,3),(974,1869669000,4),(974,1885998600,3),(974,1901723400,4),(974,1917448200,3),(974,1933173000,4),(974,1948897800,3),(974,1964622600,4),(974,1980347400,3),(974,1996072200,4),(974,2011797000,3),(974,2027521800,4),(974,2043246600,3),(974,2058971400,4),(974,2075301000,3),(974,2091025800,4),(974,2106750600,3),(974,2122475400,4),(974,2138200200,3),(975,-2147483648,0),(975,-1767209328,2),(975,-1206950400,1),(975,-1191355200,2),(975,-1175367600,1),(975,-1159819200,2),(975,-633812400,1),(975,-622062000,2),(975,-602276400,1),(975,-591825600,2),(975,-570740400,1),(975,-560203200,2),(975,-539118000,1),(975,-531345600,2),(975,-191358000,1),(975,-184190400,2),(975,-155156400,1),(975,-150062400,2),(975,-128890800,1),(975,-121118400,2),(975,-99946800,1),(975,-89582400,2),(975,-68410800,1),(975,-57960000,2),(975,499755600,1),(975,511243200,2),(975,530600400,1),(975,540273600,2),(975,562136400,1),(975,571204800,2),(975,1214283600,3),(975,1384056000,2),(975,2147483647,2),(976,-2147483648,0),(976,-1767217820,2),(976,-1206961200,1),(976,-1191366000,2),(976,-1175378400,1),(976,-1159830000,2),(976,-633823200,1),(976,-622072800,2),(976,-602287200,1),(976,-591836400,2),(976,-570751200,1),(976,-560214000,2),(976,-539128800,1),(976,-531356400,2),(976,-191368800,1),(976,-184201200,2),(976,-155167200,1),(976,-150073200,2),(976,-128901600,1),(976,-121129200,2),(976,-99957600,1),(976,-89593200,2),(976,-68421600,1),(976,-57970800,2),(976,499744800,1),(976,511232400,2),(976,530589600,1),(976,540262800,2),(976,562125600,1),(976,571194000,2),(976,592970400,1),(976,602038800,2),(976,624420000,1),(976,634698000,2),(976,938916000,1),(976,951613200,2),(976,970970400,1),(976,971571600,2),(976,1003024800,1),(976,1013907600,2),(976,2147483647,2),(977,-2147483648,0),(977,-1767214412,2),(977,-1206957600,1),(977,-1191362400,2),(977,-1175374800,1),(977,-1159826400,2),(977,-633819600,1),(977,-622069200,2),(977,-602283600,1),(977,-591832800,2),(977,-570747600,1),(977,-560210400,2),(977,-539125200,1),(977,-531352800,2),(977,-195426000,1),(977,-184197600,2),(977,-155163600,1),(977,-150069600,2),(977,-128898000,1),(977,-121125600,2),(977,-99954000,1),(977,-89589600,2),(977,-68418000,1),(977,-57967200,2),(977,499748400,1),(977,511236000,2),(977,530593200,1),(977,540266400,2),(977,562129200,1),(977,571197600,2),(977,592974000,1),(977,602042400,2),(977,624423600,1),(977,634701600,2),(977,656478000,1),(977,666756000,2),(977,687927600,1),(977,697600800,2),(977,719982000,1),(977,728445600,2),(977,750826800,1),(977,761709600,2),(977,782276400,1),(977,793159200,2),(977,813726000,1),(977,824004000,2),(977,844570800,1),(977,856058400,2),(977,876106800,1),(977,888717600,2),(977,908074800,1),(977,919562400,2),(977,938919600,1),(977,951616800,2),(977,970974000,1),(977,982461600,2),(977,1003028400,1),(977,1013911200,2),(977,1036292400,1),(977,1045360800,2),(977,1066532400,1),(977,1076810400,2),(977,1099364400,1),(977,1108864800,2),(977,1129431600,1),(977,1140314400,2),(977,1162695600,1),(977,1172368800,2),(977,1192330800,1),(977,1203213600,2),(977,1224385200,1),(977,1234663200,2),(977,1255834800,1),(977,1266717600,2),(977,1287284400,1),(977,1298167200,2),(977,1318734000,1),(977,1330221600,2),(977,1350788400,1),(977,1361066400,2),(977,1382238000,1),(977,1392516000,2),(977,1413687600,1),(977,1424570400,2),(977,1445137200,1),(977,1456020000,2),(977,1476586800,1),(977,1487469600,2),(977,1508036400,1),(977,1518919200,2),(977,1541300400,1),(977,1550368800,2),(977,1572750000,1),(977,1581818400,2),(977,1604199600,1),(977,1613872800,2),(977,1636254000,1),(977,1645322400,2),(977,1667703600,1),(977,1677376800,2),(977,1699153200,1),(977,1708221600,2),(977,1730602800,1),(977,1739671200,2),(977,1762052400,1),(977,1771725600,2),(977,1793502000,1),(977,1803175200,2),(977,1825556400,1),(977,1834624800,2),(977,1857006000,1),(977,1866074400,2),(977,1888455600,1),(977,1897524000,2),(977,1919905200,1),(977,1928973600,2),(977,1951354800,1),(977,1960423200,2),(977,1983409200,1),(977,1992477600,2),(977,2014858800,1),(977,2024532000,2),(977,2046308400,1),(977,2055376800,2),(977,2077758000,1),(977,2086826400,2),(977,2109207600,1),(977,2118880800,2),(977,2140657200,1),(978,-2147483648,0),(978,-1767211196,2),(978,-1206954000,1),(978,-1191358800,2),(978,-1175371200,1),(978,-1159822800,2),(978,-633816000,1),(978,-622065600,2),(978,-602280000,1),(978,-591829200,2),(978,-570744000,1),(978,-560206800,2),(978,-539121600,1),(978,-531349200,2),(978,-191361600,1),(978,-184194000,2),(978,-155160000,1),(978,-150066000,2),(978,-128894400,1),(978,-121122000,2),(978,-99950400,1),(978,-89586000,2),(978,-68414400,1),(978,-57963600,2),(978,499752000,1),(978,511239600,2),(978,530596800,1),(978,540270000,2),(978,562132800,1),(978,571201200,2),(978,750830400,1),(978,761713200,2),(978,2147483647,2),(979,-1693706400,0),(979,-1680483600,1),(979,-1663455600,2),(979,-1650150000,3),(979,-1632006000,2),(979,-1618700400,3),(979,-938905200,2),(979,-857257200,3),(979,-844556400,2),(979,-828226800,3),(979,-812502000,2),(979,-796777200,3),(979,-781052400,2),(979,-766623600,3),(979,228877200,2),(979,243997200,3),(979,260326800,2),(979,276051600,3),(979,291776400,2),(979,307501200,3),(979,323830800,2),(979,338950800,3),(979,354675600,2),(979,370400400,3),(979,386125200,2),(979,401850000,3),(979,417574800,2),(979,433299600,3),(979,449024400,2),(979,465354000,3),(979,481078800,2),(979,496803600,3),(979,512528400,2),(979,528253200,3),(979,543978000,2),(979,559702800,3),(979,575427600,2),(979,591152400,3),(979,606877200,2),(979,622602000,3),(979,638326800,2),(979,654656400,3),(979,670381200,2),(979,686106000,3),(979,701830800,2),(979,717555600,3),(979,733280400,2),(979,749005200,3),(979,764730000,2),(979,780454800,3),(979,796179600,2),(979,811904400,3),(979,828234000,2),(979,846378000,3),(979,859683600,2),(979,877827600,3),(979,891133200,2),(979,909277200,3),(979,922582800,2),(979,941331600,3),(979,954032400,2),(979,972781200,3),(979,985482000,2),(979,1004230800,3),(979,1017536400,2),(979,1035680400,3),(979,1048986000,2),(979,1067130000,3),(979,1080435600,2),(979,1099184400,3),(979,1111885200,2),(979,1130634000,3),(979,1143334800,2),(979,1162083600,3),(979,1174784400,2),(979,1193533200,3),(979,1206838800,2),(979,1224982800,3),(979,1238288400,2),(979,1256432400,3),(979,1269738000,2),(979,1288486800,3),(979,1301187600,2),(979,1319936400,3),(979,1332637200,2),(979,1351386000,3),(979,1364691600,2),(979,1382835600,3),(979,1396141200,2),(979,1414285200,3),(979,1427590800,2),(979,1445734800,3),(979,1459040400,2),(979,1477789200,3),(979,1490490000,2),(979,1509238800,3),(979,1521939600,2),(979,1540688400,3),(979,1553994000,2),(979,1572138000,3),(979,1585443600,2),(979,1603587600,3),(979,1616893200,2),(979,1635642000,3),(979,1648342800,2),(979,1667091600,3),(979,1679792400,2),(979,1698541200,3),(979,1711846800,2),(979,1729990800,3),(979,1743296400,2),(979,1761440400,3),(979,1774746000,2),(979,1792890000,3),(979,1806195600,2),(979,1824944400,3),(979,1837645200,2),(979,1856394000,3),(979,1869094800,2),(979,1887843600,3),(979,1901149200,2),(979,1919293200,3),(979,1932598800,2),(979,1950742800,3),(979,1964048400,2),(979,1982797200,3),(979,1995498000,2),(979,2014246800,3),(979,2026947600,2),(979,2045696400,3),(979,2058397200,2),(979,2077146000,3),(979,2090451600,2),(979,2108595600,3),(979,2121901200,2),(979,2140045200,3),(980,-1633276800,0),(980,-1615136400,1),(980,-1601827200,0),(980,-1583686800,1),(980,-880214400,2),(980,-769395600,3),(980,-765392400,1),(980,-84384000,0),(980,-68662800,1),(980,-52934400,0),(980,-37213200,1),(980,-21484800,0),(980,-5763600,1),(980,9964800,0),(980,25686000,1),(980,41414400,0),(980,57740400,1),(980,73468800,0),(980,89190000,1),(980,104918400,0),(980,120639600,1),(980,126691200,0),(980,152089200,1),(980,162374400,0),(980,183538800,1),(980,199267200,0),(980,215593200,1),(980,230716800,0),(980,247042800,1),(980,262771200,0),(980,278492400,1),(980,294220800,0),(980,309942000,1),(980,325670400,0),(980,341391600,1),(980,357120000,0),(980,372841200,1),(980,388569600,0),(980,404895600,1),(980,420019200,0),(980,436345200,1),(980,452073600,0),(980,467794800,1),(980,483523200,0),(980,499244400,1),(980,514972800,0),(980,530694000,1),(980,544608000,0),(980,562143600,1),(980,576057600,0),(980,594198000,1),(980,607507200,0),(980,625647600,1),(980,638956800,0),(980,657097200,1),(980,671011200,0),(980,688546800,1),(980,702460800,0),(980,719996400,1),(980,733910400,0),(980,752050800,1),(980,765360000,0),(980,783500400,1),(980,796809600,0),(980,814950000,1),(980,828864000,0),(980,846399600,1),(980,860313600,0),(980,877849200,1),(980,891763200,0),(980,909298800,1),(980,923212800,0),(980,941353200,1),(980,954662400,0),(980,972802800,1),(980,986112000,0),(980,1004252400,1),(980,1018166400,0),(980,1035702000,1),(980,1049616000,0),(980,1067151600,1),(980,1081065600,0),(980,1099206000,1),(980,1112515200,0),(980,1130655600,1),(980,1143964800,0),(980,1162105200,1),(980,1173600000,0),(980,1194159600,1),(980,1205049600,0),(980,1225609200,1),(980,1236499200,0),(980,1257058800,1),(980,1268553600,0),(980,1289113200,1),(980,1300003200,0),(980,1320562800,1),(980,1331452800,0),(980,1352012400,1),(980,1362902400,0),(980,1383462000,1),(980,1394352000,0),(980,1414911600,1),(980,1425801600,0),(980,1446361200,1),(980,1457856000,0),(980,1478415600,1),(980,1489305600,0),(980,1509865200,1),(980,1520755200,0),(980,1541314800,1),(980,1552204800,0),(980,1572764400,1),(980,1583654400,0),(980,1604214000,1),(980,1615708800,0),(980,1636268400,1),(980,1647158400,0),(980,1667718000,1),(980,1678608000,0),(980,1699167600,1),(980,1710057600,0),(980,1730617200,1),(980,1741507200,0),(980,1762066800,1),(980,1772956800,0),(980,1793516400,1),(980,1805011200,0),(980,1825570800,1),(980,1836460800,0),(980,1857020400,1),(980,1867910400,0),(980,1888470000,1),(980,1899360000,0),(980,1919919600,1),(980,1930809600,0),(980,1951369200,1),(980,1962864000,0),(980,1983423600,1),(980,1994313600,0),(980,2014873200,1),(980,2025763200,0),(980,2046322800,1),(980,2057212800,0),(980,2077772400,1),(980,2088662400,0),(980,2109222000,1),(980,2120112000,0),(980,2140671600,1),(981,-2147483648,0),(981,-2131645536,2),(981,-1696276800,1),(981,-1680469200,2),(981,-1632074400,1),(981,-1615143600,2),(981,-1566763200,1),(981,-1557090000,2),(981,-1535486400,1),(981,-1524949200,2),(981,-1504468800,1),(981,-1493413200,2),(981,-1472414400,1),(981,-1461963600,2),(981,-1440964800,1),(981,-1429390800,2),(981,-1409515200,1),(981,-1396731600,2),(981,-1376856000,1),(981,-1366491600,2),(981,-1346616000,1),(981,-1333832400,2),(981,-1313956800,1),(981,-1303678800,2),(981,-1282507200,1),(981,-1272661200,2),(981,-1251057600,1),(981,-1240088400,2),(981,-1219608000,1),(981,-1207429200,2),(981,-1188763200,1),(981,-1175979600,2),(981,-1157313600,1),(981,-1143925200,2),(981,-1124049600,1),(981,-1113771600,2),(981,-1091390400,1),(981,-1081026000,2),(981,-1059854400,1),(981,-1050786000,2),(981,-1030910400,1),(981,-1018126800,2),(981,-999460800,1),(981,-986677200,2),(981,-965592000,1),(981,-955227600,2),(981,-935956800,1),(981,-923173200,2),(981,-904507200,1),(981,-891723600,2),(981,-880221600,3),(981,-769395600,4),(981,-765399600,2),(981,-747252000,1),(981,-733950000,2),(981,-715802400,1),(981,-702500400,2),(981,-684352800,1),(981,-671050800,2),(981,-652903200,1),(981,-639601200,2),(981,-589399200,1),(981,-576097200,2),(981,-557949600,1),(981,-544647600,2),(981,-526500000,1),(981,-513198000,2),(981,-495050400,1),(981,-481748400,2),(981,-431546400,1),(981,-418244400,2),(981,-400096800,1),(981,-386794800,2),(981,-368647200,1),(981,-355345200,2),(981,-337197600,1),(981,-323895600,2),(981,-242244000,1),(981,-226522800,2),(981,-210794400,1),(981,-195073200,2),(981,-179344800,1),(981,-163623600,2),(981,-147895200,1),(981,-131569200,2),(981,-116445600,1),(981,-100119600,2),(981,-84391200,1),(981,-68670000,2),(981,-52941600,1),(981,-37220400,2),(981,-21492000,1),(981,-5770800,2),(981,9957600,1),(981,25678800,2),(981,41407200,1),(981,57733200,2),(981,73461600,1),(981,89182800,2),(981,104911200,1),(981,120632400,2),(981,136360800,1),(981,152082000,2),(981,167810400,1),(981,183531600,2),(981,199260000,1),(981,215586000,2),(981,230709600,1),(981,247035600,2),(981,262764000,1),(981,278485200,2),(981,294213600,1),(981,309934800,2),(981,325663200,1),(981,341384400,2),(981,357112800,1),(981,372834000,2),(981,388562400,1),(981,404888400,2),(981,420012000,1),(981,436338000,2),(981,452066400,1),(981,467787600,2),(981,483516000,1),(981,499237200,2),(981,514965600,1),(981,530686800,2),(981,544600800,1),(981,562136400,2),(981,576050400,1),(981,594190800,2),(981,607500000,1),(981,625640400,2),(981,638949600,1),(981,657090000,2),(981,671004000,1),(981,688539600,2),(981,702453600,1),(981,719989200,2),(981,733903200,1),(981,752043600,2),(981,765352800,1),(981,783493200,2),(981,796802400,1),(981,814942800,2),(981,828856800,1),(981,846392400,2),(981,860306400,1),(981,877842000,2),(981,891756000,1),(981,909291600,2),(981,923205600,1),(981,941346000,2),(981,954655200,1),(981,972795600,2),(981,986104800,1),(981,1004245200,2),(981,1018159200,1),(981,1035694800,2),(981,1049608800,1),(981,1067144400,2),(981,1081058400,1),(981,1099198800,2),(981,1112508000,1),(981,1130648400,2),(981,1143957600,1),(981,1162098000,2),(981,1173592800,1),(981,1194152400,2),(981,1205042400,1),(981,1225602000,2),(981,1236492000,1),(981,1257051600,2),(981,1268546400,1),(981,1289106000,2),(981,1299996000,1),(981,1320555600,2),(981,1331445600,1),(981,1352005200,2),(981,1362895200,1),(981,1383454800,2),(981,1394344800,1),(981,1414904400,2),(981,1425794400,1),(981,1446354000,2),(981,1457848800,1),(981,1478408400,2),(981,1489298400,1),(981,1509858000,2),(981,1520748000,1),(981,1541307600,2),(981,1552197600,1),(981,1572757200,2),(981,1583647200,1),(981,1604206800,2),(981,1615701600,1),(981,1636261200,2),(981,1647151200,1),(981,1667710800,2),(981,1678600800,1),(981,1699160400,2),(981,1710050400,1),(981,1730610000,2),(981,1741500000,1),(981,1762059600,2),(981,1772949600,1),(981,1793509200,2),(981,1805004000,1),(981,1825563600,2),(981,1836453600,1),(981,1857013200,2),(981,1867903200,1),(981,1888462800,2),(981,1899352800,1),(981,1919912400,2),(981,1930802400,1),(981,1951362000,2),(981,1962856800,1),(981,1983416400,2),(981,1994306400,1),(981,2014866000,2),(981,2025756000,1),(981,2046315600,2),(981,2057205600,1),(981,2077765200,2),(981,2088655200,1),(981,2109214800,2),(981,2120104800,1),(981,2140664400,2),(982,-2147483648,2),(982,-1694368800,1),(982,-1681671600,2),(982,-1632067200,1),(982,-1615136400,2),(982,-1029686400,1),(982,-1018198800,2),(982,-880214400,3),(982,-769395600,4),(982,-765392400,2),(982,-746035200,1),(982,-732733200,2),(982,-715795200,1),(982,-702493200,2),(982,-684345600,1),(982,-671043600,2),(982,-652896000,1),(982,-639594000,2),(982,-620755200,1),(982,-607626000,2),(982,-589392000,1),(982,-576090000,2),(982,-557942400,1),(982,-544640400,2),(982,-526492800,1),(982,-513190800,2),(982,-495043200,1),(982,-481741200,2),(982,-463593600,1),(982,-450291600,2),(982,-431539200,1),(982,-418237200,2),(982,-400089600,1),(982,-386787600,2),(982,-368640000,1),(982,-355338000,2),(982,-337190400,1),(982,-321469200,2),(982,-305740800,1),(982,-292438800,2),(982,-210787200,1),(982,-198090000,2),(982,-116438400,5),(982,-100108800,6),(982,-84384000,5),(982,-68659200,6),(982,-52934400,5),(982,-37209600,6),(982,-21484800,5),(982,-5760000,6),(982,9964800,5),(982,25689600,6),(982,41414400,5),(982,57744000,6),(982,73468800,5),(982,89193600,6),(982,104918400,5),(982,120643200,6),(982,136368000,5),(982,152092800,6),(982,167817600,5),(982,183542400,6),(982,199267200,5),(982,215596800,6),(982,230716800,5),(982,247046400,6),(982,262771200,5),(982,278496000,6),(982,294220800,5),(982,309945600,6),(982,325670400,5),(982,341395200,6),(982,357120000,5),(982,372844800,6),(982,388569600,5),(982,404899200,6),(982,420019200,5),(982,436348800,6),(982,452073600,5),(982,467798400,6),(982,483523200,5),(982,499248000,6),(982,514972800,5),(982,530697600,6),(982,544608000,5),(982,562147200,6),(982,576057600,5),(982,594201600,6),(982,607507200,5),(982,625651200,6),(982,638956800,5),(982,657100800,6),(982,671011200,5),(982,688550400,6),(982,702460800,5),(982,720000000,6),(982,733910400,5),(982,752054400,6),(982,765360000,5),(982,783504000,6),(982,796809600,5),(982,814953600,6),(982,828864000,5),(982,846403200,6),(982,860313600,5),(982,877852800,6),(982,891763200,5),(982,909302400,6),(982,923212800,5),(982,941356800,6),(982,954662400,5),(982,972806400,6),(982,986112000,5),(982,1004256000,6),(982,1018166400,5),(982,1035705600,6),(982,1049616000,5),(982,1067155200,6),(982,1081065600,5),(982,1099209600,6),(982,1112515200,5),(982,1130659200,6),(982,1136095200,2),(982,1143964800,1),(982,1162105200,2),(982,1173600000,1),(982,1194159600,2),(982,1205049600,1),(982,1225609200,2),(982,1236499200,1),(982,1257058800,2),(982,1268553600,1),(982,1289113200,2),(982,1300003200,1),(982,1320562800,2),(982,1331452800,1),(982,1352012400,2),(982,1362902400,1),(982,1383462000,2),(982,1394352000,1),(982,1414911600,2),(982,1425801600,1),(982,1446361200,2),(982,1457856000,1),(982,1478415600,2),(982,1489305600,1),(982,1509865200,2),(982,1520755200,1),(982,1541314800,2),(982,1552204800,1),(982,1572764400,2),(982,1583654400,1),(982,1604214000,2),(982,1615708800,1),(982,1636268400,2),(982,1647158400,1),(982,1667718000,2),(982,1678608000,1),(982,1699167600,2),(982,1710057600,1),(982,1730617200,2),(982,1741507200,1),(982,1762066800,2),(982,1772956800,1),(982,1793516400,2),(982,1805011200,1),(982,1825570800,2),(982,1836460800,1),(982,1857020400,2),(982,1867910400,1),(982,1888470000,2),(982,1899360000,1),(982,1919919600,2),(982,1930809600,1),(982,1951369200,2),(982,1962864000,1),(982,1983423600,2),(982,1994313600,1),(982,2014873200,2),(982,2025763200,1),(982,2046322800,2),(982,2057212800,1),(982,2077772400,2),(982,2088662400,1),(982,2109222000,2),(982,2120112000,1),(982,2140671600,2),(983,-2147483648,2),(983,-1632070800,1),(983,-1615140000,2),(983,-1601753400,1),(983,-1583697600,2),(983,-1567357200,1),(983,-1554667200,2),(983,-1534698000,1),(983,-1524074400,2),(983,-1503248400,1),(983,-1492365600,2),(983,-1471798800,1),(983,-1460916000,2),(983,-1440954000,1),(983,-1428861600,2),(983,-1409504400,1),(983,-1397412000,2),(983,-1378054800,1),(983,-1365962400,2),(983,-1346605200,1),(983,-1333908000,2),(983,-1315155600,1),(983,-1301853600,2),(983,-1283706000,1),(983,-1270404000,2),(983,-1252256400,1),(983,-1238954400,2),(983,-1220806800,1),(983,-1207504800,2),(983,-1188752400,1),(983,-1176055200,2),(983,-1157302800,1),(983,-1144000800,2),(983,-1125853200,1),(983,-1112551200,2),(983,-1094403600,1),(983,-1081101600,2),(983,-1062954000,1),(983,-1049652000,2),(983,-1031504400,1),(983,-1018202400,2),(983,-1000054800,1),(983,-986752800,2),(983,-968000400,1),(983,-955303200,2),(983,-936550800,1),(983,-880218000,3),(983,-769395600,4),(983,-765396000,2),(983,-747248400,1),(983,-733946400,2),(983,-715806000,1),(983,-702504000,2),(983,-684356400,1),(983,-671054400,2),(983,-652906800,1),(983,-634161600,2),(983,-620845200,1),(983,-602704800,2),(983,-589395600,1),(983,-576093600,2),(983,-557946000,1),(983,-544644000,2),(983,-526496400,1),(983,-513194400,2),(983,-495046800,1),(983,-481744800,2),(983,-463597200,1),(983,-450295200,2),(983,-431542800,1),(983,-418240800,2),(983,-400093200,1),(983,-384372000,2),(983,-368643600,1),(983,-352922400,2),(983,-337194000,1),(983,-321472800,2),(983,-305744400,1),(983,-289418400,2),(983,-273690000,1),(983,-257968800,2),(983,-242240400,1),(983,-226519200,2),(983,-210790800,1),(983,-195069600,2),(983,-179341200,1),(983,-163620000,2),(983,-147891600,1),(983,-131565600,2),(983,-116442000,1),(983,-100116000,2),(983,-84387600,1),(983,-68666400,2),(983,-52938000,1),(983,-37216800,2),(983,-21488400,1),(983,-5767200,2),(983,9961200,1),(983,25682400,2),(983,41410800,1),(983,57736800,2),(983,73465200,1),(983,89186400,2),(983,104914800,1),(983,120636000,2),(983,136364400,1),(983,152085600,2),(983,167814000,1),(983,183535200,2),(983,199263600,1),(983,215589600,2),(983,230713200,1),(983,247039200,2),(983,262767600,1),(983,278488800,2),(983,294217200,1),(983,309938400,2),(983,325666800,1),(983,341388000,2),(983,357116400,1),(983,372837600,2),(983,388566000,1),(983,404892000,2),(983,420015600,1),(983,436341600,2),(983,452070000,1),(983,467791200,2),(983,483519600,1),(983,499240800,2),(983,514969200,1),(983,530690400,2),(983,544604400,1),(983,562140000,2),(983,576054000,1),(983,594194400,2),(983,607503600,1),(983,625644000,2),(983,638953200,1),(983,657093600,2),(983,671007600,1),(983,688543200,2),(983,702457200,1),(983,719992800,2),(983,733906800,1),(983,752047200,2),(983,765356400,1),(983,783496800,2),(983,796806000,1),(983,814946400,2),(983,828860400,1),(983,846396000,2),(983,860310000,1),(983,877845600,2),(983,891759600,1),(983,909295200,2),(983,923209200,1),(983,941349600,2),(983,954658800,1),(983,972799200,2),(983,986108400,1),(983,1004248800,2),(983,1018162800,1),(983,1035698400,2),(983,1049612400,1),(983,1067148000,2),(983,1081062000,1),(983,1099202400,2),(983,1112511600,1),(983,1130652000,2),(983,1143961200,1),(983,1162101600,2),(983,1173596400,1),(983,1194156000,2),(983,1205046000,1),(983,1225605600,2),(983,1236495600,1),(983,1257055200,2),(983,1268550000,1),(983,1289109600,2),(983,1299999600,1),(983,1320559200,2),(983,1331449200,1),(983,1352008800,2),(983,1362898800,1),(983,1383458400,2),(983,1394348400,1),(983,1414908000,2),(983,1425798000,1),(983,1446357600,2),(983,1457852400,1),(983,1478412000,2),(983,1489302000,1),(983,1509861600,2),(983,1520751600,1),(983,1541311200,2),(983,1552201200,1),(983,1572760800,2),(983,1583650800,1),(983,1604210400,2),(983,1615705200,1),(983,1636264800,2),(983,1647154800,1),(983,1667714400,2),(983,1678604400,1),(983,1699164000,2),(983,1710054000,1),(983,1730613600,2),(983,1741503600,1),(983,1762063200,2),(983,1772953200,1),(983,1793512800,2),(983,1805007600,1),(983,1825567200,2),(983,1836457200,1),(983,1857016800,2),(983,1867906800,1),(983,1888466400,2),(983,1899356400,1),(983,1919916000,2),(983,1930806000,1),(983,1951365600,2),(983,1962860400,1),(983,1983420000,2),(983,1994310000,1),(983,2014869600,2),(983,2025759600,1),(983,2046319200,2),(983,2057209200,1),(983,2077768800,2),(983,2088658800,1),(983,2109218400,2),(983,2120108400,1),(983,2140668000,2),(984,-2147483648,0),(984,-1998663968,2),(984,-1632063600,1),(984,-1615132800,2),(984,-1600614000,1),(984,-1596816000,2),(984,-1567954800,1),(984,-1551628800,2),(984,-1536505200,1),(984,-1523203200,2),(984,-1504450800,1),(984,-1491753600,2),(984,-1473001200,1),(984,-1459699200,2),(984,-880210800,3),(984,-769395600,4),(984,-765388800,2),(984,-715791600,1),(984,-702489600,2),(984,-84380400,1),(984,-68659200,2),(984,-21481200,1),(984,-5760000,2),(984,73472400,1),(984,89193600,2),(984,104922000,1),(984,120643200,2),(984,136371600,1),(984,152092800,2),(984,167821200,1),(984,183542400,2),(984,199270800,1),(984,215596800,2),(984,230720400,1),(984,247046400,2),(984,262774800,1),(984,278496000,2),(984,294224400,1),(984,309945600,2),(984,325674000,1),(984,341395200,2),(984,357123600,1),(984,372844800,2),(984,388573200,1),(984,404899200,2),(984,420022800,1),(984,436348800,2),(984,452077200,1),(984,467798400,2),(984,483526800,1),(984,499248000,2),(984,514976400,1),(984,530697600,2),(984,544611600,1),(984,562147200,2),(984,576061200,1),(984,594201600,2),(984,607510800,1),(984,625651200,2),(984,638960400,1),(984,657100800,2),(984,671014800,1),(984,688550400,2),(984,702464400,1),(984,720000000,2),(984,733914000,1),(984,752054400,2),(984,765363600,1),(984,783504000,2),(984,796813200,1),(984,814953600,2),(984,828867600,1),(984,846403200,2),(984,860317200,1),(984,877852800,2),(984,891766800,1),(984,909302400,2),(984,923216400,1),(984,941356800,2),(984,954666000,1),(984,972806400,2),(984,986115600,1),(984,1004256000,2),(984,1018170000,1),(984,1035705600,2),(984,1049619600,1),(984,1067155200,2),(984,1081069200,1),(984,1099209600,2),(984,1112518800,1),(984,1130659200,2),(984,1143968400,1),(984,1162108800,2),(984,1173603600,1),(984,1194163200,2),(984,1205053200,1),(984,1225612800,2),(984,1236502800,1),(984,1257062400,2),(984,1268557200,1),(984,1289116800,2),(984,1300006800,1),(984,1320566400,2),(984,1331456400,1),(984,1352016000,2),(984,1362906000,1),(984,1383465600,2),(984,1394355600,1),(984,1414915200,2),(984,1425805200,1),(984,1446364800,2),(984,1457859600,1),(984,1478419200,2),(984,1489309200,1),(984,1509868800,2),(984,1520758800,1),(984,1541318400,2),(984,1552208400,1),(984,1572768000,2),(984,1583658000,1),(984,1604217600,2),(984,1615712400,1),(984,1636272000,2),(984,1647162000,1),(984,1667721600,2),(984,1678611600,1),(984,1699171200,2),(984,1710061200,1),(984,1730620800,2),(984,1741510800,1),(984,1762070400,2),(984,1772960400,1),(984,1793520000,2),(984,1805014800,1),(984,1825574400,2),(984,1836464400,1),(984,1857024000,2),(984,1867914000,1),(984,1888473600,2),(984,1899363600,1),(984,1919923200,2),(984,1930813200,1),(984,1951372800,2),(984,1962867600,1),(984,1983427200,2),(984,1994317200,1),(984,2014876800,2),(984,2025766800,1),(984,2046326400,2),(984,2057216400,1),(984,2077776000,2),(984,2088666000,1),(984,2109225600,2),(984,2120115600,1),(984,2140675200,2),(985,-2147483648,2),(985,-1664130548,1),(985,-1650137348,2),(985,-1632076148,1),(985,-1615145348,2),(985,-1598650148,1),(985,-1590100148,2),(985,-1567286948,1),(985,-1551565748,2),(985,-1535837348,1),(985,-1520116148,2),(985,-1503782948,1),(985,-1488666548,2),(985,-1472333348,1),(985,-1457216948,2),(985,-1440883748,1),(985,-1425767348,2),(985,-1409434148,1),(985,-1394317748,2),(985,-1377984548,1),(985,-1362263348,2),(985,-1346534948,1),(985,-1330813748,2),(985,-1314480548,1),(985,-1299364148,2),(985,-1283030948,1),(985,-1267914548,2),(985,-1251581348,1),(985,-1236464948,2),(985,-1220131748,1),(985,-1205015348,2),(985,-1188682148,1),(985,-1172960948,2),(985,-1156627748,1),(985,-1141511348,2),(985,-1125178148,1),(985,-1110061748,2),(985,-1096921748,4),(985,-1093728600,3),(985,-1078612200,4),(985,-1061670600,3),(985,-1048973400,4),(985,-1030221000,3),(985,-1017523800,4),(985,-998771400,3),(985,-986074200,4),(985,-966717000,3),(985,-954624600,4),(985,-935267400,3),(985,-922570200,4),(985,-903817800,3),(985,-891120600,4),(985,-872368200,6),(985,-769395600,5),(985,-765401400,4),(985,-746044200,3),(985,-733347000,4),(985,-714594600,3),(985,-701897400,4),(985,-683145000,3),(985,-670447800,4),(985,-651695400,3),(985,-638998200,4),(985,-619641000,3),(985,-606943800,4),(985,-589401000,3),(985,-576099000,4),(985,-557951400,3),(985,-544649400,4),(985,-526501800,3),(985,-513199800,4),(985,-495052200,3),(985,-481750200,4),(985,-463602600,3),(985,-450300600,4),(985,-431548200,3),(985,-418246200,4),(985,-400098600,3),(985,-386796600,4),(985,-368649000,3),(985,-355347000,4),(985,-337199400,3),(985,-323897400,4),(985,-305749800,3),(985,-289423800,4),(985,-273695400,3),(985,-257974200,4),(985,-242245800,3),(985,-226524600,4),(985,-210796200,3),(985,-195075000,4),(985,-179346600,3),(985,-163625400,4),(985,-147897000,3),(985,-131571000,4),(985,-116447400,3),(985,-100121400,4),(985,-84393000,3),(985,-68671800,4),(985,-52943400,3),(985,-37222200,4),(985,-21493800,3),(985,-5772600,4),(985,9955800,3),(985,25677000,4),(985,41405400,3),(985,57731400,4),(985,73459800,3),(985,89181000,4),(985,104909400,3),(985,120630600,4),(985,136359000,3),(985,152080200,4),(985,167808600,3),(985,183529800,4),(985,199258200,3),(985,215584200,4),(985,230707800,3),(985,247033800,4),(985,262762200,3),(985,278483400,4),(985,294211800,3),(985,309933000,4),(985,325661400,3),(985,341382600,4),(985,357111000,3),(985,372832200,4),(985,388560600,3),(985,404886600,4),(985,420010200,3),(985,436336200,4),(985,452064600,3),(985,467785800,4),(985,483514200,3),(985,499235400,4),(985,514963800,3),(985,530685000,4),(985,544591860,3),(985,562127460,4),(985,576041460,7),(985,594178260,4),(985,607491060,3),(985,625631460,4),(985,638940660,3),(985,657081060,4),(985,670995060,3),(985,688530660,4),(985,702444660,3),(985,719980260,4),(985,733894260,3),(985,752034660,4),(985,765343860,3),(985,783484260,4),(985,796793460,3),(985,814933860,4),(985,828847860,3),(985,846383460,4),(985,860297460,3),(985,877833060,4),(985,891747060,3),(985,909282660,4),(985,923196660,3),(985,941337060,4),(985,954646260,3),(985,972786660,4),(985,986095860,3),(985,1004236260,4),(985,1018150260,3),(985,1035685860,4),(985,1049599860,3),(985,1067135460,4),(985,1081049460,3),(985,1099189860,4),(985,1112499060,3),(985,1130639460,4),(985,1143948660,3),(985,1162089060,4),(985,1173583860,3),(985,1194143460,4),(985,1205033460,3),(985,1225593060,4),(985,1236483060,3),(985,1257042660,4),(985,1268537460,3),(985,1289097060,4),(985,1299987060,3),(985,1320553800,4),(985,1331443800,3),(985,1352003400,4),(985,1362893400,3),(985,1383453000,4),(985,1394343000,3),(985,1414902600,4),(985,1425792600,3),(985,1446352200,4),(985,1457847000,3),(985,1478406600,4),(985,1489296600,3),(985,1509856200,4),(985,1520746200,3),(985,1541305800,4),(985,1552195800,3),(985,1572755400,4),(985,1583645400,3),(985,1604205000,4),(985,1615699800,3),(985,1636259400,4),(985,1647149400,3),(985,1667709000,4),(985,1678599000,3),(985,1699158600,4),(985,1710048600,3),(985,1730608200,4),(985,1741498200,3),(985,1762057800,4),(985,1772947800,3),(985,1793507400,4),(985,1805002200,3),(985,1825561800,4),(985,1836451800,3),(985,1857011400,4),(985,1867901400,3),(985,1888461000,4),(985,1899351000,3),(985,1919910600,4),(985,1930800600,3),(985,1951360200,4),(985,1962855000,3),(985,1983414600,4),(985,1994304600,3),(985,2014864200,4),(985,2025754200,3),(985,2046313800,4),(985,2057203800,3),(985,2077763400,4),(985,2088653400,3),(985,2109213000,4),(985,2120103000,3),(985,2140662600,4),(986,-2147483648,2),(986,-1632060000,1),(986,-1615129200,2),(986,-880207200,3),(986,-769395600,4),(986,-765385200,2),(986,-747237600,1),(986,-732726000,2),(986,-715788000,1),(986,-702486000,2),(986,-684338400,1),(986,-671036400,2),(986,-652888800,1),(986,-639586800,2),(986,-620834400,1),(986,-608137200,2),(986,-589384800,1),(986,-576082800,2),(986,-557935200,1),(986,-544633200,2),(986,-526485600,1),(986,-513183600,2),(986,-495036000,1),(986,-481734000,2),(986,-463586400,1),(986,-450284400,2),(986,-431532000,1),(986,-418230000,2),(986,-400082400,1),(986,-386780400,2),(986,-368632800,1),(986,-355330800,2),(986,-337183200,1),(986,-323881200,2),(986,-305733600,1),(986,-292431600,2),(986,-273679200,1),(986,-260982000,2),(986,-242229600,1),(986,-226508400,2),(986,-210780000,1),(986,-195058800,2),(986,-179330400,1),(986,-163609200,2),(986,-147880800,1),(986,-131554800,2),(986,-116431200,1),(986,-100105200,2),(986,-84376800,1),(986,-68655600,2),(986,-52927200,1),(986,-37206000,2),(986,-21477600,1),(986,-5756400,2),(986,9972000,1),(986,25693200,2),(986,41421600,1),(986,57747600,2),(986,73476000,1),(986,89197200,2),(986,104925600,1),(986,120646800,2),(986,136375200,1),(986,152096400,2),(986,167824800,1),(986,183546000,2),(986,199274400,1),(986,215600400,2),(986,230724000,1),(986,247050000,2),(986,262778400,1),(986,278499600,2),(986,294228000,1),(986,309949200,2),(986,325677600,1),(986,341398800,2),(986,357127200,1),(986,372848400,2),(986,388576800,1),(986,404902800,2),(986,420026400,1),(986,436352400,2),(986,452080800,1),(986,467802000,2),(986,483530400,1),(986,499251600,2),(986,514980000,1),(986,530701200,2),(986,544615200,1),(986,562150800,2),(986,576064800,1),(986,594205200,2),(986,607514400,1),(986,625654800,2),(986,638964000,1),(986,657104400,2),(986,671018400,1),(986,688554000,2),(986,702468000,1),(986,720003600,2),(986,733917600,1),(986,752058000,2),(986,765367200,1),(986,783507600,2),(986,796816800,1),(986,814957200,2),(986,828871200,1),(986,846406800,2),(986,860320800,1),(986,877856400,2),(986,891770400,1),(986,909306000,2),(986,923220000,1),(986,941360400,2),(986,954669600,1),(986,972810000,2),(986,986119200,1),(986,1004259600,2),(986,1018173600,1),(986,1035709200,2),(986,1049623200,1),(986,1067158800,2),(986,1081072800,1),(986,1099213200,2),(986,1112522400,1),(986,1130662800,2),(986,1143972000,1),(986,1162112400,2),(986,1173607200,1),(986,1194166800,2),(986,1205056800,1),(986,1225616400,2),(986,1236506400,1),(986,1257066000,2),(986,1268560800,1),(986,1289120400,2),(986,1300010400,1),(986,1320570000,2),(986,1331460000,1),(986,1352019600,2),(986,1362909600,1),(986,1383469200,2),(986,1394359200,1),(986,1414918800,2),(986,1425808800,1),(986,1446368400,2),(986,1457863200,1),(986,1478422800,2),(986,1489312800,1),(986,1509872400,2),(986,1520762400,1),(986,1541322000,2),(986,1552212000,1),(986,1572771600,2),(986,1583661600,1),(986,1604221200,2),(986,1615716000,1),(986,1636275600,2),(986,1647165600,1),(986,1667725200,2),(986,1678615200,1),(986,1699174800,2),(986,1710064800,1),(986,1730624400,2),(986,1741514400,1),(986,1762074000,2),(986,1772964000,1),(986,1793523600,2),(986,1805018400,1),(986,1825578000,2),(986,1836468000,1),(986,1857027600,2),(986,1867917600,1),(986,1888477200,2),(986,1899367200,1),(986,1919926800,2),(986,1930816800,1),(986,1951376400,2),(986,1962871200,1),(986,1983430800,2),(986,1994320800,1),(986,2014880400,2),(986,2025770400,1),(986,2046330000,2),(986,2057220000,1),(986,2077779600,2),(986,2088669600,1),(986,2109229200,2),(986,2120119200,1),(986,2140678800,2),(987,-2147483648,0),(987,-2030202084,2),(987,-1632063600,1),(987,-1615132800,2),(987,-1251651600,1),(987,-1238349600,2),(987,-1220202000,1),(987,-1206900000,2),(987,-1188752400,1),(987,-1175450400,2),(987,-1156698000,1),(987,-1144000800,2),(987,-1125248400,1),(987,-1111946400,2),(987,-1032714000,1),(987,-1016992800,2),(987,-1001264400,1),(987,-986148000,2),(987,-969814800,1),(987,-954093600,2),(987,-937760400,1),(987,-922039200,2),(987,-906310800,1),(987,-890589600,2),(987,-880210800,3),(987,-769395600,4),(987,-765388800,2),(987,-748450800,1),(987,-732729600,2),(987,-715791600,1),(987,-702489600,2),(987,-684342000,1),(987,-671040000,2),(987,-652892400,1),(987,-639590400,2),(987,-620838000,1),(987,-608140800,2),(987,-589388400,1),(987,-576086400,2),(987,-557938800,1),(987,-544636800,2),(987,-526489200,1),(987,-513187200,2),(987,-495039600,1),(987,-481737600,2),(987,-463590000,1),(987,-450288000,2),(987,-431535600,1),(987,-418233600,2),(987,-400086000,1),(987,-386784000,2),(987,-337186800,1),(987,-321465600,2),(987,-305737200,5),(988,-2147483648,2),(988,-1632056400,1),(988,-1615125600,2),(988,-1596978000,1),(988,-1583164800,2),(988,-880203600,3),(988,-769395600,4),(988,-765381600,2),(988,-147884400,5),(988,-131554800,2),(988,-81961200,6),(988,325677600,7),(988,341398800,6),(988,357127200,7),(988,372848400,6),(988,388576800,7),(988,404902800,6),(988,420026400,7),(988,436352400,6),(988,452080800,7),(988,467802000,6),(988,483530400,7),(988,499251600,6),(988,514980000,7),(988,530701200,6),(988,544615200,7),(988,562150800,6),(988,576064800,7),(988,594205200,6),(988,607514400,7),(988,625654800,6),(988,638964000,7),(988,657104400,6),(988,671018400,7),(988,688554000,6),(988,702468000,7),(988,720003600,6),(988,733917600,7),(988,752058000,6),(988,765367200,7),(988,783507600,6),(988,796816800,7),(988,814957200,6),(988,828871200,7),(988,846406800,6),(988,860320800,7),(988,877856400,6),(988,891770400,7),(988,909306000,6),(988,923220000,7),(988,941360400,6),(988,954669600,7),(988,972810000,6),(988,986119200,7),(988,1004259600,6),(988,1018173600,7),(988,1035709200,6),(988,1049623200,7),(988,1067158800,6),(988,1081072800,7),(988,1099213200,6),(988,1112522400,7),(988,1130662800,6),(988,1143972000,7),(988,1162112400,6),(988,1173607200,7),(988,1194166800,6),(988,1205056800,7),(988,1225616400,6),(988,1236506400,7),(988,1257066000,6),(988,1268560800,7),(988,1289120400,6),(988,1300010400,7),(988,1320570000,6),(988,1331460000,7),(988,1352019600,6),(988,1362909600,7),(988,1383469200,6),(988,1394359200,7),(988,1414918800,6),(988,1425808800,7),(988,1446368400,6),(988,1457863200,7),(988,1478422800,6),(988,1489312800,7),(988,1509872400,6),(988,1520762400,7),(988,1541322000,6),(988,1552212000,7),(988,1572771600,6),(988,1583661600,7),(988,1604221200,6),(988,1615716000,7),(988,1636275600,6),(988,1647165600,7),(988,1667725200,6),(988,1678615200,7),(988,1699174800,6),(988,1710064800,7),(988,1730624400,6),(988,1741514400,7),(988,1762074000,6),(988,1772964000,7),(988,1793523600,6),(988,1805018400,7),(988,1825578000,6),(988,1836468000,7),(988,1857027600,6),(988,1867917600,7),(988,1888477200,6),(988,1899367200,7),(988,1919926800,6),(988,1930816800,7),(988,1951376400,6),(988,1962871200,7),(988,1983430800,6),(988,1994320800,7),(988,2014880400,6),(988,2025770400,7),(988,2046330000,6),(988,2057220000,7),(988,2077779600,6),(988,2088669600,7),(988,2109229200,6),(988,2120119200,7),(988,2140678800,6),(989,-2147483648,1),(989,-1892661434,2),(989,-1688410800,1),(989,-1619205434,3),(989,-1593806400,1),(989,-1335986234,4),(989,-1317585600,2),(989,-1304362800,4),(989,-1286049600,2),(989,-1272826800,4),(989,-1254513600,2),(989,-1241290800,4),(989,-1222977600,2),(989,-1209754800,4),(989,-1191355200,2),(989,-1178132400,3),(989,-870552000,2),(989,-865278000,3),(989,-740520000,5),(989,-736376400,3),(989,-718056000,2),(989,-713649600,3),(989,-36619200,6),(989,-23922000,7),(989,-3355200,6),(989,7527600,7),(989,24465600,6),(989,37767600,7),(989,55915200,6),(989,69217200,7),(989,87969600,6),(989,100666800,7),(989,118209600,6),(989,132116400,7),(989,150868800,6),(989,163566000,7),(989,182318400,6),(989,195620400,7),(989,213768000,6),(989,227070000,7),(989,245217600,6),(989,258519600,7),(989,277272000,6),(989,289969200,7),(989,308721600,6),(989,321418800,7),(989,340171200,6),(989,353473200,7),(989,371620800,6),(989,384922800,7),(989,403070400,6),(989,416372400,7),(989,434520000,6),(989,447822000,7),(989,466574400,6),(989,479271600,7),(989,498024000,6),(989,510721200,7),(989,529473600,6),(989,545194800,7),(989,560923200,6),(989,574225200,7),(989,592372800,6),(989,605674800,7),(989,624427200,6),(989,637124400,7),(989,653457600,6),(989,668574000,7),(989,687326400,6),(989,700628400,7),(989,718776000,6),(989,732078000,7),(989,750225600,6),(989,763527600,7),(989,781675200,6),(989,794977200,7),(989,813729600,6),(989,826426800,7),(989,845179200,6),(989,859690800,7),(989,876628800,6),(989,889930800,7),(989,906868800,6),(989,923194800,7),(989,939528000,6),(989,952830000,7),(989,971582400,6),(989,984279600,7),(989,1003032000,6),(989,1015729200,7),(989,1034481600,6),(989,1047178800,7),(989,1065931200,6),(989,1079233200,7),(989,1097380800,6),(989,1110682800,7),(989,1128830400,6),(989,1142132400,7),(989,1160884800,6),(989,1173582000,7),(989,1192334400,6),(989,1206846000,7),(989,1223784000,6),(989,1237086000,7),(989,1255233600,6),(989,1270350000,7),(989,1286683200,6),(989,1304823600,7),(989,1313899200,6),(989,1335668400,7),(989,1346558400,6),(989,1367118000,7),(989,1378612800,6),(989,1398567600,7),(989,1410062400,6),(989,1463281200,7),(989,1471147200,6),(989,1494730800,7),(989,1502596800,6),(989,1526180400,7),(989,1534046400,6),(989,1554606000,7),(989,1567915200,6),(989,1586055600,7),(989,1599364800,6),(989,1617505200,7),(989,1630814400,6),(989,1648954800,7),(989,1662264000,6),(989,1680404400,7),(989,1693713600,6),(989,1712458800,7),(989,1725768000,6),(989,1743908400,7),(989,1757217600,6),(989,1775358000,7),(989,1788667200,6),(989,1806807600,7),(989,1820116800,6),(989,1838257200,7),(989,1851566400,6),(989,1870311600,7),(989,1883016000,6),(989,1901761200,7),(989,1915070400,6),(989,1933210800,7),(989,1946520000,6),(989,1964660400,7),(989,1977969600,6),(989,1996110000,7),(989,2009419200,6),(989,2027559600,7),(989,2040868800,6),(989,2059614000,7),(989,2072318400,6),(989,2091063600,7),(989,2104372800,6),(989,2122513200,7),(989,2135822400,6),(989,2147483647,6),(990,-2147483648,1),(990,-1178124152,4),(990,-36619200,2),(990,-23922000,3),(990,-3355200,2),(990,7527600,3),(990,24465600,2),(990,37767600,3),(990,55915200,2),(990,69217200,3),(990,87969600,2),(990,100666800,3),(990,118209600,2),(990,132116400,3),(990,150868800,2),(990,163566000,3),(990,182318400,2),(990,195620400,3),(990,213768000,2),(990,227070000,3),(990,245217600,2),(990,258519600,3),(990,277272000,2),(990,289969200,3),(990,308721600,2),(990,321418800,3),(990,340171200,2),(990,353473200,3),(990,371620800,2),(990,384922800,5),(990,403070400,6),(990,416372400,5),(990,434520000,6),(990,447822000,5),(990,466574400,6),(990,479271600,5),(990,498024000,6),(990,510721200,5),(990,529473600,6),(990,545194800,5),(990,560923200,6),(990,574225200,5),(990,592372800,6),(990,605674800,5),(990,624427200,6),(990,637124400,5),(990,653457600,6),(990,668574000,5),(990,687326400,6),(990,700628400,5),(990,718776000,6),(990,732078000,5),(990,750225600,6),(990,763527600,5),(990,781675200,6),(990,794977200,5),(990,813729600,6),(990,826426800,5),(990,845179200,6),(990,859690800,5),(990,876628800,6),(990,889930800,5),(990,906868800,6),(990,923194800,5),(990,939528000,6),(990,952830000,5),(990,971582400,6),(990,984279600,5),(990,1003032000,6),(990,1015729200,5),(990,1034481600,6),(990,1047178800,5),(990,1065931200,6),(990,1079233200,5),(990,1097380800,6),(990,1110682800,5),(990,1128830400,6),(990,1142132400,5),(990,1160884800,6),(990,1173582000,5),(990,1192334400,6),(990,1206846000,5),(990,1223784000,6),(990,1237086000,5),(990,1255233600,6),(990,1270350000,5),(990,1286683200,6),(990,1304823600,5),(990,1313899200,6),(990,1335668400,5),(990,1346558400,6),(990,1367118000,5),(990,1378612800,6),(990,1398567600,5),(990,1410062400,6),(990,1463281200,5),(990,1471147200,6),(990,1494730800,5),(990,1502596800,6),(990,1526180400,5),(990,1534046400,6),(990,1554606000,5),(990,1567915200,6),(990,1586055600,5),(990,1599364800,6),(990,1617505200,5),(990,1630814400,6),(990,1648954800,5),(990,1662264000,6),(990,1680404400,5),(990,1693713600,6),(990,1712458800,5),(990,1725768000,6),(990,1743908400,5),(990,1757217600,6),(990,1775358000,5),(990,1788667200,6),(990,1806807600,5),(990,1820116800,6),(990,1838257200,5),(990,1851566400,6),(990,1870311600,5),(990,1883016000,6),(990,1901761200,5),(990,1915070400,6),(990,1933210800,5),(990,1946520000,6),(990,1964660400,5),(990,1977969600,6),(990,1996110000,5),(990,2009419200,6),(990,2027559600,5),(990,2040868800,6),(990,2059614000,5),(990,2072318400,6),(990,2091063600,5),(990,2104372800,6),(990,2122513200,5),(990,2135822400,6),(990,2147483647,6),(991,-2147483648,1),(991,-1402813824,3),(991,-1311534000,2),(991,-1300996800,3),(991,-933534000,2),(991,-925675200,3),(991,-902084400,2),(991,-893620800,3),(991,-870030000,2),(991,-862171200,3),(991,-775681200,2),(991,-767822400,3),(991,-744231600,2),(991,-736372800,3),(991,-144702000,2),(991,-134251200,3),(991,-113425200,2),(991,-102542400,3),(991,-86295600,2),(991,-72907200,3),(991,-54154800,2),(991,-41457600,3),(991,-21495600,2),(991,-5774400,3),(991,9954000,2),(991,25675200,3),(991,41403600,2),(991,57729600,3),(991,73458000,2),(991,87364800,3),(991,104907600,2),(991,118900800,3),(991,136357200,2),(991,150436800,3),(991,167806800,2),(991,183528000,3),(991,199256400,2),(991,215582400,3),(991,230706000,2),(991,247032000,3),(991,263365200,2),(991,276667200,3),(991,290581200,2),(991,308721600,3),(991,322030800,2),(991,340171200,3),(991,358318800,2),(991,371620800,3),(991,389768400,2),(991,403070400,3),(991,421218000,2),(991,434520000,3),(991,452667600,2),(991,466574400,3),(991,484117200,2),(991,498024000,3),(991,511333200,2),(991,529473600,3),(991,542782800,2),(991,560923200,3),(991,574837200,2),(991,592372800,3),(991,606286800,2),(991,623822400,3),(991,638946000,2),(991,655876800,3),(991,671000400,2),(991,687330000,4),(991,702450000,2),(991,718779600,4),(991,733899600,2),(991,750229200,4),(991,765349200,2),(991,781678800,4),(991,796798800,2),(991,813128400,4),(991,828853200,2),(991,844578000,4),(991,860302800,2),(991,876632400,4),(991,891147600,5),(991,909291600,4),(991,922597200,5),(991,941346000,4),(991,954651600,5),(991,972795600,4),(991,986101200,5),(991,1004245200,4),(991,1018155600,5),(991,1035694800,4),(991,1049605200,5),(991,1067144400,4),(991,1080450000,5),(991,1162098000,4),(991,1173589200,5),(991,1193547600,4),(991,1205643600,5),(991,1224997200,4),(991,1236488400,5),(991,1256446800,4),(991,1268542800,5),(991,1288501200,4),(991,1300597200,5),(991,1321160400,4),(991,1333256400,5),(991,1352005200,4),(991,1362891600,5),(991,1383454800,4),(991,1394341200,5),(991,1414904400,4),(991,1425790800,5),(991,1446354000,4),(991,1457845200,5),(991,1478408400,4),(991,1489294800,5),(991,1509858000,4),(991,1520744400,5),(991,1541307600,4),(991,1552194000,5),(991,1572757200,4),(991,1583643600,5),(991,1604206800,4),(991,1615698000,5),(991,1636261200,4),(991,1647147600,5),(991,1667710800,4),(991,1678597200,5),(991,1699160400,4),(991,1710046800,5),(991,1730610000,4),(991,1741496400,5),(991,1762059600,4),(991,1772946000,5),(991,1793509200,4),(991,1805000400,5),(991,1825563600,4),(991,1836450000,5),(991,1857013200,4),(991,1867899600,5),(991,1888462800,4),(991,1899349200,5),(991,1919912400,4),(991,1930798800,5),(991,1951362000,4),(991,1962853200,5),(991,1983416400,4),(991,1994302800,5),(991,2014866000,4),(991,2025752400,5),(991,2046315600,4),(991,2057202000,5),(991,2077765200,4),(991,2088651600,5),(991,2109214800,4),(991,2120101200,5),(991,2140664400,4),(992,228877200,0),(992,243997200,1),(992,260326800,0),(992,276051600,1),(992,291776400,0),(992,307501200,1),(992,323830800,0),(992,338950800,1),(992,354675600,0),(992,370400400,1),(992,386125200,0),(992,401850000,1),(992,417574800,0),(992,433299600,1),(992,449024400,0),(992,465354000,1),(992,481078800,0),(992,496803600,1),(992,512528400,0),(992,528253200,1),(992,543978000,0),(992,559702800,1),(992,575427600,0),(992,591152400,1),(992,606877200,0),(992,622602000,1),(992,638326800,0),(992,654656400,1),(992,670381200,0),(992,686106000,1),(992,701830800,0),(992,717555600,1),(992,733280400,0),(992,749005200,1),(992,764730000,0),(992,780454800,1),(992,796179600,0),(992,811904400,1),(992,828234000,0),(992,846378000,1),(992,859683600,0),(992,877827600,1),(992,891133200,0),(992,909277200,1),(992,922582800,0),(992,941331600,1),(992,954032400,0),(992,972781200,1),(992,985482000,0),(992,1004230800,1),(992,1017536400,0),(992,1035680400,1),(992,1048986000,0),(992,1067130000,1),(992,1080435600,0),(992,1099184400,1),(992,1111885200,0),(992,1130634000,1),(992,1143334800,0),(992,1162083600,1),(992,1174784400,0),(992,1193533200,1),(992,1206838800,0),(992,1224982800,1),(992,1238288400,0),(992,1256432400,1),(992,1269738000,0),(992,1288486800,1),(992,1301187600,0),(992,1319936400,1),(992,1332637200,0),(992,1351386000,1),(992,1364691600,0),(992,1382835600,1),(992,1396141200,0),(992,1414285200,1),(992,1427590800,0),(992,1445734800,1),(992,1459040400,0),(992,1477789200,1),(992,1490490000,0),(992,1509238800,1),(992,1521939600,0),(992,1540688400,1),(992,1553994000,0),(992,1572138000,1),(992,1585443600,0),(992,1603587600,1),(992,1616893200,0),(992,1635642000,1),(992,1648342800,0),(992,1667091600,1),(992,1679792400,0),(992,1698541200,1),(992,1711846800,0),(992,1729990800,1),(992,1743296400,0),(992,1761440400,1),(992,1774746000,0),(992,1792890000,1),(992,1806195600,0),(992,1824944400,1),(992,1837645200,0),(992,1856394000,1),(992,1869094800,0),(992,1887843600,1),(992,1901149200,0),(992,1919293200,1),(992,1932598800,0),(992,1950742800,1),(992,1964048400,0),(992,1982797200,1),(992,1995498000,0),(992,2014246800,1),(992,2026947600,0),(992,2045696400,1),(992,2058397200,0),(992,2077146000,1),(992,2090451600,0),(992,2108595600,1),(992,2121901200,0),(992,2140045200,1),(994,-1633280400,0),(994,-1615140000,1),(994,-1601830800,0),(994,-1583690400,1),(994,-880218000,2),(994,-769395600,3),(994,-765396000,1),(994,-84387600,0),(994,-68666400,1),(994,-52938000,0),(994,-37216800,1),(994,-21488400,0),(994,-5767200,1),(994,9961200,0),(994,25682400,1),(994,41410800,0),(994,57736800,1),(994,73465200,0),(994,89186400,1),(994,104914800,0),(994,120636000,1),(994,126687600,0),(994,152085600,1),(994,162370800,0),(994,183535200,1),(994,199263600,0),(994,215589600,1),(994,230713200,0),(994,247039200,1),(994,262767600,0),(994,278488800,1),(994,294217200,0),(994,309938400,1),(994,325666800,0),(994,341388000,1),(994,357116400,0),(994,372837600,1),(994,388566000,0),(994,404892000,1),(994,420015600,0),(994,436341600,1),(994,452070000,0),(994,467791200,1),(994,483519600,0),(994,499240800,1),(994,514969200,0),(994,530690400,1),(994,544604400,0),(994,562140000,1),(994,576054000,0),(994,594194400,1),(994,607503600,0),(994,625644000,1),(994,638953200,0),(994,657093600,1),(994,671007600,0),(994,688543200,1),(994,702457200,0),(994,719992800,1),(994,733906800,0),(994,752047200,1),(994,765356400,0),(994,783496800,1),(994,796806000,0),(994,814946400,1),(994,828860400,0),(994,846396000,1),(994,860310000,0),(994,877845600,1),(994,891759600,0),(994,909295200,1),(994,923209200,0),(994,941349600,1),(994,954658800,0),(994,972799200,1),(994,986108400,0),(994,1004248800,1),(994,1018162800,0),(994,1035698400,1),(994,1049612400,0),(994,1067148000,1),(994,1081062000,0),(994,1099202400,1),(994,1112511600,0),(994,1130652000,1),(994,1143961200,0),(994,1162101600,1),(994,1173596400,0),(994,1194156000,1),(994,1205046000,0),(994,1225605600,1),(994,1236495600,0),(994,1257055200,1),(994,1268550000,0),(994,1289109600,1),(994,1299999600,0),(994,1320559200,1),(994,1331449200,0),(994,1352008800,1),(994,1362898800,0),(994,1383458400,1),(994,1394348400,0),(994,1414908000,1),(994,1425798000,0),(994,1446357600,1),(994,1457852400,0),(994,1478412000,1),(994,1489302000,0),(994,1509861600,1),(994,1520751600,0),(994,1541311200,1),(994,1552201200,0),(994,1572760800,1),(994,1583650800,0),(994,1604210400,1),(994,1615705200,0),(994,1636264800,1),(994,1647154800,0),(994,1667714400,1),(994,1678604400,0),(994,1699164000,1),(994,1710054000,0),(994,1730613600,1),(994,1741503600,0),(994,1762063200,1),(994,1772953200,0),(994,1793512800,1),(994,1805007600,0),(994,1825567200,1),(994,1836457200,0),(994,1857016800,1),(994,1867906800,0),(994,1888466400,1),(994,1899356400,0),(994,1919916000,1),(994,1930806000,0),(994,1951365600,1),(994,1962860400,0),(994,1983420000,1),(994,1994310000,0),(994,2014869600,1),(994,2025759600,0),(994,2046319200,1),(994,2057209200,0),(994,2077768800,1),(994,2088658800,0),(994,2109218400,1),(994,2120108400,0),(994,2140668000,1),(995,-2147483648,2),(995,-929844000,1),(995,-923108400,2),(995,-906170400,1),(995,-892868400,2),(995,-875844000,1),(995,-857790000,2),(995,-844308000,1),(995,-825822000,2),(995,-812685600,1),(995,-794199600,2),(995,-779853600,1),(995,-762663600,2),(995,-399088800,1),(995,-386650800,2),(995,-368330400,1),(995,-355114800,2),(995,-336790800,1),(995,-323654400,2),(995,-305168400,1),(995,-292032000,2),(995,-273632400,1),(995,-260496000,2),(995,-242096400,1),(995,-228960000,2),(995,-210560400,1),(995,-197424000,2),(995,-178938000,1),(995,-165801600,2),(995,-147402000,1),(995,-134265600,2),(995,-115866000,1),(995,-102643200,2),(995,-84330000,1),(995,-71107200,2),(995,-52707600,1),(995,-39484800,2),(995,-21171600,1),(995,-7948800,2),(995,10364400,1),(995,23587200,2),(995,41900400,1),(995,55123200,2),(995,73522800,1),(995,86745600,2),(995,105058800,1),(995,118281600,2),(995,136594800,1),(995,149817600,2),(995,168130800,1),(995,181353600,2),(995,199753200,1),(995,212976000,2),(995,231289200,1),(995,244512000,2),(995,262825200,1),(995,276048000,2),(995,294361200,1),(995,307584000,2),(995,325983600,1),(995,339206400,2),(995,357519600,1),(995,370742400,2),(995,396399600,1),(995,402278400,2),(995,426812400,1),(995,433814400,2),(995,452214000,1),(995,465436800,2),(995,483750000,1),(995,496972800,2),(995,515286000,1),(995,528508800,2),(995,546822000,1),(995,560044800,2),(995,578444400,1),(995,591667200,2),(995,610412400,1),(995,623203200,2),(995,641516400,1),(995,654739200,2),(995,673052400,1),(995,686275200,2),(995,704674800,1),(995,717897600,2),(995,736210800,1),(995,749433600,2),(995,767746800,1),(995,780969600,2),(995,799020000,3),(995,812322000,2),(995,830469600,3),(995,843771600,2),(995,861919200,3),(995,875221200,2),(995,893368800,3),(995,906670800,2),(995,925423200,3),(995,938725200,2),(995,956872800,3),(995,970174800,2),(995,988322400,3),(995,1001624400,2),(995,1019772000,3),(995,1033074000,2),(995,1051221600,3),(995,1064523600,2),(995,1083276000,3),(995,1096578000,2),(995,1114725600,3),(995,1128027600,2),(995,1146175200,3),(995,1158872400,2),(995,1177624800,3),(995,1189112400,2),(995,1209074400,3),(995,1219957200,2),(995,1240524000,3),(995,1250802000,2),(995,1272578400,3),(995,1281474000,2),(995,1284069600,1),(995,1285880400,2),(995,1400191200,1),(995,1403816400,2),(995,1406844000,1),(995,1411678800,2),(996,-2147483648,1),(996,-1691962479,2),(996,-1680471279,4),(996,-1664143200,3),(996,-1650146400,4),(996,-1633903200,3),(996,-1617487200,4),(996,-1601848800,3),(996,-1586037600,4),(996,-1570399200,3),(996,-1552168800,4),(996,-1538344800,3),(996,-1522533600,4),(996,-1517011200,6),(996,-1507500000,5),(996,-1490565600,4),(996,-1473631200,5),(996,-1460930400,4),(996,-1442786400,5),(996,-1428876000,4),(996,-1410732000,5),(996,-1396216800,4),(996,-1379282400,5),(996,-1364767200,4),(996,-1348437600,5),(996,-1333317600,4),(996,-1315778400,5),(996,-1301263200,4),(996,-1284328800,5),(996,-1269813600,4),(996,-1253484000,5),(996,-1238364000,4),(996,-1221429600,5),(996,-1206914400,4),(996,-1189980000,5),(996,-1175464800,4),(996,-1159135200,5),(996,-1143410400,4),(996,-1126476000,5),(996,-1111960800,4),(996,-1095631200,5),(996,-1080511200,4),(996,-1063576800,5),(996,-1049061600,4),(996,-1032127200,5),(996,-1017612000,4),(996,-1001282400,5),(996,-986162400,4),(996,-969228000,5),(996,-950479200,4),(996,-942012000,5),(996,-733356000,4),(996,-719445600,5),(996,-699487200,4),(996,-684972000,5),(996,-668037600,4),(996,-654732000,5),(996,-636588000,4),(996,-622072800,5),(996,-605743200,4),(996,-590623200,5),(996,-574293600,4),(996,-558568800,5),(996,-542239200,4),(996,-527119200,5),(996,-512604000,4),(996,-496274400,5),(996,-481154400,4),(996,-464220000,5),(996,-449704800,4),(996,-432165600,5),(996,-417650400,4),(996,-401320800,5),(996,-386200800,4),(996,-369266400,5),(996,-354751200,4),(996,-337816800,5),(996,-323301600,4),(996,-306972000,5),(996,-291852000,4),(996,-276732000,5),(996,-257983200,4),(996,-245282400,5),(996,-226533600,4),(996,-213228000,5),(996,-195084000,4),(996,-182383200,5),(996,-163634400,4),(996,-150933600,5),(996,-132184800,4),(996,-119484000,5),(996,-100735200,4),(996,-88034400,5),(996,-68680800,4),(996,-59004000,5),(996,-37242000,9),(996,57722400,7),(996,69818400,8),(996,89172000,7),(996,101268000,8),(996,120621600,7),(996,132717600,8),(996,152071200,7),(996,164167200,8),(996,183520800,7),(996,196221600,8),(996,214970400,7),(996,227671200,8),(996,246420000,7),(996,259120800,8),(996,278474400,7),(996,290570400,8),(996,309924000,7),(996,322020000,8),(996,341373600,7),(996,354675600,8),(996,372819600,7),(996,386125200,8),(996,404269200,7),(996,417574800,8),(996,435718800,7),(996,449024400,8),(996,467773200,7),(996,481078800,8),(996,499222800,7),(996,512528400,8),(996,530672400,7),(996,543978000,8),(996,562122000,7),(996,575427600,8),(996,593571600,7),(996,606877200,8),(996,625626000,7),(996,638326800,8),(996,657075600,7),(996,670381200,8),(996,688525200,7),(996,701830800,8),(996,719974800,7),(996,733280400,8),(996,751424400,7),(996,764730000,8),(996,782874000,7),(996,796179600,8),(996,814323600,7),(996,828234000,8),(996,846378000,7),(996,859683600,8),(996,877827600,7),(996,891133200,8),(996,909277200,7),(996,922582800,8),(996,941331600,7),(996,954032400,8),(996,972781200,7),(996,985482000,8),(996,1004230800,7),(996,1017536400,8),(996,1035680400,7),(996,1048986000,8),(996,1067130000,7),(996,1080435600,8),(996,1099184400,7),(996,1111885200,8),(996,1130634000,7),(996,1143334800,8),(996,1162083600,7),(996,1174784400,8),(996,1193533200,7),(996,1206838800,8),(996,1224982800,7),(996,1238288400,8),(996,1256432400,7),(996,1269738000,8),(996,1288486800,7),(996,1301187600,8),(996,1319936400,7),(996,1332637200,8),(996,1351386000,7),(996,1364691600,8),(996,1382835600,7),(996,1396141200,8),(996,1414285200,7),(996,1427590800,8),(996,1445734800,7),(996,1459040400,8),(996,1477789200,7),(996,1490490000,8),(996,1509238800,7),(996,1521939600,8),(996,1540688400,7),(996,1553994000,8),(996,1572138000,7),(996,1585443600,8),(996,1603587600,7),(996,1616893200,8),(996,1635642000,7),(996,1648342800,8),(996,1667091600,7),(996,1679792400,8),(996,1698541200,7),(996,1711846800,8),(996,1729990800,7),(996,1743296400,8),(996,1761440400,7),(996,1774746000,8),(996,1792890000,7),(996,1806195600,8),(996,1824944400,7),(996,1837645200,8),(996,1856394000,7),(996,1869094800,8),(996,1887843600,7),(996,1901149200,8),(996,1919293200,7),(996,1932598800,8),(996,1950742800,7),(996,1964048400,8),(996,1982797200,7),(996,1995498000,8),(996,2014246800,7),(996,2026947600,8),(996,2045696400,7),(996,2058397200,8),(996,2077146000,7),(996,2090451600,8),(996,2108595600,7),(996,2121901200,8),(996,2140045200,7),(999,-2147483648,0),(999,2147483647,0),(1000,-2147483648,0),(1000,2147483647,0),(1001,-2147483648,0),(1001,2147483647,0),(1002,-2147483648,0),(1002,2147483647,0),(1003,-2147483648,0),(1003,2147483647,0),(1004,-2147483648,0),(1004,2147483647,0),(1005,-2147483648,0),(1005,2147483647,0),(1006,-2147483648,0),(1006,2147483647,0),(1007,-2147483648,0),(1007,2147483647,0),(1008,-2147483648,0),(1008,2147483647,0),(1009,-2147483648,0),(1009,2147483647,0),(1010,-2147483648,0),(1010,2147483647,0),(1012,-2147483648,0),(1012,2147483647,0),(1013,-2147483648,0),(1013,2147483647,0),(1014,-2147483648,0),(1014,2147483647,0),(1015,-2147483648,0),(1015,2147483647,0),(1016,-2147483648,0),(1016,2147483647,0),(1017,-2147483648,0),(1017,2147483647,0),(1018,-2147483648,0),(1018,2147483647,0),(1019,-2147483648,0),(1019,2147483647,0),(1020,-2147483648,0),(1020,2147483647,0),(1021,-2147483648,0),(1021,2147483647,0),(1022,-2147483648,0),(1022,2147483647,0),(1023,-2147483648,0),(1023,2147483647,0),(1024,-2147483648,0),(1024,2147483647,0),(1025,-2147483648,0),(1025,2147483647,0),(1032,-2147483648,2),(1032,-1693700372,1),(1032,-1680484772,2),(1032,-1663453172,3),(1032,-1650147572,4),(1032,-1633213172,3),(1032,-1617488372,4),(1032,-1601158772,3),(1032,-1586038772,4),(1032,-1569709172,3),(1032,-1554589172,4),(1032,-1538259572,3),(1032,-1523139572,4),(1032,-1507501172,3),(1032,-1490566772,4),(1032,-1470176372,3),(1032,-1459117172,4),(1032,-1443997172,3),(1032,-1427667572,4),(1032,-1406672372,3),(1032,-1396217972,4),(1032,-1376950772,3),(1032,-1364768372,4),(1032,-1345414772,3),(1032,-1333318772,4),(1032,-1313792372,3),(1032,-1301264372,4),(1032,-1282256372,3),(1032,-1269814772,4),(1032,-1250720372,3),(1032,-1238365172,4),(1032,-1219184372,3),(1032,-1206915572,4),(1032,-1186957172,3),(1032,-1175465972,4),(1032,-1156025972,3),(1032,-1143411572,4),(1032,-1124489972,3),(1032,-1111961972,4),(1032,-1092953972,3),(1032,-1080512372,4),(1032,-1061331572,3),(1032,-1049062772,4),(1032,-1029190772,3),(1032,-1025745572,7),(1032,-1017613200,5),(1032,-998259600,6),(1032,-986163600,5),(1032,-966723600,6),(1032,-954109200,5),(1032,-935022000,10),(1032,-857257200,8),(1032,-844556400,9),(1032,-828226800,8),(1032,-812502000,9),(1032,-796777200,8),(1032,-781052400,9),(1032,-766623600,8),(1032,220921200,13),(1032,228877200,11),(1032,243997200,12),(1032,260326800,11),(1032,276051600,12),(1032,291776400,11),(1032,307501200,12),(1032,323830800,11),(1032,338950800,12),(1032,354675600,11),(1032,370400400,12),(1032,386125200,11),(1032,401850000,12),(1032,417574800,11),(1032,433299600,12),(1032,449024400,11),(1032,465354000,12),(1032,481078800,11),(1032,496803600,12),(1032,512528400,11),(1032,528253200,12),(1032,543978000,11),(1032,559702800,12),(1032,575427600,11),(1032,591152400,12),(1032,606877200,11),(1032,622602000,12),(1032,638326800,11),(1032,654656400,12),(1032,670381200,11),(1032,686106000,12),(1032,701830800,11),(1032,717555600,12),(1032,733280400,11),(1032,749005200,12),(1032,764730000,11),(1032,780454800,12),(1032,796179600,11),(1032,811904400,12),(1032,828234000,11),(1032,846378000,12),(1032,859683600,11),(1032,877827600,12),(1032,891133200,11),(1032,909277200,12),(1032,922582800,11),(1032,941331600,12),(1032,954032400,11),(1032,972781200,12),(1032,985482000,11),(1032,1004230800,12),(1032,1017536400,11),(1032,1035680400,12),(1032,1048986000,11),(1032,1067130000,12),(1032,1080435600,11),(1032,1099184400,12),(1032,1111885200,11),(1032,1130634000,12),(1032,1143334800,11),(1032,1162083600,12),(1032,1174784400,11),(1032,1193533200,12),(1032,1206838800,11),(1032,1224982800,12),(1032,1238288400,11),(1032,1256432400,12),(1032,1269738000,11),(1032,1288486800,12),(1032,1301187600,11),(1032,1319936400,12),(1032,1332637200,11),(1032,1351386000,12),(1032,1364691600,11),(1032,1382835600,12),(1032,1396141200,11),(1032,1414285200,12),(1032,1427590800,11),(1032,1445734800,12),(1032,1459040400,11),(1032,1477789200,12),(1032,1490490000,11),(1032,1509238800,12),(1032,1521939600,11),(1032,1540688400,12),(1032,1553994000,11),(1032,1572138000,12),(1032,1585443600,11),(1032,1603587600,12),(1032,1616893200,11),(1032,1635642000,12),(1032,1648342800,11),(1032,1667091600,12),(1032,1679792400,11),(1032,1698541200,12),(1032,1711846800,11),(1032,1729990800,12),(1032,1743296400,11),(1032,1761440400,12),(1032,1774746000,11),(1032,1792890000,12),(1032,1806195600,11),(1032,1824944400,12),(1032,1837645200,11),(1032,1856394000,12),(1032,1869094800,11),(1032,1887843600,12),(1032,1901149200,11),(1032,1919293200,12),(1032,1932598800,11),(1032,1950742800,12),(1032,1964048400,11),(1032,1982797200,12),(1032,1995498000,11),(1032,2014246800,12),(1032,2026947600,11),(1032,2045696400,12),(1032,2058397200,11),(1032,2077146000,12),(1032,2090451600,11),(1032,2108595600,12),(1032,2121901200,11),(1032,2140045200,12),(1033,-2147483648,1),(1033,-733881600,2),(1033,481078800,3),(1033,496803600,4),(1033,512528400,3),(1033,528253200,4),(1033,543978000,3),(1033,559702800,4),(1033,575427600,3),(1033,591152400,4),(1033,606877200,3),(1033,622602000,4),(1033,638326800,3),(1033,654656400,4),(1033,670381200,3),(1033,686106000,4),(1033,701830800,3),(1033,717555600,4),(1033,733280400,3),(1033,749005200,4),(1033,764730000,3),(1033,780454800,4),(1033,796179600,3),(1033,811904400,4),(1033,828234000,3),(1033,846378000,4),(1033,859683600,3),(1033,877827600,4),(1033,891133200,3),(1033,909277200,4),(1033,922582800,3),(1033,941331600,4),(1033,954032400,3),(1033,972781200,4),(1033,985482000,3),(1033,1004230800,4),(1033,1017536400,3),(1033,1035680400,4),(1033,1048986000,3),(1033,1067130000,4),(1033,1080435600,3),(1033,1099184400,4),(1033,1111885200,3),(1033,1130634000,4),(1033,1143334800,3),(1033,1162083600,4),(1033,1174784400,3),(1033,1193533200,4),(1033,1206838800,3),(1033,1224982800,4),(1033,1238288400,3),(1033,1256432400,4),(1033,1269738000,3),(1033,1288486800,4),(1033,1301187600,3),(1033,1319936400,4),(1033,1332637200,3),(1033,1351386000,4),(1033,1364691600,3),(1033,1382835600,4),(1033,1396141200,3),(1033,1414285200,4),(1033,1427590800,3),(1033,1445734800,4),(1033,1459040400,3),(1033,1477789200,4),(1033,1490490000,3),(1033,1509238800,4),(1033,1521939600,3),(1033,1540688400,4),(1033,1553994000,3),(1033,1572138000,4),(1033,1585443600,3),(1033,1603587600,4),(1033,1616893200,3),(1033,1635642000,4),(1033,1648342800,3),(1033,1667091600,4),(1033,1679792400,3),(1033,1698541200,4),(1033,1711846800,3),(1033,1729990800,4),(1033,1743296400,3),(1033,1761440400,4),(1033,1774746000,3),(1033,1792890000,4),(1033,1806195600,3),(1033,1824944400,4),(1033,1837645200,3),(1033,1856394000,4),(1033,1869094800,3),(1033,1887843600,4),(1033,1901149200,3),(1033,1919293200,4),(1033,1932598800,3),(1033,1950742800,4),(1033,1964048400,3),(1033,1982797200,4),(1033,1995498000,3),(1033,2014246800,4),(1033,2026947600,3),(1033,2045696400,4),(1033,2058397200,3),(1033,2077146000,4),(1033,2090451600,3),(1033,2108595600,4),(1033,2121901200,3),(1033,2140045200,4),(1034,-2147483648,0),(1034,-1441249932,1),(1034,-1247540400,3),(1034,354916800,2),(1034,370724400,3),(1034,386452800,2),(1034,402260400,3),(1034,417988800,2),(1034,433796400,3),(1034,449611200,2),(1034,465343200,4),(1034,481068000,5),(1034,496792800,4),(1034,512517600,5),(1034,528242400,4),(1034,543967200,5),(1034,559692000,4),(1034,575416800,5),(1034,591141600,4),(1034,606866400,6),(1034,622594800,7),(1034,638319600,6),(1034,654649200,7),(1034,670374000,4),(1034,701820000,6),(1034,717548400,7),(1034,733273200,6),(1034,748998000,7),(1034,764722800,6),(1034,780447600,7),(1034,796172400,6),(1034,811897200,7),(1034,828226800,6),(1034,846370800,7),(1034,859676400,6),(1034,877820400,7),(1034,891126000,6),(1034,909270000,7),(1034,922575600,6),(1034,941324400,7),(1034,954025200,6),(1034,972774000,7),(1034,985474800,6),(1034,1004223600,7),(1034,1017529200,6),(1034,1035673200,7),(1034,1048978800,6),(1034,1067122800,7),(1034,1080428400,6),(1034,1099177200,7),(1034,1111878000,6),(1034,1130626800,7),(1034,1143327600,6),(1034,1162076400,7),(1034,1174777200,6),(1034,1193526000,7),(1034,1206831600,6),(1034,1224975600,7),(1034,1238281200,6),(1034,1256425200,7),(1034,1269730800,6),(1034,1288479600,7),(1034,1301180400,4),(1034,1414274400,7),(1034,1459033200,4),(1034,2147483647,4),(1035,-2147483648,1),(1035,-1686101632,3),(1035,-1182996000,2),(1035,-1178161200,3),(1035,-906861600,2),(1035,-904878000,5),(1035,-857257200,4),(1035,-844477200,5),(1035,-828237600,4),(1035,-812422800,3),(1035,-552362400,2),(1035,-541652400,3),(1035,166485600,6),(1035,186184800,7),(1035,198028800,6),(1035,213753600,7),(1035,228873600,6),(1035,244080000,7),(1035,260323200,6),(1035,275446800,3),(1035,291798000,2),(1035,307407600,3),(1035,323388000,2),(1035,338936400,3),(1035,354675600,8),(1035,370400400,9),(1035,386125200,8),(1035,401850000,9),(1035,417574800,8),(1035,433299600,9),(1035,449024400,8),(1035,465354000,9),(1035,481078800,8),(1035,496803600,9),(1035,512528400,8),(1035,528253200,9),(1035,543978000,8),(1035,559702800,9),(1035,575427600,8),(1035,591152400,9),(1035,606877200,8),(1035,622602000,9),(1035,638326800,8),(1035,654656400,9),(1035,670381200,8),(1035,686106000,9),(1035,701830800,8),(1035,717555600,9),(1035,733280400,8),(1035,749005200,9),(1035,764730000,8),(1035,780454800,9),(1035,796179600,8),(1035,811904400,9),(1035,828234000,8),(1035,846378000,9),(1035,859683600,8),(1035,877827600,9),(1035,891133200,8),(1035,909277200,9),(1035,922582800,8),(1035,941331600,9),(1035,954032400,8),(1035,972781200,9),(1035,985482000,8),(1035,1004230800,9),(1035,1017536400,8),(1035,1035680400,9),(1035,1048986000,8),(1035,1067130000,9),(1035,1080435600,8),(1035,1099184400,9),(1035,1111885200,8),(1035,1130634000,9),(1035,1143334800,8),(1035,1162083600,9),(1035,1174784400,8),(1035,1193533200,9),(1035,1206838800,8),(1035,1224982800,9),(1035,1238288400,8),(1035,1256432400,9),(1035,1269738000,8),(1035,1288486800,9),(1035,1301187600,8),(1035,1319936400,9),(1035,1332637200,8),(1035,1351386000,9),(1035,1364691600,8),(1035,1382835600,9),(1035,1396141200,8),(1035,1414285200,9),(1035,1427590800,8),(1035,1445734800,9),(1035,1459040400,8),(1035,1477789200,9),(1035,1490490000,8),(1035,1509238800,9),(1035,1521939600,8),(1035,1540688400,9),(1035,1553994000,8),(1035,1572138000,9),(1035,1585443600,8),(1035,1603587600,9),(1035,1616893200,8),(1035,1635642000,9),(1035,1648342800,8),(1035,1667091600,9),(1035,1679792400,8),(1035,1698541200,9),(1035,1711846800,8),(1035,1729990800,9),(1035,1743296400,8),(1035,1761440400,9),(1035,1774746000,8),(1035,1792890000,9),(1035,1806195600,8),(1035,1824944400,9),(1035,1837645200,8),(1035,1856394000,9),(1035,1869094800,8),(1035,1887843600,9),(1035,1901149200,8),(1035,1919293200,9),(1035,1932598800,8),(1035,1950742800,9),(1035,1964048400,8),(1035,1982797200,9),(1035,1995498000,8),(1035,2014246800,9),(1035,2026947600,8),(1035,2045696400,9),(1035,2058397200,8),(1035,2077146000,9),(1035,2090451600,8),(1035,2108595600,9),(1035,2121901200,8),(1035,2140045200,9),(1036,-2147483648,2),(1036,-1691964000,1),(1036,-1680472800,2),(1036,-1664143200,1),(1036,-1650146400,2),(1036,-1633903200,1),(1036,-1617487200,2),(1036,-1601848800,1),(1036,-1586037600,2),(1036,-1570399200,1),(1036,-1552168800,2),(1036,-1538344800,1),(1036,-1522533600,2),(1036,-1507500000,1),(1036,-1490565600,2),(1036,-1473631200,1),(1036,-1460930400,2),(1036,-1442786400,1),(1036,-1428876000,2),(1036,-1410732000,1),(1036,-1396216800,2),(1036,-1379282400,1),(1036,-1364767200,2),(1036,-1348437600,1),(1036,-1333317600,2),(1036,-1315778400,1),(1036,-1301263200,2),(1036,-1284328800,1),(1036,-1269813600,2),(1036,-1253484000,1),(1036,-1238364000,2),(1036,-1221429600,1),(1036,-1206914400,2),(1036,-1189980000,1),(1036,-1175464800,2),(1036,-1159135200,1),(1036,-1143410400,2),(1036,-1126476000,1),(1036,-1111960800,2),(1036,-1095631200,1),(1036,-1080511200,2),(1036,-1063576800,1),(1036,-1049061600,2),(1036,-1032127200,1),(1036,-1017612000,2),(1036,-1001282400,1),(1036,-986162400,2),(1036,-969228000,1),(1036,-950479200,2),(1036,-942012000,1),(1036,-904518000,3),(1036,-896050800,1),(1036,-875487600,3),(1036,-864601200,1),(1036,-844038000,3),(1036,-832546800,1),(1036,-812588400,3),(1036,-798073200,1),(1036,-781052400,3),(1036,-772066800,1),(1036,-764805600,2),(1036,-748476000,1),(1036,-733356000,2),(1036,-719445600,1),(1036,-717030000,3),(1036,-706748400,1),(1036,-699487200,2),(1036,-687996000,1),(1036,-668037600,2),(1036,-654732000,1),(1036,-636588000,2),(1036,-622072800,1),(1036,-605743200,2),(1036,-590623200,1),(1036,-574293600,2),(1036,-558568800,1),(1036,-542239200,2),(1036,-527119200,1),(1036,-512604000,2),(1036,-496274400,1),(1036,-481154400,2),(1036,-464220000,1),(1036,-449704800,2),(1036,-432165600,1),(1036,-417650400,2),(1036,-401320800,1),(1036,-386200800,2),(1036,-369266400,1),(1036,-354751200,2),(1036,-337816800,1),(1036,-323301600,2),(1036,-306972000,1),(1036,-291852000,2),(1036,-276732000,1),(1036,-257983200,2),(1036,-245282400,1),(1036,-226533600,2),(1036,-213228000,1),(1036,-195084000,2),(1036,-182383200,1),(1036,-163634400,2),(1036,-150933600,1),(1036,-132184800,2),(1036,-119484000,1),(1036,-100735200,2),(1036,-88034400,1),(1036,-68680800,2),(1036,-59004000,1),(1036,-37242000,4),(1036,57722400,6),(1036,69818400,1),(1036,89172000,2),(1036,101268000,1),(1036,120621600,2),(1036,132717600,1),(1036,152071200,2),(1036,164167200,1),(1036,183520800,2),(1036,196221600,1),(1036,214970400,2),(1036,227671200,1),(1036,246420000,2),(1036,259120800,1),(1036,278474400,2),(1036,290570400,1),(1036,309924000,2),(1036,322020000,1),(1036,341373600,2),(1036,354675600,5),(1036,372819600,6),(1036,386125200,5),(1036,404269200,6),(1036,417574800,5),(1036,435718800,6),(1036,449024400,5),(1036,467773200,6),(1036,481078800,5),(1036,499222800,6),(1036,512528400,5),(1036,530672400,6),(1036,543978000,5),(1036,562122000,6),(1036,575427600,5),(1036,593571600,6),(1036,606877200,5),(1036,625626000,6),(1036,638326800,5),(1036,657075600,6),(1036,670381200,5),(1036,688525200,6),(1036,701830800,5),(1036,719974800,6),(1036,733280400,5),(1036,751424400,6),(1036,764730000,5),(1036,782874000,6),(1036,796179600,5),(1036,814323600,6),(1036,820454400,7),(1036,828234000,5),(1036,846378000,6),(1036,859683600,5),(1036,877827600,6),(1036,891133200,5),(1036,909277200,6),(1036,922582800,5),(1036,941331600,6),(1036,954032400,5),(1036,972781200,6),(1036,985482000,5),(1036,1004230800,6),(1036,1017536400,5),(1036,1035680400,6),(1036,1048986000,5),(1036,1067130000,6),(1036,1080435600,5),(1036,1099184400,6),(1036,1111885200,5),(1036,1130634000,6),(1036,1143334800,5),(1036,1162083600,6),(1036,1174784400,5),(1036,1193533200,6),(1036,1206838800,5),(1036,1224982800,6),(1036,1238288400,5),(1036,1256432400,6),(1036,1269738000,5),(1036,1288486800,6),(1036,1301187600,5),(1036,1319936400,6),(1036,1332637200,5),(1036,1351386000,6),(1036,1364691600,5),(1036,1382835600,6),(1036,1396141200,5),(1036,1414285200,6),(1036,1427590800,5),(1036,1445734800,6),(1036,1459040400,5),(1036,1477789200,6),(1036,1490490000,5),(1036,1509238800,6),(1036,1521939600,5),(1036,1540688400,6),(1036,1553994000,5),(1036,1572138000,6),(1036,1585443600,5),(1036,1603587600,6),(1036,1616893200,5),(1036,1635642000,6),(1036,1648342800,5),(1036,1667091600,6),(1036,1679792400,5),(1036,1698541200,6),(1036,1711846800,5),(1036,1729990800,6),(1036,1743296400,5),(1036,1761440400,6),(1036,1774746000,5),(1036,1792890000,6),(1036,1806195600,5),(1036,1824944400,6),(1036,1837645200,5),(1036,1856394000,6),(1036,1869094800,5),(1036,1887843600,6),(1036,1901149200,5),(1036,1919293200,6),(1036,1932598800,5),(1036,1950742800,6),(1036,1964048400,5),(1036,1982797200,6),(1036,1995498000,5),(1036,2014246800,6),(1036,2026947600,5),(1036,2045696400,6),(1036,2058397200,5),(1036,2077146000,6),(1036,2090451600,5),(1036,2108595600,6),(1036,2121901200,5),(1036,2140045200,6),(1037,-2147483648,1),(1037,-905824800,4),(1037,-857257200,2),(1037,-844556400,3),(1037,-828226800,2),(1037,-812502000,3),(1037,-796777200,2),(1037,-788922000,1),(1037,-777942000,3),(1037,-766623600,2),(1037,407199600,1),(1037,417574800,5),(1037,433299600,6),(1037,449024400,5),(1037,465354000,6),(1037,481078800,5),(1037,496803600,6),(1037,512528400,5),(1037,528253200,6),(1037,543978000,5),(1037,559702800,6),(1037,575427600,5),(1037,591152400,6),(1037,606877200,5),(1037,622602000,6),(1037,638326800,5),(1037,654656400,6),(1037,670381200,5),(1037,686106000,6),(1037,701830800,5),(1037,717555600,6),(1037,733280400,5),(1037,749005200,6),(1037,764730000,5),(1037,780454800,6),(1037,796179600,5),(1037,811904400,6),(1037,828234000,5),(1037,846378000,6),(1037,859683600,5),(1037,877827600,6),(1037,891133200,5),(1037,909277200,6),(1037,922582800,5),(1037,941331600,6),(1037,954032400,5),(1037,972781200,6),(1037,985482000,5),(1037,1004230800,6),(1037,1017536400,5),(1037,1035680400,6),(1037,1048986000,5),(1037,1067130000,6),(1037,1080435600,5),(1037,1099184400,6),(1037,1111885200,5),(1037,1130634000,6),(1037,1143334800,5),(1037,1162083600,6),(1037,1174784400,5),(1037,1193533200,6),(1037,1206838800,5),(1037,1224982800,6),(1037,1238288400,5),(1037,1256432400,6),(1037,1269738000,5),(1037,1288486800,6),(1037,1301187600,5),(1037,1319936400,6),(1037,1332637200,5),(1037,1351386000,6),(1037,1364691600,5),(1037,1382835600,6),(1037,1396141200,5),(1037,1414285200,6),(1037,1427590800,5),(1037,1445734800,6),(1037,1459040400,5),(1037,1477789200,6),(1037,1490490000,5),(1037,1509238800,6),(1037,1521939600,5),(1037,1540688400,6),(1037,1553994000,5),(1037,1572138000,6),(1037,1585443600,5),(1037,1603587600,6),(1037,1616893200,5),(1037,1635642000,6),(1037,1648342800,5),(1037,1667091600,6),(1037,1679792400,5),(1037,1698541200,6),(1037,1711846800,5),(1037,1729990800,6),(1037,1743296400,5),(1037,1761440400,6),(1037,1774746000,5),(1037,1792890000,6),(1037,1806195600,5),(1037,1824944400,6),(1037,1837645200,5),(1037,1856394000,6),(1037,1869094800,5),(1037,1887843600,6),(1037,1901149200,5),(1037,1919293200,6),(1037,1932598800,5),(1037,1950742800,6),(1037,1964048400,5),(1037,1982797200,6),(1037,1995498000,5),(1037,2014246800,6),(1037,2026947600,5),(1037,2045696400,6),(1037,2058397200,5),(1037,2077146000,6),(1037,2090451600,5),(1037,2108595600,6),(1037,2121901200,5),(1037,2140045200,6),(1038,-2147483648,2),(1038,-1693706400,1),(1038,-1680483600,2),(1038,-1663455600,3),(1038,-1650150000,4),(1038,-1632006000,3),(1038,-1618700400,4),(1038,-938905200,3),(1038,-857257200,4),(1038,-844556400,3),(1038,-828226800,4),(1038,-812502000,3),(1038,-796777200,4),(1038,-781052400,3),(1038,-776563200,5),(1038,-765936000,1),(1038,-761180400,4),(1038,-757386000,2),(1038,-748479600,3),(1038,-733273200,4),(1038,-717631200,3),(1038,-714610800,6),(1038,-710380800,1),(1038,-701910000,4),(1038,-684975600,3),(1038,-670460400,4),(1038,-654130800,3),(1038,-639010800,4),(1038,315529200,2),(1038,323830800,7),(1038,338950800,8),(1038,354675600,7),(1038,370400400,8),(1038,386125200,7),(1038,401850000,8),(1038,417574800,7),(1038,433299600,8),(1038,449024400,7),(1038,465354000,8),(1038,481078800,7),(1038,496803600,8),(1038,512528400,7),(1038,528253200,8),(1038,543978000,7),(1038,559702800,8),(1038,575427600,7),(1038,591152400,8),(1038,606877200,7),(1038,622602000,8),(1038,638326800,7),(1038,654656400,8),(1038,670381200,7),(1038,686106000,8),(1038,701830800,7),(1038,717555600,8),(1038,733280400,7),(1038,749005200,8),(1038,764730000,7),(1038,780454800,8),(1038,796179600,7),(1038,811904400,8),(1038,828234000,7),(1038,846378000,8),(1038,859683600,7),(1038,877827600,8),(1038,891133200,7),(1038,909277200,8),(1038,922582800,7),(1038,941331600,8),(1038,954032400,7),(1038,972781200,8),(1038,985482000,7),(1038,1004230800,8),(1038,1017536400,7),(1038,1035680400,8),(1038,1048986000,7),(1038,1067130000,8),(1038,1080435600,7),(1038,1099184400,8),(1038,1111885200,7),(1038,1130634000,8),(1038,1143334800,7),(1038,1162083600,8),(1038,1174784400,7),(1038,1193533200,8),(1038,1206838800,7),(1038,1224982800,8),(1038,1238288400,7),(1038,1256432400,8),(1038,1269738000,7),(1038,1288486800,8),(1038,1301187600,7),(1038,1319936400,8),(1038,1332637200,7),(1038,1351386000,8),(1038,1364691600,7),(1038,1382835600,8),(1038,1396141200,7),(1038,1414285200,8),(1038,1427590800,7),(1038,1445734800,8),(1038,1459040400,7),(1038,1477789200,8),(1038,1490490000,7),(1038,1509238800,8),(1038,1521939600,7),(1038,1540688400,8),(1038,1553994000,7),(1038,1572138000,8),(1038,1585443600,7),(1038,1603587600,8),(1038,1616893200,7),(1038,1635642000,8),(1038,1648342800,7),(1038,1667091600,8),(1038,1679792400,7),(1038,1698541200,8),(1038,1711846800,7),(1038,1729990800,8),(1038,1743296400,7),(1038,1761440400,8),(1038,1774746000,7),(1038,1792890000,8),(1038,1806195600,7),(1038,1824944400,8),(1038,1837645200,7),(1038,1856394000,8),(1038,1869094800,7),(1038,1887843600,8),(1038,1901149200,7),(1038,1919293200,8),(1038,1932598800,7),(1038,1950742800,8),(1038,1964048400,7),(1038,1982797200,8),(1038,1995498000,7),(1038,2014246800,8),(1038,2026947600,7),(1038,2045696400,8),(1038,2058397200,7),(1038,2077146000,8),(1038,2090451600,7),(1038,2108595600,8),(1038,2121901200,7),(1038,2140045200,8),(1039,-2147483648,2),(1039,-1693706400,1),(1039,-1680483600,2),(1039,-1663455600,3),(1039,-1650150000,4),(1039,-1632006000,3),(1039,-1618700400,4),(1039,-938905200,3),(1039,-857257200,4),(1039,-844556400,3),(1039,-828226800,4),(1039,-812502000,3),(1039,-796777200,4),(1039,-781052400,3),(1039,-777866400,1),(1039,-765327600,4),(1039,-746578800,3),(1039,-733359600,4),(1039,-728517600,5),(1039,-721260000,2),(1039,-716425200,3),(1039,-701910000,4),(1039,-684975600,3),(1039,-670460400,4),(1039,-654217200,3),(1039,-639010800,4),(1039,283993200,2),(1039,291776400,6),(1039,307501200,7),(1039,323830800,6),(1039,338950800,7),(1039,354675600,6),(1039,370400400,7),(1039,386125200,6),(1039,401850000,7),(1039,417574800,6),(1039,433299600,7),(1039,449024400,6),(1039,465354000,7),(1039,481078800,6),(1039,496803600,7),(1039,512528400,6),(1039,528253200,7),(1039,543978000,6),(1039,559702800,7),(1039,575427600,6),(1039,591152400,7),(1039,606877200,6),(1039,622602000,7),(1039,638326800,6),(1039,654656400,7),(1039,670381200,6),(1039,686106000,7),(1039,701830800,6),(1039,717555600,7),(1039,733280400,6),(1039,749005200,7),(1039,764730000,6),(1039,780454800,7),(1039,796179600,6),(1039,811904400,7),(1039,828234000,6),(1039,846378000,7),(1039,859683600,6),(1039,877827600,7),(1039,891133200,6),(1039,909277200,7),(1039,922582800,6),(1039,941331600,7),(1039,954032400,6),(1039,972781200,7),(1039,985482000,6),(1039,1004230800,7),(1039,1017536400,6),(1039,1035680400,7),(1039,1048986000,6),(1039,1067130000,7),(1039,1080435600,6),(1039,1099184400,7),(1039,1111885200,6),(1039,1130634000,7),(1039,1143334800,6),(1039,1162083600,7),(1039,1174784400,6),(1039,1193533200,7),(1039,1206838800,6),(1039,1224982800,7),(1039,1238288400,6),(1039,1256432400,7),(1039,1269738000,6),(1039,1288486800,7),(1039,1301187600,6),(1039,1319936400,7),(1039,1332637200,6),(1039,1351386000,7),(1039,1364691600,6),(1039,1382835600,7),(1039,1396141200,6),(1039,1414285200,7),(1039,1427590800,6),(1039,1445734800,7),(1039,1459040400,6),(1039,1477789200,7),(1039,1490490000,6),(1039,1509238800,7),(1039,1521939600,6),(1039,1540688400,7),(1039,1553994000,6),(1039,1572138000,7),(1039,1585443600,6),(1039,1603587600,7),(1039,1616893200,6),(1039,1635642000,7),(1039,1648342800,6),(1039,1667091600,7),(1039,1679792400,6),(1039,1698541200,7),(1039,1711846800,6),(1039,1729990800,7),(1039,1743296400,6),(1039,1761440400,7),(1039,1774746000,6),(1039,1792890000,7),(1039,1806195600,6),(1039,1824944400,7),(1039,1837645200,6),(1039,1856394000,7),(1039,1869094800,6),(1039,1887843600,7),(1039,1901149200,6),(1039,1919293200,7),(1039,1932598800,6),(1039,1950742800,7),(1039,1964048400,6),(1039,1982797200,7),(1039,1995498000,6),(1039,2014246800,7),(1039,2026947600,6),(1039,2045696400,7),(1039,2058397200,6),(1039,2077146000,7),(1039,2090451600,6),(1039,2108595600,7),(1039,2121901200,6),(1039,2140045200,7),(1040,-2147483648,1),(1040,-1740355200,2),(1040,-1693702800,5),(1040,-1680483600,2),(1040,-1663455600,3),(1040,-1650150000,4),(1040,-1632006000,3),(1040,-1618700400,4),(1040,-1613826000,8),(1040,-1604278800,6),(1040,-1585530000,7),(1040,-1574038800,6),(1040,-1552266000,7),(1040,-1539997200,6),(1040,-1520557200,7),(1040,-1507510800,6),(1040,-1490576400,7),(1040,-1473642000,6),(1040,-1459126800,7),(1040,-1444006800,6),(1040,-1427677200,7),(1040,-1411952400,6),(1040,-1396227600,7),(1040,-1379293200,6),(1040,-1364778000,7),(1040,-1348448400,6),(1040,-1333328400,7),(1040,-1316394000,6),(1040,-1301263200,7),(1040,-1284328800,6),(1040,-1269813600,7),(1040,-1253484000,6),(1040,-1238364000,7),(1040,-1221429600,6),(1040,-1206914400,7),(1040,-1191189600,6),(1040,-1175464800,7),(1040,-1160344800,6),(1040,-1143410400,7),(1040,-1127685600,6),(1040,-1111960800,7),(1040,-1096840800,6),(1040,-1080511200,7),(1040,-1063576800,6),(1040,-1049061600,7),(1040,-1033336800,6),(1040,-1017612000,7),(1040,-1002492000,6),(1040,-986162400,7),(1040,-969228000,6),(1040,-950479200,7),(1040,-942012000,6),(1040,-934668000,3),(1040,-857257200,4),(1040,-844556400,3),(1040,-828226800,4),(1040,-812502000,3),(1040,-799293600,5),(1040,-798073200,4),(1040,-781052400,3),(1040,-766623600,4),(1040,-745455600,3),(1040,-733273200,4),(1040,220921200,2),(1040,228877200,9),(1040,243997200,10),(1040,260326800,9),(1040,276051600,10),(1040,291776400,9),(1040,307501200,10),(1040,323830800,9),(1040,338950800,10),(1040,354675600,9),(1040,370400400,10),(1040,386125200,9),(1040,401850000,10),(1040,417574800,9),(1040,433299600,10),(1040,449024400,9),(1040,465354000,10),(1040,481078800,9),(1040,496803600,10),(1040,512528400,9),(1040,528253200,10),(1040,543978000,9),(1040,559702800,10),(1040,575427600,9),(1040,591152400,10),(1040,606877200,9),(1040,622602000,10),(1040,638326800,9),(1040,654656400,10),(1040,670381200,9),(1040,686106000,10),(1040,701830800,9),(1040,717555600,10),(1040,733280400,9),(1040,749005200,10),(1040,764730000,9),(1040,780454800,10),(1040,796179600,9),(1040,811904400,10),(1040,828234000,9),(1040,846378000,10),(1040,859683600,9),(1040,877827600,10),(1040,891133200,9),(1040,909277200,10),(1040,922582800,9),(1040,941331600,10),(1040,954032400,9),(1040,972781200,10),(1040,985482000,9),(1040,1004230800,10),(1040,1017536400,9),(1040,1035680400,10),(1040,1048986000,9),(1040,1067130000,10),(1040,1080435600,9),(1040,1099184400,10),(1040,1111885200,9),(1040,1130634000,10),(1040,1143334800,9),(1040,1162083600,10),(1040,1174784400,9),(1040,1193533200,10),(1040,1206838800,9),(1040,1224982800,10),(1040,1238288400,9),(1040,1256432400,10),(1040,1269738000,9),(1040,1288486800,10),(1040,1301187600,9),(1040,1319936400,10),(1040,1332637200,9),(1040,1351386000,10),(1040,1364691600,9),(1040,1382835600,10),(1040,1396141200,9),(1040,1414285200,10),(1040,1427590800,9),(1040,1445734800,10),(1040,1459040400,9),(1040,1477789200,10),(1040,1490490000,9),(1040,1509238800,10),(1040,1521939600,9),(1040,1540688400,10),(1040,1553994000,9),(1040,1572138000,10),(1040,1585443600,9),(1040,1603587600,10),(1040,1616893200,9),(1040,1635642000,10),(1040,1648342800,9),(1040,1667091600,10),(1040,1679792400,9),(1040,1698541200,10),(1040,1711846800,9),(1040,1729990800,10),(1040,1743296400,9),(1040,1761440400,10),(1040,1774746000,9),(1040,1792890000,10),(1040,1806195600,9),(1040,1824944400,10),(1040,1837645200,9),(1040,1856394000,10),(1040,1869094800,9),(1040,1887843600,10),(1040,1901149200,9),(1040,1919293200,10),(1040,1932598800,9),(1040,1950742800,10),(1040,1964048400,9),(1040,1982797200,10),(1040,1995498000,9),(1040,2014246800,10),(1040,2026947600,9),(1040,2045696400,10),(1040,2058397200,9),(1040,2077146000,10),(1040,2090451600,9),(1040,2108595600,10),(1040,2121901200,9),(1040,2140045200,10),(1041,-2147483648,1),(1041,-1213148664,5),(1041,-1187056800,2),(1041,-1175479200,3),(1041,-1159754400,2),(1041,-1144029600,3),(1041,-1127700000,2),(1041,-1111975200,3),(1041,-1096250400,2),(1041,-1080525600,3),(1041,-1064800800,2),(1041,-1049076000,3),(1041,-1033351200,2),(1041,-1017626400,3),(1041,-1001901600,2),(1041,-986176800,3),(1041,-970452000,2),(1041,-954727200,3),(1041,296604000,4),(1041,307486800,5),(1041,323816400,4),(1041,338940000,5),(1041,354672000,2),(1041,370396800,3),(1041,386121600,2),(1041,401846400,3),(1041,417571200,2),(1041,433296000,3),(1041,449020800,2),(1041,465350400,3),(1041,481075200,2),(1041,496800000,3),(1041,512524800,2),(1041,528249600,3),(1041,543974400,2),(1041,559699200,3),(1041,575424000,2),(1041,591148800,3),(1041,606873600,2),(1041,622598400,3),(1041,638323200,2),(1041,654652800,3),(1041,662680800,5),(1041,670370400,2),(1041,686095200,3),(1041,701820000,2),(1041,717544800,3),(1041,733269600,2),(1041,748994400,3),(1041,757375200,5),(1041,764719200,4),(1041,780440400,5),(1041,796168800,4),(1041,811890000,5),(1041,828223200,4),(1041,846363600,5),(1041,859683600,6),(1041,877827600,7),(1041,891133200,6),(1041,909277200,7),(1041,922582800,6),(1041,941331600,7),(1041,954032400,6),(1041,972781200,7),(1041,985482000,6),(1041,1004230800,7),(1041,1017536400,6),(1041,1035680400,7),(1041,1048986000,6),(1041,1067130000,7),(1041,1080435600,6),(1041,1099184400,7),(1041,1111885200,6),(1041,1130634000,7),(1041,1143334800,6),(1041,1162083600,7),(1041,1174784400,6),(1041,1193533200,7),(1041,1206838800,6),(1041,1224982800,7),(1041,1238288400,6),(1041,1256432400,7),(1041,1269738000,6),(1041,1288486800,7),(1041,1301187600,6),(1041,1319936400,7),(1041,1332637200,6),(1041,1351386000,7),(1041,1364691600,6),(1041,1382835600,7),(1041,1396141200,6),(1041,1414285200,7),(1041,1427590800,6),(1041,1445734800,7),(1041,1459040400,6),(1041,1477789200,7),(1041,1490490000,6),(1041,1509238800,7),(1041,1521939600,6),(1041,1540688400,7),(1041,1553994000,6),(1041,1572138000,7),(1041,1585443600,6),(1041,1603587600,7),(1041,1616893200,6),(1041,1635642000,7),(1041,1648342800,6),(1041,1667091600,7),(1041,1679792400,6),(1041,1698541200,7),(1041,1711846800,6),(1041,1729990800,7),(1041,1743296400,6),(1041,1761440400,7),(1041,1774746000,6),(1041,1792890000,7),(1041,1806195600,6),(1041,1824944400,7),(1041,1837645200,6),(1041,1856394000,7),(1041,1869094800,6),(1041,1887843600,7),(1041,1901149200,6),(1041,1919293200,7),(1041,1932598800,6),(1041,1950742800,7),(1041,1964048400,6),(1041,1982797200,7),(1041,1995498000,6),(1041,2014246800,7),(1041,2026947600,6),(1041,2045696400,7),(1041,2058397200,6),(1041,2077146000,7),(1041,2090451600,6),(1041,2108595600,7),(1041,2121901200,6),(1041,2140045200,7),(1042,-2147483648,2),(1042,-1693706400,1),(1042,-1680483600,2),(1042,-1663455600,3),(1042,-1650150000,4),(1042,-1640998800,2),(1042,-1633212000,1),(1042,-1618700400,2),(1042,-1600466400,1),(1042,-1581202800,2),(1042,-906771600,1),(1042,-857257200,4),(1042,-844556400,3),(1042,-828226800,4),(1042,-812502000,3),(1042,-796777200,4),(1042,-788922000,2),(1042,-778471200,1),(1042,-762660000,2),(1042,-749689200,3),(1042,-733359600,4),(1042,-717634800,3),(1042,-701910000,4),(1042,-686185200,3),(1042,-670460400,4),(1042,-654130800,3),(1042,-639010800,4),(1042,-621990000,3),(1042,-605660400,4),(1042,-492656400,1),(1042,-481168800,2),(1042,-461120400,1),(1042,-449632800,2),(1042,-428547600,1),(1042,-418269600,2),(1042,-397094400,1),(1042,-386809200,2),(1042,323827200,1),(1042,338950800,5),(1042,354675600,6),(1042,370400400,5),(1042,386125200,6),(1042,401850000,5),(1042,417574800,6),(1042,433299600,5),(1042,449024400,6),(1042,465354000,5),(1042,481078800,6),(1042,496803600,5),(1042,512528400,6),(1042,528253200,5),(1042,543978000,6),(1042,559702800,5),(1042,575427600,6),(1042,591152400,5),(1042,606877200,6),(1042,622602000,5),(1042,638326800,6),(1042,654656400,5),(1042,670381200,6),(1042,686106000,5),(1042,701830800,6),(1042,717555600,5),(1042,733280400,6),(1042,749005200,5),(1042,764730000,6),(1042,780454800,5),(1042,796179600,6),(1042,811904400,5),(1042,828234000,6),(1042,846378000,5),(1042,859683600,6),(1042,877827600,5),(1042,891133200,6),(1042,909277200,5),(1042,922582800,6),(1042,941331600,5),(1042,954032400,6),(1042,972781200,5),(1042,985482000,6),(1042,1004230800,5),(1042,1017536400,6),(1042,1035680400,5),(1042,1048986000,6),(1042,1067130000,5),(1042,1080435600,6),(1042,1099184400,5),(1042,1111885200,6),(1042,1130634000,5),(1042,1143334800,6),(1042,1162083600,5),(1042,1174784400,6),(1042,1193533200,5),(1042,1206838800,6),(1042,1224982800,5),(1042,1238288400,6),(1042,1256432400,5),(1042,1269738000,6),(1042,1288486800,5),(1042,1301187600,6),(1042,1319936400,5),(1042,1332637200,6),(1042,1351386000,5),(1042,1364691600,6),(1042,1382835600,5),(1042,1396141200,6),(1042,1414285200,5),(1042,1427590800,6),(1042,1445734800,5),(1042,1459040400,6),(1042,1477789200,5),(1042,1490490000,6),(1042,1509238800,5),(1042,1521939600,6),(1042,1540688400,5),(1042,1553994000,6),(1042,1572138000,5),(1042,1585443600,6),(1042,1603587600,5),(1042,1616893200,6),(1042,1635642000,5),(1042,1648342800,6),(1042,1667091600,5),(1042,1679792400,6),(1042,1698541200,5),(1042,1711846800,6),(1042,1729990800,5),(1042,1743296400,6),(1042,1761440400,5),(1042,1774746000,6),(1042,1792890000,5),(1042,1806195600,6),(1042,1824944400,5),(1042,1837645200,6),(1042,1856394000,5),(1042,1869094800,6),(1042,1887843600,5),(1042,1901149200,6),(1042,1919293200,5),(1042,1932598800,6),(1042,1950742800,5),(1042,1964048400,6),(1042,1982797200,5),(1042,1995498000,6),(1042,2014246800,5),(1042,2026947600,6),(1042,2045696400,5),(1042,2058397200,6),(1042,2077146000,5),(1042,2090451600,6),(1042,2108595600,5),(1042,2121901200,6),(1042,2140045200,5),(1043,-2147483648,2),(1043,-904435200,1),(1043,-891129600,2),(1043,-872985600,1),(1043,-859680000,2),(1043,354675600,3),(1043,370400400,4),(1043,386125200,3),(1043,401850000,4),(1043,417574800,3),(1043,433299600,4),(1043,449024400,3),(1043,465354000,4),(1043,481078800,3),(1043,496803600,4),(1043,512528400,3),(1043,528253200,4),(1043,543978000,3),(1043,559702800,4),(1043,575427600,3),(1043,591152400,4),(1043,606877200,3),(1043,622602000,4),(1043,638326800,3),(1043,654656400,4),(1043,670381200,3),(1043,686106000,4),(1043,701830800,3),(1043,717555600,4),(1043,733280400,3),(1043,749005200,4),(1043,764730000,3),(1043,780454800,4),(1043,796179600,3),(1043,811904400,4),(1043,828234000,3),(1043,846378000,4),(1043,859683600,3),(1043,877827600,4),(1043,891133200,3),(1043,909277200,4),(1043,922582800,3),(1043,941331600,4),(1043,954032400,3),(1043,972781200,4),(1043,985482000,3),(1043,1004230800,4),(1043,1017536400,3),(1043,1035680400,4),(1043,1048986000,3),(1043,1067130000,4),(1043,1080435600,3),(1043,1099184400,4),(1043,1111885200,3),(1043,1130634000,4),(1043,1143334800,3),(1043,1162083600,4),(1043,1174784400,3),(1043,1193533200,4),(1043,1206838800,3),(1043,1224982800,4),(1043,1238288400,3),(1043,1256432400,4),(1043,1269738000,3),(1043,1288486800,4),(1043,1301187600,3),(1043,1319936400,4),(1043,1332637200,3),(1043,1351386000,4),(1043,1364691600,3),(1043,1382835600,4),(1043,1396141200,3),(1043,1414285200,4),(1043,1427590800,3),(1043,1445734800,4),(1043,1459040400,3),(1043,1477789200,4),(1043,1490490000,3),(1043,1509238800,4),(1043,1521939600,3),(1043,1540688400,4),(1043,1553994000,3),(1043,1572138000,4),(1043,1585443600,3),(1043,1603587600,4),(1043,1616893200,3),(1043,1635642000,4),(1043,1648342800,3),(1043,1667091600,4),(1043,1679792400,3),(1043,1698541200,4),(1043,1711846800,3),(1043,1729990800,4),(1043,1743296400,3),(1043,1761440400,4),(1043,1774746000,3),(1043,1792890000,4),(1043,1806195600,3),(1043,1824944400,4),(1043,1837645200,3),(1043,1856394000,4),(1043,1869094800,3),(1043,1887843600,4),(1043,1901149200,3),(1043,1919293200,4),(1043,1932598800,3),(1043,1950742800,4),(1043,1964048400,3),(1043,1982797200,4),(1043,1995498000,3),(1043,2014246800,4),(1043,2026947600,3),(1043,2045696400,4),(1043,2058397200,3),(1043,2077146000,4),(1043,2090451600,3),(1043,2108595600,4),(1043,2121901200,3),(1043,2140045200,4),(1044,-2147483648,1),(1044,-1637114100,2),(1044,-1213148664,5),(1044,-1187056800,3),(1044,-1175479200,4),(1044,-1159754400,3),(1044,-1144029600,4),(1044,-1127700000,3),(1044,-1111975200,4),(1044,-1096250400,3),(1044,-1080525600,4),(1044,-1064800800,3),(1044,-1049076000,4),(1044,-1033351200,3),(1044,-1017626400,4),(1044,-1001901600,3),(1044,-986176800,4),(1044,-970452000,3),(1044,-954727200,4),(1044,-927165600,6),(1044,-898138800,9),(1044,-857257200,7),(1044,-844556400,8),(1044,-828226800,7),(1044,-812502000,8),(1044,-800157600,11),(1044,354920400,10),(1044,370728000,11),(1044,386456400,10),(1044,402264000,11),(1044,417992400,10),(1044,433800000,11),(1044,449614800,10),(1044,465346800,12),(1044,481071600,13),(1044,496796400,12),(1044,512521200,13),(1044,528246000,12),(1044,543970800,13),(1044,559695600,12),(1044,575420400,13),(1044,591145200,12),(1044,606870000,13),(1044,622594800,12),(1044,638319600,13),(1044,641944800,6),(1044,654652800,4),(1044,670377600,3),(1044,686102400,4),(1044,694216800,5),(1044,701820000,6),(1044,717541200,5),(1044,733269600,6),(1044,748990800,5),(1044,764719200,6),(1044,780440400,5),(1044,796168800,6),(1044,811890000,5),(1044,828223200,6),(1044,846363600,5),(1044,859680000,6),(1044,877824000,5),(1044,891129600,6),(1044,909273600,5),(1044,922579200,6),(1044,941328000,5),(1044,954028800,6),(1044,972777600,5),(1044,985478400,6),(1044,1004227200,5),(1044,1017532800,6),(1044,1035676800,5),(1044,1048982400,6),(1044,1067126400,5),(1044,1080432000,6),(1044,1099180800,5),(1044,1111881600,6),(1044,1130630400,5),(1044,1143331200,6),(1044,1162080000,5),(1044,1174780800,6),(1044,1193529600,5),(1044,1206835200,6),(1044,1224979200,5),(1044,1238284800,6),(1044,1256428800,5),(1044,1269734400,6),(1044,1288483200,5),(1044,1301184000,6),(1044,1319932800,5),(1044,1332633600,6),(1044,1351382400,5),(1044,1364688000,6),(1044,1382832000,5),(1044,1396137600,6),(1044,1414281600,5),(1044,1427587200,6),(1044,1445731200,5),(1044,1459036800,6),(1044,1477785600,5),(1044,1490486400,6),(1044,1509235200,5),(1044,1521936000,6),(1044,1540684800,5),(1044,1553990400,6),(1044,1572134400,5),(1044,1585440000,6),(1044,1603584000,5),(1044,1616889600,6),(1044,1635638400,5),(1044,1648339200,6),(1044,1667088000,5),(1044,1679788800,6),(1044,1698537600,5),(1044,1711843200,6),(1044,1729987200,5),(1044,1743292800,6),(1044,1761436800,5),(1044,1774742400,6),(1044,1792886400,5),(1044,1806192000,6),(1044,1824940800,5),(1044,1837641600,6),(1044,1856390400,5),(1044,1869091200,6),(1044,1887840000,5),(1044,1901145600,6),(1044,1919289600,5),(1044,1932595200,6),(1044,1950739200,5),(1044,1964044800,6),(1044,1982793600,5),(1044,1995494400,6),(1044,2014243200,5),(1044,2026944000,6),(1044,2045692800,5),(1044,2058393600,6),(1044,2077142400,5),(1044,2090448000,6),(1044,2108592000,5),(1044,2121897600,6),(1044,2140041600,5),(1045,-2147483648,2),(1045,-1692496800,1),(1045,-1680490800,2),(1045,-935110800,1),(1045,-857257200,3),(1045,-844556400,4),(1045,-828226800,3),(1045,-812502000,4),(1045,-796777200,3),(1045,-781052400,4),(1045,-769388400,3),(1045,-747010800,4),(1045,-736383600,3),(1045,-715215600,4),(1045,-706748400,3),(1045,-683161200,4),(1045,-675298800,3),(1045,315529200,2),(1045,323830800,5),(1045,338950800,6),(1045,354675600,5),(1045,370400400,6),(1045,386125200,5),(1045,401850000,6),(1045,417574800,5),(1045,433299600,6),(1045,449024400,5),(1045,465354000,6),(1045,481078800,5),(1045,496803600,6),(1045,512528400,5),(1045,528253200,6),(1045,543978000,5),(1045,559702800,6),(1045,575427600,5),(1045,591152400,6),(1045,606877200,5),(1045,622602000,6),(1045,638326800,5),(1045,654656400,6),(1045,670381200,5),(1045,686106000,6),(1045,701830800,5),(1045,717555600,6),(1045,733280400,5),(1045,749005200,6),(1045,764730000,5),(1045,780454800,6),(1045,796179600,5),(1045,811904400,6),(1045,828234000,5),(1045,846378000,6),(1045,859683600,5),(1045,877827600,6),(1045,891133200,5),(1045,909277200,6),(1045,922582800,5),(1045,941331600,6),(1045,954032400,5),(1045,972781200,6),(1045,985482000,5),(1045,1004230800,6),(1045,1017536400,5),(1045,1035680400,6),(1045,1048986000,5),(1045,1067130000,6),(1045,1080435600,5),(1045,1099184400,6),(1045,1111885200,5),(1045,1130634000,6),(1045,1143334800,5),(1045,1162083600,6),(1045,1174784400,5),(1045,1193533200,6),(1045,1206838800,5),(1045,1224982800,6),(1045,1238288400,5),(1045,1256432400,6),(1045,1269738000,5),(1045,1288486800,6),(1045,1301187600,5),(1045,1319936400,6),(1045,1332637200,5),(1045,1351386000,6),(1045,1364691600,5),(1045,1382835600,6),(1045,1396141200,5),(1045,1414285200,6),(1045,1427590800,5),(1045,1445734800,6),(1045,1459040400,5),(1045,1477789200,6),(1045,1490490000,5),(1045,1509238800,6),(1045,1521939600,5),(1045,1540688400,6),(1045,1553994000,5),(1045,1572138000,6),(1045,1585443600,5),(1045,1603587600,6),(1045,1616893200,5),(1045,1635642000,6),(1045,1648342800,5),(1045,1667091600,6),(1045,1679792400,5),(1045,1698541200,6),(1045,1711846800,5),(1045,1729990800,6),(1045,1743296400,5),(1045,1761440400,6),(1045,1774746000,5),(1045,1792890000,6),(1045,1806195600,5),(1045,1824944400,6),(1045,1837645200,5),(1045,1856394000,6),(1045,1869094800,5),(1045,1887843600,6),(1045,1901149200,5),(1045,1919293200,6),(1045,1932598800,5),(1045,1950742800,6),(1045,1964048400,5),(1045,1982797200,6),(1045,1995498000,5),(1045,2014246800,6),(1045,2026947600,5),(1045,2045696400,6),(1045,2058397200,5),(1045,2077146000,6),(1045,2090451600,5),(1045,2108595600,6),(1045,2121901200,5),(1045,2140045200,6),(1046,-2147483648,1),(1046,-1691962479,2),(1046,-1680471279,4),(1046,-1664143200,3),(1046,-1650146400,4),(1046,-1633903200,3),(1046,-1617487200,4),(1046,-1601848800,3),(1046,-1586037600,4),(1046,-1570399200,3),(1046,-1552168800,4),(1046,-1538344800,3),(1046,-1522533600,4),(1046,-1517011200,6),(1046,-1507500000,5),(1046,-1490565600,4),(1046,-1473631200,5),(1046,-1460930400,4),(1046,-1442786400,5),(1046,-1428876000,4),(1046,-1410732000,5),(1046,-1396216800,4),(1046,-1379282400,5),(1046,-1364767200,4),(1046,-1348437600,5),(1046,-1333317600,4),(1046,-1315778400,5),(1046,-1301263200,4),(1046,-1284328800,5),(1046,-1269813600,4),(1046,-1253484000,5),(1046,-1238364000,4),(1046,-1221429600,5),(1046,-1206914400,4),(1046,-1189980000,5),(1046,-1175464800,4),(1046,-1159135200,5),(1046,-1143410400,4),(1046,-1126476000,5),(1046,-1111960800,4),(1046,-1095631200,5),(1046,-1080511200,4),(1046,-1063576800,5),(1046,-1049061600,4),(1046,-1032127200,5),(1046,-1017612000,4),(1046,-1001282400,5),(1046,-986162400,4),(1046,-969228000,5),(1046,-950479200,4),(1046,-942012000,5),(1046,-733356000,4),(1046,-719445600,5),(1046,-699487200,4),(1046,-684972000,5),(1046,-668037600,4),(1046,-654732000,5),(1046,-636588000,4),(1046,-622072800,5),(1046,-605743200,4),(1046,-590623200,5),(1046,-574293600,4),(1046,-558568800,5),(1046,-542239200,4),(1046,-527119200,5),(1046,-512604000,4),(1046,-496274400,5),(1046,-481154400,4),(1046,-464220000,5),(1046,-449704800,4),(1046,-432165600,5),(1046,-417650400,4),(1046,-401320800,5),(1046,-386200800,4),(1046,-369266400,5),(1046,-354751200,4),(1046,-337816800,5),(1046,-323301600,4),(1046,-306972000,5),(1046,-291852000,4),(1046,-276732000,5),(1046,-257983200,4),(1046,-245282400,5),(1046,-226533600,4),(1046,-213228000,5),(1046,-195084000,4),(1046,-182383200,5),(1046,-163634400,4),(1046,-150933600,5),(1046,-132184800,4),(1046,-119484000,5),(1046,-100735200,4),(1046,-88034400,5),(1046,-68680800,4),(1046,-59004000,5),(1046,-37242000,9),(1046,57722400,7),(1046,69818400,8),(1046,89172000,7),(1046,101268000,8),(1046,120621600,7),(1046,132717600,8),(1046,152071200,7),(1046,164167200,8),(1046,183520800,7),(1046,196221600,8),(1046,214970400,7),(1046,227671200,8),(1046,246420000,7),(1046,259120800,8),(1046,278474400,7),(1046,290570400,8),(1046,309924000,7),(1046,322020000,8),(1046,341373600,7),(1046,354675600,8),(1046,372819600,7),(1046,386125200,8),(1046,404269200,7),(1046,417574800,8),(1046,435718800,7),(1046,449024400,8),(1046,467773200,7),(1046,481078800,8),(1046,499222800,7),(1046,512528400,8),(1046,530672400,7),(1046,543978000,8),(1046,562122000,7),(1046,575427600,8),(1046,593571600,7),(1046,606877200,8),(1046,625626000,7),(1046,638326800,8),(1046,657075600,7),(1046,670381200,8),(1046,688525200,7),(1046,701830800,8),(1046,719974800,7),(1046,733280400,8),(1046,751424400,7),(1046,764730000,8),(1046,782874000,7),(1046,796179600,8),(1046,814323600,7),(1046,828234000,8),(1046,846378000,7),(1046,859683600,8),(1046,877827600,7),(1046,891133200,8),(1046,909277200,7),(1046,922582800,8),(1046,941331600,7),(1046,954032400,8),(1046,972781200,7),(1046,985482000,8),(1046,1004230800,7),(1046,1017536400,8),(1046,1035680400,7),(1046,1048986000,8),(1046,1067130000,7),(1046,1080435600,8),(1046,1099184400,7),(1046,1111885200,8),(1046,1130634000,7),(1046,1143334800,8),(1046,1162083600,7),(1046,1174784400,8),(1046,1193533200,7),(1046,1206838800,8),(1046,1224982800,7),(1046,1238288400,8),(1046,1256432400,7),(1046,1269738000,8),(1046,1288486800,7),(1046,1301187600,8),(1046,1319936400,7),(1046,1332637200,8),(1046,1351386000,7),(1046,1364691600,8),(1046,1382835600,7),(1046,1396141200,8),(1046,1414285200,7),(1046,1427590800,8),(1046,1445734800,7),(1046,1459040400,8),(1046,1477789200,7),(1046,1490490000,8),(1046,1509238800,7),(1046,1521939600,8),(1046,1540688400,7),(1046,1553994000,8),(1046,1572138000,7),(1046,1585443600,8),(1046,1603587600,7),(1046,1616893200,8),(1046,1635642000,7),(1046,1648342800,8),(1046,1667091600,7),(1046,1679792400,8),(1046,1698541200,7),(1046,1711846800,8),(1046,1729990800,7),(1046,1743296400,8),(1046,1761440400,7),(1046,1774746000,8),(1046,1792890000,7),(1046,1806195600,8),(1046,1824944400,7),(1046,1837645200,8),(1046,1856394000,7),(1046,1869094800,8),(1046,1887843600,7),(1046,1901149200,8),(1046,1919293200,7),(1046,1932598800,8),(1046,1950742800,7),(1046,1964048400,8),(1046,1982797200,7),(1046,1995498000,8),(1046,2014246800,7),(1046,2026947600,8),(1046,2045696400,7),(1046,2058397200,8),(1046,2077146000,7),(1046,2090451600,8),(1046,2108595600,7),(1046,2121901200,8),(1046,2140045200,7),(1047,-2147483648,2),(1047,-1691964000,1),(1047,-1680472800,2),(1047,-1664143200,1),(1047,-1650146400,2),(1047,-1633903200,1),(1047,-1617487200,2),(1047,-1601848800,1),(1047,-1586037600,2),(1047,-1570399200,1),(1047,-1552168800,2),(1047,-1538344800,1),(1047,-1522533600,2),(1047,-1507500000,1),(1047,-1490565600,2),(1047,-1473631200,1),(1047,-1460930400,2),(1047,-1442786400,1),(1047,-1428876000,2),(1047,-1410732000,1),(1047,-1396216800,2),(1047,-1379282400,1),(1047,-1364767200,2),(1047,-1348437600,1),(1047,-1333317600,2),(1047,-1315778400,1),(1047,-1301263200,2),(1047,-1284328800,1),(1047,-1269813600,2),(1047,-1253484000,1),(1047,-1238364000,2),(1047,-1221429600,1),(1047,-1206914400,2),(1047,-1189980000,1),(1047,-1175464800,2),(1047,-1159135200,1),(1047,-1143410400,2),(1047,-1126476000,1),(1047,-1111960800,2),(1047,-1095631200,1),(1047,-1080511200,2),(1047,-1063576800,1),(1047,-1049061600,2),(1047,-1032127200,1),(1047,-1017612000,2),(1047,-1001282400,1),(1047,-986162400,2),(1047,-969228000,1),(1047,-950479200,2),(1047,-942012000,1),(1047,-904518000,3),(1047,-896050800,1),(1047,-875487600,3),(1047,-864601200,1),(1047,-844038000,3),(1047,-832546800,1),(1047,-812588400,3),(1047,-798073200,1),(1047,-781052400,3),(1047,-772066800,1),(1047,-764805600,2),(1047,-748476000,1),(1047,-733356000,2),(1047,-719445600,1),(1047,-717030000,3),(1047,-706748400,1),(1047,-699487200,2),(1047,-687996000,1),(1047,-668037600,2),(1047,-654732000,1),(1047,-636588000,2),(1047,-622072800,1),(1047,-605743200,2),(1047,-590623200,1),(1047,-574293600,2),(1047,-558568800,1),(1047,-542239200,2),(1047,-527119200,1),(1047,-512604000,2),(1047,-496274400,1),(1047,-481154400,2),(1047,-464220000,1),(1047,-449704800,2),(1047,-432165600,1),(1047,-417650400,2),(1047,-401320800,4),(1047,386125200,5),(1047,401850000,6),(1047,417574800,5),(1047,433299600,6),(1047,449024400,5),(1047,465354000,6),(1047,481078800,5),(1047,496803600,6),(1047,512528400,5),(1047,528253200,6),(1047,543978000,5),(1047,559702800,6),(1047,575427600,5),(1047,591152400,6),(1047,606877200,5),(1047,622602000,6),(1047,638326800,5),(1047,654656400,6),(1047,670381200,5),(1047,686106000,6),(1047,701830800,5),(1047,717555600,6),(1047,733280400,5),(1047,749005200,6),(1047,764730000,5),(1047,780454800,6),(1047,796179600,5),(1047,811904400,6),(1047,828234000,5),(1047,846378000,6),(1047,859683600,5),(1047,877827600,6),(1047,891133200,5),(1047,909277200,6),(1047,922582800,5),(1047,941331600,6),(1047,954032400,5),(1047,972781200,6),(1047,985482000,5),(1047,1004230800,6),(1047,1017536400,5),(1047,1035680400,6),(1047,1048986000,5),(1047,1067130000,6),(1047,1080435600,5),(1047,1099184400,6),(1047,1111885200,5),(1047,1130634000,6),(1047,1143334800,5),(1047,1162083600,6),(1047,1174784400,5),(1047,1193533200,6),(1047,1206838800,5),(1047,1224982800,6),(1047,1238288400,5),(1047,1256432400,6),(1047,1269738000,5),(1047,1288486800,6),(1047,1301187600,5),(1047,1319936400,6),(1047,1332637200,5),(1047,1351386000,6),(1047,1364691600,5),(1047,1382835600,6),(1047,1396141200,5),(1047,1414285200,6),(1047,1427590800,5),(1047,1445734800,6),(1047,1459040400,5),(1047,1477789200,6),(1047,1490490000,5),(1047,1509238800,6),(1047,1521939600,5),(1047,1540688400,6),(1047,1553994000,5),(1047,1572138000,6),(1047,1585443600,5),(1047,1603587600,6),(1047,1616893200,5),(1047,1635642000,6),(1047,1648342800,5),(1047,1667091600,6),(1047,1679792400,5),(1047,1698541200,6),(1047,1711846800,5),(1047,1729990800,6),(1047,1743296400,5),(1047,1761440400,6),(1047,1774746000,5),(1047,1792890000,6),(1047,1806195600,5),(1047,1824944400,6),(1047,1837645200,5),(1047,1856394000,6),(1047,1869094800,5),(1047,1887843600,6),(1047,1901149200,5),(1047,1919293200,6),(1047,1932598800,5),(1047,1950742800,6),(1047,1964048400,5),(1047,1982797200,6),(1047,1995498000,5),(1047,2014246800,6),(1047,2026947600,5),(1047,2045696400,6),(1047,2058397200,5),(1047,2077146000,6),(1047,2090451600,5),(1047,2108595600,6),(1047,2121901200,5),(1047,2140045200,6),(1048,-2147483648,2),(1048,-1691964000,1),(1048,-1680472800,2),(1048,-1664143200,1),(1048,-1650146400,2),(1048,-1633903200,1),(1048,-1617487200,2),(1048,-1601848800,1),(1048,-1586037600,2),(1048,-1570399200,1),(1048,-1552168800,2),(1048,-1538344800,1),(1048,-1522533600,2),(1048,-1507500000,1),(1048,-1490565600,2),(1048,-1473631200,1),(1048,-1460930400,2),(1048,-1442786400,1),(1048,-1428876000,2),(1048,-1410732000,1),(1048,-1396216800,2),(1048,-1379282400,1),(1048,-1364767200,2),(1048,-1348437600,1),(1048,-1333317600,2),(1048,-1315778400,1),(1048,-1301263200,2),(1048,-1284328800,1),(1048,-1269813600,2),(1048,-1253484000,1),(1048,-1238364000,2),(1048,-1221429600,1),(1048,-1206914400,2),(1048,-1189980000,1),(1048,-1175464800,2),(1048,-1159135200,1),(1048,-1143410400,2),(1048,-1126476000,1),(1048,-1111960800,2),(1048,-1095631200,1),(1048,-1080511200,2),(1048,-1063576800,1),(1048,-1049061600,2),(1048,-1032127200,1),(1048,-1017612000,2),(1048,-1001282400,1),(1048,-986162400,2),(1048,-969228000,1),(1048,-950479200,2),(1048,-942012000,1),(1048,-904518000,3),(1048,-896050800,1),(1048,-875487600,3),(1048,-864601200,1),(1048,-844038000,3),(1048,-832546800,1),(1048,-812588400,3),(1048,-798073200,1),(1048,-781052400,3),(1048,-772066800,1),(1048,-764805600,2),(1048,-748476000,1),(1048,-733356000,2),(1048,-719445600,1),(1048,-717030000,3),(1048,-706748400,1),(1048,-699487200,2),(1048,-687996000,1),(1048,-668037600,2),(1048,-654732000,1),(1048,-636588000,2),(1048,-622072800,1),(1048,-605743200,2),(1048,-590623200,1),(1048,-574293600,2),(1048,-558568800,1),(1048,-542239200,2),(1048,-527119200,1),(1048,-512604000,2),(1048,-496274400,1),(1048,-481154400,2),(1048,-464220000,1),(1048,-449704800,2),(1048,-432165600,1),(1048,-417650400,2),(1048,-401320800,1),(1048,-386200800,2),(1048,-369266400,1),(1048,-354751200,2),(1048,-337816800,1),(1048,-323301600,2),(1048,-306972000,1),(1048,-291852000,2),(1048,-276732000,1),(1048,-257983200,2),(1048,-245282400,1),(1048,-226533600,2),(1048,-213228000,1),(1048,-195084000,2),(1048,-182383200,1),(1048,-163634400,2),(1048,-150933600,1),(1048,-132184800,2),(1048,-119484000,1),(1048,-100735200,2),(1048,-88034400,1),(1048,-68680800,2),(1048,-59004000,1),(1048,-37242000,4),(1048,57722400,6),(1048,69818400,1),(1048,89172000,2),(1048,101268000,1),(1048,120621600,2),(1048,132717600,1),(1048,152071200,2),(1048,164167200,1),(1048,183520800,2),(1048,196221600,1),(1048,214970400,2),(1048,227671200,1),(1048,246420000,2),(1048,259120800,1),(1048,278474400,2),(1048,290570400,1),(1048,309924000,2),(1048,322020000,1),(1048,341373600,2),(1048,354675600,5),(1048,372819600,6),(1048,386125200,5),(1048,404269200,6),(1048,417574800,5),(1048,435718800,6),(1048,449024400,5),(1048,467773200,6),(1048,481078800,5),(1048,499222800,6),(1048,512528400,5),(1048,530672400,6),(1048,543978000,5),(1048,562122000,6),(1048,575427600,5),(1048,593571600,6),(1048,606877200,5),(1048,625626000,6),(1048,638326800,5),(1048,657075600,6),(1048,670381200,5),(1048,688525200,6),(1048,701830800,5),(1048,719974800,6),(1048,733280400,5),(1048,751424400,6),(1048,764730000,5),(1048,782874000,6),(1048,796179600,5),(1048,814323600,6),(1048,820454400,7),(1048,828234000,5),(1048,846378000,6),(1048,859683600,5),(1048,877827600,6),(1048,891133200,5),(1048,909277200,6),(1048,922582800,5),(1048,941331600,6),(1048,954032400,5),(1048,972781200,6),(1048,985482000,5),(1048,1004230800,6),(1048,1017536400,5),(1048,1035680400,6),(1048,1048986000,5),(1048,1067130000,6),(1048,1080435600,5),(1048,1099184400,6),(1048,1111885200,5),(1048,1130634000,6),(1048,1143334800,5),(1048,1162083600,6),(1048,1174784400,5),(1048,1193533200,6),(1048,1206838800,5),(1048,1224982800,6),(1048,1238288400,5),(1048,1256432400,6),(1048,1269738000,5),(1048,1288486800,6),(1048,1301187600,5),(1048,1319936400,6),(1048,1332637200,5),(1048,1351386000,6),(1048,1364691600,5),(1048,1382835600,6),(1048,1396141200,5),(1048,1414285200,6),(1048,1427590800,5),(1048,1445734800,6),(1048,1459040400,5),(1048,1477789200,6),(1048,1490490000,5),(1048,1509238800,6),(1048,1521939600,5),(1048,1540688400,6),(1048,1553994000,5),(1048,1572138000,6),(1048,1585443600,5),(1048,1603587600,6),(1048,1616893200,5),(1048,1635642000,6),(1048,1648342800,5),(1048,1667091600,6),(1048,1679792400,5),(1048,1698541200,6),(1048,1711846800,5),(1048,1729990800,6),(1048,1743296400,5),(1048,1761440400,6),(1048,1774746000,5),(1048,1792890000,6),(1048,1806195600,5),(1048,1824944400,6),(1048,1837645200,5),(1048,1856394000,6),(1048,1869094800,5),(1048,1887843600,6),(1048,1901149200,5),(1048,1919293200,6),(1048,1932598800,5),(1048,1950742800,6),(1048,1964048400,5),(1048,1982797200,6),(1048,1995498000,5),(1048,2014246800,6),(1048,2026947600,5),(1048,2045696400,6),(1048,2058397200,5),(1048,2077146000,6),(1048,2090451600,5),(1048,2108595600,6),(1048,2121901200,5),(1048,2140045200,6),(1049,-2147483648,1),(1049,-1535938789,3),(1049,-875671200,2),(1049,-859773600,3),(1049,354672000,2),(1049,370396800,3),(1049,386121600,2),(1049,401846400,3),(1049,417574800,4),(1049,433299600,5),(1049,449024400,4),(1049,465354000,5),(1049,481078800,4),(1049,496803600,5),(1049,512528400,4),(1049,528253200,5),(1049,543978000,4),(1049,559702800,5),(1049,575427600,4),(1049,591152400,5),(1049,606877200,4),(1049,622602000,5),(1049,638326800,4),(1049,654656400,5),(1049,670381200,4),(1049,686106000,5),(1049,701830800,4),(1049,717555600,5),(1049,733280400,4),(1049,749005200,5),(1049,764730000,4),(1049,780454800,5),(1049,796179600,4),(1049,811904400,5),(1049,828234000,4),(1049,846378000,5),(1049,859683600,4),(1049,877827600,5),(1049,891133200,4),(1049,909277200,5),(1049,922582800,4),(1049,941331600,5),(1049,954032400,4),(1049,972781200,5),(1049,985482000,4),(1049,1004230800,5),(1049,1017536400,4),(1049,1035680400,5),(1049,1048986000,4),(1049,1067130000,5),(1049,1080435600,4),(1049,1099184400,5),(1049,1111885200,4),(1049,1130634000,5),(1049,1143334800,4),(1049,1162083600,5),(1049,1174784400,4),(1049,1193533200,5),(1049,1206838800,4),(1049,1224982800,5),(1049,1238288400,4),(1049,1256432400,5),(1049,1269738000,4),(1049,1288486800,5),(1049,1301187600,4),(1049,1319936400,5),(1049,1332637200,4),(1049,1351386000,5),(1049,1364691600,4),(1049,1382835600,5),(1049,1396141200,4),(1049,1414285200,5),(1049,1427590800,4),(1049,1445734800,5),(1049,1459040400,4),(1049,1477789200,5),(1049,1490490000,4),(1049,1509238800,5),(1049,1521939600,4),(1049,1540688400,5),(1049,1553994000,4),(1049,1572138000,5),(1049,1585443600,4),(1049,1603587600,5),(1049,1616893200,4),(1049,1635642000,5),(1049,1648342800,4),(1049,1667091600,5),(1049,1679792400,4),(1049,1698541200,5),(1049,1711846800,4),(1049,1729990800,5),(1049,1743296400,4),(1049,1761440400,5),(1049,1774746000,4),(1049,1792890000,5),(1049,1806195600,4),(1049,1824944400,5),(1049,1837645200,4),(1049,1856394000,5),(1049,1869094800,4),(1049,1887843600,5),(1049,1901149200,4),(1049,1919293200,5),(1049,1932598800,4),(1049,1950742800,5),(1049,1964048400,4),(1049,1982797200,5),(1049,1995498000,4),(1049,2014246800,5),(1049,2026947600,4),(1049,2045696400,5),(1049,2058397200,4),(1049,2077146000,5),(1049,2090451600,4),(1049,2108595600,5),(1049,2121901200,4),(1049,2140045200,5),(1050,-2147483648,2),(1050,-1691964000,1),(1050,-1680472800,2),(1050,-1664143200,1),(1050,-1650146400,2),(1050,-1633903200,1),(1050,-1617487200,2),(1050,-1601848800,1),(1050,-1586037600,2),(1050,-1570399200,1),(1050,-1552168800,2),(1050,-1538344800,1),(1050,-1522533600,2),(1050,-1507500000,1),(1050,-1490565600,2),(1050,-1473631200,1),(1050,-1460930400,2),(1050,-1442786400,1),(1050,-1428876000,2),(1050,-1410732000,1),(1050,-1396216800,2),(1050,-1379282400,1),(1050,-1364767200,2),(1050,-1348437600,1),(1050,-1333317600,2),(1050,-1315778400,1),(1050,-1301263200,2),(1050,-1284328800,1),(1050,-1269813600,2),(1050,-1253484000,1),(1050,-1238364000,2),(1050,-1221429600,1),(1050,-1206914400,2),(1050,-1189980000,1),(1050,-1175464800,2),(1050,-1159135200,1),(1050,-1143410400,2),(1050,-1126476000,1),(1050,-1111960800,2),(1050,-1095631200,1),(1050,-1080511200,2),(1050,-1063576800,1),(1050,-1049061600,2),(1050,-1032127200,1),(1050,-1017612000,2),(1050,-1001282400,1),(1050,-986162400,2),(1050,-969228000,1),(1050,-950479200,2),(1050,-942012000,1),(1050,-904518000,3),(1050,-896050800,1),(1050,-875487600,3),(1050,-864601200,1),(1050,-844038000,3),(1050,-832546800,1),(1050,-812588400,3),(1050,-798073200,1),(1050,-781052400,3),(1050,-772066800,1),(1050,-764805600,2),(1050,-748476000,1),(1050,-733356000,2),(1050,-719445600,1),(1050,-717030000,3),(1050,-706748400,1),(1050,-699487200,2),(1050,-687996000,1),(1050,-668037600,2),(1050,-654732000,1),(1050,-636588000,2),(1050,-622072800,1),(1050,-605743200,2),(1050,-590623200,1),(1050,-574293600,2),(1050,-558568800,1),(1050,-542239200,2),(1050,-527119200,1),(1050,-512604000,2),(1050,-496274400,1),(1050,-481154400,2),(1050,-464220000,1),(1050,-449704800,2),(1050,-432165600,1),(1050,-417650400,2),(1050,-401320800,1),(1050,-386200800,2),(1050,-369266400,1),(1050,-354751200,2),(1050,-337816800,1),(1050,-323301600,2),(1050,-306972000,1),(1050,-291852000,2),(1050,-276732000,1),(1050,-257983200,2),(1050,-245282400,1),(1050,-226533600,2),(1050,-213228000,1),(1050,-195084000,2),(1050,-182383200,1),(1050,-163634400,2),(1050,-150933600,1),(1050,-132184800,2),(1050,-119484000,1),(1050,-100735200,2),(1050,-88034400,1),(1050,-68680800,2),(1050,-59004000,1),(1050,-37242000,4),(1050,57722400,6),(1050,69818400,1),(1050,89172000,2),(1050,101268000,1),(1050,120621600,2),(1050,132717600,1),(1050,152071200,2),(1050,164167200,1),(1050,183520800,2),(1050,196221600,1),(1050,214970400,2),(1050,227671200,1),(1050,246420000,2),(1050,259120800,1),(1050,278474400,2),(1050,290570400,1),(1050,309924000,2),(1050,322020000,1),(1050,341373600,2),(1050,354675600,5),(1050,372819600,6),(1050,386125200,5),(1050,404269200,6),(1050,417574800,5),(1050,435718800,6),(1050,449024400,5),(1050,467773200,6),(1050,481078800,5),(1050,499222800,6),(1050,512528400,5),(1050,530672400,6),(1050,543978000,5),(1050,562122000,6),(1050,575427600,5),(1050,593571600,6),(1050,606877200,5),(1050,625626000,6),(1050,638326800,5),(1050,657075600,6),(1050,670381200,5),(1050,688525200,6),(1050,701830800,5),(1050,719974800,6),(1050,733280400,5),(1050,751424400,6),(1050,764730000,5),(1050,782874000,6),(1050,796179600,5),(1050,814323600,6),(1050,820454400,7),(1050,828234000,5),(1050,846378000,6),(1050,859683600,5),(1050,877827600,6),(1050,891133200,5),(1050,909277200,6),(1050,922582800,5),(1050,941331600,6),(1050,954032400,5),(1050,972781200,6),(1050,985482000,5),(1050,1004230800,6),(1050,1017536400,5),(1050,1035680400,6),(1050,1048986000,5),(1050,1067130000,6),(1050,1080435600,5),(1050,1099184400,6),(1050,1111885200,5),(1050,1130634000,6),(1050,1143334800,5),(1050,1162083600,6),(1050,1174784400,5),(1050,1193533200,6),(1050,1206838800,5),(1050,1224982800,6),(1050,1238288400,5),(1050,1256432400,6),(1050,1269738000,5),(1050,1288486800,6),(1050,1301187600,5),(1050,1319936400,6),(1050,1332637200,5),(1050,1351386000,6),(1050,1364691600,5),(1050,1382835600,6),(1050,1396141200,5),(1050,1414285200,6),(1050,1427590800,5),(1050,1445734800,6),(1050,1459040400,5),(1050,1477789200,6),(1050,1490490000,5),(1050,1509238800,6),(1050,1521939600,5),(1050,1540688400,6),(1050,1553994000,5),(1050,1572138000,6),(1050,1585443600,5),(1050,1603587600,6),(1050,1616893200,5),(1050,1635642000,6),(1050,1648342800,5),(1050,1667091600,6),(1050,1679792400,5),(1050,1698541200,6),(1050,1711846800,5),(1050,1729990800,6),(1050,1743296400,5),(1050,1761440400,6),(1050,1774746000,5),(1050,1792890000,6),(1050,1806195600,5),(1050,1824944400,6),(1050,1837645200,5),(1050,1856394000,6),(1050,1869094800,5),(1050,1887843600,6),(1050,1901149200,5),(1050,1919293200,6),(1050,1932598800,5),(1050,1950742800,6),(1050,1964048400,5),(1050,1982797200,6),(1050,1995498000,5),(1050,2014246800,6),(1050,2026947600,5),(1050,2045696400,6),(1050,2058397200,5),(1050,2077146000,6),(1050,2090451600,5),(1050,2108595600,6),(1050,2121901200,5),(1050,2140045200,6),(1051,-2147483648,1),(1051,-1869875816,3),(1051,-1693706400,2),(1051,-1680490800,3),(1051,-1570413600,2),(1051,-1552186800,3),(1051,-1538359200,2),(1051,-1522551600,3),(1051,-1507514400,2),(1051,-1490583600,3),(1051,-1440208800,2),(1051,-1428030000,3),(1051,-1409709600,2),(1051,-1396494000,3),(1051,-931140000,2),(1051,-922762800,3),(1051,-917834400,2),(1051,-892436400,3),(1051,-875844000,2),(1051,-857358000,3),(1051,-781063200,2),(1051,-764737200,3),(1051,-744343200,2),(1051,-733806000,3),(1051,-716436000,2),(1051,-701924400,3),(1051,-684986400,2),(1051,-670474800,3),(1051,-654141600,2),(1051,-639025200,3),(1051,-621828000,2),(1051,-606970800,3),(1051,-590032800,2),(1051,-575434800,3),(1051,-235620000,2),(1051,-228279600,3),(1051,-177732000,2),(1051,-165726000,3),(1051,10533600,2),(1051,23835600,3),(1051,41983200,2),(1051,55285200,3),(1051,74037600,2),(1051,87339600,3),(1051,107910000,2),(1051,121219200,3),(1051,133920000,2),(1051,152676000,3),(1051,165362400,2),(1051,183502800,3),(1051,202428000,2),(1051,215557200,3),(1051,228866400,2),(1051,245797200,3),(1051,260316000,2),(1051,277246800,4),(1051,308779200,5),(1051,323827200,4),(1051,340228800,5),(1051,354672000,4),(1051,371678400,5),(1051,386121600,4),(1051,403128000,5),(1051,428446800,4),(1051,433886400,5),(1051,482792400,2),(1051,496702800,3),(1051,512521200,6),(1051,528246000,7),(1051,543970800,6),(1051,559695600,7),(1051,575420400,6),(1051,591145200,7),(1051,606870000,6),(1051,622594800,7),(1051,638319600,6),(1051,654649200,7),(1051,670374000,6),(1051,686098800,7),(1051,701823600,6),(1051,717548400,7),(1051,733273200,6),(1051,748998000,7),(1051,764118000,6),(1051,780447600,7),(1051,796172400,6),(1051,811897200,7),(1051,828226800,6),(1051,846370800,7),(1051,859676400,6),(1051,877820400,7),(1051,891126000,6),(1051,909270000,7),(1051,922575600,6),(1051,941324400,7),(1051,954025200,6),(1051,972774000,7),(1051,985474800,6),(1051,1004223600,7),(1051,1017529200,6),(1051,1035673200,7),(1051,1048978800,6),(1051,1067122800,7),(1051,1080428400,6),(1051,1099177200,7),(1051,1111878000,6),(1051,1130626800,7),(1051,1143327600,6),(1051,1162076400,7),(1051,1167602400,3),(1051,1174784400,8),(1051,1193533200,9),(1051,1206838800,8),(1051,1224982800,9),(1051,1238288400,8),(1051,1256432400,9),(1051,1269738000,8),(1051,1288486800,9),(1051,1301274000,8),(1051,1319936400,9),(1051,1332637200,8),(1051,1351386000,9),(1051,1364691600,8),(1051,1382835600,9),(1051,1396227600,8),(1051,1414285200,9),(1051,1427590800,8),(1051,1446944400,9),(1051,1459040400,8),(1051,1473195600,5),(1051,2147483647,5),(1052,-2147483648,2),(1052,-1691964000,1),(1052,-1680472800,2),(1052,-1664143200,1),(1052,-1650146400,2),(1052,-1633903200,1),(1052,-1617487200,2),(1052,-1601848800,1),(1052,-1586037600,2),(1052,-1570399200,1),(1052,-1552168800,2),(1052,-1538344800,1),(1052,-1522533600,2),(1052,-1507500000,1),(1052,-1490565600,2),(1052,-1473631200,1),(1052,-1460930400,2),(1052,-1442786400,1),(1052,-1428876000,2),(1052,-1410732000,1),(1052,-1396216800,2),(1052,-1379282400,1),(1052,-1364767200,2),(1052,-1348437600,1),(1052,-1333317600,2),(1052,-1315778400,1),(1052,-1301263200,2),(1052,-1284328800,1),(1052,-1269813600,2),(1052,-1253484000,1),(1052,-1238364000,2),(1052,-1221429600,1),(1052,-1206914400,2),(1052,-1189980000,1),(1052,-1175464800,2),(1052,-1159135200,1),(1052,-1143410400,2),(1052,-1126476000,1),(1052,-1111960800,2),(1052,-1095631200,1),(1052,-1080511200,2),(1052,-1063576800,1),(1052,-1049061600,2),(1052,-1032127200,1),(1052,-1017612000,2),(1052,-1001282400,1),(1052,-986162400,2),(1052,-969228000,1),(1052,-950479200,2),(1052,-942012000,1),(1052,-904518000,3),(1052,-896050800,1),(1052,-875487600,3),(1052,-864601200,1),(1052,-844038000,3),(1052,-832546800,1),(1052,-812588400,3),(1052,-798073200,1),(1052,-781052400,3),(1052,-772066800,1),(1052,-764805600,2),(1052,-748476000,1),(1052,-733356000,2),(1052,-719445600,1),(1052,-717030000,3),(1052,-706748400,1),(1052,-699487200,2),(1052,-687996000,1),(1052,-668037600,2),(1052,-654732000,1),(1052,-636588000,2),(1052,-622072800,1),(1052,-605743200,2),(1052,-590623200,1),(1052,-574293600,2),(1052,-558568800,1),(1052,-542239200,2),(1052,-527119200,1),(1052,-512604000,2),(1052,-496274400,1),(1052,-481154400,2),(1052,-464220000,1),(1052,-449704800,2),(1052,-432165600,1),(1052,-417650400,2),(1052,-401320800,1),(1052,-386200800,2),(1052,-369266400,1),(1052,-354751200,2),(1052,-337816800,1),(1052,-323301600,2),(1052,-306972000,1),(1052,-291852000,2),(1052,-276732000,1),(1052,-257983200,2),(1052,-245282400,1),(1052,-226533600,2),(1052,-213228000,1),(1052,-195084000,2),(1052,-182383200,1),(1052,-163634400,2),(1052,-150933600,1),(1052,-132184800,2),(1052,-119484000,1),(1052,-100735200,2),(1052,-88034400,1),(1052,-68680800,2),(1052,-59004000,1),(1052,-37242000,4),(1052,57722400,6),(1052,69818400,1),(1052,89172000,2),(1052,101268000,1),(1052,120621600,2),(1052,132717600,1),(1052,152071200,2),(1052,164167200,1),(1052,183520800,2),(1052,196221600,1),(1052,214970400,2),(1052,227671200,1),(1052,246420000,2),(1052,259120800,1),(1052,278474400,2),(1052,290570400,1),(1052,309924000,2),(1052,322020000,1),(1052,341373600,2),(1052,354675600,5),(1052,372819600,6),(1052,386125200,5),(1052,404269200,6),(1052,417574800,5),(1052,435718800,6),(1052,449024400,5),(1052,467773200,6),(1052,481078800,5),(1052,499222800,6),(1052,512528400,5),(1052,530672400,6),(1052,543978000,5),(1052,562122000,6),(1052,575427600,5),(1052,593571600,6),(1052,606877200,5),(1052,625626000,6),(1052,638326800,5),(1052,657075600,6),(1052,670381200,5),(1052,688525200,6),(1052,701830800,5),(1052,719974800,6),(1052,733280400,5),(1052,751424400,6),(1052,764730000,5),(1052,782874000,6),(1052,796179600,5),(1052,814323600,6),(1052,820454400,7),(1052,828234000,5),(1052,846378000,6),(1052,859683600,5),(1052,877827600,6),(1052,891133200,5),(1052,909277200,6),(1052,922582800,5),(1052,941331600,6),(1052,954032400,5),(1052,972781200,6),(1052,985482000,5),(1052,1004230800,6),(1052,1017536400,5),(1052,1035680400,6),(1052,1048986000,5),(1052,1067130000,6),(1052,1080435600,5),(1052,1099184400,6),(1052,1111885200,5),(1052,1130634000,6),(1052,1143334800,5),(1052,1162083600,6),(1052,1174784400,5),(1052,1193533200,6),(1052,1206838800,5),(1052,1224982800,6),(1052,1238288400,5),(1052,1256432400,6),(1052,1269738000,5),(1052,1288486800,6),(1052,1301187600,5),(1052,1319936400,6),(1052,1332637200,5),(1052,1351386000,6),(1052,1364691600,5),(1052,1382835600,6),(1052,1396141200,5),(1052,1414285200,6),(1052,1427590800,5),(1052,1445734800,6),(1052,1459040400,5),(1052,1477789200,6),(1052,1490490000,5),(1052,1509238800,6),(1052,1521939600,5),(1052,1540688400,6),(1052,1553994000,5),(1052,1572138000,6),(1052,1585443600,5),(1052,1603587600,6),(1052,1616893200,5),(1052,1635642000,6),(1052,1648342800,5),(1052,1667091600,6),(1052,1679792400,5),(1052,1698541200,6),(1052,1711846800,5),(1052,1729990800,6),(1052,1743296400,5),(1052,1761440400,6),(1052,1774746000,5),(1052,1792890000,6),(1052,1806195600,5),(1052,1824944400,6),(1052,1837645200,5),(1052,1856394000,6),(1052,1869094800,5),(1052,1887843600,6),(1052,1901149200,5),(1052,1919293200,6),(1052,1932598800,5),(1052,1950742800,6),(1052,1964048400,5),(1052,1982797200,6),(1052,1995498000,5),(1052,2014246800,6),(1052,2026947600,5),(1052,2045696400,6),(1052,2058397200,5),(1052,2077146000,6),(1052,2090451600,5),(1052,2108595600,6),(1052,2121901200,5),(1052,2140045200,6),(1053,-2147483648,2),(1053,-1693706400,1),(1053,-1680483600,2),(1053,-1663455600,3),(1053,-1650150000,4),(1053,-1632006000,3),(1053,-1618700400,4),(1053,-938905200,3),(1053,-857257200,4),(1053,-844556400,3),(1053,-828226800,4),(1053,-812502000,3),(1053,-796777200,4),(1053,-788922000,6),(1053,-778730400,5),(1053,-762663600,6),(1053,-757389600,8),(1053,354920400,7),(1053,370728000,8),(1053,386456400,7),(1053,402264000,8),(1053,417992400,7),(1053,433800000,8),(1053,449614800,7),(1053,465346800,9),(1053,481071600,10),(1053,496796400,9),(1053,512521200,10),(1053,528246000,9),(1053,543970800,10),(1053,559695600,9),(1053,575420400,10),(1053,591145200,9),(1053,606870000,11),(1053,622598400,12),(1053,638323200,11),(1053,654652800,12),(1053,670377600,11),(1053,686102400,12),(1053,701827200,11),(1053,717552000,12),(1053,733276800,11),(1053,749001600,12),(1053,764726400,11),(1053,780451200,12),(1053,796176000,11),(1053,811900800,12),(1053,828230400,11),(1053,846374400,12),(1053,859680000,11),(1053,877824000,12),(1053,891129600,11),(1053,909273600,12),(1053,922579200,11),(1053,941328000,12),(1053,954028800,11),(1053,972777600,12),(1053,985478400,11),(1053,1004227200,12),(1053,1017532800,11),(1053,1035676800,12),(1053,1048982400,11),(1053,1067126400,12),(1053,1080432000,11),(1053,1099180800,12),(1053,1111881600,11),(1053,1130630400,12),(1053,1143331200,11),(1053,1162080000,12),(1053,1174780800,11),(1053,1193529600,12),(1053,1206835200,11),(1053,1224979200,12),(1053,1238284800,11),(1053,1256428800,12),(1053,1269734400,11),(1053,1288483200,12),(1053,1301184000,13),(1053,1414278000,12),(1054,-2147483648,1),(1054,-1441159324,2),(1054,-1247536800,3),(1054,-892522800,6),(1054,-857257200,4),(1054,-844556400,5),(1054,-828226800,4),(1054,-825382800,3),(1054,354920400,7),(1054,370728000,3),(1054,386456400,7),(1054,402264000,3),(1054,417992400,7),(1054,433800000,3),(1054,449614800,7),(1054,465346800,8),(1054,481071600,9),(1054,496796400,8),(1054,512521200,9),(1054,528246000,8),(1054,543970800,9),(1054,559695600,8),(1054,575420400,9),(1054,591145200,8),(1054,606870000,9),(1054,622594800,8),(1054,638319600,9),(1054,646783200,10),(1054,686102400,2),(1054,701820000,10),(1054,717541200,2),(1054,733269600,10),(1054,748990800,2),(1054,764719200,10),(1054,780440400,2),(1054,796179600,11),(1054,811904400,12),(1054,828234000,11),(1054,846378000,12),(1054,859683600,11),(1054,877827600,12),(1054,891133200,11),(1054,909277200,12),(1054,922582800,11),(1054,941331600,12),(1054,954032400,11),(1054,972781200,12),(1054,985482000,11),(1054,1004230800,12),(1054,1017536400,11),(1054,1035680400,12),(1054,1048986000,11),(1054,1067130000,12),(1054,1080435600,11),(1054,1099184400,12),(1054,1111885200,11),(1054,1130634000,12),(1054,1143334800,11),(1054,1162083600,12),(1054,1174784400,11),(1054,1193533200,12),(1054,1206838800,11),(1054,1224982800,12),(1054,1238288400,11),(1054,1256432400,12),(1054,1269738000,11),(1054,1288486800,12),(1054,1301187600,11),(1054,1319936400,12),(1054,1332637200,11),(1054,1351386000,12),(1054,1364691600,11),(1054,1382835600,12),(1054,1396141200,11),(1054,1414285200,12),(1054,1427590800,11),(1054,1445734800,12),(1054,1459040400,11),(1054,1477789200,12),(1054,1490490000,11),(1054,1509238800,12),(1054,1521939600,11),(1054,1540688400,12),(1054,1553994000,11),(1054,1572138000,12),(1054,1585443600,11),(1054,1603587600,12),(1054,1616893200,11),(1054,1635642000,12),(1054,1648342800,11),(1054,1667091600,12),(1054,1679792400,11),(1054,1698541200,12),(1054,1711846800,11),(1054,1729990800,12),(1054,1743296400,11),(1054,1761440400,12),(1054,1774746000,11),(1054,1792890000,12),(1054,1806195600,11),(1054,1824944400,12),(1054,1837645200,11),(1054,1856394000,12),(1054,1869094800,11),(1054,1887843600,12),(1054,1901149200,11),(1054,1919293200,12),(1054,1932598800,11),(1054,1950742800,12),(1054,1964048400,11),(1054,1982797200,12),(1054,1995498000,11),(1054,2014246800,12),(1054,2026947600,11),(1054,2045696400,12),(1054,2058397200,11),(1054,2077146000,12),(1054,2090451600,11),(1054,2108595600,12),(1054,2121901200,11),(1054,2140045200,12),(1055,-2147483648,0),(1055,-1593820800,1),(1055,-1247540400,3),(1055,354916800,2),(1055,370724400,3),(1055,386452800,2),(1055,402260400,3),(1055,417988800,2),(1055,433796400,3),(1055,449611200,2),(1055,465343200,4),(1055,481068000,5),(1055,496792800,4),(1055,512517600,5),(1055,528242400,4),(1055,543967200,5),(1055,559692000,4),(1055,575416800,5),(1055,591141600,4),(1055,606866400,6),(1055,622594800,7),(1055,638319600,6),(1055,654649200,7),(1055,670374000,4),(1055,701820000,6),(1055,717548400,7),(1055,733273200,6),(1055,748998000,7),(1055,764722800,6),(1055,780447600,7),(1055,796172400,6),(1055,811897200,7),(1055,828226800,6),(1055,846370800,7),(1055,859676400,6),(1055,877820400,7),(1055,891126000,6),(1055,909270000,7),(1055,922575600,6),(1055,941324400,7),(1055,954025200,6),(1055,972774000,7),(1055,985474800,6),(1055,1004223600,7),(1055,1017529200,6),(1055,1035673200,7),(1055,1048978800,6),(1055,1067122800,7),(1055,1080428400,6),(1055,1099177200,7),(1055,1111878000,6),(1055,1130626800,7),(1055,1143327600,6),(1055,1162076400,7),(1055,1174777200,6),(1055,1193526000,7),(1055,1206831600,6),(1055,1224975600,7),(1055,1238281200,6),(1055,1256425200,7),(1055,1269730800,6),(1055,1288479600,7),(1055,1301180400,4),(1055,1414274400,7),(1055,2147483647,7),(1056,-2147483648,0),(1056,-1830384000,6),(1056,-1689555600,1),(1056,-1677801600,2),(1056,-1667437200,3),(1056,-1647738000,4),(1056,-1635814800,3),(1056,-1616202000,4),(1056,-1604365200,3),(1056,-1584666000,4),(1056,-1572742800,3),(1056,-1553043600,4),(1056,-1541206800,3),(1056,-1521507600,4),(1056,-1442451600,3),(1056,-1426813200,4),(1056,-1379293200,3),(1056,-1364778000,4),(1056,-1348448400,3),(1056,-1333328400,4),(1056,-1316394000,3),(1056,-1301274000,4),(1056,-1284339600,3),(1056,-1269824400,4),(1056,-1221440400,3),(1056,-1206925200,4),(1056,-1191200400,3),(1056,-1175475600,4),(1056,-1127696400,3),(1056,-1111971600,4),(1056,-1096851600,3),(1056,-1080522000,4),(1056,-1063587600,3),(1056,-1049072400,4),(1056,-1033347600,3),(1056,-1017622800,4),(1056,-1002502800,3),(1056,-986173200,4),(1056,-969238800,3),(1056,-950490000,4),(1056,-942022800,3),(1056,-922669200,4),(1056,-906944400,3),(1056,-891133200,4),(1056,-877309200,3),(1056,-873684000,5),(1056,-864007200,3),(1056,-857955600,4),(1056,-845859600,3),(1056,-842839200,5),(1056,-831348000,3),(1056,-825901200,4),(1056,-814410000,3),(1056,-810784800,5),(1056,-799898400,3),(1056,-794451600,4),(1056,-782960400,3),(1056,-779335200,5),(1056,-768448800,3),(1056,-763002000,4),(1056,-749091600,3),(1056,-733366800,4),(1056,-717631200,3),(1056,-701906400,4),(1056,-686181600,3),(1056,-670456800,4),(1056,-654732000,3),(1056,-639007200,4),(1056,-591832800,3),(1056,-575503200,4),(1056,-559778400,3),(1056,-544053600,4),(1056,-528328800,3),(1056,-512604000,4),(1056,-496879200,3),(1056,-481154400,4),(1056,-465429600,3),(1056,-449704800,4),(1056,-433980000,3),(1056,-417650400,4),(1056,-401925600,3),(1056,-386200800,4),(1056,-370476000,3),(1056,-354751200,4),(1056,-339026400,3),(1056,-323301600,4),(1056,-307576800,3),(1056,-291852000,4),(1056,-276127200,3),(1056,-260402400,4),(1056,-244677600,3),(1056,-228348000,4),(1056,-212623200,3),(1056,-196898400,4),(1056,-181173600,3),(1056,-165448800,4),(1056,-149724000,3),(1056,-133999200,4),(1056,-118274400,7),(1056,212544000,2),(1056,228268800,3),(1056,243993600,4),(1056,260323200,3),(1056,276048000,4),(1056,291772800,3),(1056,307501200,4),(1056,323222400,3),(1056,338950800,4),(1056,354675600,3),(1056,370400400,4),(1056,386125200,3),(1056,401850000,4),(1056,417578400,3),(1056,433299600,4),(1056,449024400,3),(1056,465354000,4),(1056,481078800,3),(1056,496803600,4),(1056,512528400,3),(1056,528253200,4),(1056,543978000,3),(1056,559702800,4),(1056,575427600,3),(1056,591152400,4),(1056,606877200,3),(1056,622602000,4),(1056,638326800,3),(1056,654656400,4),(1056,670381200,3),(1056,686106000,4),(1056,701830800,3),(1056,717555600,8),(1056,733280400,9),(1056,749005200,8),(1056,764730000,9),(1056,780454800,8),(1056,796179600,9),(1056,811904400,8),(1056,828234000,10),(1056,846378000,6),(1056,859683600,10),(1056,877827600,6),(1056,891133200,10),(1056,909277200,6),(1056,922582800,10),(1056,941331600,6),(1056,954032400,10),(1056,972781200,6),(1056,985482000,10),(1056,1004230800,6),(1056,1017536400,10),(1056,1035680400,6),(1056,1048986000,10),(1056,1067130000,6),(1056,1080435600,10),(1056,1099184400,6),(1056,1111885200,10),(1056,1130634000,6),(1056,1143334800,10),(1056,1162083600,6),(1056,1174784400,10),(1056,1193533200,6),(1056,1206838800,10),(1056,1224982800,6),(1056,1238288400,10),(1056,1256432400,6),(1056,1269738000,10),(1056,1288486800,6),(1056,1301187600,10),(1056,1319936400,6),(1056,1332637200,10),(1056,1351386000,6),(1056,1364691600,10),(1056,1382835600,6),(1056,1396141200,10),(1056,1414285200,6),(1056,1427590800,10),(1056,1445734800,6),(1056,1459040400,10),(1056,1477789200,6),(1056,1490490000,10),(1056,1509238800,6),(1056,1521939600,10),(1056,1540688400,6),(1056,1553994000,10),(1056,1572138000,6),(1056,1585443600,10),(1056,1603587600,6),(1056,1616893200,10),(1056,1635642000,6),(1056,1648342800,10),(1056,1667091600,6),(1056,1679792400,10),(1056,1698541200,6),(1056,1711846800,10),(1056,1729990800,6),(1056,1743296400,10),(1056,1761440400,6),(1056,1774746000,10),(1056,1792890000,6),(1056,1806195600,10),(1056,1824944400,6),(1056,1837645200,10),(1056,1856394000,6),(1056,1869094800,10),(1056,1887843600,6),(1056,1901149200,10),(1056,1919293200,6),(1056,1932598800,10),(1056,1950742800,6),(1056,1964048400,10),(1056,1982797200,6),(1056,1995498000,10),(1056,2014246800,6),(1056,2026947600,10),(1056,2045696400,6),(1056,2058397200,10),(1056,2077146000,6),(1056,2090451600,10),(1056,2108595600,6),(1056,2121901200,10),(1056,2140045200,6),(1057,-2147483648,1),(1057,-905824800,4),(1057,-857257200,2),(1057,-844556400,3),(1057,-828226800,2),(1057,-812502000,3),(1057,-796777200,2),(1057,-788922000,1),(1057,-777942000,3),(1057,-766623600,2),(1057,407199600,1),(1057,417574800,5),(1057,433299600,6),(1057,449024400,5),(1057,465354000,6),(1057,481078800,5),(1057,496803600,6),(1057,512528400,5),(1057,528253200,6),(1057,543978000,5),(1057,559702800,6),(1057,575427600,5),(1057,591152400,6),(1057,606877200,5),(1057,622602000,6),(1057,638326800,5),(1057,654656400,6),(1057,670381200,5),(1057,686106000,6),(1057,701830800,5),(1057,717555600,6),(1057,733280400,5),(1057,749005200,6),(1057,764730000,5),(1057,780454800,6),(1057,796179600,5),(1057,811904400,6),(1057,828234000,5),(1057,846378000,6),(1057,859683600,5),(1057,877827600,6),(1057,891133200,5),(1057,909277200,6),(1057,922582800,5),(1057,941331600,6),(1057,954032400,5),(1057,972781200,6),(1057,985482000,5),(1057,1004230800,6),(1057,1017536400,5),(1057,1035680400,6),(1057,1048986000,5),(1057,1067130000,6),(1057,1080435600,5),(1057,1099184400,6),(1057,1111885200,5),(1057,1130634000,6),(1057,1143334800,5),(1057,1162083600,6),(1057,1174784400,5),(1057,1193533200,6),(1057,1206838800,5),(1057,1224982800,6),(1057,1238288400,5),(1057,1256432400,6),(1057,1269738000,5),(1057,1288486800,6),(1057,1301187600,5),(1057,1319936400,6),(1057,1332637200,5),(1057,1351386000,6),(1057,1364691600,5),(1057,1382835600,6),(1057,1396141200,5),(1057,1414285200,6),(1057,1427590800,5),(1057,1445734800,6),(1057,1459040400,5),(1057,1477789200,6),(1057,1490490000,5),(1057,1509238800,6),(1057,1521939600,5),(1057,1540688400,6),(1057,1553994000,5),(1057,1572138000,6),(1057,1585443600,5),(1057,1603587600,6),(1057,1616893200,5),(1057,1635642000,6),(1057,1648342800,5),(1057,1667091600,6),(1057,1679792400,5),(1057,1698541200,6),(1057,1711846800,5),(1057,1729990800,6),(1057,1743296400,5),(1057,1761440400,6),(1057,1774746000,5),(1057,1792890000,6),(1057,1806195600,5),(1057,1824944400,6),(1057,1837645200,5),(1057,1856394000,6),(1057,1869094800,5),(1057,1887843600,6),(1057,1901149200,5),(1057,1919293200,6),(1057,1932598800,5),(1057,1950742800,6),(1057,1964048400,5),(1057,1982797200,6),(1057,1995498000,5),(1057,2014246800,6),(1057,2026947600,5),(1057,2045696400,6),(1057,2058397200,5),(1057,2077146000,6),(1057,2090451600,5),(1057,2108595600,6),(1057,2121901200,5),(1057,2140045200,6),(1058,-2147483648,2),(1058,-1691964000,1),(1058,-1680472800,2),(1058,-1664143200,1),(1058,-1650146400,2),(1058,-1633903200,1),(1058,-1617487200,2),(1058,-1601848800,1),(1058,-1586037600,2),(1058,-1570399200,1),(1058,-1552168800,2),(1058,-1538344800,1),(1058,-1522533600,2),(1058,-1507500000,1),(1058,-1490565600,2),(1058,-1473631200,1),(1058,-1460930400,2),(1058,-1442786400,1),(1058,-1428876000,2),(1058,-1410732000,1),(1058,-1396216800,2),(1058,-1379282400,1),(1058,-1364767200,2),(1058,-1348437600,1),(1058,-1333317600,2),(1058,-1315778400,1),(1058,-1301263200,2),(1058,-1284328800,1),(1058,-1269813600,2),(1058,-1253484000,1),(1058,-1238364000,2),(1058,-1221429600,1),(1058,-1206914400,2),(1058,-1189980000,1),(1058,-1175464800,2),(1058,-1159135200,1),(1058,-1143410400,2),(1058,-1126476000,1),(1058,-1111960800,2),(1058,-1095631200,1),(1058,-1080511200,2),(1058,-1063576800,1),(1058,-1049061600,2),(1058,-1032127200,1),(1058,-1017612000,2),(1058,-1001282400,1),(1058,-986162400,2),(1058,-969228000,1),(1058,-950479200,2),(1058,-942012000,1),(1058,-904518000,3),(1058,-896050800,1),(1058,-875487600,3),(1058,-864601200,1),(1058,-844038000,3),(1058,-832546800,1),(1058,-812588400,3),(1058,-798073200,1),(1058,-781052400,3),(1058,-772066800,1),(1058,-764805600,2),(1058,-748476000,1),(1058,-733356000,2),(1058,-719445600,1),(1058,-717030000,3),(1058,-706748400,1),(1058,-699487200,2),(1058,-687996000,1),(1058,-668037600,2),(1058,-654732000,1),(1058,-636588000,2),(1058,-622072800,1),(1058,-605743200,2),(1058,-590623200,1),(1058,-574293600,2),(1058,-558568800,1),(1058,-542239200,2),(1058,-527119200,1),(1058,-512604000,2),(1058,-496274400,1),(1058,-481154400,2),(1058,-464220000,1),(1058,-449704800,2),(1058,-432165600,1),(1058,-417650400,2),(1058,-401320800,1),(1058,-386200800,2),(1058,-369266400,1),(1058,-354751200,2),(1058,-337816800,1),(1058,-323301600,2),(1058,-306972000,1),(1058,-291852000,2),(1058,-276732000,1),(1058,-257983200,2),(1058,-245282400,1),(1058,-226533600,2),(1058,-213228000,1),(1058,-195084000,2),(1058,-182383200,1),(1058,-163634400,2),(1058,-150933600,1),(1058,-132184800,2),(1058,-119484000,1),(1058,-100735200,2),(1058,-88034400,1),(1058,-68680800,2),(1058,-59004000,1),(1058,-37242000,4),(1058,57722400,6),(1058,69818400,1),(1058,89172000,2),(1058,101268000,1),(1058,120621600,2),(1058,132717600,1),(1058,152071200,2),(1058,164167200,1),(1058,183520800,2),(1058,196221600,1),(1058,214970400,2),(1058,227671200,1),(1058,246420000,2),(1058,259120800,1),(1058,278474400,2),(1058,290570400,1),(1058,309924000,2),(1058,322020000,1),(1058,341373600,2),(1058,354675600,5),(1058,372819600,6),(1058,386125200,5),(1058,404269200,6),(1058,417574800,5),(1058,435718800,6),(1058,449024400,5),(1058,467773200,6),(1058,481078800,5),(1058,499222800,6),(1058,512528400,5),(1058,530672400,6),(1058,543978000,5),(1058,562122000,6),(1058,575427600,5),(1058,593571600,6),(1058,606877200,5),(1058,625626000,6),(1058,638326800,5),(1058,657075600,6),(1058,670381200,5),(1058,688525200,6),(1058,701830800,5),(1058,719974800,6),(1058,733280400,5),(1058,751424400,6),(1058,764730000,5),(1058,782874000,6),(1058,796179600,5),(1058,814323600,6),(1058,820454400,7),(1058,828234000,5),(1058,846378000,6),(1058,859683600,5),(1058,877827600,6),(1058,891133200,5),(1058,909277200,6),(1058,922582800,5),(1058,941331600,6),(1058,954032400,5),(1058,972781200,6),(1058,985482000,5),(1058,1004230800,6),(1058,1017536400,5),(1058,1035680400,6),(1058,1048986000,5),(1058,1067130000,6),(1058,1080435600,5),(1058,1099184400,6),(1058,1111885200,5),(1058,1130634000,6),(1058,1143334800,5),(1058,1162083600,6),(1058,1174784400,5),(1058,1193533200,6),(1058,1206838800,5),(1058,1224982800,6),(1058,1238288400,5),(1058,1256432400,6),(1058,1269738000,5),(1058,1288486800,6),(1058,1301187600,5),(1058,1319936400,6),(1058,1332637200,5),(1058,1351386000,6),(1058,1364691600,5),(1058,1382835600,6),(1058,1396141200,5),(1058,1414285200,6),(1058,1427590800,5),(1058,1445734800,6),(1058,1459040400,5),(1058,1477789200,6),(1058,1490490000,5),(1058,1509238800,6),(1058,1521939600,5),(1058,1540688400,6),(1058,1553994000,5),(1058,1572138000,6),(1058,1585443600,5),(1058,1603587600,6),(1058,1616893200,5),(1058,1635642000,6),(1058,1648342800,5),(1058,1667091600,6),(1058,1679792400,5),(1058,1698541200,6),(1058,1711846800,5),(1058,1729990800,6),(1058,1743296400,5),(1058,1761440400,6),(1058,1774746000,5),(1058,1792890000,6),(1058,1806195600,5),(1058,1824944400,6),(1058,1837645200,5),(1058,1856394000,6),(1058,1869094800,5),(1058,1887843600,6),(1058,1901149200,5),(1058,1919293200,6),(1058,1932598800,5),(1058,1950742800,6),(1058,1964048400,5),(1058,1982797200,6),(1058,1995498000,5),(1058,2014246800,6),(1058,2026947600,5),(1058,2045696400,6),(1058,2058397200,5),(1058,2077146000,6),(1058,2090451600,5),(1058,2108595600,6),(1058,2121901200,5),(1058,2140045200,6),(1059,-2147483648,0),(1059,-2069713476,2),(1059,-1692496800,1),(1059,-1680483600,2),(1059,-1662343200,1),(1059,-1650157200,2),(1059,-1632006000,3),(1059,-1618700400,4),(1059,-1612659600,6),(1059,-1604278800,5),(1059,-1585519200,6),(1059,-1574038800,5),(1059,-1552258800,6),(1059,-1539997200,5),(1059,-1520550000,6),(1059,-1507510800,5),(1059,-1490572800,6),(1059,-1473642000,5),(1059,-1459119600,6),(1059,-1444006800,5),(1059,-1427673600,6),(1059,-1411866000,5),(1059,-1396224000,6),(1059,-1379293200,5),(1059,-1364774400,6),(1059,-1348448400,5),(1059,-1333324800,6),(1059,-1316394000,5),(1059,-1301270400,6),(1059,-1284339600,5),(1059,-1269813600,7),(1059,-1253484000,8),(1059,-1238364000,7),(1059,-1221429600,8),(1059,-1206914400,7),(1059,-1191189600,8),(1059,-1175464800,7),(1059,-1160344800,8),(1059,-1143410400,7),(1059,-1127685600,8),(1059,-1111960800,7),(1059,-1096840800,8),(1059,-1080511200,7),(1059,-1063576800,8),(1059,-1049061600,7),(1059,-1033336800,8),(1059,-1017612000,7),(1059,-1002492000,8),(1059,-986162400,7),(1059,-969228000,8),(1059,-950479200,7),(1059,-942012000,8),(1059,-935186400,11),(1059,-857257200,9),(1059,-844556400,10),(1059,-828226800,9),(1059,-812502000,10),(1059,-797986800,2),(1059,-781052400,3),(1059,-766623600,4),(1059,-745455600,3),(1059,-733273200,4),(1059,220921200,2),(1059,228877200,12),(1059,243997200,13),(1059,260326800,12),(1059,276051600,13),(1059,291776400,12),(1059,307501200,13),(1059,323830800,12),(1059,338950800,13),(1059,354675600,12),(1059,370400400,13),(1059,386125200,12),(1059,401850000,13),(1059,417574800,12),(1059,433299600,13),(1059,449024400,12),(1059,465354000,13),(1059,481078800,12),(1059,496803600,13),(1059,512528400,12),(1059,528253200,13),(1059,543978000,12),(1059,559702800,13),(1059,575427600,12),(1059,591152400,13),(1059,606877200,12),(1059,622602000,13),(1059,638326800,12),(1059,654656400,13),(1059,670381200,12),(1059,686106000,13),(1059,701830800,12),(1059,717555600,13),(1059,733280400,12),(1059,749005200,13),(1059,764730000,12),(1059,780454800,13),(1059,796179600,12),(1059,811904400,13),(1059,828234000,12),(1059,846378000,13),(1059,859683600,12),(1059,877827600,13),(1059,891133200,12),(1059,909277200,13),(1059,922582800,12),(1059,941331600,13),(1059,954032400,12),(1059,972781200,13),(1059,985482000,12),(1059,1004230800,13),(1059,1017536400,12),(1059,1035680400,13),(1059,1048986000,12),(1059,1067130000,13),(1059,1080435600,12),(1059,1099184400,13),(1059,1111885200,12),(1059,1130634000,13),(1059,1143334800,12),(1059,1162083600,13),(1059,1174784400,12),(1059,1193533200,13),(1059,1206838800,12),(1059,1224982800,13),(1059,1238288400,12),(1059,1256432400,13),(1059,1269738000,12),(1059,1288486800,13),(1059,1301187600,12),(1059,1319936400,13),(1059,1332637200,12),(1059,1351386000,13),(1059,1364691600,12),(1059,1382835600,13),(1059,1396141200,12),(1059,1414285200,13),(1059,1427590800,12),(1059,1445734800,13),(1059,1459040400,12),(1059,1477789200,13),(1059,1490490000,12),(1059,1509238800,13),(1059,1521939600,12),(1059,1540688400,13),(1059,1553994000,12),(1059,1572138000,13),(1059,1585443600,12),(1059,1603587600,13),(1059,1616893200,12),(1059,1635642000,13),(1059,1648342800,12),(1059,1667091600,13),(1059,1679792400,12),(1059,1698541200,13),(1059,1711846800,12),(1059,1729990800,13),(1059,1743296400,12),(1059,1761440400,13),(1059,1774746000,12),(1059,1792890000,13),(1059,1806195600,12),(1059,1824944400,13),(1059,1837645200,12),(1059,1856394000,13),(1059,1869094800,12),(1059,1887843600,13),(1059,1901149200,12),(1059,1919293200,13),(1059,1932598800,12),(1059,1950742800,13),(1059,1964048400,12),(1059,1982797200,13),(1059,1995498000,12),(1059,2014246800,13),(1059,2026947600,12),(1059,2045696400,13),(1059,2058397200,12),(1059,2077146000,13),(1059,2090451600,12),(1059,2108595600,13),(1059,2121901200,12),(1059,2140045200,13),(1060,-2147483648,4),(1060,-1631926800,1),(1060,-1616889600,2),(1060,-1601168400,1),(1060,-1585353600,2),(1060,-1442451600,1),(1060,-1427673600,2),(1060,-1379293200,1),(1060,-1364774400,2),(1060,-1348448400,1),(1060,-1333324800,2),(1060,-1316390400,1),(1060,-1301270400,2),(1060,-1284339600,1),(1060,-1269820800,2),(1060,-1026954000,1),(1060,-1017619200,2),(1060,-1001898000,1),(1060,-999482400,3),(1060,-986090400,1),(1060,-954115200,2),(1060,-940208400,6),(1060,-873079200,5),(1060,-862621200,6),(1060,-842839200,5),(1060,-828320400,6),(1060,-811389600,5),(1060,-796870800,6),(1060,-779940000,5),(1060,-765421200,6),(1060,-748490400,5),(1060,-733971600,6),(1060,-652327200,5),(1060,-639018000,6),(1060,135122400,5),(1060,150246000,6),(1060,166572000,5),(1060,181695600,6),(1060,196812000,5),(1060,212540400,6),(1060,228866400,5),(1060,243990000,6),(1060,260326800,7),(1060,276051600,8),(1060,283993200,6),(1060,291776400,9),(1060,307501200,10),(1060,323830800,9),(1060,338950800,10),(1060,354675600,9),(1060,370400400,10),(1060,386125200,9),(1060,401850000,10),(1060,417574800,9),(1060,433299600,10),(1060,449024400,9),(1060,465354000,10),(1060,481078800,9),(1060,496803600,10),(1060,512528400,9),(1060,528253200,10),(1060,543978000,9),(1060,559702800,10),(1060,575427600,9),(1060,591152400,10),(1060,606877200,9),(1060,622602000,10),(1060,638326800,9),(1060,654656400,10),(1060,670381200,9),(1060,686106000,10),(1060,701830800,9),(1060,717555600,10),(1060,733280400,9),(1060,749005200,10),(1060,764730000,9),(1060,780454800,10),(1060,796179600,9),(1060,811904400,10),(1060,828234000,9),(1060,846378000,10),(1060,859683600,9),(1060,877827600,10),(1060,891133200,9),(1060,909277200,10),(1060,922582800,9),(1060,941331600,10),(1060,954032400,9),(1060,972781200,10),(1060,985482000,9),(1060,1004230800,10),(1060,1017536400,9),(1060,1035680400,10),(1060,1048986000,9),(1060,1067130000,10),(1060,1080435600,9),(1060,1099184400,10),(1060,1111885200,9),(1060,1130634000,10),(1060,1143334800,9),(1060,1162083600,10),(1060,1174784400,9),(1060,1193533200,10),(1060,1206838800,9),(1060,1224982800,10),(1060,1238288400,9),(1060,1256432400,10),(1060,1269738000,9),(1060,1288486800,10),(1060,1301187600,9),(1060,1319936400,10),(1060,1332637200,9),(1060,1351386000,10),(1060,1364691600,9),(1060,1382835600,10),(1060,1396141200,9),(1060,1414285200,10),(1060,1427590800,9),(1060,1445734800,10),(1060,1459040400,9),(1060,1477789200,10),(1060,1490490000,9),(1060,1509238800,10),(1060,1521939600,9),(1060,1540688400,10),(1060,1553994000,9),(1060,1572138000,10),(1060,1585443600,9),(1060,1603587600,10),(1060,1616893200,9),(1060,1635642000,10),(1060,1648342800,9),(1060,1667091600,10),(1060,1679792400,9),(1060,1698541200,10),(1060,1711846800,9),(1060,1729990800,10),(1060,1743296400,9),(1060,1761440400,10),(1060,1774746000,9),(1060,1792890000,10),(1060,1806195600,9),(1060,1824944400,10),(1060,1837645200,9),(1060,1856394000,10),(1060,1869094800,9),(1060,1887843600,10),(1060,1901149200,9),(1060,1919293200,10),(1060,1932598800,9),(1060,1950742800,10),(1060,1964048400,9),(1060,1982797200,10),(1060,1995498000,9),(1060,2014246800,10),(1060,2026947600,9),(1060,2045696400,10),(1060,2058397200,9),(1060,2077146000,10),(1060,2090451600,9),(1060,2108595600,10),(1060,2121901200,9),(1060,2140045200,10),(1061,-2147483648,3),(1061,-1690765200,1),(1061,-1680487200,2),(1061,-1664758800,1),(1061,-1648951200,2),(1061,-1635123600,1),(1061,-1616896800,2),(1061,-1604278800,1),(1061,-1585533600,2),(1061,-1571014800,1),(1061,-1555293600,2),(1061,-932432400,1),(1061,-857257200,3),(1061,-844556400,4),(1061,-828226800,3),(1061,-812588400,4),(1061,-798073200,3),(1061,-781052400,1),(1061,-766717200,2),(1061,-750898800,4),(1061,-733359600,3),(1061,-719456400,4),(1061,-701917200,3),(1061,-689209200,4),(1061,-670460400,3),(1061,-114051600,4),(1061,-103168800,2),(1061,-81997200,4),(1061,-71715600,3),(1061,-50547600,4),(1061,-40266000,3),(1061,-18493200,4),(1061,-8211600,3),(1061,12956400,4),(1061,23238000,3),(1061,43801200,4),(1061,54687600,3),(1061,75855600,4),(1061,86742000,3),(1061,102380400,4),(1061,118105200,3),(1061,135730800,4),(1061,148518000,3),(1061,167187600,1),(1061,180489600,2),(1061,198637200,1),(1061,211939200,2),(1061,230086800,1),(1061,243388800,2),(1061,261536400,1),(1061,274838400,2),(1061,292986000,1),(1061,306288000,2),(1061,323312400,1),(1061,338342400,2),(1061,354675600,5),(1061,370400400,6),(1061,386125200,5),(1061,401850000,6),(1061,417574800,5),(1061,433299600,6),(1061,449024400,5),(1061,465354000,6),(1061,481078800,5),(1061,496803600,6),(1061,512528400,5),(1061,528253200,6),(1061,543978000,5),(1061,559702800,6),(1061,575427600,5),(1061,591152400,6),(1061,606877200,5),(1061,622602000,6),(1061,638326800,5),(1061,654656400,6),(1061,670381200,5),(1061,686106000,6),(1061,701830800,5),(1061,717555600,6),(1061,733280400,5),(1061,749005200,6),(1061,764730000,5),(1061,780454800,6),(1061,796179600,5),(1061,811904400,6),(1061,828234000,5),(1061,846378000,6),(1061,859683600,5),(1061,877827600,6),(1061,891133200,5),(1061,909277200,6),(1061,922582800,5),(1061,941331600,6),(1061,954032400,5),(1061,972781200,6),(1061,985482000,5),(1061,1004230800,6),(1061,1017536400,5),(1061,1035680400,6),(1061,1048986000,5),(1061,1067130000,6),(1061,1080435600,5),(1061,1099184400,6),(1061,1111885200,5),(1061,1130634000,6),(1061,1143334800,5),(1061,1162083600,6),(1061,1174784400,5),(1061,1193533200,6),(1061,1206838800,5),(1061,1224982800,6),(1061,1238288400,5),(1061,1256432400,6),(1061,1269738000,5),(1061,1288486800,6),(1061,1301187600,5),(1061,1319936400,6),(1061,1332637200,5),(1061,1351386000,6),(1061,1364691600,5),(1061,1382835600,6),(1061,1396141200,5),(1061,1414285200,6),(1061,1427590800,5),(1061,1445734800,6),(1061,1459040400,5),(1061,1477789200,6),(1061,1490490000,5),(1061,1509238800,6),(1061,1521939600,5),(1061,1540688400,6),(1061,1553994000,5),(1061,1572138000,6),(1061,1585443600,5),(1061,1603587600,6),(1061,1616893200,5),(1061,1635642000,6),(1061,1648342800,5),(1061,1667091600,6),(1061,1679792400,5),(1061,1698541200,6),(1061,1711846800,5),(1061,1729990800,6),(1061,1743296400,5),(1061,1761440400,6),(1061,1774746000,5),(1061,1792890000,6),(1061,1806195600,5),(1061,1824944400,6),(1061,1837645200,5),(1061,1856394000,6),(1061,1869094800,5),(1061,1887843600,6),(1061,1901149200,5),(1061,1919293200,6),(1061,1932598800,5),(1061,1950742800,6),(1061,1964048400,5),(1061,1982797200,6),(1061,1995498000,5),(1061,2014246800,6),(1061,2026947600,5),(1061,2045696400,6),(1061,2058397200,5),(1061,2077146000,6),(1061,2090451600,5),(1061,2108595600,6),(1061,2121901200,5),(1061,2140045200,6),(1062,-2147483648,1),(1062,-1535938789,3),(1062,-875671200,2),(1062,-859773600,3),(1062,354672000,2),(1062,370396800,3),(1062,386121600,2),(1062,401846400,3),(1062,417574800,4),(1062,433299600,5),(1062,449024400,4),(1062,465354000,5),(1062,481078800,4),(1062,496803600,5),(1062,512528400,4),(1062,528253200,5),(1062,543978000,4),(1062,559702800,5),(1062,575427600,4),(1062,591152400,5),(1062,606877200,4),(1062,622602000,5),(1062,638326800,4),(1062,654656400,5),(1062,670381200,4),(1062,686106000,5),(1062,701830800,4),(1062,717555600,5),(1062,733280400,4),(1062,749005200,5),(1062,764730000,4),(1062,780454800,5),(1062,796179600,4),(1062,811904400,5),(1062,828234000,4),(1062,846378000,5),(1062,859683600,4),(1062,877827600,5),(1062,891133200,4),(1062,909277200,5),(1062,922582800,4),(1062,941331600,5),(1062,954032400,4),(1062,972781200,5),(1062,985482000,4),(1062,1004230800,5),(1062,1017536400,4),(1062,1035680400,5),(1062,1048986000,4),(1062,1067130000,5),(1062,1080435600,4),(1062,1099184400,5),(1062,1111885200,4),(1062,1130634000,5),(1062,1143334800,4),(1062,1162083600,5),(1062,1174784400,4),(1062,1193533200,5),(1062,1206838800,4),(1062,1224982800,5),(1062,1238288400,4),(1062,1256432400,5),(1062,1269738000,4),(1062,1288486800,5),(1062,1301187600,4),(1062,1319936400,5),(1062,1332637200,4),(1062,1351386000,5),(1062,1364691600,4),(1062,1382835600,5),(1062,1396141200,4),(1062,1414285200,5),(1062,1427590800,4),(1062,1445734800,5),(1062,1459040400,4),(1062,1477789200,5),(1062,1490490000,4),(1062,1509238800,5),(1062,1521939600,4),(1062,1540688400,5),(1062,1553994000,4),(1062,1572138000,5),(1062,1585443600,4),(1062,1603587600,5),(1062,1616893200,4),(1062,1635642000,5),(1062,1648342800,4),(1062,1667091600,5),(1062,1679792400,4),(1062,1698541200,5),(1062,1711846800,4),(1062,1729990800,5),(1062,1743296400,4),(1062,1761440400,5),(1062,1774746000,4),(1062,1792890000,5),(1062,1806195600,4),(1062,1824944400,5),(1062,1837645200,4),(1062,1856394000,5),(1062,1869094800,4),(1062,1887843600,5),(1062,1901149200,4),(1062,1919293200,5),(1062,1932598800,4),(1062,1950742800,5),(1062,1964048400,4),(1062,1982797200,5),(1062,1995498000,4),(1062,2014246800,5),(1062,2026947600,4),(1062,2045696400,5),(1062,2058397200,4),(1062,2077146000,5),(1062,2090451600,4),(1062,2108595600,5),(1062,2121901200,4),(1062,2140045200,5),(1063,-2147483648,1),(1063,-1441158600,2),(1063,-1247536800,3),(1063,-899780400,6),(1063,-857257200,4),(1063,-844556400,5),(1063,-828226800,4),(1063,-812502000,5),(1063,-804650400,3),(1063,354920400,7),(1063,370728000,3),(1063,386456400,7),(1063,402264000,3),(1063,417992400,7),(1063,433800000,3),(1063,449614800,7),(1063,465346800,8),(1063,481071600,9),(1063,496796400,8),(1063,512521200,9),(1063,528246000,8),(1063,543970800,9),(1063,559695600,8),(1063,575420400,9),(1063,591145200,8),(1063,606870000,9),(1063,622594800,8),(1063,631141200,3),(1063,670374000,10),(1063,686102400,11),(1063,701827200,10),(1063,717552000,11),(1063,733276800,10),(1063,749001600,11),(1063,764726400,10),(1063,780451200,11),(1063,796176000,10),(1063,811900800,11),(1063,828230400,10),(1063,846374400,11),(1063,859680000,10),(1063,877824000,11),(1063,891129600,10),(1063,909273600,11),(1063,922579200,10),(1063,941328000,11),(1063,954028800,10),(1063,972777600,11),(1063,985478400,10),(1063,1004227200,11),(1063,1017532800,10),(1063,1035676800,11),(1063,1048982400,10),(1063,1067126400,11),(1063,1080432000,10),(1063,1099180800,11),(1063,1111881600,10),(1063,1130630400,11),(1063,1143331200,10),(1063,1162080000,11),(1063,1174780800,10),(1063,1193529600,11),(1063,1206835200,10),(1063,1224979200,11),(1063,1238284800,10),(1063,1256428800,11),(1063,1269734400,10),(1063,1288483200,11),(1063,1301184000,12),(1063,2147483647,12),(1064,-2147483648,1),(1064,-1855958961,6),(1064,-1689814800,2),(1064,-1680397200,3),(1064,-1665363600,2),(1064,-1648342800,3),(1064,-1635123600,2),(1064,-1616893200,3),(1064,-1604278800,2),(1064,-1585443600,3),(1064,-1574038800,2),(1064,-1552266000,3),(1064,-1539997200,2),(1064,-1520557200,3),(1064,-1507510800,2),(1064,-1490576400,3),(1064,-1470618000,2),(1064,-1459126800,3),(1064,-1444006800,2),(1064,-1427677200,3),(1064,-1411952400,2),(1064,-1396227600,3),(1064,-1379293200,2),(1064,-1364778000,3),(1064,-1348448400,2),(1064,-1333328400,3),(1064,-1316394000,2),(1064,-1301274000,3),(1064,-1284339600,2),(1064,-1269824400,3),(1064,-1253494800,2),(1064,-1238374800,3),(1064,-1221440400,2),(1064,-1206925200,3),(1064,-1191200400,2),(1064,-1175475600,3),(1064,-1160355600,2),(1064,-1143421200,3),(1064,-1127696400,2),(1064,-1111971600,3),(1064,-1096851600,2),(1064,-1080522000,3),(1064,-1063587600,2),(1064,-1049072400,3),(1064,-1033347600,2),(1064,-1017622800,3),(1064,-1002502800,2),(1064,-986173200,3),(1064,-969238800,2),(1064,-950490000,3),(1064,-942012000,4),(1064,-904438800,5),(1064,-891136800,4),(1064,-877827600,5),(1064,-857257200,4),(1064,-844556400,5),(1064,-828226800,4),(1064,-812502000,5),(1064,-796266000,4),(1064,-781052400,5),(1064,-766623600,8),(1064,196819200,7),(1064,212540400,8),(1064,228877200,9),(1064,243997200,10),(1064,260326800,9),(1064,276051600,10),(1064,291776400,9),(1064,307501200,10),(1064,323830800,9),(1064,338950800,10),(1064,354675600,9),(1064,370400400,10),(1064,386125200,9),(1064,401850000,10),(1064,417574800,9),(1064,433299600,10),(1064,449024400,9),(1064,465354000,10),(1064,481078800,9),(1064,496803600,10),(1064,512528400,9),(1064,528253200,10),(1064,543978000,9),(1064,559702800,10),(1064,575427600,9),(1064,591152400,10),(1064,606877200,9),(1064,622602000,10),(1064,638326800,9),(1064,654656400,10),(1064,670381200,9),(1064,686106000,10),(1064,701830800,9),(1064,717555600,10),(1064,733280400,9),(1064,749005200,10),(1064,764730000,9),(1064,780454800,10),(1064,796179600,9),(1064,811904400,10),(1064,828234000,9),(1064,846378000,10),(1064,859683600,9),(1064,877827600,10),(1064,891133200,9),(1064,909277200,10),(1064,922582800,9),(1064,941331600,10),(1064,954032400,9),(1064,972781200,10),(1064,985482000,9),(1064,1004230800,10),(1064,1017536400,9),(1064,1035680400,10),(1064,1048986000,9),(1064,1067130000,10),(1064,1080435600,9),(1064,1099184400,10),(1064,1111885200,9),(1064,1130634000,10),(1064,1143334800,9),(1064,1162083600,10),(1064,1174784400,9),(1064,1193533200,10),(1064,1206838800,9),(1064,1224982800,10),(1064,1238288400,9),(1064,1256432400,10),(1064,1269738000,9),(1064,1288486800,10),(1064,1301187600,9),(1064,1319936400,10),(1064,1332637200,9),(1064,1351386000,10),(1064,1364691600,9),(1064,1382835600,10),(1064,1396141200,9),(1064,1414285200,10),(1064,1427590800,9),(1064,1445734800,10),(1064,1459040400,9),(1064,1477789200,10),(1064,1490490000,9),(1064,1509238800,10),(1064,1521939600,9),(1064,1540688400,10),(1064,1553994000,9),(1064,1572138000,10),(1064,1585443600,9),(1064,1603587600,10),(1064,1616893200,9),(1064,1635642000,10),(1064,1648342800,9),(1064,1667091600,10),(1064,1679792400,9),(1064,1698541200,10),(1064,1711846800,9),(1064,1729990800,10),(1064,1743296400,9),(1064,1761440400,10),(1064,1774746000,9),(1064,1792890000,10),(1064,1806195600,9),(1064,1824944400,10),(1064,1837645200,9),(1064,1856394000,10),(1064,1869094800,9),(1064,1887843600,10),(1064,1901149200,9),(1064,1919293200,10),(1064,1932598800,9),(1064,1950742800,10),(1064,1964048400,9),(1064,1982797200,10),(1064,1995498000,9),(1064,2014246800,10),(1064,2026947600,9),(1064,2045696400,10),(1064,2058397200,9),(1064,2077146000,10),(1064,2090451600,9),(1064,2108595600,10),(1064,2121901200,9),(1064,2140045200,10),(1065,-2147483648,1),(1065,-1688265017,3),(1065,-1656819079,2),(1065,-1641353479,3),(1065,-1627965079,4),(1065,-1618716679,2),(1065,-1596429079,4),(1065,-1593820800,5),(1065,-1589860800,6),(1065,-1542427200,7),(1065,-1539493200,8),(1065,-1525323600,7),(1065,-1522728000,6),(1065,-1491188400,9),(1065,-1247536800,6),(1065,354920400,7),(1065,370728000,6),(1065,386456400,7),(1065,402264000,6),(1065,417992400,7),(1065,433800000,6),(1065,449614800,7),(1065,465346800,10),(1065,481071600,11),(1065,496796400,10),(1065,512521200,11),(1065,528246000,10),(1065,543970800,11),(1065,559695600,10),(1065,575420400,11),(1065,591145200,10),(1065,606870000,11),(1065,622594800,10),(1065,638319600,11),(1065,654649200,10),(1065,670374000,12),(1065,686102400,13),(1065,695779200,10),(1065,701823600,11),(1065,717548400,10),(1065,733273200,11),(1065,748998000,10),(1065,764722800,11),(1065,780447600,10),(1065,796172400,11),(1065,811897200,10),(1065,828226800,11),(1065,846370800,10),(1065,859676400,11),(1065,877820400,10),(1065,891126000,11),(1065,909270000,10),(1065,922575600,11),(1065,941324400,10),(1065,954025200,11),(1065,972774000,10),(1065,985474800,11),(1065,1004223600,10),(1065,1017529200,11),(1065,1035673200,10),(1065,1048978800,11),(1065,1067122800,10),(1065,1080428400,11),(1065,1099177200,10),(1065,1111878000,11),(1065,1130626800,10),(1065,1143327600,11),(1065,1162076400,10),(1065,1174777200,11),(1065,1193526000,10),(1065,1206831600,11),(1065,1224975600,10),(1065,1238281200,11),(1065,1256425200,10),(1065,1269730800,11),(1065,1288479600,10),(1065,1301180400,14),(1065,1414274400,10),(1066,-2147483648,0),(1066,-1518920008,2),(1066,166572000,1),(1066,182293200,2),(1066,200959200,1),(1066,213829200,2),(1066,228866400,1),(1066,243982800,2),(1066,260316000,1),(1066,276123600,2),(1066,291765600,1),(1066,307486800,2),(1066,323820000,1),(1066,338936400,2),(1066,354664800,1),(1066,370386000,2),(1066,386114400,1),(1066,401835600,2),(1066,417564000,1),(1066,433285200,2),(1066,449013600,1),(1066,465339600,2),(1066,481068000,1),(1066,496789200,2),(1066,512517600,1),(1066,528238800,2),(1066,543967200,1),(1066,559688400,2),(1066,575416800,1),(1066,591138000,2),(1066,606866400,1),(1066,622587600,2),(1066,638316000,1),(1066,654642000,2),(1066,670370400,1),(1066,686091600,2),(1066,701820000,1),(1066,717541200,2),(1066,733269600,1),(1066,748990800,2),(1066,764719200,1),(1066,780440400,2),(1066,796168800,1),(1066,811890000,2),(1066,828223200,1),(1066,843944400,2),(1066,859672800,1),(1066,875394000,2),(1066,891122400,1),(1066,909277200,3),(1066,922582800,4),(1066,941331600,3),(1066,954032400,4),(1066,972781200,3),(1066,985482000,4),(1066,1004230800,3),(1066,1017536400,4),(1066,1035680400,3),(1066,1048986000,4),(1066,1067130000,3),(1066,1080435600,4),(1066,1099184400,3),(1066,1111885200,4),(1066,1130634000,3),(1066,1143334800,4),(1066,1162083600,3),(1066,1174784400,4),(1066,1193533200,3),(1066,1206838800,4),(1066,1224982800,3),(1066,1238288400,4),(1066,1256432400,3),(1066,1269738000,4),(1066,1288486800,3),(1066,1301187600,4),(1066,1319936400,3),(1066,1332637200,4),(1066,1351386000,3),(1066,1364691600,4),(1066,1382835600,3),(1066,1396141200,4),(1066,1414285200,3),(1066,1427590800,4),(1066,1445734800,3),(1066,1459040400,4),(1066,1477789200,3),(1066,1490490000,4),(1066,1509238800,3),(1066,1521939600,4),(1066,1540688400,3),(1066,1553994000,4),(1066,1572138000,3),(1066,1585443600,4),(1066,1603587600,3),(1066,1616893200,4),(1066,1635642000,3),(1066,1648342800,4),(1066,1667091600,3),(1066,1679792400,4),(1066,1698541200,3),(1066,1711846800,4),(1066,1729990800,3),(1066,1743296400,4),(1066,1761440400,3),(1066,1774746000,4),(1066,1792890000,3),(1066,1806195600,4),(1066,1824944400,3),(1066,1837645200,4),(1066,1856394000,3),(1066,1869094800,4),(1066,1887843600,3),(1066,1901149200,4),(1066,1919293200,3),(1066,1932598800,4),(1066,1950742800,3),(1066,1964048400,4),(1066,1982797200,3),(1066,1995498000,4),(1066,2014246800,3),(1066,2026947600,4),(1066,2045696400,3),(1066,2058397200,4),(1066,2077146000,3),(1066,2090451600,4),(1066,2108595600,3),(1066,2121901200,4),(1066,2140045200,3),(1067,-2147483648,2),(1067,-1691884800,1),(1067,-1680573600,2),(1067,-927511200,1),(1067,-857257200,3),(1067,-844556400,4),(1067,-828226800,3),(1067,-812502000,4),(1067,-796777200,3),(1067,-781052400,4),(1067,-765327600,3),(1067,-340844400,4),(1067,-324514800,3),(1067,-308790000,4),(1067,-293065200,3),(1067,-277340400,4),(1067,-261615600,3),(1067,-245890800,4),(1067,-230166000,3),(1067,-214441200,4),(1067,-198716400,3),(1067,-182991600,4),(1067,-166662000,3),(1067,-147913200,4),(1067,-135212400,3),(1067,315529200,2),(1067,323830800,5),(1067,338950800,6),(1067,354675600,5),(1067,370400400,6),(1067,386125200,5),(1067,401850000,6),(1067,417574800,5),(1067,433299600,6),(1067,449024400,5),(1067,465354000,6),(1067,481078800,5),(1067,496803600,6),(1067,512528400,5),(1067,528253200,6),(1067,543978000,5),(1067,559702800,6),(1067,575427600,5),(1067,591152400,6),(1067,606877200,5),(1067,622602000,6),(1067,638326800,5),(1067,654656400,6),(1067,670381200,5),(1067,686106000,6),(1067,701830800,5),(1067,717555600,6),(1067,733280400,5),(1067,749005200,6),(1067,764730000,5),(1067,780454800,6),(1067,796179600,5),(1067,811904400,6),(1067,828234000,5),(1067,846378000,6),(1067,859683600,5),(1067,877827600,6),(1067,891133200,5),(1067,909277200,6),(1067,922582800,5),(1067,941331600,6),(1067,954032400,5),(1067,972781200,6),(1067,985482000,5),(1067,1004230800,6),(1067,1017536400,5),(1067,1035680400,6),(1067,1048986000,5),(1067,1067130000,6),(1067,1080435600,5),(1067,1099184400,6),(1067,1111885200,5),(1067,1130634000,6),(1067,1143334800,5),(1067,1162083600,6),(1067,1174784400,5),(1067,1193533200,6),(1067,1206838800,5),(1067,1224982800,6),(1067,1238288400,5),(1067,1256432400,6),(1067,1269738000,5),(1067,1288486800,6),(1067,1301187600,5),(1067,1319936400,6),(1067,1332637200,5),(1067,1351386000,6),(1067,1364691600,5),(1067,1382835600,6),(1067,1396141200,5),(1067,1414285200,6),(1067,1427590800,5),(1067,1445734800,6),(1067,1459040400,5),(1067,1477789200,6),(1067,1490490000,5),(1067,1509238800,6),(1067,1521939600,5),(1067,1540688400,6),(1067,1553994000,5),(1067,1572138000,6),(1067,1585443600,5),(1067,1603587600,6),(1067,1616893200,5),(1067,1635642000,6),(1067,1648342800,5),(1067,1667091600,6),(1067,1679792400,5),(1067,1698541200,6),(1067,1711846800,5),(1067,1729990800,6),(1067,1743296400,5),(1067,1761440400,6),(1067,1774746000,5),(1067,1792890000,6),(1067,1806195600,5),(1067,1824944400,6),(1067,1837645200,5),(1067,1856394000,6),(1067,1869094800,5),(1067,1887843600,6),(1067,1901149200,5),(1067,1919293200,6),(1067,1932598800,5),(1067,1950742800,6),(1067,1964048400,5),(1067,1982797200,6),(1067,1995498000,5),(1067,2014246800,6),(1067,2026947600,5),(1067,2045696400,6),(1067,2058397200,5),(1067,2077146000,6),(1067,2090451600,5),(1067,2108595600,6),(1067,2121901200,5),(1067,2140045200,6),(1068,-2147483648,1),(1068,-1855958901,5),(1068,-1689814800,2),(1068,-1680397200,3),(1068,-1665363600,2),(1068,-1648342800,3),(1068,-1635123600,2),(1068,-1616893200,3),(1068,-1604278800,2),(1068,-1585443600,3),(1068,-1574038800,2),(1068,-1552266000,3),(1068,-1539997200,2),(1068,-1520557200,3),(1068,-1507510800,2),(1068,-1490576400,3),(1068,-1470618000,2),(1068,-1459126800,3),(1068,-1444006800,2),(1068,-1427677200,3),(1068,-1411952400,2),(1068,-1396227600,3),(1068,-1379293200,2),(1068,-1364778000,3),(1068,-1348448400,2),(1068,-1333328400,3),(1068,-1316394000,2),(1068,-1301274000,3),(1068,-1284339600,2),(1068,-1269824400,3),(1068,-1253494800,2),(1068,-1238374800,3),(1068,-1221440400,2),(1068,-1206925200,3),(1068,-1191200400,2),(1068,-1175475600,3),(1068,-1160355600,2),(1068,-1143421200,3),(1068,-1127696400,2),(1068,-1111971600,3),(1068,-1096851600,2),(1068,-1080522000,3),(1068,-1063587600,2),(1068,-1049072400,3),(1068,-1033347600,2),(1068,-1017622800,3),(1068,-1002502800,2),(1068,-986173200,3),(1068,-969238800,2),(1068,-950490000,3),(1068,-942012000,4),(1068,-932436000,8),(1068,-857257200,6),(1068,-844556400,7),(1068,-828226800,6),(1068,-812502000,7),(1068,-800071200,9),(1068,-796266000,4),(1068,-781052400,9),(1068,-766623600,10),(1068,196819200,8),(1068,212540400,10),(1068,228877200,11),(1068,243997200,12),(1068,260326800,11),(1068,276051600,12),(1068,291776400,11),(1068,307501200,12),(1068,323830800,11),(1068,338950800,12),(1068,354675600,11),(1068,370400400,12),(1068,386125200,11),(1068,401850000,12),(1068,417574800,11),(1068,433299600,12),(1068,449024400,11),(1068,465354000,12),(1068,481078800,11),(1068,496803600,12),(1068,512528400,11),(1068,528253200,12),(1068,543978000,11),(1068,559702800,12),(1068,575427600,11),(1068,591152400,12),(1068,606877200,11),(1068,622602000,12),(1068,638326800,11),(1068,654656400,12),(1068,670381200,11),(1068,686106000,12),(1068,701830800,11),(1068,717555600,12),(1068,733280400,11),(1068,749005200,12),(1068,764730000,11),(1068,780454800,12),(1068,796179600,11),(1068,811904400,12),(1068,828234000,11),(1068,846378000,12),(1068,859683600,11),(1068,877827600,12),(1068,891133200,11),(1068,909277200,12),(1068,922582800,11),(1068,941331600,12),(1068,954032400,11),(1068,972781200,12),(1068,985482000,11),(1068,1004230800,12),(1068,1017536400,11),(1068,1035680400,12),(1068,1048986000,11),(1068,1067130000,12),(1068,1080435600,11),(1068,1099184400,12),(1068,1111885200,11),(1068,1130634000,12),(1068,1143334800,11),(1068,1162083600,12),(1068,1174784400,11),(1068,1193533200,12),(1068,1206838800,11),(1068,1224982800,12),(1068,1238288400,11),(1068,1256432400,12),(1068,1269738000,11),(1068,1288486800,12),(1068,1301187600,11),(1068,1319936400,12),(1068,1332637200,11),(1068,1351386000,12),(1068,1364691600,11),(1068,1382835600,12),(1068,1396141200,11),(1068,1414285200,12),(1068,1427590800,11),(1068,1445734800,12),(1068,1459040400,11),(1068,1477789200,12),(1068,1490490000,11),(1068,1509238800,12),(1068,1521939600,11),(1068,1540688400,12),(1068,1553994000,11),(1068,1572138000,12),(1068,1585443600,11),(1068,1603587600,12),(1068,1616893200,11),(1068,1635642000,12),(1068,1648342800,11),(1068,1667091600,12),(1068,1679792400,11),(1068,1698541200,12),(1068,1711846800,11),(1068,1729990800,12),(1068,1743296400,11),(1068,1761440400,12),(1068,1774746000,11),(1068,1792890000,12),(1068,1806195600,11),(1068,1824944400,12),(1068,1837645200,11),(1068,1856394000,12),(1068,1869094800,11),(1068,1887843600,12),(1068,1901149200,11),(1068,1919293200,12),(1068,1932598800,11),(1068,1950742800,12),(1068,1964048400,11),(1068,1982797200,12),(1068,1995498000,11),(1068,2014246800,12),(1068,2026947600,11),(1068,2045696400,12),(1068,2058397200,11),(1068,2077146000,12),(1068,2090451600,11),(1068,2108595600,12),(1068,2121901200,11),(1068,2140045200,12),(1069,-2147483648,1),(1069,-905824800,4),(1069,-857257200,2),(1069,-844556400,3),(1069,-828226800,2),(1069,-812502000,3),(1069,-796777200,2),(1069,-788922000,1),(1069,-777942000,3),(1069,-766623600,2),(1069,407199600,1),(1069,417574800,5),(1069,433299600,6),(1069,449024400,5),(1069,465354000,6),(1069,481078800,5),(1069,496803600,6),(1069,512528400,5),(1069,528253200,6),(1069,543978000,5),(1069,559702800,6),(1069,575427600,5),(1069,591152400,6),(1069,606877200,5),(1069,622602000,6),(1069,638326800,5),(1069,654656400,6),(1069,670381200,5),(1069,686106000,6),(1069,701830800,5),(1069,717555600,6),(1069,733280400,5),(1069,749005200,6),(1069,764730000,5),(1069,780454800,6),(1069,796179600,5),(1069,811904400,6),(1069,828234000,5),(1069,846378000,6),(1069,859683600,5),(1069,877827600,6),(1069,891133200,5),(1069,909277200,6),(1069,922582800,5),(1069,941331600,6),(1069,954032400,5),(1069,972781200,6),(1069,985482000,5),(1069,1004230800,6),(1069,1017536400,5),(1069,1035680400,6),(1069,1048986000,5),(1069,1067130000,6),(1069,1080435600,5),(1069,1099184400,6),(1069,1111885200,5),(1069,1130634000,6),(1069,1143334800,5),(1069,1162083600,6),(1069,1174784400,5),(1069,1193533200,6),(1069,1206838800,5),(1069,1224982800,6),(1069,1238288400,5),(1069,1256432400,6),(1069,1269738000,5),(1069,1288486800,6),(1069,1301187600,5),(1069,1319936400,6),(1069,1332637200,5),(1069,1351386000,6),(1069,1364691600,5),(1069,1382835600,6),(1069,1396141200,5),(1069,1414285200,6),(1069,1427590800,5),(1069,1445734800,6),(1069,1459040400,5),(1069,1477789200,6),(1069,1490490000,5),(1069,1509238800,6),(1069,1521939600,5),(1069,1540688400,6),(1069,1553994000,5),(1069,1572138000,6),(1069,1585443600,5),(1069,1603587600,6),(1069,1616893200,5),(1069,1635642000,6),(1069,1648342800,5),(1069,1667091600,6),(1069,1679792400,5),(1069,1698541200,6),(1069,1711846800,5),(1069,1729990800,6),(1069,1743296400,5),(1069,1761440400,6),(1069,1774746000,5),(1069,1792890000,6),(1069,1806195600,5),(1069,1824944400,6),(1069,1837645200,5),(1069,1856394000,6),(1069,1869094800,5),(1069,1887843600,6),(1069,1901149200,5),(1069,1919293200,6),(1069,1932598800,5),(1069,1950742800,6),(1069,1964048400,5),(1069,1982797200,6),(1069,1995498000,5),(1069,2014246800,6),(1069,2026947600,5),(1069,2045696400,6),(1069,2058397200,5),(1069,2077146000,6),(1069,2090451600,5),(1069,2108595600,6),(1069,2121901200,5),(1069,2140045200,6),(1070,-2147483648,2),(1070,-1693706400,1),(1070,-1680483600,2),(1070,-1663455600,3),(1070,-1650150000,4),(1070,-1632006000,3),(1070,-1618700400,4),(1070,-938905200,3),(1070,-857257200,4),(1070,-844556400,3),(1070,-828226800,4),(1070,-812502000,3),(1070,-796777200,4),(1070,-781052400,3),(1070,-777866400,1),(1070,-765327600,4),(1070,-746578800,3),(1070,-733359600,4),(1070,-728517600,5),(1070,-721260000,2),(1070,-716425200,3),(1070,-701910000,4),(1070,-684975600,3),(1070,-670460400,4),(1070,-654217200,3),(1070,-639010800,4),(1070,283993200,2),(1070,291776400,6),(1070,307501200,7),(1070,323830800,6),(1070,338950800,7),(1070,354675600,6),(1070,370400400,7),(1070,386125200,6),(1070,401850000,7),(1070,417574800,6),(1070,433299600,7),(1070,449024400,6),(1070,465354000,7),(1070,481078800,6),(1070,496803600,7),(1070,512528400,6),(1070,528253200,7),(1070,543978000,6),(1070,559702800,7),(1070,575427600,6),(1070,591152400,7),(1070,606877200,6),(1070,622602000,7),(1070,638326800,6),(1070,654656400,7),(1070,670381200,6),(1070,686106000,7),(1070,701830800,6),(1070,717555600,7),(1070,733280400,6),(1070,749005200,7),(1070,764730000,6),(1070,780454800,7),(1070,796179600,6),(1070,811904400,7),(1070,828234000,6),(1070,846378000,7),(1070,859683600,6),(1070,877827600,7),(1070,891133200,6),(1070,909277200,7),(1070,922582800,6),(1070,941331600,7),(1070,954032400,6),(1070,972781200,7),(1070,985482000,6),(1070,1004230800,7),(1070,1017536400,6),(1070,1035680400,7),(1070,1048986000,6),(1070,1067130000,7),(1070,1080435600,6),(1070,1099184400,7),(1070,1111885200,6),(1070,1130634000,7),(1070,1143334800,6),(1070,1162083600,7),(1070,1174784400,6),(1070,1193533200,7),(1070,1206838800,6),(1070,1224982800,7),(1070,1238288400,6),(1070,1256432400,7),(1070,1269738000,6),(1070,1288486800,7),(1070,1301187600,6),(1070,1319936400,7),(1070,1332637200,6),(1070,1351386000,7),(1070,1364691600,6),(1070,1382835600,7),(1070,1396141200,6),(1070,1414285200,7),(1070,1427590800,6),(1070,1445734800,7),(1070,1459040400,6),(1070,1477789200,7),(1070,1490490000,6),(1070,1509238800,7),(1070,1521939600,6),(1070,1540688400,7),(1070,1553994000,6),(1070,1572138000,7),(1070,1585443600,6),(1070,1603587600,7),(1070,1616893200,6),(1070,1635642000,7),(1070,1648342800,6),(1070,1667091600,7),(1070,1679792400,6),(1070,1698541200,7),(1070,1711846800,6),(1070,1729990800,7),(1070,1743296400,6),(1070,1761440400,7),(1070,1774746000,6),(1070,1792890000,7),(1070,1806195600,6),(1070,1824944400,7),(1070,1837645200,6),(1070,1856394000,7),(1070,1869094800,6),(1070,1887843600,7),(1070,1901149200,6),(1070,1919293200,7),(1070,1932598800,6),(1070,1950742800,7),(1070,1964048400,6),(1070,1982797200,7),(1070,1995498000,6),(1070,2014246800,7),(1070,2026947600,6),(1070,2045696400,7),(1070,2058397200,6),(1070,2077146000,7),(1070,2090451600,6),(1070,2108595600,7),(1070,2121901200,6),(1070,2140045200,7),(1071,-2147483648,1),(1071,-1632008194,2),(1071,-1618702594,1),(1071,-1601681794,2),(1071,-1597275394,1),(1071,-1377308194,3),(1071,-928029600,4),(1071,-899521200,7),(1071,-857257200,5),(1071,-844556400,6),(1071,-828226800,5),(1071,-812502000,6),(1071,-796777200,5),(1071,-795834000,4),(1071,354920400,8),(1071,370728000,4),(1071,386456400,8),(1071,402264000,4),(1071,417992400,8),(1071,433800000,4),(1071,449614800,8),(1071,465346800,9),(1071,481071600,10),(1071,496796400,9),(1071,512521200,10),(1071,528246000,9),(1071,543970800,10),(1071,559695600,9),(1071,575420400,10),(1071,591145200,9),(1071,606870000,11),(1071,622598400,12),(1071,638323200,11),(1071,654652800,12),(1071,670377600,11),(1071,686102400,12),(1071,701827200,11),(1071,717552000,12),(1071,733276800,11),(1071,749001600,12),(1071,764726400,11),(1071,780451200,12),(1071,796176000,11),(1071,811900800,12),(1071,828230400,11),(1071,843955200,12),(1071,853797600,3),(1071,859683600,13),(1071,877827600,14),(1071,891133200,13),(1071,909277200,14),(1071,922582800,13),(1071,941331600,14),(1071,951775200,3),(1071,985482000,13),(1071,1004230800,14),(1071,1017536400,13),(1071,1035680400,14),(1071,1048986000,13),(1071,1067130000,14),(1071,1080435600,13),(1071,1099184400,14),(1071,1111885200,13),(1071,1130634000,14),(1071,1143334800,13),(1071,1162083600,14),(1071,1174784400,13),(1071,1193533200,14),(1071,1206838800,13),(1071,1224982800,14),(1071,1238288400,13),(1071,1256432400,14),(1071,1269738000,13),(1071,1288486800,14),(1071,1301187600,13),(1071,1319936400,14),(1071,1332637200,13),(1071,1351386000,14),(1071,1364691600,13),(1071,1382835600,14),(1071,1396141200,13),(1071,1414285200,14),(1071,1427590800,13),(1071,1445734800,14),(1071,1459040400,13),(1071,1477789200,14),(1071,1490490000,13),(1071,1509238800,14),(1071,1521939600,13),(1071,1540688400,14),(1071,1553994000,13),(1071,1572138000,14),(1071,1585443600,13),(1071,1603587600,14),(1071,1616893200,13),(1071,1635642000,14),(1071,1648342800,13),(1071,1667091600,14),(1071,1679792400,13),(1071,1698541200,14),(1071,1711846800,13),(1071,1729990800,14),(1071,1743296400,13),(1071,1761440400,14),(1071,1774746000,13),(1071,1792890000,14),(1071,1806195600,13),(1071,1824944400,14),(1071,1837645200,13),(1071,1856394000,14),(1071,1869094800,13),(1071,1887843600,14),(1071,1901149200,13),(1071,1919293200,14),(1071,1932598800,13),(1071,1950742800,14),(1071,1964048400,13),(1071,1982797200,14),(1071,1995498000,13),(1071,2014246800,14),(1071,2026947600,13),(1071,2045696400,14),(1071,2058397200,13),(1071,2077146000,14),(1071,2090451600,13),(1071,2108595600,14),(1071,2121901200,13),(1071,2140045200,14),(1072,-2147483648,2),(1072,-1690765200,1),(1072,-1680487200,2),(1072,-1664758800,1),(1072,-1648951200,2),(1072,-1635123600,1),(1072,-1616896800,2),(1072,-1604278800,1),(1072,-1585533600,2),(1072,-1571014800,1),(1072,-1555293600,2),(1072,-932432400,1),(1072,-857257200,3),(1072,-844556400,4),(1072,-830311200,1),(1072,-828226800,3),(1072,-812502000,4),(1072,-807156000,1),(1072,-798073200,3),(1072,-781052400,1),(1072,-766717200,2),(1072,-750898800,4),(1072,-733359600,3),(1072,-719456400,4),(1072,-701917200,3),(1072,-689209200,4),(1072,-670460400,3),(1072,-114051600,4),(1072,-103168800,2),(1072,-81997200,4),(1072,-71715600,3),(1072,-50547600,4),(1072,-40266000,3),(1072,-18493200,4),(1072,-8211600,3),(1072,12956400,4),(1072,23238000,3),(1072,43801200,4),(1072,54687600,3),(1072,75855600,4),(1072,86742000,3),(1072,107910000,4),(1072,118191600,3),(1072,138754800,4),(1072,149641200,3),(1072,170809200,4),(1072,181090800,3),(1072,202258800,4),(1072,212540400,3),(1072,233103600,4),(1072,243990000,3),(1072,265158000,4),(1072,276044400,3),(1072,296607600,4),(1072,307494000,3),(1072,315529200,2),(1072,323830800,5),(1072,338950800,6),(1072,354675600,5),(1072,370400400,6),(1072,386125200,5),(1072,401850000,6),(1072,417574800,5),(1072,433299600,6),(1072,449024400,5),(1072,465354000,6),(1072,481078800,5),(1072,496803600,6),(1072,512528400,5),(1072,528253200,6),(1072,543978000,5),(1072,559702800,6),(1072,575427600,5),(1072,591152400,6),(1072,606877200,5),(1072,622602000,6),(1072,638326800,5),(1072,654656400,6),(1072,670381200,5),(1072,686106000,6),(1072,701830800,5),(1072,717555600,6),(1072,733280400,5),(1072,749005200,6),(1072,764730000,5),(1072,780454800,6),(1072,796179600,5),(1072,811904400,6),(1072,828234000,5),(1072,846378000,6),(1072,859683600,5),(1072,877827600,6),(1072,891133200,5),(1072,909277200,6),(1072,922582800,5),(1072,941331600,6),(1072,954032400,5),(1072,972781200,6),(1072,985482000,5),(1072,1004230800,6),(1072,1017536400,5),(1072,1035680400,6),(1072,1048986000,5),(1072,1067130000,6),(1072,1080435600,5),(1072,1099184400,6),(1072,1111885200,5),(1072,1130634000,6),(1072,1143334800,5),(1072,1162083600,6),(1072,1174784400,5),(1072,1193533200,6),(1072,1206838800,5),(1072,1224982800,6),(1072,1238288400,5),(1072,1256432400,6),(1072,1269738000,5),(1072,1288486800,6),(1072,1301187600,5),(1072,1319936400,6),(1072,1332637200,5),(1072,1351386000,6),(1072,1364691600,5),(1072,1382835600,6),(1072,1396141200,5),(1072,1414285200,6),(1072,1427590800,5),(1072,1445734800,6),(1072,1459040400,5),(1072,1477789200,6),(1072,1490490000,5),(1072,1509238800,6),(1072,1521939600,5),(1072,1540688400,6),(1072,1553994000,5),(1072,1572138000,6),(1072,1585443600,5),(1072,1603587600,6),(1072,1616893200,5),(1072,1635642000,6),(1072,1648342800,5),(1072,1667091600,6),(1072,1679792400,5),(1072,1698541200,6),(1072,1711846800,5),(1072,1729990800,6),(1072,1743296400,5),(1072,1761440400,6),(1072,1774746000,5),(1072,1792890000,6),(1072,1806195600,5),(1072,1824944400,6),(1072,1837645200,5),(1072,1856394000,6),(1072,1869094800,5),(1072,1887843600,6),(1072,1901149200,5),(1072,1919293200,6),(1072,1932598800,5),(1072,1950742800,6),(1072,1964048400,5),(1072,1982797200,6),(1072,1995498000,5),(1072,2014246800,6),(1072,2026947600,5),(1072,2045696400,6),(1072,2058397200,5),(1072,2077146000,6),(1072,2090451600,5),(1072,2108595600,6),(1072,2121901200,5),(1072,2140045200,6),(1073,-2147483648,0),(1073,-1593820800,1),(1073,-1247540400,2),(1073,354916800,3),(1073,370724400,2),(1073,386452800,3),(1073,402260400,2),(1073,417988800,3),(1073,433796400,2),(1073,449611200,3),(1073,465343200,4),(1073,481068000,5),(1073,496792800,4),(1073,512517600,5),(1073,528242400,4),(1073,543967200,5),(1073,559692000,4),(1073,575416800,5),(1073,591141600,4),(1073,606866400,6),(1073,622594800,7),(1073,638319600,6),(1073,654649200,7),(1073,670374000,8),(1073,686102400,7),(1073,687916800,2),(1073,701820000,5),(1073,717544800,4),(1073,733269600,5),(1073,748994400,4),(1073,764719200,5),(1073,780444000,4),(1073,796168800,5),(1073,811893600,4),(1073,828223200,5),(1073,846367200,4),(1073,859672800,5),(1073,877816800,4),(1073,891122400,5),(1073,909266400,4),(1073,922572000,5),(1073,941320800,4),(1073,954021600,5),(1073,972770400,4),(1073,985471200,5),(1073,1004220000,4),(1073,1017525600,5),(1073,1035669600,4),(1073,1048975200,5),(1073,1067119200,4),(1073,1080424800,5),(1073,1099173600,4),(1073,1111874400,5),(1073,1130623200,4),(1073,1143324000,5),(1073,1162072800,4),(1073,1174773600,5),(1073,1193522400,4),(1073,1206828000,5),(1073,1224972000,4),(1073,1238277600,5),(1073,1256421600,4),(1073,1269727200,6),(1073,1288479600,7),(1073,1301180400,4),(1073,2147483647,4),(1074,-2147483648,2),(1074,-1690765200,1),(1074,-1680487200,2),(1074,-1664758800,1),(1074,-1648951200,2),(1074,-1635123600,1),(1074,-1616896800,2),(1074,-1604278800,1),(1074,-1585533600,2),(1074,-1571014800,1),(1074,-1555293600,2),(1074,-932432400,1),(1074,-857257200,3),(1074,-844556400,4),(1074,-830311200,1),(1074,-828226800,3),(1074,-812502000,4),(1074,-807156000,1),(1074,-798073200,3),(1074,-781052400,1),(1074,-766717200,2),(1074,-750898800,4),(1074,-733359600,3),(1074,-719456400,4),(1074,-701917200,3),(1074,-689209200,4),(1074,-670460400,3),(1074,-114051600,4),(1074,-103168800,2),(1074,-81997200,4),(1074,-71715600,3),(1074,-50547600,4),(1074,-40266000,3),(1074,-18493200,4),(1074,-8211600,3),(1074,12956400,4),(1074,23238000,3),(1074,43801200,4),(1074,54687600,3),(1074,75855600,4),(1074,86742000,3),(1074,107910000,4),(1074,118191600,3),(1074,138754800,4),(1074,149641200,3),(1074,170809200,4),(1074,181090800,3),(1074,202258800,4),(1074,212540400,3),(1074,233103600,4),(1074,243990000,3),(1074,265158000,4),(1074,276044400,3),(1074,296607600,4),(1074,307494000,3),(1074,315529200,2),(1074,323830800,5),(1074,338950800,6),(1074,354675600,5),(1074,370400400,6),(1074,386125200,5),(1074,401850000,6),(1074,417574800,5),(1074,433299600,6),(1074,449024400,5),(1074,465354000,6),(1074,481078800,5),(1074,496803600,6),(1074,512528400,5),(1074,528253200,6),(1074,543978000,5),(1074,559702800,6),(1074,575427600,5),(1074,591152400,6),(1074,606877200,5),(1074,622602000,6),(1074,638326800,5),(1074,654656400,6),(1074,670381200,5),(1074,686106000,6),(1074,701830800,5),(1074,717555600,6),(1074,733280400,5),(1074,749005200,6),(1074,764730000,5),(1074,780454800,6),(1074,796179600,5),(1074,811904400,6),(1074,828234000,5),(1074,846378000,6),(1074,859683600,5),(1074,877827600,6),(1074,891133200,5),(1074,909277200,6),(1074,922582800,5),(1074,941331600,6),(1074,954032400,5),(1074,972781200,6),(1074,985482000,5),(1074,1004230800,6),(1074,1017536400,5),(1074,1035680400,6),(1074,1048986000,5),(1074,1067130000,6),(1074,1080435600,5),(1074,1099184400,6),(1074,1111885200,5),(1074,1130634000,6),(1074,1143334800,5),(1074,1162083600,6),(1074,1174784400,5),(1074,1193533200,6),(1074,1206838800,5),(1074,1224982800,6),(1074,1238288400,5),(1074,1256432400,6),(1074,1269738000,5),(1074,1288486800,6),(1074,1301187600,5),(1074,1319936400,6),(1074,1332637200,5),(1074,1351386000,6),(1074,1364691600,5),(1074,1382835600,6),(1074,1396141200,5),(1074,1414285200,6),(1074,1427590800,5),(1074,1445734800,6),(1074,1459040400,5),(1074,1477789200,6),(1074,1490490000,5),(1074,1509238800,6),(1074,1521939600,5),(1074,1540688400,6),(1074,1553994000,5),(1074,1572138000,6),(1074,1585443600,5),(1074,1603587600,6),(1074,1616893200,5),(1074,1635642000,6),(1074,1648342800,5),(1074,1667091600,6),(1074,1679792400,5),(1074,1698541200,6),(1074,1711846800,5),(1074,1729990800,6),(1074,1743296400,5),(1074,1761440400,6),(1074,1774746000,5),(1074,1792890000,6),(1074,1806195600,5),(1074,1824944400,6),(1074,1837645200,5),(1074,1856394000,6),(1074,1869094800,5),(1074,1887843600,6),(1074,1901149200,5),(1074,1919293200,6),(1074,1932598800,5),(1074,1950742800,6),(1074,1964048400,5),(1074,1982797200,6),(1074,1995498000,5),(1074,2014246800,6),(1074,2026947600,5),(1074,2045696400,6),(1074,2058397200,5),(1074,2077146000,6),(1074,2090451600,5),(1074,2108595600,6),(1074,2121901200,5),(1074,2140045200,6),(1075,-2147483648,1),(1075,-905824800,4),(1075,-857257200,2),(1075,-844556400,3),(1075,-828226800,2),(1075,-812502000,3),(1075,-796777200,2),(1075,-788922000,1),(1075,-777942000,3),(1075,-766623600,2),(1075,407199600,1),(1075,417574800,5),(1075,433299600,6),(1075,449024400,5),(1075,465354000,6),(1075,481078800,5),(1075,496803600,6),(1075,512528400,5),(1075,528253200,6),(1075,543978000,5),(1075,559702800,6),(1075,575427600,5),(1075,591152400,6),(1075,606877200,5),(1075,622602000,6),(1075,638326800,5),(1075,654656400,6),(1075,670381200,5),(1075,686106000,6),(1075,701830800,5),(1075,717555600,6),(1075,733280400,5),(1075,749005200,6),(1075,764730000,5),(1075,780454800,6),(1075,796179600,5),(1075,811904400,6),(1075,828234000,5),(1075,846378000,6),(1075,859683600,5),(1075,877827600,6),(1075,891133200,5),(1075,909277200,6),(1075,922582800,5),(1075,941331600,6),(1075,954032400,5),(1075,972781200,6),(1075,985482000,5),(1075,1004230800,6),(1075,1017536400,5),(1075,1035680400,6),(1075,1048986000,5),(1075,1067130000,6),(1075,1080435600,5),(1075,1099184400,6),(1075,1111885200,5),(1075,1130634000,6),(1075,1143334800,5),(1075,1162083600,6),(1075,1174784400,5),(1075,1193533200,6),(1075,1206838800,5),(1075,1224982800,6),(1075,1238288400,5),(1075,1256432400,6),(1075,1269738000,5),(1075,1288486800,6),(1075,1301187600,5),(1075,1319936400,6),(1075,1332637200,5),(1075,1351386000,6),(1075,1364691600,5),(1075,1382835600,6),(1075,1396141200,5),(1075,1414285200,6),(1075,1427590800,5),(1075,1445734800,6),(1075,1459040400,5),(1075,1477789200,6),(1075,1490490000,5),(1075,1509238800,6),(1075,1521939600,5),(1075,1540688400,6),(1075,1553994000,5),(1075,1572138000,6),(1075,1585443600,5),(1075,1603587600,6),(1075,1616893200,5),(1075,1635642000,6),(1075,1648342800,5),(1075,1667091600,6),(1075,1679792400,5),(1075,1698541200,6),(1075,1711846800,5),(1075,1729990800,6),(1075,1743296400,5),(1075,1761440400,6),(1075,1774746000,5),(1075,1792890000,6),(1075,1806195600,5),(1075,1824944400,6),(1075,1837645200,5),(1075,1856394000,6),(1075,1869094800,5),(1075,1887843600,6),(1075,1901149200,5),(1075,1919293200,6),(1075,1932598800,5),(1075,1950742800,6),(1075,1964048400,5),(1075,1982797200,6),(1075,1995498000,5),(1075,2014246800,6),(1075,2026947600,5),(1075,2045696400,6),(1075,2058397200,5),(1075,2077146000,6),(1075,2090451600,5),(1075,2108595600,6),(1075,2121901200,5),(1075,2140045200,6),(1076,-2147483648,0),(1076,-1593820800,1),(1076,-1247540400,3),(1076,354916800,2),(1076,370724400,3),(1076,386452800,2),(1076,402260400,3),(1076,417988800,2),(1076,433796400,3),(1076,449611200,2),(1076,465343200,4),(1076,481068000,5),(1076,496792800,4),(1076,512517600,5),(1076,528242400,4),(1076,543967200,5),(1076,559692000,4),(1076,575416800,6),(1076,591145200,7),(1076,606870000,6),(1076,622594800,7),(1076,638319600,6),(1076,654649200,7),(1076,670374000,4),(1076,701820000,6),(1076,717548400,7),(1076,733273200,6),(1076,748998000,7),(1076,764722800,6),(1076,780447600,7),(1076,796172400,6),(1076,811897200,7),(1076,828226800,6),(1076,846370800,7),(1076,859676400,6),(1076,877820400,7),(1076,891126000,6),(1076,909270000,7),(1076,922575600,6),(1076,941324400,7),(1076,954025200,6),(1076,972774000,7),(1076,985474800,6),(1076,1004223600,7),(1076,1017529200,6),(1076,1035673200,7),(1076,1048978800,6),(1076,1067122800,7),(1076,1080428400,6),(1076,1099177200,7),(1076,1111878000,6),(1076,1130626800,7),(1076,1143327600,6),(1076,1162076400,7),(1076,1174777200,6),(1076,1193526000,7),(1076,1206831600,6),(1076,1224975600,7),(1076,1238281200,6),(1076,1256425200,7),(1076,1269730800,6),(1076,1288479600,7),(1076,1301180400,4),(1076,1414274400,7),(1076,1480806000,4),(1076,2147483647,4),(1077,-2147483648,1),(1077,-1441160160,2),(1077,-1247536800,3),(1077,-888894000,6),(1077,-857257200,4),(1077,-844556400,5),(1077,-828226800,4),(1077,-812502000,5),(1077,-811648800,3),(1077,354920400,7),(1077,370728000,3),(1077,386456400,7),(1077,402264000,3),(1077,417992400,7),(1077,433800000,3),(1077,449614800,7),(1077,465346800,8),(1077,481071600,9),(1077,496796400,8),(1077,512521200,9),(1077,528246000,8),(1077,543970800,9),(1077,559695600,8),(1077,575420400,9),(1077,591145200,8),(1077,606870000,9),(1077,622594800,8),(1077,631141200,3),(1077,646786800,2),(1077,701820000,10),(1077,717541200,2),(1077,733269600,10),(1077,748990800,2),(1077,764719200,10),(1077,767739600,7),(1077,780436800,3),(1077,796165200,7),(1077,811886400,3),(1077,828219600,9),(1077,846374400,8),(1077,852066000,3),(1077,859683600,11),(1077,877827600,12),(1077,891133200,11),(1077,909277200,12),(1077,922582800,11),(1077,941331600,12),(1077,954032400,11),(1077,972781200,12),(1077,985482000,11),(1077,1004230800,12),(1077,1017536400,11),(1077,1035680400,12),(1077,1048986000,11),(1077,1067130000,12),(1077,1080435600,11),(1077,1099184400,12),(1077,1111885200,11),(1077,1130634000,12),(1077,1143334800,11),(1077,1162083600,12),(1077,1174784400,11),(1077,1193533200,12),(1077,1206838800,11),(1077,1224982800,12),(1077,1238288400,11),(1077,1256432400,12),(1077,1269738000,11),(1077,1288486800,12),(1077,1301187600,11),(1077,1319936400,12),(1077,1332637200,11),(1077,1351386000,12),(1077,1364691600,11),(1077,1382835600,12),(1077,1396137600,13),(1077,1414274400,8),(1078,-2147483648,1),(1078,-905824800,4),(1078,-857257200,2),(1078,-844556400,3),(1078,-828226800,2),(1078,-812502000,3),(1078,-796777200,2),(1078,-788922000,1),(1078,-777942000,3),(1078,-766623600,2),(1078,407199600,1),(1078,417574800,5),(1078,433299600,6),(1078,449024400,5),(1078,465354000,6),(1078,481078800,5),(1078,496803600,6),(1078,512528400,5),(1078,528253200,6),(1078,543978000,5),(1078,559702800,6),(1078,575427600,5),(1078,591152400,6),(1078,606877200,5),(1078,622602000,6),(1078,638326800,5),(1078,654656400,6),(1078,670381200,5),(1078,686106000,6),(1078,701830800,5),(1078,717555600,6),(1078,733280400,5),(1078,749005200,6),(1078,764730000,5),(1078,780454800,6),(1078,796179600,5),(1078,811904400,6),(1078,828234000,5),(1078,846378000,6),(1078,859683600,5),(1078,877827600,6),(1078,891133200,5),(1078,909277200,6),(1078,922582800,5),(1078,941331600,6),(1078,954032400,5),(1078,972781200,6),(1078,985482000,5),(1078,1004230800,6),(1078,1017536400,5),(1078,1035680400,6),(1078,1048986000,5),(1078,1067130000,6),(1078,1080435600,5),(1078,1099184400,6),(1078,1111885200,5),(1078,1130634000,6),(1078,1143334800,5),(1078,1162083600,6),(1078,1174784400,5),(1078,1193533200,6),(1078,1206838800,5),(1078,1224982800,6),(1078,1238288400,5),(1078,1256432400,6),(1078,1269738000,5),(1078,1288486800,6),(1078,1301187600,5),(1078,1319936400,6),(1078,1332637200,5),(1078,1351386000,6),(1078,1364691600,5),(1078,1382835600,6),(1078,1396141200,5),(1078,1414285200,6),(1078,1427590800,5),(1078,1445734800,6),(1078,1459040400,5),(1078,1477789200,6),(1078,1490490000,5),(1078,1509238800,6),(1078,1521939600,5),(1078,1540688400,6),(1078,1553994000,5),(1078,1572138000,6),(1078,1585443600,5),(1078,1603587600,6),(1078,1616893200,5),(1078,1635642000,6),(1078,1648342800,5),(1078,1667091600,6),(1078,1679792400,5),(1078,1698541200,6),(1078,1711846800,5),(1078,1729990800,6),(1078,1743296400,5),(1078,1761440400,6),(1078,1774746000,5),(1078,1792890000,6),(1078,1806195600,5),(1078,1824944400,6),(1078,1837645200,5),(1078,1856394000,6),(1078,1869094800,5),(1078,1887843600,6),(1078,1901149200,5),(1078,1919293200,6),(1078,1932598800,5),(1078,1950742800,6),(1078,1964048400,5),(1078,1982797200,6),(1078,1995498000,5),(1078,2014246800,6),(1078,2026947600,5),(1078,2045696400,6),(1078,2058397200,5),(1078,2077146000,6),(1078,2090451600,5),(1078,2108595600,6),(1078,2121901200,5),(1078,2140045200,6),(1079,-2147483648,1),(1079,-857257200,2),(1079,-844556400,3),(1079,-828226800,2),(1079,-812502000,3),(1079,-796777200,2),(1079,-788922000,4),(1079,-781048800,1),(1079,291762000,5),(1079,307576800,1),(1079,323816400,5),(1079,339026400,1),(1079,355266000,5),(1079,370393200,1),(1079,386715600,5),(1079,401846400,6),(1079,417571200,7),(1079,433296000,6),(1079,449020800,7),(1079,465350400,6),(1079,481075200,7),(1079,496800000,6),(1079,512524800,7),(1079,528249600,6),(1079,543974400,7),(1079,559699200,6),(1079,575424000,7),(1079,591148800,6),(1079,606873600,7),(1079,622598400,6),(1079,638323200,7),(1079,654652800,6),(1079,662680800,1),(1079,670370400,5),(1079,686091600,1),(1079,701820000,5),(1079,717541200,1),(1079,733269600,5),(1079,748990800,1),(1079,764719200,5),(1079,780440400,1),(1079,796168800,5),(1079,811890000,1),(1079,828223200,5),(1079,846363600,1),(1079,859683600,8),(1079,877827600,9),(1079,891133200,8),(1079,909277200,9),(1079,922582800,8),(1079,941331600,9),(1079,954032400,8),(1079,972781200,9),(1079,985482000,8),(1079,1004230800,9),(1079,1017536400,8),(1079,1035680400,9),(1079,1048986000,8),(1079,1067130000,9),(1079,1080435600,8),(1079,1099184400,9),(1079,1111885200,8),(1079,1130634000,9),(1079,1143334800,8),(1079,1162083600,9),(1079,1174784400,8),(1079,1193533200,9),(1079,1206838800,8),(1079,1224982800,9),(1079,1238288400,8),(1079,1256432400,9),(1079,1269738000,8),(1079,1288486800,9),(1079,1301187600,8),(1079,1319936400,9),(1079,1332637200,8),(1079,1351386000,9),(1079,1364691600,8),(1079,1382835600,9),(1079,1396141200,8),(1079,1414285200,9),(1079,1427590800,8),(1079,1445734800,9),(1079,1459040400,8),(1079,1477789200,9),(1079,1490490000,8),(1079,1509238800,9),(1079,1521939600,8),(1079,1540688400,9),(1079,1553994000,8),(1079,1572138000,9),(1079,1585443600,8),(1079,1603587600,9),(1079,1616893200,8),(1079,1635642000,9),(1079,1648342800,8),(1079,1667091600,9),(1079,1679792400,8),(1079,1698541200,9),(1079,1711846800,8),(1079,1729990800,9),(1079,1743296400,8),(1079,1761440400,9),(1079,1774746000,8),(1079,1792890000,9),(1079,1806195600,8),(1079,1824944400,9),(1079,1837645200,8),(1079,1856394000,9),(1079,1869094800,8),(1079,1887843600,9),(1079,1901149200,8),(1079,1919293200,9),(1079,1932598800,8),(1079,1950742800,9),(1079,1964048400,8),(1079,1982797200,9),(1079,1995498000,8),(1079,2014246800,9),(1079,2026947600,8),(1079,2045696400,9),(1079,2058397200,8),(1079,2077146000,9),(1079,2090451600,8),(1079,2108595600,9),(1079,2121901200,8),(1079,2140045200,9),(1080,-2147483648,1),(1080,-1692496800,2),(1080,-1680483600,1),(1080,323830800,3),(1080,338950800,4),(1080,354675600,3),(1080,370400400,4),(1080,386125200,3),(1080,401850000,4),(1080,417574800,3),(1080,433299600,4),(1080,449024400,3),(1080,465354000,4),(1080,481078800,3),(1080,496803600,4),(1080,512528400,3),(1080,528253200,4),(1080,543978000,3),(1080,559702800,4),(1080,575427600,3),(1080,591152400,4),(1080,606877200,3),(1080,622602000,4),(1080,638326800,3),(1080,654656400,4),(1080,670381200,3),(1080,686106000,4),(1080,701830800,3),(1080,717555600,4),(1080,733280400,3),(1080,749005200,4),(1080,764730000,3),(1080,780454800,4),(1080,796179600,3),(1080,811904400,4),(1080,828234000,3),(1080,846378000,4),(1080,859683600,3),(1080,877827600,4),(1080,891133200,3),(1080,909277200,4),(1080,922582800,3),(1080,941331600,4),(1080,954032400,3),(1080,972781200,4),(1080,985482000,3),(1080,1004230800,4),(1080,1017536400,3),(1080,1035680400,4),(1080,1048986000,3),(1080,1067130000,4),(1080,1080435600,3),(1080,1099184400,4),(1080,1111885200,3),(1080,1130634000,4),(1080,1143334800,3),(1080,1162083600,4),(1080,1174784400,3),(1080,1193533200,4),(1080,1206838800,3),(1080,1224982800,4),(1080,1238288400,3),(1080,1256432400,4),(1080,1269738000,3),(1080,1288486800,4),(1080,1301187600,3),(1080,1319936400,4),(1080,1332637200,3),(1080,1351386000,4),(1080,1364691600,3),(1080,1382835600,4),(1080,1396141200,3),(1080,1414285200,4),(1080,1427590800,3),(1080,1445734800,4),(1080,1459040400,3),(1080,1477789200,4),(1080,1490490000,3),(1080,1509238800,4),(1080,1521939600,3),(1080,1540688400,4),(1080,1553994000,3),(1080,1572138000,4),(1080,1585443600,3),(1080,1603587600,4),(1080,1616893200,3),(1080,1635642000,4),(1080,1648342800,3),(1080,1667091600,4),(1080,1679792400,3),(1080,1698541200,4),(1080,1711846800,3),(1080,1729990800,4),(1080,1743296400,3),(1080,1761440400,4),(1080,1774746000,3),(1080,1792890000,4),(1080,1806195600,3),(1080,1824944400,4),(1080,1837645200,3),(1080,1856394000,4),(1080,1869094800,3),(1080,1887843600,4),(1080,1901149200,3),(1080,1919293200,4),(1080,1932598800,3),(1080,1950742800,4),(1080,1964048400,3),(1080,1982797200,4),(1080,1995498000,3),(1080,2014246800,4),(1080,2026947600,3),(1080,2045696400,4),(1080,2058397200,3),(1080,2077146000,4),(1080,2090451600,3),(1080,2108595600,4),(1080,2121901200,3),(1080,2140045200,4),(1081,-2147483648,1),(1081,-1638322740,4),(1081,-1632006000,2),(1081,-1618700400,3),(1081,-1593824400,1),(1081,-1535938740,5),(1081,-927943200,6),(1081,-892954800,7),(1081,-857257200,3),(1081,-844556400,2),(1081,-828226800,3),(1081,-812502000,2),(1081,-797652000,6),(1081,354920400,8),(1081,370728000,6),(1081,386456400,8),(1081,402264000,6),(1081,417992400,8),(1081,433800000,6),(1081,449614800,8),(1081,465346800,9),(1081,481071600,10),(1081,496796400,9),(1081,512521200,10),(1081,528246000,9),(1081,543970800,10),(1081,559695600,9),(1081,575420400,10),(1081,591145200,9),(1081,606870000,11),(1081,622598400,12),(1081,638323200,11),(1081,654652800,12),(1081,670377600,11),(1081,686102400,12),(1081,701827200,11),(1081,717552000,12),(1081,733276800,11),(1081,749001600,12),(1081,764726400,11),(1081,780451200,12),(1081,796176000,11),(1081,811900800,12),(1081,828230400,11),(1081,846374400,12),(1081,859680000,11),(1081,877824000,12),(1081,891129600,11),(1081,906411600,15),(1081,909277200,13),(1081,922582800,14),(1081,941331600,5),(1081,1017536400,14),(1081,1035680400,13),(1081,1048986000,14),(1081,1067130000,13),(1081,1080435600,14),(1081,1099184400,13),(1081,1111885200,14),(1081,1130634000,13),(1081,1143334800,14),(1081,1162083600,13),(1081,1174784400,14),(1081,1193533200,13),(1081,1206838800,14),(1081,1224982800,13),(1081,1238288400,14),(1081,1256432400,13),(1081,1269738000,14),(1081,1288486800,13),(1081,1301187600,14),(1081,1319936400,13),(1081,1332637200,14),(1081,1351386000,13),(1081,1364691600,14),(1081,1382835600,13),(1081,1396141200,14),(1081,1414285200,13),(1081,1427590800,14),(1081,1445734800,13),(1081,1459040400,14),(1081,1477789200,13),(1081,1490490000,14),(1081,1509238800,13),(1081,1521939600,14),(1081,1540688400,13),(1081,1553994000,14),(1081,1572138000,13),(1081,1585443600,14),(1081,1603587600,13),(1081,1616893200,14),(1081,1635642000,13),(1081,1648342800,14),(1081,1667091600,13),(1081,1679792400,14),(1081,1698541200,13),(1081,1711846800,14),(1081,1729990800,13),(1081,1743296400,14),(1081,1761440400,13),(1081,1774746000,14),(1081,1792890000,13),(1081,1806195600,14),(1081,1824944400,13),(1081,1837645200,14),(1081,1856394000,13),(1081,1869094800,14),(1081,1887843600,13),(1081,1901149200,14),(1081,1919293200,13),(1081,1932598800,14),(1081,1950742800,13),(1081,1964048400,14),(1081,1982797200,13),(1081,1995498000,14),(1081,2014246800,13),(1081,2026947600,14),(1081,2045696400,13),(1081,2058397200,14),(1081,2077146000,13),(1081,2090451600,14),(1081,2108595600,13),(1081,2121901200,14),(1081,2140045200,13),(1082,-2147483648,0),(1082,-1767230360,1),(1082,-932346000,2),(1082,-857257200,1),(1082,-844556400,2),(1082,-843519600,1),(1082,136854000,2),(1082,149896800,1),(1082,168130800,2),(1082,181432800,1),(1082,199839600,2),(1082,213141600,1),(1082,231894000,2),(1082,244591200,1),(1082,263257200,2),(1082,276040800,1),(1082,294706800,2),(1082,307490400,1),(1082,326156400,2),(1082,339458400,1),(1082,357087600,2),(1082,370389600,1),(1082,389142000,2),(1082,402444000,1),(1082,419468400,2),(1082,433807200,1),(1082,449622000,2),(1082,465354000,3),(1082,481078800,4),(1082,496803600,3),(1082,512528400,4),(1082,528253200,3),(1082,543978000,4),(1082,559702800,3),(1082,575427600,4),(1082,591152400,3),(1082,606877200,4),(1082,622602000,3),(1082,638326800,4),(1082,654656400,3),(1082,670381200,4),(1082,686106000,3),(1082,701830800,4),(1082,717555600,3),(1082,733280400,4),(1082,749005200,3),(1082,764730000,4),(1082,780454800,3),(1082,796179600,4),(1082,811904400,3),(1082,828234000,4),(1082,846378000,3),(1082,859683600,4),(1082,877827600,3),(1082,891133200,4),(1082,909277200,3),(1082,922582800,4),(1082,941331600,3),(1082,954032400,4),(1082,972781200,3),(1082,985482000,4),(1082,1004230800,3),(1082,1017536400,4),(1082,1035680400,3),(1082,1048986000,4),(1082,1067130000,3),(1082,1080435600,4),(1082,1099184400,3),(1082,1111885200,4),(1082,1130634000,3),(1082,1143334800,4),(1082,1162083600,3),(1082,1174784400,4),(1082,1193533200,3),(1082,1206838800,4),(1082,1224982800,3),(1082,1238288400,4),(1082,1256432400,3),(1082,1269738000,4),(1082,1288486800,3),(1082,1301187600,4),(1082,1319936400,3),(1082,1332637200,4),(1082,1351386000,3),(1082,1364691600,4),(1082,1382835600,3),(1082,1396141200,4),(1082,1414285200,3),(1082,1427590800,4),(1082,1445734800,3),(1082,1459040400,4),(1082,1477789200,3),(1082,1490490000,4),(1082,1509238800,3),(1082,1521939600,4),(1082,1540688400,3),(1082,1553994000,4),(1082,1572138000,3),(1082,1585443600,4),(1082,1603587600,3),(1082,1616893200,4),(1082,1635642000,3),(1082,1648342800,4),(1082,1667091600,3),(1082,1679792400,4),(1082,1698541200,3),(1082,1711846800,4),(1082,1729990800,3),(1082,1743296400,4),(1082,1761440400,3),(1082,1774746000,4),(1082,1792890000,3),(1082,1806195600,4),(1082,1824944400,3),(1082,1837645200,4),(1082,1856394000,3),(1082,1869094800,4),(1082,1887843600,3),(1082,1901149200,4),(1082,1919293200,3),(1082,1932598800,4),(1082,1950742800,3),(1082,1964048400,4),(1082,1982797200,3),(1082,1995498000,4),(1082,2014246800,3),(1082,2026947600,4),(1082,2045696400,3),(1082,2058397200,4),(1082,2077146000,3),(1082,2090451600,4),(1082,2108595600,3),(1082,2121901200,4),(1082,2140045200,3),(1083,-2147483648,1),(1083,-1637114100,2),(1083,-1213148664,5),(1083,-1187056800,3),(1083,-1175479200,4),(1083,-1159754400,3),(1083,-1144029600,4),(1083,-1127700000,3),(1083,-1111975200,4),(1083,-1096250400,3),(1083,-1080525600,4),(1083,-1064800800,3),(1083,-1049076000,4),(1083,-1033351200,3),(1083,-1017626400,4),(1083,-1001901600,3),(1083,-986176800,4),(1083,-970452000,3),(1083,-954727200,4),(1083,-927165600,6),(1083,-898138800,9),(1083,-857257200,7),(1083,-844556400,8),(1083,-828226800,7),(1083,-812502000,8),(1083,-800157600,11),(1083,354920400,10),(1083,370728000,11),(1083,386456400,10),(1083,402264000,11),(1083,417992400,10),(1083,433800000,11),(1083,449614800,10),(1083,465346800,12),(1083,481071600,13),(1083,496796400,12),(1083,512521200,13),(1083,528246000,12),(1083,543970800,13),(1083,559695600,12),(1083,575420400,13),(1083,591145200,12),(1083,606870000,13),(1083,622594800,12),(1083,638319600,13),(1083,641944800,6),(1083,654652800,4),(1083,670377600,3),(1083,686102400,4),(1083,694216800,5),(1083,701820000,6),(1083,717541200,5),(1083,733269600,6),(1083,748990800,5),(1083,764719200,6),(1083,780440400,5),(1083,796168800,6),(1083,811890000,5),(1083,828223200,6),(1083,846363600,5),(1083,859680000,6),(1083,877824000,5),(1083,891129600,6),(1083,909273600,5),(1083,922579200,6),(1083,941328000,5),(1083,954028800,6),(1083,972777600,5),(1083,985478400,6),(1083,1004227200,5),(1083,1017532800,6),(1083,1035676800,5),(1083,1048982400,6),(1083,1067126400,5),(1083,1080432000,6),(1083,1099180800,5),(1083,1111881600,6),(1083,1130630400,5),(1083,1143331200,6),(1083,1162080000,5),(1083,1174780800,6),(1083,1193529600,5),(1083,1206835200,6),(1083,1224979200,5),(1083,1238284800,6),(1083,1256428800,5),(1083,1269734400,6),(1083,1288483200,5),(1083,1301184000,6),(1083,1319932800,5),(1083,1332633600,6),(1083,1351382400,5),(1083,1364688000,6),(1083,1382832000,5),(1083,1396137600,6),(1083,1414281600,5),(1083,1427587200,6),(1083,1445731200,5),(1083,1459036800,6),(1083,1477785600,5),(1083,1490486400,6),(1083,1509235200,5),(1083,1521936000,6),(1083,1540684800,5),(1083,1553990400,6),(1083,1572134400,5),(1083,1585440000,6),(1083,1603584000,5),(1083,1616889600,6),(1083,1635638400,5),(1083,1648339200,6),(1083,1667088000,5),(1083,1679788800,6),(1083,1698537600,5),(1083,1711843200,6),(1083,1729987200,5),(1083,1743292800,6),(1083,1761436800,5),(1083,1774742400,6),(1083,1792886400,5),(1083,1806192000,6),(1083,1824940800,5),(1083,1837641600,6),(1083,1856390400,5),(1083,1869091200,6),(1083,1887840000,5),(1083,1901145600,6),(1083,1919289600,5),(1083,1932595200,6),(1083,1950739200,5),(1083,1964044800,6),(1083,1982793600,5),(1083,1995494400,6),(1083,2014243200,5),(1083,2026944000,6),(1083,2045692800,5),(1083,2058393600,6),(1083,2077142400,5),(1083,2090448000,6),(1083,2108592000,5),(1083,2121897600,6),(1083,2140041600,5),(1084,-2147483648,0),(1084,-1593820800,1),(1084,-1247540400,3),(1084,354916800,2),(1084,370724400,3),(1084,386452800,2),(1084,402260400,3),(1084,417988800,2),(1084,433796400,3),(1084,449611200,2),(1084,465343200,4),(1084,481068000,5),(1084,496792800,4),(1084,512517600,5),(1084,528242400,4),(1084,543967200,5),(1084,559692000,4),(1084,575416800,5),(1084,591141600,4),(1084,606866400,6),(1084,622594800,7),(1084,638319600,6),(1084,654649200,7),(1084,670374000,8),(1084,686102400,9),(1084,695779200,7),(1084,701823600,6),(1084,717548400,7),(1084,733273200,6),(1084,748998000,7),(1084,764722800,6),(1084,780447600,7),(1084,796172400,6),(1084,811897200,7),(1084,828226800,6),(1084,846370800,7),(1084,859676400,6),(1084,877820400,7),(1084,891126000,6),(1084,909270000,7),(1084,922575600,6),(1084,941324400,7),(1084,954025200,6),(1084,972774000,7),(1084,985474800,6),(1084,1004223600,7),(1084,1017529200,6),(1084,1035673200,7),(1084,1048978800,6),(1084,1067122800,7),(1084,1080428400,6),(1084,1099177200,7),(1084,1111878000,6),(1084,1130626800,7),(1084,1143327600,6),(1084,1162076400,7),(1084,1174777200,6),(1084,1193526000,7),(1084,1206831600,6),(1084,1224975600,7),(1084,1238281200,6),(1084,1256425200,7),(1084,1269730800,6),(1084,1288479600,7),(1084,1301180400,4),(1084,1414274400,7),(1084,1459033200,4),(1084,2147483647,4),(1085,-2147483648,1),(1085,-938905200,2),(1085,-857257200,3),(1085,-844556400,2),(1085,-828226800,3),(1085,-812502000,2),(1085,-796874400,4),(1085,-794714400,1),(1085,-773456400,6),(1085,354920400,5),(1085,370728000,6),(1085,386456400,5),(1085,402264000,6),(1085,417992400,5),(1085,433800000,6),(1085,449614800,5),(1085,465346800,7),(1085,481071600,8),(1085,496796400,7),(1085,512521200,8),(1085,528246000,7),(1085,543970800,8),(1085,559695600,7),(1085,575420400,8),(1085,591145200,7),(1085,606870000,8),(1085,622594800,7),(1085,631141200,6),(1085,646786800,1),(1085,670384800,9),(1085,701820000,10),(1085,717541200,9),(1085,733269600,10),(1085,748990800,9),(1085,764719200,10),(1085,780440400,9),(1085,796179600,11),(1085,811904400,12),(1085,828234000,11),(1085,846378000,12),(1085,859683600,11),(1085,877827600,12),(1085,891133200,11),(1085,909277200,12),(1085,922582800,11),(1085,941331600,12),(1085,954032400,11),(1085,972781200,12),(1085,985482000,11),(1085,1004230800,12),(1085,1017536400,11),(1085,1035680400,12),(1085,1048986000,11),(1085,1067130000,12),(1085,1080435600,11),(1085,1099184400,12),(1085,1111885200,11),(1085,1130634000,12),(1085,1143334800,11),(1085,1162083600,12),(1085,1174784400,11),(1085,1193533200,12),(1085,1206838800,11),(1085,1224982800,12),(1085,1238288400,11),(1085,1256432400,12),(1085,1269738000,11),(1085,1288486800,12),(1085,1301187600,11),(1085,1319936400,12),(1085,1332637200,11),(1085,1351386000,12),(1085,1364691600,11),(1085,1382835600,12),(1085,1396141200,11),(1085,1414285200,12),(1085,1427590800,11),(1085,1445734800,12),(1085,1459040400,11),(1085,1477789200,12),(1085,1490490000,11),(1085,1509238800,12),(1085,1521939600,11),(1085,1540688400,12),(1085,1553994000,11),(1085,1572138000,12),(1085,1585443600,11),(1085,1603587600,12),(1085,1616893200,11),(1085,1635642000,12),(1085,1648342800,11),(1085,1667091600,12),(1085,1679792400,11),(1085,1698541200,12),(1085,1711846800,11),(1085,1729990800,12),(1085,1743296400,11),(1085,1761440400,12),(1085,1774746000,11),(1085,1792890000,12),(1085,1806195600,11),(1085,1824944400,12),(1085,1837645200,11),(1085,1856394000,12),(1085,1869094800,11),(1085,1887843600,12),(1085,1901149200,11),(1085,1919293200,12),(1085,1932598800,11),(1085,1950742800,12),(1085,1964048400,11),(1085,1982797200,12),(1085,1995498000,11),(1085,2014246800,12),(1085,2026947600,11),(1085,2045696400,12),(1085,2058397200,11),(1085,2077146000,12),(1085,2090451600,11),(1085,2108595600,12),(1085,2121901200,11),(1085,2140045200,12),(1086,-2147483648,2),(1086,-904435200,1),(1086,-891129600,2),(1086,-872985600,1),(1086,-859680000,2),(1086,354675600,3),(1086,370400400,4),(1086,386125200,3),(1086,401850000,4),(1086,417574800,3),(1086,433299600,4),(1086,449024400,3),(1086,465354000,4),(1086,481078800,3),(1086,496803600,4),(1086,512528400,3),(1086,528253200,4),(1086,543978000,3),(1086,559702800,4),(1086,575427600,3),(1086,591152400,4),(1086,606877200,3),(1086,622602000,4),(1086,638326800,3),(1086,654656400,4),(1086,670381200,3),(1086,686106000,4),(1086,701830800,3),(1086,717555600,4),(1086,733280400,3),(1086,749005200,4),(1086,764730000,3),(1086,780454800,4),(1086,796179600,3),(1086,811904400,4),(1086,828234000,3),(1086,846378000,4),(1086,859683600,3),(1086,877827600,4),(1086,891133200,3),(1086,909277200,4),(1086,922582800,3),(1086,941331600,4),(1086,954032400,3),(1086,972781200,4),(1086,985482000,3),(1086,1004230800,4),(1086,1017536400,3),(1086,1035680400,4),(1086,1048986000,3),(1086,1067130000,4),(1086,1080435600,3),(1086,1099184400,4),(1086,1111885200,3),(1086,1130634000,4),(1086,1143334800,3),(1086,1162083600,4),(1086,1174784400,3),(1086,1193533200,4),(1086,1206838800,3),(1086,1224982800,4),(1086,1238288400,3),(1086,1256432400,4),(1086,1269738000,3),(1086,1288486800,4),(1086,1301187600,3),(1086,1319936400,4),(1086,1332637200,3),(1086,1351386000,4),(1086,1364691600,3),(1086,1382835600,4),(1086,1396141200,3),(1086,1414285200,4),(1086,1427590800,3),(1086,1445734800,4),(1086,1459040400,3),(1086,1477789200,4),(1086,1490490000,3),(1086,1509238800,4),(1086,1521939600,3),(1086,1540688400,4),(1086,1553994000,3),(1086,1572138000,4),(1086,1585443600,3),(1086,1603587600,4),(1086,1616893200,3),(1086,1635642000,4),(1086,1648342800,3),(1086,1667091600,4),(1086,1679792400,3),(1086,1698541200,4),(1086,1711846800,3),(1086,1729990800,4),(1086,1743296400,3),(1086,1761440400,4),(1086,1774746000,3),(1086,1792890000,4),(1086,1806195600,3),(1086,1824944400,4),(1086,1837645200,3),(1086,1856394000,4),(1086,1869094800,3),(1086,1887843600,4),(1086,1901149200,3),(1086,1919293200,4),(1086,1932598800,3),(1086,1950742800,4),(1086,1964048400,3),(1086,1982797200,4),(1086,1995498000,3),(1086,2014246800,4),(1086,2026947600,3),(1086,2045696400,4),(1086,2058397200,3),(1086,2077146000,4),(1086,2090451600,3),(1086,2108595600,4),(1086,2121901200,3),(1086,2140045200,4),(1087,-2147483648,2),(1087,-1690765200,1),(1087,-1680487200,2),(1087,-1664758800,1),(1087,-1648951200,2),(1087,-1635123600,1),(1087,-1616896800,2),(1087,-1604278800,1),(1087,-1585533600,2),(1087,-1571014800,1),(1087,-1555293600,2),(1087,-932432400,1),(1087,-857257200,3),(1087,-844556400,4),(1087,-830311200,1),(1087,-828226800,3),(1087,-812502000,4),(1087,-807156000,1),(1087,-798073200,3),(1087,-781052400,1),(1087,-766717200,2),(1087,-750898800,4),(1087,-733359600,3),(1087,-719456400,4),(1087,-701917200,3),(1087,-689209200,4),(1087,-670460400,3),(1087,-114051600,4),(1087,-103168800,2),(1087,-81997200,4),(1087,-71715600,3),(1087,-50547600,4),(1087,-40266000,3),(1087,-18493200,4),(1087,-8211600,3),(1087,12956400,4),(1087,23238000,3),(1087,43801200,4),(1087,54687600,3),(1087,75855600,4),(1087,86742000,3),(1087,107910000,4),(1087,118191600,3),(1087,138754800,4),(1087,149641200,3),(1087,170809200,4),(1087,181090800,3),(1087,202258800,4),(1087,212540400,3),(1087,233103600,4),(1087,243990000,3),(1087,265158000,4),(1087,276044400,3),(1087,296607600,4),(1087,307494000,3),(1087,315529200,2),(1087,323830800,5),(1087,338950800,6),(1087,354675600,5),(1087,370400400,6),(1087,386125200,5),(1087,401850000,6),(1087,417574800,5),(1087,433299600,6),(1087,449024400,5),(1087,465354000,6),(1087,481078800,5),(1087,496803600,6),(1087,512528400,5),(1087,528253200,6),(1087,543978000,5),(1087,559702800,6),(1087,575427600,5),(1087,591152400,6),(1087,606877200,5),(1087,622602000,6),(1087,638326800,5),(1087,654656400,6),(1087,670381200,5),(1087,686106000,6),(1087,701830800,5),(1087,717555600,6),(1087,733280400,5),(1087,749005200,6),(1087,764730000,5),(1087,780454800,6),(1087,796179600,5),(1087,811904400,6),(1087,828234000,5),(1087,846378000,6),(1087,859683600,5),(1087,877827600,6),(1087,891133200,5),(1087,909277200,6),(1087,922582800,5),(1087,941331600,6),(1087,954032400,5),(1087,972781200,6),(1087,985482000,5),(1087,1004230800,6),(1087,1017536400,5),(1087,1035680400,6),(1087,1048986000,5),(1087,1067130000,6),(1087,1080435600,5),(1087,1099184400,6),(1087,1111885200,5),(1087,1130634000,6),(1087,1143334800,5),(1087,1162083600,6),(1087,1174784400,5),(1087,1193533200,6),(1087,1206838800,5),(1087,1224982800,6),(1087,1238288400,5),(1087,1256432400,6),(1087,1269738000,5),(1087,1288486800,6),(1087,1301187600,5),(1087,1319936400,6),(1087,1332637200,5),(1087,1351386000,6),(1087,1364691600,5),(1087,1382835600,6),(1087,1396141200,5),(1087,1414285200,6),(1087,1427590800,5),(1087,1445734800,6),(1087,1459040400,5),(1087,1477789200,6),(1087,1490490000,5),(1087,1509238800,6),(1087,1521939600,5),(1087,1540688400,6),(1087,1553994000,5),(1087,1572138000,6),(1087,1585443600,5),(1087,1603587600,6),(1087,1616893200,5),(1087,1635642000,6),(1087,1648342800,5),(1087,1667091600,6),(1087,1679792400,5),(1087,1698541200,6),(1087,1711846800,5),(1087,1729990800,6),(1087,1743296400,5),(1087,1761440400,6),(1087,1774746000,5),(1087,1792890000,6),(1087,1806195600,5),(1087,1824944400,6),(1087,1837645200,5),(1087,1856394000,6),(1087,1869094800,5),(1087,1887843600,6),(1087,1901149200,5),(1087,1919293200,6),(1087,1932598800,5),(1087,1950742800,6),(1087,1964048400,5),(1087,1982797200,6),(1087,1995498000,5),(1087,2014246800,6),(1087,2026947600,5),(1087,2045696400,6),(1087,2058397200,5),(1087,2077146000,6),(1087,2090451600,5),(1087,2108595600,6),(1087,2121901200,5),(1087,2140045200,6),(1088,-2147483648,2),(1088,-1693706400,1),(1088,-1680483600,2),(1088,-1663455600,3),(1088,-1650150000,4),(1088,-1632006000,3),(1088,-1618700400,4),(1088,-1577926800,2),(1088,-1569711600,3),(1088,-1555801200,4),(1088,-938905200,3),(1088,-857257200,4),(1088,-844556400,3),(1088,-828226800,4),(1088,-812502000,3),(1088,-796777200,4),(1088,-781052400,3),(1088,-780188400,4),(1088,-757386000,2),(1088,-748479600,3),(1088,-733359600,4),(1088,-717634800,3),(1088,-701910000,4),(1088,-684975600,3),(1088,-670460400,4),(1088,323823600,1),(1088,338940000,2),(1088,354675600,5),(1088,370400400,6),(1088,386125200,5),(1088,401850000,6),(1088,417574800,5),(1088,433299600,6),(1088,449024400,5),(1088,465354000,6),(1088,481078800,5),(1088,496803600,6),(1088,512528400,5),(1088,528253200,6),(1088,543978000,5),(1088,559702800,6),(1088,575427600,5),(1088,591152400,6),(1088,606877200,5),(1088,622602000,6),(1088,638326800,5),(1088,654656400,6),(1088,670381200,5),(1088,686106000,6),(1088,701830800,5),(1088,717555600,6),(1088,733280400,5),(1088,749005200,6),(1088,764730000,5),(1088,780454800,6),(1088,796179600,5),(1088,811904400,6),(1088,828234000,5),(1088,846378000,6),(1088,859683600,5),(1088,877827600,6),(1088,891133200,5),(1088,909277200,6),(1088,922582800,5),(1088,941331600,6),(1088,954032400,5),(1088,972781200,6),(1088,985482000,5),(1088,1004230800,6),(1088,1017536400,5),(1088,1035680400,6),(1088,1048986000,5),(1088,1067130000,6),(1088,1080435600,5),(1088,1099184400,6),(1088,1111885200,5),(1088,1130634000,6),(1088,1143334800,5),(1088,1162083600,6),(1088,1174784400,5),(1088,1193533200,6),(1088,1206838800,5),(1088,1224982800,6),(1088,1238288400,5),(1088,1256432400,6),(1088,1269738000,5),(1088,1288486800,6),(1088,1301187600,5),(1088,1319936400,6),(1088,1332637200,5),(1088,1351386000,6),(1088,1364691600,5),(1088,1382835600,6),(1088,1396141200,5),(1088,1414285200,6),(1088,1427590800,5),(1088,1445734800,6),(1088,1459040400,5),(1088,1477789200,6),(1088,1490490000,5),(1088,1509238800,6),(1088,1521939600,5),(1088,1540688400,6),(1088,1553994000,5),(1088,1572138000,6),(1088,1585443600,5),(1088,1603587600,6),(1088,1616893200,5),(1088,1635642000,6),(1088,1648342800,5),(1088,1667091600,6),(1088,1679792400,5),(1088,1698541200,6),(1088,1711846800,5),(1088,1729990800,6),(1088,1743296400,5),(1088,1761440400,6),(1088,1774746000,5),(1088,1792890000,6),(1088,1806195600,5),(1088,1824944400,6),(1088,1837645200,5),(1088,1856394000,6),(1088,1869094800,5),(1088,1887843600,6),(1088,1901149200,5),(1088,1919293200,6),(1088,1932598800,5),(1088,1950742800,6),(1088,1964048400,5),(1088,1982797200,6),(1088,1995498000,5),(1088,2014246800,6),(1088,2026947600,5),(1088,2045696400,6),(1088,2058397200,5),(1088,2077146000,6),(1088,2090451600,5),(1088,2108595600,6),(1088,2121901200,5),(1088,2140045200,6),(1089,-2147483648,1),(1089,-1672536240,2),(1089,-1585100136,3),(1089,-1561251600,4),(1089,-1553565600,3),(1089,-928198800,5),(1089,-900126000,8),(1089,-857257200,6),(1089,-844556400,7),(1089,-828226800,6),(1089,-812502000,7),(1089,-802144800,5),(1089,354920400,9),(1089,370728000,5),(1089,386456400,9),(1089,402264000,5),(1089,417992400,9),(1089,433800000,5),(1089,449614800,9),(1089,465346800,10),(1089,481071600,11),(1089,496796400,10),(1089,512521200,11),(1089,528246000,10),(1089,543970800,11),(1089,559695600,10),(1089,575420400,11),(1089,591145200,10),(1089,606870000,12),(1089,622598400,13),(1089,638323200,12),(1089,654652800,13),(1089,670377600,12),(1089,686102400,13),(1089,701827200,12),(1089,717552000,13),(1089,733276800,12),(1089,749001600,13),(1089,764726400,12),(1089,780451200,13),(1089,796176000,12),(1089,811900800,13),(1089,828230400,12),(1089,846374400,13),(1089,859680000,12),(1089,877824000,13),(1089,883605600,4),(1089,891133200,14),(1089,909277200,15),(1089,922582800,14),(1089,941331600,16),(1089,1041372000,4),(1089,1048986000,17),(1089,1067130000,16),(1089,1080435600,17),(1089,1099184400,16),(1089,1111885200,17),(1089,1130634000,16),(1089,1143334800,17),(1089,1162083600,16),(1089,1174784400,17),(1089,1193533200,16),(1089,1206838800,17),(1089,1224982800,16),(1089,1238288400,17),(1089,1256432400,16),(1089,1269738000,17),(1089,1288486800,16),(1089,1301187600,17),(1089,1319936400,16),(1089,1332637200,17),(1089,1351386000,16),(1089,1364691600,17),(1089,1382835600,16),(1089,1396141200,17),(1089,1414285200,16),(1089,1427590800,17),(1089,1445734800,16),(1089,1459040400,17),(1089,1477789200,16),(1089,1490490000,17),(1089,1509238800,16),(1089,1521939600,17),(1089,1540688400,16),(1089,1553994000,17),(1089,1572138000,16),(1089,1585443600,17),(1089,1603587600,16),(1089,1616893200,17),(1089,1635642000,16),(1089,1648342800,17),(1089,1667091600,16),(1089,1679792400,17),(1089,1698541200,16),(1089,1711846800,17),(1089,1729990800,16),(1089,1743296400,17),(1089,1761440400,16),(1089,1774746000,17),(1089,1792890000,16),(1089,1806195600,17),(1089,1824944400,16),(1089,1837645200,17),(1089,1856394000,16),(1089,1869094800,17),(1089,1887843600,16),(1089,1901149200,17),(1089,1919293200,16),(1089,1932598800,17),(1089,1950742800,16),(1089,1964048400,17),(1089,1982797200,16),(1089,1995498000,17),(1089,2014246800,16),(1089,2026947600,17),(1089,2045696400,16),(1089,2058397200,17),(1089,2077146000,16),(1089,2090451600,17),(1089,2108595600,16),(1089,2121901200,17),(1089,2140045200,16),(1090,-2147483648,0),(1090,-1577761060,1),(1090,-1247540400,2),(1090,354916800,3),(1090,370724400,2),(1090,386452800,3),(1090,402260400,2),(1090,417988800,3),(1090,433796400,2),(1090,449611200,3),(1090,465343200,4),(1090,481068000,5),(1090,496792800,4),(1090,512517600,5),(1090,528242400,4),(1090,543967200,5),(1090,559692000,4),(1090,575416800,6),(1090,591145200,7),(1090,606870000,6),(1090,622594800,7),(1090,638319600,6),(1090,654649200,7),(1090,670374000,4),(1090,701820000,6),(1090,717548400,7),(1090,733273200,6),(1090,748998000,7),(1090,764722800,6),(1090,780447600,7),(1090,796172400,6),(1090,811897200,7),(1090,828226800,6),(1090,846370800,7),(1090,859676400,6),(1090,877820400,7),(1090,891126000,6),(1090,909270000,7),(1090,922575600,6),(1090,941324400,7),(1090,954025200,6),(1090,972774000,7),(1090,985474800,6),(1090,1004223600,7),(1090,1017529200,6),(1090,1035673200,7),(1090,1048978800,6),(1090,1067122800,7),(1090,1080428400,6),(1090,1099177200,7),(1090,1111878000,6),(1090,1130626800,7),(1090,1143327600,6),(1090,1162076400,7),(1090,1174777200,6),(1090,1193526000,7),(1090,1206831600,6),(1090,1224975600,7),(1090,1238281200,6),(1090,1256425200,7),(1090,1269730800,6),(1090,1288479600,7),(1090,1301180400,4),(1090,1414274400,7),(1090,1540681200,4),(1090,2147483647,4),(1091,-2147483648,1),(1091,-1717032240,3),(1091,-1693706400,2),(1091,-1680483600,3),(1091,-1663455600,4),(1091,-1650150000,5),(1091,-1632006000,4),(1091,-1618700400,8),(1091,-1600473600,6),(1091,-1587168000,7),(1091,-1501725600,3),(1091,-931734000,2),(1091,-857257200,5),(1091,-844556400,4),(1091,-828226800,5),(1091,-812502000,4),(1091,-796874400,2),(1091,-796608000,3),(1091,-778726800,2),(1091,-762660000,3),(1091,-748486800,4),(1091,-733273200,5),(1091,-715215600,4),(1091,-701910000,5),(1091,-684975600,4),(1091,-670460400,5),(1091,-654130800,4),(1091,-639010800,5),(1091,-397094400,4),(1091,-386812800,5),(1091,-371088000,4),(1091,-355363200,5),(1091,-334195200,4),(1091,-323308800,5),(1091,-307584000,4),(1091,-291859200,5),(1091,-271296000,4),(1091,-260409600,5),(1091,-239846400,4),(1091,-228960000,5),(1091,-208396800,4),(1091,-197510400,5),(1091,-176342400,4),(1091,-166060800,5),(1091,220921200,3),(1091,228873600,4),(1091,243993600,5),(1091,260323200,4),(1091,276048000,5),(1091,291772800,4),(1091,307497600,5),(1091,323827200,4),(1091,338947200,5),(1091,354672000,4),(1091,370396800,5),(1091,386121600,4),(1091,401846400,5),(1091,417571200,4),(1091,433296000,5),(1091,449020800,4),(1091,465350400,5),(1091,481075200,4),(1091,496800000,5),(1091,512524800,4),(1091,528249600,5),(1091,543974400,4),(1091,559699200,5),(1091,567990000,3),(1091,575427600,9),(1091,591152400,10),(1091,606877200,9),(1091,622602000,10),(1091,638326800,9),(1091,654656400,10),(1091,670381200,9),(1091,686106000,10),(1091,701830800,9),(1091,717555600,10),(1091,733280400,9),(1091,749005200,10),(1091,764730000,9),(1091,780454800,10),(1091,796179600,9),(1091,811904400,10),(1091,828234000,9),(1091,846378000,10),(1091,859683600,9),(1091,877827600,10),(1091,891133200,9),(1091,909277200,10),(1091,922582800,9),(1091,941331600,10),(1091,954032400,9),(1091,972781200,10),(1091,985482000,9),(1091,1004230800,10),(1091,1017536400,9),(1091,1035680400,10),(1091,1048986000,9),(1091,1067130000,10),(1091,1080435600,9),(1091,1099184400,10),(1091,1111885200,9),(1091,1130634000,10),(1091,1143334800,9),(1091,1162083600,10),(1091,1174784400,9),(1091,1193533200,10),(1091,1206838800,9),(1091,1224982800,10),(1091,1238288400,9),(1091,1256432400,10),(1091,1269738000,9),(1091,1288486800,10),(1091,1301187600,9),(1091,1319936400,10),(1091,1332637200,9),(1091,1351386000,10),(1091,1364691600,9),(1091,1382835600,10),(1091,1396141200,9),(1091,1414285200,10),(1091,1427590800,9),(1091,1445734800,10),(1091,1459040400,9),(1091,1477789200,10),(1091,1490490000,9),(1091,1509238800,10),(1091,1521939600,9),(1091,1540688400,10),(1091,1553994000,9),(1091,1572138000,10),(1091,1585443600,9),(1091,1603587600,10),(1091,1616893200,9),(1091,1635642000,10),(1091,1648342800,9),(1091,1667091600,10),(1091,1679792400,9),(1091,1698541200,10),(1091,1711846800,9),(1091,1729990800,10),(1091,1743296400,9),(1091,1761440400,10),(1091,1774746000,9),(1091,1792890000,10),(1091,1806195600,9),(1091,1824944400,10),(1091,1837645200,9),(1091,1856394000,10),(1091,1869094800,9),(1091,1887843600,10),(1091,1901149200,9),(1091,1919293200,10),(1091,1932598800,9),(1091,1950742800,10),(1091,1964048400,9),(1091,1982797200,10),(1091,1995498000,9),(1091,2014246800,10),(1091,2026947600,9),(1091,2045696400,10),(1091,2058397200,9),(1091,2077146000,10),(1091,2090451600,9),(1091,2108595600,10),(1091,2121901200,9),(1091,2140045200,10),(1092,-2147483648,1),(1092,-905824800,4),(1092,-857257200,2),(1092,-844556400,3),(1092,-828226800,2),(1092,-812502000,3),(1092,-796777200,2),(1092,-788922000,1),(1092,-777942000,3),(1092,-766623600,2),(1092,407199600,1),(1092,417574800,5),(1092,433299600,6),(1092,449024400,5),(1092,465354000,6),(1092,481078800,5),(1092,496803600,6),(1092,512528400,5),(1092,528253200,6),(1092,543978000,5),(1092,559702800,6),(1092,575427600,5),(1092,591152400,6),(1092,606877200,5),(1092,622602000,6),(1092,638326800,5),(1092,654656400,6),(1092,670381200,5),(1092,686106000,6),(1092,701830800,5),(1092,717555600,6),(1092,733280400,5),(1092,749005200,6),(1092,764730000,5),(1092,780454800,6),(1092,796179600,5),(1092,811904400,6),(1092,828234000,5),(1092,846378000,6),(1092,859683600,5),(1092,877827600,6),(1092,891133200,5),(1092,909277200,6),(1092,922582800,5),(1092,941331600,6),(1092,954032400,5),(1092,972781200,6),(1092,985482000,5),(1092,1004230800,6),(1092,1017536400,5),(1092,1035680400,6),(1092,1048986000,5),(1092,1067130000,6),(1092,1080435600,5),(1092,1099184400,6),(1092,1111885200,5),(1092,1130634000,6),(1092,1143334800,5),(1092,1162083600,6),(1092,1174784400,5),(1092,1193533200,6),(1092,1206838800,5),(1092,1224982800,6),(1092,1238288400,5),(1092,1256432400,6),(1092,1269738000,5),(1092,1288486800,6),(1092,1301187600,5),(1092,1319936400,6),(1092,1332637200,5),(1092,1351386000,6),(1092,1364691600,5),(1092,1382835600,6),(1092,1396141200,5),(1092,1414285200,6),(1092,1427590800,5),(1092,1445734800,6),(1092,1459040400,5),(1092,1477789200,6),(1092,1490490000,5),(1092,1509238800,6),(1092,1521939600,5),(1092,1540688400,6),(1092,1553994000,5),(1092,1572138000,6),(1092,1585443600,5),(1092,1603587600,6),(1092,1616893200,5),(1092,1635642000,6),(1092,1648342800,5),(1092,1667091600,6),(1092,1679792400,5),(1092,1698541200,6),(1092,1711846800,5),(1092,1729990800,6),(1092,1743296400,5),(1092,1761440400,6),(1092,1774746000,5),(1092,1792890000,6),(1092,1806195600,5),(1092,1824944400,6),(1092,1837645200,5),(1092,1856394000,6),(1092,1869094800,5),(1092,1887843600,6),(1092,1901149200,5),(1092,1919293200,6),(1092,1932598800,5),(1092,1950742800,6),(1092,1964048400,5),(1092,1982797200,6),(1092,1995498000,5),(1092,2014246800,6),(1092,2026947600,5),(1092,2045696400,6),(1092,2058397200,5),(1092,2077146000,6),(1092,2090451600,5),(1092,2108595600,6),(1092,2121901200,5),(1092,2140045200,6),(1093,-2147483648,1),(1093,-1441160400,2),(1093,-1247536800,3),(1093,-894769200,6),(1093,-857257200,4),(1093,-844556400,5),(1093,-828226800,4),(1093,-826419600,3),(1093,354920400,7),(1093,370728000,3),(1093,386456400,7),(1093,402264000,3),(1093,417992400,7),(1093,433800000,3),(1093,449614800,7),(1093,465346800,8),(1093,481071600,9),(1093,496796400,8),(1093,512521200,9),(1093,528246000,8),(1093,543970800,9),(1093,559695600,8),(1093,575420400,9),(1093,591145200,8),(1093,606870000,9),(1093,622594800,8),(1093,638319600,9),(1093,654649200,8),(1093,670374000,10),(1093,686091600,2),(1093,701820000,10),(1093,717541200,2),(1093,733269600,10),(1093,748990800,2),(1093,764719200,10),(1093,780440400,2),(1093,796179600,11),(1093,811904400,12),(1093,828234000,11),(1093,846378000,12),(1093,859683600,11),(1093,877827600,12),(1093,891133200,11),(1093,909277200,12),(1093,922582800,11),(1093,941331600,12),(1093,954032400,11),(1093,972781200,12),(1093,985482000,11),(1093,1004230800,12),(1093,1017536400,11),(1093,1035680400,12),(1093,1048986000,11),(1093,1067130000,12),(1093,1080435600,11),(1093,1099184400,12),(1093,1111885200,11),(1093,1130634000,12),(1093,1143334800,11),(1093,1162083600,12),(1093,1174784400,11),(1093,1193533200,12),(1093,1206838800,11),(1093,1224982800,12),(1093,1238288400,11),(1093,1256432400,12),(1093,1269738000,11),(1093,1288486800,12),(1093,1301187600,11),(1093,1319936400,12),(1093,1332637200,11),(1093,1351386000,12),(1093,1364691600,11),(1093,1382835600,12),(1093,1396141200,11),(1093,1414285200,12),(1093,1427590800,11),(1093,1445734800,12),(1093,1459040400,11),(1093,1477789200,12),(1093,1490490000,11),(1093,1509238800,12),(1093,1521939600,11),(1093,1540688400,12),(1093,1553994000,11),(1093,1572138000,12),(1093,1585443600,11),(1093,1603587600,12),(1093,1616893200,11),(1093,1635642000,12),(1093,1648342800,11),(1093,1667091600,12),(1093,1679792400,11),(1093,1698541200,12),(1093,1711846800,11),(1093,1729990800,12),(1093,1743296400,11),(1093,1761440400,12),(1093,1774746000,11),(1093,1792890000,12),(1093,1806195600,11),(1093,1824944400,12),(1093,1837645200,11),(1093,1856394000,12),(1093,1869094800,11),(1093,1887843600,12),(1093,1901149200,11),(1093,1919293200,12),(1093,1932598800,11),(1093,1950742800,12),(1093,1964048400,11),(1093,1982797200,12),(1093,1995498000,11),(1093,2014246800,12),(1093,2026947600,11),(1093,2045696400,12),(1093,2058397200,11),(1093,2077146000,12),(1093,2090451600,11),(1093,2108595600,12),(1093,2121901200,11),(1093,2140045200,12),(1094,-2147483648,2),(1094,-904435200,1),(1094,-891129600,2),(1094,-872985600,1),(1094,-859680000,2),(1094,354675600,3),(1094,370400400,4),(1094,386125200,3),(1094,401850000,4),(1094,417574800,3),(1094,433299600,4),(1094,449024400,3),(1094,465354000,4),(1094,481078800,3),(1094,496803600,4),(1094,512528400,3),(1094,528253200,4),(1094,543978000,3),(1094,559702800,4),(1094,575427600,3),(1094,591152400,4),(1094,606877200,3),(1094,622602000,4),(1094,638326800,3),(1094,654656400,4),(1094,670381200,3),(1094,686106000,4),(1094,701830800,3),(1094,717555600,4),(1094,733280400,3),(1094,749005200,4),(1094,764730000,3),(1094,780454800,4),(1094,796179600,3),(1094,811904400,4),(1094,828234000,3),(1094,846378000,4),(1094,859683600,3),(1094,877827600,4),(1094,891133200,3),(1094,909277200,4),(1094,922582800,3),(1094,941331600,4),(1094,954032400,3),(1094,972781200,4),(1094,985482000,3),(1094,1004230800,4),(1094,1017536400,3),(1094,1035680400,4),(1094,1048986000,3),(1094,1067130000,4),(1094,1080435600,3),(1094,1099184400,4),(1094,1111885200,3),(1094,1130634000,4),(1094,1143334800,3),(1094,1162083600,4),(1094,1174784400,3),(1094,1193533200,4),(1094,1206838800,3),(1094,1224982800,4),(1094,1238288400,3),(1094,1256432400,4),(1094,1269738000,3),(1094,1288486800,4),(1094,1301187600,3),(1094,1319936400,4),(1094,1332637200,3),(1094,1351386000,4),(1094,1364691600,3),(1094,1382835600,4),(1094,1396141200,3),(1094,1414285200,4),(1094,1427590800,3),(1094,1445734800,4),(1094,1459040400,3),(1094,1477789200,4),(1094,1490490000,3),(1094,1509238800,4),(1094,1521939600,3),(1094,1540688400,4),(1094,1553994000,3),(1094,1572138000,4),(1094,1585443600,3),(1094,1603587600,4),(1094,1616893200,3),(1094,1635642000,4),(1094,1648342800,3),(1094,1667091600,4),(1094,1679792400,3),(1094,1698541200,4),(1094,1711846800,3),(1094,1729990800,4),(1094,1743296400,3),(1094,1761440400,4),(1094,1774746000,3),(1094,1792890000,4),(1094,1806195600,3),(1094,1824944400,4),(1094,1837645200,3),(1094,1856394000,4),(1094,1869094800,3),(1094,1887843600,4),(1094,1901149200,3),(1094,1919293200,4),(1094,1932598800,3),(1094,1950742800,4),(1094,1964048400,3),(1094,1982797200,4),(1094,1995498000,3),(1094,2014246800,4),(1094,2026947600,3),(1094,2045696400,4),(1094,2058397200,3),(1094,2077146000,4),(1094,2090451600,3),(1094,2108595600,4),(1094,2121901200,3),(1094,2140045200,4),(1095,-2147483648,2),(1095,-1691964000,1),(1095,-1680472800,2),(1095,-1664143200,1),(1095,-1650146400,2),(1095,-1633903200,1),(1095,-1617487200,2),(1095,-1601848800,1),(1095,-1586037600,2),(1095,-1570399200,1),(1095,-1552168800,2),(1095,-1538344800,1),(1095,-1522533600,2),(1095,-1507500000,1),(1095,-1490565600,2),(1095,-1473631200,1),(1095,-1460930400,2),(1095,-1442786400,1),(1095,-1428876000,2),(1095,-1410732000,1),(1095,-1396216800,2),(1095,-1379282400,1),(1095,-1364767200,2),(1095,-1348437600,1),(1095,-1333317600,2),(1095,-1315778400,1),(1095,-1301263200,2),(1095,-1284328800,1),(1095,-1269813600,2),(1095,-1253484000,1),(1095,-1238364000,2),(1095,-1221429600,1),(1095,-1206914400,2),(1095,-1189980000,1),(1095,-1175464800,2),(1095,-1159135200,1),(1095,-1143410400,2),(1095,-1126476000,1),(1095,-1111960800,2),(1095,-1095631200,1),(1095,-1080511200,2),(1095,-1063576800,1),(1095,-1049061600,2),(1095,-1032127200,1),(1095,-1017612000,2),(1095,-1001282400,1),(1095,-986162400,2),(1095,-969228000,1),(1095,-950479200,2),(1095,-942012000,1),(1095,-904518000,3),(1095,-896050800,1),(1095,-875487600,3),(1095,-864601200,1),(1095,-844038000,3),(1095,-832546800,1),(1095,-812588400,3),(1095,-798073200,1),(1095,-781052400,3),(1095,-772066800,1),(1095,-764805600,2),(1095,-748476000,1),(1095,-733356000,2),(1095,-719445600,1),(1095,-717030000,3),(1095,-706748400,1),(1095,-699487200,2),(1095,-687996000,1),(1095,-668037600,2),(1095,-654732000,1),(1095,-636588000,2),(1095,-622072800,1),(1095,-605743200,2),(1095,-590623200,1),(1095,-574293600,2),(1095,-558568800,1),(1095,-542239200,2),(1095,-527119200,1),(1095,-512604000,2),(1095,-496274400,1),(1095,-481154400,2),(1095,-464220000,1),(1095,-449704800,2),(1095,-432165600,1),(1095,-417650400,2),(1095,-401320800,1),(1095,-386200800,2),(1095,-369266400,1),(1095,-354751200,2),(1095,-337816800,1),(1095,-323301600,2),(1095,-306972000,1),(1095,-291852000,2),(1095,-276732000,1),(1095,-257983200,2),(1095,-245282400,1),(1095,-226533600,2),(1095,-213228000,1),(1095,-195084000,2),(1095,-182383200,1),(1095,-163634400,2),(1095,-150933600,1),(1095,-132184800,2),(1095,-119484000,1),(1095,-100735200,2),(1095,-88034400,1),(1095,-68680800,2),(1095,-59004000,1),(1095,-37242000,4),(1095,57722400,6),(1095,69818400,1),(1095,89172000,2),(1095,101268000,1),(1095,120621600,2),(1095,132717600,1),(1095,152071200,2),(1095,164167200,1),(1095,183520800,2),(1095,196221600,1),(1095,214970400,2),(1095,227671200,1),(1095,246420000,2),(1095,259120800,1),(1095,278474400,2),(1095,290570400,1),(1095,309924000,2),(1095,322020000,1),(1095,341373600,2),(1095,354675600,5),(1095,372819600,6),(1095,386125200,5),(1095,404269200,6),(1095,417574800,5),(1095,435718800,6),(1095,449024400,5),(1095,467773200,6),(1095,481078800,5),(1095,499222800,6),(1095,512528400,5),(1095,530672400,6),(1095,543978000,5),(1095,562122000,6),(1095,575427600,5),(1095,593571600,6),(1095,606877200,5),(1095,625626000,6),(1095,638326800,5),(1095,657075600,6),(1095,670381200,5),(1095,688525200,6),(1095,701830800,5),(1095,719974800,6),(1095,733280400,5),(1095,751424400,6),(1095,764730000,5),(1095,782874000,6),(1095,796179600,5),(1095,814323600,6),(1095,820454400,7),(1095,828234000,5),(1095,846378000,6),(1095,859683600,5),(1095,877827600,6),(1095,891133200,5),(1095,909277200,6),(1095,922582800,5),(1095,941331600,6),(1095,954032400,5),(1095,972781200,6),(1095,985482000,5),(1095,1004230800,6),(1095,1017536400,5),(1095,1035680400,6),(1095,1048986000,5),(1095,1067130000,6),(1095,1080435600,5),(1095,1099184400,6),(1095,1111885200,5),(1095,1130634000,6),(1095,1143334800,5),(1095,1162083600,6),(1095,1174784400,5),(1095,1193533200,6),(1095,1206838800,5),(1095,1224982800,6),(1095,1238288400,5),(1095,1256432400,6),(1095,1269738000,5),(1095,1288486800,6),(1095,1301187600,5),(1095,1319936400,6),(1095,1332637200,5),(1095,1351386000,6),(1095,1364691600,5),(1095,1382835600,6),(1095,1396141200,5),(1095,1414285200,6),(1095,1427590800,5),(1095,1445734800,6),(1095,1459040400,5),(1095,1477789200,6),(1095,1490490000,5),(1095,1509238800,6),(1095,1521939600,5),(1095,1540688400,6),(1095,1553994000,5),(1095,1572138000,6),(1095,1585443600,5),(1095,1603587600,6),(1095,1616893200,5),(1095,1635642000,6),(1095,1648342800,5),(1095,1667091600,6),(1095,1679792400,5),(1095,1698541200,6),(1095,1711846800,5),(1095,1729990800,6),(1095,1743296400,5),(1095,1761440400,6),(1095,1774746000,5),(1095,1792890000,6),(1095,1806195600,5),(1095,1824944400,6),(1095,1837645200,5),(1095,1856394000,6),(1095,1869094800,5),(1095,1887843600,6),(1095,1901149200,5),(1095,1919293200,6),(1095,1932598800,5),(1095,1950742800,6),(1095,1964048400,5),(1095,1982797200,6),(1095,1995498000,5),(1095,2014246800,6),(1095,2026947600,5),(1095,2045696400,6),(1095,2058397200,5),(1095,2077146000,6),(1095,2090451600,5),(1095,2108595600,6),(1095,2121901200,5),(1095,2140045200,6),(1096,-2147483648,2),(1096,-1691964000,1),(1096,-1680472800,2),(1096,-1664143200,1),(1096,-1650146400,2),(1096,-1633903200,1),(1096,-1617487200,2),(1096,-1601848800,1),(1096,-1586037600,2),(1096,-1570399200,1),(1096,-1552168800,2),(1096,-1538344800,1),(1096,-1522533600,2),(1096,-1507500000,1),(1096,-1490565600,2),(1096,-1473631200,1),(1096,-1460930400,2),(1096,-1442786400,1),(1096,-1428876000,2),(1096,-1410732000,1),(1096,-1396216800,2),(1096,-1379282400,1),(1096,-1364767200,2),(1096,-1348437600,1),(1096,-1333317600,2),(1096,-1315778400,1),(1096,-1301263200,2),(1096,-1284328800,1),(1096,-1269813600,2),(1096,-1253484000,1),(1096,-1238364000,2),(1096,-1221429600,1),(1096,-1206914400,2),(1096,-1189980000,1),(1096,-1175464800,2),(1096,-1159135200,1),(1096,-1143410400,2),(1096,-1126476000,1),(1096,-1111960800,2),(1096,-1095631200,1),(1096,-1080511200,2),(1096,-1063576800,1),(1096,-1049061600,2),(1096,-1032127200,1),(1096,-1017612000,2),(1096,-1001282400,1),(1096,-986162400,2),(1096,-969228000,1),(1096,-950479200,2),(1096,-942012000,1),(1096,-904518000,3),(1096,-896050800,1),(1096,-875487600,3),(1096,-864601200,1),(1096,-844038000,3),(1096,-832546800,1),(1096,-812588400,3),(1096,-798073200,1),(1096,-781052400,3),(1096,-772066800,1),(1096,-764805600,2),(1096,-748476000,1),(1096,-733356000,2),(1096,-719445600,1),(1096,-717030000,3),(1096,-706748400,1),(1096,-699487200,2),(1096,-687996000,1),(1096,-668037600,2),(1096,-654732000,1),(1096,-636588000,2),(1096,-622072800,1),(1096,-605743200,2),(1096,-590623200,1),(1096,-574293600,2),(1096,-558568800,1),(1096,-542239200,2),(1096,-527119200,1),(1096,-512604000,2),(1096,-496274400,1),(1096,-481154400,2),(1096,-464220000,1),(1096,-449704800,2),(1096,-432165600,1),(1096,-417650400,2),(1096,-401320800,1),(1096,-386200800,2),(1096,-369266400,1),(1096,-354751200,2),(1096,-337816800,1),(1096,-323301600,2),(1096,-306972000,1),(1096,-291852000,2),(1096,-276732000,1),(1096,-257983200,2),(1096,-245282400,1),(1096,-226533600,2),(1096,-213228000,1),(1096,-195084000,2),(1096,-182383200,1),(1096,-163634400,2),(1096,-150933600,1),(1096,-132184800,2),(1096,-119484000,1),(1096,-100735200,2),(1096,-88034400,1),(1096,-68680800,2),(1096,-59004000,1),(1096,-37242000,4),(1096,57722400,6),(1096,69818400,1),(1096,89172000,2),(1096,101268000,1),(1096,120621600,2),(1096,132717600,1),(1096,152071200,2),(1096,164167200,1),(1096,183520800,2),(1096,196221600,1),(1096,214970400,2),(1096,227671200,1),(1096,246420000,2),(1096,259120800,1),(1096,278474400,2),(1096,290570400,1),(1096,309924000,2),(1096,322020000,1),(1096,341373600,2),(1096,354675600,5),(1096,372819600,6),(1096,386125200,5),(1096,404269200,6),(1096,417574800,5),(1096,435718800,6),(1096,449024400,5),(1096,467773200,6),(1096,481078800,5),(1096,499222800,6),(1096,512528400,5),(1096,530672400,6),(1096,543978000,5),(1096,562122000,6),(1096,575427600,5),(1096,593571600,6),(1096,606877200,5),(1096,625626000,6),(1096,638326800,5),(1096,657075600,6),(1096,670381200,5),(1096,688525200,6),(1096,701830800,5),(1096,719974800,6),(1096,733280400,5),(1096,751424400,6),(1096,764730000,5),(1096,782874000,6),(1096,796179600,5),(1096,814323600,6),(1096,820454400,7),(1096,828234000,5),(1096,846378000,6),(1096,859683600,5),(1096,877827600,6),(1096,891133200,5),(1096,909277200,6),(1096,922582800,5),(1096,941331600,6),(1096,954032400,5),(1096,972781200,6),(1096,985482000,5),(1096,1004230800,6),(1096,1017536400,5),(1096,1035680400,6),(1096,1048986000,5),(1096,1067130000,6),(1096,1080435600,5),(1096,1099184400,6),(1096,1111885200,5),(1096,1130634000,6),(1096,1143334800,5),(1096,1162083600,6),(1096,1174784400,5),(1096,1193533200,6),(1096,1206838800,5),(1096,1224982800,6),(1096,1238288400,5),(1096,1256432400,6),(1096,1269738000,5),(1096,1288486800,6),(1096,1301187600,5),(1096,1319936400,6),(1096,1332637200,5),(1096,1351386000,6),(1096,1364691600,5),(1096,1382835600,6),(1096,1396141200,5),(1096,1414285200,6),(1096,1427590800,5),(1096,1445734800,6),(1096,1459040400,5),(1096,1477789200,6),(1096,1490490000,5),(1096,1509238800,6),(1096,1521939600,5),(1096,1540688400,6),(1096,1553994000,5),(1096,1572138000,6),(1096,1585443600,5),(1096,1603587600,6),(1096,1616893200,5),(1096,1635642000,6),(1096,1648342800,5),(1096,1667091600,6),(1096,1679792400,5),(1096,1698541200,6),(1096,1711846800,5),(1096,1729990800,6),(1096,1743296400,5),(1096,1761440400,6),(1096,1774746000,5),(1096,1792890000,6),(1096,1806195600,5),(1096,1824944400,6),(1096,1837645200,5),(1096,1856394000,6),(1096,1869094800,5),(1096,1887843600,6),(1096,1901149200,5),(1096,1919293200,6),(1096,1932598800,5),(1096,1950742800,6),(1096,1964048400,5),(1096,1982797200,6),(1096,1995498000,5),(1096,2014246800,6),(1096,2026947600,5),(1096,2045696400,6),(1096,2058397200,5),(1096,2077146000,6),(1096,2090451600,5),(1096,2108595600,6),(1096,2121901200,5),(1096,2140045200,6),(1103,-2147483648,0),(1103,-2056690800,1),(1103,-900909000,2),(1103,-891579600,3),(1103,-884248200,4),(1103,-766659600,1),(1103,-747981000,2),(1103,-728544600,1),(1103,-717049800,2),(1103,-694503000,1),(1103,-683785800,2),(1103,-668064600,1),(1103,-654755400,2),(1103,-636615000,1),(1103,-623305800,2),(1103,-605165400,1),(1103,-591856200,2),(1103,-573715800,1),(1103,-559801800,2),(1103,-541661400,1),(1103,-528352200,2),(1103,-510211800,1),(1103,-498112200,2),(1103,-478762200,1),(1103,-466662600,2),(1103,-446707800,1),(1103,-435213000,2),(1103,-415258200,1),(1103,-403158600,2),(1103,-383808600,1),(1103,-371709000,2),(1103,-352359000,1),(1103,-340259400,2),(1103,-320909400,1),(1103,-308809800,2),(1103,-288855000,1),(1103,-277360200,2),(1103,-257405400,1),(1103,-245910600,2),(1103,-225955800,1),(1103,-213856200,2),(1103,-194506200,1),(1103,-182406600,2),(1103,-163056600,1),(1103,-148537800,2),(1103,-132816600,1),(1103,-117088200,2),(1103,-101367000,1),(1103,-85638600,2),(1103,-69312600,1),(1103,-53584200,2),(1103,-37863000,1),(1103,-22134600,2),(1103,-6413400,1),(1103,9315000,2),(1103,25036200,1),(1103,40764600,2),(1103,56485800,1),(1103,72214200,2),(1103,88540200,1),(1103,104268600,2),(1103,119989800,1),(1103,126041400,2),(1103,151439400,1),(1103,167167800,2),(1103,182889000,1),(1103,198617400,2),(1103,214338600,1),(1103,295385400,2),(1103,309292200,1),(1104,-2147483648,0),(1104,-1956609120,2),(1104,-1668211200,1),(1104,-1647212400,2),(1104,-1636675200,1),(1104,-1613430000,2),(1104,-1605139200,1),(1104,-1581894000,2),(1104,-1539561600,1),(1104,-1531350000,2),(1104,-968025600,1),(1104,-952293600,2),(1104,-942008400,1),(1104,-920239200,3),(1104,-909957600,4),(1104,-888789600,3),(1104,-877903200,4),(1104,-857944800,3),(1104,-846453600,4),(1104,-826495200,3),(1104,-815004000,4),(1104,-795045600,3),(1104,-783554400,4),(1104,-762991200,3),(1104,-752104800,4),(1104,-731541600,3),(1104,-717631200,4),(1104,-700092000,3),(1104,-686181600,4),(1104,-668642400,3),(1104,-654732000,4),(1104,-636588000,3),(1104,-623282400,4),(1104,-605743200,3),(1104,-591832800,4),(1104,-573688800,3),(1104,-559778400,4),(1104,-542239200,3),(1104,-528328800,4),(1104,-510789600,3),(1104,-496879200,4),(1104,-479340000,3),(1104,-465429600,4),(1104,-447890400,3),(1104,-433980000,4),(1104,-415836000,3),(1104,-401925600,4),(1104,-384386400,3),(1104,-370476000,4),(1104,-352936800,3),(1104,-339026400,4),(1104,-321487200,3),(1104,-307576800,4),(1104,-290037600,3),(1104,-276127200,4),(1104,-258588000,3),(1104,-244677600,4),(1104,-226533600,3),(1104,-212623200,4),(1104,-195084000,3),(1104,-181173600,4),(1104,-163634400,3),(1104,-149724000,4),(1104,-132184800,3),(1104,-118274400,4),(1104,-100735200,3),(1104,-86824800,4),(1104,-68680800,3),(1104,-54770400,5),(1105,-2147483648,0),(1105,-1309746436,1),(1105,-1262314800,2),(1105,-946780200,3),(1105,-315629100,1),(1106,-2147483648,0),(1106,-1988167780,1),(1106,820436400,2),(1106,2147483647,2),(1107,-2147483648,1),(1107,2147483647,1),(1108,-2147483648,1),(1108,2147483647,1),(1109,-2147483648,0),(1109,-1309746436,1),(1109,-1262314800,2),(1109,-946780200,3),(1109,-315629100,1),(1110,-2147483648,0),(1110,-631152000,1),(1110,2147483647,1),(1111,-2147483648,0),(1111,-2006653308,1),(1111,2147483647,1),(1112,-2147483648,1),(1112,-315636840,2),(1112,2147483647,2),(1113,-2147483648,0),(1113,-1988164200,2),(1113,403041600,1),(1113,417034800,2),(1113,1224972000,1),(1113,1238274000,2),(1113,2147483647,2),(1114,-2147483648,0),(1114,-1309746436,1),(1114,-1262314800,2),(1114,-946780200,3),(1114,-315629100,1),(1115,-2147483648,0),(1115,-1848886912,1),(1115,2147483647,1),(1116,-2147483648,0),(1116,-1704165944,1),(1116,-757394744,2),(1116,247177800,4),(1116,259272000,3),(1116,277758000,4),(1116,283982400,2),(1116,290809800,5),(1116,306531000,2),(1116,322432200,5),(1116,338499000,2),(1116,673216200,5),(1116,685481400,2),(1116,701209800,5),(1116,717103800,2),(1116,732745800,5),(1116,748639800,2),(1116,764281800,5),(1116,780175800,2),(1116,795817800,5),(1116,811711800,2),(1116,827353800,5),(1116,843247800,2),(1116,858976200,5),(1116,874870200,2),(1116,890512200,5),(1116,906406200,2),(1116,922048200,5),(1116,937942200,2),(1116,953584200,5),(1116,969478200,2),(1116,985206600,5),(1116,1001100600,2),(1116,1016742600,5),(1116,1032636600,2),(1116,1048278600,5),(1116,1064172600,2),(1116,1079814600,5),(1116,1095708600,2),(1116,1111437000,5),(1116,1127331000,2),(1116,1206045000,5),(1116,1221939000,2),(1116,1237667400,5),(1116,1253561400,2),(1116,1269203400,5),(1116,1285097400,2),(1116,1300739400,5),(1116,1316633400,2),(1116,1332275400,5),(1116,1348169400,2),(1116,1363897800,5),(1116,1379791800,2),(1116,1395433800,5),(1116,1411327800,2),(1116,1426969800,5),(1116,1442863800,2),(1116,1458505800,5),(1116,1474399800,2),(1116,1490128200,5),(1116,1506022200,2),(1116,1521664200,5),(1116,1537558200,2),(1116,1553200200,5),(1116,1569094200,2),(1116,1584736200,5),(1116,1600630200,2),(1116,1616358600,5),(1116,1632252600,2),(1116,1647894600,5),(1116,1663788600,2),(1116,1679430600,5),(1116,1695324600,2),(1116,1710966600,5),(1116,1726860600,2),(1116,1742589000,5),(1116,1758483000,2),(1116,1774125000,5),(1116,1790019000,2),(1116,1805661000,5),(1116,1821555000,2),(1116,1837197000,5),(1116,1853091000,2),(1116,1868733000,5),(1116,1884627000,2),(1116,1900355400,5),(1116,1916249400,2),(1116,1931891400,5),(1116,1947785400,2),(1116,1963427400,5),(1116,1979321400,2),(1116,1994963400,5),(1116,2010857400,2),(1116,2026585800,5),(1116,2042479800,2),(1116,2058121800,5),(1116,2074015800,2),(1116,2089657800,5),(1116,2105551800,2),(1116,2121193800,5),(1116,2137087800,2),(1117,-2147483648,1),(1117,-1641003640,3),(1117,-933645600,2),(1117,-857358000,3),(1117,-844300800,2),(1117,-825822000,3),(1117,-812685600,2),(1117,-794199600,3),(1117,-779853600,2),(1117,-762656400,3),(1117,-748310400,2),(1117,-731127600,3),(1117,-681962400,4),(1117,-673243200,2),(1117,-667962000,3),(1117,-652327200,2),(1117,-636426000,3),(1117,-622087200,2),(1117,-608947200,3),(1117,-591847200,2),(1117,-572486400,3),(1117,-558576000,2),(1117,-542851200,3),(1117,-527731200,2),(1117,-514425600,3),(1117,-490845600,2),(1117,-482986800,3),(1117,-459475200,2),(1117,-451537200,3),(1117,-428551200,2),(1117,-418262400,3),(1117,-400032000,2),(1117,-387428400,3),(1117,142380000,2),(1117,150843600,3),(1117,167176800,2),(1117,178664400,3),(1117,334015200,2),(1117,337644000,3),(1117,452556000,2),(1117,462232800,3),(1117,482277600,2),(1117,495579600,3),(1117,516751200,2),(1117,526424400,3),(1117,545436000,2),(1117,558478800,3),(1117,576626400,2),(1117,589323600,3),(1117,609890400,2),(1117,620773200,3),(1117,638316000,2),(1117,651618000,3),(1117,669765600,2),(1117,683672400,3),(1117,701820000,2),(1117,715726800,3),(1117,733701600,2),(1117,747176400,3),(1117,765151200,2),(1117,778021200,3),(1117,796600800,2),(1117,810075600,3),(1117,826840800,2),(1117,842821200,3),(1117,858895200,2),(1117,874184400,3),(1117,890344800,2),(1117,905029200,3),(1117,923011200,2),(1117,936313200,3),(1117,955670400,2),(1117,970783200,3),(1117,986770800,2),(1117,1001282400,3),(1117,1017356400,2),(1117,1033941600,3),(1117,1048806000,2),(1117,1065132000,3),(1117,1081292400,2),(1117,1095804000,3),(1117,1112313600,2),(1117,1128812400,3),(1117,1143763200,2),(1117,1159657200,3),(1117,1175212800,2),(1117,1189897200,3),(1117,1206662400,2),(1117,1223161200,3),(1117,1238112000,2),(1117,1254006000,3),(1117,1269561600,2),(1117,1284246000,3),(1117,1301616000,2),(1117,1317510000,3),(1117,1333065600,2),(1117,1348354800,3),(1117,1364515200,2),(1117,1382828400,3),(1117,1395964800,2),(1117,1414278000,3),(1117,1427414400,2),(1117,1445727600,3),(1117,1458864000,2),(1117,1477782000,3),(1117,1490313600,2),(1117,1509231600,3),(1117,1521763200,2),(1117,1540681200,3),(1117,1553817600,2),(1117,1572130800,3),(1117,1585267200,2),(1117,1603580400,3),(1117,1616716800,2),(1117,1635634800,3),(1117,1648166400,2),(1117,1667084400,3),(1117,1679616000,2),(1117,1698534000,3),(1117,1711670400,2),(1117,1729983600,3),(1117,1743120000,2),(1117,1761433200,3),(1117,1774569600,2),(1117,1792882800,3),(1117,1806019200,2),(1117,1824937200,3),(1117,1837468800,2),(1117,1856386800,3),(1117,1868918400,2),(1117,1887836400,3),(1117,1900972800,2),(1117,1919286000,3),(1117,1932422400,2),(1117,1950735600,3),(1117,1963872000,2),(1117,1982790000,3),(1117,1995321600,2),(1117,2014239600,3),(1117,2026771200,2),(1117,2045689200,3),(1117,2058220800,2),(1117,2077138800,3),(1117,2090275200,2),(1117,2108588400,3),(1117,2121724800,2),(1117,2140038000,3),(1118,-2147483648,1),(1118,-1827687170,2),(1118,126687600,3),(1118,152085600,2),(1118,162370800,3),(1118,183535200,2),(1118,199263600,3),(1118,215589600,2),(1118,230713200,3),(1118,247039200,2),(1118,262767600,3),(1118,278488800,2),(1118,294217200,3),(1118,309938400,2),(1118,325666800,3),(1118,341388000,2),(1118,357116400,3),(1118,372837600,2),(1118,388566000,3),(1118,404892000,2),(1118,420015600,3),(1118,436341600,2),(1119,-2147483648,3),(1119,-683802000,1),(1119,-672310800,2),(1119,-654771600,1),(1119,-640861200,2),(1119,-620298000,1),(1119,-609411600,2),(1119,-588848400,1),(1119,-577962000,2),(1120,-2147483648,1),(1120,-1041418800,2),(1120,-907408800,3),(1120,-817462800,1),(1120,-7988400,4),(1120,745934400,5),(1120,2147483647,5),(1121,-2147483648,0),(1121,-1577926364,2),(1121,-574902000,1),(1121,-568087200,2),(1121,-512175600,1),(1121,-504928800,2),(1121,-449888400,1),(1121,-441856800,2),(1121,-347158800,3),(1121,378684000,2),(1121,386463600,1),(1121,402271200,2),(1121,417999600,1),(1121,433807200,2),(1121,449622000,1),(1121,465429600,2),(1121,481590000,1),(1121,496965600,2),(1121,512953200,1),(1121,528674400,2),(1121,544230000,1),(1121,560037600,2),(1121,575852400,1),(1121,591660000,2),(1121,607388400,1),(1121,623196000,2),(1121,641775600,3),(1121,844034400,2),(1121,860108400,1),(1121,875916000,3),(1121,1352505600,2),(1121,1364515200,1),(1121,1382659200,3),(1122,-1693706400,0),(1122,-1680483600,1),(1122,-1663455600,2),(1122,-1650150000,3),(1122,-1632006000,2),(1122,-1618700400,3),(1122,-938905200,2),(1122,-857257200,3),(1122,-844556400,2),(1122,-828226800,3),(1122,-812502000,2),(1122,-796777200,3),(1122,-781052400,2),(1122,-766623600,3),(1122,228877200,2),(1122,243997200,3),(1122,260326800,2),(1122,276051600,3),(1122,291776400,2),(1122,307501200,3),(1122,323830800,2),(1122,338950800,3),(1122,354675600,2),(1122,370400400,3),(1122,386125200,2),(1122,401850000,3),(1122,417574800,2),(1122,433299600,3),(1122,449024400,2),(1122,465354000,3),(1122,481078800,2),(1122,496803600,3),(1122,512528400,2),(1122,528253200,3),(1122,543978000,2),(1122,559702800,3),(1122,575427600,2),(1122,591152400,3),(1122,606877200,2),(1122,622602000,3),(1122,638326800,2),(1122,654656400,3),(1122,670381200,2),(1122,686106000,3),(1122,701830800,2),(1122,717555600,3),(1122,733280400,2),(1122,749005200,3),(1122,764730000,2),(1122,780454800,3),(1122,796179600,2),(1122,811904400,3),(1122,828234000,2),(1122,846378000,3),(1122,859683600,2),(1122,877827600,3),(1122,891133200,2),(1122,909277200,3),(1122,922582800,2),(1122,941331600,3),(1122,954032400,2),(1122,972781200,3),(1122,985482000,2),(1122,1004230800,3),(1122,1017536400,2),(1122,1035680400,3),(1122,1048986000,2),(1122,1067130000,3),(1122,1080435600,2),(1122,1099184400,3),(1122,1111885200,2),(1122,1130634000,3),(1122,1143334800,2),(1122,1162083600,3),(1122,1174784400,2),(1122,1193533200,3),(1122,1206838800,2),(1122,1224982800,3),(1122,1238288400,2),(1122,1256432400,3),(1122,1269738000,2),(1122,1288486800,3),(1122,1301187600,2),(1122,1319936400,3),(1122,1332637200,2),(1122,1351386000,3),(1122,1364691600,2),(1122,1382835600,3),(1122,1396141200,2),(1122,1414285200,3),(1122,1427590800,2),(1122,1445734800,3),(1122,1459040400,2),(1122,1477789200,3),(1122,1490490000,2),(1122,1509238800,3),(1122,1521939600,2),(1122,1540688400,3),(1122,1553994000,2),(1122,1572138000,3),(1122,1585443600,2),(1122,1603587600,3),(1122,1616893200,2),(1122,1635642000,3),(1122,1648342800,2),(1122,1667091600,3),(1122,1679792400,2),(1122,1698541200,3),(1122,1711846800,2),(1122,1729990800,3),(1122,1743296400,2),(1122,1761440400,3),(1122,1774746000,2),(1122,1792890000,3),(1122,1806195600,2),(1122,1824944400,3),(1122,1837645200,2),(1122,1856394000,3),(1122,1869094800,2),(1122,1887843600,3),(1122,1901149200,2),(1122,1919293200,3),(1122,1932598800,2),(1122,1950742800,3),(1122,1964048400,2),(1122,1982797200,3),(1122,1995498000,2),(1122,2014246800,3),(1122,2026947600,2),(1122,2045696400,3),(1122,2058397200,2),(1122,2077146000,3),(1122,2090451600,2),(1122,2108595600,3),(1122,2121901200,2),(1122,2140045200,3),(1124,-1633273200,0),(1124,-1615132800,1),(1124,-1601823600,0),(1124,-1583683200,1),(1124,-880210800,2),(1124,-769395600,3),(1124,-765388800,1),(1124,-84380400,0),(1124,-68659200,1),(1124,-52930800,0),(1124,-37209600,1),(1124,-21481200,0),(1124,-5760000,1),(1124,9968400,0),(1124,25689600,1),(1124,41418000,0),(1124,57744000,1),(1124,73472400,0),(1124,89193600,1),(1124,104922000,0),(1124,120643200,1),(1124,126694800,0),(1124,152092800,1),(1124,162378000,0),(1124,183542400,1),(1124,199270800,0),(1124,215596800,1),(1124,230720400,0),(1124,247046400,1),(1124,262774800,0),(1124,278496000,1),(1124,294224400,0),(1124,309945600,1),(1124,325674000,0),(1124,341395200,1),(1124,357123600,0),(1124,372844800,1),(1124,388573200,0),(1124,404899200,1),(1124,420022800,0),(1124,436348800,1),(1124,452077200,0),(1124,467798400,1),(1124,483526800,0),(1124,499248000,1),(1124,514976400,0),(1124,530697600,1),(1124,544611600,0),(1124,562147200,1),(1124,576061200,0),(1124,594201600,1),(1124,607510800,0),(1124,625651200,1),(1124,638960400,0),(1124,657100800,1),(1124,671014800,0),(1124,688550400,1),(1124,702464400,0),(1124,720000000,1),(1124,733914000,0),(1124,752054400,1),(1124,765363600,0),(1124,783504000,1),(1124,796813200,0),(1124,814953600,1),(1124,828867600,0),(1124,846403200,1),(1124,860317200,0),(1124,877852800,1),(1124,891766800,0),(1124,909302400,1),(1124,923216400,0),(1124,941356800,1),(1124,954666000,0),(1124,972806400,1),(1124,986115600,0),(1124,1004256000,1),(1124,1018170000,0),(1124,1035705600,1),(1124,1049619600,0),(1124,1067155200,1),(1124,1081069200,0),(1124,1099209600,1),(1124,1112518800,0),(1124,1130659200,1),(1124,1143968400,0),(1124,1162108800,1),(1124,1173603600,0),(1124,1194163200,1),(1124,1205053200,0),(1124,1225612800,1),(1124,1236502800,0),(1124,1257062400,1),(1124,1268557200,0),(1124,1289116800,1),(1124,1300006800,0),(1124,1320566400,1),(1124,1331456400,0),(1124,1352016000,1),(1124,1362906000,0),(1124,1383465600,1),(1124,1394355600,0),(1124,1414915200,1),(1124,1425805200,0),(1124,1446364800,1),(1124,1457859600,0),(1124,1478419200,1),(1124,1489309200,0),(1124,1509868800,1),(1124,1520758800,0),(1124,1541318400,1),(1124,1552208400,0),(1124,1572768000,1),(1124,1583658000,0),(1124,1604217600,1),(1124,1615712400,0),(1124,1636272000,1),(1124,1647162000,0),(1124,1667721600,1),(1124,1678611600,0),(1124,1699171200,1),(1124,1710061200,0),(1124,1730620800,1),(1124,1741510800,0),(1124,1762070400,1),(1124,1772960400,0),(1124,1793520000,1),(1124,1805014800,0),(1124,1825574400,1),(1124,1836464400,0),(1124,1857024000,1),(1124,1867914000,0),(1124,1888473600,1),(1124,1899363600,0),(1124,1919923200,1),(1124,1930813200,0),(1124,1951372800,1),(1124,1962867600,0),(1124,1983427200,1),(1124,1994317200,0),(1124,2014876800,1),(1124,2025766800,0),(1124,2046326400,1),(1124,2057216400,0),(1124,2077776000,1),(1124,2088666000,0),(1124,2109225600,1),(1124,2120115600,0),(1124,2140675200,1),(1125,-2147483648,0),(1125,-1514736000,1),(1125,-1451667600,2),(1125,-1343062800,1),(1125,-1234803600,2),(1125,-1222963200,3),(1125,-1207242000,2),(1125,-873820800,4),(1125,-769395600,5),(1125,-761677200,2),(1125,-686073600,3),(1125,-661539600,2),(1125,-495039600,3),(1125,-481734000,2),(1125,-463590000,3),(1125,-450284400,2),(1125,-431535600,3),(1125,-418230000,2),(1125,-400086000,3),(1125,-386780400,2),(1125,-368636400,3),(1125,-355330800,2),(1125,-337186800,3),(1125,-323881200,2),(1125,-305737200,3),(1125,-292431600,2),(1125,199274400,3),(1125,215600400,2),(1125,230724000,3),(1125,247050000,2),(1125,262778400,3),(1125,278499600,2),(1125,294228000,3),(1125,309949200,2),(1125,325677600,3),(1125,341398800,2),(1125,357127200,3),(1125,372848400,2),(1125,388576800,3),(1125,404902800,2),(1125,420026400,3),(1125,436352400,2),(1125,452080800,3),(1125,467802000,2),(1125,483530400,3),(1125,499251600,2),(1125,514980000,3),(1125,530701200,2),(1125,544615200,3),(1125,562150800,2),(1125,576064800,3),(1125,594205200,2),(1125,607514400,3),(1125,625654800,2),(1125,638964000,3),(1125,657104400,2),(1125,671018400,3),(1125,688554000,2),(1125,702468000,3),(1125,720003600,2),(1125,733917600,3),(1125,752058000,2),(1125,765367200,3),(1125,783507600,2),(1125,796816800,3),(1125,814957200,2),(1125,828871200,3),(1125,846406800,2),(1125,860320800,3),(1125,877856400,2),(1125,891770400,3),(1125,909306000,2),(1125,923220000,3),(1125,941360400,2),(1125,954669600,3),(1125,972810000,2),(1125,986119200,3),(1125,1004259600,2),(1125,1018173600,3),(1125,1035709200,2),(1125,1049623200,3),(1125,1067158800,2),(1125,1081072800,3),(1125,1099213200,2),(1125,1112522400,3),(1125,1130662800,2),(1125,1143972000,3),(1125,1162112400,2),(1125,1175421600,3),(1125,1193562000,2),(1125,1207476000,3),(1125,1225011600,2),(1125,1238925600,3),(1125,1256461200,2),(1125,1268560800,3),(1125,1289120400,2),(1125,1300010400,3),(1125,1320570000,2),(1125,1331460000,3),(1125,1352019600,2),(1125,1362909600,3),(1125,1383469200,2),(1125,1394359200,3),(1125,1414918800,2),(1125,1425808800,3),(1125,1446368400,2),(1125,1457863200,3),(1125,1478422800,2),(1125,1489312800,3),(1125,1509872400,2),(1125,1520762400,3),(1125,1541322000,2),(1125,1552212000,3),(1125,1572771600,2),(1125,1583661600,3),(1125,1604221200,2),(1125,1615716000,3),(1125,1636275600,2),(1125,1647165600,3),(1125,1667725200,2),(1125,1678615200,3),(1125,1699174800,2),(1125,1710064800,3),(1125,1730624400,2),(1125,1741514400,3),(1125,1762074000,2),(1125,1772964000,3),(1125,1793523600,2),(1125,1805018400,3),(1125,1825578000,2),(1125,1836468000,3),(1125,1857027600,2),(1125,1867917600,3),(1125,1888477200,2),(1125,1899367200,3),(1125,1919926800,2),(1125,1930816800,3),(1125,1951376400,2),(1125,1962871200,3),(1125,1983430800,2),(1125,1994320800,3),(1125,2014880400,2),(1125,2025770400,3),(1125,2046330000,2),(1125,2057220000,3),(1125,2077779600,2),(1125,2088669600,3),(1125,2109229200,2),(1125,2120119200,3),(1125,2140678800,2),(1126,-2147483648,0),(1126,-1514739600,1),(1126,-1343066400,2),(1126,-1234807200,1),(1126,-1220292000,2),(1126,-1207159200,1),(1126,-1191344400,2),(1126,-873828000,1),(1126,-661539600,3),(1126,28800,1),(1126,828867600,4),(1126,846403200,1),(1126,860317200,4),(1126,877852800,1),(1126,891766800,4),(1126,909302400,1),(1126,923216400,4),(1126,941356800,1),(1126,954666000,4),(1126,972806400,1),(1126,989139600,4),(1126,1001836800,1),(1126,1018170000,4),(1126,1035705600,1),(1126,1049619600,4),(1126,1067155200,1),(1126,1081069200,4),(1126,1099209600,1),(1126,1112518800,4),(1126,1130659200,1),(1126,1143968400,4),(1126,1162108800,1),(1126,1175418000,4),(1126,1193558400,1),(1126,1207472400,4),(1126,1225008000,1),(1126,1238922000,4),(1126,1256457600,1),(1126,1270371600,4),(1126,1288512000,1),(1126,1301821200,4),(1126,1319961600,1),(1126,1333270800,4),(1126,1351411200,1),(1126,1365325200,4),(1126,1382860800,1),(1126,1396774800,4),(1126,1414310400,1),(1126,1428224400,4),(1126,1445760000,1),(1126,1459674000,4),(1126,1477814400,1),(1126,1491123600,4),(1126,1509264000,1),(1126,1522573200,4),(1126,1540713600,1),(1126,1554627600,4),(1126,1572163200,1),(1126,1586077200,4),(1126,1603612800,1),(1126,1617526800,4),(1126,1635667200,1),(1126,1648976400,4),(1126,1667116800,1),(1126,1680426000,4),(1126,1698566400,1),(1126,1712480400,4),(1126,1730016000,1),(1126,1743930000,4),(1126,1761465600,1),(1126,1775379600,4),(1126,1792915200,1),(1126,1806829200,4),(1126,1824969600,1),(1126,1838278800,4),(1126,1856419200,1),(1126,1869728400,4),(1126,1887868800,1),(1126,1901782800,4),(1126,1919318400,1),(1126,1933232400,4),(1126,1950768000,1),(1126,1964682000,4),(1126,1982822400,1),(1126,1996131600,4),(1126,2014272000,1),(1126,2027581200,4),(1126,2045721600,1),(1126,2059030800,4),(1126,2077171200,1),(1126,2091085200,4),(1126,2108620800,1),(1126,2122534800,4),(1126,2140070400,1),(1127,-2147483648,0),(1127,-1514739600,1),(1127,-1343066400,2),(1127,-1234807200,1),(1127,-1220292000,2),(1127,-1207159200,1),(1127,-1191344400,2),(1127,-975261600,3),(1127,-963169200,2),(1127,-917114400,3),(1127,-907354800,2),(1127,-821901600,4),(1127,-810068400,2),(1127,-627501600,3),(1127,-612990000,2),(1127,828864000,3),(1127,846399600,2),(1127,860313600,3),(1127,877849200,2),(1127,891763200,3),(1127,909298800,2),(1127,923212800,3),(1127,941353200,2),(1127,954662400,3),(1127,972802800,2),(1127,989136000,3),(1127,1001833200,2),(1127,1018166400,3),(1127,1035702000,2),(1127,1049616000,3),(1127,1067151600,2),(1127,1081065600,3),(1127,1099206000,2),(1127,1112515200,3),(1127,1130655600,2),(1127,1143964800,3),(1127,1162105200,2),(1127,1175414400,3),(1127,1193554800,2),(1127,1207468800,3),(1127,1225004400,2),(1127,1238918400,3),(1127,1256454000,2),(1127,1270368000,3),(1127,1288508400,2),(1127,1301817600,3),(1127,1319958000,2),(1127,1333267200,3),(1127,1351407600,2),(1127,1365321600,3),(1127,1382857200,2),(1127,1396771200,3),(1127,1414306800,2),(1127,1428220800,3),(1127,1445756400,2),(1127,1459670400,3),(1127,1477810800,2),(1127,1491120000,3),(1127,1509260400,2),(1127,1522569600,3),(1127,1540710000,2),(1127,1554624000,3),(1127,1572159600,2),(1127,1586073600,3),(1127,1603609200,2),(1127,1617523200,3),(1127,1635663600,2),(1127,1648972800,3),(1127,1667113200,2),(1127,1680422400,3),(1127,1698562800,2),(1127,1712476800,3),(1127,1730012400,2),(1127,1743926400,3),(1127,1761462000,2),(1127,1775376000,3),(1127,1792911600,2),(1127,1806825600,3),(1127,1824966000,2),(1127,1838275200,3),(1127,1856415600,2),(1127,1869724800,3),(1127,1887865200,2),(1127,1901779200,3),(1127,1919314800,2),(1127,1933228800,3),(1127,1950764400,2),(1127,1964678400,3),(1127,1982818800,2),(1127,1996128000,3),(1127,2014268400,2),(1127,2027577600,3),(1127,2045718000,2),(1127,2059027200,3),(1127,2077167600,2),(1127,2091081600,3),(1127,2108617200,2),(1127,2122531200,3),(1127,2140066800,2),(1128,-2147483648,2),(1128,-1330335000,1),(1128,-1320057000,2),(1128,-1300699800,3),(1128,-1287396000,2),(1128,-1269250200,3),(1128,-1255946400,2),(1128,-1237800600,3),(1128,-1224496800,2),(1128,-1206351000,3),(1128,-1192442400,2),(1128,-1174901400,3),(1128,-1160992800,2),(1128,-1143451800,3),(1128,-1125914400,2),(1128,-1112607000,3),(1128,-1094464800,2),(1128,-1081157400,3),(1128,-1063015200,2),(1128,-1049707800,3),(1128,-1031565600,2),(1128,-1018258200,3),(1128,-1000116000,2),(1128,-986808600,3),(1128,-968061600,2),(1128,-955359000,3),(1128,-936612000,2),(1128,-923304600,3),(1128,-757425600,6),(1128,152632800,4),(1128,162309600,5),(1128,183477600,4),(1128,194968800,5),(1128,215532000,4),(1128,226418400,5),(1128,246981600,4),(1128,257868000,5),(1128,278431200,4),(1128,289317600,5),(1128,309880800,4),(1128,320767200,5),(1128,341330400,4),(1128,352216800,5),(1128,372780000,4),(1128,384271200,5),(1128,404834400,4),(1128,415720800,5),(1128,436284000,4),(1128,447170400,5),(1128,467733600,4),(1128,478620000,5),(1128,499183200,4),(1128,510069600,5),(1128,530632800,4),(1128,541519200,5),(1128,562082400,4),(1128,573573600,5),(1128,594136800,4),(1128,605023200,5),(1128,623772000,4),(1128,637682400,5),(1128,655221600,4),(1128,669132000,5),(1128,686671200,4),(1128,700581600,5),(1128,718120800,4),(1128,732636000,5),(1128,749570400,4),(1128,764085600,5),(1128,781020000,4),(1128,795535200,5),(1128,812469600,4),(1128,826984800,5),(1128,844524000,4),(1128,858434400,5),(1128,875973600,4),(1128,889884000,5),(1128,907423200,4),(1128,921938400,5),(1128,938872800,4),(1128,953388000,5),(1128,970322400,4),(1128,984837600,5),(1128,1002376800,4),(1128,1016287200,5),(1128,1033826400,4),(1128,1047736800,5),(1128,1065276000,4),(1128,1079791200,5),(1128,1096725600,4),(1128,1111240800,5),(1128,1128175200,4),(1128,1142690400,5),(1128,1159624800,4),(1128,1174140000,5),(1128,1191074400,4),(1128,1207404000,5),(1128,1222524000,4),(1128,1238853600,5),(1128,1253973600,4),(1128,1270303200,5),(1128,1285423200,4),(1128,1301752800,5),(1128,1316872800,4),(1128,1333202400,5),(1128,1348927200,4),(1128,1365256800,5),(1128,1380376800,4),(1128,1396706400,5),(1128,1411826400,4),(1128,1428156000,5),(1128,1443276000,4),(1128,1459605600,5),(1128,1474725600,4),(1128,1491055200,5),(1128,1506175200,4),(1128,1522504800,5),(1128,1538229600,4),(1128,1554559200,5),(1128,1569679200,4),(1128,1586008800,5),(1128,1601128800,4),(1128,1617458400,5),(1128,1632578400,4),(1128,1648908000,5),(1128,1664028000,4),(1128,1680357600,5),(1128,1695477600,4),(1128,1712412000,5),(1128,1727532000,4),(1128,1743861600,5),(1128,1758981600,4),(1128,1775311200,5),(1128,1790431200,4),(1128,1806760800,5),(1128,1821880800,4),(1128,1838210400,5),(1128,1853330400,4),(1128,1869660000,5),(1128,1885384800,4),(1128,1901714400,5),(1128,1916834400,4),(1128,1933164000,5),(1128,1948284000,4),(1128,1964613600,5),(1128,1979733600,4),(1128,1996063200,5),(1128,2011183200,4),(1128,2027512800,5),(1128,2042632800,4),(1128,2058962400,5),(1128,2074687200,4),(1128,2091016800,5),(1128,2106136800,4),(1128,2122466400,5),(1128,2137586400,4),(1129,-2147483648,1),(1129,-757426500,4),(1129,152632800,2),(1129,162309600,3),(1129,183477600,2),(1129,194968800,3),(1129,215532000,2),(1129,226418400,3),(1129,246981600,2),(1129,257868000,3),(1129,278431200,2),(1129,289317600,3),(1129,309880800,2),(1129,320767200,3),(1129,341330400,2),(1129,352216800,3),(1129,372780000,2),(1129,384271200,3),(1129,404834400,2),(1129,415720800,3),(1129,436284000,2),(1129,447170400,3),(1129,467733600,2),(1129,478620000,3),(1129,499183200,2),(1129,510069600,3),(1129,530632800,2),(1129,541519200,3),(1129,562082400,2),(1129,573573600,3),(1129,594136800,2),(1129,605023200,3),(1129,623772000,2),(1129,637682400,3),(1129,655221600,2),(1129,669132000,3),(1129,686671200,2),(1129,700581600,3),(1129,718120800,2),(1129,732636000,3),(1129,749570400,2),(1129,764085600,3),(1129,781020000,2),(1129,795535200,3),(1129,812469600,2),(1129,826984800,3),(1129,844524000,2),(1129,858434400,3),(1129,875973600,2),(1129,889884000,3),(1129,907423200,2),(1129,921938400,3),(1129,938872800,2),(1129,953388000,3),(1129,970322400,2),(1129,984837600,3),(1129,1002376800,2),(1129,1016287200,3),(1129,1033826400,2),(1129,1047736800,3),(1129,1065276000,2),(1129,1079791200,3),(1129,1096725600,2),(1129,1111240800,3),(1129,1128175200,2),(1129,1142690400,3),(1129,1159624800,2),(1129,1174140000,3),(1129,1191074400,2),(1129,1207404000,3),(1129,1222524000,2),(1129,1238853600,3),(1129,1253973600,2),(1129,1270303200,3),(1129,1285423200,2),(1129,1301752800,3),(1129,1316872800,2),(1129,1333202400,3),(1129,1348927200,2),(1129,1365256800,3),(1129,1380376800,2),(1129,1396706400,3),(1129,1411826400,2),(1129,1428156000,3),(1129,1443276000,2),(1129,1459605600,3),(1129,1474725600,2),(1129,1491055200,3),(1129,1506175200,2),(1129,1522504800,3),(1129,1538229600,2),(1129,1554559200,3),(1129,1569679200,2),(1129,1586008800,3),(1129,1601128800,2),(1129,1617458400,3),(1129,1632578400,2),(1129,1648908000,3),(1129,1664028000,2),(1129,1680357600,3),(1129,1695477600,2),(1129,1712412000,3),(1129,1727532000,2),(1129,1743861600,3),(1129,1758981600,2),(1129,1775311200,3),(1129,1790431200,2),(1129,1806760800,3),(1129,1821880800,2),(1129,1838210400,3),(1129,1853330400,2),(1129,1869660000,3),(1129,1885384800,2),(1129,1901714400,3),(1129,1916834400,2),(1129,1933164000,3),(1129,1948284000,2),(1129,1964613600,3),(1129,1979733600,2),(1129,1996063200,3),(1129,2011183200,2),(1129,2027512800,3),(1129,2042632800,2),(1129,2058962400,3),(1129,2074687200,2),(1129,2091016800,3),(1129,2106136800,2),(1129,2122466400,3),(1129,2137586400,2),(1129,2147483647,2),(1130,-2147483648,2),(1130,-1633273200,1),(1130,-1615132800,2),(1130,-1601823600,1),(1130,-1583683200,2),(1130,-1570374000,1),(1130,-1551628800,2),(1130,-1538924400,1),(1130,-1534089600,2),(1130,-880210800,3),(1130,-769395600,4),(1130,-765388800,2),(1130,-147884400,1),(1130,-131558400,2),(1130,-116434800,1),(1130,-100108800,2),(1130,-84380400,1),(1130,-68659200,2),(1130,-52930800,1),(1130,-37209600,2),(1130,-21481200,1),(1130,-5760000,2),(1130,9968400,1),(1130,25689600,2),(1130,41418000,1),(1130,57744000,2),(1130,73472400,1),(1130,89193600,2),(1130,104922000,1),(1130,120643200,2),(1130,126694800,1),(1130,152092800,2),(1130,162378000,1),(1130,183542400,2),(1130,199270800,1),(1130,215596800,2),(1130,230720400,1),(1130,247046400,2),(1130,262774800,1),(1130,278496000,2),(1130,294224400,1),(1130,309945600,2),(1130,325674000,1),(1130,341395200,2),(1130,357123600,1),(1130,372844800,2),(1130,388573200,1),(1130,404899200,2),(1130,420022800,1),(1130,436348800,2),(1130,452077200,1),(1130,467798400,2),(1130,483526800,1),(1130,499248000,2),(1130,514976400,1),(1130,530697600,2),(1130,544611600,1),(1130,562147200,2),(1130,576061200,1),(1130,594201600,2),(1130,607510800,1),(1130,625651200,2),(1130,638960400,1),(1130,657100800,2),(1130,671014800,1),(1130,688550400,2),(1130,702464400,1),(1130,720000000,2),(1130,733914000,1),(1130,752054400,2),(1130,765363600,1),(1130,783504000,2),(1130,796813200,1),(1130,814953600,2),(1130,828867600,1),(1130,846403200,2),(1130,860317200,1),(1130,877852800,2),(1130,891766800,1),(1130,909302400,2),(1130,923216400,1),(1130,941356800,2),(1130,954666000,1),(1130,972806400,2),(1130,986115600,1),(1130,1004256000,2),(1130,1018170000,1),(1130,1035705600,2),(1130,1049619600,1),(1130,1067155200,2),(1130,1081069200,1),(1130,1099209600,2),(1130,1112518800,1),(1130,1130659200,2),(1130,1143968400,1),(1130,1162108800,2),(1130,1173603600,1),(1130,1194163200,2),(1130,1205053200,1),(1130,1225612800,2),(1130,1236502800,1),(1130,1257062400,2),(1130,1268557200,1),(1130,1289116800,2),(1130,1300006800,1),(1130,1320566400,2),(1130,1331456400,1),(1130,1352016000,2),(1130,1362906000,1),(1130,1383465600,2),(1130,1394355600,1),(1130,1414915200,2),(1130,1425805200,1),(1130,1446364800,2),(1130,1457859600,1),(1130,1478419200,2),(1130,1489309200,1),(1130,1509868800,2),(1130,1520758800,1),(1130,1541318400,2),(1130,1552208400,1),(1130,1572768000,2),(1130,1583658000,1),(1130,1604217600,2),(1130,1615712400,1),(1130,1636272000,2),(1130,1647162000,1),(1130,1667721600,2),(1130,1678611600,1),(1130,1699171200,2),(1130,1710061200,1),(1130,1730620800,2),(1130,1741510800,1),(1130,1762070400,2),(1130,1772960400,1),(1130,1793520000,2),(1130,1805014800,1),(1130,1825574400,2),(1130,1836464400,1),(1130,1857024000,2),(1130,1867914000,1),(1130,1888473600,2),(1130,1899363600,1),(1130,1919923200,2),(1130,1930813200,1),(1130,1951372800,2),(1130,1962867600,1),(1130,1983427200,2),(1130,1994317200,1),(1130,2014876800,2),(1130,2025766800,1),(1130,2046326400,2),(1130,2057216400,1),(1130,2077776000,2),(1130,2088666000,1),(1130,2109225600,2),(1130,2120115600,1),(1130,2140675200,2),(1131,-2147483648,2),(1131,-933667200,1),(1131,-922093200,2),(1131,-908870400,1),(1131,-888829200,2),(1131,-881049600,1),(1131,-767869200,2),(1131,-745833600,1),(1131,-733827600,2),(1131,-716889600,1),(1131,-699613200,2),(1131,-683884800,1),(1131,-670669200,2),(1131,-652348800,1),(1131,-650019600,2),(1131,515527200,1),(1131,527014800,2),(1131,545162400,1),(1131,558464400,2),(1131,577216800,1),(1131,589914000,2),(1131,608666400,1),(1131,621968400,2),(1131,640116000,1),(1131,653418000,2),(1131,671565600,1),(1131,684867600,2),(1132,-1633269600,0),(1132,-1615129200,1),(1132,-1601820000,0),(1132,-1583679600,1),(1132,-880207200,2),(1132,-769395600,3),(1132,-765385200,1),(1132,-84376800,0),(1132,-68655600,1),(1132,-52927200,0),(1132,-37206000,1),(1132,-21477600,0),(1132,-5756400,1),(1132,9972000,0),(1132,25693200,1),(1132,41421600,0),(1132,57747600,1),(1132,73476000,0),(1132,89197200,1),(1132,104925600,0),(1132,120646800,1),(1132,126698400,0),(1132,152096400,1),(1132,162381600,0),(1132,183546000,1),(1132,199274400,0),(1132,215600400,1),(1132,230724000,0),(1132,247050000,1),(1132,262778400,0),(1132,278499600,1),(1132,294228000,0),(1132,309949200,1),(1132,325677600,0),(1132,341398800,1),(1132,357127200,0),(1132,372848400,1),(1132,388576800,0),(1132,404902800,1),(1132,420026400,0),(1132,436352400,1),(1132,452080800,0),(1132,467802000,1),(1132,483530400,0),(1132,499251600,1),(1132,514980000,0),(1132,530701200,1),(1132,544615200,0),(1132,562150800,1),(1132,576064800,0),(1132,594205200,1),(1132,607514400,0),(1132,625654800,1),(1132,638964000,0),(1132,657104400,1),(1132,671018400,0),(1132,688554000,1),(1132,702468000,0),(1132,720003600,1),(1132,733917600,0),(1132,752058000,1),(1132,765367200,0),(1132,783507600,1),(1132,796816800,0),(1132,814957200,1),(1132,828871200,0),(1132,846406800,1),(1132,860320800,0),(1132,877856400,1),(1132,891770400,0),(1132,909306000,1),(1132,923220000,0),(1132,941360400,1),(1132,954669600,0),(1132,972810000,1),(1132,986119200,0),(1132,1004259600,1),(1132,1018173600,0),(1132,1035709200,1),(1132,1049623200,0),(1132,1067158800,1),(1132,1081072800,0),(1132,1099213200,1),(1132,1112522400,0),(1132,1130662800,1),(1132,1143972000,0),(1132,1162112400,1),(1132,1173607200,0),(1132,1194166800,1),(1132,1205056800,0),(1132,1225616400,1),(1132,1236506400,0),(1132,1257066000,1),(1132,1268560800,0),(1132,1289120400,1),(1132,1300010400,0),(1132,1320570000,1),(1132,1331460000,0),(1132,1352019600,1),(1132,1362909600,0),(1132,1383469200,1),(1132,1394359200,0),(1132,1414918800,1),(1132,1425808800,0),(1132,1446368400,1),(1132,1457863200,0),(1132,1478422800,1),(1132,1489312800,0),(1132,1509872400,1),(1132,1520762400,0),(1132,1541322000,1),(1132,1552212000,0),(1132,1572771600,1),(1132,1583661600,0),(1132,1604221200,1),(1132,1615716000,0),(1132,1636275600,1),(1132,1647165600,0),(1132,1667725200,1),(1132,1678615200,0),(1132,1699174800,1),(1132,1710064800,0),(1132,1730624400,1),(1132,1741514400,0),(1132,1762074000,1),(1132,1772964000,0),(1132,1793523600,1),(1132,1805018400,0),(1132,1825578000,1),(1132,1836468000,0),(1132,1857027600,1),(1132,1867917600,0),(1132,1888477200,1),(1132,1899367200,0),(1132,1919926800,1),(1132,1930816800,0),(1132,1951376400,1),(1132,1962871200,0),(1132,1983430800,1),(1132,1994320800,0),(1132,2014880400,1),(1132,2025770400,0),(1132,2046330000,1),(1132,2057220000,0),(1132,2077779600,1),(1132,2088669600,0),(1132,2109229200,1),(1132,2120119200,0),(1132,2140678800,1),(1133,-2147483648,1),(1133,-1861878784,2),(1133,-631110600,4),(1133,1285498800,3),(1133,1301752800,4),(1133,1316872800,3),(1133,1325239200,6),(1133,1333202400,5),(1133,1348927200,6),(1133,1365256800,5),(1133,1380376800,6),(1133,1396706400,5),(1133,1411826400,6),(1133,1428156000,5),(1133,1443276000,6),(1133,1459605600,5),(1133,1474725600,6),(1133,1491055200,5),(1133,1506175200,6),(1133,1522504800,5),(1133,1538229600,6),(1133,1554559200,5),(1133,1569679200,6),(1133,1586008800,5),(1133,1601128800,6),(1133,1617458400,5),(1133,1632578400,6),(1133,1648908000,5),(1133,1664028000,6),(1133,1680357600,5),(1133,1695477600,6),(1133,1712412000,5),(1133,1727532000,6),(1133,1743861600,5),(1133,1758981600,6),(1133,1775311200,5),(1133,1790431200,6),(1133,1806760800,5),(1133,1821880800,6),(1133,1838210400,5),(1133,1853330400,6),(1133,1869660000,5),(1133,1885384800,6),(1133,1901714400,5),(1133,1916834400,6),(1133,1933164000,5),(1133,1948284000,6),(1133,1964613600,5),(1133,1979733600,6),(1133,1996063200,5),(1133,2011183200,6),(1133,2027512800,5),(1133,2042632800,6),(1133,2058962400,5),(1133,2074687200,6),(1133,2091016800,5),(1133,2106136800,6),(1133,2122466400,5),(1133,2137586400,6),(1133,2147483647,6),(1134,-2147483648,2),(1134,-1330335000,1),(1134,-1320057000,2),(1134,-1300699800,3),(1134,-1287396000,2),(1134,-1269250200,3),(1134,-1255946400,2),(1134,-1237800600,3),(1134,-1224496800,2),(1134,-1206351000,3),(1134,-1192442400,2),(1134,-1174901400,3),(1134,-1160992800,2),(1134,-1143451800,3),(1134,-1125914400,2),(1134,-1112607000,3),(1134,-1094464800,2),(1134,-1081157400,3),(1134,-1063015200,2),(1134,-1049707800,3),(1134,-1031565600,2),(1134,-1018258200,3),(1134,-1000116000,2),(1134,-986808600,3),(1134,-968061600,2),(1134,-955359000,3),(1134,-936612000,2),(1134,-923304600,3),(1134,-757425600,6),(1134,152632800,4),(1134,162309600,5),(1134,183477600,4),(1134,194968800,5),(1134,215532000,4),(1134,226418400,5),(1134,246981600,4),(1134,257868000,5),(1134,278431200,4),(1134,289317600,5),(1134,309880800,4),(1134,320767200,5),(1134,341330400,4),(1134,352216800,5),(1134,372780000,4),(1134,384271200,5),(1134,404834400,4),(1134,415720800,5),(1134,436284000,4),(1134,447170400,5),(1134,467733600,4),(1134,478620000,5),(1134,499183200,4),(1134,510069600,5),(1134,530632800,4),(1134,541519200,5),(1134,562082400,4),(1134,573573600,5),(1134,594136800,4),(1134,605023200,5),(1134,623772000,4),(1134,637682400,5),(1134,655221600,4),(1134,669132000,5),(1134,686671200,4),(1134,700581600,5),(1134,718120800,4),(1134,732636000,5),(1134,749570400,4),(1134,764085600,5),(1134,781020000,4),(1134,795535200,5),(1134,812469600,4),(1134,826984800,5),(1134,844524000,4),(1134,858434400,5),(1134,875973600,4),(1134,889884000,5),(1134,907423200,4),(1134,921938400,5),(1134,938872800,4),(1134,953388000,5),(1134,970322400,4),(1134,984837600,5),(1134,1002376800,4),(1134,1016287200,5),(1134,1033826400,4),(1134,1047736800,5),(1134,1065276000,4),(1134,1079791200,5),(1134,1096725600,4),(1134,1111240800,5),(1134,1128175200,4),(1134,1142690400,5),(1134,1159624800,4),(1134,1174140000,5),(1134,1191074400,4),(1134,1207404000,5),(1134,1222524000,4),(1134,1238853600,5),(1134,1253973600,4),(1134,1270303200,5),(1134,1285423200,4),(1134,1301752800,5),(1134,1316872800,4),(1134,1333202400,5),(1134,1348927200,4),(1134,1365256800,5),(1134,1380376800,4),(1134,1396706400,5),(1134,1411826400,4),(1134,1428156000,5),(1134,1443276000,4),(1134,1459605600,5),(1134,1474725600,4),(1134,1491055200,5),(1134,1506175200,4),(1134,1522504800,5),(1134,1538229600,4),(1134,1554559200,5),(1134,1569679200,4),(1134,1586008800,5),(1134,1601128800,4),(1134,1617458400,5),(1134,1632578400,4),(1134,1648908000,5),(1134,1664028000,4),(1134,1680357600,5),(1134,1695477600,4),(1134,1712412000,5),(1134,1727532000,4),(1134,1743861600,5),(1134,1758981600,4),(1134,1775311200,5),(1134,1790431200,4),(1134,1806760800,5),(1134,1821880800,4),(1134,1838210400,5),(1134,1853330400,4),(1134,1869660000,5),(1134,1885384800,4),(1134,1901714400,5),(1134,1916834400,4),(1134,1933164000,5),(1134,1948284000,4),(1134,1964613600,5),(1134,1979733600,4),(1134,1996063200,5),(1134,2011183200,4),(1134,2027512800,5),(1134,2042632800,4),(1134,2058962400,5),(1134,2074687200,4),(1134,2091016800,5),(1134,2106136800,4),(1134,2122466400,5),(1134,2137586400,4),(1135,-2147483648,1),(1135,-868010400,2),(1135,-768906000,1),(1135,1419696000,3),(1135,2147483647,3),(1136,-2147483648,1),(1136,-757426500,4),(1136,152632800,2),(1136,162309600,3),(1136,183477600,2),(1136,194968800,3),(1136,215532000,2),(1136,226418400,3),(1136,246981600,2),(1136,257868000,3),(1136,278431200,2),(1136,289317600,3),(1136,309880800,2),(1136,320767200,3),(1136,341330400,2),(1136,352216800,3),(1136,372780000,2),(1136,384271200,3),(1136,404834400,2),(1136,415720800,3),(1136,436284000,2),(1136,447170400,3),(1136,467733600,2),(1136,478620000,3),(1136,499183200,2),(1136,510069600,3),(1136,530632800,2),(1136,541519200,3),(1136,562082400,2),(1136,573573600,3),(1136,594136800,2),(1136,605023200,3),(1136,623772000,2),(1136,637682400,3),(1136,655221600,2),(1136,669132000,3),(1136,686671200,2),(1136,700581600,3),(1136,718120800,2),(1136,732636000,3),(1136,749570400,2),(1136,764085600,3),(1136,781020000,2),(1136,795535200,3),(1136,812469600,2),(1136,826984800,3),(1136,844524000,2),(1136,858434400,3),(1136,875973600,2),(1136,889884000,3),(1136,907423200,2),(1136,921938400,3),(1136,938872800,2),(1136,953388000,3),(1136,970322400,2),(1136,984837600,3),(1136,1002376800,2),(1136,1016287200,3),(1136,1033826400,2),(1136,1047736800,3),(1136,1065276000,2),(1136,1079791200,3),(1136,1096725600,2),(1136,1111240800,3),(1136,1128175200,2),(1136,1142690400,3),(1136,1159624800,2),(1136,1174140000,3),(1136,1191074400,2),(1136,1207404000,3),(1136,1222524000,2),(1136,1238853600,3),(1136,1253973600,2),(1136,1270303200,3),(1136,1285423200,2),(1136,1301752800,3),(1136,1316872800,2),(1136,1333202400,3),(1136,1348927200,2),(1136,1365256800,3),(1136,1380376800,2),(1136,1396706400,3),(1136,1411826400,2),(1136,1428156000,3),(1136,1443276000,2),(1136,1459605600,3),(1136,1474725600,2),(1136,1491055200,3),(1136,1506175200,2),(1136,1522504800,3),(1136,1538229600,2),(1136,1554559200,3),(1136,1569679200,2),(1136,1586008800,3),(1136,1601128800,2),(1136,1617458400,3),(1136,1632578400,2),(1136,1648908000,3),(1136,1664028000,2),(1136,1680357600,3),(1136,1695477600,2),(1136,1712412000,3),(1136,1727532000,2),(1136,1743861600,3),(1136,1758981600,2),(1136,1775311200,3),(1136,1790431200,2),(1136,1806760800,3),(1136,1821880800,2),(1136,1838210400,3),(1136,1853330400,2),(1136,1869660000,3),(1136,1885384800,2),(1136,1901714400,3),(1136,1916834400,2),(1136,1933164000,3),(1136,1948284000,2),(1136,1964613600,3),(1136,1979733600,2),(1136,1996063200,3),(1136,2011183200,2),(1136,2027512800,3),(1136,2042632800,2),(1136,2058962400,3),(1136,2074687200,2),(1136,2091016800,3),(1136,2106136800,2),(1136,2122466400,3),(1136,2137586400,2),(1136,2147483647,2),(1137,-2147483648,1),(1137,-1743674400,2),(1137,-1606813200,1),(1137,-907408800,2),(1137,-770634000,1),(1137,2147483647,1),(1138,-2147483648,1),(1138,-1178124152,4),(1138,-36619200,2),(1138,-23922000,3),(1138,-3355200,2),(1138,7527600,3),(1138,24465600,2),(1138,37767600,3),(1138,55915200,2),(1138,69217200,3),(1138,87969600,2),(1138,100666800,3),(1138,118209600,2),(1138,132116400,3),(1138,150868800,2),(1138,163566000,3),(1138,182318400,2),(1138,195620400,3),(1138,213768000,2),(1138,227070000,3),(1138,245217600,2),(1138,258519600,3),(1138,277272000,2),(1138,289969200,3),(1138,308721600,2),(1138,321418800,3),(1138,340171200,2),(1138,353473200,3),(1138,371620800,2),(1138,384922800,5),(1138,403070400,6),(1138,416372400,5),(1138,434520000,6),(1138,447822000,5),(1138,466574400,6),(1138,479271600,5),(1138,498024000,6),(1138,510721200,5),(1138,529473600,6),(1138,545194800,5),(1138,560923200,6),(1138,574225200,5),(1138,592372800,6),(1138,605674800,5),(1138,624427200,6),(1138,637124400,5),(1138,653457600,6),(1138,668574000,5),(1138,687326400,6),(1138,700628400,5),(1138,718776000,6),(1138,732078000,5),(1138,750225600,6),(1138,763527600,5),(1138,781675200,6),(1138,794977200,5),(1138,813729600,6),(1138,826426800,5),(1138,845179200,6),(1138,859690800,5),(1138,876628800,6),(1138,889930800,5),(1138,906868800,6),(1138,923194800,5),(1138,939528000,6),(1138,952830000,5),(1138,971582400,6),(1138,984279600,5),(1138,1003032000,6),(1138,1015729200,5),(1138,1034481600,6),(1138,1047178800,5),(1138,1065931200,6),(1138,1079233200,5),(1138,1097380800,6),(1138,1110682800,5),(1138,1128830400,6),(1138,1142132400,5),(1138,1160884800,6),(1138,1173582000,5),(1138,1192334400,6),(1138,1206846000,5),(1138,1223784000,6),(1138,1237086000,5),(1138,1255233600,6),(1138,1270350000,5),(1138,1286683200,6),(1138,1304823600,5),(1138,1313899200,6),(1138,1335668400,5),(1138,1346558400,6),(1138,1367118000,5),(1138,1378612800,6),(1138,1398567600,5),(1138,1410062400,6),(1138,1463281200,5),(1138,1471147200,6),(1138,1494730800,5),(1138,1502596800,6),(1138,1526180400,5),(1138,1534046400,6),(1138,1554606000,5),(1138,1567915200,6),(1138,1586055600,5),(1138,1599364800,6),(1138,1617505200,5),(1138,1630814400,6),(1138,1648954800,5),(1138,1662264000,6),(1138,1680404400,5),(1138,1693713600,6),(1138,1712458800,5),(1138,1725768000,6),(1138,1743908400,5),(1138,1757217600,6),(1138,1775358000,5),(1138,1788667200,6),(1138,1806807600,5),(1138,1820116800,6),(1138,1838257200,5),(1138,1851566400,6),(1138,1870311600,5),(1138,1883016000,6),(1138,1901761200,5),(1138,1915070400,6),(1138,1933210800,5),(1138,1946520000,6),(1138,1964660400,5),(1138,1977969600,6),(1138,1996110000,5),(1138,2009419200,6),(1138,2027559600,5),(1138,2040868800,6),(1138,2059614000,5),(1138,2072318400,6),(1138,2091063600,5),(1138,2104372800,6),(1138,2122513200,5),(1138,2135822400,6),(1138,2147483647,6),(1139,-2147483648,0),(1139,-1829387596,2),(1139,433256400,1),(1139,448977600,2),(1139,467298000,1),(1139,480427200,2),(1139,496760400,1),(1139,511876800,2),(1139,528210000,1),(1139,543931200,2),(1139,559659600,1),(1139,575380800,2),(1139,591109200,1),(1139,606830400,2),(1139,622558800,1),(1139,638280000,2),(1139,654008400,1),(1139,669729600,2),(1139,686062800,1),(1139,696340800,2),(1139,719931600,1),(1139,727790400,2),(1139,2147483647,2),(1140,-2147483648,1),(1140,307627200,2),(1140,788871600,3),(1140,2147483647,3),(1141,-2147483648,1),(1141,1325242800,2),(1141,2147483647,2),(1142,-2147483648,0),(1142,-1709985344,2),(1142,909842400,1),(1142,920124000,2),(1142,941896800,1),(1142,951573600,2),(1142,1259416800,1),(1142,1269698400,2),(1142,1287842400,1),(1142,1299333600,2),(1142,1319292000,1),(1142,1327154400,2),(1142,1350741600,1),(1142,1358604000,2),(1142,1382796000,1),(1142,1390050000,2),(1142,1414850400,1),(1142,1421503200,2),(1142,1446300000,1),(1142,1452952800,2),(1142,1478354400,1),(1142,1484402400,2),(1142,1509804000,1),(1142,1515852000,2),(1142,1541253600,1),(1142,1547301600,2),(1142,1572703200,1),(1142,1579356000,2),(1142,1604152800,1),(1142,1610805600,2),(1142,1636207200,1),(1142,1642255200,2),(1142,1667656800,1),(1142,1673704800,2),(1142,1699106400,1),(1142,1705154400,2),(1142,1730556000,1),(1142,1737208800,2),(1142,1762005600,1),(1142,1768658400,2),(1142,1793455200,1),(1142,1800108000,2),(1142,1825509600,1),(1142,1831557600,2),(1142,1856959200,1),(1142,1863007200,2),(1142,1888408800,1),(1142,1894456800,2),(1142,1919858400,1),(1142,1926511200,2),(1142,1951308000,1),(1142,1957960800,2),(1142,1983362400,1),(1142,1989410400,2),(1142,2014812000,1),(1142,2020860000,2),(1142,2046261600,1),(1142,2052309600,2),(1142,2077711200,1),(1142,2083759200,2),(1142,2109160800,1),(1142,2115813600,2),(1142,2140610400,1),(1142,2147263200,2),(1142,2147483647,2),(1143,-2147483648,1),(1143,2147483647,1),(1144,-2147483648,0),(1144,-1230746496,1),(1144,504939600,3),(1144,722930400,2),(1144,728888400,3),(1144,2147483647,3),(1145,-2147483648,0),(1145,-1806678012,1),(1145,2147483647,1),(1146,-2147483648,0),(1146,-1806748788,1),(1146,2147483647,1),(1147,-2147483648,1),(1147,-885549600,2),(1147,-802256400,1),(1147,-331891200,3),(1147,-281610000,1),(1147,-73728000,3),(1147,-29415540,1),(1147,-16704000,3),(1147,-10659600,1),(1147,9907200,3),(1147,21394800,1),(1147,41356800,3),(1147,52844400,1),(1147,124819200,3),(1147,130863600,1),(1147,201888000,3),(1147,209487660,1),(1147,230659200,3),(1147,241542000,1),(1147,977493600,4),(1148,-2147483648,1),(1148,-1157283000,2),(1148,-1155436200,1),(1148,-880198200,3),(1148,-769395600,4),(1148,-765376200,1),(1148,-712150200,5),(1149,-2147483648,1),(1149,-1157283000,2),(1149,-1155436200,1),(1149,-880198200,3),(1149,-769395600,4),(1149,-765376200,1),(1149,-712150200,5),(1150,-2147483648,1),(1150,307622400,2),(1150,788868000,3),(1150,2147483647,3),(1151,-2147483648,1),(1151,-1743678000,2),(1151,-1606813200,1),(1151,-1041418800,3),(1151,-907408800,2),(1151,-770634000,1),(1151,-7988400,4),(1151,915105600,1),(1151,2147483647,1),(1152,-2147483648,1),(1152,-1041418800,2),(1152,-907408800,3),(1152,-817462800,1),(1152,-7988400,4),(1152,745934400,5),(1152,2147483647,5),(1153,-2147483648,1),(1153,-1743678000,2),(1153,-1606813200,1),(1153,-1041418800,3),(1153,-907408800,2),(1153,-818067600,1),(1153,-7988400,4),(1153,2147483647,4),(1154,-2147483648,0),(1154,-1806676920,1),(1154,2147483647,1),(1155,-2147483648,1),(1155,-1861879032,2),(1156,-2147483648,0),(1156,-1545131260,1),(1156,-862918200,2),(1156,-767350800,1),(1156,287418600,3),(1156,2147483647,3),(1157,-2147483648,1),(1157,-599575200,2),(1157,276089400,3),(1157,2147483647,3),(1158,-2147483648,1),(1158,-599656320,2),(1158,152029800,3),(1158,162912600,2),(1158,1443882600,4),(1158,2147483647,4),(1159,-2147483648,0),(1159,-1829387148,2),(1159,250002000,1),(1159,257342400,2),(1159,281451600,1),(1159,288878400,2),(1159,849366000,3),(1159,857228400,4),(1159,2147483647,4),(1160,-2147483648,1),(1160,-1861879032,2),(1161,-2147483648,1),(1161,2147483647,1),(1162,-2147483648,1),(1162,893665800,2),(1162,2147483647,2),(1163,-2147483648,1),(1163,-1743678000,2),(1163,-1606813200,1),(1163,-1041418800,3),(1163,-907408800,2),(1163,-770634000,1),(1163,2147483647,1),(1164,-2147483648,1),(1164,-1743678000,2),(1164,-1606813200,1),(1164,-1041418800,3),(1164,-907408800,2),(1164,-770634000,1),(1164,2147483647,1),(1165,-2147483648,1),(1165,2147483647,1),(1166,-2147483648,1),(1166,279714600,3),(1166,289387800,2),(1166,309952800,3),(1166,320837400,2),(1166,341402400,3),(1166,352287000,2),(1166,372852000,3),(1166,384341400,2),(1166,404906400,3),(1166,415791000,2),(1166,436356000,3),(1166,447240600,2),(1166,467805600,3),(1166,478690200,2),(1166,499255200,3),(1166,510139800,2),(1166,530704800,3),(1166,541589400,2),(1166,562154400,3),(1166,573643800,2),(1166,594208800,3),(1166,605093400,2),(1166,625658400,3),(1166,636543000,2),(1166,657108000,3),(1166,667992600,2),(1166,2147483647,2),(1167,-2147483648,1),(1167,-885549600,2),(1167,-802256400,1),(1167,-331891200,3),(1167,-281610000,1),(1167,-73728000,3),(1167,-29415540,1),(1167,-16704000,3),(1167,-10659600,1),(1167,9907200,3),(1167,21394800,1),(1167,41356800,3),(1167,52844400,1),(1167,124819200,3),(1167,130863600,1),(1167,201888000,3),(1167,209487660,1),(1167,230659200,3),(1167,241542000,1),(1167,977493600,4),(1168,-2147483648,1),(1168,-1861879032,2),(1169,-2147483648,0),(1169,-1806674504,1),(1169,2147483647,1),(1170,-2147483648,1),(1170,2147483647,1),(1171,-2147483648,1),(1171,-915193200,2),(1171,939214800,3),(1171,953384400,4),(1171,973342800,5),(1171,980596800,2),(1171,1004792400,5),(1171,1012046400,2),(1171,1478350800,5),(1171,1484398800,2),(1171,2147483647,2),(1172,-2147483648,1),(1172,-1743674400,2),(1172,-1606813200,1),(1172,-907408800,2),(1172,-770634000,1),(1172,2147483647,1),(1173,-2147483648,1),(1173,2147483647,1),(1174,-2147483648,1),(1174,2147483647,1),(1175,-2147483648,1),(1175,-1743674400,2),(1175,-1606813200,1),(1175,-907408800,2),(1175,-770634000,1),(1175,2147483647,1),(1176,-2147483648,1),(1176,-1717032240,3),(1176,-1693706400,2),(1176,-1680483600,3),(1176,-1663455600,4),(1176,-1650150000,5),(1176,-1632006000,4),(1176,-1618700400,8),(1176,-1600473600,6),(1176,-1587168000,7),(1176,-1501725600,3),(1176,-931734000,2),(1176,-857257200,5),(1176,-844556400,4),(1176,-828226800,5),(1176,-812502000,4),(1176,-796874400,2),(1176,-796608000,3),(1176,-778726800,2),(1176,-762660000,3),(1176,-748486800,4),(1176,-733273200,5),(1176,-715215600,4),(1176,-701910000,5),(1176,-684975600,4),(1176,-670460400,5),(1176,-654130800,4),(1176,-639010800,5),(1176,-397094400,4),(1176,-386812800,5),(1176,-371088000,4),(1176,-355363200,5),(1176,-334195200,4),(1176,-323308800,5),(1176,-307584000,4),(1176,-291859200,5),(1176,-271296000,4),(1176,-260409600,5),(1176,-239846400,4),(1176,-228960000,5),(1176,-208396800,4),(1176,-197510400,5),(1176,-176342400,4),(1176,-166060800,5),(1176,220921200,3),(1176,228873600,4),(1176,243993600,5),(1176,260323200,4),(1176,276048000,5),(1176,291772800,4),(1176,307497600,5),(1176,323827200,4),(1176,338947200,5),(1176,354672000,4),(1176,370396800,5),(1176,386121600,4),(1176,401846400,5),(1176,417571200,4),(1176,433296000,5),(1176,449020800,4),(1176,465350400,5),(1176,481075200,4),(1176,496800000,5),(1176,512524800,4),(1176,528249600,5),(1176,543974400,4),(1176,559699200,5),(1176,567990000,3),(1176,575427600,9),(1176,591152400,10),(1176,606877200,9),(1176,622602000,10),(1176,638326800,9),(1176,654656400,10),(1176,670381200,9),(1176,686106000,10),(1176,701830800,9),(1176,717555600,10),(1176,733280400,9),(1176,749005200,10),(1176,764730000,9),(1176,780454800,10),(1176,796179600,9),(1176,811904400,10),(1176,828234000,9),(1176,846378000,10),(1176,859683600,9),(1176,877827600,10),(1176,891133200,9),(1176,909277200,10),(1176,922582800,9),(1176,941331600,10),(1176,954032400,9),(1176,972781200,10),(1176,985482000,9),(1176,1004230800,10),(1176,1017536400,9),(1176,1035680400,10),(1176,1048986000,9),(1176,1067130000,10),(1176,1080435600,9),(1176,1099184400,10),(1176,1111885200,9),(1176,1130634000,10),(1176,1143334800,9),(1176,1162083600,10),(1176,1174784400,9),(1176,1193533200,10),(1176,1206838800,9),(1176,1224982800,10),(1176,1238288400,9),(1176,1256432400,10),(1176,1269738000,9),(1176,1288486800,10),(1176,1301187600,9),(1176,1319936400,10),(1176,1332637200,9),(1176,1351386000,10),(1176,1364691600,9),(1176,1382835600,10),(1176,1396141200,9),(1176,1414285200,10),(1176,1427590800,9),(1176,1445734800,10),(1176,1459040400,9),(1176,1477789200,10),(1176,1490490000,9),(1176,1509238800,10),(1176,1521939600,9),(1176,1540688400,10),(1176,1553994000,9),(1176,1572138000,10),(1176,1585443600,9),(1176,1603587600,10),(1176,1616893200,9),(1176,1635642000,10),(1176,1648342800,9),(1176,1667091600,10),(1176,1679792400,9),(1176,1698541200,10),(1176,1711846800,9),(1176,1729990800,10),(1176,1743296400,9),(1176,1761440400,10),(1176,1774746000,9),(1176,1792890000,10),(1176,1806195600,9),(1176,1824944400,10),(1176,1837645200,9),(1176,1856394000,10),(1176,1869094800,9),(1176,1887843600,10),(1176,1901149200,9),(1176,1919293200,10),(1176,1932598800,9),(1176,1950742800,10),(1176,1964048400,9),(1176,1982797200,10),(1176,1995498000,9),(1176,2014246800,10),(1176,2026947600,9),(1176,2045696400,10),(1176,2058397200,9),(1176,2077146000,10),(1176,2090451600,9),(1176,2108595600,10),(1176,2121901200,9),(1176,2140045200,10),(1177,-2147483648,0),(1177,-1830384000,6),(1177,-1689555600,1),(1177,-1677801600,2),(1177,-1667437200,3),(1177,-1647738000,4),(1177,-1635814800,3),(1177,-1616202000,4),(1177,-1604365200,3),(1177,-1584666000,4),(1177,-1572742800,3),(1177,-1553043600,4),(1177,-1541206800,3),(1177,-1521507600,4),(1177,-1442451600,3),(1177,-1426813200,4),(1177,-1379293200,3),(1177,-1364778000,4),(1177,-1348448400,3),(1177,-1333328400,4),(1177,-1316394000,3),(1177,-1301274000,4),(1177,-1284339600,3),(1177,-1269824400,4),(1177,-1221440400,3),(1177,-1206925200,4),(1177,-1191200400,3),(1177,-1175475600,4),(1177,-1127696400,3),(1177,-1111971600,4),(1177,-1096851600,3),(1177,-1080522000,4),(1177,-1063587600,3),(1177,-1049072400,4),(1177,-1033347600,3),(1177,-1017622800,4),(1177,-1002502800,3),(1177,-986173200,4),(1177,-969238800,3),(1177,-950490000,4),(1177,-942022800,3),(1177,-922669200,4),(1177,-906944400,3),(1177,-891133200,4),(1177,-877309200,3),(1177,-873684000,5),(1177,-864007200,3),(1177,-857955600,4),(1177,-845859600,3),(1177,-842839200,5),(1177,-831348000,3),(1177,-825901200,4),(1177,-814410000,3),(1177,-810784800,5),(1177,-799898400,3),(1177,-794451600,4),(1177,-782960400,3),(1177,-779335200,5),(1177,-768448800,3),(1177,-763002000,4),(1177,-749091600,3),(1177,-733366800,4),(1177,-717631200,3),(1177,-701906400,4),(1177,-686181600,3),(1177,-670456800,4),(1177,-654732000,3),(1177,-639007200,4),(1177,-591832800,3),(1177,-575503200,4),(1177,-559778400,3),(1177,-544053600,4),(1177,-528328800,3),(1177,-512604000,4),(1177,-496879200,3),(1177,-481154400,4),(1177,-465429600,3),(1177,-449704800,4),(1177,-433980000,3),(1177,-417650400,4),(1177,-401925600,3),(1177,-386200800,4),(1177,-370476000,3),(1177,-354751200,4),(1177,-339026400,3),(1177,-323301600,4),(1177,-307576800,3),(1177,-291852000,4),(1177,-276127200,3),(1177,-260402400,4),(1177,-244677600,3),(1177,-228348000,4),(1177,-212623200,3),(1177,-196898400,4),(1177,-181173600,3),(1177,-165448800,4),(1177,-149724000,3),(1177,-133999200,4),(1177,-118274400,7),(1177,212544000,2),(1177,228268800,3),(1177,243993600,4),(1177,260323200,3),(1177,276048000,4),(1177,291772800,3),(1177,307501200,4),(1177,323222400,3),(1177,338950800,4),(1177,354675600,3),(1177,370400400,4),(1177,386125200,3),(1177,401850000,4),(1177,417578400,3),(1177,433299600,4),(1177,449024400,3),(1177,465354000,4),(1177,481078800,3),(1177,496803600,4),(1177,512528400,3),(1177,528253200,4),(1177,543978000,3),(1177,559702800,4),(1177,575427600,3),(1177,591152400,4),(1177,606877200,3),(1177,622602000,4),(1177,638326800,3),(1177,654656400,4),(1177,670381200,3),(1177,686106000,4),(1177,701830800,3),(1177,717555600,8),(1177,733280400,9),(1177,749005200,8),(1177,764730000,9),(1177,780454800,8),(1177,796179600,9),(1177,811904400,8),(1177,828234000,10),(1177,846378000,6),(1177,859683600,10),(1177,877827600,6),(1177,891133200,10),(1177,909277200,6),(1177,922582800,10),(1177,941331600,6),(1177,954032400,10),(1177,972781200,6),(1177,985482000,10),(1177,1004230800,6),(1177,1017536400,10),(1177,1035680400,6),(1177,1048986000,10),(1177,1067130000,6),(1177,1080435600,10),(1177,1099184400,6),(1177,1111885200,10),(1177,1130634000,6),(1177,1143334800,10),(1177,1162083600,6),(1177,1174784400,10),(1177,1193533200,6),(1177,1206838800,10),(1177,1224982800,6),(1177,1238288400,10),(1177,1256432400,6),(1177,1269738000,10),(1177,1288486800,6),(1177,1301187600,10),(1177,1319936400,6),(1177,1332637200,10),(1177,1351386000,6),(1177,1364691600,10),(1177,1382835600,6),(1177,1396141200,10),(1177,1414285200,6),(1177,1427590800,10),(1177,1445734800,6),(1177,1459040400,10),(1177,1477789200,6),(1177,1490490000,10),(1177,1509238800,6),(1177,1521939600,10),(1177,1540688400,6),(1177,1553994000,10),(1177,1572138000,6),(1177,1585443600,10),(1177,1603587600,6),(1177,1616893200,10),(1177,1635642000,6),(1177,1648342800,10),(1177,1667091600,6),(1177,1679792400,10),(1177,1698541200,6),(1177,1711846800,10),(1177,1729990800,6),(1177,1743296400,10),(1177,1761440400,6),(1177,1774746000,10),(1177,1792890000,6),(1177,1806195600,10),(1177,1824944400,6),(1177,1837645200,10),(1177,1856394000,6),(1177,1869094800,10),(1177,1887843600,6),(1177,1901149200,10),(1177,1919293200,6),(1177,1932598800,10),(1177,1950742800,6),(1177,1964048400,10),(1177,1982797200,6),(1177,1995498000,10),(1177,2014246800,6),(1177,2026947600,10),(1177,2045696400,6),(1177,2058397200,10),(1177,2077146000,6),(1177,2090451600,10),(1177,2108595600,6),(1177,2121901200,10),(1177,2140045200,6),(1178,-2147483648,1),(1178,-1017820800,2),(1178,-766224000,1),(1178,-745833600,3),(1178,-733827600,1),(1178,-716889600,3),(1178,-699613200,1),(1178,-683884800,3),(1178,-670669200,1),(1178,-652348800,3),(1178,-639133200,1),(1178,-620812800,3),(1178,-607597200,1),(1178,-589276800,3),(1178,-576061200,1),(1178,-562924800,3),(1178,-541760400,1),(1178,-528710400,3),(1178,-510224400,1),(1178,-497174400,3),(1178,-478688400,1),(1178,-465638400,3),(1178,-449830800,1),(1178,-434016000,3),(1178,-418208400,1),(1178,-402480000,3),(1178,-386672400,1),(1178,-370944000,3),(1178,-355136400,1),(1178,-339408000,3),(1178,-323600400,1),(1178,-302515200,3),(1178,-291978000,1),(1178,-270979200,3),(1178,-260442000,1),(1178,133977600,3),(1178,149785200,1),(1178,165513600,3),(1178,181321200,1),(1178,299606400,3),(1178,307551600,1),(1179,-2147483648,0),(1179,-1948782472,1),(1179,-1830414600,2),(1179,-767350800,3),(1179,-498128400,1),(1179,-462702600,4),(1179,-451733400,1),(1179,-429784200,4),(1179,-418296600,1),(1179,-399544200,4),(1179,-387451800,1),(1179,-368094600,4),(1179,-356002200,1),(1179,-336645000,4),(1179,-324552600,1),(1179,-305195400,4),(1179,-293103000,1),(1179,-264933000,3),(1179,547578000,5),(1179,560883600,3),(1179,579027600,5),(1179,592333200,3),(1180,-2147483648,1),(1180,-2038200925,2),(1180,-1167634800,3),(1180,-1073028000,4),(1180,-894180000,5),(1180,-879665400,6),(1180,-767005200,5),(1180,378664200,7),(1180,2147483647,7),(1181,-2147483648,1),(1181,-873057600,3),(1181,-769395600,2),(1181,-765399600,1),(1182,-2147483648,0),(1182,-2131645536,2),(1182,-1696276800,1),(1182,-1680469200,2),(1182,-1632074400,1),(1182,-1615143600,2),(1182,-1566763200,1),(1182,-1557090000,2),(1182,-1535486400,1),(1182,-1524949200,2),(1182,-1504468800,1),(1182,-1493413200,2),(1182,-1472414400,1),(1182,-1461963600,2),(1182,-1440964800,1),(1182,-1429390800,2),(1182,-1409515200,1),(1182,-1396731600,2),(1182,-1376856000,1),(1182,-1366491600,2),(1182,-1346616000,1),(1182,-1333832400,2),(1182,-1313956800,1),(1182,-1303678800,2),(1182,-1282507200,1),(1182,-1272661200,2),(1182,-1251057600,1),(1182,-1240088400,2),(1182,-1219608000,1),(1182,-1207429200,2),(1182,-1188763200,1),(1182,-1175979600,2),(1182,-1157313600,1),(1182,-1143925200,2),(1182,-1124049600,1),(1182,-1113771600,2),(1182,-1091390400,1),(1182,-1081026000,2),(1182,-1059854400,1),(1182,-1050786000,2),(1182,-1030910400,1),(1182,-1018126800,2),(1182,-999460800,1),(1182,-986677200,2),(1182,-965592000,1),(1182,-955227600,2),(1182,-935956800,1),(1182,-923173200,2),(1182,-904507200,1),(1182,-891723600,2),(1182,-880221600,3),(1182,-769395600,4),(1182,-765399600,2),(1182,-747252000,1),(1182,-733950000,2),(1182,-715802400,1),(1182,-702500400,2),(1182,-684352800,1),(1182,-671050800,2),(1182,-652903200,1),(1182,-639601200,2),(1182,-589399200,1),(1182,-576097200,2),(1182,-557949600,1),(1182,-544647600,2),(1182,-526500000,1),(1182,-513198000,2),(1182,-495050400,1),(1182,-481748400,2),(1182,-431546400,1),(1182,-418244400,2),(1182,-400096800,1),(1182,-386794800,2),(1182,-368647200,1),(1182,-355345200,2),(1182,-337197600,1),(1182,-323895600,2),(1182,-242244000,1),(1182,-226522800,2),(1182,-210794400,1),(1182,-195073200,2),(1182,-179344800,1),(1182,-163623600,2),(1182,-147895200,1),(1182,-131569200,2),(1182,-116445600,1),(1182,-100119600,2),(1182,-84391200,1),(1182,-68670000,2),(1182,-52941600,1),(1182,-37220400,2),(1182,-21492000,1),(1182,-5770800,2),(1182,9957600,1),(1182,25678800,2),(1182,41407200,1),(1182,57733200,2),(1182,73461600,1),(1182,89182800,2),(1182,104911200,1),(1182,120632400,2),(1182,136360800,1),(1182,152082000,2),(1182,167810400,1),(1182,183531600,2),(1182,199260000,1),(1182,215586000,2),(1182,230709600,1),(1182,247035600,2),(1182,262764000,1),(1182,278485200,2),(1182,294213600,1),(1182,309934800,2),(1182,325663200,1),(1182,341384400,2),(1182,357112800,1),(1182,372834000,2),(1182,388562400,1),(1182,404888400,2),(1182,420012000,1),(1182,436338000,2),(1182,452066400,1),(1182,467787600,2),(1182,483516000,1),(1182,499237200,2),(1182,514965600,1),(1182,530686800,2),(1182,544600800,1),(1182,562136400,2),(1182,576050400,1),(1182,594190800,2),(1182,607500000,1),(1182,625640400,2),(1182,638949600,1),(1182,657090000,2),(1182,671004000,1),(1182,688539600,2),(1182,702453600,1),(1182,719989200,2),(1182,733903200,1),(1182,752043600,2),(1182,765352800,1),(1182,783493200,2),(1182,796802400,1),(1182,814942800,2),(1182,828856800,1),(1182,846392400,2),(1182,860306400,1),(1182,877842000,2),(1182,891756000,1),(1182,909291600,2),(1182,923205600,1),(1182,941346000,2),(1182,954655200,1),(1182,972795600,2),(1182,986104800,1),(1182,1004245200,2),(1182,1018159200,1),(1182,1035694800,2),(1182,1049608800,1),(1182,1067144400,2),(1182,1081058400,1),(1182,1099198800,2),(1182,1112508000,1),(1182,1130648400,2),(1182,1143957600,1),(1182,1162098000,2),(1182,1173592800,1),(1182,1194152400,2),(1182,1205042400,1),(1182,1225602000,2),(1182,1236492000,1),(1182,1257051600,2),(1182,1268546400,1),(1182,1289106000,2),(1182,1299996000,1),(1182,1320555600,2),(1182,1331445600,1),(1182,1352005200,2),(1182,1362895200,1),(1182,1383454800,2),(1182,1394344800,1),(1182,1414904400,2),(1182,1425794400,1),(1182,1446354000,2),(1182,1457848800,1),(1182,1478408400,2),(1182,1489298400,1),(1182,1509858000,2),(1182,1520748000,1),(1182,1541307600,2),(1182,1552197600,1),(1182,1572757200,2),(1182,1583647200,1),(1182,1604206800,2),(1182,1615701600,1),(1182,1636261200,2),(1182,1647151200,1),(1182,1667710800,2),(1182,1678600800,1),(1182,1699160400,2),(1182,1710050400,1),(1182,1730610000,2),(1182,1741500000,1),(1182,1762059600,2),(1182,1772949600,1),(1182,1793509200,2),(1182,1805004000,1),(1182,1825563600,2),(1182,1836453600,1),(1182,1857013200,2),(1182,1867903200,1),(1182,1888462800,2),(1182,1899352800,1),(1182,1919912400,2),(1182,1930802400,1),(1182,1951362000,2),(1182,1962856800,1),(1182,1983416400,2),(1182,1994306400,1),(1182,2014866000,2),(1182,2025756000,1),(1182,2046315600,2),(1182,2057205600,1),(1182,2077765200,2),(1182,2088655200,1),(1182,2109214800,2),(1182,2120104800,1),(1182,2140664400,2),(1183,-2147483648,0),(1183,-2030202084,2),(1183,-1632063600,1),(1183,-1615132800,2),(1183,-1251651600,1),(1183,-1238349600,2),(1183,-1220202000,1),(1183,-1206900000,2),(1183,-1188752400,1),(1183,-1175450400,2),(1183,-1156698000,1),(1183,-1144000800,2),(1183,-1125248400,1),(1183,-1111946400,2),(1183,-1032714000,1),(1183,-1016992800,2),(1183,-1001264400,1),(1183,-986148000,2),(1183,-969814800,1),(1183,-954093600,2),(1183,-937760400,1),(1183,-922039200,2),(1183,-906310800,1),(1183,-890589600,2),(1183,-880210800,3),(1183,-769395600,4),(1183,-765388800,2),(1183,-748450800,1),(1183,-732729600,2),(1183,-715791600,1),(1183,-702489600,2),(1183,-684342000,1),(1183,-671040000,2),(1183,-652892400,1),(1183,-639590400,2),(1183,-620838000,1),(1183,-608140800,2),(1183,-589388400,1),(1183,-576086400,2),(1183,-557938800,1),(1183,-544636800,2),(1183,-526489200,1),(1183,-513187200,2),(1183,-495039600,1),(1183,-481737600,2),(1183,-463590000,1),(1183,-450288000,2),(1183,-431535600,1),(1183,-418233600,2),(1183,-400086000,1),(1183,-386784000,2),(1183,-337186800,1),(1183,-321465600,2),(1183,-305737200,5),(1184,-2147483648,2),(1184,-1633276800,1),(1184,-1615136400,2),(1184,-1601827200,1),(1184,-1583686800,2),(1184,-1563724800,1),(1184,-1551632400,2),(1184,-1538928000,1),(1184,-1520182800,2),(1184,-1504454400,1),(1184,-1491757200,2),(1184,-1473004800,1),(1184,-1459702800,2),(1184,-1441555200,1),(1184,-1428253200,2),(1184,-1410105600,1),(1184,-1396803600,2),(1184,-1378656000,1),(1184,-1365354000,2),(1184,-1347206400,1),(1184,-1333904400,2),(1184,-1315152000,1),(1184,-1301850000,2),(1184,-1283702400,1),(1184,-1270400400,2),(1184,-1252252800,1),(1184,-1238950800,2),(1184,-1220803200,1),(1184,-1207501200,2),(1184,-1189353600,1),(1184,-1176051600,2),(1184,-1157299200,1),(1184,-1144602000,2),(1184,-1125849600,1),(1184,-1112547600,2),(1184,-1094400000,1),(1184,-1081098000,2),(1184,-1067788800,3),(1184,-1045414800,2),(1184,-1031500800,1),(1184,-1018198800,2),(1184,-1000051200,1),(1184,-986749200,2),(1184,-967996800,1),(1184,-955299600,2),(1184,-936547200,1),(1184,-923245200,2),(1184,-905097600,1),(1184,-891795600,2),(1184,-880214400,4),(1184,-769395600,5),(1184,-765392400,2),(1184,-747244800,1),(1184,-733942800,2),(1184,-715795200,1),(1184,-702493200,2),(1184,-684345600,1),(1184,-671043600,2),(1184,-652896000,1),(1184,-639594000,2),(1184,-620841600,1),(1184,-608144400,2),(1184,-589392000,1),(1184,-576090000,2),(1184,-557942400,1),(1184,-544640400,2),(1184,-526492800,1),(1184,-513190800,2),(1184,-495043200,1),(1184,-481741200,2),(1184,-463593600,1),(1184,-447267600,2),(1184,-431539200,1),(1184,-415818000,2),(1184,-400089600,1),(1184,-384368400,2),(1184,-368640000,1),(1184,-352918800,2),(1184,-337190400,1),(1184,-321469200,2),(1184,-305740800,1),(1184,-289414800,2),(1184,-273686400,1),(1184,-257965200,2),(1184,-242236800,1),(1184,-226515600,2),(1184,-210787200,1),(1184,-195066000,2),(1184,-179337600,1),(1184,-163616400,2),(1184,-147888000,1),(1184,-131562000,2),(1184,-116438400,1),(1184,-100112400,2),(1184,-84384000,1),(1184,-68662800,2),(1184,-52934400,1),(1184,-37213200,2),(1184,-21484800,1),(1184,-5763600,2),(1184,9964800,1),(1184,25686000,2),(1184,41414400,1),(1184,57740400,2),(1184,73468800,1),(1184,89190000,2),(1184,104918400,1),(1184,120639600,2),(1184,126691200,1),(1184,152089200,2),(1184,162374400,1),(1184,183538800,2),(1184,199267200,1),(1184,215593200,2),(1184,230716800,1),(1184,247042800,2),(1184,262771200,1),(1184,278492400,2),(1184,294220800,1),(1184,309942000,2),(1184,325670400,1),(1184,341391600,2),(1184,357120000,1),(1184,372841200,2),(1184,388569600,1),(1184,404895600,2),(1184,420019200,1),(1184,436345200,2),(1184,452073600,1),(1184,467794800,2),(1184,483523200,1),(1184,499244400,2),(1184,514972800,1),(1184,530694000,2),(1184,544608000,1),(1184,562143600,2),(1184,576057600,1),(1184,594198000,2),(1184,607507200,1),(1184,625647600,2),(1184,638956800,1),(1184,657097200,2),(1184,671011200,1),(1184,688546800,2),(1184,702460800,1),(1184,719996400,2),(1184,733910400,1),(1184,752050800,2),(1184,765360000,1),(1184,783500400,2),(1184,796809600,1),(1184,814950000,2),(1184,828864000,1),(1184,846399600,2),(1184,860313600,1),(1184,877849200,2),(1184,891763200,1),(1184,909298800,2),(1184,923212800,1),(1184,941353200,2),(1184,954662400,1),(1184,972802800,2),(1184,986112000,1),(1184,1004252400,2),(1184,1018166400,1),(1184,1035702000,2),(1184,1049616000,1),(1184,1067151600,2),(1184,1081065600,1),(1184,1099206000,2),(1184,1112515200,1),(1184,1130655600,2),(1184,1143964800,1),(1184,1162105200,2),(1184,1173600000,1),(1184,1194159600,2),(1184,1205049600,1),(1184,1225609200,2),(1184,1236499200,1),(1184,1257058800,2),(1184,1268553600,1),(1184,1289113200,2),(1184,1300003200,1),(1184,1320562800,2),(1184,1331452800,1),(1184,1352012400,2),(1184,1362902400,1),(1184,1383462000,2),(1184,1394352000,1),(1184,1414911600,2),(1184,1425801600,1),(1184,1446361200,2),(1184,1457856000,1),(1184,1478415600,2),(1184,1489305600,1),(1184,1509865200,2),(1184,1520755200,1),(1184,1541314800,2),(1184,1552204800,1),(1184,1572764400,2),(1184,1583654400,1),(1184,1604214000,2),(1184,1615708800,1),(1184,1636268400,2),(1184,1647158400,1),(1184,1667718000,2),(1184,1678608000,1),(1184,1699167600,2),(1184,1710057600,1),(1184,1730617200,2),(1184,1741507200,1),(1184,1762066800,2),(1184,1772956800,1),(1184,1793516400,2),(1184,1805011200,1),(1184,1825570800,2),(1184,1836460800,1),(1184,1857020400,2),(1184,1867910400,1),(1184,1888470000,2),(1184,1899360000,1),(1184,1919919600,2),(1184,1930809600,1),(1184,1951369200,2),(1184,1962864000,1),(1184,1983423600,2),(1184,1994313600,1),(1184,2014873200,2),(1184,2025763200,1),(1184,2046322800,2),(1184,2057212800,1),(1184,2077772400,2),(1184,2088662400,1),(1184,2109222000,2),(1184,2120112000,1),(1184,2140671600,2),(1185,-2147483648,1),(1185,-1946918424,2),(1186,-2147483648,2),(1186,-1633280400,1),(1186,-1615140000,2),(1186,-1601830800,1),(1186,-1583690400,2),(1186,-1570381200,1),(1186,-1551636000,2),(1186,-1536512400,1),(1186,-1523210400,2),(1186,-1504458000,1),(1186,-1491760800,2),(1186,-1473008400,1),(1186,-1459706400,2),(1186,-1441558800,1),(1186,-1428256800,2),(1186,-1410109200,1),(1186,-1396807200,2),(1186,-1378659600,1),(1186,-1365357600,2),(1186,-1347210000,1),(1186,-1333908000,2),(1186,-1315155600,1),(1186,-1301853600,2),(1186,-1283706000,1),(1186,-1270404000,2),(1186,-1252256400,1),(1186,-1238954400,2),(1186,-1220806800,1),(1186,-1207504800,2),(1186,-1189357200,1),(1186,-1176055200,2),(1186,-1157302800,1),(1186,-1144605600,2),(1186,-1125853200,1),(1186,-1112551200,2),(1186,-1094403600,1),(1186,-1081101600,2),(1186,-1062954000,1),(1186,-1049652000,2),(1186,-1031504400,1),(1186,-1018202400,2),(1186,-1000054800,1),(1186,-986752800,2),(1186,-968000400,1),(1186,-955303200,2),(1186,-936550800,1),(1186,-923248800,2),(1186,-905101200,1),(1186,-891799200,2),(1186,-880218000,3),(1186,-769395600,4),(1186,-765396000,2),(1186,-747248400,1),(1186,-733946400,2),(1186,-715798800,1),(1186,-702496800,2),(1186,-684349200,1),(1186,-671047200,2),(1186,-652899600,1),(1186,-639597600,2),(1186,-620845200,1),(1186,-608148000,2),(1186,-589395600,1),(1186,-576093600,2),(1186,-557946000,1),(1186,-544644000,2),(1186,-526496400,1),(1186,-513194400,2),(1186,-495046800,1),(1186,-481744800,2),(1186,-463597200,1),(1186,-447271200,2),(1186,-431542800,1),(1186,-415821600,2),(1186,-400093200,1),(1186,-384372000,2),(1186,-368643600,1),(1186,-352922400,2),(1186,-337194000,1),(1186,-321472800,2),(1186,-305744400,1),(1186,-289418400,2),(1186,-273690000,1),(1186,-257968800,2),(1186,-242240400,1),(1186,-226519200,2),(1186,-210790800,1),(1186,-195069600,2),(1186,-179341200,1),(1186,-163620000,2),(1186,-147891600,1),(1186,-131565600,2),(1186,-116442000,1),(1186,-100116000,2),(1186,-84387600,1),(1186,-68666400,2),(1186,-52938000,1),(1186,-37216800,2),(1186,-21488400,1),(1186,-5767200,2),(1186,9961200,1),(1186,25682400,2),(1186,41410800,1),(1186,57736800,2),(1186,73465200,1),(1186,89186400,2),(1186,104914800,1),(1186,120636000,2),(1186,126687600,1),(1186,152085600,2),(1186,162370800,1),(1186,183535200,2),(1186,199263600,1),(1186,215589600,2),(1186,230713200,1),(1186,247039200,2),(1186,262767600,1),(1186,278488800,2),(1186,294217200,1),(1186,309938400,2),(1186,325666800,1),(1186,341388000,2),(1186,357116400,1),(1186,372837600,2),(1186,388566000,1),(1186,404892000,2),(1186,420015600,1),(1186,436341600,2),(1186,452070000,1),(1186,467791200,2),(1186,483519600,1),(1186,499240800,2),(1186,514969200,1),(1186,530690400,2),(1186,544604400,1),(1186,562140000,2),(1186,576054000,1),(1186,594194400,2),(1186,607503600,1),(1186,625644000,2),(1186,638953200,1),(1186,657093600,2),(1186,671007600,1),(1186,688543200,2),(1186,702457200,1),(1186,719992800,2),(1186,733906800,1),(1186,752047200,2),(1186,765356400,1),(1186,783496800,2),(1186,796806000,1),(1186,814946400,2),(1186,828860400,1),(1186,846396000,2),(1186,860310000,1),(1186,877845600,2),(1186,891759600,1),(1186,909295200,2),(1186,923209200,1),(1186,941349600,2),(1186,954658800,1),(1186,972799200,2),(1186,986108400,1),(1186,1004248800,2),(1186,1018162800,1),(1186,1035698400,2),(1186,1049612400,1),(1186,1067148000,2),(1186,1081062000,1),(1186,1099202400,2),(1186,1112511600,1),(1186,1130652000,2),(1186,1143961200,1),(1186,1162101600,2),(1186,1173596400,1),(1186,1194156000,2),(1186,1205046000,1),(1186,1225605600,2),(1186,1236495600,1),(1186,1257055200,2),(1186,1268550000,1),(1186,1289109600,2),(1186,1299999600,1),(1186,1320559200,2),(1186,1331449200,1),(1186,1352008800,2),(1186,1362898800,1),(1186,1383458400,2),(1186,1394348400,1),(1186,1414908000,2),(1186,1425798000,1),(1186,1446357600,2),(1186,1457852400,1),(1186,1478412000,2),(1186,1489302000,1),(1186,1509861600,2),(1186,1520751600,1),(1186,1541311200,2),(1186,1552201200,1),(1186,1572760800,2),(1186,1583650800,1),(1186,1604210400,2),(1186,1615705200,1),(1186,1636264800,2),(1186,1647154800,1),(1186,1667714400,2),(1186,1678604400,1),(1186,1699164000,2),(1186,1710054000,1),(1186,1730613600,2),(1186,1741503600,1),(1186,1762063200,2),(1186,1772953200,1),(1186,1793512800,2),(1186,1805007600,1),(1186,1825567200,2),(1186,1836457200,1),(1186,1857016800,2),(1186,1867906800,1),(1186,1888466400,2),(1186,1899356400,1),(1186,1919916000,2),(1186,1930806000,1),(1186,1951365600,2),(1186,1962860400,1),(1186,1983420000,2),(1186,1994310000,1),(1186,2014869600,2),(1186,2025759600,1),(1186,2046319200,2),(1186,2057209200,1),(1186,2077768800,2),(1186,2088658800,1),(1186,2109218400,2),(1186,2120108400,1),(1186,2140668000,2),(1187,-2147483648,1),(1187,-1157283000,2),(1187,-1155436200,1),(1187,-880198200,3),(1187,-769395600,4),(1187,-765376200,1),(1187,-712150200,5),(1188,-2147483648,2),(1188,-1633273200,1),(1188,-1615132800,2),(1188,-1601823600,1),(1188,-1583683200,2),(1188,-880210800,3),(1188,-820519140,2),(1188,-812653140,3),(1188,-796845540,2),(1188,-84380400,1),(1188,-68659200,2),(1189,-2147483648,2),(1189,-1633273200,1),(1189,-1615132800,2),(1189,-1601823600,1),(1189,-1583683200,2),(1189,-1570374000,1),(1189,-1551628800,2),(1189,-1538924400,1),(1189,-1534089600,2),(1189,-880210800,3),(1189,-769395600,4),(1189,-765388800,2),(1189,-147884400,1),(1189,-131558400,2),(1189,-116434800,1),(1189,-100108800,2),(1189,-84380400,1),(1189,-68659200,2),(1189,-52930800,1),(1189,-37209600,2),(1189,-21481200,1),(1189,-5760000,2),(1189,9968400,1),(1189,25689600,2),(1189,41418000,1),(1189,57744000,2),(1189,73472400,1),(1189,89193600,2),(1189,104922000,1),(1189,120643200,2),(1189,126694800,1),(1189,152092800,2),(1189,162378000,1),(1189,183542400,2),(1189,199270800,1),(1189,215596800,2),(1189,230720400,1),(1189,247046400,2),(1189,262774800,1),(1189,278496000,2),(1189,294224400,1),(1189,309945600,2),(1189,325674000,1),(1189,341395200,2),(1189,357123600,1),(1189,372844800,2),(1189,388573200,1),(1189,404899200,2),(1189,420022800,1),(1189,436348800,2),(1189,452077200,1),(1189,467798400,2),(1189,483526800,1),(1189,499248000,2),(1189,514976400,1),(1189,530697600,2),(1189,544611600,1),(1189,562147200,2),(1189,576061200,1),(1189,594201600,2),(1189,607510800,1),(1189,625651200,2),(1189,638960400,1),(1189,657100800,2),(1189,671014800,1),(1189,688550400,2),(1189,702464400,1),(1189,720000000,2),(1189,733914000,1),(1189,752054400,2),(1189,765363600,1),(1189,783504000,2),(1189,796813200,1),(1189,814953600,2),(1189,828867600,1),(1189,846403200,2),(1189,860317200,1),(1189,877852800,2),(1189,891766800,1),(1189,909302400,2),(1189,923216400,1),(1189,941356800,2),(1189,954666000,1),(1189,972806400,2),(1189,986115600,1),(1189,1004256000,2),(1189,1018170000,1),(1189,1035705600,2),(1189,1049619600,1),(1189,1067155200,2),(1189,1081069200,1),(1189,1099209600,2),(1189,1112518800,1),(1189,1130659200,2),(1189,1143968400,1),(1189,1162108800,2),(1189,1173603600,1),(1189,1194163200,2),(1189,1205053200,1),(1189,1225612800,2),(1189,1236502800,1),(1189,1257062400,2),(1189,1268557200,1),(1189,1289116800,2),(1189,1300006800,1),(1189,1320566400,2),(1189,1331456400,1),(1189,1352016000,2),(1189,1362906000,1),(1189,1383465600,2),(1189,1394355600,1),(1189,1414915200,2),(1189,1425805200,1),(1189,1446364800,2),(1189,1457859600,1),(1189,1478419200,2),(1189,1489309200,1),(1189,1509868800,2),(1189,1520758800,1),(1189,1541318400,2),(1189,1552208400,1),(1189,1572768000,2),(1189,1583658000,1),(1189,1604217600,2),(1189,1615712400,1),(1189,1636272000,2),(1189,1647162000,1),(1189,1667721600,2),(1189,1678611600,1),(1189,1699171200,2),(1189,1710061200,1),(1189,1730620800,2),(1189,1741510800,1),(1189,1762070400,2),(1189,1772960400,1),(1189,1793520000,2),(1189,1805014800,1),(1189,1825574400,2),(1189,1836464400,1),(1189,1857024000,2),(1189,1867914000,1),(1189,1888473600,2),(1189,1899363600,1),(1189,1919923200,2),(1189,1930813200,1),(1189,1951372800,2),(1189,1962867600,1),(1189,1983427200,2),(1189,1994317200,1),(1189,2014876800,2),(1189,2025766800,1),(1189,2046326400,2),(1189,2057216400,1),(1189,2077776000,2),(1189,2088666000,1),(1189,2109225600,2),(1189,2120115600,1),(1189,2140675200,2),(1190,-2147483648,1),(1190,893665800,2),(1190,2147483647,2),(1191,-2147483648,2),(1191,-1633269600,1),(1191,-1615129200,2),(1191,-1601820000,1),(1191,-1583679600,2),(1191,-880207200,3),(1191,-769395600,4),(1191,-765385200,2),(1191,-687967140,1),(1191,-662655600,2),(1191,-620838000,1),(1191,-608137200,2),(1191,-589388400,1),(1191,-576082800,2),(1191,-557938800,1),(1191,-544633200,2),(1191,-526489200,1),(1191,-513183600,2),(1191,-495039600,1),(1191,-481734000,2),(1191,-463590000,1),(1191,-450284400,2),(1191,-431535600,1),(1191,-418230000,2),(1191,-400086000,1),(1191,-386780400,2),(1191,-368636400,1),(1191,-355330800,2),(1191,-337186800,1),(1191,-323881200,2),(1191,-305737200,1),(1191,-292431600,2),(1191,-273682800,1),(1191,-260982000,2),(1191,-242233200,1),(1191,-226508400,2),(1191,-210783600,1),(1191,-195058800,2),(1191,-179334000,1),(1191,-163609200,2),(1191,-147884400,1),(1191,-131554800,2),(1191,-116434800,1),(1191,-100105200,2),(1191,-84376800,1),(1191,-68655600,2),(1191,-52927200,1),(1191,-37206000,2),(1191,-21477600,1),(1191,-5756400,2),(1191,9972000,1),(1191,25693200,2),(1191,41421600,1),(1191,57747600,2),(1191,73476000,1),(1191,89197200,2),(1191,104925600,1),(1191,120646800,2),(1191,126698400,1),(1191,152096400,2),(1191,162381600,1),(1191,183546000,2),(1191,199274400,1),(1191,215600400,2),(1191,230724000,1),(1191,247050000,2),(1191,262778400,1),(1191,278499600,2),(1191,294228000,1),(1191,309949200,2),(1191,325677600,1),(1191,341398800,2),(1191,357127200,1),(1191,372848400,2),(1191,388576800,1),(1191,404902800,2),(1191,420026400,1),(1191,436352400,2),(1191,452080800,1),(1191,467802000,2),(1191,483530400,1),(1191,499251600,2),(1191,514980000,1),(1191,530701200,2),(1191,544615200,1),(1191,562150800,2),(1191,576064800,1),(1191,594205200,2),(1191,607514400,1),(1191,625654800,2),(1191,638964000,1),(1191,657104400,2),(1191,671018400,1),(1191,688554000,2),(1191,702468000,1),(1191,720003600,2),(1191,733917600,1),(1191,752058000,2),(1191,765367200,1),(1191,783507600,2),(1191,796816800,1),(1191,814957200,2),(1191,828871200,1),(1191,846406800,2),(1191,860320800,1),(1191,877856400,2),(1191,891770400,1),(1191,909306000,2),(1191,923220000,1),(1191,941360400,2),(1191,954669600,1),(1191,972810000,2),(1191,986119200,1),(1191,1004259600,2),(1191,1018173600,1),(1191,1035709200,2),(1191,1049623200,1),(1191,1067158800,2),(1191,1081072800,1),(1191,1099213200,2),(1191,1112522400,1),(1191,1130662800,2),(1191,1143972000,1),(1191,1162112400,2),(1191,1173607200,1),(1191,1194166800,2),(1191,1205056800,1),(1191,1225616400,2),(1191,1236506400,1),(1191,1257066000,2),(1191,1268560800,1),(1191,1289120400,2),(1191,1300010400,1),(1191,1320570000,2),(1191,1331460000,1),(1191,1352019600,2),(1191,1362909600,1),(1191,1383469200,2),(1191,1394359200,1),(1191,1414918800,2),(1191,1425808800,1),(1191,1446368400,2),(1191,1457863200,1),(1191,1478422800,2),(1191,1489312800,1),(1191,1509872400,2),(1191,1520762400,1),(1191,1541322000,2),(1191,1552212000,1),(1191,1572771600,2),(1191,1583661600,1),(1191,1604221200,2),(1191,1615716000,1),(1191,1636275600,2),(1191,1647165600,1),(1191,1667725200,2),(1191,1678615200,1),(1191,1699174800,2),(1191,1710064800,1),(1191,1730624400,2),(1191,1741514400,1),(1191,1762074000,2),(1191,1772964000,1),(1191,1793523600,2),(1191,1805018400,1),(1191,1825578000,2),(1191,1836468000,1),(1191,1857027600,2),(1191,1867917600,1),(1191,1888477200,2),(1191,1899367200,1),(1191,1919926800,2),(1191,1930816800,1),(1191,1951376400,2),(1191,1962871200,1),(1191,1983430800,2),(1191,1994320800,1),(1191,2014880400,2),(1191,2025770400,1),(1191,2046330000,2),(1191,2057220000,1),(1191,2077779600,2),(1191,2088669600,1),(1191,2109229200,2),(1191,2120119200,1),(1191,2140678800,2),(1192,-2147483648,0),(1192,-1806678012,1),(1192,2147483647,1),(1193,-2147483648,1),(1193,-880200000,2),(1193,-769395600,3),(1193,-765378000,1),(1193,-86882400,4),(1193,-21470400,5),(1193,-5749200,4),(1193,9979200,5),(1193,25700400,4),(1193,41428800,5),(1193,57754800,4),(1193,73483200,5),(1193,89204400,4),(1193,104932800,5),(1193,120654000,4),(1193,126705600,5),(1193,152103600,4),(1193,162388800,5),(1193,183553200,4),(1193,199281600,5),(1193,215607600,4),(1193,230731200,5),(1193,247057200,4),(1193,262785600,5),(1193,278506800,4),(1193,294235200,5),(1193,309956400,4),(1193,325684800,5),(1193,341406000,4),(1193,357134400,5),(1193,372855600,4),(1193,388584000,5),(1193,404910000,4),(1193,420033600,5),(1193,436359600,6),(1193,439030800,8),(1193,452084400,7),(1193,467805600,8),(1193,483534000,7),(1193,499255200,8),(1193,514983600,7),(1193,530704800,8),(1193,544618800,7),(1193,562154400,8),(1193,576068400,7),(1193,594208800,8),(1193,607518000,7),(1193,625658400,8),(1193,638967600,7),(1193,657108000,8),(1193,671022000,7),(1193,688557600,8),(1193,702471600,7),(1193,720007200,8),(1193,733921200,7),(1193,752061600,8),(1193,765370800,7),(1193,783511200,8),(1193,796820400,7),(1193,814960800,8),(1193,828874800,7),(1193,846410400,8),(1193,860324400,7),(1193,877860000,8),(1193,891774000,7),(1193,909309600,8),(1193,923223600,7),(1193,941364000,8),(1193,954673200,7),(1193,972813600,8),(1193,986122800,7),(1193,1004263200,8),(1193,1018177200,7),(1193,1035712800,8),(1193,1049626800,7),(1193,1067162400,8),(1193,1081076400,7),(1193,1099216800,8),(1193,1112526000,7),(1193,1130666400,8),(1193,1143975600,7),(1193,1162116000,8),(1193,1173610800,7),(1193,1194170400,8),(1193,1205060400,7),(1193,1225620000,8),(1193,1236510000,7),(1193,1257069600,8),(1193,1268564400,7),(1193,1289124000,8),(1193,1300014000,7),(1193,1320573600,8),(1193,1331463600,7),(1193,1352023200,8),(1193,1362913200,7),(1193,1383472800,8),(1193,1394362800,7),(1193,1414922400,8),(1193,1425812400,7),(1193,1446372000,8),(1193,1457866800,7),(1193,1478426400,8),(1193,1489316400,7),(1193,1509876000,8),(1193,1520766000,7),(1193,1541325600,8),(1193,1552215600,7),(1193,1572775200,8),(1193,1583665200,7),(1193,1604224800,8),(1193,1615719600,7),(1193,1636279200,8),(1193,1647169200,7),(1193,1667728800,8),(1193,1678618800,7),(1193,1699178400,8),(1193,1710068400,7),(1193,1730628000,8),(1193,1741518000,7),(1193,1762077600,8),(1193,1772967600,7),(1193,1793527200,8),(1193,1805022000,7),(1193,1825581600,8),(1193,1836471600,7),(1193,1857031200,8),(1193,1867921200,7),(1193,1888480800,8),(1193,1899370800,7),(1193,1919930400,8),(1193,1930820400,7),(1193,1951380000,8),(1193,1962874800,7),(1193,1983434400,8),(1193,1994324400,7),(1193,2014884000,8),(1193,2025774000,7),(1193,2046333600,8),(1193,2057223600,7),(1193,2077783200,8),(1193,2088673200,7),(1193,2109232800,8),(1193,2120122800,7),(1193,2140682400,8),(1194,-2147483648,1),(1194,-1869875816,3),(1194,-1693706400,2),(1194,-1680490800,3),(1194,-1570413600,2),(1194,-1552186800,3),(1194,-1538359200,2),(1194,-1522551600,3),(1194,-1507514400,2),(1194,-1490583600,3),(1194,-1440208800,2),(1194,-1428030000,3),(1194,-1409709600,2),(1194,-1396494000,3),(1194,-931140000,2),(1194,-922762800,3),(1194,-917834400,2),(1194,-892436400,3),(1194,-875844000,2),(1194,-857358000,3),(1194,-781063200,2),(1194,-764737200,3),(1194,-744343200,2),(1194,-733806000,3),(1194,-716436000,2),(1194,-701924400,3),(1194,-684986400,2),(1194,-670474800,3),(1194,-654141600,2),(1194,-639025200,3),(1194,-621828000,2),(1194,-606970800,3),(1194,-590032800,2),(1194,-575434800,3),(1194,-235620000,2),(1194,-228279600,3),(1194,-177732000,2),(1194,-165726000,3),(1194,10533600,2),(1194,23835600,3),(1194,41983200,2),(1194,55285200,3),(1194,74037600,2),(1194,87339600,3),(1194,107910000,2),(1194,121219200,3),(1194,133920000,2),(1194,152676000,3),(1194,165362400,2),(1194,183502800,3),(1194,202428000,2),(1194,215557200,3),(1194,228866400,2),(1194,245797200,3),(1194,260316000,2),(1194,277246800,4),(1194,308779200,5),(1194,323827200,4),(1194,340228800,5),(1194,354672000,4),(1194,371678400,5),(1194,386121600,4),(1194,403128000,5),(1194,428446800,4),(1194,433886400,5),(1194,482792400,2),(1194,496702800,3),(1194,512521200,6),(1194,528246000,7),(1194,543970800,6),(1194,559695600,7),(1194,575420400,6),(1194,591145200,7),(1194,606870000,6),(1194,622594800,7),(1194,638319600,6),(1194,654649200,7),(1194,670374000,6),(1194,686098800,7),(1194,701823600,6),(1194,717548400,7),(1194,733273200,6),(1194,748998000,7),(1194,764118000,6),(1194,780447600,7),(1194,796172400,6),(1194,811897200,7),(1194,828226800,6),(1194,846370800,7),(1194,859676400,6),(1194,877820400,7),(1194,891126000,6),(1194,909270000,7),(1194,922575600,6),(1194,941324400,7),(1194,954025200,6),(1194,972774000,7),(1194,985474800,6),(1194,1004223600,7),(1194,1017529200,6),(1194,1035673200,7),(1194,1048978800,6),(1194,1067122800,7),(1194,1080428400,6),(1194,1099177200,7),(1194,1111878000,6),(1194,1130626800,7),(1194,1143327600,6),(1194,1162076400,7),(1194,1167602400,3),(1194,1174784400,8),(1194,1193533200,9),(1194,1206838800,8),(1194,1224982800,9),(1194,1238288400,8),(1194,1256432400,9),(1194,1269738000,8),(1194,1288486800,9),(1194,1301274000,8),(1194,1319936400,9),(1194,1332637200,8),(1194,1351386000,9),(1194,1364691600,8),(1194,1382835600,9),(1194,1396227600,8),(1194,1414285200,9),(1194,1427590800,8),(1194,1446944400,9),(1194,1459040400,8),(1194,1473195600,5),(1194,2147483647,5),(1196,-2147483648,1),(1196,-880200000,2),(1196,-769395600,3),(1196,-765378000,1),(1196,-86882400,4),(1196,-21470400,5),(1196,-5749200,4),(1196,9979200,5),(1196,25700400,4),(1196,41428800,5),(1196,57754800,4),(1196,73483200,5),(1196,89204400,4),(1196,104932800,5),(1196,120654000,4),(1196,126705600,5),(1196,152103600,4),(1196,162388800,5),(1196,183553200,4),(1196,199281600,5),(1196,215607600,4),(1196,230731200,5),(1196,247057200,4),(1196,262785600,5),(1196,278506800,4),(1196,294235200,5),(1196,309956400,4),(1196,325684800,5),(1196,341406000,4),(1196,357134400,5),(1196,372855600,4),(1196,388584000,5),(1196,404910000,4),(1196,420033600,5),(1196,436359600,6),(1196,439030800,8),(1196,452084400,7),(1196,467805600,8),(1196,483534000,7),(1196,499255200,8),(1196,514983600,7),(1196,530704800,8),(1196,544618800,7),(1196,562154400,8),(1196,576068400,7),(1196,594208800,8),(1196,607518000,7),(1196,625658400,8),(1196,638967600,7),(1196,657108000,8),(1196,671022000,7),(1196,688557600,8),(1196,702471600,7),(1196,720007200,8),(1196,733921200,7),(1196,752061600,8),(1196,765370800,7),(1196,783511200,8),(1196,796820400,7),(1196,814960800,8),(1196,828874800,7),(1196,846410400,8),(1196,860324400,7),(1196,877860000,8),(1196,891774000,7),(1196,909309600,8),(1196,923223600,7),(1196,941364000,8),(1196,954673200,7),(1196,972813600,8),(1196,986122800,7),(1196,1004263200,8),(1196,1018177200,7),(1196,1035712800,8),(1196,1049626800,7),(1196,1067162400,8),(1196,1081076400,7),(1196,1099216800,8),(1196,1112526000,7),(1196,1130666400,8),(1196,1143975600,7),(1196,1162116000,8),(1196,1173610800,7),(1196,1194170400,8),(1196,1205060400,7),(1196,1225620000,8),(1196,1236510000,7),(1196,1257069600,8),(1196,1268564400,7),(1196,1289124000,8),(1196,1300014000,7),(1196,1320573600,8),(1196,1331463600,7),(1196,1352023200,8),(1196,1362913200,7),(1196,1383472800,8),(1196,1394362800,7),(1196,1414922400,8),(1196,1425812400,7),(1196,1446372000,8),(1196,1457866800,7),(1196,1478426400,8),(1196,1489316400,7),(1196,1509876000,8),(1196,1520766000,7),(1196,1541325600,8),(1196,1552215600,7),(1196,1572775200,8),(1196,1583665200,7),(1196,1604224800,8),(1196,1615719600,7),(1196,1636279200,8),(1196,1647169200,7),(1196,1667728800,8),(1196,1678618800,7),(1196,1699178400,8),(1196,1710068400,7),(1196,1730628000,8),(1196,1741518000,7),(1196,1762077600,8),(1196,1772967600,7),(1196,1793527200,8),(1196,1805022000,7),(1196,1825581600,8),(1196,1836471600,7),(1196,1857031200,8),(1196,1867921200,7),(1196,1888480800,8),(1196,1899370800,7),(1196,1919930400,8),(1196,1930820400,7),(1196,1951380000,8),(1196,1962874800,7),(1196,1983434400,8),(1196,1994324400,7),(1196,2014884000,8),(1196,2025774000,7),(1196,2046333600,8),(1196,2057223600,7),(1196,2077783200,8),(1196,2088673200,7),(1196,2109232800,8),(1196,2120122800,7),(1196,2140682400,8),(1197,-2147483648,1),(1197,-880196400,2),(1197,-769395600,3),(1197,-765374400,1),(1197,-86878800,4),(1197,-21466800,5),(1197,-5745600,4),(1197,9982800,5),(1197,25704000,4),(1197,41432400,5),(1197,57758400,4),(1197,73486800,5),(1197,89208000,4),(1197,104936400,5),(1197,120657600,4),(1197,126709200,5),(1197,152107200,4),(1197,162392400,5),(1197,183556800,4),(1197,199285200,5),(1197,215611200,4),(1197,230734800,5),(1197,247060800,4),(1197,262789200,5),(1197,278510400,4),(1197,294238800,5),(1197,309960000,4),(1197,325688400,5),(1197,341409600,4),(1197,357138000,5),(1197,372859200,4),(1197,388587600,5),(1197,404913600,4),(1197,420037200,5),(1197,436363200,6),(1197,439034400,8),(1197,452088000,7),(1197,467809200,8),(1197,483537600,7),(1197,499258800,8),(1197,514987200,7),(1197,530708400,8),(1197,544622400,7),(1197,562158000,8),(1197,576072000,7),(1197,594212400,8),(1197,607521600,7),(1197,625662000,8),(1197,638971200,7),(1197,657111600,8),(1197,671025600,7),(1197,688561200,8),(1197,702475200,7),(1197,720010800,8),(1197,733924800,7),(1197,752065200,8),(1197,765374400,7),(1197,783514800,8),(1197,796824000,7),(1197,814964400,8),(1197,828878400,7),(1197,846414000,8),(1197,860328000,7),(1197,877863600,8),(1197,891777600,7),(1197,909313200,8),(1197,923227200,7),(1197,941367600,8),(1197,954676800,7),(1197,972817200,8),(1197,986126400,7),(1197,1004266800,8),(1197,1018180800,7),(1197,1035716400,8),(1197,1049630400,7),(1197,1067166000,8),(1197,1081080000,7),(1197,1099220400,8),(1197,1112529600,7),(1197,1130670000,8),(1197,1143979200,7),(1197,1162119600,8),(1197,1173614400,7),(1197,1194174000,8),(1197,1205064000,7),(1197,1225623600,8),(1197,1236513600,7),(1197,1257073200,8),(1197,1268568000,7),(1197,1289127600,8),(1197,1300017600,7),(1197,1320577200,8),(1197,1331467200,7),(1197,1352026800,8),(1197,1362916800,7),(1197,1383476400,8),(1197,1394366400,7),(1197,1414926000,8),(1197,1425816000,7),(1197,1446375600,8),(1197,1457870400,7),(1197,1478430000,8),(1197,1489320000,7),(1197,1509879600,8),(1197,1520769600,7),(1197,1541329200,8),(1197,1552219200,7),(1197,1572778800,8),(1197,1583668800,7),(1197,1604228400,8),(1197,1615723200,7),(1197,1636282800,8),(1197,1647172800,7),(1197,1667732400,8),(1197,1678622400,7),(1197,1699182000,8),(1197,1710072000,7),(1197,1730631600,8),(1197,1741521600,7),(1197,1762081200,8),(1197,1772971200,7),(1197,1793530800,8),(1197,1805025600,7),(1197,1825585200,8),(1197,1836475200,7),(1197,1857034800,8),(1197,1867924800,7),(1197,1888484400,8),(1197,1899374400,7),(1197,1919934000,8),(1197,1930824000,7),(1197,1951383600,8),(1197,1962878400,7),(1197,1983438000,8),(1197,1994328000,7),(1197,2014887600,8),(1197,2025777600,7),(1197,2046337200,8),(1197,2057227200,7),(1197,2077786800,8),(1197,2088676800,7),(1197,2109236400,8),(1197,2120126400,7),(1197,2140686000,8),(1198,-2147483648,2),(1198,-1633273200,1),(1198,-1615132800,2),(1198,-1601823600,1),(1198,-1583683200,2),(1198,-880210800,3),(1198,-820519140,2),(1198,-812653140,3),(1198,-796845540,2),(1198,-84380400,1),(1198,-68659200,2),(1199,-2147483648,2),(1199,-1633276800,1),(1199,-1615136400,2),(1199,-1601827200,1),(1199,-1583686800,2),(1199,-1563724800,1),(1199,-1551632400,2),(1199,-1538928000,1),(1199,-1520182800,2),(1199,-1504454400,1),(1199,-1491757200,2),(1199,-1473004800,1),(1199,-1459702800,2),(1199,-1441555200,1),(1199,-1428253200,2),(1199,-1410105600,1),(1199,-1396803600,2),(1199,-1378656000,1),(1199,-1365354000,2),(1199,-1347206400,1),(1199,-1333904400,2),(1199,-1315152000,1),(1199,-1301850000,2),(1199,-1283702400,1),(1199,-1270400400,2),(1199,-1252252800,1),(1199,-1238950800,2),(1199,-1220803200,1),(1199,-1207501200,2),(1199,-1189353600,1),(1199,-1176051600,2),(1199,-1157299200,1),(1199,-1144602000,2),(1199,-1125849600,1),(1199,-1112547600,2),(1199,-1094400000,1),(1199,-1081098000,2),(1199,-1067788800,3),(1199,-1045414800,2),(1199,-1031500800,1),(1199,-1018198800,2),(1199,-1000051200,1),(1199,-986749200,2),(1199,-967996800,1),(1199,-955299600,2),(1199,-936547200,1),(1199,-923245200,2),(1199,-905097600,1),(1199,-891795600,2),(1199,-880214400,4),(1199,-769395600,5),(1199,-765392400,2),(1199,-747244800,1),(1199,-733942800,2),(1199,-715795200,1),(1199,-702493200,2),(1199,-684345600,1),(1199,-671043600,2),(1199,-652896000,1),(1199,-639594000,2),(1199,-620841600,1),(1199,-608144400,2),(1199,-589392000,1),(1199,-576090000,2),(1199,-557942400,1),(1199,-544640400,2),(1199,-526492800,1),(1199,-513190800,2),(1199,-495043200,1),(1199,-481741200,2),(1199,-463593600,1),(1199,-447267600,2),(1199,-431539200,1),(1199,-415818000,2),(1199,-400089600,1),(1199,-384368400,2),(1199,-368640000,1),(1199,-352918800,2),(1199,-337190400,1),(1199,-321469200,2),(1199,-305740800,1),(1199,-289414800,2),(1199,-273686400,1),(1199,-257965200,2),(1199,-242236800,1),(1199,-226515600,2),(1199,-210787200,1),(1199,-195066000,2),(1199,-179337600,1),(1199,-163616400,2),(1199,-147888000,1),(1199,-131562000,2),(1199,-116438400,1),(1199,-100112400,2),(1199,-84384000,1),(1199,-68662800,2),(1199,-52934400,1),(1199,-37213200,2),(1199,-21484800,1),(1199,-5763600,2),(1199,9964800,1),(1199,25686000,2),(1199,41414400,1),(1199,57740400,2),(1199,73468800,1),(1199,89190000,2),(1199,104918400,1),(1199,120639600,2),(1199,126691200,1),(1199,152089200,2),(1199,162374400,1),(1199,183538800,2),(1199,199267200,1),(1199,215593200,2),(1199,230716800,1),(1199,247042800,2),(1199,262771200,1),(1199,278492400,2),(1199,294220800,1),(1199,309942000,2),(1199,325670400,1),(1199,341391600,2),(1199,357120000,1),(1199,372841200,2),(1199,388569600,1),(1199,404895600,2),(1199,420019200,1),(1199,436345200,2),(1199,452073600,1),(1199,467794800,2),(1199,483523200,1),(1199,499244400,2),(1199,514972800,1),(1199,530694000,2),(1199,544608000,1),(1199,562143600,2),(1199,576057600,1),(1199,594198000,2),(1199,607507200,1),(1199,625647600,2),(1199,638956800,1),(1199,657097200,2),(1199,671011200,1),(1199,688546800,2),(1199,702460800,1),(1199,719996400,2),(1199,733910400,1),(1199,752050800,2),(1199,765360000,1),(1199,783500400,2),(1199,796809600,1),(1199,814950000,2),(1199,828864000,1),(1199,846399600,2),(1199,860313600,1),(1199,877849200,2),(1199,891763200,1),(1199,909298800,2),(1199,923212800,1),(1199,941353200,2),(1199,954662400,1),(1199,972802800,2),(1199,986112000,1),(1199,1004252400,2),(1199,1018166400,1),(1199,1035702000,2),(1199,1049616000,1),(1199,1067151600,2),(1199,1081065600,1),(1199,1099206000,2),(1199,1112515200,1),(1199,1130655600,2),(1199,1143964800,1),(1199,1162105200,2),(1199,1173600000,1),(1199,1194159600,2),(1199,1205049600,1),(1199,1225609200,2),(1199,1236499200,1),(1199,1257058800,2),(1199,1268553600,1),(1199,1289113200,2),(1199,1300003200,1),(1199,1320562800,2),(1199,1331452800,1),(1199,1352012400,2),(1199,1362902400,1),(1199,1383462000,2),(1199,1394352000,1),(1199,1414911600,2),(1199,1425801600,1),(1199,1446361200,2),(1199,1457856000,1),(1199,1478415600,2),(1199,1489305600,1),(1199,1509865200,2),(1199,1520755200,1),(1199,1541314800,2),(1199,1552204800,1),(1199,1572764400,2),(1199,1583654400,1),(1199,1604214000,2),(1199,1615708800,1),(1199,1636268400,2),(1199,1647158400,1),(1199,1667718000,2),(1199,1678608000,1),(1199,1699167600,2),(1199,1710057600,1),(1199,1730617200,2),(1199,1741507200,1),(1199,1762066800,2),(1199,1772956800,1),(1199,1793516400,2),(1199,1805011200,1),(1199,1825570800,2),(1199,1836460800,1),(1199,1857020400,2),(1199,1867910400,1),(1199,1888470000,2),(1199,1899360000,1),(1199,1919919600,2),(1199,1930809600,1),(1199,1951369200,2),(1199,1962864000,1),(1199,1983423600,2),(1199,1994313600,1),(1199,2014873200,2),(1199,2025763200,1),(1199,2046322800,2),(1199,2057212800,1),(1199,2077772400,2),(1199,2088662400,1),(1199,2109222000,2),(1199,2120112000,1),(1199,2140671600,2),(1200,-2147483648,2),(1200,-1633276800,1),(1200,-1615136400,2),(1200,-1601827200,1),(1200,-1583686800,2),(1200,-900259200,1),(1200,-891795600,2),(1200,-880214400,3),(1200,-769395600,4),(1200,-765392400,2),(1200,-747244800,1),(1200,-733942800,2),(1200,-715795200,1),(1200,-702493200,2),(1200,-684345600,1),(1200,-671043600,2),(1200,-652896000,1),(1200,-639594000,2),(1200,-620841600,1),(1200,-608144400,2),(1200,-589392000,1),(1200,-576090000,2),(1200,-557942400,1),(1200,-544640400,2),(1200,-526492800,1),(1200,-513190800,2),(1200,-495043200,1),(1200,-481741200,2),(1200,-463593600,5),(1200,-386787600,2),(1200,-368640000,5),(1200,-21488400,6),(1200,-5767200,5),(1200,9961200,6),(1200,25682400,5),(1200,1143961200,6),(1200,1162101600,5),(1200,1173596400,6),(1200,1194156000,5),(1200,1205046000,6),(1200,1225605600,5),(1200,1236495600,6),(1200,1257055200,5),(1200,1268550000,6),(1200,1289109600,5),(1200,1299999600,6),(1200,1320559200,5),(1200,1331449200,6),(1200,1352008800,5),(1200,1362898800,6),(1200,1383458400,5),(1200,1394348400,6),(1200,1414908000,5),(1200,1425798000,6),(1200,1446357600,5),(1200,1457852400,6),(1200,1478412000,5),(1200,1489302000,6),(1200,1509861600,5),(1200,1520751600,6),(1200,1541311200,5),(1200,1552201200,6),(1200,1572760800,5),(1200,1583650800,6),(1200,1604210400,5),(1200,1615705200,6),(1200,1636264800,5),(1200,1647154800,6),(1200,1667714400,5),(1200,1678604400,6),(1200,1699164000,5),(1200,1710054000,6),(1200,1730613600,5),(1200,1741503600,6),(1200,1762063200,5),(1200,1772953200,6),(1200,1793512800,5),(1200,1805007600,6),(1200,1825567200,5),(1200,1836457200,6),(1200,1857016800,5),(1200,1867906800,6),(1200,1888466400,5),(1200,1899356400,6),(1200,1919916000,5),(1200,1930806000,6),(1200,1951365600,5),(1200,1962860400,6),(1200,1983420000,5),(1200,1994310000,6),(1200,2014869600,5),(1200,2025759600,6),(1200,2046319200,5),(1200,2057209200,6),(1200,2077768800,5),(1200,2088658800,6),(1200,2109218400,5),(1200,2120108400,6),(1200,2140668000,5),(1201,-2147483648,2),(1201,-1633280400,1),(1201,-1615140000,2),(1201,-1601830800,1),(1201,-1583690400,2),(1201,-1570381200,1),(1201,-1551636000,2),(1201,-1536512400,1),(1201,-1523210400,2),(1201,-1504458000,1),(1201,-1491760800,2),(1201,-1473008400,1),(1201,-1459706400,2),(1201,-1441558800,1),(1201,-1428256800,2),(1201,-1410109200,1),(1201,-1396807200,2),(1201,-1378659600,1),(1201,-1365357600,2),(1201,-1347210000,1),(1201,-1333908000,2),(1201,-1315155600,1),(1201,-1301853600,2),(1201,-1283706000,1),(1201,-1270404000,2),(1201,-1252256400,1),(1201,-1238954400,2),(1201,-1220806800,1),(1201,-1207504800,2),(1201,-1189357200,1),(1201,-1176055200,2),(1201,-1157302800,1),(1201,-1144605600,2),(1201,-1125853200,1),(1201,-1112551200,2),(1201,-1094403600,1),(1201,-1081101600,2),(1201,-1062954000,1),(1201,-1049652000,2),(1201,-1031504400,1),(1201,-1018202400,2),(1201,-1000054800,1),(1201,-986752800,2),(1201,-968000400,1),(1201,-955303200,2),(1201,-936550800,1),(1201,-923248800,2),(1201,-905101200,1),(1201,-891799200,2),(1201,-880218000,3),(1201,-769395600,4),(1201,-765396000,2),(1201,-747248400,1),(1201,-733946400,2),(1201,-715798800,1),(1201,-702496800,2),(1201,-684349200,1),(1201,-671047200,2),(1201,-652899600,1),(1201,-639597600,2),(1201,-620845200,1),(1201,-608148000,2),(1201,-589395600,1),(1201,-576093600,2),(1201,-557946000,1),(1201,-544644000,2),(1201,-526496400,1),(1201,-513194400,2),(1201,-495046800,1),(1201,-481744800,2),(1201,-463597200,1),(1201,-447271200,2),(1201,-431542800,1),(1201,-415821600,2),(1201,-400093200,1),(1201,-384372000,2),(1201,-368643600,1),(1201,-352922400,2),(1201,-337194000,1),(1201,-321472800,2),(1201,-305744400,1),(1201,-289418400,2),(1201,-273690000,1),(1201,-257968800,2),(1201,-242240400,1),(1201,-226519200,2),(1201,-210790800,1),(1201,-195069600,2),(1201,-179341200,1),(1201,-163620000,2),(1201,-147891600,1),(1201,-131565600,2),(1201,-116442000,1),(1201,-100116000,2),(1201,-84387600,1),(1201,-68666400,2),(1201,-52938000,1),(1201,-37216800,2),(1201,-21488400,1),(1201,-5767200,2),(1201,9961200,1),(1201,25682400,2),(1201,41410800,1),(1201,57736800,2),(1201,73465200,1),(1201,89186400,2),(1201,104914800,1),(1201,120636000,2),(1201,126687600,1),(1201,152085600,2),(1201,162370800,1),(1201,183535200,2),(1201,199263600,1),(1201,215589600,2),(1201,230713200,1),(1201,247039200,2),(1201,262767600,1),(1201,278488800,2),(1201,294217200,1),(1201,309938400,2),(1201,325666800,1),(1201,341388000,2),(1201,357116400,1),(1201,372837600,2),(1201,388566000,1),(1201,404892000,2),(1201,420015600,1),(1201,436341600,2),(1201,452070000,1),(1201,467791200,2),(1201,483519600,1),(1201,499240800,2),(1201,514969200,1),(1201,530690400,2),(1201,544604400,1),(1201,562140000,2),(1201,576054000,1),(1201,594194400,2),(1201,607503600,1),(1201,625644000,2),(1201,638953200,1),(1201,657093600,2),(1201,671007600,1),(1201,688543200,2),(1201,702457200,1),(1201,719992800,2),(1201,733906800,1),(1201,752047200,2),(1201,765356400,1),(1201,783496800,2),(1201,796806000,1),(1201,814946400,2),(1201,828860400,1),(1201,846396000,2),(1201,860310000,1),(1201,877845600,2),(1201,891759600,1),(1201,909295200,2),(1201,923209200,1),(1201,941349600,2),(1201,954658800,1),(1201,972799200,2),(1201,986108400,1),(1201,1004248800,2),(1201,1018162800,1),(1201,1035698400,2),(1201,1049612400,1),(1201,1067148000,2),(1201,1081062000,1),(1201,1099202400,2),(1201,1112511600,1),(1201,1130652000,2),(1201,1143961200,1),(1201,1162101600,2),(1201,1173596400,1),(1201,1194156000,2),(1201,1205046000,1),(1201,1225605600,2),(1201,1236495600,1),(1201,1257055200,2),(1201,1268550000,1),(1201,1289109600,2),(1201,1299999600,1),(1201,1320559200,2),(1201,1331449200,1),(1201,1352008800,2),(1201,1362898800,1),(1201,1383458400,2),(1201,1394348400,1),(1201,1414908000,2),(1201,1425798000,1),(1201,1446357600,2),(1201,1457852400,1),(1201,1478412000,2),(1201,1489302000,1),(1201,1509861600,2),(1201,1520751600,1),(1201,1541311200,2),(1201,1552201200,1),(1201,1572760800,2),(1201,1583650800,1),(1201,1604210400,2),(1201,1615705200,1),(1201,1636264800,2),(1201,1647154800,1),(1201,1667714400,2),(1201,1678604400,1),(1201,1699164000,2),(1201,1710054000,1),(1201,1730613600,2),(1201,1741503600,1),(1201,1762063200,2),(1201,1772953200,1),(1201,1793512800,2),(1201,1805007600,1),(1201,1825567200,2),(1201,1836457200,1),(1201,1857016800,2),(1201,1867906800,1),(1201,1888466400,2),(1201,1899356400,1),(1201,1919916000,2),(1201,1930806000,1),(1201,1951365600,2),(1201,1962860400,1),(1201,1983420000,2),(1201,1994310000,1),(1201,2014869600,2),(1201,2025759600,1),(1201,2046319200,2),(1201,2057209200,1),(1201,2077768800,2),(1201,2088658800,1),(1201,2109218400,2),(1201,2120108400,1),(1201,2140668000,2),(1202,-2147483648,1),(1202,-1157283000,2),(1202,-1155436200,1),(1202,-880198200,3),(1202,-769395600,4),(1202,-765376200,1),(1202,-712150200,5),(1203,-2147483648,2),(1203,-1633276800,1),(1203,-1615136400,2),(1203,-1601827200,1),(1203,-1583686800,2),(1203,-880214400,3),(1203,-769395600,4),(1203,-765392400,2),(1203,-715795200,1),(1203,-702493200,2),(1203,-684345600,1),(1203,-671043600,2),(1203,-652896000,1),(1203,-639594000,2),(1203,-620841600,1),(1203,-608144400,2),(1203,-589392000,1),(1203,-576090000,2),(1203,-557942400,1),(1203,-544640400,2),(1203,-526492800,1),(1203,-513190800,2),(1203,-495043200,1),(1203,-481741200,2),(1203,-463593600,1),(1203,-447267600,2),(1203,-431539200,1),(1203,-415818000,2),(1203,-400089600,1),(1203,-386787600,2),(1203,-368640000,1),(1203,-355338000,2),(1203,-337190400,1),(1203,-321469200,2),(1203,-305740800,1),(1203,-289414800,2),(1203,-273686400,1),(1203,-257965200,2),(1203,-242236800,5),(1203,-195066000,2),(1203,-84384000,1),(1203,-68662800,2),(1203,-52934400,1),(1203,-37213200,2),(1203,-21484800,1),(1203,-5763600,2),(1203,9964800,1),(1203,25686000,2),(1203,41414400,1),(1203,57740400,2),(1203,73468800,1),(1203,89190000,2),(1203,104918400,1),(1203,120639600,2),(1203,126691200,1),(1203,152089200,2),(1203,162374400,1),(1203,183538800,2),(1203,199267200,1),(1203,215593200,2),(1203,230716800,1),(1203,247042800,2),(1203,262771200,1),(1203,278492400,2),(1203,294220800,1),(1203,309942000,2),(1203,325670400,1),(1203,341391600,2),(1203,357120000,1),(1203,372841200,2),(1203,388569600,1),(1203,404895600,2),(1203,420019200,1),(1203,436345200,2),(1203,452073600,1),(1203,467794800,2),(1203,483523200,1),(1203,499244400,2),(1203,514972800,1),(1203,530694000,2),(1203,544608000,1),(1203,562143600,2),(1203,576057600,1),(1203,594198000,2),(1203,607507200,1),(1203,625647600,2),(1203,638956800,1),(1203,657097200,2),(1203,671011200,1),(1203,688546800,5),(1203,1143961200,1),(1203,1162105200,2),(1203,1173600000,1),(1203,1194159600,2),(1203,1205049600,1),(1203,1225609200,2),(1203,1236499200,1),(1203,1257058800,2),(1203,1268553600,1),(1203,1289113200,2),(1203,1300003200,1),(1203,1320562800,2),(1203,1331452800,1),(1203,1352012400,2),(1203,1362902400,1),(1203,1383462000,2),(1203,1394352000,1),(1203,1414911600,2),(1203,1425801600,1),(1203,1446361200,2),(1203,1457856000,1),(1203,1478415600,2),(1203,1489305600,1),(1203,1509865200,2),(1203,1520755200,1),(1203,1541314800,2),(1203,1552204800,1),(1203,1572764400,2),(1203,1583654400,1),(1203,1604214000,2),(1203,1615708800,1),(1203,1636268400,2),(1203,1647158400,1),(1203,1667718000,2),(1203,1678608000,1),(1203,1699167600,2),(1203,1710057600,1),(1203,1730617200,2),(1203,1741507200,1),(1203,1762066800,2),(1203,1772956800,1),(1203,1793516400,2),(1203,1805011200,1),(1203,1825570800,2),(1203,1836460800,1),(1203,1857020400,2),(1203,1867910400,1),(1203,1888470000,2),(1203,1899360000,1),(1203,1919919600,2),(1203,1930809600,1),(1203,1951369200,2),(1203,1962864000,1),(1203,1983423600,2),(1203,1994313600,1),(1203,2014873200,2),(1203,2025763200,1),(1203,2046322800,2),(1203,2057212800,1),(1203,2077772400,2),(1203,2088662400,1),(1203,2109222000,2),(1203,2120112000,1),(1203,2140671600,2),(1204,-2147483648,0),(1204,-2051202469,1),(1204,-1724083200,2),(1204,-880218000,3),(1204,-769395600,4),(1204,-765396000,2),(1204,-684349200,5),(1204,-671047200,2),(1204,104914800,5),(1204,120636000,2),(1204,126687600,5),(1204,152085600,2),(1204,167814000,5),(1204,183535200,2),(1204,199263600,5),(1204,215589600,2),(1204,230713200,5),(1204,247039200,2),(1204,262767600,5),(1204,278488800,2),(1204,294217200,5),(1204,309938400,2),(1204,325666800,5),(1204,341388000,2),(1204,357116400,5),(1204,372837600,2),(1204,388566000,5),(1204,404892000,2),(1204,420015600,5),(1204,436341600,2),(1204,452070000,5),(1204,467791200,2),(1204,483519600,5),(1204,499240800,2),(1204,514969200,5),(1204,530690400,2),(1204,544604400,5),(1204,562140000,2),(1204,576054000,5),(1204,594194400,2),(1204,607503600,5),(1204,625644000,2),(1204,638953200,5),(1204,657093600,2),(1204,671007600,5),(1204,688543200,2),(1204,702457200,5),(1204,719992800,2),(1204,733906800,5),(1204,752047200,2),(1204,765356400,5),(1204,783496800,2),(1204,796806000,5),(1204,814946400,2),(1204,828860400,5),(1204,846396000,2),(1204,860310000,5),(1204,877845600,2),(1204,891759600,5),(1204,909295200,2),(1204,923209200,5),(1204,941349600,2),(1204,954658800,5),(1204,972799200,2),(1204,986108400,5),(1204,1004248800,2),(1204,1018162800,5),(1204,1035698400,2),(1204,1049612400,5),(1204,1067148000,2),(1204,1081062000,5),(1204,1099202400,2),(1204,1112511600,5),(1204,1130652000,2),(1204,1143961200,5),(1204,1162101600,2),(1204,1173596400,5),(1204,1194156000,2),(1204,1205046000,5),(1204,1225605600,2),(1204,1236495600,5),(1204,1257055200,2),(1204,1268550000,5),(1204,1289109600,2),(1204,1299999600,5),(1204,1320559200,2),(1204,1331449200,5),(1204,1352008800,2),(1204,1362898800,5),(1204,1383458400,2),(1204,1394348400,5),(1204,1414908000,2),(1204,1425798000,5),(1204,1446357600,2),(1204,1457852400,5),(1204,1478412000,2),(1204,1489302000,5),(1204,1509861600,2),(1204,1520751600,5),(1204,1541311200,2),(1204,1552201200,5),(1204,1572760800,2),(1204,1583650800,5),(1204,1604210400,2),(1204,1615705200,5),(1204,1636264800,2),(1204,1647154800,5),(1204,1667714400,2),(1204,1678604400,5),(1204,1699164000,2),(1204,1710054000,5),(1204,1730613600,2),(1204,1741503600,5),(1204,1762063200,2),(1204,1772953200,5),(1204,1793512800,2),(1204,1805007600,5),(1204,1825567200,2),(1204,1836457200,5),(1204,1857016800,2),(1204,1867906800,5),(1204,1888466400,2),(1204,1899356400,5),(1204,1919916000,2),(1204,1930806000,5),(1204,1951365600,2),(1204,1962860400,5),(1204,1983420000,2),(1204,1994310000,5),(1204,2014869600,2),(1204,2025759600,5),(1204,2046319200,2),(1204,2057209200,5),(1204,2077768800,2),(1204,2088658800,5),(1204,2109218400,2),(1204,2120108400,5),(1204,2140668000,2),(1205,-2147483648,2),(1205,-1633273200,1),(1205,-1615132800,2),(1205,-1601823600,1),(1205,-1583683200,2),(1205,-1570374000,1),(1205,-1551628800,2),(1205,-1538924400,1),(1205,-1534089600,2),(1205,-880210800,3),(1205,-769395600,4),(1205,-765388800,2),(1205,-147884400,1),(1205,-131558400,2),(1205,-116434800,1),(1205,-100108800,2),(1205,-84380400,1),(1205,-68659200,2),(1205,-52930800,1),(1205,-37209600,2),(1205,-21481200,1),(1205,-5760000,2),(1205,9968400,1),(1205,25689600,2),(1205,41418000,1),(1205,57744000,2),(1205,73472400,1),(1205,89193600,2),(1205,104922000,1),(1205,120643200,2),(1205,126694800,1),(1205,152092800,2),(1205,162378000,1),(1205,183542400,2),(1205,199270800,1),(1205,215596800,2),(1205,230720400,1),(1205,247046400,2),(1205,262774800,1),(1205,278496000,2),(1205,294224400,1),(1205,309945600,2),(1205,325674000,1),(1205,341395200,2),(1205,357123600,1),(1205,372844800,2),(1205,388573200,1),(1205,404899200,2),(1205,420022800,1),(1205,436348800,2),(1205,452077200,1),(1205,467798400,2),(1205,483526800,1),(1205,499248000,2),(1205,514976400,1),(1205,530697600,2),(1205,544611600,1),(1205,562147200,2),(1205,576061200,1),(1205,594201600,2),(1205,607510800,1),(1205,625651200,2),(1205,638960400,1),(1205,657100800,2),(1205,671014800,1),(1205,688550400,2),(1205,702464400,1),(1205,720000000,2),(1205,733914000,1),(1205,752054400,2),(1205,765363600,1),(1205,783504000,2),(1205,796813200,1),(1205,814953600,2),(1205,828867600,1),(1205,846403200,2),(1205,860317200,1),(1205,877852800,2),(1205,891766800,1),(1205,909302400,2),(1205,923216400,1),(1205,941356800,2),(1205,954666000,1),(1205,972806400,2),(1205,986115600,1),(1205,1004256000,2),(1205,1018170000,1),(1205,1035705600,2),(1205,1049619600,1),(1205,1067155200,2),(1205,1081069200,1),(1205,1099209600,2),(1205,1112518800,1),(1205,1130659200,2),(1205,1143968400,1),(1205,1162108800,2),(1205,1173603600,1),(1205,1194163200,2),(1205,1205053200,1),(1205,1225612800,2),(1205,1236502800,1),(1205,1257062400,2),(1205,1268557200,1),(1205,1289116800,2),(1205,1300006800,1),(1205,1320566400,2),(1205,1331456400,1),(1205,1352016000,2),(1205,1362906000,1),(1205,1383465600,2),(1205,1394355600,1),(1205,1414915200,2),(1205,1425805200,1),(1205,1446364800,2),(1205,1457859600,1),(1205,1478419200,2),(1205,1489309200,1),(1205,1509868800,2),(1205,1520758800,1),(1205,1541318400,2),(1205,1552208400,1),(1205,1572768000,2),(1205,1583658000,1),(1205,1604217600,2),(1205,1615712400,1),(1205,1636272000,2),(1205,1647162000,1),(1205,1667721600,2),(1205,1678611600,1),(1205,1699171200,2),(1205,1710061200,1),(1205,1730620800,2),(1205,1741510800,1),(1205,1762070400,2),(1205,1772960400,1),(1205,1793520000,2),(1205,1805014800,1),(1205,1825574400,2),(1205,1836464400,1),(1205,1857024000,2),(1205,1867914000,1),(1205,1888473600,2),(1205,1899363600,1),(1205,1919923200,2),(1205,1930813200,1),(1205,1951372800,2),(1205,1962867600,1),(1205,1983427200,2),(1205,1994317200,1),(1205,2014876800,2),(1205,2025766800,1),(1205,2046326400,2),(1205,2057216400,1),(1205,2077776000,2),(1205,2088666000,1),(1205,2109225600,2),(1205,2120115600,1),(1205,2140675200,2),(1206,-2147483648,2),(1206,-1633269600,1),(1206,-1615129200,2),(1206,-1601820000,1),(1206,-1583679600,2),(1206,-880207200,3),(1206,-769395600,4),(1206,-765385200,2),(1206,-687967140,1),(1206,-662655600,2),(1206,-620838000,1),(1206,-608137200,2),(1206,-589388400,1),(1206,-576082800,2),(1206,-557938800,1),(1206,-544633200,2),(1206,-526489200,1),(1206,-513183600,2),(1206,-495039600,1),(1206,-481734000,2),(1206,-463590000,1),(1206,-450284400,2),(1206,-431535600,1),(1206,-418230000,2),(1206,-400086000,1),(1206,-386780400,2),(1206,-368636400,1),(1206,-355330800,2),(1206,-337186800,1),(1206,-323881200,2),(1206,-305737200,1),(1206,-292431600,2),(1206,-273682800,1),(1206,-260982000,2),(1206,-242233200,1),(1206,-226508400,2),(1206,-210783600,1),(1206,-195058800,2),(1206,-179334000,1),(1206,-163609200,2),(1206,-147884400,1),(1206,-131554800,2),(1206,-116434800,1),(1206,-100105200,2),(1206,-84376800,1),(1206,-68655600,2),(1206,-52927200,1),(1206,-37206000,2),(1206,-21477600,1),(1206,-5756400,2),(1206,9972000,1),(1206,25693200,2),(1206,41421600,1),(1206,57747600,2),(1206,73476000,1),(1206,89197200,2),(1206,104925600,1),(1206,120646800,2),(1206,126698400,1),(1206,152096400,2),(1206,162381600,1),(1206,183546000,2),(1206,199274400,1),(1206,215600400,2),(1206,230724000,1),(1206,247050000,2),(1206,262778400,1),(1206,278499600,2),(1206,294228000,1),(1206,309949200,2),(1206,325677600,1),(1206,341398800,2),(1206,357127200,1),(1206,372848400,2),(1206,388576800,1),(1206,404902800,2),(1206,420026400,1),(1206,436352400,2),(1206,452080800,1),(1206,467802000,2),(1206,483530400,1),(1206,499251600,2),(1206,514980000,1),(1206,530701200,2),(1206,544615200,1),(1206,562150800,2),(1206,576064800,1),(1206,594205200,2),(1206,607514400,1),(1206,625654800,2),(1206,638964000,1),(1206,657104400,2),(1206,671018400,1),(1206,688554000,2),(1206,702468000,1),(1206,720003600,2),(1206,733917600,1),(1206,752058000,2),(1206,765367200,1),(1206,783507600,2),(1206,796816800,1),(1206,814957200,2),(1206,828871200,1),(1206,846406800,2),(1206,860320800,1),(1206,877856400,2),(1206,891770400,1),(1206,909306000,2),(1206,923220000,1),(1206,941360400,2),(1206,954669600,1),(1206,972810000,2),(1206,986119200,1),(1206,1004259600,2),(1206,1018173600,1),(1206,1035709200,2),(1206,1049623200,1),(1206,1067158800,2),(1206,1081072800,1),(1206,1099213200,2),(1206,1112522400,1),(1206,1130662800,2),(1206,1143972000,1),(1206,1162112400,2),(1206,1173607200,1),(1206,1194166800,2),(1206,1205056800,1),(1206,1225616400,2),(1206,1236506400,1),(1206,1257066000,2),(1206,1268560800,1),(1206,1289120400,2),(1206,1300010400,1),(1206,1320570000,2),(1206,1331460000,1),(1206,1352019600,2),(1206,1362909600,1),(1206,1383469200,2),(1206,1394359200,1),(1206,1414918800,2),(1206,1425808800,1),(1206,1446368400,2),(1206,1457863200,1),(1206,1478422800,2),(1206,1489312800,1),(1206,1509872400,2),(1206,1520762400,1),(1206,1541322000,2),(1206,1552212000,1),(1206,1572771600,2),(1206,1583661600,1),(1206,1604221200,2),(1206,1615716000,1),(1206,1636275600,2),(1206,1647165600,1),(1206,1667725200,2),(1206,1678615200,1),(1206,1699174800,2),(1206,1710064800,1),(1206,1730624400,2),(1206,1741514400,1),(1206,1762074000,2),(1206,1772964000,1),(1206,1793523600,2),(1206,1805018400,1),(1206,1825578000,2),(1206,1836468000,1),(1206,1857027600,2),(1206,1867917600,1),(1206,1888477200,2),(1206,1899367200,1),(1206,1919926800,2),(1206,1930816800,1),(1206,1951376400,2),(1206,1962871200,1),(1206,1983430800,2),(1206,1994320800,1),(1206,2014880400,2),(1206,2025770400,1),(1206,2046330000,2),(1206,2057220000,1),(1206,2077779600,2),(1206,2088669600,1),(1206,2109229200,2),(1206,2120119200,1),(1206,2140678800,2),(1207,-2147483648,2),(1207,-1633269600,1),(1207,-1615129200,2),(1207,-1601820000,1),(1207,-1583679600,2),(1207,-880207200,3),(1207,-769395600,4),(1207,-765385200,2),(1207,-687967140,1),(1207,-662655600,2),(1207,-620838000,1),(1207,-608137200,2),(1207,-589388400,1),(1207,-576082800,2),(1207,-557938800,1),(1207,-544633200,2),(1207,-526489200,1),(1207,-513183600,2),(1207,-495039600,1),(1207,-481734000,2),(1207,-463590000,1),(1207,-450284400,2),(1207,-431535600,1),(1207,-418230000,2),(1207,-400086000,1),(1207,-386780400,2),(1207,-368636400,1),(1207,-355330800,2),(1207,-337186800,1),(1207,-323881200,2),(1207,-305737200,1),(1207,-292431600,2),(1207,-273682800,1),(1207,-260982000,2),(1207,-242233200,1),(1207,-226508400,2),(1207,-210783600,1),(1207,-195058800,2),(1207,-179334000,1),(1207,-163609200,2),(1207,-147884400,1),(1207,-131554800,2),(1207,-116434800,1),(1207,-100105200,2),(1207,-84376800,1),(1207,-68655600,2),(1207,-52927200,1),(1207,-37206000,2),(1207,-21477600,1),(1207,-5756400,2),(1207,9972000,1),(1207,25693200,2),(1207,41421600,1),(1207,57747600,2),(1207,73476000,1),(1207,89197200,2),(1207,104925600,1),(1207,120646800,2),(1207,126698400,1),(1207,152096400,2),(1207,162381600,1),(1207,183546000,2),(1207,199274400,1),(1207,215600400,2),(1207,230724000,1),(1207,247050000,2),(1207,262778400,1),(1207,278499600,2),(1207,294228000,1),(1207,309949200,2),(1207,325677600,1),(1207,341398800,2),(1207,357127200,1),(1207,372848400,2),(1207,388576800,1),(1207,404902800,2),(1207,420026400,1),(1207,436352400,2),(1207,452080800,1),(1207,467802000,2),(1207,483530400,1),(1207,499251600,2),(1207,514980000,1),(1207,530701200,2),(1207,544615200,1),(1207,562150800,2),(1207,576064800,1),(1207,594205200,2),(1207,607514400,1),(1207,625654800,2),(1207,638964000,1),(1207,657104400,2),(1207,671018400,1),(1207,688554000,2),(1207,702468000,1),(1207,720003600,2),(1207,733917600,1),(1207,752058000,2),(1207,765367200,1),(1207,783507600,2),(1207,796816800,1),(1207,814957200,2),(1207,828871200,1),(1207,846406800,2),(1207,860320800,1),(1207,877856400,2),(1207,891770400,1),(1207,909306000,2),(1207,923220000,1),(1207,941360400,2),(1207,954669600,1),(1207,972810000,2),(1207,986119200,1),(1207,1004259600,2),(1207,1018173600,1),(1207,1035709200,2),(1207,1049623200,1),(1207,1067158800,2),(1207,1081072800,1),(1207,1099213200,2),(1207,1112522400,1),(1207,1130662800,2),(1207,1143972000,1),(1207,1162112400,2),(1207,1173607200,1),(1207,1194166800,2),(1207,1205056800,1),(1207,1225616400,2),(1207,1236506400,1),(1207,1257066000,2),(1207,1268560800,1),(1207,1289120400,2),(1207,1300010400,1),(1207,1320570000,2),(1207,1331460000,1),(1207,1352019600,2),(1207,1362909600,1),(1207,1383469200,2),(1207,1394359200,1),(1207,1414918800,2),(1207,1425808800,1),(1207,1446368400,2),(1207,1457863200,1),(1207,1478422800,2),(1207,1489312800,1),(1207,1509872400,2),(1207,1520762400,1),(1207,1541322000,2),(1207,1552212000,1),(1207,1572771600,2),(1207,1583661600,1),(1207,1604221200,2),(1207,1615716000,1),(1207,1636275600,2),(1207,1647165600,1),(1207,1667725200,2),(1207,1678615200,1),(1207,1699174800,2),(1207,1710064800,1),(1207,1730624400,2),(1207,1741514400,1),(1207,1762074000,2),(1207,1772964000,1),(1207,1793523600,2),(1207,1805018400,1),(1207,1825578000,2),(1207,1836468000,1),(1207,1857027600,2),(1207,1867917600,1),(1207,1888477200,2),(1207,1899367200,1),(1207,1919926800,2),(1207,1930816800,1),(1207,1951376400,2),(1207,1962871200,1),(1207,1983430800,2),(1207,1994320800,1),(1207,2014880400,2),(1207,2025770400,1),(1207,2046330000,2),(1207,2057220000,1),(1207,2077779600,2),(1207,2088669600,1),(1207,2109229200,2),(1207,2120119200,1),(1207,2140678800,2),(1208,-2147483648,1),(1208,-1861879032,2),(1211,-2147483648,1),(1211,-1688265017,3),(1211,-1656819079,2),(1211,-1641353479,3),(1211,-1627965079,4),(1211,-1618716679,2),(1211,-1596429079,4),(1211,-1593820800,5),(1211,-1589860800,6),(1211,-1542427200,7),(1211,-1539493200,8),(1211,-1525323600,7),(1211,-1522728000,6),(1211,-1491188400,9),(1211,-1247536800,6),(1211,354920400,7),(1211,370728000,6),(1211,386456400,7),(1211,402264000,6),(1211,417992400,7),(1211,433800000,6),(1211,449614800,7),(1211,465346800,10),(1211,481071600,11),(1211,496796400,10),(1211,512521200,11),(1211,528246000,10),(1211,543970800,11),(1211,559695600,10),(1211,575420400,11),(1211,591145200,10),(1211,606870000,11),(1211,622594800,10),(1211,638319600,11),(1211,654649200,10),(1211,670374000,12),(1211,686102400,13),(1211,695779200,10),(1211,701823600,11),(1211,717548400,10),(1211,733273200,11),(1211,748998000,10),(1211,764722800,11),(1211,780447600,10),(1211,796172400,11),(1211,811897200,10),(1211,828226800,11),(1211,846370800,10),(1211,859676400,11),(1211,877820400,10),(1211,891126000,11),(1211,909270000,10),(1211,922575600,11),(1211,941324400,10),(1211,954025200,11),(1211,972774000,10),(1211,985474800,11),(1211,1004223600,10),(1211,1017529200,11),(1211,1035673200,10),(1211,1048978800,11),(1211,1067122800,10),(1211,1080428400,11),(1211,1099177200,10),(1211,1111878000,11),(1211,1130626800,10),(1211,1143327600,11),(1211,1162076400,10),(1211,1174777200,11),(1211,1193526000,10),(1211,1206831600,11),(1211,1224975600,10),(1211,1238281200,11),(1211,1256425200,10),(1211,1269730800,11),(1211,1288479600,10),(1211,1301180400,14),(1211,1414274400,10),(1212,228877200,0),(1212,243997200,1),(1212,260326800,0),(1212,276051600,1),(1212,291776400,0),(1212,307501200,1),(1212,323830800,0),(1212,338950800,1),(1212,354675600,0),(1212,370400400,1),(1212,386125200,0),(1212,401850000,1),(1212,417574800,0),(1212,433299600,1),(1212,449024400,0),(1212,465354000,1),(1212,481078800,0),(1212,496803600,1),(1212,512528400,0),(1212,528253200,1),(1212,543978000,0),(1212,559702800,1),(1212,575427600,0),(1212,591152400,1),(1212,606877200,0),(1212,622602000,1),(1212,638326800,0),(1212,654656400,1),(1212,670381200,0),(1212,686106000,1),(1212,701830800,0),(1212,717555600,1),(1212,733280400,0),(1212,749005200,1),(1212,764730000,0),(1212,780454800,1),(1212,796179600,0),(1212,811904400,1),(1212,828234000,0),(1212,846378000,1),(1212,859683600,0),(1212,877827600,1),(1212,891133200,0),(1212,909277200,1),(1212,922582800,0),(1212,941331600,1),(1212,954032400,0),(1212,972781200,1),(1212,985482000,0),(1212,1004230800,1),(1212,1017536400,0),(1212,1035680400,1),(1212,1048986000,0),(1212,1067130000,1),(1212,1080435600,0),(1212,1099184400,1),(1212,1111885200,0),(1212,1130634000,1),(1212,1143334800,0),(1212,1162083600,1),(1212,1174784400,0),(1212,1193533200,1),(1212,1206838800,0),(1212,1224982800,1),(1212,1238288400,0),(1212,1256432400,1),(1212,1269738000,0),(1212,1288486800,1),(1212,1301187600,0),(1212,1319936400,1),(1212,1332637200,0),(1212,1351386000,1),(1212,1364691600,0),(1212,1382835600,1),(1212,1396141200,0),(1212,1414285200,1),(1212,1427590800,0),(1212,1445734800,1),(1212,1459040400,0),(1212,1477789200,1),(1212,1490490000,0),(1212,1509238800,1),(1212,1521939600,0),(1212,1540688400,1),(1212,1553994000,0),(1212,1572138000,1),(1212,1585443600,0),(1212,1603587600,1),(1212,1616893200,0),(1212,1635642000,1),(1212,1648342800,0),(1212,1667091600,1),(1212,1679792400,0),(1212,1698541200,1),(1212,1711846800,0),(1212,1729990800,1),(1212,1743296400,0),(1212,1761440400,1),(1212,1774746000,0),(1212,1792890000,1),(1212,1806195600,0),(1212,1824944400,1),(1212,1837645200,0),(1212,1856394000,1),(1212,1869094800,0),(1212,1887843600,1),(1212,1901149200,0),(1212,1919293200,1),(1212,1932598800,0),(1212,1950742800,1),(1212,1964048400,0),(1212,1982797200,1),(1212,1995498000,0),(1212,2014246800,1),(1212,2026947600,0),(1212,2045696400,1),(1212,2058397200,0),(1212,2077146000,1),(1212,2090451600,0),(1212,2108595600,1),(1212,2121901200,0),(1212,2140045200,1),(1214,-2147483648,2),(1214,-1633280400,1),(1214,-1615140000,2),(1214,-1601830800,1),(1214,-1583690400,2),(1214,-1570381200,1),(1214,-1551636000,2),(1214,-1536512400,1),(1214,-1523210400,2),(1214,-1504458000,1),(1214,-1491760800,2),(1214,-1473008400,1),(1214,-1459706400,2),(1214,-1441558800,1),(1214,-1428256800,2),(1214,-1410109200,1),(1214,-1396807200,2),(1214,-1378659600,1),(1214,-1365357600,2),(1214,-1347210000,1),(1214,-1333908000,2),(1214,-1315155600,1),(1214,-1301853600,2),(1214,-1283706000,1),(1214,-1270404000,2),(1214,-1252256400,1),(1214,-1238954400,2),(1214,-1220806800,1),(1214,-1207504800,2),(1214,-1189357200,1),(1214,-1176055200,2),(1214,-1157302800,1),(1214,-1144605600,2),(1214,-1125853200,1),(1214,-1112551200,2),(1214,-1094403600,1),(1214,-1081101600,2),(1214,-1062954000,1),(1214,-1049652000,2),(1214,-1031504400,1),(1214,-1018202400,2),(1214,-1000054800,1),(1214,-986752800,2),(1214,-968000400,1),(1214,-955303200,2),(1214,-936550800,1),(1214,-923248800,2),(1214,-905101200,1),(1214,-891799200,2),(1214,-880218000,3),(1214,-769395600,4),(1214,-765396000,2),(1214,-747248400,1),(1214,-733946400,2),(1214,-715798800,1),(1214,-702496800,2),(1214,-684349200,1),(1214,-671047200,2),(1214,-652899600,1),(1214,-639597600,2),(1214,-620845200,1),(1214,-608148000,2),(1214,-589395600,1),(1214,-576093600,2),(1214,-557946000,1),(1214,-544644000,2),(1214,-526496400,1),(1214,-513194400,2),(1214,-495046800,1),(1214,-481744800,2),(1214,-463597200,1),(1214,-447271200,2),(1214,-431542800,1),(1214,-415821600,2),(1214,-400093200,1),(1214,-384372000,2),(1214,-368643600,1),(1214,-352922400,2),(1214,-337194000,1),(1214,-321472800,2),(1214,-305744400,1),(1214,-289418400,2),(1214,-273690000,1),(1214,-257968800,2),(1214,-242240400,1),(1214,-226519200,2),(1214,-210790800,1),(1214,-195069600,2),(1214,-179341200,1),(1214,-163620000,2),(1214,-147891600,1),(1214,-131565600,2),(1214,-116442000,1),(1214,-100116000,2),(1214,-84387600,1),(1214,-68666400,2),(1214,-52938000,1),(1214,-37216800,2),(1214,-21488400,1),(1214,-5767200,2),(1214,9961200,1),(1214,25682400,2),(1214,41410800,1),(1214,57736800,2),(1214,73465200,1),(1214,89186400,2),(1214,104914800,1),(1214,120636000,2),(1214,126687600,1),(1214,152085600,2),(1214,162370800,1),(1214,183535200,2),(1214,199263600,1),(1214,215589600,2),(1214,230713200,1),(1214,247039200,2),(1214,262767600,1),(1214,278488800,2),(1214,294217200,1),(1214,309938400,2),(1214,325666800,1),(1214,341388000,2),(1214,357116400,1),(1214,372837600,2),(1214,388566000,1),(1214,404892000,2),(1214,420015600,1),(1214,436341600,2),(1214,452070000,1),(1214,467791200,2),(1214,483519600,1),(1214,499240800,2),(1214,514969200,1),(1214,530690400,2),(1214,544604400,1),(1214,562140000,2),(1214,576054000,1),(1214,594194400,2),(1214,607503600,1),(1214,625644000,2),(1214,638953200,1),(1214,657093600,2),(1214,671007600,1),(1214,688543200,2),(1214,702457200,1),(1214,719992800,2),(1214,733906800,1),(1214,752047200,2),(1214,765356400,1),(1214,783496800,2),(1214,796806000,1),(1214,814946400,2),(1214,828860400,1),(1214,846396000,2),(1214,860310000,1),(1214,877845600,2),(1214,891759600,1),(1214,909295200,2),(1214,923209200,1),(1214,941349600,2),(1214,954658800,1),(1214,972799200,2),(1214,986108400,1),(1214,1004248800,2),(1214,1018162800,1),(1214,1035698400,2),(1214,1049612400,1),(1214,1067148000,2),(1214,1081062000,1),(1214,1099202400,2),(1214,1112511600,1),(1214,1130652000,2),(1214,1143961200,1),(1214,1162101600,2),(1214,1173596400,1),(1214,1194156000,2),(1214,1205046000,1),(1214,1225605600,2),(1214,1236495600,1),(1214,1257055200,2),(1214,1268550000,1),(1214,1289109600,2),(1214,1299999600,1),(1214,1320559200,2),(1214,1331449200,1),(1214,1352008800,2),(1214,1362898800,1),(1214,1383458400,2),(1214,1394348400,1),(1214,1414908000,2),(1214,1425798000,1),(1214,1446357600,2),(1214,1457852400,1),(1214,1478412000,2),(1214,1489302000,1),(1214,1509861600,2),(1214,1520751600,1),(1214,1541311200,2),(1214,1552201200,1),(1214,1572760800,2),(1214,1583650800,1),(1214,1604210400,2),(1214,1615705200,1),(1214,1636264800,2),(1214,1647154800,1),(1214,1667714400,2),(1214,1678604400,1),(1214,1699164000,2),(1214,1710054000,1),(1214,1730613600,2),(1214,1741503600,1),(1214,1762063200,2),(1214,1772953200,1),(1214,1793512800,2),(1214,1805007600,1),(1214,1825567200,2),(1214,1836457200,1),(1214,1857016800,2),(1214,1867906800,1),(1214,1888466400,2),(1214,1899356400,1),(1214,1919916000,2),(1214,1930806000,1),(1214,1951365600,2),(1214,1962860400,1),(1214,1983420000,2),(1214,1994310000,1),(1214,2014869600,2),(1214,2025759600,1),(1214,2046319200,2),(1214,2057209200,1),(1214,2077768800,2),(1214,2088658800,1),(1214,2109218400,2),(1214,2120108400,1),(1214,2140668000,2),(1215,-2147483648,0),(1215,-1830383032,1),(1216,-2147483648,0),(1216,-1640995148,2),(1216,-1556841600,1),(1216,-1546388400,2),(1216,-1525305600,1),(1216,-1514852400,2),(1216,-1493769600,1),(1216,-1483316400,2),(1216,-1462233600,1),(1216,-1451780400,2),(1216,-1430611200,1),(1216,-1420158000,2),(1216,-1399075200,1),(1216,-1388622000,2),(1216,-1367539200,1),(1216,-1357086000,2),(1216,-1336003200,1),(1216,-1325550000,2),(1216,-1304380800,1),(1216,-1293927600,2),(1216,-1272844800,1),(1216,-1262391600,2),(1216,-1241308800,1),(1216,-1230855600,2),(1216,-1209772800,1),(1216,-1199319600,2),(1216,-1178150400,1),(1216,-1167697200,2),(1216,-1146614400,1),(1216,-1136161200,2),(1216,-1115078400,1),(1216,-1104625200,2),(1216,-1083542400,1),(1216,-1073089200,2),(1216,-1051920000,1),(1216,-1041466800,2),(1216,-1020384000,1),(1216,-1009930800,2),(1216,-988848000,1),(1216,-978394800,2),(1216,-957312000,1),(1216,-946858800,2),(1216,-925689600,1),(1216,-915236400,2),(1216,-894153600,1),(1216,-883700400,2),(1216,-862617600,1),(1216,-852164400,2),(1217,-2147483648,0),(1217,-1309746436,1),(1217,-1262314800,2),(1217,-946780200,3),(1217,-315629100,1),(1218,-2147483648,1),(1218,-1855958961,4),(1218,-1689814800,2),(1218,-1680397200,3),(1218,-1665363600,2),(1218,-1648342800,3),(1218,-1635123600,2),(1218,-1616893200,3),(1218,-1604278800,2),(1218,-1585443600,3),(1218,-1574038800,2),(1218,-1552266000,3),(1218,-1539997200,2),(1218,-1531443600,3),(1218,-956365200,2),(1218,-950486400,4),(1218,-942012000,6),(1218,-812502000,5),(1218,-796262400,6),(1218,-781052400,5),(1218,-766630800,6),(1218,-733280400,4),(1218,-439430400,6),(1218,-212029200,4),(1218,41468400,2),(1218,54774000,3),(1218,231724806,7),(1218,246236406,6),(1218,259545607,5),(1218,275274007,6),(1218,309740408,4),(1218,325468809,7),(1218,341802009,4),(1218,357523209,6),(1219,-2147483648,0),(1219,-1309746436,1),(1219,-1262314800,2),(1219,-946780200,3),(1219,-315629100,1),(1220,-2147483648,0),(1220,-1309746436,1),(1220,-1262314800,2),(1220,-946780200,3),(1220,-315629100,1),(1221,-2147483648,0),(1221,-1830383032,1),(1222,-2147483648,0),(1222,-1588464816,1),(1223,-2147483648,0),(1223,-1830383032,1),(1224,-2147483648,0),(1224,-1830380400,1),(1224,157770004,2),(1225,-2147483648,0),(1225,-2109291020,1),(1226,-2147483648,0),(1226,-1588464816,1),(1227,-2147483648,0),(1227,-2109291020,1),(1228,-2147483648,2),(1228,-929844000,1),(1228,-923108400,2),(1228,-906170400,1),(1228,-892868400,2),(1228,-875844000,1),(1228,-857790000,2),(1228,-844308000,1),(1228,-825822000,2),(1228,-812685600,1),(1228,-794199600,2),(1228,-779853600,1),(1228,-762663600,2),(1228,-399088800,1),(1228,-386650800,2),(1228,-368330400,1),(1228,-355114800,2),(1228,-336790800,1),(1228,-323654400,2),(1228,-305168400,1),(1228,-292032000,2),(1228,-273632400,1),(1228,-260496000,2),(1228,-242096400,1),(1228,-228960000,2),(1228,-210560400,1),(1228,-197424000,2),(1228,-178938000,1),(1228,-165801600,2),(1228,-147402000,1),(1228,-134265600,2),(1228,-115866000,1),(1228,-102643200,2),(1228,-84330000,1),(1228,-71107200,2),(1228,-52707600,1),(1228,-39484800,2),(1228,-21171600,1),(1228,-7948800,2),(1228,10364400,1),(1228,23587200,2),(1228,41900400,1),(1228,55123200,2),(1228,73522800,1),(1228,86745601,2),(1228,105058802,1),(1228,118281602,2),(1228,136594803,1),(1228,149817603,2),(1228,168130804,1),(1228,181353604,2),(1228,199753205,1),(1228,212976005,2),(1228,231289206,1),(1228,244512006,2),(1228,262825207,1),(1228,276048007,2),(1228,294361208,1),(1228,307584008,2),(1228,325983609,1),(1228,339206409,2),(1228,357519609,1),(1228,370742410,2),(1228,396399611,1),(1228,402278411,2),(1228,426812412,1),(1228,433814412,2),(1228,452214012,1),(1228,465436812,2),(1228,483750012,1),(1228,496972813,2),(1228,515286013,1),(1228,528508813,2),(1228,546822013,1),(1228,560044813,2),(1228,578444414,1),(1228,591667214,2),(1228,610412414,1),(1228,623203214,2),(1228,641516415,1),(1228,654739215,2),(1228,673052416,1),(1228,686275216,2),(1228,704674816,1),(1228,717897617,2),(1228,736210817,1),(1228,749433618,2),(1228,767746818,1),(1228,780969619,2),(1228,799020019,3),(1228,812322019,2),(1228,830469620,3),(1228,843771620,2),(1228,861919220,3),(1228,875221221,2),(1228,893368821,3),(1228,906670821,2),(1228,925423222,3),(1228,938725222,2),(1228,956872822,3),(1228,970174822,2),(1228,988322422,3),(1228,1001624422,2),(1228,1019772022,3),(1228,1033074022,2),(1228,1051221622,3),(1228,1064523622,2),(1228,1083276022,3),(1228,1096578022,2),(1228,1114725622,3),(1228,1128027622,2),(1228,1146175223,3),(1228,1158872423,2),(1228,1177624823,3),(1228,1189112423,2),(1228,1209074423,3),(1228,1219957223,2),(1228,1240524024,3),(1228,1250802024,2),(1228,1272578424,3),(1228,1281474024,2),(1228,1284069624,1),(1228,1285880424,2),(1228,1400191225,1),(1228,1403816425,2),(1228,1406844025,1),(1228,1411678825,2),(1229,-2147483648,0),(1229,-1773012580,2),(1229,-956361600,1),(1229,-950490000,2),(1229,-942019200,1),(1229,-761187600,2),(1229,-617241600,1),(1229,-605149200,2),(1229,-81432000,1),(1229,-71110800,2),(1229,141264003,1),(1229,147222003,2),(1229,199756805,1),(1229,207702005,2),(1229,231292806,1),(1229,244249206,2),(1229,265507207,1),(1229,271033207,2),(1229,448243212,3),(1229,504918013,2),(1229,1212278423,1),(1229,1220223623,2),(1229,1243814424,1),(1229,1250809224,2),(1229,1272758424,1),(1229,1281222024,2),(1229,1301788824,1),(1229,1312066824,2),(1229,1335664824,1),(1229,1342749625,2),(1229,1345428025,1),(1229,1348970425,2),(1229,1367114425,1),(1229,1373162425,2),(1229,1376100025,1),(1229,1382839225,2),(1229,1396144825,1),(1229,1403920825,2),(1229,1406944825,1),(1229,1414288825,2),(1229,1427594425,1),(1229,1434247225,2),(1229,1437271226,1),(1229,1445738426,2),(1229,1459044026,1),(1229,1465092026,2),(1229,1468116026,1),(1229,1477792826,2),(1229,1490493627,1),(1229,1495332027,2),(1229,1498960827,1),(1229,1509242427,2),(1229,1521943227,1),(1229,1526176827,2),(1229,1529200827,1),(1229,1540692027,3),(1229,1557021627,4),(1229,1560045627,3),(1229,1587261627,4),(1229,1590285627,3),(1229,1618106427,4),(1229,1621130427,3),(1229,1648346427,4),(1229,1651975227,3),(1229,1679191227,4),(1229,1682215227,3),(1229,1710036027,4),(1229,1713060027,3),(1229,1740276027,4),(1229,1743904827,3),(1229,1771120827,4),(1229,1774144827,3),(1229,1801965627,4),(1229,1804989627,3),(1229,1832205627,4),(1229,1835229627,3),(1229,1863050427,4),(1229,1866074427,3),(1229,1893290427,4),(1229,1896919227,3),(1229,1924135227,4),(1229,1927159227,3),(1229,1954980027,4),(1229,1958004027,3),(1229,1985220027,4),(1229,1988848827,3),(1229,2016064827,4),(1229,2019088827,3),(1229,2046304827,4),(1229,2049933627,3),(1229,2077149627,4),(1229,2080173627,3),(1229,2107994427,4),(1229,2111018427,3),(1229,2138234427,4),(1229,2141863227,3),(1230,-2147483648,1),(1230,-1630112400,2),(1230,-1616810400,1),(1230,-1442451600,2),(1230,-1427673600,3),(1230,-1379293200,2),(1230,-1364774400,3),(1230,-1348448400,2),(1230,-1333324800,3),(1230,-1316390400,2),(1230,-1301270400,3),(1230,-1293840000,1),(1230,-81432000,2),(1230,-71110800,1),(1230,141264003,2),(1230,147222003,1),(1230,199756805,2),(1230,207702005,1),(1230,231292806,2),(1230,244249206,1),(1230,265507207,2),(1230,271033207,1),(1230,448243212,4),(1230,512528413,5),(1230,528253213,6),(1230,543978013,5),(1230,559702813,6),(1230,575427614,5),(1230,591152414,6),(1230,606877214,5),(1230,622602014,6),(1230,638326815,5),(1230,654656415,6),(1230,670381216,5),(1230,686106016,6),(1230,701830816,5),(1230,717555617,6),(1230,733280417,5),(1230,749005218,6),(1230,764730018,5),(1230,780454819,6),(1230,796179619,5),(1230,811904419,6),(1230,828234020,5),(1230,846378020,6),(1230,859683620,5),(1230,877827621,6),(1230,891133221,5),(1230,909277221,6),(1230,922582822,5),(1230,941331622,6),(1230,954032422,5),(1230,972781222,6),(1230,985482022,5),(1230,1004230822,6),(1230,1017536422,5),(1230,1035680422,6),(1230,1048986022,5),(1230,1067130022,6),(1230,1080435622,5),(1230,1099184422,6),(1230,1111885222,5),(1230,1130634022,6),(1230,1143334823,5),(1230,1162083623,6),(1230,1174784423,5),(1230,1193533223,6),(1230,1206838823,5),(1230,1224982823,6),(1230,1238288424,5),(1230,1256432424,6),(1230,1269738024,5),(1230,1288486824,6),(1230,1301187624,5),(1230,1319936424,6),(1230,1332637224,5),(1230,1351386025,6),(1230,1364691625,5),(1230,1382835625,6),(1230,1396141225,5),(1230,1414285225,6),(1230,1427590825,5),(1230,1445734826,6),(1230,1459040426,5),(1230,1477789226,6),(1230,1490490027,5),(1230,1509238827,6),(1230,1521939627,5),(1230,1540688427,6),(1230,1553994027,5),(1230,1572138027,6),(1230,1585443627,5),(1230,1603587627,6),(1230,1616893227,5),(1230,1635642027,6),(1230,1648342827,5),(1230,1667091627,6),(1230,1679792427,5),(1230,1698541227,6),(1230,1711846827,5),(1230,1729990827,6),(1230,1743296427,5),(1230,1761440427,6),(1230,1774746027,5),(1230,1792890027,6),(1230,1806195627,5),(1230,1824944427,6),(1230,1837645227,5),(1230,1856394027,6),(1230,1869094827,5),(1230,1887843627,6),(1230,1901149227,5),(1230,1919293227,6),(1230,1932598827,5),(1230,1950742827,6),(1230,1964048427,5),(1230,1982797227,6),(1230,1995498027,5),(1230,2014246827,6),(1230,2026947627,5),(1230,2045696427,6),(1230,2058397227,5),(1230,2077146027,6),(1230,2090451627,5),(1230,2108595627,6),(1230,2121901227,5),(1230,2140045227,6),(1231,-2147483648,0),(1231,-1830383032,1),(1232,-2147483648,0),(1232,-1830383032,1),(1233,-2147483648,0),(1233,-1309746436,1),(1233,-1262314800,2),(1233,-946780200,3),(1233,-315629100,1),(1234,-2147483648,0),(1234,-1309746436,1),(1234,-1262314800,2),(1234,-946780200,3),(1234,-315629100,1),(1235,-2147483648,0),(1235,-1588464816,1),(1236,-2147483648,0),(1236,-1136070432,1),(1236,198291605,3),(1236,199756805,2),(1236,207702005,3),(1236,231292806,2),(1236,244249206,3),(1236,265507207,2),(1236,271033207,3),(1236,1212278423,2),(1236,1220223623,3),(1236,1243814424,2),(1236,1250809224,3),(1236,1272758424,2),(1236,1281222024,3),(1236,1301788824,2),(1236,1312066824,3),(1236,1335664824,2),(1236,1342749625,3),(1236,1345428025,2),(1236,1348970425,3),(1236,1367114425,2),(1236,1373162425,3),(1236,1376100025,2),(1236,1382839225,3),(1236,1396144825,2),(1236,1403920825,3),(1236,1406944825,2),(1236,1414288825,3),(1236,1427594425,2),(1236,1434247225,3),(1236,1437271226,2),(1236,1445738426,3),(1236,1459044026,2),(1236,1465092026,3),(1236,1468116026,2),(1236,1477792826,3),(1236,1490493627,2),(1236,1495332027,3),(1236,1498960827,2),(1236,1509242427,3),(1236,1521943227,2),(1236,1526176827,3),(1236,1529200827,2),(1236,1540692027,5),(1236,1557021627,4),(1236,1560045627,5),(1236,1587261627,4),(1236,1590285627,5),(1236,1618106427,4),(1236,1621130427,5),(1236,1648346427,4),(1236,1651975227,5),(1236,1679191227,4),(1236,1682215227,5),(1236,1710036027,4),(1236,1713060027,5),(1236,1740276027,4),(1236,1743904827,5),(1236,1771120827,4),(1236,1774144827,5),(1236,1801965627,4),(1236,1804989627,5),(1236,1832205627,4),(1236,1835229627,5),(1236,1863050427,4),(1236,1866074427,5),(1236,1893290427,4),(1236,1896919227,5),(1236,1924135227,4),(1236,1927159227,5),(1236,1954980027,4),(1236,1958004027,5),(1236,1985220027,4),(1236,1988848827,5),(1236,2016064827,4),(1236,2019088827,5),(1236,2046304827,4),(1236,2049933627,5),(1236,2077149627,4),(1236,2080173627,5),(1236,2107994427,4),(1236,2111018427,5),(1236,2138234427,4),(1236,2141863227,5),(1237,-2147483648,0),(1237,-1830383032,1),(1238,-2147483648,0),(1238,-2109291020,1),(1239,-2147483648,0),(1239,-2109291020,1),(1240,-2147483648,1),(1240,-2109288600,3),(1240,-860976000,2),(1240,-845254800,3),(1240,-829526400,2),(1240,-813805200,3),(1241,-2147483648,0),(1241,-1230775588,2),(1241,10360800,1),(1241,24786000,2),(1241,41810400,1),(1241,56322000,2),(1241,73432800,1),(1241,87944401,2),(1241,104882402,1),(1241,119480402,2),(1241,136332003,1),(1241,151016403,2),(1241,167781604,1),(1241,182552404,2),(1241,199231205,1),(1241,214174805,2),(1241,230680806,1),(1241,245710806,2),(1241,262735207,1),(1241,277246807,2),(1241,294184808,1),(1241,308782808,2),(1241,325634409,1),(1241,340405209,2),(1241,357084009,1),(1241,371941210,2),(1241,388533610,1),(1241,403477211,2),(1241,419983211,1),(1241,435013212,2),(1241,452037612,1),(1241,466635612,2),(1241,483487212,1),(1241,498171613,2),(1241,947930422,3),(1242,-2147483648,0),(1242,-1309746436,1),(1242,-1262314800,2),(1242,-946780200,3),(1242,-315629100,1),(1243,-2147483648,0),(1243,-1230775808,2),(1243,10360800,1),(1243,24786000,2),(1243,41810400,1),(1243,56322000,2),(1243,73432800,1),(1243,87944401,2),(1243,104882402,1),(1243,119480402,2),(1243,136332003,1),(1243,151016403,2),(1243,167781604,1),(1243,182552404,2),(1243,199231205,1),(1243,214174805,2),(1243,230680806,1),(1243,245710806,2),(1243,262735207,1),(1243,277246807,2),(1243,294184808,1),(1243,308782808,2),(1243,325634409,1),(1243,340405209,2),(1243,357084009,1),(1243,371941210,2),(1243,388533610,1),(1243,403477211,2),(1243,419983211,1),(1243,435013212,2),(1243,452037612,1),(1243,466635612,2),(1243,483487212,1),(1243,498171613,2),(1243,947930422,3),(1243,1509483627,2),(1244,-2147483648,0),(1244,-2109291020,1),(1245,-2147483648,0),(1245,-1588464816,1),(1246,-2147483648,0),(1246,-1588464816,1),(1247,-2147483648,0),(1247,-1588464816,1),(1248,-2147483648,0),(1248,-1830383032,1),(1249,-2147483648,0),(1249,-1588464816,1),(1250,-2147483648,0),(1250,-2109291020,1),(1251,-2147483648,0),(1251,-2109291020,1),(1252,-2147483648,0),(1252,-1588464816,1),(1253,-2147483648,0),(1253,-2109291020,1),(1254,-2147483648,1),(1254,-2109288600,3),(1254,-860976000,2),(1254,-845254800,3),(1254,-829526400,2),(1254,-813805200,3),(1255,-2147483648,1),(1255,-2109288600,3),(1255,-860976000,2),(1255,-845254800,3),(1255,-829526400,2),(1255,-813805200,3),(1256,-2147483648,0),(1256,-1309746436,1),(1256,-1262314800,2),(1256,-946780200,3),(1256,-315629100,1),(1257,-2147483648,1),(1257,-1604359012,2),(1257,63593070,3),(1258,-2147483648,0),(1258,-1309746436,1),(1258,-1262314800,2),(1258,-946780200,3),(1258,-315629100,1),(1259,-2147483648,0),(1259,-1830387612,1),(1259,308703608,2),(1259,321314409,1),(1260,-2147483648,0),(1260,-1588464816,1),(1261,-2147483648,0),(1261,-1830383032,1),(1262,-2147483648,0),(1262,-1830383032,1),(1263,-2147483648,0),(1263,-1588464816,1),(1264,-2147483648,1),(1264,-1830384000,2),(1264,1514768427,3),(1264,1546304427,4),(1265,-2147483648,0),(1265,-1830383032,1),(1266,-2147483648,0),(1266,-1577926364,2),(1266,-574902000,1),(1266,-568087200,2),(1266,-512175600,1),(1266,-504928800,2),(1266,-449888400,1),(1266,-441856800,2),(1266,-347158800,3),(1266,378684010,2),(1266,386463610,1),(1266,402271211,2),(1266,417999611,1),(1266,433807212,2),(1266,449622012,1),(1266,465429612,2),(1266,481590012,1),(1266,496965613,2),(1266,512953213,1),(1266,528674413,2),(1266,544230013,1),(1266,560037613,2),(1266,575852414,1),(1266,591660014,2),(1266,607388414,1),(1266,623196014,2),(1266,641775615,3),(1266,844034420,2),(1266,860108420,1),(1266,875916021,3),(1266,1352505625,2),(1266,1364515225,1),(1266,1382659225,3),(1267,-2147483648,1),(1267,-1855958961,4),(1267,-969242400,2),(1267,-950493600,3),(1267,-941940000,2),(1267,-891136800,4),(1267,-877827600,5),(1267,-857257200,4),(1267,-844556400,5),(1267,-842918400,4),(1267,-842223600,5),(1267,-828230400,4),(1267,-812502000,5),(1267,-796269600,4),(1267,-781052400,5),(1267,-766634400,4),(1267,231202806,2),(1267,243903606,3),(1267,262825207,2),(1267,276044407,3),(1267,581122814,2),(1267,591145214,3),(1267,606870014,2),(1267,622594814,3),(1267,641516415,2),(1267,654649215,3),(1267,1114902022,2),(1267,1128038422,3),(1267,1143334823,2),(1267,1162083623,3),(1267,1174784423,2),(1267,1193533223,3),(1267,1206838823,2),(1267,1224982823,3),(1268,-2147483648,1),(1268,-2109288600,2),(1268,-860976000,3),(1268,-845254800,2),(1268,637970415,5),(1268,764200818,4),(1268,778640419,5),(1268,796780819,4),(1268,810090019,5),(1268,828835220,4),(1268,841539620,5),(1268,860284820,4),(1268,873594021,5),(1268,891734421,4),(1268,905043621,5),(1268,923184022,4),(1268,936493222,5),(1268,954633622,4),(1268,967942822,5),(1268,986083222,4),(1268,999392422,5),(1268,1018137622,4),(1268,1030842022,5),(1268,1049587222,4),(1268,1062896422,5),(1268,1081036822,4),(1268,1094346022,5),(1268,1112486422,4),(1268,1125795622,5),(1268,1143936023,4),(1268,1157245223,5),(1268,1175385623,4),(1268,1188694823,5),(1268,1207440023,4),(1268,1220749223,5),(1268,1238889624,4),(1268,1252198824,5),(1268,1270339224,4),(1268,1283648424,5),(1268,1301788824,4),(1268,1315098024,5),(1268,1333238424,4),(1268,1346547625,5),(1268,1365292825,4),(1268,1377997225,5),(1268,1396742425,4),(1268,1410051625,5),(1268,1428192025,4),(1268,1441501226,5),(1268,1459641626,4),(1268,1472950826,5),(1268,1491091227,4),(1268,1504400427,5),(1269,-2147483648,1),(1269,-880196400,2),(1269,-769395600,3),(1269,-765374400,1),(1269,-86878800,4),(1269,-21466800,5),(1269,-5745600,4),(1269,9982800,5),(1269,25704000,4),(1269,41432400,5),(1269,57758400,4),(1269,73486800,5),(1269,89208001,4),(1269,104936402,5),(1269,120657602,4),(1269,126709203,5),(1269,152107203,4),(1269,162392404,5),(1269,183556804,4),(1269,199285205,5),(1269,215611205,4),(1269,230734806,5),(1269,247060806,4),(1269,262789207,5),(1269,278510407,4),(1269,294238808,5),(1269,309960008,4),(1269,325688409,5),(1269,341409609,4),(1269,357138009,5),(1269,372859210,4),(1269,388587610,5),(1269,404913611,4),(1269,420037211,5),(1269,436363212,6),(1269,439034412,8),(1269,452088012,7),(1269,467809212,8),(1269,483537612,7),(1269,499258813,8),(1269,514987213,7),(1269,530708413,8),(1269,544622413,7),(1269,562158013,8),(1269,576072014,7),(1269,594212414,8),(1269,607521614,7),(1269,625662014,8),(1269,638971215,7),(1269,657111615,8),(1269,671025616,7),(1269,688561216,8),(1269,702475216,7),(1269,720010817,8),(1269,733924817,7),(1269,752065218,8),(1269,765374418,7),(1269,783514819,8),(1269,796824019,7),(1269,814964419,8),(1269,828878420,7),(1269,846414020,8),(1269,860328020,7),(1269,877863621,8),(1269,891777621,7),(1269,909313221,8),(1269,923227222,7),(1269,941367622,8),(1269,954676822,7),(1269,972817222,8),(1269,986126422,7),(1269,1004266822,8),(1269,1018180822,7),(1269,1035716422,8),(1269,1049630422,7),(1269,1067166022,8),(1269,1081080022,7),(1269,1099220422,8),(1269,1112529622,7),(1269,1130670022,8),(1269,1143979223,7),(1269,1162119623,8),(1269,1173614423,7),(1269,1194174023,8),(1269,1205064023,7),(1269,1225623623,8),(1269,1236513624,7),(1269,1257073224,8),(1269,1268568024,7),(1269,1289127624,8),(1269,1300017624,7),(1269,1320577224,8),(1269,1331467224,7),(1269,1352026825,8),(1269,1362916825,7),(1269,1383476425,8),(1269,1394366425,7),(1269,1414926025,8),(1269,1425816025,7),(1269,1446375626,8),(1269,1457870426,7),(1269,1478430026,8),(1269,1489320027,7),(1269,1509879627,8),(1269,1520769627,7),(1269,1541329227,8),(1269,1552219227,7),(1269,1572778827,8),(1269,1583668827,7),(1269,1604228427,8),(1269,1615723227,7),(1269,1636282827,8),(1269,1647172827,7),(1269,1667732427,8),(1269,1678622427,7),(1269,1699182027,8),(1269,1710072027,7),(1269,1730631627,8),(1269,1741521627,7),(1269,1762081227,8),(1269,1772971227,7),(1269,1793530827,8),(1269,1805025627,7),(1269,1825585227,8),(1269,1836475227,7),(1269,1857034827,8),(1269,1867924827,7),(1269,1888484427,8),(1269,1899374427,7),(1269,1919934027,8),(1269,1930824027,7),(1269,1951383627,8),(1269,1962878427,7),(1269,1983438027,8),(1269,1994328027,7),(1269,2014887627,8),(1269,2025777627,7),(1269,2046337227,8),(1269,2057227227,7),(1269,2077786827,8),(1269,2088676827,7),(1269,2109236427,8),(1269,2120126427,7),(1269,2140686027,8),(1270,-2147483648,1),(1270,-880200000,2),(1270,-769395600,3),(1270,-765378000,1),(1270,-86882400,4),(1270,-21470400,5),(1270,-5749200,4),(1270,9979200,5),(1270,25700400,4),(1270,41428800,5),(1270,57754800,4),(1270,73483200,5),(1270,89204401,4),(1270,104932802,5),(1270,120654002,4),(1270,126705603,5),(1270,152103603,4),(1270,162388804,5),(1270,183553204,4),(1270,199281605,5),(1270,215607605,4),(1270,230731206,5),(1270,247057206,4),(1270,262785607,5),(1270,278506807,4),(1270,294235208,5),(1270,309956408,4),(1270,325684809,5),(1270,341406009,4),(1270,357134409,5),(1270,372855610,4),(1270,388584010,5),(1270,404910011,4),(1270,420033611,5),(1270,436359612,6),(1270,439030812,8),(1270,452084412,7),(1270,467805612,8),(1270,483534012,7),(1270,499255213,8),(1270,514983613,7),(1270,530704813,8),(1270,544618813,7),(1270,562154413,8),(1270,576068414,7),(1270,594208814,8),(1270,607518014,7),(1270,625658414,8),(1270,638967615,7),(1270,657108015,8),(1270,671022016,7),(1270,688557616,8),(1270,702471616,7),(1270,720007217,8),(1270,733921217,7),(1270,752061618,8),(1270,765370818,7),(1270,783511219,8),(1270,796820419,7),(1270,814960819,8),(1270,828874820,7),(1270,846410420,8),(1270,860324420,7),(1270,877860021,8),(1270,891774021,7),(1270,909309621,8),(1270,923223622,7),(1270,941364022,8),(1270,954673222,7),(1270,972813622,8),(1270,986122822,7),(1270,1004263222,8),(1270,1018177222,7),(1270,1035712822,8),(1270,1049626822,7),(1270,1067162422,8),(1270,1081076422,7),(1270,1099216822,8),(1270,1112526022,7),(1270,1130666422,8),(1270,1143975623,7),(1270,1162116023,8),(1270,1173610823,7),(1270,1194170423,8),(1270,1205060423,7),(1270,1225620023,8),(1270,1236510024,7),(1270,1257069624,8),(1270,1268564424,7),(1270,1289124024,8),(1270,1300014024,7),(1270,1320573624,8),(1270,1331463624,7),(1270,1352023225,8),(1270,1362913225,7),(1270,1383472825,8),(1270,1394362825,7),(1270,1414922425,8),(1270,1425812425,7),(1270,1446372026,8),(1270,1457866826,7),(1270,1478426426,8),(1270,1489316427,7),(1270,1509876027,8),(1270,1520766027,7),(1270,1541325627,8),(1270,1552215627,7),(1270,1572775227,8),(1270,1583665227,7),(1270,1604224827,8),(1270,1615719627,7),(1270,1636279227,8),(1270,1647169227,7),(1270,1667728827,8),(1270,1678618827,7),(1270,1699178427,8),(1270,1710068427,7),(1270,1730628027,8),(1270,1741518027,7),(1270,1762077627,8),(1270,1772967627,7),(1270,1793527227,8),(1270,1805022027,7),(1270,1825581627,8),(1270,1836471627,7),(1270,1857031227,8),(1270,1867921227,7),(1270,1888480827,8),(1270,1899370827,7),(1270,1919930427,8),(1270,1930820427,7),(1270,1951380027,8),(1270,1962874827,7),(1270,1983434427,8),(1270,1994324427,7),(1270,2014884027,8),(1270,2025774027,7),(1270,2046333627,8),(1270,2057223627,7),(1270,2077783227,8),(1270,2088673227,7),(1270,2109232827,8),(1270,2120122827,7),(1270,2140682427,8),(1271,-2147483648,0),(1271,-1825098836,1),(1272,-2147483648,0),(1272,-1825098836,1),(1273,-2147483648,0),(1273,-1767214032,2),(1273,-1206957600,1),(1273,-1191362400,2),(1273,-1175374800,1),(1273,-1159826400,2),(1273,-633819600,1),(1273,-622069200,2),(1273,-602283600,1),(1273,-591832800,2),(1273,-570747600,1),(1273,-560210400,2),(1273,-539125200,1),(1273,-531352800,2),(1273,-191365200,1),(1273,-184197600,2),(1273,-155163600,1),(1273,-150069600,2),(1273,-128898000,1),(1273,-121125600,2),(1273,-99954000,1),(1273,-89589600,2),(1273,-68418000,1),(1273,-57967200,2),(1273,499748413,1),(1273,511236013,2),(1273,530593213,1),(1273,540266413,2),(1273,562129213,1),(1273,571197614,2),(1273,592974014,1),(1273,602042414,2),(1273,624423614,1),(1273,634701615,2),(1273,813726019,1),(1273,824004020,2),(1273,844570820,1),(1273,856058420,2),(1273,876106821,1),(1273,888717621,2),(1273,908074821,1),(1273,919562422,2),(1273,938919622,1),(1273,951616822,2),(1273,970974022,1),(1273,982461622,2),(1273,1003028422,1),(1273,1013911222,2),(1273,1036292422,1),(1273,1045360822,2),(1273,1350788425,1),(1273,1361066425,2),(1274,-2147483648,1),(1274,-1567453392,2),(1274,-1233432000,3),(1274,-1222981200,2),(1274,-1205956800,3),(1274,-1194037200,2),(1274,-1172865600,3),(1274,-1162501200,2),(1274,-1141329600,3),(1274,-1130965200,2),(1274,-1109793600,3),(1274,-1099429200,2),(1274,-1078257600,3),(1274,-1067806800,2),(1274,-1046635200,3),(1274,-1036270800,2),(1274,-1015099200,3),(1274,-1004734800,2),(1274,-983563200,3),(1274,-973198800,2),(1274,-952027200,3),(1274,-941576400,2),(1274,-931032000,3),(1274,-900882000,2),(1274,-890337600,3),(1274,-833749200,2),(1274,-827265600,3),(1274,-752274000,2),(1274,-733780800,3),(1274,-197326800,2),(1274,-190843200,3),(1274,-184194000,2),(1274,-164491200,3),(1274,-152658000,2),(1274,-132955200,3),(1274,-121122000,2),(1274,-101419200,3),(1274,-86821200,2),(1274,-71092800,3),(1274,-54766800,2),(1274,-39038400,3),(1274,-23317200,2),(1274,-7588800,5),(1274,128142003,4),(1274,136605603,5),(1274,596948414,4),(1274,605066414,5),(1274,624423614,4),(1274,636516015,5),(1274,656478015,4),(1274,667965616,5),(1274,687927616,4),(1274,699415216,5),(1274,719377217,4),(1274,731469617,5),(1274,938919622,3),(1274,952052422,5),(1274,1198983623,4),(1274,1205632823,5),(1274,1224385223,4),(1274,1237082424,5),(1275,-2147483648,1),(1275,-1567453392,2),(1275,-1233432000,3),(1275,-1222981200,2),(1275,-1205956800,3),(1275,-1194037200,2),(1275,-1172865600,3),(1275,-1162501200,2),(1275,-1141329600,3),(1275,-1130965200,2),(1275,-1109793600,3),(1275,-1099429200,2),(1275,-1078257600,3),(1275,-1067806800,2),(1275,-1046635200,3),(1275,-1036270800,2),(1275,-1015099200,3),(1275,-1004734800,2),(1275,-983563200,3),(1275,-973198800,2),(1275,-952027200,3),(1275,-941576400,2),(1275,-931032000,3),(1275,-900882000,2),(1275,-890337600,3),(1275,-833749200,2),(1275,-827265600,3),(1275,-752274000,2),(1275,-733780800,3),(1275,-197326800,2),(1275,-190843200,3),(1275,-184194000,2),(1275,-164491200,3),(1275,-152658000,2),(1275,-132955200,3),(1275,-121122000,2),(1275,-101419200,3),(1275,-86821200,2),(1275,-71092800,3),(1275,-54766800,2),(1275,-39038400,3),(1275,-23317200,2),(1275,-7588800,5),(1275,128142003,4),(1275,136605603,5),(1275,596948414,4),(1275,605066414,5),(1275,624423614,4),(1275,636516015,5),(1275,656478015,4),(1275,667965616,2),(1275,687931216,4),(1275,699415216,5),(1275,719377217,4),(1275,731469617,5),(1275,938919622,3),(1275,952052422,5),(1275,1086058822,2),(1275,1087704022,5),(1275,1198983623,4),(1275,1205632823,5),(1276,-2147483648,1),(1276,-1567453392,2),(1276,-1233432000,3),(1276,-1222981200,2),(1276,-1205956800,3),(1276,-1194037200,2),(1276,-1172865600,3),(1276,-1162501200,2),(1276,-1141329600,3),(1276,-1130965200,2),(1276,-1109793600,3),(1276,-1099429200,2),(1276,-1078257600,3),(1276,-1067806800,2),(1276,-1046635200,3),(1276,-1036270800,2),(1276,-1015099200,3),(1276,-1004734800,2),(1276,-983563200,3),(1276,-973198800,2),(1276,-952027200,3),(1276,-941576400,2),(1276,-931032000,3),(1276,-900882000,2),(1276,-890337600,3),(1276,-833749200,2),(1276,-827265600,3),(1276,-752274000,2),(1276,-733780800,3),(1276,-197326800,2),(1276,-190843200,3),(1276,-184194000,2),(1276,-164491200,3),(1276,-152658000,2),(1276,-132955200,3),(1276,-121122000,2),(1276,-101419200,3),(1276,-86821200,2),(1276,-71092800,3),(1276,-54766800,2),(1276,-39038400,3),(1276,-23317200,2),(1276,-7588800,5),(1276,128142003,4),(1276,136605603,5),(1276,596948414,4),(1276,605066414,5),(1276,624423614,4),(1276,636516015,5),(1276,656478015,4),(1276,667965616,2),(1276,687931216,4),(1276,699415216,5),(1276,719377217,4),(1276,731469617,5),(1276,938919622,3),(1276,952052422,5),(1276,1086058822,2),(1276,1087704022,5),(1276,1198983623,4),(1276,1205632823,5),(1277,-2147483648,1),(1277,-1567453392,2),(1277,-1233432000,3),(1277,-1222981200,2),(1277,-1205956800,3),(1277,-1194037200,2),(1277,-1172865600,3),(1277,-1162501200,2),(1277,-1141329600,3),(1277,-1130965200,2),(1277,-1109793600,3),(1277,-1099429200,2),(1277,-1078257600,3),(1277,-1067806800,2),(1277,-1046635200,3),(1277,-1036270800,2),(1277,-1015099200,3),(1277,-1004734800,2),(1277,-983563200,3),(1277,-973198800,2),(1277,-952027200,3),(1277,-941576400,2),(1277,-931032000,3),(1277,-900882000,2),(1277,-890337600,3),(1277,-833749200,2),(1277,-827265600,3),(1277,-752274000,2),(1277,-733780800,3),(1277,-197326800,2),(1277,-190843200,3),(1277,-184194000,2),(1277,-164491200,3),(1277,-152658000,2),(1277,-132955200,3),(1277,-121122000,2),(1277,-101419200,3),(1277,-86821200,2),(1277,-71092800,3),(1277,-54766800,2),(1277,-39038400,3),(1277,-23317200,2),(1277,-7588800,5),(1277,128142003,4),(1277,136605603,5),(1277,596948414,4),(1277,605066414,5),(1277,624423614,4),(1277,636516015,5),(1277,656478015,4),(1277,667965616,2),(1277,687931216,4),(1277,699415216,5),(1277,719377217,4),(1277,731469617,5),(1277,938919622,3),(1277,952052422,5),(1277,1198983623,4),(1277,1205632823,5),(1277,1224385223,4),(1277,1237082424,5),(1278,-2147483648,1),(1278,-1567453392,2),(1278,-1233432000,3),(1278,-1222981200,2),(1278,-1205956800,3),(1278,-1194037200,2),(1278,-1172865600,3),(1278,-1162501200,2),(1278,-1141329600,3),(1278,-1130965200,2),(1278,-1109793600,3),(1278,-1099429200,2),(1278,-1078257600,3),(1278,-1067806800,2),(1278,-1046635200,3),(1278,-1036270800,2),(1278,-1015099200,3),(1278,-1004734800,2),(1278,-983563200,3),(1278,-973198800,2),(1278,-952027200,3),(1278,-941576400,2),(1278,-931032000,3),(1278,-900882000,2),(1278,-890337600,3),(1278,-833749200,2),(1278,-827265600,3),(1278,-752274000,2),(1278,-733780800,3),(1278,-197326800,2),(1278,-190843200,3),(1278,-184194000,2),(1278,-164491200,3),(1278,-152658000,2),(1278,-132955200,3),(1278,-121122000,2),(1278,-101419200,3),(1278,-86821200,2),(1278,-71092800,3),(1278,-54766800,2),(1278,-39038400,3),(1278,-23317200,2),(1278,-7588800,5),(1278,128142003,4),(1278,136605603,5),(1278,596948414,4),(1278,605066414,5),(1278,624423614,4),(1278,636516015,2),(1278,657086415,3),(1278,669178816,2),(1278,686721616,4),(1278,699415216,5),(1278,719377217,4),(1278,731469617,5),(1278,938919622,3),(1278,952052422,5),(1278,1198983623,4),(1278,1205632823,5),(1279,-2147483648,1),(1279,-1567453392,2),(1279,-1233432000,3),(1279,-1222981200,2),(1279,-1205956800,3),(1279,-1194037200,2),(1279,-1172865600,3),(1279,-1162501200,2),(1279,-1141329600,3),(1279,-1130965200,2),(1279,-1109793600,3),(1279,-1099429200,2),(1279,-1078257600,3),(1279,-1067806800,2),(1279,-1046635200,3),(1279,-1036270800,2),(1279,-1015099200,3),(1279,-1004734800,2),(1279,-983563200,3),(1279,-973198800,2),(1279,-952027200,3),(1279,-941576400,2),(1279,-931032000,3),(1279,-900882000,2),(1279,-890337600,3),(1279,-833749200,2),(1279,-827265600,3),(1279,-752274000,2),(1279,-733780800,3),(1279,-197326800,2),(1279,-190843200,3),(1279,-184194000,2),(1279,-164491200,3),(1279,-152658000,2),(1279,-132955200,3),(1279,-121122000,2),(1279,-101419200,3),(1279,-86821200,2),(1279,-71092800,3),(1279,-54766800,2),(1279,-39038400,3),(1279,-23317200,2),(1279,-7588800,5),(1279,128142003,4),(1279,136605603,5),(1279,596948414,4),(1279,605066414,5),(1279,624423614,4),(1279,636516015,5),(1279,656478015,4),(1279,667792816,2),(1279,673588816,5),(1279,687927616,4),(1279,699415216,5),(1279,719377217,4),(1279,731469617,5),(1279,938919622,3),(1279,952052422,5),(1279,1086058822,2),(1279,1087704022,5),(1279,1198983623,4),(1279,1205632823,5),(1280,-2147483648,1),(1280,-1567453392,2),(1280,-1233432000,3),(1280,-1222981200,2),(1280,-1205956800,3),(1280,-1194037200,2),(1280,-1172865600,3),(1280,-1162501200,2),(1280,-1141329600,3),(1280,-1130965200,2),(1280,-1109793600,3),(1280,-1099429200,2),(1280,-1078257600,3),(1280,-1067806800,2),(1280,-1046635200,3),(1280,-1036270800,2),(1280,-1015099200,3),(1280,-1004734800,2),(1280,-983563200,3),(1280,-973198800,2),(1280,-952027200,3),(1280,-941576400,2),(1280,-931032000,3),(1280,-900882000,2),(1280,-890337600,3),(1280,-833749200,2),(1280,-827265600,3),(1280,-752274000,2),(1280,-733780800,3),(1280,-197326800,2),(1280,-190843200,3),(1280,-184194000,2),(1280,-164491200,3),(1280,-152658000,2),(1280,-132955200,3),(1280,-121122000,2),(1280,-101419200,3),(1280,-86821200,2),(1280,-71092800,3),(1280,-54766800,2),(1280,-39038400,3),(1280,-23317200,2),(1280,-7588800,5),(1280,128142003,4),(1280,136605603,5),(1280,596948414,4),(1280,605066414,5),(1280,624423614,4),(1280,636516015,2),(1280,655963215,3),(1280,667796416,2),(1280,687499216,3),(1280,699418816,2),(1280,719380817,4),(1280,731469617,5),(1280,938919622,3),(1280,952052422,5),(1280,1085281222,2),(1280,1096171222,5),(1280,1198983623,4),(1280,1205632823,5),(1281,-2147483648,1),(1281,-1567453392,2),(1281,-1233432000,3),(1281,-1222981200,2),(1281,-1205956800,3),(1281,-1194037200,2),(1281,-1172865600,3),(1281,-1162501200,2),(1281,-1141329600,3),(1281,-1130965200,2),(1281,-1109793600,3),(1281,-1099429200,2),(1281,-1078257600,3),(1281,-1067806800,2),(1281,-1046635200,3),(1281,-1036270800,2),(1281,-1015099200,3),(1281,-1004734800,2),(1281,-983563200,3),(1281,-973198800,2),(1281,-952027200,3),(1281,-941576400,2),(1281,-931032000,3),(1281,-900882000,2),(1281,-890337600,3),(1281,-833749200,2),(1281,-827265600,3),(1281,-752274000,2),(1281,-733780800,3),(1281,-197326800,2),(1281,-190843200,3),(1281,-184194000,2),(1281,-164491200,3),(1281,-152658000,2),(1281,-132955200,3),(1281,-121122000,2),(1281,-101419200,3),(1281,-86821200,2),(1281,-71092800,3),(1281,-54766800,2),(1281,-39038400,3),(1281,-23317200,2),(1281,-7588800,5),(1281,128142003,4),(1281,136605603,5),(1281,596948414,4),(1281,605066414,5),(1281,624423614,4),(1281,636516015,5),(1281,656478015,4),(1281,667965616,5),(1281,687927616,4),(1281,699415216,5),(1281,719377217,4),(1281,731469617,5),(1281,938919622,3),(1281,952052422,5),(1281,1086058822,2),(1281,1087704022,5),(1281,1198983623,4),(1281,1205632823,5),(1282,-2147483648,1),(1282,-1567453392,2),(1282,-1233432000,3),(1282,-1222981200,2),(1282,-1205956800,3),(1282,-1194037200,2),(1282,-1172865600,3),(1282,-1162501200,2),(1282,-1141329600,3),(1282,-1130965200,2),(1282,-1109793600,3),(1282,-1099429200,2),(1282,-1078257600,3),(1282,-1067806800,2),(1282,-1046635200,3),(1282,-1036270800,2),(1282,-1015099200,3),(1282,-1004734800,2),(1282,-983563200,3),(1282,-973198800,2),(1282,-952027200,3),(1282,-941576400,2),(1282,-931032000,3),(1282,-900882000,2),(1282,-890337600,3),(1282,-833749200,2),(1282,-827265600,3),(1282,-752274000,2),(1282,-733780800,3),(1282,-197326800,2),(1282,-190843200,3),(1282,-184194000,2),(1282,-164491200,3),(1282,-152658000,2),(1282,-132955200,3),(1282,-121122000,2),(1282,-101419200,3),(1282,-86821200,2),(1282,-71092800,3),(1282,-54766800,2),(1282,-39038400,3),(1282,-23317200,2),(1282,-7588800,5),(1282,128142003,4),(1282,136605603,5),(1282,596948414,4),(1282,605066414,5),(1282,624423614,4),(1282,636516015,5),(1282,656478015,4),(1282,667965616,2),(1282,687931216,4),(1282,699415216,5),(1282,719377217,4),(1282,731469617,5),(1282,938919622,3),(1282,952052422,5),(1282,1198983623,4),(1282,1205632823,5),(1283,-2147483648,1),(1283,-1567453392,2),(1283,-1233432000,3),(1283,-1222981200,2),(1283,-1205956800,3),(1283,-1194037200,2),(1283,-1172865600,3),(1283,-1162501200,2),(1283,-1141329600,3),(1283,-1130965200,2),(1283,-1109793600,3),(1283,-1099429200,2),(1283,-1078257600,3),(1283,-1067806800,2),(1283,-1046635200,3),(1283,-1036270800,2),(1283,-1015099200,3),(1283,-1004734800,2),(1283,-983563200,3),(1283,-973198800,2),(1283,-952027200,3),(1283,-941576400,2),(1283,-931032000,3),(1283,-900882000,2),(1283,-890337600,3),(1283,-833749200,2),(1283,-827265600,3),(1283,-752274000,2),(1283,-733780800,3),(1283,-197326800,2),(1283,-190843200,3),(1283,-184194000,2),(1283,-164491200,3),(1283,-152658000,2),(1283,-132955200,3),(1283,-121122000,2),(1283,-101419200,3),(1283,-86821200,2),(1283,-71092800,3),(1283,-54766800,2),(1283,-39038400,3),(1283,-23317200,2),(1283,-7588800,5),(1283,128142003,4),(1283,136605603,5),(1283,596948414,4),(1283,605066414,5),(1283,624423614,4),(1283,636516015,5),(1283,656478015,4),(1283,667792816,2),(1283,673588816,5),(1283,687927616,4),(1283,699415216,5),(1283,719377217,4),(1283,731469617,5),(1283,938919622,3),(1283,952052422,5),(1283,1085972422,2),(1283,1090728022,5),(1283,1198983623,4),(1283,1205632823,5),(1284,-2147483648,1),(1284,-1567453392,2),(1284,-1233432000,3),(1284,-1222981200,2),(1284,-1205956800,3),(1284,-1194037200,2),(1284,-1172865600,3),(1284,-1162501200,2),(1284,-1141329600,3),(1284,-1130965200,2),(1284,-1109793600,3),(1284,-1099429200,2),(1284,-1078257600,3),(1284,-1067806800,2),(1284,-1046635200,3),(1284,-1036270800,2),(1284,-1015099200,3),(1284,-1004734800,2),(1284,-983563200,3),(1284,-973198800,2),(1284,-952027200,3),(1284,-941576400,2),(1284,-931032000,3),(1284,-900882000,2),(1284,-890337600,3),(1284,-833749200,2),(1284,-827265600,3),(1284,-752274000,2),(1284,-733780800,3),(1284,-197326800,2),(1284,-190843200,3),(1284,-184194000,2),(1284,-164491200,3),(1284,-152658000,2),(1284,-132955200,3),(1284,-121122000,2),(1284,-101419200,3),(1284,-86821200,2),(1284,-71092800,3),(1284,-54766800,2),(1284,-39038400,3),(1284,-23317200,2),(1284,-7588800,5),(1284,128142003,4),(1284,136605603,5),(1284,596948414,4),(1284,605066414,5),(1284,624423614,4),(1284,637380015,2),(1284,655963215,3),(1284,667796416,2),(1284,675748816,5),(1284,938919622,3),(1284,952052422,5),(1284,1085972422,2),(1284,1090728022,5),(1284,1198983623,4),(1284,1200880823,3),(1284,1205031623,2),(1284,1223784023,3),(1284,1236481224,2),(1284,1255233624,5),(1285,-2147483648,1),(1285,-1567453392,2),(1285,-1233432000,3),(1285,-1222981200,2),(1285,-1205956800,3),(1285,-1194037200,2),(1285,-1172865600,3),(1285,-1162501200,2),(1285,-1141329600,3),(1285,-1130965200,2),(1285,-1109793600,3),(1285,-1099429200,2),(1285,-1078257600,3),(1285,-1067806800,2),(1285,-1046635200,3),(1285,-1036270800,2),(1285,-1015099200,3),(1285,-1004734800,2),(1285,-983563200,3),(1285,-973198800,2),(1285,-952027200,3),(1285,-941576400,2),(1285,-931032000,3),(1285,-900882000,2),(1285,-890337600,3),(1285,-833749200,2),(1285,-827265600,3),(1285,-752274000,2),(1285,-733780800,3),(1285,-197326800,2),(1285,-190843200,3),(1285,-184194000,2),(1285,-164491200,3),(1285,-152658000,2),(1285,-132955200,3),(1285,-121122000,2),(1285,-101419200,3),(1285,-86821200,2),(1285,-71092800,3),(1285,-54766800,2),(1285,-39038400,3),(1285,-23317200,2),(1285,-7588800,5),(1285,128142003,4),(1285,136605603,5),(1285,596948414,4),(1285,605066414,5),(1285,624423614,4),(1285,636516015,5),(1285,656478015,4),(1285,667965616,2),(1285,687931216,4),(1285,699415216,5),(1285,719377217,4),(1285,731469617,5),(1285,938919622,3),(1285,952052422,5),(1285,1086058822,2),(1285,1087099222,5),(1285,1198983623,4),(1285,1205632823,5),(1285,1224385223,4),(1285,1237082424,5),(1286,-2147483648,1),(1286,-1567453392,2),(1286,-1233432000,3),(1286,-1222981200,2),(1286,-1205956800,3),(1286,-1194037200,2),(1286,-1172865600,3),(1286,-1162501200,2),(1286,-1141329600,3),(1286,-1130965200,2),(1286,-1109793600,3),(1286,-1099429200,2),(1286,-1078257600,3),(1286,-1067806800,2),(1286,-1046635200,3),(1286,-1036270800,2),(1286,-1015099200,3),(1286,-1004734800,2),(1286,-983563200,3),(1286,-973198800,2),(1286,-952027200,3),(1286,-941576400,2),(1286,-931032000,3),(1286,-900882000,2),(1286,-890337600,3),(1286,-833749200,2),(1286,-827265600,3),(1286,-752274000,2),(1286,-733780800,3),(1286,-197326800,2),(1286,-190843200,3),(1286,-184194000,2),(1286,-164491200,3),(1286,-152658000,2),(1286,-132955200,3),(1286,-121122000,2),(1286,-101419200,3),(1286,-86821200,2),(1286,-71092800,3),(1286,-54766800,2),(1286,-39038400,3),(1286,-23317200,2),(1286,-7588800,5),(1286,128142003,4),(1286,136605603,5),(1286,596948414,4),(1286,605066414,5),(1286,624423614,4),(1286,636516015,5),(1286,656478015,4),(1286,667965616,5),(1286,687927616,4),(1286,699415216,5),(1286,719377217,4),(1286,731469617,5),(1286,938919622,3),(1286,952052422,5),(1286,1085886022,2),(1286,1087704022,5),(1286,1198983623,4),(1286,1205632823,5),(1287,-2147483648,0),(1287,-1826738653,1),(1287,-157750200,2),(1288,-2147483648,1),(1288,-1206389360,2),(1288,86760001,3),(1288,134017203,2),(1288,181368004,4),(1288,194497205,2),(1288,212990405,4),(1288,226033206,2),(1288,244526406,4),(1288,257569207,2),(1288,276062407,4),(1288,291783608,2),(1288,307598408,4),(1288,323406009,2),(1288,339220809,4),(1288,354942009,2),(1288,370756810,4),(1288,386478010,2),(1288,402292811,4),(1288,418014011,2),(1288,433828812,4),(1288,449636412,2),(1288,465451212,4),(1288,481172412,2),(1288,496987213,4),(1288,512708413,2),(1288,528523213,4),(1288,544244413,2),(1288,560059213,4),(1288,575866814,2),(1288,591681614,4),(1288,607402814,2),(1288,625032014,4),(1288,638938815,2),(1288,654753615,4),(1288,670474816,2),(1288,686721616,4),(1288,699418816,2),(1288,718257617,4),(1288,733546817,2),(1288,749448018,4),(1288,762318018,2),(1288,780984019,4),(1288,793767619,2),(1288,812520019,4),(1288,825649220,2),(1288,844574420,4),(1288,856666820,2),(1288,876024021,4),(1288,888721221,2),(1288,907473621,4),(1288,920775622,2),(1288,938923222,4),(1288,952225222,2),(1288,970372822,4),(1288,983674822,2),(1288,1002427222,4),(1288,1018148422,2),(1288,1030852822,4),(1288,1049598022,2),(1288,1062907222,4),(1288,1081047622,2),(1288,1097985622,4),(1288,1110682822,2),(1288,1129435222,4),(1288,1142132423,2),(1288,1160884823,4),(1288,1173582023,2),(1288,1192939223,4),(1288,1205031623,2),(1288,1224388823,4),(1288,1236481224,2),(1288,1255838424,4),(1288,1270954824,2),(1288,1286078424,4),(1288,1302404424,2),(1288,1317528024,4),(1288,1333854024,2),(1288,1349582425,4),(1288,1364094025,2),(1288,1381032025,4),(1288,1395543625,2),(1288,1412481625,4),(1288,1426993225,2),(1288,1443931226,4),(1288,1459047626,2),(1288,1475380826,4),(1288,1490497227,2),(1288,1506830427,4),(1288,1521946827,2),(1288,1538884827,4),(1288,1553396427,2),(1288,1570334427,4),(1288,1584846027,2),(1288,1601784027,4),(1288,1616900427,2),(1288,1633233627,4),(1288,1648350027,2),(1288,1664683227,4),(1288,1679799627,2),(1288,1696132827,4),(1288,1711249227,2),(1288,1728187227,4),(1288,1742698827,2),(1288,1759636827,4),(1288,1774148427,2),(1288,1791086427,4),(1288,1806202827,2),(1288,1822536027,4),(1288,1837652427,2),(1288,1853985627,4),(1288,1869102027,2),(1288,1886040027,4),(1288,1900551627,2),(1288,1917489627,4),(1288,1932001227,2),(1288,1948939227,4),(1288,1964055627,2),(1288,1980388827,4),(1288,1995505227,2),(1288,2011838427,4),(1288,2026954827,2),(1288,2043288027,4),(1288,2058404427,2),(1288,2075342427,4),(1288,2089854027,2),(1288,2106792027,4),(1288,2121303627,2),(1288,2138241627,4),(1289,-2147483648,2),(1289,-1632067200,1),(1289,-1615136400,2),(1289,-923248800,1),(1289,-880214400,3),(1289,-769395600,4),(1289,-765392400,5),(1290,-2147483648,1),(1290,-880196400,2),(1290,-769395600,3),(1290,-765374400,1),(1290,-86878800,4),(1290,-21466800,5),(1290,-5745600,4),(1290,9982800,5),(1290,25704000,4),(1290,41432400,5),(1290,57758400,4),(1290,73486800,5),(1290,89208001,4),(1290,104936402,5),(1290,120657602,4),(1290,126709203,5),(1290,152107203,4),(1290,162392404,5),(1290,183556804,4),(1290,199285205,5),(1290,215611205,4),(1290,230734806,5),(1290,247060806,4),(1290,262789207,5),(1290,278510407,4),(1290,294238808,5),(1290,309960008,4),(1290,325688409,5),(1290,341409609,4),(1290,357138009,5),(1290,372859210,4),(1290,388587610,5),(1290,404913611,4),(1290,420037211,5),(1290,436363212,6),(1290,439034412,8),(1290,452088012,7),(1290,467809212,8),(1290,483537612,7),(1290,499258813,8),(1290,514987213,7),(1290,530708413,8),(1290,544622413,7),(1290,562158013,8),(1290,576072014,7),(1290,594212414,8),(1290,607521614,7),(1290,625662014,8),(1290,638971215,7),(1290,657111615,8),(1290,671025616,7),(1290,688561216,8),(1290,702475216,7),(1290,720010817,8),(1290,733924817,7),(1290,752065218,8),(1290,765374418,7),(1290,783514819,8),(1290,796824019,7),(1290,814964419,8),(1290,828878420,7),(1290,846414020,8),(1290,860328020,7),(1290,877863621,8),(1290,891777621,7),(1290,909313221,8),(1290,923227222,7),(1290,941367622,8),(1290,954676822,7),(1290,972817222,8),(1290,986126422,7),(1290,1004266822,8),(1290,1018180822,7),(1290,1035716422,8),(1290,1049630422,7),(1290,1067166022,8),(1290,1081080022,7),(1290,1099220422,8),(1290,1112529622,7),(1290,1130670022,8),(1290,1143979223,7),(1290,1162119623,8),(1290,1173614423,7),(1290,1194174023,8),(1290,1205064023,7),(1290,1225623623,8),(1290,1236513624,7),(1290,1257073224,8),(1290,1268568024,7),(1290,1289127624,8),(1290,1300017624,7),(1290,1320577224,8),(1290,1331467224,7),(1290,1352026825,8),(1290,1362916825,7),(1290,1383476425,8),(1290,1394366425,7),(1290,1414926025,8),(1290,1425816025,7),(1290,1446375626,8),(1290,1457870426,7),(1290,1478430026,8),(1290,1489320027,7),(1290,1509879627,8),(1290,1520769627,7),(1290,1541329227,8),(1290,1552219227,7),(1290,1572778827,8),(1290,1583668827,7),(1290,1604228427,8),(1290,1615723227,7),(1290,1636282827,8),(1290,1647172827,7),(1290,1667732427,8),(1290,1678622427,7),(1290,1699182027,8),(1290,1710072027,7),(1290,1730631627,8),(1290,1741521627,7),(1290,1762081227,8),(1290,1772971227,7),(1290,1793530827,8),(1290,1805025627,7),(1290,1825585227,8),(1290,1836475227,7),(1290,1857034827,8),(1290,1867924827,7),(1290,1888484427,8),(1290,1899374427,7),(1290,1919934027,8),(1290,1930824027,7),(1290,1951383627,8),(1290,1962878427,7),(1290,1983438027,8),(1290,1994328027,7),(1290,2014887627,8),(1290,2025777627,7),(1290,2046337227,8),(1290,2057227227,7),(1290,2077786827,8),(1290,2088676827,7),(1290,2109236427,8),(1290,2120126427,7),(1290,2140686027,8),(1291,-2147483648,0),(1291,-1767216356,2),(1291,-1206957600,1),(1291,-1191362400,2),(1291,-1175374800,1),(1291,-1159826400,2),(1291,-633819600,1),(1291,-622069200,2),(1291,-602283600,1),(1291,-591832800,2),(1291,-570747600,1),(1291,-560210400,2),(1291,-539125200,1),(1291,-531352800,2),(1291,-191365200,1),(1291,-184197600,2),(1291,-155163600,1),(1291,-150069600,2),(1291,-128898000,1),(1291,-121125600,2),(1291,-99954000,1),(1291,-89589600,2),(1291,-68418000,1),(1291,-57967200,2),(1291,499748413,1),(1291,511236013,2),(1291,530593213,1),(1291,540266413,2),(1291,562129213,1),(1291,571197614,2),(1291,592974014,1),(1291,602042414,2),(1291,624423614,1),(1291,634701615,2),(1291,656478015,1),(1291,666756016,2),(1291,687927616,1),(1291,697600816,2),(1291,719982017,1),(1291,728445617,2),(1291,750826818,1),(1291,761709618,2),(1291,782276419,1),(1291,793159219,2),(1291,813726019,1),(1291,824004020,2),(1291,844570820,1),(1291,856058420,2),(1291,876106821,1),(1291,888717621,2),(1291,908074821,1),(1291,919562422,2),(1291,938919622,1),(1291,951616822,2),(1291,970974022,1),(1291,982461622,2),(1291,1003028422,1),(1291,1013911222,2),(1291,1036292422,1),(1291,1045360822,2),(1291,1318734024,1),(1291,1330221624,2),(1292,-2147483648,0),(1292,-1514739600,1),(1292,-1343066400,2),(1292,-1234807200,1),(1292,-1220292000,2),(1292,-1207159200,1),(1292,-1191344400,2),(1292,-873828000,1),(1292,-661539600,3),(1292,28800,1),(1292,828867620,4),(1292,846403220,1),(1292,860317220,4),(1292,877852821,1),(1292,891766821,4),(1292,909302421,1),(1292,923216422,4),(1292,941356822,1),(1292,954666022,4),(1292,972806422,1),(1292,989139622,4),(1292,1001836822,1),(1292,1018170022,4),(1292,1035705622,1),(1292,1049619622,4),(1292,1067155222,1),(1292,1081069222,4),(1292,1099209622,1),(1292,1112518822,4),(1292,1130659222,1),(1292,1143968423,4),(1292,1162108823,1),(1292,1175418023,4),(1292,1193558423,1),(1292,1207472423,4),(1292,1225008023,1),(1292,1238922024,4),(1292,1256457624,1),(1292,1270371624,5),(1292,1288508424,2),(1292,1301817624,5),(1292,1319958024,2),(1292,1333267224,5),(1292,1351407625,2),(1292,1365321625,5),(1292,1382857225,2),(1292,1396771225,5),(1292,1414306825,2),(1292,1428220825,5),(1292,1445756426,2),(1292,1459670426,5),(1292,1477810826,2),(1292,1491120027,5),(1292,1509260427,2),(1292,1522569627,5),(1292,1540710027,2),(1292,1554624027,5),(1292,1572159627,2),(1292,1586073627,5),(1292,1603609227,2),(1292,1617523227,5),(1292,1635663627,2),(1292,1648972827,5),(1292,1667113227,2),(1292,1680422427,5),(1292,1698562827,2),(1292,1712476827,5),(1292,1730012427,2),(1292,1743926427,5),(1292,1761462027,2),(1292,1775376027,5),(1292,1792911627,2),(1292,1806825627,5),(1292,1824966027,2),(1292,1838275227,5),(1292,1856415627,2),(1292,1869724827,5),(1292,1887865227,2),(1292,1901779227,5),(1292,1919314827,2),(1292,1933228827,5),(1292,1950764427,2),(1292,1964678427,5),(1292,1982818827,2),(1292,1996128027,5),(1292,2014268427,2),(1292,2027577627,5),(1292,2045718027,2),(1292,2059027227,5),(1292,2077167627,2),(1292,2091081627,5),(1292,2108617227,2),(1292,2122531227,5),(1292,2140066827,2),(1293,-2147483648,0),(1293,-1451678491,1),(1293,-1199217691,3),(1293,234943206,2),(1293,244616406,3),(1293,261554407,2),(1293,276066007,3),(1293,293004008,2),(1293,307515608,3),(1293,325058409,2),(1293,338706009,3),(1294,-2147483648,0),(1294,-1767213964,2),(1294,-1206957600,1),(1294,-1191362400,2),(1294,-1175374800,1),(1294,-1159826400,2),(1294,-633819600,1),(1294,-622069200,2),(1294,-602283600,1),(1294,-591832800,2),(1294,-570747600,1),(1294,-560210400,2),(1294,-539125200,1),(1294,-531352800,2),(1294,-191365200,1),(1294,-184197600,2),(1294,-155163600,1),(1294,-150069600,2),(1294,-128898000,1),(1294,-121125600,2),(1294,-99954000,1),(1294,-89589600,2),(1294,-68418000,1),(1294,-57967200,2),(1294,499748413,1),(1294,511236013,2),(1294,530593213,1),(1294,540266413,2),(1294,562129213,1),(1294,571197614,2),(1295,-2147483648,0),(1295,-1822500432,2),(1295,-1616954400,1),(1295,-1606069800,2),(1295,-1585504800,1),(1295,-1574015400,2),(1295,-1554055200,1),(1295,-1542565800,2),(1295,-1522605600,1),(1295,-1511116200,2),(1295,-1490551200,1),(1295,-1479666600,2),(1295,-1459101600,1),(1295,-1448217000,2),(1295,-1427652000,1),(1295,-1416162600,2),(1295,-1396202400,1),(1295,-1384713000,2),(1295,-1364752800,1),(1295,-1353263400,2),(1295,-1333303200,1),(1295,-1321813800,2),(1295,-1301248800,1),(1295,-1290364200,2),(1295,-1269799200,1),(1295,-1258914600,2),(1295,-1238349600,1),(1295,-1226860200,2),(1295,-1206900000,1),(1295,-1195410600,2),(1295,-1175450400,1),(1295,-1163961000,2),(1295,-1143396000,1),(1295,-1132511400,2),(1295,-1111946400,1),(1295,-1101061800,2),(1295,-1080496800,1),(1295,-1069612200,2),(1295,-1049047200,1),(1295,-1037557800,2),(1295,-1017597600,1),(1295,-1006108200,2),(1295,-986148000,1),(1295,-974658600,2),(1295,-954093600,1),(1295,-943209000,2),(1295,-922644000,1),(1295,-911759400,2),(1295,-891194400,1),(1295,-879705000,2),(1295,-859744800,1),(1295,-848255400,2),(1295,123919202,3),(1295,129618003,2),(1295,409039211,3),(1295,413874011,2),(1296,-2147483648,2),(1296,-1632074400,1),(1296,-1615143600,2),(1296,-880221600,3),(1296,-769395600,4),(1296,-765399600,2),(1297,-2147483648,0),(1297,-1767211040,2),(1297,-1206954000,1),(1297,-1191358800,2),(1297,-1175371200,1),(1297,-1159822800,2),(1297,-633816000,1),(1297,-622065600,2),(1297,-602280000,1),(1297,-591829200,2),(1297,-570744000,1),(1297,-560206800,2),(1297,-539121600,1),(1297,-531349200,2),(1297,-191361600,1),(1297,-184194000,2),(1297,-155160000,1),(1297,-150066000,2),(1297,-128894400,1),(1297,-121122000,2),(1297,-99950400,1),(1297,-89586000,2),(1297,-68414400,1),(1297,-57963600,2),(1297,499752013,1),(1297,511239613,2),(1297,530596813,1),(1297,540270013,2),(1297,562132813,1),(1297,571201214,2),(1297,938923222,1),(1297,951620422,2),(1297,970977622,1),(1297,971578822,2),(1298,-2147483648,1),(1298,-1739041424,3),(1298,704869216,2),(1298,733896017,3),(1299,-2147483648,2),(1299,-1633269600,1),(1299,-1615129200,2),(1299,-1601820000,1),(1299,-1583679600,2),(1299,-1471788000,5),(1299,-880210800,3),(1299,-769395600,4),(1299,-765388800,5),(1299,-84380400,6),(1299,-68659200,5),(1299,-52930800,6),(1299,-37209600,5),(1299,-21481200,6),(1299,-5760000,5),(1299,9968400,6),(1299,25689600,5),(1299,41418000,6),(1299,57744000,5),(1299,73472400,6),(1299,89193601,5),(1299,104922002,6),(1299,120643202,5),(1299,129114003,6),(1299,152092803,5),(1299,162378004,6),(1299,183542404,5),(1299,199270805,6),(1299,215596805,5),(1299,230720406,6),(1299,247046406,5),(1299,262774807,6),(1299,278496007,5),(1299,294224408,6),(1299,309945608,5),(1299,325674009,6),(1299,341395209,5),(1299,357123609,6),(1299,372844810,5),(1299,388573210,6),(1299,404899211,5),(1299,420022811,6),(1299,436348812,5),(1299,452077212,6),(1299,467798412,5),(1299,483526812,6),(1299,499248013,5),(1299,514976413,6),(1299,530697613,5),(1299,544611613,6),(1299,562147213,5),(1299,576061214,6),(1299,594201614,5),(1299,607510814,6),(1299,625651214,5),(1299,638960415,6),(1299,657100815,5),(1299,671014816,6),(1299,688550416,5),(1299,702464416,6),(1299,720000017,5),(1299,733914017,6),(1299,752054418,5),(1299,765363618,6),(1299,783504019,5),(1299,796813219,6),(1299,814953619,5),(1299,828867620,6),(1299,846403220,5),(1299,860317220,6),(1299,877852821,5),(1299,891766821,6),(1299,909302421,5),(1299,923216422,6),(1299,941356822,5),(1299,954666022,6),(1299,972806422,5),(1299,986115622,6),(1299,1004256022,5),(1299,1018170022,6),(1299,1035705622,5),(1299,1049619622,6),(1299,1067155222,5),(1299,1081069222,6),(1299,1099209622,5),(1299,1112518822,6),(1299,1130659222,5),(1299,1143968423,6),(1299,1162108823,5),(1299,1173603623,6),(1299,1194163223,5),(1299,1205053223,6),(1299,1225612823,5),(1299,1236502824,6),(1299,1257062424,5),(1299,1268557224,6),(1299,1289116824,5),(1299,1300006824,6),(1299,1320566424,5),(1299,1331456424,6),(1299,1352016025,5),(1299,1362906025,6),(1299,1383465625,5),(1299,1394355625,6),(1299,1414915225,5),(1299,1425805225,6),(1299,1446364826,5),(1299,1457859626,6),(1299,1478419226,5),(1299,1489309227,6),(1299,1509868827,5),(1299,1520758827,6),(1299,1541318427,5),(1299,1552208427,6),(1299,1572768027,5),(1299,1583658027,6),(1299,1604217627,5),(1299,1615712427,6),(1299,1636272027,5),(1299,1647162027,6),(1299,1667721627,5),(1299,1678611627,6),(1299,1699171227,5),(1299,1710061227,6),(1299,1730620827,5),(1299,1741510827,6),(1299,1762070427,5),(1299,1772960427,6),(1299,1793520027,5),(1299,1805014827,6),(1299,1825574427,5),(1299,1836464427,6),(1299,1857024027,5),(1299,1867914027,6),(1299,1888473627,5),(1299,1899363627,6),(1299,1919923227,5),(1299,1930813227,6),(1299,1951372827,5),(1299,1962867627,6),(1299,1983427227,5),(1299,1994317227,6),(1299,2014876827,5),(1299,2025766827,6),(1299,2046326427,5),(1299,2057216427,6),(1299,2077776027,5),(1299,2088666027,6),(1299,2109225627,5),(1299,2120115627,6),(1299,2140675227,5),(1300,-2147483648,1),(1300,-1567453392,2),(1300,-1233432000,3),(1300,-1222981200,2),(1300,-1205956800,3),(1300,-1194037200,2),(1300,-1172865600,3),(1300,-1162501200,2),(1300,-1141329600,3),(1300,-1130965200,2),(1300,-1109793600,3),(1300,-1099429200,2),(1300,-1078257600,3),(1300,-1067806800,2),(1300,-1046635200,3),(1300,-1036270800,2),(1300,-1015099200,3),(1300,-1004734800,2),(1300,-983563200,3),(1300,-973198800,2),(1300,-952027200,3),(1300,-941576400,2),(1300,-931032000,3),(1300,-900882000,2),(1300,-890337600,3),(1300,-833749200,2),(1300,-827265600,3),(1300,-752274000,2),(1300,-733780800,3),(1300,-197326800,2),(1300,-190843200,3),(1300,-184194000,2),(1300,-164491200,3),(1300,-152658000,2),(1300,-132955200,3),(1300,-121122000,2),(1300,-101419200,3),(1300,-86821200,2),(1300,-71092800,3),(1300,-54766800,2),(1300,-39038400,3),(1300,-23317200,2),(1300,-7588800,5),(1300,128142003,4),(1300,136605603,5),(1300,596948414,4),(1300,605066414,5),(1300,624423614,4),(1300,636516015,5),(1300,656478015,4),(1300,667965616,5),(1300,687927616,4),(1300,699415216,5),(1300,719377217,4),(1300,731469617,5),(1300,938919622,3),(1300,952052422,5),(1300,1198983623,4),(1300,1205632823,5),(1300,1224385223,4),(1300,1237082424,5),(1301,-2147483648,0),(1301,-1577923200,3),(1301,-880210800,1),(1301,-769395600,2),(1301,-765388800,3),(1301,-147891600,4),(1301,-131562000,3),(1301,325674009,5),(1301,341395209,3),(1301,357123609,5),(1301,372844810,3),(1301,388573210,5),(1301,404899211,3),(1301,420022811,5),(1301,436348812,3),(1301,452077212,5),(1301,467798412,3),(1301,483526812,5),(1301,499248013,3),(1301,514976413,5),(1301,530697613,3),(1301,544611613,5),(1301,562147213,3),(1301,576061214,5),(1301,594201614,3),(1301,607510814,5),(1301,625651214,3),(1301,638960415,5),(1301,657100815,3),(1301,671014816,5),(1301,688550416,3),(1301,702464416,5),(1301,720000017,3),(1301,733914017,5),(1301,752054418,3),(1301,765363618,5),(1301,783504019,3),(1301,796813219,5),(1301,814953619,3),(1301,828867620,5),(1301,846403220,3),(1301,860317220,5),(1301,877852821,3),(1301,891766821,5),(1301,909302421,3),(1301,923216422,5),(1301,941356822,7),(1301,954662422,6),(1301,972802822,8),(1301,973400422,7),(1301,986115622,5),(1301,1004256022,3),(1301,1018170022,5),(1301,1035705622,3),(1301,1049619622,5),(1301,1067155222,3),(1301,1081069222,5),(1301,1099209622,3),(1301,1112518822,5),(1301,1130659222,3),(1301,1143968423,5),(1301,1162108823,3),(1301,1173603623,5),(1301,1194163223,3),(1301,1205053223,5),(1301,1225612823,3),(1301,1236502824,5),(1301,1257062424,3),(1301,1268557224,5),(1301,1289116824,3),(1301,1300006824,5),(1301,1320566424,3),(1301,1331456424,5),(1301,1352016025,3),(1301,1362906025,5),(1301,1383465625,3),(1301,1394355625,5),(1301,1414915225,3),(1301,1425805225,5),(1301,1446364826,3),(1301,1457859626,5),(1301,1478419226,3),(1301,1489309227,5),(1301,1509868827,3),(1301,1520758827,5),(1301,1541318427,3),(1301,1552208427,5),(1301,1572768027,3),(1301,1583658027,5),(1301,1604217627,3),(1301,1615712427,5),(1301,1636272027,3),(1301,1647162027,5),(1301,1667721627,3),(1301,1678611627,5),(1301,1699171227,3),(1301,1710061227,5),(1301,1730620827,3),(1301,1741510827,5),(1301,1762070427,3),(1301,1772960427,5),(1301,1793520027,3),(1301,1805014827,5),(1301,1825574427,3),(1301,1836464427,5),(1301,1857024027,3),(1301,1867914027,5),(1301,1888473627,3),(1301,1899363627,5),(1301,1919923227,3),(1301,1930813227,5),(1301,1951372827,3),(1301,1962867627,5),(1301,1983427227,3),(1301,1994317227,5),(1301,2014876827,3),(1301,2025766827,5),(1301,2046326427,3),(1301,2057216427,5),(1301,2077776027,3),(1301,2088666027,5),(1301,2109225627,3),(1301,2120115627,5),(1301,2140675227,3),(1302,-2147483648,0),(1302,-1767212492,2),(1302,-1206954000,1),(1302,-1191358800,2),(1302,-1175371200,1),(1302,-1159822800,2),(1302,-633816000,1),(1302,-622065600,2),(1302,-602280000,1),(1302,-591829200,2),(1302,-570744000,1),(1302,-560206800,2),(1302,-539121600,1),(1302,-531349200,2),(1302,-191361600,1),(1302,-184194000,2),(1302,-155160000,1),(1302,-150066000,2),(1302,-128894400,1),(1302,-121122000,2),(1302,-99950400,1),(1302,-89586000,2),(1302,-68414400,1),(1302,-57963600,2),(1302,499752013,1),(1302,511239613,2),(1302,530596813,1),(1302,540270013,2),(1302,562132813,1),(1302,571201214,2),(1302,592977614,1),(1302,602046014,2),(1302,624427214,1),(1302,634705215,2),(1302,656481615,1),(1302,666759616,2),(1302,687931216,1),(1302,697604416,2),(1302,719985617,1),(1302,728449217,2),(1302,750830418,1),(1302,761713218,2),(1302,782280019,1),(1302,793162819,2),(1302,813729619,1),(1302,824007620,2),(1302,844574420,1),(1302,856062020,2),(1302,876110421,1),(1302,888721221,2),(1302,908078421,1),(1302,919566022,2),(1302,938923222,1),(1302,951620422,2),(1302,970977622,1),(1302,982465222,2),(1302,1003032022,1),(1302,1013914822,2),(1302,1036296022,1),(1302,1045364422,2),(1302,1066536022,1),(1302,1076814022,2),(1302,1099368022,1),(1302,1108868422,2),(1302,1129435222,1),(1302,1140318023,2),(1302,1162699223,1),(1302,1172372423,2),(1302,1192334423,1),(1302,1203217223,2),(1302,1224388823,1),(1302,1234666824,2),(1302,1255838424,1),(1302,1266721224,2),(1302,1287288024,1),(1302,1298170824,2),(1302,1318737624,1),(1302,1330225224,2),(1302,1350792025,1),(1302,1361070025,2),(1302,1382241625,1),(1302,1392519625,2),(1302,1413691225,1),(1302,1424574025,2),(1302,1445140826,1),(1302,1456023626,2),(1302,1476590426,1),(1302,1487473227,2),(1302,1508040027,1),(1302,1518922827,2),(1302,1541304027,1),(1302,1550372427,2),(1302,1572753627,1),(1302,1581822027,2),(1302,1604203227,1),(1302,1613876427,2),(1302,1636257627,1),(1302,1645326027,2),(1302,1667707227,1),(1302,1677380427,2),(1302,1699156827,1),(1302,1708225227,2),(1302,1730606427,1),(1302,1739674827,2),(1302,1762056027,1),(1302,1771729227,2),(1302,1793505627,1),(1302,1803178827,2),(1302,1825560027,1),(1302,1834628427,2),(1302,1857009627,1),(1302,1866078027,2),(1302,1888459227,1),(1302,1897527627,2),(1302,1919908827,1),(1302,1928977227,2),(1302,1951358427,1),(1302,1960426827,2),(1302,1983412827,1),(1302,1992481227,2),(1302,2014862427,1),(1302,2024535627,2),(1302,2046312027,1),(1302,2055380427,2),(1302,2077761627,1),(1302,2086830027,2),(1302,2109211227,1),(1302,2118884427,2),(1302,2140660827,1),(1303,-2147483648,0),(1303,-1514743200,1),(1303,377935210,3),(1303,828860420,2),(1303,846396020,3),(1303,860310020,2),(1303,877845621,3),(1303,891759621,2),(1303,902037621,4),(1303,909298821,1),(1303,923212822,4),(1303,941353222,1),(1303,954662422,4),(1303,972802822,1),(1303,989136022,4),(1303,1001833222,1),(1303,1018166422,4),(1303,1035702022,1),(1303,1049616022,4),(1303,1067151622,1),(1303,1081065622,4),(1303,1099206022,1),(1303,1112515222,4),(1303,1130655622,1),(1303,1143964823,4),(1303,1162105223,1),(1303,1175414423,4),(1303,1193554823,1),(1303,1207468823,4),(1303,1225004423,1),(1303,1238918424,4),(1303,1256454024,1),(1303,1270368024,4),(1303,1288508424,1),(1303,1301817624,4),(1303,1319958024,1),(1303,1333267224,4),(1303,1351407625,1),(1303,1365321625,4),(1303,1382857225,1),(1303,1396771225,4),(1303,1414306825,1),(1303,1422777625,3),(1304,-2147483648,1),(1304,-1826739140,2),(1304,-157750200,3),(1304,1197183623,2),(1304,1462086026,3),(1305,-2147483648,1),(1305,-1567453392,2),(1305,-1233432000,3),(1305,-1222981200,2),(1305,-1205956800,3),(1305,-1194037200,2),(1305,-1172865600,3),(1305,-1162501200,2),(1305,-1141329600,3),(1305,-1130965200,2),(1305,-1109793600,3),(1305,-1099429200,2),(1305,-1078257600,3),(1305,-1067806800,2),(1305,-1046635200,3),(1305,-1036270800,2),(1305,-1015099200,3),(1305,-1004734800,2),(1305,-983563200,3),(1305,-973198800,2),(1305,-952027200,3),(1305,-941576400,2),(1305,-931032000,3),(1305,-900882000,2),(1305,-890337600,3),(1305,-833749200,2),(1305,-827265600,3),(1305,-752274000,2),(1305,-733780800,3),(1305,-197326800,2),(1305,-190843200,3),(1305,-184194000,2),(1305,-164491200,3),(1305,-152658000,2),(1305,-132955200,3),(1305,-121122000,2),(1305,-101419200,3),(1305,-86821200,2),(1305,-71092800,3),(1305,-54766800,2),(1305,-39038400,3),(1305,-23317200,2),(1305,-7588800,5),(1305,128142003,4),(1305,136605603,5),(1305,596948414,4),(1305,605066414,5),(1305,624423614,4),(1305,636516015,5),(1305,656478015,4),(1305,667965616,2),(1305,687931216,4),(1305,699415216,5),(1305,719377217,4),(1305,731469617,5),(1305,938919622,3),(1305,952052422,5),(1305,1086058822,2),(1305,1087704022,5),(1305,1198983623,4),(1305,1205632823,5),(1306,-2147483648,0),(1306,-1846269040,1),(1306,-71092800,2),(1307,-2147483648,1),(1307,-1946918424,2),(1308,-2147483648,2),(1308,-1633276800,1),(1308,-1615136400,2),(1308,-1601827200,1),(1308,-1583686800,2),(1308,-1563724800,1),(1308,-1551632400,2),(1308,-1538928000,1),(1308,-1520182800,2),(1308,-1504454400,1),(1308,-1491757200,2),(1308,-1473004800,1),(1308,-1459702800,2),(1308,-1441555200,1),(1308,-1428253200,2),(1308,-1410105600,1),(1308,-1396803600,2),(1308,-1378656000,1),(1308,-1365354000,2),(1308,-1347206400,1),(1308,-1333904400,2),(1308,-1315152000,1),(1308,-1301850000,2),(1308,-1283702400,1),(1308,-1270400400,2),(1308,-1252252800,1),(1308,-1238950800,2),(1308,-1220803200,1),(1308,-1207501200,2),(1308,-1189353600,1),(1308,-1176051600,2),(1308,-1157299200,1),(1308,-1144602000,2),(1308,-1125849600,1),(1308,-1112547600,2),(1308,-1094400000,1),(1308,-1081098000,2),(1308,-1067788800,3),(1308,-1045414800,2),(1308,-1031500800,1),(1308,-1018198800,2),(1308,-1000051200,1),(1308,-986749200,2),(1308,-967996800,1),(1308,-955299600,2),(1308,-936547200,1),(1308,-923245200,2),(1308,-905097600,1),(1308,-891795600,2),(1308,-880214400,4),(1308,-769395600,5),(1308,-765392400,2),(1308,-747244800,1),(1308,-733942800,2),(1308,-715795200,1),(1308,-702493200,2),(1308,-684345600,1),(1308,-671043600,2),(1308,-652896000,1),(1308,-639594000,2),(1308,-620841600,1),(1308,-608144400,2),(1308,-589392000,1),(1308,-576090000,2),(1308,-557942400,1),(1308,-544640400,2),(1308,-526492800,1),(1308,-513190800,2),(1308,-495043200,1),(1308,-481741200,2),(1308,-463593600,1),(1308,-447267600,2),(1308,-431539200,1),(1308,-415818000,2),(1308,-400089600,1),(1308,-384368400,2),(1308,-368640000,1),(1308,-352918800,2),(1308,-337190400,1),(1308,-321469200,2),(1308,-305740800,1),(1308,-289414800,2),(1308,-273686400,1),(1308,-257965200,2),(1308,-242236800,1),(1308,-226515600,2),(1308,-210787200,1),(1308,-195066000,2),(1308,-179337600,1),(1308,-163616400,2),(1308,-147888000,1),(1308,-131562000,2),(1308,-116438400,1),(1308,-100112400,2),(1308,-84384000,1),(1308,-68662800,2),(1308,-52934400,1),(1308,-37213200,2),(1308,-21484800,1),(1308,-5763600,2),(1308,9964800,1),(1308,25686000,2),(1308,41414400,1),(1308,57740400,2),(1308,73468800,1),(1308,89190001,2),(1308,104918402,1),(1308,120639602,2),(1308,126691203,1),(1308,152089203,2),(1308,162374404,1),(1308,183538804,2),(1308,199267205,1),(1308,215593205,2),(1308,230716806,1),(1308,247042806,2),(1308,262771207,1),(1308,278492407,2),(1308,294220808,1),(1308,309942008,2),(1308,325670409,1),(1308,341391609,2),(1308,357120009,1),(1308,372841210,2),(1308,388569610,1),(1308,404895611,2),(1308,420019211,1),(1308,436345212,2),(1308,452073612,1),(1308,467794812,2),(1308,483523212,1),(1308,499244413,2),(1308,514972813,1),(1308,530694013,2),(1308,544608013,1),(1308,562143613,2),(1308,576057614,1),(1308,594198014,2),(1308,607507214,1),(1308,625647614,2),(1308,638956815,1),(1308,657097215,2),(1308,671011216,1),(1308,688546816,2),(1308,702460816,1),(1308,719996417,2),(1308,733910417,1),(1308,752050818,2),(1308,765360018,1),(1308,783500419,2),(1308,796809619,1),(1308,814950019,2),(1308,828864020,1),(1308,846399620,2),(1308,860313620,1),(1308,877849221,2),(1308,891763221,1),(1308,909298821,2),(1308,923212822,1),(1308,941353222,2),(1308,954662422,1),(1308,972802822,2),(1308,986112022,1),(1308,1004252422,2),(1308,1018166422,1),(1308,1035702022,2),(1308,1049616022,1),(1308,1067151622,2),(1308,1081065622,1),(1308,1099206022,2),(1308,1112515222,1),(1308,1130655622,2),(1308,1143964823,1),(1308,1162105223,2),(1308,1173600023,1),(1308,1194159623,2),(1308,1205049623,1),(1308,1225609223,2),(1308,1236499224,1),(1308,1257058824,2),(1308,1268553624,1),(1308,1289113224,2),(1308,1300003224,1),(1308,1320562824,2),(1308,1331452824,1),(1308,1352012425,2),(1308,1362902425,1),(1308,1383462025,2),(1308,1394352025,1),(1308,1414911625,2),(1308,1425801625,1),(1308,1446361226,2),(1308,1457856026,1),(1308,1478415626,2),(1308,1489305627,1),(1308,1509865227,2),(1308,1520755227,1),(1308,1541314827,2),(1308,1552204827,1),(1308,1572764427,2),(1308,1583654427,1),(1308,1604214027,2),(1308,1615708827,1),(1308,1636268427,2),(1308,1647158427,1),(1308,1667718027,2),(1308,1678608027,1),(1308,1699167627,2),(1308,1710057627,1),(1308,1730617227,2),(1308,1741507227,1),(1308,1762066827,2),(1308,1772956827,1),(1308,1793516427,2),(1308,1805011227,1),(1308,1825570827,2),(1308,1836460827,1),(1308,1857020427,2),(1308,1867910427,1),(1308,1888470027,2),(1308,1899360027,1),(1308,1919919627,2),(1308,1930809627,1),(1308,1951369227,2),(1308,1962864027,1),(1308,1983423627,2),(1308,1994313627,1),(1308,2014873227,2),(1308,2025763227,1),(1308,2046322827,2),(1308,2057212827,1),(1308,2077772427,2),(1308,2088662427,1),(1308,2109222027,2),(1308,2120112027,1),(1308,2140671627,2),(1309,-2147483648,0),(1309,-1514739600,1),(1309,-1343066400,2),(1309,-1234807200,1),(1309,-1220292000,2),(1309,-1207159200,1),(1309,-1191344400,2),(1309,828864020,3),(1309,846399620,2),(1309,860313620,3),(1309,877849221,2),(1309,891766821,4),(1309,909302421,1),(1309,923216422,4),(1309,941356822,1),(1309,954666022,4),(1309,972806422,1),(1309,989139622,4),(1309,1001836822,1),(1309,1018170022,4),(1309,1035705622,1),(1309,1049619622,4),(1309,1067155222,1),(1309,1081069222,4),(1309,1099209622,1),(1309,1112518822,4),(1309,1130659222,1),(1309,1143968423,4),(1309,1162108823,1),(1309,1175418023,4),(1309,1193558423,1),(1309,1207472423,4),(1309,1225008023,1),(1309,1238922024,4),(1309,1256457624,1),(1309,1270371624,4),(1309,1288512024,1),(1309,1301821224,4),(1309,1319961624,1),(1309,1333270824,4),(1309,1351411225,1),(1309,1365325225,4),(1309,1382860825,1),(1309,1396774825,4),(1309,1414310425,1),(1309,1428224425,4),(1309,1445760026,1),(1309,1459674026,4),(1309,1477814426,1),(1309,1491123627,4),(1309,1509264027,1),(1309,1522573227,4),(1309,1540713627,1),(1309,1554627627,4),(1309,1572163227,1),(1309,1586077227,4),(1309,1603612827,1),(1309,1617526827,4),(1309,1635667227,1),(1309,1648976427,4),(1309,1667116827,1),(1309,1680426027,4),(1309,1698566427,1),(1309,1712480427,4),(1309,1730016027,1),(1309,1743930027,4),(1309,1761465627,1),(1309,1775379627,4),(1309,1792915227,1),(1309,1806829227,4),(1309,1824969627,1),(1309,1838278827,4),(1309,1856419227,1),(1309,1869728427,4),(1309,1887868827,1),(1309,1901782827,4),(1309,1919318427,1),(1309,1933232427,4),(1309,1950768027,1),(1309,1964682027,4),(1309,1982822427,1),(1309,1996131627,4),(1309,2014272027,1),(1309,2027581227,4),(1309,2045721627,1),(1309,2059030827,4),(1309,2077171227,1),(1309,2091085227,4),(1309,2108620827,1),(1309,2122534827,4),(1309,2140070427,1),(1310,-2147483648,2),(1310,-1632067200,1),(1310,-1615136400,2),(1310,-923248800,1),(1310,-880214400,3),(1310,-769395600,4),(1310,-765392400,5),(1311,-2147483648,1),(1311,-1567453392,2),(1311,-1233432000,3),(1311,-1222981200,2),(1311,-1205956800,3),(1311,-1194037200,2),(1311,-1172865600,3),(1311,-1162501200,2),(1311,-1141329600,3),(1311,-1130965200,2),(1311,-1109793600,3),(1311,-1099429200,2),(1311,-1078257600,3),(1311,-1067806800,2),(1311,-1046635200,3),(1311,-1036270800,2),(1311,-1015099200,3),(1311,-1004734800,2),(1311,-983563200,3),(1311,-973198800,2),(1311,-952027200,3),(1311,-941576400,2),(1311,-931032000,3),(1311,-900882000,2),(1311,-890337600,3),(1311,-833749200,2),(1311,-827265600,3),(1311,-752274000,2),(1311,-733780800,3),(1311,-197326800,2),(1311,-190843200,3),(1311,-184194000,2),(1311,-164491200,3),(1311,-152658000,2),(1311,-132955200,3),(1311,-121122000,2),(1311,-101419200,3),(1311,-86821200,2),(1311,-71092800,3),(1311,-54766800,2),(1311,-39038400,3),(1311,-23317200,2),(1311,-7588800,5),(1311,128142003,4),(1311,136605603,5),(1311,596948414,4),(1311,605066414,5),(1311,624423614,4),(1311,636516015,5),(1311,656478015,4),(1311,667965616,2),(1311,687931216,4),(1311,699415216,5),(1311,719377217,4),(1311,731469617,5),(1311,938919622,3),(1311,952052422,5),(1311,1198983623,4),(1311,1205632823,5),(1311,1224385223,4),(1311,1237082424,5),(1312,-2147483648,1),(1312,-1545071027,3),(1312,288770408,2),(1312,297234008,3),(1312,320220009,2),(1312,328683609,3),(1312,664264816,2),(1312,678344416,3),(1312,695714416,2),(1312,700635616,3),(1313,-2147483648,1),(1313,-1680454800,2),(1313,-1627833600,1),(1314,-2147483648,0),(1314,-1767212140,2),(1314,-1206954000,1),(1314,-1191358800,2),(1314,-1175371200,1),(1314,-1159822800,2),(1314,-633816000,1),(1314,-622065600,2),(1314,-602280000,1),(1314,-591829200,2),(1314,-570744000,1),(1314,-560206800,2),(1314,-539121600,1),(1314,-531349200,2),(1314,-191361600,1),(1314,-184194000,2),(1314,-155160000,1),(1314,-150066000,2),(1314,-128894400,1),(1314,-121122000,2),(1314,-99950400,1),(1314,-89586000,2),(1314,-68414400,1),(1314,-57963600,2),(1314,499752013,1),(1314,511239613,2),(1314,530596813,1),(1314,540270013,2),(1314,562132813,1),(1314,571201214,2),(1314,592977614,1),(1314,602046014,2),(1314,624427214,1),(1314,634705215,2),(1314,656481615,1),(1314,666759616,2),(1314,687931216,1),(1314,697604416,2),(1314,719985617,1),(1314,728449217,2),(1314,750830418,1),(1314,761713218,2),(1314,782280019,1),(1314,793162819,2),(1314,813729619,1),(1314,824007620,2),(1314,844574420,1),(1314,856062020,2),(1314,876110421,1),(1314,888721221,2),(1314,908078421,1),(1314,919566022,2),(1314,938923222,1),(1314,951620422,2),(1314,970977622,1),(1314,982465222,2),(1314,1003032022,1),(1314,1013914822,2),(1314,1036296022,1),(1314,1045364422,2),(1314,1099368022,1),(1314,1108868422,2),(1314,1129435222,1),(1314,1140318023,2),(1314,1162699223,1),(1314,1172372423,2),(1314,1192334423,1),(1314,1203217223,2),(1314,1224388823,1),(1314,1234666824,2),(1314,1255838424,1),(1314,1266721224,2),(1314,1287288024,1),(1314,1298170824,2),(1314,1318737624,1),(1314,1330225224,2),(1314,1350792025,1),(1314,1361070025,2),(1314,1382241625,1),(1314,1392519625,2),(1314,1413691225,1),(1314,1424574025,2),(1314,1445140826,1),(1314,1456023626,2),(1314,1476590426,1),(1314,1487473227,2),(1314,1508040027,1),(1314,1518922827,2),(1314,1541304027,1),(1314,1550372427,2),(1314,1572753627,1),(1314,1581822027,2),(1314,1604203227,1),(1314,1613876427,2),(1314,1636257627,1),(1314,1645326027,2),(1314,1667707227,1),(1314,1677380427,2),(1314,1699156827,1),(1314,1708225227,2),(1314,1730606427,1),(1314,1739674827,2),(1314,1762056027,1),(1314,1771729227,2),(1314,1793505627,1),(1314,1803178827,2),(1314,1825560027,1),(1314,1834628427,2),(1314,1857009627,1),(1314,1866078027,2),(1314,1888459227,1),(1314,1897527627,2),(1314,1919908827,1),(1314,1928977227,2),(1314,1951358427,1),(1314,1960426827,2),(1314,1983412827,1),(1314,1992481227,2),(1314,2014862427,1),(1314,2024535627,2),(1314,2046312027,1),(1314,2055380427,2),(1314,2077761627,1),(1314,2086830027,2),(1314,2109211227,1),(1314,2118884427,2),(1314,2140660827,1),(1315,-2147483648,0),(1315,-1826738653,1),(1315,-157750200,2),(1316,-2147483648,0),(1316,-1686091520,1),(1316,323845209,4),(1316,338950809,2),(1316,354675609,3),(1316,370400410,2),(1316,386125210,3),(1316,401850011,2),(1316,417574811,3),(1316,433299612,2),(1316,449024412,3),(1316,465354012,2),(1316,481078812,3),(1316,496803613,2),(1316,512528413,3),(1316,528253213,2),(1316,543978013,3),(1316,559702813,2),(1316,575427614,3),(1316,591152414,2),(1316,606877214,3),(1316,622602014,2),(1316,638326815,3),(1316,654656415,2),(1316,670381216,3),(1316,686106016,2),(1316,701830816,3),(1316,717555617,2),(1316,733280417,3),(1316,749005218,2),(1316,764730018,3),(1316,780454819,2),(1316,796179619,3),(1316,811904419,2),(1316,820465220,5),(1317,-2147483648,2),(1317,-1632056400,1),(1317,-1615125600,2),(1317,-1596978000,1),(1317,-1583164800,2),(1317,-880203600,3),(1317,-769395600,4),(1317,-765381600,2),(1317,-147884400,5),(1317,-131554800,2),(1317,120646802,6),(1317,325677609,7),(1317,341398809,6),(1317,357127209,7),(1317,372848410,6),(1317,388576810,7),(1317,404902811,6),(1317,420026411,7),(1317,436352412,6),(1317,452080812,7),(1317,467802012,6),(1317,483530412,7),(1317,499251613,6),(1317,514980013,7),(1317,530701213,6),(1317,544615213,7),(1317,562150813,6),(1317,576064814,7),(1317,594205214,6),(1317,607514414,7),(1317,625654814,6),(1317,638964015,7),(1317,657104415,6),(1317,671018416,7),(1317,688554016,6),(1317,702468016,7),(1317,720003617,6),(1317,733917617,7),(1317,752058018,6),(1317,765367218,7),(1317,783507619,6),(1317,796816819,7),(1317,814957219,6),(1317,828871220,7),(1317,846406820,6),(1317,860320820,7),(1317,877856421,6),(1317,891770421,7),(1317,909306021,6),(1317,923220022,7),(1317,941360422,6),(1317,954669622,7),(1317,972810022,6),(1317,986119222,7),(1317,1004259622,6),(1317,1018173622,7),(1317,1035709222,6),(1317,1049623222,7),(1317,1067158822,6),(1317,1081072822,7),(1317,1099213222,6),(1317,1112522422,7),(1317,1130662822,6),(1317,1143972023,7),(1317,1162112423,6),(1317,1173607223,7),(1317,1194166823,6),(1317,1205056823,7),(1317,1225616423,6),(1317,1236506424,7),(1317,1257066024,6),(1317,1268560824,7),(1317,1289120424,6),(1317,1300010424,7),(1317,1320570024,6),(1317,1331460024,7),(1317,1352019625,6),(1317,1362909625,7),(1317,1383469225,6),(1317,1394359225,7),(1317,1414918825,6),(1317,1425808825,7),(1317,1446368426,6),(1317,1457863226,7),(1317,1478422826,6),(1317,1489312827,7),(1317,1509872427,6),(1317,1520762427,7),(1317,1541322027,6),(1317,1552212027,7),(1317,1572771627,6),(1317,1583661627,7),(1317,1604221227,6),(1317,1615716027,7),(1317,1636275627,6),(1317,1647165627,7),(1317,1667725227,6),(1317,1678615227,7),(1317,1699174827,6),(1317,1710064827,7),(1317,1730624427,6),(1317,1741514427,7),(1317,1762074027,6),(1317,1772964027,7),(1317,1793523627,6),(1317,1805018427,7),(1317,1825578027,6),(1317,1836468027,7),(1317,1857027627,6),(1317,1867917627,7),(1317,1888477227,6),(1317,1899367227,7),(1317,1919926827,6),(1317,1930816827,7),(1317,1951376427,6),(1317,1962871227,7),(1317,1983430827,6),(1317,1994320827,7),(1317,2014880427,6),(1317,2025770427,7),(1317,2046330027,6),(1317,2057220027,7),(1317,2077779627,6),(1317,2088669627,7),(1317,2109229227,6),(1317,2120119227,7),(1317,2140678827,6),(1318,-2147483648,2),(1318,-1632060000,1),(1318,-1615129200,2),(1318,-880207200,3),(1318,-769395600,4),(1318,-765385200,2),(1318,-715788000,1),(1318,-702486000,2),(1318,-684338400,1),(1318,-671036400,2),(1318,-652888800,1),(1318,-639586800,2),(1318,-620834400,1),(1318,-608137200,2),(1318,-589384800,1),(1318,-576082800,2),(1318,-557935200,1),(1318,-544633200,2),(1318,-526485600,1),(1318,-513183600,2),(1318,-495036000,1),(1318,-481734000,2),(1318,-463586400,1),(1318,-450284400,2),(1318,-431532000,1),(1318,-418230000,2),(1318,-400082400,1),(1318,-386780400,2),(1318,-368632800,1),(1318,-355330800,2),(1318,-337183200,1),(1318,-323881200,2),(1318,-305733600,1),(1318,-292431600,2),(1318,-273679200,1),(1318,-260982000,2),(1318,-242229600,1),(1318,-226508400,2),(1318,-210780000,1),(1318,-195058800,2),(1318,-179330400,1),(1318,-163609200,2),(1318,-147880800,1),(1318,-131554800,2),(1318,-116431200,1),(1318,-100105200,2),(1318,-84376800,1),(1318,-68655600,2),(1318,-52927200,1),(1318,-37206000,2),(1318,-21477600,1),(1318,-5756400,2),(1318,9972000,1),(1318,25693200,2),(1318,41421600,1),(1318,57747600,2),(1318,73476000,1),(1318,84013201,5),(1319,-2147483648,2),(1319,-1633273200,1),(1319,-1615132800,2),(1319,-1601823600,1),(1319,-1583683200,2),(1319,-1570374000,1),(1319,-1551628800,2),(1319,-1538924400,1),(1319,-1534089600,2),(1319,-880210800,3),(1319,-769395600,4),(1319,-765388800,2),(1319,-147884400,1),(1319,-131558400,2),(1319,-116434800,1),(1319,-100108800,2),(1319,-84380400,1),(1319,-68659200,2),(1319,-52930800,1),(1319,-37209600,2),(1319,-21481200,1),(1319,-5760000,2),(1319,9968400,1),(1319,25689600,2),(1319,41418000,1),(1319,57744000,2),(1319,73472400,1),(1319,89193601,2),(1319,104922002,1),(1319,120643202,2),(1319,126694803,1),(1319,152092803,2),(1319,162378004,1),(1319,183542404,2),(1319,199270805,1),(1319,215596805,2),(1319,230720406,1),(1319,247046406,2),(1319,262774807,1),(1319,278496007,2),(1319,294224408,1),(1319,309945608,2),(1319,325674009,1),(1319,341395209,2),(1319,357123609,1),(1319,372844810,2),(1319,388573210,1),(1319,404899211,2),(1319,420022811,1),(1319,436348812,2),(1319,452077212,1),(1319,467798412,2),(1319,483526812,1),(1319,499248013,2),(1319,514976413,1),(1319,530697613,2),(1319,544611613,1),(1319,562147213,2),(1319,576061214,1),(1319,594201614,2),(1319,607510814,1),(1319,625651214,2),(1319,638960415,1),(1319,657100815,2),(1319,671014816,1),(1319,688550416,2),(1319,702464416,1),(1319,720000017,2),(1319,733914017,1),(1319,752054418,2),(1319,765363618,1),(1319,783504019,2),(1319,796813219,1),(1319,814953619,2),(1319,828867620,1),(1319,846403220,2),(1319,860317220,1),(1319,877852821,2),(1319,891766821,1),(1319,909302421,2),(1319,923216422,1),(1319,941356822,2),(1319,954666022,1),(1319,972806422,2),(1319,986115622,1),(1319,1004256022,2),(1319,1018170022,1),(1319,1035705622,2),(1319,1049619622,1),(1319,1067155222,2),(1319,1081069222,1),(1319,1099209622,2),(1319,1112518822,1),(1319,1130659222,2),(1319,1143968423,1),(1319,1162108823,2),(1319,1173603623,1),(1319,1194163223,2),(1319,1205053223,1),(1319,1225612823,2),(1319,1236502824,1),(1319,1257062424,2),(1319,1268557224,1),(1319,1289116824,2),(1319,1300006824,1),(1319,1320566424,2),(1319,1331456424,1),(1319,1352016025,2),(1319,1362906025,1),(1319,1383465625,2),(1319,1394355625,1),(1319,1414915225,2),(1319,1425805225,1),(1319,1446364826,2),(1319,1457859626,1),(1319,1478419226,2),(1319,1489309227,1),(1319,1509868827,2),(1319,1520758827,1),(1319,1541318427,2),(1319,1552208427,1),(1319,1572768027,2),(1319,1583658027,1),(1319,1604217627,2),(1319,1615712427,1),(1319,1636272027,2),(1319,1647162027,1),(1319,1667721627,2),(1319,1678611627,1),(1319,1699171227,2),(1319,1710061227,1),(1319,1730620827,2),(1319,1741510827,1),(1319,1762070427,2),(1319,1772960427,1),(1319,1793520027,2),(1319,1805014827,1),(1319,1825574427,2),(1319,1836464427,1),(1319,1857024027,2),(1319,1867914027,1),(1319,1888473627,2),(1319,1899363627,1),(1319,1919923227,2),(1319,1930813227,1),(1319,1951372827,2),(1319,1962867627,1),(1319,1983427227,2),(1319,1994317227,1),(1319,2014876827,2),(1319,2025766827,1),(1319,2046326427,2),(1319,2057216427,1),(1319,2077776027,2),(1319,2088666027,1),(1319,2109225627,2),(1319,2120115627,1),(1319,2140675227,2),(1320,-2147483648,0),(1320,-2051202469,1),(1320,-1724083200,2),(1320,-880218000,3),(1320,-769395600,4),(1320,-765396000,2),(1320,-684349200,5),(1320,-671047200,2),(1320,104914802,5),(1320,120636002,2),(1320,126687603,5),(1320,152085603,2),(1320,167814004,5),(1320,183535204,2),(1320,199263605,5),(1320,215589605,2),(1320,230713206,5),(1320,247039206,2),(1320,262767607,5),(1320,278488807,2),(1320,294217208,5),(1320,309938408,2),(1320,325666809,5),(1320,341388009,2),(1320,357116409,5),(1320,372837610,2),(1320,388566010,5),(1320,404892011,2),(1320,420015611,5),(1320,436341612,2),(1320,452070012,5),(1320,467791212,2),(1320,483519612,5),(1320,499240813,2),(1320,514969213,5),(1320,530690413,2),(1320,544604413,5),(1320,562140013,2),(1320,576054014,5),(1320,594194414,2),(1320,607503614,5),(1320,625644014,2),(1320,638953215,5),(1320,657093615,2),(1320,671007616,5),(1320,688543216,2),(1320,702457216,5),(1320,719992817,2),(1320,733906817,5),(1320,752047218,2),(1320,765356418,5),(1320,783496819,2),(1320,796806019,5),(1320,814946419,2),(1320,828860420,5),(1320,846396020,2),(1320,860310020,5),(1320,877845621,2),(1320,891759621,5),(1320,909295221,2),(1320,923209222,5),(1320,941349622,2),(1320,954658822,5),(1320,972799222,2),(1320,986108422,5),(1320,1004248822,2),(1320,1018162822,5),(1320,1035698422,2),(1320,1049612422,5),(1320,1067148022,2),(1320,1081062022,5),(1320,1099202422,2),(1320,1112511622,5),(1320,1130652022,2),(1320,1143961223,5),(1320,1162101623,2),(1320,1173596423,5),(1320,1194156023,2),(1320,1205046023,5),(1320,1225605623,2),(1320,1236495624,5),(1320,1257055224,2),(1320,1268550024,5),(1320,1289109624,2),(1320,1299999624,5),(1320,1320559224,2),(1320,1331449224,5),(1320,1352008825,2),(1320,1362898825,5),(1320,1383458425,2),(1320,1394348425,5),(1320,1414908025,2),(1320,1425798025,5),(1320,1446357626,2),(1320,1457852426,5),(1320,1478412026,2),(1320,1489302027,5),(1320,1509861627,2),(1320,1520751627,5),(1320,1541311227,2),(1320,1552201227,5),(1320,1572760827,2),(1320,1583650827,5),(1320,1604210427,2),(1320,1615705227,5),(1320,1636264827,2),(1320,1647154827,5),(1320,1667714427,2),(1320,1678604427,5),(1320,1699164027,2),(1320,1710054027,5),(1320,1730613627,2),(1320,1741503627,5),(1320,1762063227,2),(1320,1772953227,5),(1320,1793512827,2),(1320,1805007627,5),(1320,1825567227,2),(1320,1836457227,5),(1320,1857016827,2),(1320,1867906827,5),(1320,1888466427,2),(1320,1899356427,5),(1320,1919916027,2),(1320,1930806027,5),(1320,1951365627,2),(1320,1962860427,5),(1320,1983420027,2),(1320,1994310027,5),(1320,2014869627,2),(1320,2025759627,5),(1320,2046319227,2),(1320,2057209227,5),(1320,2077768827,2),(1320,2088658827,5),(1320,2109218427,2),(1320,2120108427,5),(1320,2140668027,2),(1321,-2147483648,0),(1321,-1825098836,1),(1322,-2147483648,0),(1322,-1998663968,2),(1322,-1632063600,1),(1322,-1615132800,2),(1322,-1600614000,1),(1322,-1596816000,2),(1322,-1567954800,1),(1322,-1551628800,2),(1322,-1536505200,1),(1322,-1523203200,2),(1322,-1504450800,1),(1322,-1491753600,2),(1322,-1473001200,1),(1322,-1459699200,2),(1322,-880210800,3),(1322,-769395600,4),(1322,-765388800,2),(1322,-715791600,1),(1322,-702489600,2),(1322,-84380400,1),(1322,-68659200,2),(1322,-21481200,1),(1322,-5760000,2),(1322,73472400,1),(1322,89193601,2),(1322,104922002,1),(1322,120643202,2),(1322,136371603,1),(1322,152092803,2),(1322,167821204,1),(1322,183542404,2),(1322,199270805,1),(1322,215596805,2),(1322,230720406,1),(1322,247046406,2),(1322,262774807,1),(1322,278496007,2),(1322,294224408,1),(1322,309945608,2),(1322,325674009,1),(1322,341395209,2),(1322,357123609,1),(1322,372844810,2),(1322,388573210,1),(1322,404899211,2),(1322,420022811,1),(1322,436348812,2),(1322,452077212,1),(1322,467798412,2),(1322,483526812,1),(1322,499248013,2),(1322,514976413,1),(1322,530697613,2),(1322,544611613,1),(1322,562147213,2),(1322,576061214,1),(1322,594201614,2),(1322,607510814,1),(1322,625651214,2),(1322,638960415,1),(1322,657100815,2),(1322,671014816,1),(1322,688550416,2),(1322,702464416,1),(1322,720000017,2),(1322,733914017,1),(1322,752054418,2),(1322,765363618,1),(1322,783504019,2),(1322,796813219,1),(1322,814953619,2),(1322,828867620,1),(1322,846403220,2),(1322,860317220,1),(1322,877852821,2),(1322,891766821,1),(1322,909302421,2),(1322,923216422,1),(1322,941356822,2),(1322,954666022,1),(1322,972806422,2),(1322,986115622,1),(1322,1004256022,2),(1322,1018170022,1),(1322,1035705622,2),(1322,1049619622,1),(1322,1067155222,2),(1322,1081069222,1),(1322,1099209622,2),(1322,1112518822,1),(1322,1130659222,2),(1322,1143968423,1),(1322,1162108823,2),(1322,1173603623,1),(1322,1194163223,2),(1322,1205053223,1),(1322,1225612823,2),(1322,1236502824,1),(1322,1257062424,2),(1322,1268557224,1),(1322,1289116824,2),(1322,1300006824,1),(1322,1320566424,2),(1322,1331456424,1),(1322,1352016025,2),(1322,1362906025,1),(1322,1383465625,2),(1322,1394355625,1),(1322,1414915225,2),(1322,1425805225,1),(1322,1446364826,2),(1322,1457859626,1),(1322,1478419226,2),(1322,1489309227,1),(1322,1509868827,2),(1322,1520758827,1),(1322,1541318427,2),(1322,1552208427,1),(1322,1572768027,2),(1322,1583658027,1),(1322,1604217627,2),(1322,1615712427,1),(1322,1636272027,2),(1322,1647162027,1),(1322,1667721627,2),(1322,1678611627,1),(1322,1699171227,2),(1322,1710061227,1),(1322,1730620827,2),(1322,1741510827,1),(1322,1762070427,2),(1322,1772960427,1),(1322,1793520027,2),(1322,1805014827,1),(1322,1825574427,2),(1322,1836464427,1),(1322,1857024027,2),(1322,1867914027,1),(1322,1888473627,2),(1322,1899363627,1),(1322,1919923227,2),(1322,1930813227,1),(1322,1951372827,2),(1322,1962867627,1),(1322,1983427227,2),(1322,1994317227,1),(1322,2014876827,2),(1322,2025766827,1),(1322,2046326427,2),(1322,2057216427,1),(1322,2077776027,2),(1322,2088666027,1),(1322,2109225627,2),(1322,2120115627,1),(1322,2140675227,2),(1323,-2147483648,0),(1323,-1767208832,2),(1323,-1206950400,1),(1323,-1191355200,2),(1323,-1175367600,1),(1323,-1159819200,2),(1323,-633812400,1),(1323,-622062000,2),(1323,-602276400,1),(1323,-591825600,2),(1323,-570740400,1),(1323,-560203200,2),(1323,-539118000,1),(1323,-531345600,2),(1323,-191358000,1),(1323,-184190400,2),(1323,-155156400,1),(1323,-150062400,2),(1323,-128890800,1),(1323,-121118400,2),(1323,-99946800,1),(1323,-89582400,2),(1323,-68410800,1),(1323,-57960000,2),(1323,499755613,1),(1323,511243213,2),(1323,530600413,1),(1323,540273613,2),(1323,562136413,1),(1323,571204814,2),(1323,750834018,1),(1323,761716818,2),(1323,1214283623,3),(1323,1384056025,2),(1324,-2147483648,0),(1324,-1546279392,2),(1324,547020013,1),(1324,559717213,2),(1324,578469614,1),(1324,591166814,2),(1325,-2147483648,0),(1325,-1514736000,1),(1325,-1451667600,2),(1325,-1343062800,1),(1325,-1234803600,2),(1325,-1222963200,3),(1325,-1207242000,2),(1325,-873820800,4),(1325,-769395600,5),(1325,-761677200,2),(1325,-686073600,3),(1325,-661539600,2),(1325,-495039600,3),(1325,-481734000,2),(1325,-463590000,3),(1325,-450284400,2),(1325,-431535600,3),(1325,-418230000,2),(1325,-400086000,3),(1325,-386780400,2),(1325,-368636400,3),(1325,-355330800,2),(1325,-337186800,3),(1325,-323881200,2),(1325,-305737200,3),(1325,-292431600,2),(1325,199274405,3),(1325,215600405,2),(1325,230724006,3),(1325,247050006,2),(1325,262778407,3),(1325,278499607,2),(1325,294228008,3),(1325,309949208,2),(1325,325677609,3),(1325,341398809,2),(1325,357127209,3),(1325,372848410,2),(1325,388576810,3),(1325,404902811,2),(1325,420026411,3),(1325,436352412,2),(1325,452080812,3),(1325,467802012,2),(1325,483530412,3),(1325,499251613,2),(1325,514980013,3),(1325,530701213,2),(1325,544615213,3),(1325,562150813,2),(1325,576064814,3),(1325,594205214,2),(1325,607514414,3),(1325,625654814,2),(1325,638964015,3),(1325,657104415,2),(1325,671018416,3),(1325,688554016,2),(1325,702468016,3),(1325,720003617,2),(1325,733917617,3),(1325,752058018,2),(1325,765367218,3),(1325,783507619,2),(1325,796816819,3),(1325,814957219,2),(1325,828871220,3),(1325,846406820,2),(1325,860320820,3),(1325,877856421,2),(1325,891770421,3),(1325,909306021,2),(1325,923220022,3),(1325,941360422,2),(1325,954669622,3),(1325,972810022,2),(1325,986119222,3),(1325,1004259622,2),(1325,1018173622,3),(1325,1035709222,2),(1325,1049623222,3),(1325,1067158822,2),(1325,1081072822,3),(1325,1099213222,2),(1325,1112522422,3),(1325,1130662822,2),(1325,1143972023,3),(1325,1162112423,2),(1325,1175421623,3),(1325,1193562023,2),(1325,1207476023,3),(1325,1225011623,2),(1325,1238925624,3),(1325,1256461224,2),(1325,1268560824,3),(1325,1289120424,2),(1325,1300010424,3),(1325,1320570024,2),(1325,1331460024,3),(1325,1352019625,2),(1325,1362909625,3),(1325,1383469225,2),(1325,1394359225,3),(1325,1414918825,2),(1325,1425808825,3),(1325,1446368426,2),(1325,1457863226,3),(1325,1478422826,2),(1325,1489312827,3),(1325,1509872427,2),(1325,1520762427,3),(1325,1541322027,2),(1325,1552212027,3),(1325,1572771627,2),(1325,1583661627,3),(1325,1604221227,2),(1325,1615716027,3),(1325,1636275627,2),(1325,1647165627,3),(1325,1667725227,2),(1325,1678615227,3),(1325,1699174827,2),(1325,1710064827,3),(1325,1730624427,2),(1325,1741514427,3),(1325,1762074027,2),(1325,1772964027,3),(1325,1793523627,2),(1325,1805018427,3),(1325,1825578027,2),(1325,1836468027,3),(1325,1857027627,2),(1325,1867917627,3),(1325,1888477227,2),(1325,1899367227,3),(1325,1919926827,2),(1325,1930816827,3),(1325,1951376427,2),(1325,1962871227,3),(1325,1983430827,2),(1325,1994320827,3),(1325,2014880427,2),(1325,2025770427,3),(1325,2046330027,2),(1325,2057220027,3),(1325,2077779627,2),(1325,2088669627,3),(1325,2109229227,2),(1325,2120119227,3),(1325,2140678827,2),(1326,-2147483648,2),(1326,-1632060000,1),(1326,-1615129200,2),(1326,-880207200,3),(1326,-769395600,4),(1326,-765385200,2),(1326,-715788000,1),(1326,-702486000,2),(1326,-684338400,1),(1326,-671036400,2),(1326,-652888800,1),(1326,-639586800,2),(1326,-620834400,1),(1326,-608137200,2),(1326,-589384800,1),(1326,-576082800,2),(1326,-557935200,1),(1326,-544633200,2),(1326,-526485600,1),(1326,-513183600,2),(1326,-495036000,1),(1326,-481734000,2),(1326,-463586400,1),(1326,-450284400,2),(1326,-431532000,1),(1326,-418230000,2),(1326,-400082400,1),(1326,-386780400,2),(1326,-368632800,1),(1326,-355330800,2),(1326,-337183200,1),(1326,-323881200,2),(1326,-305733600,1),(1326,-292431600,2),(1326,-273679200,1),(1326,-260982000,2),(1326,-242229600,1),(1326,-226508400,2),(1326,-210780000,1),(1326,-195058800,2),(1326,-179330400,1),(1326,-163609200,2),(1326,-147880800,1),(1326,-131554800,2),(1326,-116431200,1),(1326,-100105200,2),(1326,-84376800,1),(1326,-68655600,2),(1326,-52927200,1),(1326,-37206000,2),(1326,-21477600,1),(1326,-5756400,2),(1326,9972000,1),(1326,25693200,2),(1326,41421600,1),(1326,57747600,2),(1326,73476000,1),(1326,89197201,2),(1326,104925602,1),(1326,120646802,2),(1326,136375203,1),(1326,152096403,2),(1326,167824804,1),(1326,183546004,2),(1326,199274405,1),(1326,215600405,2),(1326,230724006,1),(1326,247050006,2),(1326,262778407,1),(1326,278499607,2),(1326,294228008,1),(1326,309949208,2),(1326,325677609,1),(1326,341398809,2),(1326,357127209,1),(1326,372848410,2),(1326,388576810,1),(1326,404902811,2),(1326,420026411,1),(1326,436352412,2),(1326,452080812,1),(1326,467802012,2),(1326,483530412,1),(1326,499251613,2),(1326,514980013,1),(1326,530701213,2),(1326,544615213,1),(1326,562150813,2),(1326,576064814,1),(1326,594205214,2),(1326,607514414,1),(1326,625654814,2),(1326,638964015,1),(1326,657104415,2),(1326,671018416,1),(1326,688554016,2),(1326,702468016,1),(1326,720003617,2),(1326,733917617,1),(1326,752058018,2),(1326,765367218,1),(1326,783507619,2),(1326,796816819,1),(1326,814957219,2),(1326,828871220,1),(1326,846406820,2),(1326,860320820,1),(1326,877856421,2),(1326,891770421,1),(1326,909306021,2),(1326,923220022,1),(1326,941360422,2),(1326,954669622,1),(1326,972810022,2),(1326,986119222,1),(1326,1004259622,2),(1326,1018173622,1),(1326,1035709222,2),(1326,1049623222,1),(1326,1067158822,2),(1326,1081072822,1),(1326,1099213222,2),(1326,1112522422,1),(1326,1130662822,2),(1326,1143972023,1),(1326,1162112423,2),(1326,1173607223,1),(1326,1194166823,2),(1326,1205056823,1),(1326,1225616423,2),(1326,1236506424,1),(1326,1257066024,2),(1326,1268560824,1),(1326,1289120424,2),(1326,1300010424,1),(1326,1320570024,2),(1326,1331460024,1),(1326,1352019625,2),(1326,1362909625,1),(1326,1383469225,2),(1326,1394359225,1),(1326,1414918825,2),(1326,1425808825,5),(1327,-2147483648,2),(1327,-1633276800,1),(1327,-1615136400,2),(1327,-1601827200,1),(1327,-1583686800,2),(1327,-900259200,1),(1327,-891795600,2),(1327,-880214400,3),(1327,-769395600,4),(1327,-765392400,2),(1327,-747244800,1),(1327,-733942800,2),(1327,-715795200,1),(1327,-702493200,2),(1327,-684345600,1),(1327,-671043600,2),(1327,-652896000,1),(1327,-639594000,2),(1327,-620841600,1),(1327,-608144400,2),(1327,-589392000,1),(1327,-576090000,2),(1327,-557942400,1),(1327,-544640400,2),(1327,-526492800,1),(1327,-513190800,2),(1327,-495043200,1),(1327,-481741200,2),(1327,-463593600,5),(1327,-386787600,2),(1327,-368640000,5),(1327,-21488400,6),(1327,-5767200,5),(1327,9961200,6),(1327,25682400,5),(1327,1143961223,6),(1327,1162101623,5),(1327,1173596423,6),(1327,1194156023,5),(1327,1205046023,6),(1327,1225605623,5),(1327,1236495624,6),(1327,1257055224,5),(1327,1268550024,6),(1327,1289109624,5),(1327,1299999624,6),(1327,1320559224,5),(1327,1331449224,6),(1327,1352008825,5),(1327,1362898825,6),(1327,1383458425,5),(1327,1394348425,6),(1327,1414908025,5),(1327,1425798025,6),(1327,1446357626,5),(1327,1457852426,6),(1327,1478412026,5),(1327,1489302027,6),(1327,1509861627,5),(1327,1520751627,6),(1327,1541311227,5),(1327,1552201227,6),(1327,1572760827,5),(1327,1583650827,6),(1327,1604210427,5),(1327,1615705227,6),(1327,1636264827,5),(1327,1647154827,6),(1327,1667714427,5),(1327,1678604427,6),(1327,1699164027,5),(1327,1710054027,6),(1327,1730613627,5),(1327,1741503627,6),(1327,1762063227,5),(1327,1772953227,6),(1327,1793512827,5),(1327,1805007627,6),(1327,1825567227,5),(1327,1836457227,6),(1327,1857016827,5),(1327,1867906827,6),(1327,1888466427,5),(1327,1899356427,6),(1327,1919916027,5),(1327,1930806027,6),(1327,1951365627,5),(1327,1962860427,6),(1327,1983420027,5),(1327,1994310027,6),(1327,2014869627,5),(1327,2025759627,6),(1327,2046319227,5),(1327,2057209227,6),(1327,2077768827,5),(1327,2088658827,6),(1327,2109218427,5),(1327,2120108427,6),(1327,2140668027,5),(1328,-2147483648,0),(1328,-1767216360,2),(1328,-1206957600,1),(1328,-1191362400,2),(1328,-1175374800,1),(1328,-1159826400,2),(1328,-633819600,1),(1328,-622069200,2),(1328,-602283600,1),(1328,-591832800,2),(1328,-570747600,1),(1328,-560210400,2),(1328,-539125200,1),(1328,-531352800,2),(1328,-191365200,1),(1328,-184197600,2),(1328,-155163600,1),(1328,-150069600,2),(1328,-128898000,1),(1328,-121125600,2),(1328,-99954000,1),(1328,-89589600,2),(1328,-68418000,1),(1328,-57967200,2),(1328,499748413,1),(1328,511236013,2),(1328,530593213,1),(1328,540266413,2),(1328,562129213,1),(1328,571197614,2),(1328,592974014,1),(1328,602042414,2),(1328,624423614,1),(1328,634701615,2),(1328,938919622,1),(1328,951616822,2),(1328,970974022,1),(1328,972180022,2),(1328,1003028422,1),(1328,1013911222,2),(1329,-2147483648,0),(1329,-2131646412,2),(1329,-1632074400,1),(1329,-1615143600,2),(1329,-880221600,3),(1329,-769395600,4),(1329,-765399600,2),(1329,-526500000,1),(1329,-513198000,2),(1329,73461600,1),(1329,89182801,2),(1329,104911202,1),(1329,120632402,2),(1329,136360803,1),(1329,152082003,2),(1329,167810404,1),(1329,183531604,2),(1329,199260005,1),(1329,215586005,2),(1329,230709606,1),(1329,247035606,2),(1329,262764007,1),(1329,278485207,2),(1329,294213608,1),(1329,309934808,2),(1329,325663209,1),(1329,341384409,2),(1329,357112809,1),(1329,372834010,2),(1329,388562410,1),(1329,404888411,2),(1329,420012011,1),(1329,436338012,2),(1329,452066412,1),(1329,467787612,2),(1329,483516012,1),(1329,499237213,2),(1329,514965613,1),(1329,530686813,2),(1329,544600813,1),(1329,562136413,2),(1329,576050414,1),(1329,594190814,2),(1329,607500014,1),(1329,625640414,2),(1329,638949615,1),(1329,657090015,2),(1329,671004016,1),(1329,688539616,2),(1329,702453616,1),(1329,719989217,2),(1329,733903217,1),(1329,752043618,2),(1329,765352818,1),(1329,783493219,2),(1329,796802419,1),(1329,814942819,2),(1329,828856820,1),(1329,846392420,2),(1329,860306420,1),(1329,877842021,2),(1329,891756021,1),(1329,909291621,2),(1329,923205622,1),(1329,941346022,2),(1329,954655222,1),(1329,972795622,2),(1329,986104822,1),(1329,1004245222,2),(1329,1018159222,1),(1329,1035694822,2),(1329,1049608822,1),(1329,1067144422,2),(1329,1081058422,1),(1329,1099198822,2),(1329,1112508022,1),(1329,1130648422,2),(1329,1143957623,1),(1329,1162098023,2),(1329,1173592823,1),(1329,1194152423,2),(1329,1205042423,1),(1329,1225602023,2),(1329,1236492024,1),(1329,1257051624,2),(1329,1268546424,1),(1329,1289106024,2),(1329,1299996024,1),(1329,1320555624,2),(1329,1331445624,1),(1329,1352005225,2),(1329,1362895225,1),(1329,1383454825,2),(1329,1394344825,1),(1329,1414904425,2),(1329,1425794425,1),(1329,1446354026,2),(1329,1457848826,1),(1329,1478408426,2),(1329,1489298427,1),(1329,1509858027,2),(1329,1520748027,1),(1329,1541307627,2),(1329,1552197627,1),(1329,1572757227,2),(1329,1583647227,1),(1329,1604206827,2),(1329,1615701627,1),(1329,1636261227,2),(1329,1647151227,1),(1329,1667710827,2),(1329,1678600827,1),(1329,1699160427,2),(1329,1710050427,1),(1329,1730610027,2),(1329,1741500027,1),(1329,1762059627,2),(1329,1772949627,1),(1329,1793509227,2),(1329,1805004027,1),(1329,1825563627,2),(1329,1836453627,1),(1329,1857013227,2),(1329,1867903227,1),(1329,1888462827,2),(1329,1899352827,1),(1329,1919912427,2),(1329,1930802427,1),(1329,1951362027,2),(1329,1962856827,1),(1329,1983416427,2),(1329,1994306427,1),(1329,2014866027,2),(1329,2025756027,1),(1329,2046315627,2),(1329,2057205627,1),(1329,2077765227,2),(1329,2088655227,1),(1329,2109214827,2),(1329,2120104827,1),(1329,2140664427,2),(1330,-2147483648,0),(1330,-1686083584,1),(1330,323845209,4),(1330,338950809,2),(1330,354675609,3),(1330,370400410,2),(1330,386125210,3),(1330,401850011,2),(1330,417574811,3),(1330,433299612,2),(1330,449024412,3),(1330,465354012,2),(1330,481078812,3),(1330,496803613,2),(1330,512528413,3),(1330,528253213,2),(1330,543978013,3),(1330,559702813,2),(1330,575427614,3),(1330,591152414,2),(1330,606877214,3),(1330,622602014,2),(1330,638326815,3),(1330,654656415,2),(1330,670381216,3),(1330,686106016,2),(1330,701830816,3),(1330,717555617,2),(1330,733280417,3),(1330,749005218,2),(1330,764730018,3),(1330,780454819,2),(1330,796179619,3),(1330,811904419,2),(1330,828234020,3),(1330,846378020,2),(1330,859683620,3),(1330,877827621,2),(1330,891133221,3),(1330,909277221,2),(1330,922582822,3),(1330,941331622,2),(1330,954032422,3),(1330,972781222,2),(1330,985482022,3),(1330,1004230822,2),(1330,1017536422,3),(1330,1035680422,2),(1330,1048986022,3),(1330,1067130022,2),(1330,1080435622,3),(1330,1099184422,2),(1330,1111885222,3),(1330,1130634022,2),(1330,1143334823,3),(1330,1162083623,2),(1330,1174784423,3),(1330,1193533223,2),(1330,1206838823,3),(1330,1224982823,2),(1330,1238288424,3),(1330,1256432424,2),(1330,1269738024,3),(1330,1288486824,2),(1330,1301187624,3),(1330,1319936424,2),(1330,1332637224,3),(1330,1351386025,2),(1330,1364691625,3),(1330,1382835625,2),(1330,1396141225,3),(1330,1414285225,2),(1330,1427590825,3),(1330,1445734826,2),(1330,1459040426,3),(1330,1477789226,2),(1330,1490490027,3),(1330,1509238827,2),(1330,1521939627,3),(1330,1540688427,2),(1330,1553994027,3),(1330,1572138027,2),(1330,1585443627,3),(1330,1603587627,2),(1330,1616893227,3),(1330,1635642027,2),(1330,1648342827,3),(1330,1667091627,2),(1330,1679792427,3),(1330,1698541227,2),(1330,1711846827,3),(1330,1729990827,2),(1330,1743296427,3),(1330,1761440427,2),(1330,1774746027,3),(1330,1792890027,2),(1330,1806195627,3),(1330,1824944427,2),(1330,1837645227,3),(1330,1856394027,2),(1330,1869094827,3),(1330,1887843627,2),(1330,1901149227,3),(1330,1919293227,2),(1330,1932598827,3),(1330,1950742827,2),(1330,1964048427,3),(1330,1982797227,2),(1330,1995498027,3),(1330,2014246827,2),(1330,2026947627,3),(1330,2045696427,2),(1330,2058397227,3),(1330,2077146027,2),(1330,2090451627,3),(1330,2108595627,2),(1330,2121901227,3),(1330,2140045227,2),(1331,-2147483648,1),(1331,-1632076148,2),(1331,-1615145348,1),(1331,-1096921748,3),(1331,-1061670600,4),(1331,-1048973400,3),(1331,-1030221000,4),(1331,-1017523800,3),(1331,-998771400,4),(1331,-986074200,3),(1331,-966717000,4),(1331,-954624600,3),(1331,-935267400,4),(1331,-922570200,3),(1331,-903817800,4),(1331,-891120600,3),(1331,-872368200,6),(1331,-769395600,5),(1331,-765401400,3),(1331,-746044200,4),(1331,-733347000,3),(1331,-714594600,4),(1331,-701897400,3),(1331,-683145000,4),(1331,-670447800,3),(1331,-651695400,4),(1331,-638998200,3),(1331,-619641000,4),(1331,-606943800,3),(1331,-589401000,4),(1331,-576099000,3),(1331,-557951400,4),(1331,-544649400,3),(1331,-526501800,4),(1331,-513199800,3),(1331,-495052200,4),(1331,-481750200,3),(1331,-463602600,4),(1331,-450300600,3),(1331,-431548200,4),(1331,-418246200,3),(1331,-400098600,4),(1331,-386796600,3),(1331,-368649000,4),(1331,-355347000,3),(1331,-337199400,4),(1331,-323897400,3),(1331,-305749800,4),(1331,-289423800,3),(1331,-273695400,4),(1331,-257974200,3),(1331,-242245800,4),(1331,-226524600,3),(1331,-210796200,4),(1331,-195075000,3),(1331,-179346600,4),(1331,-163625400,3),(1331,-147897000,4),(1331,-131571000,3),(1331,-119903400,8),(1331,-116445600,7),(1331,-100119600,8),(1331,-84391200,7),(1331,-68670000,8),(1331,-52941600,7),(1331,-37220400,8),(1331,-21492000,7),(1331,-5770800,8),(1331,9957600,7),(1331,25678800,8),(1331,41407200,7),(1331,57733200,8),(1331,73461600,7),(1331,89182801,8),(1331,104911202,7),(1331,120632402,8),(1331,136360803,7),(1331,152082003,8),(1331,167810404,7),(1331,183531604,8),(1331,199260005,7),(1331,215586005,8),(1331,230709606,7),(1331,247035606,8),(1331,262764007,7),(1331,278485207,8),(1331,294213608,7),(1331,309934808,8),(1331,325663209,7),(1331,341384409,8),(1331,357112809,7),(1331,372834010,8),(1331,388562410,7),(1331,404888411,8),(1331,420012011,7),(1331,436338012,8),(1331,452066412,7),(1331,467787612,8),(1331,483516012,7),(1331,499237213,8),(1331,514965613,7),(1331,530686813,8),(1331,544593673,7),(1331,562129273,8),(1331,576043274,9),(1331,594180074,8),(1331,607492874,7),(1331,625633274,8),(1331,638942475,7),(1331,657082875,8),(1331,670996876,7),(1331,688532476,8),(1331,702446476,7),(1331,719982077,8),(1331,733896077,7),(1331,752036478,8),(1331,765345678,7),(1331,783486079,8),(1331,796795279,7),(1331,814935679,8),(1331,828849680,7),(1331,846385280,8),(1331,860299280,7),(1331,877834881,8),(1331,891748881,7),(1331,909284481,8),(1331,923198482,7),(1331,941338882,8),(1331,954648082,7),(1331,972788482,8),(1331,986097682,7),(1331,1004238082,8),(1331,1018152082,7),(1331,1035687682,8),(1331,1049601682,7),(1331,1067137282,8),(1331,1081051282,7),(1331,1099191682,8),(1331,1112500882,7),(1331,1130641282,8),(1331,1143950483,7),(1331,1162090883,8),(1331,1173585683,7),(1331,1194145283,8),(1331,1205035283,7),(1331,1225594883,8),(1331,1236484884,7),(1331,1257044484,8),(1331,1268539284,7),(1331,1289098884,8),(1331,1299988884,7),(1331,1320555624,8),(1331,1331445624,7),(1331,1352005225,8),(1331,1362895225,7),(1331,1383454825,8),(1331,1394344825,7),(1331,1414904425,8),(1331,1425794425,7),(1331,1446354026,8),(1331,1457848826,7),(1331,1478408426,8),(1331,1489298427,7),(1331,1509858027,8),(1331,1520748027,7),(1331,1541307627,8),(1331,1552197627,7),(1331,1572757227,8),(1331,1583647227,7),(1331,1604206827,8),(1331,1615701627,7),(1331,1636261227,8),(1331,1647151227,7),(1331,1667710827,8),(1331,1678600827,7),(1331,1699160427,8),(1331,1710050427,7),(1331,1730610027,8),(1331,1741500027,7),(1331,1762059627,8),(1331,1772949627,7),(1331,1793509227,8),(1331,1805004027,7),(1331,1825563627,8),(1331,1836453627,7),(1331,1857013227,8),(1331,1867903227,7),(1331,1888462827,8),(1331,1899352827,7),(1331,1919912427,8),(1331,1930802427,7),(1331,1951362027,8),(1331,1962856827,7),(1331,1983416427,8),(1331,1994306427,7),(1331,2014866027,8),(1331,2025756027,7),(1331,2046315627,8),(1331,2057205627,7),(1331,2077765227,8),(1331,2088655227,7),(1331,2109214827,8),(1331,2120104827,7),(1331,2140664427,8),(1332,-2147483648,1),(1332,-1827687170,2),(1332,294217208,3),(1332,309938408,2),(1332,325666809,3),(1332,341388009,2),(1332,357116409,3),(1332,372837610,2),(1332,388566010,3),(1332,404892011,2),(1332,420015611,3),(1332,436341612,2),(1332,452070012,3),(1332,467791212,2),(1332,483519612,3),(1332,499240813,2),(1332,514969213,3),(1332,530690413,2),(1332,544604413,3),(1332,562140013,2),(1332,576054014,3),(1332,594194414,2),(1332,607503614,3),(1332,625644014,2),(1332,638953215,3),(1332,657093615,2),(1332,671007616,3),(1332,688543216,2),(1332,702457216,3),(1332,719992817,2),(1332,733906817,3),(1332,752047218,2),(1332,765356418,3),(1332,783496819,2),(1332,796806019,3),(1332,814946419,2),(1332,828860420,3),(1332,846396020,2),(1332,860310020,3),(1332,877845621,2),(1332,891759621,3),(1332,909295221,2),(1332,923209222,3),(1332,941349622,2),(1332,954658822,3),(1332,972799222,2),(1332,986108422,3),(1332,1004248822,2),(1332,1018162822,3),(1332,1035698422,2),(1332,1049612422,3),(1332,1067148022,2),(1332,1081062022,3),(1332,1099202422,2),(1332,1112511622,3),(1332,1130652022,2),(1332,1143961223,3),(1332,1162101623,2),(1332,1173596423,3),(1332,1194156023,2),(1332,1205046023,3),(1332,1225605623,2),(1332,1236495624,3),(1332,1257055224,2),(1332,1268550024,3),(1332,1289109624,2),(1332,1299999624,3),(1332,1320559224,2),(1332,1331449224,3),(1332,1352008825,2),(1332,1362898825,3),(1332,1383458425,2),(1332,1394348425,3),(1332,1414908025,2),(1332,1425798025,3),(1332,1446357626,4),(1332,1520751627,3),(1332,1541311227,2),(1332,1552201227,3),(1332,1572760827,2),(1332,1583650827,3),(1332,1604210427,2),(1332,1615705227,3),(1332,1636264827,2),(1332,1647154827,3),(1332,1667714427,2),(1332,1678604427,3),(1332,1699164027,2),(1332,1710054027,3),(1332,1730613627,2),(1332,1741503627,3),(1332,1762063227,2),(1332,1772953227,3),(1332,1793512827,2),(1332,1805007627,3),(1332,1825567227,2),(1332,1836457227,3),(1332,1857016827,2),(1332,1867906827,3),(1332,1888466427,2),(1332,1899356427,3),(1332,1919916027,2),(1332,1930806027,3),(1332,1951365627,2),(1332,1962860427,3),(1332,1983420027,2),(1332,1994310027,3),(1332,2014869627,2),(1332,2025759627,3),(1332,2046319227,2),(1332,2057209227,3),(1332,2077768827,2),(1332,2088658827,3),(1332,2109218427,2),(1332,2120108427,3),(1332,2140668027,2),(1333,-2147483648,0),(1333,-1825098836,1),(1334,-2147483648,0),(1334,-1825098836,1),(1335,-2147483648,0),(1335,-1617040676,2),(1335,123055202,1),(1335,130914003,2),(1335,422344811,1),(1335,433054812,2),(1335,669708016,1),(1335,684219616,2),(1335,1146376823,1),(1335,1159678823,2),(1336,-2147483648,1),(1336,-1230749160,3),(1336,722926817,2),(1336,728884817,3),(1337,-2147483648,0),(1337,-1730578040,1),(1337,176010304,2),(1337,662698816,3),(1338,-2147483648,0),(1338,-2131645536,2),(1338,-1696276800,1),(1338,-1680469200,2),(1338,-1632074400,1),(1338,-1615143600,2),(1338,-1566763200,1),(1338,-1557090000,2),(1338,-1535486400,1),(1338,-1524949200,2),(1338,-1504468800,1),(1338,-1493413200,2),(1338,-1472414400,1),(1338,-1461963600,2),(1338,-1440964800,1),(1338,-1429390800,2),(1338,-1409515200,1),(1338,-1396731600,2),(1338,-1376856000,1),(1338,-1366491600,2),(1338,-1346616000,1),(1338,-1333832400,2),(1338,-1313956800,1),(1338,-1303678800,2),(1338,-1282507200,1),(1338,-1272661200,2),(1338,-1251057600,1),(1338,-1240088400,2),(1338,-1219608000,1),(1338,-1207429200,2),(1338,-1188763200,1),(1338,-1175979600,2),(1338,-1157313600,1),(1338,-1143925200,2),(1338,-1124049600,1),(1338,-1113771600,2),(1338,-1091390400,1),(1338,-1081026000,2),(1338,-1059854400,1),(1338,-1050786000,2),(1338,-1030910400,1),(1338,-1018126800,2),(1338,-999460800,1),(1338,-986677200,2),(1338,-965592000,1),(1338,-955227600,2),(1338,-935956800,1),(1338,-923173200,2),(1338,-904507200,1),(1338,-891723600,2),(1338,-880221600,3),(1338,-769395600,4),(1338,-765399600,2),(1338,-747252000,1),(1338,-733950000,2),(1338,-715802400,1),(1338,-702500400,2),(1338,-684352800,1),(1338,-671050800,2),(1338,-652903200,1),(1338,-639601200,2),(1338,-589399200,1),(1338,-576097200,2),(1338,-557949600,1),(1338,-544647600,2),(1338,-526500000,1),(1338,-513198000,2),(1338,-495050400,1),(1338,-481748400,2),(1338,-431546400,1),(1338,-418244400,2),(1338,-400096800,1),(1338,-386794800,2),(1338,-368647200,1),(1338,-355345200,2),(1338,-337197600,1),(1338,-323895600,2),(1338,-242244000,1),(1338,-226522800,2),(1338,-210794400,1),(1338,-195073200,2),(1338,-179344800,1),(1338,-163623600,2),(1338,-147895200,1),(1338,-131569200,2),(1338,-116445600,1),(1338,-100119600,2),(1338,-84391200,1),(1338,-68670000,2),(1338,-52941600,1),(1338,-37220400,2),(1338,-21492000,1),(1338,-5770800,2),(1338,9957600,1),(1338,25678800,2),(1338,41407200,1),(1338,57733200,2),(1338,73461600,1),(1338,89182801,2),(1338,104911202,1),(1338,120632402,2),(1338,136360803,1),(1338,152082003,2),(1338,167810404,1),(1338,183531604,2),(1338,199260005,1),(1338,215586005,2),(1338,230709606,1),(1338,247035606,2),(1338,262764007,1),(1338,278485207,2),(1338,294213608,1),(1338,309934808,2),(1338,325663209,1),(1338,341384409,2),(1338,357112809,1),(1338,372834010,2),(1338,388562410,1),(1338,404888411,2),(1338,420012011,1),(1338,436338012,2),(1338,452066412,1),(1338,467787612,2),(1338,483516012,1),(1338,499237213,2),(1338,514965613,1),(1338,530686813,2),(1338,544600813,1),(1338,562136413,2),(1338,576050414,1),(1338,594190814,2),(1338,607500014,1),(1338,625640414,2),(1338,638949615,1),(1338,657090015,2),(1338,671004016,1),(1338,688539616,2),(1338,702453616,1),(1338,719989217,2),(1338,733903217,1),(1338,752043618,2),(1338,765352818,1),(1338,783493219,2),(1338,796802419,1),(1338,814942819,2),(1338,828856820,1),(1338,846392420,2),(1338,860306420,1),(1338,877842021,2),(1338,891756021,1),(1338,909291621,2),(1338,923205622,1),(1338,941346022,2),(1338,954655222,1),(1338,972795622,2),(1338,986104822,1),(1338,1004245222,2),(1338,1018159222,1),(1338,1035694822,2),(1338,1049608822,1),(1338,1067144422,2),(1338,1081058422,1),(1338,1099198822,2),(1338,1112508022,1),(1338,1130648422,2),(1338,1143957623,1),(1338,1162098023,2),(1338,1173592823,1),(1338,1194152423,2),(1338,1205042423,1),(1338,1225602023,2),(1338,1236492024,1),(1338,1257051624,2),(1338,1268546424,1),(1338,1289106024,2),(1338,1299996024,1),(1338,1320555624,2),(1338,1331445624,1),(1338,1352005225,2),(1338,1362895225,1),(1338,1383454825,2),(1338,1394344825,1),(1338,1414904425,2),(1338,1425794425,1),(1338,1446354026,2),(1338,1457848826,1),(1338,1478408426,2),(1338,1489298427,1),(1338,1509858027,2),(1338,1520748027,1),(1338,1541307627,2),(1338,1552197627,1),(1338,1572757227,2),(1338,1583647227,1),(1338,1604206827,2),(1338,1615701627,1),(1338,1636261227,2),(1338,1647151227,1),(1338,1667710827,2),(1338,1678600827,1),(1338,1699160427,2),(1338,1710050427,1),(1338,1730610027,2),(1338,1741500027,1),(1338,1762059627,2),(1338,1772949627,1),(1338,1793509227,2),(1338,1805004027,1),(1338,1825563627,2),(1338,1836453627,1),(1338,1857013227,2),(1338,1867903227,1),(1338,1888462827,2),(1338,1899352827,1),(1338,1919912427,2),(1338,1930802427,1),(1338,1951362027,2),(1338,1962856827,1),(1338,1983416427,2),(1338,1994306427,1),(1338,2014866027,2),(1338,2025756027,1),(1338,2046315627,2),(1338,2057205627,1),(1338,2077765227,2),(1338,2088655227,1),(1338,2109214827,2),(1338,2120104827,1),(1338,2140664427,2),(1339,-2147483648,1),(1339,-1402813824,3),(1339,-1311534000,2),(1339,-1300996800,3),(1339,-933534000,2),(1339,-925675200,3),(1339,-902084400,2),(1339,-893620800,3),(1339,-870030000,2),(1339,-862171200,3),(1339,-775681200,2),(1339,-767822400,3),(1339,-744231600,2),(1339,-736372800,3),(1339,-144702000,2),(1339,-134251200,3),(1339,-113425200,2),(1339,-102542400,3),(1339,-86295600,2),(1339,-72907200,3),(1339,-54154800,2),(1339,-41457600,3),(1339,-21495600,2),(1339,-5774400,3),(1339,9954000,2),(1339,25675200,3),(1339,41403600,2),(1339,57729600,3),(1339,73458000,2),(1339,87364801,3),(1339,104907602,2),(1339,118900802,3),(1339,136357203,2),(1339,150436803,3),(1339,167806804,2),(1339,183528004,3),(1339,199256405,2),(1339,215582405,3),(1339,230706006,2),(1339,247032006,3),(1339,263365207,2),(1339,276667207,3),(1339,290581208,2),(1339,308721608,3),(1339,322030809,2),(1339,340171209,3),(1339,358318809,2),(1339,371620810,3),(1339,389768410,2),(1339,403070411,3),(1339,421218011,2),(1339,434520012,3),(1339,452667612,2),(1339,466574412,3),(1339,484117212,2),(1339,498024013,3),(1339,511333213,2),(1339,529473613,3),(1339,542782813,2),(1339,560923213,3),(1339,574837214,2),(1339,592372814,3),(1339,606286814,2),(1339,623822414,3),(1339,638946015,2),(1339,655876815,3),(1339,671000416,2),(1339,687330016,4),(1339,702450016,2),(1339,718779617,4),(1339,733899617,2),(1339,750229218,4),(1339,765349218,2),(1339,781678819,4),(1339,796798819,2),(1339,813128419,4),(1339,828853220,2),(1339,844578020,4),(1339,860302820,2),(1339,876632421,4),(1339,891147621,5),(1339,909291621,4),(1339,922597222,5),(1339,941346022,4),(1339,954651622,5),(1339,972795622,4),(1339,986101222,5),(1339,1004245222,4),(1339,1018155622,5),(1339,1035694822,4),(1339,1049605222,5),(1339,1067144422,4),(1339,1080450022,5),(1339,1162098023,4),(1339,1173589223,5),(1339,1193547623,4),(1339,1205643623,5),(1339,1224997223,4),(1339,1236488424,5),(1339,1256446824,4),(1339,1268542824,5),(1339,1288501224,4),(1339,1300597224,5),(1339,1321160424,4),(1339,1333256424,5),(1339,1352005225,4),(1339,1362891625,5),(1339,1383454825,4),(1339,1394341225,5),(1339,1414904425,4),(1339,1425790825,5),(1339,1446354026,4),(1339,1457845226,5),(1339,1478408426,4),(1339,1489294827,5),(1339,1509858027,4),(1339,1520744427,5),(1339,1541307627,4),(1339,1552194027,5),(1339,1572757227,4),(1339,1583643627,5),(1339,1604206827,4),(1339,1615698027,5),(1339,1636261227,4),(1339,1647147627,5),(1339,1667710827,4),(1339,1678597227,5),(1339,1699160427,4),(1339,1710046827,5),(1339,1730610027,4),(1339,1741496427,5),(1339,1762059627,4),(1339,1772946027,5),(1339,1793509227,4),(1339,1805000427,5),(1339,1825563627,4),(1339,1836450027,5),(1339,1857013227,4),(1339,1867899627,5),(1339,1888462827,4),(1339,1899349227,5),(1339,1919912427,4),(1339,1930798827,5),(1339,1951362027,4),(1339,1962853227,5),(1339,1983416427,4),(1339,1994302827,5),(1339,2014866027,4),(1339,2025752427,5),(1339,2046315627,4),(1339,2057202027,5),(1339,2077765227,4),(1339,2088651627,5),(1339,2109214827,4),(1339,2120101227,5),(1339,2140664427,4),(1340,-2147483648,0),(1340,-1514739600,1),(1340,-1343066400,2),(1340,-1234807200,1),(1340,-1220292000,2),(1340,-1207159200,1),(1340,-1191344400,2),(1340,-873828000,1),(1340,-661539600,3),(1340,28800,1),(1340,828867620,4),(1340,846403220,1),(1340,860317220,4),(1340,877852821,1),(1340,891766821,4),(1340,909302421,1),(1341,-2147483648,2),(1341,-1633276800,1),(1341,-1615136400,2),(1341,-1601827200,1),(1341,-1583686800,2),(1341,-900259200,1),(1341,-891795600,2),(1341,-880214400,3),(1341,-769395600,4),(1341,-765392400,2),(1341,-747244800,1),(1341,-733942800,2),(1341,-715795200,1),(1341,-702493200,2),(1341,-684345600,1),(1341,-671043600,2),(1341,-652896000,1),(1341,-639594000,2),(1341,-620841600,1),(1341,-608144400,2),(1341,-589392000,1),(1341,-576090000,2),(1341,-557942400,1),(1341,-544640400,2),(1341,-526492800,1),(1341,-513190800,2),(1341,-495043200,1),(1341,-481741200,2),(1341,-463593600,5),(1341,-386787600,2),(1341,-368640000,5),(1341,-21488400,6),(1341,-5767200,5),(1341,9961200,6),(1341,25682400,5),(1341,1143961223,6),(1341,1162101623,5),(1341,1173596423,6),(1341,1194156023,5),(1341,1205046023,6),(1341,1225605623,5),(1341,1236495624,6),(1341,1257055224,5),(1341,1268550024,6),(1341,1289109624,5),(1341,1299999624,6),(1341,1320559224,5),(1341,1331449224,6),(1341,1352008825,5),(1341,1362898825,6),(1341,1383458425,5),(1341,1394348425,6),(1341,1414908025,5),(1341,1425798025,6),(1341,1446357626,5),(1341,1457852426,6),(1341,1478412026,5),(1341,1489302027,6),(1341,1509861627,5),(1341,1520751627,6),(1341,1541311227,5),(1341,1552201227,6),(1341,1572760827,5),(1341,1583650827,6),(1341,1604210427,5),(1341,1615705227,6),(1341,1636264827,5),(1341,1647154827,6),(1341,1667714427,5),(1341,1678604427,6),(1341,1699164027,5),(1341,1710054027,6),(1341,1730613627,5),(1341,1741503627,6),(1341,1762063227,5),(1341,1772953227,6),(1341,1793512827,5),(1341,1805007627,6),(1341,1825567227,5),(1341,1836457227,6),(1341,1857016827,5),(1341,1867906827,6),(1341,1888466427,5),(1341,1899356427,6),(1341,1919916027,5),(1341,1930806027,6),(1341,1951365627,5),(1341,1962860427,6),(1341,1983420027,5),(1341,1994310027,6),(1341,2014869627,5),(1341,2025759627,6),(1341,2046319227,5),(1341,2057209227,6),(1341,2077768827,5),(1341,2088658827,6),(1341,2109218427,5),(1341,2120108427,6),(1341,2140668027,5),(1342,-2147483648,2),(1342,-1633276800,1),(1342,-1615136400,2),(1342,-1601827200,1),(1342,-1583686800,2),(1342,-880214400,3),(1342,-769395600,4),(1342,-765392400,2),(1342,-715795200,1),(1342,-702493200,2),(1342,-684345600,1),(1342,-671043600,2),(1342,-652896000,1),(1342,-639594000,2),(1342,-620841600,1),(1342,-608144400,2),(1342,-589392000,1),(1342,-576090000,2),(1342,-557942400,1),(1342,-544640400,2),(1342,-526492800,1),(1342,-513190800,2),(1342,-495043200,1),(1342,-481741200,2),(1342,-463593600,1),(1342,-447267600,2),(1342,-431539200,1),(1342,-415818000,2),(1342,-400089600,1),(1342,-386787600,2),(1342,-368640000,1),(1342,-355338000,2),(1342,-337190400,1),(1342,-321469200,2),(1342,-305740800,1),(1342,-289414800,2),(1342,-273686400,1),(1342,-257965200,2),(1342,-242236800,5),(1342,-195066000,2),(1342,-84384000,1),(1342,-68662800,2),(1342,-52934400,1),(1342,-37213200,2),(1342,-21484800,1),(1342,-5763600,2),(1342,9964800,1),(1342,25686000,2),(1342,41414400,1),(1342,57740400,2),(1342,73468800,1),(1342,89190001,2),(1342,104918402,1),(1342,120639602,2),(1342,126691203,1),(1342,152089203,2),(1342,162374404,1),(1342,183538804,2),(1342,199267205,1),(1342,215593205,2),(1342,230716806,1),(1342,247042806,2),(1342,262771207,1),(1342,278492407,2),(1342,294220808,1),(1342,309942008,2),(1342,325670409,1),(1342,341391609,2),(1342,357120009,1),(1342,372841210,2),(1342,388569610,1),(1342,404895611,2),(1342,420019211,1),(1342,436345212,2),(1342,452073612,1),(1342,467794812,2),(1342,483523212,1),(1342,499244413,2),(1342,514972813,1),(1342,530694013,2),(1342,544608013,1),(1342,562143613,2),(1342,576057614,1),(1342,594198014,2),(1342,607507214,1),(1342,625647614,2),(1342,638956815,1),(1342,657097215,2),(1342,671011216,1),(1342,688546816,5),(1342,1143961223,1),(1342,1162105223,2),(1342,1173600023,1),(1342,1194159623,2),(1342,1205049623,1),(1342,1225609223,2),(1342,1236499224,1),(1342,1257058824,2),(1342,1268553624,1),(1342,1289113224,2),(1342,1300003224,1),(1342,1320562824,2),(1342,1331452824,1),(1342,1352012425,2),(1342,1362902425,1),(1342,1383462025,2),(1342,1394352025,1),(1342,1414911625,2),(1342,1425801625,1),(1342,1446361226,2),(1342,1457856026,1),(1342,1478415626,2),(1342,1489305627,1),(1342,1509865227,2),(1342,1520755227,1),(1342,1541314827,2),(1342,1552204827,1),(1342,1572764427,2),(1342,1583654427,1),(1342,1604214027,2),(1342,1615708827,1),(1342,1636268427,2),(1342,1647158427,1),(1342,1667718027,2),(1342,1678608027,1),(1342,1699167627,2),(1342,1710057627,1),(1342,1730617227,2),(1342,1741507227,1),(1342,1762066827,2),(1342,1772956827,1),(1342,1793516427,2),(1342,1805011227,1),(1342,1825570827,2),(1342,1836460827,1),(1342,1857020427,2),(1342,1867910427,1),(1342,1888470027,2),(1342,1899360027,1),(1342,1919919627,2),(1342,1930809627,1),(1342,1951369227,2),(1342,1962864027,1),(1342,1983423627,2),(1342,1994313627,1),(1342,2014873227,2),(1342,2025763227,1),(1342,2046322827,2),(1342,2057212827,1),(1342,2077772427,2),(1342,2088662427,1),(1342,2109222027,2),(1342,2120112027,1),(1342,2140671627,2),(1343,-2147483648,2),(1343,-1633276800,1),(1343,-1615136400,2),(1343,-1601827200,1),(1343,-1583686800,2),(1343,-880214400,3),(1343,-769395600,4),(1343,-765392400,2),(1343,-589392000,1),(1343,-576090000,2),(1343,-495043200,1),(1343,-481741200,2),(1343,-463593600,1),(1343,-450291600,2),(1343,-431539200,1),(1343,-418237200,2),(1343,-400089600,1),(1343,-386787600,2),(1343,-368640000,1),(1343,-355338000,2),(1343,-337190400,1),(1343,-323888400,2),(1343,-305740800,1),(1343,-292438800,2),(1343,-273686400,5),(1343,-21488400,6),(1343,-5767200,5),(1343,9961200,6),(1343,25682400,5),(1343,41410800,6),(1343,57736800,5),(1343,73465200,6),(1343,89186401,5),(1343,104914802,6),(1343,120636002,5),(1343,126687603,1),(1343,152089203,5),(1343,162370804,6),(1343,183535204,5),(1343,1143961223,6),(1343,1162101623,5),(1343,1173596423,6),(1343,1194156023,5),(1343,1205046023,6),(1343,1225605623,5),(1343,1236495624,6),(1343,1257055224,5),(1343,1268550024,6),(1343,1289109624,5),(1343,1299999624,6),(1343,1320559224,5),(1343,1331449224,6),(1343,1352008825,5),(1343,1362898825,6),(1343,1383458425,5),(1343,1394348425,6),(1343,1414908025,5),(1343,1425798025,6),(1343,1446357626,5),(1343,1457852426,6),(1343,1478412026,5),(1343,1489302027,6),(1343,1509861627,5),(1343,1520751627,6),(1343,1541311227,5),(1343,1552201227,6),(1343,1572760827,5),(1343,1583650827,6),(1343,1604210427,5),(1343,1615705227,6),(1343,1636264827,5),(1343,1647154827,6),(1343,1667714427,5),(1343,1678604427,6),(1343,1699164027,5),(1343,1710054027,6),(1343,1730613627,5),(1343,1741503627,6),(1343,1762063227,5),(1343,1772953227,6),(1343,1793512827,5),(1343,1805007627,6),(1343,1825567227,5),(1343,1836457227,6),(1343,1857016827,5),(1343,1867906827,6),(1343,1888466427,5),(1343,1899356427,6),(1343,1919916027,5),(1343,1930806027,6),(1343,1951365627,5),(1343,1962860427,6),(1343,1983420027,5),(1343,1994310027,6),(1343,2014869627,5),(1343,2025759627,6),(1343,2046319227,5),(1343,2057209227,6),(1343,2077768827,5),(1343,2088658827,6),(1343,2109218427,5),(1343,2120108427,6),(1343,2140668027,5),(1344,-2147483648,2),(1344,-1633276800,1),(1344,-1615136400,2),(1344,-1601827200,1),(1344,-1583686800,2),(1344,-880214400,3),(1344,-769395600,4),(1344,-765392400,2),(1344,-462996000,1),(1344,-450291600,2),(1344,-431539200,1),(1344,-418237200,2),(1344,-400089600,1),(1344,-386787600,2),(1344,-368640000,1),(1344,-355338000,2),(1344,-337190400,1),(1344,-323888400,2),(1344,-305740800,1),(1344,-292438800,2),(1344,-273686400,1),(1344,-257965200,2),(1344,-242236800,1),(1344,-226515600,2),(1344,-210787200,1),(1344,-195066000,2),(1344,-179337600,1),(1344,-163616400,2),(1344,-147888000,5),(1344,-100112400,2),(1344,-84384000,1),(1344,-68662800,2),(1344,-52934400,1),(1344,-37213200,2),(1344,-21484800,1),(1344,-5763600,2),(1344,9964800,1),(1344,25686000,2),(1344,41414400,1),(1344,57740400,2),(1344,73468800,1),(1344,89190001,2),(1344,104918402,1),(1344,120639602,2),(1344,126691203,1),(1344,152089203,2),(1344,162374404,1),(1344,183538804,2),(1344,199267205,1),(1344,215593205,2),(1344,230716806,1),(1344,247042806,5),(1344,1143961223,1),(1344,1162105223,2),(1344,1173600023,1),(1344,1194159623,5),(1344,1205046023,6),(1344,1225605623,5),(1344,1236495624,6),(1344,1257055224,5),(1344,1268550024,6),(1344,1289109624,5),(1344,1299999624,6),(1344,1320559224,5),(1344,1331449224,6),(1344,1352008825,5),(1344,1362898825,6),(1344,1383458425,5),(1344,1394348425,6),(1344,1414908025,5),(1344,1425798025,6),(1344,1446357626,5),(1344,1457852426,6),(1344,1478412026,5),(1344,1489302027,6),(1344,1509861627,5),(1344,1520751627,6),(1344,1541311227,5),(1344,1552201227,6),(1344,1572760827,5),(1344,1583650827,6),(1344,1604210427,5),(1344,1615705227,6),(1344,1636264827,5),(1344,1647154827,6),(1344,1667714427,5),(1344,1678604427,6),(1344,1699164027,5),(1344,1710054027,6),(1344,1730613627,5),(1344,1741503627,6),(1344,1762063227,5),(1344,1772953227,6),(1344,1793512827,5),(1344,1805007627,6),(1344,1825567227,5),(1344,1836457227,6),(1344,1857016827,5),(1344,1867906827,6),(1344,1888466427,5),(1344,1899356427,6),(1344,1919916027,5),(1344,1930806027,6),(1344,1951365627,5),(1344,1962860427,6),(1344,1983420027,5),(1344,1994310027,6),(1344,2014869627,5),(1344,2025759627,6),(1344,2046319227,5),(1344,2057209227,6),(1344,2077768827,5),(1344,2088658827,6),(1344,2109218427,5),(1344,2120108427,6),(1344,2140668027,5),(1345,-2147483648,2),(1345,-1633276800,1),(1345,-1615136400,2),(1345,-1601827200,1),(1345,-1583686800,2),(1345,-880214400,3),(1345,-769395600,4),(1345,-765392400,2),(1345,-747244800,1),(1345,-733942800,2),(1345,-526492800,1),(1345,-513190800,2),(1345,-495043200,1),(1345,-481741200,2),(1345,-462996000,1),(1345,-450291600,2),(1345,-431539200,1),(1345,-418237200,2),(1345,-400089600,1),(1345,-386787600,2),(1345,-368640000,1),(1345,-355338000,2),(1345,-337190400,1),(1345,-323888400,2),(1345,-305740800,1),(1345,-289414800,2),(1345,-273686400,1),(1345,-260989200,2),(1345,-242236800,1),(1345,-226515600,2),(1345,-210787200,1),(1345,-195066000,2),(1345,-179337600,5),(1345,-21488400,6),(1345,-5767200,5),(1345,9961200,6),(1345,25682400,5),(1345,1143961223,1),(1345,1162105223,2),(1345,1173600023,1),(1345,1194159623,2),(1345,1205049623,1),(1345,1225609223,2),(1345,1236499224,1),(1345,1257058824,2),(1345,1268553624,1),(1345,1289113224,2),(1345,1300003224,1),(1345,1320562824,2),(1345,1331452824,1),(1345,1352012425,2),(1345,1362902425,1),(1345,1383462025,2),(1345,1394352025,1),(1345,1414911625,2),(1345,1425801625,1),(1345,1446361226,2),(1345,1457856026,1),(1345,1478415626,2),(1345,1489305627,1),(1345,1509865227,2),(1345,1520755227,1),(1345,1541314827,2),(1345,1552204827,1),(1345,1572764427,2),(1345,1583654427,1),(1345,1604214027,2),(1345,1615708827,1),(1345,1636268427,2),(1345,1647158427,1),(1345,1667718027,2),(1345,1678608027,1),(1345,1699167627,2),(1345,1710057627,1),(1345,1730617227,2),(1345,1741507227,1),(1345,1762066827,2),(1345,1772956827,1),(1345,1793516427,2),(1345,1805011227,1),(1345,1825570827,2),(1345,1836460827,1),(1345,1857020427,2),(1345,1867910427,1),(1345,1888470027,2),(1345,1899360027,1),(1345,1919919627,2),(1345,1930809627,1),(1345,1951369227,2),(1345,1962864027,1),(1345,1983423627,2),(1345,1994313627,1),(1345,2014873227,2),(1345,2025763227,1),(1345,2046322827,2),(1345,2057212827,1),(1345,2077772427,2),(1345,2088662427,1),(1345,2109222027,2),(1345,2120112027,1),(1345,2140671627,2),(1346,-2147483648,2),(1346,-1633276800,1),(1346,-1615136400,2),(1346,-1601827200,1),(1346,-1583686800,2),(1346,-880214400,3),(1346,-769395600,4),(1346,-765392400,2),(1346,-495043200,5),(1346,-21488400,6),(1346,-5767200,5),(1346,9961200,6),(1346,25682400,5),(1346,41410800,6),(1346,57736800,5),(1346,73465200,6),(1346,89186401,5),(1346,1143961223,6),(1346,1162101623,5),(1346,1173596423,6),(1346,1194156023,5),(1346,1205046023,6),(1346,1225605623,5),(1346,1236495624,6),(1346,1257055224,5),(1346,1268550024,6),(1346,1289109624,5),(1346,1299999624,6),(1346,1320559224,5),(1346,1331449224,6),(1346,1352008825,5),(1346,1362898825,6),(1346,1383458425,5),(1346,1394348425,6),(1346,1414908025,5),(1346,1425798025,6),(1346,1446357626,5),(1346,1457852426,6),(1346,1478412026,5),(1346,1489302027,6),(1346,1509861627,5),(1346,1520751627,6),(1346,1541311227,5),(1346,1552201227,6),(1346,1572760827,5),(1346,1583650827,6),(1346,1604210427,5),(1346,1615705227,6),(1346,1636264827,5),(1346,1647154827,6),(1346,1667714427,5),(1346,1678604427,6),(1346,1699164027,5),(1346,1710054027,6),(1346,1730613627,5),(1346,1741503627,6),(1346,1762063227,5),(1346,1772953227,6),(1346,1793512827,5),(1346,1805007627,6),(1346,1825567227,5),(1346,1836457227,6),(1346,1857016827,5),(1346,1867906827,6),(1346,1888466427,5),(1346,1899356427,6),(1346,1919916027,5),(1346,1930806027,6),(1346,1951365627,5),(1346,1962860427,6),(1346,1983420027,5),(1346,1994310027,6),(1346,2014869627,5),(1346,2025759627,6),(1346,2046319227,5),(1346,2057209227,6),(1346,2077768827,5),(1346,2088658827,6),(1346,2109218427,5),(1346,2120108427,6),(1346,2140668027,5),(1347,-2147483648,2),(1347,-1633276800,1),(1347,-1615136400,2),(1347,-1601827200,1),(1347,-1583686800,2),(1347,-880214400,3),(1347,-769395600,4),(1347,-765392400,2),(1347,-747244800,1),(1347,-733942800,2),(1347,-526492800,1),(1347,-513190800,2),(1347,-495043200,1),(1347,-481741200,2),(1347,-462996000,1),(1347,-450291600,2),(1347,-431539200,1),(1347,-418237200,2),(1347,-400089600,1),(1347,-386787600,2),(1347,-368640000,1),(1347,-355338000,2),(1347,-337190400,1),(1347,-323888400,2),(1347,-305740800,1),(1347,-289414800,2),(1347,-273686400,1),(1347,-260989200,2),(1347,-242236800,1),(1347,-226515600,2),(1347,-210787200,1),(1347,-195066000,2),(1347,-179337600,5),(1347,-21488400,6),(1347,-5767200,5),(1347,9961200,6),(1347,25682400,5),(1347,1143961223,1),(1347,1162105223,2),(1347,1173600023,1),(1347,1194159623,5),(1347,1205046023,6),(1347,1225605623,5),(1347,1236495624,6),(1347,1257055224,5),(1347,1268550024,6),(1347,1289109624,5),(1347,1299999624,6),(1347,1320559224,5),(1347,1331449224,6),(1347,1352008825,5),(1347,1362898825,6),(1347,1383458425,5),(1347,1394348425,6),(1347,1414908025,5),(1347,1425798025,6),(1347,1446357626,5),(1347,1457852426,6),(1347,1478412026,5),(1347,1489302027,6),(1347,1509861627,5),(1347,1520751627,6),(1347,1541311227,5),(1347,1552201227,6),(1347,1572760827,5),(1347,1583650827,6),(1347,1604210427,5),(1347,1615705227,6),(1347,1636264827,5),(1347,1647154827,6),(1347,1667714427,5),(1347,1678604427,6),(1347,1699164027,5),(1347,1710054027,6),(1347,1730613627,5),(1347,1741503627,6),(1347,1762063227,5),(1347,1772953227,6),(1347,1793512827,5),(1347,1805007627,6),(1347,1825567227,5),(1347,1836457227,6),(1347,1857016827,5),(1347,1867906827,6),(1347,1888466427,5),(1347,1899356427,6),(1347,1919916027,5),(1347,1930806027,6),(1347,1951365627,5),(1347,1962860427,6),(1347,1983420027,5),(1347,1994310027,6),(1347,2014869627,5),(1347,2025759627,6),(1347,2046319227,5),(1347,2057209227,6),(1347,2077768827,5),(1347,2088658827,6),(1347,2109218427,5),(1347,2120108427,6),(1347,2140668027,5),(1348,-2147483648,2),(1348,-1633276800,1),(1348,-1615136400,2),(1348,-1601827200,1),(1348,-1583686800,2),(1348,-880214400,3),(1348,-769395600,4),(1348,-765392400,2),(1348,-747244800,1),(1348,-733942800,2),(1348,-715795200,1),(1348,-702493200,2),(1348,-684345600,1),(1348,-671043600,2),(1348,-652896000,1),(1348,-639594000,2),(1348,-620841600,1),(1348,-608144400,2),(1348,-589392000,1),(1348,-576090000,2),(1348,-557942400,1),(1348,-544640400,2),(1348,-526492800,1),(1348,-513190800,2),(1348,-495043200,1),(1348,-481741200,2),(1348,-463593600,1),(1348,-447267600,2),(1348,-431539200,1),(1348,-415818000,2),(1348,-400089600,1),(1348,-386787600,2),(1348,-368640000,1),(1348,-355338000,2),(1348,-337190400,1),(1348,-323888400,2),(1348,-305740800,1),(1348,-292438800,2),(1348,-273686400,5),(1348,-21488400,6),(1348,-5767200,5),(1348,9961200,6),(1348,25682400,5),(1348,1143961223,1),(1348,1162105223,2),(1348,1173600023,6),(1348,1194156023,5),(1348,1205046023,6),(1348,1225605623,5),(1348,1236495624,6),(1348,1257055224,5),(1348,1268550024,6),(1348,1289109624,5),(1348,1299999624,6),(1348,1320559224,5),(1348,1331449224,6),(1348,1352008825,5),(1348,1362898825,6),(1348,1383458425,5),(1348,1394348425,6),(1348,1414908025,5),(1348,1425798025,6),(1348,1446357626,5),(1348,1457852426,6),(1348,1478412026,5),(1348,1489302027,6),(1348,1509861627,5),(1348,1520751627,6),(1348,1541311227,5),(1348,1552201227,6),(1348,1572760827,5),(1348,1583650827,6),(1348,1604210427,5),(1348,1615705227,6),(1348,1636264827,5),(1348,1647154827,6),(1348,1667714427,5),(1348,1678604427,6),(1348,1699164027,5),(1348,1710054027,6),(1348,1730613627,5),(1348,1741503627,6),(1348,1762063227,5),(1348,1772953227,6),(1348,1793512827,5),(1348,1805007627,6),(1348,1825567227,5),(1348,1836457227,6),(1348,1857016827,5),(1348,1867906827,6),(1348,1888466427,5),(1348,1899356427,6),(1348,1919916027,5),(1348,1930806027,6),(1348,1951365627,5),(1348,1962860427,6),(1348,1983420027,5),(1348,1994310027,6),(1348,2014869627,5),(1348,2025759627,6),(1348,2046319227,5),(1348,2057209227,6),(1348,2077768827,5),(1348,2088658827,6),(1348,2109218427,5),(1348,2120108427,6),(1348,2140668027,5),(1349,-2147483648,2),(1349,-1633276800,1),(1349,-1615136400,2),(1349,-1601827200,1),(1349,-1583686800,2),(1349,-900259200,1),(1349,-891795600,2),(1349,-880214400,3),(1349,-769395600,4),(1349,-765392400,2),(1349,-747244800,1),(1349,-733942800,2),(1349,-715795200,1),(1349,-702493200,2),(1349,-684345600,1),(1349,-671043600,2),(1349,-652896000,1),(1349,-639594000,2),(1349,-620841600,1),(1349,-608144400,2),(1349,-589392000,1),(1349,-576090000,2),(1349,-557942400,1),(1349,-544640400,2),(1349,-526492800,1),(1349,-513190800,2),(1349,-495043200,1),(1349,-481741200,2),(1349,-463593600,5),(1349,-386787600,2),(1349,-368640000,5),(1349,-21488400,6),(1349,-5767200,5),(1349,9961200,6),(1349,25682400,5),(1349,1143961223,6),(1349,1162101623,5),(1349,1173596423,6),(1349,1194156023,5),(1349,1205046023,6),(1349,1225605623,5),(1349,1236495624,6),(1349,1257055224,5),(1349,1268550024,6),(1349,1289109624,5),(1349,1299999624,6),(1349,1320559224,5),(1349,1331449224,6),(1349,1352008825,5),(1349,1362898825,6),(1349,1383458425,5),(1349,1394348425,6),(1349,1414908025,5),(1349,1425798025,6),(1349,1446357626,5),(1349,1457852426,6),(1349,1478412026,5),(1349,1489302027,6),(1349,1509861627,5),(1349,1520751627,6),(1349,1541311227,5),(1349,1552201227,6),(1349,1572760827,5),(1349,1583650827,6),(1349,1604210427,5),(1349,1615705227,6),(1349,1636264827,5),(1349,1647154827,6),(1349,1667714427,5),(1349,1678604427,6),(1349,1699164027,5),(1349,1710054027,6),(1349,1730613627,5),(1349,1741503627,6),(1349,1762063227,5),(1349,1772953227,6),(1349,1793512827,5),(1349,1805007627,6),(1349,1825567227,5),(1349,1836457227,6),(1349,1857016827,5),(1349,1867906827,6),(1349,1888466427,5),(1349,1899356427,6),(1349,1919916027,5),(1349,1930806027,6),(1349,1951365627,5),(1349,1962860427,6),(1349,1983420027,5),(1349,1994310027,6),(1349,2014869627,5),(1349,2025759627,6),(1349,2046319227,5),(1349,2057209227,6),(1349,2077768827,5),(1349,2088658827,6),(1349,2109218427,5),(1349,2120108427,6),(1349,2140668027,5),(1350,-2147483648,0),(1350,-536457600,2),(1350,-147888000,1),(1350,-131558400,2),(1350,294228008,3),(1350,325674009,4),(1350,341395209,3),(1350,357123609,4),(1350,372844810,3),(1350,388573210,4),(1350,404899211,3),(1350,420022811,4),(1350,436348812,3),(1350,452077212,4),(1350,467798412,3),(1350,483526812,4),(1350,499248013,3),(1350,514976413,4),(1350,530697613,3),(1350,544611613,4),(1350,562147213,3),(1350,576061214,4),(1350,594201614,3),(1350,607510814,4),(1350,625651214,3),(1350,638960415,4),(1350,657100815,3),(1350,671014816,4),(1350,688550416,3),(1350,702464416,4),(1350,720000017,3),(1350,733914017,4),(1350,752054418,3),(1350,765363618,4),(1350,783504019,3),(1350,796813219,4),(1350,814953619,3),(1350,828867620,4),(1350,846403220,3),(1350,860317220,4),(1350,877852821,3),(1350,891766821,4),(1350,909302421,3),(1350,923216422,4),(1350,941356822,3),(1350,954666022,4),(1350,972806422,3),(1350,986115622,4),(1350,1004256022,3),(1350,1018170022,4),(1350,1035705622,3),(1350,1049619622,4),(1350,1067155222,3),(1350,1081069222,4),(1350,1099209622,3),(1350,1112518822,4),(1350,1130659222,3),(1350,1143968423,4),(1350,1162108823,3),(1350,1173603623,4),(1350,1194163223,3),(1350,1205053223,4),(1350,1225612823,3),(1350,1236502824,4),(1350,1257062424,3),(1350,1268557224,4),(1350,1289116824,3),(1350,1300006824,4),(1350,1320566424,3),(1350,1331456424,4),(1350,1352016025,3),(1350,1362906025,4),(1350,1383465625,3),(1350,1394355625,4),(1350,1414915225,3),(1350,1425805225,4),(1350,1446364826,3),(1350,1457859626,4),(1350,1478419226,3),(1350,1489309227,4),(1350,1509868827,3),(1350,1520758827,4),(1350,1541318427,3),(1350,1552208427,4),(1350,1572768027,3),(1350,1583658027,4),(1350,1604217627,3),(1350,1615712427,4),(1350,1636272027,3),(1350,1647162027,4),(1350,1667721627,3),(1350,1678611627,4),(1350,1699171227,3),(1350,1710061227,4),(1350,1730620827,3),(1350,1741510827,4),(1350,1762070427,3),(1350,1772960427,4),(1350,1793520027,3),(1350,1805014827,4),(1350,1825574427,3),(1350,1836464427,4),(1350,1857024027,3),(1350,1867914027,4),(1350,1888473627,3),(1350,1899363627,4),(1350,1919923227,3),(1350,1930813227,4),(1350,1951372827,3),(1350,1962867627,4),(1350,1983427227,3),(1350,1994317227,4),(1350,2014876827,3),(1350,2025766827,4),(1350,2046326427,3),(1350,2057216427,4),(1350,2077776027,3),(1350,2088666027,4),(1350,2109225627,3),(1350,2120115627,4),(1350,2140675227,3),(1351,-2147483648,0),(1351,-865296000,5),(1351,-769395600,1),(1351,-765396000,2),(1351,-147898800,3),(1351,-131569200,2),(1351,325666809,4),(1351,341388009,2),(1351,357116409,4),(1351,372837610,2),(1351,388566010,4),(1351,404892011,2),(1351,420015611,4),(1351,436341612,2),(1351,452070012,4),(1351,467791212,2),(1351,483519612,4),(1351,499240813,2),(1351,514969213,4),(1351,530690413,2),(1351,544604413,4),(1351,562140013,2),(1351,576054014,4),(1351,594194414,2),(1351,607503614,4),(1351,625644014,2),(1351,638953215,4),(1351,657093615,2),(1351,671007616,4),(1351,688543216,2),(1351,702457216,4),(1351,719992817,2),(1351,733906817,4),(1351,752047218,2),(1351,765356418,4),(1351,783496819,2),(1351,796806019,4),(1351,814946419,2),(1351,828860420,4),(1351,846396020,2),(1351,860310020,4),(1351,877845621,2),(1351,891759621,4),(1351,909295221,2),(1351,923209222,4),(1351,941349622,6),(1351,954662422,7),(1351,972802822,2),(1351,986108422,4),(1351,1004248822,2),(1351,1018162822,4),(1351,1035698422,2),(1351,1049612422,4),(1351,1067148022,2),(1351,1081062022,4),(1351,1099202422,2),(1351,1112511622,4),(1351,1130652022,2),(1351,1143961223,4),(1351,1162101623,2),(1351,1173596423,4),(1351,1194156023,2),(1351,1205046023,4),(1351,1225605623,2),(1351,1236495624,4),(1351,1257055224,2),(1351,1268550024,4),(1351,1289109624,2),(1351,1299999624,4),(1351,1320559224,2),(1351,1331449224,4),(1351,1352008825,2),(1351,1362898825,4),(1351,1383458425,2),(1351,1394348425,4),(1351,1414908025,2),(1351,1425798025,4),(1351,1446357626,2),(1351,1457852426,4),(1351,1478412026,2),(1351,1489302027,4),(1351,1509861627,2),(1351,1520751627,4),(1351,1541311227,2),(1351,1552201227,4),(1351,1572760827,2),(1351,1583650827,4),(1351,1604210427,2),(1351,1615705227,4),(1351,1636264827,2),(1351,1647154827,4),(1351,1667714427,2),(1351,1678604427,4),(1351,1699164027,2),(1351,1710054027,4),(1351,1730613627,2),(1351,1741503627,4),(1351,1762063227,2),(1351,1772953227,4),(1351,1793512827,2),(1351,1805007627,4),(1351,1825567227,2),(1351,1836457227,4),(1351,1857016827,2),(1351,1867906827,4),(1351,1888466427,2),(1351,1899356427,4),(1351,1919916027,2),(1351,1930806027,4),(1351,1951365627,2),(1351,1962860427,4),(1351,1983420027,2),(1351,1994310027,4),(1351,2014869627,2),(1351,2025759627,4),(1351,2046319227,2),(1351,2057209227,4),(1351,2077768827,2),(1351,2088658827,4),(1351,2109218427,2),(1351,2120108427,4),(1351,2140668027,2),(1352,-2147483648,1),(1352,-1827687170,2),(1352,126687603,3),(1352,152085603,2),(1352,162370804,3),(1352,183535204,2),(1352,199263605,3),(1352,215589605,2),(1352,230713206,3),(1352,247039206,2),(1352,262767607,3),(1352,278488807,2),(1352,294217208,3),(1352,309938408,2),(1352,325666809,3),(1352,341388009,2),(1352,357116409,3),(1352,372837610,2),(1352,388566010,3),(1352,404892011,2),(1352,420015611,3),(1352,436341612,2),(1353,-2147483648,1),(1353,-1567453392,2),(1353,-1233432000,3),(1353,-1222981200,2),(1353,-1205956800,3),(1353,-1194037200,2),(1353,-1172865600,3),(1353,-1162501200,2),(1353,-1141329600,3),(1353,-1130965200,2),(1353,-1109793600,3),(1353,-1099429200,2),(1353,-1078257600,3),(1353,-1067806800,2),(1353,-1046635200,3),(1353,-1036270800,2),(1353,-1015099200,3),(1353,-1004734800,2),(1353,-983563200,3),(1353,-973198800,2),(1353,-952027200,3),(1353,-941576400,2),(1353,-931032000,3),(1353,-900882000,2),(1353,-890337600,3),(1353,-833749200,2),(1353,-827265600,3),(1353,-752274000,2),(1353,-733780800,3),(1353,-197326800,2),(1353,-190843200,3),(1353,-184194000,2),(1353,-164491200,3),(1353,-152658000,2),(1353,-132955200,3),(1353,-121122000,2),(1353,-101419200,3),(1353,-86821200,2),(1353,-71092800,3),(1353,-54766800,2),(1353,-39038400,3),(1353,-23317200,2),(1353,-7588800,5),(1353,128142003,4),(1353,136605603,5),(1353,596948414,4),(1353,605066414,5),(1353,624423614,4),(1353,636516015,2),(1353,657086415,3),(1353,669178816,2),(1353,686721616,4),(1353,699415216,5),(1353,719377217,4),(1353,731469617,5),(1353,938919622,3),(1353,952052422,5),(1353,1198983623,4),(1353,1205632823,5),(1354,-2147483648,1),(1354,-880207200,2),(1354,-769395600,3),(1354,-765385200,1),(1354,-21477600,4),(1354,-5756400,1),(1354,9972000,4),(1354,25693200,1),(1354,41421600,4),(1354,57747600,1),(1354,73476000,4),(1354,89197201,1),(1354,104925602,4),(1354,120646802,1),(1354,126698403,4),(1354,152096403,1),(1354,162381604,4),(1354,183546004,1),(1354,199274405,4),(1354,215600405,1),(1354,230724006,4),(1354,247050006,1),(1354,262778407,4),(1354,278499607,1),(1354,294228008,4),(1354,309949208,1),(1354,325677609,5),(1354,341402409,1),(1354,357127209,4),(1354,372848410,1),(1354,388576810,4),(1354,404902811,1),(1354,420026411,4),(1354,436352412,6),(1354,439030812,8),(1354,452084412,7),(1354,467805612,8),(1354,483534012,7),(1354,499255213,8),(1354,514983613,7),(1354,530704813,8),(1354,544618813,7),(1354,562154413,8),(1354,576068414,7),(1354,594208814,8),(1354,607518014,7),(1354,625658414,8),(1354,638967615,7),(1354,657108015,8),(1354,671022016,7),(1354,688557616,8),(1354,702471616,7),(1354,720007217,8),(1354,733921217,7),(1354,752061618,8),(1354,765370818,7),(1354,783511219,8),(1354,796820419,7),(1354,814960819,8),(1354,828874820,7),(1354,846410420,8),(1354,860324420,7),(1354,877860021,8),(1354,891774021,7),(1354,909309621,8),(1354,923223622,7),(1354,941364022,8),(1354,954673222,7),(1354,972813622,8),(1354,986122822,7),(1354,1004263222,8),(1354,1018177222,7),(1354,1035712822,8),(1354,1049626822,7),(1354,1067162422,8),(1354,1081076422,7),(1354,1099216822,8),(1354,1112526022,7),(1354,1130666422,8),(1354,1143975623,7),(1354,1162116023,8),(1354,1173610823,7),(1354,1194170423,8),(1354,1205060423,7),(1354,1225620023,8),(1354,1236510024,7),(1354,1257069624,8),(1354,1268564424,7),(1354,1289124024,8),(1354,1300014024,7),(1354,1320573624,8),(1354,1331463624,7),(1354,1352023225,8),(1354,1362913225,7),(1354,1383472825,8),(1354,1394362825,7),(1354,1414922425,8),(1354,1425812425,7),(1354,1446372026,8),(1354,1457866826,7),(1354,1478426426,8),(1354,1489316427,7),(1354,1509876027,8),(1354,1520766027,7),(1354,1541325627,8),(1354,1552215627,7),(1354,1572775227,8),(1354,1583665227,7),(1354,1604224827,8),(1354,1615719627,7),(1354,1636279227,8),(1354,1647169227,7),(1354,1667728827,8),(1354,1678618827,7),(1354,1699178427,8),(1354,1710068427,7),(1354,1730628027,8),(1354,1741518027,7),(1354,1762077627,8),(1354,1772967627,7),(1354,1793527227,8),(1354,1805022027,7),(1354,1825581627,8),(1354,1836471627,7),(1354,1857031227,8),(1354,1867921227,7),(1354,1888480827,8),(1354,1899370827,7),(1354,1919930427,8),(1354,1930820427,7),(1354,1951380027,8),(1354,1962874827,7),(1354,1983434427,8),(1354,1994324427,7),(1354,2014884027,8),(1354,2025774027,7),(1354,2046333627,8),(1354,2057223627,7),(1354,2077783227,8),(1354,2088673227,7),(1354,2109232827,8),(1354,2120122827,7),(1354,2140682427,8),(1355,-2147483648,2),(1355,-1633276800,1),(1355,-1615136400,2),(1355,-1601827200,1),(1355,-1583686800,2),(1355,-1535904000,1),(1355,-1525280400,2),(1355,-905097600,1),(1355,-891795600,2),(1355,-880214400,3),(1355,-769395600,4),(1355,-765392400,2),(1355,-757360800,1),(1355,-744224400,2),(1355,-715795200,1),(1355,-608144400,2),(1355,-589392000,1),(1355,-576090000,2),(1355,-557942400,1),(1355,-544640400,2),(1355,-526492800,1),(1355,-513190800,2),(1355,-495043200,1),(1355,-481741200,2),(1355,-463593600,1),(1355,-450291600,2),(1355,-431539200,1),(1355,-415818000,2),(1355,-400089600,1),(1355,-384368400,2),(1355,-368640000,1),(1355,-352918800,2),(1355,-337190400,1),(1355,-321469200,2),(1355,-305740800,1),(1355,-289414800,2),(1355,-273686400,1),(1355,-266432400,5),(1355,-52938000,6),(1355,-37216800,5),(1355,-21488400,6),(1355,-5767200,5),(1355,9961200,6),(1355,25682400,5),(1355,41410800,6),(1355,57736800,5),(1355,73465200,6),(1355,89186401,5),(1355,104914802,6),(1355,120636002,5),(1355,126687603,1),(1355,152089203,5),(1355,162370804,6),(1355,183535204,5),(1355,199263605,6),(1355,215589605,5),(1355,230713206,6),(1355,247039206,5),(1355,262767607,6),(1355,278488807,5),(1355,294217208,6),(1355,309938408,5),(1355,325666809,6),(1355,341388009,5),(1355,357116409,6),(1355,372837610,5),(1355,388566010,6),(1355,404892011,5),(1355,420015611,6),(1355,436341612,5),(1355,452070012,6),(1355,467791212,5),(1355,483519612,6),(1355,499240813,5),(1355,514969213,6),(1355,530690413,5),(1355,544604413,6),(1355,562140013,5),(1355,576054014,6),(1355,594194414,5),(1355,607503614,6),(1355,625644014,5),(1355,638953215,6),(1355,657093615,5),(1355,671007616,6),(1355,688543216,5),(1355,702457216,6),(1355,719992817,5),(1355,733906817,6),(1355,752047218,5),(1355,765356418,6),(1355,783496819,5),(1355,796806019,6),(1355,814946419,5),(1355,828860420,6),(1355,846396020,5),(1355,860310020,6),(1355,877845621,5),(1355,891759621,6),(1355,909295221,5),(1355,923209222,6),(1355,941349622,5),(1355,954658822,6),(1355,972799222,5),(1355,986108422,6),(1355,1004248822,5),(1355,1018162822,6),(1355,1035698422,5),(1355,1049612422,6),(1355,1067148022,5),(1355,1081062022,6),(1355,1099202422,5),(1355,1112511622,6),(1355,1130652022,5),(1355,1143961223,6),(1355,1162101623,5),(1355,1173596423,6),(1355,1194156023,5),(1355,1205046023,6),(1355,1225605623,5),(1355,1236495624,6),(1355,1257055224,5),(1355,1268550024,6),(1355,1289109624,5),(1355,1299999624,6),(1355,1320559224,5),(1355,1331449224,6),(1355,1352008825,5),(1355,1362898825,6),(1355,1383458425,5),(1355,1394348425,6),(1355,1414908025,5),(1355,1425798025,6),(1355,1446357626,5),(1355,1457852426,6),(1355,1478412026,5),(1355,1489302027,6),(1355,1509861627,5),(1355,1520751627,6),(1355,1541311227,5),(1355,1552201227,6),(1355,1572760827,5),(1355,1583650827,6),(1355,1604210427,5),(1355,1615705227,6),(1355,1636264827,5),(1355,1647154827,6),(1355,1667714427,5),(1355,1678604427,6),(1355,1699164027,5),(1355,1710054027,6),(1355,1730613627,5),(1355,1741503627,6),(1355,1762063227,5),(1355,1772953227,6),(1355,1793512827,5),(1355,1805007627,6),(1355,1825567227,5),(1355,1836457227,6),(1355,1857016827,5),(1355,1867906827,6),(1355,1888466427,5),(1355,1899356427,6),(1355,1919916027,5),(1355,1930806027,6),(1355,1951365627,5),(1355,1962860427,6),(1355,1983420027,5),(1355,1994310027,6),(1355,2014869627,5),(1355,2025759627,6),(1355,2046319227,5),(1355,2057209227,6),(1355,2077768827,5),(1355,2088658827,6),(1355,2109218427,5),(1355,2120108427,6),(1355,2140668027,5),(1356,-2147483648,2),(1356,-1633276800,1),(1356,-1615136400,2),(1356,-1601827200,1),(1356,-1583686800,2),(1356,-880214400,3),(1356,-769395600,4),(1356,-765392400,2),(1356,-52934400,1),(1356,-37213200,2),(1356,-21484800,1),(1356,-5763600,2),(1356,9964800,1),(1356,25686000,2),(1356,41414400,1),(1356,57740400,2),(1356,73468800,1),(1356,89190001,2),(1356,104918402,1),(1356,120639602,2),(1356,126691203,1),(1356,152089203,2),(1356,162374404,1),(1356,183538804,2),(1356,199267205,1),(1356,215593205,2),(1356,230716806,1),(1356,247042806,2),(1356,262771207,1),(1356,278492407,2),(1356,294220808,1),(1356,309942008,2),(1356,325670409,1),(1356,341391609,2),(1356,357120009,1),(1356,372841210,2),(1356,388569610,1),(1356,404895611,2),(1356,420019211,1),(1356,436345212,2),(1356,452073612,1),(1356,467794812,2),(1356,483523212,1),(1356,499244413,2),(1356,514972813,1),(1356,530694013,2),(1356,544608013,1),(1356,562143613,2),(1356,576057614,1),(1356,594198014,2),(1356,607507214,1),(1356,625647614,2),(1356,638956815,1),(1356,657097215,2),(1356,671011216,1),(1356,688546816,2),(1356,702460816,1),(1356,719996417,2),(1356,733910417,1),(1356,752050818,2),(1356,765360018,1),(1356,783500419,2),(1356,796809619,1),(1356,814950019,2),(1356,828864020,1),(1356,846399620,2),(1356,860313620,1),(1356,877849221,2),(1356,891763221,1),(1356,909298821,2),(1356,923212822,1),(1356,941353222,2),(1356,954662422,1),(1356,972802822,6),(1356,986108422,5),(1356,1004248822,6),(1356,1018162822,5),(1356,1035698422,6),(1356,1049612422,5),(1356,1067148022,6),(1356,1081062022,5),(1356,1099202422,6),(1356,1112511622,5),(1356,1130652022,6),(1356,1143961223,5),(1356,1162101623,6),(1356,1173596423,5),(1356,1194156023,6),(1356,1205046023,5),(1356,1225605623,6),(1356,1236495624,5),(1356,1257055224,6),(1356,1268550024,5),(1356,1289109624,6),(1356,1299999624,5),(1356,1320559224,6),(1356,1331449224,5),(1356,1352008825,6),(1356,1362898825,5),(1356,1383458425,6),(1356,1394348425,5),(1356,1414908025,6),(1356,1425798025,5),(1356,1446357626,6),(1356,1457852426,5),(1356,1478412026,6),(1356,1489302027,5),(1356,1509861627,6),(1356,1520751627,5),(1356,1541311227,6),(1356,1552201227,5),(1356,1572760827,6),(1356,1583650827,5),(1356,1604210427,6),(1356,1615705227,5),(1356,1636264827,6),(1356,1647154827,5),(1356,1667714427,6),(1356,1678604427,5),(1356,1699164027,6),(1356,1710054027,5),(1356,1730613627,6),(1356,1741503627,5),(1356,1762063227,6),(1356,1772953227,5),(1356,1793512827,6),(1356,1805007627,5),(1356,1825567227,6),(1356,1836457227,5),(1356,1857016827,6),(1356,1867906827,5),(1356,1888466427,6),(1356,1899356427,5),(1356,1919916027,6),(1356,1930806027,5),(1356,1951365627,6),(1356,1962860427,5),(1356,1983420027,6),(1356,1994310027,5),(1356,2014869627,6),(1356,2025759627,5),(1356,2046319227,6),(1356,2057209227,5),(1356,2077768827,6),(1356,2088658827,5),(1356,2109218427,6),(1356,2120108427,5),(1356,2140668027,6),(1357,-2147483648,2),(1357,-1633276800,1),(1357,-1615136400,2),(1357,-1601827200,1),(1357,-1583686800,2),(1357,-880214400,3),(1357,-769395600,4),(1357,-765392400,2),(1357,-715795200,1),(1357,-702493200,2),(1357,-684345600,1),(1357,-671043600,2),(1357,-652896000,1),(1357,-639594000,2),(1357,-620841600,1),(1357,-608144400,2),(1357,-589392000,1),(1357,-576090000,2),(1357,-557942400,1),(1357,-544640400,2),(1357,-526492800,1),(1357,-513190800,2),(1357,-495043200,1),(1357,-481741200,2),(1357,-463593600,1),(1357,-447267600,2),(1357,-431539200,1),(1357,-415818000,2),(1357,-400089600,1),(1357,-386787600,2),(1357,-368640000,1),(1357,-355338000,2),(1357,-337190400,1),(1357,-321469200,2),(1357,-305740800,1),(1357,-289414800,2),(1357,-273686400,1),(1357,-257965200,2),(1357,-242236800,5),(1357,-195066000,2),(1357,-84384000,1),(1357,-68662800,2),(1357,-52934400,1),(1357,-37213200,2),(1357,-21484800,1),(1357,-5763600,2),(1357,9964800,1),(1357,25686000,2),(1357,41414400,1),(1357,57740400,2),(1357,73468800,1),(1357,89190001,2),(1357,104918402,1),(1357,120639602,2),(1357,126691203,1),(1357,152089203,2),(1357,162374404,1),(1357,183538804,2),(1357,199267205,1),(1357,215593205,2),(1357,230716806,1),(1357,247042806,2),(1357,262771207,1),(1357,278492407,2),(1357,294220808,1),(1357,309942008,2),(1357,325670409,1),(1357,341391609,2),(1357,357120009,1),(1357,372841210,2),(1357,388569610,1),(1357,404895611,2),(1357,420019211,1),(1357,436345212,2),(1357,452073612,1),(1357,467794812,2),(1357,483523212,1),(1357,499244413,2),(1357,514972813,1),(1357,530694013,2),(1357,544608013,1),(1357,562143613,2),(1357,576057614,1),(1357,594198014,2),(1357,607507214,1),(1357,625647614,2),(1357,638956815,1),(1357,657097215,2),(1357,671011216,1),(1357,688546816,5),(1357,1143961223,1),(1357,1162105223,2),(1357,1173600023,1),(1357,1194159623,2),(1357,1205049623,1),(1357,1225609223,2),(1357,1236499224,1),(1357,1257058824,2),(1357,1268553624,1),(1357,1289113224,2),(1357,1300003224,1),(1357,1320562824,2),(1357,1331452824,1),(1357,1352012425,2),(1357,1362902425,1),(1357,1383462025,2),(1357,1394352025,1),(1357,1414911625,2),(1357,1425801625,1),(1357,1446361226,2),(1357,1457856026,1),(1357,1478415626,2),(1357,1489305627,1),(1357,1509865227,2),(1357,1520755227,1),(1357,1541314827,2),(1357,1552204827,1),(1357,1572764427,2),(1357,1583654427,1),(1357,1604214027,2),(1357,1615708827,1),(1357,1636268427,2),(1357,1647158427,1),(1357,1667718027,2),(1357,1678608027,1),(1357,1699167627,2),(1357,1710057627,1),(1357,1730617227,2),(1357,1741507227,1),(1357,1762066827,2),(1357,1772956827,1),(1357,1793516427,2),(1357,1805011227,1),(1357,1825570827,2),(1357,1836460827,1),(1357,1857020427,2),(1357,1867910427,1),(1357,1888470027,2),(1357,1899360027,1),(1357,1919919627,2),(1357,1930809627,1),(1357,1951369227,2),(1357,1962864027,1),(1357,1983423627,2),(1357,1994313627,1),(1357,2014873227,2),(1357,2025763227,1),(1357,2046322827,2),(1357,2057212827,1),(1357,2077772427,2),(1357,2088662427,1),(1357,2109222027,2),(1357,2120112027,1),(1357,2140671627,2),(1358,-2147483648,0),(1358,-1826738653,1),(1358,-157750200,2),(1359,-2147483648,1),(1359,-1205954844,2),(1359,-1192307244,3),(1360,-2147483648,1),(1360,-1938538284,3),(1360,-1009825200,2),(1360,-1002052800,3),(1360,-986756400,2),(1360,-971035200,3),(1360,-955306800,2),(1360,-939585600,3),(1360,504939613,2),(1360,512712013,3),(1360,536475613,2),(1360,544248013,3),(1360,631170015,2),(1360,638942415,3),(1360,757400418,2),(1360,765172818,3),(1361,-2147483648,2),(1361,-1633269600,1),(1361,-1615129200,2),(1361,-1601820000,1),(1361,-1583679600,2),(1361,-880207200,3),(1361,-769395600,4),(1361,-765385200,2),(1361,-687967140,1),(1361,-662655600,2),(1361,-620838000,1),(1361,-608137200,2),(1361,-589388400,1),(1361,-576082800,2),(1361,-557938800,1),(1361,-544633200,2),(1361,-526489200,1),(1361,-513183600,2),(1361,-495039600,1),(1361,-481734000,2),(1361,-463590000,1),(1361,-450284400,2),(1361,-431535600,1),(1361,-418230000,2),(1361,-400086000,1),(1361,-386780400,2),(1361,-368636400,1),(1361,-355330800,2),(1361,-337186800,1),(1361,-323881200,2),(1361,-305737200,1),(1361,-292431600,2),(1361,-273682800,1),(1361,-260982000,2),(1361,-242233200,1),(1361,-226508400,2),(1361,-210783600,1),(1361,-195058800,2),(1361,-179334000,1),(1361,-163609200,2),(1361,-147884400,1),(1361,-131554800,2),(1361,-116434800,1),(1361,-100105200,2),(1361,-84376800,1),(1361,-68655600,2),(1361,-52927200,1),(1361,-37206000,2),(1361,-21477600,1),(1361,-5756400,2),(1361,9972000,1),(1361,25693200,2),(1361,41421600,1),(1361,57747600,2),(1361,73476000,1),(1361,89197201,2),(1361,104925602,1),(1361,120646802,2),(1361,126698403,1),(1361,152096403,2),(1361,162381604,1),(1361,183546004,2),(1361,199274405,1),(1361,215600405,2),(1361,230724006,1),(1361,247050006,2),(1361,262778407,1),(1361,278499607,2),(1361,294228008,1),(1361,309949208,2),(1361,325677609,1),(1361,341398809,2),(1361,357127209,1),(1361,372848410,2),(1361,388576810,1),(1361,404902811,2),(1361,420026411,1),(1361,436352412,2),(1361,452080812,1),(1361,467802012,2),(1361,483530412,1),(1361,499251613,2),(1361,514980013,1),(1361,530701213,2),(1361,544615213,1),(1361,562150813,2),(1361,576064814,1),(1361,594205214,2),(1361,607514414,1),(1361,625654814,2),(1361,638964015,1),(1361,657104415,2),(1361,671018416,1),(1361,688554016,2),(1361,702468016,1),(1361,720003617,2),(1361,733917617,1),(1361,752058018,2),(1361,765367218,1),(1361,783507619,2),(1361,796816819,1),(1361,814957219,2),(1361,828871220,1),(1361,846406820,2),(1361,860320820,1),(1361,877856421,2),(1361,891770421,1),(1361,909306021,2),(1361,923220022,1),(1361,941360422,2),(1361,954669622,1),(1361,972810022,2),(1361,986119222,1),(1361,1004259622,2),(1361,1018173622,1),(1361,1035709222,2),(1361,1049623222,1),(1361,1067158822,2),(1361,1081072822,1),(1361,1099213222,2),(1361,1112522422,1),(1361,1130662822,2),(1361,1143972023,1),(1361,1162112423,2),(1361,1173607223,1),(1361,1194166823,2),(1361,1205056823,1),(1361,1225616423,2),(1361,1236506424,1),(1361,1257066024,2),(1361,1268560824,1),(1361,1289120424,2),(1361,1300010424,1),(1361,1320570024,2),(1361,1331460024,1),(1361,1352019625,2),(1361,1362909625,1),(1361,1383469225,2),(1361,1394359225,1),(1361,1414918825,2),(1361,1425808825,1),(1361,1446368426,2),(1361,1457863226,1),(1361,1478422826,2),(1361,1489312827,1),(1361,1509872427,2),(1361,1520762427,1),(1361,1541322027,2),(1361,1552212027,1),(1361,1572771627,2),(1361,1583661627,1),(1361,1604221227,2),(1361,1615716027,1),(1361,1636275627,2),(1361,1647165627,1),(1361,1667725227,2),(1361,1678615227,1),(1361,1699174827,2),(1361,1710064827,1),(1361,1730624427,2),(1361,1741514427,1),(1361,1762074027,2),(1361,1772964027,1),(1361,1793523627,2),(1361,1805018427,1),(1361,1825578027,2),(1361,1836468027,1),(1361,1857027627,2),(1361,1867917627,1),(1361,1888477227,2),(1361,1899367227,1),(1361,1919926827,2),(1361,1930816827,1),(1361,1951376427,2),(1361,1962871227,1),(1361,1983430827,2),(1361,1994320827,1),(1361,2014880427,2),(1361,2025770427,1),(1361,2046330027,2),(1361,2057220027,1),(1361,2077779627,2),(1361,2088669627,1),(1361,2109229227,2),(1361,2120119227,1),(1361,2140678827,2),(1362,-2147483648,2),(1362,-1633276800,1),(1362,-1615136400,2),(1362,-1601827200,1),(1362,-1583686800,2),(1362,-1535904000,1),(1362,-1525280400,2),(1362,-905097600,1),(1362,-891795600,2),(1362,-880214400,3),(1362,-769395600,4),(1362,-765392400,2),(1362,-757360800,1),(1362,-744224400,2),(1362,-715795200,1),(1362,-608144400,2),(1362,-589392000,1),(1362,-576090000,2),(1362,-557942400,1),(1362,-544640400,2),(1362,-526492800,1),(1362,-513190800,2),(1362,-495043200,1),(1362,-481741200,2),(1362,-463593600,1),(1362,-450291600,2),(1362,-431539200,1),(1362,-415818000,2),(1362,-400089600,1),(1362,-384368400,2),(1362,-368640000,1),(1362,-352918800,2),(1362,-337190400,1),(1362,-321469200,2),(1362,-305740800,1),(1362,-289414800,2),(1362,-273686400,1),(1362,-266432400,5),(1362,-52938000,6),(1362,-37216800,5),(1362,-21488400,6),(1362,-5767200,5),(1362,9961200,6),(1362,25682400,5),(1362,41410800,6),(1362,57736800,5),(1362,73465200,6),(1362,89186401,5),(1362,104914802,6),(1362,120636002,5),(1362,126687603,1),(1362,152089203,5),(1362,162370804,6),(1362,183535204,5),(1362,199263605,6),(1362,215589605,5),(1362,230713206,6),(1362,247039206,5),(1362,262767607,6),(1362,278488807,5),(1362,294217208,6),(1362,309938408,5),(1362,325666809,6),(1362,341388009,5),(1362,357116409,6),(1362,372837610,5),(1362,388566010,6),(1362,404892011,5),(1362,420015611,6),(1362,436341612,5),(1362,452070012,6),(1362,467791212,5),(1362,483519612,6),(1362,499240813,5),(1362,514969213,6),(1362,530690413,5),(1362,544604413,6),(1362,562140013,5),(1362,576054014,6),(1362,594194414,5),(1362,607503614,6),(1362,625644014,5),(1362,638953215,6),(1362,657093615,5),(1362,671007616,6),(1362,688543216,5),(1362,702457216,6),(1362,719992817,5),(1362,733906817,6),(1362,752047218,5),(1362,765356418,6),(1362,783496819,5),(1362,796806019,6),(1362,814946419,5),(1362,828860420,6),(1362,846396020,5),(1362,860310020,6),(1362,877845621,5),(1362,891759621,6),(1362,909295221,5),(1362,923209222,6),(1362,941349622,5),(1362,954658822,6),(1362,972799222,5),(1362,986108422,6),(1362,1004248822,5),(1362,1018162822,6),(1362,1035698422,5),(1362,1049612422,6),(1362,1067148022,5),(1362,1081062022,6),(1362,1099202422,5),(1362,1112511622,6),(1362,1130652022,5),(1362,1143961223,6),(1362,1162101623,5),(1362,1173596423,6),(1362,1194156023,5),(1362,1205046023,6),(1362,1225605623,5),(1362,1236495624,6),(1362,1257055224,5),(1362,1268550024,6),(1362,1289109624,5),(1362,1299999624,6),(1362,1320559224,5),(1362,1331449224,6),(1362,1352008825,5),(1362,1362898825,6),(1362,1383458425,5),(1362,1394348425,6),(1362,1414908025,5),(1362,1425798025,6),(1362,1446357626,5),(1362,1457852426,6),(1362,1478412026,5),(1362,1489302027,6),(1362,1509861627,5),(1362,1520751627,6),(1362,1541311227,5),(1362,1552201227,6),(1362,1572760827,5),(1362,1583650827,6),(1362,1604210427,5),(1362,1615705227,6),(1362,1636264827,5),(1362,1647154827,6),(1362,1667714427,5),(1362,1678604427,6),(1362,1699164027,5),(1362,1710054027,6),(1362,1730613627,5),(1362,1741503627,6),(1362,1762063227,5),(1362,1772953227,6),(1362,1793512827,5),(1362,1805007627,6),(1362,1825567227,5),(1362,1836457227,6),(1362,1857016827,5),(1362,1867906827,6),(1362,1888466427,5),(1362,1899356427,6),(1362,1919916027,5),(1362,1930806027,6),(1362,1951365627,5),(1362,1962860427,6),(1362,1983420027,5),(1362,1994310027,6),(1362,2014869627,5),(1362,2025759627,6),(1362,2046319227,5),(1362,2057209227,6),(1362,2077768827,5),(1362,2088658827,6),(1362,2109218427,5),(1362,2120108427,6),(1362,2140668027,5),(1363,-2147483648,0),(1363,-1826738653,1),(1363,-157750200,2),(1364,-2147483648,0),(1364,-1767217028,2),(1364,-1206957600,1),(1364,-1191362400,2),(1364,-1175374800,1),(1364,-1159826400,2),(1364,-633819600,1),(1364,-622069200,2),(1364,-602283600,1),(1364,-591832800,2),(1364,-570747600,1),(1364,-560210400,2),(1364,-539125200,1),(1364,-531352800,2),(1364,-191365200,1),(1364,-184197600,2),(1364,-155163600,1),(1364,-150069600,2),(1364,-128898000,1),(1364,-121125600,2),(1364,-99954000,1),(1364,-89589600,2),(1364,-68418000,1),(1364,-57967200,2),(1364,499748413,1),(1364,511236013,2),(1364,530593213,1),(1364,540266413,2),(1364,562129213,1),(1364,571197614,2),(1364,592974014,1),(1364,602042414,2),(1364,624423614,1),(1364,634701615,2),(1364,813726019,1),(1364,824004020,2),(1364,938919622,1),(1364,951616822,2),(1364,970974022,1),(1364,972180022,2),(1364,1003028422,1),(1364,1013911222,2),(1365,-2147483648,1),(1365,-1121105688,2),(1365,105084002,3),(1365,161758804,2),(1365,290584808,4),(1365,299134808,2),(1365,322034409,4),(1365,330584409,2),(1365,694260016,3),(1365,717310817,2),(1365,725868017,3),(1365,852094820,2),(1365,1113112822,4),(1365,1128229222,2),(1365,1146384023,4),(1365,1159682423,2),(1366,-2147483648,0),(1366,-1767211196,2),(1366,-1206954000,1),(1366,-1191358800,2),(1366,-1175371200,1),(1366,-1159822800,2),(1366,-633816000,1),(1366,-622065600,2),(1366,-602280000,1),(1366,-591829200,2),(1366,-570744000,1),(1366,-560206800,2),(1366,-539121600,1),(1366,-531349200,2),(1366,-191361600,1),(1366,-184194000,2),(1366,-155160000,1),(1366,-150066000,2),(1366,-128894400,1),(1366,-121122000,2),(1366,-99950400,1),(1366,-89586000,2),(1366,-68414400,1),(1366,-57963600,2),(1366,499752013,1),(1366,511239613,2),(1366,530596813,1),(1366,540270013,2),(1366,562132813,1),(1366,571201214,2),(1366,750830418,1),(1366,761713218,2),(1367,-2147483648,0),(1367,-1825098836,1),(1368,-2147483648,1),(1368,-1851537340,2),(1368,323841609,3),(1368,338958009,2),(1369,-2147483648,0),(1369,-1514743200,1),(1369,576057614,2),(1369,594198014,1),(1369,828864020,2),(1369,846399620,1),(1369,860313620,2),(1369,877849221,1),(1369,891763221,2),(1369,909298821,1),(1369,923212822,2),(1369,941353222,1),(1369,954662422,2),(1369,972802822,1),(1369,989136022,2),(1369,1001833222,1),(1369,1018166422,2),(1369,1035702022,1),(1369,1049616022,2),(1369,1067151622,1),(1369,1081065622,2),(1369,1099206022,1),(1369,1112515222,2),(1369,1130655622,1),(1369,1143964823,2),(1369,1162105223,1),(1369,1175414423,2),(1369,1193554823,1),(1369,1207468823,2),(1369,1225004423,1),(1369,1238918424,2),(1369,1256454024,1),(1369,1268553624,2),(1369,1289113224,1),(1369,1300003224,2),(1369,1320562824,1),(1369,1331452824,2),(1369,1352012425,1),(1369,1362902425,2),(1369,1383462025,1),(1369,1394352025,2),(1369,1414911625,1),(1369,1425801625,2),(1369,1446361226,1),(1369,1457856026,2),(1369,1478415626,1),(1369,1489305627,2),(1369,1509865227,1),(1369,1520755227,2),(1369,1541314827,1),(1369,1552204827,2),(1369,1572764427,1),(1369,1583654427,2),(1369,1604214027,1),(1369,1615708827,2),(1369,1636268427,1),(1369,1647158427,2),(1369,1667718027,1),(1369,1678608027,2),(1369,1699167627,1),(1369,1710057627,2),(1369,1730617227,1),(1369,1741507227,2),(1369,1762066827,1),(1369,1772956827,2),(1369,1793516427,1),(1369,1805011227,2),(1369,1825570827,1),(1369,1836460827,2),(1369,1857020427,1),(1369,1867910427,2),(1369,1888470027,1),(1369,1899360027,2),(1369,1919919627,1),(1369,1930809627,2),(1369,1951369227,1),(1369,1962864027,2),(1369,1983423627,1),(1369,1994313627,2),(1369,2014873227,1),(1369,2025763227,2),(1369,2046322827,1),(1369,2057212827,2),(1369,2077772427,1),(1369,2088662427,2),(1369,2109222027,1),(1369,2120112027,2),(1369,2140671627,1),(1370,-2147483648,0),(1370,-1514739600,1),(1370,-1343066400,2),(1370,-1234807200,1),(1370,-1220292000,2),(1370,-1207159200,1),(1370,-1191344400,2),(1370,-873828000,1),(1370,-661539600,3),(1370,28800,1),(1370,828867620,4),(1370,846403220,1),(1370,860317220,4),(1370,877852821,1),(1370,891766821,4),(1370,909302421,1),(1370,923216422,4),(1370,941356822,1),(1370,954666022,4),(1370,972806422,1),(1370,989139622,4),(1370,1001836822,1),(1370,1018170022,4),(1370,1035705622,1),(1370,1049619622,4),(1370,1067155222,1),(1370,1081069222,4),(1370,1099209622,1),(1370,1112518822,4),(1370,1130659222,1),(1370,1143968423,4),(1370,1162108823,1),(1370,1175418023,4),(1370,1193558423,1),(1370,1207472423,4),(1370,1225008023,1),(1370,1238922024,4),(1370,1256457624,1),(1370,1270371624,4),(1370,1288512024,1),(1370,1301821224,4),(1370,1319961624,1),(1370,1333270824,4),(1370,1351411225,1),(1370,1365325225,4),(1370,1382860825,1),(1370,1396774825,4),(1370,1414310425,1),(1370,1428224425,4),(1370,1445760026,1),(1370,1459674026,4),(1370,1477814426,1),(1370,1491123627,4),(1370,1509264027,1),(1370,1522573227,4),(1370,1540713627,1),(1370,1554627627,4),(1370,1572163227,1),(1370,1586077227,4),(1370,1603612827,1),(1370,1617526827,4),(1370,1635667227,1),(1370,1648976427,4),(1370,1667116827,1),(1370,1680426027,4),(1370,1698566427,1),(1370,1712480427,4),(1370,1730016027,1),(1370,1743930027,4),(1370,1761465627,1),(1370,1775379627,4),(1370,1792915227,1),(1370,1806829227,4),(1370,1824969627,1),(1370,1838278827,4),(1370,1856419227,1),(1370,1869728427,4),(1370,1887868827,1),(1370,1901782827,4),(1370,1919318427,1),(1370,1933232427,4),(1370,1950768027,1),(1370,1964682027,4),(1370,1982822427,1),(1370,1996131627,4),(1370,2014272027,1),(1370,2027581227,4),(1370,2045721627,1),(1370,2059030827,4),(1370,2077171227,1),(1370,2091085227,4),(1370,2108620827,1),(1370,2122534827,4),(1370,2140070427,1),(1371,-2147483648,1),(1371,-1567453392,2),(1371,-1233432000,3),(1371,-1222981200,2),(1371,-1205956800,3),(1371,-1194037200,2),(1371,-1172865600,3),(1371,-1162501200,2),(1371,-1141329600,3),(1371,-1130965200,2),(1371,-1109793600,3),(1371,-1099429200,2),(1371,-1078257600,3),(1371,-1067806800,2),(1371,-1046635200,3),(1371,-1036270800,2),(1371,-1015099200,3),(1371,-1004734800,2),(1371,-983563200,3),(1371,-973198800,2),(1371,-952027200,3),(1371,-941576400,2),(1371,-931032000,3),(1371,-900882000,2),(1371,-890337600,3),(1371,-833749200,2),(1371,-827265600,3),(1371,-752274000,2),(1371,-733780800,3),(1371,-197326800,2),(1371,-190843200,3),(1371,-184194000,2),(1371,-164491200,3),(1371,-152658000,2),(1371,-132955200,3),(1371,-121122000,2),(1371,-101419200,3),(1371,-86821200,2),(1371,-71092800,3),(1371,-54766800,2),(1371,-39038400,3),(1371,-23317200,2),(1371,-7588800,5),(1371,128142003,4),(1371,136605603,5),(1371,596948414,4),(1371,605066414,5),(1371,624423614,4),(1371,636516015,2),(1371,655963215,3),(1371,667796416,2),(1371,687499216,3),(1371,699418816,2),(1371,719380817,4),(1371,731469617,5),(1371,938919622,3),(1371,952052422,5),(1371,1085281222,2),(1371,1096171222,5),(1371,1198983623,4),(1371,1205632823,5),(1372,-2147483648,2),(1372,-1633276800,1),(1372,-1615136400,2),(1372,-1601827200,1),(1372,-1583686800,2),(1372,-880214400,3),(1372,-769395600,4),(1372,-765392400,2),(1372,-747244800,1),(1372,-733942800,2),(1372,-116438400,1),(1372,-100112400,2),(1372,-21484800,5),(1372,104914802,1),(1372,120639602,2),(1372,126691203,1),(1372,152089203,2),(1372,162374404,1),(1372,183538804,2),(1372,199267205,1),(1372,215593205,2),(1372,230716806,1),(1372,247042806,2),(1372,262771207,1),(1372,278492407,2),(1372,294220808,1),(1372,309942008,2),(1372,325670409,1),(1372,341391609,2),(1372,357120009,1),(1372,372841210,2),(1372,388569610,1),(1372,404895611,2),(1372,420019211,1),(1372,436345212,2),(1372,452073612,1),(1372,467794812,2),(1372,483523212,1),(1372,499244413,2),(1372,514972813,1),(1372,530694013,2),(1372,544608013,1),(1372,562143613,2),(1372,576057614,1),(1372,594198014,2),(1372,607507214,1),(1372,625647614,2),(1372,638956815,1),(1372,657097215,2),(1372,671011216,1),(1372,688546816,2),(1372,702460816,1),(1372,719996417,2),(1372,733910417,1),(1372,752050818,2),(1372,765360018,1),(1372,783500419,2),(1372,796809619,1),(1372,814950019,2),(1372,828864020,1),(1372,846399620,2),(1372,860313620,1),(1372,877849221,2),(1372,891763221,1),(1372,909298821,2),(1372,923212822,1),(1372,941353222,2),(1372,954662422,1),(1372,972802822,2),(1372,986112022,1),(1372,1004252422,2),(1372,1018166422,1),(1372,1035702022,2),(1372,1049616022,1),(1372,1067151622,2),(1372,1081065622,1),(1372,1099206022,2),(1372,1112515222,1),(1372,1130655622,2),(1372,1143964823,1),(1372,1162105223,2),(1372,1173600023,1),(1372,1194159623,2),(1372,1205049623,1),(1372,1225609223,2),(1372,1236499224,1),(1372,1257058824,2),(1372,1268553624,1),(1372,1289113224,2),(1372,1300003224,1),(1372,1320562824,2),(1372,1331452824,1),(1372,1352012425,2),(1372,1362902425,1),(1372,1383462025,2),(1372,1394352025,1),(1372,1414911625,2),(1372,1425801625,1),(1372,1446361226,2),(1372,1457856026,1),(1372,1478415626,2),(1372,1489305627,1),(1372,1509865227,2),(1372,1520755227,1),(1372,1541314827,2),(1372,1552204827,1),(1372,1572764427,2),(1372,1583654427,1),(1372,1604214027,2),(1372,1615708827,1),(1372,1636268427,2),(1372,1647158427,1),(1372,1667718027,2),(1372,1678608027,1),(1372,1699167627,2),(1372,1710057627,1),(1372,1730617227,2),(1372,1741507227,1),(1372,1762066827,2),(1372,1772956827,1),(1372,1793516427,2),(1372,1805011227,1),(1372,1825570827,2),(1372,1836460827,1),(1372,1857020427,2),(1372,1867910427,1),(1372,1888470027,2),(1372,1899360027,1),(1372,1919919627,2),(1372,1930809627,1),(1372,1951369227,2),(1372,1962864027,1),(1372,1983423627,2),(1372,1994313627,1),(1372,2014873227,2),(1372,2025763227,1),(1372,2046322827,2),(1372,2057212827,1),(1372,2077772427,2),(1372,2088662427,1),(1372,2109222027,2),(1372,2120112027,1),(1372,2140671627,2),(1373,-2147483648,0),(1373,-1514743200,1),(1373,377935210,2),(1373,407653211,1),(1373,828864020,3),(1373,846399620,1),(1373,860313620,3),(1373,877849221,1),(1373,891763221,3),(1373,909298821,1),(1373,923212822,3),(1373,941353222,1),(1373,954662422,3),(1373,972802822,1),(1373,989136022,3),(1373,1001833222,1),(1373,1018166422,3),(1373,1035702022,1),(1373,1049616022,3),(1373,1067151622,1),(1373,1081065622,3),(1373,1099206022,1),(1373,1112515222,3),(1373,1130655622,1),(1373,1143964823,3),(1373,1162105223,1),(1373,1175414423,3),(1373,1193554823,1),(1373,1207468823,3),(1373,1225004423,1),(1373,1238918424,3),(1373,1256454024,1),(1373,1270368024,3),(1373,1288508424,1),(1373,1301817624,3),(1373,1319958024,1),(1373,1333267224,3),(1373,1351407625,1),(1373,1365321625,3),(1373,1382857225,1),(1373,1396771225,3),(1373,1414306825,1),(1373,1428220825,3),(1373,1445756426,1),(1373,1459670426,3),(1373,1477810826,1),(1373,1491120027,3),(1373,1509260427,1),(1373,1522569627,3),(1373,1540710027,1),(1373,1554624027,3),(1373,1572159627,1),(1373,1586073627,3),(1373,1603609227,1),(1373,1617523227,3),(1373,1635663627,1),(1373,1648972827,3),(1373,1667113227,1),(1373,1680422427,3),(1373,1698562827,1),(1373,1712476827,3),(1373,1730012427,1),(1373,1743926427,3),(1373,1761462027,1),(1373,1775376027,3),(1373,1792911627,1),(1373,1806825627,3),(1373,1824966027,1),(1373,1838275227,3),(1373,1856415627,1),(1373,1869724827,3),(1373,1887865227,1),(1373,1901779227,3),(1373,1919314827,1),(1373,1933228827,3),(1373,1950764427,1),(1373,1964678427,3),(1373,1982818827,1),(1373,1996128027,3),(1373,2014268427,1),(1373,2027577627,3),(1373,2045718027,1),(1373,2059027227,3),(1373,2077167627,1),(1373,2091081627,3),(1373,2108617227,1),(1373,2122531227,3),(1373,2140066827,1),(1374,-2147483648,1),(1374,-880207200,2),(1374,-769395600,3),(1374,-765385200,1),(1374,-21477600,4),(1374,-5756400,1),(1374,9972000,4),(1374,25693200,1),(1374,41421600,4),(1374,57747600,1),(1374,73476000,4),(1374,89197201,1),(1374,104925602,4),(1374,120646802,1),(1374,126698403,4),(1374,152096403,1),(1374,162381604,4),(1374,183546004,1),(1374,199274405,4),(1374,215600405,1),(1374,230724006,4),(1374,247050006,1),(1374,262778407,4),(1374,278499607,1),(1374,294228008,4),(1374,309949208,1),(1374,325677609,4),(1374,341398809,1),(1374,357127209,4),(1374,372848410,1),(1374,388576810,4),(1374,404902811,1),(1374,420026411,4),(1374,436352412,1),(1374,1446372026,5),(1374,1457866826,6),(1374,1478426426,5),(1374,1489316427,6),(1374,1509876027,5),(1374,1520766027,6),(1374,1541325627,1),(1374,1547978427,5),(1374,1552215627,6),(1374,1572775227,5),(1374,1583665227,6),(1374,1604224827,5),(1374,1615719627,6),(1374,1636279227,5),(1374,1647169227,6),(1374,1667728827,5),(1374,1678618827,6),(1374,1699178427,5),(1374,1710068427,6),(1374,1730628027,5),(1374,1741518027,6),(1374,1762077627,5),(1374,1772967627,6),(1374,1793527227,5),(1374,1805022027,6),(1374,1825581627,5),(1374,1836471627,6),(1374,1857031227,5),(1374,1867921227,6),(1374,1888480827,5),(1374,1899370827,6),(1374,1919930427,5),(1374,1930820427,6),(1374,1951380027,5),(1374,1962874827,6),(1374,1983434427,5),(1374,1994324427,6),(1374,2014884027,5),(1374,2025774027,6),(1374,2046333627,5),(1374,2057223627,6),(1374,2077783227,5),(1374,2088673227,6),(1374,2109232827,5),(1374,2120122827,6),(1374,2140682427,5),(1375,-2147483648,0),(1375,-1514739600,1),(1375,-1343066400,2),(1375,-1234807200,1),(1375,-1220292000,2),(1375,-1207159200,1),(1375,-1191344400,2),(1375,-975261600,3),(1375,-963169200,2),(1375,-917114400,3),(1375,-907354800,2),(1375,-821901600,4),(1375,-810068400,2),(1375,-627501600,3),(1375,-612990000,2),(1375,828864020,3),(1375,846399620,2),(1375,860313620,3),(1375,877849221,2),(1375,891763221,3),(1375,909298821,2),(1375,923212822,3),(1375,941353222,2),(1375,954662422,3),(1375,972802822,2),(1375,989136022,3),(1375,1001833222,2),(1375,1018166422,3),(1375,1035702022,2),(1375,1049616022,3),(1375,1067151622,2),(1375,1081065622,3),(1375,1099206022,2),(1375,1112515222,3),(1375,1130655622,2),(1375,1143964823,3),(1375,1162105223,2),(1375,1175414423,3),(1375,1193554823,2),(1375,1207468823,3),(1375,1225004423,2),(1375,1238918424,3),(1375,1256454024,2),(1375,1270368024,3),(1375,1288508424,2),(1375,1301817624,3),(1375,1319958024,2),(1375,1333267224,3),(1375,1351407625,2),(1375,1365321625,3),(1375,1382857225,2),(1375,1396771225,3),(1375,1414306825,2),(1375,1428220825,3),(1375,1445756426,2),(1375,1459670426,3),(1375,1477810826,2),(1375,1491120027,3),(1375,1509260427,2),(1375,1522569627,3),(1375,1540710027,2),(1375,1554624027,3),(1375,1572159627,2),(1375,1586073627,3),(1375,1603609227,2),(1375,1617523227,3),(1375,1635663627,2),(1375,1648972827,3),(1375,1667113227,2),(1375,1680422427,3),(1375,1698562827,2),(1375,1712476827,3),(1375,1730012427,2),(1375,1743926427,3),(1375,1761462027,2),(1375,1775376027,3),(1375,1792911627,2),(1375,1806825627,3),(1375,1824966027,2),(1375,1838275227,3),(1375,1856415627,2),(1375,1869724827,3),(1375,1887865227,2),(1375,1901779227,3),(1375,1919314827,2),(1375,1933228827,3),(1375,1950764427,2),(1375,1964678427,3),(1375,1982818827,2),(1375,1996128027,3),(1375,2014268427,2),(1375,2027577627,3),(1375,2045718027,2),(1375,2059027227,3),(1375,2077167627,2),(1375,2091081627,3),(1375,2108617227,2),(1375,2122531227,3),(1375,2140066827,2),(1376,-2147483648,0),(1376,-1850328920,1),(1376,326001609,2),(1376,544597213,3),(1376,562132813,2),(1376,576046814,3),(1376,594187214,2),(1376,607496414,3),(1376,625636814,2),(1376,638946015,3),(1376,657086415,2),(1376,671000416,3),(1376,688536016,2),(1376,702450016,3),(1376,719985617,2),(1376,733899617,3),(1376,752040018,2),(1376,765349218,3),(1376,783489619,2),(1376,796798819,3),(1376,814939219,2),(1376,828853220,3),(1376,846388820,2),(1376,860302820,3),(1376,877838421,2),(1376,891752421,3),(1376,909288021,2),(1376,923202022,3),(1376,941342422,2),(1376,954651622,3),(1376,972792022,2),(1376,986101222,3),(1376,1004241622,2),(1376,1018155622,3),(1376,1035691222,2),(1376,1049605222,3),(1376,1067140822,2),(1376,1081054822,3),(1376,1099195222,2),(1376,1112504422,3),(1376,1130644822,2),(1376,1143954023,3),(1376,1162094423,2),(1376,1173589223,3),(1376,1194148823,2),(1376,1205038823,3),(1376,1225598423,2),(1376,1236488424,3),(1376,1257048024,2),(1376,1268542824,3),(1376,1289102424,2),(1376,1299992424,3),(1376,1320552024,2),(1376,1331442024,3),(1376,1352001625,2),(1376,1362891625,3),(1376,1383451225,2),(1376,1394341225,3),(1376,1414900825,2),(1376,1425790825,3),(1376,1446350426,2),(1376,1457845226,3),(1376,1478404826,2),(1376,1489294827,3),(1376,1509854427,2),(1376,1520744427,3),(1376,1541304027,2),(1376,1552194027,3),(1376,1572753627,2),(1376,1583643627,3),(1376,1604203227,2),(1376,1615698027,3),(1376,1636257627,2),(1376,1647147627,3),(1376,1667707227,2),(1376,1678597227,3),(1376,1699156827,2),(1376,1710046827,3),(1376,1730606427,2),(1376,1741496427,3),(1376,1762056027,2),(1376,1772946027,3),(1376,1793505627,2),(1376,1805000427,3),(1376,1825560027,2),(1376,1836450027,3),(1376,1857009627,2),(1376,1867899627,3),(1376,1888459227,2),(1376,1899349227,3),(1376,1919908827,2),(1376,1930798827,3),(1376,1951358427,2),(1376,1962853227,3),(1376,1983412827,2),(1376,1994302827,3),(1376,2014862427,2),(1376,2025752427,3),(1376,2046312027,2),(1376,2057202027,3),(1376,2077761627,2),(1376,2088651627,3),(1376,2109211227,2),(1376,2120101227,3),(1376,2140660827,2),(1377,-2147483648,1),(1377,-2131642800,3),(1377,-1632074400,2),(1377,-1615143600,3),(1377,-1153681200,2),(1377,-1145822400,3),(1377,-1122231600,2),(1377,-1114372800,3),(1377,-1090782000,2),(1377,-1082923200,3),(1377,-1059332400,2),(1377,-1051473600,3),(1377,-1027882800,2),(1377,-1020024000,3),(1377,-996433200,2),(1377,-988574400,3),(1377,-965674800,2),(1377,-955396800,3),(1377,-934743600,2),(1377,-923947200,3),(1377,-904503600,2),(1377,-891892800,3),(1377,-880221600,4),(1377,-769395600,5),(1377,-765399600,3),(1377,-747252000,2),(1377,-733950000,3),(1377,-715802400,2),(1377,-702500400,3),(1377,-684352800,2),(1377,-671050800,3),(1377,-652903200,2),(1377,-639601200,3),(1377,-620848800,2),(1377,-608151600,3),(1377,-589399200,2),(1377,-576097200,3),(1377,-557949600,2),(1377,-544647600,3),(1377,-526500000,2),(1377,-513198000,3),(1377,-495050400,2),(1377,-481748400,3),(1377,-463600800,2),(1377,-450298800,3),(1377,-431546400,2),(1377,-418244400,3),(1377,-400096800,2),(1377,-384375600,3),(1377,-368647200,2),(1377,-352926000,3),(1377,-337197600,2),(1377,-321476400,3),(1377,-305748000,2),(1377,-289422000,3),(1377,-273693600,2),(1377,-257972400,3),(1377,-242244000,2),(1377,-226522800,3),(1377,-210794400,2),(1377,-195073200,3),(1377,-179344800,2),(1377,-163623600,3),(1377,-147895200,2),(1377,-131569200,3),(1377,-116445600,2),(1377,-100119600,3),(1377,-84391200,2),(1377,-68670000,3),(1377,-52941600,2),(1377,-37220400,3),(1377,-21492000,2),(1377,-5770800,3),(1377,9957600,2),(1377,25678800,3),(1377,41407200,2),(1377,57733200,3),(1377,73461600,2),(1377,89182801,3),(1377,136360803,2),(1377,152082003,3),(1377,167810404,2),(1377,183531604,3),(1377,199260005,2),(1377,215586005,3),(1377,230709606,2),(1377,247035606,3),(1377,262764007,2),(1377,278485207,3),(1377,294213608,2),(1377,309934808,3),(1377,325663209,2),(1377,341384409,3),(1377,357112809,2),(1377,372834010,3),(1377,388562410,2),(1377,404888411,3),(1377,420012011,2),(1377,436338012,3),(1377,452066412,2),(1377,467787612,3),(1377,483516012,2),(1377,499237213,3),(1377,514965613,2),(1377,530686813,3),(1377,544600813,2),(1377,562136413,3),(1377,576050414,2),(1377,594190814,3),(1377,607500014,2),(1377,625640414,3),(1377,638949615,2),(1377,657090015,3),(1377,671004016,2),(1377,688539616,3),(1377,702453616,2),(1377,719989217,3),(1377,733896077,2),(1377,752036478,3),(1377,765345678,2),(1377,783486079,3),(1377,796795279,2),(1377,814935679,3),(1377,828849680,2),(1377,846385280,3),(1377,860299280,2),(1377,877834881,3),(1377,891748881,2),(1377,909284481,3),(1377,923198482,2),(1377,941338882,3),(1377,954648082,2),(1377,972788482,3),(1377,986097682,2),(1377,1004238082,3),(1377,1018152082,2),(1377,1035687682,3),(1377,1049601682,2),(1377,1067137282,3),(1377,1081051282,2),(1377,1099191682,3),(1377,1112500882,2),(1377,1130641282,3),(1377,1143950483,2),(1377,1162090883,3),(1377,1173592823,2),(1377,1194152423,3),(1377,1205042423,2),(1377,1225602023,3),(1377,1236492024,2),(1377,1257051624,3),(1377,1268546424,2),(1377,1289106024,3),(1377,1299996024,2),(1377,1320555624,3),(1377,1331445624,2),(1377,1352005225,3),(1377,1362895225,2),(1377,1383454825,3),(1377,1394344825,2),(1377,1414904425,3),(1377,1425794425,2),(1377,1446354026,3),(1377,1457848826,2),(1377,1478408426,3),(1377,1489298427,2),(1377,1509858027,3),(1377,1520748027,2),(1377,1541307627,3),(1377,1552197627,2),(1377,1572757227,3),(1377,1583647227,2),(1377,1604206827,3),(1377,1615701627,2),(1377,1636261227,3),(1377,1647151227,2),(1377,1667710827,3),(1377,1678600827,2),(1377,1699160427,3),(1377,1710050427,2),(1377,1730610027,3),(1377,1741500027,2),(1377,1762059627,3),(1377,1772949627,2),(1377,1793509227,3),(1377,1805004027,2),(1377,1825563627,3),(1377,1836453627,2),(1377,1857013227,3),(1377,1867903227,2),(1377,1888462827,3),(1377,1899352827,2),(1377,1919912427,3),(1377,1930802427,2),(1377,1951362027,3),(1377,1962856827,2),(1377,1983416427,3),(1377,1994306427,2),(1377,2014866027,3),(1377,2025756027,2),(1377,2046315627,3),(1377,2057205627,2),(1377,2077765227,3),(1377,2088655227,2),(1377,2109214827,3),(1377,2120104827,2),(1377,2140664427,3),(1378,-2147483648,0),(1378,-1514743200,1),(1378,576057614,2),(1378,594198014,1),(1378,828864020,2),(1378,846399620,1),(1378,860313620,2),(1378,877849221,1),(1378,891763221,2),(1378,909298821,1),(1378,923212822,2),(1378,941353222,1),(1378,954662422,2),(1378,972802822,1),(1378,989136022,2),(1378,1001833222,1),(1378,1018166422,2),(1378,1035702022,1),(1378,1049616022,2),(1378,1067151622,1),(1378,1081065622,2),(1378,1099206022,1),(1378,1112515222,2),(1378,1130655622,1),(1378,1143964823,2),(1378,1162105223,1),(1378,1175414423,2),(1378,1193554823,1),(1378,1207468823,2),(1378,1225004423,1),(1378,1238918424,2),(1378,1256454024,1),(1378,1270368024,2),(1378,1288508424,1),(1378,1301817624,2),(1378,1319958024,1),(1378,1333267224,2),(1378,1351407625,1),(1378,1365321625,2),(1378,1382857225,1),(1378,1396771225,2),(1378,1414306825,1),(1378,1428220825,2),(1378,1445756426,1),(1378,1459670426,2),(1378,1477810826,1),(1378,1491120027,2),(1378,1509260427,1),(1378,1522569627,2),(1378,1540710027,1),(1378,1554624027,2),(1378,1572159627,1),(1378,1586073627,2),(1378,1603609227,1),(1378,1617523227,2),(1378,1635663627,1),(1378,1648972827,2),(1378,1667113227,1),(1378,1680422427,2),(1378,1698562827,1),(1378,1712476827,2),(1378,1730012427,1),(1378,1743926427,2),(1378,1761462027,1),(1378,1775376027,2),(1378,1792911627,1),(1378,1806825627,2),(1378,1824966027,1),(1378,1838275227,2),(1378,1856415627,1),(1378,1869724827,2),(1378,1887865227,1),(1378,1901779227,2),(1378,1919314827,1),(1378,1933228827,2),(1378,1950764427,1),(1378,1964678427,2),(1378,1982818827,1),(1378,1996128027,2),(1378,2014268427,1),(1378,2027577627,2),(1378,2045718027,1),(1378,2059027227,2),(1378,2077167627,1),(1378,2091081627,2),(1378,2108617227,1),(1378,2122531227,2),(1378,2140066827,1),(1379,-2147483648,0),(1379,-1942690509,1),(1379,-1567455309,2),(1379,-1459627200,4),(1379,-1443819600,3),(1379,-1428006600,4),(1379,-1412283600,3),(1379,-1396470600,4),(1379,-1380747600,3),(1379,-1141590600,4),(1379,-1128286800,3),(1379,-1110141000,4),(1379,-1096837200,3),(1379,-1078691400,4),(1379,-1065387600,3),(1379,-1047241800,4),(1379,-1033938000,3),(1379,-1015187400,4),(1379,-1002488400,3),(1379,-983737800,4),(1379,-971038800,3),(1379,-954707400,4),(1379,-938984400,3),(1379,-920838600,4),(1379,-907534800,3),(1379,-896819400,4),(1379,-853621200,6),(1379,-845847000,5),(1379,-334789200,6),(1379,-319671000,5),(1379,-314226000,7),(1379,-309996000,5),(1379,-149720400,7),(1379,-134604000,5),(1379,-50446800,6),(1379,-34205400,5),(1379,9860400,7),(1379,14176800,5),(1379,72846000,7),(1379,80100001,5),(1379,127278003,8),(1379,132111003,6),(1379,147234603,5),(1379,156913203,7),(1379,165376804,5),(1379,219812405,7),(1379,226461606,5),(1379,250052406,7),(1379,257911207,5),(1379,282711607,7),(1379,289360808,5),(1379,294202808,7),(1379,322020009,5),(1379,566449213,7),(1379,573012014,5),(1379,597812414,7),(1379,605066414,5),(1379,625633214,7),(1379,635911215,5),(1379,656478015,7),(1379,667965616,5),(1379,688532416,7),(1379,699415216,5),(1379,719377217,7),(1379,730864817,5),(1379,1095562822,7),(1379,1111896022,5),(1379,1128834022,7),(1379,1142136023,5),(1379,1159678823,7),(1379,1173585623,5),(1379,1191733223,7),(1379,1205035223,5),(1379,1223182823,7),(1379,1236484824,5),(1379,1254632424,7),(1379,1268539224,5),(1379,1286082024,7),(1379,1299988824,5),(1379,1317531624,7),(1379,1331438424,5),(1379,1349586025,7),(1379,1362888025,5),(1379,1381035625,7),(1379,1394337625,5),(1379,1412485225,7),(1379,1425787225,5),(1380,-2147483648,2),(1380,-1632070800,1),(1380,-1615140000,2),(1380,-1601753400,1),(1380,-1583697600,2),(1380,-1567357200,1),(1380,-1554667200,2),(1380,-1534698000,1),(1380,-1524074400,2),(1380,-1503248400,1),(1380,-1492365600,2),(1380,-1471798800,1),(1380,-1460916000,2),(1380,-1440954000,1),(1380,-1428861600,2),(1380,-1409504400,1),(1380,-1397412000,2),(1380,-1378054800,1),(1380,-1365962400,2),(1380,-1346605200,1),(1380,-1333908000,2),(1380,-1315155600,1),(1380,-1301853600,2),(1380,-1283706000,1),(1380,-1270404000,2),(1380,-1252256400,1),(1380,-1238954400,2),(1380,-1220806800,1),(1380,-1207504800,2),(1380,-1188752400,1),(1380,-1176055200,2),(1380,-1157302800,1),(1380,-1144000800,2),(1380,-1125853200,1),(1380,-1112551200,2),(1380,-1094403600,1),(1380,-1081101600,2),(1380,-1062954000,1),(1380,-1049652000,2),(1380,-1031504400,1),(1380,-1018202400,2),(1380,-1000054800,1),(1380,-986752800,2),(1380,-968000400,1),(1380,-955303200,2),(1380,-936550800,1),(1380,-880218000,3),(1380,-769395600,4),(1380,-765396000,2),(1380,-747248400,1),(1380,-733946400,2),(1380,-715806000,1),(1380,-702504000,2),(1380,-684356400,1),(1380,-671054400,2),(1380,-652906800,1),(1380,-634161600,2),(1380,-620845200,1),(1380,-602704800,2),(1380,-589395600,1),(1380,-576093600,2),(1380,-557946000,1),(1380,-544644000,2),(1380,-526496400,1),(1380,-513194400,2),(1380,-495046800,1),(1380,-481744800,2),(1380,-463597200,1),(1380,-450295200,2),(1380,-431542800,1),(1380,-418240800,2),(1380,-400093200,1),(1380,-384372000,2),(1380,-368643600,1),(1380,-352922400,2),(1380,-337194000,1),(1380,-321472800,2),(1380,-305744400,1),(1380,-289418400,2),(1380,-273690000,1),(1380,-257968800,2),(1380,-242240400,1),(1380,-226519200,2),(1380,-210790800,1),(1380,-195069600,2),(1380,-179341200,1),(1380,-163620000,2),(1380,-147891600,1),(1380,-131565600,2),(1380,-116442000,1),(1380,-100116000,2),(1380,-84387600,1),(1380,-68666400,2),(1380,-52938000,1),(1380,-37216800,2),(1380,-21488400,1),(1380,-5767200,2),(1380,9961200,1),(1380,25682400,2),(1380,41410800,1),(1380,57736800,2),(1380,73465200,1),(1380,89186401,2),(1380,104914802,1),(1380,120636002,2),(1380,136364403,1),(1380,152085603,2),(1380,167814004,1),(1380,183535204,2),(1380,199263605,1),(1380,215589605,2),(1380,230713206,1),(1380,247039206,2),(1380,262767607,1),(1380,278488807,2),(1380,294217208,1),(1380,309938408,2),(1380,325666809,1),(1380,341388009,2),(1380,357116409,1),(1380,372837610,2),(1380,388566010,1),(1380,404892011,2),(1380,420015611,1),(1380,436341612,2),(1380,452070012,1),(1380,467791212,2),(1380,483519612,1),(1380,499240813,2),(1380,514969213,1),(1380,530690413,2),(1380,544604413,1),(1380,562140013,2),(1380,576054014,1),(1380,594194414,2),(1380,607503614,1),(1380,625644014,2),(1380,638953215,1),(1380,657093615,2),(1380,671007616,1),(1380,688543216,2),(1380,702457216,1),(1380,719992817,2),(1380,733906817,1),(1380,752047218,2),(1380,765356418,1),(1380,783496819,2),(1380,796806019,1),(1380,814946419,2),(1380,828860420,1),(1380,846396020,2),(1380,860310020,1),(1380,877845621,2),(1380,891759621,1),(1380,909295221,2),(1380,923209222,1),(1380,941349622,2),(1380,954658822,1),(1380,972799222,2),(1380,986108422,1),(1380,1004248822,2),(1380,1018162822,1),(1380,1035698422,2),(1380,1049612422,1),(1380,1067148022,2),(1380,1081062022,1),(1380,1099202422,2),(1380,1112511622,1),(1380,1130652022,2),(1380,1143961223,1),(1380,1162101623,2),(1380,1173596423,1),(1380,1194156023,2),(1380,1205046023,1),(1380,1225605623,2),(1380,1236495624,1),(1380,1257055224,2),(1380,1268550024,1),(1380,1289109624,2),(1380,1299999624,1),(1380,1320559224,2),(1380,1331449224,1),(1380,1352008825,2),(1380,1362898825,1),(1380,1383458425,2),(1380,1394348425,1),(1380,1414908025,2),(1380,1425798025,1),(1380,1446357626,2),(1380,1457852426,1),(1380,1478412026,2),(1380,1489302027,1),(1380,1509861627,2),(1380,1520751627,1),(1380,1541311227,2),(1380,1552201227,1),(1380,1572760827,2),(1380,1583650827,1),(1380,1604210427,2),(1380,1615705227,1),(1380,1636264827,2),(1380,1647154827,1),(1380,1667714427,2),(1380,1678604427,1),(1380,1699164027,2),(1380,1710054027,1),(1380,1730613627,2),(1380,1741503627,1),(1380,1762063227,2),(1380,1772953227,1),(1380,1793512827,2),(1380,1805007627,1),(1380,1825567227,2),(1380,1836457227,1),(1380,1857016827,2),(1380,1867906827,1),(1380,1888466427,2),(1380,1899356427,1),(1380,1919916027,2),(1380,1930806027,1),(1380,1951365627,2),(1380,1962860427,1),(1380,1983420027,2),(1380,1994310027,1),(1380,2014869627,2),(1380,2025759627,1),(1380,2046319227,2),(1380,2057209227,1),(1380,2077768827,2),(1380,2088658827,1),(1380,2109218427,2),(1380,2120108427,1),(1380,2140668027,2),(1381,-2147483648,0),(1381,-1825098836,1),(1382,-2147483648,0),(1382,-1825095030,2),(1382,-179341200,1),(1382,-163620000,2),(1382,-147891600,1),(1382,-131565600,2),(1382,-116442000,1),(1382,-100116000,2),(1382,-84387600,1),(1382,-68666400,2),(1382,-52938000,1),(1382,-37216800,2),(1382,-21488400,1),(1382,-5767200,2),(1382,9961200,1),(1382,25682400,2),(1382,41410800,1),(1382,57736800,2),(1382,73465200,1),(1382,89186401,2),(1382,104914802,1),(1382,120636002,2),(1382,136364403,1),(1382,152085603,2),(1382,167814004,1),(1382,183535204,2),(1382,199263605,1),(1382,215589605,2),(1382,230713206,1),(1382,247039206,2),(1382,262767607,1),(1382,278488807,2),(1382,294217208,1),(1382,309938408,2),(1382,325666809,1),(1382,341388009,2),(1382,357116409,1),(1382,372837610,2),(1382,388566010,1),(1382,404892011,2),(1382,420015611,1),(1382,436341612,2),(1382,452070012,1),(1382,467791212,2),(1382,483519612,1),(1382,499240813,2),(1382,514969213,1),(1382,530690413,2),(1382,544604413,1),(1382,562140013,2),(1382,576054014,1),(1382,594194414,2),(1382,607503614,1),(1382,625644014,2),(1382,638953215,1),(1382,657093615,2),(1382,671007616,1),(1382,688543216,2),(1382,702457216,1),(1382,719992817,2),(1382,733906817,1),(1382,752047218,2),(1382,765356418,1),(1382,783496819,2),(1382,796806019,1),(1382,814946419,2),(1382,828860420,1),(1382,846396020,2),(1382,860310020,1),(1382,877845621,2),(1382,891759621,1),(1382,909295221,2),(1382,923209222,1),(1382,941349622,2),(1382,954658822,1),(1382,972799222,2),(1382,986108422,1),(1382,1004248822,2),(1382,1018162822,1),(1382,1035698422,2),(1382,1049612422,1),(1382,1067148022,2),(1382,1081062022,1),(1382,1099202422,2),(1382,1112511622,1),(1382,1130652022,2),(1382,1143961223,1),(1382,1162101623,2),(1382,1173596423,1),(1382,1194156023,2),(1382,1205046023,1),(1382,1225605623,2),(1382,1236495624,1),(1382,1257055224,2),(1382,1268550024,1),(1382,1289109624,2),(1382,1299999624,1),(1382,1320559224,2),(1382,1331449224,1),(1382,1352008825,2),(1382,1362898825,1),(1382,1383458425,2),(1382,1394348425,1),(1382,1414908025,2),(1382,1425798025,1),(1382,1446357626,2),(1382,1457852426,1),(1382,1478412026,2),(1382,1489302027,1),(1382,1509861627,2),(1382,1520751627,1),(1382,1541311227,2),(1382,1552201227,1),(1382,1572760827,2),(1382,1583650827,1),(1382,1604210427,2),(1382,1615705227,1),(1382,1636264827,2),(1382,1647154827,1),(1382,1667714427,2),(1382,1678604427,1),(1382,1699164027,2),(1382,1710054027,1),(1382,1730613627,2),(1382,1741503627,1),(1382,1762063227,2),(1382,1772953227,1),(1382,1793512827,2),(1382,1805007627,1),(1382,1825567227,2),(1382,1836457227,1),(1382,1857016827,2),(1382,1867906827,1),(1382,1888466427,2),(1382,1899356427,1),(1382,1919916027,2),(1382,1930806027,1),(1382,1951365627,2),(1382,1962860427,1),(1382,1983420027,2),(1382,1994310027,1),(1382,2014869627,2),(1382,2025759627,1),(1382,2046319227,2),(1382,2057209227,1),(1382,2077768827,2),(1382,2088658827,1),(1382,2109218427,2),(1382,2120108427,1),(1382,2140668027,2),(1383,-2147483648,2),(1383,-1633280400,1),(1383,-1615140000,2),(1383,-1601830800,1),(1383,-1583690400,2),(1383,-1570381200,1),(1383,-1551636000,2),(1383,-1536512400,1),(1383,-1523210400,2),(1383,-1504458000,1),(1383,-1491760800,2),(1383,-1473008400,1),(1383,-1459706400,2),(1383,-1441558800,1),(1383,-1428256800,2),(1383,-1410109200,1),(1383,-1396807200,2),(1383,-1378659600,1),(1383,-1365357600,2),(1383,-1347210000,1),(1383,-1333908000,2),(1383,-1315155600,1),(1383,-1301853600,2),(1383,-1283706000,1),(1383,-1270404000,2),(1383,-1252256400,1),(1383,-1238954400,2),(1383,-1220806800,1),(1383,-1207504800,2),(1383,-1189357200,1),(1383,-1176055200,2),(1383,-1157302800,1),(1383,-1144605600,2),(1383,-1125853200,1),(1383,-1112551200,2),(1383,-1094403600,1),(1383,-1081101600,2),(1383,-1062954000,1),(1383,-1049652000,2),(1383,-1031504400,1),(1383,-1018202400,2),(1383,-1000054800,1),(1383,-986752800,2),(1383,-968000400,1),(1383,-955303200,2),(1383,-936550800,1),(1383,-923248800,2),(1383,-905101200,1),(1383,-891799200,2),(1383,-880218000,3),(1383,-769395600,4),(1383,-765396000,2),(1383,-747248400,1),(1383,-733946400,2),(1383,-715798800,1),(1383,-702496800,2),(1383,-684349200,1),(1383,-671047200,2),(1383,-652899600,1),(1383,-639597600,2),(1383,-620845200,1),(1383,-608148000,2),(1383,-589395600,1),(1383,-576093600,2),(1383,-557946000,1),(1383,-544644000,2),(1383,-526496400,1),(1383,-513194400,2),(1383,-495046800,1),(1383,-481744800,2),(1383,-463597200,1),(1383,-447271200,2),(1383,-431542800,1),(1383,-415821600,2),(1383,-400093200,1),(1383,-384372000,2),(1383,-368643600,1),(1383,-352922400,2),(1383,-337194000,1),(1383,-321472800,2),(1383,-305744400,1),(1383,-289418400,2),(1383,-273690000,1),(1383,-257968800,2),(1383,-242240400,1),(1383,-226519200,2),(1383,-210790800,1),(1383,-195069600,2),(1383,-179341200,1),(1383,-163620000,2),(1383,-147891600,1),(1383,-131565600,2),(1383,-116442000,1),(1383,-100116000,2),(1383,-84387600,1),(1383,-68666400,2),(1383,-52938000,1),(1383,-37216800,2),(1383,-21488400,1),(1383,-5767200,2),(1383,9961200,1),(1383,25682400,2),(1383,41410800,1),(1383,57736800,2),(1383,73465200,1),(1383,89186401,2),(1383,104914802,1),(1383,120636002,2),(1383,126687603,1),(1383,152085603,2),(1383,162370804,1),(1383,183535204,2),(1383,199263605,1),(1383,215589605,2),(1383,230713206,1),(1383,247039206,2),(1383,262767607,1),(1383,278488807,2),(1383,294217208,1),(1383,309938408,2),(1383,325666809,1),(1383,341388009,2),(1383,357116409,1),(1383,372837610,2),(1383,388566010,1),(1383,404892011,2),(1383,420015611,1),(1383,436341612,2),(1383,452070012,1),(1383,467791212,2),(1383,483519612,1),(1383,499240813,2),(1383,514969213,1),(1383,530690413,2),(1383,544604413,1),(1383,562140013,2),(1383,576054014,1),(1383,594194414,2),(1383,607503614,1),(1383,625644014,2),(1383,638953215,1),(1383,657093615,2),(1383,671007616,1),(1383,688543216,2),(1383,702457216,1),(1383,719992817,2),(1383,733906817,1),(1383,752047218,2),(1383,765356418,1),(1383,783496819,2),(1383,796806019,1),(1383,814946419,2),(1383,828860420,1),(1383,846396020,2),(1383,860310020,1),(1383,877845621,2),(1383,891759621,1),(1383,909295221,2),(1383,923209222,1),(1383,941349622,2),(1383,954658822,1),(1383,972799222,2),(1383,986108422,1),(1383,1004248822,2),(1383,1018162822,1),(1383,1035698422,2),(1383,1049612422,1),(1383,1067148022,2),(1383,1081062022,1),(1383,1099202422,2),(1383,1112511622,1),(1383,1130652022,2),(1383,1143961223,1),(1383,1162101623,2),(1383,1173596423,1),(1383,1194156023,2),(1383,1205046023,1),(1383,1225605623,2),(1383,1236495624,1),(1383,1257055224,2),(1383,1268550024,1),(1383,1289109624,2),(1383,1299999624,1),(1383,1320559224,2),(1383,1331449224,1),(1383,1352008825,2),(1383,1362898825,1),(1383,1383458425,2),(1383,1394348425,1),(1383,1414908025,2),(1383,1425798025,1),(1383,1446357626,2),(1383,1457852426,1),(1383,1478412026,2),(1383,1489302027,1),(1383,1509861627,2),(1383,1520751627,1),(1383,1541311227,2),(1383,1552201227,1),(1383,1572760827,2),(1383,1583650827,1),(1383,1604210427,2),(1383,1615705227,1),(1383,1636264827,2),(1383,1647154827,1),(1383,1667714427,2),(1383,1678604427,1),(1383,1699164027,2),(1383,1710054027,1),(1383,1730613627,2),(1383,1741503627,1),(1383,1762063227,2),(1383,1772953227,1),(1383,1793512827,2),(1383,1805007627,1),(1383,1825567227,2),(1383,1836457227,1),(1383,1857016827,2),(1383,1867906827,1),(1383,1888466427,2),(1383,1899356427,1),(1383,1919916027,2),(1383,1930806027,1),(1383,1951365627,2),(1383,1962860427,1),(1383,1983420027,2),(1383,1994310027,1),(1383,2014869627,2),(1383,2025759627,1),(1383,2046319227,2),(1383,2057209227,1),(1383,2077768827,2),(1383,2088658827,1),(1383,2109218427,2),(1383,2120108427,1),(1383,2140668027,2),(1384,-2147483648,2),(1384,-1632070800,1),(1384,-1615140000,2),(1384,-923252400,1),(1384,-880218000,3),(1384,-769395600,4),(1384,-765396000,2),(1384,136364403,1),(1384,152085603,2),(1384,167814004,1),(1384,183535204,2),(1384,199263605,1),(1384,215589605,2),(1384,230713206,1),(1384,247039206,2),(1384,262767607,1),(1384,278488807,2),(1384,294217208,1),(1384,309938408,2),(1384,325666809,1),(1384,341388009,2),(1384,357116409,1),(1384,372837610,2),(1384,388566010,1),(1384,404892011,2),(1384,420015611,1),(1384,436341612,2),(1384,452070012,1),(1384,467791212,2),(1384,483519612,1),(1384,499240813,2),(1384,514969213,1),(1384,530690413,2),(1384,544604413,1),(1384,562140013,2),(1384,576054014,1),(1384,594194414,2),(1384,607503614,1),(1384,625644014,2),(1384,638953215,1),(1384,657093615,2),(1384,671007616,1),(1384,688543216,2),(1384,702457216,1),(1384,719992817,2),(1384,733906817,1),(1384,752047218,2),(1384,765356418,1),(1384,783496819,2),(1384,796806019,1),(1384,814946419,2),(1384,828860420,1),(1384,846396020,2),(1384,860310020,1),(1384,877845621,2),(1384,891759621,1),(1384,909295221,2),(1384,923209222,1),(1384,941349622,2),(1384,954658822,1),(1384,972799222,2),(1384,986108422,1),(1384,1004248822,2),(1384,1018162822,1),(1384,1035698422,2),(1384,1049612422,1),(1384,1067148022,2),(1384,1081062022,1),(1384,1099202422,2),(1384,1112511622,1),(1384,1130652022,2),(1384,1143961223,1),(1384,1162101623,2),(1384,1173596423,1),(1384,1194156023,2),(1384,1205046023,1),(1384,1225605623,2),(1384,1236495624,1),(1384,1257055224,2),(1384,1268550024,1),(1384,1289109624,2),(1384,1299999624,1),(1384,1320559224,2),(1384,1331449224,1),(1384,1352008825,2),(1384,1362898825,1),(1384,1383458425,2),(1384,1394348425,1),(1384,1414908025,2),(1384,1425798025,1),(1384,1446357626,2),(1384,1457852426,1),(1384,1478412026,2),(1384,1489302027,1),(1384,1509861627,2),(1384,1520751627,1),(1384,1541311227,2),(1384,1552201227,1),(1384,1572760827,2),(1384,1583650827,1),(1384,1604210427,2),(1384,1615705227,1),(1384,1636264827,2),(1384,1647154827,1),(1384,1667714427,2),(1384,1678604427,1),(1384,1699164027,2),(1384,1710054027,1),(1384,1730613627,2),(1384,1741503627,1),(1384,1762063227,2),(1384,1772953227,1),(1384,1793512827,2),(1384,1805007627,1),(1384,1825567227,2),(1384,1836457227,1),(1384,1857016827,2),(1384,1867906827,1),(1384,1888466427,2),(1384,1899356427,1),(1384,1919916027,2),(1384,1930806027,1),(1384,1951365627,2),(1384,1962860427,1),(1384,1983420027,2),(1384,1994310027,1),(1384,2014869627,2),(1384,2025759627,1),(1384,2046319227,2),(1384,2057209227,1),(1384,2077768827,2),(1384,2088658827,1),(1384,2109218427,2),(1384,2120108427,1),(1384,2140668027,2),(1385,-2147483648,1),(1385,-880196400,2),(1385,-769395600,3),(1385,-765374400,1),(1385,-86878800,4),(1385,-21466800,5),(1385,-5745600,4),(1385,9982800,5),(1385,25704000,4),(1385,41432400,5),(1385,57758400,4),(1385,73486800,5),(1385,89208001,4),(1385,104936402,5),(1385,120657602,4),(1385,126709203,5),(1385,152107203,4),(1385,162392404,5),(1385,183556804,4),(1385,199285205,5),(1385,215611205,4),(1385,230734806,5),(1385,247060806,4),(1385,262789207,5),(1385,278510407,4),(1385,294238808,5),(1385,309960008,4),(1385,325688409,5),(1385,341409609,4),(1385,357138009,5),(1385,372859210,4),(1385,388587610,5),(1385,404913611,4),(1385,420037211,5),(1385,436363212,6),(1385,439030812,8),(1385,452084412,7),(1385,467805612,8),(1385,483534012,7),(1385,499255213,8),(1385,514983613,7),(1385,530704813,8),(1385,544618813,7),(1385,562154413,8),(1385,576068414,7),(1385,594208814,8),(1385,607518014,7),(1385,625658414,8),(1385,638967615,7),(1385,657108015,8),(1385,671022016,7),(1385,688557616,8),(1385,702471616,7),(1385,720007217,8),(1385,733921217,7),(1385,752061618,8),(1385,765370818,7),(1385,783511219,8),(1385,796820419,7),(1385,814960819,8),(1385,828874820,7),(1385,846410420,8),(1385,860324420,7),(1385,877860021,8),(1385,891774021,7),(1385,909309621,8),(1385,923223622,7),(1385,941364022,8),(1385,954673222,7),(1385,972813622,8),(1385,986122822,7),(1385,1004263222,8),(1385,1018177222,7),(1385,1035712822,8),(1385,1049626822,7),(1385,1067162422,8),(1385,1081076422,7),(1385,1099216822,8),(1385,1112526022,7),(1385,1130666422,8),(1385,1143975623,7),(1385,1162116023,8),(1385,1173610823,7),(1385,1194170423,8),(1385,1205060423,7),(1385,1225620023,8),(1385,1236510024,7),(1385,1257069624,8),(1385,1268564424,7),(1385,1289124024,8),(1385,1300014024,7),(1385,1320573624,8),(1385,1331463624,7),(1385,1352023225,8),(1385,1362913225,7),(1385,1383472825,8),(1385,1394362825,7),(1385,1414922425,8),(1385,1425812425,7),(1385,1446372026,8),(1385,1457866826,7),(1385,1478426426,8),(1385,1489316427,7),(1385,1509876027,8),(1385,1520766027,7),(1385,1541325627,8),(1385,1552215627,7),(1385,1572775227,8),(1385,1583665227,7),(1385,1604224827,8),(1385,1615719627,7),(1385,1636279227,8),(1385,1647169227,7),(1385,1667728827,8),(1385,1678618827,7),(1385,1699178427,8),(1385,1710068427,7),(1385,1730628027,8),(1385,1741518027,7),(1385,1762077627,8),(1385,1772967627,7),(1385,1793527227,8),(1385,1805022027,7),(1385,1825581627,8),(1385,1836471627,7),(1385,1857031227,8),(1385,1867921227,7),(1385,1888480827,8),(1385,1899370827,7),(1385,1919930427,8),(1385,1930820427,7),(1385,1951380027,8),(1385,1962874827,7),(1385,1983434427,8),(1385,1994324427,7),(1385,2014884027,8),(1385,2025774027,7),(1385,2046333627,8),(1385,2057223627,7),(1385,2077783227,8),(1385,2088673227,7),(1385,2109232827,8),(1385,2120122827,7),(1385,2140682427,8),(1386,-2147483648,0),(1386,-1767217820,2),(1386,-1206961200,1),(1386,-1191366000,2),(1386,-1175378400,1),(1386,-1159830000,2),(1386,-633823200,1),(1386,-622072800,2),(1386,-602287200,1),(1386,-591836400,2),(1386,-570751200,1),(1386,-560214000,2),(1386,-539128800,1),(1386,-531356400,2),(1386,-191368800,1),(1386,-184201200,2),(1386,-155167200,1),(1386,-150073200,2),(1386,-128901600,1),(1386,-121129200,2),(1386,-99957600,1),(1386,-89593200,2),(1386,-68421600,1),(1386,-57970800,2),(1386,499744813,1),(1386,511232413,2),(1386,530589613,1),(1386,540262813,2),(1386,562125613,1),(1386,571194014,2),(1386,592970414,1),(1386,602038814,2),(1386,624420014,1),(1386,634698015,2),(1386,938916022,1),(1386,951613222,2),(1386,970970422,1),(1386,971571622,2),(1386,1003024822,1),(1386,1013907622,2),(1387,-2147483648,2),(1387,-1633273200,1),(1387,-1615132800,2),(1387,-1601823600,1),(1387,-1583683200,2),(1387,-880210800,3),(1387,-769395600,4),(1387,-765388800,2),(1387,-84380400,1),(1387,-68659200,2),(1387,-52930800,1),(1387,-37209600,2),(1387,-21481200,1),(1387,-5760000,2),(1387,9968400,1),(1387,25689600,2),(1387,41418000,1),(1387,57744000,2),(1387,73472400,1),(1387,89193601,2),(1387,104922002,1),(1387,120643202,2),(1387,126694803,1),(1387,152092803,2),(1387,162378004,1),(1387,183542404,2),(1387,199270805,1),(1387,215596805,2),(1387,230720406,1),(1387,247046406,2),(1387,262774807,1),(1387,278496007,2),(1387,294224408,1),(1387,309945608,2),(1387,325674009,1),(1387,341395209,2),(1387,357123609,1),(1387,372844810,2),(1387,388573210,1),(1387,404899211,2),(1387,420022811,1),(1387,436348812,2),(1387,452077212,1),(1387,467798412,2),(1387,483526812,1),(1387,499248013,2),(1387,514976413,1),(1387,530697613,2),(1387,544611613,1),(1387,562147213,2),(1387,576061214,1),(1387,594201614,2),(1387,607510814,1),(1387,625651214,2),(1387,638960415,1),(1387,657100815,2),(1387,671014816,1),(1387,688550416,2),(1387,702464416,1),(1387,720000017,2),(1387,733914017,1),(1387,752054418,2),(1387,765363618,1),(1387,783504019,2),(1387,796813219,1),(1387,814953619,2),(1387,828867620,1),(1387,846403220,2),(1387,860317220,1),(1387,877852821,2),(1387,891766821,1),(1387,909302421,2),(1387,923216422,1),(1387,941356822,2),(1387,954666022,1),(1387,972806422,2),(1387,986115622,1),(1387,1004256022,2),(1387,1018170022,1),(1387,1035705622,2),(1387,1049619622,1),(1387,1067155222,2),(1387,1081069222,1),(1387,1099209622,2),(1387,1112518822,1),(1387,1130659222,2),(1387,1143968423,1),(1387,1162108823,2),(1387,1173603623,1),(1387,1194163223,2),(1387,1205053223,1),(1387,1225612823,2),(1387,1236502824,1),(1387,1257062424,2),(1387,1268557224,1),(1387,1289116824,6),(1387,1300003224,5),(1387,1320562824,6),(1387,1331452824,5),(1387,1352012425,6),(1387,1362902425,5),(1387,1383462025,6),(1387,1394352025,5),(1387,1414911625,6),(1387,1425801625,5),(1387,1446361226,6),(1387,1457856026,5),(1387,1478415626,6),(1387,1489305627,5),(1387,1509865227,6),(1387,1520755227,5),(1387,1541314827,6),(1387,1552204827,5),(1387,1572764427,6),(1387,1583654427,5),(1387,1604214027,6),(1387,1615708827,5),(1387,1636268427,6),(1387,1647158427,5),(1387,1667718027,6),(1387,1678608027,5),(1387,1699167627,6),(1387,1710057627,5),(1387,1730617227,6),(1387,1741507227,5),(1387,1762066827,6),(1387,1772956827,5),(1387,1793516427,6),(1387,1805011227,5),(1387,1825570827,6),(1387,1836460827,5),(1387,1857020427,6),(1387,1867910427,5),(1387,1888470027,6),(1387,1899360027,5),(1387,1919919627,6),(1387,1930809627,5),(1387,1951369227,6),(1387,1962864027,5),(1387,1983423627,6),(1387,1994313627,5),(1387,2014873227,6),(1387,2025763227,5),(1387,2046322827,6),(1387,2057212827,5),(1387,2077772427,6),(1387,2088662427,5),(1387,2109222027,6),(1387,2120112027,5),(1387,2140671627,6),(1388,-2147483648,2),(1388,-1633273200,1),(1388,-1615132800,2),(1388,-1601823600,1),(1388,-1583683200,2),(1388,-880210800,3),(1388,-769395600,4),(1388,-765388800,2),(1388,-84380400,1),(1388,-68659200,2),(1388,-52930800,1),(1388,-37209600,2),(1388,-21481200,1),(1388,-5760000,2),(1388,9968400,1),(1388,25689600,2),(1388,41418000,1),(1388,57744000,2),(1388,73472400,1),(1388,89193601,2),(1388,104922002,1),(1388,120643202,2),(1388,126694803,1),(1388,152092803,2),(1388,162378004,1),(1388,183542404,2),(1388,199270805,1),(1388,215596805,2),(1388,230720406,1),(1388,247046406,2),(1388,262774807,1),(1388,278496007,2),(1388,294224408,1),(1388,309945608,2),(1388,325674009,1),(1388,341395209,2),(1388,357123609,1),(1388,372844810,2),(1388,388573210,1),(1388,404899211,2),(1388,420022811,1),(1388,436348812,2),(1388,452077212,1),(1388,467798412,2),(1388,483526812,1),(1388,499248013,2),(1388,514976413,1),(1388,530697613,2),(1388,544611613,1),(1388,562147213,2),(1388,576061214,1),(1388,594201614,2),(1388,607510814,1),(1388,625651214,2),(1388,638960415,1),(1388,657100815,2),(1388,671014816,1),(1388,688550416,2),(1388,702464416,1),(1388,720000017,6),(1388,733910417,5),(1388,752050818,6),(1388,765360018,5),(1388,783500419,6),(1388,796809619,5),(1388,814950019,6),(1388,828864020,5),(1388,846399620,6),(1388,860313620,5),(1388,877849221,6),(1388,891763221,5),(1388,909298821,6),(1388,923212822,5),(1388,941353222,6),(1388,954662422,5),(1388,972802822,6),(1388,986112022,5),(1388,1004252422,6),(1388,1018166422,5),(1388,1035702022,6),(1388,1049616022,5),(1388,1067151622,6),(1388,1081065622,5),(1388,1099206022,6),(1388,1112515222,5),(1388,1130655622,6),(1388,1143964823,5),(1388,1162105223,6),(1388,1173600023,5),(1388,1194159623,6),(1388,1205049623,5),(1388,1225609223,6),(1388,1236499224,5),(1388,1257058824,6),(1388,1268553624,5),(1388,1289113224,6),(1388,1300003224,5),(1388,1320562824,6),(1388,1331452824,5),(1388,1352012425,6),(1388,1362902425,5),(1388,1383462025,6),(1388,1394352025,5),(1388,1414911625,6),(1388,1425801625,5),(1388,1446361226,6),(1388,1457856026,5),(1388,1478415626,6),(1388,1489305627,5),(1388,1509865227,6),(1388,1520755227,5),(1388,1541314827,6),(1388,1552204827,5),(1388,1572764427,6),(1388,1583654427,5),(1388,1604214027,6),(1388,1615708827,5),(1388,1636268427,6),(1388,1647158427,5),(1388,1667718027,6),(1388,1678608027,5),(1388,1699167627,6),(1388,1710057627,5),(1388,1730617227,6),(1388,1741507227,5),(1388,1762066827,6),(1388,1772956827,5),(1388,1793516427,6),(1388,1805011227,5),(1388,1825570827,6),(1388,1836460827,5),(1388,1857020427,6),(1388,1867910427,5),(1388,1888470027,6),(1388,1899360027,5),(1388,1919919627,6),(1388,1930809627,5),(1388,1951369227,6),(1388,1962864027,5),(1388,1983423627,6),(1388,1994313627,5),(1388,2014873227,6),(1388,2025763227,5),(1388,2046322827,6),(1388,2057212827,5),(1388,2077772427,6),(1388,2088662427,5),(1388,2109222027,6),(1388,2120112027,5),(1388,2140671627,6),(1389,-2147483648,2),(1389,-1633273200,1),(1389,-1615132800,2),(1389,-1601823600,1),(1389,-1583683200,2),(1389,-880210800,3),(1389,-769395600,4),(1389,-765388800,2),(1389,-84380400,1),(1389,-68659200,2),(1389,-52930800,1),(1389,-37209600,2),(1389,-21481200,1),(1389,-5760000,2),(1389,9968400,1),(1389,25689600,2),(1389,41418000,1),(1389,57744000,2),(1389,73472400,1),(1389,89193601,2),(1389,104922002,1),(1389,120643202,2),(1389,126694803,1),(1389,152092803,2),(1389,162378004,1),(1389,183542404,2),(1389,199270805,1),(1389,215596805,2),(1389,230720406,1),(1389,247046406,2),(1389,262774807,1),(1389,278496007,2),(1389,294224408,1),(1389,309945608,2),(1389,325674009,1),(1389,341395209,2),(1389,357123609,1),(1389,372844810,2),(1389,388573210,1),(1389,404899211,2),(1389,420022811,1),(1389,436348812,2),(1389,452077212,1),(1389,467798412,2),(1389,483526812,1),(1389,499248013,2),(1389,514976413,1),(1389,530697613,2),(1389,544611613,1),(1389,562147213,2),(1389,576061214,1),(1389,594201614,2),(1389,607510814,1),(1389,625651214,2),(1389,638960415,1),(1389,657100815,2),(1389,671014816,1),(1389,688550416,2),(1389,702464416,1),(1389,720000017,2),(1389,733914017,1),(1389,752054418,2),(1389,765363618,1),(1389,783504019,2),(1389,796813219,1),(1389,814953619,2),(1389,828867620,1),(1389,846403220,2),(1389,860317220,1),(1389,877852821,2),(1389,891766821,1),(1389,909302421,2),(1389,923216422,1),(1389,941356822,2),(1389,954666022,1),(1389,972806422,2),(1389,986115622,1),(1389,1004256022,2),(1389,1018170022,1),(1389,1035705622,2),(1389,1049619622,1),(1389,1067155222,6),(1389,1081065622,5),(1389,1099206022,6),(1389,1112515222,5),(1389,1130655622,6),(1389,1143964823,5),(1389,1162105223,6),(1389,1173600023,5),(1389,1194159623,6),(1389,1205049623,5),(1389,1225609223,6),(1389,1236499224,5),(1389,1257058824,6),(1389,1268553624,5),(1389,1289113224,6),(1389,1300003224,5),(1389,1320562824,6),(1389,1331452824,5),(1389,1352012425,6),(1389,1362902425,5),(1389,1383462025,6),(1389,1394352025,5),(1389,1414911625,6),(1389,1425801625,5),(1389,1446361226,6),(1389,1457856026,5),(1389,1478415626,6),(1389,1489305627,5),(1389,1509865227,6),(1389,1520755227,5),(1389,1541314827,6),(1389,1552204827,5),(1389,1572764427,6),(1389,1583654427,5),(1389,1604214027,6),(1389,1615708827,5),(1389,1636268427,6),(1389,1647158427,5),(1389,1667718027,6),(1389,1678608027,5),(1389,1699167627,6),(1389,1710057627,5),(1389,1730617227,6),(1389,1741507227,5),(1389,1762066827,6),(1389,1772956827,5),(1389,1793516427,6),(1389,1805011227,5),(1389,1825570827,6),(1389,1836460827,5),(1389,1857020427,6),(1389,1867910427,5),(1389,1888470027,6),(1389,1899360027,5),(1389,1919919627,6),(1389,1930809627,5),(1389,1951369227,6),(1389,1962864027,5),(1389,1983423627,6),(1389,1994313627,5),(1389,2014873227,6),(1389,2025763227,5),(1389,2046322827,6),(1389,2057212827,5),(1389,2077772427,6),(1389,2088662427,5),(1389,2109222027,6),(1389,2120112027,5),(1389,2140671627,6),(1390,-2147483648,0),(1390,-1514739600,1),(1390,-1343066400,2),(1390,-1234807200,1),(1390,-1220292000,2),(1390,-1207159200,1),(1390,-1191344400,2),(1390,828864020,3),(1390,846399620,2),(1390,860313620,3),(1390,877849221,2),(1390,891766821,4),(1390,909302421,1),(1390,923216422,4),(1390,941356822,1),(1390,954666022,4),(1390,972806422,1),(1390,989139622,4),(1390,1001836822,1),(1390,1018170022,4),(1390,1035705622,1),(1390,1049619622,4),(1390,1067155222,1),(1390,1081069222,4),(1390,1099209622,1),(1390,1112518822,4),(1390,1130659222,1),(1390,1143968423,4),(1390,1162108823,1),(1390,1175418023,4),(1390,1193558423,1),(1390,1207472423,4),(1390,1225008023,1),(1390,1238922024,4),(1390,1256457624,1),(1390,1268557224,4),(1390,1289116824,1),(1390,1300006824,4),(1390,1320566424,1),(1390,1331456424,4),(1390,1352016025,1),(1390,1362906025,4),(1390,1383465625,1),(1390,1394355625,4),(1390,1414915225,1),(1390,1425805225,4),(1390,1446364826,1),(1390,1457859626,4),(1390,1478419226,1),(1390,1489309227,4),(1390,1509868827,1),(1390,1520758827,4),(1390,1541318427,1),(1390,1552208427,4),(1390,1572768027,1),(1390,1583658027,4),(1390,1604217627,1),(1390,1615712427,4),(1390,1636272027,1),(1390,1647162027,4),(1390,1667721627,1),(1390,1678611627,4),(1390,1699171227,1),(1390,1710061227,4),(1390,1730620827,1),(1390,1741510827,4),(1390,1762070427,1),(1390,1772960427,4),(1390,1793520027,1),(1390,1805014827,4),(1390,1825574427,1),(1390,1836464427,4),(1390,1857024027,1),(1390,1867914027,4),(1390,1888473627,1),(1390,1899363627,4),(1390,1919923227,1),(1390,1930813227,4),(1390,1951372827,1),(1390,1962867627,4),(1390,1983427227,1),(1390,1994317227,4),(1390,2014876827,1),(1390,2025766827,4),(1390,2046326427,1),(1390,2057216427,4),(1390,2077776027,1),(1390,2088666027,4),(1390,2109225627,1),(1390,2120115627,4),(1390,2140675227,1),(1391,-2147483648,1),(1391,-1946918424,2),(1392,-2147483648,0),(1392,-1546300800,3),(1392,-880221600,1),(1392,-769395600,2),(1392,-765399600,3),(1392,-147902400,4),(1392,-131572800,3),(1392,325663209,5),(1392,341384409,3),(1392,357112809,5),(1392,372834010,3),(1392,388562410,5),(1392,404888411,3),(1392,420012011,5),(1392,436338012,3),(1392,452066412,5),(1392,467787612,3),(1392,483516012,5),(1392,499237213,3),(1392,514965613,5),(1392,530686813,3),(1392,544600813,5),(1392,562136413,3),(1392,576050414,5),(1392,594190814,3),(1392,607500014,5),(1392,625640414,3),(1392,638949615,5),(1392,657090015,3),(1392,671004016,5),(1392,688539616,3),(1392,702453616,5),(1392,719989217,3),(1392,733903217,5),(1392,752043618,3),(1392,765352818,5),(1392,783493219,3),(1392,796802419,6),(1392,814946419,7),(1392,828860420,6),(1392,846396020,7),(1392,860310020,6),(1392,877845621,7),(1392,891759621,6),(1392,909295221,7),(1392,923209222,6),(1392,941349622,8),(1392,954662422,9),(1392,972802822,7),(1392,986108422,6),(1392,1004248822,7),(1392,1018162822,6),(1392,1035698422,7),(1392,1049612422,6),(1392,1067148022,7),(1392,1081062022,6),(1392,1099202422,7),(1392,1112511622,6),(1392,1130652022,7),(1392,1143961223,6),(1392,1162101623,7),(1392,1173596423,6),(1392,1194156023,7),(1392,1205046023,6),(1392,1225605623,7),(1392,1236495624,6),(1392,1257055224,7),(1392,1268550024,6),(1392,1289109624,7),(1392,1299999624,6),(1392,1320559224,7),(1392,1331449224,6),(1392,1352008825,7),(1392,1362898825,6),(1392,1383458425,7),(1392,1394348425,6),(1392,1414908025,7),(1392,1425798025,6),(1392,1446357626,7),(1392,1457852426,6),(1392,1478412026,7),(1392,1489302027,6),(1392,1509861627,7),(1392,1520751627,6),(1392,1541311227,7),(1392,1552201227,6),(1392,1572760827,7),(1392,1583650827,6),(1392,1604210427,7),(1392,1615705227,6),(1392,1636264827,7),(1392,1647154827,6),(1392,1667714427,7),(1392,1678604427,6),(1392,1699164027,7),(1392,1710054027,6),(1392,1730613627,7),(1392,1741503627,6),(1392,1762063227,7),(1392,1772953227,6),(1392,1793512827,7),(1392,1805007627,6),(1392,1825567227,7),(1392,1836457227,6),(1392,1857016827,7),(1392,1867906827,6),(1392,1888466427,7),(1392,1899356427,6),(1392,1919916027,7),(1392,1930806027,6),(1392,1951365627,7),(1392,1962860427,6),(1392,1983420027,7),(1392,1994310027,6),(1392,2014869627,7),(1392,2025759627,6),(1392,2046319227,7),(1392,2057209227,6),(1392,2077768827,7),(1392,2088658827,6),(1392,2109218427,7),(1392,2120108427,6),(1392,2140668027,7),(1393,-2147483648,0),(1393,-1861906760,1),(1393,-1104524348,2),(1393,-765317964,3),(1393,465449412,4),(1394,-2147483648,2),(1394,-1633273200,1),(1394,-1615132800,2),(1394,-1601823600,1),(1394,-1583683200,2),(1394,-880210800,3),(1394,-820519140,2),(1394,-812653140,3),(1394,-796845540,2),(1394,-84380400,1),(1394,-68659200,2),(1395,-2147483648,1),(1395,-1670483460,3),(1395,421218011,2),(1395,436334412,3),(1395,452062812,2),(1395,467784012,3),(1395,483512412,2),(1395,499233613,3),(1395,514962013,2),(1395,530683213,3),(1395,546411613,2),(1395,562132813,3),(1395,576050414,4),(1395,594194414,5),(1395,607500014,4),(1395,625644014,5),(1395,638949615,4),(1395,657093615,5),(1395,671004016,4),(1395,688543216,5),(1395,702453616,4),(1395,719992817,5),(1395,733903217,4),(1395,752047218,5),(1395,765352818,4),(1395,783496819,5),(1395,796802419,4),(1395,814946419,5),(1395,828856820,4),(1395,846396020,5),(1395,860306420,4),(1395,877845621,5),(1395,1112504422,2),(1395,1130644822,3),(1395,1143954023,2),(1395,1162094423,3),(1395,1331449224,2),(1395,1352008825,3),(1395,1362898825,2),(1395,1383458425,3),(1395,1394348425,2),(1395,1414908025,3),(1395,1425798025,2),(1395,1446357626,3),(1395,1489302027,2),(1395,1509861627,3),(1395,1520751627,2),(1395,1541311227,3),(1395,1552201227,2),(1395,1572760827,3),(1395,1583650827,2),(1395,1604210427,3),(1395,1615705227,2),(1395,1636264827,3),(1395,1647154827,2),(1395,1667714427,3),(1395,1678604427,2),(1395,1699164027,3),(1395,1710054027,2),(1395,1730613627,3),(1395,1741503627,2),(1395,1762063227,3),(1395,1772953227,2),(1395,1793512827,3),(1395,1805007627,2),(1395,1825567227,3),(1395,1836457227,2),(1395,1857016827,3),(1395,1867906827,2),(1395,1888466427,3),(1395,1899356427,2),(1395,1919916027,3),(1395,1930806027,2),(1395,1951365627,3),(1395,1962860427,2),(1395,1983420027,3),(1395,1994310027,2),(1395,2014869627,3),(1395,2025759627,2),(1395,2046319227,3),(1395,2057209227,2),(1395,2077768827,3),(1395,2088658827,2),(1395,2109218427,3),(1395,2120108427,2),(1395,2140668027,3),(1396,-2147483648,0),(1396,-1825098836,1),(1397,-2147483648,0),(1397,-1767209328,2),(1397,-1206950400,1),(1397,-1191355200,2),(1397,-1175367600,1),(1397,-1159819200,2),(1397,-633812400,1),(1397,-622062000,2),(1397,-602276400,1),(1397,-591825600,2),(1397,-570740400,1),(1397,-560203200,2),(1397,-539118000,1),(1397,-531345600,2),(1397,-191358000,1),(1397,-184190400,2),(1397,-155156400,1),(1397,-150062400,2),(1397,-128890800,1),(1397,-121118400,2),(1397,-99946800,1),(1397,-89582400,2),(1397,-68410800,1),(1397,-57960000,2),(1397,499755613,1),(1397,511243213,2),(1397,530600413,1),(1397,540273613,2),(1397,562136413,1),(1397,571204814,2),(1397,1214283623,3),(1397,1384056025,2),(1398,-2147483648,0),(1398,-1767210264,2),(1398,-1206954000,1),(1398,-1191358800,2),(1398,-1175371200,1),(1398,-1159822800,2),(1398,-633816000,1),(1398,-622065600,2),(1398,-602280000,1),(1398,-591829200,2),(1398,-570744000,1),(1398,-560206800,2),(1398,-539121600,1),(1398,-531349200,2),(1398,-191361600,1),(1398,-184194000,2),(1398,-155160000,1),(1398,-150066000,2),(1398,-128894400,1),(1398,-121122000,2),(1398,-99950400,1),(1398,-89586000,2),(1398,-68414400,1),(1398,-57963600,2),(1398,499752013,1),(1398,511239613,2),(1398,530596813,1),(1398,540270013,2),(1398,562132813,1),(1398,571201214,2),(1399,-2147483648,1),(1399,-873057600,3),(1399,-769395600,2),(1399,-765399600,1),(1400,-2147483648,1),(1400,-1892661434,2),(1400,-1688410800,1),(1400,-1619205434,3),(1400,-1593806400,1),(1400,-1335986234,4),(1400,-1317585600,2),(1400,-1304362800,4),(1400,-1286049600,2),(1400,-1272826800,4),(1400,-1254513600,2),(1400,-1241290800,4),(1400,-1222977600,2),(1400,-1209754800,4),(1400,-1191355200,2),(1400,-1178132400,3),(1400,-870552000,2),(1400,-865278000,3),(1400,-718056000,2),(1400,-713649600,3),(1400,-36619200,5),(1400,-23922000,6),(1400,-3355200,5),(1400,7527600,6),(1400,24465600,5),(1400,37767600,6),(1400,55915200,5),(1400,69217200,6),(1400,87969601,5),(1400,100666802,6),(1400,118209602,5),(1400,132116403,6),(1400,150868803,5),(1400,163566004,6),(1400,182318404,5),(1400,195620405,6),(1400,213768005,5),(1400,227070006,6),(1400,245217606,5),(1400,258519607,6),(1400,277272007,5),(1400,289969208,6),(1400,308721608,5),(1400,321418809,6),(1400,340171209,5),(1400,353473209,6),(1400,371620810,5),(1400,384922810,6),(1400,403070411,5),(1400,416372411,6),(1400,434520012,5),(1400,447822012,6),(1400,466574412,5),(1400,479271612,6),(1400,498024013,5),(1400,510721213,6),(1400,529473613,5),(1400,545194813,6),(1400,560923213,5),(1400,574225214,6),(1400,592372814,5),(1400,605674814,6),(1400,624427214,5),(1400,637124415,6),(1400,653457615,5),(1400,668574016,6),(1400,687326416,5),(1400,700628416,6),(1400,718776017,5),(1400,732078017,6),(1400,750225618,5),(1400,763527618,6),(1400,781675219,5),(1400,794977219,6),(1400,813729619,5),(1400,826426820,6),(1400,845179220,5),(1400,859690820,6),(1400,876628821,5),(1400,889930821,6),(1400,906868821,5),(1400,923194822,6),(1400,939528022,5),(1400,952830022,6),(1400,971582422,5),(1400,984279622,6),(1400,1003032022,5),(1400,1015729222,6),(1400,1034481622,5),(1400,1047178822,6),(1400,1065931222,5),(1400,1079233222,6),(1400,1097380822,5),(1400,1110682822,6),(1400,1128830422,5),(1400,1142132423,6),(1400,1160884823,5),(1400,1173582023,6),(1400,1192334423,5),(1400,1206846023,6),(1400,1223784023,5),(1400,1237086024,6),(1400,1255233624,5),(1400,1270350024,6),(1400,1286683224,5),(1400,1304823624,6),(1400,1313899224,5),(1400,1335668424,6),(1400,1346558425,5),(1400,1367118025,6),(1400,1378612825,5),(1400,1398567625,6),(1400,1410062425,5),(1400,1463281226,6),(1400,1471147226,5),(1400,1480820426,7),(1401,-2147483648,2),(1401,-1632067200,1),(1401,-1615136400,2),(1401,-923248800,1),(1401,-880214400,3),(1401,-769395600,4),(1401,-765392400,2),(1401,136368003,1),(1401,152089203,2),(1401,167817604,1),(1401,183538804,2),(1401,199267205,1),(1401,215593205,2),(1401,230716806,1),(1401,247042806,2),(1401,262771207,1),(1401,278492407,2),(1401,294220808,1),(1401,309942008,2),(1401,325670409,1),(1401,341391609,2),(1401,357120009,1),(1401,372841210,2),(1401,388569610,1),(1401,404895611,2),(1401,420019211,1),(1401,436345212,2),(1401,452073612,1),(1401,467794812,2),(1401,483523212,1),(1401,499244413,2),(1401,514972813,1),(1401,530694013,2),(1401,544608013,1),(1401,562143613,2),(1401,576057614,1),(1401,594198014,2),(1401,607507214,1),(1401,625647614,2),(1401,638956815,1),(1401,657097215,2),(1401,671011216,1),(1401,688546816,2),(1401,702460816,1),(1401,719996417,2),(1401,733910417,1),(1401,752050818,2),(1401,765360018,1),(1401,783500419,2),(1401,796809619,1),(1401,814950019,2),(1401,828864020,1),(1401,846399620,2),(1401,860313620,1),(1401,877849221,2),(1401,891763221,1),(1401,909298821,2),(1401,923212822,1),(1401,941353222,2),(1401,954662422,1),(1401,972802822,2),(1401,986112022,1),(1401,1004252422,2),(1401,1018166422,1),(1401,1035702022,2),(1401,1049616022,1),(1401,1067151622,2),(1401,1081065622,1),(1401,1099206022,2),(1401,1112515222,1),(1401,1130655622,2),(1401,1143964823,1),(1401,1162105223,2),(1401,1173600023,1),(1401,1194159623,2),(1401,1205049623,1),(1401,1225609223,2),(1401,1236499224,1),(1401,1257058824,2),(1401,1268553624,1),(1401,1289113224,2),(1401,1300003224,1),(1401,1320562824,2),(1401,1331452824,1),(1401,1352012425,2),(1401,1362902425,1),(1401,1383462025,2),(1401,1394352025,1),(1401,1414911625,2),(1401,1425801625,1),(1401,1446361226,2),(1401,1457856026,1),(1401,1478415626,2),(1401,1489305627,1),(1401,1509865227,2),(1401,1520755227,1),(1401,1541314827,2),(1401,1552204827,1),(1401,1572764427,2),(1401,1583654427,1),(1401,1604214027,2),(1401,1615708827,1),(1401,1636268427,2),(1401,1647158427,1),(1401,1667718027,2),(1401,1678608027,1),(1401,1699167627,2),(1401,1710057627,1),(1401,1730617227,2),(1401,1741507227,1),(1401,1762066827,2),(1401,1772956827,1),(1401,1793516427,2),(1401,1805011227,1),(1401,1825570827,2),(1401,1836460827,1),(1401,1857020427,2),(1401,1867910427,1),(1401,1888470027,2),(1401,1899360027,1),(1401,1919919627,2),(1401,1930809627,1),(1401,1951369227,2),(1401,1962864027,1),(1401,1983423627,2),(1401,1994313627,1),(1401,2014873227,2),(1401,2025763227,1),(1401,2046322827,2),(1401,2057212827,1),(1401,2077772427,2),(1401,2088662427,1),(1401,2109222027,2),(1401,2120112027,1),(1401,2140671627,2),(1402,-2147483648,0),(1402,-410227200,2),(1402,-147895200,1),(1402,-131565600,2),(1402,325670409,3),(1402,341391609,2),(1402,357120009,3),(1402,372841210,2),(1402,388569610,3),(1402,404895611,2),(1402,420019211,3),(1402,436345212,2),(1402,452073612,3),(1402,467794812,2),(1402,483523212,3),(1402,499244413,2),(1402,514972813,3),(1402,530694013,2),(1402,544608013,3),(1402,562143613,2),(1402,576057614,3),(1402,594198014,2),(1402,607507214,3),(1402,625647614,2),(1402,638956815,3),(1402,657097215,2),(1402,671011216,3),(1402,688546816,2),(1402,702460816,3),(1402,719996417,2),(1402,733910417,3),(1402,752050818,2),(1402,765360018,3),(1402,783500419,2),(1402,796809619,3),(1402,814950019,2),(1402,828864020,3),(1402,846399620,2),(1402,860313620,3),(1402,877849221,2),(1402,891763221,3),(1402,909298821,2),(1402,923212822,3),(1402,941353222,2),(1402,954662422,3),(1402,972802822,4),(1402,986112022,3),(1402,1004252422,2),(1402,1018166422,3),(1402,1035702022,2),(1402,1049616022,3),(1402,1067151622,2),(1402,1081065622,3),(1402,1099206022,2),(1402,1112515222,3),(1402,1130655622,2),(1402,1143964823,3),(1402,1162105223,2),(1402,1173600023,3),(1402,1194159623,2),(1402,1205049623,3),(1402,1225609223,2),(1402,1236499224,3),(1402,1257058824,2),(1402,1268553624,3),(1402,1289113224,2),(1402,1300003224,3),(1402,1320562824,2),(1402,1331452824,3),(1402,1352012425,2),(1402,1362902425,3),(1402,1383462025,2),(1402,1394352025,3),(1402,1414911625,2),(1402,1425801625,3),(1402,1446361226,2),(1402,1457856026,3),(1402,1478415626,2),(1402,1489305627,3),(1402,1509865227,2),(1402,1520755227,3),(1402,1541314827,2),(1402,1552204827,3),(1402,1572764427,2),(1402,1583654427,3),(1402,1604214027,2),(1402,1615708827,3),(1402,1636268427,2),(1402,1647158427,3),(1402,1667718027,2),(1402,1678608027,3),(1402,1699167627,2),(1402,1710057627,3),(1402,1730617227,2),(1402,1741507227,3),(1402,1762066827,2),(1402,1772956827,3),(1402,1793516427,2),(1402,1805011227,3),(1402,1825570827,2),(1402,1836460827,3),(1402,1857020427,2),(1402,1867910427,3),(1402,1888470027,2),(1402,1899360027,3),(1402,1919919627,2),(1402,1930809627,3),(1402,1951369227,2),(1402,1962864027,3),(1402,1983423627,2),(1402,1994313627,3),(1402,2014873227,2),(1402,2025763227,3),(1402,2046322827,2),(1402,2057212827,3),(1402,2077772427,2),(1402,2088662427,3),(1402,2109222027,2),(1402,2120112027,3),(1402,2140671627,2),(1403,-2147483648,0),(1403,-1767217224,2),(1403,-1206957600,1),(1403,-1191362400,2),(1403,-1175374800,1),(1403,-1159826400,2),(1403,-633819600,1),(1403,-622069200,2),(1403,-602283600,1),(1403,-591832800,2),(1403,-570747600,1),(1403,-560210400,2),(1403,-539125200,1),(1403,-531352800,2),(1403,-191365200,1),(1403,-184197600,2),(1403,-155163600,1),(1403,-150069600,2),(1403,-128898000,1),(1403,-121125600,2),(1403,-99954000,1),(1403,-89589600,2),(1403,-68418000,1),(1403,-57967200,2),(1403,499748413,1),(1403,511236013,2),(1403,530593213,1),(1403,540266413,2),(1403,562129213,1),(1403,571197614,2),(1403,592974014,1),(1403,602042414,2),(1403,624423614,1),(1403,634701615,2),(1403,938919622,1),(1403,951616822,2),(1403,970974022,1),(1403,971575222,2),(1403,1003028422,1),(1403,1013911222,2),(1404,-2147483648,0),(1404,-2030202084,2),(1404,-1632063600,1),(1404,-1615132800,2),(1404,-1251651600,1),(1404,-1238349600,2),(1404,-1220202000,1),(1404,-1206900000,2),(1404,-1188752400,1),(1404,-1175450400,2),(1404,-1156698000,1),(1404,-1144000800,2),(1404,-1125248400,1),(1404,-1111946400,2),(1404,-1032714000,1),(1404,-1016992800,2),(1404,-1001264400,1),(1404,-986148000,2),(1404,-969814800,1),(1404,-954093600,2),(1404,-937760400,1),(1404,-922039200,2),(1404,-906310800,1),(1404,-890589600,2),(1404,-880210800,3),(1404,-769395600,4),(1404,-765388800,2),(1404,-748450800,1),(1404,-732729600,2),(1404,-715791600,1),(1404,-702489600,2),(1404,-684342000,1),(1404,-671040000,2),(1404,-652892400,1),(1404,-639590400,2),(1404,-620838000,1),(1404,-608140800,2),(1404,-589388400,1),(1404,-576086400,2),(1404,-557938800,1),(1404,-544636800,2),(1404,-526489200,1),(1404,-513187200,2),(1404,-495039600,1),(1404,-481737600,2),(1404,-463590000,1),(1404,-450288000,2),(1404,-431535600,1),(1404,-418233600,2),(1404,-400086000,1),(1404,-386784000,2),(1404,-337186800,1),(1404,-321465600,2),(1404,-305737200,5),(1405,-2147483648,0),(1405,-704937600,2),(1405,-147895200,1),(1405,-131565600,2),(1405,325670409,3),(1405,341391609,2),(1405,357120009,3),(1405,372841210,2),(1405,388569610,3),(1405,404895611,2),(1405,420019211,3),(1405,436345212,2),(1405,452073612,3),(1405,467794812,2),(1405,483523212,3),(1405,499244413,2),(1405,514972813,3),(1405,530694013,2),(1405,544608013,3),(1405,562143613,2),(1405,576057614,3),(1405,594198014,2),(1405,607507214,3),(1405,625647614,2),(1405,638956815,3),(1405,657097215,2),(1405,671011216,3),(1405,688546816,2),(1405,702460816,3),(1405,719996417,2),(1405,733910417,3),(1405,752050818,2),(1405,765360018,3),(1405,783500419,2),(1405,796809619,3),(1405,814950019,2),(1405,828864020,3),(1405,846399620,2),(1405,860313620,3),(1405,877849221,2),(1405,891763221,3),(1405,909298821,2),(1405,923212822,3),(1405,941353222,2),(1405,954662422,3),(1405,972802822,4),(1405,986112022,3),(1405,1004252422,2),(1405,1018166422,3),(1405,1035702022,2),(1405,1049616022,3),(1405,1067151622,2),(1405,1081065622,3),(1405,1099206022,2),(1405,1112515222,3),(1405,1130655622,2),(1405,1143964823,3),(1405,1162105223,4),(1405,1173600023,3),(1405,1194159623,2),(1405,1205049623,3),(1405,1225609223,2),(1405,1236499224,3),(1405,1257058824,2),(1405,1268553624,3),(1405,1289113224,2),(1405,1300003224,3),(1405,1320562824,2),(1405,1331452824,3),(1405,1352012425,2),(1405,1362902425,3),(1405,1383462025,2),(1405,1394352025,3),(1405,1414911625,2),(1405,1425801625,3),(1405,1446361226,2),(1405,1457856026,3),(1405,1478415626,2),(1405,1489305627,3),(1405,1509865227,2),(1405,1520755227,3),(1405,1541314827,2),(1405,1552204827,3),(1405,1572764427,2),(1405,1583654427,3),(1405,1604214027,2),(1405,1615708827,3),(1405,1636268427,2),(1405,1647158427,3),(1405,1667718027,2),(1405,1678608027,3),(1405,1699167627,2),(1405,1710057627,3),(1405,1730617227,2),(1405,1741507227,3),(1405,1762066827,2),(1405,1772956827,3),(1405,1793516427,2),(1405,1805011227,3),(1405,1825570827,2),(1405,1836460827,3),(1405,1857020427,2),(1405,1867910427,3),(1405,1888470027,2),(1405,1899360027,3),(1405,1919919627,2),(1405,1930809627,3),(1405,1951369227,2),(1405,1962864027,3),(1405,1983423627,2),(1405,1994313627,3),(1405,2014873227,2),(1405,2025763227,3),(1405,2046322827,2),(1405,2057212827,3),(1405,2077772427,2),(1405,2088662427,3),(1405,2109222027,2),(1405,2120112027,3),(1405,2140671627,2),(1406,-2147483648,0),(1406,-1767209328,2),(1406,-1206950400,1),(1406,-1191355200,2),(1406,-1175367600,1),(1406,-1159819200,2),(1406,-633812400,1),(1406,-622062000,2),(1406,-602276400,1),(1406,-591825600,2),(1406,-570740400,1),(1406,-560203200,2),(1406,-539118000,1),(1406,-531345600,2),(1406,-191358000,1),(1406,-184190400,2),(1406,-155156400,1),(1406,-150062400,2),(1406,-128890800,1),(1406,-121118400,2),(1406,-99946800,1),(1406,-89582400,2),(1406,-68410800,1),(1406,-57960000,2),(1406,499755613,1),(1406,511243213,2),(1406,530600413,1),(1406,540273613,2),(1406,562136413,1),(1406,571204814,2),(1406,1214283623,3),(1406,1384056025,2),(1407,-2147483648,1),(1407,-1567453392,2),(1407,-1233432000,3),(1407,-1222981200,2),(1407,-1205956800,3),(1407,-1194037200,2),(1407,-1172865600,3),(1407,-1162501200,2),(1407,-1141329600,3),(1407,-1130965200,2),(1407,-1109793600,3),(1407,-1099429200,2),(1407,-1078257600,3),(1407,-1067806800,2),(1407,-1046635200,3),(1407,-1036270800,2),(1407,-1015099200,3),(1407,-1004734800,2),(1407,-983563200,3),(1407,-973198800,2),(1407,-952027200,3),(1407,-941576400,2),(1407,-931032000,3),(1407,-900882000,2),(1407,-890337600,3),(1407,-833749200,2),(1407,-827265600,3),(1407,-752274000,2),(1407,-733780800,3),(1407,-197326800,2),(1407,-190843200,3),(1407,-184194000,2),(1407,-164491200,3),(1407,-152658000,2),(1407,-132955200,3),(1407,-121122000,2),(1407,-101419200,3),(1407,-86821200,2),(1407,-71092800,3),(1407,-54766800,2),(1407,-39038400,3),(1407,-23317200,2),(1407,-7588800,5),(1407,128142003,4),(1407,136605603,5),(1407,596948414,4),(1407,605066414,5),(1407,624423614,4),(1407,636516015,5),(1407,656478015,4),(1407,667965616,2),(1407,687931216,4),(1407,699415216,5),(1407,719377217,4),(1407,731469617,5),(1407,938919622,3),(1407,952052422,5),(1407,1198983623,4),(1407,1205632823,5),(1407,1224385223,4),(1407,1237082424,5),(1408,-2147483648,0),(1408,-1514736000,1),(1408,-1451667600,2),(1408,-1343062800,1),(1408,-1234803600,2),(1408,-1222963200,3),(1408,-1207242000,2),(1408,-873820800,4),(1408,-769395600,5),(1408,-761677200,2),(1408,-686073600,3),(1408,-661539600,2),(1408,-495039600,3),(1408,-481734000,2),(1408,-463590000,3),(1408,-450284400,2),(1408,-431535600,3),(1408,-418230000,2),(1408,-400086000,3),(1408,-386780400,2),(1408,-368636400,3),(1408,-355330800,2),(1408,-337186800,3),(1408,-323881200,2),(1408,-305737200,3),(1408,-292431600,2),(1408,199274405,3),(1408,215600405,2),(1408,230724006,3),(1408,247050006,2),(1408,262778407,3),(1408,278499607,2),(1408,294228008,3),(1408,309949208,2),(1408,325677609,3),(1408,341398809,2),(1408,357127209,3),(1408,372848410,2),(1408,388576810,3),(1408,404902811,2),(1408,420026411,3),(1408,436352412,2),(1408,452080812,3),(1408,467802012,2),(1408,483530412,3),(1408,499251613,2),(1408,514980013,3),(1408,530701213,2),(1408,544615213,3),(1408,562150813,2),(1408,576064814,3),(1408,594205214,2),(1408,607514414,3),(1408,625654814,2),(1408,638964015,3),(1408,657104415,2),(1408,671018416,3),(1408,688554016,2),(1408,702468016,3),(1408,720003617,2),(1408,733917617,3),(1408,752058018,2),(1408,765367218,3),(1408,783507619,2),(1408,796816819,3),(1408,814957219,2),(1408,828871220,3),(1408,846406820,2),(1408,860320820,3),(1408,877856421,2),(1408,891770421,3),(1408,909306021,2),(1408,923220022,3),(1408,941360422,2),(1408,954669622,3),(1408,972810022,2),(1408,986119222,3),(1408,1004259622,2),(1408,1018173622,3),(1408,1035709222,2),(1408,1049623222,3),(1408,1067158822,2),(1408,1081072822,3),(1408,1099213222,2),(1408,1112522422,3),(1408,1130662822,2),(1408,1143972023,3),(1408,1162112423,2),(1408,1175421623,3),(1408,1193562023,2),(1408,1207476023,3),(1408,1225011623,2),(1408,1238925624,3),(1408,1256461224,2),(1408,1268560824,3),(1408,1289120424,2),(1408,1300010424,3),(1408,1320570024,2),(1408,1331460024,3),(1408,1352019625,2),(1408,1362909625,3),(1408,1383469225,2),(1408,1394359225,3),(1408,1414918825,2),(1408,1425808825,3),(1408,1446368426,2),(1408,1457863226,3),(1408,1478422826,2),(1408,1489312827,3),(1408,1509872427,2),(1408,1520762427,3),(1408,1541322027,2),(1408,1552212027,3),(1408,1572771627,2),(1408,1583661627,3),(1408,1604221227,2),(1408,1615716027,3),(1408,1636275627,2),(1408,1647165627,3),(1408,1667725227,2),(1408,1678615227,3),(1408,1699174827,2),(1408,1710064827,3),(1408,1730624427,2),(1408,1741514427,3),(1408,1762074027,2),(1408,1772964027,3),(1408,1793523627,2),(1408,1805018427,3),(1408,1825578027,2),(1408,1836468027,3),(1408,1857027627,2),(1408,1867917627,3),(1408,1888477227,2),(1408,1899367227,3),(1408,1919926827,2),(1408,1930816827,3),(1408,1951376427,2),(1408,1962871227,3),(1408,1983430827,2),(1408,1994320827,3),(1408,2014880427,2),(1408,2025770427,3),(1408,2046330027,2),(1408,2057220027,3),(1408,2077779627,2),(1408,2088669627,3),(1408,2109229227,2),(1408,2120119227,3),(1408,2140678827,2),(1409,-2147483648,0),(1409,-1767212472,2),(1409,-1206954000,1),(1409,-1191358800,2),(1409,-1175371200,1),(1409,-1159822800,2),(1409,-633816000,1),(1409,-622065600,2),(1409,-602280000,1),(1409,-591829200,2),(1409,-570744000,1),(1409,-560206800,2),(1409,-539121600,1),(1409,-531349200,2),(1409,-191361600,1),(1409,-184194000,2),(1409,-155160000,1),(1409,-150066000,2),(1409,-128894400,1),(1409,-121122000,2),(1409,-99950400,1),(1409,-89586000,2),(1409,-68414400,1),(1409,-57963600,2),(1409,499752013,1),(1409,511239613,2),(1409,530596813,1),(1409,540270013,2),(1409,562132813,1),(1409,571201214,2),(1409,1214280023,3),(1410,-2147483648,1),(1410,-1892661434,2),(1410,-1688410800,1),(1410,-1619205434,3),(1410,-1593806400,1),(1410,-1335986234,4),(1410,-1317585600,2),(1410,-1304362800,4),(1410,-1286049600,2),(1410,-1272826800,4),(1410,-1254513600,2),(1410,-1241290800,4),(1410,-1222977600,2),(1410,-1209754800,4),(1410,-1191355200,2),(1410,-1178132400,3),(1410,-870552000,2),(1410,-865278000,3),(1410,-740520000,5),(1410,-736376400,3),(1410,-718056000,2),(1410,-713649600,3),(1410,-36619200,6),(1410,-23922000,7),(1410,-3355200,6),(1410,7527600,7),(1410,24465600,6),(1410,37767600,7),(1410,55915200,6),(1410,69217200,7),(1410,87969601,6),(1410,100666802,7),(1410,118209602,6),(1410,132116403,7),(1410,150868803,6),(1410,163566004,7),(1410,182318404,6),(1410,195620405,7),(1410,213768005,6),(1410,227070006,7),(1410,245217606,6),(1410,258519607,7),(1410,277272007,6),(1410,289969208,7),(1410,308721608,6),(1410,321418809,7),(1410,340171209,6),(1410,353473209,7),(1410,371620810,6),(1410,384922810,7),(1410,403070411,6),(1410,416372411,7),(1410,434520012,6),(1410,447822012,7),(1410,466574412,6),(1410,479271612,7),(1410,498024013,6),(1410,510721213,7),(1410,529473613,6),(1410,545194813,7),(1410,560923213,6),(1410,574225214,7),(1410,592372814,6),(1410,605674814,7),(1410,624427214,6),(1410,637124415,7),(1410,653457615,6),(1410,668574016,7),(1410,687326416,6),(1410,700628416,7),(1410,718776017,6),(1410,732078017,7),(1410,750225618,6),(1410,763527618,7),(1410,781675219,6),(1410,794977219,7),(1410,813729619,6),(1410,826426820,7),(1410,845179220,6),(1410,859690820,7),(1410,876628821,6),(1410,889930821,7),(1410,906868821,6),(1410,923194822,7),(1410,939528022,6),(1410,952830022,7),(1410,971582422,6),(1410,984279622,7),(1410,1003032022,6),(1410,1015729222,7),(1410,1034481622,6),(1410,1047178822,7),(1410,1065931222,6),(1410,1079233222,7),(1410,1097380822,6),(1410,1110682822,7),(1410,1128830422,6),(1410,1142132423,7),(1410,1160884823,6),(1410,1173582023,7),(1410,1192334423,6),(1410,1206846023,7),(1410,1223784023,6),(1410,1237086024,7),(1410,1255233624,6),(1410,1270350024,7),(1410,1286683224,6),(1410,1304823624,7),(1410,1313899224,6),(1410,1335668424,7),(1410,1346558425,6),(1410,1367118025,7),(1410,1378612825,6),(1410,1398567625,7),(1410,1410062425,6),(1410,1463281226,7),(1410,1471147226,6),(1410,1494730827,7),(1410,1502596827,6),(1410,1526180427,7),(1410,1534046427,6),(1410,1554606027,7),(1410,1567915227,6),(1410,1586055627,7),(1410,1599364827,6),(1410,1617505227,7),(1410,1630814427,6),(1410,1648954827,7),(1410,1662264027,6),(1410,1680404427,7),(1410,1693713627,6),(1410,1712458827,7),(1410,1725768027,6),(1410,1743908427,7),(1410,1757217627,6),(1410,1775358027,7),(1410,1788667227,6),(1410,1806807627,7),(1410,1820116827,6),(1410,1838257227,7),(1410,1851566427,6),(1410,1870311627,7),(1410,1883016027,6),(1410,1901761227,7),(1410,1915070427,6),(1410,1933210827,7),(1410,1946520027,6),(1410,1964660427,7),(1410,1977969627,6),(1410,1996110027,7),(1410,2009419227,6),(1410,2027559627,7),(1410,2040868827,6),(1410,2059614027,7),(1410,2072318427,6),(1410,2091063627,7),(1410,2104372827,6),(1410,2122513227,7),(1410,2135822427,6),(1411,-2147483648,1),(1411,-1159773600,3),(1411,-100119600,2),(1411,-89668800,3),(1411,-5770800,4),(1411,4422600,3),(1411,25678800,4),(1411,33193800,3),(1411,57733200,4),(1411,64816200,3),(1411,89182801,4),(1411,96438602,3),(1411,120632402,4),(1411,127974603,3),(1411,152082003,5),(1411,972799222,3),(1411,975823222,5),(1412,-2147483648,0),(1412,-1767214412,2),(1412,-1206957600,1),(1412,-1191362400,2),(1412,-1175374800,1),(1412,-1159826400,2),(1412,-633819600,1),(1412,-622069200,2),(1412,-602283600,1),(1412,-591832800,2),(1412,-570747600,1),(1412,-560210400,2),(1412,-539125200,1),(1412,-531352800,2),(1412,-195426000,1),(1412,-184197600,2),(1412,-155163600,1),(1412,-150069600,2),(1412,-128898000,1),(1412,-121125600,2),(1412,-99954000,1),(1412,-89589600,2),(1412,-68418000,1),(1412,-57967200,2),(1412,499748413,1),(1412,511236013,2),(1412,530593213,1),(1412,540266413,2),(1412,562129213,1),(1412,571197614,2),(1412,592974014,1),(1412,602042414,2),(1412,624423614,1),(1412,634701615,2),(1412,656478015,1),(1412,666756016,2),(1412,687927616,1),(1412,697600816,2),(1412,719982017,1),(1412,728445617,2),(1412,750826818,1),(1412,761709618,2),(1412,782276419,1),(1412,793159219,2),(1412,813726019,1),(1412,824004020,2),(1412,844570820,1),(1412,856058420,2),(1412,876106821,1),(1412,888717621,2),(1412,908074821,1),(1412,919562422,2),(1412,938919622,1),(1412,951616822,2),(1412,970974022,1),(1412,982461622,2),(1412,1003028422,1),(1412,1013911222,2),(1412,1036292422,1),(1412,1045360822,2),(1412,1066532422,1),(1412,1076810422,2),(1412,1099364422,1),(1412,1108864822,2),(1412,1129431622,1),(1412,1140314423,2),(1412,1162695623,1),(1412,1172368823,2),(1412,1192330823,1),(1412,1203213623,2),(1412,1224385223,1),(1412,1234663224,2),(1412,1255834824,1),(1412,1266717624,2),(1412,1287284424,1),(1412,1298167224,2),(1412,1318734024,1),(1412,1330221624,2),(1412,1350788425,1),(1412,1361066425,2),(1412,1382238025,1),(1412,1392516025,2),(1412,1413687625,1),(1412,1424570425,2),(1412,1445137226,1),(1412,1456020026,2),(1412,1476586826,1),(1412,1487469627,2),(1412,1508036427,1),(1412,1518919227,2),(1412,1541300427,1),(1412,1550368827,2),(1412,1572750027,1),(1412,1581818427,2),(1412,1604199627,1),(1412,1613872827,2),(1412,1636254027,1),(1412,1645322427,2),(1412,1667703627,1),(1412,1677376827,2),(1412,1699153227,1),(1412,1708221627,2),(1412,1730602827,1),(1412,1739671227,2),(1412,1762052427,1),(1412,1771725627,2),(1412,1793502027,1),(1412,1803175227,2),(1412,1825556427,1),(1412,1834624827,2),(1412,1857006027,1),(1412,1866074427,2),(1412,1888455627,1),(1412,1897524027,2),(1412,1919905227,1),(1412,1928973627,2),(1412,1951354827,1),(1412,1960423227,2),(1412,1983409227,1),(1412,1992477627,2),(1412,2014858827,1),(1412,2024532027,2),(1412,2046308427,1),(1412,2055376827,2),(1412,2077758027,1),(1412,2086826427,2),(1412,2109207627,1),(1412,2118880827,2),(1412,2140657227,1),(1413,-2147483648,0),(1413,-1686090728,1),(1413,323841609,2),(1413,338961609,3),(1413,354679209,6),(1413,370400410,4),(1413,386125210,5),(1413,401850011,4),(1413,417574811,5),(1413,433299612,4),(1413,449024412,5),(1413,465354012,4),(1413,481078812,5),(1413,496803613,4),(1413,512528413,5),(1413,528253213,4),(1413,543978013,5),(1413,559702813,4),(1413,575427614,5),(1413,591152414,4),(1413,606877214,5),(1413,622602014,4),(1413,638326815,5),(1413,654656415,4),(1413,670381216,5),(1413,686106016,4),(1413,701830816,5),(1413,717555617,4),(1413,733280417,5),(1413,749005218,4),(1413,764730018,5),(1413,780454819,4),(1413,796179619,5),(1413,811904419,4),(1413,828234020,5),(1413,846378020,4),(1413,859683620,5),(1413,877827621,4),(1413,891133221,5),(1413,909277221,4),(1413,922582822,5),(1413,941331622,4),(1413,954032422,5),(1413,972781222,4),(1413,985482022,5),(1413,1004230822,4),(1413,1017536422,5),(1413,1035680422,4),(1413,1048986022,5),(1413,1067130022,4),(1413,1080435622,5),(1413,1099184422,4),(1413,1111885222,5),(1413,1130634022,4),(1413,1143334823,5),(1413,1162083623,4),(1413,1174784423,5),(1413,1193533223,4),(1413,1206838823,5),(1413,1224982823,4),(1413,1238288424,5),(1413,1256432424,4),(1413,1269738024,5),(1413,1288486824,4),(1413,1301187624,5),(1413,1319936424,4),(1413,1332637224,5),(1413,1351386025,4),(1413,1364691625,5),(1413,1382835625,4),(1413,1396141225,5),(1413,1414285225,4),(1413,1427590825,5),(1413,1445734826,4),(1413,1459040426,5),(1413,1477789226,4),(1413,1490490027,5),(1413,1509238827,4),(1413,1521939627,5),(1413,1540688427,4),(1413,1553994027,5),(1413,1572138027,4),(1413,1585443627,5),(1413,1603587627,4),(1413,1616893227,5),(1413,1635642027,4),(1413,1648342827,5),(1413,1667091627,4),(1413,1679792427,5),(1413,1698541227,4),(1413,1711846827,5),(1413,1729990827,4),(1413,1743296427,5),(1413,1761440427,4),(1413,1774746027,5),(1413,1792890027,4),(1413,1806195627,5),(1413,1824944427,4),(1413,1837645227,5),(1413,1856394027,4),(1413,1869094827,5),(1413,1887843627,4),(1413,1901149227,5),(1413,1919293227,4),(1413,1932598827,5),(1413,1950742827,4),(1413,1964048427,5),(1413,1982797227,4),(1413,1995498027,5),(1413,2014246827,4),(1413,2026947627,5),(1413,2045696427,4),(1413,2058397227,5),(1413,2077146027,4),(1413,2090451627,5),(1413,2108595627,4),(1413,2121901227,5),(1413,2140045227,4),(1414,-2147483648,2),(1414,-1633273200,1),(1414,-1615132800,2),(1414,-1601823600,1),(1414,-1583683200,2),(1414,-1570374000,1),(1414,-1551628800,2),(1414,-1538924400,1),(1414,-1534089600,2),(1414,-880210800,3),(1414,-769395600,4),(1414,-765388800,2),(1414,-147884400,1),(1414,-131558400,2),(1414,-116434800,1),(1414,-100108800,2),(1414,-84380400,1),(1414,-68659200,2),(1414,-52930800,1),(1414,-37209600,2),(1414,-21481200,1),(1414,-5760000,2),(1414,9968400,1),(1414,25689600,2),(1414,41418000,1),(1414,57744000,2),(1414,73472400,1),(1414,89193601,2),(1414,104922002,1),(1414,120643202,2),(1414,126694803,1),(1414,152092803,2),(1414,162378004,1),(1414,183542404,2),(1414,199270805,1),(1414,215596805,2),(1414,230720406,1),(1414,247046406,2),(1414,262774807,1),(1414,278496007,2),(1414,294224408,1),(1414,309945608,2),(1414,325674009,1),(1414,341395209,2),(1414,357123609,1),(1414,372844810,2),(1414,388573210,1),(1414,404899211,2),(1414,420022811,1),(1414,436348812,2),(1414,452077212,1),(1414,467798412,2),(1414,483526812,1),(1414,499248013,2),(1414,514976413,1),(1414,530697613,2),(1414,544611613,1),(1414,562147213,2),(1414,576061214,1),(1414,594201614,2),(1414,607510814,1),(1414,625651214,2),(1414,638960415,1),(1414,657100815,2),(1414,671014816,1),(1414,688550416,2),(1414,702464416,1),(1414,720000017,2),(1414,733914017,1),(1414,752054418,2),(1414,765363618,1),(1414,783504019,2),(1414,796813219,1),(1414,814953619,2),(1414,828867620,1),(1414,846403220,2),(1414,860317220,1),(1414,877852821,2),(1414,891766821,1),(1414,909302421,2),(1414,923216422,1),(1414,941356822,2),(1414,954666022,1),(1414,972806422,2),(1414,986115622,1),(1414,1004256022,2),(1414,1018170022,1),(1414,1035705622,2),(1414,1049619622,1),(1414,1067155222,2),(1414,1081069222,1),(1414,1099209622,2),(1414,1112518822,1),(1414,1130659222,2),(1414,1143968423,1),(1414,1162108823,2),(1414,1173603623,1),(1414,1194163223,2),(1414,1205053223,1),(1414,1225612823,2),(1414,1236502824,1),(1414,1257062424,2),(1414,1268557224,1),(1414,1289116824,2),(1414,1300006824,1),(1414,1320566424,2),(1414,1331456424,1),(1414,1352016025,2),(1414,1362906025,1),(1414,1383465625,2),(1414,1394355625,1),(1414,1414915225,2),(1414,1425805225,1),(1414,1446364826,2),(1414,1457859626,1),(1414,1478419226,2),(1414,1489309227,1),(1414,1509868827,2),(1414,1520758827,1),(1414,1541318427,2),(1414,1552208427,1),(1414,1572768027,2),(1414,1583658027,1),(1414,1604217627,2),(1414,1615712427,1),(1414,1636272027,2),(1414,1647162027,1),(1414,1667721627,2),(1414,1678611627,1),(1414,1699171227,2),(1414,1710061227,1),(1414,1730620827,2),(1414,1741510827,1),(1414,1762070427,2),(1414,1772960427,1),(1414,1793520027,2),(1414,1805014827,1),(1414,1825574427,2),(1414,1836464427,1),(1414,1857024027,2),(1414,1867914027,1),(1414,1888473627,2),(1414,1899363627,1),(1414,1919923227,2),(1414,1930813227,1),(1414,1951372827,2),(1414,1962867627,1),(1414,1983427227,2),(1414,1994317227,1),(1414,2014876827,2),(1414,2025766827,1),(1414,2046326427,2),(1414,2057216427,1),(1414,2077776027,2),(1414,2088666027,1),(1414,2109225627,2),(1414,2120115627,1),(1414,2140675227,2),(1415,-2147483648,1),(1415,-880207200,2),(1415,-769395600,3),(1415,-765385200,1),(1415,-21477600,4),(1415,-5756400,1),(1415,9972000,4),(1415,25693200,1),(1415,41421600,4),(1415,57747600,1),(1415,73476000,4),(1415,89197201,1),(1415,104925602,4),(1415,120646802,1),(1415,126698403,4),(1415,152096403,1),(1415,162381604,4),(1415,183546004,1),(1415,199274405,4),(1415,215600405,1),(1415,230724006,4),(1415,247050006,1),(1415,262778407,4),(1415,278499607,1),(1415,294228008,4),(1415,309949208,1),(1415,325677609,4),(1415,341398809,1),(1415,357127209,4),(1415,372848410,1),(1415,388576810,4),(1415,404902811,1),(1415,420026411,4),(1415,436352412,5),(1415,439030812,7),(1415,452084412,6),(1415,467805612,7),(1415,483534012,6),(1415,499255213,7),(1415,514983613,6),(1415,530704813,7),(1415,544618813,6),(1415,562154413,7),(1415,576068414,6),(1415,594208814,7),(1415,607518014,6),(1415,625658414,7),(1415,638967615,6),(1415,657108015,7),(1415,671022016,6),(1415,688557616,7),(1415,702471616,6),(1415,720007217,7),(1415,733921217,6),(1415,752061618,7),(1415,765370818,6),(1415,783511219,7),(1415,796820419,6),(1415,814960819,7),(1415,828874820,6),(1415,846410420,7),(1415,860324420,6),(1415,877860021,7),(1415,891774021,6),(1415,909309621,7),(1415,923223622,6),(1415,941364022,7),(1415,954673222,6),(1415,972813622,7),(1415,986122822,6),(1415,1004263222,7),(1415,1018177222,6),(1415,1035712822,7),(1415,1049626822,6),(1415,1067162422,7),(1415,1081076422,6),(1415,1099216822,7),(1415,1112526022,6),(1415,1130666422,7),(1415,1143975623,6),(1415,1162116023,7),(1415,1173610823,6),(1415,1194170423,7),(1415,1205060423,6),(1415,1225620023,7),(1415,1236510024,6),(1415,1257069624,7),(1415,1268564424,6),(1415,1289124024,7),(1415,1300014024,6),(1415,1320573624,7),(1415,1331463624,6),(1415,1352023225,7),(1415,1362913225,6),(1415,1383472825,7),(1415,1394362825,6),(1415,1414922425,7),(1415,1425812425,6),(1415,1446372026,7),(1415,1457866826,6),(1415,1478426426,7),(1415,1489316427,6),(1415,1509876027,7),(1415,1520766027,6),(1415,1541325627,7),(1415,1552215627,6),(1415,1572775227,7),(1415,1583665227,6),(1415,1604224827,7),(1415,1615719627,6),(1415,1636279227,7),(1415,1647169227,6),(1415,1667728827,7),(1415,1678618827,6),(1415,1699178427,7),(1415,1710068427,6),(1415,1730628027,7),(1415,1741518027,6),(1415,1762077627,7),(1415,1772967627,6),(1415,1793527227,7),(1415,1805022027,6),(1415,1825581627,7),(1415,1836471627,6),(1415,1857031227,7),(1415,1867921227,6),(1415,1888480827,7),(1415,1899370827,6),(1415,1919930427,7),(1415,1930820427,6),(1415,1951380027,7),(1415,1962874827,6),(1415,1983434427,7),(1415,1994324427,6),(1415,2014884027,7),(1415,2025774027,6),(1415,2046333627,7),(1415,2057223627,6),(1415,2077783227,7),(1415,2088673227,6),(1415,2109232827,7),(1415,2120122827,6),(1415,2140682427,7),(1416,-2147483648,0),(1416,-1825098836,1),(1417,-2147483648,2),(1417,-1664130548,1),(1417,-1650137348,2),(1417,-1632076148,1),(1417,-1615145348,2),(1417,-1598650148,1),(1417,-1590100148,2),(1417,-1567286948,1),(1417,-1551565748,2),(1417,-1535837348,1),(1417,-1520116148,2),(1417,-1503782948,1),(1417,-1488666548,2),(1417,-1472333348,1),(1417,-1457216948,2),(1417,-1440883748,1),(1417,-1425767348,2),(1417,-1409434148,1),(1417,-1394317748,2),(1417,-1377984548,1),(1417,-1362263348,2),(1417,-1346534948,1),(1417,-1330813748,2),(1417,-1314480548,1),(1417,-1299364148,2),(1417,-1283030948,1),(1417,-1267914548,2),(1417,-1251581348,1),(1417,-1236464948,2),(1417,-1220131748,1),(1417,-1205015348,2),(1417,-1188682148,1),(1417,-1172960948,2),(1417,-1156627748,1),(1417,-1141511348,2),(1417,-1125178148,1),(1417,-1110061748,2),(1417,-1096921748,4),(1417,-1093728600,3),(1417,-1078612200,4),(1417,-1061670600,3),(1417,-1048973400,4),(1417,-1030221000,3),(1417,-1017523800,4),(1417,-998771400,3),(1417,-986074200,4),(1417,-966717000,3),(1417,-954624600,4),(1417,-935267400,3),(1417,-922570200,4),(1417,-903817800,3),(1417,-891120600,4),(1417,-872368200,6),(1417,-769395600,5),(1417,-765401400,4),(1417,-746044200,3),(1417,-733347000,4),(1417,-714594600,3),(1417,-701897400,4),(1417,-683145000,3),(1417,-670447800,4),(1417,-651695400,3),(1417,-638998200,4),(1417,-619641000,3),(1417,-606943800,4),(1417,-589401000,3),(1417,-576099000,4),(1417,-557951400,3),(1417,-544649400,4),(1417,-526501800,3),(1417,-513199800,4),(1417,-495052200,3),(1417,-481750200,4),(1417,-463602600,3),(1417,-450300600,4),(1417,-431548200,3),(1417,-418246200,4),(1417,-400098600,3),(1417,-386796600,4),(1417,-368649000,3),(1417,-355347000,4),(1417,-337199400,3),(1417,-323897400,4),(1417,-305749800,3),(1417,-289423800,4),(1417,-273695400,3),(1417,-257974200,4),(1417,-242245800,3),(1417,-226524600,4),(1417,-210796200,3),(1417,-195075000,4),(1417,-179346600,3),(1417,-163625400,4),(1417,-147897000,3),(1417,-131571000,4),(1417,-116447400,3),(1417,-100121400,4),(1417,-84393000,3),(1417,-68671800,4),(1417,-52943400,3),(1417,-37222200,4),(1417,-21493800,3),(1417,-5772600,4),(1417,9955800,3),(1417,25677000,4),(1417,41405400,3),(1417,57731400,4),(1417,73459800,3),(1417,89181001,4),(1417,104909402,3),(1417,120630602,4),(1417,136359003,3),(1417,152080203,4),(1417,167808604,3),(1417,183529804,4),(1417,199258205,3),(1417,215584205,4),(1417,230707806,3),(1417,247033806,4),(1417,262762207,3),(1417,278483407,4),(1417,294211808,3),(1417,309933008,4),(1417,325661409,3),(1417,341382609,4),(1417,357111009,3),(1417,372832210,4),(1417,388560610,3),(1417,404886611,4),(1417,420010211,3),(1417,436336212,4),(1417,452064612,3),(1417,467785812,4),(1417,483514212,3),(1417,499235413,4),(1417,514963813,3),(1417,530685013,4),(1417,544591873,3),(1417,562127473,4),(1417,576041474,7),(1417,594178274,4),(1417,607491074,3),(1417,625631474,4),(1417,638940675,3),(1417,657081075,4),(1417,670995076,3),(1417,688530676,4),(1417,702444676,3),(1417,719980277,4),(1417,733894277,3),(1417,752034678,4),(1417,765343878,3),(1417,783484279,4),(1417,796793479,3),(1417,814933879,4),(1417,828847880,3),(1417,846383480,4),(1417,860297480,3),(1417,877833081,4),(1417,891747081,3),(1417,909282681,4),(1417,923196682,3),(1417,941337082,4),(1417,954646282,3),(1417,972786682,4),(1417,986095882,3),(1417,1004236282,4),(1417,1018150282,3),(1417,1035685882,4),(1417,1049599882,3),(1417,1067135482,4),(1417,1081049482,3),(1417,1099189882,4),(1417,1112499082,3),(1417,1130639482,4),(1417,1143948683,3),(1417,1162089083,4),(1417,1173583883,3),(1417,1194143483,4),(1417,1205033483,3),(1417,1225593083,4),(1417,1236483084,3),(1417,1257042684,4),(1417,1268537484,3),(1417,1289097084,4),(1417,1299987084,3),(1417,1320553824,4),(1417,1331443824,3),(1417,1352003425,4),(1417,1362893425,3),(1417,1383453025,4),(1417,1394343025,3),(1417,1414902625,4),(1417,1425792625,3),(1417,1446352226,4),(1417,1457847026,3),(1417,1478406626,4),(1417,1489296627,3),(1417,1509856227,4),(1417,1520746227,3),(1417,1541305827,4),(1417,1552195827,3),(1417,1572755427,4),(1417,1583645427,3),(1417,1604205027,4),(1417,1615699827,3),(1417,1636259427,4),(1417,1647149427,3),(1417,1667709027,4),(1417,1678599027,3),(1417,1699158627,4),(1417,1710048627,3),(1417,1730608227,4),(1417,1741498227,3),(1417,1762057827,4),(1417,1772947827,3),(1417,1793507427,4),(1417,1805002227,3),(1417,1825561827,4),(1417,1836451827,3),(1417,1857011427,4),(1417,1867901427,3),(1417,1888461027,4),(1417,1899351027,3),(1417,1919910627,4),(1417,1930800627,3),(1417,1951360227,4),(1417,1962855027,3),(1417,1983414627,4),(1417,1994304627,3),(1417,2014864227,4),(1417,2025754227,3),(1417,2046313827,4),(1417,2057203827,3),(1417,2077763427,4),(1417,2088653427,3),(1417,2109213027,4),(1417,2120103027,3),(1417,2140662627,4),(1418,-2147483648,0),(1418,-1825098836,1),(1419,-2147483648,0),(1419,-1825098836,1),(1420,-2147483648,0),(1420,-1825098836,1),(1421,-2147483648,0),(1421,-1825098836,1),(1422,-2147483648,0),(1422,-2030201320,2),(1422,-1632063600,1),(1422,-1615132800,2),(1422,-880210800,3),(1422,-769395600,4),(1422,-765388800,2),(1422,-747241200,1),(1422,-732729600,2),(1422,-715791600,1),(1422,-702489600,2),(1422,-684342000,1),(1422,-671040000,2),(1422,-652892400,1),(1422,-639590400,2),(1422,-400086000,1),(1422,-384364800,2),(1422,-337186800,1),(1422,-321465600,2),(1422,-305737200,1),(1422,-292435200,2),(1422,-273682800,1),(1422,-260985600,2),(1422,73472400,5),(1423,-2147483648,0),(1423,-1538503868,2),(1423,547020013,1),(1423,559717213,2),(1423,578469614,1),(1423,591166814,2),(1423,1146981623,1),(1423,1154926823,2),(1424,-2147483648,0),(1424,-1686079492,2),(1424,670399216,1),(1424,686120416,2),(1424,701848816,1),(1424,717570017,2),(1424,733903217,1),(1424,752043618,2),(1424,765352818,1),(1424,783493219,2),(1424,796802419,1),(1424,814942819,2),(1424,828856820,1),(1424,846392420,2),(1424,860306420,1),(1424,877842021,2),(1424,891756021,1),(1424,909291621,2),(1424,923205622,1),(1424,941346022,2),(1424,954655222,1),(1424,972795622,2),(1424,986104822,1),(1424,1004245222,2),(1424,1018159222,1),(1424,1035694822,2),(1424,1049608822,1),(1424,1067144422,2),(1424,1081058422,1),(1424,1099198822,2),(1424,1112508022,1),(1424,1130648422,2),(1424,1143957623,1),(1424,1162098023,2),(1424,1173592823,1),(1424,1194152423,2),(1424,1205042423,1),(1424,1225602023,2),(1424,1236492024,1),(1424,1257051624,2),(1424,1268546424,1),(1424,1289106024,2),(1424,1299996024,1),(1424,1320555624,2),(1424,1331445624,1),(1424,1352005225,2),(1424,1362895225,1),(1424,1383454825,2),(1424,1394344825,1),(1424,1414904425,2),(1424,1425794425,1),(1424,1446354026,2),(1424,1457848826,1),(1424,1478408426,2),(1424,1489298427,1),(1424,1509858027,2),(1424,1520748027,1),(1424,1541307627,2),(1424,1552197627,1),(1424,1572757227,2),(1424,1583647227,1),(1424,1604206827,2),(1424,1615701627,1),(1424,1636261227,2),(1424,1647151227,1),(1424,1667710827,2),(1424,1678600827,1),(1424,1699160427,2),(1424,1710050427,1),(1424,1730610027,2),(1424,1741500027,1),(1424,1762059627,2),(1424,1772949627,1),(1424,1793509227,2),(1424,1805004027,1),(1424,1825563627,2),(1424,1836453627,1),(1424,1857013227,2),(1424,1867903227,1),(1424,1888462827,2),(1424,1899352827,1),(1424,1919912427,2),(1424,1930802427,1),(1424,1951362027,2),(1424,1962856827,1),(1424,1983416427,2),(1424,1994306427,1),(1424,2014866027,2),(1424,2025756027,1),(1424,2046315627,2),(1424,2057205627,1),(1424,2077765227,2),(1424,2088655227,1),(1424,2109214827,2),(1424,2120104827,1),(1424,2140664427,2),(1425,-2147483648,1),(1425,-1893434400,2),(1425,-880218000,3),(1425,-769395600,4),(1425,-765396000,2),(1425,9961200,5),(1425,25682400,2),(1425,41410800,5),(1425,57736800,2),(1425,73465200,5),(1425,89186401,2),(1425,136364403,5),(1425,152085603,2),(1425,167814004,5),(1425,183535204,2),(1425,199263605,5),(1425,215589605,2),(1425,230713206,5),(1425,247039206,2),(1425,262767607,5),(1425,278488807,2),(1425,294217208,5),(1425,309938408,2),(1425,325666809,5),(1425,341388009,2),(1425,357116409,5),(1425,372837610,2),(1425,388566010,5),(1425,404892011,2),(1425,420015611,5),(1425,436341612,2),(1425,452070012,5),(1425,467791212,2),(1425,483519612,5),(1425,499240813,2),(1425,514969213,5),(1425,530690413,2),(1425,544604413,5),(1425,562140013,2),(1425,576054014,5),(1425,594194414,2),(1425,607503614,5),(1425,625644014,2),(1425,638953215,5),(1425,657093615,2),(1425,671007616,5),(1425,688543216,2),(1425,702457216,5),(1425,719992817,2),(1425,733906817,5),(1425,752047218,2),(1425,765356418,5),(1425,783496819,2),(1425,796806019,5),(1425,814946419,2),(1425,828860420,5),(1425,846396020,2),(1425,860310020,5),(1425,877845621,2),(1425,891759621,5),(1425,909295221,2),(1425,923209222,5),(1425,941349622,2),(1425,954658822,5),(1425,972799222,2),(1425,986108422,5),(1425,1004248822,2),(1425,1018162822,5),(1425,1035698422,2),(1425,1049612422,5),(1425,1067148022,2),(1425,1081062022,5),(1425,1099202422,2),(1425,1112511622,5),(1425,1130652022,2),(1425,1143961223,5),(1425,1162101623,2),(1425,1173596423,5),(1425,1194156023,2),(1425,1205046023,5),(1425,1225605623,2),(1425,1236495624,5),(1425,1257055224,2),(1425,1268550024,5),(1425,1289109624,2),(1425,1299999624,5),(1425,1320559224,2),(1425,1331449224,5),(1425,1352008825,2),(1425,1362898825,5),(1425,1383458425,2),(1425,1394348425,5),(1425,1414908025,2),(1425,1425798025,5),(1425,1446357626,2),(1425,1457852426,5),(1425,1478412026,2),(1425,1489302027,5),(1425,1509861627,2),(1425,1520751627,5),(1425,1541311227,2),(1425,1552201227,5),(1425,1572760827,2),(1425,1583650827,5),(1425,1604210427,2),(1425,1615705227,5),(1425,1636264827,2),(1425,1647154827,5),(1425,1667714427,2),(1425,1678604427,5),(1425,1699164027,2),(1425,1710054027,5),(1425,1730613627,2),(1425,1741503627,5),(1425,1762063227,2),(1425,1772953227,5),(1425,1793512827,2),(1425,1805007627,5),(1425,1825567227,2),(1425,1836457227,5),(1425,1857016827,2),(1425,1867906827,5),(1425,1888466427,2),(1425,1899356427,5),(1425,1919916027,2),(1425,1930806027,5),(1425,1951365627,2),(1425,1962860427,5),(1425,1983420027,2),(1425,1994310027,5),(1425,2014869627,2),(1425,2025759627,5),(1425,2046319227,2),(1425,2057209227,5),(1425,2077768827,2),(1425,2088658827,5),(1425,2109218427,2),(1425,2120108427,5),(1425,2140668027,2),(1426,-2147483648,0),(1426,-1514736000,1),(1426,-1451667600,2),(1426,-1343062800,1),(1426,-1234803600,2),(1426,-1222963200,3),(1426,-1207242000,2),(1426,-873820800,4),(1426,-769395600,5),(1426,-761677200,2),(1426,-686073600,3),(1426,-661539600,2),(1426,-495039600,3),(1426,-481734000,2),(1426,-463590000,3),(1426,-450284400,2),(1426,-431535600,3),(1426,-418230000,2),(1426,-400086000,3),(1426,-386780400,2),(1426,-368636400,3),(1426,-355330800,2),(1426,-337186800,3),(1426,-323881200,2),(1426,-305737200,3),(1426,-292431600,2),(1426,199274405,3),(1426,215600405,2),(1426,230724006,3),(1426,247050006,2),(1426,262778407,3),(1426,278499607,2),(1426,294228008,3),(1426,309949208,2),(1426,325677609,3),(1426,341398809,2),(1426,357127209,3),(1426,372848410,2),(1426,388576810,3),(1426,404902811,2),(1426,420026411,3),(1426,436352412,2),(1426,452080812,3),(1426,467802012,2),(1426,483530412,3),(1426,499251613,2),(1426,514980013,3),(1426,530701213,2),(1426,544615213,3),(1426,562150813,2),(1426,576064814,3),(1426,594205214,2),(1426,607514414,3),(1426,625654814,2),(1426,638964015,3),(1426,657104415,2),(1426,671018416,3),(1426,688554016,2),(1426,702468016,3),(1426,720003617,2),(1426,733917617,3),(1426,752058018,2),(1426,765367218,3),(1426,783507619,2),(1426,796816819,3),(1426,814957219,2),(1426,828871220,3),(1426,846406820,2),(1426,860320820,3),(1426,877856421,2),(1426,891770421,3),(1426,909306021,2),(1426,923220022,3),(1426,941360422,2),(1426,954669622,3),(1426,972810022,2),(1426,986119222,3),(1426,1004259622,2),(1426,1018173622,3),(1426,1035709222,2),(1426,1049623222,3),(1426,1067158822,2),(1426,1081072822,3),(1426,1099213222,2),(1426,1112522422,3),(1426,1130662822,2),(1426,1143972023,3),(1426,1162112423,2),(1426,1175421623,3),(1426,1193562023,2),(1426,1207476023,3),(1426,1225011623,2),(1426,1238925624,3),(1426,1256461224,2),(1426,1268560824,3),(1426,1289120424,2),(1426,1300010424,3),(1426,1320570024,2),(1426,1331460024,3),(1426,1352019625,2),(1426,1362909625,3),(1426,1383469225,2),(1426,1394359225,3),(1426,1414918825,2),(1426,1425808825,3),(1426,1446368426,2),(1426,1457863226,3),(1426,1478422826,2),(1426,1489312827,3),(1426,1509872427,2),(1426,1520762427,3),(1426,1541322027,2),(1426,1552212027,3),(1426,1572771627,2),(1426,1583661627,3),(1426,1604221227,2),(1426,1615716027,3),(1426,1636275627,2),(1426,1647165627,3),(1426,1667725227,2),(1426,1678615227,3),(1426,1699174827,2),(1426,1710064827,3),(1426,1730624427,2),(1426,1741514427,3),(1426,1762074027,2),(1426,1772964027,3),(1426,1793523627,2),(1426,1805018427,3),(1426,1825578027,2),(1426,1836468027,3),(1426,1857027627,2),(1426,1867917627,3),(1426,1888477227,2),(1426,1899367227,3),(1426,1919926827,2),(1426,1930816827,3),(1426,1951376427,2),(1426,1962871227,3),(1426,1983430827,2),(1426,1994320827,3),(1426,2014880427,2),(1426,2025770427,3),(1426,2046330027,2),(1426,2057220027,3),(1426,2077779627,2),(1426,2088669627,3),(1426,2109229227,2),(1426,2120119227,3),(1426,2140678827,2),(1427,-2147483648,2),(1427,-1632070800,1),(1427,-1615140000,2),(1427,-1601753400,1),(1427,-1583697600,2),(1427,-1567357200,1),(1427,-1554667200,2),(1427,-1534698000,1),(1427,-1524074400,2),(1427,-1503248400,1),(1427,-1492365600,2),(1427,-1471798800,1),(1427,-1460916000,2),(1427,-1440954000,1),(1427,-1428861600,2),(1427,-1409504400,1),(1427,-1397412000,2),(1427,-1378054800,1),(1427,-1365962400,2),(1427,-1346605200,1),(1427,-1333908000,2),(1427,-1315155600,1),(1427,-1301853600,2),(1427,-1283706000,1),(1427,-1270404000,2),(1427,-1252256400,1),(1427,-1238954400,2),(1427,-1220806800,1),(1427,-1207504800,2),(1427,-1188752400,1),(1427,-1176055200,2),(1427,-1157302800,1),(1427,-1144000800,2),(1427,-1125853200,1),(1427,-1112551200,2),(1427,-1094403600,1),(1427,-1081101600,2),(1427,-1062954000,1),(1427,-1049652000,2),(1427,-1031504400,1),(1427,-1018202400,2),(1427,-1000054800,1),(1427,-986752800,2),(1427,-968000400,1),(1427,-955303200,2),(1427,-936550800,1),(1427,-880218000,3),(1427,-769395600,4),(1427,-765396000,2),(1427,-747248400,1),(1427,-733946400,2),(1427,-715806000,1),(1427,-702504000,2),(1427,-684356400,1),(1427,-671054400,2),(1427,-652906800,1),(1427,-634161600,2),(1427,-620845200,1),(1427,-602704800,2),(1427,-589395600,1),(1427,-576093600,2),(1427,-557946000,1),(1427,-544644000,2),(1427,-526496400,1),(1427,-513194400,2),(1427,-495046800,1),(1427,-481744800,2),(1427,-463597200,1),(1427,-450295200,2),(1427,-431542800,1),(1427,-418240800,2),(1427,-400093200,1),(1427,-384372000,2),(1427,-368643600,1),(1427,-352922400,2),(1427,-337194000,1),(1427,-321472800,2),(1427,-305744400,1),(1427,-289418400,2),(1427,-273690000,1),(1427,-257968800,2),(1427,-242240400,1),(1427,-226519200,2),(1427,-210790800,1),(1427,-195069600,2),(1427,-179341200,1),(1427,-163620000,2),(1427,-147891600,1),(1427,-131565600,2),(1427,-116442000,1),(1427,-100116000,2),(1427,-84387600,1),(1427,-68666400,2),(1427,-52938000,1),(1427,-37216800,2),(1427,-21488400,1),(1427,-5767200,2),(1427,9961200,1),(1427,25682400,2),(1427,41410800,1),(1427,57736800,2),(1427,73465200,1),(1427,89186401,2),(1427,104914802,1),(1427,120636002,2),(1427,136364403,1),(1427,152085603,2),(1427,167814004,1),(1427,183535204,2),(1427,199263605,1),(1427,215589605,2),(1427,230713206,1),(1427,247039206,2),(1427,262767607,1),(1427,278488807,2),(1427,294217208,1),(1427,309938408,2),(1427,325666809,1),(1427,341388009,2),(1427,357116409,1),(1427,372837610,2),(1427,388566010,1),(1427,404892011,2),(1427,420015611,1),(1427,436341612,2),(1427,452070012,1),(1427,467791212,2),(1427,483519612,1),(1427,499240813,2),(1427,514969213,1),(1427,530690413,2),(1427,544604413,1),(1427,562140013,2),(1427,576054014,1),(1427,594194414,2),(1427,607503614,1),(1427,625644014,2),(1427,638953215,1),(1427,657093615,2),(1427,671007616,1),(1427,688543216,2),(1427,702457216,1),(1427,719992817,2),(1427,733906817,1),(1427,752047218,2),(1427,765356418,1),(1427,783496819,2),(1427,796806019,1),(1427,814946419,2),(1427,828860420,1),(1427,846396020,2),(1427,860310020,1),(1427,877845621,2),(1427,891759621,1),(1427,909295221,2),(1427,923209222,1),(1427,941349622,2),(1427,954658822,1),(1427,972799222,2),(1427,986108422,1),(1427,1004248822,2),(1427,1018162822,1),(1427,1035698422,2),(1427,1049612422,1),(1427,1067148022,2),(1427,1081062022,1),(1427,1099202422,2),(1427,1112511622,1),(1427,1130652022,2),(1427,1143961223,1),(1427,1162101623,2),(1427,1173596423,1),(1427,1194156023,2),(1427,1205046023,1),(1427,1225605623,2),(1427,1236495624,1),(1427,1257055224,2),(1427,1268550024,1),(1427,1289109624,2),(1427,1299999624,1),(1427,1320559224,2),(1427,1331449224,1),(1427,1352008825,2),(1427,1362898825,1),(1427,1383458425,2),(1427,1394348425,1),(1427,1414908025,2),(1427,1425798025,1),(1427,1446357626,2),(1427,1457852426,1),(1427,1478412026,2),(1427,1489302027,1),(1427,1509861627,2),(1427,1520751627,1),(1427,1541311227,2),(1427,1552201227,1),(1427,1572760827,2),(1427,1583650827,1),(1427,1604210427,2),(1427,1615705227,1),(1427,1636264827,2),(1427,1647154827,1),(1427,1667714427,2),(1427,1678604427,1),(1427,1699164027,2),(1427,1710054027,1),(1427,1730613627,2),(1427,1741503627,1),(1427,1762063227,2),(1427,1772953227,1),(1427,1793512827,2),(1427,1805007627,1),(1427,1825567227,2),(1427,1836457227,1),(1427,1857016827,2),(1427,1867906827,1),(1427,1888466427,2),(1427,1899356427,1),(1427,1919916027,2),(1427,1930806027,1),(1427,1951365627,2),(1427,1962860427,1),(1427,1983420027,2),(1427,1994310027,1),(1427,2014869627,2),(1427,2025759627,1),(1427,2046319227,2),(1427,2057209227,1),(1427,2077768827,2),(1427,2088658827,1),(1427,2109218427,2),(1427,2120108427,1),(1427,2140668027,2),(1428,-2147483648,0),(1428,-1825098836,1),(1429,-2147483648,2),(1429,-1632060000,1),(1429,-1615129200,2),(1429,-880207200,3),(1429,-769395600,4),(1429,-765385200,2),(1429,-747237600,1),(1429,-732726000,2),(1429,-715788000,1),(1429,-702486000,2),(1429,-684338400,1),(1429,-671036400,2),(1429,-652888800,1),(1429,-639586800,2),(1429,-620834400,1),(1429,-608137200,2),(1429,-589384800,1),(1429,-576082800,2),(1429,-557935200,1),(1429,-544633200,2),(1429,-526485600,1),(1429,-513183600,2),(1429,-495036000,1),(1429,-481734000,2),(1429,-463586400,1),(1429,-450284400,2),(1429,-431532000,1),(1429,-418230000,2),(1429,-400082400,1),(1429,-386780400,2),(1429,-368632800,1),(1429,-355330800,2),(1429,-337183200,1),(1429,-323881200,2),(1429,-305733600,1),(1429,-292431600,2),(1429,-273679200,1),(1429,-260982000,2),(1429,-242229600,1),(1429,-226508400,2),(1429,-210780000,1),(1429,-195058800,2),(1429,-179330400,1),(1429,-163609200,2),(1429,-147880800,1),(1429,-131554800,2),(1429,-116431200,1),(1429,-100105200,2),(1429,-84376800,1),(1429,-68655600,2),(1429,-52927200,1),(1429,-37206000,2),(1429,-21477600,1),(1429,-5756400,2),(1429,9972000,1),(1429,25693200,2),(1429,41421600,1),(1429,57747600,2),(1429,73476000,1),(1429,89197201,2),(1429,104925602,1),(1429,120646802,2),(1429,136375203,1),(1429,152096403,2),(1429,167824804,1),(1429,183546004,2),(1429,199274405,1),(1429,215600405,2),(1429,230724006,1),(1429,247050006,2),(1429,262778407,1),(1429,278499607,2),(1429,294228008,1),(1429,309949208,2),(1429,325677609,1),(1429,341398809,2),(1429,357127209,1),(1429,372848410,2),(1429,388576810,1),(1429,404902811,2),(1429,420026411,1),(1429,436352412,2),(1429,452080812,1),(1429,467802012,2),(1429,483530412,1),(1429,499251613,2),(1429,514980013,1),(1429,530701213,2),(1429,544615213,1),(1429,562150813,2),(1429,576064814,1),(1429,594205214,2),(1429,607514414,1),(1429,625654814,2),(1429,638964015,1),(1429,657104415,2),(1429,671018416,1),(1429,688554016,2),(1429,702468016,1),(1429,720003617,2),(1429,733917617,1),(1429,752058018,2),(1429,765367218,1),(1429,783507619,2),(1429,796816819,1),(1429,814957219,2),(1429,828871220,1),(1429,846406820,2),(1429,860320820,1),(1429,877856421,2),(1429,891770421,1),(1429,909306021,2),(1429,923220022,1),(1429,941360422,2),(1429,954669622,1),(1429,972810022,2),(1429,986119222,1),(1429,1004259622,2),(1429,1018173622,1),(1429,1035709222,2),(1429,1049623222,1),(1429,1067158822,2),(1429,1081072822,1),(1429,1099213222,2),(1429,1112522422,1),(1429,1130662822,2),(1429,1143972023,1),(1429,1162112423,2),(1429,1173607223,1),(1429,1194166823,2),(1429,1205056823,1),(1429,1225616423,2),(1429,1236506424,1),(1429,1257066024,2),(1429,1268560824,1),(1429,1289120424,2),(1429,1300010424,1),(1429,1320570024,2),(1429,1331460024,1),(1429,1352019625,2),(1429,1362909625,1),(1429,1383469225,2),(1429,1394359225,1),(1429,1414918825,2),(1429,1425808825,1),(1429,1446368426,2),(1429,1457863226,1),(1429,1478422826,2),(1429,1489312827,1),(1429,1509872427,2),(1429,1520762427,1),(1429,1541322027,2),(1429,1552212027,1),(1429,1572771627,2),(1429,1583661627,1),(1429,1604221227,2),(1429,1615716027,1),(1429,1636275627,2),(1429,1647165627,1),(1429,1667725227,2),(1429,1678615227,1),(1429,1699174827,2),(1429,1710064827,1),(1429,1730624427,2),(1429,1741514427,1),(1429,1762074027,2),(1429,1772964027,1),(1429,1793523627,2),(1429,1805018427,1),(1429,1825578027,2),(1429,1836468027,1),(1429,1857027627,2),(1429,1867917627,1),(1429,1888477227,2),(1429,1899367227,1),(1429,1919926827,2),(1429,1930816827,1),(1429,1951376427,2),(1429,1962871227,1),(1429,1983430827,2),(1429,1994320827,1),(1429,2014880427,2),(1429,2025770427,1),(1429,2046330027,2),(1429,2057220027,1),(1429,2077779627,2),(1429,2088669627,1),(1429,2109229227,2),(1429,2120119227,1),(1429,2140678827,2),(1430,-2147483648,0),(1430,-1825098836,1),(1431,-2147483648,2),(1431,-1632056400,1),(1431,-1615125600,2),(1431,-1596978000,1),(1431,-1583164800,2),(1431,-880203600,3),(1431,-769395600,4),(1431,-765381600,2),(1431,-147884400,5),(1431,-131554800,2),(1431,-81961200,6),(1431,325677609,7),(1431,341398809,6),(1431,357127209,7),(1431,372848410,6),(1431,388576810,7),(1431,404902811,6),(1431,420026411,7),(1431,436352412,6),(1431,452080812,7),(1431,467802012,6),(1431,483530412,7),(1431,499251613,6),(1431,514980013,7),(1431,530701213,6),(1431,544615213,7),(1431,562150813,6),(1431,576064814,7),(1431,594205214,6),(1431,607514414,7),(1431,625654814,6),(1431,638964015,7),(1431,657104415,6),(1431,671018416,7),(1431,688554016,6),(1431,702468016,7),(1431,720003617,6),(1431,733917617,7),(1431,752058018,6),(1431,765367218,7),(1431,783507619,6),(1431,796816819,7),(1431,814957219,6),(1431,828871220,7),(1431,846406820,6),(1431,860320820,7),(1431,877856421,6),(1431,891770421,7),(1431,909306021,6),(1431,923220022,7),(1431,941360422,6),(1431,954669622,7),(1431,972810022,6),(1431,986119222,7),(1431,1004259622,6),(1431,1018173622,7),(1431,1035709222,6),(1431,1049623222,7),(1431,1067158822,6),(1431,1081072822,7),(1431,1099213222,6),(1431,1112522422,7),(1431,1130662822,6),(1431,1143972023,7),(1431,1162112423,6),(1431,1173607223,7),(1431,1194166823,6),(1431,1205056823,7),(1431,1225616423,6),(1431,1236506424,7),(1431,1257066024,6),(1431,1268560824,7),(1431,1289120424,6),(1431,1300010424,7),(1431,1320570024,6),(1431,1331460024,7),(1431,1352019625,6),(1431,1362909625,7),(1431,1383469225,6),(1431,1394359225,7),(1431,1414918825,6),(1431,1425808825,7),(1431,1446368426,6),(1431,1457863226,7),(1431,1478422826,6),(1431,1489312827,7),(1431,1509872427,6),(1431,1520762427,7),(1431,1541322027,6),(1431,1552212027,7),(1431,1572771627,6),(1431,1583661627,7),(1431,1604221227,6),(1431,1615716027,7),(1431,1636275627,6),(1431,1647165627,7),(1431,1667725227,6),(1431,1678615227,7),(1431,1699174827,6),(1431,1710064827,7),(1431,1730624427,6),(1431,1741514427,7),(1431,1762074027,6),(1431,1772964027,7),(1431,1793523627,6),(1431,1805018427,7),(1431,1825578027,6),(1431,1836468027,7),(1431,1857027627,6),(1431,1867917627,7),(1431,1888477227,6),(1431,1899367227,7),(1431,1919926827,6),(1431,1930816827,7),(1431,1951376427,6),(1431,1962871227,7),(1431,1983430827,6),(1431,1994320827,7),(1431,2014880427,6),(1431,2025770427,7),(1431,2046330027,6),(1431,2057220027,7),(1431,2077779627,6),(1431,2088669627,7),(1431,2109229227,6),(1431,2120119227,7),(1431,2140678827,6),(1432,-2147483648,2),(1432,-1694368800,1),(1432,-1681671600,2),(1432,-1632067200,1),(1432,-1615136400,2),(1432,-1029686400,1),(1432,-1018198800,2),(1432,-880214400,3),(1432,-769395600,4),(1432,-765392400,2),(1432,-746035200,1),(1432,-732733200,2),(1432,-715795200,1),(1432,-702493200,2),(1432,-684345600,1),(1432,-671043600,2),(1432,-652896000,1),(1432,-639594000,2),(1432,-620755200,1),(1432,-607626000,2),(1432,-589392000,1),(1432,-576090000,2),(1432,-557942400,1),(1432,-544640400,2),(1432,-526492800,1),(1432,-513190800,2),(1432,-495043200,1),(1432,-481741200,2),(1432,-463593600,1),(1432,-450291600,2),(1432,-431539200,1),(1432,-418237200,2),(1432,-400089600,1),(1432,-386787600,2),(1432,-368640000,1),(1432,-355338000,2),(1432,-337190400,1),(1432,-321469200,2),(1432,-305740800,1),(1432,-292438800,2),(1432,-210787200,1),(1432,-198090000,2),(1432,-116438400,5),(1432,-100108800,6),(1432,-84384000,5),(1432,-68659200,6),(1432,-52934400,5),(1432,-37209600,6),(1432,-21484800,5),(1432,-5760000,6),(1432,9964800,5),(1432,25689600,6),(1432,41414400,5),(1432,57744000,6),(1432,73468800,5),(1432,89193601,6),(1432,104918402,5),(1432,120643202,6),(1432,136368003,5),(1432,152092803,6),(1432,167817604,5),(1432,183542404,6),(1432,199267205,5),(1432,215596805,6),(1432,230716806,5),(1432,247046406,6),(1432,262771207,5),(1432,278496007,6),(1432,294220808,5),(1432,309945608,6),(1432,325670409,5),(1432,341395209,6),(1432,357120009,5),(1432,372844810,6),(1432,388569610,5),(1432,404899211,6),(1432,420019211,5),(1432,436348812,6),(1432,452073612,5),(1432,467798412,6),(1432,483523212,5),(1432,499248013,6),(1432,514972813,5),(1432,530697613,6),(1432,544608013,5),(1432,562147213,6),(1432,576057614,5),(1432,594201614,6),(1432,607507214,5),(1432,625651214,6),(1432,638956815,5),(1432,657100815,6),(1432,671011216,5),(1432,688550416,6),(1432,702460816,5),(1432,720000017,6),(1432,733910417,5),(1432,752054418,6),(1432,765360018,5),(1432,783504019,6),(1432,796809619,5),(1432,814953619,6),(1432,828864020,5),(1432,846403220,6),(1432,860313620,5),(1432,877852821,6),(1432,891763221,5),(1432,909302421,6),(1432,923212822,5),(1432,941356822,6),(1432,954662422,5),(1432,972806422,6),(1432,986112022,5),(1432,1004256022,6),(1432,1018166422,5),(1432,1035705622,6),(1432,1049616022,5),(1432,1067155222,6),(1432,1081065622,5),(1432,1099209622,6),(1432,1112515222,5),(1432,1130659222,6),(1432,1136095223,2),(1432,1143964823,1),(1432,1162105223,2),(1432,1173600023,1),(1432,1194159623,2),(1432,1205049623,1),(1432,1225609223,2),(1432,1236499224,1),(1432,1257058824,2),(1432,1268553624,1),(1432,1289113224,2),(1432,1300003224,1),(1432,1320562824,2),(1432,1331452824,1),(1432,1352012425,2),(1432,1362902425,1),(1432,1383462025,2),(1432,1394352025,1),(1432,1414911625,2),(1432,1425801625,1),(1432,1446361226,2),(1432,1457856026,1),(1432,1478415626,2),(1432,1489305627,1),(1432,1509865227,2),(1432,1520755227,1),(1432,1541314827,2),(1432,1552204827,1),(1432,1572764427,2),(1432,1583654427,1),(1432,1604214027,2),(1432,1615708827,1),(1432,1636268427,2),(1432,1647158427,1),(1432,1667718027,2),(1432,1678608027,1),(1432,1699167627,2),(1432,1710057627,1),(1432,1730617227,2),(1432,1741507227,1),(1432,1762066827,2),(1432,1772956827,1),(1432,1793516427,2),(1432,1805011227,1),(1432,1825570827,2),(1432,1836460827,1),(1432,1857020427,2),(1432,1867910427,1),(1432,1888470027,2),(1432,1899360027,1),(1432,1919919627,2),(1432,1930809627,1),(1432,1951369227,2),(1432,1962864027,1),(1432,1983423627,2),(1432,1994313627,1),(1432,2014873227,2),(1432,2025763227,1),(1432,2046322827,2),(1432,2057212827,1),(1432,2077772427,2),(1432,2088662427,1),(1432,2109222027,2),(1432,2120112027,1),(1432,2140671627,2),(1433,-2147483648,1),(1433,-880203600,2),(1433,-769395600,3),(1433,-765381600,1),(1433,-21474000,4),(1433,-5752800,1),(1433,9975600,4),(1433,25696800,1),(1433,41425200,4),(1433,57751200,1),(1433,73479600,4),(1433,89200801,1),(1433,104929202,4),(1433,120650402,1),(1433,126702003,4),(1433,152100003,1),(1433,162385204,4),(1433,183549604,1),(1433,199278005,4),(1433,215604005,1),(1433,230727606,4),(1433,247053606,1),(1433,262782007,4),(1433,278503207,1),(1433,294231608,4),(1433,309952808,1),(1433,325681209,4),(1433,341402409,1),(1433,357130809,4),(1433,372852010,1),(1433,388580410,4),(1433,404906411,1),(1433,420030011,4),(1433,436356012,1),(1433,439030812,6),(1433,452084412,5),(1433,467805612,6),(1433,483534012,5),(1433,499255213,6),(1433,514983613,5),(1433,530704813,6),(1433,544618813,5),(1433,562154413,6),(1433,576068414,5),(1433,594208814,6),(1433,607518014,5),(1433,625658414,6),(1433,638967615,5),(1433,657108015,6),(1433,671022016,5),(1433,688557616,6),(1433,702471616,5),(1433,720007217,6),(1433,733921217,5),(1433,752061618,6),(1433,765370818,5),(1433,783511219,6),(1433,796820419,5),(1433,814960819,6),(1433,828874820,5),(1433,846410420,6),(1433,860324420,5),(1433,877860021,6),(1433,891774021,5),(1433,909309621,6),(1433,923223622,5),(1433,941364022,6),(1433,954673222,5),(1433,972813622,6),(1433,986122822,5),(1433,1004263222,6),(1433,1018177222,5),(1433,1035712822,6),(1433,1049626822,5),(1433,1067162422,6),(1433,1081076422,5),(1433,1099216822,6),(1433,1112526022,5),(1433,1130666422,6),(1433,1143975623,5),(1433,1162116023,6),(1433,1173610823,5),(1433,1194170423,6),(1433,1205060423,5),(1433,1225620023,6),(1433,1236510024,5),(1433,1257069624,6),(1433,1268564424,5),(1433,1289124024,6),(1433,1300014024,5),(1433,1320573624,6),(1433,1331463624,5),(1433,1352023225,6),(1433,1362913225,5),(1433,1383472825,6),(1433,1394362825,5),(1433,1414922425,6),(1433,1425812425,5),(1433,1446372026,6),(1433,1457866826,5),(1433,1478426426,6),(1433,1489316427,5),(1433,1509876027,6),(1433,1520766027,5),(1433,1541325627,6),(1433,1552215627,5),(1433,1572775227,6),(1433,1583665227,5),(1433,1604224827,6),(1433,1615719627,5),(1433,1636279227,6),(1433,1647169227,5),(1433,1667728827,6),(1433,1678618827,5),(1433,1699178427,6),(1433,1710068427,5),(1433,1730628027,6),(1433,1741518027,5),(1433,1762077627,6),(1433,1772967627,5),(1433,1793527227,6),(1433,1805022027,5),(1433,1825581627,6),(1433,1836471627,5),(1433,1857031227,6),(1433,1867921227,5),(1433,1888480827,6),(1433,1899370827,5),(1433,1919930427,6),(1433,1930820427,5),(1433,1951380027,6),(1433,1962874827,5),(1433,1983434427,6),(1433,1994324427,5),(1433,2014884027,6),(1433,2025774027,5),(1433,2046333627,6),(1433,2057223627,5),(1433,2077783227,6),(1433,2088673227,5),(1433,2109232827,6),(1433,2120122827,5),(1433,2140682427,6),(1434,-2147483648,0),(1434,-1104537600,3),(1434,-880210800,1),(1434,-769395600,2),(1434,-765388800,3),(1434,-147891600,4),(1434,-131562000,3),(1434,325674009,5),(1434,341395209,3),(1434,357123609,5),(1434,372844810,3),(1434,388573210,5),(1434,404899211,3),(1434,420022811,5),(1434,436348812,3),(1434,452077212,5),(1434,467798412,3),(1434,483526812,5),(1434,499248013,3),(1434,514976413,5),(1434,530697613,3),(1434,544611613,5),(1434,562147213,3),(1434,576061214,5),(1434,594201614,3),(1434,607510814,5),(1434,625651214,3),(1434,638960415,5),(1434,657100815,3),(1434,671014816,5),(1434,688550416,3),(1434,702464416,5),(1434,720000017,3),(1434,733914017,5),(1434,752054418,3),(1434,765363618,5),(1434,783504019,3),(1434,796813219,5),(1434,814953619,3),(1434,828867620,5),(1434,846403220,3),(1434,860317220,5),(1434,877852821,3),(1434,891766821,5),(1434,909302421,3),(1434,923216422,5),(1434,941356822,3),(1434,954666022,5),(1434,972806422,3),(1434,986115622,5),(1434,1004256022,3),(1434,1018170022,5),(1434,1035705622,3),(1434,1049619622,5),(1434,1067155222,3),(1434,1081069222,5),(1434,1099209622,3),(1434,1112518822,5),(1434,1130659222,3),(1434,1143968423,5),(1434,1162108823,3),(1434,1173603623,5),(1434,1194163223,3),(1434,1205053223,5),(1434,1225612823,3),(1434,1236502824,5),(1434,1257062424,3),(1434,1268557224,5),(1434,1289116824,3),(1434,1300006824,5),(1434,1320566424,3),(1434,1331456424,5),(1434,1352016025,3),(1434,1362906025,5),(1434,1383465625,3),(1434,1394355625,5),(1434,1414915225,3),(1434,1425805225,5),(1434,1446364826,3),(1434,1457859626,5),(1434,1478419226,3),(1434,1489309227,5),(1434,1509868827,3),(1434,1520758827,5),(1434,1541318427,3),(1434,1552208427,5),(1434,1572768027,3),(1434,1583658027,5),(1434,1604217627,3),(1434,1615712427,5),(1434,1636272027,3),(1434,1647162027,5),(1434,1667721627,3),(1434,1678611627,5),(1434,1699171227,3),(1434,1710061227,5),(1434,1730620827,3),(1434,1741510827,5),(1434,1762070427,3),(1434,1772960427,5),(1434,1793520027,3),(1434,1805014827,5),(1434,1825574427,3),(1434,1836464427,5),(1434,1857024027,3),(1434,1867914027,5),(1434,1888473627,3),(1434,1899363627,5),(1434,1919923227,3),(1434,1930813227,5),(1434,1951372827,3),(1434,1962867627,5),(1434,1983427227,3),(1434,1994317227,5),(1434,2014876827,3),(1434,2025766827,5),(1434,2046326427,3),(1434,2057216427,5),(1434,2077776027,3),(1434,2088666027,5),(1434,2109225627,3),(1434,2120115627,5),(1434,2140675227,3),(1435,-2147483648,0),(1435,-31536000,1),(1435,1255802424,2),(1435,1267714824,1),(1435,1319738424,2),(1435,1329843624,3),(1435,1477065626,2),(1435,1520701227,1),(1436,-2147483648,0),(1436,-409190400,1),(1436,-163062000,0),(1436,-28857600,1),(1436,1255806024,2),(1436,1268251224,3),(1436,1319742024,2),(1436,1329854424,3),(1437,-2147483648,0),(1437,-725846400,1),(1437,-566992800,0),(1437,-415497600,1),(1438,-2147483648,1),(1438,-1680508800,2),(1438,-1665392400,1),(1438,-1601719200,3),(1438,-687052800,1),(1438,-71136000,4),(1438,-55411200,5),(1438,-37267200,4),(1438,-25776000,5),(1438,-5817600,4),(1438,5673600,5),(1438,25632000,4),(1438,37728000,5),(1438,57686400,4),(1438,67968000,5),(1438,89136001,4),(1438,100022402,5),(1438,120585602,4),(1438,131472003,5),(1438,152035203,4),(1438,162921604,5),(1438,183484804,4),(1438,194976005,5),(1438,215539205,4),(1438,226425606,5),(1438,246988806,4),(1438,257875207,5),(1438,278438407,4),(1438,289324808,5),(1438,309888008,4),(1438,320774409,5),(1438,341337609,4),(1438,352224009,5),(1438,372787210,4),(1438,386092810,5),(1438,404841611,4),(1438,417542411,5),(1438,436291212,4),(1438,447177612,5),(1438,467740812,4),(1438,478627212,5),(1438,499190413,4),(1438,510076813,5),(1438,530035213,4),(1438,542736013,5),(1438,562089613,4),(1438,574790414,5),(1438,594144014,4),(1438,606240014,5),(1438,625593614,4),(1438,637689615,5),(1438,657043215,4),(1438,670348816,5),(1438,686678416,4),(1438,701798416,5),(1438,718128017,4),(1438,733248017,5),(1438,749577618,4),(1438,764697618,5),(1438,781027219,4),(1438,796147219,5),(1438,812476819,4),(1438,828201620,5),(1438,844531220,4),(1438,859651220,5),(1438,875980821,4),(1438,891100821,5),(1438,907430421,4),(1438,922550422,5),(1438,938880022,4),(1438,954000022,5),(1438,967305622,4),(1438,985449622,5),(1438,1002384022,4),(1438,1017504022,5),(1438,1033833622,4),(1438,1048953622,5),(1438,1065283222,4),(1438,1080403222,5),(1438,1096732822,4),(1438,1111852822,5),(1438,1128182422,4),(1438,1143907223,5),(1438,1159632023,4),(1438,1174752023,5),(1438,1191686423,4),(1438,1207411223,5),(1438,1223136023,4),(1438,1238860824,5),(1438,1254585624,4),(1438,1270310424,6),(1439,-2147483648,0),(1439,-501206400,1),(1439,1255809624,2),(1440,-2147483648,2),(1440,-1330335000,1),(1440,-1320057000,2),(1440,-1300699800,3),(1440,-1287396000,2),(1440,-1269250200,3),(1440,-1255946400,2),(1440,-1237800600,3),(1440,-1224496800,2),(1440,-1206351000,3),(1440,-1192442400,2),(1440,-1174901400,3),(1440,-1160992800,2),(1440,-1143451800,3),(1440,-1125914400,2),(1440,-1112607000,3),(1440,-1094464800,2),(1440,-1081157400,3),(1440,-1063015200,2),(1440,-1049707800,3),(1440,-1031565600,2),(1440,-1018258200,3),(1440,-1000116000,2),(1440,-986808600,3),(1440,-968061600,2),(1440,-955359000,3),(1440,-936612000,2),(1440,-923304600,3),(1440,-757425600,6),(1440,152632803,4),(1440,162309604,5),(1440,183477604,4),(1440,194968805,5),(1440,215532005,4),(1440,226418406,5),(1440,246981606,4),(1440,257868007,5),(1440,278431207,4),(1440,289317608,5),(1440,309880808,4),(1440,320767209,5),(1440,341330409,4),(1440,352216809,5),(1440,372780010,4),(1440,384271210,5),(1440,404834411,4),(1440,415720811,5),(1440,436284012,4),(1440,447170412,5),(1440,467733612,4),(1440,478620012,5),(1440,499183213,4),(1440,510069613,5),(1440,530632813,4),(1440,541519213,5),(1440,562082413,4),(1440,573573614,5),(1440,594136814,4),(1440,605023214,5),(1440,623772014,4),(1440,637682415,5),(1440,655221615,4),(1440,669132016,5),(1440,686671216,4),(1440,700581616,5),(1440,718120817,4),(1440,732636017,5),(1440,749570418,4),(1440,764085618,5),(1440,781020019,4),(1440,795535219,5),(1440,812469619,4),(1440,826984820,5),(1440,844524020,4),(1440,858434420,5),(1440,875973621,4),(1440,889884021,5),(1440,907423221,4),(1440,921938422,5),(1440,938872822,4),(1440,953388022,5),(1440,970322422,4),(1440,984837622,5),(1440,1002376822,4),(1440,1016287222,5),(1440,1033826422,4),(1440,1047736822,5),(1440,1065276022,4),(1440,1079791222,5),(1440,1096725622,4),(1440,1111240822,5),(1440,1128175222,4),(1440,1142690423,5),(1440,1159624823,4),(1440,1174140023,5),(1440,1191074423,4),(1440,1207404023,5),(1440,1222524023,4),(1440,1238853624,5),(1440,1253973624,4),(1440,1270303224,5),(1440,1285423224,4),(1440,1301752824,5),(1440,1316872824,4),(1440,1333202424,5),(1440,1348927225,4),(1440,1365256825,5),(1440,1380376825,4),(1440,1396706425,5),(1440,1411826425,4),(1440,1428156025,5),(1440,1443276026,4),(1440,1459605626,5),(1440,1474725626,4),(1440,1491055227,5),(1440,1506175227,4),(1440,1522504827,5),(1440,1538229627,4),(1440,1554559227,5),(1440,1569679227,4),(1440,1586008827,5),(1440,1601128827,4),(1440,1617458427,5),(1440,1632578427,4),(1440,1648908027,5),(1440,1664028027,4),(1440,1680357627,5),(1440,1695477627,4),(1440,1712412027,5),(1440,1727532027,4),(1440,1743861627,5),(1440,1758981627,4),(1440,1775311227,5),(1440,1790431227,4),(1440,1806760827,5),(1440,1821880827,4),(1440,1838210427,5),(1440,1853330427,4),(1440,1869660027,5),(1440,1885384827,4),(1440,1901714427,5),(1440,1916834427,4),(1440,1933164027,5),(1440,1948284027,4),(1440,1964613627,5),(1440,1979733627,4),(1440,1996063227,5),(1440,2011183227,4),(1440,2027512827,5),(1440,2042632827,4),(1440,2058962427,5),(1440,2074687227,4),(1440,2091016827,5),(1440,2106136827,4),(1440,2122466427,5),(1440,2137586427,4),(1441,-2147483648,0),(1441,-157766400,2),(1441,-152658000,1),(1441,-132955200,2),(1441,-121122000,1),(1441,-101419200,2),(1441,-86821200,1),(1441,-71092800,2),(1441,-54766800,1),(1441,-39038400,2),(1441,-23317200,1),(1441,-7588800,4),(1441,128142003,3),(1441,136605603,4),(1441,389070010,1),(1441,403070411,5),(1441,416372411,6),(1441,434520012,5),(1441,447822012,6),(1441,466574412,5),(1441,479271612,6),(1441,498024013,5),(1441,510721213,6),(1441,529473613,5),(1441,545194813,6),(1441,560923213,5),(1441,574225214,6),(1441,592372814,5),(1441,605674814,6),(1441,624427214,5),(1441,637124415,6),(1441,653457615,5),(1441,668574016,6),(1441,687326416,5),(1441,700628416,6),(1441,718776017,5),(1441,732078017,6),(1441,750225618,5),(1441,763527618,6),(1441,781675219,5),(1441,794977219,6),(1441,813729619,5),(1441,826426820,6),(1441,845179220,5),(1441,859690820,6),(1441,876628821,5),(1441,889930821,6),(1441,906868821,5),(1441,923194822,6),(1441,939528022,5),(1441,952830022,6),(1441,971582422,5),(1441,984279622,6),(1441,1003032022,5),(1441,1015729222,6),(1441,1034481622,5),(1441,1047178822,6),(1441,1065931222,5),(1441,1079233222,6),(1441,1097380822,5),(1441,1110682822,6),(1441,1128830422,5),(1441,1142132423,6),(1441,1160884823,5),(1441,1173582023,6),(1441,1192334423,5),(1441,1206846023,6),(1441,1223784023,5),(1441,1237086024,6),(1441,1255233624,5),(1441,1270350024,6),(1441,1286683224,5),(1441,1304823624,6),(1441,1313899224,5),(1441,1335668424,6),(1441,1346558425,5),(1441,1367118025,6),(1441,1378612825,5),(1441,1398567625,6),(1441,1410062425,5),(1441,1463281226,6),(1441,1471147226,5),(1441,1480820426,4),(1442,-2147483648,0),(1442,218246405,1),(1443,-2147483648,2),(1443,-1330335000,1),(1443,-1320057000,2),(1443,-1300699800,3),(1443,-1287396000,2),(1443,-1269250200,3),(1443,-1255946400,2),(1443,-1237800600,3),(1443,-1224496800,2),(1443,-1206351000,3),(1443,-1192442400,2),(1443,-1174901400,3),(1443,-1160992800,2),(1443,-1143451800,3),(1443,-1125914400,2),(1443,-1112607000,3),(1443,-1094464800,2),(1443,-1081157400,3),(1443,-1063015200,2),(1443,-1049707800,3),(1443,-1031565600,2),(1443,-1018258200,3),(1443,-1000116000,2),(1443,-986808600,3),(1443,-968061600,2),(1443,-955359000,3),(1443,-936612000,2),(1443,-923304600,3),(1443,-757425600,6),(1443,152632803,4),(1443,162309604,5),(1443,183477604,4),(1443,194968805,5),(1443,215532005,4),(1443,226418406,5),(1443,246981606,4),(1443,257868007,5),(1443,278431207,4),(1443,289317608,5),(1443,309880808,4),(1443,320767209,5),(1443,341330409,4),(1443,352216809,5),(1443,372780010,4),(1443,384271210,5),(1443,404834411,4),(1443,415720811,5),(1443,436284012,4),(1443,447170412,5),(1443,467733612,4),(1443,478620012,5),(1443,499183213,4),(1443,510069613,5),(1443,530632813,4),(1443,541519213,5),(1443,562082413,4),(1443,573573614,5),(1443,594136814,4),(1443,605023214,5),(1443,623772014,4),(1443,637682415,5),(1443,655221615,4),(1443,669132016,5),(1443,686671216,4),(1443,700581616,5),(1443,718120817,4),(1443,732636017,5),(1443,749570418,4),(1443,764085618,5),(1443,781020019,4),(1443,795535219,5),(1443,812469619,4),(1443,826984820,5),(1443,844524020,4),(1443,858434420,5),(1443,875973621,4),(1443,889884021,5),(1443,907423221,4),(1443,921938422,5),(1443,938872822,4),(1443,953388022,5),(1443,970322422,4),(1443,984837622,5),(1443,1002376822,4),(1443,1016287222,5),(1443,1033826422,4),(1443,1047736822,5),(1443,1065276022,4),(1443,1079791222,5),(1443,1096725622,4),(1443,1111240822,5),(1443,1128175222,4),(1443,1142690423,5),(1443,1159624823,4),(1443,1174140023,5),(1443,1191074423,4),(1443,1207404023,5),(1443,1222524023,4),(1443,1238853624,5),(1443,1253973624,4),(1443,1270303224,5),(1443,1285423224,4),(1443,1301752824,5),(1443,1316872824,4),(1443,1333202424,5),(1443,1348927225,4),(1443,1365256825,5),(1443,1380376825,4),(1443,1396706425,5),(1443,1411826425,4),(1443,1428156025,5),(1443,1443276026,4),(1443,1459605626,5),(1443,1474725626,4),(1443,1491055227,5),(1443,1506175227,4),(1443,1522504827,5),(1443,1538229627,4),(1443,1554559227,5),(1443,1569679227,4),(1443,1586008827,5),(1443,1601128827,4),(1443,1617458427,5),(1443,1632578427,4),(1443,1648908027,5),(1443,1664028027,4),(1443,1680357627,5),(1443,1695477627,4),(1443,1712412027,5),(1443,1727532027,4),(1443,1743861627,5),(1443,1758981627,4),(1443,1775311227,5),(1443,1790431227,4),(1443,1806760827,5),(1443,1821880827,4),(1443,1838210427,5),(1443,1853330427,4),(1443,1869660027,5),(1443,1885384827,4),(1443,1901714427,5),(1443,1916834427,4),(1443,1933164027,5),(1443,1948284027,4),(1443,1964613627,5),(1443,1979733627,4),(1443,1996063227,5),(1443,2011183227,4),(1443,2027512827,5),(1443,2042632827,4),(1443,2058962427,5),(1443,2074687227,4),(1443,2091016827,5),(1443,2106136827,4),(1443,2122466427,5),(1443,2137586427,4),(1444,-2147483648,0),(1444,-407808000,1),(1445,-2147483648,0),(1445,1108166422,3),(1445,1111885222,1),(1445,1130634022,2),(1445,1143334823,1),(1445,1162083623,2),(1445,1174784423,1),(1445,1193533223,2),(1445,1206838823,1),(1445,1224982823,2),(1445,1238288424,1),(1445,1256432424,2),(1445,1269738024,1),(1445,1288486824,2),(1445,1301187624,1),(1445,1319936424,2),(1445,1332637224,1),(1445,1351386025,2),(1445,1364691625,1),(1445,1382835625,2),(1445,1396141225,1),(1445,1414285225,2),(1445,1427590825,1),(1445,1445734826,2),(1445,1459040426,1),(1445,1477789226,2),(1445,1490490027,1),(1445,1509238827,2),(1445,1521939627,1),(1445,1540688427,2),(1445,1553994027,1),(1445,1572138027,2),(1445,1585443627,1),(1445,1603587627,2),(1445,1616893227,1),(1445,1635642027,2),(1445,1648342827,1),(1445,1667091627,2),(1445,1679792427,1),(1445,1698541227,2),(1445,1711846827,1),(1445,1729990827,2),(1445,1743296427,1),(1445,1761440427,2),(1445,1774746027,1),(1445,1792890027,2),(1445,1806195627,1),(1445,1824944427,2),(1445,1837645227,1),(1445,1856394027,2),(1445,1869094827,1),(1445,1887843627,2),(1445,1901149227,1),(1445,1919293227,2),(1445,1932598827,1),(1445,1950742827,2),(1445,1964048427,1),(1445,1982797227,2),(1445,1995498027,1),(1445,2014246827,2),(1445,2026947627,1),(1445,2045696427,2),(1445,2058397227,1),(1445,2077146027,2),(1445,2090451627,1),(1445,2108595627,2),(1445,2121901227,1),(1445,2140045227,2),(1446,-2147483648,0),(1446,-380073600,1),(1447,-2147483648,2),(1447,-1691884800,1),(1447,-1680573600,2),(1447,-927511200,1),(1447,-857257200,3),(1447,-844556400,4),(1447,-828226800,3),(1447,-812502000,4),(1447,-796777200,3),(1447,-781052400,4),(1447,-765327600,3),(1447,-340844400,4),(1447,-324514800,3),(1447,-308790000,4),(1447,-293065200,3),(1447,-277340400,4),(1447,-261615600,3),(1447,-245890800,4),(1447,-230166000,3),(1447,-214441200,4),(1447,-198716400,3),(1447,-182991600,4),(1447,-166662000,3),(1447,-147913200,4),(1447,-135212400,3),(1447,315529208,2),(1447,323830809,5),(1447,338950809,6),(1447,354675609,5),(1447,370400410,6),(1447,386125210,5),(1447,401850011,6),(1447,417574811,5),(1447,433299612,6),(1447,449024412,5),(1447,465354012,6),(1447,481078812,5),(1447,496803613,6),(1447,512528413,5),(1447,528253213,6),(1447,543978013,5),(1447,559702813,6),(1447,575427614,5),(1447,591152414,6),(1447,606877214,5),(1447,622602014,6),(1447,638326815,5),(1447,654656415,6),(1447,670381216,5),(1447,686106016,6),(1447,701830816,5),(1447,717555617,6),(1447,733280417,5),(1447,749005218,6),(1447,764730018,5),(1447,780454819,6),(1447,796179619,5),(1447,811904419,6),(1447,828234020,5),(1447,846378020,6),(1447,859683620,5),(1447,877827621,6),(1447,891133221,5),(1447,909277221,6),(1447,922582822,5),(1447,941331622,6),(1447,954032422,5),(1447,972781222,6),(1447,985482022,5),(1447,1004230822,6),(1447,1017536422,5),(1447,1035680422,6),(1447,1048986022,5),(1447,1067130022,6),(1447,1080435622,5),(1447,1099184422,6),(1447,1111885222,5),(1447,1130634022,6),(1447,1143334823,5),(1447,1162083623,6),(1447,1174784423,5),(1447,1193533223,6),(1447,1206838823,5),(1447,1224982823,6),(1447,1238288424,5),(1447,1256432424,6),(1447,1269738024,5),(1447,1288486824,6),(1447,1301187624,5),(1447,1319936424,6),(1447,1332637224,5),(1447,1351386025,6),(1447,1364691625,5),(1447,1382835625,6),(1447,1396141225,5),(1447,1414285225,6),(1447,1427590825,5),(1447,1445734826,6),(1447,1459040426,5),(1447,1477789226,6),(1447,1490490027,5),(1447,1509238827,6),(1447,1521939627,5),(1447,1540688427,6),(1447,1553994027,5),(1447,1572138027,6),(1447,1585443627,5),(1447,1603587627,6),(1447,1616893227,5),(1447,1635642027,6),(1447,1648342827,5),(1447,1667091627,6),(1447,1679792427,5),(1447,1698541227,6),(1447,1711846827,5),(1447,1729990827,6),(1447,1743296427,5),(1447,1761440427,6),(1447,1774746027,5),(1447,1792890027,6),(1447,1806195627,5),(1447,1824944427,6),(1447,1837645227,5),(1447,1856394027,6),(1447,1869094827,5),(1447,1887843627,6),(1447,1901149227,5),(1447,1919293227,6),(1447,1932598827,5),(1447,1950742827,6),(1447,1964048427,5),(1447,1982797227,6),(1447,1995498027,5),(1447,2014246827,6),(1447,2026947627,5),(1447,2045696427,6),(1447,2058397227,5),(1447,2077146027,6),(1447,2090451627,5),(1447,2108595627,6),(1447,2121901227,5),(1447,2140045227,6),(1448,-2147483648,0),(1448,-719636812,1),(1449,-2147483648,0),(1449,-1441170468,1),(1449,-1247547600,3),(1449,354909609,2),(1449,370717210,3),(1449,386445610,2),(1449,402253211,3),(1449,417981611,2),(1449,433789212,3),(1449,449604012,2),(1449,465336012,4),(1449,481060812,5),(1449,496785613,4),(1449,512510413,5),(1449,528235213,4),(1449,543960013,5),(1449,559684813,4),(1449,575409614,5),(1449,591134414,4),(1449,606859214,5),(1449,622584014,4),(1449,638308815,5),(1449,654638415,4),(1449,670363216,6),(1449,686091616,7),(1449,695768416,4),(1449,701812816,5),(1449,717537617,4),(1449,733262417,5),(1449,748987218,4),(1449,764712018,5),(1449,780436819,4),(1449,796161619,5),(1449,811886419,4),(1449,828216020,5),(1449,846360020,4),(1449,859665620,5),(1449,877809621,4),(1449,891115221,5),(1449,909259221,4),(1449,922564822,5),(1449,941313622,4),(1449,954014422,5),(1449,972763222,4),(1449,985464022,5),(1449,1004212822,4),(1449,1017518422,5),(1449,1035662422,4),(1449,1048968022,5),(1449,1067112022,4),(1449,1080417622,5),(1449,1099166422,4),(1450,-2147483648,0),(1450,-1230776624,2),(1450,108165602,1),(1450,118270802,2),(1450,136591203,1),(1450,149806803,2),(1450,168127204,1),(1450,181342804,2),(1450,199749605,1),(1450,215643605,2),(1450,231285606,1),(1450,244501206,2),(1450,262735207,1),(1450,275950807,2),(1450,481154412,1),(1450,496962013,2),(1450,512949613,1),(1450,528670813,2),(1450,544399213,1),(1450,560120413,2),(1450,575848814,1),(1450,592174814,2),(1450,610581614,1),(1450,623624414,2),(1450,641167215,1),(1450,655074015,2),(1450,671839216,1),(1450,685918816,2),(1450,702856816,1),(1450,717973217,2),(1450,733701617,1),(1450,749422818,2),(1450,765151218,1),(1450,779662819,2),(1450,797205619,1),(1450,811116019,3),(1450,828655220,1),(1450,843170420,3),(1450,860104820,1),(1450,874620021,3),(1450,891554421,1),(1450,906069621,3),(1450,930780022,4),(1450,938124022,3),(1450,954367222,4),(1450,970178422,3),(1450,985816822,4),(1450,1001628022,3),(1450,1017352822,1),(1450,1033077622,3),(1450,1048802422,1),(1450,1066946422,3),(1450,1080252022,1),(1450,1097791222,3),(1450,1112306422,1),(1450,1128031222,3),(1450,1143756023,1),(1450,1161900023,3),(1450,1175205623,1),(1450,1193349623,3),(1450,1206655223,1),(1450,1225404023,3),(1450,1238104824,1),(1450,1256853624,3),(1450,1269554424,1),(1450,1288303224,3),(1450,1301608824,1),(1450,1319752824,3),(1450,1333058424,1),(1450,1387486825,2),(1450,1395957625,1),(1450,1414706425,3),(1450,1427407225,1),(1450,1446156026,3),(1450,1459461626,1),(1450,1477605626,3),(1450,1490911227,1),(1450,1509055227,3),(1450,1522360827,1),(1450,1540504827,3),(1450,1553810427,1),(1450,1571954427,3),(1450,1585260027,1),(1450,1604008827,3),(1450,1616709627,1),(1450,1635458427,3),(1450,1648764027,1),(1450,1666908027,3),(1450,1680213627,1),(1450,1698357627,3),(1450,1711663227,1),(1450,1729807227,3),(1450,1743112827,1),(1450,1761861627,3),(1450,1774562427,1),(1450,1793311227,3),(1450,1806012027,1),(1450,1824760827,3),(1450,1838066427,1),(1450,1856210427,3),(1450,1869516027,1),(1450,1887660027,3),(1450,1900965627,1),(1450,1919109627,3),(1450,1932415227,1),(1450,1951164027,3),(1450,1963864827,1),(1450,1982613627,3),(1450,1995919227,1),(1450,2014063227,3),(1450,2027368827,1),(1450,2045512827,3),(1450,2058818427,1),(1450,2076962427,3),(1450,2090268027,1),(1450,2109016827,3),(1450,2121717627,1),(1450,2140466427,3),(1451,-2147483648,0),(1451,-1441194596,1),(1451,-1247572800,3),(1451,354884409,2),(1451,370692010,3),(1451,386420410,4),(1451,402231611,1),(1451,417960011,4),(1451,433767612,1),(1451,449582412,4),(1451,465314412,5),(1451,481039212,6),(1451,496764013,5),(1451,512488813,6),(1451,528213613,5),(1451,543938413,6),(1451,559663213,5),(1451,575388014,6),(1451,591112814,5),(1451,606837614,6),(1451,622562414,5),(1451,638287215,6),(1451,654616815,5),(1451,670341616,7),(1451,686070016,8),(1451,695746816,5),(1451,701791216,6),(1451,717516017,5),(1451,733240817,6),(1451,748965618,5),(1451,764690418,6),(1451,780415219,5),(1451,796140019,6),(1451,811864819,5),(1451,828194420,6),(1451,846338420,5),(1451,859644020,6),(1451,877788021,5),(1451,891093621,6),(1451,909237621,5),(1451,922543222,6),(1451,941292022,5),(1451,953992822,6),(1451,972741622,5),(1451,985442422,6),(1451,1004191222,5),(1451,1017496822,6),(1451,1035640822,5),(1451,1048946422,6),(1451,1067090422,5),(1451,1080396022,6),(1451,1099144822,5),(1451,1111845622,6),(1451,1130594422,5),(1451,1143295223,6),(1451,1162044023,5),(1451,1174744823,6),(1451,1193493623,5),(1451,1206799223,6),(1451,1224943223,5),(1451,1238248824,6),(1451,1256392824,5),(1451,1269698424,7),(1451,1288450824,8),(1451,1301151624,5),(1452,-2147483648,0),(1452,-1441164064,1),(1452,-1247544000,2),(1452,370724410,3),(1452,386445610,4),(1452,402256811,2),(1452,417985211,4),(1452,433792812,2),(1452,449607612,4),(1452,465339612,5),(1452,481064412,6),(1452,496789213,5),(1452,512514013,6),(1452,528238813,5),(1452,543963613,6),(1452,559688413,5),(1452,575413214,6),(1452,591138014,5),(1452,606862814,6),(1452,622587614,5),(1452,638312415,6),(1452,654642015,5),(1452,670366816,7),(1452,686095216,8),(1452,695772016,5),(1452,701816416,6),(1452,717541217,5),(1452,733266017,6),(1452,748990818,5),(1452,764715618,6),(1452,780440419,8),(1452,796168819,7),(1452,811893619,8),(1452,828223220,7),(1452,846367220,8),(1452,859672820,7),(1452,877816821,8),(1452,891122421,7),(1452,909266421,8),(1452,922572022,7),(1452,941320822,8),(1452,954021622,7),(1452,972770422,8),(1452,985471222,7),(1452,1004220022,8),(1452,1017525622,7),(1452,1035669622,8),(1452,1048975222,7),(1452,1067119222,8),(1452,1080424822,7),(1452,1099173622,5),(1453,-2147483648,0),(1453,-1441165720,1),(1453,-1247544000,2),(1453,354913209,3),(1453,370720810,4),(1453,386445610,3),(1453,402256811,2),(1453,417985211,3),(1453,433792812,2),(1453,449607612,3),(1453,465339612,5),(1453,481064412,6),(1453,496789213,5),(1453,512514013,6),(1453,528238813,5),(1453,543963613,6),(1453,559688413,5),(1453,575413214,6),(1453,591138014,5),(1453,606862814,6),(1453,622587614,5),(1453,638312415,6),(1453,654642015,5),(1453,670366816,7),(1453,686095216,8),(1453,695772016,5),(1453,701816416,6),(1453,717541217,5),(1453,733266017,6),(1453,748990818,5),(1453,764715618,6),(1453,780440419,5),(1453,796165219,6),(1453,811890019,5),(1453,828219620,6),(1453,846363620,5),(1453,859669220,6),(1453,877813221,5),(1453,891118821,6),(1453,909262821,5),(1453,922568422,6),(1453,941317222,5),(1453,954018022,6),(1453,972766822,5),(1453,985467622,6),(1453,1004216422,5),(1453,1017522022,6),(1453,1035666022,5),(1453,1048971622,6),(1453,1067115622,5),(1453,1080421222,6),(1453,1099170022,5),(1454,-2147483648,0),(1454,-1441166012,1),(1454,-1247544000,3),(1454,354913209,2),(1454,370720810,3),(1454,386449210,2),(1454,402256811,3),(1454,417985211,2),(1454,433792812,3),(1454,449607612,2),(1454,465339612,4),(1454,481064412,5),(1454,496789213,4),(1454,512514013,5),(1454,528238813,4),(1454,543963613,5),(1454,559688413,4),(1454,575413214,5),(1454,591138014,4),(1454,606862814,5),(1454,622587614,4),(1454,638312415,5),(1454,654642015,4),(1454,670366816,6),(1454,686095216,7),(1454,695772016,3),(1455,-2147483648,0),(1455,-1441166012,1),(1455,-1247544000,3),(1455,354913209,2),(1455,370720810,3),(1455,386449210,2),(1455,402256811,3),(1455,417985211,2),(1455,433792812,3),(1455,449607612,2),(1455,465339612,4),(1455,481064412,5),(1455,496789213,4),(1455,512514013,5),(1455,528238813,4),(1455,543963613,5),(1455,559688413,4),(1455,575413214,5),(1455,591138014,4),(1455,606862814,5),(1455,622587614,4),(1455,638312415,5),(1455,654642015,4),(1455,670366816,6),(1455,686095216,7),(1455,695772016,3),(1456,-2147483648,0),(1456,-1441164464,1),(1456,-1247540400,2),(1456,370724410,3),(1456,386445610,4),(1456,402256811,2),(1456,417985211,4),(1456,433792812,2),(1456,449607612,4),(1456,465339612,5),(1456,481064412,6),(1456,496789213,5),(1456,512514013,6),(1456,528238813,5),(1456,543963613,6),(1456,559688413,5),(1456,575413214,6),(1456,591138014,5),(1456,606862814,6),(1456,622587614,5),(1456,638312415,6),(1456,654642015,5),(1456,670366816,7),(1456,686095216,8),(1456,695772016,5),(1456,701816416,6),(1456,717541217,5),(1456,733266017,6),(1456,748990818,5),(1456,764715618,6),(1456,780440419,5),(1456,796165219,6),(1456,811890019,5),(1456,828219620,6),(1456,846363620,5),(1456,859669220,6),(1456,877813221,5),(1456,891118821,6),(1456,909262821,5),(1456,922568422,7),(1456,941320822,8),(1456,954021622,7),(1456,972770422,8),(1456,985471222,7),(1456,1004220022,8),(1456,1017525622,7),(1456,1035669622,8),(1456,1048975222,7),(1456,1067119222,8),(1456,1080424822,7),(1456,1099173622,5),(1457,-2147483648,1),(1457,-1641005856,2),(1457,389048410,3),(1457,402264011,2),(1457,417906011,3),(1457,433800012,2),(1457,449614812,3),(1457,465422412,2),(1457,481150812,3),(1457,496792813,4),(1457,512517613,5),(1457,528242413,4),(1457,543967213,5),(1457,559692013,4),(1457,575416814,5),(1457,591141614,4),(1457,606866414,5),(1457,622591214,4),(1457,638316015,5),(1457,654645615,4),(1457,670464016,5),(1457,686275216,4),(1457,702086416,5),(1457,717897617,4),(1457,733622417,5),(1457,749433618,4),(1457,765158418,5),(1457,780969619,4),(1457,796694419,5),(1457,812505619,4),(1457,828316820,5),(1457,844128020,4),(1457,859852820,5),(1457,875664021,4),(1457,891388821,5),(1457,907200021,4),(1457,922924822,5),(1457,938736022,4),(1457,954547222,5),(1457,970358422,4),(1457,986083222,5),(1457,1001894422,4),(1457,1017619222,5),(1457,1033430422,4),(1457,1049155222,5),(1457,1064966422,4),(1457,1080777622,5),(1457,1096588822,4),(1457,1112313622,5),(1457,1128124822,4),(1457,1143849623,5),(1457,1159660823,4),(1457,1175385623,5),(1457,1191196823,4),(1458,-2147483648,0),(1458,-1577935568,1),(1458,76190400,2),(1459,-2147483648,0),(1459,-1441163964,1),(1459,-405140400,3),(1459,354916809,2),(1459,370724410,3),(1459,386452810,2),(1459,402260411,3),(1459,417988811,2),(1459,433796412,3),(1459,449611212,2),(1459,465343212,4),(1459,481068012,5),(1459,496792813,4),(1459,512517613,5),(1459,528242413,4),(1459,543967213,5),(1459,559692013,4),(1459,575416814,5),(1459,591141614,4),(1459,606866414,5),(1459,622591214,4),(1459,638316015,5),(1459,654645615,4),(1459,670370416,6),(1459,686098816,7),(1459,701823616,6),(1459,717548417,4),(1459,820440019,3),(1459,828234020,8),(1459,846378020,9),(1459,852062420,3),(1459,859680020,2),(1459,877824021,3),(1459,891129621,2),(1459,909273621,3),(1459,922579222,2),(1459,941328022,3),(1459,954028822,2),(1459,972777622,3),(1459,985478422,2),(1459,1004227222,3),(1459,1017532822,2),(1459,1035676822,3),(1459,1048982422,2),(1459,1067126422,3),(1459,1080432022,2),(1459,1099180822,3),(1459,1111881622,2),(1459,1130630422,3),(1459,1143331223,2),(1459,1162080023,3),(1459,1174780823,2),(1459,1193529623,3),(1459,1206835223,2),(1459,1224979223,3),(1459,1238284824,2),(1459,1256428824,3),(1459,1269734424,2),(1459,1288483224,3),(1459,1301184024,2),(1459,1319932824,3),(1459,1332633624,2),(1459,1351382425,3),(1459,1364688025,2),(1459,1382832025,3),(1459,1396137625,2),(1459,1414281625,3),(1459,1427587225,2),(1459,1445731226,3),(1460,-2147483648,1),(1460,-1570084924,2),(1461,-2147483648,0),(1461,-1579844100,1),(1461,-1247551200,3),(1461,354906009,2),(1461,370713610,3),(1461,386442010,2),(1461,402249611,3),(1461,417978011,2),(1461,433785612,3),(1461,449600412,2),(1461,465332412,4),(1461,481057212,5),(1461,496782013,4),(1461,512506813,5),(1461,528231613,4),(1461,543956413,5),(1461,559681213,4),(1461,575406014,5),(1461,591130814,4),(1461,606855614,5),(1461,622580414,4),(1461,638305215,5),(1461,654634815,4),(1461,670359616,6),(1461,686088016,7),(1461,695764816,4),(1461,701809216,5),(1461,717534017,4),(1461,733258817,5),(1461,748983618,4),(1461,764708418,5),(1461,780433219,4),(1461,796158019,5),(1461,801590419,8),(1461,811886419,7),(1461,828216020,6),(1461,846360020,7),(1461,859665620,6),(1461,877809621,7),(1461,891115221,6),(1461,909259221,7),(1461,922564822,6),(1461,941313622,7),(1461,954014422,6),(1461,972763222,7),(1461,985464022,6),(1461,1004212822,7),(1461,1017518422,6),(1461,1035662422,7),(1461,1048968022,6),(1461,1067112022,7),(1461,1080417622,6),(1461,1099166422,7),(1461,1111867222,6),(1461,1130616022,7),(1461,1143316823,6),(1461,1162065623,7),(1461,1174766423,6),(1461,1193515223,7),(1461,1206820823,6),(1461,1224964823,7),(1461,1238270424,6),(1461,1256414424,7),(1461,1269720024,6),(1461,1288468824,7),(1461,1301169624,4),(1461,1414263625,7),(1461,1459022426,4),(1462,-2147483648,2),(1462,-1570413600,1),(1462,-1552186800,2),(1462,-1538359200,1),(1462,-1522551600,2),(1462,-1507514400,1),(1462,-1490583600,2),(1462,-1473645600,1),(1462,-1460948400,2),(1462,-399866400,1),(1462,-386650800,2),(1462,-368330400,1),(1462,-355114800,2),(1462,-336794400,1),(1462,-323578800,2),(1462,-305172000,1),(1462,-291956400,2),(1462,-273636000,1),(1462,-260420400,2),(1462,78012000,1),(1462,86734801,2),(1462,105055202,1),(1462,118270802,2),(1462,136591203,1),(1462,149806803,2),(1462,168127204,1),(1462,181342804,2),(1462,199749605,1),(1462,212965205,2),(1462,231285606,1),(1462,244501206,2),(1462,262735207,1),(1462,275950807,2),(1462,452210412,1),(1462,466722012,2),(1462,483746412,1),(1462,498258013,2),(1462,515282413,1),(1462,529794013,2),(1462,546818413,1),(1462,561330013,2),(1462,581119214,1),(1462,592952414,2),(1462,610754414,1),(1462,624488414,2),(1462,641512815,1),(1462,656024415,2),(1462,673048816,1),(1462,687560416,2),(1462,704671216,1),(1462,718146017,2),(1462,733269617,1),(1462,748990818,2),(1462,764719218,1),(1462,780440419,2),(1462,796168819,1),(1462,811890019,2),(1462,828223220,1),(1462,843944420,2),(1462,859672820,1),(1462,875394021,2),(1462,891122421,1),(1462,906843621,2),(1462,922572022,1),(1462,941317222,2),(1462,954021622,1),(1462,972766822,2),(1462,985471222,1),(1462,1004216422,2),(1462,1017525622,1),(1462,1035666022,2),(1462,1048975222,1),(1462,1067115622,2),(1462,1080424822,1),(1462,1099170022,2),(1462,1111874422,1),(1462,1130619622,2),(1462,1143324023,1),(1462,1162069223,2),(1462,1174773623,1),(1462,1193518823,2),(1462,1206828023,1),(1462,1224968423,2),(1462,1238277624,1),(1462,1256418024,2),(1462,1269727224,1),(1462,1288472424,2),(1462,1301176824,1),(1462,1319922024,2),(1462,1332626424,1),(1462,1351371625,2),(1462,1364680825,1),(1462,1382821225,2),(1462,1396130425,1),(1462,1414270825,2),(1462,1427580025,1),(1462,1445720426,2),(1462,1459029626,1),(1462,1477774826,2),(1462,1490479227,1),(1462,1509224427,2),(1462,1521928827,1),(1462,1540674027,2),(1462,1553983227,1),(1462,1572123627,2),(1462,1585432827,1),(1462,1603573227,2),(1462,1616882427,1),(1462,1635627627,2),(1462,1648332027,1),(1462,1667077227,2),(1462,1679781627,1),(1462,1698526827,2),(1462,1711836027,1),(1462,1729976427,2),(1462,1743285627,1),(1462,1761426027,2),(1462,1774735227,1),(1462,1792875627,2),(1462,1806184827,1),(1462,1824930027,2),(1462,1837634427,1),(1462,1856379627,2),(1462,1869084027,1),(1462,1887829227,2),(1462,1901138427,1),(1462,1919278827,2),(1462,1932588027,1),(1462,1950728427,2),(1462,1964037627,1),(1462,1982782827,2),(1462,1995487227,1),(1462,2014232427,2),(1462,2026936827,1),(1462,2045682027,2),(1462,2058386427,1),(1462,2077131627,2),(1462,2090440827,1),(1462,2108581227,2),(1462,2121890427,1),(1462,2140030827,2),(1463,-2147483648,0),(1463,-1441169904,1),(1463,-1247547600,3),(1463,354909609,2),(1463,370717210,3),(1463,386445610,2),(1463,402253211,3),(1463,417981611,2),(1463,433789212,3),(1463,449604012,2),(1463,465336012,4),(1463,481060812,5),(1463,496785613,4),(1463,512510413,5),(1463,528235213,4),(1463,543960013,5),(1463,559684813,4),(1463,575409614,5),(1463,591134414,4),(1463,606859214,5),(1463,622584014,4),(1463,638308815,5),(1463,654638415,4),(1463,670363216,6),(1463,683582416,1),(1463,703018816,6),(1463,717530417,1),(1463,734468417,6),(1463,748980018,1),(1463,765918018,6),(1463,780429619,1),(1463,797367619,6),(1463,811879219,1),(1463,828817220,6),(1463,843933620,1),(1463,859671020,7),(1463,877811421,1),(1463,891120621,7),(1463,909261021,1),(1463,922570222,7),(1463,941315422,1),(1463,954019822,7),(1463,972765022,1),(1463,985469422,7),(1463,1004214622,1),(1463,1017523822,7),(1463,1035664222,1),(1463,1048973422,7),(1463,1067113822,1),(1463,1080423022,7),(1463,1099168222,1),(1463,1111872622,7),(1463,1123783222,3),(1464,-2147483648,0),(1464,-1383464380,1),(1464,-1167636600,2),(1465,-2147483648,1),(1465,-2019705670,2),(1465,-891581400,3),(1465,-872058600,2),(1465,-862637400,3),(1465,-764145000,2),(1466,-2147483648,0),(1466,-1579419232,1),(1466,-1247558400,3),(1466,354898809,2),(1466,370706410,3),(1466,386434810,2),(1466,402242411,3),(1466,417970811,2),(1466,433778412,3),(1466,449593212,2),(1466,465325212,4),(1466,481050012,5),(1466,496774813,4),(1466,512499613,5),(1466,528224413,4),(1466,543949213,5),(1466,559674013,4),(1466,575398814,5),(1466,591123614,4),(1466,606848414,5),(1466,622573214,4),(1466,638298015,5),(1466,654627615,4),(1466,670352416,6),(1466,686080816,7),(1466,695757616,4),(1466,701802016,5),(1466,717526817,4),(1466,733251617,5),(1466,748976418,4),(1466,764701218,5),(1466,780426019,4),(1466,796150819,5),(1466,811875619,4),(1466,828205220,5),(1466,846349220,4),(1466,859654820,5),(1466,877798821,4),(1466,891104421,5),(1466,909248421,4),(1466,922554022,5),(1466,941302822,4),(1466,954003622,5),(1466,972752422,4),(1466,985453222,5),(1466,1004202022,4),(1466,1017507622,5),(1466,1035651622,4),(1466,1048957222,5),(1466,1067101222,4),(1466,1080406822,5),(1466,1099155622,4),(1466,1111856422,5),(1466,1130605222,4),(1466,1143306023,5),(1466,1162054823,4),(1466,1174755623,5),(1466,1193504423,4),(1466,1206810023,5),(1466,1224954023,4),(1466,1238259624,5),(1466,1256403624,4),(1466,1269709224,5),(1466,1288458024,4),(1466,1301158824,8),(1466,1414252825,7),(1466,1459015226,3),(1467,-2147483648,0),(1467,-2032933080,1),(1467,252435606,2),(1467,417974411,4),(1467,433778412,3),(1467,449593212,4),(1467,465314412,3),(1467,481042812,4),(1467,496764013,3),(1467,512492413,4),(1467,528213613,3),(1467,543942013,4),(1467,559663213,3),(1467,575391614,4),(1467,591112814,3),(1467,606841214,4),(1467,622562414,3),(1467,638290815,4),(1467,654616815,3),(1467,670345216,4),(1467,686066416,3),(1467,701794816,4),(1467,717516017,3),(1467,733244417,4),(1467,748965618,3),(1467,764694018,4),(1467,780415219,3),(1467,796143619,4),(1467,811864819,3),(1467,828198020,4),(1467,843919220,3),(1467,859647620,4),(1467,875368821,3),(1467,891097221,4),(1467,906818421,3),(1467,988390822,4),(1467,1001692822,3),(1467,1017421222,4),(1467,1033142422,3),(1467,1048870822,4),(1467,1064592022,3),(1467,1080320422,4),(1467,1096041622,3),(1467,1111770022,4),(1467,1127491222,3),(1467,1143219623,4),(1467,1159545623,3),(1467,1206889223,2),(1467,1427479225,5),(1467,1443193226,2),(1467,1458928826,5),(1467,1474642826,2),(1468,-2147483648,2),(1468,-933667200,1),(1468,-922093200,2),(1468,-908870400,1),(1468,-888829200,2),(1468,-881049600,1),(1468,-767869200,2),(1468,-745833600,1),(1468,-733827600,2),(1468,-716889600,1),(1468,-699613200,2),(1468,-683884800,1),(1468,-670669200,2),(1468,-652348800,1),(1468,-650019600,2),(1468,515527213,1),(1468,527014813,2),(1468,545162413,1),(1468,558464413,2),(1468,577216814,1),(1468,589914014,2),(1468,608666414,1),(1468,621968414,2),(1468,640116015,1),(1468,653418015,2),(1468,671565616,1),(1468,684867616,2),(1469,-2147483648,2),(1469,-933667200,1),(1469,-922093200,2),(1469,-908870400,1),(1469,-888829200,2),(1469,-881049600,1),(1469,-767869200,2),(1469,-745833600,1),(1469,-733827600,2),(1469,-716889600,1),(1469,-699613200,2),(1469,-683884800,1),(1469,-670669200,2),(1469,-652348800,1),(1469,-650019600,2),(1469,515527213,1),(1469,527014813,2),(1469,545162413,1),(1469,558464413,2),(1469,577216814,1),(1469,589914014,2),(1469,608666414,1),(1469,621968414,2),(1469,640116015,1),(1469,653418015,2),(1469,671565616,1),(1469,684867616,2),(1470,-2147483648,1),(1470,-2019705572,2),(1470,-883287000,3),(1470,-862639200,4),(1470,-764051400,2),(1470,832962620,5),(1470,846266420,6),(1470,1145039423,2),(1471,-2147483648,1),(1471,-891582800,2),(1471,-872058600,3),(1471,-862637400,2),(1471,-576138600,4),(1471,1245430824,5),(1471,1262278824,4),(1472,-2147483648,0),(1472,-1577931912,2),(1472,-1568592000,1),(1472,-1554080400,2),(1472,-1537142400,1),(1472,-1522630800,2),(1472,-1505692800,1),(1472,-1491181200,2),(1472,-1474243200,1),(1472,-1459126800,2),(1472,-242265600,1),(1472,-228877200,2),(1472,-210556800,1),(1472,-197427600,2),(1472,-178934400,1),(1472,-165718800,2),(1472,-147398400,1),(1472,-134269200,2),(1472,-116467200,1),(1472,-102646800,2),(1472,-84326400,1),(1472,-71110800,2),(1472,-52704000,1),(1472,-39488400,2),(1472,-21168000,1),(1472,-7952400,2),(1472,10368000,1),(1472,23583600,2),(1472,41904000,1),(1472,55119600,2),(1472,73526400,1),(1472,86742001,2),(1472,105062402,1),(1472,118278002,2),(1472,136598403,1),(1472,149814003,2),(1472,168134404,1),(1472,181350004,2),(1472,199756805,1),(1472,212972405,2),(1472,231292806,1),(1472,241916406,2),(1472,262828807,1),(1472,273452407,2),(1472,418694411,1),(1472,433810812,2),(1472,450316812,1),(1472,465433212,2),(1472,508896013,1),(1472,529196413,2),(1472,541555213,1),(1472,562633213,2),(1472,574387214,1),(1472,594255614,2),(1472,607305614,1),(1472,623199614,2),(1472,638928015,1),(1472,654649215,2),(1472,670456816,1),(1472,686264416,2),(1472,702684016,1),(1472,717886817,2),(1472,733096817,1),(1472,748904418,2),(1472,765151218,1),(1472,780958819,2),(1472,796687219,1),(1472,812494819,2),(1472,828309620,1),(1472,844117220,2),(1472,859759220,1),(1472,875653221,2),(1472,891208821,1),(1472,907189221,2),(1472,922917622,1),(1472,938725222,2),(1472,954540022,1),(1472,970347622,2),(1472,986076022,1),(1472,1001883622,2),(1472,1017612022,1),(1472,1033419622,2),(1472,1049148022,1),(1472,1064955622,2),(1472,1080770422,1),(1472,1096578022,2),(1472,1112306422,1),(1472,1128114022,2),(1472,1143842423,1),(1472,1158872423,2),(1472,1175205623,1),(1472,1193950823,2),(1472,1207260023,1),(1472,1225486823,2),(1472,1238104824,1),(1472,1256850024,2),(1472,1270159224,1),(1472,1288299624,2),(1472,1301608824,1),(1472,1319749224,2),(1472,1333058424,1),(1472,1351198825,2),(1472,1364508025,1),(1472,1382648425,2),(1472,1395957625,1),(1472,1414702825,2),(1472,1427407225,1),(1472,1446152426,2),(1472,1458856826,1),(1472,1477602026,2),(1472,1490911227,1),(1472,1509051627,2),(1472,1522360827,1),(1472,1540501227,2),(1472,1553810427,1),(1472,1571950827,2),(1472,1585260027,1),(1472,1604005227,2),(1472,1616709627,1),(1472,1635454827,2),(1472,1648159227,1),(1472,1666904427,2),(1472,1680213627,1),(1472,1698354027,2),(1472,1711663227,1),(1472,1729803627,2),(1472,1743112827,1),(1472,1761858027,2),(1472,1774562427,1),(1472,1793307627,2),(1472,1806012027,1),(1472,1824757227,2),(1472,1838066427,1),(1472,1856206827,2),(1472,1869516027,1),(1472,1887656427,2),(1472,1900965627,1),(1472,1919106027,2),(1472,1932415227,1),(1472,1951160427,2),(1472,1963864827,1),(1472,1982610027,2),(1472,1995314427,1),(1472,2014059627,2),(1472,2027368827,1),(1472,2045509227,2),(1472,2058818427,1),(1472,2076958827,2),(1472,2090268027,1),(1472,2109013227,2),(1472,2121717627,1),(1472,2140462827,2),(1473,-2147483648,1),(1473,-891582800,2),(1473,-872058600,3),(1473,-862637400,2),(1473,-576138600,4),(1473,1245430824,5),(1473,1262278824,4),(1474,-2147483648,0),(1474,-1830414140,1),(1474,-879152400,2),(1474,199897205,1),(1474,969120022,2),(1475,-2147483648,0),(1475,-1577936472,1),(1476,-2147483648,0),(1476,-1441168512,1),(1476,-1247547600,3),(1476,354909609,2),(1476,370717210,3),(1476,386445610,2),(1476,402253211,3),(1476,417981611,2),(1476,433789212,3),(1476,449604012,2),(1476,465336012,4),(1476,481060812,5),(1476,496785613,4),(1476,512510413,5),(1476,528235213,4),(1476,543960013,5),(1476,559684813,4),(1476,575409614,5),(1476,591134414,4),(1476,606859214,5),(1476,622584014,4),(1476,638308815,5),(1476,654638415,4),(1476,670363216,6),(1476,684363616,7),(1477,-2147483648,0),(1477,-1518920148,2),(1477,166572004,1),(1477,182293204,2),(1477,200959205,1),(1477,213829205,2),(1477,228866406,1),(1477,243982806,2),(1477,260316007,1),(1477,276123607,2),(1477,291765608,1),(1477,307486808,2),(1477,323820009,1),(1477,338936409,2),(1477,354664809,1),(1477,370386010,2),(1477,386114410,1),(1477,401835611,2),(1477,417564011,1),(1477,433285212,2),(1477,449013612,1),(1477,465339612,2),(1477,481068012,1),(1477,496789213,2),(1477,512517613,1),(1477,528238813,2),(1477,543967213,1),(1477,559688413,2),(1477,575416814,1),(1477,591138014,2),(1477,606866414,1),(1477,622587614,2),(1477,638316015,1),(1477,654642015,2),(1477,670370416,1),(1477,686091616,2),(1477,701820016,1),(1477,717541217,2),(1477,733269617,1),(1477,748990818,2),(1477,764719218,1),(1477,780440419,2),(1477,796168819,1),(1477,811890019,2),(1477,828223220,1),(1477,843944420,2),(1477,859672820,1),(1477,875394021,2),(1477,891122421,1),(1477,909277221,3),(1477,922582822,4),(1477,941331622,3),(1477,954032422,4),(1477,972781222,3),(1477,985482022,4),(1477,1004230822,3),(1477,1017536422,4),(1477,1035680422,3),(1477,1048986022,4),(1477,1067130022,3),(1477,1080435622,4),(1477,1099184422,3),(1477,1111885222,4),(1477,1130634022,3),(1477,1143334823,4),(1477,1162083623,3),(1477,1174784423,4),(1477,1193533223,3),(1477,1206838823,4),(1477,1224982823,3),(1477,1238288424,4),(1477,1256432424,3),(1477,1269738024,4),(1477,1288486824,3),(1477,1301187624,4),(1477,1319936424,3),(1477,1332637224,4),(1477,1351386025,3),(1477,1364691625,4),(1477,1382835625,3),(1477,1396141225,4),(1477,1414285225,3),(1477,1427590825,4),(1477,1445734826,3),(1477,1459040426,4),(1477,1473282026,5),(1477,1509238827,3),(1477,1521939627,4),(1477,1540688427,3),(1477,1553994027,4),(1477,1572138027,3),(1477,1585443627,4),(1477,1603587627,3),(1477,1616893227,4),(1477,1635642027,3),(1477,1648342827,4),(1477,1667091627,3),(1477,1679792427,4),(1477,1698541227,3),(1477,1711846827,4),(1477,1729990827,3),(1477,1743296427,4),(1477,1761440427,3),(1477,1774746027,4),(1477,1792890027,3),(1477,1806195627,4),(1477,1824944427,3),(1477,1837645227,4),(1477,1856394027,3),(1477,1869094827,4),(1477,1887843627,3),(1477,1901149227,4),(1477,1919293227,3),(1477,1932598827,4),(1477,1950742827,3),(1477,1964048427,4),(1477,1982797227,3),(1477,1995498027,4),(1477,2014246827,3),(1477,2026947627,4),(1477,2045696427,3),(1477,2058397227,4),(1477,2077146027,3),(1477,2090451627,4),(1477,2108595627,3),(1477,2121901227,4),(1477,2140045227,3),(1478,-2147483648,2),(1478,-933645600,1),(1478,-857358000,2),(1478,-844300800,1),(1478,-825822000,2),(1478,-812685600,1),(1478,-794199600,2),(1478,-779853600,1),(1478,-762656400,2),(1478,-748310400,1),(1478,-731127600,2),(1478,-399088800,1),(1478,-386650800,2),(1478,-368330400,1),(1478,-355114800,2),(1478,-336790800,1),(1478,-323654400,2),(1478,-305168400,1),(1478,-292032000,2),(1478,-273632400,1),(1478,-260496000,2),(1478,-242096400,1),(1478,-228960000,2),(1478,-210560400,1),(1478,-197424000,2),(1478,-178938000,1),(1478,-165801600,2),(1478,-147402000,1),(1478,-134265600,2),(1478,-115866000,1),(1478,-102643200,2),(1478,-84330000,1),(1478,-81313200,4),(1478,142380003,3),(1478,150843603,4),(1478,167176804,3),(1478,178664404,4),(1478,334015209,3),(1478,337644009,4),(1478,452556012,3),(1478,462232812,4),(1478,482277612,3),(1478,495579613,4),(1478,516751213,3),(1478,526424413,4),(1478,545436013,3),(1478,558478813,4),(1478,576626414,3),(1478,589323614,4),(1478,609890414,3),(1478,620773214,4),(1478,638316015,3),(1478,651618015,4),(1478,669765616,3),(1478,683672416,4),(1478,701820016,3),(1478,715726817,4),(1478,733701617,3),(1478,747176418,4),(1478,765151218,3),(1478,778021219,4),(1478,796600819,3),(1478,810075619,4),(1478,820447219,2),(1478,828655220,1),(1478,843170420,5),(1478,860104820,1),(1478,874620021,5),(1478,891554421,1),(1478,906069621,5),(1478,915141621,2),(1478,924213622,1),(1478,939934822,2),(1478,956268022,1),(1478,971989222,2),(1478,987717622,1),(1478,1003438822,2),(1478,1019167222,1),(1478,1034888422,2),(1478,1050616822,1),(1478,1066338022,2),(1478,1082066422,1),(1478,1096581622,2),(1478,1113516022,1),(1478,1128380422,2),(1478,1143842423,1),(1478,1158872423,2),(1478,1175378423,1),(1478,1189638023,2),(1478,1206655223,1),(1478,1219957223,2),(1478,1238104824,1),(1478,1252015224,2),(1478,1269640884,1),(1478,1281474024,2),(1478,1301608884,1),(1478,1312146024,2),(1478,1333058424,1),(1478,1348178425,2),(1478,1364508025,1),(1478,1380229225,2),(1478,1395957625,1),(1478,1414098025,2),(1478,1427493625,1),(1478,1445547626,2),(1478,1458946826,1),(1478,1477692026,2),(1478,1490396427,1),(1478,1509141627,2),(1478,1521846027,1),(1478,1540591227,2),(1478,1553900427,1),(1478,1572040827,2),(1478,1585350027,1),(1478,1604095227,2),(1478,1616799627,1),(1478,1635544827,2),(1478,1648249227,1),(1478,1666994427,2),(1478,1679698827,1),(1478,1698444027,2),(1478,1711753227,1),(1478,1729893627,2),(1478,1743202827,1),(1478,1761343227,2),(1478,1774652427,1),(1478,1793397627,2),(1478,1806102027,1),(1478,1824847227,2),(1478,1837551627,1),(1478,1856296827,2),(1478,1869001227,1),(1478,1887746427,2),(1478,1901055627,1),(1478,1919196027,2),(1478,1932505227,1),(1478,1950645627,2),(1478,1963954827,1),(1478,1982700027,2),(1478,1995404427,1),(1478,2014149627,2),(1478,2026854027,1),(1478,2045599227,2),(1478,2058303627,1),(1478,2077048827,2),(1478,2090358027,1),(1478,2108498427,2),(1478,2121807627,1),(1478,2140552827,2),(1479,-2147483648,2),(1479,-933667200,1),(1479,-922093200,2),(1479,-908870400,1),(1479,-888829200,2),(1479,-881049600,1),(1479,-767869200,2),(1479,-745833600,1),(1479,-733827600,2),(1479,-716889600,1),(1479,-699613200,2),(1479,-683884800,1),(1479,-670669200,2),(1479,-652348800,1),(1479,-650019600,2),(1479,515527213,1),(1479,527014813,2),(1479,545162413,1),(1479,558464413,2),(1479,577216814,1),(1479,589914014,2),(1479,608666414,1),(1479,621968414,2),(1479,640116015,1),(1479,653418015,2),(1479,671565616,1),(1479,684867616,2),(1480,-2147483648,2),(1480,-933645600,1),(1480,-857358000,2),(1480,-844300800,1),(1480,-825822000,2),(1480,-812685600,1),(1480,-794199600,2),(1480,-779853600,1),(1480,-762656400,2),(1480,-748310400,1),(1480,-731127600,2),(1480,-399088800,1),(1480,-386650800,2),(1480,-368330400,1),(1480,-355114800,2),(1480,-336790800,1),(1480,-323654400,2),(1480,-305168400,1),(1480,-292032000,2),(1480,-273632400,1),(1480,-260496000,2),(1480,-242096400,1),(1480,-228960000,2),(1480,-210560400,1),(1480,-197424000,2),(1480,-178938000,1),(1480,-165801600,2),(1480,-147402000,1),(1480,-134265600,2),(1480,-115866000,1),(1480,-102643200,2),(1480,-84330000,1),(1480,-81313200,4),(1480,142380003,3),(1480,150843603,4),(1480,167176804,3),(1480,178664404,4),(1480,334015209,3),(1480,337644009,4),(1480,452556012,3),(1480,462232812,4),(1480,482277612,3),(1480,495579613,4),(1480,516751213,3),(1480,526424413,4),(1480,545436013,3),(1480,558478813,4),(1480,576626414,3),(1480,589323614,4),(1480,609890414,3),(1480,620773214,4),(1480,638316015,3),(1480,651618015,4),(1480,669765616,3),(1480,683672416,4),(1480,701820016,3),(1480,715726817,4),(1480,733701617,3),(1480,747176418,4),(1480,765151218,3),(1480,778021219,4),(1480,796600819,3),(1480,810075619,4),(1480,820447219,2),(1480,828655220,1),(1480,843170420,5),(1480,860104820,1),(1480,874620021,5),(1480,891554421,1),(1480,906069621,5),(1480,915141621,2),(1480,924213622,1),(1480,939934822,2),(1480,956268022,1),(1480,971989222,2),(1480,987717622,1),(1480,1003438822,2),(1480,1019167222,1),(1480,1034888422,2),(1480,1050616822,1),(1480,1066338022,2),(1480,1082066422,1),(1480,1096581622,2),(1480,1113516022,1),(1480,1128380422,2),(1480,1143842423,1),(1480,1158872423,2),(1480,1175378423,1),(1480,1189638023,2),(1480,1206655223,1),(1480,1220216423,2),(1480,1238104824,1),(1480,1252015224,2),(1480,1269554424,1),(1480,1281474024,2),(1480,1301608884,1),(1480,1312146024,2),(1480,1314655224,1),(1480,1317330024,2),(1480,1333058424,1),(1480,1348178425,2),(1480,1364508025,1),(1480,1380229225,2),(1480,1395957625,1),(1480,1414098025,2),(1480,1427493625,1),(1480,1445547626,2),(1480,1458946826,1),(1480,1477692026,2),(1480,1490396427,1),(1480,1509141627,2),(1480,1521846027,1),(1480,1540591227,2),(1480,1553900427,1),(1480,1572040827,2),(1480,1585350027,1),(1480,1604095227,2),(1480,1616799627,1),(1480,1635544827,2),(1480,1648249227,1),(1480,1666994427,2),(1480,1679698827,1),(1480,1698444027,2),(1480,1711753227,1),(1480,1729893627,2),(1480,1743202827,1),(1480,1761343227,2),(1480,1774652427,1),(1480,1793397627,2),(1480,1806102027,1),(1480,1824847227,2),(1480,1837551627,1),(1480,1856296827,2),(1480,1869001227,1),(1480,1887746427,2),(1480,1901055627,1),(1480,1919196027,2),(1480,1932505227,1),(1480,1950645627,2),(1480,1963954827,1),(1480,1982700027,2),(1480,1995404427,1),(1480,2014149627,2),(1480,2026854027,1),(1480,2045599227,2),(1480,2058303627,1),(1480,2077048827,2),(1480,2090358027,1),(1480,2108498427,2),(1480,2121807627,1),(1480,2140552827,2),(1481,-2147483648,0),(1481,-2004073600,1),(1481,-1851577590,2),(1481,-852105600,3),(1481,-782643600,4),(1481,-767869200,2),(1481,-718095600,3),(1481,-457776000,2),(1481,-315648000,3),(1481,171820804,2),(1482,-2147483648,0),(1482,-2056690800,1),(1482,-900909000,2),(1482,-891579600,3),(1482,-884248200,4),(1482,-766659600,1),(1482,-747981000,2),(1482,-728544600,1),(1482,-717049800,2),(1482,-694503000,1),(1482,-683785800,2),(1482,-668064600,1),(1482,-654755400,2),(1482,-636615000,1),(1482,-623305800,2),(1482,-605165400,1),(1482,-591856200,2),(1482,-573715800,1),(1482,-559801800,2),(1482,-541661400,1),(1482,-528352200,2),(1482,-510211800,1),(1482,-498112200,2),(1482,-478762200,1),(1482,-466662600,2),(1482,-446707800,1),(1482,-435213000,2),(1482,-415258200,1),(1482,-403158600,2),(1482,-383808600,1),(1482,-371709000,2),(1482,-352359000,1),(1482,-340259400,2),(1482,-320909400,1),(1482,-308809800,2),(1482,-288855000,1),(1482,-277360200,2),(1482,-257405400,1),(1482,-245910600,2),(1482,-225955800,1),(1482,-213856200,2),(1482,-194506200,1),(1482,-182406600,2),(1482,-163056600,1),(1482,-148537800,2),(1482,-132816600,1),(1482,-117088200,2),(1482,-101367000,1),(1482,-85638600,2),(1482,-69312600,1),(1482,-53584200,2),(1482,-37863000,1),(1482,-22134600,2),(1482,-6413400,1),(1482,9315000,2),(1482,25036200,1),(1482,40764600,2),(1482,56485800,1),(1482,72214200,2),(1482,88540201,1),(1482,104268602,2),(1482,119989802,1),(1482,126041402,2),(1482,151439403,1),(1482,167167804,2),(1482,182889004,1),(1482,198617405,2),(1482,214338605,1),(1482,295385408,2),(1482,309292208,1),(1483,-2147483648,0),(1483,-2032927596,1),(1483,252439206,3),(1483,417978011,2),(1483,433785612,3),(1483,449600412,2),(1483,465321612,3),(1483,481050012,2),(1483,496771213,3),(1483,512499613,2),(1483,528220813,3),(1483,543949213,2),(1483,559670413,3),(1483,575398814,2),(1483,591120014,3),(1483,606848414,2),(1483,622569614,3),(1483,638298015,2),(1483,654624015,3),(1483,670352416,2),(1483,686073616,3),(1483,701802016,2),(1483,717523217,3),(1483,733251617,2),(1483,748972818,3),(1483,764701218,2),(1483,780422419,3),(1483,796150819,2),(1483,811872019,3),(1483,828205220,2),(1483,843926420,3),(1483,859654820,2),(1483,875376021,3),(1483,891104421,2),(1483,906825621,3),(1483,988398022,2),(1483,1001700022,3),(1483,1017428422,2),(1483,1033149622,3),(1483,1048878022,2),(1483,1064599222,3),(1483,1080327622,2),(1483,1096048822,3),(1483,1111777222,2),(1483,1127498422,3),(1483,1143226823,2),(1483,1159552823,3),(1483,1427482825,2),(1483,1443196826,3),(1483,1458932426,2),(1483,1474646426,3),(1484,-2147483648,1),(1484,-1575874625,2),(1484,-1247554800,4),(1484,354902409,3),(1484,370710010,4),(1484,386438410,3),(1484,402246011,4),(1484,417974411,3),(1484,433782012,4),(1484,449596812,3),(1484,465328812,5),(1484,481053612,6),(1484,496778413,5),(1484,512503213,6),(1484,528228013,5),(1484,543952813,6),(1484,559677613,5),(1484,575402414,6),(1484,591127214,5),(1484,606852014,6),(1484,622576814,5),(1484,638301615,6),(1484,654631215,5),(1484,670356016,7),(1484,686084416,8),(1484,695761216,5),(1484,701805616,6),(1484,717530417,5),(1484,733255217,6),(1484,748980018,5),(1484,764704818,6),(1484,780429619,5),(1484,796154419,6),(1484,811879219,5),(1484,828208820,6),(1484,846352820,5),(1484,859658420,6),(1484,877802421,5),(1484,891108021,6),(1484,909252021,5),(1484,922557622,6),(1484,941306422,5),(1484,954007222,6),(1484,972756022,5),(1484,985456822,6),(1484,1004205622,5),(1484,1017511222,6),(1484,1035655222,5),(1484,1048960822,6),(1484,1067104822,5),(1484,1080410422,6),(1484,1099159222,5),(1484,1111860022,6),(1484,1130608822,5),(1484,1143309623,6),(1484,1162058423,5),(1484,1174759223,6),(1484,1193508023,5),(1484,1206813623,6),(1484,1224957623,5),(1484,1238263224,6),(1484,1256407224,5),(1484,1269712824,6),(1484,1288461624,5),(1484,1301162424,9),(1484,1414256425,5),(1485,-2147483648,1),(1485,-1869875816,3),(1485,-1693706400,2),(1485,-1680490800,3),(1485,-1570413600,2),(1485,-1552186800,3),(1485,-1538359200,2),(1485,-1522551600,3),(1485,-1507514400,2),(1485,-1490583600,3),(1485,-1440208800,2),(1485,-1428030000,3),(1485,-1409709600,2),(1485,-1396494000,3),(1485,-931140000,2),(1485,-922762800,3),(1485,-917834400,2),(1485,-892436400,3),(1485,-875844000,2),(1485,-857358000,3),(1485,-781063200,2),(1485,-764737200,3),(1485,-744343200,2),(1485,-733806000,3),(1485,-716436000,2),(1485,-701924400,3),(1485,-684986400,2),(1485,-670474800,3),(1485,-654141600,2),(1485,-639025200,3),(1485,-621828000,2),(1485,-606970800,3),(1485,-590032800,2),(1485,-575434800,3),(1485,-235620000,2),(1485,-228279600,3),(1485,-177732000,2),(1485,-165726000,3),(1485,10533600,2),(1485,23835600,3),(1485,41983200,2),(1485,55285200,3),(1485,74037600,2),(1485,87339601,3),(1485,107910002,2),(1485,121219202,3),(1485,133920003,2),(1485,152676003,3),(1485,165362404,2),(1485,183502804,3),(1485,202428005,2),(1485,215557205,3),(1485,228866406,2),(1485,245797206,3),(1485,260316007,2),(1485,277246807,4),(1485,308779208,5),(1485,323827209,4),(1485,340228809,5),(1485,354672009,4),(1485,371678410,5),(1485,386121610,4),(1485,403128011,5),(1485,428446812,4),(1485,433886412,5),(1485,482792412,2),(1485,496702813,3),(1485,512521213,6),(1485,528246013,7),(1485,543970813,6),(1485,559695613,7),(1485,575420414,6),(1485,591145214,7),(1485,606870014,6),(1485,622594814,7),(1485,638319615,6),(1485,654649215,7),(1485,670374016,6),(1485,686098816,7),(1485,701823616,6),(1485,717548417,7),(1485,733273217,6),(1485,748998018,7),(1485,764118018,6),(1485,780447619,7),(1485,796172419,6),(1485,811897219,7),(1485,828226820,6),(1485,846370820,7),(1485,859676420,6),(1485,877820421,7),(1485,891126021,6),(1485,909270021,7),(1485,922575622,6),(1485,941324422,7),(1485,954025222,6),(1485,972774022,7),(1485,985474822,6),(1485,1004223622,7),(1485,1017529222,6),(1485,1035673222,7),(1485,1048978822,6),(1485,1067122822,7),(1485,1080428422,6),(1485,1099177222,7),(1485,1111878022,6),(1485,1130626822,7),(1485,1143327623,6),(1485,1162076423,7),(1485,1167602423,3),(1485,1174784423,8),(1485,1193533223,9),(1485,1206838823,8),(1485,1224982823,9),(1485,1238288424,8),(1485,1256432424,9),(1485,1269738024,8),(1485,1288486824,9),(1485,1301274024,8),(1485,1319936424,9),(1485,1332637224,8),(1485,1351386025,9),(1485,1364691625,8),(1485,1382835625,9),(1485,1396227625,8),(1485,1414285225,9),(1485,1427590825,8),(1485,1446944426,9),(1485,1459040426,8),(1485,1473195626,5),(1486,-2147483648,1),(1486,-1451719200,2),(1486,-1172906400,3),(1486,-876641400,4),(1486,-766054800,3),(1486,-683883000,5),(1486,-620812800,3),(1486,-189415800,6),(1487,-2147483648,0),(1487,-1172913768,1),(1487,-799491600,2),(1487,-189423000,3),(1488,-2147483648,1),(1488,-1641003640,3),(1488,-933645600,2),(1488,-857358000,3),(1488,-844300800,2),(1488,-825822000,3),(1488,-812685600,2),(1488,-794199600,3),(1488,-779853600,2),(1488,-762656400,3),(1488,-748310400,2),(1488,-731127600,3),(1488,-681962400,4),(1488,-673243200,2),(1488,-667962000,3),(1488,-652327200,2),(1488,-636426000,3),(1488,-622087200,2),(1488,-608947200,3),(1488,-591847200,2),(1488,-572486400,3),(1488,-558576000,2),(1488,-542851200,3),(1488,-527731200,2),(1488,-514425600,3),(1488,-490845600,2),(1488,-482986800,3),(1488,-459475200,2),(1488,-451537200,3),(1488,-428551200,2),(1488,-418262400,3),(1488,-400032000,2),(1488,-387428400,3),(1488,142380003,2),(1488,150843603,3),(1488,167176804,2),(1488,178664404,3),(1488,334015209,2),(1488,337644009,3),(1488,452556012,2),(1488,462232812,3),(1488,482277612,2),(1488,495579613,3),(1488,516751213,2),(1488,526424413,3),(1488,545436013,2),(1488,558478813,3),(1488,576626414,2),(1488,589323614,3),(1488,609890414,2),(1488,620773214,3),(1488,638316015,2),(1488,651618015,3),(1488,669765616,2),(1488,683672416,3),(1488,701820016,2),(1488,715726817,3),(1488,733701617,2),(1488,747176418,3),(1488,765151218,2),(1488,778021219,3),(1488,796600819,2),(1488,810075619,3),(1488,826840820,2),(1488,842821220,3),(1488,858895220,2),(1488,874184421,3),(1488,890344821,2),(1488,905029221,3),(1488,923011222,2),(1488,936313222,3),(1488,955670422,2),(1488,970783222,3),(1488,986770822,2),(1488,1001282422,3),(1488,1017356422,2),(1488,1033941622,3),(1488,1048806022,2),(1488,1065132022,3),(1488,1081292422,2),(1488,1095804022,3),(1488,1112313622,2),(1488,1128812422,3),(1488,1143763223,2),(1488,1159657223,3),(1488,1175212823,2),(1488,1189897223,3),(1488,1206662423,2),(1488,1223161223,3),(1488,1238112024,2),(1488,1254006024,3),(1488,1269561624,2),(1488,1284246024,3),(1488,1301616024,2),(1488,1317510024,3),(1488,1333065624,2),(1488,1348354825,3),(1488,1364515225,2),(1488,1382828425,3),(1488,1395964825,2),(1488,1414278025,3),(1488,1427414425,2),(1488,1445727626,3),(1488,1458864026,2),(1488,1477782026,3),(1488,1490313627,2),(1488,1509231627,3),(1488,1521763227,2),(1488,1540681227,3),(1488,1553817627,2),(1488,1572130827,3),(1488,1585267227,2),(1488,1603580427,3),(1488,1616716827,2),(1488,1635634827,3),(1488,1648166427,2),(1488,1667084427,3),(1488,1679616027,2),(1488,1698534027,3),(1488,1711670427,2),(1488,1729983627,3),(1488,1743120027,2),(1488,1761433227,3),(1488,1774569627,2),(1488,1792882827,3),(1488,1806019227,2),(1488,1824937227,3),(1488,1837468827,2),(1488,1856386827,3),(1488,1868918427,2),(1488,1887836427,3),(1488,1900972827,2),(1488,1919286027,3),(1488,1932422427,2),(1488,1950735627,3),(1488,1963872027,2),(1488,1982790027,3),(1488,1995321627,2),(1488,2014239627,3),(1488,2026771227,2),(1488,2045689227,3),(1488,2058220827,2),(1488,2077138827,3),(1488,2090275227,2),(1488,2108588427,3),(1488,2121724827,2),(1488,2140038027,3),(1489,-2147483648,1),(1489,-788932800,2),(1490,-2147483648,0),(1490,-1487759676,1),(1490,-1247569200,3),(1490,354888009,2),(1490,370695610,3),(1490,386424010,2),(1490,402231611,3),(1490,417960011,2),(1490,433767612,3),(1490,449582412,2),(1490,465314412,4),(1490,481039212,5),(1490,496764013,4),(1490,512488813,5),(1490,528213613,4),(1490,543938413,5),(1490,559663213,4),(1490,575388014,5),(1490,591112814,4),(1490,606837614,5),(1490,622562414,4),(1490,638287215,5),(1490,654616815,4),(1490,670341616,6),(1490,686070016,7),(1490,695746816,4),(1490,701791216,5),(1490,717516017,4),(1490,733240817,5),(1490,748965618,4),(1490,764690418,5),(1490,780415219,4),(1490,796140019,5),(1490,811864819,4),(1490,828194420,5),(1490,846338420,4),(1490,859644020,5),(1490,877788021,4),(1490,891093621,5),(1490,909237621,4),(1490,922543222,5),(1490,941292022,4),(1490,953992822,5),(1490,972741622,4),(1490,985442422,5),(1490,1004191222,4),(1490,1017496822,5),(1490,1035640822,4),(1490,1048946422,5),(1490,1067090422,4),(1490,1080396022,5),(1490,1099144822,4),(1490,1111845622,5),(1490,1130594422,4),(1490,1143295223,5),(1490,1162044023,4),(1490,1174744823,5),(1490,1193493623,4),(1490,1206799223,5),(1490,1224943223,4),(1490,1238248824,5),(1490,1256392824,4),(1490,1269698424,6),(1490,1288450824,7),(1490,1301151624,4),(1491,-2147483648,0),(1491,-1988166492,1),(1491,-862637400,2),(1491,-764145000,1),(1491,-576135000,3),(1491,38775600,5),(1491,1018119622,4),(1491,1033840822,5),(1491,1212260423,4),(1491,1225476023,5),(1491,1239735624,4),(1491,1257012024,5),(1492,-2147483648,0),(1492,-1325483420,1),(1493,-2147483648,0),(1493,-1577943676,1),(1493,504901813,2),(1494,-2147483648,0),(1494,-1577943676,1),(1494,504901813,2),(1495,-2147483648,0),(1495,-1579424533,1),(1495,-1247558400,3),(1495,354898809,2),(1495,370706410,3),(1495,386434810,2),(1495,402242411,3),(1495,417970811,2),(1495,433778412,3),(1495,449593212,2),(1495,465325212,4),(1495,481050012,5),(1495,496774813,4),(1495,512499613,5),(1495,528224413,4),(1495,543949213,5),(1495,559674013,4),(1495,575398814,5),(1495,591123614,4),(1495,606848414,5),(1495,622573214,4),(1495,638298015,5),(1495,654627615,4),(1495,670352416,6),(1495,686080816,7),(1495,695757616,4),(1495,701802016,5),(1495,717526817,4),(1495,733251617,5),(1495,748976418,4),(1495,764701218,5),(1495,780426019,4),(1495,796150819,5),(1495,811875619,4),(1495,828205220,5),(1495,846349220,4),(1495,859654820,5),(1495,877798821,4),(1495,891104421,5),(1495,909248421,4),(1495,922554022,5),(1495,941302822,4),(1495,954003622,5),(1495,972752422,4),(1495,985453222,5),(1495,1004202022,4),(1495,1017507622,5),(1495,1035651622,4),(1495,1048957222,5),(1495,1067101222,4),(1495,1072882822,10),(1495,1080403222,8),(1495,1099152022,9),(1495,1111852822,8),(1495,1130601622,9),(1495,1143302423,8),(1495,1162051223,9),(1495,1174752023,8),(1495,1193500823,9),(1495,1206806423,8),(1495,1224950423,9),(1495,1238256024,8),(1495,1256400024,9),(1495,1269705624,8),(1495,1288454424,9),(1495,1301155224,11),(1495,1315832424,9),(1495,1414252825,4),(1496,-2147483648,1),(1496,-2019705670,2),(1496,-891581400,3),(1496,-872058600,2),(1496,-862637400,3),(1496,-764145000,2),(1497,-2147483648,0),(1497,-1577513486,1),(1497,-1247551200,3),(1497,354906009,2),(1497,370713610,3),(1497,386442010,2),(1497,402249611,3),(1497,417978011,2),(1497,433785612,3),(1497,449600412,2),(1497,465332412,4),(1497,481057212,5),(1497,496782013,4),(1497,512506813,5),(1497,528231613,4),(1497,543956413,5),(1497,559681213,4),(1497,575406014,5),(1497,591130814,4),(1497,606855614,5),(1497,622580414,4),(1497,638305215,5),(1497,654634815,4),(1497,670359616,6),(1497,686088016,7),(1497,695764816,4),(1497,701809216,5),(1497,717534017,4),(1497,733258817,5),(1497,748983618,4),(1497,764708418,5),(1497,780433219,4),(1497,796158019,5),(1497,811882819,4),(1497,828212420,5),(1497,846356420,4),(1497,859662020,5),(1497,877806021,4),(1497,891111621,5),(1497,909255621,4),(1497,922561222,5),(1497,941310022,4),(1497,954010822,5),(1497,972759622,4),(1497,985460422,5),(1497,1004209222,4),(1497,1017514822,5),(1497,1035658822,4),(1497,1048964422,5),(1497,1067108422,4),(1497,1080414022,5),(1497,1099162822,4),(1497,1111863622,5),(1497,1130612422,4),(1497,1143313223,5),(1497,1162062023,4),(1497,1174762823,5),(1497,1193511623,4),(1497,1206817223,5),(1497,1224961223,4),(1497,1238266824,5),(1497,1256410824,4),(1497,1269716424,5),(1497,1288465224,4),(1497,1301166024,8),(1497,1414260025,4),(1498,-2147483648,1),(1498,-2038200925,2),(1498,-1167634800,3),(1498,-1073028000,4),(1498,-894180000,5),(1498,-879665400,6),(1498,-767005200,5),(1498,378664210,7),(1499,-2147483648,0),(1499,-1383463280,1),(1499,-1167636600,3),(1499,-1082448000,2),(1499,-1074586800,3),(1499,-1050825600,2),(1499,-1042964400,3),(1499,-1019289600,2),(1499,-1011428400,3),(1499,-987753600,2),(1499,-979892400,3),(1499,-956217600,2),(1499,-948356400,3),(1499,-924595200,2),(1499,-916734000,3),(1499,-893059200,2),(1499,-885198000,3),(1499,-879667200,4),(1499,-767005200,3),(1500,-2147483648,0),(1500,-719636812,1),(1501,-2147483648,0),(1501,-2056692850,1),(1501,-884509200,3),(1501,-873280800,2),(1501,-855918000,3),(1501,-841744800,2),(1501,-828529200,3),(1501,-765363600,1),(1501,-747046800,4),(1501,-733827600,5),(1501,-716461200,4),(1501,-697021200,5),(1501,-683715600,4),(1501,-667990800,5),(1501,-654771600,4),(1501,-636627600,5),(1501,-623322000,4),(1501,-605178000,5),(1501,-591872400,4),(1501,-573642000,5),(1501,-559818000,4),(1501,-541674000,5),(1501,-528368400,4),(1501,-510224400,5),(1501,-498128400,4),(1501,-478774800,5),(1501,-466678800,4),(1501,-446720400,5),(1501,-435229200,4),(1501,-415258200,1),(1501,-403158600,6),(1501,-383808600,1),(1501,-371709000,6),(1501,-352359000,1),(1501,-340259400,6),(1501,-320909400,1),(1501,-308809800,6),(1501,-288855000,1),(1501,-277360200,6),(1501,-257405400,1),(1501,-245910600,6),(1501,-225955800,1),(1501,-213856200,6),(1501,-194506200,1),(1501,-182406600,6),(1501,-163056600,1),(1501,-148537800,6),(1501,-132820200,1),(1501,-117088200,6),(1501,-101370600,1),(1501,-85638600,6),(1501,-69312600,1),(1501,-53584200,6),(1501,-37863000,1),(1501,-22134600,6),(1501,-6413400,1),(1501,9315000,6),(1501,25036200,1),(1501,40764600,6),(1501,56485800,1),(1501,72214200,6),(1501,88540201,1),(1501,104268602,6),(1501,119989802,1),(1501,126041402,6),(1501,151439403,1),(1501,167167804,6),(1501,182889004,1),(1501,198617405,6),(1501,214338605,1),(1501,295385408,6),(1501,309292208,1),(1502,-2147483648,0),(1502,-2056692850,1),(1502,-884509200,3),(1502,-873280800,2),(1502,-855918000,3),(1502,-841744800,2),(1502,-828529200,3),(1502,-765363600,1),(1502,-747046800,4),(1502,-733827600,5),(1502,-716461200,4),(1502,-697021200,5),(1502,-683715600,4),(1502,-667990800,5),(1502,-654771600,4),(1502,-636627600,5),(1502,-623322000,4),(1502,-605178000,5),(1502,-591872400,4),(1502,-573642000,5),(1502,-559818000,4),(1502,-541674000,5),(1502,-528368400,4),(1502,-510224400,5),(1502,-498128400,4),(1502,-478774800,5),(1502,-466678800,4),(1502,-446720400,5),(1502,-435229200,4),(1502,-415258200,1),(1502,-403158600,6),(1502,-383808600,1),(1502,-371709000,6),(1502,-352359000,1),(1502,-340259400,6),(1502,-320909400,1),(1502,-308809800,6),(1502,-288855000,1),(1502,-277360200,6),(1502,-257405400,1),(1502,-245910600,6),(1502,-225955800,1),(1502,-213856200,6),(1502,-194506200,1),(1502,-182406600,6),(1502,-163056600,1),(1502,-148537800,6),(1502,-132820200,1),(1502,-117088200,6),(1502,-101370600,1),(1502,-85638600,6),(1502,-69312600,1),(1502,-53584200,6),(1502,-37863000,1),(1502,-22134600,6),(1502,-6413400,1),(1502,9315000,6),(1502,25036200,1),(1502,40764600,6),(1502,56485800,1),(1502,72214200,6),(1502,88540201,1),(1502,104268602,6),(1502,119989802,1),(1502,126041402,6),(1502,151439403,1),(1502,167167804,6),(1502,182889004,1),(1502,198617405,6),(1502,214338605,1),(1502,295385408,6),(1502,309292208,1),(1503,-2147483648,0),(1503,-1441188192,1),(1503,-1247565600,3),(1503,354891609,2),(1503,370699210,3),(1503,386427610,2),(1503,402235211,3),(1503,417963611,2),(1503,433771212,3),(1503,449586012,2),(1503,465318012,4),(1503,481042812,5),(1503,496767613,4),(1503,512492413,5),(1503,528217213,4),(1503,543942013,5),(1503,559666813,4),(1503,575391614,5),(1503,591116414,4),(1503,606841214,5),(1503,622566014,4),(1503,638290815,5),(1503,654620415,4),(1503,670345216,6),(1503,686073616,7),(1503,695750416,4),(1503,701794816,5),(1503,717519617,4),(1503,733244417,5),(1503,748969218,4),(1503,764694018,5),(1503,780418819,4),(1503,796143619,5),(1503,811868419,4),(1503,828198020,5),(1503,846342020,4),(1503,859647620,5),(1503,877791621,4),(1503,891097221,5),(1503,909241221,4),(1503,922546822,5),(1503,941295622,4),(1503,953996422,5),(1503,972745222,4),(1503,985446022,5),(1503,1004194822,4),(1503,1017500422,5),(1503,1035644422,4),(1503,1048950022,5),(1503,1067094022,4),(1503,1080399622,5),(1503,1099148422,4),(1503,1111849222,5),(1503,1130598022,4),(1503,1143298823,5),(1503,1162047623,4),(1503,1174748423,5),(1503,1193497223,4),(1503,1206802823,5),(1503,1224946823,4),(1503,1238252424,5),(1503,1256396424,4),(1503,1269702024,5),(1503,1288450824,4),(1503,1301151624,8),(1503,1414245625,7),(1503,1461427226,4),(1504,-2147483648,0),(1504,-1577951856,1),(1504,-1172908656,2),(1504,-880272000,3),(1504,-766054800,4),(1505,-2147483648,2),(1505,-1046678400,1),(1505,-1038733200,2),(1505,-873273600,3),(1505,-794221200,2),(1505,-496224000,1),(1505,-489315600,2),(1505,259344007,1),(1505,275151607,2),(1506,-2147483648,0),(1506,-1577936472,1),(1507,-2147483648,0),(1507,-1518920008,2),(1507,166572004,1),(1507,182293204,2),(1507,200959205,1),(1507,213829205,2),(1507,228866406,1),(1507,243982806,2),(1507,260316007,1),(1507,276123607,2),(1507,291765608,1),(1507,307486808,2),(1507,323820009,1),(1507,338936409,2),(1507,354664809,1),(1507,370386010,2),(1507,386114410,1),(1507,401835611,2),(1507,417564011,1),(1507,433285212,2),(1507,449013612,1),(1507,465339612,2),(1507,481068012,1),(1507,496789213,2),(1507,512517613,1),(1507,528238813,2),(1507,543967213,1),(1507,559688413,2),(1507,575416814,1),(1507,591138014,2),(1507,606866414,1),(1507,622587614,2),(1507,638316015,1),(1507,654642015,2),(1507,670370416,1),(1507,686091616,2),(1507,701820016,1),(1507,717541217,2),(1507,733269617,1),(1507,748990818,2),(1507,764719218,1),(1507,780440419,2),(1507,796168819,1),(1507,811890019,2),(1507,828223220,1),(1507,843944420,2),(1507,859672820,1),(1507,875394021,2),(1507,891122421,1),(1507,909277221,3),(1507,922582822,4),(1507,941331622,3),(1507,954032422,4),(1507,972781222,3),(1507,985482022,4),(1507,1004230822,3),(1507,1017536422,4),(1507,1035680422,3),(1507,1048986022,4),(1507,1067130022,3),(1507,1080435622,4),(1507,1099184422,3),(1507,1111885222,4),(1507,1130634022,3),(1507,1143334823,4),(1507,1162083623,3),(1507,1174784423,4),(1507,1193533223,3),(1507,1206838823,4),(1507,1224982823,3),(1507,1238288424,4),(1507,1256432424,3),(1507,1269738024,4),(1507,1288486824,3),(1507,1301187624,4),(1507,1319936424,3),(1507,1332637224,4),(1507,1351386025,3),(1507,1364691625,4),(1507,1382835625,3),(1507,1396141225,4),(1507,1414285225,3),(1507,1427590825,4),(1507,1445734826,3),(1507,1459040426,4),(1507,1477789226,3),(1507,1490490027,4),(1507,1509238827,3),(1507,1521939627,4),(1507,1540688427,3),(1507,1553994027,4),(1507,1572138027,3),(1507,1585443627,4),(1507,1603587627,3),(1507,1616893227,4),(1507,1635642027,3),(1507,1648342827,4),(1507,1667091627,3),(1507,1679792427,4),(1507,1698541227,3),(1507,1711846827,4),(1507,1729990827,3),(1507,1743296427,4),(1507,1761440427,3),(1507,1774746027,4),(1507,1792890027,3),(1507,1806195627,4),(1507,1824944427,3),(1507,1837645227,4),(1507,1856394027,3),(1507,1869094827,4),(1507,1887843627,3),(1507,1901149227,4),(1507,1919293227,3),(1507,1932598827,4),(1507,1950742827,3),(1507,1964048427,4),(1507,1982797227,3),(1507,1995498027,4),(1507,2014246827,3),(1507,2026947627,4),(1507,2045696427,3),(1507,2058397227,4),(1507,2077146027,3),(1507,2090451627,4),(1507,2108595627,3),(1507,2121901227,4),(1507,2140045227,3),(1508,-2147483648,0),(1508,-1441259328,1),(1508,-1247551200,3),(1508,354906009,2),(1508,370713610,3),(1508,386442010,2),(1508,402249611,3),(1508,417978011,2),(1508,433785612,3),(1508,449600412,2),(1508,465332412,4),(1508,481057212,5),(1508,496782013,4),(1508,512506813,5),(1508,528231613,4),(1508,543956413,5),(1508,559681213,4),(1508,575406014,5),(1508,591130814,4),(1508,606855614,5),(1508,622580414,4),(1508,638305215,5),(1508,654634815,4),(1508,670359616,6),(1508,686088016,7),(1508,695764816,4),(1508,701809216,5),(1508,717534017,4),(1508,733258817,5),(1508,748983618,4),(1508,764708418,5),(1508,780433219,4),(1508,796158019,5),(1508,811882819,4),(1508,828212420,5),(1508,846356420,4),(1508,859662020,5),(1508,877806021,4),(1508,891111621,5),(1508,909255621,4),(1508,922561222,5),(1508,941310022,4),(1508,954010822,5),(1508,972759622,4),(1508,985460422,5),(1508,1004209222,4),(1508,1017514822,5),(1508,1035658822,4),(1508,1048964422,5),(1508,1067108422,4),(1508,1080414022,5),(1508,1099162822,4),(1508,1111863622,5),(1508,1130612422,4),(1508,1143313223,5),(1508,1162062023,4),(1508,1174762823,5),(1508,1193511623,4),(1508,1206817223,5),(1508,1224961223,4),(1508,1238266824,5),(1508,1256410824,4),(1508,1269716424,6),(1508,1288468824,7),(1508,1301169624,4),(1509,-2147483648,0),(1509,-1579476700,1),(1509,-1247551200,3),(1509,354906009,2),(1509,370713610,3),(1509,386442010,2),(1509,402249611,3),(1509,417978011,2),(1509,433785612,3),(1509,449600412,2),(1509,465332412,4),(1509,481057212,5),(1509,496782013,4),(1509,512506813,5),(1509,528231613,4),(1509,543956413,5),(1509,559681213,4),(1509,575406014,5),(1509,591130814,4),(1509,606855614,5),(1509,622580414,4),(1509,638305215,5),(1509,654634815,4),(1509,670359616,6),(1509,686088016,7),(1509,695764816,4),(1509,701809216,5),(1509,717534017,4),(1509,733258817,5),(1509,738086417,8),(1509,748987218,7),(1509,764712018,6),(1509,780436819,7),(1509,796161619,6),(1509,811886419,7),(1509,828216020,6),(1509,846360020,7),(1509,859665620,6),(1509,877809621,7),(1509,891115221,6),(1509,909259221,7),(1509,922564822,6),(1509,941313622,7),(1509,954014422,6),(1509,972763222,7),(1509,985464022,6),(1509,1004212822,7),(1509,1017518422,6),(1509,1035662422,7),(1509,1048968022,6),(1509,1067112022,7),(1509,1080417622,6),(1509,1099166422,7),(1509,1111867222,6),(1509,1130616022,7),(1509,1143316823,6),(1509,1162065623,7),(1509,1174766423,6),(1509,1193515223,7),(1509,1206820823,6),(1509,1224964823,7),(1509,1238270424,6),(1509,1256414424,7),(1509,1269720024,6),(1509,1288468824,7),(1509,1301169624,4),(1509,1414263625,7),(1509,1469304026,4),(1510,-2147483648,0),(1510,-1582088010,1),(1510,-1247547600,3),(1510,354909609,2),(1510,370717210,3),(1510,386445610,2),(1510,402253211,3),(1510,417981611,2),(1510,433789212,3),(1510,449604012,2),(1510,465336012,4),(1510,481060812,5),(1510,496785613,4),(1510,512510413,5),(1510,528235213,4),(1510,543960013,5),(1510,559684813,4),(1510,575409614,5),(1510,591134414,4),(1510,606859214,5),(1510,622584014,4),(1510,638308815,5),(1510,654638415,4),(1510,670363216,6),(1510,686091616,7),(1510,695768416,4),(1510,701812816,5),(1510,717537617,4),(1510,733262417,5),(1510,748987218,4),(1510,764712018,5),(1510,780436819,4),(1510,796161619,5),(1510,811886419,4),(1510,828216020,5),(1510,846360020,4),(1510,859665620,5),(1510,877809621,4),(1510,891115221,5),(1510,909259221,4),(1510,922564822,5),(1510,941313622,4),(1510,954014422,5),(1510,972763222,4),(1510,985464022,5),(1510,1004212822,4),(1510,1017518422,5),(1510,1035662422,4),(1510,1048968022,5),(1510,1067112022,4),(1510,1080417622,5),(1510,1099166422,4),(1510,1111867222,5),(1510,1130616022,4),(1510,1143316823,5),(1510,1162065623,4),(1510,1174766423,5),(1510,1193515223,4),(1510,1206820823,5),(1510,1224964823,4),(1510,1238270424,5),(1510,1256414424,4),(1510,1269720024,5),(1510,1288468824,4),(1510,1301169624,8),(1510,1414263625,4),(1511,-2147483648,0),(1511,-1441164324,1),(1511,-1247540400,2),(1511,354913209,3),(1511,370720810,4),(1511,386445610,3),(1511,402256811,2),(1511,417985211,3),(1511,433792812,2),(1511,449607612,3),(1511,465339612,5),(1511,481064412,6),(1511,496789213,5),(1511,512514013,6),(1511,528238813,5),(1511,543963613,6),(1511,559688413,5),(1511,575413214,6),(1511,591138014,5),(1511,606862814,7),(1511,622591214,8),(1511,638316015,7),(1511,654645615,8),(1511,670370416,7),(1511,686095216,8),(1511,695772016,5),(1511,701816416,7),(1511,717544817,8),(1511,733269617,7),(1511,748994418,8),(1511,764719218,7),(1511,780444019,8),(1511,796168819,7),(1511,811893619,8),(1511,828223220,7),(1511,846367220,8),(1511,859672820,7),(1511,877816821,8),(1511,891122421,7),(1511,909266421,8),(1511,922572022,7),(1511,941320822,8),(1511,954021622,7),(1511,972770422,8),(1511,985471222,7),(1511,1004220022,8),(1511,1017525622,7),(1511,1035669622,8),(1511,1048975222,7),(1511,1067119222,8),(1511,1080424822,7),(1511,1099173622,5),(1512,-2147483648,1),(1512,-1570084924,2),(1513,-2147483648,0),(1513,-1946186240,1),(1513,-1172906240,2),(1513,-881220600,3),(1513,-766054800,2),(1513,-683883000,4),(1513,-620812800,2),(1513,-189415800,5),(1513,567964813,6),(1514,-2147483648,0),(1514,-1948782180,1),(1514,-1830414600,2),(1514,-768646800,3),(1514,1439564426,1),(1514,1525446027,3),(1515,-2147483648,0),(1515,-1577935568,1),(1515,76190400,2),(1516,-2147483648,0),(1516,-1441167268,1),(1516,-1247544000,2),(1516,354913209,3),(1516,370720810,4),(1516,386445610,3),(1516,402256811,2),(1516,417985211,3),(1516,433792812,2),(1516,449607612,3),(1516,465339612,5),(1516,481064412,6),(1516,496789213,5),(1516,512514013,6),(1516,528238813,5),(1516,543963613,6),(1516,559688413,5),(1516,575413214,6),(1516,591138014,5),(1516,606862814,6),(1516,622587614,5),(1516,638312415,6),(1516,654642015,5),(1516,670366816,7),(1516,686095216,8),(1516,695772016,5),(1516,701816416,6),(1516,717541217,5),(1516,733266017,6),(1516,748990818,5),(1516,764715618,6),(1516,780440419,5),(1516,796165219,6),(1516,811890019,5),(1516,828219620,6),(1516,846363620,5),(1516,859669220,6),(1516,877813221,5),(1516,891118821,6),(1516,909262821,5),(1516,922568422,6),(1516,941317222,5),(1516,954018022,6),(1516,972766822,5),(1516,985467622,6),(1516,1004216422,5),(1516,1017522022,6),(1516,1035666022,5),(1516,1048971622,6),(1516,1067115622,5),(1516,1080421222,6),(1516,1099170022,9),(1517,-2147483648,0),(1517,-1441167712,1),(1517,-1247544000,2),(1517,354913209,3),(1517,370720810,4),(1517,386445610,3),(1517,402256811,2),(1517,417985211,3),(1517,433792812,2),(1517,449607612,3),(1517,465339612,5),(1517,481064412,6),(1517,496789213,5),(1517,512514013,6),(1517,528238813,5),(1517,543963613,6),(1517,559688413,5),(1517,575413214,6),(1517,591138014,5),(1517,606862814,6),(1517,622587614,5),(1517,638312415,6),(1517,654642015,5),(1517,670366816,7),(1517,686095216,5),(1517,695768416,8),(1517,701812816,6),(1517,717541217,5),(1517,733266017,6),(1517,748990818,5),(1517,764715618,6),(1517,780440419,5),(1517,796165219,6),(1517,811890019,5),(1517,828219620,6),(1517,846363620,5),(1517,859669220,6),(1517,877813221,5),(1517,891118821,6),(1517,909262821,5),(1517,922568422,6),(1517,941317222,5),(1517,954018022,6),(1517,972766822,5),(1517,985467622,6),(1517,1004216422,5),(1517,1017522022,6),(1517,1035666022,5),(1517,1048971622,6),(1517,1067115622,5),(1517,1080421222,6),(1517,1099170022,8),(1517,1545328827,2),(1518,-2147483648,1),(1518,-1577946287,2),(1518,-873268200,3),(1518,-778410000,2),(1519,-2147483648,0),(1519,-719636812,1),(1520,-2147483648,0),(1520,-2004073600,1),(1520,-1851577590,2),(1520,-852105600,3),(1520,-782643600,4),(1520,-767869200,2),(1520,-718095600,3),(1520,-457776000,2),(1520,-315648000,3),(1520,171820804,2),(1521,-2147483648,0),(1521,-2031039048,1),(1521,-768560400,3),(1521,354891609,2),(1521,370699210,3),(1521,386427610,2),(1521,402235211,3),(1521,417963611,2),(1521,433771212,3),(1521,449586012,2),(1521,465318012,4),(1521,481042812,5),(1521,496767613,4),(1521,512492413,5),(1521,528217213,4),(1521,543942013,5),(1521,559666813,4),(1521,575391614,5),(1521,591116414,4),(1521,606841214,5),(1521,622566014,4),(1521,638290815,5),(1521,654620415,4),(1521,670345216,6),(1521,686073616,7),(1521,695750416,4),(1521,701794816,5),(1521,717519617,4),(1521,733244417,5),(1521,748969218,4),(1521,764694018,5),(1521,780418819,4),(1521,796143619,5),(1521,811868419,4),(1521,828198020,5),(1521,846342020,4),(1521,859647620,6),(1521,877795221,7),(1521,891100821,6),(1521,909244821,7),(1521,922550422,6),(1521,941299222,7),(1521,954000022,6),(1521,972748822,7),(1521,985449622,6),(1521,1004198422,7),(1521,1017504022,6),(1521,1035648022,7),(1521,1048953622,6),(1521,1067097622,7),(1521,1080403222,6),(1521,1099152022,7),(1521,1111852822,6),(1521,1130601622,7),(1521,1143302423,6),(1521,1162051223,7),(1521,1174752023,6),(1521,1193500823,7),(1521,1206806423,6),(1521,1224950423,7),(1521,1238256024,6),(1521,1256400024,7),(1521,1269705624,6),(1521,1288454424,7),(1521,1301155224,4),(1521,1414249225,7),(1521,1459008026,4),(1522,-2147483648,0),(1522,-1441168073,1),(1522,-1247544000,2),(1522,354913209,3),(1522,370720810,4),(1522,386445610,3),(1522,402256811,2),(1522,417985211,3),(1522,433792812,2),(1522,449607612,3),(1522,465339612,5),(1522,481064412,6),(1522,496789213,5),(1522,512514013,6),(1522,528238813,5),(1522,543963613,6),(1522,559688413,5),(1522,575413214,6),(1522,591138014,5),(1522,606862814,6),(1522,622587614,5),(1522,638312415,6),(1522,654642015,5),(1522,670366816,6),(1522,686091616,5),(1522,694206016,2),(1523,-2147483648,0),(1523,-1948782472,1),(1523,-1830414600,2),(1523,-767350800,3),(1523,-498128400,1),(1523,-462702600,4),(1523,-451733400,1),(1523,-429784200,4),(1523,-418296600,1),(1523,-399544200,4),(1523,-387451800,1),(1523,-368094600,4),(1523,-356002200,1),(1523,-336645000,4),(1523,-324552600,1),(1523,-305195400,4),(1523,-293103000,1),(1523,-264933000,3),(1523,547578013,5),(1523,560883613,3),(1523,579027614,5),(1523,592333214,3),(1524,-2147483648,2),(1524,-933667200,1),(1524,-922093200,2),(1524,-908870400,1),(1524,-888829200,2),(1524,-881049600,1),(1524,-767869200,2),(1524,-745833600,1),(1524,-733827600,2),(1524,-716889600,1),(1524,-699613200,2),(1524,-683884800,1),(1524,-670669200,2),(1524,-652348800,1),(1524,-650019600,2),(1524,515527213,1),(1524,527014813,2),(1524,545162413,1),(1524,558464413,2),(1524,577216814,1),(1524,589914014,2),(1524,608666414,1),(1524,621968414,2),(1524,640116015,1),(1524,653418015,2),(1524,671565616,1),(1524,684867616,2),(1525,-2147483648,1),(1525,-2038200925,2),(1525,-1167634800,3),(1525,-1073028000,4),(1525,-894180000,5),(1525,-879665400,6),(1525,-767005200,5),(1525,378664210,7),(1526,-2147483648,0),(1526,-1441188892,1),(1526,-1247565600,3),(1526,354891609,2),(1526,370699210,3),(1526,386427610,2),(1526,402235211,3),(1526,417963611,2),(1526,433771212,3),(1526,449586012,2),(1526,465318012,4),(1526,481042812,5),(1526,496767613,4),(1526,512492413,5),(1526,528217213,4),(1526,543942013,5),(1526,559666813,4),(1526,575391614,5),(1526,591116414,4),(1526,606841214,5),(1526,622566014,4),(1526,638290815,5),(1526,654620415,4),(1526,670345216,6),(1526,686073616,7),(1526,695750416,4),(1526,701794816,5),(1526,717519617,4),(1526,733244417,5),(1526,748969218,4),(1526,764694018,5),(1526,780418819,4),(1526,796143619,5),(1526,811868419,4),(1526,828198020,5),(1526,846342020,4),(1526,859647620,5),(1526,877791621,4),(1526,891097221,5),(1526,909241221,4),(1526,922546822,5),(1526,941295622,4),(1526,953996422,5),(1526,972745222,4),(1526,985446022,5),(1526,1004194822,4),(1526,1017500422,5),(1526,1035644422,4),(1526,1048950022,5),(1526,1067094022,4),(1526,1080399622,5),(1526,1099148422,4),(1526,1111849222,5),(1526,1130598022,4),(1526,1143298823,5),(1526,1162047623,4),(1526,1174748423,5),(1526,1193497223,4),(1526,1206802823,5),(1526,1224946823,4),(1526,1238252424,5),(1526,1256396424,4),(1526,1269702024,5),(1526,1288450824,4),(1526,1301151624,8),(1526,1414245625,4),(1527,-2147483648,1),(1527,-1017820800,2),(1527,-766224000,1),(1527,-745833600,3),(1527,-733827600,1),(1527,-716889600,3),(1527,-699613200,1),(1527,-683884800,3),(1527,-670669200,1),(1527,-652348800,3),(1527,-639133200,1),(1527,-620812800,3),(1527,-607597200,1),(1527,-589276800,3),(1527,-576061200,1),(1527,-562924800,3),(1527,-541760400,1),(1527,-528710400,3),(1527,-510224400,1),(1527,-497174400,3),(1527,-478688400,1),(1527,-465638400,3),(1527,-449830800,1),(1527,-434016000,3),(1527,-418208400,1),(1527,-402480000,3),(1527,-386672400,1),(1527,-370944000,3),(1527,-355136400,1),(1527,-339408000,3),(1527,-323600400,1),(1527,-302515200,3),(1527,-291978000,1),(1527,-270979200,3),(1527,-260442000,1),(1527,133977603,3),(1527,149785203,1),(1527,165513604,3),(1527,181321204,1),(1527,299606408,3),(1527,307551608,1),(1528,-2147483648,0),(1528,-1441168631,1),(1528,-1247547600,3),(1528,354909609,2),(1528,370717210,3),(1528,386445610,2),(1528,402253211,3),(1528,417981611,2),(1528,433789212,3),(1528,449604012,2),(1528,465336012,4),(1528,481060812,5),(1528,496785613,4),(1528,512510413,5),(1528,528235213,4),(1528,543960013,5),(1528,559684813,4),(1528,575409614,5),(1528,591134414,4),(1528,606859214,5),(1528,622584014,4),(1528,638308815,5),(1528,654638415,4),(1528,670363216,6),(1528,686091616,7),(1528,694206016,1),(1529,-2147483648,1),(1529,-1441162751,2),(1529,-405140400,4),(1529,354916809,3),(1529,370724410,4),(1529,386452810,3),(1529,402260411,4),(1529,417988811,3),(1529,433796412,4),(1529,449611212,3),(1529,465343212,5),(1529,481068012,6),(1529,496792813,5),(1529,512517613,6),(1529,528242413,5),(1529,543967213,6),(1529,559692013,5),(1529,575416814,6),(1529,591141614,5),(1529,606866414,6),(1529,622591214,5),(1529,638316015,6),(1529,654645615,5),(1529,670370416,7),(1529,686098816,8),(1529,694213216,2),(1529,701816416,9),(1529,717537617,2),(1529,733266017,9),(1529,748987218,2),(1529,764715618,9),(1529,780436819,4),(1529,796161619,3),(1529,811882819,4),(1529,828216020,3),(1529,859662020,3),(1529,877806021,4),(1529,891115221,3),(1529,909255621,4),(1529,922564822,3),(1529,941310022,4),(1529,954014422,3),(1529,972759622,4),(1529,985464022,3),(1529,1004209222,4),(1529,1017518422,3),(1529,1035658822,4),(1529,1048968022,3),(1529,1067108422,4),(1529,1080417622,3),(1529,1088276422,9),(1529,1099177222,8),(1529,1111878022,4),(1530,-2147483648,0),(1530,-1704165944,1),(1530,-757394744,2),(1530,247177806,4),(1530,259272007,3),(1530,277758007,4),(1530,283982407,2),(1530,290809808,5),(1530,306531008,2),(1530,322432209,5),(1530,338499009,2),(1530,673216216,5),(1530,685481416,2),(1530,701209816,5),(1530,717103817,2),(1530,732745817,5),(1530,748639818,2),(1530,764281818,5),(1530,780175819,2),(1530,795817819,5),(1530,811711819,2),(1530,827353820,5),(1530,843247820,2),(1530,858976220,5),(1530,874870221,2),(1530,890512221,5),(1530,906406221,2),(1530,922048222,5),(1530,937942222,2),(1530,953584222,5),(1530,969478222,2),(1530,985206622,5),(1530,1001100622,2),(1530,1016742622,5),(1530,1032636622,2),(1530,1048278622,5),(1530,1064172622,2),(1530,1079814622,5),(1530,1095708622,2),(1530,1111437022,5),(1530,1127331022,2),(1530,1206045023,5),(1530,1221939023,2),(1530,1237667424,5),(1530,1253561424,2),(1530,1269203424,5),(1530,1285097424,2),(1530,1300739424,5),(1530,1316633424,2),(1530,1332275424,5),(1530,1348169425,2),(1530,1363897825,5),(1530,1379791825,2),(1530,1395433825,5),(1530,1411327825,2),(1530,1426969825,5),(1530,1442863826,2),(1530,1458505826,5),(1530,1474399826,2),(1530,1490128227,5),(1530,1506022227,2),(1530,1521664227,5),(1530,1537558227,2),(1530,1553200227,5),(1530,1569094227,2),(1530,1584736227,5),(1530,1600630227,2),(1530,1616358627,5),(1530,1632252627,2),(1530,1647894627,5),(1530,1663788627,2),(1530,1679430627,5),(1530,1695324627,2),(1530,1710966627,5),(1530,1726860627,2),(1530,1742589027,5),(1530,1758483027,2),(1530,1774125027,5),(1530,1790019027,2),(1530,1805661027,5),(1530,1821555027,2),(1530,1837197027,5),(1530,1853091027,2),(1530,1868733027,5),(1530,1884627027,2),(1530,1900355427,5),(1530,1916249427,2),(1530,1931891427,5),(1530,1947785427,2),(1530,1963427427,5),(1530,1979321427,2),(1530,1994963427,5),(1530,2010857427,2),(1530,2026585827,5),(1530,2042479827,2),(1530,2058121827,5),(1530,2074015827,2),(1530,2089657827,5),(1530,2105551827,2),(1530,2121193827,5),(1530,2137087827,2),(1531,-2147483648,1),(1531,-1641003640,3),(1531,-933645600,2),(1531,-857358000,3),(1531,-844300800,2),(1531,-825822000,3),(1531,-812685600,2),(1531,-794199600,3),(1531,-779853600,2),(1531,-762656400,3),(1531,-748310400,2),(1531,-731127600,3),(1531,-681962400,4),(1531,-673243200,2),(1531,-667962000,3),(1531,-652327200,2),(1531,-636426000,3),(1531,-622087200,2),(1531,-608947200,3),(1531,-591847200,2),(1531,-572486400,3),(1531,-558576000,2),(1531,-542851200,3),(1531,-527731200,2),(1531,-514425600,3),(1531,-490845600,2),(1531,-482986800,3),(1531,-459475200,2),(1531,-451537200,3),(1531,-428551200,2),(1531,-418262400,3),(1531,-400032000,2),(1531,-387428400,3),(1531,142380003,2),(1531,150843603,3),(1531,167176804,2),(1531,178664404,3),(1531,334015209,2),(1531,337644009,3),(1531,452556012,2),(1531,462232812,3),(1531,482277612,2),(1531,495579613,3),(1531,516751213,2),(1531,526424413,3),(1531,545436013,2),(1531,558478813,3),(1531,576626414,2),(1531,589323614,3),(1531,609890414,2),(1531,620773214,3),(1531,638316015,2),(1531,651618015,3),(1531,669765616,2),(1531,683672416,3),(1531,701820016,2),(1531,715726817,3),(1531,733701617,2),(1531,747176418,3),(1531,765151218,2),(1531,778021219,3),(1531,796600819,2),(1531,810075619,3),(1531,826840820,2),(1531,842821220,3),(1531,858895220,2),(1531,874184421,3),(1531,890344821,2),(1531,905029221,3),(1531,923011222,2),(1531,936313222,3),(1531,955670422,2),(1531,970783222,3),(1531,986770822,2),(1531,1001282422,3),(1531,1017356422,2),(1531,1033941622,3),(1531,1048806022,2),(1531,1065132022,3),(1531,1081292422,2),(1531,1095804022,3),(1531,1112313622,2),(1531,1128812422,3),(1531,1143763223,2),(1531,1159657223,3),(1531,1175212823,2),(1531,1189897223,3),(1531,1206662423,2),(1531,1223161223,3),(1531,1238112024,2),(1531,1254006024,3),(1531,1269561624,2),(1531,1284246024,3),(1531,1301616024,2),(1531,1317510024,3),(1531,1333065624,2),(1531,1348354825,3),(1531,1364515225,2),(1531,1382828425,3),(1531,1395964825,2),(1531,1414278025,3),(1531,1427414425,2),(1531,1445727626,3),(1531,1458864026,2),(1531,1477782026,3),(1531,1490313627,2),(1531,1509231627,3),(1531,1521763227,2),(1531,1540681227,3),(1531,1553817627,2),(1531,1572130827,3),(1531,1585267227,2),(1531,1603580427,3),(1531,1616716827,2),(1531,1635634827,3),(1531,1648166427,2),(1531,1667084427,3),(1531,1679616027,2),(1531,1698534027,3),(1531,1711670427,2),(1531,1729983627,3),(1531,1743120027,2),(1531,1761433227,3),(1531,1774569627,2),(1531,1792882827,3),(1531,1806019227,2),(1531,1824937227,3),(1531,1837468827,2),(1531,1856386827,3),(1531,1868918427,2),(1531,1887836427,3),(1531,1900972827,2),(1531,1919286027,3),(1531,1932422427,2),(1531,1950735627,3),(1531,1963872027,2),(1531,1982790027,3),(1531,1995321627,2),(1531,2014239627,3),(1531,2026771227,2),(1531,2045689227,3),(1531,2058220827,2),(1531,2077138827,3),(1531,2090275227,2),(1531,2108588427,3),(1531,2121724827,2),(1531,2140038027,3),(1532,-2147483648,0),(1532,-706341516,1),(1532,560025013,2),(1533,-2147483648,0),(1533,-706341516,1),(1533,560025013,2),(1534,-2147483648,3),(1534,-683802000,1),(1534,-672310800,2),(1534,-654771600,1),(1534,-640861200,2),(1534,-620298000,1),(1534,-609411600,2),(1534,-588848400,1),(1534,-577962000,2),(1535,-2147483648,0),(1535,-1578807591,1),(1535,-1247551200,3),(1535,354906009,2),(1535,370713610,3),(1535,386442010,2),(1535,402249611,3),(1535,417978011,2),(1535,433785612,3),(1535,449600412,2),(1535,465332412,4),(1535,481057212,5),(1535,496782013,4),(1535,512506813,5),(1535,528231613,4),(1535,543956413,5),(1535,559681213,4),(1535,575406014,5),(1535,591130814,4),(1535,606855614,5),(1535,622580414,4),(1535,638305215,5),(1535,654634815,4),(1535,670359616,6),(1535,686088016,7),(1535,695764816,4),(1535,701809216,5),(1535,717534017,4),(1535,733258817,5),(1535,748983618,4),(1535,764708418,5),(1535,780433219,4),(1535,796158019,5),(1535,811882819,4),(1535,828212420,5),(1535,846356420,4),(1535,859662020,5),(1535,877806021,4),(1535,891111621,5),(1535,909255621,4),(1535,922561222,5),(1535,941310022,4),(1535,954010822,5),(1535,972759622,4),(1535,985460422,5),(1535,1004209222,4),(1535,1017514822,5),(1535,1020193222,8),(1535,1035662422,7),(1535,1048968022,6),(1535,1067112022,7),(1535,1080417622,6),(1535,1099166422,7),(1535,1111867222,6),(1535,1130616022,7),(1535,1143316823,6),(1535,1162065623,7),(1535,1174766423,6),(1535,1193515223,7),(1535,1206820823,6),(1535,1224964823,7),(1535,1238270424,6),(1535,1256414424,7),(1535,1269720024,6),(1535,1288468824,7),(1535,1301169624,4),(1535,1414263625,7),(1535,1464465626,4),(1536,-2147483648,0),(1536,-1577951856,1),(1536,-1172908656,2),(1536,-880272000,3),(1536,-766054800,4),(1537,-2147483648,0),(1537,-2032931252,1),(1537,252435606,3),(1537,417974411,2),(1537,433782012,3),(1537,449596812,2),(1537,465318012,3),(1537,481046412,2),(1537,496767613,3),(1537,512496013,2),(1537,528217213,3),(1537,543945613,2),(1537,559666813,3),(1537,575395214,2),(1537,591116414,3),(1537,606844814,2),(1537,622566014,3),(1537,638294415,2),(1537,654620415,3),(1537,670348816,2),(1537,686070016,3),(1537,701798416,2),(1537,717519617,3),(1537,733248017,2),(1537,748969218,3),(1537,764697618,2),(1537,780418819,3),(1537,796147219,2),(1537,811868419,3),(1537,828201620,2),(1537,843922820,3),(1537,859651220,2),(1537,875372421,3),(1537,891100821,2),(1537,906822021,3),(1537,988394422,2),(1537,1001696422,3),(1537,1017424822,2),(1537,1033146022,3),(1537,1048874422,2),(1537,1064595622,3),(1537,1080324022,2),(1537,1096045222,3),(1537,1111773622,2),(1537,1127494822,3),(1537,1143223223,2),(1537,1159549223,3),(1537,1427479225,2),(1537,1443193226,3),(1537,1458928826,2),(1537,1474642826,3),(1538,-2147483648,0),(1538,-2032931252,1),(1538,252435606,3),(1538,417974411,2),(1538,433782012,3),(1538,449596812,2),(1538,465318012,3),(1538,481046412,2),(1538,496767613,3),(1538,512496013,2),(1538,528217213,3),(1538,543945613,2),(1538,559666813,3),(1538,575395214,2),(1538,591116414,3),(1538,606844814,2),(1538,622566014,3),(1538,638294415,2),(1538,654620415,3),(1538,670348816,2),(1538,686070016,3),(1538,701798416,2),(1538,717519617,3),(1538,733248017,2),(1538,748969218,3),(1538,764697618,2),(1538,780418819,3),(1538,796147219,2),(1538,811868419,3),(1538,828201620,2),(1538,843922820,3),(1538,859651220,2),(1538,875372421,3),(1538,891100821,2),(1538,906822021,3),(1538,988394422,2),(1538,1001696422,3),(1538,1017424822,2),(1538,1033146022,3),(1538,1048874422,2),(1538,1064595622,3),(1538,1080324022,2),(1538,1096045222,3),(1538,1111773622,2),(1538,1127494822,3),(1538,1143223223,2),(1538,1159549223,3),(1538,1427479225,2),(1538,1443193226,3),(1538,1458928826,2),(1538,1474642826,3),(1539,-2147483648,0),(1539,-1325483420,1),(1540,-2147483648,0),(1540,-1579426374,1),(1540,-1247558400,2),(1540,354898809,4),(1540,370699210,3),(1540,386427610,4),(1540,402235211,3),(1540,417963611,4),(1540,433771212,3),(1540,449586012,4),(1540,465318012,5),(1540,481042812,6),(1540,496767613,5),(1540,512492413,6),(1540,528217213,5),(1540,543942013,6),(1540,559666813,5),(1540,575391614,6),(1540,591116414,5),(1540,606841214,6),(1540,622566014,5),(1540,638290815,6),(1540,654620415,5),(1540,670345216,7),(1540,686073616,8),(1540,695750416,5),(1540,701794816,6),(1540,717519617,5),(1540,733244417,6),(1540,748969218,5),(1540,764694018,6),(1540,780418819,5),(1540,796143619,6),(1540,811868419,5),(1540,828198020,6),(1540,846342020,5),(1540,859647620,6),(1540,877791621,5),(1540,891097221,6),(1540,909241221,5),(1540,922546822,6),(1540,941295622,5),(1540,953996422,6),(1540,972745222,5),(1540,985446022,6),(1540,1004194822,5),(1540,1017500422,6),(1540,1035644422,5),(1540,1048950022,6),(1540,1067094022,5),(1540,1080399622,6),(1540,1099148422,5),(1540,1111849222,6),(1540,1130598022,5),(1540,1143298823,6),(1540,1162047623,5),(1540,1174748423,6),(1540,1193497223,5),(1540,1206802823,6),(1540,1224946823,5),(1540,1238252424,6),(1540,1256396424,5),(1540,1269702024,6),(1540,1288450824,5),(1540,1301151624,9),(1540,1315828824,5),(1540,1414249225,8),(1541,-2147483648,1),(1541,-1570084924,2),(1542,-2147483648,0),(1542,-1487321251,1),(1542,-1247562000,3),(1542,354895209,2),(1542,370702810,3),(1542,386431210,2),(1542,402238811,3),(1542,417967211,2),(1542,433774812,3),(1542,449589612,2),(1542,465321612,4),(1542,481046412,5),(1542,496771213,4),(1542,512496013,5),(1542,528220813,4),(1542,543945613,5),(1542,559670413,4),(1542,575395214,5),(1542,591120014,4),(1542,606844814,5),(1542,622569614,4),(1542,638294415,5),(1542,654624015,4),(1542,670348816,6),(1542,686077216,7),(1542,695754016,4),(1542,701798416,5),(1542,717523217,4),(1542,733248017,5),(1542,748972818,4),(1542,764697618,5),(1542,780422419,4),(1542,796147219,5),(1542,811872019,4),(1542,828201620,5),(1542,846345620,4),(1542,859651220,5),(1542,877795221,4),(1542,891100821,5),(1542,909244821,4),(1542,922550422,5),(1542,941299222,4),(1542,954000022,5),(1542,972748822,4),(1542,985449622,5),(1542,1004198422,4),(1542,1017504022,5),(1542,1035648022,4),(1542,1048953622,5),(1542,1067097622,4),(1542,1080403222,5),(1542,1099152022,4),(1542,1111852822,5),(1542,1130601622,4),(1542,1143302423,5),(1542,1162051223,4),(1542,1174752023,5),(1542,1193500823,4),(1542,1206806423,5),(1542,1224950423,4),(1542,1238256024,5),(1542,1256400024,4),(1542,1269705624,5),(1542,1288454424,4),(1542,1301155224,8),(1542,1414249225,4),(1543,-2147483648,0),(1543,-1579423138,1),(1543,-1247558400,3),(1543,354898809,2),(1543,370706410,3),(1543,386434810,2),(1543,402242411,3),(1543,417970811,2),(1543,433778412,3),(1543,449593212,2),(1543,465325212,4),(1543,481050012,5),(1543,496774813,4),(1543,512499613,5),(1543,528224413,4),(1543,543949213,5),(1543,559674013,4),(1543,575398814,5),(1543,591123614,4),(1543,606848414,5),(1543,622573214,4),(1543,638298015,5),(1543,654627615,4),(1543,670352416,6),(1543,686080816,7),(1543,695757616,4),(1543,701802016,5),(1543,717526817,4),(1543,733251617,5),(1543,748976418,4),(1543,764701218,5),(1543,780426019,4),(1543,796150819,5),(1543,811875619,4),(1543,828205220,5),(1543,846349220,4),(1543,859654820,5),(1543,877798821,4),(1543,891104421,5),(1543,909248421,4),(1543,922554022,5),(1543,941302822,4),(1543,954003622,5),(1543,972752422,4),(1543,985453222,5),(1543,1004202022,4),(1543,1017507622,5),(1543,1035651622,4),(1543,1048957222,5),(1543,1067101222,4),(1543,1080406822,5),(1543,1099155622,4),(1543,1111856422,5),(1543,1130605222,4),(1543,1143306023,5),(1543,1162054823,4),(1543,1174755623,5),(1543,1193504423,4),(1543,1206810023,5),(1543,1224954023,4),(1543,1238259624,5),(1543,1256403624,4),(1543,1269709224,5),(1543,1288458024,4),(1543,1301158824,8),(1543,1414252825,4),(1544,-2147483648,1),(1544,-1577946287,2),(1544,-873268200,3),(1544,-778410000,2),(1545,-2147483648,0),(1545,-1688270553,1),(1545,-1592610305,2),(1545,-1247544000,4),(1545,354913209,3),(1545,370720810,4),(1545,386449210,3),(1545,402256811,4),(1545,417985211,3),(1545,433792812,4),(1545,449607612,3),(1545,465339612,5),(1545,481064412,6),(1545,496789213,5),(1545,512514013,6),(1545,528238813,5),(1545,543963613,6),(1545,559688413,5),(1545,575413214,6),(1545,591138014,5),(1545,606862814,6),(1545,622587614,5),(1545,638312415,6),(1545,654642015,5),(1545,670366816,7),(1545,686095216,8),(1545,695772016,5),(1545,701816416,6),(1545,717541217,5),(1545,733266017,6),(1545,748990818,5),(1545,764715618,6),(1545,780440419,5),(1545,796165219,6),(1545,811890019,5),(1545,828219620,6),(1545,846363620,5),(1545,859669220,6),(1545,877813221,5),(1545,891118821,6),(1545,909262821,5),(1545,922568422,6),(1545,941317222,5),(1545,954018022,6),(1545,972766822,5),(1545,985467622,6),(1545,1004216422,5),(1545,1017522022,6),(1545,1035666022,5),(1545,1048971622,6),(1545,1067115622,5),(1545,1080421222,6),(1545,1099170022,5),(1545,1111870822,6),(1545,1130619622,5),(1545,1143320423,6),(1545,1162069223,5),(1545,1174770023,6),(1545,1193518823,5),(1545,1206824423,6),(1545,1224968423,5),(1545,1238274024,6),(1545,1256418024,5),(1545,1269723624,6),(1545,1288472424,5),(1545,1301173224,9),(1545,1414267225,5),(1546,-2147483648,0),(1546,-1441162680,1),(1546,-405140400,3),(1546,354916809,2),(1546,370724410,3),(1546,386452810,2),(1546,402260411,3),(1546,417988811,2),(1546,433796412,3),(1546,449611212,2),(1546,465343212,4),(1546,481068012,5),(1546,496792813,4),(1546,512517613,5),(1546,528242413,4),(1546,543967213,5),(1546,559692013,4),(1546,575416814,5),(1546,591141614,4),(1546,606866414,5),(1546,622591214,4),(1546,638316015,5),(1546,654645615,4),(1546,670370416,6),(1546,686098816,7),(1546,701823616,6),(1546,717548417,7),(1546,733273217,6),(1546,748998018,7),(1546,764722818,6),(1546,780447619,7),(1546,796172419,6),(1546,811897219,4),(1546,852062420,3),(1546,859672820,5),(1546,877816821,4),(1546,891122421,5),(1546,909266421,4),(1546,922572022,5),(1546,941320822,4),(1546,954021622,5),(1546,972770422,4),(1546,985471222,5),(1546,1004220022,4),(1546,1017525622,5),(1546,1035669622,4),(1546,1048975222,5),(1546,1067119222,4),(1546,1080424822,5),(1546,1099173622,4),(1546,1111874422,5),(1546,1130623222,4),(1546,1143324023,5),(1546,1162072823,4),(1546,1174773623,5),(1546,1193522423,4),(1546,1206828023,5),(1546,1224972023,4),(1546,1238277624,5),(1546,1256421624,4),(1546,1269727224,5),(1546,1288476024,4),(1546,1293825624,3),(1546,1301176824,5),(1546,1319925624,4),(1547,-2147483648,1),(1547,-1830376800,6),(1547,-1689548400,2),(1547,-1677794400,3),(1547,-1667430000,4),(1547,-1647730800,5),(1547,-1635807600,4),(1547,-1616194800,5),(1547,-1604358000,4),(1547,-1584658800,5),(1547,-1572735600,4),(1547,-1553036400,5),(1547,-1541199600,4),(1547,-1521500400,5),(1547,-1442444400,4),(1547,-1426806000,5),(1547,-1379286000,4),(1547,-1364770800,5),(1547,-1348441200,4),(1547,-1333321200,5),(1547,-1316386800,4),(1547,-1301266800,5),(1547,-1284332400,4),(1547,-1269817200,5),(1547,-1221433200,4),(1547,-1206918000,5),(1547,-1191193200,4),(1547,-1175468400,5),(1547,-1127689200,4),(1547,-1111964400,5),(1547,-1096844400,4),(1547,-1080514800,5),(1547,-1063580400,4),(1547,-1049065200,5),(1547,-1033340400,4),(1547,-1017615600,5),(1547,-1002495600,4),(1547,-986166000,5),(1547,-969231600,4),(1547,-950482800,5),(1547,-942015600,4),(1547,-922662000,5),(1547,-906937200,4),(1547,-891126000,5),(1547,-877302000,4),(1547,-873676800,7),(1547,-864000000,4),(1547,-857948400,5),(1547,-845852400,4),(1547,-842832000,7),(1547,-831340800,4),(1547,-825894000,5),(1547,-814402800,4),(1547,-810777600,7),(1547,-799891200,4),(1547,-794444400,5),(1547,-782953200,4),(1547,-779328000,7),(1547,-768441600,4),(1547,-762994800,5),(1547,-749084400,4),(1547,-733359600,5),(1547,-717624000,4),(1547,-701899200,5),(1547,-686174400,4),(1547,-670449600,5),(1547,-654724800,4),(1547,-639000000,5),(1547,-591825600,4),(1547,-575496000,5),(1547,-559771200,4),(1547,-544046400,5),(1547,-528321600,4),(1547,-512596800,5),(1547,-496872000,4),(1547,-481147200,5),(1547,-465422400,4),(1547,-449697600,5),(1547,-433972800,4),(1547,-417643200,5),(1547,-401918400,4),(1547,-386193600,5),(1547,-370468800,4),(1547,-354744000,5),(1547,-339019200,4),(1547,-323294400,5),(1547,-307569600,4),(1547,-291844800,5),(1547,-276120000,4),(1547,-260395200,5),(1547,-244670400,4),(1547,-228340800,5),(1547,-212616000,4),(1547,-196891200,5),(1547,-181166400,4),(1547,-165441600,5),(1547,-149716800,4),(1547,-133992000,5),(1547,-118267200,9),(1547,228272406,7),(1547,243997206,8),(1547,260326807,7),(1547,276051607,8),(1547,291776408,7),(1547,307504808,8),(1547,323226009,7),(1547,338954409,8),(1547,354679209,7),(1547,370404010,8),(1547,386128810,7),(1547,401853611,8),(1547,417582011,7),(1547,433303212,8),(1547,449028012,7),(1547,465357612,8),(1547,481082412,7),(1547,496807213,8),(1547,512532013,7),(1547,528256813,8),(1547,543981613,7),(1547,559706413,8),(1547,575431214,7),(1547,591156014,8),(1547,606880814,7),(1547,622605614,8),(1547,638330415,7),(1547,654660015,8),(1547,670384816,7),(1547,686109616,8),(1547,701834416,7),(1547,717559217,10),(1547,733280417,11),(1547,749005218,12),(1547,764730018,11),(1547,780454819,12),(1547,796179619,11),(1547,811904419,12),(1547,828234020,11),(1547,846378020,12),(1547,859683620,11),(1547,877827621,12),(1547,891133221,11),(1547,909277221,12),(1547,922582822,11),(1547,941331622,12),(1547,954032422,11),(1547,972781222,12),(1547,985482022,11),(1547,1004230822,12),(1547,1017536422,11),(1547,1035680422,12),(1547,1048986022,11),(1547,1067130022,12),(1547,1080435622,11),(1547,1099184422,12),(1547,1111885222,11),(1547,1130634022,12),(1547,1143334823,11),(1547,1162083623,12),(1547,1174784423,11),(1547,1193533223,12),(1547,1206838823,11),(1547,1224982823,12),(1547,1238288424,11),(1547,1256432424,12),(1547,1269738024,11),(1547,1288486824,12),(1547,1301187624,11),(1547,1319936424,12),(1547,1332637224,11),(1547,1351386025,12),(1547,1364691625,11),(1547,1382835625,12),(1547,1396141225,11),(1547,1414285225,12),(1547,1427590825,11),(1547,1445734826,12),(1547,1459040426,11),(1547,1477789226,12),(1547,1490490027,11),(1547,1509238827,12),(1547,1521939627,11),(1547,1540688427,12),(1547,1553994027,11),(1547,1572138027,12),(1547,1585443627,11),(1547,1603587627,12),(1547,1616893227,11),(1547,1635642027,12),(1547,1648342827,11),(1547,1667091627,12),(1547,1679792427,11),(1547,1698541227,12),(1547,1711846827,11),(1547,1729990827,12),(1547,1743296427,11),(1547,1761440427,12),(1547,1774746027,11),(1547,1792890027,12),(1547,1806195627,11),(1547,1824944427,12),(1547,1837645227,11),(1547,1856394027,12),(1547,1869094827,11),(1547,1887843627,12),(1547,1901149227,11),(1547,1919293227,12),(1547,1932598827,11),(1547,1950742827,12),(1547,1964048427,11),(1547,1982797227,12),(1547,1995498027,11),(1547,2014246827,12),(1547,2026947627,11),(1547,2045696427,12),(1547,2058397227,11),(1547,2077146027,12),(1547,2090451627,11),(1547,2108595627,12),(1547,2121901227,11),(1547,2140045227,12),(1548,-2147483648,0),(1548,-1262281242,1),(1548,136360803,2),(1548,152082003,1),(1548,167810404,2),(1548,183531604,1),(1548,199260005,2),(1548,215586005,1),(1548,230709606,2),(1548,247035606,1),(1548,262764007,2),(1548,278485207,1),(1548,294213608,2),(1548,309934808,1),(1548,325663209,2),(1548,341384409,1),(1548,357112809,2),(1548,372834010,1),(1548,388562410,2),(1548,404888411,1),(1548,420012011,2),(1548,436338012,1),(1548,452066412,2),(1548,467787612,1),(1548,483516012,2),(1548,499237213,1),(1548,514965613,2),(1548,530686813,1),(1548,544600813,2),(1548,562136413,1),(1548,576050414,2),(1548,594190814,1),(1548,607500014,2),(1548,625640414,1),(1548,638949615,2),(1548,657090015,1),(1548,671004016,2),(1548,688539616,1),(1548,702453616,2),(1548,719989217,1),(1548,733903217,2),(1548,752043618,1),(1548,765352818,2),(1548,783493219,1),(1548,796802419,2),(1548,814942819,1),(1548,828856820,2),(1548,846392420,1),(1548,860306420,2),(1548,877842021,1),(1548,891756021,2),(1548,909291621,1),(1548,923205622,2),(1548,941346022,1),(1548,954655222,2),(1548,972795622,1),(1548,986104822,2),(1548,1004245222,1),(1548,1018159222,2),(1548,1035694822,1),(1548,1049608822,2),(1548,1067144422,1),(1548,1081058422,2),(1548,1099198822,1),(1548,1112508022,2),(1548,1130648422,1),(1548,1143957623,2),(1548,1162098023,1),(1548,1173592823,2),(1548,1194152423,1),(1548,1205042423,2),(1548,1225602023,1),(1548,1236492024,2),(1548,1257051624,1),(1548,1268546424,2),(1548,1289106024,1),(1548,1299996024,2),(1548,1320555624,1),(1548,1331445624,2),(1548,1352005225,1),(1548,1362895225,2),(1548,1383454825,1),(1548,1394344825,2),(1548,1414904425,1),(1548,1425794425,2),(1548,1446354026,1),(1548,1457848826,2),(1548,1478408426,1),(1548,1489298427,2),(1548,1509858027,1),(1548,1520748027,2),(1548,1541307627,1),(1548,1552197627,2),(1548,1572757227,1),(1548,1583647227,2),(1548,1604206827,1),(1548,1615701627,2),(1548,1636261227,1),(1548,1647151227,2),(1548,1667710827,1),(1548,1678600827,2),(1548,1699160427,1),(1548,1710050427,2),(1548,1730610027,1),(1548,1741500027,2),(1548,1762059627,1),(1548,1772949627,2),(1548,1793509227,1),(1548,1805004027,2),(1548,1825563627,1),(1548,1836453627,2),(1548,1857013227,1),(1548,1867903227,2),(1548,1888462827,1),(1548,1899352827,2),(1548,1919912427,1),(1548,1930802427,2),(1548,1951362027,1),(1548,1962856827,2),(1548,1983416427,1),(1548,1994306427,2),(1548,2014866027,1),(1548,2025756027,2),(1548,2046315627,1),(1548,2057205627,2),(1548,2077765227,1),(1548,2088655227,2),(1548,2109214827,1),(1548,2120104827,2),(1548,2140664427,1),(1549,-2147483648,0),(1549,-1509663504,1),(1549,-733874400,2),(1549,323827209,3),(1549,338950809,4),(1549,354675609,5),(1549,370400410,4),(1549,386125210,5),(1549,401850011,4),(1549,417574811,5),(1549,433299612,4),(1549,449024412,5),(1549,465354012,4),(1549,481078812,5),(1549,496803613,4),(1549,512528413,5),(1549,528253213,4),(1549,543978013,5),(1549,559702813,4),(1549,575427614,5),(1549,591152414,4),(1549,606877214,5),(1549,622602014,4),(1549,638326815,5),(1549,654656415,4),(1549,670381216,5),(1549,686106016,4),(1549,701830816,5),(1549,717555617,4),(1549,733280417,5),(1549,749005218,4),(1549,764730018,5),(1549,780454819,4),(1549,796179619,5),(1549,811904419,4),(1549,828234020,5),(1549,846378020,4),(1549,859683620,5),(1549,877827621,4),(1549,891133221,5),(1549,909277221,4),(1549,922582822,5),(1549,941331622,4),(1549,954032422,5),(1549,972781222,4),(1549,985482022,5),(1549,1004230822,4),(1549,1017536422,5),(1549,1035680422,4),(1549,1048986022,5),(1549,1067130022,4),(1549,1080435622,5),(1549,1099184422,4),(1549,1111885222,5),(1549,1130634022,4),(1549,1143334823,5),(1549,1162083623,4),(1549,1174784423,5),(1549,1193533223,4),(1549,1206838823,5),(1549,1224982823,4),(1549,1238288424,5),(1549,1256432424,4),(1549,1269738024,5),(1549,1288486824,4),(1549,1301187624,5),(1549,1319936424,4),(1549,1332637224,5),(1549,1351386025,4),(1549,1364691625,5),(1549,1382835625,4),(1549,1396141225,5),(1549,1414285225,4),(1549,1427590825,5),(1549,1445734826,4),(1549,1459040426,5),(1549,1477789226,4),(1549,1490490027,5),(1549,1509238827,4),(1549,1521939627,5),(1549,1540688427,4),(1549,1553994027,5),(1549,1572138027,4),(1549,1585443627,5),(1549,1603587627,4),(1549,1616893227,5),(1549,1635642027,4),(1549,1648342827,5),(1549,1667091627,4),(1549,1679792427,5),(1549,1698541227,4),(1549,1711846827,5),(1549,1729990827,4),(1549,1743296427,5),(1549,1761440427,4),(1549,1774746027,5),(1549,1792890027,4),(1549,1806195627,5),(1549,1824944427,4),(1549,1837645227,5),(1549,1856394027,4),(1549,1869094827,5),(1549,1887843627,4),(1549,1901149227,5),(1549,1919293227,4),(1549,1932598827,5),(1549,1950742827,4),(1549,1964048427,5),(1549,1982797227,4),(1549,1995498027,5),(1549,2014246827,4),(1549,2026947627,5),(1549,2045696427,4),(1549,2058397227,5),(1549,2077146027,4),(1549,2090451627,5),(1549,2108595627,4),(1549,2121901227,5),(1549,2140045227,4),(1550,-2147483648,0),(1550,-1830376800,1),(1550,-862610400,2),(1550,-764118000,3),(1550,186120004,4),(1551,-2147483648,0),(1551,-1955748776,1),(1551,354675609,2),(1551,370400410,3),(1551,386125210,2),(1551,401850011,3),(1551,417574811,2),(1551,433299612,3),(1551,449024412,2),(1551,465354012,3),(1551,481078812,2),(1551,496803613,3),(1551,512528413,2),(1551,528253213,3),(1551,543978013,2),(1551,559702813,3),(1551,575427614,2),(1551,591152414,3),(1551,606877214,2),(1551,622602014,3),(1551,638326815,2),(1551,654656415,3),(1551,670381216,2),(1551,686106016,3),(1551,701830816,2),(1551,717555617,3),(1551,733280417,2),(1551,749005218,3),(1551,764730018,2),(1551,780454819,3),(1551,796179619,2),(1551,811904419,3),(1551,828234020,2),(1551,846378020,3),(1551,859683620,2),(1551,877827621,3),(1551,891133221,2),(1551,909277221,3),(1551,922582822,2),(1551,941331622,3),(1551,954032422,2),(1551,972781222,3),(1551,985482022,2),(1551,1004230822,3),(1551,1017536422,2),(1551,1035680422,3),(1551,1048986022,2),(1551,1067130022,3),(1551,1080435622,2),(1551,1099184422,3),(1551,1111885222,2),(1551,1130634022,3),(1551,1143334823,2),(1551,1162083623,3),(1551,1174784423,2),(1551,1193533223,3),(1551,1206838823,2),(1551,1224982823,3),(1551,1238288424,2),(1551,1256432424,3),(1551,1269738024,2),(1551,1288486824,3),(1551,1301187624,2),(1551,1319936424,3),(1551,1332637224,2),(1551,1351386025,3),(1551,1364691625,2),(1551,1382835625,3),(1551,1396141225,2),(1551,1414285225,3),(1551,1427590825,2),(1551,1445734826,3),(1551,1459040426,2),(1551,1477789226,3),(1551,1490490027,2),(1551,1509238827,3),(1551,1521939627,2),(1551,1540688427,3),(1551,1553994027,2),(1551,1572138027,3),(1551,1585443627,2),(1551,1603587627,3),(1551,1616893227,2),(1551,1635642027,3),(1551,1648342827,2),(1551,1667091627,3),(1551,1679792427,2),(1551,1698541227,3),(1551,1711846827,2),(1551,1729990827,3),(1551,1743296427,2),(1551,1761440427,3),(1551,1774746027,2),(1551,1792890027,3),(1551,1806195627,2),(1551,1824944427,3),(1551,1837645227,2),(1551,1856394027,3),(1551,1869094827,2),(1551,1887843627,3),(1551,1901149227,2),(1551,1919293227,3),(1551,1932598827,2),(1551,1950742827,3),(1551,1964048427,2),(1551,1982797227,3),(1551,1995498027,2),(1551,2014246827,3),(1551,2026947627,2),(1551,2045696427,3),(1551,2058397227,2),(1551,2077146027,3),(1551,2090451627,2),(1551,2108595627,3),(1551,2121901227,2),(1551,2140045227,3),(1552,-2147483648,0),(1552,-1955748776,1),(1552,354675609,2),(1552,370400410,3),(1552,386125210,2),(1552,401850011,3),(1552,417574811,2),(1552,433299612,3),(1552,449024412,2),(1552,465354012,3),(1552,481078812,2),(1552,496803613,3),(1552,512528413,2),(1552,528253213,3),(1552,543978013,2),(1552,559702813,3),(1552,575427614,2),(1552,591152414,3),(1552,606877214,2),(1552,622602014,3),(1552,638326815,2),(1552,654656415,3),(1552,670381216,2),(1552,686106016,3),(1552,701830816,2),(1552,717555617,3),(1552,733280417,2),(1552,749005218,3),(1552,764730018,2),(1552,780454819,3),(1552,796179619,2),(1552,811904419,3),(1552,828234020,2),(1552,846378020,3),(1552,859683620,2),(1552,877827621,3),(1552,891133221,2),(1552,909277221,3),(1552,922582822,2),(1552,941331622,3),(1552,954032422,2),(1552,972781222,3),(1552,985482022,2),(1552,1004230822,3),(1552,1017536422,2),(1552,1035680422,3),(1552,1048986022,2),(1552,1067130022,3),(1552,1080435622,2),(1552,1099184422,3),(1552,1111885222,2),(1552,1130634022,3),(1552,1143334823,2),(1552,1162083623,3),(1552,1174784423,2),(1552,1193533223,3),(1552,1206838823,2),(1552,1224982823,3),(1552,1238288424,2),(1552,1256432424,3),(1552,1269738024,2),(1552,1288486824,3),(1552,1301187624,2),(1552,1319936424,3),(1552,1332637224,2),(1552,1351386025,3),(1552,1364691625,2),(1552,1382835625,3),(1552,1396141225,2),(1552,1414285225,3),(1552,1427590825,2),(1552,1445734826,3),(1552,1459040426,2),(1552,1477789226,3),(1552,1490490027,2),(1552,1509238827,3),(1552,1521939627,2),(1552,1540688427,3),(1552,1553994027,2),(1552,1572138027,3),(1552,1585443627,2),(1552,1603587627,3),(1552,1616893227,2),(1552,1635642027,3),(1552,1648342827,2),(1552,1667091627,3),(1552,1679792427,2),(1552,1698541227,3),(1552,1711846827,2),(1552,1729990827,3),(1552,1743296427,2),(1552,1761440427,3),(1552,1774746027,2),(1552,1792890027,3),(1552,1806195627,2),(1552,1824944427,3),(1552,1837645227,2),(1552,1856394027,3),(1552,1869094827,2),(1552,1887843627,3),(1552,1901149227,2),(1552,1919293227,3),(1552,1932598827,2),(1552,1950742827,3),(1552,1964048427,2),(1552,1982797227,3),(1552,1995498027,2),(1552,2014246827,3),(1552,2026947627,2),(1552,2045696427,3),(1552,2058397227,2),(1552,2077146027,3),(1552,2090451627,2),(1552,2108595627,3),(1552,2121901227,2),(1552,2140045227,3),(1553,-2147483648,2),(1553,-1691884800,1),(1553,-1680573600,2),(1553,-927511200,1),(1553,-857257200,3),(1553,-844556400,4),(1553,-828226800,3),(1553,-812502000,4),(1553,-796777200,3),(1553,-781052400,4),(1553,-765327600,3),(1553,-340844400,4),(1553,-324514800,3),(1553,-308790000,4),(1553,-293065200,3),(1553,-277340400,4),(1553,-261615600,3),(1553,-245890800,4),(1553,-230166000,3),(1553,-214441200,4),(1553,-198716400,3),(1553,-182991600,4),(1553,-166662000,3),(1553,-147913200,4),(1553,-135212400,3),(1553,315529208,2),(1553,323830809,5),(1553,338950809,6),(1553,354675609,5),(1553,370400410,6),(1553,386125210,5),(1553,401850011,6),(1553,417574811,5),(1553,433299612,6),(1553,449024412,5),(1553,465354012,6),(1553,481078812,5),(1553,496803613,6),(1553,512528413,5),(1553,528253213,6),(1553,543978013,5),(1553,559702813,6),(1553,575427614,5),(1553,591152414,6),(1553,606877214,5),(1553,622602014,6),(1553,638326815,5),(1553,654656415,6),(1553,670381216,5),(1553,686106016,6),(1553,701830816,5),(1553,717555617,6),(1553,733280417,5),(1553,749005218,6),(1553,764730018,5),(1553,780454819,6),(1553,796179619,5),(1553,811904419,6),(1553,828234020,5),(1553,846378020,6),(1553,859683620,5),(1553,877827621,6),(1553,891133221,5),(1553,909277221,6),(1553,922582822,5),(1553,941331622,6),(1553,954032422,5),(1553,972781222,6),(1553,985482022,5),(1553,1004230822,6),(1553,1017536422,5),(1553,1035680422,6),(1553,1048986022,5),(1553,1067130022,6),(1553,1080435622,5),(1553,1099184422,6),(1553,1111885222,5),(1553,1130634022,6),(1553,1143334823,5),(1553,1162083623,6),(1553,1174784423,5),(1553,1193533223,6),(1553,1206838823,5),(1553,1224982823,6),(1553,1238288424,5),(1553,1256432424,6),(1553,1269738024,5),(1553,1288486824,6),(1553,1301187624,5),(1553,1319936424,6),(1553,1332637224,5),(1553,1351386025,6),(1553,1364691625,5),(1553,1382835625,6),(1553,1396141225,5),(1553,1414285225,6),(1553,1427590825,5),(1553,1445734826,6),(1553,1459040426,5),(1553,1477789226,6),(1553,1490490027,5),(1553,1509238827,6),(1553,1521939627,5),(1553,1540688427,6),(1553,1553994027,5),(1553,1572138027,6),(1553,1585443627,5),(1553,1603587627,6),(1553,1616893227,5),(1553,1635642027,6),(1553,1648342827,5),(1553,1667091627,6),(1553,1679792427,5),(1553,1698541227,6),(1553,1711846827,5),(1553,1729990827,6),(1553,1743296427,5),(1553,1761440427,6),(1553,1774746027,5),(1553,1792890027,6),(1553,1806195627,5),(1553,1824944427,6),(1553,1837645227,5),(1553,1856394027,6),(1553,1869094827,5),(1553,1887843627,6),(1553,1901149227,5),(1553,1919293227,6),(1553,1932598827,5),(1553,1950742827,6),(1553,1964048427,5),(1553,1982797227,6),(1553,1995498027,5),(1553,2014246827,6),(1553,2026947627,5),(1553,2045696427,6),(1553,2058397227,5),(1553,2077146027,6),(1553,2090451627,5),(1553,2108595627,6),(1553,2121901227,5),(1553,2140045227,6),(1554,-2147483648,1),(1554,-1830380400,6),(1554,-1689552000,2),(1554,-1677798000,3),(1554,-1667433600,4),(1554,-1647734400,5),(1554,-1635811200,4),(1554,-1616198400,5),(1554,-1604361600,4),(1554,-1584662400,5),(1554,-1572739200,4),(1554,-1553040000,5),(1554,-1541203200,4),(1554,-1521504000,5),(1554,-1442448000,4),(1554,-1426809600,5),(1554,-1379289600,4),(1554,-1364774400,5),(1554,-1348444800,4),(1554,-1333324800,5),(1554,-1316390400,4),(1554,-1301270400,5),(1554,-1284336000,4),(1554,-1269820800,5),(1554,-1221436800,4),(1554,-1206921600,5),(1554,-1191196800,4),(1554,-1175472000,5),(1554,-1127692800,4),(1554,-1111968000,5),(1554,-1096848000,4),(1554,-1080518400,5),(1554,-1063584000,4),(1554,-1049068800,5),(1554,-1033344000,4),(1554,-1017619200,5),(1554,-1002499200,4),(1554,-986169600,5),(1554,-969235200,4),(1554,-950486400,5),(1554,-942019200,4),(1554,-922665600,5),(1554,-906940800,4),(1554,-891129600,5),(1554,-877305600,4),(1554,-873680400,7),(1554,-864003600,4),(1554,-857952000,5),(1554,-845856000,4),(1554,-842835600,7),(1554,-831344400,4),(1554,-825897600,5),(1554,-814406400,4),(1554,-810781200,7),(1554,-799894800,4),(1554,-794448000,5),(1554,-782956800,4),(1554,-779331600,7),(1554,-768445200,4),(1554,-762998400,5),(1554,-749088000,4),(1554,-733363200,5),(1554,-717627600,4),(1554,-701902800,5),(1554,-686178000,4),(1554,-670453200,5),(1554,-654728400,4),(1554,-639003600,5),(1554,-591829200,4),(1554,-575499600,5),(1554,-559774800,4),(1554,-544050000,5),(1554,-528325200,4),(1554,-512600400,5),(1554,-496875600,4),(1554,-481150800,5),(1554,-465426000,4),(1554,-449701200,5),(1554,-433976400,4),(1554,-417646800,5),(1554,-401922000,4),(1554,-386197200,5),(1554,-370472400,4),(1554,-354747600,5),(1554,-339022800,4),(1554,-323298000,5),(1554,-307573200,4),(1554,-291848400,5),(1554,-276123600,4),(1554,-260398800,5),(1554,-244674000,4),(1554,-228344400,5),(1554,-212619600,4),(1554,-196894800,5),(1554,-181170000,4),(1554,-165445200,5),(1554,-149720400,4),(1554,-133995600,5),(1554,-118270800,10),(1554,228268806,8),(1554,243993606,9),(1554,260323207,8),(1554,276048007,9),(1554,291772808,8),(1554,307501208,9),(1554,323222409,8),(1554,338950809,9),(1554,354675609,8),(1554,370400410,9),(1554,386125210,8),(1554,401850011,9),(1554,417578411,8),(1554,433299612,11),(1554,449024412,12),(1554,465354012,11),(1554,481078812,12),(1554,496803613,11),(1554,512528413,12),(1554,528253213,11),(1554,543978013,12),(1554,559702813,11),(1554,575427614,12),(1554,591152414,11),(1554,606877214,12),(1554,622602014,11),(1554,638326815,12),(1554,654656415,11),(1554,670381216,12),(1554,686106016,11),(1554,701830816,12),(1554,717555617,11),(1554,733280417,12),(1554,749005218,11),(1554,764730018,12),(1554,780454819,11),(1554,796179619,12),(1554,811904419,11),(1554,828234020,12),(1554,846378020,11),(1554,859683620,12),(1554,877827621,11),(1554,891133221,12),(1554,909277221,11),(1554,922582822,12),(1554,941331622,11),(1554,954032422,12),(1554,972781222,11),(1554,985482022,12),(1554,1004230822,11),(1554,1017536422,12),(1554,1035680422,11),(1554,1048986022,12),(1554,1067130022,11),(1554,1080435622,12),(1554,1099184422,11),(1554,1111885222,12),(1554,1130634022,11),(1554,1143334823,12),(1554,1162083623,11),(1554,1174784423,12),(1554,1193533223,11),(1554,1206838823,12),(1554,1224982823,11),(1554,1238288424,12),(1554,1256432424,11),(1554,1269738024,12),(1554,1288486824,11),(1554,1301187624,12),(1554,1319936424,11),(1554,1332637224,12),(1554,1351386025,11),(1554,1364691625,12),(1554,1382835625,11),(1554,1396141225,12),(1554,1414285225,11),(1554,1427590825,12),(1554,1445734826,11),(1554,1459040426,12),(1554,1477789226,11),(1554,1490490027,12),(1554,1509238827,11),(1554,1521939627,12),(1554,1540688427,11),(1554,1553994027,12),(1554,1572138027,11),(1554,1585443627,12),(1554,1603587627,11),(1554,1616893227,12),(1554,1635642027,11),(1554,1648342827,12),(1554,1667091627,11),(1554,1679792427,12),(1554,1698541227,11),(1554,1711846827,12),(1554,1729990827,11),(1554,1743296427,12),(1554,1761440427,11),(1554,1774746027,12),(1554,1792890027,11),(1554,1806195627,12),(1554,1824944427,11),(1554,1837645227,12),(1554,1856394027,11),(1554,1869094827,12),(1554,1887843627,11),(1554,1901149227,12),(1554,1919293227,11),(1554,1932598827,12),(1554,1950742827,11),(1554,1964048427,12),(1554,1982797227,11),(1554,1995498027,12),(1554,2014246827,11),(1554,2026947627,12),(1554,2045696427,11),(1554,2058397227,12),(1554,2077146027,11),(1554,2090451627,12),(1554,2108595627,11),(1554,2121901227,12),(1554,2140045227,11),(1555,-2147483648,0),(1555,-1956609120,2),(1555,-1668211200,1),(1555,-1647212400,2),(1555,-1636675200,1),(1555,-1613430000,2),(1555,-1605139200,1),(1555,-1581894000,2),(1555,-1539561600,1),(1555,-1531350000,2),(1555,-968025600,1),(1555,-952293600,2),(1555,-942008400,1),(1555,-920239200,3),(1555,-909957600,4),(1555,-888789600,3),(1555,-877903200,4),(1555,-857944800,3),(1555,-846453600,4),(1555,-826495200,3),(1555,-815004000,4),(1555,-795045600,3),(1555,-783554400,4),(1555,-762991200,3),(1555,-752104800,4),(1555,-731541600,3),(1555,-717631200,4),(1555,-700092000,3),(1555,-686181600,4),(1555,-668642400,3),(1555,-654732000,4),(1555,-636588000,3),(1555,-623282400,4),(1555,-605743200,3),(1555,-591832800,4),(1555,-573688800,3),(1555,-559778400,4),(1555,-542239200,3),(1555,-528328800,4),(1555,-510789600,3),(1555,-496879200,4),(1555,-479340000,3),(1555,-465429600,4),(1555,-447890400,3),(1555,-433980000,4),(1555,-415836000,3),(1555,-401925600,4),(1555,-384386400,3),(1555,-370476000,4),(1555,-352936800,3),(1555,-339026400,4),(1555,-321487200,3),(1555,-307576800,4),(1555,-290037600,3),(1555,-276127200,4),(1555,-258588000,3),(1555,-244677600,4),(1555,-226533600,3),(1555,-212623200,4),(1555,-195084000,3),(1555,-181173600,4),(1555,-163634400,3),(1555,-149724000,4),(1555,-132184800,3),(1555,-118274400,4),(1555,-100735200,3),(1555,-86824800,4),(1555,-68680800,3),(1555,-54770400,5),(1557,-2147483648,0),(1557,-1830383032,1),(1558,-2147483648,1),(1558,-1824235716,3),(1558,-1018209600,2),(1558,-1003093200,3),(1558,-986760000,2),(1558,-971643600,3),(1558,-954705600,2),(1558,-939589200,3),(1558,-923256000,2),(1558,-908139600,3),(1558,-891806400,2),(1558,-876690000,3),(1558,-860356800,2),(1558,-852066000,3),(1558,420609611,5),(1558,433306812,4),(1558,452052012,5),(1558,464151612,4),(1558,483501612,5),(1558,495601213,2),(1558,514350013,3),(1558,527054413,2),(1558,545799613,3),(1558,558504013,2),(1558,577249214,3),(1558,589953614,2),(1558,608698814,3),(1558,621403214,2),(1558,640753215,3),(1558,652852815,2),(1558,672202816,3),(1558,684907216,2),(1558,703652416,3),(1558,716356817,2),(1558,735102017,3),(1558,747806418,2),(1558,766551618,3),(1558,779256019,2),(1558,798001219,3),(1558,810705619,2),(1558,830055620,3),(1558,842760020,2),(1558,861505220,3),(1558,874209621,2),(1558,892954821,3),(1558,905659221,2),(1558,924404422,3),(1558,937108822,2),(1558,955854022,3),(1558,968558422,2),(1558,987310822,3),(1558,999410422,2),(1558,1019365222,3),(1558,1030860022,2),(1558,1050814822,3),(1558,1062914422,2),(1558,1082264422,3),(1558,1094364022,2),(1558,1113714022,3),(1558,1125813622,2),(1558,1145163623,3),(1558,1157263223,2),(1558,1176613223,3),(1558,1188712823,2),(1558,1208667623,3),(1558,1220767223,2),(1558,1240117224,3),(1558,1252216824,2),(1558,1271566824,3),(1558,1283666424,5),(1559,-2147483648,2),(1559,-1672567140,1),(1559,-1665392400,2),(1559,-883641600,1),(1559,-876128400,2),(1559,-860400000,1),(1559,-844678800,2),(1559,-828345600,1),(1559,-813229200,2),(1559,57686400,3),(1559,67968000,4),(1559,89136001,3),(1559,100022402,4),(1559,120585602,3),(1559,131472003,4),(1559,152035203,3),(1559,162921604,4),(1559,183484804,3),(1559,194976005,4),(1559,215539205,3),(1559,226425606,4),(1559,246988806,3),(1559,257875207,4),(1559,278438407,3),(1559,289324808,4),(1559,309888008,3),(1559,320774409,4),(1559,341337609,3),(1559,352224009,4),(1559,372787210,3),(1559,386697610,4),(1559,404841611,3),(1559,415728011,4),(1559,436291212,3),(1559,447177612,4),(1559,467740812,3),(1559,478627212,4),(1559,499190413,3),(1559,511286413,4),(1559,530035213,3),(1559,542736013,4),(1559,562089613,3),(1559,574790414,4),(1559,594144014,3),(1559,606240014,4),(1559,625593614,3),(1559,636480015,4),(1559,657043215,3),(1559,667929616,4),(1559,688492816,3),(1559,699379216,4),(1559,719942417,3),(1559,731433617,4),(1559,751996818,3),(1559,762883218,4),(1559,783446419,3),(1559,794332819,4),(1559,814896019,3),(1559,828201620,4),(1559,846345620,3),(1559,859651220,4),(1559,877795221,3),(1559,891100821,4),(1559,909244821,3),(1559,922550422,4),(1559,941299222,3),(1559,954000022,4),(1559,967305622,3),(1559,985449622,4),(1559,1004198422,3),(1559,1017504022,4),(1559,1035648022,3),(1559,1048953622,4),(1559,1067097622,3),(1559,1080403222,4),(1559,1099152022,3),(1559,1111852822,4),(1559,1130601622,3),(1559,1143907223,4),(1559,1162051223,3),(1559,1174752023,4),(1559,1193500823,3),(1559,1207411223,4),(1559,1223136023,3),(1559,1238860824,4),(1559,1254585624,3),(1559,1270310424,4),(1559,1286035224,3),(1559,1301760024,4),(1559,1317484824,3),(1559,1333209624,4),(1559,1349539225,3),(1559,1365264025,4),(1559,1380988825,3);
INSERT INTO `time_zone_transition` VALUES (1559,1396713625,4),(1559,1412438425,3),(1559,1428163225,4),(1559,1443888026,3),(1559,1459612826,4),(1559,1475337626,3),(1559,1491062427,4),(1559,1506787227,3),(1559,1522512027,4),(1559,1538841627,3),(1559,1554566427,4),(1559,1570291227,3),(1559,1586016027,4),(1559,1601740827,3),(1559,1617465627,4),(1559,1633190427,3),(1559,1648915227,4),(1559,1664640027,3),(1559,1680364827,4),(1559,1696089627,3),(1559,1712419227,4),(1559,1728144027,3),(1559,1743868827,4),(1559,1759593627,3),(1559,1775318427,4),(1559,1791043227,3),(1559,1806768027,4),(1559,1822492827,3),(1559,1838217627,4),(1559,1853942427,3),(1559,1869667227,4),(1559,1885996827,3),(1559,1901721627,4),(1559,1917446427,3),(1559,1933171227,4),(1559,1948896027,3),(1559,1964620827,4),(1559,1980345627,3),(1559,1996070427,4),(1559,2011795227,3),(1559,2027520027,4),(1559,2043244827,3),(1559,2058969627,4),(1559,2075299227,3),(1559,2091024027,4),(1559,2106748827,3),(1559,2122473627,4),(1559,2138198427,3),(1560,-2147483648,2),(1560,-1672565340,1),(1560,-1665390600,2),(1560,-883639800,1),(1560,-876126600,2),(1560,-860398200,1),(1560,-844677000,2),(1560,-828343800,1),(1560,-813227400,2),(1560,57688200,3),(1560,67969800,4),(1560,89137801,3),(1560,100024202,4),(1560,120587402,3),(1560,131473803,4),(1560,152037003,3),(1560,162923404,4),(1560,183486604,3),(1560,194977805,4),(1560,215541005,3),(1560,226427406,4),(1560,246990606,3),(1560,257877007,4),(1560,278440207,3),(1560,289326608,4),(1560,309889808,3),(1560,320776209,4),(1560,341339409,3),(1560,352225809,4),(1560,372789010,3),(1560,384280210,4),(1560,404843411,3),(1560,415729811,4),(1560,436293012,3),(1560,447179412,4),(1560,467742612,3),(1560,478629012,4),(1560,499192213,3),(1560,511288213,4),(1560,530037013,3),(1560,542737813,4),(1560,562091413,3),(1560,574792214,4),(1560,594145814,3),(1560,606241814,4),(1560,625595414,3),(1560,637691415,4),(1560,657045015,3),(1560,667931416,4),(1560,688494616,3),(1560,701195416,4),(1560,719944217,3),(1560,731435417,4),(1560,751998618,3),(1560,764094618,4),(1560,783448219,3),(1560,796149019,4),(1560,814897819,3),(1560,828203420,4),(1560,846347420,3),(1560,859653020,4),(1560,877797021,3),(1560,891102621,4),(1560,909246621,3),(1560,922552222,4),(1560,941301022,3),(1560,954001822,4),(1560,972750622,3),(1560,985451422,4),(1560,1004200222,3),(1560,1017505822,4),(1560,1035649822,3),(1560,1048955422,4),(1560,1067099422,3),(1560,1080405022,4),(1560,1099153822,3),(1560,1111854622,4),(1560,1130603422,3),(1560,1143909023,4),(1560,1162053023,3),(1560,1174753823,4),(1560,1193502623,3),(1560,1207413023,4),(1560,1223137823,3),(1560,1238862624,4),(1560,1254587424,3),(1560,1270312224,4),(1560,1286037024,3),(1560,1301761824,4),(1560,1317486624,3),(1560,1333211424,4),(1560,1349541025,3),(1560,1365265825,4),(1560,1380990625,3),(1560,1396715425,4),(1560,1412440225,3),(1560,1428165025,4),(1560,1443889826,3),(1560,1459614626,4),(1560,1475339426,3),(1560,1491064227,4),(1560,1506789027,3),(1560,1522513827,4),(1560,1538843427,3),(1560,1554568227,4),(1560,1570293027,3),(1560,1586017827,4),(1560,1601742627,3),(1560,1617467427,4),(1560,1633192227,3),(1560,1648917027,4),(1560,1664641827,3),(1560,1680366627,4),(1560,1696091427,3),(1560,1712421027,4),(1560,1728145827,3),(1560,1743870627,4),(1560,1759595427,3),(1560,1775320227,4),(1560,1791045027,3),(1560,1806769827,4),(1560,1822494627,3),(1560,1838219427,4),(1560,1853944227,3),(1560,1869669027,4),(1560,1885998627,3),(1560,1901723427,4),(1560,1917448227,3),(1560,1933173027,4),(1560,1948897827,3),(1560,1964622627,4),(1560,1980347427,3),(1560,1996072227,4),(1560,2011797027,3),(1560,2027521827,4),(1560,2043246627,3),(1560,2058971427,4),(1560,2075301027,3),(1560,2091025827,4),(1560,2106750627,3),(1560,2122475427,4),(1560,2138200227,3),(1561,-2147483648,2),(1561,-1672567140,1),(1561,-1665392400,2),(1561,-883641600,1),(1561,-876128400,2),(1561,-860400000,1),(1561,-844678800,2),(1561,-828345600,1),(1561,-813229200,2),(1561,57686400,3),(1561,67968000,4),(1561,625593614,3),(1561,636480015,4),(1561,657043215,3),(1561,667929616,4),(1561,688492816,3),(1561,699379216,4),(1562,-2147483648,2),(1562,-1672565340,1),(1562,-1665390600,2),(1562,-883639800,1),(1562,-876126600,2),(1562,-860398200,1),(1562,-844677000,2),(1562,-828343800,1),(1562,-813227400,2),(1562,57688200,3),(1562,67969800,4),(1562,89137801,3),(1562,100024202,4),(1562,120587402,3),(1562,131473803,4),(1562,152037003,3),(1562,162923404,4),(1562,183486604,3),(1562,194977805,4),(1562,215541005,3),(1562,226427406,4),(1562,246990606,3),(1562,257877007,4),(1562,278440207,3),(1562,289326608,4),(1562,309889808,3),(1562,320776209,4),(1562,341339409,3),(1562,352225809,4),(1562,372789010,3),(1562,386699410,4),(1562,404843411,3),(1562,415729811,4),(1562,436293012,3),(1562,447179412,4),(1562,467742612,3),(1562,478629012,4),(1562,499192213,3),(1562,511288213,4),(1562,530037013,3),(1562,542737813,4),(1562,562091413,3),(1562,574792214,4),(1562,594145814,3),(1562,606241814,4),(1562,625595414,3),(1562,636481815,4),(1562,657045015,3),(1562,667931416,4),(1562,688494616,3),(1562,699381016,4),(1562,719944217,3),(1562,731435417,4),(1562,751998618,3),(1562,762885018,4),(1562,783448219,3),(1562,794334619,4),(1562,814897819,3),(1562,828203420,4),(1562,846347420,3),(1562,859653020,4),(1562,877797021,3),(1562,891102621,4),(1562,909246621,3),(1562,922552222,4),(1562,941301022,3),(1562,946647022,1),(1562,954001822,4),(1562,972750622,3),(1562,985451422,4),(1562,1004200222,3),(1562,1017505822,4),(1562,1035649822,3),(1562,1048955422,4),(1562,1067099422,3),(1562,1080405022,4),(1562,1099153822,3),(1562,1111854622,4),(1562,1130603422,3),(1562,1143909023,4),(1562,1162053023,3),(1562,1174753823,4),(1562,1193502623,3),(1562,1207413023,4),(1562,1223137823,3),(1562,1238862624,4),(1562,1254587424,3),(1562,1270312224,4),(1562,1286037024,3),(1562,1301761824,4),(1562,1317486624,3),(1562,1333211424,4),(1562,1349541025,3),(1562,1365265825,4),(1562,1380990625,3),(1562,1396715425,4),(1562,1412440225,3),(1562,1428165025,4),(1562,1443889826,3),(1562,1459614626,4),(1562,1475339426,3),(1562,1491064227,4),(1562,1506789027,3),(1562,1522513827,4),(1562,1538843427,3),(1562,1554568227,4),(1562,1570293027,3),(1562,1586017827,4),(1562,1601742627,3),(1562,1617467427,4),(1562,1633192227,3),(1562,1648917027,4),(1562,1664641827,3),(1562,1680366627,4),(1562,1696091427,3),(1562,1712421027,4),(1562,1728145827,3),(1562,1743870627,4),(1562,1759595427,3),(1562,1775320227,4),(1562,1791045027,3),(1562,1806769827,4),(1562,1822494627,3),(1562,1838219427,4),(1562,1853944227,3),(1562,1869669027,4),(1562,1885998627,3),(1562,1901723427,4),(1562,1917448227,3),(1562,1933173027,4),(1562,1948897827,3),(1562,1964622627,4),(1562,1980347427,3),(1562,1996072227,4),(1562,2011797027,3),(1562,2027521827,4),(1562,2043246627,3),(1562,2058971427,4),(1562,2075301027,3),(1562,2091025827,4),(1562,2106750627,3),(1562,2122475427,4),(1562,2138200227,3),(1563,-2147483648,2),(1563,-1672567140,1),(1563,-1665392400,2),(1563,-883641600,1),(1563,-876128400,2),(1563,-860400000,1),(1563,-844678800,2),(1563,-828345600,1),(1563,-813229200,2),(1563,57686400,3),(1563,67968000,4),(1563,89136001,3),(1563,100022402,4),(1563,120585602,3),(1563,131472003,4),(1563,152035203,3),(1563,162921604,4),(1563,183484804,3),(1563,194976005,4),(1563,215539205,3),(1563,226425606,4),(1563,246988806,3),(1563,257875207,4),(1563,278438407,3),(1563,289324808,4),(1563,309888008,3),(1563,320774409,4),(1563,341337609,3),(1563,352224009,4),(1563,372787210,3),(1563,386697610,4),(1563,404841611,3),(1563,415728011,4),(1563,436291212,3),(1563,447177612,4),(1563,467740812,3),(1563,478627212,4),(1563,499190413,3),(1563,511286413,4),(1563,530035213,3),(1563,542736013,4),(1563,562089613,3),(1563,574790414,4),(1563,594144014,3),(1563,606240014,4),(1563,625593614,3),(1563,636480015,4),(1563,657043215,3),(1563,667929616,4),(1563,688492816,3),(1563,699379216,4),(1563,719942417,3),(1563,731433617,4),(1563,751996818,3),(1563,762883218,4),(1563,783446419,3),(1563,794332819,4),(1563,814896019,3),(1563,828201620,4),(1563,846345620,3),(1563,859651220,4),(1563,877795221,3),(1563,891100821,4),(1563,909244821,3),(1563,922550422,4),(1563,941299222,3),(1563,954000022,4),(1563,967305622,3),(1563,985449622,4),(1563,1004198422,3),(1563,1017504022,4),(1563,1035648022,3),(1563,1048953622,4),(1563,1067097622,3),(1563,1080403222,4),(1563,1099152022,3),(1563,1111852822,4),(1563,1130601622,3),(1563,1143907223,4),(1563,1162051223,3),(1563,1174752023,4),(1563,1193500823,3),(1563,1207411223,4),(1563,1223136023,3),(1563,1238860824,4),(1563,1254585624,3),(1563,1270310424,4),(1563,1286035224,3),(1563,1301760024,4),(1563,1317484824,3),(1563,1333209624,4),(1563,1349539225,3),(1563,1365264025,4),(1563,1380988825,3),(1563,1396713625,4),(1563,1412438425,3),(1563,1428163225,4),(1563,1443888026,3),(1563,1459612826,4),(1563,1475337626,3),(1563,1491062427,4),(1563,1506787227,3),(1563,1522512027,4),(1563,1538841627,3),(1563,1554566427,4),(1563,1570291227,3),(1563,1586016027,4),(1563,1601740827,3),(1563,1617465627,4),(1563,1633190427,3),(1563,1648915227,4),(1563,1664640027,3),(1563,1680364827,4),(1563,1696089627,3),(1563,1712419227,4),(1563,1728144027,3),(1563,1743868827,4),(1563,1759593627,3),(1563,1775318427,4),(1563,1791043227,3),(1563,1806768027,4),(1563,1822492827,3),(1563,1838217627,4),(1563,1853942427,3),(1563,1869667227,4),(1563,1885996827,3),(1563,1901721627,4),(1563,1917446427,3),(1563,1933171227,4),(1563,1948896027,3),(1563,1964620827,4),(1563,1980345627,3),(1563,1996070427,4),(1563,2011795227,3),(1563,2027520027,4),(1563,2043244827,3),(1563,2058969627,4),(1563,2075299227,3),(1563,2091024027,4),(1563,2106748827,3),(1563,2122473627,4),(1563,2138198427,3),(1564,-2147483648,1),(1564,-1680508800,2),(1564,-1665392400,1),(1564,-883641600,2),(1564,-876128400,1),(1564,-860400000,2),(1564,-844678800,1),(1564,-828345600,2),(1564,-813229200,1),(1564,57686400,3),(1564,67968000,4),(1564,89136001,3),(1564,100022402,4),(1564,120585602,3),(1564,131472003,4),(1564,152035203,3),(1564,162921604,4),(1564,183484804,3),(1564,194976005,4),(1564,215539205,3),(1564,226425606,4),(1564,246988806,3),(1564,257875207,4),(1564,278438407,3),(1564,289324808,4),(1564,309888008,3),(1564,320774409,4),(1564,341337609,3),(1564,352224009,4),(1564,372787210,3),(1564,386092810,4),(1564,404841611,3),(1564,417542411,4),(1564,436291212,3),(1564,447177612,4),(1564,467740812,3),(1564,478627212,4),(1564,499190413,3),(1564,510076813,4),(1564,530035213,3),(1564,542736013,4),(1564,562089613,3),(1564,574790414,4),(1564,594144014,3),(1564,606240014,4),(1564,625593614,3),(1564,637689615,4),(1564,657043215,3),(1564,670348816,4),(1564,686678416,3),(1564,701798416,4),(1564,718128017,3),(1564,733248017,4),(1564,749577618,3),(1564,764697618,4),(1564,781027219,3),(1564,796147219,4),(1564,812476819,3),(1564,828201620,4),(1564,844531220,3),(1564,859651220,4),(1564,875980821,3),(1564,891100821,4),(1564,907430421,3),(1564,922550422,4),(1564,938880022,3),(1564,954000022,4),(1564,967305622,3),(1564,985449622,4),(1564,1002384022,3),(1564,1017504022,4),(1564,1033833622,3),(1564,1048953622,4),(1564,1065283222,3),(1564,1080403222,4),(1564,1096732822,3),(1564,1111852822,4),(1564,1128182422,3),(1564,1143907223,4),(1564,1159632023,3),(1564,1174752023,4),(1564,1191686423,3),(1564,1207411223,4),(1564,1223136023,3),(1564,1238860824,4),(1564,1254585624,3),(1564,1270310424,4),(1564,1286035224,3),(1564,1301760024,4),(1564,1317484824,3),(1564,1333209624,4),(1564,1349539225,3),(1564,1365264025,4),(1564,1380988825,3),(1564,1396713625,4),(1564,1412438425,3),(1564,1428163225,4),(1564,1443888026,3),(1564,1459612826,4),(1564,1475337626,3),(1564,1491062427,4),(1564,1506787227,3),(1564,1522512027,4),(1564,1538841627,3),(1564,1554566427,4),(1564,1570291227,3),(1564,1586016027,4),(1564,1601740827,3),(1564,1617465627,4),(1564,1633190427,3),(1564,1648915227,4),(1564,1664640027,3),(1564,1680364827,4),(1564,1696089627,3),(1564,1712419227,4),(1564,1728144027,3),(1564,1743868827,4),(1564,1759593627,3),(1564,1775318427,4),(1564,1791043227,3),(1564,1806768027,4),(1564,1822492827,3),(1564,1838217627,4),(1564,1853942427,3),(1564,1869667227,4),(1564,1885996827,3),(1564,1901721627,4),(1564,1917446427,3),(1564,1933171227,4),(1564,1948896027,3),(1564,1964620827,4),(1564,1980345627,3),(1564,1996070427,4),(1564,2011795227,3),(1564,2027520027,4),(1564,2043244827,3),(1564,2058969627,4),(1564,2075299227,3),(1564,2091024027,4),(1564,2106748827,3),(1564,2122473627,4),(1564,2138198427,3),(1565,-2147483648,2),(1565,-1672565340,1),(1565,-1665390600,2),(1565,-883639800,1),(1565,-876126600,2),(1565,-860398200,1),(1565,-844677000,2),(1565,-828343800,1),(1565,-813227400,2),(1566,-2147483648,2),(1566,-1672562640,1),(1566,-1665387900,2),(1566,-883637100,1),(1566,-876123900,2),(1566,-860395500,1),(1566,-844674300,2),(1566,152039703,3),(1566,162926104,4),(1566,436295712,3),(1566,447182112,4),(1566,690311716,3),(1566,699383716,4),(1566,1165079723,3),(1566,1174756523,4),(1566,1193505323,3),(1566,1206810923,4),(1566,1224954923,3),(1566,1238260524,4),(1567,-2147483648,1),(1567,-1680508800,2),(1567,-1665392400,1),(1567,-883641600,2),(1567,-876128400,1),(1567,-860400000,2),(1567,-844678800,1),(1567,-828345600,2),(1567,-813229200,1),(1567,-71136000,3),(1567,-55411200,4),(1567,-37267200,3),(1567,-25776000,4),(1567,-5817600,3),(1567,5673600,4),(1567,25632000,3),(1567,37728000,4),(1567,57686400,3),(1567,67968000,4),(1567,89136001,3),(1567,100022402,4),(1567,120585602,3),(1567,131472003,4),(1567,152035203,3),(1567,162921604,4),(1567,183484804,3),(1567,194976005,4),(1567,215539205,3),(1567,226425606,4),(1567,246988806,3),(1567,257875207,4),(1567,278438407,3),(1567,289324808,4),(1567,309888008,3),(1567,320774409,4),(1567,341337609,3),(1567,352224009,4),(1567,372787210,3),(1567,386092810,4),(1567,404841611,3),(1567,417542411,4),(1567,436291212,3),(1567,447177612,4),(1567,467740812,3),(1567,478627212,4),(1567,499190413,3),(1567,510076813,4),(1567,530035213,3),(1567,542736013,4),(1567,562089613,3),(1567,574790414,4),(1567,594144014,3),(1567,606240014,4),(1567,625593614,3),(1567,637689615,4),(1567,657043215,3),(1567,670348816,4),(1567,686678416,3),(1567,701798416,4),(1567,718128017,3),(1567,733248017,4),(1567,749577618,3),(1567,764697618,4),(1567,781027219,3),(1567,796147219,4),(1567,812476819,3),(1567,828201620,4),(1567,844531220,3),(1567,859651220,4),(1567,875980821,3),(1567,891100821,4),(1567,907430421,3),(1567,922550422,4),(1567,938880022,3),(1567,954000022,4),(1567,967305622,3),(1567,985449622,4),(1567,1002384022,3),(1567,1017504022,4),(1567,1033833622,3),(1567,1048953622,4),(1567,1065283222,3),(1567,1080403222,4),(1567,1096732822,3),(1567,1111852822,4),(1567,1128182422,3),(1567,1143907223,4),(1567,1159632023,3),(1567,1174752023,4),(1567,1191686423,3),(1567,1207411223,4),(1567,1223136023,3),(1567,1238860824,4),(1567,1254585624,3),(1567,1270310424,4),(1567,1286035224,3),(1567,1301760024,4),(1567,1317484824,3),(1567,1333209624,4),(1567,1349539225,3),(1567,1365264025,4),(1567,1380988825,3),(1567,1396713625,4),(1567,1412438425,3),(1567,1428163225,4),(1567,1443888026,3),(1567,1459612826,4),(1567,1475337626,3),(1567,1491062427,4),(1567,1506787227,3),(1567,1522512027,4),(1567,1538841627,3),(1567,1554566427,4),(1567,1570291227,3),(1567,1586016027,4),(1567,1601740827,3),(1567,1617465627,4),(1567,1633190427,3),(1567,1648915227,4),(1567,1664640027,3),(1567,1680364827,4),(1567,1696089627,3),(1567,1712419227,4),(1567,1728144027,3),(1567,1743868827,4),(1567,1759593627,3),(1567,1775318427,4),(1567,1791043227,3),(1567,1806768027,4),(1567,1822492827,3),(1567,1838217627,4),(1567,1853942427,3),(1567,1869667227,4),(1567,1885996827,3),(1567,1901721627,4),(1567,1917446427,3),(1567,1933171227,4),(1567,1948896027,3),(1567,1964620827,4),(1567,1980345627,3),(1567,1996070427,4),(1567,2011795227,3),(1567,2027520027,4),(1567,2043244827,3),(1567,2058969627,4),(1567,2075299227,3),(1567,2091024027,4),(1567,2106748827,3),(1567,2122473627,4),(1567,2138198427,3),(1568,-2147483648,1),(1568,352216809,3),(1568,372785410,2),(1568,384273010,3),(1568,404839811,2),(1568,415722611,3),(1568,436289412,2),(1568,447172212,3),(1568,467739012,2),(1568,478621812,3),(1568,499188613,4),(1568,511282813,3),(1568,530033413,4),(1568,542732413,3),(1568,562087813,4),(1568,574786814,3),(1568,594142214,4),(1568,606236414,3),(1568,625591814,4),(1568,636476415,3),(1568,657041415,4),(1568,667926016,3),(1568,688491016,4),(1568,699375616,3),(1568,719940617,4),(1568,731430017,3),(1568,751995018,4),(1568,762879618,3),(1568,783444619,4),(1568,794329219,3),(1568,814894219,4),(1568,828198020,3),(1568,846343820,4),(1568,859647620,3),(1568,877793421,4),(1568,891097221,3),(1568,909243021,4),(1568,922546822,3),(1568,941297422,4),(1568,953996422,3),(1568,967303822,4),(1568,985446022,3),(1568,1004196622,4),(1568,1017500422,3),(1568,1035646222,4),(1568,1048950022,3),(1568,1067095822,4),(1568,1080399622,3),(1568,1099150222,4),(1568,1111849222,3),(1568,1130599822,4),(1568,1143903623,3),(1568,1162049423,4),(1568,1174748423,3),(1568,1193499023,4),(1568,1207407623,3),(1568,1223134223,4),(1568,1238857224,3),(1568,1254583824,4),(1568,1270306824,3),(1568,1286033424,4),(1568,1301756424,3),(1568,1317483024,4),(1568,1333206024,3),(1568,1349537425,4),(1568,1365260425,3),(1568,1380987025,4),(1568,1396710025,3),(1568,1412436625,4),(1568,1428159625,3),(1568,1443886226,4),(1568,1459609226,3),(1568,1475335826,4),(1568,1491058827,3),(1568,1506785427,4),(1568,1522508427,3),(1568,1538839827,4),(1568,1554562827,3),(1568,1570289427,4),(1568,1586012427,3),(1568,1601739027,4),(1568,1617462027,3),(1568,1633188627,4),(1568,1648911627,3),(1568,1664638227,4),(1568,1680361227,3),(1568,1696087827,4),(1568,1712415627,3),(1568,1728142227,4),(1568,1743865227,3),(1568,1759591827,4),(1568,1775314827,3),(1568,1791041427,4),(1568,1806764427,3),(1568,1822491027,4),(1568,1838214027,3),(1568,1853940627,4),(1568,1869663627,3),(1568,1885995027,4),(1568,1901718027,3),(1568,1917444627,4),(1568,1933167627,3),(1568,1948894227,4),(1568,1964617227,3),(1568,1980343827,4),(1568,1996066827,3),(1568,2011793427,4),(1568,2027516427,3),(1568,2043243027,4),(1568,2058966027,3),(1568,2075297427,4),(1568,2091020427,3),(1568,2106747027,4),(1568,2122470027,3),(1568,2138196627,4),(1569,-2147483648,2),(1569,-1672567140,1),(1569,-1665392400,2),(1569,-883641600,1),(1569,-876128400,2),(1569,-860400000,1),(1569,-844678800,2),(1569,-828345600,1),(1569,-813229200,2),(1569,57686400,3),(1569,67968000,4),(1569,625593614,3),(1569,636480015,4),(1569,657043215,3),(1569,667929616,4),(1569,688492816,3),(1569,699379216,4),(1569,709912816,2),(1569,719942417,3),(1569,731433617,4),(1569,751996818,3),(1569,762883218,4),(1570,-2147483648,1),(1570,352216809,3),(1570,372785410,2),(1570,384273010,3),(1570,404839811,2),(1570,415722611,3),(1570,436289412,2),(1570,447172212,3),(1570,467739012,2),(1570,478621812,3),(1570,499188613,4),(1570,511282813,3),(1570,530033413,4),(1570,542732413,3),(1570,562087813,4),(1570,574786814,3),(1570,594142214,4),(1570,606236414,3),(1570,625591814,4),(1570,636476415,3),(1570,657041415,4),(1570,667926016,3),(1570,688491016,4),(1570,699375616,3),(1570,719940617,4),(1570,731430017,3),(1570,751995018,4),(1570,762879618,3),(1570,783444619,4),(1570,794329219,3),(1570,814894219,4),(1570,828198020,3),(1570,846343820,4),(1570,859647620,3),(1570,877793421,4),(1570,891097221,3),(1570,909243021,4),(1570,922546822,3),(1570,941297422,4),(1570,953996422,3),(1570,967303822,4),(1570,985446022,3),(1570,1004196622,4),(1570,1017500422,3),(1570,1035646222,4),(1570,1048950022,3),(1570,1067095822,4),(1570,1080399622,3),(1570,1099150222,4),(1570,1111849222,3),(1570,1130599822,4),(1570,1143903623,3),(1570,1162049423,4),(1570,1174748423,3),(1570,1193499023,4),(1570,1207407623,3),(1570,1223134223,4),(1570,1238857224,3),(1570,1254583824,4),(1570,1270306824,3),(1570,1286033424,4),(1570,1301756424,3),(1570,1317483024,4),(1570,1333206024,3),(1570,1349537425,4),(1570,1365260425,3),(1570,1380987025,4),(1570,1396710025,3),(1570,1412436625,4),(1570,1428159625,3),(1570,1443886226,4),(1570,1459609226,3),(1570,1475335826,4),(1570,1491058827,3),(1570,1506785427,4),(1570,1522508427,3),(1570,1538839827,4),(1570,1554562827,3),(1570,1570289427,4),(1570,1586012427,3),(1570,1601739027,4),(1570,1617462027,3),(1570,1633188627,4),(1570,1648911627,3),(1570,1664638227,4),(1570,1680361227,3),(1570,1696087827,4),(1570,1712415627,3),(1570,1728142227,4),(1570,1743865227,3),(1570,1759591827,4),(1570,1775314827,3),(1570,1791041427,4),(1570,1806764427,3),(1570,1822491027,4),(1570,1838214027,3),(1570,1853940627,4),(1570,1869663627,3),(1570,1885995027,4),(1570,1901718027,3),(1570,1917444627,4),(1570,1933167627,3),(1570,1948894227,4),(1570,1964617227,3),(1570,1980343827,4),(1570,1996066827,3),(1570,2011793427,4),(1570,2027516427,3),(1570,2043243027,4),(1570,2058966027,3),(1570,2075297427,4),(1570,2091020427,3),(1570,2106747027,4),(1570,2122470027,3),(1570,2138196627,4),(1571,-2147483648,2),(1571,-1672567140,1),(1571,-1665392400,2),(1571,-883641600,1),(1571,-876128400,2),(1571,-860400000,1),(1571,-844678800,2),(1571,-828345600,1),(1571,-813229200,2),(1571,57686400,3),(1571,67968000,4),(1571,89136001,3),(1571,100022402,4),(1571,120585602,3),(1571,131472003,4),(1571,152035203,3),(1571,162921604,4),(1571,183484804,3),(1571,194976005,4),(1571,215539205,3),(1571,226425606,4),(1571,246988806,3),(1571,257875207,4),(1571,278438407,3),(1571,289324808,4),(1571,309888008,3),(1571,320774409,4),(1571,341337609,3),(1571,352224009,4),(1571,372787210,3),(1571,384278410,4),(1571,404841611,3),(1571,415728011,4),(1571,436291212,3),(1571,447177612,4),(1571,467740812,3),(1571,478627212,4),(1571,499190413,3),(1571,511286413,4),(1571,530035213,3),(1571,542736013,4),(1571,561484813,3),(1571,574790414,4),(1571,594144014,3),(1571,606240014,4),(1571,625593614,3),(1571,637689615,4),(1571,657043215,3),(1571,667929616,4),(1571,688492816,3),(1571,699379216,4),(1571,719942417,3),(1571,731433617,4),(1571,751996818,3),(1571,762883218,4),(1571,783446419,3),(1571,796147219,4),(1571,814896019,3),(1571,828201620,4),(1571,846345620,3),(1571,859651220,4),(1571,877795221,3),(1571,891100821,4),(1571,909244821,3),(1571,922550422,4),(1571,941299222,3),(1571,954000022,4),(1571,967305622,3),(1571,985449622,4),(1571,1004198422,3),(1571,1017504022,4),(1571,1035648022,3),(1571,1048953622,4),(1571,1067097622,3),(1571,1080403222,4),(1571,1099152022,3),(1571,1111852822,4),(1571,1130601622,3),(1571,1143907223,4),(1571,1162051223,3),(1571,1174752023,4),(1571,1193500823,3),(1571,1207411223,4),(1571,1223136023,3),(1571,1238860824,4),(1571,1254585624,3),(1571,1270310424,4),(1571,1286035224,3),(1571,1301760024,4),(1571,1317484824,3),(1571,1333209624,4),(1571,1349539225,3),(1571,1365264025,4),(1571,1380988825,3),(1571,1396713625,4),(1571,1412438425,3),(1571,1428163225,4),(1571,1443888026,3),(1571,1459612826,4),(1571,1475337626,3),(1571,1491062427,4),(1571,1506787227,3),(1571,1522512027,4),(1571,1538841627,3),(1571,1554566427,4),(1571,1570291227,3),(1571,1586016027,4),(1571,1601740827,3),(1571,1617465627,4),(1571,1633190427,3),(1571,1648915227,4),(1571,1664640027,3),(1571,1680364827,4),(1571,1696089627,3),(1571,1712419227,4),(1571,1728144027,3),(1571,1743868827,4),(1571,1759593627,3),(1571,1775318427,4),(1571,1791043227,3),(1571,1806768027,4),(1571,1822492827,3),(1571,1838217627,4),(1571,1853942427,3),(1571,1869667227,4),(1571,1885996827,3),(1571,1901721627,4),(1571,1917446427,3),(1571,1933171227,4),(1571,1948896027,3),(1571,1964620827,4),(1571,1980345627,3),(1571,1996070427,4),(1571,2011795227,3),(1571,2027520027,4),(1571,2043244827,3),(1571,2058969627,4),(1571,2075299227,3),(1571,2091024027,4),(1571,2106748827,3),(1571,2122473627,4),(1571,2138198427,3),(1572,-2147483648,2),(1572,-1672567140,1),(1572,-1665392400,2),(1572,-883641600,1),(1572,-876128400,2),(1572,-860400000,1),(1572,-844678800,2),(1572,-828345600,1),(1572,-813229200,2),(1572,57686400,3),(1572,67968000,4),(1572,89136001,3),(1572,100022402,4),(1572,120585602,3),(1572,131472003,4),(1572,152035203,3),(1572,162921604,4),(1572,183484804,3),(1572,194976005,4),(1572,215539205,3),(1572,226425606,4),(1572,246988806,3),(1572,257875207,4),(1572,278438407,3),(1572,289324808,4),(1572,309888008,3),(1572,320774409,4),(1572,341337609,3),(1572,352224009,4),(1572,372787210,3),(1572,386697610,4),(1572,404841611,3),(1572,415728011,4),(1572,436291212,3),(1572,447177612,4),(1572,467740812,3),(1572,478627212,4),(1572,499190413,3),(1572,511286413,4),(1572,530035213,3),(1572,542736013,4),(1572,562089613,3),(1572,574790414,4),(1572,594144014,3),(1572,606240014,4),(1572,625593614,3),(1572,636480015,4),(1572,657043215,3),(1572,667929616,4),(1572,688492816,3),(1572,699379216,4),(1572,719942417,3),(1572,731433617,4),(1572,751996818,3),(1572,762883218,4),(1572,783446419,3),(1572,794332819,4),(1572,814896019,3),(1572,828201620,4),(1572,846345620,3),(1572,859651220,4),(1572,877795221,3),(1572,891100821,4),(1572,909244821,3),(1572,922550422,4),(1572,941299222,3),(1572,954000022,4),(1572,967305622,3),(1572,985449622,4),(1572,1004198422,3),(1572,1017504022,4),(1572,1035648022,3),(1572,1048953622,4),(1572,1067097622,3),(1572,1080403222,4),(1572,1099152022,3),(1572,1111852822,4),(1572,1130601622,3),(1572,1143907223,4),(1572,1162051223,3),(1572,1174752023,4),(1572,1193500823,3),(1572,1207411223,4),(1572,1223136023,3),(1572,1238860824,4),(1572,1254585624,3),(1572,1270310424,4),(1572,1286035224,3),(1572,1301760024,4),(1572,1317484824,3),(1572,1333209624,4),(1572,1349539225,3),(1572,1365264025,4),(1572,1380988825,3),(1572,1396713625,4),(1572,1412438425,3),(1572,1428163225,4),(1572,1443888026,3),(1572,1459612826,4),(1572,1475337626,3),(1572,1491062427,4),(1572,1506787227,3),(1572,1522512027,4),(1572,1538841627,3),(1572,1554566427,4),(1572,1570291227,3),(1572,1586016027,4),(1572,1601740827,3),(1572,1617465627,4),(1572,1633190427,3),(1572,1648915227,4),(1572,1664640027,3),(1572,1680364827,4),(1572,1696089627,3),(1572,1712419227,4),(1572,1728144027,3),(1572,1743868827,4),(1572,1759593627,3),(1572,1775318427,4),(1572,1791043227,3),(1572,1806768027,4),(1572,1822492827,3),(1572,1838217627,4),(1572,1853942427,3),(1572,1869667227,4),(1572,1885996827,3),(1572,1901721627,4),(1572,1917446427,3),(1572,1933171227,4),(1572,1948896027,3),(1572,1964620827,4),(1572,1980345627,3),(1572,1996070427,4),(1572,2011795227,3),(1572,2027520027,4),(1572,2043244827,3),(1572,2058969627,4),(1572,2075299227,3),(1572,2091024027,4),(1572,2106748827,3),(1572,2122473627,4),(1572,2138198427,3),(1573,-2147483648,2),(1573,-1672565340,1),(1573,-1665390600,2),(1573,-883639800,1),(1573,-876126600,2),(1573,-860398200,1),(1573,-844677000,2),(1573,-828343800,1),(1573,-813227400,2),(1574,-2147483648,2),(1574,-1672559940,1),(1574,-1665385200,2),(1574,-883634400,1),(1574,-876121200,2),(1574,-860392800,1),(1574,-844671600,2),(1574,152042403,3),(1574,162928804,4),(1574,436298412,3),(1574,447184812,4),(1574,690314416,3),(1574,699386416,4),(1574,1165082423,3),(1574,1174759223,4),(1574,1193508023,3),(1574,1206813623,4),(1574,1224957623,3),(1574,1238263224,4),(1575,-2147483648,2),(1575,-1672567140,1),(1575,-1665392400,2),(1575,-883641600,1),(1575,-876128400,2),(1575,-860400000,1),(1575,-844678800,2),(1575,-828345600,1),(1575,-813229200,2),(1575,57686400,3),(1575,67968000,4),(1575,625593614,3),(1575,636480015,4),(1575,657043215,3),(1575,667929616,4),(1575,688492816,3),(1575,699379216,4),(1576,-2147483648,2),(1576,-1672565340,1),(1576,-1665390600,2),(1576,-883639800,1),(1576,-876126600,2),(1576,-860398200,1),(1576,-844677000,2),(1576,-828343800,1),(1576,-813227400,2),(1576,57688200,3),(1576,67969800,4),(1576,89137801,3),(1576,100024202,4),(1576,120587402,3),(1576,131473803,4),(1576,152037003,3),(1576,162923404,4),(1576,183486604,3),(1576,194977805,4),(1576,215541005,3),(1576,226427406,4),(1576,246990606,3),(1576,257877007,4),(1576,278440207,3),(1576,289326608,4),(1576,309889808,3),(1576,320776209,4),(1576,341339409,3),(1576,352225809,4),(1576,372789010,3),(1576,384280210,4),(1576,404843411,3),(1576,415729811,4),(1576,436293012,3),(1576,447179412,4),(1576,467742612,3),(1576,478629012,4),(1576,499192213,3),(1576,511288213,4),(1576,530037013,3),(1576,542737813,4),(1576,562091413,3),(1576,574792214,4),(1576,594145814,3),(1576,606241814,4),(1576,625595414,3),(1576,637691415,4),(1576,657045015,3),(1576,667931416,4),(1576,688494616,3),(1576,701195416,4),(1576,719944217,3),(1576,731435417,4),(1576,751998618,3),(1576,764094618,4),(1576,783448219,3),(1576,796149019,4),(1576,814897819,3),(1576,828203420,4),(1576,846347420,3),(1576,859653020,4),(1576,877797021,3),(1576,891102621,4),(1576,909246621,3),(1576,922552222,4),(1576,941301022,3),(1576,954001822,4),(1576,972750622,3),(1576,985451422,4),(1576,1004200222,3),(1576,1017505822,4),(1576,1035649822,3),(1576,1048955422,4),(1576,1067099422,3),(1576,1080405022,4),(1576,1099153822,3),(1576,1111854622,4),(1576,1130603422,3),(1576,1143909023,4),(1576,1162053023,3),(1576,1174753823,4),(1576,1193502623,3),(1576,1207413023,4),(1576,1223137823,3),(1576,1238862624,4),(1576,1254587424,3),(1576,1270312224,4),(1576,1286037024,3),(1576,1301761824,4),(1576,1317486624,3),(1576,1333211424,4),(1576,1349541025,3),(1576,1365265825,4),(1576,1380990625,3),(1576,1396715425,4),(1576,1412440225,3),(1576,1428165025,4),(1576,1443889826,3),(1576,1459614626,4),(1576,1475339426,3),(1576,1491064227,4),(1576,1506789027,3),(1576,1522513827,4),(1576,1538843427,3),(1576,1554568227,4),(1576,1570293027,3),(1576,1586017827,4),(1576,1601742627,3),(1576,1617467427,4),(1576,1633192227,3),(1576,1648917027,4),(1576,1664641827,3),(1576,1680366627,4),(1576,1696091427,3),(1576,1712421027,4),(1576,1728145827,3),(1576,1743870627,4),(1576,1759595427,3),(1576,1775320227,4),(1576,1791045027,3),(1576,1806769827,4),(1576,1822494627,3),(1576,1838219427,4),(1576,1853944227,3),(1576,1869669027,4),(1576,1885998627,3),(1576,1901723427,4),(1576,1917448227,3),(1576,1933173027,4),(1576,1948897827,3),(1576,1964622627,4),(1576,1980347427,3),(1576,1996072227,4),(1576,2011797027,3),(1576,2027521827,4),(1576,2043246627,3),(1576,2058971427,4),(1576,2075301027,3),(1576,2091025827,4),(1576,2106750627,3),(1576,2122475427,4),(1576,2138200227,3),(1577,-2147483648,2),(1577,-1672567140,1),(1577,-1665392400,2),(1577,-883641600,1),(1577,-876128400,2),(1577,-860400000,1),(1577,-844678800,2),(1577,-828345600,1),(1577,-813229200,2),(1577,57686400,3),(1577,67968000,4),(1577,89136001,3),(1577,100022402,4),(1577,120585602,3),(1577,131472003,4),(1577,152035203,3),(1577,162921604,4),(1577,183484804,3),(1577,194976005,4),(1577,215539205,3),(1577,226425606,4),(1577,246988806,3),(1577,257875207,4),(1577,278438407,3),(1577,289324808,4),(1577,309888008,3),(1577,320774409,4),(1577,341337609,3),(1577,352224009,4),(1577,372787210,3),(1577,386697610,4),(1577,404841611,3),(1577,415728011,4),(1577,436291212,3),(1577,447177612,4),(1577,467740812,3),(1577,478627212,4),(1577,499190413,3),(1577,511286413,4),(1577,530035213,3),(1577,542736013,4),(1577,562089613,3),(1577,574790414,4),(1577,594144014,3),(1577,606240014,4),(1577,625593614,3),(1577,636480015,4),(1577,657043215,3),(1577,667929616,4),(1577,688492816,3),(1577,699379216,4),(1577,719942417,3),(1577,731433617,4),(1577,751996818,3),(1577,762883218,4),(1577,783446419,3),(1577,794332819,4),(1577,814896019,3),(1577,828201620,4),(1577,846345620,3),(1577,859651220,4),(1577,877795221,3),(1577,891100821,4),(1577,909244821,3),(1577,922550422,4),(1577,941299222,3),(1577,954000022,4),(1577,967305622,3),(1577,985449622,4),(1577,1004198422,3),(1577,1017504022,4),(1577,1035648022,3),(1577,1048953622,4),(1577,1067097622,3),(1577,1080403222,4),(1577,1099152022,3),(1577,1111852822,4),(1577,1130601622,3),(1577,1143907223,4),(1577,1162051223,3),(1577,1174752023,4),(1577,1193500823,3),(1577,1207411223,4),(1577,1223136023,3),(1577,1238860824,4),(1577,1254585624,3),(1577,1270310424,4),(1577,1286035224,3),(1577,1301760024,4),(1577,1317484824,3),(1577,1333209624,4),(1577,1349539225,3),(1577,1365264025,4),(1577,1380988825,3),(1577,1396713625,4),(1577,1412438425,3),(1577,1428163225,4),(1577,1443888026,3),(1577,1459612826,4),(1577,1475337626,3),(1577,1491062427,4),(1577,1506787227,3),(1577,1522512027,4),(1577,1538841627,3),(1577,1554566427,4),(1577,1570291227,3),(1577,1586016027,4),(1577,1601740827,3),(1577,1617465627,4),(1577,1633190427,3),(1577,1648915227,4),(1577,1664640027,3),(1577,1680364827,4),(1577,1696089627,3),(1577,1712419227,4),(1577,1728144027,3),(1577,1743868827,4),(1577,1759593627,3),(1577,1775318427,4),(1577,1791043227,3),(1577,1806768027,4),(1577,1822492827,3),(1577,1838217627,4),(1577,1853942427,3),(1577,1869667227,4),(1577,1885996827,3),(1577,1901721627,4),(1577,1917446427,3),(1577,1933171227,4),(1577,1948896027,3),(1577,1964620827,4),(1577,1980345627,3),(1577,1996070427,4),(1577,2011795227,3),(1577,2027520027,4),(1577,2043244827,3),(1577,2058969627,4),(1577,2075299227,3),(1577,2091024027,4),(1577,2106748827,3),(1577,2122473627,4),(1577,2138198427,3),(1578,-2147483648,1),(1578,-1680508800,2),(1578,-1665392400,1),(1578,-883641600,2),(1578,-876128400,1),(1578,-860400000,2),(1578,-844678800,1),(1578,-828345600,2),(1578,-813229200,1),(1578,-71136000,3),(1578,-55411200,4),(1578,-37267200,3),(1578,-25776000,4),(1578,-5817600,3),(1578,5673600,4),(1578,25632000,3),(1578,37728000,4),(1578,57686400,3),(1578,67968000,4),(1578,89136001,3),(1578,100022402,4),(1578,120585602,3),(1578,131472003,4),(1578,152035203,3),(1578,162921604,4),(1578,183484804,3),(1578,194976005,4),(1578,215539205,3),(1578,226425606,4),(1578,246988806,3),(1578,257875207,4),(1578,278438407,3),(1578,289324808,4),(1578,309888008,3),(1578,320774409,4),(1578,341337609,3),(1578,352224009,4),(1578,372787210,3),(1578,386092810,4),(1578,404841611,3),(1578,417542411,4),(1578,436291212,3),(1578,447177612,4),(1578,467740812,3),(1578,478627212,4),(1578,499190413,3),(1578,510076813,4),(1578,530035213,3),(1578,542736013,4),(1578,562089613,3),(1578,574790414,4),(1578,594144014,3),(1578,606240014,4),(1578,625593614,3),(1578,637689615,4),(1578,657043215,3),(1578,670348816,4),(1578,686678416,3),(1578,701798416,4),(1578,718128017,3),(1578,733248017,4),(1578,749577618,3),(1578,764697618,4),(1578,781027219,3),(1578,796147219,4),(1578,812476819,3),(1578,828201620,4),(1578,844531220,3),(1578,859651220,4),(1578,875980821,3),(1578,891100821,4),(1578,907430421,3),(1578,922550422,4),(1578,938880022,3),(1578,954000022,4),(1578,967305622,3),(1578,985449622,4),(1578,1002384022,3),(1578,1017504022,4),(1578,1033833622,3),(1578,1048953622,4),(1578,1065283222,3),(1578,1080403222,4),(1578,1096732822,3),(1578,1111852822,4),(1578,1128182422,3),(1578,1143907223,4),(1578,1159632023,3),(1578,1174752023,4),(1578,1191686423,3),(1578,1207411223,4),(1578,1223136023,3),(1578,1238860824,4),(1578,1254585624,3),(1578,1270310424,4),(1578,1286035224,3),(1578,1301760024,4),(1578,1317484824,3),(1578,1333209624,4),(1578,1349539225,3),(1578,1365264025,4),(1578,1380988825,3),(1578,1396713625,4),(1578,1412438425,3),(1578,1428163225,4),(1578,1443888026,3),(1578,1459612826,4),(1578,1475337626,3),(1578,1491062427,4),(1578,1506787227,3),(1578,1522512027,4),(1578,1538841627,3),(1578,1554566427,4),(1578,1570291227,3),(1578,1586016027,4),(1578,1601740827,3),(1578,1617465627,4),(1578,1633190427,3),(1578,1648915227,4),(1578,1664640027,3),(1578,1680364827,4),(1578,1696089627,3),(1578,1712419227,4),(1578,1728144027,3),(1578,1743868827,4),(1578,1759593627,3),(1578,1775318427,4),(1578,1791043227,3),(1578,1806768027,4),(1578,1822492827,3),(1578,1838217627,4),(1578,1853942427,3),(1578,1869667227,4),(1578,1885996827,3),(1578,1901721627,4),(1578,1917446427,3),(1578,1933171227,4),(1578,1948896027,3),(1578,1964620827,4),(1578,1980345627,3),(1578,1996070427,4),(1578,2011795227,3),(1578,2027520027,4),(1578,2043244827,3),(1578,2058969627,4),(1578,2075299227,3),(1578,2091024027,4),(1578,2106748827,3),(1578,2122473627,4),(1578,2138198427,3),(1579,-2147483648,2),(1579,-1672567140,1),(1579,-1665392400,2),(1579,-883641600,1),(1579,-876128400,2),(1579,-860400000,1),(1579,-844678800,2),(1579,-828345600,1),(1579,-813229200,2),(1579,57686400,3),(1579,67968000,4),(1579,89136001,3),(1579,100022402,4),(1579,120585602,3),(1579,131472003,4),(1579,152035203,3),(1579,162921604,4),(1579,183484804,3),(1579,194976005,4),(1579,215539205,3),(1579,226425606,4),(1579,246988806,3),(1579,257875207,4),(1579,278438407,3),(1579,289324808,4),(1579,309888008,3),(1579,320774409,4),(1579,341337609,3),(1579,352224009,4),(1579,372787210,3),(1579,384278410,4),(1579,404841611,3),(1579,415728011,4),(1579,436291212,3),(1579,447177612,4),(1579,467740812,3),(1579,478627212,4),(1579,499190413,3),(1579,511286413,4),(1579,530035213,3),(1579,542736013,4),(1579,561484813,3),(1579,574790414,4),(1579,594144014,3),(1579,606240014,4),(1579,625593614,3),(1579,637689615,4),(1579,657043215,3),(1579,667929616,4),(1579,688492816,3),(1579,699379216,4),(1579,719942417,3),(1579,731433617,4),(1579,751996818,3),(1579,762883218,4),(1579,783446419,3),(1579,796147219,4),(1579,814896019,3),(1579,828201620,4),(1579,846345620,3),(1579,859651220,4),(1579,877795221,3),(1579,891100821,4),(1579,909244821,3),(1579,922550422,4),(1579,941299222,3),(1579,954000022,4),(1579,967305622,3),(1579,985449622,4),(1579,1004198422,3),(1579,1017504022,4),(1579,1035648022,3),(1579,1048953622,4),(1579,1067097622,3),(1579,1080403222,4),(1579,1099152022,3),(1579,1111852822,4),(1579,1130601622,3),(1579,1143907223,4),(1579,1162051223,3),(1579,1174752023,4),(1579,1193500823,3),(1579,1207411223,4),(1579,1223136023,3),(1579,1238860824,4),(1579,1254585624,3),(1579,1270310424,4),(1579,1286035224,3),(1579,1301760024,4),(1579,1317484824,3),(1579,1333209624,4),(1579,1349539225,3),(1579,1365264025,4),(1579,1380988825,3),(1579,1396713625,4),(1579,1412438425,3),(1579,1428163225,4),(1579,1443888026,3),(1579,1459612826,4),(1579,1475337626,3),(1579,1491062427,4),(1579,1506787227,3),(1579,1522512027,4),(1579,1538841627,3),(1579,1554566427,4),(1579,1570291227,3),(1579,1586016027,4),(1579,1601740827,3),(1579,1617465627,4),(1579,1633190427,3),(1579,1648915227,4),(1579,1664640027,3),(1579,1680364827,4),(1579,1696089627,3),(1579,1712419227,4),(1579,1728144027,3),(1579,1743868827,4),(1579,1759593627,3),(1579,1775318427,4),(1579,1791043227,3),(1579,1806768027,4),(1579,1822492827,3),(1579,1838217627,4),(1579,1853942427,3),(1579,1869667227,4),(1579,1885996827,3),(1579,1901721627,4),(1579,1917446427,3),(1579,1933171227,4),(1579,1948896027,3),(1579,1964620827,4),(1579,1980345627,3),(1579,1996070427,4),(1579,2011795227,3),(1579,2027520027,4),(1579,2043244827,3),(1579,2058969627,4),(1579,2075299227,3),(1579,2091024027,4),(1579,2106748827,3),(1579,2122473627,4),(1579,2138198427,3),(1580,-2147483648,2),(1580,-1672559940,1),(1580,-1665385200,2),(1580,-883634400,1),(1580,-876121200,2),(1580,-860392800,1),(1580,-844671600,2),(1580,152042403,3),(1580,162928804,4),(1580,436298412,3),(1580,447184812,4),(1580,690314416,3),(1580,699386416,4),(1580,1165082423,3),(1580,1174759223,4),(1580,1193508023,3),(1580,1206813623,4),(1580,1224957623,3),(1580,1238263224,4),(1581,-2147483648,2),(1581,-1672565340,1),(1581,-1665390600,2),(1581,-883639800,1),(1581,-876126600,2),(1581,-860398200,1),(1581,-844677000,2),(1581,-828343800,1),(1581,-813227400,2),(1581,57688200,3),(1581,67969800,4),(1581,89137801,3),(1581,100024202,4),(1581,120587402,3),(1581,131473803,4),(1581,152037003,3),(1581,162923404,4),(1581,183486604,3),(1581,194977805,4),(1581,215541005,3),(1581,226427406,4),(1581,246990606,3),(1581,257877007,4),(1581,278440207,3),(1581,289326608,4),(1581,309889808,3),(1581,320776209,4),(1581,341339409,3),(1581,352225809,4),(1581,372789010,3),(1581,386699410,4),(1581,404843411,3),(1581,415729811,4),(1581,436293012,3),(1581,447179412,4),(1581,467742612,3),(1581,478629012,4),(1581,499192213,3),(1581,511288213,4),(1581,530037013,3),(1581,542737813,4),(1581,562091413,3),(1581,574792214,4),(1581,594145814,3),(1581,606241814,4),(1581,625595414,3),(1581,636481815,4),(1581,657045015,3),(1581,667931416,4),(1581,688494616,3),(1581,699381016,4),(1581,719944217,3),(1581,731435417,4),(1581,751998618,3),(1581,762885018,4),(1581,783448219,3),(1581,794334619,4),(1581,814897819,3),(1581,828203420,4),(1581,846347420,3),(1581,859653020,4),(1581,877797021,3),(1581,891102621,4),(1581,909246621,3),(1581,922552222,4),(1581,941301022,3),(1581,946647022,1),(1581,954001822,4),(1581,972750622,3),(1581,985451422,4),(1581,1004200222,3),(1581,1017505822,4),(1581,1035649822,3),(1581,1048955422,4),(1581,1067099422,3),(1581,1080405022,4),(1581,1099153822,3),(1581,1111854622,4),(1581,1130603422,3),(1581,1143909023,4),(1581,1162053023,3),(1581,1174753823,4),(1581,1193502623,3),(1581,1207413023,4),(1581,1223137823,3),(1581,1238862624,4),(1581,1254587424,3),(1581,1270312224,4),(1581,1286037024,3),(1581,1301761824,4),(1581,1317486624,3),(1581,1333211424,4),(1581,1349541025,3),(1581,1365265825,4),(1581,1380990625,3),(1581,1396715425,4),(1581,1412440225,3),(1581,1428165025,4),(1581,1443889826,3),(1581,1459614626,4),(1581,1475339426,3),(1581,1491064227,4),(1581,1506789027,3),(1581,1522513827,4),(1581,1538843427,3),(1581,1554568227,4),(1581,1570293027,3),(1581,1586017827,4),(1581,1601742627,3),(1581,1617467427,4),(1581,1633192227,3),(1581,1648917027,4),(1581,1664641827,3),(1581,1680366627,4),(1581,1696091427,3),(1581,1712421027,4),(1581,1728145827,3),(1581,1743870627,4),(1581,1759595427,3),(1581,1775320227,4),(1581,1791045027,3),(1581,1806769827,4),(1581,1822494627,3),(1581,1838219427,4),(1581,1853944227,3),(1581,1869669027,4),(1581,1885998627,3),(1581,1901723427,4),(1581,1917448227,3),(1581,1933173027,4),(1581,1948897827,3),(1581,1964622627,4),(1581,1980347427,3),(1581,1996072227,4),(1581,2011797027,3),(1581,2027521827,4),(1581,2043246627,3),(1581,2058971427,4),(1581,2075301027,3),(1581,2091025827,4),(1581,2106750627,3),(1581,2122475427,4),(1581,2138200227,3),(1582,-2147483648,0),(1582,-1767209328,2),(1582,-1206950400,1),(1582,-1191355200,2),(1582,-1175367600,1),(1582,-1159819200,2),(1582,-633812400,1),(1582,-622062000,2),(1582,-602276400,1),(1582,-591825600,2),(1582,-570740400,1),(1582,-560203200,2),(1582,-539118000,1),(1582,-531345600,2),(1582,-191358000,1),(1582,-184190400,2),(1582,-155156400,1),(1582,-150062400,2),(1582,-128890800,1),(1582,-121118400,2),(1582,-99946800,1),(1582,-89582400,2),(1582,-68410800,1),(1582,-57960000,2),(1582,499755613,1),(1582,511243213,2),(1582,530600413,1),(1582,540273613,2),(1582,562136413,1),(1582,571204814,2),(1582,1214283623,3),(1582,1384056025,2),(1583,-2147483648,0),(1583,-1767217820,2),(1583,-1206961200,1),(1583,-1191366000,2),(1583,-1175378400,1),(1583,-1159830000,2),(1583,-633823200,1),(1583,-622072800,2),(1583,-602287200,1),(1583,-591836400,2),(1583,-570751200,1),(1583,-560214000,2),(1583,-539128800,1),(1583,-531356400,2),(1583,-191368800,1),(1583,-184201200,2),(1583,-155167200,1),(1583,-150073200,2),(1583,-128901600,1),(1583,-121129200,2),(1583,-99957600,1),(1583,-89593200,2),(1583,-68421600,1),(1583,-57970800,2),(1583,499744813,1),(1583,511232413,2),(1583,530589613,1),(1583,540262813,2),(1583,562125613,1),(1583,571194014,2),(1583,592970414,1),(1583,602038814,2),(1583,624420014,1),(1583,634698015,2),(1583,938916022,1),(1583,951613222,2),(1583,970970422,1),(1583,971571622,2),(1583,1003024822,1),(1583,1013907622,2),(1584,-2147483648,0),(1584,-1767214412,2),(1584,-1206957600,1),(1584,-1191362400,2),(1584,-1175374800,1),(1584,-1159826400,2),(1584,-633819600,1),(1584,-622069200,2),(1584,-602283600,1),(1584,-591832800,2),(1584,-570747600,1),(1584,-560210400,2),(1584,-539125200,1),(1584,-531352800,2),(1584,-195426000,1),(1584,-184197600,2),(1584,-155163600,1),(1584,-150069600,2),(1584,-128898000,1),(1584,-121125600,2),(1584,-99954000,1),(1584,-89589600,2),(1584,-68418000,1),(1584,-57967200,2),(1584,499748413,1),(1584,511236013,2),(1584,530593213,1),(1584,540266413,2),(1584,562129213,1),(1584,571197614,2),(1584,592974014,1),(1584,602042414,2),(1584,624423614,1),(1584,634701615,2),(1584,656478015,1),(1584,666756016,2),(1584,687927616,1),(1584,697600816,2),(1584,719982017,1),(1584,728445617,2),(1584,750826818,1),(1584,761709618,2),(1584,782276419,1),(1584,793159219,2),(1584,813726019,1),(1584,824004020,2),(1584,844570820,1),(1584,856058420,2),(1584,876106821,1),(1584,888717621,2),(1584,908074821,1),(1584,919562422,2),(1584,938919622,1),(1584,951616822,2),(1584,970974022,1),(1584,982461622,2),(1584,1003028422,1),(1584,1013911222,2),(1584,1036292422,1),(1584,1045360822,2),(1584,1066532422,1),(1584,1076810422,2),(1584,1099364422,1),(1584,1108864822,2),(1584,1129431622,1),(1584,1140314423,2),(1584,1162695623,1),(1584,1172368823,2),(1584,1192330823,1),(1584,1203213623,2),(1584,1224385223,1),(1584,1234663224,2),(1584,1255834824,1),(1584,1266717624,2),(1584,1287284424,1),(1584,1298167224,2),(1584,1318734024,1),(1584,1330221624,2),(1584,1350788425,1),(1584,1361066425,2),(1584,1382238025,1),(1584,1392516025,2),(1584,1413687625,1),(1584,1424570425,2),(1584,1445137226,1),(1584,1456020026,2),(1584,1476586826,1),(1584,1487469627,2),(1584,1508036427,1),(1584,1518919227,2),(1584,1541300427,1),(1584,1550368827,2),(1584,1572750027,1),(1584,1581818427,2),(1584,1604199627,1),(1584,1613872827,2),(1584,1636254027,1),(1584,1645322427,2),(1584,1667703627,1),(1584,1677376827,2),(1584,1699153227,1),(1584,1708221627,2),(1584,1730602827,1),(1584,1739671227,2),(1584,1762052427,1),(1584,1771725627,2),(1584,1793502027,1),(1584,1803175227,2),(1584,1825556427,1),(1584,1834624827,2),(1584,1857006027,1),(1584,1866074427,2),(1584,1888455627,1),(1584,1897524027,2),(1584,1919905227,1),(1584,1928973627,2),(1584,1951354827,1),(1584,1960423227,2),(1584,1983409227,1),(1584,1992477627,2),(1584,2014858827,1),(1584,2024532027,2),(1584,2046308427,1),(1584,2055376827,2),(1584,2077758027,1),(1584,2086826427,2),(1584,2109207627,1),(1584,2118880827,2),(1584,2140657227,1),(1585,-2147483648,0),(1585,-1767211196,2),(1585,-1206954000,1),(1585,-1191358800,2),(1585,-1175371200,1),(1585,-1159822800,2),(1585,-633816000,1),(1585,-622065600,2),(1585,-602280000,1),(1585,-591829200,2),(1585,-570744000,1),(1585,-560206800,2),(1585,-539121600,1),(1585,-531349200,2),(1585,-191361600,1),(1585,-184194000,2),(1585,-155160000,1),(1585,-150066000,2),(1585,-128894400,1),(1585,-121122000,2),(1585,-99950400,1),(1585,-89586000,2),(1585,-68414400,1),(1585,-57963600,2),(1585,499752013,1),(1585,511239613,2),(1585,530596813,1),(1585,540270013,2),(1585,562132813,1),(1585,571201214,2),(1585,750830418,1),(1585,761713218,2),(1586,-1693706400,0),(1586,-1680483600,1),(1586,-1663455600,2),(1586,-1650150000,3),(1586,-1632006000,2),(1586,-1618700400,3),(1586,-938905200,2),(1586,-857257200,3),(1586,-844556400,2),(1586,-828226800,3),(1586,-812502000,2),(1586,-796777200,3),(1586,-781052400,2),(1586,-766623600,3),(1586,228877206,2),(1586,243997206,3),(1586,260326807,2),(1586,276051607,3),(1586,291776408,2),(1586,307501208,3),(1586,323830809,2),(1586,338950809,3),(1586,354675609,2),(1586,370400410,3),(1586,386125210,2),(1586,401850011,3),(1586,417574811,2),(1586,433299612,3),(1586,449024412,2),(1586,465354012,3),(1586,481078812,2),(1586,496803613,3),(1586,512528413,2),(1586,528253213,3),(1586,543978013,2),(1586,559702813,3),(1586,575427614,2),(1586,591152414,3),(1586,606877214,2),(1586,622602014,3),(1586,638326815,2),(1586,654656415,3),(1586,670381216,2),(1586,686106016,3),(1586,701830816,2),(1586,717555617,3),(1586,733280417,2),(1586,749005218,3),(1586,764730018,2),(1586,780454819,3),(1586,796179619,2),(1586,811904419,3),(1586,828234020,2),(1586,846378020,3),(1586,859683620,2),(1586,877827621,3),(1586,891133221,2),(1586,909277221,3),(1586,922582822,2),(1586,941331622,3),(1586,954032422,2),(1586,972781222,3),(1586,985482022,2),(1586,1004230822,3),(1586,1017536422,2),(1586,1035680422,3),(1586,1048986022,2),(1586,1067130022,3),(1586,1080435622,2),(1586,1099184422,3),(1586,1111885222,2),(1586,1130634022,3),(1586,1143334823,2),(1586,1162083623,3),(1586,1174784423,2),(1586,1193533223,3),(1586,1206838823,2),(1586,1224982823,3),(1586,1238288424,2),(1586,1256432424,3),(1586,1269738024,2),(1586,1288486824,3),(1586,1301187624,2),(1586,1319936424,3),(1586,1332637224,2),(1586,1351386025,3),(1586,1364691625,2),(1586,1382835625,3),(1586,1396141225,2),(1586,1414285225,3),(1586,1427590825,2),(1586,1445734826,3),(1586,1459040426,2),(1586,1477789226,3),(1586,1490490027,2),(1586,1509238827,3),(1586,1521939627,2),(1586,1540688427,3),(1586,1553994027,2),(1586,1572138027,3),(1586,1585443627,2),(1586,1603587627,3),(1586,1616893227,2),(1586,1635642027,3),(1586,1648342827,2),(1586,1667091627,3),(1586,1679792427,2),(1586,1698541227,3),(1586,1711846827,2),(1586,1729990827,3),(1586,1743296427,2),(1586,1761440427,3),(1586,1774746027,2),(1586,1792890027,3),(1586,1806195627,2),(1586,1824944427,3),(1586,1837645227,2),(1586,1856394027,3),(1586,1869094827,2),(1586,1887843627,3),(1586,1901149227,2),(1586,1919293227,3),(1586,1932598827,2),(1586,1950742827,3),(1586,1964048427,2),(1586,1982797227,3),(1586,1995498027,2),(1586,2014246827,3),(1586,2026947627,2),(1586,2045696427,3),(1586,2058397227,2),(1586,2077146027,3),(1586,2090451627,2),(1586,2108595627,3),(1586,2121901227,2),(1586,2140045227,3),(1587,-1633276800,0),(1587,-1615136400,1),(1587,-1601827200,0),(1587,-1583686800,1),(1587,-880214400,2),(1587,-769395600,3),(1587,-765392400,1),(1587,-84384000,0),(1587,-68662800,1),(1587,-52934400,0),(1587,-37213200,1),(1587,-21484800,0),(1587,-5763600,1),(1587,9964800,0),(1587,25686000,1),(1587,41414400,0),(1587,57740400,1),(1587,73468800,0),(1587,89190001,1),(1587,104918402,0),(1587,120639602,1),(1587,126691203,0),(1587,152089203,1),(1587,162374404,0),(1587,183538804,1),(1587,199267205,0),(1587,215593205,1),(1587,230716806,0),(1587,247042806,1),(1587,262771207,0),(1587,278492407,1),(1587,294220808,0),(1587,309942008,1),(1587,325670409,0),(1587,341391609,1),(1587,357120009,0),(1587,372841210,1),(1587,388569610,0),(1587,404895611,1),(1587,420019211,0),(1587,436345212,1),(1587,452073612,0),(1587,467794812,1),(1587,483523212,0),(1587,499244413,1),(1587,514972813,0),(1587,530694013,1),(1587,544608013,0),(1587,562143613,1),(1587,576057614,0),(1587,594198014,1),(1587,607507214,0),(1587,625647614,1),(1587,638956815,0),(1587,657097215,1),(1587,671011216,0),(1587,688546816,1),(1587,702460816,0),(1587,719996417,1),(1587,733910417,0),(1587,752050818,1),(1587,765360018,0),(1587,783500419,1),(1587,796809619,0),(1587,814950019,1),(1587,828864020,0),(1587,846399620,1),(1587,860313620,0),(1587,877849221,1),(1587,891763221,0),(1587,909298821,1),(1587,923212822,0),(1587,941353222,1),(1587,954662422,0),(1587,972802822,1),(1587,986112022,0),(1587,1004252422,1),(1587,1018166422,0),(1587,1035702022,1),(1587,1049616022,0),(1587,1067151622,1),(1587,1081065622,0),(1587,1099206022,1),(1587,1112515222,0),(1587,1130655622,1),(1587,1143964823,0),(1587,1162105223,1),(1587,1173600023,0),(1587,1194159623,1),(1587,1205049623,0),(1587,1225609223,1),(1587,1236499224,0),(1587,1257058824,1),(1587,1268553624,0),(1587,1289113224,1),(1587,1300003224,0),(1587,1320562824,1),(1587,1331452824,0),(1587,1352012425,1),(1587,1362902425,0),(1587,1383462025,1),(1587,1394352025,0),(1587,1414911625,1),(1587,1425801625,0),(1587,1446361226,1),(1587,1457856026,0),(1587,1478415626,1),(1587,1489305627,0),(1587,1509865227,1),(1587,1520755227,0),(1587,1541314827,1),(1587,1552204827,0),(1587,1572764427,1),(1587,1583654427,0),(1587,1604214027,1),(1587,1615708827,0),(1587,1636268427,1),(1587,1647158427,0),(1587,1667718027,1),(1587,1678608027,0),(1587,1699167627,1),(1587,1710057627,0),(1587,1730617227,1),(1587,1741507227,0),(1587,1762066827,1),(1587,1772956827,0),(1587,1793516427,1),(1587,1805011227,0),(1587,1825570827,1),(1587,1836460827,0),(1587,1857020427,1),(1587,1867910427,0),(1587,1888470027,1),(1587,1899360027,0),(1587,1919919627,1),(1587,1930809627,0),(1587,1951369227,1),(1587,1962864027,0),(1587,1983423627,1),(1587,1994313627,0),(1587,2014873227,1),(1587,2025763227,0),(1587,2046322827,1),(1587,2057212827,0),(1587,2077772427,1),(1587,2088662427,0),(1587,2109222027,1),(1587,2120112027,0),(1587,2140671627,1),(1588,-2147483648,0),(1588,-2131645536,2),(1588,-1696276800,1),(1588,-1680469200,2),(1588,-1632074400,1),(1588,-1615143600,2),(1588,-1566763200,1),(1588,-1557090000,2),(1588,-1535486400,1),(1588,-1524949200,2),(1588,-1504468800,1),(1588,-1493413200,2),(1588,-1472414400,1),(1588,-1461963600,2),(1588,-1440964800,1),(1588,-1429390800,2),(1588,-1409515200,1),(1588,-1396731600,2),(1588,-1376856000,1),(1588,-1366491600,2),(1588,-1346616000,1),(1588,-1333832400,2),(1588,-1313956800,1),(1588,-1303678800,2),(1588,-1282507200,1),(1588,-1272661200,2),(1588,-1251057600,1),(1588,-1240088400,2),(1588,-1219608000,1),(1588,-1207429200,2),(1588,-1188763200,1),(1588,-1175979600,2),(1588,-1157313600,1),(1588,-1143925200,2),(1588,-1124049600,1),(1588,-1113771600,2),(1588,-1091390400,1),(1588,-1081026000,2),(1588,-1059854400,1),(1588,-1050786000,2),(1588,-1030910400,1),(1588,-1018126800,2),(1588,-999460800,1),(1588,-986677200,2),(1588,-965592000,1),(1588,-955227600,2),(1588,-935956800,1),(1588,-923173200,2),(1588,-904507200,1),(1588,-891723600,2),(1588,-880221600,3),(1588,-769395600,4),(1588,-765399600,2),(1588,-747252000,1),(1588,-733950000,2),(1588,-715802400,1),(1588,-702500400,2),(1588,-684352800,1),(1588,-671050800,2),(1588,-652903200,1),(1588,-639601200,2),(1588,-589399200,1),(1588,-576097200,2),(1588,-557949600,1),(1588,-544647600,2),(1588,-526500000,1),(1588,-513198000,2),(1588,-495050400,1),(1588,-481748400,2),(1588,-431546400,1),(1588,-418244400,2),(1588,-400096800,1),(1588,-386794800,2),(1588,-368647200,1),(1588,-355345200,2),(1588,-337197600,1),(1588,-323895600,2),(1588,-242244000,1),(1588,-226522800,2),(1588,-210794400,1),(1588,-195073200,2),(1588,-179344800,1),(1588,-163623600,2),(1588,-147895200,1),(1588,-131569200,2),(1588,-116445600,1),(1588,-100119600,2),(1588,-84391200,1),(1588,-68670000,2),(1588,-52941600,1),(1588,-37220400,2),(1588,-21492000,1),(1588,-5770800,2),(1588,9957600,1),(1588,25678800,2),(1588,41407200,1),(1588,57733200,2),(1588,73461600,1),(1588,89182801,2),(1588,104911202,1),(1588,120632402,2),(1588,136360803,1),(1588,152082003,2),(1588,167810404,1),(1588,183531604,2),(1588,199260005,1),(1588,215586005,2),(1588,230709606,1),(1588,247035606,2),(1588,262764007,1),(1588,278485207,2),(1588,294213608,1),(1588,309934808,2),(1588,325663209,1),(1588,341384409,2),(1588,357112809,1),(1588,372834010,2),(1588,388562410,1),(1588,404888411,2),(1588,420012011,1),(1588,436338012,2),(1588,452066412,1),(1588,467787612,2),(1588,483516012,1),(1588,499237213,2),(1588,514965613,1),(1588,530686813,2),(1588,544600813,1),(1588,562136413,2),(1588,576050414,1),(1588,594190814,2),(1588,607500014,1),(1588,625640414,2),(1588,638949615,1),(1588,657090015,2),(1588,671004016,1),(1588,688539616,2),(1588,702453616,1),(1588,719989217,2),(1588,733903217,1),(1588,752043618,2),(1588,765352818,1),(1588,783493219,2),(1588,796802419,1),(1588,814942819,2),(1588,828856820,1),(1588,846392420,2),(1588,860306420,1),(1588,877842021,2),(1588,891756021,1),(1588,909291621,2),(1588,923205622,1),(1588,941346022,2),(1588,954655222,1),(1588,972795622,2),(1588,986104822,1),(1588,1004245222,2),(1588,1018159222,1),(1588,1035694822,2),(1588,1049608822,1),(1588,1067144422,2),(1588,1081058422,1),(1588,1099198822,2),(1588,1112508022,1),(1588,1130648422,2),(1588,1143957623,1),(1588,1162098023,2),(1588,1173592823,1),(1588,1194152423,2),(1588,1205042423,1),(1588,1225602023,2),(1588,1236492024,1),(1588,1257051624,2),(1588,1268546424,1),(1588,1289106024,2),(1588,1299996024,1),(1588,1320555624,2),(1588,1331445624,1),(1588,1352005225,2),(1588,1362895225,1),(1588,1383454825,2),(1588,1394344825,1),(1588,1414904425,2),(1588,1425794425,1),(1588,1446354026,2),(1588,1457848826,1),(1588,1478408426,2),(1588,1489298427,1),(1588,1509858027,2),(1588,1520748027,1),(1588,1541307627,2),(1588,1552197627,1),(1588,1572757227,2),(1588,1583647227,1),(1588,1604206827,2),(1588,1615701627,1),(1588,1636261227,2),(1588,1647151227,1),(1588,1667710827,2),(1588,1678600827,1),(1588,1699160427,2),(1588,1710050427,1),(1588,1730610027,2),(1588,1741500027,1),(1588,1762059627,2),(1588,1772949627,1),(1588,1793509227,2),(1588,1805004027,1),(1588,1825563627,2),(1588,1836453627,1),(1588,1857013227,2),(1588,1867903227,1),(1588,1888462827,2),(1588,1899352827,1),(1588,1919912427,2),(1588,1930802427,1),(1588,1951362027,2),(1588,1962856827,1),(1588,1983416427,2),(1588,1994306427,1),(1588,2014866027,2),(1588,2025756027,1),(1588,2046315627,2),(1588,2057205627,1),(1588,2077765227,2),(1588,2088655227,1),(1588,2109214827,2),(1588,2120104827,1),(1588,2140664427,2),(1589,-2147483648,2),(1589,-1694368800,1),(1589,-1681671600,2),(1589,-1632067200,1),(1589,-1615136400,2),(1589,-1029686400,1),(1589,-1018198800,2),(1589,-880214400,3),(1589,-769395600,4),(1589,-765392400,2),(1589,-746035200,1),(1589,-732733200,2),(1589,-715795200,1),(1589,-702493200,2),(1589,-684345600,1),(1589,-671043600,2),(1589,-652896000,1),(1589,-639594000,2),(1589,-620755200,1),(1589,-607626000,2),(1589,-589392000,1),(1589,-576090000,2),(1589,-557942400,1),(1589,-544640400,2),(1589,-526492800,1),(1589,-513190800,2),(1589,-495043200,1),(1589,-481741200,2),(1589,-463593600,1),(1589,-450291600,2),(1589,-431539200,1),(1589,-418237200,2),(1589,-400089600,1),(1589,-386787600,2),(1589,-368640000,1),(1589,-355338000,2),(1589,-337190400,1),(1589,-321469200,2),(1589,-305740800,1),(1589,-292438800,2),(1589,-210787200,1),(1589,-198090000,2),(1589,-116438400,5),(1589,-100108800,6),(1589,-84384000,5),(1589,-68659200,6),(1589,-52934400,5),(1589,-37209600,6),(1589,-21484800,5),(1589,-5760000,6),(1589,9964800,5),(1589,25689600,6),(1589,41414400,5),(1589,57744000,6),(1589,73468800,5),(1589,89193601,6),(1589,104918402,5),(1589,120643202,6),(1589,136368003,5),(1589,152092803,6),(1589,167817604,5),(1589,183542404,6),(1589,199267205,5),(1589,215596805,6),(1589,230716806,5),(1589,247046406,6),(1589,262771207,5),(1589,278496007,6),(1589,294220808,5),(1589,309945608,6),(1589,325670409,5),(1589,341395209,6),(1589,357120009,5),(1589,372844810,6),(1589,388569610,5),(1589,404899211,6),(1589,420019211,5),(1589,436348812,6),(1589,452073612,5),(1589,467798412,6),(1589,483523212,5),(1589,499248013,6),(1589,514972813,5),(1589,530697613,6),(1589,544608013,5),(1589,562147213,6),(1589,576057614,5),(1589,594201614,6),(1589,607507214,5),(1589,625651214,6),(1589,638956815,5),(1589,657100815,6),(1589,671011216,5),(1589,688550416,6),(1589,702460816,5),(1589,720000017,6),(1589,733910417,5),(1589,752054418,6),(1589,765360018,5),(1589,783504019,6),(1589,796809619,5),(1589,814953619,6),(1589,828864020,5),(1589,846403220,6),(1589,860313620,5),(1589,877852821,6),(1589,891763221,5),(1589,909302421,6),(1589,923212822,5),(1589,941356822,6),(1589,954662422,5),(1589,972806422,6),(1589,986112022,5),(1589,1004256022,6),(1589,1018166422,5),(1589,1035705622,6),(1589,1049616022,5),(1589,1067155222,6),(1589,1081065622,5),(1589,1099209622,6),(1589,1112515222,5),(1589,1130659222,6),(1589,1136095223,2),(1589,1143964823,1),(1589,1162105223,2),(1589,1173600023,1),(1589,1194159623,2),(1589,1205049623,1),(1589,1225609223,2),(1589,1236499224,1),(1589,1257058824,2),(1589,1268553624,1),(1589,1289113224,2),(1589,1300003224,1),(1589,1320562824,2),(1589,1331452824,1),(1589,1352012425,2),(1589,1362902425,1),(1589,1383462025,2),(1589,1394352025,1),(1589,1414911625,2),(1589,1425801625,1),(1589,1446361226,2),(1589,1457856026,1),(1589,1478415626,2),(1589,1489305627,1),(1589,1509865227,2),(1589,1520755227,1),(1589,1541314827,2),(1589,1552204827,1),(1589,1572764427,2),(1589,1583654427,1),(1589,1604214027,2),(1589,1615708827,1),(1589,1636268427,2),(1589,1647158427,1),(1589,1667718027,2),(1589,1678608027,1),(1589,1699167627,2),(1589,1710057627,1),(1589,1730617227,2),(1589,1741507227,1),(1589,1762066827,2),(1589,1772956827,1),(1589,1793516427,2),(1589,1805011227,1),(1589,1825570827,2),(1589,1836460827,1),(1589,1857020427,2),(1589,1867910427,1),(1589,1888470027,2),(1589,1899360027,1),(1589,1919919627,2),(1589,1930809627,1),(1589,1951369227,2),(1589,1962864027,1),(1589,1983423627,2),(1589,1994313627,1),(1589,2014873227,2),(1589,2025763227,1),(1589,2046322827,2),(1589,2057212827,1),(1589,2077772427,2),(1589,2088662427,1),(1589,2109222027,2),(1589,2120112027,1),(1589,2140671627,2),(1590,-2147483648,2),(1590,-1632070800,1),(1590,-1615140000,2),(1590,-1601753400,1),(1590,-1583697600,2),(1590,-1567357200,1),(1590,-1554667200,2),(1590,-1534698000,1),(1590,-1524074400,2),(1590,-1503248400,1),(1590,-1492365600,2),(1590,-1471798800,1),(1590,-1460916000,2),(1590,-1440954000,1),(1590,-1428861600,2),(1590,-1409504400,1),(1590,-1397412000,2),(1590,-1378054800,1),(1590,-1365962400,2),(1590,-1346605200,1),(1590,-1333908000,2),(1590,-1315155600,1),(1590,-1301853600,2),(1590,-1283706000,1),(1590,-1270404000,2),(1590,-1252256400,1),(1590,-1238954400,2),(1590,-1220806800,1),(1590,-1207504800,2),(1590,-1188752400,1),(1590,-1176055200,2),(1590,-1157302800,1),(1590,-1144000800,2),(1590,-1125853200,1),(1590,-1112551200,2),(1590,-1094403600,1),(1590,-1081101600,2),(1590,-1062954000,1),(1590,-1049652000,2),(1590,-1031504400,1),(1590,-1018202400,2),(1590,-1000054800,1),(1590,-986752800,2),(1590,-968000400,1),(1590,-955303200,2),(1590,-936550800,1),(1590,-880218000,3),(1590,-769395600,4),(1590,-765396000,2),(1590,-747248400,1),(1590,-733946400,2),(1590,-715806000,1),(1590,-702504000,2),(1590,-684356400,1),(1590,-671054400,2),(1590,-652906800,1),(1590,-634161600,2),(1590,-620845200,1),(1590,-602704800,2),(1590,-589395600,1),(1590,-576093600,2),(1590,-557946000,1),(1590,-544644000,2),(1590,-526496400,1),(1590,-513194400,2),(1590,-495046800,1),(1590,-481744800,2),(1590,-463597200,1),(1590,-450295200,2),(1590,-431542800,1),(1590,-418240800,2),(1590,-400093200,1),(1590,-384372000,2),(1590,-368643600,1),(1590,-352922400,2),(1590,-337194000,1),(1590,-321472800,2),(1590,-305744400,1),(1590,-289418400,2),(1590,-273690000,1),(1590,-257968800,2),(1590,-242240400,1),(1590,-226519200,2),(1590,-210790800,1),(1590,-195069600,2),(1590,-179341200,1),(1590,-163620000,2),(1590,-147891600,1),(1590,-131565600,2),(1590,-116442000,1),(1590,-100116000,2),(1590,-84387600,1),(1590,-68666400,2),(1590,-52938000,1),(1590,-37216800,2),(1590,-21488400,1),(1590,-5767200,2),(1590,9961200,1),(1590,25682400,2),(1590,41410800,1),(1590,57736800,2),(1590,73465200,1),(1590,89186401,2),(1590,104914802,1),(1590,120636002,2),(1590,136364403,1),(1590,152085603,2),(1590,167814004,1),(1590,183535204,2),(1590,199263605,1),(1590,215589605,2),(1590,230713206,1),(1590,247039206,2),(1590,262767607,1),(1590,278488807,2),(1590,294217208,1),(1590,309938408,2),(1590,325666809,1),(1590,341388009,2),(1590,357116409,1),(1590,372837610,2),(1590,388566010,1),(1590,404892011,2),(1590,420015611,1),(1590,436341612,2),(1590,452070012,1),(1590,467791212,2),(1590,483519612,1),(1590,499240813,2),(1590,514969213,1),(1590,530690413,2),(1590,544604413,1),(1590,562140013,2),(1590,576054014,1),(1590,594194414,2),(1590,607503614,1),(1590,625644014,2),(1590,638953215,1),(1590,657093615,2),(1590,671007616,1),(1590,688543216,2),(1590,702457216,1),(1590,719992817,2),(1590,733906817,1),(1590,752047218,2),(1590,765356418,1),(1590,783496819,2),(1590,796806019,1),(1590,814946419,2),(1590,828860420,1),(1590,846396020,2),(1590,860310020,1),(1590,877845621,2),(1590,891759621,1),(1590,909295221,2),(1590,923209222,1),(1590,941349622,2),(1590,954658822,1),(1590,972799222,2),(1590,986108422,1),(1590,1004248822,2),(1590,1018162822,1),(1590,1035698422,2),(1590,1049612422,1),(1590,1067148022,2),(1590,1081062022,1),(1590,1099202422,2),(1590,1112511622,1),(1590,1130652022,2),(1590,1143961223,1),(1590,1162101623,2),(1590,1173596423,1),(1590,1194156023,2),(1590,1205046023,1),(1590,1225605623,2),(1590,1236495624,1),(1590,1257055224,2),(1590,1268550024,1),(1590,1289109624,2),(1590,1299999624,1),(1590,1320559224,2),(1590,1331449224,1),(1590,1352008825,2),(1590,1362898825,1),(1590,1383458425,2),(1590,1394348425,1),(1590,1414908025,2),(1590,1425798025,1),(1590,1446357626,2),(1590,1457852426,1),(1590,1478412026,2),(1590,1489302027,1),(1590,1509861627,2),(1590,1520751627,1),(1590,1541311227,2),(1590,1552201227,1),(1590,1572760827,2),(1590,1583650827,1),(1590,1604210427,2),(1590,1615705227,1),(1590,1636264827,2),(1590,1647154827,1),(1590,1667714427,2),(1590,1678604427,1),(1590,1699164027,2),(1590,1710054027,1),(1590,1730613627,2),(1590,1741503627,1),(1590,1762063227,2),(1590,1772953227,1),(1590,1793512827,2),(1590,1805007627,1),(1590,1825567227,2),(1590,1836457227,1),(1590,1857016827,2),(1590,1867906827,1),(1590,1888466427,2),(1590,1899356427,1),(1590,1919916027,2),(1590,1930806027,1),(1590,1951365627,2),(1590,1962860427,1),(1590,1983420027,2),(1590,1994310027,1),(1590,2014869627,2),(1590,2025759627,1),(1590,2046319227,2),(1590,2057209227,1),(1590,2077768827,2),(1590,2088658827,1),(1590,2109218427,2),(1590,2120108427,1),(1590,2140668027,2),(1591,-2147483648,0),(1591,-1998663968,2),(1591,-1632063600,1),(1591,-1615132800,2),(1591,-1600614000,1),(1591,-1596816000,2),(1591,-1567954800,1),(1591,-1551628800,2),(1591,-1536505200,1),(1591,-1523203200,2),(1591,-1504450800,1),(1591,-1491753600,2),(1591,-1473001200,1),(1591,-1459699200,2),(1591,-880210800,3),(1591,-769395600,4),(1591,-765388800,2),(1591,-715791600,1),(1591,-702489600,2),(1591,-84380400,1),(1591,-68659200,2),(1591,-21481200,1),(1591,-5760000,2),(1591,73472400,1),(1591,89193601,2),(1591,104922002,1),(1591,120643202,2),(1591,136371603,1),(1591,152092803,2),(1591,167821204,1),(1591,183542404,2),(1591,199270805,1),(1591,215596805,2),(1591,230720406,1),(1591,247046406,2),(1591,262774807,1),(1591,278496007,2),(1591,294224408,1),(1591,309945608,2),(1591,325674009,1),(1591,341395209,2),(1591,357123609,1),(1591,372844810,2),(1591,388573210,1),(1591,404899211,2),(1591,420022811,1),(1591,436348812,2),(1591,452077212,1),(1591,467798412,2),(1591,483526812,1),(1591,499248013,2),(1591,514976413,1),(1591,530697613,2),(1591,544611613,1),(1591,562147213,2),(1591,576061214,1),(1591,594201614,2),(1591,607510814,1),(1591,625651214,2),(1591,638960415,1),(1591,657100815,2),(1591,671014816,1),(1591,688550416,2),(1591,702464416,1),(1591,720000017,2),(1591,733914017,1),(1591,752054418,2),(1591,765363618,1),(1591,783504019,2),(1591,796813219,1),(1591,814953619,2),(1591,828867620,1),(1591,846403220,2),(1591,860317220,1),(1591,877852821,2),(1591,891766821,1),(1591,909302421,2),(1591,923216422,1),(1591,941356822,2),(1591,954666022,1),(1591,972806422,2),(1591,986115622,1),(1591,1004256022,2),(1591,1018170022,1),(1591,1035705622,2),(1591,1049619622,1),(1591,1067155222,2),(1591,1081069222,1),(1591,1099209622,2),(1591,1112518822,1),(1591,1130659222,2),(1591,1143968423,1),(1591,1162108823,2),(1591,1173603623,1),(1591,1194163223,2),(1591,1205053223,1),(1591,1225612823,2),(1591,1236502824,1),(1591,1257062424,2),(1591,1268557224,1),(1591,1289116824,2),(1591,1300006824,1),(1591,1320566424,2),(1591,1331456424,1),(1591,1352016025,2),(1591,1362906025,1),(1591,1383465625,2),(1591,1394355625,1),(1591,1414915225,2),(1591,1425805225,1),(1591,1446364826,2),(1591,1457859626,1),(1591,1478419226,2),(1591,1489309227,1),(1591,1509868827,2),(1591,1520758827,1),(1591,1541318427,2),(1591,1552208427,1),(1591,1572768027,2),(1591,1583658027,1),(1591,1604217627,2),(1591,1615712427,1),(1591,1636272027,2),(1591,1647162027,1),(1591,1667721627,2),(1591,1678611627,1),(1591,1699171227,2),(1591,1710061227,1),(1591,1730620827,2),(1591,1741510827,1),(1591,1762070427,2),(1591,1772960427,1),(1591,1793520027,2),(1591,1805014827,1),(1591,1825574427,2),(1591,1836464427,1),(1591,1857024027,2),(1591,1867914027,1),(1591,1888473627,2),(1591,1899363627,1),(1591,1919923227,2),(1591,1930813227,1),(1591,1951372827,2),(1591,1962867627,1),(1591,1983427227,2),(1591,1994317227,1),(1591,2014876827,2),(1591,2025766827,1),(1591,2046326427,2),(1591,2057216427,1),(1591,2077776027,2),(1591,2088666027,1),(1591,2109225627,2),(1591,2120115627,1),(1591,2140675227,2),(1592,-2147483648,2),(1592,-1664130548,1),(1592,-1650137348,2),(1592,-1632076148,1),(1592,-1615145348,2),(1592,-1598650148,1),(1592,-1590100148,2),(1592,-1567286948,1),(1592,-1551565748,2),(1592,-1535837348,1),(1592,-1520116148,2),(1592,-1503782948,1),(1592,-1488666548,2),(1592,-1472333348,1),(1592,-1457216948,2),(1592,-1440883748,1),(1592,-1425767348,2),(1592,-1409434148,1),(1592,-1394317748,2),(1592,-1377984548,1),(1592,-1362263348,2),(1592,-1346534948,1),(1592,-1330813748,2),(1592,-1314480548,1),(1592,-1299364148,2),(1592,-1283030948,1),(1592,-1267914548,2),(1592,-1251581348,1),(1592,-1236464948,2),(1592,-1220131748,1),(1592,-1205015348,2),(1592,-1188682148,1),(1592,-1172960948,2),(1592,-1156627748,1),(1592,-1141511348,2),(1592,-1125178148,1),(1592,-1110061748,2),(1592,-1096921748,4),(1592,-1093728600,3),(1592,-1078612200,4),(1592,-1061670600,3),(1592,-1048973400,4),(1592,-1030221000,3),(1592,-1017523800,4),(1592,-998771400,3),(1592,-986074200,4),(1592,-966717000,3),(1592,-954624600,4),(1592,-935267400,3),(1592,-922570200,4),(1592,-903817800,3),(1592,-891120600,4),(1592,-872368200,6),(1592,-769395600,5),(1592,-765401400,4),(1592,-746044200,3),(1592,-733347000,4),(1592,-714594600,3),(1592,-701897400,4),(1592,-683145000,3),(1592,-670447800,4),(1592,-651695400,3),(1592,-638998200,4),(1592,-619641000,3),(1592,-606943800,4),(1592,-589401000,3),(1592,-576099000,4),(1592,-557951400,3),(1592,-544649400,4),(1592,-526501800,3),(1592,-513199800,4),(1592,-495052200,3),(1592,-481750200,4),(1592,-463602600,3),(1592,-450300600,4),(1592,-431548200,3),(1592,-418246200,4),(1592,-400098600,3),(1592,-386796600,4),(1592,-368649000,3),(1592,-355347000,4),(1592,-337199400,3),(1592,-323897400,4),(1592,-305749800,3),(1592,-289423800,4),(1592,-273695400,3),(1592,-257974200,4),(1592,-242245800,3),(1592,-226524600,4),(1592,-210796200,3),(1592,-195075000,4),(1592,-179346600,3),(1592,-163625400,4),(1592,-147897000,3),(1592,-131571000,4),(1592,-116447400,3),(1592,-100121400,4),(1592,-84393000,3),(1592,-68671800,4),(1592,-52943400,3),(1592,-37222200,4),(1592,-21493800,3),(1592,-5772600,4),(1592,9955800,3),(1592,25677000,4),(1592,41405400,3),(1592,57731400,4),(1592,73459800,3),(1592,89181001,4),(1592,104909402,3),(1592,120630602,4),(1592,136359003,3),(1592,152080203,4),(1592,167808604,3),(1592,183529804,4),(1592,199258205,3),(1592,215584205,4),(1592,230707806,3),(1592,247033806,4),(1592,262762207,3),(1592,278483407,4),(1592,294211808,3),(1592,309933008,4),(1592,325661409,3),(1592,341382609,4),(1592,357111009,3),(1592,372832210,4),(1592,388560610,3),(1592,404886611,4),(1592,420010211,3),(1592,436336212,4),(1592,452064612,3),(1592,467785812,4),(1592,483514212,3),(1592,499235413,4),(1592,514963813,3),(1592,530685013,4),(1592,544591873,3),(1592,562127473,4),(1592,576041474,7),(1592,594178274,4),(1592,607491074,3),(1592,625631474,4),(1592,638940675,3),(1592,657081075,4),(1592,670995076,3),(1592,688530676,4),(1592,702444676,3),(1592,719980277,4),(1592,733894277,3),(1592,752034678,4),(1592,765343878,3),(1592,783484279,4),(1592,796793479,3),(1592,814933879,4),(1592,828847880,3),(1592,846383480,4),(1592,860297480,3),(1592,877833081,4),(1592,891747081,3),(1592,909282681,4),(1592,923196682,3),(1592,941337082,4),(1592,954646282,3),(1592,972786682,4),(1592,986095882,3),(1592,1004236282,4),(1592,1018150282,3),(1592,1035685882,4),(1592,1049599882,3),(1592,1067135482,4),(1592,1081049482,3),(1592,1099189882,4),(1592,1112499082,3),(1592,1130639482,4),(1592,1143948683,3),(1592,1162089083,4),(1592,1173583883,3),(1592,1194143483,4),(1592,1205033483,3),(1592,1225593083,4),(1592,1236483084,3),(1592,1257042684,4),(1592,1268537484,3),(1592,1289097084,4),(1592,1299987084,3),(1592,1320553824,4),(1592,1331443824,3),(1592,1352003425,4),(1592,1362893425,3),(1592,1383453025,4),(1592,1394343025,3),(1592,1414902625,4),(1592,1425792625,3),(1592,1446352226,4),(1592,1457847026,3),(1592,1478406626,4),(1592,1489296627,3),(1592,1509856227,4),(1592,1520746227,3),(1592,1541305827,4),(1592,1552195827,3),(1592,1572755427,4),(1592,1583645427,3),(1592,1604205027,4),(1592,1615699827,3),(1592,1636259427,4),(1592,1647149427,3),(1592,1667709027,4),(1592,1678599027,3),(1592,1699158627,4),(1592,1710048627,3),(1592,1730608227,4),(1592,1741498227,3),(1592,1762057827,4),(1592,1772947827,3),(1592,1793507427,4),(1592,1805002227,3),(1592,1825561827,4),(1592,1836451827,3),(1592,1857011427,4),(1592,1867901427,3),(1592,1888461027,4),(1592,1899351027,3),(1592,1919910627,4),(1592,1930800627,3),(1592,1951360227,4),(1592,1962855027,3),(1592,1983414627,4),(1592,1994304627,3),(1592,2014864227,4),(1592,2025754227,3),(1592,2046313827,4),(1592,2057203827,3),(1592,2077763427,4),(1592,2088653427,3),(1592,2109213027,4),(1592,2120103027,3),(1592,2140662627,4),(1593,-2147483648,2),(1593,-1632060000,1),(1593,-1615129200,2),(1593,-880207200,3),(1593,-769395600,4),(1593,-765385200,2),(1593,-747237600,1),(1593,-732726000,2),(1593,-715788000,1),(1593,-702486000,2),(1593,-684338400,1),(1593,-671036400,2),(1593,-652888800,1),(1593,-639586800,2),(1593,-620834400,1),(1593,-608137200,2),(1593,-589384800,1),(1593,-576082800,2),(1593,-557935200,1),(1593,-544633200,2),(1593,-526485600,1),(1593,-513183600,2),(1593,-495036000,1),(1593,-481734000,2),(1593,-463586400,1),(1593,-450284400,2),(1593,-431532000,1),(1593,-418230000,2),(1593,-400082400,1),(1593,-386780400,2),(1593,-368632800,1),(1593,-355330800,2),(1593,-337183200,1),(1593,-323881200,2),(1593,-305733600,1),(1593,-292431600,2),(1593,-273679200,1),(1593,-260982000,2),(1593,-242229600,1),(1593,-226508400,2),(1593,-210780000,1),(1593,-195058800,2),(1593,-179330400,1),(1593,-163609200,2),(1593,-147880800,1),(1593,-131554800,2),(1593,-116431200,1),(1593,-100105200,2),(1593,-84376800,1),(1593,-68655600,2),(1593,-52927200,1),(1593,-37206000,2),(1593,-21477600,1),(1593,-5756400,2),(1593,9972000,1),(1593,25693200,2),(1593,41421600,1),(1593,57747600,2),(1593,73476000,1),(1593,89197201,2),(1593,104925602,1),(1593,120646802,2),(1593,136375203,1),(1593,152096403,2),(1593,167824804,1),(1593,183546004,2),(1593,199274405,1),(1593,215600405,2),(1593,230724006,1),(1593,247050006,2),(1593,262778407,1),(1593,278499607,2),(1593,294228008,1),(1593,309949208,2),(1593,325677609,1),(1593,341398809,2),(1593,357127209,1),(1593,372848410,2),(1593,388576810,1),(1593,404902811,2),(1593,420026411,1),(1593,436352412,2),(1593,452080812,1),(1593,467802012,2),(1593,483530412,1),(1593,499251613,2),(1593,514980013,1),(1593,530701213,2),(1593,544615213,1),(1593,562150813,2),(1593,576064814,1),(1593,594205214,2),(1593,607514414,1),(1593,625654814,2),(1593,638964015,1),(1593,657104415,2),(1593,671018416,1),(1593,688554016,2),(1593,702468016,1),(1593,720003617,2),(1593,733917617,1),(1593,752058018,2),(1593,765367218,1),(1593,783507619,2),(1593,796816819,1),(1593,814957219,2),(1593,828871220,1),(1593,846406820,2),(1593,860320820,1),(1593,877856421,2),(1593,891770421,1),(1593,909306021,2),(1593,923220022,1),(1593,941360422,2),(1593,954669622,1),(1593,972810022,2),(1593,986119222,1),(1593,1004259622,2),(1593,1018173622,1),(1593,1035709222,2),(1593,1049623222,1),(1593,1067158822,2),(1593,1081072822,1),(1593,1099213222,2),(1593,1112522422,1),(1593,1130662822,2),(1593,1143972023,1),(1593,1162112423,2),(1593,1173607223,1),(1593,1194166823,2),(1593,1205056823,1),(1593,1225616423,2),(1593,1236506424,1),(1593,1257066024,2),(1593,1268560824,1),(1593,1289120424,2),(1593,1300010424,1),(1593,1320570024,2),(1593,1331460024,1),(1593,1352019625,2),(1593,1362909625,1),(1593,1383469225,2),(1593,1394359225,1),(1593,1414918825,2),(1593,1425808825,1),(1593,1446368426,2),(1593,1457863226,1),(1593,1478422826,2),(1593,1489312827,1),(1593,1509872427,2),(1593,1520762427,1),(1593,1541322027,2),(1593,1552212027,1),(1593,1572771627,2),(1593,1583661627,1),(1593,1604221227,2),(1593,1615716027,1),(1593,1636275627,2),(1593,1647165627,1),(1593,1667725227,2),(1593,1678615227,1),(1593,1699174827,2),(1593,1710064827,1),(1593,1730624427,2),(1593,1741514427,1),(1593,1762074027,2),(1593,1772964027,1),(1593,1793523627,2),(1593,1805018427,1),(1593,1825578027,2),(1593,1836468027,1),(1593,1857027627,2),(1593,1867917627,1),(1593,1888477227,2),(1593,1899367227,1),(1593,1919926827,2),(1593,1930816827,1),(1593,1951376427,2),(1593,1962871227,1),(1593,1983430827,2),(1593,1994320827,1),(1593,2014880427,2),(1593,2025770427,1),(1593,2046330027,2),(1593,2057220027,1),(1593,2077779627,2),(1593,2088669627,1),(1593,2109229227,2),(1593,2120119227,1),(1593,2140678827,2),(1594,-2147483648,0),(1594,-2030202084,2),(1594,-1632063600,1),(1594,-1615132800,2),(1594,-1251651600,1),(1594,-1238349600,2),(1594,-1220202000,1),(1594,-1206900000,2),(1594,-1188752400,1),(1594,-1175450400,2),(1594,-1156698000,1),(1594,-1144000800,2),(1594,-1125248400,1),(1594,-1111946400,2),(1594,-1032714000,1),(1594,-1016992800,2),(1594,-1001264400,1),(1594,-986148000,2),(1594,-969814800,1),(1594,-954093600,2),(1594,-937760400,1),(1594,-922039200,2),(1594,-906310800,1),(1594,-890589600,2),(1594,-880210800,3),(1594,-769395600,4),(1594,-765388800,2),(1594,-748450800,1),(1594,-732729600,2),(1594,-715791600,1),(1594,-702489600,2),(1594,-684342000,1),(1594,-671040000,2),(1594,-652892400,1),(1594,-639590400,2),(1594,-620838000,1),(1594,-608140800,2),(1594,-589388400,1),(1594,-576086400,2),(1594,-557938800,1),(1594,-544636800,2),(1594,-526489200,1),(1594,-513187200,2),(1594,-495039600,1),(1594,-481737600,2),(1594,-463590000,1),(1594,-450288000,2),(1594,-431535600,1),(1594,-418233600,2),(1594,-400086000,1),(1594,-386784000,2),(1594,-337186800,1),(1594,-321465600,2),(1594,-305737200,5),(1595,-2147483648,2),(1595,-1632056400,1),(1595,-1615125600,2),(1595,-1596978000,1),(1595,-1583164800,2),(1595,-880203600,3),(1595,-769395600,4),(1595,-765381600,2),(1595,-147884400,5),(1595,-131554800,2),(1595,-81961200,6),(1595,325677609,7),(1595,341398809,6),(1595,357127209,7),(1595,372848410,6),(1595,388576810,7),(1595,404902811,6),(1595,420026411,7),(1595,436352412,6),(1595,452080812,7),(1595,467802012,6),(1595,483530412,7),(1595,499251613,6),(1595,514980013,7),(1595,530701213,6),(1595,544615213,7),(1595,562150813,6),(1595,576064814,7),(1595,594205214,6),(1595,607514414,7),(1595,625654814,6),(1595,638964015,7),(1595,657104415,6),(1595,671018416,7),(1595,688554016,6),(1595,702468016,7),(1595,720003617,6),(1595,733917617,7),(1595,752058018,6),(1595,765367218,7),(1595,783507619,6),(1595,796816819,7),(1595,814957219,6),(1595,828871220,7),(1595,846406820,6),(1595,860320820,7),(1595,877856421,6),(1595,891770421,7),(1595,909306021,6),(1595,923220022,7),(1595,941360422,6),(1595,954669622,7),(1595,972810022,6),(1595,986119222,7),(1595,1004259622,6),(1595,1018173622,7),(1595,1035709222,6),(1595,1049623222,7),(1595,1067158822,6),(1595,1081072822,7),(1595,1099213222,6),(1595,1112522422,7),(1595,1130662822,6),(1595,1143972023,7),(1595,1162112423,6),(1595,1173607223,7),(1595,1194166823,6),(1595,1205056823,7),(1595,1225616423,6),(1595,1236506424,7),(1595,1257066024,6),(1595,1268560824,7),(1595,1289120424,6),(1595,1300010424,7),(1595,1320570024,6),(1595,1331460024,7),(1595,1352019625,6),(1595,1362909625,7),(1595,1383469225,6),(1595,1394359225,7),(1595,1414918825,6),(1595,1425808825,7),(1595,1446368426,6),(1595,1457863226,7),(1595,1478422826,6),(1595,1489312827,7),(1595,1509872427,6),(1595,1520762427,7),(1595,1541322027,6),(1595,1552212027,7),(1595,1572771627,6),(1595,1583661627,7),(1595,1604221227,6),(1595,1615716027,7),(1595,1636275627,6),(1595,1647165627,7),(1595,1667725227,6),(1595,1678615227,7),(1595,1699174827,6),(1595,1710064827,7),(1595,1730624427,6),(1595,1741514427,7),(1595,1762074027,6),(1595,1772964027,7),(1595,1793523627,6),(1595,1805018427,7),(1595,1825578027,6),(1595,1836468027,7),(1595,1857027627,6),(1595,1867917627,7),(1595,1888477227,6),(1595,1899367227,7),(1595,1919926827,6),(1595,1930816827,7),(1595,1951376427,6),(1595,1962871227,7),(1595,1983430827,6),(1595,1994320827,7),(1595,2014880427,6),(1595,2025770427,7),(1595,2046330027,6),(1595,2057220027,7),(1595,2077779627,6),(1595,2088669627,7),(1595,2109229227,6),(1595,2120119227,7),(1595,2140678827,6),(1596,-2147483648,1),(1596,-1892661434,2),(1596,-1688410800,1),(1596,-1619205434,3),(1596,-1593806400,1),(1596,-1335986234,4),(1596,-1317585600,2),(1596,-1304362800,4),(1596,-1286049600,2),(1596,-1272826800,4),(1596,-1254513600,2),(1596,-1241290800,4),(1596,-1222977600,2),(1596,-1209754800,4),(1596,-1191355200,2),(1596,-1178132400,3),(1596,-870552000,2),(1596,-865278000,3),(1596,-740520000,5),(1596,-736376400,3),(1596,-718056000,2),(1596,-713649600,3),(1596,-36619200,6),(1596,-23922000,7),(1596,-3355200,6),(1596,7527600,7),(1596,24465600,6),(1596,37767600,7),(1596,55915200,6),(1596,69217200,7),(1596,87969601,6),(1596,100666802,7),(1596,118209602,6),(1596,132116403,7),(1596,150868803,6),(1596,163566004,7),(1596,182318404,6),(1596,195620405,7),(1596,213768005,6),(1596,227070006,7),(1596,245217606,6),(1596,258519607,7),(1596,277272007,6),(1596,289969208,7),(1596,308721608,6),(1596,321418809,7),(1596,340171209,6),(1596,353473209,7),(1596,371620810,6),(1596,384922810,7),(1596,403070411,6),(1596,416372411,7),(1596,434520012,6),(1596,447822012,7),(1596,466574412,6),(1596,479271612,7),(1596,498024013,6),(1596,510721213,7),(1596,529473613,6),(1596,545194813,7),(1596,560923213,6),(1596,574225214,7),(1596,592372814,6),(1596,605674814,7),(1596,624427214,6),(1596,637124415,7),(1596,653457615,6),(1596,668574016,7),(1596,687326416,6),(1596,700628416,7),(1596,718776017,6),(1596,732078017,7),(1596,750225618,6),(1596,763527618,7),(1596,781675219,6),(1596,794977219,7),(1596,813729619,6),(1596,826426820,7),(1596,845179220,6),(1596,859690820,7),(1596,876628821,6),(1596,889930821,7),(1596,906868821,6),(1596,923194822,7),(1596,939528022,6),(1596,952830022,7),(1596,971582422,6),(1596,984279622,7),(1596,1003032022,6),(1596,1015729222,7),(1596,1034481622,6),(1596,1047178822,7),(1596,1065931222,6),(1596,1079233222,7),(1596,1097380822,6),(1596,1110682822,7),(1596,1128830422,6),(1596,1142132423,7),(1596,1160884823,6),(1596,1173582023,7),(1596,1192334423,6),(1596,1206846023,7),(1596,1223784023,6),(1596,1237086024,7),(1596,1255233624,6),(1596,1270350024,7),(1596,1286683224,6),(1596,1304823624,7),(1596,1313899224,6),(1596,1335668424,7),(1596,1346558425,6),(1596,1367118025,7),(1596,1378612825,6),(1596,1398567625,7),(1596,1410062425,6),(1596,1463281226,7),(1596,1471147226,6),(1596,1494730827,7),(1596,1502596827,6),(1596,1526180427,7),(1596,1534046427,6),(1596,1554606027,7),(1596,1567915227,6),(1596,1586055627,7),(1596,1599364827,6),(1596,1617505227,7),(1596,1630814427,6),(1596,1648954827,7),(1596,1662264027,6),(1596,1680404427,7),(1596,1693713627,6),(1596,1712458827,7),(1596,1725768027,6),(1596,1743908427,7),(1596,1757217627,6),(1596,1775358027,7),(1596,1788667227,6),(1596,1806807627,7),(1596,1820116827,6),(1596,1838257227,7),(1596,1851566427,6),(1596,1870311627,7),(1596,1883016027,6),(1596,1901761227,7),(1596,1915070427,6),(1596,1933210827,7),(1596,1946520027,6),(1596,1964660427,7),(1596,1977969627,6),(1596,1996110027,7),(1596,2009419227,6),(1596,2027559627,7),(1596,2040868827,6),(1596,2059614027,7),(1596,2072318427,6),(1596,2091063627,7),(1596,2104372827,6),(1596,2122513227,7),(1596,2135822427,6),(1597,-2147483648,1),(1597,-1178124152,4),(1597,-36619200,2),(1597,-23922000,3),(1597,-3355200,2),(1597,7527600,3),(1597,24465600,2),(1597,37767600,3),(1597,55915200,2),(1597,69217200,3),(1597,87969601,2),(1597,100666802,3),(1597,118209602,2),(1597,132116403,3),(1597,150868803,2),(1597,163566004,3),(1597,182318404,2),(1597,195620405,3),(1597,213768005,2),(1597,227070006,3),(1597,245217606,2),(1597,258519607,3),(1597,277272007,2),(1597,289969208,3),(1597,308721608,2),(1597,321418809,3),(1597,340171209,2),(1597,353473209,3),(1597,371620810,2),(1597,384922810,5),(1597,403070411,6),(1597,416372411,5),(1597,434520012,6),(1597,447822012,5),(1597,466574412,6),(1597,479271612,5),(1597,498024013,6),(1597,510721213,5),(1597,529473613,6),(1597,545194813,5),(1597,560923213,6),(1597,574225214,5),(1597,592372814,6),(1597,605674814,5),(1597,624427214,6),(1597,637124415,5),(1597,653457615,6),(1597,668574016,5),(1597,687326416,6),(1597,700628416,5),(1597,718776017,6),(1597,732078017,5),(1597,750225618,6),(1597,763527618,5),(1597,781675219,6),(1597,794977219,5),(1597,813729619,6),(1597,826426820,5),(1597,845179220,6),(1597,859690820,5),(1597,876628821,6),(1597,889930821,5),(1597,906868821,6),(1597,923194822,5),(1597,939528022,6),(1597,952830022,5),(1597,971582422,6),(1597,984279622,5),(1597,1003032022,6),(1597,1015729222,5),(1597,1034481622,6),(1597,1047178822,5),(1597,1065931222,6),(1597,1079233222,5),(1597,1097380822,6),(1597,1110682822,5),(1597,1128830422,6),(1597,1142132423,5),(1597,1160884823,6),(1597,1173582023,5),(1597,1192334423,6),(1597,1206846023,5),(1597,1223784023,6),(1597,1237086024,5),(1597,1255233624,6),(1597,1270350024,5),(1597,1286683224,6),(1597,1304823624,5),(1597,1313899224,6),(1597,1335668424,5),(1597,1346558425,6),(1597,1367118025,5),(1597,1378612825,6),(1597,1398567625,5),(1597,1410062425,6),(1597,1463281226,5),(1597,1471147226,6),(1597,1494730827,5),(1597,1502596827,6),(1597,1526180427,5),(1597,1534046427,6),(1597,1554606027,5),(1597,1567915227,6),(1597,1586055627,5),(1597,1599364827,6),(1597,1617505227,5),(1597,1630814427,6),(1597,1648954827,5),(1597,1662264027,6),(1597,1680404427,5),(1597,1693713627,6),(1597,1712458827,5),(1597,1725768027,6),(1597,1743908427,5),(1597,1757217627,6),(1597,1775358027,5),(1597,1788667227,6),(1597,1806807627,5),(1597,1820116827,6),(1597,1838257227,5),(1597,1851566427,6),(1597,1870311627,5),(1597,1883016027,6),(1597,1901761227,5),(1597,1915070427,6),(1597,1933210827,5),(1597,1946520027,6),(1597,1964660427,5),(1597,1977969627,6),(1597,1996110027,5),(1597,2009419227,6),(1597,2027559627,5),(1597,2040868827,6),(1597,2059614027,5),(1597,2072318427,6),(1597,2091063627,5),(1597,2104372827,6),(1597,2122513227,5),(1597,2135822427,6),(1598,-2147483648,1),(1598,-1402813824,3),(1598,-1311534000,2),(1598,-1300996800,3),(1598,-933534000,2),(1598,-925675200,3),(1598,-902084400,2),(1598,-893620800,3),(1598,-870030000,2),(1598,-862171200,3),(1598,-775681200,2),(1598,-767822400,3),(1598,-744231600,2),(1598,-736372800,3),(1598,-144702000,2),(1598,-134251200,3),(1598,-113425200,2),(1598,-102542400,3),(1598,-86295600,2),(1598,-72907200,3),(1598,-54154800,2),(1598,-41457600,3),(1598,-21495600,2),(1598,-5774400,3),(1598,9954000,2),(1598,25675200,3),(1598,41403600,2),(1598,57729600,3),(1598,73458000,2),(1598,87364801,3),(1598,104907602,2),(1598,118900802,3),(1598,136357203,2),(1598,150436803,3),(1598,167806804,2),(1598,183528004,3),(1598,199256405,2),(1598,215582405,3),(1598,230706006,2),(1598,247032006,3),(1598,263365207,2),(1598,276667207,3),(1598,290581208,2),(1598,308721608,3),(1598,322030809,2),(1598,340171209,3),(1598,358318809,2),(1598,371620810,3),(1598,389768410,2),(1598,403070411,3),(1598,421218011,2),(1598,434520012,3),(1598,452667612,2),(1598,466574412,3),(1598,484117212,2),(1598,498024013,3),(1598,511333213,2),(1598,529473613,3),(1598,542782813,2),(1598,560923213,3),(1598,574837214,2),(1598,592372814,3),(1598,606286814,2),(1598,623822414,3),(1598,638946015,2),(1598,655876815,3),(1598,671000416,2),(1598,687330016,4),(1598,702450016,2),(1598,718779617,4),(1598,733899617,2),(1598,750229218,4),(1598,765349218,2),(1598,781678819,4),(1598,796798819,2),(1598,813128419,4),(1598,828853220,2),(1598,844578020,4),(1598,860302820,2),(1598,876632421,4),(1598,891147621,5),(1598,909291621,4),(1598,922597222,5),(1598,941346022,4),(1598,954651622,5),(1598,972795622,4),(1598,986101222,5),(1598,1004245222,4),(1598,1018155622,5),(1598,1035694822,4),(1598,1049605222,5),(1598,1067144422,4),(1598,1080450022,5),(1598,1162098023,4),(1598,1173589223,5),(1598,1193547623,4),(1598,1205643623,5),(1598,1224997223,4),(1598,1236488424,5),(1598,1256446824,4),(1598,1268542824,5),(1598,1288501224,4),(1598,1300597224,5),(1598,1321160424,4),(1598,1333256424,5),(1598,1352005225,4),(1598,1362891625,5),(1598,1383454825,4),(1598,1394341225,5),(1598,1414904425,4),(1598,1425790825,5),(1598,1446354026,4),(1598,1457845226,5),(1598,1478408426,4),(1598,1489294827,5),(1598,1509858027,4),(1598,1520744427,5),(1598,1541307627,4),(1598,1552194027,5),(1598,1572757227,4),(1598,1583643627,5),(1598,1604206827,4),(1598,1615698027,5),(1598,1636261227,4),(1598,1647147627,5),(1598,1667710827,4),(1598,1678597227,5),(1598,1699160427,4),(1598,1710046827,5),(1598,1730610027,4),(1598,1741496427,5),(1598,1762059627,4),(1598,1772946027,5),(1598,1793509227,4),(1598,1805000427,5),(1598,1825563627,4),(1598,1836450027,5),(1598,1857013227,4),(1598,1867899627,5),(1598,1888462827,4),(1598,1899349227,5),(1598,1919912427,4),(1598,1930798827,5),(1598,1951362027,4),(1598,1962853227,5),(1598,1983416427,4),(1598,1994302827,5),(1598,2014866027,4),(1598,2025752427,5),(1598,2046315627,4),(1598,2057202027,5),(1598,2077765227,4),(1598,2088651627,5),(1598,2109214827,4),(1598,2120101227,5),(1598,2140664427,4),(1599,228877206,0),(1599,243997206,1),(1599,260326807,0),(1599,276051607,1),(1599,291776408,0),(1599,307501208,1),(1599,323830809,0),(1599,338950809,1),(1599,354675609,0),(1599,370400410,1),(1599,386125210,0),(1599,401850011,1),(1599,417574811,0),(1599,433299612,1),(1599,449024412,0),(1599,465354012,1),(1599,481078812,0),(1599,496803613,1),(1599,512528413,0),(1599,528253213,1),(1599,543978013,0),(1599,559702813,1),(1599,575427614,0),(1599,591152414,1),(1599,606877214,0),(1599,622602014,1),(1599,638326815,0),(1599,654656415,1),(1599,670381216,0),(1599,686106016,1),(1599,701830816,0),(1599,717555617,1),(1599,733280417,0),(1599,749005218,1),(1599,764730018,0),(1599,780454819,1),(1599,796179619,0),(1599,811904419,1),(1599,828234020,0),(1599,846378020,1),(1599,859683620,0),(1599,877827621,1),(1599,891133221,0),(1599,909277221,1),(1599,922582822,0),(1599,941331622,1),(1599,954032422,0),(1599,972781222,1),(1599,985482022,0),(1599,1004230822,1),(1599,1017536422,0),(1599,1035680422,1),(1599,1048986022,0),(1599,1067130022,1),(1599,1080435622,0),(1599,1099184422,1),(1599,1111885222,0),(1599,1130634022,1),(1599,1143334823,0),(1599,1162083623,1),(1599,1174784423,0),(1599,1193533223,1),(1599,1206838823,0),(1599,1224982823,1),(1599,1238288424,0),(1599,1256432424,1),(1599,1269738024,0),(1599,1288486824,1),(1599,1301187624,0),(1599,1319936424,1),(1599,1332637224,0),(1599,1351386025,1),(1599,1364691625,0),(1599,1382835625,1),(1599,1396141225,0),(1599,1414285225,1),(1599,1427590825,0),(1599,1445734826,1),(1599,1459040426,0),(1599,1477789226,1),(1599,1490490027,0),(1599,1509238827,1),(1599,1521939627,0),(1599,1540688427,1),(1599,1553994027,0),(1599,1572138027,1),(1599,1585443627,0),(1599,1603587627,1),(1599,1616893227,0),(1599,1635642027,1),(1599,1648342827,0),(1599,1667091627,1),(1599,1679792427,0),(1599,1698541227,1),(1599,1711846827,0),(1599,1729990827,1),(1599,1743296427,0),(1599,1761440427,1),(1599,1774746027,0),(1599,1792890027,1),(1599,1806195627,0),(1599,1824944427,1),(1599,1837645227,0),(1599,1856394027,1),(1599,1869094827,0),(1599,1887843627,1),(1599,1901149227,0),(1599,1919293227,1),(1599,1932598827,0),(1599,1950742827,1),(1599,1964048427,0),(1599,1982797227,1),(1599,1995498027,0),(1599,2014246827,1),(1599,2026947627,0),(1599,2045696427,1),(1599,2058397227,0),(1599,2077146027,1),(1599,2090451627,0),(1599,2108595627,1),(1599,2121901227,0),(1599,2140045227,1),(1601,-1633280400,0),(1601,-1615140000,1),(1601,-1601830800,0),(1601,-1583690400,1),(1601,-880218000,2),(1601,-769395600,3),(1601,-765396000,1),(1601,-84387600,0),(1601,-68666400,1),(1601,-52938000,0),(1601,-37216800,1),(1601,-21488400,0),(1601,-5767200,1),(1601,9961200,0),(1601,25682400,1),(1601,41410800,0),(1601,57736800,1),(1601,73465200,0),(1601,89186401,1),(1601,104914802,0),(1601,120636002,1),(1601,126687603,0),(1601,152085603,1),(1601,162370804,0),(1601,183535204,1),(1601,199263605,0),(1601,215589605,1),(1601,230713206,0),(1601,247039206,1),(1601,262767607,0),(1601,278488807,1),(1601,294217208,0),(1601,309938408,1),(1601,325666809,0),(1601,341388009,1),(1601,357116409,0),(1601,372837610,1),(1601,388566010,0),(1601,404892011,1),(1601,420015611,0),(1601,436341612,1),(1601,452070012,0),(1601,467791212,1),(1601,483519612,0),(1601,499240813,1),(1601,514969213,0),(1601,530690413,1),(1601,544604413,0),(1601,562140013,1),(1601,576054014,0),(1601,594194414,1),(1601,607503614,0),(1601,625644014,1),(1601,638953215,0),(1601,657093615,1),(1601,671007616,0),(1601,688543216,1),(1601,702457216,0),(1601,719992817,1),(1601,733906817,0),(1601,752047218,1),(1601,765356418,0),(1601,783496819,1),(1601,796806019,0),(1601,814946419,1),(1601,828860420,0),(1601,846396020,1),(1601,860310020,0),(1601,877845621,1),(1601,891759621,0),(1601,909295221,1),(1601,923209222,0),(1601,941349622,1),(1601,954658822,0),(1601,972799222,1),(1601,986108422,0),(1601,1004248822,1),(1601,1018162822,0),(1601,1035698422,1),(1601,1049612422,0),(1601,1067148022,1),(1601,1081062022,0),(1601,1099202422,1),(1601,1112511622,0),(1601,1130652022,1),(1601,1143961223,0),(1601,1162101623,1),(1601,1173596423,0),(1601,1194156023,1),(1601,1205046023,0),(1601,1225605623,1),(1601,1236495624,0),(1601,1257055224,1),(1601,1268550024,0),(1601,1289109624,1),(1601,1299999624,0),(1601,1320559224,1),(1601,1331449224,0),(1601,1352008825,1),(1601,1362898825,0),(1601,1383458425,1),(1601,1394348425,0),(1601,1414908025,1),(1601,1425798025,0),(1601,1446357626,1),(1601,1457852426,0),(1601,1478412026,1),(1601,1489302027,0),(1601,1509861627,1),(1601,1520751627,0),(1601,1541311227,1),(1601,1552201227,0),(1601,1572760827,1),(1601,1583650827,0),(1601,1604210427,1),(1601,1615705227,0),(1601,1636264827,1),(1601,1647154827,0),(1601,1667714427,1),(1601,1678604427,0),(1601,1699164027,1),(1601,1710054027,0),(1601,1730613627,1),(1601,1741503627,0),(1601,1762063227,1),(1601,1772953227,0),(1601,1793512827,1),(1601,1805007627,0),(1601,1825567227,1),(1601,1836457227,0),(1601,1857016827,1),(1601,1867906827,0),(1601,1888466427,1),(1601,1899356427,0),(1601,1919916027,1),(1601,1930806027,0),(1601,1951365627,1),(1601,1962860427,0),(1601,1983420027,1),(1601,1994310027,0),(1601,2014869627,1),(1601,2025759627,0),(1601,2046319227,1),(1601,2057209227,0),(1601,2077768827,1),(1601,2088658827,0),(1601,2109218427,1),(1601,2120108427,0),(1601,2140668027,1),(1602,-2147483648,2),(1602,-929844000,1),(1602,-923108400,2),(1602,-906170400,1),(1602,-892868400,2),(1602,-875844000,1),(1602,-857790000,2),(1602,-844308000,1),(1602,-825822000,2),(1602,-812685600,1),(1602,-794199600,2),(1602,-779853600,1),(1602,-762663600,2),(1602,-399088800,1),(1602,-386650800,2),(1602,-368330400,1),(1602,-355114800,2),(1602,-336790800,1),(1602,-323654400,2),(1602,-305168400,1),(1602,-292032000,2),(1602,-273632400,1),(1602,-260496000,2),(1602,-242096400,1),(1602,-228960000,2),(1602,-210560400,1),(1602,-197424000,2),(1602,-178938000,1),(1602,-165801600,2),(1602,-147402000,1),(1602,-134265600,2),(1602,-115866000,1),(1602,-102643200,2),(1602,-84330000,1),(1602,-71107200,2),(1602,-52707600,1),(1602,-39484800,2),(1602,-21171600,1),(1602,-7948800,2),(1602,10364400,1),(1602,23587200,2),(1602,41900400,1),(1602,55123200,2),(1602,73522800,1),(1602,86745601,2),(1602,105058802,1),(1602,118281602,2),(1602,136594803,1),(1602,149817603,2),(1602,168130804,1),(1602,181353604,2),(1602,199753205,1),(1602,212976005,2),(1602,231289206,1),(1602,244512006,2),(1602,262825207,1),(1602,276048007,2),(1602,294361208,1),(1602,307584008,2),(1602,325983609,1),(1602,339206409,2),(1602,357519609,1),(1602,370742410,2),(1602,396399611,1),(1602,402278411,2),(1602,426812412,1),(1602,433814412,2),(1602,452214012,1),(1602,465436812,2),(1602,483750012,1),(1602,496972813,2),(1602,515286013,1),(1602,528508813,2),(1602,546822013,1),(1602,560044813,2),(1602,578444414,1),(1602,591667214,2),(1602,610412414,1),(1602,623203214,2),(1602,641516415,1),(1602,654739215,2),(1602,673052416,1),(1602,686275216,2),(1602,704674816,1),(1602,717897617,2),(1602,736210817,1),(1602,749433618,2),(1602,767746818,1),(1602,780969619,2),(1602,799020019,3),(1602,812322019,2),(1602,830469620,3),(1602,843771620,2),(1602,861919220,3),(1602,875221221,2),(1602,893368821,3),(1602,906670821,2),(1602,925423222,3),(1602,938725222,2),(1602,956872822,3),(1602,970174822,2),(1602,988322422,3),(1602,1001624422,2),(1602,1019772022,3),(1602,1033074022,2),(1602,1051221622,3),(1602,1064523622,2),(1602,1083276022,3),(1602,1096578022,2),(1602,1114725622,3),(1602,1128027622,2),(1602,1146175223,3),(1602,1158872423,2),(1602,1177624823,3),(1602,1189112423,2),(1602,1209074423,3),(1602,1219957223,2),(1602,1240524024,3),(1602,1250802024,2),(1602,1272578424,3),(1602,1281474024,2),(1602,1284069624,1),(1602,1285880424,2),(1602,1400191225,1),(1602,1403816425,2),(1602,1406844025,1),(1602,1411678825,2),(1603,-2147483648,1),(1603,-1691962479,2),(1603,-1680471279,4),(1603,-1664143200,3),(1603,-1650146400,4),(1603,-1633903200,3),(1603,-1617487200,4),(1603,-1601848800,3),(1603,-1586037600,4),(1603,-1570399200,3),(1603,-1552168800,4),(1603,-1538344800,3),(1603,-1522533600,4),(1603,-1517011200,6),(1603,-1507500000,5),(1603,-1490565600,4),(1603,-1473631200,5),(1603,-1460930400,4),(1603,-1442786400,5),(1603,-1428876000,4),(1603,-1410732000,5),(1603,-1396216800,4),(1603,-1379282400,5),(1603,-1364767200,4),(1603,-1348437600,5),(1603,-1333317600,4),(1603,-1315778400,5),(1603,-1301263200,4),(1603,-1284328800,5),(1603,-1269813600,4),(1603,-1253484000,5),(1603,-1238364000,4),(1603,-1221429600,5),(1603,-1206914400,4),(1603,-1189980000,5),(1603,-1175464800,4),(1603,-1159135200,5),(1603,-1143410400,4),(1603,-1126476000,5),(1603,-1111960800,4),(1603,-1095631200,5),(1603,-1080511200,4),(1603,-1063576800,5),(1603,-1049061600,4),(1603,-1032127200,5),(1603,-1017612000,4),(1603,-1001282400,5),(1603,-986162400,4),(1603,-969228000,5),(1603,-950479200,4),(1603,-942012000,5),(1603,-733356000,4),(1603,-719445600,5),(1603,-699487200,4),(1603,-684972000,5),(1603,-668037600,4),(1603,-654732000,5),(1603,-636588000,4),(1603,-622072800,5),(1603,-605743200,4),(1603,-590623200,5),(1603,-574293600,4),(1603,-558568800,5),(1603,-542239200,4),(1603,-527119200,5),(1603,-512604000,4),(1603,-496274400,5),(1603,-481154400,4),(1603,-464220000,5),(1603,-449704800,4),(1603,-432165600,5),(1603,-417650400,4),(1603,-401320800,5),(1603,-386200800,4),(1603,-369266400,5),(1603,-354751200,4),(1603,-337816800,5),(1603,-323301600,4),(1603,-306972000,5),(1603,-291852000,4),(1603,-276732000,5),(1603,-257983200,4),(1603,-245282400,5),(1603,-226533600,4),(1603,-213228000,5),(1603,-195084000,4),(1603,-182383200,5),(1603,-163634400,4),(1603,-150933600,5),(1603,-132184800,4),(1603,-119484000,5),(1603,-100735200,4),(1603,-88034400,5),(1603,-68680800,4),(1603,-59004000,5),(1603,-37242000,9),(1603,57722400,7),(1603,69818400,8),(1603,89172001,7),(1603,101268002,8),(1603,120621602,7),(1603,132717603,8),(1603,152071203,7),(1603,164167204,8),(1603,183520804,7),(1603,196221605,8),(1603,214970405,7),(1603,227671206,8),(1603,246420006,7),(1603,259120807,8),(1603,278474407,7),(1603,290570408,8),(1603,309924008,7),(1603,322020009,8),(1603,341373609,7),(1603,354675609,8),(1603,372819610,7),(1603,386125210,8),(1603,404269211,7),(1603,417574811,8),(1603,435718812,7),(1603,449024412,8),(1603,467773212,7),(1603,481078812,8),(1603,499222813,7),(1603,512528413,8),(1603,530672413,7),(1603,543978013,8),(1603,562122013,7),(1603,575427614,8),(1603,593571614,7),(1603,606877214,8),(1603,625626014,7),(1603,638326815,8),(1603,657075615,7),(1603,670381216,8),(1603,688525216,7),(1603,701830816,8),(1603,719974817,7),(1603,733280417,8),(1603,751424418,7),(1603,764730018,8),(1603,782874019,7),(1603,796179619,8),(1603,814323619,7),(1603,828234020,8),(1603,846378020,7),(1603,859683620,8),(1603,877827621,7),(1603,891133221,8),(1603,909277221,7),(1603,922582822,8),(1603,941331622,7),(1603,954032422,8),(1603,972781222,7),(1603,985482022,8),(1603,1004230822,7),(1603,1017536422,8),(1603,1035680422,7),(1603,1048986022,8),(1603,1067130022,7),(1603,1080435622,8),(1603,1099184422,7),(1603,1111885222,8),(1603,1130634022,7),(1603,1143334823,8),(1603,1162083623,7),(1603,1174784423,8),(1603,1193533223,7),(1603,1206838823,8),(1603,1224982823,7),(1603,1238288424,8),(1603,1256432424,7),(1603,1269738024,8),(1603,1288486824,7),(1603,1301187624,8),(1603,1319936424,7),(1603,1332637224,8),(1603,1351386025,7),(1603,1364691625,8),(1603,1382835625,7),(1603,1396141225,8),(1603,1414285225,7),(1603,1427590825,8),(1603,1445734826,7),(1603,1459040426,8),(1603,1477789226,7),(1603,1490490027,8),(1603,1509238827,7),(1603,1521939627,8),(1603,1540688427,7),(1603,1553994027,8),(1603,1572138027,7),(1603,1585443627,8),(1603,1603587627,7),(1603,1616893227,8),(1603,1635642027,7),(1603,1648342827,8),(1603,1667091627,7),(1603,1679792427,8),(1603,1698541227,7),(1603,1711846827,8),(1603,1729990827,7),(1603,1743296427,8),(1603,1761440427,7),(1603,1774746027,8),(1603,1792890027,7),(1603,1806195627,8),(1603,1824944427,7),(1603,1837645227,8),(1603,1856394027,7),(1603,1869094827,8),(1603,1887843627,7),(1603,1901149227,8),(1603,1919293227,7),(1603,1932598827,8),(1603,1950742827,7),(1603,1964048427,8),(1603,1982797227,7),(1603,1995498027,8),(1603,2014246827,7),(1603,2026947627,8),(1603,2045696427,7),(1603,2058397227,8),(1603,2077146027,7),(1603,2090451627,8),(1603,2108595627,7),(1603,2121901227,8),(1603,2140045227,7),(1639,-2147483648,2),(1639,-1693700372,1),(1639,-1680484772,2),(1639,-1663453172,3),(1639,-1650147572,4),(1639,-1633213172,3),(1639,-1617488372,4),(1639,-1601158772,3),(1639,-1586038772,4),(1639,-1569709172,3),(1639,-1554589172,4),(1639,-1538259572,3),(1639,-1523139572,4),(1639,-1507501172,3),(1639,-1490566772,4),(1639,-1470176372,3),(1639,-1459117172,4),(1639,-1443997172,3),(1639,-1427667572,4),(1639,-1406672372,3),(1639,-1396217972,4),(1639,-1376950772,3),(1639,-1364768372,4),(1639,-1345414772,3),(1639,-1333318772,4),(1639,-1313792372,3),(1639,-1301264372,4),(1639,-1282256372,3),(1639,-1269814772,4),(1639,-1250720372,3),(1639,-1238365172,4),(1639,-1219184372,3),(1639,-1206915572,4),(1639,-1186957172,3),(1639,-1175465972,4),(1639,-1156025972,3),(1639,-1143411572,4),(1639,-1124489972,3),(1639,-1111961972,4),(1639,-1092953972,3),(1639,-1080512372,4),(1639,-1061331572,3),(1639,-1049062772,4),(1639,-1029190772,3),(1639,-1025745572,7),(1639,-1017613200,5),(1639,-998259600,6),(1639,-986163600,5),(1639,-966723600,6),(1639,-954109200,5),(1639,-935022000,10),(1639,-857257200,8),(1639,-844556400,9),(1639,-828226800,8),(1639,-812502000,9),(1639,-796777200,8),(1639,-781052400,9),(1639,-766623600,8),(1639,220921205,13),(1639,228877206,11),(1639,243997206,12),(1639,260326807,11),(1639,276051607,12),(1639,291776408,11),(1639,307501208,12),(1639,323830809,11),(1639,338950809,12),(1639,354675609,11),(1639,370400410,12),(1639,386125210,11),(1639,401850011,12),(1639,417574811,11),(1639,433299612,12),(1639,449024412,11),(1639,465354012,12),(1639,481078812,11),(1639,496803613,12),(1639,512528413,11),(1639,528253213,12),(1639,543978013,11),(1639,559702813,12),(1639,575427614,11),(1639,591152414,12),(1639,606877214,11),(1639,622602014,12),(1639,638326815,11),(1639,654656415,12),(1639,670381216,11),(1639,686106016,12),(1639,701830816,11),(1639,717555617,12),(1639,733280417,11),(1639,749005218,12),(1639,764730018,11),(1639,780454819,12),(1639,796179619,11),(1639,811904419,12),(1639,828234020,11),(1639,846378020,12),(1639,859683620,11),(1639,877827621,12),(1639,891133221,11),(1639,909277221,12),(1639,922582822,11),(1639,941331622,12),(1639,954032422,11),(1639,972781222,12),(1639,985482022,11),(1639,1004230822,12),(1639,1017536422,11),(1639,1035680422,12),(1639,1048986022,11),(1639,1067130022,12),(1639,1080435622,11),(1639,1099184422,12),(1639,1111885222,11),(1639,1130634022,12),(1639,1143334823,11),(1639,1162083623,12),(1639,1174784423,11),(1639,1193533223,12),(1639,1206838823,11),(1639,1224982823,12),(1639,1238288424,11),(1639,1256432424,12),(1639,1269738024,11),(1639,1288486824,12),(1639,1301187624,11),(1639,1319936424,12),(1639,1332637224,11),(1639,1351386025,12),(1639,1364691625,11),(1639,1382835625,12),(1639,1396141225,11),(1639,1414285225,12),(1639,1427590825,11),(1639,1445734826,12),(1639,1459040426,11),(1639,1477789226,12),(1639,1490490027,11),(1639,1509238827,12),(1639,1521939627,11),(1639,1540688427,12),(1639,1553994027,11),(1639,1572138027,12),(1639,1585443627,11),(1639,1603587627,12),(1639,1616893227,11),(1639,1635642027,12),(1639,1648342827,11),(1639,1667091627,12),(1639,1679792427,11),(1639,1698541227,12),(1639,1711846827,11),(1639,1729990827,12),(1639,1743296427,11),(1639,1761440427,12),(1639,1774746027,11),(1639,1792890027,12),(1639,1806195627,11),(1639,1824944427,12),(1639,1837645227,11),(1639,1856394027,12),(1639,1869094827,11),(1639,1887843627,12),(1639,1901149227,11),(1639,1919293227,12),(1639,1932598827,11),(1639,1950742827,12),(1639,1964048427,11),(1639,1982797227,12),(1639,1995498027,11),(1639,2014246827,12),(1639,2026947627,11),(1639,2045696427,12),(1639,2058397227,11),(1639,2077146027,12),(1639,2090451627,11),(1639,2108595627,12),(1639,2121901227,11),(1639,2140045227,12),(1640,-2147483648,1),(1640,-733881600,2),(1640,481078812,3),(1640,496803613,4),(1640,512528413,3),(1640,528253213,4),(1640,543978013,3),(1640,559702813,4),(1640,575427614,3),(1640,591152414,4),(1640,606877214,3),(1640,622602014,4),(1640,638326815,3),(1640,654656415,4),(1640,670381216,3),(1640,686106016,4),(1640,701830816,3),(1640,717555617,4),(1640,733280417,3),(1640,749005218,4),(1640,764730018,3),(1640,780454819,4),(1640,796179619,3),(1640,811904419,4),(1640,828234020,3),(1640,846378020,4),(1640,859683620,3),(1640,877827621,4),(1640,891133221,3),(1640,909277221,4),(1640,922582822,3),(1640,941331622,4),(1640,954032422,3),(1640,972781222,4),(1640,985482022,3),(1640,1004230822,4),(1640,1017536422,3),(1640,1035680422,4),(1640,1048986022,3),(1640,1067130022,4),(1640,1080435622,3),(1640,1099184422,4),(1640,1111885222,3),(1640,1130634022,4),(1640,1143334823,3),(1640,1162083623,4),(1640,1174784423,3),(1640,1193533223,4),(1640,1206838823,3),(1640,1224982823,4),(1640,1238288424,3),(1640,1256432424,4),(1640,1269738024,3),(1640,1288486824,4),(1640,1301187624,3),(1640,1319936424,4),(1640,1332637224,3),(1640,1351386025,4),(1640,1364691625,3),(1640,1382835625,4),(1640,1396141225,3),(1640,1414285225,4),(1640,1427590825,3),(1640,1445734826,4),(1640,1459040426,3),(1640,1477789226,4),(1640,1490490027,3),(1640,1509238827,4),(1640,1521939627,3),(1640,1540688427,4),(1640,1553994027,3),(1640,1572138027,4),(1640,1585443627,3),(1640,1603587627,4),(1640,1616893227,3),(1640,1635642027,4),(1640,1648342827,3),(1640,1667091627,4),(1640,1679792427,3),(1640,1698541227,4),(1640,1711846827,3),(1640,1729990827,4),(1640,1743296427,3),(1640,1761440427,4),(1640,1774746027,3),(1640,1792890027,4),(1640,1806195627,3),(1640,1824944427,4),(1640,1837645227,3),(1640,1856394027,4),(1640,1869094827,3),(1640,1887843627,4),(1640,1901149227,3),(1640,1919293227,4),(1640,1932598827,3),(1640,1950742827,4),(1640,1964048427,3),(1640,1982797227,4),(1640,1995498027,3),(1640,2014246827,4),(1640,2026947627,3),(1640,2045696427,4),(1640,2058397227,3),(1640,2077146027,4),(1640,2090451627,3),(1640,2108595627,4),(1640,2121901227,3),(1640,2140045227,4),(1641,-2147483648,0),(1641,-1441249932,1),(1641,-1247540400,3),(1641,354916809,2),(1641,370724410,3),(1641,386452810,2),(1641,402260411,3),(1641,417988811,2),(1641,433796412,3),(1641,449611212,2),(1641,465343212,4),(1641,481068012,5),(1641,496792813,4),(1641,512517613,5),(1641,528242413,4),(1641,543967213,5),(1641,559692013,4),(1641,575416814,5),(1641,591141614,4),(1641,606866414,6),(1641,622594814,7),(1641,638319615,6),(1641,654649215,7),(1641,670374016,4),(1641,701820016,6),(1641,717548417,7),(1641,733273217,6),(1641,748998018,7),(1641,764722818,6),(1641,780447619,7),(1641,796172419,6),(1641,811897219,7),(1641,828226820,6),(1641,846370820,7),(1641,859676420,6),(1641,877820421,7),(1641,891126021,6),(1641,909270021,7),(1641,922575622,6),(1641,941324422,7),(1641,954025222,6),(1641,972774022,7),(1641,985474822,6),(1641,1004223622,7),(1641,1017529222,6),(1641,1035673222,7),(1641,1048978822,6),(1641,1067122822,7),(1641,1080428422,6),(1641,1099177222,7),(1641,1111878022,6),(1641,1130626822,7),(1641,1143327623,6),(1641,1162076423,7),(1641,1174777223,6),(1641,1193526023,7),(1641,1206831623,6),(1641,1224975623,7),(1641,1238281224,6),(1641,1256425224,7),(1641,1269730824,6),(1641,1288479624,7),(1641,1301180424,4),(1641,1414274425,7),(1641,1459033226,4),(1642,-2147483648,1),(1642,-1686101632,3),(1642,-1182996000,2),(1642,-1178161200,3),(1642,-906861600,2),(1642,-904878000,5),(1642,-857257200,4),(1642,-844477200,5),(1642,-828237600,4),(1642,-812422800,3),(1642,-552362400,2),(1642,-541652400,3),(1642,166485604,6),(1642,186184804,7),(1642,198028805,6),(1642,213753605,7),(1642,228873606,6),(1642,244080006,7),(1642,260323207,6),(1642,275446807,3),(1642,291798008,2),(1642,307407608,3),(1642,323388009,2),(1642,338936409,3),(1642,354675609,8),(1642,370400410,9),(1642,386125210,8),(1642,401850011,9),(1642,417574811,8),(1642,433299612,9),(1642,449024412,8),(1642,465354012,9),(1642,481078812,8),(1642,496803613,9),(1642,512528413,8),(1642,528253213,9),(1642,543978013,8),(1642,559702813,9),(1642,575427614,8),(1642,591152414,9),(1642,606877214,8),(1642,622602014,9),(1642,638326815,8),(1642,654656415,9),(1642,670381216,8),(1642,686106016,9),(1642,701830816,8),(1642,717555617,9),(1642,733280417,8),(1642,749005218,9),(1642,764730018,8),(1642,780454819,9),(1642,796179619,8),(1642,811904419,9),(1642,828234020,8),(1642,846378020,9),(1642,859683620,8),(1642,877827621,9),(1642,891133221,8),(1642,909277221,9),(1642,922582822,8),(1642,941331622,9),(1642,954032422,8),(1642,972781222,9),(1642,985482022,8),(1642,1004230822,9),(1642,1017536422,8),(1642,1035680422,9),(1642,1048986022,8),(1642,1067130022,9),(1642,1080435622,8),(1642,1099184422,9),(1642,1111885222,8),(1642,1130634022,9),(1642,1143334823,8),(1642,1162083623,9),(1642,1174784423,8),(1642,1193533223,9),(1642,1206838823,8),(1642,1224982823,9),(1642,1238288424,8),(1642,1256432424,9),(1642,1269738024,8),(1642,1288486824,9),(1642,1301187624,8),(1642,1319936424,9),(1642,1332637224,8),(1642,1351386025,9),(1642,1364691625,8),(1642,1382835625,9),(1642,1396141225,8),(1642,1414285225,9),(1642,1427590825,8),(1642,1445734826,9),(1642,1459040426,8),(1642,1477789226,9),(1642,1490490027,8),(1642,1509238827,9),(1642,1521939627,8),(1642,1540688427,9),(1642,1553994027,8),(1642,1572138027,9),(1642,1585443627,8),(1642,1603587627,9),(1642,1616893227,8),(1642,1635642027,9),(1642,1648342827,8),(1642,1667091627,9),(1642,1679792427,8),(1642,1698541227,9),(1642,1711846827,8),(1642,1729990827,9),(1642,1743296427,8),(1642,1761440427,9),(1642,1774746027,8),(1642,1792890027,9),(1642,1806195627,8),(1642,1824944427,9),(1642,1837645227,8),(1642,1856394027,9),(1642,1869094827,8),(1642,1887843627,9),(1642,1901149227,8),(1642,1919293227,9),(1642,1932598827,8),(1642,1950742827,9),(1642,1964048427,8),(1642,1982797227,9),(1642,1995498027,8),(1642,2014246827,9),(1642,2026947627,8),(1642,2045696427,9),(1642,2058397227,8),(1642,2077146027,9),(1642,2090451627,8),(1642,2108595627,9),(1642,2121901227,8),(1642,2140045227,9),(1643,-2147483648,2),(1643,-1691964000,1),(1643,-1680472800,2),(1643,-1664143200,1),(1643,-1650146400,2),(1643,-1633903200,1),(1643,-1617487200,2),(1643,-1601848800,1),(1643,-1586037600,2),(1643,-1570399200,1),(1643,-1552168800,2),(1643,-1538344800,1),(1643,-1522533600,2),(1643,-1507500000,1),(1643,-1490565600,2),(1643,-1473631200,1),(1643,-1460930400,2),(1643,-1442786400,1),(1643,-1428876000,2),(1643,-1410732000,1),(1643,-1396216800,2),(1643,-1379282400,1),(1643,-1364767200,2),(1643,-1348437600,1),(1643,-1333317600,2),(1643,-1315778400,1),(1643,-1301263200,2),(1643,-1284328800,1),(1643,-1269813600,2),(1643,-1253484000,1),(1643,-1238364000,2),(1643,-1221429600,1),(1643,-1206914400,2),(1643,-1189980000,1),(1643,-1175464800,2),(1643,-1159135200,1),(1643,-1143410400,2),(1643,-1126476000,1),(1643,-1111960800,2),(1643,-1095631200,1),(1643,-1080511200,2),(1643,-1063576800,1),(1643,-1049061600,2),(1643,-1032127200,1),(1643,-1017612000,2),(1643,-1001282400,1),(1643,-986162400,2),(1643,-969228000,1),(1643,-950479200,2),(1643,-942012000,1),(1643,-904518000,3),(1643,-896050800,1),(1643,-875487600,3),(1643,-864601200,1),(1643,-844038000,3),(1643,-832546800,1),(1643,-812588400,3),(1643,-798073200,1),(1643,-781052400,3),(1643,-772066800,1),(1643,-764805600,2),(1643,-748476000,1),(1643,-733356000,2),(1643,-719445600,1),(1643,-717030000,3),(1643,-706748400,1),(1643,-699487200,2),(1643,-687996000,1),(1643,-668037600,2),(1643,-654732000,1),(1643,-636588000,2),(1643,-622072800,1),(1643,-605743200,2),(1643,-590623200,1),(1643,-574293600,2),(1643,-558568800,1),(1643,-542239200,2),(1643,-527119200,1),(1643,-512604000,2),(1643,-496274400,1),(1643,-481154400,2),(1643,-464220000,1),(1643,-449704800,2),(1643,-432165600,1),(1643,-417650400,2),(1643,-401320800,1),(1643,-386200800,2),(1643,-369266400,1),(1643,-354751200,2),(1643,-337816800,1),(1643,-323301600,2),(1643,-306972000,1),(1643,-291852000,2),(1643,-276732000,1),(1643,-257983200,2),(1643,-245282400,1),(1643,-226533600,2),(1643,-213228000,1),(1643,-195084000,2),(1643,-182383200,1),(1643,-163634400,2),(1643,-150933600,1),(1643,-132184800,2),(1643,-119484000,1),(1643,-100735200,2),(1643,-88034400,1),(1643,-68680800,2),(1643,-59004000,1),(1643,-37242000,4),(1643,57722400,6),(1643,69818400,1),(1643,89172001,2),(1643,101268002,1),(1643,120621602,2),(1643,132717603,1),(1643,152071203,2),(1643,164167204,1),(1643,183520804,2),(1643,196221605,1),(1643,214970405,2),(1643,227671206,1),(1643,246420006,2),(1643,259120807,1),(1643,278474407,2),(1643,290570408,1),(1643,309924008,2),(1643,322020009,1),(1643,341373609,2),(1643,354675609,5),(1643,372819610,6),(1643,386125210,5),(1643,404269211,6),(1643,417574811,5),(1643,435718812,6),(1643,449024412,5),(1643,467773212,6),(1643,481078812,5),(1643,499222813,6),(1643,512528413,5),(1643,530672413,6),(1643,543978013,5),(1643,562122013,6),(1643,575427614,5),(1643,593571614,6),(1643,606877214,5),(1643,625626014,6),(1643,638326815,5),(1643,657075615,6),(1643,670381216,5),(1643,688525216,6),(1643,701830816,5),(1643,719974817,6),(1643,733280417,5),(1643,751424418,6),(1643,764730018,5),(1643,782874019,6),(1643,796179619,5),(1643,814323619,6),(1643,820454420,7),(1643,828234020,5),(1643,846378020,6),(1643,859683620,5),(1643,877827621,6),(1643,891133221,5),(1643,909277221,6),(1643,922582822,5),(1643,941331622,6),(1643,954032422,5),(1643,972781222,6),(1643,985482022,5),(1643,1004230822,6),(1643,1017536422,5),(1643,1035680422,6),(1643,1048986022,5),(1643,1067130022,6),(1643,1080435622,5),(1643,1099184422,6),(1643,1111885222,5),(1643,1130634022,6),(1643,1143334823,5),(1643,1162083623,6),(1643,1174784423,5),(1643,1193533223,6),(1643,1206838823,5),(1643,1224982823,6),(1643,1238288424,5),(1643,1256432424,6),(1643,1269738024,5),(1643,1288486824,6),(1643,1301187624,5),(1643,1319936424,6),(1643,1332637224,5),(1643,1351386025,6),(1643,1364691625,5),(1643,1382835625,6),(1643,1396141225,5),(1643,1414285225,6),(1643,1427590825,5),(1643,1445734826,6),(1643,1459040426,5),(1643,1477789226,6),(1643,1490490027,5),(1643,1509238827,6),(1643,1521939627,5),(1643,1540688427,6),(1643,1553994027,5),(1643,1572138027,6),(1643,1585443627,5),(1643,1603587627,6),(1643,1616893227,5),(1643,1635642027,6),(1643,1648342827,5),(1643,1667091627,6),(1643,1679792427,5),(1643,1698541227,6),(1643,1711846827,5),(1643,1729990827,6),(1643,1743296427,5),(1643,1761440427,6),(1643,1774746027,5),(1643,1792890027,6),(1643,1806195627,5),(1643,1824944427,6),(1643,1837645227,5),(1643,1856394027,6),(1643,1869094827,5),(1643,1887843627,6),(1643,1901149227,5),(1643,1919293227,6),(1643,1932598827,5),(1643,1950742827,6),(1643,1964048427,5),(1643,1982797227,6),(1643,1995498027,5),(1643,2014246827,6),(1643,2026947627,5),(1643,2045696427,6),(1643,2058397227,5),(1643,2077146027,6),(1643,2090451627,5),(1643,2108595627,6),(1643,2121901227,5),(1643,2140045227,6),(1644,-2147483648,1),(1644,-905824800,4),(1644,-857257200,2),(1644,-844556400,3),(1644,-828226800,2),(1644,-812502000,3),(1644,-796777200,2),(1644,-788922000,1),(1644,-777942000,3),(1644,-766623600,2),(1644,407199611,1),(1644,417574811,5),(1644,433299612,6),(1644,449024412,5),(1644,465354012,6),(1644,481078812,5),(1644,496803613,6),(1644,512528413,5),(1644,528253213,6),(1644,543978013,5),(1644,559702813,6),(1644,575427614,5),(1644,591152414,6),(1644,606877214,5),(1644,622602014,6),(1644,638326815,5),(1644,654656415,6),(1644,670381216,5),(1644,686106016,6),(1644,701830816,5),(1644,717555617,6),(1644,733280417,5),(1644,749005218,6),(1644,764730018,5),(1644,780454819,6),(1644,796179619,5),(1644,811904419,6),(1644,828234020,5),(1644,846378020,6),(1644,859683620,5),(1644,877827621,6),(1644,891133221,5),(1644,909277221,6),(1644,922582822,5),(1644,941331622,6),(1644,954032422,5),(1644,972781222,6),(1644,985482022,5),(1644,1004230822,6),(1644,1017536422,5),(1644,1035680422,6),(1644,1048986022,5),(1644,1067130022,6),(1644,1080435622,5),(1644,1099184422,6),(1644,1111885222,5),(1644,1130634022,6),(1644,1143334823,5),(1644,1162083623,6),(1644,1174784423,5),(1644,1193533223,6),(1644,1206838823,5),(1644,1224982823,6),(1644,1238288424,5),(1644,1256432424,6),(1644,1269738024,5),(1644,1288486824,6),(1644,1301187624,5),(1644,1319936424,6),(1644,1332637224,5),(1644,1351386025,6),(1644,1364691625,5),(1644,1382835625,6),(1644,1396141225,5),(1644,1414285225,6),(1644,1427590825,5),(1644,1445734826,6),(1644,1459040426,5),(1644,1477789226,6),(1644,1490490027,5),(1644,1509238827,6),(1644,1521939627,5),(1644,1540688427,6),(1644,1553994027,5),(1644,1572138027,6),(1644,1585443627,5),(1644,1603587627,6),(1644,1616893227,5),(1644,1635642027,6),(1644,1648342827,5),(1644,1667091627,6),(1644,1679792427,5),(1644,1698541227,6),(1644,1711846827,5),(1644,1729990827,6),(1644,1743296427,5),(1644,1761440427,6),(1644,1774746027,5),(1644,1792890027,6),(1644,1806195627,5),(1644,1824944427,6),(1644,1837645227,5),(1644,1856394027,6),(1644,1869094827,5),(1644,1887843627,6),(1644,1901149227,5),(1644,1919293227,6),(1644,1932598827,5),(1644,1950742827,6),(1644,1964048427,5),(1644,1982797227,6),(1644,1995498027,5),(1644,2014246827,6),(1644,2026947627,5),(1644,2045696427,6),(1644,2058397227,5),(1644,2077146027,6),(1644,2090451627,5),(1644,2108595627,6),(1644,2121901227,5),(1644,2140045227,6),(1645,-2147483648,2),(1645,-1693706400,1),(1645,-1680483600,2),(1645,-1663455600,3),(1645,-1650150000,4),(1645,-1632006000,3),(1645,-1618700400,4),(1645,-938905200,3),(1645,-857257200,4),(1645,-844556400,3),(1645,-828226800,4),(1645,-812502000,3),(1645,-796777200,4),(1645,-781052400,3),(1645,-776563200,5),(1645,-765936000,1),(1645,-761180400,4),(1645,-757386000,2),(1645,-748479600,3),(1645,-733273200,4),(1645,-717631200,3),(1645,-714610800,6),(1645,-710380800,1),(1645,-701910000,4),(1645,-684975600,3),(1645,-670460400,4),(1645,-654130800,3),(1645,-639010800,4),(1645,315529208,2),(1645,323830809,7),(1645,338950809,8),(1645,354675609,7),(1645,370400410,8),(1645,386125210,7),(1645,401850011,8),(1645,417574811,7),(1645,433299612,8),(1645,449024412,7),(1645,465354012,8),(1645,481078812,7),(1645,496803613,8),(1645,512528413,7),(1645,528253213,8),(1645,543978013,7),(1645,559702813,8),(1645,575427614,7),(1645,591152414,8),(1645,606877214,7),(1645,622602014,8),(1645,638326815,7),(1645,654656415,8),(1645,670381216,7),(1645,686106016,8),(1645,701830816,7),(1645,717555617,8),(1645,733280417,7),(1645,749005218,8),(1645,764730018,7),(1645,780454819,8),(1645,796179619,7),(1645,811904419,8),(1645,828234020,7),(1645,846378020,8),(1645,859683620,7),(1645,877827621,8),(1645,891133221,7),(1645,909277221,8),(1645,922582822,7),(1645,941331622,8),(1645,954032422,7),(1645,972781222,8),(1645,985482022,7),(1645,1004230822,8),(1645,1017536422,7),(1645,1035680422,8),(1645,1048986022,7),(1645,1067130022,8),(1645,1080435622,7),(1645,1099184422,8),(1645,1111885222,7),(1645,1130634022,8),(1645,1143334823,7),(1645,1162083623,8),(1645,1174784423,7),(1645,1193533223,8),(1645,1206838823,7),(1645,1224982823,8),(1645,1238288424,7),(1645,1256432424,8),(1645,1269738024,7),(1645,1288486824,8),(1645,1301187624,7),(1645,1319936424,8),(1645,1332637224,7),(1645,1351386025,8),(1645,1364691625,7),(1645,1382835625,8),(1645,1396141225,7),(1645,1414285225,8),(1645,1427590825,7),(1645,1445734826,8),(1645,1459040426,7),(1645,1477789226,8),(1645,1490490027,7),(1645,1509238827,8),(1645,1521939627,7),(1645,1540688427,8),(1645,1553994027,7),(1645,1572138027,8),(1645,1585443627,7),(1645,1603587627,8),(1645,1616893227,7),(1645,1635642027,8),(1645,1648342827,7),(1645,1667091627,8),(1645,1679792427,7),(1645,1698541227,8),(1645,1711846827,7),(1645,1729990827,8),(1645,1743296427,7),(1645,1761440427,8),(1645,1774746027,7),(1645,1792890027,8),(1645,1806195627,7),(1645,1824944427,8),(1645,1837645227,7),(1645,1856394027,8),(1645,1869094827,7),(1645,1887843627,8),(1645,1901149227,7),(1645,1919293227,8),(1645,1932598827,7),(1645,1950742827,8),(1645,1964048427,7),(1645,1982797227,8),(1645,1995498027,7),(1645,2014246827,8),(1645,2026947627,7),(1645,2045696427,8),(1645,2058397227,7),(1645,2077146027,8),(1645,2090451627,7),(1645,2108595627,8),(1645,2121901227,7),(1645,2140045227,8),(1646,-2147483648,2),(1646,-1693706400,1),(1646,-1680483600,2),(1646,-1663455600,3),(1646,-1650150000,4),(1646,-1632006000,3),(1646,-1618700400,4),(1646,-938905200,3),(1646,-857257200,4),(1646,-844556400,3),(1646,-828226800,4),(1646,-812502000,3),(1646,-796777200,4),(1646,-781052400,3),(1646,-777866400,1),(1646,-765327600,4),(1646,-746578800,3),(1646,-733359600,4),(1646,-728517600,5),(1646,-721260000,2),(1646,-716425200,3),(1646,-701910000,4),(1646,-684975600,3),(1646,-670460400,4),(1646,-654217200,3),(1646,-639010800,4),(1646,283993207,2),(1646,291776408,6),(1646,307501208,7),(1646,323830809,6),(1646,338950809,7),(1646,354675609,6),(1646,370400410,7),(1646,386125210,6),(1646,401850011,7),(1646,417574811,6),(1646,433299612,7),(1646,449024412,6),(1646,465354012,7),(1646,481078812,6),(1646,496803613,7),(1646,512528413,6),(1646,528253213,7),(1646,543978013,6),(1646,559702813,7),(1646,575427614,6),(1646,591152414,7),(1646,606877214,6),(1646,622602014,7),(1646,638326815,6),(1646,654656415,7),(1646,670381216,6),(1646,686106016,7),(1646,701830816,6),(1646,717555617,7),(1646,733280417,6),(1646,749005218,7),(1646,764730018,6),(1646,780454819,7),(1646,796179619,6),(1646,811904419,7),(1646,828234020,6),(1646,846378020,7),(1646,859683620,6),(1646,877827621,7),(1646,891133221,6),(1646,909277221,7),(1646,922582822,6),(1646,941331622,7),(1646,954032422,6),(1646,972781222,7),(1646,985482022,6),(1646,1004230822,7),(1646,1017536422,6),(1646,1035680422,7),(1646,1048986022,6),(1646,1067130022,7),(1646,1080435622,6),(1646,1099184422,7),(1646,1111885222,6),(1646,1130634022,7),(1646,1143334823,6),(1646,1162083623,7),(1646,1174784423,6),(1646,1193533223,7),(1646,1206838823,6),(1646,1224982823,7),(1646,1238288424,6),(1646,1256432424,7),(1646,1269738024,6),(1646,1288486824,7),(1646,1301187624,6),(1646,1319936424,7),(1646,1332637224,6),(1646,1351386025,7),(1646,1364691625,6),(1646,1382835625,7),(1646,1396141225,6),(1646,1414285225,7),(1646,1427590825,6),(1646,1445734826,7),(1646,1459040426,6),(1646,1477789226,7),(1646,1490490027,6),(1646,1509238827,7),(1646,1521939627,6),(1646,1540688427,7),(1646,1553994027,6),(1646,1572138027,7),(1646,1585443627,6),(1646,1603587627,7),(1646,1616893227,6),(1646,1635642027,7),(1646,1648342827,6),(1646,1667091627,7),(1646,1679792427,6),(1646,1698541227,7),(1646,1711846827,6),(1646,1729990827,7),(1646,1743296427,6),(1646,1761440427,7),(1646,1774746027,6),(1646,1792890027,7),(1646,1806195627,6),(1646,1824944427,7),(1646,1837645227,6),(1646,1856394027,7),(1646,1869094827,6),(1646,1887843627,7),(1646,1901149227,6),(1646,1919293227,7),(1646,1932598827,6),(1646,1950742827,7),(1646,1964048427,6),(1646,1982797227,7),(1646,1995498027,6),(1646,2014246827,7),(1646,2026947627,6),(1646,2045696427,7),(1646,2058397227,6),(1646,2077146027,7),(1646,2090451627,6),(1646,2108595627,7),(1646,2121901227,6),(1646,2140045227,7),(1647,-2147483648,1),(1647,-1740355200,2),(1647,-1693702800,5),(1647,-1680483600,2),(1647,-1663455600,3),(1647,-1650150000,4),(1647,-1632006000,3),(1647,-1618700400,4),(1647,-1613826000,8),(1647,-1604278800,6),(1647,-1585530000,7),(1647,-1574038800,6),(1647,-1552266000,7),(1647,-1539997200,6),(1647,-1520557200,7),(1647,-1507510800,6),(1647,-1490576400,7),(1647,-1473642000,6),(1647,-1459126800,7),(1647,-1444006800,6),(1647,-1427677200,7),(1647,-1411952400,6),(1647,-1396227600,7),(1647,-1379293200,6),(1647,-1364778000,7),(1647,-1348448400,6),(1647,-1333328400,7),(1647,-1316394000,6),(1647,-1301263200,7),(1647,-1284328800,6),(1647,-1269813600,7),(1647,-1253484000,6),(1647,-1238364000,7),(1647,-1221429600,6),(1647,-1206914400,7),(1647,-1191189600,6),(1647,-1175464800,7),(1647,-1160344800,6),(1647,-1143410400,7),(1647,-1127685600,6),(1647,-1111960800,7),(1647,-1096840800,6),(1647,-1080511200,7),(1647,-1063576800,6),(1647,-1049061600,7),(1647,-1033336800,6),(1647,-1017612000,7),(1647,-1002492000,6),(1647,-986162400,7),(1647,-969228000,6),(1647,-950479200,7),(1647,-942012000,6),(1647,-934668000,3),(1647,-857257200,4),(1647,-844556400,3),(1647,-828226800,4),(1647,-812502000,3),(1647,-799293600,5),(1647,-798073200,4),(1647,-781052400,3),(1647,-766623600,4),(1647,-745455600,3),(1647,-733273200,4),(1647,220921205,2),(1647,228877206,9),(1647,243997206,10),(1647,260326807,9),(1647,276051607,10),(1647,291776408,9),(1647,307501208,10),(1647,323830809,9),(1647,338950809,10),(1647,354675609,9),(1647,370400410,10),(1647,386125210,9),(1647,401850011,10),(1647,417574811,9),(1647,433299612,10),(1647,449024412,9),(1647,465354012,10),(1647,481078812,9),(1647,496803613,10),(1647,512528413,9),(1647,528253213,10),(1647,543978013,9),(1647,559702813,10),(1647,575427614,9),(1647,591152414,10),(1647,606877214,9),(1647,622602014,10),(1647,638326815,9),(1647,654656415,10),(1647,670381216,9),(1647,686106016,10),(1647,701830816,9),(1647,717555617,10),(1647,733280417,9),(1647,749005218,10),(1647,764730018,9),(1647,780454819,10),(1647,796179619,9),(1647,811904419,10),(1647,828234020,9),(1647,846378020,10),(1647,859683620,9),(1647,877827621,10),(1647,891133221,9),(1647,909277221,10),(1647,922582822,9),(1647,941331622,10),(1647,954032422,9),(1647,972781222,10),(1647,985482022,9),(1647,1004230822,10),(1647,1017536422,9),(1647,1035680422,10),(1647,1048986022,9),(1647,1067130022,10),(1647,1080435622,9),(1647,1099184422,10),(1647,1111885222,9),(1647,1130634022,10),(1647,1143334823,9),(1647,1162083623,10),(1647,1174784423,9),(1647,1193533223,10),(1647,1206838823,9),(1647,1224982823,10),(1647,1238288424,9),(1647,1256432424,10),(1647,1269738024,9),(1647,1288486824,10),(1647,1301187624,9),(1647,1319936424,10),(1647,1332637224,9),(1647,1351386025,10),(1647,1364691625,9),(1647,1382835625,10),(1647,1396141225,9),(1647,1414285225,10),(1647,1427590825,9),(1647,1445734826,10),(1647,1459040426,9),(1647,1477789226,10),(1647,1490490027,9),(1647,1509238827,10),(1647,1521939627,9),(1647,1540688427,10),(1647,1553994027,9),(1647,1572138027,10),(1647,1585443627,9),(1647,1603587627,10),(1647,1616893227,9),(1647,1635642027,10),(1647,1648342827,9),(1647,1667091627,10),(1647,1679792427,9),(1647,1698541227,10),(1647,1711846827,9),(1647,1729990827,10),(1647,1743296427,9),(1647,1761440427,10),(1647,1774746027,9),(1647,1792890027,10),(1647,1806195627,9),(1647,1824944427,10),(1647,1837645227,9),(1647,1856394027,10),(1647,1869094827,9),(1647,1887843627,10),(1647,1901149227,9),(1647,1919293227,10),(1647,1932598827,9),(1647,1950742827,10),(1647,1964048427,9),(1647,1982797227,10),(1647,1995498027,9),(1647,2014246827,10),(1647,2026947627,9),(1647,2045696427,10),(1647,2058397227,9),(1647,2077146027,10),(1647,2090451627,9),(1647,2108595627,10),(1647,2121901227,9),(1647,2140045227,10),(1648,-2147483648,1),(1648,-1213148664,5),(1648,-1187056800,2),(1648,-1175479200,3),(1648,-1159754400,2),(1648,-1144029600,3),(1648,-1127700000,2),(1648,-1111975200,3),(1648,-1096250400,2),(1648,-1080525600,3),(1648,-1064800800,2),(1648,-1049076000,3),(1648,-1033351200,2),(1648,-1017626400,3),(1648,-1001901600,2),(1648,-986176800,3),(1648,-970452000,2),(1648,-954727200,3),(1648,296604008,4),(1648,307486808,5),(1648,323816409,4),(1648,338940009,5),(1648,354672009,2),(1648,370396810,3),(1648,386121610,2),(1648,401846411,3),(1648,417571211,2),(1648,433296012,3),(1648,449020812,2),(1648,465350412,3),(1648,481075212,2),(1648,496800013,3),(1648,512524813,2),(1648,528249613,3),(1648,543974413,2),(1648,559699213,3),(1648,575424014,2),(1648,591148814,3),(1648,606873614,2),(1648,622598414,3),(1648,638323215,2),(1648,654652815,3),(1648,662680815,5),(1648,670370416,2),(1648,686095216,3),(1648,701820016,2),(1648,717544817,3),(1648,733269617,2),(1648,748994418,3),(1648,757375218,5),(1648,764719218,4),(1648,780440419,5),(1648,796168819,4),(1648,811890019,5),(1648,828223220,4),(1648,846363620,5),(1648,859683620,6),(1648,877827621,7),(1648,891133221,6),(1648,909277221,7),(1648,922582822,6),(1648,941331622,7),(1648,954032422,6),(1648,972781222,7),(1648,985482022,6),(1648,1004230822,7),(1648,1017536422,6),(1648,1035680422,7),(1648,1048986022,6),(1648,1067130022,7),(1648,1080435622,6),(1648,1099184422,7),(1648,1111885222,6),(1648,1130634022,7),(1648,1143334823,6),(1648,1162083623,7),(1648,1174784423,6),(1648,1193533223,7),(1648,1206838823,6),(1648,1224982823,7),(1648,1238288424,6),(1648,1256432424,7),(1648,1269738024,6),(1648,1288486824,7),(1648,1301187624,6),(1648,1319936424,7),(1648,1332637224,6),(1648,1351386025,7),(1648,1364691625,6),(1648,1382835625,7),(1648,1396141225,6),(1648,1414285225,7),(1648,1427590825,6),(1648,1445734826,7),(1648,1459040426,6),(1648,1477789226,7),(1648,1490490027,6),(1648,1509238827,7),(1648,1521939627,6),(1648,1540688427,7),(1648,1553994027,6),(1648,1572138027,7),(1648,1585443627,6),(1648,1603587627,7),(1648,1616893227,6),(1648,1635642027,7),(1648,1648342827,6),(1648,1667091627,7),(1648,1679792427,6),(1648,1698541227,7),(1648,1711846827,6),(1648,1729990827,7),(1648,1743296427,6),(1648,1761440427,7),(1648,1774746027,6),(1648,1792890027,7),(1648,1806195627,6),(1648,1824944427,7),(1648,1837645227,6),(1648,1856394027,7),(1648,1869094827,6),(1648,1887843627,7),(1648,1901149227,6),(1648,1919293227,7),(1648,1932598827,6),(1648,1950742827,7),(1648,1964048427,6),(1648,1982797227,7),(1648,1995498027,6),(1648,2014246827,7),(1648,2026947627,6),(1648,2045696427,7),(1648,2058397227,6),(1648,2077146027,7),(1648,2090451627,6),(1648,2108595627,7),(1648,2121901227,6),(1648,2140045227,7),(1649,-2147483648,2),(1649,-1693706400,1),(1649,-1680483600,2),(1649,-1663455600,3),(1649,-1650150000,4),(1649,-1640998800,2),(1649,-1633212000,1),(1649,-1618700400,2),(1649,-1600466400,1),(1649,-1581202800,2),(1649,-906771600,1),(1649,-857257200,4),(1649,-844556400,3),(1649,-828226800,4),(1649,-812502000,3),(1649,-796777200,4),(1649,-788922000,2),(1649,-778471200,1),(1649,-762660000,2),(1649,-749689200,3),(1649,-733359600,4),(1649,-717634800,3),(1649,-701910000,4),(1649,-686185200,3),(1649,-670460400,4),(1649,-654130800,3),(1649,-639010800,4),(1649,-621990000,3),(1649,-605660400,4),(1649,-492656400,1),(1649,-481168800,2),(1649,-461120400,1),(1649,-449632800,2),(1649,-428547600,1),(1649,-418269600,2),(1649,-397094400,1),(1649,-386809200,2),(1649,323827209,1),(1649,338950809,5),(1649,354675609,6),(1649,370400410,5),(1649,386125210,6),(1649,401850011,5),(1649,417574811,6),(1649,433299612,5),(1649,449024412,6),(1649,465354012,5),(1649,481078812,6),(1649,496803613,5),(1649,512528413,6),(1649,528253213,5),(1649,543978013,6),(1649,559702813,5),(1649,575427614,6),(1649,591152414,5),(1649,606877214,6),(1649,622602014,5),(1649,638326815,6),(1649,654656415,5),(1649,670381216,6),(1649,686106016,5),(1649,701830816,6),(1649,717555617,5),(1649,733280417,6),(1649,749005218,5),(1649,764730018,6),(1649,780454819,5),(1649,796179619,6),(1649,811904419,5),(1649,828234020,6),(1649,846378020,5),(1649,859683620,6),(1649,877827621,5),(1649,891133221,6),(1649,909277221,5),(1649,922582822,6),(1649,941331622,5),(1649,954032422,6),(1649,972781222,5),(1649,985482022,6),(1649,1004230822,5),(1649,1017536422,6),(1649,1035680422,5),(1649,1048986022,6),(1649,1067130022,5),(1649,1080435622,6),(1649,1099184422,5),(1649,1111885222,6),(1649,1130634022,5),(1649,1143334823,6),(1649,1162083623,5),(1649,1174784423,6),(1649,1193533223,5),(1649,1206838823,6),(1649,1224982823,5),(1649,1238288424,6),(1649,1256432424,5),(1649,1269738024,6),(1649,1288486824,5),(1649,1301187624,6),(1649,1319936424,5),(1649,1332637224,6),(1649,1351386025,5),(1649,1364691625,6),(1649,1382835625,5),(1649,1396141225,6),(1649,1414285225,5),(1649,1427590825,6),(1649,1445734826,5),(1649,1459040426,6),(1649,1477789226,5),(1649,1490490027,6),(1649,1509238827,5),(1649,1521939627,6),(1649,1540688427,5),(1649,1553994027,6),(1649,1572138027,5),(1649,1585443627,6),(1649,1603587627,5),(1649,1616893227,6),(1649,1635642027,5),(1649,1648342827,6),(1649,1667091627,5),(1649,1679792427,6),(1649,1698541227,5),(1649,1711846827,6),(1649,1729990827,5),(1649,1743296427,6),(1649,1761440427,5),(1649,1774746027,6),(1649,1792890027,5),(1649,1806195627,6),(1649,1824944427,5),(1649,1837645227,6),(1649,1856394027,5),(1649,1869094827,6),(1649,1887843627,5),(1649,1901149227,6),(1649,1919293227,5),(1649,1932598827,6),(1649,1950742827,5),(1649,1964048427,6),(1649,1982797227,5),(1649,1995498027,6),(1649,2014246827,5),(1649,2026947627,6),(1649,2045696427,5),(1649,2058397227,6),(1649,2077146027,5),(1649,2090451627,6),(1649,2108595627,5),(1649,2121901227,6),(1649,2140045227,5),(1650,-2147483648,2),(1650,-904435200,1),(1650,-891129600,2),(1650,-872985600,1),(1650,-859680000,2),(1650,354675609,3),(1650,370400410,4),(1650,386125210,3),(1650,401850011,4),(1650,417574811,3),(1650,433299612,4),(1650,449024412,3),(1650,465354012,4),(1650,481078812,3),(1650,496803613,4),(1650,512528413,3),(1650,528253213,4),(1650,543978013,3),(1650,559702813,4),(1650,575427614,3),(1650,591152414,4),(1650,606877214,3),(1650,622602014,4),(1650,638326815,3),(1650,654656415,4),(1650,670381216,3),(1650,686106016,4),(1650,701830816,3),(1650,717555617,4),(1650,733280417,3),(1650,749005218,4),(1650,764730018,3),(1650,780454819,4),(1650,796179619,3),(1650,811904419,4),(1650,828234020,3),(1650,846378020,4),(1650,859683620,3),(1650,877827621,4),(1650,891133221,3),(1650,909277221,4),(1650,922582822,3),(1650,941331622,4),(1650,954032422,3),(1650,972781222,4),(1650,985482022,3),(1650,1004230822,4),(1650,1017536422,3),(1650,1035680422,4),(1650,1048986022,3),(1650,1067130022,4),(1650,1080435622,3),(1650,1099184422,4),(1650,1111885222,3),(1650,1130634022,4),(1650,1143334823,3),(1650,1162083623,4),(1650,1174784423,3),(1650,1193533223,4),(1650,1206838823,3),(1650,1224982823,4),(1650,1238288424,3),(1650,1256432424,4),(1650,1269738024,3),(1650,1288486824,4),(1650,1301187624,3),(1650,1319936424,4),(1650,1332637224,3),(1650,1351386025,4),(1650,1364691625,3),(1650,1382835625,4),(1650,1396141225,3),(1650,1414285225,4),(1650,1427590825,3),(1650,1445734826,4),(1650,1459040426,3),(1650,1477789226,4),(1650,1490490027,3),(1650,1509238827,4),(1650,1521939627,3),(1650,1540688427,4),(1650,1553994027,3),(1650,1572138027,4),(1650,1585443627,3),(1650,1603587627,4),(1650,1616893227,3),(1650,1635642027,4),(1650,1648342827,3),(1650,1667091627,4),(1650,1679792427,3),(1650,1698541227,4),(1650,1711846827,3),(1650,1729990827,4),(1650,1743296427,3),(1650,1761440427,4),(1650,1774746027,3),(1650,1792890027,4),(1650,1806195627,3),(1650,1824944427,4),(1650,1837645227,3),(1650,1856394027,4),(1650,1869094827,3),(1650,1887843627,4),(1650,1901149227,3),(1650,1919293227,4),(1650,1932598827,3),(1650,1950742827,4),(1650,1964048427,3),(1650,1982797227,4),(1650,1995498027,3),(1650,2014246827,4),(1650,2026947627,3),(1650,2045696427,4),(1650,2058397227,3),(1650,2077146027,4),(1650,2090451627,3),(1650,2108595627,4),(1650,2121901227,3),(1650,2140045227,4),(1651,-2147483648,1),(1651,-1637114100,2),(1651,-1213148664,5),(1651,-1187056800,3),(1651,-1175479200,4),(1651,-1159754400,3),(1651,-1144029600,4),(1651,-1127700000,3),(1651,-1111975200,4),(1651,-1096250400,3),(1651,-1080525600,4),(1651,-1064800800,3),(1651,-1049076000,4),(1651,-1033351200,3),(1651,-1017626400,4),(1651,-1001901600,3),(1651,-986176800,4),(1651,-970452000,3),(1651,-954727200,4),(1651,-927165600,6),(1651,-898138800,9),(1651,-857257200,7),(1651,-844556400,8),(1651,-828226800,7),(1651,-812502000,8),(1651,-800157600,11),(1651,354920409,10),(1651,370728010,11),(1651,386456410,10),(1651,402264011,11),(1651,417992411,10),(1651,433800012,11),(1651,449614812,10),(1651,465346812,12),(1651,481071612,13),(1651,496796413,12),(1651,512521213,13),(1651,528246013,12),(1651,543970813,13),(1651,559695613,12),(1651,575420414,13),(1651,591145214,12),(1651,606870014,13),(1651,622594814,12),(1651,638319615,13),(1651,641944815,6),(1651,654652815,4),(1651,670377616,3),(1651,686102416,4),(1651,694216816,5),(1651,701820016,6),(1651,717541217,5),(1651,733269617,6),(1651,748990818,5),(1651,764719218,6),(1651,780440419,5),(1651,796168819,6),(1651,811890019,5),(1651,828223220,6),(1651,846363620,5),(1651,859680020,6),(1651,877824021,5),(1651,891129621,6),(1651,909273621,5),(1651,922579222,6),(1651,941328022,5),(1651,954028822,6),(1651,972777622,5),(1651,985478422,6),(1651,1004227222,5),(1651,1017532822,6),(1651,1035676822,5),(1651,1048982422,6),(1651,1067126422,5),(1651,1080432022,6),(1651,1099180822,5),(1651,1111881622,6),(1651,1130630422,5),(1651,1143331223,6),(1651,1162080023,5),(1651,1174780823,6),(1651,1193529623,5),(1651,1206835223,6),(1651,1224979223,5),(1651,1238284824,6),(1651,1256428824,5),(1651,1269734424,6),(1651,1288483224,5),(1651,1301184024,6),(1651,1319932824,5),(1651,1332633624,6),(1651,1351382425,5),(1651,1364688025,6),(1651,1382832025,5),(1651,1396137625,6),(1651,1414281625,5),(1651,1427587225,6),(1651,1445731226,5),(1651,1459036826,6),(1651,1477785626,5),(1651,1490486427,6),(1651,1509235227,5),(1651,1521936027,6),(1651,1540684827,5),(1651,1553990427,6),(1651,1572134427,5),(1651,1585440027,6),(1651,1603584027,5),(1651,1616889627,6),(1651,1635638427,5),(1651,1648339227,6),(1651,1667088027,5),(1651,1679788827,6),(1651,1698537627,5),(1651,1711843227,6),(1651,1729987227,5),(1651,1743292827,6),(1651,1761436827,5),(1651,1774742427,6),(1651,1792886427,5),(1651,1806192027,6),(1651,1824940827,5),(1651,1837641627,6),(1651,1856390427,5),(1651,1869091227,6),(1651,1887840027,5),(1651,1901145627,6),(1651,1919289627,5),(1651,1932595227,6),(1651,1950739227,5),(1651,1964044827,6),(1651,1982793627,5),(1651,1995494427,6),(1651,2014243227,5),(1651,2026944027,6),(1651,2045692827,5),(1651,2058393627,6),(1651,2077142427,5),(1651,2090448027,6),(1651,2108592027,5),(1651,2121897627,6),(1651,2140041627,5),(1652,-2147483648,2),(1652,-1692496800,1),(1652,-1680490800,2),(1652,-935110800,1),(1652,-857257200,3),(1652,-844556400,4),(1652,-828226800,3),(1652,-812502000,4),(1652,-796777200,3),(1652,-781052400,4),(1652,-769388400,3),(1652,-747010800,4),(1652,-736383600,3),(1652,-715215600,4),(1652,-706748400,3),(1652,-683161200,4),(1652,-675298800,3),(1652,315529208,2),(1652,323830809,5),(1652,338950809,6),(1652,354675609,5),(1652,370400410,6),(1652,386125210,5),(1652,401850011,6),(1652,417574811,5),(1652,433299612,6),(1652,449024412,5),(1652,465354012,6),(1652,481078812,5),(1652,496803613,6),(1652,512528413,5),(1652,528253213,6),(1652,543978013,5),(1652,559702813,6),(1652,575427614,5),(1652,591152414,6),(1652,606877214,5),(1652,622602014,6),(1652,638326815,5),(1652,654656415,6),(1652,670381216,5),(1652,686106016,6),(1652,701830816,5),(1652,717555617,6),(1652,733280417,5),(1652,749005218,6),(1652,764730018,5),(1652,780454819,6),(1652,796179619,5),(1652,811904419,6),(1652,828234020,5),(1652,846378020,6),(1652,859683620,5),(1652,877827621,6),(1652,891133221,5),(1652,909277221,6),(1652,922582822,5),(1652,941331622,6),(1652,954032422,5),(1652,972781222,6),(1652,985482022,5),(1652,1004230822,6),(1652,1017536422,5),(1652,1035680422,6),(1652,1048986022,5),(1652,1067130022,6),(1652,1080435622,5),(1652,1099184422,6),(1652,1111885222,5),(1652,1130634022,6),(1652,1143334823,5),(1652,1162083623,6),(1652,1174784423,5),(1652,1193533223,6),(1652,1206838823,5),(1652,1224982823,6),(1652,1238288424,5),(1652,1256432424,6),(1652,1269738024,5),(1652,1288486824,6),(1652,1301187624,5),(1652,1319936424,6),(1652,1332637224,5),(1652,1351386025,6),(1652,1364691625,5),(1652,1382835625,6),(1652,1396141225,5),(1652,1414285225,6),(1652,1427590825,5),(1652,1445734826,6),(1652,1459040426,5),(1652,1477789226,6),(1652,1490490027,5),(1652,1509238827,6),(1652,1521939627,5),(1652,1540688427,6),(1652,1553994027,5),(1652,1572138027,6),(1652,1585443627,5),(1652,1603587627,6),(1652,1616893227,5),(1652,1635642027,6),(1652,1648342827,5),(1652,1667091627,6),(1652,1679792427,5),(1652,1698541227,6),(1652,1711846827,5),(1652,1729990827,6),(1652,1743296427,5),(1652,1761440427,6),(1652,1774746027,5),(1652,1792890027,6),(1652,1806195627,5),(1652,1824944427,6),(1652,1837645227,5),(1652,1856394027,6),(1652,1869094827,5),(1652,1887843627,6),(1652,1901149227,5),(1652,1919293227,6),(1652,1932598827,5),(1652,1950742827,6),(1652,1964048427,5),(1652,1982797227,6),(1652,1995498027,5),(1652,2014246827,6),(1652,2026947627,5),(1652,2045696427,6),(1652,2058397227,5),(1652,2077146027,6),(1652,2090451627,5),(1652,2108595627,6),(1652,2121901227,5),(1652,2140045227,6),(1653,-2147483648,1),(1653,-1691962479,2),(1653,-1680471279,4),(1653,-1664143200,3),(1653,-1650146400,4),(1653,-1633903200,3),(1653,-1617487200,4),(1653,-1601848800,3),(1653,-1586037600,4),(1653,-1570399200,3),(1653,-1552168800,4),(1653,-1538344800,3),(1653,-1522533600,4),(1653,-1517011200,6),(1653,-1507500000,5),(1653,-1490565600,4),(1653,-1473631200,5),(1653,-1460930400,4),(1653,-1442786400,5),(1653,-1428876000,4),(1653,-1410732000,5),(1653,-1396216800,4),(1653,-1379282400,5),(1653,-1364767200,4),(1653,-1348437600,5),(1653,-1333317600,4),(1653,-1315778400,5),(1653,-1301263200,4),(1653,-1284328800,5),(1653,-1269813600,4),(1653,-1253484000,5),(1653,-1238364000,4),(1653,-1221429600,5),(1653,-1206914400,4),(1653,-1189980000,5),(1653,-1175464800,4),(1653,-1159135200,5),(1653,-1143410400,4),(1653,-1126476000,5),(1653,-1111960800,4),(1653,-1095631200,5),(1653,-1080511200,4),(1653,-1063576800,5),(1653,-1049061600,4),(1653,-1032127200,5),(1653,-1017612000,4),(1653,-1001282400,5),(1653,-986162400,4),(1653,-969228000,5),(1653,-950479200,4),(1653,-942012000,5),(1653,-733356000,4),(1653,-719445600,5),(1653,-699487200,4),(1653,-684972000,5),(1653,-668037600,4),(1653,-654732000,5),(1653,-636588000,4),(1653,-622072800,5),(1653,-605743200,4),(1653,-590623200,5),(1653,-574293600,4),(1653,-558568800,5),(1653,-542239200,4),(1653,-527119200,5),(1653,-512604000,4),(1653,-496274400,5),(1653,-481154400,4),(1653,-464220000,5),(1653,-449704800,4),(1653,-432165600,5),(1653,-417650400,4),(1653,-401320800,5),(1653,-386200800,4),(1653,-369266400,5),(1653,-354751200,4),(1653,-337816800,5),(1653,-323301600,4),(1653,-306972000,5),(1653,-291852000,4),(1653,-276732000,5),(1653,-257983200,4),(1653,-245282400,5),(1653,-226533600,4),(1653,-213228000,5),(1653,-195084000,4),(1653,-182383200,5),(1653,-163634400,4),(1653,-150933600,5),(1653,-132184800,4),(1653,-119484000,5),(1653,-100735200,4),(1653,-88034400,5),(1653,-68680800,4),(1653,-59004000,5),(1653,-37242000,9),(1653,57722400,7),(1653,69818400,8),(1653,89172001,7),(1653,101268002,8),(1653,120621602,7),(1653,132717603,8),(1653,152071203,7),(1653,164167204,8),(1653,183520804,7),(1653,196221605,8),(1653,214970405,7),(1653,227671206,8),(1653,246420006,7),(1653,259120807,8),(1653,278474407,7),(1653,290570408,8),(1653,309924008,7),(1653,322020009,8),(1653,341373609,7),(1653,354675609,8),(1653,372819610,7),(1653,386125210,8),(1653,404269211,7),(1653,417574811,8),(1653,435718812,7),(1653,449024412,8),(1653,467773212,7),(1653,481078812,8),(1653,499222813,7),(1653,512528413,8),(1653,530672413,7),(1653,543978013,8),(1653,562122013,7),(1653,575427614,8),(1653,593571614,7),(1653,606877214,8),(1653,625626014,7),(1653,638326815,8),(1653,657075615,7),(1653,670381216,8),(1653,688525216,7),(1653,701830816,8),(1653,719974817,7),(1653,733280417,8),(1653,751424418,7),(1653,764730018,8),(1653,782874019,7),(1653,796179619,8),(1653,814323619,7),(1653,828234020,8),(1653,846378020,7),(1653,859683620,8),(1653,877827621,7),(1653,891133221,8),(1653,909277221,7),(1653,922582822,8),(1653,941331622,7),(1653,954032422,8),(1653,972781222,7),(1653,985482022,8),(1653,1004230822,7),(1653,1017536422,8),(1653,1035680422,7),(1653,1048986022,8),(1653,1067130022,7),(1653,1080435622,8),(1653,1099184422,7),(1653,1111885222,8),(1653,1130634022,7),(1653,1143334823,8),(1653,1162083623,7),(1653,1174784423,8),(1653,1193533223,7),(1653,1206838823,8),(1653,1224982823,7),(1653,1238288424,8),(1653,1256432424,7),(1653,1269738024,8),(1653,1288486824,7),(1653,1301187624,8),(1653,1319936424,7),(1653,1332637224,8),(1653,1351386025,7),(1653,1364691625,8),(1653,1382835625,7),(1653,1396141225,8),(1653,1414285225,7),(1653,1427590825,8),(1653,1445734826,7),(1653,1459040426,8),(1653,1477789226,7),(1653,1490490027,8),(1653,1509238827,7),(1653,1521939627,8),(1653,1540688427,7),(1653,1553994027,8),(1653,1572138027,7),(1653,1585443627,8),(1653,1603587627,7),(1653,1616893227,8),(1653,1635642027,7),(1653,1648342827,8),(1653,1667091627,7),(1653,1679792427,8),(1653,1698541227,7),(1653,1711846827,8),(1653,1729990827,7),(1653,1743296427,8),(1653,1761440427,7),(1653,1774746027,8),(1653,1792890027,7),(1653,1806195627,8),(1653,1824944427,7),(1653,1837645227,8),(1653,1856394027,7),(1653,1869094827,8),(1653,1887843627,7),(1653,1901149227,8),(1653,1919293227,7),(1653,1932598827,8),(1653,1950742827,7),(1653,1964048427,8),(1653,1982797227,7),(1653,1995498027,8),(1653,2014246827,7),(1653,2026947627,8),(1653,2045696427,7),(1653,2058397227,8),(1653,2077146027,7),(1653,2090451627,8),(1653,2108595627,7),(1653,2121901227,8),(1653,2140045227,7),(1654,-2147483648,2),(1654,-1691964000,1),(1654,-1680472800,2),(1654,-1664143200,1),(1654,-1650146400,2),(1654,-1633903200,1),(1654,-1617487200,2),(1654,-1601848800,1),(1654,-1586037600,2),(1654,-1570399200,1),(1654,-1552168800,2),(1654,-1538344800,1),(1654,-1522533600,2),(1654,-1507500000,1),(1654,-1490565600,2),(1654,-1473631200,1),(1654,-1460930400,2),(1654,-1442786400,1),(1654,-1428876000,2),(1654,-1410732000,1),(1654,-1396216800,2),(1654,-1379282400,1),(1654,-1364767200,2),(1654,-1348437600,1),(1654,-1333317600,2),(1654,-1315778400,1),(1654,-1301263200,2),(1654,-1284328800,1),(1654,-1269813600,2),(1654,-1253484000,1),(1654,-1238364000,2),(1654,-1221429600,1),(1654,-1206914400,2),(1654,-1189980000,1),(1654,-1175464800,2),(1654,-1159135200,1),(1654,-1143410400,2),(1654,-1126476000,1),(1654,-1111960800,2),(1654,-1095631200,1),(1654,-1080511200,2),(1654,-1063576800,1),(1654,-1049061600,2),(1654,-1032127200,1),(1654,-1017612000,2),(1654,-1001282400,1),(1654,-986162400,2),(1654,-969228000,1),(1654,-950479200,2),(1654,-942012000,1),(1654,-904518000,3),(1654,-896050800,1),(1654,-875487600,3),(1654,-864601200,1),(1654,-844038000,3),(1654,-832546800,1),(1654,-812588400,3),(1654,-798073200,1),(1654,-781052400,3),(1654,-772066800,1),(1654,-764805600,2),(1654,-748476000,1),(1654,-733356000,2),(1654,-719445600,1),(1654,-717030000,3),(1654,-706748400,1),(1654,-699487200,2),(1654,-687996000,1),(1654,-668037600,2),(1654,-654732000,1),(1654,-636588000,2),(1654,-622072800,1),(1654,-605743200,2),(1654,-590623200,1),(1654,-574293600,2),(1654,-558568800,1),(1654,-542239200,2),(1654,-527119200,1),(1654,-512604000,2),(1654,-496274400,1),(1654,-481154400,2),(1654,-464220000,1),(1654,-449704800,2),(1654,-432165600,1),(1654,-417650400,2),(1654,-401320800,4),(1654,386125210,5),(1654,401850011,6),(1654,417574811,5),(1654,433299612,6),(1654,449024412,5),(1654,465354012,6),(1654,481078812,5),(1654,496803613,6),(1654,512528413,5),(1654,528253213,6),(1654,543978013,5),(1654,559702813,6),(1654,575427614,5),(1654,591152414,6),(1654,606877214,5),(1654,622602014,6),(1654,638326815,5),(1654,654656415,6),(1654,670381216,5),(1654,686106016,6),(1654,701830816,5),(1654,717555617,6),(1654,733280417,5),(1654,749005218,6),(1654,764730018,5),(1654,780454819,6),(1654,796179619,5),(1654,811904419,6),(1654,828234020,5),(1654,846378020,6),(1654,859683620,5),(1654,877827621,6),(1654,891133221,5),(1654,909277221,6),(1654,922582822,5),(1654,941331622,6),(1654,954032422,5),(1654,972781222,6),(1654,985482022,5),(1654,1004230822,6),(1654,1017536422,5),(1654,1035680422,6),(1654,1048986022,5),(1654,1067130022,6),(1654,1080435622,5),(1654,1099184422,6),(1654,1111885222,5),(1654,1130634022,6),(1654,1143334823,5),(1654,1162083623,6),(1654,1174784423,5),(1654,1193533223,6),(1654,1206838823,5),(1654,1224982823,6),(1654,1238288424,5),(1654,1256432424,6),(1654,1269738024,5),(1654,1288486824,6),(1654,1301187624,5),(1654,1319936424,6),(1654,1332637224,5),(1654,1351386025,6),(1654,1364691625,5),(1654,1382835625,6),(1654,1396141225,5),(1654,1414285225,6),(1654,1427590825,5),(1654,1445734826,6),(1654,1459040426,5),(1654,1477789226,6),(1654,1490490027,5),(1654,1509238827,6),(1654,1521939627,5),(1654,1540688427,6),(1654,1553994027,5),(1654,1572138027,6),(1654,1585443627,5),(1654,1603587627,6),(1654,1616893227,5),(1654,1635642027,6),(1654,1648342827,5),(1654,1667091627,6),(1654,1679792427,5),(1654,1698541227,6),(1654,1711846827,5),(1654,1729990827,6),(1654,1743296427,5),(1654,1761440427,6),(1654,1774746027,5),(1654,1792890027,6),(1654,1806195627,5),(1654,1824944427,6),(1654,1837645227,5),(1654,1856394027,6),(1654,1869094827,5),(1654,1887843627,6),(1654,1901149227,5),(1654,1919293227,6),(1654,1932598827,5),(1654,1950742827,6),(1654,1964048427,5),(1654,1982797227,6),(1654,1995498027,5),(1654,2014246827,6),(1654,2026947627,5),(1654,2045696427,6),(1654,2058397227,5),(1654,2077146027,6),(1654,2090451627,5),(1654,2108595627,6),(1654,2121901227,5),(1654,2140045227,6),(1655,-2147483648,2),(1655,-1691964000,1),(1655,-1680472800,2),(1655,-1664143200,1),(1655,-1650146400,2),(1655,-1633903200,1),(1655,-1617487200,2),(1655,-1601848800,1),(1655,-1586037600,2),(1655,-1570399200,1),(1655,-1552168800,2),(1655,-1538344800,1),(1655,-1522533600,2),(1655,-1507500000,1),(1655,-1490565600,2),(1655,-1473631200,1),(1655,-1460930400,2),(1655,-1442786400,1),(1655,-1428876000,2),(1655,-1410732000,1),(1655,-1396216800,2),(1655,-1379282400,1),(1655,-1364767200,2),(1655,-1348437600,1),(1655,-1333317600,2),(1655,-1315778400,1),(1655,-1301263200,2),(1655,-1284328800,1),(1655,-1269813600,2),(1655,-1253484000,1),(1655,-1238364000,2),(1655,-1221429600,1),(1655,-1206914400,2),(1655,-1189980000,1),(1655,-1175464800,2),(1655,-1159135200,1),(1655,-1143410400,2),(1655,-1126476000,1),(1655,-1111960800,2),(1655,-1095631200,1),(1655,-1080511200,2),(1655,-1063576800,1),(1655,-1049061600,2),(1655,-1032127200,1),(1655,-1017612000,2),(1655,-1001282400,1),(1655,-986162400,2),(1655,-969228000,1),(1655,-950479200,2),(1655,-942012000,1),(1655,-904518000,3),(1655,-896050800,1),(1655,-875487600,3),(1655,-864601200,1),(1655,-844038000,3),(1655,-832546800,1),(1655,-812588400,3),(1655,-798073200,1),(1655,-781052400,3),(1655,-772066800,1),(1655,-764805600,2),(1655,-748476000,1),(1655,-733356000,2),(1655,-719445600,1),(1655,-717030000,3),(1655,-706748400,1),(1655,-699487200,2),(1655,-687996000,1),(1655,-668037600,2),(1655,-654732000,1),(1655,-636588000,2),(1655,-622072800,1),(1655,-605743200,2),(1655,-590623200,1),(1655,-574293600,2),(1655,-558568800,1),(1655,-542239200,2),(1655,-527119200,1),(1655,-512604000,2),(1655,-496274400,1),(1655,-481154400,2),(1655,-464220000,1),(1655,-449704800,2),(1655,-432165600,1),(1655,-417650400,2),(1655,-401320800,1),(1655,-386200800,2),(1655,-369266400,1),(1655,-354751200,2),(1655,-337816800,1),(1655,-323301600,2),(1655,-306972000,1),(1655,-291852000,2),(1655,-276732000,1),(1655,-257983200,2),(1655,-245282400,1),(1655,-226533600,2),(1655,-213228000,1),(1655,-195084000,2),(1655,-182383200,1),(1655,-163634400,2),(1655,-150933600,1),(1655,-132184800,2),(1655,-119484000,1),(1655,-100735200,2),(1655,-88034400,1),(1655,-68680800,2),(1655,-59004000,1),(1655,-37242000,4),(1655,57722400,6),(1655,69818400,1),(1655,89172001,2),(1655,101268002,1),(1655,120621602,2),(1655,132717603,1),(1655,152071203,2),(1655,164167204,1),(1655,183520804,2),(1655,196221605,1),(1655,214970405,2),(1655,227671206,1),(1655,246420006,2),(1655,259120807,1),(1655,278474407,2),(1655,290570408,1),(1655,309924008,2),(1655,322020009,1),(1655,341373609,2),(1655,354675609,5),(1655,372819610,6),(1655,386125210,5),(1655,404269211,6),(1655,417574811,5),(1655,435718812,6),(1655,449024412,5),(1655,467773212,6),(1655,481078812,5),(1655,499222813,6),(1655,512528413,5),(1655,530672413,6),(1655,543978013,5),(1655,562122013,6),(1655,575427614,5),(1655,593571614,6),(1655,606877214,5),(1655,625626014,6),(1655,638326815,5),(1655,657075615,6),(1655,670381216,5),(1655,688525216,6),(1655,701830816,5),(1655,719974817,6),(1655,733280417,5),(1655,751424418,6),(1655,764730018,5),(1655,782874019,6),(1655,796179619,5),(1655,814323619,6),(1655,820454420,7),(1655,828234020,5),(1655,846378020,6),(1655,859683620,5),(1655,877827621,6),(1655,891133221,5),(1655,909277221,6),(1655,922582822,5),(1655,941331622,6),(1655,954032422,5),(1655,972781222,6),(1655,985482022,5),(1655,1004230822,6),(1655,1017536422,5),(1655,1035680422,6),(1655,1048986022,5),(1655,1067130022,6),(1655,1080435622,5),(1655,1099184422,6),(1655,1111885222,5),(1655,1130634022,6),(1655,1143334823,5),(1655,1162083623,6),(1655,1174784423,5),(1655,1193533223,6),(1655,1206838823,5),(1655,1224982823,6),(1655,1238288424,5),(1655,1256432424,6),(1655,1269738024,5),(1655,1288486824,6),(1655,1301187624,5),(1655,1319936424,6),(1655,1332637224,5),(1655,1351386025,6),(1655,1364691625,5),(1655,1382835625,6),(1655,1396141225,5),(1655,1414285225,6),(1655,1427590825,5),(1655,1445734826,6),(1655,1459040426,5),(1655,1477789226,6),(1655,1490490027,5),(1655,1509238827,6),(1655,1521939627,5),(1655,1540688427,6),(1655,1553994027,5),(1655,1572138027,6),(1655,1585443627,5),(1655,1603587627,6),(1655,1616893227,5),(1655,1635642027,6),(1655,1648342827,5),(1655,1667091627,6),(1655,1679792427,5),(1655,1698541227,6),(1655,1711846827,5),(1655,1729990827,6),(1655,1743296427,5),(1655,1761440427,6),(1655,1774746027,5),(1655,1792890027,6),(1655,1806195627,5),(1655,1824944427,6),(1655,1837645227,5),(1655,1856394027,6),(1655,1869094827,5),(1655,1887843627,6),(1655,1901149227,5),(1655,1919293227,6),(1655,1932598827,5),(1655,1950742827,6),(1655,1964048427,5),(1655,1982797227,6),(1655,1995498027,5),(1655,2014246827,6),(1655,2026947627,5),(1655,2045696427,6),(1655,2058397227,5),(1655,2077146027,6),(1655,2090451627,5),(1655,2108595627,6),(1655,2121901227,5),(1655,2140045227,6),(1656,-2147483648,1),(1656,-1535938789,3),(1656,-875671200,2),(1656,-859773600,3),(1656,354672009,2),(1656,370396810,3),(1656,386121610,2),(1656,401846411,3),(1656,417574811,4),(1656,433299612,5),(1656,449024412,4),(1656,465354012,5),(1656,481078812,4),(1656,496803613,5),(1656,512528413,4),(1656,528253213,5),(1656,543978013,4),(1656,559702813,5),(1656,575427614,4),(1656,591152414,5),(1656,606877214,4),(1656,622602014,5),(1656,638326815,4),(1656,654656415,5),(1656,670381216,4),(1656,686106016,5),(1656,701830816,4),(1656,717555617,5),(1656,733280417,4),(1656,749005218,5),(1656,764730018,4),(1656,780454819,5),(1656,796179619,4),(1656,811904419,5),(1656,828234020,4),(1656,846378020,5),(1656,859683620,4),(1656,877827621,5),(1656,891133221,4),(1656,909277221,5),(1656,922582822,4),(1656,941331622,5),(1656,954032422,4),(1656,972781222,5),(1656,985482022,4),(1656,1004230822,5),(1656,1017536422,4),(1656,1035680422,5),(1656,1048986022,4),(1656,1067130022,5),(1656,1080435622,4),(1656,1099184422,5),(1656,1111885222,4),(1656,1130634022,5),(1656,1143334823,4),(1656,1162083623,5),(1656,1174784423,4),(1656,1193533223,5),(1656,1206838823,4),(1656,1224982823,5),(1656,1238288424,4),(1656,1256432424,5),(1656,1269738024,4),(1656,1288486824,5),(1656,1301187624,4),(1656,1319936424,5),(1656,1332637224,4),(1656,1351386025,5),(1656,1364691625,4),(1656,1382835625,5),(1656,1396141225,4),(1656,1414285225,5),(1656,1427590825,4),(1656,1445734826,5),(1656,1459040426,4),(1656,1477789226,5),(1656,1490490027,4),(1656,1509238827,5),(1656,1521939627,4),(1656,1540688427,5),(1656,1553994027,4),(1656,1572138027,5),(1656,1585443627,4),(1656,1603587627,5),(1656,1616893227,4),(1656,1635642027,5),(1656,1648342827,4),(1656,1667091627,5),(1656,1679792427,4),(1656,1698541227,5),(1656,1711846827,4),(1656,1729990827,5),(1656,1743296427,4),(1656,1761440427,5),(1656,1774746027,4),(1656,1792890027,5),(1656,1806195627,4),(1656,1824944427,5),(1656,1837645227,4),(1656,1856394027,5),(1656,1869094827,4),(1656,1887843627,5),(1656,1901149227,4),(1656,1919293227,5),(1656,1932598827,4),(1656,1950742827,5),(1656,1964048427,4),(1656,1982797227,5),(1656,1995498027,4),(1656,2014246827,5),(1656,2026947627,4),(1656,2045696427,5),(1656,2058397227,4),(1656,2077146027,5),(1656,2090451627,4),(1656,2108595627,5),(1656,2121901227,4),(1656,2140045227,5),(1657,-2147483648,2),(1657,-1691964000,1),(1657,-1680472800,2),(1657,-1664143200,1),(1657,-1650146400,2),(1657,-1633903200,1),(1657,-1617487200,2),(1657,-1601848800,1),(1657,-1586037600,2),(1657,-1570399200,1),(1657,-1552168800,2),(1657,-1538344800,1),(1657,-1522533600,2),(1657,-1507500000,1),(1657,-1490565600,2),(1657,-1473631200,1),(1657,-1460930400,2),(1657,-1442786400,1),(1657,-1428876000,2),(1657,-1410732000,1),(1657,-1396216800,2),(1657,-1379282400,1),(1657,-1364767200,2),(1657,-1348437600,1),(1657,-1333317600,2),(1657,-1315778400,1),(1657,-1301263200,2),(1657,-1284328800,1),(1657,-1269813600,2),(1657,-1253484000,1),(1657,-1238364000,2),(1657,-1221429600,1),(1657,-1206914400,2),(1657,-1189980000,1),(1657,-1175464800,2),(1657,-1159135200,1),(1657,-1143410400,2),(1657,-1126476000,1),(1657,-1111960800,2),(1657,-1095631200,1),(1657,-1080511200,2),(1657,-1063576800,1),(1657,-1049061600,2),(1657,-1032127200,1),(1657,-1017612000,2),(1657,-1001282400,1),(1657,-986162400,2),(1657,-969228000,1),(1657,-950479200,2),(1657,-942012000,1),(1657,-904518000,3),(1657,-896050800,1),(1657,-875487600,3),(1657,-864601200,1),(1657,-844038000,3),(1657,-832546800,1),(1657,-812588400,3),(1657,-798073200,1),(1657,-781052400,3),(1657,-772066800,1),(1657,-764805600,2),(1657,-748476000,1),(1657,-733356000,2),(1657,-719445600,1),(1657,-717030000,3),(1657,-706748400,1),(1657,-699487200,2),(1657,-687996000,1),(1657,-668037600,2),(1657,-654732000,1),(1657,-636588000,2),(1657,-622072800,1),(1657,-605743200,2),(1657,-590623200,1),(1657,-574293600,2),(1657,-558568800,1),(1657,-542239200,2),(1657,-527119200,1),(1657,-512604000,2),(1657,-496274400,1),(1657,-481154400,2),(1657,-464220000,1),(1657,-449704800,2),(1657,-432165600,1),(1657,-417650400,2),(1657,-401320800,1),(1657,-386200800,2),(1657,-369266400,1),(1657,-354751200,2),(1657,-337816800,1),(1657,-323301600,2),(1657,-306972000,1),(1657,-291852000,2),(1657,-276732000,1),(1657,-257983200,2),(1657,-245282400,1),(1657,-226533600,2),(1657,-213228000,1),(1657,-195084000,2),(1657,-182383200,1),(1657,-163634400,2),(1657,-150933600,1),(1657,-132184800,2),(1657,-119484000,1),(1657,-100735200,2),(1657,-88034400,1),(1657,-68680800,2),(1657,-59004000,1),(1657,-37242000,4),(1657,57722400,6),(1657,69818400,1),(1657,89172001,2),(1657,101268002,1),(1657,120621602,2),(1657,132717603,1),(1657,152071203,2),(1657,164167204,1),(1657,183520804,2),(1657,196221605,1),(1657,214970405,2),(1657,227671206,1),(1657,246420006,2),(1657,259120807,1),(1657,278474407,2),(1657,290570408,1),(1657,309924008,2),(1657,322020009,1),(1657,341373609,2),(1657,354675609,5),(1657,372819610,6),(1657,386125210,5),(1657,404269211,6),(1657,417574811,5),(1657,435718812,6),(1657,449024412,5),(1657,467773212,6),(1657,481078812,5),(1657,499222813,6),(1657,512528413,5),(1657,530672413,6),(1657,543978013,5),(1657,562122013,6),(1657,575427614,5),(1657,593571614,6),(1657,606877214,5),(1657,625626014,6),(1657,638326815,5),(1657,657075615,6),(1657,670381216,5),(1657,688525216,6),(1657,701830816,5),(1657,719974817,6),(1657,733280417,5),(1657,751424418,6),(1657,764730018,5),(1657,782874019,6),(1657,796179619,5),(1657,814323619,6),(1657,820454420,7),(1657,828234020,5),(1657,846378020,6),(1657,859683620,5),(1657,877827621,6),(1657,891133221,5),(1657,909277221,6),(1657,922582822,5),(1657,941331622,6),(1657,954032422,5),(1657,972781222,6),(1657,985482022,5),(1657,1004230822,6),(1657,1017536422,5),(1657,1035680422,6),(1657,1048986022,5),(1657,1067130022,6),(1657,1080435622,5),(1657,1099184422,6),(1657,1111885222,5),(1657,1130634022,6),(1657,1143334823,5),(1657,1162083623,6),(1657,1174784423,5),(1657,1193533223,6),(1657,1206838823,5),(1657,1224982823,6),(1657,1238288424,5),(1657,1256432424,6),(1657,1269738024,5),(1657,1288486824,6),(1657,1301187624,5),(1657,1319936424,6),(1657,1332637224,5),(1657,1351386025,6),(1657,1364691625,5),(1657,1382835625,6),(1657,1396141225,5),(1657,1414285225,6),(1657,1427590825,5),(1657,1445734826,6),(1657,1459040426,5),(1657,1477789226,6),(1657,1490490027,5),(1657,1509238827,6),(1657,1521939627,5),(1657,1540688427,6),(1657,1553994027,5),(1657,1572138027,6),(1657,1585443627,5),(1657,1603587627,6),(1657,1616893227,5),(1657,1635642027,6),(1657,1648342827,5),(1657,1667091627,6),(1657,1679792427,5),(1657,1698541227,6),(1657,1711846827,5),(1657,1729990827,6),(1657,1743296427,5),(1657,1761440427,6),(1657,1774746027,5),(1657,1792890027,6),(1657,1806195627,5),(1657,1824944427,6),(1657,1837645227,5),(1657,1856394027,6),(1657,1869094827,5),(1657,1887843627,6),(1657,1901149227,5),(1657,1919293227,6),(1657,1932598827,5),(1657,1950742827,6),(1657,1964048427,5),(1657,1982797227,6),(1657,1995498027,5),(1657,2014246827,6),(1657,2026947627,5),(1657,2045696427,6),(1657,2058397227,5),(1657,2077146027,6),(1657,2090451627,5),(1657,2108595627,6),(1657,2121901227,5),(1657,2140045227,6),(1658,-2147483648,1),(1658,-1869875816,3),(1658,-1693706400,2),(1658,-1680490800,3),(1658,-1570413600,2),(1658,-1552186800,3),(1658,-1538359200,2),(1658,-1522551600,3),(1658,-1507514400,2),(1658,-1490583600,3),(1658,-1440208800,2),(1658,-1428030000,3),(1658,-1409709600,2),(1658,-1396494000,3),(1658,-931140000,2),(1658,-922762800,3),(1658,-917834400,2),(1658,-892436400,3),(1658,-875844000,2),(1658,-857358000,3),(1658,-781063200,2),(1658,-764737200,3),(1658,-744343200,2),(1658,-733806000,3),(1658,-716436000,2),(1658,-701924400,3),(1658,-684986400,2),(1658,-670474800,3),(1658,-654141600,2),(1658,-639025200,3),(1658,-621828000,2),(1658,-606970800,3),(1658,-590032800,2),(1658,-575434800,3),(1658,-235620000,2),(1658,-228279600,3),(1658,-177732000,2),(1658,-165726000,3),(1658,10533600,2),(1658,23835600,3),(1658,41983200,2),(1658,55285200,3),(1658,74037600,2),(1658,87339601,3),(1658,107910002,2),(1658,121219202,3),(1658,133920003,2),(1658,152676003,3),(1658,165362404,2),(1658,183502804,3),(1658,202428005,2),(1658,215557205,3),(1658,228866406,2),(1658,245797206,3),(1658,260316007,2),(1658,277246807,4),(1658,308779208,5),(1658,323827209,4),(1658,340228809,5),(1658,354672009,4),(1658,371678410,5),(1658,386121610,4),(1658,403128011,5),(1658,428446812,4),(1658,433886412,5),(1658,482792412,2),(1658,496702813,3),(1658,512521213,6),(1658,528246013,7),(1658,543970813,6),(1658,559695613,7),(1658,575420414,6),(1658,591145214,7),(1658,606870014,6),(1658,622594814,7),(1658,638319615,6),(1658,654649215,7),(1658,670374016,6),(1658,686098816,7),(1658,701823616,6),(1658,717548417,7),(1658,733273217,6),(1658,748998018,7),(1658,764118018,6),(1658,780447619,7),(1658,796172419,6),(1658,811897219,7),(1658,828226820,6),(1658,846370820,7),(1658,859676420,6),(1658,877820421,7),(1658,891126021,6),(1658,909270021,7),(1658,922575622,6),(1658,941324422,7),(1658,954025222,6),(1658,972774022,7),(1658,985474822,6),(1658,1004223622,7),(1658,1017529222,6),(1658,1035673222,7),(1658,1048978822,6),(1658,1067122822,7),(1658,1080428422,6),(1658,1099177222,7),(1658,1111878022,6),(1658,1130626822,7),(1658,1143327623,6),(1658,1162076423,7),(1658,1167602423,3),(1658,1174784423,8),(1658,1193533223,9),(1658,1206838823,8),(1658,1224982823,9),(1658,1238288424,8),(1658,1256432424,9),(1658,1269738024,8),(1658,1288486824,9),(1658,1301274024,8),(1658,1319936424,9),(1658,1332637224,8),(1658,1351386025,9),(1658,1364691625,8),(1658,1382835625,9),(1658,1396227625,8),(1658,1414285225,9),(1658,1427590825,8),(1658,1446944426,9),(1658,1459040426,8),(1658,1473195626,5),(1659,-2147483648,2),(1659,-1691964000,1),(1659,-1680472800,2),(1659,-1664143200,1),(1659,-1650146400,2),(1659,-1633903200,1),(1659,-1617487200,2),(1659,-1601848800,1),(1659,-1586037600,2),(1659,-1570399200,1),(1659,-1552168800,2),(1659,-1538344800,1),(1659,-1522533600,2),(1659,-1507500000,1),(1659,-1490565600,2),(1659,-1473631200,1),(1659,-1460930400,2),(1659,-1442786400,1),(1659,-1428876000,2),(1659,-1410732000,1),(1659,-1396216800,2),(1659,-1379282400,1),(1659,-1364767200,2),(1659,-1348437600,1),(1659,-1333317600,2),(1659,-1315778400,1),(1659,-1301263200,2),(1659,-1284328800,1),(1659,-1269813600,2),(1659,-1253484000,1),(1659,-1238364000,2),(1659,-1221429600,1),(1659,-1206914400,2),(1659,-1189980000,1),(1659,-1175464800,2),(1659,-1159135200,1),(1659,-1143410400,2),(1659,-1126476000,1),(1659,-1111960800,2),(1659,-1095631200,1),(1659,-1080511200,2),(1659,-1063576800,1),(1659,-1049061600,2),(1659,-1032127200,1),(1659,-1017612000,2),(1659,-1001282400,1),(1659,-986162400,2),(1659,-969228000,1),(1659,-950479200,2),(1659,-942012000,1),(1659,-904518000,3),(1659,-896050800,1),(1659,-875487600,3),(1659,-864601200,1),(1659,-844038000,3),(1659,-832546800,1),(1659,-812588400,3),(1659,-798073200,1),(1659,-781052400,3),(1659,-772066800,1),(1659,-764805600,2),(1659,-748476000,1),(1659,-733356000,2),(1659,-719445600,1),(1659,-717030000,3),(1659,-706748400,1),(1659,-699487200,2),(1659,-687996000,1),(1659,-668037600,2),(1659,-654732000,1),(1659,-636588000,2),(1659,-622072800,1),(1659,-605743200,2),(1659,-590623200,1),(1659,-574293600,2),(1659,-558568800,1),(1659,-542239200,2),(1659,-527119200,1),(1659,-512604000,2),(1659,-496274400,1),(1659,-481154400,2),(1659,-464220000,1),(1659,-449704800,2),(1659,-432165600,1),(1659,-417650400,2),(1659,-401320800,1),(1659,-386200800,2),(1659,-369266400,1),(1659,-354751200,2),(1659,-337816800,1),(1659,-323301600,2),(1659,-306972000,1),(1659,-291852000,2),(1659,-276732000,1),(1659,-257983200,2),(1659,-245282400,1),(1659,-226533600,2),(1659,-213228000,1),(1659,-195084000,2),(1659,-182383200,1),(1659,-163634400,2),(1659,-150933600,1),(1659,-132184800,2),(1659,-119484000,1),(1659,-100735200,2),(1659,-88034400,1),(1659,-68680800,2),(1659,-59004000,1),(1659,-37242000,4),(1659,57722400,6),(1659,69818400,1),(1659,89172001,2),(1659,101268002,1),(1659,120621602,2),(1659,132717603,1),(1659,152071203,2),(1659,164167204,1),(1659,183520804,2),(1659,196221605,1),(1659,214970405,2),(1659,227671206,1),(1659,246420006,2),(1659,259120807,1),(1659,278474407,2),(1659,290570408,1),(1659,309924008,2),(1659,322020009,1),(1659,341373609,2),(1659,354675609,5),(1659,372819610,6),(1659,386125210,5),(1659,404269211,6),(1659,417574811,5),(1659,435718812,6),(1659,449024412,5),(1659,467773212,6),(1659,481078812,5),(1659,499222813,6),(1659,512528413,5),(1659,530672413,6),(1659,543978013,5),(1659,562122013,6),(1659,575427614,5),(1659,593571614,6),(1659,606877214,5),(1659,625626014,6),(1659,638326815,5),(1659,657075615,6),(1659,670381216,5),(1659,688525216,6),(1659,701830816,5),(1659,719974817,6),(1659,733280417,5),(1659,751424418,6),(1659,764730018,5),(1659,782874019,6),(1659,796179619,5),(1659,814323619,6),(1659,820454420,7),(1659,828234020,5),(1659,846378020,6),(1659,859683620,5),(1659,877827621,6),(1659,891133221,5),(1659,909277221,6),(1659,922582822,5),(1659,941331622,6),(1659,954032422,5),(1659,972781222,6),(1659,985482022,5),(1659,1004230822,6),(1659,1017536422,5),(1659,1035680422,6),(1659,1048986022,5),(1659,1067130022,6),(1659,1080435622,5),(1659,1099184422,6),(1659,1111885222,5),(1659,1130634022,6),(1659,1143334823,5),(1659,1162083623,6),(1659,1174784423,5),(1659,1193533223,6),(1659,1206838823,5),(1659,1224982823,6),(1659,1238288424,5),(1659,1256432424,6),(1659,1269738024,5),(1659,1288486824,6),(1659,1301187624,5),(1659,1319936424,6),(1659,1332637224,5),(1659,1351386025,6),(1659,1364691625,5),(1659,1382835625,6),(1659,1396141225,5),(1659,1414285225,6),(1659,1427590825,5),(1659,1445734826,6),(1659,1459040426,5),(1659,1477789226,6),(1659,1490490027,5),(1659,1509238827,6),(1659,1521939627,5),(1659,1540688427,6),(1659,1553994027,5),(1659,1572138027,6),(1659,1585443627,5),(1659,1603587627,6),(1659,1616893227,5),(1659,1635642027,6),(1659,1648342827,5),(1659,1667091627,6),(1659,1679792427,5),(1659,1698541227,6),(1659,1711846827,5),(1659,1729990827,6),(1659,1743296427,5),(1659,1761440427,6),(1659,1774746027,5),(1659,1792890027,6),(1659,1806195627,5),(1659,1824944427,6),(1659,1837645227,5),(1659,1856394027,6),(1659,1869094827,5),(1659,1887843627,6),(1659,1901149227,5),(1659,1919293227,6),(1659,1932598827,5),(1659,1950742827,6),(1659,1964048427,5),(1659,1982797227,6),(1659,1995498027,5),(1659,2014246827,6),(1659,2026947627,5),(1659,2045696427,6),(1659,2058397227,5),(1659,2077146027,6),(1659,2090451627,5),(1659,2108595627,6),(1659,2121901227,5),(1659,2140045227,6),(1660,-2147483648,2),(1660,-1693706400,1),(1660,-1680483600,2),(1660,-1663455600,3),(1660,-1650150000,4),(1660,-1632006000,3),(1660,-1618700400,4),(1660,-938905200,3),(1660,-857257200,4),(1660,-844556400,3),(1660,-828226800,4),(1660,-812502000,3),(1660,-796777200,4),(1660,-788922000,6),(1660,-778730400,5),(1660,-762663600,6),(1660,-757389600,8),(1660,354920409,7),(1660,370728010,8),(1660,386456410,7),(1660,402264011,8),(1660,417992411,7),(1660,433800012,8),(1660,449614812,7),(1660,465346812,9),(1660,481071612,10),(1660,496796413,9),(1660,512521213,10),(1660,528246013,9),(1660,543970813,10),(1660,559695613,9),(1660,575420414,10),(1660,591145214,9),(1660,606870014,11),(1660,622598414,12),(1660,638323215,11),(1660,654652815,12),(1660,670377616,11),(1660,686102416,12),(1660,701827216,11),(1660,717552017,12),(1660,733276817,11),(1660,749001618,12),(1660,764726418,11),(1660,780451219,12),(1660,796176019,11),(1660,811900819,12),(1660,828230420,11),(1660,846374420,12),(1660,859680020,11),(1660,877824021,12),(1660,891129621,11),(1660,909273621,12),(1660,922579222,11),(1660,941328022,12),(1660,954028822,11),(1660,972777622,12),(1660,985478422,11),(1660,1004227222,12),(1660,1017532822,11),(1660,1035676822,12),(1660,1048982422,11),(1660,1067126422,12),(1660,1080432022,11),(1660,1099180822,12),(1660,1111881622,11),(1660,1130630422,12),(1660,1143331223,11),(1660,1162080023,12),(1660,1174780823,11),(1660,1193529623,12),(1660,1206835223,11),(1660,1224979223,12),(1660,1238284824,11),(1660,1256428824,12),(1660,1269734424,11),(1660,1288483224,12),(1660,1301184024,13),(1660,1414278025,12),(1661,-2147483648,1),(1661,-1441159324,2),(1661,-1247536800,3),(1661,-892522800,6),(1661,-857257200,4),(1661,-844556400,5),(1661,-828226800,4),(1661,-825382800,3),(1661,354920409,7),(1661,370728010,3),(1661,386456410,7),(1661,402264011,3),(1661,417992411,7),(1661,433800012,3),(1661,449614812,7),(1661,465346812,8),(1661,481071612,9),(1661,496796413,8),(1661,512521213,9),(1661,528246013,8),(1661,543970813,9),(1661,559695613,8),(1661,575420414,9),(1661,591145214,8),(1661,606870014,9),(1661,622594814,8),(1661,638319615,9),(1661,646783215,10),(1661,686102416,2),(1661,701820016,10),(1661,717541217,2),(1661,733269617,10),(1661,748990818,2),(1661,764719218,10),(1661,780440419,2),(1661,796179619,11),(1661,811904419,12),(1661,828234020,11),(1661,846378020,12),(1661,859683620,11),(1661,877827621,12),(1661,891133221,11),(1661,909277221,12),(1661,922582822,11),(1661,941331622,12),(1661,954032422,11),(1661,972781222,12),(1661,985482022,11),(1661,1004230822,12),(1661,1017536422,11),(1661,1035680422,12),(1661,1048986022,11),(1661,1067130022,12),(1661,1080435622,11),(1661,1099184422,12),(1661,1111885222,11),(1661,1130634022,12),(1661,1143334823,11),(1661,1162083623,12),(1661,1174784423,11),(1661,1193533223,12),(1661,1206838823,11),(1661,1224982823,12),(1661,1238288424,11),(1661,1256432424,12),(1661,1269738024,11),(1661,1288486824,12),(1661,1301187624,11),(1661,1319936424,12),(1661,1332637224,11),(1661,1351386025,12),(1661,1364691625,11),(1661,1382835625,12),(1661,1396141225,11),(1661,1414285225,12),(1661,1427590825,11),(1661,1445734826,12),(1661,1459040426,11),(1661,1477789226,12),(1661,1490490027,11),(1661,1509238827,12),(1661,1521939627,11),(1661,1540688427,12),(1661,1553994027,11),(1661,1572138027,12),(1661,1585443627,11),(1661,1603587627,12),(1661,1616893227,11),(1661,1635642027,12),(1661,1648342827,11),(1661,1667091627,12),(1661,1679792427,11),(1661,1698541227,12),(1661,1711846827,11),(1661,1729990827,12),(1661,1743296427,11),(1661,1761440427,12),(1661,1774746027,11),(1661,1792890027,12),(1661,1806195627,11),(1661,1824944427,12),(1661,1837645227,11),(1661,1856394027,12),(1661,1869094827,11),(1661,1887843627,12),(1661,1901149227,11),(1661,1919293227,12),(1661,1932598827,11),(1661,1950742827,12),(1661,1964048427,11),(1661,1982797227,12),(1661,1995498027,11),(1661,2014246827,12),(1661,2026947627,11),(1661,2045696427,12),(1661,2058397227,11),(1661,2077146027,12),(1661,2090451627,11),(1661,2108595627,12),(1661,2121901227,11),(1661,2140045227,12),(1662,-2147483648,0),(1662,-1593820800,1),(1662,-1247540400,3),(1662,354916809,2),(1662,370724410,3),(1662,386452810,2),(1662,402260411,3),(1662,417988811,2),(1662,433796412,3),(1662,449611212,2),(1662,465343212,4),(1662,481068012,5),(1662,496792813,4),(1662,512517613,5),(1662,528242413,4),(1662,543967213,5),(1662,559692013,4),(1662,575416814,5),(1662,591141614,4),(1662,606866414,6),(1662,622594814,7),(1662,638319615,6),(1662,654649215,7),(1662,670374016,4),(1662,701820016,6),(1662,717548417,7),(1662,733273217,6),(1662,748998018,7),(1662,764722818,6),(1662,780447619,7),(1662,796172419,6),(1662,811897219,7),(1662,828226820,6),(1662,846370820,7),(1662,859676420,6),(1662,877820421,7),(1662,891126021,6),(1662,909270021,7),(1662,922575622,6),(1662,941324422,7),(1662,954025222,6),(1662,972774022,7),(1662,985474822,6),(1662,1004223622,7),(1662,1017529222,6),(1662,1035673222,7),(1662,1048978822,6),(1662,1067122822,7),(1662,1080428422,6),(1662,1099177222,7),(1662,1111878022,6),(1662,1130626822,7),(1662,1143327623,6),(1662,1162076423,7),(1662,1174777223,6),(1662,1193526023,7),(1662,1206831623,6),(1662,1224975623,7),(1662,1238281224,6),(1662,1256425224,7),(1662,1269730824,6),(1662,1288479624,7),(1662,1301180424,4),(1662,1414274425,7),(1663,-2147483648,0),(1663,-1830384000,6),(1663,-1689555600,1),(1663,-1677801600,2),(1663,-1667437200,3),(1663,-1647738000,4),(1663,-1635814800,3),(1663,-1616202000,4),(1663,-1604365200,3),(1663,-1584666000,4),(1663,-1572742800,3),(1663,-1553043600,4),(1663,-1541206800,3),(1663,-1521507600,4),(1663,-1442451600,3),(1663,-1426813200,4),(1663,-1379293200,3),(1663,-1364778000,4),(1663,-1348448400,3),(1663,-1333328400,4),(1663,-1316394000,3),(1663,-1301274000,4),(1663,-1284339600,3),(1663,-1269824400,4),(1663,-1221440400,3),(1663,-1206925200,4),(1663,-1191200400,3),(1663,-1175475600,4),(1663,-1127696400,3),(1663,-1111971600,4),(1663,-1096851600,3),(1663,-1080522000,4),(1663,-1063587600,3),(1663,-1049072400,4),(1663,-1033347600,3),(1663,-1017622800,4),(1663,-1002502800,3),(1663,-986173200,4),(1663,-969238800,3),(1663,-950490000,4),(1663,-942022800,3),(1663,-922669200,4),(1663,-906944400,3),(1663,-891133200,4),(1663,-877309200,3),(1663,-873684000,5),(1663,-864007200,3),(1663,-857955600,4),(1663,-845859600,3),(1663,-842839200,5),(1663,-831348000,3),(1663,-825901200,4),(1663,-814410000,3),(1663,-810784800,5),(1663,-799898400,3),(1663,-794451600,4),(1663,-782960400,3),(1663,-779335200,5),(1663,-768448800,3),(1663,-763002000,4),(1663,-749091600,3),(1663,-733366800,4),(1663,-717631200,3),(1663,-701906400,4),(1663,-686181600,3),(1663,-670456800,4),(1663,-654732000,3),(1663,-639007200,4),(1663,-591832800,3),(1663,-575503200,4),(1663,-559778400,3),(1663,-544053600,4),(1663,-528328800,3),(1663,-512604000,4),(1663,-496879200,3),(1663,-481154400,4),(1663,-465429600,3),(1663,-449704800,4),(1663,-433980000,3),(1663,-417650400,4),(1663,-401925600,3),(1663,-386200800,4),(1663,-370476000,3),(1663,-354751200,4),(1663,-339026400,3),(1663,-323301600,4),(1663,-307576800,3),(1663,-291852000,4),(1663,-276127200,3),(1663,-260402400,4),(1663,-244677600,3),(1663,-228348000,4),(1663,-212623200,3),(1663,-196898400,4),(1663,-181173600,3),(1663,-165448800,4),(1663,-149724000,3),(1663,-133999200,4),(1663,-118274400,7),(1663,212544005,2),(1663,228268806,3),(1663,243993606,4),(1663,260323207,3),(1663,276048007,4),(1663,291772808,3),(1663,307501208,4),(1663,323222409,3),(1663,338950809,4),(1663,354675609,3),(1663,370400410,4),(1663,386125210,3),(1663,401850011,4),(1663,417578411,3),(1663,433299612,4),(1663,449024412,3),(1663,465354012,4),(1663,481078812,3),(1663,496803613,4),(1663,512528413,3),(1663,528253213,4),(1663,543978013,3),(1663,559702813,4),(1663,575427614,3),(1663,591152414,4),(1663,606877214,3),(1663,622602014,4),(1663,638326815,3),(1663,654656415,4),(1663,670381216,3),(1663,686106016,4),(1663,701830816,3),(1663,717555617,8),(1663,733280417,9),(1663,749005218,8),(1663,764730018,9),(1663,780454819,8),(1663,796179619,9),(1663,811904419,8),(1663,828234020,10),(1663,846378020,6),(1663,859683620,10),(1663,877827621,6),(1663,891133221,10),(1663,909277221,6),(1663,922582822,10),(1663,941331622,6),(1663,954032422,10),(1663,972781222,6),(1663,985482022,10),(1663,1004230822,6),(1663,1017536422,10),(1663,1035680422,6),(1663,1048986022,10),(1663,1067130022,6),(1663,1080435622,10),(1663,1099184422,6),(1663,1111885222,10),(1663,1130634022,6),(1663,1143334823,10),(1663,1162083623,6),(1663,1174784423,10),(1663,1193533223,6),(1663,1206838823,10),(1663,1224982823,6),(1663,1238288424,10),(1663,1256432424,6),(1663,1269738024,10),(1663,1288486824,6),(1663,1301187624,10),(1663,1319936424,6),(1663,1332637224,10),(1663,1351386025,6),(1663,1364691625,10),(1663,1382835625,6),(1663,1396141225,10),(1663,1414285225,6),(1663,1427590825,10),(1663,1445734826,6),(1663,1459040426,10),(1663,1477789226,6),(1663,1490490027,10),(1663,1509238827,6),(1663,1521939627,10),(1663,1540688427,6),(1663,1553994027,10),(1663,1572138027,6),(1663,1585443627,10),(1663,1603587627,6),(1663,1616893227,10),(1663,1635642027,6),(1663,1648342827,10),(1663,1667091627,6),(1663,1679792427,10),(1663,1698541227,6),(1663,1711846827,10),(1663,1729990827,6),(1663,1743296427,10),(1663,1761440427,6),(1663,1774746027,10),(1663,1792890027,6),(1663,1806195627,10),(1663,1824944427,6),(1663,1837645227,10),(1663,1856394027,6),(1663,1869094827,10),(1663,1887843627,6),(1663,1901149227,10),(1663,1919293227,6),(1663,1932598827,10),(1663,1950742827,6),(1663,1964048427,10),(1663,1982797227,6),(1663,1995498027,10),(1663,2014246827,6),(1663,2026947627,10),(1663,2045696427,6),(1663,2058397227,10),(1663,2077146027,6),(1663,2090451627,10),(1663,2108595627,6),(1663,2121901227,10),(1663,2140045227,6),(1664,-2147483648,1),(1664,-905824800,4),(1664,-857257200,2),(1664,-844556400,3),(1664,-828226800,2),(1664,-812502000,3),(1664,-796777200,2),(1664,-788922000,1),(1664,-777942000,3),(1664,-766623600,2),(1664,407199611,1),(1664,417574811,5),(1664,433299612,6),(1664,449024412,5),(1664,465354012,6),(1664,481078812,5),(1664,496803613,6),(1664,512528413,5),(1664,528253213,6),(1664,543978013,5),(1664,559702813,6),(1664,575427614,5),(1664,591152414,6),(1664,606877214,5),(1664,622602014,6),(1664,638326815,5),(1664,654656415,6),(1664,670381216,5),(1664,686106016,6),(1664,701830816,5),(1664,717555617,6),(1664,733280417,5),(1664,749005218,6),(1664,764730018,5),(1664,780454819,6),(1664,796179619,5),(1664,811904419,6),(1664,828234020,5),(1664,846378020,6),(1664,859683620,5),(1664,877827621,6),(1664,891133221,5),(1664,909277221,6),(1664,922582822,5),(1664,941331622,6),(1664,954032422,5),(1664,972781222,6),(1664,985482022,5),(1664,1004230822,6),(1664,1017536422,5),(1664,1035680422,6),(1664,1048986022,5),(1664,1067130022,6),(1664,1080435622,5),(1664,1099184422,6),(1664,1111885222,5),(1664,1130634022,6),(1664,1143334823,5),(1664,1162083623,6),(1664,1174784423,5),(1664,1193533223,6),(1664,1206838823,5),(1664,1224982823,6),(1664,1238288424,5),(1664,1256432424,6),(1664,1269738024,5),(1664,1288486824,6),(1664,1301187624,5),(1664,1319936424,6),(1664,1332637224,5),(1664,1351386025,6),(1664,1364691625,5),(1664,1382835625,6),(1664,1396141225,5),(1664,1414285225,6),(1664,1427590825,5),(1664,1445734826,6),(1664,1459040426,5),(1664,1477789226,6),(1664,1490490027,5),(1664,1509238827,6),(1664,1521939627,5),(1664,1540688427,6),(1664,1553994027,5),(1664,1572138027,6),(1664,1585443627,5),(1664,1603587627,6),(1664,1616893227,5),(1664,1635642027,6),(1664,1648342827,5),(1664,1667091627,6),(1664,1679792427,5),(1664,1698541227,6),(1664,1711846827,5),(1664,1729990827,6),(1664,1743296427,5),(1664,1761440427,6),(1664,1774746027,5),(1664,1792890027,6),(1664,1806195627,5),(1664,1824944427,6),(1664,1837645227,5),(1664,1856394027,6),(1664,1869094827,5),(1664,1887843627,6),(1664,1901149227,5),(1664,1919293227,6),(1664,1932598827,5),(1664,1950742827,6),(1664,1964048427,5),(1664,1982797227,6),(1664,1995498027,5),(1664,2014246827,6),(1664,2026947627,5),(1664,2045696427,6),(1664,2058397227,5),(1664,2077146027,6),(1664,2090451627,5),(1664,2108595627,6),(1664,2121901227,5),(1664,2140045227,6),(1665,-2147483648,2),(1665,-1691964000,1),(1665,-1680472800,2),(1665,-1664143200,1),(1665,-1650146400,2),(1665,-1633903200,1),(1665,-1617487200,2),(1665,-1601848800,1),(1665,-1586037600,2),(1665,-1570399200,1),(1665,-1552168800,2),(1665,-1538344800,1),(1665,-1522533600,2),(1665,-1507500000,1),(1665,-1490565600,2),(1665,-1473631200,1),(1665,-1460930400,2),(1665,-1442786400,1),(1665,-1428876000,2),(1665,-1410732000,1),(1665,-1396216800,2),(1665,-1379282400,1),(1665,-1364767200,2),(1665,-1348437600,1),(1665,-1333317600,2),(1665,-1315778400,1),(1665,-1301263200,2),(1665,-1284328800,1),(1665,-1269813600,2),(1665,-1253484000,1),(1665,-1238364000,2),(1665,-1221429600,1),(1665,-1206914400,2),(1665,-1189980000,1),(1665,-1175464800,2),(1665,-1159135200,1),(1665,-1143410400,2),(1665,-1126476000,1),(1665,-1111960800,2),(1665,-1095631200,1),(1665,-1080511200,2),(1665,-1063576800,1),(1665,-1049061600,2),(1665,-1032127200,1),(1665,-1017612000,2),(1665,-1001282400,1),(1665,-986162400,2),(1665,-969228000,1),(1665,-950479200,2),(1665,-942012000,1),(1665,-904518000,3),(1665,-896050800,1),(1665,-875487600,3),(1665,-864601200,1),(1665,-844038000,3),(1665,-832546800,1),(1665,-812588400,3),(1665,-798073200,1),(1665,-781052400,3),(1665,-772066800,1),(1665,-764805600,2),(1665,-748476000,1),(1665,-733356000,2),(1665,-719445600,1),(1665,-717030000,3),(1665,-706748400,1),(1665,-699487200,2),(1665,-687996000,1),(1665,-668037600,2),(1665,-654732000,1),(1665,-636588000,2),(1665,-622072800,1),(1665,-605743200,2),(1665,-590623200,1),(1665,-574293600,2),(1665,-558568800,1),(1665,-542239200,2),(1665,-527119200,1),(1665,-512604000,2),(1665,-496274400,1),(1665,-481154400,2),(1665,-464220000,1),(1665,-449704800,2),(1665,-432165600,1),(1665,-417650400,2),(1665,-401320800,1),(1665,-386200800,2),(1665,-369266400,1),(1665,-354751200,2),(1665,-337816800,1),(1665,-323301600,2),(1665,-306972000,1),(1665,-291852000,2),(1665,-276732000,1),(1665,-257983200,2),(1665,-245282400,1),(1665,-226533600,2),(1665,-213228000,1),(1665,-195084000,2),(1665,-182383200,1),(1665,-163634400,2),(1665,-150933600,1),(1665,-132184800,2),(1665,-119484000,1),(1665,-100735200,2),(1665,-88034400,1),(1665,-68680800,2),(1665,-59004000,1),(1665,-37242000,4),(1665,57722400,6),(1665,69818400,1),(1665,89172001,2),(1665,101268002,1),(1665,120621602,2),(1665,132717603,1),(1665,152071203,2),(1665,164167204,1),(1665,183520804,2),(1665,196221605,1),(1665,214970405,2),(1665,227671206,1),(1665,246420006,2),(1665,259120807,1),(1665,278474407,2),(1665,290570408,1),(1665,309924008,2),(1665,322020009,1),(1665,341373609,2),(1665,354675609,5),(1665,372819610,6),(1665,386125210,5),(1665,404269211,6),(1665,417574811,5),(1665,435718812,6),(1665,449024412,5),(1665,467773212,6),(1665,481078812,5),(1665,499222813,6),(1665,512528413,5),(1665,530672413,6),(1665,543978013,5),(1665,562122013,6),(1665,575427614,5),(1665,593571614,6),(1665,606877214,5),(1665,625626014,6),(1665,638326815,5),(1665,657075615,6),(1665,670381216,5),(1665,688525216,6),(1665,701830816,5),(1665,719974817,6),(1665,733280417,5),(1665,751424418,6),(1665,764730018,5),(1665,782874019,6),(1665,796179619,5),(1665,814323619,6),(1665,820454420,7),(1665,828234020,5),(1665,846378020,6),(1665,859683620,5),(1665,877827621,6),(1665,891133221,5),(1665,909277221,6),(1665,922582822,5),(1665,941331622,6),(1665,954032422,5),(1665,972781222,6),(1665,985482022,5),(1665,1004230822,6),(1665,1017536422,5),(1665,1035680422,6),(1665,1048986022,5),(1665,1067130022,6),(1665,1080435622,5),(1665,1099184422,6),(1665,1111885222,5),(1665,1130634022,6),(1665,1143334823,5),(1665,1162083623,6),(1665,1174784423,5),(1665,1193533223,6),(1665,1206838823,5),(1665,1224982823,6),(1665,1238288424,5),(1665,1256432424,6),(1665,1269738024,5),(1665,1288486824,6),(1665,1301187624,5),(1665,1319936424,6),(1665,1332637224,5),(1665,1351386025,6),(1665,1364691625,5),(1665,1382835625,6),(1665,1396141225,5),(1665,1414285225,6),(1665,1427590825,5),(1665,1445734826,6),(1665,1459040426,5),(1665,1477789226,6),(1665,1490490027,5),(1665,1509238827,6),(1665,1521939627,5),(1665,1540688427,6),(1665,1553994027,5),(1665,1572138027,6),(1665,1585443627,5),(1665,1603587627,6),(1665,1616893227,5),(1665,1635642027,6),(1665,1648342827,5),(1665,1667091627,6),(1665,1679792427,5),(1665,1698541227,6),(1665,1711846827,5),(1665,1729990827,6),(1665,1743296427,5),(1665,1761440427,6),(1665,1774746027,5),(1665,1792890027,6),(1665,1806195627,5),(1665,1824944427,6),(1665,1837645227,5),(1665,1856394027,6),(1665,1869094827,5),(1665,1887843627,6),(1665,1901149227,5),(1665,1919293227,6),(1665,1932598827,5),(1665,1950742827,6),(1665,1964048427,5),(1665,1982797227,6),(1665,1995498027,5),(1665,2014246827,6),(1665,2026947627,5),(1665,2045696427,6),(1665,2058397227,5),(1665,2077146027,6),(1665,2090451627,5),(1665,2108595627,6),(1665,2121901227,5),(1665,2140045227,6),(1666,-2147483648,0),(1666,-2069713476,2),(1666,-1692496800,1),(1666,-1680483600,2),(1666,-1662343200,1),(1666,-1650157200,2),(1666,-1632006000,3),(1666,-1618700400,4),(1666,-1612659600,6),(1666,-1604278800,5),(1666,-1585519200,6),(1666,-1574038800,5),(1666,-1552258800,6),(1666,-1539997200,5),(1666,-1520550000,6),(1666,-1507510800,5),(1666,-1490572800,6),(1666,-1473642000,5),(1666,-1459119600,6),(1666,-1444006800,5),(1666,-1427673600,6),(1666,-1411866000,5),(1666,-1396224000,6),(1666,-1379293200,5),(1666,-1364774400,6),(1666,-1348448400,5),(1666,-1333324800,6),(1666,-1316394000,5),(1666,-1301270400,6),(1666,-1284339600,5),(1666,-1269813600,7),(1666,-1253484000,8),(1666,-1238364000,7),(1666,-1221429600,8),(1666,-1206914400,7),(1666,-1191189600,8),(1666,-1175464800,7),(1666,-1160344800,8),(1666,-1143410400,7),(1666,-1127685600,8),(1666,-1111960800,7),(1666,-1096840800,8),(1666,-1080511200,7),(1666,-1063576800,8),(1666,-1049061600,7),(1666,-1033336800,8),(1666,-1017612000,7),(1666,-1002492000,8),(1666,-986162400,7),(1666,-969228000,8),(1666,-950479200,7),(1666,-942012000,8),(1666,-935186400,11),(1666,-857257200,9),(1666,-844556400,10),(1666,-828226800,9),(1666,-812502000,10),(1666,-797986800,2),(1666,-781052400,3),(1666,-766623600,4),(1666,-745455600,3),(1666,-733273200,4),(1666,220921205,2),(1666,228877206,12),(1666,243997206,13),(1666,260326807,12),(1666,276051607,13),(1666,291776408,12),(1666,307501208,13),(1666,323830809,12),(1666,338950809,13),(1666,354675609,12),(1666,370400410,13),(1666,386125210,12),(1666,401850011,13),(1666,417574811,12),(1666,433299612,13),(1666,449024412,12),(1666,465354012,13),(1666,481078812,12),(1666,496803613,13),(1666,512528413,12),(1666,528253213,13),(1666,543978013,12),(1666,559702813,13),(1666,575427614,12),(1666,591152414,13),(1666,606877214,12),(1666,622602014,13),(1666,638326815,12),(1666,654656415,13),(1666,670381216,12),(1666,686106016,13),(1666,701830816,12),(1666,717555617,13),(1666,733280417,12),(1666,749005218,13),(1666,764730018,12),(1666,780454819,13),(1666,796179619,12),(1666,811904419,13),(1666,828234020,12),(1666,846378020,13),(1666,859683620,12),(1666,877827621,13),(1666,891133221,12),(1666,909277221,13),(1666,922582822,12),(1666,941331622,13),(1666,954032422,12),(1666,972781222,13),(1666,985482022,12),(1666,1004230822,13),(1666,1017536422,12),(1666,1035680422,13),(1666,1048986022,12),(1666,1067130022,13),(1666,1080435622,12),(1666,1099184422,13),(1666,1111885222,12),(1666,1130634022,13),(1666,1143334823,12),(1666,1162083623,13),(1666,1174784423,12),(1666,1193533223,13),(1666,1206838823,12),(1666,1224982823,13),(1666,1238288424,12),(1666,1256432424,13),(1666,1269738024,12),(1666,1288486824,13),(1666,1301187624,12),(1666,1319936424,13),(1666,1332637224,12),(1666,1351386025,13),(1666,1364691625,12),(1666,1382835625,13),(1666,1396141225,12),(1666,1414285225,13),(1666,1427590825,12),(1666,1445734826,13),(1666,1459040426,12),(1666,1477789226,13),(1666,1490490027,12),(1666,1509238827,13),(1666,1521939627,12),(1666,1540688427,13),(1666,1553994027,12),(1666,1572138027,13),(1666,1585443627,12),(1666,1603587627,13),(1666,1616893227,12),(1666,1635642027,13),(1666,1648342827,12),(1666,1667091627,13),(1666,1679792427,12),(1666,1698541227,13),(1666,1711846827,12),(1666,1729990827,13),(1666,1743296427,12),(1666,1761440427,13),(1666,1774746027,12),(1666,1792890027,13),(1666,1806195627,12),(1666,1824944427,13),(1666,1837645227,12),(1666,1856394027,13),(1666,1869094827,12),(1666,1887843627,13),(1666,1901149227,12),(1666,1919293227,13),(1666,1932598827,12),(1666,1950742827,13),(1666,1964048427,12),(1666,1982797227,13),(1666,1995498027,12),(1666,2014246827,13),(1666,2026947627,12),(1666,2045696427,13),(1666,2058397227,12),(1666,2077146027,13),(1666,2090451627,12),(1666,2108595627,13),(1666,2121901227,12),(1666,2140045227,13),(1667,-2147483648,4),(1667,-1631926800,1),(1667,-1616889600,2),(1667,-1601168400,1),(1667,-1585353600,2),(1667,-1442451600,1),(1667,-1427673600,2),(1667,-1379293200,1),(1667,-1364774400,2),(1667,-1348448400,1),(1667,-1333324800,2),(1667,-1316390400,1),(1667,-1301270400,2),(1667,-1284339600,1),(1667,-1269820800,2),(1667,-1026954000,1),(1667,-1017619200,2),(1667,-1001898000,1),(1667,-999482400,3),(1667,-986090400,1),(1667,-954115200,2),(1667,-940208400,6),(1667,-873079200,5),(1667,-862621200,6),(1667,-842839200,5),(1667,-828320400,6),(1667,-811389600,5),(1667,-796870800,6),(1667,-779940000,5),(1667,-765421200,6),(1667,-748490400,5),(1667,-733971600,6),(1667,-652327200,5),(1667,-639018000,6),(1667,135122403,5),(1667,150246003,6),(1667,166572004,5),(1667,181695604,6),(1667,196812005,5),(1667,212540405,6),(1667,228866406,5),(1667,243990006,6),(1667,260326807,7),(1667,276051607,8),(1667,283993207,6),(1667,291776408,9),(1667,307501208,10),(1667,323830809,9),(1667,338950809,10),(1667,354675609,9),(1667,370400410,10),(1667,386125210,9),(1667,401850011,10),(1667,417574811,9),(1667,433299612,10),(1667,449024412,9),(1667,465354012,10),(1667,481078812,9),(1667,496803613,10),(1667,512528413,9),(1667,528253213,10),(1667,543978013,9),(1667,559702813,10),(1667,575427614,9),(1667,591152414,10),(1667,606877214,9),(1667,622602014,10),(1667,638326815,9),(1667,654656415,10),(1667,670381216,9),(1667,686106016,10),(1667,701830816,9),(1667,717555617,10),(1667,733280417,9),(1667,749005218,10),(1667,764730018,9),(1667,780454819,10),(1667,796179619,9),(1667,811904419,10),(1667,828234020,9),(1667,846378020,10),(1667,859683620,9),(1667,877827621,10),(1667,891133221,9),(1667,909277221,10),(1667,922582822,9),(1667,941331622,10),(1667,954032422,9),(1667,972781222,10),(1667,985482022,9),(1667,1004230822,10),(1667,1017536422,9),(1667,1035680422,10),(1667,1048986022,9),(1667,1067130022,10),(1667,1080435622,9),(1667,1099184422,10),(1667,1111885222,9),(1667,1130634022,10),(1667,1143334823,9),(1667,1162083623,10),(1667,1174784423,9),(1667,1193533223,10),(1667,1206838823,9),(1667,1224982823,10),(1667,1238288424,9),(1667,1256432424,10),(1667,1269738024,9),(1667,1288486824,10),(1667,1301187624,9),(1667,1319936424,10),(1667,1332637224,9),(1667,1351386025,10),(1667,1364691625,9),(1667,1382835625,10),(1667,1396141225,9),(1667,1414285225,10),(1667,1427590825,9),(1667,1445734826,10),(1667,1459040426,9),(1667,1477789226,10),(1667,1490490027,9),(1667,1509238827,10),(1667,1521939627,9),(1667,1540688427,10),(1667,1553994027,9),(1667,1572138027,10),(1667,1585443627,9),(1667,1603587627,10),(1667,1616893227,9),(1667,1635642027,10),(1667,1648342827,9),(1667,1667091627,10),(1667,1679792427,9),(1667,1698541227,10),(1667,1711846827,9),(1667,1729990827,10),(1667,1743296427,9),(1667,1761440427,10),(1667,1774746027,9),(1667,1792890027,10),(1667,1806195627,9),(1667,1824944427,10),(1667,1837645227,9),(1667,1856394027,10),(1667,1869094827,9),(1667,1887843627,10),(1667,1901149227,9),(1667,1919293227,10),(1667,1932598827,9),(1667,1950742827,10),(1667,1964048427,9),(1667,1982797227,10),(1667,1995498027,9),(1667,2014246827,10),(1667,2026947627,9),(1667,2045696427,10),(1667,2058397227,9),(1667,2077146027,10),(1667,2090451627,9),(1667,2108595627,10),(1667,2121901227,9),(1667,2140045227,10),(1668,-2147483648,3),(1668,-1690765200,1),(1668,-1680487200,2),(1668,-1664758800,1),(1668,-1648951200,2),(1668,-1635123600,1),(1668,-1616896800,2),(1668,-1604278800,1),(1668,-1585533600,2),(1668,-1571014800,1),(1668,-1555293600,2),(1668,-932432400,1),(1668,-857257200,3),(1668,-844556400,4),(1668,-828226800,3),(1668,-812588400,4),(1668,-798073200,3),(1668,-781052400,1),(1668,-766717200,2),(1668,-750898800,4),(1668,-733359600,3),(1668,-719456400,4),(1668,-701917200,3),(1668,-689209200,4),(1668,-670460400,3),(1668,-114051600,4),(1668,-103168800,2),(1668,-81997200,4),(1668,-71715600,3),(1668,-50547600,4),(1668,-40266000,3),(1668,-18493200,4),(1668,-8211600,3),(1668,12956400,4),(1668,23238000,3),(1668,43801200,4),(1668,54687600,3),(1668,75855600,4),(1668,86742001,3),(1668,102380402,4),(1668,118105202,3),(1668,135730803,4),(1668,148518003,3),(1668,167187604,1),(1668,180489604,2),(1668,198637205,1),(1668,211939205,2),(1668,230086806,1),(1668,243388806,2),(1668,261536407,1),(1668,274838407,2),(1668,292986008,1),(1668,306288008,2),(1668,323312409,1),(1668,338342409,2),(1668,354675609,5),(1668,370400410,6),(1668,386125210,5),(1668,401850011,6),(1668,417574811,5),(1668,433299612,6),(1668,449024412,5),(1668,465354012,6),(1668,481078812,5),(1668,496803613,6),(1668,512528413,5),(1668,528253213,6),(1668,543978013,5),(1668,559702813,6),(1668,575427614,5),(1668,591152414,6),(1668,606877214,5),(1668,622602014,6),(1668,638326815,5),(1668,654656415,6),(1668,670381216,5),(1668,686106016,6),(1668,701830816,5),(1668,717555617,6),(1668,733280417,5),(1668,749005218,6),(1668,764730018,5),(1668,780454819,6),(1668,796179619,5),(1668,811904419,6),(1668,828234020,5),(1668,846378020,6),(1668,859683620,5),(1668,877827621,6),(1668,891133221,5),(1668,909277221,6),(1668,922582822,5),(1668,941331622,6),(1668,954032422,5),(1668,972781222,6),(1668,985482022,5),(1668,1004230822,6),(1668,1017536422,5),(1668,1035680422,6),(1668,1048986022,5),(1668,1067130022,6),(1668,1080435622,5),(1668,1099184422,6),(1668,1111885222,5),(1668,1130634022,6),(1668,1143334823,5),(1668,1162083623,6),(1668,1174784423,5),(1668,1193533223,6),(1668,1206838823,5),(1668,1224982823,6),(1668,1238288424,5),(1668,1256432424,6),(1668,1269738024,5),(1668,1288486824,6),(1668,1301187624,5),(1668,1319936424,6),(1668,1332637224,5),(1668,1351386025,6),(1668,1364691625,5),(1668,1382835625,6),(1668,1396141225,5),(1668,1414285225,6),(1668,1427590825,5),(1668,1445734826,6),(1668,1459040426,5),(1668,1477789226,6),(1668,1490490027,5),(1668,1509238827,6),(1668,1521939627,5),(1668,1540688427,6),(1668,1553994027,5),(1668,1572138027,6),(1668,1585443627,5),(1668,1603587627,6),(1668,1616893227,5),(1668,1635642027,6),(1668,1648342827,5),(1668,1667091627,6),(1668,1679792427,5),(1668,1698541227,6),(1668,1711846827,5),(1668,1729990827,6),(1668,1743296427,5),(1668,1761440427,6),(1668,1774746027,5),(1668,1792890027,6),(1668,1806195627,5),(1668,1824944427,6),(1668,1837645227,5),(1668,1856394027,6),(1668,1869094827,5),(1668,1887843627,6),(1668,1901149227,5),(1668,1919293227,6),(1668,1932598827,5),(1668,1950742827,6),(1668,1964048427,5),(1668,1982797227,6),(1668,1995498027,5),(1668,2014246827,6),(1668,2026947627,5),(1668,2045696427,6),(1668,2058397227,5),(1668,2077146027,6),(1668,2090451627,5),(1668,2108595627,6),(1668,2121901227,5),(1668,2140045227,6),(1669,-2147483648,1),(1669,-1535938789,3),(1669,-875671200,2),(1669,-859773600,3),(1669,354672009,2),(1669,370396810,3),(1669,386121610,2),(1669,401846411,3),(1669,417574811,4),(1669,433299612,5),(1669,449024412,4),(1669,465354012,5),(1669,481078812,4),(1669,496803613,5),(1669,512528413,4),(1669,528253213,5),(1669,543978013,4),(1669,559702813,5),(1669,575427614,4),(1669,591152414,5),(1669,606877214,4),(1669,622602014,5),(1669,638326815,4),(1669,654656415,5),(1669,670381216,4),(1669,686106016,5),(1669,701830816,4),(1669,717555617,5),(1669,733280417,4),(1669,749005218,5),(1669,764730018,4),(1669,780454819,5),(1669,796179619,4),(1669,811904419,5),(1669,828234020,4),(1669,846378020,5),(1669,859683620,4),(1669,877827621,5),(1669,891133221,4),(1669,909277221,5),(1669,922582822,4),(1669,941331622,5),(1669,954032422,4),(1669,972781222,5),(1669,985482022,4),(1669,1004230822,5),(1669,1017536422,4),(1669,1035680422,5),(1669,1048986022,4),(1669,1067130022,5),(1669,1080435622,4),(1669,1099184422,5),(1669,1111885222,4),(1669,1130634022,5),(1669,1143334823,4),(1669,1162083623,5),(1669,1174784423,4),(1669,1193533223,5),(1669,1206838823,4),(1669,1224982823,5),(1669,1238288424,4),(1669,1256432424,5),(1669,1269738024,4),(1669,1288486824,5),(1669,1301187624,4),(1669,1319936424,5),(1669,1332637224,4),(1669,1351386025,5),(1669,1364691625,4),(1669,1382835625,5),(1669,1396141225,4),(1669,1414285225,5),(1669,1427590825,4),(1669,1445734826,5),(1669,1459040426,4),(1669,1477789226,5),(1669,1490490027,4),(1669,1509238827,5),(1669,1521939627,4),(1669,1540688427,5),(1669,1553994027,4),(1669,1572138027,5),(1669,1585443627,4),(1669,1603587627,5),(1669,1616893227,4),(1669,1635642027,5),(1669,1648342827,4),(1669,1667091627,5),(1669,1679792427,4),(1669,1698541227,5),(1669,1711846827,4),(1669,1729990827,5),(1669,1743296427,4),(1669,1761440427,5),(1669,1774746027,4),(1669,1792890027,5),(1669,1806195627,4),(1669,1824944427,5),(1669,1837645227,4),(1669,1856394027,5),(1669,1869094827,4),(1669,1887843627,5),(1669,1901149227,4),(1669,1919293227,5),(1669,1932598827,4),(1669,1950742827,5),(1669,1964048427,4),(1669,1982797227,5),(1669,1995498027,4),(1669,2014246827,5),(1669,2026947627,4),(1669,2045696427,5),(1669,2058397227,4),(1669,2077146027,5),(1669,2090451627,4),(1669,2108595627,5),(1669,2121901227,4),(1669,2140045227,5),(1670,-2147483648,1),(1670,-1441158600,2),(1670,-1247536800,3),(1670,-899780400,6),(1670,-857257200,4),(1670,-844556400,5),(1670,-828226800,4),(1670,-812502000,5),(1670,-804650400,3),(1670,354920409,7),(1670,370728010,3),(1670,386456410,7),(1670,402264011,3),(1670,417992411,7),(1670,433800012,3),(1670,449614812,7),(1670,465346812,8),(1670,481071612,9),(1670,496796413,8),(1670,512521213,9),(1670,528246013,8),(1670,543970813,9),(1670,559695613,8),(1670,575420414,9),(1670,591145214,8),(1670,606870014,9),(1670,622594814,8),(1670,631141214,3),(1670,670374016,10),(1670,686102416,11),(1670,701827216,10),(1670,717552017,11),(1670,733276817,10),(1670,749001618,11),(1670,764726418,10),(1670,780451219,11),(1670,796176019,10),(1670,811900819,11),(1670,828230420,10),(1670,846374420,11),(1670,859680020,10),(1670,877824021,11),(1670,891129621,10),(1670,909273621,11),(1670,922579222,10),(1670,941328022,11),(1670,954028822,10),(1670,972777622,11),(1670,985478422,10),(1670,1004227222,11),(1670,1017532822,10),(1670,1035676822,11),(1670,1048982422,10),(1670,1067126422,11),(1670,1080432022,10),(1670,1099180822,11),(1670,1111881622,10),(1670,1130630422,11),(1670,1143331223,10),(1670,1162080023,11),(1670,1174780823,10),(1670,1193529623,11),(1670,1206835223,10),(1670,1224979223,11),(1670,1238284824,10),(1670,1256428824,11),(1670,1269734424,10),(1670,1288483224,11),(1670,1301184024,12),(1671,-2147483648,1),(1671,-1855958961,6),(1671,-1689814800,2),(1671,-1680397200,3),(1671,-1665363600,2),(1671,-1648342800,3),(1671,-1635123600,2),(1671,-1616893200,3),(1671,-1604278800,2),(1671,-1585443600,3),(1671,-1574038800,2),(1671,-1552266000,3),(1671,-1539997200,2),(1671,-1520557200,3),(1671,-1507510800,2),(1671,-1490576400,3),(1671,-1470618000,2),(1671,-1459126800,3),(1671,-1444006800,2),(1671,-1427677200,3),(1671,-1411952400,2),(1671,-1396227600,3),(1671,-1379293200,2),(1671,-1364778000,3),(1671,-1348448400,2),(1671,-1333328400,3),(1671,-1316394000,2),(1671,-1301274000,3),(1671,-1284339600,2),(1671,-1269824400,3),(1671,-1253494800,2),(1671,-1238374800,3),(1671,-1221440400,2),(1671,-1206925200,3),(1671,-1191200400,2),(1671,-1175475600,3),(1671,-1160355600,2),(1671,-1143421200,3),(1671,-1127696400,2),(1671,-1111971600,3),(1671,-1096851600,2),(1671,-1080522000,3),(1671,-1063587600,2),(1671,-1049072400,3),(1671,-1033347600,2),(1671,-1017622800,3),(1671,-1002502800,2),(1671,-986173200,3),(1671,-969238800,2),(1671,-950490000,3),(1671,-942012000,4),(1671,-904438800,5),(1671,-891136800,4),(1671,-877827600,5),(1671,-857257200,4),(1671,-844556400,5),(1671,-828226800,4),(1671,-812502000,5),(1671,-796266000,4),(1671,-781052400,5),(1671,-766623600,8),(1671,196819205,7),(1671,212540405,8),(1671,228877206,9),(1671,243997206,10),(1671,260326807,9),(1671,276051607,10),(1671,291776408,9),(1671,307501208,10),(1671,323830809,9),(1671,338950809,10),(1671,354675609,9),(1671,370400410,10),(1671,386125210,9),(1671,401850011,10),(1671,417574811,9),(1671,433299612,10),(1671,449024412,9),(1671,465354012,10),(1671,481078812,9),(1671,496803613,10),(1671,512528413,9),(1671,528253213,10),(1671,543978013,9),(1671,559702813,10),(1671,575427614,9),(1671,591152414,10),(1671,606877214,9),(1671,622602014,10),(1671,638326815,9),(1671,654656415,10),(1671,670381216,9),(1671,686106016,10),(1671,701830816,9),(1671,717555617,10),(1671,733280417,9),(1671,749005218,10),(1671,764730018,9),(1671,780454819,10),(1671,796179619,9),(1671,811904419,10),(1671,828234020,9),(1671,846378020,10),(1671,859683620,9),(1671,877827621,10),(1671,891133221,9),(1671,909277221,10),(1671,922582822,9),(1671,941331622,10),(1671,954032422,9),(1671,972781222,10),(1671,985482022,9),(1671,1004230822,10),(1671,1017536422,9),(1671,1035680422,10),(1671,1048986022,9),(1671,1067130022,10),(1671,1080435622,9),(1671,1099184422,10),(1671,1111885222,9),(1671,1130634022,10),(1671,1143334823,9),(1671,1162083623,10),(1671,1174784423,9),(1671,1193533223,10),(1671,1206838823,9),(1671,1224982823,10),(1671,1238288424,9),(1671,1256432424,10),(1671,1269738024,9),(1671,1288486824,10),(1671,1301187624,9),(1671,1319936424,10),(1671,1332637224,9),(1671,1351386025,10),(1671,1364691625,9),(1671,1382835625,10),(1671,1396141225,9),(1671,1414285225,10),(1671,1427590825,9),(1671,1445734826,10),(1671,1459040426,9),(1671,1477789226,10),(1671,1490490027,9),(1671,1509238827,10),(1671,1521939627,9),(1671,1540688427,10),(1671,1553994027,9),(1671,1572138027,10),(1671,1585443627,9),(1671,1603587627,10),(1671,1616893227,9),(1671,1635642027,10),(1671,1648342827,9),(1671,1667091627,10),(1671,1679792427,9),(1671,1698541227,10),(1671,1711846827,9),(1671,1729990827,10),(1671,1743296427,9),(1671,1761440427,10),(1671,1774746027,9),(1671,1792890027,10),(1671,1806195627,9),(1671,1824944427,10),(1671,1837645227,9),(1671,1856394027,10),(1671,1869094827,9),(1671,1887843627,10),(1671,1901149227,9),(1671,1919293227,10),(1671,1932598827,9),(1671,1950742827,10),(1671,1964048427,9),(1671,1982797227,10),(1671,1995498027,9),(1671,2014246827,10),(1671,2026947627,9),(1671,2045696427,10),(1671,2058397227,9),(1671,2077146027,10),(1671,2090451627,9),(1671,2108595627,10),(1671,2121901227,9),(1671,2140045227,10),(1672,-2147483648,1),(1672,-1688265017,3),(1672,-1656819079,2),(1672,-1641353479,3),(1672,-1627965079,4),(1672,-1618716679,2),(1672,-1596429079,4),(1672,-1593820800,5),(1672,-1589860800,6),(1672,-1542427200,7),(1672,-1539493200,8),(1672,-1525323600,7),(1672,-1522728000,6),(1672,-1491188400,9),(1672,-1247536800,6),(1672,354920409,7),(1672,370728010,6),(1672,386456410,7),(1672,402264011,6),(1672,417992411,7),(1672,433800012,6),(1672,449614812,7),(1672,465346812,10),(1672,481071612,11),(1672,496796413,10),(1672,512521213,11),(1672,528246013,10),(1672,543970813,11),(1672,559695613,10),(1672,575420414,11),(1672,591145214,10),(1672,606870014,11),(1672,622594814,10),(1672,638319615,11),(1672,654649215,10),(1672,670374016,12),(1672,686102416,13),(1672,695779216,10),(1672,701823616,11),(1672,717548417,10),(1672,733273217,11),(1672,748998018,10),(1672,764722818,11),(1672,780447619,10),(1672,796172419,11),(1672,811897219,10),(1672,828226820,11),(1672,846370820,10),(1672,859676420,11),(1672,877820421,10),(1672,891126021,11),(1672,909270021,10),(1672,922575622,11),(1672,941324422,10),(1672,954025222,11),(1672,972774022,10),(1672,985474822,11),(1672,1004223622,10),(1672,1017529222,11),(1672,1035673222,10),(1672,1048978822,11),(1672,1067122822,10),(1672,1080428422,11),(1672,1099177222,10),(1672,1111878022,11),(1672,1130626822,10),(1672,1143327623,11),(1672,1162076423,10),(1672,1174777223,11),(1672,1193526023,10),(1672,1206831623,11),(1672,1224975623,10),(1672,1238281224,11),(1672,1256425224,10),(1672,1269730824,11),(1672,1288479624,10),(1672,1301180424,14),(1672,1414274425,10),(1673,-2147483648,0),(1673,-1518920008,2),(1673,166572004,1),(1673,182293204,2),(1673,200959205,1),(1673,213829205,2),(1673,228866406,1),(1673,243982806,2),(1673,260316007,1),(1673,276123607,2),(1673,291765608,1),(1673,307486808,2),(1673,323820009,1),(1673,338936409,2),(1673,354664809,1),(1673,370386010,2),(1673,386114410,1),(1673,401835611,2),(1673,417564011,1),(1673,433285212,2),(1673,449013612,1),(1673,465339612,2),(1673,481068012,1),(1673,496789213,2),(1673,512517613,1),(1673,528238813,2),(1673,543967213,1),(1673,559688413,2),(1673,575416814,1),(1673,591138014,2),(1673,606866414,1),(1673,622587614,2),(1673,638316015,1),(1673,654642015,2),(1673,670370416,1),(1673,686091616,2),(1673,701820016,1),(1673,717541217,2),(1673,733269617,1),(1673,748990818,2),(1673,764719218,1),(1673,780440419,2),(1673,796168819,1),(1673,811890019,2),(1673,828223220,1),(1673,843944420,2),(1673,859672820,1),(1673,875394021,2),(1673,891122421,1),(1673,909277221,3),(1673,922582822,4),(1673,941331622,3),(1673,954032422,4),(1673,972781222,3),(1673,985482022,4),(1673,1004230822,3),(1673,1017536422,4),(1673,1035680422,3),(1673,1048986022,4),(1673,1067130022,3),(1673,1080435622,4),(1673,1099184422,3),(1673,1111885222,4),(1673,1130634022,3),(1673,1143334823,4),(1673,1162083623,3),(1673,1174784423,4),(1673,1193533223,3),(1673,1206838823,4),(1673,1224982823,3),(1673,1238288424,4),(1673,1256432424,3),(1673,1269738024,4),(1673,1288486824,3),(1673,1301187624,4),(1673,1319936424,3),(1673,1332637224,4),(1673,1351386025,3),(1673,1364691625,4),(1673,1382835625,3),(1673,1396141225,4),(1673,1414285225,3),(1673,1427590825,4),(1673,1445734826,3),(1673,1459040426,4),(1673,1477789226,3),(1673,1490490027,4),(1673,1509238827,3),(1673,1521939627,4),(1673,1540688427,3),(1673,1553994027,4),(1673,1572138027,3),(1673,1585443627,4),(1673,1603587627,3),(1673,1616893227,4),(1673,1635642027,3),(1673,1648342827,4),(1673,1667091627,3),(1673,1679792427,4),(1673,1698541227,3),(1673,1711846827,4),(1673,1729990827,3),(1673,1743296427,4),(1673,1761440427,3),(1673,1774746027,4),(1673,1792890027,3),(1673,1806195627,4),(1673,1824944427,3),(1673,1837645227,4),(1673,1856394027,3),(1673,1869094827,4),(1673,1887843627,3),(1673,1901149227,4),(1673,1919293227,3),(1673,1932598827,4),(1673,1950742827,3),(1673,1964048427,4),(1673,1982797227,3),(1673,1995498027,4),(1673,2014246827,3),(1673,2026947627,4),(1673,2045696427,3),(1673,2058397227,4),(1673,2077146027,3),(1673,2090451627,4),(1673,2108595627,3),(1673,2121901227,4),(1673,2140045227,3),(1674,-2147483648,2),(1674,-1691884800,1),(1674,-1680573600,2),(1674,-927511200,1),(1674,-857257200,3),(1674,-844556400,4),(1674,-828226800,3),(1674,-812502000,4),(1674,-796777200,3),(1674,-781052400,4),(1674,-765327600,3),(1674,-340844400,4),(1674,-324514800,3),(1674,-308790000,4),(1674,-293065200,3),(1674,-277340400,4),(1674,-261615600,3),(1674,-245890800,4),(1674,-230166000,3),(1674,-214441200,4),(1674,-198716400,3),(1674,-182991600,4),(1674,-166662000,3),(1674,-147913200,4),(1674,-135212400,3),(1674,315529208,2),(1674,323830809,5),(1674,338950809,6),(1674,354675609,5),(1674,370400410,6),(1674,386125210,5),(1674,401850011,6),(1674,417574811,5),(1674,433299612,6),(1674,449024412,5),(1674,465354012,6),(1674,481078812,5),(1674,496803613,6),(1674,512528413,5),(1674,528253213,6),(1674,543978013,5),(1674,559702813,6),(1674,575427614,5),(1674,591152414,6),(1674,606877214,5),(1674,622602014,6),(1674,638326815,5),(1674,654656415,6),(1674,670381216,5),(1674,686106016,6),(1674,701830816,5),(1674,717555617,6),(1674,733280417,5),(1674,749005218,6),(1674,764730018,5),(1674,780454819,6),(1674,796179619,5),(1674,811904419,6),(1674,828234020,5),(1674,846378020,6),(1674,859683620,5),(1674,877827621,6),(1674,891133221,5),(1674,909277221,6),(1674,922582822,5),(1674,941331622,6),(1674,954032422,5),(1674,972781222,6),(1674,985482022,5),(1674,1004230822,6),(1674,1017536422,5),(1674,1035680422,6),(1674,1048986022,5),(1674,1067130022,6),(1674,1080435622,5),(1674,1099184422,6),(1674,1111885222,5),(1674,1130634022,6),(1674,1143334823,5),(1674,1162083623,6),(1674,1174784423,5),(1674,1193533223,6),(1674,1206838823,5),(1674,1224982823,6),(1674,1238288424,5),(1674,1256432424,6),(1674,1269738024,5),(1674,1288486824,6),(1674,1301187624,5),(1674,1319936424,6),(1674,1332637224,5),(1674,1351386025,6),(1674,1364691625,5),(1674,1382835625,6),(1674,1396141225,5),(1674,1414285225,6),(1674,1427590825,5),(1674,1445734826,6),(1674,1459040426,5),(1674,1477789226,6),(1674,1490490027,5),(1674,1509238827,6),(1674,1521939627,5),(1674,1540688427,6),(1674,1553994027,5),(1674,1572138027,6),(1674,1585443627,5),(1674,1603587627,6),(1674,1616893227,5),(1674,1635642027,6),(1674,1648342827,5),(1674,1667091627,6),(1674,1679792427,5),(1674,1698541227,6),(1674,1711846827,5),(1674,1729990827,6),(1674,1743296427,5),(1674,1761440427,6),(1674,1774746027,5),(1674,1792890027,6),(1674,1806195627,5),(1674,1824944427,6),(1674,1837645227,5),(1674,1856394027,6),(1674,1869094827,5),(1674,1887843627,6),(1674,1901149227,5),(1674,1919293227,6),(1674,1932598827,5),(1674,1950742827,6),(1674,1964048427,5),(1674,1982797227,6),(1674,1995498027,5),(1674,2014246827,6),(1674,2026947627,5),(1674,2045696427,6),(1674,2058397227,5),(1674,2077146027,6),(1674,2090451627,5),(1674,2108595627,6),(1674,2121901227,5),(1674,2140045227,6),(1675,-2147483648,1),(1675,-1855958901,5),(1675,-1689814800,2),(1675,-1680397200,3),(1675,-1665363600,2),(1675,-1648342800,3),(1675,-1635123600,2),(1675,-1616893200,3),(1675,-1604278800,2),(1675,-1585443600,3),(1675,-1574038800,2),(1675,-1552266000,3),(1675,-1539997200,2),(1675,-1520557200,3),(1675,-1507510800,2),(1675,-1490576400,3),(1675,-1470618000,2),(1675,-1459126800,3),(1675,-1444006800,2),(1675,-1427677200,3),(1675,-1411952400,2),(1675,-1396227600,3),(1675,-1379293200,2),(1675,-1364778000,3),(1675,-1348448400,2),(1675,-1333328400,3),(1675,-1316394000,2),(1675,-1301274000,3),(1675,-1284339600,2),(1675,-1269824400,3),(1675,-1253494800,2),(1675,-1238374800,3),(1675,-1221440400,2),(1675,-1206925200,3),(1675,-1191200400,2),(1675,-1175475600,3),(1675,-1160355600,2),(1675,-1143421200,3),(1675,-1127696400,2),(1675,-1111971600,3),(1675,-1096851600,2),(1675,-1080522000,3),(1675,-1063587600,2),(1675,-1049072400,3),(1675,-1033347600,2),(1675,-1017622800,3),(1675,-1002502800,2),(1675,-986173200,3),(1675,-969238800,2),(1675,-950490000,3),(1675,-942012000,4),(1675,-932436000,8),(1675,-857257200,6),(1675,-844556400,7),(1675,-828226800,6),(1675,-812502000,7),(1675,-800071200,9),(1675,-796266000,4),(1675,-781052400,9),(1675,-766623600,10),(1675,196819205,8),(1675,212540405,10),(1675,228877206,11),(1675,243997206,12),(1675,260326807,11),(1675,276051607,12),(1675,291776408,11),(1675,307501208,12),(1675,323830809,11),(1675,338950809,12),(1675,354675609,11),(1675,370400410,12),(1675,386125210,11),(1675,401850011,12),(1675,417574811,11),(1675,433299612,12),(1675,449024412,11),(1675,465354012,12),(1675,481078812,11),(1675,496803613,12),(1675,512528413,11),(1675,528253213,12),(1675,543978013,11),(1675,559702813,12),(1675,575427614,11),(1675,591152414,12),(1675,606877214,11),(1675,622602014,12),(1675,638326815,11),(1675,654656415,12),(1675,670381216,11),(1675,686106016,12),(1675,701830816,11),(1675,717555617,12),(1675,733280417,11),(1675,749005218,12),(1675,764730018,11),(1675,780454819,12),(1675,796179619,11),(1675,811904419,12),(1675,828234020,11),(1675,846378020,12),(1675,859683620,11),(1675,877827621,12),(1675,891133221,11),(1675,909277221,12),(1675,922582822,11),(1675,941331622,12),(1675,954032422,11),(1675,972781222,12),(1675,985482022,11),(1675,1004230822,12),(1675,1017536422,11),(1675,1035680422,12),(1675,1048986022,11),(1675,1067130022,12),(1675,1080435622,11),(1675,1099184422,12),(1675,1111885222,11),(1675,1130634022,12),(1675,1143334823,11),(1675,1162083623,12),(1675,1174784423,11),(1675,1193533223,12),(1675,1206838823,11),(1675,1224982823,12),(1675,1238288424,11),(1675,1256432424,12),(1675,1269738024,11),(1675,1288486824,12),(1675,1301187624,11),(1675,1319936424,12),(1675,1332637224,11),(1675,1351386025,12),(1675,1364691625,11),(1675,1382835625,12),(1675,1396141225,11),(1675,1414285225,12),(1675,1427590825,11),(1675,1445734826,12),(1675,1459040426,11),(1675,1477789226,12),(1675,1490490027,11),(1675,1509238827,12),(1675,1521939627,11),(1675,1540688427,12),(1675,1553994027,11),(1675,1572138027,12),(1675,1585443627,11),(1675,1603587627,12),(1675,1616893227,11),(1675,1635642027,12),(1675,1648342827,11),(1675,1667091627,12),(1675,1679792427,11),(1675,1698541227,12),(1675,1711846827,11),(1675,1729990827,12),(1675,1743296427,11),(1675,1761440427,12),(1675,1774746027,11),(1675,1792890027,12),(1675,1806195627,11),(1675,1824944427,12),(1675,1837645227,11),(1675,1856394027,12),(1675,1869094827,11),(1675,1887843627,12),(1675,1901149227,11),(1675,1919293227,12),(1675,1932598827,11),(1675,1950742827,12),(1675,1964048427,11),(1675,1982797227,12),(1675,1995498027,11),(1675,2014246827,12),(1675,2026947627,11),(1675,2045696427,12),(1675,2058397227,11),(1675,2077146027,12),(1675,2090451627,11),(1675,2108595627,12),(1675,2121901227,11),(1675,2140045227,12),(1676,-2147483648,1),(1676,-905824800,4),(1676,-857257200,2),(1676,-844556400,3),(1676,-828226800,2),(1676,-812502000,3),(1676,-796777200,2),(1676,-788922000,1),(1676,-777942000,3),(1676,-766623600,2),(1676,407199611,1),(1676,417574811,5),(1676,433299612,6),(1676,449024412,5),(1676,465354012,6),(1676,481078812,5),(1676,496803613,6),(1676,512528413,5),(1676,528253213,6),(1676,543978013,5),(1676,559702813,6),(1676,575427614,5),(1676,591152414,6),(1676,606877214,5),(1676,622602014,6),(1676,638326815,5),(1676,654656415,6),(1676,670381216,5),(1676,686106016,6),(1676,701830816,5),(1676,717555617,6),(1676,733280417,5),(1676,749005218,6),(1676,764730018,5),(1676,780454819,6),(1676,796179619,5),(1676,811904419,6),(1676,828234020,5),(1676,846378020,6),(1676,859683620,5),(1676,877827621,6),(1676,891133221,5),(1676,909277221,6),(1676,922582822,5),(1676,941331622,6),(1676,954032422,5),(1676,972781222,6),(1676,985482022,5),(1676,1004230822,6),(1676,1017536422,5),(1676,1035680422,6),(1676,1048986022,5),(1676,1067130022,6),(1676,1080435622,5),(1676,1099184422,6),(1676,1111885222,5),(1676,1130634022,6),(1676,1143334823,5),(1676,1162083623,6),(1676,1174784423,5),(1676,1193533223,6),(1676,1206838823,5),(1676,1224982823,6),(1676,1238288424,5),(1676,1256432424,6),(1676,1269738024,5),(1676,1288486824,6),(1676,1301187624,5),(1676,1319936424,6),(1676,1332637224,5),(1676,1351386025,6),(1676,1364691625,5),(1676,1382835625,6),(1676,1396141225,5),(1676,1414285225,6),(1676,1427590825,5),(1676,1445734826,6),(1676,1459040426,5),(1676,1477789226,6),(1676,1490490027,5),(1676,1509238827,6),(1676,1521939627,5),(1676,1540688427,6),(1676,1553994027,5),(1676,1572138027,6),(1676,1585443627,5),(1676,1603587627,6),(1676,1616893227,5),(1676,1635642027,6),(1676,1648342827,5),(1676,1667091627,6),(1676,1679792427,5),(1676,1698541227,6),(1676,1711846827,5),(1676,1729990827,6),(1676,1743296427,5),(1676,1761440427,6),(1676,1774746027,5),(1676,1792890027,6),(1676,1806195627,5),(1676,1824944427,6),(1676,1837645227,5),(1676,1856394027,6),(1676,1869094827,5),(1676,1887843627,6),(1676,1901149227,5),(1676,1919293227,6),(1676,1932598827,5),(1676,1950742827,6),(1676,1964048427,5),(1676,1982797227,6),(1676,1995498027,5),(1676,2014246827,6),(1676,2026947627,5),(1676,2045696427,6),(1676,2058397227,5),(1676,2077146027,6),(1676,2090451627,5),(1676,2108595627,6),(1676,2121901227,5),(1676,2140045227,6),(1677,-2147483648,2),(1677,-1693706400,1),(1677,-1680483600,2),(1677,-1663455600,3),(1677,-1650150000,4),(1677,-1632006000,3),(1677,-1618700400,4),(1677,-938905200,3),(1677,-857257200,4),(1677,-844556400,3),(1677,-828226800,4),(1677,-812502000,3),(1677,-796777200,4),(1677,-781052400,3),(1677,-777866400,1),(1677,-765327600,4),(1677,-746578800,3),(1677,-733359600,4),(1677,-728517600,5),(1677,-721260000,2),(1677,-716425200,3),(1677,-701910000,4),(1677,-684975600,3),(1677,-670460400,4),(1677,-654217200,3),(1677,-639010800,4),(1677,283993207,2),(1677,291776408,6),(1677,307501208,7),(1677,323830809,6),(1677,338950809,7),(1677,354675609,6),(1677,370400410,7),(1677,386125210,6),(1677,401850011,7),(1677,417574811,6),(1677,433299612,7),(1677,449024412,6),(1677,465354012,7),(1677,481078812,6),(1677,496803613,7),(1677,512528413,6),(1677,528253213,7),(1677,543978013,6),(1677,559702813,7),(1677,575427614,6),(1677,591152414,7),(1677,606877214,6),(1677,622602014,7),(1677,638326815,6),(1677,654656415,7),(1677,670381216,6),(1677,686106016,7),(1677,701830816,6),(1677,717555617,7),(1677,733280417,6),(1677,749005218,7),(1677,764730018,6),(1677,780454819,7),(1677,796179619,6),(1677,811904419,7),(1677,828234020,6),(1677,846378020,7),(1677,859683620,6),(1677,877827621,7),(1677,891133221,6),(1677,909277221,7),(1677,922582822,6),(1677,941331622,7),(1677,954032422,6),(1677,972781222,7),(1677,985482022,6),(1677,1004230822,7),(1677,1017536422,6),(1677,1035680422,7),(1677,1048986022,6),(1677,1067130022,7),(1677,1080435622,6),(1677,1099184422,7),(1677,1111885222,6),(1677,1130634022,7),(1677,1143334823,6),(1677,1162083623,7),(1677,1174784423,6),(1677,1193533223,7),(1677,1206838823,6),(1677,1224982823,7),(1677,1238288424,6),(1677,1256432424,7),(1677,1269738024,6),(1677,1288486824,7),(1677,1301187624,6),(1677,1319936424,7),(1677,1332637224,6),(1677,1351386025,7),(1677,1364691625,6),(1677,1382835625,7),(1677,1396141225,6),(1677,1414285225,7),(1677,1427590825,6),(1677,1445734826,7),(1677,1459040426,6),(1677,1477789226,7),(1677,1490490027,6),(1677,1509238827,7),(1677,1521939627,6),(1677,1540688427,7),(1677,1553994027,6),(1677,1572138027,7),(1677,1585443627,6),(1677,1603587627,7),(1677,1616893227,6),(1677,1635642027,7),(1677,1648342827,6),(1677,1667091627,7),(1677,1679792427,6),(1677,1698541227,7),(1677,1711846827,6),(1677,1729990827,7),(1677,1743296427,6),(1677,1761440427,7),(1677,1774746027,6),(1677,1792890027,7),(1677,1806195627,6),(1677,1824944427,7),(1677,1837645227,6),(1677,1856394027,7),(1677,1869094827,6),(1677,1887843627,7),(1677,1901149227,6),(1677,1919293227,7),(1677,1932598827,6),(1677,1950742827,7),(1677,1964048427,6),(1677,1982797227,7),(1677,1995498027,6),(1677,2014246827,7),(1677,2026947627,6),(1677,2045696427,7),(1677,2058397227,6),(1677,2077146027,7),(1677,2090451627,6),(1677,2108595627,7),(1677,2121901227,6),(1677,2140045227,7),(1678,-2147483648,1),(1678,-1632008194,2),(1678,-1618702594,1),(1678,-1601681794,2),(1678,-1597275394,1),(1678,-1377308194,3),(1678,-928029600,4),(1678,-899521200,7),(1678,-857257200,5),(1678,-844556400,6),(1678,-828226800,5),(1678,-812502000,6),(1678,-796777200,5),(1678,-795834000,4),(1678,354920409,8),(1678,370728010,4),(1678,386456410,8),(1678,402264011,4),(1678,417992411,8),(1678,433800012,4),(1678,449614812,8),(1678,465346812,9),(1678,481071612,10),(1678,496796413,9),(1678,512521213,10),(1678,528246013,9),(1678,543970813,10),(1678,559695613,9),(1678,575420414,10),(1678,591145214,9),(1678,606870014,11),(1678,622598414,12),(1678,638323215,11),(1678,654652815,12),(1678,670377616,11),(1678,686102416,12),(1678,701827216,11),(1678,717552017,12),(1678,733276817,11),(1678,749001618,12),(1678,764726418,11),(1678,780451219,12),(1678,796176019,11),(1678,811900819,12),(1678,828230420,11),(1678,843955220,12),(1678,853797620,3),(1678,859683620,13),(1678,877827621,14),(1678,891133221,13),(1678,909277221,14),(1678,922582822,13),(1678,941331622,14),(1678,951775222,3),(1678,985482022,13),(1678,1004230822,14),(1678,1017536422,13),(1678,1035680422,14),(1678,1048986022,13),(1678,1067130022,14),(1678,1080435622,13),(1678,1099184422,14),(1678,1111885222,13),(1678,1130634022,14),(1678,1143334823,13),(1678,1162083623,14),(1678,1174784423,13),(1678,1193533223,14),(1678,1206838823,13),(1678,1224982823,14),(1678,1238288424,13),(1678,1256432424,14),(1678,1269738024,13),(1678,1288486824,14),(1678,1301187624,13),(1678,1319936424,14),(1678,1332637224,13),(1678,1351386025,14),(1678,1364691625,13),(1678,1382835625,14),(1678,1396141225,13),(1678,1414285225,14),(1678,1427590825,13),(1678,1445734826,14),(1678,1459040426,13),(1678,1477789226,14),(1678,1490490027,13),(1678,1509238827,14),(1678,1521939627,13),(1678,1540688427,14),(1678,1553994027,13),(1678,1572138027,14),(1678,1585443627,13),(1678,1603587627,14),(1678,1616893227,13),(1678,1635642027,14),(1678,1648342827,13),(1678,1667091627,14),(1678,1679792427,13),(1678,1698541227,14),(1678,1711846827,13),(1678,1729990827,14),(1678,1743296427,13),(1678,1761440427,14),(1678,1774746027,13),(1678,1792890027,14),(1678,1806195627,13),(1678,1824944427,14),(1678,1837645227,13),(1678,1856394027,14),(1678,1869094827,13),(1678,1887843627,14),(1678,1901149227,13),(1678,1919293227,14),(1678,1932598827,13),(1678,1950742827,14),(1678,1964048427,13),(1678,1982797227,14),(1678,1995498027,13),(1678,2014246827,14),(1678,2026947627,13),(1678,2045696427,14),(1678,2058397227,13),(1678,2077146027,14),(1678,2090451627,13),(1678,2108595627,14),(1678,2121901227,13),(1678,2140045227,14),(1679,-2147483648,2),(1679,-1690765200,1),(1679,-1680487200,2),(1679,-1664758800,1),(1679,-1648951200,2),(1679,-1635123600,1),(1679,-1616896800,2),(1679,-1604278800,1),(1679,-1585533600,2),(1679,-1571014800,1),(1679,-1555293600,2),(1679,-932432400,1),(1679,-857257200,3),(1679,-844556400,4),(1679,-830311200,1),(1679,-828226800,3),(1679,-812502000,4),(1679,-807156000,1),(1679,-798073200,3),(1679,-781052400,1),(1679,-766717200,2),(1679,-750898800,4),(1679,-733359600,3),(1679,-719456400,4),(1679,-701917200,3),(1679,-689209200,4),(1679,-670460400,3),(1679,-114051600,4),(1679,-103168800,2),(1679,-81997200,4),(1679,-71715600,3),(1679,-50547600,4),(1679,-40266000,3),(1679,-18493200,4),(1679,-8211600,3),(1679,12956400,4),(1679,23238000,3),(1679,43801200,4),(1679,54687600,3),(1679,75855600,4),(1679,86742001,3),(1679,107910002,4),(1679,118191602,3),(1679,138754803,4),(1679,149641203,3),(1679,170809204,4),(1679,181090804,3),(1679,202258805,4),(1679,212540405,3),(1679,233103606,4),(1679,243990006,3),(1679,265158007,4),(1679,276044407,3),(1679,296607608,4),(1679,307494008,3),(1679,315529208,2),(1679,323830809,5),(1679,338950809,6),(1679,354675609,5),(1679,370400410,6),(1679,386125210,5),(1679,401850011,6),(1679,417574811,5),(1679,433299612,6),(1679,449024412,5),(1679,465354012,6),(1679,481078812,5),(1679,496803613,6),(1679,512528413,5),(1679,528253213,6),(1679,543978013,5),(1679,559702813,6),(1679,575427614,5),(1679,591152414,6),(1679,606877214,5),(1679,622602014,6),(1679,638326815,5),(1679,654656415,6),(1679,670381216,5),(1679,686106016,6),(1679,701830816,5),(1679,717555617,6),(1679,733280417,5),(1679,749005218,6),(1679,764730018,5),(1679,780454819,6),(1679,796179619,5),(1679,811904419,6),(1679,828234020,5),(1679,846378020,6),(1679,859683620,5),(1679,877827621,6),(1679,891133221,5),(1679,909277221,6),(1679,922582822,5),(1679,941331622,6),(1679,954032422,5),(1679,972781222,6),(1679,985482022,5),(1679,1004230822,6),(1679,1017536422,5),(1679,1035680422,6),(1679,1048986022,5),(1679,1067130022,6),(1679,1080435622,5),(1679,1099184422,6),(1679,1111885222,5),(1679,1130634022,6),(1679,1143334823,5),(1679,1162083623,6),(1679,1174784423,5),(1679,1193533223,6),(1679,1206838823,5),(1679,1224982823,6),(1679,1238288424,5),(1679,1256432424,6),(1679,1269738024,5),(1679,1288486824,6),(1679,1301187624,5),(1679,1319936424,6),(1679,1332637224,5),(1679,1351386025,6),(1679,1364691625,5),(1679,1382835625,6),(1679,1396141225,5),(1679,1414285225,6),(1679,1427590825,5),(1679,1445734826,6),(1679,1459040426,5),(1679,1477789226,6),(1679,1490490027,5),(1679,1509238827,6),(1679,1521939627,5),(1679,1540688427,6),(1679,1553994027,5),(1679,1572138027,6),(1679,1585443627,5),(1679,1603587627,6),(1679,1616893227,5),(1679,1635642027,6),(1679,1648342827,5),(1679,1667091627,6),(1679,1679792427,5),(1679,1698541227,6),(1679,1711846827,5),(1679,1729990827,6),(1679,1743296427,5),(1679,1761440427,6),(1679,1774746027,5),(1679,1792890027,6),(1679,1806195627,5),(1679,1824944427,6),(1679,1837645227,5),(1679,1856394027,6),(1679,1869094827,5),(1679,1887843627,6),(1679,1901149227,5),(1679,1919293227,6),(1679,1932598827,5),(1679,1950742827,6),(1679,1964048427,5),(1679,1982797227,6),(1679,1995498027,5),(1679,2014246827,6),(1679,2026947627,5),(1679,2045696427,6),(1679,2058397227,5),(1679,2077146027,6),(1679,2090451627,5),(1679,2108595627,6),(1679,2121901227,5),(1679,2140045227,6),(1680,-2147483648,0),(1680,-1593820800,1),(1680,-1247540400,2),(1680,354916809,3),(1680,370724410,2),(1680,386452810,3),(1680,402260411,2),(1680,417988811,3),(1680,433796412,2),(1680,449611212,3),(1680,465343212,4),(1680,481068012,5),(1680,496792813,4),(1680,512517613,5),(1680,528242413,4),(1680,543967213,5),(1680,559692013,4),(1680,575416814,5),(1680,591141614,4),(1680,606866414,6),(1680,622594814,7),(1680,638319615,6),(1680,654649215,7),(1680,670374016,8),(1680,686102416,7),(1680,687916816,2),(1680,701820016,5),(1680,717544817,4),(1680,733269617,5),(1680,748994418,4),(1680,764719218,5),(1680,780444019,4),(1680,796168819,5),(1680,811893619,4),(1680,828223220,5),(1680,846367220,4),(1680,859672820,5),(1680,877816821,4),(1680,891122421,5),(1680,909266421,4),(1680,922572022,5),(1680,941320822,4),(1680,954021622,5),(1680,972770422,4),(1680,985471222,5),(1680,1004220022,4),(1680,1017525622,5),(1680,1035669622,4),(1680,1048975222,5),(1680,1067119222,4),(1680,1080424822,5),(1680,1099173622,4),(1680,1111874422,5),(1680,1130623222,4),(1680,1143324023,5),(1680,1162072823,4),(1680,1174773623,5),(1680,1193522423,4),(1680,1206828023,5),(1680,1224972023,4),(1680,1238277624,5),(1680,1256421624,4),(1680,1269727224,6),(1680,1288479624,7),(1680,1301180424,4),(1681,-2147483648,2),(1681,-1690765200,1),(1681,-1680487200,2),(1681,-1664758800,1),(1681,-1648951200,2),(1681,-1635123600,1),(1681,-1616896800,2),(1681,-1604278800,1),(1681,-1585533600,2),(1681,-1571014800,1),(1681,-1555293600,2),(1681,-932432400,1),(1681,-857257200,3),(1681,-844556400,4),(1681,-830311200,1),(1681,-828226800,3),(1681,-812502000,4),(1681,-807156000,1),(1681,-798073200,3),(1681,-781052400,1),(1681,-766717200,2),(1681,-750898800,4),(1681,-733359600,3),(1681,-719456400,4),(1681,-701917200,3),(1681,-689209200,4),(1681,-670460400,3),(1681,-114051600,4),(1681,-103168800,2),(1681,-81997200,4),(1681,-71715600,3),(1681,-50547600,4),(1681,-40266000,3),(1681,-18493200,4),(1681,-8211600,3),(1681,12956400,4),(1681,23238000,3),(1681,43801200,4),(1681,54687600,3),(1681,75855600,4),(1681,86742001,3),(1681,107910002,4),(1681,118191602,3),(1681,138754803,4),(1681,149641203,3),(1681,170809204,4),(1681,181090804,3),(1681,202258805,4),(1681,212540405,3),(1681,233103606,4),(1681,243990006,3),(1681,265158007,4),(1681,276044407,3),(1681,296607608,4),(1681,307494008,3),(1681,315529208,2),(1681,323830809,5),(1681,338950809,6),(1681,354675609,5),(1681,370400410,6),(1681,386125210,5),(1681,401850011,6),(1681,417574811,5),(1681,433299612,6),(1681,449024412,5),(1681,465354012,6),(1681,481078812,5),(1681,496803613,6),(1681,512528413,5),(1681,528253213,6),(1681,543978013,5),(1681,559702813,6),(1681,575427614,5),(1681,591152414,6),(1681,606877214,5),(1681,622602014,6),(1681,638326815,5),(1681,654656415,6),(1681,670381216,5),(1681,686106016,6),(1681,701830816,5),(1681,717555617,6),(1681,733280417,5),(1681,749005218,6),(1681,764730018,5),(1681,780454819,6),(1681,796179619,5),(1681,811904419,6),(1681,828234020,5),(1681,846378020,6),(1681,859683620,5),(1681,877827621,6),(1681,891133221,5),(1681,909277221,6),(1681,922582822,5),(1681,941331622,6),(1681,954032422,5),(1681,972781222,6),(1681,985482022,5),(1681,1004230822,6),(1681,1017536422,5),(1681,1035680422,6),(1681,1048986022,5),(1681,1067130022,6),(1681,1080435622,5),(1681,1099184422,6),(1681,1111885222,5),(1681,1130634022,6),(1681,1143334823,5),(1681,1162083623,6),(1681,1174784423,5),(1681,1193533223,6),(1681,1206838823,5),(1681,1224982823,6),(1681,1238288424,5),(1681,1256432424,6),(1681,1269738024,5),(1681,1288486824,6),(1681,1301187624,5),(1681,1319936424,6),(1681,1332637224,5),(1681,1351386025,6),(1681,1364691625,5),(1681,1382835625,6),(1681,1396141225,5),(1681,1414285225,6),(1681,1427590825,5),(1681,1445734826,6),(1681,1459040426,5),(1681,1477789226,6),(1681,1490490027,5),(1681,1509238827,6),(1681,1521939627,5),(1681,1540688427,6),(1681,1553994027,5),(1681,1572138027,6),(1681,1585443627,5),(1681,1603587627,6),(1681,1616893227,5),(1681,1635642027,6),(1681,1648342827,5),(1681,1667091627,6),(1681,1679792427,5),(1681,1698541227,6),(1681,1711846827,5),(1681,1729990827,6),(1681,1743296427,5),(1681,1761440427,6),(1681,1774746027,5),(1681,1792890027,6),(1681,1806195627,5),(1681,1824944427,6),(1681,1837645227,5),(1681,1856394027,6),(1681,1869094827,5),(1681,1887843627,6),(1681,1901149227,5),(1681,1919293227,6),(1681,1932598827,5),(1681,1950742827,6),(1681,1964048427,5),(1681,1982797227,6),(1681,1995498027,5),(1681,2014246827,6),(1681,2026947627,5),(1681,2045696427,6),(1681,2058397227,5),(1681,2077146027,6),(1681,2090451627,5),(1681,2108595627,6),(1681,2121901227,5),(1681,2140045227,6),(1682,-2147483648,1),(1682,-905824800,4),(1682,-857257200,2),(1682,-844556400,3),(1682,-828226800,2),(1682,-812502000,3),(1682,-796777200,2),(1682,-788922000,1),(1682,-777942000,3),(1682,-766623600,2),(1682,407199611,1),(1682,417574811,5),(1682,433299612,6),(1682,449024412,5),(1682,465354012,6),(1682,481078812,5),(1682,496803613,6),(1682,512528413,5),(1682,528253213,6),(1682,543978013,5),(1682,559702813,6),(1682,575427614,5),(1682,591152414,6),(1682,606877214,5),(1682,622602014,6),(1682,638326815,5),(1682,654656415,6),(1682,670381216,5),(1682,686106016,6),(1682,701830816,5),(1682,717555617,6),(1682,733280417,5),(1682,749005218,6),(1682,764730018,5),(1682,780454819,6),(1682,796179619,5),(1682,811904419,6),(1682,828234020,5),(1682,846378020,6),(1682,859683620,5),(1682,877827621,6),(1682,891133221,5),(1682,909277221,6),(1682,922582822,5),(1682,941331622,6),(1682,954032422,5),(1682,972781222,6),(1682,985482022,5),(1682,1004230822,6),(1682,1017536422,5),(1682,1035680422,6),(1682,1048986022,5),(1682,1067130022,6),(1682,1080435622,5),(1682,1099184422,6),(1682,1111885222,5),(1682,1130634022,6),(1682,1143334823,5),(1682,1162083623,6),(1682,1174784423,5),(1682,1193533223,6),(1682,1206838823,5),(1682,1224982823,6),(1682,1238288424,5),(1682,1256432424,6),(1682,1269738024,5),(1682,1288486824,6),(1682,1301187624,5),(1682,1319936424,6),(1682,1332637224,5),(1682,1351386025,6),(1682,1364691625,5),(1682,1382835625,6),(1682,1396141225,5),(1682,1414285225,6),(1682,1427590825,5),(1682,1445734826,6),(1682,1459040426,5),(1682,1477789226,6),(1682,1490490027,5),(1682,1509238827,6),(1682,1521939627,5),(1682,1540688427,6),(1682,1553994027,5),(1682,1572138027,6),(1682,1585443627,5),(1682,1603587627,6),(1682,1616893227,5),(1682,1635642027,6),(1682,1648342827,5),(1682,1667091627,6),(1682,1679792427,5),(1682,1698541227,6),(1682,1711846827,5),(1682,1729990827,6),(1682,1743296427,5),(1682,1761440427,6),(1682,1774746027,5),(1682,1792890027,6),(1682,1806195627,5),(1682,1824944427,6),(1682,1837645227,5),(1682,1856394027,6),(1682,1869094827,5),(1682,1887843627,6),(1682,1901149227,5),(1682,1919293227,6),(1682,1932598827,5),(1682,1950742827,6),(1682,1964048427,5),(1682,1982797227,6),(1682,1995498027,5),(1682,2014246827,6),(1682,2026947627,5),(1682,2045696427,6),(1682,2058397227,5),(1682,2077146027,6),(1682,2090451627,5),(1682,2108595627,6),(1682,2121901227,5),(1682,2140045227,6),(1683,-2147483648,0),(1683,-1593820800,1),(1683,-1247540400,3),(1683,354916809,2),(1683,370724410,3),(1683,386452810,2),(1683,402260411,3),(1683,417988811,2),(1683,433796412,3),(1683,449611212,2),(1683,465343212,4),(1683,481068012,5),(1683,496792813,4),(1683,512517613,5),(1683,528242413,4),(1683,543967213,5),(1683,559692013,4),(1683,575416814,6),(1683,591145214,7),(1683,606870014,6),(1683,622594814,7),(1683,638319615,6),(1683,654649215,7),(1683,670374016,4),(1683,701820016,6),(1683,717548417,7),(1683,733273217,6),(1683,748998018,7),(1683,764722818,6),(1683,780447619,7),(1683,796172419,6),(1683,811897219,7),(1683,828226820,6),(1683,846370820,7),(1683,859676420,6),(1683,877820421,7),(1683,891126021,6),(1683,909270021,7),(1683,922575622,6),(1683,941324422,7),(1683,954025222,6),(1683,972774022,7),(1683,985474822,6),(1683,1004223622,7),(1683,1017529222,6),(1683,1035673222,7),(1683,1048978822,6),(1683,1067122822,7),(1683,1080428422,6),(1683,1099177222,7),(1683,1111878022,6),(1683,1130626822,7),(1683,1143327623,6),(1683,1162076423,7),(1683,1174777223,6),(1683,1193526023,7),(1683,1206831623,6),(1683,1224975623,7),(1683,1238281224,6),(1683,1256425224,7),(1683,1269730824,6),(1683,1288479624,7),(1683,1301180424,4),(1683,1414274425,7),(1683,1480806026,4),(1684,-2147483648,1),(1684,-1441160160,2),(1684,-1247536800,3),(1684,-888894000,6),(1684,-857257200,4),(1684,-844556400,5),(1684,-828226800,4),(1684,-812502000,5),(1684,-811648800,3),(1684,354920409,7),(1684,370728010,3),(1684,386456410,7),(1684,402264011,3),(1684,417992411,7),(1684,433800012,3),(1684,449614812,7),(1684,465346812,8),(1684,481071612,9),(1684,496796413,8),(1684,512521213,9),(1684,528246013,8),(1684,543970813,9),(1684,559695613,8),(1684,575420414,9),(1684,591145214,8),(1684,606870014,9),(1684,622594814,8),(1684,631141214,3),(1684,646786815,2),(1684,701820016,10),(1684,717541217,2),(1684,733269617,10),(1684,748990818,2),(1684,764719218,10),(1684,767739618,7),(1684,780436819,3),(1684,796165219,7),(1684,811886419,3),(1684,828219620,9),(1684,846374420,8),(1684,852066020,3),(1684,859683620,11),(1684,877827621,12),(1684,891133221,11),(1684,909277221,12),(1684,922582822,11),(1684,941331622,12),(1684,954032422,11),(1684,972781222,12),(1684,985482022,11),(1684,1004230822,12),(1684,1017536422,11),(1684,1035680422,12),(1684,1048986022,11),(1684,1067130022,12),(1684,1080435622,11),(1684,1099184422,12),(1684,1111885222,11),(1684,1130634022,12),(1684,1143334823,11),(1684,1162083623,12),(1684,1174784423,11),(1684,1193533223,12),(1684,1206838823,11),(1684,1224982823,12),(1684,1238288424,11),(1684,1256432424,12),(1684,1269738024,11),(1684,1288486824,12),(1684,1301187624,11),(1684,1319936424,12),(1684,1332637224,11),(1684,1351386025,12),(1684,1364691625,11),(1684,1382835625,12),(1684,1396137625,13),(1684,1414274425,8),(1685,-2147483648,1),(1685,-905824800,4),(1685,-857257200,2),(1685,-844556400,3),(1685,-828226800,2),(1685,-812502000,3),(1685,-796777200,2),(1685,-788922000,1),(1685,-777942000,3),(1685,-766623600,2),(1685,407199611,1),(1685,417574811,5),(1685,433299612,6),(1685,449024412,5),(1685,465354012,6),(1685,481078812,5),(1685,496803613,6),(1685,512528413,5),(1685,528253213,6),(1685,543978013,5),(1685,559702813,6),(1685,575427614,5),(1685,591152414,6),(1685,606877214,5),(1685,622602014,6),(1685,638326815,5),(1685,654656415,6),(1685,670381216,5),(1685,686106016,6),(1685,701830816,5),(1685,717555617,6),(1685,733280417,5),(1685,749005218,6),(1685,764730018,5),(1685,780454819,6),(1685,796179619,5),(1685,811904419,6),(1685,828234020,5),(1685,846378020,6),(1685,859683620,5),(1685,877827621,6),(1685,891133221,5),(1685,909277221,6),(1685,922582822,5),(1685,941331622,6),(1685,954032422,5),(1685,972781222,6),(1685,985482022,5),(1685,1004230822,6),(1685,1017536422,5),(1685,1035680422,6),(1685,1048986022,5),(1685,1067130022,6),(1685,1080435622,5),(1685,1099184422,6),(1685,1111885222,5),(1685,1130634022,6),(1685,1143334823,5),(1685,1162083623,6),(1685,1174784423,5),(1685,1193533223,6),(1685,1206838823,5),(1685,1224982823,6),(1685,1238288424,5),(1685,1256432424,6),(1685,1269738024,5),(1685,1288486824,6),(1685,1301187624,5),(1685,1319936424,6),(1685,1332637224,5),(1685,1351386025,6),(1685,1364691625,5),(1685,1382835625,6),(1685,1396141225,5),(1685,1414285225,6),(1685,1427590825,5),(1685,1445734826,6),(1685,1459040426,5),(1685,1477789226,6),(1685,1490490027,5),(1685,1509238827,6),(1685,1521939627,5),(1685,1540688427,6),(1685,1553994027,5),(1685,1572138027,6),(1685,1585443627,5),(1685,1603587627,6),(1685,1616893227,5),(1685,1635642027,6),(1685,1648342827,5),(1685,1667091627,6),(1685,1679792427,5),(1685,1698541227,6),(1685,1711846827,5),(1685,1729990827,6),(1685,1743296427,5),(1685,1761440427,6),(1685,1774746027,5),(1685,1792890027,6),(1685,1806195627,5),(1685,1824944427,6),(1685,1837645227,5),(1685,1856394027,6),(1685,1869094827,5),(1685,1887843627,6),(1685,1901149227,5),(1685,1919293227,6),(1685,1932598827,5),(1685,1950742827,6),(1685,1964048427,5),(1685,1982797227,6),(1685,1995498027,5),(1685,2014246827,6),(1685,2026947627,5),(1685,2045696427,6),(1685,2058397227,5),(1685,2077146027,6),(1685,2090451627,5),(1685,2108595627,6),(1685,2121901227,5),(1685,2140045227,6),(1686,-2147483648,1),(1686,-857257200,2),(1686,-844556400,3),(1686,-828226800,2),(1686,-812502000,3),(1686,-796777200,2),(1686,-788922000,4),(1686,-781048800,1),(1686,291762008,5),(1686,307576808,1),(1686,323816409,5),(1686,339026409,1),(1686,355266009,5),(1686,370393210,1),(1686,386715610,5),(1686,401846411,6),(1686,417571211,7),(1686,433296012,6),(1686,449020812,7),(1686,465350412,6),(1686,481075212,7),(1686,496800013,6),(1686,512524813,7),(1686,528249613,6),(1686,543974413,7),(1686,559699213,6),(1686,575424014,7),(1686,591148814,6),(1686,606873614,7),(1686,622598414,6),(1686,638323215,7),(1686,654652815,6),(1686,662680815,1),(1686,670370416,5),(1686,686091616,1),(1686,701820016,5),(1686,717541217,1),(1686,733269617,5),(1686,748990818,1),(1686,764719218,5),(1686,780440419,1),(1686,796168819,5),(1686,811890019,1),(1686,828223220,5),(1686,846363620,1),(1686,859683620,8),(1686,877827621,9),(1686,891133221,8),(1686,909277221,9),(1686,922582822,8),(1686,941331622,9),(1686,954032422,8),(1686,972781222,9),(1686,985482022,8),(1686,1004230822,9),(1686,1017536422,8),(1686,1035680422,9),(1686,1048986022,8),(1686,1067130022,9),(1686,1080435622,8),(1686,1099184422,9),(1686,1111885222,8),(1686,1130634022,9),(1686,1143334823,8),(1686,1162083623,9),(1686,1174784423,8),(1686,1193533223,9),(1686,1206838823,8),(1686,1224982823,9),(1686,1238288424,8),(1686,1256432424,9),(1686,1269738024,8),(1686,1288486824,9),(1686,1301187624,8),(1686,1319936424,9),(1686,1332637224,8),(1686,1351386025,9),(1686,1364691625,8),(1686,1382835625,9),(1686,1396141225,8),(1686,1414285225,9),(1686,1427590825,8),(1686,1445734826,9),(1686,1459040426,8),(1686,1477789226,9),(1686,1490490027,8),(1686,1509238827,9),(1686,1521939627,8),(1686,1540688427,9),(1686,1553994027,8),(1686,1572138027,9),(1686,1585443627,8),(1686,1603587627,9),(1686,1616893227,8),(1686,1635642027,9),(1686,1648342827,8),(1686,1667091627,9),(1686,1679792427,8),(1686,1698541227,9),(1686,1711846827,8),(1686,1729990827,9),(1686,1743296427,8),(1686,1761440427,9),(1686,1774746027,8),(1686,1792890027,9),(1686,1806195627,8),(1686,1824944427,9),(1686,1837645227,8),(1686,1856394027,9),(1686,1869094827,8),(1686,1887843627,9),(1686,1901149227,8),(1686,1919293227,9),(1686,1932598827,8),(1686,1950742827,9),(1686,1964048427,8),(1686,1982797227,9),(1686,1995498027,8),(1686,2014246827,9),(1686,2026947627,8),(1686,2045696427,9),(1686,2058397227,8),(1686,2077146027,9),(1686,2090451627,8),(1686,2108595627,9),(1686,2121901227,8),(1686,2140045227,9),(1687,-2147483648,1),(1687,-1692496800,2),(1687,-1680483600,1),(1687,323830809,3),(1687,338950809,4),(1687,354675609,3),(1687,370400410,4),(1687,386125210,3),(1687,401850011,4),(1687,417574811,3),(1687,433299612,4),(1687,449024412,3),(1687,465354012,4),(1687,481078812,3),(1687,496803613,4),(1687,512528413,3),(1687,528253213,4),(1687,543978013,3),(1687,559702813,4),(1687,575427614,3),(1687,591152414,4),(1687,606877214,3),(1687,622602014,4),(1687,638326815,3),(1687,654656415,4),(1687,670381216,3),(1687,686106016,4),(1687,701830816,3),(1687,717555617,4),(1687,733280417,3),(1687,749005218,4),(1687,764730018,3),(1687,780454819,4),(1687,796179619,3),(1687,811904419,4),(1687,828234020,3),(1687,846378020,4),(1687,859683620,3),(1687,877827621,4),(1687,891133221,3),(1687,909277221,4),(1687,922582822,3),(1687,941331622,4),(1687,954032422,3),(1687,972781222,4),(1687,985482022,3),(1687,1004230822,4),(1687,1017536422,3),(1687,1035680422,4),(1687,1048986022,3),(1687,1067130022,4),(1687,1080435622,3),(1687,1099184422,4),(1687,1111885222,3),(1687,1130634022,4),(1687,1143334823,3),(1687,1162083623,4),(1687,1174784423,3),(1687,1193533223,4),(1687,1206838823,3),(1687,1224982823,4),(1687,1238288424,3),(1687,1256432424,4),(1687,1269738024,3),(1687,1288486824,4),(1687,1301187624,3),(1687,1319936424,4),(1687,1332637224,3),(1687,1351386025,4),(1687,1364691625,3),(1687,1382835625,4),(1687,1396141225,3),(1687,1414285225,4),(1687,1427590825,3),(1687,1445734826,4),(1687,1459040426,3),(1687,1477789226,4),(1687,1490490027,3),(1687,1509238827,4),(1687,1521939627,3),(1687,1540688427,4),(1687,1553994027,3),(1687,1572138027,4),(1687,1585443627,3),(1687,1603587627,4),(1687,1616893227,3),(1687,1635642027,4),(1687,1648342827,3),(1687,1667091627,4),(1687,1679792427,3),(1687,1698541227,4),(1687,1711846827,3),(1687,1729990827,4),(1687,1743296427,3),(1687,1761440427,4),(1687,1774746027,3),(1687,1792890027,4),(1687,1806195627,3),(1687,1824944427,4),(1687,1837645227,3),(1687,1856394027,4),(1687,1869094827,3),(1687,1887843627,4),(1687,1901149227,3),(1687,1919293227,4),(1687,1932598827,3),(1687,1950742827,4),(1687,1964048427,3),(1687,1982797227,4),(1687,1995498027,3),(1687,2014246827,4),(1687,2026947627,3),(1687,2045696427,4),(1687,2058397227,3),(1687,2077146027,4),(1687,2090451627,3),(1687,2108595627,4),(1687,2121901227,3),(1687,2140045227,4),(1688,-2147483648,1),(1688,-1638322740,4),(1688,-1632006000,2),(1688,-1618700400,3),(1688,-1593824400,1),(1688,-1535938740,5),(1688,-927943200,6),(1688,-892954800,7),(1688,-857257200,3),(1688,-844556400,2),(1688,-828226800,3),(1688,-812502000,2),(1688,-797652000,6),(1688,354920409,8),(1688,370728010,6),(1688,386456410,8),(1688,402264011,6),(1688,417992411,8),(1688,433800012,6),(1688,449614812,8),(1688,465346812,9),(1688,481071612,10),(1688,496796413,9),(1688,512521213,10),(1688,528246013,9),(1688,543970813,10),(1688,559695613,9),(1688,575420414,10),(1688,591145214,9),(1688,606870014,11),(1688,622598414,12),(1688,638323215,11),(1688,654652815,12),(1688,670377616,11),(1688,686102416,12),(1688,701827216,11),(1688,717552017,12),(1688,733276817,11),(1688,749001618,12),(1688,764726418,11),(1688,780451219,12),(1688,796176019,11),(1688,811900819,12),(1688,828230420,11),(1688,846374420,12),(1688,859680020,11),(1688,877824021,12),(1688,891129621,11),(1688,906411621,15),(1688,909277221,13),(1688,922582822,14),(1688,941331622,5),(1688,1017536422,14),(1688,1035680422,13),(1688,1048986022,14),(1688,1067130022,13),(1688,1080435622,14),(1688,1099184422,13),(1688,1111885222,14),(1688,1130634022,13),(1688,1143334823,14),(1688,1162083623,13),(1688,1174784423,14),(1688,1193533223,13),(1688,1206838823,14),(1688,1224982823,13),(1688,1238288424,14),(1688,1256432424,13),(1688,1269738024,14),(1688,1288486824,13),(1688,1301187624,14),(1688,1319936424,13),(1688,1332637224,14),(1688,1351386025,13),(1688,1364691625,14),(1688,1382835625,13),(1688,1396141225,14),(1688,1414285225,13),(1688,1427590825,14),(1688,1445734826,13),(1688,1459040426,14),(1688,1477789226,13),(1688,1490490027,14),(1688,1509238827,13),(1688,1521939627,14),(1688,1540688427,13),(1688,1553994027,14),(1688,1572138027,13),(1688,1585443627,14),(1688,1603587627,13),(1688,1616893227,14),(1688,1635642027,13),(1688,1648342827,14),(1688,1667091627,13),(1688,1679792427,14),(1688,1698541227,13),(1688,1711846827,14),(1688,1729990827,13),(1688,1743296427,14),(1688,1761440427,13),(1688,1774746027,14),(1688,1792890027,13),(1688,1806195627,14),(1688,1824944427,13),(1688,1837645227,14),(1688,1856394027,13),(1688,1869094827,14),(1688,1887843627,13),(1688,1901149227,14),(1688,1919293227,13),(1688,1932598827,14),(1688,1950742827,13),(1688,1964048427,14),(1688,1982797227,13),(1688,1995498027,14),(1688,2014246827,13),(1688,2026947627,14),(1688,2045696427,13),(1688,2058397227,14),(1688,2077146027,13),(1688,2090451627,14),(1688,2108595627,13),(1688,2121901227,14),(1688,2140045227,13),(1689,-2147483648,0),(1689,-1767230360,1),(1689,-932346000,2),(1689,-857257200,1),(1689,-844556400,2),(1689,-843519600,1),(1689,136854003,2),(1689,149896803,1),(1689,168130804,2),(1689,181432804,1),(1689,199839605,2),(1689,213141605,1),(1689,231894006,2),(1689,244591206,1),(1689,263257207,2),(1689,276040807,1),(1689,294706808,2),(1689,307490408,1),(1689,326156409,2),(1689,339458409,1),(1689,357087609,2),(1689,370389610,1),(1689,389142010,2),(1689,402444011,1),(1689,419468411,2),(1689,433807212,1),(1689,449622012,2),(1689,465354012,3),(1689,481078812,4),(1689,496803613,3),(1689,512528413,4),(1689,528253213,3),(1689,543978013,4),(1689,559702813,3),(1689,575427614,4),(1689,591152414,3),(1689,606877214,4),(1689,622602014,3),(1689,638326815,4),(1689,654656415,3),(1689,670381216,4),(1689,686106016,3),(1689,701830816,4),(1689,717555617,3),(1689,733280417,4),(1689,749005218,3),(1689,764730018,4),(1689,780454819,3),(1689,796179619,4),(1689,811904419,3),(1689,828234020,4),(1689,846378020,3),(1689,859683620,4),(1689,877827621,3),(1689,891133221,4),(1689,909277221,3),(1689,922582822,4),(1689,941331622,3),(1689,954032422,4),(1689,972781222,3),(1689,985482022,4),(1689,1004230822,3),(1689,1017536422,4),(1689,1035680422,3),(1689,1048986022,4),(1689,1067130022,3),(1689,1080435622,4),(1689,1099184422,3),(1689,1111885222,4),(1689,1130634022,3),(1689,1143334823,4),(1689,1162083623,3),(1689,1174784423,4),(1689,1193533223,3),(1689,1206838823,4),(1689,1224982823,3),(1689,1238288424,4),(1689,1256432424,3),(1689,1269738024,4),(1689,1288486824,3),(1689,1301187624,4),(1689,1319936424,3),(1689,1332637224,4),(1689,1351386025,3),(1689,1364691625,4),(1689,1382835625,3),(1689,1396141225,4),(1689,1414285225,3),(1689,1427590825,4),(1689,1445734826,3),(1689,1459040426,4),(1689,1477789226,3),(1689,1490490027,4),(1689,1509238827,3),(1689,1521939627,4),(1689,1540688427,3),(1689,1553994027,4),(1689,1572138027,3),(1689,1585443627,4),(1689,1603587627,3),(1689,1616893227,4),(1689,1635642027,3),(1689,1648342827,4),(1689,1667091627,3),(1689,1679792427,4),(1689,1698541227,3),(1689,1711846827,4),(1689,1729990827,3),(1689,1743296427,4),(1689,1761440427,3),(1689,1774746027,4),(1689,1792890027,3),(1689,1806195627,4),(1689,1824944427,3),(1689,1837645227,4),(1689,1856394027,3),(1689,1869094827,4),(1689,1887843627,3),(1689,1901149227,4),(1689,1919293227,3),(1689,1932598827,4),(1689,1950742827,3),(1689,1964048427,4),(1689,1982797227,3),(1689,1995498027,4),(1689,2014246827,3),(1689,2026947627,4),(1689,2045696427,3),(1689,2058397227,4),(1689,2077146027,3),(1689,2090451627,4),(1689,2108595627,3),(1689,2121901227,4),(1689,2140045227,3),(1690,-2147483648,1),(1690,-1637114100,2),(1690,-1213148664,5),(1690,-1187056800,3),(1690,-1175479200,4),(1690,-1159754400,3),(1690,-1144029600,4),(1690,-1127700000,3),(1690,-1111975200,4),(1690,-1096250400,3),(1690,-1080525600,4),(1690,-1064800800,3),(1690,-1049076000,4),(1690,-1033351200,3),(1690,-1017626400,4),(1690,-1001901600,3),(1690,-986176800,4),(1690,-970452000,3),(1690,-954727200,4),(1690,-927165600,6),(1690,-898138800,9),(1690,-857257200,7),(1690,-844556400,8),(1690,-828226800,7),(1690,-812502000,8),(1690,-800157600,11),(1690,354920409,10),(1690,370728010,11),(1690,386456410,10),(1690,402264011,11),(1690,417992411,10),(1690,433800012,11),(1690,449614812,10),(1690,465346812,12),(1690,481071612,13),(1690,496796413,12),(1690,512521213,13),(1690,528246013,12),(1690,543970813,13),(1690,559695613,12),(1690,575420414,13),(1690,591145214,12),(1690,606870014,13),(1690,622594814,12),(1690,638319615,13),(1690,641944815,6),(1690,654652815,4),(1690,670377616,3),(1690,686102416,4),(1690,694216816,5),(1690,701820016,6),(1690,717541217,5),(1690,733269617,6),(1690,748990818,5),(1690,764719218,6),(1690,780440419,5),(1690,796168819,6),(1690,811890019,5),(1690,828223220,6),(1690,846363620,5),(1690,859680020,6),(1690,877824021,5),(1690,891129621,6),(1690,909273621,5),(1690,922579222,6),(1690,941328022,5),(1690,954028822,6),(1690,972777622,5),(1690,985478422,6),(1690,1004227222,5),(1690,1017532822,6),(1690,1035676822,5),(1690,1048982422,6),(1690,1067126422,5),(1690,1080432022,6),(1690,1099180822,5),(1690,1111881622,6),(1690,1130630422,5),(1690,1143331223,6),(1690,1162080023,5),(1690,1174780823,6),(1690,1193529623,5),(1690,1206835223,6),(1690,1224979223,5),(1690,1238284824,6),(1690,1256428824,5),(1690,1269734424,6),(1690,1288483224,5),(1690,1301184024,6),(1690,1319932824,5),(1690,1332633624,6),(1690,1351382425,5),(1690,1364688025,6),(1690,1382832025,5),(1690,1396137625,6),(1690,1414281625,5),(1690,1427587225,6),(1690,1445731226,5),(1690,1459036826,6),(1690,1477785626,5),(1690,1490486427,6),(1690,1509235227,5),(1690,1521936027,6),(1690,1540684827,5),(1690,1553990427,6),(1690,1572134427,5),(1690,1585440027,6),(1690,1603584027,5),(1690,1616889627,6),(1690,1635638427,5),(1690,1648339227,6),(1690,1667088027,5),(1690,1679788827,6),(1690,1698537627,5),(1690,1711843227,6),(1690,1729987227,5),(1690,1743292827,6),(1690,1761436827,5),(1690,1774742427,6),(1690,1792886427,5),(1690,1806192027,6),(1690,1824940827,5),(1690,1837641627,6),(1690,1856390427,5),(1690,1869091227,6),(1690,1887840027,5),(1690,1901145627,6),(1690,1919289627,5),(1690,1932595227,6),(1690,1950739227,5),(1690,1964044827,6),(1690,1982793627,5),(1690,1995494427,6),(1690,2014243227,5),(1690,2026944027,6),(1690,2045692827,5),(1690,2058393627,6),(1690,2077142427,5),(1690,2090448027,6),(1690,2108592027,5),(1690,2121897627,6),(1690,2140041627,5),(1691,-2147483648,0),(1691,-1593820800,1),(1691,-1247540400,3),(1691,354916809,2),(1691,370724410,3),(1691,386452810,2),(1691,402260411,3),(1691,417988811,2),(1691,433796412,3),(1691,449611212,2),(1691,465343212,4),(1691,481068012,5),(1691,496792813,4),(1691,512517613,5),(1691,528242413,4),(1691,543967213,5),(1691,559692013,4),(1691,575416814,5),(1691,591141614,4),(1691,606866414,6),(1691,622594814,7),(1691,638319615,6),(1691,654649215,7),(1691,670374016,8),(1691,686102416,9),(1691,695779216,7),(1691,701823616,6),(1691,717548417,7),(1691,733273217,6),(1691,748998018,7),(1691,764722818,6),(1691,780447619,7),(1691,796172419,6),(1691,811897219,7),(1691,828226820,6),(1691,846370820,7),(1691,859676420,6),(1691,877820421,7),(1691,891126021,6),(1691,909270021,7),(1691,922575622,6),(1691,941324422,7),(1691,954025222,6),(1691,972774022,7),(1691,985474822,6),(1691,1004223622,7),(1691,1017529222,6),(1691,1035673222,7),(1691,1048978822,6),(1691,1067122822,7),(1691,1080428422,6),(1691,1099177222,7),(1691,1111878022,6),(1691,1130626822,7),(1691,1143327623,6),(1691,1162076423,7),(1691,1174777223,6),(1691,1193526023,7),(1691,1206831623,6),(1691,1224975623,7),(1691,1238281224,6),(1691,1256425224,7),(1691,1269730824,6),(1691,1288479624,7),(1691,1301180424,4),(1691,1414274425,7),(1691,1459033226,4),(1692,-2147483648,1),(1692,-938905200,2),(1692,-857257200,3),(1692,-844556400,2),(1692,-828226800,3),(1692,-812502000,2),(1692,-796874400,4),(1692,-794714400,1),(1692,-773456400,6),(1692,354920409,5),(1692,370728010,6),(1692,386456410,5),(1692,402264011,6),(1692,417992411,5),(1692,433800012,6),(1692,449614812,5),(1692,465346812,7),(1692,481071612,8),(1692,496796413,7),(1692,512521213,8),(1692,528246013,7),(1692,543970813,8),(1692,559695613,7),(1692,575420414,8),(1692,591145214,7),(1692,606870014,8),(1692,622594814,7),(1692,631141214,6),(1692,646786815,1),(1692,670384816,9),(1692,701820016,10),(1692,717541217,9),(1692,733269617,10),(1692,748990818,9),(1692,764719218,10),(1692,780440419,9),(1692,796179619,11),(1692,811904419,12),(1692,828234020,11),(1692,846378020,12),(1692,859683620,11),(1692,877827621,12),(1692,891133221,11),(1692,909277221,12),(1692,922582822,11),(1692,941331622,12),(1692,954032422,11),(1692,972781222,12),(1692,985482022,11),(1692,1004230822,12),(1692,1017536422,11),(1692,1035680422,12),(1692,1048986022,11),(1692,1067130022,12),(1692,1080435622,11),(1692,1099184422,12),(1692,1111885222,11),(1692,1130634022,12),(1692,1143334823,11),(1692,1162083623,12),(1692,1174784423,11),(1692,1193533223,12),(1692,1206838823,11),(1692,1224982823,12),(1692,1238288424,11),(1692,1256432424,12),(1692,1269738024,11),(1692,1288486824,12),(1692,1301187624,11),(1692,1319936424,12),(1692,1332637224,11),(1692,1351386025,12),(1692,1364691625,11),(1692,1382835625,12),(1692,1396141225,11),(1692,1414285225,12),(1692,1427590825,11),(1692,1445734826,12),(1692,1459040426,11),(1692,1477789226,12),(1692,1490490027,11),(1692,1509238827,12),(1692,1521939627,11),(1692,1540688427,12),(1692,1553994027,11),(1692,1572138027,12),(1692,1585443627,11),(1692,1603587627,12),(1692,1616893227,11),(1692,1635642027,12),(1692,1648342827,11),(1692,1667091627,12),(1692,1679792427,11),(1692,1698541227,12),(1692,1711846827,11),(1692,1729990827,12),(1692,1743296427,11),(1692,1761440427,12),(1692,1774746027,11),(1692,1792890027,12),(1692,1806195627,11),(1692,1824944427,12),(1692,1837645227,11),(1692,1856394027,12),(1692,1869094827,11),(1692,1887843627,12),(1692,1901149227,11),(1692,1919293227,12),(1692,1932598827,11),(1692,1950742827,12),(1692,1964048427,11),(1692,1982797227,12),(1692,1995498027,11),(1692,2014246827,12),(1692,2026947627,11),(1692,2045696427,12),(1692,2058397227,11),(1692,2077146027,12),(1692,2090451627,11),(1692,2108595627,12),(1692,2121901227,11),(1692,2140045227,12),(1693,-2147483648,2),(1693,-904435200,1),(1693,-891129600,2),(1693,-872985600,1),(1693,-859680000,2),(1693,354675609,3),(1693,370400410,4),(1693,386125210,3),(1693,401850011,4),(1693,417574811,3),(1693,433299612,4),(1693,449024412,3),(1693,465354012,4),(1693,481078812,3),(1693,496803613,4),(1693,512528413,3),(1693,528253213,4),(1693,543978013,3),(1693,559702813,4),(1693,575427614,3),(1693,591152414,4),(1693,606877214,3),(1693,622602014,4),(1693,638326815,3),(1693,654656415,4),(1693,670381216,3),(1693,686106016,4),(1693,701830816,3),(1693,717555617,4),(1693,733280417,3),(1693,749005218,4),(1693,764730018,3),(1693,780454819,4),(1693,796179619,3),(1693,811904419,4),(1693,828234020,3),(1693,846378020,4),(1693,859683620,3),(1693,877827621,4),(1693,891133221,3),(1693,909277221,4),(1693,922582822,3),(1693,941331622,4),(1693,954032422,3),(1693,972781222,4),(1693,985482022,3),(1693,1004230822,4),(1693,1017536422,3),(1693,1035680422,4),(1693,1048986022,3),(1693,1067130022,4),(1693,1080435622,3),(1693,1099184422,4),(1693,1111885222,3),(1693,1130634022,4),(1693,1143334823,3),(1693,1162083623,4),(1693,1174784423,3),(1693,1193533223,4),(1693,1206838823,3),(1693,1224982823,4),(1693,1238288424,3),(1693,1256432424,4),(1693,1269738024,3),(1693,1288486824,4),(1693,1301187624,3),(1693,1319936424,4),(1693,1332637224,3),(1693,1351386025,4),(1693,1364691625,3),(1693,1382835625,4),(1693,1396141225,3),(1693,1414285225,4),(1693,1427590825,3),(1693,1445734826,4),(1693,1459040426,3),(1693,1477789226,4),(1693,1490490027,3),(1693,1509238827,4),(1693,1521939627,3),(1693,1540688427,4),(1693,1553994027,3),(1693,1572138027,4),(1693,1585443627,3),(1693,1603587627,4),(1693,1616893227,3),(1693,1635642027,4),(1693,1648342827,3),(1693,1667091627,4),(1693,1679792427,3),(1693,1698541227,4),(1693,1711846827,3),(1693,1729990827,4),(1693,1743296427,3),(1693,1761440427,4),(1693,1774746027,3),(1693,1792890027,4),(1693,1806195627,3),(1693,1824944427,4),(1693,1837645227,3),(1693,1856394027,4),(1693,1869094827,3),(1693,1887843627,4),(1693,1901149227,3),(1693,1919293227,4),(1693,1932598827,3),(1693,1950742827,4),(1693,1964048427,3),(1693,1982797227,4),(1693,1995498027,3),(1693,2014246827,4),(1693,2026947627,3),(1693,2045696427,4),(1693,2058397227,3),(1693,2077146027,4),(1693,2090451627,3),(1693,2108595627,4),(1693,2121901227,3),(1693,2140045227,4),(1694,-2147483648,2),(1694,-1690765200,1),(1694,-1680487200,2),(1694,-1664758800,1),(1694,-1648951200,2),(1694,-1635123600,1),(1694,-1616896800,2),(1694,-1604278800,1),(1694,-1585533600,2),(1694,-1571014800,1),(1694,-1555293600,2),(1694,-932432400,1),(1694,-857257200,3),(1694,-844556400,4),(1694,-830311200,1),(1694,-828226800,3),(1694,-812502000,4),(1694,-807156000,1),(1694,-798073200,3),(1694,-781052400,1),(1694,-766717200,2),(1694,-750898800,4),(1694,-733359600,3),(1694,-719456400,4),(1694,-701917200,3),(1694,-689209200,4),(1694,-670460400,3),(1694,-114051600,4),(1694,-103168800,2),(1694,-81997200,4),(1694,-71715600,3),(1694,-50547600,4),(1694,-40266000,3),(1694,-18493200,4),(1694,-8211600,3),(1694,12956400,4),(1694,23238000,3),(1694,43801200,4),(1694,54687600,3),(1694,75855600,4),(1694,86742001,3),(1694,107910002,4),(1694,118191602,3),(1694,138754803,4),(1694,149641203,3),(1694,170809204,4),(1694,181090804,3),(1694,202258805,4),(1694,212540405,3),(1694,233103606,4),(1694,243990006,3),(1694,265158007,4),(1694,276044407,3),(1694,296607608,4),(1694,307494008,3),(1694,315529208,2),(1694,323830809,5),(1694,338950809,6),(1694,354675609,5),(1694,370400410,6),(1694,386125210,5),(1694,401850011,6),(1694,417574811,5),(1694,433299612,6),(1694,449024412,5),(1694,465354012,6),(1694,481078812,5),(1694,496803613,6),(1694,512528413,5),(1694,528253213,6),(1694,543978013,5),(1694,559702813,6),(1694,575427614,5),(1694,591152414,6),(1694,606877214,5),(1694,622602014,6),(1694,638326815,5),(1694,654656415,6),(1694,670381216,5),(1694,686106016,6),(1694,701830816,5),(1694,717555617,6),(1694,733280417,5),(1694,749005218,6),(1694,764730018,5),(1694,780454819,6),(1694,796179619,5),(1694,811904419,6),(1694,828234020,5),(1694,846378020,6),(1694,859683620,5),(1694,877827621,6),(1694,891133221,5),(1694,909277221,6),(1694,922582822,5),(1694,941331622,6),(1694,954032422,5),(1694,972781222,6),(1694,985482022,5),(1694,1004230822,6),(1694,1017536422,5),(1694,1035680422,6),(1694,1048986022,5),(1694,1067130022,6),(1694,1080435622,5),(1694,1099184422,6),(1694,1111885222,5),(1694,1130634022,6),(1694,1143334823,5),(1694,1162083623,6),(1694,1174784423,5),(1694,1193533223,6),(1694,1206838823,5),(1694,1224982823,6),(1694,1238288424,5),(1694,1256432424,6),(1694,1269738024,5),(1694,1288486824,6),(1694,1301187624,5),(1694,1319936424,6),(1694,1332637224,5),(1694,1351386025,6),(1694,1364691625,5),(1694,1382835625,6),(1694,1396141225,5),(1694,1414285225,6),(1694,1427590825,5),(1694,1445734826,6),(1694,1459040426,5),(1694,1477789226,6),(1694,1490490027,5),(1694,1509238827,6),(1694,1521939627,5),(1694,1540688427,6),(1694,1553994027,5),(1694,1572138027,6),(1694,1585443627,5),(1694,1603587627,6),(1694,1616893227,5),(1694,1635642027,6),(1694,1648342827,5),(1694,1667091627,6),(1694,1679792427,5),(1694,1698541227,6),(1694,1711846827,5),(1694,1729990827,6),(1694,1743296427,5),(1694,1761440427,6),(1694,1774746027,5),(1694,1792890027,6),(1694,1806195627,5),(1694,1824944427,6),(1694,1837645227,5),(1694,1856394027,6),(1694,1869094827,5),(1694,1887843627,6),(1694,1901149227,5),(1694,1919293227,6),(1694,1932598827,5),(1694,1950742827,6),(1694,1964048427,5),(1694,1982797227,6),(1694,1995498027,5),(1694,2014246827,6),(1694,2026947627,5),(1694,2045696427,6),(1694,2058397227,5),(1694,2077146027,6),(1694,2090451627,5),(1694,2108595627,6),(1694,2121901227,5),(1694,2140045227,6),(1695,-2147483648,2),(1695,-1693706400,1),(1695,-1680483600,2),(1695,-1663455600,3),(1695,-1650150000,4),(1695,-1632006000,3),(1695,-1618700400,4),(1695,-1577926800,2),(1695,-1569711600,3),(1695,-1555801200,4),(1695,-938905200,3),(1695,-857257200,4),(1695,-844556400,3),(1695,-828226800,4),(1695,-812502000,3),(1695,-796777200,4),(1695,-781052400,3),(1695,-780188400,4),(1695,-757386000,2),(1695,-748479600,3),(1695,-733359600,4),(1695,-717634800,3),(1695,-701910000,4),(1695,-684975600,3),(1695,-670460400,4),(1695,323823609,1),(1695,338940009,2),(1695,354675609,5),(1695,370400410,6),(1695,386125210,5),(1695,401850011,6),(1695,417574811,5),(1695,433299612,6),(1695,449024412,5),(1695,465354012,6),(1695,481078812,5),(1695,496803613,6),(1695,512528413,5),(1695,528253213,6),(1695,543978013,5),(1695,559702813,6),(1695,575427614,5),(1695,591152414,6),(1695,606877214,5),(1695,622602014,6),(1695,638326815,5),(1695,654656415,6),(1695,670381216,5),(1695,686106016,6),(1695,701830816,5),(1695,717555617,6),(1695,733280417,5),(1695,749005218,6),(1695,764730018,5),(1695,780454819,6),(1695,796179619,5),(1695,811904419,6),(1695,828234020,5),(1695,846378020,6),(1695,859683620,5),(1695,877827621,6),(1695,891133221,5),(1695,909277221,6),(1695,922582822,5),(1695,941331622,6),(1695,954032422,5),(1695,972781222,6),(1695,985482022,5),(1695,1004230822,6),(1695,1017536422,5),(1695,1035680422,6),(1695,1048986022,5),(1695,1067130022,6),(1695,1080435622,5),(1695,1099184422,6),(1695,1111885222,5),(1695,1130634022,6),(1695,1143334823,5),(1695,1162083623,6),(1695,1174784423,5),(1695,1193533223,6),(1695,1206838823,5),(1695,1224982823,6),(1695,1238288424,5),(1695,1256432424,6),(1695,1269738024,5),(1695,1288486824,6),(1695,1301187624,5),(1695,1319936424,6),(1695,1332637224,5),(1695,1351386025,6),(1695,1364691625,5),(1695,1382835625,6),(1695,1396141225,5),(1695,1414285225,6),(1695,1427590825,5),(1695,1445734826,6),(1695,1459040426,5),(1695,1477789226,6),(1695,1490490027,5),(1695,1509238827,6),(1695,1521939627,5),(1695,1540688427,6),(1695,1553994027,5),(1695,1572138027,6),(1695,1585443627,5),(1695,1603587627,6),(1695,1616893227,5),(1695,1635642027,6),(1695,1648342827,5),(1695,1667091627,6),(1695,1679792427,5),(1695,1698541227,6),(1695,1711846827,5),(1695,1729990827,6),(1695,1743296427,5),(1695,1761440427,6),(1695,1774746027,5),(1695,1792890027,6),(1695,1806195627,5),(1695,1824944427,6),(1695,1837645227,5),(1695,1856394027,6),(1695,1869094827,5),(1695,1887843627,6),(1695,1901149227,5),(1695,1919293227,6),(1695,1932598827,5),(1695,1950742827,6),(1695,1964048427,5),(1695,1982797227,6),(1695,1995498027,5),(1695,2014246827,6),(1695,2026947627,5),(1695,2045696427,6),(1695,2058397227,5),(1695,2077146027,6),(1695,2090451627,5),(1695,2108595627,6),(1695,2121901227,5),(1695,2140045227,6),(1696,-2147483648,1),(1696,-1672536240,2),(1696,-1585100136,3),(1696,-1561251600,4),(1696,-1553565600,3),(1696,-928198800,5),(1696,-900126000,8),(1696,-857257200,6),(1696,-844556400,7),(1696,-828226800,6),(1696,-812502000,7),(1696,-802144800,5),(1696,354920409,9),(1696,370728010,5),(1696,386456410,9),(1696,402264011,5),(1696,417992411,9),(1696,433800012,5),(1696,449614812,9),(1696,465346812,10),(1696,481071612,11),(1696,496796413,10),(1696,512521213,11),(1696,528246013,10),(1696,543970813,11),(1696,559695613,10),(1696,575420414,11),(1696,591145214,10),(1696,606870014,12),(1696,622598414,13),(1696,638323215,12),(1696,654652815,13),(1696,670377616,12),(1696,686102416,13),(1696,701827216,12),(1696,717552017,13),(1696,733276817,12),(1696,749001618,13),(1696,764726418,12),(1696,780451219,13),(1696,796176019,12),(1696,811900819,13),(1696,828230420,12),(1696,846374420,13),(1696,859680020,12),(1696,877824021,13),(1696,883605621,4),(1696,891133221,14),(1696,909277221,15),(1696,922582822,14),(1696,941331622,16),(1696,1041372022,4),(1696,1048986022,17),(1696,1067130022,16),(1696,1080435622,17),(1696,1099184422,16),(1696,1111885222,17),(1696,1130634022,16),(1696,1143334823,17),(1696,1162083623,16),(1696,1174784423,17),(1696,1193533223,16),(1696,1206838823,17),(1696,1224982823,16),(1696,1238288424,17),(1696,1256432424,16),(1696,1269738024,17),(1696,1288486824,16),(1696,1301187624,17),(1696,1319936424,16),(1696,1332637224,17),(1696,1351386025,16),(1696,1364691625,17),(1696,1382835625,16),(1696,1396141225,17),(1696,1414285225,16),(1696,1427590825,17),(1696,1445734826,16),(1696,1459040426,17),(1696,1477789226,16),(1696,1490490027,17),(1696,1509238827,16),(1696,1521939627,17),(1696,1540688427,16),(1696,1553994027,17),(1696,1572138027,16),(1696,1585443627,17),(1696,1603587627,16),(1696,1616893227,17),(1696,1635642027,16),(1696,1648342827,17),(1696,1667091627,16),(1696,1679792427,17),(1696,1698541227,16),(1696,1711846827,17),(1696,1729990827,16),(1696,1743296427,17),(1696,1761440427,16),(1696,1774746027,17),(1696,1792890027,16),(1696,1806195627,17),(1696,1824944427,16),(1696,1837645227,17),(1696,1856394027,16),(1696,1869094827,17),(1696,1887843627,16),(1696,1901149227,17),(1696,1919293227,16),(1696,1932598827,17),(1696,1950742827,16),(1696,1964048427,17),(1696,1982797227,16),(1696,1995498027,17),(1696,2014246827,16),(1696,2026947627,17),(1696,2045696427,16),(1696,2058397227,17),(1696,2077146027,16),(1696,2090451627,17),(1696,2108595627,16),(1696,2121901227,17),(1696,2140045227,16),(1697,-2147483648,0),(1697,-1577761060,1),(1697,-1247540400,2),(1697,354916809,3),(1697,370724410,2),(1697,386452810,3),(1697,402260411,2),(1697,417988811,3),(1697,433796412,2),(1697,449611212,3),(1697,465343212,4),(1697,481068012,5),(1697,496792813,4),(1697,512517613,5),(1697,528242413,4),(1697,543967213,5),(1697,559692013,4),(1697,575416814,6),(1697,591145214,7),(1697,606870014,6),(1697,622594814,7),(1697,638319615,6),(1697,654649215,7),(1697,670374016,4),(1697,701820016,6),(1697,717548417,7),(1697,733273217,6),(1697,748998018,7),(1697,764722818,6),(1697,780447619,7),(1697,796172419,6),(1697,811897219,7),(1697,828226820,6),(1697,846370820,7),(1697,859676420,6),(1697,877820421,7),(1697,891126021,6),(1697,909270021,7),(1697,922575622,6),(1697,941324422,7),(1697,954025222,6),(1697,972774022,7),(1697,985474822,6),(1697,1004223622,7),(1697,1017529222,6),(1697,1035673222,7),(1697,1048978822,6),(1697,1067122822,7),(1697,1080428422,6),(1697,1099177222,7),(1697,1111878022,6),(1697,1130626822,7),(1697,1143327623,6),(1697,1162076423,7),(1697,1174777223,6),(1697,1193526023,7),(1697,1206831623,6),(1697,1224975623,7),(1697,1238281224,6),(1697,1256425224,7),(1697,1269730824,6),(1697,1288479624,7),(1697,1301180424,4),(1697,1414274425,7),(1697,1540681227,4),(1698,-2147483648,1),(1698,-1717032240,3),(1698,-1693706400,2),(1698,-1680483600,3),(1698,-1663455600,4),(1698,-1650150000,5),(1698,-1632006000,4),(1698,-1618700400,8),(1698,-1600473600,6),(1698,-1587168000,7),(1698,-1501725600,3),(1698,-931734000,2),(1698,-857257200,5),(1698,-844556400,4),(1698,-828226800,5),(1698,-812502000,4),(1698,-796874400,2),(1698,-796608000,3),(1698,-778726800,2),(1698,-762660000,3),(1698,-748486800,4),(1698,-733273200,5),(1698,-715215600,4),(1698,-701910000,5),(1698,-684975600,4),(1698,-670460400,5),(1698,-654130800,4),(1698,-639010800,5),(1698,-397094400,4),(1698,-386812800,5),(1698,-371088000,4),(1698,-355363200,5),(1698,-334195200,4),(1698,-323308800,5),(1698,-307584000,4),(1698,-291859200,5),(1698,-271296000,4),(1698,-260409600,5),(1698,-239846400,4),(1698,-228960000,5),(1698,-208396800,4),(1698,-197510400,5),(1698,-176342400,4),(1698,-166060800,5),(1698,220921205,3),(1698,228873606,4),(1698,243993606,5),(1698,260323207,4),(1698,276048007,5),(1698,291772808,4),(1698,307497608,5),(1698,323827209,4),(1698,338947209,5),(1698,354672009,4),(1698,370396810,5),(1698,386121610,4),(1698,401846411,5),(1698,417571211,4),(1698,433296012,5),(1698,449020812,4),(1698,465350412,5),(1698,481075212,4),(1698,496800013,5),(1698,512524813,4),(1698,528249613,5),(1698,543974413,4),(1698,559699213,5),(1698,567990013,3),(1698,575427614,9),(1698,591152414,10),(1698,606877214,9),(1698,622602014,10),(1698,638326815,9),(1698,654656415,10),(1698,670381216,9),(1698,686106016,10),(1698,701830816,9),(1698,717555617,10),(1698,733280417,9),(1698,749005218,10),(1698,764730018,9),(1698,780454819,10),(1698,796179619,9),(1698,811904419,10),(1698,828234020,9),(1698,846378020,10),(1698,859683620,9),(1698,877827621,10),(1698,891133221,9),(1698,909277221,10),(1698,922582822,9),(1698,941331622,10),(1698,954032422,9),(1698,972781222,10),(1698,985482022,9),(1698,1004230822,10),(1698,1017536422,9),(1698,1035680422,10),(1698,1048986022,9),(1698,1067130022,10),(1698,1080435622,9),(1698,1099184422,10),(1698,1111885222,9),(1698,1130634022,10),(1698,1143334823,9),(1698,1162083623,10),(1698,1174784423,9),(1698,1193533223,10),(1698,1206838823,9),(1698,1224982823,10),(1698,1238288424,9),(1698,1256432424,10),(1698,1269738024,9),(1698,1288486824,10),(1698,1301187624,9),(1698,1319936424,10),(1698,1332637224,9),(1698,1351386025,10),(1698,1364691625,9),(1698,1382835625,10),(1698,1396141225,9),(1698,1414285225,10),(1698,1427590825,9),(1698,1445734826,10),(1698,1459040426,9),(1698,1477789226,10),(1698,1490490027,9),(1698,1509238827,10),(1698,1521939627,9),(1698,1540688427,10),(1698,1553994027,9),(1698,1572138027,10),(1698,1585443627,9),(1698,1603587627,10),(1698,1616893227,9),(1698,1635642027,10),(1698,1648342827,9),(1698,1667091627,10),(1698,1679792427,9),(1698,1698541227,10),(1698,1711846827,9),(1698,1729990827,10),(1698,1743296427,9),(1698,1761440427,10),(1698,1774746027,9),(1698,1792890027,10),(1698,1806195627,9),(1698,1824944427,10),(1698,1837645227,9),(1698,1856394027,10),(1698,1869094827,9),(1698,1887843627,10),(1698,1901149227,9),(1698,1919293227,10),(1698,1932598827,9),(1698,1950742827,10),(1698,1964048427,9),(1698,1982797227,10),(1698,1995498027,9),(1698,2014246827,10),(1698,2026947627,9),(1698,2045696427,10),(1698,2058397227,9),(1698,2077146027,10),(1698,2090451627,9),(1698,2108595627,10),(1698,2121901227,9),(1698,2140045227,10),(1699,-2147483648,1),(1699,-905824800,4),(1699,-857257200,2),(1699,-844556400,3),(1699,-828226800,2),(1699,-812502000,3),(1699,-796777200,2),(1699,-788922000,1),(1699,-777942000,3),(1699,-766623600,2),(1699,407199611,1),(1699,417574811,5),(1699,433299612,6),(1699,449024412,5),(1699,465354012,6),(1699,481078812,5),(1699,496803613,6),(1699,512528413,5),(1699,528253213,6),(1699,543978013,5),(1699,559702813,6),(1699,575427614,5),(1699,591152414,6),(1699,606877214,5),(1699,622602014,6),(1699,638326815,5),(1699,654656415,6),(1699,670381216,5),(1699,686106016,6),(1699,701830816,5),(1699,717555617,6),(1699,733280417,5),(1699,749005218,6),(1699,764730018,5),(1699,780454819,6),(1699,796179619,5),(1699,811904419,6),(1699,828234020,5),(1699,846378020,6),(1699,859683620,5),(1699,877827621,6),(1699,891133221,5),(1699,909277221,6),(1699,922582822,5),(1699,941331622,6),(1699,954032422,5),(1699,972781222,6),(1699,985482022,5),(1699,1004230822,6),(1699,1017536422,5),(1699,1035680422,6),(1699,1048986022,5),(1699,1067130022,6),(1699,1080435622,5),(1699,1099184422,6),(1699,1111885222,5),(1699,1130634022,6),(1699,1143334823,5),(1699,1162083623,6),(1699,1174784423,5),(1699,1193533223,6),(1699,1206838823,5),(1699,1224982823,6),(1699,1238288424,5),(1699,1256432424,6),(1699,1269738024,5),(1699,1288486824,6),(1699,1301187624,5),(1699,1319936424,6),(1699,1332637224,5),(1699,1351386025,6),(1699,1364691625,5),(1699,1382835625,6),(1699,1396141225,5),(1699,1414285225,6),(1699,1427590825,5),(1699,1445734826,6),(1699,1459040426,5),(1699,1477789226,6),(1699,1490490027,5),(1699,1509238827,6),(1699,1521939627,5),(1699,1540688427,6),(1699,1553994027,5),(1699,1572138027,6),(1699,1585443627,5),(1699,1603587627,6),(1699,1616893227,5),(1699,1635642027,6),(1699,1648342827,5),(1699,1667091627,6),(1699,1679792427,5),(1699,1698541227,6),(1699,1711846827,5),(1699,1729990827,6),(1699,1743296427,5),(1699,1761440427,6),(1699,1774746027,5),(1699,1792890027,6),(1699,1806195627,5),(1699,1824944427,6),(1699,1837645227,5),(1699,1856394027,6),(1699,1869094827,5),(1699,1887843627,6),(1699,1901149227,5),(1699,1919293227,6),(1699,1932598827,5),(1699,1950742827,6),(1699,1964048427,5),(1699,1982797227,6),(1699,1995498027,5),(1699,2014246827,6),(1699,2026947627,5),(1699,2045696427,6),(1699,2058397227,5),(1699,2077146027,6),(1699,2090451627,5),(1699,2108595627,6),(1699,2121901227,5),(1699,2140045227,6),(1700,-2147483648,1),(1700,-1441160400,2),(1700,-1247536800,3),(1700,-894769200,6),(1700,-857257200,4),(1700,-844556400,5),(1700,-828226800,4),(1700,-826419600,3),(1700,354920409,7),(1700,370728010,3),(1700,386456410,7),(1700,402264011,3),(1700,417992411,7),(1700,433800012,3),(1700,449614812,7),(1700,465346812,8),(1700,481071612,9),(1700,496796413,8),(1700,512521213,9),(1700,528246013,8),(1700,543970813,9),(1700,559695613,8),(1700,575420414,9),(1700,591145214,8),(1700,606870014,9),(1700,622594814,8),(1700,638319615,9),(1700,654649215,8),(1700,670374016,10),(1700,686091616,2),(1700,701820016,10),(1700,717541217,2),(1700,733269617,10),(1700,748990818,2),(1700,764719218,10),(1700,780440419,2),(1700,796179619,11),(1700,811904419,12),(1700,828234020,11),(1700,846378020,12),(1700,859683620,11),(1700,877827621,12),(1700,891133221,11),(1700,909277221,12),(1700,922582822,11),(1700,941331622,12),(1700,954032422,11),(1700,972781222,12),(1700,985482022,11),(1700,1004230822,12),(1700,1017536422,11),(1700,1035680422,12),(1700,1048986022,11),(1700,1067130022,12),(1700,1080435622,11),(1700,1099184422,12),(1700,1111885222,11),(1700,1130634022,12),(1700,1143334823,11),(1700,1162083623,12),(1700,1174784423,11),(1700,1193533223,12),(1700,1206838823,11),(1700,1224982823,12),(1700,1238288424,11),(1700,1256432424,12),(1700,1269738024,11),(1700,1288486824,12),(1700,1301187624,11),(1700,1319936424,12),(1700,1332637224,11),(1700,1351386025,12),(1700,1364691625,11),(1700,1382835625,12),(1700,1396141225,11),(1700,1414285225,12),(1700,1427590825,11),(1700,1445734826,12),(1700,1459040426,11),(1700,1477789226,12),(1700,1490490027,11),(1700,1509238827,12),(1700,1521939627,11),(1700,1540688427,12),(1700,1553994027,11),(1700,1572138027,12),(1700,1585443627,11),(1700,1603587627,12),(1700,1616893227,11),(1700,1635642027,12),(1700,1648342827,11),(1700,1667091627,12),(1700,1679792427,11),(1700,1698541227,12),(1700,1711846827,11),(1700,1729990827,12),(1700,1743296427,11),(1700,1761440427,12),(1700,1774746027,11),(1700,1792890027,12),(1700,1806195627,11),(1700,1824944427,12),(1700,1837645227,11),(1700,1856394027,12),(1700,1869094827,11),(1700,1887843627,12),(1700,1901149227,11),(1700,1919293227,12),(1700,1932598827,11),(1700,1950742827,12),(1700,1964048427,11),(1700,1982797227,12),(1700,1995498027,11),(1700,2014246827,12),(1700,2026947627,11),(1700,2045696427,12),(1700,2058397227,11),(1700,2077146027,12),(1700,2090451627,11),(1700,2108595627,12),(1700,2121901227,11),(1700,2140045227,12),(1701,-2147483648,2),(1701,-904435200,1),(1701,-891129600,2),(1701,-872985600,1),(1701,-859680000,2),(1701,354675609,3),(1701,370400410,4),(1701,386125210,3),(1701,401850011,4),(1701,417574811,3),(1701,433299612,4),(1701,449024412,3),(1701,465354012,4),(1701,481078812,3),(1701,496803613,4),(1701,512528413,3),(1701,528253213,4),(1701,543978013,3),(1701,559702813,4),(1701,575427614,3),(1701,591152414,4),(1701,606877214,3),(1701,622602014,4),(1701,638326815,3),(1701,654656415,4),(1701,670381216,3),(1701,686106016,4),(1701,701830816,3),(1701,717555617,4),(1701,733280417,3),(1701,749005218,4),(1701,764730018,3),(1701,780454819,4),(1701,796179619,3),(1701,811904419,4),(1701,828234020,3),(1701,846378020,4),(1701,859683620,3),(1701,877827621,4),(1701,891133221,3),(1701,909277221,4),(1701,922582822,3),(1701,941331622,4),(1701,954032422,3),(1701,972781222,4),(1701,985482022,3),(1701,1004230822,4),(1701,1017536422,3),(1701,1035680422,4),(1701,1048986022,3),(1701,1067130022,4),(1701,1080435622,3),(1701,1099184422,4),(1701,1111885222,3),(1701,1130634022,4),(1701,1143334823,3),(1701,1162083623,4),(1701,1174784423,3),(1701,1193533223,4),(1701,1206838823,3),(1701,1224982823,4),(1701,1238288424,3),(1701,1256432424,4),(1701,1269738024,3),(1701,1288486824,4),(1701,1301187624,3),(1701,1319936424,4),(1701,1332637224,3),(1701,1351386025,4),(1701,1364691625,3),(1701,1382835625,4),(1701,1396141225,3),(1701,1414285225,4),(1701,1427590825,3),(1701,1445734826,4),(1701,1459040426,3),(1701,1477789226,4),(1701,1490490027,3),(1701,1509238827,4),(1701,1521939627,3),(1701,1540688427,4),(1701,1553994027,3),(1701,1572138027,4),(1701,1585443627,3),(1701,1603587627,4),(1701,1616893227,3),(1701,1635642027,4),(1701,1648342827,3),(1701,1667091627,4),(1701,1679792427,3),(1701,1698541227,4),(1701,1711846827,3),(1701,1729990827,4),(1701,1743296427,3),(1701,1761440427,4),(1701,1774746027,3),(1701,1792890027,4),(1701,1806195627,3),(1701,1824944427,4),(1701,1837645227,3),(1701,1856394027,4),(1701,1869094827,3),(1701,1887843627,4),(1701,1901149227,3),(1701,1919293227,4),(1701,1932598827,3),(1701,1950742827,4),(1701,1964048427,3),(1701,1982797227,4),(1701,1995498027,3),(1701,2014246827,4),(1701,2026947627,3),(1701,2045696427,4),(1701,2058397227,3),(1701,2077146027,4),(1701,2090451627,3),(1701,2108595627,4),(1701,2121901227,3),(1701,2140045227,4),(1702,-2147483648,2),(1702,-1691964000,1),(1702,-1680472800,2),(1702,-1664143200,1),(1702,-1650146400,2),(1702,-1633903200,1),(1702,-1617487200,2),(1702,-1601848800,1),(1702,-1586037600,2),(1702,-1570399200,1),(1702,-1552168800,2),(1702,-1538344800,1),(1702,-1522533600,2),(1702,-1507500000,1),(1702,-1490565600,2),(1702,-1473631200,1),(1702,-1460930400,2),(1702,-1442786400,1),(1702,-1428876000,2),(1702,-1410732000,1),(1702,-1396216800,2),(1702,-1379282400,1),(1702,-1364767200,2),(1702,-1348437600,1),(1702,-1333317600,2),(1702,-1315778400,1),(1702,-1301263200,2),(1702,-1284328800,1),(1702,-1269813600,2),(1702,-1253484000,1),(1702,-1238364000,2),(1702,-1221429600,1),(1702,-1206914400,2),(1702,-1189980000,1),(1702,-1175464800,2),(1702,-1159135200,1),(1702,-1143410400,2),(1702,-1126476000,1),(1702,-1111960800,2),(1702,-1095631200,1),(1702,-1080511200,2),(1702,-1063576800,1),(1702,-1049061600,2),(1702,-1032127200,1),(1702,-1017612000,2),(1702,-1001282400,1),(1702,-986162400,2),(1702,-969228000,1),(1702,-950479200,2),(1702,-942012000,1),(1702,-904518000,3),(1702,-896050800,1),(1702,-875487600,3),(1702,-864601200,1),(1702,-844038000,3),(1702,-832546800,1),(1702,-812588400,3),(1702,-798073200,1),(1702,-781052400,3),(1702,-772066800,1),(1702,-764805600,2),(1702,-748476000,1),(1702,-733356000,2),(1702,-719445600,1),(1702,-717030000,3),(1702,-706748400,1),(1702,-699487200,2),(1702,-687996000,1),(1702,-668037600,2),(1702,-654732000,1),(1702,-636588000,2),(1702,-622072800,1),(1702,-605743200,2),(1702,-590623200,1),(1702,-574293600,2),(1702,-558568800,1),(1702,-542239200,2),(1702,-527119200,1),(1702,-512604000,2),(1702,-496274400,1),(1702,-481154400,2),(1702,-464220000,1),(1702,-449704800,2),(1702,-432165600,1),(1702,-417650400,2),(1702,-401320800,1),(1702,-386200800,2),(1702,-369266400,1),(1702,-354751200,2),(1702,-337816800,1),(1702,-323301600,2),(1702,-306972000,1),(1702,-291852000,2),(1702,-276732000,1),(1702,-257983200,2),(1702,-245282400,1),(1702,-226533600,2),(1702,-213228000,1),(1702,-195084000,2),(1702,-182383200,1),(1702,-163634400,2),(1702,-150933600,1),(1702,-132184800,2),(1702,-119484000,1),(1702,-100735200,2),(1702,-88034400,1),(1702,-68680800,2),(1702,-59004000,1),(1702,-37242000,4),(1702,57722400,6),(1702,69818400,1),(1702,89172001,2),(1702,101268002,1),(1702,120621602,2),(1702,132717603,1),(1702,152071203,2),(1702,164167204,1),(1702,183520804,2),(1702,196221605,1),(1702,214970405,2),(1702,227671206,1),(1702,246420006,2),(1702,259120807,1),(1702,278474407,2),(1702,290570408,1),(1702,309924008,2),(1702,322020009,1),(1702,341373609,2),(1702,354675609,5),(1702,372819610,6),(1702,386125210,5),(1702,404269211,6),(1702,417574811,5),(1702,435718812,6),(1702,449024412,5),(1702,467773212,6),(1702,481078812,5),(1702,499222813,6),(1702,512528413,5),(1702,530672413,6),(1702,543978013,5),(1702,562122013,6),(1702,575427614,5),(1702,593571614,6),(1702,606877214,5),(1702,625626014,6),(1702,638326815,5),(1702,657075615,6),(1702,670381216,5),(1702,688525216,6),(1702,701830816,5),(1702,719974817,6),(1702,733280417,5),(1702,751424418,6),(1702,764730018,5),(1702,782874019,6),(1702,796179619,5),(1702,814323619,6),(1702,820454420,7),(1702,828234020,5),(1702,846378020,6),(1702,859683620,5),(1702,877827621,6),(1702,891133221,5),(1702,909277221,6),(1702,922582822,5),(1702,941331622,6),(1702,954032422,5),(1702,972781222,6),(1702,985482022,5),(1702,1004230822,6),(1702,1017536422,5),(1702,1035680422,6),(1702,1048986022,5),(1702,1067130022,6),(1702,1080435622,5),(1702,1099184422,6),(1702,1111885222,5),(1702,1130634022,6),(1702,1143334823,5),(1702,1162083623,6),(1702,1174784423,5),(1702,1193533223,6),(1702,1206838823,5),(1702,1224982823,6),(1702,1238288424,5),(1702,1256432424,6),(1702,1269738024,5),(1702,1288486824,6),(1702,1301187624,5),(1702,1319936424,6),(1702,1332637224,5),(1702,1351386025,6),(1702,1364691625,5),(1702,1382835625,6),(1702,1396141225,5),(1702,1414285225,6),(1702,1427590825,5),(1702,1445734826,6),(1702,1459040426,5),(1702,1477789226,6),(1702,1490490027,5),(1702,1509238827,6),(1702,1521939627,5),(1702,1540688427,6),(1702,1553994027,5),(1702,1572138027,6),(1702,1585443627,5),(1702,1603587627,6),(1702,1616893227,5),(1702,1635642027,6),(1702,1648342827,5),(1702,1667091627,6),(1702,1679792427,5),(1702,1698541227,6),(1702,1711846827,5),(1702,1729990827,6),(1702,1743296427,5),(1702,1761440427,6),(1702,1774746027,5),(1702,1792890027,6),(1702,1806195627,5),(1702,1824944427,6),(1702,1837645227,5),(1702,1856394027,6),(1702,1869094827,5),(1702,1887843627,6),(1702,1901149227,5),(1702,1919293227,6),(1702,1932598827,5),(1702,1950742827,6),(1702,1964048427,5),(1702,1982797227,6),(1702,1995498027,5),(1702,2014246827,6),(1702,2026947627,5),(1702,2045696427,6),(1702,2058397227,5),(1702,2077146027,6),(1702,2090451627,5),(1702,2108595627,6),(1702,2121901227,5),(1702,2140045227,6),(1703,-2147483648,2),(1703,-1691964000,1),(1703,-1680472800,2),(1703,-1664143200,1),(1703,-1650146400,2),(1703,-1633903200,1),(1703,-1617487200,2),(1703,-1601848800,1),(1703,-1586037600,2),(1703,-1570399200,1),(1703,-1552168800,2),(1703,-1538344800,1),(1703,-1522533600,2),(1703,-1507500000,1),(1703,-1490565600,2),(1703,-1473631200,1),(1703,-1460930400,2),(1703,-1442786400,1),(1703,-1428876000,2),(1703,-1410732000,1),(1703,-1396216800,2),(1703,-1379282400,1),(1703,-1364767200,2),(1703,-1348437600,1),(1703,-1333317600,2),(1703,-1315778400,1),(1703,-1301263200,2),(1703,-1284328800,1),(1703,-1269813600,2),(1703,-1253484000,1),(1703,-1238364000,2),(1703,-1221429600,1),(1703,-1206914400,2),(1703,-1189980000,1),(1703,-1175464800,2),(1703,-1159135200,1),(1703,-1143410400,2),(1703,-1126476000,1),(1703,-1111960800,2),(1703,-1095631200,1),(1703,-1080511200,2),(1703,-1063576800,1),(1703,-1049061600,2),(1703,-1032127200,1),(1703,-1017612000,2),(1703,-1001282400,1),(1703,-986162400,2),(1703,-969228000,1),(1703,-950479200,2),(1703,-942012000,1),(1703,-904518000,3),(1703,-896050800,1),(1703,-875487600,3),(1703,-864601200,1),(1703,-844038000,3),(1703,-832546800,1),(1703,-812588400,3),(1703,-798073200,1),(1703,-781052400,3),(1703,-772066800,1),(1703,-764805600,2),(1703,-748476000,1),(1703,-733356000,2),(1703,-719445600,1),(1703,-717030000,3),(1703,-706748400,1),(1703,-699487200,2),(1703,-687996000,1),(1703,-668037600,2),(1703,-654732000,1),(1703,-636588000,2),(1703,-622072800,1),(1703,-605743200,2),(1703,-590623200,1),(1703,-574293600,2),(1703,-558568800,1),(1703,-542239200,2),(1703,-527119200,1),(1703,-512604000,2),(1703,-496274400,1),(1703,-481154400,2),(1703,-464220000,1),(1703,-449704800,2),(1703,-432165600,1),(1703,-417650400,2),(1703,-401320800,1),(1703,-386200800,2),(1703,-369266400,1),(1703,-354751200,2),(1703,-337816800,1),(1703,-323301600,2),(1703,-306972000,1),(1703,-291852000,2),(1703,-276732000,1),(1703,-257983200,2),(1703,-245282400,1),(1703,-226533600,2),(1703,-213228000,1),(1703,-195084000,2),(1703,-182383200,1),(1703,-163634400,2),(1703,-150933600,1),(1703,-132184800,2),(1703,-119484000,1),(1703,-100735200,2),(1703,-88034400,1),(1703,-68680800,2),(1703,-59004000,1),(1703,-37242000,4),(1703,57722400,6),(1703,69818400,1),(1703,89172001,2),(1703,101268002,1),(1703,120621602,2),(1703,132717603,1),(1703,152071203,2),(1703,164167204,1),(1703,183520804,2),(1703,196221605,1),(1703,214970405,2),(1703,227671206,1),(1703,246420006,2),(1703,259120807,1),(1703,278474407,2),(1703,290570408,1),(1703,309924008,2),(1703,322020009,1),(1703,341373609,2),(1703,354675609,5),(1703,372819610,6),(1703,386125210,5),(1703,404269211,6),(1703,417574811,5),(1703,435718812,6),(1703,449024412,5),(1703,467773212,6),(1703,481078812,5),(1703,499222813,6),(1703,512528413,5),(1703,530672413,6),(1703,543978013,5),(1703,562122013,6),(1703,575427614,5),(1703,593571614,6),(1703,606877214,5),(1703,625626014,6),(1703,638326815,5),(1703,657075615,6),(1703,670381216,5),(1703,688525216,6),(1703,701830816,5),(1703,719974817,6),(1703,733280417,5),(1703,751424418,6),(1703,764730018,5),(1703,782874019,6),(1703,796179619,5),(1703,814323619,6),(1703,820454420,7),(1703,828234020,5),(1703,846378020,6),(1703,859683620,5),(1703,877827621,6),(1703,891133221,5),(1703,909277221,6),(1703,922582822,5),(1703,941331622,6),(1703,954032422,5),(1703,972781222,6),(1703,985482022,5),(1703,1004230822,6),(1703,1017536422,5),(1703,1035680422,6),(1703,1048986022,5),(1703,1067130022,6),(1703,1080435622,5),(1703,1099184422,6),(1703,1111885222,5),(1703,1130634022,6),(1703,1143334823,5),(1703,1162083623,6),(1703,1174784423,5),(1703,1193533223,6),(1703,1206838823,5),(1703,1224982823,6),(1703,1238288424,5),(1703,1256432424,6),(1703,1269738024,5),(1703,1288486824,6),(1703,1301187624,5),(1703,1319936424,6),(1703,1332637224,5),(1703,1351386025,6),(1703,1364691625,5),(1703,1382835625,6),(1703,1396141225,5),(1703,1414285225,6),(1703,1427590825,5),(1703,1445734826,6),(1703,1459040426,5),(1703,1477789226,6),(1703,1490490027,5),(1703,1509238827,6),(1703,1521939627,5),(1703,1540688427,6),(1703,1553994027,5),(1703,1572138027,6),(1703,1585443627,5),(1703,1603587627,6),(1703,1616893227,5),(1703,1635642027,6),(1703,1648342827,5),(1703,1667091627,6),(1703,1679792427,5),(1703,1698541227,6),(1703,1711846827,5),(1703,1729990827,6),(1703,1743296427,5),(1703,1761440427,6),(1703,1774746027,5),(1703,1792890027,6),(1703,1806195627,5),(1703,1824944427,6),(1703,1837645227,5),(1703,1856394027,6),(1703,1869094827,5),(1703,1887843627,6),(1703,1901149227,5),(1703,1919293227,6),(1703,1932598827,5),(1703,1950742827,6),(1703,1964048427,5),(1703,1982797227,6),(1703,1995498027,5),(1703,2014246827,6),(1703,2026947627,5),(1703,2045696427,6),(1703,2058397227,5),(1703,2077146027,6),(1703,2090451627,5),(1703,2108595627,6),(1703,2121901227,5),(1703,2140045227,6),(1710,-2147483648,0),(1710,-2056690800,1),(1710,-900909000,2),(1710,-891579600,3),(1710,-884248200,4),(1710,-766659600,1),(1710,-747981000,2),(1710,-728544600,1),(1710,-717049800,2),(1710,-694503000,1),(1710,-683785800,2),(1710,-668064600,1),(1710,-654755400,2),(1710,-636615000,1),(1710,-623305800,2),(1710,-605165400,1),(1710,-591856200,2),(1710,-573715800,1),(1710,-559801800,2),(1710,-541661400,1),(1710,-528352200,2),(1710,-510211800,1),(1710,-498112200,2),(1710,-478762200,1),(1710,-466662600,2),(1710,-446707800,1),(1710,-435213000,2),(1710,-415258200,1),(1710,-403158600,2),(1710,-383808600,1),(1710,-371709000,2),(1710,-352359000,1),(1710,-340259400,2),(1710,-320909400,1),(1710,-308809800,2),(1710,-288855000,1),(1710,-277360200,2),(1710,-257405400,1),(1710,-245910600,2),(1710,-225955800,1),(1710,-213856200,2),(1710,-194506200,1),(1710,-182406600,2),(1710,-163056600,1),(1710,-148537800,2),(1710,-132816600,1),(1710,-117088200,2),(1710,-101367000,1),(1710,-85638600,2),(1710,-69312600,1),(1710,-53584200,2),(1710,-37863000,1),(1710,-22134600,2),(1710,-6413400,1),(1710,9315000,2),(1710,25036200,1),(1710,40764600,2),(1710,56485800,1),(1710,72214200,2),(1710,88540201,1),(1710,104268602,2),(1710,119989802,1),(1710,126041402,2),(1710,151439403,1),(1710,167167804,2),(1710,182889004,1),(1710,198617405,2),(1710,214338605,1),(1710,295385408,2),(1710,309292208,1),(1711,-2147483648,0),(1711,-1956609120,2),(1711,-1668211200,1),(1711,-1647212400,2),(1711,-1636675200,1),(1711,-1613430000,2),(1711,-1605139200,1),(1711,-1581894000,2),(1711,-1539561600,1),(1711,-1531350000,2),(1711,-968025600,1),(1711,-952293600,2),(1711,-942008400,1),(1711,-920239200,3),(1711,-909957600,4),(1711,-888789600,3),(1711,-877903200,4),(1711,-857944800,3),(1711,-846453600,4),(1711,-826495200,3),(1711,-815004000,4),(1711,-795045600,3),(1711,-783554400,4),(1711,-762991200,3),(1711,-752104800,4),(1711,-731541600,3),(1711,-717631200,4),(1711,-700092000,3),(1711,-686181600,4),(1711,-668642400,3),(1711,-654732000,4),(1711,-636588000,3),(1711,-623282400,4),(1711,-605743200,3),(1711,-591832800,4),(1711,-573688800,3),(1711,-559778400,4),(1711,-542239200,3),(1711,-528328800,4),(1711,-510789600,3),(1711,-496879200,4),(1711,-479340000,3),(1711,-465429600,4),(1711,-447890400,3),(1711,-433980000,4),(1711,-415836000,3),(1711,-401925600,4),(1711,-384386400,3),(1711,-370476000,4),(1711,-352936800,3),(1711,-339026400,4),(1711,-321487200,3),(1711,-307576800,4),(1711,-290037600,3),(1711,-276127200,4),(1711,-258588000,3),(1711,-244677600,4),(1711,-226533600,3),(1711,-212623200,4),(1711,-195084000,3),(1711,-181173600,4),(1711,-163634400,3),(1711,-149724000,4),(1711,-132184800,3),(1711,-118274400,4),(1711,-100735200,3),(1711,-86824800,4),(1711,-68680800,3),(1711,-54770400,5),(1712,-2147483648,0),(1712,-1309746436,1),(1712,-1262314800,2),(1712,-946780200,3),(1712,-315629100,1),(1713,-2147483648,0),(1713,-1988167780,1),(1713,820436419,2),(1716,-2147483648,0),(1716,-1309746436,1),(1716,-1262314800,2),(1716,-946780200,3),(1716,-315629100,1),(1717,-2147483648,0),(1717,-631152000,1),(1718,-2147483648,0),(1718,-2006653308,1),(1719,-2147483648,1),(1719,-315636840,2),(1720,-2147483648,0),(1720,-1988164200,2),(1720,403041611,1),(1720,417034811,2),(1720,1224972023,1),(1720,1238274024,2),(1721,-2147483648,0),(1721,-1309746436,1),(1721,-1262314800,2),(1721,-946780200,3),(1721,-315629100,1),(1722,-2147483648,0),(1722,-1848886912,1),(1723,-2147483648,0),(1723,-1704165944,1),(1723,-757394744,2),(1723,247177806,4),(1723,259272007,3),(1723,277758007,4),(1723,283982407,2),(1723,290809808,5),(1723,306531008,2),(1723,322432209,5),(1723,338499009,2),(1723,673216216,5),(1723,685481416,2),(1723,701209816,5),(1723,717103817,2),(1723,732745817,5),(1723,748639818,2),(1723,764281818,5),(1723,780175819,2),(1723,795817819,5),(1723,811711819,2),(1723,827353820,5),(1723,843247820,2),(1723,858976220,5),(1723,874870221,2),(1723,890512221,5),(1723,906406221,2),(1723,922048222,5),(1723,937942222,2),(1723,953584222,5),(1723,969478222,2),(1723,985206622,5),(1723,1001100622,2),(1723,1016742622,5),(1723,1032636622,2),(1723,1048278622,5),(1723,1064172622,2),(1723,1079814622,5),(1723,1095708622,2),(1723,1111437022,5),(1723,1127331022,2),(1723,1206045023,5),(1723,1221939023,2),(1723,1237667424,5),(1723,1253561424,2),(1723,1269203424,5),(1723,1285097424,2),(1723,1300739424,5),(1723,1316633424,2),(1723,1332275424,5),(1723,1348169425,2),(1723,1363897825,5),(1723,1379791825,2),(1723,1395433825,5),(1723,1411327825,2),(1723,1426969825,5),(1723,1442863826,2),(1723,1458505826,5),(1723,1474399826,2),(1723,1490128227,5),(1723,1506022227,2),(1723,1521664227,5),(1723,1537558227,2),(1723,1553200227,5),(1723,1569094227,2),(1723,1584736227,5),(1723,1600630227,2),(1723,1616358627,5),(1723,1632252627,2),(1723,1647894627,5),(1723,1663788627,2),(1723,1679430627,5),(1723,1695324627,2),(1723,1710966627,5),(1723,1726860627,2),(1723,1742589027,5),(1723,1758483027,2),(1723,1774125027,5),(1723,1790019027,2),(1723,1805661027,5),(1723,1821555027,2),(1723,1837197027,5),(1723,1853091027,2),(1723,1868733027,5),(1723,1884627027,2),(1723,1900355427,5),(1723,1916249427,2),(1723,1931891427,5),(1723,1947785427,2),(1723,1963427427,5),(1723,1979321427,2),(1723,1994963427,5),(1723,2010857427,2),(1723,2026585827,5),(1723,2042479827,2),(1723,2058121827,5),(1723,2074015827,2),(1723,2089657827,5),(1723,2105551827,2),(1723,2121193827,5),(1723,2137087827,2),(1724,-2147483648,1),(1724,-1641003640,3),(1724,-933645600,2),(1724,-857358000,3),(1724,-844300800,2),(1724,-825822000,3),(1724,-812685600,2),(1724,-794199600,3),(1724,-779853600,2),(1724,-762656400,3),(1724,-748310400,2),(1724,-731127600,3),(1724,-681962400,4),(1724,-673243200,2),(1724,-667962000,3),(1724,-652327200,2),(1724,-636426000,3),(1724,-622087200,2),(1724,-608947200,3),(1724,-591847200,2),(1724,-572486400,3),(1724,-558576000,2),(1724,-542851200,3),(1724,-527731200,2),(1724,-514425600,3),(1724,-490845600,2),(1724,-482986800,3),(1724,-459475200,2),(1724,-451537200,3),(1724,-428551200,2),(1724,-418262400,3),(1724,-400032000,2),(1724,-387428400,3),(1724,142380003,2),(1724,150843603,3),(1724,167176804,2),(1724,178664404,3),(1724,334015209,2),(1724,337644009,3),(1724,452556012,2),(1724,462232812,3),(1724,482277612,2),(1724,495579613,3),(1724,516751213,2),(1724,526424413,3),(1724,545436013,2),(1724,558478813,3),(1724,576626414,2),(1724,589323614,3),(1724,609890414,2),(1724,620773214,3),(1724,638316015,2),(1724,651618015,3),(1724,669765616,2),(1724,683672416,3),(1724,701820016,2),(1724,715726817,3),(1724,733701617,2),(1724,747176418,3),(1724,765151218,2),(1724,778021219,3),(1724,796600819,2),(1724,810075619,3),(1724,826840820,2),(1724,842821220,3),(1724,858895220,2),(1724,874184421,3),(1724,890344821,2),(1724,905029221,3),(1724,923011222,2),(1724,936313222,3),(1724,955670422,2),(1724,970783222,3),(1724,986770822,2),(1724,1001282422,3),(1724,1017356422,2),(1724,1033941622,3),(1724,1048806022,2),(1724,1065132022,3),(1724,1081292422,2),(1724,1095804022,3),(1724,1112313622,2),(1724,1128812422,3),(1724,1143763223,2),(1724,1159657223,3),(1724,1175212823,2),(1724,1189897223,3),(1724,1206662423,2),(1724,1223161223,3),(1724,1238112024,2),(1724,1254006024,3),(1724,1269561624,2),(1724,1284246024,3),(1724,1301616024,2),(1724,1317510024,3),(1724,1333065624,2),(1724,1348354825,3),(1724,1364515225,2),(1724,1382828425,3),(1724,1395964825,2),(1724,1414278025,3),(1724,1427414425,2),(1724,1445727626,3),(1724,1458864026,2),(1724,1477782026,3),(1724,1490313627,2),(1724,1509231627,3),(1724,1521763227,2),(1724,1540681227,3),(1724,1553817627,2),(1724,1572130827,3),(1724,1585267227,2),(1724,1603580427,3),(1724,1616716827,2),(1724,1635634827,3),(1724,1648166427,2),(1724,1667084427,3),(1724,1679616027,2),(1724,1698534027,3),(1724,1711670427,2),(1724,1729983627,3),(1724,1743120027,2),(1724,1761433227,3),(1724,1774569627,2),(1724,1792882827,3),(1724,1806019227,2),(1724,1824937227,3),(1724,1837468827,2),(1724,1856386827,3),(1724,1868918427,2),(1724,1887836427,3),(1724,1900972827,2),(1724,1919286027,3),(1724,1932422427,2),(1724,1950735627,3),(1724,1963872027,2),(1724,1982790027,3),(1724,1995321627,2),(1724,2014239627,3),(1724,2026771227,2),(1724,2045689227,3),(1724,2058220827,2),(1724,2077138827,3),(1724,2090275227,2),(1724,2108588427,3),(1724,2121724827,2),(1724,2140038027,3),(1725,-2147483648,1),(1725,-1827687170,2),(1725,126687603,3),(1725,152085603,2),(1725,162370804,3),(1725,183535204,2),(1725,199263605,3),(1725,215589605,2),(1725,230713206,3),(1725,247039206,2),(1725,262767607,3),(1725,278488807,2),(1725,294217208,3),(1725,309938408,2),(1725,325666809,3),(1725,341388009,2),(1725,357116409,3),(1725,372837610,2),(1725,388566010,3),(1725,404892011,2),(1725,420015611,3),(1725,436341612,2),(1726,-2147483648,3),(1726,-683802000,1),(1726,-672310800,2),(1726,-654771600,1),(1726,-640861200,2),(1726,-620298000,1),(1726,-609411600,2),(1726,-588848400,1),(1726,-577962000,2),(1727,-2147483648,1),(1727,-1041418800,2),(1727,-907408800,3),(1727,-817462800,1),(1727,-7988400,4),(1727,745934418,5),(1728,-2147483648,0),(1728,-1577926364,2),(1728,-574902000,1),(1728,-568087200,2),(1728,-512175600,1),(1728,-504928800,2),(1728,-449888400,1),(1728,-441856800,2),(1728,-347158800,3),(1728,378684010,2),(1728,386463610,1),(1728,402271211,2),(1728,417999611,1),(1728,433807212,2),(1728,449622012,1),(1728,465429612,2),(1728,481590012,1),(1728,496965613,2),(1728,512953213,1),(1728,528674413,2),(1728,544230013,1),(1728,560037613,2),(1728,575852414,1),(1728,591660014,2),(1728,607388414,1),(1728,623196014,2),(1728,641775615,3),(1728,844034420,2),(1728,860108420,1),(1728,875916021,3),(1728,1352505625,2),(1728,1364515225,1),(1728,1382659225,3),(1729,-1693706400,0),(1729,-1680483600,1),(1729,-1663455600,2),(1729,-1650150000,3),(1729,-1632006000,2),(1729,-1618700400,3),(1729,-938905200,2),(1729,-857257200,3),(1729,-844556400,2),(1729,-828226800,3),(1729,-812502000,2),(1729,-796777200,3),(1729,-781052400,2),(1729,-766623600,3),(1729,228877206,2),(1729,243997206,3),(1729,260326807,2),(1729,276051607,3),(1729,291776408,2),(1729,307501208,3),(1729,323830809,2),(1729,338950809,3),(1729,354675609,2),(1729,370400410,3),(1729,386125210,2),(1729,401850011,3),(1729,417574811,2),(1729,433299612,3),(1729,449024412,2),(1729,465354012,3),(1729,481078812,2),(1729,496803613,3),(1729,512528413,2),(1729,528253213,3),(1729,543978013,2),(1729,559702813,3),(1729,575427614,2),(1729,591152414,3),(1729,606877214,2),(1729,622602014,3),(1729,638326815,2),(1729,654656415,3),(1729,670381216,2),(1729,686106016,3),(1729,701830816,2),(1729,717555617,3),(1729,733280417,2),(1729,749005218,3),(1729,764730018,2),(1729,780454819,3),(1729,796179619,2),(1729,811904419,3),(1729,828234020,2),(1729,846378020,3),(1729,859683620,2),(1729,877827621,3),(1729,891133221,2),(1729,909277221,3),(1729,922582822,2),(1729,941331622,3),(1729,954032422,2),(1729,972781222,3),(1729,985482022,2),(1729,1004230822,3),(1729,1017536422,2),(1729,1035680422,3),(1729,1048986022,2),(1729,1067130022,3),(1729,1080435622,2),(1729,1099184422,3),(1729,1111885222,2),(1729,1130634022,3),(1729,1143334823,2),(1729,1162083623,3),(1729,1174784423,2),(1729,1193533223,3),(1729,1206838823,2),(1729,1224982823,3),(1729,1238288424,2),(1729,1256432424,3),(1729,1269738024,2),(1729,1288486824,3),(1729,1301187624,2),(1729,1319936424,3),(1729,1332637224,2),(1729,1351386025,3),(1729,1364691625,2),(1729,1382835625,3),(1729,1396141225,2),(1729,1414285225,3),(1729,1427590825,2),(1729,1445734826,3),(1729,1459040426,2),(1729,1477789226,3),(1729,1490490027,2),(1729,1509238827,3),(1729,1521939627,2),(1729,1540688427,3),(1729,1553994027,2),(1729,1572138027,3),(1729,1585443627,2),(1729,1603587627,3),(1729,1616893227,2),(1729,1635642027,3),(1729,1648342827,2),(1729,1667091627,3),(1729,1679792427,2),(1729,1698541227,3),(1729,1711846827,2),(1729,1729990827,3),(1729,1743296427,2),(1729,1761440427,3),(1729,1774746027,2),(1729,1792890027,3),(1729,1806195627,2),(1729,1824944427,3),(1729,1837645227,2),(1729,1856394027,3),(1729,1869094827,2),(1729,1887843627,3),(1729,1901149227,2),(1729,1919293227,3),(1729,1932598827,2),(1729,1950742827,3),(1729,1964048427,2),(1729,1982797227,3),(1729,1995498027,2),(1729,2014246827,3),(1729,2026947627,2),(1729,2045696427,3),(1729,2058397227,2),(1729,2077146027,3),(1729,2090451627,2),(1729,2108595627,3),(1729,2121901227,2),(1729,2140045227,3),(1731,-1633273200,0),(1731,-1615132800,1),(1731,-1601823600,0),(1731,-1583683200,1),(1731,-880210800,2),(1731,-769395600,3),(1731,-765388800,1),(1731,-84380400,0),(1731,-68659200,1),(1731,-52930800,0),(1731,-37209600,1),(1731,-21481200,0),(1731,-5760000,1),(1731,9968400,0),(1731,25689600,1),(1731,41418000,0),(1731,57744000,1),(1731,73472400,0),(1731,89193601,1),(1731,104922002,0),(1731,120643202,1),(1731,126694803,0),(1731,152092803,1),(1731,162378004,0),(1731,183542404,1),(1731,199270805,0),(1731,215596805,1),(1731,230720406,0),(1731,247046406,1),(1731,262774807,0),(1731,278496007,1),(1731,294224408,0),(1731,309945608,1),(1731,325674009,0),(1731,341395209,1),(1731,357123609,0),(1731,372844810,1),(1731,388573210,0),(1731,404899211,1),(1731,420022811,0),(1731,436348812,1),(1731,452077212,0),(1731,467798412,1),(1731,483526812,0),(1731,499248013,1),(1731,514976413,0),(1731,530697613,1),(1731,544611613,0),(1731,562147213,1),(1731,576061214,0),(1731,594201614,1),(1731,607510814,0),(1731,625651214,1),(1731,638960415,0),(1731,657100815,1),(1731,671014816,0),(1731,688550416,1),(1731,702464416,0),(1731,720000017,1),(1731,733914017,0),(1731,752054418,1),(1731,765363618,0),(1731,783504019,1),(1731,796813219,0),(1731,814953619,1),(1731,828867620,0),(1731,846403220,1),(1731,860317220,0),(1731,877852821,1),(1731,891766821,0),(1731,909302421,1),(1731,923216422,0),(1731,941356822,1),(1731,954666022,0),(1731,972806422,1),(1731,986115622,0),(1731,1004256022,1),(1731,1018170022,0),(1731,1035705622,1),(1731,1049619622,0),(1731,1067155222,1),(1731,1081069222,0),(1731,1099209622,1),(1731,1112518822,0),(1731,1130659222,1),(1731,1143968423,0),(1731,1162108823,1),(1731,1173603623,0),(1731,1194163223,1),(1731,1205053223,0),(1731,1225612823,1),(1731,1236502824,0),(1731,1257062424,1),(1731,1268557224,0),(1731,1289116824,1),(1731,1300006824,0),(1731,1320566424,1),(1731,1331456424,0),(1731,1352016025,1),(1731,1362906025,0),(1731,1383465625,1),(1731,1394355625,0),(1731,1414915225,1),(1731,1425805225,0),(1731,1446364826,1),(1731,1457859626,0),(1731,1478419226,1),(1731,1489309227,0),(1731,1509868827,1),(1731,1520758827,0),(1731,1541318427,1),(1731,1552208427,0),(1731,1572768027,1),(1731,1583658027,0),(1731,1604217627,1),(1731,1615712427,0),(1731,1636272027,1),(1731,1647162027,0),(1731,1667721627,1),(1731,1678611627,0),(1731,1699171227,1),(1731,1710061227,0),(1731,1730620827,1),(1731,1741510827,0),(1731,1762070427,1),(1731,1772960427,0),(1731,1793520027,1),(1731,1805014827,0),(1731,1825574427,1),(1731,1836464427,0),(1731,1857024027,1),(1731,1867914027,0),(1731,1888473627,1),(1731,1899363627,0),(1731,1919923227,1),(1731,1930813227,0),(1731,1951372827,1),(1731,1962867627,0),(1731,1983427227,1),(1731,1994317227,0),(1731,2014876827,1),(1731,2025766827,0),(1731,2046326427,1),(1731,2057216427,0),(1731,2077776027,1),(1731,2088666027,0),(1731,2109225627,1),(1731,2120115627,0),(1731,2140675227,1),(1732,-2147483648,0),(1732,-1514736000,1),(1732,-1451667600,2),(1732,-1343062800,1),(1732,-1234803600,2),(1732,-1222963200,3),(1732,-1207242000,2),(1732,-873820800,4),(1732,-769395600,5),(1732,-761677200,2),(1732,-686073600,3),(1732,-661539600,2),(1732,-495039600,3),(1732,-481734000,2),(1732,-463590000,3),(1732,-450284400,2),(1732,-431535600,3),(1732,-418230000,2),(1732,-400086000,3),(1732,-386780400,2),(1732,-368636400,3),(1732,-355330800,2),(1732,-337186800,3),(1732,-323881200,2),(1732,-305737200,3),(1732,-292431600,2),(1732,199274405,3),(1732,215600405,2),(1732,230724006,3),(1732,247050006,2),(1732,262778407,3),(1732,278499607,2),(1732,294228008,3),(1732,309949208,2),(1732,325677609,3),(1732,341398809,2),(1732,357127209,3),(1732,372848410,2),(1732,388576810,3),(1732,404902811,2),(1732,420026411,3),(1732,436352412,2),(1732,452080812,3),(1732,467802012,2),(1732,483530412,3),(1732,499251613,2),(1732,514980013,3),(1732,530701213,2),(1732,544615213,3),(1732,562150813,2),(1732,576064814,3),(1732,594205214,2),(1732,607514414,3),(1732,625654814,2),(1732,638964015,3),(1732,657104415,2),(1732,671018416,3),(1732,688554016,2),(1732,702468016,3),(1732,720003617,2),(1732,733917617,3),(1732,752058018,2),(1732,765367218,3),(1732,783507619,2),(1732,796816819,3),(1732,814957219,2),(1732,828871220,3),(1732,846406820,2),(1732,860320820,3),(1732,877856421,2),(1732,891770421,3),(1732,909306021,2),(1732,923220022,3),(1732,941360422,2),(1732,954669622,3),(1732,972810022,2),(1732,986119222,3),(1732,1004259622,2),(1732,1018173622,3),(1732,1035709222,2),(1732,1049623222,3),(1732,1067158822,2),(1732,1081072822,3),(1732,1099213222,2),(1732,1112522422,3),(1732,1130662822,2),(1732,1143972023,3),(1732,1162112423,2),(1732,1175421623,3),(1732,1193562023,2),(1732,1207476023,3),(1732,1225011623,2),(1732,1238925624,3),(1732,1256461224,2),(1732,1268560824,3),(1732,1289120424,2),(1732,1300010424,3),(1732,1320570024,2),(1732,1331460024,3),(1732,1352019625,2),(1732,1362909625,3),(1732,1383469225,2),(1732,1394359225,3),(1732,1414918825,2),(1732,1425808825,3),(1732,1446368426,2),(1732,1457863226,3),(1732,1478422826,2),(1732,1489312827,3),(1732,1509872427,2),(1732,1520762427,3),(1732,1541322027,2),(1732,1552212027,3),(1732,1572771627,2),(1732,1583661627,3),(1732,1604221227,2),(1732,1615716027,3),(1732,1636275627,2),(1732,1647165627,3),(1732,1667725227,2),(1732,1678615227,3),(1732,1699174827,2),(1732,1710064827,3),(1732,1730624427,2),(1732,1741514427,3),(1732,1762074027,2),(1732,1772964027,3),(1732,1793523627,2),(1732,1805018427,3),(1732,1825578027,2),(1732,1836468027,3),(1732,1857027627,2),(1732,1867917627,3),(1732,1888477227,2),(1732,1899367227,3),(1732,1919926827,2),(1732,1930816827,3),(1732,1951376427,2),(1732,1962871227,3),(1732,1983430827,2),(1732,1994320827,3),(1732,2014880427,2),(1732,2025770427,3),(1732,2046330027,2),(1732,2057220027,3),(1732,2077779627,2),(1732,2088669627,3),(1732,2109229227,2),(1732,2120119227,3),(1732,2140678827,2),(1733,-2147483648,0),(1733,-1514739600,1),(1733,-1343066400,2),(1733,-1234807200,1),(1733,-1220292000,2),(1733,-1207159200,1),(1733,-1191344400,2),(1733,-873828000,1),(1733,-661539600,3),(1733,28800,1),(1733,828867620,4),(1733,846403220,1),(1733,860317220,4),(1733,877852821,1),(1733,891766821,4),(1733,909302421,1),(1733,923216422,4),(1733,941356822,1),(1733,954666022,4),(1733,972806422,1),(1733,989139622,4),(1733,1001836822,1),(1733,1018170022,4),(1733,1035705622,1),(1733,1049619622,4),(1733,1067155222,1),(1733,1081069222,4),(1733,1099209622,1),(1733,1112518822,4),(1733,1130659222,1),(1733,1143968423,4),(1733,1162108823,1),(1733,1175418023,4),(1733,1193558423,1),(1733,1207472423,4),(1733,1225008023,1),(1733,1238922024,4),(1733,1256457624,1),(1733,1270371624,4),(1733,1288512024,1),(1733,1301821224,4),(1733,1319961624,1),(1733,1333270824,4),(1733,1351411225,1),(1733,1365325225,4),(1733,1382860825,1),(1733,1396774825,4),(1733,1414310425,1),(1733,1428224425,4),(1733,1445760026,1),(1733,1459674026,4),(1733,1477814426,1),(1733,1491123627,4),(1733,1509264027,1),(1733,1522573227,4),(1733,1540713627,1),(1733,1554627627,4),(1733,1572163227,1),(1733,1586077227,4),(1733,1603612827,1),(1733,1617526827,4),(1733,1635667227,1),(1733,1648976427,4),(1733,1667116827,1),(1733,1680426027,4),(1733,1698566427,1),(1733,1712480427,4),(1733,1730016027,1),(1733,1743930027,4),(1733,1761465627,1),(1733,1775379627,4),(1733,1792915227,1),(1733,1806829227,4),(1733,1824969627,1),(1733,1838278827,4),(1733,1856419227,1),(1733,1869728427,4),(1733,1887868827,1),(1733,1901782827,4),(1733,1919318427,1),(1733,1933232427,4),(1733,1950768027,1),(1733,1964682027,4),(1733,1982822427,1),(1733,1996131627,4),(1733,2014272027,1),(1733,2027581227,4),(1733,2045721627,1),(1733,2059030827,4),(1733,2077171227,1),(1733,2091085227,4),(1733,2108620827,1),(1733,2122534827,4),(1733,2140070427,1),(1734,-2147483648,0),(1734,-1514739600,1),(1734,-1343066400,2),(1734,-1234807200,1),(1734,-1220292000,2),(1734,-1207159200,1),(1734,-1191344400,2),(1734,-975261600,3),(1734,-963169200,2),(1734,-917114400,3),(1734,-907354800,2),(1734,-821901600,4),(1734,-810068400,2),(1734,-627501600,3),(1734,-612990000,2),(1734,828864020,3),(1734,846399620,2),(1734,860313620,3),(1734,877849221,2),(1734,891763221,3),(1734,909298821,2),(1734,923212822,3),(1734,941353222,2),(1734,954662422,3),(1734,972802822,2),(1734,989136022,3),(1734,1001833222,2),(1734,1018166422,3),(1734,1035702022,2),(1734,1049616022,3),(1734,1067151622,2),(1734,1081065622,3),(1734,1099206022,2),(1734,1112515222,3),(1734,1130655622,2),(1734,1143964823,3),(1734,1162105223,2),(1734,1175414423,3),(1734,1193554823,2),(1734,1207468823,3),(1734,1225004423,2),(1734,1238918424,3),(1734,1256454024,2),(1734,1270368024,3),(1734,1288508424,2),(1734,1301817624,3),(1734,1319958024,2),(1734,1333267224,3),(1734,1351407625,2),(1734,1365321625,3),(1734,1382857225,2),(1734,1396771225,3),(1734,1414306825,2),(1734,1428220825,3),(1734,1445756426,2),(1734,1459670426,3),(1734,1477810826,2),(1734,1491120027,3),(1734,1509260427,2),(1734,1522569627,3),(1734,1540710027,2),(1734,1554624027,3),(1734,1572159627,2),(1734,1586073627,3),(1734,1603609227,2),(1734,1617523227,3),(1734,1635663627,2),(1734,1648972827,3),(1734,1667113227,2),(1734,1680422427,3),(1734,1698562827,2),(1734,1712476827,3),(1734,1730012427,2),(1734,1743926427,3),(1734,1761462027,2),(1734,1775376027,3),(1734,1792911627,2),(1734,1806825627,3),(1734,1824966027,2),(1734,1838275227,3),(1734,1856415627,2),(1734,1869724827,3),(1734,1887865227,2),(1734,1901779227,3),(1734,1919314827,2),(1734,1933228827,3),(1734,1950764427,2),(1734,1964678427,3),(1734,1982818827,2),(1734,1996128027,3),(1734,2014268427,2),(1734,2027577627,3),(1734,2045718027,2),(1734,2059027227,3),(1734,2077167627,2),(1734,2091081627,3),(1734,2108617227,2),(1734,2122531227,3),(1734,2140066827,2),(1735,-2147483648,2),(1735,-1330335000,1),(1735,-1320057000,2),(1735,-1300699800,3),(1735,-1287396000,2),(1735,-1269250200,3),(1735,-1255946400,2),(1735,-1237800600,3),(1735,-1224496800,2),(1735,-1206351000,3),(1735,-1192442400,2),(1735,-1174901400,3),(1735,-1160992800,2),(1735,-1143451800,3),(1735,-1125914400,2),(1735,-1112607000,3),(1735,-1094464800,2),(1735,-1081157400,3),(1735,-1063015200,2),(1735,-1049707800,3),(1735,-1031565600,2),(1735,-1018258200,3),(1735,-1000116000,2),(1735,-986808600,3),(1735,-968061600,2),(1735,-955359000,3),(1735,-936612000,2),(1735,-923304600,3),(1735,-757425600,6),(1735,152632803,4),(1735,162309604,5),(1735,183477604,4),(1735,194968805,5),(1735,215532005,4),(1735,226418406,5),(1735,246981606,4),(1735,257868007,5),(1735,278431207,4),(1735,289317608,5),(1735,309880808,4),(1735,320767209,5),(1735,341330409,4),(1735,352216809,5),(1735,372780010,4),(1735,384271210,5),(1735,404834411,4),(1735,415720811,5),(1735,436284012,4),(1735,447170412,5),(1735,467733612,4),(1735,478620012,5),(1735,499183213,4),(1735,510069613,5),(1735,530632813,4),(1735,541519213,5),(1735,562082413,4),(1735,573573614,5),(1735,594136814,4),(1735,605023214,5),(1735,623772014,4),(1735,637682415,5),(1735,655221615,4),(1735,669132016,5),(1735,686671216,4),(1735,700581616,5),(1735,718120817,4),(1735,732636017,5),(1735,749570418,4),(1735,764085618,5),(1735,781020019,4),(1735,795535219,5),(1735,812469619,4),(1735,826984820,5),(1735,844524020,4),(1735,858434420,5),(1735,875973621,4),(1735,889884021,5),(1735,907423221,4),(1735,921938422,5),(1735,938872822,4),(1735,953388022,5),(1735,970322422,4),(1735,984837622,5),(1735,1002376822,4),(1735,1016287222,5),(1735,1033826422,4),(1735,1047736822,5),(1735,1065276022,4),(1735,1079791222,5),(1735,1096725622,4),(1735,1111240822,5),(1735,1128175222,4),(1735,1142690423,5),(1735,1159624823,4),(1735,1174140023,5),(1735,1191074423,4),(1735,1207404023,5),(1735,1222524023,4),(1735,1238853624,5),(1735,1253973624,4),(1735,1270303224,5),(1735,1285423224,4),(1735,1301752824,5),(1735,1316872824,4),(1735,1333202424,5),(1735,1348927225,4),(1735,1365256825,5),(1735,1380376825,4),(1735,1396706425,5),(1735,1411826425,4),(1735,1428156025,5),(1735,1443276026,4),(1735,1459605626,5),(1735,1474725626,4),(1735,1491055227,5),(1735,1506175227,4),(1735,1522504827,5),(1735,1538229627,4),(1735,1554559227,5),(1735,1569679227,4),(1735,1586008827,5),(1735,1601128827,4),(1735,1617458427,5),(1735,1632578427,4),(1735,1648908027,5),(1735,1664028027,4),(1735,1680357627,5),(1735,1695477627,4),(1735,1712412027,5),(1735,1727532027,4),(1735,1743861627,5),(1735,1758981627,4),(1735,1775311227,5),(1735,1790431227,4),(1735,1806760827,5),(1735,1821880827,4),(1735,1838210427,5),(1735,1853330427,4),(1735,1869660027,5),(1735,1885384827,4),(1735,1901714427,5),(1735,1916834427,4),(1735,1933164027,5),(1735,1948284027,4),(1735,1964613627,5),(1735,1979733627,4),(1735,1996063227,5),(1735,2011183227,4),(1735,2027512827,5),(1735,2042632827,4),(1735,2058962427,5),(1735,2074687227,4),(1735,2091016827,5),(1735,2106136827,4),(1735,2122466427,5),(1735,2137586427,4),(1736,-2147483648,1),(1736,-757426500,4),(1736,152632803,2),(1736,162309604,3),(1736,183477604,2),(1736,194968805,3),(1736,215532005,2),(1736,226418406,3),(1736,246981606,2),(1736,257868007,3),(1736,278431207,2),(1736,289317608,3),(1736,309880808,2),(1736,320767209,3),(1736,341330409,2),(1736,352216809,3),(1736,372780010,2),(1736,384271210,3),(1736,404834411,2),(1736,415720811,3),(1736,436284012,2),(1736,447170412,3),(1736,467733612,2),(1736,478620012,3),(1736,499183213,2),(1736,510069613,3),(1736,530632813,2),(1736,541519213,3),(1736,562082413,2),(1736,573573614,3),(1736,594136814,2),(1736,605023214,3),(1736,623772014,2),(1736,637682415,3),(1736,655221615,2),(1736,669132016,3),(1736,686671216,2),(1736,700581616,3),(1736,718120817,2),(1736,732636017,3),(1736,749570418,2),(1736,764085618,3),(1736,781020019,2),(1736,795535219,3),(1736,812469619,2),(1736,826984820,3),(1736,844524020,2),(1736,858434420,3),(1736,875973621,2),(1736,889884021,3),(1736,907423221,2),(1736,921938422,3),(1736,938872822,2),(1736,953388022,3),(1736,970322422,2),(1736,984837622,3),(1736,1002376822,2),(1736,1016287222,3),(1736,1033826422,2),(1736,1047736822,3),(1736,1065276022,2),(1736,1079791222,3),(1736,1096725622,2),(1736,1111240822,3),(1736,1128175222,2),(1736,1142690423,3),(1736,1159624823,2),(1736,1174140023,3),(1736,1191074423,2),(1736,1207404023,3),(1736,1222524023,2),(1736,1238853624,3),(1736,1253973624,2),(1736,1270303224,3),(1736,1285423224,2),(1736,1301752824,3),(1736,1316872824,2),(1736,1333202424,3),(1736,1348927225,2),(1736,1365256825,3),(1736,1380376825,2),(1736,1396706425,3),(1736,1411826425,2),(1736,1428156025,3),(1736,1443276026,2),(1736,1459605626,3),(1736,1474725626,2),(1736,1491055227,3),(1736,1506175227,2),(1736,1522504827,3),(1736,1538229627,2),(1736,1554559227,3),(1736,1569679227,2),(1736,1586008827,3),(1736,1601128827,2),(1736,1617458427,3),(1736,1632578427,2),(1736,1648908027,3),(1736,1664028027,2),(1736,1680357627,3),(1736,1695477627,2),(1736,1712412027,3),(1736,1727532027,2),(1736,1743861627,3),(1736,1758981627,2),(1736,1775311227,3),(1736,1790431227,2),(1736,1806760827,3),(1736,1821880827,2),(1736,1838210427,3),(1736,1853330427,2),(1736,1869660027,3),(1736,1885384827,2),(1736,1901714427,3),(1736,1916834427,2),(1736,1933164027,3),(1736,1948284027,2),(1736,1964613627,3),(1736,1979733627,2),(1736,1996063227,3),(1736,2011183227,2),(1736,2027512827,3),(1736,2042632827,2),(1736,2058962427,3),(1736,2074687227,2),(1736,2091016827,3),(1736,2106136827,2),(1736,2122466427,3),(1736,2137586427,2),(1737,-2147483648,2),(1737,-1633273200,1),(1737,-1615132800,2),(1737,-1601823600,1),(1737,-1583683200,2),(1737,-1570374000,1),(1737,-1551628800,2),(1737,-1538924400,1),(1737,-1534089600,2),(1737,-880210800,3),(1737,-769395600,4),(1737,-765388800,2),(1737,-147884400,1),(1737,-131558400,2),(1737,-116434800,1),(1737,-100108800,2),(1737,-84380400,1),(1737,-68659200,2),(1737,-52930800,1),(1737,-37209600,2),(1737,-21481200,1),(1737,-5760000,2),(1737,9968400,1),(1737,25689600,2),(1737,41418000,1),(1737,57744000,2),(1737,73472400,1),(1737,89193601,2),(1737,104922002,1),(1737,120643202,2),(1737,126694803,1),(1737,152092803,2),(1737,162378004,1),(1737,183542404,2),(1737,199270805,1),(1737,215596805,2),(1737,230720406,1),(1737,247046406,2),(1737,262774807,1),(1737,278496007,2),(1737,294224408,1),(1737,309945608,2),(1737,325674009,1),(1737,341395209,2),(1737,357123609,1),(1737,372844810,2),(1737,388573210,1),(1737,404899211,2),(1737,420022811,1),(1737,436348812,2),(1737,452077212,1),(1737,467798412,2),(1737,483526812,1),(1737,499248013,2),(1737,514976413,1),(1737,530697613,2),(1737,544611613,1),(1737,562147213,2),(1737,576061214,1),(1737,594201614,2),(1737,607510814,1),(1737,625651214,2),(1737,638960415,1),(1737,657100815,2),(1737,671014816,1),(1737,688550416,2),(1737,702464416,1),(1737,720000017,2),(1737,733914017,1),(1737,752054418,2),(1737,765363618,1),(1737,783504019,2),(1737,796813219,1),(1737,814953619,2),(1737,828867620,1),(1737,846403220,2),(1737,860317220,1),(1737,877852821,2),(1737,891766821,1),(1737,909302421,2),(1737,923216422,1),(1737,941356822,2),(1737,954666022,1),(1737,972806422,2),(1737,986115622,1),(1737,1004256022,2),(1737,1018170022,1),(1737,1035705622,2),(1737,1049619622,1),(1737,1067155222,2),(1737,1081069222,1),(1737,1099209622,2),(1737,1112518822,1),(1737,1130659222,2),(1737,1143968423,1),(1737,1162108823,2),(1737,1173603623,1),(1737,1194163223,2),(1737,1205053223,1),(1737,1225612823,2),(1737,1236502824,1),(1737,1257062424,2),(1737,1268557224,1),(1737,1289116824,2),(1737,1300006824,1),(1737,1320566424,2),(1737,1331456424,1),(1737,1352016025,2),(1737,1362906025,1),(1737,1383465625,2),(1737,1394355625,1),(1737,1414915225,2),(1737,1425805225,1),(1737,1446364826,2),(1737,1457859626,1),(1737,1478419226,2),(1737,1489309227,1),(1737,1509868827,2),(1737,1520758827,1),(1737,1541318427,2),(1737,1552208427,1),(1737,1572768027,2),(1737,1583658027,1),(1737,1604217627,2),(1737,1615712427,1),(1737,1636272027,2),(1737,1647162027,1),(1737,1667721627,2),(1737,1678611627,1),(1737,1699171227,2),(1737,1710061227,1),(1737,1730620827,2),(1737,1741510827,1),(1737,1762070427,2),(1737,1772960427,1),(1737,1793520027,2),(1737,1805014827,1),(1737,1825574427,2),(1737,1836464427,1),(1737,1857024027,2),(1737,1867914027,1),(1737,1888473627,2),(1737,1899363627,1),(1737,1919923227,2),(1737,1930813227,1),(1737,1951372827,2),(1737,1962867627,1),(1737,1983427227,2),(1737,1994317227,1),(1737,2014876827,2),(1737,2025766827,1),(1737,2046326427,2),(1737,2057216427,1),(1737,2077776027,2),(1737,2088666027,1),(1737,2109225627,2),(1737,2120115627,1),(1737,2140675227,2),(1738,-2147483648,2),(1738,-933667200,1),(1738,-922093200,2),(1738,-908870400,1),(1738,-888829200,2),(1738,-881049600,1),(1738,-767869200,2),(1738,-745833600,1),(1738,-733827600,2),(1738,-716889600,1),(1738,-699613200,2),(1738,-683884800,1),(1738,-670669200,2),(1738,-652348800,1),(1738,-650019600,2),(1738,515527213,1),(1738,527014813,2),(1738,545162413,1),(1738,558464413,2),(1738,577216814,1),(1738,589914014,2),(1738,608666414,1),(1738,621968414,2),(1738,640116015,1),(1738,653418015,2),(1738,671565616,1),(1738,684867616,2),(1739,-1633269600,0),(1739,-1615129200,1),(1739,-1601820000,0),(1739,-1583679600,1),(1739,-880207200,2),(1739,-769395600,3),(1739,-765385200,1),(1739,-84376800,0),(1739,-68655600,1),(1739,-52927200,0),(1739,-37206000,1),(1739,-21477600,0),(1739,-5756400,1),(1739,9972000,0),(1739,25693200,1),(1739,41421600,0),(1739,57747600,1),(1739,73476000,0),(1739,89197201,1),(1739,104925602,0),(1739,120646802,1),(1739,126698403,0),(1739,152096403,1),(1739,162381604,0),(1739,183546004,1),(1739,199274405,0),(1739,215600405,1),(1739,230724006,0),(1739,247050006,1),(1739,262778407,0),(1739,278499607,1),(1739,294228008,0),(1739,309949208,1),(1739,325677609,0),(1739,341398809,1),(1739,357127209,0),(1739,372848410,1),(1739,388576810,0),(1739,404902811,1),(1739,420026411,0),(1739,436352412,1),(1739,452080812,0),(1739,467802012,1),(1739,483530412,0),(1739,499251613,1),(1739,514980013,0),(1739,530701213,1),(1739,544615213,0),(1739,562150813,1),(1739,576064814,0),(1739,594205214,1),(1739,607514414,0),(1739,625654814,1),(1739,638964015,0),(1739,657104415,1),(1739,671018416,0),(1739,688554016,1),(1739,702468016,0),(1739,720003617,1),(1739,733917617,0),(1739,752058018,1),(1739,765367218,0),(1739,783507619,1),(1739,796816819,0),(1739,814957219,1),(1739,828871220,0),(1739,846406820,1),(1739,860320820,0),(1739,877856421,1),(1739,891770421,0),(1739,909306021,1),(1739,923220022,0),(1739,941360422,1),(1739,954669622,0),(1739,972810022,1),(1739,986119222,0),(1739,1004259622,1),(1739,1018173622,0),(1739,1035709222,1),(1739,1049623222,0),(1739,1067158822,1),(1739,1081072822,0),(1739,1099213222,1),(1739,1112522422,0),(1739,1130662822,1),(1739,1143972023,0),(1739,1162112423,1),(1739,1173607223,0),(1739,1194166823,1),(1739,1205056823,0),(1739,1225616423,1),(1739,1236506424,0),(1739,1257066024,1),(1739,1268560824,0),(1739,1289120424,1),(1739,1300010424,0),(1739,1320570024,1),(1739,1331460024,0),(1739,1352019625,1),(1739,1362909625,0),(1739,1383469225,1),(1739,1394359225,0),(1739,1414918825,1),(1739,1425808825,0),(1739,1446368426,1),(1739,1457863226,0),(1739,1478422826,1),(1739,1489312827,0),(1739,1509872427,1),(1739,1520762427,0),(1739,1541322027,1),(1739,1552212027,0),(1739,1572771627,1),(1739,1583661627,0),(1739,1604221227,1),(1739,1615716027,0),(1739,1636275627,1),(1739,1647165627,0),(1739,1667725227,1),(1739,1678615227,0),(1739,1699174827,1),(1739,1710064827,0),(1739,1730624427,1),(1739,1741514427,0),(1739,1762074027,1),(1739,1772964027,0),(1739,1793523627,1),(1739,1805018427,0),(1739,1825578027,1),(1739,1836468027,0),(1739,1857027627,1),(1739,1867917627,0),(1739,1888477227,1),(1739,1899367227,0),(1739,1919926827,1),(1739,1930816827,0),(1739,1951376427,1),(1739,1962871227,0),(1739,1983430827,1),(1739,1994320827,0),(1739,2014880427,1),(1739,2025770427,0),(1739,2046330027,1),(1739,2057220027,0),(1739,2077779627,1),(1739,2088669627,0),(1739,2109229227,1),(1739,2120119227,0),(1739,2140678827,1),(1740,-2147483648,1),(1740,-1861878784,2),(1740,-631110600,4),(1740,1285498824,3),(1740,1301752824,4),(1740,1316872824,3),(1740,1325239224,6),(1740,1333202424,5),(1740,1348927225,6),(1740,1365256825,5),(1740,1380376825,6),(1740,1396706425,5),(1740,1411826425,6),(1740,1428156025,5),(1740,1443276026,6),(1740,1459605626,5),(1740,1474725626,6),(1740,1491055227,5),(1740,1506175227,6),(1740,1522504827,5),(1740,1538229627,6),(1740,1554559227,5),(1740,1569679227,6),(1740,1586008827,5),(1740,1601128827,6),(1740,1617458427,5),(1740,1632578427,6),(1740,1648908027,5),(1740,1664028027,6),(1740,1680357627,5),(1740,1695477627,6),(1740,1712412027,5),(1740,1727532027,6),(1740,1743861627,5),(1740,1758981627,6),(1740,1775311227,5),(1740,1790431227,6),(1740,1806760827,5),(1740,1821880827,6),(1740,1838210427,5),(1740,1853330427,6),(1740,1869660027,5),(1740,1885384827,6),(1740,1901714427,5),(1740,1916834427,6),(1740,1933164027,5),(1740,1948284027,6),(1740,1964613627,5),(1740,1979733627,6),(1740,1996063227,5),(1740,2011183227,6),(1740,2027512827,5),(1740,2042632827,6),(1740,2058962427,5),(1740,2074687227,6),(1740,2091016827,5),(1740,2106136827,6),(1740,2122466427,5),(1740,2137586427,6),(1741,-2147483648,2),(1741,-1330335000,1),(1741,-1320057000,2),(1741,-1300699800,3),(1741,-1287396000,2),(1741,-1269250200,3),(1741,-1255946400,2),(1741,-1237800600,3),(1741,-1224496800,2),(1741,-1206351000,3),(1741,-1192442400,2),(1741,-1174901400,3),(1741,-1160992800,2),(1741,-1143451800,3),(1741,-1125914400,2),(1741,-1112607000,3),(1741,-1094464800,2),(1741,-1081157400,3),(1741,-1063015200,2),(1741,-1049707800,3),(1741,-1031565600,2),(1741,-1018258200,3),(1741,-1000116000,2),(1741,-986808600,3),(1741,-968061600,2),(1741,-955359000,3),(1741,-936612000,2),(1741,-923304600,3),(1741,-757425600,6),(1741,152632803,4),(1741,162309604,5),(1741,183477604,4),(1741,194968805,5),(1741,215532005,4),(1741,226418406,5),(1741,246981606,4),(1741,257868007,5),(1741,278431207,4),(1741,289317608,5),(1741,309880808,4),(1741,320767209,5),(1741,341330409,4),(1741,352216809,5),(1741,372780010,4),(1741,384271210,5),(1741,404834411,4),(1741,415720811,5),(1741,436284012,4),(1741,447170412,5),(1741,467733612,4),(1741,478620012,5),(1741,499183213,4),(1741,510069613,5),(1741,530632813,4),(1741,541519213,5),(1741,562082413,4),(1741,573573614,5),(1741,594136814,4),(1741,605023214,5),(1741,623772014,4),(1741,637682415,5),(1741,655221615,4),(1741,669132016,5),(1741,686671216,4),(1741,700581616,5),(1741,718120817,4),(1741,732636017,5),(1741,749570418,4),(1741,764085618,5),(1741,781020019,4),(1741,795535219,5),(1741,812469619,4),(1741,826984820,5),(1741,844524020,4),(1741,858434420,5),(1741,875973621,4),(1741,889884021,5),(1741,907423221,4),(1741,921938422,5),(1741,938872822,4),(1741,953388022,5),(1741,970322422,4),(1741,984837622,5),(1741,1002376822,4),(1741,1016287222,5),(1741,1033826422,4),(1741,1047736822,5),(1741,1065276022,4),(1741,1079791222,5),(1741,1096725622,4),(1741,1111240822,5),(1741,1128175222,4),(1741,1142690423,5),(1741,1159624823,4),(1741,1174140023,5),(1741,1191074423,4),(1741,1207404023,5),(1741,1222524023,4),(1741,1238853624,5),(1741,1253973624,4),(1741,1270303224,5),(1741,1285423224,4),(1741,1301752824,5),(1741,1316872824,4),(1741,1333202424,5),(1741,1348927225,4),(1741,1365256825,5),(1741,1380376825,4),(1741,1396706425,5),(1741,1411826425,4),(1741,1428156025,5),(1741,1443276026,4),(1741,1459605626,5),(1741,1474725626,4),(1741,1491055227,5),(1741,1506175227,4),(1741,1522504827,5),(1741,1538229627,4),(1741,1554559227,5),(1741,1569679227,4),(1741,1586008827,5),(1741,1601128827,4),(1741,1617458427,5),(1741,1632578427,4),(1741,1648908027,5),(1741,1664028027,4),(1741,1680357627,5),(1741,1695477627,4),(1741,1712412027,5),(1741,1727532027,4),(1741,1743861627,5),(1741,1758981627,4),(1741,1775311227,5),(1741,1790431227,4),(1741,1806760827,5),(1741,1821880827,4),(1741,1838210427,5),(1741,1853330427,4),(1741,1869660027,5),(1741,1885384827,4),(1741,1901714427,5),(1741,1916834427,4),(1741,1933164027,5),(1741,1948284027,4),(1741,1964613627,5),(1741,1979733627,4),(1741,1996063227,5),(1741,2011183227,4),(1741,2027512827,5),(1741,2042632827,4),(1741,2058962427,5),(1741,2074687227,4),(1741,2091016827,5),(1741,2106136827,4),(1741,2122466427,5),(1741,2137586427,4),(1742,-2147483648,1),(1742,-868010400,2),(1742,-768906000,1),(1742,1419696025,3),(1743,-2147483648,1),(1743,-757426500,4),(1743,152632803,2),(1743,162309604,3),(1743,183477604,2),(1743,194968805,3),(1743,215532005,2),(1743,226418406,3),(1743,246981606,2),(1743,257868007,3),(1743,278431207,2),(1743,289317608,3),(1743,309880808,2),(1743,320767209,3),(1743,341330409,2),(1743,352216809,3),(1743,372780010,2),(1743,384271210,3),(1743,404834411,2),(1743,415720811,3),(1743,436284012,2),(1743,447170412,3),(1743,467733612,2),(1743,478620012,3),(1743,499183213,2),(1743,510069613,3),(1743,530632813,2),(1743,541519213,3),(1743,562082413,2),(1743,573573614,3),(1743,594136814,2),(1743,605023214,3),(1743,623772014,2),(1743,637682415,3),(1743,655221615,2),(1743,669132016,3),(1743,686671216,2),(1743,700581616,3),(1743,718120817,2),(1743,732636017,3),(1743,749570418,2),(1743,764085618,3),(1743,781020019,2),(1743,795535219,3),(1743,812469619,2),(1743,826984820,3),(1743,844524020,2),(1743,858434420,3),(1743,875973621,2),(1743,889884021,3),(1743,907423221,2),(1743,921938422,3),(1743,938872822,2),(1743,953388022,3),(1743,970322422,2),(1743,984837622,3),(1743,1002376822,2),(1743,1016287222,3),(1743,1033826422,2),(1743,1047736822,3),(1743,1065276022,2),(1743,1079791222,3),(1743,1096725622,2),(1743,1111240822,3),(1743,1128175222,2),(1743,1142690423,3),(1743,1159624823,2),(1743,1174140023,3),(1743,1191074423,2),(1743,1207404023,3),(1743,1222524023,2),(1743,1238853624,3),(1743,1253973624,2),(1743,1270303224,3),(1743,1285423224,2),(1743,1301752824,3),(1743,1316872824,2),(1743,1333202424,3),(1743,1348927225,2),(1743,1365256825,3),(1743,1380376825,2),(1743,1396706425,3),(1743,1411826425,2),(1743,1428156025,3),(1743,1443276026,2),(1743,1459605626,3),(1743,1474725626,2),(1743,1491055227,3),(1743,1506175227,2),(1743,1522504827,3),(1743,1538229627,2),(1743,1554559227,3),(1743,1569679227,2),(1743,1586008827,3),(1743,1601128827,2),(1743,1617458427,3),(1743,1632578427,2),(1743,1648908027,3),(1743,1664028027,2),(1743,1680357627,3),(1743,1695477627,2),(1743,1712412027,3),(1743,1727532027,2),(1743,1743861627,3),(1743,1758981627,2),(1743,1775311227,3),(1743,1790431227,2),(1743,1806760827,3),(1743,1821880827,2),(1743,1838210427,3),(1743,1853330427,2),(1743,1869660027,3),(1743,1885384827,2),(1743,1901714427,3),(1743,1916834427,2),(1743,1933164027,3),(1743,1948284027,2),(1743,1964613627,3),(1743,1979733627,2),(1743,1996063227,3),(1743,2011183227,2),(1743,2027512827,3),(1743,2042632827,2),(1743,2058962427,3),(1743,2074687227,2),(1743,2091016827,3),(1743,2106136827,2),(1743,2122466427,3),(1743,2137586427,2),(1744,-2147483648,1),(1744,-1743674400,2),(1744,-1606813200,1),(1744,-907408800,2),(1744,-770634000,1),(1745,-2147483648,1),(1745,-1178124152,4),(1745,-36619200,2),(1745,-23922000,3),(1745,-3355200,2),(1745,7527600,3),(1745,24465600,2),(1745,37767600,3),(1745,55915200,2),(1745,69217200,3),(1745,87969601,2),(1745,100666802,3),(1745,118209602,2),(1745,132116403,3),(1745,150868803,2),(1745,163566004,3),(1745,182318404,2),(1745,195620405,3),(1745,213768005,2),(1745,227070006,3),(1745,245217606,2),(1745,258519607,3),(1745,277272007,2),(1745,289969208,3),(1745,308721608,2),(1745,321418809,3),(1745,340171209,2),(1745,353473209,3),(1745,371620810,2),(1745,384922810,5),(1745,403070411,6),(1745,416372411,5),(1745,434520012,6),(1745,447822012,5),(1745,466574412,6),(1745,479271612,5),(1745,498024013,6),(1745,510721213,5),(1745,529473613,6),(1745,545194813,5),(1745,560923213,6),(1745,574225214,5),(1745,592372814,6),(1745,605674814,5),(1745,624427214,6),(1745,637124415,5),(1745,653457615,6),(1745,668574016,5),(1745,687326416,6),(1745,700628416,5),(1745,718776017,6),(1745,732078017,5),(1745,750225618,6),(1745,763527618,5),(1745,781675219,6),(1745,794977219,5),(1745,813729619,6),(1745,826426820,5),(1745,845179220,6),(1745,859690820,5),(1745,876628821,6),(1745,889930821,5),(1745,906868821,6),(1745,923194822,5),(1745,939528022,6),(1745,952830022,5),(1745,971582422,6),(1745,984279622,5),(1745,1003032022,6),(1745,1015729222,5),(1745,1034481622,6),(1745,1047178822,5),(1745,1065931222,6),(1745,1079233222,5),(1745,1097380822,6),(1745,1110682822,5),(1745,1128830422,6),(1745,1142132423,5),(1745,1160884823,6),(1745,1173582023,5),(1745,1192334423,6),(1745,1206846023,5),(1745,1223784023,6),(1745,1237086024,5),(1745,1255233624,6),(1745,1270350024,5),(1745,1286683224,6),(1745,1304823624,5),(1745,1313899224,6),(1745,1335668424,5),(1745,1346558425,6),(1745,1367118025,5),(1745,1378612825,6),(1745,1398567625,5),(1745,1410062425,6),(1745,1463281226,5),(1745,1471147226,6),(1745,1494730827,5),(1745,1502596827,6),(1745,1526180427,5),(1745,1534046427,6),(1745,1554606027,5),(1745,1567915227,6),(1745,1586055627,5),(1745,1599364827,6),(1745,1617505227,5),(1745,1630814427,6),(1745,1648954827,5),(1745,1662264027,6),(1745,1680404427,5),(1745,1693713627,6),(1745,1712458827,5),(1745,1725768027,6),(1745,1743908427,5),(1745,1757217627,6),(1745,1775358027,5),(1745,1788667227,6),(1745,1806807627,5),(1745,1820116827,6),(1745,1838257227,5),(1745,1851566427,6),(1745,1870311627,5),(1745,1883016027,6),(1745,1901761227,5),(1745,1915070427,6),(1745,1933210827,5),(1745,1946520027,6),(1745,1964660427,5),(1745,1977969627,6),(1745,1996110027,5),(1745,2009419227,6),(1745,2027559627,5),(1745,2040868827,6),(1745,2059614027,5),(1745,2072318427,6),(1745,2091063627,5),(1745,2104372827,6),(1745,2122513227,5),(1745,2135822427,6),(1746,-2147483648,0),(1746,-1829387596,2),(1746,433256412,1),(1746,448977612,2),(1746,467298012,1),(1746,480427212,2),(1746,496760413,1),(1746,511876813,2),(1746,528210013,1),(1746,543931213,2),(1746,559659613,1),(1746,575380814,2),(1746,591109214,1),(1746,606830414,2),(1746,622558814,1),(1746,638280015,2),(1746,654008415,1),(1746,669729616,2),(1746,686062816,1),(1746,696340816,2),(1746,719931617,1),(1746,727790417,2),(1747,-2147483648,1),(1747,307627208,2),(1747,788871619,3),(1748,-2147483648,1),(1748,1325242824,2),(1749,-2147483648,0),(1749,-1709985344,2),(1749,909842421,1),(1749,920124022,2),(1749,941896822,1),(1749,951573622,2),(1749,1259416824,1),(1749,1269698424,2),(1749,1287842424,1),(1749,1299333624,2),(1749,1319292024,1),(1749,1327154424,2),(1749,1350741625,1),(1749,1358604025,2),(1749,1382796025,1),(1749,1390050025,2),(1749,1414850425,1),(1749,1421503225,2),(1749,1446300026,1),(1749,1452952826,2),(1749,1478354426,1),(1749,1484402427,2),(1749,1509804027,1),(1749,1515852027,2),(1749,1541253627,1),(1749,1547301627,2),(1749,1572703227,1),(1749,1579356027,2),(1749,1604152827,1),(1749,1610805627,2),(1749,1636207227,1),(1749,1642255227,2),(1749,1667656827,1),(1749,1673704827,2),(1749,1699106427,1),(1749,1705154427,2),(1749,1730556027,1),(1749,1737208827,2),(1749,1762005627,1),(1749,1768658427,2),(1749,1793455227,1),(1749,1800108027,2),(1749,1825509627,1),(1749,1831557627,2),(1749,1856959227,1),(1749,1863007227,2),(1749,1888408827,1),(1749,1894456827,2),(1749,1919858427,1),(1749,1926511227,2),(1749,1951308027,1),(1749,1957960827,2),(1749,1983362427,1),(1749,1989410427,2),(1749,2014812027,1),(1749,2020860027,2),(1749,2046261627,1),(1749,2052309627,2),(1749,2077711227,1),(1749,2083759227,2),(1749,2109160827,1),(1749,2115813627,2),(1749,2140610427,1),(1749,2147263227,2),(1751,-2147483648,0),(1751,-1230746496,1),(1751,504939613,3),(1751,722930417,2),(1751,728888417,3),(1752,-2147483648,0),(1752,-1806678012,1),(1753,-2147483648,0),(1753,-1806748788,1),(1754,-2147483648,1),(1754,-885549600,2),(1754,-802256400,1),(1754,-331891200,3),(1754,-281610000,1),(1754,-73728000,3),(1754,-29415540,1),(1754,-16704000,3),(1754,-10659600,1),(1754,9907200,3),(1754,21394800,1),(1754,41356800,3),(1754,52844400,1),(1754,124819202,3),(1754,130863603,1),(1754,201888005,3),(1754,209487665,1),(1754,230659206,3),(1754,241542006,1),(1754,977493622,4),(1755,-2147483648,1),(1755,-1157283000,2),(1755,-1155436200,1),(1755,-880198200,3),(1755,-769395600,4),(1755,-765376200,1),(1755,-712150200,5),(1756,-2147483648,1),(1756,-1157283000,2),(1756,-1155436200,1),(1756,-880198200,3),(1756,-769395600,4),(1756,-765376200,1),(1756,-712150200,5),(1757,-2147483648,1),(1757,307622408,2),(1757,788868019,3),(1758,-2147483648,1),(1758,-1743678000,2),(1758,-1606813200,1),(1758,-1041418800,3),(1758,-907408800,2),(1758,-770634000,1),(1758,-7988400,4),(1758,915105621,1),(1759,-2147483648,1),(1759,-1041418800,2),(1759,-907408800,3),(1759,-817462800,1),(1759,-7988400,4),(1759,745934418,5),(1760,-2147483648,1),(1760,-1743678000,2),(1760,-1606813200,1),(1760,-1041418800,3),(1760,-907408800,2),(1760,-818067600,1),(1760,-7988400,4),(1761,-2147483648,0),(1761,-1806676920,1),(1762,-2147483648,1),(1762,-1861879032,2),(1763,-2147483648,0),(1763,-1545131260,1),(1763,-862918200,2),(1763,-767350800,1),(1763,287418608,3),(1764,-2147483648,1),(1764,-599575200,2),(1764,276089407,3),(1765,-2147483648,1),(1765,-599656320,2),(1765,152029803,3),(1765,162912604,2),(1765,1443882626,4),(1766,-2147483648,0),(1766,-1829387148,2),(1766,250002006,1),(1766,257342407,2),(1766,281451607,1),(1766,288878408,2),(1766,849366020,3),(1766,857228420,4),(1767,-2147483648,1),(1767,-1861879032,2),(1769,-2147483648,1),(1769,893665821,2),(1770,-2147483648,1),(1770,-1743678000,2),(1770,-1606813200,1),(1770,-1041418800,3),(1770,-907408800,2),(1770,-770634000,1),(1771,-2147483648,1),(1771,-1743678000,2),(1771,-1606813200,1),(1771,-1041418800,3),(1771,-907408800,2),(1771,-770634000,1),(1773,-2147483648,1),(1773,279714607,3),(1773,289387808,2),(1773,309952808,3),(1773,320837409,2),(1773,341402409,3),(1773,352287009,2),(1773,372852010,3),(1773,384341410,2),(1773,404906411,3),(1773,415791011,2),(1773,436356012,3),(1773,447240612,2),(1773,467805612,3),(1773,478690212,2),(1773,499255213,3),(1773,510139813,2),(1773,530704813,3),(1773,541589413,2),(1773,562154413,3),(1773,573643814,2),(1773,594208814,3),(1773,605093414,2),(1773,625658414,3),(1773,636543015,2),(1773,657108015,3),(1773,667992616,2),(1774,-2147483648,1),(1774,-885549600,2),(1774,-802256400,1),(1774,-331891200,3),(1774,-281610000,1),(1774,-73728000,3),(1774,-29415540,1),(1774,-16704000,3),(1774,-10659600,1),(1774,9907200,3),(1774,21394800,1),(1774,41356800,3),(1774,52844400,1),(1774,124819202,3),(1774,130863603,1),(1774,201888005,3),(1774,209487665,1),(1774,230659206,3),(1774,241542006,1),(1774,977493622,4),(1775,-2147483648,1),(1775,-1861879032,2),(1776,-2147483648,0),(1776,-1806674504,1),(1778,-2147483648,1),(1778,-915193200,2),(1778,939214822,3),(1778,953384422,4),(1778,973342822,5),(1778,980596822,2),(1778,1004792422,5),(1778,1012046422,2),(1778,1478350826,5),(1778,1484398827,2),(1779,-2147483648,1),(1779,-1743674400,2),(1779,-1606813200,1),(1779,-907408800,2),(1779,-770634000,1),(1782,-2147483648,1),(1782,-1743674400,2),(1782,-1606813200,1),(1782,-907408800,2),(1782,-770634000,1),(1783,-2147483648,1),(1783,-1717032240,3),(1783,-1693706400,2),(1783,-1680483600,3),(1783,-1663455600,4),(1783,-1650150000,5),(1783,-1632006000,4),(1783,-1618700400,8),(1783,-1600473600,6),(1783,-1587168000,7),(1783,-1501725600,3),(1783,-931734000,2),(1783,-857257200,5),(1783,-844556400,4),(1783,-828226800,5),(1783,-812502000,4),(1783,-796874400,2),(1783,-796608000,3),(1783,-778726800,2),(1783,-762660000,3),(1783,-748486800,4),(1783,-733273200,5),(1783,-715215600,4),(1783,-701910000,5),(1783,-684975600,4),(1783,-670460400,5),(1783,-654130800,4),(1783,-639010800,5),(1783,-397094400,4),(1783,-386812800,5),(1783,-371088000,4),(1783,-355363200,5),(1783,-334195200,4),(1783,-323308800,5),(1783,-307584000,4),(1783,-291859200,5),(1783,-271296000,4),(1783,-260409600,5),(1783,-239846400,4),(1783,-228960000,5),(1783,-208396800,4),(1783,-197510400,5),(1783,-176342400,4),(1783,-166060800,5),(1783,220921205,3),(1783,228873606,4),(1783,243993606,5),(1783,260323207,4),(1783,276048007,5),(1783,291772808,4),(1783,307497608,5),(1783,323827209,4),(1783,338947209,5),(1783,354672009,4),(1783,370396810,5),(1783,386121610,4),(1783,401846411,5),(1783,417571211,4),(1783,433296012,5),(1783,449020812,4),(1783,465350412,5),(1783,481075212,4),(1783,496800013,5),(1783,512524813,4),(1783,528249613,5),(1783,543974413,4),(1783,559699213,5),(1783,567990013,3),(1783,575427614,9),(1783,591152414,10),(1783,606877214,9),(1783,622602014,10),(1783,638326815,9),(1783,654656415,10),(1783,670381216,9),(1783,686106016,10),(1783,701830816,9),(1783,717555617,10),(1783,733280417,9),(1783,749005218,10),(1783,764730018,9),(1783,780454819,10),(1783,796179619,9),(1783,811904419,10),(1783,828234020,9),(1783,846378020,10),(1783,859683620,9),(1783,877827621,10),(1783,891133221,9),(1783,909277221,10),(1783,922582822,9),(1783,941331622,10),(1783,954032422,9),(1783,972781222,10),(1783,985482022,9),(1783,1004230822,10),(1783,1017536422,9),(1783,1035680422,10),(1783,1048986022,9),(1783,1067130022,10),(1783,1080435622,9),(1783,1099184422,10),(1783,1111885222,9),(1783,1130634022,10),(1783,1143334823,9),(1783,1162083623,10),(1783,1174784423,9),(1783,1193533223,10),(1783,1206838823,9),(1783,1224982823,10),(1783,1238288424,9),(1783,1256432424,10),(1783,1269738024,9),(1783,1288486824,10),(1783,1301187624,9),(1783,1319936424,10),(1783,1332637224,9),(1783,1351386025,10),(1783,1364691625,9),(1783,1382835625,10),(1783,1396141225,9),(1783,1414285225,10),(1783,1427590825,9),(1783,1445734826,10),(1783,1459040426,9),(1783,1477789226,10),(1783,1490490027,9),(1783,1509238827,10),(1783,1521939627,9),(1783,1540688427,10),(1783,1553994027,9),(1783,1572138027,10),(1783,1585443627,9),(1783,1603587627,10),(1783,1616893227,9),(1783,1635642027,10),(1783,1648342827,9),(1783,1667091627,10),(1783,1679792427,9),(1783,1698541227,10),(1783,1711846827,9),(1783,1729990827,10),(1783,1743296427,9),(1783,1761440427,10),(1783,1774746027,9),(1783,1792890027,10),(1783,1806195627,9),(1783,1824944427,10),(1783,1837645227,9),(1783,1856394027,10),(1783,1869094827,9),(1783,1887843627,10),(1783,1901149227,9),(1783,1919293227,10),(1783,1932598827,9),(1783,1950742827,10),(1783,1964048427,9),(1783,1982797227,10),(1783,1995498027,9),(1783,2014246827,10),(1783,2026947627,9),(1783,2045696427,10),(1783,2058397227,9),(1783,2077146027,10),(1783,2090451627,9),(1783,2108595627,10),(1783,2121901227,9),(1783,2140045227,10),(1784,-2147483648,0),(1784,-1830384000,6),(1784,-1689555600,1),(1784,-1677801600,2),(1784,-1667437200,3),(1784,-1647738000,4),(1784,-1635814800,3),(1784,-1616202000,4),(1784,-1604365200,3),(1784,-1584666000,4),(1784,-1572742800,3),(1784,-1553043600,4),(1784,-1541206800,3),(1784,-1521507600,4),(1784,-1442451600,3),(1784,-1426813200,4),(1784,-1379293200,3),(1784,-1364778000,4),(1784,-1348448400,3),(1784,-1333328400,4),(1784,-1316394000,3),(1784,-1301274000,4),(1784,-1284339600,3),(1784,-1269824400,4),(1784,-1221440400,3),(1784,-1206925200,4),(1784,-1191200400,3),(1784,-1175475600,4),(1784,-1127696400,3),(1784,-1111971600,4),(1784,-1096851600,3),(1784,-1080522000,4),(1784,-1063587600,3),(1784,-1049072400,4),(1784,-1033347600,3),(1784,-1017622800,4),(1784,-1002502800,3),(1784,-986173200,4),(1784,-969238800,3),(1784,-950490000,4),(1784,-942022800,3),(1784,-922669200,4),(1784,-906944400,3),(1784,-891133200,4),(1784,-877309200,3),(1784,-873684000,5),(1784,-864007200,3),(1784,-857955600,4),(1784,-845859600,3),(1784,-842839200,5),(1784,-831348000,3),(1784,-825901200,4),(1784,-814410000,3),(1784,-810784800,5),(1784,-799898400,3),(1784,-794451600,4),(1784,-782960400,3),(1784,-779335200,5),(1784,-768448800,3),(1784,-763002000,4),(1784,-749091600,3),(1784,-733366800,4),(1784,-717631200,3),(1784,-701906400,4),(1784,-686181600,3),(1784,-670456800,4),(1784,-654732000,3),(1784,-639007200,4),(1784,-591832800,3),(1784,-575503200,4),(1784,-559778400,3),(1784,-544053600,4),(1784,-528328800,3),(1784,-512604000,4),(1784,-496879200,3),(1784,-481154400,4),(1784,-465429600,3),(1784,-449704800,4),(1784,-433980000,3),(1784,-417650400,4),(1784,-401925600,3),(1784,-386200800,4),(1784,-370476000,3),(1784,-354751200,4),(1784,-339026400,3),(1784,-323301600,4),(1784,-307576800,3),(1784,-291852000,4),(1784,-276127200,3),(1784,-260402400,4),(1784,-244677600,3),(1784,-228348000,4),(1784,-212623200,3),(1784,-196898400,4),(1784,-181173600,3),(1784,-165448800,4),(1784,-149724000,3),(1784,-133999200,4),(1784,-118274400,7),(1784,212544005,2),(1784,228268806,3),(1784,243993606,4),(1784,260323207,3),(1784,276048007,4),(1784,291772808,3),(1784,307501208,4),(1784,323222409,3),(1784,338950809,4),(1784,354675609,3),(1784,370400410,4),(1784,386125210,3),(1784,401850011,4),(1784,417578411,3),(1784,433299612,4),(1784,449024412,3),(1784,465354012,4),(1784,481078812,3),(1784,496803613,4),(1784,512528413,3),(1784,528253213,4),(1784,543978013,3),(1784,559702813,4),(1784,575427614,3),(1784,591152414,4),(1784,606877214,3),(1784,622602014,4),(1784,638326815,3),(1784,654656415,4),(1784,670381216,3),(1784,686106016,4),(1784,701830816,3),(1784,717555617,8),(1784,733280417,9),(1784,749005218,8),(1784,764730018,9),(1784,780454819,8),(1784,796179619,9),(1784,811904419,8),(1784,828234020,10),(1784,846378020,6),(1784,859683620,10),(1784,877827621,6),(1784,891133221,10),(1784,909277221,6),(1784,922582822,10),(1784,941331622,6),(1784,954032422,10),(1784,972781222,6),(1784,985482022,10),(1784,1004230822,6),(1784,1017536422,10),(1784,1035680422,6),(1784,1048986022,10),(1784,1067130022,6),(1784,1080435622,10),(1784,1099184422,6),(1784,1111885222,10),(1784,1130634022,6),(1784,1143334823,10),(1784,1162083623,6),(1784,1174784423,10),(1784,1193533223,6),(1784,1206838823,10),(1784,1224982823,6),(1784,1238288424,10),(1784,1256432424,6),(1784,1269738024,10),(1784,1288486824,6),(1784,1301187624,10),(1784,1319936424,6),(1784,1332637224,10),(1784,1351386025,6),(1784,1364691625,10),(1784,1382835625,6),(1784,1396141225,10),(1784,1414285225,6),(1784,1427590825,10),(1784,1445734826,6),(1784,1459040426,10),(1784,1477789226,6),(1784,1490490027,10),(1784,1509238827,6),(1784,1521939627,10),(1784,1540688427,6),(1784,1553994027,10),(1784,1572138027,6),(1784,1585443627,10),(1784,1603587627,6),(1784,1616893227,10),(1784,1635642027,6),(1784,1648342827,10),(1784,1667091627,6),(1784,1679792427,10),(1784,1698541227,6),(1784,1711846827,10),(1784,1729990827,6),(1784,1743296427,10),(1784,1761440427,6),(1784,1774746027,10),(1784,1792890027,6),(1784,1806195627,10),(1784,1824944427,6),(1784,1837645227,10),(1784,1856394027,6),(1784,1869094827,10),(1784,1887843627,6),(1784,1901149227,10),(1784,1919293227,6),(1784,1932598827,10),(1784,1950742827,6),(1784,1964048427,10),(1784,1982797227,6),(1784,1995498027,10),(1784,2014246827,6),(1784,2026947627,10),(1784,2045696427,6),(1784,2058397227,10),(1784,2077146027,6),(1784,2090451627,10),(1784,2108595627,6),(1784,2121901227,10),(1784,2140045227,6),(1785,-2147483648,1),(1785,-1017820800,2),(1785,-766224000,1),(1785,-745833600,3),(1785,-733827600,1),(1785,-716889600,3),(1785,-699613200,1),(1785,-683884800,3),(1785,-670669200,1),(1785,-652348800,3),(1785,-639133200,1),(1785,-620812800,3),(1785,-607597200,1),(1785,-589276800,3),(1785,-576061200,1),(1785,-562924800,3),(1785,-541760400,1),(1785,-528710400,3),(1785,-510224400,1),(1785,-497174400,3),(1785,-478688400,1),(1785,-465638400,3),(1785,-449830800,1),(1785,-434016000,3),(1785,-418208400,1),(1785,-402480000,3),(1785,-386672400,1),(1785,-370944000,3),(1785,-355136400,1),(1785,-339408000,3),(1785,-323600400,1),(1785,-302515200,3),(1785,-291978000,1),(1785,-270979200,3),(1785,-260442000,1),(1785,133977603,3),(1785,149785203,1),(1785,165513604,3),(1785,181321204,1),(1785,299606408,3),(1785,307551608,1),(1786,-2147483648,0),(1786,-1948782472,1),(1786,-1830414600,2),(1786,-767350800,3),(1786,-498128400,1),(1786,-462702600,4),(1786,-451733400,1),(1786,-429784200,4),(1786,-418296600,1),(1786,-399544200,4),(1786,-387451800,1),(1786,-368094600,4),(1786,-356002200,1),(1786,-336645000,4),(1786,-324552600,1),(1786,-305195400,4),(1786,-293103000,1),(1786,-264933000,3),(1786,547578013,5),(1786,560883613,3),(1786,579027614,5),(1786,592333214,3),(1787,-2147483648,1),(1787,-2038200925,2),(1787,-1167634800,3),(1787,-1073028000,4),(1787,-894180000,5),(1787,-879665400,6),(1787,-767005200,5),(1787,378664210,7),(1788,-2147483648,1),(1788,-873057600,3),(1788,-769395600,2),(1788,-765399600,1),(1789,-2147483648,0),(1789,-2131645536,2),(1789,-1696276800,1),(1789,-1680469200,2),(1789,-1632074400,1),(1789,-1615143600,2),(1789,-1566763200,1),(1789,-1557090000,2),(1789,-1535486400,1),(1789,-1524949200,2),(1789,-1504468800,1),(1789,-1493413200,2),(1789,-1472414400,1),(1789,-1461963600,2),(1789,-1440964800,1),(1789,-1429390800,2),(1789,-1409515200,1),(1789,-1396731600,2),(1789,-1376856000,1),(1789,-1366491600,2),(1789,-1346616000,1),(1789,-1333832400,2),(1789,-1313956800,1),(1789,-1303678800,2),(1789,-1282507200,1),(1789,-1272661200,2),(1789,-1251057600,1),(1789,-1240088400,2),(1789,-1219608000,1),(1789,-1207429200,2),(1789,-1188763200,1),(1789,-1175979600,2),(1789,-1157313600,1),(1789,-1143925200,2),(1789,-1124049600,1),(1789,-1113771600,2),(1789,-1091390400,1),(1789,-1081026000,2),(1789,-1059854400,1),(1789,-1050786000,2),(1789,-1030910400,1),(1789,-1018126800,2),(1789,-999460800,1),(1789,-986677200,2),(1789,-965592000,1),(1789,-955227600,2),(1789,-935956800,1),(1789,-923173200,2),(1789,-904507200,1),(1789,-891723600,2),(1789,-880221600,3),(1789,-769395600,4),(1789,-765399600,2),(1789,-747252000,1),(1789,-733950000,2),(1789,-715802400,1),(1789,-702500400,2),(1789,-684352800,1),(1789,-671050800,2),(1789,-652903200,1),(1789,-639601200,2),(1789,-589399200,1),(1789,-576097200,2),(1789,-557949600,1),(1789,-544647600,2),(1789,-526500000,1),(1789,-513198000,2),(1789,-495050400,1),(1789,-481748400,2),(1789,-431546400,1),(1789,-418244400,2),(1789,-400096800,1),(1789,-386794800,2),(1789,-368647200,1),(1789,-355345200,2),(1789,-337197600,1),(1789,-323895600,2),(1789,-242244000,1),(1789,-226522800,2),(1789,-210794400,1),(1789,-195073200,2),(1789,-179344800,1),(1789,-163623600,2),(1789,-147895200,1),(1789,-131569200,2),(1789,-116445600,1),(1789,-100119600,2),(1789,-84391200,1),(1789,-68670000,2),(1789,-52941600,1),(1789,-37220400,2),(1789,-21492000,1),(1789,-5770800,2),(1789,9957600,1),(1789,25678800,2),(1789,41407200,1),(1789,57733200,2),(1789,73461600,1),(1789,89182801,2),(1789,104911202,1),(1789,120632402,2),(1789,136360803,1),(1789,152082003,2),(1789,167810404,1),(1789,183531604,2),(1789,199260005,1),(1789,215586005,2),(1789,230709606,1),(1789,247035606,2),(1789,262764007,1),(1789,278485207,2),(1789,294213608,1),(1789,309934808,2),(1789,325663209,1),(1789,341384409,2),(1789,357112809,1),(1789,372834010,2),(1789,388562410,1),(1789,404888411,2),(1789,420012011,1),(1789,436338012,2),(1789,452066412,1),(1789,467787612,2),(1789,483516012,1),(1789,499237213,2),(1789,514965613,1),(1789,530686813,2),(1789,544600813,1),(1789,562136413,2),(1789,576050414,1),(1789,594190814,2),(1789,607500014,1),(1789,625640414,2),(1789,638949615,1),(1789,657090015,2),(1789,671004016,1),(1789,688539616,2),(1789,702453616,1),(1789,719989217,2),(1789,733903217,1),(1789,752043618,2),(1789,765352818,1),(1789,783493219,2),(1789,796802419,1),(1789,814942819,2),(1789,828856820,1),(1789,846392420,2),(1789,860306420,1),(1789,877842021,2),(1789,891756021,1),(1789,909291621,2),(1789,923205622,1),(1789,941346022,2),(1789,954655222,1),(1789,972795622,2),(1789,986104822,1),(1789,1004245222,2),(1789,1018159222,1),(1789,1035694822,2),(1789,1049608822,1),(1789,1067144422,2),(1789,1081058422,1),(1789,1099198822,2),(1789,1112508022,1),(1789,1130648422,2),(1789,1143957623,1),(1789,1162098023,2),(1789,1173592823,1),(1789,1194152423,2),(1789,1205042423,1),(1789,1225602023,2),(1789,1236492024,1),(1789,1257051624,2),(1789,1268546424,1),(1789,1289106024,2),(1789,1299996024,1),(1789,1320555624,2),(1789,1331445624,1),(1789,1352005225,2),(1789,1362895225,1),(1789,1383454825,2),(1789,1394344825,1),(1789,1414904425,2),(1789,1425794425,1),(1789,1446354026,2),(1789,1457848826,1),(1789,1478408426,2),(1789,1489298427,1),(1789,1509858027,2),(1789,1520748027,1),(1789,1541307627,2),(1789,1552197627,1),(1789,1572757227,2),(1789,1583647227,1),(1789,1604206827,2),(1789,1615701627,1),(1789,1636261227,2),(1789,1647151227,1),(1789,1667710827,2),(1789,1678600827,1),(1789,1699160427,2),(1789,1710050427,1),(1789,1730610027,2),(1789,1741500027,1),(1789,1762059627,2),(1789,1772949627,1),(1789,1793509227,2),(1789,1805004027,1),(1789,1825563627,2),(1789,1836453627,1),(1789,1857013227,2),(1789,1867903227,1),(1789,1888462827,2),(1789,1899352827,1),(1789,1919912427,2),(1789,1930802427,1),(1789,1951362027,2),(1789,1962856827,1),(1789,1983416427,2),(1789,1994306427,1),(1789,2014866027,2),(1789,2025756027,1),(1789,2046315627,2),(1789,2057205627,1),(1789,2077765227,2),(1789,2088655227,1),(1789,2109214827,2),(1789,2120104827,1),(1789,2140664427,2),(1790,-2147483648,0),(1790,-2030202084,2),(1790,-1632063600,1),(1790,-1615132800,2),(1790,-1251651600,1),(1790,-1238349600,2),(1790,-1220202000,1),(1790,-1206900000,2),(1790,-1188752400,1),(1790,-1175450400,2),(1790,-1156698000,1),(1790,-1144000800,2),(1790,-1125248400,1),(1790,-1111946400,2),(1790,-1032714000,1),(1790,-1016992800,2),(1790,-1001264400,1),(1790,-986148000,2),(1790,-969814800,1),(1790,-954093600,2),(1790,-937760400,1),(1790,-922039200,2),(1790,-906310800,1),(1790,-890589600,2),(1790,-880210800,3),(1790,-769395600,4),(1790,-765388800,2),(1790,-748450800,1),(1790,-732729600,2),(1790,-715791600,1),(1790,-702489600,2),(1790,-684342000,1),(1790,-671040000,2),(1790,-652892400,1),(1790,-639590400,2),(1790,-620838000,1),(1790,-608140800,2),(1790,-589388400,1),(1790,-576086400,2),(1790,-557938800,1),(1790,-544636800,2),(1790,-526489200,1),(1790,-513187200,2),(1790,-495039600,1),(1790,-481737600,2),(1790,-463590000,1),(1790,-450288000,2),(1790,-431535600,1),(1790,-418233600,2),(1790,-400086000,1),(1790,-386784000,2),(1790,-337186800,1),(1790,-321465600,2),(1790,-305737200,5),(1791,-2147483648,2),(1791,-1633276800,1),(1791,-1615136400,2),(1791,-1601827200,1),(1791,-1583686800,2),(1791,-1563724800,1),(1791,-1551632400,2),(1791,-1538928000,1),(1791,-1520182800,2),(1791,-1504454400,1),(1791,-1491757200,2),(1791,-1473004800,1),(1791,-1459702800,2),(1791,-1441555200,1),(1791,-1428253200,2),(1791,-1410105600,1),(1791,-1396803600,2),(1791,-1378656000,1),(1791,-1365354000,2),(1791,-1347206400,1),(1791,-1333904400,2),(1791,-1315152000,1),(1791,-1301850000,2),(1791,-1283702400,1),(1791,-1270400400,2),(1791,-1252252800,1),(1791,-1238950800,2),(1791,-1220803200,1),(1791,-1207501200,2),(1791,-1189353600,1),(1791,-1176051600,2),(1791,-1157299200,1),(1791,-1144602000,2),(1791,-1125849600,1),(1791,-1112547600,2),(1791,-1094400000,1),(1791,-1081098000,2),(1791,-1067788800,3),(1791,-1045414800,2),(1791,-1031500800,1),(1791,-1018198800,2),(1791,-1000051200,1),(1791,-986749200,2),(1791,-967996800,1),(1791,-955299600,2),(1791,-936547200,1),(1791,-923245200,2),(1791,-905097600,1),(1791,-891795600,2),(1791,-880214400,4),(1791,-769395600,5),(1791,-765392400,2),(1791,-747244800,1),(1791,-733942800,2),(1791,-715795200,1),(1791,-702493200,2),(1791,-684345600,1),(1791,-671043600,2),(1791,-652896000,1),(1791,-639594000,2),(1791,-620841600,1),(1791,-608144400,2),(1791,-589392000,1),(1791,-576090000,2),(1791,-557942400,1),(1791,-544640400,2),(1791,-526492800,1),(1791,-513190800,2),(1791,-495043200,1),(1791,-481741200,2),(1791,-463593600,1),(1791,-447267600,2),(1791,-431539200,1),(1791,-415818000,2),(1791,-400089600,1),(1791,-384368400,2),(1791,-368640000,1),(1791,-352918800,2),(1791,-337190400,1),(1791,-321469200,2),(1791,-305740800,1),(1791,-289414800,2),(1791,-273686400,1),(1791,-257965200,2),(1791,-242236800,1),(1791,-226515600,2),(1791,-210787200,1),(1791,-195066000,2),(1791,-179337600,1),(1791,-163616400,2),(1791,-147888000,1),(1791,-131562000,2),(1791,-116438400,1),(1791,-100112400,2),(1791,-84384000,1),(1791,-68662800,2),(1791,-52934400,1),(1791,-37213200,2),(1791,-21484800,1),(1791,-5763600,2),(1791,9964800,1),(1791,25686000,2),(1791,41414400,1),(1791,57740400,2),(1791,73468800,1),(1791,89190001,2),(1791,104918402,1),(1791,120639602,2),(1791,126691203,1),(1791,152089203,2),(1791,162374404,1),(1791,183538804,2),(1791,199267205,1),(1791,215593205,2),(1791,230716806,1),(1791,247042806,2),(1791,262771207,1),(1791,278492407,2),(1791,294220808,1),(1791,309942008,2),(1791,325670409,1),(1791,341391609,2),(1791,357120009,1),(1791,372841210,2),(1791,388569610,1),(1791,404895611,2),(1791,420019211,1),(1791,436345212,2),(1791,452073612,1),(1791,467794812,2),(1791,483523212,1),(1791,499244413,2),(1791,514972813,1),(1791,530694013,2),(1791,544608013,1),(1791,562143613,2),(1791,576057614,1),(1791,594198014,2),(1791,607507214,1),(1791,625647614,2),(1791,638956815,1),(1791,657097215,2),(1791,671011216,1),(1791,688546816,2),(1791,702460816,1),(1791,719996417,2),(1791,733910417,1),(1791,752050818,2),(1791,765360018,1),(1791,783500419,2),(1791,796809619,1),(1791,814950019,2),(1791,828864020,1),(1791,846399620,2),(1791,860313620,1),(1791,877849221,2),(1791,891763221,1),(1791,909298821,2),(1791,923212822,1),(1791,941353222,2),(1791,954662422,1),(1791,972802822,2),(1791,986112022,1),(1791,1004252422,2),(1791,1018166422,1),(1791,1035702022,2),(1791,1049616022,1),(1791,1067151622,2),(1791,1081065622,1),(1791,1099206022,2),(1791,1112515222,1),(1791,1130655622,2),(1791,1143964823,1),(1791,1162105223,2),(1791,1173600023,1),(1791,1194159623,2),(1791,1205049623,1),(1791,1225609223,2),(1791,1236499224,1),(1791,1257058824,2),(1791,1268553624,1),(1791,1289113224,2),(1791,1300003224,1),(1791,1320562824,2),(1791,1331452824,1),(1791,1352012425,2),(1791,1362902425,1),(1791,1383462025,2),(1791,1394352025,1),(1791,1414911625,2),(1791,1425801625,1),(1791,1446361226,2),(1791,1457856026,1),(1791,1478415626,2),(1791,1489305627,1),(1791,1509865227,2),(1791,1520755227,1),(1791,1541314827,2),(1791,1552204827,1),(1791,1572764427,2),(1791,1583654427,1),(1791,1604214027,2),(1791,1615708827,1),(1791,1636268427,2),(1791,1647158427,1),(1791,1667718027,2),(1791,1678608027,1),(1791,1699167627,2),(1791,1710057627,1),(1791,1730617227,2),(1791,1741507227,1),(1791,1762066827,2),(1791,1772956827,1),(1791,1793516427,2),(1791,1805011227,1),(1791,1825570827,2),(1791,1836460827,1),(1791,1857020427,2),(1791,1867910427,1),(1791,1888470027,2),(1791,1899360027,1),(1791,1919919627,2),(1791,1930809627,1),(1791,1951369227,2),(1791,1962864027,1),(1791,1983423627,2),(1791,1994313627,1),(1791,2014873227,2),(1791,2025763227,1),(1791,2046322827,2),(1791,2057212827,1),(1791,2077772427,2),(1791,2088662427,1),(1791,2109222027,2),(1791,2120112027,1),(1791,2140671627,2),(1792,-2147483648,1),(1792,-1946918424,2),(1793,-2147483648,2),(1793,-1633280400,1),(1793,-1615140000,2),(1793,-1601830800,1),(1793,-1583690400,2),(1793,-1570381200,1),(1793,-1551636000,2),(1793,-1536512400,1),(1793,-1523210400,2),(1793,-1504458000,1),(1793,-1491760800,2),(1793,-1473008400,1),(1793,-1459706400,2),(1793,-1441558800,1),(1793,-1428256800,2),(1793,-1410109200,1),(1793,-1396807200,2),(1793,-1378659600,1),(1793,-1365357600,2),(1793,-1347210000,1),(1793,-1333908000,2),(1793,-1315155600,1),(1793,-1301853600,2),(1793,-1283706000,1),(1793,-1270404000,2),(1793,-1252256400,1),(1793,-1238954400,2),(1793,-1220806800,1),(1793,-1207504800,2),(1793,-1189357200,1),(1793,-1176055200,2),(1793,-1157302800,1),(1793,-1144605600,2),(1793,-1125853200,1),(1793,-1112551200,2),(1793,-1094403600,1),(1793,-1081101600,2),(1793,-1062954000,1),(1793,-1049652000,2),(1793,-1031504400,1),(1793,-1018202400,2),(1793,-1000054800,1),(1793,-986752800,2),(1793,-968000400,1),(1793,-955303200,2),(1793,-936550800,1),(1793,-923248800,2),(1793,-905101200,1),(1793,-891799200,2),(1793,-880218000,3),(1793,-769395600,4),(1793,-765396000,2),(1793,-747248400,1),(1793,-733946400,2),(1793,-715798800,1),(1793,-702496800,2),(1793,-684349200,1),(1793,-671047200,2),(1793,-652899600,1),(1793,-639597600,2),(1793,-620845200,1),(1793,-608148000,2),(1793,-589395600,1),(1793,-576093600,2),(1793,-557946000,1),(1793,-544644000,2),(1793,-526496400,1),(1793,-513194400,2),(1793,-495046800,1),(1793,-481744800,2),(1793,-463597200,1),(1793,-447271200,2),(1793,-431542800,1),(1793,-415821600,2),(1793,-400093200,1),(1793,-384372000,2),(1793,-368643600,1),(1793,-352922400,2),(1793,-337194000,1),(1793,-321472800,2),(1793,-305744400,1),(1793,-289418400,2),(1793,-273690000,1),(1793,-257968800,2),(1793,-242240400,1),(1793,-226519200,2),(1793,-210790800,1),(1793,-195069600,2),(1793,-179341200,1),(1793,-163620000,2),(1793,-147891600,1),(1793,-131565600,2),(1793,-116442000,1),(1793,-100116000,2),(1793,-84387600,1),(1793,-68666400,2),(1793,-52938000,1),(1793,-37216800,2),(1793,-21488400,1),(1793,-5767200,2),(1793,9961200,1),(1793,25682400,2),(1793,41410800,1),(1793,57736800,2),(1793,73465200,1),(1793,89186401,2),(1793,104914802,1),(1793,120636002,2),(1793,126687603,1),(1793,152085603,2),(1793,162370804,1),(1793,183535204,2),(1793,199263605,1),(1793,215589605,2),(1793,230713206,1),(1793,247039206,2),(1793,262767607,1),(1793,278488807,2),(1793,294217208,1),(1793,309938408,2),(1793,325666809,1),(1793,341388009,2),(1793,357116409,1),(1793,372837610,2),(1793,388566010,1),(1793,404892011,2),(1793,420015611,1),(1793,436341612,2),(1793,452070012,1),(1793,467791212,2),(1793,483519612,1),(1793,499240813,2),(1793,514969213,1),(1793,530690413,2),(1793,544604413,1),(1793,562140013,2),(1793,576054014,1),(1793,594194414,2),(1793,607503614,1),(1793,625644014,2),(1793,638953215,1),(1793,657093615,2),(1793,671007616,1),(1793,688543216,2),(1793,702457216,1),(1793,719992817,2),(1793,733906817,1),(1793,752047218,2),(1793,765356418,1),(1793,783496819,2),(1793,796806019,1),(1793,814946419,2),(1793,828860420,1),(1793,846396020,2),(1793,860310020,1),(1793,877845621,2),(1793,891759621,1),(1793,909295221,2),(1793,923209222,1),(1793,941349622,2),(1793,954658822,1),(1793,972799222,2),(1793,986108422,1),(1793,1004248822,2),(1793,1018162822,1),(1793,1035698422,2),(1793,1049612422,1),(1793,1067148022,2),(1793,1081062022,1),(1793,1099202422,2),(1793,1112511622,1),(1793,1130652022,2),(1793,1143961223,1),(1793,1162101623,2),(1793,1173596423,1),(1793,1194156023,2),(1793,1205046023,1),(1793,1225605623,2),(1793,1236495624,1),(1793,1257055224,2),(1793,1268550024,1),(1793,1289109624,2),(1793,1299999624,1),(1793,1320559224,2),(1793,1331449224,1),(1793,1352008825,2),(1793,1362898825,1),(1793,1383458425,2),(1793,1394348425,1),(1793,1414908025,2),(1793,1425798025,1),(1793,1446357626,2),(1793,1457852426,1),(1793,1478412026,2),(1793,1489302027,1),(1793,1509861627,2),(1793,1520751627,1),(1793,1541311227,2),(1793,1552201227,1),(1793,1572760827,2),(1793,1583650827,1),(1793,1604210427,2),(1793,1615705227,1),(1793,1636264827,2),(1793,1647154827,1),(1793,1667714427,2),(1793,1678604427,1),(1793,1699164027,2),(1793,1710054027,1),(1793,1730613627,2),(1793,1741503627,1),(1793,1762063227,2),(1793,1772953227,1),(1793,1793512827,2),(1793,1805007627,1),(1793,1825567227,2),(1793,1836457227,1),(1793,1857016827,2),(1793,1867906827,1),(1793,1888466427,2),(1793,1899356427,1),(1793,1919916027,2),(1793,1930806027,1),(1793,1951365627,2),(1793,1962860427,1),(1793,1983420027,2),(1793,1994310027,1),(1793,2014869627,2),(1793,2025759627,1),(1793,2046319227,2),(1793,2057209227,1),(1793,2077768827,2),(1793,2088658827,1),(1793,2109218427,2),(1793,2120108427,1),(1793,2140668027,2),(1794,-2147483648,1),(1794,-1157283000,2),(1794,-1155436200,1),(1794,-880198200,3),(1794,-769395600,4),(1794,-765376200,1),(1794,-712150200,5),(1795,-2147483648,2),(1795,-1633273200,1),(1795,-1615132800,2),(1795,-1601823600,1),(1795,-1583683200,2),(1795,-880210800,3),(1795,-820519140,2),(1795,-812653140,3),(1795,-796845540,2),(1795,-84380400,1),(1795,-68659200,2),(1796,-2147483648,2),(1796,-1633273200,1),(1796,-1615132800,2),(1796,-1601823600,1),(1796,-1583683200,2),(1796,-1570374000,1),(1796,-1551628800,2),(1796,-1538924400,1),(1796,-1534089600,2),(1796,-880210800,3),(1796,-769395600,4),(1796,-765388800,2),(1796,-147884400,1),(1796,-131558400,2),(1796,-116434800,1),(1796,-100108800,2),(1796,-84380400,1),(1796,-68659200,2),(1796,-52930800,1),(1796,-37209600,2),(1796,-21481200,1),(1796,-5760000,2),(1796,9968400,1),(1796,25689600,2),(1796,41418000,1),(1796,57744000,2),(1796,73472400,1),(1796,89193601,2),(1796,104922002,1),(1796,120643202,2),(1796,126694803,1),(1796,152092803,2),(1796,162378004,1),(1796,183542404,2),(1796,199270805,1),(1796,215596805,2),(1796,230720406,1),(1796,247046406,2),(1796,262774807,1),(1796,278496007,2),(1796,294224408,1),(1796,309945608,2),(1796,325674009,1),(1796,341395209,2),(1796,357123609,1),(1796,372844810,2),(1796,388573210,1),(1796,404899211,2),(1796,420022811,1),(1796,436348812,2),(1796,452077212,1),(1796,467798412,2),(1796,483526812,1),(1796,499248013,2),(1796,514976413,1),(1796,530697613,2),(1796,544611613,1),(1796,562147213,2),(1796,576061214,1),(1796,594201614,2),(1796,607510814,1),(1796,625651214,2),(1796,638960415,1),(1796,657100815,2),(1796,671014816,1),(1796,688550416,2),(1796,702464416,1),(1796,720000017,2),(1796,733914017,1),(1796,752054418,2),(1796,765363618,1),(1796,783504019,2),(1796,796813219,1),(1796,814953619,2),(1796,828867620,1),(1796,846403220,2),(1796,860317220,1),(1796,877852821,2),(1796,891766821,1),(1796,909302421,2),(1796,923216422,1),(1796,941356822,2),(1796,954666022,1),(1796,972806422,2),(1796,986115622,1),(1796,1004256022,2),(1796,1018170022,1),(1796,1035705622,2),(1796,1049619622,1),(1796,1067155222,2),(1796,1081069222,1),(1796,1099209622,2),(1796,1112518822,1),(1796,1130659222,2),(1796,1143968423,1),(1796,1162108823,2),(1796,1173603623,1),(1796,1194163223,2),(1796,1205053223,1),(1796,1225612823,2),(1796,1236502824,1),(1796,1257062424,2),(1796,1268557224,1),(1796,1289116824,2),(1796,1300006824,1),(1796,1320566424,2),(1796,1331456424,1),(1796,1352016025,2),(1796,1362906025,1),(1796,1383465625,2),(1796,1394355625,1),(1796,1414915225,2),(1796,1425805225,1),(1796,1446364826,2),(1796,1457859626,1),(1796,1478419226,2),(1796,1489309227,1),(1796,1509868827,2),(1796,1520758827,1),(1796,1541318427,2),(1796,1552208427,1),(1796,1572768027,2),(1796,1583658027,1),(1796,1604217627,2),(1796,1615712427,1),(1796,1636272027,2),(1796,1647162027,1),(1796,1667721627,2),(1796,1678611627,1),(1796,1699171227,2),(1796,1710061227,1),(1796,1730620827,2),(1796,1741510827,1),(1796,1762070427,2),(1796,1772960427,1),(1796,1793520027,2),(1796,1805014827,1),(1796,1825574427,2),(1796,1836464427,1),(1796,1857024027,2),(1796,1867914027,1),(1796,1888473627,2),(1796,1899363627,1),(1796,1919923227,2),(1796,1930813227,1),(1796,1951372827,2),(1796,1962867627,1),(1796,1983427227,2),(1796,1994317227,1),(1796,2014876827,2),(1796,2025766827,1),(1796,2046326427,2),(1796,2057216427,1),(1796,2077776027,2),(1796,2088666027,1),(1796,2109225627,2),(1796,2120115627,1),(1796,2140675227,2),(1797,-2147483648,1),(1797,893665821,2),(1798,-2147483648,2),(1798,-1633269600,1),(1798,-1615129200,2),(1798,-1601820000,1),(1798,-1583679600,2),(1798,-880207200,3),(1798,-769395600,4),(1798,-765385200,2),(1798,-687967140,1),(1798,-662655600,2),(1798,-620838000,1),(1798,-608137200,2),(1798,-589388400,1),(1798,-576082800,2),(1798,-557938800,1),(1798,-544633200,2),(1798,-526489200,1),(1798,-513183600,2),(1798,-495039600,1),(1798,-481734000,2),(1798,-463590000,1),(1798,-450284400,2),(1798,-431535600,1),(1798,-418230000,2),(1798,-400086000,1),(1798,-386780400,2),(1798,-368636400,1),(1798,-355330800,2),(1798,-337186800,1),(1798,-323881200,2),(1798,-305737200,1),(1798,-292431600,2),(1798,-273682800,1),(1798,-260982000,2),(1798,-242233200,1),(1798,-226508400,2),(1798,-210783600,1),(1798,-195058800,2),(1798,-179334000,1),(1798,-163609200,2),(1798,-147884400,1),(1798,-131554800,2),(1798,-116434800,1),(1798,-100105200,2),(1798,-84376800,1),(1798,-68655600,2),(1798,-52927200,1),(1798,-37206000,2),(1798,-21477600,1),(1798,-5756400,2),(1798,9972000,1),(1798,25693200,2),(1798,41421600,1),(1798,57747600,2),(1798,73476000,1),(1798,89197201,2),(1798,104925602,1),(1798,120646802,2),(1798,126698403,1),(1798,152096403,2),(1798,162381604,1),(1798,183546004,2),(1798,199274405,1),(1798,215600405,2),(1798,230724006,1),(1798,247050006,2),(1798,262778407,1),(1798,278499607,2),(1798,294228008,1),(1798,309949208,2),(1798,325677609,1),(1798,341398809,2),(1798,357127209,1),(1798,372848410,2),(1798,388576810,1),(1798,404902811,2),(1798,420026411,1),(1798,436352412,2),(1798,452080812,1),(1798,467802012,2),(1798,483530412,1),(1798,499251613,2),(1798,514980013,1),(1798,530701213,2),(1798,544615213,1),(1798,562150813,2),(1798,576064814,1),(1798,594205214,2),(1798,607514414,1),(1798,625654814,2),(1798,638964015,1),(1798,657104415,2),(1798,671018416,1),(1798,688554016,2),(1798,702468016,1),(1798,720003617,2),(1798,733917617,1),(1798,752058018,2),(1798,765367218,1),(1798,783507619,2),(1798,796816819,1),(1798,814957219,2),(1798,828871220,1),(1798,846406820,2),(1798,860320820,1),(1798,877856421,2),(1798,891770421,1),(1798,909306021,2),(1798,923220022,1),(1798,941360422,2),(1798,954669622,1),(1798,972810022,2),(1798,986119222,1),(1798,1004259622,2),(1798,1018173622,1),(1798,1035709222,2),(1798,1049623222,1),(1798,1067158822,2),(1798,1081072822,1),(1798,1099213222,2),(1798,1112522422,1),(1798,1130662822,2),(1798,1143972023,1),(1798,1162112423,2),(1798,1173607223,1),(1798,1194166823,2),(1798,1205056823,1),(1798,1225616423,2),(1798,1236506424,1),(1798,1257066024,2),(1798,1268560824,1),(1798,1289120424,2),(1798,1300010424,1),(1798,1320570024,2),(1798,1331460024,1),(1798,1352019625,2),(1798,1362909625,1),(1798,1383469225,2),(1798,1394359225,1),(1798,1414918825,2),(1798,1425808825,1),(1798,1446368426,2),(1798,1457863226,1),(1798,1478422826,2),(1798,1489312827,1),(1798,1509872427,2),(1798,1520762427,1),(1798,1541322027,2),(1798,1552212027,1),(1798,1572771627,2),(1798,1583661627,1),(1798,1604221227,2),(1798,1615716027,1),(1798,1636275627,2),(1798,1647165627,1),(1798,1667725227,2),(1798,1678615227,1),(1798,1699174827,2),(1798,1710064827,1),(1798,1730624427,2),(1798,1741514427,1),(1798,1762074027,2),(1798,1772964027,1),(1798,1793523627,2),(1798,1805018427,1),(1798,1825578027,2),(1798,1836468027,1),(1798,1857027627,2),(1798,1867917627,1),(1798,1888477227,2),(1798,1899367227,1),(1798,1919926827,2),(1798,1930816827,1),(1798,1951376427,2),(1798,1962871227,1),(1798,1983430827,2),(1798,1994320827,1),(1798,2014880427,2),(1798,2025770427,1),(1798,2046330027,2),(1798,2057220027,1),(1798,2077779627,2),(1798,2088669627,1),(1798,2109229227,2),(1798,2120119227,1),(1798,2140678827,2),(1799,-2147483648,0),(1799,-1806678012,1),(1800,-2147483648,1),(1800,-880200000,2),(1800,-769395600,3),(1800,-765378000,1),(1800,-86882400,4),(1800,-21470400,5),(1800,-5749200,4),(1800,9979200,5),(1800,25700400,4),(1800,41428800,5),(1800,57754800,4),(1800,73483200,5),(1800,89204401,4),(1800,104932802,5),(1800,120654002,4),(1800,126705603,5),(1800,152103603,4),(1800,162388804,5),(1800,183553204,4),(1800,199281605,5),(1800,215607605,4),(1800,230731206,5),(1800,247057206,4),(1800,262785607,5),(1800,278506807,4),(1800,294235208,5),(1800,309956408,4),(1800,325684809,5),(1800,341406009,4),(1800,357134409,5),(1800,372855610,4),(1800,388584010,5),(1800,404910011,4),(1800,420033611,5),(1800,436359612,6),(1800,439030812,8),(1800,452084412,7),(1800,467805612,8),(1800,483534012,7),(1800,499255213,8),(1800,514983613,7),(1800,530704813,8),(1800,544618813,7),(1800,562154413,8),(1800,576068414,7),(1800,594208814,8),(1800,607518014,7),(1800,625658414,8),(1800,638967615,7),(1800,657108015,8),(1800,671022016,7),(1800,688557616,8),(1800,702471616,7),(1800,720007217,8),(1800,733921217,7),(1800,752061618,8),(1800,765370818,7),(1800,783511219,8),(1800,796820419,7),(1800,814960819,8),(1800,828874820,7),(1800,846410420,8),(1800,860324420,7),(1800,877860021,8),(1800,891774021,7),(1800,909309621,8),(1800,923223622,7),(1800,941364022,8),(1800,954673222,7),(1800,972813622,8),(1800,986122822,7),(1800,1004263222,8),(1800,1018177222,7),(1800,1035712822,8),(1800,1049626822,7),(1800,1067162422,8),(1800,1081076422,7),(1800,1099216822,8),(1800,1112526022,7),(1800,1130666422,8),(1800,1143975623,7),(1800,1162116023,8),(1800,1173610823,7),(1800,1194170423,8),(1800,1205060423,7),(1800,1225620023,8),(1800,1236510024,7),(1800,1257069624,8),(1800,1268564424,7),(1800,1289124024,8),(1800,1300014024,7),(1800,1320573624,8),(1800,1331463624,7),(1800,1352023225,8),(1800,1362913225,7),(1800,1383472825,8),(1800,1394362825,7),(1800,1414922425,8),(1800,1425812425,7),(1800,1446372026,8),(1800,1457866826,7),(1800,1478426426,8),(1800,1489316427,7),(1800,1509876027,8),(1800,1520766027,7),(1800,1541325627,8),(1800,1552215627,7),(1800,1572775227,8),(1800,1583665227,7),(1800,1604224827,8),(1800,1615719627,7),(1800,1636279227,8),(1800,1647169227,7),(1800,1667728827,8),(1800,1678618827,7),(1800,1699178427,8),(1800,1710068427,7),(1800,1730628027,8),(1800,1741518027,7),(1800,1762077627,8),(1800,1772967627,7),(1800,1793527227,8),(1800,1805022027,7),(1800,1825581627,8),(1800,1836471627,7),(1800,1857031227,8),(1800,1867921227,7),(1800,1888480827,8),(1800,1899370827,7),(1800,1919930427,8),(1800,1930820427,7),(1800,1951380027,8),(1800,1962874827,7),(1800,1983434427,8),(1800,1994324427,7),(1800,2014884027,8),(1800,2025774027,7),(1800,2046333627,8),(1800,2057223627,7),(1800,2077783227,8),(1800,2088673227,7),(1800,2109232827,8),(1800,2120122827,7),(1800,2140682427,8),(1801,-2147483648,1),(1801,-1869875816,3),(1801,-1693706400,2),(1801,-1680490800,3),(1801,-1570413600,2),(1801,-1552186800,3),(1801,-1538359200,2),(1801,-1522551600,3),(1801,-1507514400,2),(1801,-1490583600,3),(1801,-1440208800,2),(1801,-1428030000,3),(1801,-1409709600,2),(1801,-1396494000,3),(1801,-931140000,2),(1801,-922762800,3),(1801,-917834400,2),(1801,-892436400,3),(1801,-875844000,2),(1801,-857358000,3),(1801,-781063200,2),(1801,-764737200,3),(1801,-744343200,2),(1801,-733806000,3),(1801,-716436000,2),(1801,-701924400,3),(1801,-684986400,2),(1801,-670474800,3),(1801,-654141600,2),(1801,-639025200,3),(1801,-621828000,2),(1801,-606970800,3),(1801,-590032800,2),(1801,-575434800,3),(1801,-235620000,2),(1801,-228279600,3),(1801,-177732000,2),(1801,-165726000,3),(1801,10533600,2),(1801,23835600,3),(1801,41983200,2),(1801,55285200,3),(1801,74037600,2),(1801,87339601,3),(1801,107910002,2),(1801,121219202,3),(1801,133920003,2),(1801,152676003,3),(1801,165362404,2),(1801,183502804,3),(1801,202428005,2),(1801,215557205,3),(1801,228866406,2),(1801,245797206,3),(1801,260316007,2),(1801,277246807,4),(1801,308779208,5),(1801,323827209,4),(1801,340228809,5),(1801,354672009,4),(1801,371678410,5),(1801,386121610,4),(1801,403128011,5),(1801,428446812,4),(1801,433886412,5),(1801,482792412,2),(1801,496702813,3),(1801,512521213,6),(1801,528246013,7),(1801,543970813,6),(1801,559695613,7),(1801,575420414,6),(1801,591145214,7),(1801,606870014,6),(1801,622594814,7),(1801,638319615,6),(1801,654649215,7),(1801,670374016,6),(1801,686098816,7),(1801,701823616,6),(1801,717548417,7),(1801,733273217,6),(1801,748998018,7),(1801,764118018,6),(1801,780447619,7),(1801,796172419,6),(1801,811897219,7),(1801,828226820,6),(1801,846370820,7),(1801,859676420,6),(1801,877820421,7),(1801,891126021,6),(1801,909270021,7),(1801,922575622,6),(1801,941324422,7),(1801,954025222,6),(1801,972774022,7),(1801,985474822,6),(1801,1004223622,7),(1801,1017529222,6),(1801,1035673222,7),(1801,1048978822,6),(1801,1067122822,7),(1801,1080428422,6),(1801,1099177222,7),(1801,1111878022,6),(1801,1130626822,7),(1801,1143327623,6),(1801,1162076423,7),(1801,1167602423,3),(1801,1174784423,8),(1801,1193533223,9),(1801,1206838823,8),(1801,1224982823,9),(1801,1238288424,8),(1801,1256432424,9),(1801,1269738024,8),(1801,1288486824,9),(1801,1301274024,8),(1801,1319936424,9),(1801,1332637224,8),(1801,1351386025,9),(1801,1364691625,8),(1801,1382835625,9),(1801,1396227625,8),(1801,1414285225,9),(1801,1427590825,8),(1801,1446944426,9),(1801,1459040426,8),(1801,1473195626,5),(1803,-2147483648,1),(1803,-880200000,2),(1803,-769395600,3),(1803,-765378000,1),(1803,-86882400,4),(1803,-21470400,5),(1803,-5749200,4),(1803,9979200,5),(1803,25700400,4),(1803,41428800,5),(1803,57754800,4),(1803,73483200,5),(1803,89204401,4),(1803,104932802,5),(1803,120654002,4),(1803,126705603,5),(1803,152103603,4),(1803,162388804,5),(1803,183553204,4),(1803,199281605,5),(1803,215607605,4),(1803,230731206,5),(1803,247057206,4),(1803,262785607,5),(1803,278506807,4),(1803,294235208,5),(1803,309956408,4),(1803,325684809,5),(1803,341406009,4),(1803,357134409,5),(1803,372855610,4),(1803,388584010,5),(1803,404910011,4),(1803,420033611,5),(1803,436359612,6),(1803,439030812,8),(1803,452084412,7),(1803,467805612,8),(1803,483534012,7),(1803,499255213,8),(1803,514983613,7),(1803,530704813,8),(1803,544618813,7),(1803,562154413,8),(1803,576068414,7),(1803,594208814,8),(1803,607518014,7),(1803,625658414,8),(1803,638967615,7),(1803,657108015,8),(1803,671022016,7),(1803,688557616,8),(1803,702471616,7),(1803,720007217,8),(1803,733921217,7),(1803,752061618,8),(1803,765370818,7),(1803,783511219,8),(1803,796820419,7),(1803,814960819,8),(1803,828874820,7),(1803,846410420,8),(1803,860324420,7),(1803,877860021,8),(1803,891774021,7),(1803,909309621,8),(1803,923223622,7),(1803,941364022,8),(1803,954673222,7),(1803,972813622,8),(1803,986122822,7),(1803,1004263222,8),(1803,1018177222,7),(1803,1035712822,8),(1803,1049626822,7),(1803,1067162422,8),(1803,1081076422,7),(1803,1099216822,8),(1803,1112526022,7),(1803,1130666422,8),(1803,1143975623,7),(1803,1162116023,8),(1803,1173610823,7),(1803,1194170423,8),(1803,1205060423,7),(1803,1225620023,8),(1803,1236510024,7),(1803,1257069624,8),(1803,1268564424,7),(1803,1289124024,8),(1803,1300014024,7),(1803,1320573624,8),(1803,1331463624,7),(1803,1352023225,8),(1803,1362913225,7),(1803,1383472825,8),(1803,1394362825,7),(1803,1414922425,8),(1803,1425812425,7),(1803,1446372026,8),(1803,1457866826,7),(1803,1478426426,8),(1803,1489316427,7),(1803,1509876027,8),(1803,1520766027,7),(1803,1541325627,8),(1803,1552215627,7),(1803,1572775227,8),(1803,1583665227,7),(1803,1604224827,8),(1803,1615719627,7),(1803,1636279227,8),(1803,1647169227,7),(1803,1667728827,8),(1803,1678618827,7),(1803,1699178427,8),(1803,1710068427,7),(1803,1730628027,8),(1803,1741518027,7),(1803,1762077627,8),(1803,1772967627,7),(1803,1793527227,8),(1803,1805022027,7),(1803,1825581627,8),(1803,1836471627,7),(1803,1857031227,8),(1803,1867921227,7),(1803,1888480827,8),(1803,1899370827,7),(1803,1919930427,8),(1803,1930820427,7),(1803,1951380027,8),(1803,1962874827,7),(1803,1983434427,8),(1803,1994324427,7),(1803,2014884027,8),(1803,2025774027,7),(1803,2046333627,8),(1803,2057223627,7),(1803,2077783227,8),(1803,2088673227,7),(1803,2109232827,8),(1803,2120122827,7),(1803,2140682427,8),(1804,-2147483648,1),(1804,-880196400,2),(1804,-769395600,3),(1804,-765374400,1),(1804,-86878800,4),(1804,-21466800,5),(1804,-5745600,4),(1804,9982800,5),(1804,25704000,4),(1804,41432400,5),(1804,57758400,4),(1804,73486800,5),(1804,89208001,4),(1804,104936402,5),(1804,120657602,4),(1804,126709203,5),(1804,152107203,4),(1804,162392404,5),(1804,183556804,4),(1804,199285205,5),(1804,215611205,4),(1804,230734806,5),(1804,247060806,4),(1804,262789207,5),(1804,278510407,4),(1804,294238808,5),(1804,309960008,4),(1804,325688409,5),(1804,341409609,4),(1804,357138009,5),(1804,372859210,4),(1804,388587610,5),(1804,404913611,4),(1804,420037211,5),(1804,436363212,6),(1804,439034412,8),(1804,452088012,7),(1804,467809212,8),(1804,483537612,7),(1804,499258813,8),(1804,514987213,7),(1804,530708413,8),(1804,544622413,7),(1804,562158013,8),(1804,576072014,7),(1804,594212414,8),(1804,607521614,7),(1804,625662014,8),(1804,638971215,7),(1804,657111615,8),(1804,671025616,7),(1804,688561216,8),(1804,702475216,7),(1804,720010817,8),(1804,733924817,7),(1804,752065218,8),(1804,765374418,7),(1804,783514819,8),(1804,796824019,7),(1804,814964419,8),(1804,828878420,7),(1804,846414020,8),(1804,860328020,7),(1804,877863621,8),(1804,891777621,7),(1804,909313221,8),(1804,923227222,7),(1804,941367622,8),(1804,954676822,7),(1804,972817222,8),(1804,986126422,7),(1804,1004266822,8),(1804,1018180822,7),(1804,1035716422,8),(1804,1049630422,7),(1804,1067166022,8),(1804,1081080022,7),(1804,1099220422,8),(1804,1112529622,7),(1804,1130670022,8),(1804,1143979223,7),(1804,1162119623,8),(1804,1173614423,7),(1804,1194174023,8),(1804,1205064023,7),(1804,1225623623,8),(1804,1236513624,7),(1804,1257073224,8),(1804,1268568024,7),(1804,1289127624,8),(1804,1300017624,7),(1804,1320577224,8),(1804,1331467224,7),(1804,1352026825,8),(1804,1362916825,7),(1804,1383476425,8),(1804,1394366425,7),(1804,1414926025,8),(1804,1425816025,7),(1804,1446375626,8),(1804,1457870426,7),(1804,1478430026,8),(1804,1489320027,7),(1804,1509879627,8),(1804,1520769627,7),(1804,1541329227,8),(1804,1552219227,7),(1804,1572778827,8),(1804,1583668827,7),(1804,1604228427,8),(1804,1615723227,7),(1804,1636282827,8),(1804,1647172827,7),(1804,1667732427,8),(1804,1678622427,7),(1804,1699182027,8),(1804,1710072027,7),(1804,1730631627,8),(1804,1741521627,7),(1804,1762081227,8),(1804,1772971227,7),(1804,1793530827,8),(1804,1805025627,7),(1804,1825585227,8),(1804,1836475227,7),(1804,1857034827,8),(1804,1867924827,7),(1804,1888484427,8),(1804,1899374427,7),(1804,1919934027,8),(1804,1930824027,7),(1804,1951383627,8),(1804,1962878427,7),(1804,1983438027,8),(1804,1994328027,7),(1804,2014887627,8),(1804,2025777627,7),(1804,2046337227,8),(1804,2057227227,7),(1804,2077786827,8),(1804,2088676827,7),(1804,2109236427,8),(1804,2120126427,7),(1804,2140686027,8),(1805,-2147483648,2),(1805,-1633273200,1),(1805,-1615132800,2),(1805,-1601823600,1),(1805,-1583683200,2),(1805,-880210800,3),(1805,-820519140,2),(1805,-812653140,3),(1805,-796845540,2),(1805,-84380400,1),(1805,-68659200,2),(1806,-2147483648,2),(1806,-1633276800,1),(1806,-1615136400,2),(1806,-1601827200,1),(1806,-1583686800,2),(1806,-1563724800,1),(1806,-1551632400,2),(1806,-1538928000,1),(1806,-1520182800,2),(1806,-1504454400,1),(1806,-1491757200,2),(1806,-1473004800,1),(1806,-1459702800,2),(1806,-1441555200,1),(1806,-1428253200,2),(1806,-1410105600,1),(1806,-1396803600,2),(1806,-1378656000,1),(1806,-1365354000,2),(1806,-1347206400,1),(1806,-1333904400,2),(1806,-1315152000,1),(1806,-1301850000,2),(1806,-1283702400,1),(1806,-1270400400,2),(1806,-1252252800,1),(1806,-1238950800,2),(1806,-1220803200,1),(1806,-1207501200,2),(1806,-1189353600,1),(1806,-1176051600,2),(1806,-1157299200,1),(1806,-1144602000,2),(1806,-1125849600,1),(1806,-1112547600,2),(1806,-1094400000,1),(1806,-1081098000,2),(1806,-1067788800,3),(1806,-1045414800,2),(1806,-1031500800,1),(1806,-1018198800,2),(1806,-1000051200,1),(1806,-986749200,2),(1806,-967996800,1),(1806,-955299600,2),(1806,-936547200,1),(1806,-923245200,2),(1806,-905097600,1),(1806,-891795600,2),(1806,-880214400,4),(1806,-769395600,5),(1806,-765392400,2),(1806,-747244800,1),(1806,-733942800,2),(1806,-715795200,1),(1806,-702493200,2),(1806,-684345600,1),(1806,-671043600,2),(1806,-652896000,1),(1806,-639594000,2),(1806,-620841600,1),(1806,-608144400,2),(1806,-589392000,1),(1806,-576090000,2),(1806,-557942400,1),(1806,-544640400,2),(1806,-526492800,1),(1806,-513190800,2),(1806,-495043200,1),(1806,-481741200,2),(1806,-463593600,1),(1806,-447267600,2),(1806,-431539200,1),(1806,-415818000,2),(1806,-400089600,1),(1806,-384368400,2),(1806,-368640000,1),(1806,-352918800,2),(1806,-337190400,1),(1806,-321469200,2),(1806,-305740800,1),(1806,-289414800,2),(1806,-273686400,1),(1806,-257965200,2),(1806,-242236800,1),(1806,-226515600,2),(1806,-210787200,1),(1806,-195066000,2),(1806,-179337600,1),(1806,-163616400,2),(1806,-147888000,1),(1806,-131562000,2),(1806,-116438400,1),(1806,-100112400,2),(1806,-84384000,1),(1806,-68662800,2),(1806,-52934400,1),(1806,-37213200,2),(1806,-21484800,1),(1806,-5763600,2),(1806,9964800,1),(1806,25686000,2),(1806,41414400,1),(1806,57740400,2),(1806,73468800,1),(1806,89190001,2),(1806,104918402,1),(1806,120639602,2),(1806,126691203,1),(1806,152089203,2),(1806,162374404,1),(1806,183538804,2),(1806,199267205,1),(1806,215593205,2),(1806,230716806,1),(1806,247042806,2),(1806,262771207,1),(1806,278492407,2),(1806,294220808,1),(1806,309942008,2),(1806,325670409,1),(1806,341391609,2),(1806,357120009,1),(1806,372841210,2),(1806,388569610,1),(1806,404895611,2),(1806,420019211,1),(1806,436345212,2),(1806,452073612,1),(1806,467794812,2),(1806,483523212,1),(1806,499244413,2),(1806,514972813,1),(1806,530694013,2),(1806,544608013,1),(1806,562143613,2),(1806,576057614,1),(1806,594198014,2),(1806,607507214,1),(1806,625647614,2),(1806,638956815,1),(1806,657097215,2),(1806,671011216,1),(1806,688546816,2),(1806,702460816,1),(1806,719996417,2),(1806,733910417,1),(1806,752050818,2),(1806,765360018,1),(1806,783500419,2),(1806,796809619,1),(1806,814950019,2),(1806,828864020,1),(1806,846399620,2),(1806,860313620,1),(1806,877849221,2),(1806,891763221,1),(1806,909298821,2),(1806,923212822,1),(1806,941353222,2),(1806,954662422,1),(1806,972802822,2),(1806,986112022,1),(1806,1004252422,2),(1806,1018166422,1),(1806,1035702022,2),(1806,1049616022,1),(1806,1067151622,2),(1806,1081065622,1),(1806,1099206022,2),(1806,1112515222,1),(1806,1130655622,2),(1806,1143964823,1),(1806,1162105223,2),(1806,1173600023,1),(1806,1194159623,2),(1806,1205049623,1),(1806,1225609223,2),(1806,1236499224,1),(1806,1257058824,2),(1806,1268553624,1),(1806,1289113224,2),(1806,1300003224,1),(1806,1320562824,2),(1806,1331452824,1),(1806,1352012425,2),(1806,1362902425,1),(1806,1383462025,2),(1806,1394352025,1),(1806,1414911625,2),(1806,1425801625,1),(1806,1446361226,2),(1806,1457856026,1),(1806,1478415626,2),(1806,1489305627,1),(1806,1509865227,2),(1806,1520755227,1),(1806,1541314827,2),(1806,1552204827,1),(1806,1572764427,2),(1806,1583654427,1),(1806,1604214027,2),(1806,1615708827,1),(1806,1636268427,2),(1806,1647158427,1),(1806,1667718027,2),(1806,1678608027,1),(1806,1699167627,2),(1806,1710057627,1),(1806,1730617227,2),(1806,1741507227,1),(1806,1762066827,2),(1806,1772956827,1),(1806,1793516427,2),(1806,1805011227,1),(1806,1825570827,2),(1806,1836460827,1),(1806,1857020427,2),(1806,1867910427,1),(1806,1888470027,2),(1806,1899360027,1),(1806,1919919627,2),(1806,1930809627,1),(1806,1951369227,2),(1806,1962864027,1),(1806,1983423627,2),(1806,1994313627,1),(1806,2014873227,2),(1806,2025763227,1),(1806,2046322827,2),(1806,2057212827,1),(1806,2077772427,2),(1806,2088662427,1),(1806,2109222027,2),(1806,2120112027,1),(1806,2140671627,2),(1807,-2147483648,2),(1807,-1633276800,1),(1807,-1615136400,2),(1807,-1601827200,1),(1807,-1583686800,2),(1807,-900259200,1),(1807,-891795600,2),(1807,-880214400,3),(1807,-769395600,4),(1807,-765392400,2),(1807,-747244800,1),(1807,-733942800,2),(1807,-715795200,1),(1807,-702493200,2),(1807,-684345600,1),(1807,-671043600,2),(1807,-652896000,1),(1807,-639594000,2),(1807,-620841600,1),(1807,-608144400,2),(1807,-589392000,1),(1807,-576090000,2),(1807,-557942400,1),(1807,-544640400,2),(1807,-526492800,1),(1807,-513190800,2),(1807,-495043200,1),(1807,-481741200,2),(1807,-463593600,5),(1807,-386787600,2),(1807,-368640000,5),(1807,-21488400,6),(1807,-5767200,5),(1807,9961200,6),(1807,25682400,5),(1807,1143961223,6),(1807,1162101623,5),(1807,1173596423,6),(1807,1194156023,5),(1807,1205046023,6),(1807,1225605623,5),(1807,1236495624,6),(1807,1257055224,5),(1807,1268550024,6),(1807,1289109624,5),(1807,1299999624,6),(1807,1320559224,5),(1807,1331449224,6),(1807,1352008825,5),(1807,1362898825,6),(1807,1383458425,5),(1807,1394348425,6),(1807,1414908025,5),(1807,1425798025,6),(1807,1446357626,5),(1807,1457852426,6),(1807,1478412026,5),(1807,1489302027,6),(1807,1509861627,5),(1807,1520751627,6),(1807,1541311227,5),(1807,1552201227,6),(1807,1572760827,5),(1807,1583650827,6),(1807,1604210427,5),(1807,1615705227,6),(1807,1636264827,5),(1807,1647154827,6),(1807,1667714427,5),(1807,1678604427,6),(1807,1699164027,5),(1807,1710054027,6),(1807,1730613627,5),(1807,1741503627,6),(1807,1762063227,5),(1807,1772953227,6),(1807,1793512827,5),(1807,1805007627,6),(1807,1825567227,5),(1807,1836457227,6),(1807,1857016827,5),(1807,1867906827,6),(1807,1888466427,5),(1807,1899356427,6),(1807,1919916027,5),(1807,1930806027,6),(1807,1951365627,5),(1807,1962860427,6),(1807,1983420027,5),(1807,1994310027,6),(1807,2014869627,5),(1807,2025759627,6),(1807,2046319227,5),(1807,2057209227,6),(1807,2077768827,5),(1807,2088658827,6),(1807,2109218427,5),(1807,2120108427,6),(1807,2140668027,5),(1808,-2147483648,2),(1808,-1633280400,1),(1808,-1615140000,2),(1808,-1601830800,1),(1808,-1583690400,2),(1808,-1570381200,1),(1808,-1551636000,2),(1808,-1536512400,1),(1808,-1523210400,2),(1808,-1504458000,1),(1808,-1491760800,2),(1808,-1473008400,1),(1808,-1459706400,2),(1808,-1441558800,1),(1808,-1428256800,2),(1808,-1410109200,1),(1808,-1396807200,2),(1808,-1378659600,1),(1808,-1365357600,2),(1808,-1347210000,1),(1808,-1333908000,2),(1808,-1315155600,1),(1808,-1301853600,2),(1808,-1283706000,1),(1808,-1270404000,2),(1808,-1252256400,1),(1808,-1238954400,2),(1808,-1220806800,1),(1808,-1207504800,2),(1808,-1189357200,1),(1808,-1176055200,2),(1808,-1157302800,1),(1808,-1144605600,2),(1808,-1125853200,1),(1808,-1112551200,2),(1808,-1094403600,1),(1808,-1081101600,2),(1808,-1062954000,1),(1808,-1049652000,2),(1808,-1031504400,1),(1808,-1018202400,2),(1808,-1000054800,1),(1808,-986752800,2),(1808,-968000400,1),(1808,-955303200,2),(1808,-936550800,1),(1808,-923248800,2),(1808,-905101200,1),(1808,-891799200,2),(1808,-880218000,3),(1808,-769395600,4),(1808,-765396000,2),(1808,-747248400,1),(1808,-733946400,2),(1808,-715798800,1),(1808,-702496800,2),(1808,-684349200,1),(1808,-671047200,2),(1808,-652899600,1),(1808,-639597600,2),(1808,-620845200,1),(1808,-608148000,2),(1808,-589395600,1),(1808,-576093600,2),(1808,-557946000,1),(1808,-544644000,2),(1808,-526496400,1),(1808,-513194400,2),(1808,-495046800,1),(1808,-481744800,2),(1808,-463597200,1),(1808,-447271200,2),(1808,-431542800,1),(1808,-415821600,2),(1808,-400093200,1),(1808,-384372000,2),(1808,-368643600,1),(1808,-352922400,2),(1808,-337194000,1),(1808,-321472800,2),(1808,-305744400,1),(1808,-289418400,2),(1808,-273690000,1),(1808,-257968800,2),(1808,-242240400,1),(1808,-226519200,2),(1808,-210790800,1),(1808,-195069600,2),(1808,-179341200,1),(1808,-163620000,2),(1808,-147891600,1),(1808,-131565600,2),(1808,-116442000,1),(1808,-100116000,2),(1808,-84387600,1),(1808,-68666400,2),(1808,-52938000,1),(1808,-37216800,2),(1808,-21488400,1),(1808,-5767200,2),(1808,9961200,1),(1808,25682400,2),(1808,41410800,1),(1808,57736800,2),(1808,73465200,1),(1808,89186401,2),(1808,104914802,1),(1808,120636002,2),(1808,126687603,1),(1808,152085603,2),(1808,162370804,1),(1808,183535204,2),(1808,199263605,1),(1808,215589605,2),(1808,230713206,1),(1808,247039206,2),(1808,262767607,1),(1808,278488807,2),(1808,294217208,1),(1808,309938408,2),(1808,325666809,1),(1808,341388009,2),(1808,357116409,1),(1808,372837610,2),(1808,388566010,1),(1808,404892011,2),(1808,420015611,1),(1808,436341612,2),(1808,452070012,1),(1808,467791212,2),(1808,483519612,1),(1808,499240813,2),(1808,514969213,1),(1808,530690413,2),(1808,544604413,1),(1808,562140013,2),(1808,576054014,1),(1808,594194414,2),(1808,607503614,1),(1808,625644014,2),(1808,638953215,1),(1808,657093615,2),(1808,671007616,1),(1808,688543216,2),(1808,702457216,1),(1808,719992817,2),(1808,733906817,1),(1808,752047218,2),(1808,765356418,1),(1808,783496819,2),(1808,796806019,1),(1808,814946419,2),(1808,828860420,1),(1808,846396020,2),(1808,860310020,1),(1808,877845621,2),(1808,891759621,1),(1808,909295221,2),(1808,923209222,1),(1808,941349622,2),(1808,954658822,1),(1808,972799222,2),(1808,986108422,1),(1808,1004248822,2),(1808,1018162822,1),(1808,1035698422,2),(1808,1049612422,1),(1808,1067148022,2),(1808,1081062022,1),(1808,1099202422,2),(1808,1112511622,1),(1808,1130652022,2),(1808,1143961223,1),(1808,1162101623,2),(1808,1173596423,1),(1808,1194156023,2),(1808,1205046023,1),(1808,1225605623,2),(1808,1236495624,1),(1808,1257055224,2),(1808,1268550024,1),(1808,1289109624,2),(1808,1299999624,1),(1808,1320559224,2),(1808,1331449224,1),(1808,1352008825,2),(1808,1362898825,1),(1808,1383458425,2),(1808,1394348425,1),(1808,1414908025,2),(1808,1425798025,1),(1808,1446357626,2),(1808,1457852426,1),(1808,1478412026,2),(1808,1489302027,1),(1808,1509861627,2),(1808,1520751627,1),(1808,1541311227,2),(1808,1552201227,1),(1808,1572760827,2),(1808,1583650827,1),(1808,1604210427,2),(1808,1615705227,1),(1808,1636264827,2),(1808,1647154827,1),(1808,1667714427,2),(1808,1678604427,1),(1808,1699164027,2),(1808,1710054027,1),(1808,1730613627,2),(1808,1741503627,1),(1808,1762063227,2),(1808,1772953227,1),(1808,1793512827,2),(1808,1805007627,1),(1808,1825567227,2),(1808,1836457227,1),(1808,1857016827,2),(1808,1867906827,1),(1808,1888466427,2),(1808,1899356427,1),(1808,1919916027,2),(1808,1930806027,1),(1808,1951365627,2),(1808,1962860427,1),(1808,1983420027,2),(1808,1994310027,1),(1808,2014869627,2),(1808,2025759627,1),(1808,2046319227,2),(1808,2057209227,1),(1808,2077768827,2),(1808,2088658827,1),(1808,2109218427,2),(1808,2120108427,1),(1808,2140668027,2),(1809,-2147483648,1),(1809,-1157283000,2),(1809,-1155436200,1),(1809,-880198200,3),(1809,-769395600,4),(1809,-765376200,1),(1809,-712150200,5),(1810,-2147483648,2),(1810,-1633276800,1),(1810,-1615136400,2),(1810,-1601827200,1),(1810,-1583686800,2),(1810,-880214400,3),(1810,-769395600,4),(1810,-765392400,2),(1810,-715795200,1),(1810,-702493200,2),(1810,-684345600,1),(1810,-671043600,2),(1810,-652896000,1),(1810,-639594000,2),(1810,-620841600,1),(1810,-608144400,2),(1810,-589392000,1),(1810,-576090000,2),(1810,-557942400,1),(1810,-544640400,2),(1810,-526492800,1),(1810,-513190800,2),(1810,-495043200,1),(1810,-481741200,2),(1810,-463593600,1),(1810,-447267600,2),(1810,-431539200,1),(1810,-415818000,2),(1810,-400089600,1),(1810,-386787600,2),(1810,-368640000,1),(1810,-355338000,2),(1810,-337190400,1),(1810,-321469200,2),(1810,-305740800,1),(1810,-289414800,2),(1810,-273686400,1),(1810,-257965200,2),(1810,-242236800,5),(1810,-195066000,2),(1810,-84384000,1),(1810,-68662800,2),(1810,-52934400,1),(1810,-37213200,2),(1810,-21484800,1),(1810,-5763600,2),(1810,9964800,1),(1810,25686000,2),(1810,41414400,1),(1810,57740400,2),(1810,73468800,1),(1810,89190001,2),(1810,104918402,1),(1810,120639602,2),(1810,126691203,1),(1810,152089203,2),(1810,162374404,1),(1810,183538804,2),(1810,199267205,1),(1810,215593205,2),(1810,230716806,1),(1810,247042806,2),(1810,262771207,1),(1810,278492407,2),(1810,294220808,1),(1810,309942008,2),(1810,325670409,1),(1810,341391609,2),(1810,357120009,1),(1810,372841210,2),(1810,388569610,1),(1810,404895611,2),(1810,420019211,1),(1810,436345212,2),(1810,452073612,1),(1810,467794812,2),(1810,483523212,1),(1810,499244413,2),(1810,514972813,1),(1810,530694013,2),(1810,544608013,1),(1810,562143613,2),(1810,576057614,1),(1810,594198014,2),(1810,607507214,1),(1810,625647614,2),(1810,638956815,1),(1810,657097215,2),(1810,671011216,1),(1810,688546816,5),(1810,1143961223,1),(1810,1162105223,2),(1810,1173600023,1),(1810,1194159623,2),(1810,1205049623,1),(1810,1225609223,2),(1810,1236499224,1),(1810,1257058824,2),(1810,1268553624,1),(1810,1289113224,2),(1810,1300003224,1),(1810,1320562824,2),(1810,1331452824,1),(1810,1352012425,2),(1810,1362902425,1),(1810,1383462025,2),(1810,1394352025,1),(1810,1414911625,2),(1810,1425801625,1),(1810,1446361226,2),(1810,1457856026,1),(1810,1478415626,2),(1810,1489305627,1),(1810,1509865227,2),(1810,1520755227,1),(1810,1541314827,2),(1810,1552204827,1),(1810,1572764427,2),(1810,1583654427,1),(1810,1604214027,2),(1810,1615708827,1),(1810,1636268427,2),(1810,1647158427,1),(1810,1667718027,2),(1810,1678608027,1),(1810,1699167627,2),(1810,1710057627,1),(1810,1730617227,2),(1810,1741507227,1),(1810,1762066827,2),(1810,1772956827,1),(1810,1793516427,2),(1810,1805011227,1),(1810,1825570827,2),(1810,1836460827,1),(1810,1857020427,2),(1810,1867910427,1),(1810,1888470027,2),(1810,1899360027,1),(1810,1919919627,2),(1810,1930809627,1),(1810,1951369227,2),(1810,1962864027,1),(1810,1983423627,2),(1810,1994313627,1),(1810,2014873227,2),(1810,2025763227,1),(1810,2046322827,2),(1810,2057212827,1),(1810,2077772427,2),(1810,2088662427,1),(1810,2109222027,2),(1810,2120112027,1),(1810,2140671627,2),(1811,-2147483648,0),(1811,-2051202469,1),(1811,-1724083200,2),(1811,-880218000,3),(1811,-769395600,4),(1811,-765396000,2),(1811,-684349200,5),(1811,-671047200,2),(1811,104914802,5),(1811,120636002,2),(1811,126687603,5),(1811,152085603,2),(1811,167814004,5),(1811,183535204,2),(1811,199263605,5),(1811,215589605,2),(1811,230713206,5),(1811,247039206,2),(1811,262767607,5),(1811,278488807,2),(1811,294217208,5),(1811,309938408,2),(1811,325666809,5),(1811,341388009,2),(1811,357116409,5),(1811,372837610,2),(1811,388566010,5),(1811,404892011,2),(1811,420015611,5),(1811,436341612,2),(1811,452070012,5),(1811,467791212,2),(1811,483519612,5),(1811,499240813,2),(1811,514969213,5),(1811,530690413,2),(1811,544604413,5),(1811,562140013,2),(1811,576054014,5),(1811,594194414,2),(1811,607503614,5),(1811,625644014,2),(1811,638953215,5),(1811,657093615,2),(1811,671007616,5),(1811,688543216,2),(1811,702457216,5),(1811,719992817,2),(1811,733906817,5),(1811,752047218,2),(1811,765356418,5),(1811,783496819,2),(1811,796806019,5),(1811,814946419,2),(1811,828860420,5),(1811,846396020,2),(1811,860310020,5),(1811,877845621,2),(1811,891759621,5),(1811,909295221,2),(1811,923209222,5),(1811,941349622,2),(1811,954658822,5),(1811,972799222,2),(1811,986108422,5),(1811,1004248822,2),(1811,1018162822,5),(1811,1035698422,2),(1811,1049612422,5),(1811,1067148022,2),(1811,1081062022,5),(1811,1099202422,2),(1811,1112511622,5),(1811,1130652022,2),(1811,1143961223,5),(1811,1162101623,2),(1811,1173596423,5),(1811,1194156023,2),(1811,1205046023,5),(1811,1225605623,2),(1811,1236495624,5),(1811,1257055224,2),(1811,1268550024,5),(1811,1289109624,2),(1811,1299999624,5),(1811,1320559224,2),(1811,1331449224,5),(1811,1352008825,2),(1811,1362898825,5),(1811,1383458425,2),(1811,1394348425,5),(1811,1414908025,2),(1811,1425798025,5),(1811,1446357626,2),(1811,1457852426,5),(1811,1478412026,2),(1811,1489302027,5),(1811,1509861627,2),(1811,1520751627,5),(1811,1541311227,2),(1811,1552201227,5),(1811,1572760827,2),(1811,1583650827,5),(1811,1604210427,2),(1811,1615705227,5),(1811,1636264827,2),(1811,1647154827,5),(1811,1667714427,2),(1811,1678604427,5),(1811,1699164027,2),(1811,1710054027,5),(1811,1730613627,2),(1811,1741503627,5),(1811,1762063227,2),(1811,1772953227,5),(1811,1793512827,2),(1811,1805007627,5),(1811,1825567227,2),(1811,1836457227,5),(1811,1857016827,2),(1811,1867906827,5),(1811,1888466427,2),(1811,1899356427,5),(1811,1919916027,2),(1811,1930806027,5),(1811,1951365627,2),(1811,1962860427,5),(1811,1983420027,2),(1811,1994310027,5),(1811,2014869627,2),(1811,2025759627,5),(1811,2046319227,2),(1811,2057209227,5),(1811,2077768827,2),(1811,2088658827,5),(1811,2109218427,2),(1811,2120108427,5),(1811,2140668027,2),(1812,-2147483648,2),(1812,-1633273200,1),(1812,-1615132800,2),(1812,-1601823600,1),(1812,-1583683200,2),(1812,-1570374000,1),(1812,-1551628800,2),(1812,-1538924400,1),(1812,-1534089600,2),(1812,-880210800,3),(1812,-769395600,4),(1812,-765388800,2),(1812,-147884400,1),(1812,-131558400,2),(1812,-116434800,1),(1812,-100108800,2),(1812,-84380400,1),(1812,-68659200,2),(1812,-52930800,1),(1812,-37209600,2),(1812,-21481200,1),(1812,-5760000,2),(1812,9968400,1),(1812,25689600,2),(1812,41418000,1),(1812,57744000,2),(1812,73472400,1),(1812,89193601,2),(1812,104922002,1),(1812,120643202,2),(1812,126694803,1),(1812,152092803,2),(1812,162378004,1),(1812,183542404,2),(1812,199270805,1),(1812,215596805,2),(1812,230720406,1),(1812,247046406,2),(1812,262774807,1),(1812,278496007,2),(1812,294224408,1),(1812,309945608,2),(1812,325674009,1),(1812,341395209,2),(1812,357123609,1),(1812,372844810,2),(1812,388573210,1),(1812,404899211,2),(1812,420022811,1),(1812,436348812,2),(1812,452077212,1),(1812,467798412,2),(1812,483526812,1),(1812,499248013,2),(1812,514976413,1),(1812,530697613,2),(1812,544611613,1),(1812,562147213,2),(1812,576061214,1),(1812,594201614,2),(1812,607510814,1),(1812,625651214,2),(1812,638960415,1),(1812,657100815,2),(1812,671014816,1),(1812,688550416,2),(1812,702464416,1),(1812,720000017,2),(1812,733914017,1),(1812,752054418,2),(1812,765363618,1),(1812,783504019,2),(1812,796813219,1),(1812,814953619,2),(1812,828867620,1),(1812,846403220,2),(1812,860317220,1),(1812,877852821,2),(1812,891766821,1),(1812,909302421,2),(1812,923216422,1),(1812,941356822,2),(1812,954666022,1),(1812,972806422,2),(1812,986115622,1),(1812,1004256022,2),(1812,1018170022,1),(1812,1035705622,2),(1812,1049619622,1),(1812,1067155222,2),(1812,1081069222,1),(1812,1099209622,2),(1812,1112518822,1),(1812,1130659222,2),(1812,1143968423,1),(1812,1162108823,2),(1812,1173603623,1),(1812,1194163223,2),(1812,1205053223,1),(1812,1225612823,2),(1812,1236502824,1),(1812,1257062424,2),(1812,1268557224,1),(1812,1289116824,2),(1812,1300006824,1),(1812,1320566424,2),(1812,1331456424,1),(1812,1352016025,2),(1812,1362906025,1),(1812,1383465625,2),(1812,1394355625,1),(1812,1414915225,2),(1812,1425805225,1),(1812,1446364826,2),(1812,1457859626,1),(1812,1478419226,2),(1812,1489309227,1),(1812,1509868827,2),(1812,1520758827,1),(1812,1541318427,2),(1812,1552208427,1),(1812,1572768027,2),(1812,1583658027,1),(1812,1604217627,2),(1812,1615712427,1),(1812,1636272027,2),(1812,1647162027,1),(1812,1667721627,2),(1812,1678611627,1),(1812,1699171227,2),(1812,1710061227,1),(1812,1730620827,2),(1812,1741510827,1),(1812,1762070427,2),(1812,1772960427,1),(1812,1793520027,2),(1812,1805014827,1),(1812,1825574427,2),(1812,1836464427,1),(1812,1857024027,2),(1812,1867914027,1),(1812,1888473627,2),(1812,1899363627,1),(1812,1919923227,2),(1812,1930813227,1),(1812,1951372827,2),(1812,1962867627,1),(1812,1983427227,2),(1812,1994317227,1),(1812,2014876827,2),(1812,2025766827,1),(1812,2046326427,2),(1812,2057216427,1),(1812,2077776027,2),(1812,2088666027,1),(1812,2109225627,2),(1812,2120115627,1),(1812,2140675227,2),(1813,-2147483648,2),(1813,-1633269600,1),(1813,-1615129200,2),(1813,-1601820000,1),(1813,-1583679600,2),(1813,-880207200,3),(1813,-769395600,4),(1813,-765385200,2),(1813,-687967140,1),(1813,-662655600,2),(1813,-620838000,1),(1813,-608137200,2),(1813,-589388400,1),(1813,-576082800,2),(1813,-557938800,1),(1813,-544633200,2),(1813,-526489200,1),(1813,-513183600,2),(1813,-495039600,1),(1813,-481734000,2),(1813,-463590000,1),(1813,-450284400,2),(1813,-431535600,1),(1813,-418230000,2),(1813,-400086000,1),(1813,-386780400,2),(1813,-368636400,1),(1813,-355330800,2),(1813,-337186800,1),(1813,-323881200,2),(1813,-305737200,1),(1813,-292431600,2),(1813,-273682800,1),(1813,-260982000,2),(1813,-242233200,1),(1813,-226508400,2),(1813,-210783600,1),(1813,-195058800,2),(1813,-179334000,1),(1813,-163609200,2),(1813,-147884400,1),(1813,-131554800,2),(1813,-116434800,1),(1813,-100105200,2),(1813,-84376800,1),(1813,-68655600,2),(1813,-52927200,1),(1813,-37206000,2),(1813,-21477600,1),(1813,-5756400,2),(1813,9972000,1),(1813,25693200,2),(1813,41421600,1),(1813,57747600,2),(1813,73476000,1),(1813,89197201,2),(1813,104925602,1),(1813,120646802,2),(1813,126698403,1),(1813,152096403,2),(1813,162381604,1),(1813,183546004,2),(1813,199274405,1),(1813,215600405,2),(1813,230724006,1),(1813,247050006,2),(1813,262778407,1),(1813,278499607,2),(1813,294228008,1),(1813,309949208,2),(1813,325677609,1),(1813,341398809,2),(1813,357127209,1),(1813,372848410,2),(1813,388576810,1),(1813,404902811,2),(1813,420026411,1),(1813,436352412,2),(1813,452080812,1),(1813,467802012,2),(1813,483530412,1),(1813,499251613,2),(1813,514980013,1),(1813,530701213,2),(1813,544615213,1),(1813,562150813,2),(1813,576064814,1),(1813,594205214,2),(1813,607514414,1),(1813,625654814,2),(1813,638964015,1),(1813,657104415,2),(1813,671018416,1),(1813,688554016,2),(1813,702468016,1),(1813,720003617,2),(1813,733917617,1),(1813,752058018,2),(1813,765367218,1),(1813,783507619,2),(1813,796816819,1),(1813,814957219,2),(1813,828871220,1),(1813,846406820,2),(1813,860320820,1),(1813,877856421,2),(1813,891770421,1),(1813,909306021,2),(1813,923220022,1),(1813,941360422,2),(1813,954669622,1),(1813,972810022,2),(1813,986119222,1),(1813,1004259622,2),(1813,1018173622,1),(1813,1035709222,2),(1813,1049623222,1),(1813,1067158822,2),(1813,1081072822,1),(1813,1099213222,2),(1813,1112522422,1),(1813,1130662822,2),(1813,1143972023,1),(1813,1162112423,2),(1813,1173607223,1),(1813,1194166823,2),(1813,1205056823,1),(1813,1225616423,2),(1813,1236506424,1),(1813,1257066024,2),(1813,1268560824,1),(1813,1289120424,2),(1813,1300010424,1),(1813,1320570024,2),(1813,1331460024,1),(1813,1352019625,2),(1813,1362909625,1),(1813,1383469225,2),(1813,1394359225,1),(1813,1414918825,2),(1813,1425808825,1),(1813,1446368426,2),(1813,1457863226,1),(1813,1478422826,2),(1813,1489312827,1),(1813,1509872427,2),(1813,1520762427,1),(1813,1541322027,2),(1813,1552212027,1),(1813,1572771627,2),(1813,1583661627,1),(1813,1604221227,2),(1813,1615716027,1),(1813,1636275627,2),(1813,1647165627,1),(1813,1667725227,2),(1813,1678615227,1),(1813,1699174827,2),(1813,1710064827,1),(1813,1730624427,2),(1813,1741514427,1),(1813,1762074027,2),(1813,1772964027,1),(1813,1793523627,2),(1813,1805018427,1),(1813,1825578027,2),(1813,1836468027,1),(1813,1857027627,2),(1813,1867917627,1),(1813,1888477227,2),(1813,1899367227,1),(1813,1919926827,2),(1813,1930816827,1),(1813,1951376427,2),(1813,1962871227,1),(1813,1983430827,2),(1813,1994320827,1),(1813,2014880427,2),(1813,2025770427,1),(1813,2046330027,2),(1813,2057220027,1),(1813,2077779627,2),(1813,2088669627,1),(1813,2109229227,2),(1813,2120119227,1),(1813,2140678827,2),(1814,-2147483648,2),(1814,-1633269600,1),(1814,-1615129200,2),(1814,-1601820000,1),(1814,-1583679600,2),(1814,-880207200,3),(1814,-769395600,4),(1814,-765385200,2),(1814,-687967140,1),(1814,-662655600,2),(1814,-620838000,1),(1814,-608137200,2),(1814,-589388400,1),(1814,-576082800,2),(1814,-557938800,1),(1814,-544633200,2),(1814,-526489200,1),(1814,-513183600,2),(1814,-495039600,1),(1814,-481734000,2),(1814,-463590000,1),(1814,-450284400,2),(1814,-431535600,1),(1814,-418230000,2),(1814,-400086000,1),(1814,-386780400,2),(1814,-368636400,1),(1814,-355330800,2),(1814,-337186800,1),(1814,-323881200,2),(1814,-305737200,1),(1814,-292431600,2),(1814,-273682800,1),(1814,-260982000,2),(1814,-242233200,1),(1814,-226508400,2),(1814,-210783600,1),(1814,-195058800,2),(1814,-179334000,1),(1814,-163609200,2),(1814,-147884400,1),(1814,-131554800,2),(1814,-116434800,1),(1814,-100105200,2),(1814,-84376800,1),(1814,-68655600,2),(1814,-52927200,1),(1814,-37206000,2),(1814,-21477600,1),(1814,-5756400,2),(1814,9972000,1),(1814,25693200,2),(1814,41421600,1),(1814,57747600,2),(1814,73476000,1),(1814,89197201,2),(1814,104925602,1),(1814,120646802,2),(1814,126698403,1),(1814,152096403,2),(1814,162381604,1),(1814,183546004,2),(1814,199274405,1),(1814,215600405,2),(1814,230724006,1),(1814,247050006,2),(1814,262778407,1),(1814,278499607,2),(1814,294228008,1),(1814,309949208,2),(1814,325677609,1),(1814,341398809,2),(1814,357127209,1),(1814,372848410,2),(1814,388576810,1),(1814,404902811,2),(1814,420026411,1),(1814,436352412,2),(1814,452080812,1),(1814,467802012,2),(1814,483530412,1),(1814,499251613,2),(1814,514980013,1),(1814,530701213,2),(1814,544615213,1),(1814,562150813,2),(1814,576064814,1),(1814,594205214,2),(1814,607514414,1),(1814,625654814,2),(1814,638964015,1),(1814,657104415,2),(1814,671018416,1),(1814,688554016,2),(1814,702468016,1),(1814,720003617,2),(1814,733917617,1),(1814,752058018,2),(1814,765367218,1),(1814,783507619,2),(1814,796816819,1),(1814,814957219,2),(1814,828871220,1),(1814,846406820,2),(1814,860320820,1),(1814,877856421,2),(1814,891770421,1),(1814,909306021,2),(1814,923220022,1),(1814,941360422,2),(1814,954669622,1),(1814,972810022,2),(1814,986119222,1),(1814,1004259622,2),(1814,1018173622,1),(1814,1035709222,2),(1814,1049623222,1),(1814,1067158822,2),(1814,1081072822,1),(1814,1099213222,2),(1814,1112522422,1),(1814,1130662822,2),(1814,1143972023,1),(1814,1162112423,2),(1814,1173607223,1),(1814,1194166823,2),(1814,1205056823,1),(1814,1225616423,2),(1814,1236506424,1),(1814,1257066024,2),(1814,1268560824,1),(1814,1289120424,2),(1814,1300010424,1),(1814,1320570024,2),(1814,1331460024,1),(1814,1352019625,2),(1814,1362909625,1),(1814,1383469225,2),(1814,1394359225,1),(1814,1414918825,2),(1814,1425808825,1),(1814,1446368426,2),(1814,1457863226,1),(1814,1478422826,2),(1814,1489312827,1),(1814,1509872427,2),(1814,1520762427,1),(1814,1541322027,2),(1814,1552212027,1),(1814,1572771627,2),(1814,1583661627,1),(1814,1604221227,2),(1814,1615716027,1),(1814,1636275627,2),(1814,1647165627,1),(1814,1667725227,2),(1814,1678615227,1),(1814,1699174827,2),(1814,1710064827,1),(1814,1730624427,2),(1814,1741514427,1),(1814,1762074027,2),(1814,1772964027,1),(1814,1793523627,2),(1814,1805018427,1),(1814,1825578027,2),(1814,1836468027,1),(1814,1857027627,2),(1814,1867917627,1),(1814,1888477227,2),(1814,1899367227,1),(1814,1919926827,2),(1814,1930816827,1),(1814,1951376427,2),(1814,1962871227,1),(1814,1983430827,2),(1814,1994320827,1),(1814,2014880427,2),(1814,2025770427,1),(1814,2046330027,2),(1814,2057220027,1),(1814,2077779627,2),(1814,2088669627,1),(1814,2109229227,2),(1814,2120119227,1),(1814,2140678827,2),(1815,-2147483648,1),(1815,-1861879032,2),(1818,-2147483648,1),(1818,-1688265017,3),(1818,-1656819079,2),(1818,-1641353479,3),(1818,-1627965079,4),(1818,-1618716679,2),(1818,-1596429079,4),(1818,-1593820800,5),(1818,-1589860800,6),(1818,-1542427200,7),(1818,-1539493200,8),(1818,-1525323600,7),(1818,-1522728000,6),(1818,-1491188400,9),(1818,-1247536800,6),(1818,354920409,7),(1818,370728010,6),(1818,386456410,7),(1818,402264011,6),(1818,417992411,7),(1818,433800012,6),(1818,449614812,7),(1818,465346812,10),(1818,481071612,11),(1818,496796413,10),(1818,512521213,11),(1818,528246013,10),(1818,543970813,11),(1818,559695613,10),(1818,575420414,11),(1818,591145214,10),(1818,606870014,11),(1818,622594814,10),(1818,638319615,11),(1818,654649215,10),(1818,670374016,12),(1818,686102416,13),(1818,695779216,10),(1818,701823616,11),(1818,717548417,10),(1818,733273217,11),(1818,748998018,10),(1818,764722818,11),(1818,780447619,10),(1818,796172419,11),(1818,811897219,10),(1818,828226820,11),(1818,846370820,10),(1818,859676420,11),(1818,877820421,10),(1818,891126021,11),(1818,909270021,10),(1818,922575622,11),(1818,941324422,10),(1818,954025222,11),(1818,972774022,10),(1818,985474822,11),(1818,1004223622,10),(1818,1017529222,11),(1818,1035673222,10),(1818,1048978822,11),(1818,1067122822,10),(1818,1080428422,11),(1818,1099177222,10),(1818,1111878022,11),(1818,1130626822,10),(1818,1143327623,11),(1818,1162076423,10),(1818,1174777223,11),(1818,1193526023,10),(1818,1206831623,11),(1818,1224975623,10),(1818,1238281224,11),(1818,1256425224,10),(1818,1269730824,11),(1818,1288479624,10),(1818,1301180424,14),(1818,1414274425,10),(1819,228877206,0),(1819,243997206,1),(1819,260326807,0),(1819,276051607,1),(1819,291776408,0),(1819,307501208,1),(1819,323830809,0),(1819,338950809,1),(1819,354675609,0),(1819,370400410,1),(1819,386125210,0),(1819,401850011,1),(1819,417574811,0),(1819,433299612,1),(1819,449024412,0),(1819,465354012,1),(1819,481078812,0),(1819,496803613,1),(1819,512528413,0),(1819,528253213,1),(1819,543978013,0),(1819,559702813,1),(1819,575427614,0),(1819,591152414,1),(1819,606877214,0),(1819,622602014,1),(1819,638326815,0),(1819,654656415,1),(1819,670381216,0),(1819,686106016,1),(1819,701830816,0),(1819,717555617,1),(1819,733280417,0),(1819,749005218,1),(1819,764730018,0),(1819,780454819,1),(1819,796179619,0),(1819,811904419,1),(1819,828234020,0),(1819,846378020,1),(1819,859683620,0),(1819,877827621,1),(1819,891133221,0),(1819,909277221,1),(1819,922582822,0),(1819,941331622,1),(1819,954032422,0),(1819,972781222,1),(1819,985482022,0),(1819,1004230822,1),(1819,1017536422,0),(1819,1035680422,1),(1819,1048986022,0),(1819,1067130022,1),(1819,1080435622,0),(1819,1099184422,1),(1819,1111885222,0),(1819,1130634022,1),(1819,1143334823,0),(1819,1162083623,1),(1819,1174784423,0),(1819,1193533223,1),(1819,1206838823,0),(1819,1224982823,1),(1819,1238288424,0),(1819,1256432424,1),(1819,1269738024,0),(1819,1288486824,1),(1819,1301187624,0),(1819,1319936424,1),(1819,1332637224,0),(1819,1351386025,1),(1819,1364691625,0),(1819,1382835625,1),(1819,1396141225,0),(1819,1414285225,1),(1819,1427590825,0),(1819,1445734826,1),(1819,1459040426,0),(1819,1477789226,1),(1819,1490490027,0),(1819,1509238827,1),(1819,1521939627,0),(1819,1540688427,1),(1819,1553994027,0),(1819,1572138027,1),(1819,1585443627,0),(1819,1603587627,1),(1819,1616893227,0),(1819,1635642027,1),(1819,1648342827,0),(1819,1667091627,1),(1819,1679792427,0),(1819,1698541227,1),(1819,1711846827,0),(1819,1729990827,1),(1819,1743296427,0),(1819,1761440427,1),(1819,1774746027,0),(1819,1792890027,1),(1819,1806195627,0),(1819,1824944427,1),(1819,1837645227,0),(1819,1856394027,1),(1819,1869094827,0),(1819,1887843627,1),(1819,1901149227,0),(1819,1919293227,1),(1819,1932598827,0),(1819,1950742827,1),(1819,1964048427,0),(1819,1982797227,1),(1819,1995498027,0),(1819,2014246827,1),(1819,2026947627,0),(1819,2045696427,1),(1819,2058397227,0),(1819,2077146027,1),(1819,2090451627,0),(1819,2108595627,1),(1819,2121901227,0),(1819,2140045227,1);
/*!40000 ALTER TABLE `time_zone_transition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition_type`
--

DROP TABLE IF EXISTS `time_zone_transition_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_transition_type` (
  `Time_zone_id` int(10) unsigned NOT NULL,
  `Transition_type_id` int(10) unsigned NOT NULL,
  `Offset` int(11) NOT NULL DEFAULT 0,
  `Is_DST` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `Abbreviation` char(8) NOT NULL DEFAULT '',
  PRIMARY KEY (`Time_zone_id`,`Transition_type_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone transition types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition_type`
--

LOCK TABLES `time_zone_transition_type` WRITE;
/*!40000 ALTER TABLE `time_zone_transition_type` DISABLE KEYS */;
INSERT INTO `time_zone_transition_type` VALUES (1,0,-968,0,'LMT'),(1,1,0,0,'GMT'),(2,0,-52,0,'LMT'),(2,1,1200,1,'+0020'),(2,2,0,0,'GMT'),(3,0,8836,0,'LMT'),(3,1,10800,0,'EAT'),(3,2,9000,0,'+0230'),(3,3,9900,0,'+0245'),(3,4,10800,0,'EAT'),(4,0,732,0,'LMT'),(4,1,561,0,'PMT'),(4,2,3600,1,'WEST'),(4,3,0,0,'WET'),(4,4,0,0,'WET'),(4,5,7200,1,'CEST'),(4,6,3600,0,'CET'),(4,7,3600,1,'WEST'),(5,0,8836,0,'LMT'),(5,1,10800,0,'EAT'),(5,2,9000,0,'+0230'),(5,3,9900,0,'+0245'),(5,4,10800,0,'EAT'),(6,0,8836,0,'LMT'),(6,1,10800,0,'EAT'),(6,2,9000,0,'+0230'),(6,3,9900,0,'+0245'),(6,4,10800,0,'EAT'),(7,0,-968,0,'LMT'),(7,1,0,0,'GMT'),(8,0,816,0,'LMT'),(8,1,3600,0,'WAT'),(9,0,-968,0,'LMT'),(9,1,0,0,'GMT'),(10,0,-3740,0,'LMT'),(10,1,-3600,0,'-01'),(10,2,0,0,'GMT'),(11,0,7820,0,'LMT'),(11,1,7200,0,'CAT'),(12,0,816,0,'LMT'),(12,1,3600,0,'WAT'),(13,0,7820,0,'LMT'),(13,1,7200,0,'CAT'),(14,0,7509,0,'LMT'),(14,1,10800,1,'EEST'),(14,2,7200,0,'EET'),(14,3,10800,1,'EEST'),(15,0,-1820,0,'LMT'),(15,1,3600,1,'+01'),(15,2,0,0,'+00'),(15,3,3600,0,'+01'),(15,4,0,1,'+00'),(16,0,-1276,0,'LMT'),(16,1,0,0,'WET'),(16,2,3600,1,'WEST'),(16,3,0,0,'WET'),(16,4,3600,0,'CET'),(16,5,7200,1,'CEST'),(16,6,3600,0,'CET'),(17,0,-968,0,'LMT'),(17,1,0,0,'GMT'),(18,0,-968,0,'LMT'),(18,1,0,0,'GMT'),(19,0,8836,0,'LMT'),(19,1,10800,0,'EAT'),(19,2,9000,0,'+0230'),(19,3,9900,0,'+0245'),(19,4,10800,0,'EAT'),(20,0,8836,0,'LMT'),(20,1,10800,0,'EAT'),(20,2,9000,0,'+0230'),(20,3,9900,0,'+0245'),(20,4,10800,0,'EAT'),(21,0,816,0,'LMT'),(21,1,3600,0,'WAT'),(22,0,-3168,0,'LMT'),(22,1,-3600,0,'-01'),(22,2,3600,1,'+01'),(22,3,0,0,'+00'),(22,4,0,1,'+00'),(22,5,3600,0,'+01'),(23,0,-968,0,'LMT'),(23,1,0,0,'GMT'),(24,0,7820,0,'LMT'),(24,1,7200,0,'CAT'),(25,0,7820,0,'LMT'),(25,1,7200,0,'CAT'),(26,0,6720,0,'LMT'),(26,1,5400,0,'SAST'),(26,2,10800,1,'SAST'),(26,3,7200,0,'SAST'),(27,0,7588,0,'LMT'),(27,1,10800,1,'CAST'),(27,2,7200,0,'CAT'),(27,3,10800,0,'EAT'),(28,0,8836,0,'LMT'),(28,1,10800,0,'EAT'),(28,2,9000,0,'+0230'),(28,3,9900,0,'+0245'),(28,4,10800,0,'EAT'),(29,0,7808,0,'LMT'),(29,1,10800,1,'CAST'),(29,2,7200,0,'CAT'),(29,3,10800,0,'EAT'),(29,4,7200,0,'CAT'),(30,0,7820,0,'LMT'),(30,1,7200,0,'CAT'),(31,0,816,0,'LMT'),(31,1,3600,0,'WAT'),(32,0,816,0,'LMT'),(32,1,3600,0,'WAT'),(33,0,816,0,'LMT'),(33,1,3600,0,'WAT'),(34,0,-968,0,'LMT'),(34,1,0,0,'GMT'),(35,0,816,0,'LMT'),(35,1,3600,0,'WAT'),(36,0,7820,0,'LMT'),(36,1,7200,0,'CAT'),(37,0,7820,0,'LMT'),(37,1,7200,0,'CAT'),(38,0,816,0,'LMT'),(38,1,3600,0,'WAT'),(39,0,7820,0,'LMT'),(39,1,7200,0,'CAT'),(40,0,6720,0,'LMT'),(40,1,5400,0,'SAST'),(40,2,10800,1,'SAST'),(40,3,7200,0,'SAST'),(41,0,6720,0,'LMT'),(41,1,5400,0,'SAST'),(41,2,10800,1,'SAST'),(41,3,7200,0,'SAST'),(42,0,8836,0,'LMT'),(42,1,10800,0,'EAT'),(42,2,9000,0,'+0230'),(42,3,9900,0,'+0245'),(42,4,10800,0,'EAT'),(43,0,-2588,0,'LMT'),(43,1,-2588,0,'MMT'),(43,2,-2670,0,'MMT'),(43,3,0,0,'GMT'),(44,0,8836,0,'LMT'),(44,1,10800,0,'EAT'),(44,2,9000,0,'+0230'),(44,3,9900,0,'+0245'),(44,4,10800,0,'EAT'),(45,0,3612,0,'LMT'),(45,1,3600,0,'WAT'),(45,2,7200,1,'WAST'),(46,0,816,0,'LMT'),(46,1,3600,0,'WAT'),(47,0,-968,0,'LMT'),(47,1,0,0,'GMT'),(48,0,-968,0,'LMT'),(48,1,0,0,'GMT'),(49,0,816,0,'LMT'),(49,1,3600,0,'WAT'),(50,0,1616,0,'LMT'),(50,1,-2205,0,'LMT'),(50,2,0,0,'GMT'),(50,3,3600,0,'WAT'),(50,4,0,0,'GMT'),(51,0,-968,0,'LMT'),(51,1,0,0,'GMT'),(52,0,3164,0,'LMT'),(52,1,7200,1,'CEST'),(52,2,3600,0,'CET'),(52,3,7200,0,'EET'),(53,0,2444,0,'LMT'),(53,1,561,0,'PMT'),(53,2,7200,1,'CEST'),(53,3,3600,0,'CET'),(53,4,3600,0,'CET'),(53,5,7200,1,'CEST'),(54,0,4104,0,'LMT'),(54,1,5400,0,'+0130'),(54,2,7200,0,'SAST'),(54,3,10800,1,'SAST'),(54,4,3600,1,'WAT'),(54,5,7200,0,'CAT'),(55,0,-42398,0,'LMT'),(55,1,-39600,0,'NST'),(55,2,-36000,1,'NWT'),(55,3,-36000,1,'NPT'),(55,4,-39600,0,'BST'),(55,5,-36000,1,'BDT'),(55,6,-36000,0,'AHST'),(55,7,-32400,1,'HDT'),(55,8,-36000,0,'HST'),(56,0,-35976,0,'LMT'),(56,1,-36000,0,'AST'),(56,2,-32400,1,'AWT'),(56,3,-32400,1,'APT'),(56,4,-36000,0,'AHST'),(56,5,-32400,1,'AHDT'),(56,6,-32400,0,'YST'),(56,7,-28800,1,'AKDT'),(56,8,-32400,0,'AKST'),(57,0,-14764,0,'LMT'),(57,1,-14400,0,'AST'),(58,0,-14764,0,'LMT'),(58,1,-14400,0,'AST'),(59,0,-11568,0,'LMT'),(59,1,-7200,1,'-02'),(59,2,-10800,0,'-03'),(60,0,-14028,0,'LMT'),(60,1,-15408,0,'CMT'),(60,2,-14400,0,'-04'),(60,3,-10800,1,'-03'),(60,4,-7200,1,'-02'),(60,5,-10800,0,'-03'),(61,0,-15788,0,'LMT'),(61,1,-15408,0,'CMT'),(61,2,-14400,0,'-04'),(61,3,-10800,1,'-03'),(61,4,-7200,1,'-02'),(61,5,-10800,0,'-03'),(62,0,-15788,0,'LMT'),(62,1,-15408,0,'CMT'),(62,2,-14400,0,'-04'),(62,3,-10800,1,'-03'),(62,4,-7200,1,'-02'),(62,5,-10800,0,'-03'),(63,0,-15408,0,'LMT'),(63,1,-15408,0,'CMT'),(63,2,-14400,0,'-04'),(63,3,-10800,1,'-03'),(63,4,-7200,1,'-02'),(63,5,-10800,0,'-03'),(64,0,-15672,0,'LMT'),(64,1,-15408,0,'CMT'),(64,2,-14400,0,'-04'),(64,3,-10800,1,'-03'),(64,4,-7200,1,'-02'),(64,5,-10800,0,'-03'),(65,0,-16044,0,'LMT'),(65,1,-15408,0,'CMT'),(65,2,-14400,0,'-04'),(65,3,-10800,1,'-03'),(65,4,-7200,1,'-02'),(65,5,-10800,0,'-03'),(66,0,-16516,0,'LMT'),(66,1,-15408,0,'CMT'),(66,2,-14400,0,'-04'),(66,3,-10800,1,'-03'),(66,4,-7200,1,'-02'),(66,5,-10800,0,'-03'),(67,0,-16612,0,'LMT'),(67,1,-15408,0,'CMT'),(67,2,-14400,0,'-04'),(67,3,-10800,1,'-03'),(67,4,-7200,1,'-02'),(67,5,-10800,0,'-03'),(68,0,-15700,0,'LMT'),(68,1,-15408,0,'CMT'),(68,2,-14400,0,'-04'),(68,3,-10800,1,'-03'),(68,4,-7200,1,'-02'),(68,5,-10800,0,'-03'),(69,0,-16444,0,'LMT'),(69,1,-15408,0,'CMT'),(69,2,-14400,0,'-04'),(69,3,-10800,1,'-03'),(69,4,-7200,1,'-02'),(69,5,-10800,0,'-03'),(70,0,-15924,0,'LMT'),(70,1,-15408,0,'CMT'),(70,2,-14400,0,'-04'),(70,3,-10800,1,'-03'),(70,4,-7200,1,'-02'),(70,5,-10800,0,'-03'),(70,6,-10800,1,'-03'),(71,0,-15652,0,'LMT'),(71,1,-15408,0,'CMT'),(71,2,-14400,0,'-04'),(71,3,-10800,1,'-03'),(71,4,-7200,1,'-02'),(71,5,-10800,0,'-03'),(72,0,-16392,0,'LMT'),(72,1,-15408,0,'CMT'),(72,2,-14400,0,'-04'),(72,3,-10800,1,'-03'),(72,4,-7200,1,'-02'),(72,5,-10800,0,'-03'),(73,0,-16547,0,'LMT'),(73,1,-16200,0,'-0430'),(73,2,-14400,0,'AST'),(74,0,-13840,0,'LMT'),(74,1,-13840,0,'AMT'),(74,2,-14400,0,'-04'),(74,3,-10800,0,'-03'),(74,4,-10800,1,'-03'),(74,5,-14400,0,'-04'),(75,0,-21988,0,'LMT'),(75,1,-18000,1,'CDT'),(75,2,-21600,0,'CST'),(75,3,-18000,1,'CWT'),(75,4,-18000,1,'CPT'),(75,5,-18000,0,'EST'),(76,0,-42398,0,'LMT'),(76,1,-39600,0,'NST'),(76,2,-36000,1,'NWT'),(76,3,-36000,1,'NPT'),(76,4,-39600,0,'BST'),(76,5,-36000,1,'BDT'),(76,6,-36000,0,'AHST'),(76,7,-32400,1,'HDT'),(76,8,-36000,0,'HST'),(77,0,-9244,0,'LMT'),(77,1,-7200,1,'-02'),(77,2,-10800,0,'-03'),(78,0,-25260,0,'LMT'),(78,1,-25200,0,'MST'),(78,2,-21600,0,'CST'),(78,3,-28800,0,'PST'),(78,4,-21600,1,'MDT'),(78,5,-18000,1,'CDT'),(78,6,-21600,0,'CST'),(79,0,-14309,0,'LMT'),(79,1,-14309,0,'BMT'),(79,2,-10800,1,'ADT'),(79,3,-14400,0,'AST'),(80,0,-11636,0,'LMT'),(80,1,-7200,1,'-02'),(80,2,-10800,0,'-03'),(81,0,-21168,0,'LMT'),(81,1,-19800,1,'-0530'),(81,2,-21600,0,'CST'),(81,3,-18000,1,'CDT'),(82,0,-13708,0,'LMT'),(82,1,-10800,1,'ADT'),(82,2,-14400,0,'AST'),(82,3,-10800,1,'AWT'),(82,4,-10800,1,'APT'),(83,0,-14560,0,'LMT'),(83,1,-10800,1,'-03'),(83,2,-14400,0,'-04'),(84,0,-17776,0,'LMT'),(84,1,-17776,0,'BMT'),(84,2,-14400,1,'-04'),(84,3,-18000,0,'-05'),(85,0,-27889,0,'LMT'),(85,1,-25200,1,'PDT'),(85,2,-28800,0,'PST'),(85,3,-21600,1,'MWT'),(85,4,-21600,1,'MPT'),(85,5,-25200,0,'MST'),(85,6,-21600,1,'MDT'),(86,0,-14028,0,'LMT'),(86,1,-15408,0,'CMT'),(86,2,-14400,0,'-04'),(86,3,-10800,1,'-03'),(86,4,-7200,1,'-02'),(86,5,-10800,0,'-03'),(87,0,0,0,'-00'),(87,1,-21600,1,'MWT'),(87,2,-21600,1,'MPT'),(87,3,-25200,0,'MST'),(87,4,-18000,1,'MDDT'),(87,5,-21600,1,'MDT'),(87,6,-18000,1,'CDT'),(87,7,-21600,0,'CST'),(87,8,-18000,0,'EST'),(87,9,-21600,1,'MDT'),(87,10,-25200,0,'MST'),(88,0,-13108,0,'LMT'),(88,1,-10800,1,'-03'),(88,2,-14400,0,'-04'),(89,0,-20824,0,'LMT'),(89,1,-21600,0,'CST'),(89,2,-14400,1,'EDT'),(89,3,-18000,0,'EST'),(89,4,-18000,1,'CDT'),(90,0,-16064,0,'LMT'),(90,1,-16060,0,'CMT'),(90,2,-16200,0,'-0430'),(90,3,-14400,0,'-04'),(91,0,-15788,0,'LMT'),(91,1,-15408,0,'CMT'),(91,2,-14400,0,'-04'),(91,3,-10800,1,'-03'),(91,4,-7200,1,'-02'),(91,5,-10800,0,'-03'),(92,0,-12560,0,'LMT'),(92,1,-14400,0,'-04'),(92,2,-10800,0,'-03'),(93,0,-19088,0,'LMT'),(93,1,-19176,0,'CMT'),(93,2,-18000,0,'EST'),(94,0,-21036,0,'LMT'),(94,1,-18000,1,'CDT'),(94,2,-21600,0,'CST'),(94,3,-18000,0,'EST'),(94,4,-18000,1,'CWT'),(94,5,-18000,1,'CPT'),(94,6,-21600,0,'CST'),(95,0,-25460,0,'LMT'),(95,1,-25200,0,'MST'),(95,2,-21600,0,'CST'),(95,3,-18000,1,'CDT'),(95,4,-21600,1,'MDT'),(95,5,-25200,0,'MST'),(96,0,-21988,0,'LMT'),(96,1,-18000,1,'CDT'),(96,2,-21600,0,'CST'),(96,3,-18000,1,'CWT'),(96,4,-18000,1,'CPT'),(96,5,-18000,0,'EST'),(97,0,-15408,0,'LMT'),(97,1,-15408,0,'CMT'),(97,2,-14400,0,'-04'),(97,3,-10800,1,'-03'),(97,4,-7200,1,'-02'),(97,5,-10800,0,'-03'),(98,0,-20173,0,'LMT'),(98,1,-20173,0,'SJMT'),(98,2,-18000,1,'CDT'),(98,3,-21600,0,'CST'),(99,0,-27964,0,'LMT'),(99,1,-25200,0,'MST'),(99,2,-28800,0,'PST'),(99,3,-25200,0,'MST'),(100,0,-13460,0,'LMT'),(100,1,-10800,1,'-03'),(100,2,-14400,0,'-04'),(101,0,-16547,0,'LMT'),(101,1,-16200,0,'-0430'),(101,2,-14400,0,'AST'),(102,0,-4480,0,'LMT'),(102,1,-10800,0,'-03'),(102,2,-10800,0,'-03'),(102,3,-7200,1,'-02'),(102,4,-7200,1,'-02'),(102,5,0,0,'GMT'),(103,0,-33460,0,'LMT'),(103,1,-28800,1,'YDT'),(103,2,-32400,0,'YST'),(103,3,-28800,1,'YWT'),(103,4,-28800,1,'YPT'),(103,5,-25200,1,'YDDT'),(103,6,-28800,0,'PST'),(103,7,-25200,1,'PDT'),(104,0,-28856,0,'LMT'),(104,1,-25200,1,'PDT'),(104,2,-28800,0,'PST'),(104,3,-25200,1,'PWT'),(104,4,-25200,1,'PPT'),(104,5,-25200,0,'MST'),(105,0,-25196,0,'LMT'),(105,1,-21600,1,'MDT'),(105,2,-25200,0,'MST'),(105,3,-21600,1,'MWT'),(105,4,-21600,1,'MPT'),(106,0,-19931,0,'LMT'),(106,1,-21600,0,'CST'),(106,2,-18000,0,'EST'),(106,3,-14400,1,'EWT'),(106,4,-14400,1,'EPT'),(106,5,-14400,1,'EDT'),(107,0,-14764,0,'LMT'),(107,1,-14400,0,'AST'),(108,0,-27232,0,'LMT'),(108,1,-21600,1,'MDT'),(108,2,-25200,0,'MST'),(108,3,-21600,1,'MWT'),(108,4,-21600,1,'MPT'),(109,0,-16768,0,'LMT'),(109,1,-14400,1,'-04'),(109,2,-18000,0,'-05'),(109,3,-14400,0,'-04'),(109,4,-18000,0,'-05'),(110,0,-21408,0,'LMT'),(110,1,-18000,1,'CDT'),(110,2,-21600,0,'CST'),(111,0,-28084,0,'LMT'),(111,1,-25200,0,'MST'),(111,2,-28800,0,'PST'),(111,3,-25200,1,'PDT'),(111,4,-25200,1,'PWT'),(111,5,-25200,1,'PPT'),(112,0,-29447,0,'LMT'),(112,1,-25200,1,'PDT'),(112,2,-28800,0,'PST'),(112,3,-25200,1,'PWT'),(112,4,-25200,1,'PPT'),(112,5,-25200,0,'MST'),(113,0,-20678,0,'LMT'),(113,1,-18000,1,'CDT'),(113,2,-21600,0,'CST'),(113,3,-18000,1,'CWT'),(113,4,-18000,1,'CPT'),(113,5,-18000,0,'EST'),(113,6,-14400,1,'EDT'),(114,0,-9240,0,'LMT'),(114,1,-7200,1,'-02'),(114,2,-10800,0,'-03'),(115,0,-14388,0,'LMT'),(115,1,-10800,1,'ADT'),(115,2,-14400,0,'AST'),(115,3,-10800,1,'AWT'),(115,4,-10800,1,'APT'),(116,0,-12416,0,'LMT'),(116,1,-10800,0,'-03'),(116,2,-10800,0,'-03'),(116,3,-7200,1,'-02'),(116,4,-7200,1,'-02'),(117,0,-14500,0,'LMT'),(117,1,-12652,0,'NST'),(117,2,-9052,1,'NDT'),(117,3,-12600,0,'NST'),(117,4,-9000,1,'NDT'),(117,5,-9000,1,'NPT'),(117,6,-9000,1,'NWT'),(117,7,-10800,1,'ADT'),(117,8,-14400,0,'AST'),(117,9,-7200,1,'ADDT'),(117,10,-10800,1,'ADT'),(118,0,-17072,0,'LMT'),(118,1,-18430,0,'KMT'),(118,2,-18000,0,'EST'),(118,3,-14400,1,'EDT'),(118,4,-14400,0,'AST'),(118,5,-18000,0,'EST'),(119,0,-14764,0,'LMT'),(119,1,-14400,0,'AST'),(120,0,-14764,0,'LMT'),(120,1,-14400,0,'AST'),(121,0,-21724,0,'LMT'),(121,1,-18000,1,'CDT'),(121,2,-21600,0,'CST'),(122,0,-19160,0,'LMT'),(122,1,-18840,0,'QMT'),(122,2,-14400,1,'-04'),(122,3,-18000,0,'-05'),(123,0,-13960,0,'LMT'),(123,1,-13500,0,'-0345'),(123,2,-10800,0,'-03'),(123,3,-14400,0,'-04'),(124,0,-15264,0,'LMT'),(124,1,-10800,1,'ADT'),(124,2,-14400,0,'AST'),(124,3,-10800,1,'AWT'),(124,4,-10800,1,'APT'),(125,0,-19768,0,'LMT'),(125,1,-19776,0,'HMT'),(125,2,-14400,1,'CDT'),(125,3,-18000,0,'CST'),(125,4,-18000,0,'CST'),(125,5,-14400,1,'CDT'),(126,0,-26632,0,'LMT'),(126,1,-25200,0,'MST'),(126,2,-21600,0,'CST'),(126,3,-28800,0,'PST'),(126,4,-21600,1,'MDT'),(126,5,-25200,0,'MST'),(127,0,-20678,0,'LMT'),(127,1,-18000,1,'CDT'),(127,2,-21600,0,'CST'),(127,3,-18000,1,'CWT'),(127,4,-18000,1,'CPT'),(127,5,-18000,0,'EST'),(127,6,-14400,1,'EDT'),(128,0,-20790,0,'LMT'),(128,1,-18000,1,'CDT'),(128,2,-21600,0,'CST'),(128,3,-18000,1,'CWT'),(128,4,-18000,1,'CPT'),(128,5,-18000,0,'EST'),(128,6,-21600,0,'CST'),(129,0,-20723,0,'LMT'),(129,1,-18000,1,'CDT'),(129,2,-21600,0,'CST'),(129,3,-18000,1,'CWT'),(129,4,-18000,1,'CPT'),(129,5,-18000,0,'EST'),(129,6,-14400,1,'EDT'),(130,0,-20947,0,'LMT'),(130,1,-18000,1,'CDT'),(130,2,-21600,0,'CST'),(130,3,-18000,1,'CWT'),(130,4,-18000,1,'CPT'),(130,5,-18000,0,'EST'),(130,6,-14400,1,'EDT'),(131,0,-20823,0,'LMT'),(131,1,-18000,1,'CDT'),(131,2,-21600,0,'CST'),(131,3,-18000,1,'CWT'),(131,4,-18000,1,'CPT'),(131,5,-18000,0,'EST'),(131,6,-14400,1,'EDT'),(131,7,-18000,1,'CDT'),(131,8,-21600,0,'CST'),(132,0,-20416,0,'LMT'),(132,1,-18000,1,'CDT'),(132,2,-21600,0,'CST'),(132,3,-18000,1,'CWT'),(132,4,-18000,1,'CPT'),(132,5,-18000,0,'EST'),(132,6,-14400,1,'EDT'),(133,0,-21007,0,'LMT'),(133,1,-18000,1,'CDT'),(133,2,-21600,0,'CST'),(133,3,-18000,1,'CWT'),(133,4,-18000,1,'CPT'),(133,5,-18000,0,'EST'),(133,6,-14400,1,'EDT'),(134,0,-20785,0,'LMT'),(134,1,-18000,1,'CDT'),(134,2,-21600,0,'CST'),(134,3,-18000,1,'CWT'),(134,4,-18000,1,'CPT'),(134,5,-18000,0,'EST'),(134,6,-14400,1,'EDT'),(135,0,-20678,0,'LMT'),(135,1,-18000,1,'CDT'),(135,2,-21600,0,'CST'),(135,3,-18000,1,'CWT'),(135,4,-18000,1,'CPT'),(135,5,-18000,0,'EST'),(135,6,-14400,1,'EDT'),(136,0,0,0,'-00'),(136,1,-21600,1,'PDDT'),(136,2,-28800,0,'PST'),(136,3,-25200,0,'MST'),(136,4,-21600,1,'MDT'),(137,0,0,0,'-00'),(137,1,-14400,1,'EPT'),(137,2,-18000,0,'EST'),(137,3,-10800,1,'EDDT'),(137,4,-14400,1,'EDT'),(137,5,-14400,1,'EWT'),(137,6,-21600,0,'CST'),(137,7,-18000,1,'CDT'),(137,8,-14400,1,'EDT'),(137,9,-18000,0,'EST'),(138,0,-18430,0,'LMT'),(138,1,-18430,0,'KMT'),(138,2,-18000,0,'EST'),(138,3,-14400,1,'EDT'),(139,0,-15672,0,'LMT'),(139,1,-15408,0,'CMT'),(139,2,-14400,0,'-04'),(139,3,-10800,1,'-03'),(139,4,-7200,1,'-02'),(139,5,-10800,0,'-03'),(140,0,-32261,0,'LMT'),(140,1,-28800,0,'PST'),(140,2,-25200,1,'PWT'),(140,3,-25200,1,'PPT'),(140,4,-25200,1,'PDT'),(140,5,-28800,1,'YDT'),(140,6,-32400,0,'YST'),(140,7,-28800,1,'AKDT'),(140,8,-32400,0,'AKST'),(141,0,-20582,0,'LMT'),(141,1,-18000,1,'CDT'),(141,2,-21600,0,'CST'),(141,3,-18000,1,'CWT'),(141,4,-18000,1,'CPT'),(141,5,-18000,0,'EST'),(141,6,-14400,1,'EDT'),(142,0,-20364,0,'LMT'),(142,1,-18000,1,'CDT'),(142,2,-21600,0,'CST'),(142,3,-18000,1,'CWT'),(142,4,-18000,1,'CPT'),(142,5,-14400,1,'EDT'),(142,6,-18000,0,'EST'),(143,0,-20790,0,'LMT'),(143,1,-18000,1,'CDT'),(143,2,-21600,0,'CST'),(143,3,-18000,1,'CWT'),(143,4,-18000,1,'CPT'),(143,5,-18000,0,'EST'),(143,6,-21600,0,'CST'),(144,0,-16547,0,'LMT'),(144,1,-16200,0,'-0430'),(144,2,-14400,0,'AST'),(145,0,-16356,0,'LMT'),(145,1,-16356,0,'CMT'),(145,2,-12756,1,'BST'),(145,3,-14400,0,'-04'),(146,0,-18492,0,'LMT'),(146,1,-18516,0,'LMT'),(146,2,-14400,1,'-04'),(146,3,-18000,0,'-05'),(147,0,-28378,0,'LMT'),(147,1,-25200,1,'PDT'),(147,2,-28800,0,'PST'),(147,3,-25200,1,'PWT'),(147,4,-25200,1,'PPT'),(148,0,-20582,0,'LMT'),(148,1,-18000,1,'CDT'),(148,2,-21600,0,'CST'),(148,3,-18000,1,'CWT'),(148,4,-18000,1,'CPT'),(148,5,-18000,0,'EST'),(148,6,-14400,1,'EDT'),(149,0,-16547,0,'LMT'),(149,1,-16200,0,'-0430'),(149,2,-14400,0,'AST'),(150,0,-8572,0,'LMT'),(150,1,-7200,1,'-02'),(150,2,-10800,0,'-03'),(151,0,-20708,0,'LMT'),(151,1,-20712,0,'MMT'),(151,2,-21600,0,'CST'),(151,3,-18000,0,'EST'),(151,4,-18000,1,'CDT'),(151,5,-21600,0,'CST'),(152,0,-14404,0,'LMT'),(152,1,-10800,1,'-03'),(152,2,-14400,0,'-04'),(153,0,-14764,0,'LMT'),(153,1,-14400,0,'AST'),(154,0,-14660,0,'LMT'),(154,1,-14660,0,'FFMT'),(154,2,-14400,0,'AST'),(154,3,-10800,1,'ADT'),(155,0,-24000,0,'LMT'),(155,1,-21600,0,'CST'),(155,2,-18000,1,'CDT'),(156,0,-25540,0,'LMT'),(156,1,-25200,0,'MST'),(156,2,-21600,0,'CST'),(156,3,-28800,0,'PST'),(156,4,-21600,1,'MDT'),(156,5,-25200,0,'MST'),(157,0,-16516,0,'LMT'),(157,1,-15408,0,'CMT'),(157,2,-14400,0,'-04'),(157,3,-10800,1,'-03'),(157,4,-7200,1,'-02'),(157,5,-10800,0,'-03'),(158,0,-21027,0,'LMT'),(158,1,-18000,1,'CDT'),(158,2,-21600,0,'CST'),(158,3,-18000,1,'CWT'),(158,4,-18000,1,'CPT'),(158,5,-18000,0,'EST'),(158,6,-21600,0,'CST'),(159,0,-21508,0,'LMT'),(159,1,-21600,0,'CST'),(159,2,-18000,0,'EST'),(159,3,-18000,1,'CDT'),(159,4,-21600,0,'CST'),(160,0,-31578,0,'LMT'),(160,1,-28800,0,'PST'),(160,2,-25200,1,'PWT'),(160,3,-25200,1,'PPT'),(160,4,-25200,1,'PDT'),(160,5,-32400,0,'AKST'),(160,6,-28800,1,'AKDT'),(161,0,-23796,0,'LMT'),(161,1,-25200,0,'MST'),(161,2,-21600,0,'CST'),(161,3,-18000,1,'CDT'),(161,4,-18000,1,'CWT'),(162,0,-13480,0,'LMT'),(162,1,-14400,0,'AST'),(162,2,-10800,0,'-03'),(162,3,-7200,1,'-02'),(163,0,-15548,0,'LMT'),(163,1,-18000,0,'EST'),(163,2,-10800,1,'ADT'),(163,3,-14400,0,'AST'),(163,4,-10800,1,'AWT'),(163,5,-10800,1,'APT'),(164,0,-24076,0,'LMT'),(164,1,-21600,0,'CST'),(164,2,-18000,1,'CDT'),(165,0,-13491,0,'LMT'),(165,1,-13491,0,'MMT'),(165,2,-14400,0,'-04'),(165,3,-12600,0,'-0330'),(165,4,-10800,1,'-03'),(165,5,-10800,0,'-03'),(165,6,-9000,1,'-0230'),(165,7,-7200,1,'-02'),(165,8,-5400,1,'-0130'),(165,9,-7200,1,'-02'),(166,0,-19052,0,'LMT'),(166,1,-14400,1,'EDT'),(166,2,-18000,0,'EST'),(166,3,-14400,1,'EWT'),(166,4,-14400,1,'EPT'),(167,0,-14764,0,'LMT'),(167,1,-14400,0,'AST'),(168,0,-18570,0,'LMT'),(168,1,-14400,1,'EDT'),(168,2,-18000,0,'EST'),(169,0,-17762,0,'LMT'),(169,1,-14400,1,'EDT'),(169,2,-18000,0,'EST'),(169,3,-14400,1,'EWT'),(169,4,-14400,1,'EPT'),(170,0,-21184,0,'LMT'),(170,1,-14400,1,'EDT'),(170,2,-18000,0,'EST'),(170,3,-14400,1,'EWT'),(170,4,-14400,1,'EPT'),(171,0,-39698,0,'LMT'),(171,1,-39600,0,'NST'),(171,2,-36000,1,'NWT'),(171,3,-36000,1,'NPT'),(171,4,-39600,0,'BST'),(171,5,-36000,1,'BDT'),(171,6,-32400,0,'YST'),(171,7,-28800,1,'AKDT'),(171,8,-32400,0,'AKST'),(172,0,-7780,0,'LMT'),(172,1,-3600,1,'-01'),(172,2,-7200,0,'-02'),(173,0,-24427,0,'LMT'),(173,1,-21600,1,'MDT'),(173,2,-25200,0,'MST'),(173,3,-21600,1,'MWT'),(173,4,-21600,1,'MPT'),(173,5,-18000,1,'CDT'),(173,6,-21600,0,'CST'),(174,0,-24312,0,'LMT'),(174,1,-21600,1,'MDT'),(174,2,-25200,0,'MST'),(174,3,-21600,1,'MWT'),(174,4,-21600,1,'MPT'),(174,5,-18000,1,'CDT'),(174,6,-21600,0,'CST'),(175,0,-24339,0,'LMT'),(175,1,-21600,1,'MDT'),(175,2,-25200,0,'MST'),(175,3,-21600,1,'MWT'),(175,4,-21600,1,'MPT'),(175,5,-18000,1,'CDT'),(175,6,-21600,0,'CST'),(176,0,-25060,0,'LMT'),(176,1,-25200,0,'MST'),(176,2,-21600,0,'CST'),(176,3,-18000,1,'CDT'),(176,4,-21600,1,'MDT'),(176,5,-25200,0,'MST'),(177,0,-19088,0,'LMT'),(177,1,-19176,0,'CMT'),(177,2,-18000,0,'EST'),(178,0,0,0,'-00'),(178,1,-10800,1,'AWT'),(178,2,-10800,1,'APT'),(178,3,-14400,0,'AST'),(178,4,-7200,1,'ADDT'),(178,5,-10800,1,'ADT'),(178,6,-14400,1,'EDT'),(178,7,-18000,0,'EST'),(178,8,-21600,0,'CST'),(178,9,-18000,1,'CDT'),(178,10,-14400,1,'EDT'),(178,11,-18000,0,'EST'),(179,0,-13240,0,'LMT'),(179,1,-13252,0,'PMT'),(179,2,-13236,0,'PMT'),(179,3,-12600,0,'-0330'),(179,4,-10800,0,'-03'),(180,0,-26898,0,'LMT'),(180,1,-21600,1,'MDT'),(180,2,-25200,0,'MST'),(180,3,-21600,1,'MWT'),(181,0,-17360,0,'LMT'),(181,1,-17340,0,'PPMT'),(181,2,-14400,1,'EDT'),(181,3,-18000,0,'EST'),(181,4,-14400,1,'EDT'),(181,5,-18000,0,'EST'),(182,0,-14764,0,'LMT'),(182,1,-14400,0,'AST'),(183,0,-16272,0,'LMT'),(183,1,-14400,1,'-04'),(183,2,-18000,0,'-05'),(183,3,-14400,0,'-04'),(183,4,-18000,0,'-05'),(184,0,-15336,0,'LMT'),(184,1,-10800,1,'-03'),(184,2,-14400,0,'-04'),(185,0,-15865,0,'LMT'),(185,1,-14400,0,'AST'),(185,2,-10800,1,'APT'),(185,3,-10800,1,'AWT'),(186,0,-17020,0,'LMT'),(186,1,-16966,0,'SMT'),(186,2,-18000,0,'-05'),(186,3,-14400,0,'-04'),(186,4,-14400,1,'-04'),(186,5,-10800,1,'-03'),(186,6,-14400,0,'-04'),(186,7,-10800,0,'-03'),(187,0,-22696,0,'LMT'),(187,1,-18000,1,'CDT'),(187,2,-21600,0,'CST'),(187,3,-18000,1,'CWT'),(187,4,-18000,1,'CPT'),(188,0,0,0,'-00'),(188,1,-14400,1,'CDDT'),(188,2,-21600,0,'CST'),(188,3,-18000,1,'CDT'),(188,4,-18000,0,'EST'),(188,5,-21600,0,'CST'),(189,0,-8376,0,'LMT'),(189,1,-7200,1,'-02'),(189,2,-10800,0,'-03'),(190,0,-25116,0,'LMT'),(190,1,-21600,1,'MDT'),(190,2,-25200,0,'MST'),(190,3,-21600,1,'MWT'),(190,4,-21600,1,'MPT'),(190,5,-21600,0,'CST'),(191,0,0,0,'-00'),(191,1,-14400,1,'CDDT'),(191,2,-21600,0,'CST'),(191,3,-18000,1,'CDT'),(191,4,-18000,0,'EST'),(191,5,-21600,0,'CST'),(192,0,-16272,0,'LMT'),(192,1,-14400,1,'-04'),(192,2,-18000,0,'-05'),(192,3,-14400,0,'-04'),(192,4,-18000,0,'-05'),(193,0,-15408,0,'LMT'),(193,1,-15408,0,'CMT'),(193,2,-14400,0,'-04'),(193,3,-10800,1,'-03'),(193,4,-7200,1,'-02'),(193,5,-10800,0,'-03'),(194,0,-28084,0,'LMT'),(194,1,-25200,0,'MST'),(194,2,-28800,0,'PST'),(194,3,-25200,1,'PDT'),(194,4,-25200,1,'PWT'),(194,5,-25200,1,'PPT'),(195,0,-13128,0,'LMT'),(195,1,-10800,1,'-03'),(195,2,-14400,0,'-04'),(195,3,-10800,0,'-03'),(196,0,-16966,0,'LMT'),(196,1,-16966,0,'SMT'),(196,2,-18000,0,'-05'),(196,3,-14400,0,'-04'),(196,4,-14400,1,'-04'),(196,5,-10800,1,'-03'),(196,6,-10800,1,'-03'),(196,7,-14400,0,'-04'),(197,0,-16776,0,'LMT'),(197,1,-16800,0,'SDMT'),(197,2,-14400,1,'EDT'),(197,3,-18000,0,'EST'),(197,4,-16200,1,'-0430'),(197,5,-14400,0,'AST'),(198,0,-11188,0,'LMT'),(198,1,-7200,1,'-02'),(198,2,-10800,0,'-03'),(199,0,-5272,0,'LMT'),(199,1,-7200,0,'-02'),(199,2,-3600,1,'-01'),(199,3,-7200,0,'-02'),(199,4,-3600,0,'-01'),(199,5,0,1,'+00'),(199,6,0,1,'+00'),(200,0,-25196,0,'LMT'),(200,1,-21600,1,'MDT'),(200,2,-25200,0,'MST'),(200,3,-21600,1,'MWT'),(200,4,-21600,1,'MPT'),(201,0,-32473,0,'LMT'),(201,1,-28800,0,'PST'),(201,2,-25200,1,'PWT'),(201,3,-25200,1,'PPT'),(201,4,-25200,1,'PDT'),(201,5,-32400,0,'YST'),(201,6,-28800,1,'AKDT'),(201,7,-32400,0,'AKST'),(202,0,-14764,0,'LMT'),(202,1,-14400,0,'AST'),(203,0,-12652,0,'LMT'),(203,1,-9052,1,'NDT'),(203,2,-12652,0,'NST'),(203,3,-9000,1,'NDT'),(203,4,-12600,0,'NST'),(203,5,-9000,1,'NPT'),(203,6,-9000,1,'NWT'),(203,7,-5400,1,'NDDT'),(203,8,-9000,1,'NDT'),(204,0,-14764,0,'LMT'),(204,1,-14400,0,'AST'),(205,0,-14764,0,'LMT'),(205,1,-14400,0,'AST'),(206,0,-14764,0,'LMT'),(206,1,-14400,0,'AST'),(207,0,-14764,0,'LMT'),(207,1,-14400,0,'AST'),(208,0,-25880,0,'LMT'),(208,1,-21600,1,'MDT'),(208,2,-25200,0,'MST'),(208,3,-21600,1,'MWT'),(208,4,-21600,1,'MPT'),(208,5,-21600,0,'CST'),(209,0,-20932,0,'LMT'),(209,1,-18000,1,'CDT'),(209,2,-21600,0,'CST'),(210,0,-16508,0,'LMT'),(210,1,-10800,1,'ADT'),(210,2,-14400,0,'AST'),(211,0,-21420,0,'LMT'),(211,1,-21600,0,'CST'),(211,2,-18000,0,'EST'),(211,3,-14400,1,'EWT'),(211,4,-14400,1,'EPT'),(211,5,-14400,1,'EDT'),(212,0,-28084,0,'LMT'),(212,1,-25200,0,'MST'),(212,2,-28800,0,'PST'),(212,3,-25200,1,'PDT'),(212,4,-25200,1,'PWT'),(212,5,-25200,1,'PPT'),(213,0,-19052,0,'LMT'),(213,1,-14400,1,'EDT'),(213,2,-18000,0,'EST'),(213,3,-14400,1,'EWT'),(213,4,-14400,1,'EPT'),(214,0,-14764,0,'LMT'),(214,1,-14400,0,'AST'),(215,0,-29548,0,'LMT'),(215,1,-25200,1,'PDT'),(215,2,-28800,0,'PST'),(215,3,-25200,1,'PWT'),(215,4,-25200,1,'PPT'),(216,0,-14764,0,'LMT'),(216,1,-14400,0,'AST'),(217,0,-32412,0,'LMT'),(217,1,-28800,1,'YDT'),(217,2,-32400,0,'YST'),(217,3,-28800,1,'YWT'),(217,4,-28800,1,'YPT'),(217,5,-25200,1,'YDDT'),(217,6,-28800,0,'PST'),(217,7,-25200,1,'PDT'),(218,0,-23316,0,'LMT'),(218,1,-18000,1,'CDT'),(218,2,-21600,0,'CST'),(218,3,-18000,1,'CWT'),(218,4,-18000,1,'CPT'),(218,5,-18000,1,'CDT'),(218,6,-21600,0,'CST'),(219,0,-33535,0,'LMT'),(219,1,-32400,0,'YST'),(219,2,-28800,1,'YWT'),(219,3,-28800,1,'YPT'),(219,4,-28800,1,'YDT'),(219,5,-28800,1,'AKDT'),(219,6,-32400,0,'AKST'),(220,0,0,0,'-00'),(220,1,-21600,1,'MWT'),(220,2,-21600,1,'MPT'),(220,3,-25200,0,'MST'),(220,4,-18000,1,'MDDT'),(220,5,-21600,1,'MDT'),(221,0,0,0,'-00'),(221,1,28800,0,'+08'),(221,2,39600,0,'+11'),(221,3,28800,0,'+08'),(222,0,0,0,'-00'),(222,1,25200,0,'+07'),(222,2,18000,0,'+05'),(222,3,25200,0,'+07'),(223,0,0,0,'-00'),(223,1,36000,0,'+10'),(224,0,0,0,'-00'),(224,1,36000,0,'AEST'),(224,2,39600,1,'AEDT'),(224,3,0,0,'-00'),(224,4,39600,1,'AEDT'),(224,5,36000,0,'AEST'),(224,6,39600,0,'+11'),(225,0,0,0,'-00'),(225,1,21600,0,'+06'),(225,2,18000,0,'+05'),(226,0,41944,0,'LMT'),(226,1,45000,1,'NZST'),(226,2,41400,0,'NZMT'),(226,3,43200,1,'NZST'),(226,4,46800,1,'NZDT'),(226,5,43200,0,'NZST'),(226,6,43200,0,'NZST'),(227,0,0,0,'-00'),(227,1,-14400,0,'-04'),(227,2,-10800,1,'-03'),(227,3,-7200,1,'-02'),(227,4,-10800,0,'-03'),(227,5,-10800,1,'-03'),(227,6,-14400,0,'-04'),(227,7,-10800,0,'-03'),(228,0,0,0,'-00'),(228,1,-10800,0,'-03'),(229,0,41944,0,'LMT'),(229,1,45000,1,'NZST'),(229,2,41400,0,'NZMT'),(229,3,43200,1,'NZST'),(229,4,46800,1,'NZDT'),(229,5,43200,0,'NZST'),(229,6,43200,0,'NZST'),(230,0,0,0,'-00'),(230,1,10800,0,'+03'),(231,0,0,0,'-00'),(231,1,7200,1,'+02'),(231,2,0,0,'+00'),(231,3,0,0,'+00'),(232,0,0,0,'-00'),(232,1,21600,0,'+06'),(233,0,2580,0,'LMT'),(233,1,7200,1,'CEST'),(233,2,3600,0,'CET'),(233,3,3600,0,'CET'),(233,4,7200,1,'CEST'),(233,5,7200,1,'CEST'),(233,6,3600,0,'CET'),(234,0,11212,0,'LMT'),(234,1,10800,0,'+03'),(235,0,18468,0,'LMT'),(235,1,18000,0,'+05'),(235,2,25200,1,'+07'),(235,3,21600,0,'+06'),(235,4,21600,0,'+06'),(235,5,25200,1,'+07'),(235,6,21600,1,'+06'),(235,7,18000,0,'+05'),(235,8,25200,1,'+07'),(235,9,21600,0,'+06'),(236,0,8624,0,'LMT'),(236,1,10800,1,'EEST'),(236,2,7200,0,'EET'),(236,3,7200,0,'EET'),(236,4,10800,1,'EEST'),(237,0,42596,0,'LMT'),(237,1,43200,0,'+12'),(237,2,50400,1,'+14'),(237,3,46800,0,'+13'),(237,4,46800,1,'+13'),(237,5,43200,0,'+12'),(237,6,46800,1,'+13'),(237,7,43200,1,'+12'),(237,8,39600,0,'+11'),(237,9,43200,0,'+12'),(238,0,12064,0,'LMT'),(238,1,14400,0,'+04'),(238,2,18000,0,'+05'),(238,3,21600,0,'+06'),(238,4,21600,1,'+06'),(238,5,18000,0,'+05'),(238,6,21600,1,'+06'),(238,7,18000,1,'+05'),(238,8,14400,0,'+04'),(238,9,18000,0,'+05'),(239,0,13720,0,'LMT'),(239,1,14400,0,'+04'),(239,2,18000,0,'+05'),(239,3,21600,1,'+06'),(239,4,21600,0,'+06'),(239,5,18000,0,'+05'),(239,6,21600,1,'+06'),(239,7,18000,1,'+05'),(239,8,14400,0,'+04'),(239,9,21600,1,'+06'),(239,10,18000,0,'+05'),(240,0,14012,0,'LMT'),(240,1,14400,0,'+04'),(240,2,21600,1,'+06'),(240,3,18000,0,'+05'),(240,4,18000,0,'+05'),(240,5,21600,1,'+06'),(240,6,18000,1,'+05'),(240,7,14400,0,'+04'),(240,8,18000,0,'+05'),(241,0,14012,0,'LMT'),(241,1,14400,0,'+04'),(241,2,21600,1,'+06'),(241,3,18000,0,'+05'),(241,4,18000,0,'+05'),(241,5,21600,1,'+06'),(241,6,18000,1,'+05'),(241,7,14400,0,'+04'),(241,8,18000,0,'+05'),(242,0,12464,0,'LMT'),(242,1,10800,0,'+03'),(242,2,18000,0,'+05'),(242,3,21600,0,'+06'),(242,4,21600,1,'+06'),(242,5,18000,0,'+05'),(242,6,21600,1,'+06'),(242,7,18000,1,'+05'),(242,8,14400,0,'+04'),(242,9,18000,0,'+05'),(243,0,10660,0,'LMT'),(243,1,10656,0,'BMT'),(243,2,10800,0,'+03'),(243,3,14400,1,'+04'),(243,4,10800,0,'+03'),(243,5,14400,1,'+04'),(244,0,12368,0,'LMT'),(244,1,14400,0,'+04'),(244,2,10800,0,'+03'),(245,0,11964,0,'LMT'),(245,1,10800,0,'+03'),(245,2,18000,1,'+05'),(245,3,14400,0,'+04'),(245,4,14400,0,'+04'),(245,5,18000,1,'+05'),(245,6,14400,1,'+04'),(245,7,10800,0,'+03'),(245,8,18000,1,'+05'),(245,9,14400,0,'+04'),(246,0,24124,0,'LMT'),(246,1,24124,0,'BMT'),(246,2,25200,0,'+07'),(247,0,20100,0,'LMT'),(247,1,21600,0,'+06'),(247,2,28800,1,'+08'),(247,3,25200,0,'+07'),(247,4,25200,0,'+07'),(247,5,28800,1,'+08'),(247,6,25200,1,'+07'),(247,7,21600,0,'+06'),(247,8,25200,1,'+07'),(247,9,25200,0,'+07'),(248,0,8520,0,'LMT'),(248,1,10800,1,'EEST'),(248,2,7200,0,'EET'),(249,0,17904,0,'LMT'),(249,1,18000,0,'+05'),(249,2,25200,1,'+07'),(249,3,21600,0,'+06'),(249,4,21600,0,'+06'),(249,5,25200,1,'+07'),(249,6,21600,1,'+06'),(249,7,18000,0,'+05'),(249,8,21600,1,'+06'),(249,9,21600,0,'+06'),(250,0,27580,0,'LMT'),(250,1,27000,0,'+0730'),(250,2,28800,0,'+08'),(251,0,21200,0,'HMT'),(251,1,19270,0,'MMT'),(251,2,19800,0,'IST'),(251,3,23400,1,'+0630'),(252,0,27232,0,'LMT'),(252,1,28800,0,'+08'),(252,2,36000,1,'+10'),(252,3,32400,0,'+09'),(252,4,32400,0,'+09'),(252,5,36000,1,'+10'),(252,6,32400,1,'+09'),(252,7,28800,0,'+08'),(252,8,36000,0,'+10'),(252,9,36000,1,'+10'),(252,10,32400,0,'+09'),(253,0,27480,0,'LMT'),(253,1,25200,0,'+07'),(253,2,28800,0,'+08'),(253,3,32400,0,'+09'),(253,4,36000,1,'+10'),(253,5,32400,1,'+09'),(253,6,28800,0,'+08'),(254,0,29143,0,'LMT'),(254,1,32400,1,'CDT'),(254,2,28800,0,'CST'),(255,0,29143,0,'LMT'),(255,1,32400,1,'CDT'),(255,2,28800,0,'CST'),(256,0,19164,0,'LMT'),(256,1,19172,0,'MMT'),(256,2,19800,0,'+0530'),(256,3,21600,1,'+06'),(256,4,23400,1,'+0630'),(256,5,23400,0,'+0630'),(256,6,21600,0,'+06'),(256,7,19800,0,'+0530'),(257,0,21700,0,'LMT'),(257,1,21200,0,'HMT'),(257,2,23400,0,'+0630'),(257,3,19800,0,'+0530'),(257,4,21600,0,'+06'),(257,5,25200,1,'+07'),(258,0,8712,0,'LMT'),(258,1,10800,1,'EEST'),(258,2,7200,0,'EET'),(259,0,21700,0,'LMT'),(259,1,21200,0,'HMT'),(259,2,23400,0,'+0630'),(259,3,19800,0,'+0530'),(259,4,21600,0,'+06'),(259,5,25200,1,'+07'),(260,0,30140,0,'LMT'),(260,1,28800,0,'+08'),(260,2,32400,0,'+09'),(261,0,13272,0,'LMT'),(261,1,14400,0,'+04'),(262,0,16512,0,'LMT'),(262,1,18000,0,'+05'),(262,2,25200,1,'+07'),(262,3,21600,0,'+06'),(262,4,21600,0,'+06'),(262,5,25200,1,'+07'),(262,6,21600,1,'+06'),(262,7,18000,0,'+05'),(263,0,8148,0,'LMT'),(263,1,10800,1,'EEST'),(263,2,7200,0,'EET'),(263,3,7200,0,'EET'),(263,4,10800,1,'EEST'),(263,5,10800,0,'+03'),(263,6,7200,0,'EET'),(264,0,8272,0,'LMT'),(264,1,10800,1,'EEST'),(264,2,7200,0,'EET'),(264,3,10800,1,'IDT'),(264,4,7200,0,'IST'),(264,5,7200,0,'EET'),(265,0,29143,0,'LMT'),(265,1,32400,1,'CDT'),(265,2,28800,0,'CST'),(266,0,8423,0,'LMT'),(266,1,10800,1,'EEST'),(266,2,7200,0,'EET'),(266,3,10800,1,'IDT'),(266,4,7200,0,'IST'),(266,5,7200,0,'EET'),(267,0,25600,0,'LMT'),(267,1,25590,0,'PLMT'),(267,2,25200,0,'+07'),(267,3,28800,0,'+08'),(267,4,32400,0,'+09'),(267,5,25200,0,'+07'),(268,0,27402,0,'LMT'),(268,1,28800,0,'HKT'),(268,2,32400,1,'HKST'),(268,3,30600,0,'HKT'),(268,4,32400,0,'JST'),(268,5,28800,0,'HKT'),(269,0,21996,0,'LMT'),(269,1,21600,0,'+06'),(269,2,28800,1,'+08'),(269,3,25200,0,'+07'),(270,0,25025,0,'LMT'),(270,1,25025,0,'IMT'),(270,2,25200,0,'+07'),(270,3,32400,1,'+09'),(270,4,28800,0,'+08'),(270,5,28800,0,'+08'),(270,6,32400,1,'+09'),(270,7,28800,1,'+08'),(270,8,25200,0,'+07'),(270,9,32400,0,'+09'),(270,10,32400,1,'+09'),(270,11,28800,0,'+08'),(271,0,6952,0,'LMT'),(271,1,7016,0,'IMT'),(271,2,10800,1,'EEST'),(271,3,7200,0,'EET'),(271,4,14400,1,'+04'),(271,5,10800,0,'+03'),(271,6,10800,1,'EEST'),(271,7,7200,0,'EET'),(271,8,10800,1,'EEST'),(271,9,7200,0,'EET'),(271,10,10800,0,'+03'),(272,0,25632,0,'LMT'),(272,1,25632,0,'BMT'),(272,2,26400,0,'+0720'),(272,3,27000,0,'+0730'),(272,4,32400,0,'+09'),(272,5,28800,0,'+08'),(272,6,25200,0,'WIB'),(273,0,33768,0,'LMT'),(273,1,32400,0,'+09'),(273,2,34200,0,'+0930'),(273,3,32400,0,'WIT'),(274,0,8454,0,'LMT'),(274,1,8440,0,'JMT'),(274,2,10800,1,'IDT'),(274,3,7200,0,'IST'),(274,4,14400,1,'IDDT'),(274,5,10800,1,'IDT'),(275,0,16608,0,'LMT'),(275,1,14400,0,'+04'),(275,2,16200,0,'+0430'),(276,0,38076,0,'LMT'),(276,1,39600,0,'+11'),(276,2,46800,1,'+13'),(276,3,43200,0,'+12'),(276,4,43200,0,'+12'),(276,5,46800,1,'+13'),(276,6,43200,1,'+12'),(276,7,39600,0,'+11'),(276,8,43200,0,'+12'),(277,0,16092,0,'LMT'),(277,1,19800,0,'+0530'),(277,2,23400,1,'+0630'),(277,3,18000,0,'+05'),(277,4,21600,1,'PKST'),(277,5,18000,0,'PKT'),(278,0,21020,0,'LMT'),(278,1,21600,0,'+06'),(279,0,20476,0,'LMT'),(279,1,19800,0,'+0530'),(279,2,20700,0,'+0545'),(280,0,20476,0,'LMT'),(280,1,19800,0,'+0530'),(280,2,20700,0,'+0545'),(281,0,32533,0,'LMT'),(281,1,28800,0,'+08'),(281,2,36000,1,'+10'),(281,3,32400,0,'+09'),(281,4,32400,0,'+09'),(281,5,36000,1,'+10'),(281,6,32400,1,'+09'),(281,7,28800,0,'+08'),(281,8,39600,1,'+11'),(281,9,36000,0,'+10'),(281,10,36000,0,'+10'),(281,11,39600,0,'+11'),(281,12,32400,0,'+09'),(282,0,21200,0,'HMT'),(282,1,19270,0,'MMT'),(282,2,19800,0,'IST'),(282,3,23400,1,'+0630'),(283,0,22286,0,'LMT'),(283,1,21600,0,'+06'),(283,2,28800,1,'+08'),(283,3,25200,0,'+07'),(283,4,25200,0,'+07'),(283,5,28800,1,'+08'),(283,6,25200,1,'+07'),(283,7,21600,0,'+06'),(283,8,28800,0,'+08'),(283,9,28800,1,'+08'),(283,10,25200,0,'+07'),(284,0,24406,0,'LMT'),(284,1,24925,0,'SMT'),(284,2,25200,0,'+07'),(284,3,26400,1,'+0720'),(284,4,26400,0,'+0720'),(284,5,27000,0,'+0730'),(284,6,32400,0,'+09'),(284,7,28800,0,'+08'),(285,0,26480,0,'LMT'),(285,1,27000,0,'+0730'),(285,2,30000,1,'+0820'),(285,3,28800,0,'+08'),(285,4,32400,0,'+09'),(285,5,28800,0,'+08'),(286,0,11212,0,'LMT'),(286,1,10800,0,'+03'),(287,0,27250,0,'LMT'),(287,1,28800,0,'CST'),(287,2,36000,1,'+10'),(287,3,32400,0,'+09'),(287,4,32400,1,'CDT'),(287,5,28800,0,'CST'),(287,6,32400,1,'CDT'),(288,0,27250,0,'LMT'),(288,1,28800,0,'CST'),(288,2,36000,1,'+10'),(288,3,32400,0,'+09'),(288,4,32400,1,'CDT'),(288,5,28800,0,'CST'),(288,6,32400,1,'CDT'),(289,0,36192,0,'LMT'),(289,1,36000,0,'+10'),(289,2,43200,1,'+12'),(289,3,39600,0,'+11'),(289,4,39600,0,'+11'),(289,5,43200,1,'+12'),(289,6,39600,1,'+11'),(289,7,36000,0,'+10'),(289,8,43200,0,'+12'),(289,9,43200,1,'+12'),(289,10,39600,0,'+11'),(290,0,28656,0,'LMT'),(290,1,28656,0,'MMT'),(290,2,28800,0,'+08'),(290,3,32400,0,'+09'),(290,4,28800,0,'WITA'),(291,0,29040,0,'LMT'),(291,1,32400,1,'PDT'),(291,2,28800,0,'PST'),(291,3,32400,0,'JST'),(291,4,28800,0,'PST'),(292,0,13272,0,'LMT'),(292,1,14400,0,'+04'),(293,0,8008,0,'LMT'),(293,1,10800,1,'EEST'),(293,2,7200,0,'EET'),(293,3,7200,0,'EET'),(293,4,10800,1,'EEST'),(294,0,20928,0,'LMT'),(294,1,21600,0,'+06'),(294,2,28800,1,'+08'),(294,3,25200,0,'+07'),(294,4,25200,0,'+07'),(294,5,28800,1,'+08'),(294,6,25200,1,'+07'),(294,7,21600,0,'+06'),(294,8,25200,0,'+07'),(295,0,19900,0,'LMT'),(295,1,21600,0,'+06'),(295,2,28800,1,'+08'),(295,3,25200,0,'+07'),(295,4,25200,0,'+07'),(295,5,28800,1,'+08'),(295,6,25200,1,'+07'),(295,7,21600,0,'+06'),(295,8,25200,1,'+07'),(295,9,25200,0,'+07'),(296,0,17610,0,'LMT'),(296,1,18000,0,'+05'),(296,2,25200,1,'+07'),(296,3,21600,0,'+06'),(296,4,21600,0,'+06'),(296,5,25200,1,'+07'),(296,6,21600,1,'+06'),(296,7,18000,0,'+05'),(296,8,25200,0,'+07'),(296,9,25200,1,'+07'),(296,10,21600,0,'+06'),(297,0,12324,0,'LMT'),(297,1,10800,0,'+03'),(297,2,18000,0,'+05'),(297,3,21600,1,'+06'),(297,4,21600,0,'+06'),(297,5,18000,0,'+05'),(297,6,21600,1,'+06'),(297,7,18000,1,'+05'),(297,8,14400,0,'+04'),(297,9,18000,0,'+05'),(298,0,24124,0,'LMT'),(298,1,24124,0,'BMT'),(298,2,25200,0,'+07'),(299,0,26240,0,'LMT'),(299,1,26240,0,'PMT'),(299,2,27000,0,'+0730'),(299,3,32400,0,'+09'),(299,4,28800,0,'+08'),(299,5,28800,0,'WITA'),(299,6,25200,0,'WIB'),(300,0,30180,0,'LMT'),(300,1,30600,0,'KST'),(300,2,32400,0,'JST'),(300,3,32400,0,'KST'),(301,0,12368,0,'LMT'),(301,1,14400,0,'+04'),(301,2,10800,0,'+03'),(302,0,15268,0,'LMT'),(302,1,14400,0,'+04'),(302,2,18000,0,'+05'),(302,3,21600,1,'+06'),(302,4,21600,0,'+06'),(302,5,18000,0,'+05'),(302,6,21600,1,'+06'),(302,7,18000,1,'+05'),(302,8,14400,0,'+04'),(302,9,21600,0,'+06'),(302,10,21600,1,'+06'),(303,0,15712,0,'LMT'),(303,1,14400,0,'+04'),(303,2,18000,0,'+05'),(303,3,21600,1,'+06'),(303,4,21600,0,'+06'),(303,5,18000,0,'+05'),(303,6,21600,1,'+06'),(303,7,18000,1,'+05'),(303,8,14400,0,'+04'),(303,9,21600,0,'+06'),(303,10,21600,1,'+06'),(303,11,18000,0,'+05'),(304,0,23087,0,'LMT'),(304,1,23087,0,'RMT'),(304,2,23400,0,'+0630'),(304,3,32400,0,'+09'),(304,4,23400,0,'+0630'),(305,0,11212,0,'LMT'),(305,1,10800,0,'+03'),(306,0,25600,0,'LMT'),(306,1,25590,0,'PLMT'),(306,2,25200,0,'+07'),(306,3,28800,0,'+08'),(306,4,32400,0,'+09'),(306,5,25200,0,'+07'),(307,0,34248,0,'LMT'),(307,1,32400,0,'+09'),(307,2,43200,1,'+12'),(307,3,39600,0,'+11'),(307,4,39600,0,'+11'),(307,5,43200,1,'+12'),(307,6,39600,1,'+11'),(307,7,36000,0,'+10'),(307,8,39600,0,'+11'),(308,0,16073,0,'LMT'),(308,1,14400,0,'+04'),(308,2,18000,0,'+05'),(308,3,21600,1,'+06'),(308,4,21600,0,'+06'),(308,5,18000,0,'+05'),(308,6,21600,1,'+06'),(309,0,30472,0,'LMT'),(309,1,30600,0,'KST'),(309,2,32400,0,'JST'),(309,3,32400,0,'KST'),(309,4,34200,1,'KDT'),(309,5,36000,1,'KDT'),(310,0,29143,0,'LMT'),(310,1,32400,1,'CDT'),(310,2,28800,0,'CST'),(311,0,24925,0,'LMT'),(311,1,24925,0,'SMT'),(311,2,25200,0,'+07'),(311,3,26400,1,'+0720'),(311,4,26400,0,'+0720'),(311,5,27000,0,'+0730'),(311,6,32400,0,'+09'),(311,7,28800,0,'+08'),(312,0,36892,0,'LMT'),(312,1,36000,0,'+10'),(312,2,43200,1,'+12'),(312,3,39600,0,'+11'),(312,4,39600,0,'+11'),(312,5,43200,1,'+12'),(312,6,39600,1,'+11'),(312,7,36000,0,'+10'),(312,8,43200,0,'+12'),(312,9,43200,1,'+12'),(312,10,39600,0,'+11'),(313,0,29160,0,'LMT'),(313,1,28800,0,'CST'),(313,2,32400,0,'JST'),(313,3,32400,1,'CDT'),(313,4,28800,0,'CST'),(314,0,16631,0,'LMT'),(314,1,18000,0,'+05'),(314,2,25200,1,'+07'),(314,3,21600,0,'+06'),(314,4,21600,0,'+06'),(314,5,25200,1,'+07'),(314,6,21600,1,'+06'),(314,7,18000,0,'+05'),(315,0,10751,0,'LMT'),(315,1,10751,0,'TBMT'),(315,2,10800,0,'+03'),(315,3,18000,1,'+05'),(315,4,14400,0,'+04'),(315,5,14400,0,'+04'),(315,6,18000,1,'+05'),(315,7,14400,1,'+04'),(315,8,10800,0,'+03'),(315,9,14400,1,'+04'),(315,10,14400,0,'+04'),(316,0,12344,0,'LMT'),(316,1,12344,0,'TMT'),(316,2,12600,0,'+0330'),(316,3,18000,1,'+05'),(316,4,14400,0,'+04'),(316,5,16200,1,'+0430'),(316,6,12600,0,'+0330'),(317,0,8454,0,'LMT'),(317,1,8440,0,'JMT'),(317,2,10800,1,'IDT'),(317,3,7200,0,'IST'),(317,4,14400,1,'IDDT'),(317,5,10800,1,'IDT'),(318,0,21516,0,'LMT'),(318,1,19800,0,'+0530'),(318,2,21600,0,'+06'),(319,0,21516,0,'LMT'),(319,1,19800,0,'+0530'),(319,2,21600,0,'+06'),(320,0,33539,0,'LMT'),(320,1,36000,1,'JDT'),(320,2,32400,0,'JST'),(320,3,32400,0,'JST'),(321,0,20391,0,'LMT'),(321,1,21600,0,'+06'),(321,2,28800,1,'+08'),(321,3,25200,0,'+07'),(321,4,25200,0,'+07'),(321,5,28800,1,'+08'),(321,6,25200,1,'+07'),(321,7,21600,0,'+06'),(321,8,25200,1,'+07'),(321,9,25200,0,'+07'),(322,0,28656,0,'LMT'),(322,1,28656,0,'MMT'),(322,2,28800,0,'+08'),(322,3,32400,0,'+09'),(322,4,28800,0,'WITA'),(323,0,25652,0,'LMT'),(323,1,25200,0,'+07'),(323,2,32400,1,'+09'),(323,3,28800,0,'+08'),(324,0,25652,0,'LMT'),(324,1,25200,0,'+07'),(324,2,32400,1,'+09'),(324,3,28800,0,'+08'),(325,0,21020,0,'LMT'),(325,1,21600,0,'+06'),(326,0,34374,0,'LMT'),(326,1,28800,0,'+08'),(326,2,32400,0,'+09'),(326,3,39600,0,'+11'),(326,4,43200,1,'+12'),(326,5,39600,0,'+11'),(326,6,43200,1,'+12'),(326,7,39600,1,'+11'),(326,8,36000,0,'+10'),(326,9,43200,0,'+12'),(326,10,43200,1,'+12'),(326,11,36000,0,'+10'),(327,0,24124,0,'LMT'),(327,1,24124,0,'BMT'),(327,2,25200,0,'+07'),(328,0,31651,0,'LMT'),(328,1,32400,0,'+09'),(328,2,39600,1,'+11'),(328,3,36000,0,'+10'),(328,4,36000,0,'+10'),(328,5,39600,1,'+11'),(328,6,36000,1,'+10'),(328,7,32400,0,'+09'),(328,8,39600,0,'+11'),(328,9,39600,1,'+11'),(328,10,36000,0,'+10'),(329,0,31138,0,'LMT'),(329,1,28800,0,'+08'),(329,2,36000,1,'+10'),(329,3,32400,0,'+09'),(329,4,32400,0,'+09'),(329,5,36000,1,'+10'),(329,6,32400,1,'+09'),(329,7,28800,0,'+08'),(329,8,36000,0,'+10'),(329,9,36000,1,'+10'),(329,10,32400,0,'+09'),(330,0,23087,0,'LMT'),(330,1,23087,0,'RMT'),(330,2,23400,0,'+0630'),(330,3,32400,0,'+09'),(330,4,23400,0,'+0630'),(331,0,14553,0,'LMT'),(331,1,13505,0,'PMT'),(331,2,14400,0,'+04'),(331,3,21600,1,'+06'),(331,4,18000,0,'+05'),(331,5,18000,0,'+05'),(331,6,21600,1,'+06'),(331,7,18000,1,'+05'),(331,8,14400,0,'+04'),(331,9,21600,0,'+06'),(331,10,21600,1,'+06'),(331,11,18000,0,'+05'),(332,0,10680,0,'LMT'),(332,1,10800,0,'+03'),(332,2,18000,1,'+05'),(332,3,14400,0,'+04'),(332,4,14400,0,'+04'),(332,5,18000,1,'+05'),(332,6,14400,1,'+04'),(332,7,10800,0,'+03'),(332,8,18000,1,'+05'),(332,9,14400,0,'+04'),(333,0,-6160,0,'LMT'),(333,1,-6872,0,'HMT'),(333,2,-3600,1,'-01'),(333,3,-7200,0,'-02'),(333,4,-3600,1,'-01'),(333,5,-7200,0,'-02'),(333,6,-7200,0,'-02'),(333,7,0,1,'+00'),(333,8,-3600,0,'-01'),(333,9,-3600,0,'-01'),(333,10,0,0,'WET'),(333,11,0,1,'+00'),(333,12,-3600,0,'-01'),(334,0,-15558,0,'LMT'),(334,1,-14400,0,'AST'),(334,2,-10800,1,'ADT'),(335,0,-3696,0,'LMT'),(335,1,-3600,0,'-01'),(335,2,0,0,'WET'),(335,3,3600,1,'WEST'),(335,4,0,0,'WET'),(335,5,3600,1,'WEST'),(336,0,-5644,0,'LMT'),(336,1,-7200,0,'-02'),(336,2,-3600,1,'-01'),(336,3,-7200,0,'-02'),(336,4,-3600,0,'-01'),(337,0,-1624,0,'LMT'),(337,1,0,0,'WET'),(337,2,3600,1,'WEST'),(337,3,0,0,'WET'),(338,0,-1624,0,'LMT'),(338,1,0,0,'WET'),(338,2,3600,1,'WEST'),(338,3,0,0,'WET'),(339,0,2580,0,'LMT'),(339,1,7200,1,'CEST'),(339,2,3600,0,'CET'),(339,3,3600,0,'CET'),(339,4,7200,1,'CEST'),(339,5,7200,1,'CEST'),(339,6,3600,0,'CET'),(340,0,-4056,0,'LMT'),(340,1,-4056,0,'FMT'),(340,2,0,1,'+00'),(340,3,-3600,0,'-01'),(340,4,0,1,'+00'),(340,5,-3600,0,'-01'),(340,6,-3600,0,'-01'),(340,7,3600,1,'+01'),(340,8,3600,1,'WEST'),(340,9,0,0,'WET'),(340,10,0,0,'WET'),(340,11,0,0,'WET'),(340,12,3600,1,'WEST'),(341,0,-5280,0,'LMT'),(341,1,0,1,'+00'),(341,2,-3600,0,'-01'),(341,3,-3600,0,'-01'),(341,4,0,1,'+00'),(341,5,0,0,'GMT'),(342,0,-8768,0,'LMT'),(342,1,-7200,0,'-02'),(343,0,-968,0,'LMT'),(343,1,0,0,'GMT'),(344,0,-13884,0,'LMT'),(344,1,-13884,0,'SMT'),(344,2,-10800,1,'-03'),(344,3,-14400,0,'-04'),(344,4,-7200,1,'-02'),(344,5,-10800,0,'-03'),(344,6,-10800,1,'-03'),(345,0,36292,0,'LMT'),(345,1,39600,1,'AEDT'),(345,2,36000,0,'AEST'),(345,3,39600,1,'AEDT'),(345,4,36000,0,'AEST'),(346,0,32400,0,'ACST'),(346,1,37800,1,'ACDT'),(346,2,34200,0,'ACST'),(346,3,37800,1,'ACDT'),(346,4,34200,0,'ACST'),(347,0,36728,0,'LMT'),(347,1,39600,1,'AEDT'),(347,2,36000,0,'AEST'),(347,3,39600,1,'AEDT'),(347,4,36000,0,'AEST'),(348,0,32400,0,'ACST'),(348,1,37800,1,'ACDT'),(348,2,34200,0,'ACST'),(348,3,37800,1,'ACDT'),(348,4,34200,0,'ACST'),(349,0,36292,0,'LMT'),(349,1,39600,1,'AEDT'),(349,2,36000,0,'AEST'),(349,3,39600,1,'AEDT'),(349,4,36000,0,'AEST'),(350,0,34528,0,'LMT'),(350,1,36000,0,'AEST'),(350,2,39600,1,'AEDT'),(350,3,39600,1,'AEDT'),(350,4,36000,0,'AEST'),(351,0,32400,0,'ACST'),(351,1,37800,1,'ACDT'),(351,2,34200,0,'ACST'),(352,0,30928,0,'LMT'),(352,1,35100,1,'+0945'),(352,2,31500,0,'+0845'),(352,3,35100,1,'+0945'),(352,4,31500,0,'+0845'),(353,0,35356,0,'LMT'),(353,1,36000,0,'AEST'),(353,2,39600,1,'AEDT'),(353,3,39600,1,'AEDT'),(353,4,36000,0,'AEST'),(354,0,38180,0,'LMT'),(354,1,36000,0,'AEST'),(354,2,41400,1,'+1130'),(354,3,37800,0,'+1030'),(354,4,39600,1,'+11'),(355,0,35756,0,'LMT'),(355,1,39600,1,'AEDT'),(355,2,36000,0,'AEST'),(355,3,39600,1,'AEDT'),(355,4,36000,0,'AEST'),(356,0,38180,0,'LMT'),(356,1,36000,0,'AEST'),(356,2,41400,1,'+1130'),(356,3,37800,0,'+1030'),(356,4,39600,1,'+11'),(357,0,34792,0,'LMT'),(357,1,39600,1,'AEDT'),(357,2,36000,0,'AEST'),(357,3,39600,1,'AEDT'),(357,4,36000,0,'AEST'),(358,0,36292,0,'LMT'),(358,1,39600,1,'AEDT'),(358,2,36000,0,'AEST'),(358,3,39600,1,'AEDT'),(358,4,36000,0,'AEST'),(359,0,32400,0,'ACST'),(359,1,37800,1,'ACDT'),(359,2,34200,0,'ACST'),(360,0,27804,0,'LMT'),(360,1,32400,1,'AWDT'),(360,2,28800,0,'AWST'),(360,3,32400,1,'AWDT'),(360,4,28800,0,'AWST'),(361,0,36728,0,'LMT'),(361,1,39600,1,'AEDT'),(361,2,36000,0,'AEST'),(361,3,39600,1,'AEDT'),(361,4,36000,0,'AEST'),(362,0,32400,0,'ACST'),(362,1,37800,1,'ACDT'),(362,2,34200,0,'ACST'),(362,3,37800,1,'ACDT'),(362,4,34200,0,'ACST'),(363,0,36292,0,'LMT'),(363,1,39600,1,'AEDT'),(363,2,36000,0,'AEST'),(363,3,39600,1,'AEDT'),(363,4,36000,0,'AEST'),(364,0,35356,0,'LMT'),(364,1,36000,0,'AEST'),(364,2,39600,1,'AEDT'),(364,3,39600,1,'AEDT'),(364,4,36000,0,'AEST'),(365,0,34792,0,'LMT'),(365,1,39600,1,'AEDT'),(365,2,36000,0,'AEST'),(365,3,39600,1,'AEDT'),(365,4,36000,0,'AEST'),(366,0,27804,0,'LMT'),(366,1,32400,1,'AWDT'),(366,2,28800,0,'AWST'),(366,3,32400,1,'AWDT'),(366,4,28800,0,'AWST'),(367,0,32400,0,'ACST'),(367,1,37800,1,'ACDT'),(367,2,34200,0,'ACST'),(367,3,37800,1,'ACDT'),(367,4,34200,0,'ACST'),(368,0,-16272,0,'LMT'),(368,1,-14400,1,'-04'),(368,2,-18000,0,'-05'),(368,3,-14400,0,'-04'),(368,4,-18000,0,'-05'),(369,0,-7780,0,'LMT'),(369,1,-3600,1,'-01'),(369,2,-7200,0,'-02'),(370,0,-11188,0,'LMT'),(370,1,-7200,1,'-02'),(370,2,-10800,0,'-03'),(371,0,-14404,0,'LMT'),(371,1,-10800,1,'-03'),(371,2,-14400,0,'-04'),(372,0,7200,1,'CEST'),(372,1,3600,0,'CET'),(372,2,7200,1,'CEST'),(372,3,3600,0,'CET'),(373,0,-18000,1,'CDT'),(373,1,-21600,0,'CST'),(373,2,-18000,1,'CWT'),(373,3,-18000,1,'CPT'),(374,0,-15264,0,'LMT'),(374,1,-10800,1,'ADT'),(374,2,-14400,0,'AST'),(374,3,-10800,1,'AWT'),(374,4,-10800,1,'APT'),(375,0,-23316,0,'LMT'),(375,1,-18000,1,'CDT'),(375,2,-21600,0,'CST'),(375,3,-18000,1,'CWT'),(375,4,-18000,1,'CPT'),(375,5,-18000,1,'CDT'),(375,6,-21600,0,'CST'),(376,0,-19052,0,'LMT'),(376,1,-14400,1,'EDT'),(376,2,-18000,0,'EST'),(376,3,-14400,1,'EWT'),(376,4,-14400,1,'EPT'),(377,0,-27232,0,'LMT'),(377,1,-21600,1,'MDT'),(377,2,-25200,0,'MST'),(377,3,-21600,1,'MWT'),(377,4,-21600,1,'MPT'),(378,0,-12652,0,'LMT'),(378,1,-9052,1,'NDT'),(378,2,-12652,0,'NST'),(378,3,-9000,1,'NDT'),(378,4,-12600,0,'NST'),(378,5,-9000,1,'NPT'),(378,6,-9000,1,'NWT'),(378,7,-5400,1,'NDDT'),(378,8,-9000,1,'NDT'),(379,0,-29548,0,'LMT'),(379,1,-25200,1,'PDT'),(379,2,-28800,0,'PST'),(379,3,-25200,1,'PWT'),(379,4,-25200,1,'PPT'),(380,0,-25116,0,'LMT'),(380,1,-21600,1,'MDT'),(380,2,-25200,0,'MST'),(380,3,-21600,1,'MWT'),(380,4,-21600,1,'MPT'),(380,5,-21600,0,'CST'),(381,0,-32412,0,'LMT'),(381,1,-28800,1,'YDT'),(381,2,-32400,0,'YST'),(381,3,-28800,1,'YWT'),(381,4,-28800,1,'YPT'),(381,5,-25200,1,'YDDT'),(381,6,-28800,0,'PST'),(381,7,-25200,1,'PDT'),(382,0,-16966,0,'LMT'),(382,1,-16966,0,'SMT'),(382,2,-18000,0,'-05'),(382,3,-14400,0,'-04'),(382,4,-14400,1,'-04'),(382,5,-10800,1,'-03'),(382,6,-10800,1,'-03'),(382,7,-14400,0,'-04'),(383,0,-26248,0,'LMT'),(383,1,-26248,0,'EMT'),(383,2,-21600,1,'-06'),(383,3,-25200,0,'-07'),(383,4,-25200,0,'-07'),(383,5,-21600,0,'-06'),(383,6,-18000,1,'-05'),(384,0,-19768,0,'LMT'),(384,1,-19776,0,'HMT'),(384,2,-14400,1,'CDT'),(384,3,-18000,0,'CST'),(384,4,-18000,0,'CST'),(384,5,-14400,1,'CDT'),(385,0,10800,1,'EEST'),(385,1,7200,0,'EET'),(386,0,-18000,0,'EST'),(387,0,-14400,1,'EDT'),(387,1,-18000,0,'EST'),(387,2,-14400,1,'EWT'),(387,3,-14400,1,'EPT'),(388,0,7509,0,'LMT'),(388,1,10800,1,'EEST'),(388,2,7200,0,'EET'),(388,3,10800,1,'EEST'),(389,0,-1500,0,'LMT'),(389,1,-1521,0,'DMT'),(389,2,2079,1,'IST'),(389,3,3600,1,'BST'),(389,4,0,0,'GMT'),(389,5,3600,1,'IST'),(389,6,0,0,'GMT'),(389,7,0,1,'GMT'),(389,8,3600,0,'IST'),(389,9,3600,0,'IST'),(390,0,0,0,'GMT'),(391,0,0,0,'GMT'),(392,0,-3600,0,'-01'),(393,0,-36000,0,'-10'),(394,0,-39600,0,'-11'),(395,0,-43200,0,'-12'),(396,0,-7200,0,'-02'),(397,0,-10800,0,'-03'),(398,0,-14400,0,'-04'),(399,0,-18000,0,'-05'),(400,0,-21600,0,'-06'),(401,0,-25200,0,'-07'),(402,0,-28800,0,'-08'),(403,0,-32400,0,'-09'),(404,0,0,0,'GMT'),(405,0,3600,0,'+01'),(406,0,36000,0,'+10'),(407,0,39600,0,'+11'),(408,0,43200,0,'+12'),(409,0,46800,0,'+13'),(410,0,50400,0,'+14'),(411,0,7200,0,'+02'),(412,0,10800,0,'+03'),(413,0,14400,0,'+04'),(414,0,18000,0,'+05'),(415,0,21600,0,'+06'),(416,0,25200,0,'+07'),(417,0,28800,0,'+08'),(418,0,32400,0,'+09'),(419,0,0,0,'GMT'),(420,0,0,0,'GMT'),(421,0,0,0,'UTC'),(422,0,0,0,'UTC'),(423,0,0,0,'UTC'),(424,0,0,0,'UTC'),(425,0,1172,0,'LMT'),(425,1,4772,1,'NST'),(425,2,1172,0,'AMT'),(425,3,4772,1,'NST'),(425,4,1172,0,'AMT'),(425,5,1200,0,'+0020'),(425,6,4800,1,'+0120'),(425,7,4800,1,'+0120'),(425,8,3600,0,'CET'),(425,9,7200,1,'CEST'),(425,10,7200,1,'CEST'),(425,11,7200,1,'CEST'),(425,12,3600,0,'CET'),(425,13,3600,0,'CET'),(426,0,364,0,'LMT'),(426,1,0,0,'WET'),(426,2,3600,0,'CET'),(426,3,7200,1,'CEST'),(426,4,3600,0,'CET'),(427,0,11532,0,'LMT'),(427,1,10800,0,'+03'),(427,2,18000,1,'+05'),(427,3,14400,0,'+04'),(427,4,14400,0,'+04'),(427,5,18000,1,'+05'),(427,6,14400,1,'+04'),(427,7,10800,0,'+03'),(427,8,14400,0,'+04'),(428,0,5692,0,'LMT'),(428,1,5692,0,'AMT'),(428,2,10800,1,'EEST'),(428,3,7200,0,'EET'),(428,4,3600,0,'CET'),(428,5,7200,1,'CEST'),(428,6,10800,1,'EEST'),(428,7,7200,0,'EET'),(428,8,10800,1,'EEST'),(428,9,7200,0,'EET'),(429,0,-75,0,'LMT'),(429,1,3600,1,'BST'),(429,2,0,0,'GMT'),(429,3,7200,1,'BDST'),(429,4,3600,0,'BST'),(429,5,3600,1,'BST'),(429,6,0,0,'GMT'),(429,7,0,0,'GMT'),(430,0,4920,0,'LMT'),(430,1,3600,0,'CET'),(430,2,3600,0,'CET'),(430,3,7200,1,'CEST'),(430,4,7200,1,'CEST'),(430,5,7200,1,'CEST'),(430,6,3600,0,'CET'),(431,0,3208,0,'LMT'),(431,1,7200,1,'CEST'),(431,2,3600,0,'CET'),(431,3,7200,1,'CEST'),(431,4,3600,0,'CET'),(431,5,10800,1,'CEMT'),(431,6,10800,1,'CEMT'),(431,7,7200,1,'CEST'),(431,8,3600,0,'CET'),(432,0,3464,0,'PMT'),(432,1,7200,1,'CEST'),(432,2,3600,0,'CET'),(432,3,7200,1,'CEST'),(432,4,3600,0,'CET'),(432,5,0,1,'GMT'),(432,6,7200,1,'CEST'),(432,7,3600,0,'CET'),(433,0,1050,0,'BMT'),(433,1,0,0,'WET'),(433,2,3600,0,'CET'),(433,3,7200,1,'CEST'),(433,4,3600,0,'CET'),(433,5,7200,1,'CEST'),(433,6,3600,1,'WEST'),(433,7,0,0,'WET'),(433,8,0,0,'WET'),(433,9,7200,1,'CEST'),(433,10,3600,0,'CET'),(434,0,6264,0,'LMT'),(434,1,6264,0,'BMT'),(434,2,10800,1,'EEST'),(434,3,7200,0,'EET'),(434,4,10800,1,'EEST'),(434,5,7200,0,'EET'),(434,6,10800,1,'EEST'),(434,7,7200,0,'EET'),(435,0,4580,0,'LMT'),(435,1,7200,1,'CEST'),(435,2,3600,0,'CET'),(435,3,7200,1,'CEST'),(435,4,3600,0,'CET'),(435,5,3600,0,'CET'),(435,6,7200,1,'CEST'),(436,0,1786,0,'BMT'),(436,1,7200,1,'CEST'),(436,2,3600,0,'CET'),(436,3,7200,1,'CEST'),(436,4,3600,0,'CET'),(437,0,6920,0,'LMT'),(437,1,6900,0,'CMT'),(437,2,6264,0,'BMT'),(437,3,10800,1,'EEST'),(437,4,7200,0,'EET'),(437,5,7200,0,'EET'),(437,6,10800,1,'EEST'),(437,7,3600,0,'CET'),(437,8,7200,1,'CEST'),(437,9,7200,1,'CEST'),(437,10,14400,1,'MSD'),(437,11,10800,0,'MSK'),(437,12,10800,0,'MSK'),(437,13,14400,1,'MSD'),(437,14,10800,1,'EEST'),(437,15,7200,0,'EET'),(438,0,3020,0,'CMT'),(438,1,7200,1,'CEST'),(438,2,3600,0,'CET'),(438,3,3600,0,'CET'),(438,4,7200,1,'CEST'),(438,5,7200,1,'CEST'),(438,6,3600,0,'CET'),(439,0,-1500,0,'LMT'),(439,1,-1521,0,'DMT'),(439,2,2079,1,'IST'),(439,3,3600,1,'BST'),(439,4,0,0,'GMT'),(439,5,3600,1,'IST'),(439,6,0,0,'GMT'),(439,7,0,1,'GMT'),(439,8,3600,0,'IST'),(439,9,3600,0,'IST'),(440,0,-1284,0,'LMT'),(440,1,3600,1,'BST'),(440,2,0,0,'GMT'),(440,3,7200,1,'BDST'),(440,4,3600,0,'CET'),(440,5,7200,1,'CEST'),(440,6,3600,0,'CET'),(441,0,-75,0,'LMT'),(441,1,3600,1,'BST'),(441,2,0,0,'GMT'),(441,3,7200,1,'BDST'),(441,4,3600,0,'BST'),(441,5,3600,1,'BST'),(441,6,0,0,'GMT'),(441,7,0,0,'GMT'),(442,0,5989,0,'LMT'),(442,1,5989,0,'HMT'),(442,2,10800,1,'EEST'),(442,3,7200,0,'EET'),(442,4,10800,1,'EEST'),(442,5,7200,0,'EET'),(443,0,-75,0,'LMT'),(443,1,3600,1,'BST'),(443,2,0,0,'GMT'),(443,3,7200,1,'BDST'),(443,4,3600,0,'BST'),(443,5,3600,1,'BST'),(443,6,0,0,'GMT'),(443,7,0,0,'GMT'),(444,0,6952,0,'LMT'),(444,1,7016,0,'IMT'),(444,2,10800,1,'EEST'),(444,3,7200,0,'EET'),(444,4,14400,1,'+04'),(444,5,10800,0,'+03'),(444,6,10800,1,'EEST'),(444,7,7200,0,'EET'),(444,8,10800,1,'EEST'),(444,9,7200,0,'EET'),(444,10,10800,0,'+03'),(445,0,-75,0,'LMT'),(445,1,3600,1,'BST'),(445,2,0,0,'GMT'),(445,3,7200,1,'BDST'),(445,4,3600,0,'BST'),(445,5,3600,1,'BST'),(445,6,0,0,'GMT'),(445,7,0,0,'GMT'),(446,0,4920,0,'LMT'),(446,1,7200,1,'CEST'),(446,2,3600,0,'CET'),(446,3,7200,1,'CEST'),(446,4,3600,0,'CET'),(446,5,10800,1,'CEST'),(446,6,7200,0,'CET'),(446,7,14400,1,'MSD'),(446,8,10800,0,'MSK'),(446,9,10800,0,'MSK'),(446,10,14400,1,'MSD'),(446,11,10800,1,'EEST'),(446,12,7200,0,'EET'),(446,13,10800,0,'+03'),(446,14,7200,0,'EET'),(447,0,7324,0,'LMT'),(447,1,7324,0,'KMT'),(447,2,7200,0,'EET'),(447,3,10800,0,'MSK'),(447,4,3600,0,'CET'),(447,5,7200,1,'CEST'),(447,6,7200,1,'CEST'),(447,7,14400,1,'MSD'),(447,8,10800,0,'MSK'),(447,9,14400,1,'MSD'),(447,10,10800,1,'EEST'),(447,11,10800,1,'EEST'),(447,12,7200,0,'EET'),(448,0,11928,0,'LMT'),(448,1,10800,0,'+03'),(448,2,18000,1,'+05'),(448,3,14400,0,'+04'),(448,4,14400,0,'+04'),(448,5,18000,1,'+05'),(448,6,14400,1,'+04'),(448,7,10800,0,'+03'),(449,0,-2205,0,'LMT'),(449,1,3600,1,'WEST'),(449,2,0,0,'WET'),(449,3,3600,1,'WEST'),(449,4,0,0,'WET'),(449,5,7200,1,'WEMT'),(449,6,0,0,'WET'),(449,7,3600,0,'CET'),(449,8,3600,0,'CET'),(449,9,7200,1,'CEST'),(449,10,3600,1,'WEST'),(449,11,0,0,'WET'),(450,0,4920,0,'LMT'),(450,1,3600,0,'CET'),(450,2,3600,0,'CET'),(450,3,7200,1,'CEST'),(450,4,7200,1,'CEST'),(450,5,7200,1,'CEST'),(450,6,3600,0,'CET'),(451,0,-75,0,'LMT'),(451,1,3600,1,'BST'),(451,2,0,0,'GMT'),(451,3,7200,1,'BDST'),(451,4,3600,0,'BST'),(451,5,3600,1,'BST'),(451,6,0,0,'GMT'),(451,7,0,0,'GMT'),(452,0,1476,0,'LMT'),(452,1,7200,1,'CEST'),(452,2,3600,0,'CET'),(452,3,7200,1,'CEST'),(452,4,3600,0,'CET'),(452,5,3600,1,'WEST'),(452,6,0,0,'WET'),(452,7,0,0,'WET'),(452,8,3600,1,'WEST'),(452,9,3600,0,'WET'),(452,10,7200,1,'WEST'),(452,11,7200,1,'WEST'),(452,12,7200,1,'CEST'),(452,13,3600,0,'CET'),(453,0,-884,0,'LMT'),(453,1,3600,1,'WEST'),(453,2,0,0,'WET'),(453,3,7200,1,'WEMT'),(453,4,0,0,'WET'),(453,5,7200,1,'CEST'),(453,6,3600,0,'CET'),(453,7,7200,1,'CEST'),(453,8,3600,0,'CET'),(453,9,7200,1,'CEST'),(453,10,3600,0,'CET'),(454,0,3484,0,'LMT'),(454,1,7200,1,'CEST'),(454,2,3600,0,'CET'),(454,3,3600,0,'CET'),(454,4,7200,1,'CEST'),(454,5,7200,1,'CEST'),(454,6,3600,0,'CET'),(455,0,5989,0,'LMT'),(455,1,5989,0,'HMT'),(455,2,10800,1,'EEST'),(455,3,7200,0,'EET'),(455,4,10800,1,'EEST'),(455,5,7200,0,'EET'),(456,0,6616,0,'LMT'),(456,1,6600,0,'MMT'),(456,2,7200,0,'EET'),(456,3,10800,0,'MSK'),(456,4,3600,0,'CET'),(456,5,7200,1,'CEST'),(456,6,7200,1,'CEST'),(456,7,14400,1,'MSD'),(456,8,10800,0,'MSK'),(456,9,14400,1,'MSD'),(456,10,10800,1,'EEST'),(456,11,7200,0,'EET'),(456,12,10800,0,'+03'),(457,0,1772,0,'LMT'),(457,1,561,0,'PMT'),(457,2,3600,1,'WEST'),(457,3,0,0,'WET'),(457,4,3600,1,'WEST'),(457,5,7200,1,'WEMT'),(457,6,0,0,'WET'),(457,7,7200,1,'CEST'),(457,8,3600,0,'CET'),(457,9,7200,1,'CEST'),(457,10,3600,0,'CET'),(458,0,9017,0,'LMT'),(458,1,9017,0,'MMT'),(458,2,12679,1,'MST'),(458,3,9079,0,'MMT'),(458,4,16279,1,'MDST'),(458,5,14400,1,'MSD'),(458,6,10800,0,'MSK'),(458,7,14400,1,'MSD'),(458,8,18000,1,'+05'),(458,9,7200,0,'EET'),(458,10,10800,0,'MSK'),(458,11,14400,1,'MSD'),(458,12,10800,1,'EEST'),(458,13,7200,0,'EET'),(458,14,14400,0,'MSK'),(458,15,14400,1,'MSD'),(458,16,10800,0,'MSK'),(459,0,8008,0,'LMT'),(459,1,10800,1,'EEST'),(459,2,7200,0,'EET'),(459,3,7200,0,'EET'),(459,4,10800,1,'EEST'),(460,0,2580,0,'LMT'),(460,1,7200,1,'CEST'),(460,2,3600,0,'CET'),(460,3,3600,0,'CET'),(460,4,7200,1,'CEST'),(460,5,7200,1,'CEST'),(460,6,3600,0,'CET'),(461,0,561,0,'LMT'),(461,1,561,0,'PMT'),(461,2,3600,1,'WEST'),(461,3,0,0,'WET'),(461,4,3600,1,'WEST'),(461,5,0,0,'WET'),(461,6,3600,0,'CET'),(461,7,7200,1,'CEST'),(461,8,7200,1,'CEST'),(461,9,7200,1,'WEMT'),(461,10,3600,0,'CET'),(461,11,7200,1,'CEST'),(461,12,3600,0,'CET'),(462,0,4920,0,'LMT'),(462,1,3600,0,'CET'),(462,2,3600,0,'CET'),(462,3,7200,1,'CEST'),(462,4,7200,1,'CEST'),(462,5,7200,1,'CEST'),(462,6,3600,0,'CET'),(463,0,3464,0,'PMT'),(463,1,7200,1,'CEST'),(463,2,3600,0,'CET'),(463,3,7200,1,'CEST'),(463,4,3600,0,'CET'),(463,5,0,1,'GMT'),(463,6,7200,1,'CEST'),(463,7,3600,0,'CET'),(464,0,5794,0,'LMT'),(464,1,5794,0,'RMT'),(464,2,9394,1,'LST'),(464,3,7200,0,'EET'),(464,4,10800,0,'MSK'),(464,5,3600,0,'CET'),(464,6,7200,1,'CEST'),(464,7,7200,1,'CEST'),(464,8,14400,1,'MSD'),(464,9,10800,0,'MSK'),(464,10,14400,1,'MSD'),(464,11,10800,1,'EEST'),(464,12,7200,0,'EET'),(464,13,10800,1,'EEST'),(464,14,7200,0,'EET'),(465,0,2996,0,'RMT'),(465,1,7200,1,'CEST'),(465,2,3600,0,'CET'),(465,3,3600,0,'CET'),(465,4,7200,1,'CEST'),(465,5,7200,1,'CEST'),(465,6,3600,0,'CET'),(466,0,12020,0,'LMT'),(466,1,10800,0,'+03'),(466,2,14400,0,'+04'),(466,3,18000,1,'+05'),(466,4,14400,0,'+04'),(466,5,18000,1,'+05'),(466,6,14400,1,'+04'),(466,7,10800,0,'+03'),(466,8,10800,1,'+03'),(466,9,7200,0,'+02'),(466,10,14400,1,'+04'),(466,11,14400,0,'+04'),(467,0,2996,0,'RMT'),(467,1,7200,1,'CEST'),(467,2,3600,0,'CET'),(467,3,3600,0,'CET'),(467,4,7200,1,'CEST'),(467,5,7200,1,'CEST'),(467,6,3600,0,'CET'),(468,0,4920,0,'LMT'),(468,1,3600,0,'CET'),(468,2,3600,0,'CET'),(468,3,7200,1,'CEST'),(468,4,7200,1,'CEST'),(468,5,7200,1,'CEST'),(468,6,3600,0,'CET'),(469,0,11058,0,'LMT'),(469,1,10800,0,'+03'),(469,2,18000,1,'+05'),(469,3,14400,0,'+04'),(469,4,14400,0,'+04'),(469,5,18000,1,'+05'),(469,6,14400,1,'+04'),(469,7,10800,0,'+03'),(469,8,14400,0,'+04'),(470,0,8184,0,'LMT'),(470,1,8160,0,'SMT'),(470,2,7200,0,'EET'),(470,3,10800,0,'MSK'),(470,4,3600,0,'CET'),(470,5,7200,1,'CEST'),(470,6,7200,1,'CEST'),(470,7,14400,1,'MSD'),(470,8,10800,0,'MSK'),(470,9,14400,1,'MSD'),(470,10,10800,1,'EEST'),(470,11,10800,1,'EEST'),(470,12,7200,0,'EET'),(470,13,14400,0,'MSK'),(470,14,10800,0,'MSK'),(471,0,4920,0,'LMT'),(471,1,3600,0,'CET'),(471,2,3600,0,'CET'),(471,3,7200,1,'CEST'),(471,4,7200,1,'CEST'),(471,5,7200,1,'CEST'),(471,6,3600,0,'CET'),(472,0,7016,0,'IMT'),(472,1,7200,0,'EET'),(472,2,3600,0,'CET'),(472,3,7200,1,'CEST'),(472,4,3600,0,'CET'),(472,5,10800,1,'EEST'),(472,6,7200,0,'EET'),(472,7,10800,1,'EEST'),(472,8,10800,1,'EEST'),(472,9,7200,0,'EET'),(473,0,3614,0,'SET'),(473,1,3600,0,'CET'),(473,2,7200,1,'CEST'),(473,3,7200,1,'CEST'),(473,4,3600,0,'CET'),(474,0,5940,0,'LMT'),(474,1,5940,0,'TMT'),(474,2,7200,1,'CEST'),(474,3,3600,0,'CET'),(474,4,3600,0,'CET'),(474,5,7200,0,'EET'),(474,6,10800,0,'MSK'),(474,7,7200,1,'CEST'),(474,8,14400,1,'MSD'),(474,9,10800,0,'MSK'),(474,10,14400,1,'MSD'),(474,11,10800,1,'EEST'),(474,12,7200,0,'EET'),(474,13,7200,0,'EET'),(474,14,10800,1,'EEST'),(474,15,10800,1,'EEST'),(475,0,4760,0,'LMT'),(475,1,3600,0,'CET'),(475,2,7200,1,'CEST'),(475,3,3600,0,'CET'),(475,4,7200,1,'CEST'),(476,0,6920,0,'LMT'),(476,1,6900,0,'CMT'),(476,2,6264,0,'BMT'),(476,3,10800,1,'EEST'),(476,4,7200,0,'EET'),(476,5,7200,0,'EET'),(476,6,10800,1,'EEST'),(476,7,3600,0,'CET'),(476,8,7200,1,'CEST'),(476,9,7200,1,'CEST'),(476,10,14400,1,'MSD'),(476,11,10800,0,'MSK'),(476,12,10800,0,'MSK'),(476,13,14400,1,'MSD'),(476,14,10800,1,'EEST'),(476,15,7200,0,'EET'),(477,0,11616,0,'LMT'),(477,1,10800,0,'+03'),(477,2,18000,1,'+05'),(477,3,14400,0,'+04'),(477,4,14400,0,'+04'),(477,5,18000,1,'+05'),(477,6,14400,1,'+04'),(477,7,10800,0,'+03'),(477,8,10800,1,'+03'),(477,9,7200,0,'+02'),(477,10,14400,1,'+04'),(477,11,14400,0,'+04'),(478,0,5352,0,'LMT'),(478,1,3600,0,'CET'),(478,2,7200,1,'CEST'),(478,3,3600,0,'CET'),(478,4,7200,1,'CEST'),(478,5,14400,1,'MSD'),(478,6,10800,0,'MSK'),(478,7,10800,0,'MSK'),(478,8,14400,1,'MSD'),(478,9,7200,0,'EET'),(478,10,10800,1,'EEST'),(478,11,10800,1,'EEST'),(478,12,7200,0,'EET'),(479,0,1786,0,'BMT'),(479,1,7200,1,'CEST'),(479,2,3600,0,'CET'),(479,3,7200,1,'CEST'),(479,4,3600,0,'CET'),(480,0,2996,0,'RMT'),(480,1,7200,1,'CEST'),(480,2,3600,0,'CET'),(480,3,3600,0,'CET'),(480,4,7200,1,'CEST'),(480,5,7200,1,'CEST'),(480,6,3600,0,'CET'),(481,0,3921,0,'LMT'),(481,1,7200,1,'CEST'),(481,2,3600,0,'CET'),(481,3,7200,1,'CEST'),(481,4,3600,0,'CET'),(481,5,7200,1,'CEST'),(481,6,3600,0,'CET'),(482,0,6076,0,'LMT'),(482,1,5040,0,'WMT'),(482,2,5736,0,'KMT'),(482,3,3600,0,'CET'),(482,4,7200,0,'EET'),(482,5,10800,0,'MSK'),(482,6,3600,0,'CET'),(482,7,7200,1,'CEST'),(482,8,7200,1,'CEST'),(482,9,14400,1,'MSD'),(482,10,10800,0,'MSK'),(482,11,14400,1,'MSD'),(482,12,10800,1,'EEST'),(482,13,7200,0,'EET'),(482,14,7200,1,'CEST'),(482,15,3600,0,'CET'),(482,16,7200,0,'EET'),(482,17,10800,1,'EEST'),(483,0,10660,0,'LMT'),(483,1,10800,0,'+03'),(483,2,14400,0,'+04'),(483,3,18000,1,'+05'),(483,4,14400,0,'+04'),(483,5,18000,1,'+05'),(483,6,14400,1,'+04'),(483,7,10800,0,'+03'),(483,8,14400,0,'+04'),(484,0,5040,0,'LMT'),(484,1,5040,0,'WMT'),(484,2,7200,1,'CEST'),(484,3,3600,0,'CET'),(484,4,7200,1,'CEST'),(484,5,3600,0,'CET'),(484,6,10800,1,'EEST'),(484,7,7200,0,'EET'),(484,8,7200,0,'EET'),(484,9,7200,1,'CEST'),(484,10,3600,0,'CET'),(485,0,4920,0,'LMT'),(485,1,3600,0,'CET'),(485,2,3600,0,'CET'),(485,3,7200,1,'CEST'),(485,4,7200,1,'CEST'),(485,5,7200,1,'CEST'),(485,6,3600,0,'CET'),(486,0,8440,0,'LMT'),(486,1,8400,0,'+0220'),(486,2,7200,0,'EET'),(486,3,10800,0,'MSK'),(486,4,3600,0,'CET'),(486,5,7200,1,'CEST'),(486,6,7200,1,'CEST'),(486,7,14400,1,'MSD'),(486,8,10800,0,'MSK'),(486,9,14400,1,'MSD'),(486,10,10800,1,'EEST'),(486,11,10800,1,'EEST'),(486,12,7200,0,'EET'),(487,0,1786,0,'BMT'),(487,1,7200,1,'CEST'),(487,2,3600,0,'CET'),(487,3,7200,1,'CEST'),(487,4,3600,0,'CET'),(488,0,-75,0,'LMT'),(488,1,3600,1,'BST'),(488,2,0,0,'GMT'),(488,3,7200,1,'BDST'),(488,4,3600,0,'BST'),(488,5,3600,1,'BST'),(488,6,0,0,'GMT'),(488,7,0,0,'GMT'),(489,0,-75,0,'LMT'),(489,1,3600,1,'BST'),(489,2,0,0,'GMT'),(489,3,7200,1,'BDST'),(489,4,3600,0,'BST'),(489,5,3600,1,'BST'),(489,6,0,0,'GMT'),(489,7,0,0,'GMT'),(490,0,0,0,'GMT'),(491,0,0,0,'GMT'),(492,0,0,0,'GMT'),(493,0,0,0,'GMT'),(494,0,0,0,'GMT'),(495,0,-36000,0,'HST'),(496,0,27402,0,'LMT'),(496,1,28800,0,'HKT'),(496,2,32400,1,'HKST'),(496,3,30600,0,'HKT'),(496,4,32400,0,'JST'),(496,5,28800,0,'HKT'),(497,0,-5280,0,'LMT'),(497,1,0,1,'+00'),(497,2,-3600,0,'-01'),(497,3,-3600,0,'-01'),(497,4,0,1,'+00'),(497,5,0,0,'GMT'),(498,0,8836,0,'LMT'),(498,1,10800,0,'EAT'),(498,2,9000,0,'+0230'),(498,3,9900,0,'+0245'),(498,4,10800,0,'EAT'),(499,0,17380,0,'LMT'),(499,1,18000,0,'+05'),(499,2,21600,0,'+06'),(500,0,25372,0,'LMT'),(500,1,25200,0,'+07'),(501,0,23260,0,'LMT'),(501,1,23400,0,'+0630'),(502,0,8836,0,'LMT'),(502,1,10800,0,'EAT'),(502,2,9000,0,'+0230'),(502,3,9900,0,'+0245'),(502,4,10800,0,'EAT'),(503,0,0,0,'-00'),(503,1,18000,0,'+05'),(504,0,13308,0,'LMT'),(504,1,14400,0,'+04'),(505,0,17640,0,'LMT'),(505,1,17640,0,'MMT'),(505,2,18000,0,'+05'),(506,0,13800,0,'LMT'),(506,1,18000,1,'+05'),(506,2,14400,0,'+04'),(507,0,8836,0,'LMT'),(507,1,10800,0,'EAT'),(507,2,9000,0,'+0230'),(507,3,9900,0,'+0245'),(507,4,10800,0,'EAT'),(508,0,13312,0,'LMT'),(508,1,14400,0,'+04'),(509,0,12344,0,'LMT'),(509,1,12344,0,'TMT'),(509,2,12600,0,'+0330'),(509,3,18000,1,'+05'),(509,4,14400,0,'+04'),(509,5,16200,1,'+0430'),(509,6,12600,0,'+0330'),(510,0,8454,0,'LMT'),(510,1,8440,0,'JMT'),(510,2,10800,1,'IDT'),(510,3,7200,0,'IST'),(510,4,14400,1,'IDDT'),(510,5,10800,1,'IDT'),(511,0,-18430,0,'LMT'),(511,1,-18430,0,'KMT'),(511,2,-18000,0,'EST'),(511,3,-14400,1,'EDT'),(512,0,33539,0,'LMT'),(512,1,36000,1,'JDT'),(512,2,32400,0,'JST'),(512,3,32400,0,'JST'),(513,0,40160,0,'LMT'),(513,1,39600,0,'+11'),(513,2,36000,0,'+10'),(513,3,32400,0,'+09'),(513,4,-43200,0,'-12'),(513,5,43200,0,'+12'),(514,0,3164,0,'LMT'),(514,1,7200,1,'CEST'),(514,2,3600,0,'CET'),(514,3,7200,0,'EET'),(515,0,7200,1,'MEST'),(515,1,3600,0,'MET'),(515,2,7200,1,'MEST'),(515,3,3600,0,'MET'),(516,0,-25200,0,'MST'),(517,0,-21600,1,'MDT'),(517,1,-25200,0,'MST'),(517,2,-21600,1,'MWT'),(517,3,-21600,1,'MPT'),(518,0,-28084,0,'LMT'),(518,1,-25200,0,'MST'),(518,2,-28800,0,'PST'),(518,3,-25200,1,'PDT'),(518,4,-25200,1,'PWT'),(518,5,-25200,1,'PPT'),(519,0,-25540,0,'LMT'),(519,1,-25200,0,'MST'),(519,2,-21600,0,'CST'),(519,3,-28800,0,'PST'),(519,4,-21600,1,'MDT'),(519,5,-25200,0,'MST'),(520,0,-23796,0,'LMT'),(520,1,-25200,0,'MST'),(520,2,-21600,0,'CST'),(520,3,-18000,1,'CDT'),(520,4,-18000,1,'CWT'),(521,0,41944,0,'LMT'),(521,1,45000,1,'NZST'),(521,2,41400,0,'NZMT'),(521,3,43200,1,'NZST'),(521,4,46800,1,'NZDT'),(521,5,43200,0,'NZST'),(521,6,43200,0,'NZST'),(522,0,44028,0,'LMT'),(522,1,44100,0,'+1215'),(522,2,49500,1,'+1345'),(522,3,45900,0,'+1245'),(522,4,45900,0,'+1245'),(523,0,-25196,0,'LMT'),(523,1,-21600,1,'MDT'),(523,2,-25200,0,'MST'),(523,3,-21600,1,'MWT'),(523,4,-21600,1,'MPT'),(524,0,29143,0,'LMT'),(524,1,32400,1,'CDT'),(524,2,28800,0,'CST'),(525,0,-25200,1,'PDT'),(525,1,-28800,0,'PST'),(525,2,-25200,1,'PWT'),(525,3,-25200,1,'PPT'),(526,0,45184,0,'LMT'),(526,1,-41216,0,'LMT'),(526,2,-41400,0,'-1130'),(526,3,-36000,1,'-10'),(526,4,-39600,0,'-11'),(526,5,46800,0,'+13'),(526,6,50400,1,'+14'),(527,0,41944,0,'LMT'),(527,1,45000,1,'NZST'),(527,2,41400,0,'NZMT'),(527,3,43200,1,'NZST'),(527,4,46800,1,'NZDT'),(527,5,43200,0,'NZST'),(527,6,43200,0,'NZST'),(528,0,35312,0,'PMMT'),(528,1,36000,0,'+10'),(528,2,32400,0,'+09'),(528,3,39600,0,'+11'),(529,0,44028,0,'LMT'),(529,1,44100,0,'+1215'),(529,2,49500,1,'+1345'),(529,3,45900,0,'+1245'),(529,4,45900,0,'+1245'),(530,0,36428,0,'LMT'),(530,1,36000,0,'+10'),(530,2,32400,0,'+09'),(530,3,36000,0,'+10'),(531,0,-26248,0,'LMT'),(531,1,-26248,0,'EMT'),(531,2,-21600,1,'-06'),(531,3,-25200,0,'-07'),(531,4,-25200,0,'-07'),(531,5,-21600,0,'-06'),(531,6,-18000,1,'-05'),(532,0,40396,0,'LMT'),(532,1,43200,1,'+12'),(532,2,39600,0,'+11'),(533,0,-41060,0,'LMT'),(533,1,-43200,0,'-12'),(533,2,-39600,0,'-11'),(533,3,46800,0,'+13'),(534,0,-41096,0,'LMT'),(534,1,-39600,0,'-11'),(534,2,46800,0,'+13'),(535,0,42944,0,'LMT'),(535,1,46800,1,'+13'),(535,2,43200,0,'+12'),(536,0,43012,0,'LMT'),(536,1,43200,0,'+12'),(537,0,-21504,0,'LMT'),(537,1,-18000,0,'-05'),(537,2,-18000,1,'-05'),(537,3,-21600,0,'-06'),(538,0,-32388,0,'LMT'),(538,1,-32400,0,'-09'),(539,0,38388,0,'LMT'),(539,1,39600,0,'+11'),(540,0,34740,0,'LMT'),(540,1,36000,0,'GST'),(540,2,32400,0,'+09'),(540,3,39600,1,'GDT'),(540,4,36000,0,'ChST'),(541,0,-37886,0,'LMT'),(541,1,-37800,0,'HST'),(541,2,-34200,1,'HDT'),(541,3,-34200,1,'HWT'),(541,4,-34200,1,'HPT'),(541,5,-36000,0,'HST'),(542,0,-37886,0,'LMT'),(542,1,-37800,0,'HST'),(542,2,-34200,1,'HDT'),(542,3,-34200,1,'HWT'),(542,4,-34200,1,'HPT'),(542,5,-36000,0,'HST'),(543,0,-37760,0,'LMT'),(543,1,-38400,0,'-1040'),(543,2,-36000,0,'-10'),(543,3,50400,0,'+14'),(544,0,39116,0,'LMT'),(544,1,39600,0,'+11'),(544,2,32400,0,'+09'),(544,3,36000,0,'+10'),(544,4,43200,0,'+12'),(544,5,39600,0,'+11'),(545,0,40160,0,'LMT'),(545,1,39600,0,'+11'),(545,2,36000,0,'+10'),(545,3,32400,0,'+09'),(545,4,-43200,0,'-12'),(545,5,43200,0,'+12'),(546,0,41088,0,'LMT'),(546,1,39600,0,'+11'),(546,2,32400,0,'+09'),(546,3,36000,0,'+10'),(546,4,43200,0,'+12'),(547,0,-33480,0,'LMT'),(547,1,-34200,0,'-0930'),(548,0,45432,0,'LMT'),(548,1,-40968,0,'LMT'),(548,2,-39600,0,'SST'),(549,0,40060,0,'LMT'),(549,1,41400,0,'+1130'),(549,2,32400,0,'+09'),(549,3,43200,0,'+12'),(550,0,-40780,0,'LMT'),(550,1,-40800,0,'-1120'),(550,2,-41400,0,'-1130'),(550,3,-39600,0,'-11'),(551,0,40312,0,'LMT'),(551,1,40320,0,'+1112'),(551,2,41400,0,'+1130'),(551,3,45000,1,'+1230'),(551,4,39600,0,'+11'),(552,0,39948,0,'LMT'),(552,1,43200,1,'+12'),(552,2,39600,0,'+11'),(552,3,43200,1,'+12'),(552,4,39600,0,'+11'),(553,0,45432,0,'LMT'),(553,1,-40968,0,'LMT'),(553,2,-39600,0,'SST'),(554,0,32276,0,'LMT'),(554,1,32400,0,'+09'),(555,0,-31220,0,'LMT'),(555,1,-30600,0,'-0830'),(555,2,-28800,0,'-08'),(556,0,37972,0,'LMT'),(556,1,39600,0,'+11'),(556,2,32400,0,'+09'),(556,3,36000,0,'+10'),(556,4,39600,0,'+11'),(557,0,37972,0,'LMT'),(557,1,39600,0,'+11'),(557,2,32400,0,'+09'),(557,3,36000,0,'+10'),(557,4,39600,0,'+11'),(558,0,35312,0,'PMMT'),(558,1,36000,0,'+10'),(559,0,-38344,0,'LMT'),(559,1,-37800,0,'-1030'),(559,2,-36000,0,'-10'),(559,3,-34200,1,'-0930'),(560,0,34740,0,'LMT'),(560,1,36000,0,'GST'),(560,2,32400,0,'+09'),(560,3,39600,1,'GDT'),(560,4,36000,0,'ChST'),(561,0,45432,0,'LMT'),(561,1,-40968,0,'LMT'),(561,2,-39600,0,'SST'),(562,0,-35896,0,'LMT'),(562,1,-36000,0,'-10'),(563,0,41524,0,'LMT'),(563,1,43200,0,'+12'),(564,0,44360,0,'LMT'),(564,1,44400,0,'+1220'),(564,2,46800,0,'+13'),(564,3,50400,1,'+14'),(564,4,46800,0,'+13'),(564,5,50400,1,'+14'),(565,0,36428,0,'LMT'),(565,1,36000,0,'+10'),(565,2,32400,0,'+09'),(565,3,36000,0,'+10'),(566,0,39988,0,'LMT'),(566,1,43200,0,'+12'),(567,0,44120,0,'LMT'),(567,1,43200,0,'+12'),(568,0,36428,0,'LMT'),(568,1,36000,0,'+10'),(568,2,32400,0,'+09'),(568,3,36000,0,'+10'),(569,0,5040,0,'LMT'),(569,1,5040,0,'WMT'),(569,2,7200,1,'CEST'),(569,3,3600,0,'CET'),(569,4,7200,1,'CEST'),(569,5,3600,0,'CET'),(569,6,10800,1,'EEST'),(569,7,7200,0,'EET'),(569,8,7200,0,'EET'),(569,9,7200,1,'CEST'),(569,10,3600,0,'CET'),(570,0,-2205,0,'LMT'),(570,1,3600,1,'WEST'),(570,2,0,0,'WET'),(570,3,3600,1,'WEST'),(570,4,0,0,'WET'),(570,5,7200,1,'WEMT'),(570,6,0,0,'WET'),(570,7,3600,0,'CET'),(570,8,3600,0,'CET'),(570,9,7200,1,'CEST'),(570,10,3600,1,'WEST'),(570,11,0,0,'WET'),(571,0,29160,0,'LMT'),(571,1,28800,0,'CST'),(571,2,32400,0,'JST'),(571,3,32400,1,'CDT'),(571,4,28800,0,'CST'),(572,0,30472,0,'LMT'),(572,1,30600,0,'KST'),(572,2,32400,0,'JST'),(572,3,32400,0,'KST'),(572,4,34200,1,'KDT'),(572,5,36000,1,'KDT'),(573,0,24925,0,'LMT'),(573,1,24925,0,'SMT'),(573,2,25200,0,'+07'),(573,3,26400,1,'+0720'),(573,4,26400,0,'+0720'),(573,5,27000,0,'+0730'),(573,6,32400,0,'+09'),(573,7,28800,0,'+08'),(574,0,-15865,0,'LMT'),(574,1,-14400,0,'AST'),(574,2,-10800,1,'APT'),(574,3,-10800,1,'AWT'),(575,0,-15264,0,'LMT'),(575,1,-10800,1,'ADT'),(575,2,-14400,0,'AST'),(575,3,-10800,1,'AWT'),(575,4,-10800,1,'APT'),(576,0,-25116,0,'LMT'),(576,1,-21600,1,'MDT'),(576,2,-25200,0,'MST'),(576,3,-21600,1,'MWT'),(576,4,-21600,1,'MPT'),(576,5,-21600,0,'CST'),(577,0,-21036,0,'LMT'),(577,1,-18000,1,'CDT'),(577,2,-21600,0,'CST'),(577,3,-18000,0,'EST'),(577,4,-18000,1,'CWT'),(577,5,-18000,1,'CPT'),(577,6,-21600,0,'CST'),(578,0,-19088,0,'LMT'),(578,1,-19176,0,'CMT'),(578,2,-18000,0,'EST'),(579,0,-17762,0,'LMT'),(579,1,-14400,1,'EDT'),(579,2,-18000,0,'EST'),(579,3,-14400,1,'EWT'),(579,4,-14400,1,'EPT'),(580,0,-37886,0,'LMT'),(580,1,-37800,0,'HST'),(580,2,-34200,1,'HDT'),(580,3,-34200,1,'HWT'),(580,4,-34200,1,'HPT'),(580,5,-36000,0,'HST'),(581,0,-26898,0,'LMT'),(581,1,-21600,1,'MDT'),(581,2,-25200,0,'MST'),(581,3,-21600,1,'MWT'),(582,0,-25196,0,'LMT'),(582,1,-21600,1,'MDT'),(582,2,-25200,0,'MST'),(582,3,-21600,1,'MWT'),(582,4,-21600,1,'MPT'),(583,0,-31220,0,'LMT'),(583,1,-30600,0,'-0830'),(583,2,-28800,0,'-08'),(584,0,-28378,0,'LMT'),(584,1,-25200,1,'PDT'),(584,2,-28800,0,'PST'),(584,3,-25200,1,'PWT'),(584,4,-25200,1,'PPT'),(585,0,-32388,0,'LMT'),(585,1,-32400,0,'-09'),(586,0,-35976,0,'LMT'),(586,1,-36000,0,'AST'),(586,2,-32400,1,'AWT'),(586,3,-32400,1,'APT'),(586,4,-36000,0,'AHST'),(586,5,-32400,1,'AHDT'),(586,6,-32400,0,'YST'),(586,7,-28800,1,'AKDT'),(586,8,-32400,0,'AKST'),(587,0,6952,0,'LMT'),(587,1,7016,0,'IMT'),(587,2,10800,1,'EEST'),(587,3,7200,0,'EET'),(587,4,14400,1,'+04'),(587,5,10800,0,'+03'),(587,6,10800,1,'EEST'),(587,7,7200,0,'EET'),(587,8,10800,1,'EEST'),(587,9,7200,0,'EET'),(587,10,10800,0,'+03'),(588,0,0,0,'UTC'),(589,0,-35976,0,'LMT'),(589,1,-36000,0,'AST'),(589,2,-32400,1,'AWT'),(589,3,-32400,1,'APT'),(589,4,-36000,0,'AHST'),(589,5,-32400,1,'AHDT'),(589,6,-32400,0,'YST'),(589,7,-28800,1,'AKDT'),(589,8,-32400,0,'AKST'),(590,0,-42398,0,'LMT'),(590,1,-39600,0,'NST'),(590,2,-36000,1,'NWT'),(590,3,-36000,1,'NPT'),(590,4,-39600,0,'BST'),(590,5,-36000,1,'BDT'),(590,6,-36000,0,'AHST'),(590,7,-32400,1,'HDT'),(590,8,-36000,0,'HST'),(591,0,-26898,0,'LMT'),(591,1,-21600,1,'MDT'),(591,2,-25200,0,'MST'),(591,3,-21600,1,'MWT'),(592,0,-21036,0,'LMT'),(592,1,-18000,1,'CDT'),(592,2,-21600,0,'CST'),(592,3,-18000,0,'EST'),(592,4,-18000,1,'CWT'),(592,5,-18000,1,'CPT'),(592,6,-21600,0,'CST'),(593,0,-20678,0,'LMT'),(593,1,-18000,1,'CDT'),(593,2,-21600,0,'CST'),(593,3,-18000,1,'CWT'),(593,4,-18000,1,'CPT'),(593,5,-18000,0,'EST'),(593,6,-14400,1,'EDT'),(594,0,-17762,0,'LMT'),(594,1,-14400,1,'EDT'),(594,2,-18000,0,'EST'),(594,3,-14400,1,'EWT'),(594,4,-14400,1,'EPT'),(595,0,-37886,0,'LMT'),(595,1,-37800,0,'HST'),(595,2,-34200,1,'HDT'),(595,3,-34200,1,'HWT'),(595,4,-34200,1,'HPT'),(595,5,-36000,0,'HST'),(596,0,-20790,0,'LMT'),(596,1,-18000,1,'CDT'),(596,2,-21600,0,'CST'),(596,3,-18000,1,'CWT'),(596,4,-18000,1,'CPT'),(596,5,-18000,0,'EST'),(596,6,-21600,0,'CST'),(597,0,-19931,0,'LMT'),(597,1,-21600,0,'CST'),(597,2,-18000,0,'EST'),(597,3,-14400,1,'EWT'),(597,4,-14400,1,'EPT'),(597,5,-14400,1,'EDT'),(598,0,-25196,0,'LMT'),(598,1,-21600,1,'MDT'),(598,2,-25200,0,'MST'),(598,3,-21600,1,'MWT'),(598,4,-21600,1,'MPT'),(599,0,-28378,0,'LMT'),(599,1,-25200,1,'PDT'),(599,2,-28800,0,'PST'),(599,3,-25200,1,'PWT'),(599,4,-25200,1,'PPT'),(600,0,-28378,0,'LMT'),(600,1,-25200,1,'PDT'),(600,2,-28800,0,'PST'),(600,3,-25200,1,'PWT'),(600,4,-25200,1,'PPT'),(601,0,45432,0,'LMT'),(601,1,-40968,0,'LMT'),(601,2,-39600,0,'SST'),(602,0,0,0,'UTC'),(603,0,0,0,'UTC'),(604,0,9017,0,'LMT'),(604,1,9017,0,'MMT'),(604,2,12679,1,'MST'),(604,3,9079,0,'MMT'),(604,4,16279,1,'MDST'),(604,5,14400,1,'MSD'),(604,6,10800,0,'MSK'),(604,7,14400,1,'MSD'),(604,8,18000,1,'+05'),(604,9,7200,0,'EET'),(604,10,10800,0,'MSK'),(604,11,14400,1,'MSD'),(604,12,10800,1,'EEST'),(604,13,7200,0,'EET'),(604,14,14400,0,'MSK'),(604,15,14400,1,'MSD'),(604,16,10800,0,'MSK'),(605,0,3600,1,'WEST'),(605,1,0,0,'WET'),(606,0,0,0,'UTC'),(607,0,0,0,'UTC'),(608,0,-968,0,'LMT'),(608,1,0,0,'GMT'),(609,0,-52,0,'LMT'),(609,1,1200,1,'+0020'),(609,2,0,0,'GMT'),(610,0,8836,0,'LMT'),(610,1,10800,0,'EAT'),(610,2,9000,0,'+0230'),(610,3,9900,0,'+0245'),(610,4,10800,0,'EAT'),(611,0,732,0,'LMT'),(611,1,561,0,'PMT'),(611,2,3600,1,'WEST'),(611,3,0,0,'WET'),(611,4,0,0,'WET'),(611,5,7200,1,'CEST'),(611,6,3600,0,'CET'),(611,7,3600,1,'WEST'),(612,0,8836,0,'LMT'),(612,1,10800,0,'EAT'),(612,2,9000,0,'+0230'),(612,3,9900,0,'+0245'),(612,4,10800,0,'EAT'),(613,0,8836,0,'LMT'),(613,1,10800,0,'EAT'),(613,2,9000,0,'+0230'),(613,3,9900,0,'+0245'),(613,4,10800,0,'EAT'),(614,0,-968,0,'LMT'),(614,1,0,0,'GMT'),(615,0,816,0,'LMT'),(615,1,3600,0,'WAT'),(616,0,-968,0,'LMT'),(616,1,0,0,'GMT'),(617,0,-3740,0,'LMT'),(617,1,-3600,0,'-01'),(617,2,0,0,'GMT'),(618,0,7820,0,'LMT'),(618,1,7200,0,'CAT'),(619,0,816,0,'LMT'),(619,1,3600,0,'WAT'),(620,0,7820,0,'LMT'),(620,1,7200,0,'CAT'),(621,0,7509,0,'LMT'),(621,1,10800,1,'EEST'),(621,2,7200,0,'EET'),(621,3,10800,1,'EEST'),(622,0,-1820,0,'LMT'),(622,1,3600,1,'+01'),(622,2,0,0,'+00'),(622,3,3600,0,'+01'),(622,4,0,1,'+00'),(623,0,-1276,0,'LMT'),(623,1,0,0,'WET'),(623,2,3600,1,'WEST'),(623,3,0,0,'WET'),(623,4,3600,0,'CET'),(623,5,7200,1,'CEST'),(623,6,3600,0,'CET'),(624,0,-968,0,'LMT'),(624,1,0,0,'GMT'),(625,0,-968,0,'LMT'),(625,1,0,0,'GMT'),(626,0,8836,0,'LMT'),(626,1,10800,0,'EAT'),(626,2,9000,0,'+0230'),(626,3,9900,0,'+0245'),(626,4,10800,0,'EAT'),(627,0,8836,0,'LMT'),(627,1,10800,0,'EAT'),(627,2,9000,0,'+0230'),(627,3,9900,0,'+0245'),(627,4,10800,0,'EAT'),(628,0,816,0,'LMT'),(628,1,3600,0,'WAT'),(629,0,-3168,0,'LMT'),(629,1,-3600,0,'-01'),(629,2,3600,1,'+01'),(629,3,0,0,'+00'),(629,4,0,1,'+00'),(629,5,3600,0,'+01'),(630,0,-968,0,'LMT'),(630,1,0,0,'GMT'),(631,0,7820,0,'LMT'),(631,1,7200,0,'CAT'),(632,0,7820,0,'LMT'),(632,1,7200,0,'CAT'),(633,0,6720,0,'LMT'),(633,1,5400,0,'SAST'),(633,2,10800,1,'SAST'),(633,3,7200,0,'SAST'),(634,0,7588,0,'LMT'),(634,1,10800,1,'CAST'),(634,2,7200,0,'CAT'),(634,3,10800,0,'EAT'),(635,0,8836,0,'LMT'),(635,1,10800,0,'EAT'),(635,2,9000,0,'+0230'),(635,3,9900,0,'+0245'),(635,4,10800,0,'EAT'),(636,0,7808,0,'LMT'),(636,1,10800,1,'CAST'),(636,2,7200,0,'CAT'),(636,3,10800,0,'EAT'),(636,4,7200,0,'CAT'),(637,0,7820,0,'LMT'),(637,1,7200,0,'CAT'),(638,0,816,0,'LMT'),(638,1,3600,0,'WAT'),(639,0,816,0,'LMT'),(639,1,3600,0,'WAT'),(640,0,816,0,'LMT'),(640,1,3600,0,'WAT'),(641,0,-968,0,'LMT'),(641,1,0,0,'GMT'),(642,0,816,0,'LMT'),(642,1,3600,0,'WAT'),(643,0,7820,0,'LMT'),(643,1,7200,0,'CAT'),(644,0,7820,0,'LMT'),(644,1,7200,0,'CAT'),(645,0,816,0,'LMT'),(645,1,3600,0,'WAT'),(646,0,7820,0,'LMT'),(646,1,7200,0,'CAT'),(647,0,6720,0,'LMT'),(647,1,5400,0,'SAST'),(647,2,10800,1,'SAST'),(647,3,7200,0,'SAST'),(648,0,6720,0,'LMT'),(648,1,5400,0,'SAST'),(648,2,10800,1,'SAST'),(648,3,7200,0,'SAST'),(649,0,8836,0,'LMT'),(649,1,10800,0,'EAT'),(649,2,9000,0,'+0230'),(649,3,9900,0,'+0245'),(649,4,10800,0,'EAT'),(650,0,-2588,0,'LMT'),(650,1,-2588,0,'MMT'),(650,2,-2670,0,'MMT'),(650,3,0,0,'GMT'),(651,0,8836,0,'LMT'),(651,1,10800,0,'EAT'),(651,2,9000,0,'+0230'),(651,3,9900,0,'+0245'),(651,4,10800,0,'EAT'),(652,0,3612,0,'LMT'),(652,1,3600,0,'WAT'),(652,2,7200,1,'WAST'),(653,0,816,0,'LMT'),(653,1,3600,0,'WAT'),(654,0,-968,0,'LMT'),(654,1,0,0,'GMT'),(655,0,-968,0,'LMT'),(655,1,0,0,'GMT'),(656,0,816,0,'LMT'),(656,1,3600,0,'WAT'),(657,0,1616,0,'LMT'),(657,1,-2205,0,'LMT'),(657,2,0,0,'GMT'),(657,3,3600,0,'WAT'),(657,4,0,0,'GMT'),(658,0,-968,0,'LMT'),(658,1,0,0,'GMT'),(659,0,3164,0,'LMT'),(659,1,7200,1,'CEST'),(659,2,3600,0,'CET'),(659,3,7200,0,'EET'),(660,0,2444,0,'LMT'),(660,1,561,0,'PMT'),(660,2,7200,1,'CEST'),(660,3,3600,0,'CET'),(660,4,3600,0,'CET'),(660,5,7200,1,'CEST'),(661,0,4104,0,'LMT'),(661,1,5400,0,'+0130'),(661,2,7200,0,'SAST'),(661,3,10800,1,'SAST'),(661,4,3600,1,'WAT'),(661,5,7200,0,'CAT'),(662,0,-42398,0,'LMT'),(662,1,-39600,0,'NST'),(662,2,-36000,1,'NWT'),(662,3,-36000,1,'NPT'),(662,4,-39600,0,'BST'),(662,5,-36000,1,'BDT'),(662,6,-36000,0,'AHST'),(662,7,-32400,1,'HDT'),(662,8,-36000,0,'HST'),(663,0,-35976,0,'LMT'),(663,1,-36000,0,'AST'),(663,2,-32400,1,'AWT'),(663,3,-32400,1,'APT'),(663,4,-36000,0,'AHST'),(663,5,-32400,1,'AHDT'),(663,6,-32400,0,'YST'),(663,7,-28800,1,'AKDT'),(663,8,-32400,0,'AKST'),(664,0,-14764,0,'LMT'),(664,1,-14400,0,'AST'),(665,0,-14764,0,'LMT'),(665,1,-14400,0,'AST'),(666,0,-11568,0,'LMT'),(666,1,-7200,1,'-02'),(666,2,-10800,0,'-03'),(667,0,-14028,0,'LMT'),(667,1,-15408,0,'CMT'),(667,2,-14400,0,'-04'),(667,3,-10800,1,'-03'),(667,4,-7200,1,'-02'),(667,5,-10800,0,'-03'),(668,0,-15788,0,'LMT'),(668,1,-15408,0,'CMT'),(668,2,-14400,0,'-04'),(668,3,-10800,1,'-03'),(668,4,-7200,1,'-02'),(668,5,-10800,0,'-03'),(669,0,-15788,0,'LMT'),(669,1,-15408,0,'CMT'),(669,2,-14400,0,'-04'),(669,3,-10800,1,'-03'),(669,4,-7200,1,'-02'),(669,5,-10800,0,'-03'),(670,0,-15408,0,'LMT'),(670,1,-15408,0,'CMT'),(670,2,-14400,0,'-04'),(670,3,-10800,1,'-03'),(670,4,-7200,1,'-02'),(670,5,-10800,0,'-03'),(671,0,-15672,0,'LMT'),(671,1,-15408,0,'CMT'),(671,2,-14400,0,'-04'),(671,3,-10800,1,'-03'),(671,4,-7200,1,'-02'),(671,5,-10800,0,'-03'),(672,0,-16044,0,'LMT'),(672,1,-15408,0,'CMT'),(672,2,-14400,0,'-04'),(672,3,-10800,1,'-03'),(672,4,-7200,1,'-02'),(672,5,-10800,0,'-03'),(673,0,-16516,0,'LMT'),(673,1,-15408,0,'CMT'),(673,2,-14400,0,'-04'),(673,3,-10800,1,'-03'),(673,4,-7200,1,'-02'),(673,5,-10800,0,'-03'),(674,0,-16612,0,'LMT'),(674,1,-15408,0,'CMT'),(674,2,-14400,0,'-04'),(674,3,-10800,1,'-03'),(674,4,-7200,1,'-02'),(674,5,-10800,0,'-03'),(675,0,-15700,0,'LMT'),(675,1,-15408,0,'CMT'),(675,2,-14400,0,'-04'),(675,3,-10800,1,'-03'),(675,4,-7200,1,'-02'),(675,5,-10800,0,'-03'),(676,0,-16444,0,'LMT'),(676,1,-15408,0,'CMT'),(676,2,-14400,0,'-04'),(676,3,-10800,1,'-03'),(676,4,-7200,1,'-02'),(676,5,-10800,0,'-03'),(677,0,-15924,0,'LMT'),(677,1,-15408,0,'CMT'),(677,2,-14400,0,'-04'),(677,3,-10800,1,'-03'),(677,4,-7200,1,'-02'),(677,5,-10800,0,'-03'),(677,6,-10800,1,'-03'),(678,0,-15652,0,'LMT'),(678,1,-15408,0,'CMT'),(678,2,-14400,0,'-04'),(678,3,-10800,1,'-03'),(678,4,-7200,1,'-02'),(678,5,-10800,0,'-03'),(679,0,-16392,0,'LMT'),(679,1,-15408,0,'CMT'),(679,2,-14400,0,'-04'),(679,3,-10800,1,'-03'),(679,4,-7200,1,'-02'),(679,5,-10800,0,'-03'),(680,0,-16547,0,'LMT'),(680,1,-16200,0,'-0430'),(680,2,-14400,0,'AST'),(681,0,-13840,0,'LMT'),(681,1,-13840,0,'AMT'),(681,2,-14400,0,'-04'),(681,3,-10800,0,'-03'),(681,4,-10800,1,'-03'),(681,5,-14400,0,'-04'),(682,0,-21988,0,'LMT'),(682,1,-18000,1,'CDT'),(682,2,-21600,0,'CST'),(682,3,-18000,1,'CWT'),(682,4,-18000,1,'CPT'),(682,5,-18000,0,'EST'),(683,0,-42398,0,'LMT'),(683,1,-39600,0,'NST'),(683,2,-36000,1,'NWT'),(683,3,-36000,1,'NPT'),(683,4,-39600,0,'BST'),(683,5,-36000,1,'BDT'),(683,6,-36000,0,'AHST'),(683,7,-32400,1,'HDT'),(683,8,-36000,0,'HST'),(684,0,-9244,0,'LMT'),(684,1,-7200,1,'-02'),(684,2,-10800,0,'-03'),(685,0,-25260,0,'LMT'),(685,1,-25200,0,'MST'),(685,2,-21600,0,'CST'),(685,3,-28800,0,'PST'),(685,4,-21600,1,'MDT'),(685,5,-18000,1,'CDT'),(685,6,-21600,0,'CST'),(686,0,-14309,0,'LMT'),(686,1,-14309,0,'BMT'),(686,2,-10800,1,'ADT'),(686,3,-14400,0,'AST'),(687,0,-11636,0,'LMT'),(687,1,-7200,1,'-02'),(687,2,-10800,0,'-03'),(688,0,-21168,0,'LMT'),(688,1,-19800,1,'-0530'),(688,2,-21600,0,'CST'),(688,3,-18000,1,'CDT'),(689,0,-13708,0,'LMT'),(689,1,-10800,1,'ADT'),(689,2,-14400,0,'AST'),(689,3,-10800,1,'AWT'),(689,4,-10800,1,'APT'),(690,0,-14560,0,'LMT'),(690,1,-10800,1,'-03'),(690,2,-14400,0,'-04'),(691,0,-17776,0,'LMT'),(691,1,-17776,0,'BMT'),(691,2,-14400,1,'-04'),(691,3,-18000,0,'-05'),(692,0,-27889,0,'LMT'),(692,1,-25200,1,'PDT'),(692,2,-28800,0,'PST'),(692,3,-21600,1,'MWT'),(692,4,-21600,1,'MPT'),(692,5,-25200,0,'MST'),(692,6,-21600,1,'MDT'),(693,0,-14028,0,'LMT'),(693,1,-15408,0,'CMT'),(693,2,-14400,0,'-04'),(693,3,-10800,1,'-03'),(693,4,-7200,1,'-02'),(693,5,-10800,0,'-03'),(694,0,0,0,'-00'),(694,1,-21600,1,'MWT'),(694,2,-21600,1,'MPT'),(694,3,-25200,0,'MST'),(694,4,-18000,1,'MDDT'),(694,5,-21600,1,'MDT'),(694,6,-18000,1,'CDT'),(694,7,-21600,0,'CST'),(694,8,-18000,0,'EST'),(694,9,-21600,1,'MDT'),(694,10,-25200,0,'MST'),(695,0,-13108,0,'LMT'),(695,1,-10800,1,'-03'),(695,2,-14400,0,'-04'),(696,0,-20824,0,'LMT'),(696,1,-21600,0,'CST'),(696,2,-14400,1,'EDT'),(696,3,-18000,0,'EST'),(696,4,-18000,1,'CDT'),(697,0,-16064,0,'LMT'),(697,1,-16060,0,'CMT'),(697,2,-16200,0,'-0430'),(697,3,-14400,0,'-04'),(698,0,-15788,0,'LMT'),(698,1,-15408,0,'CMT'),(698,2,-14400,0,'-04'),(698,3,-10800,1,'-03'),(698,4,-7200,1,'-02'),(698,5,-10800,0,'-03'),(699,0,-12560,0,'LMT'),(699,1,-14400,0,'-04'),(699,2,-10800,0,'-03'),(700,0,-19088,0,'LMT'),(700,1,-19176,0,'CMT'),(700,2,-18000,0,'EST'),(701,0,-21036,0,'LMT'),(701,1,-18000,1,'CDT'),(701,2,-21600,0,'CST'),(701,3,-18000,0,'EST'),(701,4,-18000,1,'CWT'),(701,5,-18000,1,'CPT'),(701,6,-21600,0,'CST'),(702,0,-25460,0,'LMT'),(702,1,-25200,0,'MST'),(702,2,-21600,0,'CST'),(702,3,-18000,1,'CDT'),(702,4,-21600,1,'MDT'),(702,5,-25200,0,'MST'),(703,0,-21988,0,'LMT'),(703,1,-18000,1,'CDT'),(703,2,-21600,0,'CST'),(703,3,-18000,1,'CWT'),(703,4,-18000,1,'CPT'),(703,5,-18000,0,'EST'),(704,0,-15408,0,'LMT'),(704,1,-15408,0,'CMT'),(704,2,-14400,0,'-04'),(704,3,-10800,1,'-03'),(704,4,-7200,1,'-02'),(704,5,-10800,0,'-03'),(705,0,-20173,0,'LMT'),(705,1,-20173,0,'SJMT'),(705,2,-18000,1,'CDT'),(705,3,-21600,0,'CST'),(706,0,-27964,0,'LMT'),(706,1,-25200,0,'MST'),(706,2,-28800,0,'PST'),(706,3,-25200,0,'MST'),(707,0,-13460,0,'LMT'),(707,1,-10800,1,'-03'),(707,2,-14400,0,'-04'),(708,0,-16547,0,'LMT'),(708,1,-16200,0,'-0430'),(708,2,-14400,0,'AST'),(709,0,-4480,0,'LMT'),(709,1,-10800,0,'-03'),(709,2,-10800,0,'-03'),(709,3,-7200,1,'-02'),(709,4,-7200,1,'-02'),(709,5,0,0,'GMT'),(710,0,-33460,0,'LMT'),(710,1,-28800,1,'YDT'),(710,2,-32400,0,'YST'),(710,3,-28800,1,'YWT'),(710,4,-28800,1,'YPT'),(710,5,-25200,1,'YDDT'),(710,6,-28800,0,'PST'),(710,7,-25200,1,'PDT'),(711,0,-28856,0,'LMT'),(711,1,-25200,1,'PDT'),(711,2,-28800,0,'PST'),(711,3,-25200,1,'PWT'),(711,4,-25200,1,'PPT'),(711,5,-25200,0,'MST'),(712,0,-25196,0,'LMT'),(712,1,-21600,1,'MDT'),(712,2,-25200,0,'MST'),(712,3,-21600,1,'MWT'),(712,4,-21600,1,'MPT'),(713,0,-19931,0,'LMT'),(713,1,-21600,0,'CST'),(713,2,-18000,0,'EST'),(713,3,-14400,1,'EWT'),(713,4,-14400,1,'EPT'),(713,5,-14400,1,'EDT'),(714,0,-14764,0,'LMT'),(714,1,-14400,0,'AST'),(715,0,-27232,0,'LMT'),(715,1,-21600,1,'MDT'),(715,2,-25200,0,'MST'),(715,3,-21600,1,'MWT'),(715,4,-21600,1,'MPT'),(716,0,-16768,0,'LMT'),(716,1,-14400,1,'-04'),(716,2,-18000,0,'-05'),(716,3,-14400,0,'-04'),(716,4,-18000,0,'-05'),(717,0,-21408,0,'LMT'),(717,1,-18000,1,'CDT'),(717,2,-21600,0,'CST'),(718,0,-28084,0,'LMT'),(718,1,-25200,0,'MST'),(718,2,-28800,0,'PST'),(718,3,-25200,1,'PDT'),(718,4,-25200,1,'PWT'),(718,5,-25200,1,'PPT'),(719,0,-29447,0,'LMT'),(719,1,-25200,1,'PDT'),(719,2,-28800,0,'PST'),(719,3,-25200,1,'PWT'),(719,4,-25200,1,'PPT'),(719,5,-25200,0,'MST'),(720,0,-20678,0,'LMT'),(720,1,-18000,1,'CDT'),(720,2,-21600,0,'CST'),(720,3,-18000,1,'CWT'),(720,4,-18000,1,'CPT'),(720,5,-18000,0,'EST'),(720,6,-14400,1,'EDT'),(721,0,-9240,0,'LMT'),(721,1,-7200,1,'-02'),(721,2,-10800,0,'-03'),(722,0,-14388,0,'LMT'),(722,1,-10800,1,'ADT'),(722,2,-14400,0,'AST'),(722,3,-10800,1,'AWT'),(722,4,-10800,1,'APT'),(723,0,-12416,0,'LMT'),(723,1,-10800,0,'-03'),(723,2,-10800,0,'-03'),(723,3,-7200,1,'-02'),(723,4,-7200,1,'-02'),(724,0,-14500,0,'LMT'),(724,1,-12652,0,'NST'),(724,2,-9052,1,'NDT'),(724,3,-12600,0,'NST'),(724,4,-9000,1,'NDT'),(724,5,-9000,1,'NPT'),(724,6,-9000,1,'NWT'),(724,7,-10800,1,'ADT'),(724,8,-14400,0,'AST'),(724,9,-7200,1,'ADDT'),(724,10,-10800,1,'ADT'),(725,0,-17072,0,'LMT'),(725,1,-18430,0,'KMT'),(725,2,-18000,0,'EST'),(725,3,-14400,1,'EDT'),(725,4,-14400,0,'AST'),(725,5,-18000,0,'EST'),(726,0,-14764,0,'LMT'),(726,1,-14400,0,'AST'),(727,0,-14764,0,'LMT'),(727,1,-14400,0,'AST'),(728,0,-21724,0,'LMT'),(728,1,-18000,1,'CDT'),(728,2,-21600,0,'CST'),(729,0,-19160,0,'LMT'),(729,1,-18840,0,'QMT'),(729,2,-14400,1,'-04'),(729,3,-18000,0,'-05'),(730,0,-13960,0,'LMT'),(730,1,-13500,0,'-0345'),(730,2,-10800,0,'-03'),(730,3,-14400,0,'-04'),(731,0,-15264,0,'LMT'),(731,1,-10800,1,'ADT'),(731,2,-14400,0,'AST'),(731,3,-10800,1,'AWT'),(731,4,-10800,1,'APT'),(732,0,-19768,0,'LMT'),(732,1,-19776,0,'HMT'),(732,2,-14400,1,'CDT'),(732,3,-18000,0,'CST'),(732,4,-18000,0,'CST'),(732,5,-14400,1,'CDT'),(733,0,-26632,0,'LMT'),(733,1,-25200,0,'MST'),(733,2,-21600,0,'CST'),(733,3,-28800,0,'PST'),(733,4,-21600,1,'MDT'),(733,5,-25200,0,'MST'),(734,0,-20678,0,'LMT'),(734,1,-18000,1,'CDT'),(734,2,-21600,0,'CST'),(734,3,-18000,1,'CWT'),(734,4,-18000,1,'CPT'),(734,5,-18000,0,'EST'),(734,6,-14400,1,'EDT'),(735,0,-20790,0,'LMT'),(735,1,-18000,1,'CDT'),(735,2,-21600,0,'CST'),(735,3,-18000,1,'CWT'),(735,4,-18000,1,'CPT'),(735,5,-18000,0,'EST'),(735,6,-21600,0,'CST'),(736,0,-20723,0,'LMT'),(736,1,-18000,1,'CDT'),(736,2,-21600,0,'CST'),(736,3,-18000,1,'CWT'),(736,4,-18000,1,'CPT'),(736,5,-18000,0,'EST'),(736,6,-14400,1,'EDT'),(737,0,-20947,0,'LMT'),(737,1,-18000,1,'CDT'),(737,2,-21600,0,'CST'),(737,3,-18000,1,'CWT'),(737,4,-18000,1,'CPT'),(737,5,-18000,0,'EST'),(737,6,-14400,1,'EDT'),(738,0,-20823,0,'LMT'),(738,1,-18000,1,'CDT'),(738,2,-21600,0,'CST'),(738,3,-18000,1,'CWT'),(738,4,-18000,1,'CPT'),(738,5,-18000,0,'EST'),(738,6,-14400,1,'EDT'),(738,7,-18000,1,'CDT'),(738,8,-21600,0,'CST'),(739,0,-20416,0,'LMT'),(739,1,-18000,1,'CDT'),(739,2,-21600,0,'CST'),(739,3,-18000,1,'CWT'),(739,4,-18000,1,'CPT'),(739,5,-18000,0,'EST'),(739,6,-14400,1,'EDT'),(740,0,-21007,0,'LMT'),(740,1,-18000,1,'CDT'),(740,2,-21600,0,'CST'),(740,3,-18000,1,'CWT'),(740,4,-18000,1,'CPT'),(740,5,-18000,0,'EST'),(740,6,-14400,1,'EDT'),(741,0,-20785,0,'LMT'),(741,1,-18000,1,'CDT'),(741,2,-21600,0,'CST'),(741,3,-18000,1,'CWT'),(741,4,-18000,1,'CPT'),(741,5,-18000,0,'EST'),(741,6,-14400,1,'EDT'),(742,0,-20678,0,'LMT'),(742,1,-18000,1,'CDT'),(742,2,-21600,0,'CST'),(742,3,-18000,1,'CWT'),(742,4,-18000,1,'CPT'),(742,5,-18000,0,'EST'),(742,6,-14400,1,'EDT'),(743,0,0,0,'-00'),(743,1,-21600,1,'PDDT'),(743,2,-28800,0,'PST'),(743,3,-25200,0,'MST'),(743,4,-21600,1,'MDT'),(744,0,0,0,'-00'),(744,1,-14400,1,'EPT'),(744,2,-18000,0,'EST'),(744,3,-10800,1,'EDDT'),(744,4,-14400,1,'EDT'),(744,5,-14400,1,'EWT'),(744,6,-21600,0,'CST'),(744,7,-18000,1,'CDT'),(744,8,-14400,1,'EDT'),(744,9,-18000,0,'EST'),(745,0,-18430,0,'LMT'),(745,1,-18430,0,'KMT'),(745,2,-18000,0,'EST'),(745,3,-14400,1,'EDT'),(746,0,-15672,0,'LMT'),(746,1,-15408,0,'CMT'),(746,2,-14400,0,'-04'),(746,3,-10800,1,'-03'),(746,4,-7200,1,'-02'),(746,5,-10800,0,'-03'),(747,0,-32261,0,'LMT'),(747,1,-28800,0,'PST'),(747,2,-25200,1,'PWT'),(747,3,-25200,1,'PPT'),(747,4,-25200,1,'PDT'),(747,5,-28800,1,'YDT'),(747,6,-32400,0,'YST'),(747,7,-28800,1,'AKDT'),(747,8,-32400,0,'AKST'),(748,0,-20582,0,'LMT'),(748,1,-18000,1,'CDT'),(748,2,-21600,0,'CST'),(748,3,-18000,1,'CWT'),(748,4,-18000,1,'CPT'),(748,5,-18000,0,'EST'),(748,6,-14400,1,'EDT'),(749,0,-20364,0,'LMT'),(749,1,-18000,1,'CDT'),(749,2,-21600,0,'CST'),(749,3,-18000,1,'CWT'),(749,4,-18000,1,'CPT'),(749,5,-14400,1,'EDT'),(749,6,-18000,0,'EST'),(750,0,-20790,0,'LMT'),(750,1,-18000,1,'CDT'),(750,2,-21600,0,'CST'),(750,3,-18000,1,'CWT'),(750,4,-18000,1,'CPT'),(750,5,-18000,0,'EST'),(750,6,-21600,0,'CST'),(751,0,-16547,0,'LMT'),(751,1,-16200,0,'-0430'),(751,2,-14400,0,'AST'),(752,0,-16356,0,'LMT'),(752,1,-16356,0,'CMT'),(752,2,-12756,1,'BST'),(752,3,-14400,0,'-04'),(753,0,-18492,0,'LMT'),(753,1,-18516,0,'LMT'),(753,2,-14400,1,'-04'),(753,3,-18000,0,'-05'),(754,0,-28378,0,'LMT'),(754,1,-25200,1,'PDT'),(754,2,-28800,0,'PST'),(754,3,-25200,1,'PWT'),(754,4,-25200,1,'PPT'),(755,0,-20582,0,'LMT'),(755,1,-18000,1,'CDT'),(755,2,-21600,0,'CST'),(755,3,-18000,1,'CWT'),(755,4,-18000,1,'CPT'),(755,5,-18000,0,'EST'),(755,6,-14400,1,'EDT'),(756,0,-16547,0,'LMT'),(756,1,-16200,0,'-0430'),(756,2,-14400,0,'AST'),(757,0,-8572,0,'LMT'),(757,1,-7200,1,'-02'),(757,2,-10800,0,'-03'),(758,0,-20708,0,'LMT'),(758,1,-20712,0,'MMT'),(758,2,-21600,0,'CST'),(758,3,-18000,0,'EST'),(758,4,-18000,1,'CDT'),(758,5,-21600,0,'CST'),(759,0,-14404,0,'LMT'),(759,1,-10800,1,'-03'),(759,2,-14400,0,'-04'),(760,0,-14764,0,'LMT'),(760,1,-14400,0,'AST'),(761,0,-14660,0,'LMT'),(761,1,-14660,0,'FFMT'),(761,2,-14400,0,'AST'),(761,3,-10800,1,'ADT'),(762,0,-24000,0,'LMT'),(762,1,-21600,0,'CST'),(762,2,-18000,1,'CDT'),(763,0,-25540,0,'LMT'),(763,1,-25200,0,'MST'),(763,2,-21600,0,'CST'),(763,3,-28800,0,'PST'),(763,4,-21600,1,'MDT'),(763,5,-25200,0,'MST'),(764,0,-16516,0,'LMT'),(764,1,-15408,0,'CMT'),(764,2,-14400,0,'-04'),(764,3,-10800,1,'-03'),(764,4,-7200,1,'-02'),(764,5,-10800,0,'-03'),(765,0,-21027,0,'LMT'),(765,1,-18000,1,'CDT'),(765,2,-21600,0,'CST'),(765,3,-18000,1,'CWT'),(765,4,-18000,1,'CPT'),(765,5,-18000,0,'EST'),(765,6,-21600,0,'CST'),(766,0,-21508,0,'LMT'),(766,1,-21600,0,'CST'),(766,2,-18000,0,'EST'),(766,3,-18000,1,'CDT'),(766,4,-21600,0,'CST'),(767,0,-31578,0,'LMT'),(767,1,-28800,0,'PST'),(767,2,-25200,1,'PWT'),(767,3,-25200,1,'PPT'),(767,4,-25200,1,'PDT'),(767,5,-32400,0,'AKST'),(767,6,-28800,1,'AKDT'),(768,0,-23796,0,'LMT'),(768,1,-25200,0,'MST'),(768,2,-21600,0,'CST'),(768,3,-18000,1,'CDT'),(768,4,-18000,1,'CWT'),(769,0,-13480,0,'LMT'),(769,1,-14400,0,'AST'),(769,2,-10800,0,'-03'),(769,3,-7200,1,'-02'),(770,0,-15548,0,'LMT'),(770,1,-18000,0,'EST'),(770,2,-10800,1,'ADT'),(770,3,-14400,0,'AST'),(770,4,-10800,1,'AWT'),(770,5,-10800,1,'APT'),(771,0,-24076,0,'LMT'),(771,1,-21600,0,'CST'),(771,2,-18000,1,'CDT'),(772,0,-13491,0,'LMT'),(772,1,-13491,0,'MMT'),(772,2,-14400,0,'-04'),(772,3,-12600,0,'-0330'),(772,4,-10800,1,'-03'),(772,5,-10800,0,'-03'),(772,6,-9000,1,'-0230'),(772,7,-7200,1,'-02'),(772,8,-5400,1,'-0130'),(772,9,-7200,1,'-02'),(773,0,-19052,0,'LMT'),(773,1,-14400,1,'EDT'),(773,2,-18000,0,'EST'),(773,3,-14400,1,'EWT'),(773,4,-14400,1,'EPT'),(774,0,-14764,0,'LMT'),(774,1,-14400,0,'AST'),(775,0,-18570,0,'LMT'),(775,1,-14400,1,'EDT'),(775,2,-18000,0,'EST'),(776,0,-17762,0,'LMT'),(776,1,-14400,1,'EDT'),(776,2,-18000,0,'EST'),(776,3,-14400,1,'EWT'),(776,4,-14400,1,'EPT'),(777,0,-21184,0,'LMT'),(777,1,-14400,1,'EDT'),(777,2,-18000,0,'EST'),(777,3,-14400,1,'EWT'),(777,4,-14400,1,'EPT'),(778,0,-39698,0,'LMT'),(778,1,-39600,0,'NST'),(778,2,-36000,1,'NWT'),(778,3,-36000,1,'NPT'),(778,4,-39600,0,'BST'),(778,5,-36000,1,'BDT'),(778,6,-32400,0,'YST'),(778,7,-28800,1,'AKDT'),(778,8,-32400,0,'AKST'),(779,0,-7780,0,'LMT'),(779,1,-3600,1,'-01'),(779,2,-7200,0,'-02'),(780,0,-24427,0,'LMT'),(780,1,-21600,1,'MDT'),(780,2,-25200,0,'MST'),(780,3,-21600,1,'MWT'),(780,4,-21600,1,'MPT'),(780,5,-18000,1,'CDT'),(780,6,-21600,0,'CST'),(781,0,-24312,0,'LMT'),(781,1,-21600,1,'MDT'),(781,2,-25200,0,'MST'),(781,3,-21600,1,'MWT'),(781,4,-21600,1,'MPT'),(781,5,-18000,1,'CDT'),(781,6,-21600,0,'CST'),(782,0,-24339,0,'LMT'),(782,1,-21600,1,'MDT'),(782,2,-25200,0,'MST'),(782,3,-21600,1,'MWT'),(782,4,-21600,1,'MPT'),(782,5,-18000,1,'CDT'),(782,6,-21600,0,'CST'),(783,0,-25060,0,'LMT'),(783,1,-25200,0,'MST'),(783,2,-21600,0,'CST'),(783,3,-18000,1,'CDT'),(783,4,-21600,1,'MDT'),(783,5,-25200,0,'MST'),(784,0,-19088,0,'LMT'),(784,1,-19176,0,'CMT'),(784,2,-18000,0,'EST'),(785,0,0,0,'-00'),(785,1,-10800,1,'AWT'),(785,2,-10800,1,'APT'),(785,3,-14400,0,'AST'),(785,4,-7200,1,'ADDT'),(785,5,-10800,1,'ADT'),(785,6,-14400,1,'EDT'),(785,7,-18000,0,'EST'),(785,8,-21600,0,'CST'),(785,9,-18000,1,'CDT'),(785,10,-14400,1,'EDT'),(785,11,-18000,0,'EST'),(786,0,-13240,0,'LMT'),(786,1,-13252,0,'PMT'),(786,2,-13236,0,'PMT'),(786,3,-12600,0,'-0330'),(786,4,-10800,0,'-03'),(787,0,-26898,0,'LMT'),(787,1,-21600,1,'MDT'),(787,2,-25200,0,'MST'),(787,3,-21600,1,'MWT'),(788,0,-17360,0,'LMT'),(788,1,-17340,0,'PPMT'),(788,2,-14400,1,'EDT'),(788,3,-18000,0,'EST'),(788,4,-14400,1,'EDT'),(788,5,-18000,0,'EST'),(789,0,-14764,0,'LMT'),(789,1,-14400,0,'AST'),(790,0,-16272,0,'LMT'),(790,1,-14400,1,'-04'),(790,2,-18000,0,'-05'),(790,3,-14400,0,'-04'),(790,4,-18000,0,'-05'),(791,0,-15336,0,'LMT'),(791,1,-10800,1,'-03'),(791,2,-14400,0,'-04'),(792,0,-15865,0,'LMT'),(792,1,-14400,0,'AST'),(792,2,-10800,1,'APT'),(792,3,-10800,1,'AWT'),(793,0,-17020,0,'LMT'),(793,1,-16966,0,'SMT'),(793,2,-18000,0,'-05'),(793,3,-14400,0,'-04'),(793,4,-14400,1,'-04'),(793,5,-10800,1,'-03'),(793,6,-14400,0,'-04'),(793,7,-10800,0,'-03'),(794,0,-22696,0,'LMT'),(794,1,-18000,1,'CDT'),(794,2,-21600,0,'CST'),(794,3,-18000,1,'CWT'),(794,4,-18000,1,'CPT'),(795,0,0,0,'-00'),(795,1,-14400,1,'CDDT'),(795,2,-21600,0,'CST'),(795,3,-18000,1,'CDT'),(795,4,-18000,0,'EST'),(795,5,-21600,0,'CST'),(796,0,-8376,0,'LMT'),(796,1,-7200,1,'-02'),(796,2,-10800,0,'-03'),(797,0,-25116,0,'LMT'),(797,1,-21600,1,'MDT'),(797,2,-25200,0,'MST'),(797,3,-21600,1,'MWT'),(797,4,-21600,1,'MPT'),(797,5,-21600,0,'CST'),(798,0,0,0,'-00'),(798,1,-14400,1,'CDDT'),(798,2,-21600,0,'CST'),(798,3,-18000,1,'CDT'),(798,4,-18000,0,'EST'),(798,5,-21600,0,'CST'),(799,0,-16272,0,'LMT'),(799,1,-14400,1,'-04'),(799,2,-18000,0,'-05'),(799,3,-14400,0,'-04'),(799,4,-18000,0,'-05'),(800,0,-15408,0,'LMT'),(800,1,-15408,0,'CMT'),(800,2,-14400,0,'-04'),(800,3,-10800,1,'-03'),(800,4,-7200,1,'-02'),(800,5,-10800,0,'-03'),(801,0,-28084,0,'LMT'),(801,1,-25200,0,'MST'),(801,2,-28800,0,'PST'),(801,3,-25200,1,'PDT'),(801,4,-25200,1,'PWT'),(801,5,-25200,1,'PPT'),(802,0,-13128,0,'LMT'),(802,1,-10800,1,'-03'),(802,2,-14400,0,'-04'),(802,3,-10800,0,'-03'),(803,0,-16966,0,'LMT'),(803,1,-16966,0,'SMT'),(803,2,-18000,0,'-05'),(803,3,-14400,0,'-04'),(803,4,-14400,1,'-04'),(803,5,-10800,1,'-03'),(803,6,-10800,1,'-03'),(803,7,-14400,0,'-04'),(804,0,-16776,0,'LMT'),(804,1,-16800,0,'SDMT'),(804,2,-14400,1,'EDT'),(804,3,-18000,0,'EST'),(804,4,-16200,1,'-0430'),(804,5,-14400,0,'AST'),(805,0,-11188,0,'LMT'),(805,1,-7200,1,'-02'),(805,2,-10800,0,'-03'),(806,0,-5272,0,'LMT'),(806,1,-7200,0,'-02'),(806,2,-3600,1,'-01'),(806,3,-7200,0,'-02'),(806,4,-3600,0,'-01'),(806,5,0,1,'+00'),(806,6,0,1,'+00'),(807,0,-25196,0,'LMT'),(807,1,-21600,1,'MDT'),(807,2,-25200,0,'MST'),(807,3,-21600,1,'MWT'),(807,4,-21600,1,'MPT'),(808,0,-32473,0,'LMT'),(808,1,-28800,0,'PST'),(808,2,-25200,1,'PWT'),(808,3,-25200,1,'PPT'),(808,4,-25200,1,'PDT'),(808,5,-32400,0,'YST'),(808,6,-28800,1,'AKDT'),(808,7,-32400,0,'AKST'),(809,0,-14764,0,'LMT'),(809,1,-14400,0,'AST'),(810,0,-12652,0,'LMT'),(810,1,-9052,1,'NDT'),(810,2,-12652,0,'NST'),(810,3,-9000,1,'NDT'),(810,4,-12600,0,'NST'),(810,5,-9000,1,'NPT'),(810,6,-9000,1,'NWT'),(810,7,-5400,1,'NDDT'),(810,8,-9000,1,'NDT'),(811,0,-14764,0,'LMT'),(811,1,-14400,0,'AST'),(812,0,-14764,0,'LMT'),(812,1,-14400,0,'AST'),(813,0,-14764,0,'LMT'),(813,1,-14400,0,'AST'),(814,0,-14764,0,'LMT'),(814,1,-14400,0,'AST'),(815,0,-25880,0,'LMT'),(815,1,-21600,1,'MDT'),(815,2,-25200,0,'MST'),(815,3,-21600,1,'MWT'),(815,4,-21600,1,'MPT'),(815,5,-21600,0,'CST'),(816,0,-20932,0,'LMT'),(816,1,-18000,1,'CDT'),(816,2,-21600,0,'CST'),(817,0,-16508,0,'LMT'),(817,1,-10800,1,'ADT'),(817,2,-14400,0,'AST'),(818,0,-21420,0,'LMT'),(818,1,-21600,0,'CST'),(818,2,-18000,0,'EST'),(818,3,-14400,1,'EWT'),(818,4,-14400,1,'EPT'),(818,5,-14400,1,'EDT'),(819,0,-28084,0,'LMT'),(819,1,-25200,0,'MST'),(819,2,-28800,0,'PST'),(819,3,-25200,1,'PDT'),(819,4,-25200,1,'PWT'),(819,5,-25200,1,'PPT'),(820,0,-19052,0,'LMT'),(820,1,-14400,1,'EDT'),(820,2,-18000,0,'EST'),(820,3,-14400,1,'EWT'),(820,4,-14400,1,'EPT'),(821,0,-14764,0,'LMT'),(821,1,-14400,0,'AST'),(822,0,-29548,0,'LMT'),(822,1,-25200,1,'PDT'),(822,2,-28800,0,'PST'),(822,3,-25200,1,'PWT'),(822,4,-25200,1,'PPT'),(823,0,-14764,0,'LMT'),(823,1,-14400,0,'AST'),(824,0,-32412,0,'LMT'),(824,1,-28800,1,'YDT'),(824,2,-32400,0,'YST'),(824,3,-28800,1,'YWT'),(824,4,-28800,1,'YPT'),(824,5,-25200,1,'YDDT'),(824,6,-28800,0,'PST'),(824,7,-25200,1,'PDT'),(825,0,-23316,0,'LMT'),(825,1,-18000,1,'CDT'),(825,2,-21600,0,'CST'),(825,3,-18000,1,'CWT'),(825,4,-18000,1,'CPT'),(825,5,-18000,1,'CDT'),(825,6,-21600,0,'CST'),(826,0,-33535,0,'LMT'),(826,1,-32400,0,'YST'),(826,2,-28800,1,'YWT'),(826,3,-28800,1,'YPT'),(826,4,-28800,1,'YDT'),(826,5,-28800,1,'AKDT'),(826,6,-32400,0,'AKST'),(827,0,0,0,'-00'),(827,1,-21600,1,'MWT'),(827,2,-21600,1,'MPT'),(827,3,-25200,0,'MST'),(827,4,-18000,1,'MDDT'),(827,5,-21600,1,'MDT'),(828,0,0,0,'-00'),(828,1,28800,0,'+08'),(828,2,39600,0,'+11'),(828,3,28800,0,'+08'),(829,0,0,0,'-00'),(829,1,25200,0,'+07'),(829,2,18000,0,'+05'),(829,3,25200,0,'+07'),(830,0,0,0,'-00'),(830,1,36000,0,'+10'),(831,0,0,0,'-00'),(831,1,36000,0,'AEST'),(831,2,39600,1,'AEDT'),(831,3,0,0,'-00'),(831,4,39600,1,'AEDT'),(831,5,36000,0,'AEST'),(831,6,39600,0,'+11'),(832,0,0,0,'-00'),(832,1,21600,0,'+06'),(832,2,18000,0,'+05'),(833,0,41944,0,'LMT'),(833,1,45000,1,'NZST'),(833,2,41400,0,'NZMT'),(833,3,43200,1,'NZST'),(833,4,46800,1,'NZDT'),(833,5,43200,0,'NZST'),(833,6,43200,0,'NZST'),(834,0,0,0,'-00'),(834,1,-14400,0,'-04'),(834,2,-10800,1,'-03'),(834,3,-7200,1,'-02'),(834,4,-10800,0,'-03'),(834,5,-10800,1,'-03'),(834,6,-14400,0,'-04'),(834,7,-10800,0,'-03'),(835,0,0,0,'-00'),(835,1,-10800,0,'-03'),(836,0,41944,0,'LMT'),(836,1,45000,1,'NZST'),(836,2,41400,0,'NZMT'),(836,3,43200,1,'NZST'),(836,4,46800,1,'NZDT'),(836,5,43200,0,'NZST'),(836,6,43200,0,'NZST'),(837,0,0,0,'-00'),(837,1,10800,0,'+03'),(838,0,0,0,'-00'),(838,1,7200,1,'+02'),(838,2,0,0,'+00'),(838,3,0,0,'+00'),(839,0,0,0,'-00'),(839,1,21600,0,'+06'),(840,0,2580,0,'LMT'),(840,1,7200,1,'CEST'),(840,2,3600,0,'CET'),(840,3,3600,0,'CET'),(840,4,7200,1,'CEST'),(840,5,7200,1,'CEST'),(840,6,3600,0,'CET'),(841,0,11212,0,'LMT'),(841,1,10800,0,'+03'),(842,0,18468,0,'LMT'),(842,1,18000,0,'+05'),(842,2,25200,1,'+07'),(842,3,21600,0,'+06'),(842,4,21600,0,'+06'),(842,5,25200,1,'+07'),(842,6,21600,1,'+06'),(842,7,18000,0,'+05'),(842,8,25200,1,'+07'),(842,9,21600,0,'+06'),(843,0,8624,0,'LMT'),(843,1,10800,1,'EEST'),(843,2,7200,0,'EET'),(843,3,7200,0,'EET'),(843,4,10800,1,'EEST'),(844,0,42596,0,'LMT'),(844,1,43200,0,'+12'),(844,2,50400,1,'+14'),(844,3,46800,0,'+13'),(844,4,46800,1,'+13'),(844,5,43200,0,'+12'),(844,6,46800,1,'+13'),(844,7,43200,1,'+12'),(844,8,39600,0,'+11'),(844,9,43200,0,'+12'),(845,0,12064,0,'LMT'),(845,1,14400,0,'+04'),(845,2,18000,0,'+05'),(845,3,21600,0,'+06'),(845,4,21600,1,'+06'),(845,5,18000,0,'+05'),(845,6,21600,1,'+06'),(845,7,18000,1,'+05'),(845,8,14400,0,'+04'),(845,9,18000,0,'+05'),(846,0,13720,0,'LMT'),(846,1,14400,0,'+04'),(846,2,18000,0,'+05'),(846,3,21600,1,'+06'),(846,4,21600,0,'+06'),(846,5,18000,0,'+05'),(846,6,21600,1,'+06'),(846,7,18000,1,'+05'),(846,8,14400,0,'+04'),(846,9,21600,1,'+06'),(846,10,18000,0,'+05'),(847,0,14012,0,'LMT'),(847,1,14400,0,'+04'),(847,2,21600,1,'+06'),(847,3,18000,0,'+05'),(847,4,18000,0,'+05'),(847,5,21600,1,'+06'),(847,6,18000,1,'+05'),(847,7,14400,0,'+04'),(847,8,18000,0,'+05'),(848,0,14012,0,'LMT'),(848,1,14400,0,'+04'),(848,2,21600,1,'+06'),(848,3,18000,0,'+05'),(848,4,18000,0,'+05'),(848,5,21600,1,'+06'),(848,6,18000,1,'+05'),(848,7,14400,0,'+04'),(848,8,18000,0,'+05'),(849,0,12464,0,'LMT'),(849,1,10800,0,'+03'),(849,2,18000,0,'+05'),(849,3,21600,0,'+06'),(849,4,21600,1,'+06'),(849,5,18000,0,'+05'),(849,6,21600,1,'+06'),(849,7,18000,1,'+05'),(849,8,14400,0,'+04'),(849,9,18000,0,'+05'),(850,0,10660,0,'LMT'),(850,1,10656,0,'BMT'),(850,2,10800,0,'+03'),(850,3,14400,1,'+04'),(850,4,10800,0,'+03'),(850,5,14400,1,'+04'),(851,0,12368,0,'LMT'),(851,1,14400,0,'+04'),(851,2,10800,0,'+03'),(852,0,11964,0,'LMT'),(852,1,10800,0,'+03'),(852,2,18000,1,'+05'),(852,3,14400,0,'+04'),(852,4,14400,0,'+04'),(852,5,18000,1,'+05'),(852,6,14400,1,'+04'),(852,7,10800,0,'+03'),(852,8,18000,1,'+05'),(852,9,14400,0,'+04'),(853,0,24124,0,'LMT'),(853,1,24124,0,'BMT'),(853,2,25200,0,'+07'),(854,0,20100,0,'LMT'),(854,1,21600,0,'+06'),(854,2,28800,1,'+08'),(854,3,25200,0,'+07'),(854,4,25200,0,'+07'),(854,5,28800,1,'+08'),(854,6,25200,1,'+07'),(854,7,21600,0,'+06'),(854,8,25200,1,'+07'),(854,9,25200,0,'+07'),(855,0,8520,0,'LMT'),(855,1,10800,1,'EEST'),(855,2,7200,0,'EET'),(856,0,17904,0,'LMT'),(856,1,18000,0,'+05'),(856,2,25200,1,'+07'),(856,3,21600,0,'+06'),(856,4,21600,0,'+06'),(856,5,25200,1,'+07'),(856,6,21600,1,'+06'),(856,7,18000,0,'+05'),(856,8,21600,1,'+06'),(856,9,21600,0,'+06'),(857,0,27580,0,'LMT'),(857,1,27000,0,'+0730'),(857,2,28800,0,'+08'),(858,0,21200,0,'HMT'),(858,1,19270,0,'MMT'),(858,2,19800,0,'IST'),(858,3,23400,1,'+0630'),(859,0,27232,0,'LMT'),(859,1,28800,0,'+08'),(859,2,36000,1,'+10'),(859,3,32400,0,'+09'),(859,4,32400,0,'+09'),(859,5,36000,1,'+10'),(859,6,32400,1,'+09'),(859,7,28800,0,'+08'),(859,8,36000,0,'+10'),(859,9,36000,1,'+10'),(859,10,32400,0,'+09'),(860,0,27480,0,'LMT'),(860,1,25200,0,'+07'),(860,2,28800,0,'+08'),(860,3,32400,0,'+09'),(860,4,36000,1,'+10'),(860,5,32400,1,'+09'),(860,6,28800,0,'+08'),(861,0,29143,0,'LMT'),(861,1,32400,1,'CDT'),(861,2,28800,0,'CST'),(862,0,29143,0,'LMT'),(862,1,32400,1,'CDT'),(862,2,28800,0,'CST'),(863,0,19164,0,'LMT'),(863,1,19172,0,'MMT'),(863,2,19800,0,'+0530'),(863,3,21600,1,'+06'),(863,4,23400,1,'+0630'),(863,5,23400,0,'+0630'),(863,6,21600,0,'+06'),(863,7,19800,0,'+0530'),(864,0,21700,0,'LMT'),(864,1,21200,0,'HMT'),(864,2,23400,0,'+0630'),(864,3,19800,0,'+0530'),(864,4,21600,0,'+06'),(864,5,25200,1,'+07'),(865,0,8712,0,'LMT'),(865,1,10800,1,'EEST'),(865,2,7200,0,'EET'),(866,0,21700,0,'LMT'),(866,1,21200,0,'HMT'),(866,2,23400,0,'+0630'),(866,3,19800,0,'+0530'),(866,4,21600,0,'+06'),(866,5,25200,1,'+07'),(867,0,30140,0,'LMT'),(867,1,28800,0,'+08'),(867,2,32400,0,'+09'),(868,0,13272,0,'LMT'),(868,1,14400,0,'+04'),(869,0,16512,0,'LMT'),(869,1,18000,0,'+05'),(869,2,25200,1,'+07'),(869,3,21600,0,'+06'),(869,4,21600,0,'+06'),(869,5,25200,1,'+07'),(869,6,21600,1,'+06'),(869,7,18000,0,'+05'),(870,0,8148,0,'LMT'),(870,1,10800,1,'EEST'),(870,2,7200,0,'EET'),(870,3,7200,0,'EET'),(870,4,10800,1,'EEST'),(870,5,10800,0,'+03'),(870,6,7200,0,'EET'),(871,0,8272,0,'LMT'),(871,1,10800,1,'EEST'),(871,2,7200,0,'EET'),(871,3,10800,1,'IDT'),(871,4,7200,0,'IST'),(871,5,7200,0,'EET'),(872,0,29143,0,'LMT'),(872,1,32400,1,'CDT'),(872,2,28800,0,'CST'),(873,0,8423,0,'LMT'),(873,1,10800,1,'EEST'),(873,2,7200,0,'EET'),(873,3,10800,1,'IDT'),(873,4,7200,0,'IST'),(873,5,7200,0,'EET'),(874,0,25600,0,'LMT'),(874,1,25590,0,'PLMT'),(874,2,25200,0,'+07'),(874,3,28800,0,'+08'),(874,4,32400,0,'+09'),(874,5,25200,0,'+07'),(875,0,27402,0,'LMT'),(875,1,28800,0,'HKT'),(875,2,32400,1,'HKST'),(875,3,30600,0,'HKT'),(875,4,32400,0,'JST'),(875,5,28800,0,'HKT'),(876,0,21996,0,'LMT'),(876,1,21600,0,'+06'),(876,2,28800,1,'+08'),(876,3,25200,0,'+07'),(877,0,25025,0,'LMT'),(877,1,25025,0,'IMT'),(877,2,25200,0,'+07'),(877,3,32400,1,'+09'),(877,4,28800,0,'+08'),(877,5,28800,0,'+08'),(877,6,32400,1,'+09'),(877,7,28800,1,'+08'),(877,8,25200,0,'+07'),(877,9,32400,0,'+09'),(877,10,32400,1,'+09'),(877,11,28800,0,'+08'),(878,0,6952,0,'LMT'),(878,1,7016,0,'IMT'),(878,2,10800,1,'EEST'),(878,3,7200,0,'EET'),(878,4,14400,1,'+04'),(878,5,10800,0,'+03'),(878,6,10800,1,'EEST'),(878,7,7200,0,'EET'),(878,8,10800,1,'EEST'),(878,9,7200,0,'EET'),(878,10,10800,0,'+03'),(879,0,25632,0,'LMT'),(879,1,25632,0,'BMT'),(879,2,26400,0,'+0720'),(879,3,27000,0,'+0730'),(879,4,32400,0,'+09'),(879,5,28800,0,'+08'),(879,6,25200,0,'WIB'),(880,0,33768,0,'LMT'),(880,1,32400,0,'+09'),(880,2,34200,0,'+0930'),(880,3,32400,0,'WIT'),(881,0,8454,0,'LMT'),(881,1,8440,0,'JMT'),(881,2,10800,1,'IDT'),(881,3,7200,0,'IST'),(881,4,14400,1,'IDDT'),(881,5,10800,1,'IDT'),(882,0,16608,0,'LMT'),(882,1,14400,0,'+04'),(882,2,16200,0,'+0430'),(883,0,38076,0,'LMT'),(883,1,39600,0,'+11'),(883,2,46800,1,'+13'),(883,3,43200,0,'+12'),(883,4,43200,0,'+12'),(883,5,46800,1,'+13'),(883,6,43200,1,'+12'),(883,7,39600,0,'+11'),(883,8,43200,0,'+12'),(884,0,16092,0,'LMT'),(884,1,19800,0,'+0530'),(884,2,23400,1,'+0630'),(884,3,18000,0,'+05'),(884,4,21600,1,'PKST'),(884,5,18000,0,'PKT'),(885,0,21020,0,'LMT'),(885,1,21600,0,'+06'),(886,0,20476,0,'LMT'),(886,1,19800,0,'+0530'),(886,2,20700,0,'+0545'),(887,0,20476,0,'LMT'),(887,1,19800,0,'+0530'),(887,2,20700,0,'+0545'),(888,0,32533,0,'LMT'),(888,1,28800,0,'+08'),(888,2,36000,1,'+10'),(888,3,32400,0,'+09'),(888,4,32400,0,'+09'),(888,5,36000,1,'+10'),(888,6,32400,1,'+09'),(888,7,28800,0,'+08'),(888,8,39600,1,'+11'),(888,9,36000,0,'+10'),(888,10,36000,0,'+10'),(888,11,39600,0,'+11'),(888,12,32400,0,'+09'),(889,0,21200,0,'HMT'),(889,1,19270,0,'MMT'),(889,2,19800,0,'IST'),(889,3,23400,1,'+0630'),(890,0,22286,0,'LMT'),(890,1,21600,0,'+06'),(890,2,28800,1,'+08'),(890,3,25200,0,'+07'),(890,4,25200,0,'+07'),(890,5,28800,1,'+08'),(890,6,25200,1,'+07'),(890,7,21600,0,'+06'),(890,8,28800,0,'+08'),(890,9,28800,1,'+08'),(890,10,25200,0,'+07'),(891,0,24406,0,'LMT'),(891,1,24925,0,'SMT'),(891,2,25200,0,'+07'),(891,3,26400,1,'+0720'),(891,4,26400,0,'+0720'),(891,5,27000,0,'+0730'),(891,6,32400,0,'+09'),(891,7,28800,0,'+08'),(892,0,26480,0,'LMT'),(892,1,27000,0,'+0730'),(892,2,30000,1,'+0820'),(892,3,28800,0,'+08'),(892,4,32400,0,'+09'),(892,5,28800,0,'+08'),(893,0,11212,0,'LMT'),(893,1,10800,0,'+03'),(894,0,27250,0,'LMT'),(894,1,28800,0,'CST'),(894,2,36000,1,'+10'),(894,3,32400,0,'+09'),(894,4,32400,1,'CDT'),(894,5,28800,0,'CST'),(894,6,32400,1,'CDT'),(895,0,27250,0,'LMT'),(895,1,28800,0,'CST'),(895,2,36000,1,'+10'),(895,3,32400,0,'+09'),(895,4,32400,1,'CDT'),(895,5,28800,0,'CST'),(895,6,32400,1,'CDT'),(896,0,36192,0,'LMT'),(896,1,36000,0,'+10'),(896,2,43200,1,'+12'),(896,3,39600,0,'+11'),(896,4,39600,0,'+11'),(896,5,43200,1,'+12'),(896,6,39600,1,'+11'),(896,7,36000,0,'+10'),(896,8,43200,0,'+12'),(896,9,43200,1,'+12'),(896,10,39600,0,'+11'),(897,0,28656,0,'LMT'),(897,1,28656,0,'MMT'),(897,2,28800,0,'+08'),(897,3,32400,0,'+09'),(897,4,28800,0,'WITA'),(898,0,29040,0,'LMT'),(898,1,32400,1,'PDT'),(898,2,28800,0,'PST'),(898,3,32400,0,'JST'),(898,4,28800,0,'PST'),(899,0,13272,0,'LMT'),(899,1,14400,0,'+04'),(900,0,8008,0,'LMT'),(900,1,10800,1,'EEST'),(900,2,7200,0,'EET'),(900,3,7200,0,'EET'),(900,4,10800,1,'EEST'),(901,0,20928,0,'LMT'),(901,1,21600,0,'+06'),(901,2,28800,1,'+08'),(901,3,25200,0,'+07'),(901,4,25200,0,'+07'),(901,5,28800,1,'+08'),(901,6,25200,1,'+07'),(901,7,21600,0,'+06'),(901,8,25200,0,'+07'),(902,0,19900,0,'LMT'),(902,1,21600,0,'+06'),(902,2,28800,1,'+08'),(902,3,25200,0,'+07'),(902,4,25200,0,'+07'),(902,5,28800,1,'+08'),(902,6,25200,1,'+07'),(902,7,21600,0,'+06'),(902,8,25200,1,'+07'),(902,9,25200,0,'+07'),(903,0,17610,0,'LMT'),(903,1,18000,0,'+05'),(903,2,25200,1,'+07'),(903,3,21600,0,'+06'),(903,4,21600,0,'+06'),(903,5,25200,1,'+07'),(903,6,21600,1,'+06'),(903,7,18000,0,'+05'),(903,8,25200,0,'+07'),(903,9,25200,1,'+07'),(903,10,21600,0,'+06'),(904,0,12324,0,'LMT'),(904,1,10800,0,'+03'),(904,2,18000,0,'+05'),(904,3,21600,1,'+06'),(904,4,21600,0,'+06'),(904,5,18000,0,'+05'),(904,6,21600,1,'+06'),(904,7,18000,1,'+05'),(904,8,14400,0,'+04'),(904,9,18000,0,'+05'),(905,0,24124,0,'LMT'),(905,1,24124,0,'BMT'),(905,2,25200,0,'+07'),(906,0,26240,0,'LMT'),(906,1,26240,0,'PMT'),(906,2,27000,0,'+0730'),(906,3,32400,0,'+09'),(906,4,28800,0,'+08'),(906,5,28800,0,'WITA'),(906,6,25200,0,'WIB'),(907,0,30180,0,'LMT'),(907,1,30600,0,'KST'),(907,2,32400,0,'JST'),(907,3,32400,0,'KST'),(908,0,12368,0,'LMT'),(908,1,14400,0,'+04'),(908,2,10800,0,'+03'),(909,0,15268,0,'LMT'),(909,1,14400,0,'+04'),(909,2,18000,0,'+05'),(909,3,21600,1,'+06'),(909,4,21600,0,'+06'),(909,5,18000,0,'+05'),(909,6,21600,1,'+06'),(909,7,18000,1,'+05'),(909,8,14400,0,'+04'),(909,9,21600,0,'+06'),(909,10,21600,1,'+06'),(910,0,15712,0,'LMT'),(910,1,14400,0,'+04'),(910,2,18000,0,'+05'),(910,3,21600,1,'+06'),(910,4,21600,0,'+06'),(910,5,18000,0,'+05'),(910,6,21600,1,'+06'),(910,7,18000,1,'+05'),(910,8,14400,0,'+04'),(910,9,21600,0,'+06'),(910,10,21600,1,'+06'),(910,11,18000,0,'+05'),(911,0,23087,0,'LMT'),(911,1,23087,0,'RMT'),(911,2,23400,0,'+0630'),(911,3,32400,0,'+09'),(911,4,23400,0,'+0630'),(912,0,11212,0,'LMT'),(912,1,10800,0,'+03'),(913,0,25600,0,'LMT'),(913,1,25590,0,'PLMT'),(913,2,25200,0,'+07'),(913,3,28800,0,'+08'),(913,4,32400,0,'+09'),(913,5,25200,0,'+07'),(914,0,34248,0,'LMT'),(914,1,32400,0,'+09'),(914,2,43200,1,'+12'),(914,3,39600,0,'+11'),(914,4,39600,0,'+11'),(914,5,43200,1,'+12'),(914,6,39600,1,'+11'),(914,7,36000,0,'+10'),(914,8,39600,0,'+11'),(915,0,16073,0,'LMT'),(915,1,14400,0,'+04'),(915,2,18000,0,'+05'),(915,3,21600,1,'+06'),(915,4,21600,0,'+06'),(915,5,18000,0,'+05'),(915,6,21600,1,'+06'),(916,0,30472,0,'LMT'),(916,1,30600,0,'KST'),(916,2,32400,0,'JST'),(916,3,32400,0,'KST'),(916,4,34200,1,'KDT'),(916,5,36000,1,'KDT'),(917,0,29143,0,'LMT'),(917,1,32400,1,'CDT'),(917,2,28800,0,'CST'),(918,0,24925,0,'LMT'),(918,1,24925,0,'SMT'),(918,2,25200,0,'+07'),(918,3,26400,1,'+0720'),(918,4,26400,0,'+0720'),(918,5,27000,0,'+0730'),(918,6,32400,0,'+09'),(918,7,28800,0,'+08'),(919,0,36892,0,'LMT'),(919,1,36000,0,'+10'),(919,2,43200,1,'+12'),(919,3,39600,0,'+11'),(919,4,39600,0,'+11'),(919,5,43200,1,'+12'),(919,6,39600,1,'+11'),(919,7,36000,0,'+10'),(919,8,43200,0,'+12'),(919,9,43200,1,'+12'),(919,10,39600,0,'+11'),(920,0,29160,0,'LMT'),(920,1,28800,0,'CST'),(920,2,32400,0,'JST'),(920,3,32400,1,'CDT'),(920,4,28800,0,'CST'),(921,0,16631,0,'LMT'),(921,1,18000,0,'+05'),(921,2,25200,1,'+07'),(921,3,21600,0,'+06'),(921,4,21600,0,'+06'),(921,5,25200,1,'+07'),(921,6,21600,1,'+06'),(921,7,18000,0,'+05'),(922,0,10751,0,'LMT'),(922,1,10751,0,'TBMT'),(922,2,10800,0,'+03'),(922,3,18000,1,'+05'),(922,4,14400,0,'+04'),(922,5,14400,0,'+04'),(922,6,18000,1,'+05'),(922,7,14400,1,'+04'),(922,8,10800,0,'+03'),(922,9,14400,1,'+04'),(922,10,14400,0,'+04'),(923,0,12344,0,'LMT'),(923,1,12344,0,'TMT'),(923,2,12600,0,'+0330'),(923,3,18000,1,'+05'),(923,4,14400,0,'+04'),(923,5,16200,1,'+0430'),(923,6,12600,0,'+0330'),(924,0,8454,0,'LMT'),(924,1,8440,0,'JMT'),(924,2,10800,1,'IDT'),(924,3,7200,0,'IST'),(924,4,14400,1,'IDDT'),(924,5,10800,1,'IDT'),(925,0,21516,0,'LMT'),(925,1,19800,0,'+0530'),(925,2,21600,0,'+06'),(926,0,21516,0,'LMT'),(926,1,19800,0,'+0530'),(926,2,21600,0,'+06'),(927,0,33539,0,'LMT'),(927,1,36000,1,'JDT'),(927,2,32400,0,'JST'),(927,3,32400,0,'JST'),(928,0,20391,0,'LMT'),(928,1,21600,0,'+06'),(928,2,28800,1,'+08'),(928,3,25200,0,'+07'),(928,4,25200,0,'+07'),(928,5,28800,1,'+08'),(928,6,25200,1,'+07'),(928,7,21600,0,'+06'),(928,8,25200,1,'+07'),(928,9,25200,0,'+07'),(929,0,28656,0,'LMT'),(929,1,28656,0,'MMT'),(929,2,28800,0,'+08'),(929,3,32400,0,'+09'),(929,4,28800,0,'WITA'),(930,0,25652,0,'LMT'),(930,1,25200,0,'+07'),(930,2,32400,1,'+09'),(930,3,28800,0,'+08'),(931,0,25652,0,'LMT'),(931,1,25200,0,'+07'),(931,2,32400,1,'+09'),(931,3,28800,0,'+08'),(932,0,21020,0,'LMT'),(932,1,21600,0,'+06'),(933,0,34374,0,'LMT'),(933,1,28800,0,'+08'),(933,2,32400,0,'+09'),(933,3,39600,0,'+11'),(933,4,43200,1,'+12'),(933,5,39600,0,'+11'),(933,6,43200,1,'+12'),(933,7,39600,1,'+11'),(933,8,36000,0,'+10'),(933,9,43200,0,'+12'),(933,10,43200,1,'+12'),(933,11,36000,0,'+10'),(934,0,24124,0,'LMT'),(934,1,24124,0,'BMT'),(934,2,25200,0,'+07'),(935,0,31651,0,'LMT'),(935,1,32400,0,'+09'),(935,2,39600,1,'+11'),(935,3,36000,0,'+10'),(935,4,36000,0,'+10'),(935,5,39600,1,'+11'),(935,6,36000,1,'+10'),(935,7,32400,0,'+09'),(935,8,39600,0,'+11'),(935,9,39600,1,'+11'),(935,10,36000,0,'+10'),(936,0,31138,0,'LMT'),(936,1,28800,0,'+08'),(936,2,36000,1,'+10'),(936,3,32400,0,'+09'),(936,4,32400,0,'+09'),(936,5,36000,1,'+10'),(936,6,32400,1,'+09'),(936,7,28800,0,'+08'),(936,8,36000,0,'+10'),(936,9,36000,1,'+10'),(936,10,32400,0,'+09'),(937,0,23087,0,'LMT'),(937,1,23087,0,'RMT'),(937,2,23400,0,'+0630'),(937,3,32400,0,'+09'),(937,4,23400,0,'+0630'),(938,0,14553,0,'LMT'),(938,1,13505,0,'PMT'),(938,2,14400,0,'+04'),(938,3,21600,1,'+06'),(938,4,18000,0,'+05'),(938,5,18000,0,'+05'),(938,6,21600,1,'+06'),(938,7,18000,1,'+05'),(938,8,14400,0,'+04'),(938,9,21600,0,'+06'),(938,10,21600,1,'+06'),(938,11,18000,0,'+05'),(939,0,10680,0,'LMT'),(939,1,10800,0,'+03'),(939,2,18000,1,'+05'),(939,3,14400,0,'+04'),(939,4,14400,0,'+04'),(939,5,18000,1,'+05'),(939,6,14400,1,'+04'),(939,7,10800,0,'+03'),(939,8,18000,1,'+05'),(939,9,14400,0,'+04'),(940,0,-6160,0,'LMT'),(940,1,-6872,0,'HMT'),(940,2,-3600,1,'-01'),(940,3,-7200,0,'-02'),(940,4,-3600,1,'-01'),(940,5,-7200,0,'-02'),(940,6,-7200,0,'-02'),(940,7,0,1,'+00'),(940,8,-3600,0,'-01'),(940,9,-3600,0,'-01'),(940,10,0,0,'WET'),(940,11,0,1,'+00'),(940,12,-3600,0,'-01'),(941,0,-15558,0,'LMT'),(941,1,-14400,0,'AST'),(941,2,-10800,1,'ADT'),(942,0,-3696,0,'LMT'),(942,1,-3600,0,'-01'),(942,2,0,0,'WET'),(942,3,3600,1,'WEST'),(942,4,0,0,'WET'),(942,5,3600,1,'WEST'),(943,0,-5644,0,'LMT'),(943,1,-7200,0,'-02'),(943,2,-3600,1,'-01'),(943,3,-7200,0,'-02'),(943,4,-3600,0,'-01'),(944,0,-1624,0,'LMT'),(944,1,0,0,'WET'),(944,2,3600,1,'WEST'),(944,3,0,0,'WET'),(945,0,-1624,0,'LMT'),(945,1,0,0,'WET'),(945,2,3600,1,'WEST'),(945,3,0,0,'WET'),(946,0,2580,0,'LMT'),(946,1,7200,1,'CEST'),(946,2,3600,0,'CET'),(946,3,3600,0,'CET'),(946,4,7200,1,'CEST'),(946,5,7200,1,'CEST'),(946,6,3600,0,'CET'),(947,0,-4056,0,'LMT'),(947,1,-4056,0,'FMT'),(947,2,0,1,'+00'),(947,3,-3600,0,'-01'),(947,4,0,1,'+00'),(947,5,-3600,0,'-01'),(947,6,-3600,0,'-01'),(947,7,3600,1,'+01'),(947,8,3600,1,'WEST'),(947,9,0,0,'WET'),(947,10,0,0,'WET'),(947,11,0,0,'WET'),(947,12,3600,1,'WEST'),(948,0,-5280,0,'LMT'),(948,1,0,1,'+00'),(948,2,-3600,0,'-01'),(948,3,-3600,0,'-01'),(948,4,0,1,'+00'),(948,5,0,0,'GMT'),(949,0,-8768,0,'LMT'),(949,1,-7200,0,'-02'),(950,0,-968,0,'LMT'),(950,1,0,0,'GMT'),(951,0,-13884,0,'LMT'),(951,1,-13884,0,'SMT'),(951,2,-10800,1,'-03'),(951,3,-14400,0,'-04'),(951,4,-7200,1,'-02'),(951,5,-10800,0,'-03'),(951,6,-10800,1,'-03'),(952,0,36292,0,'LMT'),(952,1,39600,1,'AEDT'),(952,2,36000,0,'AEST'),(952,3,39600,1,'AEDT'),(952,4,36000,0,'AEST'),(953,0,32400,0,'ACST'),(953,1,37800,1,'ACDT'),(953,2,34200,0,'ACST'),(953,3,37800,1,'ACDT'),(953,4,34200,0,'ACST'),(954,0,36728,0,'LMT'),(954,1,39600,1,'AEDT'),(954,2,36000,0,'AEST'),(954,3,39600,1,'AEDT'),(954,4,36000,0,'AEST'),(955,0,32400,0,'ACST'),(955,1,37800,1,'ACDT'),(955,2,34200,0,'ACST'),(955,3,37800,1,'ACDT'),(955,4,34200,0,'ACST'),(956,0,36292,0,'LMT'),(956,1,39600,1,'AEDT'),(956,2,36000,0,'AEST'),(956,3,39600,1,'AEDT'),(956,4,36000,0,'AEST'),(957,0,34528,0,'LMT'),(957,1,36000,0,'AEST'),(957,2,39600,1,'AEDT'),(957,3,39600,1,'AEDT'),(957,4,36000,0,'AEST'),(958,0,32400,0,'ACST'),(958,1,37800,1,'ACDT'),(958,2,34200,0,'ACST'),(959,0,30928,0,'LMT'),(959,1,35100,1,'+0945'),(959,2,31500,0,'+0845'),(959,3,35100,1,'+0945'),(959,4,31500,0,'+0845'),(960,0,35356,0,'LMT'),(960,1,36000,0,'AEST'),(960,2,39600,1,'AEDT'),(960,3,39600,1,'AEDT'),(960,4,36000,0,'AEST'),(961,0,38180,0,'LMT'),(961,1,36000,0,'AEST'),(961,2,41400,1,'+1130'),(961,3,37800,0,'+1030'),(961,4,39600,1,'+11'),(962,0,35756,0,'LMT'),(962,1,39600,1,'AEDT'),(962,2,36000,0,'AEST'),(962,3,39600,1,'AEDT'),(962,4,36000,0,'AEST'),(963,0,38180,0,'LMT'),(963,1,36000,0,'AEST'),(963,2,41400,1,'+1130'),(963,3,37800,0,'+1030'),(963,4,39600,1,'+11'),(964,0,34792,0,'LMT'),(964,1,39600,1,'AEDT'),(964,2,36000,0,'AEST'),(964,3,39600,1,'AEDT'),(964,4,36000,0,'AEST'),(965,0,36292,0,'LMT'),(965,1,39600,1,'AEDT'),(965,2,36000,0,'AEST'),(965,3,39600,1,'AEDT'),(965,4,36000,0,'AEST'),(966,0,32400,0,'ACST'),(966,1,37800,1,'ACDT'),(966,2,34200,0,'ACST'),(967,0,27804,0,'LMT'),(967,1,32400,1,'AWDT'),(967,2,28800,0,'AWST'),(967,3,32400,1,'AWDT'),(967,4,28800,0,'AWST'),(968,0,36728,0,'LMT'),(968,1,39600,1,'AEDT'),(968,2,36000,0,'AEST'),(968,3,39600,1,'AEDT'),(968,4,36000,0,'AEST'),(969,0,32400,0,'ACST'),(969,1,37800,1,'ACDT'),(969,2,34200,0,'ACST'),(969,3,37800,1,'ACDT'),(969,4,34200,0,'ACST'),(970,0,36292,0,'LMT'),(970,1,39600,1,'AEDT'),(970,2,36000,0,'AEST'),(970,3,39600,1,'AEDT'),(970,4,36000,0,'AEST'),(971,0,35356,0,'LMT'),(971,1,36000,0,'AEST'),(971,2,39600,1,'AEDT'),(971,3,39600,1,'AEDT'),(971,4,36000,0,'AEST'),(972,0,34792,0,'LMT'),(972,1,39600,1,'AEDT'),(972,2,36000,0,'AEST'),(972,3,39600,1,'AEDT'),(972,4,36000,0,'AEST'),(973,0,27804,0,'LMT'),(973,1,32400,1,'AWDT'),(973,2,28800,0,'AWST'),(973,3,32400,1,'AWDT'),(973,4,28800,0,'AWST'),(974,0,32400,0,'ACST'),(974,1,37800,1,'ACDT'),(974,2,34200,0,'ACST'),(974,3,37800,1,'ACDT'),(974,4,34200,0,'ACST'),(975,0,-16272,0,'LMT'),(975,1,-14400,1,'-04'),(975,2,-18000,0,'-05'),(975,3,-14400,0,'-04'),(975,4,-18000,0,'-05'),(976,0,-7780,0,'LMT'),(976,1,-3600,1,'-01'),(976,2,-7200,0,'-02'),(977,0,-11188,0,'LMT'),(977,1,-7200,1,'-02'),(977,2,-10800,0,'-03'),(978,0,-14404,0,'LMT'),(978,1,-10800,1,'-03'),(978,2,-14400,0,'-04'),(979,0,7200,1,'CEST'),(979,1,3600,0,'CET'),(979,2,7200,1,'CEST'),(979,3,3600,0,'CET'),(980,0,-18000,1,'CDT'),(980,1,-21600,0,'CST'),(980,2,-18000,1,'CWT'),(980,3,-18000,1,'CPT'),(981,0,-15264,0,'LMT'),(981,1,-10800,1,'ADT'),(981,2,-14400,0,'AST'),(981,3,-10800,1,'AWT'),(981,4,-10800,1,'APT'),(982,0,-23316,0,'LMT'),(982,1,-18000,1,'CDT'),(982,2,-21600,0,'CST'),(982,3,-18000,1,'CWT'),(982,4,-18000,1,'CPT'),(982,5,-18000,1,'CDT'),(982,6,-21600,0,'CST'),(983,0,-19052,0,'LMT'),(983,1,-14400,1,'EDT'),(983,2,-18000,0,'EST'),(983,3,-14400,1,'EWT'),(983,4,-14400,1,'EPT'),(984,0,-27232,0,'LMT'),(984,1,-21600,1,'MDT'),(984,2,-25200,0,'MST'),(984,3,-21600,1,'MWT'),(984,4,-21600,1,'MPT'),(985,0,-12652,0,'LMT'),(985,1,-9052,1,'NDT'),(985,2,-12652,0,'NST'),(985,3,-9000,1,'NDT'),(985,4,-12600,0,'NST'),(985,5,-9000,1,'NPT'),(985,6,-9000,1,'NWT'),(985,7,-5400,1,'NDDT'),(985,8,-9000,1,'NDT'),(986,0,-29548,0,'LMT'),(986,1,-25200,1,'PDT'),(986,2,-28800,0,'PST'),(986,3,-25200,1,'PWT'),(986,4,-25200,1,'PPT'),(987,0,-25116,0,'LMT'),(987,1,-21600,1,'MDT'),(987,2,-25200,0,'MST'),(987,3,-21600,1,'MWT'),(987,4,-21600,1,'MPT'),(987,5,-21600,0,'CST'),(988,0,-32412,0,'LMT'),(988,1,-28800,1,'YDT'),(988,2,-32400,0,'YST'),(988,3,-28800,1,'YWT'),(988,4,-28800,1,'YPT'),(988,5,-25200,1,'YDDT'),(988,6,-28800,0,'PST'),(988,7,-25200,1,'PDT'),(989,0,-16966,0,'LMT'),(989,1,-16966,0,'SMT'),(989,2,-18000,0,'-05'),(989,3,-14400,0,'-04'),(989,4,-14400,1,'-04'),(989,5,-10800,1,'-03'),(989,6,-10800,1,'-03'),(989,7,-14400,0,'-04'),(990,0,-26248,0,'LMT'),(990,1,-26248,0,'EMT'),(990,2,-21600,1,'-06'),(990,3,-25200,0,'-07'),(990,4,-25200,0,'-07'),(990,5,-21600,0,'-06'),(990,6,-18000,1,'-05'),(991,0,-19768,0,'LMT'),(991,1,-19776,0,'HMT'),(991,2,-14400,1,'CDT'),(991,3,-18000,0,'CST'),(991,4,-18000,0,'CST'),(991,5,-14400,1,'CDT'),(992,0,10800,1,'EEST'),(992,1,7200,0,'EET'),(993,0,-18000,0,'EST'),(994,0,-14400,1,'EDT'),(994,1,-18000,0,'EST'),(994,2,-14400,1,'EWT'),(994,3,-14400,1,'EPT'),(995,0,7509,0,'LMT'),(995,1,10800,1,'EEST'),(995,2,7200,0,'EET'),(995,3,10800,1,'EEST'),(996,0,-1500,0,'LMT'),(996,1,-1521,0,'DMT'),(996,2,2079,1,'IST'),(996,3,3600,1,'BST'),(996,4,0,0,'GMT'),(996,5,3600,1,'IST'),(996,6,0,0,'GMT'),(996,7,0,1,'GMT'),(996,8,3600,0,'IST'),(996,9,3600,0,'IST'),(997,0,0,0,'GMT'),(998,0,0,0,'GMT'),(999,0,-3600,0,'-01'),(1000,0,-36000,0,'-10'),(1001,0,-39600,0,'-11'),(1002,0,-43200,0,'-12'),(1003,0,-7200,0,'-02'),(1004,0,-10800,0,'-03'),(1005,0,-14400,0,'-04'),(1006,0,-18000,0,'-05'),(1007,0,-21600,0,'-06'),(1008,0,-25200,0,'-07'),(1009,0,-28800,0,'-08'),(1010,0,-32400,0,'-09'),(1011,0,0,0,'GMT'),(1012,0,3600,0,'+01'),(1013,0,36000,0,'+10'),(1014,0,39600,0,'+11'),(1015,0,43200,0,'+12'),(1016,0,46800,0,'+13'),(1017,0,50400,0,'+14'),(1018,0,7200,0,'+02'),(1019,0,10800,0,'+03'),(1020,0,14400,0,'+04'),(1021,0,18000,0,'+05'),(1022,0,21600,0,'+06'),(1023,0,25200,0,'+07'),(1024,0,28800,0,'+08'),(1025,0,32400,0,'+09'),(1026,0,0,0,'GMT'),(1027,0,0,0,'GMT'),(1028,0,0,0,'UTC'),(1029,0,0,0,'UTC'),(1030,0,0,0,'UTC'),(1031,0,0,0,'UTC'),(1032,0,1172,0,'LMT'),(1032,1,4772,1,'NST'),(1032,2,1172,0,'AMT'),(1032,3,4772,1,'NST'),(1032,4,1172,0,'AMT'),(1032,5,1200,0,'+0020'),(1032,6,4800,1,'+0120'),(1032,7,4800,1,'+0120'),(1032,8,3600,0,'CET'),(1032,9,7200,1,'CEST'),(1032,10,7200,1,'CEST'),(1032,11,7200,1,'CEST'),(1032,12,3600,0,'CET'),(1032,13,3600,0,'CET'),(1033,0,364,0,'LMT'),(1033,1,0,0,'WET'),(1033,2,3600,0,'CET'),(1033,3,7200,1,'CEST'),(1033,4,3600,0,'CET'),(1034,0,11532,0,'LMT'),(1034,1,10800,0,'+03'),(1034,2,18000,1,'+05'),(1034,3,14400,0,'+04'),(1034,4,14400,0,'+04'),(1034,5,18000,1,'+05'),(1034,6,14400,1,'+04'),(1034,7,10800,0,'+03'),(1034,8,14400,0,'+04'),(1035,0,5692,0,'LMT'),(1035,1,5692,0,'AMT'),(1035,2,10800,1,'EEST'),(1035,3,7200,0,'EET'),(1035,4,3600,0,'CET'),(1035,5,7200,1,'CEST'),(1035,6,10800,1,'EEST'),(1035,7,7200,0,'EET'),(1035,8,10800,1,'EEST'),(1035,9,7200,0,'EET'),(1036,0,-75,0,'LMT'),(1036,1,3600,1,'BST'),(1036,2,0,0,'GMT'),(1036,3,7200,1,'BDST'),(1036,4,3600,0,'BST'),(1036,5,3600,1,'BST'),(1036,6,0,0,'GMT'),(1036,7,0,0,'GMT'),(1037,0,4920,0,'LMT'),(1037,1,3600,0,'CET'),(1037,2,3600,0,'CET'),(1037,3,7200,1,'CEST'),(1037,4,7200,1,'CEST'),(1037,5,7200,1,'CEST'),(1037,6,3600,0,'CET'),(1038,0,3208,0,'LMT'),(1038,1,7200,1,'CEST'),(1038,2,3600,0,'CET'),(1038,3,7200,1,'CEST'),(1038,4,3600,0,'CET'),(1038,5,10800,1,'CEMT'),(1038,6,10800,1,'CEMT'),(1038,7,7200,1,'CEST'),(1038,8,3600,0,'CET'),(1039,0,3464,0,'PMT'),(1039,1,7200,1,'CEST'),(1039,2,3600,0,'CET'),(1039,3,7200,1,'CEST'),(1039,4,3600,0,'CET'),(1039,5,0,1,'GMT'),(1039,6,7200,1,'CEST'),(1039,7,3600,0,'CET'),(1040,0,1050,0,'BMT'),(1040,1,0,0,'WET'),(1040,2,3600,0,'CET'),(1040,3,7200,1,'CEST'),(1040,4,3600,0,'CET'),(1040,5,7200,1,'CEST'),(1040,6,3600,1,'WEST'),(1040,7,0,0,'WET'),(1040,8,0,0,'WET'),(1040,9,7200,1,'CEST'),(1040,10,3600,0,'CET'),(1041,0,6264,0,'LMT'),(1041,1,6264,0,'BMT'),(1041,2,10800,1,'EEST'),(1041,3,7200,0,'EET'),(1041,4,10800,1,'EEST'),(1041,5,7200,0,'EET'),(1041,6,10800,1,'EEST'),(1041,7,7200,0,'EET'),(1042,0,4580,0,'LMT'),(1042,1,7200,1,'CEST'),(1042,2,3600,0,'CET'),(1042,3,7200,1,'CEST'),(1042,4,3600,0,'CET'),(1042,5,3600,0,'CET'),(1042,6,7200,1,'CEST'),(1043,0,1786,0,'BMT'),(1043,1,7200,1,'CEST'),(1043,2,3600,0,'CET'),(1043,3,7200,1,'CEST'),(1043,4,3600,0,'CET'),(1044,0,6920,0,'LMT'),(1044,1,6900,0,'CMT'),(1044,2,6264,0,'BMT'),(1044,3,10800,1,'EEST'),(1044,4,7200,0,'EET'),(1044,5,7200,0,'EET'),(1044,6,10800,1,'EEST'),(1044,7,3600,0,'CET'),(1044,8,7200,1,'CEST'),(1044,9,7200,1,'CEST'),(1044,10,14400,1,'MSD'),(1044,11,10800,0,'MSK'),(1044,12,10800,0,'MSK'),(1044,13,14400,1,'MSD'),(1044,14,10800,1,'EEST'),(1044,15,7200,0,'EET'),(1045,0,3020,0,'CMT'),(1045,1,7200,1,'CEST'),(1045,2,3600,0,'CET'),(1045,3,3600,0,'CET'),(1045,4,7200,1,'CEST'),(1045,5,7200,1,'CEST'),(1045,6,3600,0,'CET'),(1046,0,-1500,0,'LMT'),(1046,1,-1521,0,'DMT'),(1046,2,2079,1,'IST'),(1046,3,3600,1,'BST'),(1046,4,0,0,'GMT'),(1046,5,3600,1,'IST'),(1046,6,0,0,'GMT'),(1046,7,0,1,'GMT'),(1046,8,3600,0,'IST'),(1046,9,3600,0,'IST'),(1047,0,-1284,0,'LMT'),(1047,1,3600,1,'BST'),(1047,2,0,0,'GMT'),(1047,3,7200,1,'BDST'),(1047,4,3600,0,'CET'),(1047,5,7200,1,'CEST'),(1047,6,3600,0,'CET'),(1048,0,-75,0,'LMT'),(1048,1,3600,1,'BST'),(1048,2,0,0,'GMT'),(1048,3,7200,1,'BDST'),(1048,4,3600,0,'BST'),(1048,5,3600,1,'BST'),(1048,6,0,0,'GMT'),(1048,7,0,0,'GMT'),(1049,0,5989,0,'LMT'),(1049,1,5989,0,'HMT'),(1049,2,10800,1,'EEST'),(1049,3,7200,0,'EET'),(1049,4,10800,1,'EEST'),(1049,5,7200,0,'EET'),(1050,0,-75,0,'LMT'),(1050,1,3600,1,'BST'),(1050,2,0,0,'GMT'),(1050,3,7200,1,'BDST'),(1050,4,3600,0,'BST'),(1050,5,3600,1,'BST'),(1050,6,0,0,'GMT'),(1050,7,0,0,'GMT'),(1051,0,6952,0,'LMT'),(1051,1,7016,0,'IMT'),(1051,2,10800,1,'EEST'),(1051,3,7200,0,'EET'),(1051,4,14400,1,'+04'),(1051,5,10800,0,'+03'),(1051,6,10800,1,'EEST'),(1051,7,7200,0,'EET'),(1051,8,10800,1,'EEST'),(1051,9,7200,0,'EET'),(1051,10,10800,0,'+03'),(1052,0,-75,0,'LMT'),(1052,1,3600,1,'BST'),(1052,2,0,0,'GMT'),(1052,3,7200,1,'BDST'),(1052,4,3600,0,'BST'),(1052,5,3600,1,'BST'),(1052,6,0,0,'GMT'),(1052,7,0,0,'GMT'),(1053,0,4920,0,'LMT'),(1053,1,7200,1,'CEST'),(1053,2,3600,0,'CET'),(1053,3,7200,1,'CEST'),(1053,4,3600,0,'CET'),(1053,5,10800,1,'CEST'),(1053,6,7200,0,'CET'),(1053,7,14400,1,'MSD'),(1053,8,10800,0,'MSK'),(1053,9,10800,0,'MSK'),(1053,10,14400,1,'MSD'),(1053,11,10800,1,'EEST'),(1053,12,7200,0,'EET'),(1053,13,10800,0,'+03'),(1053,14,7200,0,'EET'),(1054,0,7324,0,'LMT'),(1054,1,7324,0,'KMT'),(1054,2,7200,0,'EET'),(1054,3,10800,0,'MSK'),(1054,4,3600,0,'CET'),(1054,5,7200,1,'CEST'),(1054,6,7200,1,'CEST'),(1054,7,14400,1,'MSD'),(1054,8,10800,0,'MSK'),(1054,9,14400,1,'MSD'),(1054,10,10800,1,'EEST'),(1054,11,10800,1,'EEST'),(1054,12,7200,0,'EET'),(1055,0,11928,0,'LMT'),(1055,1,10800,0,'+03'),(1055,2,18000,1,'+05'),(1055,3,14400,0,'+04'),(1055,4,14400,0,'+04'),(1055,5,18000,1,'+05'),(1055,6,14400,1,'+04'),(1055,7,10800,0,'+03'),(1056,0,-2205,0,'LMT'),(1056,1,3600,1,'WEST'),(1056,2,0,0,'WET'),(1056,3,3600,1,'WEST'),(1056,4,0,0,'WET'),(1056,5,7200,1,'WEMT'),(1056,6,0,0,'WET'),(1056,7,3600,0,'CET'),(1056,8,3600,0,'CET'),(1056,9,7200,1,'CEST'),(1056,10,3600,1,'WEST'),(1056,11,0,0,'WET'),(1057,0,4920,0,'LMT'),(1057,1,3600,0,'CET'),(1057,2,3600,0,'CET'),(1057,3,7200,1,'CEST'),(1057,4,7200,1,'CEST'),(1057,5,7200,1,'CEST'),(1057,6,3600,0,'CET'),(1058,0,-75,0,'LMT'),(1058,1,3600,1,'BST'),(1058,2,0,0,'GMT'),(1058,3,7200,1,'BDST'),(1058,4,3600,0,'BST'),(1058,5,3600,1,'BST'),(1058,6,0,0,'GMT'),(1058,7,0,0,'GMT'),(1059,0,1476,0,'LMT'),(1059,1,7200,1,'CEST'),(1059,2,3600,0,'CET'),(1059,3,7200,1,'CEST'),(1059,4,3600,0,'CET'),(1059,5,3600,1,'WEST'),(1059,6,0,0,'WET'),(1059,7,0,0,'WET'),(1059,8,3600,1,'WEST'),(1059,9,3600,0,'WET'),(1059,10,7200,1,'WEST'),(1059,11,7200,1,'WEST'),(1059,12,7200,1,'CEST'),(1059,13,3600,0,'CET'),(1060,0,-884,0,'LMT'),(1060,1,3600,1,'WEST'),(1060,2,0,0,'WET'),(1060,3,7200,1,'WEMT'),(1060,4,0,0,'WET'),(1060,5,7200,1,'CEST'),(1060,6,3600,0,'CET'),(1060,7,7200,1,'CEST'),(1060,8,3600,0,'CET'),(1060,9,7200,1,'CEST'),(1060,10,3600,0,'CET'),(1061,0,3484,0,'LMT'),(1061,1,7200,1,'CEST'),(1061,2,3600,0,'CET'),(1061,3,3600,0,'CET'),(1061,4,7200,1,'CEST'),(1061,5,7200,1,'CEST'),(1061,6,3600,0,'CET'),(1062,0,5989,0,'LMT'),(1062,1,5989,0,'HMT'),(1062,2,10800,1,'EEST'),(1062,3,7200,0,'EET'),(1062,4,10800,1,'EEST'),(1062,5,7200,0,'EET'),(1063,0,6616,0,'LMT'),(1063,1,6600,0,'MMT'),(1063,2,7200,0,'EET'),(1063,3,10800,0,'MSK'),(1063,4,3600,0,'CET'),(1063,5,7200,1,'CEST'),(1063,6,7200,1,'CEST'),(1063,7,14400,1,'MSD'),(1063,8,10800,0,'MSK'),(1063,9,14400,1,'MSD'),(1063,10,10800,1,'EEST'),(1063,11,7200,0,'EET'),(1063,12,10800,0,'+03'),(1064,0,1772,0,'LMT'),(1064,1,561,0,'PMT'),(1064,2,3600,1,'WEST'),(1064,3,0,0,'WET'),(1064,4,3600,1,'WEST'),(1064,5,7200,1,'WEMT'),(1064,6,0,0,'WET'),(1064,7,7200,1,'CEST'),(1064,8,3600,0,'CET'),(1064,9,7200,1,'CEST'),(1064,10,3600,0,'CET'),(1065,0,9017,0,'LMT'),(1065,1,9017,0,'MMT'),(1065,2,12679,1,'MST'),(1065,3,9079,0,'MMT'),(1065,4,16279,1,'MDST'),(1065,5,14400,1,'MSD'),(1065,6,10800,0,'MSK'),(1065,7,14400,1,'MSD'),(1065,8,18000,1,'+05'),(1065,9,7200,0,'EET'),(1065,10,10800,0,'MSK'),(1065,11,14400,1,'MSD'),(1065,12,10800,1,'EEST'),(1065,13,7200,0,'EET'),(1065,14,14400,0,'MSK'),(1065,15,14400,1,'MSD'),(1065,16,10800,0,'MSK'),(1066,0,8008,0,'LMT'),(1066,1,10800,1,'EEST'),(1066,2,7200,0,'EET'),(1066,3,7200,0,'EET'),(1066,4,10800,1,'EEST'),(1067,0,2580,0,'LMT'),(1067,1,7200,1,'CEST'),(1067,2,3600,0,'CET'),(1067,3,3600,0,'CET'),(1067,4,7200,1,'CEST'),(1067,5,7200,1,'CEST'),(1067,6,3600,0,'CET'),(1068,0,561,0,'LMT'),(1068,1,561,0,'PMT'),(1068,2,3600,1,'WEST'),(1068,3,0,0,'WET'),(1068,4,3600,1,'WEST'),(1068,5,0,0,'WET'),(1068,6,3600,0,'CET'),(1068,7,7200,1,'CEST'),(1068,8,7200,1,'CEST'),(1068,9,7200,1,'WEMT'),(1068,10,3600,0,'CET'),(1068,11,7200,1,'CEST'),(1068,12,3600,0,'CET'),(1069,0,4920,0,'LMT'),(1069,1,3600,0,'CET'),(1069,2,3600,0,'CET'),(1069,3,7200,1,'CEST'),(1069,4,7200,1,'CEST'),(1069,5,7200,1,'CEST'),(1069,6,3600,0,'CET'),(1070,0,3464,0,'PMT'),(1070,1,7200,1,'CEST'),(1070,2,3600,0,'CET'),(1070,3,7200,1,'CEST'),(1070,4,3600,0,'CET'),(1070,5,0,1,'GMT'),(1070,6,7200,1,'CEST'),(1070,7,3600,0,'CET'),(1071,0,5794,0,'LMT'),(1071,1,5794,0,'RMT'),(1071,2,9394,1,'LST'),(1071,3,7200,0,'EET'),(1071,4,10800,0,'MSK'),(1071,5,3600,0,'CET'),(1071,6,7200,1,'CEST'),(1071,7,7200,1,'CEST'),(1071,8,14400,1,'MSD'),(1071,9,10800,0,'MSK'),(1071,10,14400,1,'MSD'),(1071,11,10800,1,'EEST'),(1071,12,7200,0,'EET'),(1071,13,10800,1,'EEST'),(1071,14,7200,0,'EET'),(1072,0,2996,0,'RMT'),(1072,1,7200,1,'CEST'),(1072,2,3600,0,'CET'),(1072,3,3600,0,'CET'),(1072,4,7200,1,'CEST'),(1072,5,7200,1,'CEST'),(1072,6,3600,0,'CET'),(1073,0,12020,0,'LMT'),(1073,1,10800,0,'+03'),(1073,2,14400,0,'+04'),(1073,3,18000,1,'+05'),(1073,4,14400,0,'+04'),(1073,5,18000,1,'+05'),(1073,6,14400,1,'+04'),(1073,7,10800,0,'+03'),(1073,8,10800,1,'+03'),(1073,9,7200,0,'+02'),(1073,10,14400,1,'+04'),(1073,11,14400,0,'+04'),(1074,0,2996,0,'RMT'),(1074,1,7200,1,'CEST'),(1074,2,3600,0,'CET'),(1074,3,3600,0,'CET'),(1074,4,7200,1,'CEST'),(1074,5,7200,1,'CEST'),(1074,6,3600,0,'CET'),(1075,0,4920,0,'LMT'),(1075,1,3600,0,'CET'),(1075,2,3600,0,'CET'),(1075,3,7200,1,'CEST'),(1075,4,7200,1,'CEST'),(1075,5,7200,1,'CEST'),(1075,6,3600,0,'CET'),(1076,0,11058,0,'LMT'),(1076,1,10800,0,'+03'),(1076,2,18000,1,'+05'),(1076,3,14400,0,'+04'),(1076,4,14400,0,'+04'),(1076,5,18000,1,'+05'),(1076,6,14400,1,'+04'),(1076,7,10800,0,'+03'),(1076,8,14400,0,'+04'),(1077,0,8184,0,'LMT'),(1077,1,8160,0,'SMT'),(1077,2,7200,0,'EET'),(1077,3,10800,0,'MSK'),(1077,4,3600,0,'CET'),(1077,5,7200,1,'CEST'),(1077,6,7200,1,'CEST'),(1077,7,14400,1,'MSD'),(1077,8,10800,0,'MSK'),(1077,9,14400,1,'MSD'),(1077,10,10800,1,'EEST'),(1077,11,10800,1,'EEST'),(1077,12,7200,0,'EET'),(1077,13,14400,0,'MSK'),(1077,14,10800,0,'MSK'),(1078,0,4920,0,'LMT'),(1078,1,3600,0,'CET'),(1078,2,3600,0,'CET'),(1078,3,7200,1,'CEST'),(1078,4,7200,1,'CEST'),(1078,5,7200,1,'CEST'),(1078,6,3600,0,'CET'),(1079,0,7016,0,'IMT'),(1079,1,7200,0,'EET'),(1079,2,3600,0,'CET'),(1079,3,7200,1,'CEST'),(1079,4,3600,0,'CET'),(1079,5,10800,1,'EEST'),(1079,6,7200,0,'EET'),(1079,7,10800,1,'EEST'),(1079,8,10800,1,'EEST'),(1079,9,7200,0,'EET'),(1080,0,3614,0,'SET'),(1080,1,3600,0,'CET'),(1080,2,7200,1,'CEST'),(1080,3,7200,1,'CEST'),(1080,4,3600,0,'CET'),(1081,0,5940,0,'LMT'),(1081,1,5940,0,'TMT'),(1081,2,7200,1,'CEST'),(1081,3,3600,0,'CET'),(1081,4,3600,0,'CET'),(1081,5,7200,0,'EET'),(1081,6,10800,0,'MSK'),(1081,7,7200,1,'CEST'),(1081,8,14400,1,'MSD'),(1081,9,10800,0,'MSK'),(1081,10,14400,1,'MSD'),(1081,11,10800,1,'EEST'),(1081,12,7200,0,'EET'),(1081,13,7200,0,'EET'),(1081,14,10800,1,'EEST'),(1081,15,10800,1,'EEST'),(1082,0,4760,0,'LMT'),(1082,1,3600,0,'CET'),(1082,2,7200,1,'CEST'),(1082,3,3600,0,'CET'),(1082,4,7200,1,'CEST'),(1083,0,6920,0,'LMT'),(1083,1,6900,0,'CMT'),(1083,2,6264,0,'BMT'),(1083,3,10800,1,'EEST'),(1083,4,7200,0,'EET'),(1083,5,7200,0,'EET'),(1083,6,10800,1,'EEST'),(1083,7,3600,0,'CET'),(1083,8,7200,1,'CEST'),(1083,9,7200,1,'CEST'),(1083,10,14400,1,'MSD'),(1083,11,10800,0,'MSK'),(1083,12,10800,0,'MSK'),(1083,13,14400,1,'MSD'),(1083,14,10800,1,'EEST'),(1083,15,7200,0,'EET'),(1084,0,11616,0,'LMT'),(1084,1,10800,0,'+03'),(1084,2,18000,1,'+05'),(1084,3,14400,0,'+04'),(1084,4,14400,0,'+04'),(1084,5,18000,1,'+05'),(1084,6,14400,1,'+04'),(1084,7,10800,0,'+03'),(1084,8,10800,1,'+03'),(1084,9,7200,0,'+02'),(1084,10,14400,1,'+04'),(1084,11,14400,0,'+04'),(1085,0,5352,0,'LMT'),(1085,1,3600,0,'CET'),(1085,2,7200,1,'CEST'),(1085,3,3600,0,'CET'),(1085,4,7200,1,'CEST'),(1085,5,14400,1,'MSD'),(1085,6,10800,0,'MSK'),(1085,7,10800,0,'MSK'),(1085,8,14400,1,'MSD'),(1085,9,7200,0,'EET'),(1085,10,10800,1,'EEST'),(1085,11,10800,1,'EEST'),(1085,12,7200,0,'EET'),(1086,0,1786,0,'BMT'),(1086,1,7200,1,'CEST'),(1086,2,3600,0,'CET'),(1086,3,7200,1,'CEST'),(1086,4,3600,0,'CET'),(1087,0,2996,0,'RMT'),(1087,1,7200,1,'CEST'),(1087,2,3600,0,'CET'),(1087,3,3600,0,'CET'),(1087,4,7200,1,'CEST'),(1087,5,7200,1,'CEST'),(1087,6,3600,0,'CET'),(1088,0,3921,0,'LMT'),(1088,1,7200,1,'CEST'),(1088,2,3600,0,'CET'),(1088,3,7200,1,'CEST'),(1088,4,3600,0,'CET'),(1088,5,7200,1,'CEST'),(1088,6,3600,0,'CET'),(1089,0,6076,0,'LMT'),(1089,1,5040,0,'WMT'),(1089,2,5736,0,'KMT'),(1089,3,3600,0,'CET'),(1089,4,7200,0,'EET'),(1089,5,10800,0,'MSK'),(1089,6,3600,0,'CET'),(1089,7,7200,1,'CEST'),(1089,8,7200,1,'CEST'),(1089,9,14400,1,'MSD'),(1089,10,10800,0,'MSK'),(1089,11,14400,1,'MSD'),(1089,12,10800,1,'EEST'),(1089,13,7200,0,'EET'),(1089,14,7200,1,'CEST'),(1089,15,3600,0,'CET'),(1089,16,7200,0,'EET'),(1089,17,10800,1,'EEST'),(1090,0,10660,0,'LMT'),(1090,1,10800,0,'+03'),(1090,2,14400,0,'+04'),(1090,3,18000,1,'+05'),(1090,4,14400,0,'+04'),(1090,5,18000,1,'+05'),(1090,6,14400,1,'+04'),(1090,7,10800,0,'+03'),(1090,8,14400,0,'+04'),(1091,0,5040,0,'LMT'),(1091,1,5040,0,'WMT'),(1091,2,7200,1,'CEST'),(1091,3,3600,0,'CET'),(1091,4,7200,1,'CEST'),(1091,5,3600,0,'CET'),(1091,6,10800,1,'EEST'),(1091,7,7200,0,'EET'),(1091,8,7200,0,'EET'),(1091,9,7200,1,'CEST'),(1091,10,3600,0,'CET'),(1092,0,4920,0,'LMT'),(1092,1,3600,0,'CET'),(1092,2,3600,0,'CET'),(1092,3,7200,1,'CEST'),(1092,4,7200,1,'CEST'),(1092,5,7200,1,'CEST'),(1092,6,3600,0,'CET'),(1093,0,8440,0,'LMT'),(1093,1,8400,0,'+0220'),(1093,2,7200,0,'EET'),(1093,3,10800,0,'MSK'),(1093,4,3600,0,'CET'),(1093,5,7200,1,'CEST'),(1093,6,7200,1,'CEST'),(1093,7,14400,1,'MSD'),(1093,8,10800,0,'MSK'),(1093,9,14400,1,'MSD'),(1093,10,10800,1,'EEST'),(1093,11,10800,1,'EEST'),(1093,12,7200,0,'EET'),(1094,0,1786,0,'BMT'),(1094,1,7200,1,'CEST'),(1094,2,3600,0,'CET'),(1094,3,7200,1,'CEST'),(1094,4,3600,0,'CET'),(1095,0,-75,0,'LMT'),(1095,1,3600,1,'BST'),(1095,2,0,0,'GMT'),(1095,3,7200,1,'BDST'),(1095,4,3600,0,'BST'),(1095,5,3600,1,'BST'),(1095,6,0,0,'GMT'),(1095,7,0,0,'GMT'),(1096,0,-75,0,'LMT'),(1096,1,3600,1,'BST'),(1096,2,0,0,'GMT'),(1096,3,7200,1,'BDST'),(1096,4,3600,0,'BST'),(1096,5,3600,1,'BST'),(1096,6,0,0,'GMT'),(1096,7,0,0,'GMT'),(1097,0,0,0,'GMT'),(1098,0,0,0,'GMT'),(1099,0,0,0,'GMT'),(1100,0,0,0,'GMT'),(1101,0,0,0,'GMT'),(1102,0,-36000,0,'HST'),(1103,0,27402,0,'LMT'),(1103,1,28800,0,'HKT'),(1103,2,32400,1,'HKST'),(1103,3,30600,0,'HKT'),(1103,4,32400,0,'JST'),(1103,5,28800,0,'HKT'),(1104,0,-5280,0,'LMT'),(1104,1,0,1,'+00'),(1104,2,-3600,0,'-01'),(1104,3,-3600,0,'-01'),(1104,4,0,1,'+00'),(1104,5,0,0,'GMT'),(1105,0,8836,0,'LMT'),(1105,1,10800,0,'EAT'),(1105,2,9000,0,'+0230'),(1105,3,9900,0,'+0245'),(1105,4,10800,0,'EAT'),(1106,0,17380,0,'LMT'),(1106,1,18000,0,'+05'),(1106,2,21600,0,'+06'),(1107,0,25372,0,'LMT'),(1107,1,25200,0,'+07'),(1108,0,23260,0,'LMT'),(1108,1,23400,0,'+0630'),(1109,0,8836,0,'LMT'),(1109,1,10800,0,'EAT'),(1109,2,9000,0,'+0230'),(1109,3,9900,0,'+0245'),(1109,4,10800,0,'EAT'),(1110,0,0,0,'-00'),(1110,1,18000,0,'+05'),(1111,0,13308,0,'LMT'),(1111,1,14400,0,'+04'),(1112,0,17640,0,'LMT'),(1112,1,17640,0,'MMT'),(1112,2,18000,0,'+05'),(1113,0,13800,0,'LMT'),(1113,1,18000,1,'+05'),(1113,2,14400,0,'+04'),(1114,0,8836,0,'LMT'),(1114,1,10800,0,'EAT'),(1114,2,9000,0,'+0230'),(1114,3,9900,0,'+0245'),(1114,4,10800,0,'EAT'),(1115,0,13312,0,'LMT'),(1115,1,14400,0,'+04'),(1116,0,12344,0,'LMT'),(1116,1,12344,0,'TMT'),(1116,2,12600,0,'+0330'),(1116,3,18000,1,'+05'),(1116,4,14400,0,'+04'),(1116,5,16200,1,'+0430'),(1116,6,12600,0,'+0330'),(1117,0,8454,0,'LMT'),(1117,1,8440,0,'JMT'),(1117,2,10800,1,'IDT'),(1117,3,7200,0,'IST'),(1117,4,14400,1,'IDDT'),(1117,5,10800,1,'IDT'),(1118,0,-18430,0,'LMT'),(1118,1,-18430,0,'KMT'),(1118,2,-18000,0,'EST'),(1118,3,-14400,1,'EDT'),(1119,0,33539,0,'LMT'),(1119,1,36000,1,'JDT'),(1119,2,32400,0,'JST'),(1119,3,32400,0,'JST'),(1120,0,40160,0,'LMT'),(1120,1,39600,0,'+11'),(1120,2,36000,0,'+10'),(1120,3,32400,0,'+09'),(1120,4,-43200,0,'-12'),(1120,5,43200,0,'+12'),(1121,0,3164,0,'LMT'),(1121,1,7200,1,'CEST'),(1121,2,3600,0,'CET'),(1121,3,7200,0,'EET'),(1122,0,7200,1,'MEST'),(1122,1,3600,0,'MET'),(1122,2,7200,1,'MEST'),(1122,3,3600,0,'MET'),(1123,0,-25200,0,'MST'),(1124,0,-21600,1,'MDT'),(1124,1,-25200,0,'MST'),(1124,2,-21600,1,'MWT'),(1124,3,-21600,1,'MPT'),(1125,0,-28084,0,'LMT'),(1125,1,-25200,0,'MST'),(1125,2,-28800,0,'PST'),(1125,3,-25200,1,'PDT'),(1125,4,-25200,1,'PWT'),(1125,5,-25200,1,'PPT'),(1126,0,-25540,0,'LMT'),(1126,1,-25200,0,'MST'),(1126,2,-21600,0,'CST'),(1126,3,-28800,0,'PST'),(1126,4,-21600,1,'MDT'),(1126,5,-25200,0,'MST'),(1127,0,-23796,0,'LMT'),(1127,1,-25200,0,'MST'),(1127,2,-21600,0,'CST'),(1127,3,-18000,1,'CDT'),(1127,4,-18000,1,'CWT'),(1128,0,41944,0,'LMT'),(1128,1,45000,1,'NZST'),(1128,2,41400,0,'NZMT'),(1128,3,43200,1,'NZST'),(1128,4,46800,1,'NZDT'),(1128,5,43200,0,'NZST'),(1128,6,43200,0,'NZST'),(1129,0,44028,0,'LMT'),(1129,1,44100,0,'+1215'),(1129,2,49500,1,'+1345'),(1129,3,45900,0,'+1245'),(1129,4,45900,0,'+1245'),(1130,0,-25196,0,'LMT'),(1130,1,-21600,1,'MDT'),(1130,2,-25200,0,'MST'),(1130,3,-21600,1,'MWT'),(1130,4,-21600,1,'MPT'),(1131,0,29143,0,'LMT'),(1131,1,32400,1,'CDT'),(1131,2,28800,0,'CST'),(1132,0,-25200,1,'PDT'),(1132,1,-28800,0,'PST'),(1132,2,-25200,1,'PWT'),(1132,3,-25200,1,'PPT'),(1133,0,45184,0,'LMT'),(1133,1,-41216,0,'LMT'),(1133,2,-41400,0,'-1130'),(1133,3,-36000,1,'-10'),(1133,4,-39600,0,'-11'),(1133,5,46800,0,'+13'),(1133,6,50400,1,'+14'),(1134,0,41944,0,'LMT'),(1134,1,45000,1,'NZST'),(1134,2,41400,0,'NZMT'),(1134,3,43200,1,'NZST'),(1134,4,46800,1,'NZDT'),(1134,5,43200,0,'NZST'),(1134,6,43200,0,'NZST'),(1135,0,35312,0,'PMMT'),(1135,1,36000,0,'+10'),(1135,2,32400,0,'+09'),(1135,3,39600,0,'+11'),(1136,0,44028,0,'LMT'),(1136,1,44100,0,'+1215'),(1136,2,49500,1,'+1345'),(1136,3,45900,0,'+1245'),(1136,4,45900,0,'+1245'),(1137,0,36428,0,'LMT'),(1137,1,36000,0,'+10'),(1137,2,32400,0,'+09'),(1137,3,36000,0,'+10'),(1138,0,-26248,0,'LMT'),(1138,1,-26248,0,'EMT'),(1138,2,-21600,1,'-06'),(1138,3,-25200,0,'-07'),(1138,4,-25200,0,'-07'),(1138,5,-21600,0,'-06'),(1138,6,-18000,1,'-05'),(1139,0,40396,0,'LMT'),(1139,1,43200,1,'+12'),(1139,2,39600,0,'+11'),(1140,0,-41060,0,'LMT'),(1140,1,-43200,0,'-12'),(1140,2,-39600,0,'-11'),(1140,3,46800,0,'+13'),(1141,0,-41096,0,'LMT'),(1141,1,-39600,0,'-11'),(1141,2,46800,0,'+13'),(1142,0,42944,0,'LMT'),(1142,1,46800,1,'+13'),(1142,2,43200,0,'+12'),(1143,0,43012,0,'LMT'),(1143,1,43200,0,'+12'),(1144,0,-21504,0,'LMT'),(1144,1,-18000,0,'-05'),(1144,2,-18000,1,'-05'),(1144,3,-21600,0,'-06'),(1145,0,-32388,0,'LMT'),(1145,1,-32400,0,'-09'),(1146,0,38388,0,'LMT'),(1146,1,39600,0,'+11'),(1147,0,34740,0,'LMT'),(1147,1,36000,0,'GST'),(1147,2,32400,0,'+09'),(1147,3,39600,1,'GDT'),(1147,4,36000,0,'ChST'),(1148,0,-37886,0,'LMT'),(1148,1,-37800,0,'HST'),(1148,2,-34200,1,'HDT'),(1148,3,-34200,1,'HWT'),(1148,4,-34200,1,'HPT'),(1148,5,-36000,0,'HST'),(1149,0,-37886,0,'LMT'),(1149,1,-37800,0,'HST'),(1149,2,-34200,1,'HDT'),(1149,3,-34200,1,'HWT'),(1149,4,-34200,1,'HPT'),(1149,5,-36000,0,'HST'),(1150,0,-37760,0,'LMT'),(1150,1,-38400,0,'-1040'),(1150,2,-36000,0,'-10'),(1150,3,50400,0,'+14'),(1151,0,39116,0,'LMT'),(1151,1,39600,0,'+11'),(1151,2,32400,0,'+09'),(1151,3,36000,0,'+10'),(1151,4,43200,0,'+12'),(1151,5,39600,0,'+11'),(1152,0,40160,0,'LMT'),(1152,1,39600,0,'+11'),(1152,2,36000,0,'+10'),(1152,3,32400,0,'+09'),(1152,4,-43200,0,'-12'),(1152,5,43200,0,'+12'),(1153,0,41088,0,'LMT'),(1153,1,39600,0,'+11'),(1153,2,32400,0,'+09'),(1153,3,36000,0,'+10'),(1153,4,43200,0,'+12'),(1154,0,-33480,0,'LMT'),(1154,1,-34200,0,'-0930'),(1155,0,45432,0,'LMT'),(1155,1,-40968,0,'LMT'),(1155,2,-39600,0,'SST'),(1156,0,40060,0,'LMT'),(1156,1,41400,0,'+1130'),(1156,2,32400,0,'+09'),(1156,3,43200,0,'+12'),(1157,0,-40780,0,'LMT'),(1157,1,-40800,0,'-1120'),(1157,2,-41400,0,'-1130'),(1157,3,-39600,0,'-11'),(1158,0,40312,0,'LMT'),(1158,1,40320,0,'+1112'),(1158,2,41400,0,'+1130'),(1158,3,45000,1,'+1230'),(1158,4,39600,0,'+11'),(1159,0,39948,0,'LMT'),(1159,1,43200,1,'+12'),(1159,2,39600,0,'+11'),(1159,3,43200,1,'+12'),(1159,4,39600,0,'+11'),(1160,0,45432,0,'LMT'),(1160,1,-40968,0,'LMT'),(1160,2,-39600,0,'SST'),(1161,0,32276,0,'LMT'),(1161,1,32400,0,'+09'),(1162,0,-31220,0,'LMT'),(1162,1,-30600,0,'-0830'),(1162,2,-28800,0,'-08'),(1163,0,37972,0,'LMT'),(1163,1,39600,0,'+11'),(1163,2,32400,0,'+09'),(1163,3,36000,0,'+10'),(1163,4,39600,0,'+11'),(1164,0,37972,0,'LMT'),(1164,1,39600,0,'+11'),(1164,2,32400,0,'+09'),(1164,3,36000,0,'+10'),(1164,4,39600,0,'+11'),(1165,0,35312,0,'PMMT'),(1165,1,36000,0,'+10'),(1166,0,-38344,0,'LMT'),(1166,1,-37800,0,'-1030'),(1166,2,-36000,0,'-10'),(1166,3,-34200,1,'-0930'),(1167,0,34740,0,'LMT'),(1167,1,36000,0,'GST'),(1167,2,32400,0,'+09'),(1167,3,39600,1,'GDT'),(1167,4,36000,0,'ChST'),(1168,0,45432,0,'LMT'),(1168,1,-40968,0,'LMT'),(1168,2,-39600,0,'SST'),(1169,0,-35896,0,'LMT'),(1169,1,-36000,0,'-10'),(1170,0,41524,0,'LMT'),(1170,1,43200,0,'+12'),(1171,0,44360,0,'LMT'),(1171,1,44400,0,'+1220'),(1171,2,46800,0,'+13'),(1171,3,50400,1,'+14'),(1171,4,46800,0,'+13'),(1171,5,50400,1,'+14'),(1172,0,36428,0,'LMT'),(1172,1,36000,0,'+10'),(1172,2,32400,0,'+09'),(1172,3,36000,0,'+10'),(1173,0,39988,0,'LMT'),(1173,1,43200,0,'+12'),(1174,0,44120,0,'LMT'),(1174,1,43200,0,'+12'),(1175,0,36428,0,'LMT'),(1175,1,36000,0,'+10'),(1175,2,32400,0,'+09'),(1175,3,36000,0,'+10'),(1176,0,5040,0,'LMT'),(1176,1,5040,0,'WMT'),(1176,2,7200,1,'CEST'),(1176,3,3600,0,'CET'),(1176,4,7200,1,'CEST'),(1176,5,3600,0,'CET'),(1176,6,10800,1,'EEST'),(1176,7,7200,0,'EET'),(1176,8,7200,0,'EET'),(1176,9,7200,1,'CEST'),(1176,10,3600,0,'CET'),(1177,0,-2205,0,'LMT'),(1177,1,3600,1,'WEST'),(1177,2,0,0,'WET'),(1177,3,3600,1,'WEST'),(1177,4,0,0,'WET'),(1177,5,7200,1,'WEMT'),(1177,6,0,0,'WET'),(1177,7,3600,0,'CET'),(1177,8,3600,0,'CET'),(1177,9,7200,1,'CEST'),(1177,10,3600,1,'WEST'),(1177,11,0,0,'WET'),(1178,0,29160,0,'LMT'),(1178,1,28800,0,'CST'),(1178,2,32400,0,'JST'),(1178,3,32400,1,'CDT'),(1178,4,28800,0,'CST'),(1179,0,30472,0,'LMT'),(1179,1,30600,0,'KST'),(1179,2,32400,0,'JST'),(1179,3,32400,0,'KST'),(1179,4,34200,1,'KDT'),(1179,5,36000,1,'KDT'),(1180,0,24925,0,'LMT'),(1180,1,24925,0,'SMT'),(1180,2,25200,0,'+07'),(1180,3,26400,1,'+0720'),(1180,4,26400,0,'+0720'),(1180,5,27000,0,'+0730'),(1180,6,32400,0,'+09'),(1180,7,28800,0,'+08'),(1181,0,-15865,0,'LMT'),(1181,1,-14400,0,'AST'),(1181,2,-10800,1,'APT'),(1181,3,-10800,1,'AWT'),(1182,0,-15264,0,'LMT'),(1182,1,-10800,1,'ADT'),(1182,2,-14400,0,'AST'),(1182,3,-10800,1,'AWT'),(1182,4,-10800,1,'APT'),(1183,0,-25116,0,'LMT'),(1183,1,-21600,1,'MDT'),(1183,2,-25200,0,'MST'),(1183,3,-21600,1,'MWT'),(1183,4,-21600,1,'MPT'),(1183,5,-21600,0,'CST'),(1184,0,-21036,0,'LMT'),(1184,1,-18000,1,'CDT'),(1184,2,-21600,0,'CST'),(1184,3,-18000,0,'EST'),(1184,4,-18000,1,'CWT'),(1184,5,-18000,1,'CPT'),(1184,6,-21600,0,'CST'),(1185,0,-19088,0,'LMT'),(1185,1,-19176,0,'CMT'),(1185,2,-18000,0,'EST'),(1186,0,-17762,0,'LMT'),(1186,1,-14400,1,'EDT'),(1186,2,-18000,0,'EST'),(1186,3,-14400,1,'EWT'),(1186,4,-14400,1,'EPT'),(1187,0,-37886,0,'LMT'),(1187,1,-37800,0,'HST'),(1187,2,-34200,1,'HDT'),(1187,3,-34200,1,'HWT'),(1187,4,-34200,1,'HPT'),(1187,5,-36000,0,'HST'),(1188,0,-26898,0,'LMT'),(1188,1,-21600,1,'MDT'),(1188,2,-25200,0,'MST'),(1188,3,-21600,1,'MWT'),(1189,0,-25196,0,'LMT'),(1189,1,-21600,1,'MDT'),(1189,2,-25200,0,'MST'),(1189,3,-21600,1,'MWT'),(1189,4,-21600,1,'MPT'),(1190,0,-31220,0,'LMT'),(1190,1,-30600,0,'-0830'),(1190,2,-28800,0,'-08'),(1191,0,-28378,0,'LMT'),(1191,1,-25200,1,'PDT'),(1191,2,-28800,0,'PST'),(1191,3,-25200,1,'PWT'),(1191,4,-25200,1,'PPT'),(1192,0,-32388,0,'LMT'),(1192,1,-32400,0,'-09'),(1193,0,-35976,0,'LMT'),(1193,1,-36000,0,'AST'),(1193,2,-32400,1,'AWT'),(1193,3,-32400,1,'APT'),(1193,4,-36000,0,'AHST'),(1193,5,-32400,1,'AHDT'),(1193,6,-32400,0,'YST'),(1193,7,-28800,1,'AKDT'),(1193,8,-32400,0,'AKST'),(1194,0,6952,0,'LMT'),(1194,1,7016,0,'IMT'),(1194,2,10800,1,'EEST'),(1194,3,7200,0,'EET'),(1194,4,14400,1,'+04'),(1194,5,10800,0,'+03'),(1194,6,10800,1,'EEST'),(1194,7,7200,0,'EET'),(1194,8,10800,1,'EEST'),(1194,9,7200,0,'EET'),(1194,10,10800,0,'+03'),(1195,0,0,0,'UTC'),(1196,0,-35976,0,'LMT'),(1196,1,-36000,0,'AST'),(1196,2,-32400,1,'AWT'),(1196,3,-32400,1,'APT'),(1196,4,-36000,0,'AHST'),(1196,5,-32400,1,'AHDT'),(1196,6,-32400,0,'YST'),(1196,7,-28800,1,'AKDT'),(1196,8,-32400,0,'AKST'),(1197,0,-42398,0,'LMT'),(1197,1,-39600,0,'NST'),(1197,2,-36000,1,'NWT'),(1197,3,-36000,1,'NPT'),(1197,4,-39600,0,'BST'),(1197,5,-36000,1,'BDT'),(1197,6,-36000,0,'AHST'),(1197,7,-32400,1,'HDT'),(1197,8,-36000,0,'HST'),(1198,0,-26898,0,'LMT'),(1198,1,-21600,1,'MDT'),(1198,2,-25200,0,'MST'),(1198,3,-21600,1,'MWT'),(1199,0,-21036,0,'LMT'),(1199,1,-18000,1,'CDT'),(1199,2,-21600,0,'CST'),(1199,3,-18000,0,'EST'),(1199,4,-18000,1,'CWT'),(1199,5,-18000,1,'CPT'),(1199,6,-21600,0,'CST'),(1200,0,-20678,0,'LMT'),(1200,1,-18000,1,'CDT'),(1200,2,-21600,0,'CST'),(1200,3,-18000,1,'CWT'),(1200,4,-18000,1,'CPT'),(1200,5,-18000,0,'EST'),(1200,6,-14400,1,'EDT'),(1201,0,-17762,0,'LMT'),(1201,1,-14400,1,'EDT'),(1201,2,-18000,0,'EST'),(1201,3,-14400,1,'EWT'),(1201,4,-14400,1,'EPT'),(1202,0,-37886,0,'LMT'),(1202,1,-37800,0,'HST'),(1202,2,-34200,1,'HDT'),(1202,3,-34200,1,'HWT'),(1202,4,-34200,1,'HPT'),(1202,5,-36000,0,'HST'),(1203,0,-20790,0,'LMT'),(1203,1,-18000,1,'CDT'),(1203,2,-21600,0,'CST'),(1203,3,-18000,1,'CWT'),(1203,4,-18000,1,'CPT'),(1203,5,-18000,0,'EST'),(1203,6,-21600,0,'CST'),(1204,0,-19931,0,'LMT'),(1204,1,-21600,0,'CST'),(1204,2,-18000,0,'EST'),(1204,3,-14400,1,'EWT'),(1204,4,-14400,1,'EPT'),(1204,5,-14400,1,'EDT'),(1205,0,-25196,0,'LMT'),(1205,1,-21600,1,'MDT'),(1205,2,-25200,0,'MST'),(1205,3,-21600,1,'MWT'),(1205,4,-21600,1,'MPT'),(1206,0,-28378,0,'LMT'),(1206,1,-25200,1,'PDT'),(1206,2,-28800,0,'PST'),(1206,3,-25200,1,'PWT'),(1206,4,-25200,1,'PPT'),(1207,0,-28378,0,'LMT'),(1207,1,-25200,1,'PDT'),(1207,2,-28800,0,'PST'),(1207,3,-25200,1,'PWT'),(1207,4,-25200,1,'PPT'),(1208,0,45432,0,'LMT'),(1208,1,-40968,0,'LMT'),(1208,2,-39600,0,'SST'),(1209,0,0,0,'UTC'),(1210,0,0,0,'UTC'),(1211,0,9017,0,'LMT'),(1211,1,9017,0,'MMT'),(1211,2,12679,1,'MST'),(1211,3,9079,0,'MMT'),(1211,4,16279,1,'MDST'),(1211,5,14400,1,'MSD'),(1211,6,10800,0,'MSK'),(1211,7,14400,1,'MSD'),(1211,8,18000,1,'+05'),(1211,9,7200,0,'EET'),(1211,10,10800,0,'MSK'),(1211,11,14400,1,'MSD'),(1211,12,10800,1,'EEST'),(1211,13,7200,0,'EET'),(1211,14,14400,0,'MSK'),(1211,15,14400,1,'MSD'),(1211,16,10800,0,'MSK'),(1212,0,3600,1,'WEST'),(1212,1,0,0,'WET'),(1213,0,0,0,'UTC'),(1214,0,-17762,0,'LMT'),(1214,1,-14400,1,'EDT'),(1214,2,-18000,0,'EST'),(1214,3,-14400,1,'EWT'),(1214,4,-14400,1,'EPT'),(1215,0,-968,0,'LMT'),(1215,1,0,0,'GMT'),(1216,0,-52,0,'LMT'),(1216,1,1200,1,'+0020'),(1216,2,0,0,'GMT'),(1217,0,8836,0,'LMT'),(1217,1,10800,0,'EAT'),(1217,2,9000,0,'+0230'),(1217,3,9900,0,'+0245'),(1217,4,10800,0,'EAT'),(1218,0,732,0,'LMT'),(1218,1,561,0,'PMT'),(1218,2,3600,1,'WEST'),(1218,3,0,0,'WET'),(1218,4,0,0,'WET'),(1218,5,7200,1,'CEST'),(1218,6,3600,0,'CET'),(1218,7,3600,1,'WEST'),(1219,0,8836,0,'LMT'),(1219,1,10800,0,'EAT'),(1219,2,9000,0,'+0230'),(1219,3,9900,0,'+0245'),(1219,4,10800,0,'EAT'),(1220,0,8836,0,'LMT'),(1220,1,10800,0,'EAT'),(1220,2,9000,0,'+0230'),(1220,3,9900,0,'+0245'),(1220,4,10800,0,'EAT'),(1221,0,-968,0,'LMT'),(1221,1,0,0,'GMT'),(1222,0,816,0,'LMT'),(1222,1,3600,0,'WAT'),(1223,0,-968,0,'LMT'),(1223,1,0,0,'GMT'),(1224,0,-3740,0,'LMT'),(1224,1,-3600,0,'-01'),(1224,2,0,0,'GMT'),(1225,0,7820,0,'LMT'),(1225,1,7200,0,'CAT'),(1226,0,816,0,'LMT'),(1226,1,3600,0,'WAT'),(1227,0,7820,0,'LMT'),(1227,1,7200,0,'CAT'),(1228,0,7509,0,'LMT'),(1228,1,10800,1,'EEST'),(1228,2,7200,0,'EET'),(1228,3,10800,1,'EEST'),(1229,0,-1820,0,'LMT'),(1229,1,3600,1,'+01'),(1229,2,0,0,'+00'),(1229,3,3600,0,'+01'),(1229,4,0,1,'+00'),(1230,0,-1276,0,'LMT'),(1230,1,0,0,'WET'),(1230,2,3600,1,'WEST'),(1230,3,0,0,'WET'),(1230,4,3600,0,'CET'),(1230,5,7200,1,'CEST'),(1230,6,3600,0,'CET'),(1231,0,-968,0,'LMT'),(1231,1,0,0,'GMT'),(1232,0,-968,0,'LMT'),(1232,1,0,0,'GMT'),(1233,0,8836,0,'LMT'),(1233,1,10800,0,'EAT'),(1233,2,9000,0,'+0230'),(1233,3,9900,0,'+0245'),(1233,4,10800,0,'EAT'),(1234,0,8836,0,'LMT'),(1234,1,10800,0,'EAT'),(1234,2,9000,0,'+0230'),(1234,3,9900,0,'+0245'),(1234,4,10800,0,'EAT'),(1235,0,816,0,'LMT'),(1235,1,3600,0,'WAT'),(1236,0,-3168,0,'LMT'),(1236,1,-3600,0,'-01'),(1236,2,3600,1,'+01'),(1236,3,0,0,'+00'),(1236,4,0,1,'+00'),(1236,5,3600,0,'+01'),(1237,0,-968,0,'LMT'),(1237,1,0,0,'GMT'),(1238,0,7820,0,'LMT'),(1238,1,7200,0,'CAT'),(1239,0,7820,0,'LMT'),(1239,1,7200,0,'CAT'),(1240,0,6720,0,'LMT'),(1240,1,5400,0,'SAST'),(1240,2,10800,1,'SAST'),(1240,3,7200,0,'SAST'),(1241,0,7588,0,'LMT'),(1241,1,10800,1,'CAST'),(1241,2,7200,0,'CAT'),(1241,3,10800,0,'EAT'),(1242,0,8836,0,'LMT'),(1242,1,10800,0,'EAT'),(1242,2,9000,0,'+0230'),(1242,3,9900,0,'+0245'),(1242,4,10800,0,'EAT'),(1243,0,7808,0,'LMT'),(1243,1,10800,1,'CAST'),(1243,2,7200,0,'CAT'),(1243,3,10800,0,'EAT'),(1243,4,7200,0,'CAT'),(1244,0,7820,0,'LMT'),(1244,1,7200,0,'CAT'),(1245,0,816,0,'LMT'),(1245,1,3600,0,'WAT'),(1246,0,816,0,'LMT'),(1246,1,3600,0,'WAT'),(1247,0,816,0,'LMT'),(1247,1,3600,0,'WAT'),(1248,0,-968,0,'LMT'),(1248,1,0,0,'GMT'),(1249,0,816,0,'LMT'),(1249,1,3600,0,'WAT'),(1250,0,7820,0,'LMT'),(1250,1,7200,0,'CAT'),(1251,0,7820,0,'LMT'),(1251,1,7200,0,'CAT'),(1252,0,816,0,'LMT'),(1252,1,3600,0,'WAT'),(1253,0,7820,0,'LMT'),(1253,1,7200,0,'CAT'),(1254,0,6720,0,'LMT'),(1254,1,5400,0,'SAST'),(1254,2,10800,1,'SAST'),(1254,3,7200,0,'SAST'),(1255,0,6720,0,'LMT'),(1255,1,5400,0,'SAST'),(1255,2,10800,1,'SAST'),(1255,3,7200,0,'SAST'),(1256,0,8836,0,'LMT'),(1256,1,10800,0,'EAT'),(1256,2,9000,0,'+0230'),(1256,3,9900,0,'+0245'),(1256,4,10800,0,'EAT'),(1257,0,-2588,0,'LMT'),(1257,1,-2588,0,'MMT'),(1257,2,-2670,0,'MMT'),(1257,3,0,0,'GMT'),(1258,0,8836,0,'LMT'),(1258,1,10800,0,'EAT'),(1258,2,9000,0,'+0230'),(1258,3,9900,0,'+0245'),(1258,4,10800,0,'EAT'),(1259,0,3612,0,'LMT'),(1259,1,3600,0,'WAT'),(1259,2,7200,1,'WAST'),(1260,0,816,0,'LMT'),(1260,1,3600,0,'WAT'),(1261,0,-968,0,'LMT'),(1261,1,0,0,'GMT'),(1262,0,-968,0,'LMT'),(1262,1,0,0,'GMT'),(1263,0,816,0,'LMT'),(1263,1,3600,0,'WAT'),(1264,0,1616,0,'LMT'),(1264,1,-2205,0,'LMT'),(1264,2,0,0,'GMT'),(1264,3,3600,0,'WAT'),(1264,4,0,0,'GMT'),(1265,0,-968,0,'LMT'),(1265,1,0,0,'GMT'),(1266,0,3164,0,'LMT'),(1266,1,7200,1,'CEST'),(1266,2,3600,0,'CET'),(1266,3,7200,0,'EET'),(1267,0,2444,0,'LMT'),(1267,1,561,0,'PMT'),(1267,2,7200,1,'CEST'),(1267,3,3600,0,'CET'),(1267,4,3600,0,'CET'),(1267,5,7200,1,'CEST'),(1268,0,4104,0,'LMT'),(1268,1,5400,0,'+0130'),(1268,2,7200,0,'SAST'),(1268,3,10800,1,'SAST'),(1268,4,3600,1,'WAT'),(1268,5,7200,0,'CAT'),(1269,0,-42398,0,'LMT'),(1269,1,-39600,0,'NST'),(1269,2,-36000,1,'NWT'),(1269,3,-36000,1,'NPT'),(1269,4,-39600,0,'BST'),(1269,5,-36000,1,'BDT'),(1269,6,-36000,0,'AHST'),(1269,7,-32400,1,'HDT'),(1269,8,-36000,0,'HST'),(1270,0,-35976,0,'LMT'),(1270,1,-36000,0,'AST'),(1270,2,-32400,1,'AWT'),(1270,3,-32400,1,'APT'),(1270,4,-36000,0,'AHST'),(1270,5,-32400,1,'AHDT'),(1270,6,-32400,0,'YST'),(1270,7,-28800,1,'AKDT'),(1270,8,-32400,0,'AKST'),(1271,0,-14764,0,'LMT'),(1271,1,-14400,0,'AST'),(1272,0,-14764,0,'LMT'),(1272,1,-14400,0,'AST'),(1273,0,-11568,0,'LMT'),(1273,1,-7200,1,'-02'),(1273,2,-10800,0,'-03'),(1274,0,-14028,0,'LMT'),(1274,1,-15408,0,'CMT'),(1274,2,-14400,0,'-04'),(1274,3,-10800,1,'-03'),(1274,4,-7200,1,'-02'),(1274,5,-10800,0,'-03'),(1275,0,-15788,0,'LMT'),(1275,1,-15408,0,'CMT'),(1275,2,-14400,0,'-04'),(1275,3,-10800,1,'-03'),(1275,4,-7200,1,'-02'),(1275,5,-10800,0,'-03'),(1276,0,-15788,0,'LMT'),(1276,1,-15408,0,'CMT'),(1276,2,-14400,0,'-04'),(1276,3,-10800,1,'-03'),(1276,4,-7200,1,'-02'),(1276,5,-10800,0,'-03'),(1277,0,-15408,0,'LMT'),(1277,1,-15408,0,'CMT'),(1277,2,-14400,0,'-04'),(1277,3,-10800,1,'-03'),(1277,4,-7200,1,'-02'),(1277,5,-10800,0,'-03'),(1278,0,-15672,0,'LMT'),(1278,1,-15408,0,'CMT'),(1278,2,-14400,0,'-04'),(1278,3,-10800,1,'-03'),(1278,4,-7200,1,'-02'),(1278,5,-10800,0,'-03'),(1279,0,-16044,0,'LMT'),(1279,1,-15408,0,'CMT'),(1279,2,-14400,0,'-04'),(1279,3,-10800,1,'-03'),(1279,4,-7200,1,'-02'),(1279,5,-10800,0,'-03'),(1280,0,-16516,0,'LMT'),(1280,1,-15408,0,'CMT'),(1280,2,-14400,0,'-04'),(1280,3,-10800,1,'-03'),(1280,4,-7200,1,'-02'),(1280,5,-10800,0,'-03'),(1281,0,-16612,0,'LMT'),(1281,1,-15408,0,'CMT'),(1281,2,-14400,0,'-04'),(1281,3,-10800,1,'-03'),(1281,4,-7200,1,'-02'),(1281,5,-10800,0,'-03'),(1282,0,-15700,0,'LMT'),(1282,1,-15408,0,'CMT'),(1282,2,-14400,0,'-04'),(1282,3,-10800,1,'-03'),(1282,4,-7200,1,'-02'),(1282,5,-10800,0,'-03'),(1283,0,-16444,0,'LMT'),(1283,1,-15408,0,'CMT'),(1283,2,-14400,0,'-04'),(1283,3,-10800,1,'-03'),(1283,4,-7200,1,'-02'),(1283,5,-10800,0,'-03'),(1284,0,-15924,0,'LMT'),(1284,1,-15408,0,'CMT'),(1284,2,-14400,0,'-04'),(1284,3,-10800,1,'-03'),(1284,4,-7200,1,'-02'),(1284,5,-10800,0,'-03'),(1284,6,-10800,1,'-03'),(1285,0,-15652,0,'LMT'),(1285,1,-15408,0,'CMT'),(1285,2,-14400,0,'-04'),(1285,3,-10800,1,'-03'),(1285,4,-7200,1,'-02'),(1285,5,-10800,0,'-03'),(1286,0,-16392,0,'LMT'),(1286,1,-15408,0,'CMT'),(1286,2,-14400,0,'-04'),(1286,3,-10800,1,'-03'),(1286,4,-7200,1,'-02'),(1286,5,-10800,0,'-03'),(1287,0,-16547,0,'LMT'),(1287,1,-16200,0,'-0430'),(1287,2,-14400,0,'AST'),(1288,0,-13840,0,'LMT'),(1288,1,-13840,0,'AMT'),(1288,2,-14400,0,'-04'),(1288,3,-10800,0,'-03'),(1288,4,-10800,1,'-03'),(1288,5,-14400,0,'-04'),(1289,0,-21988,0,'LMT'),(1289,1,-18000,1,'CDT'),(1289,2,-21600,0,'CST'),(1289,3,-18000,1,'CWT'),(1289,4,-18000,1,'CPT'),(1289,5,-18000,0,'EST'),(1290,0,-42398,0,'LMT'),(1290,1,-39600,0,'NST'),(1290,2,-36000,1,'NWT'),(1290,3,-36000,1,'NPT'),(1290,4,-39600,0,'BST'),(1290,5,-36000,1,'BDT'),(1290,6,-36000,0,'AHST'),(1290,7,-32400,1,'HDT'),(1290,8,-36000,0,'HST'),(1291,0,-9244,0,'LMT'),(1291,1,-7200,1,'-02'),(1291,2,-10800,0,'-03'),(1292,0,-25260,0,'LMT'),(1292,1,-25200,0,'MST'),(1292,2,-21600,0,'CST'),(1292,3,-28800,0,'PST'),(1292,4,-21600,1,'MDT'),(1292,5,-18000,1,'CDT'),(1292,6,-21600,0,'CST'),(1293,0,-14309,0,'LMT'),(1293,1,-14309,0,'BMT'),(1293,2,-10800,1,'ADT'),(1293,3,-14400,0,'AST'),(1294,0,-11636,0,'LMT'),(1294,1,-7200,1,'-02'),(1294,2,-10800,0,'-03'),(1295,0,-21168,0,'LMT'),(1295,1,-19800,1,'-0530'),(1295,2,-21600,0,'CST'),(1295,3,-18000,1,'CDT'),(1296,0,-13708,0,'LMT'),(1296,1,-10800,1,'ADT'),(1296,2,-14400,0,'AST'),(1296,3,-10800,1,'AWT'),(1296,4,-10800,1,'APT'),(1297,0,-14560,0,'LMT'),(1297,1,-10800,1,'-03'),(1297,2,-14400,0,'-04'),(1298,0,-17776,0,'LMT'),(1298,1,-17776,0,'BMT'),(1298,2,-14400,1,'-04'),(1298,3,-18000,0,'-05'),(1299,0,-27889,0,'LMT'),(1299,1,-25200,1,'PDT'),(1299,2,-28800,0,'PST'),(1299,3,-21600,1,'MWT'),(1299,4,-21600,1,'MPT'),(1299,5,-25200,0,'MST'),(1299,6,-21600,1,'MDT'),(1300,0,-14028,0,'LMT'),(1300,1,-15408,0,'CMT'),(1300,2,-14400,0,'-04'),(1300,3,-10800,1,'-03'),(1300,4,-7200,1,'-02'),(1300,5,-10800,0,'-03'),(1301,0,0,0,'-00'),(1301,1,-21600,1,'MWT'),(1301,2,-21600,1,'MPT'),(1301,3,-25200,0,'MST'),(1301,4,-18000,1,'MDDT'),(1301,5,-21600,1,'MDT'),(1301,6,-18000,1,'CDT'),(1301,7,-21600,0,'CST'),(1301,8,-18000,0,'EST'),(1301,9,-21600,1,'MDT'),(1301,10,-25200,0,'MST'),(1302,0,-13108,0,'LMT'),(1302,1,-10800,1,'-03'),(1302,2,-14400,0,'-04'),(1303,0,-20824,0,'LMT'),(1303,1,-21600,0,'CST'),(1303,2,-14400,1,'EDT'),(1303,3,-18000,0,'EST'),(1303,4,-18000,1,'CDT'),(1304,0,-16064,0,'LMT'),(1304,1,-16060,0,'CMT'),(1304,2,-16200,0,'-0430'),(1304,3,-14400,0,'-04'),(1305,0,-15788,0,'LMT'),(1305,1,-15408,0,'CMT'),(1305,2,-14400,0,'-04'),(1305,3,-10800,1,'-03'),(1305,4,-7200,1,'-02'),(1305,5,-10800,0,'-03'),(1306,0,-12560,0,'LMT'),(1306,1,-14400,0,'-04'),(1306,2,-10800,0,'-03'),(1307,0,-19088,0,'LMT'),(1307,1,-19176,0,'CMT'),(1307,2,-18000,0,'EST'),(1308,0,-21036,0,'LMT'),(1308,1,-18000,1,'CDT'),(1308,2,-21600,0,'CST'),(1308,3,-18000,0,'EST'),(1308,4,-18000,1,'CWT'),(1308,5,-18000,1,'CPT'),(1308,6,-21600,0,'CST'),(1309,0,-25460,0,'LMT'),(1309,1,-25200,0,'MST'),(1309,2,-21600,0,'CST'),(1309,3,-18000,1,'CDT'),(1309,4,-21600,1,'MDT'),(1309,5,-25200,0,'MST'),(1310,0,-21988,0,'LMT'),(1310,1,-18000,1,'CDT'),(1310,2,-21600,0,'CST'),(1310,3,-18000,1,'CWT'),(1310,4,-18000,1,'CPT'),(1310,5,-18000,0,'EST'),(1311,0,-15408,0,'LMT'),(1311,1,-15408,0,'CMT'),(1311,2,-14400,0,'-04'),(1311,3,-10800,1,'-03'),(1311,4,-7200,1,'-02'),(1311,5,-10800,0,'-03'),(1312,0,-20173,0,'LMT'),(1312,1,-20173,0,'SJMT'),(1312,2,-18000,1,'CDT'),(1312,3,-21600,0,'CST'),(1313,0,-27964,0,'LMT'),(1313,1,-25200,0,'MST'),(1313,2,-28800,0,'PST'),(1313,3,-25200,0,'MST'),(1314,0,-13460,0,'LMT'),(1314,1,-10800,1,'-03'),(1314,2,-14400,0,'-04'),(1315,0,-16547,0,'LMT'),(1315,1,-16200,0,'-0430'),(1315,2,-14400,0,'AST'),(1316,0,-4480,0,'LMT'),(1316,1,-10800,0,'-03'),(1316,2,-10800,0,'-03'),(1316,3,-7200,1,'-02'),(1316,4,-7200,1,'-02'),(1316,5,0,0,'GMT'),(1317,0,-33460,0,'LMT'),(1317,1,-28800,1,'YDT'),(1317,2,-32400,0,'YST'),(1317,3,-28800,1,'YWT'),(1317,4,-28800,1,'YPT'),(1317,5,-25200,1,'YDDT'),(1317,6,-28800,0,'PST'),(1317,7,-25200,1,'PDT'),(1318,0,-28856,0,'LMT'),(1318,1,-25200,1,'PDT'),(1318,2,-28800,0,'PST'),(1318,3,-25200,1,'PWT'),(1318,4,-25200,1,'PPT'),(1318,5,-25200,0,'MST'),(1319,0,-25196,0,'LMT'),(1319,1,-21600,1,'MDT'),(1319,2,-25200,0,'MST'),(1319,3,-21600,1,'MWT'),(1319,4,-21600,1,'MPT'),(1320,0,-19931,0,'LMT'),(1320,1,-21600,0,'CST'),(1320,2,-18000,0,'EST'),(1320,3,-14400,1,'EWT'),(1320,4,-14400,1,'EPT'),(1320,5,-14400,1,'EDT'),(1321,0,-14764,0,'LMT'),(1321,1,-14400,0,'AST'),(1322,0,-27232,0,'LMT'),(1322,1,-21600,1,'MDT'),(1322,2,-25200,0,'MST'),(1322,3,-21600,1,'MWT'),(1322,4,-21600,1,'MPT'),(1323,0,-16768,0,'LMT'),(1323,1,-14400,1,'-04'),(1323,2,-18000,0,'-05'),(1323,3,-14400,0,'-04'),(1323,4,-18000,0,'-05'),(1324,0,-21408,0,'LMT'),(1324,1,-18000,1,'CDT'),(1324,2,-21600,0,'CST'),(1325,0,-28084,0,'LMT'),(1325,1,-25200,0,'MST'),(1325,2,-28800,0,'PST'),(1325,3,-25200,1,'PDT'),(1325,4,-25200,1,'PWT'),(1325,5,-25200,1,'PPT'),(1326,0,-29447,0,'LMT'),(1326,1,-25200,1,'PDT'),(1326,2,-28800,0,'PST'),(1326,3,-25200,1,'PWT'),(1326,4,-25200,1,'PPT'),(1326,5,-25200,0,'MST'),(1327,0,-20678,0,'LMT'),(1327,1,-18000,1,'CDT'),(1327,2,-21600,0,'CST'),(1327,3,-18000,1,'CWT'),(1327,4,-18000,1,'CPT'),(1327,5,-18000,0,'EST'),(1327,6,-14400,1,'EDT'),(1328,0,-9240,0,'LMT'),(1328,1,-7200,1,'-02'),(1328,2,-10800,0,'-03'),(1329,0,-14388,0,'LMT'),(1329,1,-10800,1,'ADT'),(1329,2,-14400,0,'AST'),(1329,3,-10800,1,'AWT'),(1329,4,-10800,1,'APT'),(1330,0,-12416,0,'LMT'),(1330,1,-10800,0,'-03'),(1330,2,-10800,0,'-03'),(1330,3,-7200,1,'-02'),(1330,4,-7200,1,'-02'),(1331,0,-14500,0,'LMT'),(1331,1,-12652,0,'NST'),(1331,2,-9052,1,'NDT'),(1331,3,-12600,0,'NST'),(1331,4,-9000,1,'NDT'),(1331,5,-9000,1,'NPT'),(1331,6,-9000,1,'NWT'),(1331,7,-10800,1,'ADT'),(1331,8,-14400,0,'AST'),(1331,9,-7200,1,'ADDT'),(1331,10,-10800,1,'ADT'),(1332,0,-17072,0,'LMT'),(1332,1,-18430,0,'KMT'),(1332,2,-18000,0,'EST'),(1332,3,-14400,1,'EDT'),(1332,4,-14400,0,'AST'),(1332,5,-18000,0,'EST'),(1333,0,-14764,0,'LMT'),(1333,1,-14400,0,'AST'),(1334,0,-14764,0,'LMT'),(1334,1,-14400,0,'AST'),(1335,0,-21724,0,'LMT'),(1335,1,-18000,1,'CDT'),(1335,2,-21600,0,'CST'),(1336,0,-19160,0,'LMT'),(1336,1,-18840,0,'QMT'),(1336,2,-14400,1,'-04'),(1336,3,-18000,0,'-05'),(1337,0,-13960,0,'LMT'),(1337,1,-13500,0,'-0345'),(1337,2,-10800,0,'-03'),(1337,3,-14400,0,'-04'),(1338,0,-15264,0,'LMT'),(1338,1,-10800,1,'ADT'),(1338,2,-14400,0,'AST'),(1338,3,-10800,1,'AWT'),(1338,4,-10800,1,'APT'),(1339,0,-19768,0,'LMT'),(1339,1,-19776,0,'HMT'),(1339,2,-14400,1,'CDT'),(1339,3,-18000,0,'CST'),(1339,4,-18000,0,'CST'),(1339,5,-14400,1,'CDT'),(1340,0,-26632,0,'LMT'),(1340,1,-25200,0,'MST'),(1340,2,-21600,0,'CST'),(1340,3,-28800,0,'PST'),(1340,4,-21600,1,'MDT'),(1340,5,-25200,0,'MST'),(1341,0,-20678,0,'LMT'),(1341,1,-18000,1,'CDT'),(1341,2,-21600,0,'CST'),(1341,3,-18000,1,'CWT'),(1341,4,-18000,1,'CPT'),(1341,5,-18000,0,'EST'),(1341,6,-14400,1,'EDT'),(1342,0,-20790,0,'LMT'),(1342,1,-18000,1,'CDT'),(1342,2,-21600,0,'CST'),(1342,3,-18000,1,'CWT'),(1342,4,-18000,1,'CPT'),(1342,5,-18000,0,'EST'),(1342,6,-21600,0,'CST'),(1343,0,-20723,0,'LMT'),(1343,1,-18000,1,'CDT'),(1343,2,-21600,0,'CST'),(1343,3,-18000,1,'CWT'),(1343,4,-18000,1,'CPT'),(1343,5,-18000,0,'EST'),(1343,6,-14400,1,'EDT'),(1344,0,-20947,0,'LMT'),(1344,1,-18000,1,'CDT'),(1344,2,-21600,0,'CST'),(1344,3,-18000,1,'CWT'),(1344,4,-18000,1,'CPT'),(1344,5,-18000,0,'EST'),(1344,6,-14400,1,'EDT'),(1345,0,-20823,0,'LMT'),(1345,1,-18000,1,'CDT'),(1345,2,-21600,0,'CST'),(1345,3,-18000,1,'CWT'),(1345,4,-18000,1,'CPT'),(1345,5,-18000,0,'EST'),(1345,6,-14400,1,'EDT'),(1345,7,-18000,1,'CDT'),(1345,8,-21600,0,'CST'),(1346,0,-20416,0,'LMT'),(1346,1,-18000,1,'CDT'),(1346,2,-21600,0,'CST'),(1346,3,-18000,1,'CWT'),(1346,4,-18000,1,'CPT'),(1346,5,-18000,0,'EST'),(1346,6,-14400,1,'EDT'),(1347,0,-21007,0,'LMT'),(1347,1,-18000,1,'CDT'),(1347,2,-21600,0,'CST'),(1347,3,-18000,1,'CWT'),(1347,4,-18000,1,'CPT'),(1347,5,-18000,0,'EST'),(1347,6,-14400,1,'EDT'),(1348,0,-20785,0,'LMT'),(1348,1,-18000,1,'CDT'),(1348,2,-21600,0,'CST'),(1348,3,-18000,1,'CWT'),(1348,4,-18000,1,'CPT'),(1348,5,-18000,0,'EST'),(1348,6,-14400,1,'EDT'),(1349,0,-20678,0,'LMT'),(1349,1,-18000,1,'CDT'),(1349,2,-21600,0,'CST'),(1349,3,-18000,1,'CWT'),(1349,4,-18000,1,'CPT'),(1349,5,-18000,0,'EST'),(1349,6,-14400,1,'EDT'),(1350,0,0,0,'-00'),(1350,1,-21600,1,'PDDT'),(1350,2,-28800,0,'PST'),(1350,3,-25200,0,'MST'),(1350,4,-21600,1,'MDT'),(1351,0,0,0,'-00'),(1351,1,-14400,1,'EPT'),(1351,2,-18000,0,'EST'),(1351,3,-10800,1,'EDDT'),(1351,4,-14400,1,'EDT'),(1351,5,-14400,1,'EWT'),(1351,6,-21600,0,'CST'),(1351,7,-18000,1,'CDT'),(1351,8,-14400,1,'EDT'),(1351,9,-18000,0,'EST'),(1352,0,-18430,0,'LMT'),(1352,1,-18430,0,'KMT'),(1352,2,-18000,0,'EST'),(1352,3,-14400,1,'EDT'),(1353,0,-15672,0,'LMT'),(1353,1,-15408,0,'CMT'),(1353,2,-14400,0,'-04'),(1353,3,-10800,1,'-03'),(1353,4,-7200,1,'-02'),(1353,5,-10800,0,'-03'),(1354,0,-32261,0,'LMT'),(1354,1,-28800,0,'PST'),(1354,2,-25200,1,'PWT'),(1354,3,-25200,1,'PPT'),(1354,4,-25200,1,'PDT'),(1354,5,-28800,1,'YDT'),(1354,6,-32400,0,'YST'),(1354,7,-28800,1,'AKDT'),(1354,8,-32400,0,'AKST'),(1355,0,-20582,0,'LMT'),(1355,1,-18000,1,'CDT'),(1355,2,-21600,0,'CST'),(1355,3,-18000,1,'CWT'),(1355,4,-18000,1,'CPT'),(1355,5,-18000,0,'EST'),(1355,6,-14400,1,'EDT'),(1356,0,-20364,0,'LMT'),(1356,1,-18000,1,'CDT'),(1356,2,-21600,0,'CST'),(1356,3,-18000,1,'CWT'),(1356,4,-18000,1,'CPT'),(1356,5,-14400,1,'EDT'),(1356,6,-18000,0,'EST'),(1357,0,-20790,0,'LMT'),(1357,1,-18000,1,'CDT'),(1357,2,-21600,0,'CST'),(1357,3,-18000,1,'CWT'),(1357,4,-18000,1,'CPT'),(1357,5,-18000,0,'EST'),(1357,6,-21600,0,'CST'),(1358,0,-16547,0,'LMT'),(1358,1,-16200,0,'-0430'),(1358,2,-14400,0,'AST'),(1359,0,-16356,0,'LMT'),(1359,1,-16356,0,'CMT'),(1359,2,-12756,1,'BST'),(1359,3,-14400,0,'-04'),(1360,0,-18492,0,'LMT'),(1360,1,-18516,0,'LMT'),(1360,2,-14400,1,'-04'),(1360,3,-18000,0,'-05'),(1361,0,-28378,0,'LMT'),(1361,1,-25200,1,'PDT'),(1361,2,-28800,0,'PST'),(1361,3,-25200,1,'PWT'),(1361,4,-25200,1,'PPT'),(1362,0,-20582,0,'LMT'),(1362,1,-18000,1,'CDT'),(1362,2,-21600,0,'CST'),(1362,3,-18000,1,'CWT'),(1362,4,-18000,1,'CPT'),(1362,5,-18000,0,'EST'),(1362,6,-14400,1,'EDT'),(1363,0,-16547,0,'LMT'),(1363,1,-16200,0,'-0430'),(1363,2,-14400,0,'AST'),(1364,0,-8572,0,'LMT'),(1364,1,-7200,1,'-02'),(1364,2,-10800,0,'-03'),(1365,0,-20708,0,'LMT'),(1365,1,-20712,0,'MMT'),(1365,2,-21600,0,'CST'),(1365,3,-18000,0,'EST'),(1365,4,-18000,1,'CDT'),(1365,5,-21600,0,'CST'),(1366,0,-14404,0,'LMT'),(1366,1,-10800,1,'-03'),(1366,2,-14400,0,'-04'),(1367,0,-14764,0,'LMT'),(1367,1,-14400,0,'AST'),(1368,0,-14660,0,'LMT'),(1368,1,-14660,0,'FFMT'),(1368,2,-14400,0,'AST'),(1368,3,-10800,1,'ADT'),(1369,0,-24000,0,'LMT'),(1369,1,-21600,0,'CST'),(1369,2,-18000,1,'CDT'),(1370,0,-25540,0,'LMT'),(1370,1,-25200,0,'MST'),(1370,2,-21600,0,'CST'),(1370,3,-28800,0,'PST'),(1370,4,-21600,1,'MDT'),(1370,5,-25200,0,'MST'),(1371,0,-16516,0,'LMT'),(1371,1,-15408,0,'CMT'),(1371,2,-14400,0,'-04'),(1371,3,-10800,1,'-03'),(1371,4,-7200,1,'-02'),(1371,5,-10800,0,'-03'),(1372,0,-21027,0,'LMT'),(1372,1,-18000,1,'CDT'),(1372,2,-21600,0,'CST'),(1372,3,-18000,1,'CWT'),(1372,4,-18000,1,'CPT'),(1372,5,-18000,0,'EST'),(1372,6,-21600,0,'CST'),(1373,0,-21508,0,'LMT'),(1373,1,-21600,0,'CST'),(1373,2,-18000,0,'EST'),(1373,3,-18000,1,'CDT'),(1373,4,-21600,0,'CST'),(1374,0,-31578,0,'LMT'),(1374,1,-28800,0,'PST'),(1374,2,-25200,1,'PWT'),(1374,3,-25200,1,'PPT'),(1374,4,-25200,1,'PDT'),(1374,5,-32400,0,'AKST'),(1374,6,-28800,1,'AKDT'),(1375,0,-23796,0,'LMT'),(1375,1,-25200,0,'MST'),(1375,2,-21600,0,'CST'),(1375,3,-18000,1,'CDT'),(1375,4,-18000,1,'CWT'),(1376,0,-13480,0,'LMT'),(1376,1,-14400,0,'AST'),(1376,2,-10800,0,'-03'),(1376,3,-7200,1,'-02'),(1377,0,-15548,0,'LMT'),(1377,1,-18000,0,'EST'),(1377,2,-10800,1,'ADT'),(1377,3,-14400,0,'AST'),(1377,4,-10800,1,'AWT'),(1377,5,-10800,1,'APT'),(1378,0,-24076,0,'LMT'),(1378,1,-21600,0,'CST'),(1378,2,-18000,1,'CDT'),(1379,0,-13491,0,'LMT'),(1379,1,-13491,0,'MMT'),(1379,2,-14400,0,'-04'),(1379,3,-12600,0,'-0330'),(1379,4,-10800,1,'-03'),(1379,5,-10800,0,'-03'),(1379,6,-9000,1,'-0230'),(1379,7,-7200,1,'-02'),(1379,8,-5400,1,'-0130'),(1379,9,-7200,1,'-02'),(1380,0,-19052,0,'LMT'),(1380,1,-14400,1,'EDT'),(1380,2,-18000,0,'EST'),(1380,3,-14400,1,'EWT'),(1380,4,-14400,1,'EPT'),(1381,0,-14764,0,'LMT'),(1381,1,-14400,0,'AST'),(1382,0,-18570,0,'LMT'),(1382,1,-14400,1,'EDT'),(1382,2,-18000,0,'EST'),(1383,0,-17762,0,'LMT'),(1383,1,-14400,1,'EDT'),(1383,2,-18000,0,'EST'),(1383,3,-14400,1,'EWT'),(1383,4,-14400,1,'EPT'),(1384,0,-21184,0,'LMT'),(1384,1,-14400,1,'EDT'),(1384,2,-18000,0,'EST'),(1384,3,-14400,1,'EWT'),(1384,4,-14400,1,'EPT'),(1385,0,-39698,0,'LMT'),(1385,1,-39600,0,'NST'),(1385,2,-36000,1,'NWT'),(1385,3,-36000,1,'NPT'),(1385,4,-39600,0,'BST'),(1385,5,-36000,1,'BDT'),(1385,6,-32400,0,'YST'),(1385,7,-28800,1,'AKDT'),(1385,8,-32400,0,'AKST'),(1386,0,-7780,0,'LMT'),(1386,1,-3600,1,'-01'),(1386,2,-7200,0,'-02'),(1387,0,-24427,0,'LMT'),(1387,1,-21600,1,'MDT'),(1387,2,-25200,0,'MST'),(1387,3,-21600,1,'MWT'),(1387,4,-21600,1,'MPT'),(1387,5,-18000,1,'CDT'),(1387,6,-21600,0,'CST'),(1388,0,-24312,0,'LMT'),(1388,1,-21600,1,'MDT'),(1388,2,-25200,0,'MST'),(1388,3,-21600,1,'MWT'),(1388,4,-21600,1,'MPT'),(1388,5,-18000,1,'CDT'),(1388,6,-21600,0,'CST'),(1389,0,-24339,0,'LMT'),(1389,1,-21600,1,'MDT'),(1389,2,-25200,0,'MST'),(1389,3,-21600,1,'MWT'),(1389,4,-21600,1,'MPT'),(1389,5,-18000,1,'CDT'),(1389,6,-21600,0,'CST'),(1390,0,-25060,0,'LMT'),(1390,1,-25200,0,'MST'),(1390,2,-21600,0,'CST'),(1390,3,-18000,1,'CDT'),(1390,4,-21600,1,'MDT'),(1390,5,-25200,0,'MST'),(1391,0,-19088,0,'LMT'),(1391,1,-19176,0,'CMT'),(1391,2,-18000,0,'EST'),(1392,0,0,0,'-00'),(1392,1,-10800,1,'AWT'),(1392,2,-10800,1,'APT'),(1392,3,-14400,0,'AST'),(1392,4,-7200,1,'ADDT'),(1392,5,-10800,1,'ADT'),(1392,6,-14400,1,'EDT'),(1392,7,-18000,0,'EST'),(1392,8,-21600,0,'CST'),(1392,9,-18000,1,'CDT'),(1392,10,-14400,1,'EDT'),(1392,11,-18000,0,'EST'),(1393,0,-13240,0,'LMT'),(1393,1,-13252,0,'PMT'),(1393,2,-13236,0,'PMT'),(1393,3,-12600,0,'-0330'),(1393,4,-10800,0,'-03'),(1394,0,-26898,0,'LMT'),(1394,1,-21600,1,'MDT'),(1394,2,-25200,0,'MST'),(1394,3,-21600,1,'MWT'),(1395,0,-17360,0,'LMT'),(1395,1,-17340,0,'PPMT'),(1395,2,-14400,1,'EDT'),(1395,3,-18000,0,'EST'),(1395,4,-14400,1,'EDT'),(1395,5,-18000,0,'EST'),(1396,0,-14764,0,'LMT'),(1396,1,-14400,0,'AST'),(1397,0,-16272,0,'LMT'),(1397,1,-14400,1,'-04'),(1397,2,-18000,0,'-05'),(1397,3,-14400,0,'-04'),(1397,4,-18000,0,'-05'),(1398,0,-15336,0,'LMT'),(1398,1,-10800,1,'-03'),(1398,2,-14400,0,'-04'),(1399,0,-15865,0,'LMT'),(1399,1,-14400,0,'AST'),(1399,2,-10800,1,'APT'),(1399,3,-10800,1,'AWT'),(1400,0,-17020,0,'LMT'),(1400,1,-16966,0,'SMT'),(1400,2,-18000,0,'-05'),(1400,3,-14400,0,'-04'),(1400,4,-14400,1,'-04'),(1400,5,-10800,1,'-03'),(1400,6,-14400,0,'-04'),(1400,7,-10800,0,'-03'),(1401,0,-22696,0,'LMT'),(1401,1,-18000,1,'CDT'),(1401,2,-21600,0,'CST'),(1401,3,-18000,1,'CWT'),(1401,4,-18000,1,'CPT'),(1402,0,0,0,'-00'),(1402,1,-14400,1,'CDDT'),(1402,2,-21600,0,'CST'),(1402,3,-18000,1,'CDT'),(1402,4,-18000,0,'EST'),(1402,5,-21600,0,'CST'),(1403,0,-8376,0,'LMT'),(1403,1,-7200,1,'-02'),(1403,2,-10800,0,'-03'),(1404,0,-25116,0,'LMT'),(1404,1,-21600,1,'MDT'),(1404,2,-25200,0,'MST'),(1404,3,-21600,1,'MWT'),(1404,4,-21600,1,'MPT'),(1404,5,-21600,0,'CST'),(1405,0,0,0,'-00'),(1405,1,-14400,1,'CDDT'),(1405,2,-21600,0,'CST'),(1405,3,-18000,1,'CDT'),(1405,4,-18000,0,'EST'),(1405,5,-21600,0,'CST'),(1406,0,-16272,0,'LMT'),(1406,1,-14400,1,'-04'),(1406,2,-18000,0,'-05'),(1406,3,-14400,0,'-04'),(1406,4,-18000,0,'-05'),(1407,0,-15408,0,'LMT'),(1407,1,-15408,0,'CMT'),(1407,2,-14400,0,'-04'),(1407,3,-10800,1,'-03'),(1407,4,-7200,1,'-02'),(1407,5,-10800,0,'-03'),(1408,0,-28084,0,'LMT'),(1408,1,-25200,0,'MST'),(1408,2,-28800,0,'PST'),(1408,3,-25200,1,'PDT'),(1408,4,-25200,1,'PWT'),(1408,5,-25200,1,'PPT'),(1409,0,-13128,0,'LMT'),(1409,1,-10800,1,'-03'),(1409,2,-14400,0,'-04'),(1409,3,-10800,0,'-03'),(1410,0,-16966,0,'LMT'),(1410,1,-16966,0,'SMT'),(1410,2,-18000,0,'-05'),(1410,3,-14400,0,'-04'),(1410,4,-14400,1,'-04'),(1410,5,-10800,1,'-03'),(1410,6,-10800,1,'-03'),(1410,7,-14400,0,'-04'),(1411,0,-16776,0,'LMT'),(1411,1,-16800,0,'SDMT'),(1411,2,-14400,1,'EDT'),(1411,3,-18000,0,'EST'),(1411,4,-16200,1,'-0430'),(1411,5,-14400,0,'AST'),(1412,0,-11188,0,'LMT'),(1412,1,-7200,1,'-02'),(1412,2,-10800,0,'-03'),(1413,0,-5272,0,'LMT'),(1413,1,-7200,0,'-02'),(1413,2,-3600,1,'-01'),(1413,3,-7200,0,'-02'),(1413,4,-3600,0,'-01'),(1413,5,0,1,'+00'),(1413,6,0,1,'+00'),(1414,0,-25196,0,'LMT'),(1414,1,-21600,1,'MDT'),(1414,2,-25200,0,'MST'),(1414,3,-21600,1,'MWT'),(1414,4,-21600,1,'MPT'),(1415,0,-32473,0,'LMT'),(1415,1,-28800,0,'PST'),(1415,2,-25200,1,'PWT'),(1415,3,-25200,1,'PPT'),(1415,4,-25200,1,'PDT'),(1415,5,-32400,0,'YST'),(1415,6,-28800,1,'AKDT'),(1415,7,-32400,0,'AKST'),(1416,0,-14764,0,'LMT'),(1416,1,-14400,0,'AST'),(1417,0,-12652,0,'LMT'),(1417,1,-9052,1,'NDT'),(1417,2,-12652,0,'NST'),(1417,3,-9000,1,'NDT'),(1417,4,-12600,0,'NST'),(1417,5,-9000,1,'NPT'),(1417,6,-9000,1,'NWT'),(1417,7,-5400,1,'NDDT'),(1417,8,-9000,1,'NDT'),(1418,0,-14764,0,'LMT'),(1418,1,-14400,0,'AST'),(1419,0,-14764,0,'LMT'),(1419,1,-14400,0,'AST'),(1420,0,-14764,0,'LMT'),(1420,1,-14400,0,'AST'),(1421,0,-14764,0,'LMT'),(1421,1,-14400,0,'AST'),(1422,0,-25880,0,'LMT'),(1422,1,-21600,1,'MDT'),(1422,2,-25200,0,'MST'),(1422,3,-21600,1,'MWT'),(1422,4,-21600,1,'MPT'),(1422,5,-21600,0,'CST'),(1423,0,-20932,0,'LMT'),(1423,1,-18000,1,'CDT'),(1423,2,-21600,0,'CST'),(1424,0,-16508,0,'LMT'),(1424,1,-10800,1,'ADT'),(1424,2,-14400,0,'AST'),(1425,0,-21420,0,'LMT'),(1425,1,-21600,0,'CST'),(1425,2,-18000,0,'EST'),(1425,3,-14400,1,'EWT'),(1425,4,-14400,1,'EPT'),(1425,5,-14400,1,'EDT'),(1426,0,-28084,0,'LMT'),(1426,1,-25200,0,'MST'),(1426,2,-28800,0,'PST'),(1426,3,-25200,1,'PDT'),(1426,4,-25200,1,'PWT'),(1426,5,-25200,1,'PPT'),(1427,0,-19052,0,'LMT'),(1427,1,-14400,1,'EDT'),(1427,2,-18000,0,'EST'),(1427,3,-14400,1,'EWT'),(1427,4,-14400,1,'EPT'),(1428,0,-14764,0,'LMT'),(1428,1,-14400,0,'AST'),(1429,0,-29548,0,'LMT'),(1429,1,-25200,1,'PDT'),(1429,2,-28800,0,'PST'),(1429,3,-25200,1,'PWT'),(1429,4,-25200,1,'PPT'),(1430,0,-14764,0,'LMT'),(1430,1,-14400,0,'AST'),(1431,0,-32412,0,'LMT'),(1431,1,-28800,1,'YDT'),(1431,2,-32400,0,'YST'),(1431,3,-28800,1,'YWT'),(1431,4,-28800,1,'YPT'),(1431,5,-25200,1,'YDDT'),(1431,6,-28800,0,'PST'),(1431,7,-25200,1,'PDT'),(1432,0,-23316,0,'LMT'),(1432,1,-18000,1,'CDT'),(1432,2,-21600,0,'CST'),(1432,3,-18000,1,'CWT'),(1432,4,-18000,1,'CPT'),(1432,5,-18000,1,'CDT'),(1432,6,-21600,0,'CST'),(1433,0,-33535,0,'LMT'),(1433,1,-32400,0,'YST'),(1433,2,-28800,1,'YWT'),(1433,3,-28800,1,'YPT'),(1433,4,-28800,1,'YDT'),(1433,5,-28800,1,'AKDT'),(1433,6,-32400,0,'AKST'),(1434,0,0,0,'-00'),(1434,1,-21600,1,'MWT'),(1434,2,-21600,1,'MPT'),(1434,3,-25200,0,'MST'),(1434,4,-18000,1,'MDDT'),(1434,5,-21600,1,'MDT'),(1435,0,0,0,'-00'),(1435,1,28800,0,'+08'),(1435,2,39600,0,'+11'),(1435,3,28800,0,'+08'),(1436,0,0,0,'-00'),(1436,1,25200,0,'+07'),(1436,2,18000,0,'+05'),(1436,3,25200,0,'+07'),(1437,0,0,0,'-00'),(1437,1,36000,0,'+10'),(1438,0,0,0,'-00'),(1438,1,36000,0,'AEST'),(1438,2,39600,1,'AEDT'),(1438,3,0,0,'-00'),(1438,4,39600,1,'AEDT'),(1438,5,36000,0,'AEST'),(1438,6,39600,0,'+11'),(1439,0,0,0,'-00'),(1439,1,21600,0,'+06'),(1439,2,18000,0,'+05'),(1440,0,41944,0,'LMT'),(1440,1,45000,1,'NZST'),(1440,2,41400,0,'NZMT'),(1440,3,43200,1,'NZST'),(1440,4,46800,1,'NZDT'),(1440,5,43200,0,'NZST'),(1440,6,43200,0,'NZST'),(1441,0,0,0,'-00'),(1441,1,-14400,0,'-04'),(1441,2,-10800,1,'-03'),(1441,3,-7200,1,'-02'),(1441,4,-10800,0,'-03'),(1441,5,-10800,1,'-03'),(1441,6,-14400,0,'-04'),(1441,7,-10800,0,'-03'),(1442,0,0,0,'-00'),(1442,1,-10800,0,'-03'),(1443,0,41944,0,'LMT'),(1443,1,45000,1,'NZST'),(1443,2,41400,0,'NZMT'),(1443,3,43200,1,'NZST'),(1443,4,46800,1,'NZDT'),(1443,5,43200,0,'NZST'),(1443,6,43200,0,'NZST'),(1444,0,0,0,'-00'),(1444,1,10800,0,'+03'),(1445,0,0,0,'-00'),(1445,1,7200,1,'+02'),(1445,2,0,0,'+00'),(1445,3,0,0,'+00'),(1446,0,0,0,'-00'),(1446,1,21600,0,'+06'),(1447,0,2580,0,'LMT'),(1447,1,7200,1,'CEST'),(1447,2,3600,0,'CET'),(1447,3,3600,0,'CET'),(1447,4,7200,1,'CEST'),(1447,5,7200,1,'CEST'),(1447,6,3600,0,'CET'),(1448,0,11212,0,'LMT'),(1448,1,10800,0,'+03'),(1449,0,18468,0,'LMT'),(1449,1,18000,0,'+05'),(1449,2,25200,1,'+07'),(1449,3,21600,0,'+06'),(1449,4,21600,0,'+06'),(1449,5,25200,1,'+07'),(1449,6,21600,1,'+06'),(1449,7,18000,0,'+05'),(1449,8,25200,1,'+07'),(1449,9,21600,0,'+06'),(1450,0,8624,0,'LMT'),(1450,1,10800,1,'EEST'),(1450,2,7200,0,'EET'),(1450,3,7200,0,'EET'),(1450,4,10800,1,'EEST'),(1451,0,42596,0,'LMT'),(1451,1,43200,0,'+12'),(1451,2,50400,1,'+14'),(1451,3,46800,0,'+13'),(1451,4,46800,1,'+13'),(1451,5,43200,0,'+12'),(1451,6,46800,1,'+13'),(1451,7,43200,1,'+12'),(1451,8,39600,0,'+11'),(1451,9,43200,0,'+12'),(1452,0,12064,0,'LMT'),(1452,1,14400,0,'+04'),(1452,2,18000,0,'+05'),(1452,3,21600,0,'+06'),(1452,4,21600,1,'+06'),(1452,5,18000,0,'+05'),(1452,6,21600,1,'+06'),(1452,7,18000,1,'+05'),(1452,8,14400,0,'+04'),(1452,9,18000,0,'+05'),(1453,0,13720,0,'LMT'),(1453,1,14400,0,'+04'),(1453,2,18000,0,'+05'),(1453,3,21600,1,'+06'),(1453,4,21600,0,'+06'),(1453,5,18000,0,'+05'),(1453,6,21600,1,'+06'),(1453,7,18000,1,'+05'),(1453,8,14400,0,'+04'),(1453,9,21600,1,'+06'),(1453,10,18000,0,'+05'),(1454,0,14012,0,'LMT'),(1454,1,14400,0,'+04'),(1454,2,21600,1,'+06'),(1454,3,18000,0,'+05'),(1454,4,18000,0,'+05'),(1454,5,21600,1,'+06'),(1454,6,18000,1,'+05'),(1454,7,14400,0,'+04'),(1454,8,18000,0,'+05'),(1455,0,14012,0,'LMT'),(1455,1,14400,0,'+04'),(1455,2,21600,1,'+06'),(1455,3,18000,0,'+05'),(1455,4,18000,0,'+05'),(1455,5,21600,1,'+06'),(1455,6,18000,1,'+05'),(1455,7,14400,0,'+04'),(1455,8,18000,0,'+05'),(1456,0,12464,0,'LMT'),(1456,1,10800,0,'+03'),(1456,2,18000,0,'+05'),(1456,3,21600,0,'+06'),(1456,4,21600,1,'+06'),(1456,5,18000,0,'+05'),(1456,6,21600,1,'+06'),(1456,7,18000,1,'+05'),(1456,8,14400,0,'+04'),(1456,9,18000,0,'+05'),(1457,0,10660,0,'LMT'),(1457,1,10656,0,'BMT'),(1457,2,10800,0,'+03'),(1457,3,14400,1,'+04'),(1457,4,10800,0,'+03'),(1457,5,14400,1,'+04'),(1458,0,12368,0,'LMT'),(1458,1,14400,0,'+04'),(1458,2,10800,0,'+03'),(1459,0,11964,0,'LMT'),(1459,1,10800,0,'+03'),(1459,2,18000,1,'+05'),(1459,3,14400,0,'+04'),(1459,4,14400,0,'+04'),(1459,5,18000,1,'+05'),(1459,6,14400,1,'+04'),(1459,7,10800,0,'+03'),(1459,8,18000,1,'+05'),(1459,9,14400,0,'+04'),(1460,0,24124,0,'LMT'),(1460,1,24124,0,'BMT'),(1460,2,25200,0,'+07'),(1461,0,20100,0,'LMT'),(1461,1,21600,0,'+06'),(1461,2,28800,1,'+08'),(1461,3,25200,0,'+07'),(1461,4,25200,0,'+07'),(1461,5,28800,1,'+08'),(1461,6,25200,1,'+07'),(1461,7,21600,0,'+06'),(1461,8,25200,1,'+07'),(1461,9,25200,0,'+07'),(1462,0,8520,0,'LMT'),(1462,1,10800,1,'EEST'),(1462,2,7200,0,'EET'),(1463,0,17904,0,'LMT'),(1463,1,18000,0,'+05'),(1463,2,25200,1,'+07'),(1463,3,21600,0,'+06'),(1463,4,21600,0,'+06'),(1463,5,25200,1,'+07'),(1463,6,21600,1,'+06'),(1463,7,21600,1,'+06'),(1464,0,27580,0,'LMT'),(1464,1,27000,0,'+0730'),(1464,2,28800,0,'+08'),(1465,0,21200,0,'HMT'),(1465,1,19270,0,'MMT'),(1465,2,19800,0,'IST'),(1465,3,23400,1,'+0630'),(1466,0,27232,0,'LMT'),(1466,1,28800,0,'+08'),(1466,2,36000,1,'+10'),(1466,3,32400,0,'+09'),(1466,4,32400,0,'+09'),(1466,5,36000,1,'+10'),(1466,6,32400,1,'+09'),(1466,7,28800,0,'+08'),(1466,8,36000,0,'+10'),(1466,9,36000,1,'+10'),(1466,10,32400,0,'+09'),(1467,0,27480,0,'LMT'),(1467,1,25200,0,'+07'),(1467,2,28800,0,'+08'),(1467,3,32400,0,'+09'),(1467,4,36000,1,'+10'),(1467,5,32400,1,'+09'),(1467,6,28800,0,'+08'),(1468,0,29143,0,'LMT'),(1468,1,32400,1,'CDT'),(1468,2,28800,0,'CST'),(1469,0,29143,0,'LMT'),(1469,1,32400,1,'CDT'),(1469,2,28800,0,'CST'),(1470,0,19164,0,'LMT'),(1470,1,19172,0,'MMT'),(1470,2,19800,0,'+0530'),(1470,3,21600,1,'+06'),(1470,4,23400,1,'+0630'),(1470,5,23400,0,'+0630'),(1470,6,21600,0,'+06'),(1470,7,19800,0,'+0530'),(1471,0,21700,0,'LMT'),(1471,1,21200,0,'HMT'),(1471,2,23400,0,'+0630'),(1471,3,19800,0,'+0530'),(1471,4,21600,0,'+06'),(1471,5,25200,1,'+07'),(1472,0,8712,0,'LMT'),(1472,1,10800,1,'EEST'),(1472,2,7200,0,'EET'),(1473,0,21700,0,'LMT'),(1473,1,21200,0,'HMT'),(1473,2,23400,0,'+0630'),(1473,3,19800,0,'+0530'),(1473,4,21600,0,'+06'),(1473,5,25200,1,'+07'),(1474,0,30140,0,'LMT'),(1474,1,28800,0,'+08'),(1474,2,32400,0,'+09'),(1475,0,13272,0,'LMT'),(1475,1,14400,0,'+04'),(1476,0,16512,0,'LMT'),(1476,1,18000,0,'+05'),(1476,2,25200,1,'+07'),(1476,3,21600,0,'+06'),(1476,4,21600,0,'+06'),(1476,5,25200,1,'+07'),(1476,6,21600,1,'+06'),(1476,7,18000,0,'+05'),(1477,0,8148,0,'LMT'),(1477,1,10800,1,'EEST'),(1477,2,7200,0,'EET'),(1477,3,7200,0,'EET'),(1477,4,10800,1,'EEST'),(1477,5,10800,0,'+03'),(1477,6,7200,0,'EET'),(1478,0,8272,0,'LMT'),(1478,1,10800,1,'EEST'),(1478,2,7200,0,'EET'),(1478,3,10800,1,'IDT'),(1478,4,7200,0,'IST'),(1478,5,7200,0,'EET'),(1479,0,29143,0,'LMT'),(1479,1,32400,1,'CDT'),(1479,2,28800,0,'CST'),(1480,0,8423,0,'LMT'),(1480,1,10800,1,'EEST'),(1480,2,7200,0,'EET'),(1480,3,10800,1,'IDT'),(1480,4,7200,0,'IST'),(1480,5,7200,0,'EET'),(1481,0,25600,0,'LMT'),(1481,1,25590,0,'PLMT'),(1481,2,25200,0,'+07'),(1481,3,28800,0,'+08'),(1481,4,32400,0,'+09'),(1481,5,25200,0,'+07'),(1482,0,27402,0,'LMT'),(1482,1,28800,0,'HKT'),(1482,2,32400,1,'HKST'),(1482,3,30600,0,'HKT'),(1482,4,32400,0,'JST'),(1482,5,28800,0,'HKT'),(1483,0,21996,0,'LMT'),(1483,1,21600,0,'+06'),(1483,2,28800,1,'+08'),(1483,3,25200,0,'+07'),(1484,0,25025,0,'LMT'),(1484,1,25025,0,'IMT'),(1484,2,25200,0,'+07'),(1484,3,32400,1,'+09'),(1484,4,28800,0,'+08'),(1484,5,28800,0,'+08'),(1484,6,32400,1,'+09'),(1484,7,28800,1,'+08'),(1484,8,25200,0,'+07'),(1484,9,32400,0,'+09'),(1484,10,32400,1,'+09'),(1484,11,28800,0,'+08'),(1485,0,6952,0,'LMT'),(1485,1,7016,0,'IMT'),(1485,2,10800,1,'EEST'),(1485,3,7200,0,'EET'),(1485,4,14400,1,'+04'),(1485,5,10800,0,'+03'),(1485,6,10800,1,'EEST'),(1485,7,7200,0,'EET'),(1485,8,10800,1,'EEST'),(1485,9,7200,0,'EET'),(1485,10,10800,0,'+03'),(1486,0,25632,0,'LMT'),(1486,1,25632,0,'BMT'),(1486,2,26400,0,'+0720'),(1486,3,27000,0,'+0730'),(1486,4,32400,0,'+09'),(1486,5,28800,0,'+08'),(1486,6,25200,0,'WIB'),(1487,0,33768,0,'LMT'),(1487,1,32400,0,'+09'),(1487,2,34200,0,'+0930'),(1487,3,32400,0,'WIT'),(1488,0,8454,0,'LMT'),(1488,1,8440,0,'JMT'),(1488,2,10800,1,'IDT'),(1488,3,7200,0,'IST'),(1488,4,14400,1,'IDDT'),(1488,5,10800,1,'IDT'),(1489,0,16608,0,'LMT'),(1489,1,14400,0,'+04'),(1489,2,16200,0,'+0430'),(1490,0,38076,0,'LMT'),(1490,1,39600,0,'+11'),(1490,2,46800,1,'+13'),(1490,3,43200,0,'+12'),(1490,4,43200,0,'+12'),(1490,5,46800,1,'+13'),(1490,6,43200,1,'+12'),(1490,7,39600,0,'+11'),(1490,8,43200,0,'+12'),(1491,0,16092,0,'LMT'),(1491,1,19800,0,'+0530'),(1491,2,23400,1,'+0630'),(1491,3,18000,0,'+05'),(1491,4,21600,1,'PKST'),(1491,5,18000,0,'PKT'),(1492,0,21020,0,'LMT'),(1492,1,21600,0,'+06'),(1493,0,20476,0,'LMT'),(1493,1,19800,0,'+0530'),(1493,2,20700,0,'+0545'),(1494,0,20476,0,'LMT'),(1494,1,19800,0,'+0530'),(1494,2,20700,0,'+0545'),(1495,0,32533,0,'LMT'),(1495,1,28800,0,'+08'),(1495,2,36000,1,'+10'),(1495,3,32400,0,'+09'),(1495,4,32400,0,'+09'),(1495,5,36000,1,'+10'),(1495,6,32400,1,'+09'),(1495,7,28800,0,'+08'),(1495,8,39600,1,'+11'),(1495,9,36000,0,'+10'),(1495,10,36000,0,'+10'),(1495,11,39600,0,'+11'),(1495,12,32400,0,'+09'),(1496,0,21200,0,'HMT'),(1496,1,19270,0,'MMT'),(1496,2,19800,0,'IST'),(1496,3,23400,1,'+0630'),(1497,0,22286,0,'LMT'),(1497,1,21600,0,'+06'),(1497,2,28800,1,'+08'),(1497,3,25200,0,'+07'),(1497,4,25200,0,'+07'),(1497,5,28800,1,'+08'),(1497,6,25200,1,'+07'),(1497,7,21600,0,'+06'),(1497,8,28800,0,'+08'),(1497,9,28800,1,'+08'),(1497,10,25200,0,'+07'),(1498,0,24406,0,'LMT'),(1498,1,24925,0,'SMT'),(1498,2,25200,0,'+07'),(1498,3,26400,1,'+0720'),(1498,4,26400,0,'+0720'),(1498,5,27000,0,'+0730'),(1498,6,32400,0,'+09'),(1498,7,28800,0,'+08'),(1499,0,26480,0,'LMT'),(1499,1,27000,0,'+0730'),(1499,2,30000,1,'+0820'),(1499,3,28800,0,'+08'),(1499,4,32400,0,'+09'),(1499,5,28800,0,'+08'),(1500,0,11212,0,'LMT'),(1500,1,10800,0,'+03'),(1501,0,27250,0,'LMT'),(1501,1,28800,0,'CST'),(1501,2,36000,1,'+10'),(1501,3,32400,0,'+09'),(1501,4,32400,1,'CDT'),(1501,5,28800,0,'CST'),(1501,6,32400,1,'CDT'),(1502,0,27250,0,'LMT'),(1502,1,28800,0,'CST'),(1502,2,36000,1,'+10'),(1502,3,32400,0,'+09'),(1502,4,32400,1,'CDT'),(1502,5,28800,0,'CST'),(1502,6,32400,1,'CDT'),(1503,0,36192,0,'LMT'),(1503,1,36000,0,'+10'),(1503,2,43200,1,'+12'),(1503,3,39600,0,'+11'),(1503,4,39600,0,'+11'),(1503,5,43200,1,'+12'),(1503,6,39600,1,'+11'),(1503,7,36000,0,'+10'),(1503,8,43200,0,'+12'),(1503,9,43200,1,'+12'),(1503,10,39600,0,'+11'),(1504,0,28656,0,'LMT'),(1504,1,28656,0,'MMT'),(1504,2,28800,0,'+08'),(1504,3,32400,0,'+09'),(1504,4,28800,0,'WITA'),(1505,0,29040,0,'LMT'),(1505,1,32400,1,'PDT'),(1505,2,28800,0,'PST'),(1505,3,32400,0,'JST'),(1505,4,28800,0,'PST'),(1506,0,13272,0,'LMT'),(1506,1,14400,0,'+04'),(1507,0,8008,0,'LMT'),(1507,1,10800,1,'EEST'),(1507,2,7200,0,'EET'),(1507,3,7200,0,'EET'),(1507,4,10800,1,'EEST'),(1508,0,20928,0,'LMT'),(1508,1,21600,0,'+06'),(1508,2,28800,1,'+08'),(1508,3,25200,0,'+07'),(1508,4,25200,0,'+07'),(1508,5,28800,1,'+08'),(1508,6,25200,1,'+07'),(1508,7,21600,0,'+06'),(1508,8,25200,0,'+07'),(1509,0,19900,0,'LMT'),(1509,1,21600,0,'+06'),(1509,2,28800,1,'+08'),(1509,3,25200,0,'+07'),(1509,4,25200,0,'+07'),(1509,5,28800,1,'+08'),(1509,6,25200,1,'+07'),(1509,7,21600,0,'+06'),(1509,8,25200,1,'+07'),(1509,9,25200,0,'+07'),(1510,0,17610,0,'LMT'),(1510,1,18000,0,'+05'),(1510,2,25200,1,'+07'),(1510,3,21600,0,'+06'),(1510,4,21600,0,'+06'),(1510,5,25200,1,'+07'),(1510,6,21600,1,'+06'),(1510,7,18000,0,'+05'),(1510,8,25200,0,'+07'),(1510,9,25200,1,'+07'),(1510,10,21600,0,'+06'),(1511,0,12324,0,'LMT'),(1511,1,10800,0,'+03'),(1511,2,18000,0,'+05'),(1511,3,21600,1,'+06'),(1511,4,21600,0,'+06'),(1511,5,18000,0,'+05'),(1511,6,21600,1,'+06'),(1511,7,18000,1,'+05'),(1511,8,14400,0,'+04'),(1511,9,18000,0,'+05'),(1512,0,24124,0,'LMT'),(1512,1,24124,0,'BMT'),(1512,2,25200,0,'+07'),(1513,0,26240,0,'LMT'),(1513,1,26240,0,'PMT'),(1513,2,27000,0,'+0730'),(1513,3,32400,0,'+09'),(1513,4,28800,0,'+08'),(1513,5,28800,0,'WITA'),(1513,6,25200,0,'WIB'),(1514,0,30180,0,'LMT'),(1514,1,30600,0,'KST'),(1514,2,32400,0,'JST'),(1514,3,32400,0,'KST'),(1515,0,12368,0,'LMT'),(1515,1,14400,0,'+04'),(1515,2,10800,0,'+03'),(1516,0,15268,0,'LMT'),(1516,1,14400,0,'+04'),(1516,2,18000,0,'+05'),(1516,3,21600,1,'+06'),(1516,4,21600,0,'+06'),(1516,5,18000,0,'+05'),(1516,6,21600,1,'+06'),(1516,7,18000,1,'+05'),(1516,8,14400,0,'+04'),(1516,9,21600,0,'+06'),(1516,10,21600,1,'+06'),(1517,0,15712,0,'LMT'),(1517,1,14400,0,'+04'),(1517,2,18000,0,'+05'),(1517,3,21600,1,'+06'),(1517,4,21600,0,'+06'),(1517,5,18000,0,'+05'),(1517,6,21600,1,'+06'),(1517,7,18000,1,'+05'),(1517,8,21600,0,'+06'),(1517,9,21600,1,'+06'),(1517,10,18000,0,'+05'),(1518,0,23087,0,'LMT'),(1518,1,23087,0,'RMT'),(1518,2,23400,0,'+0630'),(1518,3,32400,0,'+09'),(1518,4,23400,0,'+0630'),(1519,0,11212,0,'LMT'),(1519,1,10800,0,'+03'),(1520,0,25600,0,'LMT'),(1520,1,25590,0,'PLMT'),(1520,2,25200,0,'+07'),(1520,3,28800,0,'+08'),(1520,4,32400,0,'+09'),(1520,5,25200,0,'+07'),(1521,0,34248,0,'LMT'),(1521,1,32400,0,'+09'),(1521,2,43200,1,'+12'),(1521,3,39600,0,'+11'),(1521,4,39600,0,'+11'),(1521,5,43200,1,'+12'),(1521,6,39600,1,'+11'),(1521,7,36000,0,'+10'),(1521,8,39600,0,'+11'),(1522,0,16073,0,'LMT'),(1522,1,14400,0,'+04'),(1522,2,18000,0,'+05'),(1522,3,21600,1,'+06'),(1522,4,21600,0,'+06'),(1522,5,18000,0,'+05'),(1522,6,21600,1,'+06'),(1523,0,30472,0,'LMT'),(1523,1,30600,0,'KST'),(1523,2,32400,0,'JST'),(1523,3,32400,0,'KST'),(1523,4,34200,1,'KDT'),(1523,5,36000,1,'KDT'),(1524,0,29143,0,'LMT'),(1524,1,32400,1,'CDT'),(1524,2,28800,0,'CST'),(1525,0,24925,0,'LMT'),(1525,1,24925,0,'SMT'),(1525,2,25200,0,'+07'),(1525,3,26400,1,'+0720'),(1525,4,26400,0,'+0720'),(1525,5,27000,0,'+0730'),(1525,6,32400,0,'+09'),(1525,7,28800,0,'+08'),(1526,0,36892,0,'LMT'),(1526,1,36000,0,'+10'),(1526,2,43200,1,'+12'),(1526,3,39600,0,'+11'),(1526,4,39600,0,'+11'),(1526,5,43200,1,'+12'),(1526,6,39600,1,'+11'),(1526,7,36000,0,'+10'),(1526,8,43200,0,'+12'),(1526,9,43200,1,'+12'),(1526,10,39600,0,'+11'),(1527,0,29160,0,'LMT'),(1527,1,28800,0,'CST'),(1527,2,32400,0,'JST'),(1527,3,32400,1,'CDT'),(1527,4,28800,0,'CST'),(1528,0,16631,0,'LMT'),(1528,1,18000,0,'+05'),(1528,2,25200,1,'+07'),(1528,3,21600,0,'+06'),(1528,4,21600,0,'+06'),(1528,5,25200,1,'+07'),(1528,6,21600,1,'+06'),(1528,7,18000,0,'+05'),(1529,0,10751,0,'LMT'),(1529,1,10751,0,'TBMT'),(1529,2,10800,0,'+03'),(1529,3,18000,1,'+05'),(1529,4,14400,0,'+04'),(1529,5,14400,0,'+04'),(1529,6,18000,1,'+05'),(1529,7,14400,1,'+04'),(1529,8,10800,0,'+03'),(1529,9,14400,1,'+04'),(1529,10,14400,0,'+04'),(1530,0,12344,0,'LMT'),(1530,1,12344,0,'TMT'),(1530,2,12600,0,'+0330'),(1530,3,18000,1,'+05'),(1530,4,14400,0,'+04'),(1530,5,16200,1,'+0430'),(1530,6,12600,0,'+0330'),(1531,0,8454,0,'LMT'),(1531,1,8440,0,'JMT'),(1531,2,10800,1,'IDT'),(1531,3,7200,0,'IST'),(1531,4,14400,1,'IDDT'),(1531,5,10800,1,'IDT'),(1532,0,21516,0,'LMT'),(1532,1,19800,0,'+0530'),(1532,2,21600,0,'+06'),(1533,0,21516,0,'LMT'),(1533,1,19800,0,'+0530'),(1533,2,21600,0,'+06'),(1534,0,33539,0,'LMT'),(1534,1,36000,1,'JDT'),(1534,2,32400,0,'JST'),(1534,3,32400,0,'JST'),(1535,0,20391,0,'LMT'),(1535,1,21600,0,'+06'),(1535,2,28800,1,'+08'),(1535,3,25200,0,'+07'),(1535,4,25200,0,'+07'),(1535,5,28800,1,'+08'),(1535,6,25200,1,'+07'),(1535,7,21600,0,'+06'),(1535,8,25200,1,'+07'),(1535,9,25200,0,'+07'),(1536,0,28656,0,'LMT'),(1536,1,28656,0,'MMT'),(1536,2,28800,0,'+08'),(1536,3,32400,0,'+09'),(1536,4,28800,0,'WITA'),(1537,0,25652,0,'LMT'),(1537,1,25200,0,'+07'),(1537,2,32400,1,'+09'),(1537,3,28800,0,'+08'),(1538,0,25652,0,'LMT'),(1538,1,25200,0,'+07'),(1538,2,32400,1,'+09'),(1538,3,28800,0,'+08'),(1539,0,21020,0,'LMT'),(1539,1,21600,0,'+06'),(1540,0,34374,0,'LMT'),(1540,1,28800,0,'+08'),(1540,2,32400,0,'+09'),(1540,3,39600,0,'+11'),(1540,4,43200,1,'+12'),(1540,5,39600,0,'+11'),(1540,6,43200,1,'+12'),(1540,7,39600,1,'+11'),(1540,8,36000,0,'+10'),(1540,9,43200,0,'+12'),(1540,10,43200,1,'+12'),(1540,11,36000,0,'+10'),(1541,0,24124,0,'LMT'),(1541,1,24124,0,'BMT'),(1541,2,25200,0,'+07'),(1542,0,31651,0,'LMT'),(1542,1,32400,0,'+09'),(1542,2,39600,1,'+11'),(1542,3,36000,0,'+10'),(1542,4,36000,0,'+10'),(1542,5,39600,1,'+11'),(1542,6,36000,1,'+10'),(1542,7,32400,0,'+09'),(1542,8,39600,0,'+11'),(1542,9,39600,1,'+11'),(1542,10,36000,0,'+10'),(1543,0,31138,0,'LMT'),(1543,1,28800,0,'+08'),(1543,2,36000,1,'+10'),(1543,3,32400,0,'+09'),(1543,4,32400,0,'+09'),(1543,5,36000,1,'+10'),(1543,6,32400,1,'+09'),(1543,7,28800,0,'+08'),(1543,8,36000,0,'+10'),(1543,9,36000,1,'+10'),(1543,10,32400,0,'+09'),(1544,0,23087,0,'LMT'),(1544,1,23087,0,'RMT'),(1544,2,23400,0,'+0630'),(1544,3,32400,0,'+09'),(1544,4,23400,0,'+0630'),(1545,0,14553,0,'LMT'),(1545,1,13505,0,'PMT'),(1545,2,14400,0,'+04'),(1545,3,21600,1,'+06'),(1545,4,18000,0,'+05'),(1545,5,18000,0,'+05'),(1545,6,21600,1,'+06'),(1545,7,18000,1,'+05'),(1545,8,14400,0,'+04'),(1545,9,21600,0,'+06'),(1545,10,21600,1,'+06'),(1545,11,18000,0,'+05'),(1546,0,10680,0,'LMT'),(1546,1,10800,0,'+03'),(1546,2,18000,1,'+05'),(1546,3,14400,0,'+04'),(1546,4,14400,0,'+04'),(1546,5,18000,1,'+05'),(1546,6,14400,1,'+04'),(1546,7,10800,0,'+03'),(1546,8,18000,1,'+05'),(1546,9,14400,0,'+04'),(1547,0,-6160,0,'LMT'),(1547,1,-6872,0,'HMT'),(1547,2,-3600,1,'-01'),(1547,3,-7200,0,'-02'),(1547,4,-3600,1,'-01'),(1547,5,-7200,0,'-02'),(1547,6,-7200,0,'-02'),(1547,7,0,1,'+00'),(1547,8,-3600,0,'-01'),(1547,9,-3600,0,'-01'),(1547,10,0,0,'WET'),(1547,11,0,1,'+00'),(1547,12,-3600,0,'-01'),(1548,0,-15558,0,'LMT'),(1548,1,-14400,0,'AST'),(1548,2,-10800,1,'ADT'),(1549,0,-3696,0,'LMT'),(1549,1,-3600,0,'-01'),(1549,2,0,0,'WET'),(1549,3,3600,1,'WEST'),(1549,4,0,0,'WET'),(1549,5,3600,1,'WEST'),(1550,0,-5644,0,'LMT'),(1550,1,-7200,0,'-02'),(1550,2,-3600,1,'-01'),(1550,3,-7200,0,'-02'),(1550,4,-3600,0,'-01'),(1551,0,-1624,0,'LMT'),(1551,1,0,0,'WET'),(1551,2,3600,1,'WEST'),(1551,3,0,0,'WET'),(1552,0,-1624,0,'LMT'),(1552,1,0,0,'WET'),(1552,2,3600,1,'WEST'),(1552,3,0,0,'WET'),(1553,0,2580,0,'LMT'),(1553,1,7200,1,'CEST'),(1553,2,3600,0,'CET'),(1553,3,3600,0,'CET'),(1553,4,7200,1,'CEST'),(1553,5,7200,1,'CEST'),(1553,6,3600,0,'CET'),(1554,0,-4056,0,'LMT'),(1554,1,-4056,0,'FMT'),(1554,2,0,1,'+00'),(1554,3,-3600,0,'-01'),(1554,4,0,1,'+00'),(1554,5,-3600,0,'-01'),(1554,6,-3600,0,'-01'),(1554,7,3600,1,'+01'),(1554,8,3600,1,'WEST'),(1554,9,0,0,'WET'),(1554,10,0,0,'WET'),(1554,11,0,0,'WET'),(1554,12,3600,1,'WEST'),(1555,0,-5280,0,'LMT'),(1555,1,0,1,'+00'),(1555,2,-3600,0,'-01'),(1555,3,-3600,0,'-01'),(1555,4,0,1,'+00'),(1555,5,0,0,'GMT'),(1556,0,-7200,0,'-02'),(1557,0,-968,0,'LMT'),(1557,1,0,0,'GMT'),(1558,0,-13884,0,'LMT'),(1558,1,-13884,0,'SMT'),(1558,2,-10800,1,'-03'),(1558,3,-14400,0,'-04'),(1558,4,-7200,1,'-02'),(1558,5,-10800,0,'-03'),(1558,6,-10800,1,'-03'),(1559,0,36292,0,'LMT'),(1559,1,39600,1,'AEDT'),(1559,2,36000,0,'AEST'),(1559,3,39600,1,'AEDT'),(1559,4,36000,0,'AEST'),(1560,0,32400,0,'ACST'),(1560,1,37800,1,'ACDT'),(1560,2,34200,0,'ACST'),(1560,3,37800,1,'ACDT'),(1560,4,34200,0,'ACST'),(1561,0,36728,0,'LMT'),(1561,1,39600,1,'AEDT'),(1561,2,36000,0,'AEST'),(1561,3,39600,1,'AEDT'),(1561,4,36000,0,'AEST'),(1562,0,32400,0,'ACST'),(1562,1,37800,1,'ACDT'),(1562,2,34200,0,'ACST'),(1562,3,37800,1,'ACDT'),(1562,4,34200,0,'ACST'),(1563,0,36292,0,'LMT'),(1563,1,39600,1,'AEDT'),(1563,2,36000,0,'AEST'),(1563,3,39600,1,'AEDT'),(1563,4,36000,0,'AEST'),(1564,0,34528,0,'LMT'),(1564,1,36000,0,'AEST'),(1564,2,39600,1,'AEDT'),(1564,3,39600,1,'AEDT'),(1564,4,36000,0,'AEST'),(1565,0,32400,0,'ACST'),(1565,1,37800,1,'ACDT'),(1565,2,34200,0,'ACST'),(1566,0,30928,0,'LMT'),(1566,1,35100,1,'+0945'),(1566,2,31500,0,'+0845'),(1566,3,35100,1,'+0945'),(1566,4,31500,0,'+0845'),(1567,0,35356,0,'LMT'),(1567,1,36000,0,'AEST'),(1567,2,39600,1,'AEDT'),(1567,3,39600,1,'AEDT'),(1567,4,36000,0,'AEST'),(1568,0,38180,0,'LMT'),(1568,1,36000,0,'AEST'),(1568,2,41400,1,'+1130'),(1568,3,37800,0,'+1030'),(1568,4,39600,1,'+11'),(1569,0,35756,0,'LMT'),(1569,1,39600,1,'AEDT'),(1569,2,36000,0,'AEST'),(1569,3,39600,1,'AEDT'),(1569,4,36000,0,'AEST'),(1570,0,38180,0,'LMT'),(1570,1,36000,0,'AEST'),(1570,2,41400,1,'+1130'),(1570,3,37800,0,'+1030'),(1570,4,39600,1,'+11'),(1571,0,34792,0,'LMT'),(1571,1,39600,1,'AEDT'),(1571,2,36000,0,'AEST'),(1571,3,39600,1,'AEDT'),(1571,4,36000,0,'AEST'),(1572,0,36292,0,'LMT'),(1572,1,39600,1,'AEDT'),(1572,2,36000,0,'AEST'),(1572,3,39600,1,'AEDT'),(1572,4,36000,0,'AEST'),(1573,0,32400,0,'ACST'),(1573,1,37800,1,'ACDT'),(1573,2,34200,0,'ACST'),(1574,0,27804,0,'LMT'),(1574,1,32400,1,'AWDT'),(1574,2,28800,0,'AWST'),(1574,3,32400,1,'AWDT'),(1574,4,28800,0,'AWST'),(1575,0,36728,0,'LMT'),(1575,1,39600,1,'AEDT'),(1575,2,36000,0,'AEST'),(1575,3,39600,1,'AEDT'),(1575,4,36000,0,'AEST'),(1576,0,32400,0,'ACST'),(1576,1,37800,1,'ACDT'),(1576,2,34200,0,'ACST'),(1576,3,37800,1,'ACDT'),(1576,4,34200,0,'ACST'),(1577,0,36292,0,'LMT'),(1577,1,39600,1,'AEDT'),(1577,2,36000,0,'AEST'),(1577,3,39600,1,'AEDT'),(1577,4,36000,0,'AEST'),(1578,0,35356,0,'LMT'),(1578,1,36000,0,'AEST'),(1578,2,39600,1,'AEDT'),(1578,3,39600,1,'AEDT'),(1578,4,36000,0,'AEST'),(1579,0,34792,0,'LMT'),(1579,1,39600,1,'AEDT'),(1579,2,36000,0,'AEST'),(1579,3,39600,1,'AEDT'),(1579,4,36000,0,'AEST'),(1580,0,27804,0,'LMT'),(1580,1,32400,1,'AWDT'),(1580,2,28800,0,'AWST'),(1580,3,32400,1,'AWDT'),(1580,4,28800,0,'AWST'),(1581,0,32400,0,'ACST'),(1581,1,37800,1,'ACDT'),(1581,2,34200,0,'ACST'),(1581,3,37800,1,'ACDT'),(1581,4,34200,0,'ACST'),(1582,0,-16272,0,'LMT'),(1582,1,-14400,1,'-04'),(1582,2,-18000,0,'-05'),(1582,3,-14400,0,'-04'),(1582,4,-18000,0,'-05'),(1583,0,-7780,0,'LMT'),(1583,1,-3600,1,'-01'),(1583,2,-7200,0,'-02'),(1584,0,-11188,0,'LMT'),(1584,1,-7200,1,'-02'),(1584,2,-10800,0,'-03'),(1585,0,-14404,0,'LMT'),(1585,1,-10800,1,'-03'),(1585,2,-14400,0,'-04'),(1586,0,7200,1,'CEST'),(1586,1,3600,0,'CET'),(1586,2,7200,1,'CEST'),(1586,3,3600,0,'CET'),(1587,0,-18000,1,'CDT'),(1587,1,-21600,0,'CST'),(1587,2,-18000,1,'CWT'),(1587,3,-18000,1,'CPT'),(1588,0,-15264,0,'LMT'),(1588,1,-10800,1,'ADT'),(1588,2,-14400,0,'AST'),(1588,3,-10800,1,'AWT'),(1588,4,-10800,1,'APT'),(1589,0,-23316,0,'LMT'),(1589,1,-18000,1,'CDT'),(1589,2,-21600,0,'CST'),(1589,3,-18000,1,'CWT'),(1589,4,-18000,1,'CPT'),(1589,5,-18000,1,'CDT'),(1589,6,-21600,0,'CST'),(1590,0,-19052,0,'LMT'),(1590,1,-14400,1,'EDT'),(1590,2,-18000,0,'EST'),(1590,3,-14400,1,'EWT'),(1590,4,-14400,1,'EPT'),(1591,0,-27232,0,'LMT'),(1591,1,-21600,1,'MDT'),(1591,2,-25200,0,'MST'),(1591,3,-21600,1,'MWT'),(1591,4,-21600,1,'MPT'),(1592,0,-12652,0,'LMT'),(1592,1,-9052,1,'NDT'),(1592,2,-12652,0,'NST'),(1592,3,-9000,1,'NDT'),(1592,4,-12600,0,'NST'),(1592,5,-9000,1,'NPT'),(1592,6,-9000,1,'NWT'),(1592,7,-5400,1,'NDDT'),(1592,8,-9000,1,'NDT'),(1593,0,-29548,0,'LMT'),(1593,1,-25200,1,'PDT'),(1593,2,-28800,0,'PST'),(1593,3,-25200,1,'PWT'),(1593,4,-25200,1,'PPT'),(1594,0,-25116,0,'LMT'),(1594,1,-21600,1,'MDT'),(1594,2,-25200,0,'MST'),(1594,3,-21600,1,'MWT'),(1594,4,-21600,1,'MPT'),(1594,5,-21600,0,'CST'),(1595,0,-32412,0,'LMT'),(1595,1,-28800,1,'YDT'),(1595,2,-32400,0,'YST'),(1595,3,-28800,1,'YWT'),(1595,4,-28800,1,'YPT'),(1595,5,-25200,1,'YDDT'),(1595,6,-28800,0,'PST'),(1595,7,-25200,1,'PDT'),(1596,0,-16966,0,'LMT'),(1596,1,-16966,0,'SMT'),(1596,2,-18000,0,'-05'),(1596,3,-14400,0,'-04'),(1596,4,-14400,1,'-04'),(1596,5,-10800,1,'-03'),(1596,6,-10800,1,'-03'),(1596,7,-14400,0,'-04'),(1597,0,-26248,0,'LMT'),(1597,1,-26248,0,'EMT'),(1597,2,-21600,1,'-06'),(1597,3,-25200,0,'-07'),(1597,4,-25200,0,'-07'),(1597,5,-21600,0,'-06'),(1597,6,-18000,1,'-05'),(1598,0,-19768,0,'LMT'),(1598,1,-19776,0,'HMT'),(1598,2,-14400,1,'CDT'),(1598,3,-18000,0,'CST'),(1598,4,-18000,0,'CST'),(1598,5,-14400,1,'CDT'),(1599,0,10800,1,'EEST'),(1599,1,7200,0,'EET'),(1600,0,-18000,0,'EST'),(1601,0,-14400,1,'EDT'),(1601,1,-18000,0,'EST'),(1601,2,-14400,1,'EWT'),(1601,3,-14400,1,'EPT'),(1602,0,7509,0,'LMT'),(1602,1,10800,1,'EEST'),(1602,2,7200,0,'EET'),(1602,3,10800,1,'EEST'),(1603,0,-1500,0,'LMT'),(1603,1,-1521,0,'DMT'),(1603,2,2079,1,'IST'),(1603,3,3600,1,'BST'),(1603,4,0,0,'GMT'),(1603,5,3600,1,'IST'),(1603,6,0,0,'GMT'),(1603,7,0,1,'GMT'),(1603,8,3600,0,'IST'),(1603,9,3600,0,'IST'),(1604,0,0,0,'GMT'),(1605,0,0,0,'GMT'),(1606,0,-3600,0,'-01'),(1607,0,-36000,0,'-10'),(1608,0,-39600,0,'-11'),(1609,0,-43200,0,'-12'),(1610,0,-7200,0,'-02'),(1611,0,-10800,0,'-03'),(1612,0,-14400,0,'-04'),(1613,0,-18000,0,'-05'),(1614,0,-21600,0,'-06'),(1615,0,-25200,0,'-07'),(1616,0,-28800,0,'-08'),(1617,0,-32400,0,'-09'),(1618,0,0,0,'GMT'),(1619,0,3600,0,'+01'),(1620,0,36000,0,'+10'),(1621,0,39600,0,'+11'),(1622,0,43200,0,'+12'),(1623,0,46800,0,'+13'),(1624,0,50400,0,'+14'),(1625,0,7200,0,'+02'),(1626,0,10800,0,'+03'),(1627,0,14400,0,'+04'),(1628,0,18000,0,'+05'),(1629,0,21600,0,'+06'),(1630,0,25200,0,'+07'),(1631,0,28800,0,'+08'),(1632,0,32400,0,'+09'),(1633,0,0,0,'GMT'),(1634,0,0,0,'GMT'),(1635,0,0,0,'UTC'),(1636,0,0,0,'UTC'),(1637,0,0,0,'UTC'),(1638,0,0,0,'UTC'),(1639,0,1172,0,'LMT'),(1639,1,4772,1,'NST'),(1639,2,1172,0,'AMT'),(1639,3,4772,1,'NST'),(1639,4,1172,0,'AMT'),(1639,5,1200,0,'+0020'),(1639,6,4800,1,'+0120'),(1639,7,4800,1,'+0120'),(1639,8,3600,0,'CET'),(1639,9,7200,1,'CEST'),(1639,10,7200,1,'CEST'),(1639,11,7200,1,'CEST'),(1639,12,3600,0,'CET'),(1639,13,3600,0,'CET'),(1640,0,364,0,'LMT'),(1640,1,0,0,'WET'),(1640,2,3600,0,'CET'),(1640,3,7200,1,'CEST'),(1640,4,3600,0,'CET'),(1641,0,11532,0,'LMT'),(1641,1,10800,0,'+03'),(1641,2,18000,1,'+05'),(1641,3,14400,0,'+04'),(1641,4,14400,0,'+04'),(1641,5,18000,1,'+05'),(1641,6,14400,1,'+04'),(1641,7,10800,0,'+03'),(1641,8,14400,0,'+04'),(1642,0,5692,0,'LMT'),(1642,1,5692,0,'AMT'),(1642,2,10800,1,'EEST'),(1642,3,7200,0,'EET'),(1642,4,3600,0,'CET'),(1642,5,7200,1,'CEST'),(1642,6,10800,1,'EEST'),(1642,7,7200,0,'EET'),(1642,8,10800,1,'EEST'),(1642,9,7200,0,'EET'),(1643,0,-75,0,'LMT'),(1643,1,3600,1,'BST'),(1643,2,0,0,'GMT'),(1643,3,7200,1,'BDST'),(1643,4,3600,0,'BST'),(1643,5,3600,1,'BST'),(1643,6,0,0,'GMT'),(1643,7,0,0,'GMT'),(1644,0,4920,0,'LMT'),(1644,1,3600,0,'CET'),(1644,2,3600,0,'CET'),(1644,3,7200,1,'CEST'),(1644,4,7200,1,'CEST'),(1644,5,7200,1,'CEST'),(1644,6,3600,0,'CET'),(1645,0,3208,0,'LMT'),(1645,1,7200,1,'CEST'),(1645,2,3600,0,'CET'),(1645,3,7200,1,'CEST'),(1645,4,3600,0,'CET'),(1645,5,10800,1,'CEMT'),(1645,6,10800,1,'CEMT'),(1645,7,7200,1,'CEST'),(1645,8,3600,0,'CET'),(1646,0,3464,0,'PMT'),(1646,1,7200,1,'CEST'),(1646,2,3600,0,'CET'),(1646,3,7200,1,'CEST'),(1646,4,3600,0,'CET'),(1646,5,0,1,'GMT'),(1646,6,7200,1,'CEST'),(1646,7,3600,0,'CET'),(1647,0,1050,0,'BMT'),(1647,1,0,0,'WET'),(1647,2,3600,0,'CET'),(1647,3,7200,1,'CEST'),(1647,4,3600,0,'CET'),(1647,5,7200,1,'CEST'),(1647,6,3600,1,'WEST'),(1647,7,0,0,'WET'),(1647,8,0,0,'WET'),(1647,9,7200,1,'CEST'),(1647,10,3600,0,'CET'),(1648,0,6264,0,'LMT'),(1648,1,6264,0,'BMT'),(1648,2,10800,1,'EEST'),(1648,3,7200,0,'EET'),(1648,4,10800,1,'EEST'),(1648,5,7200,0,'EET'),(1648,6,10800,1,'EEST'),(1648,7,7200,0,'EET'),(1649,0,4580,0,'LMT'),(1649,1,7200,1,'CEST'),(1649,2,3600,0,'CET'),(1649,3,7200,1,'CEST'),(1649,4,3600,0,'CET'),(1649,5,3600,0,'CET'),(1649,6,7200,1,'CEST'),(1650,0,1786,0,'BMT'),(1650,1,7200,1,'CEST'),(1650,2,3600,0,'CET'),(1650,3,7200,1,'CEST'),(1650,4,3600,0,'CET'),(1651,0,6920,0,'LMT'),(1651,1,6900,0,'CMT'),(1651,2,6264,0,'BMT'),(1651,3,10800,1,'EEST'),(1651,4,7200,0,'EET'),(1651,5,7200,0,'EET'),(1651,6,10800,1,'EEST'),(1651,7,3600,0,'CET'),(1651,8,7200,1,'CEST'),(1651,9,7200,1,'CEST'),(1651,10,14400,1,'MSD'),(1651,11,10800,0,'MSK'),(1651,12,10800,0,'MSK'),(1651,13,14400,1,'MSD'),(1651,14,10800,1,'EEST'),(1651,15,7200,0,'EET'),(1652,0,3020,0,'CMT'),(1652,1,7200,1,'CEST'),(1652,2,3600,0,'CET'),(1652,3,3600,0,'CET'),(1652,4,7200,1,'CEST'),(1652,5,7200,1,'CEST'),(1652,6,3600,0,'CET'),(1653,0,-1500,0,'LMT'),(1653,1,-1521,0,'DMT'),(1653,2,2079,1,'IST'),(1653,3,3600,1,'BST'),(1653,4,0,0,'GMT'),(1653,5,3600,1,'IST'),(1653,6,0,0,'GMT'),(1653,7,0,1,'GMT'),(1653,8,3600,0,'IST'),(1653,9,3600,0,'IST'),(1654,0,-1284,0,'LMT'),(1654,1,3600,1,'BST'),(1654,2,0,0,'GMT'),(1654,3,7200,1,'BDST'),(1654,4,3600,0,'CET'),(1654,5,7200,1,'CEST'),(1654,6,3600,0,'CET'),(1655,0,-75,0,'LMT'),(1655,1,3600,1,'BST'),(1655,2,0,0,'GMT'),(1655,3,7200,1,'BDST'),(1655,4,3600,0,'BST'),(1655,5,3600,1,'BST'),(1655,6,0,0,'GMT'),(1655,7,0,0,'GMT'),(1656,0,5989,0,'LMT'),(1656,1,5989,0,'HMT'),(1656,2,10800,1,'EEST'),(1656,3,7200,0,'EET'),(1656,4,10800,1,'EEST'),(1656,5,7200,0,'EET'),(1657,0,-75,0,'LMT'),(1657,1,3600,1,'BST'),(1657,2,0,0,'GMT'),(1657,3,7200,1,'BDST'),(1657,4,3600,0,'BST'),(1657,5,3600,1,'BST'),(1657,6,0,0,'GMT'),(1657,7,0,0,'GMT'),(1658,0,6952,0,'LMT'),(1658,1,7016,0,'IMT'),(1658,2,10800,1,'EEST'),(1658,3,7200,0,'EET'),(1658,4,14400,1,'+04'),(1658,5,10800,0,'+03'),(1658,6,10800,1,'EEST'),(1658,7,7200,0,'EET'),(1658,8,10800,1,'EEST'),(1658,9,7200,0,'EET'),(1658,10,10800,0,'+03'),(1659,0,-75,0,'LMT'),(1659,1,3600,1,'BST'),(1659,2,0,0,'GMT'),(1659,3,7200,1,'BDST'),(1659,4,3600,0,'BST'),(1659,5,3600,1,'BST'),(1659,6,0,0,'GMT'),(1659,7,0,0,'GMT'),(1660,0,4920,0,'LMT'),(1660,1,7200,1,'CEST'),(1660,2,3600,0,'CET'),(1660,3,7200,1,'CEST'),(1660,4,3600,0,'CET'),(1660,5,10800,1,'CEST'),(1660,6,7200,0,'CET'),(1660,7,14400,1,'MSD'),(1660,8,10800,0,'MSK'),(1660,9,10800,0,'MSK'),(1660,10,14400,1,'MSD'),(1660,11,10800,1,'EEST'),(1660,12,7200,0,'EET'),(1660,13,10800,0,'+03'),(1660,14,7200,0,'EET'),(1661,0,7324,0,'LMT'),(1661,1,7324,0,'KMT'),(1661,2,7200,0,'EET'),(1661,3,10800,0,'MSK'),(1661,4,3600,0,'CET'),(1661,5,7200,1,'CEST'),(1661,6,7200,1,'CEST'),(1661,7,14400,1,'MSD'),(1661,8,10800,0,'MSK'),(1661,9,14400,1,'MSD'),(1661,10,10800,1,'EEST'),(1661,11,10800,1,'EEST'),(1661,12,7200,0,'EET'),(1662,0,11928,0,'LMT'),(1662,1,10800,0,'+03'),(1662,2,18000,1,'+05'),(1662,3,14400,0,'+04'),(1662,4,14400,0,'+04'),(1662,5,18000,1,'+05'),(1662,6,14400,1,'+04'),(1662,7,10800,0,'+03'),(1663,0,-2205,0,'LMT'),(1663,1,3600,1,'WEST'),(1663,2,0,0,'WET'),(1663,3,3600,1,'WEST'),(1663,4,0,0,'WET'),(1663,5,7200,1,'WEMT'),(1663,6,0,0,'WET'),(1663,7,3600,0,'CET'),(1663,8,3600,0,'CET'),(1663,9,7200,1,'CEST'),(1663,10,3600,1,'WEST'),(1663,11,0,0,'WET'),(1664,0,4920,0,'LMT'),(1664,1,3600,0,'CET'),(1664,2,3600,0,'CET'),(1664,3,7200,1,'CEST'),(1664,4,7200,1,'CEST'),(1664,5,7200,1,'CEST'),(1664,6,3600,0,'CET'),(1665,0,-75,0,'LMT'),(1665,1,3600,1,'BST'),(1665,2,0,0,'GMT'),(1665,3,7200,1,'BDST'),(1665,4,3600,0,'BST'),(1665,5,3600,1,'BST'),(1665,6,0,0,'GMT'),(1665,7,0,0,'GMT'),(1666,0,1476,0,'LMT'),(1666,1,7200,1,'CEST'),(1666,2,3600,0,'CET'),(1666,3,7200,1,'CEST'),(1666,4,3600,0,'CET'),(1666,5,3600,1,'WEST'),(1666,6,0,0,'WET'),(1666,7,0,0,'WET'),(1666,8,3600,1,'WEST'),(1666,9,3600,0,'WET'),(1666,10,7200,1,'WEST'),(1666,11,7200,1,'WEST'),(1666,12,7200,1,'CEST'),(1666,13,3600,0,'CET'),(1667,0,-884,0,'LMT'),(1667,1,3600,1,'WEST'),(1667,2,0,0,'WET'),(1667,3,7200,1,'WEMT'),(1667,4,0,0,'WET'),(1667,5,7200,1,'CEST'),(1667,6,3600,0,'CET'),(1667,7,7200,1,'CEST'),(1667,8,3600,0,'CET'),(1667,9,7200,1,'CEST'),(1667,10,3600,0,'CET'),(1668,0,3484,0,'LMT'),(1668,1,7200,1,'CEST'),(1668,2,3600,0,'CET'),(1668,3,3600,0,'CET'),(1668,4,7200,1,'CEST'),(1668,5,7200,1,'CEST'),(1668,6,3600,0,'CET'),(1669,0,5989,0,'LMT'),(1669,1,5989,0,'HMT'),(1669,2,10800,1,'EEST'),(1669,3,7200,0,'EET'),(1669,4,10800,1,'EEST'),(1669,5,7200,0,'EET'),(1670,0,6616,0,'LMT'),(1670,1,6600,0,'MMT'),(1670,2,7200,0,'EET'),(1670,3,10800,0,'MSK'),(1670,4,3600,0,'CET'),(1670,5,7200,1,'CEST'),(1670,6,7200,1,'CEST'),(1670,7,14400,1,'MSD'),(1670,8,10800,0,'MSK'),(1670,9,14400,1,'MSD'),(1670,10,10800,1,'EEST'),(1670,11,7200,0,'EET'),(1670,12,10800,0,'+03'),(1671,0,1772,0,'LMT'),(1671,1,561,0,'PMT'),(1671,2,3600,1,'WEST'),(1671,3,0,0,'WET'),(1671,4,3600,1,'WEST'),(1671,5,7200,1,'WEMT'),(1671,6,0,0,'WET'),(1671,7,7200,1,'CEST'),(1671,8,3600,0,'CET'),(1671,9,7200,1,'CEST'),(1671,10,3600,0,'CET'),(1672,0,9017,0,'LMT'),(1672,1,9017,0,'MMT'),(1672,2,12679,1,'MST'),(1672,3,9079,0,'MMT'),(1672,4,16279,1,'MDST'),(1672,5,14400,1,'MSD'),(1672,6,10800,0,'MSK'),(1672,7,14400,1,'MSD'),(1672,8,18000,1,'+05'),(1672,9,7200,0,'EET'),(1672,10,10800,0,'MSK'),(1672,11,14400,1,'MSD'),(1672,12,10800,1,'EEST'),(1672,13,7200,0,'EET'),(1672,14,14400,0,'MSK'),(1672,15,14400,1,'MSD'),(1672,16,10800,0,'MSK'),(1673,0,8008,0,'LMT'),(1673,1,10800,1,'EEST'),(1673,2,7200,0,'EET'),(1673,3,7200,0,'EET'),(1673,4,10800,1,'EEST'),(1674,0,2580,0,'LMT'),(1674,1,7200,1,'CEST'),(1674,2,3600,0,'CET'),(1674,3,3600,0,'CET'),(1674,4,7200,1,'CEST'),(1674,5,7200,1,'CEST'),(1674,6,3600,0,'CET'),(1675,0,561,0,'LMT'),(1675,1,561,0,'PMT'),(1675,2,3600,1,'WEST'),(1675,3,0,0,'WET'),(1675,4,3600,1,'WEST'),(1675,5,0,0,'WET'),(1675,6,3600,0,'CET'),(1675,7,7200,1,'CEST'),(1675,8,7200,1,'CEST'),(1675,9,7200,1,'WEMT'),(1675,10,3600,0,'CET'),(1675,11,7200,1,'CEST'),(1675,12,3600,0,'CET'),(1676,0,4920,0,'LMT'),(1676,1,3600,0,'CET'),(1676,2,3600,0,'CET'),(1676,3,7200,1,'CEST'),(1676,4,7200,1,'CEST'),(1676,5,7200,1,'CEST'),(1676,6,3600,0,'CET'),(1677,0,3464,0,'PMT'),(1677,1,7200,1,'CEST'),(1677,2,3600,0,'CET'),(1677,3,7200,1,'CEST'),(1677,4,3600,0,'CET'),(1677,5,0,1,'GMT'),(1677,6,7200,1,'CEST'),(1677,7,3600,0,'CET'),(1678,0,5794,0,'LMT'),(1678,1,5794,0,'RMT'),(1678,2,9394,1,'LST'),(1678,3,7200,0,'EET'),(1678,4,10800,0,'MSK'),(1678,5,3600,0,'CET'),(1678,6,7200,1,'CEST'),(1678,7,7200,1,'CEST'),(1678,8,14400,1,'MSD'),(1678,9,10800,0,'MSK'),(1678,10,14400,1,'MSD'),(1678,11,10800,1,'EEST'),(1678,12,7200,0,'EET'),(1678,13,10800,1,'EEST'),(1678,14,7200,0,'EET'),(1679,0,2996,0,'RMT'),(1679,1,7200,1,'CEST'),(1679,2,3600,0,'CET'),(1679,3,3600,0,'CET'),(1679,4,7200,1,'CEST'),(1679,5,7200,1,'CEST'),(1679,6,3600,0,'CET'),(1680,0,12020,0,'LMT'),(1680,1,10800,0,'+03'),(1680,2,14400,0,'+04'),(1680,3,18000,1,'+05'),(1680,4,14400,0,'+04'),(1680,5,18000,1,'+05'),(1680,6,14400,1,'+04'),(1680,7,10800,0,'+03'),(1680,8,10800,1,'+03'),(1680,9,14400,1,'+04'),(1680,10,14400,0,'+04'),(1681,0,2996,0,'RMT'),(1681,1,7200,1,'CEST'),(1681,2,3600,0,'CET'),(1681,3,3600,0,'CET'),(1681,4,7200,1,'CEST'),(1681,5,7200,1,'CEST'),(1681,6,3600,0,'CET'),(1682,0,4920,0,'LMT'),(1682,1,3600,0,'CET'),(1682,2,3600,0,'CET'),(1682,3,7200,1,'CEST'),(1682,4,7200,1,'CEST'),(1682,5,7200,1,'CEST'),(1682,6,3600,0,'CET'),(1683,0,11058,0,'LMT'),(1683,1,10800,0,'+03'),(1683,2,18000,1,'+05'),(1683,3,14400,0,'+04'),(1683,4,14400,0,'+04'),(1683,5,18000,1,'+05'),(1683,6,14400,1,'+04'),(1683,7,10800,0,'+03'),(1683,8,14400,0,'+04'),(1684,0,8184,0,'LMT'),(1684,1,8160,0,'SMT'),(1684,2,7200,0,'EET'),(1684,3,10800,0,'MSK'),(1684,4,3600,0,'CET'),(1684,5,7200,1,'CEST'),(1684,6,7200,1,'CEST'),(1684,7,14400,1,'MSD'),(1684,8,10800,0,'MSK'),(1684,9,14400,1,'MSD'),(1684,10,10800,1,'EEST'),(1684,11,10800,1,'EEST'),(1684,12,7200,0,'EET'),(1684,13,14400,0,'MSK'),(1684,14,10800,0,'MSK'),(1685,0,4920,0,'LMT'),(1685,1,3600,0,'CET'),(1685,2,3600,0,'CET'),(1685,3,7200,1,'CEST'),(1685,4,7200,1,'CEST'),(1685,5,7200,1,'CEST'),(1685,6,3600,0,'CET'),(1686,0,7016,0,'IMT'),(1686,1,7200,0,'EET'),(1686,2,3600,0,'CET'),(1686,3,7200,1,'CEST'),(1686,4,3600,0,'CET'),(1686,5,10800,1,'EEST'),(1686,6,7200,0,'EET'),(1686,7,10800,1,'EEST'),(1686,8,10800,1,'EEST'),(1686,9,7200,0,'EET'),(1687,0,3614,0,'SET'),(1687,1,3600,0,'CET'),(1687,2,7200,1,'CEST'),(1687,3,7200,1,'CEST'),(1687,4,3600,0,'CET'),(1688,0,5940,0,'LMT'),(1688,1,5940,0,'TMT'),(1688,2,7200,1,'CEST'),(1688,3,3600,0,'CET'),(1688,4,3600,0,'CET'),(1688,5,7200,0,'EET'),(1688,6,10800,0,'MSK'),(1688,7,7200,1,'CEST'),(1688,8,14400,1,'MSD'),(1688,9,10800,0,'MSK'),(1688,10,14400,1,'MSD'),(1688,11,10800,1,'EEST'),(1688,12,7200,0,'EET'),(1688,13,7200,0,'EET'),(1688,14,10800,1,'EEST'),(1688,15,10800,1,'EEST'),(1689,0,4760,0,'LMT'),(1689,1,3600,0,'CET'),(1689,2,7200,1,'CEST'),(1689,3,3600,0,'CET'),(1689,4,7200,1,'CEST'),(1690,0,6920,0,'LMT'),(1690,1,6900,0,'CMT'),(1690,2,6264,0,'BMT'),(1690,3,10800,1,'EEST'),(1690,4,7200,0,'EET'),(1690,5,7200,0,'EET'),(1690,6,10800,1,'EEST'),(1690,7,3600,0,'CET'),(1690,8,7200,1,'CEST'),(1690,9,7200,1,'CEST'),(1690,10,14400,1,'MSD'),(1690,11,10800,0,'MSK'),(1690,12,10800,0,'MSK'),(1690,13,14400,1,'MSD'),(1690,14,10800,1,'EEST'),(1690,15,7200,0,'EET'),(1691,0,11616,0,'LMT'),(1691,1,10800,0,'+03'),(1691,2,18000,1,'+05'),(1691,3,14400,0,'+04'),(1691,4,14400,0,'+04'),(1691,5,18000,1,'+05'),(1691,6,14400,1,'+04'),(1691,7,10800,0,'+03'),(1691,8,10800,1,'+03'),(1691,9,7200,0,'+02'),(1691,10,14400,1,'+04'),(1691,11,14400,0,'+04'),(1692,0,5352,0,'LMT'),(1692,1,3600,0,'CET'),(1692,2,7200,1,'CEST'),(1692,3,3600,0,'CET'),(1692,4,7200,1,'CEST'),(1692,5,14400,1,'MSD'),(1692,6,10800,0,'MSK'),(1692,7,10800,0,'MSK'),(1692,8,14400,1,'MSD'),(1692,9,7200,0,'EET'),(1692,10,10800,1,'EEST'),(1692,11,10800,1,'EEST'),(1692,12,7200,0,'EET'),(1693,0,1786,0,'BMT'),(1693,1,7200,1,'CEST'),(1693,2,3600,0,'CET'),(1693,3,7200,1,'CEST'),(1693,4,3600,0,'CET'),(1694,0,2996,0,'RMT'),(1694,1,7200,1,'CEST'),(1694,2,3600,0,'CET'),(1694,3,3600,0,'CET'),(1694,4,7200,1,'CEST'),(1694,5,7200,1,'CEST'),(1694,6,3600,0,'CET'),(1695,0,3921,0,'LMT'),(1695,1,7200,1,'CEST'),(1695,2,3600,0,'CET'),(1695,3,7200,1,'CEST'),(1695,4,3600,0,'CET'),(1695,5,7200,1,'CEST'),(1695,6,3600,0,'CET'),(1696,0,6076,0,'LMT'),(1696,1,5040,0,'WMT'),(1696,2,5736,0,'KMT'),(1696,3,3600,0,'CET'),(1696,4,7200,0,'EET'),(1696,5,10800,0,'MSK'),(1696,6,3600,0,'CET'),(1696,7,7200,1,'CEST'),(1696,8,7200,1,'CEST'),(1696,9,14400,1,'MSD'),(1696,10,10800,0,'MSK'),(1696,11,14400,1,'MSD'),(1696,12,10800,1,'EEST'),(1696,13,7200,0,'EET'),(1696,14,7200,1,'CEST'),(1696,15,3600,0,'CET'),(1696,16,7200,0,'EET'),(1696,17,10800,1,'EEST'),(1697,0,10660,0,'LMT'),(1697,1,10800,0,'+03'),(1697,2,14400,0,'+04'),(1697,3,18000,1,'+05'),(1697,4,14400,0,'+04'),(1697,5,18000,1,'+05'),(1697,6,14400,1,'+04'),(1697,7,10800,0,'+03'),(1697,8,14400,0,'+04'),(1698,0,5040,0,'LMT'),(1698,1,5040,0,'WMT'),(1698,2,7200,1,'CEST'),(1698,3,3600,0,'CET'),(1698,4,7200,1,'CEST'),(1698,5,3600,0,'CET'),(1698,6,10800,1,'EEST'),(1698,7,7200,0,'EET'),(1698,8,7200,0,'EET'),(1698,9,7200,1,'CEST'),(1698,10,3600,0,'CET'),(1699,0,4920,0,'LMT'),(1699,1,3600,0,'CET'),(1699,2,3600,0,'CET'),(1699,3,7200,1,'CEST'),(1699,4,7200,1,'CEST'),(1699,5,7200,1,'CEST'),(1699,6,3600,0,'CET'),(1700,0,8440,0,'LMT'),(1700,1,8400,0,'+0220'),(1700,2,7200,0,'EET'),(1700,3,10800,0,'MSK'),(1700,4,3600,0,'CET'),(1700,5,7200,1,'CEST'),(1700,6,7200,1,'CEST'),(1700,7,14400,1,'MSD'),(1700,8,10800,0,'MSK'),(1700,9,14400,1,'MSD'),(1700,10,10800,1,'EEST'),(1700,11,10800,1,'EEST'),(1700,12,7200,0,'EET'),(1701,0,1786,0,'BMT'),(1701,1,7200,1,'CEST'),(1701,2,3600,0,'CET'),(1701,3,7200,1,'CEST'),(1701,4,3600,0,'CET'),(1702,0,-75,0,'LMT'),(1702,1,3600,1,'BST'),(1702,2,0,0,'GMT'),(1702,3,7200,1,'BDST'),(1702,4,3600,0,'BST'),(1702,5,3600,1,'BST'),(1702,6,0,0,'GMT'),(1702,7,0,0,'GMT'),(1703,0,-75,0,'LMT'),(1703,1,3600,1,'BST'),(1703,2,0,0,'GMT'),(1703,3,7200,1,'BDST'),(1703,4,3600,0,'BST'),(1703,5,3600,1,'BST'),(1703,6,0,0,'GMT'),(1703,7,0,0,'GMT'),(1704,0,0,0,'GMT'),(1705,0,0,0,'GMT'),(1706,0,0,0,'GMT'),(1707,0,0,0,'GMT'),(1708,0,0,0,'GMT'),(1709,0,-36000,0,'HST'),(1710,0,27402,0,'LMT'),(1710,1,28800,0,'HKT'),(1710,2,32400,1,'HKST'),(1710,3,30600,0,'HKT'),(1710,4,32400,0,'JST'),(1710,5,28800,0,'HKT'),(1711,0,-5280,0,'LMT'),(1711,1,0,1,'+00'),(1711,2,-3600,0,'-01'),(1711,3,-3600,0,'-01'),(1711,4,0,1,'+00'),(1711,5,0,0,'GMT'),(1712,0,8836,0,'LMT'),(1712,1,10800,0,'EAT'),(1712,2,9000,0,'+0230'),(1712,3,9900,0,'+0245'),(1712,4,10800,0,'EAT'),(1713,0,17380,0,'LMT'),(1713,1,18000,0,'+05'),(1713,2,21600,0,'+06'),(1714,0,25200,0,'+07'),(1715,0,23400,0,'+0630'),(1716,0,8836,0,'LMT'),(1716,1,10800,0,'EAT'),(1716,2,9000,0,'+0230'),(1716,3,9900,0,'+0245'),(1716,4,10800,0,'EAT'),(1717,0,0,0,'-00'),(1717,1,18000,0,'+05'),(1718,0,13308,0,'LMT'),(1718,1,14400,0,'+04'),(1719,0,17640,0,'LMT'),(1719,1,17640,0,'MMT'),(1719,2,18000,0,'+05'),(1720,0,13800,0,'LMT'),(1720,1,18000,1,'+05'),(1720,2,14400,0,'+04'),(1721,0,8836,0,'LMT'),(1721,1,10800,0,'EAT'),(1721,2,9000,0,'+0230'),(1721,3,9900,0,'+0245'),(1721,4,10800,0,'EAT'),(1722,0,13312,0,'LMT'),(1722,1,14400,0,'+04'),(1723,0,12344,0,'LMT'),(1723,1,12344,0,'TMT'),(1723,2,12600,0,'+0330'),(1723,3,18000,1,'+05'),(1723,4,14400,0,'+04'),(1723,5,16200,1,'+0430'),(1723,6,12600,0,'+0330'),(1724,0,8454,0,'LMT'),(1724,1,8440,0,'JMT'),(1724,2,10800,1,'IDT'),(1724,3,7200,0,'IST'),(1724,4,14400,1,'IDDT'),(1724,5,10800,1,'IDT'),(1725,0,-18430,0,'LMT'),(1725,1,-18430,0,'KMT'),(1725,2,-18000,0,'EST'),(1725,3,-14400,1,'EDT'),(1726,0,33539,0,'LMT'),(1726,1,36000,1,'JDT'),(1726,2,32400,0,'JST'),(1726,3,32400,0,'JST'),(1727,0,40160,0,'LMT'),(1727,1,39600,0,'+11'),(1727,2,36000,0,'+10'),(1727,3,32400,0,'+09'),(1727,4,-43200,0,'-12'),(1727,5,43200,0,'+12'),(1728,0,3164,0,'LMT'),(1728,1,7200,1,'CEST'),(1728,2,3600,0,'CET'),(1728,3,7200,0,'EET'),(1729,0,7200,1,'MEST'),(1729,1,3600,0,'MET'),(1729,2,7200,1,'MEST'),(1729,3,3600,0,'MET'),(1730,0,-25200,0,'MST'),(1731,0,-21600,1,'MDT'),(1731,1,-25200,0,'MST'),(1731,2,-21600,1,'MWT'),(1731,3,-21600,1,'MPT'),(1732,0,-28084,0,'LMT'),(1732,1,-25200,0,'MST'),(1732,2,-28800,0,'PST'),(1732,3,-25200,1,'PDT'),(1732,4,-25200,1,'PWT'),(1732,5,-25200,1,'PPT'),(1733,0,-25540,0,'LMT'),(1733,1,-25200,0,'MST'),(1733,2,-21600,0,'CST'),(1733,3,-28800,0,'PST'),(1733,4,-21600,1,'MDT'),(1733,5,-25200,0,'MST'),(1734,0,-23796,0,'LMT'),(1734,1,-25200,0,'MST'),(1734,2,-21600,0,'CST'),(1734,3,-18000,1,'CDT'),(1734,4,-18000,1,'CWT'),(1735,0,41944,0,'LMT'),(1735,1,45000,1,'NZST'),(1735,2,41400,0,'NZMT'),(1735,3,43200,1,'NZST'),(1735,4,46800,1,'NZDT'),(1735,5,43200,0,'NZST'),(1735,6,43200,0,'NZST'),(1736,0,44028,0,'LMT'),(1736,1,44100,0,'+1215'),(1736,2,49500,1,'+1345'),(1736,3,45900,0,'+1245'),(1736,4,45900,0,'+1245'),(1737,0,-25196,0,'LMT'),(1737,1,-21600,1,'MDT'),(1737,2,-25200,0,'MST'),(1737,3,-21600,1,'MWT'),(1737,4,-21600,1,'MPT'),(1738,0,29143,0,'LMT'),(1738,1,32400,1,'CDT'),(1738,2,28800,0,'CST'),(1739,0,-25200,1,'PDT'),(1739,1,-28800,0,'PST'),(1739,2,-25200,1,'PWT'),(1739,3,-25200,1,'PPT'),(1740,0,45184,0,'LMT'),(1740,1,-41216,0,'LMT'),(1740,2,-41400,0,'-1130'),(1740,3,-36000,1,'-10'),(1740,4,-39600,0,'-11'),(1740,5,46800,0,'+13'),(1740,6,50400,1,'+14'),(1741,0,41944,0,'LMT'),(1741,1,45000,1,'NZST'),(1741,2,41400,0,'NZMT'),(1741,3,43200,1,'NZST'),(1741,4,46800,1,'NZDT'),(1741,5,43200,0,'NZST'),(1741,6,43200,0,'NZST'),(1742,0,35312,0,'PMMT'),(1742,1,36000,0,'+10'),(1742,2,32400,0,'+09'),(1742,3,39600,0,'+11'),(1743,0,44028,0,'LMT'),(1743,1,44100,0,'+1215'),(1743,2,49500,1,'+1345'),(1743,3,45900,0,'+1245'),(1743,4,45900,0,'+1245'),(1744,0,36428,0,'LMT'),(1744,1,36000,0,'+10'),(1744,2,32400,0,'+09'),(1744,3,36000,0,'+10'),(1745,0,-26248,0,'LMT'),(1745,1,-26248,0,'EMT'),(1745,2,-21600,1,'-06'),(1745,3,-25200,0,'-07'),(1745,4,-25200,0,'-07'),(1745,5,-21600,0,'-06'),(1745,6,-18000,1,'-05'),(1746,0,40396,0,'LMT'),(1746,1,43200,1,'+12'),(1746,2,39600,0,'+11'),(1747,0,-41060,0,'LMT'),(1747,1,-43200,0,'-12'),(1747,2,-39600,0,'-11'),(1747,3,46800,0,'+13'),(1748,0,-41096,0,'LMT'),(1748,1,-39600,0,'-11'),(1748,2,46800,0,'+13'),(1749,0,42944,0,'LMT'),(1749,1,46800,1,'+13'),(1749,2,43200,0,'+12'),(1750,0,43200,0,'+12'),(1751,0,-21504,0,'LMT'),(1751,1,-18000,0,'-05'),(1751,2,-18000,1,'-05'),(1751,3,-21600,0,'-06'),(1752,0,-32388,0,'LMT'),(1752,1,-32400,0,'-09'),(1753,0,38388,0,'LMT'),(1753,1,39600,0,'+11'),(1754,0,34740,0,'LMT'),(1754,1,36000,0,'GST'),(1754,2,32400,0,'+09'),(1754,3,39600,1,'GDT'),(1754,4,36000,0,'ChST'),(1755,0,-37886,0,'LMT'),(1755,1,-37800,0,'HST'),(1755,2,-34200,1,'HDT'),(1755,3,-34200,1,'HWT'),(1755,4,-34200,1,'HPT'),(1755,5,-36000,0,'HST'),(1756,0,-37886,0,'LMT'),(1756,1,-37800,0,'HST'),(1756,2,-34200,1,'HDT'),(1756,3,-34200,1,'HWT'),(1756,4,-34200,1,'HPT'),(1756,5,-36000,0,'HST'),(1757,0,-37760,0,'LMT'),(1757,1,-38400,0,'-1040'),(1757,2,-36000,0,'-10'),(1757,3,50400,0,'+14'),(1758,0,39116,0,'LMT'),(1758,1,39600,0,'+11'),(1758,2,32400,0,'+09'),(1758,3,36000,0,'+10'),(1758,4,43200,0,'+12'),(1758,5,39600,0,'+11'),(1759,0,40160,0,'LMT'),(1759,1,39600,0,'+11'),(1759,2,36000,0,'+10'),(1759,3,32400,0,'+09'),(1759,4,-43200,0,'-12'),(1759,5,43200,0,'+12'),(1760,0,41088,0,'LMT'),(1760,1,39600,0,'+11'),(1760,2,32400,0,'+09'),(1760,3,36000,0,'+10'),(1760,4,43200,0,'+12'),(1761,0,-33480,0,'LMT'),(1761,1,-34200,0,'-0930'),(1762,0,45432,0,'LMT'),(1762,1,-40968,0,'LMT'),(1762,2,-39600,0,'SST'),(1763,0,40060,0,'LMT'),(1763,1,41400,0,'+1130'),(1763,2,32400,0,'+09'),(1763,3,43200,0,'+12'),(1764,0,-40780,0,'LMT'),(1764,1,-40800,0,'-1120'),(1764,2,-41400,0,'-1130'),(1764,3,-39600,0,'-11'),(1765,0,40312,0,'LMT'),(1765,1,40320,0,'+1112'),(1765,2,41400,0,'+1130'),(1765,3,45000,1,'+1230'),(1765,4,39600,0,'+11'),(1766,0,39948,0,'LMT'),(1766,1,43200,1,'+12'),(1766,2,39600,0,'+11'),(1766,3,43200,1,'+12'),(1766,4,39600,0,'+11'),(1767,0,45432,0,'LMT'),(1767,1,-40968,0,'LMT'),(1767,2,-39600,0,'SST'),(1768,0,32400,0,'+09'),(1769,0,-31220,0,'LMT'),(1769,1,-30600,0,'-0830'),(1769,2,-28800,0,'-08'),(1770,0,37972,0,'LMT'),(1770,1,39600,0,'+11'),(1770,2,32400,0,'+09'),(1770,3,36000,0,'+10'),(1770,4,39600,0,'+11'),(1771,0,37972,0,'LMT'),(1771,1,39600,0,'+11'),(1771,2,32400,0,'+09'),(1771,3,36000,0,'+10'),(1771,4,39600,0,'+11'),(1772,0,36000,0,'+10'),(1773,0,-38344,0,'LMT'),(1773,1,-37800,0,'-1030'),(1773,2,-36000,0,'-10'),(1773,3,-34200,1,'-0930'),(1774,0,34740,0,'LMT'),(1774,1,36000,0,'GST'),(1774,2,32400,0,'+09'),(1774,3,39600,1,'GDT'),(1774,4,36000,0,'ChST'),(1775,0,45432,0,'LMT'),(1775,1,-40968,0,'LMT'),(1775,2,-39600,0,'SST'),(1776,0,-35896,0,'LMT'),(1776,1,-36000,0,'-10'),(1777,0,43200,0,'+12'),(1778,0,44360,0,'LMT'),(1778,1,44400,0,'+1220'),(1778,2,46800,0,'+13'),(1778,3,50400,1,'+14'),(1778,4,46800,0,'+13'),(1778,5,50400,1,'+14'),(1779,0,36428,0,'LMT'),(1779,1,36000,0,'+10'),(1779,2,32400,0,'+09'),(1779,3,36000,0,'+10'),(1780,0,43200,0,'+12'),(1781,0,43200,0,'+12'),(1782,0,36428,0,'LMT'),(1782,1,36000,0,'+10'),(1782,2,32400,0,'+09'),(1782,3,36000,0,'+10'),(1783,0,5040,0,'LMT'),(1783,1,5040,0,'WMT'),(1783,2,7200,1,'CEST'),(1783,3,3600,0,'CET'),(1783,4,7200,1,'CEST'),(1783,5,3600,0,'CET'),(1783,6,10800,1,'EEST'),(1783,7,7200,0,'EET'),(1783,8,7200,0,'EET'),(1783,9,7200,1,'CEST'),(1783,10,3600,0,'CET'),(1784,0,-2205,0,'LMT'),(1784,1,3600,1,'WEST'),(1784,2,0,0,'WET'),(1784,3,3600,1,'WEST'),(1784,4,0,0,'WET'),(1784,5,7200,1,'WEMT'),(1784,6,0,0,'WET'),(1784,7,3600,0,'CET'),(1784,8,3600,0,'CET'),(1784,9,7200,1,'CEST'),(1784,10,3600,1,'WEST'),(1784,11,0,0,'WET'),(1785,0,29160,0,'LMT'),(1785,1,28800,0,'CST'),(1785,2,32400,0,'JST'),(1785,3,32400,1,'CDT'),(1785,4,28800,0,'CST'),(1786,0,30472,0,'LMT'),(1786,1,30600,0,'KST'),(1786,2,32400,0,'JST'),(1786,3,32400,0,'KST'),(1786,4,34200,1,'KDT'),(1786,5,36000,1,'KDT'),(1787,0,24925,0,'LMT'),(1787,1,24925,0,'SMT'),(1787,2,25200,0,'+07'),(1787,3,26400,1,'+0720'),(1787,4,26400,0,'+0720'),(1787,5,27000,0,'+0730'),(1787,6,32400,0,'+09'),(1787,7,28800,0,'+08'),(1788,0,-15865,0,'LMT'),(1788,1,-14400,0,'AST'),(1788,2,-10800,1,'APT'),(1788,3,-10800,1,'AWT'),(1789,0,-15264,0,'LMT'),(1789,1,-10800,1,'ADT'),(1789,2,-14400,0,'AST'),(1789,3,-10800,1,'AWT'),(1789,4,-10800,1,'APT'),(1790,0,-25116,0,'LMT'),(1790,1,-21600,1,'MDT'),(1790,2,-25200,0,'MST'),(1790,3,-21600,1,'MWT'),(1790,4,-21600,1,'MPT'),(1790,5,-21600,0,'CST'),(1791,0,-21036,0,'LMT'),(1791,1,-18000,1,'CDT'),(1791,2,-21600,0,'CST'),(1791,3,-18000,0,'EST'),(1791,4,-18000,1,'CWT'),(1791,5,-18000,1,'CPT'),(1791,6,-21600,0,'CST'),(1792,0,-19088,0,'LMT'),(1792,1,-19176,0,'CMT'),(1792,2,-18000,0,'EST'),(1793,0,-17762,0,'LMT'),(1793,1,-14400,1,'EDT'),(1793,2,-18000,0,'EST'),(1793,3,-14400,1,'EWT'),(1793,4,-14400,1,'EPT'),(1794,0,-37886,0,'LMT'),(1794,1,-37800,0,'HST'),(1794,2,-34200,1,'HDT'),(1794,3,-34200,1,'HWT'),(1794,4,-34200,1,'HPT'),(1794,5,-36000,0,'HST'),(1795,0,-26898,0,'LMT'),(1795,1,-21600,1,'MDT'),(1795,2,-25200,0,'MST'),(1795,3,-21600,1,'MWT'),(1796,0,-25196,0,'LMT'),(1796,1,-21600,1,'MDT'),(1796,2,-25200,0,'MST'),(1796,3,-21600,1,'MWT'),(1796,4,-21600,1,'MPT'),(1797,0,-31220,0,'LMT'),(1797,1,-30600,0,'-0830'),(1797,2,-28800,0,'-08'),(1798,0,-28378,0,'LMT'),(1798,1,-25200,1,'PDT'),(1798,2,-28800,0,'PST'),(1798,3,-25200,1,'PWT'),(1798,4,-25200,1,'PPT'),(1799,0,-32388,0,'LMT'),(1799,1,-32400,0,'-09'),(1800,0,-35976,0,'LMT'),(1800,1,-36000,0,'AST'),(1800,2,-32400,1,'AWT'),(1800,3,-32400,1,'APT'),(1800,4,-36000,0,'AHST'),(1800,5,-32400,1,'AHDT'),(1800,6,-32400,0,'YST'),(1800,7,-28800,1,'AKDT'),(1800,8,-32400,0,'AKST'),(1801,0,6952,0,'LMT'),(1801,1,7016,0,'IMT'),(1801,2,10800,1,'EEST'),(1801,3,7200,0,'EET'),(1801,4,14400,1,'+04'),(1801,5,10800,0,'+03'),(1801,6,10800,1,'EEST'),(1801,7,7200,0,'EET'),(1801,8,10800,1,'EEST'),(1801,9,7200,0,'EET'),(1801,10,10800,0,'+03'),(1802,0,0,0,'UTC'),(1803,0,-35976,0,'LMT'),(1803,1,-36000,0,'AST'),(1803,2,-32400,1,'AWT'),(1803,3,-32400,1,'APT'),(1803,4,-36000,0,'AHST'),(1803,5,-32400,1,'AHDT'),(1803,6,-32400,0,'YST'),(1803,7,-28800,1,'AKDT'),(1803,8,-32400,0,'AKST'),(1804,0,-42398,0,'LMT'),(1804,1,-39600,0,'NST'),(1804,2,-36000,1,'NWT'),(1804,3,-36000,1,'NPT'),(1804,4,-39600,0,'BST'),(1804,5,-36000,1,'BDT'),(1804,6,-36000,0,'AHST'),(1804,7,-32400,1,'HDT'),(1804,8,-36000,0,'HST'),(1805,0,-26898,0,'LMT'),(1805,1,-21600,1,'MDT'),(1805,2,-25200,0,'MST'),(1805,3,-21600,1,'MWT'),(1806,0,-21036,0,'LMT'),(1806,1,-18000,1,'CDT'),(1806,2,-21600,0,'CST'),(1806,3,-18000,0,'EST'),(1806,4,-18000,1,'CWT'),(1806,5,-18000,1,'CPT'),(1806,6,-21600,0,'CST'),(1807,0,-20678,0,'LMT'),(1807,1,-18000,1,'CDT'),(1807,2,-21600,0,'CST'),(1807,3,-18000,1,'CWT'),(1807,4,-18000,1,'CPT'),(1807,5,-18000,0,'EST'),(1807,6,-14400,1,'EDT'),(1808,0,-17762,0,'LMT'),(1808,1,-14400,1,'EDT'),(1808,2,-18000,0,'EST'),(1808,3,-14400,1,'EWT'),(1808,4,-14400,1,'EPT'),(1809,0,-37886,0,'LMT'),(1809,1,-37800,0,'HST'),(1809,2,-34200,1,'HDT'),(1809,3,-34200,1,'HWT'),(1809,4,-34200,1,'HPT'),(1809,5,-36000,0,'HST'),(1810,0,-20790,0,'LMT'),(1810,1,-18000,1,'CDT'),(1810,2,-21600,0,'CST'),(1810,3,-18000,1,'CWT'),(1810,4,-18000,1,'CPT'),(1810,5,-18000,0,'EST'),(1810,6,-21600,0,'CST'),(1811,0,-19931,0,'LMT'),(1811,1,-21600,0,'CST'),(1811,2,-18000,0,'EST'),(1811,3,-14400,1,'EWT'),(1811,4,-14400,1,'EPT'),(1811,5,-14400,1,'EDT'),(1812,0,-25196,0,'LMT'),(1812,1,-21600,1,'MDT'),(1812,2,-25200,0,'MST'),(1812,3,-21600,1,'MWT'),(1812,4,-21600,1,'MPT'),(1813,0,-28378,0,'LMT'),(1813,1,-25200,1,'PDT'),(1813,2,-28800,0,'PST'),(1813,3,-25200,1,'PWT'),(1813,4,-25200,1,'PPT'),(1814,0,-28378,0,'LMT'),(1814,1,-25200,1,'PDT'),(1814,2,-28800,0,'PST'),(1814,3,-25200,1,'PWT'),(1814,4,-25200,1,'PPT'),(1815,0,45432,0,'LMT'),(1815,1,-40968,0,'LMT'),(1815,2,-39600,0,'SST'),(1816,0,0,0,'UTC'),(1817,0,0,0,'UTC'),(1818,0,9017,0,'LMT'),(1818,1,9017,0,'MMT'),(1818,2,12679,1,'MST'),(1818,3,9079,0,'MMT'),(1818,4,16279,1,'MDST'),(1818,5,14400,1,'MSD'),(1818,6,10800,0,'MSK'),(1818,7,14400,1,'MSD'),(1818,8,18000,1,'+05'),(1818,9,7200,0,'EET'),(1818,10,10800,0,'MSK'),(1818,11,14400,1,'MSD'),(1818,12,10800,1,'EEST'),(1818,13,7200,0,'EET'),(1818,14,14400,0,'MSK'),(1818,15,14400,1,'MSD'),(1818,16,10800,0,'MSK'),(1819,0,3600,1,'WEST'),(1819,1,0,0,'WET'),(1820,0,0,0,'UTC');
/*!40000 ALTER TABLE `time_zone_transition_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Password` char(41) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Reload_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Shutdown_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Process_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `File_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_db_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Super_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Repl_slave_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Repl_client_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_user_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tablespace_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_history_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `ssl_type` enum('','ANY','X509','SPECIFIED') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `ssl_cipher` blob NOT NULL,
  `x509_issuer` blob NOT NULL,
  `x509_subject` blob NOT NULL,
  `max_questions` int(11) unsigned NOT NULL DEFAULT 0,
  `max_updates` int(11) unsigned NOT NULL DEFAULT 0,
  `max_connections` int(11) unsigned NOT NULL DEFAULT 0,
  `max_user_connections` int(11) NOT NULL DEFAULT 0,
  `plugin` char(64) CHARACTER SET latin1 NOT NULL DEFAULT '',
  `authentication_string` text COLLATE utf8_bin NOT NULL,
  `password_expired` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `is_role` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `default_role` char(80) COLLATE utf8_bin NOT NULL DEFAULT '',
  `max_statement_time` decimal(12,6) NOT NULL DEFAULT 0.000000,
  PRIMARY KEY (`Host`,`User`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Users and global privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES ('localhost','root','*DAEAFADB40481804151BA708437A5BEC415FBA85','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0,'mysql_native_password','*DAEAFADB40481804151BA708437A5BEC415FBA85','N','N','',0.000000),('%','wikiuser','*57237BB49761F29AB9724BA084E811D70C12393D','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0,'','','N','N','',0.000000),('%','root','*DAEAFADB40481804151BA708437A5BEC415FBA85','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0,'','','N','N','',0.000000);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `general_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `general_log` (
  `event_time` timestamp(6) NOT NULL DEFAULT current_timestamp(6) ON UPDATE current_timestamp(6),
  `user_host` mediumtext NOT NULL,
  `thread_id` bigint(21) unsigned NOT NULL,
  `server_id` int(10) unsigned NOT NULL,
  `command_type` varchar(64) NOT NULL,
  `argument` mediumtext NOT NULL
) ENGINE=CSV DEFAULT CHARSET=utf8 COMMENT='General log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `slow_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `slow_log` (
  `start_time` timestamp(6) NOT NULL DEFAULT current_timestamp(6) ON UPDATE current_timestamp(6),
  `user_host` mediumtext NOT NULL,
  `query_time` time(6) NOT NULL,
  `lock_time` time(6) NOT NULL,
  `rows_sent` int(11) NOT NULL,
  `rows_examined` int(11) NOT NULL,
  `db` varchar(512) NOT NULL,
  `last_insert_id` int(11) NOT NULL,
  `insert_id` int(11) NOT NULL,
  `server_id` int(10) unsigned NOT NULL,
  `sql_text` mediumtext NOT NULL,
  `thread_id` bigint(21) unsigned NOT NULL,
  `rows_affected` int(11) NOT NULL
) ENGINE=CSV DEFAULT CHARSET=utf8 COMMENT='Slow log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `transaction_registry`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `transaction_registry` (
  `transaction_id` bigint(20) unsigned NOT NULL,
  `commit_id` bigint(20) unsigned NOT NULL,
  `begin_timestamp` timestamp(6) NOT NULL DEFAULT '0000-00-00 00:00:00.000000',
  `commit_timestamp` timestamp(6) NOT NULL DEFAULT '0000-00-00 00:00:00.000000',
  `isolation_level` enum('READ-UNCOMMITTED','READ-COMMITTED','REPEATABLE-READ','SERIALIZABLE') COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`transaction_id`),
  UNIQUE KEY `commit_id` (`commit_id`),
  KEY `begin_timestamp` (`begin_timestamp`),
  KEY `commit_timestamp` (`commit_timestamp`,`transaction_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin STATS_PERSISTENT=0;
/*!40101 SET character_set_client = @saved_cs_client */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2019-05-20 16:34:30
